// Class: ReadCutsGA
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : Cuts::CutsGA
TMVA Release   : 3.8.13        [198669]
ROOT Release   : 5.19/02       [332546]
Creator        : heponx
Date           : Fri Mar 28 00:39:40 2008
Host           : Darwin jlctpcmac.kek.jp 9.2.0 Darwin Kernel Version 9.2.0: Tue Feb 5 16:15:19 PST 2008; root:xnu-1228.3.13~1/RELEASE_PPC Power Macintosh
Dir            : /Users/root/root_v5.19.02-macosx10.5-ppc/test
Training events: 1000


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
V: "False" [Verbose mode]
H: "False" [Print classifier-specific help message]
FitMethod: "GA" [Minimization Method]
EffMethod: "EffSel" [Selection Method]
# Default:
D: "False" [use-decorrelated-variables flag (depreciated)]
Normalise: "False" [Normalise input variables]
VarTransform: "None" [Variable transformation method]
VarTransformType: "Signal" [Use signal or background events for var transform]
NbinsMVAPdf: "60" [Number of bins used to create MVA PDF]
NsmoothMVAPdf: "2" [Number of smoothing iterations for MVA PDF]
VerboseLevel: "Info" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs]
TxtWeightFilesOnly: "True" [if True, write all weights as text files]
CutRangeMin[0]: "-1" [Minimum of allowed cut range (set per variable)]
    CutRangeMin[1]: "-1"
    CutRangeMin[2]: "-1"
    CutRangeMin[3]: "-1"
CutRangeMax[0]: "-1" [Maximum of allowed cut range (set per variable)]
    CutRangeMax[1]: "-1"
    CutRangeMax[2]: "-1"
    CutRangeMax[3]: "-1"
VarProp[0]: "FSmart" [Categorisation of cuts]
    VarProp[1]: "FSmart"
    VarProp[2]: "FSmart"
    VarProp[3]: "FSmart"
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 4
var1+var2                     var1_P_var2                       'F'    [-6.05220985413,4.87306022644]
var1-var2                     var1_M_var2                       'F'    [-3.84853005409,3.82592988014]
var3                          var3                              'F'    [-5.18697977066,3.14527988434]
var4                          var4                              'F'    [-4.88857984543,3.45718002319]


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;
};

#endif

class ReadCutsGA : public IClassifierReader {

 public:

   // constructor
   ReadCutsGA( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "ReadCutsGA" ),
        fStatusIsClean( true ),
        fNvars( 4 ),
        fIsNormalised( false )
   {      
      // the training input variables
      const char* inputVars[] = { "var1+var2", "var1-var2", "var3", "var4" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -6.05220985412598;
      fVmax[0] = 4.87306022644043;
      fVmin[1] = -3.84853005409241;
      fVmax[1] = 3.82592988014221;
      fVmin[2] = -5.1869797706604;
      fVmax[2] = 3.14527988433838;
      fVmin[3] = -4.88857984542847;
      fVmax[3] = 3.45718002319336;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';

      // initialize constants
      Initialize();

   }

   // destructor
   virtual ~ReadCutsGA() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // common member variables
   const char* fClassName;
   bool fStatusIsClean;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[4];
   double fVmax[4];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[4];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)
   // not implemented for class: "ReadCutsGA"
};
   inline double ReadCutsGA::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!fStatusIsClean) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            retval = GetMvaValue__( iV );
         }
         else {
            retval = GetMvaValue__( inputValues );
         }
      }

      return retval;
   }
