// Class: ReadHMatrix
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : HMatrix::HMatrix
TMVA Release   : 3.8.13        [198669]
ROOT Release   : 5.19/02       [332546]
Creator        : heponx
Date           : Fri Mar 28 00:39:41 2008
Host           : Darwin jlctpcmac.kek.jp 9.2.0 Darwin Kernel Version 9.2.0: Tue Feb 5 16:15:19 PST 2008; root:xnu-1228.3.13~1/RELEASE_PPC Power Macintosh
Dir            : /Users/root/root_v5.19.02-macosx10.5-ppc/test
Training events: 1000


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
# Default:
D: "False" [use-decorrelated-variables flag (depreciated)]
Normalise: "True" [Normalise input variables]
VarTransform: "None" [Variable transformation method]
VarTransformType: "Signal" [Use signal or background events for var transform]
NbinsMVAPdf: "60" [Number of bins used to create MVA PDF]
NsmoothMVAPdf: "2" [Number of smoothing iterations for MVA PDF]
V: "False" [Verbose mode]
VerboseLevel: "Info" [Verbosity level]
H: "False" [Print classifier-specific help message]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs]
TxtWeightFilesOnly: "True" [if True, write all weights as text files]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 4
var1+var2                     var1_P_var2                       'F'    [-6.05220985413,4.87306022644]
var1-var2                     var1_M_var2                       'F'    [-3.84853005409,3.82592988014]
var3                          var3                              'F'    [-5.18697977066,3.14527988434]
var4                          var4                              'F'    [-4.88857984543,3.45718002319]


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;
};

#endif

class ReadHMatrix : public IClassifierReader {

 public:

   // constructor
   ReadHMatrix( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "ReadHMatrix" ),
        fStatusIsClean( true ),
        fNvars( 4 ),
        fIsNormalised( true )
   {      
      // the training input variables
      const char* inputVars[] = { "var1+var2", "var1-var2", "var3", "var4" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -6.05220985412598;
      fVmax[0] = 4.87306022644043;
      fVmin[1] = -3.84853005409241;
      fVmax[1] = 3.82592988014221;
      fVmin[2] = -5.1869797706604;
      fVmax[2] = 3.14527988433838;
      fVmin[3] = -4.88857984542847;
      fVmax[3] = 3.45718002319336;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';

      // initialize constants
      Initialize();

   }

   // destructor
   virtual ~ReadHMatrix() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // common member variables
   const char* fClassName;
   bool fStatusIsClean;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[4];
   double fVmax[4];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[4];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)
   // arrays of input evt vs. variable 
   double fInvHMatrixS[4][4]; // inverse H-matrix (signal)
   double fInvHMatrixB[4][4]; // inverse H-matrix (background)
   double fVecMeanS[4];    // vector of mean values (signal)
   double fVecMeanB[4];    // vector of mean values (background)
   
   double GetChi2( const std::vector<double>& inputValues, int type ) const;
};
   
void ReadHMatrix::Initialize() 
{
   // init vectors with mean values
   fVecMeanS[0] = 0.220898117261162;
   fVecMeanB[0] = -0.0287195809214008;
   fVecMeanS[1] = -0.0435629891575133;
   fVecMeanB[1] = 0.0708565210287714;
   fVecMeanS[2] = 0.38705872570598;
   fVecMeanB[2] = 0.0846738188617756;
   fVecMeanS[3] = 0.360681566404401;
   fVecMeanB[3] = -0.0351139006392349;
   
   // init H-matrices
   fInvHMatrixS[0][0] = 25.1676178492386;
   fInvHMatrixB[0][0] = 23.8633193245359;
   fInvHMatrixS[0][1] = -2.89137089315929;
   fInvHMatrixB[0][1] = -3.11776446424714;
   fInvHMatrixS[0][2] = 0.522300394423745;
   fInvHMatrixB[0][2] = -1.64122167929563;
   fInvHMatrixS[0][3] = -21.8642494160358;
   fInvHMatrixB[0][3] = -19.0766651123962;
   fInvHMatrixS[1][0] = -2.89137089315929;
   fInvHMatrixB[1][0] = -3.11776446424714;
   fInvHMatrixS[1][1] = 11.4792775565283;
   fInvHMatrixB[1][1] = 11.3033548460756;
   fInvHMatrixS[1][2] = -0.160366487609839;
   fInvHMatrixB[1][2] = 1.27661078107944;
   fInvHMatrixS[1][3] = 5.72705418365208;
   fInvHMatrixB[1][3] = 3.19374278548995;
   fInvHMatrixS[2][0] = 0.522300394423757;
   fInvHMatrixB[2][0] = -1.64122167929564;
   fInvHMatrixS[2][1] = -0.16036648760984;
   fInvHMatrixB[2][1] = 1.27661078107945;
   fInvHMatrixS[2][2] = 97.8157585554844;
   fInvHMatrixB[2][2] = 94.5926150265065;
   fInvHMatrixS[2][3] = -90.648811908888;
   fInvHMatrixB[2][3] = -84.9195380765953;
   fInvHMatrixS[3][0] = -21.8642494160358;
   fInvHMatrixB[3][0] = -19.0766651123962;
   fInvHMatrixS[3][1] = 5.72705418365208;
   fInvHMatrixB[3][1] = 3.19374278548995;
   fInvHMatrixS[3][2] = -90.648811908888;
   fInvHMatrixB[3][2] = -84.9195380765953;
   fInvHMatrixS[3][3] = 119.45116612948;
   fInvHMatrixB[3][3] = 110.519266711491;
}
   
inline double ReadHMatrix::GetMvaValue__( const std::vector<double>& inputValues ) const
{
   // returns the H-matrix signal estimator
   double s = GetChi2( inputValues, 0 );
   double b = GetChi2( inputValues, 1 );
   
   if (s+b <= 0) std::cout << "Problem in class ReadHMatrix::GetMvaValue__: s+b = "
                           << s+b << " <= 0 "  << std::endl;
   
   return (b - s)/(s + b);
}
   
inline double ReadHMatrix::GetChi2( const std::vector<double>& inputValues, int type ) const
{
   // compute chi2-estimator for event according to type (signal/background)
   
   size_t ivar,jvar;
   double chi2 = 0;
   for (ivar=0; ivar<GetNvar(); ivar++) {
      for (jvar=0; jvar<GetNvar(); jvar++) {
         if (type == 0) 
            chi2 += ( (inputValues[ivar] - fVecMeanS[ivar])*(inputValues[jvar] - fVecMeanS[jvar])
                      * fInvHMatrixS[ivar][jvar] );
         else
            chi2 += ( (inputValues[ivar] - fVecMeanB[ivar])*(inputValues[jvar] - fVecMeanB[jvar])
                      * fInvHMatrixB[ivar][jvar] );
      }
   }   // loop over variables   
   
   // sanity check
   if (chi2 < 0) std::cout << "Problem in class ReadHMatrix::GetChi2: chi2 = "
                           << chi2 << " < 0 "  << std::endl;
   
   return chi2;
}
   
// Clean up
inline void ReadHMatrix::Clear() 
{
   // nothing to clear
}
   inline double ReadHMatrix::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!fStatusIsClean) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            retval = GetMvaValue__( iV );
         }
         else {
            retval = GetMvaValue__( inputValues );
         }
      }

      return retval;
   }
