// Class: ReadMLP
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : MLP::MLP
TMVA Release   : 3.8.13        [198669]
ROOT Release   : 5.19/02       [332546]
Creator        : heponx
Date           : Fri Mar 28 00:39:51 2008
Host           : Darwin jlctpcmac.kek.jp 9.2.0 Darwin Kernel Version 9.2.0: Tue Feb 5 16:15:19 PST 2008; root:xnu-1228.3.13~1/RELEASE_PPC Power Macintosh
Dir            : /Users/root/root_v5.19.02-macosx10.5-ppc/test
Training events: 1000


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
Normalise: "True" [Normalise input variables]
V: "False" [Verbose mode]
H: "False" [Print classifier-specific help message]
NCycles: "200" [Number of training cycles]
HiddenLayers: "N+1,N" [Specification of hidden layer architecture]
TestRate: "5" [Test for overtraining performed at each #th epochs]
# Default:
D: "False" [use-decorrelated-variables flag (depreciated)]
VarTransform: "None" [Variable transformation method]
VarTransformType: "Signal" [Use signal or background events for var transform]
NbinsMVAPdf: "60" [Number of bins used to create MVA PDF]
NsmoothMVAPdf: "2" [Number of smoothing iterations for MVA PDF]
VerboseLevel: "Info" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs]
TxtWeightFilesOnly: "True" [if True, write all weights as text files]
NeuronType: "tanh" [Neuron activation function type]
NeuronInputType: "sum" [Neuron input function type]
TrainingMethod: "BP" [Train with Back-Propagation (BP - default) or Genetic Algorithm (GA - slower and worse)]
LearningRate: "0.02" [ANN learning rate parameter]
DecayRate: "0.01" [Decay rate for learning parameter]
BPMode: "sequential" [Back-propagation learning mode: sequential or batch]
BatchSize: "-1" [Batch size: number of events/batch, only set if in Batch Mode, -1 for BatchSize=number_of_events]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 4
var1+var2                     var1_P_var2                       'F'    [-6.05220985413,4.87306022644]
var1-var2                     var1_M_var2                       'F'    [-3.84853005409,3.82592988014]
var3                          var3                              'F'    [-5.18697977066,3.14527988434]
var4                          var4                              'F'    [-4.88857984543,3.45718002319]


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;
};

#endif

class ReadMLP : public IClassifierReader {

 public:

   // constructor
   ReadMLP( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "ReadMLP" ),
        fStatusIsClean( true ),
        fNvars( 4 ),
        fIsNormalised( true )
   {      
      // the training input variables
      const char* inputVars[] = { "var1+var2", "var1-var2", "var3", "var4" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -6.05220985412598;
      fVmax[0] = 4.87306022644043;
      fVmin[1] = -3.84853005409241;
      fVmax[1] = 3.82592988014221;
      fVmin[2] = -5.1869797706604;
      fVmax[2] = 3.14527988433838;
      fVmin[3] = -4.88857984542847;
      fVmax[3] = 3.45718002319336;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';

      // initialize constants
      Initialize();

   }

   // destructor
   virtual ~ReadMLP() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // common member variables
   const char* fClassName;
   bool fStatusIsClean;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[4];
   double fVmax[4];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[4];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)

   double ActivationFnc(double x) const;

   int fLayers;
   int fLayerSize[4];
   double fWeightMatrix0to1[6][5];   // weight matrix from layer 0 to 1
   double fWeightMatrix1to2[5][6];   // weight matrix from layer 1 to 2
   double fWeightMatrix2to3[1][5];   // weight matrix from layer 2 to 3

   double * fWeights[4];
};

inline void ReadMLP::Initialize()
{
   // build network structure
   fLayers = 4;
   fLayerSize[0] = 5; fWeights[0] = new double[5]; 
   fLayerSize[1] = 6; fWeights[1] = new double[6]; 
   fLayerSize[2] = 5; fWeights[2] = new double[5]; 
   fLayerSize[3] = 1; fWeights[3] = new double[1]; 
   // weight matrix from layer 0 to 1
   fWeightMatrix0to1[0][0] = -0.939783666232008;
   fWeightMatrix0to1[1][0] = 1.88904259132089;
   fWeightMatrix0to1[2][0] = 0.867885852976532;
   fWeightMatrix0to1[3][0] = 0.937124078801016;
   fWeightMatrix0to1[4][0] = -0.811330996643768;
   fWeightMatrix0to1[0][1] = -2.2547082867736;
   fWeightMatrix0to1[1][1] = -0.545759894720658;
   fWeightMatrix0to1[2][1] = 1.78966046484588;
   fWeightMatrix0to1[3][1] = -0.987387687199455;
   fWeightMatrix0to1[4][1] = -0.562376054881956;
   fWeightMatrix0to1[0][2] = -2.32355832369168;
   fWeightMatrix0to1[1][2] = -0.628758062563447;
   fWeightMatrix0to1[2][2] = -1.61813946858601;
   fWeightMatrix0to1[3][2] = 0.563110714096418;
   fWeightMatrix0to1[4][2] = -0.973206811511032;
   fWeightMatrix0to1[0][3] = 0.929127901669487;
   fWeightMatrix0to1[1][3] = -0.398395083590788;
   fWeightMatrix0to1[2][3] = 2.70346677695598;
   fWeightMatrix0to1[3][3] = 1.66161244870259;
   fWeightMatrix0to1[4][3] = 3.79019610045768;
   fWeightMatrix0to1[0][4] = 0.174056046591149;
   fWeightMatrix0to1[1][4] = -0.148765075525019;
   fWeightMatrix0to1[2][4] = -0.336175980662591;
   fWeightMatrix0to1[3][4] = 0.875740157902505;
   fWeightMatrix0to1[4][4] = -0.698409067206089;
   // weight matrix from layer 1 to 2
   fWeightMatrix1to2[0][0] = -0.270546871391212;
   fWeightMatrix1to2[1][0] = 1.90676273444207;
   fWeightMatrix1to2[2][0] = -1.8424297375441;
   fWeightMatrix1to2[3][0] = -1.61482981600354;
   fWeightMatrix1to2[0][1] = -0.952336382775597;
   fWeightMatrix1to2[1][1] = -0.130064016276363;
   fWeightMatrix1to2[2][1] = 0.628069261118704;
   fWeightMatrix1to2[3][1] = -0.357382743207237;
   fWeightMatrix1to2[0][2] = 0.654346602746491;
   fWeightMatrix1to2[1][2] = 1.36270373928672;
   fWeightMatrix1to2[2][2] = -0.293916675429003;
   fWeightMatrix1to2[3][2] = -1.29539711327416;
   fWeightMatrix1to2[0][3] = 2.00744491410125;
   fWeightMatrix1to2[1][3] = -1.01025445809436;
   fWeightMatrix1to2[2][3] = 0.683559126349106;
   fWeightMatrix1to2[3][3] = 1.21584740459207;
   fWeightMatrix1to2[0][4] = 1.3726821285093;
   fWeightMatrix1to2[1][4] = 1.54771804378768;
   fWeightMatrix1to2[2][4] = -0.011056306828447;
   fWeightMatrix1to2[3][4] = -0.870476804696637;
   fWeightMatrix1to2[0][5] = -0.688216916888826;
   fWeightMatrix1to2[1][5] = 1.89286910962178;
   fWeightMatrix1to2[2][5] = 0.906999178283285;
   fWeightMatrix1to2[3][5] = 2.01730467718963;
   // weight matrix from layer 2 to 3
   fWeightMatrix2to3[0][0] = 0.565371771372789;
   fWeightMatrix2to3[0][1] = 0.557789810557079;
   fWeightMatrix2to3[0][2] = 0.496792810636299;
   fWeightMatrix2to3[0][3] = -1.64725422414195;
   fWeightMatrix2to3[0][4] = 1.09659874971601;
}

inline double ReadMLP::GetMvaValue__( const std::vector<double>& inputValues ) const
{
   if (inputValues.size() != (unsigned int)fLayerSize[0]-1) {
      std::cout << "Input vector needs to be of size " << fLayerSize[0]-1 << std::endl;
      return 0;
   }

   for (int l=0; l<fLayers; l++)
      for (int i=0; i<fLayerSize[l]; i++) fWeights[l][i]=0;

   for (int l=0; l<fLayers-1; l++)
      fWeights[l][fLayerSize[l]-1]=1;

   for (int i=0; i<fLayerSize[0]-1; i++)
      fWeights[0][i]=inputValues[i];

   // layer 0 to 1
   for (int o=0; o<fLayerSize[1]-1; o++) {
      for (int i=0; i<fLayerSize[0]; i++) {
         double inputVal = fWeightMatrix0to1[o][i] * fWeights[0][i];
         fWeights[1][o] += inputVal;
      }
      fWeights[1][o] = ActivationFnc(fWeights[1][o]);
   }
   // layer 1 to 2
   for (int o=0; o<fLayerSize[2]-1; o++) {
      for (int i=0; i<fLayerSize[1]; i++) {
         double inputVal = fWeightMatrix1to2[o][i] * fWeights[1][i];
         fWeights[2][o] += inputVal;
      }
      fWeights[2][o] = ActivationFnc(fWeights[2][o]);
   }
   // layer 2 to 3
   for (int o=0; o<fLayerSize[3]; o++) {
      for (int i=0; i<fLayerSize[2]; i++) {
         double inputVal = fWeightMatrix2to3[o][i] * fWeights[2][i];
         fWeights[3][o] += inputVal;
      }
   }

   return fWeights[3][0];
}

double ReadMLP::ActivationFnc(double x) const {
   // hyperbolic tan
   return tanh(-x);
}
   
// Clean up
inline void ReadMLP::Clear() 
{
   // nothing to clear
}
   inline double ReadMLP::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!fStatusIsClean) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            retval = GetMvaValue__( iV );
         }
         else {
            retval = GetMvaValue__( inputValues );
         }
      }

      return retval;
   }
