// Class: ReadRuleFit
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : RuleFit::RuleFit
TMVA Release   : 3.8.13        [198669]
ROOT Release   : 5.19/02       [332546]
Creator        : heponx
Date           : Fri Mar 28 00:40:00 2008
Host           : Darwin jlctpcmac.kek.jp 9.2.0 Darwin Kernel Version 9.2.0: Tue Feb 5 16:15:19 PST 2008; root:xnu-1228.3.13~1/RELEASE_PPC Power Macintosh
Dir            : /Users/root/root_v5.19.02-macosx10.5-ppc/test
Training events: 1000


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
V: "False" [Verbose mode]
H: "False" [Print classifier-specific help message]
GDTau: "-1" [Gradient-directed path: default fit cut-off]
GDTauPrec: "0.01" [Gradient-directed path: precision of tau]
GDStep: "0.01" [Gradient-directed path: step size]
GDNSteps: "10000" [Gradient-directed path: number of steps]
GDErrScale: "1.02" [Stop scan when error>scale*errmin]
fEventsMin: "0.01" [Minimum fraction of events in a splittable node]
fEventsMax: "0.5" [Maximum fraction of events in a splittable node]
nTrees: "20" [Number of trees in forest.]
RuleMinDist: "0.001" [Minimum distance between rules]
MinImp: "0.001" [Minimum rule importance accepted]
Model: "modrulelinear" [Model to be used]
RuleFitModule: "rftmva" [Which RuleFit module to use]
# Default:
D: "False" [use-decorrelated-variables flag (depreciated)]
Normalise: "False" [Normalise input variables]
VarTransform: "None" [Variable transformation method]
VarTransformType: "Signal" [Use signal or background events for var transform]
NbinsMVAPdf: "60" [Number of bins used to create MVA PDF]
NsmoothMVAPdf: "2" [Number of smoothing iterations for MVA PDF]
VerboseLevel: "Info" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs]
TxtWeightFilesOnly: "True" [if True, write all weights as text files]
GDPathEveFrac: "0.5" [Fraction of events used for the path search]
GDValidEveFrac: "0.5" [Fraction of events used for the validation]
ForestType: "adaboost" [Method to use for forest generation]
RFWorkDir: "./rulefit" [Friedmans RuleFit module: working dir]
RFNrules: "2000" [Friedmans RuleFit module: maximum number of rules]
RFNendnodes: "4" [Friedmans RuleFit module: average number of end nodes]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 4
var1+var2                     var1_P_var2                       'F'    [-6.05220985413,4.87306022644]
var1-var2                     var1_M_var2                       'F'    [-3.84853005409,3.82592988014]
var3                          var3                              'F'    [-5.18697977066,3.14527988434]
var4                          var4                              'F'    [-4.88857984543,3.45718002319]


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;
};

#endif

class ReadRuleFit : public IClassifierReader {

 public:

   // constructor
   ReadRuleFit( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "ReadRuleFit" ),
        fStatusIsClean( true ),
        fNvars( 4 ),
        fIsNormalised( false )
   {      
      // the training input variables
      const char* inputVars[] = { "var1+var2", "var1-var2", "var3", "var4" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -6.05220985412598;
      fVmax[0] = 4.87306022644043;
      fVmin[1] = -3.84853005409241;
      fVmax[1] = 3.82592988014221;
      fVmin[2] = -5.1869797706604;
      fVmax[2] = 3.14527988433838;
      fVmin[3] = -4.88857984542847;
      fVmax[3] = 3.45718002319336;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';

      // initialize constants
      Initialize();

   }

   // destructor
   virtual ~ReadRuleFit() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // common member variables
   const char* fClassName;
   bool fStatusIsClean;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[4];
   double fVmax[4];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[4];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)
   // not implemented for class: "ReadRuleFit"
};
void   ReadRuleFit::Initialize(){}
void   ReadRuleFit::Clear(){}
double ReadRuleFit::GetMvaValue__( const std::vector<double>& inputValues ) const {
   double rval=0.02833892819;
   //
   // here follows all rules ordered in importance (most important first)
   // at the end of each line, the relative importance of the rule is given
   //
   if ((inputValues[0]<1.719992638)&&(-0.5070559144<inputValues[3])) rval+=0.1662293432;   // importance = 0.494
   if ((-1.577239543<inputValues[0])&&(-1.608188471<inputValues[2])&&(-2.398300911<inputValues[3])&&(inputValues[3]<1.996672046)) rval+=-0.1669356127;   // importance = 0.448
   if ((inputValues[2]<1.633571928)&&(-0.5070559144<inputValues[3])) rval+=0.1243809316;   // importance = 0.369
   if ((0.7448080659<inputValues[3])) rval+=0.1148441812;   // importance = 0.308
   if ((inputValues[3]<0.7448080659)) rval+=-0.1128211594;   // importance = 0.303
   if ((-0.08976792097<inputValues[3])) rval+=0.0971326719;   // importance = 0.289
   if ((inputValues[3]<-0.08976792097)) rval+=-0.0945594993;   // importance = 0.281
   if ((-0.5681862533<inputValues[2])&&(-1.341631901<inputValues[3])&&(inputValues[3]<1.417800525)) rval+=-0.09157878733;   // importance = 0.273
   if ((inputValues[3]<-0.5070559144)) rval+=-0.09129431744;   // importance = 0.262
   if ((0.05663871169<inputValues[0])&&(-0.9243439078<inputValues[3])&&(inputValues[3]<0.9378175199)) rval+=-0.09939050982;   // importance = 0.252
   if ((-0.5070559144<inputValues[3])) rval+=0.08604485487;   // importance = 0.247
   if ((-0.9243439078<inputValues[3])) rval+=0.08838224722;   // importance = 0.234
   if ((inputValues[3]<-0.9243439078)) rval+=-0.08571062735;   // importance = 0.227
   if ((inputValues[2]<1.455723933)&&(-0.5070559144<inputValues[3])) rval+=0.0744238034;   // importance = 0.221
   if ((inputValues[1]<1.331730402)&&(inputValues[2]<0.6538087904)&&(-0.8372287791<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.07328848033;   // importance = 0.208
   if ((0.01080346406<inputValues[0])&&(inputValues[1]<-0.450849247)&&(-0.5070559144<inputValues[3])) rval+=0.09345406351;   // importance = 0.204
   if ((0.01080346406<inputValues[0])&&(-0.5070559144<inputValues[3])) rval+=0.06832611393;   // importance = 0.202
   if ((inputValues[2]<1.618867296)&&(-2.008236289<inputValues[3])&&(inputValues[3]<2.229528263)) rval+=0.08562841722;   // importance = 0.190
   if ((inputValues[1]<1.331730402)&&(-0.4572314829<inputValues[2])&&(inputValues[2]<0.6538087904)&&(-0.8372287791<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=-0.07158839763;   // importance = 0.189
   if ((-0.8627065659<inputValues[0])&&(inputValues[0]<0.7155258238)) rval+=0.06549081864;   // importance = 0.184
   if ((1.579384053<inputValues[3])) rval+=0.0881458307;   // importance = 0.175
   if ((inputValues[3]<1.579384053)) rval+=-0.08605366659;   // importance = 0.171
   if ((-1.341631901<inputValues[3])) rval+=0.07427038759;   // importance = 0.170
   if ((inputValues[3]<-1.341631901)) rval+=-0.06954143416;   // importance = 0.159
   if ((-0.9243439078<inputValues[3])&&(inputValues[3]<0.9378175199)) rval+=-0.05290269029;   // importance = 0.157
   if ((1.719992638<inputValues[0])&&(-0.5070559144<inputValues[3])) rval+=-0.07318148945;   // importance = 0.155
   if ((-0.212626785<inputValues[0])&&(1.331730402<inputValues[1])&&(-1.235111207<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.1226612146;   // importance = 0.155
   if ((inputValues[1]<-0.2031615853)&&(inputValues[3]<0.7448080659)) rval+=-0.05777728689;   // importance = 0.154
   if ((-0.5070559144<inputValues[3])&&(inputValues[3]<0.9865300022)) rval+=-0.04989874131;   // importance = 0.146
   if ((inputValues[2]<-0.5681862533)&&(-1.341631901<inputValues[3])&&(inputValues[3]<1.417800525)) rval+=0.0661633559;   // importance = 0.145
   if ((-0.2031615853<inputValues[1])&&(inputValues[3]<0.7448080659)) rval+=-0.04813348788;   // importance = 0.142
   if ((0.1273630261<inputValues[2])&&(-0.5070559144<inputValues[3])&&(inputValues[3]<0.9865300022)) rval+=-0.0543389824;   // importance = 0.134
   if ((0.1503420144<inputValues[2])&&(-0.5070559144<inputValues[3])&&(inputValues[3]<0.9865300022)) rval+=-0.05081098159;   // importance = 0.125
   if ((-0.08594025075<inputValues[2])&&(-1.08923445<inputValues[3])&&(inputValues[3]<0.7448080659)) rval+=-0.04675450137;   // importance = 0.120
   if ((1.331730402<inputValues[1])&&(-1.235111207<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.06618320929;   // importance = 0.114
   if ((-0.3009337902<inputValues[0])&&(inputValues[2]<-0.5681862533)&&(-1.341631901<inputValues[3])&&(inputValues[3]<1.417800525)) rval+=0.0846483984;   // importance = 0.111
   if ((-0.8409194522<inputValues[2])&&(inputValues[3]<-0.5070559144)) rval+=-0.05794707655;   // importance = 0.108
   if ((-2.158610708<inputValues[0])&&(inputValues[1]<1.331730402)&&(inputValues[2]<0.6538087904)&&(-0.1164680302<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.04336115752;   // importance = 0.102
   if ((-2.314647585<inputValues[0])&&(inputValues[1]<1.331730402)&&(-1.540812779<inputValues[2])&&(inputValues[2]<0.6538087904)&&(-0.1164680302<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.04336115752;   // importance = 0.102
   if ((inputValues[0]<0.05663871169)&&(-0.9243439078<inputValues[3])&&(inputValues[3]<0.9378175199)) rval+=0.03880405746;   // importance = 0.100
   if ((0.09958984256<inputValues[1])&&(inputValues[3]<-0.5070559144)) rval+=-0.03760751038;   // importance = 0.093
   if ((-0.8409194522<inputValues[2])&&(-1.524289447<inputValues[3])&&(inputValues[3]<-0.5070559144)) rval+=-0.05055514812;   // importance = 0.093
   if ((-1.129630715<inputValues[0])&&(inputValues[3]<-0.5070559144)) rval+=-0.04450110121;   // importance = 0.093
   if ((inputValues[1]<0.09958984256)&&(inputValues[3]<-0.5070559144)) rval+=-0.04301406369;   // importance = 0.090
   if ((inputValues[0]<2.302515459)&&(1.67554003<inputValues[2])&&(inputValues[3]<1.996672046)) rval+=-0.09154587402;   // importance = 0.088
   if ((inputValues[0]<-1.129630715)&&(inputValues[3]<-0.5070559144)) rval+=-0.03537464433;   // importance = 0.088
   if ((inputValues[2]<-0.08594025075)&&(-1.08923445<inputValues[3])&&(inputValues[3]<0.7448080659)) rval+=0.03415170051;   // importance = 0.087
   if ((inputValues[2]<-0.8409194522)&&(inputValues[3]<-0.5070559144)) rval+=-0.03206652723;   // importance = 0.083
   if ((inputValues[2]<1.67554003)&&(inputValues[3]<1.996672046)) rval+=0.04700383691;   // importance = 0.083
   if ((2.302515459<inputValues[0])&&(0.9941087209<inputValues[2])&&(0.9713505447<inputValues[3])&&(inputValues[3]<1.996672046)) rval+=0.07836116413;   // importance = 0.082
   if ((-1.496017486<inputValues[3])&&(inputValues[3]<-0.5070559144)) rval+=-0.03294263663;   // importance = 0.082
   if ((1.67554003<inputValues[2])&&(inputValues[3]<1.996672046)) rval+=-0.07042372485;   // importance = 0.080
   if ((0.1805614114<inputValues[1])) rval+=0.02373971705;   // importance = 0.071
   if ((-0.9706075788<inputValues[1])) rval+=-0.02865474331;   // importance = 0.067
   if ((inputValues[2]<-2.0623824)) rval+=0.05358605986;   // importance = 0.066
   if ((inputValues[1]<0.1805614114)) rval+=-0.02097343244;   // importance = 0.062
   if ((inputValues[0]<-0.212626785)&&(1.331730402<inputValues[1])&&(-1.235111207<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=-0.04987064625;   // importance = 0.062
   if ((0.01080346406<inputValues[0])&&(inputValues[0]<0.8319712617)&&(inputValues[1]<-0.450849247)&&(-0.5070559144<inputValues[3])) rval+=0.04475888002;   // importance = 0.059
   if ((-2.0623824<inputValues[2])) rval+=-0.04687545166;   // importance = 0.058
   if ((1.360658997<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.0518733742;   // importance = 0.058
   if ((0.01080346406<inputValues[0])&&(-0.450849247<inputValues[1])&&(-0.5070559144<inputValues[3])) rval+=-0.02134756936;   // importance = 0.057
   if ((1.839951432<inputValues[2])&&(1.579384053<inputValues[3])) rval+=0.04205944145;   // importance = 0.057
   if ((1.633571928<inputValues[2])&&(-0.5070559144<inputValues[3])) rval+=-0.02983605;   // importance = 0.051
   if ((inputValues[1]<-0.9706075788)) rval+=0.01852123047;   // importance = 0.043
   if ((0.2298204422<inputValues[0])) rval+=-0.01442806707;   // importance = 0.043
   if ((inputValues[0]<0.2298204422)) rval+=0.01424255611;   // importance = 0.042
   if ((inputValues[2]<-2.0623824)&&(-2.008236289<inputValues[3])&&(inputValues[3]<2.229528263)) rval+=0.07265744563;   // importance = 0.041
   if ((inputValues[2]<-2.0623824)&&(-2.008236289<inputValues[3])) rval+=0.07265744563;   // importance = 0.041
   if ((inputValues[0]<-0.8627065659)) rval+=-0.01441569411;   // importance = 0.040
   if ((-1.08923445<inputValues[3])&&(inputValues[3]<0.7448080659)) rval+=-0.0127818983;   // importance = 0.038
   if ((inputValues[2]<1.839951432)&&(1.579384053<inputValues[3])) rval+=0.02430613961;   // importance = 0.038
   if ((inputValues[1]<1.331730402)&&(inputValues[2]<0.6538087904)&&(-0.1164680302<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.01580367996;   // importance = 0.037
   if ((inputValues[1]<1.331730402)&&(-1.540812779<inputValues[2])&&(inputValues[2]<0.6538087904)&&(-0.1164680302<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.01580367996;   // importance = 0.037
   if ((1.455723933<inputValues[2])&&(-0.5070559144<inputValues[3])) rval+=0.01985903293;   // importance = 0.037
   if ((inputValues[0]<-0.3009337902)&&(inputValues[2]<-0.5681862533)&&(-1.341631901<inputValues[3])&&(inputValues[3]<1.417800525)) rval+=-0.01828988154;   // importance = 0.034
   if ((inputValues[1]<-0.2908249497)&&(inputValues[2]<1.839951432)&&(1.579384053<inputValues[3])) rval+=0.03092962891;   // importance = 0.034
   if ((inputValues[3]<1.996672046)) rval+=-0.02105978604;   // importance = 0.030
   if ((-1.058267504<inputValues[3])&&(inputValues[3]<-0.5070559144)) rval+=0.01302399653;   // importance = 0.027
   if ((-1.341631901<inputValues[3])&&(inputValues[3]<1.417800525)) rval+=-0.009201797027;   // importance = 0.026
   if ((-0.8627065659<inputValues[0])) rval+=0.0090520211;   // importance = 0.025
   if ((inputValues[2]<0.1273630261)&&(-0.5070559144<inputValues[3])&&(inputValues[3]<0.9865300022)) rval+=0.009263219275;   // importance = 0.021
   if ((inputValues[1]<1.331730402)&&(1.081813982<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.01348524247;   // importance = 0.021
   if ((1.996672046<inputValues[3])) rval+=0.01508690285;   // importance = 0.021
   if ((inputValues[1]<1.331730402)&&(0.6538087904<inputValues[2])&&(1.081813982<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.01174814547;   // importance = 0.018
   if ((-0.9261767328<inputValues[0])&&(inputValues[1]<1.331730402)&&(inputValues[2]<0.6538087904)&&(-0.1164680302<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.007640520344;   // importance = 0.017
   if ((inputValues[1]<-0.9706075788)&&(0.7868171334<inputValues[2])) rval+=0.01058921715;   // importance = 0.017
   if ((inputValues[1]<-0.9706075788)&&(0.7868171334<inputValues[2])&&(0.3001613259<inputValues[3])) rval+=0.01058921715;   // importance = 0.016
   if ((0.02068251371<inputValues[2])) rval+=0.005482153238;   // importance = 0.016
   if ((inputValues[0]<-0.3009337902)&&(inputValues[1]<0.2121772289)&&(inputValues[2]<-0.5681862533)&&(-1.341631901<inputValues[3])&&(inputValues[3]<1.417800525)) rval+=-0.01202577131;   // importance = 0.016
   if ((inputValues[2]<-0.395930469)) rval+=0.005414162416;   // importance = 0.016
   if ((inputValues[2]<-0.395930469)&&(inputValues[3]<0.4743362814)) rval+=0.005414162416;   // importance = 0.016
   if ((inputValues[1]<-0.9706075788)&&(inputValues[2]<0.7868171334)) rval+=0.008142221083;   // importance = 0.015
   if ((inputValues[2]<0.1503420144)&&(-0.5070559144<inputValues[3])&&(inputValues[3]<0.9865300022)) rval+=0.006236247275;   // importance = 0.015
   if ((2.302515459<inputValues[0])&&(-1.608188471<inputValues[2])&&(-2.398300911<inputValues[3])&&(inputValues[3]<1.996672046)) rval+=0.009386566585;   // importance = 0.013
   if ((2.000654936<inputValues[2])&&(1.996672046<inputValues[3])) rval+=0.01252276646;   // importance = 0.013
   if ((1.081813982<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=0.007489208132;   // importance = 0.012
   if ((-0.395930469<inputValues[2])) rval+=-0.003132806594;   // importance = 0.009
   if ((2.302515459<inputValues[0])&&(1.67554003<inputValues[2])&&(-2.398300911<inputValues[3])&&(inputValues[3]<1.996672046)) rval+=0.01176200028;   // importance = 0.007
   if ((2.302515459<inputValues[0])&&(1.67554003<inputValues[2])&&(inputValues[3]<1.996672046)) rval+=0.01176200028;   // importance = 0.007
   if ((2.302515459<inputValues[0])&&(1.67554003<inputValues[2])&&(0.9713505447<inputValues[3])&&(inputValues[3]<1.996672046)) rval+=0.01176200028;   // importance = 0.007
   if ((inputValues[0]<-0.3009337902)&&(0.2121772289<inputValues[1])&&(inputValues[2]<-0.5681862533)&&(-1.341631901<inputValues[3])&&(inputValues[3]<1.417800525)) rval+=-0.004469437721;   // importance = 0.006
   if ((inputValues[2]<-2.0623824)&&(inputValues[3]<-2.008236289)) rval+=-0.005661034942;   // importance = 0.006
   if ((1.331730402<inputValues[1])&&(1.081813982<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=-0.008780525523;   // importance = 0.005
   if ((inputValues[2]<0.02068251371)) rval+=-0.001459934748;   // importance = 0.004
   if ((1.67554003<inputValues[2])&&(1.455023769<inputValues[3])&&(inputValues[3]<1.996672046)) rval+=-0.00376120064;   // importance = 0.004
   if ((-0.2908249497<inputValues[1])&&(inputValues[2]<1.839951432)&&(1.579384053<inputValues[3])) rval+=-0.002395424342;   // importance = 0.003
   if ((inputValues[0]<-2.314647585)&&(inputValues[1]<1.331730402)&&(-1.540812779<inputValues[2])&&(inputValues[2]<0.6538087904)&&(-0.1164680302<inputValues[3])&&(inputValues[3]<1.579384053)) rval+=-0.004407930259;   // importance = 0.001
   //
   // here follows all linear terms
   // at the end of each line, the relative importance of the term is given
   //
   rval+=-0.01928294082*std::min( double(3.35435009), std::max( double(inputValues[0]), double(-3.403450012)));   // importance = 0.184
   rval+=-0.01477915118*std::min( double(2.52312994), std::max( double(inputValues[1]), double(-2.46736002)));   // importance = 0.097
   rval+=-0.01304704925*std::min( double(2.232280016), std::max( double(inputValues[2]), double(-2.345360041)));   // importance = 0.087
   rval+=0.1364456731*std::min( double(2.484050035), std::max( double(inputValues[3]), double(-2.507430077)));   // importance = 1.000
   return rval;
}
   inline double ReadRuleFit::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!fStatusIsClean) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            retval = GetMvaValue__( iV );
         }
         else {
            retval = GetMvaValue__( inputValues );
         }
      }

      return retval;
   }
