// Class: ReadSVM_Gauss
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : SVM::SVM_Gauss
TMVA Release   : 3.8.13        [198669]
ROOT Release   : 5.19/02       [332546]
Creator        : heponx
Date           : Fri Mar 28 00:39:53 2008
Host           : Darwin jlctpcmac.kek.jp 9.2.0 Darwin Kernel Version 9.2.0: Tue Feb 5 16:15:19 PST 2008; root:xnu-1228.3.13~1/RELEASE_PPC Power Macintosh
Dir            : /Users/root/root_v5.19.02-macosx10.5-ppc/test
Training events: 1000


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
V: "False" [Verbose mode]
H: "False" [Print classifier-specific help message]
C: "1" [C parameter]
Tol: "0.001" [Tolerance parameter]
Sigma: "2" [Kernel parameter: Sigma]
Kernel: "Gauss" [Uses kernel function]
# Default:
D: "False" [use-decorrelated-variables flag (depreciated)]
Normalise: "True" [Normalise input variables]
VarTransform: "None" [Variable transformation method]
VarTransformType: "Signal" [Use signal or background events for var transform]
NbinsMVAPdf: "60" [Number of bins used to create MVA PDF]
NsmoothMVAPdf: "2" [Number of smoothing iterations for MVA PDF]
VerboseLevel: "Info" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs]
TxtWeightFilesOnly: "True" [if True, write all weights as text files]
MaxIter: "1000" [Maximum number of training loops]
Order: "3" [Polynomial Kernel parameter: polynomial order]
Theta: "1" [Sigmoid Kernel parameter: Theta]
Kappa: "1" [Sigmoid Kernel parameter: Kappa]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 4
var1+var2                     var1_P_var2                       'F'    [-6.05220985413,4.87306022644]
var1-var2                     var1_M_var2                       'F'    [-3.84853005409,3.82592988014]
var3                          var3                              'F'    [-5.18697977066,3.14527988434]
var4                          var4                              'F'    [-4.88857984543,3.45718002319]


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;
};

#endif

class ReadSVM_Gauss : public IClassifierReader {

 public:

   // constructor
   ReadSVM_Gauss( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "ReadSVM_Gauss" ),
        fStatusIsClean( true ),
        fNvars( 4 ),
        fIsNormalised( true )
   {      
      // the training input variables
      const char* inputVars[] = { "var1+var2", "var1-var2", "var3", "var4" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -6.05220985412598;
      fVmax[0] = 4.87306022644043;
      fVmin[1] = -3.84853005409241;
      fVmax[1] = 3.82592988014221;
      fVmin[2] = -5.1869797706604;
      fVmax[2] = 3.14527988433838;
      fVmin[3] = -4.88857984542847;
      fVmax[3] = 3.45718002319336;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';

      // initialize constants
      Initialize();

   }

   // destructor
   virtual ~ReadSVM_Gauss() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // common member variables
   const char* fClassName;
   bool fStatusIsClean;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[4];
   double fVmax[4];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[4];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)
   // not implemented for class: "ReadSVM_Gauss"
   float        fBparameter;
   int          fNOfSuppVec;
   static float fAllSuppVectors[][525];
   static float fAlphaTypeCoef[525];

   // Kernel parameter(s) 
   float fSigmaParm;
};

inline void ReadSVM_Gauss::Initialize() 
{
   fBparameter = 0.281995594501495;
   fNOfSuppVec = 525;

   // Kernel parameter(s) 
   fSigmaParm  = -0.5;
}

inline double ReadSVM_Gauss::GetMvaValue__(const std::vector<double>& inputValues ) const
{
   double mvaval = 0; 
   double temp = 0; 

   for (int ievt = 0; ievt < fNOfSuppVec; ievt++ ){
      temp = 0;
      for ( unsigned int ivar = 0; ivar < GetNvar(); ivar++ ) {
         temp += (fAllSuppVectors[ivar][ievt] - inputValues[ivar])  
               * (fAllSuppVectors[ivar][ievt] - inputValues[ivar]); 
      }
      mvaval += fAlphaTypeCoef[ievt] * exp( fSigmaParm * temp ); 
   }
   mvaval -= fBparameter;
   return 1./(1. + exp( -mvaval));
}
// Clean up
inline void ReadSVM_Gauss::Clear() 
{
   // nothing to clear 
}

float ReadSVM_Gauss::fAlphaTypeCoef[] =
{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.611337840557098, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.479562848806381, 1, 1, 1, 1, 1, 1, -1, -1, -1, -1, -1, -1, -1, -0.592390239238739, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -0.302742540836334, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -0.853685438632965, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -0.997375726699829, -1, -1, -1, -0.378863573074341, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -0.103809170424938, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -0.615305662155151, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -0.259718716144562, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -0.987004935741425, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1 };

float ReadSVM_Gauss::fAllSuppVectors[][525] =
{
   { 0.499699294567108, 0.124426178634167, -0.0456089675426483, 0.222948238253593, -0.286379218101501, 0.364323228597641, -0.248613566160202, -0.130260422825813, -0.37459123134613, 0.384033501148224, 0.336807191371918, -0.114696510136127, 0.432147651910782, 0.121888943016529, 0.254114508628845, -0.242999061942101, -0.207272708415985, 0.0457480326294899, 0.0247032474726439, 0.252582281827927, 0.174158588051796, -0.102471627295017, 0.255950629711151, -0.240560665726662, 0.006572803016752, -0.539216935634613, 0.433762222528458, -0.0497736297547817, -0.390045344829559, -0.0233889278024435, 0.224842920899391, -0.0706353634595871, 0.703015089035034, -0.530896723270416, -0.0301018115133047, 0.0274253748357296, 0.0367523729801178, -0.168608218431473, 0.378094971179962, -0.0149479517713189, 0.518950045108795, 0.880456984043121, 0.322964072227478, 0.316595315933228, -0.284014075994492, 0.371263086795807, -0.0265156254172325, 0.0236121956259012, 0.122015245258808, 0.18070487678051, 0.0795998275279999, 0.366984933614731, -0.083010345697403, 0.419538348913193, -0.0971134155988693, 0.270751178264618, -0.278987199068069, -0.245871305465698, 0.146347835659981, 0.368579417467117, -0.234999269247055, -0.263705164194107, 0.133791625499725, -0.34215635061264, 0.192371413111687, 0.341566801071167, 0.161433950066566, 0.116759553551674, 0.534294307231903, 0.0898439660668373, -0.179787799715996, 0.152066692709923, -0.136394843459129, -0.233950302004814, 0.204612761735916, 0.191168695688248, 0.757787227630615, 0.324631750583649, 0.145243972539902, 0.148870423436165, -0.0378380008041859, -0.141070231795311, -0.203327715396881, 0.062891773879528, 0.175958082079887, 0.283100515604019, 0.235905349254608, 0.285002529621124, -0.161476120352745, 0.46381551027298, -0.291900366544724, 0.0751587525010109, -0.24809367954731, -0.236602887511253, -0.0692093074321747, 0.121614351868629, 0.0456235446035862, 0.432568699121475, -0.306237757205963, -0.176390185952187, 0.299195319414139, -0.267631858587265, 0.685777962207794, 0.537298321723938, 0.148039326071739, 0.160890266299248, 0.150766953825951, 0.137758582830429, 0.659611105918884, 0.0470971986651421, 0.218900740146637, 0.324948459863663, 0.12829427421093, 0.656599760055542, -0.0754334256052971, 0.299116581678391, 0.324232667684555, -0.13065767288208, 0.179227575659752, 0.109519451856613, 0.602572739124298, 0.21135675907135, 0.747407555580139, -0.0170330200344324, 0.146259963512421, 0.72198212146759, 0.318105578422546, 0.171745836734772, 1, 0.00291705830022693, 0.257805019617081, -0.152734935283661, 0.240752816200256, 0.1547631919384, 0.212660148739815, 0.270196497440338, -0.119115628302097, 0.215321883559227, -0.0415761172771454, 0.0319781117141247, 0.100027695298195, 0.436669260263443, -0.00119267450645566, 0.72153913974762, -0.0721419528126717, -0.0167895443737507, 0.349841177463531, 0.152322977781296, 0.1699188798666, 0.314878225326538, 0.226512432098389, -0.0365657173097134, -0.3523308634758, 0.0319927670061588, -0.0136793237179518, 0.0634098425507545, -0.0305704418569803, 0.316388487815857, -0.09642144292593, 0.48714491724968, -0.232859268784523, -0.159912779927254, 0.000171133389812894, 0.0966135933995247, 0.79159140586853, 0.280911087989807, -0.0714792907238007, 0.11359441280365, 0.307570397853851, 0.00928395334631205, -0.296896129846573, 0.00913750194013119, -0.0681933090090752, 0.131309300661087, 0.471987366676331, 0.0946255475282669, 0.00832836050540209, 0.24495042860508, 0.196039974689484, -0.236306324601173, -0.350923180580139, -0.17119488120079, -0.138219952583313, -0.43122324347496, -0.185817867517471, 0.210803911089897, 0.0404904931783676, 0.624862313270569, 0.042540792375803, -0.169578433036804, 0.81790828704834, 0.352239310741425, -0.256549298763275, 0.152214959263802, 0.0111804744228721, -0.178751677274704, 0.122421659529209, -0.0411495938897133, 0.395220398902893, 0.336543589830399, -0.00475872820243239, 0.061590202152729, -0.00200913706794381, -0.155574217438698, 0.513793230056763, 0.114125303924084, 0.330934584140778, -0.0411788783967495, -0.368281066417694, -0.104174122214317, 0.164886504411697, 0.0138623286038637, 0.119917370378971, 0.291116803884506, 0.131314799189568, 0.196032643318176, 0.263090044260025, 0.149719834327698, -0.127404659986496, 0.0262977108359337, 0.222413688898087, -0.309671998023987, 0.0349162705242634, 0.207960963249207, -0.577035665512085, 0.126079231500626, 0.455744326114655, 0.0117790810763836, -0.0808575376868248, 0.0382644608616829, -0.527969598770142, -0.16967548429966, 0.339935719966888, 0.193799287080765, -0.0260396618396044, 0.136815816164017, 0.349517196416855, -0.071966215968132, -0.266540795564651, -0.24820901453495, 0.263282239437103, -0.44013836979866, 0.118293605744839, -0.123342521488667, 0.0157588385045528, -0.248655676841736, -0.18499593436718, 0.366347879171371, 0.311145603656769, -0.0695076957345009, 0.221390381455421, 0.121599711477757, 0.382812470197678, 0.145088374614716, 0.0970730781555176, 0.393294602632523, 0.00637326762080193, 0.250107288360596, 0.284052431583405, 0.285097718238831, 0.38514831662178, 0.287678897380829, -0.0271545182913542, 0.364242672920227, 0.319736689329147, -0.218142911791801, -0.0552069060504436, 0.145335495471954, -0.0504674389958382, 0.165865883231163, -0.109995469450951, 0.492618471384048, 0.156418070197105, 0.66530978679657, 0.349746018648148, -0.0931153520941734, 0.208460718393326, 0.45016822218895, 0.0330380499362946, -0.641305029392242, 0.0494934804737568, 0.273235321044922, -0.174958646297455, -0.129691109061241, 0.112296499311924, 0.195974066853523, 0.12114754319191, 0.144877851009369, 0.52240264415741, -0.287215828895569, 0.0454661212861538, -0.212770044803619, -0.0365181118249893, 0.0592341981828213, -0.228890493512154, 0.144799128174782, 0.189387515187263, 0.473151654005051, -0.0806323736906052, 0.548939287662506, -0.0511429347097874, 0.129714831709862, -0.0731048658490181, 0.224667176604271, -0.0875337868928909, -0.215902253985405, 0.243301048874855, 0.147504776716232, 0.261598080396652, -0.182973086833954, 0.175767704844475, 0.0939116030931473, 0.0500902608036995, 0.262868523597717, 0.322848737239838, 0.0449938215315342, 0.677466928958893, 0.153668478131294, 0.284061580896378, 0.383083403110504, 0.0694710090756416, 0.00828990899026394, 0.251573622226715, 0.0126541163772345, 0.199754297733307, -0.247593924403191, 0.473098546266556, -0.197839543223381, 0.426791250705719, -0.237443149089813, -0.107159838080406, -0.0378929190337658, 0.474936485290527, 0.235176771879196, -0.150450319051743, -0.191212683916092, 0.426950514316559, 0.0661283060908318, 0.484582006931305, -0.367411553859711, 0.460150599479675, 0.108347862958908, 0.190595716238022, -0.00303428969345987, 0.532809674739838, 0.275754243135452, -0.13808998465538, -0.436848729848862, 0.0022616907954216, 0.563527464866638, 0.641605138778687, 0.29443022608757, 0.198994591832161, -0.127133727073669, 0.0957605317234993, 0.0948781669139862, 0.351788967847824, -0.180256441235542, 0.0687058195471764, -0.075091078877449, 0.0781463161110878, 0.148769751191139, 0.637389242649078, 0.401424378156662, 0.3433498442173, -0.203818336129189, -0.153187081217766, 0.327824354171753, 0.291323661804199, -0.0251444857567549, 0.318493694067001, 0.12087844312191, -0.227336302399635, -0.312060981988907, 0.484263509511948, 0.0947207361459732, -0.0178586263209581, -0.373708873987198, 0.0683049112558365, 0.564512312412262, 0.577114343643188, 0.495044022798538, -0.22806304693222, -0.340441048145294, 0.857711493968964, 0.361072033643723, 0.11358892172575, -0.0667910575866699, 0.151458919048309, 0.275756061077118, 0.22566120326519, 0.181975334882736, -0.447479128837585, -0.0317822992801666, 0.174469798803329, 0.168952316045761, 0.609124481678009, 0.114238791167736, 0.093884140253067, 0.421590477228165, 0.35879111289978, -0.334910750389099, 0.246713310480118, 0.0726270079612732, 0.0583371929824352, 0.0985320806503296, -0.371803194284439, 0.240436121821404, 0.286598831415176, -0.0252140667289495, -0.0565688833594322, -0.0840739384293556, 0.0907666012644768, -0.127496182918549, 0.0244963858276606, 0.192788794636726, 0.0972378328442574, 0.104640856385231, 0.56316864490509, -0.178532019257545, -0.158924266695976, -0.336863994598389, 0.0660349428653717, 0.525078952312469, -0.19145068526268, 0.417092651128769, 0.28145843744278, 0.280504703521729, -0.0649329870939255, -0.239769861102104, -0.0350188501179218, -0.356244772672653, -0.200887516140938, 0.349063187837601, -0.147772133350372, 0.589026093482971, -0.351386308670044, 0.266449213027954, -0.154790714383125, -0.160213023424149, -0.288841396570206, 0.0755413472652435, 0.208812192082405, -0.105483025312424, 0.03483572229743, 0.292451351881027, -0.275380849838257, -0.178099974989891, -0.0601642206311226, 0.365743786096573, -0.00828999653458595, 0.22268645465374, 0.283741235733032, 0.184144616127014, 0.288037687540054, 0.183022439479828, 0.0727862641215324, -0.336783468723297, 0.0368054620921612, 0.828282475471497, 0.30079710483551, 0.344788700342178, -0.0805023908615112, -0.304701894521713, -0.133777037262917, -0.241177573800087, 0.581185638904572, 0.269301325082779, 0.462504774332047, 0.114321164786816, -0.327667027711868, 0.308795064687729, 0.297088295221329, 0.203453972935677, 0.0380045138299465, 0.224297389388084, 0.0197642482817173, -0.293893903493881, 0.426707029342651, -0.065518781542778, 0.245124340057373, -0.436297714710236, -0.202707126736641, -0.0164856649935246, 0.0445270128548145, 0.0505643859505653, 0.172842368483543, -0.411906540393829, -0.0853883177042007, 0.0886192843317986, 0.276305258274078, 0.4346903860569, -1, 0.853856205940247, 0.280770152807236, 0.0600469969213009, 0.254903525114059, -0.165454089641571, 0.166790351271629, 0.0700568109750748, 0.0255087167024612, 0.0851520970463753, -0.236419811844826, -0.459563016891479, 0.0320458561182022, 0.00645747035741806, -0.0281888134777546, 0.619645059108734, -0.450281798839569, 0.0886979997158051, 0.277392655611038, 0.713085353374481, 0.0199381411075592, 0.0987755507230759, -0.388090193271637, 0.187906533479691, 0.356962293386459, 0.133194833993912, -0.739424288272858, 0.481605440378189, 0.0672285109758377, 0.262317508459091, -0.0286025386303663, 0.395579218864441, 0.12536895275116 }, 

   { 0.109573848545551, 0.0235430467873812, -0.677733600139618, 0.158403351902962, -0.215712890028954, 0.0731647834181786, 0.0399142354726791, -0.133768349885941, 0.146134093403816, 0.0150056453421712, 0.347875952720642, 0.175798714160919, -0.271229475736618, -0.0406490936875343, 0.416524440050125, -0.156042218208313, 0.116763956844807, 0.0444617792963982, 0.123107053339481, 0.741568803787231, -0.255775630474091, 0.247621342539787, 0.166383072733879, -0.346294045448303, -0.0424081720411777, -0.09524055570364, 0.04355488717556, -0.0292320046573877, -0.035262368619442, 0.255627125501633, 0.120785064995289, 0.502667367458344, -0.134101912379265, -0.422745019197464, -0.13852958381176, 0.0504061728715897, 0.177620336413383, 0.396775841712952, -0.0803287476301193, -0.178730472922325, -0.0129780909046531, -0.0659382045269012, 0.433057188987732, 0.207261517643929, -0.133106410503387, -0.0219064000993967, 0.221039682626724, 0.365922838449478, 0.346153378486633, 0.168358445167542, -0.00602776324376464, 0.339502722024918, 0.0181719809770584, 0.439986675977707, 0.159497901797295, -0.0798857286572456, 0.186963021755219, -0.372659415006638, -0.192735359072685, -0.0190188940614462, -0.101419493556023, 0.756191313266754, 0.315607875585556, 0.118369281291962, -0.318610042333603, 0.31661382317543, 0.388822168111801, -0.288400709629059, 0.693849503993988, -0.232951864600182, 0.336875855922699, 0.149834677577019, -0.273986667394638, 0.504666149616241, -0.427534937858582, -0.210930794477463, 0.333964854478836, -0.123873196542263, -0.111669071018696, 0.199631005525589, -0.249140620231628, 0.635278642177582, -0.263471275568008, 0.155904144048691, 0.207284972071648, -0.108541809022427, -0.100622050464153, -0.246571063995361, -0.169684872031212, 0.0652450174093246, 0.56669008731842, -0.519366800785065, 0.05585802718997, -0.331960797309875, -0.244374170899391, 0.350148439407349, -0.763480365276337, 0.419419765472412, 0.149128422141075, -0.649007201194763, 0.654868245124817, 0.0635693073272705, -0.233689397573471, 0.258282691240311, -0.097098670899868, 0.226499363780022, -0.301115602254868, -0.375038743019104, -0.350372552871704, -0.0539034456014633, -0.179504469037056, -0.149837225675583, -0.0355594828724861, -0.324278175830841, -0.287723153829575, 0.416469752788544, 0.266225934028625, 0.283384144306183, -0.0800212472677231, 0.137560188770294, 0.0510316267609596, 0.0142472814768553, 0.0261334776878357, -0.182152196764946, 0.0668633580207825, 0.238904118537903, 0.11283141374588, -0.0758020579814911, 0.0616643242537975, 0.0386372730135918, 0.182094931602478, -0.279829442501068, 0.048188429325819, -0.334277540445328, -0.260878264904022, 0.222887367010117, 0.403561949729919, -0.0513208508491516, -0.0499657057225704, -1, -0.293263614177704, 0.414494335651398, -0.309934496879578, -0.160368263721466, -0.270981937646866, -0.0445242822170258, -0.401388466358185, 0.118035688996315, 0.190796509385109, 0.091302864253521, 0.50159102678299, -0.27579265832901, 0.0944249033927917, 0.348884522914886, -0.640060663223267, -0.0292684882879257, 0.100246824324131, 0.0507241152226925, 0.0623340457677841, 0.303312569856644, 0.196589753031731, 0.0900597870349884, 0.491401374340057, 0.660484254360199, 0.0838886424899101, 0.681470811367035, 0.804246842861176, -0.00581927876919508, -0.419883579015732, 0.291376888751984, 0.028851579874754, 0.110454700887203, -0.430167019367218, 0.556688070297241, -0.230228573083878, 0.144205614924431, -0.118043467402458, 0.0625190809369087, -0.0897313728928566, -0.178673133254051, -0.299935102462769, 0.192396610975266, -0.292393207550049, 0.205770865082741, 0.684746563434601, -0.236730650067329, 0.282388597726822, -0.022239975631237, 0.312952309846878, 0.374316930770874, 0.328883081674576, -0.313549071550369, -0.208590567111969, 0.52757853269577, 0.334955215454102, 0.0897757261991501, 0.5323606133461, -0.0779259875416756, -0.639875650405884, 0.0813295319676399, -0.228396520018578, 0.47806105017662, 0.282404273748398, 0.43636167049408, 0.0222843401134014, -0.545609712600708, -0.556651532649994, 0.0570985116064548, 0.0167464874684811, -0.121410474181175, 0.213185057044029, -0.168671131134033, -0.16486631333828, 0.096864178776741, -0.362816423177719, 0.282219231128693, 0.279183208942413, 0.441477328538895, 0.279644459486008, 0.0589071027934551, 0.373850435018539, -0.498119711875916, -0.290897309780121, -0.334981203079224, -0.320191860198975, -0.079132579267025, -0.0552038736641407, -0.376279205083847, -0.152789875864983, -0.243751332163811, 0.547473073005676, 0.260654211044312, 0.276222705841064, 0.0909406170248985, 0.203172609210014, -0.315712094306946, 0.422692984342575, -0.247584819793701, 0.143621876835823, 0.0935232192277908, 0.0576926805078983, -0.75396317243576, 0.169638007879257, -0.311154127120972, 0.0466717146337032, -0.375883102416992, 0.458132594823837, 0.0587533451616764, 0.0885586962103844, -0.187132358551025, 0.042702704668045, 0.321846783161163, 0.212645635008812, -0.133520767092705, -0.422502666711807, -0.489756911993027, 0.191669538617134, 0.127323642373085, -0.236311063170433, 0.351016283035278, -0.0450298450887203, -0.0541718602180481, 0.355472594499588, -0.756923615932465, 0.0508622229099274, -0.143971011042595, -0.251293212175369, 0.827362477779388, -0.208504557609558, -0.0207310765981674, -0.489259153604507, 0.709490954875946, -0.0184247251600027, 0.198192477226257, -0.0667564645409584, -0.12640106678009, 0.332883387804031, 0.0839746668934822, -0.310447871685028, -0.0887489020824432, 0.202784329652786, 0.232076287269592, 0.091193400323391, -0.135824516415596, -0.232266485691071, 0.564803302288055, -0.0624017640948296, 0.0683253556489944, 0.515908658504486, 0.156996086239815, 0.139577254652977, -0.0787234157323837, 0.681825220584869, -0.0755753293633461, -0.0804017260670662, 0.18892015516758, 0.214800804853439, -0.462187558412552, 0.637678802013397, 0.396343231201172, -0.780044436454773, 0.399045705795288, -0.218167781829834, 0.101036444306374, -0.150478318333626, -0.349489063024521, -0.0818741396069527, 0.252429515123367, -0.398573935031891, 0.151299268007278, 0.0617059916257858, -0.116096742451191, 0.037508849054575, 0.334970831871033, 0.0042192186228931, -0.132660776376724, -0.104836031794548, -0.151301831007004, 0.0351529829204082, -0.102581784129143, -0.549000144004822, -0.672779560089111, -0.0551595576107502, 0.110577188432217, -0.109206363558769, 0.802873432636261, 0.092042975127697, 0.310687690973282, -0.51886647939682, 0.0975443422794342, 0.832843005657196, 0.0355803817510605, 0.505648612976074, -0.123247742652893, -0.275253236293793, 0.541671991348267, 0.0474926121532917, -0.0592406317591667, -0.435793519020081, -0.4468092918396, -0.05119314417243, -0.370092451572418, 0.184398666024208, 0.379776567220688, -0.065294474363327, 0.0130432834848762, 0.144805014133453, -0.123636014759541, 0.125939831137657, 0.437120020389557, -0.106389231979847, 0.0331411175429821, 0.263179451227188, 0.640534996986389, -0.186512127518654, -0.186501696705818, 0.0486914031207561, -0.189488232135773, 0.363126546144485, 0.160347461700439, -0.0241241473704576, -0.26904821395874, -0.0115630123764277, 0.0652241557836533, -0.0200925972312689, -0.525587439537048, -0.0580574870109558, 0.225618496537209, -0.0690237209200859, -0.237538516521454, 0.144020572304726, 0.0897470563650131, 0.502437949180603, -0.222251445055008, -0.0387310348451138, 0.21301044523716, -0.517255902290344, -0.175733506679535, 0.138149172067642, 0.345486223697662, -0.0937003716826439, 0.373162418603897, 0.271352022886276, -0.381525218486786, 0.100580386817455, -0.420264065265656, -0.104163661599159, 0.647511422634125, 0.260497808456421, 0.333714693784714, 0.00828464236110449, 0.0496478192508221, 0.357786744832993, -0.397497653961182, -0.464822262525558, -0.444708824157715, 1, 0.131055504083633, -0.0604237765073776, 0.340172499418259, 0.476231575012207, -0.208861589431763, -0.0362943895161152, -0.057640515267849, -0.495216608047485, -0.108805030584335, -0.555635154247284, 0.704518675804138, 0.183817520737648, 0.338058978319168, 0.16202574968338, 0.257560819387436, -0.326472461223602, -0.192977711558342, -0.167568758130074, 0.426620244979858, 0.0144740054383874, -0.147611662745476, 0.629394114017487, -0.242516070604324, -0.169909000396729, -0.098586730659008, -0.275065571069717, -0.518983721733093, 0.105617888271809, 0.329083770513535, 0.00682525476440787, 0.176835909485817, 0.368713915348053, 0.457097977399826, 0.4775450527668, -0.107376933097839, 0.0479538850486279, 0.259173959493637, -0.0697899013757706, -0.0827367603778839, 0.175238430500031, 0.336805462837219, -0.459143698215485, -0.246073320508003, 0.552599132061005, 0.0987952500581741, -0.143241330981255, 0.163662359118462, 0.320606291294098, -0.330493599176407, 0.291918933391571, -0.210498183965683, 0.249260559678078, 0.10300400853157, -0.0108359241858125, 0.13157930970192, -0.17641369998455, 0.295020133256912, 0.122288763523102, -0.287235826253891, 0.116644069552422, 0.193139344453812, -0.625065505504608, -0.177057400345802, -0.132426217198372, 0.0953761264681816, 0.36939412355423, -0.00880579836666584, -0.176228657364845, -0.321122258901596, 0.514128684997559, 0.0144010372459888, 0.0635250061750412, -0.0669910088181496, -0.79748147726059, 0.155075430870056, 0.0269595757126808, 0.0569265000522137, 0.0656333118677139, -0.0593969896435738, 0.447168946266174, 0.0779338479042053, -0.166805192828178, 0.389979273080826, -0.150892674922943, -0.381856173276901, 0.743846476078033, -0.23164364695549, 0.08070407807827, 0.383844643831253, -0.277314603328705, -0.16294302046299, 0.0405657365918159, -0.0979977548122406, 0.0189772564917803, -0.206289425492287, 0.541846692562103, 0.128819525241852, -0.00675224093720317, -0.0998636782169342, -0.330501407384872, -0.0854392200708389, 0.278737545013428, -0.223921924829483, -0.194559589028358, 0.305840462446213, 0.0851421728730202, 0.24800181388855, 0.366206884384155, 0.261318743228912, 0.184977203607559, -0.0348271876573563, 0.717845976352692, -0.102639123797417, -0.204246267676353, -0.45454403758049, 0.462505578994751, 0.331953018903732, 0.0188912563025951, -0.293135911226273, 0.0599860027432442, 0.105409398674965, -0.249919861555099, -0.170586571097374, 0.202184930443764, 0.171157345175743, 0.110986337065697, 0.390325844287872, 0.0256930347532034 }, 

   { 0.333981424570084, 0.0910197049379349, 0.0634065493941307, 0.556751728057861, 0.271873414516449, 0.313444375991821, 0.0931175798177719, 0.188851520419121, -0.0592132359743118, 0.196568518877029, 0.316703975200653, 0.194086596369743, 0.206112146377563, -0.0041333376429975, -0.145960420370102, 0.138785868883133, 0.0317344777286053, -0.0667190104722977, 0.473612189292908, 0.444110006093979, 0.319212317466736, 0.196616515517235, 0.414060533046722, 0.422884076833725, -0.0112694762647152, 0.14844711124897, 0.416170418262482, 0.733791351318359, 0.213238656520844, 0.238629132509232, 0.22687241435051, 0.424965143203735, 0.497264862060547, 0.0792078003287315, -0.0907461196184158, 0.0154747776687145, 0.317419290542603, 0.174788102507591, 0.418222665786743, 0.0867999717593193, 0.641516268253326, 0.752230525016785, 0.189833238720894, 0.466447293758392, -0.0805663987994194, 0.484528809785843, 0.00761137343943119, 0.404612928628922, 0.170846790075302, 0.337689906358719, 0.200915470719337, 0.370379716157913, 0.218627348542213, 0.365151822566986, 0.197101384401321, 0.262344181537628, 0.294628351926804, 0.131289705634117, 0.308010071516037, 0.345728516578674, 0.147465392947197, -0.0452962592244148, 0.421011835336685, -0.125053718686104, 0.553669691085815, 0.55931282043457, -0.231241017580032, 0.41869792342186, 0.344343543052673, 0.176165878772736, 0.143881723284721, 0.326998919248581, 0.0783796831965446, -0.266429543495178, 0.44851216673851, 0.230021625757217, 0.498539417982101, 0.147837430238724, 0.439563810825348, 0.295067608356476, 0.064995564520359, 0.278836697340012, 0.119472987949848, 0.0816585049033165, 0.202523678541183, 0.587199628353119, 0.354019194841385, 0.0525259524583817, 0.249452129006386, 0.196342885494232, -0.0646595507860184, -0.028834929689765, 0.0781252458691597, 0.212936222553253, 0.245974078774452, 0.020378615707159, 0.448524177074432, 0.311994582414627, -0.0899252146482468, 0.439616620540619, 0.373980164527893, -0.304232031106949, 0.310799241065979, 0.174423262476921, 0.306104242801666, 0.0759721770882607, 0.164867624640465, 0.43987825512886, 0.439350187778473, 0.372763216495514, 0.30224934220314, 0.360771268606186, 0.391581654548645, 0.639579176902771, 0.20879328250885, 0.194305017590523, 0.346162974834442, -0.335798501968384, 0.313326746225357, 0.430781096220016, 0.288269937038422, 0.212326541543007, 0.314853340387344, 0.232047483325005, 0.313362777233124, 0.594823002815247, 0.297076672315598, 0.0874816551804543, 0.687534987926483, 0.34318420290947, 0.267795294523239, -0.251134783029556, 0.517573893070221, 0.322505533695221, 0.233370050787926, 0.303819119930267, 0.0876256823539734, 0.285924822092056, 0.0283140279352665, 0.148046270012856, 0.306075423955917, 0.502283930778503, 0.186436802148819, 0.315285414457321, 0.179461508989334, 0.298315227031708, 0.381483525037766, 0.374265789985657, 0.601445496082306, 0.28673854470253, 0.451428562402725, -0.0453082472085953, -0.0313576459884644, 0.228019759058952, 0.353966385126114, 0.255431294441223, 0.407793343067169, 0.195692405104637, 0.105870433151722, 0.586659550666809, -0.00837228912860155, 0.0980118215084076, 0.246905401349068, 0.192420780658722, 0.702848970890045, 0.315743863582611, 0.297904759645462, 0.00449576135724783, 0.215463742613792, -0.298593699932098, 0.248045548796654, 0.231625035405159, 0.272046238183975, 0.312894701957703, 0.487591594457626, 0.295782893896103, 0.112634502351284, 0.460866570472717, 0.0380568951368332, 0.0210458934307098, -0.00307001569308341, 0.108342744410038, 0.170373931527138, -0.35922309756279, 0.12366871535778, 0.094423346221447, 0.0639922320842743, 0.474171489477158, 0.497641712427139, 0.113618619740009, 0.496688783168793, 0.436431407928467, 0.307287573814392, 0.254600793123245, 0.0574777908623219, 0.0949466228485107, 0.116306968033314, 0.445094138383865, 0.482615768909454, 0.177687674760818, 0.351794123649597, 0.258232444524765, 0.0205154344439507, 0.0187800005078316, 0.475194007158279, 0.211354419589043, 0.235739156603813, 0.281337827444077, 0.158818855881691, 0.0147066805511713, 0.267226427793503, 0.160590276122093, 0.221116468310356, 0.391468822956085, 0.557747840881348, 0.335762441158295, 0.0243871249258518, 0.0821193605661392, 0.0301550757139921, 0.368423461914062, 0.479296147823334, 0.174627289175987, 0.292914539575577, 0.298053592443466, -0.09620201587677, 0.199348077178001, 0.317088037729263, 0.246334120631218, 0.34393310546875, 0.234774231910706, 0.259415805339813, -0.114060305058956, 0.312359422445297, -0.00869393814355135, 0.270476430654526, 0.480184257030487, 0.265222162008286, 0.284820675849915, 0.164999648928642, 0.0972413197159767, 0.177409246563911, -0.16109436750412, 0.123503096401691, 0.156742587685585, -0.180548891425133, 0.151392295956612, 0.113721832633018, 0.37698295712471, 0.235503926873207, 0.0186167862266302, 0.418755531311035, 0.646120011806488, 0.295715689659119, 0.0215835627168417, 0.230847328901291, 0.132329031825066, 0.373922556638718, -0.0427255257964134, 0.363742858171463, 0.26432204246521, 0.172536611557007, 0.0174262318760157, 0.264410853385925, 0.232131496071815, 0.227510899305344, -0.0866007581353188, -0.0203282423317432, 0.0896779447793961, 0.310314357280731, 0.199974551796913, 0.332414001226425, 0.167426362633705, 0.173993602395058, 0.330277740955353, 0.206023335456848, 0.274525761604309, 0.35498172044754, 0.663339853286743, 0.129283040761948, 0.0128608392551541, 0.323028802871704, 0.0732238292694092, 0.356275498867035, 0.235119879245758, 0.218620151281357, 0.237822622060776, 0.500538885593414, 0.409850388765335, 0.572740197181702, 0.093777671456337, -0.104269452393055, 0.316067904233932, -0.0239311065524817, 0.492841094732285, -0.146870136260986, 0.282413184642792, 0.054186973720789, 0.882533669471741, 0.128392532467842, 0.347843199968338, 0.103210881352425, 0.475359618663788, 0.14680290222168, 0.335796058177948, 0.111878395080566, 0.086833581328392, 0.189473196864128, 0.32643723487854, 0.23824268579483, -0.211467251181602, 0.338177144527435, 0.170832395553589, 0.287372201681137, 0.247956737875938, 0.0869319811463356, 0.0117807071655989, 0.668423712253571, 0.164596393704414, 0.287633836269379, 0.681094944477081, 0.482874989509583, 0.43914857506752, 0.263805985450745, 0.368603467941284, 0.0646859183907509, 0.236067995429039, 0.304018348455429, 0.125850602984428, 0.278757512569427, 0.291301518678665, -0.0850213617086411, 0.439220577478409, 0.0774819627404213, 0.143168836832047, -0.0636274218559265, 0.30329105257988, 0.532527804374695, 0.109581299126148, 0.310998439788818, 0.35464808344841, 0.465263932943344, 0.353762358427048, 0.412265092134476, 0.200401812791824, 0.386008113622665, 0.340063810348511, 0.19882720708847, -0.31792339682579, 0.108237132430077, 0.454928189516068, 0.167493566870689, 0.565515279769897, 0.246120497584343, 0.110687844455242, 0.00271952385082841, 0.112344056367874, 0.378931999206543, -0.109410919249058, 0.459510385990143, 0.457470118999481, 0.415042251348495, 0.303876727819443, 0.44095841050148, 0.68238627910614, 0.207465916872025, 0.190198093652725, 0.0673478618264198, 0.195711597800255, 0.244387477636337, 0.160386249423027, 0.11454513669014, 0.531253218650818, 0.35866379737854, 0.169216990470886, 0.545256614685059, 0.0490287020802498, -0.0361342839896679, -0.0215211845934391, 0.244689911603928, 0.272439897060394, 0.325813174247742, 0.32066211104393, 0.0497127883136272, 0.049698393791914, 0.669945538043976, 0.385796904563904, -0.0477757677435875, 0.287124991416931, 0.39463484287262, 0.282494783401489, 0.180937692523003, 0.293435394763947, 0.131949782371521, 0.225924298167229, 0.342089653015137, 0.216301456093788, 0.0710251331329346, 0.276633232831955, 0.69643771648407, 0.408722251653671, 0.340913504362106, -0.116319000720978, 0.233240440487862, 0.00667285127565265, 0.0976733714342117, 0.50915116071701, -0.000316841906169429, -0.191427066922188, 0.292016804218292, 0.370384514331818, 0.0684928148984909, 0.144705027341843, 0.523346602916718, 0.115642085671425, 0.297067046165466, 0.377683848142624, -0.0870160385966301, 0.434539973735809, 0.251602798700333, 0.374481827020645, 0.0167445484548807, 0.114350721240044, 0.145441919565201, 0.4614018201828, 0.0814688876271248, 0.293490588665009, 0.496813595294952, 0.245220378041267, -0.0994808301329613, 0.0311944056302309, -0.05793147534132, -0.0437792614102364, 0.254454374313354, 0.248031139373779, 0.121650062501431, 0.417262554168701, 0.222124606370926, 0.43660905957222, 0.159015670418739, -0.118409678339958, 0.257877200841904, 0.296899050474167, 0.0295837987214327, 0.136675998568535, 0.259699046611786, 0.347207129001617, 0.0544270016252995, 0.134386107325554, 0.226315543055534, 0.20565128326416, 0.295787692070007, -0.0743976160883904, 0.258618921041489, 0.358903825283051, 0.159728571772575, 0.154671117663383, 0.441664099693298, 0.0189600251615047, 0.388550043106079, 0.648081064224243, 0.298550456762314, 0.360941678285599, 0.408705443143845, 0.121083594858646, 0.0642418637871742, 0.275305867195129, 0.474020272493362, 0.399012982845306, 0.313533186912537, 0.234983056783676, -0.194103419780731, 0.560371398925781, 0.21586699783802, 0.213704317808151, 0.446632742881775, 0.0186071861535311, 0.251091539859772, -0.00262595620006323, 0.690175294876099, 0.228149384260178, 0.427658289670944, 0.0180407166481018, 0.0344324260950089, 0.142141506075859, 0.252049267292023, -0.0176975075155497, 0.408633440732956, 0.025481665506959, 0.138711452484131, 0.508097469806671, -0.0393314883112907, 0.381867587566376, -1, 0.522693753242493, 0.653236985206604, 0.261825710535049, 0.195387557148933, 0.239692464470863, 0.117391906678677, 0.301044374704361, 0.297981590032578, -0.0596237033605576, 0.183172389864922, -0.352435022592545, 0.485700160264969, 0.229786396026611, 0.328619122505188, 0.555532395839691, 0.0814832895994186, -0.156740218400955, 0.42263925075531, 0.485354512929916, -0.0441705025732517, 0.104483045637608, 0.250450640916824, 0.474193066358566, 0.254653602838516, 0.50128298997879, -0.123500727117062, 0.447590440511703, 0.325909167528152, 0.0295645985752344, 0.468492358922958, 0.445509403944016, 0.350747585296631 }, 

   { 0.335892707109451, 0.154591053724289, 0.0173692759126425, 0.400452435016632, 0.197175547480583, 0.134612053632736, -0.0684467554092407, 0.130382359027863, -0.186096906661987, 0.189919173717499, 0.338785201311111, 0.156328469514847, 0.163687884807587, 0.114625848829746, 0.0629924461245537, -0.0303363800048828, -0.097807765007019, -0.0133936479687691, 0.251663088798523, 0.380947917699814, 0.225496515631676, 0.285991907119751, 0.272528797388077, 0.29833111166954, 0.0851258412003517, 0.0662899315357208, 0.253227978944778, 0.410057306289673, 0.208666414022446, 0.29752591252327, 0.168116480112076, 0.180841505527496, 0.437275916337967, 0.0881477370858192, -0.0242207087576389, 0.0961829498410225, 0.271440804004669, 0.216205582022667, 0.329614043235779, 0.113818258047104, 0.472402721643448, 0.588166892528534, 0.283966928720474, 0.357791244983673, -0.248034954071045, 0.372148245573044, 0.034331176429987, 0.250388205051422, 0.157112091779709, 0.0681543424725533, 0.200410723686218, 0.312307059764862, 0.101272962987423, 0.311832576990128, 0.224729657173157, 0.293809056282043, 0.113051399588585, 0.0678547918796539, 0.308460801839828, 0.338588684797287, 0.111970610916615, -0.0858879536390305, 0.327390193939209, -0.118095926940441, 0.325602442026138, 0.367604613304138, -0.105112083256245, 0.312307059764862, 0.290981262922287, 0.164512261748314, 0.197868123650551, 0.243618294596672, 0.0320977158844471, -0.059618316590786, 0.301273912191391, 0.231521129608154, 0.454882442951202, 0.279233992099762, 0.258567214012146, 0.206636637449265, 0.180482044816017, 0.125431343913078, 0.103216461837292, 0.126306027173996, 0.253522723913193, 0.266911566257477, 0.333062529563904, 0.256688416004181, 0.0805414766073227, 0.168051779270172, -0.188270479440689, -0.0212946683168411, 0.00534640345722437, 0.223835796117783, 0.208311751484871, -0.0500302202999592, 0.279231578111649, 0.210399031639099, 0.122344739735126, 0.272787600755692, 0.305712103843689, -0.389927357435226, 0.411708444356918, 0.192317992448807, 0.214849203824997, 0.16822911798954, 0.189617216587067, 0.310881197452545, 0.366614907979965, 0.270235419273376, 0.235666960477829, 0.197079703211784, 0.088090218603611, 0.529039859771729, 0.114745669066906, 0.108558103442192, 0.10958856344223, -0.361450612545013, 0.280806034803391, 0.325537741184235, 0.257917761802673, 0.218772143125534, 0.311921238899231, 0.183779522776604, 0.137370333075523, 0.509350836277008, 0.275869399309158, 0.195615485310555, 0.585566818714142, 0.288546502590179, 0.248480647802353, -0.276576399803162, 0.403455138206482, 0.258677452802658, 0.172116115689278, 0.102495141327381, -0.0124398740008473, 0.316843509674072, 0.0606199838221073, 0.133667856454849, 0.18122972548008, 0.385261476039886, 0.101126782596111, 0.318147152662277, -0.0499942675232887, 0.2728570997715, 0.354431450366974, 0.331665396690369, 0.352399289608002, 0.288251727819443, 0.399266183376312, -0.0627336725592613, -0.0904842838644981, 0.122759319841862, 0.219122022390366, 0.18414618074894, 0.343048423528671, 0.276355892419815, 0.123931176960468, 0.462404847145081, -0.0121522983536124, 0.167265757918358, 0.143011525273323, 0.0801676362752914, 0.466886162757874, 0.369596034288406, 0.119332432746887, 0.0319874733686447, 0.11878365278244, -0.300770729780197, 0.0982247069478035, 0.211549326777458, 0.249913707375526, 0.121311880648136, 0.398810893297195, 0.220993638038635, 0.0096048517152667, 0.256686002016068, 0.0917759239673615, -0.0537638515233994, 0.0610177852213383, -0.0176449101418257, 0.0709318071603775, -0.310217440128326, -0.0665631666779518, 0.109629303216934, 0.234178781509399, 0.417917609214783, 0.338416129350662, 0.1604023873806, 0.50294041633606, 0.345952898263931, 0.229064807295799, -0.0343767590820789, 0.0435909740626812, -0.0495820790529251, 0.224861472845078, 0.213861867785454, 0.309970557689667, 0.20849147439003, 0.170944273471832, 0.10335785895586, 0.0551585294306278, 0.00809750892221928, 0.300171583890915, 0.137030050158501, 0.289229482412338, 0.144911885261536, 0.107592336833477, -0.0644543170928955, 0.0751806646585464, -0.0173980724066496, 0.169331476092339, 0.255502164363861, 0.327996462583542, 0.12905952334404, 0.189401552081108, 0.0823867246508598, -0.0680177956819534, 0.244725450873375, 0.270724266767502, -0.0239690840244293, 0.290434896945953, 0.232935026288033, -0.0294425133615732, 0.203988596796989, 0.363063365221024, 0.126164644956589, 0.301036655902863, 0.188891112804413, 0.255346417427063, -0.0121211456134915, 0.256674021482468, 0.258953034877777, 0.257330656051636, 0.329824954271317, 0.230713546276093, 0.196624383330345, 0.127731904387474, 0.113099321722984, 0.12025985121727, -0.103348314762115, 0.136347055435181, 0.148218959569931, -0.220787584781647, 0.203842416405678, 0.15820486843586, 0.366492658853531, 0.239633038640022, -0.0713871642947197, 0.335768073797226, 0.423772037029266, 0.245274230837822, 0.0798441171646118, 0.278455138206482, 0.172669693827629, 0.217504441738129, 0.0356971547007561, 0.264498353004456, 0.25838029384613, 0.26763528585434, 0.0339669249951839, 0.0395386144518852, 0.0731844455003738, 0.110877841711044, -0.0536152720451355, -0.0703015923500061, 0.0166335739195347, -0.0090657090768218, 0.09915691614151, 0.303823709487915, 0.283389389514923, 0.186437159776688, 0.168998375535011, 0.0766113325953484, 0.133202955126762, 0.266336411237717, 0.602015852928162, 0.0580677874386311, -0.108126796782017, 0.0906160473823547, 0.124532677233219, 0.175286591053009, -0.0174148548394442, 0.115287259221077, 0.1916733533144, 0.402779370546341, 0.166431799530983, 0.308098942041397, 0.0320593640208244, -0.0174747612327337, 0.0731628760695457, -0.0527285896241665, 0.269118666648865, -0.083599366247654, 0.131441578269005, 0.0864582508802414, 0.639064610004425, 0.0202210247516632, 0.400843054056168, 0.0596134886145592, 0.384786993265152, 0.0460856594145298, 0.17303155362606, 0.0979874655604362, -0.0690099075436592, 0.0663929730653763, 0.0490356497466564, 0.0948457419872284, 0.0153850400820374, 0.160272985696793, 0.242429673671722, 0.0417097806930542, 0.253479599952698, 0.0600544288754463, -0.0603420324623585, 0.499216347932816, 0.0892836451530457, 0.288110345602036, 0.550847351551056, 0.459095388650894, 0.0602533295750618, 0.198421701788902, 0.107613906264305, 0.0110211484134197, 0.0526830144226551, 0.387339174747467, 0.00740972906351089, 0.294928193092346, 0.0888402983546257, -0.0599250607192516, 0.280839592218399, 0.115330398082733, 0.00435667764395475, -0.110230855643749, 0.250455290079117, 0.309678196907043, -0.0204463377594948, 0.174850448966026, 0.278965592384338, 0.25590717792511, 0.322971165180206, 0.28369614481926, 0.0733306258916855, 0.246194452047348, 0.376670300960541, -0.00815027300268412, -0.181325629353523, 0.118697375059128, 0.480567365884781, 0.345694094896317, 0.387238532304764, 0.108033284544945, 0.0854158028960228, -0.0359152667224407, 0.248703509569168, 0.298580348491669, -0.0297348741441965, 0.213931366801262, 0.131841778755188, 0.20322173833847, 0.262463808059692, 0.362344473600388, 0.529423296451569, 0.0785500481724739, 0.212601348757744, 0.126787722110748, 0.0796739682555199, 0.205352157354355, 0.161332204937935, 0.0120995342731476, 0.381858557462692, 0.0776106417179108, -0.0713799968361855, 0.291395843029022, -0.00793218798935413, 0.0535864755511284, -0.1164376065135, 0.127269402146339, 0.0875102877616882, 0.399009793996811, 0.338277161121368, -0.0408423133194447, -0.00808796752244234, 0.680057942867279, 0.171845331788063, -0.0621345676481724, 0.102679662406445, 0.244334831833839, 0.139297053217888, 0.168413639068604, 0.226241812109947, -0.0180475153028965, 0.134094417095184, 0.211729049682617, 0.19403862953186, -0.0233699772506952, 0.0543461367487907, 0.466890931129456, 0.25713175535202, 0.323095768690109, -0.104719072580338, 0.20482973754406, -0.0442931689321995, -0.0313045382499695, 0.297032237052917, -0.117427326738834, -0.0706658288836479, 0.269770503044128, 0.361563235521317, -0.0180163607001305, 0.193338871002197, 0.246177673339844, -0.0310984496027231, 0.0904483050107956, 0.203099519014359, -0.0368594564497471, 0.249460786581039, 0.0718256682157516, 0.348866939544678, -0.0563352108001709, -0.0174891464412212, 0.0612670183181763, 0.30396032333374, 0.0142707023769617, 0.273161441087723, 0.316256374120712, 0.286109328269958, 0.0282634273171425, -0.0134463692083955, -0.0567402131855488, -0.078744187951088, 0.0444369204342365, 0.112255781888962, -0.0359991416335106, 0.355442762374878, -0.0191906057298183, 0.229021668434143, 5.50926743017044e-05, -0.0647275075316429, 0.0368282608687878, 0.299431055784225, -0.0214384496212006, 0.102816261351109, 0.188210517168045, 0.326623320579529, 0.0626377686858177, 0.00850489735603333, 0.00562917999923229, 0.131674021482468, 0.198457643389702, 0.0402934998273849, 0.0829283148050308, 0.194839045405388, 0.019329559057951, 0.17226231098175, 0.481710463762283, -0.0665415972471237, 0.311576157808304, 0.582710266113281, 0.26276096701622, 0.127130404114723, 0.265936225652695, -0.0428097806870937, 0.0945485904812813, 0.166532441973686, 0.461784154176712, 0.312841475009918, 0.17981344461441, 0.145875245332718, -0.258727788925171, 0.339789301156998, 0.0908868536353111, 0.213435307145119, 0.350666671991348, 0.0781354680657387, 0.124961636960506, -0.0676846876740456, 0.491763472557068, 0.158919006586075, 0.345588654279709, -0.0558942668139935, -0.0373818725347519, -0.00484559871256351, 0.0607685633003712, -0.00058715051272884, 0.269535660743713, -0.0342497453093529, 0.0680728703737259, 0.403690010309219, -0.00306026451289654, 0.260268658399582, -1, 0.456250816583633, 0.495842188596725, 0.108306474983692, 0.0864918082952499, 0.118081495165825, 0.112459480762482, 0.291762501001358, 0.212769106030464, -0.01650420576334, 0.012408678419888, -0.182602912187576, 0.264239549636841, 0.110101394355297, 0.0298929959535599, 0.379689812660217, 0.0429415479302406, 0.0312973111867905, 0.325767785310745, 0.253951698541641, -0.0157804880291224, 0.0391767621040344, -0.0346595346927643, 0.267637670040131, 0.277774572372437, 0.23397508263588, -0.17906342446804, 0.385335773229599, 0.213035106658936, 0.125117406249046, 0.296354055404663, 0.270089238882065, 0.169362634420395 }
};
   inline double ReadSVM_Gauss::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!fStatusIsClean) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            retval = GetMvaValue__( iV );
         }
         else {
            retval = GetMvaValue__( inputValues );
         }
      }

      return retval;
   }
