// Class: ReadBDT
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : BDT::BDT
TMVA Release   : 3.8.13        [198669]
ROOT Release   : 5.19/02       [332546]
Creator        : heponx
Date           : Fri Mar 28 00:39:56 2008
Host           : Darwin jlctpcmac.kek.jp 9.2.0 Darwin Kernel Version 9.2.0: Tue Feb 5 16:15:19 PST 2008; root:xnu-1228.3.13~1/RELEASE_PPC Power Macintosh
Dir            : /Users/root/root_v5.19.02-macosx10.5-ppc/test
Training events: 1000


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
V: "False" [Verbose mode]
H: "False" [Print classifier-specific help message]
NTrees: "400" [Number of trees in the forest]
BoostType: "AdaBoost" [Boosting type for the trees in the forest]
SeparationType: "giniindex" [Separation criterion for node splitting]
nCuts: "20" [Number of steps during node cut optimisation]
PruneStrength: "4.5" [Pruning strength (negative value == automatic adjustment)]
PruneMethod: "costcomplexity" [Pruning method: NoPruning (switched off), ExpectedError or CostComplexity]
# Default:
D: "False" [use-decorrelated-variables flag (depreciated)]
Normalise: "False" [Normalise input variables]
VarTransform: "None" [Variable transformation method]
VarTransformType: "Signal" [Use signal or background events for var transform]
NbinsMVAPdf: "60" [Number of bins used to create MVA PDF]
NsmoothMVAPdf: "2" [Number of smoothing iterations for MVA PDF]
VerboseLevel: "Info" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs]
TxtWeightFilesOnly: "True" [if True, write all weights as text files]
UseYesNoLeaf: "True" [Use Sig or Bkg node type or the ratio S/B as classification in the leaf node]
UseWeightedTrees: "True" [Use weighted trees or simple average in classification from the forest]
nEventsMin: "20" [Minimum number of events in a leaf node (default: max(20, N_train/(Nvar^2)/10) ) ]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 4
var1+var2                     var1_P_var2                       'F'    [-6.05220985413,4.87306022644]
var1-var2                     var1_M_var2                       'F'    [-3.84853005409,3.82592988014]
var3                          var3                              'F'    [-5.18697977066,3.14527988434]
var4                          var4                              'F'    [-4.88857984543,3.45718002319]


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#define NN new ReadBDT_DecisionTreeNode
class ReadBDT_DecisionTreeNode{
   
public:
   
   // constructor of an essentially "empty" node floating in space
   ReadBDT_DecisionTreeNode ( 
                      ReadBDT_DecisionTreeNode* left,
                      ReadBDT_DecisionTreeNode* right,
                      double cutValue, bool cutType, int selector,
                      int nodeType, double purity):
   fLeft(left),
   fRight(right),
   fCutValue(cutValue),
   fCutType(cutType),
   fSelector(selector),
   fNodeType(nodeType),
   fPurity(purity) {}
   virtual ~ReadBDT_DecisionTreeNode();  
   // test event if it decends the tree at this node to the right
   virtual bool GoesRight( const std::vector<double>& inputValues ) const;
   ReadBDT_DecisionTreeNode* GetRight( void ) {return fRight; };
   // test event if it decends the tree at this node to the left 
   virtual bool GoesLeft ( const std::vector<double>& inputValues ) const;
   ReadBDT_DecisionTreeNode* GetLeft( void ) {return fLeft; };   
   //return  S/(S+B) (purity) at this node (from  training)
   double GetPurity( void ) const {return fPurity;} 
   //return the node type
   int    GetNodeType( void ) const {return fNodeType;}
private:
   ReadBDT_DecisionTreeNode*   fLeft;    // pointer to the left daughter node
   ReadBDT_DecisionTreeNode*   fRight;   // pointer to the right daughter node
   double              fCutValue;// cut value appplied on this node to discriminate bkg against sig
   bool                fCutType; // true: if event variable > cutValue ==> signal , false otherwise
   int                 fSelector;// index of variable used in node selection (decision tree)   
   int                 fNodeType;// Type of node: -1 == Bkg-leaf, 1 == Signal-leaf, 0 = internal 
   double              fPurity;  // Purity of node from training
}; 
//_______________________________________________________________________
  ReadBDT_DecisionTreeNode::~ReadBDT_DecisionTreeNode(){   
   if (fLeft != NULL) delete fLeft;
   if (fRight != NULL) delete fRight;
}; 
//_______________________________________________________________________
bool ReadBDT_DecisionTreeNode::GoesRight(const  std::vector<double>& inputValues) const{
   // test event if it decends the tree at this node to the right
   bool result = (inputValues[fSelector] > fCutValue );
   if (fCutType == true) return result; //the cuts are selecting Signal ;
   else return !result;
}
//_______________________________________________________________________
bool ReadBDT_DecisionTreeNode::GoesLeft(const  std::vector<double>& inputValues) const{
   // test event if it decends the tree at this node to the left
   if (!this->GoesRight(inputValues)) return true;
   else return false;
}
#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;
};

#endif

class ReadBDT : public IClassifierReader {

 public:

   // constructor
   ReadBDT( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "ReadBDT" ),
        fStatusIsClean( true ),
        fNvars( 4 ),
        fIsNormalised( false )
   {      
      // the training input variables
      const char* inputVars[] = { "var1+var2", "var1-var2", "var3", "var4" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -6.05220985412598;
      fVmax[0] = 4.87306022644043;
      fVmin[1] = -3.84853005409241;
      fVmax[1] = 3.82592988014221;
      fVmin[2] = -5.1869797706604;
      fVmax[2] = 3.14527988433838;
      fVmin[3] = -4.88857984542847;
      fVmax[3] = 3.45718002319336;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';

      // initialize constants
      Initialize();

   }

   // destructor
   virtual ~ReadBDT() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // common member variables
   const char* fClassName;
   bool fStatusIsClean;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[4];
   double fVmax[4];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[4];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)
   std::vector<ReadBDT_DecisionTreeNode*> fForest;       // i.e. root nodes of decision trees
   std::vector<double>            fBoostWeights; // the weights applied in the individual boosts
};
double ReadBDT::GetMvaValue__( const std::vector<double>& inputValues ) const{
   double myMVA = 0;
   double norm  = 0;
for (unsigned int itree=0; itree<fForest.size(); itree++){
      ReadBDT_DecisionTreeNode *current = fForest[itree];
      while (current->GetNodeType() == 0){ //intermediate node
         if (current->GoesRight(inputValues)) current=(ReadBDT_DecisionTreeNode*)current->GetRight();
         else current=(ReadBDT_DecisionTreeNode*)current->GetLeft();
      }
      myMVA += fBoostWeights[itree] *  current->GetNodeType();
      norm  += fBoostWeights[itree];
   }
   return myMVA /= norm;
};
void ReadBDT::Initialize(){
 
  // itree = 0
  fBoostWeights.push_back(1.46962249269322);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.05827, 1, -1, -1, 0.127717) , 
NN(
NN(
0, 
0, 
-0.311943, 1, -1, 1, 0.596059) , 
NN(
0, 
0, 
1.63357, 0, -1, 1, 0.933628) , 
0.98653, 1, 3, 0, 0.716772) , 
-0.507056, 1, 3, 0, 0.5)    );
  // itree = 1
  fBoostWeights.push_back(0.985643);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.22173, 0, -1, -1, 0.186212) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.130372) , 
NN(
NN(
NN(
0, 
0, 
-1.064, 0, -1, -1, 0.37667) , 
NN(
NN(
0, 
0, 
0.236073, 0, -1, -1, 0.481184) , 
NN(
0, 
0, 
0.424419, 1, -1, 1, 0.691342) , 
0.175754, 1, 3, 0, 0.531533) , 
0.384173, 0, 2, 0, 0.485701) , 
NN(
0, 
0, 
1.18131, 0, -1, 1, 0.64582) , 
0.969027, 1, 3, 0, 0.501892) , 
-1.13472, 1, 3, 0, 0.490888) , 
NN(
0, 
0, 
-2.02894, 1, -1, 1, 0.682992) , 
-1.84672, 0, 0, 0, 0.509239) , 
NN(
0, 
0, 
1.56515, 0, -1, 1, 0.847529) , 
1.4178, 1, 3, 0, 0.550116) , 
-1.34163, 1, 3, 0, 0.503088)    );
  // itree = 2
  fBoostWeights.push_back(0.875364);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.67619, 1, -1, -1, 0.275281) , 
NN(
NN(
0, 
0, 
-2.45145, 1, -1, -1, 0.403452) , 
NN(
0, 
0, 
0.367629, 0, -1, 1, 0.545941) , 
-0.244935, 1, 3, 0, 0.466638) , 
-1.35433, 1, 1, 0, 0.445039) , 
NN(
0, 
0, 
-0.86317, 0, -1, 1, 0.716097) , 
0.744808, 1, 3, 0, 0.504248)    );
  // itree = 3
  fBoostWeights.push_back(0.858909);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.0995898, 1, -1, -1, 0.332043) , 
NN(
NN(
0, 
0, 
0.948007, 0, -1, 1, 0.553693) , 
NN(
0, 
0, 
1.56515, 0, -1, 1, 0.742232) , 
1.37597, 1, 3, 0, 0.572107) , 
-0.924344, 1, 3, 0, 0.525855)    );
  // itree = 4
  fBoostWeights.push_back(0.813345);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-2.42432, 1, -1, -1, 0.323419) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.190405) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.445385, 1, -1, -1, 0.357932) , 
NN(
0, 
0, 
0.383353, 0, -1, 1, 0.528577) , 
0.0854725, 1, 3, 0, 0.456555) , 
NN(
0, 
0, 
-1.5629, 1, -1, 1, 0.556403) , 
-0.512545, 0, 0, 0, 0.492527) , 
NN(
0, 
0, 
0.342047, 1, -1, 1, 0.833345) , 
1.0017, 1, 3, 0, 0.505845) , 
2.4335, 0, 0, 0, 0.489923) , 
-0.945259, 1, 3, 0, 0.457033) , 
NN(
0, 
0, 
1.69539, 0, -1, 1, 0.757355) , 
1.27052, 1, 2, 0, 0.488471)    );
  // itree = 5
  fBoostWeights.push_back(0.825581);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.16162, 1, -1, -1, 0.304503) , 
NN(
NN(
NN(
0, 
0, 
0.581471, 1, -1, -1, 0.399598) , 
NN(
0, 
0, 
1.17087, 0, -1, 1, 0.534611) , 
-0.407229, 1, 3, 0, 0.505447) , 
NN(
0, 
0, 
3.13446, 0, -1, 1, 0.763586) , 
1.37597, 1, 3, 0, 0.524719) , 
-0.924344, 1, 3, 0, 0.484996)    );
  // itree = 6
  fBoostWeights.push_back(0.7673);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.98069, 1, -1, -1, 0.256419) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.292304) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.295938) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.521501, 1, -1, -1, 0.386526) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.124264) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.492412) , 
-0.336542, 1, 3, 0, 0.39151) , 
NN(
0, 
0, 
0.30224, 0, -1, 1, 0.564088) , 
-0.0961593, 1, 0, 0, 0.493917) , 
0.390405, 0, 3, 0, 0.448111) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.395511) , 
NN(
0, 
0, 
-0.488847, 1, -1, 1, 0.654342) , 
-0.0275903, 1, 3, 0, 0.580984) , 
-0.255019, 0, 1, 0, 0.480041) , 
NN(
0, 
0, 
-1.23305, 1, -1, 1, 0.582008) , 
-0.568186, 0, 2, 0, 0.508505) , 
-2.04208, 1, 0, 0, 0.4932) , 
2.23704, 0, 0, 0, 0.478977) , 
NN(
0, 
0, 
0.669734, 1, -1, 1, 0.618217) , 
-0.970608, 0, 1, 0, 0.504941) , 
NN(
0, 
0, 
1.26212, 0, -1, 1, 0.752315) , 
1.4178, 1, 3, 0, 0.519246) , 
-1.34163, 1, 3, 0, 0.497049)    );
  // itree = 7
  fBoostWeights.push_back(0.781492);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.0146, 1, -1, -1, 0.377633) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.341074) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.210618) , 
NN(
0, 
0, 
-0.0220803, 1, -1, -1, 0.478863) , 
-0.627945, 1, 3, 0, 0.463594) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.683639) , 
1.52175, 1, 1, 0, 0.485497) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.670019) , 
1.86244, 1, 0, 0, 0.507662) , 
NN(
0, 
0, 
0.587526, 1, -1, 1, 0.63719) , 
-1.21903, 0, 1, 0, 0.526585) , 
2.39112, 0, 0, 0, 0.513104) , 
NN(
NN(
0, 
0, 
-0.514587, 0, -1, -1, 0.481588) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.506341) , 
NN(
0, 
0, 
-0.975778, 0, -1, 1, 0.69809) , 
-0.432139, 1, 3, 0, 0.668104) , 
-0.425074, 1, 2, 0, 0.592762) , 
-0.419723, 0, 0, 0, 0.540228) , 
NN(
0, 
0, 
3.13446, 0, -1, 1, 0.726237) , 
1.37597, 1, 3, 0, 0.551581) , 
-0.924344, 1, 3, 0, 0.523308)    );
  // itree = 8
  fBoostWeights.push_back(0.847095);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.320584, 0, -1, -1, 0.310491) , 
NN(
NN(
0, 
0, 
-1.63035, 0, -1, -1, 0.345964) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.496618, 0, -1, -1, 0.363947) , 
NN(
0, 
0, 
-0.382052, 0, -1, -1, 0.491607) , 
-0.462328, 1, 3, 0, 0.47419) , 
NN(
0, 
0, 
2.08973, 0, 0, 1, 1) , 
2.17049, 1, 3, 0, 0.478947) , 
NN(
0, 
0, 
-0.0497113, 1, -1, 1, 0.642443) , 
-0.83009, 0, 2, 0, 0.501431) , 
-1.23157, 1, 3, 0, 0.489981) , 
1.71545, 0, 1, 0, 0.474676)    );
  // itree = 9
  fBoostWeights.push_back(0.761349);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.33166, 1, -1, -1, 0.36906) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.563287) , 
0.186597, 1, 3, 0, 0.385413) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.224326) , 
NN(
NN(
0, 
0, 
1.16166, 1, -1, -1, 0.351845) , 
NN(
0, 
0, 
-0.43138, 0, -1, -1, 0.487887) , 
-0.888007, 1, 3, 0, 0.480093) , 
-1.67215, 1, 1, 0, 0.466311) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.725779) , 
-2.12178, 0, 1, 0, 0.473199) , 
NN(
0, 
0, 
2.08973, 0, 0, 1, 1) , 
2.15139, 1, 3, 0, 0.477213) , 
-0.862707, 1, 0, 0, 0.449795)    );
  // itree = 10
  fBoostWeights.push_back(0.670391);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.196267) , 
NN(
NN(
NN(
0, 
0, 
-0.914877, 0, -1, -1, 0.235514) , 
NN(
0, 
0, 
-0.715813, 1, -1, -1, 0.455419) , 
-0.717001, 1, 2, 0, 0.386034) , 
NN(
0, 
0, 
-1.97973, 0, -1, 1, 0.53111) , 
-1.22531, 0, 2, 0, 0.425959) , 
1.83153, 0, 1, 0, 0.393315) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.502769, 0, -1, -1, 0.191743) , 
NN(
0, 
0, 
-0.50694, 0, -1, -1, 0.472516) , 
-0.809606, 1, 3, 0, 0.439438) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.596783) , 
1.33173, 1, 1, 0, 0.462632) , 
NN(
NN(
NN(
0, 
0, 
1.71787, 0, -1, 1, 0.502036) , 
NN(
0, 
0, 
1.56515, 0, -1, 1, 0.696233) , 
1.37181, 1, 3, 0, 0.525332) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.763473) , 
-0.43138, 0, 0, 0, 0.548272) , 
0.12015, 1, 3, 0, 0.512507) , 
-0.862707, 1, 0, 0, 0.476976)    );
  // itree = 11
  fBoostWeights.push_back(0.780731);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.50711, 1, -1, -1, 0.314644) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.26675, 0, -1, -1, 0.25083) , 
NN(
0, 
0, 
0.847317, 0, -1, 1, 0.578504) , 
-0.070832, 1, 3, 0, 0.385997) , 
NN(
NN(
0, 
0, 
-2.17038, 1, -1, -1, 0.326272) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.279048) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.236302) , 
NN(
0, 
0, 
0.278138, 0, -1, -1, 0.481949) , 
-0.370697, 1, 3, 0, 0.463867) , 
NN(
0, 
0, 
-0.885022, 1, -1, 1, 0.646374) , 
-0.496299, 0, 0, 0, 0.497412) , 
-1.28214, 1, 0, 0, 0.478999) , 
NN(
0, 
0, 
-0.414702, 0, -1, 1, 0.625763) , 
-1.80339, 0, 0, 0, 0.495052) , 
-1.15916, 1, 3, 0, 0.485499) , 
0.386888, 0, 1, 0, 0.469413) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.283864) , 
NN(
NN(
0, 
0, 
1.29459, 1, -1, -1, 0.474346) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.81062) , 
0.409824, 1, 3, 0, 0.535802) , 
1.48728, 0, 0, 0, 0.482047) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.736337) , 
-1.16107, 0, 0, 0, 0.531302) , 
0.732794, 1, 1, 0, 0.482652) , 
-2.48686, 1, 3, 0, 0.480854) , 
NN(
0, 
0, 
2.33705, 0, 0, 1, 1) , 
2.24158, 1, 3, 0, 0.482152) , 
1.71545, 0, 1, 0, 0.467413)    );
  // itree = 12
  fBoostWeights.push_back(0.79207);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.483897, 0, -1, -1, 0.399135) , 
NN(
0, 
0, 
0.109447, 1, -1, 1, 0.653757) , 
0.938995, 1, 3, 0, 0.434392) , 
NN(
NN(
0, 
0, 
1.55809, 1, -1, -1, 0.448195) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.134987) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.400028) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.319222) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.589011) , 
-0.158615, 1, 3, 0, 0.488658) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.761438) , 
-1.95739, 0, 0, 0, 0.545021) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.758759) , 
0.696919, 1, 0, 0, 0.591785) , 
1.43084, 0, 0, 0, 0.547676) , 
0.562386, 0, 1, 0, 0.512938) , 
NN(
NN(
0, 
0, 
1.08607, 0, -1, 1, 0.573951) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
0.87987, 1, 2, 0, 0.603718) , 
0.624429, 1, 1, 0, 0.557694) , 
1.36636, 0, 1, 0, 0.52437) , 
0.180561, 1, 1, 0, 0.479479)    );
  // itree = 13
  fBoostWeights.push_back(0.802365);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.255959) , 
NN(
NN(
NN(
0, 
0, 
-0.034085, 1, -1, -1, 0.195881) , 
NN(
NN(
NN(
0, 
0, 
0.702631, 1, -1, -1, 0.376894) , 
NN(
NN(
0, 
0, 
-0.508191, 0, -1, -1, 0.360219) , 
NN(
NN(
0, 
0, 
-0.609971, 0, -1, -1, 0.455393) , 
NN(
0, 
0, 
-0.242931, 1, -1, 1, 0.663373) , 
-0.411854, 1, 3, 0, 0.51965) , 
0.0901787, 0, 2, 0, 0.475683) , 
-0.08419, 0, 0, 0, 0.431655) , 
NN(
0, 
0, 
-1.20395, 1, -1, 1, 0.521131) , 
0.576801, 1, 3, 0, 0.447899) , 
-1.31001, 1, 3, 0, 0.434093) , 
NN(
NN(
0, 
0, 
-1.80811, 1, -1, -1, 0.441016) , 
NN(
NN(
NN(
0, 
0, 
-1.26675, 0, -1, -1, 0.373444) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.667932) , 
-0.0503071, 1, 3, 0, 0.452386) , 
NN(
0, 
0, 
-0.883491, 0, -1, 1, 0.682208) , 
0.777773, 1, 1, 0, 0.568418) , 
1.15325, 0, 1, 0, 0.498012) , 
0.436899, 1, 1, 0, 0.458621) , 
2.42756, 0, 0, 0, 0.450149) , 
NN(
0, 
0, 
0.837822, 0, -1, 1, 0.580122) , 
1.27052, 1, 2, 0, 0.46031)    );
  // itree = 14
  fBoostWeights.push_back(0.868452);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.12131, 0, -1, -1, 0.39667) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.376325) , 
NN(
NN(
0, 
0, 
0.538916, 1, -1, -1, 0.461101) , 
NN(
NN(
NN(
0, 
0, 
-0.316844, 1, -1, -1, 0.424928) , 
NN(
NN(
0, 
0, 
0.0273095, 1, -1, -1, 0.440243) , 
NN(
NN(
0, 
0, 
-0.214094, 0, -1, 1, 0.547119) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.889115) , 
-0.160604, 1, 3, 0, 0.692177) , 
-0.152691, 0, 2, 0, 0.563757) , 
0.111169, 1, 1, 0, 0.516674) , 
NN(
0, 
0, 
0.516627, 0, -1, 1, 0.682457) , 
0.35558, 1, 2, 0, 0.551305) , 
0.680079, 0, 2, 0, 0.52419) , 
-1.64328, 1, 0, 0, 0.515295) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.93796, 1, 2, 0, 0.519561) , 
NN(
0, 
0, 
-1.19392, 1, -1, 1, 0.600959) , 
-0.970608, 0, 1, 0, 0.536385) , 
-0.924344, 1, 3, 0, 0.516097)    );
  // itree = 15
  fBoostWeights.push_back(0.911526);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-2.16162, 1, -1, -1, 0.419146) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.365886) , 
NN(
NN(
NN(
0, 
0, 
0.698258, 1, -1, -1, 0.437522) , 
NN(
NN(
0, 
0, 
-0.62698, 0, -1, -1, 0.452472) , 
NN(
NN(
NN(
0, 
0, 
0.24027, 1, -1, -1, 0.464386) , 
NN(
0, 
0, 
0.606517, 0, -1, 1, 0.690729) , 
0.192141, 1, 3, 0, 0.561948) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.826868) , 
-0.169043, 0, 2, 0, 0.606601) , 
-0.314931, 1, 2, 0, 0.556467) , 
0.509408, 0, 2, 0, 0.519215) , 
NN(
0, 
0, 
1.65607, 0, -1, 1, 0.672173) , 
1.33811, 1, 2, 0, 0.528373) , 
-1.54537, 1, 0, 0, 0.518855) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.648204) , 
-1.91104, 0, 0, 0, 0.526561) , 
-0.924344, 1, 3, 0, 0.511012) , 
NN(
0, 
0, 
1.55303, 0, -1, 1, 0.781496) , 
2.96114, 1, 0, 0, 0.522662)    );
  // itree = 16
  fBoostWeights.push_back(0.777626);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-2.24287, 0, -1, -1, 0.27809) , 
NN(
NN(
NN(
0, 
0, 
-0.214882, 0, -1, -1, 0.353902) , 
NN(
0, 
0, 
-0.530772, 1, -1, 1, 0.519587) , 
-0.446848, 1, 3, 0, 0.431099) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.625407) , 
-1.15068, 0, 2, 0, 0.458637) , 
-1.17526, 1, 3, 0, 0.429914) , 
NN(
NN(
NN(
0, 
0, 
-0.358042, 0, -1, 1, 0.518125) , 
NN(
0, 
0, 
2.11477, 0, -1, 1, 0.614264) , 
0.899532, 1, 3, 0, 0.537732) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.875717) , 
-2.14924, 0, 1, 0, 0.54944) , 
-0.0897679, 1, 3, 0, 0.49701)    );
  // itree = 17
  fBoostWeights.push_back(0.750895);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.31643, 1, -1, -1, 0.391739) , 
NN(
0, 
0, 
-0.802461, 0, -1, 1, 0.53689) , 
-0.507056, 1, 3, 0, 0.499342)    );
  // itree = 18
  fBoostWeights.push_back(0.875399);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.279186) , 
NN(
NN(
0, 
0, 
-0.757618, 0, -1, -1, 0.306157) , 
NN(
NN(
0, 
0, 
-1.19909, 0, -1, -1, 0.448261) , 
NN(
0, 
0, 
-0.931875, 1, -1, 1, 0.587534) , 
-0.514317, 1, 3, 0, 0.495988) , 
-1.18472, 1, 1, 0, 0.462895) , 
0.343582, 0, 0, 0, 0.435921) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.123946) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.718046) , 
-0.240417, 1, 3, 0, 0.566934) , 
0.897595, 1, 0, 0, 0.452363) , 
NN(
0, 
0, 
-0.093869, 0, -1, 1, 0.534333) , 
0.0206825, 1, 2, 0, 0.494746)    );
  // itree = 19
  fBoostWeights.push_back(0.848126);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.724195, 1, -1, -1, 0.318774) , 
NN(
0, 
0, 
1.4513, 1, -1, -1, 0.499196) , 
-0.929342, 0, 2, 0, 0.386368) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.341289) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.716604) , 
-0.616179, 1, 3, 0, 0.584423) , 
-1.01534, 0, 1, 0, 0.429266) , 
NN(
NN(
0, 
0, 
-0.441714, 0, -1, -1, 0.402891) , 
NN(
NN(
NN(
0, 
0, 
0.673479, 1, -1, -1, 0.370423) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.104873) , 
NN(
0, 
0, 
0.499434, 0, -1, 1, 0.505327) , 
-0.331032, 1, 3, 0, 0.447486) , 
NN(
NN(
0, 
0, 
-0.158822, 1, -1, -1, 0.379651) , 
NN(
NN(
NN(
0, 
0, 
0.550288, 1, -1, -1, 0.461109) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.85998) , 
0.48633, 1, 3, 0, 0.52107) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.776686) , 
0.199877, 0, 0, 0, 0.601005) , 
0.983086, 0, 2, 0, 0.577526) , 
-0.127321, 1, 0, 0, 0.522595) , 
NN(
NN(
0, 
0, 
-1.24324, 0, -1, -1, 0.492386) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.763951) , 
-0.651831, 1, 3, 0, 0.628667) , 
-0.745419, 0, 2, 0, 0.543807) , 
0.877862, 0, 0, 0, 0.511667) , 
NN(
0, 
0, 
1.56439, 0, -1, 1, 0.754136) , 
1.38294, 1, 0, 0, 0.532806) , 
1.86243, 0, 0, 0, 0.512952) , 
-0.862707, 1, 0, 0, 0.489665)    );
  // itree = 20
  fBoostWeights.push_back(0.792196);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
0.629727, 0, -1, -1, 0.404778) , 
-0.639591, 1, 3, 0, 0.387354) , 
NN(
NN(
0, 
0, 
-0.443301, 0, -1, -1, 0.392574) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.359604) , 
NN(
NN(
0, 
0, 
-1.59313, 0, -1, -1, 0.207102) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.349096) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.437148) , 
NN(
NN(
0, 
0, 
0.211196, 0, -1, 1, 0.550026) , 
NN(
0, 
0, 
0.412044, 0, -1, 1, 0.744821) , 
-0.115882, 1, 3, 0, 0.642991) , 
1.25042, 0, 1, 0, 0.598046) , 
-0.27364, 0, 0, 0, 0.551945) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.72843) , 
-0.0274425, 1, 0, 0, 0.578162) , 
-1.0628, 1, 3, 0, 0.559849) , 
0.16836, 0, 0, 0, 0.526207) , 
-1.38198, 1, 0, 0, 0.481408) , 
0.390969, 0, 0, 0, 0.452208) , 
NN(
0, 
0, 
-0.86317, 0, -1, 1, 0.555614) , 
0.744808, 1, 3, 0, 0.468526)    );
  // itree = 21
  fBoostWeights.push_back(0.733458);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.443301, 0, -1, -1, 0.445335) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.328289, 0, -1, -1, 0.36494) , 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.151408) , 
NN(
0, 
0, 
-0.299657, 0, -1, -1, 0.424888) , 
-0.28059, 1, 3, 0, 0.378335) , 
NN(
0, 
0, 
0.618367, 0, -1, 1, 0.512186) , 
0.26163, 1, 1, 0, 0.437689) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.743176) , 
0.725611, 1, 3, 0, 0.456023) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.626692) , 
1.41313, 1, 1, 0, 0.485033) , 
NN(
0, 
0, 
1.59473, 0, -1, 1, 0.593183) , 
0.590802, 1, 2, 0, 0.515948) , 
2.42739, 0, 0, 0, 0.500542) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.89607, 1, 2, 0, 0.504827) , 
NN(
0, 
0, 
0.894993, 0, -1, 1, 0.662395) , 
-1.55501, 0, 1, 0, 0.51635) , 
NN(
NN(
0, 
0, 
-0.626424, 0, -1, -1, 0.470559) , 
NN(
0, 
0, 
-0.494476, 0, -1, 1, 0.649176) , 
-0.579972, 1, 3, 0, 0.604825) , 
-0.299574, 0, 0, 0, 0.543756) , 
-1.40897, 1, 0, 0, 0.525445)    );
  // itree = 22
  fBoostWeights.push_back(0.839805);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.666165, 1, -1, -1, 0.376208) , 
NN(
NN(
0, 
0, 
1.29982, 1, -1, -1, 0.399858) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
NN(
0, 
0, 
-0.379372, 0, -1, -1, 0.369278) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.57235) , 
-0.034151, 1, 3, 0, 0.426096) , 
-1.42985, 1, 2, 0, 0.388377) , 
NN(
0, 
0, 
-1.72056, 0, -1, 1, 0.57652) , 
-1.03578, 0, 1, 0, 0.477907) , 
NN(
NN(
0, 
0, 
-0.782475, 0, -1, -1, 0.480212) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.400468) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.754095) , 
-0.738883, 1, 3, 0, 0.664188) , 
0.274451, 0, 1, 0, 0.592947) , 
-0.210717, 1, 1, 0, 0.517911) , 
0.564284, 0, 1, 0, 0.474105) , 
0.164034, 0, 2, 0, 0.448132) , 
NN(
0, 
0, 
0.0498626, 1, -1, 1, 0.543519) , 
0.59894, 1, 2, 0, 0.461285) , 
NN(
0, 
0, 
0.566484, 1, -1, 1, 0.640496) , 
0.744808, 1, 3, 0, 0.489038)    );
  // itree = 23
  fBoostWeights.push_back(0.831456);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.219774) , 
NN(
NN(
0, 
0, 
-0.191309, 0, -1, -1, 0.45247) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.32112, 1, 3, 0, 0.466226) , 
-0.362997, 1, 2, 0, 0.429761) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.330869) , 
NN(
NN(
NN(
0, 
0, 
-0.403094, 1, -1, -1, 0.359204) , 
NN(
NN(
NN(
0, 
0, 
-2.06679, 1, -1, -1, 0.407126) , 
NN(
0, 
0, 
0.306569, 0, -1, 1, 0.577227) , 
-0.777011, 1, 3, 0, 0.48488) , 
NN(
0, 
0, 
-0.71058, 0, -1, 1, 0.715455) , 
-0.812887, 1, 0, 0, 0.52506) , 
-0.50345, 0, 0, 0, 0.470048) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.70183) , 
0.246771, 1, 2, 0, 0.493655) , 
0.598016, 0, 2, 0, 0.478448) , 
NN(
0, 
0, 
0.84695, 0, -1, 1, 0.657828) , 
0.560162, 1, 3, 0, 0.497914) , 
NN(
0, 
0, 
-1.17426, 1, -1, 1, 0.775954) , 
1.75758, 1, 1, 0, 0.527073) , 
0.371859, 0, 0, 0, 0.492211) , 
NN(
0, 
0, 
3.22907, 0, -1, 1, 0.647435) , 
1.1988, 1, 2, 0, 0.50228) , 
NN(
NN(
0, 
0, 
-2.19587, 0, -1, -1, 0.478582) , 
NN(
0, 
0, 
-0.568428, 1, -1, 1, 0.691214) , 
0.325305, 0, 2, 0, 0.60935) , 
-1.35433, 0, 1, 0, 0.51628)    );
  // itree = 24
  fBoostWeights.push_back(0.735073);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.659467, 1, -1, -1, 0.2571) , 
NN(
NN(
0, 
0, 
-0.815367, 0, -1, -1, 0.385591) , 
NN(
0, 
0, 
0.442639, 1, -1, 1, 0.50695) , 
-0.1552, 1, 2, 0, 0.450188) , 
0.704314, 0, 0, 0, 0.426402) , 
NN(
0, 
0, 
1.88497, 0, -1, 1, 0.559954) , 
1.16141, 1, 0, 0, 0.446083) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.20584) , 
NN(
NN(
0, 
0, 
0.250416, 0, -1, 1, 0.500994) , 
NN(
0, 
0, 
0.359257, 0, -1, 1, 0.592814) , 
0.178566, 1, 3, 0, 0.532697) , 
2.36941, 0, 0, 0, 0.524637) , 
-2.37647, 1, 3, 0, 0.522288) , 
0.180561, 1, 1, 0, 0.483849) , 
NN(
0, 
0, 
1.55303, 0, -1, 1, 0.705025) , 
2.96114, 1, 0, 0, 0.492438)    );
  // itree = 25
  fBoostWeights.push_back(0.769444);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.240544, 0, -1, -1, 0.401506) , 
NN(
0, 
0, 
0.0679897, 1, -1, 1, 0.522412) , 
-0.456553, 1, 3, 0, 0.454938) , 
NN(
0, 
0, 
0.422896, 1, -1, 1, 0.540438) , 
-0.0897679, 1, 3, 0, 0.502486)    );
  // itree = 26
  fBoostWeights.push_back(0.72199);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.267818) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.915201, 0, -1, -1, 0.283671) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.504997) , 
-0.269162, 1, 3, 0, 0.381883) , 
NN(
0, 
0, 
-3.07805, 1, -1, 1, 0.501474) , 
-0.929342, 0, 2, 0, 0.421529) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.244425) , 
NN(
0, 
0, 
-1.52151, 1, -1, 1, 0.620533) , 
-1.159, 1, 3, 0, 0.570539) , 
-0.699024, 0, 1, 0, 0.463885) , 
-0.870768, 0, 0, 0, 0.437091) , 
NN(
NN(
0, 
0, 
1.38496, 1, -1, -1, 0.47739) , 
NN(
NN(
0, 
0, 
0.741295, 1, -1, -1, 0.445252) , 
NN(
0, 
0, 
-0.26704, 0, -1, 1, 0.583795) , 
-0.439158, 1, 3, 0, 0.548426) , 
0.294419, 0, 3, 0, 0.514205) , 
-0.735566, 1, 0, 0, 0.489997) , 
NN(
0, 
0, 
1.72349, 1, -1, 1, 0.69514) , 
1.57938, 1, 3, 0, 0.498505)    );
  // itree = 27
  fBoostWeights.push_back(0.701322);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-3.32906, 0, -1, -1, 0.391794) , 
NN(
NN(
NN(
0, 
0, 
-0.461771, 0, -1, -1, 0.367784) , 
NN(
NN(
0, 
0, 
-0.34006, 0, -1, 1, 0.521048) , 
NN(
0, 
0, 
0.446059, 0, -1, 1, 0.66848) , 
-0.565084, 0, 3, 0, 0.531284) , 
-0.879256, 1, 3, 0, 0.525186) , 
NN(
0, 
0, 
2.38956, 0, -1, 1, 0.746303) , 
1.57103, 1, 3, 0, 0.536787) , 
-0.862707, 1, 0, 0, 0.498618)    );
  // itree = 28
  fBoostWeights.push_back(0.72014);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.09918, 0, -1, -1, 0.419177) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.364898) , 
NN(
NN(
0, 
0, 
0.438119, 0, -1, -1, 0.424333) , 
NN(
0, 
0, 
0.708625, 1, -1, 1, 0.563707) , 
0.568664, 1, 3, 0, 0.51667) , 
1.38745, 0, 1, 0, 0.490352) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.784612) , 
0.0985762, 0, 2, 0, 0.51216) , 
0.32752, 1, 3, 0, 0.456787)    );
  // itree = 29
  fBoostWeights.push_back(0.820148);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.297888, 0, -1, -1, 0.324732) , 
NN(
NN(
0, 
0, 
-0.586123, 1, -1, -1, 0.35354) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.229564) , 
NN(
NN(
NN(
0, 
0, 
0.619118, 0, -1, -1, 0.187184) , 
NN(
NN(
0, 
0, 
0.470859, 0, -1, -1, 0.437347) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.759523) , 
-0.824296, 1, 3, 0, 0.552832) , 
-1.1988, 0, 0, 0, 0.445324) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.66217) , 
-0.539432, 1, 0, 0, 0.501305) , 
0.0776072, 0, 2, 0, 0.438447) , 
NN(
0, 
0, 
0.443026, 1, -1, 1, 0.586491) , 
0.288156, 1, 0, 0, 0.492754) , 
1.60622, 0, 1, 0, 0.468557) , 
-0.0347362, 1, 1, 0, 0.440088) , 
NN(
0, 
0, 
1.3257, 0, -1, 1, 0.511531) , 
0.32752, 1, 3, 0, 0.469084) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.279795) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.368173) , 
NN(
NN(
0, 
0, 
-0.96822, 0, -1, 1, 0.52755) , 
NN(
0, 
0, 
0.466894, 1, -1, 1, 0.721996) , 
0.685914, 1, 3, 0, 0.557209) , 
-0.766555, 0, 1, 0, 0.536707) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.75783) , 
-0.670215, 1, 1, 0, 0.562485) , 
-2.24894, 1, 0, 0, 0.545515) , 
-0.586885, 0, 1, 0, 0.491314)    );
  // itree = 30
  fBoostWeights.push_back(0.714849);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
1.568, 1, -1, -1, 0.404701) , 
NN(
NN(
NN(
0, 
0, 
-0.155879, 0, -1, -1, 0.429005) , 
NN(
NN(
0, 
0, 
-0.858499, 0, -1, -1, 0.359847) , 
NN(
0, 
0, 
0.126104, 0, -1, 1, 0.576027) , 
-0.414371, 1, 3, 0, 0.505667) , 
-0.203208, 1, 1, 0, 0.465763) , 
NN(
0, 
0, 
1.65217, 0, -1, 1, 0.59724) , 
0.603237, 1, 3, 0, 0.495728) , 
1.13048, 0, 1, 0, 0.478027) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.856339) , 
-2.42611, 0, 1, 0, 0.484515) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.733739) , 
2.4829, 1, 1, 0, 0.491438)    );
  // itree = 31
  fBoostWeights.push_back(0.783623);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.320584, 0, -1, -1, 0.456602) , 
NN(
0, 
0, 
1.29958, 0, -1, 1, 0.558073) , 
-0.507056, 1, 3, 0, 0.535109)    );
  // itree = 32
  fBoostWeights.push_back(0.730368);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.12131, 0, -1, -1, 0.393657) , 
NN(
NN(
0, 
0, 
2.37634, 0, -1, -1, 0.447967) , 
NN(
NN(
0, 
0, 
0.0621327, 0, -1, 1, 0.507271) , 
NN(
0, 
0, 
-0.857848, 0, -1, 1, 0.629676) , 
0.791423, 1, 3, 0, 0.532431) , 
0.478539, 0, 1, 0, 0.504363) , 
-0.507056, 1, 3, 0, 0.480675)    );
  // itree = 33
  fBoostWeights.push_back(0.770814);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.57115, 0, -1, -1, 0.353335) , 
NN(
NN(
NN(
0, 
0, 
0.172985, 0, -1, -1, 0.402584) , 
NN(
NN(
NN(
0, 
0, 
0.602259, 0, -1, -1, 0.327257) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.172244, 1, -1, -1, 0.354453) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.081041) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.418964) , 
NN(
NN(
0, 
0, 
-0.883475, 0, -1, -1, 0.464489) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.772159) , 
-0.464927, 1, 3, 0, 0.596156) , 
-0.385911, 0, 2, 0, 0.536673) , 
-1.01519, 1, 3, 0, 0.508136) , 
-0.201376, 0, 2, 0, 0.427867) , 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.657896, 0, -1, -1, 0.151381) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.470711) , 
-0.164614, 1, 3, 0, 0.275467) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.496982) , 
-1.17795, 0, 0, 0, 0.339475) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.701727) , 
0.278523, 0, 1, 0, 0.422482) , 
NN(
0, 
0, 
-0.41909, 1, -1, 1, 0.58451) , 
1.22478, 1, 1, 0, 0.487664) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.735329) , 
0.199125, 1, 2, 0, 0.532009) , 
0.0642531, 1, 1, 0, 0.481427) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
0.606331, 1, 3, 0, 0.492457) , 
0.393245, 0, 2, 0, 0.47088) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.3601) , 
NN(
0, 
0, 
0.188634, 1, -1, 1, 0.546887) , 
0.804531, 1, 3, 0, 0.446493) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.788209) , 
-1.16456, 0, 1, 0, 0.50971) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.752434) , 
0.733172, 0, 2, 0, 0.574573) , 
0.608157, 1, 2, 0, 0.493172) , 
1.95916, 0, 0, 0, 0.485006) , 
NN(
0, 
0, 
2.08973, 0, 0, 1, 1) , 
2.13758, 1, 3, 0, 0.48659) , 
-1.34163, 1, 3, 0, 0.480271)    );
  // itree = 34
  fBoostWeights.push_back(0.751261);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.22173, 0, -1, -1, 0.357121) , 
NN(
NN(
NN(
0, 
0, 
-0.880634, 0, -1, -1, 0.32533) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.328233) , 
NN(
NN(
NN(
NN(
0, 
0, 
1.76158, 1, -1, -1, 0.409074) , 
NN(
NN(
0, 
0, 
1.39536, 1, -1, 1, 0.515255) , 
NN(
0, 
0, 
-0.16852, 0, -1, 1, 0.699811) , 
0.703678, 1, 2, 0, 0.554631) , 
2.43382, 0, 0, 0, 0.540038) , 
NN(
0, 
0, 
2.04736, 1, -1, 1, 0.858792) , 
1.83237, 1, 2, 0, 0.550243) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.719637) , 
0.00632801, 0, 0, 0, 0.565719) , 
-0.144768, 1, 0, 0, 0.547926) , 
-0.488597, 1, 3, 0, 0.530027) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.446404) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.308901) , 
NN(
0, 
0, 
-1.8437, 0, -1, 1, 0.625255) , 
-1.13706, 1, 3, 0, 0.613949) , 
-1.21114, 1, 1, 0, 0.589426) , 
-0.282304, 0, 0, 0, 0.55333) , 
-1.34163, 1, 3, 0, 0.544808)    );
  // itree = 35
  fBoostWeights.push_back(0.743733);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.75208, 1, -1, -1, 0.34704) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.486734, 1, -1, -1, 0.410432) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.334993) , 
NN(
NN(
NN(
0, 
0, 
-0.665606, 0, -1, -1, 0.477253) , 
NN(
NN(
NN(
0, 
0, 
-1.01451, 1, -1, -1, 0.441786) , 
NN(
NN(
0, 
0, 
-0.446235, 0, -1, -1, 0.488996) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.703418) , 
-0.315539, 1, 3, 0, 0.566149) , 
-0.104728, 1, 1, 0, 0.516001) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.677598) , 
0.015309, 1, 3, 0, 0.547459) , 
-0.110124, 0, 0, 0, 0.514924) , 
NN(
0, 
0, 
0.485233, 1, -1, 1, 0.680438) , 
0.315364, 1, 2, 0, 0.542974) , 
0.681868, 0, 3, 0, 0.53082) , 
0.671322, 0, 2, 0, 0.511933) , 
NN(
0, 
0, 
1.6662, 0, -1, 1, 0.632291) , 
0.973612, 1, 3, 0, 0.521746) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.88644, 1, 2, 0, 0.524691) , 
NN(
0, 
0, 
-0.119877, 0, -1, 1, 0.6299) , 
-1.35433, 0, 1, 0, 0.536771) , 
-1.34163, 1, 3, 0, 0.528915)    );
  // itree = 36
  fBoostWeights.push_back(0.672256);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.203162, 1, -1, -1, 0.420237) , 
NN(
NN(
0, 
0, 
0.493868, 1, -1, -1, 0.452224) , 
NN(
NN(
NN(
0, 
0, 
-0.507089, 0, -1, -1, 0.460975) , 
NN(
0, 
0, 
-0.0766143, 1, -1, 1, 0.694338) , 
-0.322843, 0, 3, 0, 0.522976) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.718111) , 
0.165232, 1, 3, 0, 0.57078) , 
0.132194, 0, 2, 0, 0.500863) , 
-0.358649, 1, 2, 0, 0.475669) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.873396) , 
-3.42721, 0, 0, 0, 0.478721) , 
NN(
0, 
0, 
0.180925, 1, -1, 1, 0.63605) , 
0.744808, 1, 3, 0, 0.501781)    );
  // itree = 37
  fBoostWeights.push_back(0.642359);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.8178, 0, -1, -1, 0.29416) , 
NN(
NN(
0, 
0, 
0.502129, 1, -1, -1, 0.422236) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.249697) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.221476) , 
NN(
NN(
0, 
0, 
-1.33318, 0, -1, -1, 0.471706) , 
NN(
0, 
0, 
-0.0982477, 1, -1, 1, 0.62766) , 
0.0453735, 1, 3, 0, 0.507627) , 
2.09918, 0, 1, 0, 0.492335) , 
0.185741, 0, 2, 0, 0.471531) , 
NN(
0, 
0, 
0.325726, 0, -1, 1, 0.614972) , 
0.2516, 1, 2, 0, 0.488763) , 
0.447509, 0, 2, 0, 0.473298) , 
-1.37067, 1, 3, 0, 0.464621) , 
NN(
0, 
0, 
1.06593, 0, -1, 1, 0.603256) , 
0.744808, 1, 3, 0, 0.483906)    );
  // itree = 38
  fBoostWeights.push_back(0.784962);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.558422, 1, -1, -1, 0.400905) , 
NN(
NN(
0, 
0, 
-1.25229, 1, -1, 1, 0.528216) , 
NN(
0, 
0, 
1.18005, 0, -1, 1, 0.689936) , 
0.98653, 1, 3, 0, 0.54249) , 
-0.507056, 1, 3, 0, 0.512944)    );
  // itree = 39
  fBoostWeights.push_back(0.814032);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.558422, 1, -1, -1, 0.421374) , 
NN(
0, 
0, 
-1.18469, 1, -1, 1, 0.530426) , 
-0.0897679, 1, 3, 0, 0.482995)    );
  // itree = 40
  fBoostWeights.push_back(0.801254);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.244863) , 
NN(
NN(
0, 
0, 
-0.699024, 1, -1, -1, 0.292988) , 
NN(
0, 
0, 
-0.993078, 0, -1, -1, 0.447279) , 
-1.17526, 1, 3, 0, 0.407156) , 
-0.177572, 0, 2, 0, 0.371173) , 
NN(
0, 
0, 
0.948007, 1, -1, -1, 0.493405) , 
-0.558422, 1, 0, 0, 0.430883) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.342989, 0, -1, -1, 0.367464) , 
NN(
0, 
0, 
1.06837, 0, -1, 1, 0.51407) , 
0.410802, 1, 3, 0, 0.456426) , 
NN(
0, 
0, 
1.79707, 0, -1, 1, 0.728532) , 
1.61754, 1, 3, 0, 0.480878) , 
NN(
0, 
0, 
-0.912084, 1, -1, 1, 0.662721) , 
-0.542451, 0, 0, 0, 0.513429) , 
NN(
0, 
0, 
0.443727, 1, -1, 1, 0.653389) , 
0.0985762, 0, 2, 0, 0.547075) , 
-0.0897679, 1, 3, 0, 0.49672)    );
  // itree = 41
  fBoostWeights.push_back(0.799849);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.37752, 0, -1, -1, 0.292828) , 
NN(
NN(
0, 
0, 
-0.296871, 1, -1, -1, 0.353312) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.332248) , 
NN(
NN(
0, 
0, 
-0.563955, 1, -1, -1, 0.388161) , 
NN(
0, 
0, 
-0.346831, 1, -1, 1, 0.754182) , 
-0.649085, 1, 2, 0, 0.529256) , 
-0.182694, 0, 2, 0, 0.470574) , 
-1.11305, 0, 0, 0, 0.44074) , 
-2.29167, 1, 0, 0, 0.418951) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.345756) , 
NN(
NN(
0, 
0, 
-0.812814, 0, -1, -1, 0.495412) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.388168) , 
NN(
NN(
0, 
0, 
0.0642531, 1, -1, 1, 0.524449) , 
NN(
0, 
0, 
0.396303, 0, -1, 1, 0.66519) , 
-0.112387, 1, 3, 0, 0.600036) , 
0.947878, 0, 2, 0, 0.58146) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.895302) , 
1.23283, 1, 3, 0, 0.588983) , 
0.82002, 0, 0, 0, 0.553696) , 
-0.718107, 1, 0, 0, 0.542548) , 
-0.862707, 1, 0, 0, 0.511411)    );
  // itree = 42
  fBoostWeights.push_back(0.735973);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.203162, 1, -1, -1, 0.473174) , 
NN(
0, 
0, 
0.370364, 0, -1, 1, 0.571395) , 
-0.0897679, 1, 3, 0, 0.529239)    );
  // itree = 43
  fBoostWeights.push_back(0.86392);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
2.27403, 0, -1, -1, 0.439969) , 
NN(
0, 
0, 
-0.906123, 0, -1, 1, 0.556178) , 
-0.259464, 1, 3, 0, 0.515808) , 
NN(
0, 
0, 
1.43564, 0, -1, 1, 0.67458) , 
0.853908, 1, 2, 0, 0.535628)    );
  // itree = 44
  fBoostWeights.push_back(0.766279);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
1.24453, 1, -1, -1, 0.358085) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.267198) , 
NN(
NN(
NN(
0, 
0, 
-0.788481, 0, -1, -1, 0.328792) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.301313) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.288593) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
-0.778108, 1, -1, 1, 0.657108) , 
-1.03945, 1, 3, 0, 0.582882) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.830471) , 
-1.48057, 0, 3, 0, 0.638269) , 
0.372794, 0, 1, 0, 0.581692) , 
-2.16638, 1, 0, 0, 0.542793) , 
-0.56107, 0, 2, 0, 0.420629) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.631704) , 
-1.11544, 0, 1, 0, 0.449149) , 
-1.523, 1, 1, 0, 0.421166) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.665573) , 
-0.806395, 1, 3, 0, 0.561527) , 
0.585642, 1, 1, 0, 0.440504) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.716471) , 
0.417383, 1, 3, 0, 0.462918) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.70303) , 
-2.90374, 0, 0, 0, 0.472186) , 
0.946333, 0, 1, 0, 0.4448) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.23324) , 
NN(
NN(
0, 
0, 
0.924117, 0, -1, -1, 0.353569) , 
NN(
0, 
0, 
0.162594, 1, -1, 1, 0.634814) , 
-0.286066, 1, 3, 0, 0.583487) , 
0.630521, 0, 3, 0, 0.530634) , 
0.390969, 1, 0, 0, 0.472846) , 
NN(
NN(
0, 
0, 
0.732758, 0, -1, 1, 0.539149) , 
NN(
0, 
0, 
0.777311, 0, -1, 1, 0.730865) , 
0.810201, 1, 3, 0, 0.602817) , 
0.437295, 1, 2, 0, 0.510363)    );
  // itree = 45
  fBoostWeights.push_back(0.714313);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.323989) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.246725) , 
NN(
NN(
0, 
0, 
-0.752491, 1, -1, -1, 0.347595) , 
NN(
0, 
0, 
-2.00356, 1, -1, 1, 0.53527) , 
-1.24655, 1, 3, 0, 0.469487) , 
-0.389434, 0, 2, 0, 0.393783) , 
NN(
NN(
0, 
0, 
-1.75425, 0, -1, -1, 0.351513) , 
NN(
NN(
0, 
0, 
-0.217597, 1, -1, -1, 0.489077) , 
NN(
0, 
0, 
-0.565403, 0, -1, 1, 0.625072) , 
-0.378855, 0, 3, 0, 0.515503) , 
-0.825264, 1, 3, 0, 0.496515) , 
-1.53113, 1, 0, 0, 0.477977) , 
1.82279, 0, 0, 0, 0.467188) , 
NN(
NN(
0, 
0, 
0.722757, 1, -1, -1, 0.492049) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.347331) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.436052) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.592473) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.04694, 1, 3, 0, 0.65816) , 
1.65798, 0, 2, 0, 0.612829) , 
-0.527412, 1, 1, 0, 0.562041) , 
NN(
0, 
0, 
-1.77267, 1, -1, 1, 0.713038) , 
-0.888878, 0, 1, 0, 0.611381) , 
NN(
0, 
0, 
1.21563, 0, -1, 1, 0.718589) , 
0.422896, 1, 1, 0, 0.648946) , 
0.641999, 1, 2, 0, 0.605487) , 
0.437295, 1, 2, 0, 0.507415)    );
  // itree = 46
  fBoostWeights.push_back(0.829667);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-1.10283, 0, -1, -1, 0.204184) , 
NN(
NN(
0, 
0, 
-1.2287, 0, -1, -1, 0.384927) , 
NN(
0, 
0, 
0.455138, 0, -1, -1, 0.468145) , 
-0.349703, 1, 3, 0, 0.441159) , 
-1.53565, 1, 0, 0, 0.421912) , 
NN(
NN(
0, 
0, 
-1.12279, 0, -1, -1, 0.439923) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.781511) , 
-0.971856, 1, 3, 0, 0.602148) , 
-1.90801, 0, 0, 0, 0.440784) , 
NN(
0, 
0, 
-0.586123, 1, -1, 1, 0.577485) , 
1.71545, 1, 1, 0, 0.451863) , 
NN(
0, 
0, 
1.38745, 0, -1, 1, 0.579676) , 
0.32752, 1, 3, 0, 0.499234)    );
  // itree = 47
  fBoostWeights.push_back(0.66032);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.840919, 0, -1, -1, 0.41308) , 
NN(
NN(
NN(
0, 
0, 
0.857093, 0, -1, -1, 0.424141) , 
NN(
0, 
0, 
-0.220137, 1, -1, 1, 0.574372) , 
0.614129, 1, 3, 0, 0.501796) , 
NN(
0, 
0, 
0.353294, 1, -1, 1, 0.592932) , 
0.638814, 0, 2, 0, 0.569714) , 
-0.507056, 1, 3, 0, 0.539889)    );
  // itree = 48
  fBoostWeights.push_back(0.716595);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.294094, 0, -1, -1, 0.318842) , 
NN(
NN(
0, 
0, 
-0.68792, 0, -1, -1, 0.442523) , 
NN(
0, 
0, 
-0.71419, 1, -1, 1, 0.512665) , 
-0.47116, 1, 3, 0, 0.493277) , 
0.431848, 0, 2, 0, 0.460771) , 
NN(
0, 
0, 
1.8166, 1, -1, 1, 0.589624) , 
0.603237, 1, 3, 0, 0.481636) , 
NN(
0, 
0, 
0.46084, 0, -1, 1, 0.574388) , 
1.33173, 1, 1, 0, 0.495223)    );
  // itree = 49
  fBoostWeights.push_back(0.651041);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.840112, 0, -1, -1, 0.448629) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.5738) , 
-0.216984, 1, 3, 0, 0.47675) , 
NN(
NN(
NN(
0, 
0, 
-1.02045, 1, -1, 1, 0.54559) , 
NN(
0, 
0, 
2.93017, 0, -1, 1, 0.705925) , 
1.25231, 1, 3, 0, 0.557819) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.858318) , 
-2.14924, 0, 1, 0, 0.564925) , 
-0.0897679, 1, 3, 0, 0.528689)    );
  // itree = 50
  fBoostWeights.push_back(0.740013);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.452124, 0, -1, -1, 0.384298) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
0.87987, 1, 2, 0, 0.402021) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.271783) , 
NN(
NN(
0, 
0, 
-1.06672, 0, -1, -1, 0.385641) , 
NN(
0, 
0, 
-0.186939, 0, -1, 1, 0.558718) , 
-0.384351, 1, 3, 0, 0.476834) , 
0.850281, 0, 0, 0, 0.443458) , 
NN(
0, 
0, 
-0.686631, 1, -1, 1, 0.552853) , 
0.145007, 1, 3, 0, 0.497305) , 
0.613103, 0, 1, 0, 0.470657) , 
NN(
NN(
0, 
0, 
-2.07723, 0, -1, -1, 0.473156) , 
NN(
NN(
NN(
0, 
0, 
-1.22945, 1, -1, 1, 0.527893) , 
NN(
0, 
0, 
-1.15649, 0, -1, 1, 0.81905) , 
0.566236, 1, 2, 0, 0.570782) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.947039) , 
-1.54258, 0, 1, 0, 0.61703) , 
-1.69229, 1, 1, 0, 0.568403) , 
-0.872342, 0, 1, 0, 0.496744) , 
NN(
0, 
0, 
0.411586, 1, -1, 1, 0.596482) , 
1.33173, 1, 1, 0, 0.511572)    );
  // itree = 51
  fBoostWeights.push_back(0.723803);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.09479, 1, -1, -1, 0.359187) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.0462737, 0, -1, -1, 0.298751) , 
NN(
0, 
0, 
-1.0072, 1, -1, -1, 0.498651) , 
0.450951, 0, 3, 0, 0.464156) , 
NN(
NN(
0, 
0, 
-1.94672, 1, -1, -1, 0.480331) , 
NN(
0, 
0, 
-1.83748, 0, -1, 1, 0.690354) , 
-0.514317, 1, 3, 0, 0.583189) , 
-1.32427, 0, 0, 0, 0.494441) , 
NN(
0, 
0, 
-0.0454887, 1, -1, 1, 0.707287) , 
0.907668, 1, 3, 0, 0.504634) , 
NN(
NN(
0, 
0, 
-0.035676, 0, -1, -1, 0.477915) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.53765) , 
NN(
0, 
0, 
1.23003, 0, -1, 1, 0.796222) , 
0.194911, 1, 2, 0, 0.677262) , 
0.266332, 1, 1, 0, 0.589471) , 
0.474563, 1, 0, 0, 0.529845) , 
1.86861, 0, 0, 0, 0.513908)    );
  // itree = 52
  fBoostWeights.push_back(0.827372);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.221938, 0, -1, -1, 0.292752) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.0648183, 1, -1, -1, 0.386125) , 
NN(
NN(
0, 
0, 
-1.46388, 1, -1, -1, 0.365892) , 
NN(
0, 
0, 
-0.818881, 0, -1, 1, 0.516616) , 
-1.00417, 1, 3, 0, 0.491716) , 
-0.401894, 0, 0, 0, 0.448448) , 
NN(
NN(
NN(
0, 
0, 
0.348733, 0, -1, -1, 0.341344) , 
NN(
0, 
0, 
0.030055, 1, -1, 1, 0.513269) , 
-0.074275, 1, 3, 0, 0.44332) , 
NN(
0, 
0, 
1.5149, 0, -1, 1, 0.561985) , 
0.18022, 1, 2, 0, 0.506316) , 
0.240509, 1, 0, 0, 0.4729) , 
NN(
0, 
0, 
2.33705, 0, 0, 1, 1) , 
2.24158, 1, 3, 0, 0.475531) , 
1.68312, 0, 1, 0, 0.464325) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.811896) , 
2.4829, 1, 1, 0, 0.471692)    );
  // itree = 53
  fBoostWeights.push_back(0.814561);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.158172) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.110209) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.113533) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.417185) , 
-0.508991, 1, 3, 0, 0.354769) , 
0.553033, 0, 0, 0, 0.286356) , 
NN(
NN(
0, 
0, 
0.936341, 0, -1, -1, 0.487187) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.847947) , 
0.740476, 1, 0, 0, 0.591759) , 
0.773517, 1, 1, 0, 0.423711) , 
1.20753, 0, 1, 0, 0.356067) , 
NN(
0, 
0, 
-1.75271, 1, -1, 1, 0.52989) , 
1.29982, 1, 1, 0, 0.433615) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.346481, 0, -1, -1, 0.276371) , 
NN(
0, 
0, 
-1.45149, 1, -1, -1, 0.487521) , 
-0.172301, 1, 3, 0, 0.448339) , 
NN(
0, 
0, 
0.639743, 1, -1, 1, 0.543069) , 
-0.230586, 0, 2, 0, 0.481383) , 
NN(
0, 
0, 
1.63357, 0, -1, 1, 0.623427) , 
0.603237, 1, 3, 0, 0.510396) , 
0.564284, 0, 1, 0, 0.485645)    );
  // itree = 54
  fBoostWeights.push_back(0.648069);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.767171, 1, -1, -1, 0.382171) , 
NN(
NN(
0, 
0, 
-0.25372, 0, -1, -1, 0.491491) , 
NN(
NN(
NN(
0, 
0, 
-0.253451, 0, -1, -1, 0.491313) , 
NN(
0, 
0, 
1.19675, 0, -1, 1, 0.603251) , 
0.537664, 1, 3, 0, 0.538617) , 
NN(
0, 
0, 
0.0403445, 1, -1, 1, 0.687835) , 
0.114859, 0, 3, 0, 0.576057) , 
-0.157557, 1, 3, 0, 0.550487) , 
-0.924344, 1, 3, 0, 0.535964)    );
  // itree = 55
  fBoostWeights.push_back(0.624754);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.820793, 0, -1, -1, 0.305749) , 
NN(
NN(
0, 
0, 
-1.22466, 0, -1, -1, 0.435159) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.367469) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.801863) , 
-0.694841, 1, 3, 0, 0.623107) , 
-0.818006, 1, 0, 0, 0.497119) , 
0.320584, 0, 0, 0, 0.419938) , 
NN(
NN(
0, 
0, 
-0.557459, 1, -1, -1, 0.472187) , 
NN(
0, 
0, 
-0.267743, 0, -1, 1, 0.585284) , 
-0.489374, 1, 3, 0, 0.545643) , 
0.180561, 0, 1, 0, 0.49002) , 
NN(
NN(
NN(
0, 
0, 
2.14569, 1, -1, -1, 0.439449) , 
NN(
NN(
0, 
0, 
0.197928, 0, -1, 1, 0.544521) , 
NN(
0, 
0, 
0.741276, 0, -1, 1, 0.720708) , 
0.777398, 1, 3, 0, 0.576687) , 
1.65044, 0, 0, 0, 0.552607) , 
NN(
0, 
0, 
0.386141, 1, -1, 1, 0.661006) , 
0.573215, 1, 1, 0, 0.593078) , 
0.0206825, 1, 2, 0, 0.549999)    );
  // itree = 56
  fBoostWeights.push_back(0.820496);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.51812, 1, -1, -1, 0.497879) , 
NN(
0, 
0, 
0.180925, 1, -1, 1, 0.613716) , 
0.744808, 1, 3, 0, 0.510927)    );
  // itree = 57
  fBoostWeights.push_back(0.858987);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.829781, 0, -1, -1, 0.40627) , 
NN(
NN(
0, 
0, 
1.40613, 1, -1, -1, 0.429751) , 
NN(
NN(
0, 
0, 
-0.0265513, 0, -1, -1, 0.41947) , 
NN(
NN(
0, 
0, 
0.268508, 1, -1, 1, 0.504496) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.320411) , 
NN(
0, 
0, 
0.877256, 0, -1, 1, 0.628849) , 
0.537395, 1, 3, 0, 0.500374) , 
NN(
0, 
0, 
-0.305555, 1, -1, 1, 0.639666) , 
0.663195, 0, 2, 0, 0.61289) , 
1.17087, 0, 1, 0, 0.595088) , 
-1.48115, 1, 0, 0, 0.580105) , 
1.29958, 0, 0, 0, 0.550063) , 
-0.507056, 1, 3, 0, 0.525137)    );
  // itree = 58
  fBoostWeights.push_back(0.738856);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.93301, 1, -1, -1, 0.325363) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.279307) , 
NN(
0, 
0, 
0.858813, 0, -1, -1, 0.451445) , 
0.029662, 1, 3, 0, 0.408248) , 
NN(
0, 
0, 
0.792349, 0, -1, 1, 0.51695) , 
0.204516, 1, 0, 0, 0.464022) , 
NN(
NN(
0, 
0, 
-0.175284, 0, -1, 1, 0.500019) , 
NN(
0, 
0, 
-0.213852, 1, -1, 1, 0.674248) , 
-0.0219562, 1, 3, 0, 0.557255) , 
0.111517, 0, 2, 0, 0.506131) , 
-1.34163, 1, 3, 0, 0.49876) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.750357) , 
2.4829, 1, 1, 0, 0.505619)    );
  // itree = 59
  fBoostWeights.push_back(0.824047);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.301037, 0, -1, -1, 0.356629) , 
NN(
NN(
0, 
0, 
-0.518172, 0, -1, -1, 0.316533) , 
NN(
NN(
0, 
0, 
0.0374115, 1, -1, -1, 0.443022) , 
NN(
0, 
0, 
0.375322, 0, -1, 1, 0.53163) , 
0.037, 1, 3, 0, 0.487412) , 
-0.372882, 1, 1, 0, 0.465408) , 
1.12412, 0, 1, 0, 0.439459) , 
NN(
0, 
0, 
-0.120688, 1, -1, 1, 0.602598) , 
1.95075, 1, 1, 0, 0.452676) , 
NN(
0, 
0, 
1.43564, 0, -1, 1, 0.67726) , 
1.1988, 1, 2, 0, 0.462798) , 
NN(
NN(
NN(
0, 
0, 
-0.12723, 1, -1, -1, 0.417933) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.259294) , 
NN(
NN(
0, 
0, 
1.75332, 1, -1, -1, 0.370455) , 
NN(
NN(
0, 
0, 
-0.609552, 0, -1, -1, 0.481261) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.701808) , 
-0.07808, 1, 2, 0, 0.60023) , 
0.595393, 0, 2, 0, 0.565836) , 
-1.19951, 1, 1, 0, 0.529904) , 
NN(
0, 
0, 
-1.47222, 1, -1, 1, 0.697176) , 
-1.29393, 0, 1, 0, 0.564953) , 
-1.63585, 1, 1, 0, 0.53035) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.74845) , 
-2.46311, 0, 1, 0, 0.540915) , 
-0.586885, 0, 1, 0, 0.48442)    );
  // itree = 60
  fBoostWeights.push_back(0.773345);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.296019, 0, -1, -1, 0.365524) , 
NN(
NN(
0, 
0, 
1.47369, 1, -1, -1, 0.228033) , 
NN(
NN(
NN(
NN(
0, 
0, 
1.25578, 0, -1, -1, 0.434937) , 
NN(
0, 
0, 
1.08587, 0, -1, 1, 0.574209) , 
0.64903, 1, 3, 0, 0.489199) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.624086) , 
1.28644, 1, 1, 0, 0.52042) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
-0.866118, 0, 1, 0, 0.538589) , 
-1.18469, 1, 1, 0, 0.511418) , 
0.596343, 1, 0, 0, 0.436195) , 
NN(
0, 
0, 
1.1346, 0, -1, 1, 0.577763) , 
-0.170026, 0, 3, 0, 0.467773) , 
NN(
NN(
0, 
0, 
1.84958, 1, -1, -1, 0.386196) , 
NN(
NN(
0, 
0, 
-0.180804, 0, -1, 1, 0.519457) , 
NN(
0, 
0, 
0.496584, 0, -1, 1, 0.708111) , 
0.117243, 1, 3, 0, 0.573365) , 
1.30151, 0, 1, 0, 0.53224) , 
-0.316443, 0, 0, 0, 0.492298)    );
  // itree = 61
  fBoostWeights.push_back(0.74621);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.10754, 0, -1, -1, 0.412044) , 
NN(
0, 
0, 
1.08805, 0, -1, 1, 0.602777) , 
0.921132, 1, 2, 0, 0.435007) , 
NN(
NN(
0, 
0, 
-2.22173, 0, -1, -1, 0.323657) , 
NN(
NN(
NN(
0, 
0, 
-0.784618, 0, -1, -1, 0.293513) , 
NN(
0, 
0, 
-0.906123, 1, -1, 1, 0.518306) , 
-0.444473, 1, 3, 0, 0.495966) , 
NN(
0, 
0, 
-0.866432, 1, -1, 1, 0.686473) , 
-0.654969, 0, 2, 0, 0.530577) , 
-1.33604, 1, 3, 0, 0.517859) , 
0.22982, 0, 0, 0, 0.484455)    );
  // itree = 62
  fBoostWeights.push_back(0.766664);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.147849) , 
NN(
NN(
NN(
0, 
0, 
0.119652, 1, -1, -1, 0.312074) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.540958, 1, -1, -1, 0.387686) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.347711) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.321032) , 
NN(
NN(
0, 
0, 
-0.332224, 1, -1, -1, 0.490639) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.650095) , 
0.323098, 1, 3, 0, 0.507249) , 
0.335197, 0, 2, 0, 0.484762) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.685189) , 
0.608655, 1, 2, 0, 0.510992) , 
0.9078, 0, 2, 0, 0.498458) , 
0.205021, 0, 0, 0, 0.473772) , 
NN(
0, 
0, 
-2.13841, 1, -1, 1, 0.767498) , 
-2.87192, 0, 0, 0, 0.479401) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.779921) , 
0.646947, 1, 0, 0, 0.487027) , 
0.831631, 0, 0, 0, 0.475806) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.75744) , 
1.02701, 1, 0, 0, 0.485975) , 
1.21096, 0, 0, 0, 0.477314) , 
NN(
0, 
0, 
1.89473, 0, -1, 1, 0.586345) , 
1.39971, 1, 0, 0, 0.49077) , 
NN(
0, 
0, 
1.43564, 0, -1, 1, 0.637792) , 
1.27052, 1, 2, 0, 0.495864)    );
  // itree = 63
  fBoostWeights.push_back(0.697582);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.31043) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.934332, 0, -1, -1, 0.307597) , 
NN(
NN(
0, 
0, 
0.304773, 1, -1, -1, 0.40394) , 
NN(
NN(
0, 
0, 
0.979937, 1, -1, -1, 0.396018) , 
NN(
0, 
0, 
-0.834088, 0, -1, 1, 0.539853) , 
-0.94376, 1, 3, 0, 0.502192) , 
-0.096755, 0, 3, 0, 0.460652) , 
-0.728163, 1, 1, 0, 0.438002) , 
NN(
0, 
0, 
-0.397372, 1, -1, 1, 0.526939) , 
0.508355, 1, 0, 0, 0.461509) , 
NN(
NN(
0, 
0, 
0.441224, 1, -1, -1, 0.484403) , 
NN(
0, 
0, 
-1.18657, 1, -1, 1, 0.685399) , 
-0.168243, 0, 3, 0, 0.561965) , 
-1.05368, 0, 1, 0, 0.477697) , 
1.91364, 0, 0, 0, 0.465676) , 
NN(
0, 
0, 
-0.118297, 1, -1, 1, 0.574788) , 
0.853908, 1, 2, 0, 0.476972)    );
  // itree = 64
  fBoostWeights.push_back(0.697096);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.53465, 1, -1, -1, 0.281219) , 
NN(
NN(
0, 
0, 
-1.01851, 0, -1, -1, 0.38896) , 
NN(
0, 
0, 
-0.176028, 1, -1, 1, 0.593125) , 
-0.432274, 1, 3, 0, 0.485813) , 
0.882574, 0, 1, 0, 0.418701) , 
NN(
NN(
0, 
0, 
0.726343, 0, -1, 1, 0.511626) , 
NN(
0, 
0, 
1.18005, 0, -1, 1, 0.648565) , 
0.99068, 1, 3, 0, 0.520747) , 
-0.862707, 1, 0, 0, 0.497737)    );
  // itree = 65
  fBoostWeights.push_back(0.685924);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.558422, 1, -1, -1, 0.421413) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.294671) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.366964) , 
NN(
NN(
NN(
0, 
0, 
0.48729, 1, -1, -1, 0.453513) , 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.210457) , 
NN(
0, 
0, 
0.343291, 0, -1, -1, 0.468692) , 
0.979869, 1, 3, 0, 0.332216) , 
NN(
0, 
0, 
1.94598, 0, -1, 1, 0.6824) , 
-1.15026, 0, 1, 0, 0.380183) , 
NN(
0, 
0, 
0.697984, 1, -1, 1, 0.512802) , 
0.816568, 0, 2, 0, 0.478546) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.640639) , 
-0.542451, 0, 0, 0, 0.509405) , 
NN(
0, 
0, 
-0.227656, 1, -1, 1, 0.63536) , 
0.0985762, 0, 2, 0, 0.548606) , 
0.66236, 0, 1, 0, 0.521889) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.67586) , 
-0.199938, 0, 3, 0, 0.534747) , 
-0.29968, 1, 3, 0, 0.525768) , 
-0.397034, 1, 3, 0, 0.518276) , 
-0.507056, 1, 3, 0, 0.501585)    );
  // itree = 66
  fBoostWeights.push_back(0.763085);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.523474, 1, -1, -1, 0.305111) , 
NN(
NN(
NN(
0, 
0, 
0.0383692, 1, -1, -1, 0.375722) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.273121) , 
NN(
0, 
0, 
-0.689771, 1, -1, 1, 0.642097) , 
-0.680104, 1, 3, 0, 0.529707) , 
-0.399459, 0, 2, 0, 0.434152) , 
NN(
0, 
0, 
-0.465177, 1, -1, 1, 0.537668) , 
-0.912489, 0, 0, 0, 0.461048) , 
-1.10085, 1, 3, 0, 0.441746) , 
NN(
NN(
0, 
0, 
0.798569, 0, -1, -1, 0.471085) , 
NN(
0, 
0, 
0.744413, 1, -1, 1, 0.622749) , 
0.0736846, 1, 0, 0, 0.558757) , 
0.0206825, 1, 2, 0, 0.50897)    );
  // itree = 67
  fBoostWeights.push_back(0.704489);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-1.73264, 0, -1, -1, 0.316369) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.610891, 1, -1, -1, 0.327308) , 
NN(
NN(
0, 
0, 
0.442368, 0, -1, -1, 0.449261) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.748346) , 
0.0806985, 1, 3, 0, 0.508895) , 
0.202554, 0, 2, 0, 0.440827) , 
NN(
0, 
0, 
0.310151, 0, -1, 1, 0.512932) , 
-0.109289, 1, 0, 0, 0.484884) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.652065) , 
2.09918, 1, 1, 0, 0.493549) , 
-1.21638, 1, 2, 0, 0.48563) , 
NN(
NN(
0, 
0, 
-0.964174, 0, -1, -1, 0.397574) , 
NN(
0, 
0, 
-0.675551, 0, -1, 1, 0.697991) , 
-2.28821, 1, 0, 0, 0.600352) , 
-1.85903, 0, 0, 0, 0.494848) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.931374) , 
-3.42721, 0, 0, 0, 0.498611) , 
NN(
0, 
0, 
0.422896, 0, -1, 1, 0.606483) , 
0.744808, 1, 3, 0, 0.509913)    );
  // itree = 68
  fBoostWeights.push_back(0.771411);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.0950895, 0, -1, -1, 0.296658) , 
NN(
NN(
0, 
0, 
-0.483244, 0, -1, -1, 0.343182) , 
NN(
0, 
0, 
0.127869, 0, -1, 1, 0.531721) , 
-0.795267, 1, 3, 0, 0.481874) , 
-0.0484698, 0, 2, 0, 0.400176) , 
NN(
0, 
0, 
-1.58451, 1, -1, -1, 0.496098) , 
-0.613542, 0, 1, 0, 0.432947) , 
NN(
0, 
0, 
-1.67882, 1, -1, 1, 0.536096) , 
1.33173, 1, 1, 0, 0.450212) , 
NN(
0, 
0, 
-0.86317, 1, -1, 1, 0.543772) , 
0.32752, 1, 3, 0, 0.484102)    );
  // itree = 69
  fBoostWeights.push_back(0.813992);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.965158, 1, -1, -1, 0.365334) , 
NN(
0, 
0, 
2.33235, 0, -1, 1, 0.57344) , 
0.910562, 1, 3, 0, 0.406185) , 
NN(
0, 
0, 
0.763464, 1, -1, -1, 0.484245) , 
0.370364, 0, 3, 0, 0.443743) , 
NN(
0, 
0, 
0.126029, 1, -1, 1, 0.541994) , 
-0.0897679, 0, 3, 0, 0.483947)    );
  // itree = 70
  fBoostWeights.push_back(0.744809);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.279948, 0, -1, -1, 0.344771) , 
NN(
0, 
0, 
1.63357, 0, -1, 1, 0.583138) , 
1.03815, 1, 3, 0, 0.367407) , 
NN(
0, 
0, 
0.10414, 0, -1, -1, 0.499287) , 
0.12015, 0, 3, 0, 0.419412) , 
NN(
NN(
NN(
0, 
0, 
-0.68575, 0, -1, -1, 0.365989) , 
NN(
0, 
0, 
-0.871242, 0, -1, 1, 0.554947) , 
-0.341909, 1, 3, 0, 0.480751) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.389664) , 
NN(
NN(
0, 
0, 
-2.15343, 1, -1, -1, 0.43244) , 
NN(
0, 
0, 
-0.758476, 1, -1, 1, 0.756109) , 
-0.901137, 1, 3, 0, 0.680244) , 
-1.50186, 1, 1, 0, 0.619731) , 
0.235983, 0, 1, 0, 0.550553) , 
-0.316443, 0, 0, 0, 0.468876)    );
  // itree = 71
  fBoostWeights.push_back(0.758393);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.387645, 1, -1, -1, 0.342451) , 
NN(
NN(
NN(
0, 
0, 
0.22572, 0, -1, -1, 0.286516) , 
NN(
NN(
NN(
0, 
0, 
1.70407, 0, -1, -1, 0.381986) , 
NN(
0, 
0, 
1.15737, 0, -1, 1, 0.600022) , 
0.970828, 1, 3, 0, 0.426833) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.599862) , 
0.437976, 0, 3, 0, 0.461245) , 
0.357977, 1, 3, 0, 0.401589) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.597369) , 
0.104619, 0, 3, 0, 0.443359) , 
-0.170026, 1, 3, 0, 0.419322) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.329339) , 
NN(
NN(
NN(
0, 
0, 
-1.23723, 0, -1, -1, 0.386224) , 
NN(
0, 
0, 
-1.92298, 0, -1, 1, 0.548095) , 
-1.33251, 1, 3, 0, 0.528845) , 
NN(
0, 
0, 
-0.728554, 1, -1, 1, 0.669268) , 
0.303696, 1, 3, 0, 0.566911) , 
2.01186, 0, 1, 0, 0.535792) , 
-0.316443, 0, 0, 0, 0.46301)    );
  // itree = 72
  fBoostWeights.push_back(0.773863);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.250433) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.0812642, 0, -1, -1, 0.300794) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.273621) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.391709) , 
NN(
NN(
0, 
0, 
0.108569, 1, -1, -1, 0.353901) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.882908) , 
-0.777494, 1, 3, 0, 0.624761) , 
0.054849, 0, 0, 0, 0.491856) , 
-0.382845, 1, 1, 0, 0.431397) , 
-0.100234, 0, 2, 0, 0.356961) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.516997) , 
1.34839, 1, 0, 0, 0.387507) , 
NN(
NN(
0, 
0, 
0.127931, 0, -1, -1, 0.390304) , 
NN(
NN(
NN(
0, 
0, 
-1.47747, 0, -1, -1, 0.342714) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.656214) , 
0.09974, 1, 3, 0, 0.492199) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.819041) , 
0.48441, 0, 1, 0, 0.580681) , 
0.868377, 0, 1, 0, 0.465609) , 
0.402261, 1, 1, 0, 0.427747) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.173206) , 
NN(
0, 
0, 
-1.11623, 0, -1, 1, 0.562947) , 
-1.06849, 1, 3, 0, 0.546778) , 
-0.622586, 0, 1, 0, 0.451249) , 
-1.41512, 1, 1, 0, 0.437876) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.592198) , 
-1.91868, 0, 1, 0, 0.446139) , 
NN(
0, 
0, 
-1.16848, 0, -1, 1, 0.613684) , 
2.09918, 1, 1, 0, 0.45571) , 
NN(
0, 
0, 
0.372366, 0, -1, 1, 0.65457) , 
1.1621, 1, 3, 0, 0.462949)    );
  // itree = 73
  fBoostWeights.push_back(0.828183);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.380717, 1, -1, -1, 0.282723) , 
NN(
0, 
0, 
1.77632, 1, -1, 1, 0.604915) , 
1.00652, 1, 2, 0, 0.357926) , 
NN(
NN(
0, 
0, 
0.481326, 0, -1, -1, 0.369711) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.2316) , 
NN(
NN(
0, 
0, 
0.243943, 0, -1, -1, 0.440821) , 
NN(
0, 
0, 
0.280508, 0, -1, 1, 0.528158) , 
-0.214186, 1, 3, 0, 0.495147) , 
0.306048, 0, 0, 0, 0.471099) , 
NN(
0, 
0, 
-0.846437, 0, -1, 1, 0.545914) , 
0.474563, 1, 0, 0, 0.495069) , 
-1.79392, 1, 1, 0, 0.485946) , 
1.86861, 0, 0, 0, 0.473522) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.695792) , 
2.4829, 1, 1, 0, 0.481764)    );
  // itree = 74
  fBoostWeights.push_back(0.833253);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-2.45561, 0, -1, -1, 0.307068) , 
NN(
0, 
0, 
-1.90764, 0, -1, 1, 0.503257) , 
-0.538817, 1, 2, 0, 0.393264) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.0291062, 1, -1, -1, 0.439632) , 
NN(
0, 
0, 
0.520198, 0, -1, 1, 0.622547) , 
-0.648855, 0, 2, 0, 0.46013) , 
NN(
0, 
0, 
2.51019, 0, -1, 1, 0.648794) , 
2.16996, 1, 0, 0, 0.476972) , 
NN(
NN(
0, 
0, 
-0.545129, 0, -1, -1, 0.387647) , 
NN(
0, 
0, 
0.441962, 0, -1, 1, 0.62248) , 
-0.358798, 1, 3, 0, 0.560168) , 
-0.299574, 0, 0, 0, 0.502645) , 
-1.40897, 1, 0, 0, 0.48759)    );
  // itree = 75
  fBoostWeights.push_back(0.762275);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.393464) , 
NN(
NN(
NN(
0, 
0, 
1.24781, 1, -1, -1, 0.399595) , 
NN(
NN(
0, 
0, 
-1.70875, 0, -1, -1, 0.391577) , 
NN(
0, 
0, 
-0.558996, 0, -1, 1, 0.552064) , 
-0.819081, 1, 3, 0, 0.503638) , 
0.946333, 0, 1, 0, 0.469495) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.737852) , 
0.243403, 1, 2, 0, 0.497034) , 
0.123733, 0, 3, 0, 0.479156) , 
-2.4111, 1, 3, 0, 0.474507) , 
NN(
0, 
0, 
-0.11146, 1, -1, 1, 0.617356) , 
0.5431, 1, 0, 0, 0.507394) , 
NN(
0, 
0, 
-1.5062, 0, -1, 1, 0.609608) , 
0.32752, 1, 3, 0, 0.546489)    );
  // itree = 76
  fBoostWeights.push_back(0.823087);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.180946) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.149816) , 
NN(
NN(
0, 
0, 
-1.79294, 0, 0, -1, 0) , 
NN(
0, 
0, 
-0.594415, 0, -1, -1, 0.372995) , 
-1.1253, 1, 3, 0, 0.356487) , 
0.612179, 0, 0, 0, 0.306243) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.570808) , 
-0.0159147, 1, 2, 0, 0.382777) , 
NN(
0, 
0, 
-1.34255, 1, -1, 1, 0.512236) , 
-1.1399, 0, 2, 0, 0.416481) , 
2.27403, 0, 1, 0, 0.391281) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.553453) , 
-0.216984, 1, 3, 0, 0.425202) , 
NN(
0, 
0, 
0.193974, 1, -1, 1, 0.568825) , 
-0.0897679, 1, 3, 0, 0.51169)    );
  // itree = 77
  fBoostWeights.push_back(0.766611);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.586885, 0, -1, -1, 0.378819) , 
NN(
0, 
0, 
0.193974, 1, -1, 1, 0.545379) , 
-0.0897679, 1, 3, 0, 0.478062)    );
  // itree = 78
  fBoostWeights.push_back(0.732131);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
2.31991, 1, -1, -1, 0.360435) , 
NN(
0, 
0, 
0.688824, 0, -1, -1, 0.490397) , 
0.377241, 1, 2, 0, 0.407765) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.182346) , 
NN(
NN(
0, 
0, 
0.305233, 1, -1, -1, 0.408272) , 
NN(
NN(
NN(
0, 
0, 
0.523954, 0, -1, -1, 0.479912) , 
NN(
0, 
0, 
0.744332, 0, -1, 1, 0.645951) , 
0.659289, 1, 3, 0, 0.510389) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.693402) , 
-1.32964, 0, 0, 0, 0.527072) , 
-0.404037, 1, 3, 0, 0.505291) , 
3.16633, 0, 0, 0, 0.499167) , 
0.948007, 0, 1, 0, 0.473074)    );
  // itree = 79
  fBoostWeights.push_back(0.811828);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.55534, 1, -1, -1, 0.349551) , 
NN(
NN(
NN(
0, 
0, 
-0.11382, 0, -1, -1, 0.375055) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.368333) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.97568, 0, -1, -1, 0.303278) , 
NN(
NN(
0, 
0, 
0.898718, 1, -1, -1, 0.378282) , 
NN(
0, 
0, 
0.014757, 1, -1, 1, 0.537261) , 
0.45158, 0, 2, 0, 0.495312) , 
-1.14326, 1, 3, 0, 0.482291) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.752124) , 
0.112529, 0, 1, 0, 0.498758) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.738484) , 
1.02966, 1, 1, 0, 0.517841) , 
1.24522, 0, 1, 0, 0.495664) , 
0.0292537, 1, 1, 0, 0.462923) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.367228) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.337129) , 
NN(
0, 
0, 
-1.03532, 1, -1, 1, 0.575093) , 
-0.372089, 0, 3, 0, 0.468022) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.774017) , 
-0.552656, 1, 0, 0, 0.553391) , 
0.199519, 0, 2, 0, 0.489896) , 
NN(
0, 
0, 
1.62967, 0, -1, 1, 0.626049) , 
0.142633, 1, 0, 0, 0.541958) , 
-0.603799, 0, 1, 0, 0.490001) , 
1.34723, 0, 1, 0, 0.47139) , 
NN(
0, 
0, 
-0.703647, 1, -1, 1, 0.671771) , 
2.09918, 1, 1, 0, 0.483024)    );
  // itree = 80
  fBoostWeights.push_back(0.701083);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.29858) , 
NN(
NN(
0, 
0, 
0.43338, 1, -1, -1, 0.394265) , 
NN(
0, 
0, 
-0.173495, 0, -1, 1, 0.511125) , 
-0.451008, 1, 3, 0, 0.477292) , 
1.82279, 0, 0, 0, 0.46327) , 
NN(
NN(
0, 
0, 
-0.355748, 0, -1, 1, 0.536965) , 
NN(
0, 
0, 
0.777311, 0, -1, 1, 0.695683) , 
0.810201, 1, 3, 0, 0.582368) , 
0.437295, 1, 2, 0, 0.497964)    );
  // itree = 81
  fBoostWeights.push_back(0.775515);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.160199, 1, -1, -1, 0.426238) , 
NN(
0, 
0, 
1.53689, 0, -1, 1, 0.657251) , 
0.99068, 1, 3, 0, 0.444503) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.357717) , 
NN(
0, 
0, 
0.126029, 1, -1, 1, 0.509775) , 
0.285218, 0, 3, 0, 0.482636) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.691249) , 
-0.462535, 1, 0, 0, 0.509162) , 
-0.316443, 0, 0, 0, 0.469982) , 
NN(
NN(
0, 
0, 
-1.56759, 1, -1, -1, 0.309139) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.337977) , 
NN(
0, 
0, 
-1.63532, 1, -1, 1, 0.632687) , 
-0.844431, 1, 3, 0, 0.596011) , 
1.26686, 0, 0, 0, 0.558261) , 
-0.970608, 0, 1, 0, 0.48558)    );
  // itree = 82
  fBoostWeights.push_back(0.792111);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.29876, 0, -1, -1, 0.398726) , 
NN(
0, 
0, 
0.923178, 0, -1, 1, 0.661727) , 
0.793216, 1, 3, 0, 0.413992) , 
NN(
0, 
0, 
1.28503, 0, -1, 1, 0.68639) , 
1.21582, 1, 2, 0, 0.427217) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.250066) , 
NN(
0, 
0, 
1.06313, 1, -1, 1, 0.685291) , 
0.145007, 1, 3, 0, 0.398599) , 
NN(
NN(
NN(
NN(
0, 
0, 
1.13173, 0, -1, -1, 0.219393) , 
NN(
NN(
NN(
0, 
0, 
0.156759, 0, -1, -1, 0.42027) , 
NN(
0, 
0, 
1.21113, 0, -1, 1, 0.699033) , 
0.852942, 1, 3, 0, 0.447411) , 
NN(
0, 
0, 
1.22224, 1, -1, 1, 0.608422) , 
-0.133841, 0, 2, 0, 0.486604) , 
-1.60352, 1, 3, 0, 0.474152) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.717957) , 
2.60362, 1, 1, 0, 0.489022) , 
NN(
NN(
0, 
0, 
-0.843424, 0, -1, -1, 0.384395) , 
NN(
0, 
0, 
0.393205, 1, -1, 1, 0.694756) , 
-0.158763, 1, 3, 0, 0.605938) , 
0.565225, 0, 1, 0, 0.534665) , 
0.099142, 1, 1, 0, 0.5231) , 
-0.203162, 1, 1, 0, 0.487275)    );
  // itree = 83
  fBoostWeights.push_back(0.81288);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.383078, 0, -1, -1, 0.334226) , 
NN(
0, 
0, 
0.333311, 0, -1, 1, 0.506844) , 
0.385022, 1, 3, 0, 0.395616) , 
NN(
NN(
NN(
0, 
0, 
-0.884906, 0, -1, -1, 0.340288) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.52749) , 
-0.424799, 1, 2, 0, 0.444635) , 
NN(
0, 
0, 
-0.703049, 1, -1, 1, 0.603157) , 
-1.04664, 1, 0, 0, 0.516267) , 
-0.483897, 0, 0, 0, 0.443055) , 
NN(
0, 
0, 
2.11476, 0, -1, 1, 0.739047) , 
1.27475, 1, 3, 0, 0.453266) , 
NN(
NN(
0, 
0, 
2.6955, 1, -1, -1, 0.420122) , 
NN(
NN(
0, 
0, 
2.32104, 0, -1, -1, 0.462248) , 
NN(
0, 
0, 
0.255626, 1, -1, 1, 0.597778) , 
-0.277011, 1, 3, 0, 0.559137) , 
1.86861, 0, 0, 0, 0.543893) , 
0.180561, 1, 1, 0, 0.502299)    );
  // itree = 84
  fBoostWeights.push_back(0.700794);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.578, 1, -1, -1, 0.449034) , 
NN(
NN(
NN(
0, 
0, 
-0.791848, 0, -1, -1, 0.276725) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.275371) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.401368) , 
NN(
NN(
0, 
0, 
-0.621108, 0, -1, -1, 0.420371) , 
NN(
0, 
0, 
0.120089, 0, -1, 1, 0.651274) , 
-0.298203, 1, 2, 0, 0.568767) , 
-1.97021, 1, 1, 0, 0.542551) , 
-0.568338, 0, 1, 0, 0.517014) , 
-0.481252, 0, 1, 0, 0.478059) , 
NN(
NN(
0, 
0, 
1.86005, 1, -1, 1, 0.500144) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.446683) , 
NN(
NN(
0, 
0, 
0.212361, 1, -1, 1, 0.58775) , 
NN(
NN(
0, 
0, 
-2.67845, 1, -1, 1, 0.583801) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.828562) , 
-0.416759, 1, 3, 0, 0.716871) , 
0.178478, 0, 0, 0, 0.634053) , 
0.75492, 0, 1, 0, 0.619093) , 
0.904934, 0, 1, 0, 0.569638) , 
-0.203162, 1, 1, 0, 0.534759) , 
0.437295, 0, 2, 0, 0.51013)    );
  // itree = 85
  fBoostWeights.push_back(0.827566);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.13858, 0, -1, -1, 0.446619) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.347906) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.166871) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.248534) , 
NN(
NN(
NN(
NN(
0, 
0, 
1.77083, 1, -1, -1, 0.235159) , 
NN(
NN(
NN(
NN(
0, 
0, 
1.12325, 1, -1, -1, 0.361221) , 
NN(
0, 
0, 
2.94352, 0, -1, 1, 0.671509) , 
0.952795, 1, 3, 0, 0.411803) , 
NN(
0, 
0, 
0.54427, 0, -1, 1, 0.600907) , 
0.788543, 1, 1, 0, 0.467238) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
-0.816608, 0, 1, 0, 0.480633) , 
-1.23118, 1, 1, 0, 0.45777) , 
NN(
0, 
0, 
0.129035, 0, -1, 1, 0.70866) , 
0.783191, 0, 0, 0, 0.506525) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.755795) , 
-0.111541, 0, 2, 0, 0.554322) , 
-0.328375, 1, 3, 0, 0.526906) , 
0.446765, 1, 0, 0, 0.494182) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.283981) , 
NN(
NN(
0, 
0, 
-1.59313, 0, -1, -1, 0.356459) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.43791) , 
NN(
NN(
0, 
0, 
-0.494672, 0, -1, 1, 0.574997) , 
NN(
0, 
0, 
-0.17646, 1, -1, 1, 0.687569) , 
0.111516, 1, 3, 0, 0.621059) , 
0.830447, 0, 2, 0, 0.591558) , 
-0.963537, 1, 3, 0, 0.579054) , 
-0.665794, 1, 1, 0, 0.536465) , 
NN(
0, 
0, 
0.521957, 0, -1, 1, 0.684668) , 
-1.05552, 0, 1, 0, 0.563205) , 
0.327412, 0, 0, 0, 0.529827) , 
2.09918, 0, 1, 0, 0.523209) , 
-1.40897, 1, 0, 0, 0.512161)    );
  // itree = 86
  fBoostWeights.push_back(0.744819);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.3159, 1, -1, -1, 0.439998) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.317088) , 
NN(
NN(
NN(
0, 
0, 
-0.0632695, 0, -1, -1, 0.441778) , 
NN(
NN(
0, 
0, 
-1.59212, 0, -1, -1, 0.448907) , 
NN(
NN(
0, 
0, 
-0.628793, 0, -1, 1, 0.512931) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.734377) , 
-0.163591, 1, 3, 0, 0.570504) , 
-1.09215, 1, 1, 0, 0.54081) , 
0.060945, 0, 2, 0, 0.508908) , 
NN(
0, 
0, 
0.0759488, 1, -1, 1, 0.615508) , 
0.270481, 1, 3, 0, 0.541669) , 
0.756156, 0, 2, 0, 0.530774) , 
0.948007, 0, 1, 0, 0.506655) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.464683) , 
NN(
0, 
0, 
1.03049, 1, -1, 1, 0.700654) , 
0.649572, 1, 3, 0, 0.635283) , 
0.853908, 1, 2, 0, 0.521314)    );
  // itree = 87
  fBoostWeights.push_back(0.736109);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.285178, 0, -1, -1, 0.348623) , 
NN(
NN(
0, 
0, 
-0.176494, 0, -1, -1, 0.386039) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.156124) , 
NN(
NN(
NN(
0, 
0, 
0.00276376, 1, -1, -1, 0.295433) , 
NN(
0, 
0, 
0.522277, 0, -1, -1, 0.491202) , 
-0.463535, 1, 3, 0, 0.475213) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.46502) , 
NN(
0, 
0, 
-1.11677, 1, -1, 1, 0.695437) , 
-0.48734, 0, 3, 0, 0.518921) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.707105) , 
-0.438639, 1, 0, 0, 0.560304) , 
-0.221034, 0, 0, 0, 0.500197) , 
-1.00904, 1, 0, 0, 0.484789) , 
NN(
NN(
0, 
0, 
0.325443, 0, -1, -1, 0.358076) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.703849) , 
-0.906233, 1, 3, 0, 0.593718) , 
-1.14072, 0, 0, 0, 0.495075) , 
-1.51812, 1, 0, 0, 0.480882) , 
-1.35433, 1, 1, 0, 0.465974) , 
NN(
0, 
0, 
0.691709, 0, -1, 1, 0.617055) , 
0.70125, 1, 2, 0, 0.477111) , 
NN(
0, 
0, 
1.03049, 1, -1, 1, 0.623729) , 
0.853908, 1, 2, 0, 0.493588)    );
  // itree = 88
  fBoostWeights.push_back(0.710627);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.354845) , 
NN(
NN(
0, 
0, 
-0.736379, 0, -1, -1, 0.405837) , 
NN(
0, 
0, 
0.852507, 1, -1, 1, 0.515452) , 
-0.343006, 1, 3, 0, 0.477828) , 
0.334297, 0, 2, 0, 0.46592) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.868751) , 
-3.42721, 0, 0, 0, 0.469284) , 
NN(
0, 
0, 
-0.168967, 0, -1, 1, 0.57049) , 
0.437295, 1, 2, 0, 0.499339)    );
  // itree = 89
  fBoostWeights.push_back(0.735203);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
2.03131, 0, -1, -1, 0.332928) , 
NN(
NN(
0, 
0, 
-1.22505, 1, -1, -1, 0.321286) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.0798105, 0, -1, -1, 0.24287) , 
NN(
NN(
0, 
0, 
-0.0245105, 0, -1, -1, 0.449824) , 
NN(
0, 
0, 
-0.928439, 1, -1, 1, 0.5778) , 
-0.361428, 0, 3, 0, 0.488924) , 
0.208789, 1, 1, 0, 0.435425) , 
NN(
0, 
0, 
0.397093, 1, -1, 1, 0.607847) , 
1.07573, 1, 0, 0, 0.474514) , 
NN(
NN(
0, 
0, 
-1.7063, 1, -1, 1, 0.521266) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.871365) , 
0.776816, 1, 3, 0, 0.544973) , 
-0.114916, 0, 1, 0, 0.50545) , 
NN(
0, 
0, 
0.422005, 1, -1, 1, 0.616555) , 
0.915234, 1, 2, 0, 0.516965) , 
-2.19768, 1, 0, 0, 0.509095) , 
1.68312, 0, 1, 0, 0.494173) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.759641) , 
2.4829, 1, 1, 0, 0.499132)    );
  // itree = 90
  fBoostWeights.push_back(0.765716);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.157119, 0, -1, -1, 0.364664) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.17799, 0, -1, -1, 0.364844) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.198071) , 
NN(
NN(
NN(
0, 
0, 
-1.44763, 0, -1, -1, 0.42437) , 
NN(
0, 
0, 
0.474292, 0, -1, 1, 0.556995) , 
0.244656, 1, 2, 0, 0.460216) , 
NN(
0, 
0, 
-0.647463, 1, -1, 1, 0.652419) , 
0.659011, 1, 1, 0, 0.484684) , 
0.91388, 0, 0, 0, 0.469482) , 
NN(
0, 
0, 
0.0242465, 1, -1, 1, 0.731496) , 
0.949881, 1, 2, 0, 0.487186) , 
0.911829, 0, 1, 0, 0.457252) , 
NN(
0, 
0, 
2.00284, 0, -1, 1, 0.595868) , 
1.66015, 1, 1, 0, 0.476448) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.822579) , 
1.10256, 1, 0, 0, 0.488681) , 
1.28982, 0, 0, 0, 0.469086) , 
NN(
0, 
0, 
2.09834, 0, -1, 1, 0.786326) , 
1.57938, 1, 3, 0, 0.474141) , 
NN(
NN(
NN(
0, 
0, 
-0.210824, 0, -1, -1, 0.480233) , 
NN(
0, 
0, 
1.93417, 0, -1, 1, 0.78482) , 
0.622144, 1, 2, 0, 0.527211) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.687702) , 
-2.05293, 0, 1, 0, 0.565686) , 
-0.970608, 0, 1, 0, 0.49108)    );
  // itree = 91
  fBoostWeights.push_back(0.739909);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.336253) , 
NN(
NN(
0, 
0, 
-1.57855, 0, -1, -1, 0.482119) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.219652) , 
NN(
NN(
NN(
0, 
0, 
-0.687451, 1, -1, -1, 0.423165) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.627685) , 
-0.221418, 1, 3, 0, 0.521802) , 
NN(
0, 
0, 
-0.244849, 0, -1, 1, 0.598545) , 
-0.0109767, 1, 3, 0, 0.57254) , 
1.42803, 0, 1, 0, 0.553264) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.67185) , 
1.76945, 1, 1, 0, 0.564443) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.544102) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.784521) , 
-0.38975, 1, 3, 0, 0.703628) , 
-1.64328, 0, 0, 0, 0.573658) , 
-0.812543, 1, 2, 0, 0.560612) , 
-2.5055, 1, 1, 0, 0.555747)    );
  // itree = 92
  fBoostWeights.push_back(0.824653);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.828316, 1, -1, -1, 0.407474) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.253869) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.171087) , 
NN(
NN(
0, 
0, 
-1.25357, 0, -1, -1, 0.406887) , 
NN(
0, 
0, 
-0.790493, 1, -1, 1, 0.552599) , 
-0.824622, 1, 3, 0, 0.474442) , 
2.14785, 0, 1, 0, 0.449476) , 
NN(
0, 
0, 
-0.718561, 1, -1, 1, 0.627708) , 
-0.553849, 1, 2, 0, 0.499596) , 
0.230113, 0, 0, 0, 0.458624) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.722248) , 
0.760086, 1, 0, 0, 0.494559) , 
-0.170559, 0, 2, 0, 0.452337) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.704064) , 
0.196767, 1, 3, 0, 0.471452) , 
NN(
0, 
0, 
1.38745, 0, -1, 1, 0.576043) , 
0.32752, 1, 3, 0, 0.508962)    );
  // itree = 93
  fBoostWeights.push_back(0.810276);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.30328, 0, -1, -1, 0.336218) , 
NN(
NN(
0, 
0, 
-1.01851, 0, -1, -1, 0.38007) , 
NN(
0, 
0, 
-0.176028, 1, -1, 1, 0.621887) , 
-0.432274, 1, 3, 0, 0.505965) , 
0.882574, 0, 1, 0, 0.451358) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
1.99226, 1, -1, -1, 0.473372) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.179346) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.0075735) , 
NN(
0, 
0, 
0.640165, 0, -1, 1, 0.700834) , 
-0.366793, 1, 3, 0, 0.644449) , 
2.00823, 0, 0, 0, 0.576257) , 
-0.0347362, 0, 1, 0, 0.494996) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.89607, 1, 2, 0, 0.499402) , 
NN(
NN(
0, 
0, 
-0.587315, 0, -1, -1, 0.427849) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.804535) , 
-0.156324, 1, 3, 0, 0.629882) , 
-0.43138, 0, 0, 0, 0.523807) , 
NN(
NN(
0, 
0, 
-0.277109, 1, -1, 1, 0.5787) , 
NN(
0, 
0, 
0.744332, 0, -1, 1, 0.783621) , 
0.660757, 1, 3, 0, 0.609174) , 
-0.586885, 0, 1, 0, 0.544946) , 
-0.862707, 1, 0, 0, 0.520335)    );
  // itree = 94
  fBoostWeights.push_back(0.782629);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.200225) , 
NN(
NN(
0, 
0, 
1.53609, 1, -1, -1, 0.328157) , 
NN(
0, 
0, 
0.0646485, 1, -1, -1, 0.490185) , 
-1.04375, 1, 3, 0, 0.462147) , 
-1.33166, 1, 1, 0, 0.417715) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.258203) , 
NN(
NN(
0, 
0, 
-0.458261, 0, -1, -1, 0.377818) , 
NN(
0, 
0, 
-0.193135, 1, -1, 1, 0.599741) , 
-0.0684208, 1, 3, 0, 0.493698) , 
1.23518, 0, 1, 0, 0.446607) , 
NN(
0, 
0, 
0.502494, 0, -1, 1, 0.655294) , 
-0.716346, 0, 2, 0, 0.510761) , 
NN(
0, 
0, 
-0.144654, 1, -1, 1, 0.601082) , 
0.0344666, 1, 2, 0, 0.564714) , 
-0.862707, 1, 0, 0, 0.525157)    );
  // itree = 95
  fBoostWeights.push_back(0.772621);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.936519, 1, -1, -1, 0.364203) , 
NN(
0, 
0, 
1.14407, 0, -1, 1, 0.544948) , 
0.810201, 1, 3, 0, 0.412497) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.13455) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.25566) , 
NN(
NN(
0, 
0, 
-0.66377, 0, -1, -1, 0.325863) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.570463) , 
-0.468951, 1, 2, 0, 0.471197) , 
-0.909626, 0, 0, 0, 0.402811) , 
NN(
0, 
0, 
0.722123, 0, -1, 1, 0.553007) , 
-0.558085, 1, 0, 0, 0.476811) , 
-0.299237, 0, 1, 0, 0.460729) , 
NN(
0, 
0, 
0.30059, 0, -1, 1, 0.547616) , 
-0.203162, 1, 1, 0, 0.515247) , 
0.437295, 0, 2, 0, 0.484493)    );
  // itree = 96
  fBoostWeights.push_back(0.721271);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.951483, 1, -1, -1, 0.424676) , 
NN(
NN(
NN(
0, 
0, 
-0.445636, 1, -1, -1, 0.444107) , 
NN(
NN(
0, 
0, 
0.756684, 0, -1, -1, 0.142592) , 
NN(
NN(
NN(
0, 
0, 
-1.15481, 0, -1, -1, 0.269188) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.56517) , 
-0.841816, 1, 3, 0, 0.466229) , 
NN(
0, 
0, 
-0.252497, 0, -1, 1, 0.581484) , 
-0.586885, 1, 1, 0, 0.543968) , 
-2.22416, 1, 3, 0, 0.536913) , 
-0.279726, 0, 2, 0, 0.48885) , 
NN(
0, 
0, 
0.242638, 0, -1, 1, 0.648084) , 
0.20641, 1, 3, 0, 0.522435) , 
0.437295, 0, 2, 0, 0.493846)    );
  // itree = 97
  fBoostWeights.push_back(0.715501);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.293216) , 
NN(
NN(
0, 
0, 
-0.93301, 1, -1, -1, 0.363121) , 
NN(
NN(
0, 
0, 
-0.425489, 0, -1, -1, 0.480287) , 
NN(
0, 
0, 
0.013, 1, -1, 1, 0.54771) , 
0.218166, 0, 3, 0, 0.520489) , 
-1.34163, 1, 3, 0, 0.51337) , 
-1.67215, 1, 1, 0, 0.502078) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.705803) , 
-2.12178, 0, 1, 0, 0.509046)    );
  // itree = 98
  fBoostWeights.push_back(0.750658);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.17465, 1, -1, -1, 0.441732) , 
NN(
0, 
0, 
0.456863, 0, -1, 1, 0.521629) , 
-0.324807, 1, 3, 0, 0.488481) , 
NN(
0, 
0, 
-2.14924, 0, -1, 1, 0.566709) , 
0.32752, 1, 3, 0, 0.516177)    );
  // itree = 99
  fBoostWeights.push_back(0.743418);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.09479, 1, -1, -1, 0.316398) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.321321) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.360015) , 
NN(
NN(
NN(
0, 
0, 
-1.36315, 0, -1, -1, 0.258874) , 
NN(
NN(
0, 
0, 
-0.13411, 1, -1, -1, 0.374471) , 
NN(
NN(
0, 
0, 
-0.694672, 1, -1, -1, 0.463609) , 
NN(
NN(
0, 
0, 
0.335899, 0, -1, -1, 0.453711) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.803684) , 
-0.846099, 1, 3, 0, 0.650513) , 
-0.152262, 0, 0, 0, 0.571809) , 
-1.36154, 1, 0, 0, 0.496389) , 
-0.620634, 0, 2, 0, 0.438243) , 
NN(
0, 
0, 
-0.793055, 0, -1, 1, 0.540963) , 
-0.303825, 1, 2, 0, 0.490493) , 
0.165866, 0, 3, 0, 0.471725) , 
NN(
0, 
0, 
-1.61457, 1, -1, 1, 0.691114) , 
-2.60336, 0, 0, 0, 0.47819) , 
NN(
0, 
0, 
0.195392, 0, -1, 1, 0.737374) , 
0.414244, 1, 3, 0, 0.502966) , 
1.24684, 0, 0, 0, 0.494286) , 
NN(
0, 
0, 
-0.257399, 0, -1, 1, 0.596892) , 
0.437295, 1, 2, 0, 0.52112) , 
1.86861, 0, 0, 0, 0.504633)    );
  // itree = 100
  fBoostWeights.push_back(0.735332);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.203162, 1, -1, -1, 0.45031) , 
NN(
NN(
NN(
0, 
0, 
1.81853, 0, -1, -1, 0.44948) , 
NN(
0, 
0, 
2.33235, 0, -1, 1, 0.679475) , 
0.916722, 1, 3, 0, 0.48657) , 
NN(
0, 
0, 
0.1414, 0, -1, 1, 0.655806) , 
0.0985762, 0, 2, 0, 0.533911) , 
-0.0897679, 1, 3, 0, 0.496734)    );
  // itree = 101
  fBoostWeights.push_back(0.748165);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.901515, 0, -1, -1, 0.267021) , 
NN(
0, 
0, 
-0.820808, 0, -1, -1, 0.395023) , 
-0.696443, 1, 2, 0, 0.335352) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.626143) , 
0.193889, 1, 3, 0, 0.383967) , 
NN(
0, 
0, 
-0.882952, 0, -1, 1, 0.56928) , 
1.51521, 1, 1, 0, 0.429357) , 
NN(
NN(
0, 
0, 
-0.343874, 0, -1, -1, 0.399811) , 
NN(
NN(
NN(
0, 
0, 
0.360774, 1, -1, -1, 0.373089) , 
NN(
NN(
NN(
0, 
0, 
-0.162394, 1, -1, -1, 0.415593) , 
NN(
0, 
0, 
-0.692276, 0, -1, 1, 0.643727) , 
0.65325, 1, 3, 0, 0.497352) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.814498) , 
-0.111243, 0, 2, 0, 0.567042) , 
0.422896, 0, 1, 0, 0.488067) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.675967, 0, -1, -1, 0.409164) , 
NN(
0, 
0, 
0.831273, 0, -1, 1, 0.737626) , 
0.606922, 1, 3, 0, 0.497016) , 
NN(
0, 
0, 
0.664161, 0, -1, 1, 0.700359) , 
0.430043, 1, 1, 0, 0.577969) , 
NN(
0, 
0, 
0.247295, 0, -1, 1, 0.691162) , 
0.062576, 0, 2, 0, 0.625554) , 
0.715526, 0, 0, 0, 0.565686) , 
-0.460203, 1, 3, 0, 0.546655) , 
-0.862707, 1, 0, 0, 0.515412)    );
  // itree = 102
  fBoostWeights.push_back(0.78237);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.974555, 0, -1, -1, 0.291098) , 
NN(
NN(
0, 
0, 
0.396755, 1, -1, -1, 0.398322) , 
NN(
NN(
0, 
0, 
-1.84318, 0, -1, -1, 0.218752) , 
NN(
0, 
0, 
-0.478737, 1, -1, 1, 0.655728) , 
-1.18052, 1, 3, 0, 0.587681) , 
-0.00417376, 0, 2, 0, 0.453502) , 
2.03305, 0, 1, 0, 0.41047) , 
NN(
NN(
0, 
0, 
-1.70183, 0, -1, -1, 0.343138) , 
NN(
NN(
0, 
0, 
-0.271651, 0, -1, -1, 0.405921) , 
NN(
NN(
0, 
0, 
0.951483, 1, -1, 1, 0.516444) , 
NN(
0, 
0, 
0.199802, 1, -1, 1, 0.618939) , 
0.442639, 0, 3, 0, 0.583089) , 
-0.435273, 1, 3, 0, 0.569164) , 
-0.689726, 1, 2, 0, 0.52879) , 
0.948007, 0, 1, 0, 0.49561)    );
  // itree = 103
  fBoostWeights.push_back(0.771837);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.203389) , 
NN(
NN(
NN(
0, 
0, 
-1.82921, 0, -1, -1, 0.394044) , 
NN(
NN(
0, 
0, 
0.242553, 0, -1, -1, 0.456709) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.639502) , 
-0.232107, 1, 3, 0, 0.50749) , 
-0.150767, 1, 1, 0, 0.442714) , 
NN(
0, 
0, 
0.301338, 0, -1, 1, 0.545237) , 
0.44922, 1, 0, 0, 0.468862) , 
2.09918, 0, 1, 0, 0.452693) , 
NN(
NN(
0, 
0, 
1.27611, 1, -1, -1, 0.481122) , 
NN(
NN(
NN(
0, 
0, 
1.82887, 1, -1, -1, 0.266921) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.346067) , 
NN(
0, 
0, 
1.80786, 1, -1, 1, 0.698945) , 
0.80299, 1, 3, 0, 0.507911) , 
NN(
0, 
0, 
0.241923, 1, -1, 1, 0.664251) , 
0.556802, 0, 2, 0, 0.608301) , 
-1.18469, 1, 1, 0, 0.584293) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.965624) , 
0.636773, 0, 0, 0, 0.613098) , 
0.491022, 1, 0, 0, 0.534504) , 
0.0206825, 1, 2, 0, 0.497386)    );
  // itree = 104
  fBoostWeights.push_back(0.671825);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.268469, 0, -1, -1, 0.356564) , 
NN(
NN(
NN(
0, 
0, 
-0.342972, 1, -1, -1, 0.36227) , 
NN(
0, 
0, 
-1.68158, 1, -1, -1, 0.489672) , 
-0.514317, 0, 3, 0, 0.43835) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
-0.0886442, 0, -1, 1, 0.597477) , 
-0.572701, 1, 3, 0, 0.565788) , 
0.44922, 1, 0, 0, 0.469871) , 
-0.111734, 0, 2, 0, 0.444873) , 
NN(
NN(
NN(
0, 
0, 
-1.91847, 0, -1, -1, 0.340811) , 
NN(
NN(
NN(
0, 
0, 
1.39096, 1, -1, -1, 0.42438) , 
NN(
0, 
0, 
0.322343, 0, -1, 1, 0.55681) , 
0.515513, 0, 3, 0, 0.514676) , 
NN(
NN(
NN(
0, 
0, 
0.269258, 1, -1, 1, 0.545327) , 
NN(
0, 
0, 
1.56112, 0, -1, 1, 0.788352) , 
0.973289, 1, 3, 0, 0.579403) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.836103) , 
0.143494, 1, 1, 0, 0.643197) , 
0.271817, 0, 1, 0, 0.574593) , 
-1.42804, 1, 1, 0, 0.553995) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.732486) , 
0.100628, 0, 2, 0, 0.571338) , 
0.0206825, 1, 2, 0, 0.514302)    );
  // itree = 105
  fBoostWeights.push_back(0.754691);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.125148, 1, -1, -1, 0.372402) , 
NN(
0, 
0, 
-0.698968, 1, -1, -1, 0.463444) , 
-0.357434, 0, 3, 0, 0.4125) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.60804) , 
-1.73805, 0, 1, 0, 0.42722) , 
NN(
NN(
0, 
0, 
0.216616, 1, -1, 1, 0.505115) , 
NN(
0, 
0, 
1.3257, 0, -1, 1, 0.627318) , 
0.0783247, 1, 3, 0, 0.592324) , 
0.0206825, 1, 2, 0, 0.517919)    );
  // itree = 106
  fBoostWeights.push_back(0.810409);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
-0.0945803, 0, -1, -1, 0.437165) , 
-0.328641, 1, 3, 0, 0.410844) , 
NN(
NN(
0, 
0, 
-0.131078, 0, -1, -1, 0.463858) , 
NN(
0, 
0, 
0.160259, 0, -1, 1, 0.615269) , 
0.000253513, 1, 2, 0, 0.517574) , 
0.868241, 0, 0, 0, 0.498381) , 
NN(
0, 
0, 
0.578, 1, -1, 1, 0.588385) , 
0.437295, 1, 2, 0, 0.52113)    );
  // itree = 107
  fBoostWeights.push_back(0.81425);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.2108, 1, -1, -1, 0.43614) , 
NN(
NN(
0, 
0, 
-1.2202, 0, -1, -1, 0.436385) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.873776) , 
-0.728335, 1, 2, 0, 0.626354) , 
-1.90801, 0, 0, 0, 0.456643) , 
NN(
0, 
0, 
-0.586123, 1, -1, 1, 0.667477) , 
1.71545, 1, 1, 0, 0.481933) , 
NN(
0, 
0, 
1.06593, 0, -1, 1, 0.582725) , 
0.32752, 1, 3, 0, 0.516388)    );
  // itree = 108
  fBoostWeights.push_back(0.780732);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.840919, 0, -1, -1, 0.41549) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.335369) , 
NN(
NN(
0, 
0, 
-0.97268, 0, -1, -1, 0.454727) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.263096) , 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.183646) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.80689) , 
0.501929, 1, 3, 0, 0.332952) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.190381) , 
NN(
0, 
0, 
0.282171, 0, -1, 1, 0.522098) , 
0.830708, 1, 3, 0, 0.38883) , 
NN(
0, 
0, 
0.213459, 1, -1, 1, 0.559058) , 
0.725897, 0, 2, 0, 0.503438) , 
0.689147, 0, 1, 0, 0.459031) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.625192) , 
1.29986, 1, 1, 0, 0.496526) , 
NN(
0, 
0, 
0.405017, 0, -1, 1, 0.625335) , 
-0.581814, 0, 1, 0, 0.522109) , 
NN(
0, 
0, 
0.0710343, 1, -1, 1, 0.656558) , 
-0.132363, 0, 2, 0, 0.540883) , 
-1.47833, 1, 1, 0, 0.528726) , 
-0.192963, 1, 3, 0, 0.511301) , 
-1.79942, 1, 1, 0, 0.503687) , 
-0.507056, 1, 3, 0, 0.487792) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.822862) , 
-2.42611, 0, 1, 0, 0.494574) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.750514) , 
2.4829, 1, 1, 0, 0.502654)    );
  // itree = 109
  fBoostWeights.push_back(0.782454);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
2.13088, 1, -1, -1, 0.333903) , 
NN(
NN(
NN(
0, 
0, 
0.029653, 1, -1, -1, 0.275266) , 
NN(
NN(
0, 
0, 
-0.318724, 1, -1, -1, 0.466078) , 
NN(
0, 
0, 
-1.92945, 1, -1, 1, 0.58876) , 
-0.900376, 0, 2, 0, 0.496294) , 
-0.421703, 0, 1, 0, 0.443638) , 
NN(
0, 
0, 
-1.63762, 0, -1, 1, 0.663223) , 
0.350101, 1, 1, 0, 0.48104) , 
0.882574, 0, 1, 0, 0.432828) , 
NN(
NN(
0, 
0, 
0.908823, 1, -1, -1, 0.458679) , 
NN(
NN(
NN(
0, 
0, 
-0.00197774, 0, -1, -1, 0.499324) , 
NN(
0, 
0, 
0.0033585, 1, -1, 1, 0.588901) , 
-0.139189, 0, 3, 0, 0.532036) , 
NN(
0, 
0, 
0.182847, 1, -1, 1, 0.624579) , 
-0.297225, 0, 0, 0, 0.554484) , 
0.700503, 0, 3, 0, 0.540215) , 
-0.862707, 1, 0, 0, 0.511567)    );
  // itree = 110
  fBoostWeights.push_back(0.68116);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.56088, 1, -1, -1, 0.33923) , 
NN(
NN(
0, 
0, 
-1.5451, 0, -1, -1, 0.378611) , 
NN(
0, 
0, 
-0.305031, 1, -1, 1, 0.62065) , 
-0.836151, 1, 3, 0, 0.480024) , 
-0.233811, 0, 2, 0, 0.408978) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.787098) , 
-3.32906, 0, 0, 0, 0.420646) , 
NN(
NN(
NN(
0, 
0, 
0.833496, 1, -1, -1, 0.314416) , 
NN(
0, 
0, 
2.20174, 1, -1, 1, 0.570856) , 
0.810201, 1, 3, 0, 0.403864) , 
NN(
NN(
0, 
0, 
-0.293813, 1, -1, 1, 0.52021) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.390155) , 
NN(
NN(
0, 
0, 
-0.151865, 0, -1, 1, 0.599593) , 
NN(
0, 
0, 
0.0469275, 0, -1, 1, 0.733881) , 
-0.152675, 1, 3, 0, 0.663993) , 
-0.621271, 1, 0, 0, 0.606546) , 
0.135971, 0, 0, 0, 0.553823) , 
0.575478, 0, 2, 0, 0.519082) , 
-0.862707, 1, 0, 0, 0.491867)    );
  // itree = 111
  fBoostWeights.push_back(0.762821);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.03232, 0, -1, -1, 0.376877) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
0.534769, 0, -1, -1, 0.425596) , 
-0.605893, 1, 3, 0, 0.415377) , 
NN(
0, 
0, 
-0.0139153, 0, -1, 1, 0.50715) , 
0.30091, 0, 0, 0, 0.459161) , 
NN(
0, 
0, 
-0.396518, 0, -1, 1, 0.601769) , 
0.845983, 1, 2, 0, 0.476011) , 
-0.862707, 1, 0, 0, 0.448996)    );
  // itree = 112
  fBoostWeights.push_back(0.785338);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.713284, 0, -1, -1, 0.231064) , 
NN(
0, 
0, 
0.059915, 0, -1, -1, 0.410426) , 
-0.293008, 1, 3, 0, 0.360503) , 
NN(
0, 
0, 
-2.11624, 1, -1, 1, 0.635372) , 
-1.41767, 0, 2, 0, 0.376522) , 
NN(
NN(
0, 
0, 
-1.5163, 0, -1, -1, 0.29621) , 
NN(
NN(
NN(
0, 
0, 
0.0762818, 1, -1, -1, 0.290164) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.35304) , 
NN(
NN(
NN(
0, 
0, 
-0.232833, 0, -1, -1, 0.421294) , 
NN(
0, 
0, 
0.899497, 0, -1, 1, 0.531785) , 
0.0383566, 1, 0, 0, 0.481482) , 
NN(
0, 
0, 
-1.21487, 1, -1, 1, 0.586669) , 
-0.944992, 0, 1, 0, 0.500653) , 
-1.66258, 1, 1, 0, 0.491611) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.639638) , 
-2.05089, 0, 1, 0, 0.497817) , 
-0.99881, 1, 3, 0, 0.492469) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.887327) , 
-1.18771, 0, 2, 0, 0.501615) , 
-1.30333, 1, 2, 0, 0.490855) , 
0.948007, 0, 1, 0, 0.460846)    );
  // itree = 113
  fBoostWeights.push_back(0.864349);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
3.21675, 1, -1, -1, 0.299888) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.05524, 0, -1, -1, 0.368753) , 
NN(
NN(
0, 
0, 
-1.07262, 0, -1, -1, 0.350984) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.66577) , 
-0.372695, 1, 3, 0, 0.543642) , 
-0.143943, 0, 1, 0, 0.42061) , 
NN(
NN(
0, 
0, 
-0.347855, 0, -1, -1, 0.386831) , 
NN(
0, 
0, 
1.2995, 1, -1, 1, 0.544198) , 
-0.485309, 1, 3, 0, 0.498256) , 
0.77778, 1, 1, 0, 0.452994) , 
NN(
0, 
0, 
1.28961, 0, -1, 1, 0.651361) , 
0.829765, 1, 3, 0, 0.463111) , 
NN(
0, 
0, 
1.19392, 0, -1, 1, 0.57278) , 
0.930722, 1, 0, 0, 0.485517) , 
2.41487, 0, 0, 0, 0.47703) , 
NN(
NN(
0, 
0, 
0.711686, 1, -1, -1, 0.425904) , 
NN(
NN(
0, 
0, 
-1.72056, 0, -1, 1, 0.563402) , 
NN(
0, 
0, 
0.139733, 0, -1, 1, 0.768035) , 
-0.0665325, 1, 2, 0, 0.635609) , 
0.325305, 0, 2, 0, 0.575056) , 
-0.586885, 0, 1, 0, 0.504639)    );
  // itree = 114
  fBoostWeights.push_back(0.83489);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.125089, 0, -1, -1, 0.364071) , 
NN(
0, 
0, 
0.116667, 1, -1, 1, 0.58916) , 
0.66692, 1, 3, 0, 0.387847) , 
NN(
NN(
0, 
0, 
1.79084, 1, -1, -1, 0.385611) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.428408) , 
NN(
NN(
0, 
0, 
-1.934, 0, -1, -1, 0.377094) , 
NN(
0, 
0, 
-0.631336, 0, -1, 1, 0.71015) , 
-0.779022, 1, 3, 0, 0.647114) , 
0.410117, 0, 2, 0, 0.602277) , 
1.40393, 0, 1, 0, 0.493561) , 
0.568402, 1, 1, 0, 0.442259) , 
NN(
NN(
0, 
0, 
1.04245, 1, -1, -1, 0.41225) , 
NN(
0, 
0, 
0.627092, 0, -1, 1, 0.592633) , 
0.512859, 0, 3, 0, 0.534345) , 
0.776084, 1, 0, 0, 0.467737) , 
NN(
NN(
0, 
0, 
-1.2666, 0, -1, 1, 0.508186) , 
NN(
NN(
0, 
0, 
-0.954786, 0, -1, 1, 0.531517) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.825807) , 
-0.267885, 1, 3, 0, 0.67927) , 
0.0284651, 0, 2, 0, 0.606827) , 
-0.586885, 0, 1, 0, 0.507152)    );
  // itree = 115
  fBoostWeights.push_back(0.790556);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-1.09492, 0, -1, -1, 0.243257) , 
NN(
NN(
NN(
0, 
0, 
-0.812693, 0, -1, -1, 0.374707) , 
NN(
0, 
0, 
-0.461543, 1, -1, 1, 0.517822) , 
-0.272465, 0, 3, 0, 0.411199) , 
NN(
0, 
0, 
2.82846, 0, -1, 1, 0.562561) , 
1.29958, 1, 0, 0, 0.438861) , 
-0.942996, 1, 3, 0, 0.417778) , 
NN(
NN(
0, 
0, 
-0.349063, 1, -1, -1, 0.447607) , 
NN(
0, 
0, 
1.71743, 0, -1, 1, 0.662021) , 
-0.340723, 0, 2, 0, 0.49733) , 
1.04716, 1, 1, 0, 0.44347) , 
NN(
NN(
0, 
0, 
-2.28298, 1, -1, -1, 0.399661) , 
NN(
NN(
0, 
0, 
0.131901, 1, -1, -1, 0.430691) , 
NN(
0, 
0, 
-0.0693675, 1, -1, 1, 0.663861) , 
0.214787, 0, 2, 0, 0.564671) , 
-1.29231, 1, 0, 0, 0.523925) , 
-0.529543, 0, 1, 0, 0.467274) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.662817) , 
2.4829, 1, 1, 0, 0.474696)    );
  // itree = 116
  fBoostWeights.push_back(0.807385);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.840112, 0, -1, -1, 0.44548) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.541832, 1, -1, -1, 0.46152) , 
NN(
0, 
0, 
-0.191953, 1, -1, 1, 0.657391) , 
0.913735, 1, 3, 0, 0.475953) , 
NN(
0, 
0, 
-0.265606, 0, -1, 1, 0.563587) , 
0.313181, 1, 1, 0, 0.514794) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.764674) , 
-0.403146, 0, 2, 0, 0.532115) , 
-0.259464, 1, 3, 0, 0.503216) , 
NN(
0, 
0, 
2.63126, 0, -1, 1, 0.694486) , 
1.27052, 1, 2, 0, 0.509813)    );
  // itree = 117
  fBoostWeights.push_back(0.746892);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.240544, 0, -1, -1, 0.439937) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.591291) , 
-0.216984, 1, 3, 0, 0.473812) , 
NN(
NN(
0, 
0, 
0.254545, 1, -1, -1, 0.458585) , 
NN(
NN(
NN(
0, 
0, 
0.53163, 0, -1, -1, 0.492505) , 
NN(
0, 
0, 
1.34667, 0, -1, 1, 0.716526) , 
0.916722, 1, 3, 0, 0.522976) , 
NN(
0, 
0, 
0.930836, 0, -1, 1, 0.677981) , 
0.311326, 0, 0, 0, 0.567001) , 
-0.343652, 1, 0, 0, 0.535275) , 
-0.0897679, 1, 3, 0, 0.507487)    );
  // itree = 118
  fBoostWeights.push_back(0.680077);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.243417, 1, -1, -1, 0.384839) , 
NN(
NN(
0, 
0, 
1.19889, 1, -1, -1, 0.338934) , 
NN(
NN(
NN(
0, 
0, 
1.80419, 1, -1, -1, 0.4357) , 
NN(
0, 
0, 
0.363808, 0, -1, 1, 0.567567) , 
0.14088, 1, 3, 0, 0.475431) , 
NN(
0, 
0, 
-0.56018, 0, -1, 1, 0.555029) , 
-0.507836, 0, 1, 0, 0.505627) , 
-1.08923, 1, 3, 0, 0.489954) , 
0.390969, 0, 0, 0, 0.454324) , 
NN(
0, 
0, 
1.35725, 1, -1, 1, 0.608881) , 
0.744808, 1, 3, 0, 0.467708)    );
  // itree = 119
  fBoostWeights.push_back(0.759565);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.760086, 1, -1, -1, 0.401116) , 
NN(
NN(
0, 
0, 
0.865546, 0, -1, -1, 0.453842) , 
NN(
0, 
0, 
1.16318, 1, -1, 1, 0.553135) , 
0.0404195, 1, 3, 0, 0.497532) , 
1.33173, 0, 1, 0, 0.48065) , 
NN(
0, 
0, 
1.35725, 1, -1, 1, 0.687337) , 
0.744808, 1, 3, 0, 0.498053)    );
  // itree = 120
  fBoostWeights.push_back(0.733661);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.269429) , 
NN(
NN(
0, 
0, 
-3.35143, 0, -1, -1, 0.262024) , 
NN(
NN(
0, 
0, 
0.318274, 1, -1, -1, 0.432211) , 
NN(
NN(
0, 
0, 
2.44783, 0, -1, -1, 0.495874) , 
NN(
0, 
0, 
-0.20293, 0, -1, 1, 0.605577) , 
-0.278717, 1, 3, 0, 0.535457) , 
-0.0666463, 0, 3, 0, 0.481349) , 
-2.31741, 1, 0, 0, 0.470096) , 
1.82279, 0, 0, 0, 0.457183) , 
NN(
0, 
0, 
1.47531, 0, -1, 1, 0.70288) , 
0.744808, 1, 3, 0, 0.477316)    );
  // itree = 121
  fBoostWeights.push_back(0.828302);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.970608, 0, -1, -1, 0.447778) , 
NN(
NN(
NN(
0, 
0, 
0.357344, 0, -1, -1, 0.390433) , 
NN(
0, 
0, 
1.17127, 1, -1, 1, 0.594905) , 
0.587517, 1, 3, 0, 0.489352) , 
NN(
0, 
0, 
-0.389344, 0, -1, 1, 0.590982) , 
0.518811, 0, 2, 0, 0.554395) , 
-0.0897679, 1, 3, 0, 0.508749)    );
  // itree = 122
  fBoostWeights.push_back(0.728601);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.240544, 0, -1, -1, 0.38994) , 
NN(
0, 
0, 
-0.195408, 0, -1, 1, 0.522408) , 
-0.456553, 1, 3, 0, 0.461041) , 
NN(
0, 
0, 
0.370364, 0, -1, 1, 0.594583) , 
-0.0897679, 1, 3, 0, 0.537952)    );
  // itree = 123
  fBoostWeights.push_back(0.809098);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.57115, 1, -1, -1, 0.374426) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.176881, 1, -1, -1, 0.422951) , 
NN(
0, 
0, 
1.06593, 0, -1, 1, 0.519397) , 
-0.147162, 1, 3, 0, 0.49711) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.705502) , 
-0.172655, 0, 2, 0, 0.510189) , 
NN(
NN(
0, 
0, 
-0.96537, 0, -1, -1, 0.474708) , 
NN(
0, 
0, 
-1.08781, 0, -1, 1, 0.695333) , 
-0.34789, 1, 3, 0, 0.600583) , 
-0.261533, 0, 2, 0, 0.532755) , 
-0.924344, 1, 3, 0, 0.517567)    );
  // itree = 124
  fBoostWeights.push_back(0.746108);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.36034, 1, -1, -1, 0.318054) , 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.180517) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.439214) , 
0.224376, 1, 3, 0, 0.281776) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.578158) , 
0.914141, 1, 0, 0, 0.315106) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.321909, 1, -1, -1, 0.239129) , 
NN(
NN(
0, 
0, 
-0.624582, 0, -1, -1, 0.38818) , 
NN(
0, 
0, 
0.345791, 1, -1, 1, 0.589326) , 
0.584055, 1, 3, 0, 0.409135) , 
0.935386, 0, 0, 0, 0.382758) , 
NN(
NN(
NN(
0, 
0, 
-0.607967, 1, -1, -1, 0.334079) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.178442) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.550742) , 
-0.065202, 1, 3, 0, 0.44302) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.733716) , 
-0.621066, 0, 2, 0, 0.521007) , 
NN(
0, 
0, 
1.04604, 0, -1, 1, 0.723293) , 
0.422475, 1, 2, 0, 0.565545) , 
-1.19705, 1, 0, 0, 0.506295) , 
NN(
0, 
0, 
-0.569029, 0, -1, 1, 0.667766) , 
-0.985518, 0, 1, 0, 0.538215) , 
-0.090859, 0, 1, 0, 0.452616) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.770311) , 
1.37244, 1, 0, 0, 0.466899) , 
-1.24284, 1, 1, 0, 0.442346) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.651359) , 
-2.46544, 0, 1, 0, 0.449028) , 
NN(
0, 
0, 
1.61216, 0, -1, 1, 0.525332) , 
1.18219, 1, 1, 0, 0.465754) , 
1.86861, 0, 0, 0, 0.453483)    );
  // itree = 125
  fBoostWeights.push_back(0.809227);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.16848, 0, -1, -1, 0.339444) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.130113) , 
NN(
NN(
NN(
0, 
0, 
0.665191, 1, -1, -1, 0.306492) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.138817) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.408572) , 
1.29298, 1, 3, 0, 0.179085) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.489799) , 
1.86441, 0, 0, 0, 0.308799) , 
NN(
0, 
0, 
0.340626, 0, -1, 1, 0.581529) , 
2.64307, 1, 0, 0, 0.372393) , 
NN(
0, 
0, 
1.28275, 0, -1, 1, 0.653396) , 
1.56924, 0, 0, 0, 0.475992) , 
1.09131, 1, 0, 0, 0.429243) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.659617) , 
-0.00473078, 0, 2, 0, 0.470332) , 
-0.328375, 1, 3, 0, 0.430585) , 
NN(
NN(
0, 
0, 
-1.14341, 1, -1, -1, 0.454427) , 
NN(
0, 
0, 
0.456527, 1, -1, 1, 0.554193) , 
-0.214186, 1, 3, 0, 0.516799) , 
0.776084, 0, 0, 0, 0.493936) , 
2.09918, 0, 1, 0, 0.485164)    );
  // itree = 126
  fBoostWeights.push_back(0.740768);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.0744663) , 
NN(
NN(
0, 
0, 
-0.518359, 1, -1, -1, 0.325967) , 
NN(
0, 
0, 
-0.93688, 1, -1, -1, 0.435241) , 
-0.309272, 1, 2, 0, 0.391461) , 
0.891821, 0, 2, 0, 0.377312) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.543494) , 
-1.93712, 0, 1, 0, 0.399164) , 
NN(
0, 
0, 
1.61122, 0, -1, 1, 0.72157) , 
1.21582, 1, 2, 0, 0.413779) , 
NN(
NN(
0, 
0, 
0.272898, 0, -1, -1, 0.475596) , 
NN(
NN(
0, 
0, 
0.918665, 1, -1, -1, 0.390931) , 
NN(
0, 
0, 
1.91298, 0, -1, 1, 0.625395) , 
0.0968087, 1, 2, 0, 0.546479) , 
0.776084, 1, 0, 0, 0.496193) , 
-0.203162, 1, 1, 0, 0.463287)    );
  // itree = 127
  fBoostWeights.push_back(0.685471);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.43743, 0, -1, -1, 0.178181) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.504381) , 
-0.0239237, 1, 2, 0, 0.383078) , 
NN(
NN(
NN(
0, 
0, 
-0.448678, 1, -1, -1, 0.380169) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.329662) , 
NN(
0, 
0, 
-1.42584, 1, -1, 1, 0.551206) , 
-0.62849, 0, 3, 0, 0.473656) , 
NN(
0, 
0, 
0.261298, 0, -1, 1, 0.609613) , 
-0.363949, 1, 0, 0, 0.520306) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.855573) , 
1.2679, 1, 1, 0, 0.55084) , 
-0.268554, 0, 2, 0, 0.466966) , 
NN(
0, 
0, 
0.330122, 0, -1, 1, 0.546437) , 
0.195361, 1, 3, 0, 0.495828) , 
1.71545, 0, 1, 0, 0.482199) , 
NN(
0, 
0, 
2.93017, 0, -1, 1, 0.714253) , 
1.27052, 1, 2, 0, 0.489609)    );
  // itree = 128
  fBoostWeights.push_back(0.682022);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.226816) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.0781914) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.522492) , 
0.00719754, 1, 2, 0, 0.386802) , 
-1.43743, 1, 0, 0, 0.324147) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.396487) , 
NN(
NN(
0, 
0, 
-0.52369, 0, -1, -1, 0.451215) , 
NN(
0, 
0, 
-0.139919, 0, -1, 1, 0.549151) , 
-0.294587, 1, 2, 0, 0.508067) , 
0.592897, 0, 2, 0, 0.495311) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.898273) , 
-3.44723, 0, 0, 0, 0.501033) , 
NN(
0, 
0, 
0.731344, 0, -1, 1, 0.587961) , 
0.505003, 1, 3, 0, 0.51817) , 
1.71545, 0, 1, 0, 0.494558)    );
  // itree = 129
  fBoostWeights.push_back(0.82728);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.882874, 0, -1, -1, 0.327495) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.372068, 1, -1, -1, 0.45726) , 
NN(
0, 
0, 
0.476406, 1, -1, 1, 0.58733) , 
0.40866, 1, 3, 0, 0.48984) , 
NN(
NN(
0, 
0, 
-2.42184, 1, -1, -1, 0.448629) , 
NN(
NN(
0, 
0, 
-0.988052, 0, -1, 1, 0.561915) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.803739) , 
-0.731848, 1, 3, 0, 0.711297) , 
-1.08743, 1, 2, 0, 0.592778) , 
-0.604538, 0, 2, 0, 0.516616) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.36087) , 
NN(
0, 
0, 
0.198496, 1, -1, 1, 0.653463) , 
-0.328375, 1, 3, 0, 0.626406) , 
0.728146, 1, 0, 0, 0.549471) , 
1.71545, 0, 1, 0, 0.523067)    );
  // itree = 130
  fBoostWeights.push_back(0.832481);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.382875, 0, -1, -1, 0.357367) , 
NN(
0, 
0, 
-1.42809, 1, -1, -1, 0.475706) , 
-0.281338, 1, 3, 0, 0.407578) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.671943) , 
-3.32906, 0, 0, 0, 0.418131) , 
NN(
NN(
NN(
0, 
0, 
-0.034523, 1, -1, -1, 0.430743) , 
NN(
0, 
0, 
1.41174, 0, -1, 1, 0.682052) , 
-0.499326, 0, 3, 0, 0.491304) , 
NN(
0, 
0, 
0.738572, 0, -1, 1, 0.601264) , 
0.0344666, 1, 2, 0, 0.558934) , 
-0.862707, 1, 0, 0, 0.519568)    );
  // itree = 131
  fBoostWeights.push_back(0.718446);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.523474, 1, -1, -1, 0.353531) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.298745) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.288155) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.210315) , 
NN(
0, 
0, 
0.636636, 1, -1, -1, 0.498762) , 
-0.284852, 1, 3, 0, 0.456609) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.71663) , 
-0.109319, 0, 2, 0, 0.499151) , 
0.228013, 0, 0, 0, 0.458162) , 
NN(
0, 
0, 
1.20947, 0, -1, 1, 0.561663) , 
0.532299, 1, 0, 0, 0.495415) , 
-0.315043, 1, 2, 0, 0.481677) , 
NN(
0, 
0, 
-0.697291, 1, -1, 1, 0.574484) , 
-0.462502, 0, 2, 0, 0.496501) , 
NN(
0, 
0, 
2.33235, 0, -1, 1, 0.652193) , 
0.937818, 1, 3, 0, 0.506215) , 
-0.924344, 1, 3, 0, 0.489165)    );
  // itree = 132
  fBoostWeights.push_back(0.732491);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.16313, 1, -1, -1, 0.32079) , 
NN(
0, 
0, 
-0.772274, 1, -1, -1, 0.451855) , 
-0.267432, 0, 3, 0, 0.375551) , 
NN(
0, 
0, 
-0.170559, 0, -1, 1, 0.53087) , 
1.06831, 1, 1, 0, 0.421065) , 
NN(
0, 
0, 
1.21415, 0, -1, 1, 0.514905) , 
0.32752, 1, 3, 0, 0.452144) , 
NN(
NN(
0, 
0, 
0.286026, 0, -1, -1, 0.417146) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.380285, 0, -1, -1, 0.393438) , 
NN(
0, 
0, 
1.17126, 1, -1, 1, 0.808252) , 
0.535854, 1, 3, 0, 0.442708) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.664821) , 
-0.710879, 1, 1, 0, 0.487713) , 
NN(
0, 
0, 
-0.991256, 0, -1, 1, 0.636846) , 
-1.1355, 0, 0, 0, 0.534768) , 
NN(
0, 
0, 
-1.47222, 1, -1, 1, 0.863226) , 
-1.29393, 0, 1, 0, 0.598685) , 
-1.64816, 1, 1, 0, 0.542609) , 
-0.586885, 0, 1, 0, 0.477444)    );
  // itree = 133
  fBoostWeights.push_back(0.632271);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.68209, 0, -1, -1, 0.379438) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.340783) , 
NN(
NN(
0, 
0, 
0.44519, 1, -1, -1, 0.415064) , 
NN(
NN(
NN(
0, 
0, 
0.148247, 1, -1, -1, 0.449823) , 
NN(
0, 
0, 
0.293337, 0, -1, 1, 0.59558) , 
-0.0423462, 1, 3, 0, 0.506998) , 
NN(
0, 
0, 
-0.102182, 0, -1, 1, 0.586956) , 
9.32589e-05, 1, 2, 0, 0.552624) , 
0.722843, 0, 2, 0, 0.537794) , 
-1.73805, 1, 1, 0, 0.526312) , 
NN(
0, 
0, 
2.33235, 0, -1, 1, 0.694633) , 
0.937818, 1, 3, 0, 0.536769) , 
NN(
0, 
0, 
-0.400119, 1, -1, 1, 0.705084) , 
-1.80339, 0, 0, 0, 0.546714) , 
-0.924344, 1, 3, 0, 0.529046)    );
  // itree = 134
  fBoostWeights.push_back(0.786593);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.259132) , 
NN(
NN(
0, 
0, 
-1.96248, 0, -1, -1, 0.44496) , 
NN(
0, 
0, 
-0.958039, 0, -1, 1, 0.535682) , 
-0.588138, 1, 3, 0, 0.515505) , 
0.59689, 0, 0, 0, 0.502783) , 
NN(
0, 
0, 
1.90318, 0, -1, 1, 0.580493) , 
0.776084, 1, 0, 0, 0.523241)    );
  // itree = 135
  fBoostWeights.push_back(0.868646);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.749185, 0, -1, -1, 0.395445) , 
NN(
0, 
0, 
-0.111765, 0, -1, 1, 0.639134) , 
0.250391, 1, 3, 0, 0.447607) , 
NN(
NN(
NN(
0, 
0, 
0.558051, 0, -1, -1, 0.453953) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.362289) , 
NN(
NN(
NN(
0, 
0, 
0.238602, 1, -1, -1, 0.47691) , 
NN(
0, 
0, 
1.29097, 0, -1, 1, 0.671851) , 
0.482317, 1, 3, 0, 0.527309) , 
NN(
0, 
0, 
0.717011, 1, -1, 1, 0.709177) , 
0.425577, 0, 0, 0, 0.57755) , 
-0.0302608, 1, 0, 0, 0.548104) , 
0.610884, 0, 2, 0, 0.526411) , 
NN(
0, 
0, 
-1.02884, 1, -1, 1, 0.667377) , 
-0.812814, 0, 1, 0, 0.552455) , 
-0.316443, 1, 0, 0, 0.50866)    );
  // itree = 136
  fBoostWeights.push_back(0.805473);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.108013, 0, -1, -1, 0.351454) , 
NN(
0, 
0, 
0.415345, 1, -1, -1, 0.498068) , 
0.509438, 1, 2, 0, 0.408791) , 
NN(
NN(
0, 
0, 
-2.23824, 0, -1, -1, 0.350928) , 
NN(
NN(
NN(
0, 
0, 
-0.659271, 0, -1, -1, 0.297453) , 
NN(
0, 
0, 
0.259727, 0, -1, 1, 0.604628) , 
-0.217352, 1, 3, 0, 0.507422) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.704245) , 
-0.922993, 0, 2, 0, 0.544492) , 
-0.942098, 1, 3, 0, 0.494383) , 
-0.0371549, 0, 2, 0, 0.441078) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.773928) , 
-0.102306, 0, 1, 0, 0.449437) , 
NN(
NN(
0, 
0, 
-1.74574, 0, -1, -1, 0.383507) , 
NN(
0, 
0, 
0.356444, 1, -1, 1, 0.604877) , 
-1.29231, 1, 0, 0, 0.546815) , 
-0.203162, 0, 1, 0, 0.486295)    );
  // itree = 137
  fBoostWeights.push_back(0.765049);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.272824) , 
NN(
NN(
0, 
0, 
0.493706, 0, -1, -1, 0.202977) , 
NN(
NN(
NN(
NN(
0, 
0, 
-2.43676, 0, -1, -1, 0.245715) , 
NN(
NN(
0, 
0, 
-1.6322, 0, -1, -1, 0.32171) , 
NN(
NN(
0, 
0, 
-0.983592, 1, -1, -1, 0.37019) , 
NN(
0, 
0, 
-0.945205, 0, -1, 1, 0.56824) , 
-0.165147, 0, 3, 0, 0.479844) , 
-1.07308, 1, 2, 0, 0.460186) , 
-2.18889, 1, 0, 0, 0.438234) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.71626) , 
-2.86265, 0, 0, 0, 0.452896) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.616577) , 
0.556287, 1, 2, 0, 0.474221) , 
-2.07043, 1, 3, 0, 0.463846) , 
-0.462535, 0, 0, 0, 0.437434) , 
NN(
NN(
0, 
0, 
0.676535, 1, -1, -1, 0.382475) , 
NN(
NN(
NN(
0, 
0, 
0.22632, 0, -1, -1, 0.454784) , 
NN(
NN(
0, 
0, 
0.905434, 0, -1, -1, 0.468426) , 
NN(
0, 
0, 
1.37061, 1, -1, 1, 0.637212) , 
0.632703, 0, 3, 0, 0.599594) , 
0.337148, 1, 0, 0, 0.554954) , 
NN(
0, 
0, 
1.21835, 0, -1, 1, 0.67164) , 
0.744413, 1, 1, 0, 0.588872) , 
-0.460203, 1, 3, 0, 0.573927) , 
-0.316443, 1, 0, 0, 0.518363)    );
  // itree = 138
  fBoostWeights.push_back(0.66218);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-1.68777, 1, -1, -1, 0.28578) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.572579) , 
-0.268374, 0, 2, 0, 0.348231) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.240956) , 
NN(
NN(
NN(
0, 
0, 
1.43659, 1, -1, -1, 0.412258) , 
NN(
NN(
0, 
0, 
-2.98069, 1, -1, -1, 0.369942) , 
NN(
NN(
0, 
0, 
-1.79294, 0, 0, -1, 0) , 
NN(
0, 
0, 
-0.153769, 0, -1, 1, 0.527892) , 
-1.14374, 1, 3, 0, 0.521464) , 
-1.21555, 1, 2, 0, 0.495339) , 
-0.0623079, 0, 2, 0, 0.452514) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.620953) , 
0.587507, 1, 3, 0, 0.466067) , 
0.733592, 0, 3, 0, 0.459999) , 
NN(
0, 
0, 
1.2698, 0, -1, 1, 0.564163) , 
0.88002, 1, 3, 0, 0.467301) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
2.02278, 1, 2, 0, 0.468801) , 
-1.31111, 1, 1, 0, 0.458851) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.679716) , 
-2.42611, 0, 1, 0, 0.464453) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.752808) , 
2.4829, 1, 1, 0, 0.470962)    );
  // itree = 139
  fBoostWeights.push_back(0.775585);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.271273, 0, -1, -1, 0.2999) , 
NN(
NN(
0, 
0, 
-0.222297, 1, -1, -1, 0.324131) , 
NN(
0, 
0, 
-0.103717, 0, -1, 1, 0.529539) , 
-0.323509, 1, 3, 0, 0.44171) , 
-0.0588983, 0, 3, 0, 0.372038) , 
NN(
0, 
0, 
0.404992, 1, -1, -1, 0.480237) , 
0.267383, 1, 3, 0, 0.395531) , 
NN(
NN(
0, 
0, 
-0.800771, 0, -1, -1, 0.396805) , 
NN(
0, 
0, 
-0.373651, 1, -1, 1, 0.567784) , 
-0.817148, 1, 3, 0, 0.476087) , 
-0.585796, 0, 2, 0, 0.417033) , 
NN(
0, 
0, 
-0.379704, 1, -1, 1, 0.573934) , 
0.533717, 1, 3, 0, 0.432101) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.331237) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.300732) , 
NN(
0, 
0, 
0.276615, 0, -1, 1, 0.620878) , 
-0.328375, 1, 3, 0, 0.604493) , 
1.41378, 0, 1, 0, 0.559819) , 
0.776084, 1, 0, 0, 0.467947)    );
  // itree = 140
  fBoostWeights.push_back(0.798623);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.767171, 1, -1, -1, 0.421301) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.137981, 0, -1, -1, 0.479661) , 
NN(
NN(
NN(
0, 
0, 
-0.0461715, 1, -1, -1, 0.43259) , 
NN(
0, 
0, 
-0.180566, 0, -1, 1, 0.569085) , 
-0.288609, 1, 3, 0, 0.54069) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
0.59536, 1, 3, 0, 0.550735) , 
0.316352, 0, 2, 0, 0.524708) , 
NN(
0, 
0, 
-0.0706148, 1, -1, 1, 0.619591) , 
1.71999, 1, 0, 0, 0.535956) , 
NN(
0, 
0, 
0.540571, 0, -1, 1, 0.651571) , 
-0.766246, 0, 2, 0, 0.544605) , 
-0.924344, 1, 3, 0, 0.533742)    );
  // itree = 141
  fBoostWeights.push_back(0.664605);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.357227) , 
NN(
NN(
0, 
0, 
-2.98069, 1, -1, -1, 0.337004) , 
NN(
0, 
0, 
0.206461, 1, -1, -1, 0.495831) , 
-1.17526, 1, 3, 0, 0.479308) , 
-0.0884405, 0, 3, 0, 0.459093) , 
NN(
0, 
0, 
-1.10401, 0, -1, 1, 0.537973) , 
0.0364975, 1, 3, 0, 0.494728) , 
NN(
0, 
0, 
1.7989, 0, -1, 1, 0.63749) , 
0.744808, 1, 3, 0, 0.508093)    );
  // itree = 142
  fBoostWeights.push_back(0.889758);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.203162, 1, -1, -1, 0.462493) , 
NN(
0, 
0, 
-2.14924, 0, -1, 1, 0.544803) , 
-0.0897679, 1, 3, 0, 0.511262)    );
  // itree = 143
  fBoostWeights.push_back(0.879296);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.284071) , 
NN(
NN(
0, 
0, 
-1.88329, 1, -1, -1, 0.403393) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.67711) , 
-0.627424, 1, 2, 0, 0.471431) , 
-0.238935, 0, 2, 0, 0.391013) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
1.31434, 1, -1, -1, 0.250665) , 
NN(
NN(
0, 
0, 
0.0686562, 0, -1, -1, 0.374764) , 
NN(
NN(
0, 
0, 
0.777131, 1, -1, -1, 0.451928) , 
NN(
0, 
0, 
0.67479, 0, -1, 1, 0.748703) , 
-0.081899, 1, 3, 0, 0.601116) , 
0.421427, 1, 1, 0, 0.483945) , 
1.07995, 0, 1, 0, 0.425387) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.672162) , 
1.74877, 1, 1, 0, 0.458748) , 
NN(
0, 
0, 
0.556638, 0, -1, 1, 0.559795) , 
-0.308393, 0, 1, 0, 0.495372) , 
NN(
NN(
0, 
0, 
0.422558, 1, -1, -1, 0.429571) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.243304) , 
NN(
0, 
0, 
1.27394, 0, -1, 1, 0.731467) , 
-0.222866, 1, 3, 0, 0.704821) , 
0.614951, 0, 3, 0, 0.612036) , 
0.954398, 1, 0, 0, 0.526536) , 
-1.40897, 1, 0, 0, 0.50442)    );
  // itree = 144
  fBoostWeights.push_back(0.727714);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.50711, 1, -1, -1, 0.379473) , 
NN(
NN(
0, 
0, 
-0.0864138, 1, -1, -1, 0.461239) , 
NN(
0, 
0, 
-2.05272, 0, -1, 1, 0.552964) , 
-0.189627, 1, 3, 0, 0.522745) , 
1.71545, 0, 1, 0, 0.508281)    );
  // itree = 145
  fBoostWeights.push_back(0.75785);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.558422, 1, -1, -1, 0.298322) , 
NN(
0, 
0, 
0.0271208, 1, -1, -1, 0.447137) , 
-0.277011, 1, 3, 0, 0.401085) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.262543) , 
NN(
0, 
0, 
-1.89884, 0, -1, -1, 0.47201) , 
0.0783247, 1, 3, 0, 0.441559) , 
NN(
NN(
NN(
0, 
0, 
-0.450576, 0, -1, -1, 0.391777) , 
NN(
NN(
0, 
0, 
0.639458, 0, -1, -1, 0.423122) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.671457) , 
-0.829477, 1, 3, 0, 0.531212) , 
-0.825668, 0, 2, 0, 0.463745) , 
NN(
0, 
0, 
0.238403, 0, -1, 1, 0.622167) , 
-0.267885, 1, 3, 0, 0.556546) , 
0.230675, 0, 2, 0, 0.515351) , 
0.948007, 0, 1, 0, 0.485563)    );
  // itree = 146
  fBoostWeights.push_back(0.822716);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.3159, 1, -1, -1, 0.469108) , 
NN(
NN(
0, 
0, 
0.238282, 0, -1, -1, 0.347596) , 
NN(
NN(
NN(
0, 
0, 
1.7989, 1, -1, -1, 0.45844) , 
NN(
0, 
0, 
1.23304, 0, -1, 1, 0.55356) , 
0.512859, 0, 3, 0, 0.530317) , 
NN(
NN(
0, 
0, 
-2.31118, 1, -1, 1, 0.508155) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.729198) , 
-0.462837, 1, 3, 0, 0.639455) , 
-1.62718, 0, 0, 0, 0.543063) , 
-1.30333, 1, 2, 0, 0.533122) , 
0.948007, 0, 1, 0, 0.516366)    );
  // itree = 147
  fBoostWeights.push_back(0.862183);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.195581) , 
NN(
NN(
0, 
0, 
-0.208764, 1, -1, -1, 0.201806) , 
NN(
NN(
0, 
0, 
-0.651227, 0, -1, -1, 0.430977) , 
NN(
0, 
0, 
0.188921, 0, -1, 1, 0.550204) , 
-0.0708687, 1, 3, 0, 0.487808) , 
0.890869, 0, 2, 0, 0.461804) , 
0.402674, 0, 0, 0, 0.433338) , 
NN(
0, 
0, 
0.844204, 1, -1, 1, 0.583964) , 
0.498976, 1, 0, 0, 0.455314) , 
NN(
NN(
NN(
0, 
0, 
-0.379182, 0, -1, -1, 0.477644) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.269364) , 
NN(
0, 
0, 
-1.00888, 1, -1, 1, 0.608402) , 
-0.51441, 0, 3, 0, 0.483945) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.775053) , 
-0.0198152, 1, 2, 0, 0.613894) , 
-1.55435, 1, 0, 0, 0.546521) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.873789) , 
-3.28082, 0, 0, 0, 0.55511) , 
-0.767028, 0, 0, 0, 0.494503) , 
NN(
NN(
NN(
0, 
0, 
0.942896, 1, -1, -1, 0.45846) , 
NN(
0, 
0, 
1.3879, 1, -1, 1, 0.599962) , 
0.610884, 0, 2, 0, 0.558035) , 
NN(
0, 
0, 
1.67672, 0, -1, 1, 0.767561) , 
-0.812814, 0, 1, 0, 0.585676) , 
0.776084, 1, 0, 0, 0.520883)    );
  // itree = 148
  fBoostWeights.push_back(0.726489);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.970608, 0, -1, -1, 0.450221) , 
NN(
NN(
NN(
0, 
0, 
-1.94719, 1, -1, 1, 0.507505) , 
NN(
0, 
0, 
3.13446, 0, -1, 1, 0.737057) , 
1.4287, 1, 3, 0, 0.517633) , 
NN(
0, 
0, 
0.0161598, 0, -1, 1, 0.638669) , 
-0.760989, 0, 0, 0, 0.537297) , 
-0.0897679, 1, 3, 0, 0.500674)    );
  // itree = 149
  fBoostWeights.push_back(0.711135);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.275633, 1, -1, -1, 0.385655) , 
NN(
NN(
0, 
0, 
-0.967998, 0, -1, -1, 0.346096) , 
NN(
NN(
0, 
0, 
-1.4358, 0, -1, -1, 0.422373) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.715346) , 
-0.223231, 1, 3, 0, 0.517131) , 
-1.01534, 1, 1, 0, 0.480451) , 
-0.774197, 0, 0, 0, 0.426298) , 
NN(
0, 
0, 
0.375179, 0, -1, 1, 0.509337) , 
0.175019, 1, 3, 0, 0.449259) , 
NN(
0, 
0, 
-0.170634, 1, -1, 1, 0.65898) , 
0.907668, 1, 3, 0, 0.455949) , 
NN(
NN(
NN(
0, 
0, 
0.808597, 0, -1, 1, 0.525865) , 
NN(
0, 
0, 
2.94352, 0, -1, 1, 0.760351) , 
1.35409, 1, 3, 0, 0.540935) , 
NN(
0, 
0, 
-1.21461, 1, -1, 1, 0.738985) , 
-0.812814, 0, 1, 0, 0.564458) , 
0.776084, 1, 0, 0, 0.487672)    );
  // itree = 150
  fBoostWeights.push_back(0.751491);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.229698) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.329487) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.583244) , 
-0.414337, 1, 3, 0, 0.517594) , 
0.161798, 0, 3, 0, 0.382185) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.24312) , 
NN(
NN(
0, 
0, 
-1.75425, 0, -1, -1, 0.346898) , 
NN(
0, 
0, 
-0.16005, 0, -1, 1, 0.503512) , 
-0.822736, 1, 3, 0, 0.454833) , 
-0.0541548, 0, 3, 0, 0.416352) , 
NN(
0, 
0, 
-1.23196, 1, -1, 1, 0.618439) , 
-2.42157, 0, 0, 0, 0.430527) , 
NN(
0, 
0, 
-0.0484528, 0, -1, 1, 0.578617) , 
0.172228, 1, 3, 0, 0.463819) , 
-0.242748, 0, 0, 0, 0.442637) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.678298) , 
0.907668, 1, 3, 0, 0.451624) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
1.2778, 0, -1, 1, 0.551077) , 
-0.608787, 1, 3, 0, 0.544684) , 
NN(
0, 
0, 
1.17789, 0, -1, 1, 0.70742) , 
1.41378, 1, 1, 0, 0.566321) , 
0.22982, 1, 0, 0, 0.503002)    );
  // itree = 151
  fBoostWeights.push_back(0.804438);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.901782, 1, -1, -1, 0.390027) , 
NN(
NN(
NN(
0, 
0, 
-0.0466913, 0, -1, -1, 0.445325) , 
NN(
0, 
0, 
-1.82772, 1, -1, 1, 0.568149) , 
0.508173, 1, 3, 0, 0.4806) , 
NN(
0, 
0, 
0.187117, 1, -1, 1, 0.562803) , 
-0.511171, 0, 0, 0, 0.504966) , 
-0.924344, 1, 3, 0, 0.495668)    );
  // itree = 152
  fBoostWeights.push_back(0.770407);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.25112, 0, -1, -1, 0.170529) , 
NN(
NN(
NN(
0, 
0, 
-1.66055, 0, -1, -1, 0.19147) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.314778) , 
NN(
NN(
0, 
0, 
1.24997, 0, -1, -1, 0.452448) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.57857, 0, -1, -1, 0.393635) , 
NN(
0, 
0, 
0.131024, 0, -1, -1, 0.49394) , 
-0.292748, 1, 3, 0, 0.449623) , 
NN(
0, 
0, 
-0.155288, 1, -1, 1, 0.579697) , 
0.300536, 1, 1, 0, 0.500783) , 
NN(
0, 
0, 
-0.552773, 0, -1, 1, 0.753749) , 
-1.46139, 0, 0, 0, 0.529782) , 
0.111517, 0, 2, 0, 0.489876) , 
1.92748, 0, 1, 0, 0.480674) , 
NN(
0, 
0, 
2.89519, 0, -1, 1, 0.635568) , 
2.29903, 1, 0, 0, 0.488724) , 
-1.17493, 1, 3, 0, 0.483377) , 
NN(
0, 
0, 
0.654705, 1, -1, 1, 0.609335) , 
-2.01577, 0, 0, 0, 0.490249) , 
-2.17621, 1, 3, 0, 0.488089)    );
  // itree = 153
  fBoostWeights.push_back(0.75938);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.287546) , 
NN(
NN(
NN(
0, 
0, 
0.039958, 1, -1, -1, 0.440818) , 
NN(
0, 
0, 
-0.6138, 1, -1, 1, 0.59241) , 
0.48349, 1, 3, 0, 0.462072) , 
NN(
0, 
0, 
-1.65072, 1, -1, 1, 0.625672) , 
-1.92427, 0, 0, 0, 0.474374) , 
1.82279, 0, 0, 0, 0.465289) , 
NN(
0, 
0, 
2.35481, 0, -1, 1, 0.570813) , 
0.744808, 1, 3, 0, 0.475517) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.780029) , 
-2.42611, 0, 1, 0, 0.481192) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.689038) , 
2.4829, 1, 1, 0, 0.486406)    );
  // itree = 154
  fBoostWeights.push_back(0.887198);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.51132, 0, -1, -1, 0.207392) , 
NN(
0, 
0, 
1.02339, 1, -1, -1, 0.380053) , 
-0.395479, 1, 3, 0, 0.325563) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.672349) , 
0.594371, 1, 3, 0, 0.352144) , 
NN(
0, 
0, 
0.841801, 0, -1, 1, 0.71818) , 
-2.44092, 0, 0, 0, 0.368502) , 
NN(
NN(
NN(
0, 
0, 
-1.94558, 0, -1, -1, 0.44413) , 
NN(
0, 
0, 
0.680194, 0, -1, 1, 0.623469) , 
0.397289, 1, 3, 0, 0.483579) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.815014) , 
0.130601, 1, 1, 0, 0.510885) , 
0.235983, 0, 1, 0, 0.446378) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.283374) , 
NN(
NN(
0, 
0, 
0.249184, 1, -1, 1, 0.5066) , 
NN(
NN(
0, 
0, 
0.86704, 0, -1, 1, 0.51753) , 
NN(
0, 
0, 
0.030055, 1, -1, 1, 0.72662) , 
-0.074275, 1, 3, 0, 0.640184) , 
0.136138, 0, 2, 0, 0.566317) , 
1.78488, 0, 1, 0, 0.54991) , 
0.22982, 1, 0, 0, 0.494106)    );
  // itree = 155
  fBoostWeights.push_back(0.654911);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.739867, 1, -1, -1, 0.3962) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.250201) , 
NN(
NN(
0, 
0, 
0.645178, 0, -1, -1, 0.388202) , 
NN(
NN(
NN(
0, 
0, 
0.0181343, 1, -1, -1, 0.397032) , 
NN(
NN(
0, 
0, 
-0.434687, 1, -1, -1, 0.446585) , 
NN(
NN(
0, 
0, 
-0.159392, 0, -1, 1, 0.504117) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.712088) , 
-0.43814, 1, 3, 0, 0.582327) , 
-0.409432, 0, 0, 0, 0.519778) , 
-0.062343, 0, 3, 0, 0.480449) , 
NN(
0, 
0, 
0.368979, 0, -1, 1, 0.600525) , 
0.190543, 1, 3, 0, 0.503031) , 
0.454954, 0, 3, 0, 0.485954) , 
0.873471, 0, 2, 0, 0.474406) , 
0.948007, 0, 1, 0, 0.454702) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.891733) , 
-3.42721, 0, 0, 0, 0.457729) , 
NN(
0, 
0, 
0.180925, 1, -1, 1, 0.66657) , 
0.744808, 1, 3, 0, 0.476523)    );
  // itree = 156
  fBoostWeights.push_back(0.776425);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
1.67765, 0, -1, -1, 0.319909) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.658851) , 
0.829765, 1, 3, 0, 0.341618) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.547867) , 
2.30075, 1, 1, 0, 0.380844) , 
NN(
0, 
0, 
-0.37846, 1, -1, 1, 0.56567) , 
1.17247, 0, 1, 0, 0.412799) , 
NN(
NN(
NN(
0, 
0, 
-0.373098, 0, -1, -1, 0.457912) , 
NN(
0, 
0, 
0.571036, 1, -1, 1, 0.650124) , 
0.397289, 1, 3, 0, 0.493082) , 
NN(
NN(
0, 
0, 
0.137819, 1, -1, 1, 0.541449) , 
NN(
0, 
0, 
0.215102, 1, -1, 1, 0.6321) , 
0.232448, 0, 3, 0, 0.590442) , 
-0.247128, 1, 0, 0, 0.556054) , 
0.948007, 0, 1, 0, 0.521395)    );
  // itree = 157
  fBoostWeights.push_back(0.830548);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.18068, 0, -1, -1, 0.189448) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.179288) , 
NN(
0, 
0, 
1.07788, 0, -1, -1, 0.434408) , 
0.182116, 1, 2, 0, 0.338119) , 
NN(
0, 
0, 
0.900039, 0, -1, -1, 0.479584) , 
0.399455, 0, 0, 0, 0.404279) , 
-0.937754, 1, 0, 0, 0.37456) , 
NN(
0, 
0, 
-1.09073, 1, -1, 1, 0.527373) , 
-1.33519, 0, 0, 0, 0.394093) , 
NN(
NN(
0, 
0, 
1.19069, 0, -1, 1, 0.503184) , 
NN(
0, 
0, 
0.620123, 0, -1, 1, 0.642798) , 
0.603237, 1, 3, 0, 0.526988) , 
0.564284, 0, 1, 0, 0.479311)    );
  // itree = 158
  fBoostWeights.push_back(0.785691);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.550376, 1, -1, -1, 0.290534) , 
NN(
0, 
0, 
0.89792, 1, -1, -1, 0.401974) , 
-0.338147, 1, 3, 0, 0.36712) , 
NN(
0, 
0, 
-2.33803, 1, -1, 1, 0.620236) , 
-1.44606, 0, 2, 0, 0.386885) , 
NN(
0, 
0, 
0.468577, 1, -1, -1, 0.499696) , 
0.374831, 1, 2, 0, 0.419708) , 
NN(
NN(
0, 
0, 
-0.98942, 0, -1, -1, 0.427977) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.291302) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.364513) , 
NN(
0, 
0, 
0.560163, 1, -1, 1, 0.566557) , 
0.317816, 1, 3, 0, 0.485567) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.665824) , 
-0.049991, 0, 2, 0, 0.531297) , 
NN(
0, 
0, 
-1.71493, 1, -1, 1, 0.635038) , 
-0.58027, 0, 1, 0, 0.573805) , 
-0.3004, 1, 2, 0, 0.546528) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.871449) , 
-0.600855, 0, 2, 0, 0.568508) , 
-0.404037, 1, 3, 0, 0.537793) , 
0.564284, 0, 1, 0, 0.495937)    );
  // itree = 159
  fBoostWeights.push_back(0.798513);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.264699) , 
NN(
0, 
0, 
0.280635, 1, -1, 1, 0.526652) , 
-0.184024, 1, 2, 0, 0.419422) , 
NN(
NN(
NN(
0, 
0, 
-1.01534, 0, -1, -1, 0.397971) , 
NN(
0, 
0, 
-1.78359, 0, -1, 1, 0.53101) , 
-0.31132, 1, 2, 0, 0.46955) , 
NN(
0, 
0, 
-0.167225, 1, -1, 1, 0.570565) , 
-0.532666, 1, 0, 0, 0.516578) , 
0.255911, 0, 0, 0, 0.496919) , 
NN(
0, 
0, 
1.04268, 0, -1, 1, 0.590789) , 
0.776084, 1, 0, 0, 0.522615)    );
  // itree = 160
  fBoostWeights.push_back(0.708845);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.829781, 0, -1, -1, 0.402255) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.435655, 0, -1, -1, 0.356057) , 
NN(
0, 
0, 
0.914197, 0, -1, 1, 0.818114) , 
0.809641, 1, 3, 0, 0.378088) , 
NN(
0, 
0, 
-0.549109, 1, -1, 1, 0.547003) , 
0.308196, 0, 0, 0, 0.466886) , 
NN(
0, 
0, 
1.0328, 0, -1, 1, 0.646964) , 
1.74303, 1, 0, 0, 0.487158) , 
NN(
NN(
0, 
0, 
-0.230847, 0, -1, -1, 0.487461) , 
NN(
0, 
0, 
0.597374, 0, -1, 1, 0.616728) , 
-0.00248623, 1, 3, 0, 0.572265) , 
-0.213792, 0, 1, 0, 0.519884) , 
-0.507056, 1, 3, 0, 0.499134)    );
  // itree = 161
  fBoostWeights.push_back(0.694624);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.829781, 0, -1, -1, 0.42604) , 
NN(
0, 
0, 
1.17087, 0, -1, 1, 0.504601) , 
-0.507056, 1, 3, 0, 0.491438)    );
  // itree = 162
  fBoostWeights.push_back(0.769637);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.180668) , 
NN(
NN(
NN(
0, 
0, 
-0.232897, 0, -1, -1, 0.378652) , 
NN(
0, 
0, 
0.209992, 1, -1, 1, 0.503115) , 
-0.0425555, 1, 3, 0, 0.416242) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.768217) , 
1.51376, 1, 1, 0, 0.443728) , 
2.26716, 0, 1, 0, 0.427461) , 
NN(
0, 
0, 
-1.19104, 1, -1, 1, 0.568089) , 
-0.970608, 0, 1, 0, 0.459431) , 
NN(
0, 
0, 
-1.17833, 1, -1, 1, 0.566936) , 
0.0206825, 1, 2, 0, 0.52113)    );
  // itree = 163
  fBoostWeights.push_back(0.71938);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.997925, 0, -1, -1, 0.395595) , 
NN(
0, 
0, 
0.238403, 0, -1, 1, 0.512458) , 
-0.191793, 1, 3, 0, 0.436414) , 
NN(
0, 
0, 
1.3257, 0, -1, 1, 0.541782) , 
0.0206825, 1, 2, 0, 0.497095)    );
  // itree = 164
  fBoostWeights.push_back(0.773007);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.12131, 0, -1, -1, 0.408957) , 
NN(
0, 
0, 
-0.906123, 1, -1, 1, 0.526867) , 
-0.507056, 1, 3, 0, 0.505864)    );
  // itree = 165
  fBoostWeights.push_back(0.712359);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.199065) , 
NN(
0, 
0, 
1.03049, 1, -1, -1, 0.464482) , 
0.649572, 1, 3, 0, 0.351894) , 
NN(
NN(
0, 
0, 
0.272414, 1, -1, -1, 0.437082) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.2409) , 
NN(
NN(
0, 
0, 
-1.16429, 0, -1, -1, 0.386401) , 
NN(
0, 
0, 
-0.410429, 0, -1, 1, 0.520669) , 
-0.780472, 1, 3, 0, 0.453641) , 
-1.17465, 1, 1, 0, 0.425289) , 
NN(
0, 
0, 
-0.110085, 0, -1, 1, 0.553347) , 
-0.303507, 1, 2, 0, 0.461019) , 
NN(
0, 
0, 
-1.07782, 0, -1, 1, 0.61562) , 
-0.191793, 1, 3, 0, 0.521175) , 
0.0973288, 0, 2, 0, 0.48047) , 
0.853908, 0, 2, 0, 0.466545)    );
  // itree = 166
  fBoostWeights.push_back(0.718095);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.04268, 0, -1, -1, 0.367242) , 
NN(
NN(
NN(
0, 
0, 
-2.64252, 0, -1, -1, 0.375205) , 
NN(
NN(
0, 
0, 
0.700948, 1, -1, -1, 0.429014) , 
NN(
NN(
0, 
0, 
0.491982, 1, -1, -1, 0.402904) , 
NN(
NN(
0, 
0, 
-1.33956, 0, -1, -1, 0.133781) , 
NN(
NN(
0, 
0, 
0.423882, 0, -1, -1, 0.490026) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.06929, 0, -1, -1, 0.378743) , 
NN(
NN(
0, 
0, 
-0.977371, 0, -1, -1, 0.436573) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.782341) , 
-0.616691, 1, 3, 0, 0.553749) , 
-0.612426, 0, 2, 0, 0.466942) , 
NN(
NN(
0, 
0, 
0.629873, 1, -1, 1, 0.572805) , 
NN(
NN(
0, 
0, 
0.00297625, 1, -1, 1, 0.657226) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.94027) , 
0.0187988, 1, 3, 0, 0.719142) , 
0.15133, 0, 2, 0, 0.619958) , 
-0.247602, 1, 2, 0, 0.573842) , 
NN(
0, 
0, 
0.198, 0, -1, 1, 0.820776) , 
-1.20518, 0, 2, 0, 0.586828) , 
0.410581, 0, 0, 0, 0.561725) , 
-1.54195, 1, 3, 0, 0.556654) , 
0.819041, 0, 2, 0, 0.54237) , 
-1.42633, 1, 1, 0, 0.530368) , 
-1.64577, 1, 2, 0, 0.523904) , 
NN(
0, 
0, 
0.0572712, 0, -1, 1, 0.775168) , 
1.13714, 1, 0, 0, 0.529516) , 
1.32235, 0, 0, 0, 0.503625)    );
  // itree = 167
  fBoostWeights.push_back(0.801853);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.840919, 0, -1, -1, 0.364801) , 
NN(
NN(
0, 
0, 
0.193816, 0, -1, -1, 0.448485) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.445451, 0, -1, -1, 0.384583) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.316066) , 
NN(
NN(
NN(
0, 
0, 
0.777807, 0, -1, -1, 0.396913) , 
NN(
0, 
0, 
0.26959, 0, -1, 1, 0.613543) , 
0.935355, 1, 3, 0, 0.473758) , 
NN(
0, 
0, 
-1.62144, 1, -1, 1, 0.689994) , 
-1.19266, 0, 1, 0, 0.514907) , 
-0.378906, 1, 0, 0, 0.466897) , 
NN(
0, 
0, 
0.0653063, 1, -1, 1, 0.565414) , 
0.515919, 0, 2, 0, 0.527943) , 
-0.157557, 1, 3, 0, 0.496224) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.658529) , 
-0.766246, 0, 2, 0, 0.509316) , 
NN(
0, 
0, 
0.785578, 0, -1, 1, 0.658077) , 
0.585642, 1, 1, 0, 0.533045) , 
0.948007, 0, 1, 0, 0.513239) , 
-0.924344, 1, 3, 0, 0.501526)    );
  // itree = 168
  fBoostWeights.push_back(0.779424);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.802887, 1, -1, -1, 0.382107) , 
NN(
0, 
0, 
-2.32713, 1, -1, 1, 0.529278) , 
-0.760398, 0, 3, 0, 0.401122) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.576586) , 
-2.46311, 0, 1, 0, 0.416739) , 
NN(
NN(
0, 
0, 
3.21675, 1, -1, -1, 0.295837) , 
NN(
NN(
0, 
0, 
-0.0597337, 1, -1, -1, 0.42361) , 
NN(
0, 
0, 
-0.199382, 0, -1, 1, 0.544249) , 
-0.507056, 1, 3, 0, 0.523165) , 
2.41487, 0, 0, 0, 0.515369) , 
-0.586885, 1, 1, 0, 0.488921)    );
  // itree = 169
  fBoostWeights.push_back(0.79063);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.0420388, 1, -1, -1, 0.344086) , 
NN(
NN(
0, 
0, 
-0.838527, 0, -1, -1, 0.455193) , 
NN(
0, 
0, 
-0.227381, 0, -1, 1, 0.621688) , 
-0.481172, 1, 2, 0, 0.531899) , 
-0.957337, 0, 0, 0, 0.413314) , 
NN(
0, 
0, 
-0.0505591, 1, -1, 1, 0.569814) , 
0.5431, 1, 0, 0, 0.44507) , 
NN(
0, 
0, 
1.3257, 0, -1, 1, 0.518571) , 
0.32752, 1, 3, 0, 0.473736)    );
  // itree = 170
  fBoostWeights.push_back(0.804943);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.17564, 1, -1, -1, 0.381369) , 
NN(
NN(
0, 
0, 
-1.87693, 1, -1, -1, 0.418923) , 
NN(
NN(
0, 
0, 
-1.32767, 0, -1, -1, 0.310093) , 
NN(
0, 
0, 
-1.16095, 1, -1, 1, 0.625008) , 
-1.15888, 1, 3, 0, 0.572348) , 
0.204821, 0, 1, 0, 0.495406) , 
-0.474585, 0, 2, 0, 0.421596) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.635757) , 
0.196767, 1, 3, 0, 0.438855) , 
NN(
NN(
NN(
0, 
0, 
0.486089, 1, -1, -1, 0.434653) , 
NN(
0, 
0, 
1.87407, 0, -1, 1, 0.642528) , 
0.730514, 1, 3, 0, 0.488855) , 
NN(
0, 
0, 
0.498738, 0, -1, 1, 0.609627) , 
0.0736846, 0, 0, 0, 0.532764) , 
0.32752, 1, 3, 0, 0.474906)    );
  // itree = 171
  fBoostWeights.push_back(0.751169);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.31193) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.751633, 0, -1, -1, 0.290223) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.460707) , 
-0.14487, 1, 3, 0, 0.352982) , 
NN(
0, 
0, 
-0.389434, 1, -1, 1, 0.504971) , 
-0.957337, 0, 0, 0, 0.411516) , 
NN(
0, 
0, 
-0.683205, 1, -1, 1, 0.551368) , 
0.5431, 1, 0, 0, 0.444112) , 
NN(
0, 
0, 
-1.93137, 0, -1, 1, 0.600858) , 
-0.970608, 0, 1, 0, 0.473351) , 
0.366173, 0, 2, 0, 0.449248) , 
NN(
0, 
0, 
0.0985762, 0, -1, 1, 0.562158) , 
0.32752, 1, 3, 0, 0.492389)    );
  // itree = 172
  fBoostWeights.push_back(0.711152);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.36034, 1, -1, -1, 0.396999) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.277819) , 
NN(
NN(
0, 
0, 
-2.11299, 0, -1, -1, 0.294345) , 
NN(
NN(
0, 
0, 
-1.7306, 0, -1, -1, 0.110292) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.368615) , 
NN(
NN(
0, 
0, 
-0.424742, 0, -1, -1, 0.396908) , 
NN(
0, 
0, 
-0.205917, 1, -1, 1, 0.605169) , 
-0.462879, 1, 3, 0, 0.534465) , 
-0.137706, 0, 0, 0, 0.460979) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.264534) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.248106) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
-0.893078, 1, -1, 1, 0.681051) , 
-1.17459, 1, 3, 0, 0.658218) , 
-2.0275, 1, 0, 0, 0.621563) , 
1.63239, 0, 1, 0, 0.579333) , 
-0.611862, 0, 2, 0, 0.513462) , 
-1.58794, 1, 3, 0, 0.503604) , 
-1.67335, 1, 2, 0, 0.48599) , 
0.852292, 0, 0, 0, 0.466627) , 
NN(
0, 
0, 
-1.17753, 0, -1, 1, 0.580516) , 
-1.05368, 0, 1, 0, 0.490298) , 
NN(
NN(
0, 
0, 
0.666012, 1, -1, -1, 0.407865) , 
NN(
0, 
0, 
0.738742, 0, -1, 1, 0.616303) , 
-0.1547, 1, 3, 0, 0.582424) , 
0.0206825, 1, 2, 0, 0.543531) , 
1.86861, 0, 0, 0, 0.531631)    );
  // itree = 173
  fBoostWeights.push_back(0.893104);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-1.78077, 0, -1, -1, 0.244643) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.212368) , 
NN(
NN(
0, 
0, 
-1.65816, 1, -1, -1, 0.456242) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.766075) , 
-0.281338, 1, 3, 0, 0.533221) , 
-1.06691, 0, 0, 0, 0.460826) , 
-0.0340835, 1, 1, 0, 0.3925) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.776277) , 
-3.32906, 0, 0, 0, 0.410276) , 
NN(
0, 
0, 
-1.3809, 1, -1, 1, 0.595133) , 
-1.01534, 0, 1, 0, 0.460946) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.269445) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.523508) , 
NN(
0, 
0, 
2.99585, 0, -1, 1, 0.690543) , 
1.3234, 1, 3, 0, 0.591481) , 
0.36034, 1, 2, 0, 0.4515) , 
NN(
0, 
0, 
1.38294, 1, -1, 1, 0.569862) , 
1.86243, 0, 0, 0, 0.558549) , 
-0.862707, 1, 0, 0, 0.537457)    );
  // itree = 174
  fBoostWeights.push_back(0.670093);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.970608, 0, -1, -1, 0.448697) , 
NN(
NN(
0, 
0, 
0.661327, 0, -1, -1, 0.481144) , 
NN(
NN(
0, 
0, 
0.434103, 1, -1, -1, 0.472783) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.428142) , 
NN(
NN(
0, 
0, 
0.704566, 1, -1, 1, 0.563318) , 
NN(
0, 
0, 
1.45572, 0, -1, 1, 0.947484) , 
0.985237, 1, 3, 0, 0.576676) , 
-0.17555, 1, 0, 0, 0.546444) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.10055, 1, 0, 0, 0.573689) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.921082) , 
-0.448435, 0, 0, 0, 0.616754) , 
-0.716463, 1, 0, 0, 0.589298) , 
1.3257, 0, 0, 0, 0.565826) , 
-0.0897679, 1, 3, 0, 0.518756)    );
  // itree = 175
  fBoostWeights.push_back(0.747636);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.68105, 0, -1, -1, 0.369103) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
NN(
0, 
0, 
0.400068, 1, -1, -1, 0.44073) , 
NN(
NN(
0, 
0, 
0.381799, 1, -1, -1, 0.496576) , 
NN(
0, 
0, 
-0.00842384, 0, -1, 1, 0.566754) , 
0.324242, 1, 3, 0, 0.513656) , 
0.673689, 0, 2, 0, 0.501846) , 
-1.6451, 1, 3, 0, 0.500456) , 
-1.31019, 1, 2, 0, 0.49325) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.781847) , 
-3.42721, 0, 0, 0, 0.496638) , 
NN(
0, 
0, 
0.422896, 0, -1, 1, 0.620138) , 
0.744808, 1, 3, 0, 0.509316)    );
  // itree = 176
  fBoostWeights.push_back(0.773741);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.385223) , 
NN(
NN(
0, 
0, 
0.47875, 0, -1, -1, 0.374462) , 
NN(
NN(
NN(
0, 
0, 
-3.17239, 1, -1, -1, 0.39484) , 
NN(
NN(
0, 
0, 
-1.85147, 0, 0, -1, 0) , 
NN(
NN(
NN(
0, 
0, 
-0.651138, 0, -1, -1, 0.376611) , 
NN(
0, 
0, 
-0.194721, 0, -1, 1, 0.505129) , 
-0.45205, 1, 3, 0, 0.485767) , 
NN(
0, 
0, 
-0.852913, 0, -1, 1, 0.62539) , 
-0.889096, 0, 3, 0, 0.494394) , 
-1.17878, 1, 3, 0, 0.490816) , 
-1.22044, 1, 2, 0, 0.481447) , 
NN(
0, 
0, 
-0.243417, 0, -1, 1, 0.579475) , 
0.732311, 1, 0, 0, 0.502372) , 
0.452792, 0, 3, 0, 0.489282) , 
0.599364, 0, 3, 0, 0.482075) , 
NN(
0, 
0, 
0.388636, 0, -1, 1, 0.613395) , 
0.744808, 1, 3, 0, 0.494441)    );
  // itree = 177
  fBoostWeights.push_back(0.767585);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.411939, 1, -1, -1, 0.3078) , 
NN(
NN(
0, 
0, 
-0.259286, 0, -1, -1, 0.36042) , 
NN(
NN(
0, 
0, 
0.335025, 0, -1, -1, 0.382491) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.764608) , 
-0.353913, 1, 3, 0, 0.515323) , 
-0.119192, 1, 1, 0, 0.426264) , 
0.0959412, 0, 0, 0, 0.391792) , 
NN(
0, 
0, 
0.972631, 1, -1, 1, 0.560146) , 
0.680832, 1, 0, 0, 0.427973) , 
NN(
NN(
0, 
0, 
-2.9684, 1, -1, -1, 0.446375) , 
NN(
NN(
0, 
0, 
-0.753051, 1, -1, -1, 0.225971) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.80972) , 
-1.2591, 1, 3, 0, 0.685403) , 
0.152568, 0, 1, 0, 0.564597) , 
-1.79265, 0, 0, 0, 0.449611) , 
NN(
0, 
0, 
0.239673, 1, -1, 1, 0.5531) , 
0.0206825, 1, 2, 0, 0.51067)    );
  // itree = 178
  fBoostWeights.push_back(0.631199);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.04268, 0, -1, -1, 0.353717) , 
NN(
NN(
0, 
0, 
-2.30405, 1, -1, -1, 0.449007) , 
NN(
NN(
0, 
0, 
0.454049, 0, -1, 1, 0.53506) , 
NN(
0, 
0, 
0.388636, 0, -1, 1, 0.643597) , 
0.591226, 1, 3, 0, 0.552312) , 
-0.507056, 1, 3, 0, 0.536234) , 
1.86861, 0, 0, 0, 0.521641)    );
  // itree = 179
  fBoostWeights.push_back(0.715261);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.351835) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.362222) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.222581, 0, -1, -1, 0.358343) , 
NN(
NN(
0, 
0, 
-0.62044, 0, -1, -1, 0.39172) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.649506) , 
-0.400932, 1, 3, 0, 0.496911) , 
-0.735649, 0, 0, 0, 0.434087) , 
NN(
0, 
0, 
-0.414383, 0, -1, 1, 0.562451) , 
0.0287678, 1, 0, 0, 0.465139) , 
NN(
0, 
0, 
-1.17182, 1, -1, 1, 0.625128) , 
-0.98283, 0, 1, 0, 0.484693) , 
-1.47783, 1, 1, 0, 0.472924) , 
NN(
0, 
0, 
0.408972, 1, -1, 1, 0.572212) , 
0.5431, 1, 0, 0, 0.497168) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.761349) , 
2.4829, 1, 1, 0, 0.506479) , 
0.366173, 0, 2, 0, 0.482818) , 
NN(
0, 
0, 
1.3257, 0, -1, 1, 0.56592) , 
0.32752, 1, 3, 0, 0.514549)    );
  // itree = 180
  fBoostWeights.push_back(0.776829);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-1.98061, 0, 0, -1, 0) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.202504) , 
NN(
NN(
0, 
0, 
-1.44905, 0, -1, -1, 0.354555) , 
NN(
0, 
0, 
0.239949, 0, -1, -1, 0.491864) , 
-0.815987, 1, 3, 0, 0.444579) , 
-0.463873, 0, 2, 0, 0.41661) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.660599) , 
-1.56066, 0, 2, 0, 0.432653) , 
-1.89783, 1, 3, 0, 0.420384) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.713394) , 
-2.22382, 0, 2, 0, 0.430724) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.812496) , 
-3.19544, 0, 0, 0, 0.444093) , 
NN(
0, 
0, 
-0.0492042, 0, -1, 1, 0.550178) , 
-0.372003, 1, 2, 0, 0.494196) , 
NN(
0, 
0, 
1.3257, 0, -1, 1, 0.582464) , 
0.0206825, 1, 2, 0, 0.547486)    );
  // itree = 181
  fBoostWeights.push_back(0.697721);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.405165, 1, -1, -1, 0.253592) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.72943) , 
1.42167, 1, 3, 0, 0.303027) , 
NN(
0, 
0, 
1.59466, 0, -1, -1, 0.472102) , 
0.300485, 0, 1, 0, 0.394535) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.311708) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.113775) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.287373) , 
NN(
0, 
0, 
-2.18234, 1, -1, -1, 0.441926) , 
-0.557784, 0, 3, 0, 0.407318) , 
2.14785, 0, 1, 0, 0.384743) , 
NN(
0, 
0, 
-1.08199, 0, -1, 1, 0.590671) , 
-0.511558, 1, 2, 0, 0.453698) , 
0.230113, 0, 0, 0, 0.417133) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.579727) , 
-0.111734, 1, 2, 0, 0.447457) , 
NN(
0, 
0, 
-0.355106, 0, -1, 1, 0.571151) , 
0.767972, 1, 0, 0, 0.463361) , 
NN(
0, 
0, 
0.242569, 1, -1, 1, 0.545539) , 
0.0206825, 1, 2, 0, 0.509993) , 
1.32235, 0, 0, 0, 0.492713)    );
  // itree = 182
  fBoostWeights.push_back(0.795611);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.65668, 1, -1, -1, 0.426588) , 
NN(
NN(
0, 
0, 
-2.34771, 1, -1, -1, 0.478878) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.764523) , 
-0.614517, 1, 3, 0, 0.610687) , 
-1.81287, 0, 0, 0, 0.452773) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.347042) , 
NN(
NN(
NN(
0, 
0, 
-0.202603, 0, -1, -1, 0.440608) , 
NN(
0, 
0, 
1.11754, 0, -1, 1, 0.608954) , 
0.400103, 1, 2, 0, 0.50823) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.78393) , 
0.577161, 0, 0, 0, 0.538502) , 
0.464968, 1, 0, 0, 0.517174) , 
-0.608787, 1, 3, 0, 0.508479) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.690956) , 
0.349986, 0, 0, 0, 0.52531) , 
0.22982, 1, 0, 0, 0.483026)    );
  // itree = 183
  fBoostWeights.push_back(0.727268);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.27602, 0, -1, -1, 0.37368) , 
NN(
NN(
NN(
0, 
0, 
-0.00585625, 1, -1, -1, 0.334101) , 
NN(
NN(
0, 
0, 
-1.63211, 0, -1, -1, 0.260869) , 
NN(
0, 
0, 
1.71545, 0, -1, 1, 0.510176) , 
-1.15465, 1, 3, 0, 0.460766) , 
-0.275378, 0, 2, 0, 0.414468) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.60836) , 
0.126029, 1, 2, 0, 0.46227) , 
-0.0640205, 0, 3, 0, 0.426722) , 
NN(
0, 
0, 
1.06593, 0, -1, 1, 0.513864) , 
0.32752, 1, 3, 0, 0.457598)    );
  // itree = 184
  fBoostWeights.push_back(0.804432);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.13358, 1, -1, -1, 0.355263) , 
NN(
NN(
0, 
0, 
-0.785729, 0, -1, -1, 0.280276) , 
NN(
0, 
0, 
0.254683, 0, -1, 1, 0.507301) , 
-0.420954, 1, 3, 0, 0.440399) , 
-0.100174, 0, 1, 0, 0.391875) , 
NN(
0, 
0, 
2.20045, 0, -1, 1, 0.546751) , 
1.71545, 1, 1, 0, 0.405739) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.611684) , 
0.196767, 1, 3, 0, 0.422108) , 
NN(
0, 
0, 
-2.14924, 0, -1, 1, 0.545585) , 
0.32752, 1, 3, 0, 0.465452)    );
  // itree = 185
  fBoostWeights.push_back(0.82335);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.658508, 1, -1, -1, 0.390008) , 
NN(
NN(
0, 
0, 
-1.96692, 0, -1, -1, 0.374953) , 
NN(
NN(
NN(
0, 
0, 
-0.44231, 0, -1, -1, 0.275017) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.609707) , 
-0.548793, 1, 3, 0, 0.523495) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.866093) , 
-1.08406, 1, 0, 0, 0.595804) , 
0.116823, 0, 1, 0, 0.488391) , 
-0.774197, 0, 0, 0, 0.424261) , 
NN(
0, 
0, 
-0.170634, 1, -1, 1, 0.733541) , 
0.907668, 1, 3, 0, 0.438906) , 
NN(
0, 
0, 
-0.125526, 0, -1, 1, 0.54628) , 
0.776084, 1, 0, 0, 0.466613) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.835163) , 
2.4829, 1, 1, 0, 0.476923)    );
  // itree = 186
  fBoostWeights.push_back(0.733121);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.97528, 0, -1, -1, 0.3356) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.209901) , 
NN(
NN(
0, 
0, 
-0.425136, 0, -1, -1, 0.370405) , 
NN(
0, 
0, 
0.353349, 0, -1, 1, 0.512585) , 
-0.4656, 1, 3, 0, 0.456441) , 
-0.106858, 0, 3, 0, 0.4189) , 
NN(
0, 
0, 
0.125261, 0, -1, 1, 0.532447) , 
0.0364975, 1, 3, 0, 0.468136) , 
-1.42633, 1, 1, 0, 0.45382) , 
NN(
0, 
0, 
0.120589, 1, -1, 1, 0.611678) , 
1.34551, 1, 0, 0, 0.468869) , 
NN(
0, 
0, 
1.47531, 0, -1, 1, 0.658666) , 
0.744808, 1, 3, 0, 0.49068)    );
  // itree = 187
  fBoostWeights.push_back(0.844318);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.249321) , 
NN(
NN(
NN(
0, 
0, 
-0.780321, 0, -1, -1, 0.245199) , 
NN(
NN(
NN(
0, 
0, 
-0.634481, 0, -1, -1, 0.125301) , 
NN(
NN(
0, 
0, 
-0.709146, 0, -1, -1, 0.305067) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.599955) , 
-0.779876, 1, 3, 0, 0.416455) , 
-0.620634, 0, 2, 0, 0.280256) , 
NN(
0, 
0, 
0.0190145, 0, -1, -1, 0.483036) , 
-0.288024, 1, 2, 0, 0.409462) , 
-1.4808, 1, 0, 0, 0.376407) , 
NN(
0, 
0, 
0.695875, 1, -1, 1, 0.570061) , 
-1.98104, 0, 0, 0, 0.400318) , 
0.248926, 0, 2, 0, 0.375887) , 
NN(
0, 
0, 
-0.187425, 0, -1, -1, 0.478952) , 
0.543964, 1, 2, 0, 0.397329) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.853578) , 
-3.383, 0, 0, 0, 0.402245) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.631501) , 
-1.89507, 0, 1, 0, 0.420623) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.234256) , 
NN(
0, 
0, 
0.526656, 0, -1, 1, 0.524251) , 
0.0735737, 1, 3, 0, 0.432438) , 
NN(
NN(
0, 
0, 
0.91294, 1, -1, 1, 0.523562) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.803391) , 
-0.279039, 0, 3, 0, 0.571688) , 
0.234882, 1, 1, 0, 0.515878) , 
NN(
0, 
0, 
-1.02884, 1, -1, 1, 0.674193) , 
-0.812814, 0, 1, 0, 0.545682) , 
0.22982, 1, 0, 0, 0.476032)    );
  // itree = 188
  fBoostWeights.push_back(0.827274);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.542084, 0, -1, -1, 0.252195) , 
NN(
0, 
0, 
-0.60719, 1, -1, -1, 0.481983) , 
-0.214015, 1, 3, 0, 0.352197) , 
NN(
0, 
0, 
-1.09137, 0, -1, -1, 0.491283) , 
-0.892541, 0, 2, 0, 0.388427) , 
NN(
0, 
0, 
-0.291812, 0, -1, 1, 0.539204) , 
0.44922, 1, 0, 0, 0.436482) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.417613) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.309769) , 
NN(
NN(
NN(
0, 
0, 
-1.44085, 0, -1, -1, 0.316826) , 
NN(
NN(
NN(
0, 
0, 
0.697122, 0, -1, -1, 0.486701) , 
NN(
0, 
0, 
0.514729, 1, -1, 1, 0.665004) , 
0.544374, 1, 3, 0, 0.576985) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.791334) , 
1.41056, 1, 1, 0, 0.606901) , 
-0.963555, 1, 1, 0, 0.563988) , 
NN(
NN(
0, 
0, 
-0.250328, 0, -1, 1, 0.53089) , 
NN(
0, 
0, 
0.891647, 0, -1, 1, 0.748996) , 
0.117378, 1, 3, 0, 0.648883) , 
0.415236, 0, 2, 0, 0.602766) , 
-2.09512, 1, 1, 0, 0.593627) , 
-1.17833, 1, 0, 0, 0.578515) , 
0.0206825, 1, 2, 0, 0.521074)    );
  // itree = 189
  fBoostWeights.push_back(0.735324);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.268469, 0, -1, -1, 0.326206) , 
NN(
NN(
NN(
0, 
0, 
0.793461, 0, -1, -1, 0.358554) , 
NN(
NN(
0, 
0, 
-0.299561, 1, -1, -1, 0.386335) , 
NN(
0, 
0, 
-0.457898, 0, -1, 1, 0.568968) , 
-0.533151, 0, 3, 0, 0.46061) , 
-1.66661, 1, 0, 0, 0.429908) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
-0.0886442, 0, -1, 1, 0.576268) , 
-0.572701, 1, 3, 0, 0.544035) , 
0.44922, 1, 0, 0, 0.463882) , 
-0.111734, 0, 2, 0, 0.434208) , 
NN(
NN(
NN(
0, 
0, 
0.388843, 0, -1, -1, 0.495529) , 
NN(
0, 
0, 
0.229143, 1, -1, 1, 0.586241) , 
0.883244, 1, 2, 0, 0.517617) , 
NN(
0, 
0, 
0.274268, 0, -1, 1, 0.673635) , 
-0.760989, 0, 0, 0, 0.548654) , 
0.0206825, 1, 2, 0, 0.503714)    );
  // itree = 190
  fBoostWeights.push_back(0.676413);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.82499, 1, -1, -1, 0.261991) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.14972, 0, -1, -1, 0.278281) , 
NN(
NN(
NN(
0, 
0, 
-0.662902, 1, -1, -1, 0.156051) , 
NN(
0, 
0, 
0.259727, 0, -1, -1, 0.44939) , 
-1.12772, 1, 3, 0, 0.435412) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.825013) , 
-1.9578, 0, 2, 0, 0.454806) , 
-2.0633, 1, 0, 0, 0.431157) , 
NN(
NN(
0, 
0, 
0.479746, 1, -1, -1, 0.431985) , 
NN(
NN(
0, 
0, 
0.690934, 1, -1, -1, 0.419184) , 
NN(
NN(
0, 
0, 
0.54128, 1, -1, 1, 0.515799) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.550183) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.490594) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.910475) , 
-0.141231, 1, 3, 0, 0.741992) , 
0.195193, 0, 2, 0, 0.668761) , 
-0.0332738, 0, 0, 0, 0.586143) , 
0.509326, 0, 2, 0, 0.546026) , 
0.638075, 0, 1, 0, 0.506089) , 
-0.204632, 1, 2, 0, 0.483329) , 
NN(
0, 
0, 
1.71637, 0, -1, 1, 0.650272) , 
0.853908, 1, 2, 0, 0.501344) , 
2.41487, 0, 0, 0, 0.491768)    );
  // itree = 191
  fBoostWeights.push_back(0.72784);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.281124) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.450161, 1, -1, -1, 0.387686) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.540482) , 
-0.193865, 0, 3, 0, 0.412178) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.96779, 1, 2, 0, 0.419151) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.260349) , 
NN(
NN(
0, 
0, 
0.17425, 1, -1, -1, 0.442268) , 
NN(
NN(
0, 
0, 
-0.831001, 1, -1, -1, 0.407643) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.765532) , 
-0.119186, 1, 3, 0, 0.551324) , 
-0.121964, 0, 1, 0, 0.46454) , 
0.679141, 0, 3, 0, 0.451296) , 
NN(
0, 
0, 
0.158834, 1, -1, 1, 0.60664) , 
0.846377, 1, 2, 0, 0.468677) , 
NN(
NN(
0, 
0, 
-1.20068, 0, -1, -1, 0.357585) , 
NN(
0, 
0, 
0.157743, 0, -1, 1, 0.648576) , 
-0.336012, 1, 2, 0, 0.577734) , 
-0.655495, 0, 1, 0, 0.491478) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.719086) , 
-1.26697, 0, 1, 0, 0.499885) , 
0.776084, 0, 0, 0, 0.476722) , 
-1.67215, 1, 1, 0, 0.467589) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.734293) , 
-2.12178, 0, 1, 0, 0.474079)    );
  // itree = 192
  fBoostWeights.push_back(0.752559);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.118437, 1, -1, -1, 0.357596) , 
NN(
0, 
0, 
-0.220137, 0, -1, 1, 0.628629) , 
0.793271, 1, 3, 0, 0.417239) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.162238) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.213994) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.338038) , 
NN(
0, 
0, 
0.246031, 0, -1, 1, 0.569622) , 
0.0121408, 0, 3, 0, 0.450135) , 
0.476181, 0, 1, 0, 0.409593) , 
NN(
0, 
0, 
0.872476, 0, -1, 1, 0.520289) , 
0.591646, 1, 1, 0, 0.465025) , 
1.45483, 0, 1, 0, 0.444695) , 
NN(
0, 
0, 
-0.800771, 1, -1, 1, 0.629915) , 
1.75358, 1, 1, 0, 0.47361) , 
NN(
NN(
0, 
0, 
-2.94347, 0, -1, -1, 0.253733) , 
NN(
NN(
0, 
0, 
0.097855, 1, -1, 1, 0.527873) , 
NN(
0, 
0, 
-0.842196, 1, -1, 1, 0.68034) , 
-0.260193, 0, 3, 0, 0.573356) , 
-2.20172, 1, 0, 0, 0.558198) , 
0.0642531, 0, 1, 0, 0.513971) , 
0.776084, 0, 0, 0, 0.487013)    );
  // itree = 193
  fBoostWeights.push_back(0.789629);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.215413) , 
NN(
0, 
0, 
1.78812, 0, -1, -1, 0.477057) , 
0.984958, 1, 3, 0, 0.277329) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.244222) , 
NN(
0, 
0, 
-0.604909, 1, -1, 1, 0.578075) , 
0.918132, 1, 3, 0, 0.388753) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.616473) , 
1.59466, 0, 0, 0, 0.463739) , 
0.300485, 0, 1, 0, 0.385124) , 
NN(
NN(
0, 
0, 
2.43612, 0, -1, -1, 0.453847) , 
NN(
0, 
0, 
0.132373, 1, -1, 1, 0.550837) , 
-0.25021, 1, 3, 0, 0.519699) , 
1.32235, 0, 0, 0, 0.498684)    );
  // itree = 194
  fBoostWeights.push_back(0.864544);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
2.03131, 0, -1, -1, 0.241975) , 
NN(
NN(
NN(
0, 
0, 
-0.088107, 0, -1, -1, 0.404379) , 
NN(
0, 
0, 
1.30059, 1, -1, 1, 0.539073) , 
0.544374, 1, 3, 0, 0.471896) , 
NN(
NN(
0, 
0, 
0.330981, 0, -1, -1, 0.352643) , 
NN(
NN(
NN(
0, 
0, 
0.278804, 1, -1, -1, 0.471651) , 
NN(
NN(
0, 
0, 
-1.1106, 0, -1, -1, 0.45713) , 
NN(
0, 
0, 
-0.657895, 0, -1, 1, 0.697329) , 
-0.827359, 1, 3, 0, 0.598186) , 
-0.267289, 0, 2, 0, 0.534675) , 
NN(
NN(
NN(
0, 
0, 
-0.383025, 1, -1, -1, 0.45064) , 
NN(
0, 
0, 
0.347709, 1, -1, 1, 0.637247) , 
-0.147512, 1, 3, 0, 0.554453) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.841414) , 
0.202336, 1, 2, 0, 0.642014) , 
-0.175414, 1, 0, 0, 0.587244) , 
1.19069, 0, 0, 0, 0.562149) , 
0.392338, 0, 2, 0, 0.531775) , 
1.68312, 0, 1, 0, 0.512715) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.77646) , 
2.4829, 1, 1, 0, 0.518998)    );
  // itree = 195
  fBoostWeights.push_back(0.750982);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.56088, 1, -1, -1, 0.308151) , 
NN(
NN(
0, 
0, 
-1.29554, 0, -1, -1, 0.406414) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.713048) , 
-0.411676, 1, 3, 0, 0.464352) , 
-0.233811, 0, 2, 0, 0.380918) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.759932) , 
-3.32906, 0, 0, 0, 0.397455) , 
NN(
NN(
NN(
0, 
0, 
0.285685, 1, -1, -1, 0.396187) , 
NN(
NN(
NN(
NN(
0, 
0, 
1.38202, 1, -1, -1, 0.474378) , 
NN(
0, 
0, 
0.880556, 0, -1, 1, 0.708571) , 
0.566761, 1, 3, 0, 0.502948) , 
NN(
0, 
0, 
-0.27185, 1, -1, 1, 0.683203) , 
1.33173, 1, 1, 0, 0.522415) , 
NN(
0, 
0, 
0.387821, 0, -1, 1, 0.672353) , 
-0.458843, 0, 0, 0, 0.54402) , 
0.743326, 0, 2, 0, 0.51637) , 
NN(
0, 
0, 
1.60813, 0, -1, 1, 0.676818) , 
1.38699, 1, 2, 0, 0.523023) , 
-0.862707, 1, 0, 0, 0.49493)    );
  // itree = 196
  fBoostWeights.push_back(0.736543);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.599936, 1, -1, -1, 0.42992) , 
NN(
NN(
NN(
0, 
0, 
-0.388795, 0, -1, -1, 0.408596) , 
NN(
0, 
0, 
-1.56936, 0, -1, 1, 0.546712) , 
-0.191793, 0, 3, 0, 0.49723) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.323065) , 
NN(
NN(
NN(
0, 
0, 
-0.717314, 1, -1, -1, 0.451487) , 
NN(
0, 
0, 
0.35787, 0, -1, 1, 0.602329) , 
0.029662, 1, 3, 0, 0.561888) , 
NN(
0, 
0, 
0.452991, 1, -1, 1, 0.68738) , 
0.242569, 1, 0, 0, 0.604886) , 
-1.70286, 1, 1, 0, 0.585875) , 
0.0206825, 1, 2, 0, 0.546453) , 
1.32235, 0, 0, 0, 0.5293)    );
  // itree = 197
  fBoostWeights.push_back(0.733894);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.22255, 0, -1, -1, 0.259979) , 
NN(
NN(
NN(
0, 
0, 
-1.85041, 0, -1, -1, 0.435388) , 
NN(
NN(
0, 
0, 
-0.868426, 0, -1, 1, 0.525326) , 
NN(
NN(
NN(
0, 
0, 
-0.579794, 0, -1, -1, 0.417603) , 
NN(
0, 
0, 
-0.341346, 1, -1, 1, 0.634673) , 
0.777513, 1, 3, 0, 0.475527) , 
NN(
0, 
0, 
0.865581, 0, -1, 1, 0.652386) , 
-0.0706148, 1, 1, 0, 0.597781) , 
0.524844, 1, 0, 0, 0.555022) , 
-1.1404, 1, 0, 0, 0.539995) , 
NN(
0, 
0, 
-2.35493, 1, -1, 1, 0.721131) , 
-2.01577, 0, 0, 0, 0.548689) , 
-1.75892, 1, 3, 0, 0.544378)    );
  // itree = 198
  fBoostWeights.push_back(0.84291);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.3159, 1, -1, -1, 0.361764) , 
NN(
0, 
0, 
1.38915, 0, -1, 1, 0.504982) , 
0.46084, 1, 3, 0, 0.391166) , 
NN(
NN(
0, 
0, 
0.238282, 0, -1, -1, 0.279047) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.342009) , 
NN(
NN(
NN(
0, 
0, 
-0.806762, 0, -1, -1, 0.293451) , 
NN(
0, 
0, 
1.10451, 1, -1, 1, 0.557928) , 
0.0133513, 1, 2, 0, 0.437574) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.348027, 0, -1, -1, 0.36777) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.825942) , 
0.626422, 1, 3, 0, 0.446149) , 
NN(
0, 
0, 
0.00366176, 0, -1, 1, 0.635451) , 
0.207637, 1, 1, 0, 0.545569) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.880977) , 
-0.0987647, 0, 1, 0, 0.581561) , 
-0.200051, 1, 1, 0, 0.527392) , 
0.358239, 0, 1, 0, 0.503447) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.406576) , 
NN(
NN(
0, 
0, 
-1.0775, 0, -1, 1, 0.557281) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.843131) , 
-0.0168383, 1, 3, 0, 0.703201) , 
0.83057, 0, 0, 0, 0.636777) , 
0.439717, 1, 1, 0, 0.539306) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.453101) , 
NN(
NN(
NN(
0, 
0, 
0.85464, 1, -1, -1, 0.475782) , 
NN(
NN(
0, 
0, 
-0.474549, 0, -1, 1, 0.617777) , 
NN(
0, 
0, 
-0.953372, 0, -1, 1, 0.857604) , 
0.436742, 1, 3, 0, 0.691565) , 
-1.26704, 1, 1, 0, 0.637269) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.771488) , 
-1.99041, 0, 1, 0, 0.663149) , 
-1.65, 1, 0, 0, 0.640619) , 
-0.612783, 0, 1, 0, 0.578154) , 
-1.30333, 1, 2, 0, 0.567067) , 
0.948007, 0, 1, 0, 0.528902)    );
  // itree = 199
  fBoostWeights.push_back(0.7507);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
2.17648, 0, -1, -1, 0.290602) , 
NN(
0, 
0, 
0.0794625, 0, -1, -1, 0.465568) , 
-0.277011, 1, 3, 0, 0.414215) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.310334, 0, -1, -1, 0.322943) , 
NN(
0, 
0, 
1.65246, 0, -1, 1, 0.648355) , 
0.994109, 1, 3, 0, 0.388658) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.309474, 0, -1, -1, 0.16794) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.561654) , 
-0.0803205, 1, 3, 0, 0.374516) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.308795) , 
NN(
NN(
0, 
0, 
-0.747939, 1, -1, -1, 0.418157) , 
NN(
0, 
0, 
-0.0778963, 0, -1, 1, 0.616337) , 
-0.679399, 1, 3, 0, 0.566658) , 
-0.286916, 0, 0, 0, 0.487951) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.64396) , 
0.359164, 1, 0, 0, 0.526505) , 
-0.445103, 0, 1, 0, 0.499313) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.740652) , 
-1.90075, 0, 1, 0, 0.530749) , 
0.537476, 0, 2, 0, 0.492355) , 
NN(
NN(
0, 
0, 
0.301309, 1, -1, -1, 0.428637) , 
NN(
0, 
0, 
-1.00348, 0, -1, 1, 0.628126) , 
-0.378107, 1, 2, 0, 0.590933) , 
-0.133413, 1, 1, 0, 0.537237) , 
0.948007, 0, 1, 0, 0.511566)    );
  // itree = 200
  fBoostWeights.push_back(0.949002);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.33519, 0, -1, -1, 0.387858) , 
NN(
NN(
NN(
NN(
0, 
0, 
1.08451, 1, -1, -1, 0.243686) , 
NN(
0, 
0, 
1.64619, 0, -1, 1, 0.680971) , 
0.921132, 1, 2, 0, 0.319983) , 
NN(
NN(
NN(
0, 
0, 
-0.638154, 0, -1, -1, 0.317097) , 
NN(
NN(
0, 
0, 
-0.981699, 0, -1, -1, 0.421186) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.759382) , 
-0.275378, 1, 2, 0, 0.540653) , 
0.114851, 0, 2, 0, 0.446538) , 
NN(
0, 
0, 
-1.15891, 0, -1, 1, 0.641865) , 
-0.0668125, 1, 0, 0, 0.519826) , 
0.620948, 0, 0, 0, 0.469168) , 
NN(
NN(
0, 
0, 
0.632731, 1, -1, 1, 0.509666) , 
NN(
0, 
0, 
1.08937, 1, -1, 1, 0.686107) , 
0.0372545, 1, 3, 0, 0.597796) , 
0.106272, 1, 1, 0, 0.519527) , 
0.948007, 0, 1, 0, 0.49173)    );
  // itree = 201
  fBoostWeights.push_back(0.78869);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.17465, 1, -1, -1, 0.391009) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.494665) , 
-0.216984, 1, 3, 0, 0.413686) , 
NN(
0, 
0, 
-0.541653, 0, -1, 1, 0.53112) , 
-0.0897679, 1, 3, 0, 0.48739)    );
  // itree = 202
  fBoostWeights.push_back(0.747955);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.180715, 1, -1, -1, 0.38526) , 
NN(
NN(
0, 
0, 
-0.240544, 0, -1, -1, 0.38591) , 
NN(
0, 
0, 
-0.205996, 1, -1, 1, 0.55827) , 
-0.431958, 1, 3, 0, 0.487056) , 
-0.0640205, 0, 3, 0, 0.449477) , 
NN(
0, 
0, 
0.908359, 0, -1, 1, 0.53363) , 
0.32752, 1, 3, 0, 0.483435)    );
  // itree = 203
  fBoostWeights.push_back(0.73398);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.10233, 1, -1, -1, 0.349079) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.207744, 1, -1, -1, 0.378174) , 
NN(
0, 
0, 
1.21415, 0, -1, 1, 0.533913) , 
0.325318, 1, 3, 0, 0.465605) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.248257) , 
NN(
0, 
0, 
-1.11622, 0, -1, 1, 0.599779) , 
-0.78155, 1, 3, 0, 0.574047) , 
-0.0438787, 0, 2, 0, 0.496795) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.350383) , 
NN(
0, 
0, 
-0.0147425, 1, -1, 1, 0.591807) , 
-0.380687, 1, 3, 0, 0.564599) , 
-0.586885, 0, 1, 0, 0.518626) , 
-0.924344, 1, 3, 0, 0.507574)    );
  // itree = 204
  fBoostWeights.push_back(0.798448);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.42312, 1, -1, -1, 0.429024) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.292341) , 
NN(
0, 
0, 
-2.16162, 1, -1, -1, 0.447414) , 
-0.793915, 0, 3, 0, 0.393318) , 
NN(
0, 
0, 
-0.555459, 1, -1, 1, 0.618143) , 
-0.887414, 1, 2, 0, 0.537127) , 
-0.268473, 0, 2, 0, 0.476292) , 
NN(
0, 
0, 
-0.760989, 1, -1, 1, 0.553241) , 
0.32752, 1, 3, 0, 0.506628)    );
  // itree = 205
  fBoostWeights.push_back(0.881823);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.312785) , 
NN(
NN(
NN(
0, 
0, 
0.263476, 0, -1, -1, 0.382515) , 
NN(
NN(
0, 
0, 
-1.85878, 0, -1, -1, 0.3547) , 
NN(
0, 
0, 
-1.66967, 1, -1, 1, 0.629786) , 
-0.663579, 1, 2, 0, 0.497609) , 
-0.957337, 0, 0, 0, 0.420798) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.288754) , 
NN(
0, 
0, 
-0.0590435, 0, -1, 1, 0.633171) , 
-0.358683, 1, 3, 0, 0.583267) , 
0.5431, 1, 0, 0, 0.454872) , 
0.366173, 0, 2, 0, 0.432429) , 
NN(
0, 
0, 
1.74303, 1, -1, 1, 0.508111) , 
0.32752, 1, 3, 0, 0.462275)    );
  // itree = 206
  fBoostWeights.push_back(0.800163);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.31734, 1, -1, -1, 0.217273) , 
NN(
0, 
0, 
1.29982, 1, -1, -1, 0.406263) , 
0.786817, 0, 2, 0, 0.378409) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.302177) , 
NN(
0, 
0, 
1.49078, 0, -1, 1, 0.545986) , 
0.702505, 1, 3, 0, 0.406312) , 
NN(
NN(
0, 
0, 
-3.14509, 0, -1, -1, 0.258942) , 
NN(
NN(
NN(
0, 
0, 
0.193237, 1, -1, -1, 0.441384) , 
NN(
NN(
0, 
0, 
0.575116, 0, -1, 1, 0.500533) , 
NN(
0, 
0, 
0.675566, 0, -1, 1, 0.651599) , 
0.309595, 1, 2, 0, 0.558579) , 
0.0121275, 0, 1, 0, 0.526841) , 
NN(
0, 
0, 
-1.21075, 1, -1, 1, 0.674409) , 
-0.79408, 0, 2, 0, 0.542618) , 
-2.29992, 1, 0, 0, 0.532951) , 
1.21578, 0, 0, 0, 0.510321) , 
0.564284, 0, 1, 0, 0.46666)    );
  // itree = 207
  fBoostWeights.push_back(0.776241);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.56656, 1, -1, -1, 0.329134) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.334125) , 
NN(
NN(
NN(
0, 
0, 
0.282965, 1, -1, -1, 0.432646) , 
NN(
0, 
0, 
-0.56838, 1, -1, 1, 0.537381) , 
-0.0836028, 0, 3, 0, 0.483092) , 
NN(
0, 
0, 
0.388636, 0, -1, 1, 0.567846) , 
0.603237, 1, 3, 0, 0.500151) , 
1.23136, 0, 1, 0, 0.490791) , 
1.36702, 0, 1, 0, 0.471185) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.757132) , 
2.4829, 1, 1, 0, 0.477981)    );
  // itree = 208
  fBoostWeights.push_back(0.773763);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.0879588, 0, -1, -1, 0.336566) , 
NN(
0, 
0, 
0.844788, 1, -1, 1, 0.575111) , 
0.584584, 1, 3, 0, 0.379279) , 
NN(
NN(
NN(
0, 
0, 
0.0201372, 1, -1, -1, 0.447882) , 
NN(
NN(
NN(
0, 
0, 
0.199778, 1, -1, -1, 0.414278) , 
NN(
0, 
0, 
0.620224, 0, -1, 1, 0.555497) , 
0.3305, 1, 3, 0, 0.474731) , 
NN(
NN(
NN(
0, 
0, 
-0.483011, 0, -1, -1, 0.449021) , 
NN(
0, 
0, 
0.287563, 0, -1, 1, 0.584108) , 
-0.220964, 1, 3, 0, 0.524392) , 
NN(
0, 
0, 
-0.638612, 1, -1, 1, 0.704333) , 
0.18862, 0, 1, 0, 0.584377) , 
-0.229219, 0, 0, 0, 0.521378) , 
-0.70517, 1, 1, 0, 0.508362) , 
NN(
0, 
0, 
1.90101, 1, -1, 1, 0.676665) , 
1.1988, 1, 2, 0, 0.515) , 
-1.35433, 1, 1, 0, 0.498999)    );
  // itree = 209
  fBoostWeights.push_back(0.765926);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.224849) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.294233) , 
NN(
0, 
0, 
1.17644, 1, -1, -1, 0.438568) , 
-0.229642, 0, 3, 0, 0.378488) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.554488) , 
0.0354075, 1, 3, 0, 0.415401) , 
NN(
0, 
0, 
-0.405024, 1, -1, 1, 0.573288) , 
-0.294215, 0, 1, 0, 0.440118) , 
0.297597, 0, 2, 0, 0.386495) , 
NN(
0, 
0, 
-0.586123, 1, -1, 1, 0.631103) , 
1.73014, 1, 1, 0, 0.412543) , 
NN(
0, 
0, 
-0.519691, 1, -1, 1, 0.57296) , 
-0.586885, 0, 1, 0, 0.461962) , 
NN(
0, 
0, 
0.939046, 1, -1, 1, 0.603481) , 
0.32752, 1, 3, 0, 0.51641)    );
  // itree = 210
  fBoostWeights.push_back(0.759771);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.180715, 1, -1, -1, 0.374164) , 
NN(
0, 
0, 
0.760086, 0, -1, 1, 0.501914) , 
-0.0640205, 0, 3, 0, 0.452304) , 
NN(
NN(
0, 
0, 
0.369541, 0, -1, -1, 0.436281) , 
NN(
0, 
0, 
0.744332, 0, -1, 1, 0.608479) , 
0.563743, 1, 3, 0, 0.525942) , 
0.32752, 1, 3, 0, 0.480825)    );
  // itree = 211
  fBoostWeights.push_back(0.687626);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.391587, 1, -1, -1, 0.42253) , 
NN(
NN(
0, 
0, 
-0.241811, 0, -1, -1, 0.448053) , 
NN(
0, 
0, 
-0.13372, 0, -1, 1, 0.565773) , 
-0.22779, 1, 3, 0, 0.52557) , 
0.221997, 0, 3, 0, 0.479587) , 
NN(
0, 
0, 
1.18005, 0, -1, 1, 0.626087) , 
0.976901, 1, 3, 0, 0.48793) , 
NN(
NN(
0, 
0, 
-2.98069, 1, -1, -1, 0.466569) , 
NN(
0, 
0, 
-0.698381, 0, -1, 1, 0.625557) , 
-1.34249, 1, 3, 0, 0.580758) , 
-0.812543, 0, 2, 0, 0.497843)    );
  // itree = 212
  fBoostWeights.push_back(0.5886);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.840919, 0, -1, -1, 0.435269) , 
NN(
NN(
NN(
0, 
0, 
-0.355748, 1, -1, -1, 0.44808) , 
NN(
0, 
0, 
0.240009, 1, -1, 1, 0.633098) , 
0.810201, 1, 3, 0, 0.49357) , 
NN(
0, 
0, 
-0.586885, 0, -1, 1, 0.56419) , 
0.495537, 0, 2, 0, 0.542085) , 
-0.924344, 1, 3, 0, 0.535021)    );
  // itree = 213
  fBoostWeights.push_back(0.825211);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.170243, 0, -1, -1, 0.377685) , 
NN(
NN(
NN(
0, 
0, 
-1.48517, 0, -1, -1, 0.376852) , 
NN(
NN(
0, 
0, 
-2.98069, 1, -1, -1, 0.35836) , 
NN(
0, 
0, 
0.385486, 0, -1, 1, 0.566869) , 
-1.15477, 1, 3, 0, 0.531713) , 
-0.586885, 1, 1, 0, 0.474527) , 
NN(
NN(
0, 
0, 
0.0185295, 0, -1, -1, 0.39751) , 
NN(
0, 
0, 
0.0754018, 0, -1, 1, 0.659302) , 
-0.227742, 1, 3, 0, 0.597735) , 
-0.348962, 1, 2, 0, 0.528123) , 
0.0488495, 0, 2, 0, 0.476158) , 
NN(
0, 
0, 
1.06593, 0, -1, 1, 0.54869) , 
0.32752, 1, 3, 0, 0.503871)    );
  // itree = 214
  fBoostWeights.push_back(0.622136);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.82499, 1, -1, -1, 0.387122) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.612639, 0, -1, -1, 0.35022) , 
NN(
0, 
0, 
-0.220782, 0, -1, -1, 0.496333) , 
-0.453517, 1, 3, 0, 0.457015) , 
NN(
NN(
0, 
0, 
-2.16162, 1, -1, -1, 0.490072) , 
NN(
0, 
0, 
0.512701, 0, -1, 1, 0.628072) , 
-1.24997, 1, 3, 0, 0.593503) , 
-0.784773, 0, 2, 0, 0.49461) , 
NN(
0, 
0, 
-1.70232, 1, -1, 1, 0.553987) , 
-0.0897679, 1, 3, 0, 0.530449) , 
2.41487, 0, 0, 0, 0.523773)    );
  // itree = 215
  fBoostWeights.push_back(0.817434);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.784773, 0, -1, -1, 0.43) , 
NN(
NN(
0, 
0, 
0.447597, 1, -1, -1, 0.416087) , 
NN(
NN(
NN(
NN(
0, 
0, 
1.16318, 1, -1, 1, 0.531491) , 
NN(
0, 
0, 
1.65894, 0, -1, 1, 0.67596) , 
0.970927, 1, 3, 0, 0.545164) , 
NN(
0, 
0, 
2.08973, 0, 0, 1, 1) , 
2.13426, 1, 3, 0, 0.549157) , 
NN(
0, 
0, 
1.05811, 0, -1, 1, 0.747178) , 
0.406628, 1, 1, 0, 0.571657) , 
0.744413, 0, 1, 0, 0.530564) , 
-0.0897679, 1, 3, 0, 0.492378)    );
  // itree = 216
  fBoostWeights.push_back(0.771645);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.327568) , 
NN(
NN(
0, 
0, 
-0.437282, 0, -1, -1, 0.380966) , 
NN(
NN(
0, 
0, 
-0.187253, 1, -1, -1, 0.483149) , 
NN(
0, 
0, 
-0.226005, 0, -1, 1, 0.559683) , 
0.0258575, 1, 3, 0, 0.521078) , 
-1.35433, 1, 1, 0, 0.50376) , 
0.733592, 0, 3, 0, 0.494473) , 
NN(
0, 
0, 
2.22704, 0, -1, 1, 0.657414) , 
0.88002, 1, 3, 0, 0.505008) , 
NN(
0, 
0, 
2.04167, 0, -1, 1, 0.829523) , 
1.68713, 1, 2, 0, 0.513031)    );
  // itree = 217
  fBoostWeights.push_back(0.774221);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.118919, 1, -1, -1, 0.453537) , 
NN(
0, 
0, 
0.370364, 0, -1, 1, 0.566819) , 
-0.0897679, 1, 3, 0, 0.525462)    );
  // itree = 218
  fBoostWeights.push_back(0.63343);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.179199, 0, -1, -1, 0.372409) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.250697) , 
NN(
NN(
NN(
0, 
0, 
-0.956174, 1, -1, -1, 0.240662) , 
NN(
0, 
0, 
-0.609589, 0, -1, -1, 0.46831) , 
-1.11366, 1, 3, 0, 0.420288) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.839562) , 
-0.984934, 0, 1, 0, 0.447515) , 
-1.33166, 1, 1, 0, 0.415408) , 
NN(
0, 
0, 
-0.586885, 0, -1, 1, 0.528442) , 
-0.558422, 1, 0, 0, 0.470297) , 
0.126029, 0, 2, 0, 0.447324) , 
NN(
0, 
0, 
0.511719, 0, -1, 1, 0.560051) , 
0.0364975, 1, 3, 0, 0.501727) , 
NN(
0, 
0, 
0.180925, 1, -1, 1, 0.683628) , 
0.744808, 1, 3, 0, 0.523759)    );
  // itree = 219
  fBoostWeights.push_back(0.658424);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.223776) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.246254) , 
NN(
NN(
0, 
0, 
-0.363788, 0, -1, -1, 0.30818) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.146399) , 
NN(
0, 
0, 
-0.286317, 0, -1, -1, 0.485736) , 
-0.338755, 1, 3, 0, 0.415685) , 
NN(
0, 
0, 
-0.613542, 1, -1, 1, 0.551763) , 
0.0860592, 0, 0, 0, 0.497745) , 
-0.932351, 1, 3, 0, 0.464368) , 
-0.0568283, 0, 2, 0, 0.445524) , 
NN(
0, 
0, 
1.57137, 1, -1, 1, 0.667959) , 
1.32834, 1, 1, 0, 0.458647) , 
2.09918, 0, 1, 0, 0.448388) , 
NN(
0, 
0, 
1.2403, 0, -1, 1, 0.540271) , 
0.0206825, 1, 2, 0, 0.502421)    );
  // itree = 220
  fBoostWeights.push_back(0.807948);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.10096, 1, -1, -1, 0.364428) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.236895) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.627529) , 
0.446452, 1, 3, 0, 0.308763) , 
NN(
0, 
0, 
1.34026, 0, -1, 1, 0.523674) , 
1.3159, 1, 1, 0, 0.436171) , 
NN(
NN(
NN(
0, 
0, 
-0.14267, 1, -1, -1, 0.466245) , 
NN(
NN(
0, 
0, 
0.286708, 0, -1, 1, 0.508169) , 
NN(
0, 
0, 
-0.283268, 0, -1, 1, 0.675339) , 
0.176622, 1, 3, 0, 0.555535) , 
0.499668, 0, 3, 0, 0.529751) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.743991) , 
-1.80339, 0, 0, 0, 0.544844) , 
0.948007, 0, 1, 0, 0.517247) , 
-0.924344, 1, 3, 0, 0.507119)    );
  // itree = 221
  fBoostWeights.push_back(0.823304);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.12629, 1, -1, -1, 0.422991) , 
NN(
NN(
0, 
0, 
-0.466088, 0, -1, -1, 0.367714) , 
NN(
NN(
NN(
0, 
0, 
0.860791, 1, -1, -1, 0.454491) , 
NN(
0, 
0, 
-2.1201, 1, -1, 1, 0.565578) , 
0.461286, 0, 3, 0, 0.544844) , 
NN(
0, 
0, 
-1.33944, 1, -1, 1, 0.819452) , 
0.993259, 1, 3, 0, 0.551112) , 
-1.22916, 1, 2, 0, 0.541087) , 
1.32235, 0, 0, 0, 0.519572)    );
  // itree = 222
  fBoostWeights.push_back(0.701995);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.954662, 1, -1, -1, 0.35177) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.450664) , 
NN(
0, 
0, 
1.63357, 0, -1, 1, 0.746076) , 
0.763726, 1, 3, 0, 0.545595) , 
-0.441714, 0, 1, 0, 0.394149) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.632763, 1, -1, -1, 0.370726) , 
NN(
NN(
0, 
0, 
-0.280478, 0, -1, -1, 0.383845) , 
NN(
0, 
0, 
0.436136, 1, -1, 1, 0.530406) , 
-0.494536, 1, 3, 0, 0.496787) , 
0.669526, 0, 2, 0, 0.479276) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.658564) , 
-1.9625, 0, 1, 0, 0.490312) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.925443) , 
1.19505, 1, 2, 0, 0.496479) , 
NN(
0, 
0, 
0.0919142, 0, -1, 1, 0.595254) , 
1.18219, 1, 1, 0, 0.515671) , 
0.776084, 0, 0, 0, 0.477611)    );
  // itree = 223
  fBoostWeights.push_back(0.848239);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.767762, 0, -1, -1, 0.354191) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.456296, 1, -1, -1, 0.265971) , 
NN(
NN(
NN(
0, 
0, 
-0.867758, 0, -1, -1, 0.292849) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.543091) , 
-0.578594, 1, 3, 0, 0.467604) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.735215) , 
-0.571812, 0, 1, 0, 0.554984) , 
-0.62599, 0, 2, 0, 0.421135) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.317528) , 
NN(
0, 
0, 
2.03345, 1, -1, -1, 0.496331) , 
0.111084, 1, 3, 0, 0.435048) , 
NN(
0, 
0, 
-0.64207, 1, -1, 1, 0.539293) , 
0.216661, 0, 1, 0, 0.493442) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.284103) , 
NN(
0, 
0, 
0.431009, 1, -1, 1, 0.669881) , 
-0.235491, 1, 3, 0, 0.611443) , 
-0.0378763, 0, 2, 0, 0.51783) , 
-0.29889, 1, 2, 0, 0.498322) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.671011) , 
-1.43705, 0, 0, 0, 0.505337) , 
NN(
0, 
0, 
-1.06301, 1, -1, 1, 0.616083) , 
-1.62718, 0, 0, 0, 0.514689) , 
-1.30333, 1, 2, 0, 0.509591) , 
NN(
0, 
0, 
0.411586, 1, -1, 1, 0.597448) , 
1.33173, 1, 1, 0, 0.523035)    );
  // itree = 224
  fBoostWeights.push_back(0.787192);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.320584, 0, -1, -1, 0.372182) , 
NN(
0, 
0, 
0.228199, 1, -1, 1, 0.504997) , 
-0.065102, 1, 3, 0, 0.410176) , 
NN(
0, 
0, 
-0.763743, 1, -1, 1, 0.58299) , 
-0.970608, 0, 1, 0, 0.446371) , 
NN(
NN(
NN(
0, 
0, 
0.831276, 0, -1, -1, 0.441983) , 
NN(
0, 
0, 
1.43564, 0, -1, 1, 0.603587) , 
1.00627, 1, 3, 0, 0.489419) , 
NN(
0, 
0, 
0.601033, 1, -1, 1, 0.584978) , 
0.725172, 0, 2, 0, 0.556957) , 
0.0206825, 1, 2, 0, 0.511045)    );
  // itree = 225
  fBoostWeights.push_back(0.66854);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-2.16162, 1, -1, -1, 0.281799) , 
NN(
NN(
0, 
0, 
-1.06182, 1, -1, -1, 0.421113) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.332732) , 
NN(
NN(
0, 
0, 
-2.24716, 0, -1, -1, 0.440675) , 
NN(
0, 
0, 
-0.763224, 1, -1, 1, 0.577627) , 
-0.156695, 1, 3, 0, 0.507355) , 
0.701915, 0, 2, 0, 0.485275) , 
0.269177, 0, 0, 0, 0.459075) , 
-1.37067, 1, 3, 0, 0.454279) , 
NN(
0, 
0, 
1.06593, 0, -1, 1, 0.672129) , 
0.744808, 1, 3, 0, 0.482136)    );
  // itree = 226
  fBoostWeights.push_back(0.746378);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.98451, 0, -1, -1, 0.28529) , 
NN(
0, 
0, 
1.02778, 1, -1, -1, 0.482955) , 
-1.37067, 1, 3, 0, 0.477969) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.736544) , 
2.4829, 1, 1, 0, 0.484003) , 
NN(
0, 
0, 
-0.86317, 0, -1, 1, 0.616167) , 
0.744808, 1, 3, 0, 0.500394)    );
  // itree = 227
  fBoostWeights.push_back(0.790694);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.752762, 0, -1, -1, 0.417837) , 
NN(
NN(
NN(
0, 
0, 
-0.038847, 0, -1, -1, 0.343) , 
NN(
NN(
0, 
0, 
-0.944081, 0, -1, -1, 0.419305) , 
NN(
0, 
0, 
-1.1879, 1, -1, 1, 0.549075) , 
-0.334188, 1, 2, 0, 0.506652) , 
-0.525645, 0, 1, 0, 0.449321) , 
NN(
0, 
0, 
0.122159, 1, -1, 1, 0.542074) , 
0.180561, 1, 1, 0, 0.494774) , 
0.59894, 0, 2, 0, 0.480565) , 
NN(
0, 
0, 
-0.14267, 0, -1, 1, 0.586809) , 
0.744808, 1, 3, 0, 0.493057)    );
  // itree = 228
  fBoostWeights.push_back(0.688742);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
1.73033, 1, -1, -1, 0.366849) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.247941) , 
NN(
NN(
0, 
0, 
-1.38565, 1, -1, -1, 0.261611) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.389427) , 
NN(
NN(
NN(
0, 
0, 
-0.629819, 0, -1, -1, 0.399591) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.459779, 0, -1, -1, 0.20467) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.473088) , 
-0.298526, 1, 3, 0, 0.38628) , 
NN(
0, 
0, 
1.1425, 0, -1, 1, 0.587813) , 
-0.874156, 0, 2, 0, 0.43459) , 
NN(
0, 
0, 
-0.324662, 1, -1, 1, 0.611673) , 
-0.113404, 1, 0, 0, 0.506478) , 
0.148688, 1, 1, 0, 0.46565) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.859764) , 
0.357497, 1, 3, 0, 0.490806) , 
0.534885, 0, 2, 0, 0.467532) , 
-1.37922, 1, 3, 0, 0.459799) , 
-0.855933, 1, 1, 0, 0.446386) , 
0.868241, 0, 0, 0, 0.423375) , 
NN(
0, 
0, 
0.651248, 1, -1, 1, 0.580988) , 
0.744808, 1, 3, 0, 0.441795) , 
NN(
0, 
0, 
-2.48387, 0, -1, 1, 0.613902) , 
-0.970608, 0, 1, 0, 0.472019)    );
  // itree = 229
  fBoostWeights.push_back(0.718969);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
1.3982, 1, -1, -1, 0.334712) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.565907) , 
-0.271181, 0, 3, 0, 0.356819) , 
NN(
0, 
0, 
-1.22037, 0, -1, 1, 0.61495) , 
-0.704714, 0, 1, 0, 0.389609) , 
NN(
NN(
NN(
0, 
0, 
-2.22313, 0, -1, -1, 0.284939) , 
NN(
0, 
0, 
-0.183344, 0, -1, 1, 0.51496) , 
-1.09559, 1, 3, 0, 0.501713) , 
NN(
0, 
0, 
-0.500781, 1, -1, 1, 0.671389) , 
1.30151, 1, 1, 0, 0.527752) , 
0.371859, 0, 0, 0, 0.475724) , 
NN(
0, 
0, 
0.240009, 1, -1, 1, 0.637629) , 
0.853908, 1, 2, 0, 0.498817)    );
  // itree = 230
  fBoostWeights.push_back(0.730088);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.12629, 1, -1, -1, 0.404337) , 
NN(
NN(
0, 
0, 
2.10233, 0, -1, -1, 0.447434) , 
NN(
0, 
0, 
1.21545, 1, -1, 1, 0.538469) , 
-0.25021, 1, 3, 0, 0.511466) , 
1.32235, 0, 0, 0, 0.490672)    );
  // itree = 231
  fBoostWeights.push_back(0.751993);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.126029, 1, -1, -1, 0.440027) , 
NN(
0, 
0, 
1.38745, 0, -1, 1, 0.531805) , 
-0.0897679, 1, 3, 0, 0.497305)    );
  // itree = 232
  fBoostWeights.push_back(0.670246);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.331291, 1, -1, -1, 0.381845) , 
NN(
NN(
NN(
0, 
0, 
-1.47838, 0, -1, -1, 0.396556) , 
NN(
NN(
0, 
0, 
-1.30051, 1, -1, -1, 0.352828) , 
NN(
0, 
0, 
-0.598305, 0, -1, 1, 0.541524) , 
-0.943108, 1, 3, 0, 0.498079) , 
-0.308393, 0, 1, 0, 0.447306) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.720123) , 
0.760086, 1, 0, 0, 0.478203) , 
-0.170559, 0, 2, 0, 0.429503) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.571854) , 
0.196767, 1, 3, 0, 0.441881) , 
NN(
0, 
0, 
0.518811, 1, -1, 1, 0.582068) , 
0.32752, 1, 3, 0, 0.498803)    );
  // itree = 233
  fBoostWeights.push_back(0.768325);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
1.20307, 0, -1, -1, 0.332339) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
0.922642, 1, 3, 0, 0.348444) , 
NN(
0, 
0, 
2.50738, 1, -1, -1, 0.492623) , 
1.29982, 1, 1, 0, 0.416277) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.208973) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.606756, 1, -1, -1, 0.338173) , 
NN(
NN(
0, 
0, 
-0.792044, 0, -1, -1, 0.410139) , 
NN(
NN(
0, 
0, 
0.375869, 0, -1, -1, 0.475081) , 
NN(
0, 
0, 
1.05147, 0, -1, 1, 0.644899) , 
0.669086, 1, 3, 0, 0.510545) , 
-0.125526, 1, 2, 0, 0.48126) , 
0.228838, 0, 1, 0, 0.457671) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.606366) , 
0.392545, 1, 1, 0, 0.47278) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.38328) , 
NN(
0, 
0, 
-1.30006, 1, -1, 1, 0.75794) , 
-0.717535, 1, 2, 0, 0.652208) , 
-0.878612, 0, 0, 0, 0.493766) , 
-1.74079, 1, 1, 0, 0.47313) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.706694) , 
-2.41457, 0, 1, 0, 0.480963) , 
NN(
0, 
0, 
-1.34605, 0, -1, 1, 0.650903) , 
-1.71004, 0, 0, 0, 0.496123) , 
0.564284, 0, 1, 0, 0.471327)    );
  // itree = 234
  fBoostWeights.push_back(0.802794);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.0706148, 1, -1, -1, 0.379465) , 
NN(
NN(
0, 
0, 
-1.18688, 0, -1, -1, 0.341015) , 
NN(
NN(
NN(
0, 
0, 
0.784558, 0, -1, -1, 0.407375) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.604432) , 
-0.33539, 1, 3, 0, 0.46667) , 
NN(
0, 
0, 
1.33064, 1, -1, 1, 0.545096) , 
-0.201286, 1, 3, 0, 0.52392) , 
-1.22916, 1, 2, 0, 0.515966) , 
1.86861, 0, 0, 0, 0.504184)    );
  // itree = 235
  fBoostWeights.push_back(0.794225);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.3379) , 
NN(
NN(
NN(
0, 
0, 
0.263476, 0, -1, -1, 0.345752) , 
NN(
NN(
0, 
0, 
-2.14325, 1, -1, -1, 0.228672) , 
NN(
NN(
0, 
0, 
-0.925525, 0, -1, 1, 0.509216) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.752698) , 
-0.221648, 1, 3, 0, 0.582123) , 
-1.36796, 1, 3, 0, 0.536532) , 
-0.957337, 0, 0, 0, 0.413164) , 
NN(
NN(
0, 
0, 
-0.580432, 1, -1, -1, 0.331761) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.676276) , 
-0.235072, 1, 3, 0, 0.585243) , 
0.5431, 1, 0, 0, 0.442869) , 
0.366173, 0, 2, 0, 0.42707) , 
NN(
NN(
0, 
0, 
0.372366, 0, -1, -1, 0.396471) , 
NN(
0, 
0, 
0.995733, 1, -1, 1, 0.546691) , 
1.18935, 0, 3, 0, 0.529578) , 
0.32752, 1, 3, 0, 0.466621)    );
  // itree = 236
  fBoostWeights.push_back(0.772615);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.132986, 0, -1, -1, 0.361045) , 
NN(
NN(
0, 
0, 
-0.517342, 0, -1, -1, 0.338497) , 
NN(
0, 
0, 
-0.419559, 1, -1, 1, 0.588929) , 
-0.658754, 1, 3, 0, 0.480706) , 
-0.739306, 0, 0, 0, 0.402542) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.185931) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.238873) , 
NN(
NN(
0, 
0, 
-1.61045, 1, -1, -1, 0.33075) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.729177) , 
-0.769921, 1, 3, 0, 0.584765) , 
-0.268554, 0, 2, 0, 0.405491) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.628621) , 
0.333707, 1, 0, 0, 0.483326) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.820351) , 
1.73467, 1, 1, 0, 0.533437) , 
2.44064, 0, 1, 0, 0.500635) , 
0.564284, 1, 1, 0, 0.431864) , 
NN(
NN(
NN(
0, 
0, 
0.486089, 1, -1, -1, 0.3646) , 
NN(
0, 
0, 
0.588751, 1, -1, 1, 0.550919) , 
0.730514, 1, 3, 0, 0.424077) , 
NN(
0, 
0, 
0.724869, 0, -1, 1, 0.561124) , 
0.908359, 0, 0, 0, 0.497811) , 
0.32752, 1, 3, 0, 0.457876)    );
  // itree = 237
  fBoostWeights.push_back(0.766641);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.0618412, 1, -1, -1, 0.374152) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.187824) , 
NN(
NN(
0, 
0, 
-1.85213, 0, -1, -1, 0.338262) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.514763) , 
-0.803914, 1, 3, 0, 0.403809) , 
-1.33166, 1, 1, 0, 0.36596) , 
NN(
0, 
0, 
0.0337323, 0, -1, -1, 0.486562) , 
-0.540328, 1, 2, 0, 0.413925) , 
NN(
0, 
0, 
0.792828, 0, -1, 1, 0.573545) , 
-0.214186, 1, 3, 0, 0.50401) , 
-0.242748, 0, 0, 0, 0.467792) , 
NN(
NN(
0, 
0, 
1.5395, 0, -1, 1, 0.505922) , 
NN(
0, 
0, 
0.589801, 0, -1, 1, 0.604139) , 
0.512859, 1, 3, 0, 0.533638) , 
0.22982, 1, 0, 0, 0.495903)    );
  // itree = 238
  fBoostWeights.push_back(0.743224);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.348663, 0, -1, -1, 0.414438) , 
NN(
0, 
0, 
0.532299, 1, -1, 1, 0.503647) , 
0.0364975, 1, 3, 0, 0.458623) , 
NN(
NN(
0, 
0, 
-1.55193, 0, -1, -1, 0.430973) , 
NN(
0, 
0, 
0.355812, 0, -1, 1, 0.613631) , 
-0.368203, 1, 3, 0, 0.569557) , 
-0.970608, 0, 1, 0, 0.480917) , 
NN(
0, 
0, 
-0.541653, 0, -1, 1, 0.645959) , 
0.744808, 1, 3, 0, 0.500202)    );
  // itree = 239
  fBoostWeights.push_back(0.838464);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.084158, 0, -1, -1, 0.379623) , 
NN(
NN(
0, 
0, 
-0.616086, 0, -1, -1, 0.39077) , 
NN(
0, 
0, 
-0.25976, 0, -1, 1, 0.566441) , 
-0.420954, 1, 3, 0, 0.511437) , 
-0.100174, 0, 1, 0, 0.441382) , 
NN(
0, 
0, 
-0.586123, 1, -1, 1, 0.632679) , 
1.71545, 1, 1, 0, 0.454563) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.629873) , 
0.196767, 1, 3, 0, 0.470409) , 
NN(
0, 
0, 
0.308694, 1, -1, 1, 0.604475) , 
0.32752, 1, 3, 0, 0.524117)    );
  // itree = 240
  fBoostWeights.push_back(0.797447);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.124031, 1, -1, -1, 0.389207) , 
NN(
NN(
0, 
0, 
0.57341, 0, -1, -1, 0.429296) , 
NN(
0, 
0, 
-0.259295, 1, -1, 1, 0.561619) , 
-0.0935618, 1, 3, 0, 0.47712) , 
0.06056, 0, 2, 0, 0.434546) , 
NN(
0, 
0, 
0.71832, 0, -1, 1, 0.530407) , 
0.49024, 1, 3, 0, 0.455344) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.832579) , 
-2.21486, 0, 2, 0, 0.458696) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.846676) , 
-3.04776, 0, 0, 0, 0.46181) , 
NN(
0, 
0, 
-2.04127, 0, -1, 1, 0.58978) , 
-1.35433, 0, 1, 0, 0.476905)    );
  // itree = 241
  fBoostWeights.push_back(0.753433);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.221938, 0, -1, -1, 0.359447) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.806618, 0, -1, -1, 0.316085) , 
NN(
NN(
0, 
0, 
0.689278, 1, -1, -1, 0.284411) , 
NN(
0, 
0, 
0.953875, 0, -1, 1, 0.581403) , 
-0.390894, 1, 3, 0, 0.503778) , 
0.476782, 1, 1, 0, 0.422954) , 
NN(
NN(
0, 
0, 
-0.634314, 0, -1, -1, 0.384341) , 
NN(
0, 
0, 
-0.614044, 0, -1, 1, 0.565628) , 
-0.42525, 1, 2, 0, 0.518903) , 
-0.114916, 0, 1, 0, 0.476044) , 
NN(
0, 
0, 
0.754239, 1, -1, 1, 0.552765) , 
0.240509, 1, 0, 0, 0.508713) , 
1.68312, 0, 1, 0, 0.499884) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.761255) , 
2.4829, 1, 1, 0, 0.504988)    );
  // itree = 242
  fBoostWeights.push_back(0.743895);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.87693, 0, -1, -1, 0.444693) , 
NN(
NN(
0, 
0, 
-0.358042, 0, -1, 1, 0.52085) , 
NN(
0, 
0, 
-0.509506, 0, -1, 1, 0.682852) , 
0.899532, 1, 3, 0, 0.542422) , 
-0.0897679, 1, 3, 0, 0.507492)    );
  // itree = 243
  fBoostWeights.push_back(0.748015);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.948007, 0, -1, -1, 0.44815) , 
NN(
0, 
0, 
0.125261, 0, -1, 1, 0.535693) , 
0.0364975, 1, 3, 0, 0.49284) , 
NN(
0, 
0, 
0.744332, 0, -1, 1, 0.666573) , 
0.744808, 1, 3, 0, 0.511968)    );
  // itree = 244
  fBoostWeights.push_back(0.766881);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.10233, 1, -1, -1, 0.32002) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.463192, 0, -1, -1, 0.367187) , 
NN(
NN(
0, 
0, 
-0.511403, 0, -1, -1, 0.433977) , 
NN(
0, 
0, 
-0.404682, 1, -1, 1, 0.598846) , 
-0.34789, 1, 3, 0, 0.549152) , 
-0.0253688, 0, 2, 0, 0.478799) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.789219) , 
-1.91104, 0, 0, 0, 0.501213) , 
NN(
0, 
0, 
-1.18469, 1, -1, 1, 0.603171) , 
0.24318, 1, 2, 0, 0.549424) , 
-0.924344, 1, 3, 0, 0.534815)    );
  // itree = 245
  fBoostWeights.push_back(0.792599);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.136632, 1, -1, -1, 0.244195) , 
NN(
0, 
0, 
0.207678, 0, -1, -1, 0.466821) , 
-1.29476, 1, 3, 0, 0.456785) , 
NN(
0, 
0, 
-0.586123, 1, -1, 1, 0.654733) , 
1.71545, 1, 1, 0, 0.471829) , 
NN(
0, 
0, 
1.3257, 0, -1, 1, 0.603678) , 
0.32752, 1, 3, 0, 0.526005)    );
  // itree = 246
  fBoostWeights.push_back(0.739706);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.168229, 1, -1, -1, 0.324238) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.353016) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.160841) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.695037) , 
-0.358838, 1, 3, 0, 0.601765) , 
-0.116847, 1, 1, 0, 0.462237) , 
-0.796685, 0, 0, 0, 0.378497) , 
NN(
NN(
0, 
0, 
1.51521, 1, -1, -1, 0.273893) , 
NN(
0, 
0, 
-0.481806, 1, -1, 1, 0.582482) , 
-1.15477, 1, 3, 0, 0.513652) , 
-0.62044, 0, 2, 0, 0.420369) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.620205) , 
0.366173, 1, 2, 0, 0.452418) , 
NN(
0, 
0, 
0.00443425, 0, -1, 1, 0.55725) , 
0.5431, 1, 0, 0, 0.473096) , 
NN(
0, 
0, 
0.0985762, 0, -1, 1, 0.587654) , 
0.32752, 1, 3, 0, 0.519455)    );
  // itree = 247
  fBoostWeights.push_back(0.74111);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.116659) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.212412) , 
NN(
NN(
0, 
0, 
-0.395744, 0, -1, -1, 0.363731) , 
NN(
0, 
0, 
-0.257525, 0, -1, -1, 0.498451) , 
-0.558526, 1, 3, 0, 0.454922) , 
0.228697, 0, 2, 0, 0.406969) , 
0.493391, 0, 0, 0, 0.3682) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.797269) , 
-2.8173, 0, 0, 0, 0.377574) , 
NN(
0, 
0, 
0.432351, 0, -1, 1, 0.502338) , 
0.480719, 1, 2, 0, 0.415593) , 
NN(
NN(
0, 
0, 
0.436503, 1, -1, -1, 0.397133) , 
NN(
0, 
0, 
-0.0884805, 1, -1, 1, 0.5529) , 
0.512859, 0, 3, 0, 0.500407) , 
0.776084, 1, 0, 0, 0.44403) , 
NN(
NN(
NN(
0, 
0, 
1.22852, 1, -1, -1, 0.301919) , 
NN(
NN(
NN(
0, 
0, 
-0.141488, 0, -1, -1, 0.425185) , 
NN(
NN(
0, 
0, 
-0.90135, 0, -1, -1, 0.304765) , 
NN(
0, 
0, 
-0.459241, 0, -1, 1, 0.635755) , 
-0.724357, 1, 2, 0, 0.587175) , 
-1.18058, 1, 1, 0, 0.522533) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.966811) , 
0.793216, 1, 3, 0, 0.538982) , 
0.918984, 0, 2, 0, 0.514094) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.800033) , 
-2.46311, 0, 1, 0, 0.537347) , 
-0.586885, 0, 1, 0, 0.471141)    );
  // itree = 248
  fBoostWeights.push_back(0.791723);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.3159, 1, -1, -1, 0.355346) , 
NN(
NN(
NN(
0, 
0, 
1.36839, 1, -1, -1, 0.450137) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.732132) , 
-1.17218, 0, 2, 0, 0.46127) , 
NN(
NN(
0, 
0, 
-0.858499, 0, -1, -1, 0.413652) , 
NN(
0, 
0, 
-1.51124, 1, -1, 1, 0.594672) , 
-0.65833, 1, 3, 0, 0.535202) , 
-0.734765, 0, 0, 0, 0.480274) , 
0.948007, 0, 1, 0, 0.44693)    );
  // itree = 249
  fBoostWeights.push_back(0.754785);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.13548, 0, -1, -1, 0.304066) , 
NN(
NN(
0, 
0, 
0.659328, 1, -1, -1, 0.276158) , 
NN(
NN(
0, 
0, 
0.298879, 0, -1, -1, 0.46993) , 
NN(
0, 
0, 
0.486625, 1, -1, 1, 0.778338) , 
0.793271, 1, 3, 0, 0.487916) , 
-1.30588, 1, 2, 0, 0.476349) , 
1.86861, 0, 0, 0, 0.458837) , 
NN(
NN(
NN(
0, 
0, 
-0.618766, 1, -1, -1, 0.211807) , 
NN(
0, 
0, 
0.437382, 1, -1, 1, 0.524958) , 
-0.392189, 1, 3, 0, 0.481785) , 
NN(
NN(
0, 
0, 
-1.09924, 1, -1, -1, 0.481045) , 
NN(
0, 
0, 
-0.0450035, 0, -1, 1, 0.737336) , 
-0.707147, 1, 2, 0, 0.673817) , 
-0.813998, 0, 0, 0, 0.540968) , 
-0.203162, 0, 1, 0, 0.49207)    );
  // itree = 250
  fBoostWeights.push_back(0.732023);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-3.38376, 0, -1, -1, 0.446723) , 
NN(
NN(
0, 
0, 
1.41378, 0, -1, -1, 0.493765) , 
NN(
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.238986) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.273074) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.594153) , 
-0.256544, 1, 3, 0, 0.521702) , 
0.674525, 0, 2, 0, 0.414462) , 
NN(
NN(
0, 
0, 
-0.56554, 0, -1, -1, 0.446192) , 
NN(
0, 
0, 
-0.0723178, 0, -1, 1, 0.63239) , 
-0.00420446, 1, 3, 0, 0.540023) , 
-0.319967, 0, 0, 0, 0.490505) , 
NN(
NN(
0, 
0, 
0.390927, 0, -1, 1, 0.525039) , 
NN(
0, 
0, 
0.46975, 1, -1, 1, 0.678594) , 
0.30578, 1, 2, 0, 0.586355) , 
0.107732, 1, 0, 0, 0.53487) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.744119) , 
-1.212, 0, 0, 0, 0.543272) , 
NN(
0, 
0, 
-0.600432, 1, -1, 1, 0.654753) , 
1.18219, 1, 1, 0, 0.568135) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.855309) , 
1.06756, 1, 0, 0, 0.580141) , 
1.26789, 0, 0, 0, 0.564064) , 
-1.40897, 1, 0, 0, 0.547613)    );
  // itree = 251
  fBoostWeights.push_back(0.760752);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.305782, 0, -1, -1, 0.408703) , 
NN(
NN(
0, 
0, 
-0.516966, 1, -1, -1, 0.386206) , 
NN(
NN(
0, 
0, 
-2.15343, 1, -1, -1, 0.409663) , 
NN(
0, 
0, 
0.322406, 0, -1, 1, 0.611002) , 
-0.769133, 1, 3, 0, 0.557496) , 
-1.2108, 1, 1, 0, 0.520444) , 
-0.280478, 0, 0, 0, 0.472488) , 
NN(
0, 
0, 
-0.165882, 1, -1, 1, 0.642872) , 
0.61459, 1, 3, 0, 0.494196) , 
NN(
NN(
NN(
0, 
0, 
0.225258, 1, -1, -1, 0.470176) , 
NN(
0, 
0, 
1.04156, 1, -1, 1, 0.593919) , 
0.459875, 1, 3, 0, 0.535481) , 
NN(
0, 
0, 
-0.240417, 1, -1, 1, 0.769382) , 
-0.125526, 0, 2, 0, 0.577727) , 
0.728146, 1, 0, 0, 0.51895) , 
NN(
0, 
0, 
0.320584, 0, -1, 1, 0.666803) , 
1.71545, 1, 1, 0, 0.530319)    );
  // itree = 252
  fBoostWeights.push_back(0.835809);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.82499, 1, -1, -1, 0.336374) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.9774, 0, -1, -1, 0.31576) , 
NN(
NN(
0, 
0, 
-0.969223, 0, -1, -1, 0.359657) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.693106) , 
-0.368343, 1, 2, 0, 0.522427) , 
0.106597, 0, 2, 0, 0.427411) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.320735) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.37932) , 
NN(
NN(
NN(
0, 
0, 
0.243155, 0, -1, -1, 0.441108) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.691595) , 
0.361538, 1, 3, 0, 0.493288) , 
NN(
0, 
0, 
0.654509, 0, -1, 1, 0.60375) , 
0.542301, 1, 1, 0, 0.553762) , 
0.828319, 0, 2, 0, 0.527468) , 
2.02003, 0, 1, 0, 0.512442) , 
-0.546086, 1, 1, 0, 0.489599) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.224177) , 
NN(
0, 
0, 
0.66358, 0, -1, 1, 0.60416) , 
-0.328375, 1, 3, 0, 0.580738) , 
0.507514, 1, 0, 0, 0.520159) , 
2.41487, 0, 0, 0, 0.512179) , 
NN(
0, 
0, 
-2.41519, 0, -1, 1, 0.630598) , 
-1.35433, 0, 1, 0, 0.525508)    );
  // itree = 253
  fBoostWeights.push_back(0.725326);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.459285, 0, -1, -1, 0.414468) , 
NN(
0, 
0, 
0.855538, 0, -1, 1, 0.559061) , 
0.410327, 1, 3, 0, 0.468977) , 
NN(
NN(
NN(
0, 
0, 
1.51521, 1, -1, -1, 0.345777) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.38882) , 
NN(
NN(
0, 
0, 
-0.751845, 0, -1, -1, 0.472484) , 
NN(
0, 
0, 
0.165156, 1, -1, 1, 0.671098) , 
-0.287488, 1, 3, 0, 0.572065) , 
-0.602229, 0, 0, 0, 0.53177) , 
-1.17024, 1, 3, 0, 0.511851) , 
NN(
0, 
0, 
-0.111765, 0, -1, 1, 0.655767) , 
0.250391, 1, 3, 0, 0.552235) , 
-0.316443, 0, 0, 0, 0.503228)    );
  // itree = 254
  fBoostWeights.push_back(0.79087);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.132363, 0, -1, -1, 0.409269) , 
NN(
0, 
0, 
0.30059, 0, -1, 1, 0.500751) , 
-0.0723424, 0, 3, 0, 0.44148) , 
NN(
0, 
0, 
-1.61457, 1, -1, 1, 0.683152) , 
-1.95523, 0, 0, 0, 0.452225) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.288085) , 
NN(
NN(
0, 
0, 
-2.02683, 0, -1, -1, 0.243465) , 
NN(
NN(
NN(
0, 
0, 
0.286856, 1, -1, -1, 0.487963) , 
NN(
0, 
0, 
-2.03891, 1, -1, 1, 0.613781) , 
0.428887, 1, 3, 0, 0.533072) , 
NN(
0, 
0, 
-0.942832, 1, -1, 1, 0.660239) , 
-0.589546, 0, 2, 0, 0.55297) , 
-1.0861, 1, 3, 0, 0.543946) , 
-0.29876, 0, 1, 0, 0.532967) , 
-0.203162, 0, 1, 0, 0.483434)    );
  // itree = 255
  fBoostWeights.push_back(0.857555);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.0805435, 0, -1, -1, 0.301416) , 
NN(
0, 
0, 
1.38915, 0, -1, 1, 0.525356) , 
0.46084, 1, 3, 0, 0.340059) , 
NN(
NN(
NN(
0, 
0, 
-0.449742, 0, -1, -1, 0.280301) , 
NN(
NN(
0, 
0, 
-0.296446, 1, -1, -1, 0.388667) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.151504) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.584125) , 
-0.809701, 1, 3, 0, 0.540092) , 
-0.547357, 1, 0, 0, 0.439623) , 
0.381918, 0, 0, 0, 0.397265) , 
NN(
0, 
0, 
-0.0884643, 0, -1, -1, 0.498297) , 
-0.0761253, 1, 2, 0, 0.460643) , 
0.948007, 0, 1, 0, 0.43005)    );
  // itree = 256
  fBoostWeights.push_back(0.711394);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.259898) , 
NN(
NN(
0, 
0, 
-0.840112, 0, -1, -1, 0.383227) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.544875) , 
-0.216984, 1, 3, 0, 0.425133) , 
-0.0884405, 0, 3, 0, 0.399178) , 
NN(
0, 
0, 
0.371189, 0, -1, -1, 0.471032) , 
0.0364975, 1, 3, 0, 0.43177) , 
NN(
0, 
0, 
-0.509506, 0, -1, 1, 0.527551) , 
0.744808, 1, 3, 0, 0.442797) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.685509) , 
2.4829, 1, 1, 0, 0.448213)    );
  // itree = 257
  fBoostWeights.push_back(0.797135);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.651313, 0, -1, -1, 0.218848) , 
NN(
0, 
0, 
0.244084, 0, -1, -1, 0.425178) , 
-0.117489, 1, 3, 0, 0.356313) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.17612) , 
NN(
0, 
0, 
1.87252, 1, -1, -1, 0.485221) , 
0.0735737, 1, 3, 0, 0.390773) , 
NN(
0, 
0, 
1.07555, 0, -1, 1, 0.559624) , 
0.412849, 1, 1, 0, 0.446857) , 
NN(
0, 
0, 
-1.89828, 1, -1, 1, 0.714647) , 
-1.50521, 0, 1, 0, 0.46544) , 
0.393778, 1, 0, 0, 0.423105) , 
NN(
NN(
NN(
0, 
0, 
0.406158, 1, -1, -1, 0.376817) , 
NN(
NN(
0, 
0, 
-0.987158, 0, -1, -1, 0.433922) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.771062) , 
-0.450587, 1, 3, 0, 0.539301) , 
-0.206217, 0, 3, 0, 0.462664) , 
NN(
0, 
0, 
-0.0959445, 1, -1, 1, 0.627025) , 
-0.605542, 1, 0, 0, 0.505156) , 
-0.247128, 0, 0, 0, 0.454743) , 
NN(
NN(
0, 
0, 
1.89337, 0, -1, -1, 0.355933) , 
NN(
0, 
0, 
0.616084, 1, -1, 1, 0.652552) , 
-0.277011, 1, 3, 0, 0.578495) , 
1.33173, 1, 1, 0, 0.474708)    );
  // itree = 258
  fBoostWeights.push_back(0.741633);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.329495) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.156215, 1, -1, -1, 0.203971) , 
NN(
NN(
NN(
0, 
0, 
-0.844461, 0, -1, -1, 0.395911) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.543953) , 
-0.266305, 1, 3, 0, 0.460137) , 
NN(
0, 
0, 
0.465986, 0, -1, 1, 0.617658) , 
-0.845292, 1, 0, 0, 0.509266) , 
-0.421615, 0, 0, 0, 0.40878) , 
NN(
0, 
0, 
0.08209, 1, -1, -1, 0.4872) , 
0.0414135, 1, 0, 0, 0.443189) , 
NN(
0, 
0, 
0.576849, 1, -1, 1, 0.527294) , 
0.404671, 1, 3, 0, 0.461716) , 
1.82279, 0, 0, 0, 0.451454) , 
NN(
0, 
0, 
2.03549, 0, -1, 1, 0.602047) , 
1.1621, 1, 3, 0, 0.459191) , 
NN(
NN(
0, 
0, 
-2.32713, 0, -1, -1, 0.232941) , 
NN(
0, 
0, 
0.261751, 0, -1, 1, 0.595445) , 
-1.0861, 1, 3, 0, 0.584712) , 
-0.586885, 0, 1, 0, 0.498573)    );
  // itree = 259
  fBoostWeights.push_back(0.723963);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.767171, 1, -1, -1, 0.353392) , 
NN(
NN(
NN(
0, 
0, 
-0.255202, 0, -1, -1, 0.437495) , 
NN(
NN(
NN(
0, 
0, 
0.110417, 0, -1, -1, 0.448349) , 
NN(
0, 
0, 
0.801528, 0, -1, 1, 0.577403) , 
0.477973, 1, 3, 0, 0.50051) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.682361) , 
-0.132363, 0, 2, 0, 0.522871) , 
-0.156138, 1, 3, 0, 0.494078) , 
NN(
0, 
0, 
0.0254637, 0, -1, 1, 0.585225) , 
-0.586885, 0, 1, 0, 0.522182) , 
-0.924344, 1, 3, 0, 0.511491)    );
  // itree = 260
  fBoostWeights.push_back(0.748744);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.26171) , 
NN(
NN(
0, 
0, 
-0.533175, 0, -1, -1, 0.295671) , 
NN(
NN(
0, 
0, 
-0.0663847, 1, -1, -1, 0.346985) , 
NN(
0, 
0, 
-1.32044, 0, -1, 1, 0.537784) , 
-0.828475, 1, 3, 0, 0.46355) , 
0.320584, 0, 0, 0, 0.434581) , 
0.0592401, 0, 2, 0, 0.408304) , 
NN(
0, 
0, 
-0.170148, 0, -1, -1, 0.473253) , 
-0.244935, 1, 3, 0, 0.454328) , 
NN(
0, 
0, 
2.34496, 0, -1, 1, 0.600149) , 
0.744808, 1, 3, 0, 0.471127)    );
  // itree = 261
  fBoostWeights.push_back(0.75725);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.390013, 0, -1, -1, 0.320279) , 
NN(
NN(
0, 
0, 
0.190307, 1, -1, -1, 0.341033) , 
NN(
NN(
0, 
0, 
-0.435345, 1, -1, -1, 0.386553) , 
NN(
0, 
0, 
-1.06023, 1, -1, 1, 0.563249) , 
-0.317877, 1, 3, 0, 0.470821) , 
0.0553507, 0, 3, 0, 0.422671) , 
0.464367, 0, 3, 0, 0.410329) , 
NN(
0, 
0, 
-0.170634, 1, -1, 1, 0.679453) , 
0.907668, 1, 3, 0, 0.420387) , 
NN(
0, 
0, 
0.671584, 1, -1, 1, 0.599985) , 
0.776084, 1, 0, 0, 0.468784)    );
  // itree = 262
  fBoostWeights.push_back(0.784525);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.466307, 0, -1, -1, 0.376259) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.271473) , 
NN(
NN(
0, 
0, 
-2.15337, 1, -1, -1, 0.419707) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.701087) , 
-0.721829, 1, 3, 0, 0.531516) , 
0.793461, 0, 1, 0, 0.478183) , 
-1.73114, 0, 0, 0, 0.388765) , 
NN(
0, 
0, 
-2.14924, 0, -1, 1, 0.512098) , 
0.32752, 1, 3, 0, 0.436192)    );
  // itree = 263
  fBoostWeights.push_back(0.780009);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.162667) , 
NN(
NN(
NN(
0, 
0, 
0.390618, 1, -1, -1, 0.296551) , 
NN(
0, 
0, 
1.24546, 1, -1, -1, 0.40523) , 
0.122489, 0, 3, 0, 0.368645) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.223407) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.590718) , 
-0.469723, 1, 3, 0, 0.513609) , 
-0.988558, 0, 1, 0, 0.387087) , 
0.318136, 0, 0, 0, 0.373913) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.633069) , 
-1.89507, 0, 1, 0, 0.391768) , 
NN(
0, 
0, 
0.0801517, 1, -1, -1, 0.498374) , 
0.447482, 1, 0, 0, 0.426458) , 
NN(
0, 
0, 
-2.43602, 1, -1, 1, 0.696514) , 
-2.04605, 0, 2, 0, 0.430941) , 
NN(
0, 
0, 
1.89917, 1, -1, 1, 0.630001) , 
0.744808, 1, 3, 0, 0.452598)    );
  // itree = 264
  fBoostWeights.push_back(0.698538);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.748212, 1, -1, -1, 0.399184) , 
NN(
0, 
0, 
-0.234201, 1, -1, 1, 0.583876) , 
-0.903119, 0, 2, 0, 0.427227) , 
NN(
0, 
0, 
-0.86317, 1, -1, 1, 0.556905) , 
0.32752, 1, 3, 0, 0.478345)    );
  // itree = 265
  fBoostWeights.push_back(0.8425);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.233329) , 
NN(
0, 
0, 
-0.970608, 1, -1, 1, 0.519949) , 
0.196767, 0, 3, 0, 0.497259) , 
NN(
0, 
0, 
0.0985762, 0, -1, 1, 0.591224) , 
0.32752, 1, 3, 0, 0.534163)    );
  // itree = 266
  fBoostWeights.push_back(0.623846);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.387645, 1, -1, -1, 0.422595) , 
NN(
NN(
NN(
0, 
0, 
-2.30885, 0, -1, -1, 0.255205) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.488979) , 
-0.838011, 1, 3, 0, 0.440503) , 
NN(
0, 
0, 
1.72487, 0, -1, 1, 0.570291) , 
-0.829542, 1, 1, 0, 0.531639) , 
-0.366598, 0, 0, 0, 0.47381) , 
NN(
NN(
0, 
0, 
1.2947, 1, -1, -1, 0.429308) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.241158) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.333937) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.353103) , 
NN(
0, 
0, 
-0.737162, 0, -1, 1, 0.621481) , 
0.730514, 1, 3, 0, 0.489708) , 
NN(
0, 
0, 
0.237957, 1, -1, 1, 0.687771) , 
0.518811, 0, 2, 0, 0.569056) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.813069) , 
0.299425, 0, 0, 0, 0.624404) , 
-0.0730908, 1, 0, 0, 0.578295) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.753169) , 
-0.542451, 0, 0, 0, 0.607921) , 
-2.08654, 1, 1, 0, 0.584658) , 
1.06593, 0, 1, 0, 0.534122) , 
0.32752, 1, 3, 0, 0.497457)    );
  // itree = 267
  fBoostWeights.push_back(0.822916);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.43743, 0, -1, -1, 0.2576) , 
NN(
NN(
0, 
0, 
-0.219235, 1, -1, -1, 0.354797) , 
NN(
NN(
0, 
0, 
-0.363788, 0, -1, 1, 0.539968) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.684307) , 
-0.150138, 1, 3, 0, 0.57459) , 
0.123085, 0, 3, 0, 0.547182) , 
1.71545, 0, 1, 0, 0.523789) , 
NN(
NN(
0, 
0, 
0.216616, 1, -1, -1, 0.457525) , 
NN(
0, 
0, 
0.491022, 1, -1, 1, 0.61252) , 
0.0783247, 1, 3, 0, 0.576504) , 
0.0206825, 1, 2, 0, 0.554075)    );
  // itree = 268
  fBoostWeights.push_back(0.811981);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.36034, 1, -1, -1, 0.403062) , 
NN(
NN(
NN(
0, 
0, 
1.20983, 0, -1, -1, 0.295846) , 
NN(
NN(
0, 
0, 
-1.96449, 0, -1, -1, 0.42045) , 
NN(
0, 
0, 
1.71727, 0, -1, 1, 0.676067) , 
-0.331337, 1, 0, 0, 0.550675) , 
1.30144, 1, 1, 0, 0.464017) , 
NN(
NN(
0, 
0, 
-2.01288, 0, -1, -1, 0.318239) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.202251, 1, -1, -1, 0.42131) , 
NN(
NN(
NN(
0, 
0, 
-0.293838, 1, -1, -1, 0.325643) , 
NN(
0, 
0, 
-1.07382, 0, -1, 1, 0.565529) , 
-0.459785, 1, 3, 0, 0.512678) , 
NN(
0, 
0, 
-0.751717, 1, -1, 1, 0.691289) , 
-0.61733, 0, 2, 0, 0.560119) , 
0.187117, 0, 0, 0, 0.512433) , 
NN(
0, 
0, 
0.514398, 0, -1, 1, 0.622035) , 
0.08143, 1, 3, 0, 0.568628) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.88584) , 
-1.18771, 0, 2, 0, 0.575508) , 
-1.30333, 1, 2, 0, 0.565266) , 
0.809545, 0, 1, 0, 0.539843) , 
1.86861, 0, 0, 0, 0.525646)    );
  // itree = 269
  fBoostWeights.push_back(0.82137);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.0649075, 1, -1, -1, 0.464037) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.691402) , 
0.196767, 1, 3, 0, 0.478305) , 
NN(
0, 
0, 
0.10138, 0, -1, 1, 0.568374) , 
0.32752, 1, 3, 0, 0.512248)    );
  // itree = 270
  fBoostWeights.push_back(0.717993);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.17648, 1, -1, -1, 0.43802) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.107864, 0, -1, -1, 0.423804) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.70955) , 
0.39658, 1, 3, 0, 0.439346) , 
NN(
NN(
0, 
0, 
-1.09492, 0, -1, -1, 0.47883) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.719897) , 
-0.147346, 1, 3, 0, 0.580836) , 
0.106272, 1, 1, 0, 0.491041) , 
NN(
0, 
0, 
1.69845, 0, -1, 1, 0.583947) , 
0.230675, 1, 2, 0, 0.53031) , 
0.948007, 0, 1, 0, 0.508109)    );
  // itree = 271
  fBoostWeights.push_back(0.784632);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.760086, 1, -1, -1, 0.398967) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.767117) , 
0.829765, 1, 3, 0, 0.424478) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.286151) , 
NN(
NN(
0, 
0, 
-1.11622, 0, -1, -1, 0.354631) , 
NN(
NN(
NN(
0, 
0, 
-0.945146, 0, -1, -1, 0.308903) , 
NN(
0, 
0, 
-0.202893, 0, -1, -1, 0.485991) , 
-0.732613, 1, 2, 0, 0.441531) , 
NN(
0, 
0, 
-1.04208, 1, -1, 1, 0.603352) , 
-0.438907, 1, 0, 0, 0.509621) , 
-0.601668, 0, 1, 0, 0.479777) , 
-1.67867, 1, 1, 0, 0.440835) , 
NN(
0, 
0, 
-1.1093, 0, -1, 1, 0.617728) , 
0.622144, 1, 2, 0, 0.476026) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.0381917, 1, -1, -1, 0.295882) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.373411) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.761428) , 
-0.221981, 0, 3, 0, 0.448996) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.317715) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.8118) , 
-0.205528, 1, 3, 0, 0.690423) , 
0.593282, 0, 1, 0, 0.568549) , 
0.395266, 1, 1, 0, 0.497401) , 
NN(
0, 
0, 
0.0910428, 0, -1, 1, 0.58029) , 
0.284173, 0, 1, 0, 0.542663) , 
NN(
0, 
0, 
-1.40875, 0, -1, 1, 0.783718) , 
-2.24087, 0, 0, 0, 0.553195) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.767866) , 
0.780667, 1, 1, 0, 0.565156) , 
-0.373098, 1, 1, 0, 0.52254) , 
0.948007, 0, 1, 0, 0.498847)    );
  // itree = 272
  fBoostWeights.push_back(0.704796);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.587509, 1, -1, -1, 0.352791) , 
NN(
NN(
0, 
0, 
-0.218294, 1, -1, -1, 0.458271) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.210165) , 
NN(
NN(
0, 
0, 
0.587504, 0, -1, -1, 0.275102) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.191771) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.0712106) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.905212) , 
-1.02324, 1, 3, 0, 0.756232) , 
-1.09727, 0, 0, 0, 0.60768) , 
-1.63195, 1, 0, 0, 0.473327) , 
-0.576128, 1, 1, 0, 0.376907) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.625419) , 
-1.05924, 0, 1, 0, 0.441215) , 
NN(
0, 
0, 
0.647461, 1, -1, 1, 0.640387) , 
-0.713378, 1, 0, 0, 0.556726) , 
-0.136909, 0, 2, 0, 0.503051) , 
1.71545, 0, 1, 0, 0.490491) , 
NN(
0, 
0, 
-1.35265, 1, -1, 1, 0.713375) , 
-2.47267, 0, 0, 0, 0.498509) , 
NN(
NN(
0, 
0, 
0.226128, 0, -1, -1, 0.465124) , 
NN(
0, 
0, 
-0.168967, 1, -1, 1, 0.639333) , 
0.418056, 1, 3, 0, 0.570719) , 
0.437295, 1, 2, 0, 0.522274)    );
  // itree = 273
  fBoostWeights.push_back(0.801105);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.114872) , 
NN(
NN(
0, 
0, 
1.03977, 1, -1, -1, 0.367573) , 
NN(
NN(
0, 
0, 
-0.184108, 0, -1, -1, 0.383587) , 
NN(
0, 
0, 
-0.287231, 0, -1, 1, 0.558413) , 
-0.193266, 1, 3, 0, 0.469121) , 
0.350033, 0, 3, 0, 0.437409) , 
-1.65891, 1, 0, 0, 0.427261) , 
NN(
NN(
0, 
0, 
-2.00428, 0, -1, -1, 0.403082) , 
NN(
0, 
0, 
-2.26124, 1, -1, 1, 0.652786) , 
-1.16601, 1, 3, 0, 0.590918) , 
-1.81287, 0, 0, 0, 0.449477) , 
NN(
NN(
NN(
0, 
0, 
0.541811, 0, -1, -1, 0.371501) , 
NN(
0, 
0, 
1.97842, 1, -1, 1, 0.574774) , 
0.921132, 1, 2, 0, 0.403667) , 
NN(
NN(
0, 
0, 
0.48252, 0, -1, -1, 0.491804) , 
NN(
0, 
0, 
0.903868, 0, -1, 1, 0.665985) , 
0.408331, 1, 2, 0, 0.56025) , 
-0.0706148, 1, 1, 0, 0.508977) , 
0.22982, 1, 0, 0, 0.473952)    );
  // itree = 274
  fBoostWeights.push_back(0.722786);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.273887) , 
NN(
0, 
0, 
2.20412, 1, -1, 1, 0.535661) , 
1.07308, 1, 3, 0, 0.350777) , 
NN(
NN(
0, 
0, 
-1.12131, 0, -1, -1, 0.43602) , 
NN(
0, 
0, 
-0.397034, 1, -1, 1, 0.514073) , 
-0.507056, 1, 3, 0, 0.500515) , 
1.86861, 0, 0, 0, 0.486977)    );
  // itree = 275
  fBoostWeights.push_back(0.700587);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.00697, 1, -1, -1, 0.405662) , 
NN(
0, 
0, 
1.51249, 0, -1, -1, 0.496793) , 
0.232448, 1, 3, 0, 0.456226) , 
NN(
NN(
0, 
0, 
1.81895, 1, -1, -1, 0.396012) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.376173) , 
NN(
NN(
0, 
0, 
-0.858499, 0, -1, -1, 0.344839) , 
NN(
NN(
0, 
0, 
-0.342675, 0, -1, 1, 0.529014) , 
NN(
0, 
0, 
-0.866019, 0, -1, 1, 0.66393) , 
0.0308375, 1, 3, 0, 0.592457) , 
-0.942081, 1, 3, 0, 0.550643) , 
-1.57152, 1, 1, 0, 0.5217) , 
NN(
0, 
0, 
0.192236, 1, -1, 1, 0.652957) , 
-0.1591, 1, 0, 0, 0.560679) , 
0.946333, 0, 1, 0, 0.527497) , 
0.22982, 0, 0, 0, 0.498849)    );
  // itree = 276
  fBoostWeights.push_back(0.777672);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.16162, 1, -1, -1, 0.369919) , 
NN(
NN(
NN(
0, 
0, 
0.929285, 1, -1, -1, 0.416356) , 
NN(
0, 
0, 
-1.55051, 1, -1, 1, 0.531591) , 
0.747893, 0, 2, 0, 0.511765) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.70819) , 
-2.12178, 0, 1, 0, 0.517692) , 
-0.924344, 1, 3, 0, 0.50757)    );
  // itree = 277
  fBoostWeights.push_back(0.7623);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.00955718) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.558693, 1, -1, -1, 0.321408) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.483932) , 
-0.0479638, 0, 3, 0, 0.372919) , 
NN(
0, 
0, 
1.64741, 0, -1, 1, 0.507792) , 
-0.239044, 0, 1, 0, 0.413925) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.949136) , 
2.08155, 1, 0, 0, 0.429612) , 
NN(
0, 
0, 
1.12896, 0, -1, 1, 0.639967) , 
1.32046, 1, 1, 0, 0.458201) , 
2.34798, 0, 0, 0, 0.438479) , 
NN(
0, 
0, 
2.03222, 0, -1, 1, 0.660962) , 
2.66951, 1, 0, 0, 0.45614) , 
NN(
NN(
0, 
0, 
0.0592401, 0, -1, -1, 0.45466) , 
NN(
0, 
0, 
-1.53258, 1, -1, 1, 0.593496) , 
-0.214186, 1, 3, 0, 0.543049) , 
0.22982, 0, 0, 0, 0.507668)    );
  // itree = 278
  fBoostWeights.push_back(0.780012);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.0836217, 0, -1, -1, 0.389949) , 
NN(
0, 
0, 
0.777311, 0, -1, 1, 0.609266) , 
0.810201, 1, 3, 0, 0.447388) , 
NN(
NN(
0, 
0, 
0.281312, 0, -1, -1, 0.350696) , 
NN(
NN(
NN(
0, 
0, 
0.320584, 0, -1, -1, 0.42325) , 
NN(
NN(
0, 
0, 
-0.0706212, 0, -1, -1, 0.455229) , 
NN(
NN(
0, 
0, 
-0.0397201, 0, -1, 1, 0.512054) , 
NN(
NN(
0, 
0, 
-0.267971, 0, -1, 1, 0.615399) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.824478) , 
-0.148427, 1, 3, 0, 0.729459) , 
0.0314285, 1, 1, 0, 0.589966) , 
0.884577, 0, 1, 0, 0.562151) , 
-0.676325, 1, 2, 0, 0.528708) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.747121) , 
0.281103, 1, 2, 0, 0.556233) , 
0.535119, 0, 3, 0, 0.539356) , 
0.437295, 0, 2, 0, 0.509643)    );
  // itree = 279
  fBoostWeights.push_back(0.792743);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.262654) , 
NN(
0, 
0, 
1.78531, 0, -1, -1, 0.458613) , 
1.21586, 1, 3, 0, 0.298325) , 
NN(
0, 
0, 
-1.18915, 1, -1, 1, 0.682713) , 
-0.441714, 0, 1, 0, 0.355609) , 
NN(
NN(
0, 
0, 
-3.3335, 0, -1, -1, 0.296442) , 
NN(
NN(
0, 
0, 
1.3852, 1, -1, 1, 0.50781) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.181468, 0, -1, -1, 0.325852) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.658151, 0, -1, -1, 0.214978) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.00608636) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.261123) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.35589) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.329174) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.766402) , 
-0.830187, 1, 3, 0, 0.622097) , 
-1.32943, 1, 2, 0, 0.558328) , 
0.555969, 0, 1, 0, 0.509151) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.788447) , 
1.02045, 1, 1, 0, 0.555511) , 
1.65221, 0, 1, 0, 0.494786) , 
-0.609163, 0, 2, 0, 0.404225) , 
NN(
0, 
0, 
-1.36372, 1, -1, 1, 0.612004) , 
-1.41482, 0, 0, 0, 0.46023) , 
NN(
0, 
0, 
-0.273379, 1, -1, 1, 0.588544) , 
-0.293617, 1, 2, 0, 0.526869) , 
0.908747, 0, 0, 0, 0.506892) , 
NN(
0, 
0, 
-0.571412, 1, -1, 1, 0.644622) , 
-1.05368, 0, 1, 0, 0.533442) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.82463) , 
0.24011, 1, 2, 0, 0.567088) , 
0.320555, 0, 2, 0, 0.544032) , 
-2.29437, 1, 0, 0, 0.536307) , 
1.86861, 0, 0, 0, 0.520169)    );
  // itree = 280
  fBoostWeights.push_back(0.856803);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.578, 1, -1, -1, 0.40186) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.932513, 0, -1, -1, 0.286248) , 
NN(
NN(
0, 
0, 
-0.220124, 0, -1, -1, 0.393306) , 
NN(
0, 
0, 
-0.234811, 1, -1, 1, 0.594212) , 
-0.147346, 1, 3, 0, 0.456873) , 
1.0681, 0, 1, 0, 0.420448) , 
NN(
0, 
0, 
-1.47834, 1, -1, 1, 0.639896) , 
-0.970608, 0, 1, 0, 0.470921) , 
NN(
0, 
0, 
-0.119969, 0, -1, 1, 0.566403) , 
0.00716327, 1, 2, 0, 0.511385) , 
0.437295, 0, 2, 0, 0.47436)    );
  // itree = 281
  fBoostWeights.push_back(0.8144);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-1.58451, 0, -1, -1, 0.33923) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.686357) , 
0.622144, 1, 2, 0, 0.387026) , 
NN(
NN(
0, 
0, 
-0.560528, 0, -1, -1, 0.424811) , 
NN(
NN(
0, 
0, 
1.77988, 1, -1, -1, 0.381811) , 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.219577, 1, -1, -1, 0.318658) , 
NN(
0, 
0, 
0.782556, 0, -1, 1, 0.556182) , 
0.596258, 1, 3, 0, 0.405462) , 
NN(
0, 
0, 
1.6547, 0, -1, 1, 0.624563) , 
0.733517, 1, 1, 0, 0.453889) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.802622) , 
-1.09365, 0, 1, 0, 0.473595) , 
NN(
0, 
0, 
0.0522143, 1, -1, 1, 0.647653) , 
-0.132363, 0, 2, 0, 0.503698) , 
NN(
0, 
0, 
0.121641, 1, -1, 1, 0.632297) , 
-0.382052, 0, 0, 0, 0.536303) , 
1.43631, 0, 1, 0, 0.524044) , 
-0.507056, 1, 3, 0, 0.509422) , 
-1.31111, 1, 1, 0, 0.495248) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.701909) , 
-2.42611, 0, 1, 0, 0.501286) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.748505) , 
2.4829, 1, 1, 0, 0.506869)    );
  // itree = 282
  fBoostWeights.push_back(0.704567);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.1414, 0, -1, -1, 0.299746) , 
NN(
NN(
0, 
0, 
-1.17465, 1, -1, -1, 0.412483) , 
NN(
0, 
0, 
-0.534466, 1, -1, 1, 0.52921) , 
-0.264912, 1, 3, 0, 0.460896) , 
0.111225, 0, 3, 0, 0.437436) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.338672) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.297609) , 
NN(
0, 
0, 
-0.387508, 1, -1, 1, 0.592405) , 
-0.197403, 1, 3, 0, 0.555252) , 
0.798569, 0, 2, 0, 0.477568) , 
NN(
0, 
0, 
1.87407, 0, -1, 1, 0.567486) , 
0.0736846, 1, 0, 0, 0.526485) , 
0.0206825, 1, 2, 0, 0.490397)    );
  // itree = 283
  fBoostWeights.push_back(0.77473);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.247104, 0, -1, -1, 0.408053) , 
NN(
NN(
0, 
0, 
-0.240544, 0, -1, -1, 0.421244) , 
NN(
0, 
0, 
0.029835, 1, -1, 1, 0.600994) , 
-0.324807, 1, 3, 0, 0.511565) , 
-0.366598, 0, 0, 0, 0.453378) , 
NN(
NN(
NN(
0, 
0, 
1.48895, 1, -1, -1, 0.430668) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.429536, 0, -1, -1, 0.496743) , 
NN(
0, 
0, 
1.43564, 0, -1, 1, 0.631481) , 
0.880936, 1, 3, 0, 0.539661) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.756352) , 
0.0985762, 0, 2, 0, 0.554323) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
0.784755, 1, 1, 0, 0.571943) , 
1.21526, 0, 1, 0, 0.54353) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.828905) , 
-2.14924, 0, 1, 0, 0.557655) , 
0.32752, 1, 3, 0, 0.493789)    );
  // itree = 284
  fBoostWeights.push_back(0.736915);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.362315) , 
NN(
NN(
NN(
0, 
0, 
-0.997925, 0, -1, -1, 0.236877) , 
NN(
NN(
NN(
0, 
0, 
-0.712043, 1, -1, -1, 0.340866) , 
NN(
NN(
0, 
0, 
-2.01339, 0, -1, -1, 0.427178) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.615772) , 
-0.892052, 1, 3, 0, 0.505477) , 
-0.921226, 0, 2, 0, 0.427328) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.804523) , 
1.2143, 1, 1, 0, 0.456901) , 
1.58429, 0, 1, 0, 0.431631) , 
NN(
0, 
0, 
0.168232, 1, -1, 1, 0.528076) , 
-0.481172, 1, 2, 0, 0.483848) , 
-0.0884405, 0, 3, 0, 0.466222) , 
NN(
0, 
0, 
0.371189, 0, -1, 1, 0.540629) , 
0.0364975, 1, 3, 0, 0.502968) , 
NN(
0, 
0, 
0.388636, 0, -1, 1, 0.60402) , 
0.744808, 1, 3, 0, 0.514924)    );
  // itree = 285
  fBoostWeights.push_back(0.673144);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.809819, 1, -1, -1, 0.410624) , 
NN(
NN(
0, 
0, 
-0.176185, 1, -1, -1, 0.434794) , 
NN(
0, 
0, 
0.874649, 1, -1, 1, 0.534904) , 
-0.368986, 1, 3, 0, 0.506637) , 
0.431848, 0, 2, 0, 0.482635) , 
NN(
0, 
0, 
1.644, 0, -1, 1, 0.572039) , 
1.33173, 1, 1, 0, 0.495789) , 
NN(
0, 
0, 
2.44609, 0, -1, 1, 0.611563) , 
0.744808, 1, 3, 0, 0.509286)    );
  // itree = 286
  fBoostWeights.push_back(0.77823);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.201237, 1, -1, -1, 0.290295) , 
NN(
NN(
0, 
0, 
1.29982, 1, -1, -1, 0.381095) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.685111) , 
-0.193076, 1, 3, 0, 0.453631) , 
-0.0605282, 0, 2, 0, 0.363694) , 
NN(
0, 
0, 
1.41783, 0, -1, 1, 0.529387) , 
0.374831, 1, 2, 0, 0.413684) , 
NN(
NN(
NN(
0, 
0, 
-2.4354, 0, -1, -1, 0.375004) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.248032) , 
NN(
NN(
NN(
0, 
0, 
0.423417, 0, -1, -1, 0.439209) , 
NN(
0, 
0, 
-0.362073, 1, -1, 1, 0.525846) , 
0.613527, 1, 3, 0, 0.464835) , 
NN(
0, 
0, 
-0.36281, 0, -1, 1, 0.65347) , 
-0.47427, 0, 3, 0, 0.482445) , 
-1.19495, 1, 0, 0, 0.466197) , 
NN(
NN(
0, 
0, 
0.757369, 1, -1, -1, 0.452716) , 
NN(
0, 
0, 
-1.03297, 1, -1, 1, 0.686244) , 
0.36904, 0, 3, 0, 0.606742) , 
-0.862225, 0, 1, 0, 0.502852) , 
-1.75274, 1, 1, 0, 0.490678) , 
NN(
NN(
0, 
0, 
-1.11788, 0, -1, -1, 0.419909) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.870319) , 
-0.636064, 1, 3, 0, 0.630555) , 
-1.71004, 0, 0, 0, 0.50466) , 
0.564284, 0, 1, 0, 0.475223)    );
  // itree = 287
  fBoostWeights.push_back(0.839877);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.75425, 0, -1, -1, 0.291841) , 
NN(
NN(
NN(
0, 
0, 
-0.458773, 0, -1, -1, 0.344805) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
1.09131, 1, -1, -1, 0.194286) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.881611, 1, -1, -1, 0.284012) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.300137) , 
NN(
0, 
0, 
1.62538, 0, -1, -1, 0.48277) , 
0.120273, 1, 3, 0, 0.430564) , 
0.258416, 1, 1, 0, 0.387985) , 
NN(
0, 
0, 
-0.236085, 1, -1, -1, 0.49267) , 
-0.10807, 0, 1, 0, 0.419909) , 
NN(
0, 
0, 
0.703674, 1, -1, 1, 0.674546) , 
-1.10512, 0, 1, 0, 0.44521) , 
-1.67756, 1, 1, 0, 0.425434) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.605862) , 
1.57384, 1, 1, 0, 0.443116) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.739395) , 
-0.135088, 0, 2, 0, 0.458347) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.764908) , 
-0.224642, 0, 2, 0, 0.474228) , 
-0.321356, 1, 2, 0, 0.460621) , 
NN(
0, 
0, 
0.200984, 0, -1, 1, 0.609934) , 
-0.830502, 0, 2, 0, 0.469748) , 
-0.993087, 1, 3, 0, 0.465937) , 
NN(
NN(
0, 
0, 
-2.68764, 1, -1, -1, 0.481994) , 
NN(
0, 
0, 
-1.90085, 0, -1, 1, 0.674601) , 
-0.514317, 1, 3, 0, 0.585745) , 
-1.40897, 0, 0, 0, 0.48247)    );
  // itree = 288
  fBoostWeights.push_back(0.824028);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.320584, 0, -1, -1, 0.356328) , 
NN(
NN(
NN(
0, 
0, 
-0.143703, 1, -1, -1, 0.43901) , 
NN(
0, 
0, 
-0.100064, 1, -1, 1, 0.516244) , 
-0.196619, 0, 3, 0, 0.469216) , 
NN(
0, 
0, 
0.566484, 1, -1, 1, 0.575271) , 
0.505003, 1, 3, 0, 0.494352) , 
1.71545, 0, 1, 0, 0.483444)    );
  // itree = 289
  fBoostWeights.push_back(0.783377);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.3159, 1, -1, -1, 0.385712) , 
NN(
0, 
0, 
1.49593, 0, -1, 1, 0.575134) , 
0.377241, 1, 2, 0, 0.449822) , 
NN(
NN(
NN(
0, 
0, 
-1.56801, 0, -1, -1, 0.418055) , 
NN(
NN(
0, 
0, 
-0.346763, 0, -1, -1, 0.399495) , 
NN(
NN(
NN(
0, 
0, 
-0.292015, 0, -1, -1, 0.476934) , 
NN(
0, 
0, 
2.40523, 0, -1, 1, 0.607748) , 
0.117464, 1, 3, 0, 0.553647) , 
NN(
0, 
0, 
0.239461, 0, -1, 1, 0.644558) , 
-0.514625, 0, 1, 0, 0.579904) , 
-0.617057, 1, 3, 0, 0.558107) , 
-1.21554, 1, 1, 0, 0.537094) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.744192) , 
-2.05089, 0, 1, 0, 0.54712) , 
0.948007, 0, 1, 0, 0.52381)    );
  // itree = 290
  fBoostWeights.push_back(0.770092);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.221938, 0, -1, -1, 0.29872) , 
NN(
NN(
0, 
0, 
-0.798908, 0, -1, -1, 0.328727) , 
NN(
NN(
0, 
0, 
-0.518487, 0, -1, -1, 0.39705) , 
NN(
0, 
0, 
-2.05272, 0, -1, 1, 0.523879) , 
-0.340206, 1, 3, 0, 0.503944) , 
-0.884257, 1, 3, 0, 0.492118) , 
1.68312, 0, 1, 0, 0.481219) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.721133) , 
2.4829, 1, 1, 0, 0.489499)    );
  // itree = 291
  fBoostWeights.push_back(0.741347);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.239586, 1, -1, -1, 0.407705) , 
NN(
NN(
0, 
0, 
1.2247, 1, -1, -1, 0.40432) , 
NN(
NN(
0, 
0, 
-1.00639, 0, -1, -1, 0.404153) , 
NN(
0, 
0, 
0.0790605, 0, -1, 1, 0.624143) , 
-0.462488, 1, 3, 0, 0.538811) , 
0.235983, 0, 1, 0, 0.477887) , 
-0.0863038, 0, 0, 0, 0.443071) , 
NN(
NN(
0, 
0, 
0.570965, 1, -1, -1, 0.481381) , 
NN(
0, 
0, 
0.777311, 0, -1, 1, 0.695147) , 
0.810201, 1, 3, 0, 0.548374) , 
0.437295, 1, 2, 0, 0.475958)    );
  // itree = 292
  fBoostWeights.push_back(0.747598);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.339286) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.333203) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.165939) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.112165) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.185349) , 
NN(
NN(
0, 
0, 
0.556982, 0, -1, -1, 0.361913) , 
NN(
0, 
0, 
-1.57415, 1, -1, 1, 0.501425) , 
-0.957021, 1, 3, 0, 0.452821) , 
-0.709574, 1, 1, 0, 0.426839) , 
-2.79721, 1, 0, 0, 0.399224) , 
NN(
0, 
0, 
-1.14119, 1, -1, 1, 0.591989) , 
-1.05154, 0, 1, 0, 0.434756) , 
-0.317737, 0, 0, 0, 0.394549) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.573438) , 
-0.224175, 1, 3, 0, 0.45032) , 
0.040939, 0, 3, 0, 0.427348) , 
NN(
0, 
0, 
-0.27163, 0, -1, 1, 0.514324) , 
0.0731012, 1, 0, 0, 0.459664) , 
0.373431, 0, 2, 0, 0.445096) , 
NN(
0, 
0, 
-0.586123, 1, -1, 1, 0.642453) , 
1.71545, 1, 1, 0, 0.463682) , 
NN(
0, 
0, 
1.06593, 0, -1, 1, 0.562166) , 
0.32752, 1, 3, 0, 0.501505)    );
  // itree = 293
  fBoostWeights.push_back(0.692295);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.0729577, 1, -1, -1, 0.414877) , 
NN(
NN(
0, 
0, 
0.320584, 0, -1, -1, 0.393024) , 
NN(
0, 
0, 
-1.06873, 0, -1, 1, 0.525049) , 
-0.590528, 1, 3, 0, 0.499512) , 
-0.203162, 1, 1, 0, 0.464738) , 
NN(
0, 
0, 
0.0985762, 0, -1, 1, 0.569166) , 
0.32752, 1, 3, 0, 0.505081)    );
  // itree = 294
  fBoostWeights.push_back(0.672518);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.760086, 0, -1, -1, 0.401415) , 
NN(
0, 
0, 
0.478539, 1, -1, 1, 0.50391) , 
-0.324807, 1, 3, 0, 0.467754) , 
NN(
0, 
0, 
0.908359, 0, -1, 1, 0.562191) , 
0.32752, 1, 3, 0, 0.503553)    );
  // itree = 295
  fBoostWeights.push_back(0.706384);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.645442, 0, -1, -1, 0.258565) , 
NN(
NN(
NN(
0, 
0, 
-0.251537, 0, -1, -1, 0.33111) , 
NN(
NN(
0, 
0, 
-0.771311, 1, -1, -1, 0.363377) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.816453) , 
-0.790596, 1, 3, 0, 0.482879) , 
-0.897376, 0, 2, 0, 0.383533) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.690972) , 
0.0501038, 1, 3, 0, 0.423047) , 
0.44922, 0, 0, 0, 0.358708) , 
NN(
NN(
0, 
0, 
-1.15919, 0, -1, -1, 0.44013) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.585115) , 
-0.332839, 1, 2, 0, 0.50929) , 
-0.586885, 0, 1, 0, 0.410973) , 
NN(
NN(
NN(
0, 
0, 
-0.383516, 0, -1, -1, 0.452137) , 
NN(
0, 
0, 
0.53983, 1, -1, 1, 0.609146) , 
1.01042, 1, 3, 0, 0.468421) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.613162) , 
1.57384, 1, 1, 0, 0.484619) , 
0.0206825, 1, 2, 0, 0.451758)    );
  // itree = 296
  fBoostWeights.push_back(0.919641);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.51677, 1, -1, -1, 0.365095) , 
NN(
NN(
0, 
0, 
-0.2835, 0, -1, -1, 0.329723) , 
NN(
NN(
0, 
0, 
-2.22313, 0, -1, -1, 0.336818) , 
NN(
NN(
NN(
0, 
0, 
1.00588, 1, -1, -1, 0.364427) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.332301) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.61533, 1, -1, -1, 0.264104) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.281809) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.378854) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.668844) , 
-0.127759, 1, 3, 0, 0.531077) , 
0.438388, 1, 1, 0, 0.444745) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.700023) , 
0.279376, 0, 1, 0, 0.530596) , 
0.192325, 1, 1, 0, 0.458447) , 
NN(
NN(
0, 
0, 
-0.700777, 1, -1, -1, 0.40518) , 
NN(
0, 
0, 
-0.18179, 0, -1, 1, 0.621974) , 
-0.034808, 1, 3, 0, 0.551741) , 
-0.107515, 0, 1, 0, 0.500685) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.81412, 1, 3, 0, 0.504829) , 
-1.30134, 1, 0, 0, 0.491904) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.694216) , 
-1.85689, 0, 0, 0, 0.501891) , 
0.809289, 0, 1, 0, 0.485722) , 
NN(
0, 
0, 
-0.0505167, 1, -1, 1, 0.644984) , 
2.07326, 1, 0, 0, 0.497613) , 
-0.942996, 1, 3, 0, 0.487209) , 
-1.64874, 1, 1, 0, 0.471651) , 
1.33173, 0, 1, 0, 0.455016)    );
  // itree = 297
  fBoostWeights.push_back(0.849772);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.904245, 0, -1, -1, 0.313892) , 
NN(
0, 
0, 
0.822017, 0, -1, -1, 0.454345) , 
0.377241, 1, 2, 0, 0.363125) , 
NN(
NN(
NN(
0, 
0, 
0.796959, 1, -1, -1, 0.389074) , 
NN(
NN(
0, 
0, 
-1.09169, 1, -1, -1, 0.345415) , 
NN(
0, 
0, 
-0.008267, 1, -1, 1, 0.588282) , 
-0.38279, 1, 3, 0, 0.511334) , 
-0.335683, 0, 0, 0, 0.443437) , 
NN(
NN(
0, 
0, 
0.779766, 1, -1, -1, 0.389575) , 
NN(
NN(
NN(
0, 
0, 
0.250758, 1, -1, -1, 0.437055) , 
NN(
0, 
0, 
0.284893, 0, -1, 1, 0.592813) , 
-0.0443975, 0, 3, 0, 0.486564) , 
NN(
NN(
0, 
0, 
0.56346, 0, -1, -1, 0.415078) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.721689) , 
-0.264679, 1, 0, 0, 0.620554) , 
0.395158, 1, 1, 0, 0.523586) , 
0.65095, 0, 1, 0, 0.498598) , 
-0.133413, 1, 1, 0, 0.469601) , 
0.948007, 0, 1, 0, 0.444075)    );
  // itree = 298
  fBoostWeights.push_back(0.759321);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.07264, 0, -1, -1, 0.290198) , 
NN(
NN(
NN(
NN(
0, 
0, 
1.37306, 0, -1, -1, 0.114539) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.377709) , 
-0.62507, 1, 3, 0, 0.299986) , 
NN(
NN(
0, 
0, 
0.593827, 1, -1, -1, 0.428944) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.743851) , 
-0.380191, 0, 3, 0, 0.446188) , 
-0.368541, 1, 2, 0, 0.426652) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.385572) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.906815) , 
-0.698804, 1, 2, 0, 0.79149) , 
-1.08833, 0, 0, 0, 0.444344) , 
-1.57291, 1, 0, 0, 0.433936) , 
NN(
0, 
0, 
-2.13841, 1, -1, 1, 0.731757) , 
-2.5015, 0, 0, 0, 0.440214) , 
NN(
NN(
0, 
0, 
-1.70999, 1, -1, -1, 0.437547) , 
NN(
NN(
0, 
0, 
-1.57262, 0, -1, -1, 0.410209) , 
NN(
0, 
0, 
0.07275, 0, -1, 1, 0.595306) , 
-0.801328, 1, 3, 0, 0.579592) , 
-1.53258, 1, 1, 0, 0.55004) , 
0.180561, 0, 1, 0, 0.494414)    );
  // itree = 299
  fBoostWeights.push_back(0.785488);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.243753) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.391274) , 
NN(
0, 
0, 
1.8485, 0, -1, 1, 0.556745) , 
0.57799, 1, 3, 0, 0.476485) , 
1.59466, 1, 0, 0, 0.423559) , 
NN(
NN(
0, 
0, 
-1.42633, 1, -1, 1, 0.518536) , 
NN(
NN(
0, 
0, 
0.72167, 0, -1, 1, 0.589531) , 
NN(
0, 
0, 
1.17032, 0, -1, 1, 0.76626) , 
0.877883, 1, 3, 0, 0.605426) , 
0.0206825, 1, 2, 0, 0.562842) , 
1.32235, 0, 0, 0, 0.538777)    );
  // itree = 300
  fBoostWeights.push_back(0.806348);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.388971, 0, -1, -1, 0.445791) , 
NN(
NN(
0, 
0, 
-0.840112, 0, -1, -1, 0.430589) , 
NN(
0, 
0, 
-0.207704, 1, -1, 1, 0.619838) , 
-0.324807, 1, 3, 0, 0.542693) , 
0.0882514, 0, 0, 0, 0.505357) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.854933) , 
2.4829, 1, 1, 0, 0.51688) , 
NN(
0, 
0, 
-0.760989, 1, -1, 1, 0.595596) , 
0.32752, 1, 3, 0, 0.546334)    );
  // itree = 301
  fBoostWeights.push_back(0.800151);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.320584, 0, -1, -1, 0.397585) , 
NN(
NN(
NN(
0, 
0, 
-0.354705, 0, -1, -1, 0.374308) , 
NN(
NN(
0, 
0, 
-0.518304, 0, -1, -1, 0.41912) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.611122) , 
-0.332839, 1, 2, 0, 0.504949) , 
-0.602236, 0, 1, 0, 0.469499) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.640486) , 
-0.133369, 1, 1, 0, 0.492627) , 
0.180561, 0, 1, 0, 0.450791) , 
NN(
0, 
0, 
-0.760989, 0, -1, 1, 0.568367) , 
0.0206825, 1, 2, 0, 0.515359)    );
  // itree = 302
  fBoostWeights.push_back(0.746132);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
0.331874, 0, -1, -1, 0.384026) , 
-0.328641, 1, 3, 0, 0.346473) , 
NN(
NN(
NN(
0, 
0, 
-1.21133, 1, -1, -1, 0.387901) , 
NN(
0, 
0, 
0.177357, 0, -1, 1, 0.513726) , 
-0.0133238, 1, 2, 0, 0.416197) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.488631, 0, -1, -1, 0.257177) , 
NN(
NN(
0, 
0, 
0.565404, 0, -1, -1, 0.447425) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.745177) , 
-0.383553, 1, 3, 0, 0.601398) , 
0.710591, 0, 1, 0, 0.417282) , 
NN(
0, 
0, 
-0.978978, 1, -1, 1, 0.623902) , 
1.75111, 1, 1, 0, 0.464742) , 
NN(
0, 
0, 
-0.145721, 0, -1, 1, 0.608088) , 
-0.0401462, 1, 0, 0, 0.50609) , 
0.0642531, 1, 1, 0, 0.457252) , 
0.827687, 0, 0, 0, 0.438383) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.61123) , 
1.82279, 1, 0, 0, 0.453468) , 
NN(
NN(
0, 
0, 
0.386628, 0, -1, -1, 0.493008) , 
NN(
0, 
0, 
1.14407, 0, -1, 1, 0.616688) , 
0.810201, 1, 3, 0, 0.527129) , 
0.437295, 1, 2, 0, 0.47516)    );
  // itree = 303
  fBoostWeights.push_back(0.718124);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.271221) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.278448) , 
NN(
NN(
NN(
0, 
0, 
-0.674293, 0, -1, -1, 0.35137) , 
NN(
0, 
0, 
-0.955656, 0, -1, -1, 0.468087) , 
-0.308002, 1, 3, 0, 0.422793) , 
NN(
0, 
0, 
1.19345, 0, -1, 1, 0.635116) , 
-1.62992, 0, 3, 0, 0.435565) , 
-1.14463, 1, 1, 0, 0.415668) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.571721) , 
-1.89507, 0, 1, 0, 0.428031) , 
0.357469, 0, 0, 0, 0.413872) , 
NN(
0, 
0, 
-0.235072, 1, -1, 1, 0.524331) , 
0.5431, 1, 0, 0, 0.440008) , 
NN(
0, 
0, 
1.3257, 0, -1, 1, 0.52568) , 
0.32752, 1, 3, 0, 0.472966)    );
  // itree = 304
  fBoostWeights.push_back(0.678243);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.12629, 1, -1, -1, 0.398655) , 
NN(
NN(
NN(
0, 
0, 
-1.14959, 0, -1, -1, 0.325475) , 
NN(
NN(
0, 
0, 
0.666012, 1, -1, -1, 0.440329) , 
NN(
NN(
NN(
0, 
0, 
-1.6866, 0, -1, -1, 0.2724) , 
NN(
0, 
0, 
-0.289608, 1, -1, 1, 0.565377) , 
-1.06155, 1, 3, 0, 0.542896) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.816678) , 
-1.89757, 0, 0, 0, 0.566454) , 
-0.128769, 0, 2, 0, 0.507341) , 
-2.1813, 1, 0, 0, 0.496864) , 
NN(
0, 
0, 
0.834093, 1, -1, 1, 0.579975) , 
0.153126, 1, 3, 0, 0.530066) , 
1.32235, 0, 0, 0, 0.505463)    );
  // itree = 305
  fBoostWeights.push_back(0.691336);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.11967, 0, -1, -1, 0.401361) , 
NN(
0, 
0, 
-1.82772, 1, -1, 1, 0.518458) , 
0.544374, 1, 3, 0, 0.440508) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.21683) , 
NN(
NN(
0, 
0, 
-0.298805, 0, -1, -1, 0.395189) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.397933) , 
NN(
NN(
0, 
0, 
-1.14269, 1, -1, 1, 0.518815) , 
NN(
0, 
0, 
0.238403, 0, -1, 1, 0.639132) , 
-0.232107, 1, 3, 0, 0.571814) , 
-1.62987, 1, 1, 0, 0.549936) , 
-0.111734, 0, 2, 0, 0.519606) , 
2.09918, 0, 1, 0, 0.504176) , 
0.0206825, 0, 2, 0, 0.467539)    );
  // itree = 306
  fBoostWeights.push_back(0.714147);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.507453, 0, -1, -1, 0.356729) , 
NN(
NN(
NN(
0, 
0, 
0.664186, 0, -1, -1, 0.390122) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.233201) , 
NN(
0, 
0, 
0.347534, 0, -1, 1, 0.506445) , 
0.952769, 1, 3, 0, 0.406816) , 
NN(
0, 
0, 
0.705995, 0, -1, 1, 0.572429) , 
0.696384, 0, 2, 0, 0.490427) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.997719) , 
0.758745, 1, 1, 0, 0.528725) , 
0.410327, 1, 3, 0, 0.438098) , 
NN(
0, 
0, 
-0.714342, 1, -1, 1, 0.577485) , 
-0.405014, 0, 0, 0, 0.475961) , 
-0.686623, 1, 1, 0, 0.462123) , 
NN(
0, 
0, 
0.411586, 0, -1, 1, 0.548566) , 
1.30791, 1, 1, 0, 0.479117) , 
NN(
NN(
0, 
0, 
-0.361368, 0, -1, -1, 0.484051) , 
NN(
0, 
0, 
0.652364, 1, -1, 1, 0.657617) , 
0.250448, 1, 3, 0, 0.558761) , 
-0.970608, 0, 1, 0, 0.495497)    );
  // itree = 307
  fBoostWeights.push_back(0.712844);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-1.60375, 0, -1, -1, 0.266957) , 
NN(
0, 
0, 
-2.67151, 1, -1, -1, 0.433931) , 
-0.526368, 0, 3, 0, 0.346655) , 
NN(
0, 
0, 
-2.20498, 1, -1, 1, 0.543464) , 
-1.01534, 0, 1, 0, 0.400961) , 
NN(
0, 
0, 
0.472242, 0, -1, -1, 0.474283) , 
-1.04085, 1, 0, 0, 0.46087) , 
NN(
0, 
0, 
3.09328, 0, -1, 1, 0.596761) , 
0.744808, 1, 3, 0, 0.475149)    );
  // itree = 308
  fBoostWeights.push_back(0.772291);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.190138, 1, -1, -1, 0.243093) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.180368) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.128706) , 
NN(
NN(
NN(
0, 
0, 
-0.826021, 0, -1, -1, 0.330464) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.292587) , 
NN(
0, 
0, 
0.42556, 0, -1, 1, 0.537298) , 
-0.153923, 1, 3, 0, 0.466046) , 
-0.224673, 1, 2, 0, 0.412612) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.663117) , 
-1.77931, 0, 0, 0, 0.430468) , 
-2.28697, 1, 0, 0, 0.421421) , 
0.91187, 0, 2, 0, 0.409151) , 
0.592181, 0, 0, 0, 0.393823) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.785152) , 
1.27793, 1, 2, 0, 0.398592) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.83888) , 
-2.93659, 0, 0, 0, 0.404798) , 
NN(
0, 
0, 
0.380897, 0, -1, 1, 0.538684) , 
1.09926, 1, 0, 0, 0.423787) , 
NN(
NN(
0, 
0, 
-0.118919, 1, -1, -1, 0.429626) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.318378) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.419723) , 
NN(
NN(
0, 
0, 
1.06103, 1, -1, 1, 0.523663) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.70757) , 
-0.101962, 1, 3, 0, 0.598926) , 
0.27569, 0, 2, 0, 0.551604) , 
0.410984, 1, 1, 0, 0.517386) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.60802) , 
0.270582, 0, 1, 0, 0.538771) , 
NN(
0, 
0, 
0.614992, 1, -1, 1, 0.640592) , 
0.627513, 1, 3, 0, 0.555225) , 
1.36636, 0, 1, 0, 0.516258) , 
0.180561, 1, 1, 0, 0.46887)    );
  // itree = 309
  fBoostWeights.push_back(0.779993);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.14924, 0, -1, -1, 0.455702) , 
NN(
NN(
0, 
0, 
-0.240544, 0, -1, -1, 0.442178) , 
NN(
0, 
0, 
-0.356112, 0, -1, 1, 0.58237) , 
-0.456553, 1, 3, 0, 0.523493) , 
-0.0897679, 0, 3, 0, 0.482369)    );
  // itree = 310
  fBoostWeights.push_back(0.775689);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.156612) , 
NN(
0, 
0, 
0.321444, 0, -1, -1, 0.375938) , 
-0.160026, 1, 3, 0, 0.33282) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.31555) , 
NN(
0, 
0, 
3.0057, 0, -1, -1, 0.498567) , 
0.832254, 1, 3, 0, 0.403894) , 
NN(
0, 
0, 
0.272757, 1, -1, 1, 0.603351) , 
1.87407, 0, 0, 0, 0.554367) , 
0.0736846, 1, 0, 0, 0.456667) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.196673) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.330959) , 
NN(
0, 
0, 
-2.16162, 1, -1, 1, 0.501873) , 
-0.545723, 0, 3, 0, 0.449961) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.609826) , 
-0.191793, 1, 3, 0, 0.483775) , 
NN(
0, 
0, 
0.238403, 0, -1, 1, 0.613344) , 
-0.372003, 1, 2, 0, 0.548305) , 
2.09918, 0, 1, 0, 0.533473) , 
0.0206825, 0, 2, 0, 0.490258)    );
  // itree = 311
  fBoostWeights.push_back(0.638152);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.382627, 1, -1, -1, 0.344076) , 
NN(
NN(
0, 
0, 
-1.13577, 0, -1, -1, 0.436892) , 
NN(
0, 
0, 
0.50474, 0, -1, 1, 0.557667) , 
-0.329226, 1, 3, 0, 0.506069) , 
0.0488495, 0, 2, 0, 0.454501) , 
NN(
0, 
0, 
0.308694, 1, -1, 1, 0.53424) , 
0.32752, 1, 3, 0, 0.485134)    );
  // itree = 312
  fBoostWeights.push_back(0.730999);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.251607, 1, -1, -1, 0.363639) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.280895) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.256294) , 
NN(
NN(
0, 
0, 
0.274927, 1, -1, -1, 0.442289) , 
NN(
NN(
0, 
0, 
-1.45344, 1, -1, -1, 0.45802) , 
NN(
NN(
0, 
0, 
0.573339, 0, -1, -1, 0.496496) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.416039) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.733937) , 
-0.361198, 1, 3, 0, 0.665891) , 
-0.703961, 1, 2, 0, 0.592582) , 
-0.0463612, 1, 1, 0, 0.517648) , 
-0.0623079, 0, 2, 0, 0.477066) , 
1.14991, 0, 0, 0, 0.471686) , 
2.30013, 0, 1, 0, 0.46497) , 
1.34551, 0, 0, 0, 0.451484) , 
NN(
0, 
0, 
-0.220137, 0, -1, 1, 0.569635) , 
0.744808, 1, 3, 0, 0.464671)    );
  // itree = 313
  fBoostWeights.push_back(0.819619);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.824857, 0, -1, -1, 0.27185) , 
NN(
NN(
NN(
0, 
0, 
0.029905, 0, -1, -1, 0.317929) , 
NN(
NN(
0, 
0, 
0.137645, 1, -1, -1, 0.424141) , 
NN(
0, 
0, 
-0.686622, 0, -1, 1, 0.601634) , 
-0.343006, 1, 3, 0, 0.521645) , 
-0.119964, 0, 2, 0, 0.456352) , 
NN(
0, 
0, 
1.11034, 1, -1, 1, 0.540289) , 
0.146269, 1, 2, 0, 0.479794) , 
1.68312, 0, 1, 0, 0.465928) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.687169) , 
2.4829, 1, 1, 0, 0.473524) , 
NN(
0, 
0, 
0.641999, 1, -1, 1, 0.589853) , 
0.437295, 1, 2, 0, 0.506411)    );
  // itree = 314
  fBoostWeights.push_back(0.839984);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.45539, 0, -1, -1, 0.216092) , 
NN(
0, 
0, 
1.2669, 0, -1, 1, 0.596599) , 
0.451547, 1, 0, 0, 0.348541) , 
NN(
NN(
0, 
0, 
2.2275, 0, -1, -1, 0.346236) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.682628) , 
-0.241961, 1, 3, 0, 0.536256) , 
1.74619, 1, 1, 0, 0.410156) , 
NN(
NN(
0, 
0, 
-0.86335, 0, -1, -1, 0.396906) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.262947, 1, -1, -1, 0.371039) , 
NN(
0, 
0, 
-0.0884643, 0, -1, 1, 0.50617) , 
-0.1547, 1, 3, 0, 0.484455) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.727151) , 
-0.393705, 0, 2, 0, 0.501662) , 
NN(
NN(
0, 
0, 
-1.46598, 0, -1, 1, 0.573725) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.43984) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.944368) , 
-0.363232, 1, 3, 0, 0.837592) , 
-0.338476, 1, 1, 0, 0.663151) , 
-0.802461, 0, 0, 0, 0.530417) , 
-0.689726, 1, 2, 0, 0.514601) , 
0.948007, 0, 1, 0, 0.491544)    );
  // itree = 315
  fBoostWeights.push_back(0.683862);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.0662527, 0, -1, -1, 0.31724) , 
NN(
0, 
0, 
0.954579, 1, -1, 1, 0.507257) , 
0.16566, 1, 2, 0, 0.437316) , 
NN(
NN(
0, 
0, 
1.0223, 1, -1, -1, 0.417387) , 
NN(
NN(
0, 
0, 
0.289185, 0, -1, -1, 0.407374) , 
NN(
NN(
NN(
0, 
0, 
0.0937318, 0, -1, -1, 0.42697) , 
NN(
NN(
NN(
0, 
0, 
-0.355749, 0, -1, -1, 0.369824) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.665257) , 
-0.205175, 1, 3, 0, 0.510071) , 
NN(
0, 
0, 
-1.34217, 0, -1, 1, 0.638949) , 
-0.229068, 1, 1, 0, 0.570413) , 
0.159566, 0, 3, 0, 0.527137) , 
NN(
0, 
0, 
0.736398, 0, -1, 1, 0.75138) , 
0.592624, 1, 3, 0, 0.553752) , 
-1.40446, 1, 1, 0, 0.527574) , 
0.809545, 0, 1, 0, 0.503279) , 
0.885784, 0, 0, 0, 0.488269) , 
NN(
0, 
0, 
1.88247, 1, -1, 1, 0.664039) , 
1.27052, 1, 2, 0, 0.494884)    );
  // itree = 316
  fBoostWeights.push_back(0.747184);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.287793) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.304361) , 
NN(
NN(
0, 
0, 
-0.201851, 1, -1, -1, 0.445283) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.645889) , 
0.554141, 1, 3, 0, 0.455058) , 
0.334297, 0, 2, 0, 0.442293) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.838118) , 
-3.42721, 0, 0, 0, 0.445519) , 
-1.73805, 1, 1, 0, 0.435583) , 
NN(
NN(
NN(
0, 
0, 
0.449658, 0, -1, -1, 0.480099) , 
NN(
0, 
0, 
0.912624, 0, -1, 1, 0.624023) , 
0.810201, 1, 3, 0, 0.525312) , 
NN(
0, 
0, 
0.820468, 0, -1, 1, 0.631353) , 
0.422896, 1, 1, 0, 0.561211) , 
0.437295, 1, 2, 0, 0.473208)    );
  // itree = 317
  fBoostWeights.push_back(0.806011);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.0599493, 1, -1, -1, 0.399642) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.221966) , 
NN(
0, 
0, 
0.794144, 0, -1, 1, 0.550948) , 
-0.385499, 1, 3, 0, 0.535503) , 
0.524276, 1, 0, 0, 0.475997) , 
NN(
NN(
0, 
0, 
-0.678866, 1, -1, 1, 0.509449) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.818243) , 
0.598781, 1, 3, 0, 0.531388) , 
-0.229219, 0, 0, 0, 0.499228) , 
NN(
0, 
0, 
1.56515, 0, -1, 1, 0.712307) , 
1.57938, 1, 3, 0, 0.503323)    );
  // itree = 318
  fBoostWeights.push_back(0.731319);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.0956126, 1, -1, -1, 0.299942) , 
NN(
0, 
0, 
0.0202797, 1, -1, -1, 0.462893) , 
0.570027, 1, 3, 0, 0.362828) , 
NN(
NN(
0, 
0, 
-0.163575, 1, -1, -1, 0.407199) , 
NN(
0, 
0, 
0.582373, 0, -1, 1, 0.505136) , 
0.0480801, 1, 3, 0, 0.451141) , 
0.541613, 0, 2, 0, 0.428521) , 
NN(
0, 
0, 
-1.53616, 1, -1, 1, 0.530522) , 
-1.16992, 0, 0, 0, 0.444835) , 
NN(
0, 
0, 
1.43564, 0, -1, 1, 0.608237) , 
1.27052, 1, 2, 0, 0.450702)    );
  // itree = 319
  fBoostWeights.push_back(0.780913);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.126029, 1, -1, -1, 0.443959) , 
NN(
0, 
0, 
0.370364, 0, -1, 1, 0.52026) , 
-0.0897679, 1, 3, 0, 0.490942)    );
  // itree = 320
  fBoostWeights.push_back(0.770407);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.0086825, 0, -1, -1, 0.376058) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.284488) , 
NN(
NN(
0, 
0, 
-1.22651, 0, -1, -1, 0.264268) , 
NN(
NN(
0, 
0, 
-0.971921, 0, -1, -1, 0.406526) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.742331) , 
-0.627424, 1, 2, 0, 0.522867) , 
-1.38865, 0, 0, 0, 0.46373) , 
-0.234156, 0, 2, 0, 0.411205) , 
NN(
0, 
0, 
-0.855775, 1, -1, 1, 0.528158) , 
-1.00942, 1, 0, 0, 0.457915) , 
-0.599248, 0, 0, 0, 0.409082) , 
NN(
0, 
0, 
-0.148403, 0, -1, 1, 0.565187) , 
0.997949, 1, 0, 0, 0.424369) , 
NN(
0, 
0, 
0.728929, 1, -1, 1, 0.50011) , 
0.32752, 1, 3, 0, 0.454861)    );
  // itree = 321
  fBoostWeights.push_back(0.771673);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.33173, 1, -1, -1, 0.44089) , 
NN(
0, 
0, 
0.728929, 1, -1, 1, 0.529158) , 
-0.0897679, 1, 3, 0, 0.494564)    );
  // itree = 322
  fBoostWeights.push_back(0.789425);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.3159, 1, -1, -1, 0.448891) , 
NN(
NN(
NN(
0, 
0, 
-0.0814337, 0, -1, -1, 0.350227) , 
NN(
NN(
0, 
0, 
-2.01538, 0, -1, -1, 0.395477) , 
NN(
NN(
NN(
0, 
0, 
0.431073, 0, -1, -1, 0.499098) , 
NN(
0, 
0, 
-0.804546, 0, -1, 1, 0.616767) , 
0.658531, 1, 3, 0, 0.531523) , 
NN(
0, 
0, 
-0.69042, 1, -1, 1, 0.648733) , 
-0.252424, 0, 0, 0, 0.55392) , 
-1.66871, 1, 1, 0, 0.536911) , 
-0.1547, 1, 3, 0, 0.495509) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.323619) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.0705551) , 
NN(
NN(
0, 
0, 
-0.727352, 0, -1, 1, 0.522326) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.677391) , 
-0.84147, 1, 3, 0, 0.588349) , 
-3.0717, 1, 0, 0, 0.567496) , 
-0.585175, 0, 2, 0, 0.499989) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.737957) , 
-0.0292777, 1, 0, 0, 0.580294) , 
-0.382926, 0, 2, 0, 0.514782) , 
0.948007, 0, 1, 0, 0.499905)    );
  // itree = 323
  fBoostWeights.push_back(0.882185);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.794134, 0, -1, -1, 0.376473) , 
NN(
NN(
0, 
0, 
-1.37347, 0, -1, -1, 0.40554) , 
NN(
NN(
0, 
0, 
-1.18482, 0, -1, -1, 0.410709) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.209753) , 
NN(
NN(
0, 
0, 
-0.502438, 0, -1, 1, 0.562787) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.792143) , 
-0.103247, 1, 3, 0, 0.618303) , 
-0.709229, 1, 1, 0, 0.587961) , 
0.899965, 0, 1, 0, 0.532684) , 
-0.845637, 1, 1, 0, 0.487857) , 
0.321034, 0, 2, 0, 0.453568) , 
NN(
NN(
0, 
0, 
0.153871, 0, -1, -1, 0.429108) , 
NN(
NN(
NN(
0, 
0, 
0.613678, 0, -1, -1, 0.481598) , 
NN(
0, 
0, 
-0.647177, 1, -1, 1, 0.851788) , 
0.874921, 1, 2, 0, 0.523942) , 
NN(
0, 
0, 
0.482411, 1, -1, 1, 0.864904) , 
1.04177, 1, 0, 0, 0.572977) , 
1.2778, 0, 0, 0, 0.520314) , 
0.22982, 1, 0, 0, 0.48365) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.790791) , 
2.4829, 1, 1, 0, 0.49014)    );
  // itree = 324
  fBoostWeights.push_back(0.712488);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.54393, 1, -1, -1, 0.274928) , 
NN(
0, 
0, 
0.92218, 0, -1, -1, 0.465023) , 
0.250448, 1, 3, 0, 0.350114) , 
NN(
NN(
0, 
0, 
-2.24287, 0, -1, -1, 0.371306) , 
NN(
0, 
0, 
1.53119, 0, -1, 1, 0.511466) , 
-0.507056, 1, 3, 0, 0.491115) , 
-0.970608, 1, 1, 0, 0.458349)    );
  // itree = 325
  fBoostWeights.push_back(0.731007);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.840112, 0, -1, -1, 0.337689) , 
NN(
0, 
0, 
0.456863, 0, -1, -1, 0.470667) , 
-0.324807, 1, 3, 0, 0.425739) , 
NN(
0, 
0, 
2.12776, 1, -1, 1, 0.552503) , 
0.32752, 1, 3, 0, 0.473068)    );
  // itree = 326
  fBoostWeights.push_back(0.643793);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.26525) , 
NN(
NN(
0, 
0, 
0.571219, 0, -1, -1, 0.388206) , 
NN(
0, 
0, 
-0.24012, 0, -1, -1, 0.452061) , 
-0.324807, 1, 3, 0, 0.431632) , 
2.09918, 0, 1, 0, 0.426463) , 
NN(
0, 
0, 
0.518811, 0, -1, 1, 0.586149) , 
0.32752, 1, 3, 0, 0.486048)    );
  // itree = 327
  fBoostWeights.push_back(0.662726);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.1399, 0, -1, -1, 0.391038) , 
NN(
0, 
0, 
-1.55778, 1, -1, 1, 0.511837) , 
-0.244935, 1, 3, 0, 0.478402) , 
NN(
0, 
0, 
0.388636, 0, -1, 1, 0.643352) , 
0.744808, 1, 3, 0, 0.4954)    );
  // itree = 328
  fBoostWeights.push_back(0.727672);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.98069, 1, -1, -1, 0.27484) , 
NN(
NN(
NN(
0, 
0, 
0.745092, 1, -1, -1, 0.425633) , 
NN(
NN(
0, 
0, 
-0.961616, 0, -1, -1, 0.397127) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
0, 
0, 
0.898772, 0, -1, 1, 0.557715) , 
-1.02825, 1, 3, 0, 0.553028) , 
-1.58713, 1, 0, 0, 0.522553) , 
0.269177, 0, 0, 0, 0.48164) , 
NN(
0, 
0, 
0.954464, 0, -1, 1, 0.565961) , 
0.639128, 1, 2, 0, 0.499096) , 
-1.34163, 1, 3, 0, 0.492433)    );
  // itree = 329
  fBoostWeights.push_back(0.772894);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.922467, 0, -1, -1, 0.395005) , 
NN(
NN(
0, 
0, 
-0.395345, 0, -1, -1, 0.408075) , 
NN(
NN(
NN(
0, 
0, 
0.61478, 1, -1, -1, 0.370731) , 
NN(
NN(
NN(
0, 
0, 
0.311512, 0, -1, -1, 0.418221) , 
NN(
0, 
0, 
0.393566, 1, -1, 1, 0.560071) , 
0.358087, 1, 3, 0, 0.503535) , 
NN(
0, 
0, 
0.46155, 1, -1, 1, 0.697408) , 
-0.542451, 0, 0, 0, 0.538662) , 
1.2403, 0, 1, 0, 0.50348) , 
NN(
NN(
0, 
0, 
-0.20343, 0, -1, 1, 0.586242) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.752522) , 
0.219195, 1, 3, 0, 0.620479) , 
0.128875, 0, 2, 0, 0.546894) , 
-0.308608, 1, 2, 0, 0.524912) , 
-0.812543, 1, 2, 0, 0.510961)    );
  // itree = 330
  fBoostWeights.push_back(0.776663);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.320615, 0, -1, -1, 0.359626) , 
NN(
NN(
NN(
0, 
0, 
-1.93438, 0, -1, -1, 0.439161) , 
NN(
NN(
0, 
0, 
-1.20686, 0, -1, -1, 0.298645) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.586135) , 
-0.556447, 1, 3, 0, 0.528082) , 
1.18219, 1, 1, 0, 0.456562) , 
NN(
0, 
0, 
0.51134, 0, -1, 1, 0.682969) , 
0.414244, 1, 3, 0, 0.477401) , 
1.34551, 0, 0, 0, 0.460763) , 
NN(
0, 
0, 
0.578, 1, -1, 1, 0.600536) , 
0.437295, 1, 2, 0, 0.50028)    );
  // itree = 331
  fBoostWeights.push_back(0.824789);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.694693, 0, -1, -1, 0.296935) , 
NN(
0, 
0, 
-1.35451, 0, -1, -1, 0.438794) , 
-0.349114, 1, 3, 0, 0.415263) , 
NN(
0, 
0, 
-0.950566, 1, -1, 1, 0.544334) , 
-0.818555, 0, 2, 0, 0.434017) , 
NN(
NN(
NN(
0, 
0, 
0.956484, 1, -1, -1, 0.4052) , 
NN(
NN(
0, 
0, 
0.359113, 0, -1, -1, 0.37129) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.585353) , 
NN(
0, 
0, 
0.773299, 1, -1, 1, 0.918324) , 
0.242942, 1, 3, 0, 0.70886) , 
0.453276, 1, 0, 0, 0.575298) , 
0.839279, 0, 0, 0, 0.49442) , 
NN(
0, 
0, 
1.93419, 0, -1, 1, 0.632613) , 
1.50975, 1, 0, 0, 0.534152) , 
0.22982, 1, 0, 0, 0.478957)    );
  // itree = 332
  fBoostWeights.push_back(0.834632);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.269464) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.484859, 1, -1, -1, 0.343941) , 
NN(
0, 
0, 
1.11076, 0, -1, 1, 0.5462) , 
0.583317, 1, 3, 0, 0.372616) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.600963) , 
1.56946, 1, 1, 0, 0.40551) , 
NN(
0, 
0, 
-1.66621, 1, -1, 1, 0.502527) , 
0.0628731, 0, 1, 0, 0.446889) , 
-1.48156, 1, 0, 0, 0.431348) , 
NN(
0, 
0, 
-2.31741, 1, -1, 1, 0.503771) , 
-0.272366, 0, 2, 0, 0.45235) , 
NN(
0, 
0, 
1.70255, 0, -1, 1, 0.923909) , 
1.57938, 1, 3, 0, 0.454789) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.725226) , 
2.30013, 1, 1, 0, 0.46212) , 
NN(
0, 
0, 
1.86808, 1, -1, 1, 0.641969) , 
1.86861, 1, 0, 0, 0.480188)    );
  // itree = 333
  fBoostWeights.push_back(0.861472);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.110478) , 
NN(
0, 
0, 
0.631091, 0, -1, -1, 0.410249) , 
-0.0956387, 1, 3, 0, 0.341093) , 
NN(
0, 
0, 
0.94866, 0, -1, -1, 0.468099) , 
0.650925, 0, 0, 0, 0.429325) , 
NN(
NN(
NN(
0, 
0, 
-0.147663, 0, -1, -1, 0.32898) , 
NN(
0, 
0, 
-0.330511, 0, -1, 1, 0.526999) , 
-0.387417, 1, 3, 0, 0.511378) , 
NN(
0, 
0, 
-1.16443, 1, -1, 1, 0.610803) , 
-0.734765, 0, 0, 0, 0.538022) , 
0.564284, 0, 1, 0, 0.503141)    );
  // itree = 334
  fBoostWeights.push_back(0.74295);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.657086, 0, -1, -1, 0.338057) , 
NN(
0, 
0, 
1.29334, 0, -1, -1, 0.469143) , 
-0.334227, 1, 3, 0, 0.449185) , 
NN(
0, 
0, 
1.26885, 1, -1, 1, 0.628814) , 
-1.95523, 0, 0, 0, 0.460451) , 
NN(
NN(
NN(
0, 
0, 
-0.198471, 1, -1, -1, 0.448306) , 
NN(
0, 
0, 
0.92218, 0, -1, 1, 0.673467) , 
0.744944, 1, 3, 0, 0.490735) , 
NN(
0, 
0, 
-0.640795, 1, -1, 1, 0.600748) , 
-0.068279, 0, 3, 0, 0.53102) , 
0.180561, 0, 1, 0, 0.49422)    );
  // itree = 335
  fBoostWeights.push_back(0.706053);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.25568) , 
NN(
NN(
0, 
0, 
0.929708, 1, -1, -1, 0.420569) , 
NN(
0, 
0, 
0.817199, 0, -1, 1, 0.5378) , 
0.232448, 1, 3, 0, 0.475611) , 
1.78488, 0, 1, 0, 0.461562) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.310059) , 
NN(
NN(
NN(
0, 
0, 
-0.855836, 1, -1, -1, 0.417021) , 
NN(
0, 
0, 
-0.851982, 1, -1, 1, 0.601687) , 
-0.978319, 1, 3, 0, 0.518683) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.868893) , 
2.14785, 1, 1, 0, 0.542058) , 
-0.264901, 0, 0, 0, 0.519323) , 
-0.240544, 0, 2, 0, 0.483859) , 
NN(
0, 
0, 
0.283856, 0, -1, 1, 0.587575) , 
-0.40615, 1, 3, 0, 0.557628) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.777449) , 
0.907668, 1, 3, 0, 0.568523) , 
0.22982, 0, 0, 0, 0.521165)    );
  // itree = 336
  fBoostWeights.push_back(0.715341);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
1.57734, 0, -1, -1, 0.475898) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.30515) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.388422) , 
NN(
NN(
0, 
0, 
1.14875, 0, -1, -1, 0.455369) , 
NN(
0, 
0, 
-1.08808, 0, -1, 1, 0.659351) , 
-0.638067, 1, 3, 0, 0.547199) , 
0.163962, 0, 0, 0, 0.497679) , 
NN(
0, 
0, 
-1.38501, 0, -1, 1, 0.741135) , 
1.36771, 1, 1, 0, 0.517522) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.70374) , 
-0.190661, 1, 2, 0, 0.550872) , 
-1.48786, 1, 1, 0, 0.519454) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.717896) , 
0.897595, 1, 0, 0, 0.549072) , 
-0.0623079, 0, 2, 0, 0.508284) , 
NN(
0, 
0, 
0.372366, 0, -1, 1, 0.594376) , 
0.744808, 1, 3, 0, 0.517185) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.758253) , 
2.4829, 1, 1, 0, 0.52436)    );
  // itree = 337
  fBoostWeights.push_back(0.760446);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.241937) , 
NN(
0, 
0, 
1.64047, 0, -1, 1, 0.571291) , 
0.830708, 1, 3, 0, 0.398231) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.630824, 0, -1, -1, 0.404986) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.750057) , 
-0.391099, 0, 3, 0, 0.43088) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.637844) , 
1.55843, 1, 0, 0, 0.487397) , 
NN(
NN(
0, 
0, 
-2.24287, 0, -1, -1, 0.448647) , 
NN(
0, 
0, 
-0.220931, 1, -1, 1, 0.598107) , 
-0.435188, 1, 3, 0, 0.558695) , 
0.390969, 0, 0, 0, 0.528566) , 
0.786817, 0, 2, 0, 0.509693) , 
NN(
NN(
0, 
0, 
-0.0879588, 0, -1, 1, 0.545388) , 
NN(
0, 
0, 
1.08403, 0, -1, 1, 0.822326) , 
0.584584, 1, 3, 0, 0.594587) , 
-0.970608, 0, 1, 0, 0.525377)    );
  // itree = 338
  fBoostWeights.push_back(0.741733);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.245282, 1, -1, -1, 0.407183) , 
NN(
0, 
0, 
1.29024, 0, -1, 1, 0.616413) , 
1.02631, 1, 3, 0, 0.429643) , 
NN(
0, 
0, 
0.424317, 0, -1, 1, 0.657787) , 
-0.387191, 0, 2, 0, 0.456903) , 
NN(
NN(
0, 
0, 
1.82312, 1, -1, -1, 0.467073) , 
NN(
NN(
0, 
0, 
-2.05678, 0, -1, -1, 0.426494) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.40384) , 
NN(
NN(
0, 
0, 
-2.27826, 1, -1, -1, 0.484628) , 
NN(
0, 
0, 
-0.035542, 0, -1, 1, 0.693056) , 
-0.924435, 1, 3, 0, 0.646723) , 
-0.140791, 0, 0, 0, 0.600093) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.749653) , 
0.384901, 1, 2, 0, 0.642024) , 
-1.50186, 1, 1, 0, 0.594767) , 
0.235983, 0, 1, 0, 0.540365) , 
0.22982, 0, 0, 0, 0.503579)    );
  // itree = 339
  fBoostWeights.push_back(0.774344);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.291043, 1, -1, -1, 0.43066) , 
NN(
0, 
0, 
0.837822, 0, -1, 1, 0.551158) , 
0.935649, 1, 2, 0, 0.445189) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.819806) , 
-0.718801, 0, 3, 0, 0.451718) , 
NN(
NN(
NN(
0, 
0, 
-3.16903, 1, -1, -1, 0.338308) , 
NN(
0, 
0, 
-0.954304, 0, -1, 1, 0.514123) , 
-1.26462, 1, 3, 0, 0.473423) , 
NN(
NN(
0, 
0, 
0.1984, 0, -1, -1, 0.486337) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.608104) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.801066) , 
-0.572701, 1, 3, 0, 0.729936) , 
0.564284, 0, 1, 0, 0.65168) , 
-0.558422, 1, 0, 0, 0.552669) , 
-0.39593, 0, 2, 0, 0.473032)    );
  // itree = 340
  fBoostWeights.push_back(0.765454);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
1.35633, 0, -1, -1, 0.409207) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.30884, 0, -1, -1, 0.231373) , 
NN(
NN(
0, 
0, 
-1.64416, 1, -1, -1, 0.39932) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.591452) , 
-0.427388, 1, 3, 0, 0.494221) , 
-0.630194, 0, 0, 0, 0.394793) , 
NN(
0, 
0, 
0.404704, 1, -1, 1, 0.515254) , 
-0.0793924, 1, 0, 0, 0.464571) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.739481) , 
1.81954, 1, 1, 0, 0.479226) , 
0.32752, 0, 3, 0, 0.455008) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.688455) , 
2.17136, 1, 1, 0, 0.46741) , 
NN(
NN(
0, 
0, 
-0.268374, 0, -1, -1, 0.442434) , 
NN(
NN(
0, 
0, 
-1.10044, 1, -1, -1, 0.471991) , 
NN(
0, 
0, 
0.669186, 0, -1, 1, 0.67708) , 
-0.257937, 1, 3, 0, 0.631193) , 
-1.48517, 1, 1, 0, 0.566626) , 
-0.586885, 0, 1, 0, 0.496738)    );
  // itree = 341
  fBoostWeights.push_back(0.790823);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.304004) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.155317) , 
NN(
0, 
0, 
2.38591, 0, -1, -1, 0.458698) , 
0.36034, 1, 2, 0, 0.337666) , 
NN(
NN(
0, 
0, 
1.531, 1, -1, -1, 0.413464) , 
NN(
0, 
0, 
0.295811, 0, -1, 1, 0.528386) , 
0.0919142, 1, 3, 0, 0.455326) , 
1.30509, 0, 0, 0, 0.433022) , 
NN(
0, 
0, 
0.219214, 1, -1, -1, 0.491492) , 
0.280938, 0, 1, 0, 0.454577) , 
-0.475955, 1, 1, 0, 0.446523) , 
NN(
NN(
0, 
0, 
0.89674, 0, -1, -1, 0.417333) , 
NN(
NN(
NN(
0, 
0, 
-0.505622, 0, -1, -1, 0.26772) , 
NN(
NN(
0, 
0, 
-1.0929, 1, -1, -1, 0.454861) , 
NN(
0, 
0, 
-1.01727, 1, -1, 1, 0.710696) , 
0.154003, 1, 2, 0, 0.570868) , 
-0.885591, 0, 1, 0, 0.517624) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.713049) , 
-0.719314, 1, 1, 0, 0.552232) , 
-1.64816, 1, 1, 0, 0.510581) , 
-0.586885, 0, 1, 0, 0.465216)    );
  // itree = 342
  fBoostWeights.push_back(0.818236);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.273825) , 
NN(
NN(
NN(
0, 
0, 
2.12883, 1, -1, -1, 0.396012) , 
NN(
NN(
0, 
0, 
-0.425136, 0, -1, -1, 0.380184) , 
NN(
NN(
0, 
0, 
0.993629, 1, -1, -1, 0.467844) , 
NN(
0, 
0, 
-0.297666, 1, -1, 1, 0.587403) , 
-0.188156, 0, 3, 0, 0.505143) , 
-0.588138, 1, 3, 0, 0.484511) , 
1.32235, 0, 0, 0, 0.467444) , 
NN(
0, 
0, 
0.918984, 0, -1, 1, 0.565774) , 
-1.07776, 0, 1, 0, 0.481635) , 
-2.12178, 1, 1, 0, 0.473592)    );
  // itree = 343
  fBoostWeights.push_back(0.682454);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.319837, 1, -1, -1, 0.345368) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.228314, 1, -1, -1, 0.402043) , 
NN(
0, 
0, 
0.744332, 0, -1, 1, 0.513133) , 
0.864903, 1, 3, 0, 0.417994) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.578375) , 
-0.443673, 0, 2, 0, 0.428811) , 
NN(
0, 
0, 
-0.137277, 1, -1, 1, 0.552232) , 
-0.771783, 0, 0, 0, 0.446874) , 
-0.384936, 1, 3, 0, 0.433685) , 
NN(
0, 
0, 
-1.35598, 1, -1, 1, 0.583997) , 
-0.996527, 0, 2, 0, 0.445947) , 
NN(
0, 
0, 
2.01805, 0, -1, 1, 0.56257) , 
1.33173, 1, 1, 0, 0.464682)    );
  // itree = 344
  fBoostWeights.push_back(0.815873);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.906776, 0, -1, -1, 0.280053) , 
NN(
0, 
0, 
0.404534, 0, -1, -1, 0.414346) , 
-0.165693, 1, 3, 0, 0.374288) , 
NN(
0, 
0, 
-1.86816, 1, -1, -1, 0.497069) , 
0.793271, 1, 3, 0, 0.392012) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.16585) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.244071) , 
NN(
0, 
0, 
1.53968, 1, -1, 1, 0.65456) , 
-0.532745, 1, 3, 0, 0.594846) , 
1.88729, 0, 0, 0, 0.536846) , 
1.04268, 1, 1, 0, 0.420997) , 
NN(
NN(
0, 
0, 
-0.749185, 0, -1, -1, 0.478195) , 
NN(
0, 
0, 
-0.111765, 0, -1, 1, 0.60826) , 
0.250391, 1, 3, 0, 0.509917) , 
-0.316443, 0, 0, 0, 0.455427)    );
  // itree = 345
  fBoostWeights.push_back(0.803522);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.962582, 1, -1, -1, 0.329095) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.77166, 0, -1, -1, 0.199906) , 
NN(
0, 
0, 
0.236726, 0, -1, -1, 0.407341) , 
-0.588591, 1, 3, 0, 0.375896) , 
NN(
0, 
0, 
-1.78538, 1, -1, 1, 0.554535) , 
-1.43743, 0, 0, 0, 0.408428) , 
NN(
0, 
0, 
-0.225099, 0, -1, -1, 0.495078) , 
0.0287375, 1, 2, 0, 0.454964) , 
0.786817, 0, 2, 0, 0.434635) , 
NN(
NN(
0, 
0, 
-0.351063, 0, -1, -1, 0.492531) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.789949) , 
0.429525, 1, 3, 0, 0.548259) , 
-0.255346, 0, 1, 0, 0.450193) , 
NN(
NN(
NN(
0, 
0, 
-0.186496, 1, -1, -1, 0.4379) , 
NN(
0, 
0, 
0.000163969, 1, -1, 1, 0.614495) , 
-0.554339, 0, 0, 0, 0.514634) , 
NN(
0, 
0, 
1.55716, 0, -1, 1, 0.758799) , 
1.21582, 1, 2, 0, 0.528791) , 
-0.586885, 0, 1, 0, 0.473532)    );
  // itree = 346
  fBoostWeights.push_back(0.733357);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.382704, 0, -1, -1, 0.330375) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.43071, 0, -1, -1, 0.443296) , 
NN(
0, 
0, 
0.837822, 0, -1, 1, 0.55063) , 
0.777398, 1, 3, 0, 0.462849) , 
NN(
0, 
0, 
1.00645, 1, -1, 1, 0.567168) , 
0.906757, 1, 1, 0, 0.490354) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.177684) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.419878) , 
NN(
NN(
0, 
0, 
-1.16012, 0, -1, -1, 0.481981) , 
NN(
NN(
0, 
0, 
-1.7228, 0, -1, -1, 0.459006) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.563653) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.930888) , 
-0.78179, 1, 3, 0, 0.788974) , 
-1.17606, 1, 0, 0, 0.656107) , 
-0.650279, 0, 2, 0, 0.565527) , 
0.287254, 0, 0, 0, 0.518997) , 
1.88407, 0, 1, 0, 0.501568) , 
NN(
NN(
NN(
0, 
0, 
-0.0368002, 1, -1, -1, 0.398201) , 
NN(
0, 
0, 
0.177242, 1, -1, 1, 0.675368) , 
-0.121819, 1, 3, 0, 0.559923) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.794717) , 
-0.194501, 0, 2, 0, 0.616724) , 
-0.285454, 1, 2, 0, 0.555628) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.727887) , 
-1.35433, 0, 1, 0, 0.580011) , 
0.111517, 0, 2, 0, 0.531755) , 
-1.34163, 1, 3, 0, 0.525425)    );
  // itree = 347
  fBoostWeights.push_back(0.787983);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.3159, 1, -1, -1, 0.424461) , 
NN(
0, 
0, 
1.38915, 0, -1, 1, 0.651548) , 
0.46084, 1, 3, 0, 0.461147) , 
NN(
NN(
0, 
0, 
-1.00848, 0, -1, -1, 0.352486) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.120271) , 
NN(
NN(
0, 
0, 
1.46887, 1, -1, -1, 0.482603) , 
NN(
0, 
0, 
0.29456, 0, -1, 1, 0.618422) , 
-0.123213, 0, 3, 0, 0.520882) , 
-0.889198, 1, 3, 0, 0.516114) , 
NN(
NN(
0, 
0, 
-1.72756, 0, -1, -1, 0.3791) , 
NN(
0, 
0, 
-0.80844, 0, -1, 1, 0.647981) , 
-0.984229, 1, 2, 0, 0.613495) , 
-0.604694, 0, 0, 0, 0.542844) , 
-2.19768, 1, 0, 0, 0.534918) , 
0.948007, 0, 1, 0, 0.516378)    );
  // itree = 348
  fBoostWeights.push_back(0.807328);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
1.10909, 0, -1, -1, 0.271374) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.634984) , 
0.367584, 1, 3, 0, 0.330522) , 
NN(
0, 
0, 
1.50471, 0, -1, -1, 0.477509) , 
1.3159, 1, 1, 0, 0.429029) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.248861, 0, -1, -1, 0.470357) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.414403) , 
NN(
0, 
0, 
1.1252, 0, -1, 1, 0.615306) , 
0.0459205, 1, 3, 0, 0.558914) , 
0.506907, 1, 0, 0, 0.504606) , 
NN(
NN(
0, 
0, 
-0.845779, 0, -1, -1, 0.456444) , 
NN(
0, 
0, 
-0.860786, 1, -1, 1, 0.705869) , 
-0.710862, 1, 3, 0, 0.59543) , 
-0.382926, 0, 2, 0, 0.525244) , 
NN(
0, 
0, 
0.931082, 0, -1, 1, 0.67491) , 
0.585642, 1, 1, 0, 0.541842) , 
0.948007, 0, 1, 0, 0.513605)    );
  // itree = 349
  fBoostWeights.push_back(0.806644);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.177466) , 
NN(
0, 
0, 
-0.242748, 0, -1, -1, 0.477831) , 
0.371872, 0, 3, 0, 0.403749) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.290343) , 
NN(
NN(
0, 
0, 
-0.686477, 1, -1, -1, 0.394861) , 
NN(
0, 
0, 
-1.1779, 1, -1, 1, 0.56434) , 
-0.307274, 1, 2, 0, 0.499444) , 
0.68971, 0, 3, 0, 0.483878) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.720765) , 
0.130601, 1, 1, 0, 0.503795) , 
0.235983, 0, 1, 0, 0.45892) , 
NN(
NN(
0, 
0, 
0.501326, 0, -1, -1, 0.473711) , 
NN(
NN(
NN(
0, 
0, 
0.927732, 1, -1, -1, 0.459012) , 
NN(
0, 
0, 
1.2778, 0, -1, 1, 0.624039) , 
0.0735737, 1, 3, 0, 0.570783) , 
NN(
0, 
0, 
0.635756, 0, -1, 1, 0.732942) , 
0.445154, 1, 1, 0, 0.612237) , 
1.04268, 0, 1, 0, 0.582643) , 
0.22982, 1, 0, 0, 0.510552)    );
  // itree = 350
  fBoostWeights.push_back(0.802691);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-2.42372, 1, -1, -1, 0.408616) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.618004) , 
-0.191793, 1, 3, 0, 0.432809) , 
NN(
NN(
0, 
0, 
1.84353, 1, -1, -1, 0.453108) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.39901) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.627957, 0, -1, -1, 0.424017) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.216421) , 
NN(
0, 
0, 
0.660024, 0, -1, 1, 0.559741) , 
0.41486, 1, 3, 0, 0.379572) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.664169) , 
-1.09902, 0, 1, 0, 0.448732) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.71472) , 
-0.614827, 0, 0, 0, 0.507382) , 
NN(
0, 
0, 
-0.072503, 0, -1, 1, 0.705746) , 
-0.169497, 1, 1, 0, 0.56254) , 
0.228666, 0, 1, 0, 0.521276) , 
NN(
0, 
0, 
0.358239, 1, -1, 1, 0.672775) , 
0.614222, 1, 1, 0, 0.545121) , 
NN(
0, 
0, 
1.44128, 0, -1, 1, 0.678226) , 
-1.5408, 0, 1, 0, 0.560987) , 
NN(
0, 
0, 
-0.130968, 0, -1, 1, 0.69364) , 
-0.043491, 0, 2, 0, 0.589597) , 
-0.302388, 1, 2, 0, 0.579984) , 
1.2403, 0, 1, 0, 0.55308) , 
-0.39593, 1, 2, 0, 0.526905)    );
  // itree = 351
  fBoostWeights.push_back(0.871134);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.379434, 0, -1, -1, 0.134664) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.154296) , 
NN(
NN(
0, 
0, 
-0.919304, 0, -1, -1, 0.361778) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.599943) , 
-0.618708, 1, 3, 0, 0.479361) , 
-0.615021, 0, 2, 0, 0.344872) , 
-1.05433, 1, 2, 0, 0.282367) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.587839) , 
-1.7826, 0, 2, 0, 0.301153) , 
NN(
0, 
0, 
-2.01441, 1, -1, -1, 0.46947) , 
-1.47838, 0, 0, 0, 0.350949) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.6314) , 
0.760086, 1, 0, 0, 0.369577) , 
NN(
NN(
NN(
0, 
0, 
0.217308, 0, -1, -1, 0.476354) , 
NN(
0, 
0, 
1.33866, 0, -1, 1, 0.709386) , 
0.90183, 1, 3, 0, 0.484143) , 
NN(
0, 
0, 
-0.674739, 1, -1, 1, 0.609148) , 
0.935236, 1, 2, 0, 0.499908) , 
-0.39593, 1, 2, 0, 0.4713)    );
  // itree = 352
  fBoostWeights.push_back(0.709339);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.970608, 0, -1, -1, 0.392829) , 
NN(
NN(
0, 
0, 
-0.0864287, 0, -1, -1, 0.314882) , 
NN(
NN(
NN(
0, 
0, 
0.109168, 0, -1, -1, 0.473914) , 
NN(
0, 
0, 
2.44609, 0, -1, 1, 0.587071) , 
0.648278, 1, 3, 0, 0.498611) , 
NN(
0, 
0, 
0.528788, 1, -1, 1, 0.622068) , 
-0.170161, 0, 3, 0, 0.523049) , 
-0.480174, 1, 3, 0, 0.516082) , 
-0.39593, 1, 2, 0, 0.489475)    );
  // itree = 353
  fBoostWeights.push_back(0.732062);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.850484, 0, -1, -1, 0.412288) , 
NN(
0, 
0, 
-0.839528, 1, -1, 1, 0.521825) , 
-0.769235, 0, 3, 0, 0.444852) , 
NN(
0, 
0, 
0.266571, 0, -1, 1, 0.545359) , 
-0.189627, 1, 3, 0, 0.510434) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.854002) , 
-3.04776, 0, 0, 0, 0.514451)    );
  // itree = 354
  fBoostWeights.push_back(0.697775);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.840919, 0, -1, -1, 0.419543) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.890694, 1, -1, -1, 0.425317) , 
NN(
0, 
0, 
1.56515, 0, -1, 1, 0.681177) , 
1.3691, 1, 3, 0, 0.445204) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.595574) , 
0.363583, 0, 3, 0, 0.476835) , 
NN(
NN(
0, 
0, 
0.955971, 0, -1, -1, 0.48785) , 
NN(
0, 
0, 
0.824704, 1, -1, 1, 0.629664) , 
-0.238903, 1, 3, 0, 0.570798) , 
0.280593, 0, 3, 0, 0.533297) , 
-0.924344, 1, 3, 0, 0.526452)    );
  // itree = 355
  fBoostWeights.push_back(0.82039);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.16162, 1, -1, -1, 0.348892) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.636119, 1, -1, -1, 0.257781) , 
NN(
NN(
NN(
0, 
0, 
0.589921, 1, -1, -1, 0.435042) , 
NN(
0, 
0, 
-0.233166, 1, -1, 1, 0.521172) , 
-0.133497, 0, 3, 0, 0.471388) , 
NN(
0, 
0, 
1.02679, 1, -1, 1, 0.608293) , 
0.932583, 1, 0, 0, 0.481059) , 
1.15214, 0, 0, 0, 0.468804) , 
NN(
0, 
0, 
1.83168, 0, -1, 1, 0.582857) , 
1.39498, 1, 0, 0, 0.488889) , 
NN(
0, 
0, 
-0.394415, 0, -1, 1, 0.642892) , 
-1.80339, 0, 0, 0, 0.497035) , 
-0.924344, 1, 3, 0, 0.488492)    );
  // itree = 356
  fBoostWeights.push_back(0.832206);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-1.92788, 0, -1, -1, 0.342051) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.763543, 0, -1, -1, 0.253605) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.266872) , 
NN(
NN(
0, 
0, 
0.235588, 0, -1, -1, 0.217255) , 
NN(
NN(
0, 
0, 
-0.957772, 0, -1, -1, 0.143574) , 
NN(
0, 
0, 
-0.472329, 0, -1, 1, 0.52998) , 
-0.789384, 1, 3, 0, 0.505989) , 
-1.01846, 1, 2, 0, 0.476424) , 
0.381748, 0, 3, 0, 0.435649) , 
-0.232948, 0, 0, 0, 0.405984) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.668184) , 
0.87719, 1, 3, 0, 0.420362) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.666421) , 
-1.48196, 0, 0, 0, 0.436595) , 
-1.60488, 1, 0, 0, 0.417873) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.84481) , 
-3.46687, 0, 0, 0, 0.422643) , 
NN(
NN(
NN(
0, 
0, 
0.103055, 1, -1, -1, 0.37255) , 
NN(
0, 
0, 
1.06445, 1, -1, 1, 0.534886) , 
0.12444, 1, 2, 0, 0.456431) , 
NN(
0, 
0, 
0.45233, 1, -1, 1, 0.728334) , 
-0.732954, 0, 1, 0, 0.514125) , 
0.0310842, 1, 0, 0, 0.462162) , 
NN(
0, 
0, 
2.48071, 0, -1, 1, 0.609788) , 
1.32235, 1, 0, 0, 0.486517)    );
  // itree = 357
  fBoostWeights.push_back(0.795161);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
1.7329, 1, -1, -1, 0.394976) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.276762) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.232819) , 
NN(
NN(
NN(
0, 
0, 
0.01655, 1, -1, -1, 0.384788) , 
NN(
0, 
0, 
0.300733, 0, -1, 1, 0.509733) , 
-0.107805, 0, 3, 0, 0.465188) , 
NN(
0, 
0, 
0.725124, 0, -1, 1, 0.563237) , 
0.34585, 1, 3, 0, 0.485003) , 
0.878684, 0, 2, 0, 0.471808) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.817294) , 
1.19505, 1, 2, 0, 0.476827) , 
1.00615, 0, 0, 0, 0.465162) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.70349) , 
1.16645, 1, 0, 0, 0.47033) , 
1.18219, 0, 1, 0, 0.456015) , 
NN(
0, 
0, 
2.12629, 1, -1, 1, 0.545145) , 
1.32235, 1, 0, 0, 0.470457)    );
  // itree = 358
  fBoostWeights.push_back(0.781183);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.17465, 0, -1, -1, 0.427869) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.298718) , 
NN(
NN(
NN(
0, 
0, 
0.749565, 0, -1, -1, 0.273046) , 
NN(
NN(
0, 
0, 
0.243066, 0, -1, -1, 0.482574) , 
NN(
0, 
0, 
1.83995, 0, -1, 1, 0.766115) , 
1.20235, 1, 3, 0, 0.510615) , 
-0.048648, 0, 1, 0, 0.457588) , 
NN(
0, 
0, 
-0.454963, 1, -1, 1, 0.570373) , 
0.239673, 1, 1, 0, 0.515979) , 
-1.17833, 1, 0, 0, 0.500869) , 
NN(
0, 
0, 
-1.11622, 0, -1, 1, 0.611465) , 
-0.0773185, 0, 2, 0, 0.528665) , 
-0.507056, 1, 3, 0, 0.513589)    );
  // itree = 359
  fBoostWeights.push_back(0.814288);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.038272, 1, -1, -1, 0.414602) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.329683) , 
NN(
NN(
0, 
0, 
0.37186, 1, -1, -1, 0.498259) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.568168) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.872759) , 
0.0616853, 1, 3, 0, 0.677346) , 
-1.0983, 0, 1, 0, 0.544324) , 
-1.7063, 1, 1, 0, 0.509062) , 
-0.119683, 0, 1, 0, 0.475085) , 
NN(
NN(
0, 
0, 
1.95444, 1, -1, -1, 0.336345) , 
NN(
NN(
0, 
0, 
1.2155, 1, -1, 1, 0.529658) , 
NN(
0, 
0, 
1.20627, 0, -1, 1, 0.683856) , 
-0.179314, 1, 3, 0, 0.619586) , 
1.70397, 0, 1, 0, 0.56851) , 
0.418739, 1, 1, 0, 0.507745) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.730122) , 
2.4829, 1, 1, 0, 0.51497) , 
NN(
0, 
0, 
0.716366, 1, -1, 1, 0.652261) , 
0.853908, 1, 2, 0, 0.528459)    );
  // itree = 360
  fBoostWeights.push_back(0.782987);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.52018, 0, -1, -1, 0.319448) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.181826) , 
NN(
NN(
NN(
0, 
0, 
-0.349649, 0, -1, -1, 0.380744) , 
NN(
0, 
0, 
0.204514, 1, -1, 1, 0.545348) , 
-0.229532, 1, 3, 0, 0.473786) , 
NN(
0, 
0, 
-1.01661, 0, -1, 1, 0.571151) , 
-0.892541, 0, 2, 0, 0.50237) , 
2.4829, 0, 1, 0, 0.491968) , 
0.111225, 0, 3, 0, 0.462198) , 
NN(
NN(
NN(
0, 
0, 
-0.263976, 1, -1, -1, 0.451578) , 
NN(
NN(
0, 
0, 
2.16476, 1, -1, -1, 0.376504) , 
NN(
NN(
0, 
0, 
0.966809, 1, -1, 1, 0.540702) , 
NN(
0, 
0, 
1.05192, 0, 0, 1, 1) , 
1.34527, 1, 3, 0, 0.552012) , 
1.67031, 0, 2, 0, 0.541463) , 
0.311349, 1, 3, 0, 0.507277) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.714187) , 
1.90738, 1, 1, 0, 0.523487) , 
0.0206825, 1, 2, 0, 0.496806)    );
  // itree = 361
  fBoostWeights.push_back(0.795933);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.543879, 0, -1, -1, 0.256824) , 
NN(
0, 
0, 
0.324885, 0, -1, -1, 0.419002) , 
-0.148248, 1, 3, 0, 0.358639) , 
NN(
0, 
0, 
-0.334525, 1, -1, -1, 0.478616) , 
1.04851, 1, 1, 0, 0.405831) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.887789) , 
1.01745, 1, 2, 0, 0.415022) , 
NN(
0, 
0, 
0.908604, 0, -1, 1, 0.589191) , 
-1.78997, 0, 0, 0, 0.436102) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.333675, 0, -1, -1, 0.428967) , 
NN(
0, 
0, 
-1.02506, 1, -1, 1, 0.580033) , 
0.0458088, 1, 0, 0, 0.478245) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.623977) , 
-1.9501, 0, 1, 0, 0.501472) , 
NN(
0, 
0, 
-0.441173, 1, -1, 1, 0.675326) , 
-0.232039, 1, 1, 0, 0.523368) , 
0.0642531, 0, 1, 0, 0.480125) , 
NN(
0, 
0, 
1.28872, 0, -1, 1, 0.549749) , 
0.776084, 1, 0, 0, 0.502655)    );
  // itree = 362
  fBoostWeights.push_back(0.830024);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.1414, 0, -1, -1, 0.238787) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.162996) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.131351) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
NN(
0, 
0, 
-0.796978, 0, -1, -1, 0.440321) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.579515) , 
-0.261201, 1, 3, 0, 0.466225) , 
-1.99437, 1, 3, 0, 0.443108) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.739458) , 
-2.26157, 0, 2, 0, 0.460447) , 
2.27403, 0, 1, 0, 0.438722) , 
-0.496733, 0, 2, 0, 0.403985) , 
NN(
0, 
0, 
-0.372038, 0, -1, 1, 0.581573) , 
-0.372003, 1, 2, 0, 0.478255) , 
0.111225, 0, 3, 0, 0.435912) , 
NN(
NN(
NN(
0, 
0, 
0.676289, 0, -1, -1, 0.457529) , 
NN(
0, 
0, 
1.16647, 0, -1, 1, 0.6425) , 
0.598726, 1, 3, 0, 0.493999) , 
NN(
NN(
0, 
0, 
2.68987, 1, -1, -1, 0.397883) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.314215) , 
NN(
0, 
0, 
1.67376, 0, -1, 1, 0.743234) , 
0.778943, 1, 3, 0, 0.466734) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.83764) , 
0.85071, 0, 0, 0, 0.564558) , 
NN(
0, 
0, 
0.373313, 1, -1, 1, 0.700401) , 
0.583482, 0, 2, 0, 0.65368) , 
2.37474, 0, 0, 0, 0.620169) , 
0.491022, 1, 0, 0, 0.552248) , 
0.0206825, 1, 2, 0, 0.500559)    );
  // itree = 363
  fBoostWeights.push_back(0.842205);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.0688777) , 
NN(
NN(
0, 
0, 
-1.10556, 0, -1, -1, 0.322809) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.534603) , 
-0.0187377, 1, 3, 0, 0.370664) , 
-1.61082, 1, 0, 0, 0.324921) , 
NN(
0, 
0, 
-0.592842, 1, -1, 1, 0.524371) , 
-1.77298, 0, 0, 0, 0.399542) , 
NN(
NN(
NN(
0, 
0, 
-1.11211, 0, -1, -1, 0.370625) , 
NN(
NN(
NN(
0, 
0, 
0.977094, 1, -1, -1, 0.38219) , 
NN(
0, 
0, 
2.44129, 0, -1, 1, 0.533663) , 
0.239836, 1, 2, 0, 0.466766) , 
NN(
0, 
0, 
0.261748, 0, -1, 1, 0.560753) , 
0.238911, 0, 0, 0, 0.494592) , 
-0.387191, 1, 2, 0, 0.481139) , 
NN(
0, 
0, 
-0.618987, 1, -1, 1, 0.593132) , 
-0.43138, 0, 0, 0, 0.497051) , 
-0.862707, 1, 0, 0, 0.474503)    );
  // itree = 364
  fBoostWeights.push_back(0.768093);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.938249, 1, -1, -1, 0.33481) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.277682) , 
NN(
NN(
0, 
0, 
-0.171806, 1, -1, -1, 0.39284) , 
NN(
0, 
0, 
-0.295507, 1, -1, 1, 0.589914) , 
-0.384743, 1, 3, 0, 0.469826) , 
-0.198097, 0, 3, 0, 0.419806) , 
NN(
0, 
0, 
-2.19331, 1, -1, 1, 0.548806) , 
-1.87693, 0, 0, 0, 0.439774) , 
NN(
0, 
0, 
-0.861085, 1, -1, 1, 0.526076) , 
-0.122299, 1, 3, 0, 0.479677) , 
0.399289, 0, 2, 0, 0.443796) , 
NN(
0, 
0, 
0.240009, 1, -1, 1, 0.567439) , 
0.853908, 1, 2, 0, 0.455728)    );
  // itree = 365
  fBoostWeights.push_back(0.667026);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.167985, 0, -1, -1, 0.40406) , 
NN(
NN(
0, 
0, 
-2.13946, 1, -1, -1, 0.363843) , 
NN(
NN(
0, 
0, 
-1.1852, 0, -1, -1, 0.316176) , 
NN(
NN(
0, 
0, 
-0.67693, 0, -1, 1, 0.576256) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.758872) , 
-0.302957, 1, 3, 0, 0.635174) , 
-2.05433, 1, 0, 0, 0.589179) , 
0.564284, 0, 1, 0, 0.506154) , 
-0.312098, 0, 2, 0, 0.444574) , 
NN(
0, 
0, 
0.136243, 0, -1, 1, 0.535843) , 
0.195361, 1, 3, 0, 0.478114) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.881503) , 
-3.22562, 0, 0, 0, 0.48063) , 
NN(
0, 
0, 
1.60205, 0, -1, 1, 0.618569) , 
0.853908, 1, 2, 0, 0.494001)    );
  // itree = 366
  fBoostWeights.push_back(0.746579);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.563733, 0, -1, -1, 0.409968) , 
NN(
0, 
0, 
-0.067261, 0, -1, -1, 0.487023) , 
-0.451008, 1, 3, 0, 0.468658) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.285387) , 
NN(
0, 
0, 
0.364905, 1, -1, 1, 0.55718) , 
0.50808, 1, 3, 0, 0.444878) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.584926) , 
0.0123048, 0, 0, 0, 0.501153) , 
NN(
0, 
0, 
1.22709, 0, -1, 1, 0.627716) , 
-0.220137, 0, 1, 0, 0.561082) , 
0.437295, 1, 2, 0, 0.496794)    );
  // itree = 367
  fBoostWeights.push_back(0.82532);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.607058, 0, -1, -1, 0.418111) , 
NN(
0, 
0, 
1.03962, 0, -1, 1, 0.837208) , 
1.10183, 1, 3, 0, 0.427742) , 
NN(
NN(
0, 
0, 
-0.0652509, 1, -1, 1, 0.504729) , 
NN(
0, 
0, 
0.388636, 0, -1, 1, 0.644909) , 
0.603237, 1, 3, 0, 0.532778) , 
0.564284, 0, 1, 0, 0.499152)    );
  // itree = 368
  fBoostWeights.push_back(0.717402);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.897108, 0, -1, -1, 0.293425) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.476027) , 
0.0377115, 1, 3, 0, 0.336671) , 
NN(
0, 
0, 
-0.927505, 1, -1, -1, 0.48315) , 
-2.0884, 0, 0, 0, 0.364588) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.641009) , 
-2.2168, 0, 2, 0, 0.379345) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.640909) , 
1.83153, 1, 1, 0, 0.431036) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.560529, 0, -1, -1, 0.402406) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.228488) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.292679) , 
NN(
NN(
0, 
0, 
0.246399, 0, -1, -1, 0.481757) , 
NN(
0, 
0, 
0.01774, 0, -1, 1, 0.646293) , 
-0.0808285, 1, 3, 0, 0.578533) , 
0.87577, 0, 1, 0, 0.525646) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.776889) , 
1.30305, 1, 1, 0, 0.571164) , 
1.91217, 0, 1, 0, 0.54346) , 
-0.203162, 1, 1, 0, 0.490137) , 
NN(
0, 
0, 
1.24608, 0, -1, 1, 0.576413) , 
0.266204, 1, 2, 0, 0.528453) , 
NN(
0, 
0, 
1.18005, 0, -1, 1, 0.725368) , 
0.99068, 1, 3, 0, 0.542155) , 
-0.862707, 1, 0, 0, 0.515696)    );
  // itree = 369
  fBoostWeights.push_back(0.663298);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.484914, 1, -1, -1, 0.397849) , 
NN(
NN(
0, 
0, 
-1.25229, 1, -1, -1, 0.472422) , 
NN(
NN(
0, 
0, 
0.310334, 0, -1, 1, 0.535567) , 
NN(
0, 
0, 
1.59199, 0, -1, 1, 0.694054) , 
0.810201, 1, 3, 0, 0.586197) , 
0.638814, 1, 2, 0, 0.500198) , 
-0.507056, 1, 3, 0, 0.483677)    );
  // itree = 370
  fBoostWeights.push_back(0.717596);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.382627, 1, -1, -1, 0.397175) , 
NN(
0, 
0, 
0.349328, 0, -1, 1, 0.528246) , 
0.0783247, 1, 3, 0, 0.492072) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0) , 
NN(
NN(
NN(
0, 
0, 
-0.920932, 0, -1, -1, 0.356795) , 
NN(
NN(
0, 
0, 
0.632123, 1, -1, -1, 0.440545) , 
NN(
NN(
0, 
0, 
-0.983854, 0, -1, -1, 0.431313) , 
NN(
NN(
0, 
0, 
-1.54623, 0, -1, -1, 0.483501) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.768954) , 
-0.903358, 1, 3, 0, 0.6561) , 
-0.66545, 1, 1, 0, 0.553163) , 
0.249935, 0, 1, 0, 0.503515) , 
-0.236571, 0, 0, 0, 0.477416) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.607669) , 
0.712027, 1, 0, 0, 0.495933) , 
-2.42372, 1, 3, 0, 0.490064) , 
NN(
0, 
0, 
0.253102, 0, -1, 1, 0.636457) , 
-0.191793, 1, 3, 0, 0.553072) , 
0.0206825, 0, 2, 0, 0.517105)    );
  // itree = 371
  fBoostWeights.push_back(0.814198);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-0.562417, 0, -1, -1, 0.297341) , 
NN(
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0.526928, 1, -1, -1, 0.31846) , 
NN(
0, 
0, 
-0.0891612, 0, -1, 1, 0.720823) , 
0.790302, 1, 2, 0, 0.349161) , 
NN(
0, 
0, 
0.064933, 0, -1, -1, 0.447844) , 
0.13117, 0, 0, 0, 0.401943) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.291555) , 
NN(
0, 
0, 
-0.174009, 0, -1, 1, 0.640663) , 
-0.462879, 1, 3, 0, 0.562783) , 
-1.12478, 0, 0, 0, 0.419313) , 
NN(
NN(
0, 
0, 
-1.55426, 1, -1, -1, 0.400105) , 
NN(
0, 
0, 
-0.714233, 1, -1, 1, 0.630823) , 
-1.27307, 1, 3, 0, 0.577815) , 
-0.604538, 0, 2, 0, 0.451635) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.746545) , 
1.05632, 1, 0, 0, 0.463555) , 
NN(
0, 
0, 
0.593159, 1, -1, 1, 0.570364) , 
1.21578, 1, 0, 0, 0.481841) , 
1.68312, 0, 1, 0, 0.467594) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.714177) , 
2.4829, 1, 1, 0, 0.473305)    );
  // itree = 372
  fBoostWeights.push_back(0.800356);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-0.268473, 0, -1, -1, 0.435932) , 
NN(
NN(
0, 
0, 
0.369541, 0, -1, -1, 0.487604) , 
NN(
0, 
0, 
0.388636, 0, -1, 1, 0.603596) , 
0.563743, 1, 3, 0, 0.543816) , 
0.32752, 1, 3, 0, 0.475247)    );
  // itree = 373
  fBoostWeights.push_back(0.717585);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.176881, 1, -1, -1, 0.324012) , 
NN(
NN(
0, 
0, 
0.63503, 0, -1, -1, 0.342786) , 
NN(
NN(
0, 
0, 
1.06648, 1, -1, -1, 0.417038) , 
NN(
0, 
0, 
1.07185, 0, -1, 1, 0.579373) , 
-0.935691, 1, 3, 0, 0.510954) , 
0.320584, 0, 0, 0, 0.477531) , 
-0.177572, 0, 2, 0, 0.402613) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.570382) , 
-1.35433, 0, 1, 0, 0.425209) , 
NN(
NN(
0, 
0, 
0.794235, 1, -1, -1, 0.481505) , 
NN(
NN(
NN(
0, 
0, 
0.538024, 0, -1, 1, 0.523243) , 
NN(
0, 
0, 
2.38956, 0, -1, 1, 0.763445) , 
1.46327, 1, 3, 0, 0.548366) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.801697) , 
0.0861225, 0, 2, 0, 0.598388) , 
0.908359, 1, 0, 0, 0.523367) , 
-0.0897679, 1, 3, 0, 0.482895)    );
  // itree = 374
  fBoostWeights.push_back(0.734607);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.666012, 1, -1, -1, 0.262882) , 
NN(
NN(
0, 
0, 
2.37634, 0, -1, -1, 0.48761) , 
NN(
0, 
0, 
2.38956, 0, -1, 1, 0.778184) , 
1.38076, 1, 3, 0, 0.49947) , 
-0.1547, 1, 3, 0, 0.451045) , 
NN(
NN(
NN(
0, 
0, 
-0.923107, 0, -1, -1, 0.269726) , 
NN(
0, 
0, 
-0.0920758, 0, -1, -1, 0.493568) , 
-0.894821, 1, 2, 0, 0.435761) , 
NN(
NN(
0, 
0, 
-0.997925, 0, -1, -1, 0.420471) , 
NN(
0, 
0, 
-0.685089, 0, -1, 1, 0.657039) , 
-0.649766, 1, 3, 0, 0.598968) , 
-0.203162, 1, 1, 0, 0.530513) , 
0.0206825, 0, 2, 0, 0.484711)    );
  // itree = 375
  fBoostWeights.push_back(0.871547);
  fForest.push_back( 
NN(
NN(
0, 
0, 
1.10096, 1, -1, -1, 0.371527) , 
NN(
NN(
0, 
0, 
0.955971, 0, -1, -1, 0.476478) , 
NN(
0, 
0, 
-2.14924, 0, -1, 1, 0.557338) , 
-0.157557, 1, 3, 0, 0.531741) , 
-0.924344, 1, 3, 0, 0.520729)    );
  // itree = 376
  fBoostWeights.push_back(0.743427);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.36034, 1, -1, -1, 0.380886) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.49511, 0, -1, -1, 0.330743) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.166838) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.193727) , 
NN(
0, 
0, 
-1.58741, 0, -1, 1, 0.518121) , 
-0.441804, 1, 3, 0, 0.502264) , 
-0.342591, 1, 2, 0, 0.486775) , 
NN(
NN(
0, 
0, 
-0.867054, 1, -1, -1, 0.469327) , 
NN(
NN(
0, 
0, 
-1.06463, 0, -1, -1, 0.471971) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.782159) , 
-0.624371, 1, 3, 0, 0.68622) , 
-0.383114, 1, 1, 0, 0.615564) , 
-0.488021, 0, 2, 0, 0.506845) , 
-1.21638, 1, 2, 0, 0.499751) , 
NN(
0, 
0, 
-0.519122, 1, -1, 1, 0.690173) , 
-1.90951, 0, 0, 0, 0.513379) , 
NN(
0, 
0, 
1.63357, 0, -1, 1, 0.720951) , 
0.744808, 1, 3, 0, 0.525671) , 
1.86861, 0, 0, 0, 0.512101)    );
  // itree = 377
  fBoostWeights.push_back(0.738233);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
1.19597, 1, -1, -1, 0.364112) , 
NN(
NN(
NN(
0, 
0, 
0.214077, 1, -1, -1, 0.341025) , 
NN(
NN(
0, 
0, 
0.981275, 1, -1, -1, 0.352387) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.82185, 0, -1, -1, 0.161094) , 
NN(
0, 
0, 
-0.275229, 0, -1, -1, 0.419922) , 
-1.04089, 1, 3, 0, 0.388062) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.710727) , 
-1.71513, 0, 0, 0, 0.433785) , 
NN(
0, 
0, 
1.23518, 1, -1, 1, 0.59414) , 
-0.614488, 1, 0, 0, 0.519777) , 
0.380327, 0, 0, 0, 0.469258) , 
0.062146, 0, 2, 0, 0.425474) , 
NN(
0, 
0, 
-0.0245105, 0, -1, 1, 0.510995) , 
0.182786, 1, 3, 0, 0.45706) , 
0.915234, 0, 2, 0, 0.449978) , 
NN(
0, 
0, 
2.03222, 0, -1, 1, 0.608618) , 
2.65625, 1, 0, 0, 0.454758) , 
NN(
0, 
0, 
0.145014, 1, -1, 1, 0.579835) , 
-1.95523, 0, 0, 0, 0.460733)    );
  // itree = 378
  fBoostWeights.push_back(0.741081);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.91663, 0, -1, -1, 0.412669) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.253776) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.54878, 1, -1, -1, 0.277285) , 
NN(
0, 
0, 
0.510546, 0, -1, 1, 0.51751) , 
0.379209, 0, 3, 0, 0.482938) , 
NN(
0, 
0, 
0.580765, 1, -1, 1, 0.545203) , 
0.374831, 1, 2, 0, 0.503003) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.713022) , 
-1.09654, 0, 1, 0, 0.511191) , 
-1.22301, 1, 1, 0, 0.503905) , 
-1.35433, 1, 1, 0, 0.492887)    );
  // itree = 379
  fBoostWeights.push_back(0.808464);
  fForest.push_back( 
NN(
NN(
0, 
0, 
0.36034, 1, -1, -1, 0.371779) , 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.245846) , 
NN(
0, 
0, 
1.11608, 1, -1, -1, 0.426978) , 
-0.154559, 1, 3, 0, 0.377705) , 
NN(
NN(
NN(
0, 
0, 
-0.527997, 1, -1, -1, 0.375612) , 
NN(
0, 
0, 
0.194703, 1, -1, -1, 0.468724) , 
-0.454584, 1, 3, 0, 0.434014) , 
NN(
0, 
0, 
0.194134, 0, -1, 1, 0.577672) , 
-0.341221, 1, 0, 0, 0.481726) , 
0.315874, 0, 0, 0, 0.441825) , 
NN(
0, 
0, 
-0.239103, 1, -1, 1, 0.660794) , 
0.938995, 1, 3, 0, 0.452834) , 
NN(
NN(
0, 
0, 
1.31049, 0, -1, -1, 0.352303) , 
NN(
NN(
0, 
0, 
1.63082, 0, -1, -1, 0.484829) , 
NN(
0, 
0, 
0.300641, 0, -1, 1, 0.629441) , 
0.0319117, 1, 2, 0, 0.572789) , 
-1.51497, 1, 0, 0, 0.544942) , 
0.436899, 1, 1, 0, 0.488335) , 
1.86861, 0, 0, 0, 0.477833)    );
  // itree = 380
  fBoostWeights.push_back(0.718778);
  fForest.push_back( 
NN(
NN(
0, 
0, 
2.65792, 1, -1, -1, 0.409551) , 
NN(
NN(
0, 
0, 
0.0306553, 1, -1, -1, 0.434789) , 
NN(
NN(
NN(
NN(
0, 
0, 
-0.735517, 1, -1, -1, 0.433005) , 
NN(
0, 
0, 
0.927991, 0, -1, 1, 0.710752) , 
0.868232, 1, 3, 0, 0.4637) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.624302) , 
1.07125, 1, 1, 0, 0.496788) , 
NN(
0, 
0, 
-0.239816, 0, -1, 1, 0.625739) , 
0.0802602, 0, 2, 0, 0.546846) , 
-0.25021, 1, 3, 0, 0.511037) , 
1.32235, 0, 0, 0, 0.493581)    );
  // itree = 381
  fBoostWeights.push_back(0.721919);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.985838, 1, -1, -1, 0.391462) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.273601) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.6087, 0, -1, -1, 0.287281) , 
NN(
0, 
0, 
-0.660984, 0, -1, -1, 0.408647) , 
-0.936947, 1, 3, 0, 0.373328) , 
NN(
0, 
0, 
0.843301, 0, -1, 1, 0.517821) , 
-1.94099, 0, 2, 0, 0.385342) , 
NN(
0, 
0, 
0.238403, 0, -1, 1, 0.569702) , 
-0.221751, 1, 3, 0, 0.469288) , 
-0.0566298, 0, 2, 0, 0.439988) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.749477) , 
0.0284, 1, 2, 0, 0.468609) , 
0.117124, 0, 2, 0, 0.432261) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.902086) , 
-3.42721, 0, 0, 0, 0.434911) , 
NN(
0, 
0, 
-0.220137, 0, -1, 1, 0.550869) , 
0.744808, 1, 3, 0, 0.445247)    );
  // itree = 382
  fBoostWeights.push_back(0.727474);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-2.22173, 0, -1, -1, 0.349575) , 
NN(
NN(
0, 
0, 
-0.559331, 0, -1, -1, 0.446683) , 
NN(
NN(
NN(
NN(
0, 
0, 
0.736882, 1, -1, -1, 0.393053) , 
NN(
0, 
0, 
0.733907, 0, -1, 1, 0.55509) , 
0.649572, 1, 3, 0, 0.455245) , 
NN(
0, 
0, 
-1.01154, 1, -1, 1, 0.559585) , 
0.534337, 0, 2, 0, 0.524128) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.775119) , 
1.8632, 1, 1, 0, 0.5428) , 
-0.261688, 1, 3, 0, 0.522763) , 
-1.34163, 1, 3, 0, 0.517027)    );
  // itree = 383
  fBoostWeights.push_back(0.957793);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0.977575, 1, -1, -1, 0.416525) , 
NN(
0, 
0, 
-1.10679, 1, -1, 1, 0.580024) , 
-0.648855, 0, 2, 0, 0.440142) , 
NN(
NN(
0, 
0, 
-1.64303, 1, -1, -1, 0.165165) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.739244) , 
-1.21871, 1, 3, 0, 0.654215) , 
-1.77063, 0, 0, 0, 0.458102) , 
NN(
NN(
0, 
0, 
1.1901, 0, -1, -1, 0.33042) , 
NN(
0, 
0, 
0.5431, 1, -1, 1, 0.57125) , 
0.786817, 0, 2, 0, 0.541582) , 
0.180561, 1, 1, 0, 0.500814)    );
  // itree = 384
  fBoostWeights.push_back(0.766417);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.23196, 1, -1, -1, 0.282523) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.272896) , 
NN(
NN(
NN(
0, 
0, 
-0.523818, 1, -1, -1, 0.347724) , 
NN(
0, 
0, 
-0.559958, 0, -1, 1, 0.520467) , 
-0.27438, 1, 3, 0, 0.464413) , 
NN(
0, 
0, 
1.27382, 1, -1, 1, 0.607425) , 
-1.00762, 0, 0, 0, 0.493606) , 
0.466307, 0, 2, 0, 0.471473) , 
-2.18599, 1, 0, 0, 0.464284) , 
NN(
0, 
0, 
-0.760989, 1, -1, 1, 0.559193) , 
0.32752, 1, 3, 0, 0.500106)    );
  // itree = 385
  fBoostWeights.push_back(0.828414);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
-1.59222, 0, -1, -1, 0.399687) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.293667) , 
NN(
0, 
0, 
0.962582, 1, -1, 1, 0.58342) , 
0.649572, 1, 3, 0, 0.449768) , 
NN(
NN(
0, 
0, 
-2.05649, 0, -1, -1, 0.383036) , 
NN(
0, 
0, 
0.265523, 1, -1, 1, 0.567503) , 
-1.28816, 1, 3, 0, 0.560612) , 
0.786817, 0, 2, 0, 0.545865) , 
-1.39436, 1, 1, 0, 0.53284) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.838994) , 
-2.5055, 0, 1, 0, 0.538221)    );
  // itree = 386
  fBoostWeights.push_back(0.860933);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.291239) , 
NN(
0, 
0, 
0.542195, 0, -1, 1, 0.503552) , 
0.163457, 1, 2, 0, 0.450555) , 
NN(
NN(
NN(
NN(
0, 
0, 
-1.56563, 0, -1, -1, 0.412521) , 
NN(
NN(
0, 
0, 
-0.813227, 1, -1, -1, 0.430875) , 
NN(
NN(
0, 
0, 
0.644986, 0, -1, -1, 0.479903) , 
NN(
0, 
0, 
0.995009, 1, -1, 1, 0.584913) , 
-0.0859812, 0, 3, 0, 0.537841) , 
-1.45523, 1, 0, 0, 0.514367) , 
-1.42633, 1, 1, 0, 0.50303) , 
NN(
0, 
0, 
-0.234264, 0, -1, 1, 0.654913) , 
0.700897, 1, 2, 0, 0.525177) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.616631) , 
NN(
NN(
0, 
0, 
0, 1, -1, 1, 0.62612) , 
NN(
0, 
0, 
0.644195, 0, -1, 1, 0.886134) , 
-0.0310626, 1, 3, 0, 0.818641) , 
0.953733, 1, 0, 0, 0.719089) , 
0.768453, 1, 0, 0, 0.557592) , 
1.32235, 0, 0, 0, 0.539806)    );
  // itree = 387
  fBoostWeights.push_back(0.84086);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.310628) , 
NN(
0, 
0, 
1.94908, 0, -1, 1, 0.521091) , 
0.649139, 1, 3, 0, 0.381972) , 
NN(
NN(
NN(
0, 
0, 
0.560095, 1, -1, -1, 0.364146) , 
NN(
NN(
NN(
0, 
0, 
1.09224, 1, -1, -1, 0.314788) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.379565) , 
NN(
0, 
0, 
-1.04809, 0, -1, 1, 0.543062) , 
0.029662, 1, 3, 0, 0.510524) , 
0.318155, 0, 0, 0, 0.470273) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.830015) , 
0.466381, 1, 1, 0, 0.517674) , 
0.763017, 0, 1, 0, 0.472117) , 
NN(
0, 
0, 
1.07645, 0, -1, 1, 0.679873) , 
0.961843, 1, 0, 0, 0.493405) , 
1.3257, 0, 0, 0, 0.466543) , 
NN(
NN(
0, 
0, 
-2.23824, 0, -1, -1, 0.461813) , 
NN(
NN(
0, 
0, 
0.278311, 0, -1, 1, 0.539918) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.490514) , 
NN(
NN(
NN(
0, 
0, 
-0.277744, 0, -1, 1, 0.552121) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.730636) , 
-0.0163265, 1, 3, 0, 0.626003) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.854616) , 
-1.01813, 0, 1, 0, 0.665228) , 
-1.53356, 1, 1, 0, 0.636402) , 
0.564284, 0, 1, 0, 0.608315) , 
-1.10085, 1, 3, 0, 0.593811) , 
0.0206825, 0, 2, 0, 0.522301)    );
  // itree = 388
  fBoostWeights.push_back(0.813885);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.96248, 0, -1, -1, 0.420992) , 
NN(
NN(
0, 
0, 
0.180925, 1, -1, -1, 0.418568) , 
NN(
NN(
0, 
0, 
-0.925935, 1, -1, 1, 0.535355) , 
NN(
0, 
0, 
0.298667, 0, -1, 1, 0.605491) , 
-0.063257, 0, 3, 0, 0.562885) , 
0.718743, 0, 3, 0, 0.546068) , 
-0.924344, 1, 3, 0, 0.536822) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.856527) , 
-2.42611, 0, 1, 0, 0.544453) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.789707) , 
2.4829, 1, 1, 0, 0.551088)    );
  // itree = 389
  fBoostWeights.push_back(0.88537);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.257211) , 
NN(
NN(
NN(
NN(
0, 
0, 
-2.43408, 1, -1, -1, 0.390018) , 
NN(
0, 
0, 
1.28503, 0, -1, 1, 0.765298) , 
0.801852, 1, 3, 0, 0.416473) , 
NN(
0, 
0, 
0.0115599, 0, -1, 1, 0.596424) , 
-1.85965, 0, 1, 0, 0.451332) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.768819) , 
-0.387524, 1, 1, 0, 0.475464) , 
-0.29876, 0, 1, 0, 0.459687) , 
NN(
NN(
NN(
0, 
0, 
1.27148, 0, -1, -1, 0.268935) , 
NN(
NN(
0, 
0, 
-1.40658, 0, -1, -1, 0.409617) , 
NN(
0, 
0, 
0.204998, 1, -1, 1, 0.565938) , 
0.0287375, 1, 2, 0, 0.492036) , 
0.786817, 0, 2, 0, 0.470068) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.230745) , 
NN(
NN(
0, 
0, 
1.39207, 1, -1, -1, 0.484224) , 
NN(
NN(
0, 
0, 
0.319109, 1, -1, 1, 0.525251) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.724472) , 
-0.253254, 1, 3, 0, 0.675062) , 
0.43948, 0, 3, 0, 0.61408) , 
0.0220667, 1, 1, 0, 0.575464) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.945583) , 
-0.115951, 0, 1, 0, 0.606906) , 
0.502038, 0, 1, 0, 0.532195) , 
-0.203162, 1, 1, 0, 0.504126)    );
  // itree = 390
  fBoostWeights.push_back(0.753449);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.332917) , 
NN(
NN(
NN(
0, 
0, 
0.956418, 1, -1, -1, 0.342528) , 
NN(
0, 
0, 
-0.604087, 0, -1, 1, 0.500328) , 
-0.838011, 1, 3, 0, 0.476629) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.671314) , 
1.28811, 1, 1, 0, 0.494502) , 
0.373431, 0, 2, 0, 0.477116) , 
NN(
0, 
0, 
-0.586123, 1, -1, 1, 0.651356) , 
1.71545, 1, 1, 0, 0.493154) , 
NN(
0, 
0, 
0.728929, 0, -1, 1, 0.629916) , 
0.32752, 1, 3, 0, 0.543531)    );
  // itree = 391
  fBoostWeights.push_back(0.769452);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.320584, 0, -1, -1, 0.381934) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.547754) , 
-0.191793, 1, 3, 0, 0.403426) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.202159) , 
NN(
NN(
0, 
0, 
1.15245, 1, -1, -1, 0.438574) , 
NN(
NN(
NN(
0, 
0, 
0.564627, 0, -1, 1, 0.511297) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.162758) , 
NN(
0, 
0, 
-0.062367, 0, -1, 1, 0.539796) , 
-0.38497, 1, 3, 0, 0.494385) , 
NN(
0, 
0, 
0.235464, 0, -1, 1, 0.760252) , 
0.185259, 1, 3, 0, 0.599954) , 
0.183811, 0, 0, 0, 0.552436) , 
NN(
0, 
0, 
1.04385, 0, -1, 1, 0.734994) , 
0.828731, 1, 2, 0, 0.567434) , 
0.990705, 0, 2, 0, 0.557254) , 
-0.302388, 1, 2, 0, 0.544204) , 
-0.39593, 1, 2, 0, 0.513576)    );
  // itree = 392
  fBoostWeights.push_back(0.857838);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.908359, 0, -1, -1, 0.393226) , 
NN(
NN(
0, 
0, 
-1.2469, 0, -1, -1, 0.365327) , 
NN(
NN(
0, 
0, 
-1.02008, 0, -1, -1, 0.223717) , 
NN(
0, 
0, 
-0.317825, 1, -1, 1, 0.620238) , 
-0.611535, 1, 3, 0, 0.581463) , 
-0.558422, 1, 0, 0, 0.487261) , 
-0.0371549, 0, 2, 0, 0.424143) , 
NN(
NN(
NN(
0, 
0, 
-0.420464, 1, -1, -1, 0.161259) , 
NN(
0, 
0, 
-0.69647, 0, -1, -1, 0.455212) , 
-0.950154, 1, 3, 0, 0.398495) , 
NN(
NN(
NN(
0, 
0, 
-0.615293, 0, -1, -1, 0.392082) , 
NN(
0, 
0, 
0.053757, 0, -1, 1, 0.570798) , 
-0.1861, 1, 2, 0, 0.514769) , 
NN(
0, 
0, 
-0.302661, 1, -1, 1, 0.621612) , 
-1.12981, 0, 1, 0, 0.543712) , 
-1.29231, 1, 0, 0, 0.517916) , 
0.180561, 0, 1, 0, 0.469241)    );
  // itree = 393
  fBoostWeights.push_back(0.823322);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.11508, 1, -1, -1, 0.38978) , 
NN(
NN(
NN(
0, 
0, 
0.923946, 0, -1, -1, 0.402856) , 
NN(
0, 
0, 
0.71975, 1, -1, 1, 0.534749) , 
0.410327, 1, 3, 0, 0.443329) , 
NN(
0, 
0, 
0.491121, 1, -1, 1, 0.625749) , 
-0.836542, 0, 1, 0, 0.476561) , 
-0.734765, 1, 0, 0, 0.45519) , 
NN(
0, 
0, 
-1.75271, 1, -1, 1, 0.571726) , 
1.29979, 1, 1, 0, 0.47629) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.720228) , 
-2.12178, 0, 1, 0, 0.482945)    );
  // itree = 394
  fBoostWeights.push_back(0.734655);
  fForest.push_back( 
NN(
NN(
0, 
0, 
-1.68209, 0, -1, -1, 0.348491) , 
NN(
NN(
0, 
0, 
0.118638, 0, -1, -1, 0.46646) , 
NN(
0, 
0, 
0.308694, 0, -1, 1, 0.569022) , 
-0.157557, 1, 3, 0, 0.539329) , 
-0.924344, 1, 3, 0, 0.525832)    );
  // itree = 395
  fBoostWeights.push_back(0.815695);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-0.267028, 0, -1, -1, 0.372341) , 
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.208966) , 
NN(
NN(
0, 
0, 
0.74587, 1, -1, -1, 0.419262) , 
NN(
0, 
0, 
0.77455, 1, -1, 1, 0.687535) , 
0.218562, 1, 2, 0, 0.523765) , 
1.22315, 0, 1, 0, 0.455298) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.779408) , 
1.32052, 1, 1, 0, 0.522132) , 
1.43014, 0, 1, 0, 0.461283) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.697834) , 
2.60362, 1, 1, 0, 0.47857) , 
NN(
NN(
0, 
0, 
0.864251, 1, -1, -1, 0.463906) , 
NN(
NN(
0, 
0, 
0.0968413, 1, -1, -1, 0.496574) , 
NN(
0, 
0, 
0.194796, 0, -1, 1, 0.61955) , 
-0.415422, 1, 3, 0, 0.591391) , 
0.537476, 0, 2, 0, 0.558828) , 
0.564284, 0, 1, 0, 0.532411)    );
  // itree = 396
  fBoostWeights.push_back(0.791246);
  fForest.push_back( 
NN(
NN(
NN(
NN(
0, 
0, 
-1.81718, 0, -1, -1, 0.370464) , 
NN(
NN(
0, 
0, 
0.600938, 1, -1, -1, 0.435358) , 
NN(
NN(
0, 
0, 
0.135455, 0, -1, -1, 0.468483) , 
NN(
NN(
0, 
0, 
-0.372344, 1, -1, 1, 0.528414) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
0.178918, 1, 3, 0, 0.60133) , 
-0.213108, 1, 2, 0, 0.535987) , 
0.175306, 0, 2, 0, 0.493316) , 
-1.01709, 1, 2, 0, 0.479703) , 
NN(
0, 
0, 
1.12279, 0, -1, 1, 0.740524) , 
0.907668, 1, 3, 0, 0.489512) , 
NN(
0, 
0, 
1.90318, 0, -1, 1, 0.601625) , 
0.776084, 1, 0, 0, 0.525098)    );
  // itree = 397
  fBoostWeights.push_back(0.795542);
  fForest.push_back( 
NN(
NN(
NN(
0, 
0, 
0.549689, 0, -1, -1, 0.434492) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.60241) , 
-0.191793, 1, 3, 0, 0.451447) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.430245) , 
NN(
NN(
0, 
0, 
-0.000955732, 1, -1, -1, 0.462301) , 
NN(
0, 
0, 
-0.438199, 0, -1, 1, 0.618041) , 
-0.241546, 1, 3, 0, 0.601685) , 
-1.59566, 1, 0, 0, 0.591068) , 
-0.39593, 1, 2, 0, 0.564378)    );
  // itree = 398
  fBoostWeights.push_back(0.77609);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.449291, 0, -1, -1, 0.368153) , 
NN(
0, 
0, 
-0.490997, 1, -1, 1, 0.564754) , 
0.100059, 1, 2, 0, 0.453902) , 
NN(
NN(
NN(
0, 
0, 
-0.938525, 0, -1, -1, 0.352536) , 
NN(
NN(
0, 
0, 
0.962513, 1, -1, -1, 0.485216) , 
NN(
0, 
0, 
0.107198, 0, -1, 1, 0.596876) , 
0.12015, 1, 3, 0, 0.544553) , 
-0.637785, 1, 0, 0, 0.521775) , 
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.35418) , 
NN(
NN(
0, 
0, 
-1.34748, 0, -1, -1, 0.341613) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.965549) , 
-0.698804, 1, 2, 0, 0.774796) , 
-1.62824, 1, 0, 0, 0.642817) , 
-1.09507, 0, 0, 0, 0.533384) , 
-0.128493, 1, 1, 0, 0.512578) , 
NN(
0, 
0, 
-0.693758, 1, -1, 1, 0.69653) , 
-1.95523, 0, 0, 0, 0.522435) , 
NN(
NN(
0, 
0, 
0.0167487, 0, -1, 1, 0.551429) , 
NN(
0, 
0, 
1.92756, 0, -1, 1, 0.757672) , 
0.622144, 1, 2, 0, 0.592521) , 
-0.970608, 0, 1, 0, 0.534679)    );
  // itree = 399
  fBoostWeights.push_back(0.753994);
  fForest.push_back( 
NN(
NN(
NN(
NN(
NN(
NN(
NN(
NN(
0, 
0, 
-0.020787, 0, -1, -1, 0.344689) , 
NN(
NN(
NN(
NN(
0, 
0, 
0, 1, -1, -1, 0.0218058) , 
NN(
0, 
0, 
0, 1, -1, -1, 0.484026) , 
-0.0830187, 1, 3, 0, 0.376216) , 
NN(
0, 
0, 
-1.43269, 1, -1, 1, 0.532891) , 
-0.501225, 0, 0, 0, 0.448144) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.610597) , 
0.449521, 1, 0, 0, 0.482022) , 
-0.255976, 0, 1, 0, 0.426832) , 
NN(
NN(
0, 
0, 
0.229184, 1, -1, -1, 0.430303) , 
NN(
NN(
0, 
0, 
1.24414, 1, -1, 1, 0.549363) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.885216) , 
-0.195726, 1, 3, 0, 0.646789) , 
-0.00621006, 0, 2, 0, 0.50411) , 
0.322406, 1, 1, 0, 0.459696) , 
NN(
NN(
0, 
0, 
-3.01287, 1, -1, -1, 0.453843) , 
NN(
0, 
0, 
0, 1, -1, 1, 0.854323) , 
-0.916958, 1, 3, 0, 0.679283) , 
-1.81467, 0, 0, 0, 0.475514) , 
NN(
0, 
0, 
0.556604, 1, -1, 1, 0.568492) , 
1.30987, 1, 0, 0, 0.49231) , 
NN(
0, 
0, 
0, 1, -1, 1, 1) , 
1.93537, 1, 2, 0, 0.495712) , 
NN(
0, 
0, 
-0.0990402, 1, -1, 1, 0.658195) , 
-1.2108, 0, 1, 0, 0.519632) , 
NN(
0, 
0, 
0.320584, 0, -1, 1, 0.699909) , 
1.71545, 1, 1, 0, 0.535799)    );
   return;
};
 
// Clean up
inline void ReadBDT::Clear() 
{
   for (unsigned int itree=0; itree<fForest.size(); itree++) { 
      delete fForest[itree]; 
   }
}
   inline double ReadBDT::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!fStatusIsClean) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            retval = GetMvaValue__( iV );
         }
         else {
            retval = GetMvaValue__( inputValues );
         }
      }

      return retval;
   }
