// Class: ReadLikelihood
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : Likelihood::Likelihood
TMVA Release   : 3.8.13        [198669]
ROOT Release   : 5.19/02       [332546]
Creator        : heponx
Date           : Fri Mar 28 00:39:40 2008
Host           : Darwin jlctpcmac.kek.jp 9.2.0 Darwin Kernel Version 9.2.0: Tue Feb 5 16:15:19 PST 2008; root:xnu-1228.3.13~1/RELEASE_PPC Power Macintosh
Dir            : /Users/root/root_v5.19.02-macosx10.5-ppc/test
Training events: 1000


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
V: "False" [Verbose mode]
H: "False" [Print classifier-specific help message]
NSmooth: "10" [Number of smoothing iterations for the input histograms]
NAvEvtPerBin: "50" [Average number of events per PDF bin]
TransformOutput: "False" [Transform likelihood output by inverse sigmoid function]
# Default:
D: "False" [use-decorrelated-variables flag (depreciated)]
Normalise: "False" [Normalise input variables]
VarTransform: "None" [Variable transformation method]
VarTransformType: "Signal" [Use signal or background events for var transform]
NbinsMVAPdf: "60" [Number of bins used to create MVA PDF]
NsmoothMVAPdf: "2" [Number of smoothing iterations for MVA PDF]
VerboseLevel: "Info" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs]
TxtWeightFilesOnly: "True" [if True, write all weights as text files]
NSmoothSig[0]: "10" [Number of smoothing iterations for the input histograms]
    NSmoothSig[1]: "10"
    NSmoothSig[2]: "10"
    NSmoothSig[3]: "10"
NSmoothBkg[0]: "10" [Number of smoothing iterations for the input histograms]
    NSmoothBkg[1]: "10"
    NSmoothBkg[2]: "10"
    NSmoothBkg[3]: "10"
NAvEvtPerBinSig[0]: "50" [Average num of events per PDF bin and variable (signal)]
    NAvEvtPerBinSig[1]: "50"
    NAvEvtPerBinSig[2]: "50"
    NAvEvtPerBinSig[3]: "50"
NAvEvtPerBinBkg[0]: "50" [Average num of events per PDF bin and variable (background)]
    NAvEvtPerBinBkg[1]: "50"
    NAvEvtPerBinBkg[2]: "50"
    NAvEvtPerBinBkg[3]: "50"
PDFInterpol[0]: "Spline2" [Method of interpolating reference histograms (e.g. Spline2 or KDE)]
    PDFInterpol[1]: "Spline2"
    PDFInterpol[2]: "Spline2"
    PDFInterpol[3]: "Spline2"
KDEtype: "Gauss" [KDE kernel type (1=Gauss)]
KDEiter: "Nonadaptive" [Number of iterations (1=non-adaptive, 2=adaptive)]
KDEFineFactor: "1" [Fine tuning factor for Adaptive KDE: Factor to multyply the width of the kernel]
KDEborder: "None" [Border effects treatment (1=no treatment , 2=kernel renormalization, 3=sample mirroring)]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 4
var1+var2                     var1_P_var2                       'F'    [-6.05220985413,4.87306022644]
var1-var2                     var1_M_var2                       'F'    [-3.84853005409,3.82592988014]
var3                          var3                              'F'    [-5.18697977066,3.14527988434]
var4                          var4                              'F'    [-4.88857984543,3.45718002319]


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#include <math.h>
#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;
};

#endif

class ReadLikelihood : public IClassifierReader {

 public:

   // constructor
   ReadLikelihood( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "ReadLikelihood" ),
        fStatusIsClean( true ),
        fNvars( 4 ),
        fIsNormalised( false )
   {      
      // the training input variables
      const char* inputVars[] = { "var1+var2", "var1-var2", "var3", "var4" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -6.05220985412598;
      fVmax[0] = 4.87306022644043;
      fVmin[1] = -3.84853005409241;
      fVmax[1] = 3.82592988014221;
      fVmin[2] = -5.1869797706604;
      fVmax[2] = 3.14527988433838;
      fVmin[3] = -4.88857984542847;
      fVmax[3] = 3.45718002319336;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';

      // initialize constants
      Initialize();

   }

   // destructor
   virtual ~ReadLikelihood() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // common member variables
   const char* fClassName;
   bool fStatusIsClean;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[4];
   double fVmax[4];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[4];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)
   double       fEpsilon;
   static float fRefS[][10000]; // signal reference vector [nvars][max_nbins]
   static float fRefB[][10000]; // backgr reference vector [nvars][max_nbins]

// if a variable has its PDF encoded as a spline0 --> treat it like an Integer valued one
   bool    fHasDiscretPDF[4]; 
   int    fNbin[4]; // number of bins (discrete variables may have less bins)
   double TransformLikelihoodOutput( double, double ) const;
};

inline void ReadLikelihood::Initialize() 
{
   fEpsilon = 1e-08;
   fNbin[0] = 10000;
   fNbin[1] = 10000;
   fNbin[2] = 10000;
   fNbin[3] = 10000;
   fHasDiscretPDF[0] = false; 
   fHasDiscretPDF[1] = false; 
   fHasDiscretPDF[2] = false; 
   fHasDiscretPDF[3] = false; 
}

inline double ReadLikelihood::GetMvaValue__( const std::vector<double>& inputValues ) const
{
   double ps(1), pb(1);
   const std::vector<double>& inputValuesSig = inputValues;
   const std::vector<double>& inputValuesBgd = inputValues;
   for (size_t ivar = 0; ivar < GetNvar(); ivar++) {

      // dummy at present... will be used for variable transforms
      double x[2] = { inputValuesSig[ivar], inputValuesBgd[ivar] };

      for (int itype=0; itype < 2; itype++) {

         // interpolate linearly between adjacent bins
         // this is not useful for discrete variables (or forced Spline0)
         int bin = int((x[itype] - fVmin[ivar])/(fVmax[ivar] - fVmin[ivar])*fNbin[ivar]) + 0;

         // since the test data sample is in general different from the training sample
         // it can happen that the min/max of the training sample are trespassed --> correct this
         if      (bin < 0) {
            bin = 0;
            x[itype] = fVmin[ivar];
         }
         else if (bin >= fNbin[ivar]) {
            bin = fNbin[ivar]-1;
            x[itype] = fVmax[ivar];
         }

         // find corresponding histogram from cached indices
         float ref = (itype == 0) ? fRefS[ivar][bin] : fRefB[ivar][bin];

         // sanity check
         if (ref < 0) {
            std::cout << "Fatal error in ReadLikelihood: bin entry < 0 ==> abort" << std::endl;
            exit(1);
         }

         double p = ref;

         if (GetType(ivar) != 'I' && !fHasDiscretPDF[ivar]) {
            float bincenter = (bin + 0.5)/fNbin[ivar]*(fVmax[ivar] - fVmin[ivar]) + fVmin[ivar];
            int nextbin = bin;
            if ((x[itype] > bincenter && bin != fNbin[ivar]-1) || bin == 0) 
               nextbin++;
            else
               nextbin--;  

            double refnext      = (itype == 0) ? fRefS[ivar][nextbin] : fRefB[ivar][nextbin];
            float nextbincenter = (nextbin + 0.5)/fNbin[ivar]*(fVmax[ivar] - fVmin[ivar]) + fVmin[ivar];

            double dx = bincenter - nextbincenter;
            double dy = ref - refnext;
            p += (x[itype] - bincenter) * dy/dx;
         }

         if (p < fEpsilon) p = fEpsilon; // avoid zero response

         if (itype == 0) ps *= p;
         else            pb *= p;
      }            
   }     

   // the likelihood ratio (transform it ?)
   return TransformLikelihoodOutput( ps, pb );   
}

inline double ReadLikelihood::TransformLikelihoodOutput( double ps, double pb ) const
{
   // returns transformed or non-transformed output
   if (ps + pb < fEpsilon) pb = fEpsilon;
   double r = ps/(ps + pb);

   if (false) {
      // inverse Fermi function

      // sanity check
      if      (r <= 0.0) r = fEpsilon;
      else if (r >= 1.0) r = 1.0 - fEpsilon;

      double tau = 15.0;
      r = - log(1.0/r - 1.0)/tau;
   }

   return r;
}

// Clean up
inline void ReadLikelihood::Clear() 
{
   // nothing to clear
}

// signal map
float ReadLikelihood::fRefS[][10000] = 
{ 
   { 0.00642212899401784, 0.00640435377135873, 0.00638657854869962, 0.00636880332604051, 0.00635111192241311, 0.00633337860926986, 0.00631566671654582, 0.00629803817719221, 0.00628034677356482, 0.00626276060938835, 0.00624513253569603, 0.00622750446200371, 0.0062099602073431, 0.00619239499792457, 0.00617489265277982, 0.00615736981853843, 0.00613984651863575, 0.00612240750342607, 0.00610492657870054, 0.00608752947300673, 0.00607008999213576, 0.00605267193168402, 0.00603533815592527, 0.00601794105023146, 0.00600060727447271, 0.00598331494256854, 0.00596600212156773, 0.00594875169917941, 0.00593148078769445, 0.00591423083096743, 0.00589702278375626, 0.00587981473654509, 0.00586269097402692, 0.00584548292681575, 0.00582835869863629, 0.00581125589087605, 0.00579413212835789, 0.00577707123011351, 0.00576001033186913, 0.00574297038838267, 0.00572595139965415, 0.00570895383134484, 0.00569193484261632, 0.00567502109333873, 0.00565804401412606, 0.00564117217436433, 0.00562425842508674, 0.00560734467580914, 0.00559051521122456, 0.00557364290580153, 0.00555687630549073, 0.00554004637524486, 0.0055232378654182, 0.00550651270896196, 0.00548974610865116, 0.00547306379303336, 0.00545633863657713, 0.00543963490054011, 0.0054230154491961, 0.00540633266791701, 0.00538975512608886, 0.00537313520908356, 0.00535651575773954, 0.00534000108018517, 0.00532342353835702, 0.00530690886080265, 0.00529041513800621, 0.00527390046045184, 0.0052574910223484, 0.00524099729955196, 0.00522458786144853, 0.0052081779576838, 0.00519178947433829, 0.00517542194575071, 0.00515907583758235, 0.00514274975284934, 0.00512646650895476, 0.00511016184464097, 0.00509385764598846, 0.0050776582211256, 0.00506139546632767, 0.00504523795098066, 0.0050290385261178, 0.00501283910125494, 0.00499672396108508, 0.00498056644573808, 0.00496449321508408, 0.00494839856401086, 0.004932283423841, 0.00491629401221871, 0.00490022031590343, 0.00488425185903907, 0.00486824149265885, 0.00485225254669785, 0.00483634695410728, 0.00482037849724293, 0.00480451574549079, 0.00478861015290022, 0.00477270456030965, 0.00475688371807337, 0.00474102003499866, 0.0047252201475203, 0.00470946216955781, 0.00469364039599895, 0.00467794528231025, 0.00466216634958982, 0.0046464498154819, 0.00463077565655112, 0.00461508054286242, 0.00459946924820542, 0.00458381604403257, 0.00456820521503687, 0.00455261487513781, 0.00453702500090003, 0.00452147657051682, 0.00450594956055284, 0.00449042208492756, 0.00447493745014071, 0.00445945234969258, 0.00444396724924445, 0.00442858738824725, 0.00441312324255705, 0.00439778482541442, 0.00438238400965929, 0.0043670036830008, 0.00435170810669661, 0.00433634873479605, 0.00432109506800771, 0.00430579902604222, 0.00429052393883467, 0.00427531218156219, 0.00426007900387049, 0.00424490915611386, 0.00422971835359931, 0.00421452755108476, 0.00419944152235985, 0.00418429262936115, 0.0041691861115396, 0.00415414199233055, 0.00413903500884771, 0.00412405421957374, 0.00410898914560676, 0.00409398740157485, 0.00407900661230087, 0.00406404677778482, 0.00404914980754256, 0.0040341904386878, 0.00401929346844554, 0.00400441791862249, 0.00398954190313816, 0.00397470826283097, 0.00395989511162043, 0.00394508289173245, 0.00393031211569905, 0.00391554133966565, 0.00390077056363225, 0.00388608407229185, 0.00387135520577431, 0.00385671062394977, 0.00384202389977872, 0.00382735836319625, 0.0038127766456455, 0.00379813206382096, 0.0037835924886167, 0.00376901077106595, 0.00375445000827312, 0.00373995280824602, 0.00372541300021112, 0.0037109786644578, 0.00369650172069669, 0.00368202547542751, 0.00366763304919004, 0.00365319824777544, 0.00363880582153797, 0.00362447625957429, 0.00361008383333683, 0.00359579618088901, 0.00358146685175598, 0.0035671794321388, 0.00355293392203748, 0.00353866745717824, 0.00352446408942342, 0.00351023953408003, 0.00349603616632521, 0.0034818749409169, 0.00346771348267794, 0.00345363607630134, 0.00343949580565095, 0.00342539744451642, 0.00341134122572839, 0.00339728477410972, 0.00338322832249105, 0.00336925615556538, 0.00335526280105114, 0.00334129040129483, 0.00332733918912709, 0.00331336702220142, 0.00329949962906539, 0.00328556937165558, 0.00327174412086606, 0.00325787696056068, 0.00324400956742465, 0.00323024764657021, 0.00321642216295004, 0.00320268119685352, 0.00318891881033778, 0.00317515688948333, 0.00316147855482996, 0.00314775854349136, 0.00313412235118449, 0.00312046520411968, 0.0031067868694663, 0.0030932140070945, 0.00307959876954556, 0.00306602567434311, 0.00305249472148716, 0.00303892162628472, 0.00302545353770256, 0.00301192235201597, 0.00299845449626446, 0.0029850285500288, 0.00297156046144664, 0.00295817642472684, 0.00294475047849119, 0.00293136644177139, 0.00291800335980952, 0.00290466146543622, 0.00289136171340942, 0.00287806149572134, 0.00286478269845247, 0.00285154581069946, 0.00283828773535788, 0.00282503012567759, 0.00281187705695629, 0.00279870326630771, 0.00278555043041706, 0.00277239759452641, 0.00275924452580512, 0.00274619669653475, 0.00273306504823267, 0.00272005912847817, 0.00270701153203845, 0.00269394251517951, 0.00268099969252944, 0.00266797305084765, 0.0026550511829555, 0.00264210836030543, 0.00262914458289742, 0.00261628604494035, 0.00260336417704821, 0.00259050563909113, 0.00257768877781928, 0.00256485119462013, 0.00255207647569478, 0.00253925984725356, 0.00252650608308613, 0.00251379446126521, 0.00250104092992842, 0.00248837121762335, 0.00247565959580243, 0.00246298988349736, 0.00245034135878086, 0.00243771378882229, 0.00242514931596816, 0.00241254270076752, 0.00239995704032481, 0.0023874135222286, 0.00237489095889032, 0.00236234744079411, 0.00234990892931819, 0.00233744946308434, 0.00232501095160842, 0.0023125724401325, 0.00230013392865658, 0.00228777946904302, 0.00227538286708295, 0.00226307054981589, 0.00225073704496026, 0.00223840377293527, 0.002226154319942, 0.00221384200267494, 0.00220163445919752, 0.00218940619379282, 0.00217715674079955, 0.00216501229442656, 0.00215280498377979, 0.00214066077023745, 0.00212855823338032, 0.00211641401983798, 0.00210437481291592, 0.00209227227605879, 0.00208021211437881, 0.00206821481697261, 0.00205617561005056, 0.00204422022216022, 0.00203220196999609, 0.00202026776969433, 0.00200835452415049, 0.00199642032384872, 0.00198457017540932, 0.00197265692986548, 0.00196080678142607, 0.00194897770415992, 0.00193714839406312, 0.00192536122631282, 0.00191359501332045, 0.00190184987150133, 0.00189010496251285, 0.00187838077545166, 0.00186665647197515, 0.00185503740794957, 0.00184337631799281, 0.00183175725396723, 0.00182011723518372, 0.00180849828757346, 0.00179696315899491, 0.00178536504972726, 0.00177387217991054, 0.00176235812250525, 0.00175082311034203, 0.00173939310479909, 0.00172790011856705, 0.00171644915826619, 0.00170506129506975, 0.00169363128952682, 0.00168230629060417, 0.00167091842740774, 0.00165957247372717, 0.00164828961715102, 0.00163696461822838, 0.00162572378758341, 0.00161441985983402, 0.00160317902918905, 0.00159200117923319, 0.00158076034858823, 0.00156962452456355, 0.00155842571984977, 0.00154728977940977, 0.00153619598131627, 0.00152506027370691, 0.00151398743037134, 0.00150293577462435, 0.00149188388604671, 0.00148087425623089, 0.00146986439358443, 0.00145887571852654, 0.00144792895298451, 0.00143698218744248, 0.00142605660948902, 0.00141515175346285, 0.00140424713026732, 0.00139342644251883, 0.00138258480001241, 0.00137176411226392, 0.00136094354093075, 0.00135014392435551, 0.00133940728846937, 0.00132862874306738, 0.00131795508787036, 0.00130723952315748, 0.00129652384202927, 0.00128589232917875, 0.00127521879039705, 0.00126458727754653, 0.00125401874538511, 0.00124338711611927, 0.00123286072630435, 0.00122229207772762, 0.0012117656879127, 0.00120128120761365, 0.00119077577255666, 0.00118033320177346, 0.00116986979264766, 0.00115942733827978, 0.00114904786460102, 0.00113862648140639, 0.00112826807890087, 0.00111793063115329, 0.00110759329982102, 0.00109729787800461, 0.0010870024561882, 0.00107672810554504, 0.00106649578083307, 0.00105626345612109, 0.00104605208616704, 0.00103586190380156, 0.00102565053384751, 0.00101554417051375, 0.00100541696883738, 0.00099528965074569, 0.000985204358585179, 0.0009750981698744, 0.000965096929576248, 0.000955032592173666, 0.000945010397117585, 0.000935051240958273, 0.000925050000660121, 0.000915132754016668, 0.000905173539649695, 0.000895256409421563, 0.00088540225988254, 0.000875485071446747, 0.000865672947838902, 0.00085581885650754, 0.000845985661726445, 0.00083623657701537, 0.000826424453407526, 0.000816717394627631, 0.000806947296950966, 0.000797219225205481, 0.000787554192356765, 0.000777847075369209, 0.000768245139624923, 0.000758580048568547, 0.000748957041651011, 0.000739397015422583, 0.000729774066712707, 0.000720214040484279, 0.000710696098394692, 0.000701178039889783, 0.000691681168973446, 0.000682205194607377, 0.000672750233206898, 0.000663316284772009, 0.00065390340751037, 0.00064449047204107, 0.000635119620710611, 0.000625727698206902, 0.000616419827565551, 0.0006071119569242, 0.000597762118559331, 0.000588517286814749, 0.000579230429138988, 0.000570027623325586, 0.000560782791581005, 0.000551579985767603, 0.00054244021885097, 0.000533237413037568, 0.000524139672052115, 0.000514978833962232, 0.000505881092976779, 0.000496825436130166, 0.000487727666040882, 0.000478734931675717, 0.000469679187517613, 0.00046066552749835, 0.000451714819064364, 0.00044272214290686, 0.000433834502473474, 0.000424862839281559, 0.000415975169744343, 0.000407108542276546, 0.00039822090184316, 0.000389375287340954, 0.000380550685804337, 0.00037174709723331, 0.000363006518455222, 0.000354202929884195, 0.000345462351106107, 0.000336742814397439, 0.000328023277688771, 0.000319345737807453, 0.000310668197926134, 0.000302032683975995, 0.000293418182991445, 0.000284803711110726, 0.000276210223091766, 0.000267658731900156, 0.000259065243881196, 0.000250576849794015, 0.000242067399085499, 0.000233536920859478, 0.000225111522013322, 0.0002166441117879, 0.000208260738872923, 0.000199814327061176, 0.000191409941180609, 0.000183089592610486, 0.000174706219695508, 0.000166406884090975, 0.000158065537107177, 0.000149787199916318, 0.000141529890242964, 0.00013325156760402, 0.00012505728227552, 0.000116821000119671, 0.000108626714791171, 0.000100495468359441, 9.23011903068982e-05, 8.41699438751675e-05, 7.60807233746164e-05, 6.79704899084754e-05, 5.99442937527783e-05, 5.18550732522272e-05, 4.38288843724877e-05, 3.58237011823803e-05, 2.78185252682306e-05, 1.98553661903134e-05, 1.18922089313855e-05, 3.95006236431072e-06, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 1.79565330872989e-15, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 0.00198361813090742, 7.31181808077963e-06, 1.52749762492022e-05, 2.32171223615296e-05, 3.11802796204574e-05, 3.92274814657867e-05, 4.72116516903043e-05, 5.52378405700438e-05, 6.33270610705949e-05, 7.1395275881514e-05, 7.95055093476549e-05, 8.76157428137958e-05, 9.57469965214841e-05, 0.000103941267298069, 0.000112093526695389, 0.000120308810437564, 0.000128524101455696, 0.00013673938519787, 0.000145038735354319, 0.000153296045027673, 0.000161616379045881, 0.000169915714650415, 0.000178236048668623, 0.000186619436135516, 0.000194981796084903, 0.000203365183551796, 0.000211790582397953, 0.00022021598124411, 0.000228704418987036, 0.000237171814660542, 0.000245639268541709, 0.000254190701525658, 0.000262700137682259, 0.000271293625701219, 0.00027984511689283, 0.000288417562842369, 0.000297074089758098, 0.000305688590742648, 0.000314366130623966, 0.000323022657539696, 0.000331700197421014, 0.000340440747095272, 0.00034916031290777, 0.000357879849616438, 0.000366683467291296, 0.000375466042896733, 0.000384290644433349, 0.000393115245969966, 0.000401960860472172, 0.000410848500905558, 0.000419715128373355, 0.00042866580770351, 0.000437574461102486, 0.000446525140432641, 0.000455517845693976, 0.00046448950888589, 0.000473524210974574, 0.000482537900097668, 0.000491572602186352, 0.000500670401379466, 0.00050974718760699, 0.000518865883350372, 0.000527984695509076, 0.000537124462425709, 0.000546327268239111, 0.000555488048121333, 0.000564669840969145, 0.000573935685679317, 0.000583159446250647, 0.000592467316891998, 0.000601733161602169, 0.00061102001927793, 0.000620369915850461, 0.000629698799457401, 0.00063909066375345, 0.00064848258625716, 0.00065785349579528, 0.000667308398988098, 0.000676742289215326, 0.000686197308823466, 0.000695694179739803, 0.000705191167071462, 0.00071475119329989, 0.000724269135389477, 0.000733808148652315, 0.000743431155569851, 0.000753012136556208, 0.000762656156439334, 0.00077230017632246, 0.000781944254413247, 0.000791651313193142, 0.000801337417215109, 0.000811086501926184, 0.000820814515464008, 0.000830563600175083, 0.000840375723782927, 0.000850145879667252, 0.000859999970998615, 0.000869812094606459, 0.000879666302353144, 0.000889583490788937, 0.00089945865329355, 0.000909375725314021, 0.000919335056096315, 0.000929273141082376, 0.000939295336138457, 0.00094927562167868, 0.000959276861976832, 0.000969341024756432, 0.000979384290985763, 0.000989490537904203, 0.000999575830064714, 0.00100968219339848, 0.0010198304662481, 0.00102997885551304, 0.00104018999263644, 0.00105038040783256, 0.00106057070661336, 0.00107082410249859, 0.00108107749838382, 0.00109133077785373, 0.00110164715442806, 0.00111194257624447, 0.00112232193350792, 0.00113265938125551, 0.00114301778376102, 0.00115343916695565, 0.00116383971180767, 0.00117430312093347, 0.0011847245041281, 0.00119520898442715, 0.00120571453589946, 0.00121621997095644, 0.00122676754835993, 0.00123731500934809, 0.00124788354150951, 0.00125849398318678, 0.00126908358652145, 0.00127971509937197, 0.00129038875456899, 0.00130104122217745, 0.00131177785806358, 0.00132247246801853, 0.00133318803273141, 0.00134394562337548, 0.00135470321401954, 0.00136554485652596, 0.00137632363475859, 0.00138714432250708, 0.00139802787452936, 0.0014088696334511, 0.00141979521140456, 0.00143069995101541, 0.00144160457421094, 0.0014525722945109, 0.00146351906005293, 0.00147450785152614, 0.00148553866893053, 0.00149654829874635, 0.00150762114208192, 0.00151867291424423, 0.00152974564116448, 0.00154088146518916, 0.00155199633445591, 0.00156317418441176, 0.00157433096319437, 0.0015854878583923, 0.00159672868903726, 0.00160792749375105, 0.00161921035032719, 0.00163045129738748, 0.00164173415396363, 0.00165305903647095, 0.0016643840353936, 0.00167570891790092, 0.00168709678109735, 0.00169846380595118, 0.00170989369507879, 0.0017213027458638, 0.00173273275140673, 0.00174422562122345, 0.00175569765269756, 0.00176723266486079, 0.00177874672226608, 0.00179026077967137, 0.00180185888893902, 0.00181341485586017, 0.00182505487464368, 0.00183665298391134, 0.00184829311911017, 0.00185997516382486, 0.00187163613736629, 0.00188331818208098, 0.00189508439507335, 0.00190680858213454, 0.00191859563346952, 0.00193034089170396, 0.00194212794303894, 0.00195397832430899, 0.00196580728515983, 0.00197769957594573, 0.00198839418590069, 0.00199793302454054, 0.00200752471573651, 0.00201711617410183, 0.00202673906460404, 0.00203641480766237, 0.00204607984051108, 0.00205579726025462, 0.00206551467999816, 0.00207526376470923, 0.00208503380417824, 0.00209484645165503, 0.00210466887801886, 0.00211451225914061, 0.00212436681613326, 0.00213427329435945, 0.00214421143755317, 0.0021541602909565, 0.00216412986628711, 0.00217409967444837, 0.00218414282426238, 0.00219417549669743, 0.00220427149906754, 0.00221435655839741, 0.00222445232793689, 0.00223461119458079, 0.00224478053860366, 0.00225497083738446, 0.00226520304568112, 0.00227542500942945, 0.00228569936007261, 0.00229597371071577, 0.00230629020370543, 0.00231665908358991, 0.00232699629850686, 0.00233740732073784, 0.00234779715538025, 0.00235825008712709, 0.00236871372908354, 0.00237917737103999, 0.00238971412181854, 0.00240021967329085, 0.00241079856641591, 0.00242138840258121, 0.0024319882504642, 0.00244263024069369, 0.00245327246375382, 0.0024639458861202, 0.00247468263842165, 0.0024854086805135, 0.00249614543281496, 0.00250693433918059, 0.00251772347837687, 0.00252858619205654, 0.00253942795097828, 0.00255029066465795, 0.00256120599806309, 0.0025721313431859, 0.00258307787589729, 0.00259406678378582, 0.00260505545884371, 0.00261608650907874, 0.00262712780386209, 0.00263821077533066, 0.00264929421246052, 0.00266043026931584, 0.00267157633788884, 0.00268274359405041, 0.00269392156042159, 0.00270516239106655, 0.00271640322171152, 0.00272768596187234, 0.00273897941224277, 0.00275027309544384, 0.00276162941008806, 0.00277297524735332, 0.00278441584669054, 0.00279582478106022, 0.00280724419280887, 0.00281871622428298, 0.00283018802292645, 0.00284174410626292, 0.00285327923484147, 0.00286481413058937, 0.00287641235627234, 0.00288801034912467, 0.00289964000694454, 0.00291133252903819, 0.00292300432920456, 0.00293472828343511, 0.00294644199311733, 0.00295819761231542, 0.00296998443081975, 0.00298180337995291, 0.00299366400577128, 0.00300549319945276, 0.0030173750128597, 0.00302927778102458, 0.00304122245870531, 0.00305318809114397, 0.00306515395641327, 0.00307714054360986, 0.00308917998336256, 0.00310125085525215, 0.00311332149431109, 0.00312542379833758, 0.00313754705712199, 0.00314970198087394, 0.00316185667179525, 0.00317406398244202, 0.00318631366826594, 0.0031985524110496, 0.00321083329617977, 0.00322312489151955, 0.00323544768616557, 0.00324780214577913, 0.00326016708277166, 0.00327257416211069, 0.00328499148599803, 0.00329741952009499, 0.00330991065129638, 0.00332240154966712, 0.00333489268086851, 0.00334745738655329, 0.00336003233678639, 0.00337263895198703, 0.00338524556718767, 0.00339786265976727, 0.00341055309399962, 0.00342323328368366, 0.00343596609309316, 0.0034486879594624, 0.00346144172362983, 0.00347424810752273, 0.00348704354837537, 0.00349991279654205, 0.0035127610899508, 0.00352564081549644, 0.00353856245055795, 0.00355147360824049, 0.00356445857323706, 0.00357743282802403, 0.00359044899232686, 0.0036034865770489, 0.00361652346327901, 0.00362960295751691, 0.00364273460581899, 0.00365585647523403, 0.00366901978850365, 0.00368218310177326, 0.00369537761434913, 0.00370861496776342, 0.00372188305482268, 0.00373518303968012, 0.00374845135957003, 0.00376177253201604, 0.00377513538114727, 0.00378851965069771, 0.00380192487500608, 0.00381533987820148, 0.00382878701202571, 0.00384226534515619, 0.00385575462132692, 0.00386927532963455, 0.00388283771462739, 0.00389640033245087, 0.00391000462695956, 0.00392362009733915, 0.00393726630136371, 0.00395095534622669, 0.00396463321521878, 0.00397836370393634, 0.00399209465831518, 0.00400584656745195, 0.00401967205107212, 0.00403346493840218, 0.00404731137678027, 0.00406118901446462, 0.00407505687326193, 0.00408897642046213, 0.00410292809829116, 0.00411688955500722, 0.00413088267669082, 0.0041448762640357, 0.00415893271565437, 0.00417299894616008, 0.00418707681819797, 0.00420120637863874, 0.0042153256945312, 0.00422948691993952, 0.00424365932121873, 0.00425788341090083, 0.00427212892100215, 0.00428637443110347, 0.00430066185072064, 0.00431495998054743, 0.00432930001989007, 0.00434365030378103, 0.00435802154242992, 0.00437242491170764, 0.0043868594802916, 0.00440132571384311, 0.00441580172628164, 0.00443029962480068, 0.00444482872262597, 0.00445937877520919, 0.00447397120296955, 0.00448856316506863, 0.00450318679213524, 0.00451784208416939, 0.00453250762075186, 0.00454722531139851, 0.00456193322315812, 0.00457669328898191, 0.0045914645306766, 0.00460624555125833, 0.00462108943611383, 0.00463593378663063, 0.00465079862624407, 0.00466567510738969, 0.00468059256672859, 0.00469555240124464, 0.0047105229459703, 0.00472552515566349, 0.00474052643403411, 0.00475555984303355, 0.00477063562721014, 0.00478571048006415, 0.00480084912851453, 0.00481597660109401, 0.00483114644885063, 0.00484633771702647, 0.00486153969541192, 0.00487679336220026, 0.0048920470289886, 0.00490734307095408, 0.0049226600676775, 0.00493797706440091, 0.00495332572609186, 0.00496872654184699, 0.00498414877802134, 0.00499957101419568, 0.00501501373946667, 0.00503050955012441, 0.00504602631554008, 0.00506156357005239, 0.00507710129022598, 0.00509268091991544, 0.00510829221457243, 0.00512391375377774, 0.00513958791270852, 0.00515524111688137, 0.00517095718532801, 0.00518669420853257, 0.00520243216305971, 0.00521822180598974, 0.00523401098325849, 0.00524985371157527, 0.00526568526402116, 0.00528156943619251, 0.00529745360836387, 0.00531339040026069, 0.00532933790236712, 0.00534530682489276, 0.00536130648106337, 0.0053773270919919, 0.00539336865767837, 0.00540945259854198, 0.00542553653940558, 0.00544165167957544, 0.00545780919492245, 0.00547395693138242, 0.00549017731100321, 0.00550637627020478, 0.00552262831479311, 0.00553889106959105, 0.00555517431348562, 0.00557149993255734, 0.00558784604072571, 0.00560420379042625, 0.00562059180811048, 0.0056370017118752, 0.00565344281494617, 0.0056699151173234, 0.00568639812991023, 0.00570290256291628, 0.00571943819522858, 0.0057359947822988, 0.00575259327888489, 0.00576920248568058, 0.00578583311289549, 0.00580249447375536, 0.00581916701048613, 0.00583590194582939, 0.00585262663662434, 0.00586938299238682, 0.00588614959269762, 0.00590294785797596, 0.00591979874297976, 0.00593666033819318, 0.00595353171229362, 0.00597042450681329, 0.0059873596765101, 0.00600431486964226, 0.00602130265906453, 0.0060382904484868, 0.00605530897155404, 0.00607234891504049, 0.0060894307680428, 0.00610655453056097, 0.0061236578039825, 0.0061408132314682, 0.00615797890350223, 0.00617517670616508, 0.00619239499792457, 0.00620964495465159, 0.00622691633179784, 0.00624421844258904, 0.00626153172925115, 0.00627887574955821, 0.00629626261070371, 0.00631365971639752, 0.00633105635643005, 0.0063484855927527, 0.00636595580726862, 0.00638345815241337, 0.00640099216252565, 0.00641852570697665, 0.00643606949597597, 0.00645366637036204, 0.00647127348929644, 0.0064889332279563, 0.00650658272206783, 0.00652427366003394, 0.00654198601841927, 0.00655971933156252, 0.00657748430967331, 0.00659526977688074, 0.00661307666450739, 0.00663091475144029, 0.0066487742587924, 0.00666664401069283, 0.00668454542756081, 0.00670249946415424, 0.00672045303508639, 0.00673842802643776, 0.00675642443820834, 0.00677446182817221, 0.0067925313487649, 0.00681061111390591, 0.00682870158925653, 0.00684681348502636, 0.00686496635898948, 0.00688316253945231, 0.00690136849880219, 0.00691958423703909, 0.00693783303722739, 0.00695611210539937, 0.00697441305965185, 0.0069927554577589, 0.00701108761131763, 0.00702946214005351, 0.00704785669222474, 0.0070662833750248, 0.00708471005782485, 0.00710319960489869, 0.00712169986218214, 0.00714022107422352, 0.00715875253081322, 0.00717730540782213, 0.00719593185931444, 0.00721453689038754, 0.00723318429663777, 0.00725183123722672, 0.00727053033187985, 0.0072892727330327, 0.00730801466852427, 0.00732675660401583, 0.00734553998336196, 0.00736436620354652, 0.00738320220261812, 0.00740208057686687, 0.00742095895111561, 0.00743985828012228, 0.00745881022885442, 0.00747777242213488, 0.00749675603583455, 0.00751576013863087, 0.00753479683771729, 0.00755386427044868, 0.00757295219227672, 0.00759205175563693, 0.00761119276285172, 0.00763034308329225, 0.00764952646568418, 0.00766873080283403, 0.00768795562908053, 0.00770722283050418, 0.00772648956626654, 0.00774579960852861, 0.00776512920856476, 0.00778448069468141, 0.00780386244878173, 0.00782326608896255, 0.00784265995025635, 0.0078621469438076, 0.00788161344826221, 0.00790113303810358, 0.00792064238339663, 0.00794017128646374, 0.0079597532749176, 0.00797934643924236, 0.00799896102398634, 0.00801863707602024, 0.00803830288350582, 0.0080579798668623, 0.00807772018015385, 0.00809745024889708, 0.00811721011996269, 0.00813702307641506, 0.00815683603286743, 0.00817668158560991, 0.00819653645157814, 0.0082164341583848, 0.00823637377470732, 0.00825629197061062, 0.00827625300735235, 0.00829624384641647, 0.00831624679267406, 0.00833629071712494, 0.00835636723786592, 0.00837645400315523, 0.00839655101299286, 0.00841670017689466, 0.00843684002757072, 0.0084570525214076, 0.00847725383937359, 0.00849748775362968, 0.00851775333285332, 0.0085380282253027, 0.00855835620313883, 0.00857867393642664, 0.00859903357923031, 0.00861942488700151, 0.00863981619477272, 0.00866024941205978, 0.00868069287389517, 0.00870117917656898, 0.00872169621288776, 0.00874222349375486, 0.00876276101917028, 0.00878335256129503, 0.00880395341664553, 0.00882458593696356, 0.00884521938860416, 0.00886590499430895, 0.00888661108911037, 0.00890733767300844, 0.00892809592187405, 0.00894884578883648, 0.00896964594721794, 0.00899047777056694, 0.00901133194565773, 0.00903219543397427, 0.00905309151858091, 0.00907401740550995, 0.00909495539963245, 0.0091159250587225, 0.00913693569600582, 0.00915793608874083, 0.00917897839099169, 0.00920006260275841, 0.00922112725675106, 0.00924225244671106, 0.00926339998841286, 0.00928456895053387, 0.00930576957762241, 0.00932695902884007, 0.00934820063412189, 0.00936947483569384, 0.00939076952636242, 0.00941208470612764, 0.00943341106176376, 0.00945476721972227, 0.00947616808116436, 0.0094975782558322, 0.00951900891959667, 0.00954046100378036, 0.00956195592880249, 0.00958346016705036, 0.00960499700158834, 0.00962654408067465, 0.00964813306927681, 0.00966974254697561, 0.00969137251377106, 0.00971302483230829, 0.00973469763994217, 0.0097564123570919, 0.00977814849466085, 0.00979987345635891, 0.00982167292386293, 0.00984347146004438, 0.00986529048532248, 0.00988715328276157, 0.0099090151488781, 0.00993089750409126, 0.0099528543651104, 0.00997478980571032, 0.00999677740037441, 0.0100187556818128, 0.0100407740101218, 0.0100628463551402, 0.0100849084556103, 0.0101070012897253, 0.0101291257888079, 0.0101512614637613, 0.0101734269410372, 0.0101956259459257, 0.0102178556844592, 0.0102400854229927, 0.0102623570710421, 0.0102846482768655, 0.0103069730103016, 0.010329307988286, 0.0103516634553671, 0.0103740720078349, 0.0103964796289802, 0.0104189198464155, 0.0104413907974958, 0.0104638617485762, 0.0104863857850432, 0.0105089200660586, 0.0105314757674932, 0.0105540733784437, 0.0105766812339425, 0.0105993095785379, 0.0106219798326492, 0.0106446510180831, 0.0106673743575811, 0.0106900976970792, 0.0107128638774157, 0.0107356393709779, 0.0107584353536367, 0.0107812853530049, 0.0108041344210505, 0.0108270160853863, 0.0108499275520444, 0.010872851125896, 0.0108958063647151, 0.0109187811613083, 0.0109417978674173, 0.0109648164361715, 0.0109878657385707, 0.0110109355300665, 0.0110340369865298, 0.0110571598634124, 0.0110803237184882, 0.0111034987494349, 0.0111266952008009, 0.0111499233171344, 0.0111731616780162, 0.0111964410170913, 0.0112197315320373, 0.0112430537119508, 0.0112663973122835, 0.0112897614017129, 0.0113131674006581, 0.0113365733996034, 0.0113600324839354, 0.0113834915682673, 0.0114069813862443, 0.0114305028691888, 0.0114540355280042, 0.011477611027658, 0.0115012051537633, 0.0115248113870621, 0.0115484585985541, 0.0115721179172397, 0.0115958070382476, 0.011619527824223, 0.011643260717392, 0.0116669926792383, 0.0116908177733421, 0.0117146354168653, 0.0117384605109692, 0.0117623088881373, 0.0117861870676279, 0.0118101090192795, 0.0118340402841568, 0.0118579929694533, 0.0118819763883948, 0.0119059812277555, 0.0119300074875355, 0.0119540756568313, 0.0119781326502562, 0.0120022436603904, 0.0120263956487179, 0.0120505373924971, 0.0120747210457921, 0.0120989046990871, 0.012123130261898, 0.0121474089100957, 0.0121716754510999, 0.0121959643438458, 0.0122202839702368, 0.0122446473687887, 0.0122690191492438, 0.0122934235259891, 0.0123178381472826, 0.0123422844335437, 0.0123667633160949, 0.0123912515118718, 0.0124157816171646, 0.0124403219670057, 0.0124648939818144, 0.0124894976615906, 0.0125141134485602, 0.0125387590378523, 0.0125634148716927, 0.0125881135463715, 0.0126128438860178, 0.0126375630497932, 0.0126623446121812, 0.0126871271058917, 0.0127119412645698, 0.0127367973327637, 0.0127616422250867, 0.0127865308895707, 0.012811460532248, 0.0128363994881511, 0.0128613505512476, 0.0128863323479891, 0.0129113458096981, 0.0129363909363747, 0.0129614463075995, 0.0129865435883403, 0.0130116315558553, 0.0130367716774344, 0.013061941601336, 0.0130871133878827, 0.0131123261526227, 0.0131375612691045, 0.0131628159433603, 0.0131880920380354, 0.013213399797678, 0.0132387392222881, 0.0132640786468983, 0.0132894599810243, 0.0133148618042469, 0.0133402952924371, 0.0133657502010465, 0.0133912255987525, 0.0134167326614261, 0.0134422508999705, 0.0134678008034825, 0.0134933814406395, 0.0135189723223448, 0.0135445846244693, 0.0135702509433031, 0.0135959153994918, 0.0136216105893254, 0.0136473495513201, 0.0136730773374438, 0.0136988582089543, 0.0137246381491423, 0.0137504609301686, 0.0137763153761625, 0.0138021791353822, 0.0138280652463436, 0.0138539830222726, 0.0138799296692014, 0.0139059005305171, 0.0139318909496069, 0.0139579018577933, 0.0139839462935925, 0.0140100093558431, 0.0140360835939646, 0.0140622220933437, 0.014088349416852, 0.0141144972294569, 0.0141406981274486, 0.0141668980941176, 0.0141931194812059, 0.0142194153741002, 0.0142456796020269, 0.0142720062285662, 0.0142983319237828, 0.014324669726193, 0.0143510811030865, 0.0143774598836899, 0.0144039029255509, 0.0144303655251861, 0.0144568402320147, 0.0144833233207464, 0.0145098716020584, 0.0145364282652736, 0.0145630184561014, 0.0145896077156067, 0.0146162277087569, 0.0146428914740682, 0.0146695747971535, 0.0146962702274323, 0.0147229852154851, 0.0147497439756989, 0.0147765222936869, 0.0148033201694489, 0.0148301413282752, 0.0148569820448756, 0.014883866533637, 0.0149107705801725, 0.0149376960471272, 0.014964621514082, 0.0149915991351008, 0.0150185879319906, 0.0150456307455897, 0.0150726605206728, 0.0150997210294008, 0.0151268159970641, 0.0151539519429207, 0.0151810767129064, 0.0152082433924079, 0.0152354324236512, 0.0152626521885395, 0.0152899045497179, 0.015317153185606, 0.0153444483876228, 0.0153717622160912, 0.0153991086408496, 0.0154264736920595, 0.0154538406059146, 0.0154812606051564, 0.0155087010934949, 0.0155361732468009, 0.0155636565759778, 0.0155911482870579, 0.015618703328073, 0.0156462490558624, 0.0156738366931677, 0.0157014448195696, 0.0157290641218424, 0.0157567355781794, 0.0157844070345163, 0.0158121101558208, 0.0158398430794477, 0.0158675983548164, 0.0158953871577978, 0.0159231964498758, 0.0159510131925344, 0.0159788746386766, 0.0160067453980446, 0.0160346459597349, 0.0160625819116831, 0.0160905160009861, 0.0161185022443533, 0.0161464884877205, 0.0161745082587004, 0.0162025671452284, 0.0162306390702724, 0.016258729621768, 0.016286863014102, 0.016315009444952, 0.0163431819528341, 0.0163713693618774, 0.0163995865732431, 0.0164278354495764, 0.0164561066776514, 0.0164843760430813, 0.0165127106010914, 0.0165410544723272, 0.0165694206953049, 0.0165978036820889, 0.0166262220591307, 0.016654659062624, 0.0166831314563751, 0.0167116094380617, 0.0167401432991028, 0.016768665984273, 0.0167972296476364, 0.0168258268386126, 0.0168544333428144, 0.016883060336113, 0.0169117283076048, 0.0169404093176126, 0.0169691108167171, 0.0169978532940149, 0.0170266181230545, 0.0170554034411907, 0.0170842092484236, 0.0171130262315273, 0.017141904681921, 0.0171707738190889, 0.017199695110321, 0.0172286182641983, 0.0172575581818819, 0.01728655397892, 0.0173155497759581, 0.0173445977270603, 0.0173736233264208, 0.0174027029424906, 0.0174318142235279, 0.0174609366804361, 0.0174901094287634, 0.017519261687994, 0.0175484549254179, 0.0175776947289705, 0.0176069419831038, 0.0176361985504627, 0.017665509134531, 0.0176948308944702, 0.0177241824567318, 0.0177535563707352, 0.0177829302847385, 0.0178123638033867, 0.0178418103605509, 0.0178712904453278, 0.0179007686674595, 0.0179302878677845, 0.0179598312824965, 0.0179894026368856, 0.0180190075188875, 0.0180486012250185, 0.0180782489478588, 0.0181079152971506, 0.0181376039981842, 0.0181673038750887, 0.0181970559060574, 0.0182268172502518, 0.0182566214352846, 0.0182864256203175, 0.0183162502944469, 0.0183461271226406, 0.0183760151267052, 0.0184059254825115, 0.0184358451515436, 0.0184658076614141, 0.0184957999736071, 0.0185258146375418, 0.0185558497905731, 0.0185858942568302, 0.0186159722507, 0.0186460912227631, 0.0186762195080519, 0.018706351518631, 0.0187365524470806, 0.0187667459249496, 0.0187969617545605, 0.0188272371888161, 0.0188574939966202, 0.0188878104090691, 0.018918139860034, 0.0189484693109989, 0.0189788620918989, 0.0190092660486698, 0.0190396700054407, 0.0190701335668564, 0.0191006101667881, 0.0191310979425907, 0.0191616266965866, 0.0191921535879374, 0.0192227251827717, 0.0192533284425735, 0.0192839428782463, 0.0193146057426929, 0.0193452723324299, 0.0193759612739086, 0.0194066893309355, 0.0194374285638332, 0.0194681864231825, 0.0194989778101444, 0.0195297915488482, 0.0195606239140034, 0.0195915009826422, 0.0196223855018616, 0.0196533259004354, 0.0196842420846224, 0.019715191796422, 0.0197461917996407, 0.0197772048413754, 0.0198082495480776, 0.0198393035680056, 0.0198703892529011, 0.0199015066027641, 0.0199326351284981, 0.0199638027697802, 0.0199949834495783, 0.0200261864811182, 0.0200574286282063, 0.0200886838138103, 0.0201199483126402, 0.02015127427876, 0.0201826021075249, 0.0202139597386122, 0.0202453304082155, 0.0202767327427864, 0.0203081741929054, 0.0203396286815405, 0.0203710906207561, 0.0204025972634554, 0.0204341243952513, 0.0204656831920147, 0.0204972624778748, 0.0205288622528315, 0.02056048437953, 0.0205921269953251, 0.0206238124519587, 0.020655507221818, 0.020687211304903, 0.0207189712673426, 0.0207507386803627, 0.0207825396209955, 0.0208143480122089, 0.0208462011069059, 0.0208780765533447, 0.020909970626235, 0.0209418963640928, 0.0209738221019506, 0.0210058018565178, 0.0210377909243107, 0.0210698116570711, 0.0211018528789282, 0.0211339145898819, 0.0211660005152225, 0.0211981367319822, 0.0212302729487419, 0.0212624296545982, 0.0212946068495512, 0.0213268175721169, 0.0213590692728758, 0.0213913191109896, 0.021423602476716, 0.0214559305459261, 0.021488256752491, 0.0215206015855074, 0.0215530004352331, 0.0215853992849588, 0.0216178186237812, 0.0216502919793129, 0.0216827653348446, 0.0217152778059244, 0.0217478144913912, 0.0217803604900837, 0.0218129567801952, 0.0218455363065004, 0.0218781661242247, 0.0219108387827873, 0.02194351144135, 0.0219761934131384, 0.0220089294016361, 0.0220416840165854, 0.0220744721591473, 0.0221072696149349, 0.0221400801092386, 0.0221729390323162, 0.0222058016806841, 0.0222387034446001, 0.0222716275602579, 0.0223045721650124, 0.0223375391215086, 0.0223705470561981, 0.0224035568535328, 0.0224366169422865, 0.0224696882069111, 0.0225027706474066, 0.0225358922034502, 0.022569028660655, 0.0226022023707628, 0.0226354002952576, 0.0226686093956232, 0.022701857611537, 0.0227351095527411, 0.0227684006094933, 0.0228017345070839, 0.0228350684046745, 0.0228684227913618, 0.0229018200188875, 0.0229352284222841, 0.0229686684906483, 0.0230021364986897, 0.0230356175452471, 0.0230691209435463, 0.0231026541441679, 0.0231362301856279, 0.0231697931885719, 0.0232034232467413, 0.0232370514422655, 0.0232707094401121, 0.0233043897897005, 0.0233380924910307, 0.0233718231320381, 0.0234055910259485, 0.0234393645077944, 0.023473160341382, 0.0235069897025824, 0.0235408376902342, 0.0235747378319502, 0.0236086398363113, 0.0236425623297691, 0.0236765071749687, 0.0237104799598455, 0.0237444862723351, 0.0237811580300331, 0.0238206051290035, 0.02386006526649, 0.0238995458930731, 0.0239390451461077, 0.023978577926755, 0.0240181405097246, 0.0240577049553394, 0.0240972992032766, 0.0241369251161814, 0.0241765752434731, 0.0242162309587002, 0.0242559313774109, 0.0242956429719925, 0.0243353955447674, 0.0243751388043165, 0.0244149230420589, 0.024454727768898, 0.0244945548474789, 0.0245344024151564, 0.0245742909610271, 0.024614168331027, 0.0246540904045105, 0.0246940534561872, 0.0247340146452188, 0.0247740000486374, 0.0248140152543783, 0.0248540416359901, 0.0248941294848919, 0.0249341875314713, 0.0249742977321148, 0.0250144395977259, 0.0250545814633369, 0.0250947419553995, 0.0251349676400423, 0.0251751840114594, 0.0252154190093279, 0.0252556968480349, 0.0252959839999676, 0.0253363158553839, 0.0253766365349293, 0.025416998192668, 0.0254573803395033, 0.0254977848380804, 0.0255382098257542, 0.0255786776542664, 0.0256191436201334, 0.025659654289484, 0.0257001724094152, 0.0257407147437334, 0.025781286880374, 0.0258218795061111, 0.0258624833077192, 0.0259031299501657, 0.0259437840431929, 0.0259844828397036, 0.0260251816362143, 0.0260658990591764, 0.026106683537364, 0.0261474438011646, 0.0261882599443197, 0.0262290723621845, 0.0262699164450169, 0.0263107940554619, 0.0263516809791327, 0.0263926014304161, 0.0264335386455059, 0.0264745019376278, 0.0265154931694269, 0.0265564862638712, 0.0265975296497345, 0.0266385860741138, 0.0266796518117189, 0.0267207603901625, 0.0267618782818317, 0.0268030073493719, 0.0268441997468472, 0.0268853921443224, 0.0269266162067652, 0.0269678495824337, 0.027009092271328, 0.0270504020154476, 0.0270917098969221, 0.027133047580719, 0.0271743983030319, 0.0272157769650221, 0.0272571817040443, 0.0272986032068729, 0.0273400489240885, 0.0273815244436264, 0.0274229999631643, 0.0274645369499922, 0.0275060553103685, 0.0275476481765509, 0.0275892149657011, 0.0276308283209801, 0.0276724621653557, 0.0277141164988279, 0.0277557801455259, 0.0277974996715784, 0.0278392154723406, 0.0278809759765863, 0.0279227364808321, 0.027964536100626, 0.0280063599348068, 0.0280481912195683, 0.0280900448560715, 0.028131952509284, 0.0281738471239805, 0.0282157734036446, 0.0282577555626631, 0.0282997116446495, 0.0283417254686356, 0.0283837467432022, 0.0284257791936398, 0.0284678637981415, 0.0285099595785141, 0.0285520646721125, 0.0285942256450653, 0.0286363735795021, 0.0286785513162613, 0.0287207737565041, 0.0287630166858435, 0.0288052465766668, 0.0288475509732962, 0.0288898386061192, 0.0289321858435869, 0.0289745349436998, 0.0290168896317482, 0.0290592908859253, 0.0291017014533281, 0.0291441436856985, 0.0291866194456816, 0.0292291026562452, 0.0292716175317764, 0.0293141435831785, 0.0293567031621933, 0.0293992888182402, 0.0294418800622225, 0.0294845141470432, 0.02952716127038, 0.0295698363333941, 0.0296125318855047, 0.0296552535146475, 0.029697984457016, 0.0297407619655132, 0.0297835394740105, 0.029826370999217, 0.0298691894859076, 0.0299120415002108, 0.0299549363553524, 0.0299978293478489, 0.0300407651811838, 0.0300837140530348, 0.0301266890019178, 0.030169690027833, 0.0302127115428448, 0.0302557274699211, 0.0302988197654486, 0.0303418915718794, 0.0303850192576647, 0.0304281562566757, 0.0304713007062674, 0.0305144879966974, 0.0305576901882887, 0.0306009277701378, 0.0306441709399223, 0.0306874345988035, 0.0307307466864586, 0.0307740513235331, 0.0308174248784781, 0.0308607704937458, 0.030904171988368, 0.0309475790709257, 0.03099100664258, 0.0310344789177179, 0.031077953055501, 0.0311214663088322, 0.0311649870127439, 0.031208535656333, 0.0312521047890186, 0.031295720487833, 0.0313393287360668, 0.0313829891383648, 0.0314266383647919, 0.0314703322947025, 0.0315140411257744, 0.0315577797591686, 0.0316015556454659, 0.0316453315317631, 0.0316891297698021, 0.0317329578101635, 0.0317768082022667, 0.0318206772208214, 0.0318645834922791, 0.0319085046648979, 0.0319524295628071, 0.0319964252412319, 0.0320404097437859, 0.0320843979716301, 0.03212845697999, 0.0321725085377693, 0.0322166010737419, 0.0322607010602951, 0.0323048233985901, 0.0323489867150784, 0.0323931537568569, 0.0324373356997967, 0.0324815884232521, 0.0325258187949657, 0.0325700752437115, 0.0326143801212311, 0.0326586812734604, 0.0327030122280121, 0.0327473916113377, 0.0327917635440826, 0.0328361764550209, 0.0328806079924107, 0.032925046980381, 0.0329695232212543, 0.0330140292644501, 0.033058550208807, 0.0331031046807766, 0.0331476777791977, 0.0331922620534897, 0.0332368835806847, 0.0332815200090408, 0.0333261899650097, 0.0333708599209785, 0.0334155820310116, 0.0334602892398834, 0.0335050560534, 0.0335498303174973, 0.033594623208046, 0.0336394645273685, 0.0336842983961105, 0.0337291546165943, 0.0337740704417229, 0.0338189713656902, 0.0338639244437218, 0.033908873796463, 0.0339538492262363, 0.033998865634203, 0.0340438932180405, 0.0340889506042004, 0.0341340377926826, 0.0341791287064552, 0.0342242494225502, 0.0342694036662579, 0.0343145653605461, 0.0343597680330276, 0.0344049632549286, 0.0344502218067646, 0.0344954766333103, 0.034540768712759, 0.0345860794186592, 0.0346314013004303, 0.0346767529845238, 0.0347221456468105, 0.0347675308585167, 0.034812968224287, 0.0348584055900574, 0.0349038690328598, 0.0349493585526943, 0.0349948816001415, 0.0350404195487499, 0.035085991024971, 0.0351315625011921, 0.0351771824061871, 0.0352228246629238, 0.0352684706449509, 0.0353141389787197, 0.0353598482906818, 0.0354055799543858, 0.0354513078927994, 0.0354971028864384, 0.0355428792536259, 0.0355887115001678, 0.0356345362961292, 0.0356803946197033, 0.0357262901961803, 0.0357721969485283, 0.0358181186020374, 0.0358640924096107, 0.0359100662171841, 0.035956047475338, 0.036002092063427, 0.0360481403768063, 0.0360942147672176, 0.0361403040587902, 0.0361864231526852, 0.0362325608730316, 0.0362787321209908, 0.0363249257206917, 0.0363711304962635, 0.0364173538982868, 0.0364636182785034, 0.0365098938345909, 0.0365562029182911, 0.0366025194525719, 0.0366488620638847, 0.0366952419281006, 0.0367416366934776, 0.0367880426347256, 0.0368344932794571, 0.0368809513747692, 0.0369274467229843, 0.0369739420711994, 0.0370204858481884, 0.0370670445263386, 0.0371136255562305, 0.0371602289378643, 0.0372068397700787, 0.0372534953057766, 0.0373001806437969, 0.0373468808829784, 0.0373935960233212, 0.0374403223395348, 0.0374870933592319, 0.0375338867306709, 0.0375806875526905, 0.0376275405287743, 0.0376743860542774, 0.0377212502062321, 0.03776815533638, 0.0378150977194309, 0.0378620363771915, 0.0379090160131454, 0.0379560068249702, 0.0380030386149883, 0.0380500629544258, 0.0380971394479275, 0.0381442233920097, 0.0381913408637047, 0.0382384769618511, 0.0382856279611588, 0.0383328087627888, 0.0383800193667412, 0.0384272448718548, 0.0384744927287102, 0.0385217666625977, 0.0385690554976463, 0.0386163927614689, 0.0386637300252914, 0.0387110784649849, 0.0387584753334522, 0.0388058982789516, 0.0388533212244511, 0.0389007888734341, 0.0389482602477074, 0.0389957651495934, 0.0390432924032211, 0.0390908531844616, 0.0391384176909924, 0.0391860119998455, 0.0392336323857307, 0.0392812862992287, 0.0393289476633072, 0.0393766425549984, 0.0394243486225605, 0.0394720807671547, 0.0395198427140713, 0.0395676307380199, 0.0396154299378395, 0.03966324031353, 0.0397111251950264, 0.0397589802742004, 0.0398068837821484, 0.0398547984659672, 0.0399027466773987, 0.0399507246911526, 0.0399987027049065, 0.0400467030704021, 0.040094755589962, 0.0401427932083607, 0.040190901607275, 0.0402389951050282, 0.040287122130394, 0.0403352789580822, 0.0403834581375122, 0.0404316522181034, 0.040479876101017, 0.0405281186103821, 0.0405764020979404, 0.0406246818602085, 0.0406729876995087, 0.0407213345170021, 0.0407696925103664, 0.0408180803060532, 0.0408664755523205, 0.0409149080514908, 0.0409633591771126, 0.0410118438303471, 0.0410603359341621, 0.0411088578402996, 0.0411573834717274, 0.0412059649825096, 0.0412545502185822, 0.0413031689822674, 0.0413517989218235, 0.0414004735648632, 0.0414491407573223, 0.0414978563785553, 0.0415465794503689, 0.041595347225666, 0.0416441150009632, 0.0416929125785828, 0.0417417399585247, 0.0417905785143375, 0.0418394654989243, 0.0418883338570595, 0.0419372580945492, 0.0419861860573292, 0.0420351475477219, 0.0420841388404369, 0.0421331450343132, 0.0421821884810925, 0.042231235653162, 0.0422803051769733, 0.0423294194042683, 0.0423785224556923, 0.0424276851117611, 0.0424768403172493, 0.0425260365009308, 0.0425752587616444, 0.0426244847476482, 0.0426737479865551, 0.042723037302494, 0.0427723303437233, 0.0428216829895973, 0.0428710170090199, 0.0429204031825066, 0.0429698117077351, 0.0430192202329636, 0.0430686809122562, 0.0431181490421295, 0.0431676395237446, 0.0432171411812305, 0.043266698718071, 0.0433162525296211, 0.0433658473193645, 0.0434154458343983, 0.043465081602335, 0.0435147322714329, 0.0435644239187241, 0.0436141043901443, 0.0436638481914997, 0.0437135770916939, 0.043763343244791, 0.0438131280243397, 0.0438629686832428, 0.0439127869904041, 0.0439626649022102, 0.0440125353634357, 0.0440624579787254, 0.0441123880445957, 0.0441623404622078, 0.0442123375833035, 0.0442623235285282, 0.0443123392760754, 0.0443623997271061, 0.0444124639034271, 0.0444625690579414, 0.044512677937746, 0.0445627979934216, 0.0446129962801933, 0.0446631610393524, 0.0447133854031563, 0.0447636023163795, 0.0448138602077961, 0.0448641367256641, 0.0449144504964352, 0.044964749366045, 0.0450151227414608, 0.0450654774904251, 0.0451158843934536, 0.0451662987470627, 0.0452167242765427, 0.0452672131359577, 0.0453176833689213, 0.0453682020306587, 0.0454187318682671, 0.0454692877829075, 0.0455198585987091, 0.0455704778432846, 0.0456210896372795, 0.0456717386841774, 0.0457224175333977, 0.0457731150090694, 0.0458238162100315, 0.0458745770156384, 0.0459253303706646, 0.0459761247038841, 0.0460269302129745, 0.0460777543485165, 0.0461286120116711, 0.0461794994771481, 0.046230386942625, 0.0462813302874565, 0.0463322587311268, 0.0463832430541515, 0.0464342460036278, 0.0464852638542652, 0.0465363077819347, 0.0465873628854752, 0.0466384552419186, 0.0466895736753941, 0.0467407032847404, 0.0467918626964092, 0.0468430481851101, 0.0468942411243916, 0.0469454862177372, 0.0469967238605022, 0.0470479875802994, 0.0470992960035801, 0.0471506044268608, 0.0472019575536251, 0.04725331813097, 0.0473047010600567, 0.0473561212420464, 0.0474075376987457, 0.047459002584219, 0.0475104823708534, 0.04756198823452, 0.0476135052740574, 0.0476650707423687, 0.0477166511118412, 0.0477682314813137, 0.0478198640048504, 0.0478715039789677, 0.0479231774806976, 0.047974843531847, 0.0480265617370605, 0.0480783060193062, 0.0481300614774227, 0.0481818318367004, 0.0482336394488811, 0.0482854731380939, 0.0483373142778873, 0.0483892001211643, 0.0484410859644413, 0.0484930090606213, 0.0485449656844139, 0.048596914857626, 0.0486489199101925, 0.0487009212374687, 0.0487529560923576, 0.0488050207495689, 0.0488570928573608, 0.0489092133939266, 0.048961341381073, 0.0490134917199612, 0.0490656718611717, 0.0491178631782532, 0.0491700656712055, 0.049222320318222, 0.0492745824158192, 0.0493268929421902, 0.0493791848421097, 0.0494315139949322, 0.0494838953018188, 0.0495362728834152, 0.0495886765420437, 0.0496411100029945, 0.0496935434639454, 0.0497460290789604, 0.0497985146939754, 0.0498510599136353, 0.0499035976827145, 0.0499561578035355, 0.0500087514519691, 0.0500613711774349, 0.0501140132546425, 0.0501666553318501, 0.0502193421125412, 0.0502720475196838, 0.0503247752785683, 0.0503775328397751, 0.0504303127527237, 0.0504830926656723, 0.050535935908556, 0.0505887679755688, 0.0506416447460651, 0.050694540143013, 0.0507474392652512, 0.0508003905415535, 0.0508533455431461, 0.0509063154459, 0.0509593337774277, 0.051012359559536, 0.0510654263198376, 0.0511184856295586, 0.0511715784668922, 0.0512247048318386, 0.0512778647243977, 0.0513310208916664, 0.0513842105865479, 0.0514374412596226, 0.0514906719326973, 0.0515439249575138, 0.0515972077846527, 0.0516505241394043, 0.0517038404941559, 0.0517572201788425, 0.0518105737864971, 0.0518639832735062, 0.0519174039363861, 0.0519708469510078, 0.052024319767952, 0.0520778223872185, 0.0521313212811947, 0.0521848648786545, 0.0522384233772755, 0.0522920116782188, 0.0523456111550331, 0.0523992478847504, 0.0524528957903385, 0.0525065846741199, 0.0525602884590626, 0.0526140034198761, 0.0526677593588829, 0.05272151902318, 0.0527753196656704, 0.0528291240334511, 0.0528829731047153, 0.0529368259012699, 0.0529907196760178, 0.0530446246266365, 0.0530985482037067, 0.0531525053083897, 0.0532064847648144, 0.0532604902982712, 0.0533145107328892, 0.0533685497939587, 0.0534226298332214, 0.0534767135977745, 0.05353082716465, 0.0535849742591381, 0.0536391288042068, 0.0536933243274689, 0.0537475347518921, 0.0538017526268959, 0.0538560152053833, 0.0539102964103222, 0.0539646111428738, 0.0540189333260059, 0.054073266685009, 0.0541276559233665, 0.0541820302605629, 0.0542364567518234, 0.0542909018695354, 0.0543453507125378, 0.0543998293578625, 0.0544543564319611, 0.054508876055479, 0.0545634441077709, 0.0546180084347725, 0.0546726249158382, 0.054727241396904, 0.0547818839550018, 0.0548365488648415, 0.054891262203455, 0.0549459755420685, 0.0550007112324238, 0.0550554767251015, 0.0551102608442307, 0.0551650673151016, 0.0552199073135853, 0.0552747622132301, 0.0553296394646168, 0.0553845427930355, 0.055439468473196, 0.0554944239556789, 0.0555493868887424, 0.0556043721735477, 0.0556594021618366, 0.0557144396007061, 0.0557694919407368, 0.0558246001601219, 0.0558796934783459, 0.0559348426759243, 0.0559899881482124, 0.0560451596975327, 0.0561003722250462, 0.0561555996537209, 0.0562108531594276, 0.0562661178410053, 0.0563213974237442, 0.0563767477869987, 0.0564320869743824, 0.0564874485135078, 0.0565428324043751, 0.0565982386469841, 0.056653693318367, 0.056709136813879, 0.0567646212875843, 0.0568201132118702, 0.0568756349384785, 0.0569311827421188, 0.0569867789745331, 0.0570423565804958, 0.0570979788899422, 0.0571536161005497, 0.0572092905640602, 0.0572649650275707, 0.0573206879198551, 0.0573764108121395, 0.0574321784079075, 0.0574879609048367, 0.0575437620282173, 0.0575995817780495, 0.0576554350554943, 0.0577113106846809, 0.0577672198414803, 0.0578231327235699, 0.057879064232111, 0.0579350478947163, 0.0579910166561604, 0.0580470487475395, 0.0581030733883381, 0.058159127831459, 0.058215219527483, 0.0582713223993778, 0.0583274401724339, 0.0583835989236832, 0.0584397576749325, 0.0584959760308266, 0.0585521869361401, 0.0586084239184856, 0.0586646944284439, 0.0587209798395634, 0.0587772987782955, 0.0588336326181889, 0.0588899813592434, 0.0589463822543621, 0.0590027831494808, 0.0590592138469219, 0.0591156631708145, 0.0591721273958683, 0.059228640049696, 0.0592851489782333, 0.0593416877090931, 0.0593982562422752, 0.0594548545777798, 0.0595114715397358, 0.059568103402853, 0.0596247538924217, 0.0596814416348934, 0.0597381442785263, 0.0597948841750622, 0.0598516203463078, 0.0599084049463272, 0.0599651969969273, 0.0600220188498497, 0.0600788742303848, 0.0601357333362103, 0.0601926073431969, 0.0602495446801186, 0.06030647829175, 0.0603634379804134, 0.0604204200208187, 0.0604774132370949, 0.0605344586074352, 0.0605915039777756, 0.060648575425148, 0.0607056841254234, 0.0607628040015697, 0.0608199462294579, 0.0608771145343781, 0.0609342828392982, 0.0609915219247341, 0.06104876101017, 0.0611060261726379, 0.0611632950603962, 0.0612205974757671, 0.0612779445946217, 0.0613352917134762, 0.0613926649093628, 0.0614500679075718, 0.0615074820816517, 0.0615649335086346, 0.0616224035620689, 0.0616798922419548, 0.0617374181747437, 0.0617949441075325, 0.0618525110185146, 0.0619100891053677, 0.0619676969945431, 0.0620253197848797, 0.0620829798281193, 0.0621406584978104, 0.0621983483433723, 0.0622560791671276, 0.062313836067915, 0.0623715929687023, 0.0624293871223927, 0.0624871924519539, 0.0625450313091278, 0.0626028999686241, 0.0626607835292816, 0.0627186968922615, 0.062776617705822, 0.0628345534205437, 0.0628925561904907, 0.0629505440592766, 0.0630085691809654, 0.0630666241049767, 0.0631246790289879, 0.0631827935576439, 0.0632409006357193, 0.0632990300655365, 0.0633571967482567, 0.0634153857827187, 0.063473604619503, 0.063531830906868, 0.0635900795459747, 0.0636483654379845, 0.0637066513299942, 0.0637649968266487, 0.063823327422142, 0.0638816878199577, 0.063940092921257, 0.0639985129237175, 0.064056932926178, 0.0641154050827026, 0.0641738846898079, 0.0642324015498161, 0.064290925860405, 0.0643494799733162, 0.0644080713391304, 0.0644666701555252, 0.064525306224823, 0.0645839497447014, 0.0646426156163216, 0.0647013038396835, 0.0647600367665291, 0.064818762242794, 0.064877524971962, 0.0649363100528717, 0.0649951249361038, 0.0650539472699165, 0.0651128217577934, 0.0651716813445091, 0.0652305781841278, 0.0652895197272301, 0.0653484687209129, 0.065407432615757, 0.0654664188623428, 0.0655254274606705, 0.0655844956636429, 0.0656435489654541, 0.0657026320695877, 0.0657617598772049, 0.0658208727836609, 0.0658800601959229, 0.0659392103552818, 0.065998412668705, 0.0660576447844505, 0.0661168843507767, 0.0661761686205864, 0.0662354603409767, 0.0662947669625282, 0.0663541257381439, 0.0664134696125984, 0.0664728730916977, 0.0665322840213776, 0.0665917098522186, 0.0666511580348015, 0.0667106434702873, 0.0667701363563538, 0.0668296813964844, 0.0668892189860344, 0.066948801279068, 0.0670083984732628, 0.0670680031180382, 0.0671276599168777, 0.0671873167157173, 0.0672470107674599, 0.0673067048192024, 0.0673664510250092, 0.0674262121319771, 0.0674859806895256, 0.0675457864999771, 0.0676056146621704, 0.0676654651761055, 0.067725345492363, 0.0677852258086205, 0.0678451657295227, 0.0679050981998444, 0.0679650530219078, 0.0680250450968742, 0.0680850595235825, 0.0681450814008713, 0.0682051479816437, 0.0682652220129967, 0.0683253481984138, 0.0683854520320892, 0.0684456080198288, 0.0685058087110519, 0.0685659721493721, 0.0686262175440788, 0.0686864480376244, 0.0687467157840729, 0.0688070058822632, 0.0688673183321953, 0.0689276456832886, 0.0689880102872849, 0.0690483748912811, 0.0691087990999222, 0.0691692158579826, 0.0692296698689461, 0.0692901462316513, 0.0693506449460983, 0.0694111660122871, 0.0694717094302177, 0.0695322677493095, 0.0695928558707237, 0.0696534663438797, 0.0697141066193581, 0.0697747692465782, 0.0698354467749596, 0.0698961392045021, 0.0699568837881088, 0.0700176432728767, 0.0700784027576447, 0.0701391994953156, 0.0702000260353088, 0.0702608674764633, 0.0703217312693596, 0.0703826323151588, 0.0704435259103775, 0.0705044865608215, 0.0705654248595238, 0.0706264078617096, 0.0706874132156372, 0.0707484409213066, 0.0708094984292984, 0.070870578289032, 0.0709316581487656, 0.0709927976131439, 0.0710539221763611, 0.0711151137948036, 0.0711762979626656, 0.0712375119328499, 0.071298748254776, 0.0713599994778633, 0.0714213028550148, 0.0714825987815857, 0.071543924510479, 0.0716052874922752, 0.0716666653752327, 0.0717280507087708, 0.0717894807457924, 0.0718509182333946, 0.0719123855233192, 0.0719738826155663, 0.0720353946089745, 0.072096936404705, 0.0721584931015968, 0.0722200646996498, 0.072281688451767, 0.0723433122038841, 0.0724049583077431, 0.0724666267633438, 0.0725283473730087, 0.072590060532093, 0.0726518034934998, 0.0727135688066483, 0.0727753564715385, 0.0728371813893318, 0.0728990137577057, 0.0729608833789825, 0.07302276045084, 0.0730846598744392, 0.0731465965509415, 0.0732085555791855, 0.0732705220580101, 0.0733325406908989, 0.0733945444226265, 0.0734565854072571, 0.0735186636447906, 0.0735807567834854, 0.073642872273922, 0.0737050101161003, 0.0737671703100204, 0.073829360306263, 0.0738915577530861, 0.0739538073539734, 0.0740160495042801, 0.0740783140063286, 0.0741406306624413, 0.0742029473185539, 0.0742652863264084, 0.0743276700377464, 0.0743900686502457, 0.0744524821639061, 0.0745149180293083, 0.0745773687958717, 0.0746398717164993, 0.0747023671865463, 0.0747674107551575, 0.0748349651694298, 0.0749025344848633, 0.0749701038002968, 0.0750376656651497, 0.0751052349805832, 0.0751727968454361, 0.075240358710289, 0.0753079354763031, 0.0753755047917366, 0.0754430741071701, 0.0755106434226036, 0.0755782201886177, 0.0756457969546318, 0.0757133737206459, 0.07578095048666, 0.0758485272526741, 0.0759160965681076, 0.0759836807847023, 0.0760512575507164, 0.0761188343167305, 0.0761864334344864, 0.0762540027499199, 0.0763215944170952, 0.0763891637325287, 0.0764567404985428, 0.0765243396162987, 0.0765919163823128, 0.0766595155000687, 0.0767270997166634, 0.0767946839332581, 0.0768622830510139, 0.076929859817028, 0.0769974589347839, 0.0770650506019592, 0.0771326497197151, 0.0772002413868904, 0.0772678330540657, 0.0773354321718216, 0.0774030312895775, 0.0774706304073334, 0.0775382295250893, 0.0776058286428452, 0.0776734203100204, 0.0777410417795181, 0.0778086259961128, 0.0778762400150299, 0.0779438391327858, 0.0780114531517029, 0.0780790522694588, 0.0781466588377953, 0.0782142728567123, 0.0782818794250488, 0.0783494859933853, 0.078417107462883, 0.0784847065806389, 0.0785523131489754, 0.0786199346184731, 0.0786875486373901, 0.0787551626563072, 0.0788227841258049, 0.078890398144722, 0.0789580196142197, 0.0790256336331367, 0.0790932551026344, 0.0791608840227127, 0.0792284905910492, 0.0792961418628693, 0.0793637484312057, 0.079431377351284, 0.0794989913702011, 0.0795666202902794, 0.0796342566609383, 0.0797018781304359, 0.079769492149353, 0.0798371434211731, 0.0799047499895096, 0.0799724012613297, 0.0800400301814079, 0.0801076591014862, 0.0801752954721451, 0.0802429243922234, 0.0803105682134628, 0.0803781971335411, 0.0804458335042, 0.0805134847760201, 0.0805811211466789, 0.080648772418499, 0.0807164087891579, 0.0807840377092361, 0.0808516964316368, 0.0809193328022957, 0.0809869915246964, 0.0810546278953552, 0.0811222717165947, 0.0811899229884148, 0.0812575817108154, 0.0813252106308937, 0.0813928693532944, 0.0814605206251144, 0.0815281867980957, 0.0815958306193352, 0.0816634818911552, 0.0817311406135559, 0.081798791885376, 0.0818664580583572, 0.0819341167807579, 0.0820017531514168, 0.0820694342255592, 0.0821370929479599, 0.0822047591209412, 0.0822724178433418, 0.0823400616645813, 0.0824077501893044, 0.0824754014611244, 0.0825430750846863, 0.0826107338070869, 0.0826784074306488, 0.0827460736036301, 0.0828137546777725, 0.0828814059495926, 0.0829490944743156, 0.0830167531967163, 0.0830844417214394, 0.0831521078944206, 0.0832197815179825, 0.0832874551415443, 0.0833551362156868, 0.0834228172898293, 0.0834904909133911, 0.0835581570863724, 0.0836258605122566, 0.0836935415863991, 0.0837612226605415, 0.083828903734684, 0.0838965773582458, 0.0839642733335495, 0.0840319469571114, 0.084099642932415, 0.0841673314571381, 0.0842350125312805, 0.0843027085065842, 0.0843704044818878, 0.0844380781054497, 0.0845057815313339, 0.0845734626054764, 0.0846411734819412, 0.0847088694572449, 0.0847765505313873, 0.0848442539572716, 0.0849119499325752, 0.0849796533584595, 0.0850473567843437, 0.0851150453090668, 0.0851827561855316, 0.0852504596114159, 0.0853181481361389, 0.0853858664631844, 0.085453562438488, 0.085521288216114, 0.0855889767408371, 0.0856566876173019, 0.0857244059443474, 0.0857921093702316, 0.0858598276972771, 0.0859275311231613, 0.0859952345490456, 0.0860629677772522, 0.0861306712031364, 0.0861983895301819, 0.0862661004066467, 0.0863338112831116, 0.0864015370607376, 0.0864692479372025, 0.0865369737148285, 0.0866046920418739, 0.0866724103689194, 0.0867401361465454, 0.0868078619241714, 0.0868755802512169, 0.0869433134794235, 0.0870110243558884, 0.0870787650346756, 0.0871464908123016, 0.0872142091393471, 0.0872819423675537, 0.0873496755957603, 0.0874174013733864, 0.087485134601593, 0.0875528603792191, 0.0876206085085869, 0.0876883342862129, 0.0877560898661613, 0.0878238156437874, 0.087891548871994, 0.0879592821002007, 0.0880270302295685, 0.0880947709083557, 0.0881625041365623, 0.0882302522659302, 0.0882979929447174, 0.0883657336235046, 0.0884334743022919, 0.0885012298822403, 0.0885689780116081, 0.0886367186903954, 0.0887044668197632, 0.0887722074985504, 0.0888399705290794, 0.0889077112078667, 0.0889754593372345, 0.0890432223677635, 0.0891109779477119, 0.0891787260770798, 0.0892464816570282, 0.0893142446875572, 0.0893820002675056, 0.0894497632980347, 0.0895175188779831, 0.0895852819085121, 0.0896530374884605, 0.0897208005189896, 0.0897885710000992, 0.0898563265800476, 0.0899240896105766, 0.0899918600916862, 0.0900596305727959, 0.0901273936033249, 0.0901951566338539, 0.0902629345655441, 0.0903306975960732, 0.0903984755277634, 0.0904662385582924, 0.0905340164899826, 0.0906017869710922, 0.0906695649027824, 0.0907373353838921, 0.0908051207661629, 0.0908728986978531, 0.0909406766295433, 0.0910084620118141, 0.0910762324929237, 0.091144010424614, 0.0912117958068848, 0.0912795811891556, 0.0913473516702652, 0.0914151519536972, 0.0914829298853874, 0.0915507152676582, 0.0916185155510902, 0.0916862860321999, 0.0917540788650513, 0.0918218716979027, 0.0918896645307541, 0.0919574573636055, 0.0920252427458763, 0.0920930430293083, 0.0921608358621597, 0.0922286286950111, 0.0922964215278625, 0.0923642218112946, 0.0924320220947266, 0.0924998298287392, 0.0925676226615906, 0.0926354229450226, 0.0927032306790352, 0.0927710309624672, 0.0928388386964798, 0.0929066315293312, 0.0929744392633438, 0.0930422469973564, 0.0931100621819496, 0.0931778699159622, 0.0932456701993942, 0.0933134704828262, 0.0933812856674194, 0.0934491008520126, 0.0935169160366058, 0.093584731221199, 0.0936525389552116, 0.0937203615903854, 0.093788169324398, 0.0938559845089912, 0.093923807144165, 0.0939916223287582, 0.0940594598650932, 0.0941272675991058, 0.0941950902342796, 0.094262920320034, 0.0943307504057884, 0.0943985655903816, 0.0944663882255554, 0.0945342108607292, 0.0946020409464836, 0.094669871032238, 0.0947377011179924, 0.0948055237531662, 0.0948733612895012, 0.0949411988258362, 0.09500902146101, 0.095076858997345, 0.0951446890830994, 0.0952125191688538, 0.0952803567051888, 0.0953482016921043, 0.0954160317778587, 0.0954838767647743, 0.0955517143011093, 0.0956195667386055, 0.0956874042749405, 0.0957552418112755, 0.0958230867981911, 0.0958909317851067, 0.0959587842226028, 0.0960266217589378, 0.0960944667458534, 0.0961623191833496, 0.0962301716208458, 0.0962980017066002, 0.096365861594677, 0.0964337140321732, 0.0965015664696693, 0.0965694263577461, 0.0966372713446617, 0.0967051163315773, 0.0967729836702347, 0.0968408435583115, 0.0969086959958076, 0.0969765558838844, 0.0970444157719612, 0.0971122831106186, 0.0971801429986954, 0.0972480028867722, 0.0973158776760101, 0.0973837375640869, 0.0974515974521637, 0.0975194722414017, 0.0975873321294785, 0.0976551994681358, 0.0977230668067932, 0.0977909415960312, 0.097858801484108, 0.0979266762733459, 0.0979945436120033, 0.0980624333024025, 0.0981303080916405, 0.0981981679797173, 0.0982660427689552, 0.0983339250087738, 0.0984018072485924, 0.0984696820378304, 0.0985375568270683, 0.0986054390668869, 0.0986733213067055, 0.0987412184476852, 0.0988090857863426, 0.0988769829273224, 0.0989448577165604, 0.0990127474069595, 0.0990806296467781, 0.0991485193371773, 0.0992164090275764, 0.0992842987179756, 0.0993521884083748, 0.0994200706481934, 0.0994879752397537, 0.0995558574795723, 0.0996237620711327, 0.0996916517615318, 0.0997595489025116, 0.099827453494072, 0.0998953357338905, 0.0999632477760315, 0.10003113001585, 0.100099042057991, 0.100166939198971, 0.100234843790531, 0.100302755832672, 0.100370652973652, 0.100438565015793, 0.100506462156773, 0.100574381649494, 0.100642278790474, 0.100710183382034, 0.100778095424175, 0.100846007466316, 0.100913919508457, 0.100981831550598, 0.10104975104332, 0.10111765563488, 0.101185582578182, 0.101253479719162, 0.101321399211884, 0.101389326155186, 0.101457245647907, 0.101525172591209, 0.10159307718277, 0.101660996675491, 0.101728923618793, 0.101796850562096, 0.101864770054817, 0.101932696998119, 0.102000616490841, 0.102068543434143, 0.102136477828026, 0.102204404771328, 0.10227233171463, 0.102340266108513, 0.102408200502396, 0.102476127445698, 0.102544061839581, 0.102611988782883, 0.102679930627346, 0.102747865021229, 0.102815799415112, 0.102883733808994, 0.102951668202877, 0.103019617497921, 0.103087559342384, 0.103155493736267, 0.10322343558073, 0.103291384875774, 0.103359326720238, 0.10342726111412, 0.103495217859745, 0.103563159704208, 0.103631108999252, 0.103699065744877, 0.10376700758934, 0.103834964334965, 0.103902913630009, 0.103970862925053, 0.104038804769516, 0.104106768965721, 0.104174725711346, 0.10424268245697, 0.104310631752014, 0.104378588497639, 0.104446545243263, 0.104514509439468, 0.104582473635674, 0.104650437831879, 0.104718387126923, 0.104786351323128, 0.104854315519333, 0.104922279715538, 0.104990243911743, 0.105058215558529, 0.105126179754734, 0.10519415140152, 0.105262123048306, 0.105330087244511, 0.105398058891296, 0.105466037988663, 0.105534002184868, 0.105601981282234, 0.10566995292902, 0.105737932026386, 0.105805911123753, 0.105873882770538, 0.105941861867905, 0.106009840965271, 0.106077820062637, 0.106145806610584, 0.10621377825737, 0.106281764805317, 0.106349751353264, 0.10641773045063, 0.106485724449158, 0.106553703546524, 0.106621697545052, 0.106689684092999, 0.106757670640945, 0.106825657188892, 0.10689365118742, 0.106961645185947, 0.107029631733894, 0.107097640633583, 0.10716562718153, 0.107233621180058, 0.107301615178585, 0.107369616627693, 0.107437610626221, 0.107505604624748, 0.107573606073856, 0.107641614973545, 0.107709616422653, 0.107777610421181, 0.107845619320869, 0.107913620769978, 0.107981629669666, 0.108049631118774, 0.108117640018463, 0.108185641467571, 0.108253665268421, 0.108321666717529, 0.108389675617218, 0.108457684516907, 0.108525708317757, 0.108593717217445, 0.108661741018295, 0.108729742467403, 0.108797766268253, 0.108865782618523, 0.108933798968792, 0.109001807868481, 0.10906982421875, 0.109137862920761, 0.10920587927103, 0.1092738956213, 0.10934191942215, 0.10940995067358, 0.10947797447443, 0.109546005725861, 0.10961402207613, 0.10968204587698, 0.109750084578991, 0.109818123281002, 0.109886154532433, 0.109954170882702, 0.110022209584713, 0.110090248286724, 0.110158279538155, 0.110226318240166, 0.110294342041016, 0.110362388193607, 0.110430434346199, 0.11049846559763, 0.11056649684906, 0.110634543001652, 0.110702581703663, 0.110770620405674, 0.110838666558266, 0.110906712710857, 0.110974751412868, 0.111042805016041, 0.111110858619213, 0.111178897321224, 0.111246950924397, 0.111314997076988, 0.11138304322958, 0.111451104283333, 0.111519150435925, 0.111587211489677, 0.111655257642269, 0.111723318696022, 0.111791379749775, 0.111859433352947, 0.1119274944067, 0.111995555460453, 0.112063601613045, 0.112131655216217, 0.112199723720551, 0.112267784774303, 0.112335853278637, 0.11240392178297, 0.112471982836723, 0.112540051341057, 0.11260811239481, 0.112676180899143, 0.112744241952896, 0.11281231045723, 0.112880386412144, 0.112948454916477, 0.113016545772552, 0.113084606826305, 0.113152682781219, 0.113220751285553, 0.113288842141628, 0.113356903195381, 0.113424986600876, 0.113493070006371, 0.113561153411865, 0.113629229366779, 0.113697297871113, 0.113765388727188, 0.113833472132683, 0.113901562988758, 0.113969638943672, 0.114037722349167, 0.114105813205242, 0.114173904061317, 0.114241987466812, 0.114310078322887, 0.114378161728382, 0.114446267485619, 0.114514358341694, 0.11458245664835, 0.114650540053844, 0.1147186383605, 0.114786729216576, 0.114854834973812, 0.114922933280468, 0.114991024136543, 0.115059122443199, 0.115127228200436, 0.115195326507092, 0.115263424813747, 0.115331530570984, 0.11539962887764, 0.115467749536037, 0.115535847842693, 0.115603946149349, 0.115672066807747, 0.115740180015564, 0.11580827832222, 0.115876384079456, 0.115944497287273, 0.11601261049509, 0.116080731153488, 0.116148844361305, 0.116216957569122, 0.116285070776939, 0.116353191435337, 0.116421304643154, 0.116489417850971, 0.116557531058788, 0.116625659167767, 0.116693794727325, 0.116761922836304, 0.11683002114296, 0.116898149251938, 0.116966277360916, 0.117034390568733, 0.117102533578873, 0.11717065423727, 0.117238782346249, 0.117306910455227, 0.117375053465366, 0.117443181574345, 0.117511309683323, 0.117579452693462, 0.117647565901279, 0.117715708911419, 0.117783851921558, 0.117851980030537, 0.117920123040676, 0.117988266050816, 0.118056394159794, 0.118124537169933, 0.118192680180073, 0.118260823190212, 0.118328966200352, 0.118397109210491, 0.118465252220631, 0.11853339523077, 0.118601553142071, 0.11866968870163, 0.11873784661293, 0.11880598962307, 0.118874132633209, 0.11894229054451, 0.119010448455811, 0.11907859146595, 0.11914674192667, 0.119214899837971, 0.119283057749271, 0.119351215660572, 0.119419381022453, 0.119487524032593, 0.119555696845055, 0.119623854756355, 0.119692005217075, 0.119760178029537, 0.119828335940838, 0.119896493852139, 0.11996465921402, 0.120032832026482, 0.120100997388363, 0.120169170200825, 0.120237328112125, 0.120305508375168, 0.120373666286469, 0.120441846549511, 0.120510019361973, 0.120578192174435, 0.120646357536316, 0.120714530348778, 0.12078271061182, 0.120850883424282, 0.120919056236744, 0.120987236499786, 0.121055424213409, 0.121123604476452, 0.121191784739494, 0.121259972453117, 0.12132815271616, 0.121396340429783, 0.121464505791664, 0.121532708406448, 0.121600888669491, 0.121669076383114, 0.121737271547318, 0.121805444359779, 0.121873639523983, 0.121941819787025, 0.12201002240181, 0.122078202664852, 0.122146397829056, 0.12221460044384, 0.122282795608044, 0.122350990772247, 0.122419185936451, 0.122487388551235, 0.122555583715439, 0.122623793780804, 0.122691981494427, 0.12276017665863, 0.122828401625156, 0.12289659678936, 0.122964799404144, 0.123033009469509, 0.123101219534874, 0.123169414699078, 0.123237639665604, 0.123305834829807, 0.123374044895172, 0.123442262411118, 0.123510472476482, 0.123578682541847, 0.123646892607212, 0.123715102672577, 0.123783327639103, 0.123851537704468, 0.123919747769833, 0.123987972736359, 0.124056197702885, 0.12412440776825, 0.124192632734776, 0.124260850250721, 0.124329097568989, 0.124397307634354, 0.124465517699718, 0.124533772468567, 0.124601982533932, 0.124670192599297, 0.124738432466984, 0.124806672334671, 0.124874897301197, 0.124943122267723, 0.125011339783669, 0.125079602003098, 0.125147819519043, 0.12521605193615, 0.125284284353256, 0.125352531671524, 0.125420764088631, 0.125488996505737, 0.125557243824005, 0.125625476241112, 0.12569372355938, 0.125761970877647, 0.125830203294754, 0.125898450613022, 0.12596669793129, 0.126034930348396, 0.126103177666664, 0.126171439886093, 0.1262396723032, 0.126307934522629, 0.126376181840897, 0.126444429159164, 0.126512676477432, 0.1265809237957, 0.126649171113968, 0.126717448234558, 0.126785680651665, 0.126853942871094, 0.126922205090523, 0.126990467309952, 0.12705871462822, 0.127126976847649, 0.127195239067078, 0.127263501286507, 0.127331748604774, 0.127400040626526, 0.127468287944794, 0.127536565065384, 0.127604812383652, 0.127673089504242, 0.127741351723671, 0.127809628844261, 0.12787789106369, 0.12794616818428, 0.128014445304871, 0.128082722425461, 0.12815098464489, 0.128219246864319, 0.128287523984909, 0.12835581600666, 0.128424093127251, 0.128492370247841, 0.128560647368431, 0.128628924489021, 0.128697201609612, 0.128765493631363, 0.128833770751953, 0.128902047872543, 0.128970324993134, 0.129038631916046, 0.129106909036636, 0.129175186157227, 0.129243478178978, 0.129311785101891, 0.129380062222481, 0.129448354244232, 0.129516646265984, 0.129584923386574, 0.129653230309486, 0.129721507430077, 0.129789814352989, 0.129858106374741, 0.129926398396492, 0.129994705319405, 0.130062997341156, 0.130131304264069, 0.130199611186981, 0.130267903208733, 0.130336210131645, 0.130404517054558, 0.130472809076309, 0.130541115999222, 0.130609437823296, 0.130677729845047, 0.13074603676796, 0.130814343690872, 0.130882650613785, 0.130950957536697, 0.131019294261932, 0.131087586283684, 0.131155908107758, 0.13122421503067, 0.131292536854744, 0.131360843777657, 0.131429150700569, 0.131497472524643, 0.131565794348717, 0.131634116172791, 0.131702437996864, 0.131770744919777, 0.131839081645012, 0.131907403469086, 0.131975725293159, 0.132044062018394, 0.132112383842468, 0.132180705666542, 0.132249027490616, 0.132317364215851, 0.132385686039925, 0.132454007863998, 0.132522344589233, 0.132590681314468, 0.132659018039703, 0.132727339863777, 0.132795676589012, 0.132864013314247, 0.132932364940643, 0.133000701665878, 0.133069023489952, 0.133137360215187, 0.133205711841583, 0.133274048566818, 0.133342385292053, 0.133410736918449, 0.133479073643684, 0.133547425270081, 0.133615776896477, 0.133684113621712, 0.133752465248108, 0.133820801973343, 0.1338891685009, 0.133957520127296, 0.134025856852531, 0.134094223380089, 0.134162575006485, 0.134230926632881, 0.134299263358116, 0.134367629885674, 0.13443598151207, 0.134504333138466, 0.134572699666023, 0.134641066193581, 0.134709417819977, 0.134777784347534, 0.134846150875092, 0.134914517402649, 0.134982869029045, 0.135051235556602, 0.13511960208416, 0.135187953710556, 0.135256335139275, 0.135324701666832, 0.135393083095551, 0.135461449623108, 0.135529816150665, 0.135598182678223, 0.135666564106941, 0.135734930634499, 0.135803312063217, 0.135871678590775, 0.135940060019493, 0.136008441448212, 0.136076807975769, 0.136145189404488, 0.136213570833206, 0.136281952261925, 0.136350333690643, 0.136418715119362, 0.136487111449242, 0.13655549287796, 0.13662388920784, 0.136692255735397, 0.136760637164116, 0.136829018592834, 0.136897414922714, 0.136965826153755, 0.137034207582474, 0.137102589011192, 0.137171000242233, 0.137239381670952, 0.137307778000832, 0.13737615942955, 0.137444570660591, 0.137512966990471, 0.137581363320351, 0.13764975965023, 0.13771815598011, 0.13778655230999, 0.137854963541031, 0.137923359870911, 0.13799175620079, 0.138060167431831, 0.138128578662872, 0.138196974992752, 0.138265386223793, 0.138333782553673, 0.138402223587036, 0.138470605015755, 0.138539031147957, 0.138607442378998, 0.138675853610039, 0.138744279742241, 0.138812690973282, 0.138881087303162, 0.138949513435364, 0.139017924666405, 0.139086350798607, 0.139154776930809, 0.13922318816185, 0.139291599392891, 0.139360025525093, 0.139428451657295, 0.139496877789497, 0.139565289020538, 0.13963371515274, 0.139702141284943, 0.139770582318306, 0.139838993549347, 0.139907419681549, 0.139975860714912, 0.140044301748276, 0.140112727880478, 0.14018115401268, 0.140249595046043, 0.140318021178246, 0.140386462211609, 0.140454888343811, 0.140523329377174, 0.140591770410538, 0.140660211443901, 0.140728652477264, 0.140797078609467, 0.140865534543991, 0.140933975577354, 0.141002416610718, 0.14107084274292, 0.141139313578606, 0.141207754611969, 0.141276210546494, 0.141344651579857, 0.14141309261322, 0.141481533646584, 0.141549989581108, 0.141618460416794, 0.141686901450157, 0.141755342483521, 0.141823813319206, 0.14189225435257, 0.141960725188255, 0.142029166221619, 0.142097637057304, 0.142166092991829, 0.142234563827515, 0.142303019762039, 0.142371475696564, 0.142439931631088, 0.142508402466774, 0.142576858401299, 0.142645314335823, 0.142713785171509, 0.142781987786293, 0.142849862575531, 0.142917692661285, 0.142985492944717, 0.143053278326988, 0.143121033906937, 0.143188744783401, 0.143256440758705, 0.143324106931686, 0.143391713500023, 0.143459320068359, 0.143526881933212, 0.143594428896904, 0.143661916255951, 0.143729388713837, 0.143796846270561, 0.143864259123802, 0.14393162727356, 0.143998995423317, 0.144066318869591, 0.144133612513542, 0.144200891256332, 0.144268110394478, 0.144335299730301, 0.144402489066124, 0.144469648599625, 0.144536733627319, 0.144603818655014, 0.144670873880386, 0.144737914204597, 0.144804894924164, 0.144871845841408, 0.144938781857491, 0.145005688071251, 0.145072564482689, 0.145139396190643, 0.145206212997437, 0.145273000001907, 0.145339742302895, 0.145406454801559, 0.145473152399063, 0.145539805293083, 0.145606443285942, 0.145673036575317, 0.14573960006237, 0.145806133747101, 0.145872637629509, 0.145939141511917, 0.14600558578968, 0.146072000265121, 0.14613838493824, 0.146204739809036, 0.146271049976349, 0.146337360143661, 0.146403625607491, 0.146469861268997, 0.146536067128181, 0.146602228283882, 0.146668374538422, 0.146734490990639, 0.146800592541695, 0.146866634488106, 0.146932661533356, 0.146998658776283, 0.147064626216888, 0.14713054895401, 0.147196471691132, 0.147262334823608, 0.147328183054924, 0.147393986582756, 0.147459775209427, 0.147525504231453, 0.14759124815464, 0.147656932473183, 0.147722601890564, 0.147788226604462, 0.147853821516037, 0.147919401526451, 0.147984951734543, 0.148050457239151, 0.148115932941437, 0.1481813788414, 0.148246809840202, 0.148312211036682, 0.148377552628517, 0.148442879319191, 0.148508161306381, 0.148573458194733, 0.148638695478439, 0.148703888058662, 0.148769065737724, 0.148834213614464, 0.148899331688881, 0.148964419960976, 0.149029463529587, 0.149094492197037, 0.149159491062164, 0.149224475026131, 0.149289414286613, 0.149354323744774, 0.149419173598289, 0.149484023451805, 0.14954885840416, 0.149613633751869, 0.149678379297256, 0.149743109941483, 0.149807810783386, 0.149872466921806, 0.149937108159065, 0.150001704692841, 0.150066286325455, 0.150130823254585, 0.150195315480232, 0.15025982260704, 0.150324255228043, 0.150388672947884, 0.150453075766563, 0.15051743388176, 0.150581762194633, 0.150646060705185, 0.150710344314575, 0.150774583220482, 0.150838792324066, 0.150902971625328, 0.150967121124268, 0.151031255722046, 0.151095330715179, 0.151159375905991, 0.151223421096802, 0.151287406682968, 0.151351392269135, 0.151415318250656, 0.151479229331017, 0.151543125510216, 0.15160696208477, 0.151670783758163, 0.151734560728073, 0.15179830789566, 0.151862040162086, 0.151925727725029, 0.151989415287971, 0.152053043246269, 0.152116656303406, 0.152180224657059, 0.15224377810955, 0.152307271957397, 0.152370765805244, 0.152434214949608, 0.15249764919281, 0.152561038732529, 0.152624413371086, 0.15268774330616, 0.15275102853775, 0.152814313769341, 0.152877569198608, 0.152940779924393, 0.153003960847855, 0.153067111968994, 0.153130233287811, 0.153193309903145, 0.153256371617317, 0.153319403529167, 0.153382420539856, 0.153445392847061, 0.153508320450783, 0.153571233153343, 0.153634116053581, 0.153696954250336, 0.153759777545929, 0.1538225710392, 0.153885319828987, 0.153948068618774, 0.154010757803917, 0.154073417186737, 0.154136076569557, 0.154198676347733, 0.154261231422424, 0.154323786497116, 0.154386311769485, 0.154448807239532, 0.154511243104935, 0.154573678970337, 0.154636070132256, 0.154698446393013, 0.154760777950287, 0.1548230946064, 0.154885351657867, 0.154947593808174, 0.15500982105732, 0.155072018504143, 0.155134156346321, 0.155196294188499, 0.155258387327194, 0.155320450663567, 0.155382484197617, 0.155444473028183, 0.155506432056427, 0.155568391084671, 0.155630305409431, 0.155692175030708, 0.155754044651985, 0.155815854668617, 0.155877649784088, 0.155939415097237, 0.156001135706902, 0.156062841415405, 0.156124517321587, 0.156186163425446, 0.156247764825821, 0.156309351325035, 0.156370893120766, 0.156432434916496, 0.156493902206421, 0.156555369496346, 0.156616806983948, 0.156678199768066, 0.156739547848701, 0.156800895929337, 0.156862214207649, 0.156923487782478, 0.156984731554985, 0.157045945525169, 0.157107144594193, 0.157168298959732, 0.157229423522949, 0.157290518283844, 0.157351568341255, 0.157412618398666, 0.157473623752594, 0.157534599304199, 0.157595545053482, 0.157656446099281, 0.157717347145081, 0.157778188586235, 0.157839015126228, 0.157899811863899, 0.157960578799248, 0.158021315932274, 0.158082023262978, 0.158142670989037, 0.158203333616257, 0.158263936638832, 0.158324524760246, 0.158385068178177, 0.158445596694946, 0.158506095409393, 0.158566549420357, 0.158626973628998, 0.158687382936478, 0.158747747540474, 0.158808082342148, 0.158868402242661, 0.158928692340851, 0.158988937735558, 0.159049153327942, 0.159109339118004, 0.159169495105743, 0.159229621291161, 0.159289732575417, 0.159349784255028, 0.159409821033478, 0.159469842910767, 0.159529805183411, 0.159589752554893, 0.159649685025215, 0.159709572792053, 0.159769430756569, 0.159829258918762, 0.159889042377472, 0.15994881093502, 0.160008549690247, 0.16006825864315, 0.160127937793732, 0.160187557339668, 0.160247191786766, 0.160306766629219, 0.160366341471672, 0.16042585670948, 0.160485342144966, 0.160544812679291, 0.160604238510132, 0.160663649439812, 0.160723015666008, 0.160782366991043, 0.160841658711433, 0.160900965332985, 0.160960212349892, 0.161019429564476, 0.161078616976738, 0.161137774586678, 0.161196917295456, 0.161256015300751, 0.161315083503723, 0.161374121904373, 0.161433145403862, 0.161492109298706, 0.16155107319355, 0.161609977483749, 0.161668851971626, 0.161727741360664, 0.161786571145058, 0.161845371127129, 0.161904126405716, 0.161962851881981, 0.162021577358246, 0.162080243229866, 0.162138894200325, 0.1621975004673, 0.162256106734276, 0.162314668297768, 0.162373185157776, 0.162431672215462, 0.162490144371986, 0.162548571825027, 0.162606969475746, 0.162665352225304, 0.162723705172539, 0.16278201341629, 0.162840291857719, 0.162898555397987, 0.162956789135933, 0.163014978170395, 0.163073137402534, 0.163131281733513, 0.163189366459846, 0.16324745118618, 0.163305476307869, 0.163363501429558, 0.163421496748924, 0.163479432463646, 0.163537368178368, 0.163595259189606, 0.16365310549736, 0.163710936903954, 0.163768723607063, 0.163826510310173, 0.163884237408638, 0.163941964507103, 0.163999646902084, 0.164057299494743, 0.16411492228508, 0.164172500371933, 0.164230063557625, 0.164287596940994, 0.16434508562088, 0.164402559399605, 0.164459988474846, 0.164517402648926, 0.164574772119522, 0.164632111787796, 0.164689436554909, 0.164746716618538, 0.164803981781006, 0.16486120223999, 0.164918407797813, 0.164975568652153, 0.16503269970417, 0.165089800953865, 0.165146872401237, 0.16520394384861, 0.165260940790176, 0.165317922830582, 0.165374889969826, 0.165431812405586, 0.165488705039024, 0.16554556787014, 0.165602400898933, 0.165659204125404, 0.165715977549553, 0.165772706270218, 0.165829434990883, 0.165886104106903, 0.165942773222923, 0.165999367833138, 0.166055962443352, 0.166112527251244, 0.166169062256813, 0.166225552558899, 0.166282042860985, 0.166338473558426, 0.166394889354706, 0.166451275348663, 0.166507601737976, 0.16656394302845, 0.166620224714279, 0.166676476597786, 0.166732713580132, 0.166788905858994, 0.166845068335533, 0.166901215910912, 0.166957333683968, 0.16701340675354, 0.167069435119629, 0.167125463485718, 0.167181447148323, 0.167237386107445, 0.167293325066566, 0.167349234223366, 0.167405098676682, 0.167460933327675, 0.167516738176346, 0.167572513222694, 0.167628243565559, 0.167683973908424, 0.167739659547806, 0.167795300483704, 0.167850941419601, 0.167906522750854, 0.167962089180946, 0.168017625808716, 0.168073132634163, 0.168128594756126, 0.168184041976929, 0.168239444494247, 0.168294817209244, 0.16835018992424, 0.168405517935753, 0.168460801243782, 0.16851606965065, 0.168571278452873, 0.168626487255096, 0.168681666254997, 0.168736800551414, 0.168791905045509, 0.168846994638443, 0.168902054429054, 0.168957054615021, 0.169012054800987, 0.16906701028347, 0.169121935963631, 0.169176831841469, 0.169231697916985, 0.169286549091339, 0.169341340661049, 0.169396117329597, 0.169450864195824, 0.169505596160889, 0.169560268521309, 0.169614925980568, 0.169669568538666, 0.169724136590958, 0.169778719544411, 0.169833242893219, 0.169887766242027, 0.169942229986191, 0.169996693730354, 0.170051097869873, 0.170105472207069, 0.170159816741943, 0.170214161276817, 0.170268446207047, 0.170322716236115, 0.17037695646286, 0.170431137084961, 0.170485332608223, 0.17053946852684, 0.170593559741974, 0.170647650957108, 0.170701697468758, 0.170755729079247, 0.170809715986252, 0.170863687992096, 0.170917615294456, 0.170971512794495, 0.171025365591049, 0.171079233288765, 0.171133026480675, 0.171186804771423, 0.171240568161011, 0.171294271945953, 0.171347975730896, 0.171401619911194, 0.171455264091492, 0.171508848667145, 0.171562433242798, 0.171615958213806, 0.171669483184814, 0.171722933650017, 0.17177639901638, 0.171829789876938, 0.171883195638657, 0.171936541795731, 0.171989858150482, 0.172043189406395, 0.172096431255341, 0.172149688005447, 0.172202870249748, 0.172256052494049, 0.172309190034866, 0.172362312674522, 0.172415390610695, 0.172468453645706, 0.172521471977234, 0.1725744754076, 0.172627419233322, 0.172680363059044, 0.172733262181282, 0.172786146402359, 0.172838985919952, 0.172891795635223, 0.172944575548172, 0.172997310757637, 0.173050060868263, 0.173102751374245, 0.173155412077904, 0.173208028078079, 0.173260629177094, 0.173313200473785, 0.173365741968155, 0.173418253660202, 0.173470720648766, 0.173523172736168, 0.173575595021248, 0.173627987504005, 0.173680350184441, 0.173732683062553, 0.173784971237183, 0.173837229609489, 0.173889487981796, 0.173941686749458, 0.173993855714798, 0.174046009778976, 0.174098134040833, 0.174150198698044, 0.174202263355255, 0.174254298210144, 0.174306288361549, 0.174358248710632, 0.174410194158554, 0.174462094902992, 0.174513980746269, 0.174565806984901, 0.174617618322372, 0.174669414758682, 0.174721151590347, 0.174772888422012, 0.174824580550194, 0.174876227974892, 0.174927890300751, 0.174979478120804, 0.175031036138535, 0.175082594156265, 0.175134107470512, 0.175185605883598, 0.175237044692039, 0.175288453698158, 0.175339862704277, 0.175391212105751, 0.175442561507225, 0.175493851304054, 0.175545111298561, 0.175596341490746, 0.175647556781769, 0.17569874227047, 0.175749897956848, 0.175801008939743, 0.175852090120316, 0.175903171300888, 0.175954192876816, 0.176005184650421, 0.176056146621704, 0.176107108592987, 0.176158010959625, 0.176208883523941, 0.176259711384773, 0.176310539245605, 0.176361337304115, 0.176412090659142, 0.176462799310684, 0.176513507962227, 0.176564171910286, 0.176614806056023, 0.176665395498276, 0.176715970039368, 0.176766529679298, 0.176817044615746, 0.176867514848709, 0.176917970180511, 0.176968410611153, 0.177018791437149, 0.177069172263145, 0.177119493484497, 0.177169784903526, 0.177220076322556, 0.177270323038101, 0.177320510149002, 0.177370712161064, 0.177420854568481, 0.177470967173576, 0.177521079778671, 0.177571132779121, 0.17762117087841, 0.177671164274216, 0.177721127867699, 0.17777107656002, 0.177820965647697, 0.177870869636536, 0.177920699119568, 0.177970513701439, 0.178020313382149, 0.178070068359375, 0.17811980843544, 0.17816948890686, 0.178219169378281, 0.178268820047379, 0.178318426012993, 0.178368002176285, 0.178417533636093, 0.17846705019474, 0.178516536951065, 0.178566008806229, 0.178615421056747, 0.178664818406105, 0.178714171051979, 0.178763508796692, 0.178812831640244, 0.17886209487915, 0.178911328315735, 0.178960546851158, 0.179009735584259, 0.179058894515038, 0.179108023643494, 0.179157108068466, 0.179206162691116, 0.179255202412605, 0.179304212331772, 0.179353177547455, 0.179402127861977, 0.179451048374176, 0.179499924182892, 0.179548770189285, 0.179597571492195, 0.179646372795105, 0.179695144295692, 0.179743871092796, 0.179792568087578, 0.179841235280037, 0.179889872670174, 0.179938480257988, 0.17998705804348, 0.180035620927811, 0.180084139108658, 0.180132627487183, 0.180181071162224, 0.180229499936104, 0.180277913808823, 0.180326268076897, 0.18037460744381, 0.1804229170084, 0.180471181869507, 0.180519461631775, 0.180567651987076, 0.180615857243538, 0.180663987994194, 0.180712133646011, 0.180760219693184, 0.180808275938034, 0.180856332182884, 0.180904313921928, 0.180952295660973, 0.181000247597694, 0.181048169732094, 0.181096062064171, 0.181143894791603, 0.181191727519035, 0.181239515542984, 0.18128727376461, 0.181335002183914, 0.181382715702057, 0.181430384516716, 0.181478038430214, 0.181525647640228, 0.18157322704792, 0.18162077665329, 0.181668296456337, 0.181715786457062, 0.181763231754303, 0.181810662150383, 0.181858077645302, 0.181905463337898, 0.18195278942585, 0.18200010061264, 0.182047367095947, 0.182094633579254, 0.182141840457916, 0.182189017534256, 0.182236209511757, 0.182283312082291, 0.182330429553986, 0.182377472519875, 0.182424515485764, 0.182471543550491, 0.182518497109413, 0.182565450668335, 0.182612374424934, 0.18265925347805, 0.182706102728844, 0.182752951979637, 0.182799726724625, 0.182846501469612, 0.182893231511116, 0.182939931750298, 0.182986617088318, 0.183033257722855, 0.183079868555069, 0.183126449584961, 0.183173015713692, 0.1832195520401, 0.183266043663025, 0.183312505483627, 0.183358907699585, 0.183405339717865, 0.183451682329178, 0.183498054742813, 0.183544352650642, 0.18359063565731, 0.183636873960495, 0.183683097362518, 0.183729290962219, 0.183775454759598, 0.183821573853493, 0.183867692947388, 0.183913752436638, 0.183959797024727, 0.184005796909332, 0.184051781892776, 0.184097737073898, 0.184143647551537, 0.184189543128014, 0.184235408902168, 0.184281215071678, 0.184327021241188, 0.184372797608376, 0.184418514370918, 0.184464246034622, 0.184509918093681, 0.184555560350418, 0.184601172804832, 0.184646755456924, 0.184692323207855, 0.184737831354141, 0.184783339500427, 0.18482880294323, 0.18487423658371, 0.184919625520706, 0.184965014457703, 0.185010373592377, 0.185055688023567, 0.185100957751274, 0.185146227478981, 0.185191437602043, 0.185236632823944, 0.185281798243523, 0.185326918959618, 0.185372024774551, 0.185417100787163, 0.185462132096291, 0.185507163405418, 0.18555212020874, 0.185597091913223, 0.1856419891119, 0.185686901211739, 0.185731753706932, 0.185776576399803, 0.185821384191513, 0.185866162180901, 0.185910895466805, 0.185955598950386, 0.186000287532806, 0.186044931411743, 0.186089530587196, 0.186134144663811, 0.186178684234619, 0.186223223805428, 0.186267733573914, 0.186312183737755, 0.186356619000435, 0.186401039361954, 0.186445415019989, 0.186489760875702, 0.186534076929092, 0.186578363180161, 0.186622619628906, 0.18666684627533, 0.186711043119431, 0.186755210161209, 0.186799347400665, 0.186843454837799, 0.186887517571449, 0.186931580305099, 0.186975583434105, 0.187019556760788, 0.187063530087471, 0.187107443809509, 0.187151327729225, 0.18719519674778, 0.187239021062851, 0.187282830476761, 0.187326595187187, 0.187370344996452, 0.187414050102234, 0.187457725405693, 0.187501385807991, 0.187545001506805, 0.187588602304459, 0.187632158398628, 0.187675684690475, 0.18771918118, 0.187762662768364, 0.187806099653244, 0.187849506735802, 0.187892884016037, 0.18793623149395, 0.18797954916954, 0.188022837042809, 0.188066110014915, 0.188109338283539, 0.188152521848679, 0.188195690512657, 0.188238829374313, 0.188281938433647, 0.188325017690659, 0.188368067145348, 0.188411071896553, 0.188454061746597, 0.188497021794319, 0.188539952039719, 0.188582852482796, 0.188625708222389, 0.18866853415966, 0.188711330294609, 0.188754141330719, 0.188796862959862, 0.188839584589005, 0.188882246613503, 0.188924908638, 0.188967540860176, 0.189010128378868, 0.189052686095238, 0.189095228910446, 0.189137727022171, 0.189180195331573, 0.189222633838654, 0.189265057444572, 0.189307436347008, 0.189349785447121, 0.189392104744911, 0.189434394240379, 0.189476653933525, 0.189518883824348, 0.189561069011688, 0.189603239297867, 0.189645394682884, 0.189687490463257, 0.189729586243629, 0.189771637320518, 0.189813643693924, 0.189855650067329, 0.18989759683609, 0.189939513802528, 0.189981415867805, 0.19002328813076, 0.190065115690231, 0.190106943249702, 0.190148711204529, 0.190190449357033, 0.190232172608376, 0.190273866057396, 0.190315514802933, 0.190357148647308, 0.1903987377882, 0.190440312027931, 0.190481841564178, 0.190523341298103, 0.190564826130867, 0.190606251358986, 0.190647661685944, 0.19068905711174, 0.190730407834053, 0.190771743655205, 0.190813019871712, 0.190854281187057, 0.190895512700081, 0.190936729311943, 0.19097788631916, 0.191019028425217, 0.191060155630112, 0.191101223230362, 0.191142275929451, 0.191183283925056, 0.191224306821823, 0.191265240311623, 0.191306173801422, 0.19134709239006, 0.191387951374054, 0.191428795456886, 0.191469609737396, 0.191510379314423, 0.191551133990288, 0.191591843962669, 0.19163253903389, 0.191673189401627, 0.191713809967041, 0.191754400730133, 0.191794991493225, 0.191835522651672, 0.191876038908958, 0.1919164955616, 0.19195693731308, 0.191997364163399, 0.192037761211395, 0.192078113555908, 0.192118436098099, 0.192158743739128, 0.192198991775513, 0.192239239811897, 0.192279428243637, 0.192319601774216, 0.192359760403633, 0.192399889230728, 0.192439958453178, 0.192479997873306, 0.192520037293434, 0.192560017108917, 0.192599982023239, 0.1926399320364, 0.192679822444916, 0.192719683051109, 0.192759528756142, 0.192799344658852, 0.192839130759239, 0.192878887057304, 0.192918583750725, 0.192958280444145, 0.192997962236404, 0.193037584424019, 0.193077191710472, 0.193116739392281, 0.193156272172928, 0.193195790052414, 0.193235263228416, 0.193274721503258, 0.193314135074615, 0.193353518843651, 0.193392902612686, 0.193432211875916, 0.193471521139145, 0.193510785698891, 0.193550020456314, 0.193589210510254, 0.193628415465355, 0.19366754591465, 0.193706661462784, 0.193745747208595, 0.193784803152084, 0.193823829293251, 0.193862825632095, 0.193901792168617, 0.193940714001656, 0.193979635834694, 0.194018512964249, 0.19405734539032, 0.19409616291523, 0.194134935736656, 0.194173693656921, 0.194212421774864, 0.194251105189323, 0.194289788603783, 0.194328412413597, 0.194367006421089, 0.19440558552742, 0.194444105029106, 0.194482624530792, 0.194521129131317, 0.194559559226036, 0.194597974419594, 0.19463637471199, 0.194674760103226, 0.194713085889816, 0.194751366972923, 0.194789633154869, 0.194827869534492, 0.194866091012955, 0.194904267787933, 0.19494241476059, 0.194980531930923, 0.195018619298935, 0.195056676864624, 0.195094704627991, 0.195132702589035, 0.195170685648918, 0.195208609104156, 0.195246532559395, 0.195284396409988, 0.19532223045826, 0.19536004960537, 0.195397824048996, 0.195435613393784, 0.195473313331604, 0.195511013269424, 0.195545390248299, 0.195576474070549, 0.195607483386993, 0.195638462901115, 0.195669382810593, 0.195700287818909, 0.195731118321419, 0.195761904120445, 0.195792660117149, 0.195823341608047, 0.195853993296623, 0.195884600281715, 0.195915162563324, 0.195945650339127, 0.195976123213768, 0.196006536483765, 0.196036890149117, 0.196067228913307, 0.196097478270531, 0.196127727627754, 0.196157887578011, 0.196188017725945, 0.196218088269234, 0.196248129010201, 0.196278110146523, 0.196308061480522, 0.196337953209877, 0.196367815136909, 0.196397602558136, 0.19642736017704, 0.196457058191299, 0.196486741304398, 0.196516335010529, 0.196545898914337, 0.196575418114662, 0.196604877710342, 0.1966343075037, 0.196663677692413, 0.196693018078804, 0.196722283959389, 0.196751520037651, 0.19678071141243, 0.196809858083725, 0.196838945150375, 0.196868002414703, 0.196896985173225, 0.196925938129425, 0.19695483148098, 0.196983709931374, 0.1970124989748, 0.197041273117065, 0.197069987654686, 0.197098657488823, 0.197127282619476, 0.197155863046646, 0.197184383869171, 0.197212874889374, 0.19724129140377, 0.197269678115845, 0.197298020124435, 0.197326317429543, 0.197354555130005, 0.197382748126984, 0.19741091132164, 0.19743900001049, 0.197467058897018, 0.197495073080063, 0.197523012757301, 0.19755095243454, 0.197578832507133, 0.197606638073921, 0.197634398937225, 0.197662115097046, 0.197689816355705, 0.197717443108559, 0.197745025157928, 0.197772562503815, 0.197800055146217, 0.197827488183975, 0.197854891419411, 0.197882235050201, 0.197909533977509, 0.197936803102493, 0.197963997721672, 0.197991162538528, 0.198018252849579, 0.198045328259468, 0.198072344064713, 0.198099315166473, 0.198126241564751, 0.198153123259544, 0.198179945349693, 0.19820673763752, 0.198233485221863, 0.1982601583004, 0.198286801576614, 0.198313400149345, 0.19833992421627, 0.198366448283195, 0.198392897844315, 0.19841930270195, 0.198445662856102, 0.198471963405609, 0.198498234152794, 0.198524430394173, 0.198550596833229, 0.198576748371124, 0.198602810502052, 0.198628857731819, 0.19865483045578, 0.198680758476257, 0.198706641793251, 0.198732480406761, 0.198758274316788, 0.198784023523331, 0.19880972802639, 0.198835372924805, 0.198860988020897, 0.198886543512344, 0.198912039399147, 0.198937505483627, 0.198962911963463, 0.198988288640976, 0.199013605713844, 0.19903889298439, 0.199064090847969, 0.199089288711548, 0.199114426970482, 0.199139505624771, 0.199164539575577, 0.199189528822899, 0.199214473366737, 0.199239373207092, 0.199264228343964, 0.19928902387619, 0.199313789606094, 0.199338495731354, 0.19936315715313, 0.199387773871422, 0.19941234588623, 0.199436873197556, 0.199461326003075, 0.199485749006271, 0.199510127305984, 0.199534446001053, 0.199558734893799, 0.199582979083061, 0.199607148766518, 0.199631288647652, 0.199655413627625, 0.199679464101791, 0.199703454971313, 0.199727416038513, 0.199751317501068, 0.199775174260139, 0.199798986315727, 0.199822753667831, 0.199846461415291, 0.199870139360428, 0.19989375770092, 0.199917331337929, 0.199940875172615, 0.199964344501495, 0.199987784028053, 0.200011193752289, 0.200034499168396, 0.200057789683342, 0.200081050395966, 0.200104251503944, 0.20012740790844, 0.200150519609451, 0.200173556804657, 0.200196579098701, 0.200219541788101, 0.200242474675179, 0.20026533305645, 0.200288146734238, 0.200310945510864, 0.200333654880524, 0.200356334447861, 0.200378969311714, 0.200401559472084, 0.200424090027809, 0.200446590781212, 0.20046903192997, 0.200491413474083, 0.200513780117035, 0.200536087155342, 0.200558334589005, 0.200580552220345, 0.20060271024704, 0.200624823570251, 0.20064689218998, 0.200668916106224, 0.200690895318985, 0.200712814927101, 0.200734704732895, 0.200756520032883, 0.200778290629387, 0.20080004632473, 0.200821742415428, 0.200843378901482, 0.200864970684052, 0.200886517763138, 0.200908035039902, 0.20092947781086, 0.200950890779495, 0.200972259044647, 0.200993567705154, 0.201014831662178, 0.201036050915718, 0.201057225465775, 0.201078340411186, 0.201099440455437, 0.20112045109272, 0.201141446828842, 0.20116238296032, 0.201183259487152, 0.201204106211662, 0.201224908232689, 0.201245665550232, 0.201266348361969, 0.201287001371384, 0.201307624578476, 0.201328173279762, 0.201348662376404, 0.201369136571884, 0.201389566063881, 0.201409935951233, 0.201430261135101, 0.201450541615486, 0.201470762491226, 0.201490953564644, 0.201511085033417, 0.201531156897545, 0.201551198959351, 0.201571211218834, 0.201591148972511, 0.201611042022705, 0.201630890369415, 0.201650694012642, 0.201670467853546, 0.201690182089806, 0.20170983672142, 0.201729461550713, 0.20174902677536, 0.201768547296524, 0.201788023114204, 0.20180743932724, 0.201826810836792, 0.201846167445183, 0.201865449547768, 0.201884686946869, 0.201903879642487, 0.201923012733459, 0.20194211602211, 0.201961189508438, 0.201980173587799, 0.201999112963676, 0.202018037438393, 0.202036887407303, 0.202055707573891, 0.202074483036995, 0.202093213796616, 0.202111884951591, 0.202130511403084, 0.202149093151093, 0.202167615294456, 0.202186077833176, 0.202204540371895, 0.202222913503647, 0.202241271734238, 0.202259570360184, 0.202277809381485, 0.202296003699303, 0.202314168214798, 0.20233228802681, 0.202350333333015, 0.20236836373806, 0.202386319637299, 0.202404230833054, 0.202422097325325, 0.202439934015274, 0.202457696199417, 0.202475443482399, 0.202493116259575, 0.202510759234428, 0.202528357505798, 0.202545896172523, 0.202563390135765, 0.202580824494362, 0.202598229050636, 0.202615574002266, 0.202632889151573, 0.202650144696236, 0.202667355537415, 0.202684536576271, 0.202701658010483, 0.202718704938889, 0.202735736966133, 0.202752709388733, 0.202769637107849, 0.202786535024643, 0.202803358435631, 0.202820152044296, 0.202836886048317, 0.202853575348854, 0.202870234847069, 0.202886819839478, 0.202903375029564, 0.202919870615005, 0.202936336398125, 0.202952742576599, 0.202969118952751, 0.202985420823097, 0.203001692891121, 0.203017920255661, 0.203034088015556, 0.203050211071968, 0.203066304326057, 0.203082337975502, 0.203098312020302, 0.20311427116394, 0.203130140900612, 0.203145995736122, 0.203161790966988, 0.20317754149437, 0.203193247318268, 0.203208908438683, 0.203224495053291, 0.203240051865578, 0.203255578875542, 0.203271046280861, 0.203286468982697, 0.203301846981049, 0.203317165374756, 0.20333243906498, 0.203347682952881, 0.203362852334976, 0.203377991914749, 0.2033931016922, 0.203408122062683, 0.203423127532005, 0.203438073396683, 0.203452974557877, 0.203467831015587, 0.203482627868652, 0.203497409820557, 0.203512102365494, 0.20352678000927, 0.203541398048401, 0.203555971384048, 0.203570500016212, 0.203584969043732, 0.203599393367767, 0.203613787889481, 0.203628107905388, 0.203642383217812, 0.203656643629074, 0.203670859336853, 0.203685000538826, 0.203699082136154, 0.20371313393116, 0.203727155923843, 0.203741103410721, 0.203755035996437, 0.203768864274025, 0.203782707452774, 0.203796461224556, 0.203810200095177, 0.203823879361153, 0.203837484121323, 0.20385105907917, 0.203864619135857, 0.203878089785576, 0.203891530632973, 0.203904926776886, 0.203918278217316, 0.203931570053101, 0.203944832086563, 0.203958034515381, 0.203971177339554, 0.203984275460243, 0.20399734377861, 0.204010367393494, 0.204023331403732, 0.204036265611649, 0.20404914021492, 0.204061955213547, 0.204074755311012, 0.204087495803833, 0.204100146889687, 0.204112812876701, 0.20412540435791, 0.204137936234474, 0.204150423407555, 0.204162880778313, 0.204175278544426, 0.204187646508217, 0.204199954867363, 0.204212218523026, 0.204224437475204, 0.204236596822739, 0.204248711466789, 0.204260781407356, 0.20427280664444, 0.204284802079201, 0.204296723008156, 0.204308614134789, 0.204320445656776, 0.204332232475281, 0.204343974590302, 0.204355672001839, 0.204367309808731, 0.204378917813301, 0.204390481114388, 0.204401984810829, 0.204413443803787, 0.204424843192101, 0.204436212778091, 0.204447522759438, 0.204458817839622, 0.204470038414001, 0.204481214284897, 0.204492345452309, 0.204503417015076, 0.204514443874359, 0.20452544093132, 0.204536378383636, 0.20454728603363, 0.204558134078979, 0.204568937420845, 0.204579666256905, 0.204590380191803, 0.204601049423218, 0.204611659049988, 0.204622223973274, 0.204632729291916, 0.204643189907074, 0.20465362071991, 0.204663991928101, 0.204674318432808, 0.204684615135193, 0.204694837331772, 0.204705029726028, 0.20471516251564, 0.20472526550293, 0.204735293984413, 0.204745307564735, 0.204755276441574, 0.204765170812607, 0.204775035381317, 0.20478481054306, 0.204794585704803, 0.204804316163063, 0.204813957214355, 0.204823598265648, 0.204833164811134, 0.204842686653137, 0.204852193593979, 0.204861611127853, 0.204870983958244, 0.204880326986313, 0.204889610409737, 0.204898878931999, 0.204908058047295, 0.20491723716259, 0.204926311969757, 0.204935371875763, 0.204944387078285, 0.204953342676163, 0.204962253570557, 0.204971134662628, 0.204979956150055, 0.204988718032837, 0.204997435212135, 0.205006122589111, 0.205014750361443, 0.205023318529129, 0.205031871795654, 0.205040350556374, 0.205048799514771, 0.205057188868523, 0.205065548419952, 0.205073833465576, 0.205082103610039, 0.205090284347534, 0.205098450183868, 0.205106556415558, 0.205114647746086, 0.20512267947197, 0.205130636692047, 0.205138564109802, 0.205146431922913, 0.205154269933701, 0.205162048339844, 0.205169782042503, 0.205177471041679, 0.205185115337372, 0.205192700028419, 0.205200240015984, 0.205207750201225, 0.205215200781822, 0.205222606658936, 0.205229952931404, 0.205237254500389, 0.205244526267052, 0.205251753330231, 0.205258920788765, 0.205266058444977, 0.205273121595383, 0.205280140042305, 0.205287128686905, 0.20529405772686, 0.205300942063332, 0.20530778169632, 0.205314576625824, 0.205321326851845, 0.205328017473221, 0.205334663391113, 0.205341264605522, 0.205347836017609, 0.205354332923889, 0.205360800027847, 0.205367207527161, 0.205373600125313, 0.205379903316498, 0.20538617670536, 0.205392405390739, 0.205398589372635, 0.205404728651047, 0.205410808324814, 0.205416828393936, 0.205422833561897, 0.205428779125214, 0.205434665083885, 0.205440506339073, 0.205446317791939, 0.20545206964016, 0.205457791686058, 0.205463439226151, 0.205469056963921, 0.205474615097046, 0.20548015832901, 0.205485612154007, 0.205491036176682, 0.205496430397034, 0.20550175011158, 0.205507040023804, 0.205512270331383, 0.205517455935478, 0.20552259683609, 0.205527693033218, 0.205532729625702, 0.205537751317024, 0.205542698502541, 0.205547615885735, 0.205552458763123, 0.205557271838188, 0.205562055110931, 0.205566763877869, 0.205571427941322, 0.205576047301292, 0.20558063685894, 0.205585151910782, 0.205589637160301, 0.205594062805176, 0.205598473548889, 0.205602794885635, 0.20560710132122, 0.205611348152161, 0.205615535378456, 0.20561970770359, 0.205623790621758, 0.205627858638763, 0.205631867051125, 0.205635830760002, 0.205639749765396, 0.205643624067307, 0.205647423863411, 0.205651208758354, 0.205654934048653, 0.205658629536629, 0.205662250518799, 0.205665841698647, 0.205669373273849, 0.20567287504673, 0.205676302313805, 0.205679699778557, 0.205683052539825, 0.20568636059761, 0.205689623951912, 0.205692827701569, 0.205696001648903, 0.205699101090431, 0.205702170729637, 0.205705180764198, 0.205708175897598, 0.205711081624031, 0.205713972449303, 0.20571680366993, 0.205719590187073, 0.205722317099571, 0.205725029110909, 0.205727651715279, 0.205730259418488, 0.205732807517052, 0.205735296010971, 0.205737769603729, 0.205740168690681, 0.20574252307415, 0.205744832754135, 0.205747112631798, 0.205749332904816, 0.205751493573189, 0.20575362443924, 0.205755680799484, 0.205757737159729, 0.205759719014168, 0.205761656165123, 0.205763518810272, 0.205765381455421, 0.205767184495926, 0.205768913030624, 0.205770611763, 0.205772280693054, 0.205773875117302, 0.205775439739227, 0.205776944756508, 0.205778419971466, 0.205779835581779, 0.205781191587448, 0.205782517790794, 0.205783799290657, 0.205785036087036, 0.20578621327877, 0.205787360668182, 0.205788433551788, 0.205789461731911, 0.205790475010872, 0.205791413784027, 0.20579232275486, 0.205793172121048, 0.205793976783752, 0.205794721841812, 0.205795437097549, 0.205796092748642, 0.205796733498573, 0.205797269940376, 0.205797806382179, 0.205798298120499, 0.205798700451851, 0.205799087882042, 0.205799430608749, 0.205799698829651, 0.205799967050552, 0.205800145864487, 0.205800279974937, 0.205800369381905, 0.205800428986549, 0.205800428986549, 0.205800384283066, 0.20580030977726, 0.205800160765648, 0.205799981951714, 0.205799743533134, 0.205799460411072, 0.205799147486687, 0.205798774957657, 0.205798327922821, 0.205797851085663, 0.205797359347343, 0.205796778202057, 0.205796182155609, 0.205795526504517, 0.20579482614994, 0.20579406619072, 0.205793276429176, 0.205792427062988, 0.205791518092155, 0.205790594220161, 0.205789610743523, 0.205788567662239, 0.205787494778633, 0.205786377191544, 0.205785199999809, 0.20578396320343, 0.205782696604729, 0.205781355500221, 0.205780014395714, 0.205778613686562, 0.205777138471603, 0.205775633454323, 0.205774083733559, 0.205772489309311, 0.205770835280418, 0.205769136548042, 0.205767393112183, 0.205765604972839, 0.205763787031174, 0.205761894583702, 0.205759972333908, 0.205757990479469, 0.205755963921547, 0.205753892660141, 0.20575176179409, 0.205749601125717, 0.20574739575386, 0.205745130777359, 0.205742821097374, 0.205740481615067, 0.205738067626953, 0.205735623836517, 0.205733135342598, 0.205730587244034, 0.205727994441986, 0.205725356936455, 0.20572267472744, 0.205719962716103, 0.205717161297798, 0.205714344978333, 0.205711469054222, 0.205708548426628, 0.205705583095551, 0.205702558159828, 0.205699503421783, 0.205696389079094, 0.205693230032921, 0.205690041184425, 0.205686792731285, 0.2056834846735, 0.205680146813393, 0.20567674934864, 0.205673322081566, 0.205669820308685, 0.205666273832321, 0.205662712454796, 0.205659076571465, 0.20565539598465, 0.205651685595512, 0.20564791560173, 0.205644100904465, 0.205640241503716, 0.205636337399483, 0.205632388591766, 0.205628380179405, 0.205624297261238, 0.205620214343071, 0.20561608672142, 0.205611899495125, 0.205607652664185, 0.2056033462286, 0.205599009990692, 0.205594629049301, 0.205590218305588, 0.205585733056068, 0.205581203103065, 0.205576628446579, 0.20557202398777, 0.205567359924316, 0.205562651157379, 0.205557882785797, 0.205553069710732, 0.205548211932182, 0.205543324351311, 0.205538377165794, 0.205533400177956, 0.20552833378315, 0.205523252487183, 0.20551809668541, 0.205512925982475, 0.205507695674896, 0.205502435564995, 0.205497100949287, 0.205491721630096, 0.205486312508583, 0.205480843782425, 0.205475330352783, 0.205469772219658, 0.205464154481888, 0.205458506941795, 0.205452814698219, 0.205447062849998, 0.205441266298294, 0.205435410141945, 0.205429524183273, 0.205423593521118, 0.205417603254318, 0.205411568284035, 0.205405488610268, 0.205399364233017, 0.205393195152283, 0.205386966466904, 0.205380693078041, 0.205374389886856, 0.205368027091026, 0.205361619591713, 0.205355152487755, 0.205348670482635, 0.20534211397171, 0.205335512757301, 0.20532888174057, 0.205322191119194, 0.205315425992012, 0.20530866086483, 0.205301821231842, 0.20529493689537, 0.205288007855415, 0.205281049013138, 0.205274000763893, 0.205266952514648, 0.205259829759598, 0.205252677202225, 0.205245450139046, 0.205238193273544, 0.205230891704559, 0.20522353053093, 0.205216139554977, 0.205208703875542, 0.205201208591461, 0.205193668603897, 0.205186083912849, 0.205178439617157, 0.205170765519142, 0.205163031816483, 0.205155253410339, 0.205147430300713, 0.205139547586441, 0.205131635069847, 0.20512367784977, 0.205115661025047, 0.205107599496841, 0.205099493265152, 0.205091327428818, 0.205083131790161, 0.205074891448021, 0.205066606402397, 0.205058261752129, 0.205049872398376, 0.205041438341141, 0.205032974481583, 0.205024421215057, 0.20501583814621, 0.205007210373878, 0.204998552799225, 0.204989820718765, 0.204981043934822, 0.204972252249718, 0.204963371157646, 0.204954475164413, 0.204945519566536, 0.204936519265175, 0.20492747426033, 0.204918384552002, 0.204909235239029, 0.204900056123734, 0.204890802502632, 0.204881519079208, 0.204872190952301, 0.20486281812191, 0.204853385686874, 0.204843908548355, 0.204834401607513, 0.204824820160866, 0.204815194010735, 0.204805538058281, 0.204795822501183, 0.204786077141762, 0.204776257276535, 0.204766422510147, 0.204756528139114, 0.204746589064598, 0.204736590385437, 0.204726561903954, 0.204716444015503, 0.204706326127052, 0.204696148633957, 0.204685911536217, 0.204675644636154, 0.204665318131447, 0.204654946923256, 0.204644545912743, 0.204634085297585, 0.204623565077782, 0.204613000154495, 0.204602390527725, 0.204591736197472, 0.204581037163734, 0.204570293426514, 0.204559504985809, 0.20454865694046, 0.204537779092789, 0.204526841640472, 0.204515859484673, 0.204504817724228, 0.204493746161461, 0.204482614994049, 0.204471468925476, 0.204460233449936, 0.204448968172073, 0.204437658190727, 0.204426318407059, 0.204414889216423, 0.204403430223465, 0.204391941428185, 0.204380393028259, 0.20436879992485, 0.204357162117958, 0.204345479607582, 0.204333737492561, 0.204321950674057, 0.204310119152069, 0.204298242926598, 0.204286321997643, 0.204274326562881, 0.20426233112812, 0.204250246286392, 0.204238131642342, 0.204225972294807, 0.204213783144951, 0.204201519489288, 0.204189226031303, 0.204176858067513, 0.20416447520256, 0.204152017831802, 0.204139530658722, 0.204126983880997, 0.204114407300949, 0.204101771116257, 0.204089090228081, 0.204076364636421, 0.204063594341278, 0.20405076444149, 0.20403790473938, 0.204025000333786, 0.204012036323547, 0.203999027609825, 0.203985974192619, 0.203972861170769, 0.203959703445435, 0.203946530818939, 0.203933268785477, 0.203919976949692, 0.203906625509262, 0.203893259167671, 0.203879803419113, 0.203866332769394, 0.20385280251503, 0.203839227557182, 0.203825607895851, 0.203811943531036, 0.203798204660416, 0.203784450888634, 0.203770652413368, 0.203756779432297, 0.203742876648903, 0.203728944063187, 0.203714922070503, 0.203700885176659, 0.203686788678169, 0.203672632575035, 0.20365846157074, 0.2036442309618, 0.203629940748215, 0.203615620732307, 0.203601241111755, 0.20358681678772, 0.203572347760201, 0.203557819128036, 0.20354326069355, 0.20352865755558, 0.203513979911804, 0.203499287366867, 0.203484520316124, 0.203469723463058, 0.203454881906509, 0.203439965844154, 0.203425049781799, 0.203410059213638, 0.203395023941994, 0.203379929065704, 0.203364789485931, 0.203349620103836, 0.203334391117096, 0.203319117426872, 0.203303799033165, 0.203288435935974, 0.203273013234138, 0.20325756072998, 0.203242048621178, 0.203226491808891, 0.203210890293121, 0.203195258975029, 0.203179523348808, 0.203163802623749, 0.203147992491722, 0.203132182359695, 0.203116297721863, 0.203100338578224, 0.203084364533424, 0.203065350651741, 0.203043267130852, 0.20302115380764, 0.202998995780945, 0.202976807951927, 0.202954575419426, 0.202932298183441, 0.202909991145134, 0.202887639403343, 0.202865242958069, 0.202842831611633, 0.202820375561714, 0.20279785990715, 0.202775299549103, 0.202752724289894, 0.202730119228363, 0.202707439661026, 0.202684745192528, 0.202662006020546, 0.202639237046242, 0.202616408467293, 0.202593564987183, 0.202570661902428, 0.20254772901535, 0.202524766325951, 0.202501744031906, 0.2024787068367, 0.20245561003685, 0.202432483434677, 0.202409297227859, 0.202386125922203, 0.202362865209579, 0.202339574694633, 0.202316254377365, 0.202292889356613, 0.202269479632378, 0.202246055006981, 0.202222570776939, 0.202199056744576, 0.202175498008728, 0.202151894569397, 0.202128261327744, 0.202104598283768, 0.202080890536308, 0.202057138085365, 0.202033326029778, 0.20200951397419, 0.201985657215118, 0.201961725950241, 0.201937779784203, 0.201913803815842, 0.201889783143997, 0.201865717768669, 0.201841622591019, 0.201817467808723, 0.201793298125267, 0.201769083738327, 0.201744809746742, 0.201720505952835, 0.201696187257767, 0.201671823859215, 0.201647400856018, 0.201622933149338, 0.201598450541496, 0.201573923230171, 0.201549366116524, 0.201524764299393, 0.201500102877617, 0.201475411653519, 0.201450705528259, 0.201425939798355, 0.201401144266129, 0.201376274228096, 0.201351389288902, 0.201326489448547, 0.201301530003548, 0.201276525855064, 0.201251477003098, 0.201226413249969, 0.201201289892197, 0.201176136732101, 0.201150953769684, 0.201125711202621, 0.201100453734398, 0.20107513666153, 0.201049789786339, 0.201024428009987, 0.200998976826668, 0.200973510742188, 0.200947999954224, 0.200922474265099, 0.200896888971329, 0.200871258974075, 0.200845614075661, 0.200819909572601, 0.20079417526722, 0.200768381357193, 0.200742587447166, 0.200716719031334, 0.20069083571434, 0.200664892792702, 0.200638934969902, 0.200612902641296, 0.200586870312691, 0.200560763478279, 0.200534656643867, 0.200508490204811, 0.200482279062271, 0.200456038117409, 0.200429737567902, 0.200403422117233, 0.200377076864243, 0.200350672006607, 0.200324222445488, 0.200297743082047, 0.200271233916283, 0.200244680047035, 0.200218081474304, 0.200191453099251, 0.200164794921875, 0.200138077139854, 0.200111299753189, 0.200084507465363, 0.200057700276375, 0.200030833482742, 0.200003921985626, 0.199976965785027, 0.199949979782104, 0.19992296397686, 0.199895918369293, 0.199868813157082, 0.199841663241386, 0.199814483523369, 0.199787274003029, 0.199760004878044, 0.199732720851898, 0.199705377221107, 0.199678003787994, 0.19965061545372, 0.19962315261364, 0.199595645070076, 0.19956810772419, 0.199540540575981, 0.19951294362545, 0.199485301971436, 0.199457615613937, 0.199429899454117, 0.199402138590813, 0.199374333024025, 0.199346497654915, 0.199318617582321, 0.199290692806244, 0.199262723326683, 0.199234738945961, 0.199206709861755, 0.199178621172905, 0.199150517582893, 0.199122354388237, 0.199094161391258, 0.199065938591957, 0.199037656188011, 0.199009358882904, 0.198981016874313, 0.198952630162239, 0.198924198746681, 0.19889572262764, 0.198867231607437, 0.19883868098259, 0.19881010055542, 0.198781505227089, 0.198752820491791, 0.198724120855331, 0.198695376515388, 0.198666632175446, 0.198637798428535, 0.198608949780464, 0.198580056428909, 0.198551118373871, 0.198522165417671, 0.198493137955666, 0.19846411049366, 0.198435008525848, 0.198405891656876, 0.198376715183258, 0.198347523808479, 0.198318287730217, 0.198288977146149, 0.19825966656208, 0.198230311274529, 0.198200911283493, 0.198171481490135, 0.198142006993294, 0.198112487792969, 0.19808292388916, 0.198053330183029, 0.198023691773415, 0.197994023561478, 0.197964310646057, 0.197934553027153, 0.197904765605927, 0.197874948382378, 0.197845086455345, 0.197815179824829, 0.197785228490829, 0.197755247354507, 0.197725236415863, 0.197695165872574, 0.197665065526962, 0.197634920477867, 0.19760474562645, 0.197574526071548, 0.197544276714325, 0.197513982653618, 0.197483643889427, 0.197453275322914, 0.197422862052917, 0.197392404079437, 0.197361916303635, 0.197331383824348, 0.19730082154274, 0.197270229458809, 0.197239562869072, 0.197208881378174, 0.197178170084953, 0.197147414088249, 0.197116628289223, 0.19708576798439, 0.197054892778397, 0.197023957967758, 0.19699302315712, 0.196962013840675, 0.19693098962307, 0.196899905800819, 0.196868792176247, 0.196837648749352, 0.196806460618973, 0.19677522778511, 0.196743965148926, 0.196712642908096, 0.196681305766106, 0.196649923920631, 0.196618482470512, 0.196587026119232, 0.196555525064468, 0.196523994207382, 0.196492403745651, 0.196460783481598, 0.196429118514061, 0.19639740884304, 0.196365684270859, 0.196333900094032, 0.196302086114883, 0.196270257234573, 0.196238353848457, 0.196206405758858, 0.196174457669258, 0.196142464876175, 0.196110412478447, 0.196078315377235, 0.19604617357254, 0.196014031767845, 0.195981845259666, 0.195949569344521, 0.195917293429375, 0.195884972810745, 0.195852622389793, 0.195820212364197, 0.195787772536278, 0.195755302906036, 0.195722788572311, 0.195690244436264, 0.195657655596733, 0.195625022053719, 0.195592328906059, 0.195559620857239, 0.195526897907257, 0.195494100451469, 0.195461288094521, 0.195428401231766, 0.19539549946785, 0.195362567901611, 0.195329576730728, 0.195296555757523, 0.195263490080833, 0.195230394601822, 0.195197269320488, 0.195164084434509, 0.195130869746208, 0.195097610354424, 0.195064321160316, 0.195030972361565, 0.194997608661652, 0.194964200258255, 0.194930747151375, 0.194897264242172, 0.194863721728325, 0.194830164313316, 0.194796577095985, 0.194762915372849, 0.19472923874855, 0.194695502519608, 0.194661736488342, 0.194627955555916, 0.194594115018845, 0.19456022977829, 0.194526299834251, 0.194492354989052, 0.194458350539207, 0.194424331188202, 0.194390267133713, 0.19435615837574, 0.194322004914284, 0.194287806749344, 0.194253578782082, 0.194219321012497, 0.194185003638268, 0.194150656461716, 0.19411626458168, 0.194081842899323, 0.194047391414642, 0.194012895226479, 0.19397833943367, 0.1939437687397, 0.193909138441086, 0.19387449324131, 0.19383978843689, 0.193805068731308, 0.193770289421082, 0.193735465407372, 0.1937006264925, 0.193665742874146, 0.193630784749985, 0.193595811724663, 0.19356082379818, 0.193525776267052, 0.193490698933601, 0.193455576896667, 0.19342041015625, 0.193385198712349, 0.193349957466125, 0.19331468641758, 0.193279355764389, 0.193244010210037, 0.193208605051041, 0.19317315518856, 0.193137690424919, 0.193102180957794, 0.193066626787186, 0.193031027913094, 0.19299541413784, 0.192959740757942, 0.192924022674561, 0.192888274788857, 0.19285249710083, 0.19281667470932, 0.192780792713165, 0.192744895815849, 0.19270895421505, 0.192672967910767, 0.192636936903, 0.192600905895233, 0.192564785480499, 0.192528665065765, 0.192492485046387, 0.192456275224686, 0.192419990897179, 0.192383721470833, 0.192347392439842, 0.192311018705368, 0.192274615168571, 0.192238166928291, 0.192201673984528, 0.19216513633728, 0.192128568887711, 0.192091971635818, 0.192055329680443, 0.192018643021584, 0.191981926560402, 0.191945165395737, 0.191908359527588, 0.191871523857117, 0.191834658384323, 0.191797718405724, 0.191760778427124, 0.19172377884388, 0.191686749458313, 0.191649690270424, 0.191612556576729, 0.191575407981873, 0.191538229584694, 0.19150099158287, 0.191463723778725, 0.191426441073418, 0.191389083862305, 0.191351696848869, 0.191314294934273, 0.19127681851387, 0.191239297389984, 0.191201776266098, 0.191164195537567, 0.191126570105553, 0.191088929772377, 0.191051229834557, 0.191013500094414, 0.190975710749626, 0.190937906503677, 0.190900057554245, 0.19086217880249, 0.190824255347252, 0.190786257386208, 0.190748274326324, 0.190710231661797, 0.190672129392624, 0.19063401222229, 0.190595850348473, 0.190557643771172, 0.190519407391548, 0.190481126308441, 0.190442800521851, 0.190404444932938, 0.190366044640541, 0.190327599644661, 0.190289154648781, 0.190250635147095, 0.190212070941925, 0.190173476934433, 0.19013486802578, 0.19009618461132, 0.190057471394539, 0.190018728375435, 0.189979955554008, 0.189941138029099, 0.189902260899544, 0.189863353967667, 0.189824417233467, 0.189785435795784, 0.189746424555779, 0.189707353711128, 0.189668267965317, 0.189629137516022, 0.189589947462082, 0.18955072760582, 0.189511477947235, 0.189472198486328, 0.189432844519615, 0.189393490552902, 0.189354076981544, 0.189314618706703, 0.189275130629539, 0.189235612750053, 0.189196050167084, 0.189156457781792, 0.189116805791855, 0.189077123999596, 0.189037397503853, 0.188997626304626, 0.1889578551054, 0.188918009400368, 0.188878148794174, 0.188838213682175, 0.188798263669014, 0.18875826895237, 0.188718244433403, 0.188678175210953, 0.18863807618618, 0.188597902655602, 0.188557714223862, 0.188517481088638, 0.188477218151093, 0.188436895608902, 0.188396587967873, 0.188356190919876, 0.188315764069557, 0.188275307416916, 0.188234820961952, 0.188194274902344, 0.188153699040413, 0.188113078474998, 0.188072428107262, 0.188031747937202, 0.187991008162498, 0.187950238585472, 0.187909424304962, 0.187868550419807, 0.187827676534653, 0.187786757946014, 0.187745779752731, 0.187704771757126, 0.187663733959198, 0.187622651457787, 0.187581524252892, 0.187540367245674, 0.187499150633812, 0.187457919120789, 0.187416657805443, 0.187375321984291, 0.187333956360817, 0.18729256093502, 0.187251150608063, 0.187209665775299, 0.187168151140213, 0.187126606702805, 0.187085017561913, 0.187043398618698, 0.187001720070839, 0.186960011720657, 0.186918258666992, 0.186876475811005, 0.186834648251534, 0.18679279088974, 0.186750873923302, 0.186708956956863, 0.18666698038578, 0.186624944210052, 0.186582893133163, 0.18654078245163, 0.186498656868935, 0.186456501483917, 0.186414271593094, 0.186372026801109, 0.18632972240448, 0.186287418007851, 0.186245024204254, 0.186202615499496, 0.186160162091255, 0.186117678880692, 0.186075165867805, 0.186032608151436, 0.185989990830421, 0.185947358608246, 0.185904666781425, 0.185861960053444, 0.185819208621979, 0.185776397585869, 0.185733556747437, 0.185690671205521, 0.185647770762444, 0.185604810714722, 0.185561820864677, 0.185518801212311, 0.185475721955299, 0.185432612895966, 0.185389474034309, 0.185346275568008, 0.185303062200546, 0.185259774327278, 0.18521648645401, 0.185173138976097, 0.185129776597023, 0.185086339712143, 0.18504287302494, 0.184999391436577, 0.184955835342407, 0.184912279248238, 0.184868648648262, 0.184824988245964, 0.184781283140182, 0.184737578034401, 0.184693798422813, 0.184649989008904, 0.18460613489151, 0.184562250971794, 0.184518337249756, 0.184474363923073, 0.184430360794067, 0.184386312961578, 0.184342235326767, 0.184298098087311, 0.184253945946693, 0.184209734201431, 0.184165492653847, 0.184121236205101, 0.184076920151711, 0.184032559394836, 0.18398816883564, 0.18394373357296, 0.183899253606796, 0.183854728937149, 0.183810189366341, 0.183765590190887, 0.183720991015434, 0.183676302433014, 0.183631613850594, 0.183586865663528, 0.183542057871819, 0.183497235178947, 0.183452382683754, 0.183407485485077, 0.183362543582916, 0.183317571878433, 0.183272555470467, 0.183227494359016, 0.183182388544083, 0.183137267827988, 0.183092087507248, 0.183046892285347, 0.183001637458801, 0.182956352829933, 0.182910993695259, 0.182865634560585, 0.182820245623589, 0.182774782180786, 0.182729288935661, 0.182683780789375, 0.182638227939606, 0.18259260058403, 0.182546973228455, 0.182501301169395, 0.182455569505692, 0.182409822940826, 0.182364016771317, 0.182318180799484, 0.182272300124168, 0.18222638964653, 0.182180434465408, 0.182134449481964, 0.182088419795036, 0.182042360305786, 0.181996241211891, 0.181950092315674, 0.181903898715973, 0.181857690215111, 0.181811437010765, 0.181765124201775, 0.181718781590462, 0.181672394275665, 0.181625962257385, 0.181579515337944, 0.181533023715019, 0.18148647248745, 0.181439891457558, 0.181393295526505, 0.181346639990807, 0.181299939751625, 0.181253224611282, 0.181206449866295, 0.181159630417824, 0.18111278116703, 0.181065887212753, 0.181018978357315, 0.180972024798393, 0.180924996733665, 0.180877953767776, 0.180830880999565, 0.18078376352787, 0.180736601352692, 0.180689409375191, 0.180642157793045, 0.180594876408577, 0.180547580122948, 0.180500194430351, 0.180452808737755, 0.180405378341675, 0.180357918143272, 0.180310398340225, 0.180262833833694, 0.180215254426003, 0.180167645215988, 0.180119976401329, 0.180072277784348, 0.180024519562721, 0.179976731538773, 0.179928913712502, 0.179881051182747, 0.17983315885067, 0.179785206913948, 0.179737240076065, 0.179689228534698, 0.179641172289848, 0.179593071341515, 0.179544940590858, 0.179496765136719, 0.179448559880257, 0.179400309920311, 0.179352015256882, 0.17930369079113, 0.179255321621895, 0.179206922650337, 0.179158478975296, 0.179109990596771, 0.179061457514763, 0.179012894630432, 0.178964287042618, 0.178915664553642, 0.178866967558861, 0.178818255662918, 0.178769513964653, 0.178720712661743, 0.178671881556511, 0.178623005747795, 0.178574100136757, 0.178525134921074, 0.178476139903069, 0.17842710018158, 0.178378060460091, 0.178328946232796, 0.178279787302017, 0.178230598568916, 0.178181380033493, 0.178132116794586, 0.178082808852196, 0.178033486008644, 0.177984103560448, 0.177934676408768, 0.177885219454765, 0.177835732698441, 0.177786186337471, 0.177736610174179, 0.177687019109726, 0.177637353539467, 0.177587643265724, 0.177537932991982, 0.177488148212433, 0.177438348531723, 0.17738850414753, 0.177338615059853, 0.177288681268692, 0.17723873257637, 0.177188724279404, 0.177138686180115, 0.177088588476181, 0.177038475871086, 0.176988318562508, 0.176938131451607, 0.176887884736061, 0.176837593317032, 0.176787301898003, 0.176736935973167, 0.17668654024601, 0.176636099815369, 0.176585629582405, 0.17653514444828, 0.17648458480835, 0.176433995366096, 0.176383376121521, 0.176332712173462, 0.176282003521919, 0.176231250166893, 0.176180481910706, 0.176129654049873, 0.176078796386719, 0.176027894020081, 0.17597696185112, 0.175925984978676, 0.175874978303909, 0.175823912024498, 0.175772830843925, 0.175721675157547, 0.175670519471169, 0.175619289278984, 0.175568044185638, 0.17551676928997, 0.175465434789658, 0.175414070487022, 0.175362661480904, 0.175311222672462, 0.175259739160538, 0.175208210945129, 0.175156652927399, 0.175105050206184, 0.175053432583809, 0.175001740455627, 0.174950018525124, 0.174898266792297, 0.174846470355988, 0.174794644117355, 0.174742758274078, 0.174690842628479, 0.174638897180557, 0.174586907029152, 0.174534872174263, 0.174482807517052, 0.174430713057518, 0.17437855899334, 0.174326375126839, 0.174274161458015, 0.174221888184547, 0.174169600009918, 0.174117252230644, 0.174064874649048, 0.174012452363968, 0.173960000276566, 0.17390750348568, 0.173854976892471, 0.173802390694618, 0.173749774694443, 0.173697128891945, 0.173644438385963, 0.17359171807766, 0.173538953065872, 0.173486143350601, 0.173433288931847, 0.17338040471077, 0.173327475786209, 0.173274502158165, 0.17322151362896, 0.17316846549511, 0.173115372657776, 0.173062279820442, 0.173009127378464, 0.172955915331841, 0.172902673482895, 0.172849401831627, 0.172796085476875, 0.172742739319801, 0.172689348459244, 0.172635912895203, 0.172582432627678, 0.172528952360153, 0.172475397586823, 0.172421798110008, 0.172368183732033, 0.172314509749413, 0.172260820865631, 0.172207057476044, 0.172153279185295, 0.172099456191063, 0.172045588493347, 0.17199170589447, 0.171937763690948, 0.171883791685104, 0.171829760074615, 0.171775728464127, 0.171721622347832, 0.171667501330376, 0.171613320708275, 0.171559110283852, 0.171504870057106, 0.171450585126877, 0.171396255493164, 0.171341896057129, 0.171287477016449, 0.171233028173447, 0.171178564429283, 0.171124041080475, 0.171069487929344, 0.171014875173569, 0.170960247516632, 0.170905560255051, 0.170850843191147, 0.170796096324921, 0.170741304755211, 0.170686468482018, 0.170631587505341, 0.170576676726341, 0.17052173614502, 0.170466735959053, 0.170411705970764, 0.170356646180153, 0.170301541686058, 0.170246407389641, 0.17019122838974, 0.170135989785194, 0.170080721378326, 0.170025423169136, 0.169970095157623, 0.169914722442627, 0.169859275221825, 0.169803842902184, 0.169748336076736, 0.169692829251289, 0.169637233018875, 0.169581606984138, 0.169525980949402, 0.169470280408859, 0.169414550065994, 0.169358789920807, 0.169302985072136, 0.169247135519981, 0.169191256165504, 0.169135332107544, 0.1690793633461, 0.169023379683495, 0.168967321515083, 0.168911248445511, 0.168855145573616, 0.168798968195915, 0.168742775917053, 0.168686538934708, 0.168630257248878, 0.168573960661888, 0.168517604470253, 0.168461218476295, 0.168404772877693, 0.16834831237793, 0.168291807174683, 0.168235257267952, 0.168178677558899, 0.168122053146362, 0.168065384030342, 0.168008670210838, 0.167951926589012, 0.167895153164864, 0.167838349938393, 0.167781472206116, 0.167724579572678, 0.167667627334595, 0.167610675096512, 0.167553663253784, 0.167496591806412, 0.167439520359039, 0.1673823595047, 0.167325213551521, 0.167267993092537, 0.167210757732391, 0.167153462767601, 0.167096152901649, 0.167038768529892, 0.166981369256973, 0.166923925280571, 0.166866451501846, 0.166808933019638, 0.166751369833946, 0.166693776845932, 0.166636124253273, 0.166578456759453, 0.16652075946331, 0.166462972760201, 0.166405200958252, 0.166347354650497, 0.166289478540421, 0.166231587529182, 0.1661736369133, 0.166115641593933, 0.166057631373405, 0.165999561548233, 0.165941447019577, 0.165883302688599, 0.165825128555298, 0.165766909718513, 0.165708631277084, 0.165650352835655, 0.16559199988842, 0.165533617138863, 0.165475204586983, 0.165416747331619, 0.165358260273933, 0.165299713611603, 0.165241152048111, 0.165182545781136, 0.165123894810677, 0.165065214037895, 0.165006473660469, 0.164947703480721, 0.16488890349865, 0.164830043911934, 0.164771169424057, 0.164712235331535, 0.164653286337852, 0.164594307541847, 0.164535254240036, 0.164476186037064, 0.164417058229446, 0.164357900619507, 0.164298713207245, 0.164239466190338, 0.16418020427227, 0.164120882749557, 0.164061516523361, 0.164002135396004, 0.163942709565163, 0.163883239030838, 0.163823738694191, 0.16376419365406, 0.163704618811607, 0.16364498436451, 0.163585335016251, 0.163525611162186, 0.16346587240696, 0.16340608894825, 0.163346275687218, 0.163286417722702, 0.163226529955864, 0.163166582584381, 0.163106620311737, 0.163046613335609, 0.162986546754837, 0.162926465272903, 0.162866324186325, 0.162806153297424, 0.162745952606201, 0.162685707211494, 0.162625432014465, 0.162565097212791, 0.162504732608795, 0.162444338202477, 0.162383899092674, 0.162323415279388, 0.162262871861458, 0.162202328443527, 0.162141740322113, 0.162081092596054, 0.162020415067673, 0.161959707736969, 0.161898955702782, 0.161838158965111, 0.161777332425117, 0.161716446280479, 0.161655575037003, 0.161594599485397, 0.161533564329147, 0.161472484469414, 0.161411359906197, 0.161350250244141, 0.161289095878601, 0.161227941513062, 0.161166742444038, 0.161105543375015, 0.161044344305992, 0.160983100533485, 0.160921841859818, 0.160860568284988, 0.160799279808998, 0.160737976431847, 0.160676643252373, 0.160615295171738, 0.160553947091103, 0.160492524504662, 0.160431131720543, 0.160369709134102, 0.160308286547661, 0.160246819257736, 0.16018533706665, 0.160123825073242, 0.160062313079834, 0.160000771284103, 0.159939229488373, 0.159877672791481, 0.159816071391106, 0.159754455089569, 0.159692838788033, 0.159631192684174, 0.159569531679153, 0.159507840871811, 0.159446150064468, 0.159384429454803, 0.159322693943977, 0.159260928630829, 0.159199148416519, 0.159137383103371, 0.159075543284416, 0.159013733267784, 0.158951863646507, 0.15888999402523, 0.158828124403954, 0.158766210079193, 0.158704280853271, 0.158642336726189, 0.158580392599106, 0.158518403768539, 0.158456400036812, 0.158394396305084, 0.158332362771034, 0.158270299434662, 0.158208236098289, 0.158146128058434, 0.158084034919739, 0.15802189707756, 0.157959759235382, 0.157897591590881, 0.157835394144058, 0.157773196697235, 0.157710984349251, 0.157648742198944, 0.157586500048637, 0.157524183392525, 0.157461911439896, 0.157399609684944, 0.157337263226509, 0.157274916768074, 0.157212540507317, 0.157150164246559, 0.157087743282318, 0.157025322318077, 0.156962886452675, 0.15690042078495, 0.156837940216064, 0.156775444746017, 0.156712919473648, 0.156650394201279, 0.156587839126587, 0.156525254249573, 0.15646268427372, 0.156400069594383, 0.156337440013885, 0.156274780631065, 0.156212106347084, 0.156149417161942, 0.156086713075638, 0.156024008989334, 0.155961260199547, 0.15589851140976, 0.155835717916489, 0.155772924423218, 0.155710130929947, 0.155647277832031, 0.155584424734116, 0.155521556735039, 0.155458673834801, 0.155395776033401, 0.155332833528519, 0.155269891023636, 0.155206933617592, 0.155143946409225, 0.155080944299698, 0.155017927289009, 0.154954880475998, 0.154891833662987, 0.154828757047653, 0.154765665531158, 0.154702559113503, 0.154639422893524, 0.154576271772385, 0.154513105750084, 0.154449909925461, 0.154386729001999, 0.154323488473892, 0.154260247945786, 0.154196992516518, 0.154133692383766, 0.154070422053337, 0.154007107019424, 0.153943762183189, 0.153880417346954, 0.153817042708397, 0.153753653168678, 0.153690248727798, 0.153626799583435, 0.153563380241394, 0.153499886393547, 0.153436422348022, 0.153372913599014, 0.153309375047684, 0.153245851397514, 0.153182283043861, 0.153118699789047, 0.153055146336555, 0.152991518378258, 0.15292789041996, 0.15286423265934, 0.152800559997559, 0.152736887335777, 0.152673169970512, 0.152609452605247, 0.15254570543766, 0.152481943368912, 0.152418151497841, 0.15235435962677, 0.152290537953377, 0.152226716279984, 0.152162849903107, 0.15209898352623, 0.152035087347031, 0.151971191167831, 0.15190726518631, 0.151843294501305, 0.151779338717461, 0.151715353131294, 0.151651352643967, 0.151587337255478, 0.151523292064667, 0.151459231972694, 0.151395171880722, 0.151331052184105, 0.151266932487488, 0.151202797889709, 0.15113864839077, 0.15107449889183, 0.151010289788246, 0.150946095585823, 0.150881856679916, 0.15081761777401, 0.150753363966942, 0.15068906545639, 0.150624781847, 0.150560453534126, 0.150496110320091, 0.150431782007217, 0.150367394089699, 0.150302991271019, 0.150238588452339, 0.150174170732498, 0.150109708309174, 0.150045216083527, 0.149980753660202, 0.149916261434555, 0.149851724505424, 0.149787187576294, 0.149722620844841, 0.149658039212227, 0.149593457579613, 0.149528831243515, 0.149464204907417, 0.149399548768997, 0.149334892630577, 0.149270206689835, 0.149205476045609, 0.149140745401382, 0.149076014757156, 0.149011254310608, 0.148946464061737, 0.148881644010544, 0.148816838860512, 0.148752003908157, 0.148687139153481, 0.148622274398804, 0.148557364940643, 0.148492470383644, 0.148427531123161, 0.148362562060356, 0.148297607898712, 0.148232609033585, 0.148167625069618, 0.148102596402168, 0.148037552833557, 0.147972479462624, 0.14790740609169, 0.147842302918434, 0.147777199745178, 0.1477120667696, 0.14764691889286, 0.147581741213799, 0.147516548633575, 0.147451341152191, 0.147386103868484, 0.147320866584778, 0.147255599498749, 0.147190302610397, 0.147125005722046, 0.147059664130211, 0.146994337439537, 0.146928995847702, 0.146863594651222, 0.146798223257065, 0.146732792258263, 0.146667376160622, 0.146601930260658, 0.146536439657211, 0.146470963954926, 0.146405443549156, 0.146339938044548, 0.146274402737617, 0.146208822727203, 0.146143227815628, 0.146077632904053, 0.146012023091316, 0.145946398377419, 0.145880714058876, 0.145815059542656, 0.145749360322952, 0.145683631300926, 0.145617917180061, 0.145552173256874, 0.145486414432526, 0.145420625805855, 0.145354807376862, 0.14528900384903, 0.145223140716553, 0.145157292485237, 0.14509142935276, 0.145025506615639, 0.144959598779678, 0.144893676042557, 0.144827708601952, 0.144761756062508, 0.144695743918419, 0.144629761576653, 0.144563734531403, 0.14449767768383, 0.144431620836258, 0.144365534186363, 0.144299432635307, 0.144233331084251, 0.144167169928551, 0.14410100877285, 0.144034847617149, 0.143968641757965, 0.143902450799942, 0.143836200237274, 0.143769964575768, 0.143703684210777, 0.143637388944626, 0.143571108579636, 0.143504768610001, 0.143438443541527, 0.143372073769569, 0.143305689096451, 0.143239304423332, 0.14317287504673, 0.143106445670128, 0.143040001392365, 0.142973527312279, 0.142907023429871, 0.142840504646301, 0.142773985862732, 0.142707452178001, 0.142640858888626, 0.142574280500412, 0.142507687211037, 0.142441064119339, 0.14237442612648, 0.14230777323246, 0.142241105437279, 0.142174407839775, 0.142107680439949, 0.142040953040123, 0.141974195837975, 0.141907438635826, 0.141840666532516, 0.141773834824562, 0.141707018017769, 0.141640156507492, 0.141573294997215, 0.1415064483881, 0.141439542174339, 0.141372606158257, 0.141305670142174, 0.14123871922493, 0.141171753406525, 0.141104772686958, 0.141037747263908, 0.140970706939697, 0.140903651714325, 0.140836611390114, 0.140769511461258, 0.140702411532402, 0.140635311603546, 0.140568152070045, 0.140500992536545, 0.140433818101883, 0.14036662876606, 0.140299409627914, 0.140232175588608, 0.14016492664814, 0.14009764790535, 0.140030354261398, 0.139963060617447, 0.139895722270012, 0.139828383922577, 0.13976101577282, 0.139693632721901, 0.139626234769821, 0.139558807015419, 0.139491379261017, 0.139423936605453, 0.139356449246407, 0.139288946986198, 0.139221429824829, 0.139153927564621, 0.139086350798607, 0.139018788933754, 0.138951227068901, 0.138883605599403, 0.138815984129906, 0.138748347759247, 0.138680681586266, 0.138613000512123, 0.138545304536819, 0.138477578759193, 0.138409867882729, 0.138342097401619, 0.138274326920509, 0.138206526637077, 0.138138726353645, 0.138070911169052, 0.138003066182137, 0.137935191392899, 0.137867316603661, 0.1377994120121, 0.137731492519379, 0.137663543224335, 0.137595593929291, 0.137527629733086, 0.137459620833397, 0.137391611933708, 0.137323573231697, 0.137255519628525, 0.137187466025352, 0.137119367718697, 0.13705125451088, 0.136983141303062, 0.136914998292923, 0.136846840381622, 0.13677866756916, 0.136710464954376, 0.13664223253727, 0.136574000120163, 0.136505767703056, 0.136437490582466, 0.136369183659554, 0.136300876736641, 0.136232554912567, 0.136164218187332, 0.136095836758614, 0.136027455329895, 0.135959059000015, 0.135890617966652, 0.135822176933289, 0.135753735899925, 0.135685250163078, 0.135616764426231, 0.135548233985901, 0.13547970354557, 0.135411158204079, 0.135342568159103, 0.135274007916451, 0.135205388069153, 0.135136753320694, 0.135068118572235, 0.134999454021454, 0.134930774569511, 0.134862065315247, 0.134793356060982, 0.134724631905556, 0.134655863046646, 0.134587079286575, 0.134518280625343, 0.134449481964111, 0.134380653500557, 0.134311810135841, 0.134242951869965, 0.134174033999443, 0.134105160832405, 0.134036213159561, 0.133967280387878, 0.133898317813873, 0.133829340338707, 0.133760347962379, 0.133691340684891, 0.133622288703918, 0.133553251624107, 0.133484184741974, 0.133415088057518, 0.133345976471901, 0.133276835083961, 0.133207708597183, 0.133138537406921, 0.133069351315498, 0.133000165224075, 0.132930934429169, 0.132861718535423, 0.132792443037033, 0.132723152637482, 0.132653877139091, 0.132584571838379, 0.132515221834183, 0.132445886731148, 0.132376506924629, 0.132307112216949, 0.13223771750927, 0.132168292999268, 0.132098853588104, 0.13202939927578, 0.131959915161133, 0.131890416145325, 0.131820902228355, 0.131751358509064, 0.131681799888611, 0.131612226366997, 0.131542652845383, 0.131473019719124, 0.131403401494026, 0.131333753466606, 0.131264105439186, 0.131194412708282, 0.131124690175056, 0.131054982542992, 0.130985245108604, 0.130915477871895, 0.130845710635185, 0.130775898694992, 0.130706116557121, 0.130636274814606, 0.130566418170929, 0.130496546626091, 0.130426645278931, 0.130356773734093, 0.130286827683449, 0.130216896533966, 0.130146920681, 0.130076944828033, 0.130006939172745, 0.129936933517456, 0.129866883158684, 0.129796832799911, 0.129726752638817, 0.129656657576561, 0.129586547613144, 0.129516422748566, 0.129446282982826, 0.129376113414764, 0.12930591404438, 0.129235714673996, 0.129165500402451, 0.129095271229744, 0.129024997353554, 0.128954708576202, 0.128884434700012, 0.128814101219177, 0.128743767738342, 0.128673419356346, 0.128603056073189, 0.12853267788887, 0.128462240099907, 0.128391847014427, 0.128321394324303, 0.128250926733017, 0.12818044424057, 0.128109931945801, 0.128039419651031, 0.127968892455101, 0.127898320555687, 0.127827748656273, 0.127757161855698, 0.1276865452528, 0.127615913748741, 0.12754525244236, 0.127474591135979, 0.127403929829597, 0.127333208918571, 0.127262488007545, 0.127191737294197, 0.127120971679688, 0.127050191164017, 0.126979395747185, 0.126908600330353, 0.126837745308876, 0.126766890287399, 0.126696035265923, 0.126625135540962, 0.126554220914841, 0.126483306288719, 0.126412346959114, 0.126341387629509, 0.126270398497581, 0.126199409365654, 0.126128375530243, 0.126057341694832, 0.125986278057098, 0.125915199518204, 0.125844106078148, 0.125772997736931, 0.125701874494553, 0.125630706548691, 0.125559538602829, 0.125488355755806, 0.125417158007622, 0.125345915555954, 0.125274688005447, 0.125203415751457, 0.125132143497467, 0.125060841441154, 0.12498950958252, 0.124918185174465, 0.124846838414669, 0.124775461852551, 0.124704077839851, 0.124632656574249, 0.124561227858067, 0.124489799141884, 0.124418310821056, 0.124346829950809, 0.12427531182766, 0.12420380115509, 0.124132260680199, 0.124060690402985, 0.123989127576351, 0.123917527496815, 0.123845905065536, 0.123774290084839, 0.123702637851238, 0.123630963265896, 0.123559266328812, 0.123487561941147, 0.123415842652321, 0.123344086110592, 0.123272344470024, 0.123200558125973, 0.12312875688076, 0.123056940734386, 0.122985102236271, 0.122913241386414, 0.122841358184814, 0.122769467532635, 0.122697554528713, 0.12262561917305, 0.122553676366806, 0.122481718659401, 0.122409723699093, 0.122337713837624, 0.122265696525574, 0.122193664312363, 0.122121602296829, 0.122049517929554, 0.121977411210537, 0.121905311942101, 0.121833167970181, 0.12176102399826, 0.121688827872276, 0.121616661548615, 0.121544450521469, 0.121472224593163, 0.121399983763695, 0.121327705681324, 0.121255420148373, 0.12118311971426, 0.121110811829567, 0.121038474142551, 0.120966099202633, 0.120893724262714, 0.120821334421635, 0.120748914778233, 0.120676502585411, 0.120604030787945, 0.12053158134222, 0.120459087193012, 0.120386585593224, 0.120314061641693, 0.120241530239582, 0.120168954133987, 0.120096370577812, 0.120023764669895, 0.119951151311398, 0.119878515601158, 0.119805864989758, 0.119733192026615, 0.119660496711731, 0.119587779045105, 0.119515061378479, 0.119442313909531, 0.11936954408884, 0.119296759366989, 0.119223967194557, 0.119151145219803, 0.119078285992146, 0.11900544911623, 0.118932574987411, 0.11885966360569, 0.118786759674549, 0.118713818490505, 0.118640884757042, 0.118567913770676, 0.118494898080826, 0.118421904742718, 0.118348881602287, 0.118275836110115, 0.11820276081562, 0.118129685521126, 0.118056587874889, 0.117983460426331, 0.117910325527191, 0.117837183177471, 0.117764003574848, 0.117690816521645, 0.117617592215538, 0.117544382810593, 0.117471128702164, 0.117397852241993, 0.117324583232403, 0.11725127696991, 0.117177940905094, 0.117104604840279, 0.117031246423721, 0.116957865655422, 0.116884477436543, 0.11681105941534, 0.116737633943558, 0.116664156317711, 0.116590686142445, 0.116517215967178, 0.116443686187267, 0.116370178759098, 0.116296611726284, 0.116223067045212, 0.116149485111237, 0.11607588082552, 0.116002254188061, 0.115928635001183, 0.11585495620966, 0.115781277418137, 0.115707598626614, 0.115633882582188, 0.115560166537762, 0.115486390888691, 0.115412630140781, 0.11533884704113, 0.115265041589737, 0.115191213786602, 0.115117378532887, 0.115043506026268, 0.114969626069069, 0.114895738661289, 0.114821821451187, 0.114747881889343, 0.114673927426338, 0.114599943161011, 0.114525958895683, 0.114451967179775, 0.114377915859222, 0.11430387198925, 0.114229820668697, 0.114155724644661, 0.114081636071205, 0.114007502794266, 0.113933376967907, 0.113859213888645, 0.113785035908222, 0.113710843026638, 0.113636620342731, 0.113562382757664, 0.113488145172596, 0.113413862884045, 0.113339588046074, 0.11326526850462, 0.113190948963165, 0.113116607069969, 0.113042250275612, 0.112967871129513, 0.112893469631672, 0.112819045782089, 0.112744614481926, 0.11267014592886, 0.112595692276955, 0.112521193921566, 0.112446680665016, 0.112372152507305, 0.112297594547272, 0.112223036587238, 0.112148463726044, 0.112073846161366, 0.111999228596687, 0.111924581229687, 0.111849933862686, 0.111775256693363, 0.111700549721718, 0.111625835299492, 0.111551098525524, 0.111476354300976, 0.111401580274105, 0.111326791346073, 0.111251980066299, 0.111177161335945, 0.111102305352688, 0.111027449369431, 0.110952563583851, 0.11087766289711, 0.110802747309208, 0.110727794468403, 0.110652849078178, 0.110577866435051, 0.110502891242504, 0.110427878797054, 0.110352836549282, 0.11027780175209, 0.110202714800835, 0.11012764275074, 0.110052533447742, 0.109977409243584, 0.109902262687683, 0.109827093780041, 0.109751924872398, 0.109676733613014, 0.109601497650146, 0.109526291489601, 0.109451033174992, 0.10937575250864, 0.109300471842289, 0.109225139021873, 0.109149821102619, 0.109074488282204, 0.108999110758305, 0.108923733234406, 0.108848318457603, 0.108772896230221, 0.108697474002838, 0.108622007071972, 0.108546540141106, 0.108471021056175, 0.108395524322987, 0.108319997787476, 0.108244441449642, 0.108168877661228, 0.108093291521072, 0.108017683029175, 0.107942067086697, 0.107866406440735, 0.107790753245354, 0.10771507024765, 0.107639357447624, 0.107563659548759, 0.10748790204525, 0.107412166893482, 0.107336394488811, 0.107260599732399, 0.107184790074825, 0.10710895806551, 0.107033111155033, 0.106957241892815, 0.106881350278854, 0.106805458664894, 0.106729529798031, 0.106653586030006, 0.106577634811401, 0.106501661241055, 0.106425665318966, 0.106349661946297, 0.106273613870144, 0.106197565793991, 0.106121487915516, 0.10604540258646, 0.105969302356243, 0.105893172323704, 0.105817027390003, 0.105740860104561, 0.105664670467377, 0.105588480830193, 0.105512261390686, 0.105436027050018, 0.105359762907028, 0.105283491313457, 0.105207212269306, 0.105130888521671, 0.105054564774036, 0.10497821867466, 0.104901842772961, 0.104825459420681, 0.104749046266079, 0.104672633111477, 0.104596205055714, 0.104519732296467, 0.104443252086639, 0.10436674952507, 0.104290246963501, 0.104213714599609, 0.104137144982815, 0.104060582816601, 0.103983975946903, 0.103907376527786, 0.103830754756927, 0.103754103183746, 0.103677444159985, 0.10360074788332, 0.103524059057236, 0.103447340428829, 0.1033705919981, 0.103293843567371, 0.103217072784901, 0.103140264749527, 0.103063456714153, 0.102986618876457, 0.102909773588181, 0.102832905948162, 0.102756023406982, 0.10267911106348, 0.102602191269398, 0.102525241672993, 0.102448292076588, 0.102371297776699, 0.102294318377972, 0.102217279374599, 0.102140247821808, 0.102063201367855, 0.10198612511158, 0.101909033954144, 0.101831920444965, 0.101754792034626, 0.101677656173706, 0.101600475609303, 0.10152330994606, 0.101446107029915, 0.101368881762028, 0.101291641592979, 0.101214371621609, 0.101137109100819, 0.101059816777706, 0.100982487201691, 0.100905157625675, 0.100827798247337, 0.100750438868999, 0.10067305713892, 0.100595645606518, 0.100518219172955, 0.10044077038765, 0.100363306701183, 0.100285835564137, 0.100208319723606, 0.100130811333656, 0.100053280591965, 0.0999757125973701, 0.0998981520533562, 0.0998205542564392, 0.0997429415583611, 0.0996653214097023, 0.0995876714587212, 0.0995100066065788, 0.0994323119521141, 0.0993546098470688, 0.0992768928408623, 0.0991991385817528, 0.0991213917732239, 0.0990436002612114, 0.0989658087491989, 0.0988879948854446, 0.098810151219368, 0.0987323001027107, 0.0986544266343117, 0.098576545715332, 0.0984986424446106, 0.0984207019209862, 0.0983427613973618, 0.0982648059725761, 0.0981868132948875, 0.0981088131666183, 0.0980307906866074, 0.0979527533054352, 0.0978747233748436, 0.097796618938446, 0.0977185443043709, 0.0976404175162315, 0.0975622832775116, 0.0974841564893723, 0.0974059700965881, 0.097327783703804, 0.0972495749592781, 0.097171351313591, 0.0970931276679039, 0.0970148518681526, 0.0969365760684013, 0.0968582853674889, 0.096779964864254, 0.0967016294598579, 0.0966232791543007, 0.0965448990464211, 0.0964665114879608, 0.0963880941271782, 0.096309669315815, 0.0962312147021294, 0.0961527600884438, 0.0960742756724358, 0.095995768904686, 0.095917247235775, 0.0958387032151222, 0.0957601517438889, 0.0956815853714943, 0.0956029742956161, 0.095524363219738, 0.0954457297921181, 0.0953670889139175, 0.0952884256839752, 0.0952097102999687, 0.095131017267704, 0.0950523093342781, 0.0949735566973686, 0.0948947966098785, 0.0948160067200661, 0.094737209379673, 0.0946583971381187, 0.0945795625448227, 0.0945007055997849, 0.0944218263030052, 0.0943429321050644, 0.094264030456543, 0.094185084104538, 0.094106137752533, 0.0940271764993668, 0.0939481928944588, 0.0938692018389702, 0.093790166079998, 0.0937111377716064, 0.0936320722103119, 0.0935529917478561, 0.0934739038348198, 0.0933947786688805, 0.0933156535029411, 0.0932364985346794, 0.0931573212146759, 0.0930781364440918, 0.0929989293217659, 0.0929196998476982, 0.0928404629230499, 0.0927611887454987, 0.0926819145679474, 0.0926026105880737, 0.0925232991576195, 0.0924439579248428, 0.0923645868897438, 0.0922852158546448, 0.092205822467804, 0.0921264141798019, 0.0920469835400581, 0.0919675379991531, 0.0918880775570869, 0.091808594763279, 0.0917290672659874, 0.091649554669857, 0.0915700048208237, 0.0914904475212097, 0.0914108753204346, 0.091331273317337, 0.0912516638636589, 0.0911745578050613, 0.0911000594496727, 0.0910255536437035, 0.0909510254859924, 0.0908764973282814, 0.0908019542694092, 0.0907274037599564, 0.0906528607010841, 0.0905782878398895, 0.0905037224292755, 0.0904291570186615, 0.0903545469045639, 0.0902799591422081, 0.0902053415775299, 0.0901307314634323, 0.0900561287999153, 0.0899814739823341, 0.0899068489670753, 0.0898321866989136, 0.089757539331913, 0.0896828919649124, 0.0896082147955894, 0.0895335450768471, 0.0894588232040405, 0.0893841311335564, 0.089309461414814, 0.0892347246408463, 0.0891600102186203, 0.0890852734446526, 0.0890105366706848, 0.0889357998967171, 0.0888610407710075, 0.0887862890958786, 0.0887115076184273, 0.088636726140976, 0.0885619521141052, 0.0884871333837509, 0.0884123370051384, 0.0883375331759453, 0.0882626920938492, 0.0881878733634949, 0.0881130322813988, 0.0880381911993027, 0.0879633501172066, 0.0878884717822075, 0.0878136083483696, 0.0877387225627899, 0.0876638442277908, 0.0875889584422112, 0.0875140279531479, 0.087439127266407, 0.0873641967773438, 0.0872892737388611, 0.0872143507003784, 0.0871393978595734, 0.0870644375681877, 0.0869894921779633, 0.086914524435997, 0.086839534342289, 0.0867645516991615, 0.0866895616054535, 0.0866145715117455, 0.0865395441651344, 0.0864645317196846, 0.0863894820213318, 0.0863144472241402, 0.0862394273281097, 0.0861643701791763, 0.0860892981290817, 0.0860142260789871, 0.0859391540288925, 0.0858640596270561, 0.0857889726758003, 0.0857138708233833, 0.0856387615203857, 0.0855636447668076, 0.0854885056614876, 0.0854133740067482, 0.0853382423520088, 0.0852630808949471, 0.0851879268884659, 0.0851127505302429, 0.08503757417202, 0.084962397813797, 0.0848871991038322, 0.0848120003938675, 0.0847367793321609, 0.084661565721035, 0.0845863446593285, 0.0845111012458801, 0.0844358578324318, 0.0843605995178223, 0.0842853412032127, 0.0842100754380226, 0.0841348171234131, 0.08405951410532, 0.0839842259883881, 0.083908922970295, 0.0838336274027824, 0.0837582945823669, 0.0836829766631126, 0.0836076289415359, 0.0835322886705399, 0.0834569334983826, 0.0833815932273865, 0.0833062082529068, 0.0832308381795883, 0.0831554532051086, 0.0830800458788872, 0.0830046534538269, 0.0829292461276054, 0.082853838801384, 0.0827784091234207, 0.0827029570937157, 0.082627534866333, 0.082552082836628, 0.0824766308069229, 0.0824011564254761, 0.082325667142868, 0.0822501927614212, 0.082174725830555, 0.0820992067456245, 0.0820236951112747, 0.0819481611251831, 0.0818726494908333, 0.0817971378564835, 0.0817215740680695, 0.0816460251808167, 0.0815704688429832, 0.0814948901534081, 0.0814193412661552, 0.0813437402248383, 0.0812681615352631, 0.0811925455927849, 0.0811169445514679, 0.0810413286089897, 0.0809657052159309, 0.080890066921711, 0.0808144360780716, 0.0807387679815292, 0.0806631371378899, 0.0805874466896057, 0.080511786043644, 0.080436110496521, 0.0803604051470757, 0.0802847221493721, 0.0802090018987656, 0.0801332741975784, 0.0800575464963913, 0.0799818336963654, 0.0799060836434364, 0.0798303410410881, 0.079754576086998, 0.0796788036823273, 0.0796030163764954, 0.0795272514224052, 0.0794514715671539, 0.0793756619095802, 0.0792998597025871, 0.079224020242691, 0.0791482180356979, 0.0790723860263824, 0.0789965391159058, 0.0789207071065903, 0.0788448378443718, 0.0787689685821533, 0.0786931216716766, 0.0786172300577164, 0.0785413384437561, 0.078465424478054, 0.078389510512352, 0.0783136188983917, 0.0782376900315285, 0.0781617537140846, 0.0780858173966408, 0.0780098587274551, 0.0779339075088501, 0.0778579562902451, 0.0777819827198982, 0.0777060016989708, 0.0776300057768822, 0.0775540098547935, 0.0774779915809631, 0.0774019956588745, 0.0773259773850441, 0.0772499144077301, 0.0771739035844803, 0.0770978406071663, 0.0770217999815941, 0.0769457444548607, 0.0768696367740631, 0.0767935663461685, 0.0767174810171127, 0.0766413807868958, 0.0765652805566788, 0.07648915797472, 0.0764130353927612, 0.0763369128108025, 0.0762607902288437, 0.0761846452951431, 0.0761084705591202, 0.0760323107242584, 0.0759561434388161, 0.0758799612522125, 0.075803779065609, 0.075727567076683, 0.0756513625383377, 0.0755751579999924, 0.0754989311099052, 0.0754226967692375, 0.0753464549779892, 0.0752702206373215, 0.0751939564943314, 0.0751177072525024, 0.0750414356589317, 0.0749651417136192, 0.0748888552188873, 0.0748125612735748, 0.0747362524271011, 0.0746599584817886, 0.0745836272835732, 0.0745072960853577, 0.0744309574365616, 0.0743546038866043, 0.0742782577872276, 0.0742019042372704, 0.0741255283355713, 0.0740491524338722, 0.0739727541804314, 0.0738963559269905, 0.0738199651241302, 0.0737435519695282, 0.0736671313643456, 0.0735906958580017, 0.0735142529010773, 0.0734378173947334, 0.0733613520860672, 0.0732848942279816, 0.0732084140181541, 0.0731319561600685, 0.0730554759502411, 0.0729789584875107, 0.0729024559259415, 0.0728259533643723, 0.0727494359016418, 0.0726729109883308, 0.072596363723278, 0.0725198239088058, 0.0724432542920113, 0.0723666995763779, 0.0722901374101639, 0.0722135454416275, 0.0721369683742523, 0.0720603764057159, 0.071983776986599, 0.0719071626663208, 0.0718305334448814, 0.0717539116740227, 0.0716772824525833, 0.071600615978241, 0.0715239942073822, 0.0714473202824593, 0.0713706463575363, 0.071293979883194, 0.0712172761559486, 0.0711405798792839, 0.0710639134049416, 0.0709871798753738, 0.0709104686975479, 0.0708337351679802, 0.0707570016384125, 0.0706802681088448, 0.0706034973263741, 0.0705267414450645, 0.0704499706625938, 0.0703731998801231, 0.0702964216470718, 0.0702196061611176, 0.0701428130269051, 0.0700659975409508, 0.0699891820549965, 0.0699123665690422, 0.0698355212807655, 0.0697586908936501, 0.0696818307042122, 0.0696049481630325, 0.0695281177759171, 0.0694512128829956, 0.0693743377923965, 0.0692974552512169, 0.0692205354571342, 0.0691436305642128, 0.0690667182207108, 0.0689897909760475, 0.0689128562808037, 0.0688359066843987, 0.0687589645385742, 0.0686820074915886, 0.0686050429940224, 0.0685280561447144, 0.0684510692954063, 0.0683740898966789, 0.0682971030473709, 0.0682200789451599, 0.0681430473923683, 0.0680660232901573, 0.0679889991879463, 0.0679119676351547, 0.0678348988294601, 0.0677578523755074, 0.0676807686686516, 0.067603699862957, 0.0675266087055206, 0.0674495249986649, 0.0673724338412285, 0.0672953054308891, 0.0672181844711304, 0.0671410784125328, 0.0670639500021935, 0.0669867992401123, 0.0669096410274506, 0.0668324902653694, 0.0667553246021271, 0.0666781440377235, 0.0666009709239006, 0.0665237754583359, 0.06644656509161, 0.0663693621754646, 0.0662921518087387, 0.0662149116396904, 0.0661377012729645, 0.0660604387521744, 0.0659832134842873, 0.0659059286117554, 0.0658286735415459, 0.0657514184713364, 0.0656741186976433, 0.0655968189239502, 0.0655195116996765, 0.0654422119259834, 0.0653649196028709, 0.0652875751256943, 0.0652102380990982, 0.0651328936219215, 0.0650555491447449, 0.0649782121181488, 0.0649008303880692, 0.0648234635591507, 0.064746081829071, 0.0646687000989914, 0.06459129601717, 0.0645138695836067, 0.0644364580512047, 0.064359039068222, 0.0642816126346588, 0.0642041712999344, 0.0641267225146294, 0.0640492513775826, 0.0639718100428581, 0.0638943240046501, 0.0638168454170227, 0.0637393444776535, 0.0636618509888649, 0.0635843425989151, 0.0635068267583847, 0.0634293258190155, 0.0633517876267433, 0.0632742419838905, 0.0631966888904572, 0.0631191208958626, 0.0630415678024292, 0.0629640147089958, 0.0628864020109177, 0.0628088265657425, 0.0627312138676643, 0.0626536160707474, 0.0625760108232498, 0.0624983906745911, 0.0624207556247711, 0.0623430982232094, 0.0622654631733894, 0.0621878243982792, 0.062110148370266, 0.0620324686169624, 0.0619547702372074, 0.0618770942091942, 0.061799418181181, 0.0617216974496841, 0.0616439804434776, 0.0615662597119808, 0.0614885427057743, 0.061410803347826, 0.0613330379128456, 0.0612552985548973, 0.0611775368452072, 0.061099749058485, 0.0610219910740852, 0.0609441883862019, 0.0608663819730282, 0.0607886016368866, 0.0607107803225517, 0.0606329515576363, 0.0605551302433014, 0.0604772828519344, 0.0603994391858578, 0.060321569442749, 0.0602437220513821, 0.0601658597588539, 0.0600879676640034, 0.0600100792944431, 0.0599321760237217, 0.0598542653024197, 0.0597763769328594, 0.0596984513103962, 0.0596205182373524, 0.0595425702631474, 0.0594646371901035, 0.0593866854906082, 0.0593087151646614, 0.0592307411134243, 0.0591527484357357, 0.0590747781097889, 0.0589967854321003, 0.0589187704026699, 0.0588407590985298, 0.0587627440690994, 0.0586847104132175, 0.0586066767573357, 0.0585286431014538, 0.0584505833685398, 0.0583725273609161, 0.058294452726841, 0.0582163780927658, 0.0581382773816586, 0.0580602027475834, 0.0579820834100246, 0.0579039603471756, 0.0578258447349072, 0.0577477216720581, 0.0576695874333382, 0.0575914420187473, 0.0575132854282856, 0.0574351251125336, 0.0573569647967815, 0.0572787821292877, 0.0572005994617939, 0.0571223981678486, 0.057044193148613, 0.0569659918546677, 0.0568877682089806, 0.0568095445632935, 0.0567312985658646, 0.056653056293726, 0.0565748102962971, 0.0564965419471264, 0.0564182810485363, 0.0563399903476238, 0.0562617033720016, 0.0561834163963795, 0.0561051107943058, 0.0560268014669418, 0.0559484735131264, 0.0558701455593109, 0.0557918138802052, 0.0557134859263897, 0.0556351356208324, 0.0555567443370819, 0.0554783940315247, 0.0554000250995159, 0.0553216300904751, 0.0552432388067245, 0.055164847522974, 0.0550864338874817, 0.0550080016255379, 0.0549295656383038, 0.0548511557281017, 0.0547727197408676, 0.0546942465007305, 0.0546157881617546, 0.0545373149216175, 0.0544588603079319, 0.0543803833425045, 0.0543018653988838, 0.0542233660817146, 0.0541448518633842, 0.0540663525462151, 0.0539878122508526, 0.0539092719554901, 0.0538307353854179, 0.053752176463604, 0.0536736361682415, 0.0535950548946857, 0.05351647362113, 0.0534378923475742, 0.0533593110740185, 0.0532806888222694, 0.053202111274004, 0.0531234629452229, 0.0530448593199253, 0.0529662184417248, 0.0528875738382339, 0.0528089292347431, 0.0527302660048008, 0.0526515990495682, 0.0525729358196259, 0.0524942278862, 0.0524155423045158, 0.0523368343710899, 0.0522581301629543, 0.0521794185042381, 0.0521006919443607, 0.0520219653844833, 0.0519432350993156, 0.051864467561245, 0.0517857149243355, 0.0517069473862648, 0.0516281574964523, 0.0515494048595428, 0.0514705963432789, 0.0513918027281761, 0.0513129681348801, 0.0512341596186161, 0.0511553473770618, 0.0510765127837658, 0.0509976781904697, 0.0509188026189804, 0.0508399493992329, 0.0507610961794853, 0.050682220607996, 0.0506033450365067, 0.050524428486824, 0.0504455305635929, 0.0503666549921036, 0.0502877160906792, 0.0502087995409966, 0.0501298829913139, 0.050050925463438, 0.0499719865620136, 0.0498930290341377, 0.0498140454292297, 0.0497350879013538, 0.0496560856699944, 0.0495771057903767, 0.0494981035590172, 0.0494191013276577, 0.0493400804698467, 0.0492610596120358, 0.0491820387542248, 0.049102995544672, 0.0490239486098289, 0.0489448867738247, 0.0488658212125301, 0.0487867370247841, 0.0487076714634895, 0.0486285872757435, 0.0485494807362556, 0.0484703555703163, 0.0483912490308285, 0.0483121424913406, 0.0482329912483692, 0.0481538660824299, 0.048074696213007, 0.0479955486953259, 0.0479163974523544, 0.04783720895648, 0.0477580390870571, 0.0476788505911827, 0.047599658370018, 0.0475204475224018, 0.0474412366747856, 0.0473620034754276, 0.0472827516496181, 0.0472035370767117, 0.0471243038773537, 0.0470450334250927, 0.0469657592475414, 0.0468865036964417, 0.0468072071671486, 0.0467279329895973, 0.0466486401855946, 0.0465693213045597, 0.0464900285005569, 0.0464106909930706, 0.046331375837326, 0.0462520159780979, 0.0461726561188698, 0.0460933223366737, 0.0460139401257038, 0.0459346026182175, 0.0458552017807961, 0.0457758009433746, 0.045696422457695, 0.0456170029938221, 0.0455376021564007, 0.0454581789672375, 0.0453787334263325, 0.0452993139624596, 0.0452198535203934, 0.0451404079794884, 0.0450609438121319, 0.0449814610183239, 0.0449019968509674, 0.0448224917054176, 0.0447430089116096, 0.0446635037660599, 0.0445839762687683, 0.0445044673979282, 0.044424943625927, 0.0443454198539257, 0.0442658513784409, 0.0441863015294075, 0.0441067554056644, 0.0440271608531475, 0.043947596102953, 0.0438680052757263, 0.0437883958220482, 0.0437088049948215, 0.0436291955411434, 0.0435495637357235, 0.0434699542820454, 0.0433903001248837, 0.0433106683194637, 0.0432309955358505, 0.043151319026947, 0.0430716685950756, 0.0429919771850109, 0.0429123006761074, 0.0428326055407524, 0.0427528917789459, 0.0426731966435909, 0.0425934605300426, 0.0425137653946877, 0.0424340069293976, 0.0423542484641075, 0.0422745123505592, 0.042194776237011, 0.0421149954199791, 0.042035199701786, 0.0419553965330124, 0.0418756194412708, 0.041795838624239, 0.0417160168290138, 0.0416361801326275, 0.0415563583374023, 0.0414765365421772, 0.0413966961205006, 0.0413168333470821, 0.0412369705736637, 0.0411570854485035, 0.0410772226750851, 0.0409973412752151, 0.0409174375236034, 0.0408375300467014, 0.0407576039433479, 0.0406777001917362, 0.0405977927148342, 0.0405178479850292, 0.0404378995299339, 0.0403579548001289, 0.0402779877185822, 0.0401980429887772, 0.0401180535554886, 0.0400380641222, 0.0399580746889114, 0.0398780629038811, 0.0397980324923992, 0.0397180430591106, 0.0396379940211773, 0.0395579822361469, 0.0394779331982136, 0.0393978804349899, 0.0393178053200245, 0.0392377339303493, 0.039157684892416, 0.0390775874257088, 0.0389974974095821, 0.0389173999428749, 0.0388372652232647, 0.0387571714818478, 0.0386770330369473, 0.0385969020426273, 0.0385167635977268, 0.0384366065263748, 0.0383564718067646, 0.0382762737572193, 0.0381960943341255, 0.0381159372627735, 0.0380357168614864, 0.0379555411636829, 0.0378753170371056, 0.0377951003611088, 0.0377148799598217, 0.0376346372067928, 0.0375543981790543, 0.0374741367995739, 0.0373938754200935, 0.0373136326670647, 0.0372333526611328, 0.0371530689299107, 0.0370727628469467, 0.0369924604892731, 0.0369121320545673, 0.036831833422184, 0.03675152733922, 0.0366711840033531, 0.0365908592939377, 0.0365104675292969, 0.0364301204681396, 0.0363497771322727, 0.0362693890929222, 0.0361890196800232, 0.0361085906624794, 0.0360282249748707, 0.0359478145837784, 0.0358674079179764, 0.0357869975268841, 0.0357065238058567, 0.0356260947883129, 0.0355456471443176, 0.0354651920497417, 0.0353847406804562, 0.0353042297065258, 0.0352237559854984, 0.0351432822644711, 0.0350627712905407, 0.0349822789430618, 0.0349017195403576, 0.0348212048411369, 0.0347406938672066, 0.0346601605415344, 0.0345796197652817, 0.0344990454614162, 0.0344184674322605, 0.0343378931283951, 0.0342573150992393, 0.0341767594218254, 0.0340961404144764, 0.0340155214071274, 0.0339349023997784, 0.0338542833924294, 0.0337736867368221, 0.0336930230259895, 0.0336123593151569, 0.0335316993296146, 0.0334510393440723, 0.03337037935853, 0.033289697021246, 0.0332089923322201, 0.0331282913684845, 0.0330475866794586, 0.0329669043421745, 0.0328861624002457, 0.0328054167330265, 0.032724667340517, 0.03264394775033, 0.0325632020831108, 0.0324824340641499, 0.0324016250669956, 0.0323208384215832, 0.0322400704026222, 0.0321592837572098, 0.0320784747600555, 0.0319976471364498, 0.0319168195128441, 0.0318360105156898, 0.0317551828920841, 0.0316743291914463, 0.0315934605896473, 0.031512588262558, 0.0314317159354687, 0.0313508696854115, 0.0312699526548386, 0.0311890821903944, 0.0311081260442734, 0.0310272350907326, 0.03094632178545, 0.0308653879910707, 0.030784472823143, 0.0307034775614738, 0.0306225419044495, 0.0305415671318769, 0.0304606109857559, 0.0303796548396349, 0.0302986185997725, 0.0302176382392645, 0.0301366224884987, 0.0300556253641844, 0.0299746263772249, 0.029893547296524, 0.0298125278204679, 0.0297314897179604, 0.0296504497528076, 0.0295693874359131, 0.0294882878661156, 0.0294072274118662, 0.0293261241167784, 0.0292450431734324, 0.0291639603674412, 0.0290827974677086, 0.0290016941726208, 0.0289205498993397, 0.0288394279778004, 0.0287583041936159, 0.0286771170794964, 0.0285959728062153, 0.0285147856920958, 0.028433620929718, 0.0283524543046951, 0.0282712038606405, 0.0281900186091661, 0.02810881100595, 0.0280276034027338, 0.027946375310421, 0.0278651472181082, 0.0277838781476021, 0.0277026277035475, 0.0276213772594929, 0.0275401286780834, 0.0274588372558355, 0.027377525344491, 0.0272962339222431, 0.0272149424999952, 0.0271336510777473, 0.027052316814661, 0.0269709639251232, 0.0268896296620369, 0.0268082953989506, 0.0267269425094128, 0.0266455877572298, 0.0265642106533051, 0.0264828130602837, 0.0264014396816492, 0.0263200420886278, 0.0262386668473482, 0.0261572282761335, 0.0260758120566607, 0.0259943939745426, 0.0259129554033279, 0.0258315168321133, 0.0257500372827053, 0.0256685763597488, 0.0255871172994375, 0.0255056358873844, 0.0254241768270731, 0.0253426544368267, 0.025261152535677, 0.0251796506345272, 0.0250981282442808, 0.0250166282057762, 0.0249350629746914, 0.0248535182327032, 0.0247719753533602, 0.0246904101222754, 0.0246088672429323, 0.0245273038744926, 0.0244456753134727, 0.0243640895932913, 0.024282481521368, 0.0242008958011866, 0.0241192914545536, 0.0240376219153404, 0.0239559933543205, 0.023874344304204, 0.0237927176058292, 0.0237110685557127, 0.0236293561756611, 0.0235476884990931, 0.0234659966081381, 0.0233843270689249, 0.0233026370406151, 0.023220881819725, 0.0231391917914152, 0.023057458922267, 0.0229757465422153, 0.0228939931839705, 0.0228122193366289, 0.0227304864674807, 0.0226487126201391, 0.0225669387727976, 0.0224851630628109, 0.0224033463746309, 0.0223215501755476, 0.0222397334873676, 0.0221579372882843, 0.0220761001110077, 0.0219942629337311, 0.0219124238938093, 0.0218305662274361, 0.0217487271875143, 0.0216668471693993, 0.0215849466621876, 0.0215030889958143, 0.0214211884886026, 0.0213393084704876, 0.0212573856115341, 0.0211754441261292, 0.0210935417562723, 0.0210116002708673, 0.0209296774119139, 0.0208477359265089, 0.0207657720893621, 0.0206837859004736, 0.020601823925972, 0.0205198377370834, 0.02043785341084, 0.0203558690845966, 0.0202738419175148, 0.020191814750433, 0.0201098099350929, 0.0200277622789145, 0.0199457351118326, 0.0198636464774609, 0.0197815969586372, 0.0196995493024588, 0.0196174792945385, 0.0195354111492634, 0.0194532796740532, 0.0193711891770363, 0.0192891005426645, 0.0192069690674543, 0.0191248785704374, 0.0190427042543888, 0.0189605727791786, 0.0188784394413233, 0.0187962651252747, 0.0187141336500645, 0.0186319183558226, 0.0185497440397739, 0.0184675715863705, 0.0183853562921286, 0.0183031819760799, 0.0182209219783545, 0.0181387066841125, 0.0180564913898706, 0.0179742537438869, 0.0178920179605484, 0.0178097169846296, 0.0177274588495493, 0.017645200714469, 0.017562922090292, 0.017480643466115, 0.0173983443528414, 0.017316022887826, 0.0172337219119072, 0.0171513799577951, 0.0170690603554249, 0.0169867184013128, 0.016904354095459, 0.0168220121413469, 0.0167396496981382, 0.0166572872549295, 0.0165749024599791, 0.0164924971759319, 0.0164101142436266, 0.0163276884704828, 0.0162453036755323, 0.0161628779023886, 0.0160804316401482, 0.0159979835152626, 0.015915535390377, 0.0158331096172333, 0.0157506223767996, 0.0156681314110756, 0.0155856423079967, 0.0155031755566597, 0.0154206855222583, 0.0153381759300828, 0.0152556449174881, 0.0151731139048934, 0.0150906043127179, 0.0150080937892199, 0.0149255413562059, 0.0148429470136762, 0.0147603955119848, 0.0146778216585517, 0.0145952710881829, 0.0145126767456532, 0.0144300600513816, 0.0143474461510777, 0.014264851808548, 0.014182236045599, 0.0140996007248759, 0.0140169858932495, 0.0139343068003654, 0.0138516500592232, 0.0137690138071775, 0.0136863356456161, 0.0136036789044738, 0.0135209374129772, 0.0134382592514157, 0.013355559669435, 0.0132728610187769, 0.0131901409476995, 0.0131073780357838, 0.0130246579647064, 0.0129419164732099, 0.0128591544926167, 0.0127764139324427, 0.0126936100423336, 0.0126108471304178, 0.0125280637294054, 0.0124452598392963, 0.0123624764382839, 0.0122796297073364, 0.0121968258172274, 0.0121139790862799, 0.0120311537757516, 0.0119483284652233, 0.0118654407560825, 0.0117825949564576, 0.0116997277364135, 0.0116168605163693, 0.011533971875906, 0.0114510413259268, 0.011368153616786, 0.0112852435559034, 0.0112023344263434, 0.0111194252967834, 0.0110364528372884, 0.0109535222873092, 0.0108705507591367, 0.0107875987887383, 0.0107046477496624, 0.0106216752901673, 0.0105386609211564, 0.0104556679725647, 0.010372675023973, 0.0102896820753813, 0.0102066667750478, 0.010123610496521, 0.0100405542179942, 0.00995753984898329, 0.00987450499087572, 0.00979142729192972, 0.00970834959298372, 0.00962527189403772, 0.0095421951264143, 0.0094591174274683, 0.00937599875032902, 0.00929287821054459, 0.0092097595334053, 0.00912663992494345, 0.00904352124780416, 0.00896035879850388, 0.00887719728052616, 0.00879403669387102, 0.00871087517589331, 0.00862771365791559, 0.00854453071951866, 0.00846130680292845, 0.0083781024441123, 0.0082948999479413, 0.00821167603135109, 0.00812847167253494, 0.00804520584642887, 0.00796196050941944, 0.00787873566150665, 0.00779546890407801, 0.00771222310140729, 0.00762891490012407, 0.0075456271879375, 0.00746236136183143, 0.00737905316054821, 0.00729574402794242, 0.0072124358266592, 0.00712908525019884, 0.00704575562849641, 0.00696240505203605, 0.00687907543033361, 0.00679572485387325, 0.0067123114131391, 0.00662896083667874, 0.00654556835070252, 0.00646219681948423, 0.00637880433350801, 0.00629534851759672, 0.0062119560316205, 0.00612852163612843, 0.00604510819539428, 0.0059616737999022, 0.00587817607447505, 0.00579474121332169, 0.00571126490831375, 0.00562780909240246, 0.00554435374215245, 0.00546081410720944, 0.00537733733654022, 0.00529381865635514, 0.00521030044183135, 0.0051268027164042, 0.00504322117194533, 0.00495970249176025, 0.00487614190205932, 0.00479260226711631, 0.00470904167741537, 0.00462543871253729, 0.00454185716807842, 0.00445827562361956, 0.00437467312440276, 0.00429107062518597, 0.00420742575079203, 0.00412382325157523, 0.00404017837718129, 0.00395655492320657, 0.00387291004881263, 0.00378926540724933, 0.00370557885617018, 0.00362189207226038, 0.00353822624310851, 0.00345453969202936, 0.00337085290811956, 0.0032871242146939, 0.00320339552126825, 0.00311968778260052, 0.00303595908917487, 0.00295223039574921, 0.00286845955997705, 0.0027846887242049, 0.00270093930885196, 0.0026171684730798, 0.00253339787013829, 0.00244958489201963, 0.00236579310148954, 0.00228198035620153, 0.00219816761091352, 0.00211435509845614, 0.00203050021082163, 0.00194666627794504, 0.0018628325778991, 0.00177895685192198, 0.00169512303546071, 0.00161122623831034, 0.00152732944115996, 0.00144345371518284, 0.00135955680161715, 0.0012756809592247, 0.00119170011021197, 0.00110780342947692, 0.00102388567756861, 0.00093994673807174, 0.000856007914990187, 0.000772006053011864, 0.000688067229930311, 0.000604107393883169, 0.000520126544870436, 0.000436145724961534, 0.000352143833879381, 0.0002681209880393, 0.000184119140612893, 0.000100096258393023, 1.60733925440582e-05, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556, 0.012569572776556   }, 
   { 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 0.0150850676000118, 8.82685526448768e-06, 3.84053055313416e-05, 6.79413205944002e-05, 9.75197690422647e-05, 0.000127183098811656, 0.00015684642130509, 0.000186509743798524, 0.000216215514228679, 0.000245878822170198, 0.000275627040537074, 0.00030537522980012, 0.000335165852447972, 0.000364914070814848, 0.000394747126847506, 0.00042462267447263, 0.000454498163890094, 0.000484331219922751, 0.000514249142725021, 0.000544209557119757, 0.000574169913306832, 0.000604087894316763, 0.000634090683888644, 0.000664135965052992, 0.000694181188009679, 0.000724226469174027, 0.000754314183723181, 0.000784444273449481, 0.00081457442138344, 0.00084470451110974, 0.000874877092428505, 0.000905092107132077, 0.000935307121835649, 0.000965522136539221, 0.000995779526419938, 0.00102607940789312, 0.0010563792893663, 0.00108667917083949, 0.00111702154390514, 0.00114740629214793, 0.00117783341556787, 0.00120826065540314, 0.00123864540364593, 0.00126911501865834, 0.00129962700884789, 0.00133013911545277, 0.00136060873046517, 0.00139120558742434, 0.00142176018562168, 0.00145235715899616, 0.00148295401595533, 0.00151359336450696, 0.00154427520465106, 0.00157495704479516, 0.00160559639334679, 0.0016363631002605, 0.00166712980717421, 0.00169789651408792, 0.0017286631045863, 0.00175947230309248, 0.0017903238767758, 0.0018211753340438, 0.00185202690772712, 0.00188296334818006, 0.00191389978863299, 0.0019448361126706, 0.00197577266953886, 0.00200675148516893, 0.00203777267597616, 0.00206883647479117, 0.00209985789842904, 0.00213096407242119, 0.00216202787123621, 0.00219317642040551, 0.00222432496957481, 0.00225547351874411, 0.0022866646759212, 0.00231789797544479, 0.00234913174062967, 0.00238036504015326, 0.00241164118051529, 0.00244295923039317, 0.00247427774593234, 0.00250559602864087, 0.00253695668652654, 0.00256836018525064, 0.0025997634511441, 0.00263116648420691, 0.00266265473328531, 0.00269410037435591, 0.00272563076578081, 0.0027571190148592, 0.00278869201429188, 0.00282026501372457, 0.00285183801315725, 0.00288341101258993, 0.0029150687623769, 0.00294672674499452, 0.00297838449478149, 0.00301008485257626, 0.00304178497754037, 0.00307352794334292, 0.00310531305149198, 0.00313705578446388, 0.00316888326779008, 0.00320071098394692, 0.0032325810752809, 0.0032644085586071, 0.00329632102511823, 0.00332823372446001, 0.00336018856614828, 0.0033921857830137, 0.00342409824952483, 0.00345613807439804, 0.00348817766644061, 0.00352021772414446, 0.00355225731618702, 0.00358433951623738, 0.00361646432429552, 0.00364863150753081, 0.00368075584992766, 0.0037129654083401, 0.00374517519958317, 0.00377738475799561, 0.00380959431640804, 0.00384188862517476, 0.00387418316677213, 0.00390651961788535, 0.00393881415948272, 0.00397119345143437, 0.00400357274338603, 0.00403599441051483, 0.00406837370246649, 0.00410083821043372, 0.00413330225273967, 0.00416580867022276, 0.00419827271252871, 0.00423082197085023, 0.00426341313868761, 0.00429600477218628, 0.00432855356484652, 0.00436118757352233, 0.00439386395737529, 0.00442654034122825, 0.00445921672508121, 0.00449189310893416, 0.00452461186796427, 0.00455741537734866, 0.0045901769772172, 0.00462298048660159, 0.00465578399598598, 0.00468863034620881, 0.00472151860594749, 0.00475436449050903, 0.00478729559108615, 0.00482022669166327, 0.00485320016741753, 0.00488613080233335, 0.00491914665326476, 0.00495216250419617, 0.00498522073030472, 0.00501827942207456, 0.00505138002336025, 0.00508448062464595, 0.00511758122593164, 0.00515072466805577, 0.00518391001969576, 0.00521713821217418, 0.00525032356381416, 0.00528355175629258, 0.00531682232394814, 0.00535013480111957, 0.00538344774395227, 0.00541676068678498, 0.00545007362961769, 0.00548347132280469, 0.00551686901599169, 0.00555030908435583, 0.00558370724320412, 0.00561718968674541, 0.00565067213028669, 0.0056841978803277, 0.0057176798582077, 0.00575124798342586, 0.00578481517732143, 0.00581842474639416, 0.00585199287161231, 0.00588564528152347, 0.00591933960095048, 0.00595303438603878, 0.00598668679594994, 0.00602042395621538, 0.00605416158214211, 0.00608794111758471, 0.00612172111868858, 0.00615554302930832, 0.00618936540558934, 0.00622322969138622, 0.00625709444284439, 0.0062910015694797, 0.00632495060563087, 0.00635890057310462, 0.00639284960925579, 0.00642684148624539, 0.00646087573841214, 0.00649491045624018, 0.00652894470840693, 0.00656302133575082, 0.00659714033827186, 0.00663125934079289, 0.00666542071849108, 0.0066995401866734, 0.00673374393954873, 0.00676799099892378, 0.00680219521746039, 0.00683644134551287, 0.00687073078006506, 0.00690501974895597, 0.00693939300253987, 0.00697368197143078, 0.00700805615633726, 0.00704242987558246, 0.00707688834518194, 0.00711126253008842, 0.00714576290920377, 0.00718022184446454, 0.00721472315490246, 0.00724922399967909, 0.00728376815095544, 0.00731835374608636, 0.00735293980687857, 0.00738752586767077, 0.00742215383797884, 0.00745682464912534, 0.00749149639159441, 0.00752616720274091, 0.00756087992340326, 0.00759563595056534, 0.00763039197772741, 0.00766514707356691, 0.00769998831674457, 0.00773482862859964, 0.00776966940611601, 0.00780450971797109, 0.00783943571150303, 0.00787436123937368, 0.00790928676724434, 0.00794429704546928, 0.00797922257333994, 0.00801423192024231, 0.00804928503930569, 0.00808433815836906, 0.00811939127743244, 0.00815448630601168, 0.00818958133459091, 0.00822476111352444, 0.00825985614210367, 0.0082950796931982, 0.00833030138164759, 0.00836552493274212, 0.0084007466211915, 0.00843601208180189, 0.00847131945192814, 0.00850666966289282, 0.00854197703301907, 0.00857732631266117, 0.00861271843314171, 0.00864811148494482, 0.00868350267410278, 0.00871898047626019, 0.00875445827841759, 0.00878993514925241, 0.00882541202008724, 0.00886097457259893, 0.00889653619378805, 0.0089321406558156, 0.00896770227700472, 0.00900330673903227, 0.00903899595141411, 0.00907464325428009, 0.00911037530750036, 0.0091460645198822, 0.00918179657310247, 0.00921752862632275, 0.00925334449857473, 0.00928911846131086, 0.009324936196208, 0.00936079490929842, 0.00939665362238884, 0.00943251326680183, 0.00946845673024654, 0.00950440019369125, 0.00954034458845854, 0.00957628898322582, 0.00961227528750896, 0.0096483463421464, 0.00968437548726797, 0.00972040370106697, 0.00975651759654284, 0.0097926314920187, 0.00982874538749456, 0.00986490119248629, 0.00990105792880058, 0.0099372984841466, 0.00997353997081518, 0.0100096957758069, 0.0100459791719913, 0.0100822625681758, 0.0101185878738761, 0.0101549150422215, 0.0101912403479218, 0.010227651335299, 0.0102640623226762, 0.0103004723787308, 0.0103368842974305, 0.0103733791038394, 0.0104098748415709, 0.0104463705793023, 0.0104828663170338, 0.0105194048956037, 0.0105560272932053, 0.010592607781291, 0.0106291882693768, 0.0106658544391394, 0.0107025187462568, 0.0107392258942127, 0.0107758920639753, 0.0108126001432538, 0.0108493501320481, 0.0108861429616809, 0.0109228929504752, 0.0109597286209464, 0.0109966062009335, 0.0110334418714046, 0.0110702766105533, 0.0111071961000562, 0.0111441593617201, 0.0111811216920614, 0.0112180411815643, 0.0112550463527441, 0.0112920515239239, 0.0113290986046195, 0.0113661466166377, 0.0114032356068492, 0.0114403255283833, 0.0114774573594332, 0.0115146329626441, 0.011551764793694, 0.0115889385342598, 0.0116261979565024, 0.0116634154692292, 0.0117006320506334, 0.0117379343137145, 0.0117752375081182, 0.0118125816807151, 0.011849882081151, 0.0118872700259089, 0.0119246561080217, 0.0119620859622955, 0.0119994729757309, 0.0120369447395205, 0.0120744593441486, 0.0121119301766157, 0.0121494447812438, 0.0121870012953877, 0.0122245578095317, 0.0122621562331915, 0.0122997555881739, 0.0123373540118337, 0.0123750381171703, 0.012412722222507, 0.0124504063278437, 0.0124881332740188, 0.0125258583575487, 0.0125636272132397, 0.0126013960689306, 0.01263920776546, 0.0126770613715053, 0.0127149149775505, 0.0127527257427573, 0.0127906650304794, 0.0128286024555564, 0.0128665417432785, 0.0129045220091939, 0.012942461296916, 0.0129804844036698, 0.0130185084417462, 0.0130565725266933, 0.0130945965647697, 0.0131327044218779, 0.013170856051147, 0.013209005817771, 0.0132471146062016, 0.0132853081449866, 0.0133235435932875, 0.0133617790415883, 0.0133999725803733, 0.01343824993819, 0.0134765710681677, 0.0135148912668228, 0.0135532114654779, 0.0135915745049715, 0.0136299366131425, 0.0136683853343129, 0.0137067474424839, 0.0137452371418476, 0.0137837277725339, 0.0138222184032202, 0.0138606652617455, 0.013899240642786, 0.0139378169551492, 0.0139763904735446, 0.0140149667859077, 0.0140535840764642, 0.0140922432765365, 0.0141309462487698, 0.0141696482896805, 0.0142083074897528, 0.0142470523715019, 0.0142857981845737, 0.0143245849758387, 0.0143633726984262, 0.0144022023305297, 0.014441073872149, 0.0144799463450909, 0.0145187759771943, 0.0145577332004905, 0.0145966475829482, 0.0146356467157602, 0.014674561098218, 0.0147135611623526, 0.014752603136003, 0.0147916451096535, 0.0148306861519814, 0.0148698138073087, 0.0149089395999908, 0.0149480663239956, 0.0149871930480003, 0.0150263626128435, 0.0150655740872025, 0.0151047855615616, 0.0151439970359206, 0.0151832932606339, 0.0152225904166698, 0.0152618866413832, 0.0153011828660965, 0.0153405647724867, 0.0153799457475543, 0.0154193276539445, 0.0154587086290121, 0.015498174354434, 0.0155376410111785, 0.0155771495774388, 0.0156166581436992, 0.0156561676412821, 0.0156957190483809, 0.0157353114336729, 0.0157749056816101, 0.0158144980669022, 0.0158541351556778, 0.0158938132226467, 0.0159334912896156, 0.0159731693565845, 0.0160129331052303, 0.0160526540130377, 0.0160924587398767, 0.0161322224885225, 0.0161720290780067, 0.0162119194865227, 0.0162517670542002, 0.0162916146218777, 0.0163315068930387, 0.016371438279748, 0.0164114143699408, 0.0164513476192951, 0.0164913665503263, 0.0165313836187124, 0.0165714435279369, 0.0166114624589682, 0.016651563346386, 0.0166916660964489, 0.0167317688465118, 0.0167719163000584, 0.0168120600283146, 0.0168522913008928, 0.0168925207108259, 0.016932750120759, 0.0169729813933372, 0.0170132536441088, 0.0170535687357187, 0.017093924805522, 0.0171342398971319, 0.0171745978295803, 0.017214996740222, 0.0172553975135088, 0.0172958392649889, 0.0173362828791142, 0.0173767674714327, 0.0174172949045897, 0.0174577794969082, 0.01749830506742, 0.0175389181822538, 0.0175794865936041, 0.0176200997084379, 0.0176607128232718, 0.0177013669162989, 0.0177420619875193, 0.0177827179431915, 0.0178234558552504, 0.0178642384707928, 0.0179049782454967, 0.017945758998394, 0.0179865416139364, 0.0180274080485106, 0.0180682744830847, 0.0181090980768204, 0.0181500092148781, 0.0181909594684839, 0.0182319097220898, 0.0182728618383408, 0.0183138139545918, 0.018354807049036, 0.0183958876878023, 0.018436923623085, 0.0184779595583677, 0.0185190811753273, 0.0185602027922869, 0.0186013653874397, 0.0186424870043993, 0.0186836943030357, 0.018724899739027, 0.0187661480158567, 0.018807353451848, 0.0188486445695162, 0.0188899356871843, 0.0189312696456909, 0.0189725607633591, 0.0190139357000589, 0.0190553553402424, 0.0190967302769423, 0.0191381499171257, 0.0191796105355024, 0.0192210711538792, 0.0192625727504492, 0.0193040762096643, 0.0193456225097179, 0.0193871669471264, 0.0194287560880184, 0.0194703433662653, 0.0195119753479958, 0.0195536483079195, 0.0195953212678432, 0.0196369513869286, 0.019678708165884, 0.0197204668074846, 0.0197621826082468, 0.0198039822280407, 0.0198457837104797, 0.0198875833302736, 0.0199294686317444, 0.0199713539332151, 0.0200131963938475, 0.0200551226735115, 0.0200970508158207, 0.0201390217989683, 0.0201809909194708, 0.0202230028808117, 0.0202650167047977, 0.0203070696443319, 0.0203490816056728, 0.020391222089529, 0.020433321595192, 0.020475460216403, 0.0205175578594208, 0.0205597802996635, 0.0206019636243582, 0.0206442307680845, 0.0206864140927792, 0.0207286793738604, 0.0207709893584251, 0.0208132993429899, 0.0208556093275547, 0.0208979602903128, 0.0209403540939093, 0.0209827497601509, 0.0210251454263926, 0.0210675820708275, 0.0211100596934557, 0.0211525820195675, 0.0211951043456793, 0.0212375819683075, 0.0212801452726126, 0.0213227104395628, 0.0213653165847063, 0.021407924592495, 0.0214505717158318, 0.0214932225644588, 0.0215359143912792, 0.0215786043554544, 0.0216213390231133, 0.0216641146689653, 0.0217068921774626, 0.0217496268451214, 0.02179248444736, 0.021835345774889, 0.0218782071024179, 0.0219210684299469, 0.0219639744609594, 0.0220068767666817, 0.0220498647540808, 0.0220928117632866, 0.0221358016133308, 0.0221788305789232, 0.0222218614071608, 0.0222648940980434, 0.0223080087453127, 0.0223511252552271, 0.0223942399024963, 0.0224373564124107, 0.0224805139005184, 0.0225237142294645, 0.0225669592618942, 0.0226102005690336, 0.0226534008979797, 0.0226967297494411, 0.0227400157600641, 0.0227833427488804, 0.0228266716003418, 0.0228700414299965, 0.0229134541004896, 0.0229568667709827, 0.0230002794414759, 0.0230437349528074, 0.0230872333049774, 0.0231307316571474, 0.0231742281466722, 0.0232177674770355, 0.0232613515108824, 0.0233049746602774, 0.0233485586941242, 0.0233921855688095, 0.0234358515590429, 0.0234795194119215, 0.0235231854021549, 0.0235669389367104, 0.0236106906086206, 0.0236544441431761, 0.0236981939524412, 0.0237420313060284, 0.0237858686596155, 0.0238297488540411, 0.0238735862076283, 0.0239175073802471, 0.0239614322781563, 0.0240053534507751, 0.0240493174642324, 0.0240933243185282, 0.0241373330354691, 0.0241813398897648, 0.0242254305630922, 0.0242694802582264, 0.0243135709315538, 0.0243577063083649, 0.0244018398225307, 0.0244459751993418, 0.0244901515543461, 0.0245343707501888, 0.02457863278687, 0.0246228501200676, 0.0246671121567488, 0.0247114170342684, 0.0247557628899813, 0.0248000677675009, 0.0248444564640522, 0.0248888451606035, 0.0249332338571548, 0.0249776225537062, 0.0250220950692892, 0.0250665713101625, 0.025111086666584, 0.0251555591821671, 0.025200117379427, 0.025244677439332, 0.0252892784774303, 0.0253338385373354, 0.025378480553627, 0.0254231244325638, 0.0254678092896938, 0.025512496009469, 0.0255572255700827, 0.025601951405406, 0.0256467238068581, 0.025691494345665, 0.0257362648844719, 0.0257811211049557, 0.0258259773254395, 0.0258708335459232, 0.0259157307446003, 0.0259606279432774, 0.026005569845438, 0.0260505508631468, 0.0260954946279526, 0.0261405184864998, 0.0261855442076921, 0.0262305680662394, 0.0262756384909153, 0.0263207051903009, 0.0263658575713634, 0.026411009952426, 0.0264561213552952, 0.0265012737363577, 0.0265465117990971, 0.0265917498618364, 0.0266369432210922, 0.02668222412467, 0.0267275050282478, 0.0267728269100189, 0.02681814879179, 0.0268635153770447, 0.0269088800996542, 0.0269543286412954, 0.026999693363905, 0.0270451437681913, 0.027090635150671, 0.0271361265331507, 0.0271816216409206, 0.0272271130234003, 0.0272726882249117, 0.0273182671517134, 0.0273638851940632, 0.0274094641208649, 0.0274551250040531, 0.0275007877498865, 0.0275464933365583, 0.0275921542197466, 0.0276379007846117, 0.027683649212122, 0.0277294367551804, 0.0277751833200455, 0.0278210155665874, 0.0278668906539679, 0.0279127638787031, 0.0279585961252451, 0.0280045550316572, 0.0280504282563925, 0.028096430003643, 0.0281423460692167, 0.0281883496791124, 0.0282343924045563, 0.0282804351300001, 0.0283264815807343, 0.0283725671470165, 0.0284186545759439, 0.0284648239612579, 0.0285109542310238, 0.0285570826381445, 0.0286032967269421, 0.0286495089530945, 0.0286957658827305, 0.0287420228123665, 0.0287882778793573, 0.0288346204906702, 0.0288809612393379, 0.0289272572845221, 0.0289736408740282, 0.0290200244635344, 0.0290664508938789, 0.0291128363460302, 0.0291593465954065, 0.0292058140039444, 0.0292523242533207, 0.029298834502697, 0.0293453894555569, 0.0293919406831264, 0.0294385366141796, 0.0294851325452328, 0.0295317694544792, 0.0295784082263708, 0.0296251326799393, 0.0296718124300241, 0.0297185350209475, 0.029765298590064, 0.0298120658844709, 0.0298588313162327, 0.0299056395888329, 0.0299524888396263, 0.0299993399530649, 0.0300461892038584, 0.0300930831581354, 0.0301400180906057, 0.0301869530230761, 0.0302339289337397, 0.0302809067070484, 0.0303279291838408, 0.0303749907761812, 0.0304220095276833, 0.0304690711200237, 0.0305161774158478, 0.03056332282722, 0.0306104719638824, 0.0306575763970613, 0.0307047665119171, 0.0307519994676113, 0.0307992305606604, 0.0308464635163546, 0.030893737450242, 0.030941054224968, 0.030988372862339, 0.0310356877744198, 0.0310830473899841, 0.0311304498463869, 0.031177893280983, 0.0312252528965473, 0.0312727391719818, 0.0313202254474163, 0.0313677117228508, 0.0314152017235756, 0.0314627289772034, 0.0315103009343147, 0.0315579175949097, 0.0316054858267307, 0.0316530987620354, 0.0317008011043072, 0.0317484587430954, 0.0317961126565933, 0.0318438559770584, 0.0318915955722332, 0.0319393388926983, 0.0319871641695499, 0.032034907490015, 0.0320827327668667, 0.0321306027472019, 0.0321785137057304, 0.0322263352572918, 0.0322742909193039, 0.0323222018778324, 0.0323701985180378, 0.0324181094765663, 0.032466147094965, 0.0325141847133636, 0.0325622260570526, 0.0326102636754513, 0.0326583869755268, 0.0327065102756023, 0.0327546335756779, 0.0328027568757534, 0.0328509211540222, 0.0328991301357746, 0.0329473838210106, 0.0329955890774727, 0.0330438837409019, 0.0330921746790409, 0.0331405103206635, 0.0331888049840927, 0.0332371816039085, 0.0332855582237244, 0.0333339832723141, 0.0333823189139366, 0.0334307812154293, 0.0334792844951153, 0.0335277915000916, 0.0335762947797775, 0.0336247980594635, 0.0336733497679234, 0.0337219387292862, 0.0337705723941326, 0.0338191613554955, 0.0338677912950516, 0.0339164696633816, 0.0339651443064213, 0.034013818949461, 0.0340625792741776, 0.0341113358736038, 0.034160140901804, 0.0342089012265205, 0.0342577025294304, 0.0343065485358238, 0.0343554317951202, 0.034404281526804, 0.034453209489584, 0.0345021411776543, 0.0345511101186275, 0.0346000418066978, 0.0346490554511547, 0.0346980690956116, 0.0347471237182617, 0.0347961410880089, 0.0348452404141426, 0.0348943397402763, 0.0349434800446033, 0.0349926240742207, 0.0350417643785477, 0.0350909940898418, 0.0351402163505554, 0.0351894870400429, 0.0352387167513371, 0.0352879837155342, 0.035337295383215, 0.035386648029089, 0.0354359596967697, 0.035485316067934, 0.0355347543954849, 0.0355841517448425, 0.0356335453689098, 0.0356830283999443, 0.0357325077056885, 0.0357820317149162, 0.0358315147459507, 0.0358810797333717, 0.0359306447207928, 0.0359802544116974, 0.0360298231244087, 0.0360794700682163, 0.0361291654407978, 0.0361788161098957, 0.0362285114824772, 0.0362782441079617, 0.03632802516222, 0.0363777615129948, 0.0364275388419628, 0.0364773571491241, 0.0365271791815758, 0.0365770421922207, 0.0366269052028656, 0.0366768129169941, 0.0367267616093159, 0.0367767065763474, 0.0368266552686691, 0.0368766039609909, 0.0369266383349895, 0.0369767136871815, 0.0370267443358898, 0.0370767787098885, 0.037126898765564, 0.0371770560741425, 0.0372272171080112, 0.0372773371636868, 0.0373274981975555, 0.0373777411878109, 0.0374279879033566, 0.0374781861901283, 0.0375284776091576, 0.0375788062810898, 0.0376290939748287, 0.0376794263720512, 0.0377297960221767, 0.0377802141010761, 0.0378306284546852, 0.037881001830101, 0.0379314571619034, 0.0379819571971893, 0.0380324572324753, 0.0380829572677612, 0.0381334982812405, 0.0381840392947197, 0.0382346659898758, 0.0382852107286453, 0.0383358784019947, 0.0383865050971508, 0.0384371764957905, 0.0384878441691399, 0.0385386012494564, 0.0385893546044827, 0.0386401079595089, 0.0386909060180187, 0.0387417040765285, 0.0387924984097481, 0.0388433784246445, 0.0388942621648312, 0.0389451012015343, 0.0389960259199142, 0.0390469506382942, 0.0390979573130608, 0.0391488820314407, 0.0391998924314976, 0.0392509438097477, 0.0393019951879978, 0.0393530465662479, 0.0394041426479816, 0.0394552759826183, 0.0395064130425453, 0.0395575501024723, 0.0396087281405926, 0.0396599061787128, 0.03971116989851, 0.0397623926401138, 0.039813656359911, 0.0398649610579014, 0.0399163104593754, 0.0399675741791725, 0.0400189235806465, 0.0400703139603138, 0.0401217453181744, 0.0401731394231319, 0.0402245707809925, 0.0402760468423367, 0.0403275638818741, 0.0403790809214115, 0.0404306054115295, 0.040482122451067, 0.0405337251722813, 0.0405853278934956, 0.0406369306147099, 0.0406885743141174, 0.0407402627170086, 0.04079195484519, 0.0408436395227909, 0.0408953726291656, 0.0409471429884434, 0.0409989133477211, 0.0410506911575794, 0.0411025024950504, 0.0411543622612953, 0.0412062183022499, 0.0412580780684948, 0.0413100197911263, 0.041361965239048, 0.0414139032363892, 0.0414658486843109, 0.0415178351104259, 0.041569858789444, 0.0416219308972359, 0.0416739583015442, 0.0417260266840458, 0.0417781844735146, 0.0418302938342094, 0.0418824478983879, 0.0419346056878567, 0.0419868007302284, 0.0420390442013741, 0.0420912355184555, 0.0421435199677944, 0.0421958044171333, 0.0422481298446655, 0.0423004515469074, 0.0423527806997299, 0.0424051433801651, 0.0424575544893742, 0.0425100065767765, 0.0425624139606953, 0.0426148250699043, 0.0426673628389835, 0.0427198521792889, 0.0427723489701748, 0.0428249314427376, 0.0428774654865265, 0.0429300889372826, 0.0429826676845551, 0.0430353283882141, 0.0430879928171635, 0.0431406609714031, 0.0431933254003525, 0.0432460717856884, 0.0432988218963146, 0.0433516092598438, 0.04340435937047, 0.0434571951627731, 0.0435100272297859, 0.0435629077255726, 0.0436157360672951, 0.0436686612665653, 0.0437215752899647, 0.0437745377421379, 0.0438274554908276, 0.0438804589211941, 0.0439335070550442, 0.043986551463604, 0.0440395995974541, 0.0440926402807236, 0.0441457740962505, 0.0441988632082939, 0.0442520380020142, 0.0443051680922508, 0.0443583838641644, 0.0444115996360779, 0.0444648116827011, 0.0445180721580982, 0.044571328908205, 0.044624675065279, 0.0446779727935791, 0.0447312742471695, 0.0447846613824368, 0.0448380447924137, 0.0448914766311646, 0.0449448600411415, 0.0449983328580856, 0.0450518019497395, 0.0451053120195866, 0.045158825814724, 0.0452123805880547, 0.0452659353613853, 0.0453195348381996, 0.0453730896115303, 0.0454267300665379, 0.0454804114997387, 0.0455340966582298, 0.0455877371132374, 0.0456414595246315, 0.0456952266395092, 0.0457489974796772, 0.0458028055727482, 0.0458565726876259, 0.0459103807806969, 0.0459642335772514, 0.0460181310772896, 0.0460719838738441, 0.046125914901495, 0.0461798533797264, 0.0462338365614414, 0.0462877713143826, 0.0463417954742908, 0.0463958159089088, 0.0464498810470104, 0.0465039052069187, 0.0465580113232136, 0.0466121584177017, 0.0466663055121899, 0.0467204116284847, 0.0467746071517467, 0.0468288436532021, 0.0468830727040768, 0.0469372682273388, 0.0469915457069874, 0.0470458641648293, 0.0471001826226711, 0.0471544601023197, 0.0472088642418385, 0.0472632236778736, 0.0473176725208759, 0.0473720319569111, 0.0474265217781067, 0.0474809668958187, 0.0475354567170143, 0.0475899465382099, 0.0476444736123085, 0.0476990528404713, 0.0477536246180534, 0.0478082373738289, 0.0478628575801849, 0.047917515039444, 0.0479721762239933, 0.0480268746614456, 0.0480815321207047, 0.0481362789869308, 0.0481910593807697, 0.0482458472251892, 0.0483005940914154, 0.0483554191887379, 0.0484102927148342, 0.0484651625156403, 0.0485200323164463, 0.0485749468207359, 0.0486298613250256, 0.0486848168075085, 0.0487397722899914, 0.0487947687506676, 0.048849806189537, 0.0489048473536968, 0.0489598922431469, 0.0490149743855, 0.0490700975060463, 0.0491252653300762, 0.0491803511977196, 0.0492355599999428, 0.0492907278239727, 0.0493459776043892, 0.0494011901319027, 0.0494564399123192, 0.0495117381215096, 0.0495670773088932, 0.0496224164962769, 0.0496777072548866, 0.0497330874204636, 0.0497885085642338, 0.0498439334332943, 0.0498993545770645, 0.049954779446125, 0.0500102862715721, 0.0500657930970192, 0.0501212999224663, 0.0501768514513969, 0.0502324439585209, 0.0502880327403545, 0.0503436252474785, 0.050399262458086, 0.0504549369215965, 0.0505106188356876, 0.0505662932991982, 0.0506220161914825, 0.0506777763366699, 0.0507335811853409, 0.0507893413305283, 0.0508451461791992, 0.0509009920060635, 0.050956841558218, 0.0510127246379852, 0.0510686151683331, 0.0511245504021645, 0.0511805228888988, 0.05123645439744, 0.0512924268841743, 0.0513484850525856, 0.0514045059680939, 0.0514605641365051, 0.0515166223049164, 0.0515727251768112, 0.0516288690268993, 0.0516850128769875, 0.0517411530017853, 0.051797341555357, 0.051853571087122, 0.0519098006188869, 0.0519660301506519, 0.0520223006606102, 0.0520786121487617, 0.0521349683403969, 0.0521912425756454, 0.0522476397454739, 0.0523040406405926, 0.052360475063324, 0.0524168759584427, 0.0524733178317547, 0.0525298044085503, 0.0525862835347652, 0.0526428110897541, 0.0526993349194527, 0.0527559444308281, 0.0528125166893005, 0.0528690814971924, 0.0529257357120514, 0.0529823899269104, 0.0530390851199627, 0.0530957393348217, 0.0531524792313576, 0.0532092116773129, 0.0532659962773323, 0.0533227324485779, 0.0533795543015003, 0.0534364208579063, 0.0534932464361191, 0.0535501502454281, 0.0536070168018341, 0.0536639243364334, 0.053720872849226, 0.0537778250873089, 0.0538347736001015, 0.0538918115198612, 0.0539488457143307, 0.0540059208869934, 0.0540629588067532, 0.0541200339794159, 0.0541771575808525, 0.0542343184351921, 0.0542914383113384, 0.0543486401438713, 0.0544058457016945, 0.0544630512595177, 0.0545202977955341, 0.0545775890350342, 0.0546348802745342, 0.0546922124922276, 0.0547495000064373, 0.0548068769276142, 0.0548642501235008, 0.054921668022871, 0.0549790412187576, 0.0550365447998047, 0.0550940036773682, 0.0551515035331249, 0.0552089624106884, 0.0552665069699287, 0.0553240962326527, 0.0553816817700863, 0.0554392673075199, 0.0554968565702438, 0.055554524064064, 0.0556121990084648, 0.0556699112057686, 0.0557275861501694, 0.0557853430509567, 0.0558430999517441, 0.0559008978307247, 0.0559586547315121, 0.0560164973139763, 0.0560743324458599, 0.0561321750283241, 0.0561900623142719, 0.0562479831278324, 0.0563059113919735, 0.0563638806343079, 0.0564218088984489, 0.0564798191189766, 0.0565378703176975, 0.0565959252417088, 0.0566539354622364, 0.0567120313644409, 0.0567701272666454, 0.0568283125758171, 0.0568864084780216, 0.0569445863366127, 0.0570028126239777, 0.057061031460762, 0.057119257748127, 0.0571775212883949, 0.0572358295321465, 0.057294137775898, 0.0573524460196495, 0.0574107579886913, 0.0574691481888294, 0.0575275830924511, 0.0575860217213631, 0.0576444156467915, 0.0577028878033161, 0.0577613711357117, 0.0578198879957199, 0.0578783676028252, 0.057936929166317, 0.0579955354332924, 0.0580540969967842, 0.0581126995384693, 0.058171346783638, 0.0582300387322903, 0.0582887306809425, 0.0583473779261112, 0.0584061071276665, 0.0584648437798023, 0.0585236586630344, 0.05858239158988, 0.0586412511765957, 0.0587000697851181, 0.0587589293718338, 0.0588177889585495, 0.0588767342269421, 0.0589356385171413, 0.0589946247637272, 0.0590535253286362, 0.0591125153005123, 0.0591715425252914, 0.0592306181788445, 0.0592896863818169, 0.0593487173318863, 0.0594078302383423, 0.0594669431447983, 0.0595261007547379, 0.0595852583646774, 0.0596444569528103, 0.0597036555409431, 0.0597628988325596, 0.059822142124176, 0.0598814263939857, 0.0599407516419888, 0.0600000806152821, 0.0600594021379948, 0.0601187311112881, 0.0601781420409679, 0.0602375529706478, 0.060296967625618, 0.0603564232587814, 0.0604159198701382, 0.0604754164814949, 0.0605349130928516, 0.0605944469571114, 0.060654029250145, 0.0607136525213718, 0.0607731901109219, 0.0608328618109226, 0.0608925260603428, 0.060952190309763, 0.0610118582844734, 0.0610715858638287, 0.0611313357949257, 0.0611911118030548, 0.0612508617341518, 0.0613106936216354, 0.0613705329596996, 0.061430387198925, 0.061490248888731, 0.0615501254796982, 0.0616100467741489, 0.061670009046793, 0.061729971319437, 0.0617899149656296, 0.061849944293499, 0.0619099885225296, 0.0619700364768505, 0.0620300844311714, 0.0620901547372341, 0.0621502920985222, 0.0622104443609715, 0.0622705742716789, 0.0623307712376118, 0.0623909905552864, 0.0624512247741222, 0.0625114440917969, 0.0625717267394066, 0.0626320317387581, 0.0626923367381096, 0.0627526566386223, 0.0628129988908768, 0.0628734081983566, 0.0629338175058365, 0.0629942044615746, 0.0630546808242798, 0.0631151497364044, 0.0631756484508514, 0.0632361397147179, 0.0632966756820679, 0.0633572340011597, 0.0634178295731544, 0.0634784325957298, 0.0635390356183052, 0.0635996982455254, 0.0636603608727455, 0.0637210682034492, 0.0637817457318306, 0.0638424977660179, 0.0639032647013664, 0.0639640390872955, 0.064024806022644, 0.0640856400132179, 0.064146488904953, 0.0642073675990105, 0.0642682239413261, 0.0643291473388672, 0.0643901005387306, 0.0644510611891747, 0.0645119994878769, 0.0645729824900627, 0.0646340250968933, 0.0646950751543045, 0.0647561177611351, 0.0648172274231911, 0.064878337085247, 0.0649394690990448, 0.0650006011128426, 0.0650617927312851, 0.0651230067014694, 0.0651842206716537, 0.0652454197406769, 0.065306693315506, 0.0653693005442619, 0.0654333531856537, 0.0654974356293678, 0.065561518073082, 0.0656256154179573, 0.0656897500157356, 0.0657538920640945, 0.0658180117607117, 0.0658821985125542, 0.0659463778138161, 0.0660105720162392, 0.0660747811198235, 0.0661390125751495, 0.0662032887339592, 0.0662675574421883, 0.0663318261504173, 0.06639613956213, 0.066460445523262, 0.0665247887372971, 0.0665891394019127, 0.0666535124182701, 0.0667179003357887, 0.0667823031544685, 0.0668466910719872, 0.0669111311435699, 0.0669756010174751, 0.0670400783419609, 0.0671045184135437, 0.0671690255403519, 0.0672335550189018, 0.067298099398613, 0.0673626363277435, 0.0674271956086159, 0.0674917995929718, 0.0675564035773277, 0.0676210075616837, 0.0676856338977814, 0.0677502900362015, 0.0678149312734604, 0.0678796395659447, 0.067944310605526, 0.0680090487003326, 0.0680737942457199, 0.0681385472416878, 0.068203292787075, 0.0682680755853653, 0.0683328956365585, 0.0683977156877518, 0.0684625208377838, 0.0685273557901382, 0.0685922354459763, 0.0686571076512337, 0.0687219947576523, 0.0687869116663933, 0.0688518509268761, 0.0689168125391006, 0.068981759250164, 0.0690467581152916, 0.069111742079258, 0.0691767632961273, 0.0692417696118355, 0.0693068280816078, 0.0693719089031219, 0.0694369897246361, 0.069502055644989, 0.0695671737194061, 0.069632314145565, 0.0696974694728851, 0.0697625949978828, 0.0698277950286865, 0.0698929876089096, 0.0699582099914551, 0.0700234472751617, 0.0700886845588684, 0.0701539516448975, 0.0702192410826683, 0.0702845528721809, 0.0703498274087906, 0.0704151540994644, 0.0704804882407188, 0.0705458670854568, 0.0706112310290337, 0.0706766322255135, 0.0707420483231544, 0.0708074793219566, 0.07087292522192, 0.0709383860230446, 0.0710038915276527, 0.0710693746805191, 0.0711348429322243, 0.0712003856897354, 0.0712659284472466, 0.0713314861059189, 0.071397066116333, 0.0714626461267471, 0.0715282708406448, 0.0715939104557037, 0.0716595500707626, 0.0717252045869827, 0.071790874004364, 0.0718565657734871, 0.0719222575426102, 0.0719879940152168, 0.0720537602901459, 0.0721195265650749, 0.0721853002905846, 0.072251059114933, 0.0723168775439262, 0.0723827257752419, 0.0724485367536545, 0.0725143924355507, 0.0725802779197693, 0.0726461708545685, 0.0727120861411095, 0.0727780014276505, 0.072843961417675, 0.0729099214076996, 0.0729759037494659, 0.0730418562889099, 0.0731078758835793, 0.0731738805770874, 0.0732399374246597, 0.0733059793710709, 0.0733720511198044, 0.0734381601214409, 0.073504276573658, 0.0735703930258751, 0.0736365392804146, 0.0737027078866959, 0.0737688615918159, 0.0738350376486778, 0.0739012509584427, 0.0739674940705299, 0.0740337148308754, 0.0740999653935432, 0.0741662383079529, 0.0742325335741043, 0.0742988511919975, 0.0743651762604713, 0.0744315087795258, 0.0744978487491608, 0.0745642185211182, 0.0746306255459785, 0.0746970176696777, 0.0747634470462799, 0.0748298913240433, 0.0748963356018066, 0.0749628022313118, 0.0750293061137199, 0.0750958099961281, 0.0751623213291168, 0.0752288326621056, 0.0752953961491585, 0.0753619745373726, 0.0754285827279091, 0.0754951611161232, 0.0755617842078209, 0.0756284222006798, 0.0756950974464417, 0.0757617428898811, 0.0758284255862236, 0.0758951306343079, 0.0759618654847145, 0.0760285705327988, 0.0760953351855278, 0.0761621072888374, 0.0762289091944695, 0.0762957036495209, 0.0763625279068947, 0.0764293521642685, 0.0764962062239647, 0.0765630528330803, 0.0766299441456795, 0.076696865260601, 0.076763778924942, 0.0768307223916054, 0.0768976658582687, 0.0769646316766739, 0.0770316272974014, 0.0770986378192902, 0.0771656110882759, 0.0772326663136482, 0.0772997140884399, 0.0773668065667152, 0.0774338617920876, 0.077500969171524, 0.0775680840015411, 0.0776352360844612, 0.0777023732662201, 0.0777695551514626, 0.0778367221355438, 0.0779039189219475, 0.0779711157083511, 0.0780383720993996, 0.0781056210398674, 0.0781729072332382, 0.0782401785254478, 0.0783074572682381, 0.0783747881650925, 0.0784421339631081, 0.0785094723105431, 0.0785768181085587, 0.0786442086100578, 0.0787116065621376, 0.0787790194153786, 0.0788464471697807, 0.0789139196276665, 0.078981377184391, 0.0790488719940186, 0.0791163519024849, 0.0791838616132736, 0.0792514011263847, 0.079318955540657, 0.0793865025043488, 0.0794540792703629, 0.0795216858386993, 0.0795893222093582, 0.0796569287776947, 0.0797245725989342, 0.0797922536730766, 0.0798599347472191, 0.0799276009202003, 0.0799953192472458, 0.080063059926033, 0.080130822956562, 0.0801985561847687, 0.0802663415670395, 0.0803341418504715, 0.0804019719362259, 0.0804697871208191, 0.0805376395583153, 0.0806054919958115, 0.08067337423563, 0.080741249024868, 0.0808091759681702, 0.0808771103620529, 0.0809450522065163, 0.0810130089521408, 0.0810809955000877, 0.0811489894986153, 0.0812170058488846, 0.0812850147485733, 0.0813530683517456, 0.0814211219549179, 0.0814892128109932, 0.0815573334693909, 0.081625409424305, 0.0816935375332832, 0.0817616879940033, 0.0818298608064651, 0.081898033618927, 0.0819662138819695, 0.0820344388484955, 0.0821026638150215, 0.0821708738803864, 0.082239143550396, 0.0823074355721474, 0.0823757573962212, 0.082444041967392, 0.0825123637914658, 0.0825807079672813, 0.0826490744948387, 0.0827174186706543, 0.0827858224511147, 0.0828542411327362, 0.0829226821660995, 0.0829910933971405, 0.0830595642328262, 0.0831280499696732, 0.0831965357065201, 0.0832650437951088, 0.0833335816860199, 0.0834020972251892, 0.0834706723690033, 0.083539217710495, 0.0836078077554703, 0.0836764425039291, 0.0837450549006462, 0.0838137045502663, 0.0838823765516281, 0.08395104855299, 0.084019735455513, 0.0840884298086166, 0.0841571316123009, 0.0842258855700493, 0.0842946544289589, 0.0843634307384491, 0.0844322070479393, 0.0845010206103325, 0.0845698490738869, 0.0846386924386024, 0.0847075507044792, 0.0847764164209366, 0.0848452970385551, 0.0849142000079155, 0.0849831104278564, 0.0850520730018616, 0.0851210355758667, 0.085190013051033, 0.0852589905261993, 0.0853279829025269, 0.085397019982338, 0.0854660421609879, 0.0855350866913795, 0.0856041610240936, 0.0856732502579689, 0.0857423841953278, 0.0858114883303642, 0.0858806148171425, 0.0859497860074043, 0.0860189646482468, 0.086088165640831, 0.0861573442816734, 0.0862265676259995, 0.0862957909703255, 0.0863650590181351, 0.0864343047142029, 0.0865035951137543, 0.0865729227662086, 0.086642250418663, 0.0867115780711174, 0.0867809280753136, 0.0868503078818321, 0.0869196802377701, 0.0869890600442886, 0.0870584920048714, 0.0871279314160347, 0.0871974006295204, 0.0872668474912643, 0.0873363390564919, 0.0874058455228806, 0.0874753892421722, 0.0875449031591415, 0.0876144394278526, 0.0876840054988861, 0.0877536088228226, 0.0878231823444366, 0.0878928229212761, 0.0879624560475349, 0.0880321189761162, 0.0881017744541168, 0.0881714597344398, 0.0882411748170853, 0.0883108749985695, 0.0883805900812149, 0.0884503424167633, 0.0885201171040535, 0.0885899215936661, 0.0886597186326981, 0.0887295231223106, 0.0887993648648262, 0.0888692140579224, 0.0889391005039215, 0.0890089422464371, 0.0890788435935974, 0.0891487747430801, 0.0892187133431435, 0.0892886370420456, 0.0893586277961731, 0.0894286185503006, 0.0894986093044281, 0.0895686224102974, 0.0896386578679085, 0.0897087082266808, 0.089778758585453, 0.0898488312959671, 0.0899189412593842, 0.0899890586733818, 0.0900591984391212, 0.0901293233036995, 0.0901995077729225, 0.0902696847915649, 0.0903398990631104, 0.0904101058840752, 0.09048031270504, 0.0905505642294884, 0.0906208381056786, 0.0906910970807076, 0.0907614007592201, 0.0908317267894745, 0.09090206772089, 0.0909724235534668, 0.091042771935463, 0.0911131501197815, 0.0911835506558418, 0.0912539511919022, 0.0913243815302849, 0.0913948342204094, 0.0914652943611145, 0.0915357992053032, 0.0916062667965889, 0.0916767865419388, 0.0917473286390305, 0.0918178781867027, 0.0918884053826332, 0.0919590070843697, 0.0920295938849449, 0.0921002179384232, 0.0921708270907402, 0.0922414734959602, 0.0923121422529221, 0.0923828333616257, 0.0924535244703293, 0.0925242230296135, 0.0925949439406395, 0.0926656946539879, 0.0927364379167557, 0.0928072184324265, 0.0928780138492584, 0.0929488465189934, 0.0930196642875671, 0.0930905044078827, 0.0931613892316818, 0.0932322666049004, 0.0933031290769577, 0.0933740362524986, 0.0934449732303619, 0.0935159251093864, 0.0935868844389915, 0.0936578363180161, 0.0937288403511047, 0.0937998667359352, 0.0938709005713463, 0.0939419269561768, 0.0940129980444908, 0.0940840616822243, 0.0941551476716995, 0.0942262411117554, 0.0942973643541336, 0.0943685248494148, 0.0944396927952766, 0.0945108383893967, 0.0945820510387421, 0.0946532636880875, 0.0947244986891747, 0.0947957038879395, 0.0948669612407684, 0.0949382483959198, 0.095009557902813, 0.0950808301568031, 0.0951521769165993, 0.0952235087752342, 0.0952948853373528, 0.0953662618994713, 0.0954376384615898, 0.0955090299248695, 0.0955804660916328, 0.0956519171595573, 0.0957233458757401, 0.0957948341965675, 0.0958663374185562, 0.0959378331899643, 0.0960093438625336, 0.0960808917880058, 0.0961524620652199, 0.0962240099906921, 0.0962955951690674, 0.0963671952486038, 0.096438854932785, 0.0965104848146439, 0.0965821072459221, 0.0966538041830063, 0.0967254936695099, 0.0967972129583359, 0.0968689247965813, 0.0969406440854073, 0.0970124155282974, 0.0970841720700264, 0.0971559509634972, 0.0972277745604515, 0.0972995981574059, 0.097371444106102, 0.0974432677030563, 0.0975151509046555, 0.0975870564579964, 0.0976589620113373, 0.0977308452129364, 0.0978027954697609, 0.097874753177166, 0.0979467332363129, 0.0980186983942986, 0.0980907008051872, 0.0981627330183983, 0.0982347801327705, 0.0983068495988846, 0.0983788967132568, 0.0984509661793709, 0.0985230803489685, 0.0985952019691467, 0.0986673310399055, 0.0987394899129868, 0.0988116636872292, 0.0988838523626328, 0.0989560335874557, 0.0990282669663429, 0.0991005077958107, 0.0991727486252785, 0.0992450043559074, 0.0993172973394394, 0.0993895977735519, 0.0994619205594063, 0.0995342433452606, 0.0996065959334373, 0.0996789708733559, 0.0997513681650162, 0.0998237505555153, 0.0998961552977562, 0.0999686047434807, 0.100041039288044, 0.10011351108551, 0.100185997784138, 0.100258514285088, 0.100331030786037, 0.100403554737568, 0.10047610104084, 0.100548677146435, 0.100621238350868, 0.100693851709366, 0.100766457617283, 0.100839093327522, 0.100911751389503, 0.100984416902065, 0.101057097315788, 0.101129792630672, 0.101202517747879, 0.101275265216827, 0.101347967982292, 0.101420752704144, 0.101493537425995, 0.101566337049007, 0.101639144122601, 0.101711988449097, 0.101784840226173, 0.101857714354992, 0.101930566132069, 0.10200347006321, 0.102076396346092, 0.102149300277233, 0.102222248911858, 0.102295212447643, 0.102368198335171, 0.102441214025021, 0.102514192461967, 0.10258724540472, 0.102660298347473, 0.102733381092548, 0.102806441485882, 0.102879516780376, 0.102952629327774, 0.103025764226913, 0.103098921477795, 0.103172071278095, 0.103245258331299, 0.103318460285664, 0.103391692042351, 0.103464893996716, 0.103538148105145, 0.103611387312412, 0.103684671223164, 0.103757955133915, 0.103831276297569, 0.103904612362385, 0.103977963328362, 0.104051314294338, 0.104124702513218, 0.104198098182678, 0.10427151620388, 0.10434490442276, 0.104418352246284, 0.104491837322712, 0.104565322399139, 0.104638792574406, 0.104712314903736, 0.104785852134228, 0.1048593968153, 0.104932941496372, 0.105006523430347, 0.105080090463161, 0.10515371710062, 0.105227336287498, 0.105300977826118, 0.105374656617641, 0.105448327958584, 0.105522029101849, 0.105595722794533, 0.105669461190701, 0.105743199586868, 0.105816967785358, 0.105890721082687, 0.105964511632919, 0.106038331985474, 0.106112159788609, 0.106185987591743, 0.106259852647781, 0.106333740055561, 0.106407634913921, 0.106481522321701, 0.106555461883545, 0.106629386544228, 0.106703348457813, 0.106777302920818, 0.106851316988468, 0.106925316154957, 0.106999360024929, 0.107073374092579, 0.107147440314293, 0.107221521437168, 0.107295617461205, 0.107369683682919, 0.107443816959858, 0.107517972588539, 0.10759212821722, 0.107666283845901, 0.107740484178066, 0.107814699411392, 0.10788893699646, 0.107963144779205, 0.108037412166595, 0.108111687004566, 0.108185954391956, 0.108260288834572, 0.108334593474865, 0.108408935368061, 0.10848330706358, 0.108557678759098, 0.108632057905197, 0.108706459403038, 0.108780898153782, 0.108855299651623, 0.108929745852947, 0.109004229307175, 0.109078712761402, 0.109153233468533, 0.109227739274502, 0.109302289783955, 0.109376847743988, 0.109451428055763, 0.109525993466377, 0.109600581228733, 0.109675198793411, 0.109749853610992, 0.109824493527412, 0.109899178147316, 0.10997386276722, 0.110048569738865, 0.110123284161091, 0.11019803583622, 0.110272787511349, 0.110347576439381, 0.110422305762768, 0.110497117042542, 0.110571943223476, 0.110646791756153, 0.11072164028883, 0.110796503722668, 0.110871389508247, 0.110946305096149, 0.111021228134632, 0.111096151173115, 0.111171081662178, 0.111246056854725, 0.111321054399014, 0.111396044492722, 0.111471064388752, 0.111546106636524, 0.111621163785458, 0.111696220934391, 0.111771307885647, 0.111846417188644, 0.1119215041399, 0.11199663579464, 0.112071797251701, 0.112146966159344, 0.112222157418728, 0.112297341227531, 0.112372577190399, 0.112447813153267, 0.112523064017296, 0.112598299980164, 0.112673580646515, 0.112748891115189, 0.112824209034443, 0.112899519503117, 0.112974889576435, 0.113050259649754, 0.113125644624233, 0.113201037049294, 0.113276459276676, 0.113351881504059, 0.113427326083183, 0.113502807915211, 0.113578267395496, 0.113653771579266, 0.113729283213615, 0.113804817199707, 0.113880358636379, 0.113955929875374, 0.114031530916691, 0.114107124507427, 0.114182718098164, 0.114258348941803, 0.114333994686604, 0.114409662783146, 0.114485330879688, 0.114561036229134, 0.114636763930321, 0.114712484180927, 0.114788226783276, 0.114863991737366, 0.114939779043198, 0.11501556634903, 0.115091361105442, 0.115167200565338, 0.115243047475815, 0.115318924188614, 0.115394786000252, 0.115470692515373, 0.115546599030495, 0.1156225502491, 0.115698494017124, 0.115774430334568, 0.115850389003754, 0.115926407277584, 0.116002425551414, 0.116078443825245, 0.116154484450817, 0.116230554878712, 0.116306632757187, 0.116382718086243, 0.116458833217621, 0.116534948348999, 0.1166110932827, 0.116687245666981, 0.116763442754745, 0.116839624941349, 0.116915844380856, 0.116992063820362, 0.117068313062191, 0.117144584655762, 0.117220871150494, 0.117297120392323, 0.117373451590538, 0.117449767887592, 0.11752612143755, 0.117602482438087, 0.117678850889206, 0.117755264043808, 0.117831662297249, 0.117908075451851, 0.117984518408775, 0.118060998618603, 0.118137456476688, 0.118213936686516, 0.118290446698666, 0.118366971611977, 0.118443518877029, 0.118520095944405, 0.118596643209457, 0.118673257529736, 0.118749871850014, 0.118826493620872, 0.118903093039989, 0.118979774415493, 0.119056433439255, 0.1191331371665, 0.119209825992584, 0.119286552071571, 0.119363315403461, 0.11944006383419, 0.11951682716608, 0.119593635201454, 0.119670413434505, 0.119747258722782, 0.119824081659317, 0.119900941848755, 0.119977809488773, 0.120054721832275, 0.120131604373455, 0.120208539068699, 0.120285488665104, 0.12036245316267, 0.120439387857914, 0.120516374707222, 0.120593391358852, 0.120670415461063, 0.120747439563274, 0.120824508368969, 0.120901592075825, 0.120978675782681, 0.121055789291859, 0.121132902801037, 0.121210016310215, 0.121287181973457, 0.1213643476367, 0.121441535651684, 0.121518738567829, 0.121595963835716, 0.121673211455345, 0.121750444173813, 0.121827736496925, 0.121905021369457, 0.12198231369257, 0.122059628367424, 0.12213696539402, 0.122214317321777, 0.122291706502438, 0.122369065880775, 0.122446484863758, 0.12252389639616, 0.122601337730885, 0.12267879396677, 0.122756265103817, 0.122833721339703, 0.122911237180233, 0.122988745570183, 0.123066276311874, 0.12314385175705, 0.123221419751644, 0.123298987746239, 0.123376600444317, 0.123454228043556, 0.123531877994537, 0.123609483242035, 0.123687148094177, 0.123764857649803, 0.123842552304268, 0.123920276761055, 0.123998001217842, 0.124075762927532, 0.124153532087803, 0.124231316149235, 0.124309100210667, 0.12438689917326, 0.124464735388756, 0.124542616307735, 0.124620459973812, 0.124698348343372, 0.124776244163513, 0.124854184687138, 0.12493209540844, 0.125010058283806, 0.125088021159172, 0.125165984034538, 0.125243991613388, 0.125321999192238, 0.12540003657341, 0.125478088855743, 0.125556141138077, 0.125634238123894, 0.125712350010872, 0.12579046189785, 0.125868558883667, 0.125946715474129, 0.12602487206459, 0.126103058457375, 0.126181244850159, 0.126259475946426, 0.126337721943855, 0.126415967941284, 0.126494258642197, 0.126572519540787, 0.126650810241699, 0.126729130744934, 0.126807451248169, 0.126885771751404, 0.126964151859283, 0.127042517066002, 0.127120941877365, 0.127199336886406, 0.127277791500092, 0.127356231212616, 0.127434700727463, 0.127513155341148, 0.127591639757156, 0.127670168876648, 0.12774869799614, 0.127827227115631, 0.127905800938606, 0.127984374761581, 0.128062978386879, 0.128141567111015, 0.128220215439796, 0.128298878669739, 0.128377512097359, 0.128456190228462, 0.128534883260727, 0.128613591194153, 0.128692328929901, 0.128771066665649, 0.12884983420372, 0.128928631544113, 0.129007413983345, 0.12908624112606, 0.129165023565292, 0.12924388051033, 0.129322737455368, 0.129401639103889, 0.129480510950089, 0.129559427499771, 0.129638358950615, 0.12971730530262, 0.129796266555786, 0.129875227808952, 0.12995420396328, 0.130033224821091, 0.130112245678902, 0.130191281437874, 0.130270346999168, 0.130349442362785, 0.130428522825241, 0.130507633090019, 0.130586758255959, 0.130665898323059, 0.130745053291321, 0.130824238061905, 0.130903422832489, 0.130982622504234, 0.131061837077141, 0.131141111254692, 0.13122034072876, 0.131299629807472, 0.131378903985023, 0.131458222866058, 0.131537541747093, 0.13161689043045, 0.131696254014969, 0.131775617599487, 0.131854981184006, 0.131934404373169, 0.132013857364655, 0.132093265652657, 0.132172733545303, 0.13225220143795, 0.132331684231758, 0.132411196827888, 0.132490739226341, 0.132570251822472, 0.132649824023247, 0.132729381322861, 0.132808983325958, 0.132888585329056, 0.132968202233315, 0.133047834038734, 0.133127495646477, 0.133207157254219, 0.133286863565445, 0.133366569876671, 0.133446276187897, 0.133526012301445, 0.133605793118477, 0.133685544133186, 0.133765339851379, 0.133845135569572, 0.133924961090088, 0.134004801511765, 0.134084656834602, 0.134164527058601, 0.134244382381439, 0.134324312210083, 0.134404227137566, 0.134484171867371, 0.134564131498337, 0.134644091129303, 0.134724080562592, 0.13480406999588, 0.134884119033813, 0.134964138269424, 0.135044187307358, 0.135124251246452, 0.135204330086708, 0.135284453630447, 0.135364577174187, 0.135444685816765, 0.135524839162827, 0.135605022311211, 0.135685205459595, 0.13576540350914, 0.135845616459846, 0.135925859212875, 0.136006101965904, 0.136086374521255, 0.136166661977768, 0.13624694943428, 0.136327281594276, 0.136407598853111, 0.136487975716591, 0.136568337678909, 0.136648699641228, 0.13672910630703, 0.136809527873993, 0.136889964342117, 0.136970415711403, 0.137050867080688, 0.137131363153458, 0.137211874127388, 0.137292370200157, 0.13737291097641, 0.137453436851501, 0.137534022331238, 0.137614607810974, 0.137698918581009, 0.137787193059921, 0.137875437736511, 0.13796366751194, 0.13805191218853, 0.138140141963959, 0.138228356838226, 0.138316556811333, 0.138404756784439, 0.138492926955223, 0.138581112027168, 0.138669297099113, 0.138757437467575, 0.138845592737198, 0.138933718204498, 0.139021843671799, 0.139109969139099, 0.1391980946064, 0.139286160469055, 0.139374256134033, 0.13946233689785, 0.139550402760506, 0.139638468623161, 0.139726489782333, 0.139814555644989, 0.139902576804161, 0.139990597963333, 0.140078604221344, 0.140166595578194, 0.140254601836205, 0.140342563390732, 0.140430554747581, 0.140518501400948, 0.140606448054314, 0.14069439470768, 0.140782326459885, 0.14087025821209, 0.140958160161972, 0.141046047210693, 0.141133934259415, 0.141221836209297, 0.141309708356857, 0.141397580504417, 0.141485422849655, 0.141573265194893, 0.141661092638969, 0.141748920083046, 0.141836732625961, 0.141924530267715, 0.14201232790947, 0.142100095748901, 0.142187878489494, 0.142275646328926, 0.142363399267197, 0.142451152205467, 0.142538875341415, 0.142626613378525, 0.142714321613312, 0.142802029848099, 0.142889708280563, 0.14297741651535, 0.143065094947815, 0.14315277338028, 0.143240407109261, 0.143328055739403, 0.143415689468384, 0.143503323197365, 0.143590942025185, 0.143678560853004, 0.143766149878502, 0.143853738903999, 0.143941313028336, 0.144028887152672, 0.144116446375847, 0.144203990697861, 0.144291535019875, 0.144379064440727, 0.144466578960419, 0.14455409348011, 0.144641578197479, 0.14472907781601, 0.144816562533379, 0.144904032349586, 0.144991502165794, 0.14507894217968, 0.145166382193565, 0.145253822207451, 0.145341232419014, 0.145428642630577, 0.14551605284214, 0.145603433251381, 0.145690828561783, 0.145778194069862, 0.145865574479103, 0.14595291018486, 0.146040260791779, 0.146127596497536, 0.146214917302132, 0.146302223205566, 0.146389529109001, 0.146476820111275, 0.146564111113548, 0.146651387214661, 0.146738648414612, 0.146825909614563, 0.146913155913353, 0.147000387310982, 0.147087603807449, 0.147174835205078, 0.147262036800385, 0.14734922349453, 0.147436425089836, 0.14752359688282, 0.147610768675804, 0.147697910666466, 0.147785067558289, 0.14787220954895, 0.147959351539612, 0.14804644882679, 0.148133561015129, 0.148220643401146, 0.148307740688324, 0.14839480817318, 0.148481890559196, 0.148568958044052, 0.148656010627747, 0.148743033409119, 0.148830056190491, 0.148917093873024, 0.149004116654396, 0.149091109633446, 0.149178087711334, 0.149265080690384, 0.149352043867111, 0.149439007043839, 0.149525955319405, 0.149612903594971, 0.149699836969376, 0.149786755442619, 0.149873659014702, 0.149960547685623, 0.150047466158867, 0.150134339928627, 0.150221228599548, 0.150308102369308, 0.150394946336746, 0.150481775403023, 0.150568604469299, 0.150655433535576, 0.150742262601852, 0.150829061865807, 0.150915861129761, 0.151002630591393, 0.151089414954185, 0.151176184415817, 0.151262924075127, 0.151349678635597, 0.151436418294907, 0.151523143053055, 0.151609867811203, 0.151696562767029, 0.151783257722855, 0.15186995267868, 0.151956632733345, 0.152043297886848, 0.152129948139191, 0.152216598391533, 0.152303233742714, 0.152389869093895, 0.152476489543915, 0.152563095092773, 0.152649700641632, 0.15273629128933, 0.152822881937027, 0.152909442782402, 0.152995988726616, 0.15308253467083, 0.153169080615044, 0.153255626559258, 0.153342142701149, 0.15342865884304, 0.15351514518261, 0.153601631522179, 0.153688117861748, 0.153774604201317, 0.153861060738564, 0.153947502374649, 0.154033944010735, 0.15412038564682, 0.154206812381744, 0.154293224215508, 0.154379621148109, 0.154466018080711, 0.154552415013313, 0.154638767242432, 0.154725134372711, 0.15481148660183, 0.154897838830948, 0.154984176158905, 0.155070513486862, 0.155156821012497, 0.155243128538132, 0.155329406261444, 0.155415698885918, 0.15550197660923, 0.155588239431381, 0.155674487352371, 0.155760735273361, 0.155846983194351, 0.155933201313019, 0.156019434332848, 0.156105622649193, 0.156191825866699, 0.156278014183044, 0.15636420249939, 0.156450361013412, 0.156536519527435, 0.156622663140297, 0.156708806753159, 0.156794935464859, 0.156881064176559, 0.156967163085938, 0.157053276896477, 0.157139360904694, 0.157225430011749, 0.157311514019966, 0.157397568225861, 0.157483622431755, 0.157569661736488, 0.157655701041222, 0.157741725444794, 0.157827734947205, 0.157913729548454, 0.157999724149704, 0.158085703849792, 0.158171683549881, 0.158257633447647, 0.158343583345413, 0.158429518342018, 0.158515468239784, 0.158601388335228, 0.158687308430672, 0.158773213624954, 0.158859103918076, 0.158944994211197, 0.159030869603157, 0.159116730093956, 0.159202560782433, 0.159288421273232, 0.15937428176403, 0.159460097551346, 0.1595458984375, 0.159631714224815, 0.159717500209808, 0.159803301095963, 0.159889072179794, 0.159974828362465, 0.160060584545135, 0.160146340727806, 0.160232067108154, 0.160317808389664, 0.160403519868851, 0.160489231348038, 0.160574927926064, 0.160660609602928, 0.160746306180954, 0.160831972956657, 0.160917609930038, 0.161003276705742, 0.161088928580284, 0.161174535751343, 0.161260172724724, 0.161345764994621, 0.161431357264519, 0.161516964435577, 0.161602556705475, 0.16168811917305, 0.161773696541786, 0.161859214305878, 0.161944776773453, 0.162030309438705, 0.162115827202797, 0.162201344966888, 0.162286832928658, 0.162372335791588, 0.162457808852196, 0.162543281912804, 0.162628754973412, 0.162714198231697, 0.162799641489983, 0.162885099649429, 0.162970513105392, 0.163055926561356, 0.163141325116158, 0.163226723670959, 0.163312092423439, 0.16339747607708, 0.163482829928398, 0.163568198680878, 0.163653552532196, 0.163738876581192, 0.163824215531349, 0.163909554481506, 0.163994833827019, 0.164080142974854, 0.164165407419205, 0.164250716567039, 0.164335951209068, 0.164421215653419, 0.164506465196609, 0.164591699838638, 0.164676934480667, 0.164762154221535, 0.16484734416008, 0.164932548999786, 0.165017753839493, 0.165102928876877, 0.165188118815422, 0.165273249149323, 0.165358394384384, 0.165443539619446, 0.165528669953346, 0.165613800287247, 0.165698915719986, 0.165784016251564, 0.165869101881981, 0.165954157710075, 0.166039243340492, 0.166124299168587, 0.166209354996681, 0.166294410824776, 0.166379451751709, 0.16646446287632, 0.166549474000931, 0.16663447022438, 0.16671946644783, 0.166804447770119, 0.166889443993568, 0.166974395513535, 0.167059332132339, 0.167144298553467, 0.167229220271111, 0.167314171791077, 0.167399078607559, 0.167483970522881, 0.167568877339363, 0.167653754353523, 0.167738631367683, 0.167823493480682, 0.167908355593681, 0.167993202805519, 0.168078035116196, 0.168162867426872, 0.168247669935226, 0.168332472443581, 0.168417274951935, 0.168502062559128, 0.16858683526516, 0.168671622872353, 0.168756365776062, 0.168841108679771, 0.168925851583481, 0.169010609388351, 0.169095307588577, 0.169180020689964, 0.16926471889019, 0.169349387288094, 0.169434100389481, 0.169518768787384, 0.169603437185287, 0.169688060879707, 0.16977271437645, 0.169857338070869, 0.169941946864128, 0.170026555657387, 0.170111164450645, 0.170195758342743, 0.17028035223484, 0.170364916324615, 0.170449495315552, 0.170534044504166, 0.170618578791618, 0.170703113079071, 0.170787647366524, 0.170872136950493, 0.170956641435623, 0.171041160821915, 0.171125635504723, 0.171210110187531, 0.171294569969177, 0.171379044651985, 0.17146347463131, 0.171547919511795, 0.171632334589958, 0.171716749668121, 0.171801149845123, 0.171885550022125, 0.171969950199127, 0.172054305672646, 0.172138705849648, 0.172223031520844, 0.172307386994362, 0.172391712665558, 0.172476053237915, 0.17256036400795, 0.172644689679146, 0.172728970646858, 0.172813251614571, 0.172897532582283, 0.172981813549995, 0.173066064715385, 0.173150315880775, 0.173234552145004, 0.173318788409233, 0.173403009772301, 0.173487201333046, 0.173571422696114, 0.173655599355698, 0.173739776015282, 0.173823967576027, 0.173908114433289, 0.173992276191711, 0.174076408147812, 0.174160555005074, 0.174244657158852, 0.174328774213791, 0.17441289126873, 0.174496978521347, 0.174581035971642, 0.174665123224258, 0.174749180674553, 0.174833238124847, 0.174917280673981, 0.175001323223114, 0.175085350871086, 0.175169378519058, 0.175253346562386, 0.175337344408035, 0.175421342253685, 0.175505325198174, 0.17558927834034, 0.175673231482506, 0.175757169723511, 0.175841107964516, 0.175925046205521, 0.176008954644203, 0.176092848181725, 0.176176756620407, 0.176260650157928, 0.176344513893127, 0.176428377628326, 0.176512241363525, 0.176596090197563, 0.17667992413044, 0.176763772964478, 0.176847577095032, 0.176931381225586, 0.17701518535614, 0.177098974585533, 0.177182748913765, 0.177266538143158, 0.177350282669067, 0.177434042096138, 0.177517756819725, 0.177601486444473, 0.177685230970383, 0.177768930792809, 0.177852660417557, 0.17793633043766, 0.178020000457764, 0.178103685379028, 0.178187340497971, 0.178270995616913, 0.178354635834694, 0.178438276052475, 0.178521901369095, 0.178605496883392, 0.178689107298851, 0.178772702813148, 0.178856283426285, 0.178939878940582, 0.179023414850235, 0.17910698056221, 0.179190516471863, 0.179274052381516, 0.179357573390007, 0.179441094398499, 0.179524600505829, 0.179608076810837, 0.179691582918167, 0.179775044322014, 0.179858505725861, 0.179941982030869, 0.180025413632393, 0.18010887503624, 0.180192276835442, 0.180275708436966, 0.180359125137329, 0.18044251203537, 0.180525884032249, 0.18060927093029, 0.180692657828331, 0.180775985121727, 0.180859342217445, 0.180942669510841, 0.181026011705399, 0.181109338998795, 0.181192621588707, 0.181275933980942, 0.181359216570854, 0.181442499160767, 0.181525781750679, 0.181609034538269, 0.181692287325859, 0.181775540113449, 0.181858777999878, 0.181941986083984, 0.182025209069252, 0.182108372449875, 0.182191580533981, 0.182274758815765, 0.182357951998711, 0.182441100478172, 0.182524248957634, 0.182607397437096, 0.182690516114235, 0.182773649692535, 0.182856768369675, 0.182939887046814, 0.18302296102047, 0.183106049895287, 0.183189108967781, 0.183272168040276, 0.18335522711277, 0.183438271284103, 0.183521330356598, 0.183604344725609, 0.183687344193459, 0.183770343661308, 0.18385337293148, 0.183936342597008, 0.184019327163696, 0.184102267026901, 0.18418525159359, 0.184268191456795, 0.184351116418839, 0.184434056282043, 0.184516951441765, 0.184599876403809, 0.184682786464691, 0.184765681624413, 0.184848546981812, 0.184931412339211, 0.185014247894287, 0.185097113251686, 0.185179978609085, 0.185262799263, 0.185345619916916, 0.185428410768509, 0.185511201620102, 0.185594007372856, 0.185676798224449, 0.18575955927372, 0.18584232032299, 0.1859250664711, 0.186007812619209, 0.186090558767319, 0.186173275113106, 0.186255991458893, 0.186338678002357, 0.186421364545822, 0.186504065990448, 0.18658672273159, 0.186669364571571, 0.186752021312714, 0.186834678053856, 0.186917334794998, 0.186999946832657, 0.187082558870316, 0.187165156006813, 0.187247753143311, 0.187330350279808, 0.187412902712822, 0.187495470046997, 0.187578022480011, 0.187660574913025, 0.187743097543716, 0.187825635075569, 0.187908142805099, 0.187990665435791, 0.188073173165321, 0.18815566599369, 0.188238143920898, 0.188320577144623, 0.188403025269508, 0.188485488295555, 0.188567936420441, 0.188650369644165, 0.188732773065567, 0.188815206289291, 0.18889756500721, 0.188979968428612, 0.189062342047691, 0.189144730567932, 0.189227074384689, 0.189309433102608, 0.189391776919365, 0.1894740909338, 0.189556404948235, 0.189638704061508, 0.189721032977104, 0.189803332090378, 0.18988561630249, 0.189967885613441, 0.190050110220909, 0.19013237953186, 0.190214619040489, 0.190296873450279, 0.190379083156586, 0.190461292862892, 0.190543502569199, 0.190625682473183, 0.190707877278328, 0.190790042281151, 0.190872207283974, 0.190954357385635, 0.191036507487297, 0.191118642687798, 0.191200748085976, 0.191282883286476, 0.191364973783493, 0.191447079181671, 0.191529169678688, 0.191611260175705, 0.191693291068077, 0.191775351762772, 0.191857412457466, 0.191939473152161, 0.192021489143372, 0.19210347533226, 0.192185491323471, 0.19226747751236, 0.192349463701248, 0.192431464791298, 0.192513421177864, 0.192595362663269, 0.192677333950996, 0.19275926053524, 0.192841202020645, 0.192923113703728, 0.193005010485649, 0.193086922168732, 0.193168818950653, 0.193250685930252, 0.193332552909851, 0.19341441988945, 0.193496257066727, 0.193578124046326, 0.193659946322441, 0.193741753697395, 0.193823575973511, 0.193905398249626, 0.193987146019936, 0.194068938493729, 0.194150730967522, 0.194232478737831, 0.194314241409302, 0.194395989179611, 0.194477707147598, 0.194559440016747, 0.194641128182411, 0.194722846150398, 0.194804534316063, 0.194886237382889, 0.194967910647392, 0.195049583911896, 0.195131227374077, 0.195212855935097, 0.195294499397278, 0.195376127958298, 0.195457726716995, 0.195539355278015, 0.19562092423439, 0.195702522993088, 0.195784121751785, 0.195865646004677, 0.195947214961052, 0.196028769016266, 0.196110293269157, 0.19619183242321, 0.19627334177494, 0.196354851126671, 0.196436360478401, 0.196517840027809, 0.196599304676056, 0.196680799126625, 0.196762233972549, 0.196843683719635, 0.196925133466721, 0.197006568312645, 0.197087988257408, 0.19716939330101, 0.197250798344612, 0.197332158684731, 0.197413563728333, 0.197494894266129, 0.197576269507408, 0.197657659649849, 0.197738990187645, 0.19782030582428, 0.197901621460915, 0.197982937097549, 0.198064252734184, 0.198145538568497, 0.19822683930397, 0.19830809533596, 0.198389366269112, 0.19847060739994, 0.198551848530769, 0.198633104562759, 0.198714300990105, 0.198795527219772, 0.198876723647118, 0.198957949876785, 0.199039101600647, 0.199120298027992, 0.199201434850693, 0.199282586574554, 0.199363768100739, 0.199444875121117, 0.199526011943817, 0.199607104063034, 0.199688225984573, 0.199769303202629, 0.199850410223007, 0.199931502342224, 0.200012549757957, 0.200093597173691, 0.200174659490585, 0.20025572180748, 0.200336739420891, 0.200417727231979, 0.20049874484539, 0.200579777359962, 0.200660720467567, 0.200741708278656, 0.200822681188583, 0.20090363919735, 0.200984597206116, 0.20106552541256, 0.201146468520164, 0.201227381825447, 0.201308265328407, 0.201389193534851, 0.20147006213665, 0.201550975441933, 0.20163182914257, 0.20171269774437, 0.201793551445007, 0.201874375343323, 0.201955229043961, 0.202036038041115, 0.20211686193943, 0.202197670936584, 0.202278465032578, 0.202359214425087, 0.20244000852108, 0.202520757913589, 0.20260152220726, 0.20268227159977, 0.202762991189957, 0.202843725681305, 0.20292441546917, 0.203005135059357, 0.203085839748383, 0.203166529536247, 0.203247174620628, 0.203327849507332, 0.203408524394035, 0.203489169478416, 0.203569814562798, 0.203650444746017, 0.203731045126915, 0.203811645507812, 0.20389224588871, 0.203972831368446, 0.204053416848183, 0.204133972525597, 0.204214543104172, 0.204295083880424, 0.204375624656677, 0.204456150531769, 0.20453667640686, 0.204617157578468, 0.204697668552399, 0.204778179526329, 0.204858660697937, 0.204939112067223, 0.205019563436508, 0.205100044608116, 0.205180466175079, 0.205260902643204, 0.205341309309006, 0.205421715974808, 0.205502107739449, 0.205582544207573, 0.205662906169891, 0.205743238329887, 0.205823615193367, 0.205903992056847, 0.205984324216843, 0.206064671278, 0.206144988536835, 0.206225320696831, 0.206305593252182, 0.206385880708694, 0.206466183066368, 0.206546410918236, 0.206626713275909, 0.206706970930099, 0.206787198781967, 0.206867441534996, 0.206947654485703, 0.20702788233757, 0.207108095288277, 0.207188293337822, 0.207268491387367, 0.207348629832268, 0.207428812980652, 0.207508951425552, 0.207589134573936, 0.207669228315353, 0.207749381661415, 0.207829475402832, 0.207909598946571, 0.207989707589149, 0.208069786429405, 0.208149895071983, 0.208229914307594, 0.208309978246689, 0.208390042185783, 0.208470061421394, 0.208550095558167, 0.208630114793777, 0.20871014893055, 0.208790138363838, 0.208870127797127, 0.208950102329254, 0.20903006196022, 0.209110051393509, 0.209189996123314, 0.209269925951958, 0.209349855780602, 0.209429770708084, 0.209509670734406, 0.209589585661888, 0.209669455885887, 0.20974937081337, 0.209829241037369, 0.209909081459045, 0.209988966584206, 0.210068807005882, 0.210148632526398, 0.210228458046913, 0.210308253765106, 0.21038806438446, 0.210467875003815, 0.210547640919685, 0.210627406835556, 0.210707187652588, 0.210786938667297, 0.210866689682007, 0.210946425795555, 0.211026132106781, 0.211105853319168, 0.211185574531555, 0.211265251040459, 0.211344957351685, 0.211424618959427, 0.211504280567169, 0.211583942174911, 0.211663588881493, 0.211743220686913, 0.211822867393494, 0.211902469396591, 0.211982101202011, 0.212061673402786, 0.212141290307045, 0.212220832705498, 0.212300419807434, 0.212379977107048, 0.212459534406662, 0.212539076805115, 0.212618604302406, 0.212698087096214, 0.212777614593506, 0.212857127189636, 0.212936609983444, 0.213016107678413, 0.213095545768738, 0.213175028562546, 0.21325446665287, 0.213333919644356, 0.21341335773468, 0.213492780923843, 0.213572159409523, 0.213651597499847, 0.213730975985527, 0.213810369372368, 0.213889732956886, 0.213969111442566, 0.214048445224762, 0.21412780880928, 0.214207127690315, 0.21428644657135, 0.214365765452385, 0.21444508433342, 0.214524358510971, 0.214603647589684, 0.214682906866074, 0.214762195944786, 0.214841440320015, 0.214920684695244, 0.214999929070473, 0.215079143643379, 0.215158373117447, 0.215237587690353, 0.215316772460938, 0.215395957231522, 0.215475127100945, 0.215554296970367, 0.215633451938629, 0.215712606906891, 0.215791746973991, 0.21587085723877, 0.21594999730587, 0.216029092669487, 0.216108202934265, 0.21618726849556, 0.216266378760338, 0.216345444321632, 0.216424494981766, 0.216503530740738, 0.216582581400871, 0.216661632061005, 0.216740623116493, 0.216819658875465, 0.216898635029793, 0.216977626085281, 0.21705661714077, 0.217135578393936, 0.217214539647102, 0.217293500900269, 0.217372447252274, 0.217451378703117, 0.2175302952528, 0.217609211802483, 0.217688113451004, 0.217767000198364, 0.217845886945724, 0.217924758791924, 0.218003615736961, 0.218082472681999, 0.218161329627037, 0.218240171670914, 0.218318969011307, 0.218397796154022, 0.218476608395576, 0.21855540573597, 0.21863417327404, 0.218712955713272, 0.218791723251343, 0.218870475888252, 0.218949243426323, 0.21902796626091, 0.219106674194336, 0.219185397028923, 0.21926411986351, 0.219342812895775, 0.219421491026878, 0.219500169157982, 0.219578832387924, 0.219657495617867, 0.219736143946648, 0.219814792275429, 0.219893395900726, 0.219972029328346, 0.220050632953644, 0.220129251480103, 0.220207825303078, 0.220286384224892, 0.220364972949028, 0.220443531870842, 0.220522090792656, 0.220600619912148, 0.220679149031639, 0.220757678151131, 0.2208361774683, 0.22091469168663, 0.220993191003799, 0.221070811152458, 0.221147567033768, 0.221224278211594, 0.221300944685936, 0.221377551555634, 0.221454128623009, 0.221530646085739, 0.221607118844986, 0.221683546900749, 0.221759930253029, 0.221836224198341, 0.221912518143654, 0.22198873758316, 0.222064912319183, 0.222141072154045, 0.222217157483101, 0.222293168306351, 0.222369179129601, 0.222445130348206, 0.222521021962166, 0.222596853971481, 0.222672641277313, 0.222748398780823, 0.222824111580849, 0.222899749875069, 0.222975373268127, 0.223050907254219, 0.223126426339149, 0.223201885819435, 0.223277315497398, 0.223352655768394, 0.223427966237068, 0.223503232002258, 0.223578467965126, 0.223653614521027, 0.223728731274605, 0.223803803324699, 0.223878845572472, 0.223953828215599, 0.224028766155243, 0.224103659391403, 0.224178463220596, 0.224253252148628, 0.224327996373177, 0.224402695894241, 0.224477335810661, 0.224551886320114, 0.224626466631889, 0.224700957536697, 0.224775403738022, 0.224849820137024, 0.224924176931381, 0.224998474121094, 0.225072711706161, 0.225146949291229, 0.22522109746933, 0.225295215845108, 0.22536925971508, 0.225443288683891, 0.225517243146896, 0.225591167807579, 0.225665047764778, 0.225738853216171, 0.225812628865242, 0.225886359810829, 0.225960060954094, 0.226033672690392, 0.226107254624367, 0.226180791854858, 0.226254269480705, 0.22632771730423, 0.226401120424271, 0.226474434137344, 0.226547718048096, 0.226620972156525, 0.22669418156147, 0.226767331361771, 0.226840421557426, 0.226913467049599, 0.226986467838287, 0.227059438824654, 0.227132365107536, 0.227205216884613, 0.227278023958206, 0.227350771427155, 0.227423503994942, 0.227496162056923, 0.227568760514259, 0.227641358971596, 0.227713868021965, 0.227786347270012, 0.227858766913414, 0.227931141853333, 0.228003472089767, 0.228075757622719, 0.228147998452187, 0.228220194578171, 0.228292316198349, 0.228364393115044, 0.228436440229416, 0.228508427739143, 0.228580385446548, 0.228652283549309, 0.228724136948586, 0.228795945644379, 0.228867694735527, 0.228939384222031, 0.229011058807373, 0.229082643985748, 0.229154229164124, 0.229225739836693, 0.229297205805779, 0.229368597269058, 0.229439973831177, 0.229511290788651, 0.229582563042641, 0.229653790593147, 0.229724958539009, 0.229796081781387, 0.229867160320282, 0.229938194155693, 0.230009183287621, 0.230080127716064, 0.230150982737541, 0.230221837759018, 0.23029263317585, 0.230363354086876, 0.230434060096741, 0.230504706501961, 0.230575278401375, 0.230645820498466, 0.230716332793236, 0.230786815285683, 0.230857208371162, 0.23092757165432, 0.230997875332832, 0.231068134307861, 0.231138333678246, 0.231208503246307, 0.231278628110886, 0.231348678469658, 0.231418699026108, 0.231488674879074, 0.231558591127396, 0.231628462672234, 0.231698304414749, 0.231768071651459, 0.231837809085846, 0.231907486915588, 0.231977105140686, 0.232046708464622, 0.232116252183914, 0.232185736298561, 0.232255160808563, 0.232324570417404, 0.232393905520439, 0.232463210821152, 0.23253245651722, 0.232601672410965, 0.232670798897743, 0.232739925384521, 0.232808977365494, 0.232877984642982, 0.232946932315826, 0.233015835285187, 0.233084693551064, 0.233153522014618, 0.233222305774689, 0.233291015028954, 0.233359679579735, 0.233428314328194, 0.233496874570847, 0.233565434813499, 0.233633905649185, 0.233702301979065, 0.233770713210106, 0.23383903503418, 0.233907327055931, 0.233975574374199, 0.234043747186661, 0.2341118901968, 0.234179988503456, 0.234248027205467, 0.234316021203995, 0.2343839854002, 0.234451875090599, 0.234519720077515, 0.234587535262108, 0.234655290842056, 0.234723001718521, 0.234790652990341, 0.234858274459839, 0.234925836324692, 0.234993353486061, 0.235060811042786, 0.235128238797188, 0.235195606946945, 0.235262930393219, 0.235330194234848, 0.235397413372993, 0.235464602708817, 0.235531747341156, 0.235598832368851, 0.235665857791901, 0.235732838511467, 0.235799789428711, 0.235866650938988, 0.235933512449265, 0.236000314354897, 0.236067041754723, 0.236133739352226, 0.236200377345085, 0.236266985535622, 0.236333534121513, 0.236400052905083, 0.236466497182846, 0.236532911658287, 0.236599281430244, 0.236665561795235, 0.236731857061386, 0.23679806292057, 0.236864238977432, 0.236930325627327, 0.236996412277222, 0.237062439322472, 0.237128421664238, 0.237194329500198, 0.237260222434998, 0.23732602596283, 0.237391829490662, 0.237457573413849, 0.237523257732391, 0.23758889734745, 0.237654477357864, 0.237720027565956, 0.237785503268242, 0.237850949168205, 0.237916365265846, 0.23798169195652, 0.238046988844872, 0.238112270832062, 0.238177463412285, 0.238242626190186, 0.238307729363441, 0.238372772932053, 0.238437801599503, 0.238502755761147, 0.238567665219307, 0.238632529973984, 0.238697364926338, 0.238762125372887, 0.238826841115952, 0.238891527056694, 0.238956168293953, 0.239020735025406, 0.239085257053375, 0.239149749279022, 0.239214181900024, 0.239278569817543, 0.239342898130417, 0.239407196640968, 0.239471420645714, 0.239535644650459, 0.239599779248238, 0.239663854241371, 0.239727914333344, 0.239791914820671, 0.239855855703354, 0.239919766783714, 0.239983603358269, 0.240047439932823, 0.240111202001572, 0.240174904465675, 0.240238577127457, 0.240302175283432, 0.240365773439407, 0.240429282188416, 0.24049274623394, 0.240556180477142, 0.240619540214539, 0.240682885050774, 0.240746140480042, 0.240809381008148, 0.24087256193161, 0.240935668349266, 0.240998774766922, 0.241061806678772, 0.2411248087883, 0.241187751293182, 0.24125063419342, 0.241313472390175, 0.241376280784607, 0.241439044475555, 0.241501748561859, 0.241564393043518, 0.241626977920532, 0.241689547896385, 0.241752058267593, 0.241814494132996, 0.241876915097237, 0.241939291357994, 0.242001593112946, 0.242063865065575, 0.24212609231472, 0.242188274860382, 0.242250382900238, 0.242312461137772, 0.242374494671822, 0.242436468601227, 0.242498382925987, 0.242560282349586, 0.242622122168541, 0.242683887481689, 0.242745622992516, 0.242807328701019, 0.242868959903717, 0.242930561304092, 0.242992103099823, 0.243053615093231, 0.243115052580833, 0.243176460266113, 0.24323782324791, 0.243299096822739, 0.243360370397568, 0.243421584367752, 0.24348272383213, 0.243543848395348, 0.24360491335392, 0.243665918707848, 0.243726879358292, 0.243787795305252, 0.24384868144989, 0.243909507989883, 0.24397024512291, 0.244031012058258, 0.244091674685478, 0.244152322411537, 0.24421289563179, 0.244273439049721, 0.244333907961845, 0.244394361972809, 0.244454741477966, 0.244515091180801, 0.244575366377831, 0.244635626673698, 0.24469581246376, 0.2447559684515, 0.244816079735756, 0.244876116514206, 0.244936123490334, 0.244996085762978, 0.245055988430977, 0.245115861296654, 0.245175659656525, 0.245235428214073, 0.245295152068138, 0.245354816317558, 0.245414420962334, 0.245473995804787, 0.245533511042595, 0.245592996478081, 0.245652407407761, 0.245711788535118, 0.245771139860153, 0.245830416679382, 0.245889648795128, 0.24594883620739, 0.246007978916168, 0.246067076921463, 0.246126100420952, 0.246185094118118, 0.246244043111801, 0.246302932500839, 0.246361777186394, 0.246420592069626, 0.246479347348213, 0.246538043022156, 0.246596723794937, 0.246655315160751, 0.246713876724243, 0.24677237868309, 0.246830835938454, 0.246889263391495, 0.246947631239891, 0.247005939483643, 0.247064217925072, 0.247122421860695, 0.247180610895157, 0.247238725423813, 0.247296825051308, 0.247354850172997, 0.247412815690041, 0.247470781207085, 0.247528657317162, 0.247586488723755, 0.247644260525703, 0.24770200252533, 0.247759714722633, 0.247817367315292, 0.247874945402145, 0.247932508587837, 0.247989997267723, 0.248047456145287, 0.248104855418205, 0.248162224888802, 0.248219519853592, 0.24827678501606, 0.248334005475044, 0.248391166329384, 0.24844828248024, 0.248505353927612, 0.248562350869179, 0.248619347810745, 0.248676255345345, 0.248733133077621, 0.248789966106415, 0.248846739530563, 0.248903468251228, 0.24896015226841, 0.249016791582108, 0.249073371291161, 0.249129921197891, 0.249186396598816, 0.249242827296257, 0.249299213290215, 0.24935556948185, 0.249411880970001, 0.249468132853508, 0.249524310231209, 0.24958048760891, 0.249636590480804, 0.249692633748055, 0.249748647212982, 0.249804601073265, 0.249860510230064, 0.24991637468338, 0.249972194433212, 0.250027984380722, 0.250083684921265, 0.250139355659485, 0.25019496679306, 0.250250548124313, 0.250306069850922, 0.250361561775208, 0.250416994094849, 0.250472366809845, 0.250527709722519, 0.250582993030548, 0.250638216733932, 0.250693410634995, 0.250748544931412, 0.250803649425507, 0.250858694314957, 0.250913709402084, 0.250968635082245, 0.251023530960083, 0.251078397035599, 0.25113320350647, 0.251187950372696, 0.2512426674366, 0.251297324895859, 0.251351922750473, 0.251406490802765, 0.251461029052734, 0.251515477895737, 0.251569896936417, 0.251624256372452, 0.251678615808487, 0.251732885837555, 0.251787066459656, 0.251841276884079, 0.251895427703857, 0.251949459314346, 0.252003520727158, 0.252057492733002, 0.252111434936523, 0.2521653175354, 0.252219200134277, 0.252272963523865, 0.252326726913452, 0.252380400896072, 0.25243404507637, 0.252487659454346, 0.252541214227676, 0.252594739198685, 0.252648174762726, 0.252701580524445, 0.252754956483841, 0.25280824303627, 0.252861529588699, 0.252914726734161, 0.252967894077301, 0.253021031618118, 0.253074079751968, 0.253127098083496, 0.253180086612701, 0.253233045339584, 0.253285884857178, 0.253338724374771, 0.25339150428772, 0.253444224596024, 0.253496944904327, 0.253549575805664, 0.253602176904678, 0.253654688596725, 0.253707200288773, 0.253759652376175, 0.253812044858932, 0.253864377737045, 0.253916680812836, 0.253968924283981, 0.254021137952805, 0.254073292016983, 0.254125386476517, 0.25417748093605, 0.254229485988617, 0.254281431436539, 0.254333347082138, 0.254385232925415, 0.254437029361725, 0.254488825798035, 0.254540532827377, 0.254592210054398, 0.254643857479095, 0.254695415496826, 0.254746943712234, 0.25479844212532, 0.254849851131439, 0.254901260137558, 0.25495257973671, 0.255003869533539, 0.255055129528046, 0.255106300115585, 0.255157470703125, 0.255208551883698, 0.255259603261948, 0.255310595035553, 0.255361557006836, 0.255412459373474, 0.25546333193779, 0.255514115095139, 0.255564898252487, 0.255615592002869, 0.255666255950928, 0.255716890096664, 0.255767464637756, 0.255817979574203, 0.255868434906006, 0.255918860435486, 0.255969226360321, 0.256019562482834, 0.256069839000702, 0.256120055913925, 0.256170243024826, 0.256220370531082, 0.256270498037338, 0.256320506334305, 0.256370484828949, 0.256420433521271, 0.256470322608948, 0.256520181894302, 0.256569981575012, 0.256619721651077, 0.25666943192482, 0.256719082593918, 0.256768703460693, 0.256818234920502, 0.256867736577988, 0.256917208433151, 0.25696662068367, 0.257016003131866, 0.257065296173096, 0.257114589214325, 0.257163763046265, 0.257212966680527, 0.257262080907822, 0.257311165332794, 0.257360190153122, 0.257409155368805, 0.257458090782166, 0.257506966590881, 0.257555812597275, 0.257604598999023, 0.257653325796127, 0.257702022790909, 0.257750660181046, 0.257799237966537, 0.257847785949707, 0.257896274328232, 0.257944732904434, 0.257993161678314, 0.258041501045227, 0.25808984041214, 0.258138060569763, 0.258186280727386, 0.258234411478043, 0.258282542228699, 0.258330583572388, 0.258378624916077, 0.258426576852798, 0.258474498987198, 0.258522361516953, 0.258570224046707, 0.258617967367172, 0.258665710687637, 0.258713394403458, 0.258761018514633, 0.258808612823486, 0.258856147527695, 0.258903622627258, 0.258951038122177, 0.258998453617096, 0.25904580950737, 0.259093075990677, 0.259140342473984, 0.259187519550323, 0.259234666824341, 0.259281784296036, 0.259328812360764, 0.259375840425491, 0.259422779083252, 0.25946968793869, 0.259516566991806, 0.259563356637955, 0.259610116481781, 0.259656846523285, 0.259703516960144, 0.259750127792358, 0.25979670882225, 0.259843230247498, 0.259889721870422, 0.25993612408638, 0.259982526302338, 0.260028839111328, 0.260075122117996, 0.26012134552002, 0.26016753911972, 0.260213673114777, 0.26025977730751, 0.260305821895599, 0.260351806879044, 0.260397762060165, 0.260443657636642, 0.260489493608475, 0.260535299777985, 0.260581076145172, 0.260626763105392, 0.26067242026329, 0.260718017816544, 0.260763585567474, 0.26080909371376, 0.260854542255402, 0.260899990797043, 0.260945349931717, 0.260990679264069, 0.261035948991776, 0.261081159114838, 0.261126309633255, 0.26117143034935, 0.261216521263123, 0.26126155257225, 0.261306554079056, 0.261351466178894, 0.26139634847641, 0.261441200971603, 0.261486023664474, 0.261530727148056, 0.261575430631638, 0.261620104312897, 0.261664688587189, 0.261709213256836, 0.261753708124161, 0.261798173189163, 0.261842608451843, 0.261886924505234, 0.261931240558624, 0.26197549700737, 0.262019723653793, 0.262063890695572, 0.262107998132706, 0.262152075767517, 0.262196093797684, 0.262240052223206, 0.262283980846405, 0.26232784986496, 0.26237165927887, 0.262415438890457, 0.262459188699722, 0.262502878904343, 0.262546509504318, 0.262590080499649, 0.262633621692657, 0.262677133083344, 0.262720555067062, 0.262763947248459, 0.262807279825211, 0.262850612401962, 0.262893825769424, 0.262937039136887, 0.262980222702026, 0.263023316860199, 0.263066351413727, 0.263109356164932, 0.263152331113815, 0.263195246458054, 0.263238102197647, 0.263280928134918, 0.263323694467545, 0.263366401195526, 0.263409078121185, 0.263451725244522, 0.263494282960892, 0.263536810874939, 0.263579279184341, 0.263621717691422, 0.263664096593857, 0.26370644569397, 0.263748735189438, 0.263790965080261, 0.263833165168762, 0.263875275850296, 0.263917356729507, 0.263959407806396, 0.264001429080963, 0.264043360948563, 0.264085292816162, 0.264127105474472, 0.264168947935104, 0.26421070098877, 0.26425239443779, 0.264294058084488, 0.264335691928864, 0.264377236366272, 0.264418751001358, 0.264460206031799, 0.264501631259918, 0.264543026685715, 0.264584332704544, 0.264625579118729, 0.264666825532913, 0.264707982540131, 0.26474916934967, 0.264790236949921, 0.264831244945526, 0.264872252941132, 0.26491317152977, 0.264954060316086, 0.264994919300079, 0.265035688877106, 0.265076458454132, 0.265117138624191, 0.26515781879425, 0.265198409557343, 0.26523894071579, 0.265279471874237, 0.265319883823395, 0.265360325574875, 0.265400677919388, 0.265441000461578, 0.265481233596802, 0.265521496534348, 0.265561640262604, 0.265601754188538, 0.265641838312149, 0.265681862831116, 0.265721827745438, 0.265761762857437, 0.265801638364792, 0.265841454267502, 0.265881240367889, 0.265920996665955, 0.265960663557053, 0.266000300645828, 0.266039907932281, 0.26607945561409, 0.266118943691254, 0.266158372163773, 0.266197800636292, 0.266237109899521, 0.26627641916275, 0.266315698623657, 0.266354888677597, 0.266394019126892, 0.266433149576187, 0.266472220420837, 0.266511231660843, 0.266550183296204, 0.266589105129242, 0.266627967357635, 0.266666799783707, 0.266705542802811, 0.266744285821915, 0.266782939434052, 0.266821593046188, 0.266860127449036, 0.266898691654205, 0.266937166452408, 0.266975611448288, 0.267013996839523, 0.267052352428436, 0.267090618610382, 0.267128884792328, 0.267167061567307, 0.267205208539963, 0.267243325710297, 0.267281353473663, 0.267319351434708, 0.26735731959343, 0.267395228147507, 0.267433047294617, 0.267470896244049, 0.267508625984192, 0.267546355724335, 0.267584025859833, 0.267621636390686, 0.267659187316895, 0.267696708440781, 0.267734199762344, 0.267771601676941, 0.267808973789215, 0.267846316099167, 0.267883598804474, 0.267920821905136, 0.267958015203476, 0.267995148897171, 0.268032222986221, 0.268069267272949, 0.268106251955032, 0.268143206834793, 0.268180102109909, 0.26821693778038, 0.268253713846207, 0.268290489912033, 0.268327176570892, 0.268363833427429, 0.268400430679321, 0.268436998128891, 0.268473505973816, 0.268509984016418, 0.268546372652054, 0.268582731485367, 0.268619060516357, 0.268655329942703, 0.268691539764404, 0.268727719783783, 0.268763810396194, 0.268799901008606, 0.268835961818695, 0.268871903419495, 0.268907845020294, 0.268943727016449, 0.268979549407959, 0.269015341997147, 0.269051104784012, 0.26908677816391, 0.269122421741486, 0.269158035516739, 0.269193559885025, 0.269229084253311, 0.26926451921463, 0.269299924373627, 0.269335269927979, 0.269370555877686, 0.26940581202507, 0.269441038370132, 0.26947620511055, 0.269511312246323, 0.269546359777451, 0.269581377506256, 0.269616365432739, 0.269651263952255, 0.269686132669449, 0.26972097158432, 0.269755721092224, 0.269790470600128, 0.269825130701065, 0.269859790802002, 0.269894361495972, 0.269928902387619, 0.269963383674622, 0.269997805356979, 0.270032197237015, 0.270066559314728, 0.270100831985474, 0.270135104656219, 0.270169287919998, 0.270203441381454, 0.270237535238266, 0.270271599292755, 0.270305573940277, 0.270339548587799, 0.270373463630676, 0.270407319068909, 0.270441114902496, 0.270474910736084, 0.270508617162704, 0.270542293787003, 0.270575910806656, 0.270609468221664, 0.270642995834351, 0.270676463842392, 0.270709902048111, 0.270743280649185, 0.270776599645615, 0.270809859037399, 0.270843148231506, 0.270876318216324, 0.270909458398819, 0.270942538976669, 0.270975589752197, 0.27100858092308, 0.271041512489319, 0.271074414253235, 0.271107256412506, 0.271140068769455, 0.271172821521759, 0.271205544471741, 0.271238178014755, 0.271270781755447, 0.271303355693817, 0.27133584022522, 0.271368324756622, 0.27140074968338, 0.271433115005493, 0.271465420722961, 0.271497696638107, 0.271529942750931, 0.271562099456787, 0.271594226360321, 0.271626323461533, 0.271658331155777, 0.271690309047699, 0.271722257137299, 0.271754145622253, 0.271786004304886, 0.271817773580551, 0.271849513053894, 0.271881192922592, 0.271912842988968, 0.271944463253021, 0.271975994110107, 0.272007495164871, 0.272038966417313, 0.272070348262787, 0.272101730108261, 0.272133022546768, 0.272164285182953, 0.272195488214493, 0.27222666144371, 0.272257775068283, 0.272288858890533, 0.272319853305817, 0.272350817918777, 0.272381782531738, 0.27241262793541, 0.272443473339081, 0.272474229335785, 0.272504985332489, 0.272535651922226, 0.272566288709641, 0.27259686589241, 0.272627413272858, 0.27265790104866, 0.272688329219818, 0.272718727588654, 0.272749096155167, 0.272779375314713, 0.272809624671936, 0.272839844226837, 0.272869974374771, 0.272900104522705, 0.272930145263672, 0.272960126399994, 0.272990107536316, 0.273020029067993, 0.273049920797348, 0.273079723119736, 0.273109495639801, 0.273139178752899, 0.273168861865997, 0.273198485374451, 0.273228079080582, 0.273257583379745, 0.273287057876587, 0.273316502571106, 0.27334588766098, 0.273375242948532, 0.273404508829117, 0.273433744907379, 0.273462921380997, 0.273492097854614, 0.273521155118942, 0.27355021238327, 0.273579210042953, 0.273608148097992, 0.273637056350708, 0.273665904998779, 0.273694723844528, 0.273723483085632, 0.273752182722092, 0.273775696754456, 0.273793965578079, 0.273812144994736, 0.27383029460907, 0.273848354816437, 0.273866355419159, 0.273884296417236, 0.273902237415314, 0.273920029401779, 0.273937791585922, 0.273955494165421, 0.273973107337952, 0.27399069070816, 0.274008214473724, 0.274025648832321, 0.274043053388596, 0.274060368537903, 0.274077624082565, 0.274094849824905, 0.274111956357956, 0.274129033088684, 0.274146050214767, 0.274163007736206, 0.274179905653, 0.274196714162827, 0.274213492870331, 0.274230182170868, 0.27424681186676, 0.274263381958008, 0.274279892444611, 0.274296343326569, 0.274312734603882, 0.27432906627655, 0.274345308542252, 0.27436152100563, 0.274377673864365, 0.274393737316132, 0.274409741163254, 0.274425685405731, 0.274441570043564, 0.274457395076752, 0.274473160505295, 0.274488866329193, 0.274504482746124, 0.274520069360733, 0.274535596370697, 0.274551033973694, 0.274566441774368, 0.274581760168076, 0.274597018957138, 0.274612218141556, 0.274627327919006, 0.274642437696457, 0.27465745806694, 0.274672359228134, 0.274687260389328, 0.274702101945877, 0.274716883897781, 0.274731576442719, 0.274746209383011, 0.274760752916336, 0.274775296449661, 0.274789720773697, 0.27480411529541, 0.274818450212479, 0.27483269572258, 0.274846911430359, 0.274861037731171, 0.274875104427338, 0.274889141321182, 0.27490308880806, 0.274916976690292, 0.27493080496788, 0.274944543838501, 0.274958252906799, 0.27497187256813, 0.274985492229462, 0.274998992681503, 0.2750124335289, 0.275025814771652, 0.27503913640976, 0.275052398443222, 0.27506560087204, 0.275078743696213, 0.275091826915741, 0.275104850530624, 0.275117814540863, 0.275130689144135, 0.275143504142761, 0.275156259536743, 0.27516895532608, 0.275181591510773, 0.275194197893143, 0.275206685066223, 0.275219172239304, 0.275231510400772, 0.275243848562241, 0.275256097316742, 0.275268316268921, 0.275280475616455, 0.275292545557022, 0.275304555892944, 0.275316476821899, 0.275328367948532, 0.27534019947052, 0.275351971387863, 0.275363683700562, 0.275375306606293, 0.275386899709702, 0.275398403406143, 0.275409877300262, 0.275421231985092, 0.275432556867599, 0.275443822145462, 0.27545502781868, 0.275466173887253, 0.275477260351181, 0.27548822760582, 0.275499224662781, 0.275510102510452, 0.275520920753479, 0.275531709194183, 0.275542378425598, 0.275553047657013, 0.275563597679138, 0.275574088096619, 0.275584578514099, 0.275594979524612, 0.275605291128159, 0.27561554312706, 0.275625735521317, 0.275635868310928, 0.275645941495895, 0.27565598487854, 0.275665909051895, 0.275675803422928, 0.275685638189316, 0.275695413351059, 0.275705099105835, 0.275714725255966, 0.275724321603775, 0.275733828544617, 0.275743275880814, 0.275752693414688, 0.275761991739273, 0.275771260261536, 0.275780469179153, 0.275789618492126, 0.275798678398132, 0.275807678699493, 0.27581661939621, 0.275825530290604, 0.27583435177803, 0.275843113660812, 0.27585181593895, 0.275860488414764, 0.27586904168129, 0.275877565145493, 0.275885999202728, 0.275894403457642, 0.275902718305588, 0.275910973548889, 0.275919198989868, 0.27592733502388, 0.275935411453247, 0.275943428277969, 0.275951355695724, 0.275959253311157, 0.275967091321945, 0.275974839925766, 0.275982558727264, 0.275990188121796, 0.275997787714005, 0.276005268096924, 0.276012748479843, 0.276020139455795, 0.27602744102478, 0.276034712791443, 0.276041895151138, 0.276049047708511, 0.27605614066124, 0.276063144207001, 0.276070088148117, 0.276077002286911, 0.276083827018738, 0.27609059214592, 0.276097267866135, 0.276103943586349, 0.276110500097275, 0.276117026805878, 0.276123464107513, 0.276129871606827, 0.276136189699173, 0.276142448186874, 0.276148647069931, 0.276154816150665, 0.27616086602211, 0.276166886091232, 0.27617284655571, 0.276178747415543, 0.276184558868408, 0.276190340518951, 0.276196032762527, 0.276201635599136, 0.276207238435745, 0.276212781667709, 0.276218205690384, 0.276223599910736, 0.276228934526443, 0.276234179735184, 0.276239395141602, 0.276244521141052, 0.276249587535858, 0.276254624128342, 0.276259571313858, 0.27626445889473, 0.276269286870956, 0.276274085044861, 0.276278764009476, 0.276283383369446, 0.276287972927094, 0.276292502880096, 0.276296943426132, 0.276301354169846, 0.276305675506592, 0.276309937238693, 0.27631413936615, 0.276318281888962, 0.276322364807129, 0.276326358318329, 0.276330322027206, 0.276334196329117, 0.276338040828705, 0.276341795921326, 0.276345521211624, 0.276349157094955, 0.276352733373642, 0.276356250047684, 0.276359707117081, 0.27636307477951, 0.276366412639618, 0.276369690895081, 0.276372909545898, 0.276376038789749, 0.276379108428955, 0.276382118463516, 0.276385068893433, 0.276387959718704, 0.276390790939331, 0.276393562555313, 0.27639627456665, 0.276398897171021, 0.276401489973068, 0.276404023170471, 0.276406437158585, 0.276408851146698, 0.276411175727844, 0.276413440704346, 0.276415646076202, 0.276417762041092, 0.276419848203659, 0.276421874761581, 0.276423811912537, 0.276425719261169, 0.276427567005157, 0.276429325342178, 0.276431024074554, 0.276432663202286, 0.276434242725372, 0.276435762643814, 0.276437222957611, 0.276438593864441, 0.276439905166626, 0.276441186666489, 0.276442408561707, 0.276443511247635, 0.276444613933563, 0.276445627212524, 0.276446580886841, 0.276447474956512, 0.276448309421539, 0.276449084281921, 0.276449769735336, 0.276450425386429, 0.276450991630554, 0.276451528072357, 0.276451975107193, 0.276452362537384, 0.27645269036293, 0.276452958583832, 0.276453167200089, 0.2764533162117, 0.276453375816345, 0.276453375816345, 0.276453346014023, 0.276453226804733, 0.276453077793121, 0.276452839374542, 0.276452541351318, 0.27645218372345, 0.276451766490936, 0.276451289653778, 0.276450753211975, 0.276450127363205, 0.276449471712112, 0.276448726654053, 0.276447951793671, 0.276447057723999, 0.276446163654327, 0.276445180177689, 0.276444107294083, 0.276443034410477, 0.276441842317581, 0.276440620422363, 0.276439309120178, 0.276437968015671, 0.276436537504196, 0.276435047388077, 0.276433527469635, 0.276431888341904, 0.27643021941185, 0.276428490877151, 0.276426702737808, 0.27642485499382, 0.276422917842865, 0.276420921087265, 0.276418894529343, 0.276416778564453, 0.276414632797241, 0.27641236782074, 0.276410102844238, 0.276407718658447, 0.276405304670334, 0.276402831077576, 0.27640026807785, 0.276397675275803, 0.27639502286911, 0.27639228105545, 0.276389479637146, 0.276386618614197, 0.276383697986603, 0.276380717754364, 0.276377707719803, 0.276374578475952, 0.276371389627457, 0.276368170976639, 0.276364862918854, 0.276361495256424, 0.276358097791672, 0.276354610919952, 0.276351064443588, 0.276347458362579, 0.276343792676926, 0.276340067386627, 0.276336252689362, 0.276332378387451, 0.276328474283218, 0.276324510574341, 0.276320457458496, 0.276316344738007, 0.276312172412872, 0.276307940483093, 0.276303648948669, 0.276299297809601, 0.276294857263565, 0.276290386915207, 0.276285856962204, 0.276281237602234, 0.276276558637619, 0.276271849870682, 0.276267051696777, 0.276262193918228, 0.276257276535034, 0.276252299547195, 0.27624723315239, 0.276242136955261, 0.276236981153488, 0.276231735944748, 0.276226431131363, 0.276221096515656, 0.276215672492981, 0.276210188865662, 0.276204645633698, 0.276199042797089, 0.276193350553513, 0.276187628507614, 0.276181846857071, 0.276175975799561, 0.276170074939728, 0.276164084672928, 0.276158034801483, 0.276151925325394, 0.276145756244659, 0.27613952755928, 0.276133239269257, 0.276126861572266, 0.276120454072952, 0.276113986968994, 0.276107430458069, 0.276100814342499, 0.276094138622284, 0.276087433099747, 0.276080638170242, 0.276073783636093, 0.276066869497299, 0.27605989575386, 0.276052832603455, 0.276045739650726, 0.276038557291031, 0.276031345129013, 0.276024013757706, 0.276016682386398, 0.276009261608124, 0.276001781225204, 0.27599424123764, 0.275986641645432, 0.275978952646255, 0.275971233844757, 0.275963455438614, 0.275955587625504, 0.275947630405426, 0.275939673185349, 0.275931656360626, 0.275923520326614, 0.275915384292603, 0.275907129049301, 0.275898844003677, 0.275890469551086, 0.275882065296173, 0.275873571634293, 0.27586504817009, 0.27585643529892, 0.275847733020782, 0.275839030742645, 0.275830239057541, 0.275821387767792, 0.275812476873398, 0.275803506374359, 0.275794446468353, 0.275785326957703, 0.275776147842407, 0.275766938924789, 0.275757640600204, 0.275748312473297, 0.2757388651371, 0.275729387998581, 0.275719851255417, 0.275710254907608, 0.275700569152832, 0.275690823793411, 0.275681048631668, 0.275671184062958, 0.275661289691925, 0.275651276111603, 0.275641262531281, 0.275631129741669, 0.275620967149734, 0.275610744953156, 0.275600463151932, 0.275590091943741, 0.275579690933228, 0.275569200515747, 0.275558680295944, 0.275548040866852, 0.275537371635437, 0.2755266726017, 0.275515854358673, 0.275505006313324, 0.27549409866333, 0.275483101606369, 0.275472074747086, 0.275460958480835, 0.275449812412262, 0.275438547134399, 0.275427281856537, 0.275415927171707, 0.275404512882233, 0.275393009185791, 0.275381475687027, 0.275369882583618, 0.275358200073242, 0.275346457958221, 0.275334686040878, 0.275322824716568, 0.275310933589935, 0.275298923254013, 0.275286883115768, 0.275274783372879, 0.275262624025345, 0.275250375270844, 0.275238126516342, 0.275225728750229, 0.275213330984116, 0.275200873613358, 0.27518829703331, 0.27517569065094, 0.275163024663925, 0.275150299072266, 0.275137513875961, 0.275124669075012, 0.275111734867096, 0.275098741054535, 0.275085717439651, 0.275072604417801, 0.275059461593628, 0.275046229362488, 0.275032937526703, 0.275019556283951, 0.275006145238876, 0.274992674589157, 0.274979114532471, 0.274965554475784, 0.274951875209808, 0.274938136339188, 0.274924337863922, 0.274910479784012, 0.274896562099457, 0.274882584810257, 0.274868547916412, 0.274854451417923, 0.274840295314789, 0.274826049804688, 0.274811774492264, 0.274797379970551, 0.274782985448837, 0.274768501520157, 0.274753957986832, 0.274739384651184, 0.274724692106247, 0.274709969758987, 0.274695187807083, 0.274680316448212, 0.274665385484695, 0.274650424718857, 0.274635374546051, 0.2746202647686, 0.274605125188828, 0.274589896202087, 0.27457457780838, 0.27455922961235, 0.274543821811676, 0.274528354406357, 0.274512827396393, 0.274497210979462, 0.274481534957886, 0.274465769529343, 0.2744500041008, 0.274434179067612, 0.274418264627457, 0.274402260780334, 0.27438622713089, 0.274370104074478, 0.274353951215744, 0.274337738752365, 0.274321436882019, 0.274305075407028, 0.274288654327393, 0.274272203445435, 0.274255633354187, 0.274239063262939, 0.274222373962402, 0.274205654859543, 0.274188846349716, 0.274172008037567, 0.274155110120773, 0.274138122797012, 0.274121075868607, 0.274103969335556, 0.274086803197861, 0.274069577455521, 0.274052292108536, 0.274034917354584, 0.274017512798309, 0.274000018835068, 0.273982495069504, 0.273964881896973, 0.273947238922119, 0.273929506540298, 0.273911714553833, 0.273893862962723, 0.273875951766968, 0.273857951164246, 0.273839920759201, 0.273821800947189, 0.273803651332855, 0.273785412311554, 0.27376714348793, 0.273748785257339, 0.273730367422104, 0.273711889982224, 0.273693323135376, 0.273674726486206, 0.273656070232391, 0.273637354373932, 0.273618578910828, 0.273599714040756, 0.27358078956604, 0.273561835289001, 0.273542791604996, 0.273523658514023, 0.27350452542305, 0.273485273122787, 0.273465991020203, 0.273446619510651, 0.273427218198776, 0.273407727479935, 0.273388206958771, 0.27336859703064, 0.273348927497864, 0.273329198360443, 0.273309409618378, 0.273289561271667, 0.273269653320312, 0.27324965596199, 0.273229628801346, 0.273209542036057, 0.2731893658638, 0.273169130086899, 0.273148834705353, 0.273128509521484, 0.273108065128326, 0.273087590932846, 0.273067057132721, 0.273046463727951, 0.273025780916214, 0.273005068302155, 0.272984266281128, 0.272963404655457, 0.272942543029785, 0.272921532392502, 0.272900491952896, 0.272879391908646, 0.27285823225975, 0.272836983203888, 0.272815704345703, 0.272794365882874, 0.272772967815399, 0.272751480340958, 0.272729933261871, 0.27270832657814, 0.272686660289764, 0.272664934396744, 0.272643148899078, 0.272621303796768, 0.272599369287491, 0.272577434778214, 0.272555351257324, 0.272533237934113, 0.272511094808578, 0.2724888920784, 0.272466599941254, 0.272444218397141, 0.272421836853027, 0.272399336099625, 0.2723768055439, 0.272354185581207, 0.27233150601387, 0.272308796644211, 0.272286027669907, 0.272263169288635, 0.272240251302719, 0.272217273712158, 0.272194236516953, 0.272171139717102, 0.272147953510284, 0.272124767303467, 0.27210146188736, 0.272078096866608, 0.272054672241211, 0.272031217813492, 0.272007673978806, 0.271984070539474, 0.271960407495499, 0.271936684846878, 0.271912902593613, 0.27188903093338, 0.271865099668503, 0.271841168403625, 0.271817117929459, 0.271793007850647, 0.271768838167191, 0.271744608879089, 0.271720319986343, 0.271696001291275, 0.271671563386917, 0.271647065877914, 0.271622568368912, 0.271597981452942, 0.271573275327682, 0.271548569202423, 0.271523773670197, 0.271498918533325, 0.271474003791809, 0.271449029445648, 0.271423995494843, 0.27139887213707, 0.271373748779297, 0.271348506212234, 0.271323204040527, 0.271297842264175, 0.271272450685501, 0.271246999502182, 0.271221429109573, 0.271195858716965, 0.271170169115067, 0.271144449710846, 0.271118670701981, 0.271092802286148, 0.271066874265671, 0.271040946245193, 0.271014899015427, 0.270988762378693, 0.270962625741959, 0.270936399698257, 0.270910084247589, 0.270883738994598, 0.270857334136963, 0.270830869674683, 0.270804315805435, 0.270777732133865, 0.270751059055328, 0.270724356174469, 0.27069753408432, 0.270670682191849, 0.270643800497055, 0.270616799592972, 0.270589768886566, 0.270562648773193, 0.270535528659821, 0.270508289337158, 0.270480990409851, 0.270453661680222, 0.270426243543625, 0.270398765802383, 0.270371228456497, 0.270343631505966, 0.27031597495079, 0.270288228988647, 0.27026042342186, 0.27023258805275, 0.270204693078995, 0.270176708698273, 0.270148694515228, 0.270120561122894, 0.270092397928238, 0.270064175128937, 0.270035892724991, 0.2700075507164, 0.269979149103165, 0.269950658082962, 0.269922137260437, 0.269893497228622, 0.269864857196808, 0.269836127758026, 0.2698073387146, 0.269778519868851, 0.269749581813812, 0.269720613956451, 0.269691586494446, 0.269662499427795, 0.269633322954178, 0.269604086875916, 0.269574791193008, 0.269545465707779, 0.26951602101326, 0.269486576318741, 0.269457042217255, 0.269427418708801, 0.269397765398026, 0.269368022680283, 0.269338250160217, 0.269308418035507, 0.26927849650383, 0.269248515367508, 0.269218474626541, 0.26918837428093, 0.269158214330673, 0.269127994775772, 0.269097685813904, 0.269067347049713, 0.269036948680878, 0.269006460905075, 0.26897594332695, 0.268945336341858, 0.268914669752121, 0.268883973360062, 0.268853157758713, 0.268822312355042, 0.268791407346725, 0.268760442733765, 0.268729388713837, 0.268698304891586, 0.268667131662369, 0.268635898828506, 0.268604606389999, 0.268573254346848, 0.268541872501373, 0.268510371446609, 0.268478840589523, 0.26844722032547, 0.268415570259094, 0.268383860588074, 0.268352091312408, 0.268320202827454, 0.268288344144821, 0.268256336450577, 0.26822429895401, 0.268192201852798, 0.268160045146942, 0.268127828836441, 0.268095523118973, 0.268063187599182, 0.268030792474747, 0.267998307943344, 0.267965763807297, 0.267933160066605, 0.26790052652359, 0.267867773771286, 0.26783499121666, 0.267802149057388, 0.267769247293472, 0.267736256122589, 0.267703235149384, 0.267670124769211, 0.267636984586716, 0.267603725194931, 0.267570465803146, 0.267537087202072, 0.267503678798676, 0.267470240592957, 0.26743671298027, 0.267403095960617, 0.267369419336319, 0.267335683107376, 0.267301946878433, 0.267268091440201, 0.267234176397324, 0.267200201749802, 0.267166137695312, 0.267132073640823, 0.267097890377045, 0.267063647508621, 0.267029374837875, 0.266995012760162, 0.266960620880127, 0.266926169395447, 0.266891628503799, 0.266857028007507, 0.266822338104248, 0.266787648200989, 0.26675283908844, 0.266718000173569, 0.266683101654053, 0.26664811372757, 0.266613066196442, 0.266577988862991, 0.266542822122574, 0.266507595777512, 0.266472339630127, 0.266436964273453, 0.266401559114456, 0.266366064548492, 0.266330540180206, 0.266294956207275, 0.266259282827377, 0.266223579645157, 0.266187787055969, 0.266151905059814, 0.26611602306366, 0.266080051660538, 0.266044050455093, 0.266007930040359, 0.265971750020981, 0.26593554019928, 0.265899240970612, 0.265862911939621, 0.265826493501663, 0.265790015459061, 0.265753477811813, 0.265716880559921, 0.265680253505707, 0.265643507242203, 0.265606731176376, 0.265569865703583, 0.265532970428467, 0.265495985746384, 0.265458971261978, 0.265421867370605, 0.265384674072266, 0.265347480773926, 0.265310198068619, 0.265272825956345, 0.265235424041748, 0.265197962522507, 0.265160411596298, 0.265122830867767, 0.265085160732269, 0.265047430992126, 0.265009671449661, 0.264971822500229, 0.264933913946152, 0.264895915985107, 0.264857888221741, 0.264819800853729, 0.264781624078751, 0.264743447303772, 0.264705151319504, 0.264666795730591, 0.264628380537033, 0.264589905738831, 0.264551371335983, 0.264512777328491, 0.264474123716354, 0.26443538069725, 0.264396607875824, 0.264357775449753, 0.264318853616714, 0.264279872179031, 0.264240860939026, 0.264201760292053, 0.264162600040436, 0.264123380184174, 0.264084100723267, 0.264044731855392, 0.264005333185196, 0.263965845108032, 0.263926327228546, 0.263886719942093, 0.263847053050995, 0.263807356357574, 0.263767570257187, 0.263727694749832, 0.263687789440155, 0.263647824525833, 0.263607800006866, 0.263567715883255, 0.263527542352676, 0.263487309217453, 0.263447046279907, 0.263406693935394, 0.263366281986237, 0.263325810432434, 0.263285279273987, 0.263244658708572, 0.263204038143158, 0.263163298368454, 0.263122528791428, 0.263081669807434, 0.263040781021118, 0.262999802827835, 0.262958735227585, 0.262917667627335, 0.262876480817795, 0.262835294008255, 0.262793987989426, 0.262752652168274, 0.262711256742477, 0.262669771909714, 0.262628257274628, 0.262586653232574, 0.262544989585876, 0.262503266334534, 0.262461483478546, 0.262419611215591, 0.262377738952637, 0.262335777282715, 0.262293726205826, 0.262251645326614, 0.262209475040436, 0.262167245149612, 0.262124985456467, 0.262082606554031, 0.262040227651596, 0.261997759342194, 0.261955201625824, 0.261912614107132, 0.261869966983795, 0.261827230453491, 0.261784434318542, 0.261741608381271, 0.261698693037033, 0.261655747890472, 0.261612683534622, 0.26156958937645, 0.261526465415955, 0.26148322224617, 0.261439919471741, 0.261396586894989, 0.26135316491127, 0.261309713125229, 0.26126617193222, 0.261222571134567, 0.261178910732269, 0.261135190725327, 0.261091411113739, 0.261047571897507, 0.26100367307663, 0.260959714651108, 0.260915666818619, 0.260871559381485, 0.260822802782059, 0.26076939702034, 0.260715961456299, 0.260662466287613, 0.260608941316605, 0.260555386543274, 0.260501801967621, 0.260448187589645, 0.260394513607025, 0.26034078001976, 0.260287076234818, 0.260233283042908, 0.260179489850998, 0.260125607252121, 0.260071724653244, 0.260017782449722, 0.259963810443878, 0.259909808635712, 0.259855777025223, 0.259801685810089, 0.259747534990311, 0.259693384170532, 0.259639203548431, 0.259584993124008, 0.259530693292618, 0.259476393461227, 0.259422034025192, 0.259367644786835, 0.259313225746155, 0.259258776903152, 0.259204268455505, 0.259149760007858, 0.259095162153244, 0.259040534496307, 0.258985906839371, 0.258931219577789, 0.258876472711563, 0.258821725845337, 0.258766949176788, 0.258712083101273, 0.258657217025757, 0.258602291345596, 0.258547335863113, 0.25849238038063, 0.258437365293503, 0.258382260799408, 0.258327186107635, 0.258272022008896, 0.258216857910156, 0.258161634206772, 0.258106410503387, 0.258051127195358, 0.257995784282684, 0.257940411567688, 0.257885009050369, 0.257829576730728, 0.257774084806442, 0.257718563079834, 0.257663041353226, 0.25760743021965, 0.257551789283752, 0.257496118545532, 0.25744041800499, 0.257384657859802, 0.257328897714615, 0.257273077964783, 0.257217228412628, 0.257161319255829, 0.25710541009903, 0.257049411535263, 0.256993412971497, 0.256937384605408, 0.256881296634674, 0.256825178861618, 0.25676903128624, 0.256712824106216, 0.256656587123871, 0.256600320339203, 0.256544023752213, 0.256487667560577, 0.25643128156662, 0.25637486577034, 0.256318390369415, 0.256261914968491, 0.256205350160599, 0.256148785352707, 0.256092190742493, 0.256035536527634, 0.255978852510452, 0.255922138690948, 0.2558653652668, 0.255808591842651, 0.255751729011536, 0.255694836378098, 0.255637943744659, 0.255580991506577, 0.255524009466171, 0.255466967821121, 0.255409926176071, 0.255352824926376, 0.255295664072037, 0.255238503217697, 0.255181282758713, 0.255124032497406, 0.255066752433777, 0.255009412765503, 0.254952043294907, 0.25489467382431, 0.254837185144424, 0.254779726266861, 0.254722207784653, 0.254664659500122, 0.254607081413269, 0.254549443721771, 0.254491776227951, 0.254434078931808, 0.254376322031021, 0.254318565130234, 0.254260748624802, 0.254202902317047, 0.254144996404648, 0.254087030887604, 0.25402906537056, 0.253971070051193, 0.253913015127182, 0.253854930400848, 0.253796815872192, 0.253738671541214, 0.253680467605591, 0.253622233867645, 0.253563940525055, 0.253505676984787, 0.253447324037552, 0.253388941287994, 0.253330498933792, 0.25327205657959, 0.253213554620743, 0.253155052661896, 0.253096461296082, 0.253037840127945, 0.252979189157486, 0.252920538187027, 0.252861797809601, 0.252803027629852, 0.252744257450104, 0.252685397863388, 0.25262650847435, 0.252567619085312, 0.252508670091629, 0.252449661493301, 0.252390652894974, 0.252331584692001, 0.252272486686707, 0.252213329076767, 0.252154171466827, 0.252094954252243, 0.252035707235336, 0.251976400613785, 0.251917093992233, 0.251857727766037, 0.251798331737518, 0.251738905906677, 0.251679390668869, 0.251619905233383, 0.25156033039093, 0.251500725746155, 0.251441121101379, 0.251381427049637, 0.251321732997894, 0.251262009143829, 0.25120222568512, 0.251142412424088, 0.251082539558411, 0.251022666692734, 0.250962734222412, 0.250902771949768, 0.250842779874802, 0.250782698392868, 0.250722646713257, 0.250662535429001, 0.250602334737778, 0.250542163848877, 0.250481933355331, 0.250421643257141, 0.250361353158951, 0.250301003456116, 0.250240623950958, 0.250180184841156, 0.250119745731354, 0.250059247016907, 0.249998703598976, 0.249938145279884, 0.249877527356148, 0.24981689453125, 0.249756202101707, 0.249695479869843, 0.249634712934494, 0.249573916196823, 0.24951308965683, 0.249452218413353, 0.249391287565231, 0.249330371618271, 0.249269366264343, 0.249208331108093, 0.249147281050682, 0.249086171388626, 0.249025031924248, 0.248963862657547, 0.248902663588524, 0.248841390013695, 0.248780101537704, 0.248718783259392, 0.248657420277596, 0.248596027493477, 0.248534575104713, 0.248473107814789, 0.248411595821381, 0.248350039124489, 0.248288437724113, 0.248226806521416, 0.248165160417557, 0.248103454709053, 0.248041704297066, 0.247979924082756, 0.247918128967285, 0.247856259346008, 0.24779437482357, 0.247732430696487, 0.247670471668243, 0.247608467936516, 0.247546419501305, 0.24748432636261, 0.247422218322754, 0.247360050678253, 0.247297883033752, 0.247235640883446, 0.247173354029655, 0.247111067175865, 0.247048705816269, 0.246986329555511, 0.246923923492432, 0.246861457824707, 0.24679896235466, 0.246736437082291, 0.246673867106438, 0.246611252427101, 0.246548607945442, 0.2464859187603, 0.246423199772835, 0.246360436081886, 0.246297642588615, 0.246234819293022, 0.246171921491623, 0.246109023690224, 0.24604606628418, 0.245983093976974, 0.245920062065125, 0.245857015252113, 0.245793908834457, 0.245730757713318, 0.245667591691017, 0.245604366064072, 0.245541125535965, 0.245477825403214, 0.245414510369301, 0.245351135730743, 0.245287746191025, 0.245224311947823, 0.245160818099976, 0.245097324252129, 0.245033755898476, 0.244970187544823, 0.244906544685364, 0.244842886924744, 0.24477918446064, 0.244715437293053, 0.244651660323143, 0.24458783864975, 0.244523987174034, 0.244460090994835, 0.244396165013313, 0.244332209229469, 0.244268223643303, 0.244204148650169, 0.244140088558197, 0.244075953960419, 0.244011789560318, 0.243947610259056, 0.243883371353149, 0.24381910264492, 0.243754804134369, 0.243690460920334, 0.243626073002815, 0.243561640381813, 0.24349719285965, 0.243432700634003, 0.243368178606033, 0.243303596973419, 0.243238985538483, 0.243174344301224, 0.243109658360481, 0.243044927716255, 0.242980182170868, 0.242915406823158, 0.242850542068481, 0.242785662412643, 0.242720752954483, 0.242655828595161, 0.242590844631195, 0.242525815963745, 0.24246072769165, 0.242395669221878, 0.242330521345139, 0.242265343666077, 0.242200121283531, 0.242134869098663, 0.242069572210312, 0.242004245519638, 0.241938918828964, 0.241873502731323, 0.24180805683136, 0.241742566227913, 0.241677075624466, 0.241611525416374, 0.241545930504799, 0.241480320692062, 0.24141463637352, 0.241348922252655, 0.24128320813179, 0.241217419505119, 0.241151601076126, 0.241085767745972, 0.241019859910011, 0.24095393717289, 0.240887969732285, 0.240821957588196, 0.240755900740623, 0.240689843893051, 0.240623727440834, 0.240557566285133, 0.240491390228271, 0.240425139665604, 0.240358874201775, 0.240292564034462, 0.240226224064827, 0.24015985429287, 0.240093439817429, 0.240026980638504, 0.239960476756096, 0.239893957972527, 0.239827379584312, 0.239760756492615, 0.239694118499756, 0.239627420902252, 0.239560708403587, 0.2394939661026, 0.239427149295807, 0.239360317587852, 0.239293456077576, 0.239226549863815, 0.23915958404541, 0.239092618227005, 0.239025607705116, 0.238958522677422, 0.238891422748566, 0.238824293017387, 0.238757133483887, 0.238689929246902, 0.238622650504112, 0.238555386662483, 0.238488033413887, 0.238420695066452, 0.238353282213211, 0.238285839557648, 0.238218382000923, 0.238150835037231, 0.238083302974701, 0.238015726208687, 0.237948089838028, 0.237880423665047, 0.237812727689743, 0.237745001912117, 0.237677201628685, 0.237609401345253, 0.237541556358337, 0.237473651766777, 0.237405717372894, 0.23733776807785, 0.237269744277, 0.237201720476151, 0.237133637070656, 0.237065508961678, 0.236997365951538, 0.236929163336754, 0.236860930919647, 0.236792668700218, 0.236724346876144, 0.236656010150909, 0.236587628722191, 0.23651921749115, 0.236450776457787, 0.236382275819778, 0.236313745379448, 0.236245185136795, 0.236176565289497, 0.236107915639877, 0.236039236187935, 0.235970497131348, 0.23590175807476, 0.23583297431469, 0.235764145851135, 0.235695257782936, 0.235626339912415, 0.235557407140732, 0.235488429665565, 0.235419392585754, 0.235350325703621, 0.235281229019165, 0.235212102532387, 0.235142931342125, 0.23507371544838, 0.235004469752312, 0.234935194253922, 0.234865844249725, 0.234796494245529, 0.234727114439011, 0.234657675027847, 0.2345881909132, 0.234518676996231, 0.234449103474617, 0.234379529953003, 0.234309911727905, 0.234240233898163, 0.234170526266098, 0.234100788831711, 0.234031021595001, 0.233961224555969, 0.233891367912292, 0.233821466565132, 0.233751535415649, 0.233681574463844, 0.233611583709717, 0.233541533350945, 0.233471438288689, 0.233401343226433, 0.233331188559532, 0.233261004090309, 0.233190774917603, 0.233120486140251, 0.2330501973629, 0.232979848980904, 0.232909455895424, 0.232839062809944, 0.232768580317497, 0.232698112726212, 0.232627555727959, 0.232556998729706, 0.232486382126808, 0.232415735721588, 0.232345059514046, 0.232274353504181, 0.232203587889671, 0.232132792472839, 0.232061952352524, 0.231991082429886, 0.231920182704926, 0.231849253177643, 0.231778234243393, 0.231707230210304, 0.231636181473732, 0.231565073132515, 0.231493949890137, 0.231422767043114, 0.231351554393768, 0.231280297040939, 0.231209024786949, 0.231137678027153, 0.231066331267357, 0.230994939804077, 0.230923503637314, 0.230852022767067, 0.230780526995659, 0.230708971619606, 0.23063737154007, 0.230565741658211, 0.23049408197403, 0.230422377586365, 0.230350658297539, 0.230278879404068, 0.230207070708275, 0.230135217308998, 0.230063319206238, 0.229991391301155, 0.229919418692589, 0.2298474162817, 0.229775369167328, 0.229703277349472, 0.229631170630455, 0.229559034109116, 0.229486852884293, 0.229414612054825, 0.229342341423035, 0.229270040988922, 0.229197695851326, 0.229125320911407, 0.229052886366844, 0.22898043692112, 0.228907972574234, 0.228835418820381, 0.228762835264206, 0.22869023680687, 0.228617593646049, 0.228544935584068, 0.228472203016281, 0.228399440646172, 0.22832664847374, 0.228253796696663, 0.228180944919586, 0.228108033537865, 0.228035092353821, 0.227962121367455, 0.227889075875282, 0.22781603038311, 0.227742910385132, 0.227669790387154, 0.227596610784531, 0.227523401379585, 0.227450162172318, 0.227376893162727, 0.227303579449654, 0.227230206131935, 0.227156803011894, 0.227083370089531, 0.227009907364845, 0.226936385035515, 0.226862818002701, 0.226789236068726, 0.226715624332428, 0.226641967892647, 0.226568251848221, 0.226494535803795, 0.226420745253563, 0.226346909999847, 0.226273059844971, 0.226199179887772, 0.22612527012825, 0.226051285862923, 0.225977301597595, 0.225903242826462, 0.225829184055328, 0.22575506567955, 0.22568091750145, 0.225606724619865, 0.225532501935959, 0.225458219647408, 0.225383922457695, 0.225309565663338, 0.225235223770142, 0.225160792469978, 0.225086331367493, 0.225011825561523, 0.224937289953232, 0.224862724542618, 0.224788129329681, 0.2247134745121, 0.224638804793358, 0.224564090371132, 0.224489316344261, 0.224414557218552, 0.224339708685875, 0.224264845252037, 0.224189937114716, 0.224114969372749, 0.224039986729622, 0.223964974284172, 0.2238899320364, 0.223814815282822, 0.223739698529243, 0.223664507269859, 0.223589316010475, 0.223514050245285, 0.223438784480095, 0.223363429307938, 0.223288103938103, 0.223212704062462, 0.223137244582176, 0.223061785101891, 0.222986280918121, 0.222910732030869, 0.222835138440132, 0.222759515047073, 0.222683861851692, 0.222608163952827, 0.222532421350479, 0.222456634044647, 0.222380831837654, 0.222304984927177, 0.222229063510895, 0.222153142094612, 0.222077205777168, 0.222001194953918, 0.221925154328346, 0.221849083900452, 0.221772968769073, 0.221696823835373, 0.221620634198189, 0.221544399857521, 0.221468135714531, 0.221391826868057, 0.221315488219261, 0.221239104866982, 0.221162691712379, 0.221086233854294, 0.221009746193886, 0.220933213829994, 0.220856636762619, 0.220780044794083, 0.220703393220901, 0.220626711845398, 0.220550030469894, 0.220473244786263, 0.220396459102631, 0.220319613814354, 0.220242768526077, 0.220165848731995, 0.22008889913559, 0.220011904835701, 0.21993488073349, 0.219857826828957, 0.219780758023262, 0.219703614711761, 0.219626441597939, 0.219549223780632, 0.219471976161003, 0.219394713640213, 0.219317376613617, 0.21924002468586, 0.219162628054619, 0.219085201621056, 0.219007700681686, 0.218930214643478, 0.218852654099464, 0.218775063753128, 0.21869745850563, 0.218619778752327, 0.218542084097862, 0.218464344739914, 0.218386560678482, 0.218308761715889, 0.218230918049812, 0.218153029680252, 0.218075096607208, 0.217997133731842, 0.217919126152992, 0.217841073870659, 0.217763021588326, 0.217684894800186, 0.217606753110886, 0.21752855181694, 0.217450350522995, 0.217372089624405, 0.21729376912117, 0.217215433716774, 0.217137038707733, 0.21705861389637, 0.216980159282684, 0.216901689767838, 0.216823145747185, 0.216744616627693, 0.216665983200073, 0.216587349772453, 0.216508656740189, 0.216429963707924, 0.216351196169853, 0.21627239882946, 0.216193556785583, 0.216114684939384, 0.216035813093185, 0.215956836938858, 0.215877875685692, 0.21579883992672, 0.215719774365425, 0.215640664100647, 0.21556156873703, 0.215482383966446, 0.215403169393539, 0.215323925018311, 0.215244650840759, 0.215165331959724, 0.215085968375206, 0.215006560087204, 0.214927151799202, 0.214847669005394, 0.214768156409264, 0.214688614010811, 0.214609041810036, 0.214529395103455, 0.214449763298035, 0.214370042085648, 0.21429032087326, 0.214210525155067, 0.214130729436874, 0.214050859212875, 0.213970988988876, 0.213891059160233, 0.213811084628105, 0.213731095194817, 0.213651046156883, 0.213570967316628, 0.213490873575211, 0.213410690426826, 0.213330507278442, 0.213250294327736, 0.213170036673546, 0.213089719414711, 0.213009387254715, 0.212929040193558, 0.212848603725433, 0.212768137454987, 0.212687656283379, 0.212607115507126, 0.212526544928551, 0.212445959448814, 0.212365299463272, 0.212284624576569, 0.212203904986382, 0.212123155593872, 0.212042346596718, 0.211961552500725, 0.211880668997765, 0.211799770593643, 0.211718827486038, 0.211637824773788, 0.211556822061539, 0.211475759744644, 0.211394652724266, 0.211313530802727, 0.211232364177704, 0.211151167750359, 0.211069911718369, 0.210988625884056, 0.21090729534626, 0.210825964808464, 0.210744559764862, 0.210663110017776, 0.210581660270691, 0.210500136017799, 0.210418581962585, 0.210336998105049, 0.21025538444519, 0.210173711180687, 0.210092037916183, 0.210010275244713, 0.209928527474403, 0.209846705198288, 0.209764823317528, 0.209682956337929, 0.209601014852524, 0.209519073367119, 0.20943708717823, 0.209355026483536, 0.209272980690002, 0.209190845489502, 0.20910869538784, 0.209026515483856, 0.208944275975227, 0.208862021565437, 0.208779722452164, 0.208697378635406, 0.208615005016327, 0.208532586693764, 0.208450123667717, 0.208367645740509, 0.208285123109818, 0.208202555775642, 0.208119943737984, 0.208037286996841, 0.207954615354538, 0.207871913909912, 0.207789152860641, 0.207706347107887, 0.207623511552811, 0.207540661096573, 0.207457780838013, 0.207374840974808, 0.207291856408119, 0.207208812236786, 0.207125782966614, 0.207042679190636, 0.206959545612335, 0.206876367330551, 0.206793129444122, 0.206709906458855, 0.206626638770103, 0.206543311476707, 0.20645996928215, 0.206376537680626, 0.206293120980263, 0.206209659576416, 0.206126153469086, 0.206042587757111, 0.205958992242813, 0.205875381827354, 0.205791741609573, 0.205708026885986, 0.205624297261238, 0.205540537834167, 0.205456733703613, 0.205372869968414, 0.205288976430893, 0.205205038189888, 0.205121099948883, 0.205037102103233, 0.2049530595541, 0.204868987202644, 0.204784870147705, 0.204700723290443, 0.204616546630859, 0.204532310366631, 0.204448044300079, 0.204363733530045, 0.204279407858849, 0.204195037484169, 0.204110622406006, 0.204026162624359, 0.203941658139229, 0.203857153654099, 0.203772574663162, 0.203687965869904, 0.203603342175484, 0.203518643975258, 0.203433945775032, 0.203349187970161, 0.203264400362968, 0.203179553151131, 0.203094676136971, 0.203009784221649, 0.202924847602844, 0.202839866280556, 0.202754855155945, 0.202669784426689, 0.202584713697433, 0.202499583363533, 0.202414378523827, 0.202329203486443, 0.202243939042091, 0.202158644795418, 0.202073350548744, 0.201987966895103, 0.201902613043785, 0.201817154884338, 0.20173168182373, 0.201646193861961, 0.201560646295547, 0.20147505402565, 0.20138943195343, 0.201303765177727, 0.201218098402023, 0.201132342219353, 0.201046571135521, 0.200960755348206, 0.200874894857407, 0.200789019465446, 0.200703114271164, 0.200617134571075, 0.200531125068665, 0.200445115566254, 0.200359031558037, 0.200272917747498, 0.200186774134636, 0.20010057091713, 0.200014337897301, 0.199928089976311, 0.199841797351837, 0.19975546002388, 0.199669077992439, 0.199582666158676, 0.199496194720268, 0.19940972328186, 0.199323177337646, 0.199236631393433, 0.199150025844574, 0.199063390493393, 0.19897672533989, 0.198890000581741, 0.198803246021271, 0.198716446757317, 0.19862961769104, 0.198542758822441, 0.19845587015152, 0.198368892073631, 0.198281928896904, 0.198194891214371, 0.198107853531837, 0.198020741343498, 0.197933629155159, 0.197846457362175, 0.197759255766869, 0.19767202436924, 0.197584748268127, 0.19749741256237, 0.197410047054291, 0.197322651743889, 0.197235226631165, 0.197147756814957, 0.197060242295265, 0.196972697973251, 0.196885108947754, 0.196797490119934, 0.196709841489792, 0.196622133255005, 0.196534395217896, 0.196446627378464, 0.19635882973671, 0.196271002292633, 0.196183100342751, 0.196095153689384, 0.196007207036018, 0.195919200778008, 0.195831179618835, 0.19574311375618, 0.195655003190041, 0.195566833019257, 0.19547863304615, 0.195390447974205, 0.195302173495293, 0.195213854312897, 0.195125505328178, 0.19503715634346, 0.194948747754097, 0.19486029446125, 0.19477179646492, 0.194683253765106, 0.194594711065292, 0.194506108760834, 0.194417476654053, 0.194328770041466, 0.194240063428879, 0.194151341915131, 0.194062530994415, 0.193973690271378, 0.193884834647179, 0.193795904517174, 0.19370698928833, 0.193618014454842, 0.193528980016708, 0.193439930677414, 0.193350836634636, 0.193261727690697, 0.193172544240952, 0.193083345890045, 0.192994102835655, 0.19290480017662, 0.192815497517586, 0.192726150155067, 0.192636758089066, 0.192547336220741, 0.192457839846611, 0.19236832857132, 0.192278802394867, 0.19218921661377, 0.19209960103035, 0.192009925842285, 0.191920235753059, 0.191830515861511, 0.191740736365318, 0.191650927066803, 0.191561058163643, 0.191471174359322, 0.191381290555, 0.191291302442551, 0.191201329231262, 0.191111266613007, 0.191021203994751, 0.190931096673012, 0.190840944647789, 0.190750747919083, 0.190660521388054, 0.190570265054703, 0.190479978919029, 0.190389633178711, 0.190299242734909, 0.190208852291107, 0.190118402242661, 0.19002790749073, 0.189937368035316, 0.189846828579903, 0.189756214618683, 0.189665555953979, 0.189574912190437, 0.189484179019928, 0.189393445849419, 0.189302653074265, 0.189211815595627, 0.189120963215828, 0.189030051231384, 0.188939109444618, 0.188848122954369, 0.188757106661797, 0.188666060566902, 0.188575237989426, 0.188484698534012, 0.188394159078598, 0.188303619623184, 0.188213124871254, 0.188122615218163, 0.18803209066391, 0.18794159591198, 0.187851086258888, 0.187760606408119, 0.18767012655735, 0.18757963180542, 0.187489151954651, 0.187398672103882, 0.187308192253113, 0.187217757105827, 0.187127247452736, 0.187036827206612, 0.186946377158165, 0.186855912208557, 0.186765491962433, 0.186675027012825, 0.18658459186554, 0.186494141817093, 0.186403721570969, 0.186313301324844, 0.18622288107872, 0.186132460832596, 0.186042055487633, 0.18595165014267, 0.185861259698868, 0.185770839452744, 0.18568043410778, 0.185590073466301, 0.185499653220177, 0.185409307479858, 0.185318917036057, 0.185228541493416, 0.185138151049614, 0.185047805309296, 0.184957459568977, 0.184867113828659, 0.18477675318718, 0.1846863925457, 0.184596046805382, 0.184505730867386, 0.184415385127068, 0.184325039386749, 0.184234723448753, 0.18414443731308, 0.184054121375084, 0.183963775634766, 0.183873474597931, 0.183783188462257, 0.1836928576231, 0.183602586388588, 0.183512285351753, 0.183421984314919, 0.183331698179245, 0.183241441845894, 0.183151170611382, 0.183060899376869, 0.182970628142357, 0.182880371809006, 0.182790115475655, 0.182699859142303, 0.182609632611275, 0.182519376277924, 0.182429134845734, 0.182338893413544, 0.182248666882515, 0.182158455252647, 0.18206824362278, 0.181978017091751, 0.181887790560722, 0.181797593832016, 0.18170739710331, 0.181617185473442, 0.181526973843575, 0.181436792016029, 0.181346595287323, 0.1812564432621, 0.181166261434555, 0.181076094508171, 0.180985897779465, 0.180895730853081, 0.180805593729019, 0.180715441703796, 0.180625289678574, 0.180535137653351, 0.180444985628128, 0.180354863405228, 0.180264711380005, 0.180174589157104, 0.180084437131882, 0.179994329810143, 0.179904222488403, 0.179814115166664, 0.179723992943764, 0.179633885622025, 0.179543793201447, 0.17945371568203, 0.179363593459129, 0.179273515939713, 0.179183438420296, 0.179093360900879, 0.179003283381462, 0.178913235664368, 0.178823158144951, 0.178733080625534, 0.178643018007278, 0.178552970290184, 0.178462937474251, 0.178372904658318, 0.178282856941223, 0.17819282412529, 0.178102761507034, 0.178012758493423, 0.177922740578651, 0.177832707762718, 0.177742704749107, 0.177652671933174, 0.177562698721886, 0.177472710609436, 0.177382692694664, 0.177292689681053, 0.177202701568604, 0.177112743258476, 0.177022740244865, 0.176932781934738, 0.176842778921127, 0.176752820611, 0.176662892103195, 0.176572933793068, 0.176482975482941, 0.176393032073975, 0.176303058862686, 0.176213145256042, 0.176123201847076, 0.176033273339272, 0.175943344831467, 0.175853416323662, 0.175763502717018, 0.175673574209213, 0.175583690404892, 0.175493776798248, 0.175403863191605, 0.175313964486122, 0.175224080681801, 0.17513419687748, 0.175044313073158, 0.174954429268837, 0.174864560365677, 0.174774691462517, 0.174684822559357, 0.174594953656197, 0.174505114555359, 0.17441526055336, 0.174325421452522, 0.174235552549362, 0.174145728349686, 0.174055874347687, 0.173966065049171, 0.173876225948334, 0.173786386847496, 0.17369656264782, 0.173606753349304, 0.173516944050789, 0.173427164554596, 0.173337325453758, 0.173247560858727, 0.173157751560211, 0.173067957162857, 0.172978177666664, 0.172888398170471, 0.172798633575439, 0.172708868980408, 0.172619089484215, 0.172529339790344, 0.172439560294151, 0.172349825501442, 0.172260046005249, 0.172170326113701, 0.172080591320992, 0.171990856528282, 0.171901106834412, 0.171811386942863, 0.171721667051315, 0.171631947159767, 0.17154224216938, 0.171452507376671, 0.171362817287445, 0.171273112297058, 0.171183407306671, 0.171093732118607, 0.171004012227058, 0.170914337038994, 0.17082467675209, 0.170735001564026, 0.170645326375961, 0.170555666089058, 0.170465990900993, 0.170376315712929, 0.170286685228348, 0.170197024941444, 0.170107364654541, 0.17001773416996, 0.169928103685379, 0.169838488101959, 0.169748842716217, 0.169659212231636, 0.169569596648216, 0.169479981064796, 0.169390365481377, 0.169300779700279, 0.169211164116859, 0.169121563434601, 0.169031977653503, 0.168942391872406, 0.168852791190147, 0.168763220310211, 0.168673634529114, 0.168584063649178, 0.168494507670403, 0.168404936790466, 0.168315380811691, 0.168225824832916, 0.168136268854141, 0.168046727776527, 0.167957186698914, 0.1678676456213, 0.167778119444847, 0.167688578367233, 0.167599067091942, 0.16750955581665, 0.167420014739037, 0.167330518364906, 0.167241021990776, 0.167151495814323, 0.167062014341354, 0.166972517967224, 0.166883051395416, 0.166793555021286, 0.166704043745995, 0.166614577174187, 0.16652512550354, 0.166435658931732, 0.166346177458763, 0.166256710886955, 0.16616727411747, 0.166077822446823, 0.165988385677338, 0.16589891910553, 0.165809497237206, 0.16572006046772, 0.165630638599396, 0.16554120182991, 0.165451794862747, 0.165362372994423, 0.165272936224937, 0.165183559060097, 0.165094137191772, 0.165004745125771, 0.164915338158607, 0.164825975894928, 0.164736583828926, 0.164647191762924, 0.164557814598083, 0.164468422532082, 0.164379075169563, 0.164289712905884, 0.164200365543365, 0.164110988378525, 0.164021641016006, 0.163932293653488, 0.16384294629097, 0.163753598928452, 0.163664266467094, 0.163574948906898, 0.163485616445541, 0.163396283984184, 0.16330698132515, 0.163217678666115, 0.163128361105919, 0.163039058446884, 0.162949770689011, 0.162860468029976, 0.162771180272102, 0.162681877613068, 0.162592619657516, 0.162503346800804, 0.162414073944092, 0.162324801087379, 0.162235528230667, 0.162146255373955, 0.162057027220726, 0.161967754364014, 0.161878511309624, 0.161789268255234, 0.161700010299683, 0.161610797047615, 0.161521553993225, 0.161432340741158, 0.161343112587929, 0.1612538844347, 0.161164686083794, 0.161075472831726, 0.160986259579659, 0.160897076129913, 0.160807877779007, 0.160718694329262, 0.160629510879517, 0.16054031252861, 0.160451129078865, 0.160361960530281, 0.160272806882858, 0.160183623433113, 0.16009446978569, 0.160005316138268, 0.159916162490845, 0.159827023744583, 0.15973787009716, 0.159648731350899, 0.159559592604637, 0.159470468759537, 0.159381359815598, 0.159292221069336, 0.159203112125397, 0.159113988280296, 0.159024879336357, 0.158935785293579, 0.158846691250801, 0.158757567405701, 0.158668488264084, 0.158579394221306, 0.15849032998085, 0.158401250839233, 0.158312171697617, 0.158223092556, 0.158134028315544, 0.158044964075089, 0.157955914735794, 0.157866850495338, 0.157777801156044, 0.157688766717911, 0.157599717378616, 0.157510697841644, 0.157421663403511, 0.157332643866539, 0.157243609428406, 0.157154574990273, 0.157065585255623, 0.156976565718651, 0.15688756108284, 0.156798556447029, 0.156709566712379, 0.156620591878891, 0.15653158724308, 0.156442612409592, 0.156353622674942, 0.156264647841454, 0.156175673007965, 0.156086727976799, 0.155997753143311, 0.155908808112144, 0.155819833278656, 0.15573088824749, 0.155641973018646, 0.15555302798748, 0.155464082956314, 0.155375152826309, 0.155286222696304, 0.155197292566299, 0.155108377337456, 0.155019447207451, 0.154930531978607, 0.154841646552086, 0.154752746224403, 0.154663860797882, 0.1545749604702, 0.154486060142517, 0.154397189617157, 0.154308304190636, 0.154219433665276, 0.154130548238754, 0.154041677713394, 0.153952822089195, 0.153863966464996, 0.153775125741959, 0.15368627011776, 0.153597429394722, 0.153508588671684, 0.153419747948647, 0.15333092212677, 0.153242096304893, 0.153153255581856, 0.15306444466114, 0.152975618839264, 0.15288682281971, 0.152798026800156, 0.152709200978279, 0.152620419859886, 0.152531638741493, 0.152442827820778, 0.152354046702385, 0.152265265583992, 0.152176484465599, 0.152087718248367, 0.151998952031136, 0.151910200715065, 0.151821434497833, 0.151732683181763, 0.151643931865692, 0.151555195450783, 0.151466444134712, 0.151377707719803, 0.151288971304893, 0.151200264692307, 0.151111513376236, 0.151022791862488, 0.150934100151062, 0.150845378637314, 0.150756672024727, 0.15066796541214, 0.150579273700714, 0.150490581989288, 0.150401890277863, 0.150313213467598, 0.150224536657333, 0.150135859847069, 0.150047183036804, 0.149958521127701, 0.149869859218597, 0.149781197309494, 0.149692550301552, 0.149603888392448, 0.149515226483345, 0.149426609277725, 0.149337977170944, 0.149249315261841, 0.14916068315506, 0.149072080850601, 0.148983463644981, 0.148894846439362, 0.148806244134903, 0.148717626929283, 0.148629024624825, 0.148540407419205, 0.148451834917068, 0.14836323261261, 0.148274645209312, 0.148186072707176, 0.14809750020504, 0.148008927702904, 0.147920355200768, 0.147831797599792, 0.147743225097656, 0.147654667496681, 0.147566124796867, 0.147477582097054, 0.14738903939724, 0.147300496697426, 0.147211968898773, 0.147123456001282, 0.147034928202629, 0.146946400403976, 0.146857872605324, 0.146769359707832, 0.146680861711502, 0.146592363715172, 0.14650385081768, 0.146415367722511, 0.14632685482502, 0.146238386631012, 0.146149903535843, 0.146061435341835, 0.145972952246666, 0.145884484052658, 0.145796030759811, 0.145707577466965, 0.145619109272957, 0.14553065598011, 0.145442202687263, 0.1453537940979, 0.145265340805054, 0.145176902413368, 0.145088464021683, 0.145000040531158, 0.144911631941795, 0.144823208451271, 0.144734799861908, 0.144646376371384, 0.144557982683182, 0.14446958899498, 0.144381210207939, 0.144292816519737, 0.144204422831535, 0.144116029143333, 0.144027665257454, 0.143939286470413, 0.143850907683372, 0.143762543797493, 0.143674179911613, 0.143585816025734, 0.143497481942177, 0.143409132957458, 0.14332078397274, 0.143232449889183, 0.143144115805626, 0.14305579662323, 0.142967462539673, 0.142879143357277, 0.14279080927372, 0.142702504992485, 0.14261420071125, 0.142525911331177, 0.142437607049942, 0.142349302768707, 0.142261013388634, 0.142172738909721, 0.142084449529648, 0.141996175050735, 0.141907885670662, 0.14181961119175, 0.141731351613998, 0.141643092036247, 0.141554847359657, 0.141466587781906, 0.141378328204155, 0.141290113329887, 0.141201868653297, 0.141113623976707, 0.14102540910244, 0.140937149524689, 0.140848964452744, 0.140760734677315, 0.140672519803047, 0.14058430492878, 0.140496119856834, 0.140407919883728, 0.140319719910622, 0.140231519937515, 0.14014333486557, 0.140055149793625, 0.139966979622841, 0.139878794550896, 0.139790624380112, 0.139702469110489, 0.139614298939705, 0.139526158571243, 0.139437988400459, 0.139349848031998, 0.139261722564697, 0.139173552393913, 0.139085441827774, 0.138997301459312, 0.138909161090851, 0.138821050524712, 0.138732939958572, 0.138644829392433, 0.138556718826294, 0.138468608260155, 0.138380497694016, 0.138292402029037, 0.138204306364059, 0.138116225600243, 0.138028144836426, 0.137940064072609, 0.137851998209953, 0.137763917446136, 0.137675866484642, 0.137587800621986, 0.137499734759331, 0.137411668896675, 0.137323632836342, 0.137235596776009, 0.137147545814514, 0.137059509754181, 0.136971488595009, 0.136883452534676, 0.136795431375504, 0.136707425117493, 0.136619403958321, 0.13653139770031, 0.136443376541138, 0.136355385184288, 0.136267378926277, 0.136179402470589, 0.136091396212578, 0.136003419756889, 0.135915458202362, 0.135827466845512, 0.135739505290985, 0.135651543736458, 0.135563567280769, 0.135475605726242, 0.135387673974037, 0.13529971241951, 0.135211765766144, 0.135123804211617, 0.135035902261734, 0.134947970509529, 0.134860038757324, 0.134772121906281, 0.134684190154076, 0.134596288204193, 0.134508371353149, 0.134420454502106, 0.134332552552223, 0.134244650602341, 0.134156778454781, 0.134068891406059, 0.133981004357338, 0.133893117308617, 0.133805245161057, 0.133717358112335, 0.133629500865936, 0.133541643619537, 0.133453786373138, 0.13336592912674, 0.133278071880341, 0.133190244436264, 0.133102402091026, 0.133014559745789, 0.132926717400551, 0.132838889956474, 0.132751077413559, 0.132663264870644, 0.132575437426567, 0.132487624883652, 0.132399812340736, 0.132312029600143, 0.132224231958389, 0.132136449217796, 0.132048651576042, 0.131960853934288, 0.131873100996017, 0.131785303354263, 0.13169752061367, 0.1316097676754, 0.131521999835968, 0.131434261798859, 0.131346508860588, 0.131258741021156, 0.131170988082886, 0.131083250045776, 0.130995541810989, 0.13090780377388, 0.130820065736771, 0.130732327699661, 0.130644604563713, 0.130556896328926, 0.130469188094139, 0.130381479859352, 0.130293771624565, 0.130206078290939, 0.130118399858475, 0.130030691623688, 0.129943013191223, 0.129855319857597, 0.129767656326294, 0.129679977893829, 0.129592314362526, 0.129504665732384, 0.12941700220108, 0.129329338669777, 0.129241704940796, 0.129154041409492, 0.129066407680511, 0.128978759050369, 0.128891110420227, 0.128803491592407, 0.128715872764587, 0.128628253936768, 0.128540650010109, 0.128453031182289, 0.12836542725563, 0.128277823328972, 0.128190219402313, 0.128102630376816, 0.128015026450157, 0.127927452325821, 0.127839878201485, 0.127752289175987, 0.127664729952812, 0.127577155828476, 0.12748958170414, 0.127402037382126, 0.127314478158951, 0.127226918935776, 0.127139374613762, 0.127051830291748, 0.126964300870895, 0.126876771450043, 0.126789227128029, 0.126701712608337, 0.126614198088646, 0.126526683568954, 0.126439169049263, 0.126351654529572, 0.126264154911041, 0.12617664039135, 0.126089170575142, 0.126001670956612, 0.125914171338081, 0.125826686620712, 0.125739216804504, 0.125651761889458, 0.12556429207325, 0.125476822257042, 0.125389352440834, 0.125301897525787, 0.125214457511902, 0.125127002596855, 0.125039547681808, 0.124952122569084, 0.12486469745636, 0.124777264893055, 0.12468983232975, 0.124602414667606, 0.124514989554882, 0.124427579343319, 0.124340169131756, 0.124252773821354, 0.124165371060371, 0.124077975749969, 0.123990565538406, 0.123903207480907, 0.123815819621086, 0.123728446662426, 0.123641073703766, 0.123553708195686, 0.123466335237026, 0.123378977179527, 0.123291626572609, 0.123204261064529, 0.123116917908192, 0.123029582202435, 0.122942253947258, 0.122854918241501, 0.122767575085163, 0.122680246829987, 0.122592911124229, 0.122505620121956, 0.122418291866779, 0.122330985963345, 0.122243672609329, 0.122156381607056, 0.122069105505943, 0.121981807053089, 0.121894508600235, 0.121807225048542, 0.12171994894743, 0.121632680296898, 0.121545404195786, 0.121458128094673, 0.121370889246464, 0.121283613145351, 0.121196381747723, 0.121109135448933, 0.121021889150143, 0.120934642851353, 0.120847404003143, 0.120760187506676, 0.120672963559628, 0.120585724711418, 0.120498508214951, 0.120411291718483, 0.120324090123177, 0.120236895978451, 0.120149686932564, 0.120062492787838, 0.119975291192532, 0.119888126850128, 0.119800925254822, 0.119713746011257, 0.119626566767693, 0.119539402425289, 0.119452223181725, 0.119365081191063, 0.119277931749821, 0.119190767407417, 0.119103625416756, 0.119016468524933, 0.118929356336594, 0.118842199444771, 0.11875506490469, 0.11866794526577, 0.118580803275108, 0.11849369853735, 0.118406593799591, 0.118319489061832, 0.118232376873493, 0.118145279586315, 0.118058189749718, 0.11797109246254, 0.117884002625942, 0.117796912789345, 0.117709822952747, 0.117622762918472, 0.117535687983036, 0.117448635399342, 0.117361575365067, 0.117274515330791, 0.117187470197678, 0.117100402712822, 0.117013365030289, 0.116926319897175, 0.116839282214642, 0.116752251982689, 0.116665229201317, 0.116578221321106, 0.116491191089153, 0.116404183208942, 0.116317167878151, 0.11623015999794, 0.11614315956831, 0.116056151688099, 0.11596916615963, 0.11588217318058, 0.115795187652111, 0.115708217024803, 0.115621246397495, 0.115534253418446, 0.11544731259346, 0.115360349416733, 0.115273386240005, 0.115186437964439, 0.115099467337132, 0.115012533962727, 0.114925593137741, 0.114838652312756, 0.114751718938351, 0.114664800465107, 0.114577867090702, 0.11449096351862, 0.114404052495956, 0.114317126572132, 0.114230208098888, 0.114143319427967, 0.114056438207626, 0.113969534635544, 0.113882638514042, 0.113795764744282, 0.113708883523941, 0.113622017204762, 0.113535135984421, 0.113448269665241, 0.113361395895481, 0.113274537026882, 0.113187685608864, 0.113100841641426, 0.113013997673988, 0.11292714625597, 0.112840324640274, 0.112753495573997, 0.11266665905714, 0.112579837441444, 0.112493015825748, 0.112406186759472, 0.112319394946098, 0.112232573330402, 0.112145781517029, 0.112058982253075, 0.111972197890282, 0.111885406076908, 0.111798629164696, 0.111711844801903, 0.111625052988529, 0.111538276076317, 0.111451521515846, 0.111364759504795, 0.111278004944324, 0.111191242933273, 0.111104480922222, 0.111017763614655, 0.110931016504765, 0.110844276845455, 0.110757537186146, 0.110670804977417, 0.11058409512043, 0.110497362911701, 0.110410645604134, 0.110323935747147, 0.11023722589016, 0.110150553286076, 0.110063843429089, 0.109977141022682, 0.109890438616276, 0.109803758561611, 0.109717078506947, 0.109630413353443, 0.109543740749359, 0.109457068145275, 0.109370388090611, 0.109283722937107, 0.109197095036507, 0.109110444784164, 0.109023794531822, 0.108937159180641, 0.10885051637888, 0.108763888478279, 0.108677253127098, 0.108590632677078, 0.108503989875317, 0.108417384326458, 0.108330778777599, 0.108244173228741, 0.108157567679882, 0.108070962131023, 0.107984356582165, 0.107897780835629, 0.107811205089092, 0.107724621891975, 0.107638031244278, 0.107551462948322, 0.107464902102947, 0.107378348708153, 0.107291772961617, 0.107205227017403, 0.107118673622608, 0.107032120227814, 0.106945596635342, 0.106859035789967, 0.106772512197495, 0.106685973703861, 0.10659945756197, 0.106512933969498, 0.106426425278187, 0.106339894235134, 0.106253407895565, 0.106166899204254, 0.106080397963524, 0.105993896722794, 0.105907402932644, 0.105820916593075, 0.105734445154667, 0.105647966265678, 0.105561502277851, 0.105475030839443, 0.105388544499874, 0.105302110314369, 0.105215661227703, 0.105129189789295, 0.10504274815321, 0.104956306517124, 0.104869849979877, 0.104783438146114, 0.104696996510029, 0.104610569775105, 0.104524157941341, 0.104437723755836, 0.104351334273815, 0.104264907538891, 0.104178503155708, 0.104092113673687, 0.104005716741085, 0.103919319808483, 0.103832930326462, 0.103746555745602, 0.103660181164742, 0.103573806583881, 0.103487446904182, 0.103401072323322, 0.103314720094204, 0.103228345513344, 0.103141993284225, 0.103055648505688, 0.102969311177731, 0.102882958948612, 0.102796651422977, 0.10271030664444, 0.102623984217644, 0.102537669241428, 0.102451339364052, 0.102365016937256, 0.102278716862202, 0.102192439138889, 0.102106116712093, 0.10201982408762, 0.101933524012566, 0.101847246289253, 0.101760976016521, 0.101674683392048, 0.101588405668736, 0.101502127945423, 0.101415865123272, 0.101329617202282, 0.10124334692955, 0.10115709900856, 0.10107085108757, 0.100984610617161, 0.100898385047913, 0.100812144577503, 0.100725904107094, 0.100639685988426, 0.100553460419178, 0.100467249751091, 0.100381024181843, 0.100294813513756, 0.100213184952736, 0.100136086344719, 0.100059017539024, 0.0999819934368134, 0.0999049693346024, 0.0998279824852943, 0.0997510179877281, 0.0996740758419037, 0.0995971858501434, 0.0995202958583832, 0.0994434356689453, 0.0993666052818298, 0.0992897897958755, 0.0992130637168884, 0.0991363227367401, 0.0990595817565918, 0.0989828929305077, 0.0989062190055847, 0.0988295897841454, 0.0987529754638672, 0.0986764207482338, 0.0985998660326004, 0.0985233336687088, 0.0984468162059784, 0.098370335996151, 0.0982938930392265, 0.0982174649834633, 0.0981410816311836, 0.0980647355318069, 0.0979883745312691, 0.0979120582342148, 0.0978357717394829, 0.0977595150470734, 0.0976832881569862, 0.0976070985198021, 0.0975309312343597, 0.0974547788500786, 0.0973786488175392, 0.0973025634884834, 0.0972265005111694, 0.097150444984436, 0.0970744490623474, 0.0969984456896782, 0.0969224944710732, 0.0968465879559517, 0.0967706739902496, 0.0966947823762894, 0.0966189280152321, 0.0965431109070778, 0.0964673236012459, 0.0963915586471558, 0.0963158085942268, 0.0962400808930397, 0.0961643978953362, 0.0960887372493744, 0.0960131138563156, 0.0959374979138374, 0.095861941576004, 0.09578637778759, 0.0957108438014984, 0.0956353396177292, 0.0955598652362823, 0.0954844206571579, 0.0954089984297752, 0.0953336209058762, 0.0952582657337189, 0.0951829329133034, 0.0951076149940491, 0.0950323268771172, 0.09495709836483, 0.0948818698525429, 0.0948066636919975, 0.094731479883194, 0.0946563258767128, 0.0945812165737152, 0.0945061296224594, 0.0944310799241066, 0.0943560302257538, 0.0942810103297234, 0.0942060574889183, 0.0941310971975327, 0.0940561518073082, 0.0939812585711479, 0.0939063653349876, 0.0938315168023109, 0.093756690621376, 0.0936819016933441, 0.093607172369957, 0.093532420694828, 0.0934576988220215, 0.0933830142021179, 0.093308337032795, 0.0932337194681168, 0.0931591168045998, 0.0930845439434052, 0.0930099859833717, 0.0929354652762413, 0.0928609669208527, 0.0927864983677864, 0.0927120745182037, 0.0926376581192017, 0.0925632864236832, 0.0924889147281647, 0.0924145728349686, 0.092340275645256, 0.0922660082578659, 0.0921917483210564, 0.0921175256371498, 0.0920433178544044, 0.0919691622257233, 0.0918950214982033, 0.0918208882212639, 0.0917467996478081, 0.0916727557778358, 0.0915986970067024, 0.0915247052907944, 0.0914507210254669, 0.091376781463623, 0.0913028568029404, 0.0912289321422577, 0.0911550670862198, 0.0910812243819237, 0.0910073816776276, 0.0909335911273956, 0.0908598601818085, 0.0907861217856407, 0.0907124206423759, 0.0906387493014336, 0.0905650928616524, 0.0904914513230324, 0.090417854487896, 0.0903442576527596, 0.0902707353234291, 0.0901971906423569, 0.0901237055659294, 0.0900502353906631, 0.0899767950177193, 0.0899034142494202, 0.0898300036787987, 0.0897566825151443, 0.0896833315491676, 0.0896100178360939, 0.0895367488265038, 0.0894635021686554, 0.0893902778625488, 0.0893170759081841, 0.0892439261078835, 0.0891707614064217, 0.0890976786613464, 0.0890245735645294, 0.0889515206217766, 0.0888784825801849, 0.0888054817914963, 0.0887324810028076, 0.0886595472693443, 0.0885866433382034, 0.0885137319564819, 0.0884408801794052, 0.0883680358529091, 0.0882952287793159, 0.0882224217057228, 0.0881496593356133, 0.0880769267678261, 0.0880042165517807, 0.0879315212368965, 0.0878588780760765, 0.0877862647175789, 0.0877136439085007, 0.0876410976052284, 0.0875685513019562, 0.0874960497021675, 0.0874235406517982, 0.0873510986566544, 0.0872786417603493, 0.0872062519192696, 0.0871338471770287, 0.0870615094900131, 0.0869891792535782, 0.0869168937206268, 0.0868446230888367, 0.0867723599076271, 0.0867001414299011, 0.0866279453039169, 0.0865557715296745, 0.0864836573600769, 0.0864115357398987, 0.0863394439220428, 0.0862673968076706, 0.0861953943967819, 0.0861233696341515, 0.0860513970255852, 0.0859794393181801, 0.0859075263142586, 0.0858356282114983, 0.0857637748122215, 0.0856919065117836, 0.0856200978159904, 0.0855483040213585, 0.0854765549302101, 0.0854048654437065, 0.0853331461548805, 0.0852614790201187, 0.0851898118853569, 0.0851181969046593, 0.0850465968251228, 0.0849750190973282, 0.0849034711718559, 0.0848319679498672, 0.084760494530201, 0.0846890211105347, 0.0846175998449326, 0.0845461785793304, 0.0844748094677925, 0.0844034478068352, 0.0843321457505226, 0.0842608287930489, 0.0841895714402199, 0.0841183140873909, 0.0840471088886261, 0.0839759483933449, 0.0839047655463219, 0.083833634853363, 0.0837625116109848, 0.0836914405226707, 0.0836203619837761, 0.0835493430495262, 0.0834783464670181, 0.0834073647856712, 0.0833364129066467, 0.0832655504345894, 0.0831946581602097, 0.0831237807869911, 0.0830529406666756, 0.0829821228981018, 0.0829113647341728, 0.082840584218502, 0.082769863307476, 0.0826991349458694, 0.0826284810900688, 0.0825578272342682, 0.0824872180819511, 0.0824166312813759, 0.0823460519313812, 0.0822755321860313, 0.0822050198912621, 0.0821345448493958, 0.0820640623569489, 0.0819936394691467, 0.0819232240319252, 0.0818528607487679, 0.0817825049161911, 0.0817122012376785, 0.0816419124603271, 0.081571638584137, 0.0815013945102692, 0.0814311727881432, 0.0813609883189201, 0.0812908113002777, 0.0812206789851189, 0.0811505615711212, 0.0810805335640907, 0.0810104981064796, 0.0809404477477074, 0.0808704644441605, 0.0808004811406136, 0.0807305425405502, 0.0806606039404869, 0.0805907249450684, 0.0805208459496498, 0.080451026558876, 0.0803812369704247, 0.0803114548325539, 0.0802417024970055, 0.0801719725131989, 0.0801022946834564, 0.0800326094031334, 0.0799629762768745, 0.0798933431506157, 0.079823762178421, 0.0797541886568069, 0.0796846747398376, 0.0796151459217072, 0.0795456767082214, 0.0794762298464775, 0.0794067904353142, 0.0793373882770538, 0.0792679935693741, 0.0791986659169197, 0.0791293233633041, 0.0790600404143333, 0.0789907947182655, 0.0789215788245201, 0.0788523554801941, 0.0787831619381905, 0.0787140130996704, 0.078644871711731, 0.0785757899284363, 0.0785066857933998, 0.0784376561641693, 0.0783686116337776, 0.0782996490597725, 0.0782306641340256, 0.0781617313623428, 0.0780928060412407, 0.0780239552259445, 0.0779551118612289, 0.0778862535953522, 0.0778174549341202, 0.0777486637234688, 0.0776799321174622, 0.0776111781597137, 0.0775425136089325, 0.0774738341569901, 0.0774051919579506, 0.0773365870118141, 0.0772679895162582, 0.0771994367241859, 0.0771308839321136, 0.0770623907446861, 0.0769938975572586, 0.0769254639744759, 0.0768570452928543, 0.0767886564135551, 0.0767202749848366, 0.0766519382596016, 0.0765836238861084, 0.0765153244137764, 0.0764470621943474, 0.0763788148760796, 0.0763106197118759, 0.0762424319982529, 0.0761742889881134, 0.0761061608791351, 0.0760380923748016, 0.0759699940681458, 0.0759019628167152, 0.0758339464664459, 0.0757659450173378, 0.0756979808211327, 0.0756300389766693, 0.0755621269345284, 0.0754942521452904, 0.0754263997077942, 0.0753585547208786, 0.0752907544374466, 0.0752229690551758, 0.0751552358269691, 0.0750875324010849, 0.0750198215246201, 0.0749521777033806, 0.0748845189809799, 0.0748169422149658, 0.0747493356466293, 0.0746817886829376, 0.0746142268180847, 0.0745467394590378, 0.0744792520999908, 0.0744118168950081, 0.0743443965911865, 0.0742769911885262, 0.0742096230387688, 0.0741422772407532, 0.0740749910473824, 0.0740077123045921, 0.0739404559135437, 0.0738732069730759, 0.0738060101866722, 0.0737388432025909, 0.0736716762185097, 0.0736045464873314, 0.0735374465584755, 0.0734703838825226, 0.0734033510088921, 0.0733363330364227, 0.0732693299651146, 0.0732023790478706, 0.0731354206800461, 0.0730685293674469, 0.0730016529560089, 0.0729347988963127, 0.0728679820895195, 0.0728011727333069, 0.0727344304323196, 0.0726676806807518, 0.0726009681820869, 0.0725342482328415, 0.072467602789402, 0.0724009498953819, 0.0723343417048454, 0.0722677707672119, 0.0722011998295784, 0.0721346810460091, 0.0720681920647621, 0.0720017328858376, 0.0719352886080742, 0.0718688741326332, 0.0718024596571922, 0.071736104786396, 0.0716697424650192, 0.0716034397482872, 0.0715371668338776, 0.0714709013700485, 0.0714046880602837, 0.0713384747505188, 0.0712723061442375, 0.0712061524391174, 0.0711400210857391, 0.0710739269852638, 0.0710078626871109, 0.0709418505430222, 0.0708758234977722, 0.0708098411560059, 0.0707438960671425, 0.0706779733300209, 0.0706120505928993, 0.0705461874604225, 0.0704803243279457, 0.0704145058989525, 0.0703486800193787, 0.0702829286456108, 0.0702171921730042, 0.0701514557003975, 0.0700857862830162, 0.0700201466679573, 0.0699545219540596, 0.0698888972401619, 0.0698233246803284, 0.069757767021656, 0.0696922391653061, 0.0696267262101173, 0.0695612654089928, 0.06949582695961, 0.0694304034113884, 0.0693650394678116, 0.0692996606230736, 0.0692343339323997, 0.0691690146923065, 0.0691037327051163, 0.0690384730696678, 0.0689732655882835, 0.0689080581068993, 0.0688429027795792, 0.0687777549028397, 0.0687126442790031, 0.0686475485563278, 0.0685824751853943, 0.0685174465179443, 0.068452425301075, 0.0683874487876892, 0.068322479724884, 0.0682575553655624, 0.0681926235556602, 0.068127766251564, 0.068062961101532, 0.0679981410503387, 0.0679333508014679, 0.0678685754537582, 0.0678038373589516, 0.0677391067147255, 0.0676744356751442, 0.0676097571849823, 0.0675451382994652, 0.0674805343151093, 0.0674159675836563, 0.0673514232039452, 0.0672868862748146, 0.0672224089503288, 0.0671579167246819, 0.0670934841036797, 0.0670290887355804, 0.0669647008180618, 0.0669003203511238, 0.06683599203825, 0.0667717084288597, 0.0667074248194695, 0.0666431859135628, 0.0665789544582367, 0.0665147602558136, 0.0664505660533905, 0.0663864314556122, 0.0663222968578339, 0.0662582367658615, 0.0661941394209862, 0.0661301165819168, 0.0660661607980728, 0.0660021677613258, 0.0659382194280624, 0.065874271094799, 0.0658103749155998, 0.0657464936375618, 0.0656826570630074, 0.0656188279390335, 0.0655550509691238, 0.0654912739992142, 0.0654275640845299, 0.0653638616204262, 0.0653001591563225, 0.0652365162968636, 0.0651728957891464, 0.0651092976331711, 0.0650457143783569, 0.0649821609258652, 0.0649186372756958, 0.0648551508784294, 0.0647916942834854, 0.0647282600402832, 0.0646648555994034, 0.0646014586091042, 0.0645381063222885, 0.0644747614860535, 0.0644114688038826, 0.0643481686711311, 0.0642849430441856, 0.0642216950654984, 0.0641585513949394, 0.0640953928232193, 0.0640322417020798, 0.0639691352844238, 0.0639060437679291, 0.0638429820537567, 0.0637799426913261, 0.0637169480323792, 0.0636539533734322, 0.0635909959673882, 0.0635280832648277, 0.0634651929140091, 0.0634023323655128, 0.063339464366436, 0.0632766932249069, 0.0632138773798943, 0.0631511360406876, 0.0630883872509003, 0.0630256831645966, 0.0629630014300346, 0.0629003494977951, 0.0628377348184586, 0.0627751350402832, 0.0627125725150108, 0.0626500099897385, 0.0625875145196915, 0.0625250041484833, 0.0624625571072102, 0.0624001026153564, 0.0623376965522766, 0.0622753277420998, 0.0622129961848259, 0.0621506534516811, 0.0620883703231812, 0.0620260983705521, 0.0619638301432133, 0.061901617795229, 0.0618394240736961, 0.0617772564291954, 0.0617151074111462, 0.0616529993712902, 0.0615909323096275, 0.0615288726985455, 0.0614668391644955, 0.0614048615098, 0.0613428950309753, 0.0612809397280216, 0.0612190216779709, 0.0611571110785007, 0.0610952414572239, 0.0610333904623985, 0.0609716065227985, 0.0609098039567471, 0.06084805727005, 0.0607863441109657, 0.0607246346771717, 0.0606629550457001, 0.0606012903153896, 0.060539685189724, 0.0604780614376068, 0.0604165270924568, 0.0603549890220165, 0.0602934882044792, 0.0602319799363613, 0.0601705238223076, 0.0601090975105762, 0.0600476823747158, 0.059986300766468, 0.0599249415099621, 0.05986363068223, 0.0598023198544979, 0.0597410462796688, 0.0596798174083233, 0.0596185997128487, 0.0595574304461479, 0.0594962686300278, 0.05943513661623, 0.0593740157783031, 0.0593129396438599, 0.0592518746852875, 0.059190858155489, 0.0591298565268517, 0.0590689070522785, 0.0590079389512539, 0.0589470416307449, 0.0588861182332039, 0.0588252767920494, 0.0587644390761852, 0.0587036237120628, 0.058642853051424, 0.0585820898413658, 0.0585213787853718, 0.0584606789052486, 0.0584000162780285, 0.0583393462002277, 0.0582787431776524, 0.0582181289792061, 0.0581575743854046, 0.0580970272421837, 0.0580365173518658, 0.0579760372638702, 0.057915560901165, 0.057855162769556, 0.0577947422862053, 0.0577343963086605, 0.0576740317046642, 0.0576137155294418, 0.0575534366071224, 0.057493157684803, 0.0574329271912575, 0.057372685521841, 0.0573125146329403, 0.0572523586452007, 0.0571922361850739, 0.0571321099996567, 0.0570720434188843, 0.0570119768381119, 0.0569519549608231, 0.0568919740617275, 0.0568320117890835, 0.0567720718681812, 0.0567121468484402, 0.0566522926092148, 0.056592408567667, 0.0565325990319252, 0.056472759693861, 0.0564129911363125, 0.0563532300293446, 0.0562935061752796, 0.056233823299408, 0.056174136698246, 0.0561145059764385, 0.0560548678040504, 0.0559953190386295, 0.0559357441961765, 0.0558762215077877, 0.0558166988193989, 0.0557572282850742, 0.055697750300169, 0.0556383393704891, 0.0555789470672607, 0.0555195473134518, 0.0554602071642876, 0.0554008930921555, 0.0553416162729263, 0.0552823357284069, 0.0552231036126614, 0.0551638714969158, 0.0551047064363956, 0.055045560002327, 0.0549864359200001, 0.054927334189415, 0.0548682473599911, 0.0548092313110828, 0.0547501891851425, 0.0546912103891373, 0.0546322241425514, 0.0545732900500298, 0.054514367133379, 0.0544554963707924, 0.0543966479599476, 0.0543377995491028, 0.0542790032923222, 0.0542202480137348, 0.0541615039110184, 0.0541027709841728, 0.0540440827608109, 0.0539854019880295, 0.0539267659187317, 0.0538681410253048, 0.0538095533847809, 0.05375100299716, 0.053692452609539, 0.0536339692771435, 0.053575474768877, 0.0535170398652554, 0.0534586012363434, 0.0534002147614956, 0.0533418245613575, 0.0532835125923157, 0.0532251819968224, 0.053166888654232, 0.0531086511909962, 0.0530503913760185, 0.0529922023415565, 0.0529340244829655, 0.0528758727014065, 0.0528177320957184, 0.0527596361935139, 0.0527015589177608, 0.0526435151696205, 0.0525854863226414, 0.0525275059044361, 0.0524695478379726, 0.0524116456508636, 0.0523537285625935, 0.0522958487272263, 0.0522379912436008, 0.052180141210556, 0.052122350782156, 0.0520645678043365, 0.0520068183541298, 0.0519491173326969, 0.0518914051353931, 0.051833763718605, 0.051776111125946, 0.0517185144126415, 0.0516608990728855, 0.0516033619642258, 0.0515458360314369, 0.0514883510768414, 0.051430843770504, 0.0513734184205532, 0.051316000521183, 0.0512586012482643, 0.0512012429535389, 0.0511438995599747, 0.0510865896940231, 0.0510292835533619, 0.0509720258414745, 0.0509147793054581, 0.0508575886487961, 0.0508003942668438, 0.0507432520389557, 0.0506861731410027, 0.0506290793418884, 0.0505720041692257, 0.0505149513483047, 0.0504579395055771, 0.05040093511343, 0.0503439866006374, 0.0502870343625546, 0.0502301380038261, 0.0501732565462589, 0.0501164197921753, 0.0500596053898335, 0.050002783536911, 0.0499460138380527, 0.0498892553150654, 0.0498325787484646, 0.0497758723795414, 0.0497192218899727, 0.0496625676751137, 0.0496059656143188, 0.0495493672788143, 0.0494928434491158, 0.0494363233447075, 0.0493798144161701, 0.0493233390152454, 0.0492668747901917, 0.0492104701697826, 0.0491540655493736, 0.0490977019071579, 0.0490413568913937, 0.0489850752055645, 0.0489288158714771, 0.0488725565373898, 0.0488163270056248, 0.0487601049244404, 0.0487039387226105, 0.0486477762460709, 0.0485916659235954, 0.04853555560112, 0.0484794974327087, 0.0484234467148781, 0.0483674444258213, 0.0483114756643772, 0.0482555031776428, 0.0481996163725853, 0.0481436811387539, 0.0480878241360188, 0.0480319447815418, 0.0479761399328709, 0.0479203201830387, 0.0478645712137222, 0.0478088222444057, 0.0477531254291534, 0.047697439789772, 0.0476417616009712, 0.0475861392915249, 0.0475305207073689, 0.0474749505519867, 0.0474193915724754, 0.0473638623952866, 0.0473083890974522, 0.0472529195249081, 0.0471974797546864, 0.0471420660614967, 0.0470866858959198, 0.047031294554472, 0.0469759702682495, 0.0469206497073174, 0.04686538875103, 0.0468101240694523, 0.0467549003660679, 0.046699695289135, 0.046644538640976, 0.0465893931686878, 0.0465342923998833, 0.0464792139828205, 0.0464241318404675, 0.0463691018521786, 0.0463140793144703, 0.0462591052055359, 0.0462041310966015, 0.0461492128670216, 0.0460943132638931, 0.0460394397377968, 0.0459846034646034, 0.0459297746419907, 0.0458749756217003, 0.0458201989531517, 0.0457654669880867, 0.0457107573747635, 0.0456560887396336, 0.0456014312803745, 0.0455468110740185, 0.045492198318243, 0.0454376302659512, 0.0453830920159817, 0.0453285649418831, 0.0452740676701069, 0.0452195815742016, 0.0451651550829411, 0.0451107211410999, 0.0450563505291939, 0.045001994818449, 0.0449476577341557, 0.0448933690786362, 0.0448390953242779, 0.0447848588228226, 0.0447306148707867, 0.0446764342486858, 0.0446222424507141, 0.0445681177079678, 0.0445139855146408, 0.0444599203765392, 0.0444058403372765, 0.0443518236279488, 0.0442977882921696, 0.0442438200116158, 0.0441898629069328, 0.0441359393298626, 0.0440820418298244, 0.0440281815826893, 0.0439743474125862, 0.0439205430448055, 0.0438667498528957, 0.0438129715621471, 0.0437592454254627, 0.0437055267393589, 0.0436518527567387, 0.0435982085764408, 0.0435445606708527, 0.043490968644619, 0.0434373877942562, 0.0433838404715061, 0.043330330401659, 0.0432768538594246, 0.0432233847677708, 0.0431699603796005, 0.0431165546178818, 0.0430631637573242, 0.0430098026990891, 0.0429564639925957, 0.042903158813715, 0.0428498797118664, 0.042796652764082, 0.0427434146404266, 0.0426902323961258, 0.042637050151825, 0.0425839275121689, 0.042530819773674, 0.0424777194857597, 0.0424246974289417, 0.0423716343939304, 0.0423186458647251, 0.0422656759619713, 0.0422127321362495, 0.0421597920358181, 0.0421069078147411, 0.0420540198683739, 0.0420011803507805, 0.0419483706355095, 0.0418955832719803, 0.0418428257107735, 0.0417900756001472, 0.0417373888194561, 0.0416847094893456, 0.0416320711374283, 0.0415794402360916, 0.0415268503129482, 0.0414742603898048, 0.0414217300713062, 0.0413692221045494, 0.0413167253136635, 0.0412642732262611, 0.0412118285894394, 0.0411594323813915, 0.0411070473492146, 0.0410546995699406, 0.0410023517906666, 0.040950071066618, 0.0408977977931499, 0.0408455617725849, 0.0407933481037617, 0.040741141885519, 0.04068898037076, 0.0406368561089039, 0.040584746748209, 0.0405326597392559, 0.0404806099832058, 0.0404285602271557, 0.0403765700757504, 0.0403246060013771, 0.0402726382017136, 0.0402207300066948, 0.0401688180863857, 0.0401170030236244, 0.0400651469826698, 0.0400133393704891, 0.0399615354835987, 0.0399097949266434, 0.039858054369688, 0.0398063659667969, 0.0397546887397766, 0.0397030338644981, 0.0396514162421227, 0.0395998172461987, 0.0395482666790485, 0.0394967049360275, 0.0394452102482319, 0.0393937006592751, 0.0393422767519951, 0.0392908230423927, 0.0392394326627254, 0.0391880497336388, 0.0391366928815842, 0.0390853844583035, 0.039034079760313, 0.0389828160405159, 0.0389315634965897, 0.0388803519308567, 0.0388291515409946, 0.0387779958546162, 0.0387268625199795, 0.0386757552623749, 0.0386246703565121, 0.0385736413300037, 0.038522619754076, 0.0384716130793095, 0.0384206585586071, 0.0383696891367435, 0.0383187867701054, 0.0382678806781769, 0.0382170341908932, 0.0381661728024483, 0.0381153896450996, 0.0380646102130413, 0.0380138456821442, 0.0379631258547306, 0.0379124134778976, 0.0378617532551289, 0.037811104208231, 0.0377604998648167, 0.0377098917961121, 0.0376593396067619, 0.0376088097691536, 0.0375582873821259, 0.0375078171491623, 0.037457350641489, 0.037406925112009, 0.0373565107584, 0.0373061485588551, 0.0372557863593102, 0.0372054688632488, 0.037155169993639, 0.0371049121022224, 0.037054680287838, 0.0370044857263565, 0.0369543060660362, 0.0369041338562965, 0.0368540175259113, 0.0368039011955261, 0.0367538221180439, 0.0367037579417229, 0.0366543829441071, 0.0366055369377136, 0.0365567356348038, 0.0365079529583454, 0.0364591926336288, 0.0364104770123959, 0.0363617800176144, 0.0363131463527679, 0.0362645126879215, 0.0362159013748169, 0.0361673347651958, 0.0361187867820263, 0.0360702611505985, 0.036021776497364, 0.0359733141958714, 0.0359248928725719, 0.0358764752745628, 0.0358281172811985, 0.035779781639576, 0.0357314646244049, 0.0356831736862659, 0.0356349237263203, 0.0355866961181164, 0.0355385467410088, 0.0354903824627399, 0.0354422591626644, 0.0353941358625889, 0.0353460572659969, 0.0352980196475983, 0.0352500006556511, 0.0352020040154457, 0.0351540297269821, 0.0351060964167118, 0.0350582078099251, 0.0350103378295898, 0.0349624902009964, 0.0349146872758865, 0.0348669439554214, 0.0348191820085049, 0.0347714610397816, 0.0347237624228001, 0.0346760824322701, 0.0346284694969654, 0.0345808565616608, 0.0345332846045494, 0.0344857349991798, 0.0344382263720036, 0.0343907400965691, 0.0343432761728764, 0.0342958308756351, 0.0342484302818775, 0.0342010706663132, 0.0341537520289421, 0.0341064557433128, 0.0340591818094254, 0.0340119078755379, 0.0339646972715855, 0.0339174866676331, 0.0338703170418739, 0.0338231921195984, 0.0337760858237743, 0.0337290018796921, 0.0336819402873516, 0.0336349196732044, 0.0335879437625408, 0.0335409864783287, 0.0334940925240517, 0.0334471985697746, 0.0334003269672394, 0.0333534777164459, 0.0333066694438457, 0.0332598835229874, 0.0332131385803223, 0.0331664197146893, 0.0331197157502174, 0.0330730564892292, 0.0330264195799828, 0.0329798012971878, 0.0329332277178764, 0.0328866727650166, 0.0328401625156403, 0.0327936746180058, 0.0327472500503063, 0.0327008217573166, 0.0326544158160686, 0.0326080545783043, 0.0325617156922817, 0.0325153954327106, 0.0324690937995911, 0.0324228368699551, 0.0323766246438026, 0.032330434769392, 0.0322842597961426, 0.0322381108999252, 0.0321920029819012, 0.0321459397673607, 0.032099936157465, 0.0320539362728596, 0.0320079363882542, 0.0319619737565517, 0.0319160372018814, 0.0318701416254044, 0.0318242684006691, 0.0317784138023853, 0.0317326039075851, 0.0316868349909782, 0.0316410697996616, 0.031595341861248, 0.031549658626318, 0.0315039791166782, 0.031458355486393, 0.0314127393066883, 0.0313672013580799, 0.03132164478302, 0.0312761329114437, 0.031230641528964, 0.0311851911246777, 0.0311397630721331, 0.0310943555086851, 0.031048970296979, 0.0310036260634661, 0.0309583246707916, 0.0309130437672138, 0.0308677833527327, 0.0308225676417351, 0.0307773742824793, 0.0307322628796101, 0.0306871104985476, 0.0306419990956783, 0.0305969323962927, 0.0305518861860037, 0.0305068604648113, 0.0304618552327156, 0.0304168928414583, 0.0303719751536846, 0.0303270779550076, 0.030282199382782, 0.03023736551404, 0.0301925521343946, 0.0301477592438459, 0.0301030091941357, 0.0300582833588123, 0.0300136171281338, 0.0299689527601004, 0.0299243088811636, 0.0298797078430653, 0.0298351496458054, 0.0297905895859003, 0.0297460742294788, 0.0297015998512506, 0.0296571273356676, 0.0296126957982779, 0.0295683071017265, 0.0295239184051752, 0.0294795725494623, 0.0294352676719427, 0.0293910484761, 0.0293467864394188, 0.0293025244027376, 0.0292583480477333, 0.029214171692729, 0.0291700381785631, 0.0291259456425905, 0.0290818549692631, 0.0290378034114838, 0.028993796557188, 0.0289497915655375, 0.0289058275520802, 0.028861902654171, 0.0288180224597454, 0.028774144127965, 0.0287302639335394, 0.0286865141242743, 0.0286427177488804, 0.0285989660769701, 0.0285552553832531, 0.0285115465521812, 0.028467919677496, 0.0284242518246174, 0.0283806715160608, 0.0283370893448591, 0.0282935481518507, 0.0282500088214874, 0.0282065086066723, 0.0281630549579859, 0.0281195994466543, 0.0280762705951929, 0.0280329007655382, 0.0279895309358835, 0.0279462449252605, 0.0279029589146376, 0.0278596747666597, 0.0278164744377136, 0.0277732722461224, 0.0277301128953695, 0.0276869554072618, 0.0276438388973475, 0.0276007670909166, 0.0275577362626791, 0.0275147054344416, 0.0274717174470425, 0.0274288132786751, 0.0273858681321144, 0.027342963963747, 0.0273001026362181, 0.0272572841495275, 0.027214465662837, 0.0271716881543398, 0.0271289125084877, 0.0270861778408289, 0.0270434878766537, 0.0270008370280266, 0.0269581880420446, 0.0269155818969011, 0.0268729776144028, 0.0268304534256458, 0.0267879329621792, 0.0267454963177443, 0.0267030168324709, 0.026660580188036, 0.0266181845217943, 0.0265758335590363, 0.026533480733633, 0.0264911726117134, 0.0264488626271486, 0.0264065954834223, 0.0263643711805344, 0.0263221878558397, 0.0262800473719835, 0.0262379087507725, 0.0261958111077547, 0.0261537581682205, 0.026111701503396, 0.0260696895420551, 0.0260276775807142, 0.0259857513010502, 0.0259438212960958, 0.0259018931537867, 0.0258600506931543, 0.025818208232522, 0.0257763657718897, 0.0257346071302891, 0.0256928522139788, 0.0256510935723782, 0.0256094206124544, 0.0255677457898855, 0.0255261175334454, 0.0254845302551985, 0.0254429820924997, 0.025401396676898, 0.0253598913550377, 0.0253183878958225, 0.0252769291400909, 0.0252355076372623, 0.0251941327005625, 0.0251527577638626, 0.0251113809645176, 0.0250700898468494, 0.0250287987291813, 0.0249875523149967, 0.0249463450163603, 0.0249051805585623, 0.0248640179634094, 0.0248228535056114, 0.0247817318886518, 0.0247406549751759, 0.0246996190398932, 0.0246585812419653, 0.0246176291257143, 0.0245766788721085, 0.0245357248932123, 0.0244948174804449, 0.0244539510458708, 0.0244130846112967, 0.0243723019957542, 0.0243315193802118, 0.0242907404899597, 0.024250041693449, 0.0242093876004219, 0.0241686925292015, 0.0241280794143677, 0.0240874662995338, 0.0240468978881836, 0.0240063294768333, 0.0239658001810312, 0.0239253155887127, 0.0238848719745874, 0.0238444302231073, 0.0238040313124657, 0.0237636733800173, 0.023723317310214, 0.0236830431967974, 0.0236427709460258, 0.0236025005578995, 0.0235622692853212, 0.0235220808535814, 0.0234818924218416, 0.0234417915344238, 0.0234016887843609, 0.0233615860342979, 0.0233215242624283, 0.0232815071940422, 0.0232415329664946, 0.0232015550136566, 0.0231616236269474, 0.0231217332184315, 0.0230818428099155, 0.0230420790612698, 0.0230022724717855, 0.0229624677449465, 0.0229227039963007, 0.0228829830884933, 0.0228433050215244, 0.0228036269545555, 0.0227639898657799, 0.0227243974804878, 0.0226848032325506, 0.0226452518254519, 0.0226057432591915, 0.0225662346929312, 0.0225267689675093, 0.0224873851984739, 0.022448007017374, 0.0224086232483387, 0.0223692841827869, 0.0223299469798803, 0.0222906488925219, 0.0222513973712921, 0.0222121849656105, 0.0221730154007673, 0.0221338458359241, 0.0220946781337261, 0.0220555923879147, 0.0220165085047483, 0.0219774655997753, 0.0219384245574474, 0.0218994691967964, 0.0218605101108551, 0.0218215957283974, 0.0217826813459396, 0.0217438098043203, 0.0217049811035395, 0.0216661505401134, 0.0216273628175259, 0.0215886179357767, 0.021549915894866, 0.0215112119913101, 0.0214725118130445, 0.0214338935911655, 0.0213952753692865, 0.0213567428290844, 0.0213182121515274, 0.0212796777486801, 0.0212411880493164, 0.0212027411907911, 0.0211642924696207, 0.0211258865892887, 0.0210875254124403, 0.0210491623729467, 0.0210108831524849, 0.0209725629538298, 0.0209343265742064, 0.0208960920572281, 0.0208579003810883, 0.0208197478204966, 0.02078159712255, 0.0207435321062803, 0.0207054652273655, 0.0206674002110958, 0.0206293761730194, 0.0205913968384266, 0.0205534584820271, 0.0205155182629824, 0.0204776227474213, 0.0204397272318602, 0.0204018726944923, 0.0203640628606081, 0.020326292142272, 0.020288523286581, 0.0202507972717285, 0.0202131569385529, 0.0201754737645388, 0.020137831568718, 0.0201002322137356, 0.0200626328587532, 0.0200251191854477, 0.0199876055121422, 0.0199500899761915, 0.0199126619845629, 0.0198751892894506, 0.0198378041386604, 0.0198004599660635, 0.0197631157934666, 0.0197257697582245, 0.0196885112673044, 0.0196512509137392, 0.0196140334010124, 0.0195768587291241, 0.0195396840572357, 0.0195025522261858, 0.0194654632359743, 0.0194283742457628, 0.0193913262337446, 0.0193542782217264, 0.0193173158913851, 0.0192803535610437, 0.0192433912307024, 0.0192065145820379, 0.0191696360707283, 0.0191328004002571, 0.0190960075706244, 0.0190592147409916, 0.0190224647521973, 0.0189857576042414, 0.0189490485936403, 0.0189123842865229, 0.0188757609575987, 0.0188391376286745, 0.0188025571405888, 0.0187660194933414, 0.0187294818460941, 0.0186930280178785, 0.0186565332114697, 0.0186201222240925, 0.0185837112367153, 0.0185473430901766, 0.0185110177844763, 0.0184747334569693, 0.0184384509921074, 0.0184021666646004, 0.0183659251779318, 0.0183297693729401, 0.0182935707271099, 0.0182574577629566, 0.0182213429361582, 0.0181852709501982, 0.0181492008268833, 0.0181131716817617, 0.0180771853774786, 0.0180412419140339, 0.018005296587944, 0.0179694797843695, 0.0179335791617632, 0.0178977213799953, 0.0178619045764208, 0.0178261287510395, 0.0177903976291418, 0.0177546665072441, 0.0177189763635397, 0.0176832862198353, 0.0176476389169693, 0.0176120344549417, 0.0175764728337526, 0.0175409112125635, 0.0175053924322128, 0.0174699146300554, 0.0174344796687365, 0.0173990447074175, 0.017363652586937, 0.0173282604664564, 0.0172929111868143, 0.0172576028853655, 0.0172223374247551, 0.0171870738267899, 0.0171518512070179, 0.0171166285872459, 0.0170814916491508, 0.0170463528484106, 0.0170112568885088, 0.0169761627912521, 0.0169411096721888, 0.0169061422348022, 0.0168711319565773, 0.0168362054973841, 0.0168012380599976, 0.0167663563042879, 0.0167314726859331, 0.0166966319084167, 0.0166618339717388, 0.0166270360350609, 0.0165922790765762, 0.0165575239807367, 0.0165228527039289, 0.0164881814271212, 0.0164535529911518, 0.0164189245551825, 0.01638438180089, 0.0163498371839523, 0.0163153372704983, 0.0162808354943991, 0.0162463765591383, 0.016211960464716, 0.0161775443702936, 0.0161431711167097, 0.0161088388413191, 0.0160745084285736, 0.0160402189940214, 0.0160059724003077, 0.0159717686474323, 0.015937564894557, 0.0159033611416817, 0.0158692840486765, 0.0158351641148329, 0.0158010870218277, 0.0157670527696609, 0.0157330185174942, 0.0156990271061659, 0.015665078535676, 0.015631128102541, 0.0155972214415669, 0.0155633566901088, 0.0155295338481665, 0.0154957119375467, 0.0154619319364429, 0.0154281528666615, 0.0153944585472345, 0.0153607632964849, 0.0153271118178964, 0.0152935013175011, 0.0152598908171058, 0.0152262803167105, 0.015192755497992, 0.0151592316105962, 0.0151257487013936, 0.015092265792191, 0.0150588257238269, 0.0150254284963012, 0.0149920722469687, 0.0149587169289589, 0.0149254044517875, 0.0148921338841319, 0.0148589052259922, 0.0148256774991751, 0.0147924926131964, 0.0147593067958951, 0.0147261638194323, 0.0146930627524853, 0.0146599616855383, 0.0146269463002682, 0.0145939299836755, 0.0145609145984054, 0.0145279411226511, 0.0144950104877353, 0.0144621217623353, 0.0144292339682579, 0.0143964290618896, 0.0143636269494891, 0.0143308639526367, 0.0142981028184295, 0.0142653854563832, 0.0142326662316918, 0.0141999898478389, 0.0141673563048244, 0.0141347637400031, 0.014102173037827, 0.0140696233138442, 0.0140371173620224, 0.014004610478878, 0.0139721464365721, 0.0139397252351046, 0.0139073031023145, 0.0138749666512012, 0.0138426283374429, 0.0138103356584907, 0.0137780401855707, 0.0137457894161344, 0.0137135796248913, 0.0136813698336482, 0.013649201951921, 0.0136170359328389, 0.013584952801466, 0.0135528706014156, 0.0135208312422037, 0.0134887909516692, 0.0134568363428116, 0.0134248808026314, 0.0133929690346122, 0.0133610563352704, 0.0133291864767671, 0.0132973594591022, 0.0132655315101147, 0.0132337464019656, 0.0132019612938166, 0.0131702600046992, 0.0131385596469045, 0.0131069021299481, 0.0130752446129918, 0.0130436290055513, 0.0130120562389493, 0.0129805263131857, 0.0129489945247769, 0.0129175493493676, 0.0128860613331199, 0.0128546580672264, 0.012823254801333, 0.0127918515354395, 0.0127605330199003, 0.0127292154356837, 0.012697939760983, 0.0126666622236371, 0.0126354722306132, 0.0126042384654284, 0.0125730894505978, 0.0125419413670897, 0.0125108351930976, 0.0124798137694597, 0.012448750436306, 0.0124177290126681, 0.0123867494985461, 0.0123557709157467, 0.0123248342424631, 0.012293940410018, 0.0122630465775728, 0.0122321955859661, 0.0122013865038753, 0.0121706193313003, 0.0121398530900478, 0.0121091287583113, 0.0120784463360906, 0.0120477648451924, 0.0120171252638102, 0.0119865713641047, 0.0119559736922383, 0.0119254617020488, 0.0118949078023434, 0.0118644377216697, 0.011833967640996, 0.0118035404011607, 0.011773114092648, 0.0117427725344896, 0.0117124291136861, 0.0116820875555277, 0.0116517879068851, 0.0116215301677585, 0.0115913152694702, 0.0115611841902137, 0.0115310112014413, 0.0115008819848299, 0.0114707518368959, 0.0114406635984778, 0.0114106191322207, 0.0113806165754795, 0.0113506130874157, 0.0113206524401903, 0.0112906927242875, 0.011260817758739, 0.0112309409305453, 0.0112011088058352, 0.01117127481848, 0.0111414846032858, 0.0111117782071233, 0.0110820736736059, 0.0110523672774434, 0.0110227037221193, 0.0109930401667953, 0.010963462293148, 0.0109338844195008, 0.0109043046832085, 0.0108748115599155, 0.0108453175053, 0.0108158243820071, 0.0107864160090685, 0.0107570076361299, 0.0107276402413845, 0.0106982747092843, 0.0106689939275384, 0.0106397122144699, 0.0106104733422399, 0.0105812344700098, 0.0105520375072956, 0.0105228833854198, 0.0104937301948667, 0.0104646179825068, 0.0104355486109853, 0.0104064801707864, 0.0103774517774582, 0.0103484680876136, 0.0103195253759623, 0.0102905845269561, 0.0102616846561432, 0.0102328704670072, 0.0102040134370327, 0.0101751983165741, 0.0101464269682765, 0.0101176546886563, 0.0100889252498746, 0.0100602377206087, 0.0100315501913428, 0.0100029055029154, 0.00997430272400379, 0.00994574278593063, 0.00991718284785748, 0.00988866575062275, 0.00986014772206545, 0.00983171537518501, 0.00980328302830458, 0.00977489259094, 0.00974654406309128, 0.00971819739788771, 0.00968989171087742, 0.00966158602386713, 0.00963332317769527, 0.00960510224103928, 0.00957692507654428, 0.00954874698072672, 0.00952061079442501, 0.00949251744896173, 0.00946442503482103, 0.00943637453019619, 0.0094083659350872, 0.00938039924949408, 0.0093524344265461, 0.0093245105817914, 0.00929658673703671, 0.00926870573312044, 0.00924086757004261, 0.00921307131648064, 0.00918527506291866, 0.00915752165019512, 0.00912981014698744, 0.00910209957510233, 0.00907443091273308, 0.00904680415987968, 0.00901917740702629, 0.0089915944263339, 0.0089640524238348, 0.00893655326217413, 0.00890909694135189, 0.00888159777969122, 0.00885418336838484, 0.00882681179791689, 0.00879939738661051, 0.00877206865698099, 0.0087447389960289, 0.00871745217591524, 0.00869020726531744, 0.00866300612688065, 0.00863580405712128, 0.00860860198736191, 0.00858148466795683, 0.00855441018939018, 0.00852733477950096, 0.00850026030093431, 0.00847327057272196, 0.0084462808445096, 0.00841929111629725, 0.00839238613843918, 0.00836548116058111, 0.00833857618272305, 0.00831175688654184, 0.00828493665903807, 0.00825815927237272, 0.0082313809543848, 0.00820464547723532, 0.00817795284092426, 0.00815130304545164, 0.00812469515949488, 0.00809808727353811, 0.00807152129709721, 0.00804495625197887, 0.0080184331163764, 0.00799195282161236, 0.00796547159552574, 0.00793903414160013, 0.00791263859719038, 0.00788628496229649, 0.00785993132740259, 0.00783362053334713, 0.00780731020495296, 0.00778108416125178, 0.00775490049272776, 0.00772867491468787, 0.00770253362134099, 0.00767639232799411, 0.00765025150030851, 0.00762419542297721, 0.00759813887998462, 0.00757212517783046, 0.00754611194133759, 0.00752014061436057, 0.0074942116625607, 0.00746832462027669, 0.00744243850931525, 0.00741659430786967, 0.00739079341292381, 0.00736503396183252, 0.00733927497640252, 0.00731355836614966, 0.00728788366541266, 0.00726220943033695, 0.00723657757043839, 0.00721094617620111, 0.0071853562258184, 0.00715980958193541, 0.00713430484756827, 0.00710880057886243, 0.00708333821967244, 0.00705791870132089, 0.00703249918296933, 0.00700716441497207, 0.0069818296469748, 0.00695649487897754, 0.00693120248615742, 0.00690595246851444, 0.0068807452917099, 0.00685553764924407, 0.00683037238195539, 0.00680520758032799, 0.00678012706339359, 0.00675504701212049, 0.00673000980168581, 0.00670497165992856, 0.00667997682467103, 0.00665502389892936, 0.00663007097318769, 0.00660524563863873, 0.00658033508807421, 0.00655550928786397, 0.00653068395331502, 0.00650590099394321, 0.00648115994408727, 0.00645641935989261, 0.00643172115087509, 0.00640706578269601, 0.00638240994885564, 0.00635779649019241, 0.00633322540670633, 0.00630865478888154, 0.00628416892141104, 0.00625968258827925, 0.0062352386303246, 0.00621079513803124, 0.00618639448657632, 0.00616203574463725, 0.0061376765370369, 0.00611336017027497, 0.00608908664435148, 0.0060648126527667, 0.0060406238771975, 0.00601639226078987, 0.00599224586039782, 0.00596809946000576, 0.00594399543479085, 0.00591989094391465, 0.00589587213471532, 0.00587185239419341, 0.00584787596017122, 0.00582389906048775, 0.00580000691115856, 0.00577607285231352, 0.00575222307816148, 0.00572837376967072, 0.00570452446117997, 0.00568075990304351, 0.00565699487924576, 0.00563327269628644, 0.00560955051332712, 0.00558591308072209, 0.00556227611377835, 0.00553868152201176, 0.00551512883976102, 0.00549157662317157, 0.00546806678175926, 0.00544455647468567, 0.00542108900845051, 0.00539766391739249, 0.00537423882633448, 0.00535089848563075, 0.00532755814492702, 0.00530421826988459, 0.00528092030435801, 0.00525766471400857, 0.00523445196449757, 0.00521123921498656, 0.00518806837499142, 0.00516498275101185, 0.00514185475185513, 0.005118811968714, 0.00509572587907314, 0.00507272547110915, 0.00504972413182259, 0.00502676609903574, 0.00500380806624889, 0.00498093431815505, 0.00495806103572249, 0.00493518775328994, 0.00491239875555038, 0.00488961068913341, 0.00486686453223228, 0.00484416075050831, 0.00482145696878433, 0.00479879602789879, 0.0047761769965291, 0.00475355796515942, 0.00473098177462816, 0.00470840511843562, 0.00468591367825866, 0.00466342223808169, 0.00464093079790473, 0.00461852410808206, 0.00459611788392067, 0.00457371072843671, 0.00455138925462961, 0.00452906731516123, 0.00450678821653128, 0.00448455102741718, 0.00446231430396438, 0.00444011995568871, 0.0044179679825902, 0.00439581600949168, 0.00437370641157031, 0.00435163918882608, 0.00432957196608186, 0.00430754758417606, 0.00428556511178613, 0.00426362548023462, 0.00424168538302183, 0.00421978812664747, 0.00419789040461183, 0.00417607789859176, 0.00415430823341012, 0.00413249572739005, 0.00411072513088584, 0.00408899784088135, 0.004067312926054, 0.00404562707990408, 0.00402398454025388, 0.00400238437578082, 0.00398082658648491, 0.00395926833152771, 0.00393775291740894, 0.00391623750329018, 0.00389476446434855, 0.00387333403341472, 0.00385198812000453, 0.00383060006424785, 0.0038092543836683, 0.00378795107826591, 0.00376664777286351, 0.0037453870754689, 0.00372416875325143, 0.00370299257338047, 0.00368181662634015, 0.00366068328730762, 0.00363959209062159, 0.00361850089393556, 0.00359745230525732, 0.00357640371657908, 0.00355544011108577, 0.00353447627276182, 0.00351355480961502, 0.003492675954476, 0.00347179686650634, 0.00345096061937511, 0.00343012413941324, 0.00340933003462851, 0.00338857853785157, 0.00336786918342113, 0.00334716029465199, 0.00332649354822934, 0.00330582680180669, 0.00328524480573833, 0.00326466304250062, 0.00324408104643226, 0.00322362640872598, 0.0032031296286732, 0.00318267522379756, 0.00316222058609128, 0.00314185093156993, 0.00312148104421794, 0.0031011113896966, 0.00308078434318304, 0.00306049967184663, 0.00304025714285672, 0.00302001461386681, 0.00299981492571533, 0.00297965737991035, 0.00295949983410537, 0.00293938489630818, 0.0029193121008575, 0.00289932452142239, 0.00287929456681013, 0.00285930652171373, 0.00283931894227862, 0.00281941588036716, 0.00279951328411698, 0.00277961045503616, 0.00275979237630963, 0.00273997453041375, 0.00272015621885657, 0.00270042312331498, 0.00268069026060402, 0.00266099954023957, 0.00264130881987512, 0.00262174545787275, 0.00260213972069323, 0.00258253398351371, 0.0025629703886807, 0.00254344940185547, 0.00252397102303803, 0.00250449264422059, 0.00248505640774965, 0.00246566301211715, 0.00244631175883114, 0.00242696050554514, 0.00240760925225914, 0.00238834298215806, 0.00236907671205699, 0.00234985281713307, 0.00233067129738629, 0.0023115323856473, 0.00229239347390831, 0.00227329693734646, 0.00225420040078461, 0.00223514623939991, 0.002216134686023, 0.00219712289981544, 0.00217815348878503, 0.00215922691859305, 0.00214034249074757, 0.00212145806290209, 0.00210261601023376, 0.00208381656557322, 0.00206501712091267, 0.00204630242660642, 0.00202758796513081, 0.00200887327082455, 0.00199020095169544, 0.00197157124057412, 0.00195294141303748, 0.0019343540770933, 0.00191580934915692, 0.00189730687998235, 0.00187880429439247, 0.00186034443322569, 0.00184188445564359, 0.00182350934483111, 0.00180513423401862, 0.00178675889037549, 0.00176846876274794, 0.00175022089388222, 0.00173193076625466, 0.00171372527256608, 0.00169551989529282, 0.00167735700961202, 0.00165919400751591, 0.0016411158721894, 0.00162303785327822, 0.00160500220954418, 0.00158696656581014, 0.00156897341366857, 0.00155102252028883, 0.0015330717433244, 0.00151516345795244, 0.00149733992293477, 0.0014794742455706, 0.00146165071055293, 0.00144386955071241, 0.00142613111529499, 0.00140839256346226, 0.00139069638680667, 0.00137304270174354, 0.00135538901668042, 0.00133777770679444, 0.00132020877208561, 0.00130264007020742, 0.00128511351067573, 0.00126762955915183, 0.00125014572404325, 0.0012327041476965, 0.00121534755453467, 0.00119799084495753, 0.00118063425179571, 0.00116332003381103, 0.0011460481910035, 0.00112877646461129, 0.00111154711339623, 0.00109436025377363, 0.00107717327773571, 0.00106007128488272, 0.00104292680043727, 0.00102586718276143, 0.00100880756508559, 0.000991832930594683, 0.000974815688095987, 0.000957883370574564, 0.000940951169468462, 0.000924018851947039, 0.000907171459402889, 0.000890324008651078, 0.000873476616106927, 0.000856714090332389, 0.00083995156455785, 0.000823231472168118, 0.000806511379778385, 0.000789833720773458, 0.000773198436945677, 0.000756605702918023, 0.000740012910682708, 0.000723504985217005, 0.000706997059751302, 0.00069048919249326, 0.000674023642204702, 0.000657600641716272, 0.000641177641227841, 0.000624839449301362, 0.000608458823990077, 0.000592163123656064, 0.000575867365114391, 0.000559614098165184, 0.000543360773008317, 0.000527192372828722, 0.000511023972649127, 0.000494897947646677, 0.000478814385132864, 0.000462730880826712, 0.000446647318312898, 0.000430648622568697, 0.000414649955928326, 0.000398693751776591, 0.000382737489417195, 0.000366866122931242, 0.000350952323060483, 0.000335123419063166, 0.000319294456858188, 0.000303507986245677, 0.000287763919914141, 0.000272062316071242, 0.000256360712228343, 0.000240701527218334, 0.000225084775593132, 0.000209468038519844, 0.000193893734831363, 0.000178319431142882, 0.000162830008775927, 0.000147298138472252, 0.000131851134938188, 0.000116404138680082, 0.000100999583082739, 8.5637453594245e-05, 7.0275338657666e-05, 5.49556534679141e-05, 3.96784053009469e-05, 2.44435959757539e-05, 9.25122185435612e-06, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353, 0.0025141779333353   }, 
   { 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 2.39756169731237e-15, 6.32413957646349e-07, 1.90317075521307e-06, 3.17293938678631e-06, 4.4402377170627e-06, 5.70852444070624e-06, 6.97557561579742e-06, 8.24287326395279e-06, 9.50943103816826e-06, 1.07754949567607e-05, 1.20385930131306e-05, 1.33019384520594e-05, 1.45660251291702e-05, 1.58293714775937e-05, 1.70919756783405e-05, 1.83528500201646e-05, 1.96119981410448e-05, 2.08726269192994e-05, 2.21325135498773e-05, 2.33919072343269e-05, 2.46495692408644e-05, 2.5906492737704e-05, 2.71626740868669e-05, 2.84193502011476e-05, 2.96755333693e-05, 3.09297356579918e-05, 3.21832012559753e-05, 3.34374090016354e-05, 3.46893903042655e-05, 3.59421101165935e-05, 3.7193105526967e-05, 3.84443483198993e-05, 3.96941031794995e-05, 4.09441090596374e-05, 4.21923868998419e-05, 4.34401699749287e-05, 4.46882004325744e-05, 4.59345028502867e-05, 4.71810453746002e-05, 4.84273441543337e-05, 4.96716711495537e-05, 5.09152559970971e-05, 5.21590845892206e-05, 5.34014325239696e-05, 5.46442752238363e-05, 5.58853862457909e-05, 5.71257587580476e-05, 5.83663750148844e-05, 5.96052632317878e-05, 6.08448972343467e-05, 6.20825521764345e-05, 6.33206946076825e-05, 6.45581021672115e-05, 6.57925484119914e-05, 6.7028719058726e-05, 6.82631580275483e-05, 6.94980990374461e-05, 7.07320432411507e-05, 7.19642630429007e-05, 7.3195988079533e-05, 7.44269709684886e-05, 7.56586960051209e-05, 7.68894387874752e-05, 7.81184426159598e-05, 7.93479412095621e-05, 8.05744857643731e-05, 8.18027547211386e-05, 8.3030026871711e-05, 8.42558220028877e-05, 8.54821118991822e-05, 8.67074122652411e-05, 8.79302533576265e-05, 8.91543095349334e-05, 9.0376655862201e-05, 9.159972978523e-05, 9.28218141780235e-05, 9.40434183576144e-05, 9.52620539464988e-05, 9.64809296419844e-05, 9.77007948677056e-05, 9.89194304565899e-05, 0.000100137811386958, 0.000101354220532812, 0.000102568657894153, 0.00010378505976405, 0.000105000486655626, 0.00010621540423017, 0.000107428604678717, 0.000108641062979586, 0.000109853026515339, 0.000111064982775133, 0.000112276698928326, 0.000113486443297006, 0.000114695685624611, 0.00011590542999329, 0.000117112940642983, 0.000118321200716309, 0.000119527729111724, 0.000120734504889697, 0.000121940036478918, 0.000123145335237496, 0.000124349389807321, 0.000125552454846911, 0.000126756014651619, 0.000127959094243124, 0.000129160180222243, 0.000130362008349039, 0.000131560635054484, 0.000132760746055283, 0.000133960595121607, 0.000135158479679376, 0.000136356844450347, 0.000137553244712763, 0.000138750154292211, 0.000139945550472476, 0.000141139986226335, 0.000142335149575956, 0.000143528333865106, 0.000144721765536815, 0.000145914949825965, 0.000147104932693765, 0.00014829688007012, 0.000149486601003446, 0.000150676831253804, 0.000151866814121604, 0.000153054555994458, 0.00015424181765411, 0.000155428584548645, 0.000156615336891264, 0.000157801870955154, 0.000158986396854743, 0.00016017169400584, 0.000161354735610075, 0.000162537297001109, 0.000163720367709175, 0.000164901692187414, 0.000166083525982685, 0.000167264355695806, 0.000168442726135254, 0.000169622318935581, 0.000170800441992469, 0.000171978797880001, 0.000173156440723687, 0.00017433257016819, 0.000175507972016931, 0.000176682384335436, 0.000177857786184177, 0.000179031951120123, 0.000180204646312632, 0.000181377807166427, 0.000182548028533347, 0.000183719967026263, 0.000184890915988944, 0.000186060147825629, 0.000187230107258074, 0.000188398102181964, 0.000189565602340735, 0.000190733087947592, 0.000191899103811011, 0.000193065861822106, 0.000194230393390171, 0.000195395667105913, 0.000196558961761184, 0.000197721514268778, 0.000198884808924049, 0.000200047114049084, 0.000201208182261325, 0.000202369265025482, 0.00020352860155981, 0.000204687457880937, 0.000205846299650148, 0.000207004908588715, 0.00020816178584937, 0.000209319143323228, 0.000210473299375735, 0.000211628925171681, 0.000212784318136983, 0.000213937732041813, 0.000215091640711762, 0.000216243832255714, 0.000217396256630309, 0.000218546949326992, 0.000219697161810473, 0.000220847854507156, 0.000221996568143368, 0.000223145543714054, 0.000224293034989387, 0.000225440031499602, 0.000226587260840461, 0.000227732773055322, 0.000228878518100828, 0.000230023782933131, 0.000231167316087522, 0.000232310121646151, 0.000233452417887747, 0.000234594699577428, 0.000235736748436466, 0.000236876832786947, 0.000238017644733191, 0.000239156230236404, 0.000240294582908973, 0.000241433168412186, 0.000242570036789402, 0.000243707385379821, 0.000244843773543835, 0.000245977658778429, 0.000247113057412207, 0.000248246447881684, 0.000249380595050752, 0.000250513752689585, 0.000251645193202421, 0.000252776109846309, 0.000253906298894435, 0.00025503701181151, 0.000256166938925162, 0.000257295148912817, 0.000258423882769421, 0.000259549618931487, 0.000260677072219551, 0.000261803565081209, 0.000262928573647514, 0.000264054076978937, 0.000265177601249889, 0.000266300630755723, 0.000267423660261557, 0.000268545467406511, 0.00026966750738211, 0.000270788790658116, 0.0002719086187426, 0.000273027195362374, 0.000274145539151505, 0.000275264348601922, 0.000276382197625935, 0.000277499784715474, 0.000278615392744541, 0.000279729050816968, 0.000280844658846036, 0.000281959306448698, 0.000283073430182412, 0.000284185574855655, 0.000285297282971442, 0.000286408438114449, 0.000287519593257457, 0.000288630544673651, 0.000289739487925544, 0.000290847674477845, 0.000291956617729738, 0.000293064600555226, 0.00029417106998153, 0.000295276549877599, 0.00029638153500855, 0.000297487305942923, 0.000298591796308756, 0.000299694831483066, 0.000300797342788428, 0.00030189985409379, 0.000303001172142103, 0.000304102431982756, 0.000305203488096595, 0.000306302274111658, 0.000307400623569265, 0.000308498449157923, 0.000309596536681056, 0.000310694129439071, 0.000311789714032784, 0.000312885851599276, 0.000313980446662754, 0.000315074081299827, 0.000316168210702017, 0.00031726059387438, 0.000318353500915691, 0.000319445651257411, 0.000320535065839067, 0.000321625993819907, 0.000322714913636446, 0.000323804357321933, 0.000324893306242302, 0.000325980508932844, 0.000327066954923794, 0.000328152702422813, 0.000329238653648645, 0.000330324401147664, 0.000331408140482381, 0.000332492374582216, 0.000333573669195175, 0.000334656680934131, 0.000335738935973495, 0.000336819241056219, 0.000337900244630873, 0.000338979327352718, 0.000340057886205614, 0.000341136706992984, 0.00034221401438117, 0.000343291583703831, 0.00034436842543073, 0.000345443550031632, 0.000346518150763586, 0.000347592023899779, 0.000348666129866615, 0.000349739741068333, 0.000350811664247885, 0.000351884023984894, 0.000352953211404383, 0.000354024348780513, 0.000355094496626407, 0.000356164178811014, 0.000357232114765793, 0.000358299323124811, 0.000359365774784237, 0.000360432750312611, 0.000361499201972038, 0.000362563703674823, 0.000363627419574186, 0.000364691892173141, 0.000365754385711625, 0.000366817403119057, 0.000367878674296662, 0.000368939188774675, 0.000370000227121636, 0.000371060508769006, 0.000372119044186547, 0.000373177143046632, 0.000374235154595226, 0.000375292001990601, 0.000376348820282146, 0.000377405376639217, 0.000378458760678768, 0.000379513861844316, 0.000380568206310272, 0.000381620833650231, 0.000382673926651478, 0.000383725069696084, 0.000384776736609638, 0.000385826861020178, 0.000386876054108143, 0.000387925945688039, 0.000388973858207464, 0.000390022032661363, 0.000391069974284619, 0.000392114685382694, 0.000393161142710596, 0.000394205853808671, 0.00039525082684122, 0.000396295276004821, 0.000397338037146255, 0.000398380041588098, 0.000399421318434179, 0.000400463060941547, 0.000401504308683798, 0.000402543606469408, 0.000403583369916305, 0.000404620193876326, 0.000405658734962344, 0.000406696548452601, 0.00040773261571303, 0.000408768915804103, 0.000409804750233889, 0.000410837586969137, 0.000411872199038044, 0.000412904802942649, 0.000413938163546845, 0.000414970534620807, 0.000416001188568771, 0.000417031318647787, 0.000418060750234872, 0.000419090618379414, 0.000420119496993721, 0.000421146978624165, 0.000422174838604406, 0.000423199817305431, 0.000424226513132453, 0.00042525221942924, 0.000426276179496199, 0.00042730089626275, 0.00042832363396883, 0.000429345876909792, 0.000430368061643094, 0.000431388849392533, 0.00043241007369943, 0.000433429609984159, 0.000434449641034007, 0.000435467663919553, 0.000436484988313168, 0.000437503011198714, 0.000438520073657855, 0.000439535622717813, 0.000440551433712244, 0.000441565789515153, 0.000442579126683995, 0.000443592958617955, 0.000444605306256562, 0.000445617653895169, 0.000446628546342254, 0.000447638652985916, 0.000448649283498526, 0.000449659186415374, 0.000450667343102396, 0.000451675005024299, 0.000452682928880677, 0.000453690096037462, 0.000454695778898895, 0.000455700472230092, 0.000456704670796171, 0.000457709393231198, 0.000458713329862803, 0.000459715578472242, 0.000460717041278258, 0.000461717776488513, 0.000462719268398359, 0.000463719799881801, 0.000464719778392464, 0.00046571803977713, 0.000466714584035799, 0.000467712612589821, 0.000468709651613608, 0.000469706457806751, 0.000470701284939423, 0.000471696577733383, 0.00047268919297494, 0.000473683001473546, 0.000474676577141508, 0.00047566820285283, 0.000476660061394796, 0.000477651425171643, 0.000478640053188428, 0.000479629932669923, 0.000480618327856064, 0.000481606955872849, 0.000482594856293872, 0.000483581272419542, 0.000484566960949451, 0.000485551892779768, 0.000486537057440728, 0.000487521989271045, 0.000488505000248551, 0.000489488418679684, 0.000490468868520111, 0.000491450889967382, 0.000492432329338044, 0.000493411847855896, 0.000494392064865679, 0.000495370361022651, 0.000496348133310676, 0.000497326138429344, 0.000498302455525845, 0.000499279238283634, 0.000500254274811596, 0.000501229602377862, 0.000502203125506639, 0.000503176241181791, 0.000504149822518229, 0.000505122414324433, 0.000506093725562096, 0.00050706509500742, 0.000508033728692681, 0.000509003817569464, 0.000509973207954317, 0.000510942074470222, 0.000511908961925656, 0.000512875383719802, 0.000513841048814356, 0.000514807237777859, 0.000515772611834109, 0.000516736530698836, 0.000517699518240988, 0.000518662971444428, 0.000519625900778919, 0.00052058685105294, 0.000521547393873334, 0.000522507121786475, 0.000523467373568565, 0.000524426810443401, 0.000525384559296072, 0.000526341609656811, 0.000527298136148602, 0.000528254895471036, 0.000529211189132184, 0.000530166726093739, 0.000531120516825467, 0.000532073609065264, 0.000533026177436113, 0.000533978745806962, 0.000534931081347167, 0.000535881670657545, 0.000536832259967923, 0.000537781626917422, 0.000538730004336685, 0.000539678847417235, 0.000540626002475619, 0.000541573623195291, 0.000542520545423031, 0.000543464673683047, 0.000544410140719265, 0.000545354036148638, 0.000546298222616315, 0.000547241885215044, 0.000548183568753302, 0.000549124786630273, 0.000550065538845956, 0.000551006232853979, 0.000551946461200714, 0.000552885176148266, 0.000553823949303478, 0.000554760219529271, 0.000555697944946587, 0.000556634739041328, 0.000557570019736886, 0.000558505766093731, 0.000559439591597766, 0.000560372893232852, 0.000561306194867939, 0.00056223850697279, 0.000563170819077641, 0.000564101152122021, 0.000565032009035349, 0.000565961352549493, 0.000566889706533402, 0.000567819050047547, 0.000568747462239116, 0.000569673837162554, 0.000570600212085992, 0.000571525597479194, 0.000572451506741345, 0.000573375902604312, 0.000574298843275756, 0.000575222773477435, 0.000576144200749695, 0.000577066617552191, 0.000577988103032112, 0.000578907551243901, 0.000579827988985926, 0.00058074650587514, 0.000581664964556694, 0.000582583423238248, 0.000583499961066991, 0.000584416440688074, 0.000585331988986582, 0.000586247537285089, 0.000587162037845701, 0.000588075548876077, 0.000588989118114114, 0.00058990070829168, 0.00059081322979182, 0.000591724819969386, 0.000592634431086481, 0.00059354497352615, 0.000594454584643245, 0.000595362216699868, 0.000596270314417779, 0.000597176898736507, 0.000598083541262895, 0.000598990183789283, 0.000599895778577775, 0.000600799452513456, 0.000601702660787851, 0.00060260680038482, 0.000603508960921317, 0.000604411645326763, 0.000605312292464077, 0.000606212532147765, 0.000607112247962505, 0.000608011905569583, 0.000608910690061748, 0.000609807902947068, 0.000610704650171101, 0.000611601339187473, 0.000612498086411506, 0.000613393902312964, 0.000614287157077342, 0.000615181925240904, 0.000616074772551656, 0.000616967561654747, 0.000617859768681228, 0.000618750636931509, 0.000619640981312841, 0.000620530743617564, 0.000621420564129949, 0.00062230892945081, 0.000623196829110384, 0.000624084612354636, 0.000624971464276314, 0.00062585633713752, 0.000626742257736623, 0.000627626664936543, 0.000628510548267514, 0.000629394431598485, 0.000630276394076645, 0.000631158822216094, 0.000632039271295071, 0.000632920127827674, 0.000633800576906651, 0.000634679570794106, 0.000635559030342847, 0.000636435986962169, 0.00063731346745044, 0.00063819094793871, 0.000639065925497562, 0.000639941950794309, 0.000640815938822925, 0.000641689985059202, 0.000642563973087817, 0.000643435982055962, 0.000644308049231768, 0.000645179068669677, 0.000646050670184195, 0.00064692075829953, 0.00064778933301568, 0.000648658839054406, 0.000649526948109269, 0.00065039360197261, 0.000651261187158525, 0.00065212621120736, 0.000652991875540465, 0.000653857016004622, 0.000654720177408308, 0.000655584270134568, 0.000656446442008018, 0.000657308555673808, 0.000658170785754919, 0.000659031968098134, 0.000659891113173217, 0.000660749792587012, 0.000661609519738704, 0.000662467733491212, 0.000663325423374772, 0.000664181658066809, 0.000665036903228611, 0.000665893137920648, 0.000666748383082449, 0.000667602638714015, 0.000668455380946398, 0.000669307657517493, 0.000670159934088588, 0.000671011744998395, 0.000671863555908203, 0.000672712340019643, 0.000673561706207693, 0.00067441095598042, 0.000675258750561625, 0.000676107127219439, 0.00067695346660912, 0.00067780032986775, 0.000678644690196961, 0.000679490040056407, 0.000680334400385618, 0.000681177247315645, 0.000682020676322281, 0.000682863057591021, 0.000683703983668238, 0.000684545433614403, 0.000685384846292436, 0.000686224782839417, 0.000687064195517451, 0.000687901629135013, 0.000688739062752575, 0.000689575565047562, 0.000690412474796176, 0.000691247987560928, 0.000692082510795444, 0.000692917499691248, 0.000693749985657632, 0.000694583461154252, 0.000695416005328298, 0.000696246570441872, 0.000697078066878021, 0.000697908108122647, 0.000698737683705986, 0.000699567201081663, 0.00070039473939687, 0.000701222335919738, 0.00070204894291237, 0.000702875549905002, 0.000703701109159738, 0.000704525737091899, 0.00070535036502406, 0.000706173945218325, 0.000706996594090015, 0.000707819708622992, 0.00070864032022655, 0.000709461572114378, 0.000710282707586884, 0.000711101340129972, 0.000711920554749668, 0.000712738721631467, 0.000713556364644319, 0.000714373600203544, 0.000715189264155924, 0.000716004986315966, 0.000716819777153432, 0.000717634451575577, 0.000718448252882808, 0.000719260948244482, 0.000720073760021478, 0.000720884534530342, 0.000721695774700493, 0.000722507073078305, 0.000723315344657749, 0.000724125129636377, 0.000724932935554534, 0.000725740741472691, 0.000726548605598509, 0.00072735536377877, 0.000728159677237272, 0.000728965562302619, 0.000729769410099834, 0.000730573257897049, 0.000731376640032977, 0.000732178508769721, 0.000732980901375413, 0.000733782246243209, 0.000734582194127142, 0.000735381618142128, 0.000736180518288165, 0.000736979418434203, 0.000737776863388717, 0.000738573842681944, 0.000739370763767511, 0.000740165240131319, 0.000740961113478988, 0.000741756113711745, 0.000742549076676369, 0.000743342563509941, 0.000744134595151991, 0.00074492662679404, 0.000745718134567142, 0.000746507663279772, 0.000747297657653689, 0.000748086196836084, 0.000748875259887427, 0.000749663799069822, 0.000750449893530458, 0.000751236919313669, 0.000752021966036409, 0.000752807594835758, 0.000753592175897211, 0.000754375767428428, 0.000755158835090697, 0.000755940971430391, 0.000756723049562424, 0.000757504196371883, 0.000758284411858767, 0.000759065034799278, 0.000759844144340605, 0.000760622322559357, 0.000761400500778109, 0.000762176641728729, 0.000762953830417246, 0.000763730029575527, 0.000764504307880998, 0.000765279517509043, 0.000766052689868957, 0.000766825920436531, 0.000767599151004106, 0.000768370402511209, 0.000769141654018313, 0.000769911915995181, 0.000770682177972049, 0.000771451450418681, 0.000772219733335078, 0.000772987958043814, 0.0007737543201074, 0.000774521555285901, 0.000775287917349488, 0.000776052242144942, 0.000776817032601684, 0.000777580891735852, 0.000778344227001071, 0.000779107154812664, 0.000779868452809751, 0.00078062986722216, 0.000781391165219247, 0.000782150600571185, 0.000782909977715462, 0.000783667899668217, 0.000784426287282258, 0.000785183685366064, 0.00078594108344987, 0.000786696560680866, 0.000787451048381627, 0.000788205943536013, 0.000788960431236774, 0.000789713871199638, 0.000790465855970979, 0.000791217316873372, 0.000791968777775764, 0.000792719831224531, 0.000793470302596688, 0.000794218853116035, 0.000794966879766434, 0.000795715372078121, 0.00079646339872852, 0.000797209911979735, 0.000797955493908376, 0.000798700610175729, 0.000799445144366473, 0.000800189736764878, 0.000800933281425387, 0.000801675370894372, 0.000802417984232306, 0.000803159084171057, 0.00080389971844852, 0.000804640294518322, 0.000805378949735314, 0.000806117604952306, 0.000806856201961637, 0.000807593401987106, 0.000808330078143626, 0.000809065764769912, 0.000809801451396197, 0.000810536614153534, 0.0008112697978504, 0.000812003971077502, 0.000812735699582845, 0.000813468417618424, 0.000814200146123767, 0.000814929895568639, 0.000815660634543747, 0.000816389394458383, 0.000817118620034307, 0.000817846914287657, 0.000818574160803109, 0.000819300941657275, 0.000820026267319918, 0.000820752524305135, 0.00082147732609883, 0.000822200672701001, 0.000822924950625747, 0.000823646783828735, 0.000824369199108332, 0.000825091497972608, 0.000825811410322785, 0.00082653173012659, 0.000827252108138055, 0.0008279699832201, 0.000828688382171094, 0.000829405267722905, 0.000830122153274715, 0.000830839038826525, 0.000831554003525525, 0.000832268851809204, 0.000832982361316681, 0.000833696802146733, 0.000834409263916314, 0.000835122191347182, 0.000835833139717579, 0.00083654309855774, 0.00083725358126685, 0.000837964122183621, 0.000838672567624599, 0.00083938060561195, 0.000840087595861405, 0.000840794644318521, 0.000841501168906689, 0.000842207169625908, 0.000842911191284657, 0.000843614805489779, 0.000844318827148527, 0.000845022441353649, 0.000845724542159587, 0.000846426060888916, 0.000847127172164619, 0.000847826770041138, 0.000848526891786605, 0.000849225500132889, 0.000849923584610224, 0.000850621785502881, 0.000851317425258458, 0.00085201405454427, 0.000852710218168795, 0.000853404868394136, 0.00085409905295819, 0.000854793179314584, 0.000855485908687115, 0.000856178114190698, 0.000856869330164045, 0.000857560487929732, 0.000858251238241792, 0.000858940475154668, 0.000859629712067544, 0.000860316911712289, 0.000861005217302591, 0.000861692940816283, 0.000862378219608217, 0.0008630640222691, 0.000863748835399747, 0.000864433124661446, 0.000865117355715483, 0.000865799724124372, 0.0008664820343256, 0.000867163354996592, 0.000867845141328871, 0.000868525530677289, 0.000869204406626523, 0.000869884213898331, 0.000870561576448381, 0.000871239928528666, 0.000871917291078717, 0.000872592674568295, 0.000873268640134484, 0.00087394448928535, 0.000874617951922119, 0.000875291822012514, 0.000875964760780334, 0.000876637175679207, 0.000877309124916792, 0.000877980084624141, 0.000878650520462543, 0.000879319559317082, 0.000879989005625248, 0.000880657520610839, 0.000881324929650873, 0.000881992455106229, 0.000882657943293452, 0.000883323955349624, 0.000883989967405796, 0.000884653476532549, 0.00088531756773591, 0.000885980087332428, 0.000886642665136606, 0.000887304777279496, 0.00088796578347683, 0.000888625858351588, 0.000889285409357399, 0.000889945076778531, 0.000890603696461767, 0.000891260744538158, 0.000891918432898819, 0.000892575480975211, 0.000893230142537504, 0.000893885793630034, 0.000894540455192327, 0.000895193603355438, 0.000895847741048783, 0.000896499492228031, 0.000897151592653245, 0.000897803285624832, 0.000898452999535948, 0.000899102713447064, 0.000899751437827945, 0.000900400627870113, 0.000901048362720758, 0.000901695108041167, 0.000902342319022864, 0.000902987085282803, 0.000903632899280638, 0.000904278131201863, 0.000904920918401331, 0.000905564695131034, 0.000906206492800266, 0.000906848756130785, 0.000907490088138729, 0.000908130430616438, 0.000908770191017538, 0.000909409078303725, 0.00091004790738225, 0.000910686212591827, 0.000911322655156255, 0.000911960029043257, 0.000912595889531076, 0.000913230760488659, 0.000913865573238581, 0.00091449951287359, 0.000915132462978363, 0.000915765296667814, 0.000916396267712116, 0.000917028170078993, 0.000917659606784582, 0.000918288598768413, 0.000918918056413531, 0.000919546466320753, 0.000920174468774348, 0.000920801889151335, 0.000921428378205746, 0.000922054401598871, 0.00092267885338515, 0.000923304352909327, 0.000923927931580693, 0.000924550928175449, 0.000925173924770206, 0.000925795000512153, 0.000926417065784335, 0.000927038083318621, 0.000927657238207757, 0.000928277208004147, 0.000928895373363048, 0.000929513422306627, 0.000930131005588919, 0.000930747133679688, 0.000931363261770457, 0.00093197834212333, 0.000932593480683863, 0.000933207629714161, 0.000933820265345275, 0.000934433366637677, 0.000935045594815165, 0.000935656717047095, 0.000936267839279026, 0.000936877564527094, 0.000937486765906215, 0.000938095967285335, 0.000938703189603984, 0.000935610209126025, 0.000928799097891897, 0.000922026578336954, 0.000915254349820316, 0.000908512971363962, 0.000901763909496367, 0.000895022007171065, 0.000888303387910128, 0.000881624524481595, 0.000874928548000753, 0.000868248927872628, 0.000861600739881396, 0.000854951154906303, 0.0008483417914249, 0.000841723580379039, 0.000835113110952079, 0.000828518532216549, 0.000821970286779106, 0.000815406267065555, 0.000808849756140262, 0.000802317110355943, 0.000795807456597686, 0.000789328827522695, 0.000782834482379258, 0.000776355678681284, 0.00076988385990262, 0.000763467804063112, 0.000757027301006019, 0.000750602106563747, 0.000744192802812904, 0.000737814058084041, 0.000731459527742118, 0.000725096848327667, 0.00071874086279422, 0.000712400884367526, 0.000706107937730849, 0.000699798751156777, 0.000693521345965564, 0.00068721134448424, 0.000680964498315006, 0.000674740877002478, 0.000668501481413841, 0.000662277394440025, 0.000656060699839145, 0.000649899360723794, 0.000643713283352554, 0.000637559394817799, 0.000631404982414097, 0.000625296961516142, 0.000619165715761483, 0.000613057287409902, 0.000606956717092544, 0.000600879662670195, 0.000594833632931113, 0.000588779279496521, 0.000582740933168679, 0.000576725346036255, 0.000570717675145715, 0.000564741145353764, 0.000558764557354152, 0.000552795419935137, 0.000546833442058414, 0.000540895387530327, 0.000534995924681425, 0.000529081095010042, 0.000523197464644909, 0.000517312495503575, 0.000511444173753262, 0.000505591160617769, 0.00049976899754256, 0.000493946601636708, 0.000488131568999961, 0.000482348201330751, 0.000476556655485183, 0.000470811850391328, 0.000465059303678572, 0.000459313509054482, 0.000453583983471617, 0.000447869737399742, 0.000442194606876001, 0.000436511269072071, 0.000430859072366729, 0.00042519872658886, 0.000419585790950805, 0.000413948408095166, 0.000408334541134536, 0.000402736448450014, 0.000397145457100123, 0.000391609646612778, 0.000386041647288948, 0.000380497454898432, 0.000374984578229487, 0.000369502551620826, 0.000363996863598004, 0.000358505989424884, 0.00035303141339682, 0.000347604014677927, 0.000342159561114386, 0.000336747209075838, 0.00033130228985101, 0.000325920584145933, 0.000320562598062679, 0.000315187848173082, 0.000309829163597897, 0.000304477347526699, 0.000299173436360434, 0.000293860910460353, 0.000288571609416977, 0.0002832823083736, 0.000277999934041873, 0.000272773351753131, 0.000267522613285109, 0.000262294575804844, 0.000257074920227751, 0.000251893827226013, 0.000246704817982391, 0.000241547444602475, 0.000236389038036577, 0.00023123859136831, 0.000226127653149888, 0.000221015739953145, 0.000215911713894457, 0.000210815545869991, 0.000205742180696689, 0.000200708323973231, 0.000195657921722159, 0.000190639606444165, 0.000185620578122325, 0.000180616581928916, 0.000175644468981773, 0.000170671337400563, 0.000165706645930186, 0.000160757292178459, 0.000155838541104458, 0.000150920037413016, 0.000146040314575657, 0.000141144788358361, 0.000136273010866717, 0.000131408116430975, 0.000126558777992614, 0.000121748715173453, 0.000116922856250312, 0.000112136011011899, 0.000107340558315627, 0.000102592726761941, 9.78204916464165e-05, 9.3071699666325e-05, 8.83387256180868e-05, 8.36129038361832e-05, 7.89421683293767e-05, 7.42400661692955e-05, 6.95763010298833e-05, 6.4912463130895e-05, 6.02882100793067e-05, 5.56552768102847e-05, 5.10221252625342e-05, 4.64121621917002e-05, 4.18261734012049e-05, 3.72710492229089e-05, 3.27233246935066e-05, 2.81521952274488e-05, 2.36271898756968e-05, 1.91343733604299e-05, 1.46251950354781e-05, 1.0131128874491e-05, 5.64513675271883e-06, 1.17404272259591e-06, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00093900877982378, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 0.00121471227612346, 7.15029216280527e-07, 5.18219349032734e-06, 9.66493462328799e-06, 1.41464606713271e-05, 1.86363467946649e-05, 2.314920493518e-05, 2.76778555416968e-05, 3.22297964885365e-05, 3.67890643246938e-05, 4.13560119341128e-05, 4.59387883893214e-05, 5.05524658365175e-05, 5.51579651073553e-05, 5.97788603045046e-05, 6.4415653469041e-05, 6.90992819727398e-05, 7.37506852601655e-05, 7.84419316914864e-05, 8.31398501759395e-05, 8.78460996318609e-05, 9.25835702219047e-05, 9.73202186287381e-05, 0.000102072976005729, 0.000106832630990539, 0.000111631838080939, 0.000116431008791551, 0.000121229430078529, 0.000126067112432793, 0.000130896936752833, 0.000135765338200144, 0.000140625779749826, 0.000145509417052381, 0.000150401261635125, 0.000155323999933898, 0.000160254072397947, 0.000165192119311541, 0.000170144907315262, 0.000175121997017413, 0.000180098475539126, 0.000185089898877777, 0.000190089660463855, 0.000195112414075993, 0.000200166527065448, 0.000205228352569975, 0.000210289363167249, 0.000215358595596626, 0.000220474190427922, 0.000225574534852058, 0.000230697813094594, 0.000235828279983252, 0.000240998546360061, 0.000246152165345848, 0.000251345365541056, 0.000256530445767567, 0.000261738256085664, 0.000266970222583041, 0.000272201694315299, 0.000277448067208752, 0.0002827106800396, 0.000288004433969036, 0.000293305114610121, 0.000298598082736135, 0.000303922250168398, 0.000309254042804241, 0.000314617209369317, 0.0003199796192348, 0.000325358123518527, 0.000330743234371766, 0.000336160475853831, 0.000341585400747135, 0.000347017252352089, 0.000352465169271454, 0.000357928161974996, 0.000363414612365887, 0.000368901062756777, 0.00037440232699737, 0.000379927543690428, 0.000385467807063833, 0.00039102413575165, 0.000396579736843705, 0.000402150733862072, 0.000407753483159468, 0.000413362926337868, 0.000418972893385217, 0.000424606289016083, 0.000430278043495491, 0.000435934402048588, 0.00044160638935864, 0.00044729292858392, 0.000452995824161917, 0.000458721828181297, 0.000464447221020237, 0.00047019642079249, 0.000475952634587884, 0.000481740775285289, 0.000487536221044138, 0.000493331230245531, 0.000499149668030441, 0.000504975556395948, 0.000510833284351975, 0.00051669025560841, 0.000522562302649021, 0.000528450647834688, 0.000534361519385129, 0.000540288630872965, 0.000546215334907174, 0.000552157056517899, 0.000558114843443036, 0.000564103247597814, 0.000570083735510707, 0.00057608011411503, 0.000582107051741332, 0.000588133989367634, 0.000594192068092525, 0.000600242288783193, 0.000606315617915243, 0.000612412288319319, 0.000618508958723396, 0.000624621112365276, 0.000630748108960688, 0.000636883254628628, 0.000643064850009978, 0.000649223278742284, 0.000655412732157856, 0.000661617028526962, 0.000667845597490668, 0.000674073642585427, 0.000680308847222477, 0.00068656774237752, 0.000692833913490176, 0.000699131516739726, 0.000705428945366293, 0.000711741799023002, 0.000718070135917515, 0.000724421406630427, 0.000730773026589304, 0.000737147754989564, 0.000743522075936198, 0.000749943777918816, 0.00075634871609509, 0.000762777635827661, 0.00076921412255615, 0.000775681342929602, 0.000782148737926036, 0.000788631208706647, 0.00079512974480167, 0.000801635440438986, 0.000808172335382551, 0.000814717321190983, 0.000821269175503403, 0.000827837153337896, 0.000834428414236754, 0.000841026718262583, 0.000847633229568601, 0.000854262965731323, 0.000860899861436337, 0.000867560680489987, 0.000874236866366118, 0.000880912295542657, 0.000887611648067832, 0.00089432584354654, 0.000901048246305436, 0.000907793873921037, 0.000914546835701913, 0.000921307771932334, 0.000928099208977073, 0.000934899260755628, 0.000941706297453493, 0.000948528759181499, 0.000955375086050481, 0.000962220248766243, 0.000969089567661285, 0.000975966395344585, 0.000982866040430963, 0.00098978157620877, 0.000996712478809059, 0.0010036431485787, 0.00101058930158615, 0.00101757457014173, 0.00102454365696758, 0.00103154394309968, 0.00103854411281645, 0.00104558351449668, 0.00105261441785842, 0.00105966138653457, 0.00106673128902912, 0.00107381632551551, 0.00108091742731631, 0.00108801771420985, 0.00109514209907502, 0.00110227370169014, 0.00110943615436554, 0.00111659872345626, 0.00112376862671226, 0.00113096216227859, 0.00113818689715117, 0.0011454033665359, 0.00115263543557376, 0.00115988240577281, 0.00116714590694755, 0.00117443222552538, 0.00118172564543784, 0.00118902733083814, 0.00119635206647217, 0.00120369251817465, 0.00121104042045772, 0.00122002954594791, 0.00123049598187208, 0.00124108092859387, 0.00125164224300534, 0.00126226688735187, 0.00127290724776685, 0.0012836029054597, 0.00129433826077729, 0.00130511296447366, 0.00131594308186322, 0.00132677296642214, 0.00133764266502112, 0.00134857557713985, 0.00135954783763736, 0.0013705282472074, 0.00138157967012376, 0.00139263109304011, 0.00140376156195998, 0.00141489214729518, 0.00142607791349292, 0.0014372953446582, 0.00144856818951666, 0.00145984895061702, 0.0014711928088218, 0.00148256029933691, 0.00149399123620242, 0.00150541414041072, 0.00151690829079598, 0.00152840255759656, 0.00154000730253756, 0.00155158038251102, 0.00156322482507676, 0.00157487706746906, 0.00158661638852209, 0.00159835536032915, 0.00161015777848661, 0.0016219443641603, 0.00163383386097848, 0.00164573907386512, 0.0016576680354774, 0.00166963634546846, 0.00168165226932615, 0.00169369962532073, 0.00170578667894006, 0.0017179447459057, 0.00173007941339165, 0.00174230861011893, 0.00175452209077775, 0.00176680681761354, 0.00177909934427589, 0.00179146300069988, 0.00180385052226484, 0.00181629310827702, 0.00182873592711985, 0.00184125767555088, 0.00185378734022379, 0.00186637253500521, 0.00187896529678255, 0.00189163733739406, 0.00190430937800556, 0.00191705266479403, 0.00192980351857841, 0.00194261793512851, 0.00195544003508985, 0.00196834141388535, 0.00198124255985022, 0.00199420726858079, 0.00200717966072261, 0.00202023889869452, 0.00203329022042453, 0.00204640487208962, 0.00205951975658536, 0.00207271333783865, 0.00208593858405948, 0.0020991878118366, 0.0021124763879925, 0.00212579662911594, 0.00213918020017445, 0.00215259520336986, 0.00216604978777468, 0.00217951228842139, 0.00219303811900318, 0.00220658746547997, 0.00222016079351306, 0.0022338128183037, 0.00224748882465065, 0.00226118857972324, 0.00227494374848902, 0.00228869868442416, 0.0023025325499475, 0.00231639831326902, 0.00233029574155807, 0.00234420085325837, 0.00235818512737751, 0.00237217731773853, 0.00238625635392964, 0.00240031979046762, 0.0024144381750375, 0.0024285966064781, 0.00244280998595059, 0.00245703128166497, 0.00247130030766129, 0.00248559284955263, 0.00249998038634658, 0.0025143283419311, 0.00252877897582948, 0.00254320562817156, 0.00255771167576313, 0.00257224915549159, 0.00258682644926012, 0.00260142749175429, 0.00261606788262725, 0.00263076345436275, 0.00264549860730767, 0.00266028149053454, 0.00267505622468889, 0.00268988637253642, 0.00270477985031903, 0.00271966517902911, 0.00273462967015803, 0.00274961767718196, 0.00276463758200407, 0.00277972058393061, 0.00279478775337338, 0.002809934085235, 0.00282511208206415, 0.00284032966010273, 0.00285556283779442, 0.0028708593454212, 0.00288616400212049, 0.002901571104303, 0.00291695445775986, 0.00293238554149866, 0.00294785597361624, 0.00296340533532202, 0.00297893118113279, 0.00299453595653176, 0.00301012489944696, 0.00302583258599043, 0.00304150837473571, 0.00305725540965796, 0.00307302619330585, 0.00308882910758257, 0.00310470256954432, 0.00312059186398983, 0.00313650513999164, 0.00315248128026724, 0.00316847348585725, 0.00318453647196293, 0.00320060038939118, 0.00321672670543194, 0.00323287700302899, 0.00324906664900482, 0.00326528027653694, 0.00328156515024602, 0.00329787353985012, 0.0033142133615911, 0.00333060091361403, 0.00334699591621757, 0.00336347846314311, 0.00337993679568172, 0.00339651387184858, 0.00341304391622543, 0.00342966057360172, 0.00344629306346178, 0.00346299656666815, 0.00347970821894705, 0.00349645945243537, 0.00351324188522995, 0.003530103713274, 0.00354694179259241, 0.00356386695057154, 0.0035807837266475, 0.00359779549762607, 0.00361480773426592, 0.0036318670026958, 0.00364894210360944, 0.00366608845070004, 0.00368325831368566, 0.0037004838231951, 0.00371769350022078, 0.00373499002307653, 0.00375231052748859, 0.00376967783086002, 0.00378705351613462, 0.00380449229851365, 0.00382199417799711, 0.00383948069065809, 0.00385704613290727, 0.00387461902573705, 0.0038922477979213, 0.00390989985316992, 0.00392761547118425, 0.00394533108919859, 0.00396312540397048, 0.00398089643567801, 0.00399878574535251, 0.00401663547381759, 0.00403457228094339, 0.00405252538621426, 0.00407055672258139, 0.00408856477588415, 0.00410664407536387, 0.00412474665790796, 0.00414292048662901, 0.00416108686476946, 0.00417932402342558, 0.0041975537315011, 0.00421586958691478, 0.00423420965671539, 0.00425259722396731, 0.00427098479121923, 0.00428943522274494, 0.00430793361738324, 0.00432647112756968, 0.00434503238648176, 0.00436362531036139, 0.00438225036486983, 0.00440095365047455, 0.00441964156925678, 0.00443841610103846, 0.0044571990147233, 0.00447602104395628, 0.00449490640312433, 0.00451378431171179, 0.00453270925208926, 0.00455172127112746, 0.00457074074074626, 0.00458976067602634, 0.00460887560620904, 0.00462800590321422, 0.0046471762470901, 0.0046663535758853, 0.00468561099842191, 0.00470487587153912, 0.00472422782331705, 0.00474354811012745, 0.00476293964311481, 0.00478236237540841, 0.00480185635387897, 0.00482134334743023, 0.00484089273959398, 0.00486045749858022, 0.0048800865188241, 0.00489973835647106, 0.00491943815723062, 0.00493915425613523, 0.00495891692116857, 0.00497872708365321, 0.00499858474358916, 0.00501845823600888, 0.00503837922587991, 0.00505831651389599, 0.00507834041491151, 0.00509834056720138, 0.00511842733249068, 0.00513853784650564, 0.00515867210924625, 0.00517887808382511, 0.00519908359274268, 0.00521932076662779, 0.00523961381986737, 0.00525999302044511, 0.00528033310547471, 0.00530076026916504, 0.00532119488343596, 0.00534169329330325, 0.00536219915375113, 0.00538276042789221, 0.00540334545075893, 0.0054240096360445, 0.00544465845450759, 0.00546537013724446, 0.00548609718680382, 0.00550691969692707, 0.00552771799266338, 0.00554859545081854, 0.00556947290897369, 0.00559041369706392, 0.00561138661578298, 0.00563241401687264, 0.00565344979986548, 0.00567453261464834, 0.00569564709439874, 0.0057168179191649, 0.00573800317943096, 0.00575926108285785, 0.0057805092073977, 0.00580184580758214, 0.00582316610962152, 0.00584458140656352, 0.00586597248911858, 0.00588746694847941, 0.00590896885842085, 0.00593048660084605, 0.00595206022262573, 0.00597369624301791, 0.00599535647779703, 0.00601701671257615, 0.00603875610977411, 0.00606050295755267, 0.00608233734965324, 0.00610414752736688, 0.00612603733316064, 0.00614792620763183, 0.00616990262642503, 0.00619187904521823, 0.00621392671018839, 0.00623595807701349, 0.00625807698816061, 0.00628021219745278, 0.00630240933969617, 0.00632459158077836, 0.00634685205295682, 0.00636915257200599, 0.00639149267226458, 0.00641384022310376, 0.00643624365329742, 0.00645868666470051, 0.00648116879165173, 0.00650368304923177, 0.00652624433860183, 0.00654882099479437, 0.00657146982848644, 0.00659411773085594, 0.00661683734506369, 0.00663955742493272, 0.0066623636521399, 0.00668518524616957, 0.00670801615342498, 0.006730901543051, 0.0067538577131927, 0.00677684647962451, 0.00679981056600809, 0.00682287802919745, 0.00684594502672553, 0.00686908420175314, 0.00689223874360323, 0.00691542355343699, 0.00693864142522216, 0.00696193799376488, 0.006985227111727, 0.00700858701020479, 0.00703193107619882, 0.00705536920577288, 0.00707882409915328, 0.00710233440622687, 0.00712586008012295, 0.00714942533522844, 0.00717302225530148, 0.00719669787213206, 0.00722035858780146, 0.0072440980002284, 0.0072678136639297, 0.0072916392236948, 0.00731546524912119, 0.00733934715390205, 0.00736325234174728, 0.00738719711080194, 0.00741118099540472, 0.00743521330878139, 0.00745925260707736, 0.00748337944969535, 0.00750751420855522, 0.00753166433423758, 0.00755589315667748, 0.00758013082668185, 0.00760442297905684, 0.00762873189523816, 0.00765311159193516, 0.00767749128863215, 0.00770195806398988, 0.00772641645744443, 0.00775092979893088, 0.00777545943856239, 0.0078000845387578, 0.00782469380646944, 0.00784936547279358, 0.00787402130663395, 0.0078987879678607, 0.00792356301099062, 0.00794838555157185, 0.00797322299331427, 0.00799810886383057, 0.008023033849895, 0.00804800633341074, 0.00807299464941025, 0.00809804629534483, 0.00812309794127941, 0.00814823713153601, 0.00817336607724428, 0.00819858442991972, 0.00822378601878881, 0.00824908260256052, 0.00827434752136469, 0.00829970743507147, 0.00832507573068142, 0.00835052132606506, 0.00837596878409386, 0.00840143114328384, 0.00842698849737644, 0.00845253001898527, 0.00847814325243235, 0.00850379560142756, 0.0085294721648097, 0.00855517853051424, 0.0085809575393796, 0.00860672909766436, 0.00863257795572281, 0.00865840446203947, 0.00868432596325874, 0.00871026236563921, 0.00873626302927732, 0.00876227114349604, 0.00878831837326288, 0.00881440564990044, 0.00884056370705366, 0.00886670593172312, 0.00889293476939201, 0.00891914870589972, 0.00894544925540686, 0.00897175818681717, 0.00899812206625938, 0.00902451667934656, 0.00905093643814325, 0.0090773943811655, 0.00910393241792917, 0.00913044717162848, 0.00915707927197218, 0.00918364804238081, 0.0092103211209178, 0.0092370081692934, 0.00926376692950726, 0.00929051823914051, 0.00931731704622507, 0.00934419501572847, 0.0093710646033287, 0.00939797330647707, 0.00942495372146368, 0.00945194251835346, 0.00947897043079138, 0.00950606074184179, 0.00953316781669855, 0.00956032238900661, 0.00958746764808893, 0.00961470231413841, 0.00964196678251028, 0.00966927967965603, 0.00969660747796297, 0.00972396787256002, 0.00975138321518898, 0.00977885257452726, 0.00980631541460752, 0.00983385648578405, 0.00986138265579939, 0.00988899543881416, 0.00991663243621588, 0.00994431599974632, 0.00997202377766371, 0.00999977812170982, 0.0100275501608849, 0.0100553836673498, 0.0100832264870405, 0.0101111708208919, 0.0101390602067113, 0.0101670604199171, 0.0101950606331229, 0.0102231316268444, 0.0102512193843722, 0.010279337875545, 0.0103075038641691, 0.0103357015177608, 0.0103639308363199, 0.0103922225534916, 0.0104205077514052, 0.0104488795623183, 0.0104772904887795, 0.0105057014152408, 0.0105341924354434, 0.0105626666918397, 0.0105911968275905, 0.0106197809800506, 0.0106484219431877, 0.0106770461425185, 0.0107057513669133, 0.0107344696298242, 0.0107632521539927, 0.0107920430600643, 0.0108208963647485, 0.0108497589826584, 0.0108786830678582, 0.0109076164662838, 0.0109366290271282, 0.0109656490385532, 0.0109947388991714, 0.0110237998887897, 0.0110529689118266, 0.011082130484283, 0.0111113889142871, 0.0111406212672591, 0.0111699188128114, 0.0111992312595248, 0.0112286061048508, 0.0112580144777894, 0.0112874684855342, 0.0113169467076659, 0.0113464565947652, 0.0113760456442833, 0.0114056272432208, 0.0114352311939001, 0.0114649077877402, 0.0114946234971285, 0.0115243634209037, 0.0115541657432914, 0.0115839680656791, 0.0116138178855181, 0.0116437068209052, 0.0116736674681306, 0.011703628115356, 0.0117336437106133, 0.0117636770009995, 0.0117937624454498, 0.011823883280158, 0.0118540488183498, 0.0118842385709286, 0.0119144758209586, 0.0119447447359562, 0.0119750611484051, 0.0120053850114346, 0.012035820633173, 0.0120661994442344, 0.0120966741815209, 0.0121271479874849, 0.0121577261015773, 0.0121882706880569, 0.012218895368278, 0.0122495125979185, 0.0122802164405584, 0.0123109351843596, 0.0123417191207409, 0.0123724853619933, 0.012403323315084, 0.0124342413619161, 0.0124651342630386, 0.0124960672110319, 0.0125270644202828, 0.0125580914318562, 0.0125891659408808, 0.0126202665269375, 0.012651395983994, 0.0126825738698244, 0.0127137834206223, 0.0127450404688716, 0.012776305899024, 0.0128076579421759, 0.0128390174359083, 0.0128704244270921, 0.0129018472507596, 0.0129333352670074, 0.0129648363217711, 0.0129964100196958, 0.013027966953814, 0.0130596039816737, 0.0130912559106946, 0.0131230028346181, 0.013154718093574, 0.0131864883005619, 0.0132182911038399, 0.0132501814514399, 0.0132820624858141, 0.013313983567059, 0.0133459279313684, 0.0133779449388385, 0.0134099842980504, 0.0134420795366168, 0.0134741747751832, 0.0135063258931041, 0.013538546860218, 0.013570767827332, 0.0136030130088329, 0.0136353457346559, 0.0136676775291562, 0.0137000642716885, 0.0137325013056397, 0.0137649271637201, 0.0137974414974451, 0.0138299390673637, 0.013862531632185, 0.0138951251283288, 0.0139277894049883, 0.0139604536816478, 0.0139931812882423, 0.0140259237959981, 0.0140587389469147, 0.0140915531665087, 0.0141244465485215, 0.01415731664747, 0.0141902808099985, 0.0142232459038496, 0.0142562976107001, 0.0142893325537443, 0.0143224392086267, 0.0143555384129286, 0.0143887400627136, 0.0144219491630793, 0.0144551917910576, 0.0144884726032615, 0.0145217766985297, 0.0145551515743136, 0.0145885590463877, 0.0146219674497843, 0.0146554531529546, 0.0146889789029956, 0.0147225204855204, 0.0147560937330127, 0.0147897228598595, 0.0148233752697706, 0.0148570900782943, 0.0148908384144306, 0.0149245923385024, 0.0149584030732512, 0.0149922529235482, 0.0150261418893933, 0.0150600476190448, 0.0150940250605345, 0.0151280164718628, 0.0151620721444488, 0.0151961194351315, 0.0152302468195558, 0.015264380723238, 0.0152986021712422, 0.0153328003361821, 0.0153670692816377, 0.0154013456776738, 0.0154357254505157, 0.0154700819402933, 0.0155044915154576, 0.015538927167654, 0.0155734177678823, 0.0156079474836588, 0.0156425163149834, 0.01567711122334, 0.0157117508351803, 0.0157464295625687, 0.0157811567187309, 0.0158158931881189, 0.0158507004380226, 0.0158855225890875, 0.0159203913062811, 0.0159553084522486, 0.0159902181476355, 0.0160251911729574, 0.0160602200776339, 0.0160952936857939, 0.016130369156599, 0.0161655079573393, 0.0162006691098213, 0.0162358731031418, 0.0162710975855589, 0.0163064021617174, 0.0163416899740696, 0.0163770746439695, 0.0164124425500631, 0.0164478812366724, 0.0164833422750235, 0.0165188759565353, 0.016554394736886, 0.016589991748333, 0.0166255813091993, 0.0166612714529037, 0.0166969411075115, 0.0167326722294092, 0.0167684350162745, 0.0168042369186878, 0.0168400872498751, 0.0168759860098362, 0.0169118754565716, 0.016947852447629, 0.0169838443398476, 0.0170198753476143, 0.017055930569768, 0.0170920491218567, 0.0171281918883324, 0.0171643830835819, 0.0172006189823151, 0.0172368567436934, 0.0172731261700392, 0.0173094980418682, 0.0173458773642778, 0.0173822641372681, 0.0174187310039997, 0.0174551978707314, 0.0174917355179787, 0.0175282638520002, 0.0175648834556341, 0.0176015049219131, 0.0176382027566433, 0.0176748987287283, 0.0177116338163614, 0.0177484080195427, 0.0177852548658848, 0.0178220998495817, 0.0178590174764395, 0.0178959183394909, 0.0179329067468643, 0.0179699268192053, 0.0180069711059332, 0.0180440470576286, 0.0180811695754528, 0.0181183405220509, 0.0181555561721325, 0.0181927587836981, 0.0182300470769405, 0.0182673521339893, 0.0183047186583281, 0.0183420870453119, 0.0183795187622309, 0.0184169802814722, 0.0184544809162617, 0.0184920486062765, 0.018529599532485, 0.0185671951621771, 0.0186048708856106, 0.0186425540596247, 0.018680278211832, 0.0187180563807487, 0.0187558531761169, 0.0187936946749687, 0.0188315510749817, 0.0188694819808006, 0.018907418474555, 0.0189454257488251, 0.0189834423363209, 0.0190215297043324, 0.0190595928579569, 0.0190977733582258, 0.0191359166055918, 0.0191741622984409, 0.0192123986780643, 0.0192506834864616, 0.0192890111356974, 0.0193273890763521, 0.0193657837808132, 0.0194042362272739, 0.0194426998496056, 0.0194812305271626, 0.0195197612047195, 0.0195583701133728, 0.019597003236413, 0.0196356661617756, 0.0196743626147509, 0.0197131130844355, 0.0197518784552813, 0.0197907350957394, 0.0198295656591654, 0.0198684576898813, 0.0199073925614357, 0.0199463795870543, 0.0199853852391243, 0.020024411380291, 0.0200634952634573, 0.0201026182621717, 0.0201417710632086, 0.0201809667050838, 0.0202201921492815, 0.0202594567090273, 0.0202987752854824, 0.0203381199389696, 0.020377503708005, 0.0204169191420078, 0.0204563811421394, 0.0204958766698837, 0.0205354001373053, 0.0205749813467264, 0.0206145960837603, 0.0206542573869228, 0.0206939224153757, 0.0207336563616991, 0.0207733884453773, 0.0208131987601519, 0.0208530407398939, 0.0208929050713778, 0.0209328122437, 0.0209727697074413, 0.021012756973505, 0.0210527796298265, 0.021092826500535, 0.0211329199373722, 0.021173071116209, 0.0212132409214973, 0.0212534461170435, 0.0212936904281378, 0.0213339906185865, 0.0213743150234222, 0.0214146561920643, 0.0214550644159317, 0.021495508030057, 0.021535973995924, 0.0215764958411455, 0.0216170214116573, 0.0216576121747494, 0.0216982532292604, 0.021738899871707, 0.0217796042561531, 0.0218203496187925, 0.0218611098825932, 0.0219019465148449, 0.0219427850097418, 0.0219836700707674, 0.0220245942473412, 0.0220655836164951, 0.0221065878868103, 0.0221476163715124, 0.0221886746585369, 0.0222298055887222, 0.0222709588706493, 0.0223121512681246, 0.0223533697426319, 0.0223946534097195, 0.0224359650164843, 0.0224772840738297, 0.0225186608731747, 0.0225600767880678, 0.0226015374064445, 0.0226430334150791, 0.0226845350116491, 0.0227261073887348, 0.0227677281945944, 0.0228093583136797, 0.0228510480374098, 0.0228927414864302, 0.0229345131665468, 0.0229762904345989, 0.0230181254446507, 0.0230600070208311, 0.0231018979102373, 0.0231438409537077, 0.0231858249753714, 0.0232278425246477, 0.0232699047774076, 0.0233119912445545, 0.0233541242778301, 0.0233962927013636, 0.0234384927898645, 0.0234807375818491, 0.0235230382531881, 0.0235653538256884, 0.0236077085137367, 0.0236501041799784, 0.023692524060607, 0.0237349979579449, 0.0237775202840567, 0.0238200500607491, 0.0238626282662153, 0.0239052753895521, 0.0239479094743729, 0.0239906124770641, 0.0240333396941423, 0.024076122790575, 0.0241189301013947, 0.0241617672145367, 0.0242046527564526, 0.0242475774139166, 0.0242905486375093, 0.0243335403501987, 0.0243765581399202, 0.0244196262210608, 0.0244627501815557, 0.0245059039443731, 0.0245490744709969, 0.0245923064649105, 0.0246355552226305, 0.0246788505464792, 0.0247221887111664, 0.0247655548155308, 0.0248089954257011, 0.0248524267226458, 0.0248959120362997, 0.0249394383281469, 0.0249829888343811, 0.0250266175717115, 0.0250702388584614, 0.02511390671134, 0.0251576285809278, 0.0252013690769672, 0.0252451654523611, 0.0252889897674322, 0.0253328569233418, 0.0253767445683479, 0.0254207048565149, 0.0254646725952625, 0.0255086738616228, 0.0255527161061764, 0.0255968254059553, 0.0256409514695406, 0.0256851185113192, 0.0257293004542589, 0.0257735457271338, 0.0258178375661373, 0.0258621387183666, 0.0259064957499504, 0.025950875133276, 0.0259953010827303, 0.0260397754609585, 0.0260842815041542, 0.0261288117617369, 0.026173397898674, 0.0262180082499981, 0.0262626633048058, 0.026307350024581, 0.0263521112501621, 0.0263968612998724, 0.0264416430145502, 0.0264864880591631, 0.0265313759446144, 0.0265763085335493, 0.0266212485730648, 0.0266662482172251, 0.0267112739384174, 0.0267563555389643, 0.0268014390021563, 0.0268465857952833, 0.0268917642533779, 0.0269369818270206, 0.0269822552800179, 0.0270275454968214, 0.0270728729665279, 0.0271182227879763, 0.0271636471152306, 0.027209086343646, 0.0272545721381903, 0.0273000821471214, 0.0273456405848265, 0.0273912437260151, 0.0274368636310101, 0.0274825505912304, 0.0275282505899668, 0.0275739971548319, 0.0276197753846645, 0.0276655927300453, 0.0277114585042, 0.0277573727071285, 0.0278032794594765, 0.0278492476791143, 0.0278952550143003, 0.0279413033276796, 0.027987414970994, 0.0280335154384375, 0.0280796606093645, 0.0281258579343557, 0.0281721111387014, 0.0282183866947889, 0.0282646883279085, 0.0283110272139311, 0.0283574238419533, 0.0284038428217173, 0.0284503027796745, 0.0284968074411154, 0.0285433307290077, 0.028589928522706, 0.0286365319043398, 0.0286831874400377, 0.028729859739542, 0.0287765804678202, 0.0288233477622271, 0.0288701429963112, 0.028916984796524, 0.0289638433605433, 0.0290107633918524, 0.0290577113628387, 0.029104707762599, 0.0291517358273268, 0.0291987881064415, 0.0292458944022655, 0.0292930249124765, 0.0293402019888163, 0.0293874368071556, 0.0294346697628498, 0.0294819585978985, 0.0295292697846889, 0.0295766554772854, 0.0296240616589785, 0.0296714771538973, 0.0297189485281706, 0.0297664664685726, 0.0298140477389097, 0.0298616345971823, 0.0299092587083578, 0.0299569256603718, 0.0300046186894178, 0.0300523806363344, 0.0301001444458961, 0.0301479604095221, 0.0301958099007607, 0.0302437078207731, 0.0302916374057531, 0.0303396061062813, 0.0303875971585512, 0.0304356310516596, 0.0304837357252836, 0.030536063015461, 0.0305927284061909, 0.0306494366377592, 0.030706150457263, 0.0307629257440567, 0.0308197494596243, 0.0308766029775143, 0.0309335011988878, 0.0309903901070356, 0.0310473684221506, 0.0311043802648783, 0.0311614237725735, 0.0312185175716877, 0.0312756076455116, 0.0313327610492706, 0.0313899628818035, 0.0314471982419491, 0.031504463404417, 0.0315617434680462, 0.0316191017627716, 0.0316764786839485, 0.0317339189350605, 0.0317913740873337, 0.0318488776683807, 0.0319063924252987, 0.031963974237442, 0.0320215709507465, 0.0320792309939861, 0.0321369096636772, 0.0321946479380131, 0.0322524048388004, 0.0323102027177811, 0.0323680378496647, 0.0324258916079998, 0.0324838049709797, 0.0325417630374432, 0.0325997546315193, 0.0326577983796597, 0.0327158197760582, 0.0327739380300045, 0.0328320898115635, 0.0328902713954449, 0.0329484865069389, 0.0330067165195942, 0.0330650247633457, 0.0331233479082584, 0.033181719481945, 0.0332401394844055, 0.0332985408604145, 0.0333570390939713, 0.0334155559539795, 0.0334741175174713, 0.0335327237844467, 0.0335913337767124, 0.0336500070989132, 0.0337087251245975, 0.0337674766778946, 0.0338262766599655, 0.0338850766420364, 0.0339439548552036, 0.034002847969532, 0.0340617559850216, 0.0341207571327686, 0.0341797471046448, 0.034238800406456, 0.0342978835105896, 0.0343570113182068, 0.0344162061810493, 0.0344754159450531, 0.0345346294343472, 0.0345938988029957, 0.0346532389521599, 0.034712590277195, 0.034771990031004, 0.0348313748836517, 0.0348908491432667, 0.0349503606557846, 0.0350099205970764, 0.0350695066154003, 0.035129077732563, 0.0351887345314026, 0.0352484472095966, 0.0353081971406937, 0.0353679582476616, 0.0354277230799198, 0.0354875959455967, 0.0355474837124348, 0.0356074050068855, 0.0356673747301102, 0.0357273444533348, 0.0357873924076557, 0.0358474552631378, 0.035907581448555, 0.0359677411615849, 0.0360279120504856, 0.036088153719902, 0.0361484065651894, 0.0362086892127991, 0.0362690389156342, 0.0363294184207916, 0.0363898277282715, 0.0364502891898155, 0.0365107804536819, 0.036571316421032, 0.036631852388382, 0.0366924554109573, 0.0367531217634678, 0.0368137992918491, 0.0368745103478432, 0.0369352549314499, 0.0369960479438305, 0.0370568819344044, 0.0371177531778812, 0.0371786542236805, 0.0372395887970924, 0.037300568073988, 0.0373615957796574, 0.0374226719141006, 0.0374837629497051, 0.0375448688864708, 0.0376060418784618, 0.0376672744750977, 0.037728525698185, 0.0377898029983044, 0.0378511026501656, 0.0379124768078327, 0.0379738844931126, 0.0380353070795536, 0.0380967929959297, 0.0381582975387573, 0.0382198467850685, 0.0382814444601536, 0.0383430682122707, 0.0384047329425812, 0.0384664200246334, 0.0385281816124916, 0.0385899655520916, 0.0386517830193043, 0.0387136377394199, 0.0387755185365677, 0.0388374477624893, 0.0388994067907333, 0.0389614291489124, 0.0390234589576721, 0.039085540920496, 0.0391476601362228, 0.0392098091542721, 0.0392720066010952, 0.039334237575531, 0.0393965132534504, 0.039458803832531, 0.0395211614668369, 0.0395835526287556, 0.0396459698677063, 0.0397084206342697, 0.039770919829607, 0.0398334637284279, 0.039896048605442, 0.0399586521089077, 0.0400213003158569, 0.0400839745998383, 0.0401467010378838, 0.0402094610035419, 0.0402722768485546, 0.0403351113200188, 0.0403979830443859, 0.0404609143733978, 0.0405238531529903, 0.0405868403613567, 0.040649875998497, 0.0407129339873791, 0.0407760441303253, 0.0408391915261745, 0.0409023799002171, 0.0409655906260014, 0.0410288386046886, 0.0410921350121498, 0.0411554649472237, 0.0412188395857811, 0.0412822477519512, 0.0413456782698631, 0.0414091572165489, 0.0414726920425892, 0.0415362641215324, 0.0415998548269272, 0.0416634790599346, 0.0417271628975868, 0.0417908653616905, 0.0418546125292778, 0.0419184044003487, 0.0419822074472904, 0.042046070098877, 0.0421099849045277, 0.0421739257872105, 0.0422379039227962, 0.0423018857836723, 0.0423659533262253, 0.0424300394952297, 0.0424941815435886, 0.0425583384931087, 0.042622547596693, 0.0426867939531803, 0.0427510775625706, 0.042815376073122, 0.0428797416388988, 0.0429441295564175, 0.0430085584521294, 0.0430730357766151, 0.0431375354528427, 0.0432020947337151, 0.0432666763663292, 0.0433312729001045, 0.0433959402143955, 0.0434606336057186, 0.0435253791511059, 0.0435901433229446, 0.0436549447476864, 0.0437198057770729, 0.0437846779823303, 0.0438496135175228, 0.0439145676791668, 0.0439795590937138, 0.0440446063876152, 0.0441096797585487, 0.0441747978329659, 0.0442399457097054, 0.0443051196634769, 0.0443703569471836, 0.0444356240332127, 0.0445009171962738, 0.0445662625133991, 0.0446316301822662, 0.0446970500051975, 0.0447625070810318, 0.0448280014097691, 0.044893529266119, 0.0449591018259525, 0.0450247041881084, 0.0450903587043285, 0.0451560281217098, 0.0452217385172844, 0.0452874861657619, 0.0453532934188843, 0.0454191341996193, 0.0454850047826767, 0.0455509200692177, 0.045616839081049, 0.0456828325986862, 0.0457488708198071, 0.0458149313926697, 0.045881025493145, 0.0459471419453621, 0.0460133105516434, 0.0460795387625694, 0.046145785599947, 0.0462120994925499, 0.0462783984839916, 0.0463447533547878, 0.0464111529290676, 0.0464776083827019, 0.0465440899133682, 0.0466105900704861, 0.0466771461069584, 0.0467437356710434, 0.0468103848397732, 0.0468770377337933, 0.0469437129795551, 0.0470104590058327, 0.0470772460103035, 0.0471440851688385, 0.0472109392285347, 0.0472778342664242, 0.0473447553813457, 0.0474117398262024, 0.0474787428975105, 0.0475457943975925, 0.0476128794252872, 0.0476799719035625, 0.047747153788805, 0.0478143654763699, 0.0478815957903862, 0.0479488633573055, 0.0480161607265472, 0.0480835102498531, 0.0481509044766426, 0.0482183247804642, 0.0482857972383499, 0.048353273421526, 0.0484208352863789, 0.0484884083271027, 0.0485560297966003, 0.0486236810684204, 0.0486913584172726, 0.0487590804696083, 0.0488268584012985, 0.0488946512341499, 0.0489624962210655, 0.0490303672850132, 0.0490982942283154, 0.0491662546992302, 0.0492342412471771, 0.0493022762238979, 0.0493703223764896, 0.0494384318590164, 0.0495065785944462, 0.0495747663080692, 0.0496429912745953, 0.0497112534940243, 0.049779549241066, 0.0498478934168816, 0.0499162413179874, 0.0499846562743187, 0.0500531047582626, 0.0501216016709805, 0.050190132111311, 0.050258681178093, 0.0503272749483585, 0.0503959096968174, 0.0504645928740501, 0.050533302128315, 0.0506020560860634, 0.0506708323955536, 0.0507396534085274, 0.050808522850275, 0.050877433270216, 0.0509463809430599, 0.051015343517065, 0.051084365695715, 0.0511534176766872, 0.0512225143611431, 0.0512916445732117, 0.0513607934117317, 0.0514299944043159, 0.0514992475509644, 0.0515685379505157, 0.0516378507018089, 0.0517072007060051, 0.0517765916883945, 0.0518460273742676, 0.0519155003130436, 0.0519850105047226, 0.0520545467734337, 0.0521241277456284, 0.0521937534213066, 0.0522634461522102, 0.0523331239819527, 0.0524028614163399, 0.0524726323783398, 0.0525424480438232, 0.0526123084127903, 0.0526821874082088, 0.0527521185576916, 0.0528220683336258, 0.0528920702636242, 0.0529621094465256, 0.0530322007834911, 0.0531023256480694, 0.0531724579632282, 0.0532426573336124, 0.053312886506319, 0.0533831492066383, 0.0534534491598606, 0.0535237826406956, 0.0535941831767559, 0.0536645837128162, 0.0537350475788116, 0.0538055412471294, 0.053876057267189, 0.0539466552436352, 0.0540172457695007, 0.0540878884494305, 0.0541585832834244, 0.0542293041944504, 0.0543000549077988, 0.0543708354234695, 0.0544416718184948, 0.0545125529170036, 0.0545834712684155, 0.0546544156968594, 0.0547254160046577, 0.0547964349389076, 0.0548674799501896, 0.0549385994672775, 0.0550097413361073, 0.0550809353590012, 0.0551521331071854, 0.0552233792841434, 0.0552946664392948, 0.0553659982979298, 0.055437371134758, 0.0555087588727474, 0.055580198764801, 0.0556516945362091, 0.0557231977581978, 0.0557947568595409, 0.0558663420379162, 0.0559379756450653, 0.0560096427798271, 0.0560813583433628, 0.0561530999839306, 0.0562248639762402, 0.056296706199646, 0.0563685558736324, 0.0564404502511024, 0.0565123967826366, 0.0565843470394611, 0.056656364351511, 0.0567284040153027, 0.0568004995584488, 0.0568726249039173, 0.0569447800517082, 0.0570169687271118, 0.0570892058312893, 0.0571614913642406, 0.0572337992489338, 0.0573061555624008, 0.0573785454034805, 0.0574509613215923, 0.0575234442949295, 0.0575959570705891, 0.0576684810221195, 0.0577410645782948, 0.0578136928379536, 0.057886328548193, 0.0579590313136578, 0.0580317489802837, 0.0581045150756836, 0.0581773221492767, 0.0582501590251923, 0.0583230629563332, 0.0583959594368935, 0.0584689192473888, 0.0585419274866581, 0.0586149506270885, 0.0586880370974541, 0.0587611235678196, 0.0588342808187008, 0.0589074678719044, 0.0589806772768497, 0.0590539388358593, 0.0591272301971912, 0.0592005699872971, 0.0592739507555962, 0.0593473613262177, 0.0594208054244518, 0.0594942793250084, 0.0595678165555, 0.0596413761377335, 0.0597149878740311, 0.0597886256873608, 0.0598623044788837, 0.0599360242486, 0.0600097663700581, 0.0600835755467415, 0.060157410800457, 0.0602312758564949, 0.0603051632642746, 0.0603791289031506, 0.0604530908167362, 0.0605271048843861, 0.0606011748313904, 0.0606752671301365, 0.0607494078576565, 0.0608235597610474, 0.0608977675437927, 0.060972023755312, 0.0610462911427021, 0.0611206367611885, 0.061194971203804, 0.0612693801522255, 0.0613438077270985, 0.0614182762801647, 0.0614928044378757, 0.0615673363208771, 0.0616419315338135, 0.0617165490984917, 0.061791218817234, 0.0618659146130085, 0.0619406513869762, 0.0620154216885567, 0.062090240418911, 0.0621651001274586, 0.062239982187748, 0.0623149238526821, 0.0623898692429066, 0.0624648742377758, 0.0625399276614189, 0.0626149997115135, 0.0626901239156723, 0.0627652779221535, 0.0628404766321182, 0.0629156976938248, 0.0629909783601761, 0.0630662813782692, 0.0631416141986847, 0.063217006623745, 0.0632924288511276, 0.0633678957819939, 0.0634433850646019, 0.0635189041495323, 0.0635944753885269, 0.0636700913310051, 0.0637457445263863, 0.0638214349746704, 0.0638971477746964, 0.0639729127287865, 0.0640487149357796, 0.0641245394945145, 0.0642004236578941, 0.064276322722435, 0.0643522813916206, 0.0644282624125481, 0.0645043030381203, 0.0645803660154343, 0.0646564513444901, 0.0647326111793518, 0.0648087710142136, 0.0648850053548813, 0.0649612620472908, 0.0650375261902809, 0.0651138722896576, 0.0651902481913567, 0.0652666538953781, 0.065343089401722, 0.0654195696115494, 0.0654960945248604, 0.0655726566910744, 0.0656492561101913, 0.0657258927822113, 0.0658025443553925, 0.0658792555332184, 0.0659560114145279, 0.0660327896475792, 0.0661096125841141, 0.0661864653229713, 0.0662633553147316, 0.0663403049111366, 0.0664172768592834, 0.0664942860603333, 0.066571332514286, 0.0666484236717224, 0.0667255520820618, 0.0668027177453041, 0.0668799206614494, 0.066957138478756, 0.0670344233512878, 0.0671117529273033, 0.06718909740448, 0.0672664865851402, 0.0673439204692841, 0.0674213767051697, 0.0674989074468613, 0.0675764232873917, 0.067654013633728, 0.0677316337823868, 0.0678092688322067, 0.0678869858384132, 0.0679647251963615, 0.0680424943566322, 0.0681202933192253, 0.0681981444358826, 0.0682760551571846, 0.0683539509773254, 0.0684319213032722, 0.0685099065303802, 0.068587951362133, 0.0686660259962082, 0.0687441155314445, 0.0688222721219063, 0.0689004585146904, 0.0689786821603775, 0.0690569579601288, 0.0691352412104607, 0.0692135766148567, 0.0692919716238976, 0.069370374083519, 0.0694488286972046, 0.0695273131132126, 0.0696058422327042, 0.0696844235062599, 0.0697630122303963, 0.0698416605591774, 0.0699203312397003, 0.0699990466237068, 0.0700777992606163, 0.0701565891504288, 0.0702354237437248, 0.0703143179416656, 0.0703931972384453, 0.0704721584916115, 0.0705511346459389, 0.0706301555037498, 0.0707092136144638, 0.0707883015275002, 0.0708674266934395, 0.0709466189146042, 0.0710258409380913, 0.0711050778627396, 0.0711843594908714, 0.0712636932730675, 0.0713430568575859, 0.0714224502444267, 0.0715018957853317, 0.0715813636779785, 0.0716608688235283, 0.0717404186725616, 0.071820005774498, 0.0718996375799179, 0.0719792991876602, 0.0720589905977249, 0.0721387341618538, 0.0722185224294662, 0.0722983479499817, 0.0723781883716583, 0.0724580883979797, 0.0725380107760429, 0.0726179778575897, 0.0726979896426201, 0.0727780163288116, 0.072858102619648, 0.0729382336139679, 0.0730183869600296, 0.0730985775589943, 0.0731787979602814, 0.0732590854167938, 0.0733393877744675, 0.0734197348356247, 0.0735001340508461, 0.0735805556178093, 0.0736610069870949, 0.0737414956092834, 0.0738220661878586, 0.0739026367664337, 0.0739832296967506, 0.0740638822317123, 0.074144572019577, 0.0742253065109253, 0.0743060633540154, 0.0743868499994278, 0.074467696249485, 0.0745485723018646, 0.0746294856071472, 0.0747104436159134, 0.0747914239764214, 0.0748724564909935, 0.074953518807888, 0.0750346407294273, 0.0751157775521278, 0.0751969441771507, 0.0752781629562378, 0.0753594413399696, 0.0754407346248627, 0.0755220577120781, 0.0756034329533577, 0.0756848230957985, 0.0757662877440453, 0.0758477598428726, 0.0759292840957642, 0.0760108456015587, 0.0760924369096756, 0.0761740878224373, 0.076255738735199, 0.076337456703186, 0.0764192119240761, 0.0765010043978691, 0.0765828266739845, 0.0766646862030029, 0.0767465829849243, 0.0768285244703293, 0.0769105106592178, 0.0769925266504288, 0.0770745575428009, 0.0771566554903984, 0.0772388055920601, 0.0773209631443024, 0.0774031654000282, 0.0774853900074959, 0.0775676742196083, 0.0776499956846237, 0.0777323469519615, 0.0778147503733635, 0.0778971686959267, 0.077979639172554, 0.0780621543526649, 0.0781446918845177, 0.078227274119854, 0.0783099085092545, 0.0783925428986549, 0.078475259244442, 0.0785579904913902, 0.0786407589912415, 0.0787235796451569, 0.0788063928484917, 0.0788892954587936, 0.078972227871418, 0.0790551826357841, 0.0791381970047951, 0.079221211373806, 0.0793042853474617, 0.0793874338269234, 0.0794705674052238, 0.0795537531375885, 0.0796369761228561, 0.0797202438116074, 0.0798035636544228, 0.0798868983983994, 0.0799702778458595, 0.0800536870956421, 0.0801371335983276, 0.080220639705658, 0.0803041607141495, 0.0803877338767052, 0.0804713293910027, 0.0805549770593643, 0.080638661980629, 0.0807223841547966, 0.0808061435818672, 0.080889917910099, 0.0809737741947174, 0.0810576304793358, 0.0811415463685989, 0.0812254846096039, 0.0813094675540924, 0.0813934803009033, 0.081477552652359, 0.0815616548061371, 0.0816458016633987, 0.0817299485206604, 0.081814169883728, 0.0818984284996986, 0.0819827169179916, 0.0820670425891876, 0.0821513906121254, 0.0822357982397079, 0.0823202431201935, 0.0824047103524208, 0.0824892371892929, 0.0825737863779068, 0.0826583877205849, 0.0827430039644241, 0.0828276872634888, 0.0829124078154564, 0.0829971134662628, 0.083081915974617, 0.083166740834713, 0.0832515731453896, 0.0833364874124527, 0.0834214016795158, 0.0835063755512238, 0.0835914015769958, 0.0836764276027679, 0.0837615206837654, 0.0838466510176659, 0.0839317888021469, 0.0840170085430145, 0.0841022208333015, 0.0841875001788139, 0.0842728316783905, 0.0843581631779671, 0.084443561732769, 0.084528960287571, 0.0846144482493401, 0.0846999511122704, 0.084785483777523, 0.0848710536956787, 0.0849566608667374, 0.0850423201918602, 0.085128016769886, 0.0852137356996536, 0.0852995067834854, 0.0853853151202202, 0.0854711383581161, 0.0855570212006569, 0.0856429561972618, 0.0857289209961891, 0.0858149006962776, 0.0859009250998497, 0.0859870091080666, 0.0860731080174446, 0.0861592665314674, 0.0862454250454903, 0.0863316655158997, 0.0864179208874702, 0.0865042135119438, 0.086590550839901, 0.0866769254207611, 0.0867633149027824, 0.0868497863411903, 0.0869362577795982, 0.0870227888226509, 0.0871093571186066, 0.0871959403157234, 0.087282583117485, 0.0873692557215691, 0.0874559804797173, 0.0875427275896072, 0.087629497051239, 0.0877163410186768, 0.0878031998872757, 0.0878901109099388, 0.0879770442843437, 0.0880640000104904, 0.0881510376930237, 0.0882380902767181, 0.0883251875638962, 0.0884123221039772, 0.0884994715452194, 0.0885866805911064, 0.0886739417910576, 0.0887612253427505, 0.0888485237956047, 0.0889358893036842, 0.0890232846140862, 0.0891107246279716, 0.0891982018947601, 0.0892857164144516, 0.0893732458353043, 0.0894608497619629, 0.0895484611392021, 0.0896361246705055, 0.0897238329052925, 0.0898115485906601, 0.0898993238806725, 0.0899871438741684, 0.0900749862194061, 0.0901628881692886, 0.0902507901191711, 0.0903387740254402, 0.0904267728328705, 0.0905148163437843, 0.0906028971076012, 0.0906909853219986, 0.090779148042202, 0.090867355465889, 0.0909555777907372, 0.0910438522696495, 0.0911321267485619, 0.0912204831838608, 0.0913088545203209, 0.0913972780108452, 0.0914857462048531, 0.0915742367506027, 0.0916627570986748, 0.0917513519525528, 0.0918399542570114, 0.0919286161661148, 0.0920172780752182, 0.0921060144901276, 0.0921947658061981, 0.0922835543751717, 0.0923723950982094, 0.0924612805247307, 0.0925501734018326, 0.092639148235321, 0.0927281230688095, 0.0928171500563622, 0.0929062068462372, 0.0929953008890152, 0.0930844470858574, 0.093173623085022, 0.0932628363370895, 0.0933520868420601, 0.0934413745999336, 0.0935307145118713, 0.0936200693249702, 0.0937094762921333, 0.0937989205121994, 0.0938883945345879, 0.0939779058098793, 0.0940674543380737, 0.0941570475697517, 0.0942466929554939, 0.0943363457918167, 0.0944260582327843, 0.0945158004760742, 0.0946055948734283, 0.0946954190731049, 0.0947852656245232, 0.0948751717805862, 0.0949651151895523, 0.0950550809502602, 0.0951450914144516, 0.0952351465821266, 0.095325231552124, 0.095415361225605, 0.0955055132508278, 0.0955957099795341, 0.0956859439611435, 0.0957762375473976, 0.0958665385842323, 0.0959568843245506, 0.0960472822189331, 0.0961377024650574, 0.0962281674146652, 0.0963186845183372, 0.0964092090725899, 0.0964998006820679, 0.0965904071927071, 0.0966810658574104, 0.0967717617750168, 0.0968624725937843, 0.0969532579183578, 0.097044050693512, 0.0971349030733109, 0.0972257852554321, 0.097316712141037, 0.097407653927803, 0.0974986404180527, 0.0975897014141083, 0.0976807698607445, 0.0977718681097031, 0.0978630185127258, 0.0979542210698128, 0.0980454236268997, 0.0981366783380508, 0.0982279926538467, 0.098319336771965, 0.0984107032418251, 0.09850212931633, 0.0985935777425766, 0.0986850559711456, 0.0987765789031982, 0.0988681465387344, 0.098959743976593, 0.0990513861179352, 0.0991430580615997, 0.0992347821593285, 0.0993265360593796, 0.0994183272123337, 0.0995101481676102, 0.0996020138263702, 0.0996939316391945, 0.0997858718037605, 0.0998778343200684, 0.0999698638916016, 0.100061908364296, 0.100154019892216, 0.100246146321297, 0.100338317453861, 0.100430518388748, 0.100522756576538, 0.100615054368973, 0.100707374513149, 0.100799724459648, 0.100892126560211, 0.100984551012516, 0.101077027618885, 0.101169556379318, 0.101262092590332, 0.10135468095541, 0.101447321474552, 0.101539976894855, 0.101632677018642, 0.101725414395332, 0.101818211376667, 0.101911023259163, 0.102003864943981, 0.102096758782864, 0.102189682424068, 0.102282650768757, 0.102375656366348, 0.102468699216843, 0.10256177932024, 0.102654881775379, 0.102748043835163, 0.10284124314785, 0.102934472262859, 0.103027746081352, 0.103121042251587, 0.103214375674725, 0.103307776153088, 0.103401191532612, 0.1034946590662, 0.10358814150095, 0.103681676089764, 0.103775262832642, 0.103868864476681, 0.103962518274784, 0.104056186974049, 0.104149922728539, 0.104243688285351, 0.104337468743324, 0.104431323707104, 0.104525215923786, 0.104619108140469, 0.104713059961796, 0.104807056486607, 0.10490109026432, 0.104995153844357, 0.105089254677296, 0.105183407664299, 0.105277560651302, 0.105371788144112, 0.105466052889824, 0.105560332536697, 0.105654671788216, 0.105749033391476, 0.10584345459938, 0.105937890708447, 0.106032364070415, 0.10613139718771, 0.106234952807426, 0.106338545680046, 0.106442123651505, 0.106545686721802, 0.106649279594421, 0.10675286501646, 0.10685645788908, 0.10696005821228, 0.107063643634319, 0.1071672514081, 0.107270836830139, 0.107374459505081, 0.107478067278862, 0.107581675052643, 0.107685290277004, 0.107788905501366, 0.107892528176308, 0.10799615085125, 0.108099773526192, 0.108203396201134, 0.108307041227818, 0.10841066390276, 0.108514316380024, 0.108617946505547, 0.10872159153223, 0.108825251460075, 0.108928889036179, 0.109032556414604, 0.109136193990707, 0.109239861369133, 0.109343536198139, 0.109447196125984, 0.10955087095499, 0.109654530882835, 0.109758213162422, 0.109861887991428, 0.109965570271015, 0.110069260001183, 0.110172934830189, 0.110276624560356, 0.110380329191685, 0.110484018921852, 0.1105877161026, 0.110691420733929, 0.110795117914677, 0.110898844897747, 0.111002542078495, 0.111106254160404, 0.111209973692894, 0.111313693225384, 0.111417420208454, 0.111521132290363, 0.111624866724014, 0.111728623509407, 0.111832343041897, 0.111936084926128, 0.112039819359779, 0.112143576145172, 0.112247325479984, 0.112351067364216, 0.112454831600189, 0.112558580935001, 0.112662345170975, 0.112766101956367, 0.112869866192341, 0.112973645329475, 0.113077394664288, 0.113181181252003, 0.113284975290298, 0.113388739526272, 0.113492533564568, 0.113596297800541, 0.113700106739998, 0.113803893327713, 0.113907687366009, 0.114011488854885, 0.114115282893181, 0.114219099283218, 0.114322915673256, 0.114426709711552, 0.11453054100275, 0.114634349942207, 0.114738166332245, 0.114841997623444, 0.114945806562901, 0.11504965275526, 0.11515349149704, 0.115257322788239, 0.115361168980598, 0.115465007722378, 0.115568846464157, 0.115672700107098, 0.115776538848877, 0.115880407392979, 0.115984238684177, 0.11608812212944, 0.116191983222961, 0.116295844316483, 0.116399712860584, 0.116503588855267, 0.116607472300529, 0.116711355745792, 0.116815216839314, 0.116919107735157, 0.117022983729839, 0.117126882076263, 0.117230780422688, 0.11733466386795, 0.117438577115536, 0.11754247546196, 0.117646373808384, 0.11775029450655, 0.117854192852974, 0.11795811355114, 0.118062026798725, 0.118165954947472, 0.118269875645638, 0.118373811244965, 0.118477746844292, 0.118581667542458, 0.118685595691204, 0.118789546191692, 0.118893481791019, 0.118997439742088, 0.119101382791996, 0.119205325841904, 0.119309283792973, 0.119413234293461, 0.11951719969511, 0.11962116509676, 0.119725130498409, 0.11982911080122, 0.119933068752289, 0.120037041604519, 0.12014102935791, 0.12024500221014, 0.120348989963531, 0.120452962815762, 0.120556950569153, 0.120660960674286, 0.120764948427677, 0.12086895853281, 0.120972946286201, 0.121076963841915, 0.121180966496468, 0.12128496915102, 0.121389001607895, 0.121493004262447, 0.121597036719322, 0.121701061725616, 0.12180507928133, 0.121909111738205, 0.12201314419508, 0.122117184102535, 0.12222121655941, 0.122325263917446, 0.122429296374321, 0.122533358633518, 0.122637405991554, 0.122741460800171, 0.122845515608788, 0.122949577867985, 0.123053640127182, 0.123157702386379, 0.123261779546738, 0.123365849256516, 0.123469926416874, 0.123574011027813, 0.12367807328701, 0.12378217279911, 0.123886249959469, 0.123990349471569, 0.124094434082508, 0.124198533594608, 0.124302640557289, 0.124406732618809, 0.124510832130909, 0.12461494654417, 0.124719068408012, 0.124823167920113, 0.124927282333374, 0.125031396746635, 0.125135540962219, 0.125239670276642, 0.125343814492226, 0.125447943806648, 0.12555205821991, 0.125656217336655, 0.125760331749916, 0.125864505767822, 0.125968649983406, 0.12607279419899, 0.126176953315735, 0.126281097531319, 0.126385256648064, 0.12648943066597, 0.126593589782715, 0.126697763800621, 0.126801937818527, 0.126906111836433, 0.127010300755501, 0.127114474773407, 0.127218648791313, 0.127322837710381, 0.127427026629448, 0.127531230449677, 0.127635419368744, 0.127739623188972, 0.12784381210804, 0.12794803082943, 0.128052234649658, 0.128156438469887, 0.128260672092438, 0.128364875912666, 0.128469109535217, 0.128573328256607, 0.128677546977997, 0.128781795501709, 0.128886014223099, 0.12899024784565, 0.129094496369362, 0.129198729991913, 0.129302978515625, 0.129407241940498, 0.129511475563049, 0.129615724086761, 0.129719987511635, 0.129824236035347, 0.129928514361382, 0.130032777786255, 0.130137041211128, 0.130241304636002, 0.130345597863197, 0.130449876189232, 0.130554139614105, 0.130658447742462, 0.130762711167336, 0.130867019295692, 0.130971312522888, 0.131075605750084, 0.131179913878441, 0.131284207105637, 0.131388515233994, 0.13149282336235, 0.131597131490707, 0.131701454520226, 0.131805762648582, 0.131910085678101, 0.132014408707619, 0.132118731737137, 0.132223069667816, 0.132327407598495, 0.132431730628014, 0.132536068558693, 0.132640406489372, 0.132744759321213, 0.132849112153053, 0.132953464984894, 0.133057817816734, 0.133162170648575, 0.133266538381577, 0.133370906114578, 0.133475258946419, 0.133579641580582, 0.133684009313583, 0.133788377046585, 0.133892759680748, 0.13399712741375, 0.134101510047913, 0.134205907583237, 0.134310305118561, 0.134414702653885, 0.134519085288048, 0.134623497724533, 0.134727880358696, 0.134832292795181, 0.134936720132828, 0.135041117668152, 0.135145530104637, 0.135249942541122, 0.135354369878769, 0.135458812117577, 0.135563224554062, 0.13566766679287, 0.135772094130516, 0.135876536369324, 0.135980978608131, 0.136085391044617, 0.136189848184586, 0.136294305324554, 0.136398747563362, 0.136503204703331, 0.1366076618433, 0.136712118983269, 0.136816591024399, 0.136921048164368, 0.137025520205498, 0.137129992246628, 0.137234464287758, 0.137338951230049, 0.137443423271179, 0.137547925114632, 0.137652397155762, 0.137756898999214, 0.137861400842667, 0.137965887784958, 0.13807038962841, 0.138174876570702, 0.138279393315315, 0.138383910059929, 0.138488411903381, 0.138592943549156, 0.138697445392609, 0.138801962137222, 0.138906493782997, 0.139011025428772, 0.139115542173386, 0.139220088720322, 0.139324620366096, 0.139429152011871, 0.139533683657646, 0.139638245105743, 0.139742791652679, 0.139847338199615, 0.139951899647713, 0.14005646109581, 0.140161007642746, 0.140265583992004, 0.14037013053894, 0.14047472178936, 0.140579283237457, 0.140683859586716, 0.140788450837135, 0.140893027186394, 0.140997618436813, 0.141102194786072, 0.141206786036491, 0.141311377286911, 0.141415968537331, 0.141520574688911, 0.141625180840492, 0.141729772090912, 0.141834393143654, 0.141939014196396, 0.142043605446815, 0.142148226499557, 0.142252847552299, 0.142357468605042, 0.142462104558945, 0.142566740512848, 0.14267136156559, 0.142775997519493, 0.142880648374557, 0.142985284328461, 0.143089935183525, 0.143194571137428, 0.143299236893654, 0.143403887748718, 0.143508538603783, 0.143613204360008, 0.143717870116234, 0.143822535872459, 0.143927201628685, 0.144031867384911, 0.144136548042297, 0.144241228699684, 0.144345924258232, 0.144450590014458, 0.144555270671844, 0.144659966230392, 0.144764676690102, 0.144869357347488, 0.144974067807198, 0.145078763365746, 0.145183473825455, 0.145288199186325, 0.145392879843712, 0.145497620105743, 0.145602315664291, 0.145707041025162, 0.145811781287193, 0.145916491746902, 0.146021246910095, 0.146125957369804, 0.146230712532997, 0.146335437893867, 0.146440178155899, 0.146544933319092, 0.146649673581123, 0.146754413843155, 0.14685919880867, 0.146963939070702, 0.147068709135056, 0.147173464298248, 0.147278234362602, 0.147383004426956, 0.14748777449131, 0.147592544555664, 0.147697329521179, 0.147802114486694, 0.147906899452209, 0.148011684417725, 0.14811646938324, 0.148221269249916, 0.148326069116592, 0.148430868983269, 0.148535653948784, 0.148640468716621, 0.148745283484459, 0.148850083351135, 0.148954898118973, 0.149059727787971, 0.149164542555809, 0.149269372224808, 0.149374186992645, 0.149479046463966, 0.149583876132965, 0.149688705801964, 0.149793535470963, 0.149898380041122, 0.150003239512444, 0.150108084082603, 0.150212928652763, 0.150317788124084, 0.150422632694244, 0.150527492165565, 0.150632366538048, 0.15073724091053, 0.150842100381851, 0.150946974754333, 0.151051834225655, 0.151156723499298, 0.15126159787178, 0.151366502046585, 0.151471361517906, 0.151576265692711, 0.151681169867516, 0.151786059141159, 0.151890963315964, 0.151995852589607, 0.152100771665573, 0.152205675840378, 0.152310580015182, 0.15241551399231, 0.152520418167114, 0.15262533724308, 0.152730271220207, 0.152835190296173, 0.152940139174461, 0.153045058250427, 0.153149992227554, 0.153254941105843, 0.15335987508297, 0.153464823961258, 0.153569757938385, 0.153674721717834, 0.153779685497284, 0.153884634375572, 0.15398958325386, 0.154094561934471, 0.154199510812759, 0.154304504394531, 0.154409468173981, 0.154514446854591, 0.154619425535202, 0.154724389314651, 0.154829382896423, 0.154934376478195, 0.155039370059967, 0.155144363641739, 0.155249357223511, 0.155354365706444, 0.155459359288216, 0.155564367771149, 0.155669376254082, 0.155774384737015, 0.155879408121109, 0.155984401702881, 0.156089439988136, 0.156194463372231, 0.156299486756325, 0.156404539942741, 0.156509563326836, 0.156614601612091, 0.156719639897346, 0.156824663281441, 0.156929731369019, 0.157034769654274, 0.157139822840691, 0.157244861125946, 0.157349929213524, 0.157455012202263, 0.157560080289841, 0.157665118575096, 0.157770216464996, 0.157875284552574, 0.157980352640152, 0.158085435628891, 0.158190503716469, 0.158295586705208, 0.158400684595108, 0.158505767583847, 0.158610880374908, 0.158715948462486, 0.158821046352386, 0.158926159143448, 0.159031271934509, 0.159136384725571, 0.159241482615471, 0.159346610307693, 0.159451723098755, 0.159556835889816, 0.159661963582039, 0.159767091274261, 0.159872233867645, 0.159977361559868, 0.16008248925209, 0.160187631845474, 0.160292774438858, 0.160397917032242, 0.160503089427948, 0.160608202219009, 0.160713389515877, 0.160818532109261, 0.160923704504967, 0.161028847098351, 0.161134034395218, 0.161239206790924, 0.16134437918663, 0.161449551582336, 0.161554723978043, 0.161659896373749, 0.161765098571777, 0.161870270967484, 0.161975458264351, 0.162080675363541, 0.162185847759247, 0.162291064858437, 0.162396267056465, 0.162501454353333, 0.162606671452522, 0.162711888551712, 0.162817105650902, 0.162922322750092, 0.163027539849281, 0.163132771849632, 0.163238003849983, 0.163343220949173, 0.163448467850685, 0.163553699851036, 0.163658931851387, 0.16376419365406, 0.163869425654411, 0.163974672555923, 0.164079919457436, 0.164185166358948, 0.164290443062782, 0.164395704865456, 0.164500951766968, 0.164606228470802, 0.164711490273476, 0.164816781878471, 0.164922058582306, 0.16502733528614, 0.165132611989975, 0.165237903594971, 0.165343180298805, 0.165448471903801, 0.165553778409958, 0.165659055113792, 0.165764376521111, 0.165869668126106, 0.165974959731102, 0.16608028113842, 0.166185602545738, 0.166290909051895, 0.166396215558052, 0.16650153696537, 0.166606873273849, 0.166712209582329, 0.166817530989647, 0.166922882199287, 0.167028203606606, 0.167133525013924, 0.167238891124725, 0.167344227433205, 0.167449578642845, 0.167554944753647, 0.167660281062126, 0.167765647172928, 0.167870998382568, 0.16797636449337, 0.168081745505333, 0.168187111616135, 0.168292492628098, 0.16839787364006, 0.168503224849701, 0.168608620762825, 0.168714001774788, 0.168819382786751, 0.168924778699875, 0.16903018951416, 0.169135585427284, 0.169240981340408, 0.169346377253532, 0.169451773166656, 0.169557169079781, 0.169662609696388, 0.169768005609512, 0.16987344622612, 0.169978857040405, 0.170084282755852, 0.170189708471298, 0.170295149087906, 0.170400574803352, 0.17050601541996, 0.170611456036568, 0.170716896653175, 0.170822352170944, 0.170927792787552, 0.171033218502998, 0.17113870382309, 0.17124417424202, 0.171349599957466, 0.171455070376396, 0.171560540795326, 0.171666011214256, 0.171771481633186, 0.171876952052116, 0.171982437372208, 0.172087907791138, 0.17219340801239, 0.172298923134804, 0.172404393553734, 0.172509893774986, 0.172615364193916, 0.17272087931633, 0.172826379537582, 0.172931894659996, 0.173037394881248, 0.173142910003662, 0.173248410224915, 0.173353955149651, 0.173459470272064, 0.173565000295639, 0.173670515418053, 0.173776045441628, 0.173881575465202, 0.173987120389938, 0.174092665314674, 0.17419821023941, 0.174303755164146, 0.174409300088882, 0.174514845013618, 0.174620404839516, 0.174725964665413, 0.174831509590149, 0.174937084317207, 0.175042659044266, 0.175148218870163, 0.175253793597221, 0.175359383225441, 0.175464957952499, 0.175570547580719, 0.175676122307777, 0.175781697034836, 0.175887286663055, 0.175992891192436, 0.176098480820656, 0.176204100251198, 0.176309689879417, 0.176415294408798, 0.17652091383934, 0.17662650346756, 0.176732152700424, 0.176837772130966, 0.176943391561508, 0.17704901099205, 0.177154630422592, 0.177260264754295, 0.177365899085999, 0.177471548318863, 0.177577167749405, 0.177682816982269, 0.177788481116295, 0.177894100546837, 0.177999764680862, 0.178105399012566, 0.178211078047752, 0.178316742181778, 0.178422406315804, 0.178528070449829, 0.178633749485016, 0.17873939871788, 0.178845092654228, 0.178950771689415, 0.179056435823441, 0.179162129759789, 0.179267823696136, 0.179373502731323, 0.179479196667671, 0.179584890604019, 0.179690599441528, 0.179796308279037, 0.179902002215385, 0.180007725954056, 0.180113419890404, 0.180219158530235, 0.180324867367744, 0.180430576205254, 0.180536285042763, 0.180642053484917, 0.180747777223587, 0.180853515863419, 0.180959239602089, 0.181064963340759, 0.181170731782913, 0.181276455521584, 0.181382223963737, 0.181487962603569, 0.181593731045723, 0.181699499487877, 0.181805238127708, 0.181911006569862, 0.182016775012016, 0.182122573256493, 0.182228326797485, 0.182334095239639, 0.182439878582954, 0.18254566192627, 0.182651445269585, 0.1827572286129, 0.182863026857376, 0.182968825101852, 0.183074623346329, 0.183180406689644, 0.18328620493412, 0.183392032980919, 0.183497831225395, 0.183603644371033, 0.18370945751667, 0.183815285563469, 0.183921113610268, 0.184026941657066, 0.184132739901543, 0.184238582849503, 0.184344425797462, 0.184450253844261, 0.184556096792221, 0.184661954641342, 0.184767782688141, 0.184873640537262, 0.184979483485222, 0.185085341334343, 0.185191228985786, 0.185297057032585, 0.185402914881706, 0.185508772730827, 0.185614660382271, 0.185720533132553, 0.185826420783997, 0.18593230843544, 0.186038136482239, 0.186144083738327, 0.186249971389771, 0.186355844140053, 0.186461731791496, 0.18656761944294, 0.186673536896706, 0.18677943944931, 0.186885356903076, 0.186991259455681, 0.187097132205963, 0.187203079462051, 0.187308996915817, 0.187414944171906, 0.187520831823349, 0.187626764178276, 0.187732711434364, 0.187838613986969, 0.187944561243057, 0.188050493597984, 0.188156455755234, 0.188262403011322, 0.18836835026741, 0.188474297523499, 0.188580259680748, 0.188686236739159, 0.188792183995247, 0.188898146152496, 0.189004108309746, 0.189110085368156, 0.189216077327728, 0.189322039484978, 0.189428001642227, 0.189533993601799, 0.18963997066021, 0.189745962619781, 0.189851984381676, 0.189957946538925, 0.190063938498497, 0.19016994535923, 0.190275967121124, 0.190381973981857, 0.190487965941429, 0.190593972802162, 0.190699994564056, 0.190806016325951, 0.190912052989006, 0.191018044948578, 0.191124111413956, 0.19123013317585, 0.191336154937744, 0.1914421916008, 0.191548228263855, 0.191654279828072, 0.191760316491127, 0.191866382956505, 0.19197241961956, 0.192078471183777, 0.192184522747993, 0.192290589213371, 0.192396685481071, 0.192502737045288, 0.192608803510666, 0.192714884877205, 0.192820936441422, 0.192927017807961, 0.193033114075661, 0.193139210343361, 0.193245276808739, 0.193351373076439, 0.193457469344139, 0.193563565611839, 0.193669676780701, 0.193775787949562, 0.193881869316101, 0.193987980484962, 0.194094091653824, 0.194200232625008, 0.194306343793869, 0.19441245496273, 0.194518581032753, 0.194624707102776, 0.194730848073959, 0.194836989045143, 0.194943115115166, 0.195049256086349, 0.195155397057533, 0.195261523127556, 0.195367693901062, 0.195473834872246, 0.195579990744591, 0.195686161518097, 0.195792317390442, 0.195898488163948, 0.196004658937454, 0.196110814809799, 0.196217000484467, 0.196323156356812, 0.196429342031479, 0.196535527706146, 0.196641728281975, 0.196747899055481, 0.19685409963131, 0.196960300207138, 0.197066485881805, 0.197172686457634, 0.197278901934624, 0.197385117411613, 0.197491317987442, 0.197597518563271, 0.197703763842583, 0.197809964418411, 0.197916179895401, 0.198022410273552, 0.198128640651703, 0.198234871029854, 0.198341086506844, 0.198447346687317, 0.198553562164307, 0.198659837245941, 0.198766067624092, 0.198872312903404, 0.198978558182716, 0.19908481836319, 0.199191093444824, 0.199297353625298, 0.199403613805771, 0.199509873986244, 0.199616149067879, 0.199722424149513, 0.199828699231148, 0.199934974312782, 0.200041249394417, 0.200147539377213, 0.200253844261169, 0.200360119342804, 0.2004664093256, 0.200572699308395, 0.200679019093513, 0.20078532397747, 0.200891643762589, 0.200997918844223, 0.20110422372818, 0.20121057331562, 0.201316893100739, 0.201423197984695, 0.201529532670975, 0.201635867357254, 0.201742172241211, 0.201848521828651, 0.201954856514931, 0.20206119120121, 0.202167540788651, 0.202273890376091, 0.202380239963531, 0.202486589550972, 0.202592939138412, 0.202699318528175, 0.202805668115616, 0.202912017703056, 0.203018397092819, 0.203124761581421, 0.203231140971184, 0.203337505459785, 0.20344389975071, 0.203550264239311, 0.203656688332558, 0.203763037919998, 0.203869462013245, 0.203975841403008, 0.204082235693932, 0.204188629984856, 0.204295039176941, 0.204401448369026, 0.204507872462273, 0.204614266753197, 0.204720690846443, 0.20482711493969, 0.204933539032936, 0.205039963126183, 0.205146387219429, 0.205252811312675, 0.205359250307083, 0.205465689301491, 0.205572128295898, 0.205678567290306, 0.205785006284714, 0.205891475081444, 0.205997914075851, 0.20610436797142, 0.206210821866989, 0.206317290663719, 0.206423744559288, 0.206530198454857, 0.206636697053909, 0.206743165850639, 0.206849649548531, 0.206956118345261, 0.207062616944313, 0.207169100642204, 0.207275584340096, 0.207382068037987, 0.207488551735878, 0.20759505033493, 0.207701563835144, 0.207808077335358, 0.20791457593441, 0.208021089434624, 0.208127602934837, 0.208234116435051, 0.208340629935265, 0.208447143435478, 0.208553671836853, 0.208660215139389, 0.208766758441925, 0.208873257040977, 0.208979815244675, 0.209086358547211, 0.209192901849747, 0.209299430251122, 0.209405973553658, 0.209512516856194, 0.209619089961052, 0.20972566306591, 0.209832236170769, 0.209938779473305, 0.210045352578163, 0.210151895880699, 0.210258513689041, 0.210365071892738, 0.210471644997597, 0.210578233003616, 0.210684835910797, 0.210791423916817, 0.210897997021675, 0.211004599928856, 0.211111187934875, 0.211218118667603, 0.211325258016586, 0.211432337760925, 0.211539387702942, 0.211646348237991, 0.211753323674202, 0.211860209703445, 0.211967051029205, 0.21207383275032, 0.212180554866791, 0.212287232279778, 0.212393864989281, 0.2125004529953, 0.212606966495514, 0.212713465094566, 0.212819889187813, 0.212926283478737, 0.213032588362694, 0.213138863444328, 0.213245093822479, 0.213351249694824, 0.213457375764847, 0.213563457131386, 0.21366947889328, 0.213775441050529, 0.213881358504295, 0.213987216353416, 0.214093029499054, 0.214198812842369, 0.214304521679878, 0.214410170912743, 0.214515775442123, 0.214621335268021, 0.214726850390434, 0.214832291007042, 0.214937716722488, 0.215043053030968, 0.215148359537125, 0.215253636240959, 0.215358808636665, 0.21546396613121, 0.215569064021111, 0.215674117207527, 0.21577912569046, 0.215884059667587, 0.215988948941231, 0.216093778610229, 0.216198593378067, 0.216303333640099, 0.216407999396324, 0.216512635350227, 0.216617226600647, 0.216721788048744, 0.216826260089874, 0.216930687427521, 0.217035084962845, 0.217139407992363, 0.217243686318398, 0.217347919940948, 0.217452108860016, 0.217556223273277, 0.217660307884216, 0.217764317989349, 0.217868328094482, 0.217972218990326, 0.218076094985008, 0.218179941177368, 0.218283697962761, 0.21838741004467, 0.218491092324257, 0.218594700098038, 0.218698263168335, 0.218801751732826, 0.218905240297318, 0.219008639454842, 0.219112008810043, 0.2192153185606, 0.219318583607674, 0.219421789050102, 0.219524934887886, 0.219628036022186, 0.219731092453003, 0.219834104180336, 0.219937041401863, 0.220039933919907, 0.220142796635628, 0.220245614647865, 0.220348343253136, 0.220451027154922, 0.220553681254387, 0.220656290650368, 0.220758810639381, 0.220861315727234, 0.220963761210442, 0.221066161990166, 0.221168473362923, 0.221270769834518, 0.221373021602631, 0.221475198864937, 0.221577346324921, 0.221679404377937, 0.221781447529793, 0.221883401274681, 0.221985355019569, 0.222087234258652, 0.222189053893089, 0.222290843725204, 0.222392544150352, 0.2224942445755, 0.222595855593681, 0.22269743680954, 0.222798943519592, 0.222900420427322, 0.223001852631569, 0.223103225231171, 0.223204523324966, 0.223305776715279, 0.223407000303268, 0.223508164286613, 0.223609283566475, 0.22371032834053, 0.223811343312263, 0.223912313580513, 0.224013209342957, 0.224114075303078, 0.224214851856232, 0.224315613508224, 0.224416330456734, 0.224516972899437, 0.224617570638657, 0.224718123674393, 0.224818617105484, 0.224919065833092, 0.225019484758377, 0.225119799375534, 0.225220113992691, 0.225320354104042, 0.225420534610748, 0.225520685315132, 0.225620776414871, 0.225720807909966, 0.225820779800415, 0.225920721888542, 0.226020604372025, 0.226120442152023, 0.226220235228539, 0.226319968700409, 0.226419657468796, 0.226519271731377, 0.226618841290474, 0.226718366146088, 0.226817861199379, 0.226917266845703, 0.227016627788544, 0.227115958929062, 0.227215245366096, 0.227314457297325, 0.227413639426231, 0.227512747049332, 0.22761182487011, 0.227710828185081, 0.227809816598892, 0.227908700704575, 0.228007584810257, 0.228106394410133, 0.228205129504204, 0.228303849697113, 0.228402510285378, 0.22850114107132, 0.228599652647972, 0.228698179125786, 0.228796616196632, 0.228895038366318, 0.228993386030197, 0.229091688990593, 0.229189932346344, 0.229288130998611, 0.229386284947395, 0.229484364390373, 0.229582414031029, 0.229680418968201, 0.229778349399567, 0.22987625002861, 0.229974091053009, 0.230071887373924, 0.230169609189034, 0.23026730120182, 0.230364933609962, 0.230462521314621, 0.230560034513474, 0.230657532811165, 0.23075495660305, 0.230852350592613, 0.23094967007637, 0.231046929955482, 0.231144174933434, 0.231241345405579, 0.23133847117424, 0.231435567140579, 0.231532588601112, 0.231629550457001, 0.231726482510567, 0.231823340058327, 0.231920152902603, 0.232016921043396, 0.232113644480705, 0.23221030831337, 0.232306927442551, 0.232403472065926, 0.232499986886978, 0.232596442103386, 0.232692837715149, 0.23278920352459, 0.232885524630547, 0.232981786131859, 0.233077988028526, 0.233174130320549, 0.233270242810249, 0.233366280794144, 0.233462274074554, 0.233558237552643, 0.233654141426086, 0.233749970793724, 0.233845770359039, 0.23394151031971, 0.234037205576897, 0.2341328561306, 0.234228432178497, 0.234323993325233, 0.234419450163841, 0.234514907002449, 0.234610304236412, 0.23470564186573, 0.234800919890404, 0.234896138310432, 0.2349913418293, 0.2350864559412, 0.235181540250778, 0.235276579856873, 0.235371559858322, 0.235466495156288, 0.235561355948448, 0.235656172037125, 0.235750943422318, 0.235845685005188, 0.235940337181091, 0.236034959554672, 0.23612953722477, 0.2362240254879, 0.23631851375103, 0.236412912607193, 0.236507281661034, 0.236601591110229, 0.236695870757103, 0.236790090799332, 0.236884221434593, 0.236978337168694, 0.23707240819931, 0.237166419625282, 0.237260356545448, 0.237354248762131, 0.237448111176491, 0.237541928887367, 0.237635657191277, 0.237729385495186, 0.237823024392128, 0.237916618585587, 0.238010168075562, 0.238103672862053, 0.238197103142738, 0.238290503621101, 0.238383829593658, 0.238477125763893, 0.238570377230644, 0.238663554191589, 0.238756701350212, 0.238849759101868, 0.238942816853523, 0.239035800099373, 0.239128723740578, 0.239221602678299, 0.239314451813698, 0.239407226443291, 0.2394999563694, 0.239592641592026, 0.239685252308846, 0.239777833223343, 0.239870339632034, 0.239962831139565, 0.240055248141289, 0.240147620439529, 0.240239933133125, 0.240332216024399, 0.240424409508705, 0.240516602993011, 0.240608721971512, 0.240700766444206, 0.240792766213417, 0.240884751081467, 0.240976646542549, 0.241068512201309, 0.241160318255424, 0.241252079606056, 0.241343766450882, 0.241435423493385, 0.241527050733566, 0.241618573665619, 0.24171008169651, 0.241801530122757, 0.241892948746681, 0.241984307765961, 0.242075592279434, 0.242166832089424, 0.24225802719593, 0.242349162697792, 0.24244025349617, 0.242531314492226, 0.242622300982475, 0.242713242769241, 0.242804124951363, 0.24289496243, 0.242985755205154, 0.243076488375664, 0.24316717684269, 0.243257790803909, 0.243348374962807, 0.243438899517059, 0.24352939426899, 0.243619829416275, 0.243710190057755, 0.243800520896912, 0.243890807032585, 0.243981018662453, 0.244071185588837, 0.244161307811737, 0.244251370429993, 0.244341403245926, 0.244431376457214, 0.244521290063858, 0.244611144065857, 0.244700953364372, 0.244790732860565, 0.244880437850952, 0.244970098137856, 0.245059698820114, 0.24514926970005, 0.245238780975342, 0.24532824754715, 0.245417639613152, 0.245507001876831, 0.245596304535866, 0.245685562491417, 0.245774760842323, 0.245863899588585, 0.245953008532524, 0.246042042970657, 0.246131062507629, 0.246219992637634, 0.246308892965317, 0.246397718787193, 0.246486529707909, 0.246575266122818, 0.246663957834244, 0.246752604842186, 0.246841192245483, 0.246929720044136, 0.247018218040466, 0.247106641530991, 0.247195020318031, 0.247283354401588, 0.247371658682823, 0.24745985865593, 0.247548058629036, 0.247636154294014, 0.247724249958992, 0.247812286019325, 0.247900247573853, 0.247988164424896, 0.248076036572456, 0.248163878917694, 0.248251646757126, 0.248339369893074, 0.248427018523216, 0.248514637351036, 0.248602211475372, 0.248689711093903, 0.248777166008949, 0.248864591121674, 0.248951971530914, 0.249039262533188, 0.249126523733139, 0.249213725328445, 0.249300882220268, 0.249387994408607, 0.249475046992302, 0.249562054872513, 0.249649003148079, 0.249735906720161, 0.249822750687599, 0.249909549951553, 0.249996304512024, 0.25008299946785, 0.250169634819031, 0.250256240367889, 0.250342786312103, 0.250429272651672, 0.250515699386597, 0.250602126121521, 0.250688433647156, 0.250774711370468, 0.250860959291458, 0.250947147607803, 0.251033306121826, 0.251119375228882, 0.251205414533615, 0.251291364431381, 0.251377314329147, 0.251463204622269, 0.251549035310745, 0.251634806394577, 0.251720517873764, 0.251806199550629, 0.251891821622849, 0.251977384090424, 0.252062916755676, 0.252148389816284, 0.252233803272247, 0.252319186925888, 0.252404510974884, 0.252489745616913, 0.252574950456619, 0.252660125494003, 0.252745240926743, 0.252830296754837, 0.252915322780609, 0.253000259399414, 0.253085166215897, 0.253170043230057, 0.25325483083725, 0.25333958864212, 0.253424286842346, 0.253508925437927, 0.253593534231186, 0.2536780834198, 0.253762602806091, 0.253847032785416, 0.253931432962418, 0.254015773534775, 0.25410008430481, 0.254184305667877, 0.254268527030945, 0.254352658987045, 0.254436731338501, 0.254520773887634, 0.254604756832123, 0.254688709974289, 0.254772573709488, 0.254856437444687, 0.254940211772919, 0.255023956298828, 0.25510761141777, 0.25519123673439, 0.255274832248688, 0.25535836815834, 0.255441844463348, 0.255525261163712, 0.25560861825943, 0.255691945552826, 0.2557752430439, 0.255858451128006, 0.255941599607468, 0.256024718284607, 0.256107807159424, 0.256190836429596, 0.256273806095123, 0.256356686353683, 0.256439566612244, 0.256522357463837, 0.25660514831543, 0.256687819957733, 0.256770491600037, 0.256853103637695, 0.256935656070709, 0.257018178701401, 0.257100611925125, 0.257183015346527, 0.257265359163284, 0.257347673177719, 0.257429927587509, 0.257512122392654, 0.257594257593155, 0.257676362991333, 0.257758408784866, 0.257840394973755, 0.257922351360321, 0.258004248142242, 0.258086055517197, 0.258167862892151, 0.25824961066246, 0.258331298828125, 0.258412927389145, 0.25849449634552, 0.258576065301895, 0.258657515048981, 0.258738964796066, 0.258820354938507, 0.258901655673981, 0.258982926607132, 0.259064167737961, 0.259145349264145, 0.259226471185684, 0.259307563304901, 0.259388595819473, 0.259469538927078, 0.259550452232361, 0.259631335735321, 0.259712159633636, 0.259792894124985, 0.259873628616333, 0.259954303503036, 0.260034918785095, 0.260115474462509, 0.260196000337601, 0.260276436805725, 0.260356843471527, 0.260437220335007, 0.260517537593842, 0.260597795248032, 0.260677993297577, 0.260758131742477, 0.260838240385056, 0.260918259620667, 0.260998278856277, 0.261078238487244, 0.261158138513565, 0.261237978935242, 0.261317789554596, 0.261397510766983, 0.261477202177048, 0.26155686378479, 0.261636435985565, 0.261715978384018, 0.261795461177826, 0.261874884366989, 0.261954307556152, 0.262033641338348, 0.2621129155159, 0.262192159891129, 0.262271344661713, 0.26235044002533, 0.262429535388947, 0.262508571147919, 0.262587547302246, 0.262666463851929, 0.262745350599289, 0.262824177742004, 0.262902945280075, 0.262981683015823, 0.263060331344604, 0.263138979673386, 0.2632175385952, 0.263296067714691, 0.263374537229538, 0.26345294713974, 0.263531297445297, 0.263609617948532, 0.263687878847122, 0.26376610994339, 0.26384425163269, 0.263922363519669, 0.264000415802002, 0.264078408479691, 0.264156371355057, 0.264234274625778, 0.264312148094177, 0.264389932155609, 0.264467716217041, 0.264545410871506, 0.264623045921326, 0.264700651168823, 0.264778196811676, 0.264855682849884, 0.26493313908577, 0.265010505914688, 0.265087872743607, 0.265165150165558, 0.265242367982864, 0.265319585800171, 0.26539671421051, 0.265473812818527, 0.265550851821899, 0.265627831220627, 0.265704751014709, 0.26578164100647, 0.265858471393585, 0.265935242176056, 0.266011983156204, 0.266088664531708, 0.266165286302567, 0.266241848468781, 0.266318380832672, 0.266394853591919, 0.266471266746521, 0.266547650098801, 0.266623973846436, 0.266700237989426, 0.266776442527771, 0.266852617263794, 0.266928732395172, 0.267004787921906, 0.267080813646317, 0.267156779766083, 0.267232686281204, 0.267308562994003, 0.267384350299835, 0.267460107803345, 0.267535805702209, 0.267611473798752, 0.267687082290649, 0.267762631177902, 0.26783812046051, 0.267913579940796, 0.267988979816437, 0.268064320087433, 0.268139600753784, 0.268214881420135, 0.26829007267952, 0.268365204334259, 0.268440306186676, 0.268515348434448, 0.268590331077576, 0.268665254116058, 0.268740177154541, 0.268815010786057, 0.268889784812927, 0.268964529037476, 0.269039213657379, 0.26911386847496, 0.269188404083252, 0.269262969493866, 0.269337445497513, 0.269411861896515, 0.269486248493195, 0.269560545682907, 0.26963484287262, 0.269709050655365, 0.269783228635788, 0.269857347011566, 0.2699314057827, 0.270005434751511, 0.270079433917999, 0.270153343677521, 0.270227193832397, 0.270301014184952, 0.270374774932861, 0.270448476076126, 0.270522147417068, 0.270595759153366, 0.270669341087341, 0.270742833614349, 0.270816296339035, 0.270889669656754, 0.270963042974472, 0.271036356687546, 0.271109610795975, 0.271182835102081, 0.271255970001221, 0.271329045295715, 0.27140212059021, 0.271475106477737, 0.27154803276062, 0.271620959043503, 0.271693795919418, 0.271766573190689, 0.271839320659637, 0.271912008523941, 0.271984666585922, 0.272057265043259, 0.272129774093628, 0.272202283143997, 0.272274702787399, 0.272347062826157, 0.272419422864914, 0.272491693496704, 0.272563934326172, 0.272636115550995, 0.272708237171173, 0.272780328989029, 0.272852331399918, 0.272924304008484, 0.272996246814728, 0.273068100214005, 0.273139923810959, 0.273211687803268, 0.273283421993256, 0.273355066776276, 0.273426711559296, 0.273498266935349, 0.273569792509079, 0.273641228675842, 0.273712664842606, 0.273784011602402, 0.273855328559875, 0.273926585912704, 0.273997813463211, 0.27406895160675, 0.274140059947968, 0.274211138486862, 0.274282097816467, 0.274353086948395, 0.274423986673355, 0.274494826793671, 0.274565637111664, 0.274636387825012, 0.274707078933716, 0.274777710437775, 0.274848282337189, 0.274918854236603, 0.27498933672905, 0.275059789419174, 0.275130152702332, 0.275200515985489, 0.275270789861679, 0.275341033935547, 0.27541121840477, 0.275481373071671, 0.275551468133926, 0.275621503591537, 0.275691449642181, 0.275761395692825, 0.275831252336502, 0.275901079177856, 0.275970876216888, 0.276040583848953, 0.276110261678696, 0.276179879903793, 0.276249468326569, 0.276318997144699, 0.276388466358185, 0.276457875967026, 0.276527255773544, 0.276596546173096, 0.276665836572647, 0.276735067367554, 0.276804208755493, 0.27687332034111, 0.276942372322083, 0.277011394500732, 0.277080327272415, 0.277149260044098, 0.277218103408813, 0.277286916971207, 0.277355670928955, 0.277424365282059, 0.27749302983284, 0.277561634778976, 0.277630180120468, 0.277698665857315, 0.27776712179184, 0.277835518121719, 0.277903884649277, 0.277972131967545, 0.278040409088135, 0.278108596801758, 0.278176724910736, 0.278244823217392, 0.278312861919403, 0.278380841016769, 0.278448790311813, 0.278516680002213, 0.278584510087967, 0.278652280569077, 0.278720021247864, 0.278787702322006, 0.278855353593826, 0.278922915458679, 0.27899044752121, 0.279057919979095, 0.279125332832336, 0.279192715883255, 0.279260069131851, 0.279327303171158, 0.279394537210464, 0.279461711645126, 0.279528826475143, 0.279595881700516, 0.279662907123566, 0.279729872941971, 0.279796808958054, 0.279863625764847, 0.27993044257164, 0.279997229576111, 0.280063927173615, 0.280130594968796, 0.280197203159332, 0.280263751745224, 0.280330270528793, 0.280396729707718, 0.280463129281998, 0.280529469251633, 0.280595779418945, 0.280662029981613, 0.280728220939636, 0.280794352293015, 0.28086045384407, 0.280926495790482, 0.28099250793457, 0.281058430671692, 0.281124323606491, 0.281190156936646, 0.2812559902668, 0.281321704387665, 0.281387388706207, 0.281453043222427, 0.28151860833168, 0.281584143638611, 0.281649619340897, 0.28171506524086, 0.281780451536179, 0.281845778226852, 0.281911045312881, 0.281976282596588, 0.28204146027565, 0.282106578350067, 0.282171666622162, 0.282236695289612, 0.282301664352417, 0.282366544008255, 0.282431453466415, 0.282496273517609, 0.282561033964157, 0.282625764608383, 0.282690405845642, 0.282755017280579, 0.28281956911087, 0.28288409113884, 0.282948583364487, 0.283012956380844, 0.283077359199524, 0.283141613006592, 0.283205896615982, 0.283270090818405, 0.283334255218506, 0.283398330211639, 0.283462405204773, 0.283526420593262, 0.283590346574783, 0.283654242753983, 0.283718079328537, 0.283781886100769, 0.283845633268356, 0.283909350633621, 0.283972978591919, 0.284036546945572, 0.284100115299225, 0.284163594245911, 0.284227043390274, 0.28429040312767, 0.284353762865067, 0.284417033195496, 0.284480273723602, 0.284543454647064, 0.284606575965881, 0.284669667482376, 0.284732699394226, 0.284795701503754, 0.284858614206314, 0.284921497106552, 0.284984290599823, 0.285047084093094, 0.285109788179398, 0.285172462463379, 0.285235106945038, 0.28529766201973, 0.285360187292099, 0.285422652959824, 0.285485059022903, 0.285547405481339, 0.285609751939774, 0.285672008991241, 0.285734206438065, 0.285796374082565, 0.285858482122421, 0.285920560359955, 0.285982549190521, 0.286044508218765, 0.286106407642365, 0.286168247461319, 0.286230057477951, 0.286291837692261, 0.286353528499603, 0.286415189504623, 0.286476790904999, 0.286538302898407, 0.286599814891815, 0.286661237478256, 0.286722630262375, 0.286783993244171, 0.286845266819, 0.286906540393829, 0.286967724561691, 0.287028849124908, 0.287089943885803, 0.287150949239731, 0.287211954593658, 0.287272900342941, 0.287333756685257, 0.287394613027573, 0.287455379962921, 0.287516117095947, 0.287576794624329, 0.287637412548065, 0.287698000669479, 0.287758529186249, 0.287818998098373, 0.287879407405853, 0.287939786911011, 0.288000106811523, 0.288060367107391, 0.288120597600937, 0.288180768489838, 0.288240879774094, 0.288300931453705, 0.288360983133316, 0.288420915603638, 0.288480848073959, 0.288540661334991, 0.288600504398346, 0.288660258054733, 0.288719952106476, 0.288779616355896, 0.288839191198349, 0.288898795843124, 0.28895828127861, 0.289017736911774, 0.289077132940292, 0.289136469364166, 0.289195775985718, 0.289255023002625, 0.289314210414886, 0.289373368024826, 0.289432466030121, 0.289491474628448, 0.289550483226776, 0.289609432220459, 0.289668321609497, 0.28972715139389, 0.289785921573639, 0.289844661951065, 0.289903342723846, 0.289961993694305, 0.29002058506012, 0.290079087018967, 0.290137588977814, 0.290196031332016, 0.290254414081573, 0.290312737226486, 0.290371000766754, 0.2904292345047, 0.290487378835678, 0.290545493364334, 0.290603578090668, 0.290661603212357, 0.290719568729401, 0.2907774746418, 0.290835350751877, 0.290893167257309, 0.290950924158096, 0.291008651256561, 0.291066318750381, 0.291123926639557, 0.29118150472641, 0.291238993406296, 0.291296452283859, 0.291353851556778, 0.291411221027374, 0.291468530893326, 0.291525781154633, 0.291582971811295, 0.291640102863312, 0.291697204113007, 0.291754275560379, 0.291811287403107, 0.29186823964119, 0.291925132274628, 0.291981965303421, 0.29203873872757, 0.292095482349396, 0.2921521961689, 0.292208820581436, 0.29226541519165, 0.29232195019722, 0.292378425598145, 0.292434871196747, 0.292491227388382, 0.292547583580017, 0.292603880167007, 0.292660087347031, 0.292716264724731, 0.29277241230011, 0.292823672294617, 0.292869985103607, 0.29291620850563, 0.292962312698364, 0.293008387088776, 0.293054342269897, 0.293100237846375, 0.293146014213562, 0.293191730976105, 0.29323735833168, 0.293282866477966, 0.293328285217285, 0.293373674154282, 0.293418943881989, 0.293464124202728, 0.293509215116501, 0.293554246425629, 0.293599128723145, 0.293643981218338, 0.293688714504242, 0.293733388185501, 0.293777972459793, 0.293822437524796, 0.293866842985153, 0.293911159038544, 0.293955385684967, 0.293999493122101, 0.294043570756912, 0.294087529182434, 0.294131398200989, 0.294175177812576, 0.294218897819519, 0.294262498617172, 0.294306039810181, 0.2943494617939, 0.294392824172974, 0.294436097145081, 0.294479250907898, 0.294522345066071, 0.294565349817276, 0.294608294963837, 0.294651120901108, 0.294693857431412, 0.294736504554749, 0.294779062271118, 0.294821530580521, 0.294863939285278, 0.294906258583069, 0.294948488473892, 0.294990599155426, 0.295032680034637, 0.295074641704559, 0.295116484165192, 0.295158267021179, 0.2951999604702, 0.295241564512253, 0.295283108949661, 0.29532453417778, 0.295365869998932, 0.295407146215439, 0.295448303222656, 0.295489430427551, 0.295530438423157, 0.295571327209473, 0.295612156391144, 0.295652866363525, 0.295693546533585, 0.295734137296677, 0.295774579048157, 0.295814990997314, 0.295855283737183, 0.295895487070084, 0.29593563079834, 0.295975685119629, 0.296015620231628, 0.296055495738983, 0.296095281839371, 0.296134978532791, 0.296174585819244, 0.29621410369873, 0.296253532171249, 0.296292871236801, 0.296332150697708, 0.296371310949326, 0.296410411596298, 0.296449393033981, 0.296488285064697, 0.296527117490768, 0.296565860509872, 0.296604484319687, 0.296643078327179, 0.296681553125381, 0.296719908714294, 0.296758234500885, 0.296796441078186, 0.29683455824852, 0.296872615814209, 0.296910554170609, 0.296948432922363, 0.296986222267151, 0.297023892402649, 0.297061502933502, 0.297099024057388, 0.297136455774307, 0.297173798084259, 0.297211050987244, 0.297248214483261, 0.297285288572311, 0.297322303056717, 0.297359198331833, 0.297396034002304, 0.297432750463486, 0.297469407320023, 0.29750594496727, 0.297542423009872, 0.297578781843185, 0.297615110874176, 0.297651290893555, 0.297687441110611, 0.297723472118378, 0.2977594435215, 0.297795295715332, 0.297831058502197, 0.297866761684418, 0.297902345657349, 0.297937870025635, 0.297973275184631, 0.298008620738983, 0.298043876886368, 0.298079043626785, 0.298114120960236, 0.298149108886719, 0.298184037208557, 0.298218846321106, 0.298253566026688, 0.298288226127625, 0.298322767019272, 0.298357248306274, 0.298391610383987, 0.298425912857056, 0.298460096120834, 0.298494219779968, 0.298528254032135, 0.298562198877335, 0.298596084117889, 0.298629850149155, 0.298663556575775, 0.298697113990784, 0.29873064160347, 0.298764079809189, 0.298797398805618, 0.298830628395081, 0.298863798379898, 0.298896878957748, 0.298929870128632, 0.298962771892548, 0.298995584249496, 0.299028307199478, 0.299060940742493, 0.29909348487854, 0.299125969409943, 0.299158334732056, 0.299190640449524, 0.299222826957703, 0.299254953861237, 0.299286991357803, 0.299318939447403, 0.299350798130035, 0.299382537603378, 0.299414217472076, 0.299445807933807, 0.299477308988571, 0.29950875043869, 0.299540102481842, 0.299571335315704, 0.299602478742599, 0.29963356256485, 0.299664556980133, 0.299695461988449, 0.299726277589798, 0.299756973981857, 0.299787610769272, 0.299818158149719, 0.299848616123199, 0.299878984689713, 0.299909293651581, 0.299939453601837, 0.299969583749771, 0.299999624490738, 0.300029546022415, 0.300059407949448, 0.300089180469513, 0.300118863582611, 0.300148457288742, 0.300177931785583, 0.300207376480103, 0.300236701965332, 0.300265967845917, 0.30029508471489, 0.30032417178154, 0.300353139638901, 0.300382047891617, 0.300410836935043, 0.300439566373825, 0.300468176603317, 0.300496727228165, 0.300525188446045, 0.30055359005928, 0.300581872463226, 0.300610065460205, 0.300638169050217, 0.300666183233261, 0.300694108009338, 0.300721973180771, 0.300749748945236, 0.300777405500412, 0.300804972648621, 0.300832480192184, 0.300859898328781, 0.300887227058411, 0.300914466381073, 0.300941616296768, 0.300968676805496, 0.300995647907257, 0.301022559404373, 0.3010493516922, 0.301076054573059, 0.301102697849274, 0.301129251718521, 0.301155686378479, 0.301182061433792, 0.301208347082138, 0.301234543323517, 0.301260620355606, 0.301286667585373, 0.30131259560585, 0.30133843421936, 0.301364213228226, 0.301389873027802, 0.30141544342041, 0.301440954208374, 0.301466345787048, 0.301491677761078, 0.30151692032814, 0.301542073488235, 0.301567137241364, 0.301592111587524, 0.301616996526718, 0.301641792058945, 0.301666498184204, 0.301691144704819, 0.301715672016144, 0.301740109920502, 0.301764488220215, 0.301788777112961, 0.301812946796417, 0.301837056875229, 0.301861077547073, 0.301885008811951, 0.301908850669861, 0.301932603120804, 0.30195626616478, 0.301979869604111, 0.30200332403183, 0.302026778459549, 0.302050083875656, 0.302073299884796, 0.302096426486969, 0.302119523286819, 0.30214250087738, 0.302165359258652, 0.302188158035278, 0.302210867404938, 0.30223348736763, 0.302256017923355, 0.302278459072113, 0.302300840616226, 0.302323132753372, 0.302345305681229, 0.30236741900444, 0.302389442920685, 0.30241134762764, 0.30243319272995, 0.302454948425293, 0.302476614713669, 0.302498191595078, 0.302519679069519, 0.302541047334671, 0.302562355995178, 0.302583605051041, 0.302604734897614, 0.302625805139542, 0.302646785974503, 0.302667647600174, 0.302688419818878, 0.30270916223526, 0.302729785442352, 0.302750289440155, 0.302770733833313, 0.302791118621826, 0.30281138420105, 0.302831560373306, 0.302851676940918, 0.30287167429924, 0.302891582250595, 0.302911400794983, 0.302931189537048, 0.302950829267502, 0.302970409393311, 0.30298987030983, 0.303009301424026, 0.303028583526611, 0.303047835826874, 0.303066968917847, 0.303086012601852, 0.303104966878891, 0.303123861551285, 0.303142666816711, 0.303161382675171, 0.303179979324341, 0.303198516368866, 0.303216964006424, 0.303235292434692, 0.303253591060638, 0.303271770477295, 0.303289830684662, 0.303307861089706, 0.303325772285461, 0.303343623876572, 0.303361356258392, 0.303378999233246, 0.303396582603455, 0.303414076566696, 0.303431451320648, 0.303448766469955, 0.303465992212296, 0.303483098745346, 0.303500175476074, 0.303517132997513, 0.303534001111984, 0.303550779819489, 0.303567498922348, 0.303584098815918, 0.303600609302521, 0.303617089986801, 0.30363342165947, 0.303649663925171, 0.30366587638855, 0.303681939840317, 0.303697943687439, 0.303713887929916, 0.303729683160782, 0.303745448589325, 0.303761094808578, 0.303776681423187, 0.303792148828506, 0.303807526826859, 0.303822815418243, 0.303838074207306, 0.303853183984756, 0.303868234157562, 0.303883194923401, 0.303898066282272, 0.303912848234177, 0.303927540779114, 0.303942173719406, 0.303956687450409, 0.303971111774445, 0.303985446691513, 0.303999751806259, 0.304013907909393, 0.30402797460556, 0.304042011499405, 0.304055899381638, 0.304069727659225, 0.304083436727524, 0.3040971159935, 0.304110676050186, 0.304124176502228, 0.304137527942657, 0.304150849580765, 0.304164081811905, 0.304177194833755, 0.304190248250961, 0.304203182458878, 0.304216057062149, 0.304228842258453, 0.304241538047791, 0.304254144430161, 0.304266661405563, 0.304279088973999, 0.304291427135468, 0.304303675889969, 0.304315865039825, 0.304327934980392, 0.304339945316315, 0.304351836442947, 0.304363667964935, 0.304375410079956, 0.30438706278801, 0.304398626089096, 0.304410099983215, 0.304421484470367, 0.304432779550552, 0.30444398522377, 0.304455101490021, 0.304466158151627, 0.304477095603943, 0.304488003253937, 0.304498761892319, 0.304509431123734, 0.304520040750504, 0.304530531167984, 0.30454096198082, 0.304551333189011, 0.30456155538559, 0.304571747779846, 0.304581820964813, 0.304591804742813, 0.304601699113846, 0.304611563682556, 0.304621279239655, 0.304630935192108, 0.304640471935272, 0.304649949073792, 0.304659336805344, 0.304668605327606, 0.304677844047546, 0.304686963558197, 0.30469599366188, 0.304704934358597, 0.304713785648346, 0.30472257733345, 0.304731249809265, 0.304739862680435, 0.304748386144638, 0.304756820201874, 0.30476513504982, 0.304773390293121, 0.304781585931778, 0.304789632558823, 0.304797619581223, 0.304805517196655, 0.304813325405121, 0.304821074008942, 0.304828703403473, 0.304836273193359, 0.304843723773956, 0.304851114749908, 0.304858416318893, 0.304865598678589, 0.30487272143364, 0.304879754781723, 0.304886698722839, 0.304893553256989, 0.304900318384171, 0.304907023906708, 0.304913610219955, 0.304920107126236, 0.304926544427872, 0.304932862520218, 0.304939121007919, 0.304945260286331, 0.304951369762421, 0.304957330226898, 0.304963260889053, 0.304969042539597, 0.304974764585495, 0.304980397224426, 0.30498594045639, 0.30499142408371, 0.304996818304062, 0.305002093315125, 0.305007308721542, 0.305012434720993, 0.305017441511154, 0.305022358894348, 0.30502724647522, 0.305032014846802, 0.305036664009094, 0.305041283369064, 0.305045783519745, 0.305050224065781, 0.305054545402527, 0.305058777332306, 0.30506294965744, 0.305067002773285, 0.305070996284485, 0.305074870586395, 0.305078715085983, 0.305082410573959, 0.305086076259613, 0.305089622735977, 0.305093050003052, 0.305096417665482, 0.305099725723267, 0.305102944374084, 0.305106043815613, 0.305109053850174, 0.30511200428009, 0.30511486530304, 0.305117607116699, 0.305120289325714, 0.305122882127762, 0.30512535572052, 0.305127799510956, 0.305130124092102, 0.305132359266281, 0.305134505033493, 0.30513659119606, 0.305138558149338, 0.305140465497971, 0.305142253637314, 0.305143982172012, 0.305145591497421, 0.305147171020508, 0.305148631334305, 0.305149972438812, 0.305151253938675, 0.305152475833893, 0.305153578519821, 0.305154591798782, 0.305155545473099, 0.305156379938126, 0.305157154798508, 0.3051578104496, 0.305158406496048, 0.305158913135529, 0.30515930056572, 0.305159628391266, 0.305159866809845, 0.305160045623779, 0.305160075426102, 0.305160045623779, 0.305159956216812, 0.305159777402878, 0.305159479379654, 0.305159091949463, 0.305158644914627, 0.305158108472824, 0.305157482624054, 0.305156737565994, 0.30515593290329, 0.305155068635941, 0.305154025554657, 0.305152982473373, 0.305151849985123, 0.305150598287582, 0.305149257183075, 0.3051478266716, 0.305146336555481, 0.305144757032394, 0.305143058300018, 0.305141299962997, 0.305139452219009, 0.305137515068054, 0.305135458707809, 0.305133372545242, 0.305131167173386, 0.305128902196884, 0.305126518011093, 0.305124044418335, 0.30512148141861, 0.30511885881424, 0.30511611700058, 0.305113315582275, 0.305110424757004, 0.305107444524765, 0.305104345083237, 0.305101186037064, 0.305097967386246, 0.305094629526138, 0.305091202259064, 0.305087715387344, 0.305084109306335, 0.305080443620682, 0.305076658725739, 0.305072814226151, 0.305068820714951, 0.305064857006073, 0.305060744285583, 0.305056512355804, 0.305052220821381, 0.30504783987999, 0.305043369531631, 0.305038809776306, 0.305034190416336, 0.305029451847076, 0.305024653673172, 0.305019736289978, 0.305014759302139, 0.305009692907333, 0.305004507303238, 0.304999262094498, 0.304993897676468, 0.304988503456116, 0.304982990026474, 0.304977387189865, 0.304971694946289, 0.304965913295746, 0.304960072040558, 0.304954141378403, 0.30494812130928, 0.304941982030869, 0.30493575334549, 0.304929494857788, 0.304923087358475, 0.304916620254517, 0.304910063743591, 0.304903447628021, 0.304896712303162, 0.304889857769012, 0.304883003234863, 0.30487596988678, 0.304868906736374, 0.304861724376678, 0.304854482412338, 0.304847151041031, 0.304839730262756, 0.304832220077515, 0.304824590682983, 0.30481693148613, 0.304809153079987, 0.304801285266876, 0.304793328046799, 0.304785281419754, 0.304777145385742, 0.304768949747086, 0.304760664701462, 0.304752260446548, 0.30474379658699, 0.304735213518143, 0.304726600646973, 0.304717838764191, 0.304709047079086, 0.304700136184692, 0.304691135883331, 0.304682046175003, 0.30467289686203, 0.304663598537445, 0.304654270410538, 0.304644852876663, 0.304635345935822, 0.30462571978569, 0.304616034030914, 0.304606258869171, 0.304596394300461, 0.304586440324783, 0.304576426744461, 0.304566293954849, 0.304556041955948, 0.304545760154724, 0.304535359144211, 0.304524898529053, 0.304514318704605, 0.304503679275513, 0.304492920637131, 0.304482102394104, 0.304471224546432, 0.304460227489471, 0.304449141025543, 0.304437935352325, 0.304426699876785, 0.304415374994278, 0.304403930902481, 0.304392397403717, 0.304380774497986, 0.30436909198761, 0.304357320070267, 0.304345458745956, 0.304333478212357, 0.304321467876434, 0.3043093085289, 0.304297089576721, 0.304284811019897, 0.304272413253784, 0.304259926080704, 0.304247349500656, 0.304234683513641, 0.304221957921982, 0.304209142923355, 0.304196208715439, 0.304183214902878, 0.30417013168335, 0.304156959056854, 0.304143697023392, 0.304130345582962, 0.304116904735565, 0.304103374481201, 0.30408975481987, 0.304076045751572, 0.304062277078629, 0.304048418998718, 0.304034471511841, 0.304020404815674, 0.304006278514862, 0.303992062807083, 0.303977757692337, 0.303963333368301, 0.303948879241943, 0.303934305906296, 0.303919643163681, 0.303904920816422, 0.303890079259872, 0.303875148296356, 0.303860127925873, 0.303845047950745, 0.303829878568649, 0.303814619779587, 0.303799271583557, 0.30378383398056, 0.303768277168274, 0.303752660751343, 0.303736984729767, 0.303721189498901, 0.303705304861069, 0.303689360618591, 0.303673297166824, 0.30365714430809, 0.303640931844711, 0.303624600172043, 0.30360820889473, 0.303591758012772, 0.303575158119202, 0.303558498620987, 0.303541779518127, 0.303524941205978, 0.303508013486862, 0.303490996360779, 0.303473919630051, 0.303456723690033, 0.30343946814537, 0.303422093391418, 0.303404659032822, 0.303387135267258, 0.303369522094727, 0.303351819515228, 0.30333399772644, 0.30331614613533, 0.30329817533493, 0.303280115127563, 0.303261995315552, 0.303243726491928, 0.303225457668304, 0.303207010030746, 0.303188532590866, 0.303169935941696, 0.303151309490204, 0.303132563829422, 0.303113728761673, 0.303094774484634, 0.303075790405273, 0.303056687116623, 0.303037524223328, 0.30301821231842, 0.302998870611191, 0.302979409694672, 0.302959889173508, 0.302940249443054, 0.302920550107956, 0.302900731563568, 0.302880853414536, 0.302860915660858, 0.302840858697891, 0.302820712327957, 0.302800476551056, 0.302780151367188, 0.302759736776352, 0.302739232778549, 0.302718698978424, 0.302698016166687, 0.302677273750305, 0.302656412124634, 0.302635490894318, 0.302614480257034, 0.302593380212784, 0.302572190761566, 0.302550911903381, 0.302529543638229, 0.302508115768433, 0.302486568689346, 0.302464932203293, 0.302443236112595, 0.302421450614929, 0.302399545907974, 0.302377581596375, 0.302355527877808, 0.302333354949951, 0.302311152219772, 0.302288800477982, 0.302266389131546, 0.302243888378143, 0.302221328020096, 0.302198648452759, 0.302175909280777, 0.302153050899506, 0.302130132913589, 0.302107095718384, 0.302083998918533, 0.302060812711716, 0.302037507295609, 0.302014142274857, 0.30199071764946, 0.301967173814774, 0.30194354057312, 0.3019198179245, 0.301896035671234, 0.301872104406357, 0.301848143339157, 0.30182409286499, 0.301799923181534, 0.301775693893433, 0.301751375198364, 0.301726967096329, 0.301702469587326, 0.301677882671356, 0.301653206348419, 0.301628440618515, 0.301603615283966, 0.301578670740128, 0.301553666591644, 0.301528543233871, 0.301503360271454, 0.301478058099747, 0.301452696323395, 0.301427245140076, 0.301401704549789, 0.301376044750214, 0.301350325345993, 0.301324516534805, 0.301298648118973, 0.301272660493851, 0.301246613264084, 0.301220417022705, 0.301194190979004, 0.301167845726013, 0.3011414706707, 0.301114946603775, 0.301088362932205, 0.301061689853668, 0.301034927368164, 0.301008105278015, 0.300981134176254, 0.300954133272171, 0.300927013158798, 0.300899803638458, 0.300872504711151, 0.300845146179199, 0.300817668437958, 0.300790160894394, 0.300762504339218, 0.300734788179398, 0.30070698261261, 0.300679087638855, 0.300651103258133, 0.300622999668121, 0.30059489607811, 0.300566643476486, 0.300538301467896, 0.30050989985466, 0.300481379032135, 0.300452798604965, 0.300424098968506, 0.300395309925079, 0.30036649107933, 0.300337553024292, 0.300308525562286, 0.300279408693314, 0.300250202417374, 0.300220906734467, 0.300191551446915, 0.300162076950073, 0.300132542848587, 0.300102889537811, 0.300073146820068, 0.300043374300003, 0.300013452768326, 0.299983441829681, 0.299953371286392, 0.299923241138458, 0.299892991781235, 0.299862653017044, 0.299832224845886, 0.299801737070084, 0.299771130084991, 0.299740433692932, 0.299709647893906, 0.299678802490234, 0.299647867679596, 0.29961684346199, 0.299585700035095, 0.299554497003555, 0.299523204565048, 0.299491852521896, 0.299460381269455, 0.299428820610046, 0.299397170543671, 0.299365431070328, 0.299333661794662, 0.299301743507385, 0.299269735813141, 0.299237698316574, 0.299205511808395, 0.29917323589325, 0.299140930175781, 0.299108505249023, 0.299075990915298, 0.299043387174606, 0.299010694026947, 0.298977941274643, 0.298945069313049, 0.298912137746811, 0.298879057168961, 0.298845946788788, 0.298812747001648, 0.298779457807541, 0.298746079206467, 0.298712611198425, 0.298679053783417, 0.298645406961441, 0.298611670732498, 0.298577845096588, 0.298543959856033, 0.298509955406189, 0.2984758913517, 0.298441708087921, 0.298407465219498, 0.298373103141785, 0.298338711261749, 0.298304170370102, 0.29826956987381, 0.298234879970551, 0.298200100660324, 0.29816523194313, 0.298130303621292, 0.298095256090164, 0.298060119152069, 0.298024922609329, 0.2979896068573, 0.297954231500626, 0.297918766736984, 0.297883182764053, 0.2978475689888, 0.297811806201935, 0.297775983810425, 0.29774010181427, 0.297704070806503, 0.297667980194092, 0.297631829977036, 0.29759556055069, 0.297559231519699, 0.297522813081741, 0.297486275434494, 0.297449678182602, 0.297412991523743, 0.297376245260239, 0.297339349985123, 0.29730236530304, 0.297265350818634, 0.297228217124939, 0.297190994024277, 0.297153681516647, 0.297116309404373, 0.297078847885132, 0.297041267156601, 0.297003626823425, 0.296965897083282, 0.29692804813385, 0.296890139579773, 0.296852141618729, 0.296814054250717, 0.296775877475739, 0.296737611293793, 0.29669925570488, 0.296660840511322, 0.296622306108475, 0.296583712100983, 0.296544998884201, 0.296506226062775, 0.296467363834381, 0.29642841219902, 0.296389371156693, 0.296350210905075, 0.296311020851135, 0.296271711587906, 0.296232312917709, 0.296192824840546, 0.296153277158737, 0.296113580465317, 0.296073853969574, 0.296034008264542, 0.295994132757187, 0.295954138040543, 0.295914024114609, 0.295873880386353, 0.295833587646484, 0.295793235301971, 0.295752793550491, 0.295712292194366, 0.295671671628952, 0.295624852180481, 0.295571684837341, 0.295518457889557, 0.295465171337128, 0.295411795377731, 0.295358300209045, 0.295304805040359, 0.295251160860062, 0.295197427272797, 0.295143693685532, 0.295089840888977, 0.295035898685455, 0.294981837272644, 0.29492774605751, 0.294873595237732, 0.294819355010986, 0.294765025377274, 0.294710606336594, 0.294656097888947, 0.294601529836655, 0.294546902179718, 0.294492185115814, 0.294437348842621, 0.294382482767105, 0.294327527284622, 0.294272482395172, 0.294217348098755, 0.294162154197693, 0.294106870889664, 0.29405152797699, 0.293996065855026, 0.293940514326096, 0.293884962797165, 0.293829262256622, 0.293773531913757, 0.293717682361603, 0.293661773204803, 0.293605774641037, 0.293549746274948, 0.293493568897247, 0.293437361717224, 0.293381035327911, 0.293324649333954, 0.293268203735352, 0.29321163892746, 0.293155014514923, 0.293098300695419, 0.293041527271271, 0.292984664440155, 0.292927771806717, 0.292870730161667, 0.292813628911972, 0.292756468057632, 0.292699187994003, 0.292641878128052, 0.292584449052811, 0.292526960372925, 0.292469382286072, 0.292411714792252, 0.292354017496109, 0.292296200990677, 0.2922383248806, 0.292180359363556, 0.292122304439545, 0.292064189910889, 0.292005985975266, 0.291947692632675, 0.29188933968544, 0.291830867528915, 0.291772395372391, 0.291713774204254, 0.291655093431473, 0.291596353054047, 0.291537523269653, 0.291478604078293, 0.291419595479965, 0.291360527276993, 0.291301399469376, 0.291242152452469, 0.291182845830917, 0.291123449802399, 0.291064023971558, 0.291004478931427, 0.290944814682007, 0.290885120630264, 0.290825337171555, 0.2907654941082, 0.290705531835556, 0.29064553976059, 0.290585428476334, 0.290525257587433, 0.290464967489243, 0.290404617786407, 0.29034423828125, 0.290283739566803, 0.290223181247711, 0.29016250371933, 0.290101766586304, 0.290040969848633, 0.289980113506317, 0.289919137954712, 0.289858102798462, 0.289796978235245, 0.28973576426506, 0.289674490690231, 0.289613097906113, 0.289551675319672, 0.289490133523941, 0.289428561925888, 0.289366871118546, 0.289305090904236, 0.289243280887604, 0.289181381464005, 0.289119362831116, 0.289057284593582, 0.288995146751404, 0.288932919502258, 0.288870602846146, 0.288808196783066, 0.288745731115341, 0.288683205842972, 0.288620561361313, 0.288557857275009, 0.288495093584061, 0.288432210683823, 0.28836926817894, 0.28830623626709, 0.288243144750595, 0.288179993629456, 0.288116723299026, 0.28805336356163, 0.287989944219589, 0.287926465272903, 0.28786289691925, 0.28779923915863, 0.287735491991043, 0.287671685218811, 0.287607789039612, 0.287543833255768, 0.287479788064957, 0.287415653467178, 0.287351459264755, 0.287287175655365, 0.287222802639008, 0.287158370018005, 0.287093847990036, 0.287029236555099, 0.286964565515518, 0.28689980506897, 0.286834955215454, 0.286770045757294, 0.286705046892166, 0.286639988422394, 0.286574810743332, 0.286509603261948, 0.286444276571274, 0.286378890275955, 0.286313414573669, 0.286247879266739, 0.286182224750519, 0.286116510629654, 0.286050736904144, 0.285984873771667, 0.285918921232224, 0.285852938890457, 0.285786807537079, 0.285720646381378, 0.285654366016388, 0.285588026046753, 0.285521626472473, 0.285455107688904, 0.28538852930069, 0.285321921110153, 0.285255134105682, 0.285188347101212, 0.285121440887451, 0.285054475069046, 0.284987419843674, 0.284920305013657, 0.284853100776672, 0.284785807132721, 0.284718453884125, 0.284651011228561, 0.284583479166031, 0.284515857696533, 0.284448176622391, 0.284380435943604, 0.284312605857849, 0.284244656562805, 0.284176677465439, 0.284108608961105, 0.284040421247482, 0.283972173929214, 0.283903896808624, 0.283835500478745, 0.283767014741898, 0.283698469400406, 0.283629834651947, 0.283561140298843, 0.283492356538773, 0.283423483371735, 0.283354550600052, 0.28328549861908, 0.283216387033463, 0.283147245645523, 0.283077955245972, 0.283008635044098, 0.282939195632935, 0.282869696617126, 0.282800108194351, 0.282730460166931, 0.282660722732544, 0.28259089589119, 0.282521039247513, 0.282451063394547, 0.282380998134613, 0.282310873270035, 0.282240658998489, 0.282170355319977, 0.282099992036819, 0.282029539346695, 0.281959027051926, 0.281888425350189, 0.281817764043808, 0.281746983528137, 0.281676143407822, 0.281605213880539, 0.281534224748611, 0.281463146209717, 0.281392008066177, 0.281320750713348, 0.281249433755875, 0.281178057193756, 0.281106561422348, 0.281035006046295, 0.280963391065598, 0.280891686677933, 0.280819892883301, 0.280748009681702, 0.280676037073135, 0.280604034662247, 0.280531913042068, 0.280459761619568, 0.280387490987778, 0.280315160751343, 0.280242711305618, 0.280170232057571, 0.280097663402557, 0.280024975538254, 0.279952228069305, 0.279879450798035, 0.279806524515152, 0.279733538627625, 0.279660522937775, 0.279587358236313, 0.279514193534851, 0.279440879821777, 0.279367506504059, 0.279294073581696, 0.279220521450043, 0.279146909713745, 0.279073238372803, 0.278999477624893, 0.278925627470016, 0.278851717710495, 0.278777718544006, 0.278703600168228, 0.27862948179245, 0.278555244207382, 0.278480917215347, 0.278406530618668, 0.278332054615021, 0.278257489204407, 0.278182864189148, 0.278108149766922, 0.278033345937729, 0.277958482503891, 0.277883529663086, 0.277808517217636, 0.277733385562897, 0.277658224105835, 0.277582943439484, 0.277507603168488, 0.277432203292847, 0.277356684207916, 0.277281075716019, 0.277205437421799, 0.277129709720612, 0.277053892612457, 0.276977956295013, 0.276901990175247, 0.276825964450836, 0.276749819517136, 0.276673585176468, 0.276597291231155, 0.276520937681198, 0.276444494724274, 0.276367962360382, 0.276291370391846, 0.27621465921402, 0.276137888431549, 0.276061058044434, 0.275984138250351, 0.275907129049301, 0.275830030441284, 0.275752872228622, 0.275675654411316, 0.27559831738472, 0.275520950555801, 0.275443464517593, 0.275365889072418, 0.275288283824921, 0.275210529565811, 0.275132745504379, 0.275054901838303, 0.274976938962936, 0.274898916482925, 0.274820774793625, 0.274742633104324, 0.274664342403412, 0.274585992097855, 0.274507582187653, 0.274429053068161, 0.274350464344025, 0.274271816015244, 0.274193048477173, 0.27411425113678, 0.27403536438942, 0.273956388235092, 0.27387735247612, 0.273798197507858, 0.273718953132629, 0.273639678955078, 0.27356031537056, 0.273480862379074, 0.273401319980621, 0.273321747779846, 0.273242026567459, 0.273162245750427, 0.273082405328751, 0.273002475500107, 0.272922486066818, 0.272842407226562, 0.27276223897934, 0.272682011127472, 0.272601664066315, 0.272521287202835, 0.272440791130066, 0.272360235452652, 0.272279620170593, 0.272198855876923, 0.272118091583252, 0.272037237882614, 0.271956294775009, 0.271875232458115, 0.271794110536575, 0.271712929010391, 0.271631687879562, 0.271550297737122, 0.271468907594681, 0.271387368440628, 0.271305799484253, 0.271224141120911, 0.271142393350601, 0.271060585975647, 0.270978659391403, 0.270896673202515, 0.270814657211304, 0.270732492208481, 0.270650267601013, 0.270567983388901, 0.270485609769821, 0.270403146743774, 0.270320624113083, 0.270238012075424, 0.270155340433121, 0.270072549581528, 0.26998969912529, 0.269906789064407, 0.269823759794235, 0.269740700721741, 0.269657522439957, 0.269574254751205, 0.269490957260132, 0.269407570362091, 0.269324064254761, 0.269240528345108, 0.269156873226166, 0.269073128700256, 0.268989324569702, 0.268905490636826, 0.268821507692337, 0.268737494945526, 0.268653392791748, 0.268569201231003, 0.26848492026329, 0.268400579690933, 0.268316149711609, 0.268231630325317, 0.268147051334381, 0.2680624127388, 0.267977654933929, 0.267892837524414, 0.267807930707932, 0.267722934484482, 0.267637878656387, 0.267552733421326, 0.267467528581619, 0.267382204532623, 0.267296850681305, 0.267211407423019, 0.267125844955444, 0.267040252685547, 0.26695454120636, 0.266868770122528, 0.266782909631729, 0.266696989536285, 0.266610980033875, 0.266524940729141, 0.266438722610474, 0.266352504491806, 0.266266167163849, 0.266179770231247, 0.266093283891678, 0.266006708145142, 0.265920072793961, 0.265833377838135, 0.265746563673019, 0.265659689903259, 0.265572726726532, 0.26548570394516, 0.265398591756821, 0.265311390161514, 0.265224128961563, 0.265136778354645, 0.265049368143082, 0.264961838722229, 0.264874219894409, 0.264786601066589, 0.264698833227158, 0.264611005783081, 0.264523088932037, 0.264435112476349, 0.264347046613693, 0.264258921146393, 0.264170676469803, 0.264082372188568, 0.263994008302689, 0.263905555009842, 0.263817012310028, 0.263728410005569, 0.263639718294144, 0.263550937175751, 0.263462096452713, 0.263373166322708, 0.263284146785736, 0.263195067644119, 0.263105899095535, 0.263016670942307, 0.262927353382111, 0.262837916612625, 0.262748450040817, 0.26265886425972, 0.262569218873978, 0.262479513883591, 0.262389719486237, 0.262299835681915, 0.262209862470627, 0.262119829654694, 0.262029707431793, 0.261939525604248, 0.261849254369736, 0.261758893728256, 0.261668473482132, 0.261577934026718, 0.261487364768982, 0.261396706104279, 0.261305958032608, 0.26121512055397, 0.261124223470688, 0.261033236980438, 0.260942161083221, 0.26085102558136, 0.260759800672531, 0.260668516159058, 0.260577112436295, 0.260485649108887, 0.260394126176834, 0.260302513837814, 0.260210812091827, 0.260119050741196, 0.260027199983597, 0.259935259819031, 0.25984326004982, 0.259751170873642, 0.259658962488174, 0.259566754102707, 0.259474396705627, 0.259382009506226, 0.259289532899857, 0.25919696688652, 0.259104311466217, 0.259011596441269, 0.258918762207031, 0.258825898170471, 0.258732944726944, 0.25863990187645, 0.25854679942131, 0.258453577756882, 0.258360326290131, 0.25826695561409, 0.258173525333405, 0.258080005645752, 0.257986426353455, 0.257892727851868, 0.257798999547958, 0.257705181837082, 0.257611274719238, 0.257517278194427, 0.257423222064972, 0.257329076528549, 0.257234841585159, 0.257140547037125, 0.257046163082123, 0.256951719522476, 0.25685715675354, 0.256762564182281, 0.256667852401733, 0.256573051214218, 0.25647822022438, 0.256383299827576, 0.256288230419159, 0.256193190813065, 0.256098002195358, 0.256002753973007, 0.255907416343689, 0.255812019109726, 0.255716562271118, 0.255620956420898, 0.255525320768356, 0.255429595708847, 0.255333781242371, 0.255237907171249, 0.255141913890839, 0.255045920610428, 0.254949778318405, 0.254853576421738, 0.254757314920425, 0.254660964012146, 0.254564523696899, 0.254468023777008, 0.254371404647827, 0.254274725914001, 0.254177987575531, 0.254081159830093, 0.253984242677689, 0.253887236118317, 0.253790199756622, 0.253693044185638, 0.25359582901001, 0.253498524427414, 0.253401130437851, 0.253303676843643, 0.253206133842468, 0.253108471632004, 0.253010809421539, 0.252913057804108, 0.252815186977386, 0.252717256546021, 0.252619236707687, 0.252521127462387, 0.252422988414764, 0.25232470035553, 0.252226382493973, 0.252127975225449, 0.252029478549957, 0.251930922269821, 0.251832276582718, 0.251733541488647, 0.251634746789932, 0.25153586268425, 0.2514368891716, 0.251337856054306, 0.251238703727722, 0.251139521598816, 0.251040250062943, 0.250940889120102, 0.250841438770294, 0.250741958618164, 0.250642329454422, 0.250542670488358, 0.250442922115326, 0.250343084335327, 0.250243157148361, 0.25014317035675, 0.250043123960495, 0.24994295835495, 0.249842748045921, 0.249742433428764, 0.249642044305801, 0.249541595578194, 0.249441027641296, 0.249340415000916, 0.249239712953568, 0.249138936400414, 0.249038085341454, 0.248937144875526, 0.248836100101471, 0.248735025525093, 0.248633846640587, 0.248532608151436, 0.248431250452995, 0.24832983314991, 0.24822835624218, 0.248126804828644, 0.248025149106979, 0.247923418879509, 0.247821599245071, 0.247719705104828, 0.24761775135994, 0.247515708208084, 0.247413575649261, 0.247311383485794, 0.247209116816521, 0.247106745839119, 0.247004315257072, 0.246901795268059, 0.246799185872078, 0.246696531772614, 0.24659375846386, 0.246490925550461, 0.246388018131256, 0.246285006403923, 0.246181949973106, 0.246078819036484, 0.245975568890572, 0.245872274041176, 0.245768874883652, 0.245665416121483, 0.245561882853508, 0.245458245277405, 0.245354548096657, 0.245250761508942, 0.245146915316582, 0.245042979717255, 0.244938939809799, 0.24483485519886, 0.244730666279793, 0.244626432657242, 0.244522094726562, 0.244417652487755, 0.244313165545464, 0.244208604097366, 0.244103938341141, 0.243999227881432, 0.243894428014755, 0.243789538741112, 0.243684560060501, 0.243579506874084, 0.243474394083023, 0.243369191884995, 0.243263900279999, 0.243158549070358, 0.243053093552589, 0.242947593331337, 0.242841988801956, 0.242736324667931, 0.242630571126938, 0.242524728178978, 0.242418795824051, 0.242312803864479, 0.242206737399101, 0.242100566625595, 0.241994336247444, 0.24188806116581, 0.241781651973724, 0.241675198078156, 0.241568639874458, 0.241462022066116, 0.241355329751968, 0.241248533129692, 0.241141676902771, 0.241034731268883, 0.240927711129189, 0.240820616483688, 0.24071341753006, 0.240606173872948, 0.24049885571003, 0.240391418337822, 0.24028392136097, 0.24017633497715, 0.240068703889847, 0.239960968494415, 0.239853158593178, 0.239745289087296, 0.239637300372124, 0.239529252052307, 0.239421129226685, 0.239312916994095, 0.239204630255699, 0.239096269011497, 0.23898783326149, 0.238879308104515, 0.238770708441734, 0.238662049174309, 0.238553270697594, 0.238444417715073, 0.23833554983139, 0.238226518034935, 0.238117471337318, 0.238008305430412, 0.2378990650177, 0.237789765000343, 0.237680360674858, 0.23757092654705, 0.237461358308792, 0.237351730465889, 0.237242013216019, 0.237132221460342, 0.237022370100021, 0.236912429332733, 0.236802384257317, 0.236692309379578, 0.236582115292549, 0.236471846699715, 0.236361533403397, 0.236251100897789, 0.236140623688698, 0.236030042171478, 0.235919401049614, 0.235808655619621, 0.235697850584984, 0.235586956143379, 0.235475957393646, 0.235364928841591, 0.235253795981407, 0.235142588615417, 0.235031321644783, 0.234919920563698, 0.23480848968029, 0.234696984291077, 0.234585389494896, 0.234473705291748, 0.234361931681633, 0.234250113368034, 0.234138175845146, 0.234026178717613, 0.233914121985435, 0.233801960945129, 0.233689695596695, 0.233577400445938, 0.233465015888214, 0.233352527022362, 0.233239993453026, 0.233127355575562, 0.233014658093452, 0.232901871204376, 0.232788980007172, 0.232676059007645, 0.232563018798828, 0.232449933886528, 0.232336729764938, 0.232223495841026, 0.232110157608986, 0.231996729969978, 0.231883242726326, 0.231769651174545, 0.23165600001812, 0.231542259454727, 0.231428444385529, 0.231314569711685, 0.231200590729713, 0.231086537241936, 0.230972409248352, 0.230858191847801, 0.230743914842606, 0.230629548430443, 0.230515077710152, 0.230400577187538, 0.230285957455635, 0.230171293020248, 0.230056539177895, 0.229941666126251, 0.229826763272285, 0.229711771011353, 0.229596674442291, 0.229481533169746, 0.229366287589073, 0.229250997304916, 0.229135572910309, 0.229020088911057, 0.228904560208321, 0.228788942098618, 0.228673219680786, 0.22855743765831, 0.228441551327705, 0.228325620293617, 0.228209599852562, 0.228093475103378, 0.22797729074955, 0.227861031889915, 0.227744683623314, 0.227628275752068, 0.227511793375015, 0.227395206689835, 0.227278545498848, 0.227161824703217, 0.227044984698296, 0.226928099989891, 0.226811140775681, 0.226694077253342, 0.226576939225197, 0.226459741592407, 0.22634245455265, 0.226225093007088, 0.226107612252235, 0.2259900867939, 0.225872486829758, 0.225754797458649, 0.225637033581734, 0.225519180297852, 0.225401267409325, 0.225283265113831, 0.225165203213692, 0.225047066807747, 0.224928796291351, 0.224810495972633, 0.224692091345787, 0.224573597311974, 0.224455073475838, 0.224336430430412, 0.224217727780342, 0.224098935723305, 0.223980069160461, 0.223861128091812, 0.223742082715034, 0.223623007535934, 0.223503798246384, 0.223384514451027, 0.223265200853348, 0.223145768046379, 0.223026260733604, 0.222906693816185, 0.222787022590637, 0.222667306661606, 0.222547471523285, 0.22242759168148, 0.222307592630386, 0.222187548875809, 0.222067415714264, 0.221947208046913, 0.221826910972595, 0.221706554293633, 0.22158607840538, 0.221465572714806, 0.221344962716103, 0.221224263310432, 0.221103504300117, 0.220982670783997, 0.22086176276207, 0.220740735530853, 0.220619648694992, 0.220498502254486, 0.220377236604691, 0.220255970954895, 0.220134541392326, 0.220013052225113, 0.219891518354416, 0.219769880175591, 0.219648167490959, 0.219526380300522, 0.219404473900795, 0.219282537698746, 0.219160541892052, 0.219038426876068, 0.218916222453117, 0.218793973326683, 0.218671634793282, 0.218549177050591, 0.218426704406738, 0.218304112553596, 0.218181446194649, 0.218058720231056, 0.217935889959335, 0.217812970280647, 0.217690005898476, 0.217566967010498, 0.217443838715553, 0.217320591211319, 0.217197299003601, 0.217073932290077, 0.216950461268425, 0.216826975345612, 0.216703340411186, 0.216579660773277, 0.216455891728401, 0.216332033276558, 0.216208145022392, 0.216084122657776, 0.215960025787354, 0.215835869312286, 0.215711623430252, 0.215587332844734, 0.215462923049927, 0.215338438749313, 0.215213879942894, 0.215089246630669, 0.214964553713799, 0.214839726686478, 0.214714869856834, 0.214589923620224, 0.214464887976646, 0.214339807629585, 0.214214593172073, 0.214089319109917, 0.213963985443115, 0.213838547468185, 0.213713020086288, 0.213587462902069, 0.21346178650856, 0.213336050510406, 0.213210240006447, 0.213084325194359, 0.212958365678787, 0.212832286953926, 0.212706193327904, 0.212579935789108, 0.21245364844799, 0.212327286601067, 0.212200820446014, 0.212074294686317, 0.211947694420815, 0.211821004748344, 0.211694240570068, 0.211567372083664, 0.211440458893776, 0.21131344139576, 0.211186349391937, 0.21105919778347, 0.210931941866875, 0.210804656147957, 0.210677251219749, 0.210549756884575, 0.210422188043594, 0.210294559597969, 0.210166841745377, 0.210039034485817, 0.20991113781929, 0.209783211350441, 0.209655180573463, 0.209527060389519, 0.20939889550209, 0.209270596504211, 0.209142282605171, 0.20901383459568, 0.208885326981544, 0.208756759762764, 0.208628073334694, 0.208499327301979, 0.208370506763458, 0.20824159681797, 0.208112642168999, 0.207983568310738, 0.207854434847832, 0.207725211977959, 0.20759591460228, 0.207466572523117, 0.207337096333504, 0.207207560539246, 0.20707793533802, 0.20694825053215, 0.206818506121635, 0.20668862760067, 0.206558704376221, 0.206428706645966, 0.206298604607582, 0.206168457865715, 0.206038191914558, 0.205907896161079, 0.205777451395988, 0.205646976828575, 0.205516442656517, 0.205385789275169, 0.205255076289177, 0.205124288797379, 0.204993396997452, 0.204862460494041, 0.204731419682503, 0.204600274562836, 0.204469099640846, 0.204337850213051, 0.204206481575966, 0.204075068235397, 0.203943535685539, 0.203811943531036, 0.203680276870728, 0.203548580408096, 0.203416734933853, 0.203284814953804, 0.203152850270271, 0.203024849295616, 0.202900961041451, 0.202776968479156, 0.202652931213379, 0.202528849244118, 0.202404677867889, 0.202280476689339, 0.202156156301498, 0.202031791210175, 0.20190741121769, 0.201782912015915, 0.201658383011818, 0.201533794403076, 0.201409116387367, 0.201284408569336, 0.201159596443176, 0.201034769415855, 0.200909838080406, 0.200784847140312, 0.200659841299057, 0.200534731149673, 0.200409561395645, 0.200284332036972, 0.200159043073654, 0.200033694505692, 0.199908286333084, 0.19978278875351, 0.199657276272774, 0.19953165948391, 0.199406027793884, 0.199280261993408, 0.19915446639061, 0.199028626084328, 0.198902696371078, 0.198776721954346, 0.198650687932968, 0.198524594306946, 0.198398426175117, 0.198272198438644, 0.198145925998688, 0.198019564151764, 0.197893127799034, 0.197766676545143, 0.197640120983124, 0.197513520717621, 0.197386845946312, 0.197260111570358, 0.197133347392082, 0.197006493806839, 0.196879595518112, 0.196752592921257, 0.196625545620918, 0.196498423814774, 0.196371257305145, 0.196244046092033, 0.196116745471954, 0.195989400148392, 0.195861995220184, 0.19573450088501, 0.19560694694519, 0.19547937810421, 0.195351704955101, 0.195223957300186, 0.195096179842949, 0.194968312978745, 0.194840386509895, 0.194712415337563, 0.194584399461746, 0.194456279277802, 0.194328084588051, 0.194199904799461, 0.19407157599926, 0.193943232297897, 0.193814814090729, 0.193686321377754, 0.193557798862457, 0.193429186940193, 0.193300545215607, 0.193171799182892, 0.193042993545532, 0.19291415810585, 0.192785233259201, 0.192656219005585, 0.192527189850807, 0.192398086190224, 0.192268922924995, 0.192139700055122, 0.192010372877121, 0.19188104569912, 0.191751629114151, 0.191622138023376, 0.191492602229118, 0.191362977027893, 0.191233336925507, 0.191103562712669, 0.190973803400993, 0.190843924880028, 0.190714001655579, 0.190584033727646, 0.190453976392746, 0.190323889255524, 0.190193712711334, 0.190063461661339, 0.189933180809021, 0.189802825450897, 0.18967242538929, 0.189541935920715, 0.189411371946335, 0.189280793070793, 0.189150109887123, 0.189019381999969, 0.18888857960701, 0.188757702708244, 0.188626796007156, 0.188495814800262, 0.188364788889885, 0.18823367357254, 0.18810248374939, 0.187971279025078, 0.187839969992638, 0.187708601355553, 0.187577173113823, 0.187445685267448, 0.187314167618752, 0.187182545661926, 0.187050893902779, 0.186919137835503, 0.186787322163582, 0.186655476689339, 0.186523571610451, 0.186391577124596, 0.186259537935257, 0.186127409338951, 0.185995236039162, 0.185863003134727, 0.18573072552681, 0.185598373413086, 0.185465931892395, 0.185333445668221, 0.18520088493824, 0.185068309307098, 0.184935629367828, 0.184802889823914, 0.184670075774193, 0.184537202119827, 0.184404328465462, 0.184271335601807, 0.184138268232346, 0.184005156159401, 0.18387196958065, 0.183738768100739, 0.183605462312698, 0.183472096920013, 0.183338657021523, 0.183205157518387, 0.183071672916412, 0.182938039302826, 0.182804360985756, 0.18267060816288, 0.18253681063652, 0.182402968406677, 0.182269036769867, 0.182135045528412, 0.182000979781151, 0.181866869330406, 0.181732729077339, 0.181598484516144, 0.181464165449142, 0.181329816579819, 0.181195393204689, 0.181060925126076, 0.180926352739334, 0.180791735649109, 0.180657058954239, 0.180522292852402, 0.180387556552887, 0.18025267124176, 0.180117756128311, 0.179982736706734, 0.179847687482834, 0.179712608456612, 0.179577425122261, 0.179442182183266, 0.179306879639626, 0.179171487689018, 0.179036110639572, 0.178900629281998, 0.178765058517456, 0.178629443049431, 0.1784937530756, 0.178358048200607, 0.178222239017487, 0.17808635532856, 0.177950412034988, 0.177814438939095, 0.177678421139717, 0.17754228413105, 0.177406117320061, 0.177269861102104, 0.177133575081825, 0.176997184753418, 0.176860779523849, 0.176724284887314, 0.176587715744972, 0.176451116800308, 0.176314413547516, 0.176177725195885, 0.176040917634964, 0.175904035568237, 0.175767108798027, 0.175630122423172, 0.175493076443672, 0.175355955958366, 0.175218775868416, 0.175081521272659, 0.174944207072258, 0.174806892871857, 0.174669459462166, 0.17453196644783, 0.174394384026527, 0.174256756901741, 0.174119114875793, 0.173981353640556, 0.173843562602997, 0.17370568215847, 0.173567742109299, 0.173429787158966, 0.173291727900505, 0.173153609037399, 0.173015430569649, 0.172877177596092, 0.172738894820213, 0.172600522637367, 0.172462075948715, 0.172323569655418, 0.172185018658638, 0.172046422958374, 0.171907737851143, 0.171768993139267, 0.171630203723907, 0.171491324901581, 0.171352416276932, 0.171213403344154, 0.171074360609055, 0.170935213565826, 0.170796036720276, 0.170656815171242, 0.170517519116402, 0.170378133654594, 0.170238703489304, 0.170099183917046, 0.169959664344788, 0.169820070266724, 0.169680371880531, 0.169540598988533, 0.169400796294212, 0.169260948896408, 0.169121026992798, 0.16898101568222, 0.168840959668159, 0.168700814247131, 0.168560683727264, 0.168420419096947, 0.168280124664307, 0.168139755725861, 0.167999312281609, 0.167858839035034, 0.167718291282654, 0.167577639222145, 0.167436957359314, 0.167296200990677, 0.167155385017395, 0.167014554142952, 0.166873618960381, 0.166732624173164, 0.166591554880142, 0.166450440883636, 0.166309282183647, 0.166168019175529, 0.166026696562767, 0.165885329246521, 0.165743872523308, 0.165602415800095, 0.165460854768753, 0.165319219231606, 0.165177553892136, 0.165035784244537, 0.164894014596939, 0.164752140641212, 0.16461019217968, 0.164468184113503, 0.16432611644268, 0.164184048771858, 0.164041846990585, 0.163899600505829, 0.163757279515266, 0.16361491382122, 0.16347248852253, 0.163329988718033, 0.163187429308891, 0.163044810295105, 0.16290208697319, 0.162759393453598, 0.162616565823555, 0.162473693490028, 0.162330761551857, 0.16218775510788, 0.162044703960419, 0.161901593208313, 0.16175839304924, 0.161615148186684, 0.161471828818321, 0.161328494548798, 0.161185055971146, 0.161041542887688, 0.160897970199585, 0.160754352807999, 0.160610690712929, 0.160466939210892, 0.160323113203049, 0.160179242491722, 0.160035282373428, 0.159891322255135, 0.159747257828712, 0.159603133797646, 0.159458935260773, 0.159314677119255, 0.159170404076576, 0.159026011824608, 0.158881574869156, 0.158737063407898, 0.158592492341995, 0.158447921276093, 0.158303216099739, 0.158158481121063, 0.158013641834259, 0.157868757843971, 0.1577238291502, 0.157578840851784, 0.157433792948723, 0.157288640737534, 0.157143443822861, 0.156998202204704, 0.156852930784225, 0.156707540154457, 0.156562104821205, 0.156416594982147, 0.156271010637283, 0.156125411391258, 0.155979722738266, 0.155833974480629, 0.155688151717186, 0.155542269349098, 0.155396372079849, 0.155250370502472, 0.155104294419289, 0.154958158731461, 0.154811948537827, 0.154665738344193, 0.15451942384243, 0.154373034834862, 0.154226571321487, 0.15408006310463, 0.153933569788933, 0.153786927461624, 0.153640225529671, 0.153493463993073, 0.153346657752991, 0.153199791908264, 0.153052851557732, 0.152905851602554, 0.15275876224041, 0.152611628174782, 0.152464464306831, 0.152317211031914, 0.152169898152351, 0.152022510766983, 0.151875078678131, 0.151727586984634, 0.151580020785332, 0.151432380080223, 0.15128467977047, 0.151136934757233, 0.150989145040512, 0.150841251015663, 0.150693312287331, 0.150545299053192, 0.150397226214409, 0.150249138474464, 0.150100946426392, 0.149952679872513, 0.149804353713989, 0.149655982851982, 0.14950755238533, 0.149359047412872, 0.149210467934608, 0.149061813950539, 0.148913130164146, 0.148764431476593, 0.14861561357975, 0.14846670627594, 0.148317754268646, 0.148168742656708, 0.148019686341286, 0.147870570421219, 0.147721379995346, 0.147572100162506, 0.147422790527344, 0.147273406386375, 0.147123992443085, 0.146974489092827, 0.146824911236763, 0.146675273776054, 0.146525576710701, 0.146375849843025, 0.146226033568382, 0.146076142787933, 0.14592619240284, 0.145776182413101, 0.145626157522202, 0.145476028323174, 0.145325809717178, 0.1451755464077, 0.145025223493576, 0.14487487077713, 0.144724413752556, 0.144573897123337, 0.144423320889473, 0.144272699952126, 0.144122034311295, 0.143971279263496, 0.143820449709892, 0.143669560551643, 0.143518596887589, 0.143367633223534, 0.143216550350189, 0.143065422773361, 0.142914205789566, 0.142762944102287, 0.142611682415009, 0.142460286617279, 0.142308831214905, 0.142157316207886, 0.142005741596222, 0.141854137182236, 0.141702443361282, 0.141550675034523, 0.141398832201958, 0.141246944665909, 0.141095042228699, 0.14094303548336, 0.140790954232216, 0.140638813376427, 0.140486598014832, 0.140334382653236, 0.140182048082352, 0.140029668807983, 0.139877200126648, 0.139724686741829, 0.13957217335701, 0.139419510960579, 0.139266818761826, 0.139114052057266, 0.138961225748062, 0.138808369636536, 0.138655409216881, 0.138502404093742, 0.138349309563637, 0.138196170330048, 0.138042971491814, 0.137889742851257, 0.137736424803734, 0.137583032250404, 0.13742958009243, 0.13727605342865, 0.13712252676487, 0.1369688808918, 0.136815175414085, 0.136661395430565, 0.136507585644722, 0.136353746056557, 0.136199787259102, 0.136045753955841, 0.135891690850258, 0.135737538337708, 0.135583370923996, 0.135429114103317, 0.135274767875671, 0.135120376944542, 0.134965926408768, 0.134811460971832, 0.134656891226768, 0.134502246975899, 0.134347528219223, 0.134192749857903, 0.134037971496582, 0.133883059024811, 0.133728116750717, 0.133573099970818, 0.133418023586273, 0.133262917399406, 0.133107721805573, 0.132952451705933, 0.132797122001648, 0.132641702890396, 0.132486298680305, 0.132330775260925, 0.132175207138062, 0.132019564509392, 0.131863847374916, 0.131708115339279, 0.131552308797836, 0.131396412849426, 0.13124044239521, 0.131084427237511, 0.130928382277489, 0.130772233009338, 0.130616024136543, 0.130459755659103, 0.130303427577019, 0.130147069692612, 0.129990607500076, 0.129834085702896, 0.129677534103394, 0.129520878195763, 0.129364192485809, 0.12920743227005, 0.129050597548485, 0.128893703222275, 0.12873674929142, 0.128579765558243, 0.128422677516937, 0.128265514969826, 0.128108322620392, 0.127951070666313, 0.127793744206429, 0.12763637304306, 0.127478912472725, 0.127321392297745, 0.127163797616959, 0.127006158232689, 0.126848489046097, 0.126690715551376, 0.126532882452011, 0.12637497484684, 0.126217022538185, 0.126059055328369, 0.125900968909264, 0.125742822885513, 0.125584602355957, 0.125426337122917, 0.125268027186394, 0.125109642744064, 0.124951183795929, 0.124792665243149, 0.124634072184563, 0.124475479125977, 0.124316774308681, 0.124157987535, 0.123999156057835, 0.123840264976025, 0.123681336641312, 0.123522311449051, 0.123363219201565, 0.123204074800014, 0.123044855892658, 0.122885651886463, 0.122726313769817, 0.122566916048527, 0.122407451272011, 0.12224792689085, 0.122088380157948, 0.121928729116917, 0.12176901102066, 0.121609233319759, 0.121449410915375, 0.121289566159248, 0.121129594743252, 0.12096956372261, 0.120809480547905, 0.120649330317974, 0.12048914283514, 0.1203288808465, 0.120168551802635, 0.120008133351803, 0.119847670197487, 0.119687214493752, 0.119526617228985, 0.119365967810154, 0.119205251336098, 0.119044475257397, 0.118883691728115, 0.118722781538963, 0.118561826646328, 0.118400789797306, 0.11823970079422, 0.118078604340553, 0.117917388677597, 0.117756128311157, 0.117594785988331, 0.117433376610279, 0.117271915078163, 0.117110408842564, 0.116948828101158, 0.116787187755108, 0.116625465452671, 0.11646369099617, 0.116301901638508, 0.116140007972717, 0.115978039801121, 0.115816004574299, 0.115653917193413, 0.115491814911366, 0.115329600870609, 0.115167319774628, 0.115004979074001, 0.11484257876873, 0.114680171012878, 0.114517636597157, 0.11435505002737, 0.114192388951778, 0.114029675722122, 0.113866932690144, 0.113704085350037, 0.113541193306446, 0.11337822675705, 0.113215200603008, 0.113052159547806, 0.112889014184475, 0.112725786864758, 0.112562514841557, 0.11239916831255, 0.112235806882381, 0.112072333693504, 0.111908808350563, 0.111745223402977, 0.111581563949585, 0.111417911946774, 0.111254125833511, 0.111090287566185, 0.110926382243633, 0.110762409865856, 0.110598415136337, 0.110434338450432, 0.11027017980814, 0.110105954110622, 0.10994166880846, 0.109777398407459, 0.109612986445427, 0.109448529779911, 0.109283983707428, 0.109119400382042, 0.108954787254333, 0.108790054917336, 0.108625285327435, 0.108460441231728, 0.108295522630215, 0.108130604028702, 0.10796557366848, 0.107800491154194, 0.107635334134102, 0.107470124959946, 0.107304878532887, 0.10713953524828, 0.106974124908447, 0.10680865496397, 0.106643125414848, 0.106477521359921, 0.106311909854412, 0.106146201491356, 0.105980433523655, 0.105814598500729, 0.105648681521416, 0.105482757091522, 0.1053167283535, 0.105150625109673, 0.104984469711781, 0.104818247258663, 0.104651995003223, 0.104485660791397, 0.104319252073765, 0.104152783751488, 0.103986270725727, 0.103819705545902, 0.10365305095911, 0.103486336767673, 0.103319548070431, 0.103152699768543, 0.102985836565495, 0.102818861603737, 0.102651827037334, 0.102484732866287, 0.102317579090595, 0.102150417864323, 0.10198312997818, 0.101815775036812, 0.10164837539196, 0.101480893790722, 0.101313404738903, 0.101145818829536, 0.100978158414364, 0.100810430943966, 0.100642651319504, 0.10047485679388, 0.100306950509548, 0.100138984620571, 0.0999709442257881, 0.0998028516769409, 0.0996347293257713, 0.0994665026664734, 0.0992982238531113, 0.0991298705339432, 0.0989614725112915, 0.0987930446863174, 0.0986245200037956, 0.0984559208154678, 0.0982872545719147, 0.0981185287237167, 0.097949780523777, 0.0977809429168701, 0.0976120233535767, 0.0974430590867996, 0.097274012863636, 0.0971049889922142, 0.0969358161091805, 0.0967665985226631, 0.0965973138809204, 0.0964279547333717, 0.0962585955858231, 0.0960891097784042, 0.0959195792675018, 0.0957499742507935, 0.0955803170800209, 0.0954106003046036, 0.0952408686280251, 0.095071017742157, 0.0949010998010635, 0.0947311222553253, 0.0945611000061035, 0.0943910330533981, 0.0942208766937256, 0.0940506458282471, 0.0938803777098656, 0.0937100127339363, 0.0935396626591682, 0.09336918592453, 0.0931986421346664, 0.0930280536413193, 0.0928573980927467, 0.0926867052912712, 0.0925159081816673, 0.0923450589179993, 0.0921741500496864, 0.0920031741261482, 0.0918322056531906, 0.0916611030697823, 0.0914899259805679, 0.0913187190890312, 0.0911474153399467, 0.0909761115908623, 0.0908046886324883, 0.0906332284212112, 0.0904616862535477, 0.0902900770306587, 0.0901184752583504, 0.0899467393755913, 0.0897749587893486, 0.0896031036973, 0.0894311964511871, 0.0892592668533325, 0.089087225496769, 0.08891511708498, 0.0887429565191269, 0.0885707214474678, 0.0883985012769699, 0.0882261469960213, 0.0880537331104279, 0.0878812521696091, 0.0877087116241455, 0.0875361561775208, 0.087363488972187, 0.087190754711628, 0.0870179682970047, 0.0868451073765755, 0.0866722613573074, 0.0864992737770081, 0.0863262340426445, 0.0861531421542168, 0.0859799757599831, 0.0858067870140076, 0.0856334865093231, 0.0854601487517357, 0.0852867215871811, 0.0851132497191429, 0.0849397480487823, 0.0847661644220352, 0.0845925062894821, 0.0844187587499619, 0.0842449739575386, 0.084071159362793, 0.0838972479104996, 0.0837232619524002, 0.0835492238402367, 0.0833751186728477, 0.0832009539008141, 0.0830267667770386, 0.0828524902462959, 0.0826781317591667, 0.0825037211179733, 0.0823292285203934, 0.0821547508239746, 0.0819801390171051, 0.0818054676055908, 0.0816307365894318, 0.0814559459686279, 0.0812811329960823, 0.0811062231659889, 0.080931231379509, 0.0807562172412872, 0.0805810987949371, 0.080405980348587, 0.0802307650446892, 0.0800554528832436, 0.0798800960183144, 0.079704686999321, 0.0795292481780052, 0.0793536901473999, 0.079178087413311, 0.0790024250745773, 0.0788267180323601, 0.0786509588360786, 0.07847511023283, 0.0782991871237755, 0.0781232118606567, 0.077947162091732, 0.0777710899710655, 0.0775949358940125, 0.0774186924099922, 0.0772423967719078, 0.0770660489797592, 0.0768896862864494, 0.0767132043838501, 0.0765366703271866, 0.0763600468635559, 0.0761833861470222, 0.0760066881775856, 0.0758299008011818, 0.0756530463695526, 0.0754761248826981, 0.0752991288900375, 0.0751221626996994, 0.0749450400471687, 0.0747678875923157, 0.0745906382799149, 0.0744133517146111, 0.0742360278964043, 0.0740586146712303, 0.0738811269402504, 0.0737035796046257, 0.0735259652137756, 0.0733483657240868, 0.0731706321239471, 0.0729928389191628, 0.0728149712085724, 0.0726370438933372, 0.0724591165781021, 0.0722810626029968, 0.0721029564738274, 0.0719247907400131, 0.0717465579509735, 0.0715682506561279, 0.0713899508118629, 0.0712115317583084, 0.0710330531001091, 0.0708545073866844, 0.0706758946180344, 0.0704972743988037, 0.0703185349702835, 0.0701397359371185, 0.0699608698487282, 0.0697819441556931, 0.0696030259132385, 0.0694239884614944, 0.0692448690533638, 0.0690656900405884, 0.0688864663243294, 0.0687072053551674, 0.068527840077877, 0.0683484226465225, 0.0681689456105232, 0.0679893866181374, 0.0678098425269127, 0.0676301568746567, 0.0674504265189171, 0.0672706291079521, 0.0670907720923424, 0.0669109001755714, 0.0667309165000916, 0.0665508508682251, 0.0663707330822945, 0.0661905631422997, 0.0660104006528854, 0.0658301040530205, 0.0656497403979301, 0.0654693096876144, 0.065288819372654, 0.0651083141565323, 0.0649277120828629, 0.0647470280528069, 0.0645663067698479, 0.0643854960799217, 0.0642047077417374, 0.0640237703919411, 0.0638427883386612, 0.0636617243289948, 0.0634806230664253, 0.0632994994521141, 0.0631182491779327, 0.0629369467496872, 0.0627555921673775, 0.0625741630792618, 0.0623927414417267, 0.0622111931443214, 0.0620295777916908, 0.0618479028344154, 0.061666164547205, 0.0614844039082527, 0.0613025426864624, 0.0611206106841564, 0.0609386190772057, 0.060756579041481, 0.0605745241045952, 0.0603923536837101, 0.0602101050317287, 0.0600278005003929, 0.0598454438149929, 0.0596630088984966, 0.0594805739820004, 0.0592980235815048, 0.0591153986752033, 0.0589327253401279, 0.0587499886751175, 0.0585672557353973, 0.0583843924105167, 0.0582014508545399, 0.0580184757709503, 0.0578354075551033, 0.0576523579657078, 0.0574691779911518, 0.0572859384119511, 0.0571026280522346, 0.0569192618131638, 0.0567358620464802, 0.0565523989498615, 0.0563688389956951, 0.0561852194368839, 0.0560015626251698, 0.0558178499341011, 0.0556340701878071, 0.0554501935839653, 0.055266261100769, 0.0550822578370571, 0.0548982582986355, 0.0547141581773758, 0.0545299686491489, 0.0543457493185997, 0.0541614294052124, 0.0539771132171154, 0.0537927001714706, 0.0536081939935684, 0.0534236580133438, 0.0532390214502811, 0.0530543886125088, 0.0528696626424789, 0.0526848360896111, 0.0524999834597111, 0.0523150339722633, 0.052130114287138, 0.0519450753927231, 0.0517599657177925, 0.0515747629106045, 0.0513895303010941, 0.0512042641639709, 0.0510189011693001, 0.0508334785699844, 0.050647959113121, 0.0504624061286449, 0.0502768568694592, 0.0500911809504032, 0.0499054379761219, 0.0497196391224861, 0.0495337694883347, 0.0493478737771511, 0.0491618812084198, 0.0489758253097534, 0.048789706081152, 0.0486035235226154, 0.0484173707664013, 0.0482310652732849, 0.0480446927249432, 0.0478582568466663, 0.0476717539131641, 0.0474851913750172, 0.0472986325621605, 0.0471119396388531, 0.0469251871109009, 0.0467383787035942, 0.0465515293180943, 0.0463646501302719, 0.0461776778101921, 0.0459906086325645, 0.0458034761250019, 0.0456163138151169, 0.0454290919005871, 0.0452417992055416, 0.045054417103529, 0.0448669977486134, 0.0446794852614403, 0.0444920063018799, 0.0443043746054173, 0.0441167019307613, 0.0439289733767509, 0.0437411405146122, 0.043553315103054, 0.0433653928339481, 0.0431773774325848, 0.0429893285036087, 0.0428012199699879, 0.0426131039857864, 0.0424248352646828, 0.0422365330159664, 0.0420481711626053, 0.0418597422540188, 0.0416712835431099, 0.0414827316999435, 0.0412941128015518, 0.0411054342985153, 0.0409166887402534, 0.0407279431819916, 0.0405390709638596, 0.0403501093387604, 0.0401611439883709, 0.039972048252821, 0.039782989770174, 0.0395938046276569, 0.0394045524299145, 0.0392152406275272, 0.0390258617699146, 0.0388365164399147, 0.0386470183730125, 0.0384574495255947, 0.0382678210735321, 0.0380781255662441, 0.0378884337842464, 0.0376986153423786, 0.0375087670981884, 0.0373188182711601, 0.0371288135647774, 0.0369388349354267, 0.0367486998438835, 0.0365585312247276, 0.0363682694733143, 0.0361779443919659, 0.0359876193106174, 0.0357972010970116, 0.0356066860258579, 0.0354161411523819, 0.0352254994213581, 0.0350348241627216, 0.0348441526293755, 0.0346533209085464, 0.0344624593853951, 0.0342715308070183, 0.0340805128216743, 0.0338894911110401, 0.0336983762681484, 0.0335071980953217, 0.0333159528672695, 0.0331246182322502, 0.0329333133995533, 0.0327418819069862, 0.0325503870844841, 0.0323588289320469, 0.0321672074496746, 0.0319755524396896, 0.0317838042974472, 0.0315919928252697, 0.0314001217484474, 0.0312081836163998, 0.0310162138193846, 0.0308241806924343, 0.0306320525705814, 0.0304398611187935, 0.0302476081997156, 0.0300553534179926, 0.0298629719763994, 0.0296705309301615, 0.0294780228286982, 0.0292854849249125, 0.0290928818285465, 0.0289002172648907, 0.0287074595689774, 0.0285146664828062, 0.0283217802643776, 0.028128894045949, 0.0279358830302954, 0.0277428384870291, 0.0275496989488602, 0.0273564960807562, 0.0271632913500071, 0.0269699934870005, 0.0267766024917364, 0.0265831798315048, 0.026389691978693, 0.0261961743235588, 0.0260025281459093, 0.0258088521659374, 0.0256151128560305, 0.0254212766885757, 0.0252274423837662, 0.0250335112214088, 0.0248395185917616, 0.0246454309672117, 0.0244513098150492, 0.0242571923881769, 0.0240629445761442, 0.0238686371594667, 0.0236742310225964, 0.0234797969460487, 0.023285361006856, 0.0230907667428255, 0.0228961426764727, 0.0227014534175396, 0.0225067008286715, 0.0223118867725134, 0.0221170708537102, 0.0219221282750368, 0.0217271260917187, 0.02153205499053, 0.0213369242846966, 0.021141791716218, 0.0209465343505144, 0.0207512136548758, 0.020555829629302, 0.0203604139387608, 0.020164966583252, 0.019969392567873, 0.019773755222559, 0.0195780880749226, 0.0193823222070932, 0.0191865600645542, 0.0189906693994999, 0.0187947154045105, 0.0185987297445536, 0.0184026509523392, 0.0182066019624472, 0.0180103946477175, 0.0178141575306654, 0.0176178235560656, 0.0174214281141758, 0.0172250308096409, 0.0170285403728485, 0.0168319866061211, 0.016635337844491, 0.0164386555552483, 0.0162419434636831, 0.0160451363772154, 0.0158482659608126, 0.0156513005495071, 0.0154543034732342, 0.0152572747319937, 0.0150601519271731, 0.014862964861095, 0.0146657144650817, 0.0144683700054884, 0.0142710888758302, 0.0140736168250442, 0.0138761140406132, 0.0136785479262471, 0.013480918481946, 0.0132832573726773, 0.0130855021998286, 0.0128876827657223, 0.0126898009330034, 0.0124918539077044, 0.012293940410018, 0.0120958676561713, 0.0118977334350348, 0.011699534021318, 0.0115012722089887, 0.0113030103966594, 0.0111046228557825, 0.010906171053648, 0.0107076559215784, 0.0105090783908963, 0.0103105315938592, 0.010111827403307, 0.00991305988281965, 0.00971426069736481, 0.00951536558568478, 0.00931640807539225, 0.00911745056509972, 0.00891839805990458, 0.0087192514911294, 0.00852004066109657, 0.00832079909741879, 0.00812155660241842, 0.00792215671390295, 0.00772272516041994, 0.00752319814637303, 0.00732363993301988, 0.00712405005469918, 0.00692436518147588, 0.00672458577901125, 0.00652477471157908, 0.00632486818358302, 0.00612499378621578, 0.0059249927289784, 0.00572492880746722, 0.00552480109035969, 0.00532457930967212, 0.00512438826262951, 0.0049240393564105, 0.00472365925088525, 0.00452321534976363, 0.00432270858436823, 0.00412220181897283, 0.00392156792804599, 0.00372087187133729, 0.0035201117862016, 0.00331928883679211, 0.00311843398958445, 0.00291751581244171, 0.00271650310605764, 0.00251542730256915, 0.0023142877034843, 0.00211311690509319, 0.00191188266035169, 0.00171055365353823, 0.00150916143320501, 0.00130773754790425, 0.00110625044908375, 0.000904699962120503, 0.000703054771292955, 0.000501346308737993, 0.000299574574455619, 9.78028474492021e-05, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353, 0.0479512326419353   }, 
   { 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 2.36422671567318e-15, 1.60967957185676e-07, 5.00358282806701e-07, 8.37809182030469e-07, 1.17913884878362e-06, 1.51658969116397e-06, 1.85985879852524e-06, 2.20506717596436e-06, 2.55221516454185e-06, 2.8954839308426e-06, 3.24457096212427e-06, 3.59365822077962e-06, 3.94468452213914e-06, 4.29765077569755e-06, 4.64867707705707e-06, 5.00358237331966e-06, 5.35848766958225e-06, 5.71533200854901e-06, 6.07023775955895e-06, 6.43096109342878e-06, 6.79168442729861e-06, 7.15434725861996e-06, 7.51313154978561e-06, 7.87967292126268e-06, 8.2462138379924e-06, 8.61275566421682e-06, 8.9831755758496e-06, 9.34971740207402e-06, 9.7201382232015e-06, 1.00924971775385e-05, 1.0466796993569e-05, 1.08372159957071e-05, 1.1215393897146e-05, 1.15935717985849e-05, 1.19717497000238e-05, 1.23479876492638e-05, 1.27300445456058e-05, 1.31140404846519e-05, 1.34980355142034e-05, 1.38820323627442e-05, 1.42640883495915e-05, 1.46539032357396e-05, 1.50417772601941e-05, 1.54335302795516e-05, 1.58214061229955e-05, 1.6215099094552e-05, 1.6608790247119e-05, 1.70044222613797e-05, 1.73961761902319e-05, 1.77956862899009e-05, 1.81951982085593e-05, 1.85947083082283e-05, 1.8998098312295e-05, 1.9397608411964e-05, 1.98010002350202e-05, 2.02063292817911e-05, 2.06135955522768e-05, 2.10189245990478e-05, 2.14281335502164e-05, 2.18392797250999e-05, 2.22504277189728e-05, 2.26615738938563e-05, 2.30746609304333e-05, 2.34896870097145e-05, 2.39085911744041e-05, 2.43255544774001e-05, 2.4742521418375e-05, 2.51633646257687e-05, 2.55861505138455e-05, 2.60089327639434e-05, 2.64297759713372e-05, 2.68564381258329e-05, 2.72831002803287e-05, 2.77117014775285e-05, 2.81422417174326e-05, 2.85689056909177e-05, 2.9001384973526e-05, 2.94358051178278e-05, 2.98702252621297e-05, 3.03046417684527e-05, 3.07410009554587e-05, 3.11793010041583e-05, 3.16195400955621e-05, 3.20578365062829e-05, 3.25000146403909e-05, 3.2944131817203e-05, 3.33901843987405e-05, 3.38343015755527e-05, 3.42784187523648e-05, 3.47283530572895e-05, 3.51782873622142e-05, 3.5630160709843e-05, 3.60781596100423e-05, 3.65339110430796e-05, 3.69877197954338e-05, 3.74434748664498e-05, 3.79011653421912e-05, 3.83569204132073e-05, 3.8818488974357e-05, 3.92800611734856e-05, 3.97435687773395e-05, 4.02032055717427e-05, 4.06686558562797e-05, 4.11341025028378e-05, 4.16034308727831e-05, 4.206888115732e-05, 4.25401485699695e-05, 4.30114123446401e-05, 4.34846224379726e-05, 4.39597715740092e-05, 4.44310353486799e-05, 4.49061808467377e-05, 4.53852080681827e-05, 4.58642316516489e-05, 4.63413198303897e-05, 4.6824225137243e-05, 4.73071268061176e-05, 4.77919711556751e-05, 4.82748764625285e-05, 4.87597135361284e-05, 4.92484396090731e-05, 4.97391010867432e-05, 5.02297625644132e-05, 5.07184849993791e-05, 5.12110818817746e-05, 5.17075604875572e-05, 5.22021036886144e-05, 5.26966468896717e-05, 5.31931254954543e-05, 5.36934821866453e-05, 5.41957815585192e-05, 5.46941955690272e-05, 5.51984376215842e-05, 5.57026760361623e-05, 5.62088498554658e-05, 5.67169663554523e-05, 5.72212047700305e-05, 5.77312603127211e-05, 5.8241312217433e-05, 5.8755245845532e-05, 5.92653013882227e-05, 5.97792350163218e-05, 6.0297050367808e-05, 6.08129230386112e-05, 6.13287920714356e-05, 6.18485501036048e-05, 6.23702362645417e-05, 6.28919297014363e-05, 6.34175012237392e-05, 6.39372519799508e-05, 6.44647589069791e-05, 6.49922658340074e-05, 6.55197800369933e-05, 6.60472869640216e-05, 6.65786719764583e-05, 6.71120069455355e-05, 6.76453273626976e-05, 6.81825404171832e-05, 6.87139254296198e-05, 6.92511312081479e-05, 6.97902796673588e-05, 7.03313635312952e-05, 7.08705119905062e-05, 7.14135312591679e-05, 7.19565578037873e-05, 7.2503462433815e-05, 7.30464889784344e-05, 7.35933863325045e-05, 7.41422263672575e-05, 7.46930090826936e-05, 7.52457344788127e-05, 7.57945817895234e-05, 7.63492353144102e-05, 7.69058387959376e-05, 7.74624350015074e-05, 7.80171030783094e-05, 7.85756419645622e-05, 7.9136123531498e-05, 7.96985332272016e-05, 8.02590147941373e-05, 8.08233671705239e-05, 8.1389669503551e-05, 8.19559718365781e-05, 8.25241950224154e-05, 8.30904973554425e-05, 8.36606704979204e-05, 8.42327863210812e-05, 8.48068448249251e-05, 8.53770252433605e-05, 8.59549545566551e-05, 8.65309484652244e-05, 8.71108204592019e-05, 8.76848789630458e-05, 8.82666863617487e-05, 8.88484937604517e-05, 8.94322438398376e-05, 9.00179365999065e-05, 9.05997512745671e-05, 9.11873794393614e-05, 9.17769502848387e-05, 9.2366521130316e-05, 9.29541492951103e-05, 9.35456555453129e-05, 9.41410471568815e-05, 9.47364314924926e-05, 9.53279377426952e-05, 9.59252647589892e-05, 9.65245344559662e-05, 9.71238041529432e-05, 9.77269519353285e-05, 9.83242716756649e-05, 9.89293621387333e-05, 9.9534445325844e-05, 0.00010014146391768, 0.000100744611700065, 0.000101353580248542, 0.000101964476925787, 0.000102575380878989, 0.000103188220236916, 0.000103799131466076, 0.000104415841633454, 0.000105032566352747, 0.000105649291072041, 0.000106266008515377, 0.000106884668639395, 0.000107507206848823, 0.00010812974505825, 0.000108750340586994, 0.000109376756881829, 0.000110003180452622, 0.000110631539428141, 0.000111261833808385, 0.000111886314698495, 0.000112518544483464, 0.000113152716949116, 0.000113786896690726, 0.000114419126475696, 0.000115057184302714, 0.000115695234853774, 0.000116335228085518, 0.000116971343231853, 0.000117613271868322, 0.000118257150461432, 0.000118901021778584, 0.000119546828500461, 0.00012019070709357, 0.000120840399176814, 0.000121490083984099, 0.000122139768791385, 0.000122787532745861, 0.000123441102914512, 0.000124096593935974, 0.000124754049465992, 0.000125407619634643, 0.000126065075164661, 0.000126726386952214, 0.000127387713291682, 0.000128049039631151, 0.000128708430565894, 0.000129373627714813, 0.000130040774820372, 0.000130707921925932, 0.000131373133626767, 0.000132042216137052, 0.000132715169456787, 0.000133386201923713, 0.000134057219838724, 0.0001347321231151, 0.000135408961796202, 0.000136085800477304, 0.000136764589115046, 0.000137441427796148, 0.000138124087243341, 0.000138804811285809, 0.000139489406137727, 0.00014017206558492, 0.000140858610393479, 0.000141545140650123, 0.000142235556268133, 0.000142922101076692, 0.000143612516694702, 0.000144304867717437, 0.000144999168696813, 0.000145695405080914, 0.000146389691508375, 0.000147087863297202, 0.000147786049637944, 0.000148488106788136, 0.000149184328620322, 0.00014988832117524, 0.000150592313730158, 0.000151298256241716, 0.00015200418420136, 0.000152710126712918, 0.000153419925482012, 0.000154129738803022, 0.000154841487528756, 0.00015555128629785, 0.00015626497042831, 0.000156980619067326, 0.000157698174007237, 0.000158413808094338, 0.000159133312990889, 0.000159854767844081, 0.000160576208145358, 0.000161299598403275, 0.000162019103299826, 0.000162746364367194, 0.000163473625434563, 0.000164202836458571, 0.000164928162121214, 0.000165659308549948, 0.000166392390383407, 0.000167125472216867, 0.000167856604093686, 0.000168591650435701, 0.000169330538483337, 0.000170067505678162, 0.000170808343682438, 0.000171545310877264, 0.000172288084286265, 0.000173030872247182, 0.000173777531017549, 0.000174520289874636, 0.000175266948645003, 0.000176015571923926, 0.000176766101503745, 0.000177514695678838, 0.000178267175215296, 0.00017901964019984, 0.000179776005097665, 0.000180532355443574, 0.000181286784936674, 0.000182045070687309, 0.000182805306394584, 0.000183567477506585, 0.00018432576325722, 0.000185089884325862, 0.000185855940799229, 0.000186621982720681, 0.000187386103789322, 0.00018815603107214, 0.000188925958354957, 0.000189697835594416, 0.000190469712833874, 0.000191241575521417, 0.000192017323570326, 0.000192793071619235, 0.00019357270502951, 0.000194346503121778, 0.000195128086488694, 0.000195909655303694, 0.00019669315952342, 0.000197476663743146, 0.000198258218006231, 0.000199045607587323, 0.000199834947125055, 0.000200624272110872, 0.000201411647140048, 0.000202202907530591, 0.000202998053282499, 0.000203791263629682, 0.000204582524020225, 0.000205379605176859, 0.000206178621738218, 0.000206979588256218, 0.000207780554774217, 0.000208577621378936, 0.000209382473258302, 0.000210185375181027, 0.000210992147913203, 0.000211795049835928, 0.000212603772524744, 0.000213414430618286, 0.000214225088711828, 0.000215033811400644, 0.000215848340303637, 0.000216662883758545, 0.000217479348066263, 0.000218295826925896, 0.000219112305785529, 0.000219930720049888, 0.000220753019675612, 0.000221575319301337, 0.000222395668970421, 0.000223219889448956, 0.000224046074436046, 0.000224874194827862, 0.000225704236072488, 0.000226530406507663, 0.00022736239770893, 0.000228194403462112, 0.000229028315516189, 0.000229860306717455, 0.000230696183280088, 0.000231533995247446, 0.000232373742619529, 0.000233209619182162, 0.000234051301958971, 0.00023489493469242, 0.000235738538322039, 0.000236584121012129, 0.000237425803788938, 0.000238275257288478, 0.000239124696236104, 0.000239974149735644, 0.00024082358868327, 0.000241674977587536, 0.000242530237301253, 0.000243385511566885, 0.000244238821323961, 0.000245096045546234, 0.000245955161517486, 0.000246816256549209, 0.000247679272433743, 0.000248538417508826, 0.00024940338335, 0.000250268349191174, 0.000251135235885158, 0.000252000201726332, 0.000252869038376957, 0.000253739795880392, 0.000254612532444298, 0.000255483319051564, 0.00025635797646828, 0.000257232633884996, 0.000258109212154523, 0.00025898776948452, 0.000259864347754046, 0.000260744825936854, 0.000261627254076302, 0.00026251160306856, 0.000263392081251368, 0.000264278380200267, 0.000265166600001976, 0.000266054819803685, 0.000266944989562035, 0.000267831317614764, 0.000268725358182564, 0.000269619398750365, 0.000270513439318165, 0.000271405559033155, 0.000272303499514237, 0.000273201439995319, 0.00027410130132921, 0.000274999212706462, 0.000275902973953635, 0.000276806706096977, 0.00027771238819696, 0.000278618070296943, 0.000279521831544116, 0.00028043141355738, 0.000281340966466814, 0.000282252469332889, 0.000283162051346153, 0.000284075475065038, 0.000284990877844393, 0.000285908201476559, 0.000286821654299274, 0.00028774089878425, 0.000288662093225867, 0.000289583287667483, 0.00029050643206574, 0.000291425705654547, 0.000292352720862255, 0.000293277815217152, 0.000294206780381501, 0.000295131845632568, 0.000296062760753557, 0.000296995567623526, 0.000297928432701156, 0.000298859347822145, 0.000299794075544924, 0.000300730811432004, 0.000301669468171895, 0.000302608124911785, 0.000303544860798866, 0.000304487388348207, 0.000305431865854189, 0.000306376343360171, 0.000307318870909512, 0.000308263348415494, 0.000309213646687567, 0.000310161995003, 0.000311110343318433, 0.000312062591547146, 0.00031301481067203, 0.000313970929710194, 0.000314927019644529, 0.000315881217829883, 0.000316837307764217, 0.000317797326715663, 0.000318759237416089, 0.000319717277307063, 0.00032068116706796, 0.000321646948577836, 0.000322612759191543, 0.00032358051976189, 0.000324544380418956, 0.000325514061842114, 0.000326485722325742, 0.00032745924545452, 0.000328428955981508, 0.000329404458170757, 0.000330379960360005, 0.000331357412505895, 0.000332332885591313, 0.000333312287693843, 0.000334293610649183, 0.000335276854457334, 0.000336262077325955, 0.000337243400281295, 0.000338228594046086, 0.000339217658620328, 0.00034020483144559, 0.000341191975167021, 0.000342182989697903, 0.000343175925081596, 0.00034417086862959, 0.000345161854056641, 0.000346158689353615, 0.00034715750371106, 0.000348156259860843, 0.000349156965967268, 0.000350153801264241, 0.000351158378180116, 0.000352163013303652, 0.000353167590219527, 0.000354170246282592, 0.000355178723111749, 0.000356189120793715, 0.000357199547579512, 0.000358206103555858, 0.000359220372047275, 0.000360234669642523, 0.000361250888090581, 0.000362267135642469, 0.000363281433237717, 0.000364301551599056, 0.000365321640856564, 0.000366343709174544, 0.000367363827535883, 0.000368387816706672, 0.000369415676686913, 0.000370441586710513, 0.000371467525837943, 0.000372495385818183, 0.000373527116607875, 0.000374558876501396, 0.000375592557247728, 0.000376624288037419, 0.000377659947844222, 0.000378697499400005, 0.000379737000912428, 0.00038077071076259, 0.000381812133127823, 0.000382855534553528, 0.000383898877771571, 0.000384944229153916, 0.00038598757237196, 0.000387034873710945, 0.00038808406679891, 0.000389133259886876, 0.000390180532122031, 0.000391233596019447, 0.000392286689020693, 0.00039334173197858, 0.000394394766772166, 0.000395453680539504, 0.00039650869439356, 0.000397571478970349, 0.000398632313590497, 0.000399693148210645, 0.000400757853640243, 0.000401820638217032, 0.000402887293603271, 0.000403953978093341, 0.00040502255433239, 0.00040608920971863, 0.00040716360672377, 0.00040823218296282, 0.000409308559028432, 0.000410379085224122, 0.000411459302995354, 0.000412537629017606, 0.000413613946875557, 0.00041469422285445, 0.000415774411521852, 0.000416856608353555, 0.000417940696934238, 0.000419024814618751, 0.000420110882259905, 0.000421198841650039, 0.000422284909291193, 0.000423376797698438, 0.000424468627898023, 0.000425560487201437, 0.000426654325565323, 0.000427748134825379, 0.000428845814894885, 0.000429941574111581, 0.000431043124990538, 0.000432140805060044, 0.000433242385042831, 0.000434343935921788, 0.000435449386714026, 0.000436550937592983, 0.000437660259194672, 0.000438769580796361, 0.00043987698154524, 0.000440988223999739, 0.000442097545601428, 0.000443210738012567, 0.000444323959527537, 0.000445441022748128, 0.000446556136012077, 0.000447675178293139, 0.00044879419147037, 0.000449915154604241, 0.000451034167781472, 0.000452159001724795, 0.000453283864771947, 0.000454408669611439, 0.000455535453511402, 0.000456662237411365, 0.000457792863016948, 0.000458923546830192, 0.000460054201539606, 0.00046118680620566, 0.000462321331724524, 0.000463455857243389, 0.000464594253571704, 0.00046573267900385, 0.000466873025288805, 0.000468011421617121, 0.000469153717858717, 0.000470297934953123, 0.000471442210255191, 0.000472588377306238, 0.000473734544357285, 0.000474884582217783, 0.00047603267012164, 0.000477184687042609, 0.000478334724903107, 0.000479488633573055, 0.000480642600450665, 0.000481800379930064, 0.000482956267660484, 0.000484115997096524, 0.000485273834783584, 0.000486435485072434, 0.000487599114421755, 0.000488760764710605, 0.000489926373120397, 0.000491091923322529, 0.000492261373437941, 0.000493428844492882, 0.000494598294608295, 0.000495769723784178, 0.00049694103654474, 0.000498114386573434, 0.000499289657454938, 0.000500466849189252, 0.000501644040923566, 0.000502825132571161, 0.000504004245158285, 0.00050518533680588, 0.000506366428453475, 0.000507551361806691, 0.000508736295159906, 0.000509923265781254, 0.000511110119987279, 0.000512298953253776, 0.000513489707373083, 0.00051468244055286, 0.000515873252879828, 0.000517067848704755, 0.000518262560945004, 0.000519459135830402, 0.000520657689776272, 0.00052185618551448, 0.00052305863937363, 0.000524259055964649, 0.000525461509823799, 0.00052666588453576, 0.000527872121892869, 0.00052907649660483, 0.000530286633875221, 0.000531494850292802, 0.000532706966623664, 0.000533917162101716, 0.000535131199285388, 0.00053634331561625, 0.000537561252713203, 0.000538779189810157, 0.000539995147846639, 0.000541216984856874, 0.000542436842806637, 0.000543658621609211, 0.000544880458619446, 0.0005461061373353, 0.000547329836990684, 0.00054855941561982, 0.000549787073396146, 0.000551016593817621, 0.000552246172446758, 0.000553479650989175, 0.000554713071323931, 0.000555946491658688, 0.000557183811906725, 0.000558421132154763, 0.00055966037325561, 0.000560899672564119, 0.000562140834517777, 0.000563382054679096, 0.000564627116546035, 0.000565870257560164, 0.000567117298487574, 0.000568364339414984, 0.000569613242987543, 0.000570862204767764, 0.000572115066461265, 0.000573367869947106, 0.000574620731640607, 0.000575875514186919, 0.00057713221758604, 0.000578390900045633, 0.000579647603444755, 0.000580910127609968, 0.000582170730922371, 0.000583433255087584, 0.000584695779252797, 0.000585962145123631, 0.000587226648349315, 0.00058849697234109, 0.000589763338211924, 0.000591035583056509, 0.000592307827901095, 0.00059358001453802, 0.000594854238443077, 0.000596128345932811, 0.000597406411543489, 0.000598682498093694, 0.000599962542764843, 0.000601242471020669, 0.000602526357397437, 0.000603808264713734, 0.000605092092882842, 0.000606376037467271, 0.00060766376554966, 0.000608951551839709, 0.000610241142567247, 0.000611532828770578, 0.000612824398558587, 0.000614117947407067, 0.000615411554463208, 0.000616707082372159, 0.00061800453113392, 0.00061930384254083, 0.000620601291302592, 0.000621904560830444, 0.000623205909505486, 0.000624509120825678, 0.000625812390353531, 0.000627119559794664, 0.000628426671028137, 0.000629733840469271, 0.000631044851616025, 0.000632355862762779, 0.000633668852970004, 0.000634981784969568, 0.000636296637821943, 0.000637611548881978, 0.000638928380794823, 0.000640247133560479, 0.000641567865386605, 0.000642892497126013, 0.000644211249891669, 0.000645537802483886, 0.000646860396955162, 0.00064818694954738, 0.000649513502139598, 0.000650841917376965, 0.000652172369882464, 0.000653504743240774, 0.000654835137538612, 0.000656171352602541, 0.000657505646813661, 0.000658841920085251, 0.000660181976854801, 0.000661518250126392, 0.000662860285956413, 0.000664200342725962, 0.000665546336676925, 0.000666886393446475, 0.000668232329189777, 0.000669578206725419, 0.000670926121529192, 0.000672273978125304, 0.000673625676427037, 0.00067497551208362, 0.000676331110298634, 0.000677686766721308, 0.000679040444083512, 0.000680396100506186, 0.000681755598634481, 0.000683115096762776, 0.000684476515743881, 0.000685836013872176, 0.000687201332766563, 0.000688564730808139, 0.000689929991494864, 0.000691295368596911, 0.000692664529196918, 0.000694035668857396, 0.000695404829457402, 0.000696777948178351, 0.000698151008691639, 0.000699526048265398, 0.000700901029631495, 0.000702278048265725, 0.000703654950484633, 0.000705035810824484, 0.000706414692103863, 0.000707799452356994, 0.000709180254489183, 0.000710566877387464, 0.000711953500285745, 0.000713338260538876, 0.000714728783350438, 0.00071611738530919, 0.000717509887181222, 0.000718900409992784, 0.000720294774509966, 0.000721689197234809, 0.000723085540812463, 0.000724481884390116, 0.00072588212788105, 0.000727282313164324, 0.000728682556655258, 0.000730086700059474, 0.000731488806195557, 0.000732894928660244, 0.000734300934709609, 0.000735706998966634, 0.000737114925868809, 0.000738526810891926, 0.000739936775062233, 0.0007413505227305, 0.000742766307666898, 0.000744180113542825, 0.000745597761124372, 0.00074701348785311, 0.000748433114495128, 0.000749852799344808, 0.000751274346839637, 0.000752697815187275, 0.000754121283534914, 0.000755546789150685, 0.000756974157411605, 0.000758399604819715, 0.000759830872993916, 0.000761262082960457, 0.000762691430281848, 0.000764126540161669, 0.000765559787396342, 0.000766996876336634, 0.000768431986216456, 0.000769870996009558, 0.000771308084949851, 0.000772750936448574, 0.000774191925302148, 0.000775634776800871, 0.000777079607360065, 0.000778524437919259, 0.000779973168391734, 0.0007814199780114, 0.000782870571129024, 0.000784319301601499, 0.000785773794632405, 0.000787224504165351, 0.000788680976256728, 0.000790135469287634, 0.000791593920439482, 0.000793050392530859, 0.000794510706327856, 0.000795972999185324, 0.000797433371189982, 0.00079889950575307, 0.000800361798610538, 0.000801829912234098, 0.000803296105004847, 0.000804766139481217, 0.000806232274044305, 0.000807706208433956, 0.000809176301117986, 0.000810652098152786, 0.000812126090750098, 0.000813601887784898, 0.00081508164294064, 0.000816557556390762, 0.000818039174191654, 0.000819518929347396, 0.000821002526208758, 0.000822486123070121, 0.000823971698991954, 0.000825457274913788, 0.000826944829896092, 0.000828434247523546, 0.000829923723358661, 0.000831417040899396, 0.00083290837937966, 0.000834403675980866, 0.000835896993521601, 0.000837394152767956, 0.000838891370221972, 0.000840392429381609, 0.000841889588627964, 0.000843392568640411, 0.000844893744215369, 0.000846400565933436, 0.000847903604153544, 0.000849412404932082, 0.000850921263918281, 0.000852428143844008, 0.000853938981890678, 0.000855449703522027, 0.000856964325066656, 0.000858477025758475, 0.000859993684571236, 0.000861510226968676, 0.000863028806634247, 0.000864547328092158, 0.000866067770402879, 0.00086759019177407, 0.000869114533998072, 0.000870638876222074, 0.000872163218446076, 0.000873691402375698, 0.000875219702720642, 0.000876749865710735, 0.000878278049640357, 0.000879812112543732, 0.000881344196386635, 0.00088288018014282, 0.000884414184838533, 0.000885952147655189, 0.000887492031324655, 0.000889031914994121, 0.000890571740455925, 0.000892113544978201, 0.000893657270353287, 0.000895202974788845, 0.000896748621016741, 0.000898294325452298, 0.000899845792446285, 0.000901393475942314, 0.000902945001143962, 0.000904496409930289, 0.000906051835045218, 0.000907607201952487, 0.000909162627067417, 0.000910721777472645, 0.000912279181648046, 0.000913840311113745, 0.000915399577934295, 0.000916962744668126, 0.000918525911401957, 0.000920092919841409, 0.000921657949220389, 0.000923226936720312, 0.000924795866012573, 0.000926364795304835, 0.000927937624510378, 0.00092950853286311, 0.000931083282921463, 0.000932658091187477, 0.000934234820306301, 0.000935813470277935, 0.000937392120249569, 0.000938972632866353, 0.000940553261898458, 0.000942135811783373, 0.000943720282521099, 0.000945306674111634, 0.00094689306570217, 0.000948481436353177, 0.000950069807004184, 0.00095166196115315, 0.000953252252656966, 0.000954846444074064, 0.000956440635491163, 0.000958036747761071, 0.000959632860030979, 0.000961230834946036, 0.000962832767982036, 0.000964430859312415, 0.000966032734140754, 0.000967636588029563, 0.000969240500126034, 0.000970846274867654, 0.000968494976405054, 0.000962200749199837, 0.000955868687015027, 0.000949591922108084, 0.000943338382057846, 0.000937061558943242, 0.000930841080844402, 0.000924629217479378, 0.000918432953767478, 0.000912245362997055, 0.000906080123968422, 0.00089994102017954, 0.000893792253918946, 0.000887677422724664, 0.000881600426509976, 0.000875494268257171, 0.000869450159370899, 0.000863407098222524, 0.000857372710015625, 0.000851361604873091, 0.000845390313770622, 0.000839411281049252, 0.000833440804854035, 0.000827501527965069, 0.000821548688691109, 0.000815657782368362, 0.00080976786557585, 0.000803916773293167, 0.000798058928921819, 0.000792201026342809, 0.000786391668953001, 0.000780559028498828, 0.000774789368733764, 0.0007690274505876, 0.000763289863243699, 0.000757529865950346, 0.000751807761844248, 0.000746096309740096, 0.000740414892788976, 0.000734757690224797, 0.000729117076843977, 0.000723485136404634, 0.000717860995791852, 0.000712261011358351, 0.000706669758073986, 0.000701108598150313, 0.000695580441970378, 0.000690052285790443, 0.000684526050463319, 0.000679029850289226, 0.000673543312586844, 0.000668080116156489, 0.000662648875731975, 0.00065723224543035, 0.000651818467304111, 0.000646420230623335, 0.000641045218799263, 0.000635664444416761, 0.000630337046459317, 0.000625019252765924, 0.000619722821284086, 0.000614414748270065, 0.0006091357790865, 0.000603906286414713, 0.00059863697970286, 0.000593439443036914, 0.000588233233429492, 0.00058303662808612, 0.00057786435354501, 0.000572714314330369, 0.000567566254176199, 0.000562449276912957, 0.000557371939066797, 0.000552286917809397, 0.000547211559023708, 0.00054215855197981, 0.000537153973709792, 0.000532101897988468, 0.00052711385069415, 0.000522150017786771, 0.000517155160196126, 0.000512223283294588, 0.000507299206219614, 0.000502407143358141, 0.0004974763141945, 0.000492609455250204, 0.000487765879370272, 0.000482892210129648, 0.000478080648463219, 0.000473277759738266, 0.000468459416879341, 0.000463705015135929, 0.000458942929981276, 0.000454196269856766, 0.000449474900960922, 0.00044478353811428, 0.000440094125224277, 0.000435396941611543, 0.000430762796895579, 0.000426120939664543, 0.00042149651562795, 0.000416886585298926, 0.000412325141951442, 0.000407756073400378, 0.000403195590479299, 0.000398659409256652, 0.000394115399103612, 0.000389634544262663, 0.000385153602110222, 0.000380704645067453, 0.00037623243406415, 0.000371800968423486, 0.000367400556569919, 0.000362977822078392, 0.000358609366230667, 0.000354257441358641, 0.000349921931046993, 0.000345570966601372, 0.000341259757988155, 0.000336956261890009, 0.000332677998812869, 0.000328438531141728, 0.000324192282278091, 0.000319961545756087, 0.000315747282002121, 0.00031154855969362, 0.000307374022668228, 0.000303215958410874, 0.000299097795505077, 0.000294971774565056, 0.000290862197289243, 0.000286769180092961, 0.000282690656604245, 0.000278637366136536, 0.000274607300525531, 0.000270602526143193, 0.000266573479166254, 0.000262600689893588, 0.000258643354754895, 0.000254656042670831, 0.000250739481998608, 0.00024682970251888, 0.000242937370785512, 0.000239037297433242, 0.000235184677876532, 0.000231309837545268, 0.000227482480113395, 0.000223685172386467, 0.000219889800064266, 0.000216102213016711, 0.000212338869459927, 0.000208615267183632, 0.000204852913157083, 0.00020116129599046, 0.000197469678823836, 0.000193795567611232, 0.000190120437764563, 0.00018647825345397, 0.000182874951860867, 0.000179241498699412, 0.000175654626218602, 0.000172092972206883, 0.00016851483087521, 0.000164985191076994, 0.000161472009494901, 0.000157950140419416, 0.000154468943946995, 0.000151002299389802, 0.00014753760478925, 0.000144096222356893, 0.000140695497975685, 0.000137301612994634, 0.000133878624183126, 0.000130532178445719, 0.000127179999253713, 0.000123843332403339, 0.000120523138321005, 0.000117243638669606, 0.000113962159957737, 0.000110691398731433, 0.000107442938315216, 0.000104204234958161, 0.000100987759651616, 9.77965828496963e-05, 9.46275977184996e-05, 9.14382835617289e-05, 8.83178145159036e-05, 8.5191561083775e-05, 8.20575660327449e-05, 7.8969111200422e-05, 7.59068061597645e-05, 7.28591185179539e-05, 6.97909636073746e-05, 6.67830463498831e-05, 6.37537814327516e-05, 6.07631700404454e-05, 5.78057042730507e-05, 5.48549323866609e-05, 5.19293862453196e-05, 4.89796002511866e-05, 4.60782212030608e-05, 4.31779699283652e-05, 4.03086523874663e-05, 3.74790688510984e-05, 3.46417400578503e-05, 3.18132151733153e-05, 2.90079424303258e-05, 2.62122521235142e-05, 2.3446718842024e-05, 2.07064804271795e-05, 1.79816033778479e-05, 1.52509464896866e-05, 1.25581282190979e-05, 9.88179635896813e-06, 7.20645130058983e-06, 4.55435747426236e-06, 1.93523919733707e-06, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.000971655768807977, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 0.00321411550976336, 3.49690225220911e-07, 2.95034828923235e-06, 5.59948239242658e-06, 8.24777089292184e-06, 1.09288939711405e-05, 1.36178377942997e-05, 1.63165059348103e-05, 1.90374375961255e-05, 2.17671076825354e-05, 2.45375013037119e-05, 2.73147306870669e-05, 3.0109364161035e-05, 3.29185131704435e-05, 3.57374519808218e-05, 3.85795756301377e-05, 4.14304340665694e-05, 4.43201170128305e-05, 4.72117026220076e-05, 5.01178728882223e-05, 5.30569486727472e-05, 5.60038461117074e-05, 5.89749797654804e-05, 6.19393467786722e-05, 6.49414141662419e-05, 6.79532749927603e-05, 7.0980706368573e-05, 7.40409668651409e-05, 7.7092568972148e-05, 8.01772112026811e-05, 8.32763034850359e-05, 8.64015964907594e-05, 8.95404955372214e-05, 9.26977882045321e-05, 9.58628224907443e-05, 9.90434346022084e-05, 0.000102248210168909, 0.000105460807390045, 0.000108706379251089, 0.000111958652269095, 0.000115228460344952, 0.000118529205792584, 0.000121831071737688, 0.000125148304505274, 0.000128483079606667, 0.000131856606458314, 0.000135223366669379, 0.00013861338084098, 0.000142026721732691, 0.000145441968925297, 0.00014888821169734, 0.000152350999996997, 0.000155836984049529, 0.000159332688781433, 0.000162842974532396, 0.000166378420544788, 0.00016990520816762, 0.000173480380908586, 0.000177056630491279, 0.000180663861101493, 0.00018427983741276, 0.000187919067684561, 0.000191551545867696, 0.000195208180230111, 0.000198903697310016, 0.000202600145712495, 0.000206328579224646, 0.000210057085496373, 0.000213809675187804, 0.000217578839510679, 0.000221355818212032, 0.000225172538193874, 0.000228989258175716, 0.000232838880037889, 0.000236687585129403, 0.000240561435930431, 0.000244458555243909, 0.000248348980676383, 0.000252278143307194, 0.000256217026617378, 0.000260186934610829, 0.00026415684260428, 0.000268158793915063, 0.000272153847618029, 0.000276179955108091, 0.000280230393400416, 0.000284289417322725, 0.000288371840724722, 0.000292470678687096, 0.000296570506179705, 0.000300701474770904, 0.000304840970784426, 0.000309020339045674, 0.000313192926114425, 0.000317404221277684, 0.000321616564178839, 0.000325843429891393, 0.00033008778700605, 0.000334356271196157, 0.000338648183969781, 0.000342940911650658, 0.000347265799064189, 0.000351606082404032, 0.00035593961365521, 0.000360319681931287, 0.000364700768841431, 0.000369114772183821, 0.000373535614926368, 0.00037798160337843, 0.000382434343919158, 0.000386920146411285, 0.000391389476135373, 0.000395899434806779, 0.000400424964027479, 0.000404967926442623, 0.000409533182391897, 0.000414108188124374, 0.000418684183387086, 0.000423305697040632, 0.00042792916065082, 0.000432582746725529, 0.000437238137237728, 0.000441924668848515, 0.000446619873400778, 0.000451315077953041, 0.000456051027867943, 0.000460802519228309, 0.000465578195871785, 0.000470353930722922, 0.000475152919534594, 0.000479970301967114, 0.000484793534269556, 0.00048965064343065, 0.000494514708407223, 0.000499403802677989, 0.000504307507071644, 0.000509236473590136, 0.000514148909132928, 0.000519102963153273, 0.000524078495800495, 0.000529072363860905, 0.000534080783836544, 0.000539106607902795, 0.000544149079360068, 0.000549190503079444, 0.000554257014300674, 0.00055936147691682, 0.000564460118766874, 0.000569597526919097, 0.000574736855924129, 0.000579890736844391, 0.00058507762150839, 0.00059025565860793, 0.000595474557485431, 0.000600702129304409, 0.000605952052865177, 0.000611211580689996, 0.000616471224930137, 0.000621779239736497, 0.000627094123046845, 0.000632426410447806, 0.00063777226023376, 0.00064314529299736, 0.000648532004561275, 0.000653936993330717, 0.000659333250951022, 0.000664761639200151, 0.000670230598188937, 0.000675690942443907, 0.000681183242704719, 0.000686691084410995, 0.000692200905177742, 0.000697733834385872, 0.000703283410985023, 0.000708863895852119, 0.000714445486664772, 0.000720066716894507, 0.00072568014729768, 0.000731303356587887, 0.00073697225889191, 0.000742643023841083, 0.000748343823943287, 0.00075404642848298, 0.000759780174121261, 0.000765523698646575, 0.00077126530231908, 0.000777048408053815, 0.000782846240326762, 0.000788662349805236, 0.000794492079876363, 0.000800340378191322, 0.000806188501883298, 0.000812075450085104, 0.000817970198113471, 0.000823882408440113, 0.000829825643450022, 0.000835769635159522, 0.000841744884382933, 0.000847713381517678, 0.000853706034831703, 0.000859729829244316, 0.000865763111505657, 0.000871826545335352, 0.000877892016433179, 0.000883988454006612, 0.00089008582290262, 0.000896190933417529, 0.000902328116353601, 0.000908481830265373, 0.000914666336029768, 0.00092085194773972, 0.000927061017137021, 0.000933271716348827, 0.000939512741751969, 0.000945771986152977, 0.000952045782469213, 0.000958344084210694, 0.000964657636359334, 0.000970987719483674, 0.000977312098257244, 0.000983681879006326, 0.000990060507319868, 0.000996447750367224, 0.00100286712404341, 0.00100929429754615, 0.00101575232110918, 0.00102219695691019, 0.00102867244277149, 0.00103518005926162, 0.00104169524274766, 0.00104823580477387, 0.00105477555189282, 0.00106133241206408, 0.00106791965663433, 0.00107451621443033, 0.00108114408794791, 0.00108778174035251, 0.0010944337118417, 0.00110110326204449, 0.00110779597889632, 0.00111448194365948, 0.00112121447455138, 0.0011279471218586, 0.00113470479846001, 0.00114148575812578, 0.00114826881326735, 0.00115506630390882, 0.00116188905667514, 0.00116872636135668, 0.00117559649515897, 0.00118246674537659, 0.00118936900980771, 0.00119627232197672, 0.00120319763664156, 0.00121013377793133, 0.00121709227096289, 0.00122408289462328, 0.00123107340186834, 0.00123809673823416, 0.0012451201910153, 0.00125215225853026, 0.00125922332517803, 0.00126630405429751, 0.00127340783365071, 0.00128051952924579, 0.00128766323905438, 0.00129479134920985, 0.00130196812096983, 0.00130915141198784, 0.00131636112928391, 0.00132357655093074, 0.00133081036619842, 0.00133806653320789, 0.00134532374795526, 0.00135262054391205, 0.00135991850402206, 0.00136724056210369, 0.00137458497192711, 0.00138193904422224, 0.00138932408299297, 0.00139668711926788, 0.00140409637242556, 0.00141153100412339, 0.00141896458808333, 0.00142643123399466, 0.00143390463199466, 0.00144139630720019, 0.00144890369847417, 0.00145642564166337, 0.00146398122888058, 0.00147153518628329, 0.00147912302054465, 0.00148671772330999, 0.00149433745536953, 0.00150194845627993, 0.00150960916653275, 0.00151726766489446, 0.00152494455687702, 0.00153265171684325, 0.00154036749154329, 0.00154809292871505, 0.00155584083404392, 0.00156362145207822, 0.0015714013716206, 0.0015791985206306, 0.00158702686894685, 0.00159485614858568, 0.00160270871128887, 0.00161057082004845, 0.00161845539696515, 0.00162637291941792, 0.00163429044187069, 0.00164224079344422, 0.00165019033011049, 0.00165816396474838, 0.00166614656336606, 0.00167415221221745, 0.00168218335602432, 0.00169022870250046, 0.0016982916276902, 0.00170635362155735, 0.00171444949228317, 0.00172255898360163, 0.00173069466836751, 0.00173883815295994, 0.00174699712079018, 0.00175518787000328, 0.00176337896846235, 0.00177158729638904, 0.00177981809247285, 0.00178805831819773, 0.00179633777588606, 0.00180461106356233, 0.0018129221862182, 0.00182123435661197, 0.00182956305798143, 0.00183790817391127, 0.00184627750422806, 0.00185466918628663, 0.00186307064723223, 0.00187149422708899, 0.00187991315033287, 0.00188837735913694, 0.00189684284850955, 0.0019053315045312, 0.00191384623758495, 0.00192236690782011, 0.00193091272376478, 0.00193945178762078, 0.00194802961777896, 0.00195662397891283, 0.00196523382328451, 0.00197386019863188, 0.00198250310495496, 0.00199116906151175, 0.00199982849881053, 0.00200852751731873, 0.00201724097132683, 0.00202596513554454, 0.00203471980057657, 0.00204347586259246, 0.00205225544050336, 0.0020610427018255, 0.00206987070851028, 0.00207869801670313, 0.00208754232153296, 0.00209641782566905, 0.00210529449395835, 0.00211420212872326, 0.00212310370989144, 0.00213204324245453, 0.00214099255390465, 0.00214996421709657, 0.00215895404107869, 0.00216795946471393, 0.00217696488834918, 0.00218600244261324, 0.00219506327994168, 0.00220413273200393, 0.00221322546713054, 0.00222233566455543, 0.0022314537782222, 0.00224058819003403, 0.00224973796866834, 0.00225892779417336, 0.00226811063475907, 0.00227731699123979, 0.00228655501268804, 0.00229579326696694, 0.00230504898354411, 0.00231432006694376, 0.002323615597561, 0.00233293417841196, 0.00234226160682738, 0.00235161231830716, 0.00236096419394016, 0.00237034866586328, 0.00237974780611694, 0.00238916440866888, 0.00239859567955136, 0.00240805209614336, 0.00241751503199339, 0.00242698006331921, 0.00243649212643504, 0.00244600558653474, 0.00245554908178747, 0.00246510258875787, 0.00247466377913952, 0.00248425686731935, 0.00249384297057986, 0.00250347470864654, 0.00251310877501965, 0.00252277357503772, 0.00253244047053158, 0.00254212971776724, 0.00255182757973671, 0.00256154965609312, 0.00257129594683647, 0.00258105015382171, 0.00259082810953259, 0.00260062306188047, 0.00261043338105083, 0.00262026814743876, 0.00263009499758482, 0.00263996236026287, 0.00264983647502959, 0.00265973713248968, 0.00266965152695775, 0.00267958291806281, 0.00268951430916786, 0.00269947899505496, 0.00270946556702256, 0.00271946215070784, 0.00272948271594942, 0.00273951818235219, 0.00274956319481134, 0.00275962240993977, 0.00276970048435032, 0.00277980766259134, 0.00278992555104196, 0.00280005787499249, 0.00281021511182189, 0.00282038724981248, 0.00283057661727071, 0.00284076598472893, 0.00285099516622722, 0.00286123412661254, 0.00287148682400584, 0.00288176536560059, 0.00289203529246151, 0.00290235364809632, 0.00291267107240856, 0.00292302155867219, 0.00293337996117771, 0.00294376234523952, 0.00295415264554322, 0.00296456040814519, 0.002974983304739, 0.00298542203381658, 0.00299589266069233, 0.00300637213513255, 0.00301686790771782, 0.00302738626487553, 0.00303790741600096, 0.00304844998754561, 0.00305901071988046, 0.00306960148736835, 0.00308019435033202, 0.00309080956503749, 0.00310145085677505, 0.00311208423227072, 0.00312275579199195, 0.00313343689776957, 0.0031441415194422, 0.00315486337058246, 0.00316559849306941, 0.00317636015824974, 0.0031871129758656, 0.00319790723733604, 0.0032087080180645, 0.00322185107506812, 0.00323731172829866, 0.00325278798118234, 0.00326824863441288, 0.00328381033614278, 0.003299426054582, 0.00331504992209375, 0.0033307506237179, 0.00334643642418087, 0.00336218439042568, 0.00337797845713794, 0.00339381163939834, 0.00340971443802118, 0.00342560932040215, 0.00344155891798437, 0.00345756276510656, 0.00347358197905123, 0.00348966289311647, 0.00350576778873801, 0.00352191878482699, 0.00353808561339974, 0.00355436047539115, 0.00357060483656824, 0.00358691113069654, 0.00360326399095356, 0.00361963221803308, 0.00363610917702317, 0.00365254725329578, 0.00366905517876148, 0.00368563295342028, 0.00370221864432096, 0.00371881178580225, 0.00373550574295223, 0.00375220784917474, 0.00376894045621157, 0.00378575106151402, 0.00380256935022771, 0.00381944980472326, 0.00383634539321065, 0.00385327264666557, 0.00387027696706355, 0.00388729688711464, 0.00390435568988323, 0.00392149947583675, 0.00393860507756472, 0.00395578006282449, 0.00397302489727736, 0.0039902850985527, 0.00400760769844055, 0.00402496149763465, 0.00404232274740934, 0.00405974593013525, 0.004077207762748, 0.00409472454339266, 0.00411227205768228, 0.00412983493879437, 0.00414745975285769, 0.00416513159871101, 0.00418282626196742, 0.00420057587325573, 0.00421834783628583, 0.00423618266358972, 0.00425404822453856, 0.00427195988595486, 0.00428988737985492, 0.00430785398930311, 0.00432587461546063, 0.00434394972398877, 0.00436204764991999, 0.00438018469139934, 0.0043983762152493, 0.00441659847274423, 0.00443482864648104, 0.00445315986871719, 0.00447147525846958, 0.00448986003175378, 0.0045082843862474, 0.00452674739062786, 0.00454525696113706, 0.00456376606598496, 0.00458235293626785, 0.00460097100585699, 0.00461961980909109, 0.00463832309469581, 0.00465707341209054, 0.00467583863064647, 0.00469463504850864, 0.00471350876614451, 0.00473241368308663, 0.004751349799335, 0.00477033294737339, 0.00478932308033109, 0.00480839097872376, 0.00482749007642269, 0.00484660407528281, 0.00486581213772297, 0.00488500390201807, 0.0049042422324419, 0.00492355087772012, 0.00494287488982081, 0.0049622762016952, 0.00498168589547276, 0.00500111794099212, 0.00502064358443022, 0.00504016131162643, 0.00505973352119327, 0.00507934484630823, 0.00509899435564876, 0.00511866714805365, 0.0051384181715548, 0.00515818363055587, 0.00517801241949201, 0.00519784074276686, 0.00521772261708975, 0.00523768365383148, 0.00525763537734747, 0.00527764204889536, 0.00529771018773317, 0.00531779462471604, 0.00533789442852139, 0.0053580948151648, 0.00537828775122762, 0.00539853516966105, 0.00541883567348123, 0.00543914502486587, 0.00545954750850797, 0.00547992624342442, 0.00550037529319525, 0.00552087090909481, 0.00554140424355865, 0.0055619771592319, 0.005582588724792, 0.00560321658849716, 0.00562389008700848, 0.00564464135095477, 0.00566540053114295, 0.00568621372804046, 0.00570704275742173, 0.00572792580351233, 0.00574887078255415, 0.00576981622725725, 0.00579083850607276, 0.00581187708303332, 0.00583294685930014, 0.00585407065227628, 0.00587524799630046, 0.00589644955471158, 0.00591769721359015, 0.00593897607177496, 0.00596028612926602, 0.00598168093711138, 0.00600306876003742, 0.00602450221776962, 0.00604599062353373, 0.00606750976294279, 0.00608909176662564, 0.00611066492274404, 0.00613231584429741, 0.00615400588139892, 0.00617572711780667, 0.00619745627045631, 0.00621927762404084, 0.00624111481010914, 0.00626298319548368, 0.00628492143005133, 0.00630687549710274, 0.00632889894768596, 0.00635091448202729, 0.00637298449873924, 0.00639512483030558, 0.0064172800630331, 0.00643945904448628, 0.00646172277629375, 0.00648396322503686, 0.00650628935545683, 0.00652865460142493, 0.0065510580316186, 0.00657350057736039, 0.00659597339108586, 0.00661849416792393, 0.00664106104522943, 0.00666364282369614, 0.00668626325204968, 0.0067089619114995, 0.0067316684871912, 0.00675441324710846, 0.0067772357724607, 0.00680004293099046, 0.00682292738929391, 0.00684584304690361, 0.00686878198757768, 0.00689180614426732, 0.00691482238471508, 0.00693788565695286, 0.00696101086214185, 0.00698415096849203, 0.00700733857229352, 0.00703058764338493, 0.00705385999754071, 0.00707718683406711, 0.00710053695365787, 0.00712390244007111, 0.00714736105874181, 0.0071708201430738, 0.00719433324411511, 0.00721788452938199, 0.00724149029701948, 0.00726510491222143, 0.0072887884452939, 0.00731247197836637, 0.00733623281121254, 0.00736002530902624, 0.00738383317366242, 0.00740773417055607, 0.00743161141872406, 0.00745556643232703, 0.00747956847772002, 0.00750358542427421, 0.00752768060192466, 0.00755177531391382, 0.00757591612637043, 0.00760008115321398, 0.00762433093041182, 0.00764858862385154, 0.00767292408272624, 0.00769724324345589, 0.00772164110094309, 0.00774605385959148, 0.00777051318436861, 0.00779504235833883, 0.00781958736479282, 0.00784416310489178, 0.00786881614476442, 0.00789346173405647, 0.00791816972196102, 0.00794291589409113, 0.00796769373118877, 0.00799249392002821, 0.00801737979054451, 0.00804228149354458, 0.00806724559515715, 0.00809220038354397, 0.00811720360070467, 0.00814230740070343, 0.00816738698631525, 0.00819253642112017, 0.00821772497147322, 0.00824294425547123, 0.00826817937195301, 0.00829350017011166, 0.00831884425133467, 0.00834421068429947, 0.00836964789777994, 0.00839510839432478, 0.00842062197625637, 0.00844613742083311, 0.0084717134013772, 0.00849735178053379, 0.00852300599217415, 0.00854869931936264, 0.00857446156442165, 0.00860021635890007, 0.00862601026892662, 0.00865191221237183, 0.00867779087275267, 0.00870374776422977, 0.00872972048819065, 0.00875574629753828, 0.00878178048878908, 0.00880788452923298, 0.00883401930332184, 0.0088602164760232, 0.00888641271740198, 0.00891268812119961, 0.00893897842615843, 0.00896530691534281, 0.00899165868759155, 0.00901809614151716, 0.00904454942792654, 0.00907104928046465, 0.00909758079797029, 0.00912418030202389, 0.00915076583623886, 0.00917742867022753, 0.00920410640537739, 0.00923086237162352, 0.00925761833786964, 0.00928445067256689, 0.00931129977107048, 0.00933817867189646, 0.00936510507017374, 0.00939208641648293, 0.00941911339759827, 0.00944617111235857, 0.00947324559092522, 0.00950037315487862, 0.00952753145247698, 0.00955474469810724, 0.00958199799060822, 0.00960930436849594, 0.00963663309812546, 0.00966399442404509, 0.0096913930028677, 0.00971885584294796, 0.00974635500460863, 0.00977387186139822, 0.00980144087225199, 0.00982907321304083, 0.00985672138631344, 0.00988440681248903, 0.00991211738437414, 0.00993987359106541, 0.00996770057827234, 0.00999553315341473, 0.0100234523415565, 0.0100513491779566, 0.0100793149322271, 0.0101073272526264, 0.0101353861391544, 0.0101634757593274, 0.0101916035637259, 0.0102197555825114, 0.0102479783818126, 0.010276191867888, 0.0103044984862208, 0.0103328227996826, 0.0103611834347248, 0.0103895990177989, 0.0104180388152599, 0.0104465475305915, 0.0104750478640199, 0.0105036022141576, 0.0105322059243917, 0.0105608701705933, 0.0105895483866334, 0.0106182582676411, 0.0106470081955194, 0.0106758121401072, 0.0107046468183398, 0.010733550414443, 0.0107624717056751, 0.0107914442196488, 0.0108204428106546, 0.0108494563028216, 0.0108785694465041, 0.0109076770022511, 0.0109368432313204, 0.0109660355374217, 0.010995289310813, 0.011024565435946, 0.0110538806766272, 0.0110832434147596, 0.0111126201227307, 0.0111420685425401, 0.0111715467646718, 0.0112010883167386, 0.0112306196242571, 0.0112602151930332, 0.0112898489460349, 0.0113195441663265, 0.0113492636010051, 0.0113790286704898, 0.0114088244736195, 0.0114386519417167, 0.0114685194566846, 0.0114984484389424, 0.0115284146741033, 0.0115583976730704, 0.0115884346887469, 0.0116185192018747, 0.0116486325860023, 0.0116787860170007, 0.0117089627310634, 0.0117392018437386, 0.0117694791406393, 0.0117997946217656, 0.0118301659822464, 0.0118605364114046, 0.0118909850716591, 0.0119214402511716, 0.0119519671425223, 0.0119825312867761, 0.0120131187140942, 0.0120437601581216, 0.0120744109153748, 0.012105131521821, 0.0121358660981059, 0.0121666779741645, 0.0121975066140294, 0.0122283743694425, 0.0122592644765973, 0.012290240265429, 0.0123212244361639, 0.012352260760963, 0.0123833296820521, 0.0124144442379475, 0.0124456072226167, 0.0124767692759633, 0.0125080002471805, 0.0125392721965909, 0.012570564635098, 0.0126019213348627, 0.0126333218067884, 0.012664757668972, 0.0126962056383491, 0.0127277160063386, 0.0127592897042632, 0.0127908624708652, 0.012822481803596, 0.0128541551530361, 0.0128858759999275, 0.0129176201298833, 0.0129493717104197, 0.0129812154918909, 0.0130130834877491, 0.0130449905991554, 0.0130769349634647, 0.0131089268252254, 0.0131409503519535, 0.0131730120629072, 0.0132051054388285, 0.0132372761145234, 0.0132694458588958, 0.0133016696199775, 0.0133339175954461, 0.0133662289008498, 0.0133985774591565, 0.0134309409186244, 0.0134633984416723, 0.0134958475828171, 0.0135283526033163, 0.0135608864948153, 0.0135934678837657, 0.0136260874569416, 0.013658756390214, 0.0136914607137442, 0.0137242125347257, 0.0137569736689329, 0.0137898270040751, 0.0138226561248302, 0.0138555560261011, 0.0138885015621781, 0.0139214787632227, 0.0139545099809766, 0.0139875495806336, 0.0140206580981612, 0.0140537898987532, 0.0140869915485382, 0.0141202099621296, 0.0141534581780434, 0.0141867529600859, 0.0142200877889991, 0.0142534608021379, 0.0142868869006634, 0.0143203381448984, 0.0143538424745202, 0.0143873794004321, 0.0144209610298276, 0.0144545808434486, 0.0144882248714566, 0.0145219238474965, 0.0145556451752782, 0.0145894531160593, 0.0146232461556792, 0.0146571137011051, 0.0146909998729825, 0.0147249149158597, 0.01475889980793, 0.0147929321974516, 0.0148269720375538, 0.0148610817268491, 0.0148952081799507, 0.0149293793365359, 0.0149635970592499, 0.0149978464469314, 0.015032134950161, 0.0150664616376162, 0.0151008432731032, 0.0151352547109127, 0.0151697136461735, 0.0152042033150792, 0.0152387255802751, 0.0152732925489545, 0.0153079135343432, 0.0153425810858607, 0.0153772430494428, 0.0154119720682502, 0.0154467495158315, 0.0154815819114447, 0.0155163966119289, 0.0155513063073158, 0.0155862448737025, 0.0156212085857987, 0.0156561955809593, 0.0156912580132484, 0.0157263539731503, 0.0157614704221487, 0.015796635299921, 0.0158318635076284, 0.0158671047538519, 0.0159023851156235, 0.0159377064555883, 0.0159730724990368, 0.016008485108614, 0.0160439293831587, 0.0160794276744127, 0.0161149334162474, 0.0161505080759525, 0.0161861181259155, 0.016221771016717, 0.0162574462592602, 0.0162931773811579, 0.0163289476186037, 0.0163647253066301, 0.0164005737751722, 0.0164364594966173, 0.0164723992347717, 0.0165083557367325, 0.016544358804822, 0.0165803898125887, 0.0166164878755808, 0.0166526213288307, 0.016688771545887, 0.0167249757796526, 0.0167612340301275, 0.0167975071817636, 0.0168338287621737, 0.016870180144906, 0.0169065874069929, 0.0169430170208216, 0.0169794913381338, 0.0170160364359617, 0.0170525964349508, 0.0170891750603914, 0.0171258132904768, 0.0171625055372715, 0.0171992387622595, 0.0172359924763441, 0.017272787168622, 0.0173096507787704, 0.0173464827239513, 0.017383424565196, 0.0174203813076019, 0.0174573846161366, 0.0174944270402193, 0.0175314918160439, 0.0175686255097389, 0.0176057610660791, 0.0176429748535156, 0.0176802016794682, 0.0177174936980009, 0.0177548136562109, 0.0177921503782272, 0.017829542979598, 0.0178669802844524, 0.0179044492542744, 0.0179419554769993, 0.0179795417934656, 0.0180171336978674, 0.0180547591298819, 0.0180924199521542, 0.0181301534175873, 0.0181678924709558, 0.0182056948542595, 0.0182435289025307, 0.0182814169675112, 0.0183193050324917, 0.0183572843670845, 0.0183952562510967, 0.0184332858771086, 0.018471360206604, 0.0185094699263573, 0.0185476299375296, 0.0185858123004436, 0.0186240412294865, 0.0186623241752386, 0.0187006313353777, 0.0187389925122261, 0.0187773853540421, 0.0188158061355352, 0.0188542921096087, 0.0188927762210369, 0.0189313236624002, 0.0189699269831181, 0.019008556380868, 0.0190472360700369, 0.0190859381109476, 0.0191246960312128, 0.019163466989994, 0.0192022938281298, 0.0192411728203297, 0.0192800760269165, 0.0193190202116966, 0.0193580165505409, 0.0193970296531916, 0.0194361042231321, 0.0194751936942339, 0.0195143613964319, 0.0195535533130169, 0.0195927731692791, 0.0196320358663797, 0.0196713339537382, 0.0197106823325157, 0.0197500567883253, 0.0197894964367151, 0.0198289677500725, 0.0198684614151716, 0.0199080053716898, 0.0199475940316916, 0.0199872143566608, 0.0200268756598234, 0.0200665853917599, 0.020106352865696, 0.0201461166143417, 0.0201859306544065, 0.0202257856726646, 0.0202656928449869, 0.0203056409955025, 0.020345626398921, 0.0203856509178877, 0.0204257126897573, 0.0204658042639494, 0.0205059479922056, 0.0205461401492357, 0.0205863378942013, 0.0206266064196825, 0.020666915923357, 0.0207072775810957, 0.0207476262003183, 0.0207880344241858, 0.0208285115659237, 0.020869005471468, 0.0209095478057861, 0.0209501255303621, 0.020990751683712, 0.0210314020514488, 0.0210720971226692, 0.0211128331720829, 0.0211536213755608, 0.0211944356560707, 0.0212352927774191, 0.0212761983275414, 0.0213171187788248, 0.021358085796237, 0.0213991086930037, 0.0214401837438345, 0.0214812587946653, 0.0215224139392376, 0.0215635672211647, 0.0216047894209623, 0.0216460525989532, 0.021687338128686, 0.0217286925762892, 0.0217700693756342, 0.0218114666640759, 0.0218529365956783, 0.021894408389926, 0.0219359416514635, 0.0219775140285492, 0.0220191329717636, 0.0220608077943325, 0.0221024882048368, 0.0221442058682442, 0.0221859719604254, 0.0222278013825417, 0.0222696624696255, 0.0223115365952253, 0.0223534815013409, 0.0223954562097788, 0.0224374402314425, 0.0224795080721378, 0.0225215945392847, 0.0225637406110764, 0.0226059015840292, 0.0226481091231108, 0.022690374404192, 0.0227326434105635, 0.0227749682962894, 0.0228173341602087, 0.0228597745299339, 0.0229021925479174, 0.0229447018355131, 0.0229872148483992, 0.0230297781527042, 0.0230723842978477, 0.0231150407344103, 0.0231577474623919, 0.023200461640954, 0.0232432205229998, 0.0232860185205936, 0.0233288761228323, 0.0233717765659094, 0.0234146900475025, 0.0234576445072889, 0.0235006529837847, 0.023543706163764, 0.0235868152230978, 0.0236299149692059, 0.023673078045249, 0.0237162802368402, 0.0237595364451408, 0.0238028299063444, 0.023846123367548, 0.023889496922493, 0.0239329002797604, 0.0239763576537371, 0.0240198206156492, 0.0240633562207222, 0.0241069253534079, 0.0241505280137062, 0.0241941418498755, 0.024237846955657, 0.0242815688252449, 0.0243253279477358, 0.02436912804842, 0.024412963539362, 0.024456849321723, 0.0245007555931807, 0.0245447345077991, 0.0245887339115143, 0.0246327575296164, 0.024676850065589, 0.0247209835797548, 0.0247651170939207, 0.0248093269765377, 0.0248535517603159, 0.0248978473246098, 0.0249421652406454, 0.0249865390360355, 0.0250309258699417, 0.0250753369182348, 0.0251198206096888, 0.0251643396914005, 0.025208905339241, 0.0252535045146942, 0.0252981428056955, 0.0253428015857935, 0.0253875330090523, 0.0254322998225689, 0.0254770908504725, 0.0255219154059887, 0.0255668144673109, 0.0256117302924395, 0.0256566759198904, 0.025701655074954, 0.025746701285243, 0.0257917642593384, 0.025836868211627, 0.0258820559829473, 0.0259272418916225, 0.0259724855422974, 0.0260177347809076, 0.0260630622506142, 0.0261084120720625, 0.0261538084596395, 0.0261992439627647, 0.0262447185814381, 0.0262902025133371, 0.0263357684016228, 0.0263813696801662, 0.0264269970357418, 0.0264726672321558, 0.026518365368247, 0.0265641417354345, 0.0266099106520414, 0.0266557410359383, 0.0267016142606735, 0.0267475284636021, 0.0267934836447239, 0.0268394630402327, 0.0268855113536119, 0.0269315596669912, 0.0269776545464993, 0.0270238127559423, 0.0270700007677078, 0.0271162427961826, 0.0271625146269798, 0.0272087976336479, 0.0272551625967026, 0.0273015443235636, 0.0273479726165533, 0.0273944344371557, 0.0274409390985966, 0.027487501502037, 0.0275340918451548, 0.0275807082653046, 0.0276273600757122, 0.0276740752160549, 0.0277208238840103, 0.027767613530159, 0.0278144497424364, 0.027861287817359, 0.0279081910848618, 0.0279551539570093, 0.0280021168291569, 0.0280491523444653, 0.0280962232500315, 0.028143335133791, 0.0281904470175505, 0.0282376427203417, 0.0282848794013262, 0.0283321365714073, 0.0283794403076172, 0.0284267794340849, 0.028474161401391, 0.0285215750336647, 0.0285690426826477, 0.0286165345460176, 0.0286640785634518, 0.0287116579711437, 0.0287592951208353, 0.028806934133172, 0.0288546420633793, 0.0289023742079735, 0.0289501789957285, 0.0289980005472898, 0.0290458500385284, 0.029093760997057, 0.0291416700929403, 0.0291896723210812, 0.0292376764118671, 0.0292857438325882, 0.0293338485062122, 0.0293819736689329, 0.0294301565736532, 0.0294783692806959, 0.0295266285538673, 0.0295749250799417, 0.029623256996274, 0.0296716466546059, 0.0297200698405504, 0.0297685004770756, 0.0298169981688261, 0.0298655293881893, 0.0299141090363264, 0.0299627147614956, 0.0300113949924707, 0.0300600957125425, 0.0301088206470013, 0.0301575921475887, 0.0302064102143049, 0.0302552487701178, 0.030304154381156, 0.030353095382452, 0.0304020848125219, 0.0304510816931725, 0.0305001176893711, 0.0305492226034403, 0.0305983349680901, 0.0306475255638361, 0.0306967385113239, 0.0307459998875856, 0.030795281752944, 0.0308446045964956, 0.0308939795941114, 0.0309434030205011, 0.0309928487986326, 0.031042343005538, 0.0310918744653463, 0.0311414375901222, 0.0311910398304462, 0.0312406793236732, 0.0312903895974159, 0.0313401147723198, 0.0313898846507072, 0.0314396731555462, 0.0314895398914814, 0.0315394289791584, 0.0315893515944481, 0.0316393114626408, 0.0316893383860588, 0.0317393690347672, 0.0317894741892815, 0.0318395793437958, 0.0318897478282452, 0.0319399535655975, 0.0319902002811432, 0.032040499150753, 0.0320908315479755, 0.0321411900222301, 0.0321915820240974, 0.0322420559823513, 0.0322925262153149, 0.0323430672287941, 0.0323936119675636, 0.0324442125856876, 0.0324948504567146, 0.0325455442070961, 0.0325962714850903, 0.0326470248401165, 0.0326978303492069, 0.0327486880123615, 0.0327995792031288, 0.0328504927456379, 0.0329014398157597, 0.0329524390399456, 0.0330035053193569, 0.0330545604228973, 0.0331057012081146, 0.0331568568944931, 0.0332080498337746, 0.0332592874765396, 0.0333105884492397, 0.0333619192242622, 0.0334132686257362, 0.0334646590054035, 0.0335160940885544, 0.0335675776004791, 0.0336191020905972, 0.0336706601083279, 0.0337222628295422, 0.0337738990783691, 0.0338255763053894, 0.0338773019611835, 0.0339290536940098, 0.0339808538556099, 0.0340326875448227, 0.03408457711339, 0.0341364964842796, 0.034188449382782, 0.0342404320836067, 0.0342924706637859, 0.0343445613980293, 0.0343966595828533, 0.0344488397240639, 0.0345010198652744, 0.0345532707870007, 0.0346055254340172, 0.0346578545868397, 0.0347102135419846, 0.0347626060247421, 0.0348150283098221, 0.0348674915730953, 0.0349200330674648, 0.0349725596606731, 0.0350251719355583, 0.0350777916610241, 0.0351304672658443, 0.0351831763982773, 0.0352359600365162, 0.0352887324988842, 0.0353415682911873, 0.0353944301605225, 0.0354473665356636, 0.035500306636095, 0.0355533100664616, 0.035606324672699, 0.0356593802571297, 0.0357124954462051, 0.0357656441628933, 0.0358188487589359, 0.0358720719814301, 0.0359253510832787, 0.035978652536869, 0.0360320098698139, 0.0360853970050812, 0.0361388325691223, 0.0361922942101955, 0.0362458229064941, 0.0362993627786636, 0.0363529622554779, 0.0364065654575825, 0.0364602506160736, 0.0365139432251453, 0.0365676917135715, 0.0366214960813522, 0.0366753153502941, 0.0367291867733002, 0.0367830693721771, 0.03683702647686, 0.0368910133838654, 0.0369450263679028, 0.0369991064071655, 0.0370532162487507, 0.037107340991497, 0.0371615327894688, 0.0372157655656338, 0.0372700393199921, 0.0373243391513824, 0.0373786725103855, 0.0374330841004848, 0.037487480789423, 0.0375419519841671, 0.0375964567065239, 0.0376509949564934, 0.0377055965363979, 0.0377601943910122, 0.0378148630261421, 0.0378695838153362, 0.03792430087924, 0.0379790887236595, 0.038033913820982, 0.0380887724459171, 0.0381436832249165, 0.0381986163556576, 0.0382536016404629, 0.0383086167275906, 0.0383636727929115, 0.0384187735617161, 0.0384739153087139, 0.0385339148342609, 0.0385987535119057, 0.0386636257171631, 0.038728516548872, 0.0387934371829033, 0.0388584025204182, 0.0389234013855457, 0.0389884188771248, 0.0390534736216068, 0.0391185879707336, 0.0391837172210217, 0.0392488725483418, 0.0393140688538551, 0.0393792949616909, 0.039444588124752, 0.0395098589360714, 0.0395752117037773, 0.0396405793726444, 0.0397059619426727, 0.039771419018507, 0.0398368835449219, 0.0399024114012718, 0.0399679280817509, 0.0400335155427456, 0.0400991253554821, 0.0401647426187992, 0.0402304232120514, 0.0402961373329163, 0.0403618887066841, 0.0404276698827744, 0.0404934585094452, 0.0405593141913414, 0.0406252071261406, 0.0406911075115204, 0.0407570526003838, 0.0408230386674404, 0.0408890657126904, 0.0409551076591015, 0.0410211905837059, 0.0410873219370842, 0.0411534607410431, 0.041219636797905, 0.0412858538329601, 0.0413521230220795, 0.0414183922111988, 0.0414847396314144, 0.04155108705163, 0.0416174717247486, 0.0416839085519314, 0.041750356554985, 0.041816845536232, 0.0418833754956722, 0.0419499352574348, 0.0420165471732616, 0.0420831777155399, 0.0421498268842697, 0.0422165021300316, 0.0422832556068897, 0.0423500165343285, 0.0424168109893799, 0.0424836501479149, 0.0425505116581917, 0.0426174029707909, 0.0426843427121639, 0.0427513159811497, 0.0428183376789093, 0.0428853556513786, 0.0429524295032024, 0.0430195443332195, 0.0430866740643978, 0.0431538335978985, 0.0432210452854633, 0.0432882979512215, 0.0433555692434311, 0.0434228740632534, 0.043490219861269, 0.043557595461607, 0.0436250083148479, 0.0436924509704113, 0.0437599383294582, 0.0438274666666985, 0.0438950024545193, 0.0439625754952431, 0.0440301969647408, 0.0440978556871414, 0.0441655144095421, 0.0442332439124584, 0.0443009957671165, 0.0443687699735165, 0.0444366037845612, 0.0445044599473476, 0.0445723533630371, 0.0446402728557587, 0.0447082109749317, 0.0447762049734592, 0.0448442324995995, 0.0449122898280621, 0.0449803993105888, 0.0450485162436962, 0.0451166816055775, 0.0451848544180393, 0.0452531091868877, 0.0453213639557362, 0.0453896559774876, 0.0454580001533031, 0.045526348054409, 0.0455947481095791, 0.0456631854176521, 0.0457316488027573, 0.0458001717925072, 0.0458686873316765, 0.0459372512996197, 0.0460058785974979, 0.0460745058953762, 0.0461431629955769, 0.0462118536233902, 0.0462806187570095, 0.0463493876159191, 0.0464181825518608, 0.0464870370924473, 0.0465558990836143, 0.0466248169541359, 0.0466937571763992, 0.0467627383768559, 0.0468317605555058, 0.0469007901847363, 0.0469698719680309, 0.047038983553648, 0.0471081435680389, 0.0471773073077202, 0.0472465269267559, 0.0473157912492752, 0.047385074198246, 0.0474543906748295, 0.0475237295031548, 0.0475931316614151, 0.0476625375449657, 0.0477319955825806, 0.0478014834225178, 0.047871008515358, 0.0479405671358109, 0.0480101592838764, 0.0480797775089741, 0.0481494478881359, 0.048219121992588, 0.0482888631522655, 0.0483586266636848, 0.0484283976256847, 0.0484982468187809, 0.0485680997371674, 0.0486379936337471, 0.0487079322338104, 0.0487778857350349, 0.0488479062914848, 0.0489179268479347, 0.0489879883825779, 0.0490580871701241, 0.0491282306611538, 0.0491983778774738, 0.0492685846984386, 0.0493388473987579, 0.0494091138243675, 0.0494793951511383, 0.049549762159586, 0.0496201254427433, 0.0496905334293842, 0.0497609712183475, 0.0498314537107944, 0.0499019734561443, 0.0499725043773651, 0.050043098628521, 0.0501136779785156, 0.0501843467354774, 0.0502550043165684, 0.0503257177770138, 0.0503964833915234, 0.0504672713577747, 0.0505380779504776, 0.050608929246664, 0.0506798066198826, 0.0507507286965847, 0.0508216731250286, 0.0508926659822464, 0.0509637035429478, 0.0510347299277782, 0.0511058196425438, 0.0511769391596317, 0.0512481145560741, 0.0513192787766457, 0.0513905249536037, 0.0514617785811424, 0.0515330545604229, 0.0516043975949287, 0.0516757629811764, 0.0517471469938755, 0.0518185868859291, 0.0518900528550148, 0.0519615560770035, 0.0520330704748631, 0.0521046258509159, 0.0521762259304523, 0.0522478669881821, 0.0523195341229439, 0.0523912273347378, 0.0524629801511765, 0.0525347329676151, 0.0526065342128277, 0.0526783764362335, 0.052750252187252, 0.0528221540153027, 0.0528940930962563, 0.0529660657048225, 0.0530380867421627, 0.0531101152300835, 0.0531821846961975, 0.0532542951405048, 0.0533264502882957, 0.0533986166119576, 0.0534708239138126, 0.0535430833697319, 0.0536153577268124, 0.0536876767873764, 0.0537600219249725, 0.0538324154913425, 0.0539048165082932, 0.0539772734045982, 0.0540497601032257, 0.0541222840547562, 0.0541948080062866, 0.0542673915624619, 0.0543400384485722, 0.0544126927852631, 0.0544853582978249, 0.0545580796897411, 0.0546308569610119, 0.0547036342322826, 0.0547764711081982, 0.0548493303358555, 0.0549222305417061, 0.0549951456487179, 0.0550681166350842, 0.0551411062479019, 0.0552141219377518, 0.0552871786057949, 0.0553602762520313, 0.055433414876461, 0.0555065833032131, 0.0555797778069973, 0.0556530132889748, 0.0557262822985649, 0.0557995773851871, 0.0558729134500027, 0.0559462979435921, 0.0560196898877621, 0.0560931228101254, 0.0561666004359722, 0.0562401115894318, 0.0563136339187622, 0.0563872009515762, 0.0564608201384544, 0.056534469127655, 0.0566081255674362, 0.0566818527877331, 0.0567555949091911, 0.0568293780088425, 0.056903176009655, 0.056977029889822, 0.057050921022892, 0.0571248196065426, 0.0571987666189671, 0.0572727471590042, 0.0573467761278152, 0.0574208162724972, 0.0574948936700821, 0.0575690157711506, 0.0576431676745415, 0.0577173456549644, 0.0577915720641613, 0.0578658431768417, 0.0579401254653931, 0.0580144450068474, 0.0580887943506241, 0.0581631921231747, 0.0582376159727573, 0.0583120845258236, 0.0583865605294704, 0.0584610924124718, 0.0585356429219246, 0.0586102418601513, 0.0586848668754101, 0.058759544044733, 0.0588342323899269, 0.0589089654386044, 0.0589837320148945, 0.0590585246682167, 0.0591333582997322, 0.0592082366347313, 0.0592831335961819, 0.0593580678105354, 0.059433039277792, 0.0595080479979515, 0.0595830678939819, 0.0596581399440765, 0.0597332492470741, 0.0598083958029747, 0.0598835572600365, 0.0599587559700012, 0.0600340142846107, 0.0601093024015427, 0.0601845942437649, 0.0602599382400513, 0.0603353232145309, 0.0604107230901718, 0.0604861676692963, 0.060561653226614, 0.0606371685862541, 0.0607127286493778, 0.0607882887125015, 0.0608639121055603, 0.0609395690262318, 0.0610152445733547, 0.0610909685492516, 0.0611667260527611, 0.0612425170838833, 0.0613183304667473, 0.0613941811025143, 0.0614700838923454, 0.0615459904074669, 0.0616219490766525, 0.0616979263722897, 0.0617739595472813, 0.0618500150740147, 0.0619261153042316, 0.0620022378861904, 0.0620784088969231, 0.0621545910835266, 0.0622308291494846, 0.0623070895671844, 0.0623833723366261, 0.0624597109854221, 0.0625360906124115, 0.0626124814152718, 0.062688909471035, 0.0627653822302818, 0.0628418773412704, 0.062918409705162, 0.062994971871376, 0.0630715861916542, 0.0631482228636742, 0.0632248967885971, 0.0633015930652618, 0.0633783414959908, 0.0634551197290421, 0.0635319203138351, 0.0636087581515312, 0.0636856406927109, 0.0637625455856323, 0.0638394951820374, 0.063916452229023, 0.0639934837818146, 0.064070537686348, 0.0641475990414619, 0.0642247125506401, 0.0643018707633018, 0.0643790438771248, 0.0644562542438507, 0.0645335167646408, 0.0646108016371727, 0.064688116312027, 0.0647654682397842, 0.0648428648710251, 0.0649202764034271, 0.0649977475404739, 0.0650752037763596, 0.0651527345180511, 0.0652302876114845, 0.0653078854084015, 0.0653855055570602, 0.0654631704092026, 0.0655408576130867, 0.0656185895204544, 0.0656963512301445, 0.0657741352915764, 0.0658519715070724, 0.0659298449754715, 0.0660077407956123, 0.0660856664180756, 0.0661636218428612, 0.066241629421711, 0.0663196593523026, 0.0663977190852165, 0.0664758309721947, 0.0665539726614952, 0.0666321367025375, 0.0667103305459023, 0.0667885765433311, 0.066866859793663, 0.0669451430439949, 0.0670234933495522, 0.0671018809080124, 0.0671802908182144, 0.0672587156295776, 0.0673371851444244, 0.0674156993627548, 0.0674942508339882, 0.0675728023052216, 0.0676514282822609, 0.067730076611042, 0.0678087547421455, 0.067887470126152, 0.0679662227630615, 0.0680450201034546, 0.0681238174438477, 0.0682026743888855, 0.0682815611362457, 0.0683604702353477, 0.0684394091367722, 0.0685184001922607, 0.0685974285006523, 0.0686764866113663, 0.0687555745244026, 0.0688346847891808, 0.0689138472080231, 0.0689930394291878, 0.0690722614526749, 0.0691515356302261, 0.0692308098077774, 0.0693101435899734, 0.0693895071744919, 0.0694689154624939, 0.0695483312010765, 0.0696277767419815, 0.0697072818875313, 0.0697868168354034, 0.0698663741350174, 0.0699459761381149, 0.0700256153941154, 0.070105291903019, 0.0701849758625031, 0.0702647119760513, 0.0703444927930832, 0.0704242885112762, 0.0705041289329529, 0.0705840066075325, 0.0706639215350151, 0.0707438290119171, 0.0708238035440445, 0.0709038227796555, 0.0709838718175888, 0.0710639432072639, 0.0711440518498421, 0.0712242051959038, 0.0713043734431267, 0.0713845938444138, 0.0714648365974426, 0.0715451240539551, 0.0716254264116287, 0.0717057809233665, 0.0717861652374268, 0.0718665719032288, 0.0719470083713531, 0.0720274895429611, 0.0721080228686333, 0.0721885859966278, 0.0722691565752029, 0.0723497867584229, 0.0724304392933846, 0.0725111216306686, 0.0725918561220169, 0.072672612965107, 0.0727534070611, 0.0728342235088348, 0.0729150846600533, 0.0729959830641747, 0.0730768963694572, 0.0731578469276428, 0.0732388496398926, 0.0733198896050453, 0.0734009295701981, 0.0734820440411568, 0.0735631659626961, 0.0736443474888802, 0.0737255364656448, 0.0738067775964737, 0.0738880410790443, 0.073969341814518, 0.0740506798028946, 0.0741320475935936, 0.074213445186615, 0.0742948949337006, 0.0743763521313667, 0.0744578614830971, 0.0745394080877304, 0.0746209770441055, 0.074702575802803, 0.0747842267155647, 0.0748658925294876, 0.0749476030468941, 0.0750293508172035, 0.0751111432909966, 0.0751929432153702, 0.075274795293808, 0.0753566771745682, 0.0754385739564896, 0.0755205228924751, 0.0756025090813637, 0.0756845250725746, 0.0757665932178497, 0.0758486539125443, 0.0759307742118835, 0.0760129392147064, 0.0760951116681099, 0.0761773437261581, 0.0762596055865288, 0.0763418897986412, 0.076424203813076, 0.0765065625309944, 0.0765889510512352, 0.076671376824379, 0.0767538249492645, 0.0768363177776337, 0.076918862760067, 0.0770014077425003, 0.0770840048789978, 0.0771666467189789, 0.0772493109107018, 0.0773319974541664, 0.0774147361516953, 0.0774975046515465, 0.0775802880525589, 0.0776631310582161, 0.0777460113167763, 0.0778288915753365, 0.077911838889122, 0.0779947862029076, 0.0780778080224991, 0.0781608372926712, 0.0782439038157463, 0.078327015042305, 0.0784101635217667, 0.0784933343529701, 0.078576534986496, 0.0786597803235054, 0.0787430554628372, 0.078826367855072, 0.0789097175002098, 0.0789930820465088, 0.0790764987468719, 0.0791599377989769, 0.0792434215545654, 0.0793269351124763, 0.0794104933738708, 0.0794940739870071, 0.079577699303627, 0.0796613395214081, 0.0797450095415115, 0.0798287466168404, 0.0799124911427498, 0.0799962878227234, 0.0800801068544388, 0.0801639556884766, 0.0802478417754173, 0.0803317576646805, 0.0804157108068466, 0.0804997086524963, 0.0805837363004684, 0.0806677788496017, 0.0807518810033798, 0.0808360204100609, 0.0809201896190643, 0.0810043662786484, 0.0810885950922966, 0.0811728686094284, 0.0812571570277214, 0.0813414826989174, 0.0814258456230164, 0.0815102532505989, 0.0815946981310844, 0.0816791504621506, 0.0817636549472809, 0.0818481966853142, 0.0819327607750893, 0.0820173546671867, 0.082102008163929, 0.0821866765618324, 0.0822713822126389, 0.0823561176657677, 0.0824408978223801, 0.0825257077813148, 0.0826105400919914, 0.082695409655571, 0.0827803164720535, 0.0828652679920197, 0.0829502418637276, 0.0830352529883385, 0.0831203162670135, 0.0832053795456886, 0.0832905024290085, 0.0833756402134895, 0.0834608227014542, 0.0835460647940636, 0.083631306886673, 0.0837165862321854, 0.0838018879294395, 0.0838872417807579, 0.0839726328849792, 0.0840580612421036, 0.0841435045003891, 0.0842289999127388, 0.0843145251274109, 0.084400087594986, 0.0844856649637222, 0.0845713019371033, 0.0846569612622261, 0.0847426503896713, 0.0848283767700195, 0.0849141553044319, 0.0849999487400055, 0.0850857421755791, 0.0851716101169586, 0.0852575153112411, 0.0853434577584267, 0.0854294076561928, 0.0855154097080231, 0.0856014564633369, 0.085687518119812, 0.0857736170291901, 0.0858597457408905, 0.0859459340572357, 0.0860321298241615, 0.0861183702945709, 0.0862046405673027, 0.0862909331917763, 0.0863772630691528, 0.0864636451005936, 0.0865500569343567, 0.0866364985704422, 0.0867229849100113, 0.086809478700161, 0.0868960320949554, 0.0869826078414917, 0.0870692357420921, 0.0871558785438538, 0.0872425436973572, 0.0873292535543442, 0.087416023015976, 0.0875027999281883, 0.0875895991921425, 0.0876764431595802, 0.0877633467316628, 0.0878502577543259, 0.0879371911287308, 0.0880241915583611, 0.0881112217903137, 0.0881982892751694, 0.0882853642106056, 0.0883724987506866, 0.0884596556425095, 0.0885468274354935, 0.0886340588331223, 0.088721327483654, 0.0888086259365082, 0.0888959169387817, 0.0889832824468613, 0.0890706926584244, 0.0891581326723099, 0.089245580136776, 0.0893330723047256, 0.0894206240773201, 0.089508168399334, 0.0895957872271538, 0.0896834135055542, 0.0897710844874382, 0.089858777821064, 0.089946523308754, 0.0900342911481857, 0.0901220887899399, 0.0902099162340164, 0.0902977958321571, 0.090385690331459, 0.0904736518859863, 0.0905616134405136, 0.0906496345996857, 0.0907376781105995, 0.0908257365226746, 0.0909138545393944, 0.0910020023584366, 0.0910901874303818, 0.0911783799529076, 0.0912666395306587, 0.0913549289107323, 0.0914432182908058, 0.0915315672755241, 0.0916199535131454, 0.0917083844542503, 0.0917968079447746, 0.0918853059411049, 0.0919738337397575, 0.0920623987913132, 0.0921509638428688, 0.0922395810484886, 0.0923282504081726, 0.0924169421195984, 0.092505656182766, 0.0925944149494171, 0.0926831960678101, 0.0927720293402672, 0.0928608700633049, 0.092949777841568, 0.0930387079715729, 0.0931276604533195, 0.0932166576385498, 0.093305692076683, 0.0933947488665581, 0.0934838503599167, 0.0935729816555977, 0.0936621502041817, 0.093751348555088, 0.0938405841588974, 0.0939298570156097, 0.0940191522240639, 0.0941084772348404, 0.0941978543996811, 0.0942872539162636, 0.0943766981363297, 0.0944661647081375, 0.094555675983429, 0.0946452245116234, 0.0947347804903984, 0.0948243960738182, 0.0949140414595604, 0.095003716647625, 0.0950934216380119, 0.0951831638813019, 0.0952729359269142, 0.0953627601265907, 0.0954525843262672, 0.0955424681305885, 0.095632404088974, 0.0957223251461983, 0.0958123281598091, 0.0959023386240005, 0.0959923937916756, 0.0960824713110924, 0.0961725935339928, 0.0962627530097961, 0.0963529348373413, 0.0964431464672089, 0.0965334177017212, 0.0966236963868141, 0.0967140272259712, 0.0968043580651283, 0.0968947634100914, 0.0969851985573769, 0.0970756486058235, 0.0971661433577538, 0.0972566679120064, 0.0973472371697426, 0.09743782132864, 0.0975284650921822, 0.0976191163063049, 0.0977098271250725, 0.0978005602955818, 0.0978913083672523, 0.0979821085929871, 0.0980729311704636, 0.0981637984514236, 0.0982547104358673, 0.098345659673214, 0.0984366238117218, 0.098527617752552, 0.0986186563968658, 0.098709724843502, 0.0988008379936218, 0.098891980946064, 0.0989831611514091, 0.0990743562579155, 0.0991655960679054, 0.0992568805813789, 0.0993481874465942, 0.0994395241141319, 0.0995309054851532, 0.0996223315596581, 0.0997137576341629, 0.0998052433133125, 0.0998967662453651, 0.0999883264303207, 0.100079886615276, 0.100171513855457, 0.100263170897961, 0.100354850292206, 0.100446566939354, 0.100538305938244, 0.100630104541779, 0.100721932947636, 0.100813761353493, 0.100905664265156, 0.10099758207798, 0.101089537143707, 0.101181529462337, 0.101273559033871, 0.101365625858307, 0.101457715034485, 0.101549841463566, 0.10164201259613, 0.101734191179276, 0.101826414465904, 0.101918675005436, 0.102010980248451, 0.102103307843208, 0.102195680141449, 0.102288067340851, 0.102380506694317, 0.102472990751266, 0.102565482258797, 0.10265801846981, 0.102750584483147, 0.102843195199966, 0.102935835719109, 0.103028513491154, 0.10312120616436, 0.103213936090469, 0.103306725621223, 0.103399515151978, 0.103492364287376, 0.103585243225098, 0.103678151965141, 0.103771090507507, 0.103864073753357, 0.103957086801529, 0.104050144553185, 0.104143232107162, 0.104236327111721, 0.104329489171505, 0.104422673583031, 0.104515872895718, 0.104609131813049, 0.104702398180962, 0.104795731604099, 0.104889079928398, 0.104982472956181, 0.105075888335705, 0.105169340968132, 0.105262838304043, 0.105356365442276, 0.10544990748167, 0.10554351657629, 0.105637140572071, 0.105730786919594, 0.105824485421181, 0.105918206274509, 0.106011971831322, 0.106105767190456, 0.106199599802494, 0.106293447315693, 0.106387369334698, 0.106481291353703, 0.10657525062561, 0.106669239699841, 0.106763310730457, 0.106857359409332, 0.106951460242271, 0.107045605778694, 0.107139773666859, 0.107233949005604, 0.107328198850155, 0.107422471046448, 0.107516758143902, 0.107611112296581, 0.107705481350422, 0.107799902558327, 0.107894346117973, 0.107988819479942, 0.108083337545395, 0.108177870512009, 0.108272463083267, 0.108367063105106, 0.10846172273159, 0.108556397259235, 0.108651101589203, 0.108745843172073, 0.108840629458427, 0.108935452997684, 0.109030313789845, 0.109125189483166, 0.10922010242939, 0.109315052628517, 0.109410040080547, 0.109505072236061, 0.109600119292736, 0.109695211052895, 0.109790332615376, 0.109885483980179, 0.109980665147305, 0.110075905919075, 0.110171161592007, 0.110266447067261, 0.110361777245998, 0.110457144677639, 0.110552549362183, 0.110647968947887, 0.110743433237076, 0.110838942229748, 0.110934473574162, 0.111030034720898, 0.111125633120537, 0.111221268773079, 0.111316941678524, 0.111412614583969, 0.11150835454464, 0.111604124307632, 0.111699931323528, 0.111795768141747, 0.111891634762287, 0.111987560987473, 0.112083494663239, 0.112179465591908, 0.11227548122406, 0.112371526658535, 0.112467601895332, 0.112563699483871, 0.112659849226475, 0.11275602132082, 0.112852238118649, 0.112948462367058, 0.113044753670692, 0.11314108222723, 0.113237433135509, 0.113333806395531, 0.113430239260197, 0.113526672124863, 0.113623157143593, 0.113719686865807, 0.113816231489182, 0.11391282081604, 0.114009454846382, 0.114106088876724, 0.114202782511711, 0.11429950594902, 0.114396251738071, 0.114493049681187, 0.114589869976044, 0.114686749875546, 0.114783637225628, 0.114880561828613, 0.114977523684502, 0.115074522793293, 0.115171551704407, 0.115268610417843, 0.115365698933601, 0.115462839603424, 0.115560002624989, 0.115657187998295, 0.115754425525665, 0.115851707756519, 0.115948997437954, 0.116046339273453, 0.116143710911274, 0.116241119801998, 0.116338551044464, 0.116436026990414, 0.116533525288105, 0.116631075739861, 0.116728648543358, 0.116826243698597, 0.11692388355732, 0.117021575570107, 0.117119282484055, 0.117217019200325, 0.117314793169498, 0.117412611842155, 0.117510460317135, 0.117608338594437, 0.117706261575222, 0.117804206907749, 0.117902189493179, 0.118000201880932, 0.118098258972168, 0.118196345865726, 0.118294470012188, 0.11839260160923, 0.118490792810917, 0.118589013814926, 0.118687272071838, 0.118785560131073, 0.118883885443211, 0.118982240557671, 0.119080640375614, 0.119179047644138, 0.119277521967888, 0.119376011192799, 0.119474545121193, 0.119573101401329, 0.119671702384949, 0.11977032572031, 0.119868993759155, 0.119967676699162, 0.120066411793232, 0.120165176689625, 0.120263978838921, 0.120366595685482, 0.120473079383373, 0.120579563081264, 0.120686024427414, 0.120792470872402, 0.120898939669132, 0.12100537866354, 0.121111817657948, 0.121218256652355, 0.12132465839386, 0.121431082487106, 0.121537506580353, 0.121643908321857, 0.121750317513943, 0.121856711804867, 0.121963106095791, 0.122069478034973, 0.122175857424736, 0.122282236814499, 0.122388608753681, 0.122494958341122, 0.122601307928562, 0.122707657516003, 0.122813992202282, 0.122920326888561, 0.123026646673679, 0.123132966458797, 0.123239301145077, 0.123345598578453, 0.123451896011829, 0.123558200895786, 0.123664490878582, 0.123770780861378, 0.123877055943012, 0.123983323574066, 0.12408959120512, 0.124195851385593, 0.124302111566067, 0.124408334493637, 0.124514579772949, 0.12462080270052, 0.124727040529251, 0.124833270907402, 0.124939478933811, 0.12504568696022, 0.125151887536049, 0.125258088111877, 0.125364288687706, 0.125470489263535, 0.12557664513588, 0.125682815909386, 0.125788986682892, 0.125895127654076, 0.126001298427582, 0.126107439398766, 0.126213580369949, 0.126319706439972, 0.126425847411156, 0.126531973481178, 0.126638099551201, 0.126744195818901, 0.126850292086601, 0.126956403255463, 0.127062484622002, 0.127168580889702, 0.127274662256241, 0.127380713820457, 0.127486780285835, 0.127592846751213, 0.12769889831543, 0.127804949879646, 0.127910986542702, 0.128017038106918, 0.128123044967651, 0.128229081630707, 0.12833508849144, 0.128441110253334, 0.128547102212906, 0.128653109073639, 0.128759101033211, 0.128865092992783, 0.128971055150032, 0.129077032208443, 0.129182994365692, 0.129288956522942, 0.12939490377903, 0.129500865936279, 0.129606813192368, 0.129712745547295, 0.12981866300106, 0.129924595355988, 0.130030512809753, 0.130136430263519, 0.130242332816124, 0.130348235368729, 0.130454123020172, 0.130560010671616, 0.130665868520737, 0.13077175617218, 0.130877614021301, 0.130983486771584, 0.131089344620705, 0.131195187568665, 0.131301030516624, 0.131406873464584, 0.131512686610222, 0.131618514657021, 0.131724342703819, 0.131830155849457, 0.131935954093933, 0.132041752338409, 0.132147535681725, 0.132253333926201, 0.132359102368355, 0.132464900612831, 0.132570669054985, 0.132676422595978, 0.132782176136971, 0.132887914776802, 0.132993668317795, 0.133099406957626, 0.133205145597458, 0.133310854434967, 0.133416578173637, 0.133522272109985, 0.133627980947495, 0.133733689785004, 0.133839383721352, 0.133945062756538, 0.134050741791725, 0.134156420826912, 0.134262099862099, 0.134367749094963, 0.134473413228989, 0.134579062461853, 0.134684711694717, 0.134790360927582, 0.134895980358124, 0.135001599788666, 0.135107219219208, 0.135212823748589, 0.135318428277969, 0.13542403280735, 0.13552962243557, 0.135635226964951, 0.135740771889687, 0.135846376419067, 0.135951951146126, 0.136057510972023, 0.13616307079792, 0.136268615722656, 0.136374160647392, 0.136479705572128, 0.136585220694542, 0.136690735816956, 0.13679626584053, 0.136901780962944, 0.137007281184196, 0.13711279630661, 0.137218281626701, 0.137323781847954, 0.137429252266884, 0.137534722685814, 0.137640208005905, 0.137745663523674, 0.137851119041443, 0.137956574559212, 0.138062000274658, 0.138167455792427, 0.138272881507874, 0.138378322124481, 0.138483718037605, 0.138589143753052, 0.138694554567337, 0.138799950480461, 0.138905346393585, 0.139010742306709, 0.139116123318672, 0.139221489429474, 0.139326855540276, 0.139432236552238, 0.139537587761879, 0.139642938971519, 0.13974829018116, 0.139853611588478, 0.139958962798119, 0.140064269304276, 0.140169605612755, 0.140274912118912, 0.140380218625069, 0.140485525131226, 0.140590816736221, 0.140696108341217, 0.140801399946213, 0.140906676650047, 0.141011923551559, 0.141117200255394, 0.141222462058067, 0.141327708959579, 0.141432955861092, 0.141538187861443, 0.141643419861794, 0.141748651862144, 0.141853868961334, 0.141959100961685, 0.142064303159714, 0.142169490456581, 0.14227469265461, 0.142379879951477, 0.142485067248344, 0.142590254545212, 0.142695412039757, 0.142800599336624, 0.142905741930008, 0.143010899424553, 0.143116056919098, 0.143221169710159, 0.143326312303543, 0.143431439995766, 0.143536567687988, 0.14364168047905, 0.143746793270111, 0.143851891160011, 0.143956989049911, 0.144062072038651, 0.14416715502739, 0.144272238016129, 0.144377306103706, 0.144482374191284, 0.144587427377701, 0.144692480564117, 0.144797533750534, 0.144902586936951, 0.145007610321045, 0.145112633705139, 0.145217657089233, 0.145322665572166, 0.145427659153938, 0.145532697439194, 0.145637676119804, 0.145742669701576, 0.145847663283348, 0.145952627062798, 0.146057605743408, 0.146162569522858, 0.146267518401146, 0.146372467279434, 0.146477431058884, 0.146582379937172, 0.146687313914299, 0.146792247891426, 0.146897152066231, 0.147002071142197, 0.147106990218163, 0.147211894392967, 0.147316798567772, 0.147421672940254, 0.147526577115059, 0.147631451487541, 0.147736310958862, 0.147841170430183, 0.147946044802666, 0.148050889372826, 0.148155748844147, 0.148260578513145, 0.148365408182144, 0.148470237851143, 0.148575067520142, 0.14867989718914, 0.148784697055817, 0.148889511823654, 0.148994311690331, 0.149099096655846, 0.1492038667202, 0.149308651685715, 0.14941343665123, 0.149518191814423, 0.149622961878777, 0.149727717041969, 0.149832457304001, 0.149937197566032, 0.150041937828064, 0.150146663188934, 0.150251403450966, 0.150356113910675, 0.150460824370384, 0.150565534830093, 0.150670230388641, 0.150774911046028, 0.150879606604576, 0.150984272360802, 0.151088953018188, 0.151193633675575, 0.15129828453064, 0.151402935385704, 0.151507586240768, 0.151612237095833, 0.151716858148575, 0.151821509003639, 0.15192611515522, 0.152030751109123, 0.152135342359543, 0.152239948511124, 0.152344554662704, 0.152449145913124, 0.152553707361221, 0.152658313512802, 0.152762874960899, 0.152867466211319, 0.152972027659416, 0.153076574206352, 0.153181120753288, 0.153285667300224, 0.15339021384716, 0.153494730591774, 0.153599262237549, 0.153703778982162, 0.153808280825615, 0.153912797570229, 0.15401728451252, 0.154121771454811, 0.154226288199425, 0.154330760240555, 0.154435232281685, 0.154539704322815, 0.154644161462784, 0.154748618602753, 0.15485306084156, 0.154957517981529, 0.155061930418015, 0.155166372656822, 0.155270785093307, 0.155375212430954, 0.155479654669762, 0.155584052205086, 0.155688419938087, 0.155792817473412, 0.155897215008736, 0.156001597642899, 0.156105980277061, 0.156210348010063, 0.156314715743065, 0.156419068574905, 0.156523421406746, 0.156627774238586, 0.156732097268105, 0.156836435198784, 0.156940773129463, 0.15704508125782, 0.157149389386177, 0.157253682613373, 0.15735799074173, 0.157462313771248, 0.157566577196121, 0.157670855522156, 0.15777513384819, 0.157879412174225, 0.157983660697937, 0.15808792412281, 0.158192157745361, 0.158296406269073, 0.158400654792786, 0.158504888415337, 0.158609107136726, 0.158713325858116, 0.158817544579506, 0.158921763300896, 0.159025952219963, 0.159130156040192, 0.159234344959259, 0.159338533878326, 0.159442692995071, 0.159546881914139, 0.159651041030884, 0.159755185246468, 0.159859344363213, 0.159963473677635, 0.16006763279438, 0.160171762108803, 0.160275891423225, 0.160380005836487, 0.160484120249748, 0.16058823466301, 0.16069233417511, 0.160796418786049, 0.16090053319931, 0.161004602909088, 0.161108687520027, 0.161212742328644, 0.16131679713726, 0.161420881748199, 0.161524921655655, 0.16162896156311, 0.161733001470566, 0.161837041378021, 0.161941051483154, 0.16204509139061, 0.162149101495743, 0.162253096699715, 0.162357106804848, 0.16246110200882, 0.162565097212791, 0.162669077515602, 0.162773057818413, 0.162877023220062, 0.162980988621712, 0.163084954023361, 0.163188889622688, 0.163292855024338, 0.163396790623665, 0.163500726222992, 0.163604661822319, 0.163708597421646, 0.16381248831749, 0.163916379213333, 0.16402031481266, 0.164124220609665, 0.164228081703186, 0.16433197259903, 0.164435848593712, 0.164539724588394, 0.164643585681915, 0.164747446775436, 0.164851307868958, 0.164955139160156, 0.165058970451355, 0.165162816643715, 0.165266647934914, 0.165370464324951, 0.16547429561615, 0.165578097105026, 0.165681913495064, 0.165785700082779, 0.165889486670494, 0.165993273258209, 0.166097059845924, 0.166200831532478, 0.166304603219032, 0.166408360004425, 0.166512101888657, 0.166615843772888, 0.16671958565712, 0.166823327541351, 0.16692703962326, 0.167030781507492, 0.167134508490562, 0.167238190770149, 0.167341902852058, 0.167445585131645, 0.167549312114716, 0.167652979493141, 0.167756661772728, 0.167860344052315, 0.167963996529579, 0.168067663908005, 0.168171316385269, 0.168274953961372, 0.168378606438637, 0.16848224401474, 0.168585866689682, 0.168689474463463, 0.168793112039566, 0.168896719813347, 0.169000327587128, 0.169103935360909, 0.169207498431206, 0.169311106204987, 0.169414684176445, 0.169518262147903, 0.169621810317039, 0.169725358486176, 0.169828936457634, 0.16993248462677, 0.170036047697067, 0.170139536261559, 0.170243084430695, 0.170346617698669, 0.170450150966644, 0.170553639531136, 0.170657142996788, 0.17076064646244, 0.170864149928093, 0.170967608690262, 0.171071112155914, 0.171174570918083, 0.171278044581413, 0.171381503343582, 0.171484962105751, 0.171588391065598, 0.171691864728928, 0.171795293688774, 0.171898722648621, 0.172002136707306, 0.172105565667152, 0.172208979725838, 0.172312393784523, 0.172415778040886, 0.17251917719841, 0.172622546553612, 0.172725945711136, 0.172829315066338, 0.172932684421539, 0.17303603887558, 0.17313939332962, 0.1732427328825, 0.17334608733654, 0.173449441790581, 0.173552766442299, 0.173656091094017, 0.173759400844574, 0.173862725496292, 0.173966005444527, 0.174069330096245, 0.174172610044479, 0.174275889992714, 0.174379169940948, 0.174482464790344, 0.174585729837418, 0.174688994884491, 0.174792245030403, 0.174895480275154, 0.174998730421066, 0.175101980566978, 0.175205215811729, 0.175308436155319, 0.175411656498909, 0.175514861941338, 0.175618067383766, 0.175721272826195, 0.175824463367462, 0.17592765390873, 0.176030844449997, 0.176134005188942, 0.176237180829048, 0.176340341567993, 0.176443517208099, 0.176546648144722, 0.176649793982506, 0.176752924919128, 0.176856070756912, 0.176959186792374, 0.177062302827835, 0.177165418863297, 0.177268534898758, 0.177371621131897, 0.177474722266197, 0.177577808499336, 0.177680894732475, 0.177783951163292, 0.17788702249527, 0.177990093827248, 0.178093165159225, 0.178196206688881, 0.178299263119698, 0.178402289748192, 0.178505316376686, 0.17860834300518, 0.178711384534836, 0.178814381361008, 0.178917393088341, 0.179020404815674, 0.179123401641846, 0.179226353764534, 0.179329350590706, 0.179432347416878, 0.179535299539566, 0.179638266563416, 0.179741218686104, 0.179844170808792, 0.179947137832642, 0.180050060153008, 0.180152982473373, 0.180255934596062, 0.180358842015266, 0.180461749434471, 0.180564671754837, 0.180667564272881, 0.180770456790924, 0.180873349308968, 0.180976212024689, 0.181079104542732, 0.181181997060776, 0.181284844875336, 0.181387707591057, 0.181490540504456, 0.181593388319016, 0.181696251034737, 0.181799054145813, 0.181901916861534, 0.18200471997261, 0.182107537984848, 0.182210355997086, 0.182313144207001, 0.182415947318077, 0.182518735527992, 0.182621508836746, 0.182724297046661, 0.182827055454254, 0.182929843664169, 0.183032587170601, 0.183135360479355, 0.183238089084625, 0.183340847492218, 0.183443561196327, 0.183546289801598, 0.183649018406868, 0.183751747012138, 0.183854445815086, 0.183957144618034, 0.184059843420982, 0.184162527322769, 0.184265211224556, 0.184367910027504, 0.18447057902813, 0.184573233127594, 0.184675872325897, 0.184778556227684, 0.184881195425987, 0.184983819723129, 0.185086444020271, 0.185189083218575, 0.185291722416878, 0.185394331812859, 0.185496956110001, 0.18559955060482, 0.18570214509964, 0.185804724693298, 0.185907304286957, 0.186009898781776, 0.186112463474274, 0.186215028166771, 0.186317592859268, 0.186420157551765, 0.18652269244194, 0.186625197529793, 0.18672776222229, 0.186830297112465, 0.186932817101479, 0.187035337090492, 0.187137857079506, 0.187240362167358, 0.18734285235405, 0.187445342540741, 0.187547832727432, 0.187650293111801, 0.187752768397331, 0.1878552287817, 0.187957718968391, 0.188060164451599, 0.188162609934807, 0.188265040516853, 0.1883674710989, 0.188469916582108, 0.188572332262993, 0.188674747943878, 0.188777163624763, 0.188879549503326, 0.188981965184212, 0.189084351062775, 0.189186751842499, 0.189289107918739, 0.189391493797302, 0.189493864774704, 0.189596220850945, 0.189698576927185, 0.189800918102264, 0.189903289079666, 0.190005600452423, 0.190107941627502, 0.190210253000259, 0.190312564373016, 0.190414875745773, 0.19051718711853, 0.190619483590126, 0.190721780061722, 0.190824076533318, 0.190926343202591, 0.191028624773026, 0.191130891442299, 0.191233143210411, 0.191335409879684, 0.191437661647797, 0.191539913415909, 0.19164215028286, 0.191744357347488, 0.191846594214439, 0.191948816180229, 0.192051023244858, 0.192153230309486, 0.192255437374115, 0.192357629537582, 0.192459791898727, 0.192561984062195, 0.192664161324501, 0.192766323685646, 0.192868486046791, 0.192970663309097, 0.193072810769081, 0.193174958229065, 0.193277075886726, 0.193379208445549, 0.19348132610321, 0.193583443760872, 0.193685561418533, 0.193787679076195, 0.193889781832695, 0.193991869688034, 0.194093927741051, 0.194196030497551, 0.19429811835289, 0.194400176405907, 0.194502234458923, 0.19460429251194, 0.194706350564957, 0.194808378815651, 0.194910421967506, 0.195012450218201, 0.195114463567734, 0.195216491818428, 0.195318520069122, 0.195420503616333, 0.195522516965866, 0.195624515414238, 0.195726498961449, 0.195828497409821, 0.195930451154709, 0.19603243470192, 0.196134403347969, 0.196236357092857, 0.196338281035423, 0.196440249681473, 0.196542173624039, 0.196644112467766, 0.196746036410332, 0.196847975254059, 0.196949869394302, 0.197051778435707, 0.197153687477112, 0.197255566716194, 0.197357475757599, 0.197459354996681, 0.197561234235764, 0.197663113474846, 0.197764948010445, 0.197866812348366, 0.197968661785126, 0.198070511221886, 0.198172345757484, 0.198274180293083, 0.19837598502636, 0.19847783446312, 0.198579639196396, 0.198681443929672, 0.198783248662949, 0.198885053396225, 0.198986828327179, 0.199088618159294, 0.199190393090248, 0.199292182922363, 0.199393928050995, 0.199495673179626, 0.199597433209419, 0.199699178338051, 0.199800923466682, 0.199902653694153, 0.200004383921623, 0.200106099247932, 0.200207814574242, 0.20030951499939, 0.200411230325699, 0.200512900948524, 0.200614601373672, 0.20071630179882, 0.200817972421646, 0.200919657945633, 0.201021313667297, 0.201122954487801, 0.201224625110626, 0.201326265931129, 0.201427921652794, 0.201529547572136, 0.201631173491478, 0.201732769608498, 0.20183439552784, 0.201936006546021, 0.202037632465363, 0.202139213681221, 0.202240809798241, 0.202342376112938, 0.202443942427635, 0.202545523643494, 0.202647104859352, 0.202748641371727, 0.202850207686424, 0.20295175909996, 0.203053295612335, 0.203154847025871, 0.203256353735924, 0.203357875347137, 0.20345938205719, 0.203560903668404, 0.203662425279617, 0.203763902187347, 0.203865393996239, 0.203966870903969, 0.20406836271286, 0.204169824719429, 0.204271301627159, 0.204372733831406, 0.204474180936813, 0.204575657844543, 0.204677104949951, 0.204778537154198, 0.204879954457283, 0.204981371760368, 0.205082789063454, 0.2051842212677, 0.205285608768463, 0.205386996269226, 0.20548839867115, 0.205589771270752, 0.205691158771515, 0.205792516469955, 0.205893903970718, 0.205995261669159, 0.206096619367599, 0.206197962164879, 0.206299304962158, 0.206400632858276, 0.206501975655556, 0.206603273749352, 0.20670460164547, 0.206805929541588, 0.206907212734222, 0.207008510828018, 0.207109808921814, 0.207211092114449, 0.207312375307083, 0.207413628697395, 0.20751491189003, 0.207616180181503, 0.207717418670654, 0.207818672060966, 0.207919910550117, 0.208021149039268, 0.208122387528419, 0.208223596215248, 0.208324819803238, 0.208426028490067, 0.208527237176895, 0.208628430962563, 0.20872962474823, 0.208830803632736, 0.208931997418404, 0.209033161401749, 0.209134325385094, 0.2092355042696, 0.209336653351784, 0.209437787532806, 0.20953893661499, 0.209640085697174, 0.209741204977036, 0.209842339158058, 0.209943443536758, 0.21004456281662, 0.210145682096481, 0.210246756672859, 0.210347846150398, 0.210448950529099, 0.210550010204315, 0.210651099681854, 0.210752174258232, 0.210853219032288, 0.210954263806343, 0.211055338382721, 0.211156368255615, 0.211257413029671, 0.211358442902565, 0.211459472775459, 0.211560472846031, 0.211661487817764, 0.211762502789497, 0.211863487958908, 0.21196448802948, 0.212065473198891, 0.212166473269463, 0.212267443537712, 0.2123683989048, 0.212469354271889, 0.212570339441299, 0.212671265006065, 0.212772205471992, 0.21287314593792, 0.212974086403847, 0.213075011968613, 0.213175922632217, 0.213276833295822, 0.213377758860588, 0.21347863972187, 0.213579535484314, 0.213680446147919, 0.21378131210804, 0.213882178068161, 0.213983044028282, 0.214083909988403, 0.214184775948524, 0.214285627007484, 0.214386463165283, 0.214487299323082, 0.214588135480881, 0.214688956737518, 0.214789777994156, 0.214890584349632, 0.214991420507431, 0.215092211961746, 0.215193003416061, 0.215293794870377, 0.215394556522369, 0.215495347976685, 0.215596109628677, 0.21569687128067, 0.215797618031502, 0.215898379683495, 0.215999141335487, 0.216099858283997, 0.216200590133667, 0.216301307082176, 0.216402053833008, 0.216502755880356, 0.216603457927704, 0.216704159975052, 0.216804847121239, 0.216905534267426, 0.217006236314774, 0.217106908559799, 0.217207551002502, 0.217308238148689, 0.217408895492554, 0.217509537935257, 0.217610195279121, 0.217710822820663, 0.217811450362206, 0.21791210770607, 0.218012720346451, 0.218113332986832, 0.218213945627213, 0.218314528465271, 0.218415141105652, 0.218515709042549, 0.218616291880608, 0.218716874718666, 0.218817442655563, 0.218918010592461, 0.219018563628197, 0.219119131565094, 0.219219669699669, 0.219320207834244, 0.219420731067657, 0.219521269202232, 0.219621792435646, 0.219722300767899, 0.21982279419899, 0.219923302531242, 0.220023795962334, 0.220124304294586, 0.220224782824516, 0.220325246453285, 0.220425710082054, 0.220526188611984, 0.220626652240753, 0.2207270860672, 0.22082756459713, 0.220927998423576, 0.221028432250023, 0.221128866076469, 0.221229285001755, 0.221329689025879, 0.221430093050003, 0.221530497074127, 0.221630901098251, 0.221731275320053, 0.221831679344177, 0.221932038664818, 0.22203241288662, 0.222132802009583, 0.222233161330223, 0.22233347594738, 0.222433850169182, 0.222534194588661, 0.222634509205818, 0.222734853625298, 0.222835168242455, 0.22293546795845, 0.223035797476768, 0.223136082291603, 0.22323639690876, 0.223336696624756, 0.223436966538429, 0.223537236452103, 0.223637506365776, 0.223736643791199, 0.223834589123726, 0.223932474851608, 0.224030315876007, 0.2241280823946, 0.224225804209709, 0.224323466420174, 0.224421054124832, 0.224518597126007, 0.22461611032486, 0.224713534116745, 0.224810898303986, 0.224908202886581, 0.225005462765694, 0.225102677941322, 0.225199803709984, 0.225296914577484, 0.225393921136856, 0.225490897893906, 0.225587829947472, 0.22568467259407, 0.225781485438347, 0.225878223776817, 0.225974917411804, 0.226071521639824, 0.226168096065521, 0.226264640688896, 0.226361066102982, 0.226457476615906, 0.226553812623024, 0.226650103926659, 0.226746335625648, 0.226842492818832, 0.226938620209694, 0.227034658193588, 0.22713066637516, 0.227226614952087, 0.22732250392437, 0.227418318390846, 0.227514088153839, 0.227609813213348, 0.227705463767052, 0.227801069617271, 0.227896615862846, 0.227992087602615, 0.228087514638901, 0.22818286716938, 0.228278174996376, 0.228373453021049, 0.228468656539917, 0.228563785552979, 0.228658854961395, 0.22875389456749, 0.228848844766617, 0.228943765163422, 0.229038625955582, 0.229133412241936, 0.229228138923645, 0.229322850704193, 0.229417473077774, 0.229512020945549, 0.229606539011002, 0.229700997471809, 0.229795396327972, 0.229889735579491, 0.229984015226364, 0.230078235268593, 0.230172410607338, 0.230266511440277, 0.230360567569733, 0.230454564094543, 0.230548501014709, 0.230642378330231, 0.230736196041107, 0.230829983949661, 0.230923682451248, 0.231017336249352, 0.231110915541649, 0.231204450130463, 0.231297940015793, 0.231391355395317, 0.231484726071358, 0.231578037142754, 0.231671303510666, 0.231764480471611, 0.231857627630234, 0.231950685381889, 0.232043713331223, 0.232136681675911, 0.232229590415955, 0.232322424650192, 0.232415243983269, 0.232507959008217, 0.232600644230843, 0.232693284749985, 0.232785850763321, 0.232878342270851, 0.232970774173737, 0.2330631762743, 0.233155518770218, 0.23324778676033, 0.233339995145798, 0.233432173728943, 0.233524292707443, 0.233616337180138, 0.233708322048187, 0.233800247311592, 0.233892127871513, 0.23398394882679, 0.234075725078583, 0.23416742682457, 0.234259068965912, 0.234350651502609, 0.234442204236984, 0.234533652663231, 0.234625086188316, 0.234716445207596, 0.234807759523392, 0.234899014234543, 0.234990194439888, 0.235081315040588, 0.235172405838966, 0.235263422131538, 0.235354363918304, 0.235445275902748, 0.235536113381386, 0.235626921057701, 0.23571765422821, 0.235808342695236, 0.235898941755295, 0.235989511013031, 0.2360799908638, 0.236170440912247, 0.236260831356049, 0.236351162195206, 0.236441448330879, 0.236531674861908, 0.236621841788292, 0.23671193420887, 0.236801967024803, 0.236891970038414, 0.236981898546219, 0.237071767449379, 0.237161576747894, 0.237251326441765, 0.237341031432152, 0.237430676817894, 0.237520277500153, 0.237609788775444, 0.237699255347252, 0.237788692116737, 0.237878054380417, 0.23796734213829, 0.23805658519268, 0.238145768642426, 0.238234907388687, 0.238323971629143, 0.238412976264954, 0.238501936197281, 0.238590836524963, 0.238679677248001, 0.238768458366394, 0.238857209682465, 0.238945871591568, 0.239034473896027, 0.239123046398163, 0.239211529493332, 0.239299967885017, 0.23938837647438, 0.239476680755615, 0.239564970135689, 0.239653170108795, 0.239741340279579, 0.239829435944557, 0.23991747200489, 0.24000546336174, 0.240093395113945, 0.240181252360344, 0.240269064903259, 0.24035681784153, 0.240444511175156, 0.240532159805298, 0.240619733929634, 0.240707293152809, 0.240794733166695, 0.240882143378258, 0.240969493985176, 0.241056799888611, 0.241144046187401, 0.241231203079224, 0.241318345069885, 0.241405412554741, 0.241492420434952, 0.241579368710518, 0.2416662722826, 0.241753101348877, 0.241839900612831, 0.241926625370979, 0.242013275623322, 0.242099896073341, 0.242186442017555, 0.242272958159447, 0.242359384894371, 0.242445766925812, 0.242532104253769, 0.242618352174759, 0.242704555392265, 0.242790699005127, 0.242876812815666, 0.242962852120399, 0.243048816919327, 0.243134751915932, 0.243220612406731, 0.243306428194046, 0.243392184376717, 0.243477866053581, 0.243563503026962, 0.243649080395699, 0.243734613060951, 0.243820071220398, 0.243905499577522, 0.243990838527679, 0.244076132774353, 0.244161352515221, 0.244246557354927, 0.244331657886505, 0.244416728615761, 0.244501739740372, 0.244586676359177, 0.244671568274498, 0.244756400585175, 0.244841188192368, 0.244925931096077, 0.245010554790497, 0.245095193386078, 0.245179727673531, 0.2452642172575, 0.245348647236824, 0.245433032512665, 0.245517358183861, 0.245601609349251, 0.245685815811157, 0.24576997756958, 0.245854064822197, 0.245938092470169, 0.246022075414658, 0.24610598385334, 0.2461898624897, 0.246273651719093, 0.246357411146164, 0.246441081166267, 0.24652473628521, 0.246608316898346, 0.246691823005676, 0.246775284409523, 0.246858686208725, 0.246942028403282, 0.247025325894356, 0.247108548879623, 0.247191742062569, 0.247274860739708, 0.247357904911041, 0.247440904378891, 0.247523859143257, 0.247606754302979, 0.247689574956894, 0.247772365808487, 0.247855067253113, 0.247937738895416, 0.248020336031914, 0.248102888464928, 0.248185351490974, 0.248267784714699, 0.248350188136101, 0.248432472348213, 0.248514756560326, 0.24859693646431, 0.248679086565971, 0.248761191964149, 0.24884320795536, 0.248925194144249, 0.24900709092617, 0.249088972806931, 0.249170750379562, 0.249252498149872, 0.249334186315536, 0.249415814876556, 0.249497398734093, 0.249578908085823, 0.24966037273407, 0.249741747975349, 0.249823108315468, 0.24990439414978, 0.249985620379448, 0.250066787004471, 0.25014790892601, 0.250228941440582, 0.250309944152832, 0.250390887260437, 0.25047180056572, 0.250552624464035, 0.250633388757706, 0.250714093446732, 0.250794738531113, 0.250875353813171, 0.250955909490585, 0.251036375761032, 0.251116782426834, 0.251197189092636, 0.251277506351471, 0.251357734203339, 0.251437932252884, 0.251518100500107, 0.251598179340363, 0.251678198575974, 0.251758188009262, 0.251838088035583, 0.25191792845726, 0.251997709274292, 0.252077490091324, 0.252157181501389, 0.252236783504486, 0.252316325902939, 0.252395868301392, 0.252475321292877, 0.252554714679718, 0.252634048461914, 0.252713352441788, 0.252792567014694, 0.252871721982956, 0.252950817346573, 0.253029882907867, 0.253108859062195, 0.253187835216522, 0.25326669216156, 0.253345519304276, 0.253424286842346, 0.253503024578094, 0.253581672906876, 0.25366023182869, 0.253738790750504, 0.25381726026535, 0.253895699977875, 0.253974050283432, 0.254052370786667, 0.254130631685257, 0.25420880317688, 0.25428694486618, 0.254365056753159, 0.254443049430847, 0.254521012306213, 0.254598915576935, 0.254676759243011, 0.254754573106766, 0.254832297563553, 0.254909992218018, 0.254987627267838, 0.25506517291069, 0.255142688751221, 0.255220144987106, 0.255297511816025, 0.255374848842621, 0.255452126264572, 0.255529373884201, 0.255606532096863, 0.25568363070488, 0.255760669708252, 0.255837678909302, 0.255914598703384, 0.255991488695145, 0.256068289279938, 0.256145060062408, 0.256221771240234, 0.256298422813416, 0.256375014781952, 0.256451517343521, 0.25652801990509, 0.256604462862015, 0.256680816411972, 0.256757110357285, 0.256833344697952, 0.256909549236298, 0.256985694169998, 0.257061749696732, 0.257137775421143, 0.257213741540909, 0.257289618253708, 0.257365494966507, 0.257441282272339, 0.257517009973526, 0.257592707872391, 0.257668316364288, 0.257743865251541, 0.257819354534149, 0.257894814014435, 0.257970213890076, 0.258045554161072, 0.258120834827423, 0.258196026086807, 0.258271187543869, 0.258346319198608, 0.258421331644058, 0.258496314287186, 0.258571267127991, 0.258646160364151, 0.258720964193344, 0.258795708417892, 0.258870422840118, 0.258945047855377, 0.259019643068314, 0.259094178676605, 0.259168654680252, 0.259243071079254, 0.259317427873611, 0.259391725063324, 0.259465962648392, 0.259540140628815, 0.259614288806915, 0.259688347578049, 0.25976237654686, 0.259836316108704, 0.259910255670547, 0.259984076023102, 0.260057866573334, 0.260131597518921, 0.260205268859863, 0.260278880596161, 0.260352432727814, 0.260425925254822, 0.260499387979507, 0.260572761297226, 0.2606460750103, 0.260719358921051, 0.260792583227158, 0.260865718126297, 0.260938823223114, 0.261011868715286, 0.261084854602814, 0.261157810688019, 0.261230677366257, 0.261303454637527, 0.261376231908798, 0.261448919773102, 0.261521577835083, 0.261594146490097, 0.261666685342789, 0.261739134788513, 0.261811554431915, 0.261883914470673, 0.261956214904785, 0.262028425931931, 0.262100636959076, 0.262172758579254, 0.262244820594788, 0.262316852807999, 0.262388795614243, 0.262460678815842, 0.262532562017441, 0.262604296207428, 0.262676060199738, 0.262747704982758, 0.262819319963455, 0.262890875339508, 0.262962371110916, 0.263033807277679, 0.263105183839798, 0.263176500797272, 0.263247787952423, 0.263318985700607, 0.263390123844147, 0.263461232185364, 0.263532280921936, 0.263603270053864, 0.263674199581146, 0.263745039701462, 0.263815850019455, 0.263886600732803, 0.263957291841507, 0.264027953147888, 0.264098525047302, 0.264169067144394, 0.264239519834518, 0.264309912919998, 0.264380246400833, 0.264450550079346, 0.264520794153214, 0.264590978622437, 0.264661103487015, 0.264731168746948, 0.264801174402237, 0.264871120452881, 0.26494100689888, 0.265010833740234, 0.265080660581589, 0.265150338411331, 0.265220016241074, 0.265289634466171, 0.265359193086624, 0.26542866230011, 0.265498101711273, 0.265567481517792, 0.265636801719666, 0.265706062316895, 0.265775263309479, 0.265844434499741, 0.265913516283035, 0.265982538461685, 0.266051560640335, 0.266120463609695, 0.266189306974411, 0.266258120536804, 0.26632684469223, 0.266395568847656, 0.266464203596115, 0.266532778739929, 0.266601294279099, 0.266669750213623, 0.266738176345825, 0.266806483268738, 0.26687479019165, 0.266943007707596, 0.267011225223541, 0.267079323530197, 0.267147392034531, 0.267215400934219, 0.267283320426941, 0.267351239919662, 0.267419040203094, 0.267486840486526, 0.267554551362991, 0.267622202634811, 0.267689824104309, 0.26775735616684, 0.267824858427048, 0.267892271280289, 0.267959624528885, 0.268026977777481, 0.26809424161911, 0.268161445856094, 0.268228590488434, 0.268295675516129, 0.268362700939178, 0.268429666757584, 0.268496572971344, 0.268563449382782, 0.268630236387253, 0.268696993589401, 0.268763691186905, 0.268830299377441, 0.268896877765656, 0.268963396549225, 0.269029855728149, 0.269096255302429, 0.269162595272064, 0.269228875637054, 0.2692950963974, 0.269361317157745, 0.269427388906479, 0.269493460655212, 0.269559472799301, 0.269625425338745, 0.269691288471222, 0.269757121801376, 0.269822895526886, 0.269888609647751, 0.269954264163971, 0.270019859075546, 0.270085394382477, 0.270150870084763, 0.270216315984726, 0.270281702280045, 0.270346999168396, 0.270412266254425, 0.270477443933487, 0.270542591810226, 0.270607709884644, 0.270672708749771, 0.270737677812576, 0.270802587270737, 0.270867437124252, 0.270932227373123, 0.270996987819672, 0.271061688661575, 0.271126300096512, 0.271190851926804, 0.271255373954773, 0.271319836378098, 0.271384209394455, 0.27144855260849, 0.27151283621788, 0.271577090024948, 0.271641254425049, 0.271705359220505, 0.271769404411316, 0.271833419799805, 0.271897345781326, 0.271961241960526, 0.27202507853508, 0.272088825702667, 0.27215251326561, 0.272216200828552, 0.272279798984528, 0.272343307733536, 0.272406816482544, 0.272470235824585, 0.272533595561981, 0.272596895694733, 0.272660136222839, 0.272723346948624, 0.272786498069763, 0.272849559783936, 0.272912591695786, 0.272975564002991, 0.273038476705551, 0.273101300001144, 0.273164093494415, 0.273226827383041, 0.273289531469345, 0.273352175951004, 0.273414731025696, 0.273477226495743, 0.273539662361145, 0.273602098226547, 0.273664385080338, 0.27372670173645, 0.273788899183273, 0.273851066827774, 0.27391317486763, 0.273975223302841, 0.274037212133408, 0.274099171161652, 0.274161040782928, 0.274222850799561, 0.27428463101387, 0.274346321821213, 0.274407982826233, 0.274469554424286, 0.274531096220016, 0.274592578411102, 0.274654000997543, 0.27471536397934, 0.274776667356491, 0.274837911128998, 0.27489909529686, 0.274960249662399, 0.275021314620972, 0.275082319974899, 0.275143295526505, 0.275204241275787, 0.275265067815781, 0.275325864553452, 0.275386601686478, 0.275447279214859, 0.275507867336273, 0.275568455457687, 0.275628954172134, 0.275689393281937, 0.275749802589417, 0.275810122489929, 0.275870382785797, 0.275930613279343, 0.275990784168243, 0.276050865650177, 0.276110947132111, 0.276170909404755, 0.276230871677399, 0.276290714740753, 0.276350557804108, 0.276410311460495, 0.276470005512238, 0.276529639959335, 0.276589244604111, 0.276648789644241, 0.276708245277405, 0.276767671108246, 0.27682700753212, 0.276886314153671, 0.276945561170578, 0.27700474858284, 0.277063876390457, 0.277122914791107, 0.277181953191757, 0.277240931987762, 0.277299851179123, 0.277358680963516, 0.277417451143265, 0.277476191520691, 0.27753484249115, 0.277593493461609, 0.277652055025101, 0.277710527181625, 0.277768969535828, 0.277827382087708, 0.27788570523262, 0.277943968772888, 0.278002202510834, 0.278060346841812, 0.278118431568146, 0.278176456689835, 0.278234452009201, 0.278292387723923, 0.278350293636322, 0.278408080339432, 0.278465837240219, 0.278523534536362, 0.278581172227859, 0.278638750314713, 0.278696268796921, 0.278753757476807, 0.278811186552048, 0.278868526220322, 0.278925836086273, 0.27898308634758, 0.27904024720192, 0.279097378253937, 0.279154449701309, 0.279211461544037, 0.279268443584442, 0.279325306415558, 0.279382139444351, 0.2794389128685, 0.279495656490326, 0.279552340507507, 0.279608935117722, 0.279665499925613, 0.27972200512886, 0.27977842092514, 0.279834806919098, 0.279891133308411, 0.279947400093079, 0.280003607273102, 0.280059784650803, 0.280115872621536, 0.280171900987625, 0.280227899551392, 0.280283808708191, 0.280339688062668, 0.2803955078125, 0.280451267957687, 0.280506938695908, 0.280562579631805, 0.280618160963058, 0.280673682689667, 0.28072914481163, 0.280784577131271, 0.280839890241623, 0.280895203351974, 0.280950427055359, 0.281005620956421, 0.281060725450516, 0.281115800142288, 0.281170815229416, 0.281225770711899, 0.281280666589737, 0.28133550286293, 0.281390279531479, 0.281445026397705, 0.281499683856964, 0.281554251909256, 0.281608819961548, 0.281663328409195, 0.281717747449875, 0.281772136688232, 0.281826466321945, 0.281880736351013, 0.281934916973114, 0.281989067792892, 0.282043188810349, 0.282097220420837, 0.282151192426682, 0.282205104827881, 0.282258987426758, 0.282312780618668, 0.282366514205933, 0.282420247793198, 0.282473862171173, 0.282527416944504, 0.282580941915512, 0.282634437084198, 0.282687813043594, 0.282741189002991, 0.282794445753098, 0.282847702503204, 0.282900869846344, 0.282953977584839, 0.283007055521011, 0.283060044050217, 0.2831130027771, 0.283165901899338, 0.283218711614609, 0.283271491527557, 0.283324211835861, 0.283376902341843, 0.283429473638535, 0.283482044935226, 0.283534556627274, 0.283586949110031, 0.283639341592789, 0.283691644668579, 0.283743917942047, 0.28379613161087, 0.283848255872726, 0.28390035033226, 0.283952355384827, 0.284004360437393, 0.284056276082993, 0.284108132123947, 0.284159958362579, 0.284211665391922, 0.284263372421265, 0.28431499004364, 0.284366577863693, 0.284418106079102, 0.284469544887543, 0.284520953893661, 0.284572303295135, 0.284623593091965, 0.284674823284149, 0.284725993871689, 0.284777104854584, 0.284828156232834, 0.284879177808762, 0.284930109977722, 0.28498101234436, 0.285031795501709, 0.285082578659058, 0.285133302211761, 0.285183966159821, 0.285234570503235, 0.285285085439682, 0.285335600376129, 0.285386025905609, 0.285436391830444, 0.285486727952957, 0.285536974668503, 0.285587191581726, 0.28563728928566, 0.285687416791916, 0.285737454891205, 0.285787403583527, 0.285837292671204, 0.285887181758881, 0.28593698143959, 0.285986691713333, 0.286036401987076, 0.286086022853851, 0.28613555431366, 0.286185085773468, 0.286234557628632, 0.286283940076828, 0.286333292722702, 0.286382585763931, 0.286431789398193, 0.286480963230133, 0.286530077457428, 0.286579161882401, 0.286628127098083, 0.286677092313766, 0.286725968122482, 0.286774784326553, 0.286823570728302, 0.286872267723083, 0.286920934915543, 0.286969512701035, 0.287018090486526, 0.287066519260406, 0.287114977836609, 0.287163317203522, 0.287211656570435, 0.287259876728058, 0.287308096885681, 0.287356197834015, 0.287404328584671, 0.287452340126038, 0.287500292062759, 0.287548214197159, 0.287596046924591, 0.287643879652023, 0.287691593170166, 0.287739306688309, 0.287786900997162, 0.287834465503693, 0.287881970405579, 0.287929445505142, 0.287976831197739, 0.288024187088013, 0.288071423768997, 0.288118660449982, 0.288165807723999, 0.288212925195694, 0.288259983062744, 0.28830698132515, 0.28835391998291, 0.288400799036026, 0.288447618484497, 0.288494378328323, 0.288541108369827, 0.288587749004364, 0.288634330034256, 0.288680851459503, 0.288727343082428, 0.288773775100708, 0.288820147514343, 0.288866430521011, 0.288912683725357, 0.288958877325058, 0.289004981517792, 0.289051085710526, 0.289097100496292, 0.289143085479736, 0.289188981056213, 0.289234817028046, 0.289280593395233, 0.289326339960098, 0.289372026920319, 0.289417624473572, 0.289463222026825, 0.289508700370789, 0.289554178714752, 0.289599567651749, 0.2896448969841, 0.289690166711807, 0.289735376834869, 0.289780557155609, 0.289825677871704, 0.289870738983154, 0.289915680885315, 0.289960622787476, 0.290005505084991, 0.290050357580185, 0.290095090866089, 0.29013979434967, 0.290184438228607, 0.290229022502899, 0.290273547172546, 0.290318012237549, 0.290362447500229, 0.290406793355942, 0.290451109409332, 0.290495365858078, 0.290539562702179, 0.290583670139313, 0.290627777576447, 0.290671765804291, 0.290715754032135, 0.29075962305069, 0.290803492069244, 0.290847271680832, 0.290890991687775, 0.290934652090073, 0.290978282690048, 0.291021853685379, 0.291065335273743, 0.291108787059784, 0.291152149438858, 0.291195511817932, 0.291238784790039, 0.291281998157501, 0.291325122117996, 0.291368246078491, 0.291411280632019, 0.291454285383224, 0.291497200727463, 0.291540056467056, 0.291582882404327, 0.291625648736954, 0.291668325662613, 0.291711002588272, 0.291753560304642, 0.291796088218689, 0.291838586330414, 0.291880995035172, 0.291923344135284, 0.291965663433075, 0.292007893323898, 0.292050093412399, 0.292092204093933, 0.292134255170822, 0.292176306247711, 0.292218238115311, 0.292260140180588, 0.29230198264122, 0.292343765497208, 0.29238548874855, 0.292427152395248, 0.292468756437302, 0.29251030087471, 0.292551845312119, 0.292593270540237, 0.292634636163712, 0.292675971984863, 0.29271724820137, 0.292758464813232, 0.29279962182045, 0.292840719223022, 0.29288175702095, 0.292922735214233, 0.292963653802872, 0.293004512786865, 0.293045341968536, 0.293080806732178, 0.293110907077789, 0.293140888214111, 0.293170839548111, 0.293200641870499, 0.293230414390564, 0.293260097503662, 0.293289661407471, 0.293319165706635, 0.293348580598831, 0.293377935886383, 0.293407171964645, 0.293436378240585, 0.293465465307236, 0.293494462966919, 0.293523401021957, 0.293552249670029, 0.29358097910881, 0.29360967874527, 0.293638288974762, 0.293666779994965, 0.293695211410522, 0.293723553419113, 0.293751835823059, 0.293780028820038, 0.293808132410049, 0.293836146593094, 0.293864071369171, 0.293891936540604, 0.293919712305069, 0.293947398662567, 0.293974995613098, 0.294002503156662, 0.294029951095581, 0.294057279825211, 0.294084578752518, 0.294111788272858, 0.294138878583908, 0.294165909290314, 0.294192850589752, 0.294219732284546, 0.29424649477005, 0.294273197650909, 0.294299811124802, 0.294326364994049, 0.294352799654007, 0.294379144906998, 0.294405430555344, 0.294431656599045, 0.294457763433456, 0.294483810663223, 0.294509798288345, 0.294535636901855, 0.294561415910721, 0.294587135314941, 0.294612735509872, 0.294638305902481, 0.2946637570858, 0.294689118862152, 0.294714421033859, 0.294739633798599, 0.294764757156372, 0.294789791107178, 0.294814765453339, 0.294839650392532, 0.294864445924759, 0.294889152050018, 0.294913798570633, 0.29493835568428, 0.294962823390961, 0.294987201690674, 0.29501149058342, 0.295035719871521, 0.295059889554977, 0.295083910226822, 0.295107871294022, 0.295131742954254, 0.295155614614487, 0.295179307460785, 0.295202940702438, 0.295226514339447, 0.295249968767166, 0.29527336359024, 0.29529669880867, 0.295319885015488, 0.295343071222305, 0.295366108417511, 0.295389086008072, 0.29541203379631, 0.295434832572937, 0.295457571744919, 0.295480221509933, 0.295502781867981, 0.295525252819061, 0.295547664165497, 0.295569986104965, 0.295592218637466, 0.295614361763, 0.29563644528389, 0.295658469200134, 0.295680344104767, 0.295702159404755, 0.29572394490242, 0.295745581388474, 0.295767158269882, 0.295788645744324, 0.29581007361412, 0.29583141207695, 0.29585263133049, 0.295873820781708, 0.295894891023636, 0.295915901660919, 0.295936793088913, 0.295957624912262, 0.295978397130966, 0.295999050140381, 0.296019643545151, 0.296040117740631, 0.296060562133789, 0.29608091711998, 0.296101182699203, 0.296121329069138, 0.296141445636749, 0.296161442995071, 0.296181380748749, 0.296201199293137, 0.296220988035202, 0.296240627765656, 0.296260267496109, 0.296279788017273, 0.296299189329147, 0.296318531036377, 0.296337783336639, 0.296356976032257, 0.296376079320908, 0.296395093202591, 0.29641404747963, 0.296432882547379, 0.296451658010483, 0.29647034406662, 0.29648894071579, 0.296507477760315, 0.296525925397873, 0.296544253826141, 0.296562552452087, 0.296580731868744, 0.296598851680756, 0.296616852283478, 0.296634823083878, 0.29665270447731, 0.296670466661453, 0.296688139438629, 0.296705782413483, 0.296723276376724, 0.296740740537643, 0.296758115291595, 0.296775370836258, 0.296792596578598, 0.296809703111649, 0.296826750040054, 0.296843707561493, 0.296860575675964, 0.296877354383469, 0.296894073486328, 0.29691070318222, 0.296927213668823, 0.296943664550781, 0.296960055828094, 0.296976357698441, 0.296992540359497, 0.297008693218231, 0.297024726867676, 0.297040700912476, 0.297056585550308, 0.297072380781174, 0.297088086605072, 0.297103732824326, 0.29711925983429, 0.297134727239609, 0.297150105237961, 0.297165423631668, 0.297180622816086, 0.297195762395859, 0.297210842370987, 0.297225803136826, 0.297240674495697, 0.297255516052246, 0.297270238399506, 0.297284841537476, 0.297299414873123, 0.297313898801804, 0.297328293323517, 0.297342598438263, 0.297356814146042, 0.297370970249176, 0.297385007143021, 0.297399014234543, 0.297412902116776, 0.297426730394363, 0.297440469264984, 0.297454088926315, 0.297467678785324, 0.297481149435043, 0.29749459028244, 0.297507882118225, 0.297521114349365, 0.297534257173538, 0.297547370195389, 0.297560334205627, 0.297573268413544, 0.297586053609848, 0.29759880900383, 0.297611474990845, 0.297624051570892, 0.297636538743973, 0.297648936510086, 0.297661274671555, 0.297673523426056, 0.297685712575912, 0.297697752714157, 0.297709763050079, 0.297721683979034, 0.297733515501022, 0.297745257616043, 0.297756940126419, 0.297768533229828, 0.29778003692627, 0.297791451215744, 0.297802776098251, 0.297814011573792, 0.297825217247009, 0.297836273908615, 0.297847330570221, 0.297858238220215, 0.297869086265564, 0.297879815101624, 0.297890514135361, 0.297901123762131, 0.297911614179611, 0.297922044992447, 0.297932416200638, 0.297942638397217, 0.297952830791473, 0.297962933778763, 0.297972947359085, 0.297982901334763, 0.297992736101151, 0.298002511262894, 0.29801219701767, 0.298021823167801, 0.29803130030632, 0.298040747642517, 0.298050105571747, 0.298059403896332, 0.298068583011627, 0.298077672719955, 0.298086702823639, 0.298095673322678, 0.298104524612427, 0.298113316297531, 0.298121988773346, 0.298130571842194, 0.298139125108719, 0.298147588968277, 0.298155933618546, 0.298164218664169, 0.298172414302826, 0.298180550336838, 0.298188596963882, 0.29819655418396, 0.298204392194748, 0.298212200403214, 0.29821988940239, 0.298227518796921, 0.298235058784485, 0.298242539167404, 0.298249870538712, 0.298257172107697, 0.298264384269714, 0.298271507024765, 0.298278570175171, 0.298285514116287, 0.298292368650436, 0.298299193382263, 0.2983058989048, 0.298312544822693, 0.298319071531296, 0.298325538635254, 0.298331916332245, 0.298338234424591, 0.298344433307648, 0.298350602388382, 0.298356622457504, 0.298362612724304, 0.298368513584137, 0.29837429523468, 0.298380017280579, 0.298385679721832, 0.298391222953796, 0.298396706581116, 0.298402100801468, 0.298407375812531, 0.298412621021271, 0.298417776823044, 0.29842284321785, 0.298427820205688, 0.29843270778656, 0.298437505960464, 0.298442244529724, 0.298446893692017, 0.298451483249664, 0.298455953598022, 0.298460334539413, 0.298464685678482, 0.298468887805939, 0.298473060131073, 0.298477113246918, 0.29848113656044, 0.29848501086235, 0.298488855361938, 0.298492580652237, 0.298496246337891, 0.298499822616577, 0.298503309488297, 0.298506736755371, 0.298510015010834, 0.298513293266296, 0.298516452312469, 0.298519551753998, 0.298522531986237, 0.298525452613831, 0.298528283834457, 0.298531055450439, 0.29853367805481, 0.29853630065918, 0.29853880405426, 0.298541218042374, 0.29854354262352, 0.298545807600021, 0.298547983169556, 0.298550069332123, 0.298552066087723, 0.298554003238678, 0.298555821180344, 0.298557579517365, 0.298559278249741, 0.298560857772827, 0.298562377691269, 0.298563808202744, 0.298565149307251, 0.298566401004791, 0.298567593097687, 0.298568695783615, 0.298569679260254, 0.29857063293457, 0.298571467399597, 0.298572242259979, 0.298572927713394, 0.298573553562164, 0.298574060201645, 0.298574507236481, 0.298574864864349, 0.298575133085251, 0.298575311899185, 0.298575431108475, 0.298575431108475, 0.298575401306152, 0.29857525229454, 0.298575043678284, 0.29857474565506, 0.298574358224869, 0.298573851585388, 0.298573285341263, 0.298572689294815, 0.298571944236755, 0.298571139574051, 0.298570275306702, 0.298569291830063, 0.298568248748779, 0.298567086458206, 0.298565894365311, 0.298564612865448, 0.298563212156296, 0.298561751842499, 0.298560231924057, 0.298558592796326, 0.29855689406395, 0.298555105924606, 0.298553198575974, 0.298551261425018, 0.298549205064774, 0.298547118902206, 0.29854491353035, 0.298542588949203, 0.298540264368057, 0.298537790775299, 0.298535227775574, 0.298532634973526, 0.298529922962189, 0.298527121543884, 0.298524260520935, 0.298521339893341, 0.298518270254135, 0.298515200614929, 0.298511981964111, 0.298508733510971, 0.298505365848541, 0.298501908779144, 0.298498392105103, 0.298494756221771, 0.298491090536118, 0.298487305641174, 0.298483431339264, 0.298479527235031, 0.298475474119186, 0.298471391201019, 0.298467189073563, 0.298462897539139, 0.298458576202393, 0.298454135656357, 0.298449635505676, 0.298445016145706, 0.298440337181091, 0.298435568809509, 0.298430740833282, 0.298425793647766, 0.298420816659927, 0.298415690660477, 0.298410534858704, 0.298405230045319, 0.298399895429611, 0.298394471406937, 0.298388957977295, 0.298383355140686, 0.298377692699432, 0.298371970653534, 0.298366129398346, 0.298360198736191, 0.298354208469391, 0.298348098993301, 0.298341929912567, 0.298335701227188, 0.29832935333252, 0.298322945833206, 0.298316448926926, 0.298309832811356, 0.298303216695786, 0.298296451568604, 0.298289597034454, 0.29828268289566, 0.298275709152222, 0.298268646001816, 0.29826146364212, 0.298254251480103, 0.298246920108795, 0.298239499330521, 0.298232018947601, 0.298224419355392, 0.298216789960861, 0.29820904135704, 0.298201233148575, 0.29819330573082, 0.298185348510742, 0.298177272081375, 0.298169106245041, 0.298160880804062, 0.298152565956116, 0.298144161701202, 0.298135697841644, 0.298127114772797, 0.298118472099304, 0.298109740018845, 0.298100918531418, 0.298092067241669, 0.298083066940308, 0.298074007034302, 0.298064857721329, 0.298055619001389, 0.298046320676804, 0.298036962747574, 0.298027485609055, 0.298017919063568, 0.298008292913437, 0.297998577356339, 0.297988772392273, 0.297978848218918, 0.29796889424324, 0.297958850860596, 0.297948718070984, 0.297938525676727, 0.297928243875504, 0.29791784286499, 0.297907382249832, 0.297896802425385, 0.297886192798615, 0.297875493764877, 0.297864705324173, 0.297853827476501, 0.297842860221863, 0.297831803560257, 0.297820687294006, 0.297809481620789, 0.297798186540604, 0.297786831855774, 0.297775357961655, 0.297763824462891, 0.297752231359482, 0.297740489244461, 0.29772874712944, 0.29771688580513, 0.297704935073853, 0.297692894935608, 0.297680765390396, 0.29766857624054, 0.297656297683716, 0.297643929719925, 0.297631472349167, 0.297618955373764, 0.297606348991394, 0.297593653202057, 0.297580868005753, 0.297568023204803, 0.297555088996887, 0.297542065382004, 0.297528952360153, 0.297515749931335, 0.297502487897873, 0.297489136457443, 0.297475695610046, 0.297462195158005, 0.297448575496674, 0.297434896230698, 0.297421127557755, 0.297407299280167, 0.297393351793289, 0.297379344701767, 0.2973652780056, 0.297351062297821, 0.29733681678772, 0.297322452068329, 0.297308057546616, 0.297293543815613, 0.297278940677643, 0.297264277935028, 0.297249495983124, 0.297234684228897, 0.297219753265381, 0.297204732894897, 0.297189682722092, 0.297174483537674, 0.297159254550934, 0.297143876552582, 0.29712849855423, 0.297112971544266, 0.297097384929657, 0.297081738710403, 0.29706597328186, 0.297050178050995, 0.297034233808517, 0.297018259763718, 0.297002166509628, 0.296986013650894, 0.29696974158287, 0.296953439712524, 0.296937048435211, 0.296920537948608, 0.296903967857361, 0.296887308359146, 0.296870559453964, 0.296853750944138, 0.296836823225021, 0.296819865703583, 0.296802788972855, 0.296785622835159, 0.296768397092819, 0.296751081943512, 0.296733677387238, 0.296716213226318, 0.29669862985611, 0.296680986881256, 0.296663254499435, 0.296645432710648, 0.296627551317215, 0.296609580516815, 0.296591520309448, 0.296573370695114, 0.296555131673813, 0.296536862850189, 0.296518445014954, 0.296499997377396, 0.296481430530548, 0.296462774276733, 0.296444058418274, 0.29642528295517, 0.296406358480453, 0.296387404203415, 0.296368330717087, 0.296349227428436, 0.296330004930496, 0.296310693025589, 0.296291321516037, 0.296271860599518, 0.296252310276031, 0.296232670545578, 0.29621297121048, 0.296193182468414, 0.296173274517059, 0.296153336763382, 0.296133309602737, 0.296113193035126, 0.296092957258224, 0.296072661876678, 0.296052306890488, 0.29603186249733, 0.296011298894882, 0.295990705490112, 0.295969992876053, 0.295949220657349, 0.295928329229355, 0.295907378196716, 0.295886337757111, 0.29586523771286, 0.29584401845932, 0.295822739601135, 0.295801401138306, 0.295779943466187, 0.295758426189423, 0.295736819505692, 0.295715123414993, 0.295693337917328, 0.295671492815018, 0.29564955830574, 0.295627534389496, 0.295605421066284, 0.295583218336105, 0.295560956001282, 0.295538604259491, 0.295516133308411, 0.295493632555008, 0.295471042394638, 0.295448362827301, 0.295425593852997, 0.295402765274048, 0.295379817485809, 0.295356780290604, 0.295333683490753, 0.295310497283936, 0.295287251472473, 0.295263916254044, 0.295240491628647, 0.295216977596283, 0.295193374156952, 0.295169711112976, 0.295145958662033, 0.295122116804123, 0.295098185539246, 0.295074194669724, 0.295050084590912, 0.295025914907455, 0.295001655817032, 0.294977307319641, 0.294952929019928, 0.294928401708603, 0.294903844594955, 0.294879168272018, 0.294854402542114, 0.294829577207565, 0.294804662466049, 0.294779658317566, 0.294754594564438, 0.294729441404343, 0.294704169034958, 0.294678837060928, 0.294653445482254, 0.294627964496613, 0.294602394104004, 0.294576704502106, 0.294550985097885, 0.294525146484375, 0.29449924826622, 0.29447329044342, 0.294447183609009, 0.294421046972275, 0.294394820928574, 0.294368475675583, 0.29434210062027, 0.294315606355667, 0.29428905248642, 0.294262379407883, 0.294235646724701, 0.294208854436874, 0.294181972742081, 0.294154942035675, 0.294127911329269, 0.294100761413574, 0.294073522090912, 0.294046223163605, 0.29401883482933, 0.293991357088089, 0.293963819742203, 0.293936163187027, 0.293908447027206, 0.293880641460419, 0.293852746486664, 0.293824791908264, 0.293796747922897, 0.293768614530563, 0.29374036192894, 0.293712079524994, 0.293683707714081, 0.293655246496201, 0.293626695871353, 0.293598085641861, 0.293569326400757, 0.29354053735733, 0.293511688709259, 0.293482720851898, 0.293453693389893, 0.293424546718597, 0.293395340442657, 0.29336604475975, 0.293336659669876, 0.293307214975357, 0.293277680873871, 0.293248057365417, 0.293218374252319, 0.293188571929932, 0.293158710002899, 0.2931287586689, 0.29309868812561, 0.293068617582321, 0.29303839802742, 0.293008118867874, 0.292977750301361, 0.292947322130203, 0.292916774749756, 0.292886167764664, 0.292855471372604, 0.292824685573578, 0.292793840169907, 0.292762905359268, 0.292731881141663, 0.29270076751709, 0.292669594287872, 0.292638301849365, 0.292606949806213, 0.292575508356094, 0.292543977499008, 0.292512357234955, 0.292480707168579, 0.292448937892914, 0.292417109012604, 0.292385160923004, 0.292353123426437, 0.292321026325226, 0.292288839817047, 0.292256593704224, 0.292224228382111, 0.292191833257675, 0.292159289121628, 0.292126685380936, 0.292094051837921, 0.292061239480972, 0.292028427124023, 0.291995525360107, 0.291962504386902, 0.291929423809052, 0.291896253824234, 0.291862994432449, 0.291829645633698, 0.291796237230301, 0.291762739419937, 0.291729152202606, 0.291695475578308, 0.291661709547043, 0.291627883911133, 0.291593998670578, 0.291559994220734, 0.291525900363922, 0.291491717100143, 0.29145747423172, 0.291423141956329, 0.291388750076294, 0.291354238986969, 0.291319698095322, 0.291285008192062, 0.291250288486481, 0.291215479373932, 0.291180551052094, 0.29114556312561, 0.291110515594482, 0.291075319051743, 0.29104009270668, 0.291004776954651, 0.290969401597977, 0.290933907032013, 0.290898323059082, 0.290862679481506, 0.290826946496964, 0.290791153907776, 0.290755242109299, 0.290719240903854, 0.290683209896088, 0.290647059679031, 0.290610820055008, 0.290574491024017, 0.290538132190704, 0.290501654148102, 0.290465086698532, 0.290428459644318, 0.290391743183136, 0.290354937314987, 0.290318012237549, 0.29028108716011, 0.290244042873383, 0.290206879377365, 0.290169656276703, 0.290132373571396, 0.290094971656799, 0.290057510137558, 0.290019959211349, 0.289982348680496, 0.289944618940353, 0.289906829595566, 0.289868921041489, 0.289830982685089, 0.289792954921722, 0.289754807949066, 0.289716601371765, 0.289678305387497, 0.289639949798584, 0.289601475000381, 0.289562940597534, 0.289524286985397, 0.289485603570938, 0.289446800947189, 0.289407938718796, 0.289368987083435, 0.28932997584343, 0.289290845394135, 0.289251625537872, 0.289212375879288, 0.289173007011414, 0.289133578538895, 0.289094030857086, 0.289054423570633, 0.289014726877213, 0.288974910974503, 0.28893506526947, 0.288895130157471, 0.288855105638504, 0.28881499171257, 0.288774818181992, 0.288734525442123, 0.28869417309761, 0.28865373134613, 0.288613229990005, 0.288572579622269, 0.288531929254532, 0.288491159677505, 0.288450300693512, 0.288409382104874, 0.288368344306946, 0.288327246904373, 0.288286060094833, 0.288244813680649, 0.288203477859497, 0.288162022829056, 0.28812050819397, 0.288078933954239, 0.288037240505219, 0.287995487451553, 0.287953644990921, 0.287911713123322, 0.287869691848755, 0.287827610969543, 0.287785440683365, 0.287743210792542, 0.287700861692429, 0.287658452987671, 0.287615954875946, 0.287573337554932, 0.287530660629272, 0.287487924098969, 0.287445068359375, 0.287402182817459, 0.287359178066254, 0.287316113710403, 0.287272959947586, 0.287229686975479, 0.287186354398727, 0.287142962217331, 0.287099450826645, 0.287055879831314, 0.287012189626694, 0.286968469619751, 0.286924660205841, 0.286880731582642, 0.286836743354797, 0.286792695522308, 0.28674852848053, 0.286704301834106, 0.286659955978394, 0.286615550518036, 0.286571115255356, 0.286526501178741, 0.286481887102127, 0.286437124013901, 0.28639230132103, 0.286347419023514, 0.286302447319031, 0.286257356405258, 0.286212235689163, 0.286166995763779, 0.286121666431427, 0.286076307296753, 0.286030828952789, 0.285985261201859, 0.285939604043961, 0.285893887281418, 0.285848081111908, 0.285802185535431, 0.285756230354309, 0.28571018576622, 0.285664021968842, 0.285617828369141, 0.28557151556015, 0.285525143146515, 0.285478681325912, 0.285432130098343, 0.285385489463806, 0.285338759422302, 0.285291969776154, 0.285245090723038, 0.285198152065277, 0.285151064395905, 0.28510394692421, 0.28505676984787, 0.285009473562241, 0.284962087869644, 0.284914642572403, 0.284867078065872, 0.284819453954697, 0.284771740436554, 0.284723967313766, 0.284676104784012, 0.28462815284729, 0.284580111503601, 0.284531980752945, 0.284483790397644, 0.284435510635376, 0.284387141466141, 0.284338682889938, 0.284290164709091, 0.284241557121277, 0.284192830324173, 0.284144073724747, 0.284095197916031, 0.28404626250267, 0.283997237682343, 0.283948123455048, 0.283898949623108, 0.283849656581879, 0.283800303936005, 0.283750861883163, 0.283701330423355, 0.283651739358902, 0.283602029085159, 0.283552259206772, 0.28350242972374, 0.283452481031418, 0.283402472734451, 0.283352375030518, 0.283302187919617, 0.283251941204071, 0.283201575279236, 0.283151149749756, 0.283100634813309, 0.283050030469894, 0.282999366521835, 0.282948613166809, 0.282897740602493, 0.282846808433533, 0.282795786857605, 0.282744705677032, 0.282693564891815, 0.282642304897308, 0.282590955495834, 0.282539546489716, 0.28248804807663, 0.282436460256577, 0.282384753227234, 0.282333016395569, 0.282281190156937, 0.282229274511337, 0.282177269458771, 0.282125204801559, 0.282073020935059, 0.282020747661591, 0.2819684445858, 0.281911224126816, 0.281849086284637, 0.281786859035492, 0.281724601984024, 0.281662285327911, 0.281599879264832, 0.281537413597107, 0.281474858522415, 0.281412243843079, 0.281349569559097, 0.281286835670471, 0.2812240421772, 0.281161159276962, 0.281098216772079, 0.281035214662552, 0.280972123146057, 0.28090900182724, 0.280845761299133, 0.280782461166382, 0.280719131231308, 0.280655711889267, 0.280592232942581, 0.280528694391251, 0.280465096235275, 0.28040137887001, 0.280337661504745, 0.280273824930191, 0.280209958553314, 0.280145972967148, 0.280081957578659, 0.280017882585526, 0.279953747987747, 0.279889494180679, 0.279825210571289, 0.279760807752609, 0.279696434736252, 0.279631912708282, 0.279567360877991, 0.279502749443054, 0.279438048601151, 0.27937325835228, 0.279308438301086, 0.279243558645248, 0.279178589582443, 0.279113560914993, 0.279048442840576, 0.278983294963837, 0.27891805768013, 0.278852730989456, 0.27878737449646, 0.278721928596497, 0.278656423091888, 0.278590857982635, 0.278525233268738, 0.278459519147873, 0.278393745422363, 0.278327912092209, 0.278261989355087, 0.278196007013321, 0.27812996506691, 0.278063833713531, 0.277997672557831, 0.277931421995163, 0.27786511182785, 0.277798712253571, 0.277732282876968, 0.277665764093399, 0.277599185705185, 0.277532547712326, 0.2774658203125, 0.277399003505707, 0.277332186698914, 0.277265280485153, 0.277198284864426, 0.277131229639053, 0.277064085006714, 0.276996910572052, 0.276929646730423, 0.276862323284149, 0.276794940233231, 0.276727467775345, 0.276659935712814, 0.276592373847961, 0.276524662971497, 0.276456981897354, 0.2763891518116, 0.276321291923523, 0.276253372430801, 0.276185363531113, 0.276117295026779, 0.276049196720123, 0.275980949401855, 0.275912702083588, 0.27584433555603, 0.275775939226151, 0.275707483291626, 0.275638937950134, 0.275570333003998, 0.275501668453217, 0.275432914495468, 0.275364100933075, 0.275295227766037, 0.275226265192032, 0.275157302618027, 0.275088220834732, 0.27501904964447, 0.274949878454208, 0.274880558252335, 0.274811238050461, 0.274741798639297, 0.274672299623489, 0.274602770805359, 0.274533152580261, 0.274463474750519, 0.274393737316132, 0.274323880672455, 0.274254024028778, 0.274184048175812, 0.274114042520523, 0.274043947458267, 0.273973792791367, 0.273903548717499, 0.273833274841309, 0.273762911558151, 0.273692488670349, 0.273622006177902, 0.273551434278488, 0.273480802774429, 0.273410111665726, 0.273339331150055, 0.273268491029739, 0.273197621107101, 0.273126631975174, 0.273055613040924, 0.272984534502029, 0.272913336753845, 0.272842109203339, 0.272770822048187, 0.272699445486069, 0.272627979516983, 0.272556483745575, 0.272484928369522, 0.272413283586502, 0.272341549396515, 0.272269785404205, 0.272197932004929, 0.272126048803329, 0.272054076194763, 0.27198201417923, 0.271909922361374, 0.271837711334229, 0.271765470504761, 0.271693140268326, 0.271620780229568, 0.271548330783844, 0.271475821733475, 0.271403223276138, 0.271330565214157, 0.271257847547531, 0.271185100078583, 0.271112203598022, 0.271039307117462, 0.270966291427612, 0.27089324593544, 0.270820140838623, 0.270746946334839, 0.270673662424088, 0.270600348711014, 0.270526975393295, 0.27045351266861, 0.270379990339279, 0.270306378602982, 0.270232707262039, 0.270159006118774, 0.27008518576622, 0.270011335611343, 0.2699373960495, 0.269863396883011, 0.269789308309555, 0.269715189933777, 0.269640982151031, 0.269566714763641, 0.269492357969284, 0.269417971372604, 0.26934352517128, 0.269268959760666, 0.269194364547729, 0.269119679927826, 0.269044935703278, 0.268970131874084, 0.268895238637924, 0.268820315599442, 0.268745303153992, 0.268670201301575, 0.268595099449158, 0.268519848585129, 0.2684445977211, 0.268369227647781, 0.268293827772141, 0.268218338489532, 0.268142759799957, 0.26806715130806, 0.267991483211517, 0.267915725708008, 0.267839908599854, 0.267764031887054, 0.267688065767288, 0.267612040042877, 0.267535984516144, 0.267459779977798, 0.267383545637131, 0.267307251691818, 0.267230927944183, 0.267154484987259, 0.26707798242569, 0.267001420259476, 0.266924768686295, 0.266848117113113, 0.26677131652832, 0.266694515943527, 0.266617596149445, 0.26654064655304, 0.266463607549667, 0.26638650894165, 0.266309350728989, 0.26623210310936, 0.266154795885086, 0.266077399253845, 0.265999972820282, 0.265922456979752, 0.265844911336899, 0.265767276287079, 0.265689522027969, 0.265611797571182, 0.265533924102783, 0.265456020832062, 0.265378057956696, 0.265300005674362, 0.265221893787384, 0.265143722295761, 0.265065461397171, 0.264987140893936, 0.264908760786057, 0.264830321073532, 0.264751762151718, 0.264673173427582, 0.264594554901123, 0.264515846967697, 0.264437049627304, 0.264358192682266, 0.264279246330261, 0.264200270175934, 0.264121204614639, 0.264042109251022, 0.263962924480438, 0.263883650302887, 0.263804316520691, 0.26372492313385, 0.263645440340042, 0.263565927743912, 0.263486325740814, 0.263406664133072, 0.263326972723007, 0.263247162103653, 0.263167291879654, 0.26308736205101, 0.263007342815399, 0.262927293777466, 0.262847125530243, 0.262766927480698, 0.262686669826508, 0.26260632276535, 0.262525916099548, 0.262445479631424, 0.26236492395401, 0.262284308671951, 0.262203633785248, 0.262122869491577, 0.262042075395584, 0.261961191892624, 0.261880248785019, 0.261799246072769, 0.261718153953552, 0.261637032032013, 0.261555790901184, 0.261474519968033, 0.261393159627914, 0.261311739683151, 0.261230260133743, 0.261148720979691, 0.261067092418671, 0.260985404253006, 0.260903656482697, 0.26082181930542, 0.260739952325821, 0.260657966136932, 0.260575950145721, 0.260493874549866, 0.260411709547043, 0.260329484939575, 0.26024717092514, 0.260164827108383, 0.260082423686981, 0.259999930858612, 0.259917348623276, 0.259834736585617, 0.259752005338669, 0.259669274091721, 0.259586423635483, 0.259503543376923, 0.259420543909073, 0.259337514638901, 0.259254425764084, 0.2591712474823, 0.259088009595871, 0.259004712104797, 0.258921325206757, 0.258837908506393, 0.258754402399063, 0.258670806884766, 0.258587181568146, 0.258503466844559, 0.258419692516327, 0.25833585858345, 0.258251935243607, 0.258167952299118, 0.258083909749985, 0.257999777793884, 0.257915616035461, 0.257831364870071, 0.257747024297714, 0.257662653923035, 0.25757822394371, 0.257493704557419, 0.25740909576416, 0.257324427366257, 0.257239729166031, 0.25715497136116, 0.257070064544678, 0.256985157728195, 0.256900191307068, 0.256815105676651, 0.256729990243912, 0.256644785404205, 0.256559550762177, 0.256474226713181, 0.256388813257217, 0.256303369998932, 0.256217837333679, 0.256132215261459, 0.256046563386917, 0.255960822105408, 0.255875051021576, 0.255789190530777, 0.255703210830688, 0.2556172311306, 0.255531191825867, 0.255445033311844, 0.255358815193176, 0.255272567272186, 0.255186200141907, 0.255099803209305, 0.255013346672058, 0.254926800727844, 0.254840195178986, 0.25475350022316, 0.254666775465012, 0.254579931497574, 0.254493087530136, 0.254406124353409, 0.254319131374359, 0.254232048988342, 0.254144877195358, 0.254057675600052, 0.253970384597778, 0.25388303399086, 0.253795623779297, 0.253708124160767, 0.253620594739914, 0.253532975912094, 0.253445267677307, 0.253357529640198, 0.253269702196121, 0.2531818151474, 0.253093868494034, 0.253005832433701, 0.252917736768723, 0.2528295814991, 0.252741366624832, 0.252653062343597, 0.252564698457718, 0.252476304769516, 0.252387762069702, 0.252299219369888, 0.252210557460785, 0.252121895551682, 0.252033114433289, 0.251944303512573, 0.251855373382568, 0.251766413450241, 0.251677364110947, 0.251588255167007, 0.251499086618423, 0.251409858465195, 0.251320540904999, 0.25123119354248, 0.251141726970673, 0.251052260398865, 0.250962644815445, 0.250873029232025, 0.250783294439316, 0.250693529844284, 0.250603705644608, 0.250513762235641, 0.250423789024353, 0.25033375620842, 0.250243633985519, 0.250153452157974, 0.250063180923462, 0.249972879886627, 0.249882504343987, 0.249792039394379, 0.249701529741287, 0.249610960483551, 0.249520286917686, 0.249429598450661, 0.249338790774345, 0.249247923493385, 0.249157011508942, 0.24906599521637, 0.248974978923798, 0.248883828520775, 0.248792633414268, 0.248701378703117, 0.248610034584999, 0.248518660664558, 0.248427167534828, 0.248335644602776, 0.248244047164917, 0.248152390122414, 0.248060658574104, 0.247968852519989, 0.247876986861229, 0.247785031795502, 0.247693032026291, 0.247600972652435, 0.247508838772774, 0.247416630387306, 0.247324362397194, 0.247232034802437, 0.247139647603035, 0.247047141194344, 0.246954619884491, 0.24686199426651, 0.246769338846207, 0.246676579117775, 0.246583759784698, 0.246490865945816, 0.246397942304611, 0.246304914355278, 0.246211841702461, 0.246118679642677, 0.246025502681732, 0.245932206511497, 0.245838850736618, 0.245745450258255, 0.245651945471764, 0.245558395981789, 0.245464786887169, 0.245371073484421, 0.24527733027935, 0.245183497667313, 0.245089590549469, 0.244995653629303, 0.24490162730217, 0.244807526469231, 0.244713366031647, 0.244619145989418, 0.244524836540222, 0.244430497288704, 0.244336053729057, 0.244241580367088, 0.244147002696991, 0.244052365422249, 0.243957668542862, 0.243862897157669, 0.24376805126667, 0.243673175573349, 0.243578195571899, 0.243483170866966, 0.243388041853905, 0.243292883038521, 0.243197664618492, 0.243102356791496, 0.243006974458694, 0.242911517620087, 0.242816030979156, 0.242720425128937, 0.242624804377556, 0.242529079318047, 0.242433309555054, 0.242337495088577, 0.242241561412811, 0.242145568132401, 0.242049500346184, 0.241953402757645, 0.241857245564461, 0.241760969161987, 0.24166464805603, 0.24156828224659, 0.241471827030182, 0.241375297307968, 0.241278722882271, 0.241182073950768, 0.241085335612297, 0.240988522768021, 0.240891680121422, 0.240794748067856, 0.240697756409645, 0.24060070514679, 0.24050360918045, 0.240406379103661, 0.240309119224548, 0.240211799740791, 0.24011442065239, 0.240016937255859, 0.239919409155846, 0.239821821451187, 0.239724144339561, 0.239626422524452, 0.239528611302376, 0.239430725574493, 0.239332795143127, 0.239234805107117, 0.239136725664139, 0.239038586616516, 0.238940387964249, 0.238842129707336, 0.238743782043457, 0.238645374774933, 0.238546878099442, 0.238448366522789, 0.238349735736847, 0.238251060247421, 0.23815231025219, 0.238053485751152, 0.237954616546631, 0.237855657935143, 0.237756654620171, 0.237657591700554, 0.237558424472809, 0.23745921254158, 0.237359941005707, 0.237260580062866, 0.237161159515381, 0.23706166446209, 0.236962124705315, 0.236862495541573, 0.236762806773186, 0.236663073301315, 0.236563220620155, 0.236463323235512, 0.236363381147385, 0.236263334751129, 0.236163273453712, 0.236063107848167, 0.235962882637978, 0.235862568020821, 0.235762193799019, 0.235661789774895, 0.235561296343803, 0.235460713505745, 0.235360071063042, 0.235259383916855, 0.235158607363701, 0.235057771205902, 0.234956875443459, 0.234855875372887, 0.234754875302315, 0.234653785824776, 0.234552592039108, 0.234451368451118, 0.234350040555, 0.23424868285656, 0.234147220849991, 0.234045743942261, 0.233944147825241, 0.233842492103577, 0.233740791678429, 0.233639031648636, 0.233537167310715, 0.23343525826931, 0.23333328962326, 0.233231231570244, 0.233129099011421, 0.233026936650276, 0.232924669981003, 0.232822358608246, 0.232719972729683, 0.232617527246475, 0.2325149923563, 0.232412397861481, 0.232309758663177, 0.232207044959068, 0.232104226946831, 0.23200136423111, 0.231898441910744, 0.231795474886894, 0.231692403554916, 0.231589272618294, 0.231486096978188, 0.231382831931114, 0.231279492378235, 0.231176093220711, 0.231072634458542, 0.230969086289406, 0.230865493416786, 0.230761811137199, 0.23065809905529, 0.230554312467575, 0.23045040667057, 0.230346515774727, 0.230242505669594, 0.230138421058655, 0.230034276843071, 0.229930058121681, 0.229825809597969, 0.229721441864967, 0.229617059230804, 0.229512557387352, 0.2294080555439, 0.229303419589996, 0.22919873893261, 0.229093983769417, 0.22898918390274, 0.228884279727936, 0.228779345750809, 0.228674322366714, 0.228569269180298, 0.228464111685753, 0.228358894586563, 0.228253602981567, 0.228148236870766, 0.22804282605648, 0.227937340736389, 0.227831780910492, 0.227726146578789, 0.227620467543602, 0.227514714002609, 0.227408900856972, 0.227303013205528, 0.227197036147118, 0.227091014385223, 0.226984918117523, 0.226878762245178, 0.226772546768188, 0.22666622698307, 0.22655987739563, 0.226453438401222, 0.22634693980217, 0.226240381598473, 0.226133733987808, 0.22602704167366, 0.225920259952545, 0.225813433527946, 0.225706547498703, 0.225599557161331, 0.225492522120476, 0.225385412573814, 0.225278243422508, 0.225171014666557, 0.225063696503639, 0.224956333637238, 0.224848881363869, 0.224741354584694, 0.224633783102036, 0.224526137113571, 0.224418431520462, 0.224310651421547, 0.224202811717987, 0.224094897508621, 0.223986923694611, 0.223878875374794, 0.223770752549171, 0.223662570118904, 0.22355429828167, 0.22344596683979, 0.223337605595589, 0.22322915494442, 0.223120644688606, 0.223012045025826, 0.2229033857584, 0.222794651985168, 0.222685858607292, 0.222577020525932, 0.222468078136444, 0.222359091043472, 0.222250044345856, 0.222140908241272, 0.222031712532043, 0.221922442317009, 0.22181311249733, 0.221703723073006, 0.221594229340553, 0.221484705805779, 0.221375107765198, 0.221265435218811, 0.221155717968941, 0.221045926213264, 0.22093603014946, 0.220826119184494, 0.220716089010239, 0.2206060141325, 0.220495879650116, 0.220385670661926, 0.220275402069092, 0.220165073871613, 0.220054641366005, 0.219944179058075, 0.219833627343178, 0.219723030924797, 0.219612330198288, 0.219501569867134, 0.219390794634819, 0.219279900193214, 0.219168961048126, 0.21905791759491, 0.218946859240532, 0.218835696578026, 0.218724474310875, 0.21861320734024, 0.218501836061478, 0.218390420079231, 0.21827894449234, 0.218167364597321, 0.218055754899979, 0.217944070696831, 0.217832341790199, 0.217720493674278, 0.217608600854874, 0.217496663331985, 0.217384606599808, 0.217272505164146, 0.217160359025002, 0.217048123478889, 0.216935828328133, 0.216823443770409, 0.216711029410362, 0.216598525643349, 0.21648596227169, 0.216373309493065, 0.216260656714439, 0.216147854924202, 0.216035023331642, 0.215922102332115, 0.215809136629105, 0.215696096420288, 0.215582996606827, 0.215469807386398, 0.215356588363647, 0.215243294835091, 0.215129911899567, 0.215016469359398, 0.214902922511101, 0.214789390563965, 0.214675709605217, 0.214562013745308, 0.214448213577271, 0.214334383606911, 0.214220449328423, 0.214106485247612, 0.213992416858673, 0.213878318667412, 0.213764175772667, 0.21364988386631, 0.213535562157631, 0.213421165943146, 0.213306739926338, 0.213192194700241, 0.21307760477066, 0.212962940335274, 0.212848216295242, 0.212733432650566, 0.212618559598923, 0.212503626942635, 0.212388664484024, 0.212273582816124, 0.21215845644474, 0.212043270468712, 0.211927980184555, 0.211812674999237, 0.211697280406952, 0.2115817964077, 0.211466252803802, 0.211350679397583, 0.211234971880913, 0.211119279265404, 0.211003437638283, 0.210887610912323, 0.210771635174751, 0.210655644536018, 0.210539549589157, 0.210423424839973, 0.210307225584984, 0.210190951824188, 0.210074618458748, 0.20995819568634, 0.20984174311161, 0.209725171327591, 0.209608569741249, 0.20949187874794, 0.209375128149986, 0.209258317947388, 0.209141433238983, 0.209024459123611, 0.208907470107079, 0.20879040658474, 0.208673238754272, 0.208556026220322, 0.208438709378242, 0.208321392536163, 0.208203926682472, 0.208086475729942, 0.207968905568123, 0.20785129070282, 0.20773358643055, 0.207615852355957, 0.207498013973236, 0.207380130887032, 0.20726215839386, 0.207144111394882, 0.207026034593582, 0.206907853484154, 0.206789642572403, 0.206671342253685, 0.206552982330322, 0.206434547901154, 0.206316083669662, 0.206197455525398, 0.206078842282295, 0.205960124731064, 0.205841362476349, 0.205722525715828, 0.205603629350662, 0.205484628677368, 0.205365642905235, 0.205246523022652, 0.205127343535423, 0.205008134245872, 0.20488877594471, 0.204769417643547, 0.204649955034256, 0.204530462622643, 0.204410865902901, 0.204291224479675, 0.204171508550644, 0.204051733016968, 0.203931868076324, 0.20381198823452, 0.203691959381104, 0.203571930527687, 0.203451812267303, 0.203331634402275, 0.203211382031441, 0.203091025352478, 0.202970683574677, 0.202850222587585, 0.20272970199585, 0.202609091997147, 0.202488452196121, 0.202367693185806, 0.202246934175491, 0.202126041054726, 0.202005118131638, 0.201884165406227, 0.201763078570366, 0.201641947031021, 0.20152074098587, 0.201399490237236, 0.201278135180473, 0.201156780123711, 0.201035276055336, 0.2009137570858, 0.200792133808136, 0.200670480728149, 0.200548723340034, 0.200426936149597, 0.200305044651031, 0.200183138251305, 0.200061142444611, 0.199939057230949, 0.199816912412643, 0.19969467818737, 0.199572429060936, 0.199450060725212, 0.199327692389488, 0.199205175042152, 0.199082657694817, 0.19896000623703, 0.198837354779243, 0.198714599013329, 0.19859179854393, 0.198468878865242, 0.198345944285393, 0.19822296500206, 0.198099851608276, 0.197976723313332, 0.197853475809097, 0.197730213403702, 0.197606831789017, 0.197483420372009, 0.197359919548035, 0.197236374020576, 0.197112739086151, 0.196989044547081, 0.196865290403366, 0.196741476655006, 0.19661757349968, 0.196493625640869, 0.196369588375092, 0.196245491504669, 0.196121349930763, 0.195997074246407, 0.19587279856205, 0.195748418569565, 0.195624023675919, 0.19549947977066, 0.195374920964241, 0.195250257849693, 0.195125594735146, 0.195000827312469, 0.194875970482826, 0.194751098752022, 0.194626092910767, 0.19450107216835, 0.194375947117805, 0.194250792264938, 0.194125533103943, 0.194000229239464, 0.193874850869179, 0.193749412894249, 0.193623915314674, 0.19349829852581, 0.193372666835785, 0.193246960639954, 0.193121165037155, 0.192995309829712, 0.192869424819946, 0.19274340569973, 0.192617371678352, 0.192491248250008, 0.192365065217018, 0.192238792777061, 0.192112505435944, 0.191986069083214, 0.191859647631645, 0.191733092069626, 0.191606506705284, 0.191479846835136, 0.191353157162666, 0.191226318478584, 0.191099464893341, 0.190972551703453, 0.19084557890892, 0.190718501806259, 0.190591350197792, 0.190464183688164, 0.190336897969246, 0.190209567546844, 0.190082147717476, 0.189954712986946, 0.189827159047127, 0.189699575304985, 0.189571872353554, 0.189444154500961, 0.189316347241402, 0.189188495278358, 0.189060553908348, 0.188932523131371, 0.188804492354393, 0.188676297664642, 0.188548117876053, 0.188419803977013, 0.188291490077972, 0.188163056969643, 0.188034608960152, 0.187906041741371, 0.187777444720268, 0.187648773193359, 0.187520012259483, 0.187391221523285, 0.187262296676636, 0.187133401632309, 0.187004342675209, 0.186875283718109, 0.186746090650558, 0.186616882681847, 0.186487570405006, 0.186358243227005, 0.186228811740875, 0.186103522777557, 0.185982584953308, 0.185861617326736, 0.185740560293198, 0.185619503259659, 0.185498401522636, 0.185377210378647, 0.185255989432335, 0.185134708881378, 0.185013383626938, 0.184891983866692, 0.184770569205284, 0.184649094939232, 0.184527575969696, 0.184405967593193, 0.184284374117851, 0.184162676334381, 0.184040948748589, 0.183919161558151, 0.183797359466553, 0.183675482869148, 0.183553516864777, 0.183431565761566, 0.183309525251389, 0.183187454938889, 0.183065295219421, 0.182943135499954, 0.18282088637352, 0.182698637247086, 0.182576268911362, 0.182453900575638, 0.182331457734108, 0.182208999991417, 0.182086482644081, 0.181963890790939, 0.181841269135475, 0.181718558073044, 0.181595847010612, 0.181473046541214, 0.181350231170654, 0.181227326393127, 0.181104406714439, 0.180981412529945, 0.18085840344429, 0.180735290050507, 0.180612161755562, 0.180488973855972, 0.180365741252899, 0.180242478847504, 0.180119127035141, 0.179995760321617, 0.179872304201126, 0.179748848080635, 0.179625272750854, 0.179501727223396, 0.179378062486649, 0.179254397749901, 0.179130643606186, 0.17900687456131, 0.178883031010628, 0.178759142756462, 0.178635209798813, 0.178511217236519, 0.178387209773064, 0.17826309800148, 0.178138971328735, 0.178014770150185, 0.177890539169312, 0.177766248583794, 0.177641913294792, 0.177517503499985, 0.177393078804016, 0.177268579602242, 0.177144050598145, 0.17701943218708, 0.176894828677177, 0.176770120859146, 0.176645383238792, 0.176520615816116, 0.176395744085312, 0.176270872354507, 0.176145911216736, 0.176020950078964, 0.175895884633064, 0.175770819187164, 0.175645649433136, 0.175520464777946, 0.175395205616951, 0.175269931554794, 0.17514456808567, 0.175019204616547, 0.174893766641617, 0.174768269062042, 0.174642726778984, 0.17451710999012, 0.174391493201256, 0.174265772104263, 0.174140051007271, 0.174014240503311, 0.17388841509819, 0.173762500286102, 0.173636570572853, 0.173510551452637, 0.17338453233242, 0.173258408904076, 0.17313227057457, 0.173006102442741, 0.172879830002785, 0.172753557562828, 0.172627180814743, 0.172500804066658, 0.172374352812767, 0.172247871756554, 0.172121301293373, 0.171994730830193, 0.171868041157722, 0.171741351485252, 0.171614602208138, 0.1714878231287, 0.171360939741135, 0.17123407125473, 0.171107158064842, 0.170980110764503, 0.170853093266487, 0.170725956559181, 0.170598849654198, 0.170471608638763, 0.170344397425652, 0.17021706700325, 0.170089736580849, 0.16996231675148, 0.16983488202095, 0.169707372784615, 0.169579833745956, 0.169452250003815, 0.169324561953545, 0.169196903705597, 0.169069111347198, 0.168941333889961, 0.168813467025757, 0.168685585260391, 0.168557614088058, 0.168429628014565, 0.168301552534103, 0.168173462152481, 0.168045282363892, 0.167917102575302, 0.167788848280907, 0.167660549283028, 0.167532205581665, 0.167403772473335, 0.167275324463844, 0.167146816849709, 0.16701827943325, 0.166889652609825, 0.1667610257864, 0.166632294654846, 0.166503548622131, 0.166374728083611, 0.166245892643929, 0.166116952896118, 0.165988028049469, 0.165858998894691, 0.165729954838753, 0.16560086607933, 0.165471702814102, 0.16534249484539, 0.165213242173195, 0.165083929896355, 0.16495455801487, 0.164825171232224, 0.164695680141449, 0.164566189050674, 0.164436608552933, 0.16430701315403, 0.16417732834816, 0.16404764354229, 0.163917869329453, 0.163788080215454, 0.163658231496811, 0.163528308272362, 0.16339835524559, 0.163268327713013, 0.163138270378113, 0.163008153438568, 0.162878006696701, 0.162747770547867, 0.162617534399033, 0.16248719394207, 0.162356853485107, 0.162226438522339, 0.162095993757248, 0.161965489387512, 0.161834895610809, 0.161704316735268, 0.161573618650436, 0.161442935466766, 0.161312147974968, 0.16118136048317, 0.161050483584404, 0.160919576883316, 0.160788610577583, 0.160657599568367, 0.160526514053345, 0.160395428538322, 0.160264238715172, 0.160133048892021, 0.160001784563065, 0.159870460629463, 0.159739106893539, 0.15960767865181, 0.159476220607758, 0.159344673156738, 0.159213125705719, 0.159081503748894, 0.158949851989746, 0.158818125724792, 0.158686354756355, 0.158554524183273, 0.158422663807869, 0.15829074382782, 0.158158779144287, 0.158026784658432, 0.157894685864449, 0.157762587070465, 0.157630398869514, 0.157498195767403, 0.157365918159485, 0.157233610749245, 0.157101213932037, 0.15696881711483, 0.156836330890656, 0.15670382976532, 0.156571239233017, 0.156438633799553, 0.156305938959122, 0.156173229217529, 0.156040489673615, 0.155907645821571, 0.155774787068367, 0.155641838908195, 0.155508875846863, 0.155375838279724, 0.155242785811424, 0.155109643936157, 0.154976487159729, 0.154843240976334, 0.154709994792938, 0.154576644301414, 0.154443293809891, 0.154309868812561, 0.154176399111748, 0.154042884707451, 0.153909280896187, 0.153775691986084, 0.153641998767853, 0.153508275747299, 0.15337447822094, 0.15324068069458, 0.153106778860092, 0.152972877025604, 0.152838870882988, 0.152704864740372, 0.152570784091949, 0.152436673641205, 0.152302518486977, 0.152168244123459, 0.152034014463425, 0.151899635791779, 0.151765301823616, 0.151630848646164, 0.151496380567551, 0.151361837983131, 0.151227280497551, 0.151092648506165, 0.150957971811295, 0.15082323551178, 0.150688454508781, 0.150553613901138, 0.150418758392334, 0.150283843278885, 0.150148838758469, 0.150013834238052, 0.149878710508347, 0.149743616580963, 0.149608418345451, 0.149473205208778, 0.149337902665138, 0.149202600121498, 0.149067178368568, 0.148931756615639, 0.148796275258064, 0.148660749197006, 0.148525193333626, 0.148389548063278, 0.148253872990608, 0.148118123412132, 0.147982358932495, 0.147846505045891, 0.147710636258125, 0.147574678063393, 0.147438704967499, 0.147302657365799, 0.147166594862938, 0.147030428051949, 0.14689427614212, 0.146758019924164, 0.146621748805046, 0.146485432982445, 0.146349027752876, 0.146212607622147, 0.146076112985611, 0.145939588546753, 0.145802974700928, 0.145666360855103, 0.145529642701149, 0.145392939448357, 0.145256131887436, 0.145119309425354, 0.144982382655144, 0.144845470786095, 0.144708469510078, 0.14457143843174, 0.14443439245224, 0.144297212362289, 0.1441600471735, 0.144022792577744, 0.143885508179665, 0.14374814927578, 0.143610790371895, 0.143473327159882, 0.143335863947868, 0.143198296427727, 0.143060728907585, 0.142923071980476, 0.142785385251045, 0.142647638916969, 0.142509862780571, 0.14237205684185, 0.14223413169384, 0.142096221446991, 0.141958191990852, 0.141820192337036, 0.14168207347393, 0.141543939709663, 0.14140573143959, 0.141267508268356, 0.141129195690155, 0.140990853309631, 0.140852451324463, 0.140714034438133, 0.140575543045998, 0.140436992049217, 0.140298411250114, 0.140159741044044, 0.140021070837975, 0.139882311224937, 0.139743536710739, 0.139604657888412, 0.139465793967247, 0.139326810836792, 0.139187842607498, 0.139048770070076, 0.138909697532654, 0.138770535588264, 0.138631358742714, 0.138492122292519, 0.138352811336517, 0.138213485479355, 0.138074055314064, 0.137934625148773, 0.137795120477676, 0.137655586004257, 0.137515962123871, 0.137376338243484, 0.137236624956131, 0.137096881866455, 0.136957079172134, 0.13681723177433, 0.136677324771881, 0.13653738796711, 0.136397406458855, 0.136257335543633, 0.136117249727249, 0.13597708940506, 0.135836884379387, 0.135696619749069, 0.135556355118752, 0.135415971279144, 0.135275587439537, 0.135135114192963, 0.134994640946388, 0.134854063391685, 0.134713485836983, 0.134572803974152, 0.13443212211132, 0.134291380643845, 0.134150564670563, 0.134009718894958, 0.133868813514709, 0.133727878332138, 0.133586838841438, 0.1334458142519, 0.133304685354233, 0.133163556456566, 0.133022338151932, 0.132881104946136, 0.132739782333374, 0.132598429918289, 0.132457062602043, 0.132315561175346, 0.132174104452133, 0.132032498717308, 0.131890937685966, 0.131749272346497, 0.131607562303543, 0.131465792655945, 0.131323993206024, 0.131182134151459, 0.131040245294571, 0.130898267030716, 0.1307562738657, 0.130614191293716, 0.130472108721733, 0.130329966545105, 0.130187749862671, 0.130045503377914, 0.129903167486191, 0.129760831594467, 0.129618406295776, 0.129475966095924, 0.129333421587944, 0.129190891981125, 0.129048258066177, 0.12890562415123, 0.128762900829315, 0.128620132803917, 0.128477305173874, 0.128334477543831, 0.128191560506821, 0.128048598766327, 0.12790559232235, 0.127762526273727, 0.127619415521622, 0.127476245164871, 0.127333045005798, 0.127189770340919, 0.127046480774879, 0.126903086900711, 0.126759693026543, 0.126616209745407, 0.12647271156311, 0.126329183578491, 0.126185551285744, 0.126041889190674, 0.125898167490959, 0.125754415988922, 0.125610575079918, 0.125466734170914, 0.125322803854942, 0.125178843736649, 0.125034809112549, 0.124890774488449, 0.124746635556221, 0.124602481722832, 0.124458245933056, 0.124314002692699, 0.124169699847698, 0.12402531504631, 0.123880915343761, 0.123736426234245, 0.123591937124729, 0.123447343707085, 0.123302727937698, 0.123158060014248, 0.123013347387314, 0.122868567705154, 0.122723758220673, 0.122578881680965, 0.122433975338936, 0.122288979589939, 0.122143983840942, 0.121998965740204, 0.121853783726692, 0.121708661317825, 0.121563427150249, 0.121418178081512, 0.121272832155228, 0.121127486228943, 0.120982028543949, 0.120836585760117, 0.120691046118736, 0.120545491576195, 0.120399847626686, 0.120254196226597, 0.12010845541954, 0.119962692260742, 0.119816906750202, 0.119671002030373, 0.119525097310543, 0.119379095733166, 0.119233101606369, 0.119086995720863, 0.118940912187099, 0.118794716894627, 0.118648499250412, 0.118502207100391, 0.11835590749979, 0.118209503591061, 0.118063099682331, 0.117916643619537, 0.117770105600357, 0.117623552680016, 0.117476902902126, 0.117330238223076, 0.117183499038219, 0.117036744952202, 0.116889886558056, 0.116743043065071, 0.116596080362797, 0.116449117660522, 0.116302080452442, 0.116155028343201, 0.116007879376411, 0.115860715508461, 0.115713514387608, 0.115566216409206, 0.115418903529644, 0.115271508693695, 0.115124084055424, 0.114976584911346, 0.114829078316689, 0.114681489765644, 0.114533878862858, 0.114386178553104, 0.114238455891609, 0.114090658724308, 0.113942846655846, 0.113794945180416, 0.113647043704987, 0.113499075174332, 0.11335101723671, 0.113202951848507, 0.113054804503918, 0.112906649708748, 0.11275839060545, 0.112610131502151, 0.112461768090725, 0.11231341958046, 0.112164951860905, 0.11201649159193, 0.111867934465408, 0.111719377338886, 0.111570790410042, 0.111422061920166, 0.111273370683193, 0.111124530434608, 0.110975749790668, 0.110826835036278, 0.110677920281887, 0.110528916120529, 0.110379904508591, 0.110230796039104, 0.110081680119038, 0.109932474792004, 0.109783262014389, 0.109633952379227, 0.109484635293484, 0.109335266053677, 0.109185814857483, 0.109036348760128, 0.108886793255806, 0.108737207949162, 0.108587548136711, 0.108437895774841, 0.108288124203682, 0.108138360083103, 0.107988506555557, 0.107838645577431, 0.107688672840595, 0.10753870755434, 0.107388645410538, 0.107238590717316, 0.107088461518288, 0.106938242912292, 0.106788031756878, 0.106637723743916, 0.106487393379211, 0.106336981058121, 0.106186561286449, 0.106036052107811, 0.105885528028011, 0.105734921991825, 0.105584308505058, 0.105433590710163, 0.105282858014107, 0.105132058262825, 0.104981236159801, 0.104830354452133, 0.104679383337498, 0.104528412222862, 0.104377366602421, 0.104226268827915, 0.104075103998184, 0.103923954069614, 0.103772677481174, 0.103621408343315, 0.103470042347908, 0.10331866145134, 0.103167198598385, 0.103015713393688, 0.102864198386669, 0.102712579071522, 0.102560959756374, 0.10240925103426, 0.102257512509823, 0.10210569947958, 0.101953871548176, 0.101801961660385, 0.101650021970272, 0.101498007774353, 0.101345978677273, 0.101193867623806, 0.101041749119759, 0.100889526307583, 0.100737288594246, 0.100585043430328, 0.100432641804218, 0.100280284881592, 0.100127816200256, 0.0999753400683403, 0.0998227745294571, 0.0996701866388321, 0.0995175242424011, 0.0993648394942284, 0.099212072789669, 0.0990592986345291, 0.0989064201712608, 0.0987535491585732, 0.0986005738377571, 0.0984475836157799, 0.0982945561408997, 0.0981414318084717, 0.0979883074760437, 0.0978350937366486, 0.0976818427443504, 0.0975285246968269, 0.0973751991987228, 0.0972217693924904, 0.0970683395862579, 0.0969148203730583, 0.0967612862586975, 0.0966076701879501, 0.0964540243148804, 0.096300296485424, 0.0961465835571289, 0.0959927961230278, 0.0958389118313789, 0.0956850275397301, 0.0955310463905334, 0.0953770652413368, 0.0952230021357536, 0.0950689092278481, 0.0949147269129753, 0.0947605445981026, 0.0946062654256821, 0.0944519862532616, 0.0942976102232933, 0.0941432192921638, 0.0939887836575508, 0.0938342586159706, 0.0936797186732292, 0.0935250818729401, 0.0933704450726509, 0.0932157337665558, 0.0930609852075577, 0.0929061621427536, 0.0927513241767883, 0.0925963893532753, 0.0924414545297623, 0.0922864302992821, 0.0921313911676407, 0.0919762551784515, 0.091821126639843, 0.0916659310460091, 0.0915106534957886, 0.0913553684949875, 0.091199979186058, 0.0910445973277092, 0.0908891037106514, 0.0907336100935936, 0.0905780419707298, 0.0904224440455437, 0.0902667716145515, 0.0901110768318176, 0.0899552851915359, 0.0897995084524155, 0.0896436274051666, 0.0894877314567566, 0.0893318057060242, 0.0891757756471634, 0.089019738137722, 0.0888635963201523, 0.0887074545025826, 0.0885512307286263, 0.0883949771523476, 0.0882386490702629, 0.0880823060870171, 0.0879258662462234, 0.0877694189548492, 0.0876128897070885, 0.0874563381075859, 0.0872997418045998, 0.0871430635452271, 0.0869863703846931, 0.0868295729160309, 0.0866727828979492, 0.0865158960223198, 0.0863590091466904, 0.086202010512352, 0.0860450118780136, 0.0858879238367081, 0.0857308432459831, 0.0855736508965492, 0.0854164510965347, 0.0852591693401337, 0.085101880133152, 0.0849445164203644, 0.0847870782017708, 0.084629625082016, 0.084472082555294, 0.0843145549297333, 0.084156908094883, 0.0839992538094521, 0.0838415175676346, 0.0836837664246559, 0.0835259258747101, 0.0833680778741837, 0.0832101255655289, 0.0830521881580353, 0.0828941538929939, 0.0827360972762108, 0.0825779885053635, 0.0824198052287102, 0.0822615996003151, 0.0821033045649529, 0.0819450095295906, 0.0817866176366806, 0.08162821829319, 0.0814697220921516, 0.0813112184405327, 0.0811526253819466, 0.080994039773941, 0.080835334956646, 0.0806766301393509, 0.0805178359150887, 0.0803590342402458, 0.0802001729607582, 0.0800412446260452, 0.0798822864890099, 0.0797232314944267, 0.0795641839504242, 0.0794050320982933, 0.079245887696743, 0.0790866315364838, 0.0789273828268051, 0.0787680298089981, 0.0786086767911911, 0.0784492343664169, 0.0782897844910622, 0.0781302973628044, 0.0779706686735153, 0.077811099588871, 0.0776513889431953, 0.0774916931986809, 0.0773318856954575, 0.077172078192234, 0.0770121887326241, 0.0768522769212723, 0.0766922831535339, 0.076532281935215, 0.0763721764087677, 0.0762120634317398, 0.0760518535971642, 0.0758916661143303, 0.0757313892245293, 0.0755710452795029, 0.0754107013344765, 0.0752502381801605, 0.0750897899270058, 0.0749292224645615, 0.0747686699032784, 0.0746080130338669, 0.0744473561644554, 0.0742866024374962, 0.0741258412599564, 0.07396499812603, 0.0738041400909424, 0.073643185198307, 0.0734822154045105, 0.0733212009072304, 0.0731601119041443, 0.0729990005493164, 0.0728377848863602, 0.0726765692234039, 0.0725152716040611, 0.0723539665341377, 0.0721925497055054, 0.0720311403274536, 0.0718696340918541, 0.071708120405674, 0.0715465173125267, 0.0713849142193794, 0.0712231993675232, 0.071061484515667, 0.070899710059166, 0.070737861096859, 0.070576012134552, 0.0704140514135361, 0.0702520906925201, 0.0700900182127953, 0.0699279606342316, 0.0697657987475395, 0.0696036368608475, 0.0694413855671883, 0.0692790970206261, 0.0691167488694191, 0.0689544007182121, 0.0687919557094574, 0.0686294510960579, 0.0684669464826584, 0.0683043226599693, 0.0681417211890221, 0.0679790005087852, 0.0678162798285484, 0.0676534622907639, 0.0674906522035599, 0.0673277452588081, 0.0671648383140564, 0.0670018345117569, 0.066838800907135, 0.066675677895546, 0.0665125846862793, 0.0663494318723679, 0.0661861449480057, 0.0660229027271271, 0.0658595263957977, 0.065696157515049, 0.0655326917767525, 0.065369226038456, 0.0652056634426117, 0.065042108297348, 0.0648784190416336, 0.0647147670388222, 0.0645509958267212, 0.0643872171640396, 0.0642233490943909, 0.0640594810247421, 0.0638955757021904, 0.0637315511703491, 0.0635675266385078, 0.0634034126996994, 0.0632392913103104, 0.0630750805139542, 0.0629108399152756, 0.0627465397119522, 0.0625822022557259, 0.0624178051948547, 0.0622533783316612, 0.0620888583362103, 0.0619243383407593, 0.0617597550153732, 0.0615950785577297, 0.0614304058253765, 0.0612656362354755, 0.0611008629202843, 0.0609360039234161, 0.0607711374759674, 0.0606061518192291, 0.0604411661624908, 0.0602761171758175, 0.0601110383868217, 0.0599458664655685, 0.0597806945443153, 0.0596154294908047, 0.0594501309096813, 0.0592848025262356, 0.0591193847358227, 0.0589539594948292, 0.0587884485721588, 0.0586229041218758, 0.0584572963416576, 0.0582916550338268, 0.0581259578466415, 0.0579602234065533, 0.0577944032847881, 0.0576285794377327, 0.0574626289308071, 0.0572967082262039, 0.0571307018399239, 0.0569646582007408, 0.0567985884845257, 0.0566323883831501, 0.0564662255346775, 0.0562999360263348, 0.0561336763203144, 0.0559672936797142, 0.0558009147644043, 0.0556344352662563, 0.055467963218689, 0.0553013868629932, 0.0551347881555557, 0.0549681298434734, 0.0548014342784882, 0.0546346828341484, 0.0544678941369057, 0.0543010756373405, 0.0541341342031956, 0.0539672262966633, 0.0538001880049706, 0.0536331571638584, 0.0534660294651985, 0.0532989017665386, 0.0531316474080086, 0.0529644303023815, 0.0527970865368843, 0.0526297688484192, 0.0524623356759548, 0.0522948950529099, 0.0521274246275425, 0.0519598349928856, 0.0517922416329384, 0.0516245886683464, 0.0514568686485291, 0.0512890890240669, 0.0511213093996048, 0.0509534403681755, 0.0507855340838432, 0.0506175681948662, 0.0504495725035667, 0.0502815134823322, 0.0501134283840656, 0.049945242702961, 0.0497770309448242, 0.0496088154613972, 0.0494404807686806, 0.0492721386253834, 0.049103707075119, 0.0489352457225323, 0.0487667247653008, 0.0485982000827789, 0.0484295524656773, 0.0482609048485756, 0.0480921939015388, 0.0479234531521797, 0.0477546192705631, 0.0475857518613338, 0.0474168248474598, 0.0472478978335857, 0.0470789074897766, 0.0469098277390003, 0.0467407144606113, 0.0465715378522873, 0.0464023612439632, 0.0462330617010593, 0.0460637658834457, 0.0458943694829941, 0.0457249768078327, 0.0455554910004139, 0.0453860051929951, 0.0452164299786091, 0.0450468175113201, 0.0448771454393864, 0.0447074435651302, 0.0445377118885517, 0.0443678498268127, 0.0441980250179768, 0.0440280698239803, 0.0438581518828869, 0.0436881072819233, 0.0435180626809597, 0.0433479286730289, 0.0431777611374855, 0.043007530272007, 0.0428372696042061, 0.0426669418811798, 0.0424965880811214, 0.0423262342810631, 0.0421557277441025, 0.0419852435588837, 0.0418146438896656, 0.0416440404951572, 0.0414733439683914, 0.0413026474416256, 0.0411318577826023, 0.040961068123579, 0.0407901890575886, 0.0406192727386951, 0.0404482670128345, 0.0402772948145866, 0.0401061922311783, 0.0399350933730602, 0.0397639349102974, 0.0395927093923092, 0.0394214540719986, 0.0392501093447208, 0.0390787608921528, 0.0389073193073273, 0.0387358479201794, 0.0385643132030964, 0.0383927822113037, 0.0382211208343506, 0.0380494631826878, 0.0378777123987675, 0.0377059616148472, 0.0375341176986694, 0.0373622737824917, 0.0371903665363789, 0.0370183698832989, 0.0368463695049286, 0.0366742759943008, 0.0365021824836731, 0.0363299660384655, 0.0361577831208706, 0.0359854735434055, 0.0358131639659405, 0.035640761256218, 0.0354683585464954, 0.0352958627045155, 0.0351233668625355, 0.0349508076906204, 0.0347781591117382, 0.0346055068075657, 0.034432765096426, 0.0342599898576736, 0.0340871512889862, 0.0339142829179764, 0.0337413512170315, 0.0335683934390545, 0.0333953388035297, 0.033222284168005, 0.0330491364002228, 0.0328759588301182, 0.0327027179300785, 0.0325294472277164, 0.032356146723032, 0.0321827493607998, 0.0320093557238579, 0.0318358354270458, 0.0316623449325562, 0.0314887315034866, 0.0313151180744171, 0.0311414133757353, 0.0309677086770535, 0.030793908983469, 0.0306201092898846, 0.0304461866617203, 0.0302722956985235, 0.0300982799381018, 0.0299242939800024, 0.0297502465546131, 0.0295760743319988, 0.0294019039720297, 0.0292276684194803, 0.0290534049272537, 0.0288790501654148, 0.0287046916782856, 0.0285302083939314, 0.0283557586371899, 0.0281812138855457, 0.0280066393315792, 0.0278319716453552, 0.0276573374867439, 0.0274825748056173, 0.027307815849781, 0.0271329917013645, 0.0269580744206905, 0.0267831590026617, 0.0266081485897303, 0.0264331419020891, 0.0262580383569002, 0.0260829050093889, 0.0259077101945877, 0.025732483714819, 0.0255571939051151, 0.0253818761557341, 0.0252064634114504, 0.0250310506671667, 0.0248555764555931, 0.024680009111762, 0.0245044399052858, 0.0243287812918425, 0.0241531189531088, 0.0239773653447628, 0.0238016117364168, 0.0236257333308458, 0.02344985678792, 0.0232739150524139, 0.0230979453772306, 0.0229218807071447, 0.022745817899704, 0.0225696284323931, 0.0223934706300497, 0.0222172513604164, 0.0220409389585257, 0.0218646284192801, 0.0216882228851318, 0.0215117856860161, 0.0213352870196104, 0.0211587566882372, 0.0209821350872517, 0.020805511623621, 0.020628796890378, 0.0204520802944899, 0.0202752724289894, 0.0200984627008438, 0.0199215300381184, 0.0197445973753929, 0.0195676311850548, 0.0193905737251043, 0.0192134883254766, 0.0190363358706236, 0.0188591554760933, 0.0186818819493055, 0.0185046065598726, 0.0183272399008274, 0.0181498732417822, 0.0179724115878344, 0.0177949517965317, 0.017617367208004, 0.0174398124217987, 0.0172621365636587, 0.017084488645196, 0.0169067494571209, 0.0167289469391108, 0.0165511146187782, 0.0163731891661882, 0.0161952618509531, 0.0160172432661057, 0.0158392246812582, 0.0156610812991858, 0.0154829695820808, 0.0153047330677509, 0.0151265282183886, 0.0149481985718012, 0.0147698689252138, 0.0145915085449815, 0.0144130242988467, 0.0142345391213894, 0.0140559626743197, 0.0138774160295725, 0.0136987138539553, 0.0135200433433056, 0.0133412797003984, 0.0131624853238463, 0.0129836285486817, 0.0128047401085496, 0.0126257594674826, 0.012446777895093, 0.0122677041217685, 0.012088630348444, 0.011909494176507, 0.0117302658036351, 0.0115510355681181, 0.0113717140629888, 0.0111923916265368, 0.0110129760578275, 0.0108335297554731, 0.0106540219858289, 0.0104744816198945, 0.0102948490530252, 0.010115216486156, 0.00993549078702927, 0.00975576508790255, 0.00957594625651836, 0.00939609669148922, 0.00921621639281511, 0.00903624203056097, 0.00885626766830683, 0.00867616944015026, 0.00849610287696123, 0.0083159115165472, 0.00813575182110071, 0.00795546732842922, 0.00777518330141902, 0.00759477494284511, 0.00741439778357744, 0.00723392749205232, 0.00705342553555965, 0.00687292451038957, 0.00669226795434952, 0.00651164213195443, 0.00633089290931821, 0.00615017395466566, 0.00596933159977198, 0.00578851951286197, 0.00560758356004953, 0.0054266476072371, 0.00524561898782849, 0.00506455916911364, 0.00488343695178628, 0.00470228400081396, 0.00452106911689043, 0.00433985376730561, 0.00415857648476958, 0.00397717533633113, 0.00379580515436828, 0.00361431064084172, 0.00343281636014581, 0.00325122871436179, 0.00306964130140841, 0.00288796075619757, 0.00270628021098673, 0.00252447533421218, 0.00234270165674388, 0.00216080411337316, 0.00197890633717179, 0.00179694639518857, 0.00161495560314506, 0.0014329026453197, 0.0012507566716522, 0.00106861058156937, 0.000886402558535337, 0.000704132427927107, 0.000521800189744681, 0.000339468038873747, 0.000157042755745351, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011, 0.0401918515563011   }, 
}; 

// background map
float ReadLikelihood::fRefB[][10000] = 
{ 
   { 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 0.0017563016, 1.8577666e-05, 4.6279758e-05, 7.4022952e-05, 0.00010176616, 0.00012959156, 0.00015733474, 0.00018516014, 0.00021298554, 0.00024085204, 0.00026867742, 0.00029658503, 0.00032445154, 0.00035235914, 0.00038030784, 0.00040825654, 0.00043624634, 0.00046419507, 0.00049222598, 0.00052021578, 0.00054828776, 0.00057635974, 0.00060439063, 0.00063250377, 0.00066061685, 0.00068872998, 0.00071684306, 0.00074503839, 0.00077319262, 0.00080142898, 0.0008296654, 0.00085786072, 0.00088609714, 0.00091437466, 0.00094269327, 0.00097092957, 0.00099928933, 0.0010276079, 0.0010559676, 0.0010843684, 0.0011127283, 0.0011411702, 0.001169571, 0.0011980539, 0.0012264958, 0.0012549788, 0.0012834618, 0.001311986, 0.0013405101, 0.0013690754, 0.0013976404, 0.0014262057, 0.0014548532, 0.0014834184, 0.001512107, 0.0015407132, 0.0015694428, 0.0015980903, 0.0016268198, 0.0016555495, 0.0016842791, 0.001713091, 0.0017418206, 0.0017706325, 0.0017994443, 0.0018282973, 0.0018571501, 0.0018860028, 0.0019149381, 0.0019437911, 0.0019727673, 0.0020016613, 0.0020306376, 0.0020595726, 0.0020885901, 0.0021176483, 0.0021466245, 0.0021757241, 0.0022047414, 0.002233841, 0.0022629406, 0.0022920812, 0.0023211807, 0.0023503623, 0.0023795031, 0.0024087259, 0.0024379487, 0.0024671305, 0.0024963946, 0.0025256171, 0.0025549224, 0.0025841861, 0.0026135321, 0.0026428374, 0.0026721836, 0.0027015295, 0.0027309582, 0.0027603863, 0.0027897735, 0.0028192019, 0.0028486303, 0.0028781407, 0.0029076512, 0.0029371209, 0.0029666724, 0.002996183, 0.0030257758, 0.0030553273, 0.0030849611, 0.0031145129, 0.0031441876, 0.0031738626, 0.0032034966, 0.0032332125, 0.0032628875, 0.0032926034, 0.0033223196, 0.003352118, 0.0033818751, 0.0034116732, 0.0034414304, 0.0034713107, 0.0035011503, 0.0035309894, 0.00356087, 0.0035907505, 0.003620713, 0.0036505936, 0.0036805973, 0.0037105188, 0.0037405228, 0.0037704853, 0.00380053, 0.0038306161, 0.0038606196, 0.003890747, 0.0039207917, 0.0039509186, 0.0039810869, 0.0040111728, 0.0040413821, 0.0040715095, 0.0041017183, 0.0041319276, 0.0041621779, 0.0041924287, 0.0042227199, 0.0042530112, 0.0042833029, 0.0043136352, 0.0043439269, 0.0043743001, 0.0044046743, 0.004435089, 0.0044654626, 0.0044959183, 0.0045263334, 0.00455683, 0.0045873271, 0.0046177828, 0.0046483208, 0.0046788594, 0.004709397, 0.0047399765, 0.0047705555, 0.004801135, 0.004831796, 0.0048624161, 0.0048930775, 0.00492378, 0.0049544415, 0.0049851853, 0.0050158878, 0.0050466722, 0.0050774566, 0.0051082005, 0.0051390263, 0.0051698107, 0.005200678, 0.0052315034, 0.0052623707, 0.005293237, 0.0053241863, 0.0053550946, 0.0053860433, 0.0054170336, 0.0054479828, 0.005478973, 0.0055099633, 0.0055410354, 0.0055720252, 0.0056031393, 0.0056341705, 0.0056652841, 0.0056964383, 0.0057275519, 0.0057587479, 0.0057898611, 0.0058210976, 0.0058522937, 0.0058834893, 0.0059147258, 0.0059460038, 0.0059773228, 0.0060085594, 0.0060399198, 0.0060712388, 0.0061025992, 0.0061339587, 0.0061653601, 0.006196761, 0.0062281624, 0.0062596048, 0.0062910467, 0.0063225301, 0.0063540139, 0.0063855383, 0.0064170216, 0.0064485869, 0.0064801942, 0.0065117185, 0.0065433253, 0.006574932, 0.0066065798, 0.0066382275, 0.0066699162, 0.006701564, 0.0067332531, 0.0067649828, 0.006796754, 0.0068284841, 0.0068602553, 0.0068920674, 0.0069238385, 0.0069556921, 0.0069875042, 0.0070193983, 0.0070512518, 0.0070831869, 0.0071151233, 0.0071470174, 0.0071789934, 0.0072109289, 0.0072429469, 0.0072749234, 0.0073069823, 0.0073390407, 0.0073710592, 0.0074031581, 0.0074352175, 0.0074673588, 0.0074994583, 0.0075315996, 0.0075637405, 0.0075959638, 0.0076281866, 0.0076603689, 0.0076925922, 0.0077248565, 0.0077571208, 0.007789385, 0.0078217313, 0.007854037, 0.0078863837, 0.0079186885, 0.0079511171, 0.0079835057, 0.0080158934, 0.008048363, 0.0080807908, 0.0081132613, 0.0081457309, 0.0081782416, 0.0082107531, 0.0082432637, 0.0082758572, 0.0083084088, 0.0083410023, 0.0083735948, 0.0084062293, 0.0084388629, 0.0084715383, 0.0085041737, 0.0085368901, 0.0085696056, 0.0086023221, 0.0086351205, 0.0086678378, 0.0087006362, 0.0087334346, 0.0087662749, 0.0087991143, 0.0088319536, 0.0088648349, 0.0088977152, 0.0089306375, 0.0089635178, 0.008996482, 0.0090294443, 0.0090624075, 0.0090954108, 0.009128416, 0.0091614602, 0.0091945063, 0.0092275925, 0.0092606368, 0.0092937648, 0.0093268519, 0.00936002, 0.0093931472, 0.0094263563, 0.0094595663, 0.0094927354, 0.0095259864, 0.0095591955, 0.0095924875, 0.0096257385, 0.0096590295, 0.0096923625, 0.0097256964, 0.0097590294, 0.0097924033, 0.0098258182, 0.0098591922, 0.0098926481, 0.009926022, 0.0099595189, 0.0099930167, 0.010026474, 0.010060011, 0.010093508, 0.010127089, 0.010160627, 0.010194207, 0.010227786, 0.010261407, 0.010295027, 0.01032869, 0.010362391, 0.010396054, 0.010429756, 0.010463459, 0.010497244, 0.010530948, 0.010564773, 0.010598517, 0.010632344, 0.01066621, 0.010700037, 0.010733904, 0.010767772, 0.010801679, 0.010835588, 0.010869537, 0.010903446, 0.010937436, 0.010971385, 0.011005417, 0.011039449, 0.01107348, 0.011107554, 0.011141626, 0.01117574, 0.011209854, 0.011243967, 0.011278123, 0.011312278, 0.011346474, 0.011380629, 0.011414866, 0.011449103, 0.011483382, 0.01151766, 0.011551938, 0.011586257, 0.011620536, 0.011654896, 0.011689215, 0.011723617, 0.011758018, 0.01179242, 0.011826863, 0.011861306, 0.011895789, 0.011930273, 0.011964756, 0.011999241, 0.012033806, 0.012068331, 0.012102938, 0.012137504, 0.012172152, 0.012206718, 0.012241407, 0.012276055, 0.012310704, 0.012345434, 0.012380124, 0.012414854, 0.012449625, 0.012484397, 0.01251921, 0.01255394, 0.012588793, 0.012623606, 0.012658501, 0.012693354, 0.012728249, 0.012763184, 0.01279808, 0.012833057, 0.012867993, 0.012902969, 0.012937946, 0.012973006, 0.013007984, 0.013043042, 0.013078101, 0.013113202, 0.013148343, 0.013183443, 0.013218584, 0.013253685, 0.013288909, 0.013324091, 0.013359315, 0.013394497, 0.013429762, 0.013465026, 0.013500291, 0.013535637, 0.013570903, 0.01360625, 0.013641596, 0.013676984, 0.013712373, 0.013747761, 0.013783189, 0.013818619, 0.013854089, 0.01388956, 0.013925071, 0.01396054, 0.013996093, 0.014031645, 0.014067197, 0.014102791, 0.014138344, 0.014174018, 0.014209612, 0.014245288, 0.014280924, 0.01431664, 0.014352316, 0.014388074, 0.01442379, 0.014459549, 0.014495348, 0.014531106, 0.014566944, 0.014602744, 0.014638625, 0.014674423, 0.014710346, 0.014746228, 0.01478215, 0.014818113, 0.014854035, 0.01489004, 0.014926004, 0.014962007, 0.014998054, 0.015034058, 0.015070145, 0.015106191, 0.015142318, 0.015178405, 0.015214574, 0.015250701, 0.01528687, 0.015323081, 0.01535925, 0.01539546, 0.015431711, 0.015467961, 0.015504212, 0.015540505, 0.015576798, 0.015613172, 0.015649464, 0.01568584, 0.015722254, 0.015758628, 0.015795043, 0.015831459, 0.015867915, 0.015904373, 0.015940871, 0.015977327, 0.016013866, 0.016050445, 0.016086984, 0.016123565, 0.016160103, 0.016196765, 0.016233345, 0.016270008, 0.016306669, 0.016343372, 0.016380077, 0.016416738, 0.016453523, 0.016490227, 0.016527012, 0.016563756, 0.016600583, 0.016637452, 0.016674235, 0.016711146, 0.01674797, 0.01678488, 0.016821789, 0.016858697, 0.016895646, 0.016932597, 0.016969588, 0.01700658, 0.017043611, 0.017080644, 0.017117716, 0.017154748, 0.017191863, 0.017228937, 0.01726605, 0.017303165, 0.01734036, 0.017377557, 0.017414711, 0.017451949, 0.017489146, 0.017526425, 0.017563663, 0.017600982, 0.01763822, 0.01767558, 0.017712859, 0.017750261, 0.017787622, 0.017824981, 0.017862424, 0.017899828, 0.017937271, 0.017974755, 0.018012198, 0.018049724, 0.018087206, 0.018124733, 0.018162258, 0.018199865, 0.018237431, 0.018275037, 0.018312605, 0.018350296, 0.018387944, 0.018425591, 0.018463282, 0.018500971, 0.018538743, 0.018576434, 0.018614246, 0.018651977, 0.018689791, 0.018727643, 0.018765416, 0.018803269, 0.018841125, 0.018879019, 0.018916914, 0.018954849, 0.018992744, 0.019030722, 0.019068658, 0.019106677, 0.019144695, 0.019182716, 0.019220775, 0.019258792, 0.019296892, 0.019335033, 0.019373093, 0.019411236, 0.019449377, 0.01948756, 0.019525703, 0.019563926, 0.01960215, 0.019640416, 0.019678598, 0.019716905, 0.019755211, 0.019793516, 0.019831864, 0.019870169, 0.019908559, 0.019946907, 0.019985335, 0.020023724, 0.020062154, 0.020100623, 0.020139094, 0.020177566, 0.020216035, 0.020254588, 0.0202931, 0.020331694, 0.020370245, 0.020408839, 0.020447433, 0.02048607, 0.020524746, 0.020563379, 0.020602055, 0.020640731, 0.020679489, 0.020718208, 0.020756966, 0.020795723, 0.020834481, 0.020873323, 0.020912122, 0.020950962, 0.020989802, 0.021028684, 0.021067567, 0.021106489, 0.021145454, 0.021184376, 0.021223338, 0.021262303, 0.021301307, 0.021340312, 0.021379357, 0.021418404, 0.021457491, 0.021496579, 0.021535665, 0.021574793, 0.021613922, 0.021653092, 0.021692261, 0.02173147, 0.021770641, 0.021809891, 0.021849101, 0.021888396, 0.021927688, 0.021966981, 0.022006312, 0.022045605, 0.022084981, 0.022124356, 0.02216373, 0.022203147, 0.022242561, 0.022282019, 0.022321476, 0.022360975, 0.022400431, 0.02243997, 0.022479469, 0.022519009, 0.02255863, 0.022598168, 0.02263779, 0.022677371, 0.022717034, 0.022756655, 0.022796357, 0.02283602, 0.022875724, 0.022915469, 0.022955213, 0.022994999, 0.023034744, 0.023074571, 0.023114355, 0.023154182, 0.023194009, 0.023233877, 0.023273747, 0.023313656, 0.023353606, 0.023393515, 0.023433506, 0.023473457, 0.023513447, 0.023553479, 0.02359347, 0.023633543, 0.023673577, 0.023713691, 0.023753764, 0.02379388, 0.023833994, 0.023874151, 0.023914348, 0.023954503, 0.023994742, 0.024034936, 0.024075175, 0.024115412, 0.024155693, 0.024195973, 0.024236292, 0.024276612, 0.024316972, 0.024357334, 0.024397695, 0.024438098, 0.024478499, 0.024518944, 0.024559386, 0.024599871, 0.024640314, 0.02468084, 0.024721324, 0.024761891, 0.024802499, 0.024843024, 0.024883632, 0.024924241, 0.02496489, 0.025005497, 0.025046187, 0.025086878, 0.025127526, 0.025168298, 0.025208989, 0.025249761, 0.025290491, 0.025331305, 0.025372118, 0.025412932, 0.025453787, 0.025494641, 0.025535494, 0.02557639, 0.025617328, 0.025658222, 0.0256992, 0.025740137, 0.025781116, 0.025822135, 0.025863152, 0.025904171, 0.02594519, 0.025986291, 0.026027391, 0.026068492, 0.026109595, 0.026150735, 0.026191879, 0.026233062, 0.026274286, 0.026315469, 0.026356734, 0.026397958, 0.026439223, 0.026480488, 0.026521796, 0.026563102, 0.026604449, 0.026645839, 0.026687186, 0.026728576, 0.026769964, 0.026811393, 0.026852865, 0.026894296, 0.026935806, 0.026977278, 0.02701881, 0.027060302, 0.027101874, 0.027143428, 0.027185002, 0.027226597, 0.027268233, 0.027309887, 0.027351523, 0.0273932, 0.027434876, 0.027476594, 0.027518312, 0.02756007, 0.027601788, 0.027643587, 0.027685367, 0.027727187, 0.02776905, 0.027810868, 0.027852751, 0.027894612, 0.027936535, 0.027978439, 0.02802038, 0.028062325, 0.028104309, 0.028146314, 0.028188298, 0.028230345, 0.02827237, 0.028314438, 0.028356547, 0.028398633, 0.028440742, 0.028482869, 0.028525017, 0.028567169, 0.028609378, 0.028651569, 0.028693801, 0.02873601, 0.028778285, 0.028820578, 0.028862851, 0.028905163, 0.028947478, 0.028989831, 0.029032186, 0.029074583, 0.029116955, 0.029159395, 0.02920185, 0.029244266, 0.029286744, 0.029329224, 0.02937174, 0.02941424, 0.0294568, 0.029499341, 0.029541921, 0.029584501, 0.029627101, 0.029669765, 0.029712386, 0.029755071, 0.029797735, 0.029840438, 0.029883184, 0.029925887, 0.029968651, 0.030011415, 0.030054204, 0.030096989, 0.030139837, 0.030182645, 0.030225534, 0.030268382, 0.03031129, 0.03035422, 0.030397132, 0.0304401, 0.030483032, 0.030526046, 0.030569013, 0.030612046, 0.030655058, 0.030698135, 0.030741207, 0.030784281, 0.030827416, 0.030870512, 0.030913666, 0.030956803, 0.030999999, 0.031043155, 0.031086396, 0.031129614, 0.03117287, 0.03121615, 0.03125941, 0.031302731, 0.031346027, 0.031389371, 0.031432755, 0.031476095, 0.031519517, 0.031562898, 0.031606343, 0.031649765, 0.031693231, 0.031736694, 0.031780198, 0.031823684, 0.031867255, 0.031910799, 0.031954348, 0.031997956, 0.032041542, 0.032085169, 0.0321288, 0.032172468, 0.032216094, 0.032259807, 0.032303561, 0.032347251, 0.032391004, 0.032434735, 0.032478549, 0.032522321, 0.032566156, 0.032609969, 0.032653823, 0.032697659, 0.032741576, 0.03278549, 0.032829385, 0.032873347, 0.032917283, 0.032961261, 0.033005279, 0.033049278, 0.033093296, 0.033137336, 0.033181418, 0.033225458, 0.03326958, 0.03331368, 0.033357821, 0.033401944, 0.033446148, 0.033490352, 0.033534516, 0.033578761, 0.033622984, 0.033667251, 0.033711519, 0.033755824, 0.03380011, 0.033844437, 0.033888828, 0.033933155, 0.033977542, 0.034021933, 0.03406636, 0.034110773, 0.034155246, 0.034199692, 0.034244187, 0.034288656, 0.034333233, 0.034377787, 0.034422297, 0.034466892, 0.034511466, 0.034556106, 0.034600716, 0.034645375, 0.034690052, 0.034734707, 0.034779422, 0.034824122, 0.034868881, 0.034913599, 0.034958396, 0.035003159, 0.035047982, 0.035092823, 0.035137638, 0.035182524, 0.035227362, 0.035272289, 0.035317171, 0.035362117, 0.035407037, 0.035452023, 0.035497028, 0.035542015, 0.035587039, 0.035632044, 0.035677135, 0.035722181, 0.035767291, 0.035812374, 0.035857506, 0.035902634, 0.035947803, 0.035993014, 0.036038186, 0.036083393, 0.036128607, 0.036173902, 0.036219131, 0.036264427, 0.036309738, 0.036355034, 0.036400408, 0.036445744, 0.036491118, 0.036536474, 0.036581911, 0.036627308, 0.036672767, 0.036718264, 0.036763702, 0.036809221, 0.036854718, 0.036900278, 0.036945798, 0.03699138, 0.03703694, 0.037082564, 0.037128206, 0.037173808, 0.037219491, 0.037265133, 0.037310857, 0.037356544, 0.037402287, 0.037447993, 0.037493777, 0.037539523, 0.037585352, 0.03763118, 0.037676986, 0.037722856, 0.037768703, 0.037814613, 0.037860502, 0.037906431, 0.037952341, 0.037998311, 0.038044307, 0.038090277, 0.038136311, 0.038182322, 0.038228378, 0.038274471, 0.038320523, 0.038366642, 0.038412716, 0.038458873, 0.038505007, 0.038551185, 0.03859736, 0.03864358, 0.038689777, 0.038736038, 0.038782317, 0.038828574, 0.038874876, 0.038921155, 0.038967516, 0.03901384, 0.03906022, 0.039106585, 0.039152987, 0.039199367, 0.039245855, 0.039292317, 0.039338741, 0.039385267, 0.039432947, 0.039481867, 0.039530765, 0.039579704, 0.039628647, 0.039677586, 0.039726593, 0.039775565, 0.039824557, 0.039873559, 0.039922584, 0.039971635, 0.040020667, 0.040069733, 0.040118799, 0.040167894, 0.040216997, 0.040266104, 0.040315211, 0.040364366, 0.040413503, 0.040462669, 0.040511858, 0.040561035, 0.040610243, 0.040659439, 0.040708669, 0.040757917, 0.04080718, 0.040856428, 0.040905721, 0.040954996, 0.041004322, 0.041053653, 0.041102976, 0.041152313, 0.041201655, 0.04125106, 0.041300423, 0.041349828, 0.041399229, 0.041448656, 0.041498106, 0.041547541, 0.041597009, 0.041646451, 0.041695949, 0.041745484, 0.041794971, 0.041844498, 0.041894022, 0.04194358, 0.041993149, 0.042042736, 0.042092316, 0.042141922, 0.042191524, 0.042241182, 0.042290822, 0.042340461, 0.04239013, 0.042439815, 0.042489495, 0.042539217, 0.042588942, 0.042638659, 0.042688407, 0.042738158, 0.042787939, 0.042837724, 0.042887509, 0.042937323, 0.042987134, 0.043036994, 0.043086838, 0.043136694, 0.04318656, 0.043236446, 0.043286383, 0.04333628, 0.043386206, 0.043436136, 0.043486081, 0.043536082, 0.043586038, 0.043636039, 0.043686029, 0.043736048, 0.043786082, 0.043836121, 0.04388617, 0.043936241, 0.043986313, 0.044036426, 0.044086538, 0.04413664, 0.044186782, 0.044236913, 0.0442871, 0.044337258, 0.044387449, 0.044437632, 0.044487838, 0.044538103, 0.04458832, 0.044638578, 0.044688821, 0.044739097, 0.044789378, 0.044839706, 0.044890013, 0.044940341, 0.044990659, 0.045041017, 0.045091406, 0.045141768, 0.045192167, 0.045242555, 0.045292988, 0.045343406, 0.045393869, 0.045444332, 0.045494795, 0.045545261, 0.04559578, 0.045646284, 0.045696791, 0.045747329, 0.04579787, 0.045848448, 0.04589903, 0.045949593, 0.046000209, 0.046050798, 0.046101443, 0.046152066, 0.046202727, 0.046253376, 0.046304051, 0.046354763, 0.046405457, 0.046456177, 0.046506885, 0.046557639, 0.046608403, 0.046659164, 0.046709936, 0.046760734, 0.046811525, 0.04686236, 0.046913199, 0.046964031, 0.047014903, 0.047065753, 0.047116652, 0.047167543, 0.047218468, 0.047269393, 0.047320317, 0.047371268, 0.047422227, 0.0474732, 0.047524177, 0.047575168, 0.047626179, 0.047677226, 0.047728274, 0.047779299, 0.047830377, 0.047881447, 0.047932554, 0.047983635, 0.048034765, 0.048085872, 0.048137031, 0.048188206, 0.048239358, 0.048290547, 0.048341729, 0.04839294, 0.048444152, 0.048495393, 0.048546627, 0.04859788, 0.04864914, 0.048700456, 0.04875176, 0.048803054, 0.048854381, 0.048905708, 0.04895705, 0.049008425, 0.049059816, 0.049111169, 0.049162578, 0.049214005, 0.049265433, 0.049316879, 0.049368318, 0.049419798, 0.049471248, 0.049522776, 0.049574282, 0.049625773, 0.049677312, 0.049728848, 0.049780414, 0.049831972, 0.049883559, 0.04993514, 0.049986746, 0.050038397, 0.050090011, 0.050141666, 0.050193317, 0.050245002, 0.050296687, 0.050348394, 0.050400075, 0.050451811, 0.050503541, 0.050555315, 0.050607082, 0.050658841, 0.050710626, 0.050762422, 0.050814256, 0.05086606, 0.05091792, 0.050969746, 0.051021621, 0.051073484, 0.051125403, 0.051177319, 0.05122922, 0.051281162, 0.051333092, 0.05138506, 0.051437035, 0.051489007, 0.051541012, 0.051593002, 0.051645059, 0.051697068, 0.051749125, 0.051801182, 0.051853247, 0.05190536, 0.051957447, 0.052009564, 0.05206167, 0.052113812, 0.052165966, 0.052218128, 0.052270297, 0.052322499, 0.052374683, 0.052426919, 0.052479163, 0.052531384, 0.052583642, 0.052635893, 0.052688204, 0.052740473, 0.052792795, 0.052845094, 0.052897438, 0.052949801, 0.053002156, 0.053054515, 0.053106889, 0.053159293, 0.053211685, 0.053264119, 0.053316563, 0.053369001, 0.053421475, 0.053473931, 0.053526439, 0.053578924, 0.053631451, 0.053683955, 0.053736504, 0.053789075, 0.053841621, 0.053894207, 0.053946789, 0.053999398, 0.054052018, 0.054104656, 0.054157276, 0.054209948, 0.054262586, 0.054315288, 0.054367993, 0.054420684, 0.054473415, 0.054526135, 0.054578904, 0.054631643, 0.054684419, 0.054737192, 0.054789998, 0.054842819, 0.054895636, 0.054948483, 0.055001315, 0.055054184, 0.055107079, 0.055159956, 0.055212867, 0.055265762, 0.055318691, 0.055371627, 0.055424593, 0.055477556, 0.055530533, 0.055583511, 0.055636521, 0.055689551, 0.055742573, 0.055795614, 0.055848654, 0.055901736, 0.055954818, 0.056007922, 0.056061026, 0.056114145, 0.056167264, 0.056220438, 0.056273594, 0.056326751, 0.056379944, 0.05643313, 0.056486364, 0.056539573, 0.056592818, 0.056646068, 0.056699324, 0.056752626, 0.056805905, 0.056859192, 0.056912497, 0.056965832, 0.05701917, 0.057072535, 0.057125911, 0.05717928, 0.05723267, 0.05728608, 0.057339512, 0.057392921, 0.057446372, 0.057499819, 0.057553288, 0.057606805, 0.057660282, 0.057713799, 0.057767306, 0.057820849, 0.0578744, 0.057927951, 0.057981525, 0.058035113, 0.058088705, 0.05814233, 0.058195971, 0.058249582, 0.058303233, 0.058356885, 0.058410596, 0.058464266, 0.058517974, 0.05857167, 0.058625411, 0.058679182, 0.058732916, 0.058786687, 0.058840446, 0.058894251, 0.058948062, 0.059001882, 0.059055731, 0.059109561, 0.059163429, 0.059217308, 0.059271168, 0.059325065, 0.059378974, 0.059432905, 0.059486825, 0.059540786, 0.059594747, 0.05964873, 0.059702732, 0.059756719, 0.059810732, 0.059864759, 0.05991878, 0.059972838, 0.060026906, 0.060080994, 0.060135093, 0.06018918, 0.060243301, 0.060297441, 0.060351577, 0.060405724, 0.060459897, 0.060514074, 0.060568273, 0.060622476, 0.060676701, 0.06073093, 0.060785171, 0.060839441, 0.060893714, 0.060948003, 0.061002284, 0.061056599, 0.061110929, 0.061165269, 0.061219625, 0.061273973, 0.061328348, 0.061382744, 0.06143713, 0.061491553, 0.061545983, 0.061600439, 0.061654888, 0.061709337, 0.061763827, 0.061818328, 0.061872803, 0.061927319, 0.061981868, 0.062036391, 0.062090982, 0.062145531, 0.062200107, 0.062254716, 0.062309314, 0.06236393, 0.062418588, 0.06247323, 0.062527888, 0.062582552, 0.06263724, 0.062691949, 0.062746637, 0.062801383, 0.062856123, 0.06291087, 0.062965631, 0.063020408, 0.0630752, 0.063129991, 0.063184828, 0.063239627, 0.063294478, 0.063349336, 0.063404188, 0.063459098, 0.063513987, 0.06356889, 0.063623816, 0.063678734, 0.063733675, 0.063788645, 0.0638436, 0.063898586, 0.063953578, 0.064008571, 0.064063631, 0.064118646, 0.064173698, 0.064228766, 0.064283818, 0.064338915, 0.064394012, 0.064449139, 0.064504266, 0.064559385, 0.064614549, 0.064669728, 0.0647249, 0.064780064, 0.06483528, 0.064890504, 0.06494572, 0.065000966, 0.065056235, 0.065111503, 0.065166786, 0.065222062, 0.065277375, 0.065332703, 0.065388016, 0.065443374, 0.065498725, 0.065554097, 0.065609492, 0.065664873, 0.065720297, 0.065775715, 0.065831132, 0.065886579, 0.065942064, 0.065997541, 0.066053033, 0.066108517, 0.066164032, 0.066219576, 0.066275097, 0.066330656, 0.066386223, 0.066441812, 0.066497415, 0.066552997, 0.066608615, 0.066664256, 0.066719897, 0.066775523, 0.066831209, 0.066886902, 0.066942573, 0.06699831, 0.067054011, 0.067109749, 0.067165494, 0.067221254, 0.067277022, 0.067332819, 0.067388602, 0.067444436, 0.067500249, 0.067556091, 0.067611933, 0.067667797, 0.067723677, 0.067779563, 0.067835465, 0.067891382, 0.067947306, 0.068003252, 0.068059191, 0.068115152, 0.068171136, 0.068227135, 0.068283156, 0.068339147, 0.068395197, 0.068451233, 0.068507299, 0.06856335, 0.068619438, 0.068675548, 0.068731651, 0.068787768, 0.068843894, 0.068900064, 0.068956204, 0.069012403, 0.069068566, 0.069124781, 0.069180988, 0.069237202, 0.069293439, 0.069349691, 0.069405943, 0.069462247, 0.069518521, 0.069574825, 0.069631159, 0.069687463, 0.069743805, 0.069800168, 0.069856524, 0.06991291, 0.069969311, 0.07002572, 0.070082135, 0.070138559, 0.070195012, 0.070251472, 0.070307948, 0.070364423, 0.070420928, 0.070477434, 0.070533961, 0.070590496, 0.070647031, 0.070703588, 0.070760176, 0.070816733, 0.070873357, 0.070929974, 0.070986576, 0.071043238, 0.071099877, 0.071156561, 0.071213223, 0.071269907, 0.071326613, 0.071383335, 0.071440056, 0.071496829, 0.071553566, 0.071610332, 0.071667127, 0.071723908, 0.071780711, 0.071837544, 0.071894363, 0.071951203, 0.072008058, 0.072064936, 0.072121836, 0.072178714, 0.072235636, 0.072292566, 0.072349489, 0.072406441, 0.072463401, 0.072520383, 0.07257738, 0.072634391, 0.072691388, 0.072748423, 0.072805464, 0.072862506, 0.072919577, 0.072976649, 0.073033728, 0.073090866, 0.073147953, 0.073205099, 0.073262237, 0.073319376, 0.073376559, 0.073433757, 0.073490918, 0.073548123, 0.073605359, 0.073662601, 0.073719844, 0.073777087, 0.073834375, 0.07389167, 0.073948972, 0.074006267, 0.074063599, 0.074120931, 0.074178301, 0.074235663, 0.074293025, 0.074350417, 0.074407823, 0.074465238, 0.074522667, 0.074580103, 0.074637525, 0.074695028, 0.074752495, 0.074809991, 0.074867502, 0.074925013, 0.074982539, 0.075040095, 0.075097635, 0.075155228, 0.075212792, 0.075270392, 0.075328015, 0.075385623, 0.075443268, 0.07550092, 0.075558566, 0.075616241, 0.075673923, 0.075731635, 0.075789347, 0.075847059, 0.075904801, 0.075962551, 0.076020323, 0.076078095, 0.076135874, 0.07619369, 0.076251507, 0.076309346, 0.076367162, 0.076425023, 0.076482907, 0.076540776, 0.076598682, 0.07665658, 0.076714493, 0.076772444, 0.076830372, 0.076888338, 0.076946318, 0.077004284, 0.077062286, 0.077120289, 0.077178292, 0.077236362, 0.077294394, 0.077352457, 0.077410541, 0.077468611, 0.077526718, 0.077584833, 0.077642955, 0.077701084, 0.077759244, 0.077817418, 0.077875599, 0.077933766, 0.077991985, 0.078050211, 0.078108452, 0.078166671, 0.078224927, 0.078283213, 0.078341492, 0.078399792, 0.078458086, 0.078516401, 0.078574739, 0.078633077, 0.07869143, 0.078749828, 0.078808181, 0.078866601, 0.078925006, 0.078983434, 0.079041876, 0.079100318, 0.079158776, 0.079217255, 0.079275727, 0.079334259, 0.079392754, 0.079451293, 0.079509839, 0.079568371, 0.079626948, 0.079685539, 0.079744123, 0.079802692, 0.079861328, 0.079919964, 0.079978615, 0.080037281, 0.080095924, 0.08015462, 0.080213323, 0.080272026, 0.080330729, 0.080389477, 0.080448225, 0.080506995, 0.080565758, 0.080624551, 0.080683365, 0.080742151, 0.080800973, 0.080859818, 0.080918655, 0.080977552, 0.081036404, 0.081095293, 0.081154197, 0.081213102, 0.081272036, 0.081330977, 0.081389934, 0.081448905, 0.081507877, 0.08156687, 0.081625886, 0.08168488, 0.081743918, 0.081802987, 0.081862047, 0.081921093, 0.081980184, 0.082039282, 0.082098395, 0.082157522, 0.082216643, 0.0822758, 0.082334958, 0.082394131, 0.082453333, 0.08251252, 0.08257173, 0.082630962, 0.082690187, 0.082749449, 0.082808711, 0.08286798, 0.082927279, 0.082986578, 0.083045878, 0.083105244, 0.08316455, 0.083223924, 0.083283298, 0.083342656, 0.08340206, 0.083461471, 0.083520897, 0.083580345, 0.083639763, 0.083699241, 0.083758712, 0.08381819, 0.083877668, 0.083937183, 0.083996706, 0.084056236, 0.084115781, 0.084175363, 0.084234931, 0.084294535, 0.084354103, 0.084413737, 0.084473372, 0.084532991, 0.08459267, 0.08465232, 0.084712006, 0.084771693, 0.084831387, 0.084891103, 0.084950849, 0.085010558, 0.085070327, 0.08513011, 0.085189879, 0.085249677, 0.085309476, 0.085369296, 0.085429139, 0.085488975, 0.085548833, 0.085608713, 0.085668616, 0.085728511, 0.085788414, 0.085848339, 0.085908279, 0.085968241, 0.086028174, 0.086088166, 0.086148158, 0.086208135, 0.086268172, 0.086328194, 0.08638823, 0.086448304, 0.086508349, 0.08656843, 0.086628526, 0.086688608, 0.086748734, 0.086808868, 0.086869024, 0.086929187, 0.086989336, 0.087049529, 0.087109745, 0.087169923, 0.087230153, 0.087290391, 0.087350644, 0.087410912, 0.087471172, 0.087531455, 0.087591767, 0.087652087, 0.087712392, 0.087772734, 0.087833107, 0.087893426, 0.087953821, 0.0880142, 0.088074617, 0.088135034, 0.088195443, 0.08825589, 0.088316366, 0.088376805, 0.088437326, 0.088497803, 0.088558301, 0.088618822, 0.088679336, 0.088739887, 0.088800453, 0.088861011, 0.088921599, 0.08898221, 0.08904279, 0.089103438, 0.089164063, 0.089224719, 0.089285396, 0.089346044, 0.089406714, 0.089467444, 0.089528158, 0.089588881, 0.08964961, 0.089710362, 0.089771137, 0.089831926, 0.089892693, 0.089953497, 0.090014331, 0.090075135, 0.090136014, 0.090196848, 0.090257719, 0.090318598, 0.090379484, 0.090440392, 0.090501323, 0.090562247, 0.090623207, 0.090684153, 0.090745129, 0.090806119, 0.090867087, 0.090928108, 0.090989143, 0.091050163, 0.091111213, 0.091172278, 0.091233365, 0.091294453, 0.09135554, 0.091416664, 0.091477796, 0.091538958, 0.091600075, 0.091661252, 0.091722436, 0.091783628, 0.091844812, 0.091906048, 0.09196727, 0.092028521, 0.092089757, 0.092151031, 0.092212319, 0.0922736, 0.092334934, 0.092396237, 0.09245757, 0.092518933, 0.092580281, 0.092641652, 0.092703044, 0.09276443, 0.092825867, 0.092887282, 0.09294872, 0.093010165, 0.093071617, 0.093133092, 0.093194596, 0.093256086, 0.093317598, 0.093379125, 0.093440667, 0.093502223, 0.09356378, 0.093625367, 0.093686961, 0.093748577, 0.093810171, 0.093871802, 0.093933463, 0.093995117, 0.094056807, 0.094118461, 0.094180167, 0.094241895, 0.0943036, 0.094365343, 0.094427086, 0.094488822, 0.094550617, 0.09461239, 0.094674215, 0.094736025, 0.09480074, 0.094868414, 0.09493608, 0.095003732, 0.095071413, 0.095139049, 0.0952067, 0.095274322, 0.095341936, 0.09540958, 0.095477164, 0.095544763, 0.095612369, 0.095679939, 0.095747516, 0.095815077, 0.095882639, 0.095950186, 0.096017718, 0.096085265, 0.096152782, 0.096220285, 0.096287794, 0.096355289, 0.096422784, 0.096490249, 0.096557729, 0.096625194, 0.096692652, 0.096760109, 0.096827544, 0.096894972, 0.0969624, 0.097029813, 0.097097211, 0.097164623, 0.097232006, 0.097299397, 0.09736675, 0.097434111, 0.097501487, 0.097568825, 0.097636163, 0.097703494, 0.097770818, 0.097838141, 0.097905435, 0.097972743, 0.098040022, 0.098107293, 0.098174587, 0.098241836, 0.098309085, 0.098376341, 0.098443575, 0.098510824, 0.098578028, 0.09864524, 0.098712459, 0.098779649, 0.098846853, 0.09891402, 0.098981194, 0.099048369, 0.099115521, 0.099182673, 0.099249803, 0.099316932, 0.099384062, 0.099451177, 0.099518284, 0.099585362, 0.099652454, 0.099719547, 0.099786609, 0.099853672, 0.099920742, 0.099987768, 0.10005483, 0.10012186, 0.10018887, 0.10025589, 0.10032289, 0.1003899, 0.10045687, 0.10052385, 0.10059084, 0.1006578, 0.10072476, 0.1007917, 0.10085864, 0.10092559, 0.10099249, 0.10105941, 0.10112631, 0.1011932, 0.10126009, 0.10132697, 0.10139384, 0.10146071, 0.10152757, 0.10159442, 0.10166125, 0.10172807, 0.10179491, 0.10186172, 0.10192853, 0.10199533, 0.10206211, 0.1021289, 0.10219566, 0.10226243, 0.10232919, 0.10239593, 0.10246269, 0.1025294, 0.10259612, 0.10266283, 0.10272953, 0.10279624, 0.10286292, 0.10292961, 0.10299628, 0.10306294, 0.1031296, 0.10319624, 0.10326288, 0.10332951, 0.10339613, 0.10346275, 0.10352935, 0.10359595, 0.10366254, 0.10372912, 0.10379569, 0.10386226, 0.10392881, 0.10399536, 0.10406189, 0.10412841, 0.10419495, 0.10426145, 0.10432797, 0.10439447, 0.10446094, 0.10452743, 0.10459389, 0.10466037, 0.10472681, 0.10479327, 0.10485971, 0.10492613, 0.10499257, 0.10505896, 0.10512537, 0.10519178, 0.10525816, 0.10532454, 0.10539092, 0.10545728, 0.10552362, 0.10558996, 0.10565631, 0.10572264, 0.10578895, 0.10585528, 0.10592158, 0.10598787, 0.10605417, 0.10612044, 0.10618673, 0.10625298, 0.10631923, 0.10638548, 0.10645172, 0.10651796, 0.10658418, 0.10665038, 0.1067166, 0.10678278, 0.10684898, 0.10691517, 0.10698133, 0.1070475, 0.10711364, 0.10717978, 0.10724594, 0.10731205, 0.10737819, 0.10744429, 0.10751039, 0.1075765, 0.10764258, 0.10770868, 0.10777473, 0.10784079, 0.10790686, 0.1079729, 0.10803893, 0.10810497, 0.10817099, 0.10823701, 0.108303, 0.108369, 0.108435, 0.10850097, 0.10856694, 0.10863289, 0.10869884, 0.1087648, 0.10883074, 0.10889668, 0.10896259, 0.1090285, 0.1090944, 0.1091603, 0.1092262, 0.10929208, 0.10935794, 0.10942382, 0.10948966, 0.10955551, 0.10962135, 0.10968716, 0.10975301, 0.1098188, 0.10988461, 0.10995042, 0.1100162, 0.11008197, 0.11014775, 0.11021352, 0.11027927, 0.11034501, 0.11041076, 0.11047647, 0.11054219, 0.11060791, 0.11067361, 0.11073931, 0.11080501, 0.11087067, 0.11093635, 0.11100201, 0.11106767, 0.11113331, 0.11119895, 0.11126459, 0.1113302, 0.11139581, 0.11146142, 0.11152702, 0.11159261, 0.11165818, 0.11172374, 0.11178931, 0.11185486, 0.11192042, 0.11198594, 0.11205147, 0.11211701, 0.11218251, 0.11224801, 0.11231352, 0.11237899, 0.11244448, 0.11250995, 0.1125754, 0.11264087, 0.11270632, 0.11277176, 0.11283718, 0.1129026, 0.11296801, 0.11303341, 0.11309881, 0.11316419, 0.11322957, 0.11329495, 0.1133603, 0.11342566, 0.11349102, 0.11355635, 0.11362168, 0.113687, 0.1137523, 0.11381762, 0.11388291, 0.11394821, 0.11401349, 0.11407875, 0.114144, 0.11420926, 0.11427452, 0.11433975, 0.11440498, 0.11447021, 0.11453541, 0.11460061, 0.11466581, 0.11473099, 0.11479616, 0.11486134, 0.1149265, 0.11499166, 0.1150568, 0.11512195, 0.11518708, 0.11525217, 0.11531731, 0.11538242, 0.11544751, 0.11551259, 0.11557765, 0.11564274, 0.11570781, 0.11577287, 0.11583789, 0.11590294, 0.11596797, 0.116033, 0.11609801, 0.11616299, 0.11622798, 0.11629297, 0.11635796, 0.11642292, 0.11648791, 0.11655284, 0.1166178, 0.11668272, 0.11674765, 0.11681258, 0.11687748, 0.11694239, 0.1170073, 0.11707218, 0.11713706, 0.11720194, 0.1172668, 0.11733165, 0.11739649, 0.11746132, 0.11752615, 0.11759098, 0.11765578, 0.11772058, 0.11778538, 0.11785017, 0.11791493, 0.11797973, 0.11804447, 0.11810923, 0.11817396, 0.11823872, 0.11830346, 0.11836816, 0.11843289, 0.11849758, 0.11856227, 0.11862697, 0.11869165, 0.11875634, 0.11882097, 0.11888561, 0.11895029, 0.1190149, 0.11907953, 0.11914415, 0.11920876, 0.11927337, 0.11933795, 0.11940254, 0.11946712, 0.11953168, 0.11959627, 0.1196608, 0.11972535, 0.1197899, 0.11985443, 0.11991894, 0.11998346, 0.12004796, 0.12011245, 0.12017694, 0.1202414, 0.12030588, 0.12037035, 0.12043481, 0.12049924, 0.12056366, 0.12062812, 0.12069253, 0.12075695, 0.12082133, 0.12088574, 0.12095013, 0.12101451, 0.12107888, 0.12114324, 0.12120758, 0.12127194, 0.12133627, 0.12140061, 0.12146492, 0.12152924, 0.12159353, 0.12165783, 0.12172211, 0.12178639, 0.12185066, 0.12191492, 0.12197916, 0.1220434, 0.12210765, 0.12217187, 0.1222361, 0.12230032, 0.12236451, 0.12242872, 0.1224929, 0.12255708, 0.12262127, 0.12268541, 0.12274957, 0.12281371, 0.12287785, 0.12294197, 0.12300609, 0.12307022, 0.12313431, 0.1231984, 0.12326249, 0.12332656, 0.12339064, 0.12345469, 0.12351874, 0.12358279, 0.12364681, 0.12371086, 0.12377486, 0.12383888, 0.12390289, 0.12396687, 0.12403087, 0.12409484, 0.12415881, 0.12422278, 0.12428672, 0.12435066, 0.12441461, 0.12447853, 0.12454246, 0.12460638, 0.12467027, 0.12473416, 0.12479804, 0.12486193, 0.1249258, 0.12498964, 0.12505352, 0.12511735, 0.1251812, 0.12524502, 0.12530884, 0.12537266, 0.12543646, 0.12550025, 0.12556402, 0.1256278, 0.12569158, 0.12575534, 0.12581909, 0.12588285, 0.12594657, 0.1260103, 0.12607403, 0.12613772, 0.12620144, 0.12626512, 0.12632881, 0.12639248, 0.12645614, 0.12651981, 0.12658346, 0.12664711, 0.12671074, 0.12677437, 0.126838, 0.12690161, 0.12696521, 0.12702879, 0.12709238, 0.12715596, 0.12721954, 0.1272831, 0.12734666, 0.12741017, 0.12747374, 0.12753725, 0.12760077, 0.1276643, 0.12772778, 0.12779129, 0.12785476, 0.12791823, 0.12798171, 0.12804517, 0.12810862, 0.12817207, 0.12823549, 0.12829894, 0.12836234, 0.12842575, 0.12848915, 0.12855256, 0.12861595, 0.12867932, 0.12874268, 0.12880605, 0.12886941, 0.12893274, 0.12899609, 0.1290594, 0.12912273, 0.12918603, 0.12924933, 0.12931263, 0.1293759, 0.1294392, 0.12950246, 0.12956572, 0.12962897, 0.12969223, 0.12975547, 0.12981868, 0.12988189, 0.12994511, 0.1300083, 0.13007152, 0.1301347, 0.13019787, 0.13026103, 0.1303242, 0.13038737, 0.1304505, 0.13051362, 0.13057674, 0.13063988, 0.13070299, 0.13076608, 0.13082917, 0.13089226, 0.13095534, 0.1310184, 0.13108148, 0.13114451, 0.13120757, 0.1312706, 0.1313336, 0.13139665, 0.13145964, 0.13152266, 0.13158566, 0.13164863, 0.1317116, 0.13177459, 0.13183755, 0.1319005, 0.13196343, 0.13202639, 0.13208932, 0.13215223, 0.13221513, 0.13227803, 0.13234091, 0.13240381, 0.13246667, 0.13252954, 0.13259241, 0.13265525, 0.13271812, 0.13278094, 0.13284378, 0.13290659, 0.13296939, 0.1330322, 0.13309497, 0.13315779, 0.13322054, 0.13328335, 0.13334608, 0.13340881, 0.13347158, 0.13353431, 0.13359703, 0.13365977, 0.13372244, 0.13378517, 0.13384785, 0.13391052, 0.13397323, 0.13403589, 0.13409854, 0.1341612, 0.13422383, 0.13428648, 0.13434911, 0.13441172, 0.13447434, 0.13453692, 0.13459952, 0.13466212, 0.13472471, 0.13478725, 0.13484982, 0.13491237, 0.1349749, 0.13503742, 0.13509998, 0.13516247, 0.135225, 0.13528749, 0.13534997, 0.13541247, 0.13547494, 0.13553743, 0.13559988, 0.13566232, 0.13572478, 0.1357872, 0.13584964, 0.13591206, 0.13597447, 0.13603686, 0.13609925, 0.13616164, 0.13622403, 0.13628639, 0.13634875, 0.13641109, 0.13647343, 0.13653576, 0.1365981, 0.13666043, 0.13672273, 0.13678502, 0.13684732, 0.1369096, 0.13697188, 0.13703415, 0.13709641, 0.13715866, 0.1372209, 0.13728315, 0.13734536, 0.13740759, 0.13746981, 0.137532, 0.13759418, 0.13765639, 0.13771853, 0.13778071, 0.13784286, 0.13790502, 0.13796717, 0.13802929, 0.13809143, 0.13815354, 0.13821565, 0.13827774, 0.13833983, 0.13840194, 0.138464, 0.13852607, 0.13858813, 0.13865018, 0.13871221, 0.13877426, 0.13883629, 0.1388983, 0.13896032, 0.13902231, 0.13908432, 0.13914628, 0.13920826, 0.13927022, 0.13933218, 0.13939413, 0.13945608, 0.13951804, 0.13957994, 0.13964185, 0.13970378, 0.13976566, 0.13982758, 0.13988943, 0.13995132, 0.1400132, 0.14007506, 0.1401369, 0.14019875, 0.14026058, 0.1403224, 0.14038421, 0.14044602, 0.14050783, 0.14056963, 0.14063139, 0.14069317, 0.14075494, 0.1408167, 0.14087845, 0.1409402, 0.14100192, 0.14106365, 0.14112538, 0.14118707, 0.14124879, 0.14131048, 0.14137216, 0.14143384, 0.14149551, 0.14155717, 0.14161882, 0.14168046, 0.14174208, 0.14180373, 0.14186533, 0.14192694, 0.14198856, 0.14205013, 0.14211172, 0.14217328, 0.14223486, 0.14229642, 0.14235796, 0.14241952, 0.14248104, 0.14254257, 0.14260408, 0.14266559, 0.14272709, 0.14278859, 0.14285009, 0.14291154, 0.14297302, 0.14303449, 0.14309593, 0.14315738, 0.1432188, 0.14328021, 0.14334165, 0.14340305, 0.14346446, 0.14352584, 0.14358723, 0.14364859, 0.14370996, 0.14377134, 0.14383268, 0.14389402, 0.14395535, 0.14401668, 0.14407799, 0.1441393, 0.14420061, 0.14426191, 0.14432319, 0.14438446, 0.14444573, 0.14450698, 0.14456823, 0.14462946, 0.14469071, 0.14475194, 0.14481315, 0.14487435, 0.14493553, 0.14499675, 0.14505793, 0.14511912, 0.14518027, 0.14524142, 0.14530258, 0.14536373, 0.14542486, 0.14548598, 0.14554709, 0.1456082, 0.14566931, 0.14573039, 0.14579147, 0.14585257, 0.14591362, 0.1459747, 0.14603575, 0.14609677, 0.14615782, 0.14621884, 0.14627984, 0.14634085, 0.14640185, 0.14646284, 0.14652382, 0.14658479, 0.14664577, 0.14670673, 0.14676768, 0.14682862, 0.14688954, 0.14695048, 0.14701138, 0.1470723, 0.14713319, 0.14719409, 0.14725499, 0.14731586, 0.14737673, 0.14743757, 0.14749843, 0.14755927, 0.14762011, 0.14768091, 0.14774175, 0.14780255, 0.14786336, 0.14792414, 0.14798492, 0.1480457, 0.14810646, 0.14816724, 0.14822796, 0.14828871, 0.14834945, 0.14841017, 0.14847089, 0.1485316, 0.14859229, 0.148653, 0.14871366, 0.14877437, 0.14883502, 0.14889567, 0.1489563, 0.14901695, 0.14907756, 0.14913821, 0.14919883, 0.14925945, 0.14932004, 0.14938061, 0.14944121, 0.1495018, 0.14956236, 0.14962292, 0.14968346, 0.149744, 0.14980453, 0.14986506, 0.14992557, 0.14998609, 0.1500466, 0.15010709, 0.15016757, 0.15022802, 0.15028849, 0.15034896, 0.1504094, 0.15046984, 0.15053028, 0.1505907, 0.15065113, 0.15071154, 0.15077192, 0.15083231, 0.15089269, 0.15095307, 0.15101343, 0.15107378, 0.15113415, 0.1511945, 0.15125483, 0.15131515, 0.15137546, 0.15143578, 0.15149607, 0.15155634, 0.15161665, 0.15167692, 0.15173717, 0.15179743, 0.15185767, 0.15191792, 0.15197816, 0.15203838, 0.1520986, 0.1521588, 0.15221901, 0.1522792, 0.15233938, 0.15239955, 0.15245971, 0.15251988, 0.15258002, 0.15264018, 0.15270032, 0.15276043, 0.15282054, 0.15288065, 0.15294075, 0.15300085, 0.15306093, 0.15312098, 0.15318103, 0.1532411, 0.15330118, 0.1533612, 0.15342124, 0.15348127, 0.15354127, 0.15360129, 0.15366128, 0.15372129, 0.15378125, 0.15384123, 0.15390119, 0.15396115, 0.15402111, 0.15408103, 0.15414098, 0.1542009, 0.15426083, 0.15432072, 0.15438063, 0.15444051, 0.1545004, 0.15456027, 0.15462013, 0.15467998, 0.15473983, 0.15479967, 0.15485951, 0.15491933, 0.15497914, 0.15503897, 0.15509877, 0.15515855, 0.15521833, 0.15527812, 0.15533786, 0.15539761, 0.15545738, 0.15551712, 0.15557684, 0.15563658, 0.15569629, 0.155756, 0.15581571, 0.15587538, 0.15593506, 0.15599473, 0.15605441, 0.15611406, 0.15617372, 0.15623334, 0.15629297, 0.15635259, 0.15641223, 0.15647182, 0.15653142, 0.156591, 0.1566506, 0.15671018, 0.15676972, 0.1568293, 0.15688884, 0.15694839, 0.15700792, 0.15706743, 0.15712695, 0.15718646, 0.15724596, 0.15730543, 0.15736492, 0.15742441, 0.15748386, 0.15754333, 0.15760277, 0.15766221, 0.15772164, 0.15778106, 0.15784048, 0.15789989, 0.15795928, 0.15801868, 0.15807806, 0.15813743, 0.15819681, 0.15825614, 0.15831453, 0.15837182, 0.1584291, 0.15848634, 0.15854353, 0.15860069, 0.1586578, 0.15871489, 0.15877196, 0.15882896, 0.15888591, 0.15894286, 0.15899976, 0.15905663, 0.15911344, 0.15917023, 0.159227, 0.15928368, 0.15934037, 0.15939699, 0.1594536, 0.15951017, 0.15956669, 0.15962318, 0.15967964, 0.15973602, 0.15979241, 0.15984875, 0.15990508, 0.15996133, 0.16001754, 0.16007374, 0.16012987, 0.16018598, 0.16024208, 0.16029811, 0.16035412, 0.16041008, 0.160466, 0.16052191, 0.16057774, 0.16063356, 0.16068935, 0.16074508, 0.1608008, 0.16085644, 0.16091208, 0.16096769, 0.16102323, 0.16107874, 0.16113421, 0.16118966, 0.16124506, 0.16130042, 0.16135576, 0.16141105, 0.16146632, 0.16152154, 0.1615767, 0.16163187, 0.16168696, 0.16174202, 0.16179706, 0.16185206, 0.16190702, 0.16196193, 0.16201681, 0.16207166, 0.16212645, 0.16218126, 0.16223596, 0.16229066, 0.16234532, 0.16239993, 0.16245453, 0.16250905, 0.16256356, 0.16261804, 0.16267247, 0.16272688, 0.16278124, 0.16283555, 0.16288985, 0.16294409, 0.16299829, 0.16305248, 0.16310659, 0.16316071, 0.16321476, 0.16326879, 0.16332279, 0.16337672, 0.16343065, 0.16348448, 0.16353834, 0.16359214, 0.16364591, 0.16369963, 0.16375332, 0.16380696, 0.16386057, 0.16391416, 0.16396768, 0.16402119, 0.16407466, 0.16412807, 0.16418146, 0.1642348, 0.16428813, 0.16434141, 0.16439465, 0.16444783, 0.16450101, 0.16455415, 0.16460723, 0.16466027, 0.16471328, 0.16476627, 0.16481921, 0.16487211, 0.16492496, 0.16497782, 0.16503058, 0.16508335, 0.16513607, 0.16518873, 0.16524138, 0.16529399, 0.16534656, 0.16539907, 0.16545157, 0.16550404, 0.16555645, 0.16560882, 0.16566117, 0.16571347, 0.16576575, 0.16581796, 0.16587017, 0.16592231, 0.16597444, 0.16602652, 0.16607855, 0.16613057, 0.16618253, 0.16623448, 0.16628636, 0.16633824, 0.16639005, 0.16644184, 0.16649356, 0.16654529, 0.16659696, 0.16664858, 0.16670018, 0.16675174, 0.16680326, 0.16685475, 0.16690619, 0.16695759, 0.16700897, 0.1670603, 0.16711161, 0.16716288, 0.16721408, 0.16726527, 0.16731641, 0.16736753, 0.16741861, 0.16746964, 0.16752064, 0.16757159, 0.16762254, 0.16767339, 0.16772425, 0.16777506, 0.16782585, 0.16787659, 0.16792727, 0.16797794, 0.16802856, 0.16807915, 0.1681297, 0.16818021, 0.16823068, 0.16828114, 0.16833152, 0.16838191, 0.16843222, 0.16848251, 0.16853276, 0.16858298, 0.16863315, 0.16868329, 0.16873339, 0.16878347, 0.16883348, 0.16888347, 0.16893344, 0.16898334, 0.16903323, 0.16908306, 0.16913287, 0.16918264, 0.16923235, 0.16928206, 0.1693317, 0.16938132, 0.1694309, 0.16948044, 0.16952994, 0.16957942, 0.16962886, 0.16967823, 0.16972759, 0.1697769, 0.16982619, 0.16987544, 0.16992465, 0.16997381, 0.17002295, 0.17007205, 0.17012109, 0.17017011, 0.17021909, 0.17026803, 0.17031696, 0.17036581, 0.17041464, 0.17046344, 0.1705122, 0.17056093, 0.17060961, 0.17065825, 0.17070685, 0.17075543, 0.17080396, 0.17085245, 0.17090093, 0.17094934, 0.17099774, 0.17104606, 0.1710944, 0.17114267, 0.1711909, 0.17123909, 0.17128724, 0.17133537, 0.17138346, 0.1714315, 0.17147952, 0.1715275, 0.17157544, 0.17162333, 0.1716712, 0.171719, 0.1717668, 0.17181455, 0.17186227, 0.17190994, 0.17195758, 0.17200516, 0.17205274, 0.17210028, 0.17214777, 0.1721952, 0.17224261, 0.17229, 0.17233734, 0.17238463, 0.17243192, 0.17247914, 0.17252633, 0.17257346, 0.17262058, 0.17266767, 0.17271471, 0.17276169, 0.17280868, 0.1728556, 0.17290249, 0.17294934, 0.17299616, 0.17304292, 0.17308967, 0.17313638, 0.17318304, 0.17322968, 0.17327628, 0.17332283, 0.17336935, 0.17341582, 0.17346226, 0.17350867, 0.17355505, 0.17360137, 0.17364767, 0.17369393, 0.17374015, 0.17378633, 0.17383246, 0.17387858, 0.17392464, 0.17397068, 0.17401667, 0.17406262, 0.17410855, 0.17415443, 0.17420027, 0.17424607, 0.17429185, 0.1743376, 0.17438328, 0.17442895, 0.17447457, 0.17452015, 0.17456569, 0.17461121, 0.17465667, 0.17470211, 0.17474751, 0.17479286, 0.1748382, 0.17488348, 0.17492871, 0.17497393, 0.1750191, 0.17506425, 0.17510933, 0.1751544, 0.17519942, 0.17524442, 0.17528936, 0.17533427, 0.17537914, 0.17542399, 0.17546877, 0.17551354, 0.17555825, 0.17560296, 0.1756476, 0.17569222, 0.1757368, 0.17578134, 0.17582585, 0.17587031, 0.17591473, 0.17595913, 0.17600347, 0.17604777, 0.17609206, 0.1761363, 0.17618051, 0.17622468, 0.17626882, 0.17631288, 0.17635693, 0.17640096, 0.17644493, 0.17648886, 0.17653276, 0.17657664, 0.17662048, 0.17666426, 0.17670801, 0.17675175, 0.17679541, 0.17683907, 0.17688267, 0.17692621, 0.17696977, 0.17701325, 0.1770567, 0.17710014, 0.1771435, 0.17718686, 0.17723018, 0.17727342, 0.17731665, 0.17735985, 0.17740302, 0.17744611, 0.17748921, 0.17753226, 0.17757526, 0.17761825, 0.17766118, 0.17770407, 0.17774691, 0.17778973, 0.17783253, 0.17787527, 0.17791797, 0.17796065, 0.1780033, 0.17804588, 0.17808844, 0.17813097, 0.17817344, 0.17821589, 0.17825831, 0.17830066, 0.17834301, 0.1783853, 0.17842756, 0.17846979, 0.17851198, 0.17855412, 0.17859624, 0.17863832, 0.17868035, 0.17872235, 0.17876431, 0.17880623, 0.17884812, 0.17888997, 0.17893177, 0.17897357, 0.17901531, 0.179057, 0.17909867, 0.17914027, 0.17918189, 0.17922343, 0.17926495, 0.17930643, 0.17934786, 0.17938927, 0.17943063, 0.17947197, 0.17951323, 0.17955451, 0.17959571, 0.17963688, 0.17967802, 0.17971914, 0.17976019, 0.17980121, 0.17984222, 0.17988317, 0.17992409, 0.17996496, 0.1800058, 0.18004662, 0.18008737, 0.18012811, 0.18016879, 0.18020944, 0.18025008, 0.18029065, 0.1803312, 0.18037169, 0.18041216, 0.18045262, 0.18049301, 0.18053333, 0.18057367, 0.18061395, 0.1806542, 0.1806944, 0.18073457, 0.1807747, 0.1808148, 0.18085486, 0.18089488, 0.18093485, 0.1809748, 0.1810147, 0.18105458, 0.18109441, 0.18113421, 0.18117398, 0.18121369, 0.18125337, 0.18129303, 0.18133265, 0.18137221, 0.18141176, 0.18145123, 0.1814907, 0.18153013, 0.1815695, 0.18160887, 0.18164815, 0.18168744, 0.18172668, 0.18176588, 0.18180503, 0.18184416, 0.18188323, 0.1819223, 0.18196131, 0.18200029, 0.18203922, 0.18207812, 0.182117, 0.1821558, 0.18219462, 0.18223335, 0.18227206, 0.18231075, 0.18234937, 0.18238798, 0.18242653, 0.18246506, 0.18250355, 0.18254201, 0.18258043, 0.1826188, 0.18265714, 0.18269545, 0.1827337, 0.18277195, 0.18281011, 0.18284829, 0.18288641, 0.18292448, 0.18296251, 0.18300052, 0.18303849, 0.18307641, 0.18311431, 0.18315217, 0.18318999, 0.18322776, 0.18326552, 0.18330321, 0.18334088, 0.18337852, 0.18341608, 0.18345366, 0.18349117, 0.18352865, 0.18356609, 0.1836035, 0.18364088, 0.18367821, 0.18371549, 0.18375275, 0.18378998, 0.18382716, 0.18386431, 0.18390141, 0.18393847, 0.18397552, 0.18401252, 0.18404949, 0.18408638, 0.18412329, 0.18416013, 0.18419693, 0.1842337, 0.18427044, 0.18430713, 0.18434379, 0.18438043, 0.18441701, 0.18445355, 0.18449005, 0.18452653, 0.18456295, 0.18459935, 0.18463571, 0.18467204, 0.18470834, 0.18474458, 0.18478081, 0.18481696, 0.18485311, 0.1848892, 0.18492527, 0.18496129, 0.18499729, 0.18503323, 0.18506914, 0.18510501, 0.18514085, 0.18517666, 0.18521242, 0.18524814, 0.18528384, 0.18531948, 0.1853551, 0.18539068, 0.18542624, 0.18546173, 0.18549718, 0.18553261, 0.18556799, 0.18560335, 0.18563868, 0.18567395, 0.18570919, 0.18574439, 0.18577954, 0.18581468, 0.18584979, 0.18588483, 0.18591984, 0.18595481, 0.18598977, 0.18602468, 0.18605955, 0.18609437, 0.18612917, 0.18616393, 0.18619864, 0.18623331, 0.18626796, 0.18630257, 0.18633713, 0.18637167, 0.18640617, 0.18644063, 0.18647504, 0.18650942, 0.18654375, 0.18657808, 0.18661234, 0.18664658, 0.18668078, 0.18671492, 0.18674903, 0.18678312, 0.18681718, 0.18685117, 0.18688515, 0.18691908, 0.18695296, 0.18698685, 0.18702066, 0.18705443, 0.18708819, 0.18712191, 0.18715557, 0.18718922, 0.18722281, 0.18725637, 0.18728989, 0.18732339, 0.18735683, 0.18739024, 0.18742362, 0.18745695, 0.18749027, 0.1875235, 0.18755673, 0.18758991, 0.18762308, 0.18765618, 0.18768924, 0.1877223, 0.18775529, 0.18778825, 0.18782118, 0.18785407, 0.18788691, 0.18791974, 0.18795252, 0.18798524, 0.18801796, 0.18805061, 0.18808323, 0.18811584, 0.18814838, 0.18818091, 0.18821338, 0.1882458, 0.18827823, 0.18831058, 0.18834291, 0.18837519, 0.18840745, 0.18843967, 0.18847185, 0.188504, 0.18853609, 0.18856817, 0.1886002, 0.18863218, 0.18866414, 0.18869606, 0.18872793, 0.18875976, 0.18879159, 0.18882336, 0.18885507, 0.18888678, 0.18891844, 0.18895006, 0.18898162, 0.18901317, 0.18904468, 0.18907616, 0.18910758, 0.18913898, 0.18917033, 0.18920165, 0.18923293, 0.18926418, 0.1892954, 0.18932655, 0.18935768, 0.18938878, 0.18941985, 0.18945086, 0.18948185, 0.1895128, 0.18954371, 0.18957458, 0.1896054, 0.18963622, 0.18966697, 0.1896977, 0.18972838, 0.18975903, 0.18978965, 0.1898202, 0.18985075, 0.18988125, 0.18991172, 0.18994214, 0.18997252, 0.19000286, 0.19003317, 0.19006345, 0.1900937, 0.19012389, 0.19015406, 0.19018418, 0.19021426, 0.19024432, 0.19027433, 0.19030431, 0.19033425, 0.19036415, 0.190394, 0.19042383, 0.19045362, 0.19048336, 0.19051309, 0.19054276, 0.1905724, 0.190602, 0.19063157, 0.1906611, 0.19069061, 0.19072004, 0.19074945, 0.19077884, 0.19080819, 0.19083747, 0.19086674, 0.19089596, 0.19092518, 0.19095431, 0.19098344, 0.19101252, 0.19104154, 0.19107056, 0.19109954, 0.19112846, 0.19115734, 0.19118622, 0.19121502, 0.19124381, 0.19127254, 0.19130126, 0.19132993, 0.19135857, 0.19138715, 0.19141571, 0.19144423, 0.19147271, 0.19150117, 0.19152957, 0.19155793, 0.19158626, 0.19161455, 0.19164282, 0.19167104, 0.19169922, 0.19172737, 0.19175547, 0.19178355, 0.19181158, 0.19183958, 0.19186753, 0.19189546, 0.19192335, 0.19195119, 0.19197901, 0.19200678, 0.1920345, 0.1920622, 0.19208986, 0.1921175, 0.19214506, 0.19217262, 0.19220014, 0.1922276, 0.19225505, 0.19228244, 0.19230981, 0.19233714, 0.19236442, 0.19239168, 0.19241887, 0.19244605, 0.1924732, 0.19250029, 0.19252735, 0.1925544, 0.19258139, 0.19260833, 0.19263524, 0.19266212, 0.19268896, 0.19271575, 0.19274253, 0.19276924, 0.19279593, 0.19282261, 0.1928492, 0.19287577, 0.19290233, 0.19292884, 0.19295529, 0.19298171, 0.19300811, 0.19303446, 0.19306077, 0.19308706, 0.1931133, 0.19313949, 0.19316566, 0.19319181, 0.19321789, 0.19324394, 0.19326995, 0.19329596, 0.1933219, 0.19334781, 0.19337367, 0.19339949, 0.19342528, 0.19345105, 0.19347677, 0.19350244, 0.1935281, 0.19355369, 0.19357927, 0.1936048, 0.19363029, 0.19365574, 0.19368117, 0.19370654, 0.19373189, 0.19375721, 0.19378246, 0.19380771, 0.1938329, 0.19385806, 0.19388318, 0.19390827, 0.19393331, 0.19395831, 0.1939833, 0.19400825, 0.19403315, 0.19405799, 0.19408281, 0.19410759, 0.19413236, 0.19415706, 0.19418173, 0.19420637, 0.19423097, 0.19425553, 0.19428007, 0.19430454, 0.19432898, 0.19435339, 0.19437778, 0.19440211, 0.1944264, 0.19445068, 0.19447489, 0.19449909, 0.19452325, 0.19454734, 0.19457142, 0.19459547, 0.19461945, 0.19464342, 0.19466735, 0.19469124, 0.1947151, 0.19473892, 0.19476269, 0.19478641, 0.19481012, 0.19483379, 0.19485742, 0.19488101, 0.19490457, 0.19492806, 0.19495156, 0.19497499, 0.1949984, 0.19502176, 0.1950451, 0.1950684, 0.19509165, 0.19511485, 0.19513804, 0.19516118, 0.19518428, 0.19520736, 0.19523039, 0.19525339, 0.19527635, 0.19529927, 0.19532214, 0.19534498, 0.19536778, 0.19539057, 0.19541329, 0.19543599, 0.19545864, 0.19548126, 0.19550385, 0.19552638, 0.19554889, 0.19557135, 0.19559379, 0.19561619, 0.19563854, 0.19566086, 0.19568315, 0.19570538, 0.1957276, 0.19574977, 0.19577192, 0.19579402, 0.19581608, 0.19583809, 0.19586007, 0.19588204, 0.19590393, 0.1959258, 0.19594765, 0.19596942, 0.19599122, 0.19601291, 0.1960346, 0.19605626, 0.19607788, 0.19609943, 0.19612098, 0.19614248, 0.19616395, 0.19618537, 0.19620676, 0.1962281, 0.19624943, 0.19627067, 0.19629194, 0.19631313, 0.19633429, 0.19635542, 0.1963765, 0.19639757, 0.19641858, 0.19643955, 0.19646049, 0.19648139, 0.19650225, 0.1965231, 0.19654386, 0.19656463, 0.19658534, 0.19660604, 0.19662666, 0.19664729, 0.19666782, 0.19668837, 0.19670884, 0.1967293, 0.1967497, 0.1967701, 0.19679044, 0.19681074, 0.19683102, 0.19685124, 0.19687143, 0.19689159, 0.19691172, 0.19693178, 0.19695182, 0.19696772, 0.19697946, 0.19699116, 0.19700281, 0.19701442, 0.19702597, 0.1970375, 0.19704895, 0.19706039, 0.19707175, 0.19708309, 0.19709437, 0.1971056, 0.19711679, 0.19712794, 0.19713904, 0.19715008, 0.19716109, 0.19717206, 0.197183, 0.19719385, 0.19720468, 0.19721545, 0.19722618, 0.19723687, 0.19724749, 0.1972581, 0.19726864, 0.19727914, 0.1972896, 0.19730002, 0.19731037, 0.1973207, 0.19733098, 0.1973412, 0.19735138, 0.1973615, 0.1973716, 0.19738165, 0.19739164, 0.1974016, 0.19741151, 0.19742137, 0.19743118, 0.19744094, 0.19745067, 0.19746034, 0.19746998, 0.19747956, 0.1974891, 0.19749857, 0.19750804, 0.19751742, 0.1975268, 0.1975361, 0.19754536, 0.19755457, 0.19756375, 0.19757287, 0.19758196, 0.19759101, 0.19759999, 0.1976089, 0.19761781, 0.19762668, 0.19763547, 0.19764423, 0.19765294, 0.19766162, 0.19767022, 0.1976788, 0.19768734, 0.19769581, 0.19770426, 0.19771264, 0.19772099, 0.19772929, 0.19773754, 0.19774574, 0.19775392, 0.19776204, 0.1977701, 0.19777812, 0.19778611, 0.19779404, 0.19780192, 0.19780976, 0.19781756, 0.19782531, 0.197833, 0.19784066, 0.19784828, 0.19785583, 0.19786337, 0.19787084, 0.19787826, 0.19788563, 0.19789296, 0.19790025, 0.19790751, 0.19791472, 0.19792184, 0.19792897, 0.19793601, 0.19794303, 0.19795001, 0.19795692, 0.19796379, 0.19797063, 0.19797742, 0.19798414, 0.19799085, 0.1979975, 0.19800408, 0.19801065, 0.19801717, 0.19802362, 0.19803004, 0.1980364, 0.19804275, 0.19804901, 0.19805525, 0.19806144, 0.19806758, 0.19807369, 0.19807974, 0.19808573, 0.19809169, 0.19809759, 0.19810346, 0.1981093, 0.19811507, 0.1981208, 0.19812648, 0.19813211, 0.1981377, 0.19814326, 0.19814874, 0.1981542, 0.19815962, 0.19816497, 0.19817029, 0.19817556, 0.19818078, 0.19818598, 0.19819109, 0.19819619, 0.19820122, 0.1982062, 0.19821116, 0.19821607, 0.19822092, 0.19822574, 0.19823052, 0.19823523, 0.19823989, 0.19824453, 0.19824912, 0.19825365, 0.19825813, 0.19826256, 0.19826695, 0.19827132, 0.19827563, 0.19827987, 0.1982841, 0.19828826, 0.19829239, 0.19829647, 0.19830048, 0.19830447, 0.19830842, 0.19831233, 0.19831616, 0.19831997, 0.19832373, 0.19832745, 0.19833109, 0.19833471, 0.19833827, 0.19834182, 0.19834529, 0.19834873, 0.1983521, 0.19835545, 0.19835874, 0.19836199, 0.19836521, 0.19836837, 0.19837147, 0.19837452, 0.19837755, 0.19838053, 0.19838347, 0.19838636, 0.19838919, 0.19839197, 0.19839473, 0.19839741, 0.19840007, 0.19840269, 0.19840524, 0.19840777, 0.19841023, 0.19841267, 0.19841504, 0.19841735, 0.19841965, 0.19842188, 0.19842409, 0.19842623, 0.19842833, 0.19843039, 0.19843242, 0.19843437, 0.1984363, 0.19843817, 0.19844, 0.19844179, 0.19844352, 0.1984452, 0.19844684, 0.19844845, 0.19845, 0.1984515, 0.19845296, 0.19845437, 0.19845575, 0.19845708, 0.19845834, 0.19845957, 0.19846077, 0.19846189, 0.19846299, 0.19846404, 0.19846503, 0.198466, 0.19846691, 0.19846776, 0.1984686, 0.19846934, 0.19847007, 0.19847077, 0.1984714, 0.19847199, 0.19847253, 0.19847304, 0.19847347, 0.19847387, 0.19847424, 0.19847454, 0.19847482, 0.19847505, 0.19847521, 0.19847535, 0.19847544, 0.19847545, 0.19847545, 0.19847541, 0.1984753, 0.19847517, 0.19847496, 0.19847472, 0.19847444, 0.19847411, 0.19847374, 0.19847332, 0.19847284, 0.19847234, 0.19847178, 0.19847117, 0.19847052, 0.19846982, 0.19846907, 0.1984683, 0.19846745, 0.19846658, 0.19846565, 0.19846468, 0.19846366, 0.19846259, 0.19846149, 0.19846033, 0.19845913, 0.19845788, 0.19845659, 0.19845524, 0.19845386, 0.19845243, 0.19845097, 0.19844943, 0.19844785, 0.19844624, 0.19844459, 0.19844286, 0.19844113, 0.19843933, 0.19843748, 0.1984356, 0.19843365, 0.19843167, 0.19842964, 0.19842757, 0.19842544, 0.19842328, 0.19842108, 0.19841881, 0.19841652, 0.19841416, 0.19841175, 0.19840932, 0.19840683, 0.19840431, 0.1984017, 0.1983991, 0.19839643, 0.19839372, 0.19839096, 0.19838814, 0.1983853, 0.19838239, 0.19837944, 0.19837646, 0.19837342, 0.19837032, 0.19836719, 0.19836402, 0.19836082, 0.19835754, 0.19835421, 0.19835085, 0.19834745, 0.19834401, 0.19834051, 0.19833697, 0.1983334, 0.19832975, 0.19832605, 0.19832234, 0.19831856, 0.19831474, 0.19831088, 0.19830698, 0.198303, 0.19829901, 0.19829497, 0.19829088, 0.19828674, 0.19828255, 0.19827832, 0.19827403, 0.19826972, 0.19826536, 0.19826093, 0.19825648, 0.19825196, 0.19824742, 0.19824281, 0.19823816, 0.19823349, 0.19822875, 0.19822395, 0.19821914, 0.19821428, 0.19820935, 0.19820438, 0.19819938, 0.19819431, 0.1981892, 0.19818406, 0.19817887, 0.19817361, 0.19816834, 0.198163, 0.19815762, 0.1981522, 0.19814672, 0.19814122, 0.19813564, 0.19813004, 0.19812439, 0.19811869, 0.19811295, 0.19810715, 0.19810131, 0.19809543, 0.1980895, 0.19808352, 0.1980775, 0.19807144, 0.19806533, 0.19805916, 0.19805296, 0.19804671, 0.1980404, 0.19803406, 0.19802767, 0.19802123, 0.19801475, 0.19800824, 0.19800168, 0.19799504, 0.19798839, 0.19798169, 0.19797491, 0.19796811, 0.19796126, 0.19795437, 0.19794743, 0.19794045, 0.19793342, 0.19792633, 0.19791922, 0.19791207, 0.19790484, 0.19789757, 0.19789027, 0.19788294, 0.1978755, 0.19786808, 0.1978606, 0.19785304, 0.19784546, 0.19783786, 0.19783016, 0.19782244, 0.19781467, 0.19780688, 0.19779903, 0.1977911, 0.19778316, 0.19777517, 0.19776712, 0.19775903, 0.19775091, 0.19774272, 0.1977345, 0.19772622, 0.19771791, 0.19770955, 0.19770116, 0.19769268, 0.19768418, 0.19767565, 0.19766706, 0.19765842, 0.19764973, 0.197641, 0.19763222, 0.1976234, 0.19761454, 0.19760561, 0.19759667, 0.19758767, 0.19757859, 0.19756952, 0.19756037, 0.19755119, 0.19754194, 0.19753267, 0.19752334, 0.19751398, 0.19750455, 0.19749507, 0.19748558, 0.19747601, 0.19746642, 0.19745678, 0.19744709, 0.19743735, 0.19742756, 0.19741772, 0.19740786, 0.19739792, 0.19738796, 0.19737794, 0.19736788, 0.19735777, 0.19734763, 0.19733743, 0.19732718, 0.19731688, 0.19730656, 0.19729619, 0.19728574, 0.19727528, 0.19726476, 0.1972542, 0.19724359, 0.19723292, 0.19722222, 0.19721147, 0.19720069, 0.19718982, 0.19717894, 0.19716801, 0.19715704, 0.19714601, 0.19713494, 0.19712383, 0.19711266, 0.19710146, 0.19709019, 0.1970789, 0.19706756, 0.19705616, 0.19704472, 0.19703326, 0.19702172, 0.19701014, 0.19699852, 0.19698685, 0.19697514, 0.19696337, 0.19695158, 0.19693974, 0.19692785, 0.19691588, 0.19690391, 0.19689186, 0.19687979, 0.19686766, 0.19685549, 0.19684328, 0.19683102, 0.19681868, 0.19680633, 0.19679394, 0.19678149, 0.196769, 0.19675645, 0.19674386, 0.19673124, 0.19671856, 0.19670585, 0.19669308, 0.19668025, 0.1966674, 0.19665448, 0.19664153, 0.19662854, 0.1966155, 0.19660242, 0.19658928, 0.1965761, 0.19656286, 0.19654959, 0.19653626, 0.19652291, 0.19650951, 0.19649604, 0.19648254, 0.19646898, 0.1964554, 0.19644175, 0.19642806, 0.19641434, 0.19640057, 0.19638672, 0.19637287, 0.19635895, 0.19634499, 0.19633096, 0.19631693, 0.19630282, 0.19628868, 0.19627447, 0.19626024, 0.19624597, 0.19623163, 0.19621727, 0.19620284, 0.19618838, 0.19617388, 0.1961593, 0.19614469, 0.19613005, 0.19611537, 0.19610061, 0.19608584, 0.19607098, 0.19605611, 0.1960412, 0.19602621, 0.1960112, 0.19599614, 0.19598103, 0.19596586, 0.19595067, 0.19593541, 0.19592011, 0.19590479, 0.1958894, 0.19587396, 0.19585849, 0.19584297, 0.19582741, 0.19581179, 0.19579613, 0.19578044, 0.19576468, 0.19574887, 0.19573303, 0.19571714, 0.19570121, 0.19568522, 0.19566919, 0.19565311, 0.195637, 0.19562085, 0.19560464, 0.19558837, 0.19557208, 0.19555573, 0.19553931, 0.19552287, 0.19550639, 0.19548987, 0.19547328, 0.19545665, 0.19543998, 0.19542329, 0.19540653, 0.1953897, 0.19537285, 0.19535595, 0.19533901, 0.19532201, 0.19530499, 0.1952879, 0.19527078, 0.19525358, 0.19523637, 0.1952191, 0.1952018, 0.19518442, 0.19516703, 0.19514957, 0.19513209, 0.19511454, 0.19509695, 0.19507933, 0.19506164, 0.19504392, 0.19502614, 0.19500834, 0.19499047, 0.19497256, 0.1949546, 0.19493659, 0.19491856, 0.19490045, 0.1948823, 0.19486412, 0.1948459, 0.19482763, 0.19480929, 0.19479094, 0.19477253, 0.19475406, 0.19473556, 0.194717, 0.19469839, 0.19467977, 0.19466107, 0.19464234, 0.19462356, 0.19460474, 0.19458586, 0.19456692, 0.19454798, 0.19452897, 0.19450989, 0.19449081, 0.19447166, 0.19445246, 0.19443323, 0.19441393, 0.1943946, 0.19437523, 0.1943558, 0.19433634, 0.1943168, 0.19429725, 0.19427764, 0.19425799, 0.19423829, 0.19421855, 0.19419874, 0.19417891, 0.19415903, 0.19413911, 0.19411914, 0.19409911, 0.19407904, 0.19405894, 0.19403878, 0.19401857, 0.19399832, 0.19397801, 0.19395767, 0.19393729, 0.19391686, 0.19389638, 0.19387585, 0.19385527, 0.19383466, 0.19381401, 0.1937933, 0.19377255, 0.19375172, 0.19373089, 0.19371, 0.19368905, 0.19366807, 0.19364704, 0.19362599, 0.19360484, 0.19358367, 0.19356246, 0.1935412, 0.19351989, 0.19349855, 0.19347714, 0.1934557, 0.19343421, 0.19341268, 0.1933911, 0.19336948, 0.19334781, 0.19332607, 0.19330432, 0.1932825, 0.19326065, 0.19323874, 0.19321679, 0.19319481, 0.19317275, 0.19315067, 0.19312854, 0.19310638, 0.19308417, 0.19306187, 0.19303955, 0.19301721, 0.19299479, 0.19297235, 0.19294985, 0.1929273, 0.1929047, 0.19288208, 0.19285938, 0.19283664, 0.19281389, 0.19279106, 0.1927682, 0.19274528, 0.19272232, 0.19269933, 0.19267625, 0.19265318, 0.19263002, 0.19260684, 0.19258361, 0.19256034, 0.19253701, 0.19251363, 0.19249022, 0.19246677, 0.19244324, 0.19241969, 0.19239609, 0.19237244, 0.19234875, 0.192325, 0.19230123, 0.1922774, 0.19225353, 0.1922296, 0.19220564, 0.19218162, 0.19215755, 0.19213347, 0.19210929, 0.19208509, 0.19206087, 0.19203655, 0.19201224, 0.19198787, 0.19196342, 0.19193895, 0.19191444, 0.19188987, 0.19186527, 0.1918406, 0.19181591, 0.19179116, 0.19176635, 0.19174151, 0.19171663, 0.19169171, 0.19166672, 0.1916417, 0.19161662, 0.1915915, 0.19156636, 0.19154115, 0.19151591, 0.19149061, 0.19146526, 0.19143985, 0.19141442, 0.19138893, 0.19136342, 0.19133784, 0.19131221, 0.19128656, 0.19126084, 0.19123508, 0.19120927, 0.19118342, 0.19115752, 0.19113159, 0.1911056, 0.19107957, 0.19105349, 0.19102736, 0.19100119, 0.19097497, 0.19094871, 0.19092241, 0.19089605, 0.19086964, 0.19084319, 0.1908167, 0.19079016, 0.19076358, 0.19073696, 0.19071028, 0.19068356, 0.19065678, 0.19062999, 0.19060311, 0.19057621, 0.19054927, 0.19052225, 0.19049521, 0.19046813, 0.190441, 0.19041382, 0.19038659, 0.19035931, 0.190332, 0.19030465, 0.19027723, 0.19024977, 0.19022226, 0.19019471, 0.19016714, 0.19013949, 0.1901118, 0.19008406, 0.19005629, 0.19002846, 0.19000059, 0.18997268, 0.18994471, 0.1899167, 0.18988866, 0.18986055, 0.18983242, 0.18980423, 0.18977597, 0.18974771, 0.18971938, 0.18969101, 0.18966259, 0.1896341, 0.18960559, 0.18957704, 0.18954843, 0.18951978, 0.18949111, 0.18946235, 0.18943357, 0.18940473, 0.18937585, 0.18934692, 0.18931794, 0.18928893, 0.18925989, 0.18923078, 0.18920162, 0.18917242, 0.18914318, 0.18911389, 0.18908454, 0.18905516, 0.18902571, 0.18899624, 0.18896674, 0.18893716, 0.18890755, 0.1888779, 0.18884818, 0.18881842, 0.18878862, 0.18875879, 0.1887289, 0.18869896, 0.18866897, 0.18863897, 0.18860888, 0.18857875, 0.18854859, 0.18851839, 0.18848814, 0.18845783, 0.18842748, 0.18839709, 0.18836665, 0.18833615, 0.18830563, 0.18827505, 0.18824443, 0.18821377, 0.18818304, 0.1881523, 0.18812148, 0.18809064, 0.18805975, 0.18802878, 0.1879978, 0.18796676, 0.1879357, 0.18790455, 0.18787338, 0.18784213, 0.18781088, 0.18777958, 0.18774822, 0.18771681, 0.18768536, 0.18765387, 0.18762232, 0.18759075, 0.18755911, 0.18752743, 0.18749571, 0.18746394, 0.18743211, 0.18740025, 0.18736835, 0.1873364, 0.18730439, 0.18727234, 0.18724026, 0.18720812, 0.18717594, 0.1871437, 0.18711142, 0.18707909, 0.18704674, 0.18701434, 0.18698186, 0.18694936, 0.18691681, 0.18688421, 0.18685156, 0.1868189, 0.18678614, 0.18675336, 0.18672054, 0.18668766, 0.18665475, 0.18662179, 0.18658876, 0.18655571, 0.18652262, 0.18648946, 0.18645628, 0.18642303, 0.18638974, 0.18635643, 0.18632305, 0.18628961, 0.18625614, 0.18622261, 0.18618907, 0.18615545, 0.18612181, 0.18608811, 0.18605436, 0.18602058, 0.18598674, 0.18595286, 0.18591893, 0.18588495, 0.18585093, 0.18581688, 0.1857796, 0.18573922, 0.18569876, 0.18565829, 0.18561782, 0.18557729, 0.18553674, 0.1854962, 0.18545561, 0.18541498, 0.18537435, 0.18533368, 0.185293, 0.18525228, 0.18521154, 0.18517077, 0.18512997, 0.18508916, 0.18504831, 0.18500744, 0.18496655, 0.18492562, 0.18488467, 0.1848437, 0.18480273, 0.18476169, 0.18472064, 0.18467957, 0.18463847, 0.18459733, 0.1845562, 0.18451501, 0.18447383, 0.1844326, 0.18439135, 0.18435006, 0.18430877, 0.18426743, 0.18422608, 0.18418472, 0.1841433, 0.18410186, 0.18406041, 0.18401892, 0.18397743, 0.1839359, 0.18389434, 0.18385275, 0.18381114, 0.18376951, 0.18372785, 0.18368617, 0.18364446, 0.18360272, 0.18356097, 0.18351917, 0.18347734, 0.18343551, 0.18339366, 0.18335177, 0.18330985, 0.18326792, 0.18322594, 0.18318395, 0.18314195, 0.18309991, 0.18305783, 0.18301575, 0.18297364, 0.18293148, 0.18288931, 0.18284711, 0.18280491, 0.18276265, 0.18272038, 0.18267809, 0.18263577, 0.18259342, 0.18255104, 0.18250865, 0.18246622, 0.18242377, 0.1823813, 0.1823388, 0.18229629, 0.18225372, 0.18221115, 0.18216856, 0.18212593, 0.18208326, 0.18204057, 0.18199788, 0.18195516, 0.18191242, 0.18186963, 0.18182682, 0.18178399, 0.18174113, 0.18169825, 0.18165533, 0.1816124, 0.18156944, 0.18152645, 0.18148345, 0.18144041, 0.18139736, 0.18135427, 0.18131116, 0.18126801, 0.18122487, 0.18118167, 0.18113846, 0.18109524, 0.18105195, 0.18100868, 0.18096536, 0.180922, 0.18087864, 0.18083526, 0.18079184, 0.1807484, 0.18070494, 0.18066144, 0.18061791, 0.18057437, 0.1805308, 0.18048722, 0.18044358, 0.18039994, 0.18035625, 0.18031257, 0.18026884, 0.1802251, 0.18018132, 0.18013752, 0.18009371, 0.18004987, 0.18000598, 0.17996207, 0.17991814, 0.1798742, 0.17983021, 0.17978622, 0.17974217, 0.17969812, 0.17965405, 0.17960995, 0.17956582, 0.17952166, 0.17947748, 0.17943329, 0.17938904, 0.17934477, 0.1793005, 0.17925619, 0.17921187, 0.17916749, 0.1791231, 0.17907871, 0.17903426, 0.1789898, 0.1789453, 0.17890081, 0.17885627, 0.1788117, 0.17876713, 0.1787225, 0.17867789, 0.17863321, 0.17858851, 0.17854379, 0.17849906, 0.17845428, 0.17840949, 0.17836466, 0.17831983, 0.17827496, 0.17823008, 0.17818514, 0.17814021, 0.17809522, 0.17805025, 0.17800522, 0.17796016, 0.17791508, 0.17787001, 0.17782487, 0.17777972, 0.17773455, 0.17768934, 0.1776441, 0.17759888, 0.17755358, 0.17750829, 0.17746295, 0.17741761, 0.17737223, 0.17732684, 0.17728138, 0.17723593, 0.17719045, 0.17714494, 0.17709942, 0.17705385, 0.17700827, 0.17696269, 0.17691703, 0.17687139, 0.1768257, 0.17677999, 0.17673425, 0.17668851, 0.17664272, 0.17659689, 0.17655106, 0.17650521, 0.1764593, 0.17641339, 0.17636746, 0.17632148, 0.17627551, 0.17622949, 0.17618345, 0.17613739, 0.1760913, 0.17604518, 0.17599903, 0.17595287, 0.17590666, 0.17586045, 0.17581421, 0.17576794, 0.17572165, 0.17567532, 0.17562899, 0.17558259, 0.1755362, 0.17548977, 0.17544334, 0.17539684, 0.17535037, 0.17530383, 0.17525728, 0.1752107, 0.1751641, 0.17511748, 0.17507082, 0.17502415, 0.17497745, 0.17493071, 0.17488396, 0.17483717, 0.17479037, 0.17474355, 0.1746967, 0.1746498, 0.1746029, 0.17455597, 0.17450902, 0.17446202, 0.17441501, 0.17436798, 0.17432092, 0.17427385, 0.17422673, 0.1741796, 0.17413242, 0.17408524, 0.17403804, 0.1739908, 0.17394352, 0.17389624, 0.17384893, 0.17380159, 0.1737542, 0.17370683, 0.17365941, 0.17361197, 0.17356451, 0.173517, 0.17346948, 0.17342195, 0.17337438, 0.17332679, 0.17327917, 0.17323153, 0.17318384, 0.17313614, 0.17308842, 0.17304067, 0.17299291, 0.17294511, 0.17289728, 0.17284945, 0.17280155, 0.17275366, 0.17270574, 0.17265779, 0.17260981, 0.17256179, 0.17251378, 0.17246571, 0.17241763, 0.17236955, 0.17232142, 0.17227325, 0.17222507, 0.17217687, 0.17212863, 0.17208037, 0.1720321, 0.17198378, 0.17193545, 0.17188708, 0.17183872, 0.1717903, 0.17174186, 0.17169341, 0.17164493, 0.17159639, 0.17154786, 0.17149931, 0.17145072, 0.17140211, 0.17135346, 0.17130479, 0.17125611, 0.17120738, 0.17115866, 0.17110988, 0.17106108, 0.17101227, 0.17096344, 0.17091458, 0.17086567, 0.17081675, 0.1707678, 0.17071883, 0.17066984, 0.1706208, 0.17057176, 0.17052269, 0.17047361, 0.17042448, 0.17037533, 0.17032614, 0.17027695, 0.17022774, 0.17017847, 0.17012921, 0.1700799, 0.17003058, 0.16998123, 0.16993183, 0.16988245, 0.16983302, 0.16978355, 0.16973408, 0.16968459, 0.16963504, 0.16958548, 0.16953591, 0.1694863, 0.16943666, 0.16938701, 0.16933732, 0.16928761, 0.16923787, 0.16918811, 0.16913834, 0.16908851, 0.16903868, 0.16898882, 0.16893892, 0.16888903, 0.16883907, 0.16878912, 0.16873913, 0.1686891, 0.16863906, 0.16858901, 0.16853893, 0.16848882, 0.16843867, 0.16838849, 0.1683383, 0.16828808, 0.16823784, 0.16818756, 0.16813727, 0.16808696, 0.16803659, 0.16798621, 0.16793583, 0.16788541, 0.16783497, 0.1677845, 0.16773398, 0.16768347, 0.16763291, 0.16758233, 0.16753173, 0.16748111, 0.16743046, 0.16737978, 0.16732909, 0.16727835, 0.1672276, 0.16717683, 0.16712601, 0.16707519, 0.16702433, 0.16697346, 0.16692254, 0.16687162, 0.16682065, 0.16676968, 0.16671866, 0.16666763, 0.16661657, 0.16656549, 0.16651438, 0.16646323, 0.16641207, 0.16636088, 0.16630967, 0.16625844, 0.16620718, 0.16615589, 0.16610458, 0.16605324, 0.16600187, 0.16595048, 0.16589905, 0.16584763, 0.16579615, 0.16574466, 0.16569315, 0.16564161, 0.16559003, 0.16553843, 0.16548683, 0.16543518, 0.1653835, 0.1653318, 0.16528007, 0.16522834, 0.16517656, 0.16512476, 0.16507295, 0.16502109, 0.16496922, 0.16491733, 0.16486539, 0.16481346, 0.16476147, 0.16470946, 0.16465743, 0.16460539, 0.16455331, 0.16450121, 0.16444908, 0.16439691, 0.16434474, 0.16429253, 0.1642403, 0.16418804, 0.16413575, 0.16408345, 0.16403113, 0.16397877, 0.16392638, 0.16387396, 0.16382155, 0.16376907, 0.1637166, 0.16366407, 0.16361155, 0.16355897, 0.16350639, 0.16345377, 0.16340114, 0.16334847, 0.16329579, 0.16324307, 0.16319035, 0.16313757, 0.16308479, 0.16303197, 0.16297911, 0.16292624, 0.16287337, 0.16282044, 0.16276748, 0.16271451, 0.16266152, 0.1626085, 0.16255544, 0.16250239, 0.16244929, 0.16239616, 0.16234301, 0.16228984, 0.16223665, 0.16218342, 0.16213018, 0.16207691, 0.16202359, 0.16197026, 0.16191691, 0.16186354, 0.16181014, 0.16175671, 0.16170326, 0.16164978, 0.16159625, 0.16154274, 0.16148919, 0.1614356, 0.161382, 0.16132836, 0.1612747, 0.16122101, 0.16116731, 0.16111358, 0.16105983, 0.16100603, 0.16095223, 0.16089839, 0.16084452, 0.16079064, 0.16073672, 0.16068278, 0.16062883, 0.16057484, 0.16052081, 0.16046679, 0.1604127, 0.16035862, 0.1603045, 0.16025037, 0.1601962, 0.160142, 0.16008779, 0.16003355, 0.15997928, 0.15992498, 0.15987067, 0.15981632, 0.15976195, 0.15970755, 0.15965313, 0.15959868, 0.1595442, 0.15948971, 0.15943518, 0.15938063, 0.15932606, 0.15927145, 0.15921682, 0.15916218, 0.15910749, 0.1590528, 0.15899807, 0.15894331, 0.15888853, 0.15883374, 0.15877891, 0.15872404, 0.15866917, 0.15861426, 0.15855934, 0.15850437, 0.1584494, 0.1583944, 0.15833934, 0.15828429, 0.15822922, 0.1581741, 0.15811896, 0.15806381, 0.15800862, 0.15795341, 0.15789817, 0.15784292, 0.15778762, 0.15773232, 0.15767698, 0.15762161, 0.15756622, 0.1575108, 0.15745535, 0.15739989, 0.1573444, 0.15728888, 0.15723333, 0.15717776, 0.15712216, 0.15706655, 0.15701091, 0.15695524, 0.15689954, 0.15684383, 0.15678808, 0.15673231, 0.1566765, 0.1566207, 0.15656485, 0.15650897, 0.15645307, 0.15639713, 0.15634118, 0.15628521, 0.15622921, 0.15617318, 0.15611713, 0.15606105, 0.15600497, 0.15594882, 0.15589267, 0.15583649, 0.15578027, 0.15572405, 0.1556678, 0.15561152, 0.1555552, 0.15549888, 0.15544254, 0.15538615, 0.15532973, 0.15527329, 0.15521683, 0.15516034, 0.15510385, 0.1550473, 0.15499073, 0.15493415, 0.15487753, 0.1548209, 0.15476424, 0.15470755, 0.15465084, 0.15459408, 0.15453732, 0.15448053, 0.15442371, 0.15436687, 0.15431, 0.15425311, 0.15419619, 0.15413925, 0.15408228, 0.15402529, 0.15396826, 0.15391122, 0.15385415, 0.15379705, 0.15373993, 0.15368278, 0.15362561, 0.15356842, 0.1535112, 0.15345393, 0.15339667, 0.15333937, 0.15328203, 0.15322469, 0.15316732, 0.15310989, 0.15305248, 0.15299502, 0.15293755, 0.15288003, 0.15282251, 0.15276496, 0.15270738, 0.15264978, 0.15259212, 0.15253448, 0.15247679, 0.15241909, 0.15236135, 0.15230359, 0.1522458, 0.152188, 0.15213017, 0.15207231, 0.15201442, 0.15195651, 0.15189858, 0.1518406, 0.15178262, 0.15172462, 0.15166655, 0.1516085, 0.15155041, 0.1514923, 0.15143414, 0.15137599, 0.15131779, 0.15125957, 0.15120134, 0.15114306, 0.15108477, 0.15102644, 0.1509681, 0.15090974, 0.15085134, 0.15079293, 0.15073447, 0.150676, 0.1506175, 0.15055896, 0.15050043, 0.15044186, 0.15038325, 0.15032463, 0.15026599, 0.15020731, 0.1501486, 0.15008987, 0.15003113, 0.14997233, 0.14991353, 0.14985472, 0.14979585, 0.14973697, 0.14967808, 0.14961913, 0.14956018, 0.1495012, 0.14944218, 0.14938316, 0.14932409, 0.14926502, 0.14920591, 0.14914677, 0.14908762, 0.14902844, 0.14896922, 0.14890999, 0.14885071, 0.14879143, 0.14873211, 0.14867279, 0.14861341, 0.14855403, 0.14849462, 0.14843518, 0.1483757, 0.1483162, 0.14825669, 0.14819716, 0.1481376, 0.14807799, 0.14801836, 0.14795874, 0.14789906, 0.14783937, 0.14777964, 0.1477199, 0.14766014, 0.14760032, 0.14754051, 0.14748065, 0.14742078, 0.14736088, 0.14730096, 0.14724101, 0.14718103, 0.14712103, 0.14706102, 0.14700097, 0.14694089, 0.14688078, 0.14682065, 0.14676049, 0.14670032, 0.14664012, 0.14657989, 0.14651963, 0.14645936, 0.14639904, 0.14633872, 0.14627835, 0.14621797, 0.14615756, 0.14609711, 0.14603667, 0.14597617, 0.14591567, 0.14585513, 0.14579459, 0.14573398, 0.14567336, 0.14561273, 0.14555208, 0.14549138, 0.14543068, 0.14536993, 0.14530917, 0.14524838, 0.14518756, 0.14512672, 0.14506586, 0.14500494, 0.14494403, 0.1448831, 0.14482212, 0.14476113, 0.14470011, 0.14463906, 0.14457799, 0.14451692, 0.14445578, 0.14439462, 0.14433345, 0.14427227, 0.14421102, 0.1441498, 0.14408852, 0.14402722, 0.1439659, 0.14390454, 0.14384316, 0.14378177, 0.14372033, 0.14365888, 0.14359739, 0.14353591, 0.14347437, 0.14341281, 0.14335123, 0.14328963, 0.14322798, 0.14316635, 0.14310466, 0.14304294, 0.14298122, 0.14291947, 0.14285767, 0.14279586, 0.14273402, 0.14267217, 0.14261027, 0.14254837, 0.14248642, 0.14242446, 0.14236248, 0.14230047, 0.14223842, 0.14217636, 0.14211427, 0.14205214, 0.14199004, 0.14192785, 0.14186567, 0.14180344, 0.1417412, 0.14167891, 0.14161664, 0.14155433, 0.14149196, 0.1414296, 0.14136723, 0.14130481, 0.14124236, 0.14117987, 0.14111738, 0.14105485, 0.1409923, 0.14092973, 0.14086713, 0.1408045, 0.14074187, 0.14067918, 0.14061648, 0.14055374, 0.14049099, 0.14042822, 0.14036542, 0.14030258, 0.14023973, 0.14017686, 0.14011395, 0.14005101, 0.13998806, 0.13992508, 0.13986208, 0.13979904, 0.13973598, 0.13967291, 0.1396098, 0.13954666, 0.1394835, 0.13942033, 0.1393571, 0.13929388, 0.13923061, 0.13916732, 0.13910401, 0.13904066, 0.1389773, 0.13891391, 0.1388505, 0.13878706, 0.1387236, 0.13866012, 0.13859659, 0.13853304, 0.13846949, 0.13840589, 0.13834228, 0.13827863, 0.13821496, 0.13815127, 0.13808754, 0.13802379, 0.13796002, 0.13789624, 0.1378324, 0.13776857, 0.13770469, 0.13764079, 0.13757688, 0.13751292, 0.13744894, 0.13738494, 0.13732092, 0.13725686, 0.13719279, 0.13712868, 0.13706456, 0.1370004, 0.13693622, 0.13687202, 0.1368078, 0.13674353, 0.13667926, 0.13661495, 0.13655064, 0.13648626, 0.13642187, 0.13635747, 0.13629304, 0.13622859, 0.1361641, 0.13609959, 0.13603504, 0.13597049, 0.13590589, 0.13584128, 0.13577664, 0.13571198, 0.13564731, 0.1355826, 0.13551785, 0.13545308, 0.1353883, 0.13532348, 0.13525864, 0.13519377, 0.13512889, 0.13506396, 0.13499902, 0.13493405, 0.13486907, 0.13480403, 0.13473898, 0.13467392, 0.13460882, 0.1345437, 0.13447855, 0.13441338, 0.1343482, 0.13428296, 0.13421772, 0.13415244, 0.13408715, 0.13402182, 0.13395646, 0.13389109, 0.13382567, 0.13376026, 0.13369481, 0.13362935, 0.13356382, 0.1334983, 0.13343275, 0.13336717, 0.13330157, 0.13323593, 0.13317028, 0.13310459, 0.13303888, 0.13297315, 0.13290741, 0.13284162, 0.1327758, 0.13270995, 0.13264474, 0.13258012, 0.13251549, 0.13245086, 0.13238625, 0.13232164, 0.13225701, 0.13219243, 0.13212784, 0.13206324, 0.13199867, 0.13193409, 0.13186951, 0.13180494, 0.13174039, 0.13167582, 0.13161127, 0.13154671, 0.13148218, 0.13141765, 0.13135311, 0.13128859, 0.13122405, 0.13115954, 0.13109504, 0.13103053, 0.13096602, 0.13090153, 0.13083702, 0.13077255, 0.13070807, 0.13064359, 0.13057911, 0.13051465, 0.13045017, 0.13038573, 0.13032128, 0.13025682, 0.13019238, 0.13012795, 0.13006352, 0.12999909, 0.12993467, 0.12987025, 0.12980583, 0.12974142, 0.12967703, 0.12961262, 0.12954824, 0.12948386, 0.12941946, 0.12935509, 0.12929071, 0.12922634, 0.12916198, 0.12909763, 0.12903328, 0.12896894, 0.1289046, 0.12884025, 0.12877594, 0.12871161, 0.12864728, 0.12858295, 0.12851866, 0.12845434, 0.12839004, 0.12832575, 0.12826148, 0.12819718, 0.12813291, 0.12806863, 0.12800434, 0.12794007, 0.12787583, 0.12781157, 0.12774733, 0.12768307, 0.12761883, 0.1275546, 0.12749037, 0.12742615, 0.12736191, 0.12729771, 0.12723351, 0.1271693, 0.12710509, 0.12704089, 0.1269767, 0.12691252, 0.12684834, 0.12678416, 0.12672001, 0.12665583, 0.12659168, 0.12652752, 0.12646337, 0.12639923, 0.12633508, 0.12627095, 0.12620682, 0.1261427, 0.12607859, 0.12601446, 0.12595035, 0.12588625, 0.12582214, 0.12575807, 0.12569396, 0.12562987, 0.12556581, 0.12550174, 0.12543766, 0.1253736, 0.12530953, 0.12524548, 0.12518144, 0.12511739, 0.12505335, 0.12498931, 0.1249253, 0.12486126, 0.12479724, 0.12473325, 0.12466922, 0.12460522, 0.12454123, 0.12447724, 0.12441324, 0.12434927, 0.12428529, 0.1242213, 0.12415735, 0.12409339, 0.12402944, 0.12396548, 0.12390152, 0.12383758, 0.12377365, 0.12370971, 0.1236458, 0.12358185, 0.12351795, 0.12345403, 0.12339013, 0.12332621, 0.12326232, 0.12319843, 0.12313455, 0.12307066, 0.12300678, 0.12294291, 0.12287905, 0.12281518, 0.12275133, 0.12268747, 0.12262362, 0.12255979, 0.12249596, 0.12243212, 0.1223683, 0.12230448, 0.12224066, 0.12217683, 0.12211303, 0.12204924, 0.12198544, 0.12192165, 0.12185787, 0.12179409, 0.12173031, 0.12166654, 0.12160277, 0.12153901, 0.12147526, 0.1214115, 0.12134775, 0.12128402, 0.12122027, 0.12115655, 0.12109283, 0.12102909, 0.12096538, 0.12090168, 0.12083796, 0.12077426, 0.12071057, 0.12064687, 0.1205832, 0.12051953, 0.12045584, 0.12039217, 0.1203285, 0.12026486, 0.12020118, 0.12013754, 0.1200739, 0.12001026, 0.11994661, 0.11988299, 0.11981936, 0.11975575, 0.11969213, 0.11962851, 0.11956492, 0.11950132, 0.11943773, 0.11937413, 0.11931054, 0.11924697, 0.11918341, 0.11911984, 0.11905626, 0.1189927, 0.11892915, 0.11886561, 0.11880206, 0.11873852, 0.11867499, 0.11861146, 0.11854792, 0.11848442, 0.11842089, 0.11835739, 0.1182939, 0.1182304, 0.11816689, 0.11810341, 0.11803992, 0.11797646, 0.11791297, 0.11784951, 0.11778605, 0.11772258, 0.11765913, 0.11759569, 0.11753224, 0.1174688, 0.11740537, 0.11734194, 0.11727853, 0.1172151, 0.11715168, 0.11708829, 0.11702488, 0.11696147, 0.11689809, 0.1168347, 0.1167713, 0.11670794, 0.11664456, 0.11658119, 0.11651784, 0.11645449, 0.11639114, 0.11632778, 0.11626444, 0.1162011, 0.11613777, 0.11607444, 0.11601111, 0.1159478, 0.1158845, 0.11582118, 0.11575788, 0.11569458, 0.1156313, 0.115568, 0.11550472, 0.11544144, 0.11537819, 0.11531491, 0.11525164, 0.11518839, 0.11512515, 0.1150619, 0.11499865, 0.11493541, 0.11487218, 0.11480896, 0.11474575, 0.11468253, 0.11461931, 0.1145561, 0.11449291, 0.11442971, 0.11436652, 0.11430333, 0.11424015, 0.11417698, 0.11411381, 0.11405063, 0.11398748, 0.11392432, 0.11386117, 0.11379802, 0.11373488, 0.11367176, 0.11360862, 0.11354551, 0.11348236, 0.11341926, 0.11335616, 0.11329304, 0.11322995, 0.11316685, 0.11310375, 0.11304068, 0.11297759, 0.11291452, 0.11285145, 0.11278839, 0.11272533, 0.11266228, 0.11259923, 0.11253618, 0.11247315, 0.11241011, 0.11234707, 0.11228405, 0.11222105, 0.11215802, 0.11209501, 0.11203201, 0.11196901, 0.11190602, 0.11184303, 0.11178004, 0.11171706, 0.1116541, 0.11159112, 0.11152816, 0.1114652, 0.11140224, 0.1113393, 0.11127635, 0.11121341, 0.11115048, 0.11108755, 0.11102463, 0.11096171, 0.11089879, 0.11083588, 0.11077299, 0.11071008, 0.11064719, 0.1105843, 0.11052141, 0.11045855, 0.11039567, 0.1103328, 0.11026994, 0.11020708, 0.11014424, 0.11008138, 0.11001854, 0.1099557, 0.10989287, 0.10983004, 0.10976722, 0.1097044, 0.1096416, 0.10957879, 0.10951598, 0.10945318, 0.10939039, 0.10932761, 0.10926483, 0.10920204, 0.10913928, 0.10907651, 0.10901375, 0.10895099, 0.10888824, 0.10882548, 0.10876275, 0.1087, 0.10863728, 0.10857455, 0.10851182, 0.10844912, 0.1083864, 0.10832369, 0.10826099, 0.10819831, 0.1081356, 0.10807291, 0.10801023, 0.10794756, 0.1078849, 0.10782223, 0.10775957, 0.10769691, 0.10763427, 0.10757161, 0.10750897, 0.10744634, 0.10738371, 0.10732108, 0.10725847, 0.10719584, 0.10713323, 0.10707063, 0.10700803, 0.10694544, 0.10688284, 0.10682026, 0.10675769, 0.10669511, 0.10663253, 0.10656997, 0.10650741, 0.10644486, 0.1063823, 0.10631976, 0.10625722, 0.10619469, 0.10613216, 0.10606962, 0.10600711, 0.10594459, 0.10588209, 0.10581958, 0.10575707, 0.10569458, 0.1056321, 0.10556962, 0.10550713, 0.10544465, 0.10538219, 0.10531973, 0.10525727, 0.10519481, 0.10513236, 0.10506992, 0.10500748, 0.10494505, 0.10488262, 0.10482019, 0.10475777, 0.10469536, 0.10463295, 0.10457055, 0.10450815, 0.10444576, 0.10438337, 0.10432099, 0.1042586, 0.10419624, 0.10413386, 0.10407151, 0.10400914, 0.1039468, 0.10388445, 0.1038221, 0.10375976, 0.10369743, 0.1036351, 0.10357278, 0.10351046, 0.10344815, 0.10338584, 0.10332354, 0.10326124, 0.10319895, 0.10313667, 0.10307439, 0.10301211, 0.10294982, 0.10288756, 0.10282529, 0.10276304, 0.10270078, 0.10263854, 0.1025763, 0.10251407, 0.10245182, 0.1023896, 0.10232738, 0.10226516, 0.10220296, 0.10214075, 0.10207854, 0.10201634, 0.10195416, 0.10189196, 0.10182978, 0.10176761, 0.10170543, 0.10164328, 0.10158111, 0.10151896, 0.1014568, 0.10139466, 0.10133252, 0.10127039, 0.10120825, 0.10114612, 0.10108401, 0.10102189, 0.10095977, 0.10089767, 0.10083557, 0.10077348, 0.10071138, 0.1006493, 0.1005872, 0.10052514, 0.10046307, 0.10040101, 0.10033894, 0.10027689, 0.10021483, 0.1001528, 0.10009076, 0.10002872, 0.099966697, 0.099904664, 0.099842638, 0.099780627, 0.099718615, 0.099656612, 0.099594608, 0.099532619, 0.099470623, 0.099408641, 0.099346668, 0.099284686, 0.099222712, 0.099160746, 0.099098794, 0.099036843, 0.098974891, 0.098912939, 0.098851003, 0.098789074, 0.098727137, 0.098665223, 0.098603301, 0.098541386, 0.09847948, 0.098417573, 0.098355681, 0.098293774, 0.098231897, 0.098169997, 0.09810812, 0.098046251, 0.097984388, 0.097922526, 0.097860657, 0.097798809, 0.097736947, 0.097675115, 0.097613275, 0.097551443, 0.09748961, 0.097427785, 0.097365975, 0.097304165, 0.097242355, 0.097180538, 0.097118758, 0.097056963, 0.096995175, 0.096933387, 0.0968716, 0.096809834, 0.096748069, 0.096686296, 0.096624538, 0.096562795, 0.096501052, 0.096439309, 0.096377574, 0.096315831, 0.096254103, 0.09619239, 0.096130669, 0.096068949, 0.09600725, 0.095945545, 0.095883854, 0.095822155, 0.095760457, 0.095698796, 0.09563712, 0.095575437, 0.095513768, 0.095452122, 0.095390461, 0.095328793, 0.095267154, 0.095205508, 0.095143877, 0.095082246, 0.095020622, 0.094958991, 0.094897375, 0.094835773, 0.094774164, 0.094712563, 0.094650969, 0.094589382, 0.094527788, 0.094466209, 0.09440463, 0.094343059, 0.094281502, 0.09421993, 0.094158381, 0.094096832, 0.094035283, 0.093973741, 0.093912199, 0.093850672, 0.093789153, 0.093727633, 0.093666114, 0.093604594, 0.093543097, 0.093481593, 0.093420103, 0.093358606, 0.093297116, 0.093235642, 0.093174167, 0.0931127, 0.093051232, 0.092989773, 0.09292832, 0.092866875, 0.092805423, 0.092743978, 0.092682548, 0.092621125, 0.092559688, 0.09249828, 0.092436865, 0.09237545, 0.09231405, 0.092252649, 0.092191249, 0.092129856, 0.092068486, 0.092007093, 0.091945723, 0.091884352, 0.091822989, 0.091761634, 0.091700271, 0.09163893, 0.091577582, 0.091516249, 0.091454916, 0.091393583, 0.091332257, 0.091270939, 0.091209628, 0.091148317, 0.091087013, 0.09102571, 0.090964429, 0.090903133, 0.090841845, 0.090780579, 0.090719298, 0.090658031, 0.090596765, 0.090535522, 0.090474255, 0.090413004, 0.090351768, 0.090290524, 0.090229303, 0.090168066, 0.090106845, 0.090045631, 0.089984417, 0.089923203, 0.089862004, 0.089800812, 0.089739613, 0.089678422, 0.089617245, 0.089556068, 0.089494899, 0.08943373, 0.08937256, 0.089311406, 0.089250252, 0.089189105, 0.089127965, 0.089066826, 0.089005694, 0.088944577, 0.088883452, 0.08882232, 0.088761218, 0.088700116, 0.088639013, 0.088577919, 0.088516824, 0.088455737, 0.088394664, 0.088333577, 0.088272505, 0.08821144, 0.088150375, 0.088089332, 0.088028267, 0.087967224, 0.087906174, 0.087845147, 0.087784119, 0.087723091, 0.087662071, 0.087601051, 0.087540045, 0.087479033, 0.087418035, 0.087357037, 0.087296054, 0.087235071, 0.08717408, 0.087113105, 0.087052137, 0.086991169, 0.086930215, 0.086869247, 0.086808294, 0.086747371, 0.086686417, 0.086625487, 0.086564556, 0.086503632, 0.086442716, 0.086381786, 0.086320885, 0.086259976, 0.086199082, 0.086138181, 0.086077288, 0.086016409, 0.08595553, 0.085894659, 0.085833788, 0.085772917, 0.085712053, 0.085651204, 0.085590363, 0.085529514, 0.085468665, 0.085407846, 0.085347012, 0.085286193, 0.085225366, 0.085164547, 0.085103743, 0.085042939, 0.084982142, 0.084921338, 0.084860556, 0.084799774, 0.084738992, 0.084678225, 0.084617443, 0.084556691, 0.084495932, 0.084435172, 0.084374428, 0.084313683, 0.084252954, 0.084192209, 0.084131487, 0.084070757, 0.08401005, 0.083949342, 0.083888628, 0.08382792, 0.08376722, 0.083706528, 0.083645836, 0.083585158, 0.083524473, 0.083463803, 0.08340314, 0.083342478, 0.083281815, 0.083221167, 0.08316052, 0.083099872, 0.083039239, 0.082978606, 0.082917973, 0.08285737, 0.082796738, 0.082736127, 0.082675524, 0.082614914, 0.082554318, 0.08249373, 0.082433134, 0.082372561, 0.082311988, 0.082251415, 0.082190834, 0.082130283, 0.082069732, 0.082009174, 0.081948623, 0.081888087, 0.081827544, 0.081767023, 0.081706494, 0.081645973, 0.081585445, 0.081524931, 0.081464432, 0.081403933, 0.081343435, 0.081282943, 0.08122246, 0.081161983, 0.081101492, 0.081041038, 0.080980562, 0.080920108, 0.080859646, 0.0807992, 0.080738746, 0.080678321, 0.080617875, 0.080557443, 0.080497012, 0.080436595, 0.080376178, 0.080315776, 0.080255367, 0.080194965, 0.080134571, 0.080074191, 0.080013797, 0.079953417, 0.07989303, 0.079832673, 0.079772301, 0.079711951, 0.079651587, 0.079591244, 0.079530895, 0.07947056, 0.079410218, 0.079349898, 0.07928957, 0.079229243, 0.079168938, 0.079108626, 0.079048313, 0.078988031, 0.078927718, 0.078867435, 0.078807153, 0.078746878, 0.078686602, 0.078626335, 0.078566059, 0.078505799, 0.078445554, 0.078385301, 0.078325063, 0.078264825, 0.078204595, 0.078144357, 0.078084134, 0.078023918, 0.077963702, 0.077903494, 0.077843286, 0.077783093, 0.0777229, 0.077662699, 0.077602528, 0.077542342, 0.077482171, 0.077422015, 0.077361837, 0.077301688, 0.077241533, 0.077181384, 0.07712125, 0.077061094, 0.077000976, 0.076940849, 0.076880716, 0.076820612, 0.076760486, 0.076700374, 0.076640286, 0.076580174, 0.076520093, 0.076459996, 0.076399915, 0.076339856, 0.076279774, 0.0762197, 0.076159641, 0.076099582, 0.07603953, 0.075979471, 0.075919442, 0.075859413, 0.075799368, 0.075739354, 0.075679317, 0.07561931, 0.075559296, 0.075499281, 0.075439289, 0.075379282, 0.07531929, 0.07525932, 0.075199328, 0.075139351, 0.075079374, 0.075019404, 0.074959457, 0.074899487, 0.07483954, 0.074779607, 0.074719653, 0.074659728, 0.07459978, 0.074539863, 0.074479945, 0.074420027, 0.074360117, 0.074300207, 0.074240312, 0.074180424, 0.074120522, 0.074060634, 0.074000753, 0.073940881, 0.073881023, 0.073821142, 0.073761277, 0.073701419, 0.073641583, 0.073581733, 0.07352189, 0.073462054, 0.073402241, 0.073342405, 0.073282585, 0.073222764, 0.073162965, 0.07310316, 0.073043354, 0.072983555, 0.072923765, 0.072863989, 0.072804213, 0.072744429, 0.072684668, 0.072624885, 0.072565146, 0.072505385, 0.072445624, 0.0723859, 0.072326146, 0.072266407, 0.072206676, 0.072146967, 0.072087243, 0.072027534, 0.071967818, 0.071908109, 0.0718484, 0.071788728, 0.071729042, 0.071669348, 0.071609676, 0.071549997, 0.071490325, 0.071430676, 0.071371004, 0.071311347, 0.071251698, 0.071192056, 0.071132414, 0.071072794, 0.071013168, 0.070953541, 0.070893914, 0.070834301, 0.070774689, 0.0707151, 0.070655495, 0.070595898, 0.070539609, 0.070486628, 0.070433676, 0.07038077, 0.070327841, 0.070274949, 0.070222072, 0.070169218, 0.070116378, 0.070063591, 0.070010781, 0.069958016, 0.069905259, 0.069852524, 0.069799811, 0.069747128, 0.069694459, 0.069641799, 0.06958916, 0.069536537, 0.069483958, 0.069431387, 0.06937883, 0.069326289, 0.069273777, 0.069221281, 0.069168806, 0.069116354, 0.069063932, 0.069011495, 0.068959102, 0.068906754, 0.068854384, 0.068802066, 0.068749741, 0.068697445, 0.068645164, 0.068592913, 0.06854067, 0.068488471, 0.068436272, 0.068384103, 0.068331927, 0.068279803, 0.068227686, 0.068175592, 0.068123519, 0.068071455, 0.068019427, 0.067967422, 0.067915417, 0.067863442, 0.067811497, 0.067759544, 0.067707635, 0.067655735, 0.067603864, 0.067551993, 0.067500174, 0.067448348, 0.067396544, 0.06734477, 0.067293018, 0.067241289, 0.067189574, 0.06713786, 0.067086197, 0.067034543, 0.066982888, 0.066931285, 0.066879675, 0.066828109, 0.066776551, 0.066725001, 0.066673487, 0.066622004, 0.066570513, 0.066519067, 0.06646762, 0.066416197, 0.066364802, 0.066313423, 0.066262074, 0.066210732, 0.06615942, 0.066108115, 0.06605684, 0.066005573, 0.065954335, 0.06590312, 0.065851927, 0.065800734, 0.065749586, 0.06569843, 0.065647326, 0.06559623, 0.065545149, 0.065494083, 0.065443054, 0.06539201, 0.065341033, 0.065290034, 0.065239094, 0.065188155, 0.065137215, 0.065086335, 0.065035447, 0.06498459, 0.064933755, 0.064882927, 0.064832121, 0.064781338, 0.064730577, 0.064679846, 0.064629108, 0.064578429, 0.064527735, 0.064477071, 0.064426444, 0.06437581, 0.064325213, 0.064274631, 0.064224072, 0.064173527, 0.06412302, 0.064072512, 0.064022034, 0.063971564, 0.063921124, 0.063870691, 0.063820302, 0.063769922, 0.063719556, 0.06366922, 0.063618891, 0.06356857, 0.063518308, 0.063468039, 0.0634178, 0.06336759, 0.063317373, 0.063267194, 0.063217029, 0.063166894, 0.063116767, 0.063066661, 0.063016571, 0.062966503, 0.062916473, 0.062866457, 0.062816441, 0.062766455, 0.062716484, 0.062666543, 0.062616616, 0.062566727, 0.062516838, 0.062466979, 0.062417138, 0.062367305, 0.062317502, 0.062267721, 0.062217962, 0.062168203, 0.062118489, 0.062068764, 0.062019091, 0.061969433, 0.061919782, 0.061870158, 0.061820552, 0.061770961, 0.061721403, 0.061671849, 0.061622333, 0.061572835, 0.061523337, 0.06147388, 0.061424423, 0.061375011, 0.061325602, 0.061276209, 0.061226845, 0.061177496, 0.061128173, 0.061078884, 0.061029579, 0.060980324, 0.060931064, 0.060881834, 0.060832631, 0.060783457, 0.060734279, 0.060685132, 0.060636006, 0.0605869, 0.060537815, 0.060488746, 0.060439713, 0.060390662, 0.060341675, 0.060292665, 0.060243703, 0.060194768, 0.06014584, 0.06009692, 0.060048036, 0.059999164, 0.059950329, 0.059901495, 0.059852701, 0.059803899, 0.059755124, 0.059706382, 0.059657641, 0.059608947, 0.059560254, 0.059511587, 0.059462935, 0.059414309, 0.059365693, 0.059317119, 0.059268534, 0.059219994, 0.059171453, 0.059122946, 0.059074454, 0.059025995, 0.058977548, 0.058929112, 0.058880713, 0.058832314, 0.058783948, 0.058735602, 0.058687262, 0.058638956, 0.058590673, 0.058542386, 0.058494147, 0.058445912, 0.058397707, 0.058349513, 0.058301337, 0.058253184, 0.058205061, 0.058156949, 0.058108859, 0.05806078, 0.058012739, 0.057964709, 0.057916682, 0.0578687, 0.05782073, 0.057772785, 0.057724848, 0.057676926, 0.057629034, 0.057581171, 0.057533324, 0.057485487, 0.057437669, 0.057389881, 0.057342112, 0.057294358, 0.057246625, 0.057198912, 0.057151221, 0.057103548, 0.057055898, 0.057008263, 0.056960654, 0.056913059, 0.056865491, 0.056817923, 0.056770403, 0.056722868, 0.056675393, 0.056627918, 0.056580462, 0.056533027, 0.056485608, 0.056438208, 0.056390859, 0.056343485, 0.056296159, 0.056248851, 0.056201547, 0.056154281, 0.056107018, 0.056059796, 0.056012575, 0.055965379, 0.055918202, 0.055871047, 0.055823918, 0.055776808, 0.055729702, 0.055682629, 0.055635564, 0.055588536, 0.055541527, 0.055494532, 0.055447564, 0.055400606, 0.055353664, 0.055306744, 0.055259861, 0.055212982, 0.055166129, 0.05511928, 0.055072471, 0.055025663, 0.054978907, 0.054932147, 0.054885399, 0.054838683, 0.054791991, 0.054745305, 0.054698661, 0.054652017, 0.054605406, 0.054558802, 0.054512229, 0.054465681, 0.054419141, 0.054372627, 0.054326128, 0.054279644, 0.05423319, 0.054186743, 0.054140337, 0.054093949, 0.054047555, 0.054001205, 0.053954851, 0.053908538, 0.05386224, 0.053815968, 0.053769715, 0.053723469, 0.053677257, 0.053631056, 0.053584889, 0.053538725, 0.053492587, 0.053446457, 0.053400367, 0.053354274, 0.053308219, 0.053262185, 0.053216167, 0.053170159, 0.053124186, 0.053078219, 0.053032286, 0.052986369, 0.052940473, 0.052894592, 0.052848723, 0.052802898, 0.052757066, 0.052711278, 0.052665487, 0.052619737, 0.052573986, 0.052528262, 0.05248256, 0.052436896, 0.052391224, 0.052345593, 0.052299961, 0.05225436, 0.052208778, 0.052163225, 0.052117679, 0.052072156, 0.052026663, 0.051981177, 0.051935717, 0.05189028, 0.051844858, 0.05179945, 0.051754076, 0.051708698, 0.051663369, 0.051618051, 0.05157274, 0.051527463, 0.051482197, 0.05143695, 0.051391736, 0.051346529, 0.051301353, 0.051256187, 0.051211048, 0.051165931, 0.051120818, 0.051075749, 0.051030669, 0.050985642, 0.050940614, 0.050895598, 0.050850622, 0.050805658, 0.050760716, 0.050715797, 0.050670881, 0.050626006, 0.050581139, 0.050536301, 0.050491478, 0.050446667, 0.050401893, 0.050357126, 0.050312381, 0.050267655, 0.050222956, 0.050178267, 0.050133612, 0.050088953, 0.050044332, 0.049999725, 0.049955145, 0.049910586, 0.049866032, 0.049821503, 0.049776997, 0.049732517, 0.04968806, 0.04964361, 0.049599186, 0.049554788, 0.04951039, 0.049466033, 0.049421679, 0.049377363, 0.049333051, 0.049288761, 0.04924449, 0.049200255, 0.049156025, 0.049111824, 0.049067624, 0.049023468, 0.048979305, 0.048935194, 0.04889109, 0.048847001, 0.048802942, 0.048758887, 0.048714858, 0.048670851, 0.04862687, 0.0485829, 0.048538957, 0.048495017, 0.048451126, 0.048407219, 0.048363362, 0.048319511, 0.048275687, 0.048231874, 0.048188083, 0.048144314, 0.048100583, 0.048056856, 0.048013143, 0.047969449, 0.047925778, 0.04788214, 0.047838505, 0.047794901, 0.047751311, 0.047707744, 0.047664188, 0.047620662, 0.047577154, 0.047533672, 0.047490191, 0.04744675, 0.047403306, 0.047359906, 0.047316521, 0.047273152, 0.047229812, 0.047186464, 0.047143154, 0.047099873, 0.0470566, 0.047013346, 0.046970133, 0.046926908, 0.046883721, 0.046840534, 0.04679741, 0.046754267, 0.046711158, 0.046668068, 0.046624992, 0.046581935, 0.046538923, 0.0464959, 0.046452921, 0.046409946, 0.04636699, 0.046324063, 0.046281159, 0.046238266, 0.04619538, 0.046152543, 0.046109706, 0.046066891, 0.046024103, 0.045981336, 0.04593857, 0.045895845, 0.045853123, 0.045810435, 0.045767777, 0.045725118, 0.045682494, 0.045639869, 0.045597285, 0.045554709, 0.045512158, 0.045469627, 0.045427106, 0.045384612, 0.045342147, 0.045299675, 0.045257255, 0.045214843, 0.045172457, 0.045130074, 0.045087717, 0.04504538, 0.045003079, 0.044960778, 0.044918515, 0.044876259, 0.044834021, 0.044791814, 0.044749603, 0.044707444, 0.044665284, 0.044623148, 0.044581037, 0.044538938, 0.044496857, 0.044454817, 0.044412781, 0.04437077, 0.04432876, 0.044286791, 0.04424483, 0.044202905, 0.044160999, 0.044119086, 0.044077218, 0.044035364, 0.043993525, 0.04395172, 0.043909919, 0.043868139, 0.043826394, 0.043784641, 0.043742932, 0.043701228, 0.043659564, 0.043617904, 0.043576259, 0.04353464, 0.043493047, 0.043451477, 0.043409929, 0.043368392, 0.04332687, 0.043285381, 0.043243885, 0.043202445, 0.043161001, 0.043119587, 0.043078192, 0.043036807, 0.042995453, 0.042954117, 0.0429128, 0.042871512, 0.042830214, 0.042788956, 0.042747717, 0.042706508, 0.042665318, 0.042624123, 0.042582978, 0.042541843, 0.042500719, 0.042459629, 0.042418543, 0.042377483, 0.042336453, 0.042295419, 0.042254429, 0.042213447, 0.042172492, 0.042131554, 0.042090625, 0.042049725, 0.042008851, 0.041967995, 0.041927151, 0.041886341, 0.041845534, 0.041804753, 0.041763987, 0.04172327, 0.041682538, 0.041641846, 0.041601162, 0.041560497, 0.041519854, 0.041479245, 0.041438643, 0.041398067, 0.041357487, 0.041316953, 0.041276421, 0.041235927, 0.041195452, 0.041154996, 0.041114558, 0.041074131, 0.041033737, 0.040993351, 0.040952995, 0.040912651, 0.040872332, 0.040832024, 0.040791746, 0.040751465, 0.040711239, 0.040671024, 0.040630814, 0.040590636, 0.04055047, 0.040510319, 0.040470216, 0.04043011, 0.040390018, 0.04034996, 0.04030991, 0.040269908, 0.040229898, 0.040189922, 0.040149942, 0.040109999, 0.040070083, 0.04003017, 0.039990298, 0.039950442, 0.039910585, 0.039870776, 0.039830957, 0.039791174, 0.039751414, 0.039711677, 0.039671957, 0.039632242, 0.039592568, 0.039552897, 0.03951326, 0.039473642, 0.039434027, 0.039394427, 0.039354879, 0.039315324, 0.03927581, 0.039236307, 0.039196819, 0.039157357, 0.039117903, 0.039078478, 0.039039079, 0.038999699, 0.038960326, 0.038920976, 0.038881656, 0.038842361, 0.038803067, 0.038763814, 0.038724553, 0.038685337, 0.038646132, 0.038606934, 0.038567774, 0.038528632, 0.038489491, 0.038450398, 0.038411304, 0.038372241, 0.0383332, 0.038294174, 0.038255177, 0.038216174, 0.038177218, 0.038138263, 0.038099345, 0.038060438, 0.038021546, 0.03798268, 0.037943836, 0.037904993, 0.037866205, 0.037827399, 0.037788637, 0.037749887, 0.03771117, 0.037672453, 0.037633765, 0.037595101, 0.037556458, 0.037517834, 0.037479214, 0.037440632, 0.03740206, 0.037363529, 0.037324984, 0.037286483, 0.037247993, 0.037209522, 0.03717107, 0.037132643, 0.037094221, 0.037055846, 0.037017468, 0.03697912, 0.036940783, 0.036902487, 0.03686421, 0.036825936, 0.036787689, 0.036749445, 0.036711242, 0.036673062, 0.036634888, 0.036596723, 0.036558617, 0.036520492, 0.036482405, 0.036444325, 0.036406282, 0.036368243, 0.036330238, 0.03629224, 0.036254272, 0.036216326, 0.036178399, 0.036140483, 0.0361026, 0.036064722, 0.036026869, 0.035989057, 0.035951234, 0.035913441, 0.035875682, 0.035837919, 0.035800174, 0.035762478, 0.035724789, 0.035687119, 0.035649452, 0.035611831, 0.035574205, 0.035536636, 0.035499062, 0.035461497, 0.035423972, 0.035386447, 0.035348959, 0.035311509, 0.035274044, 0.035236612, 0.035199199, 0.035161797, 0.035124425, 0.035087068, 0.035049744, 0.035012439, 0.034975138, 0.034937855, 0.034900598, 0.034863383, 0.034826178, 0.034788966, 0.034751792, 0.034714639, 0.034677505, 0.034640405, 0.034603298, 0.034566235, 0.034529172, 0.034492139, 0.034455117, 0.034418136, 0.034381144, 0.034344215, 0.034307264, 0.034270357, 0.034233436, 0.034196582, 0.034159731, 0.034122884, 0.034086078, 0.034049284, 0.034012508, 0.033975754, 0.033939023, 0.033902295, 0.033865605, 0.033828933, 0.03379228, 0.033755615, 0.033719029, 0.033682425, 0.03364585, 0.033609286, 0.033572748, 0.033536229, 0.033499751, 0.033463266, 0.03342681, 0.033390373, 0.033353947, 0.033317573, 0.033281188, 0.033244845, 0.033208489, 0.033172179, 0.033135876, 0.033099595, 0.033063345, 0.033027112, 0.03299088, 0.032954689, 0.032918502, 0.032882355, 0.032846238, 0.032810107, 0.032774013, 0.032737918, 0.032701872, 0.032665823, 0.032629818, 0.032593817, 0.03255783, 0.032521877, 0.032485947, 0.032450002, 0.032414131, 0.032378241, 0.032342378, 0.032306548, 0.032270718, 0.032234918, 0.032199141, 0.032163396, 0.032127645, 0.032091931, 0.032056224, 0.032020558, 0.031984892, 0.031949267, 0.031913631, 0.031878028, 0.031842459, 0.031806886, 0.031771351, 0.03173583, 0.031700332, 0.031664848, 0.031629387, 0.031593949, 0.031558532, 0.031523135, 0.031487755, 0.031452376, 0.031417053, 0.031381726, 0.031346429, 0.031311143, 0.031275887, 0.031240635, 0.031205434, 0.031170219, 0.031135047, 0.031099873, 0.031064732, 0.031029612, 0.030994512, 0.030959433, 0.030924372, 0.030889332, 0.030854307, 0.030819306, 0.030784311, 0.030749355, 0.030714419, 0.030679503, 0.030644597, 0.030609716, 0.030574849, 0.030540008, 0.030505175, 0.030470381, 0.030435598, 0.030400841, 0.030366078, 0.030331356, 0.030296646, 0.030261977, 0.03022732, 0.030192671, 0.030158045, 0.030123437, 0.030088859, 0.030054295, 0.030019758, 0.029985227, 0.029950731, 0.029916236, 0.029881774, 0.029847329, 0.02981291, 0.029778507, 0.029744117, 0.029709747, 0.029675396, 0.029641094, 0.029606787, 0.029572498, 0.029538233, 0.029503983, 0.029469747, 0.029435571, 0.029401377, 0.029367208, 0.029333053, 0.029298941, 0.029264828, 0.029230744, 0.029196672, 0.029162638, 0.029128596, 0.029094594, 0.029060593, 0.029026655, 0.028992705, 0.028958768, 0.028924879, 0.028890973, 0.028857101, 0.028823277, 0.02878944, 0.028755637, 0.028721854, 0.028688077, 0.028654333, 0.028620606, 0.028586907, 0.028553214, 0.028519541, 0.028485889, 0.028452262, 0.028418669, 0.028385077, 0.02835151, 0.028317953, 0.028284432, 0.028250914, 0.028217439, 0.028183971, 0.028150525, 0.028117092, 0.028083675, 0.028050292, 0.028016938, 0.027983574, 0.027950251, 0.027916927, 0.027883647, 0.027850376, 0.027817134, 0.027783915, 0.027750697, 0.027717516, 0.027684329, 0.027651191, 0.027618051, 0.027584955, 0.027551858, 0.027518969, 0.027486334, 0.027453741, 0.027421148, 0.027388576, 0.027356023, 0.027323512, 0.027291002, 0.027258512, 0.027226042, 0.027193613, 0.027161205, 0.027128797, 0.02709643, 0.027064063, 0.027031736, 0.02699941, 0.026967127, 0.026934842, 0.026902597, 0.026870353, 0.026838152, 0.026805948, 0.026773766, 0.026741626, 0.026709506, 0.026677383, 0.026645305, 0.026613247, 0.026581187, 0.02654917, 0.026517153, 0.026485175, 0.026453219, 0.026421284, 0.026389347, 0.026357453, 0.026325559, 0.026293706, 0.026261853, 0.026230061, 0.026198229, 0.026166478, 0.026134707, 0.026102977, 0.026071247, 0.026039578, 0.026007909, 0.025976242, 0.025944635, 0.025913008, 0.025881423, 0.025849856, 0.025818313, 0.025786767, 0.025755282, 0.025723778, 0.025692316, 0.025660874, 0.025629451, 0.025598031, 0.025566671, 0.025535289, 0.025503971, 0.02547265, 0.025441334, 0.025410075, 0.025378797, 0.025347581, 0.025316345, 0.025285168, 0.025253994, 0.02522284, 0.025191706, 0.025160592, 0.025129499, 0.025098426, 0.025067354, 0.025036365, 0.025005333, 0.024974342, 0.024943374, 0.024912445, 0.024881516, 0.024850607, 0.024819741, 0.024788855, 0.024758028, 0.024727203, 0.024696417, 0.024665611, 0.024634868, 0.024604125, 0.024573401, 0.024542699, 0.024512038, 0.024481377, 0.024450757, 0.024420116, 0.024389537, 0.024358977, 0.02432842, 0.024297882, 0.024267362, 0.024236888, 0.024206411, 0.024175975, 0.02414554, 0.024115145, 0.024084752, 0.024054399, 0.024024047, 0.023993732, 0.023963401, 0.023933131, 0.02390288, 0.023872631, 0.023842398, 0.023812212, 0.023782043, 0.023751875, 0.023721747, 0.023691621, 0.023661533, 0.023631448, 0.023601424, 0.023571379, 0.023541376, 0.023511373, 0.02348141, 0.023451446, 0.023421524, 0.023391625, 0.023361724, 0.023331841, 0.023302022, 0.023272185, 0.023242386, 0.023212608, 0.02318285, 0.023153115, 0.023123378, 0.023093682, 0.023064008, 0.023034353, 0.023004699, 0.022975085, 0.022945492, 0.02291592, 0.022886349, 0.022856837, 0.022827307, 0.022797817, 0.022768347, 0.022738898, 0.02270947, 0.022680063, 0.022650676, 0.022621309, 0.022591963, 0.022562636, 0.022533331, 0.022504047, 0.022474784, 0.022445519, 0.022416316, 0.022387113, 0.022357933, 0.022328772, 0.022299632, 0.022270491, 0.022241412, 0.022212312, 0.022183273, 0.022154257, 0.022125218, 0.022096243, 0.022067266, 0.022038311, 0.022009376, 0.021980483, 0.021951567, 0.021922713, 0.021893861, 0.021865029, 0.021836217, 0.021807445, 0.021778656, 0.021749925, 0.021721197, 0.021692486, 0.021663819, 0.021635152, 0.021606524, 0.021577897, 0.02154929, 0.021520704, 0.021492161, 0.021463616, 0.021435112, 0.02140661, 0.021378145, 0.021349683, 0.021321241, 0.021292821, 0.021264441, 0.02123606, 0.02120772, 0.021179382, 0.021151084, 0.021122806, 0.021094527, 0.021066291, 0.021038055, 0.021009861, 0.020981666, 0.020953512, 0.020925358, 0.020897243, 0.020869132, 0.020841058, 0.020812986, 0.020784955, 0.020756925, 0.020728935, 0.020700965, 0.020672996, 0.020645067, 0.020617159, 0.020589273, 0.020561386, 0.020533541, 0.020505695, 0.020477911, 0.020450104, 0.020422341, 0.020394577, 0.020366875, 0.020339154, 0.020311471, 0.02028379, 0.020256171, 0.020228531, 0.020200931, 0.020173332, 0.020145793, 0.020118255, 0.020090718, 0.020063242, 0.020035746, 0.020008311, 0.019980855, 0.019953441, 0.019926047, 0.019898674, 0.019871321, 0.01984399, 0.019816676, 0.019789387, 0.019762095, 0.019734865, 0.019707635, 0.019680427, 0.019653218, 0.019626072, 0.019598924, 0.019571796, 0.019544691, 0.019517606, 0.019490561, 0.019463494, 0.019436492, 0.019409468, 0.019382507, 0.019355543, 0.019328602, 0.019301681, 0.019274801, 0.019247901, 0.01922106, 0.019194201, 0.019167405, 0.019140627, 0.01911385, 0.019087093, 0.019060357, 0.019033661, 0.019006968, 0.018980291, 0.018953638, 0.018927025, 0.018900411, 0.018873839, 0.018847268, 0.018820716, 0.018794186, 0.018767696, 0.018741207, 0.018714739, 0.018688289, 0.018661883, 0.018635495, 0.018609108, 0.018582763, 0.018556416, 0.018530112, 0.018503806, 0.018477544, 0.018451281, 0.018425057, 0.018398834, 0.018372653, 0.018346474, 0.018320331, 0.018294193, 0.018268092, 0.018241994, 0.018215956, 0.018189898, 0.01816386, 0.018137865, 0.018111888, 0.018085932, 0.018059978, 0.018034063, 0.01800815, 0.017982278, 0.017956425, 0.017930591, 0.017904758, 0.017878968, 0.017853178, 0.017827449, 0.017801678, 0.01777599, 0.0177503, 0.017724615, 0.017698988, 0.017673342, 0.017647734, 0.017622149, 0.017596584, 0.017571019, 0.017545516, 0.017519992, 0.017494529, 0.017469047, 0.017443607, 0.017418185, 0.017392786, 0.017367406, 0.017342044, 0.017316706, 0.017291388, 0.017266091, 0.017240813, 0.017215557, 0.01719032, 0.017165106, 0.017139912, 0.017114736, 0.017089583, 0.017064448, 0.017039336, 0.017014245, 0.016989172, 0.016964141, 0.016939091, 0.016914101, 0.016889092, 0.016864143, 0.016839195, 0.016814267, 0.01678938, 0.016764473, 0.016739627, 0.016714782, 0.016689958, 0.016665153, 0.016640389, 0.016615625, 0.016590903, 0.016566161, 0.016541479, 0.016516799, 0.016492158, 0.016467499, 0.016442899, 0.016418301, 0.016393742, 0.016369164, 0.016344646, 0.01632015, 0.016295655, 0.016271198, 0.016246745, 0.016222332, 0.016197916, 0.016173543, 0.016149171, 0.016124817, 0.016100485, 0.016076196, 0.016051903, 0.016027655, 0.016003406, 0.015979197, 0.015955009, 0.01593082, 0.015906675, 0.015882527, 0.015858421, 0.015834317, 0.015810251, 0.015786206, 0.015762184, 0.015738159, 0.015714178, 0.015690196, 0.015666254, 0.015642313, 0.015618433, 0.015594534, 0.015570674, 0.015546815, 0.015522997, 0.015499177, 0.015475402, 0.015451666, 0.015427909, 0.015404193, 0.015380478, 0.015356824, 0.015333151, 0.015309517, 0.015285905, 0.015262312, 0.015238721, 0.015215191, 0.01519164, 0.015168151, 0.015144642, 0.015121172, 0.015097703, 0.015074297, 0.015050909, 0.015027482, 0.015004138, 0.01498077, 0.014957466, 0.014934141, 0.014910878, 0.014887595, 0.014864373, 0.01484113, 0.014817949, 0.014794748, 0.014771607, 0.014748467, 0.014725348, 0.014702249, 0.014679172, 0.014656113, 0.014633098, 0.014610081, 0.014587063, 0.014564109, 0.014541154, 0.01451822, 0.014495306, 0.014472432, 0.01444954, 0.014426708, 0.014403877, 0.014381066, 0.014358276, 0.014335526, 0.014312776, 0.014290068, 0.014267339, 0.014244673, 0.014222026, 0.014199358, 0.014176752, 0.014154147, 0.014131582, 0.014109017, 0.014086475, 0.01406395, 0.014041468, 0.014018986, 0.013996545, 0.013974103, 0.013951704, 0.013929304, 0.013906945, 0.013884585, 0.013862268, 0.01383995, 0.013817674, 0.013795396, 0.01377314, 0.013750926, 0.01372871, 0.013706536, 0.013684362, 0.013662229, 0.013640096, 0.013618025, 0.013595933, 0.013573882, 0.013551832, 0.013529822, 0.013507813, 0.013485844, 0.013463876, 0.013441969, 0.013420041, 0.013398156, 0.013376289, 0.013354423, 0.013332599, 0.013310774, 0.013289011, 0.013267227, 0.013245486, 0.013223743, 0.013202062, 0.01318036, 0.0131587, 0.013137061, 0.013115441, 0.013093823, 0.013072265, 0.013050687, 0.013029151, 0.013007633, 0.012986138, 0.012964662, 0.012943188, 0.012921773, 0.012900339, 0.012878967, 0.012857574, 0.012836242, 0.012814891, 0.012793601, 0.012772289, 0.012751019, 0.01272977, 0.012708561, 0.012687334, 0.012666167, 0.012644978, 0.012623833, 0.012602727, 0.012581601, 0.012560536, 0.012539472, 0.012518428, 0.012497406, 0.012476402, 0.012455421, 0.01243448, 0.012413518, 0.012392618, 0.012371719, 0.01235086, 0.01232998, 0.012309162, 0.012288345, 0.012267548, 0.012246792, 0.012226036, 0.0122053, 0.012184585, 0.012163912, 0.012143238, 0.012122585, 0.012101952, 0.01208136, 0.012060769, 0.012040218, 0.012019668, 0.011999138, 0.011978628, 0.01195816, 0.011937692, 0.011917264, 0.011896838, 0.011876451, 0.011856086, 0.0118357, 0.011815375, 0.01179505, 0.011774767, 0.011754484, 0.011734242, 0.011713999, 0.011693798, 0.011673598, 0.011653458, 0.011633297, 0.011613178, 0.01159306, 0.011572982, 0.011552904, 0.011532867, 0.01151285, 0.011492834, 0.011472859, 0.011452884, 0.01143295, 0.011413016, 0.011393144, 0.011373252, 0.011353399, 0.011333548, 0.011313758, 0.011293947, 0.011274177, 0.011254407, 0.0112347, 0.011214972, 0.011195284, 0.011175597, 0.01115597, 0.011136345, 0.011116719, 0.011097134, 0.01107757, 0.011058027, 0.011038483, 0.011019002, 0.010999499, 0.010980058, 0.010960597, 0.010941177, 0.010921777, 0.010902398, 0.010883039, 0.010863701, 0.010844384, 0.010825087, 0.01080581, 0.010786554, 0.010767319, 0.010748104, 0.010728911, 0.010709736, 0.010690584, 0.010671451, 0.01065236, 0.010633248, 0.010614197, 0.010595126, 0.010576117, 0.010557108, 0.01053812, 0.010519151, 0.010500224, 0.010481277, 0.01046239, 0.010443524, 0.010424639, 0.010405815, 0.010386971, 0.010368187, 0.010349404, 0.010330661, 0.010311899, 0.010293198, 0.010274498, 0.010255838, 0.010237177, 0.010218538, 0.010199919, 0.010181341, 0.010162764, 0.010144227, 0.010125691, 0.010107195, 0.0100887, 0.010070225, 0.010051792, 0.010033357, 0.010014965, 0.0099965725, 0.0099782208, 0.0099598486, 0.0099415379, 0.0099232271, 0.0099049583, 0.0098866886, 0.0098684607, 0.0098502524, 0.0098320656, 0.0098138778, 0.0097957319, 0.0097776065, 0.0097594811, 0.0097413762, 0.0097233113, 0.0097052483, 0.0096872458, 0.0096692229, 0.0096512204, 0.0096332394, 0.0096153188, 0.0095973993, 0.0095794788, 0.0095615797, 0.0095437411, 0.009525883, 0.0095080659, 0.0094902487, 0.0094724931, 0.0094547169, 0.0094369818, 0.0094192876, 0.0094015729, 0.0093838796, 0.009366205, 0.0093486141, 0.0093309823, 0.0093133701, 0.0092957988, 0.0092782704, 0.0092607196, 0.0092432108, 0.0092257019, 0.009208275, 0.0091908071, 0.0091733597, 0.0091559533, 0.0091385879, 0.0091212224, 0.0091038579, 0.0090865539, 0.0090692509, 0.0090519469, 0.0090346849, 0.0090174638, 0.0090002418, 0.0089830207, 0.0089658406, 0.0089487014, 0.0089315614, 0.0089144437, 0.008897325, 0.0088802883, 0.0088632107, 0.0088461749, 0.0088292006, 0.0088121844, 0.0087952092, 0.0087782554, 0.0087613426, 0.0087444093, 0.008727516, 0.0087106442, 0.0086938338, 0.0086769825, 0.0086601721, 0.0086433822, 0.0086266538, 0.0086098844, 0.0085931569, 0.008576449, 0.0085598035, 0.0085431365, 0.0085264705, 0.0085098865, 0.0084932614, 0.0084766764, 0.0084601128, 0.0084436107, 0.0084271086, 0.008410586, 0.0083941044, 0.0083776843, 0.0083612436, 0.0083448244, 0.0083284043, 0.008312067, 0.0082957083, 0.0082793711, 0.0082630748, 0.008246799, 0.0082305223, 0.008214267, 0.0081980936, 0.0081818793, 0.008165665, 0.0081494916, 0.0081333797, 0.0081172483, 0.0081011364, 0.008085046, 0.0080690365, 0.0080529861, 0.0080369571, 0.0080209477, 0.0080050007, 0.0079890331, 0.0079731066, 0.00795718, 0.007941315, 0.0079254294, 0.0079095643, 0.0078937616, 0.007877958, 0.0078621544, 0.0078463713, 0.0078306505, 0.0078149084, 0.0077992077, 0.0077835079, 0.0077678687, 0.0077522299, 0.0077365912, 0.0077209724, 0.0077054366, 0.0076898588, 0.0076743024, 0.0076587866, 0.0076433122, 0.0076278374, 0.0076123634, 0.0075969496, 0.0075815166, 0.0075661242, 0.0075507322, 0.0075354218, 0.0075200708, 0.0075047603, 0.0074894503, 0.0074742227, 0.0074589532, 0.0074437256, 0.0074284975, 0.0074133519, 0.0073981653, 0.0073830187, 0.0073679141, 0.0073528094, 0.0073377262, 0.0073226416, 0.0073076398, 0.0072925971, 0.0072775949, 0.0072625931, 0.0072476738, 0.0072327331, 0.0072177928, 0.007202894, 0.0071880566, 0.0071731983, 0.0071583409, 0.0071435235, 0.0071287681, 0.0071139717, 0.0070992163, 0.0070845229, 0.0070698084, 0.0070550949, 0.0070404215, 0.0070258104, 0.0070111779, 0.0069965464, 0.0069819554, 0.0069674263, 0.0069528762, 0.0069383471, 0.0069238385, 0.0069093914, 0.0068949237, 0.0068804771, 0.0068660504, 0.0068516652, 0.00683728, 0.0068229148, 0.0068086116, 0.0067942878, 0.006779985, 0.0067657023, 0.006751481, 0.0067372401, 0.0067230188, 0.0067088185, 0.0066946796, 0.0066805203, 0.0066663818, 0.0066522635, 0.006638207, 0.0066241296, 0.0066100936, 0.0065960577, 0.0065820836, 0.0065680887, 0.0065541142, 0.0065402011, 0.0065262686, 0.0065123555, 0.0064984635, 0.0064846538, 0.0064708022, 0.0064569721, 0.006443162, 0.0064294343, 0.0064156651, 0.006401917, 0.0063881893, 0.006374544, 0.0063608573, 0.0063471911, 0.0063335663, 0.0063199825, 0.0063063777, 0.0062928144, 0.0062792921, 0.0062657492, 0.0062522274, 0.006238746, 0.0062253061, 0.0062118657, 0.0061984258, 0.0061850268, 0.0061716689, 0.0061583114, 0.0061449534, 0.006131616, 0.0061183609, 0.0061050649, 0.0060918098, 0.0060786163, 0.0060653817, 0.0060521676, 0.006038995, 0.0060258838, 0.0060127312, 0.0059996205, 0.0059865089, 0.0059734802, 0.0059604095, 0.0059473808, 0.0059343721, 0.0059214048, 0.0059084375, 0.0058954908, 0.005882544, 0.0058696792, 0.0058567938, 0.0058439085, 0.0058311061, 0.0058182827, 0.0058054794, 0.0057926765, 0.005779956, 0.0057671941, 0.0057544732, 0.0057417732, 0.0057291342, 0.0057164752, 0.0057038162, 0.0056911982, 0.0056786416, 0.005666065, 0.0056535085, 0.0056409724, 0.0056284987, 0.0056160041, 0.005603509, 0.0055910968, 0.0055786637, 0.005566251, 0.0055538588, 0.0055415286, 0.0055291778, 0.0055168476, 0.0055045378, 0.0054922896, 0.0054800208, 0.0054677729, 0.0054555456, 0.0054433797, 0.0054311929, 0.0054190271, 0.0054068817, 0.0053947978, 0.0053826934, 0.0053706099, 0.005358588, 0.0053465455, 0.005334523, 0.005322522, 0.005310582, 0.005298642, 0.0052867024, 0.0052747829, 0.0052629253, 0.0052510472, 0.0052392101, 0.005227373, 0.0052155973, 0.0052038017, 0.0051920465, 0.0051803328, 0.0051685986, 0.0051569049, 0.0051452117, 0.0051335804, 0.0051219487, 0.0051102964, 0.0050987061, 0.0050871568, 0.0050755865, 0.0050640581, 0.0050525288, 0.0050410824, 0.005029595, 0.0050181276, 0.0050067012, 0.0049953163, 0.0049839313, 0.0049725464, 0.0049612434, 0.0049498999, 0.0049385973, 0.0049272943, 0.0049160533, 0.0049048117, 0.0048935711, 0.0048823711, 0.0048712119, 0.0048600528, 0.0048489147, 0.0048377761, 0.0048267199, 0.0048156227, 0.004804567, 0.0047935308, 0.0047825361, 0.0047715418, 0.0047605676, 0.0047496352, 0.0047387024, 0.0047277901, 0.0047168774, 0.0047060475, 0.0046951761, 0.0046843463, 0.0046735369, 0.0046627885, 0.0046519996, 0.0046412516, 0.0046305242, 0.0046198587, 0.0046091517, 0.0045984858, 0.0045878408, 0.0045772572, 0.0045666532, 0.0045560696, 0.004545548, 0.0045349849, 0.0045244633, 0.0045139617, 0.0045035225, 0.0044930619, 0.0044826018, 0.0044721826, 0.0044618249, 0.0044514472, 0.0044410899, 0.0044307527, 0.0044204774, 0.0044101817, 0.0043999064, 0.0043896516, 0.0043794587, 0.0043692449, 0.0043590725, 0.0043489411, 0.0043387893, 0.0043286374, 0.0043185265, 0.004308477, 0.0042984281, 0.0042883786, 0.0042783502, 0.0042683831, 0.0042583956, 0.0042484286, 0.0042385031, 0.004228618, 0.0042187124, 0.0042088274, 0.0041990043, 0.0041891811, 0.0041793375, 0.0041695558, 0.0041598147, 0.004150074, 0.0041403328, 0.0041306126, 0.0041209538, 0.0041112746, 0.0041016364, 0.0040919981, 0.0040824213, 0.004072845, 0.0040632687, 0.0040537128, 0.0040442389, 0.0040347236, 0.0040252497, 0.0040158173, 0.0040063849, 0.003996952, 0.00398754, 0.0039781891, 0.0039688386, 0.0039594886, 0.0039501786, 0.0039409106, 0.003931642, 0.003922374, 0.0039131469, 0.0039039608, 0.0038947747, 0.0038856093, 0.0038764437, 0.0038673605, 0.0038582359, 0.0038491527, 0.003840131, 0.0038310683, 0.0038220468, 0.0038130456, 0.0038040855, 0.0037951048, 0.0037861653, 0.0037772462, 0.0037683686, 0.0037594906, 0.0037506334, 0.0037417966, 0.003733001, 0.0037242055, 0.0037154304, 0.003706676, 0.0036979625, 0.003689249, 0.0036805561, 0.0036719248, 0.0036632733, 0.0036546213, 0.003646011, 0.0036374617, 0.0036288921, 0.0036203433, 0.003611794, 0.0036033271, 0.0035948399, 0.0035863731, 0.0035779267, 0.0035695424, 0.0035611372, 0.0035527523, 0.0035443886, 0.0035360858, 0.0035277631, 0.0035194608, 0.00351122, 0.0035029587, 0.0034947179, 0.0034864976, 0.0034783392, 0.0034701601, 0.0034620014, 0.0034538636, 0.0034457871, 0.0034376902, 0.0034296138, 0.0034215581, 0.0034135638, 0.0034055698, 0.0033975756, 0.003389643, 0.00338169, 0.0033737575, 0.0033658457, 0.0033579953, 0.0033501245, 0.0033422948, 0.003334465, 0.0033267173, 0.0033189082, 0.0033111607, 0.003303413, 0.0032957273, 0.0032880413, 0.0032803554, 0.0032726901, 0.0032651071, 0.0032574828, 0.003249879, 0.0032423576, 0.0032347951, 0.003227253, 0.0032197519, 0.0032122922, 0.0032048116, 0.0031973724, 0.0031899333, 0.0031825555, 0.0031751778, 0.0031678004, 0.0031604636, 0.0031531684, 0.0031458728, 0.0031385776, 0.003131323, 0.0031241304, 0.0031168966, 0.003109704, 0.0031025524, 0.0030953803, 0.0030882494, 0.0030811387, 0.00307409, 0.0030670001, 0.0030599511, 0.0030529024, 0.0030459356, 0.0030389279, 0.0030319614, 0.0030250154, 0.0030181103, 0.0030112055, 0.0030043209, 0.0029974366, 0.0029906342, 0.0029838115, 0.0029770092, 0.0029702482, 0.0029634871, 0.0029567464, 0.0029500059, 0.0029433474, 0.0029366687, 0.0029300102, 0.0029233724, 0.0029167756, 0.0029101789, 0.0029036028, 0.0028970472, 0.0028905533, 0.0028840387, 0.0028775448, 0.0028711124, 0.0028646598, 0.0028582274, 0.0028518157, 0.0028454447, 0.0028390742, 0.002832724, 0.0028263947, 0.0028201267, 0.0028138382, 0.0028075702, 0.0028013228, 0.0027951372, 0.0027889311, 0.0027827453, 0.0027765802, 0.0027704765, 0.0027643526, 0.0027582492, 0.0027522277, 0.0027461653, 0.0027401235, 0.0027341021, 0.0027281425, 0.0027221623, 0.0027162028, 0.0027102635, 0.0027043861, 0.0026985086, 0.0026926312, 0.0026867744, 0.0026809792, 0.0026751838, 0.0026693884, 0.002663614, 0.002657901, 0.0026521881, 0.0026464746, 0.0026408236, 0.0026351721, 0.0026295206, 0.0026238898, 0.0026183412, 0.0026127514, 0.0026071824, 0.0026016338, 0.0025961671, 0.0025906598, 0.0025851931, 0.0025797267, 0.0025743218, 0.0025689171, 0.0025635124, 0.0025581487, 0.0025528262, 0.0025475037, 0.0025421809, 0.0025369406, 0.0025316591, 0.0025264185, 0.0025211785, 0.0025159996, 0.0025108415, 0.0025056629, 0.002500525, 0.0024954285, 0.0024903116, 0.0024852355, 0.00248018, 0.0024751658, 0.0024701513, 0.0024651578, 0.0024601638, 0.0024552522, 0.0024503202, 0.0024453879, 0.0024405383, 0.0024356677, 0.0024308176, 0.0024259679, 0.0024212, 0.0024163912, 0.0024116235, 0.0024068763, 0.0024021908, 0.0023974846, 0.0023927786, 0.0023881139, 0.0023835103, 0.0023788866, 0.0023742833, 0.0023697417, 0.0023651589, 0.0023606173, 0.0023560962, 0.0023516365, 0.0023471564, 0.0023426972, 0.0023382581, 0.0023338809, 0.0023294832, 0.0023250852, 0.0023207287, 0.0023164335, 0.002312118, 0.0023078229, 0.0023035484, 0.0022993356, 0.002295102, 0.0022908892, 0.002286738, 0.0022825866, 0.0022784355, 0.0022743051, 0.0022702359, 0.0022661465, 0.0022620773, 0.0022580291, 0.0022540423, 0.0022500348, 0.0022460478, 0.0022420816, 0.0022381977, 0.0022342724, 0.0022303681, 0.002226484, 0.0022226821, 0.0022188392, 0.0022150166, 0.0022112562, 0.0022074953, 0.0022037346, 0.0021999942, 0.0021963159, 0.0021926372, 0.0021889587, 0.0021853007, 0.0021817044, 0.0021781081, 0.0021745118, 0.002170936, 0.0021674423, 0.0021639077, 0.0021604139, 0.0021569205, 0.0021534886, 0.0021500564, 0.0021466245, 0.002143275, 0.002139884, 0.0021365343, 0.0021331846, 0.0021298965, 0.0021266085, 0.0021233202, 0.0021200734, 0.0021168881, 0.0021136615, 0.0021104557, 0.002107291, 0.0021041878, 0.0021010435, 0.0020979405, 0.0020948374, 0.0020918164, 0.0020887749, 0.0020857335, 0.0020827742, 0.0020797942, 0.0020768146, 0.0020738759, 0.0020709988, 0.0020680805, 0.0020652034, 0.0020623265, 0.0020595314, 0.002056716, 0.0020539213, 0.0020511264, 0.0020484137, 0.0020456805, 0.0020429678, 0.0020403168, 0.0020376453, 0.0020349738, 0.0020323433, 0.0020297745, 0.0020271849, 0.0020245956, 0.0020220473, 0.0020195814, 0.0020170535, 0.0020145671, 0.002012101, 0.0020096966, 0.0020072716, 0.0020048672, 0.0020024832, 0.0020001612, 0.0019978182, 0.0019954962, 0.0019932357, 0.0019909544, 0.0019886938, 0.0019864538, 0.0019842756, 0.0019820766, 0.0019798984, 0.0019777406, 0.0019756444, 0.0019735277, 0.0019714315, 0.0019693559, 0.0019673419, 0.0019653076, 0.0019632934, 0.0019613206, 0.0019593888, 0.0019574366, 0.001955505, 0.0019536347, 0.0019517646, 0.0019498945, 0.001948045, 0.0019462572, 0.0019444692, 0.0019426814, 0.0019409138, 0.0019392081, 0.0019374819, 0.0019357762, 0.0019341118, 0.0019324883, 0.0019308442, 0.0019292412, 0.0019276383, 0.0019261177, 0.0019245559, 0.0019230144   }, 
   { 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 2.5243977e-15, 6.0931302e-06, 1.8066345e-05, 3.0124775e-05, 4.2140597e-05, 5.428425e-05, 6.6385292e-05, 7.8571553e-05, 9.0715199e-05, 0.00010294408, 0.00011517294, 0.00012744442, 0.00013975851, 0.0001521152, 0.00016451451, 0.00017695643, 0.00018939834, 0.00020188287, 0.00021441001, 0.00022693713, 0.00023946428, 0.00025207663, 0.00026468898, 0.00027738657, 0.00029008414, 0.00030282431, 0.00031556451, 0.0003283899, 0.00034121529, 0.00035404068, 0.00036695128, 0.00037990452, 0.00039285774, 0.00040585359, 0.00041889204, 0.00043193047, 0.00044496896, 0.00045813521, 0.00047125886, 0.00048446778, 0.000497634, 0.0005109281, 0.0005241796, 0.00053751632, 0.00055085303, 0.00056423235, 0.00057765428, 0.00059107621, 0.00060454081, 0.0006180479, 0.00063159771, 0.00064514746, 0.00065873977, 0.00067237474, 0.00068600976, 0.00069972995, 0.00071345014, 0.00072721293, 0.00074097572, 0.00075482379, 0.00076867174, 0.00078260503, 0.0007964957, 0.00081042887, 0.00082444737, 0.00083846587, 0.00085252692, 0.00086658803, 0.0008807343, 0.00089483795, 0.00090902683, 0.00092325831, 0.00093748985, 0.00095176394, 0.00096603809, 0.00098039745, 0.0009947567, 0.0010092013, 0.0010236033, 0.0010380904, 0.0010525775, 0.0010670648, 0.0010816371, 0.0010962095, 0.0011108671, 0.0011255674, 0.0011402675, 0.0011549677, 0.0011697531, 0.001184496, 0.0011993666, 0.0012141946, 0.0012290227, 0.0012439786, 0.0012588919, 0.0012738904, 0.0012888887, 0.0013039724, 0.0013190135, 0.0013341398, 0.0013492663, 0.0013644351, 0.0013796466, 0.0013949007, 0.0014101975, 0.0014254516, 0.0014408336, 0.0014561729, 0.0014715975, 0.0014869794, 0.0015024466, 0.0015179563, 0.0015334662, 0.0015490612, 0.0015646135, 0.0015802511, 0.0015958888, 0.0016116117, 0.0016272919, 0.0016430572, 0.0016588228, 0.0016746308, 0.0016904814, 0.0017063322, 0.0017222679, 0.0017382038, 0.0017541824, 0.0017702034, 0.0017862245, 0.0018022882, 0.0018183946, 0.0018345435, 0.0018506924, 0.0018669266, 0.0018831607, 0.0018994374, 0.0019157142, 0.0019320336, 0.0019483955, 0.0019647575, 0.0019812046, 0.001997652, 0.0020141844, 0.0020306741, 0.0020472065, 0.0020638241, 0.0020803991, 0.0020971019, 0.0021137621, 0.0021305077, 0.0021472105, 0.0021639985, 0.0021807868, 0.0021976174, 0.0022145333, 0.0022314065, 0.002248365, 0.0022653237, 0.0022823673, 0.0022993684, 0.0023164547, 0.0023335409, 0.0023507127, 0.0023677989, 0.002385013, 0.0024022271, 0.0024194838, 0.0024367832, 0.0024540827, 0.0024714672, 0.002488852, 0.0025062792, 0.0025237063, 0.0025411763, 0.002558731, 0.0025762438, 0.0025938838, 0.002611439, 0.0026291215, 0.0026467619, 0.0026645302, 0.002682213, 0.0027000236, 0.0027178342, 0.002735645, 0.0027535409, 0.0027714367, 0.0027893754, 0.0028073138, 0.0028253375, 0.0028433611, 0.002861385, 0.0028794941, 0.002897603, 0.0029157544, 0.0029339485, 0.0029521852, 0.0029704224, 0.0029887443, 0.0030070236, 0.0030253457, 0.0030437529, 0.0030621602, 0.00308061, 0.0030991023, 0.0031176372, 0.0031361724, 0.00315475, 0.0031733275, 0.0031919482, 0.0032106533, 0.0032293163, 0.0032481072, 0.0032668551, 0.0032856883, 0.0033044792, 0.003323355, 0.003342231, 0.0033611497, 0.0033801531, 0.0033991144, 0.0034181608, 0.0034372071, 0.0034562962, 0.0034754276, 0.0034946019, 0.0035137762, 0.0035329503, 0.0035522524, 0.0035715117, 0.0035908138, 0.0036101583, 0.0036295454, 0.0036489328, 0.0036684051, 0.0036878351, 0.0037073074, 0.0037269078, 0.0037464227, 0.0037660659, 0.0037856661, 0.0038053514, 0.0038250796, 0.0038448076, 0.0038645358, 0.003884349, 0.0039041624, 0.0039240187, 0.0039439169, 0.0039638155, 0.0039837994, 0.0040037828, 0.0040238095, 0.0040438357, 0.0040639471, 0.0040840586, 0.0041041705, 0.0041243676, 0.0041445643, 0.0041648461, 0.0041850857, 0.0042054099, 0.0042257351, 0.004246145, 0.0042665545, 0.0042869644, 0.0043074596, 0.0043279119, 0.0043484922, 0.0043690298, 0.004389653, 0.0044102757, 0.0044309413, 0.0044516069, 0.0044723148, 0.0044931085, 0.0045138588, 0.0045346948, 0.0045555308, 0.0045764521, 0.0045973305, 0.0046183369, 0.004639301, 0.0046602646, 0.0046813563, 0.0047024051, 0.0047235396, 0.0047446736, 0.0047658929, 0.0047870697, 0.0048082895, 0.0048295516, 0.004850856, 0.0048722033, 0.0048935506, 0.0049149827, 0.0049363729, 0.0049578906, 0.0049793655, 0.0050008409, 0.0050224434, 0.0050440039, 0.0050656493, 0.0050872946, 0.0051090256, 0.0051307138, 0.0051524877, 0.0051742606, 0.0051960764, 0.0052179354, 0.0052397936, 0.0052617379, 0.0052836388, 0.0053056679, 0.0053276536, 0.0053496831, 0.0053717545, 0.0053938264, 0.005415983, 0.0054381401, 0.005460382, 0.005482581, 0.0055048657, 0.0055271508, 0.0055495203, 0.0055718478, 0.0055942177, 0.0056166728, 0.0056390855, 0.0056616259, 0.0056841234, 0.0057067061, 0.0057292464, 0.0057519148, 0.0057745404, 0.0057972511, 0.0058199619, 0.0058426722, 0.0058654686, 0.0058882646, 0.0059111458, 0.0059339842, 0.0059569078, 0.0059798323, 0.0060028411, 0.0060258075, 0.0060488167, 0.0060719107, 0.0060950047, 0.0061181844, 0.0061413213, 0.0061645433, 0.0061877226, 0.0062110303, 0.0062342947, 0.006257602, 0.0062809945, 0.0063043442, 0.0063278223, 0.0063512572, 0.0063747354, 0.0063982555, 0.0064218184, 0.0064453813, 0.0064689871, 0.0064926348, 0.0065162834, 0.0065400167, 0.0065637496, 0.0065875258, 0.0066113444, 0.0066352054, 0.0066590244, 0.0066829277, 0.0067068748, 0.006730821, 0.0067548528, 0.0067788842, 0.0068029584, 0.0068270327, 0.0068511921, 0.0068753092, 0.0068995114, 0.0069237556, 0.0069480003, 0.0069722878, 0.0069965748, 0.0070209475, 0.0070453198, 0.0070697777, 0.0070941928, 0.0071186507, 0.0071431939, 0.0071676942, 0.0071923221, 0.0072169076, 0.0072415783, 0.0072662067, 0.0072909202, 0.0073156762, 0.0073403893, 0.0073652309, 0.0073900293, 0.0074149561, 0.0074398397, 0.0074647665, 0.0074897353, 0.007514704, 0.0075397585, 0.0075647701, 0.0075899097, 0.0076150065, 0.0076401886, 0.0076653282, 0.0076905955, 0.0077158203, 0.00774113, 0.0077663972, 0.0077917501, 0.0078171454, 0.0078425398, 0.007867978, 0.007893458, 0.0079189809, 0.0079445047, 0.0079701124, 0.0079956781, 0.0080213286, 0.0080469791, 0.0080726733, 0.0080984524, 0.0081241876, 0.0081500085, 0.0081757875, 0.0082016941, 0.0082275579, 0.0082535073, 0.0082794558, 0.0083054053, 0.0083314395, 0.0083574736, 0.0083835935, 0.0084096696, 0.0084358742, 0.008462037, 0.0084881987, 0.008514489, 0.0085407356, 0.0085670687, 0.0085934019, 0.0086198188, 0.0086461948, 0.0086726546, 0.0086991154, 0.0087255752, 0.0087521635, 0.008778709, 0.0088052973, 0.0088319285, 0.0088586016, 0.0088852746, 0.0089120343, 0.0089387493, 0.0089655509, 0.0089923944, 0.0090192379, 0.0090461252, 0.0090730116, 0.0090999836, 0.0091269547, 0.0091540115, 0.0091810264, 0.0092080832, 0.0092352256, 0.0092623672, 0.0092895525, 0.0093167368, 0.0093440069, 0.0093712769, 0.0093985889, 0.0094259018, 0.0094532566, 0.0094806971, 0.0095080957, 0.0095355781, 0.0095630614, 0.0095906295, 0.0096181547, 0.0096457656, 0.0096733766, 0.0097010303, 0.009728726, 0.0097564226, 0.009784204, 0.0098119844, 0.0098398086, 0.0098676328, 0.0098955417, 0.0099234506, 0.0099513596, 0.0099793971, 0.010007391, 0.010035428, 0.010063508, 0.01009163, 0.010119751, 0.010147916, 0.010176124, 0.010204374, 0.010232624, 0.010260916, 0.010289252, 0.010317586, 0.010346008, 0.010374428, 0.010402891, 0.010431396, 0.010459944, 0.010488451, 0.01051704, 0.010545675, 0.010574307, 0.010603026, 0.010631745, 0.010660507, 0.010689267, 0.010718115, 0.010746919, 0.010775764, 0.010804696, 0.010833628, 0.010862603, 0.010891619, 0.010920678, 0.010949737, 0.01097884, 0.011007943, 0.011037087, 0.011066318, 0.011095548, 0.01112482, 0.011154092, 0.01118345, 0.011212809, 0.011242208, 0.01127161, 0.011301052, 0.011330538, 0.011360065, 0.011389636, 0.011419208, 0.011448821, 0.011478435, 0.011508133, 0.011537831, 0.011567573, 0.011597357, 0.011627141, 0.011657011, 0.011686879, 0.011716791, 0.011746703, 0.011776657, 0.011806696, 0.011836693, 0.011866775, 0.011896858, 0.011927025, 0.01195715, 0.01198736, 0.01201757, 0.012047823, 0.012078118, 0.012108456, 0.012138835, 0.012169174, 0.012199639, 0.012230063, 0.012260571, 0.012291036, 0.012321588, 0.012352181, 0.012382775, 0.01241341, 0.012444088, 0.01247481, 0.012505531, 0.012536339, 0.012567102, 0.012597951, 0.0126288, 0.012659691, 0.01269067, 0.012721603, 0.012752623, 0.012783643, 0.012814705, 0.012845768, 0.012876914, 0.012908061, 0.012939251, 0.012970484, 0.013001718, 0.013033035, 0.01306431, 0.01309567, 0.013127032, 0.013158476, 0.013189922, 0.013221367, 0.013252899, 0.01328443, 0.013316004, 0.013347619, 0.013379279, 0.013410936, 0.013442637, 0.013474339, 0.013506084, 0.013537913, 0.013569742, 0.013601614, 0.013633485, 0.013665442, 0.013697357, 0.013729399, 0.013761397, 0.013793441, 0.013825525, 0.013857652, 0.013889823, 0.01392195, 0.013954205, 0.013986417, 0.014018716, 0.014051013, 0.014083354, 0.014115738, 0.01414812, 0.014180631, 0.014213056, 0.01424561, 0.014278121, 0.014310675, 0.014343271, 0.014375866, 0.014408591, 0.014441272, 0.014473997, 0.014506763, 0.014539572, 0.014572381, 0.014605191, 0.014638127, 0.014671021, 0.014704001, 0.014736938, 0.014770003, 0.014803026, 0.014836133, 0.01486924, 0.01490239, 0.01493554, 0.014968733, 0.01500201, 0.015035288, 0.015068608, 0.015101929, 0.015135293, 0.015168699, 0.015202147, 0.015235594, 0.015269086, 0.015302619, 0.015336152, 0.015369771, 0.01540339, 0.015437094, 0.015470755, 0.015504502, 0.015538248, 0.015572038, 0.015605869, 0.015639702, 0.015673576, 0.015707493, 0.015741453, 0.015775412, 0.015809456, 0.01584346, 0.01587759, 0.015911678, 0.015945764, 0.015979979, 0.016014151, 0.016048409, 0.016082669, 0.016117012, 0.016151311, 0.016185654, 0.016220083, 0.016254468, 0.016288981, 0.016323453, 0.016357966, 0.016392523, 0.016427122, 0.016461721, 0.01649636, 0.016531089, 0.016565815, 0.016600585, 0.016635353, 0.016670164, 0.016704977, 0.016739916, 0.016774772, 0.016809709, 0.016844694, 0.016879717, 0.016914742, 0.01694981, 0.016984919, 0.01702003, 0.017055225, 0.017090421, 0.017125616, 0.017160939, 0.017196177, 0.017231543, 0.017266909, 0.017302316, 0.017337725, 0.017373176, 0.017408669, 0.017444164, 0.017479742, 0.01751532, 0.017550942, 0.017586563, 0.01762227, 0.017657977, 0.017693726, 0.017729474, 0.017765267, 0.017801143, 0.017837021, 0.017872941, 0.01790886, 0.017944865, 0.017980827, 0.018016875, 0.018052921, 0.018089054, 0.018125188, 0.018161319, 0.018197538, 0.018233756, 0.018270016, 0.018306278, 0.018342622, 0.018378967, 0.018415399, 0.018451788, 0.018488217, 0.018524734, 0.018561209, 0.018597767, 0.018634327, 0.018670971, 0.018707614, 0.018744299, 0.018780988, 0.018817717, 0.018854488, 0.018891303, 0.018928159, 0.018965017, 0.019001916, 0.01903886, 0.019075844, 0.019112827, 0.019149812, 0.019186925, 0.019223996, 0.019261109, 0.019298263, 0.019335462, 0.019372659, 0.019409943, 0.019447226, 0.019484509, 0.019521877, 0.019559246, 0.0195967, 0.019634111, 0.019671606, 0.019709103, 0.019746684, 0.019784223, 0.019821806, 0.01985947, 0.019897139, 0.019934846, 0.019972555, 0.02001035, 0.020048145, 0.02008594, 0.020123862, 0.02016174, 0.020199664, 0.020237628, 0.020275636, 0.020313643, 0.020351693, 0.020389786, 0.020427879, 0.020466056, 0.020504236, 0.020542454, 0.020580675, 0.020618983, 0.020657288, 0.020695636, 0.020734027, 0.020772416, 0.020810852, 0.020849328, 0.020887846, 0.020926366, 0.020964969, 0.021003529, 0.02104222, 0.021080866, 0.021119555, 0.021158289, 0.021197019, 0.021235837, 0.021274654, 0.021313513, 0.021352416, 0.02139136, 0.021430263, 0.021469293, 0.021508282, 0.021547312, 0.021586426, 0.021625498, 0.021664698, 0.021703858, 0.0217431, 0.0217823, 0.021821627, 0.021860916, 0.021900244, 0.021939615, 0.021978987, 0.022018442, 0.022057898, 0.02209744, 0.022136938, 0.022176523, 0.022216106, 0.022255734, 0.022295402, 0.022335071, 0.022374826, 0.022414539, 0.022454377, 0.022494175, 0.022534056, 0.022573898, 0.022613822, 0.022653788, 0.022693757, 0.022733809, 0.022773819, 0.022813916, 0.02285401, 0.022894189, 0.022934329, 0.02297451, 0.023014775, 0.023055041, 0.023095349, 0.023135656, 0.023176052, 0.023216445, 0.023256883, 0.023297317, 0.023337796, 0.023378359, 0.023418883, 0.023459531, 0.023500139, 0.023540786, 0.023581479, 0.023622213, 0.023662947, 0.023703704, 0.023744546, 0.023785386, 0.02382629, 0.023867173, 0.023908144, 0.023949111, 0.023990082, 0.024031155, 0.024072209, 0.024113329, 0.024154445, 0.024195649, 0.024236832, 0.024278078, 0.024319323, 0.024360653, 0.024401942, 0.024443295, 0.024484731, 0.024526127, 0.024567608, 0.024609089, 0.024650631, 0.024692155, 0.024733782, 0.024775371, 0.024817042, 0.024858693, 0.024900407, 0.024942165, 0.024983922, 0.025025763, 0.025067585, 0.025109492, 0.025151378, 0.025193347, 0.025235295, 0.025277264, 0.025319321, 0.025361376, 0.025403496, 0.025445614, 0.025487797, 0.025529981, 0.025572229, 0.025614474, 0.025656745, 0.025699096, 0.02574143, 0.025783846, 0.025826244, 0.025868725, 0.025911186, 0.025953688, 0.025996253, 0.026038822, 0.02608145, 0.026124083, 0.026166776, 0.026209472, 0.026252231, 0.026294988, 0.026337767, 0.026380632, 0.026423478, 0.026466405, 0.026509335, 0.026552327, 0.026595298, 0.026638355, 0.02668139, 0.026724469, 0.026767632, 0.026810775, 0.02685398, 0.026897185, 0.026940454, 0.026983725, 0.027027057, 0.027070392, 0.027113769, 0.02715721, 0.027200628, 0.027244132, 0.027287636, 0.027331203, 0.027374752, 0.027418382, 0.027462015, 0.027505668, 0.027549386, 0.027593102, 0.027636904, 0.027680686, 0.027724531, 0.027768375, 0.027812306, 0.027856214, 0.027900144, 0.027944161, 0.027988175, 0.028032348, 0.028076515, 0.028120721, 0.028164959, 0.028209232, 0.028253525, 0.028297881, 0.028342215, 0.028386604, 0.028431056, 0.028475497, 0.028520001, 0.028564529, 0.028609099, 0.0286537, 0.028698312, 0.028742965, 0.028787643, 0.028832361, 0.028877098, 0.028921904, 0.028966708, 0.029011542, 0.029056432, 0.029101344, 0.029146286, 0.029191246, 0.029236242, 0.029281262, 0.029326353, 0.029371433, 0.029416598, 0.029461753, 0.029506942, 0.029552191, 0.029597424, 0.029642727, 0.029688049, 0.029733395, 0.029778777, 0.02982422, 0.029869653, 0.029915169, 0.029960664, 0.030006194, 0.030051805, 0.030097399, 0.030143043, 0.030188711, 0.03023443, 0.030280149, 0.030325932, 0.030371727, 0.030417556, 0.030463433, 0.030509323, 0.030555278, 0.030601222, 0.030647216, 0.030693248, 0.030739285, 0.030785378, 0.030831516, 0.03087767, 0.030923838, 0.03097008, 0.031016311, 0.031062605, 0.031108912, 0.031155238, 0.031201618, 0.03124804, 0.031294476, 0.031340953, 0.031387471, 0.031433988, 0.031480573, 0.031527176, 0.03157378, 0.031620469, 0.031667136, 0.031713869, 0.031760644, 0.031807449, 0.031854276, 0.031901147, 0.031948008, 0.031994961, 0.032041885, 0.032088839, 0.032135881, 0.032182921, 0.032229993, 0.032277122, 0.032324269, 0.032371417, 0.032418657, 0.032465879, 0.032513175, 0.032560449, 0.032607779, 0.032655172, 0.03270255, 0.032749988, 0.032797452, 0.032844953, 0.032892462, 0.032940026, 0.032987617, 0.033035215, 0.033082906, 0.033130571, 0.033178285, 0.033226039, 0.033273835, 0.033321656, 0.033369474, 0.033417366, 0.033465281, 0.033513214, 0.033561174, 0.033609204, 0.033657223, 0.033705298, 0.033753406, 0.033801511, 0.03384969, 0.033897892, 0.033946127, 0.033994362, 0.03404269, 0.034090996, 0.034139369, 0.034187753, 0.034236148, 0.034284625, 0.034333095, 0.034381617, 0.034430169, 0.03447875, 0.034527346, 0.034576006, 0.03462467, 0.034673359, 0.034722127, 0.03477088, 0.034819715, 0.034868531, 0.034917403, 0.034966309, 0.035015225, 0.035064183, 0.035113186, 0.035162218, 0.035211261, 0.035260379, 0.035309486, 0.035358656, 0.035407826, 0.035457052, 0.035506297, 0.035555568, 0.035604887, 0.035654228, 0.035703611, 0.035753015, 0.035802476, 0.035851933, 0.035901446, 0.035950992, 0.03600052, 0.036050141, 0.036099773, 0.036149442, 0.036199145, 0.036248881, 0.036298625, 0.036348451, 0.036398251, 0.036448121, 0.036498006, 0.036547914, 0.036597863, 0.036647856, 0.036697879, 0.03674791, 0.036798012, 0.03684812, 0.036898289, 0.036948442, 0.036998626, 0.037048891, 0.037099138, 0.037149452, 0.037199795, 0.037250157, 0.037300553, 0.037351012, 0.037401453, 0.037451956, 0.03750249, 0.037553027, 0.037603624, 0.037654243, 0.037704907, 0.037755597, 0.037806306, 0.037857052, 0.037907854, 0.037958678, 0.038009498, 0.038060386, 0.038111281, 0.038162231, 0.038213201, 0.038264196, 0.038315274, 0.038366318, 0.038417418, 0.038468562, 0.038519733, 0.038570896, 0.038622167, 0.038673416, 0.038724683, 0.03877604, 0.038827382, 0.03887878, 0.0389302, 0.038981661, 0.039033141, 0.039084669, 0.039136197, 0.039187774, 0.039239395, 0.039291028, 0.039342735, 0.03939442, 0.039446164, 0.039497938, 0.039549749, 0.039601561, 0.039653428, 0.039705336, 0.039757248, 0.039809242, 0.039861225, 0.039913271, 0.039965317, 0.040017419, 0.04006955, 0.040121716, 0.04017387, 0.040226087, 0.04027836, 0.040330607, 0.040382963, 0.040435288, 0.040487688, 0.040540088, 0.040592536, 0.040645014, 0.040697489, 0.040750045, 0.040802624, 0.040855225, 0.040907849, 0.040960535, 0.041013211, 0.041065954, 0.041118722, 0.04117148, 0.041224316, 0.041277181, 0.041330069, 0.041383006, 0.041435968, 0.041488934, 0.041541968, 0.041595004, 0.041648064, 0.041701213, 0.04175432, 0.041807521, 0.041860722, 0.041913975, 0.041967232, 0.042020548, 0.042073872, 0.042127248, 0.04218065, 0.042234074, 0.042287558, 0.042341046, 0.042394567, 0.04244813, 0.042501729, 0.04255534, 0.042608999, 0.042662691, 0.042716388, 0.04277017, 0.042823922, 0.042877749, 0.042931594, 0.042985495, 0.043039411, 0.043093331, 0.043147303, 0.043201324, 0.043255363, 0.043309424, 0.04336356, 0.043417647, 0.043471806, 0.043526027, 0.043580249, 0.04363453, 0.043688804, 0.043743141, 0.043797515, 0.043851916, 0.043906312, 0.043960761, 0.044015247, 0.044069756, 0.044124324, 0.044178896, 0.044233516, 0.044288173, 0.044342849, 0.04439757, 0.044452302, 0.044507049, 0.044561863, 0.044616695, 0.044671547, 0.04472648, 0.044781394, 0.044836372, 0.044891369, 0.044946402, 0.045001451, 0.045056537, 0.045111667, 0.045166809, 0.045222025, 0.04527723, 0.045332503, 0.045387775, 0.045443099, 0.045498446, 0.045553841, 0.045609217, 0.045664664, 0.045720141, 0.04577563, 0.0458312, 0.045886751, 0.04594237, 0.045998007, 0.046053655, 0.046109386, 0.046165094, 0.046220854, 0.046276662, 0.046332486, 0.046388332, 0.046444252, 0.046500158, 0.046556082, 0.046612103, 0.046668116, 0.046724189, 0.04678024, 0.046836358, 0.046892505, 0.046948686, 0.04700489, 0.047061127, 0.047117405, 0.047173694, 0.047230065, 0.047286406, 0.047342811, 0.047399245, 0.047455724, 0.047512192, 0.047568735, 0.047625311, 0.047681905, 0.047738537, 0.04779518, 0.047851883, 0.047908574, 0.047965344, 0.048022129, 0.048078928, 0.048135776, 0.048192661, 0.04824958, 0.048306502, 0.048363503, 0.048420496, 0.04847753, 0.048534613, 0.048591688, 0.048648871, 0.04870601, 0.048763227, 0.048820447, 0.048877724, 0.048934992, 0.048992354, 0.049049683, 0.049107067, 0.049164504, 0.049221952, 0.049279448, 0.04933697, 0.049394533, 0.049452104, 0.04950973, 0.049567353, 0.049625061, 0.049682744, 0.049740478, 0.049798276, 0.049856067, 0.049913906, 0.049971782, 0.05002968, 0.050087623, 0.050145596, 0.050203577, 0.050261602, 0.050319672, 0.050377741, 0.050435897, 0.050494041, 0.050552238, 0.050610464, 0.05066872, 0.050726999, 0.050785314, 0.050843641, 0.050902016, 0.050960455, 0.051018886, 0.051077385, 0.051135868, 0.051194426, 0.051252998, 0.051311579, 0.05137023, 0.051428884, 0.051487587, 0.051546298, 0.051605113, 0.051663879, 0.051722694, 0.05178158, 0.051840458, 0.051899407, 0.051958345, 0.052017327, 0.052076355, 0.052135393, 0.052194465, 0.0522536, 0.052312735, 0.052371912, 0.052431144, 0.052490376, 0.052549679, 0.052608971, 0.052668288, 0.052727647, 0.052787054, 0.052846491, 0.052905962, 0.05296547, 0.053024985, 0.053084575, 0.053144157, 0.053203784, 0.053263441, 0.053323098, 0.05338284, 0.053442586, 0.053502388, 0.053562202, 0.053622056, 0.053681921, 0.053741869, 0.053801794, 0.053861734, 0.053921774, 0.053981796, 0.054041866, 0.054101985, 0.054162122, 0.054222282, 0.054282516, 0.054342721, 0.054403014, 0.054463286, 0.054523598, 0.054583978, 0.05464435, 0.054704793, 0.054765243, 0.054825738, 0.054886241, 0.054946814, 0.05500738, 0.055067971, 0.055128649, 0.0551893, 0.055250023, 0.055310782, 0.055371549, 0.055432368, 0.055493213, 0.055554073, 0.055614978, 0.055675901, 0.055736851, 0.055797882, 0.055858895, 0.05591996, 0.055981059, 0.056042191, 0.05610336, 0.056164537, 0.056225762, 0.056287013, 0.056348298, 0.05640959, 0.056470968, 0.056532338, 0.056593757, 0.056655213, 0.056716662, 0.056778181, 0.056839723, 0.056901302, 0.056962874, 0.057024535, 0.057086196, 0.057147924, 0.057209641, 0.057271399, 0.057333212, 0.057395026, 0.057456896, 0.057518788, 0.057580706, 0.05764265, 0.057704672, 0.057766668, 0.057828695, 0.057890806, 0.057952907, 0.058015089, 0.058077239, 0.058139462, 0.058201704, 0.058263965, 0.058326274, 0.058388621, 0.058450989, 0.058513384, 0.058575831, 0.05863829, 0.058700789, 0.058763325, 0.058825869, 0.058888469, 0.058951095, 0.059013765, 0.059076466, 0.059139196, 0.059201922, 0.059264738, 0.059327535, 0.0593904, 0.059453283, 0.059516173, 0.059579115, 0.059642103, 0.059705112, 0.059768155, 0.059831243, 0.059894327, 0.059957486, 0.06002064, 0.060083851, 0.060147077, 0.060210329, 0.060273636, 0.060336962, 0.060400333, 0.060463719, 0.060527161, 0.060590591, 0.060654119, 0.060717613, 0.060781136, 0.06084476, 0.060908355, 0.060971998, 0.0610357, 0.061099403, 0.061163135, 0.061226919, 0.061290726, 0.061354548, 0.061418436, 0.061482321, 0.06154627, 0.061610233, 0.061674245, 0.061738279, 0.061802339, 0.061866436, 0.06193056, 0.061994735, 0.062058888, 0.062123131, 0.06218737, 0.062251668, 0.062315993, 0.062380321, 0.062444717, 0.062509127, 0.062573582, 0.062638067, 0.062702566, 0.062767096, 0.062831692, 0.062896274, 0.0629609, 0.063025601, 0.06309028, 0.063155025, 0.063219793, 0.063284598, 0.063349441, 0.063414291, 0.063479163, 0.063544087, 0.063609056, 0.063674025, 0.063739084, 0.063804127, 0.063869208, 0.063934341, 0.063999474, 0.064064629, 0.064129852, 0.064195104, 0.064260364, 0.06432569, 0.064391024, 0.064456426, 0.064521819, 0.064587243, 0.064652719, 0.064718202, 0.064783737, 0.064849302, 0.064914897, 0.064980514, 0.065046199, 0.065111876, 0.065177605, 0.065243363, 0.065309159, 0.065374941, 0.065440804, 0.065506689, 0.065572605, 0.065638557, 0.065704525, 0.065770566, 0.065836586, 0.065902658, 0.065968774, 0.066034883, 0.066101052, 0.066167265, 0.066233508, 0.066299751, 0.066366084, 0.066432402, 0.066498779, 0.066565156, 0.066631578, 0.066698052, 0.066764511, 0.066831037, 0.066897601, 0.066964187, 0.067030795, 0.067097478, 0.067164131, 0.06723085, 0.0672976, 0.067364365, 0.067431159, 0.067498006, 0.06756489, 0.067631796, 0.067698732, 0.06776569, 0.067832686, 0.067899734, 0.067966774, 0.068033904, 0.068100996, 0.068168156, 0.06823536, 0.068302572, 0.068369851, 0.068437129, 0.068504438, 0.068571806, 0.068639189, 0.068706587, 0.068774052, 0.06884151, 0.068909004, 0.068976574, 0.069044143, 0.06911175, 0.069179386, 0.069247074, 0.06931477, 0.069382511, 0.069450259, 0.069518067, 0.069585897, 0.069653742, 0.069721662, 0.069789574, 0.069857545, 0.069925539, 0.069993556, 0.070061617, 0.070129722, 0.070197791, 0.070265919, 0.070334144, 0.070402332, 0.070470609, 0.070538864, 0.070607178, 0.070675522, 0.070743904, 0.070812292, 0.070880719, 0.070949189, 0.071017683, 0.071086228, 0.071154796, 0.071223415, 0.071292013, 0.071360692, 0.071429387, 0.071498096, 0.071566842, 0.071635641, 0.071704462, 0.071773298, 0.071842209, 0.071911111, 0.071980059, 0.072049044, 0.072118044, 0.072187111, 0.072256155, 0.072325267, 0.072394408, 0.072463594, 0.07253278, 0.072602041, 0.072671287, 0.072740577, 0.07280992, 0.072879277, 0.072948657, 0.073018089, 0.073087551, 0.073157027, 0.073226586, 0.073296115, 0.073365703, 0.073435329, 0.073504962, 0.07357467, 0.073644355, 0.073714107, 0.073783889, 0.073853709, 0.073923536, 0.073993407, 0.074063323, 0.07413324, 0.07420323, 0.074273214, 0.074343279, 0.074413322, 0.074483424, 0.074553572, 0.074623697, 0.074693903, 0.074764132, 0.074834384, 0.074904665, 0.074975006, 0.07504534, 0.075115703, 0.075186141, 0.075256564, 0.075327076, 0.075397581, 0.07546813, 0.075538702, 0.075609319, 0.075679943, 0.075750642, 0.07582131, 0.075892039, 0.075962827, 0.076033615, 0.076104455, 0.076175317, 0.076246209, 0.076317146, 0.076388106, 0.076459087, 0.076530106, 0.07660117, 0.076672226, 0.076743372, 0.076814517, 0.076885693, 0.07695692, 0.077028178, 0.07709942, 0.077170767, 0.077242076, 0.077313438, 0.077384867, 0.077456288, 0.077527791, 0.077599265, 0.077670805, 0.077742383, 0.077813983, 0.077885598, 0.077957273, 0.07802894, 0.078100652, 0.078172438, 0.078244217, 0.07831604, 0.078387901, 0.078459762, 0.078531712, 0.078603648, 0.078675628, 0.078747623, 0.07881967, 0.078891739, 0.078963876, 0.07903599, 0.079108149, 0.079180382, 0.079252608, 0.079324901, 0.079397179, 0.079469495, 0.079541877, 0.079614274, 0.079686686, 0.079759158, 0.079831652, 0.079904154, 0.079976745, 0.080049306, 0.080121934, 0.080194578, 0.080267258, 0.080339961, 0.080412716, 0.080485493, 0.0805583, 0.080631167, 0.080704018, 0.080776952, 0.080849871, 0.080922835, 0.08099585, 0.081068859, 0.081141919, 0.081215039, 0.081288159, 0.081361309, 0.081434533, 0.081507757, 0.081580997, 0.081654288, 0.081727624, 0.081800945, 0.081874333, 0.081947766, 0.082021222, 0.082094699, 0.082168192, 0.082241744, 0.082315356, 0.082388937, 0.082462557, 0.082536258, 0.082609937, 0.082683675, 0.082757458, 0.082831264, 0.082905099, 0.082978964, 0.083052844, 0.083126768, 0.083200738, 0.083274715, 0.083348751, 0.083422802, 0.083496891, 0.083571024, 0.083645172, 0.083719321, 0.083793551, 0.083867811, 0.083942063, 0.084016412, 0.084090732, 0.084165096, 0.084239528, 0.084313951, 0.084388442, 0.084462918, 0.084537454, 0.084612027, 0.084686637, 0.08476124, 0.084835939, 0.084910624, 0.084985346, 0.08506009, 0.085134894, 0.085209712, 0.085284553, 0.085359447, 0.085434362, 0.085509323, 0.08558429, 0.085659288, 0.085734345, 0.085809432, 0.085884519, 0.08595968, 0.086034827, 0.086110048, 0.086185284, 0.086260535, 0.086335875, 0.086411186, 0.086486548, 0.086561941, 0.086637385, 0.08671283, 0.086788312, 0.086863838, 0.086939394, 0.087015003, 0.087090604, 0.087166257, 0.08724194, 0.087317653, 0.087393403, 0.087469198, 0.087545015, 0.087620839, 0.087696724, 0.087772638, 0.087848544, 0.087924525, 0.088000529, 0.088076584, 0.088157646, 0.08824385, 0.088330097, 0.088416286, 0.088502549, 0.088588789, 0.088675097, 0.088761374, 0.088847637, 0.088933945, 0.089020245, 0.08910659, 0.089192905, 0.089279249, 0.089365587, 0.089451991, 0.089538366, 0.089624748, 0.089711145, 0.089797564, 0.089883998, 0.089970417, 0.090056889, 0.09014333, 0.090229787, 0.090316281, 0.090402782, 0.090489283, 0.090575784, 0.090662308, 0.090748876, 0.09083543, 0.090921968, 0.091008529, 0.091095112, 0.091181718, 0.091268323, 0.091354944, 0.091441564, 0.091528215, 0.091614865, 0.09170153, 0.09178821, 0.09187489, 0.091961578, 0.09204828, 0.092135012, 0.092221737, 0.092308462, 0.092395224, 0.092481993, 0.09256877, 0.092655554, 0.092742339, 0.092829183, 0.092915989, 0.093002811, 0.093089677, 0.093176529, 0.093263373, 0.093350239, 0.09343715, 0.093524054, 0.093610957, 0.093697891, 0.093784824, 0.093871765, 0.093958713, 0.094045699, 0.094132647, 0.09421967, 0.094306648, 0.094393678, 0.094480716, 0.094567746, 0.094654784, 0.094741836, 0.094828911, 0.094915986, 0.095003076, 0.095090173, 0.0951773, 0.095264427, 0.095351562, 0.095438711, 0.095525876, 0.095613055, 0.095700219, 0.095787436, 0.09587463, 0.095961839, 0.096049078, 0.096136332, 0.096223578, 0.096310832, 0.0963981, 0.096485399, 0.09657269, 0.096660003, 0.096747302, 0.09683463, 0.096921988, 0.097009331, 0.097096711, 0.097184055, 0.097271457, 0.097358868, 0.097446278, 0.097533695, 0.097621121, 0.097708553, 0.097796001, 0.097883485, 0.097970963, 0.098058477, 0.098145954, 0.098233461, 0.098320976, 0.098408513, 0.098496079, 0.098583631, 0.098671198, 0.098758757, 0.098846361, 0.098933965, 0.099021584, 0.099109188, 0.099196851, 0.099284492, 0.099372141, 0.099459812, 0.099547498, 0.099635191, 0.099722899, 0.099810615, 0.099898331, 0.099986061, 0.10007381, 0.10016159, 0.10024935, 0.10033713, 0.10042493, 0.10051271, 0.10060056, 0.10068838, 0.10077622, 0.10086405, 0.10095193, 0.10103981, 0.10112771, 0.10121558, 0.1013035, 0.1013914, 0.10147934, 0.1015673, 0.10165524, 0.10174319, 0.10183117, 0.10191917, 0.10200717, 0.10209516, 0.10218318, 0.10227124, 0.10235927, 0.10244732, 0.10253538, 0.10262346, 0.10271156, 0.10279964, 0.10288778, 0.1029759, 0.10306402, 0.10315217, 0.10324034, 0.1033285, 0.10341668, 0.10350485, 0.10359305, 0.10368129, 0.10376951, 0.10385776, 0.10394597, 0.10403425, 0.1041225, 0.10421079, 0.1042991, 0.1043874, 0.1044757, 0.10456402, 0.10465238, 0.10474072, 0.10482909, 0.10491743, 0.10500584, 0.10509423, 0.10518262, 0.10527106, 0.10535949, 0.10544792, 0.10553638, 0.10562483, 0.10571331, 0.10580179, 0.10589029, 0.10597881, 0.10606732, 0.10615584, 0.10624437, 0.10633293, 0.10642151, 0.10651007, 0.10659866, 0.10668726, 0.10677586, 0.10686448, 0.10695314, 0.10704175, 0.10713044, 0.10721909, 0.10730775, 0.10739647, 0.10748515, 0.10757387, 0.10766259, 0.10775131, 0.10784008, 0.10792883, 0.10801757, 0.10810638, 0.10819517, 0.10828397, 0.1083728, 0.1084616, 0.10855044, 0.10863928, 0.10872814, 0.10881703, 0.10890589, 0.10899478, 0.10908369, 0.10917259, 0.10926154, 0.10935046, 0.10943941, 0.10952839, 0.10961735, 0.10970633, 0.10979532, 0.10988432, 0.10997335, 0.11006239, 0.11015143, 0.11024045, 0.11032953, 0.1104186, 0.1105077, 0.11059678, 0.1106859, 0.11077502, 0.11086414, 0.11095328, 0.11104243, 0.11113159, 0.11122077, 0.11130996, 0.11139917, 0.11148836, 0.11157759, 0.11166682, 0.11175606, 0.11184533, 0.11193458, 0.11202385, 0.11211314, 0.11220245, 0.11229177, 0.1123811, 0.11247042, 0.11255977, 0.11264913, 0.1127385, 0.11282787, 0.11291726, 0.11300664, 0.11309607, 0.11318549, 0.11327495, 0.11336438, 0.11345384, 0.11354332, 0.11363278, 0.11372229, 0.1138118, 0.11390132, 0.11399084, 0.11408036, 0.11416992, 0.11425948, 0.11434904, 0.11443862, 0.11452822, 0.11461783, 0.11470746, 0.11479707, 0.11488672, 0.11497637, 0.11506603, 0.1151557, 0.11524536, 0.11533508, 0.11542479, 0.1155145, 0.11560424, 0.11569398, 0.11578373, 0.11587349, 0.11596328, 0.11605306, 0.11614285, 0.11623266, 0.11632248, 0.11641233, 0.11650215, 0.116592, 0.11668188, 0.11677175, 0.11686164, 0.11695155, 0.11704144, 0.11713137, 0.11722131, 0.11731127, 0.11740121, 0.11749119, 0.11758117, 0.11767113, 0.11776114, 0.11785117, 0.11794119, 0.11803123, 0.11812127, 0.11821133, 0.11830141, 0.11839148, 0.11848157, 0.11857168, 0.11866179, 0.11875192, 0.11884207, 0.1189322, 0.11902235, 0.11911254, 0.11920272, 0.11929291, 0.1193831, 0.11947334, 0.11956355, 0.11965381, 0.11974407, 0.11983431, 0.11992458, 0.12001487, 0.12010518, 0.12019549, 0.12028579, 0.12037612, 0.12046646, 0.12055682, 0.1206472, 0.12073755, 0.12082794, 0.12091835, 0.12100875, 0.12109918, 0.1211896, 0.12128004, 0.12137052, 0.12146097, 0.12155145, 0.12164193, 0.12173243, 0.12182293, 0.12191347, 0.12200401, 0.12209454, 0.12218509, 0.12227567, 0.12236625, 0.12245684, 0.12254746, 0.12263804, 0.12272868, 0.12281931, 0.12290996, 0.12300064, 0.12309127, 0.12318197, 0.12327266, 0.12336335, 0.12345409, 0.1235448, 0.12363555, 0.1237263, 0.12381706, 0.12390783, 0.1239986, 0.1240894, 0.12418021, 0.12427102, 0.12436185, 0.12445268, 0.12454354, 0.12463439, 0.12472528, 0.12481616, 0.12490703, 0.12499796, 0.12508889, 0.12517981, 0.12527075, 0.1253617, 0.12545268, 0.12554364, 0.12563463, 0.12572564, 0.12581664, 0.12590766, 0.12599869, 0.12608972, 0.12618081, 0.12627184, 0.12636292, 0.12645403, 0.12654512, 0.12663624, 0.12672734, 0.12681848, 0.12690963, 0.12700079, 0.12709196, 0.12718312, 0.12727432, 0.12736553, 0.12745674, 0.12754796, 0.1276392, 0.12773044, 0.1278217, 0.12791297, 0.12800427, 0.12809557, 0.12818685, 0.12827817, 0.1283695, 0.12846082, 0.12855218, 0.12864354, 0.1287349, 0.12882629, 0.12891769, 0.1290091, 0.12910052, 0.12919194, 0.12928338, 0.12937483, 0.1294663, 0.12955776, 0.12964925, 0.12974074, 0.12983224, 0.12992378, 0.1300153, 0.13010684, 0.13019839, 0.13028997, 0.13038154, 0.13047312, 0.1305647, 0.13065632, 0.13074794, 0.13083957, 0.13093121, 0.13102287, 0.13111454, 0.13120623, 0.1312979, 0.13138959, 0.13148132, 0.13157304, 0.13166477, 0.13175653, 0.13184828, 0.13194004, 0.13203183, 0.13212362, 0.13221541, 0.13230722, 0.13239905, 0.13249087, 0.13258272, 0.13267459, 0.13276647, 0.13285834, 0.13295022, 0.13304214, 0.13313405, 0.13322596, 0.1333179, 0.13340986, 0.13350181, 0.1335938, 0.13368578, 0.13377777, 0.13386977, 0.13396177, 0.13405383, 0.13414587, 0.1342379, 0.13432996, 0.13442203, 0.13451412, 0.13460623, 0.13469832, 0.13479045, 0.13488258, 0.13497473, 0.1350669, 0.13515903, 0.13525121, 0.1353434, 0.13543558, 0.13552782, 0.13562001, 0.13571227, 0.13580449, 0.13589676, 0.13598903, 0.13608129, 0.13617359, 0.13626589, 0.13635819, 0.13645053, 0.13654286, 0.1366352, 0.13672756, 0.13681993, 0.13691229, 0.1370047, 0.13709708, 0.13718949, 0.13728192, 0.13737436, 0.13746679, 0.13755926, 0.13765173, 0.1377442, 0.13783671, 0.13792922, 0.13802172, 0.13811424, 0.13820679, 0.13829935, 0.1383919, 0.13848446, 0.13857706, 0.13866964, 0.13876225, 0.13885488, 0.13894749, 0.13904013, 0.1391328, 0.13922545, 0.13931811, 0.13941081, 0.13950349, 0.13959621, 0.13968894, 0.13978167, 0.1398744, 0.13996714, 0.14005992, 0.14015268, 0.14024548, 0.14033826, 0.14043108, 0.14052391, 0.14061673, 0.14070958, 0.14080241, 0.14089529, 0.14098817, 0.14108106, 0.14117396, 0.14126685, 0.14135978, 0.14145273, 0.14154567, 0.14163864, 0.14173159, 0.14182457, 0.14191756, 0.14201057, 0.14210358, 0.1421966, 0.14228964, 0.14238268, 0.14247574, 0.14256883, 0.14266188, 0.14275499, 0.14284809, 0.14294119, 0.14303432, 0.14312749, 0.1432206, 0.14331377, 0.14340694, 0.14350015, 0.14359333, 0.14368653, 0.14377974, 0.14387298, 0.14396621, 0.14405946, 0.14415272, 0.144246, 0.14433928, 0.14443259, 0.14452589, 0.1446192, 0.14471252, 0.14480586, 0.14489922, 0.14499259, 0.14508596, 0.14517933, 0.14527275, 0.14536616, 0.14545958, 0.14555299, 0.14564645, 0.1457399, 0.14583337, 0.14592685, 0.14602034, 0.14611384, 0.14620733, 0.14630088, 0.14639442, 0.14648795, 0.1465815, 0.14667507, 0.14676864, 0.14686224, 0.14695583, 0.14704946, 0.14714308, 0.14723672, 0.14733036, 0.147424, 0.14751768, 0.14761136, 0.14770506, 0.14779876, 0.14789248, 0.14798619, 0.14807993, 0.14817369, 0.14826745, 0.14836122, 0.14845499, 0.1485488, 0.14864261, 0.14873642, 0.14883025, 0.14892408, 0.14901793, 0.14911181, 0.14920567, 0.14929956, 0.14939344, 0.14948735, 0.14958127, 0.14967521, 0.14976914, 0.14986309, 0.14995706, 0.15005103, 0.15014502, 0.15023902, 0.15033302, 0.15042704, 0.15052107, 0.15061513, 0.15070918, 0.15080324, 0.15089732, 0.1509914, 0.15108551, 0.15117963, 0.15127373, 0.15136786, 0.15146202, 0.15155618, 0.15165035, 0.15174451, 0.15183872, 0.15193291, 0.15202712, 0.15212135, 0.15221557, 0.15230982, 0.15240408, 0.15249835, 0.15259264, 0.15268692, 0.15278123, 0.15287554, 0.15296987, 0.15306421, 0.15315856, 0.15325291, 0.15334728, 0.15344167, 0.15353607, 0.15363048, 0.15372488, 0.15381932, 0.15391377, 0.15400821, 0.15410268, 0.15419714, 0.15429161, 0.15438612, 0.15448064, 0.15457515, 0.15466967, 0.15476421, 0.15485875, 0.15495332, 0.15504791, 0.15514249, 0.15523709, 0.1553317, 0.15542632, 0.15552096, 0.15561558, 0.15571025, 0.15580492, 0.15589958, 0.15599428, 0.15608896, 0.15618369, 0.1562784, 0.15637313, 0.15646788, 0.15656264, 0.1566574, 0.15675217, 0.15684699, 0.15694177, 0.15703657, 0.15713142, 0.15722625, 0.1573211, 0.15741596, 0.15751083, 0.15760568, 0.1577006, 0.1577955, 0.15789041, 0.15798533, 0.15808028, 0.15817522, 0.15827018, 0.15836516, 0.15846013, 0.15855512, 0.15865013, 0.15874515, 0.15884018, 0.15893522, 0.15903027, 0.15912533, 0.1592204, 0.1593155, 0.15941058, 0.1595057, 0.15960078, 0.15969592, 0.1597911, 0.15988623, 0.15998138, 0.16007656, 0.16017176, 0.16026695, 0.16036215, 0.16045737, 0.16055259, 0.16064785, 0.16074312, 0.1608384, 0.16093363, 0.16102894, 0.16112424, 0.16121955, 0.16131487, 0.16141018, 0.16150555, 0.1616009, 0.16169627, 0.16179167, 0.16188702, 0.16198243, 0.16207786, 0.16217327, 0.16226871, 0.16236416, 0.16245961, 0.16255508, 0.16265057, 0.16274607, 0.16284156, 0.16293707, 0.16303261, 0.16312815, 0.16322367, 0.16331924, 0.16341481, 0.1635104, 0.16360597, 0.16370161, 0.16379721, 0.16389284, 0.16398847, 0.16408414, 0.1641798, 0.16427547, 0.16437112, 0.16446684, 0.16456255, 0.16465826, 0.164754, 0.16484973, 0.16494548, 0.16504124, 0.16513704, 0.16523281, 0.16532859, 0.16542439, 0.16552025, 0.16561607, 0.16571192, 0.16580775, 0.16590361, 0.1659995, 0.16609541, 0.16619131, 0.16628718, 0.16638315, 0.16647905, 0.166575, 0.16667095, 0.16676693, 0.16686289, 0.16695888, 0.16705489, 0.1671509, 0.16724694, 0.16734296, 0.16743903, 0.1675351, 0.16763115, 0.16772723, 0.16782331, 0.1679194, 0.16801555, 0.16811167, 0.16820779, 0.16830394, 0.16840011, 0.16849628, 0.16859245, 0.16868864, 0.16878486, 0.16888107, 0.16897729, 0.16907355, 0.1691698, 0.16926603, 0.16936234, 0.1694586, 0.16955489, 0.16965123, 0.16974753, 0.16984387, 0.1699402, 0.17003654, 0.17013294, 0.17022929, 0.17032567, 0.17042208, 0.17051849, 0.1706149, 0.17071132, 0.17080776, 0.17090422, 0.17100069, 0.17109719, 0.17119366, 0.17129014, 0.17138667, 0.1714832, 0.17157973, 0.17167626, 0.17177284, 0.1718694, 0.17196597, 0.17206255, 0.17215914, 0.17225574, 0.17235239, 0.17244904, 0.17254569, 0.17264232, 0.17273898, 0.17283569, 0.17293237, 0.17302909, 0.17312577, 0.1732225, 0.17331927, 0.173416, 0.17351277, 0.17360952, 0.17370631, 0.17380311, 0.17389992, 0.17399675, 0.17409354, 0.17419042, 0.17428724, 0.1743841, 0.17448099, 0.17457788, 0.17467475, 0.17477167, 0.17486858, 0.17496552, 0.17506245, 0.17515941, 0.17525636, 0.17535335, 0.17545034, 0.17554733, 0.17564432, 0.17574136, 0.17583838, 0.17593543, 0.17603248, 0.17612955, 0.17622662, 0.17632371, 0.17642081, 0.17651793, 0.17661503, 0.17671217, 0.17680934, 0.17690648, 0.17700364, 0.17710081, 0.17719799, 0.17729521, 0.17739241, 0.17748965, 0.17758688, 0.17768411, 0.17778139, 0.17787868, 0.17797594, 0.17807321, 0.17817053, 0.17826787, 0.17836517, 0.17846251, 0.17855984, 0.1786572, 0.1787546, 0.17885198, 0.17894937, 0.17904676, 0.17914419, 0.1792416, 0.17933905, 0.1794365, 0.17953394, 0.17963146, 0.17972891, 0.17982642, 0.17992392, 0.18002267, 0.18012269, 0.18022269, 0.18032265, 0.18042256, 0.18052244, 0.18062228, 0.18072212, 0.18082191, 0.18092166, 0.18102138, 0.18112105, 0.18122071, 0.18132031, 0.18141989, 0.18151943, 0.18161893, 0.18171841, 0.18181784, 0.18191727, 0.18201663, 0.18211594, 0.18221524, 0.18231452, 0.18241374, 0.18251294, 0.18261209, 0.18271124, 0.18281034, 0.18290938, 0.18300842, 0.18310738, 0.18320635, 0.18330526, 0.18340415, 0.18350302, 0.18360183, 0.18370059, 0.18379936, 0.18389803, 0.18399672, 0.18409537, 0.18419398, 0.18429255, 0.18439108, 0.18448959, 0.18458804, 0.18468648, 0.18478489, 0.18488324, 0.18498158, 0.18507989, 0.18517813, 0.18527637, 0.18537456, 0.1854727, 0.18557084, 0.18566892, 0.18576697, 0.18586498, 0.18596298, 0.18606094, 0.18615882, 0.18625669, 0.18635456, 0.18645239, 0.18655017, 0.18664789, 0.18674558, 0.18684326, 0.18694091, 0.18703851, 0.18713608, 0.18723361, 0.18733111, 0.18742858, 0.18752602, 0.18762338, 0.18772076, 0.18781807, 0.18791538, 0.18801263, 0.18810984, 0.18820703, 0.18830417, 0.18840133, 0.18849839, 0.18859541, 0.18869245, 0.18878944, 0.18888636, 0.18898329, 0.18908015, 0.18917699, 0.18927382, 0.18937056, 0.18946731, 0.18956399, 0.18966067, 0.18975732, 0.18985392, 0.1899505, 0.190047, 0.1901435, 0.19023994, 0.19033639, 0.19043279, 0.19052912, 0.19062546, 0.19072172, 0.19081798, 0.19091423, 0.1910104, 0.19110653, 0.19120264, 0.19129874, 0.19139478, 0.1914908, 0.19158675, 0.1916827, 0.19177857, 0.19187444, 0.19197032, 0.19206612, 0.19216187, 0.1922576, 0.19235331, 0.19244896, 0.19254459, 0.19264017, 0.19273575, 0.19283126, 0.19292675, 0.19302221, 0.19311763, 0.19321303, 0.19330838, 0.19340371, 0.19349895, 0.19359422, 0.19368944, 0.19378462, 0.19387977, 0.19397487, 0.19406994, 0.19416498, 0.19425999, 0.19435497, 0.19444989, 0.19454479, 0.19463967, 0.19473448, 0.1948293, 0.19492406, 0.19501877, 0.19511345, 0.19520812, 0.19530275, 0.19539735, 0.19549187, 0.19558641, 0.19568089, 0.19577533, 0.19586974, 0.19596413, 0.19605848, 0.19615278, 0.19624707, 0.19634134, 0.19643553, 0.19652969, 0.19662385, 0.19671793, 0.19681203, 0.19690605, 0.19700006, 0.19709402, 0.19718795, 0.19728185, 0.19737568, 0.19746952, 0.19756332, 0.19765708, 0.19775084, 0.19784449, 0.19793814, 0.19803177, 0.19812535, 0.1982189, 0.19831242, 0.19840589, 0.19849935, 0.19859275, 0.19868612, 0.19877949, 0.19887277, 0.19896606, 0.19905929, 0.19915251, 0.19924566, 0.19933881, 0.19943191, 0.19952498, 0.199618, 0.19971098, 0.19980395, 0.19989689, 0.19998978, 0.20008263, 0.20017545, 0.20026822, 0.20036101, 0.20045373, 0.2005464, 0.20063904, 0.20073166, 0.20082425, 0.20091681, 0.20100929, 0.20110178, 0.20119423, 0.20128663, 0.201379, 0.20147133, 0.20156363, 0.20165591, 0.20174813, 0.20184034, 0.20193252, 0.20202464, 0.20211671, 0.2022088, 0.2023008, 0.2023928, 0.20248477, 0.2025767, 0.20266858, 0.20276041, 0.20285225, 0.20294404, 0.20303579, 0.20312749, 0.20321918, 0.20331083, 0.20340241, 0.20349401, 0.20358554, 0.20367706, 0.20376854, 0.20385994, 0.20395137, 0.20404272, 0.20413406, 0.20422538, 0.20431663, 0.20440784, 0.20449905, 0.20459023, 0.20468134, 0.20477243, 0.20486349, 0.2049545, 0.20504549, 0.20513645, 0.20522736, 0.20531824, 0.20540911, 0.20549992, 0.2055907, 0.20568144, 0.20577216, 0.20586284, 0.20595346, 0.20604406, 0.20613462, 0.20622519, 0.20631567, 0.20640615, 0.20649658, 0.20658696, 0.20667735, 0.20676766, 0.20685795, 0.20694822, 0.20703843, 0.20712863, 0.20721878, 0.20730892, 0.20739898, 0.20748904, 0.20757906, 0.20766905, 0.20775899, 0.20784891, 0.20793879, 0.20802861, 0.20811844, 0.20820823, 0.20829794, 0.20838767, 0.20847732, 0.20856696, 0.20865655, 0.20874614, 0.20883568, 0.20892517, 0.20901462, 0.20910405, 0.20919344, 0.20928282, 0.20937215, 0.20946142, 0.20955066, 0.20963989, 0.20972909, 0.20981824, 0.20990735, 0.20999645, 0.21008548, 0.21017452, 0.21026348, 0.21035242, 0.21044135, 0.21053021, 0.21061903, 0.21070786, 0.21079662, 0.21088536, 0.21097405, 0.21106271, 0.21115133, 0.21123992, 0.21132852, 0.21141706, 0.21150552, 0.211594, 0.21168241, 0.2117708, 0.21185917, 0.21194749, 0.21203576, 0.21212402, 0.21221223, 0.2123004, 0.21238858, 0.21247669, 0.21256475, 0.21265277, 0.21274082, 0.21282877, 0.2129167, 0.2130046, 0.21309248, 0.21318033, 0.21326812, 0.2133559, 0.21344361, 0.21353132, 0.21361898, 0.21370658, 0.21379422, 0.21388178, 0.21396929, 0.21405676, 0.2141442, 0.21423164, 0.21431904, 0.21440639, 0.21449369, 0.21458097, 0.21466821, 0.21475543, 0.21484262, 0.21492974, 0.21501686, 0.21510394, 0.21519098, 0.21527797, 0.21536495, 0.2154519, 0.21553878, 0.21562566, 0.21571247, 0.2157993, 0.21588604, 0.21597277, 0.21605946, 0.21614611, 0.21623273, 0.21631931, 0.21640585, 0.21649237, 0.21657889, 0.21666533, 0.21675172, 0.21683812, 0.21692446, 0.21701078, 0.21709707, 0.21718329, 0.2172695, 0.21735567, 0.2174418, 0.21752793, 0.21761398, 0.21770003, 0.21778603, 0.21787198, 0.21795791, 0.21804382, 0.21812968, 0.2182155, 0.21830128, 0.21838705, 0.21847276, 0.21855845, 0.21864411, 0.21872972, 0.21881531, 0.21890086, 0.21898638, 0.21907185, 0.21915731, 0.21924271, 0.21932809, 0.21941343, 0.21949872, 0.219584, 0.21966925, 0.21975446, 0.21983962, 0.21992475, 0.22000985, 0.2200949, 0.22017993, 0.22026494, 0.22034991, 0.22043481, 0.22051972, 0.22060457, 0.22068939, 0.22077417, 0.22085893, 0.22094366, 0.22102834, 0.22111298, 0.22119762, 0.22128217, 0.22136672, 0.22145122, 0.2215357, 0.22162013, 0.22170454, 0.22178893, 0.22187328, 0.22195756, 0.22204185, 0.22212607, 0.22221024, 0.22229445, 0.22237854, 0.22246264, 0.22254671, 0.22263072, 0.22271474, 0.22279868, 0.2228826, 0.22296649, 0.22305036, 0.22313417, 0.22321795, 0.22330169, 0.22338541, 0.22346909, 0.22355272, 0.22363633, 0.22371991, 0.22380345, 0.22388695, 0.22397043, 0.22405386, 0.22413725, 0.22422065, 0.22430396, 0.22438726, 0.22447053, 0.22455376, 0.22463696, 0.22472012, 0.22480325, 0.22488633, 0.22496939, 0.22505239, 0.22513539, 0.22521833, 0.22530127, 0.22538413, 0.22546697, 0.22554979, 0.22563256, 0.22571531, 0.22579801, 0.22588071, 0.22596334, 0.22604595, 0.22612852, 0.22621106, 0.22629356, 0.22637601, 0.22645846, 0.22654085, 0.22662321, 0.22670554, 0.22678784, 0.22687009, 0.22695231, 0.22703451, 0.22711667, 0.22719878, 0.22728084, 0.22736293, 0.22744492, 0.2275269, 0.22760886, 0.22769077, 0.22777265, 0.22785448, 0.22793628, 0.22801806, 0.22809981, 0.2281815, 0.22826318, 0.22834483, 0.22842643, 0.228508, 0.22858953, 0.22867104, 0.22875248, 0.22883393, 0.22891529, 0.22899666, 0.22907799, 0.22915928, 0.22924054, 0.22932175, 0.22940291, 0.22948408, 0.22956519, 0.22964628, 0.22972731, 0.22980833, 0.22988933, 0.22997026, 0.23005117, 0.23013204, 0.23021287, 0.23029369, 0.23037444, 0.23045518, 0.23053589, 0.23061654, 0.2306972, 0.23077777, 0.23085834, 0.23093887, 0.23101935, 0.23109981, 0.23118022, 0.23126061, 0.23134099, 0.23142128, 0.23150159, 0.23158182, 0.23166206, 0.23174222, 0.23182239, 0.2319025, 0.23198259, 0.23206261, 0.23214263, 0.2322226, 0.23230252, 0.23238242, 0.2324623, 0.23254216, 0.23262192, 0.2327017, 0.23278141, 0.23286113, 0.23294079, 0.23302041, 0.23310001, 0.23317957, 0.23325907, 0.23333858, 0.23341802, 0.23349744, 0.23357682, 0.23365617, 0.23373547, 0.23381479, 0.23389401, 0.23397322, 0.23405242, 0.23413154, 0.23421066, 0.23428974, 0.23436877, 0.23444778, 0.23452674, 0.23460567, 0.23468456, 0.23476344, 0.23484226, 0.23492107, 0.23499979, 0.23507853, 0.23515722, 0.23523588, 0.2353145, 0.23539308, 0.23547165, 0.23555017, 0.23562866, 0.23570709, 0.23578551, 0.23586389, 0.23594224, 0.23602055, 0.23609883, 0.23617706, 0.23625526, 0.23633344, 0.23641159, 0.23648968, 0.23656777, 0.23664579, 0.2367238, 0.23680174, 0.23687968, 0.23695758, 0.23703542, 0.23711327, 0.23719104, 0.23726879, 0.23734653, 0.23742419, 0.23750184, 0.23757946, 0.23765707, 0.2377346, 0.23781213, 0.23788959, 0.23796704, 0.23804446, 0.23812182, 0.23819919, 0.23827647, 0.23835374, 0.23843098, 0.23850821, 0.23858535, 0.2386625, 0.23873959, 0.23881666, 0.23889367, 0.23897067, 0.23904763, 0.23912455, 0.23920144, 0.2392783, 0.23935513, 0.2394319, 0.23950867, 0.23958538, 0.23966207, 0.2397387, 0.23981532, 0.2398919, 0.23996843, 0.24004495, 0.24012142, 0.24019787, 0.24027428, 0.24035063, 0.24042697, 0.24050327, 0.24057955, 0.24065576, 0.24073195, 0.24080813, 0.24088426, 0.24096036, 0.24103642, 0.24111246, 0.24118841, 0.24126439, 0.24134029, 0.2414162, 0.24149206, 0.24156787, 0.24164364, 0.24171939, 0.24179509, 0.24187078, 0.24194643, 0.24202202, 0.24209762, 0.24217317, 0.24224865, 0.24232411, 0.24239957, 0.24247496, 0.2425503, 0.24262567, 0.24270095, 0.24277622, 0.24285145, 0.24292663, 0.24300179, 0.24307694, 0.24315201, 0.24322708, 0.24330208, 0.24337706, 0.24345201, 0.24352694, 0.2436018, 0.24367665, 0.24375148, 0.24382626, 0.243901, 0.2439757, 0.24405037, 0.24412501, 0.24419962, 0.24427418, 0.24434872, 0.24442323, 0.24449769, 0.2445721, 0.24464652, 0.24472086, 0.2447952, 0.2448695, 0.24494375, 0.24501798, 0.24509215, 0.24516633, 0.24524045, 0.24531452, 0.24538857, 0.24546258, 0.24553658, 0.24561051, 0.24568442, 0.2457583, 0.24583215, 0.24590595, 0.24597973, 0.24605347, 0.24612716, 0.24620084, 0.24627446, 0.24634807, 0.24642164, 0.24649517, 0.24656866, 0.24664213, 0.24671555, 0.24678896, 0.24686229, 0.24693562, 0.2470089, 0.24708217, 0.2471554, 0.24722856, 0.24730173, 0.24737483, 0.24744791, 0.24752095, 0.24759395, 0.24766694, 0.24773987, 0.24781281, 0.24788567, 0.2479585, 0.24803132, 0.24810408, 0.24817681, 0.24824952, 0.24832217, 0.24839479, 0.2484674, 0.24853997, 0.24861248, 0.24868497, 0.24875742, 0.24882986, 0.24890225, 0.24897461, 0.24904692, 0.24911921, 0.24919145, 0.24926367, 0.24933586, 0.24940798, 0.24948011, 0.24955218, 0.24962421, 0.24969622, 0.2497682, 0.24984011, 0.24991202, 0.24998391, 0.25005573, 0.25012752, 0.25019929, 0.25027102, 0.2503427, 0.2504144, 0.25048599, 0.2505576, 0.25062913, 0.25070065, 0.25077215, 0.25084361, 0.25091502, 0.25098643, 0.25105774, 0.25112909, 0.25120035, 0.25127161, 0.2513428, 0.25141397, 0.25148514, 0.25155625, 0.2516273, 0.25169834, 0.25176933, 0.25184032, 0.25191125, 0.25198215, 0.25205299, 0.25212383, 0.25219464, 0.25226539, 0.25233611, 0.25240681, 0.25247744, 0.2525481, 0.25261864, 0.25268921, 0.25275972, 0.25283021, 0.25290066, 0.25297105, 0.25304148, 0.25311181, 0.25318208, 0.25325239, 0.25332263, 0.25339282, 0.253463, 0.25353315, 0.25360325, 0.25367332, 0.25374335, 0.25381333, 0.2538833, 0.25395322, 0.2540231, 0.25409299, 0.25416282, 0.25423259, 0.25430232, 0.25437206, 0.25444174, 0.25451142, 0.254581, 0.25465059, 0.25472015, 0.25478965, 0.25485915, 0.25492859, 0.254998, 0.25506735, 0.2551367, 0.25520599, 0.25527528, 0.25534451, 0.25541371, 0.25548288, 0.25555202, 0.25562111, 0.25569019, 0.25575918, 0.2558282, 0.25589713, 0.2559661, 0.25603497, 0.25610381, 0.25617263, 0.25624144, 0.25631016, 0.25637889, 0.25644758, 0.25651622, 0.25658482, 0.2566534, 0.25672194, 0.25679046, 0.25685894, 0.25692737, 0.2569958, 0.25706413, 0.2571325, 0.25720078, 0.25726905, 0.25733727, 0.25740549, 0.25747365, 0.25754178, 0.25760987, 0.25767788, 0.25774592, 0.25781393, 0.25788188, 0.2579498, 0.25801766, 0.25808555, 0.25815338, 0.25822115, 0.25828889, 0.2583566, 0.25842428, 0.2584919, 0.25855953, 0.25862709, 0.25869462, 0.25876212, 0.25882959, 0.25889704, 0.25896442, 0.2590318, 0.25909913, 0.25916642, 0.25923368, 0.25930092, 0.25936812, 0.25943527, 0.25950238, 0.25956947, 0.25963652, 0.25970355, 0.25977051, 0.25983748, 0.25990438, 0.25997129, 0.26003811, 0.26010492, 0.26017171, 0.26023847, 0.26030517, 0.26037183, 0.26043847, 0.26050508, 0.26057166, 0.26063818, 0.26070467, 0.26077113, 0.26083755, 0.26090395, 0.26097032, 0.26103666, 0.26110294, 0.2611692, 0.26123542, 0.26130164, 0.26136777, 0.26143387, 0.26149997, 0.26156601, 0.26163206, 0.26169801, 0.26176396, 0.26182985, 0.26189575, 0.26196158, 0.26202738, 0.26209316, 0.2621589, 0.26222461, 0.26229027, 0.26235589, 0.26242149, 0.26248705, 0.26255259, 0.26261809, 0.26268354, 0.26274437, 0.26280051, 0.26285663, 0.26291266, 0.26296863, 0.26302451, 0.26308033, 0.26313609, 0.26319179, 0.2632474, 0.26330298, 0.26335844, 0.26341388, 0.26346925, 0.26352453, 0.26357976, 0.26363489, 0.26368999, 0.26374501, 0.26379994, 0.26385483, 0.26390964, 0.26396441, 0.26401907, 0.2640737, 0.26412824, 0.26418275, 0.26423717, 0.2642915, 0.26434579, 0.26440001, 0.26445413, 0.26450819, 0.26456219, 0.26461616, 0.26467001, 0.26472384, 0.26477757, 0.26483127, 0.26488486, 0.26493841, 0.26499188, 0.26504529, 0.26509863, 0.26515189, 0.26520509, 0.26525822, 0.2653113, 0.26536429, 0.26541722, 0.26547006, 0.26552287, 0.26557562, 0.26562828, 0.26568088, 0.26573339, 0.26578587, 0.26583827, 0.26589057, 0.26594284, 0.26599506, 0.26604715, 0.26609924, 0.26615122, 0.26620314, 0.26625502, 0.26630679, 0.26635852, 0.26641017, 0.26646173, 0.26651329, 0.26656473, 0.26661611, 0.26666743, 0.26671866, 0.26676986, 0.26682097, 0.26687202, 0.26692301, 0.26697394, 0.26702479, 0.26707554, 0.26712626, 0.2671769, 0.2672275, 0.26727802, 0.26732841, 0.26737881, 0.26742914, 0.26747936, 0.26752955, 0.26757964, 0.26762968, 0.26767966, 0.26772955, 0.26777941, 0.26782918, 0.26787886, 0.26792851, 0.2679781, 0.26802757, 0.26807702, 0.2681264, 0.26817569, 0.26822492, 0.26827407, 0.26832318, 0.26837221, 0.26842117, 0.26847005, 0.26851889, 0.26856768, 0.26861635, 0.26866499, 0.26871353, 0.26876202, 0.26881045, 0.26885879, 0.2689071, 0.26895532, 0.26900348, 0.26905155, 0.26909959, 0.26914755, 0.26919541, 0.26924327, 0.26929101, 0.2693387, 0.26938632, 0.26943386, 0.26948133, 0.26952875, 0.2695761, 0.26962337, 0.26967058, 0.26971772, 0.26976484, 0.26981184, 0.26985878, 0.26990566, 0.26995248, 0.26999921, 0.27004588, 0.27009249, 0.27013904, 0.2701855, 0.2702319, 0.27027828, 0.27032453, 0.27037072, 0.27041686, 0.27046293, 0.27050892, 0.27055487, 0.27060074, 0.27064654, 0.27069226, 0.27073795, 0.27078351, 0.27082905, 0.27087453, 0.27091992, 0.27096525, 0.27101052, 0.2710557, 0.27110085, 0.27114591, 0.27119091, 0.27123582, 0.27128071, 0.27132544, 0.2713702, 0.27141485, 0.27145943, 0.27150396, 0.27154839, 0.27159283, 0.27163711, 0.27168137, 0.27172557, 0.2717697, 0.27181372, 0.27185771, 0.27190164, 0.27194548, 0.27198926, 0.27203298, 0.27207661, 0.27212021, 0.27216372, 0.27220717, 0.27225053, 0.27229384, 0.27233708, 0.27238026, 0.27242339, 0.27246642, 0.27250937, 0.27255228, 0.27259514, 0.27263793, 0.27268061, 0.27272323, 0.27276582, 0.27280834, 0.27285078, 0.27289316, 0.27293545, 0.27297768, 0.27301985, 0.27306193, 0.27310395, 0.27314594, 0.27318785, 0.27322966, 0.27327141, 0.27331313, 0.27335477, 0.27339631, 0.2734378, 0.27347925, 0.27352059, 0.27356189, 0.27360308, 0.27364427, 0.27368537, 0.2737264, 0.27376735, 0.27380824, 0.27384904, 0.27388981, 0.27393052, 0.27397111, 0.27401167, 0.27405214, 0.27409256, 0.27413291, 0.2741732, 0.2742134, 0.27425358, 0.27429363, 0.27433366, 0.27437359, 0.2744135, 0.27445328, 0.27449304, 0.27453271, 0.27457231, 0.27461186, 0.27465135, 0.27469078, 0.27473009, 0.2747694, 0.27480859, 0.27484772, 0.27488679, 0.2749258, 0.27496472, 0.27500358, 0.27504241, 0.27508113, 0.27511978, 0.27515841, 0.27519694, 0.27523538, 0.2752738, 0.27531213, 0.27535039, 0.27538857, 0.27542672, 0.27546477, 0.2755028, 0.27554068, 0.27557856, 0.27561638, 0.27565411, 0.27569178, 0.27572936, 0.27576688, 0.27580431, 0.27584171, 0.27587903, 0.27591628, 0.27595347, 0.27599061, 0.27602765, 0.27606463, 0.27610156, 0.2761384, 0.27617517, 0.27621189, 0.27624857, 0.27628514, 0.27632165, 0.2763581, 0.27639446, 0.27643079, 0.27646706, 0.27650321, 0.2765393, 0.27657536, 0.27661133, 0.27664724, 0.27668309, 0.27671888, 0.27675459, 0.27679023, 0.27682579, 0.27686128, 0.27689672, 0.27693212, 0.27696741, 0.27700266, 0.27703783, 0.27707291, 0.27710795, 0.27714291, 0.27717781, 0.27721265, 0.27724743, 0.27728212, 0.27731675, 0.27735132, 0.2773858, 0.27742025, 0.27745458, 0.27748889, 0.27752313, 0.27755728, 0.27759138, 0.27762538, 0.27765936, 0.27769324, 0.2777271, 0.27776083, 0.27779448, 0.27782813, 0.27786168, 0.27789518, 0.27792859, 0.27796194, 0.27799523, 0.27802846, 0.2780616, 0.27809468, 0.27812767, 0.27816063, 0.27819353, 0.27822635, 0.2782591, 0.27829176, 0.27832437, 0.27835691, 0.27838939, 0.27842182, 0.27845415, 0.2784864, 0.27851865, 0.27855077, 0.27858287, 0.27861485, 0.2786468, 0.27867866, 0.27871048, 0.27874219, 0.27877387, 0.27880546, 0.27883703, 0.2788685, 0.27889988, 0.27893123, 0.27896246, 0.27899367, 0.27902481, 0.27905589, 0.27908686, 0.27911782, 0.27914867, 0.27917948, 0.27921018, 0.27924085, 0.27927145, 0.27930197, 0.27933246, 0.27936283, 0.27939317, 0.27942339, 0.27945361, 0.27948371, 0.27951375, 0.27954376, 0.27957371, 0.27960354, 0.27963331, 0.27966303, 0.27969268, 0.27972227, 0.27975178, 0.27978125, 0.27981064, 0.27983993, 0.27986917, 0.27989838, 0.27992749, 0.27995652, 0.27998552, 0.28001443, 0.28004324, 0.28007203, 0.28010073, 0.28012937, 0.28015795, 0.28018647, 0.28021494, 0.28024328, 0.28027159, 0.28029981, 0.28032801, 0.28035611, 0.28038415, 0.28041211, 0.28044, 0.28046784, 0.28049561, 0.2805233, 0.28055096, 0.28057852, 0.280606, 0.28063345, 0.28066081, 0.28068811, 0.28071532, 0.2807425, 0.28076962, 0.28079662, 0.28082356, 0.28085047, 0.28087729, 0.28090405, 0.28093073, 0.28095737, 0.28098392, 0.28101042, 0.28103682, 0.2810632, 0.28108945, 0.28111571, 0.28114185, 0.28116792, 0.28119394, 0.2812199, 0.28124577, 0.28127158, 0.28129733, 0.28132302, 0.28134865, 0.28137419, 0.28139967, 0.28142506, 0.28145042, 0.28147569, 0.28150094, 0.28152606, 0.28155112, 0.28157613, 0.28160107, 0.28162596, 0.28165078, 0.28167549, 0.28170016, 0.28172475, 0.28174931, 0.28177381, 0.28179818, 0.28182253, 0.28184679, 0.28187099, 0.28189513, 0.28191918, 0.2819432, 0.28196713, 0.28199098, 0.28201479, 0.28203851, 0.2820622, 0.28208578, 0.28210929, 0.28213277, 0.28215614, 0.28217947, 0.28220275, 0.28222594, 0.28224906, 0.28227213, 0.28229511, 0.28231803, 0.28234088, 0.28236365, 0.28238642, 0.28240907, 0.28243163, 0.28245413, 0.2824766, 0.28249899, 0.28252131, 0.28254354, 0.28256571, 0.28258786, 0.28260991, 0.2826319, 0.28265378, 0.28267562, 0.28269741, 0.28271914, 0.2827408, 0.28276235, 0.28278387, 0.28280529, 0.28282669, 0.282848, 0.28286922, 0.28289041, 0.28291151, 0.28293255, 0.2829535, 0.28297439, 0.28299525, 0.28301603, 0.28303674, 0.28305736, 0.28307793, 0.28309843, 0.28311884, 0.28313923, 0.28315952, 0.28317976, 0.28319991, 0.28321999, 0.28324005, 0.28326002, 0.2832799, 0.28329974, 0.28331947, 0.28333917, 0.28335881, 0.28337836, 0.28339785, 0.28341728, 0.28343663, 0.28345594, 0.28347513, 0.28349429, 0.2835134, 0.28353241, 0.28355137, 0.28357026, 0.28358907, 0.28360781, 0.2836265, 0.28364512, 0.28366366, 0.28368217, 0.28370059, 0.28371891, 0.28373718, 0.28375539, 0.28377354, 0.28379163, 0.28380963, 0.28382757, 0.28384545, 0.28386325, 0.28388101, 0.28389868, 0.28391626, 0.28393382, 0.28395128, 0.28396872, 0.28398603, 0.28400332, 0.28402051, 0.28403765, 0.28405473, 0.28407171, 0.28408864, 0.28410554, 0.28412232, 0.28413904, 0.28415573, 0.28417233, 0.28418884, 0.28420532, 0.28422171, 0.28423804, 0.28425428, 0.28427047, 0.28428662, 0.28430265, 0.28431866, 0.2843346, 0.28435043, 0.28436622, 0.28438196, 0.2843976, 0.28441319, 0.28442872, 0.28444418, 0.28445956, 0.28447488, 0.28449014, 0.28450531, 0.28452045, 0.28453547, 0.28455046, 0.28456536, 0.28458023, 0.28459501, 0.28460974, 0.28462437, 0.28463894, 0.28465346, 0.28466791, 0.28468227, 0.28469661, 0.28471082, 0.28472498, 0.28473914, 0.28475314, 0.28476712, 0.28478104, 0.28479487, 0.28480864, 0.28482234, 0.28483599, 0.28484955, 0.28486305, 0.2848765, 0.28488985, 0.28490317, 0.2849164, 0.28492957, 0.28494266, 0.28495571, 0.28496864, 0.28498155, 0.28499436, 0.28500715, 0.28501984, 0.28503245, 0.28504503, 0.28505751, 0.28506994, 0.28508231, 0.28509459, 0.28510684, 0.28511897, 0.28513107, 0.28514311, 0.28515506, 0.28516692, 0.28517875, 0.28519049, 0.28520218, 0.2852138, 0.28522536, 0.28523684, 0.28524825, 0.2852596, 0.2852709, 0.28528211, 0.28529325, 0.28530431, 0.28531533, 0.28532627, 0.28533718, 0.28534797, 0.2853587, 0.2853694, 0.28538001, 0.28539056, 0.28540102, 0.28541145, 0.28542176, 0.28543204, 0.28544226, 0.2854524, 0.28546244, 0.28547245, 0.28548241, 0.28549224, 0.28550205, 0.28551179, 0.28552145, 0.28553107, 0.28554058, 0.28555006, 0.28555948, 0.2855688, 0.28557804, 0.28558725, 0.28559637, 0.28560543, 0.28561443, 0.28562334, 0.28563222, 0.28564101, 0.28564975, 0.28565839, 0.28566697, 0.2856755, 0.28568396, 0.28569233, 0.28570068, 0.28570893, 0.2857171, 0.28572524, 0.28573328, 0.28574127, 0.28574917, 0.28575704, 0.28576481, 0.28577253, 0.28578019, 0.28578776, 0.28579527, 0.28580272, 0.28581008, 0.28581738, 0.28582469, 0.28583184, 0.28583896, 0.28584597, 0.28585294, 0.28585985, 0.28586671, 0.28587347, 0.28588018, 0.28588682, 0.28589341, 0.28589991, 0.28590634, 0.28591269, 0.28591901, 0.28592524, 0.28593141, 0.28593752, 0.28594354, 0.28594953, 0.2859554, 0.28596124, 0.28596699, 0.28597271, 0.28597832, 0.28598389, 0.2859894, 0.28599483, 0.28600016, 0.28600544, 0.28601068, 0.28601584, 0.28602096, 0.28602597, 0.28603092, 0.28603581, 0.28604066, 0.2860454, 0.28605008, 0.2860547, 0.28605926, 0.28606373, 0.28606817, 0.28607252, 0.28607681, 0.28608102, 0.28608516, 0.28608924, 0.28609326, 0.28609723, 0.2861011, 0.28610492, 0.28610864, 0.28611234, 0.28611591, 0.28611949, 0.28612298, 0.28612635, 0.28612971, 0.28613299, 0.28613618, 0.28613934, 0.28614241, 0.28614539, 0.28614834, 0.2861512, 0.28615403, 0.28615674, 0.2861594, 0.28616202, 0.28616455, 0.28616703, 0.28616944, 0.28617176, 0.28617403, 0.28617623, 0.28617835, 0.28618041, 0.2861824, 0.28618434, 0.28618619, 0.28618798, 0.28618973, 0.28619137, 0.28619298, 0.2861945, 0.28619596, 0.28619736, 0.28619868, 0.28619993, 0.28620112, 0.28620225, 0.28620329, 0.28620428, 0.2862052, 0.28620607, 0.28620684, 0.28620756, 0.28620821, 0.28620878, 0.28620929, 0.28620976, 0.28621015, 0.28621042, 0.28621069, 0.28621086, 0.28621098, 0.28621101, 0.28621101, 0.28621092, 0.28621075, 0.28621054, 0.28621024, 0.28620988, 0.28620943, 0.28620896, 0.28620842, 0.28620777, 0.28620705, 0.28620633, 0.28620547, 0.28620461, 0.28620362, 0.28620258, 0.28620151, 0.28620031, 0.28619909, 0.28619778, 0.28619644, 0.28619501, 0.28619349, 0.28619191, 0.28619027, 0.28618857, 0.28618678, 0.28618494, 0.28618306, 0.28618106, 0.28617904, 0.28617692, 0.28617474, 0.28617251, 0.28617018, 0.28616783, 0.28616539, 0.28616285, 0.28616029, 0.28615764, 0.28615493, 0.28615212, 0.28614929, 0.28614637, 0.28614339, 0.28614035, 0.28613722, 0.28613403, 0.28613079, 0.28612748, 0.28612408, 0.28612062, 0.28611711, 0.2861135, 0.28610986, 0.28610614, 0.28610232, 0.28609848, 0.28609455, 0.28609058, 0.2860865, 0.28608236, 0.28607818, 0.28607392, 0.2860696, 0.28606519, 0.28606072, 0.28605619, 0.2860516, 0.28604695, 0.28604218, 0.28603739, 0.28603253, 0.28602761, 0.2860226, 0.28601754, 0.28601241, 0.2860072, 0.28600192, 0.28599659, 0.28599116, 0.28598571, 0.28598017, 0.28597456, 0.2859689, 0.28596315, 0.28595734, 0.28595144, 0.2859455, 0.28593951, 0.28593341, 0.28592727, 0.28592107, 0.28591478, 0.28590843, 0.28590202, 0.28589556, 0.285889, 0.28588238, 0.28587568, 0.28586894, 0.28586212, 0.28585523, 0.28584829, 0.28584123, 0.28583416, 0.28582704, 0.2858198, 0.2858125, 0.28580514, 0.28579772, 0.28579023, 0.28578267, 0.28577504, 0.28576735, 0.28575957, 0.28575176, 0.28574386, 0.28573591, 0.28572789, 0.28571978, 0.28571162, 0.28570339, 0.28569508, 0.28568673, 0.2856783, 0.2856698, 0.28566119, 0.28565258, 0.28564388, 0.28563508, 0.28562626, 0.28561738, 0.28560838, 0.28559935, 0.28559026, 0.28558105, 0.28557184, 0.28556252, 0.28555316, 0.28554371, 0.2855342, 0.28552461, 0.28551495, 0.28550526, 0.28549546, 0.28548563, 0.2854757, 0.28546572, 0.28545567, 0.28544557, 0.28543541, 0.28542513, 0.28541481, 0.28540444, 0.28539398, 0.28538346, 0.28537288, 0.28536221, 0.28535151, 0.28534073, 0.28532985, 0.28531891, 0.28530794, 0.28529051, 0.2852667, 0.2852428, 0.28521883, 0.28519484, 0.28517076, 0.28514665, 0.28512248, 0.28509825, 0.28507397, 0.28504965, 0.28502524, 0.2850008, 0.2849763, 0.28495175, 0.2849271, 0.28490242, 0.28487769, 0.28485292, 0.28482807, 0.28480315, 0.28477824, 0.2847532, 0.28472811, 0.28470299, 0.28467783, 0.28465259, 0.28462729, 0.28460196, 0.28457654, 0.28455108, 0.28452557, 0.2845, 0.28447437, 0.28444868, 0.28442293, 0.28439713, 0.28437126, 0.28434536, 0.28431937, 0.28429335, 0.28426731, 0.28424114, 0.28421494, 0.28418872, 0.28416243, 0.28413606, 0.28410965, 0.28408319, 0.28405663, 0.28403008, 0.28400344, 0.28397676, 0.28394997, 0.28392318, 0.28389633, 0.28386942, 0.28384238, 0.28381538, 0.28378829, 0.28376114, 0.28373393, 0.28370669, 0.2836794, 0.28365201, 0.28362456, 0.28359711, 0.28356957, 0.28354198, 0.28351432, 0.2834866, 0.28345886, 0.28343105, 0.28340316, 0.28337523, 0.28334725, 0.28331921, 0.2832911, 0.28326297, 0.28323475, 0.28320649, 0.28317815, 0.28314978, 0.28312135, 0.28309286, 0.28306431, 0.2830357, 0.28300703, 0.28297833, 0.28294957, 0.28292072, 0.28289181, 0.2828629, 0.28283387, 0.28280485, 0.28277573, 0.28274655, 0.28271735, 0.28268808, 0.28265876, 0.28262934, 0.2825999, 0.28257042, 0.28254086, 0.28251126, 0.28248158, 0.28245184, 0.28242207, 0.28239223, 0.28236234, 0.28233239, 0.28230235, 0.28227231, 0.28224221, 0.28221202, 0.2821818, 0.28215152, 0.28212118, 0.28209078, 0.2820603, 0.28202981, 0.2819992, 0.28196859, 0.28193793, 0.2819072, 0.28187639, 0.28184557, 0.28181466, 0.28178367, 0.28175265, 0.28172159, 0.28169048, 0.28165928, 0.28162804, 0.28159675, 0.2815654, 0.28153399, 0.28150252, 0.28147101, 0.28143942, 0.2814078, 0.28137609, 0.28134435, 0.28131258, 0.2812807, 0.28124878, 0.2812168, 0.28118479, 0.28115273, 0.28112057, 0.28108835, 0.28105614, 0.2810238, 0.28099144, 0.28095904, 0.28092656, 0.28089401, 0.28086144, 0.2808288, 0.28079611, 0.28076336, 0.28073055, 0.28069764, 0.28066474, 0.28063175, 0.28059873, 0.28056562, 0.28053248, 0.28049928, 0.28046602, 0.2804327, 0.28039932, 0.28036591, 0.28033242, 0.28029886, 0.28026527, 0.2802316, 0.28019789, 0.28016415, 0.28013033, 0.28009644, 0.2800625, 0.28002852, 0.27999449, 0.27996039, 0.27992621, 0.27989203, 0.27985772, 0.27982342, 0.27978903, 0.27975458, 0.2797201, 0.27968556, 0.27965093, 0.27961627, 0.27958155, 0.27954677, 0.27951196, 0.27947706, 0.2794421, 0.27940711, 0.27937204, 0.27933693, 0.27930179, 0.27926654, 0.27923125, 0.27919593, 0.27916053, 0.27912509, 0.2790896, 0.27905405, 0.2790184, 0.27898273, 0.27894703, 0.27891123, 0.27887538, 0.27883947, 0.27880353, 0.27876753, 0.27873147, 0.27869532, 0.27865916, 0.27862293, 0.27858663, 0.27855027, 0.27851388, 0.27847743, 0.27844089, 0.27840433, 0.2783677, 0.27833104, 0.27829427, 0.27825749, 0.27822062, 0.27818373, 0.27814677, 0.27810976, 0.27807269, 0.27803555, 0.27799839, 0.27796111, 0.27792379, 0.27788648, 0.27784905, 0.27781159, 0.27777404, 0.27773649, 0.27769884, 0.27766114, 0.27762339, 0.27758557, 0.27754772, 0.27750981, 0.27747184, 0.27743378, 0.2773957, 0.27735758, 0.2773194, 0.27728111, 0.27724281, 0.27720445, 0.27716601, 0.27712756, 0.277089, 0.27705041, 0.27701178, 0.27697307, 0.27693433, 0.27689549, 0.27685663, 0.27681768, 0.27677873, 0.27673969, 0.27670059, 0.2766614, 0.27662224, 0.27658296, 0.27654365, 0.27650425, 0.27646482, 0.27642533, 0.27638581, 0.27634618, 0.27630654, 0.27626681, 0.27622706, 0.27618724, 0.27614734, 0.27610743, 0.27606741, 0.27602738, 0.27598727, 0.27594709, 0.27590686, 0.2758666, 0.27582628, 0.27578589, 0.27574545, 0.27570495, 0.27566439, 0.27562377, 0.27558312, 0.27554238, 0.27550161, 0.27546078, 0.27541989, 0.27537894, 0.27533793, 0.2752969, 0.27525577, 0.27521458, 0.27517337, 0.27513209, 0.27509075, 0.27504933, 0.2750079, 0.27496636, 0.27492481, 0.27488321, 0.27484152, 0.27479976, 0.27475801, 0.27471614, 0.27467424, 0.2746323, 0.27459025, 0.2745482, 0.27450609, 0.27446389, 0.27442166, 0.27437937, 0.27433702, 0.27429461, 0.27425215, 0.27420962, 0.27416706, 0.27412444, 0.27408174, 0.274039, 0.2739962, 0.27395335, 0.27391043, 0.27386749, 0.27382442, 0.27378136, 0.27373824, 0.27369505, 0.27365178, 0.27360848, 0.27356511, 0.27352169, 0.27347821, 0.2734347, 0.27339113, 0.2733475, 0.27330381, 0.27326006, 0.27321622, 0.27317238, 0.27312842, 0.27308446, 0.27304041, 0.27299634, 0.2729522, 0.272908, 0.27286375, 0.27281943, 0.27277505, 0.27273062, 0.27268615, 0.27264163, 0.27259701, 0.27255234, 0.27250764, 0.27246287, 0.27241808, 0.2723732, 0.27232826, 0.27228329, 0.27223822, 0.27219313, 0.27214798, 0.27210277, 0.2720575, 0.27201217, 0.27196679, 0.27192134, 0.27187586, 0.27183032, 0.27178472, 0.27173907, 0.27169332, 0.27164757, 0.27160174, 0.27155587, 0.27150992, 0.27146393, 0.27141786, 0.27137175, 0.27132556, 0.27127939, 0.27123308, 0.27118674, 0.27114037, 0.2710939, 0.27104741, 0.27100086, 0.27095425, 0.27090758, 0.27086082, 0.27081406, 0.27076724, 0.2707203, 0.27067339, 0.27062637, 0.27057931, 0.27053219, 0.27048501, 0.27043778, 0.27039048, 0.27034312, 0.27029577, 0.27024829, 0.27020076, 0.27015319, 0.2701056, 0.27005789, 0.27001017, 0.26996237, 0.26991454, 0.26986662, 0.26981866, 0.26977065, 0.26972258, 0.26967445, 0.26962626, 0.26957804, 0.26952973, 0.26948136, 0.26943296, 0.2693845, 0.26933599, 0.26928741, 0.26923874, 0.26919007, 0.26914135, 0.2690925, 0.26904365, 0.26899472, 0.26894578, 0.26889673, 0.26884767, 0.2687985, 0.26874933, 0.26870006, 0.26865077, 0.26860139, 0.26855198, 0.2685025, 0.26845297, 0.26840338, 0.26835373, 0.26830405, 0.26825428, 0.26820448, 0.26815462, 0.26810467, 0.26805469, 0.26800466, 0.26795459, 0.2679044, 0.26785421, 0.26780394, 0.26775363, 0.26770326, 0.26765284, 0.26760232, 0.26755181, 0.26750124, 0.26745057, 0.26739985, 0.26734906, 0.26729825, 0.26724738, 0.26719645, 0.26714545, 0.2670944, 0.26704329, 0.26699215, 0.26694092, 0.26688966, 0.26683831, 0.26678693, 0.26673549, 0.266684, 0.26663247, 0.26658085, 0.2665292, 0.26647747, 0.2664257, 0.26637384, 0.26632196, 0.26627004, 0.26621804, 0.26616597, 0.26611385, 0.26606169, 0.26600945, 0.26595718, 0.26590484, 0.26585245, 0.2658, 0.26574749, 0.26569495, 0.26564232, 0.26558962, 0.2655369, 0.26548412, 0.26543128, 0.26537836, 0.26532543, 0.26527241, 0.26521933, 0.26516622, 0.26511303, 0.26505983, 0.26500651, 0.26495317, 0.26489976, 0.26484632, 0.2647928, 0.26473919, 0.26468557, 0.26463193, 0.26457816, 0.26452437, 0.26447052, 0.26441661, 0.26436263, 0.2643086, 0.26425454, 0.26420042, 0.26414624, 0.26409197, 0.2640377, 0.26398334, 0.26392892, 0.26387444, 0.2638199, 0.26376531, 0.26371071, 0.26365599, 0.26360121, 0.26354644, 0.26349157, 0.26343668, 0.26338169, 0.26332667, 0.26327157, 0.26321641, 0.26316121, 0.26310599, 0.26305068, 0.26299527, 0.26293987, 0.26288438, 0.26282889, 0.26277328, 0.2627176, 0.2626619, 0.26260614, 0.26255035, 0.26249444, 0.26243854, 0.26238257, 0.26232651, 0.26227042, 0.26221427, 0.26215807, 0.2621018, 0.26204544, 0.26198909, 0.26193264, 0.26187617, 0.26181963, 0.26176301, 0.26170638, 0.26164964, 0.26159286, 0.26153606, 0.26147917, 0.26142222, 0.26136523, 0.26130819, 0.26125109, 0.26119393, 0.26113668, 0.2610794, 0.26102209, 0.26096469, 0.26090726, 0.26084974, 0.2607922, 0.26073459, 0.26067692, 0.26061919, 0.26056141, 0.26050359, 0.26044568, 0.26038775, 0.26032972, 0.26027167, 0.26021355, 0.26015538, 0.26009718, 0.26003888, 0.25998053, 0.25992215, 0.25986367, 0.2598052, 0.25974661, 0.25968799, 0.25962931, 0.25957057, 0.2595118, 0.25945294, 0.25939405, 0.25933507, 0.25927606, 0.25921699, 0.25915787, 0.25909868, 0.25903946, 0.25898015, 0.25892079, 0.25886139, 0.25880191, 0.25874242, 0.25868285, 0.25862318, 0.25856352, 0.25850379, 0.25844395, 0.25838411, 0.25832421, 0.25826424, 0.25820422, 0.25814414, 0.258084, 0.2580238, 0.25796354, 0.25790325, 0.25784287, 0.25778246, 0.25772199, 0.25766149, 0.2576009, 0.25754023, 0.25747955, 0.25741878, 0.25735798, 0.2572971, 0.25723618, 0.25717521, 0.25711417, 0.25705308, 0.25699195, 0.25693074, 0.25686949, 0.25680816, 0.2567468, 0.25668538, 0.25662389, 0.25656232, 0.25650075, 0.25643912, 0.25637737, 0.25631565, 0.25625381, 0.25619194, 0.25612998, 0.25606802, 0.25600597, 0.25594386, 0.2558817, 0.2558195, 0.25575724, 0.2556949, 0.25563252, 0.25557008, 0.25550759, 0.25544503, 0.25538242, 0.25531977, 0.25525707, 0.25519428, 0.25513145, 0.25506857, 0.25500563, 0.25494263, 0.25487959, 0.25481644, 0.25475329, 0.25469008, 0.25462678, 0.25456345, 0.25450006, 0.25443661, 0.25437313, 0.25430956, 0.25424594, 0.25418228, 0.25411853, 0.25405475, 0.25399092, 0.25392702, 0.25386307, 0.25379908, 0.25373501, 0.25367087, 0.25360671, 0.25354245, 0.25347817, 0.25341386, 0.25334945, 0.25328499, 0.25322047, 0.25315592, 0.25309128, 0.2530266, 0.25296187, 0.25289705, 0.2528322, 0.25276729, 0.25270236, 0.25263733, 0.25257227, 0.25250709, 0.25244194, 0.25237671, 0.25231138, 0.25224605, 0.25218064, 0.25211516, 0.25204965, 0.25198406, 0.25191844, 0.25185275, 0.25178698, 0.2517212, 0.25165534, 0.25158939, 0.25152344, 0.25145739, 0.25139132, 0.25132519, 0.25125897, 0.25119272, 0.25112641, 0.25106004, 0.25099364, 0.25092715, 0.25086063, 0.25079402, 0.25072739, 0.25066069, 0.25059393, 0.25052711, 0.25046027, 0.25039333, 0.25032634, 0.25025931, 0.25019222, 0.25012508, 0.25005785, 0.2499906, 0.24992327, 0.24985591, 0.24978845, 0.24972099, 0.24965344, 0.24958584, 0.2495182, 0.24945046, 0.2493827, 0.2493149, 0.24924698, 0.24917908, 0.24911109, 0.24904303, 0.24897492, 0.24890676, 0.24883854, 0.24877027, 0.24870194, 0.24863356, 0.24856512, 0.24849664, 0.24842806, 0.24835947, 0.24829081, 0.24822207, 0.24815331, 0.24808447, 0.24801557, 0.24794662, 0.24787763, 0.24780856, 0.24773946, 0.24767028, 0.24760106, 0.24753179, 0.24746244, 0.24739306, 0.24732359, 0.24725407, 0.24718453, 0.24711491, 0.24704523, 0.24697551, 0.24690571, 0.24683587, 0.24676596, 0.24669601, 0.246626, 0.24655592, 0.24648581, 0.24641563, 0.24634537, 0.24627511, 0.24620473, 0.24613436, 0.24606389, 0.24599338, 0.24592282, 0.24585217, 0.24578148, 0.24571075, 0.24563995, 0.2455691, 0.24549818, 0.24542722, 0.2453562, 0.24528511, 0.24521399, 0.2451428, 0.24507155, 0.24500024, 0.24492888, 0.24485748, 0.24478599, 0.24471447, 0.2446429, 0.24457125, 0.24449955, 0.2444278, 0.24435601, 0.24428412, 0.24421221, 0.24414025, 0.24406821, 0.24399611, 0.24392398, 0.24385177, 0.24377953, 0.24370721, 0.24363485, 0.24356243, 0.24348994, 0.24341741, 0.2433448, 0.24327216, 0.24319947, 0.24312671, 0.24305388, 0.242981, 0.24290806, 0.2428351, 0.24276204, 0.24268892, 0.24261579, 0.24254258, 0.24246933, 0.242396, 0.24232261, 0.24224918, 0.24217568, 0.24210216, 0.24202853, 0.24195486, 0.24188118, 0.24180739, 0.24173358, 0.2416597, 0.24158575, 0.24151175, 0.24143769, 0.2413636, 0.24128945, 0.2412152, 0.24114096, 0.24106659, 0.24099222, 0.24091777, 0.24084328, 0.2407687, 0.24069409, 0.24061942, 0.24054472, 0.24046993, 0.24039508, 0.24032019, 0.24024524, 0.24017024, 0.24009518, 0.24002008, 0.23994488, 0.23986967, 0.23979439, 0.23971903, 0.23964363, 0.23956817, 0.23949265, 0.23941711, 0.2393415, 0.2392658, 0.23919006, 0.23911427, 0.23903842, 0.23896255, 0.23888654, 0.23881054, 0.23873447, 0.23865835, 0.23858216, 0.23850593, 0.23842962, 0.23835328, 0.23827688, 0.2382004, 0.23812388, 0.23804732, 0.23797069, 0.237894, 0.23781724, 0.23774044, 0.2376636, 0.23758668, 0.23750971, 0.23743267, 0.23735559, 0.23727846, 0.23720124, 0.237124, 0.2370467, 0.23696937, 0.23689194, 0.23681444, 0.23673692, 0.23665936, 0.23658168, 0.236504, 0.23642623, 0.23634844, 0.23627058, 0.23619264, 0.23611465, 0.23603661, 0.23595855, 0.23588039, 0.23580217, 0.23572391, 0.23564561, 0.23556723, 0.23548882, 0.23541033, 0.23533179, 0.23525317, 0.23517454, 0.23509583, 0.23501705, 0.23493823, 0.23485935, 0.23478043, 0.23470144, 0.23462242, 0.23454331, 0.23446412, 0.23438491, 0.23430568, 0.23422633, 0.23414694, 0.23406751, 0.23398802, 0.23390847, 0.23382884, 0.2337492, 0.23366946, 0.23358968, 0.23350987, 0.23342836, 0.23334517, 0.23326196, 0.23317872, 0.23309548, 0.23301224, 0.23292898, 0.23284571, 0.23276241, 0.23267911, 0.2325958, 0.23251249, 0.23242913, 0.23234577, 0.23226242, 0.23217908, 0.23209567, 0.23201224, 0.23192884, 0.23184539, 0.23176198, 0.23167852, 0.23159504, 0.23151156, 0.23142806, 0.23134458, 0.23126107, 0.23117752, 0.23109396, 0.23101041, 0.23092684, 0.23084326, 0.23075968, 0.23067605, 0.23059243, 0.2305088, 0.23042515, 0.23034146, 0.23025781, 0.23017412, 0.23009044, 0.23000669, 0.22992299, 0.22983925, 0.22975549, 0.22967173, 0.22958796, 0.22950418, 0.22942036, 0.22933654, 0.22925273, 0.22916889, 0.22908501, 0.22900115, 0.22891726, 0.22883341, 0.22874947, 0.22866556, 0.22858162, 0.22849767, 0.22841372, 0.22832976, 0.22824576, 0.22816177, 0.22807777, 0.22799374, 0.22790971, 0.22782566, 0.22774161, 0.22765753, 0.22757344, 0.22748934, 0.22740522, 0.2273211, 0.22723697, 0.22715281, 0.22706865, 0.22698447, 0.22690028, 0.22681607, 0.22673187, 0.22664763, 0.22656338, 0.22647914, 0.22639488, 0.22631058, 0.2262263, 0.22614199, 0.22605766, 0.22597335, 0.225889, 0.22580463, 0.22572027, 0.22563589, 0.22555149, 0.22546709, 0.22538266, 0.22529823, 0.22521378, 0.22512931, 0.22504485, 0.22496037, 0.22487585, 0.22479135, 0.22470681, 0.22462228, 0.22453773, 0.22445318, 0.2243686, 0.22428401, 0.22419938, 0.22411476, 0.22403017, 0.2239455, 0.22386087, 0.22377621, 0.22369151, 0.22360684, 0.22352211, 0.2234374, 0.22335266, 0.22326791, 0.22318317, 0.22309838, 0.22301361, 0.22292882, 0.222844, 0.22275919, 0.22267437, 0.22258951, 0.22250465, 0.22241975, 0.22233488, 0.22225, 0.22216508, 0.22208013, 0.22199519, 0.22191025, 0.22182529, 0.22174032, 0.22165534, 0.22157033, 0.22148532, 0.22140029, 0.22131525, 0.22123021, 0.22114511, 0.22106007, 0.22097495, 0.22088985, 0.22080472, 0.22071959, 0.22063446, 0.2205493, 0.22046413, 0.22037892, 0.22029375, 0.22020856, 0.22012331, 0.22003809, 0.21995285, 0.21986759, 0.21978231, 0.21969701, 0.21961172, 0.2195264, 0.2194411, 0.21935575, 0.21927039, 0.21918502, 0.21909967, 0.21901427, 0.21892884, 0.21884347, 0.21875802, 0.2186726, 0.21858713, 0.21850166, 0.21841618, 0.21833071, 0.21824519, 0.21815968, 0.21807413, 0.21798861, 0.21790302, 0.21781747, 0.21773188, 0.2176463, 0.21756071, 0.21747506, 0.21738943, 0.21730378, 0.21721812, 0.21713245, 0.21704674, 0.21696106, 0.21687534, 0.21678963, 0.21670388, 0.21661815, 0.21653235, 0.21644659, 0.21636081, 0.21627501, 0.21618921, 0.21610336, 0.21601753, 0.21593168, 0.21584581, 0.21575993, 0.21567403, 0.21558814, 0.2155022, 0.2154163, 0.21533035, 0.21524438, 0.21515842, 0.21507242, 0.21498644, 0.21490043, 0.21481439, 0.21472839, 0.21464233, 0.21455626, 0.21447021, 0.21438409, 0.21429801, 0.21421191, 0.21412578, 0.21403965, 0.2139535, 0.21386732, 0.21378116, 0.21369497, 0.21360874, 0.21352255, 0.21343634, 0.21335007, 0.21326384, 0.21317756, 0.21309128, 0.21300499, 0.21291867, 0.21283235, 0.21274605, 0.21265969, 0.21257335, 0.21248698, 0.21240059, 0.21231419, 0.21222779, 0.21214135, 0.21205492, 0.21196848, 0.21188204, 0.21179557, 0.2117091, 0.21162258, 0.21153606, 0.21144955, 0.211363, 0.21127646, 0.2111899, 0.21110331, 0.21101673, 0.21093011, 0.21084352, 0.2107569, 0.21067023, 0.2105836, 0.21049693, 0.21041024, 0.21032356, 0.21023685, 0.21015014, 0.2100634, 0.20997664, 0.2098899, 0.20980312, 0.20971633, 0.20962957, 0.20954275, 0.20945595, 0.20936908, 0.20928226, 0.20919538, 0.20910855, 0.20902164, 0.20893474, 0.20884781, 0.2087609, 0.20867397, 0.20858704, 0.20850006, 0.20841308, 0.2083261, 0.20823911, 0.20815207, 0.20806505, 0.207978, 0.20789094, 0.20780389, 0.20771681, 0.20762973, 0.20754261, 0.2074555, 0.20736837, 0.20728123, 0.20719406, 0.2071069, 0.20701972, 0.20693254, 0.20684533, 0.2067581, 0.20667085, 0.20658365, 0.20649636, 0.20640911, 0.20632181, 0.2062345, 0.20614722, 0.20605987, 0.20597254, 0.20588517, 0.20579784, 0.20571046, 0.20562308, 0.20553565, 0.20544825, 0.20536081, 0.20527339, 0.20518593, 0.20509848, 0.20501098, 0.2049235, 0.20483598, 0.20474847, 0.20466095, 0.20457339, 0.20448585, 0.20439829, 0.20431072, 0.20422311, 0.20413549, 0.20404787, 0.20396025, 0.20387262, 0.20378494, 0.20369728, 0.20360959, 0.20352188, 0.2034342, 0.20334645, 0.20325872, 0.20317096, 0.2030832, 0.20299542, 0.20290767, 0.20281985, 0.20273203, 0.2026442, 0.20255637, 0.20246851, 0.20238066, 0.20229279, 0.20220488, 0.20211698, 0.20202905, 0.20194115, 0.20185319, 0.20176522, 0.20167729, 0.20158929, 0.20150129, 0.20141327, 0.20132527, 0.20123725, 0.2011492, 0.20106113, 0.20097306, 0.20088498, 0.20079689, 0.20070878, 0.20062065, 0.2005325, 0.20044437, 0.2003562, 0.20026803, 0.20017986, 0.20009163, 0.20000342, 0.19991519, 0.19982699, 0.19973871, 0.19965045, 0.19956216, 0.19947387, 0.19938558, 0.19929726, 0.19920895, 0.19912058, 0.19903222, 0.19894388, 0.19885549, 0.19876708, 0.19867869, 0.19859025, 0.19850183, 0.1984134, 0.19832492, 0.19823647, 0.19814798, 0.19805948, 0.19797097, 0.19788244, 0.1977939, 0.19770534, 0.19761682, 0.19752823, 0.19743964, 0.19735104, 0.19726241, 0.19717382, 0.19708519, 0.19699651, 0.19690783, 0.19681917, 0.19673049, 0.19664179, 0.19655304, 0.19646433, 0.19637558, 0.19628683, 0.19619808, 0.19610929, 0.19602047, 0.19593169, 0.19584288, 0.19575404, 0.19566521, 0.19557633, 0.19548744, 0.19539857, 0.1953097, 0.19522077, 0.19513182, 0.19504292, 0.19495396, 0.194865, 0.19477603, 0.19468705, 0.19459803, 0.19450901, 0.19442001, 0.19433096, 0.19424193, 0.19415286, 0.19406377, 0.19397469, 0.19388558, 0.19379647, 0.19370735, 0.19361818, 0.19352904, 0.19343987, 0.19335069, 0.19326149, 0.19317228, 0.19308309, 0.19299386, 0.19290461, 0.19281533, 0.19272608, 0.19263676, 0.1925475, 0.19245817, 0.19236885, 0.19227952, 0.19219019, 0.19210082, 0.19201145, 0.19192205, 0.19183263, 0.19174325, 0.19165383, 0.19156437, 0.19147493, 0.19138546, 0.19129601, 0.1912065, 0.191117, 0.19102749, 0.19093795, 0.19084841, 0.19075885, 0.1906693, 0.1905797, 0.19049011, 0.19040056, 0.1903109, 0.19022124, 0.1901316, 0.19004196, 0.18995228, 0.18986259, 0.18977292, 0.1896832, 0.18959348, 0.18950374, 0.18941399, 0.18932424, 0.18923445, 0.18914467, 0.18905488, 0.18896507, 0.18887524, 0.1887854, 0.18869555, 0.18860567, 0.18851583, 0.18842594, 0.18833603, 0.18824612, 0.18815617, 0.18806624, 0.18797629, 0.18788631, 0.18779632, 0.18770632, 0.18761633, 0.18752632, 0.1874363, 0.18734626, 0.18725619, 0.18716612, 0.18707603, 0.18698594, 0.18689582, 0.1868057, 0.18671557, 0.18662544, 0.18653525, 0.18644509, 0.18635491, 0.18626469, 0.18617453, 0.18608427, 0.18599403, 0.18590377, 0.18581352, 0.18572323, 0.18563296, 0.18554263, 0.18545233, 0.18536201, 0.18527167, 0.1851813, 0.18509094, 0.18500055, 0.18491016, 0.18481976, 0.18472935, 0.18463892, 0.18454847, 0.18445799, 0.18436757, 0.18427707, 0.18418658, 0.18409607, 0.18400554, 0.183915, 0.18382446, 0.18373388, 0.18364333, 0.18355273, 0.18346213, 0.18337151, 0.18328092, 0.18319027, 0.18309961, 0.18300895, 0.18291827, 0.18282759, 0.18273689, 0.18264616, 0.18255545, 0.1824647, 0.18237394, 0.18228319, 0.1821924, 0.18210164, 0.18201083, 0.18191999, 0.18182917, 0.1817383, 0.18164748, 0.18155661, 0.1814657, 0.18137482, 0.18128391, 0.18119298, 0.18110204, 0.1810111, 0.18092014, 0.18082917, 0.18073818, 0.18064718, 0.18055618, 0.18046516, 0.1803741, 0.18028308, 0.18019201, 0.18010092, 0.18000983, 0.17991872, 0.17982763, 0.1797365, 0.17964536, 0.17955419, 0.17946303, 0.17937183, 0.17928067, 0.17918946, 0.17909825, 0.17900701, 0.17891577, 0.17882451, 0.17873326, 0.17864197, 0.17855066, 0.17845935, 0.17836803, 0.17827669, 0.17818536, 0.178094, 0.17800263, 0.17791124, 0.17781985, 0.17772843, 0.177637, 0.17754556, 0.17745411, 0.17736267, 0.17727119, 0.17717968, 0.17708819, 0.17699668, 0.17690516, 0.17681362, 0.17672205, 0.1766305, 0.1765389, 0.17644733, 0.17635572, 0.17626409, 0.17617247, 0.17608082, 0.17598915, 0.17589751, 0.17580584, 0.17571412, 0.17562242, 0.17553069, 0.17543896, 0.17534722, 0.17525545, 0.17516369, 0.1750719, 0.1749801, 0.17488828, 0.17479646, 0.17470463, 0.17461278, 0.17452091, 0.17442904, 0.17433713, 0.17424525, 0.17415334, 0.17406142, 0.17396946, 0.17387752, 0.17378554, 0.17369357, 0.17360157, 0.17350958, 0.17341757, 0.17332552, 0.17323349, 0.17314143, 0.17304936, 0.17295727, 0.17286518, 0.17277308, 0.17268096, 0.17258883, 0.17249669, 0.17240451, 0.17231235, 0.17222017, 0.17212796, 0.17203577, 0.17194353, 0.17185129, 0.17175904, 0.17166679, 0.17157449, 0.17148221, 0.17138994, 0.17129762, 0.17120528, 0.17111292, 0.17102058, 0.17092822, 0.17083585, 0.17074344, 0.17065108, 0.17055863, 0.17046621, 0.17037377, 0.17028131, 0.17018884, 0.17009635, 0.17000383, 0.16991135, 0.16981883, 0.1697263, 0.16963375, 0.16954118, 0.16944864, 0.16935606, 0.16926344, 0.16917081, 0.1690782, 0.16898558, 0.16889293, 0.16880026, 0.16870758, 0.16861489, 0.16852219, 0.16842948, 0.16833676, 0.168244, 0.16815124, 0.1680585, 0.16796574, 0.16787294, 0.16778013, 0.16768731, 0.16759449, 0.16750164, 0.16740879, 0.16731592, 0.16722304, 0.16713014, 0.16703723, 0.16694431, 0.16685139, 0.16675843, 0.16666548, 0.1665725, 0.16647951, 0.16638653, 0.1662935, 0.1662005, 0.16610746, 0.16601439, 0.16592133, 0.16582827, 0.16573519, 0.16564207, 0.16554897, 0.16545583, 0.16536269, 0.16526955, 0.16517641, 0.16508321, 0.16499001, 0.1648968, 0.16480358, 0.16471036, 0.16461712, 0.16452387, 0.1644306, 0.16433731, 0.16424403, 0.16415071, 0.16405739, 0.16396405, 0.16387072, 0.16377735, 0.163684, 0.16359061, 0.16349719, 0.16340381, 0.16331041, 0.16321693, 0.16312349, 0.16303004, 0.16293655, 0.16284308, 0.16274957, 0.16265605, 0.16256253, 0.16246897, 0.16237547, 0.16228189, 0.16218829, 0.16209471, 0.16200112, 0.16190749, 0.16181387, 0.16172023, 0.16162655, 0.16153289, 0.16143921, 0.16134554, 0.16125181, 0.1611581, 0.16106436, 0.16097063, 0.16087686, 0.1607831, 0.16068931, 0.16059551, 0.16050172, 0.16040789, 0.16031405, 0.16022019, 0.16012634, 0.16003247, 0.15993857, 0.15984467, 0.15975076, 0.15965684, 0.15956289, 0.15946895, 0.15937498, 0.159281, 0.15918702, 0.15909301, 0.158999, 0.15890497, 0.15881093, 0.15871687, 0.1586228, 0.15852872, 0.15843463, 0.15834051, 0.1582464, 0.15815225, 0.15805812, 0.15796396, 0.1578698, 0.15777561, 0.15768141, 0.15758722, 0.157493, 0.15739875, 0.1573045, 0.15721025, 0.15711597, 0.15702169, 0.15692738, 0.15683307, 0.15673874, 0.1566444, 0.15655006, 0.1564557, 0.1563613, 0.15626691, 0.15617253, 0.1560781, 0.15598369, 0.15588924, 0.15579477, 0.15570033, 0.15560582, 0.15551135, 0.15541685, 0.15532231, 0.1552278, 0.15513325, 0.15503868, 0.15494412, 0.15484953, 0.15475492, 0.15466033, 0.15456571, 0.15447105, 0.1543764, 0.15428177, 0.15418708, 0.1540924, 0.1539977, 0.15390298, 0.15380827, 0.15371352, 0.15361877, 0.15352401, 0.15342923, 0.15333442, 0.15323964, 0.15314482, 0.15304999, 0.15295516, 0.15286028, 0.15276545, 0.15267055, 0.15257566, 0.15248075, 0.15238583, 0.15229091, 0.15219596, 0.152101, 0.15200602, 0.15191104, 0.15181607, 0.15172105, 0.15162602, 0.15153098, 0.15143593, 0.15134089, 0.15124582, 0.15115072, 0.15105562, 0.15096051, 0.15086539, 0.15077025, 0.1506751, 0.15057993, 0.15048474, 0.15038958, 0.15029436, 0.15019915, 0.15010393, 0.15000866, 0.14991343, 0.14981817, 0.14972287, 0.14962758, 0.14953227, 0.14943697, 0.14934163, 0.14924629, 0.14915094, 0.14905556, 0.14896017, 0.14886478, 0.14876936, 0.14867395, 0.14857849, 0.14848307, 0.1483876, 0.14829212, 0.14819667, 0.14810115, 0.14800562, 0.14791013, 0.14781457, 0.14771903, 0.14762345, 0.14752787, 0.1474323, 0.14733669, 0.14724109, 0.14714545, 0.14704981, 0.14695416, 0.1468585, 0.1467628, 0.14666712, 0.14657141, 0.1464757, 0.14637996, 0.14628422, 0.14618845, 0.14609268, 0.14599693, 0.14590113, 0.14580531, 0.14570948, 0.14561364, 0.14551783, 0.14542195, 0.14532608, 0.14523019, 0.14513429, 0.14503838, 0.14494246, 0.1448465, 0.14475057, 0.1446546, 0.14455864, 0.14446265, 0.14436664, 0.14427061, 0.14417459, 0.14407857, 0.1439825, 0.14388643, 0.14379483, 0.14370759, 0.14362034, 0.14353316, 0.14344598, 0.1433588, 0.14327164, 0.14318451, 0.14309743, 0.14301033, 0.14292327, 0.1428362, 0.14274918, 0.14266215, 0.14257517, 0.1424882, 0.14240125, 0.14231429, 0.1422274, 0.14214048, 0.1420536, 0.14196675, 0.14187992, 0.1417931, 0.1417063, 0.14161952, 0.14153273, 0.14144601, 0.14135927, 0.14127257, 0.14118589, 0.14109924, 0.14101256, 0.14092597, 0.14083932, 0.14075275, 0.14066619, 0.14057963, 0.14049312, 0.14040661, 0.14032009, 0.14023362, 0.14014716, 0.14006074, 0.13997433, 0.13988793, 0.13980156, 0.13971519, 0.13962886, 0.13954253, 0.13945624, 0.13936995, 0.13928372, 0.13919747, 0.13911125, 0.13902502, 0.13893884, 0.13885269, 0.13876653, 0.13868043, 0.13859431, 0.1385082, 0.13842215, 0.13833609, 0.13825007, 0.13816406, 0.13807806, 0.1379921, 0.13790612, 0.13782023, 0.13773429, 0.13764839, 0.13756253, 0.13747667, 0.13739085, 0.13730504, 0.13721921, 0.13713343, 0.13704768, 0.13696194, 0.13687621, 0.13679053, 0.13670483, 0.13661917, 0.13653354, 0.13644788, 0.1363623, 0.13627672, 0.13619116, 0.13610561, 0.13602009, 0.13593456, 0.13584906, 0.13576362, 0.13567816, 0.13559273, 0.13550732, 0.1354219, 0.13533653, 0.13525118, 0.13516584, 0.13508053, 0.13499525, 0.13490994, 0.13482472, 0.13473947, 0.13465424, 0.13456905, 0.13448386, 0.1343987, 0.13431357, 0.13422844, 0.13414332, 0.13405822, 0.13397318, 0.13388814, 0.13380311, 0.1337181, 0.13363309, 0.13354813, 0.13346317, 0.13337825, 0.13329335, 0.13320847, 0.13312358, 0.13303871, 0.13295388, 0.13286909, 0.13278429, 0.13269952, 0.13261475, 0.13253003, 0.13244531, 0.13236059, 0.13227591, 0.13219126, 0.13210662, 0.13202201, 0.13193738, 0.13185282, 0.13176824, 0.13168369, 0.13159916, 0.13151467, 0.13143018, 0.13134569, 0.13126124, 0.13117683, 0.13109243, 0.13100806, 0.13092366, 0.1308393, 0.13075499, 0.13067067, 0.13058636, 0.13050209, 0.13041782, 0.1303336, 0.13024938, 0.13016519, 0.13008101, 0.12999687, 0.1299127, 0.12982859, 0.12974447, 0.12966041, 0.12957633, 0.12949227, 0.1294083, 0.12932429, 0.12924029, 0.12915632, 0.12907237, 0.12898846, 0.12890454, 0.12882061, 0.12873678, 0.12865292, 0.12856911, 0.12848528, 0.12840149, 0.12831773, 0.12823398, 0.12815022, 0.1280665, 0.12798281, 0.12789914, 0.12781546, 0.12773184, 0.12764823, 0.12756464, 0.12748106, 0.12739746, 0.12731393, 0.12723042, 0.12714691, 0.12706339, 0.12697995, 0.1268965, 0.1268131, 0.12672967, 0.1266463, 0.12656294, 0.12647957, 0.12639622, 0.12631293, 0.12622963, 0.12614638, 0.12606308, 0.12597987, 0.12589668, 0.12581348, 0.12573031, 0.12564714, 0.12556399, 0.12548088, 0.12539779, 0.12531468, 0.12523162, 0.12514862, 0.12506559, 0.12498257, 0.12489958, 0.12481663, 0.12473368, 0.12465075, 0.12456784, 0.12448497, 0.12440208, 0.12431927, 0.12423643, 0.12415361, 0.12407083, 0.12398806, 0.12390529, 0.12382256, 0.12373985, 0.12365716, 0.12357447, 0.12349184, 0.1234092, 0.12332659, 0.12324399, 0.12316139, 0.12307885, 0.12299632, 0.12291376, 0.12283127, 0.1227488, 0.12266636, 0.12258392, 0.12250147, 0.12241907, 0.1223367, 0.12225433, 0.12217195, 0.12208964, 0.12200733, 0.12192505, 0.12184275, 0.12176053, 0.1216783, 0.12159609, 0.12151388, 0.12143171, 0.12134956, 0.12126743, 0.12118529, 0.1211032, 0.12102112, 0.12093909, 0.12085705, 0.12077501, 0.12069303, 0.12061104, 0.12052909, 0.12044714, 0.1203652, 0.12028331, 0.12020142, 0.12011959, 0.12003773, 0.1199559, 0.11987409, 0.1197923, 0.11971052, 0.11962878, 0.11954706, 0.11946531, 0.11938363, 0.11930199, 0.11922033, 0.11913872, 0.11905707, 0.11897549, 0.11889391, 0.11881237, 0.1187308, 0.11864928, 0.11856779, 0.11848634, 0.11840487, 0.1183234, 0.118242, 0.11816061, 0.11807919, 0.11799783, 0.1179165, 0.11783518, 0.11775386, 0.11767257, 0.11759134, 0.11751009, 0.11742886, 0.11734762, 0.11726645, 0.11718527, 0.11710413, 0.11702298, 0.11694185, 0.11686078, 0.11677972, 0.11669867, 0.11661761, 0.11653661, 0.1164556, 0.11637461, 0.11629367, 0.11621272, 0.11613181, 0.1160509, 0.11597003, 0.11588918, 0.11580835, 0.11572752, 0.11564669, 0.11556591, 0.11548515, 0.1154044, 0.11532365, 0.11524296, 0.11516229, 0.11508162, 0.11500098, 0.11492032, 0.11483972, 0.11475912, 0.11467854, 0.11459798, 0.11451745, 0.11443692, 0.11435647, 0.11427597, 0.11419553, 0.11411509, 0.11403467, 0.11395425, 0.11387387, 0.11379353, 0.11371318, 0.11363284, 0.11355254, 0.11347228, 0.11339201, 0.11331174, 0.11323153, 0.11315133, 0.11307114, 0.11299095, 0.11291081, 0.11283067, 0.11275057, 0.11267051, 0.11259042, 0.11251036, 0.11243034, 0.11235033, 0.11227031, 0.11219034, 0.11211038, 0.11203046, 0.11195051, 0.11187064, 0.11179077, 0.11171091, 0.11163104, 0.11155125, 0.11147144, 0.11139166, 0.11131188, 0.11123213, 0.1111524, 0.11107273, 0.11099305, 0.11091337, 0.11083372, 0.1107541, 0.1106745, 0.11059488, 0.11051532, 0.11043578, 0.11035623, 0.11027676, 0.11019723, 0.11011776, 0.11003833, 0.10995885, 0.10987944, 0.10980006, 0.10972068, 0.1096413, 0.10956197, 0.10948268, 0.10940338, 0.10932409, 0.10924482, 0.10916559, 0.10908636, 0.10900715, 0.10892795, 0.1088488, 0.10876964, 0.10869052, 0.10861143, 0.10853234, 0.10845327, 0.10837422, 0.10829517, 0.10821617, 0.10813718, 0.10805821, 0.10797923, 0.1079003, 0.10782141, 0.10774252, 0.10766364, 0.10758477, 0.10750594, 0.10742711, 0.10734832, 0.10726952, 0.10719076, 0.10711203, 0.10703333, 0.10695463, 0.10687592, 0.10679726, 0.10671863, 0.10663999, 0.10656137, 0.1064828, 0.10640424, 0.10632566, 0.10624716, 0.10616865, 0.10609017, 0.1060117, 0.10593322, 0.10585479, 0.10577639, 0.10569798, 0.10561959, 0.10554125, 0.10546294, 0.10538462, 0.10530632, 0.10522803, 0.10514978, 0.10507154, 0.10499331, 0.1049151, 0.10483692, 0.10475876, 0.1046806, 0.10460249, 0.10452441, 0.10444632, 0.10436825, 0.10429018, 0.10421216, 0.10413414, 0.10405616, 0.10397819, 0.10390023, 0.10382233, 0.10374442, 0.10366654, 0.10358864, 0.10351078, 0.10343295, 0.10335512, 0.10327732, 0.10319955, 0.10312179, 0.10304409, 0.10296635, 0.10288864, 0.10281096, 0.10273331, 0.10265565, 0.10257804, 0.10250042, 0.10242285, 0.10234527, 0.10226775, 0.10219023, 0.10211272, 0.10203522, 0.10195774, 0.1018803, 0.10180288, 0.10172544, 0.10164804, 0.10157069, 0.10149336, 0.10141603, 0.10133868, 0.10126141, 0.10118414, 0.10110685, 0.1010296, 0.10095241, 0.10087521, 0.10079803, 0.10072089, 0.10064373, 0.1005666, 0.1004895, 0.10041244, 0.10033535, 0.10025831, 0.1001813, 0.10010426, 0.10002728, 0.099950314, 0.099873401, 0.099796467, 0.099719547, 0.099642672, 0.099565774, 0.099488944, 0.099412084, 0.099335276, 0.09925849, 0.099181712, 0.099104993, 0.099028237, 0.098951511, 0.09887483, 0.098798148, 0.098721452, 0.098644823, 0.098568209, 0.098491587, 0.098415017, 0.098338477, 0.098261937, 0.09818542, 0.09810888, 0.098032415, 0.097955965, 0.097879499, 0.097803056, 0.097726658, 0.097650275, 0.097573929, 0.097497582, 0.097421214, 0.097344913, 0.097268626, 0.097192355, 0.097116075, 0.097039856, 0.096963644, 0.096887417, 0.096811265, 0.096735112, 0.096658982, 0.096582867, 0.096506745, 0.096430674, 0.096354619, 0.096278585, 0.096202537, 0.096126527, 0.096050546, 0.095974609, 0.095898665, 0.095822729, 0.095746815, 0.095670938, 0.095595077, 0.095519185, 0.09544339, 0.095367566, 0.095291764, 0.095216006, 0.095140263, 0.095064536, 0.094988823, 0.094913095, 0.094837442, 0.094761789, 0.094686158, 0.094610505, 0.094534919, 0.094459355, 0.094383799, 0.094308287, 0.094232731, 0.094157219, 0.094081759, 0.094006293, 0.093930833, 0.093855396, 0.093779996, 0.093704648, 0.093629248, 0.093553901, 0.093478598, 0.093403272, 0.093327969, 0.093252704, 0.093177438, 0.093102224, 0.093026988, 0.092951827, 0.092876635, 0.092801504, 0.092726357, 0.092651226, 0.092576139, 0.092501067, 0.092426002, 0.092350945, 0.092275932, 0.09220095, 0.092125975, 0.092050977, 0.091976061, 0.091901116, 0.091826238, 0.091751337, 0.091676466, 0.091601633, 0.091526799, 0.091451988, 0.091377206, 0.091302447, 0.091227688, 0.091152959, 0.091078229, 0.091003545, 0.090928882, 0.090854235, 0.090779573, 0.09070497, 0.090630397, 0.090555809, 0.090481244, 0.090406701, 0.090332195, 0.090257697, 0.090183191, 0.090108745, 0.090034291, 0.089959875, 0.089885503, 0.089811124, 0.089736752, 0.089662403, 0.089588076, 0.089513741, 0.089439467, 0.089365192, 0.089290939, 0.089216694, 0.089142509, 0.089068338, 0.08899419, 0.088919997, 0.088845871, 0.08877176, 0.088697664, 0.088623576, 0.088549525, 0.088475488, 0.088401489, 0.088327497, 0.088253513, 0.088179544, 0.088105619, 0.088031679, 0.08795777, 0.087883867, 0.087810025, 0.087736167, 0.087662347, 0.087588549, 0.08751478, 0.087441012, 0.087367237, 0.087293535, 0.087219834, 0.087146111, 0.087072439, 0.086998813, 0.086925171, 0.086851582, 0.086777985, 0.086704411, 0.086630829, 0.086557321, 0.086483791, 0.086410299, 0.086336799, 0.086263366, 0.086189888, 0.086116508, 0.086043112, 0.085969701, 0.085896365, 0.085822992, 0.085749693, 0.085676387, 0.085603118, 0.085529804, 0.08545658, 0.085383385, 0.085310183, 0.085236996, 0.085163802, 0.085090645, 0.085017525, 0.084944405, 0.0848713, 0.084798247, 0.084725194, 0.084652178, 0.084579132, 0.084506139, 0.084433183, 0.084360227, 0.084287249, 0.084214352, 0.084141456, 0.084068589, 0.0839957, 0.083922885, 0.083850056, 0.083777256, 0.083704472, 0.083631709, 0.083558969, 0.083486244, 0.083413534, 0.083340831, 0.083268166, 0.083195515, 0.083122931, 0.083050258, 0.082977705, 0.082905121, 0.08283259, 0.082760036, 0.082687542, 0.082615025, 0.082542539, 0.082470082, 0.082397684, 0.08232525, 0.082252853, 0.08218047, 0.082108103, 0.082035773, 0.08196345, 0.081891179, 0.081818856, 0.081746601, 0.081674375, 0.081602149, 0.081529945, 0.081457742, 0.081385583, 0.081313431, 0.081241295, 0.081169195, 0.081097104, 0.081025042, 0.080953002, 0.080880955, 0.080808952, 0.08073698, 0.080665007, 0.080593005, 0.080521099, 0.080449179, 0.080377281, 0.08030539, 0.080233559, 0.080161721, 0.080089897, 0.080018096, 0.079946302, 0.079874553, 0.079802789, 0.079731047, 0.079659358, 0.079587683, 0.079516023, 0.079444386, 0.079372741, 0.079301141, 0.079229556, 0.079158016, 0.079086445, 0.079014897, 0.078943387, 0.078871891, 0.078800425, 0.078728996, 0.078657553, 0.078586154, 0.07851474, 0.078443356, 0.078372009, 0.07830067, 0.078229353, 0.078158051, 0.078086764, 0.078015514, 0.077944286, 0.077873066, 0.077801853, 0.077730663, 0.077659495, 0.077588335, 0.077517234, 0.077446133, 0.077375039, 0.077303968, 0.077232927, 0.077161916, 0.077090912, 0.077019878, 0.076948926, 0.076877981, 0.07680703, 0.0767361, 0.076665245, 0.076594368, 0.07652352, 0.076452672, 0.076381855, 0.076311059, 0.076240301, 0.076169513, 0.076098762, 0.076028064, 0.075957365, 0.075886704, 0.07581602, 0.075745381, 0.075674742, 0.075604141, 0.075533569, 0.075462997, 0.075392425, 0.075321905, 0.075251378, 0.075180896, 0.075110465, 0.075040005, 0.07496956, 0.074899152, 0.074828759, 0.074758388, 0.07468804, 0.074617714, 0.074547365, 0.074477069, 0.07440684, 0.074336559, 0.074266329, 0.074196093, 0.074125916, 0.074055716, 0.073985554, 0.073915429, 0.07384529, 0.073775157, 0.0737051, 0.073635049, 0.073564999, 0.073494986, 0.073424943, 0.073354959, 0.073285006, 0.073215075, 0.073145129, 0.073075227, 0.073005326, 0.072935455, 0.072865598, 0.072795771, 0.072725974, 0.07265614, 0.072586372, 0.072516613, 0.07244689, 0.072377183, 0.072307512, 0.07223779, 0.072168142, 0.072098508, 0.072028883, 0.071959272, 0.071889684, 0.071820118, 0.071750589, 0.071681038, 0.071611546, 0.071542084, 0.071472608, 0.071403153, 0.071333721, 0.071264319, 0.071194932, 0.071125567, 0.071056172, 0.07098686, 0.070917554, 0.070848286, 0.070778988, 0.070709728, 0.070640512, 0.070571288, 0.07050208, 0.070432909, 0.070363753, 0.070294634, 0.070225462, 0.070156388, 0.070087329, 0.070018262, 0.069949217, 0.069880165, 0.069811165, 0.069742195, 0.069673218, 0.06960427, 0.069535367, 0.069466457, 0.069397576, 0.069328673, 0.06925983, 0.069191016, 0.069122195, 0.069053389, 0.068984628, 0.068915881, 0.068847135, 0.068778411, 0.068709724, 0.068641059, 0.068572409, 0.06850376, 0.068435155, 0.068366557, 0.068297945, 0.068229385, 0.068160847, 0.068092324, 0.06802386, 0.067955367, 0.067886867, 0.067818433, 0.067750007, 0.067681618, 0.067613229, 0.06754484, 0.067476496, 0.067408174, 0.067339867, 0.067271583, 0.067203306, 0.067135051, 0.067066804, 0.066998608, 0.066930406, 0.066862248, 0.066794053, 0.066725917, 0.066657834, 0.06658975, 0.066521659, 0.066453591, 0.06638553, 0.066317521, 0.066249512, 0.066183403, 0.06611906, 0.066054806, 0.06599056, 0.065926298, 0.065862089, 0.065797873, 0.065733746, 0.065669581, 0.065605491, 0.065541409, 0.065477371, 0.065413326, 0.065349326, 0.06528537, 0.065221414, 0.065157503, 0.065093592, 0.065029711, 0.064965889, 0.064902052, 0.064838275, 0.064774483, 0.064710781, 0.064647086, 0.064583384, 0.064519726, 0.064456113, 0.064392492, 0.064328916, 0.064265348, 0.064201854, 0.064138375, 0.064074881, 0.06401144, 0.063948035, 0.063884631, 0.063821271, 0.063757911, 0.063694634, 0.063631363, 0.063568085, 0.06350486, 0.063441619, 0.063378476, 0.063315324, 0.063252188, 0.063189082, 0.063126013, 0.063062996, 0.062999934, 0.062936954, 0.062873982, 0.062811047, 0.062748201, 0.062685266, 0.06262242, 0.062559567, 0.062496804, 0.062433999, 0.062371235, 0.062308516, 0.062245835, 0.062183116, 0.062120479, 0.062057886, 0.06199529, 0.061932702, 0.061870154, 0.06180764, 0.061745178, 0.061682712, 0.061620288, 0.061557867, 0.061495487, 0.061433151, 0.061370812, 0.061308518, 0.061246224, 0.061184015, 0.061121762, 0.061059549, 0.060997382, 0.060935263, 0.060873136, 0.06081105, 0.060749017, 0.060686976, 0.060624935, 0.060562938, 0.060500987, 0.060439076, 0.060377162, 0.060315292, 0.060253426, 0.060191642, 0.060129859, 0.060068034, 0.060006294, 0.059944596, 0.059882898, 0.059821241, 0.059759583, 0.059697971, 0.059636403, 0.059574828, 0.059513304, 0.059451818, 0.059390333, 0.059328888, 0.059267446, 0.059206046, 0.059144691, 0.059083331, 0.059022017, 0.058960747, 0.05889947, 0.058838245, 0.058777012, 0.058715824, 0.058654681, 0.058593538, 0.058532435, 0.058471333, 0.058410276, 0.0583493, 0.058288243, 0.058227308, 0.05816634, 0.05810545, 0.058044516, 0.05798367, 0.057922825, 0.057862021, 0.057801221, 0.057740454, 0.057679739, 0.05761902, 0.057558391, 0.057497669, 0.057437036, 0.057376444, 0.057315897, 0.057255305, 0.057194803, 0.057134297, 0.057073835, 0.05701337, 0.056952998, 0.056892574, 0.056832239, 0.056771863, 0.056711573, 0.056651279, 0.056591026, 0.056530777, 0.056470614, 0.056410447, 0.056350287, 0.056290206, 0.056230042, 0.056170005, 0.056109928, 0.056049932, 0.05598994, 0.055929944, 0.055870038, 0.055810127, 0.055750217, 0.055690397, 0.055630531, 0.055570748, 0.055510964, 0.055451188, 0.055391494, 0.055331793, 0.055272143, 0.055212446, 0.055152837, 0.05509327, 0.055033702, 0.054974131, 0.05491465, 0.054855168, 0.054795686, 0.054736249, 0.054676849, 0.054617494, 0.054558139, 0.054498784, 0.05443947, 0.054380205, 0.054320976, 0.054261703, 0.054202519, 0.054143377, 0.054084238, 0.05402514, 0.053966042, 0.053906985, 0.053847928, 0.053788956, 0.05372994, 0.053670969, 0.053612042, 0.053553157, 0.053494271, 0.05343543, 0.053376622, 0.053317823, 0.053259026, 0.053200308, 0.053141594, 0.053082921, 0.053024206, 0.052965574, 0.052906986, 0.052848399, 0.052789893, 0.052731305, 0.052672803, 0.052614346, 0.052555885, 0.052497428, 0.052439053, 0.052380674, 0.052322343, 0.052264009, 0.052205719, 0.052147474, 0.052089229, 0.052031025, 0.051972818, 0.051914658, 0.05185654, 0.051798418, 0.051740345, 0.051682312, 0.051624276, 0.051566325, 0.051508296, 0.051450342, 0.05139244, 0.051334575, 0.051276669, 0.051218849, 0.051161025, 0.051103253, 0.051045474, 0.050987735, 0.050930046, 0.050872348, 0.050814699, 0.050757051, 0.050699484, 0.050641876, 0.050584309, 0.050526787, 0.05046935, 0.050411869, 0.050354432, 0.050296996, 0.0502396, 0.050182249, 0.05012494, 0.050067589, 0.05001032, 0.049953051, 0.04989583, 0.049838606, 0.049781468, 0.049724329, 0.049667187, 0.04961009, 0.049552996, 0.049495984, 0.049438976, 0.04938196, 0.049324989, 0.049268071, 0.049211141, 0.049154304, 0.049097415, 0.049040575, 0.048983779, 0.048927024, 0.048870225, 0.048813514, 0.048756842, 0.048700169, 0.0486435, 0.048586871, 0.048530284, 0.048473746, 0.048417158, 0.048360661, 0.0483042, 0.048247747, 0.048191331, 0.048134871, 0.0480785, 0.04802217, 0.047965843, 0.047909513, 0.047853265, 0.047797024, 0.047740825, 0.047684576, 0.047628421, 0.047572304, 0.047516186, 0.047460068, 0.047404036, 0.047348004, 0.047291972, 0.047235984, 0.047180042, 0.047124095, 0.047068235, 0.04701237, 0.046956472, 0.046900652, 0.046844877, 0.046789143, 0.046733368, 0.046677634, 0.046621945, 0.046566296, 0.046510648, 0.046455041, 0.046399482, 0.046343919, 0.046288356, 0.046232875, 0.046177398, 0.046121966, 0.046066489, 0.046011098, 0.045955744, 0.045900397, 0.045845132, 0.045789786, 0.045734521, 0.045679297, 0.045624118, 0.045568898, 0.045513719, 0.045458626, 0.045403533, 0.045348436, 0.045293387, 0.045238335, 0.045183368, 0.04512836, 0.045073438, 0.045018513, 0.044963636, 0.044908755, 0.044853911, 0.044799119, 0.044744324, 0.04468957, 0.044634819, 0.044580106, 0.044525441, 0.044470813, 0.044416144, 0.044361521, 0.044306982, 0.044252444, 0.044197898, 0.044143405, 0.044088949, 0.044034496, 0.043980084, 0.043925669, 0.043871343, 0.043817017, 0.043762691, 0.043708406, 0.043654162, 0.043599922, 0.043545764, 0.043491524, 0.04343741, 0.043383297, 0.043329187, 0.043275114, 0.043221042, 0.043167051, 0.043113068, 0.043059085, 0.043005139, 0.042951237, 0.042897381, 0.04284348, 0.042789664, 0.042735893, 0.042682119, 0.042628348, 0.042574618, 0.042520925, 0.04246724, 0.042413637, 0.042359993, 0.04230639, 0.042252827, 0.042199314, 0.042145751, 0.042092279, 0.042038843, 0.041985411, 0.041931979, 0.041878637, 0.041825287, 0.041771937, 0.041718636, 0.041665375, 0.041612111, 0.041558892, 0.041505676, 0.041452542, 0.041399408, 0.041346271, 0.041293226, 0.041240133, 0.041187085, 0.041134078, 0.041081116, 0.041028149, 0.040975232, 0.040922351, 0.040869474, 0.040816598, 0.040763766, 0.040711012, 0.040658217, 0.040605471, 0.040552761, 0.040500052, 0.040447429, 0.040394809, 0.040342186, 0.040289607, 0.040237024, 0.040184531, 0.040131994, 0.040079501, 0.040027089, 0.039974682, 0.03992223, 0.039869864, 0.039817538, 0.039765257, 0.039712932, 0.039660651, 0.039608411, 0.039556216, 0.039504018, 0.039451864, 0.039399754, 0.039347641, 0.039295573, 0.039243504, 0.039191477, 0.039139498, 0.039087556, 0.03903557, 0.038983632, 0.038931776, 0.03887992, 0.038828064, 0.038776249, 0.038724441, 0.038672712, 0.038620941, 0.038569257, 0.038517568, 0.038465928, 0.038414285, 0.038362686, 0.038311128, 0.03825957, 0.038208097, 0.038156539, 0.038105071, 0.038053643, 0.038002253, 0.037950825, 0.037899479, 0.037848137, 0.037796877, 0.037745573, 0.037694316, 0.037643101, 0.037591886, 0.037540708, 0.037489537, 0.037438449, 0.03738736, 0.037336271, 0.037285224, 0.037234221, 0.037183218, 0.0371323, 0.037081294, 0.037030421, 0.036979545, 0.036928713, 0.036877837, 0.036827046, 0.036776256, 0.036725551, 0.03667476, 0.036624096, 0.036573436, 0.036522817, 0.036472153, 0.036421575, 0.036371, 0.036320467, 0.036269929, 0.036219481, 0.036168989, 0.036118582, 0.036068216, 0.036017768, 0.035967447, 0.035917126, 0.035866845, 0.035816524, 0.035766289, 0.035716094, 0.0356659, 0.035615709, 0.035565555, 0.035515446, 0.035465382, 0.035415314, 0.035365291, 0.035315268, 0.03526533, 0.035215307, 0.03516541, 0.035115514, 0.035065666, 0.03501581, 0.034965958, 0.034916189, 0.034866422, 0.034816697, 0.034766927, 0.034717247, 0.034667607, 0.034618009, 0.034568369, 0.034518775, 0.034469217, 0.034419704, 0.034370195, 0.034320727, 0.034271255, 0.034221873, 0.034172487, 0.034123059, 0.034073718, 0.034024417, 0.033975162, 0.033925865, 0.033876609, 0.033827435, 0.033778265, 0.03372905, 0.033679925, 0.033630837, 0.033581793, 0.033532709, 0.033483665, 0.033434708, 0.03338575, 0.033336751, 0.033287831, 0.033238962, 0.033190131, 0.0331413, 0.033092428, 0.033043679, 0.032994892, 0.032946192, 0.032897446, 0.032848787, 0.032800127, 0.032751508, 0.032702893, 0.032654319, 0.032605786, 0.032557294, 0.032508764, 0.032460317, 0.03241187, 0.032363467, 0.03231506, 0.032266703, 0.032218382, 0.032170106, 0.03212183, 0.032073509, 0.032025319, 0.031977084, 0.031928938, 0.031880744, 0.031832639, 0.031784579, 0.031736512, 0.031688452, 0.031640429, 0.031592451, 0.031544518, 0.031496536, 0.031448644, 0.031400751, 0.031352904, 0.031305052, 0.031257246, 0.031209478, 0.031161757, 0.031114034, 0.031066312, 0.031018632, 0.030970996, 0.0309234, 0.030875804, 0.030828211, 0.030780701, 0.030733235, 0.030685684, 0.030638259, 0.030590834, 0.030543454, 0.030496029, 0.030448688, 0.030401351, 0.030354055, 0.030306758, 0.030259505, 0.030212337, 0.030165168, 0.030117998, 0.030070832, 0.030023705, 0.029976621, 0.029929582, 0.029882496, 0.029835498, 0.029788544, 0.029741632, 0.029694676, 0.029647764, 0.029600892, 0.029554065, 0.029507194, 0.02946041, 0.029413667, 0.029366925, 0.029320182, 0.029273527, 0.029226867, 0.029180255, 0.029133638, 0.029087024, 0.029040495, 0.028993966, 0.028947478, 0.028900949, 0.028854504, 0.028808104, 0.028761746, 0.028715344, 0.028668985, 0.02862267, 0.028576396, 0.028530123, 0.02848389, 0.028437659, 0.028391512, 0.028345367, 0.02829922, 0.028253118, 0.028207058, 0.028160997, 0.028114935, 0.02806896, 0.028022984, 0.027977053, 0.027931118, 0.02788523, 0.027839383, 0.027793577, 0.027747728, 0.027701924, 0.02765616, 0.027610485, 0.027564721, 0.027519045, 0.027473411, 0.027427819, 0.027382227, 0.027336592, 0.027291086, 0.027245579, 0.027200071, 0.027154567, 0.027109144, 0.027063724, 0.027018385, 0.026972964, 0.02692767, 0.026882334, 0.026837083, 0.026791789, 0.026746582, 0.026701372, 0.02665625, 0.026611039, 0.026565917, 0.026520837, 0.026475798, 0.02643076, 0.026385725, 0.026340729, 0.026295774, 0.026250865, 0.02620591, 0.026161043, 0.026116176, 0.026071394, 0.026026567, 0.025981788, 0.025937047, 0.025892351, 0.02584761, 0.025802957, 0.0257583, 0.025713688, 0.025669077, 0.025624508, 0.025579982, 0.025535498, 0.025491012, 0.025446529, 0.025402131, 0.025357733, 0.025313374, 0.025268976, 0.025224661, 0.025180347, 0.025136121, 0.025091847, 0.025047621, 0.025003433, 0.02495929, 0.024915105, 0.024871005, 0.024826946, 0.02478289, 0.024738831, 0.024694815, 0.024650844, 0.024606911, 0.024563024, 0.024519052, 0.024475208, 0.024431363, 0.024387559, 0.024343714, 0.024299955, 0.024256237, 0.024212563, 0.024168847, 0.024125172, 0.024081541, 0.024037952, 0.023994362, 0.023950813, 0.023907268, 0.023863805, 0.023820261, 0.023776842, 0.023733422, 0.023690045, 0.023646712, 0.023603292, 0.023560002, 0.023516756, 0.023473464, 0.023430213, 0.023387007, 0.023343844, 0.023300681, 0.023257518, 0.023214441, 0.023171362, 0.023128327, 0.023085291, 0.023042299, 0.022999307, 0.022956397, 0.022913449, 0.022870585, 0.02282772, 0.022784896, 0.022742074, 0.022699252, 0.022656513, 0.02261382, 0.022571126, 0.022528389, 0.022485737, 0.022443127, 0.02240056, 0.022357952, 0.022315428, 0.022272903, 0.02223042, 0.022187939, 0.0221455, 0.022103062, 0.022060707, 0.022018356, 0.021976002, 0.02193369, 0.021891423, 0.021849196, 0.021806929, 0.021764744, 0.021722605, 0.021680422, 0.02163828, 0.021596182, 0.021554127, 0.021512114, 0.021470059, 0.02142809, 0.021386117, 0.021344233, 0.021302264, 0.021260379, 0.021218535, 0.021176737, 0.021134935, 0.021093138, 0.021051381, 0.021009708, 0.020967994, 0.020926321, 0.02088465, 0.020843064, 0.020801477, 0.020759888, 0.020718345, 0.020676844, 0.020635385, 0.020593882, 0.020552468, 0.020511093, 0.020469721, 0.020428346, 0.020387014, 0.020345727, 0.020304481, 0.020263236, 0.02022199, 0.020180786, 0.020139668, 0.02009855, 0.02005739, 0.020016314, 0.019975282, 0.019934248, 0.019893216, 0.019852225, 0.019811278, 0.019770373, 0.019729469, 0.019688563, 0.019647744, 0.019606924, 0.019566104, 0.01952537, 0.019484635, 0.019443944, 0.019403253, 0.01936256, 0.019321911, 0.019281346, 0.019240784, 0.019200176, 0.019159654, 0.019119175, 0.019078696, 0.019038219, 0.018997824, 0.01895743, 0.01891708, 0.018876687, 0.018836377, 0.018796112, 0.018755889, 0.018715581, 0.0186754, 0.018635219, 0.018595081, 0.018554986, 0.018514847, 0.018474754, 0.018434742, 0.018394733, 0.01835468, 0.018314714, 0.018274788, 0.018234905, 0.018194981, 0.018155098, 0.018115258, 0.018075503, 0.018035663, 0.017995909, 0.017956197, 0.017916529, 0.017876774, 0.017837148, 0.01779752, 0.01775798, 0.017718395, 0.01767881, 0.017639313, 0.017599814, 0.017560357, 0.017520901, 0.017481487, 0.017442117, 0.017402787, 0.017363418, 0.01732409, 0.017284846, 0.017245602, 0.017206358, 0.017167158, 0.017128, 0.017088842, 0.017049728, 0.017010612, 0.01697154, 0.016932551, 0.016893523, 0.016854491, 0.016815547, 0.016776644, 0.016737742, 0.016698839, 0.016659981, 0.016621163, 0.016582388, 0.016543571, 0.016504839, 0.016466107, 0.016427418, 0.016388729, 0.016350083, 0.016311478, 0.016272917, 0.016234355, 0.016195795, 0.016157275, 0.016118841, 0.016080366, 0.01604189, 0.016003499, 0.015965151, 0.015926803, 0.015888454, 0.015850147, 0.015811928, 0.015773663, 0.015735444, 0.015697222, 0.015659086, 0.015620952, 0.015582817, 0.015544725, 0.015506674, 0.015468709, 0.015430702, 0.015392694, 0.015354729, 0.015316808, 0.015278927, 0.015241005, 0.015203169, 0.015165374, 0.015127622, 0.015089785, 0.015052075, 0.015014366, 0.014976699, 0.014938991, 0.014901366, 0.014863785, 0.014826204, 0.014788622, 0.014751126, 0.01471363, 0.014676177, 0.014638723, 0.014601269, 0.014563859, 0.014526532, 0.014489206, 0.014451838, 0.014414555, 0.014377315, 0.014340117, 0.014302876, 0.014265679, 0.014228566, 0.014191411, 0.014154297, 0.014117228, 0.014080158, 0.014043172, 0.014006145, 0.01396916, 0.013932261, 0.013895361, 0.013858462, 0.013821561, 0.013784748, 0.013747975, 0.013711161, 0.013674389, 0.013637659, 0.013600973, 0.01356433, 0.013527642, 0.013490998, 0.01345444, 0.013417881, 0.01338128, 0.013344764, 0.013308289, 0.013271859, 0.013235386, 0.013198954, 0.013162608, 0.013126263, 0.013089917, 0.013053572, 0.013017312, 0.012981093, 0.012944875, 0.012908615, 0.01287244, 0.012836349, 0.012800218, 0.012764084, 0.012728037, 0.012692032, 0.012656027, 0.01261998, 0.012584017, 0.012548097, 0.012512221, 0.0124763, 0.012440466, 0.012404632, 0.012368883, 0.01233309, 0.012297343, 0.012261635, 0.012225886, 0.012190222, 0.012154601, 0.012119022, 0.012083358, 0.012047822, 0.012012285, 0.011976792, 0.011941342, 0.01190589, 0.011870439, 0.01183503, 0.011799579, 0.011764256, 0.011729019, 0.011693696, 0.011658458, 0.011623135, 0.011587939, 0.011552745, 0.011517593, 0.011482482, 0.011447372, 0.011412304, 0.011377194, 0.011342212, 0.011307186, 0.011272204, 0.011237265, 0.011202283, 0.011167386, 0.011132531, 0.011097677, 0.011062865, 0.011028053, 0.010993327, 0.010958601, 0.010923874, 0.010889232, 0.010854549, 0.010819949, 0.010785351, 0.01075071, 0.010716153, 0.010681682, 0.010647169, 0.010612655, 0.010578184, 0.010543799, 0.010509414, 0.01047507, 0.010440727, 0.010406426, 0.010372126, 0.010337826, 0.01030361, 0.010269437, 0.010235265, 0.010201092, 0.01016692, 0.010132832, 0.010098745, 0.0100647, 0.010030697, 0.0099966954, 0.0099626938, 0.009928776, 0.0098949019, 0.009860985, 0.0098271528, 0.0097933216, 0.0097594466, 0.0097256573, 0.0096919108, 0.0096582072, 0.0096245455, 0.009590799, 0.0095571382, 0.0095235622, 0.0094899433, 0.0094564101, 0.0094228759, 0.0093893418, 0.0093558514, 0.0093223611, 0.0092889545, 0.0092555489, 0.0092221862, 0.0091887377, 0.0091554169, 0.0091221398, 0.0090888618, 0.0090556266, 0.0090223914, 0.0089891991, 0.0089560058, 0.0089228563, 0.0088897906, 0.008856684, 0.0088236192, 0.0087905964, 0.0087575316, 0.0087245526, 0.0086915726, 0.0086586783, 0.0086257411, 0.0085928468, 0.0085599953, 0.0085271858, 0.00849442, 0.0084616533, 0.0084289294, 0.0083962055, 0.0083634388, 0.0083307577, 0.0082981614, 0.0082655642, 0.0082330108, 0.0082003726, 0.008167862, 0.0081353514, 0.0081028827, 0.008070414, 0.0080380309, 0.0080056051, 0.0079732649, 0.0079408819, 0.0079085836, 0.0078762863, 0.0078440309, 0.0078116907, 0.0077794781, 0.0077473079, 0.0077151377, 0.0076830531, 0.0076509258, 0.0076188408, 0.0075867563, 0.0075547565, 0.0075227572, 0.0074907998, 0.0074588428, 0.0074269283, 0.0073949718, 0.0073631001, 0.0073312707, 0.0072994842, 0.0072676549, 0.0072359112, 0.0072041671, 0.0071724658, 0.0071408073, 0.0071091489, 0.0070775324, 0.0070459163, 0.0070142578, 0.0069827694, 0.0069512385, 0.00691975, 0.0068883044, 0.0068567735, 0.0068253707, 0.0067939674, 0.006762607, 0.0067312894, 0.0067000142, 0.0066686962, 0.006637421, 0.006606231, 0.0065749981, 0.006543851, 0.0065127034, 0.0064815134, 0.0064504086, 0.0064193467, 0.0063882843, 0.0063573071, 0.0063262875, 0.0062953108, 0.0062643765, 0.0062334426, 0.0062025925, 0.0061717434, 0.0061408943, 0.006110088, 0.0060792817, 0.0060485173, 0.0060178395, 0.0059871604, 0.0059563965, 0.0059257601, 0.0058951243, 0.0058645308, 0.0058340225, 0.0058034719, 0.0057729632, 0.0057424549, 0.0057119899, 0.0056815664, 0.0056511434, 0.0056207632, 0.0055904677, 0.0055600447, 0.0055297497, 0.0054994542, 0.0054692016, 0.0054390347, 0.005408782, 0.0053786142, 0.0053484896, 0.0053184074, 0.0052882829, 0.0052582431, 0.0052282037, 0.0051981215, 0.0051681674, 0.0051382123, 0.0051083011, 0.0050784317, 0.0050484776, 0.005018651, 0.0049888245, 0.0049590408, 0.0049292566, 0.0048995153, 0.0048698168, 0.0048401179, 0.0048104194, 0.0047808057, 0.0047511924, 0.0047216215, 0.0046920083, 0.0046624797, 0.0046329517, 0.0046035089, 0.0045740656, 0.0045446227, 0.0045152646, 0.0044858218, 0.0044565066, 0.0044271913, 0.0043979189, 0.0043686461, 0.004339416, 0.0043101436, 0.0042809565, 0.0042517688, 0.0042226668, 0.004193522, 0.0041644624, 0.0041354029, 0.0041063856, 0.0040774117, 0.0040484373, 0.0040195058, 0.0039905738, 0.0039615994, 0.0039327531, 0.0039039492, 0.0038751455, 0.0038463839, 0.0038175376, 0.0037888191, 0.0037601001, 0.003731424, 0.0037027907, 0.003674157, 0.0036455665, 0.0036169328, 0.0035884273, 0.0035598793, 0.0035314162, 0.0035029531, 0.0034744474, 0.0034460272, 0.0034176493, 0.0033892714, 0.003360979, 0.0033326012, 0.0033043511, 0.0032760585, 0.0032478513, 0.0032196864, 0.003191479, 0.0031633568, 0.0031352348, 0.00310707, 0.0030789904, 0.0030509534, 0.0030230021, 0.0029949225, 0.0029669707, 0.0029390189, 0.0029111099, 0.0028832434, 0.0028554196, 0.0028275957, 0.002799772, 0.002771948, 0.0027442093, 0.0027165131, 0.0026888172, 0.0026611637, 0.0026334249, 0.0026058143, 0.0025782033, 0.0025506779, 0.0025231522, 0.0024956267, 0.002468101, 0.0024406607, 0.0024132202, 0.0023858224, 0.0023584673, 0.0023311123, 0.0023037144, 0.0022764017, 0.0022491317, 0.0022219045, 0.0021947622, 0.0021674498, 0.0021403076, 0.0021131656, 0.0020860662, 0.0020589666, 0.0020319098, 0.0020048954, 0.0019779236, 0.0019508241, 0.0019239377, 0.0018970086, 0.0018701222, 0.0018431505, 0.0018163066, 0.0017895054, 0.001762704, 0.0017359455, 0.0017092294, 0.0016825134, 0.0016557974, 0.0016291239, 0.0016024931, 0.0015759049, 0.0015493167, 0.0015227711, 0.0014961829, 0.00146968, 0.0014431769, 0.0014167592, 0.0013903414, 0.0013638812, 0.0013375485, 0.0013111734, 0.0012848834, 0.0012585935, 0.0012323462, 0.0012060988, 0.0011798089, 0.0011536467, 0.0011274846, 0.0011014078, 0.0010753309, 0.0010491688, 0.0010230918, 0.00099710014, 0.0009711085, 0.00094511686, 0.00091921043, 0.00089326128, 0.00086739752, 0.00084149104, 0.00081566977, 0.00078984856, 0.0007640699, 0.00073824869, 0.0007125127, 0.00068681926, 0.00066112587, 0.00063547504, 0.00060986687, 0.00058421609, 0.00055865053, 0.00053312758, 0.00050760456, 0.00048212422, 0.00045664384, 0.00043124871, 0.00040572573, 0.0003803306, 0.00035497808, 0.00032971078, 0.00030431562, 0.00027904831, 0.00025378098, 0.00022855628, 0.00020337419, 0.0001782347, 0.00015305261, 0.00012795573, 0.00010277362, 7.7719364e-05, 5.2707699e-05, 2.7696044e-05, 2.726995e-06, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386, 0.015146386   }, 
   { 0.011242852, 0.011215086, 0.011187441, 0.011159855, 0.011132208, 0.011104622, 0.011077156, 0.011049571, 0.011022224, 0.0109947, 0.010967353, 0.010940127, 0.010912721, 0.010885555, 0.010858389, 0.010831162, 0.010804117, 0.010777012, 0.010749904, 0.010722979, 0.010695992, 0.010669006, 0.01064214, 0.010615334, 0.010588407, 0.010561661, 0.010534976, 0.010508168, 0.010481603, 0.010454916, 0.010428349, 0.010401843, 0.010375217, 0.010348829, 0.010322444, 0.010295997, 0.010269672, 0.010243405, 0.010217078, 0.010190872, 0.010164725, 0.010138459, 0.010112492, 0.010086465, 0.010060319, 0.010034352, 0.010008445, 0.0099824788, 0.0099566318, 0.0099308444, 0.0099049378, 0.009879211, 0.0098535446, 0.0098278178, 0.0098022111, 0.0097764833, 0.0097509976, 0.0097255101, 0.0096999034, 0.0096745361, 0.0096491696, 0.0096237427, 0.0095984349, 0.0095731886, 0.0095478212, 0.0095226346, 0.0094975671, 0.0094723804, 0.0094473734, 0.0094222464, 0.0093972385, 0.0093722912, 0.0093474044, 0.0093223965, 0.0092976298, 0.0092726825, 0.0092479745, 0.0092232684, 0.0091985008, 0.0091738533, 0.0091492655, 0.009124619, 0.0091000916, 0.009075623, 0.0090510966, 0.0090266885, 0.009002341, 0.0089779338, 0.0089536458, 0.0089294184, 0.0089050708, 0.0088809635, 0.0088567957, 0.0088326279, 0.0088086408, 0.0087846527, 0.008760605, 0.0087366775, 0.0087126894, 0.008688882, 0.0086650141, 0.0086411471, 0.0086174589, 0.0085937707, 0.0085700229, 0.0085463952, 0.0085228272, 0.0084991399, 0.0084756911, 0.0084522432, 0.0084286761, 0.0084053474, 0.0083820196, 0.0083585717, 0.0083353631, 0.0083120959, 0.0082888277, 0.0082656788, 0.0082425913, 0.0082194433, 0.0081964144, 0.008173327, 0.0081504183, 0.0081275702, 0.0081045423, 0.0080817537, 0.0080589652, 0.0080360565, 0.0080133881, 0.0079907198, 0.0079679918, 0.007945383, 0.0079228356, 0.0079002269, 0.0078777382, 0.0078553101, 0.0078328215, 0.0078104525, 0.0077881441, 0.0077657159, 0.0077435272, 0.0077213384, 0.00769903, 0.0076769008, 0.007654713, 0.007632704, 0.0076106954, 0.0075885663, 0.0075666779, 0.0075448491, 0.0075229001, 0.0075011314, 0.0074793026, 0.0074574738, 0.0074357651, 0.0074141761, 0.0073924069, 0.007370878, 0.0073493491, 0.0073277, 0.0073062917, 0.0072848825, 0.0072633531, 0.0072420044, 0.0072207153, 0.0071993661, 0.0071781371, 0.007156848, 0.007135679, 0.0071145697, 0.0070934002, 0.0070724115, 0.0070514223, 0.007030373, 0.0070094438, 0.0069885748, 0.0069676451, 0.0069469558, 0.0069262064, 0.0069053373, 0.0068847076, 0.0068640783, 0.0068433289, 0.0068228194, 0.0068023098, 0.0067816805, 0.0067612911, 0.0067408415, 0.006720392, 0.0067000627, 0.0066796727, 0.006659463, 0.0066392533, 0.006618984, 0.0065988339, 0.0065787449, 0.0065585952, 0.0065386253, 0.0065186555, 0.0064985659, 0.0064787162, 0.0064588664, 0.0064389561, 0.0064191665, 0.0063994969, 0.0063797068, 0.0063600368, 0.0063404269, 0.0063207569, 0.006301207, 0.0062815975, 0.0062621669, 0.0062427367, 0.0062232469, 0.0062038768, 0.0061846268, 0.0061652567, 0.0061460063, 0.0061268164, 0.0061075664, 0.0060884361, 0.006069426, 0.0060502361, 0.0060312855, 0.0060123354, 0.0059933248, 0.0059744343, 0.0059556044, 0.0059367139, 0.0059180036, 0.0058992933, 0.0058805225, 0.0058618723, 0.0058431621, 0.0058246315, 0.0058061015, 0.0057875109, 0.0057691, 0.0057506897, 0.0057322192, 0.005713868, 0.0056956373, 0.0056772274, 0.0056590564, 0.0056408858, 0.0056226552, 0.0056045442, 0.0055864938, 0.0055683833, 0.0055503924, 0.0055324612, 0.0055144709, 0.0054966002, 0.0054788492, 0.0054609179, 0.0054432275, 0.0054254164, 0.0054077855, 0.0053902147, 0.0053725233, 0.0053549525, 0.0053375019, 0.0053198705, 0.0053024795, 0.0052850884, 0.0052676373, 0.0052503659, 0.0052330955, 0.005215764, 0.0051985527, 0.0051814015, 0.0051641902, 0.005147099, 0.0051300679, 0.0051129768, 0.0050960057, 0.0050790943, 0.0050621228, 0.0050453315, 0.0050283605, 0.0050116284, 0.0049948972, 0.0049781059, 0.0049614944, 0.0049449434, 0.0049282713, 0.0049117804, 0.0048952885, 0.004878737, 0.0048623052, 0.0048459936, 0.0048295022, 0.0048132506, 0.004796999, 0.0047806874, 0.0047645555, 0.004748364, 0.004732172, 0.0047161602, 0.0047001489, 0.0046840766, 0.004668125, 0.0046521132, 0.0046362816, 0.0046204496, 0.0046045575, 0.0045887856, 0.0045731338, 0.0045573618, 0.00454171, 0.0045261779, 0.0045105256, 0.0044950536, 0.004479582, 0.0044640498, 0.0044486974, 0.0044333455, 0.0044179335, 0.0044026412, 0.004387409, 0.0043721166, 0.0043569445, 0.0043417122, 0.0043266602, 0.0043116678, 0.0042965556, 0.0042815632, 0.0042666909, 0.0042516985, 0.0042368262, 0.0042220741, 0.0042071412, 0.0041924487, 0.0041778167, 0.004163004, 0.0041484316, 0.0041338592, 0.0041192267, 0.004104774, 0.0040903813, 0.0040758685, 0.0040614763, 0.0040471433, 0.0040327511, 0.0040185382, 0.0040042056, 0.0039899931, 0.0039758999, 0.0039616874, 0.0039476547, 0.0039336216, 0.0039195293, 0.003905616, 0.0038917034, 0.0038777306, 0.0038639375, 0.0038501446, 0.0038362918, 0.0038225588, 0.0038088858, 0.0037952128, 0.0037815997, 0.0037680466, 0.0037544337, 0.0037410606, 0.0037276275, 0.0037141345, 0.0037007614, 0.003687328, 0.003674075, 0.0036608817, 0.0036475086, 0.0036343753, 0.0036213021, 0.0036081087, 0.0035950355, 0.003582082, 0.003569009, 0.0035560555, 0.0035432221, 0.0035302686, 0.0035174354, 0.0035046618, 0.0034918285, 0.003479175, 0.0034665214, 0.0034538079, 0.0034412143, 0.0034287409, 0.0034160872, 0.0034036739, 0.0033912, 0.0033788464, 0.0033665528, 0.0033541392, 0.0033418455, 0.0033296717, 0.003317378, 0.0033052641, 0.0032931503, 0.0032809766, 0.0032689229, 0.0032569889, 0.0032449351, 0.0032330013, 0.0032211873, 0.0032092535, 0.0031974395, 0.0031856855, 0.0031738717, 0.0031622373, 0.0031506035, 0.0031389096, 0.0031273356, 0.0031157616, 0.0031042474, 0.0030928534, 0.0030813392, 0.0030700648, 0.0030587306, 0.0030473366, 0.0030361223, 0.003024908, 0.0030136339, 0.0030025395, 0.0029915052, 0.0029802909, 0.0029693164, 0.0029583422, 0.0029473079, 0.0029364536, 0.002925599, 0.0029146846, 0.0029039502, 0.0028932155, 0.0028824212, 0.0028717467, 0.0028610122, 0.0028504573, 0.002839963, 0.0028293482, 0.0028189139, 0.0028084791, 0.0027979843, 0.0027876697, 0.002777355, 0.0027670402, 0.0027568457, 0.0027466509, 0.002736456, 0.0027263211, 0.0027162463, 0.0027061715, 0.0026961567, 0.0026862018, 0.0026761869, 0.0026663521, 0.0026563969, 0.002646622, 0.0026369072, 0.0026270719, 0.0026174171, 0.0026077621, 0.002598047, 0.0025885119, 0.0025790369, 0.0025694417, 0.0025599666, 0.0025506115, 0.0025411362, 0.0025318409, 0.0025225459, 0.0025131907, 0.0025040754, 0.0024948998, 0.0024856648, 0.0024766093, 0.0024675538, 0.0024584387, 0.0024495032, 0.0024404479, 0.0024315724, 0.0024226969, 0.0024137616, 0.002405006, 0.0023963104, 0.0023874952, 0.0023788596, 0.0023702239, 0.0023615283, 0.0023530128, 0.0023445571, 0.0023359815, 0.0023275258, 0.0023191902, 0.0023107345, 0.0023024587, 0.0022941828, 0.0022858472, 0.0022776914, 0.0022695356, 0.0022613797, 0.002253344, 0.002245188, 0.0022372121, 0.0022292961, 0.0022212602, 0.0022134045, 0.0022055483, 0.0021976326, 0.0021898963, 0.0021822203, 0.0021744242, 0.0021667483, 0.0021591922, 0.002151516, 0.0021440201, 0.0021365238, 0.0021289678, 0.0021215915, 0.0021142152, 0.002106779, 0.0020995229, 0.0020922665, 0.0020849502, 0.002077814, 0.0020706176, 0.0020635412, 0.0020565249, 0.0020493884, 0.0020424321, 0.0020355356, 0.0020285193, 0.0020216827, 0.0020148463, 0.0020079499, 0.0020012334, 0.0019945768, 0.0019878002, 0.0019812037, 0.0019746069, 0.0019679503, 0.0019614736, 0.001954997, 0.0019484602, 0.0019421036, 0.0019357469, 0.0019293301, 0.0019230933, 0.0019167366, 0.0019105598, 0.0019044429, 0.0018982062, 0.0018922092, 0.0018862123, 0.0018800955, 0.0018741584, 0.0018682214, 0.0018622245, 0.0018564076, 0.0018506505, 0.0018447734, 0.0018390764, 0.0018333794, 0.0018276223, 0.0018220452, 0.0018164681, 0.001810891, 0.0018053737, 0.0017998567, 0.0017944593, 0.0017890622, 0.0017836648, 0.0017783876, 0.0017731102, 0.0017677729, 0.0017626156, 0.0017575183, 0.0017523009, 0.0017472636, 0.0017423461, 0.0017372487, 0.0017323312, 0.0017274136, 0.0017224962, 0.0017176388, 0.0017129012, 0.0017080436, 0.0017033661, 0.0016986884, 0.001693951, 0.0016893933, 0.0016847156, 0.0016802179, 0.0016757802, 0.0016712225, 0.0016668448, 0.001662527, 0.0016580892, 0.0016538315, 0.0016496336, 0.0016453159, 0.0016411779, 0.0016371001, 0.0016329022, 0.0016288843, 0.0016248664, 0.0016208484, 0.0016169505, 0.0016131124, 0.0016091543, 0.0016053764, 0.0016015983, 0.0015977602, 0.0015941021, 0.001590324, 0.0015867858, 0.0015831877, 0.0015795896, 0.0015761113, 0.0015726332, 0.0015691549, 0.0015657967, 0.0015624384, 0.0015590801, 0.0015557818, 0.0015526034, 0.0015493052, 0.0015461867, 0.0015431283, 0.0015399498, 0.0015369514, 0.001533953, 0.0015308945, 0.0015280161, 0.0015252574, 0.0015223189, 0.0015195603, 0.0015166817, 0.0015139832, 0.0015113446, 0.0015085861, 0.0015060673, 0.0015034886, 0.00150085, 0.0014983913, 0.0014959924, 0.0014934738, 0.001491135, 0.001488856, 0.0014864574, 0.0014842385, 0.0014820795, 0.0014798008, 0.0014777018, 0.0014756029, 0.001473444, 0.0014714651, 0.0014695461, 0.001467507, 0.001465708, 0.001463729, 0.00146187, 0.0014601909, 0.0014583917, 0.0014566527, 0.0014550334, 0.0014532944, 0.0014517951, 0.001450236, 0.0014486767, 0.0014472374, 0.0014457982, 0.001444299, 0.0014429797, 0.0014417204, 0.001440341, 0.0014391416, 0.0014380022, 0.0014367428, 0.0014356634, 0.0014345839, 0.0014334446, 0.0014324851, 0.0014314655, 0.001430566, 0.0014296664, 0.0014288269, 0.0014280473, 0.0014273276, 0.0014264882, 0.0014258286, 0.0014252287, 0.0014245091, 0.0014239694, 0.0014234897, 0.0014228899, 0.0014224702, 0.0014221104, 0.0014216306, 0.0014213307, 0.001421031, 0.0014207311, 0.0014204913, 0.0014202513, 0.0014201313, 0.0014200715, 0.0014198915, 0.0014199514, 0.0014199514, 0.0014199514, 0.0014200715, 0.0014202513, 0.0014203113, 0.0014205511, 0.0014209109, 0.0014210909, 0.0014214506, 0.0014218704, 0.0014221703, 0.0014226501, 0.0014231898, 0.0014236097, 0.0014242092, 0.0014248689, 0.0014254086, 0.0014261282, 0.001426848, 0.0014275076, 0.0014283471, 0.0014291267, 0.0014300263, 0.0014309858, 0.0014318255, 0.0014328449, 0.0014339242, 0.0014349439, 0.0014360232, 0.0014372226, 0.0014383619, 0.0014396214, 0.0014408807, 0.0014422, 0.0014435793, 0.0014450186, 0.0014463379, 0.0014478372, 0.0014493364, 0.0014508356, 0.0014524548, 0.0014539539, 0.0014556332, 0.0014573722, 0.0014590514, 0.0014608505, 0.0014627095, 0.0014644486, 0.0014663676, 0.0014683467, 0.0014702057, 0.0014722446, 0.0014743436, 0.0014763825, 0.0014785413, 0.0014807003, 0.0014828591, 0.0014851381, 0.0014874168, 0.0014896957, 0.0014920944, 0.0014945532, 0.0014969519, 0.0014994107, 0.0015018694, 0.0015044481, 0.0015070868, 0.0015096654, 0.0015123641, 0.0015151226, 0.0015177613, 0.0015205798, 0.0015234583, 0.0015262769, 0.0015292154, 0.0015322139, 0.0015350925, 0.0015381508, 0.0015412691, 0.0015442676, 0.0015474461, 0.0015506845, 0.0015538028, 0.0015571011, 0.0015604594, 0.0015636977, 0.001567116, 0.0015704742, 0.0015740125, 0.0015775505, 0.0015809688, 0.001584627, 0.0015882251, 0.0015918233, 0.0015955414, 0.0015993194, 0.0016029775, 0.0016068756, 0.0016107135, 0.0016145516, 0.0016185096, 0.0016225276, 0.0016264255, 0.0016305035, 0.0016346414, 0.0016386593, 0.0016428571, 0.0016469951, 0.0016512529, 0.0016555706, 0.0016597684, 0.0016642062, 0.0016686439, 0.0016730217, 0.0016775792, 0.001682077, 0.0016865747, 0.0016911923, 0.00169587, 0.0017004875, 0.0017052251, 0.0017099627, 0.0017147003, 0.0017195578, 0.0017244752, 0.0017292728, 0.0017342502, 0.0017392876, 0.001744205, 0.0017493025, 0.0017544599, 0.0017594973, 0.0017647146, 0.0017698719, 0.0017751491, 0.0017804864, 0.0017857638, 0.001791161, 0.0017966181, 0.0018019554, 0.0018075926, 0.0018131697, 0.0018186269, 0.0018242641, 0.0018299611, 0.0018355983, 0.0018413553, 0.0018471723, 0.0018528694, 0.0018587464, 0.0018646832, 0.0018705004, 0.0018764972, 0.0018824342, 0.0018884911, 0.0018946079, 0.0019006649, 0.0019068416, 0.0019130785, 0.0019192554, 0.001925552, 0.0019319088, 0.0019381456, 0.0019446223, 0.0019510989, 0.0019575157, 0.0019640522, 0.001970649, 0.0019771256, 0.0019837823, 0.0019904987, 0.0019970953, 0.0020039319, 0.0020107084, 0.002017485, 0.0020243814, 0.0020312178, 0.0020381743, 0.0020451907, 0.0020521472, 0.0020592236, 0.0020663599, 0.0020734363, 0.0020806324, 0.0020878888, 0.0020950851, 0.0021024013, 0.0021097774, 0.0021170939, 0.00212453, 0.002132026, 0.0021394624, 0.0021470184, 0.0021546346, 0.0021621308, 0.0021698067, 0.0021775428, 0.0021851589, 0.002192955, 0.0022006908, 0.0022086068, 0.0022165228, 0.0022243189, 0.0022323546, 0.0022403905, 0.0022483664, 0.0022564624, 0.0022646182, 0.0022727139, 0.0022809298, 0.0022892056, 0.0022973614, 0.0023057568, 0.0023140928, 0.0023224284, 0.0023309442, 0.0023394597, 0.0023478556, 0.002356431, 0.0023650667, 0.0023735822, 0.0023822777, 0.0023909132, 0.0023997289, 0.0024085441, 0.0024172396, 0.0024261754, 0.0024351107, 0.0024439862, 0.0024529814, 0.0024620369, 0.0024710321, 0.0024801474, 0.0024893228, 0.0024984381, 0.0025076733, 0.0025169686, 0.002526144, 0.002535559, 0.0025449141, 0.0025542695, 0.0025637448, 0.0025732799, 0.0025827547, 0.0025923499, 0.002601885, 0.0026115403, 0.0026212551, 0.0026309104, 0.0026406853, 0.0026505201, 0.0026602952, 0.0026701901, 0.002680145, 0.0026900398, 0.0027001149, 0.0027101894, 0.0027201446, 0.0027303391, 0.0027405338, 0.0027506088, 0.0027608636, 0.0027711783, 0.0027814328, 0.0027918078, 0.0028022423, 0.0028125569, 0.0028230515, 0.0028334863, 0.0028441008, 0.0028547153, 0.00286527, 0.0028759446, 0.002886679, 0.0028973534, 0.0029081481, 0.0029190022, 0.0029297969, 0.0029407113, 0.0029516856, 0.0029626, 0.0029736343, 0.0029847885, 0.002995763, 0.0030069773, 0.0030181315, 0.0030292857, 0.0030405601, 0.0030517741, 0.0030631684, 0.0030745624, 0.0030858368, 0.0030973509, 0.0031088651, 0.003120319, 0.0031319531, 0.0031435871, 0.0031551614, 0.0031668551, 0.0031786091, 0.0031903032, 0.0032021173, 0.0032139909, 0.003225805, 0.003237739, 0.0032497328, 0.0032616067, 0.0032737204, 0.0032858341, 0.0032978281, 0.0033100618, 0.0033221755, 0.0033344091, 0.0033467028, 0.0033589364, 0.0033713502, 0.0033837638, 0.0033961176, 0.0034085913, 0.0034211248, 0.0034335984, 0.003446192, 0.0034589055, 0.0034714988, 0.0034842123, 0.0034969859, 0.0035096994, 0.0035225328, 0.0035354262, 0.0035481995, 0.0035612129, 0.0035742263, 0.0035871195, 0.003600193, 0.0036132061, 0.0036263992, 0.0036395928, 0.0036527261, 0.0036660391, 0.0036793521, 0.0036926055, 0.0037059786, 0.0037194116, 0.0037327849, 0.003746338, 0.0037598908, 0.0037733242, 0.0037869969, 0.0038006702, 0.0038142232, 0.0038280161, 0.003841809, 0.0038555418, 0.0038693948, 0.0038831879, 0.0038971605, 0.0039111334, 0.0039250464, 0.0039390791, 0.0039532315, 0.0039672642, 0.003981417, 0.00399569, 0.0040098429, 0.0040241154, 0.004038448, 0.0040527205, 0.0040671132, 0.0040815659, 0.0040959585, 0.004110531, 0.0041251038, 0.0041395561, 0.0041542486, 0.0041689412, 0.0041835136, 0.0041983263, 0.0042131385, 0.0042278911, 0.0042427634, 0.0042575756, 0.0042725676, 0.0042875605, 0.0043024924, 0.0043175449, 0.004332657, 0.0043477095, 0.0043629417, 0.0043781735, 0.0043933457, 0.0044086981, 0.00442405, 0.0044392822, 0.0044547543, 0.0044702264, 0.0044856383, 0.0045011705, 0.0045167627, 0.0045322948, 0.0045479471, 0.0045635388, 0.0045793103, 0.0045950823, 0.0046107946, 0.0046266862, 0.0046425778, 0.0046584099, 0.0046744216, 0.0046904339, 0.0047063855, 0.0047224574, 0.0047385884, 0.0047546607, 0.0047709122, 0.0047871643, 0.0048033558, 0.0048196674, 0.0048360992, 0.0048523508, 0.0048688417, 0.0048853336, 0.0049017053, 0.0049183168, 0.0049348078, 0.0049514193, 0.004968151, 0.0049847625, 0.0050014937, 0.0050183455, 0.0050350768, 0.0050519882, 0.0050688395, 0.0050857505, 0.005102722, 0.0051197531, 0.0051367246, 0.0051538758, 0.005171027, 0.0051881182, 0.0052053295, 0.0052226009, 0.0052398117, 0.0052571427, 0.0052745338, 0.0052919248, 0.0053093759, 0.005326767, 0.0053443378, 0.005361909, 0.0053794198, 0.0053971112, 0.0054148021, 0.005432433, 0.0054501835, 0.0054680547, 0.0054858052, 0.0055036764, 0.0055216672, 0.0055395379, 0.0055575287, 0.0055755796, 0.0055935699, 0.0056117405, 0.0056299116, 0.0056480221, 0.0056662527, 0.0056844237, 0.005702774, 0.0057211244, 0.0057394155, 0.0057578855, 0.0057763564, 0.0057948269, 0.005813357, 0.0058320081, 0.0058505381, 0.0058691883, 0.0058879592, 0.0059065497, 0.0059253797, 0.0059442106, 0.0059629804, 0.005981931, 0.0060008811, 0.0060197711, 0.0060388418, 0.006057912, 0.0060769222, 0.0060960525, 0.0061152424, 0.0061343727, 0.0061536226, 0.006172813, 0.0061921827, 0.0062115528, 0.0062308633, 0.0062504131, 0.0062698429, 0.006289273, 0.006308943, 0.0063285534, 0.0063481033, 0.0063677728, 0.0063875625, 0.0064071729, 0.0064270226, 0.0064468724, 0.006466662, 0.0064866319, 0.0065066013, 0.0065264511, 0.0065465411, 0.0065665711, 0.0065866606, 0.0066068703, 0.0066269599, 0.0066472297, 0.006667499, 0.0066877087, 0.0067080981, 0.006728488, 0.0067488174, 0.006769327, 0.0067898361, 0.0068102861, 0.0068309153, 0.0068515446, 0.0068721143, 0.0068928637, 0.0069136126, 0.0069343019, 0.0069551119, 0.0069760405, 0.0069967904, 0.0070177796, 0.0070386487, 0.007059698, 0.0070807468, 0.0071017365, 0.0071229655, 0.0071441345, 0.0071652438, 0.007186533, 0.0072078216, 0.0072290511, 0.0072504603, 0.0072718686, 0.0072932178, 0.0073147467, 0.0073362761, 0.007357745, 0.0073793936, 0.0074010431, 0.0074226316, 0.0074444008, 0.0074661695, 0.0074878782, 0.007509707, 0.0075314757, 0.0075534247, 0.0075754332, 0.0075973221, 0.0076193307, 0.0076414593, 0.0076634679, 0.0076856567, 0.0077079055, 0.0077300342, 0.0077522825, 0.0077746511, 0.0077968999, 0.0078192679, 0.007841697, 0.0078640655, 0.0078866137, 0.007909162, 0.0079316506, 0.007954319, 0.0079769874, 0.0079995953, 0.0080223838, 0.0080450522, 0.0080679003, 0.0080907494, 0.008113537, 0.0081365053, 0.0081595341, 0.0081824418, 0.0082054697, 0.0082286177, 0.0082516465, 0.0082748551, 0.0082981223, 0.0083212703, 0.0083445385, 0.0083678663, 0.0083911344, 0.0084145833, 0.0084380312, 0.0084614186, 0.0084849866, 0.0085085547, 0.0085320622, 0.0085556898, 0.0085793184, 0.0086030662, 0.0086268736, 0.0086505618, 0.0086743692, 0.0086982977, 0.0087221051, 0.0087460931, 0.0087700803, 0.0087940078, 0.008818116, 0.0088422233, 0.008866271, 0.0088904984, 0.0089147259, 0.0089389542, 0.0089633018, 0.0089876484, 0.0090119364, 0.0090363435, 0.0090608709, 0.009085279, 0.0091098063, 0.009134274, 0.0091589205, 0.0091836285, 0.0092082154, 0.009232983, 0.0092577497, 0.0092825172, 0.009307405, 0.0093322927, 0.009357119, 0.0093821259, 0.0094071338, 0.0094320811, 0.0094572082, 0.0094823353, 0.0095074018, 0.0095326491, 0.0095578963, 0.009583083, 0.0096084503, 0.0096337572, 0.0096591841, 0.0096846111, 0.0097099775, 0.0097355256, 0.0097611314, 0.0097866189, 0.0098122861, 0.0098379524, 0.0098635592, 0.0098893465, 0.0099151935, 0.0099409204, 0.009966827, 0.0099927336, 0.01001864, 0.010044606, 0.010070693, 0.01009666, 0.010122746, 0.010148954, 0.01017504, 0.010201246, 0.010227453, 0.010253779, 0.010280106, 0.010306432, 0.010332879, 0.010359325, 0.010385771, 0.010412278, 0.010438904, 0.01046541, 0.010492098, 0.010518784, 0.010545409, 0.010572216, 0.010599082, 0.010625828, 0.010652754, 0.01067968, 0.010706548, 0.010733593, 0.010760639, 0.010787626, 0.010814792, 0.010841838, 0.010869063, 0.010896349, 0.010923516, 0.010950861, 0.010978268, 0.011005553, 0.011033019, 0.011060545, 0.011087951, 0.011115537, 0.011143123, 0.011170649, 0.011198354, 0.011226119, 0.011253767, 0.011281592, 0.011309417, 0.011337183, 0.011365129, 0.011393134, 0.01142102, 0.011449026, 0.011477031, 0.011505157, 0.011533223, 0.011561409, 0.011589654, 0.0116179, 0.011646084, 0.011674509, 0.011702877, 0.011731242, 0.011759667, 0.011788152, 0.011816697, 0.011845242, 0.011873788, 0.011902393, 0.011931058, 0.011959844, 0.01198857, 0.012017295, 0.01204626, 0.012075105, 0.01210389, 0.012132855, 0.01216194, 0.012190966, 0.01221999, 0.012249136, 0.01227828, 0.012307425, 0.012336631, 0.012365895, 0.012395221, 0.012424545, 0.01245387, 0.012483256, 0.0125127, 0.012542265, 0.01257177, 0.012601335, 0.012631079, 0.012660705, 0.012690268, 0.012720014, 0.012749879, 0.012779683, 0.012809488, 0.012839412, 0.012869338, 0.012899262, 0.012929247, 0.012959291, 0.012989395, 0.0130195, 0.013049664, 0.01307983, 0.013110054, 0.013140398, 0.013170683, 0.013201026, 0.013231491, 0.013261896, 0.0132923, 0.013322944, 0.013353469, 0.013384053, 0.013414638, 0.013445341, 0.013476046, 0.01350681, 0.013537574, 0.013568338, 0.013599283, 0.013630167, 0.013661051, 0.013691785, 0.01372234, 0.013752864, 0.013783359, 0.013814002, 0.013844677, 0.013875381, 0.013906115, 0.013936879, 0.013967674, 0.013998527, 0.014029411, 0.014060356, 0.0140913, 0.014122334, 0.014153369, 0.014184463, 0.014215617, 0.014246861, 0.014278045, 0.014309259, 0.014340593, 0.014371926, 0.01440329, 0.014434773, 0.014466198, 0.014497742, 0.014529165, 0.014560799, 0.014592403, 0.014624097, 0.014655761, 0.014687484, 0.014719298, 0.014751112, 0.014782956, 0.014814858, 0.014846763, 0.014878755, 0.014910779, 0.014942834, 0.014975008, 0.015007121, 0.015039233, 0.015071527, 0.015103792, 0.015136085, 0.015168408, 0.015200792, 0.015233204, 0.015265647, 0.015298151, 0.015330714, 0.015363337, 0.01539587, 0.015428554, 0.015461237, 0.01549404, 0.015526844, 0.015559646, 0.01559251, 0.015625404, 0.015658356, 0.01569134, 0.015724411, 0.015757484, 0.015790589, 0.01582372, 0.015856825, 0.015890136, 0.01592339, 0.015956704, 0.015990077, 0.01602345, 0.016056851, 0.016090315, 0.016123837, 0.016157359, 0.016190972, 0.016224615, 0.016258258, 0.016291961, 0.016325723, 0.016359517, 0.016393308, 0.016427223, 0.016461134, 0.016495077, 0.01652905, 0.016563082, 0.016597144, 0.016631266, 0.01666542, 0.016699601, 0.016733874, 0.016768176, 0.016802419, 0.016836751, 0.016871145, 0.016905656, 0.016940109, 0.016974621, 0.017009193, 0.017043736, 0.017078398, 0.01711309, 0.017147781, 0.017182535, 0.017217377, 0.017252188, 0.017287031, 0.017321963, 0.017356955, 0.017391948, 0.01742694, 0.017462051, 0.017497163, 0.017532336, 0.017567538, 0.017602738, 0.017638, 0.017673321, 0.017708704, 0.017744087, 0.017779497, 0.017814999, 0.017850531, 0.017886093, 0.017921714, 0.017957337, 0.017992958, 0.018028701, 0.018064471, 0.018100273, 0.018136105, 0.018172026, 0.018207949, 0.01824387, 0.018279912, 0.018315922, 0.018352054, 0.018388186, 0.018424347, 0.01846057, 0.018496729, 0.01853304, 0.018569384, 0.018605722, 0.018642155, 0.018678617, 0.018715046, 0.018751599, 0.018788179, 0.018824762, 0.018861404, 0.018898072, 0.018934837, 0.018971566, 0.019008419, 0.019045237, 0.019082092, 0.01911903, 0.019156002, 0.019193033, 0.019230094, 0.019267155, 0.019304274, 0.019341428, 0.01937867, 0.019415939, 0.019453239, 0.0194906, 0.019527901, 0.019565294, 0.019602772, 0.019640282, 0.019677794, 0.019715367, 0.019752996, 0.019790627, 0.019828316, 0.019866068, 0.019903848, 0.01994166, 0.019979529, 0.020017369, 0.0200553, 0.02009332, 0.020131342, 0.020169364, 0.02020744, 0.020245584, 0.020283753, 0.020321952, 0.020360244, 0.020398503, 0.020436825, 0.020475235, 0.020513646, 0.020552086, 0.020590587, 0.020629117, 0.020667706, 0.020706298, 0.020744978, 0.020783687, 0.020822367, 0.020861197, 0.020899998, 0.020938858, 0.020977776, 0.021016726, 0.021055706, 0.021094657, 0.021133728, 0.021172827, 0.021211985, 0.021251176, 0.021290425, 0.021329679, 0.021368956, 0.021408297, 0.021447696, 0.021487124, 0.021526584, 0.021566076, 0.021605564, 0.021645205, 0.021684814, 0.021724483, 0.021764183, 0.021803882, 0.021843703, 0.021883523, 0.0219234, 0.021963311, 0.022003191, 0.022043189, 0.022083219, 0.022123309, 0.022163428, 0.022203518, 0.022243727, 0.022283966, 0.022324206, 0.022364536, 0.022404926, 0.022445314, 0.022485673, 0.022526152, 0.022566661, 0.02260723, 0.0226478, 0.02268846, 0.022729117, 0.022769807, 0.022810526, 0.022851333, 0.022892145, 0.022933044, 0.022973973, 0.023014901, 0.023055889, 0.02309694, 0.02313802, 0.023179069, 0.023220237, 0.023261435, 0.023302663, 0.023343924, 0.023385271, 0.023426618, 0.023467971, 0.023509439, 0.023550909, 0.023592405, 0.023633992, 0.023675583, 0.023717171, 0.023758851, 0.023800587, 0.023842327, 0.023884095, 0.023925953, 0.023967842, 0.024009762, 0.024051711, 0.024093719, 0.024135727, 0.024177797, 0.024219954, 0.024262082, 0.024304241, 0.024346521, 0.024388766, 0.024431106, 0.024473472, 0.024515873, 0.0245583, 0.024600757, 0.024643306, 0.024685854, 0.024728434, 0.02477107, 0.024813769, 0.024856498, 0.024899285, 0.024942013, 0.024984861, 0.025027769, 0.025070678, 0.025113646, 0.025156641, 0.025199672, 0.025242759, 0.025285877, 0.025329057, 0.025372263, 0.025415502, 0.025458796, 0.025502065, 0.025545424, 0.025588842, 0.025632288, 0.025675798, 0.025719304, 0.025762903, 0.02580647, 0.025850099, 0.025893813, 0.025937533, 0.025981311, 0.026025118, 0.026068985, 0.026112821, 0.026156718, 0.026200738, 0.026244726, 0.026288772, 0.026332879, 0.026377015, 0.026421156, 0.026465351, 0.026509609, 0.026553895, 0.026598213, 0.026642621, 0.026686996, 0.026731435, 0.026775932, 0.026820488, 0.026865019, 0.026909666, 0.02695431, 0.026998987, 0.027043724, 0.027088491, 0.027133288, 0.027178118, 0.027223064, 0.02726795, 0.027312957, 0.027357934, 0.027402971, 0.027448095, 0.027493224, 0.027538382, 0.027583627, 0.027628815, 0.027674181, 0.027719518, 0.027764855, 0.027810281, 0.027855737, 0.027901225, 0.02794674, 0.027992347, 0.028037924, 0.028083561, 0.028129289, 0.028175043, 0.028220801, 0.028266678, 0.028312463, 0.02835837, 0.028404336, 0.028450303, 0.028496299, 0.028542385, 0.02858844, 0.028634589, 0.028680766, 0.028727001, 0.028773237, 0.028819565, 0.028865919, 0.028912278, 0.028958693, 0.029005168, 0.029051675, 0.029098181, 0.029144777, 0.029191403, 0.029238058, 0.029284745, 0.029331522, 0.029378269, 0.029425101, 0.029471999, 0.029518895, 0.029565791, 0.029612776, 0.029659823, 0.029706867, 0.029753944, 0.02980114, 0.029848335, 0.029895503, 0.029942786, 0.029990075, 0.03003742, 0.030084854, 0.03013226, 0.030179726, 0.030227192, 0.030274775, 0.030322332, 0.030369978, 0.030417655, 0.030465359, 0.030513093, 0.030560888, 0.030608684, 0.030656571, 0.030704517, 0.030752432, 0.030800406, 0.030848444, 0.030896507, 0.030944604, 0.030992758, 0.031040974, 0.03108919, 0.031137465, 0.03118577, 0.031234104, 0.03128247, 0.031330924, 0.031379439, 0.031427927, 0.031476472, 0.031525046, 0.031573679, 0.031622376, 0.031671099, 0.031719826, 0.031768609, 0.031817485, 0.031866301, 0.031915203, 0.031964172, 0.032013223, 0.032062251, 0.032111276, 0.03216042, 0.032209534, 0.032258742, 0.032308005, 0.032357268, 0.032406595, 0.032455917, 0.032505363, 0.032554746, 0.032604251, 0.032653786, 0.032703321, 0.032752912, 0.032802571, 0.032852255, 0.032901939, 0.032951687, 0.03300152, 0.033051353, 0.033101216, 0.033151142, 0.033201095, 0.033251081, 0.033301122, 0.033351198, 0.033401333, 0.033451498, 0.033501692, 0.033551976, 0.0336022, 0.033652544, 0.033702888, 0.033753261, 0.033803727, 0.03385425, 0.033904742, 0.033955298, 0.034005884, 0.034056555, 0.034107201, 0.034157965, 0.03420873, 0.034259524, 0.034310348, 0.034361232, 0.034412175, 0.034463149, 0.034514152, 0.034565184, 0.03461631, 0.034667373, 0.034718528, 0.03476974, 0.034821015, 0.034872316, 0.034923621, 0.034974985, 0.035026379, 0.035077803, 0.035129316, 0.035180889, 0.035232436, 0.035284005, 0.035335671, 0.035387333, 0.035439085, 0.035490841, 0.035542686, 0.035594527, 0.035646461, 0.035698336, 0.0357503, 0.035802264, 0.035854373, 0.035906456, 0.035958569, 0.036010776, 0.036062948, 0.036115181, 0.036167502, 0.036219858, 0.036272209, 0.036324654, 0.036377095, 0.036429569, 0.03648207, 0.036534693, 0.036587283, 0.03663994, 0.036692653, 0.036745366, 0.036798112, 0.03685097, 0.036903836, 0.036956701, 0.037009653, 0.037062664, 0.037115645, 0.037168663, 0.037221793, 0.037274927, 0.037328091, 0.03738131, 0.037434597, 0.037487876, 0.037541218, 0.03759459, 0.037647992, 0.037701454, 0.037754975, 0.037808504, 0.037862085, 0.037915699, 0.03796934, 0.03802304, 0.038076803, 0.038130596, 0.038184389, 0.038238239, 0.038292151, 0.038346097, 0.038400073, 0.038454104, 0.038508162, 0.038562253, 0.038616441, 0.038670558, 0.038724773, 0.038779046, 0.038833376, 0.038887706, 0.038942102, 0.038996488, 0.039050974, 0.039105486, 0.039160032, 0.0392146, 0.039269235, 0.039323922, 0.039378617, 0.039433338, 0.039488122, 0.039542958, 0.039597806, 0.039652739, 0.039707698, 0.039762657, 0.03981768, 0.039872766, 0.039927848, 0.039983016, 0.040038217, 0.040093448, 0.040148649, 0.04020397, 0.040259354, 0.040314738, 0.040370177, 0.040425651, 0.040481176, 0.040536653, 0.040592305, 0.040647928, 0.040703576, 0.040759284, 0.040815059, 0.04087086, 0.040926635, 0.040982522, 0.041038446, 0.041094396, 0.04115041, 0.041206449, 0.041262489, 0.041318592, 0.04137475, 0.041430943, 0.041487195, 0.041543476, 0.041599754, 0.041656125, 0.041712526, 0.041768935, 0.041825417, 0.041881911, 0.041938495, 0.041995101, 0.042051744, 0.04210842, 0.042165086, 0.042221878, 0.0422787, 0.042335518, 0.042392369, 0.042449281, 0.042506222, 0.042563252, 0.042620286, 0.042677373, 0.042734466, 0.042791646, 0.042848855, 0.042906094, 0.042963337, 0.043020695, 0.043078057, 0.043135446, 0.043192867, 0.043250352, 0.043307859, 0.043365404, 0.04342306, 0.043480691, 0.043538351, 0.0435961, 0.04365382, 0.043711632, 0.043769501, 0.043827377, 0.043885276, 0.043943234, 0.044001281, 0.044059277, 0.044117358, 0.044175494, 0.044233669, 0.044291865, 0.044350125, 0.044408444, 0.044466704, 0.044525087, 0.044583496, 0.044641938, 0.04470041, 0.044758935, 0.044817526, 0.044876084, 0.044934765, 0.044993445, 0.045052156, 0.045110926, 0.045169786, 0.045228615, 0.045287475, 0.045346394, 0.045405373, 0.045464385, 0.045523454, 0.045582552, 0.045641653, 0.045700841, 0.045760028, 0.045819283, 0.045878559, 0.045937933, 0.045997299, 0.046056699, 0.046116132, 0.046175618, 0.04623514, 0.046294723, 0.046354353, 0.046413999, 0.046473697, 0.046533395, 0.046593186, 0.046652976, 0.046712887, 0.046772763, 0.046832699, 0.046892639, 0.046952672, 0.047012731, 0.047072813, 0.047132969, 0.047193114, 0.047253355, 0.047313623, 0.047373895, 0.047434196, 0.047494579, 0.047555029, 0.047615476, 0.047675986, 0.047736526, 0.047797069, 0.047857665, 0.047918357, 0.047979042, 0.04803979, 0.048100602, 0.04816135, 0.048222218, 0.048283149, 0.048344105, 0.048405062, 0.048466112, 0.048527163, 0.048588213, 0.048649382, 0.048710577, 0.048771776, 0.048833035, 0.048894353, 0.048955705, 0.049017049, 0.049078487, 0.049139958, 0.049201455, 0.049262989, 0.049324602, 0.049386192, 0.049447838, 0.049509581, 0.049571313, 0.049633056, 0.049694911, 0.049756769, 0.049818661, 0.049880635, 0.049942583, 0.05000462, 0.050066691, 0.050128825, 0.050190948, 0.050253108, 0.050315384, 0.050377637, 0.050439909, 0.050502282, 0.050564677, 0.050627071, 0.050689559, 0.050752051, 0.050814629, 0.05087721, 0.050939847, 0.051002514, 0.05106521, 0.051127996, 0.05119076, 0.051253576, 0.051316451, 0.05137936, 0.051442295, 0.051505294, 0.051568292, 0.051631384, 0.051694497, 0.051757675, 0.051820852, 0.051884092, 0.051947385, 0.052010685, 0.052073982, 0.052137371, 0.052200846, 0.052264299, 0.052327834, 0.052391395, 0.052454993, 0.052518591, 0.052582309, 0.052646004, 0.052709747, 0.052773554, 0.052837394, 0.052901227, 0.052965127, 0.053029142, 0.053093128, 0.053157147, 0.053221222, 0.053285357, 0.053349502, 0.053413697, 0.053477921, 0.053542212, 0.053606529, 0.053670906, 0.053735308, 0.053799685, 0.053864211, 0.053928711, 0.053993266, 0.054057915, 0.05412253, 0.054187208, 0.054251883, 0.054316651, 0.054381482, 0.054446306, 0.054511189, 0.054576106, 0.054641083, 0.054706059, 0.054771096, 0.054836195, 0.05490132, 0.05496648, 0.055031694, 0.055096913, 0.055162188, 0.055227552, 0.055292893, 0.055358347, 0.055423774, 0.055489231, 0.055554777, 0.055620324, 0.055685896, 0.055751566, 0.055817265, 0.055882961, 0.055948742, 0.05601456, 0.056080379, 0.056146283, 0.05621222, 0.056278184, 0.056344185, 0.056410238, 0.056476261, 0.056542408, 0.056608584, 0.056674827, 0.056741085, 0.056807324, 0.056873683, 0.056940064, 0.057006452, 0.05707293, 0.057139371, 0.057205908, 0.057272471, 0.057339098, 0.057405785, 0.057472415, 0.057539161, 0.057605933, 0.057672739, 0.057739634, 0.057806503, 0.057873424, 0.057940379, 0.0580074, 0.058074474, 0.058141552, 0.058208715, 0.058275878, 0.058343045, 0.058410328, 0.058477588, 0.058544964, 0.058612309, 0.058679774, 0.058747206, 0.058814675, 0.058882233, 0.058949783, 0.059017401, 0.059085105, 0.059152782, 0.059220511, 0.059288282, 0.059356075, 0.059423961, 0.059491813, 0.059559818, 0.059627797, 0.059695806, 0.059763867, 0.059831932, 0.059900057, 0.05996827, 0.060036488, 0.060104761, 0.060173038, 0.060241371, 0.060309742, 0.06037816, 0.06044665, 0.060515162, 0.060583677, 0.060652252, 0.060720891, 0.060789522, 0.060858276, 0.06092697, 0.060995754, 0.061064571, 0.061133444, 0.061202347, 0.061271254, 0.06134028, 0.061409272, 0.061478358, 0.061547503, 0.061616585, 0.06168576, 0.061754994, 0.061824288, 0.061893582, 0.061962906, 0.062032323, 0.062101737, 0.062171213, 0.062240716, 0.062310249, 0.062379844, 0.062449474, 0.062519155, 0.062588871, 0.062658556, 0.06272839, 0.062798224, 0.062868051, 0.062938012, 0.063007936, 0.063077882, 0.063147932, 0.063218005, 0.063288108, 0.06335824, 0.063428499, 0.063498721, 0.06356892, 0.063639291, 0.063709609, 0.06378001, 0.06385044, 0.063920908, 0.063991457, 0.064061955, 0.064132564, 0.06420321, 0.064279482, 0.064361565, 0.064443693, 0.064525805, 0.064607941, 0.064690113, 0.064772293, 0.06485451, 0.06493672, 0.065018967, 0.065101273, 0.06518352, 0.065265812, 0.065348141, 0.065430507, 0.065512843, 0.065595254, 0.065677635, 0.065760039, 0.065842494, 0.065924965, 0.066007443, 0.066089973, 0.066172458, 0.066255026, 0.066337526, 0.06642013, 0.066502728, 0.066585317, 0.066667967, 0.066750638, 0.066833325, 0.066915989, 0.066998683, 0.067081429, 0.067164198, 0.067246974, 0.067329779, 0.067412563, 0.067495383, 0.067578264, 0.067661136, 0.067744017, 0.067826919, 0.067909874, 0.067992784, 0.068075761, 0.068158746, 0.068241775, 0.068324782, 0.068407841, 0.06849093, 0.068574019, 0.068657093, 0.068740189, 0.068823375, 0.068906531, 0.068989739, 0.069072917, 0.069156125, 0.069239378, 0.069322631, 0.069405913, 0.069489211, 0.069572553, 0.069655888, 0.06973923, 0.069822639, 0.069906026, 0.069989443, 0.070072852, 0.070156351, 0.070239827, 0.070323288, 0.070406802, 0.070490345, 0.070573919, 0.070657484, 0.07074108, 0.07082469, 0.070908301, 0.070991978, 0.071075648, 0.071159363, 0.071243055, 0.0713268, 0.071410529, 0.071494296, 0.071578093, 0.071661875, 0.071745716, 0.07182958, 0.071913451, 0.071997382, 0.072081193, 0.072165139, 0.0722491, 0.072333068, 0.072417058, 0.072501041, 0.072585091, 0.072669119, 0.072753198, 0.072837263, 0.072921365, 0.073005505, 0.073089644, 0.073173821, 0.07325796, 0.073342182, 0.073426381, 0.073510639, 0.073594898, 0.073679186, 0.073763423, 0.073847756, 0.073932096, 0.074016452, 0.074100852, 0.074185252, 0.07426969, 0.074354067, 0.074438542, 0.074523009, 0.074607506, 0.074692003, 0.074776582, 0.074861109, 0.074945703, 0.075030245, 0.075114861, 0.075199507, 0.075284161, 0.075368829, 0.075453542, 0.075538203, 0.075622939, 0.075707689, 0.075792491, 0.075877264, 0.075962082, 0.076046892, 0.076131716, 0.076216571, 0.076301493, 0.076386377, 0.076471306, 0.076556265, 0.076641224, 0.076726176, 0.076811187, 0.076896206, 0.076981254, 0.077066317, 0.07715141, 0.077236496, 0.077321582, 0.077406734, 0.077491909, 0.077577107, 0.077662282, 0.077747501, 0.077832729, 0.077917978, 0.07800328, 0.078088544, 0.078173861, 0.078259192, 0.078344591, 0.07842993, 0.078515299, 0.078600727, 0.078686155, 0.078771636, 0.078857094, 0.078942567, 0.079028077, 0.07911361, 0.079199173, 0.079284728, 0.079370335, 0.079455949, 0.079541534, 0.079627216, 0.079712853, 0.079798557, 0.079884224, 0.079969972, 0.080055714, 0.080141515, 0.080227241, 0.080313057, 0.080398887, 0.080484726, 0.080570586, 0.080656484, 0.080742374, 0.080828279, 0.080914237, 0.081000216, 0.081086203, 0.081172168, 0.0812582, 0.081344239, 0.081430264, 0.081516385, 0.081602454, 0.08168859, 0.081774727, 0.081860892, 0.081947058, 0.082033232, 0.082119435, 0.082205668, 0.082291938, 0.082378194, 0.082464509, 0.082550809, 0.082637124, 0.082723476, 0.082809858, 0.082896233, 0.082982659, 0.083069086, 0.083155572, 0.083241984, 0.083328471, 0.083414979, 0.08350151, 0.083588056, 0.083674654, 0.0837612, 0.083847813, 0.083934419, 0.084021091, 0.084107779, 0.084194429, 0.084281132, 0.084367864, 0.084454574, 0.084541373, 0.08462812, 0.084714934, 0.084801756, 0.08488863, 0.084975481, 0.08506231, 0.085149214, 0.085236147, 0.08532308, 0.085410073, 0.085497022, 0.085584044, 0.085671015, 0.085758038, 0.085845128, 0.085932173, 0.086019292, 0.086106412, 0.086193517, 0.086280674, 0.086367838, 0.086455047, 0.086542249, 0.08662951, 0.086716756, 0.086803973, 0.086891264, 0.08697857, 0.08706592, 0.087153256, 0.087240644, 0.087328032, 0.08741539, 0.08750286, 0.087590292, 0.087677777, 0.087765262, 0.087852769, 0.087940276, 0.088027783, 0.088115394, 0.088202938, 0.08829055, 0.088378161, 0.088465847, 0.088553488, 0.088641137, 0.088728838, 0.088816568, 0.088904306, 0.088992089, 0.08907982, 0.089167662, 0.089255467, 0.089343302, 0.089431174, 0.089519031, 0.089606918, 0.089694843, 0.089782782, 0.089870729, 0.089958668, 0.090046681, 0.090134695, 0.090222739, 0.090310782, 0.090398863, 0.090486921, 0.090575054, 0.090663187, 0.090751328, 0.090839475, 0.09092772, 0.091015905, 0.091104127, 0.091192372, 0.091280617, 0.091368891, 0.091457218, 0.091545574, 0.091633916, 0.091722257, 0.091810644, 0.091899037, 0.091987468, 0.092075944, 0.09216439, 0.092252851, 0.092341341, 0.092429876, 0.092518397, 0.092606962, 0.092695564, 0.092784151, 0.092872784, 0.092961416, 0.09305004, 0.093138725, 0.093227416, 0.09331616, 0.093404897, 0.093493663, 0.093582377, 0.093671203, 0.093760021, 0.093848884, 0.093937725, 0.094026603, 0.094115451, 0.094204381, 0.094293311, 0.094382271, 0.094471224, 0.094560221, 0.094649233, 0.094738267, 0.094827309, 0.094916373, 0.095005482, 0.095094584, 0.095183723, 0.095272847, 0.095361993, 0.095451199, 0.095540397, 0.09562964, 0.095718868, 0.095808133, 0.095897414, 0.095986702, 0.096076041, 0.096165389, 0.096254721, 0.096344121, 0.096433535, 0.09652295, 0.096612364, 0.096701846, 0.096791305, 0.096880816, 0.096970342, 0.097059876, 0.097149417, 0.09723898, 0.097328596, 0.097418204, 0.097507857, 0.097597495, 0.097687162, 0.097776853, 0.097866572, 0.0979563, 0.098046042, 0.098135822, 0.098225623, 0.098315418, 0.098405287, 0.098495103, 0.098584987, 0.098674871, 0.098764792, 0.098854706, 0.098944664, 0.09903463, 0.099124603, 0.099214591, 0.099304646, 0.099394694, 0.099484764, 0.099574842, 0.099664949, 0.099755041, 0.099845208, 0.09993533, 0.10002553, 0.10011575, 0.100206, 0.10029622, 0.10038646, 0.10047672, 0.10056706, 0.10065738, 0.10074774, 0.10083807, 0.10092843, 0.1010188, 0.10110926, 0.10119968, 0.10129012, 0.10138061, 0.10147112, 0.10156161, 0.10165215, 0.1017427, 0.10183328, 0.10192391, 0.1020145, 0.10210514, 0.10219575, 0.10228643, 0.10237712, 0.10246786, 0.10255857, 0.10264932, 0.10274012, 0.10283085, 0.10292166, 0.10301251, 0.10310337, 0.10319421, 0.10328511, 0.10337604, 0.10346693, 0.10355787, 0.10364885, 0.10373984, 0.10383084, 0.10392188, 0.10401288, 0.10410393, 0.10419502, 0.10428616, 0.10437727, 0.10446841, 0.10455956, 0.10465074, 0.10474192, 0.10483316, 0.10492442, 0.10501563, 0.10510692, 0.10519822, 0.10528958, 0.10538086, 0.10547222, 0.1055636, 0.10565501, 0.10574643, 0.10583787, 0.10592928, 0.10602076, 0.10611226, 0.10620377, 0.10629533, 0.10638683, 0.10647843, 0.10657004, 0.1066616, 0.10675327, 0.10684489, 0.10693655, 0.10702828, 0.10711996, 0.1072117, 0.1073034, 0.1073952, 0.10748699, 0.10757878, 0.10767062, 0.10776245, 0.1078543, 0.10794618, 0.10803811, 0.10813002, 0.10822196, 0.10831392, 0.10840594, 0.1084979, 0.10858993, 0.10868194, 0.10877401, 0.10886609, 0.10895822, 0.10905033, 0.10914243, 0.1092346, 0.10932678, 0.10941898, 0.10951121, 0.10960341, 0.10969569, 0.10978794, 0.10988025, 0.10997257, 0.11006491, 0.11015723, 0.11024965, 0.11034204, 0.11043443, 0.11052682, 0.11061929, 0.11071176, 0.11080428, 0.1108968, 0.11098935, 0.11108184, 0.11117442, 0.11126701, 0.11135962, 0.11145226, 0.11154487, 0.11163756, 0.11173023, 0.11182292, 0.11191566, 0.11200839, 0.11210117, 0.11219396, 0.11228675, 0.11237955, 0.1124724, 0.11256525, 0.11265816, 0.11275104, 0.11284397, 0.11293688, 0.11302983, 0.11312281, 0.11321583, 0.11330887, 0.11340187, 0.11349496, 0.11358803, 0.11368109, 0.11377422, 0.11386734, 0.1139605, 0.11405369, 0.11414687, 0.1142401, 0.11433328, 0.11442656, 0.11451985, 0.11461315, 0.11470645, 0.1147998, 0.11489309, 0.11498649, 0.11507988, 0.1151733, 0.1152667, 0.11536016, 0.11545365, 0.1155471, 0.11564061, 0.11573413, 0.11582768, 0.11592124, 0.11601484, 0.11610845, 0.11620203, 0.1162957, 0.11638936, 0.11648306, 0.11657676, 0.11667047, 0.11676421, 0.11685797, 0.11695173, 0.11704555, 0.11713938, 0.11723319, 0.11732704, 0.11742095, 0.11751483, 0.11760873, 0.11770266, 0.11779662, 0.1178906, 0.11798461, 0.11807866, 0.11817263, 0.11826669, 0.11836077, 0.11845487, 0.11854898, 0.11864311, 0.11873725, 0.11883142, 0.1189256, 0.11901983, 0.11911405, 0.1192083, 0.11930259, 0.11939688, 0.11949115, 0.11958547, 0.11967984, 0.1197742, 0.11986859, 0.11996301, 0.1200574, 0.12015186, 0.12024633, 0.12034081, 0.1204353, 0.12052984, 0.12062438, 0.12071896, 0.1208135, 0.12090811, 0.12100271, 0.12109737, 0.12119204, 0.12128674, 0.12138143, 0.12147611, 0.12157085, 0.12166562, 0.1217604, 0.12185521, 0.12195, 0.12204481, 0.12213968, 0.12223457, 0.12232947, 0.12242436, 0.1225193, 0.12261426, 0.12270921, 0.12280419, 0.1228992, 0.12299426, 0.12308931, 0.12318439, 0.12327948, 0.12337457, 0.12346967, 0.12356483, 0.12366003, 0.12375522, 0.12385044, 0.12394564, 0.12404086, 0.12413613, 0.12423144, 0.12432674, 0.12442207, 0.1245174, 0.12461278, 0.12470812, 0.12480357, 0.12489895, 0.12499441, 0.12508987, 0.12518537, 0.12528086, 0.12537636, 0.12547189, 0.12556747, 0.12566304, 0.12575866, 0.12585422, 0.1259499, 0.12604554, 0.12614124, 0.12623692, 0.12633263, 0.12642837, 0.12652412, 0.12661992, 0.12671569, 0.12681147, 0.12690733, 0.12700318, 0.12709907, 0.12719496, 0.12729083, 0.12738676, 0.12748273, 0.12757869, 0.12767471, 0.12777069, 0.12786674, 0.12796278, 0.12805885, 0.12815493, 0.12825103, 0.12834714, 0.1284433, 0.12853947, 0.12863567, 0.12873183, 0.12882806, 0.12892431, 0.12902057, 0.12911686, 0.12921315, 0.12930948, 0.12940581, 0.12950216, 0.12959856, 0.12969498, 0.12979136, 0.12988782, 0.12998426, 0.13008074, 0.13017724, 0.13027374, 0.13037027, 0.13046686, 0.13056344, 0.13066001, 0.1307566, 0.13085325, 0.13094993, 0.13104661, 0.1311433, 0.13124, 0.1313367, 0.13143349, 0.13153024, 0.13162705, 0.13172384, 0.13182068, 0.13191754, 0.13201438, 0.13211128, 0.13220817, 0.13230509, 0.13240208, 0.13249904, 0.13259603, 0.13269298, 0.13279001, 0.13288708, 0.13298416, 0.13308123, 0.13317834, 0.13327546, 0.13337258, 0.13346975, 0.13356695, 0.13366412, 0.13376135, 0.13385859, 0.13395587, 0.13405313, 0.13415042, 0.13424774, 0.13434508, 0.13444243, 0.13453983, 0.13463718, 0.1347346, 0.13483205, 0.13492952, 0.13502702, 0.13512449, 0.135222, 0.13531952, 0.13541709, 0.13551468, 0.13561223, 0.13570984, 0.13580748, 0.13590515, 0.13600284, 0.13610049, 0.13619819, 0.13629591, 0.13639368, 0.13649145, 0.13658926, 0.13668701, 0.13678487, 0.13688271, 0.13698058, 0.13707846, 0.13717635, 0.13727428, 0.13737221, 0.1374702, 0.13756818, 0.13766617, 0.13776419, 0.13786225, 0.13796031, 0.13805836, 0.13815644, 0.1382546, 0.13835272, 0.13845091, 0.13854909, 0.13864727, 0.13874547, 0.1388437, 0.13894197, 0.13904026, 0.13913853, 0.13923687, 0.13933522, 0.13943353, 0.13953193, 0.13963029, 0.13972871, 0.13982716, 0.13992563, 0.1400241, 0.14012255, 0.14022107, 0.1403196, 0.14041817, 0.14051674, 0.14061533, 0.14071393, 0.14081255, 0.14091119, 0.14100988, 0.14110856, 0.14120726, 0.141306, 0.14140475, 0.14150348, 0.14160225, 0.14170109, 0.14179991, 0.14189875, 0.14199764, 0.14209646, 0.14219536, 0.1422943, 0.14239325, 0.1424922, 0.14259118, 0.1426902, 0.14278919, 0.14288825, 0.1429873, 0.14308637, 0.14318547, 0.14328459, 0.14338374, 0.14348289, 0.14358206, 0.14368123, 0.14378045, 0.1438797, 0.14397897, 0.14407825, 0.14417748, 0.14427681, 0.14437614, 0.14447552, 0.14457488, 0.14467427, 0.14477368, 0.14487308, 0.14497255, 0.14507203, 0.14517149, 0.14527102, 0.14537056, 0.14547011, 0.14556967, 0.14566921, 0.14576882, 0.14586848, 0.14596811, 0.14606778, 0.14616744, 0.14626715, 0.14636688, 0.14646664, 0.14656639, 0.14666618, 0.14676599, 0.14686579, 0.14696564, 0.14706549, 0.14716534, 0.14726526, 0.1473652, 0.14746515, 0.1475651, 0.14766504, 0.14776504, 0.14786507, 0.14796507, 0.14806516, 0.14816524, 0.14826533, 0.14836541, 0.14846557, 0.14856572, 0.14866588, 0.14876609, 0.1488663, 0.14896654, 0.14906676, 0.14916702, 0.14926732, 0.14936765, 0.14946796, 0.14956835, 0.14966871, 0.14976905, 0.14986946, 0.14996991, 0.15007034, 0.15017083, 0.15027131, 0.15037178, 0.1504723, 0.15057287, 0.15067345, 0.15077402, 0.15087461, 0.15097526, 0.1510759, 0.15117653, 0.1512772, 0.15137792, 0.15147865, 0.15157939, 0.15168016, 0.15178089, 0.15188169, 0.15198253, 0.15208337, 0.15218423, 0.1522851, 0.15238599, 0.15248689, 0.15258783, 0.15268879, 0.15278973, 0.15289076, 0.15299177, 0.15309283, 0.15319385, 0.15329491, 0.153396, 0.15349711, 0.15359823, 0.1536994, 0.15380056, 0.15390176, 0.15400295, 0.1541042, 0.15420544, 0.15430669, 0.15440799, 0.15450929, 0.1546106, 0.15471196, 0.15481333, 0.15491471, 0.15501614, 0.15511757, 0.155219, 0.15532041, 0.15542193, 0.15552342, 0.15562496, 0.15572649, 0.15582804, 0.15592964, 0.15603122, 0.15613437, 0.15623909, 0.15634383, 0.15644845, 0.15655312, 0.15665774, 0.15676233, 0.15686688, 0.15697138, 0.15707588, 0.15718035, 0.1572848, 0.15738921, 0.15749356, 0.1575979, 0.15770222, 0.1578065, 0.15791078, 0.15801497, 0.15811917, 0.15822333, 0.15832746, 0.15843156, 0.15853561, 0.15863967, 0.15874368, 0.15884764, 0.15895163, 0.15905552, 0.15915942, 0.15926327, 0.15936711, 0.1594709, 0.15957466, 0.1596784, 0.15978213, 0.15988581, 0.15998945, 0.16009305, 0.16019665, 0.16030021, 0.16040374, 0.16050723, 0.16061068, 0.16071413, 0.16081755, 0.16092092, 0.16102427, 0.16112755, 0.16123085, 0.16133411, 0.16143733, 0.16154054, 0.16164367, 0.16174681, 0.16184995, 0.16195302, 0.16205606, 0.16215904, 0.16226204, 0.16236499, 0.16246793, 0.16257082, 0.16267367, 0.16277651, 0.1628793, 0.16298209, 0.16308485, 0.16318756, 0.16329022, 0.16339287, 0.1634955, 0.16359809, 0.16370064, 0.16380316, 0.16390567, 0.16400814, 0.16411059, 0.164213, 0.16431537, 0.16441773, 0.16452003, 0.16462235, 0.1647246, 0.1648268, 0.16492899, 0.16503118, 0.16513331, 0.16523543, 0.16533749, 0.16543953, 0.16554156, 0.16564354, 0.16574551, 0.16584742, 0.16594931, 0.16605116, 0.16615301, 0.16625483, 0.16635659, 0.16645834, 0.16656005, 0.16666174, 0.16676341, 0.16686502, 0.16696659, 0.16706817, 0.16716971, 0.16727121, 0.16737267, 0.16747412, 0.16757554, 0.16767693, 0.1677783, 0.16787957, 0.16798089, 0.16808215, 0.16818339, 0.1682846, 0.16838573, 0.16848689, 0.168588, 0.1686891, 0.16879015, 0.16889115, 0.16899213, 0.16909309, 0.16919403, 0.16929494, 0.16939577, 0.16949664, 0.16959742, 0.16969824, 0.16979897, 0.1698997, 0.17000036, 0.17010103, 0.17020167, 0.17030227, 0.17040284, 0.17050335, 0.17060384, 0.17070433, 0.17080477, 0.1709052, 0.17100558, 0.17110592, 0.17120627, 0.17130658, 0.17140684, 0.17150705, 0.17160724, 0.17170744, 0.17180759, 0.17190771, 0.17200775, 0.1721078, 0.17220785, 0.17230785, 0.17240781, 0.17250772, 0.17260763, 0.1727075, 0.17280737, 0.17290717, 0.17300692, 0.1731067, 0.17320642, 0.17330611, 0.17340577, 0.1735054, 0.173605, 0.17370456, 0.1738041, 0.17390361, 0.17400308, 0.17410253, 0.17420195, 0.17430134, 0.1744007, 0.17450002, 0.1745993, 0.17469859, 0.17479785, 0.17489706, 0.17499621, 0.17509535, 0.17519447, 0.17529358, 0.17539264, 0.17549165, 0.17559063, 0.17568961, 0.17578855, 0.17588745, 0.17598632, 0.17608516, 0.176184, 0.17628276, 0.17638153, 0.17648025, 0.17657894, 0.1766776, 0.17677625, 0.17687485, 0.17697342, 0.17707193, 0.17717047, 0.17726894, 0.1773674, 0.17746583, 0.1775642, 0.17766255, 0.17776091, 0.17785922, 0.17795749, 0.17805572, 0.17815392, 0.1782521, 0.17835025, 0.17844839, 0.17854644, 0.17864452, 0.17874256, 0.17884056, 0.17893852, 0.17903644, 0.17913435, 0.17923225, 0.17933011, 0.17942792, 0.17952567, 0.17962345, 0.17972119, 0.17981888, 0.17991656, 0.18001416, 0.1801118, 0.18020937, 0.18030691, 0.18040442, 0.18050189, 0.18059936, 0.18069679, 0.18079421, 0.18089156, 0.18098888, 0.18108618, 0.18118346, 0.18128069, 0.18137793, 0.1814751, 0.18157226, 0.18166937, 0.18176647, 0.18186353, 0.18196055, 0.18205756, 0.18215452, 0.18225148, 0.1823484, 0.18244527, 0.18254212, 0.18263893, 0.18273574, 0.18283249, 0.1829292, 0.18302591, 0.18312258, 0.18321922, 0.18331584, 0.18341242, 0.18350896, 0.18360548, 0.18370199, 0.18379845, 0.18389487, 0.18399125, 0.18408763, 0.18418394, 0.18428026, 0.18437655, 0.18447278, 0.18456902, 0.1846652, 0.18476135, 0.18485749, 0.18495357, 0.18504962, 0.18514569, 0.18524167, 0.18533766, 0.18543358, 0.1855295, 0.18562539, 0.18572125, 0.18581709, 0.18591286, 0.18600863, 0.18610437, 0.18620008, 0.18629576, 0.18639137, 0.18648697, 0.18658257, 0.18667813, 0.18677367, 0.18686913, 0.1869646, 0.18706004, 0.18715544, 0.18725081, 0.18734613, 0.18744145, 0.18753673, 0.18763199, 0.18772721, 0.18782237, 0.18791755, 0.18801269, 0.18810777, 0.18820284, 0.18829787, 0.18839291, 0.18848787, 0.18858284, 0.18867773, 0.18877263, 0.18886749, 0.18896233, 0.1890571, 0.18915187, 0.18924661, 0.18934132, 0.18943599, 0.18953064, 0.18962523, 0.18971984, 0.1898144, 0.18990894, 0.19000341, 0.19009787, 0.19019233, 0.19028673, 0.19038108, 0.19047543, 0.19056974, 0.19066402, 0.19075829, 0.19085249, 0.19094671, 0.19104087, 0.191135, 0.1912291, 0.19132315, 0.19141722, 0.19151123, 0.19160521, 0.19169915, 0.19179307, 0.19188698, 0.19198082, 0.19207466, 0.19216846, 0.19226223, 0.19235598, 0.19244967, 0.19254336, 0.192637, 0.19273062, 0.1928242, 0.19291775, 0.19301128, 0.19310479, 0.19319826, 0.19329169, 0.19338511, 0.19347847, 0.19357182, 0.19366513, 0.19375843, 0.19385166, 0.19394489, 0.19403811, 0.19413128, 0.1942244, 0.1943175, 0.19441058, 0.19450362, 0.19459665, 0.19468963, 0.19478258, 0.19487551, 0.1949684, 0.19506128, 0.19515409, 0.19524689, 0.19533968, 0.19543244, 0.19552512, 0.19561782, 0.19571047, 0.19580308, 0.19589567, 0.19598825, 0.19608077, 0.19617327, 0.19626573, 0.19635816, 0.19645061, 0.19654296, 0.19663531, 0.19672765, 0.19681993, 0.1969122, 0.19700441, 0.19709662, 0.19718881, 0.19728091, 0.19737303, 0.19746512, 0.19755715, 0.19764918, 0.19774115, 0.19783312, 0.19792506, 0.19801696, 0.19810881, 0.19820064, 0.19829246, 0.19838423, 0.19847599, 0.19856769, 0.19865936, 0.19875105, 0.19884263, 0.19893426, 0.19902582, 0.19911735, 0.19920884, 0.1993003, 0.19939177, 0.19948319, 0.19957456, 0.19966592, 0.19975722, 0.19984853, 0.1999398, 0.20003101, 0.20012222, 0.20021342, 0.20030454, 0.20039564, 0.20048675, 0.2005778, 0.20066881, 0.2007598, 0.20085075, 0.20094168, 0.20103259, 0.20112346, 0.2012143, 0.20130511, 0.20139587, 0.20148662, 0.20157737, 0.20166804, 0.20175871, 0.20184931, 0.20193991, 0.20203049, 0.20212103, 0.20221154, 0.20230202, 0.20239246, 0.20248286, 0.20257325, 0.20266362, 0.20275396, 0.20284423, 0.2029345, 0.20302473, 0.20311493, 0.20320512, 0.20329526, 0.20338538, 0.20347545, 0.20356552, 0.20365556, 0.20374551, 0.2038355, 0.20392542, 0.20401534, 0.2041052, 0.20419505, 0.20428485, 0.20437463, 0.20446439, 0.20455413, 0.2046438, 0.20473348, 0.20482311, 0.20491271, 0.20500228, 0.2050918, 0.20518133, 0.20527081, 0.20536026, 0.20544967, 0.20553908, 0.20562844, 0.20571773, 0.20580706, 0.20589633, 0.20598555, 0.20607477, 0.20616394, 0.20625308, 0.20634221, 0.2064313, 0.20652038, 0.2066094, 0.20669837, 0.20678736, 0.20687626, 0.20696518, 0.20705406, 0.2071429, 0.20723173, 0.20732051, 0.20740926, 0.20749798, 0.20758669, 0.20767534, 0.20776398, 0.20785257, 0.20794117, 0.20802972, 0.20811822, 0.2082067, 0.20829517, 0.20838359, 0.20847195, 0.20856033, 0.20864867, 0.20873696, 0.20882525, 0.20891346, 0.20900169, 0.20908988, 0.20917802, 0.20926614, 0.20935421, 0.20944229, 0.20953034, 0.20961832, 0.20970629, 0.20979424, 0.20988214, 0.20997003, 0.21005788, 0.21014568, 0.21023349, 0.21032123, 0.21040896, 0.21049666, 0.21058433, 0.21067195, 0.21075958, 0.21084715, 0.2109347, 0.21102223, 0.21110968, 0.21119715, 0.21128459, 0.21137199, 0.21145937, 0.21154667, 0.21163398, 0.21172126, 0.2118085, 0.21189572, 0.21198289, 0.21207005, 0.21215717, 0.21224429, 0.21233134, 0.21241836, 0.21250537, 0.21259235, 0.2126793, 0.21276622, 0.21285307, 0.21293995, 0.21302675, 0.21311355, 0.2132003, 0.21328704, 0.21337374, 0.21346042, 0.21354705, 0.21363366, 0.21372025, 0.21380681, 0.21389332, 0.21397981, 0.21406625, 0.21415269, 0.21423908, 0.21432547, 0.21441178, 0.21449809, 0.21458438, 0.21467063, 0.21475685, 0.21484302, 0.21492919, 0.21501534, 0.21510141, 0.21518748, 0.21527353, 0.21535954, 0.2154455, 0.21553144, 0.21561736, 0.21570326, 0.21578912, 0.21587494, 0.21596074, 0.2160465, 0.21613222, 0.21621794, 0.2163036, 0.21638924, 0.21647486, 0.21656044, 0.21664599, 0.21673153, 0.21681701, 0.21690248, 0.21698791, 0.21707331, 0.21715869, 0.21724403, 0.21732932, 0.21741462, 0.21749987, 0.21758507, 0.21767028, 0.21775544, 0.21784057, 0.21792567, 0.21801072, 0.21809578, 0.21818079, 0.21826576, 0.21835071, 0.21843563, 0.21852054, 0.21860537, 0.2186902, 0.21877499, 0.21885976, 0.2189445, 0.21902922, 0.2191139, 0.21919855, 0.21928316, 0.21936774, 0.21945229, 0.21953683, 0.21962132, 0.21970579, 0.21979024, 0.21987462, 0.21995901, 0.22004335, 0.22012764, 0.22021194, 0.2202962, 0.22038044, 0.22046462, 0.22054878, 0.22063293, 0.22071701, 0.2208011, 0.22088514, 0.22096914, 0.22105314, 0.22113708, 0.221221, 0.22130491, 0.22138877, 0.22147258, 0.2215564, 0.22164017, 0.22172391, 0.22180761, 0.2218913, 0.22197492, 0.22205855, 0.22214215, 0.22222568, 0.22230925, 0.22239274, 0.22247618, 0.22255965, 0.22264305, 0.22272643, 0.22280976, 0.22289309, 0.22297639, 0.22305962, 0.22314286, 0.22322606, 0.22330922, 0.22339237, 0.22347547, 0.22355855, 0.2236416, 0.22372462, 0.2238076, 0.22389054, 0.22397347, 0.22405636, 0.22413924, 0.22422206, 0.22430485, 0.22438763, 0.22447041, 0.22455311, 0.22463578, 0.22471845, 0.22480108, 0.22488366, 0.22496621, 0.22504877, 0.22513123, 0.22521372, 0.22529617, 0.22537856, 0.22546098, 0.22554329, 0.22562563, 0.22570793, 0.22579019, 0.22587241, 0.22595462, 0.22603677, 0.22611892, 0.22620103, 0.22628312, 0.22636518, 0.22644718, 0.22652918, 0.22661112, 0.22669305, 0.22677496, 0.22685681, 0.22693865, 0.22702047, 0.22710223, 0.227184, 0.2272657, 0.2273474, 0.22742903, 0.22751066, 0.22759226, 0.22767383, 0.22775537, 0.22783685, 0.22791834, 0.22799979, 0.22808121, 0.2281626, 0.22824393, 0.22832526, 0.22840658, 0.22848783, 0.22856906, 0.22865026, 0.22873142, 0.22881258, 0.22889368, 0.22897477, 0.22905582, 0.22913684, 0.22921786, 0.2292988, 0.22937973, 0.22946064, 0.2295415, 0.22962235, 0.22970316, 0.22978394, 0.22986469, 0.22994541, 0.2300261, 0.23010676, 0.23018737, 0.230268, 0.23034856, 0.2304291, 0.23050959, 0.23059008, 0.23067051, 0.23075093, 0.23083134, 0.23091169, 0.230992, 0.23107231, 0.23115258, 0.23123282, 0.23131303, 0.2313932, 0.23147334, 0.23155345, 0.23163354, 0.23171361, 0.23179363, 0.23187362, 0.23195356, 0.23203351, 0.23211342, 0.23219328, 0.23227313, 0.23235296, 0.23243274, 0.23251249, 0.2325922, 0.23267192, 0.23275156, 0.23283119, 0.23291081, 0.23299037, 0.23306993, 0.23314941, 0.23322891, 0.23330836, 0.23338777, 0.23346716, 0.23354654, 0.23362584, 0.23370516, 0.23378442, 0.23386367, 0.23394287, 0.23402205, 0.23410122, 0.23418032, 0.23425941, 0.23433846, 0.2344175, 0.23449652, 0.23457547, 0.2346544, 0.23473333, 0.23481219, 0.23489103, 0.23496984, 0.23504862, 0.2351274, 0.23520613, 0.23528482, 0.23536348, 0.23544213, 0.23552074, 0.23559931, 0.23567785, 0.23575635, 0.23583484, 0.23591331, 0.23599172, 0.23607011, 0.23614848, 0.2362268, 0.23630513, 0.23638338, 0.23646162, 0.23653983, 0.23661801, 0.23669617, 0.2367743, 0.23685239, 0.23693047, 0.23700847, 0.23708647, 0.23716445, 0.23724239, 0.2373203, 0.23739818, 0.23747602, 0.23755385, 0.23763165, 0.2377094, 0.23778714, 0.23786484, 0.2379425, 0.23802012, 0.23809776, 0.23817533, 0.23825286, 0.23833039, 0.23840788, 0.23848535, 0.23856276, 0.23864016, 0.23871751, 0.23879488, 0.23887217, 0.23894946, 0.2390267, 0.2391039, 0.23918109, 0.23925824, 0.23933536, 0.23941247, 0.23948954, 0.23956658, 0.23964359, 0.23972055, 0.23979747, 0.23987441, 0.2399513, 0.24002814, 0.24010496, 0.24018174, 0.24025853, 0.24033526, 0.24041194, 0.24048863, 0.24056526, 0.24064188, 0.24071845, 0.24079502, 0.24087152, 0.24094801, 0.24102449, 0.24110091, 0.24117732, 0.24125367, 0.24133003, 0.24140635, 0.2414826, 0.24155885, 0.24163508, 0.24171126, 0.24178742, 0.24186353, 0.24193965, 0.24201572, 0.24209175, 0.24216776, 0.24224374, 0.24231969, 0.24239561, 0.2424715, 0.24254735, 0.24262317, 0.24269897, 0.24277475, 0.24285047, 0.24292618, 0.24300185, 0.2430775, 0.24315311, 0.2432287, 0.24330425, 0.24337976, 0.24345526, 0.24353072, 0.24360617, 0.24368159, 0.24375694, 0.24383229, 0.2439076, 0.24398288, 0.24405812, 0.24413334, 0.24420854, 0.24428372, 0.24435884, 0.24443394, 0.244509, 0.24458404, 0.24465907, 0.24473405, 0.24480897, 0.24488391, 0.2449588, 0.24503367, 0.24510849, 0.24518329, 0.24525805, 0.24533278, 0.24540751, 0.24548218, 0.24555682, 0.24563144, 0.24570604, 0.24577598, 0.24584121, 0.2459064, 0.24597149, 0.24603651, 0.2461015, 0.24616638, 0.24623124, 0.24629597, 0.24636067, 0.2464253, 0.24648985, 0.24655437, 0.24661879, 0.24668312, 0.24674743, 0.24681166, 0.24687579, 0.24693987, 0.24700391, 0.24706785, 0.24713174, 0.24719554, 0.2472593, 0.24732296, 0.24738659, 0.24745014, 0.24751361, 0.24757701, 0.24764036, 0.24770363, 0.24776684, 0.24782997, 0.24789304, 0.24795604, 0.24801897, 0.24808183, 0.24814463, 0.24820738, 0.24827003, 0.2483326, 0.24839514, 0.2484576, 0.24852002, 0.24858232, 0.24864459, 0.24870677, 0.24876888, 0.24883094, 0.24889293, 0.24895483, 0.24901669, 0.24907847, 0.24914019, 0.24920183, 0.24926341, 0.24932492, 0.24938637, 0.24944773, 0.24950905, 0.24957028, 0.24963146, 0.24969257, 0.24975361, 0.24981457, 0.24987547, 0.24993631, 0.24999706, 0.25005776, 0.2501184, 0.25017896, 0.25023946, 0.25029987, 0.25036022, 0.25042051, 0.25048074, 0.25054091, 0.25060099, 0.25066102, 0.25072098, 0.25078085, 0.25084069, 0.25090042, 0.25096011, 0.25101972, 0.25107926, 0.25113875, 0.25119814, 0.25125748, 0.25131676, 0.25137597, 0.2514351, 0.25149417, 0.25155318, 0.25161213, 0.25167099, 0.25172979, 0.25178853, 0.25184718, 0.2519058, 0.2519643, 0.2520228, 0.25208119, 0.25213951, 0.25219777, 0.25225595, 0.25231406, 0.25237212, 0.25243011, 0.25248802, 0.25254586, 0.25260365, 0.25266138, 0.25271904, 0.25277662, 0.25283411, 0.25289157, 0.25294897, 0.25300625, 0.25306353, 0.25312069, 0.25317779, 0.25323483, 0.25329179, 0.25334871, 0.25340554, 0.25346231, 0.253519, 0.25357562, 0.25363219, 0.25368869, 0.25374514, 0.25380147, 0.25385779, 0.253914, 0.25397018, 0.25402626, 0.25408226, 0.25413823, 0.25419411, 0.25424993, 0.25430569, 0.25436139, 0.25441697, 0.25447252, 0.25452805, 0.25458342, 0.25463879, 0.25469404, 0.25474927, 0.2548044, 0.25485948, 0.25491449, 0.25496945, 0.25502428, 0.25507912, 0.25513384, 0.25518849, 0.25524312, 0.25529763, 0.25535208, 0.2554065, 0.25546083, 0.2555151, 0.25556928, 0.2556234, 0.25567746, 0.25573143, 0.25578538, 0.25583923, 0.25589302, 0.25594673, 0.25600037, 0.25605398, 0.25610748, 0.25616094, 0.25621429, 0.25626764, 0.25632086, 0.25637406, 0.25642717, 0.25648019, 0.25653318, 0.25658607, 0.25663891, 0.25669166, 0.25674438, 0.25679702, 0.25684959, 0.2569021, 0.25695449, 0.25700688, 0.25705916, 0.2571114, 0.25716358, 0.25721565, 0.25726768, 0.25731966, 0.25737152, 0.25742334, 0.25747511, 0.25752681, 0.25757843, 0.25762996, 0.25768143, 0.25773284, 0.25778422, 0.25783548, 0.25788671, 0.25793782, 0.25798893, 0.25803992, 0.25809085, 0.25814173, 0.25819254, 0.25824326, 0.25829396, 0.25834456, 0.25839508, 0.25844556, 0.25849596, 0.25854629, 0.25859654, 0.25864673, 0.25869688, 0.25874695, 0.25879693, 0.25884685, 0.25889671, 0.25894651, 0.25899622, 0.25904584, 0.25909546, 0.25914496, 0.25919443, 0.25924379, 0.25929314, 0.2593424, 0.25939155, 0.25944066, 0.25948972, 0.25953868, 0.25958759, 0.25963643, 0.25968522, 0.25973392, 0.25978255, 0.25983113, 0.25987962, 0.25992805, 0.25997645, 0.26002473, 0.26007295, 0.26012111, 0.26016921, 0.26021725, 0.2602652, 0.26031309, 0.26036093, 0.26040864, 0.26045635, 0.26050398, 0.26055154, 0.26059905, 0.26064643, 0.26069379, 0.26074106, 0.26078829, 0.26083541, 0.2608825, 0.26092952, 0.26097646, 0.26102334, 0.26107013, 0.26111689, 0.26116356, 0.26121014, 0.26125672, 0.26130316, 0.26134959, 0.2613959, 0.26144215, 0.26148838, 0.26153451, 0.26158059, 0.26162654, 0.2616725, 0.26171833, 0.26176414, 0.26180986, 0.26185554, 0.26190111, 0.26194662, 0.2619921, 0.26203746, 0.26208279, 0.26212803, 0.26217321, 0.2622183, 0.26226339, 0.26230833, 0.26235327, 0.26239812, 0.26244286, 0.26248759, 0.26253223, 0.26257679, 0.26262131, 0.26266575, 0.26271009, 0.26275441, 0.26279864, 0.2628428, 0.26288691, 0.26293093, 0.26297489, 0.26301882, 0.26306263, 0.26310638, 0.26315007, 0.2631937, 0.26323727, 0.26328072, 0.26332414, 0.2633675, 0.26341081, 0.26345399, 0.26349717, 0.26354024, 0.26358327, 0.26362622, 0.26366907, 0.2637119, 0.26375464, 0.26379731, 0.2638399, 0.26388246, 0.26392493, 0.26396734, 0.26400968, 0.26405194, 0.26409414, 0.26413628, 0.26417834, 0.26422033, 0.26426226, 0.26430413, 0.26434591, 0.26438764, 0.2644293, 0.26447091, 0.26451242, 0.26455387, 0.26459527, 0.26463658, 0.26467782, 0.26471901, 0.26476014, 0.2648012, 0.26484215, 0.26488307, 0.26492393, 0.26496473, 0.26500541, 0.26504603, 0.26508662, 0.26512712, 0.26516756, 0.26520795, 0.26524827, 0.2652885, 0.26532868, 0.26536876, 0.26540878, 0.26544875, 0.26548865, 0.2655285, 0.26556826, 0.26560792, 0.26564756, 0.26568711, 0.26572663, 0.26576602, 0.26580539, 0.26584467, 0.26588389, 0.26592302, 0.26596212, 0.26600116, 0.26604009, 0.26607898, 0.26611778, 0.26615652, 0.26619521, 0.26623383, 0.26627237, 0.26631084, 0.26634926, 0.26638758, 0.26642585, 0.26646402, 0.26650217, 0.26654026, 0.26657826, 0.2666162, 0.26665404, 0.26669186, 0.26672956, 0.26676723, 0.26680484, 0.26684234, 0.2668798, 0.2669172, 0.26695454, 0.26699179, 0.26702899, 0.26706606, 0.26710317, 0.26714012, 0.26717705, 0.26721388, 0.26725066, 0.26728737, 0.26732403, 0.2673606, 0.26739711, 0.26743355, 0.26746994, 0.26750621, 0.26754248, 0.26757863, 0.26761475, 0.26765078, 0.26768672, 0.26772267, 0.26775846, 0.26779422, 0.26782992, 0.26786557, 0.26790112, 0.26793665, 0.26797205, 0.2680074, 0.26804268, 0.26807791, 0.26811308, 0.26814815, 0.26818317, 0.26821813, 0.268253, 0.26828784, 0.26832259, 0.26835725, 0.26839185, 0.26842642, 0.2684609, 0.26849529, 0.26852965, 0.2685639, 0.26859814, 0.26863226, 0.2686663, 0.26870033, 0.26873425, 0.2687681, 0.26880193, 0.26883566, 0.26886931, 0.26890293, 0.26893646, 0.26896992, 0.2690033, 0.26903662, 0.26906988, 0.26910308, 0.26913619, 0.26916924, 0.26920223, 0.26923516, 0.26926801, 0.26930079, 0.26933348, 0.26936615, 0.26939872, 0.26943123, 0.26946369, 0.26949605, 0.26952836, 0.26956064, 0.26959279, 0.26962489, 0.26965693, 0.26968887, 0.26972079, 0.26975262, 0.26978439, 0.2698161, 0.26984772, 0.26987928, 0.26991078, 0.26994219, 0.26997358, 0.27000487, 0.27003607, 0.27006724, 0.27009833, 0.27012935, 0.27016029, 0.27019116, 0.27022201, 0.27025276, 0.27028343, 0.27031404, 0.27034459, 0.27037507, 0.2704055, 0.27043584, 0.27046609, 0.27049631, 0.27052647, 0.27055654, 0.27058655, 0.27061647, 0.27064636, 0.27067614, 0.27070588, 0.27073553, 0.27076513, 0.27079466, 0.27082413, 0.27085355, 0.27088287, 0.27091211, 0.27094132, 0.27097043, 0.27099949, 0.27102846, 0.2710574, 0.27108625, 0.27111503, 0.27114376, 0.2711724, 0.27120098, 0.27122951, 0.27125797, 0.27128634, 0.27131465, 0.27134287, 0.27137104, 0.27139914, 0.27142721, 0.27145517, 0.27148309, 0.27151093, 0.2715387, 0.27156639, 0.27159402, 0.27162158, 0.27164909, 0.27167651, 0.27170387, 0.27173117, 0.27175841, 0.27178556, 0.27181268, 0.27183968, 0.27186665, 0.27189353, 0.27192035, 0.27194709, 0.27197379, 0.2720004, 0.27202696, 0.27205342, 0.27207983, 0.27210617, 0.27213246, 0.27215868, 0.27218482, 0.27221087, 0.27223691, 0.27226284, 0.27228868, 0.27231455, 0.27234024, 0.27236593, 0.27239153, 0.27241704, 0.27244252, 0.27246791, 0.27249324, 0.27251852, 0.2725437, 0.27256882, 0.27259389, 0.27261886, 0.2726438, 0.27266866, 0.27269343, 0.27271816, 0.27274281, 0.27276739, 0.27279192, 0.27281639, 0.27284077, 0.27286509, 0.27288932, 0.27291349, 0.2729376, 0.27296162, 0.27298564, 0.27300951, 0.27303338, 0.27305713, 0.27308083, 0.27310446, 0.27312803, 0.27315155, 0.27317497, 0.27319834, 0.27322164, 0.27324486, 0.27326801, 0.27329111, 0.27331415, 0.2733371, 0.27335998, 0.27338281, 0.27340558, 0.27342826, 0.27345088, 0.27347341, 0.27349591, 0.27351832, 0.27354071, 0.27356297, 0.27358517, 0.27360728, 0.2736294, 0.27365139, 0.27367336, 0.27369523, 0.27371702, 0.27373877, 0.27376047, 0.27378204, 0.27380359, 0.27382505, 0.27384645, 0.27386779, 0.27388906, 0.27391025, 0.27393135, 0.27395242, 0.27397344, 0.27399436, 0.27401522, 0.27403596, 0.27405673, 0.27407739, 0.27409798, 0.27411848, 0.27413893, 0.27415931, 0.27417964, 0.2741999, 0.27422005, 0.2742402, 0.27426022, 0.27428019, 0.2743001, 0.27431995, 0.27433971, 0.27435941, 0.27437907, 0.27439862, 0.27441815, 0.27443761, 0.27445695, 0.27447626, 0.27449545, 0.27451465, 0.27453372, 0.27455276, 0.27457172, 0.27459061, 0.27460945, 0.27462819, 0.27464688, 0.2746655, 0.27468407, 0.27470255, 0.274721, 0.27473933, 0.27475762, 0.2747758, 0.27479398, 0.27481204, 0.27483007, 0.27484798, 0.2748659, 0.27488369, 0.27490145, 0.27491909, 0.27493674, 0.27495426, 0.27497172, 0.27498913, 0.27500644, 0.27502373, 0.27504092, 0.27505806, 0.27507511, 0.27509212, 0.27510902, 0.27512592, 0.2751427, 0.27515942, 0.27517608, 0.27519268, 0.27520919, 0.27522564, 0.27524203, 0.27525833, 0.27527457, 0.27529079, 0.27530691, 0.27532294, 0.27533895, 0.27535483, 0.27537069, 0.27538645, 0.27540216, 0.27541783, 0.27543339, 0.27544886, 0.2754643, 0.2754797, 0.27549502, 0.27551022, 0.27552539, 0.2755405, 0.27555552, 0.27557048, 0.27558538, 0.27560019, 0.27561498, 0.27562967, 0.27564427, 0.27565885, 0.27567333, 0.27568775, 0.27570212, 0.27571636, 0.27573061, 0.27574477, 0.27575883, 0.27577284, 0.27578679, 0.27580068, 0.2758145, 0.27582824, 0.27584192, 0.27585554, 0.27586907, 0.27588254, 0.27589595, 0.27590927, 0.27592257, 0.27593577, 0.27594888, 0.27596194, 0.27597496, 0.27598786, 0.27600074, 0.27601352, 0.27602628, 0.27603891, 0.27605152, 0.27606404, 0.2760765, 0.27608889, 0.2761012, 0.27611345, 0.27612564, 0.27613777, 0.27614981, 0.27616179, 0.27617371, 0.27618557, 0.27619731, 0.27620906, 0.27622068, 0.27623227, 0.27624378, 0.27625522, 0.27626657, 0.27627793, 0.27628914, 0.27630028, 0.2763114, 0.27632245, 0.27633339, 0.27634433, 0.27635515, 0.27636591, 0.27637658, 0.27638721, 0.27639776, 0.27640826, 0.27641869, 0.27642906, 0.27643934, 0.27644956, 0.27645969, 0.2764698, 0.27647981, 0.27648973, 0.27649963, 0.27650943, 0.27651921, 0.27652887, 0.27653849, 0.27654803, 0.27655751, 0.27656692, 0.27657625, 0.27658552, 0.27659473, 0.27660388, 0.27661294, 0.27662194, 0.27663085, 0.27663973, 0.27664855, 0.27665728, 0.27666593, 0.27667454, 0.27668306, 0.2766915, 0.2766999, 0.27670822, 0.27671647, 0.27672467, 0.27673277, 0.27674082, 0.27674881, 0.27675673, 0.2767646, 0.27677238, 0.27678007, 0.27678773, 0.2767953, 0.27680284, 0.27681026, 0.27681765, 0.27682495, 0.27683219, 0.27683935, 0.27684647, 0.2768535, 0.27686045, 0.27686739, 0.27687418, 0.27688095, 0.27688766, 0.27689427, 0.27690086, 0.27690735, 0.27691376, 0.27692011, 0.27692643, 0.27693263, 0.27693877, 0.27694488, 0.2769509, 0.27695686, 0.27696273, 0.27696854, 0.27697429, 0.27697998, 0.27698559, 0.27699113, 0.27699661, 0.27700204, 0.27700737, 0.27701265, 0.27701783, 0.27702299, 0.27702808, 0.27703306, 0.27703801, 0.2770429, 0.27704766, 0.2770524, 0.27705708, 0.2770617, 0.2770662, 0.27707067, 0.27707505, 0.27707937, 0.27708364, 0.27708781, 0.27709195, 0.277096, 0.2771, 0.2771039, 0.27710775, 0.27711153, 0.27711526, 0.27711892, 0.2771225, 0.27712601, 0.27712944, 0.27713284, 0.27713615, 0.27713937, 0.27714252, 0.27714565, 0.27714869, 0.27715167, 0.27715456, 0.2771574, 0.27716017, 0.27716288, 0.27716547, 0.27716807, 0.27717057, 0.27717298, 0.27717537, 0.27717766, 0.27717987, 0.27718204, 0.27718413, 0.27718616, 0.27718809, 0.27718997, 0.27719182, 0.27719355, 0.27719525, 0.27719685, 0.2771984, 0.27719989, 0.27720129, 0.27720264, 0.27720392, 0.27720511, 0.27720627, 0.27720734, 0.27720836, 0.27720925, 0.27721018, 0.27721095, 0.2772117, 0.27721235, 0.27721295, 0.27721348, 0.27721396, 0.27721438, 0.27721468, 0.27721491, 0.27721512, 0.27721527, 0.2772153, 0.2772153, 0.27721524, 0.27721506, 0.27721485, 0.27721462, 0.27721423, 0.27721381, 0.27721334, 0.27721277, 0.27721214, 0.27721149, 0.27721071, 0.27720988, 0.27720901, 0.27720806, 0.27720702, 0.27720594, 0.27720475, 0.27720353, 0.27720225, 0.27720088, 0.27719945, 0.27719793, 0.27719635, 0.27719474, 0.27719304, 0.27719125, 0.27718943, 0.27718753, 0.27718553, 0.2771835, 0.27718139, 0.27717918, 0.27717695, 0.27717465, 0.27717224, 0.27716321, 0.27714744, 0.27713159, 0.2771157, 0.27709976, 0.27708372, 0.27706766, 0.27705151, 0.27703533, 0.27701905, 0.27700275, 0.27698636, 0.27696991, 0.27695343, 0.27693686, 0.27692023, 0.27690357, 0.27688682, 0.27687001, 0.27685314, 0.27683625, 0.27681923, 0.27680221, 0.27678511, 0.27676794, 0.27675071, 0.27673346, 0.27671608, 0.27669868, 0.27668121, 0.27666369, 0.27664614, 0.27662846, 0.27661076, 0.276593, 0.27657518, 0.2765573, 0.27653936, 0.2765213, 0.27650326, 0.27648515, 0.27646694, 0.2764487, 0.27643037, 0.27641204, 0.27639359, 0.27637511, 0.27635655, 0.27633795, 0.2763193, 0.27630055, 0.27628177, 0.27626291, 0.27624398, 0.27622506, 0.27620599, 0.27618691, 0.27616778, 0.27614853, 0.27612928, 0.27610993, 0.27609056, 0.2760711, 0.27605158, 0.27603203, 0.27601236, 0.27599269, 0.27597293, 0.27595311, 0.27593324, 0.27591333, 0.2758933, 0.27587327, 0.27585313, 0.27583298, 0.27581272, 0.27579242, 0.27577209, 0.27575165, 0.27573118, 0.27571064, 0.27569005, 0.27566937, 0.27564868, 0.27562791, 0.27560705, 0.27558616, 0.27556518, 0.27554417, 0.27552307, 0.27550197, 0.27548075, 0.2754595, 0.27543816, 0.27541679, 0.27539536, 0.27537385, 0.2753523, 0.27533066, 0.27530897, 0.27528724, 0.27526543, 0.27524358, 0.27522165, 0.27519968, 0.27517763, 0.27515551, 0.27513334, 0.27511111, 0.27508885, 0.27506649, 0.27504408, 0.27502161, 0.27499908, 0.27497652, 0.27495387, 0.27493116, 0.27490839, 0.27488557, 0.27486268, 0.27483973, 0.27481672, 0.27479365, 0.27477053, 0.27474734, 0.2747241, 0.27470076, 0.2746774, 0.27465397, 0.27463049, 0.27460694, 0.27458334, 0.27455965, 0.27453589, 0.27451214, 0.27448827, 0.27446437, 0.27444038, 0.27441636, 0.27439228, 0.27436811, 0.27434388, 0.27431965, 0.2742953, 0.27427089, 0.27424645, 0.27422193, 0.27419737, 0.27417272, 0.27414802, 0.27412325, 0.27409846, 0.27407357, 0.27404863, 0.27402365, 0.27399859, 0.27397346, 0.27394828, 0.27392307, 0.27389774, 0.27387241, 0.27384698, 0.27382147, 0.27379596, 0.27377033, 0.2737447, 0.27371898, 0.2736932, 0.27366734, 0.27364144, 0.27361548, 0.27358949, 0.27356339, 0.27353725, 0.27351105, 0.27348477, 0.27345848, 0.27343208, 0.27340564, 0.27337915, 0.27335256, 0.27332595, 0.27329925, 0.27327251, 0.27324572, 0.27321884, 0.2731919, 0.27316496, 0.2731379, 0.27311078, 0.2730836, 0.27305639, 0.27302909, 0.27300176, 0.27297437, 0.27294689, 0.27291936, 0.27289179, 0.2728641, 0.27283642, 0.27280864, 0.27278081, 0.27275291, 0.27272496, 0.27269697, 0.2726689, 0.27264076, 0.27261257, 0.27258432, 0.27255601, 0.27252761, 0.2724992, 0.27247071, 0.27244216, 0.27241355, 0.27238485, 0.27235612, 0.27232736, 0.27229849, 0.27226958, 0.27224061, 0.27221158, 0.27218246, 0.27215332, 0.27212411, 0.27209482, 0.27206549, 0.27203611, 0.27200663, 0.27197713, 0.27194756, 0.27191791, 0.27188823, 0.27185845, 0.27182865, 0.27179876, 0.27176884, 0.2717388, 0.27170876, 0.27167866, 0.27164847, 0.27161825, 0.27158791, 0.27155757, 0.27152714, 0.27149665, 0.27146611, 0.27143553, 0.27140486, 0.27137414, 0.27134335, 0.27131253, 0.2712816, 0.27125067, 0.27121961, 0.27118853, 0.27115741, 0.27112621, 0.27109495, 0.27106363, 0.27103221, 0.27100077, 0.27096927, 0.27093771, 0.27090609, 0.27087438, 0.27084264, 0.27081084, 0.27077898, 0.27074704, 0.27071503, 0.27068302, 0.27065089, 0.27061874, 0.27058652, 0.27055421, 0.27052188, 0.27048945, 0.270457, 0.27042446, 0.27039188, 0.27035922, 0.2703265, 0.27029374, 0.2702609, 0.270228, 0.27019507, 0.27016205, 0.270129, 0.27009583, 0.27006266, 0.2700294, 0.26999611, 0.2699627, 0.26992926, 0.26989582, 0.26986223, 0.26982862, 0.26979494, 0.2697612, 0.26972741, 0.26969355, 0.26965964, 0.26962566, 0.26959163, 0.26955754, 0.26952338, 0.26948917, 0.2694549, 0.26942053, 0.26938614, 0.26935169, 0.26931718, 0.26928261, 0.26924795, 0.26921326, 0.26917848, 0.26914367, 0.2691088, 0.26907387, 0.26903883, 0.26900378, 0.26896867, 0.26893348, 0.26889825, 0.26886296, 0.26882756, 0.26879218, 0.26875669, 0.26872116, 0.26868555, 0.26864985, 0.26861414, 0.26857838, 0.26854253, 0.26850662, 0.26847064, 0.26843461, 0.26839855, 0.26836237, 0.26832619, 0.26828992, 0.26825359, 0.26821721, 0.26818076, 0.26814425, 0.26810768, 0.26807106, 0.26803437, 0.26799762, 0.26796082, 0.26792395, 0.26788703, 0.26785004, 0.26781297, 0.26777589, 0.2677387, 0.26770148, 0.26766419, 0.26762685, 0.26758942, 0.26755196, 0.26751444, 0.2674768, 0.26743916, 0.26740146, 0.26736367, 0.26732588, 0.26728794, 0.26725, 0.267212, 0.26717392, 0.2671358, 0.26709759, 0.26705933, 0.26702103, 0.26698264, 0.26694423, 0.26690573, 0.26686719, 0.26682854, 0.26678988, 0.26675111, 0.26671231, 0.26667348, 0.26663458, 0.26659557, 0.26655656, 0.26651743, 0.26647827, 0.26643905, 0.2663998, 0.26636046, 0.26632103, 0.26628157, 0.26624209, 0.26620251, 0.26616284, 0.26612315, 0.26608339, 0.26604357, 0.2660037, 0.26596373, 0.26592377, 0.26588368, 0.26584354, 0.2658034, 0.26576313, 0.26572284, 0.26568246, 0.26564205, 0.26560155, 0.26556098, 0.26552039, 0.26547974, 0.26543903, 0.26539823, 0.2653574, 0.26531646, 0.26527551, 0.26523447, 0.2651934, 0.26515225, 0.26511103, 0.26506978, 0.26502845, 0.26498708, 0.26494563, 0.26490411, 0.26486254, 0.2648209, 0.26477924, 0.26473746, 0.26469564, 0.2646538, 0.26461184, 0.26456988, 0.2645278, 0.26448572, 0.26444352, 0.26440132, 0.264359, 0.26431665, 0.26427424, 0.26423177, 0.26418921, 0.26414666, 0.26410398, 0.26406127, 0.26401851, 0.26397565, 0.26393276, 0.26388982, 0.26384678, 0.26380372, 0.2637606, 0.26371738, 0.26367411, 0.26363084, 0.26358742, 0.26354399, 0.26350051, 0.26345694, 0.26341334, 0.26336968, 0.26332593, 0.26328212, 0.26323825, 0.26319435, 0.26315036, 0.26310632, 0.26306221, 0.26301807, 0.26297385, 0.26292956, 0.26288521, 0.26284084, 0.26279634, 0.26275182, 0.26270723, 0.26266259, 0.26261792, 0.26257312, 0.2625283, 0.26248342, 0.26243851, 0.26239347, 0.26234841, 0.26230329, 0.26225811, 0.26221287, 0.26216754, 0.26212218, 0.26207677, 0.26203126, 0.26198575, 0.26194012, 0.26189446, 0.26184872, 0.26180294, 0.26175711, 0.26171118, 0.26166523, 0.26161921, 0.26157311, 0.26152694, 0.26148075, 0.26143447, 0.26138815, 0.26134175, 0.26129532, 0.2612488, 0.26120222, 0.26115558, 0.26110891, 0.26106218, 0.26101536, 0.26096848, 0.26092154, 0.26087451, 0.26082748, 0.26078039, 0.26073322, 0.26068598, 0.26063868, 0.26059133, 0.26054391, 0.26049647, 0.2604489, 0.26040131, 0.26035362, 0.26030594, 0.26025817, 0.26021034, 0.26016241, 0.26011446, 0.26006645, 0.26001838, 0.25997022, 0.25992203, 0.25987378, 0.25982544, 0.2597771, 0.25972864, 0.25968015, 0.25963157, 0.25958297, 0.2595343, 0.25948554, 0.25943676, 0.25938788, 0.25933895, 0.25928998, 0.25924096, 0.25919184, 0.25914267, 0.25909343, 0.25904414, 0.25899482, 0.25894544, 0.25889596, 0.25884646, 0.25879684, 0.25874719, 0.25869751, 0.25864774, 0.25859791, 0.25854802, 0.25849807, 0.25844806, 0.25839803, 0.25834787, 0.25829768, 0.25824746, 0.25819713, 0.25814676, 0.25809634, 0.25804585, 0.25799531, 0.2579447, 0.25789404, 0.25784329, 0.2577925, 0.25774163, 0.25769076, 0.2576398, 0.25758874, 0.25753766, 0.25748652, 0.25743529, 0.25738406, 0.25733271, 0.2572813, 0.25722983, 0.25717834, 0.25712678, 0.25707513, 0.25702342, 0.25697169, 0.25691989, 0.256868, 0.25681606, 0.25676408, 0.25671202, 0.2566599, 0.25660774, 0.2565555, 0.25650322, 0.25645086, 0.25639841, 0.25634596, 0.25629342, 0.25624081, 0.25618815, 0.25613543, 0.25608265, 0.25602981, 0.25597692, 0.25592399, 0.25587094, 0.25581786, 0.25576475, 0.25571153, 0.25565827, 0.25560495, 0.25555158, 0.25549811, 0.25544462, 0.25539106, 0.25533745, 0.25528377, 0.25523001, 0.25517622, 0.25512236, 0.25506842, 0.25501445, 0.25496039, 0.25490627, 0.25485212, 0.25479791, 0.25474364, 0.25468928, 0.25463489, 0.25458038, 0.2545259, 0.2544713, 0.25441664, 0.25436196, 0.25430718, 0.25425234, 0.25419748, 0.25414252, 0.25408751, 0.25403243, 0.25397733, 0.25392213, 0.25386691, 0.2538116, 0.25375623, 0.25370076, 0.25364527, 0.25358972, 0.25353411, 0.25347844, 0.25342271, 0.25336695, 0.25331107, 0.25325519, 0.25319919, 0.25314319, 0.25308707, 0.25303093, 0.25297472, 0.25291845, 0.25286213, 0.25280571, 0.25274926, 0.25269276, 0.25263616, 0.25257951, 0.25252283, 0.25246608, 0.25240925, 0.25235239, 0.25229546, 0.25223845, 0.25218141, 0.25212431, 0.25206709, 0.25200987, 0.25195256, 0.25189519, 0.25183779, 0.2517803, 0.25172278, 0.25166517, 0.25160751, 0.25154981, 0.25149202, 0.25143421, 0.2513763, 0.25131834, 0.25126031, 0.25120223, 0.25114408, 0.25108591, 0.25102761, 0.25096929, 0.25091091, 0.25085247, 0.25079396, 0.2507354, 0.25067678, 0.2506181, 0.25055936, 0.25050053, 0.2504417, 0.25038275, 0.25032377, 0.25026473, 0.25020561, 0.25014648, 0.25008726, 0.25002795, 0.2499686, 0.24990918, 0.24984974, 0.24979019, 0.2497306, 0.24967097, 0.24961126, 0.24955148, 0.24949166, 0.24943176, 0.24937181, 0.24931182, 0.24925175, 0.24919161, 0.24913143, 0.24907117, 0.24901086, 0.2489505, 0.24889006, 0.24882956, 0.24876903, 0.2487084, 0.24864775, 0.248587, 0.2485262, 0.24846536, 0.24840446, 0.24834347, 0.24828243, 0.24822134, 0.2481602, 0.24809897, 0.2480377, 0.24797636, 0.24791497, 0.24785352, 0.24779199, 0.2477304, 0.24766879, 0.24760708, 0.24754533, 0.24748351, 0.24742162, 0.24735971, 0.2472977, 0.24723564, 0.24717352, 0.24711135, 0.24704911, 0.24698681, 0.24692443, 0.24686202, 0.24679954, 0.246737, 0.24667442, 0.24661174, 0.24654901, 0.24648623, 0.24642339, 0.2463605, 0.24629754, 0.24623451, 0.24617143, 0.24610829, 0.24604508, 0.24598181, 0.2459185, 0.24585512, 0.24579167, 0.24572815, 0.2456646, 0.24560097, 0.24553728, 0.24547355, 0.24540974, 0.24534586, 0.24528195, 0.24521795, 0.2451539, 0.2450898, 0.24502563, 0.24496141, 0.24489713, 0.24483277, 0.24476835, 0.2447039, 0.24463937, 0.24457477, 0.24451011, 0.24444541, 0.24438065, 0.2443158, 0.24425094, 0.24418595, 0.24412097, 0.24405588, 0.24399075, 0.24392557, 0.24386032, 0.24379499, 0.24372964, 0.24366421, 0.24359871, 0.24353315, 0.24346754, 0.24340186, 0.24333614, 0.24327032, 0.24320449, 0.24313857, 0.24307258, 0.24300656, 0.24294046, 0.24287429, 0.24280809, 0.24274181, 0.24267548, 0.24260908, 0.24254261, 0.24247611, 0.24240953, 0.24234287, 0.24227619, 0.24220943, 0.2421426, 0.24207573, 0.24200879, 0.24194179, 0.24187472, 0.24180761, 0.24174042, 0.24167319, 0.24160589, 0.24153851, 0.2414711, 0.24140361, 0.24133608, 0.24126849, 0.2412008, 0.24113308, 0.24106529, 0.24099748, 0.24092954, 0.24086159, 0.24079356, 0.2407255, 0.24065734, 0.24058913, 0.24052088, 0.24045254, 0.24038418, 0.24031574, 0.24024722, 0.24017863, 0.24011001, 0.24004132, 0.23997256, 0.23990378, 0.2398349, 0.23976599, 0.23969698, 0.23962794, 0.23955882, 0.23948966, 0.23942043, 0.23935114, 0.2392818, 0.23921238, 0.23914291, 0.23907338, 0.23900378, 0.23893414, 0.23886444, 0.23879465, 0.23872483, 0.23865493, 0.23858498, 0.23851496, 0.23844488, 0.23837475, 0.23830456, 0.2382343, 0.23816398, 0.23809363, 0.23802318, 0.23795268, 0.23788214, 0.23781152, 0.23774084, 0.23767011, 0.23759931, 0.23752846, 0.23745754, 0.23738655, 0.23731551, 0.23724443, 0.23717326, 0.23710206, 0.23703077, 0.23695943, 0.23688805, 0.23681659, 0.23674506, 0.23667347, 0.23660183, 0.23653014, 0.23645836, 0.23638655, 0.23631467, 0.23624273, 0.23617074, 0.23609868, 0.23602656, 0.23595437, 0.23588212, 0.23580982, 0.23573746, 0.23566502, 0.23559254, 0.23552001, 0.23544741, 0.23537472, 0.23530202, 0.23522922, 0.23515637, 0.23508346, 0.2350105, 0.23493747, 0.23486438, 0.23479125, 0.23471804, 0.23464479, 0.23457146, 0.23449807, 0.23442461, 0.2343511, 0.23427753, 0.2342039, 0.23413022, 0.23405646, 0.23398265, 0.23390879, 0.23383486, 0.23376086, 0.23368683, 0.2336127, 0.23353854, 0.2334643, 0.23339002, 0.23331568, 0.23324126, 0.23316678, 0.23309225, 0.23301764, 0.232943, 0.2328683, 0.23279351, 0.23271868, 0.23264378, 0.23256883, 0.2324938, 0.23241873, 0.2323436, 0.23226842, 0.23219316, 0.23211785, 0.23204246, 0.23196703, 0.23189154, 0.23181598, 0.23174036, 0.23166467, 0.23158894, 0.23151313, 0.2314373, 0.23136136, 0.23128335, 0.23120327, 0.23112318, 0.23104307, 0.23096295, 0.23088279, 0.23080263, 0.23072246, 0.23064224, 0.23056202, 0.23048179, 0.23040153, 0.23032124, 0.23024096, 0.23016065, 0.23008032, 0.22999997, 0.2299196, 0.22983922, 0.22975883, 0.22967841, 0.22959797, 0.22951753, 0.22943704, 0.22935654, 0.22927605, 0.22919551, 0.22911498, 0.22903441, 0.22895382, 0.22887321, 0.22879261, 0.22871196, 0.22863132, 0.22855063, 0.22846997, 0.22838923, 0.22830851, 0.22822776, 0.22814701, 0.22806624, 0.22798544, 0.2279046, 0.22782378, 0.22774293, 0.22766206, 0.22758116, 0.22750024, 0.22741935, 0.22733837, 0.22725745, 0.22717644, 0.22709545, 0.22701444, 0.22693342, 0.22685236, 0.22677128, 0.22669019, 0.22660911, 0.22652796, 0.22644682, 0.22636566, 0.22628449, 0.22620329, 0.22612208, 0.22604083, 0.22595958, 0.22587831, 0.22579703, 0.22571573, 0.2256344, 0.22555308, 0.22547169, 0.22539032, 0.22530892, 0.22522752, 0.22514609, 0.22506462, 0.22498317, 0.22490168, 0.22482018, 0.22473867, 0.2246571, 0.22457555, 0.224494, 0.2244124, 0.22433077, 0.22424914, 0.2241675, 0.22408584, 0.22400415, 0.22392246, 0.22384073, 0.22375898, 0.22367723, 0.22359546, 0.22351366, 0.22343186, 0.22335002, 0.22326817, 0.22318631, 0.22310442, 0.22302251, 0.22294059, 0.22285865, 0.2227767, 0.22269474, 0.22261274, 0.22253072, 0.22244872, 0.22236666, 0.22228459, 0.22220251, 0.2221204, 0.22203828, 0.22195615, 0.22187401, 0.22179182, 0.22170962, 0.2216274, 0.22154519, 0.22146294, 0.22138068, 0.22129841, 0.22121611, 0.22113378, 0.22105145, 0.22096911, 0.22088672, 0.22080435, 0.22072193, 0.22063951, 0.22055706, 0.22047459, 0.22039212, 0.22030963, 0.22022711, 0.22014457, 0.220062, 0.21997945, 0.21989688, 0.21981424, 0.21973163, 0.21964897, 0.21956635, 0.21948364, 0.21940096, 0.21931824, 0.21923549, 0.21915276, 0.21906999, 0.2189872, 0.21890438, 0.21882157, 0.21873872, 0.21865585, 0.21857299, 0.21849009, 0.21840718, 0.21832423, 0.21824129, 0.21815832, 0.21807532, 0.21799235, 0.21790931, 0.21782628, 0.21774319, 0.21766014, 0.21757703, 0.21749394, 0.21741079, 0.21732767, 0.21724448, 0.21716128, 0.21707809, 0.21699487, 0.21691161, 0.21682836, 0.21674509, 0.21666181, 0.2165785, 0.21649517, 0.21641183, 0.21632846, 0.21624506, 0.21616167, 0.21607824, 0.21599481, 0.21591136, 0.21582787, 0.21574436, 0.21566087, 0.21557733, 0.2154938, 0.21541022, 0.21532665, 0.21524304, 0.21515943, 0.21507581, 0.21499212, 0.21490845, 0.21482478, 0.21474107, 0.21465732, 0.21457358, 0.21448982, 0.21440604, 0.21432224, 0.21423844, 0.21415459, 0.21407074, 0.21398684, 0.21390297, 0.21381906, 0.21373513, 0.21365118, 0.21356723, 0.21348324, 0.21339926, 0.21331523, 0.21323119, 0.21314715, 0.21306306, 0.21297899, 0.21289489, 0.21281075, 0.21272659, 0.21264243, 0.21255827, 0.21247406, 0.21238986, 0.21230562, 0.21222135, 0.21213709, 0.21205281, 0.2119685, 0.2118842, 0.21179983, 0.21171549, 0.21163109, 0.2115467, 0.21146229, 0.21137784, 0.2112934, 0.21120894, 0.21112446, 0.21103992, 0.21095541, 0.21087088, 0.21078633, 0.21070175, 0.21061714, 0.21053253, 0.21044791, 0.21036325, 0.21027859, 0.21019389, 0.21010919, 0.21002448, 0.20993973, 0.20985498, 0.20977019, 0.20968542, 0.20960058, 0.20951577, 0.20943092, 0.20934604, 0.20926118, 0.20917624, 0.20909132, 0.2090064, 0.20892145, 0.20883645, 0.20875147, 0.20866646, 0.20858143, 0.20849638, 0.20841131, 0.20832625, 0.20824112, 0.20815602, 0.20807089, 0.20798573, 0.20790054, 0.20781535, 0.20773016, 0.20764492, 0.20755966, 0.20747441, 0.20738913, 0.20730384, 0.2072185, 0.20713316, 0.20704782, 0.20696244, 0.20687705, 0.20679164, 0.20670621, 0.20662077, 0.20653531, 0.20644984, 0.20636433, 0.20627882, 0.20619327, 0.20610772, 0.20602214, 0.20593657, 0.20585094, 0.20576532, 0.20567968, 0.20559402, 0.20550834, 0.20542265, 0.20533693, 0.20525119, 0.20516545, 0.20507966, 0.20499387, 0.20490807, 0.20482226, 0.2047364, 0.20465054, 0.20456468, 0.20447876, 0.20439285, 0.20430692, 0.20422097, 0.20413499, 0.20404902, 0.203963, 0.20387699, 0.20379093, 0.20370486, 0.20361881, 0.20353271, 0.20344658, 0.20336044, 0.20327431, 0.20318814, 0.20310196, 0.20301574, 0.20292951, 0.20284331, 0.20275703, 0.20267075, 0.20258446, 0.20249812, 0.20241182, 0.20232546, 0.2022391, 0.20215271, 0.20206629, 0.20197988, 0.20189346, 0.20180698, 0.20172052, 0.201634, 0.20154752, 0.20146097, 0.20137443, 0.20128787, 0.20120129, 0.20111468, 0.20102806, 0.20094141, 0.20085476, 0.20076808, 0.20068139, 0.20059468, 0.20050795, 0.20042121, 0.20033444, 0.20024765, 0.20016086, 0.20007402, 0.1999872, 0.19990034, 0.19981347, 0.19972658, 0.19963966, 0.19955276, 0.1994658, 0.19937885, 0.19929184, 0.19920486, 0.19911784, 0.1990308, 0.19894375, 0.19885668, 0.19876957, 0.19868246, 0.19859536, 0.1985082, 0.19842103, 0.19833386, 0.19824667, 0.19815944, 0.19807221, 0.19798495, 0.19789769, 0.1978104, 0.19772309, 0.19763577, 0.19754842, 0.19746107, 0.19737367, 0.19728629, 0.19719887, 0.19711144, 0.19702397, 0.1969365, 0.19684903, 0.19676152, 0.19667399, 0.19658644, 0.19649889, 0.19641131, 0.19632372, 0.1962361, 0.19614846, 0.19606081, 0.19597314, 0.19588546, 0.19579777, 0.19571003, 0.19562228, 0.19553453, 0.19544676, 0.19535896, 0.19527113, 0.19518332, 0.19509546, 0.19500761, 0.19491972, 0.1948318, 0.19474389, 0.19465595, 0.19456799, 0.19448003, 0.19439203, 0.194304, 0.19421598, 0.19412793, 0.19403987, 0.19395177, 0.19386367, 0.19377556, 0.19368741, 0.19359925, 0.19351107, 0.19342288, 0.19333467, 0.19324645, 0.19315819, 0.19306992, 0.19298166, 0.19289333, 0.19280502, 0.1927167, 0.19262832, 0.19253998, 0.19245158, 0.19236314, 0.19227472, 0.1921863, 0.19209783, 0.19200933, 0.19192085, 0.1918323, 0.19174378, 0.19165525, 0.19156666, 0.19147806, 0.19138946, 0.19130082, 0.19121219, 0.1911235, 0.19103482, 0.19094615, 0.19085743, 0.19076869, 0.19067994, 0.19059116, 0.19050236, 0.19041355, 0.19032474, 0.1902359, 0.19014701, 0.19005814, 0.18996926, 0.18988036, 0.1897914, 0.18970245, 0.18961348, 0.18952449, 0.18943548, 0.18934645, 0.1892574, 0.18916835, 0.18907928, 0.18899018, 0.18890107, 0.18881194, 0.18872277, 0.18863362, 0.18854442, 0.18845522, 0.188366, 0.18827675, 0.18818749, 0.18809822, 0.1880089, 0.18791962, 0.18783028, 0.18774092, 0.18765156, 0.18756217, 0.18747276, 0.18738334, 0.18729389, 0.18720444, 0.18711495, 0.18702547, 0.18693595, 0.18684644, 0.18675688, 0.18666731, 0.18657774, 0.18648812, 0.18639851, 0.18630886, 0.1862192, 0.18612953, 0.18603984, 0.18595012, 0.1858604, 0.18577065, 0.1856809, 0.18559109, 0.18550131, 0.18541148, 0.18532164, 0.18523178, 0.18514191, 0.18505201, 0.18496209, 0.18487217, 0.18478222, 0.18469226, 0.18460229, 0.18451226, 0.18442225, 0.18433222, 0.18424216, 0.1841521, 0.184062, 0.1839719, 0.18388176, 0.18379162, 0.18370144, 0.18361127, 0.18352108, 0.18343084, 0.18334061, 0.18325037, 0.1831601, 0.1830698, 0.18297949, 0.18288918, 0.18279882, 0.18270847, 0.18261807, 0.18252768, 0.18243726, 0.18234682, 0.18225637, 0.18216591, 0.18207541, 0.18198492, 0.18189438, 0.18180384, 0.18171327, 0.18162271, 0.1815321, 0.18144149, 0.18135084, 0.18126018, 0.18116952, 0.18107884, 0.18098815, 0.18089738, 0.18080667, 0.18071589, 0.18062514, 0.18053433, 0.18044353, 0.18035267, 0.18026182, 0.18017097, 0.18008007, 0.17998917, 0.17989826, 0.17980729, 0.17971635, 0.17962538, 0.17953438, 0.17944336, 0.17935234, 0.17926128, 0.17917019, 0.17907913, 0.17898804, 0.1788969, 0.17880577, 0.1787146, 0.17862342, 0.17853223, 0.17844102, 0.17834979, 0.17825854, 0.17816728, 0.17807598, 0.1779847, 0.17789336, 0.17780201, 0.17771068, 0.17761929, 0.17752789, 0.17743647, 0.17734507, 0.17725362, 0.17716216, 0.17707066, 0.17697917, 0.17688765, 0.17679609, 0.17670456, 0.17661299, 0.17652138, 0.17642978, 0.17633817, 0.17624651, 0.17615482, 0.17606317, 0.17597146, 0.17587975, 0.175788, 0.17569624, 0.17560446, 0.17551269, 0.17542087, 0.17532903, 0.17523721, 0.17514534, 0.17505345, 0.17496155, 0.17486963, 0.17477769, 0.17468575, 0.17459378, 0.17450179, 0.17440978, 0.17431776, 0.17422572, 0.17413364, 0.17404157, 0.17394948, 0.17385733, 0.17376523, 0.17367306, 0.17358088, 0.17348871, 0.1733965, 0.17330426, 0.17321205, 0.17311977, 0.1730275, 0.1729352, 0.17284289, 0.17275052, 0.17265819, 0.17256583, 0.17247345, 0.17238103, 0.1722886, 0.17219616, 0.1721037, 0.17201123, 0.17191873, 0.17182621, 0.17173368, 0.17164114, 0.17154858, 0.17145598, 0.17136337, 0.17127074, 0.17117812, 0.17108546, 0.17099278, 0.17090006, 0.17080738, 0.17071465, 0.17062189, 0.17052911, 0.17043634, 0.17034352, 0.17025073, 0.17015786, 0.17006502, 0.16997214, 0.16987924, 0.16978633, 0.16969341, 0.16960046, 0.16950749, 0.16941451, 0.16932151, 0.16922848, 0.16913544, 0.16904238, 0.16894931, 0.16885622, 0.1687631, 0.16866997, 0.16857685, 0.16848369, 0.16839048, 0.16829729, 0.16820405, 0.16811082, 0.16801755, 0.16792428, 0.16783102, 0.16773769, 0.16764437, 0.16755103, 0.16745766, 0.16736428, 0.16727087, 0.16717744, 0.16708402, 0.16699056, 0.1668971, 0.16680361, 0.16671011, 0.16661656, 0.16652304, 0.16642947, 0.1663359, 0.16624229, 0.16614868, 0.16605504, 0.16596138, 0.1658677, 0.16577402, 0.16568032, 0.16558659, 0.16549285, 0.16539907, 0.16530532, 0.1652115, 0.1651177, 0.16502386, 0.16493002, 0.16483614, 0.16474225, 0.16464834, 0.16455442, 0.16446048, 0.1643665, 0.16427255, 0.16417855, 0.16408452, 0.16399048, 0.16389644, 0.16380236, 0.16370827, 0.16361417, 0.16352005, 0.16342592, 0.16333176, 0.16323759, 0.1631434, 0.16304918, 0.16295493, 0.16286071, 0.16276641, 0.16267212, 0.16257784, 0.16248351, 0.16238917, 0.16229481, 0.16220044, 0.16210604, 0.16201164, 0.16191719, 0.16182275, 0.16172829, 0.16163379, 0.16153929, 0.16144477, 0.16135022, 0.16125567, 0.16116109, 0.16106652, 0.16097189, 0.16087729, 0.16078261, 0.16068797, 0.16059327, 0.16049859, 0.16040385, 0.16030911, 0.16021435, 0.16011958, 0.16002481, 0.15992998, 0.15983514, 0.1597403, 0.15964544, 0.15955056, 0.15945566, 0.15936074, 0.15926582, 0.15917087, 0.15907587, 0.15898089, 0.15888588, 0.15879086, 0.1586958, 0.15860075, 0.15850566, 0.15841058, 0.15831545, 0.15822034, 0.15812513, 0.15802999, 0.15793478, 0.1578396, 0.15774435, 0.15764911, 0.15755385, 0.15745859, 0.15736327, 0.15726796, 0.15717264, 0.15707728, 0.1569819, 0.15688652, 0.15679109, 0.15669569, 0.15660022, 0.15650479, 0.15640929, 0.15631381, 0.15621828, 0.15612276, 0.1560272, 0.15593162, 0.15583603, 0.15574044, 0.15564482, 0.15554918, 0.15545352, 0.15535784, 0.15526214, 0.15516642, 0.15507071, 0.15497494, 0.15487917, 0.15478338, 0.15468758, 0.15459175, 0.15449591, 0.15440005, 0.15430416, 0.1542083, 0.15411237, 0.15401644, 0.15392052, 0.15382452, 0.15372854, 0.15363254, 0.15353653, 0.15344049, 0.15334444, 0.15324837, 0.15315226, 0.15305614, 0.15296002, 0.15286386, 0.1527677, 0.1526715, 0.15257531, 0.1524791, 0.15238284, 0.15228659, 0.15219033, 0.15209404, 0.15199773, 0.15190139, 0.15180504, 0.15170869, 0.1516123, 0.15151589, 0.15141948, 0.15132304, 0.15122658, 0.15113011, 0.15103363, 0.1509371, 0.15084058, 0.15074404, 0.15064746, 0.1505509, 0.15045428, 0.15035766, 0.15026103, 0.15016438, 0.15006772, 0.14997102, 0.14987431, 0.14977758, 0.14968085, 0.14958407, 0.1494873, 0.1493905, 0.14929368, 0.14919685, 0.14909998, 0.14900313, 0.14890623, 0.14880933, 0.1487124, 0.14861545, 0.14851849, 0.14842151, 0.14832452, 0.14822748, 0.14813045, 0.14803343, 0.14793636, 0.14783926, 0.14774215, 0.14764503, 0.14754789, 0.14745073, 0.14735354, 0.14725634, 0.14715914, 0.1470619, 0.14696465, 0.14686739, 0.14677007, 0.14667279, 0.14657547, 0.14647812, 0.14638074, 0.1462834, 0.14618599, 0.14608857, 0.14599115, 0.14589372, 0.14579624, 0.14569876, 0.14560124, 0.14550373, 0.14540617, 0.14530863, 0.14521106, 0.14511344, 0.14501584, 0.1449182, 0.14482057, 0.14472289, 0.1446252, 0.14452751, 0.14442979, 0.14433205, 0.14423428, 0.14413652, 0.14403874, 0.14394091, 0.14384307, 0.14374523, 0.14364736, 0.14354949, 0.14345159, 0.14335366, 0.14325573, 0.14315775, 0.14305981, 0.1429618, 0.14286378, 0.14276576, 0.14266771, 0.14256966, 0.14247157, 0.14237346, 0.14227536, 0.14218138, 0.14209162, 0.14200185, 0.1419121, 0.14182238, 0.14173265, 0.14164297, 0.14155327, 0.14146361, 0.14137396, 0.14128432, 0.1411947, 0.14110509, 0.1410155, 0.14092591, 0.14083636, 0.14074682, 0.14065731, 0.14056778, 0.14047828, 0.14038879, 0.14029931, 0.14020988, 0.14012043, 0.14003102, 0.1399416, 0.13985223, 0.13976285, 0.1396735, 0.13958415, 0.13949482, 0.1394055, 0.13931623, 0.13922696, 0.13913769, 0.13904843, 0.1389592, 0.13886999, 0.13878077, 0.1386916, 0.13860241, 0.13851327, 0.13842413, 0.13833499, 0.13824591, 0.1381568, 0.13806772, 0.13797867, 0.13788962, 0.13780059, 0.13771157, 0.13762257, 0.13753359, 0.13744462, 0.13735567, 0.13726674, 0.13717781, 0.13708891, 0.13700002, 0.13691114, 0.13682228, 0.13673343, 0.1366446, 0.13655579, 0.13646699, 0.13637823, 0.13628946, 0.1362007, 0.13611197, 0.13602324, 0.13593455, 0.13584585, 0.13575719, 0.13566853, 0.13557987, 0.13549127, 0.13540265, 0.13531406, 0.13522549, 0.1351369, 0.13504837, 0.13495985, 0.13487132, 0.13478281, 0.13469434, 0.13460587, 0.1345174, 0.13442898, 0.13434055, 0.13425215, 0.13416375, 0.13407537, 0.13398701, 0.13389866, 0.13381034, 0.13372204, 0.13363372, 0.13354544, 0.13345718, 0.13336892, 0.13328069, 0.13319248, 0.13310425, 0.13301608, 0.13292789, 0.13283975, 0.1327516, 0.13266347, 0.13257538, 0.13248727, 0.13239919, 0.13231111, 0.13222308, 0.13213503, 0.13204703, 0.13195902, 0.13187104, 0.13178307, 0.13169511, 0.13160716, 0.13151924, 0.13143133, 0.13134342, 0.13125557, 0.13116769, 0.13107984, 0.13099203, 0.1309042, 0.1308164, 0.13072862, 0.13064086, 0.1305531, 0.13046536, 0.13037764, 0.13028993, 0.13020223, 0.13011457, 0.13002691, 0.12993927, 0.12985164, 0.12976401, 0.12967643, 0.12958884, 0.12950128, 0.12941371, 0.12932619, 0.12923867, 0.12915117, 0.12906368, 0.1289762, 0.12888874, 0.1288013, 0.12871388, 0.12862647, 0.12853907, 0.12845169, 0.12836434, 0.12827699, 0.12818964, 0.12810233, 0.12801503, 0.12792775, 0.12784046, 0.12775321, 0.12766598, 0.12757874, 0.12749155, 0.12740436, 0.12731718, 0.12723, 0.12714288, 0.12705575, 0.12696862, 0.12688151, 0.12679444, 0.12670738, 0.12662034, 0.12653327, 0.12644625, 0.12635927, 0.12627226, 0.1261853, 0.12609833, 0.12601139, 0.12592445, 0.12583755, 0.12575065, 0.12566377, 0.1255769, 0.12549007, 0.12540323, 0.1253164, 0.1252296, 0.12514281, 0.12505604, 0.12496927, 0.12488253, 0.12479582, 0.1247091, 0.12462242, 0.12453574, 0.12444907, 0.12436242, 0.12427579, 0.12418918, 0.12410258, 0.12401599, 0.12392943, 0.12384287, 0.12375633, 0.12366982, 0.12358329, 0.1234968, 0.12341033, 0.12332389, 0.12323742, 0.123151, 0.12306457, 0.12297819, 0.12289179, 0.12280543, 0.12271909, 0.12263276, 0.12254643, 0.12246011, 0.12237384, 0.12228754, 0.1222013, 0.12211506, 0.12202883, 0.12194261, 0.12185642, 0.12177025, 0.12168407, 0.12159792, 0.12151179, 0.12142568, 0.12133958, 0.12125349, 0.12116741, 0.12108137, 0.12099532, 0.1209093, 0.1208233, 0.12073729, 0.12065133, 0.12056536, 0.12047941, 0.12039348, 0.12030756, 0.12022167, 0.12013578, 0.12004991, 0.11996406, 0.11987822, 0.1197924, 0.11970659, 0.11962079, 0.11953503, 0.11944927, 0.11936352, 0.11927779, 0.11919208, 0.11910639, 0.11902069, 0.11893504, 0.11884939, 0.11876375, 0.11867813, 0.11859254, 0.11850694, 0.11842137, 0.11833581, 0.11825027, 0.11816475, 0.11807923, 0.11799373, 0.11790825, 0.1178228, 0.11773735, 0.11765192, 0.1175665, 0.11748109, 0.11739571, 0.11731034, 0.11722498, 0.11713965, 0.11705432, 0.11696901, 0.11688372, 0.11679844, 0.11671319, 0.11662793, 0.11654271, 0.1164575, 0.11637229, 0.11628711, 0.11620194, 0.11611679, 0.11603165, 0.11594653, 0.11586144, 0.11577634, 0.11569127, 0.1156062, 0.11552115, 0.11543614, 0.11535111, 0.11526613, 0.11518115, 0.11509617, 0.11501123, 0.1149263, 0.11484138, 0.11475647, 0.11467159, 0.11458673, 0.11450185, 0.11441702, 0.11433218, 0.11424738, 0.11416259, 0.11407781, 0.11399305, 0.11390831, 0.11382356, 0.11373886, 0.11365415, 0.11356945, 0.11348481, 0.11340015, 0.11331552, 0.11323088, 0.11314628, 0.11306168, 0.1129771, 0.11289255, 0.11280801, 0.11272347, 0.11263897, 0.11255446, 0.11246999, 0.11238552, 0.11230105, 0.11221662, 0.11213221, 0.1120478, 0.11196341, 0.11187903, 0.1117947, 0.11171033, 0.111626, 0.1115417, 0.11145741, 0.11137312, 0.11128887, 0.1112046, 0.11112038, 0.11103615, 0.11095197, 0.11086778, 0.11078359, 0.11069944, 0.11061531, 0.1105312, 0.11044707, 0.11036298, 0.1102789, 0.11019483, 0.1101108, 0.11002676, 0.10994273, 0.10985874, 0.10977477, 0.1096908, 0.10960685, 0.1095229, 0.10943899, 0.10935508, 0.10927118, 0.10918731, 0.10910346, 0.10901961, 0.10893577, 0.10885197, 0.10876817, 0.10868438, 0.10860062, 0.10851688, 0.10843313, 0.10834941, 0.10826571, 0.10818203, 0.10809835, 0.10801469, 0.10793106, 0.10784742, 0.10776383, 0.10768023, 0.10759665, 0.10751309, 0.10742953, 0.107346, 0.10726249, 0.10717898, 0.1070955, 0.10701203, 0.10692859, 0.10684514, 0.10676171, 0.10667831, 0.10659491, 0.10651154, 0.10642819, 0.10634483, 0.1062615, 0.10617818, 0.10609487, 0.10601161, 0.10592833, 0.10584509, 0.10576184, 0.10567862, 0.10559542, 0.10551224, 0.10542906, 0.1053459, 0.10526274, 0.10517963, 0.1050965, 0.10501342, 0.10493033, 0.10484727, 0.10476422, 0.10468119, 0.10459818, 0.10451517, 0.10443217, 0.1043492, 0.10426626, 0.10418332, 0.10410038, 0.10401747, 0.10393459, 0.10385171, 0.10376885, 0.103686, 0.10360316, 0.10352036, 0.10343754, 0.10335477, 0.103272, 0.10318924, 0.10310651, 0.10302378, 0.10294107, 0.10285838, 0.10277571, 0.10269304, 0.1026104, 0.10252777, 0.10244516, 0.10236256, 0.10227998, 0.10219743, 0.10211486, 0.10203233, 0.1019498, 0.10186731, 0.10178481, 0.10170233, 0.10161989, 0.10153744, 0.10145503, 0.1013726, 0.1012902, 0.10120783, 0.10112546, 0.10104311, 0.10096079, 0.10087846, 0.10079616, 0.10071389, 0.10063159, 0.10054936, 0.1004671, 0.10038489, 0.10030267, 0.10022047, 0.10013831, 0.10005614, 0.099974014, 0.099891864, 0.099809743, 0.099727653, 0.099645577, 0.099563494, 0.099481456, 0.09939941, 0.099317387, 0.099235378, 0.099153399, 0.099071406, 0.098989449, 0.098907523, 0.098825596, 0.098743677, 0.098661773, 0.098579906, 0.098498024, 0.098416179, 0.098334342, 0.098252527, 0.098170713, 0.098088935, 0.098007172, 0.097925417, 0.097843654, 0.097761944, 0.097680233, 0.09759853, 0.09751685, 0.097435199, 0.09735354, 0.097271912, 0.097190291, 0.097108692, 0.097027108, 0.096945532, 0.096863985, 0.096782438, 0.096700914, 0.096619412, 0.096537918, 0.096456446, 0.096374989, 0.096293531, 0.096212119, 0.096130691, 0.096049301, 0.095967911, 0.095886543, 0.095805198, 0.09572386, 0.095642544, 0.095561229, 0.095479935, 0.095398672, 0.095317416, 0.095236167, 0.095154949, 0.095073737, 0.094992541, 0.094911344, 0.094830178, 0.094749041, 0.094667904, 0.094586797, 0.09450569, 0.094424598, 0.094343521, 0.094262466, 0.094181433, 0.094100408, 0.094019391, 0.093938403, 0.093857415, 0.093776464, 0.093695514, 0.093614578, 0.09353368, 0.093452767, 0.093371883, 0.093291014, 0.093210153, 0.093129322, 0.093048491, 0.092967704, 0.092886902, 0.092806123, 0.092725359, 0.092644617, 0.09256389, 0.092483178, 0.092402473, 0.092321798, 0.092241131, 0.092160471, 0.092079848, 0.091999225, 0.091918625, 0.091838032, 0.091757447, 0.091676906, 0.091596358, 0.091515839, 0.091435313, 0.091354817, 0.091274358, 0.091193885, 0.091113426, 0.091033004, 0.090952583, 0.090872183, 0.090791792, 0.09071143, 0.090631068, 0.090550728, 0.090470411, 0.090390101, 0.090309814, 0.090229534, 0.090149261, 0.090069026, 0.089988783, 0.089908578, 0.089828379, 0.089748189, 0.089668036, 0.089587875, 0.089507736, 0.08942762, 0.089347504, 0.089267425, 0.089187339, 0.089107282, 0.089027233, 0.088947207, 0.08886721, 0.088787206, 0.088707224, 0.088627264, 0.088547304, 0.088467374, 0.088387452, 0.088307552, 0.088227659, 0.088147782, 0.088067941, 0.087988093, 0.087908253, 0.08782845, 0.087748669, 0.087668888, 0.087589122, 0.087509379, 0.087429643, 0.087349921, 0.08727023, 0.087190554, 0.087110862, 0.087031215, 0.086951584, 0.086871952, 0.08679235, 0.086712755, 0.086633168, 0.086553603, 0.086474061, 0.086394548, 0.086315021, 0.086235546, 0.086156048, 0.086076573, 0.085997127, 0.085917696, 0.085838281, 0.085758872, 0.085679471, 0.085600108, 0.085520737, 0.085441403, 0.085362084, 0.085282765, 0.085203476, 0.08512418, 0.085044928, 0.084965669, 0.084886447, 0.084807225, 0.08472801, 0.084648848, 0.084569663, 0.084490508, 0.084411368, 0.084332243, 0.084253132, 0.084174044, 0.084094957, 0.084015906, 0.083936848, 0.083857819, 0.083778813, 0.0836998, 0.083620831, 0.083541855, 0.083462901, 0.083383963, 0.083305039, 0.083226129, 0.083147243, 0.083068356, 0.082989506, 0.082910649, 0.082831837, 0.082753025, 0.082674205, 0.082595453, 0.08251667, 0.082437932, 0.082359187, 0.082280472, 0.082201779, 0.082123071, 0.0820444, 0.081965759, 0.081887096, 0.081808478, 0.081729874, 0.081651263, 0.081572697, 0.081494115, 0.081415586, 0.08133705, 0.081258513, 0.081180029, 0.081101537, 0.081023082, 0.080944613, 0.080866173, 0.080787756, 0.080709338, 0.080630966, 0.080552578, 0.080474205, 0.08039587, 0.080317535, 0.080239236, 0.080160931, 0.080082633, 0.080004379, 0.079926118, 0.079847887, 0.079769656, 0.079691447, 0.079613253, 0.079535097, 0.07945694, 0.079378784, 0.079300657, 0.079222545, 0.079144448, 0.079066366, 0.078988306, 0.078910261, 0.078832224, 0.078754202, 0.078676201, 0.078598216, 0.078520238, 0.078442283, 0.078364342, 0.078286409, 0.078208514, 0.078130595, 0.078052752, 0.077974878, 0.07789702, 0.077819191, 0.07774137, 0.077663586, 0.077585779, 0.077508017, 0.077430263, 0.077352531, 0.077274814, 0.077197097, 0.077119403, 0.077041723, 0.076964065, 0.07688643, 0.076808788, 0.076731175, 0.076653592, 0.076575994, 0.076498426, 0.076420881, 0.07634335, 0.076265834, 0.076188318, 0.076110832, 0.076033369, 0.075955905, 0.075878456, 0.075801045, 0.075723611, 0.075646237, 0.07556884, 0.075491495, 0.075414136, 0.075336792, 0.075259484, 0.07518217, 0.0751049, 0.075027607, 0.07495036, 0.074873127, 0.074795887, 0.074718699, 0.074641496, 0.074564308, 0.074487157, 0.074410006, 0.074332885, 0.074255757, 0.074178666, 0.074101582, 0.074024513, 0.073947452, 0.073870413, 0.073793389, 0.073716395, 0.073639393, 0.073562436, 0.073485471, 0.073408529, 0.073331602, 0.07325469, 0.07317777, 0.073100902, 0.073024042, 0.072947197, 0.072870359, 0.072793521, 0.072716728, 0.072639927, 0.072563171, 0.072486416, 0.072409667, 0.072332948, 0.072256222, 0.072179541, 0.07210286, 0.072026186, 0.071949542, 0.071872912, 0.071796305, 0.071719691, 0.071643099, 0.071566537, 0.071489975, 0.071413442, 0.071336918, 0.071260408, 0.071183912, 0.07110744, 0.071030974, 0.070954546, 0.070878103, 0.070801698, 0.070725292, 0.070648916, 0.070572533, 0.070496202, 0.070419855, 0.070343532, 0.070267215, 0.070190944, 0.07011465, 0.070038408, 0.069962166, 0.069885924, 0.069809727, 0.069733515, 0.069657356, 0.069581173, 0.069505021, 0.069428876, 0.069352768, 0.069276683, 0.069200575, 0.069124512, 0.069048457, 0.068972409, 0.068896383, 0.06882038, 0.068744384, 0.06866841, 0.068592444, 0.068516493, 0.068440564, 0.06836465, 0.068288751, 0.068212867, 0.068137005, 0.068061143, 0.067985304, 0.067909479, 0.067833669, 0.067757875, 0.06768211, 0.067606352, 0.067530602, 0.067454882, 0.067379139, 0.067303464, 0.067227758, 0.067152113, 0.06707646, 0.067000814, 0.066925213, 0.066849589, 0.066774018, 0.066698425, 0.066622868, 0.066547334, 0.0664718, 0.066396296, 0.066320799, 0.066245325, 0.066169858, 0.066094406, 0.066018969, 0.065943561, 0.065868154, 0.065792777, 0.065717399, 0.065642044, 0.065566704, 0.065491378, 0.065416075, 0.06534078, 0.065265492, 0.065190241, 0.06511499, 0.065039761, 0.064964555, 0.064889334, 0.064814158, 0.064738989, 0.064663842, 0.064588688, 0.064513572, 0.064438485, 0.064363375, 0.064288311, 0.064213239, 0.064138196, 0.064063177, 0.063988164, 0.063913167, 0.063838191, 0.063763224, 0.063688271, 0.063613333, 0.063538417, 0.063463517, 0.063388616, 0.063313745, 0.063238889, 0.063164048, 0.063089229, 0.063014418, 0.062939622, 0.06286484, 0.062790081, 0.062715329, 0.062640592, 0.062565878, 0.062491179, 0.062416483, 0.062341828, 0.062267154, 0.062192541, 0.062117908, 0.062043283, 0.061968721, 0.061894126, 0.061819572, 0.061745018, 0.061670493, 0.061595973, 0.061521471, 0.061446998, 0.061372522, 0.061298069, 0.061223641, 0.06114921, 0.061074812, 0.061000422, 0.06092605, 0.060851686, 0.06077734, 0.060703013, 0.060628705, 0.060554415, 0.060480133, 0.060405869, 0.06033162, 0.060257383, 0.060185358, 0.060115404, 0.060045481, 0.059975557, 0.059905693, 0.059835844, 0.059766009, 0.059696205, 0.059626382, 0.059556656, 0.059486896, 0.059417214, 0.059347499, 0.059277829, 0.059208218, 0.059138581, 0.059069015, 0.058999423, 0.058929887, 0.058860365, 0.058790877, 0.058721405, 0.058651961, 0.058582529, 0.058513131, 0.058443762, 0.058374409, 0.058305081, 0.058235772, 0.058166496, 0.058097243, 0.058028027, 0.057958804, 0.057889629, 0.057820469, 0.057751343, 0.057682194, 0.057613142, 0.057544086, 0.057475045, 0.057406038, 0.057337016, 0.057268079, 0.057199113, 0.05713021, 0.057061303, 0.05699243, 0.056923617, 0.056854773, 0.056786001, 0.056717198, 0.056648448, 0.056579724, 0.056511026, 0.056442346, 0.056373697, 0.056305062, 0.056236457, 0.056167886, 0.056099322, 0.056030795, 0.055962294, 0.055893809, 0.055825338, 0.055756915, 0.055688504, 0.055620112, 0.055551741, 0.055483412, 0.05541509, 0.055346802, 0.055278525, 0.055210277, 0.055142064, 0.05507385, 0.055005692, 0.054937527, 0.054869432, 0.054801334, 0.054733224, 0.054665204, 0.054597154, 0.054529179, 0.054461174, 0.054393213, 0.054325286, 0.054257382, 0.054189496, 0.054121647, 0.054053802, 0.053985994, 0.053918213, 0.05385045, 0.053782713, 0.053714994, 0.053647302, 0.053579643, 0.053511996, 0.053444382, 0.053376783, 0.05330921, 0.05324167, 0.05317416, 0.053106647, 0.053039182, 0.052971736, 0.052904312, 0.052836876, 0.052769534, 0.05270214, 0.052634839, 0.052567542, 0.052500241, 0.052432999, 0.052365743, 0.052298564, 0.052231338, 0.05216419, 0.052097082, 0.05202993, 0.051962852, 0.051895779, 0.051828746, 0.051761732, 0.051694732, 0.051627763, 0.051560819, 0.051493909, 0.051427018, 0.051360164, 0.051293284, 0.051226463, 0.051159672, 0.051092897, 0.051026121, 0.050959405, 0.050892707, 0.050826035, 0.050759349, 0.050692722, 0.050626129, 0.050559547, 0.050492991, 0.050426427, 0.050359923, 0.050293464, 0.050226998, 0.050160527, 0.050094124, 0.050027721, 0.049961384, 0.049895041, 0.049828697, 0.049762405, 0.04969614, 0.049629901, 0.04956365, 0.049497459, 0.049431302, 0.049365152, 0.049299035, 0.049232908, 0.049166832, 0.049100775, 0.049034767, 0.048968744, 0.048902761, 0.048836809, 0.048770875, 0.048704937, 0.048639063, 0.048573215, 0.048507381, 0.048441567, 0.048375748, 0.048310008, 0.048244268, 0.048178542, 0.048112828, 0.048047163, 0.047981542, 0.047915917, 0.047850329, 0.047784723, 0.047719192, 0.047653675, 0.047588177, 0.047522675, 0.047457229, 0.047391802, 0.047326408, 0.047261044, 0.047195658, 0.047130324, 0.04706502, 0.046999756, 0.046934463, 0.046869233, 0.046804033, 0.046738844, 0.046673659, 0.04660853, 0.046543419, 0.046478324, 0.046413243, 0.046348188, 0.0462832, 0.046218194, 0.046153229, 0.046088252, 0.046023339, 0.045958467, 0.045893576, 0.045828708, 0.04576388, 0.045699082, 0.045634318, 0.04556958, 0.045504812, 0.045440104, 0.045375425, 0.04531078, 0.045246121, 0.045181517, 0.045116946, 0.045052376, 0.044987865, 0.04492332, 0.044858821, 0.044794358, 0.044729937, 0.044665527, 0.044601105, 0.044536747, 0.0444724, 0.044408049, 0.044343766, 0.044279508, 0.044215247, 0.044151038, 0.044086795, 0.044022642, 0.043958489, 0.043894369, 0.043830235, 0.043766156, 0.043702126, 0.043638088, 0.043574072, 0.043510068, 0.043446112, 0.043382198, 0.04331829, 0.043254364, 0.043190509, 0.043126673, 0.043062866, 0.042999089, 0.042935297, 0.042871546, 0.042807829, 0.042744145, 0.042680439, 0.042616799, 0.042553186, 0.042489592, 0.042426039, 0.042362452, 0.042298932, 0.042235423, 0.042171959, 0.042108472, 0.042045053, 0.041981649, 0.041918259, 0.041854877, 0.041791547, 0.041728266, 0.04166498, 0.041601714, 0.041538447, 0.04147524, 0.041412063, 0.041348897, 0.041285735, 0.041222617, 0.041159529, 0.041096475, 0.041033432, 0.04097037, 0.04090739, 0.040844411, 0.040781483, 0.040718533, 0.040655624, 0.040592749, 0.040529899, 0.040467095, 0.040404264, 0.040341478, 0.040278714, 0.040215991, 0.040153261, 0.040090576, 0.040027924, 0.039965305, 0.039902654, 0.039840087, 0.039777525, 0.039714977, 0.039652474, 0.039589956, 0.039527498, 0.039465055, 0.039402641, 0.039340217, 0.039277844, 0.039215509, 0.039153185, 0.03909089, 0.039028581, 0.038966339, 0.03890413, 0.038841933, 0.038779724, 0.038717568, 0.038655441, 0.038593341, 0.038531259, 0.038469177, 0.038407154, 0.038345143, 0.038283169, 0.038221173, 0.03815924, 0.038097322, 0.038035449, 0.037973545, 0.037911717, 0.037849903, 0.037788104, 0.037726339, 0.037664566, 0.03760286, 0.037541166, 0.037479501, 0.037417825, 0.037356194, 0.037294604, 0.037233029, 0.037171487, 0.037109926, 0.037048414, 0.036986958, 0.036925491, 0.036864042, 0.036802631, 0.036741253, 0.036679905, 0.036618572, 0.03655722, 0.036495935, 0.036434676, 0.036373459, 0.036312204, 0.03625102, 0.03618985, 0.036128711, 0.036067601, 0.03600648, 0.035945415, 0.035884365, 0.0358233, 0.035762329, 0.035701353, 0.035640396, 0.035579484, 0.035518538, 0.035457686, 0.035396829, 0.035335992, 0.035275154, 0.035214376, 0.035153642, 0.035092905, 0.03503219, 0.034971468, 0.034910813, 0.034850184, 0.03478957, 0.034728955, 0.034668401, 0.034607846, 0.034547351, 0.034486856, 0.03442635, 0.034365915, 0.034305498, 0.034245107, 0.034184732, 0.034124359, 0.034064028, 0.034003731, 0.03394343, 0.033883192, 0.033822954, 0.033762757, 0.033702582, 0.033642389, 0.033582266, 0.033522163, 0.033462074, 0.033401985, 0.033341955, 0.033281956, 0.033221956, 0.033162005, 0.033102032, 0.033042125, 0.032982245, 0.032922365, 0.032862499, 0.032802682, 0.032742891, 0.032683134, 0.032623388, 0.03256363, 0.032503929, 0.032444246, 0.032384623, 0.032324966, 0.032265358, 0.032205779, 0.03214623, 0.032086708, 0.032027159, 0.031967685, 0.031908225, 0.031848796, 0.031789366, 0.031729981, 0.031670615, 0.031611286, 0.03155195, 0.031492669, 0.031433403, 0.031374156, 0.031314936, 0.031255715, 0.031196557, 0.031137411, 0.031078298, 0.031019166, 0.030960081, 0.030901056, 0.030842016, 0.030783037, 0.030724028, 0.030665064, 0.030606143, 0.030547239, 0.030488333, 0.030429488, 0.030370643, 0.03031186, 0.030253058, 0.030194275, 0.030135535, 0.030076824, 0.030018143, 0.029959464, 0.029900815, 0.029842196, 0.029783605, 0.029725015, 0.029666485, 0.029607955, 0.029549455, 0.029490987, 0.029432515, 0.029374106, 0.029315695, 0.029257344, 0.029198965, 0.029140616, 0.029082324, 0.029024035, 0.028965805, 0.028907545, 0.028849343, 0.028791144, 0.028733006, 0.028674835, 0.028616723, 0.028558644, 0.028500592, 0.028442543, 0.028384492, 0.028326502, 0.028268542, 0.028210612, 0.028152652, 0.028094782, 0.028036911, 0.02797907, 0.027921259, 0.027863421, 0.027805641, 0.027747888, 0.02769017, 0.027632449, 0.027574759, 0.027517129, 0.027459498, 0.027401837, 0.027344266, 0.027286727, 0.027229184, 0.027171675, 0.027114164, 0.027056715, 0.026999263, 0.026941873, 0.026884452, 0.026827091, 0.026769761, 0.026712429, 0.026655128, 0.026597857, 0.026540618, 0.026483407, 0.026426196, 0.026368987, 0.026311835, 0.026254714, 0.026197623, 0.026140563, 0.026083473, 0.026026443, 0.025969442, 0.025912439, 0.025855498, 0.025798559, 0.025741648, 0.025684766, 0.025627887, 0.025571065, 0.025514245, 0.025457455, 0.025400663, 0.025343932, 0.025287231, 0.025230529, 0.02517386, 0.025117187, 0.025060579, 0.025003998, 0.024947416, 0.024890834, 0.024834312, 0.024777822, 0.024721362, 0.024664901, 0.024608439, 0.024552038, 0.024495667, 0.024439326, 0.024382984, 0.024326675, 0.024270393, 0.024214111, 0.024157891, 0.024101639, 0.024045479, 0.023989318, 0.023933185, 0.023877053, 0.023820953, 0.023764882, 0.023708841, 0.023652799, 0.023596818, 0.023540838, 0.023484884, 0.023428965, 0.023373043, 0.023317182, 0.02326132, 0.023205519, 0.023149688, 0.023093916, 0.023038175, 0.022982433, 0.022926722, 0.02287101, 0.02281536, 0.022759736, 0.022704147, 0.022648523, 0.022592964, 0.022537433, 0.0224819, 0.022426428, 0.022370927, 0.022315485, 0.022260074, 0.022204692, 0.022149311, 0.022093959, 0.022038639, 0.021983346, 0.021928053, 0.021872791, 0.021817591, 0.02176239, 0.021707218, 0.021652047, 0.021596905, 0.021541823, 0.021486741, 0.021431629, 0.021376606, 0.021321613, 0.021266622, 0.021211691, 0.0211567, 0.021101797, 0.021046927, 0.020992054, 0.020937212, 0.02088237, 0.020827588, 0.020772837, 0.020718085, 0.020663364, 0.020608641, 0.020553978, 0.020499347, 0.020444684, 0.020390082, 0.020335512, 0.020280968, 0.020226456, 0.020171916, 0.020117464, 0.020062981, 0.020008558, 0.019954136, 0.019899774, 0.019845413, 0.01979108, 0.019736718, 0.019682445, 0.019628203, 0.019573962, 0.019519748, 0.019465538, 0.019411385, 0.019357232, 0.019303109, 0.019248987, 0.019194925, 0.019140894, 0.01908686, 0.019032858, 0.018978857, 0.018924914, 0.018871002, 0.018817119, 0.018763207, 0.018709356, 0.018655533, 0.01860171, 0.018547947, 0.018494153, 0.018440422, 0.01838672, 0.018333048, 0.018279376, 0.018225733, 0.018172121, 0.018118538, 0.018064925, 0.018011402, 0.017957879, 0.017904388, 0.017850924, 0.017797463, 0.017744061, 0.017690657, 0.017637284, 0.017583912, 0.0175306, 0.017477287, 0.017424034, 0.017370781, 0.017317528, 0.017264307, 0.017211143, 0.017157981, 0.017104818, 0.017051745, 0.016998643, 0.016945599, 0.016892556, 0.016839514, 0.016786531, 0.016733577, 0.016680654, 0.016627703, 0.016574809, 0.016521947, 0.016469114, 0.016416311, 0.016363477, 0.016310705, 0.016257962, 0.01620522, 0.016152536, 0.016099853, 0.0160472, 0.015994577, 0.015941955, 0.015889391, 0.015836827, 0.015784295, 0.015731791, 0.015679289, 0.015626846, 0.015574402, 0.015521989, 0.015469576, 0.015417224, 0.0153649, 0.015312606, 0.015260314, 0.015208021, 0.015155758, 0.015103554, 0.015051381, 0.014999177, 0.014947034, 0.014894921, 0.014842808, 0.014790754, 0.014738671, 0.014686647, 0.014634654, 0.014582661, 0.014530698, 0.014478764, 0.014426862, 0.014374987, 0.014323113, 0.0142713, 0.014219487, 0.014167704, 0.01411592, 0.014064167, 0.014012473, 0.013960781, 0.013909116, 0.013857453, 0.013805849, 0.013754276, 0.013702702, 0.013651129, 0.013599616, 0.013548132, 0.013496649, 0.013445195, 0.013393741, 0.013342347, 0.013290984, 0.01323965, 0.013188287, 0.013136983, 0.013085708, 0.013034466, 0.012983222, 0.012932008, 0.012880825, 0.012829671, 0.012778547, 0.012727393, 0.012676328, 0.012625266, 0.01257423, 0.012523168, 0.012472194, 0.01242122, 0.012370275, 0.012319363, 0.012268448, 0.012217594, 0.01216674, 0.012115916, 0.012065092, 0.012014329, 0.011963594, 0.011912861, 0.011862186, 0.011811453, 0.011760808, 0.011710194, 0.01165958, 0.011608967, 0.011558442, 0.011507887, 0.011457394, 0.0114069, 0.011356406, 0.011305972, 0.011255567, 0.011205194, 0.011154819, 0.011104475, 0.011054161, 0.011003847, 0.010953562, 0.010903339, 0.010853114, 0.01080292, 0.010752755, 0.010702561, 0.010652456, 0.010602353, 0.010552279, 0.010502204, 0.010452189, 0.010402175, 0.010352191, 0.010302236, 0.010252281, 0.010202387, 0.010152523, 0.010102659, 0.010052795, 0.01000299, 0.0099532157, 0.0099034403, 0.0098536955, 0.0098039526, 0.0097542675, 0.0097046122, 0.0096549587, 0.0096053332, 0.0095557394, 0.0095061744, 0.0094566094, 0.0094071059, 0.0093575716, 0.009308096, 0.0092586521, 0.0092092371, 0.0091598229, 0.0091104377, 0.0090610832, 0.0090117585, 0.0089624338, 0.0089131687, 0.0088639045, 0.0088146692, 0.0087654646, 0.0087162303, 0.0086670853, 0.0086179702, 0.0085688559, 0.008519711, 0.0084706554, 0.0084216306, 0.0083726058, 0.0083236117, 0.0082746157, 0.0082256813, 0.0081767468, 0.0081278719, 0.0080789663, 0.0080301212, 0.0079813069, 0.0079324916, 0.0078837369, 0.0078349514, 0.0077862269, 0.0077375318, 0.0076888064, 0.0076401718, 0.0075915367, 0.0075429315, 0.0074943565, 0.0074457517, 0.0073972363, 0.0073487214, 0.0073002358, 0.0072517805, 0.0072032954, 0.0071549006, 0.0071065053, 0.0070581404, 0.0070097749, 0.0069614695, 0.0069131646, 0.0068648891, 0.0068166442, 0.0067683989, 0.0067202137, 0.0066720583, 0.0066239028, 0.0065757479, 0.0065276222, 0.0064795567, 0.0064315214, 0.0063834866, 0.0063354508, 0.0062874751, 0.0062394999, 0.0061915843, 0.0061436393, 0.006095754, 0.006047898, 0.0060000727, 0.0059522772, 0.0059044519, 0.0058566863, 0.0058089211, 0.0057611852, 0.0057135099, 0.0056658341, 0.0056181885, 0.0055705733, 0.0055229575, 0.0054753721, 0.0054278462, 0.0053803208, 0.005332795, 0.0052852994, 0.0052378639, 0.0051904279, 0.0051430222, 0.0050956164, 0.0050482708, 0.0050009252, 0.0049536396, 0.0049063237, 0.0048590675, 0.0048118425, 0.0047646165, 0.0047174506, 0.0046702549, 0.0046231188, 0.0045759832, 0.0045289071, 0.0044818316, 0.0044347858, 0.0043877396, 0.0043407539, 0.0042937677, 0.0042468118, 0.0041998862, 0.0041529899, 0.0041061239, 0.0040592584, 0.0040124222, 0.0039656162, 0.0039188401, 0.0038720642, 0.0038253481, 0.003778632, 0.0037319462, 0.00368529, 0.0036386338, 0.0035920078, 0.0035454417, 0.0034988758, 0.0034523094, 0.0034058033, 0.0033592973, 0.0033128508, 0.0032664048, 0.0032199586, 0.0031735725, 0.0031272161, 0.00308086, 0.0030345039, 0.0029882076, 0.0029419411, 0.0028957047, 0.0028494985, 0.0028032623, 0.002757086, 0.0027109096, 0.0026647933, 0.002618677, 0.0025725907, 0.0025265343, 0.0024805081, 0.0024344516, 0.002388485, 0.0023425184, 0.0022965821, 0.0022506758, 0.0022047693, 0.0021588928, 0.0021130764, 0.0020672297, 0.0020214433, 0.0019756567, 0.0019299303, 0.0018842038, 0.0018385071, 0.0017928105, 0.0017471439, 0.0017015373, 0.0016559608, 0.0016103542, 0.0015647775, 0.0015192608, 0.0014737443, 0.0014282875, 0.0013828009, 0.0013373742, 0.0012919775, 0.0012465806, 0.001201214, 0.0011558771, 0.0011105705, 0.0010652636, 0.0010199869, 0.00097474008, 0.00092952326, 0.00088433648, 0.00083917961, 0.00079402275, 0.00074889592, 0.00070379907, 0.0006587322, 0.00061366527, 0.00056862837, 0.00052365143, 0.00047867451, 0.00043372755, 0.00038878061, 0.00034386365, 0.00029900664, 0.00025414967, 0.00020929266, 0.00016449564, 0.00011969861, 7.496155e-05, 3.0224501e-05, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097, 0.0022735097   }, 
   { 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 0.0022699314, 3.6942531e-06, 2.3535968e-05, 4.3318094e-05, 6.3338564e-05, 8.3239858e-05, 0.00010320075, 0.00012334039, 0.00014336086, 0.00016338132, 0.00018358053, 0.00020372018, 0.00022385981, 0.0002441782, 0.00026443703, 0.00028469582, 0.00030513338, 0.00032545178, 0.00034582976, 0.00036638649, 0.00038682405, 0.0004073212, 0.00042793751, 0.00044849425, 0.00046905098, 0.00048984605, 0.00051046233, 0.00053119782, 0.00055205252, 0.00057278795, 0.00059358304, 0.00061455689, 0.00063541153, 0.00065632578, 0.00067741878, 0.00069839257, 0.00071936636, 0.00074051903, 0.00076161197, 0.00078276452, 0.00080403627, 0.00082524843, 0.00084646058, 0.00086785154, 0.0008891233, 0.0009104546, 0.00093196472, 0.00095335563, 0.00097480614, 0.00099637581, 0.0010178859, 0.0010394555, 0.0010611444, 0.0010827737, 0.0011044625, 0.0011261513, 0.0011479594, 0.0011697077, 0.0011915158, 0.0012135025, 0.0012353702, 0.0012572377, 0.0012792841, 0.0013012709, 0.0013232576, 0.0013454231, 0.0013675292, 0.001389635, 0.0014119197, 0.0014340853, 0.0014563103, 0.0014787142, 0.0015009989, 0.0015233431, 0.0015458066, 0.0015681508, 0.0015906143, 0.0016131969, 0.0016357199, 0.001658243, 0.0016809447, 0.0017035869, 0.0017262291, 0.0017489905, 0.0017717519, 0.0017945132, 0.0018173937, 0.0018402147, 0.0018630953, 0.0018860949, 0.001909035, 0.0019319751, 0.0019551537, 0.0019781534, 0.0020012723, 0.0020244508, 0.0020475695, 0.0020708076, 0.0020941051, 0.0021174029, 0.0021406407, 0.0021640577, 0.0021874746, 0.0022108317, 0.0022343677, 0.002257844, 0.0022813205, 0.002305035, 0.0023285712, 0.0023521665, 0.0023758218, 0.0023996558, 0.0024233703, 0.0024470852, 0.0024709785, 0.0024948125, 0.0025186464, 0.0025426589, 0.0025666121, 0.0025905652, 0.002614697, 0.0026387095, 0.0026627819, 0.0026869732, 0.0027111645, 0.0027352963, 0.0027596666, 0.002783858, 0.0028081685, 0.0028325983, 0.0028569684, 0.0028813386, 0.0029058873, 0.0029303769, 0.0029548067, 0.0029794746, 0.0030040236, 0.0030286321, 0.0030534193, 0.0030780875, 0.0031027556, 0.0031276024, 0.0031523895, 0.0031772363, 0.0032022023, 0.0032271086, 0.0032520152, 0.0032770408, 0.0033020664, 0.0033270919, 0.0033522963, 0.0033773815, 0.0034024664, 0.00342779, 0.0034529946, 0.0034781988, 0.0035036413, 0.0035289649, 0.0035542885, 0.0035797909, 0.0036051739, 0.0036306165, 0.0036562381, 0.0036817999, 0.0037073616, 0.0037330426, 0.003758664, 0.003784345, 0.0038101454, 0.003835886, 0.003861686, 0.0038876054, 0.0039134654, 0.003939325, 0.0039652446, 0.003991283, 0.0040172618, 0.0040433002, 0.0040694582, 0.0040955562, 0.0041217138, 0.0041479906, 0.0041742083, 0.0042004255, 0.0042268215, 0.0042530983, 0.0042794347, 0.0043059499, 0.0043323459, 0.0043588015, 0.0043853763, 0.0044118916, 0.0044384664, 0.00446516, 0.0044917949, 0.0045184288, 0.0045453017, 0.0045719957, 0.0045988089, 0.0046256813, 0.0046524946, 0.0046793674, 0.0047064191, 0.0047333511, 0.0047603431, 0.0047875135, 0.0048145056, 0.0048416168, 0.0048688469, 0.0048960173, 0.0049231881, 0.0049505373, 0.0049777674, 0.0050051166, 0.0050325855, 0.0050599347, 0.005087344, 0.005114872, 0.0051424005, 0.0051698685, 0.0051975162, 0.0052251038, 0.0052527515, 0.005280518, 0.0053082248, 0.0053359312, 0.0053638173, 0.0053915838, 0.0054194098, 0.0054472955, 0.0054752999, 0.0055033052, 0.00553125, 0.0055593741, 0.005587379, 0.0056155026, 0.0056437459, 0.0056718704, 0.0057000536, 0.0057283561, 0.005756659, 0.0057849619, 0.005813384, 0.005841746, 0.0058701681, 0.0058987089, 0.0059271907, 0.0059556724, 0.0059843324, 0.0060129333, 0.0060415338, 0.0060702539, 0.0060989736, 0.0061276932, 0.0061565922, 0.006185371, 0.0062141507, 0.0062431684, 0.0062720673, 0.0063009658, 0.0063300431, 0.0063590608, 0.006388138, 0.0064172749, 0.0064464123, 0.0064755492, 0.0065048644, 0.0065340614, 0.006563317, 0.0065926923, 0.0066220677, 0.0066513834, 0.0066809375, 0.0067103724, 0.0067398068, 0.006769421, 0.0067989151, 0.0068285284, 0.0068582618, 0.0068878755, 0.0069175484, 0.0069474, 0.0069771335, 0.0070069851, 0.0070368368, 0.0070667486, 0.0070966003, 0.0071266908, 0.0071566622, 0.0071866331, 0.0072166636, 0.0072468133, 0.0072769634, 0.0073070535, 0.0073373821, 0.0073675322, 0.0073978608, 0.0074281897, 0.0074585183, 0.0074889064, 0.0075194137, 0.0075498018, 0.0075802496, 0.0076108761, 0.0076414435, 0.00767201, 0.0077026961, 0.0077333227, 0.0077640093, 0.0077948146, 0.0078255599, 0.0078563653, 0.0078872899, 0.0079181548, 0.0079490198, 0.0079800636, 0.0080109881, 0.0080419714, 0.0080731343, 0.0081042377, 0.0081352815, 0.0081665628, 0.0081977258, 0.0082288897, 0.0082602901, 0.0082915723, 0.0083228536, 0.0083543146, 0.008385716, 0.0084171174, 0.0084486976, 0.0084801577, 0.0085117379, 0.0085433777, 0.0085750166, 0.0086065968, 0.0086384146, 0.008670114, 0.0087018134, 0.0087337503, 0.0087655084, 0.0087973271, 0.0088293841, 0.0088612614, 0.0088931993, 0.0089251958, 0.008957372, 0.0089894282, 0.0090214852, 0.0090537202, 0.0090858964, 0.0091181314, 0.0091504864, 0.0091827214, 0.0092150159, 0.0092474902, 0.0092798453, 0.0093122581, 0.0093448507, 0.009377325, 0.0094098579, 0.0094425101, 0.0094751036, 0.0095076961, 0.0095404675, 0.0095731802, 0.0096059516, 0.0096387826, 0.0096716136, 0.0097044446, 0.0097374553, 0.0097703459, 0.0098032961, 0.0098363664, 0.0098693762, 0.0099024447, 0.0099356342, 0.0099687632, 0.010001952, 0.01003526, 0.010068448, 0.010101696, 0.010135124, 0.010168492, 0.010201858, 0.010235345, 0.010268833, 0.010302259, 0.010335924, 0.01036947, 0.010403017, 0.010436801, 0.010470467, 0.010504072, 0.010537916, 0.010571701, 0.010605485, 0.01063945, 0.010673353, 0.010707256, 0.010741279, 0.010775242, 0.010809265, 0.010843406, 0.01087749, 0.010911631, 0.010945774, 0.010980095, 0.011014297, 0.011048557, 0.011082938, 0.011117318, 0.01115164, 0.011186139, 0.011220579, 0.011255078, 0.011289697, 0.011324257, 0.011358815, 0.011393553, 0.011428172, 0.01146285, 0.011497707, 0.011532445, 0.011567242, 0.011602219, 0.011637016, 0.011671933, 0.011706969, 0.011741946, 0.011776981, 0.011812137, 0.011847172, 0.011882327, 0.011917541, 0.011952756, 0.01198797, 0.012023305, 0.012058638, 0.012093912, 0.012129424, 0.012164818, 0.012200271, 0.012235844, 0.012271355, 0.012306808, 0.012342559, 0.012378131, 0.012413763, 0.012449574, 0.012485323, 0.012521075, 0.012556944, 0.012592755, 0.012628625, 0.012664615, 0.012700544, 0.012736533, 0.012772582, 0.012808631, 0.012844739, 0.012880967, 0.012917075, 0.012953243, 0.012989471, 0.013025817, 0.013062105, 0.013098392, 0.013134916, 0.013171263, 0.013207729, 0.013244255, 0.01328078, 0.013317306, 0.013354009, 0.013390595, 0.013427239, 0.013464004, 0.013500707, 0.01353747, 0.013574354, 0.013611177, 0.013648001, 0.013685003, 0.013721945, 0.013758888, 0.01379601, 0.013833012, 0.013870073, 0.013907314, 0.013944434, 0.013981615, 0.014018916, 0.014056156, 0.014093457, 0.014130875, 0.014168235, 0.014205595, 0.014243133, 0.014280552, 0.014318031, 0.014355688, 0.014393287, 0.014430884, 0.014468601, 0.01450626, 0.014543977, 0.014581813, 0.01461959, 0.014657366, 0.014695321, 0.014733218, 0.014771173, 0.014809188, 0.014847203, 0.014885218, 0.014923411, 0.014961487, 0.014999621, 0.015037874, 0.015076068, 0.015114321, 0.015152575, 0.015191007, 0.015229319, 0.015267693, 0.015306244, 0.015344676, 0.015383168, 0.015421838, 0.01546033, 0.015498941, 0.015537671, 0.015576341, 0.015615071, 0.015653862, 0.015692711, 0.015731441, 0.015770409, 0.015809318, 0.015848227, 0.015887255, 0.015926283, 0.015965251, 0.016004398, 0.016043486, 0.016082633, 0.0161219, 0.016161047, 0.016200313, 0.016239697, 0.016278965, 0.016318349, 0.016357794, 0.01639724, 0.016436685, 0.016476249, 0.016515754, 0.016555319, 0.016595002, 0.016634626, 0.01667425, 0.016714111, 0.016753795, 0.016793538, 0.01683346, 0.016873322, 0.016913185, 0.016953224, 0.016993146, 0.017033068, 0.017073229, 0.01711327, 0.017153371, 0.017193589, 0.01723375, 0.01727391, 0.01731425, 0.017354527, 0.017394807, 0.017435266, 0.017475605, 0.017516002, 0.017556461, 0.017597038, 0.017637556, 0.017678073, 0.01771877, 0.017759407, 0.017800042, 0.017840859, 0.017881555, 0.01792231, 0.017963246, 0.018004002, 0.018044878, 0.01808593, 0.018126866, 0.018167801, 0.018208914, 0.018249966, 0.01829108, 0.018332254, 0.018373428, 0.0184146, 0.018455951, 0.018497184, 0.018538417, 0.018579889, 0.01862124, 0.01866265, 0.018704182, 0.018745653, 0.018787123, 0.018828833, 0.018870363, 0.018911954, 0.018953722, 0.018995432, 0.019037142, 0.01907897, 0.019120738, 0.019162567, 0.019204574, 0.019246463, 0.01928841, 0.019330416, 0.019372486, 0.019414492, 0.019456677, 0.019498805, 0.01954093, 0.019583235, 0.019625422, 0.019667666, 0.019710032, 0.019752396, 0.019794703, 0.019837126, 0.019879609, 0.019922154, 0.019964578, 0.02000724, 0.020049784, 0.020092446, 0.020135168, 0.020177832, 0.020220554, 0.020263396, 0.020306176, 0.02034902, 0.020391978, 0.020434881, 0.020477721, 0.020520801, 0.02056382, 0.020606842, 0.02065004, 0.020693121, 0.020736258, 0.020779517, 0.020822717, 0.020865977, 0.020909354, 0.020952672, 0.020996049, 0.021039546, 0.021082923, 0.02112636, 0.021169975, 0.021213533, 0.021257091, 0.021300765, 0.021344323, 0.021388115, 0.021431912, 0.021475647, 0.021519501, 0.021563295, 0.021607149, 0.021651065, 0.021695038, 0.021738952, 0.021783102, 0.021827137, 0.02187117, 0.021915322, 0.021959474, 0.022003686, 0.022047898, 0.022092229, 0.0221365, 0.022180831, 0.022225281, 0.022269612, 0.022314122, 0.022358632, 0.022403141, 0.022447592, 0.022492221, 0.02253679, 0.022581479, 0.022626167, 0.022670915, 0.022715783, 0.022760471, 0.022805398, 0.022850266, 0.022895133, 0.02294012, 0.022985106, 0.023030033, 0.02307508, 0.023120305, 0.023165289, 0.023210576, 0.023255799, 0.023300905, 0.023346251, 0.023391474, 0.023436878, 0.023482161, 0.023527626, 0.023573028, 0.023618551, 0.023664134, 0.023709597, 0.023755239, 0.02380082, 0.023846524, 0.023892105, 0.023937866, 0.023983628, 0.024029447, 0.024075208, 0.024121149, 0.024167087, 0.024212968, 0.024258967, 0.024305027, 0.024351027, 0.024397086, 0.024443205, 0.024489323, 0.0245355, 0.024581859, 0.024627976, 0.024674391, 0.024720751, 0.024767047, 0.024813464, 0.024859881, 0.024906356, 0.024952831, 0.024999429, 0.025045963, 0.025092619, 0.025139153, 0.025185928, 0.025232702, 0.025279416, 0.025326248, 0.025373023, 0.025419917, 0.025466751, 0.025513703, 0.025560655, 0.025607668, 0.025654798, 0.025701812, 0.025748942, 0.025796017, 0.025843266, 0.025890457, 0.02593771, 0.02598496, 0.026032329, 0.026079757, 0.026127009, 0.026174556, 0.026222046, 0.026269535, 0.026317084, 0.026364572, 0.026412122, 0.026459849, 0.026507517, 0.026555244, 0.02660297, 0.026650758, 0.026698606, 0.026746452, 0.026794359, 0.026842324, 0.026890229, 0.026938256, 0.02698628, 0.027034307, 0.027082451, 0.027130535, 0.027178738, 0.027227001, 0.027275207, 0.027323471, 0.027371854, 0.027420176, 0.027468558, 0.027517002, 0.027565442, 0.027613947, 0.027662506, 0.027711008, 0.02775963, 0.02780831, 0.027856931, 0.027905671, 0.027954414, 0.028003154, 0.028052013, 0.028100872, 0.028149731, 0.028198712, 0.028247628, 0.028296608, 0.028345646, 0.028394744, 0.028443784, 0.028492941, 0.028542096, 0.028591314, 0.028640591, 0.028689807, 0.028739143, 0.028788539, 0.028837876, 0.028887272, 0.028936787, 0.028986242, 0.029035756, 0.029085331, 0.029134905, 0.029184539, 0.029234232, 0.029283928, 0.029333681, 0.029383492, 0.029433245, 0.029483119, 0.029532991, 0.029582864, 0.029632855, 0.029682847, 0.029732836, 0.029782949, 0.029832998, 0.029883111, 0.029933279, 0.029983452, 0.030033741, 0.030084031, 0.03013432, 0.030184608, 0.030235017, 0.030285425, 0.030335896, 0.030386364, 0.030436892, 0.03048742, 0.030538067, 0.030588653, 0.0306393, 0.030690067, 0.030740714, 0.03079154, 0.030842306, 0.03089313, 0.030944016, 0.030994961, 0.031045908, 0.031096911, 0.031147916, 0.031198921, 0.031250045, 0.031301167, 0.031352289, 0.031403534, 0.031454775, 0.031505961, 0.031557322, 0.031608626, 0.031659987, 0.031711411, 0.031762831, 0.031814311, 0.031865854, 0.031917393, 0.031968992, 0.032020595, 0.032072254, 0.032123972, 0.032175694, 0.032227412, 0.032279253, 0.03233109, 0.032382928, 0.032434829, 0.032486785, 0.032538742, 0.032590762, 0.032642838, 0.032694854, 0.032747049, 0.032799188, 0.032851323, 0.032903578, 0.032955777, 0.033008091, 0.033060469, 0.033112779, 0.033165216, 0.03321765, 0.033270087, 0.03332264, 0.033375192, 0.033427749, 0.033480361, 0.033533033, 0.033585705, 0.033638436, 0.033691231, 0.033743963, 0.033796813, 0.033849668, 0.033902518, 0.033955488, 0.034008458, 0.034061432, 0.034114521, 0.03416761, 0.034220699, 0.034273848, 0.03432706, 0.034380209, 0.034433477, 0.034486804, 0.034540072, 0.034593463, 0.03464685, 0.034700297, 0.034753744, 0.034807254, 0.03486076, 0.034914386, 0.034967951, 0.03502164, 0.035075322, 0.035129011, 0.035182755, 0.03523656, 0.035290364, 0.035344228, 0.035398152, 0.035452016, 0.035506003, 0.035559986, 0.035614029, 0.035668131, 0.035722237, 0.035776336, 0.035830561, 0.035884783, 0.035939004, 0.035993285, 0.036047626, 0.036101907, 0.036156371, 0.036210712, 0.036265172, 0.036319688, 0.036374211, 0.036428791, 0.036483429, 0.036538012, 0.036592707, 0.036647469, 0.036702167, 0.036756922, 0.036811799, 0.03686662, 0.036921497, 0.036976434, 0.037031371, 0.037086368, 0.037141424, 0.03719648, 0.037251595, 0.037306711, 0.03736183, 0.037417062, 0.03747236, 0.037527591, 0.037582889, 0.037638303, 0.037693594, 0.037749071, 0.037804484, 0.037860014, 0.03791555, 0.037971079, 0.038026676, 0.038082328, 0.03813792, 0.038193692, 0.038249463, 0.038305175, 0.038361002, 0.038416836, 0.038472667, 0.038528617, 0.038584623, 0.038640577, 0.038696587, 0.038752716, 0.038808722, 0.038864855, 0.03892104, 0.038977228, 0.039033476, 0.039089784, 0.039146032, 0.0392024, 0.039258767, 0.039315194, 0.039371621, 0.039428107, 0.03948465, 0.0395412, 0.039597742, 0.039654408, 0.039711073, 0.039767738, 0.039824527, 0.039881308, 0.039938033, 0.039994877, 0.040051781, 0.040108684, 0.040165648, 0.040222671, 0.040279575, 0.040336654, 0.040393796, 0.040450878, 0.04050808, 0.040565282, 0.040622484, 0.040679742, 0.040737066, 0.040794384, 0.040851764, 0.040909205, 0.040966582, 0.041024085, 0.041081525, 0.041139141, 0.041196704, 0.041254319, 0.041311998, 0.041369732, 0.041427355, 0.041485149, 0.041543007, 0.041600805, 0.041658662, 0.041716579, 0.041774496, 0.041832473, 0.041890506, 0.041948542, 0.042006638, 0.04206479, 0.042122886, 0.042181041, 0.042239316, 0.042297531, 0.042355862, 0.042414196, 0.04247253, 0.042530924, 0.042589378, 0.042647827, 0.0427064, 0.04276491, 0.042823482, 0.042882115, 0.042940684, 0.042999435, 0.04305819, 0.043116879, 0.04317569, 0.043234557, 0.043293372, 0.043352298, 0.043411225, 0.043470155, 0.043529205, 0.043590318, 0.043653212, 0.043716148, 0.043779124, 0.043842092, 0.043905117, 0.043968186, 0.044031229, 0.044094328, 0.044157494, 0.044220634, 0.044283792, 0.044347059, 0.044410259, 0.044473529, 0.044536803, 0.044600159, 0.044663485, 0.044726867, 0.044790309, 0.044853754, 0.044917151, 0.044980697, 0.045044214, 0.045107733, 0.04517135, 0.04523493, 0.045298535, 0.045362215, 0.045425929, 0.045489609, 0.045553364, 0.045617152, 0.04568094, 0.045744739, 0.045808602, 0.045872487, 0.045936409, 0.046000339, 0.04606428, 0.046128288, 0.046192307, 0.046256363, 0.046320431, 0.046384562, 0.046448655, 0.046512846, 0.046576988, 0.046641216, 0.046705466, 0.046769731, 0.046834022, 0.046898387, 0.046962712, 0.047027074, 0.047091532, 0.047155939, 0.047220416, 0.047284931, 0.047349427, 0.047413971, 0.047478564, 0.047543172, 0.04760782, 0.047672454, 0.047737166, 0.047801856, 0.047866609, 0.047931381, 0.047996163, 0.048060987, 0.048125863, 0.048190754, 0.048255611, 0.048320573, 0.048385568, 0.048450526, 0.048515547, 0.048580613, 0.048645664, 0.048710793, 0.0487759, 0.048841063, 0.048906274, 0.048971478, 0.049036767, 0.049101982, 0.04916732, 0.049232617, 0.049298014, 0.049363364, 0.049428772, 0.049494226, 0.049559698, 0.049625177, 0.049690753, 0.049756281, 0.049821828, 0.049887471, 0.049953058, 0.050018724, 0.050084442, 0.050150178, 0.050215874, 0.050281685, 0.050347451, 0.050413277, 0.050479133, 0.050545003, 0.050610933, 0.050676893, 0.050742824, 0.050808847, 0.050874881, 0.050940901, 0.051007021, 0.051073119, 0.051139232, 0.0512054, 0.051271591, 0.051337793, 0.051404033, 0.051470336, 0.051536638, 0.05160296, 0.051669341, 0.051735703, 0.051802076, 0.051868577, 0.05193501, 0.05200154, 0.052068032, 0.052134607, 0.052201159, 0.052267745, 0.05233442, 0.052401084, 0.052467745, 0.052534461, 0.052601241, 0.052667975, 0.052734792, 0.052801657, 0.052868512, 0.052935354, 0.053002324, 0.053069223, 0.053136211, 0.053203214, 0.053270243, 0.05333728, 0.053404372, 0.053471476, 0.053538617, 0.053605765, 0.053672966, 0.053740188, 0.053807404, 0.053874716, 0.053942017, 0.054009348, 0.054076698, 0.054144103, 0.05421146, 0.054278906, 0.054346424, 0.0544139, 0.054481439, 0.054548994, 0.054616563, 0.054684144, 0.054751791, 0.054819465, 0.054887153, 0.054954872, 0.055022646, 0.055090394, 0.055158217, 0.055226058, 0.055293936, 0.055361807, 0.055429701, 0.055497672, 0.055565644, 0.055633616, 0.055701651, 0.055769723, 0.055837769, 0.05590592, 0.055974022, 0.056042187, 0.056110393, 0.056178622, 0.056246843, 0.056315146, 0.056383442, 0.056451786, 0.056520145, 0.056588523, 0.056656957, 0.056725387, 0.056793831, 0.056862343, 0.056930862, 0.056999404, 0.057068042, 0.057136655, 0.057205252, 0.057273939, 0.057342652, 0.057411324, 0.057480086, 0.057548903, 0.057617668, 0.057686534, 0.057755366, 0.05782428, 0.057893172, 0.057962142, 0.058031093, 0.058100097, 0.058169127, 0.058238193, 0.05830726, 0.058376361, 0.058445536, 0.058514714, 0.058583867, 0.058653105, 0.058722351, 0.058791608, 0.058860932, 0.058930289, 0.058999632, 0.059069019, 0.059138466, 0.059207849, 0.059277356, 0.059346877, 0.059416395, 0.059485946, 0.059555531, 0.059625138, 0.059694778, 0.05976446, 0.059834145, 0.05990389, 0.059973616, 0.060043409, 0.060113192, 0.060183, 0.060252909, 0.060322829, 0.060392708, 0.060462642, 0.060532644, 0.060602609, 0.060672637, 0.060742725, 0.060812809, 0.060882911, 0.060953073, 0.061023217, 0.061093438, 0.061163664, 0.061233897, 0.061304174, 0.061374485, 0.061444823, 0.061515208, 0.061585594, 0.061655995, 0.06172647, 0.061796911, 0.061867397, 0.061937965, 0.062008511, 0.062079076, 0.062149744, 0.062220335, 0.062291019, 0.062361713, 0.062432442, 0.062503204, 0.062573969, 0.062644772, 0.06271562, 0.062786482, 0.06285736, 0.062928297, 0.062999241, 0.063070238, 0.063141234, 0.063212276, 0.063283317, 0.06335441, 0.063425511, 0.063496657, 0.063567825, 0.063639008, 0.06371022, 0.0637815, 0.063852794, 0.063924074, 0.063995413, 0.064066812, 0.064138189, 0.064209603, 0.064281046, 0.064352535, 0.064424045, 0.064495564, 0.064567156, 0.064638719, 0.064710312, 0.064781971, 0.064853653, 0.064925335, 0.064997055, 0.065068841, 0.065140568, 0.065212429, 0.06528426, 0.065356113, 0.065428033, 0.065499969, 0.065571874, 0.065643847, 0.065715894, 0.065787882, 0.065859966, 0.065932065, 0.066004165, 0.066076301, 0.066148475, 0.066220671, 0.066292904, 0.066365123, 0.06643746, 0.066509768, 0.066582084, 0.066654466, 0.066726848, 0.066799276, 0.06687174, 0.066944249, 0.067016698, 0.067089245, 0.067161806, 0.067234375, 0.067306995, 0.067379691, 0.067452312, 0.067525029, 0.067597784, 0.067670524, 0.067743286, 0.067816131, 0.06788896, 0.067961782, 0.068034701, 0.068107605, 0.068180583, 0.068253569, 0.068326548, 0.068399586, 0.068472683, 0.068545744, 0.068618886, 0.068691999, 0.068765186, 0.068838395, 0.068911612, 0.068984859, 0.069058165, 0.069131464, 0.0692048, 0.069278173, 0.069351554, 0.069424994, 0.06949845, 0.069571927, 0.069645442, 0.069719002, 0.069792524, 0.069866143, 0.069939747, 0.070013396, 0.070087068, 0.070160761, 0.070234485, 0.070308261, 0.070382074, 0.070455842, 0.070529684, 0.070603564, 0.070677467, 0.070751369, 0.070825338, 0.070899315, 0.070973307, 0.071047351, 0.07112141, 0.071195543, 0.071269616, 0.071343787, 0.07141795, 0.07149215, 0.071566395, 0.071640663, 0.071714908, 0.071789257, 0.071863599, 0.071937948, 0.072012372, 0.072086811, 0.072161227, 0.072235726, 0.072310239, 0.072384752, 0.072459333, 0.072533943, 0.07260856, 0.072683163, 0.072757855, 0.072832569, 0.072907306, 0.072982036, 0.073056862, 0.07313168, 0.073206514, 0.073281385, 0.073356256, 0.073431186, 0.073506147, 0.073581144, 0.073656097, 0.073731169, 0.073806249, 0.073881321, 0.07395646, 0.074031658, 0.074106775, 0.074181981, 0.074257247, 0.074332461, 0.074407749, 0.074483112, 0.074558429, 0.074633777, 0.074709207, 0.074784629, 0.074860074, 0.074935555, 0.075011075, 0.075086594, 0.075162157, 0.075237788, 0.075313397, 0.075389005, 0.075464725, 0.075540438, 0.075616136, 0.075691901, 0.075767711, 0.07584352, 0.07591936, 0.075995222, 0.076071121, 0.076147057, 0.076223001, 0.076299004, 0.076375, 0.076451026, 0.076527126, 0.076603211, 0.076679349, 0.076755486, 0.076831669, 0.076907866, 0.076984078, 0.077060372, 0.077136658, 0.077212945, 0.07728935, 0.077365674, 0.077442087, 0.077518538, 0.077594958, 0.077671461, 0.077747986, 0.077824518, 0.077901073, 0.07797768, 0.078054279, 0.078130938, 0.078207619, 0.078284316, 0.078361057, 0.078437842, 0.078514598, 0.078591406, 0.078668296, 0.078745134, 0.078822061, 0.078898981, 0.078975938, 0.079052933, 0.079129949, 0.079206981, 0.079284042, 0.079361156, 0.079438277, 0.079515435, 0.0795926, 0.079669796, 0.079747029, 0.079824321, 0.079901591, 0.079978913, 0.080056243, 0.080133647, 0.080211036, 0.080288462, 0.080365933, 0.08044342, 0.080520913, 0.080598459, 0.080676049, 0.080753617, 0.080831245, 0.080908939, 0.080986597, 0.081064261, 0.08114206, 0.081219785, 0.081297576, 0.081375442, 0.081453256, 0.08153113, 0.081609063, 0.081686959, 0.081764929, 0.081842884, 0.081920929, 0.081998967, 0.082076997, 0.082155161, 0.082233258, 0.082311422, 0.082389615, 0.082467824, 0.082546011, 0.082624309, 0.082702607, 0.08278092, 0.08285924, 0.08293765, 0.08301603, 0.083094448, 0.083172925, 0.083251417, 0.083329938, 0.08340846, 0.083487071, 0.08356566, 0.083644286, 0.083722934, 0.083801642, 0.08388035, 0.083959073, 0.08403784, 0.0841166, 0.084195405, 0.084274299, 0.084353156, 0.084432051, 0.084511034, 0.084589958, 0.084668964, 0.08474797, 0.084827028, 0.084906079, 0.084985182, 0.085064322, 0.085143469, 0.085222632, 0.085301861, 0.085381106, 0.085460365, 0.085539639, 0.085618973, 0.085698336, 0.08577767, 0.085857131, 0.085936539, 0.086016007, 0.086095519, 0.086175047, 0.086254537, 0.086334132, 0.086413726, 0.086493351, 0.086573027, 0.086652696, 0.086732395, 0.086812116, 0.086891897, 0.086971715, 0.087051541, 0.087131351, 0.087211281, 0.087291151, 0.087371081, 0.087451078, 0.087531082, 0.087611072, 0.087691128, 0.087771192, 0.087851264, 0.087931424, 0.088011585, 0.088091761, 0.088171974, 0.088252239, 0.088332459, 0.088412791, 0.088493109, 0.088573456, 0.088653825, 0.088734262, 0.088814661, 0.088895112, 0.088975616, 0.089056127, 0.089136697, 0.089217231, 0.089297876, 0.089378498, 0.089459129, 0.089539848, 0.089620568, 0.089701287, 0.089782059, 0.089862838, 0.08994367, 0.090024516, 0.090105429, 0.090186305, 0.090267234, 0.090348244, 0.090429172, 0.090510212, 0.090591282, 0.090672374, 0.090753458, 0.090834595, 0.090915717, 0.090996951, 0.091078117, 0.091159381, 0.091240667, 0.091321923, 0.091403253, 0.091484606, 0.091565982, 0.091647387, 0.091728866, 0.091810301, 0.09189181, 0.091973349, 0.092054874, 0.092136443, 0.092218064, 0.092299692, 0.092381321, 0.092463031, 0.09254472, 0.092626505, 0.09270823, 0.092790075, 0.092871889, 0.092953734, 0.093035616, 0.093117535, 0.093199454, 0.093281396, 0.093363434, 0.093445465, 0.093527488, 0.093609571, 0.093691669, 0.093773775, 0.093855977, 0.09393812, 0.094020359, 0.094102584, 0.094184883, 0.094267167, 0.094349526, 0.094431862, 0.094514251, 0.094596639, 0.094679058, 0.094761565, 0.094844036, 0.094926544, 0.095009111, 0.095091738, 0.095174275, 0.095256954, 0.095339611, 0.09542226, 0.095504999, 0.09558776, 0.095670491, 0.095753297, 0.095836125, 0.095918953, 0.096001878, 0.096084781, 0.096167736, 0.096250668, 0.09633366, 0.096416697, 0.096499763, 0.096582815, 0.096665964, 0.096749082, 0.096832231, 0.096915439, 0.096998677, 0.097081877, 0.097165175, 0.097248457, 0.097331755, 0.097415127, 0.097498544, 0.09758193, 0.097665377, 0.097748883, 0.097832315, 0.097915865, 0.097999446, 0.098082989, 0.098166592, 0.098250248, 0.098333895, 0.098417595, 0.098501258, 0.098585032, 0.098668829, 0.098752588, 0.098836422, 0.098920308, 0.099004187, 0.09908808, 0.099172078, 0.099255994, 0.099339999, 0.099424064, 0.099508099, 0.099592164, 0.099676274, 0.099760413, 0.099844567, 0.099928781, 0.10001295, 0.10009722, 0.10018151, 0.10026582, 0.10035013, 0.10043451, 0.10051888, 0.10060332, 0.10068772, 0.10077219, 0.10085671, 0.1009412, 0.10102575, 0.10111035, 0.10119495, 0.1012796, 0.10136428, 0.10144895, 0.10153367, 0.1016184, 0.10170318, 0.10178798, 0.10187282, 0.10195767, 0.10204257, 0.1021275, 0.10221241, 0.10229743, 0.10238237, 0.1024674, 0.10255247, 0.10263757, 0.10272263, 0.10280782, 0.10289297, 0.10297815, 0.10306339, 0.10314865, 0.10323388, 0.1033192, 0.10340452, 0.10348987, 0.10357527, 0.10366069, 0.10374616, 0.10383159, 0.10391708, 0.10400262, 0.10408819, 0.10417376, 0.10425939, 0.10434502, 0.10443067, 0.10451639, 0.1046021, 0.10468782, 0.10477363, 0.10485944, 0.10494525, 0.1050311, 0.10511702, 0.1052029, 0.10528885, 0.10537485, 0.10546084, 0.10554687, 0.10563295, 0.10571898, 0.10580511, 0.10589123, 0.10597742, 0.10606359, 0.10614979, 0.10623607, 0.10632236, 0.10640861, 0.10649501, 0.10658137, 0.10666775, 0.10675414, 0.10684063, 0.10692707, 0.10701358, 0.10710012, 0.10718661, 0.10727324, 0.10735986, 0.10744648, 0.10753315, 0.10761986, 0.10770658, 0.10779332, 0.10788009, 0.10796691, 0.10805374, 0.10814062, 0.10822748, 0.10831441, 0.10840131, 0.10848834, 0.10857536, 0.10866233, 0.1087494, 0.10883648, 0.10892361, 0.10901073, 0.10909794, 0.10918507, 0.10927233, 0.10935959, 0.10944686, 0.10953417, 0.10962152, 0.10970888, 0.10979625, 0.10988369, 0.10997112, 0.11005861, 0.11014611, 0.11023359, 0.11032119, 0.11040878, 0.11049636, 0.11058404, 0.11067168, 0.11075934, 0.11084711, 0.11093484, 0.11102264, 0.11111046, 0.11119828, 0.1112861, 0.11137402, 0.11146194, 0.1115499, 0.11163788, 0.1117259, 0.1118139, 0.11190198, 0.11199006, 0.11207815, 0.11216632, 0.11225446, 0.11234267, 0.11243091, 0.11251912, 0.11260745, 0.11269578, 0.11278407, 0.11287244, 0.11296084, 0.11304923, 0.11313768, 0.11322621, 0.11331465, 0.11340319, 0.11349175, 0.11358034, 0.11366896, 0.1137576, 0.11384629, 0.11393497, 0.1140237, 0.11411243, 0.11420126, 0.11429002, 0.11437889, 0.11446776, 0.1145566, 0.11464556, 0.11473449, 0.11482345, 0.11491249, 0.11500153, 0.11509055, 0.11517967, 0.11526881, 0.11535791, 0.1154471, 0.1155363, 0.11562551, 0.11571479, 0.11580402, 0.11589333, 0.11598269, 0.11607204, 0.11616146, 0.11625089, 0.11634032, 0.11642978, 0.11651933, 0.11660882, 0.11669841, 0.11678801, 0.11687762, 0.11696724, 0.11705697, 0.1171466, 0.11723631, 0.11732613, 0.11741585, 0.11750571, 0.11759556, 0.1176854, 0.1177753, 0.11786521, 0.11795516, 0.11804516, 0.11813512, 0.11822515, 0.11831526, 0.11840532, 0.11849543, 0.11858559, 0.11867576, 0.11876594, 0.11885621, 0.1189464, 0.11903674, 0.11912705, 0.1192174, 0.11930773, 0.11939815, 0.11948856, 0.11957903, 0.1196695, 0.11975997, 0.11985053, 0.11994109, 0.12003169, 0.12012231, 0.12021296, 0.12030362, 0.12039964, 0.12050081, 0.12060202, 0.12070321, 0.12080441, 0.12090553, 0.12100676, 0.12110788, 0.121209, 0.12131017, 0.12141129, 0.1215124, 0.12161352, 0.12171463, 0.12181571, 0.1219168, 0.12201788, 0.12211896, 0.12221999, 0.12232104, 0.12242211, 0.12252313, 0.12262414, 0.12272514, 0.12282619, 0.12292715, 0.12302817, 0.12312914, 0.12323012, 0.12333109, 0.12343206, 0.12353297, 0.12363391, 0.12373485, 0.12383579, 0.12393668, 0.12403759, 0.12413849, 0.12423935, 0.12434027, 0.12444112, 0.124542, 0.12464285, 0.12474371, 0.12484453, 0.12494536, 0.12504618, 0.12514699, 0.12524776, 0.12534857, 0.12544936, 0.12555011, 0.1256509, 0.12575166, 0.12585241, 0.12595314, 0.1260539, 0.1261546, 0.12625533, 0.12635604, 0.12645675, 0.12655741, 0.12665811, 0.12675878, 0.12685946, 0.1269601, 0.12706074, 0.12716137, 0.127262, 0.12736265, 0.12746325, 0.12756386, 0.12766446, 0.12776507, 0.12786561, 0.12796618, 0.12806676, 0.12816733, 0.12826785, 0.12836836, 0.12846893, 0.12856941, 0.12866993, 0.12877044, 0.12887093, 0.1289714, 0.12907192, 0.12917237, 0.12927283, 0.12937328, 0.12947373, 0.12957415, 0.1296746, 0.129775, 0.12987539, 0.1299758, 0.13007618, 0.13017659, 0.13027693, 0.13037735, 0.13047767, 0.13057803, 0.13067837, 0.13077872, 0.130879, 0.13097933, 0.13107963, 0.13117994, 0.13128021, 0.1313805, 0.13148078, 0.13158101, 0.13168126, 0.13178152, 0.13188177, 0.13198198, 0.13208224, 0.13218242, 0.13228264, 0.13238283, 0.13248302, 0.13258319, 0.13268337, 0.13278352, 0.13288364, 0.1329838, 0.13308394, 0.13318408, 0.13328417, 0.13338429, 0.13348438, 0.1335845, 0.13368455, 0.13378465, 0.1338847, 0.13398479, 0.13408481, 0.13418484, 0.1342849, 0.13438489, 0.13448492, 0.13458492, 0.13468494, 0.13478491, 0.13488489, 0.13498485, 0.13508484, 0.13518478, 0.13528472, 0.13538466, 0.13548461, 0.1355845, 0.1356844, 0.13578433, 0.13588421, 0.13598411, 0.13608398, 0.13618384, 0.1362837, 0.13638356, 0.1364834, 0.13658324, 0.13668305, 0.13678288, 0.13688269, 0.13698252, 0.13708226, 0.13718203, 0.13728185, 0.13738158, 0.13748138, 0.13758111, 0.13768086, 0.13778058, 0.13788031, 0.13798001, 0.13807973, 0.13817942, 0.13827913, 0.13837878, 0.13847849, 0.13857812, 0.13867778, 0.13877743, 0.13887708, 0.13897669, 0.13907631, 0.13917592, 0.13927554, 0.13937514, 0.13947472, 0.1395743, 0.13967386, 0.13977344, 0.13987298, 0.13997251, 0.14007206, 0.14017157, 0.14027111, 0.14037061, 0.14047013, 0.1405696, 0.14066909, 0.14076856, 0.14086804, 0.14096747, 0.14106694, 0.14116637, 0.14126582, 0.14136523, 0.14146462, 0.14156407, 0.14166343, 0.14176284, 0.14186221, 0.14196159, 0.14206095, 0.14216031, 0.14225966, 0.142359, 0.14245833, 0.14255765, 0.14265695, 0.14275628, 0.14285555, 0.14295483, 0.14305413, 0.14315337, 0.14325266, 0.1433519, 0.14345115, 0.14355038, 0.14364962, 0.14374882, 0.14384805, 0.14394723, 0.14404643, 0.14414561, 0.14424476, 0.14434396, 0.14444311, 0.14454226, 0.14464138, 0.14474054, 0.14483964, 0.14493878, 0.14503787, 0.14513697, 0.14523605, 0.14533515, 0.14543423, 0.14553331, 0.14563234, 0.14573137, 0.14583041, 0.14592944, 0.1460285, 0.14612748, 0.1462265, 0.14632547, 0.14642447, 0.14652345, 0.14662242, 0.14672136, 0.14682035, 0.14691928, 0.14701824, 0.14711714, 0.14721604, 0.14731497, 0.14741385, 0.14751278, 0.14761162, 0.14771053, 0.14780939, 0.14790826, 0.14800711, 0.14810595, 0.14820477, 0.14830358, 0.14840241, 0.14850123, 0.14860001, 0.14869879, 0.14879757, 0.14889635, 0.14899515, 0.14909387, 0.14919263, 0.14929135, 0.1493901, 0.14948881, 0.14958754, 0.14968625, 0.14978494, 0.14988361, 0.14998227, 0.15008096, 0.15017959, 0.15027829, 0.15037689, 0.15047558, 0.15057418, 0.15067281, 0.15077144, 0.15087001, 0.15096863, 0.15106721, 0.15116577, 0.15126434, 0.15136288, 0.15146142, 0.15156001, 0.15165851, 0.15175705, 0.15185556, 0.1519541, 0.15205255, 0.15215108, 0.15224954, 0.15234803, 0.15244646, 0.15254496, 0.1526434, 0.15274183, 0.15284026, 0.15293866, 0.15303707, 0.15313548, 0.15323387, 0.15333226, 0.15343066, 0.15352902, 0.1536274, 0.15372574, 0.15382409, 0.15392241, 0.15402074, 0.15411906, 0.15421738, 0.15431568, 0.15441397, 0.15451227, 0.15461053, 0.1547088, 0.15480706, 0.15490532, 0.15500355, 0.15510178, 0.1552, 0.15529823, 0.15539645, 0.15549463, 0.15559283, 0.15569101, 0.1557892, 0.15588734, 0.15598552, 0.15608366, 0.1561818, 0.15627991, 0.15637806, 0.15647615, 0.15657428, 0.15667237, 0.15677045, 0.15686853, 0.15696661, 0.15706466, 0.1571627, 0.15726078, 0.1573588, 0.15745683, 0.15755484, 0.15765285, 0.15775084, 0.15784886, 0.15794684, 0.15804483, 0.15814279, 0.15824078, 0.1583387, 0.15843664, 0.1585346, 0.15863247, 0.15873043, 0.15882832, 0.15892622, 0.1590241, 0.15912203, 0.15921988, 0.15931776, 0.1594156, 0.15951346, 0.15961128, 0.15970913, 0.15980692, 0.15990475, 0.16000256, 0.16010034, 0.16019814, 0.1602959, 0.16039367, 0.16049144, 0.16058923, 0.16068694, 0.16078469, 0.16088243, 0.16098015, 0.16107784, 0.16117555, 0.16127324, 0.1613709, 0.16146861, 0.16156627, 0.16166392, 0.16176157, 0.16185923, 0.16195685, 0.16205448, 0.1621521, 0.16224973, 0.1623473, 0.1624449, 0.16254248, 0.16264008, 0.16273762, 0.16283517, 0.16293272, 0.16303027, 0.16312779, 0.16322532, 0.16332284, 0.16342033, 0.16351786, 0.16361532, 0.16371284, 0.16381027, 0.16390774, 0.16400521, 0.16410264, 0.16420007, 0.16429751, 0.16439493, 0.16449234, 0.16458975, 0.16468713, 0.16478452, 0.16488189, 0.16497929, 0.16507661, 0.16517398, 0.16527133, 0.16536868, 0.165466, 0.16556329, 0.16566062, 0.16575791, 0.16585521, 0.1659525, 0.16604976, 0.16614702, 0.1662443, 0.16634154, 0.1664388, 0.16653599, 0.16663325, 0.16673045, 0.16682766, 0.16692485, 0.16702202, 0.1671192, 0.16721639, 0.16731356, 0.16741069, 0.16750784, 0.16760498, 0.16770212, 0.1677992, 0.16789636, 0.16799346, 0.16809057, 0.16818766, 0.16828473, 0.1683818, 0.16847885, 0.1685759, 0.16867295, 0.16876997, 0.16886698, 0.16896403, 0.16906102, 0.16915803, 0.16925502, 0.16935202, 0.16944897, 0.16954596, 0.16964291, 0.16973987, 0.1698368, 0.16993374, 0.17003064, 0.17012757, 0.17022447, 0.17032136, 0.17041828, 0.17051513, 0.17061202, 0.17070886, 0.17080575, 0.17090257, 0.17099944, 0.17109625, 0.17119306, 0.17128986, 0.17138669, 0.17148349, 0.17158026, 0.17167704, 0.17177381, 0.1718706, 0.17196731, 0.1720641, 0.1721608, 0.17225756, 0.17235424, 0.17245099, 0.17254765, 0.17264435, 0.17274104, 0.17283772, 0.17293438, 0.17303103, 0.17312768, 0.17322433, 0.17332096, 0.17341758, 0.17351422, 0.17361082, 0.17370743, 0.17380399, 0.17390059, 0.17399715, 0.17409369, 0.17419027, 0.17428681, 0.17438337, 0.17447989, 0.17457642, 0.1746729, 0.17476942, 0.1748659, 0.17496242, 0.17505886, 0.17515536, 0.17525183, 0.17534825, 0.17544471, 0.17554113, 0.17563757, 0.175734, 0.17583041, 0.17592677, 0.17602322, 0.17611957, 0.17621596, 0.17631231, 0.17640871, 0.17650503, 0.1766014, 0.1766977, 0.17679401, 0.17689034, 0.17698665, 0.17708296, 0.17717923, 0.17727552, 0.17737177, 0.17746806, 0.17756431, 0.17766057, 0.1777568, 0.17785305, 0.17794925, 0.1780455, 0.17814167, 0.17823786, 0.17833404, 0.17843023, 0.17852642, 0.17862257, 0.17871872, 0.17881484, 0.17891102, 0.17900713, 0.17910326, 0.17919935, 0.17929548, 0.17939155, 0.17948765, 0.17958371, 0.17967975, 0.17977585, 0.17987189, 0.17996795, 0.18006396, 0.18015999, 0.18025598, 0.18035203, 0.18044801, 0.180544, 0.18063997, 0.18073598, 0.18083192, 0.18092786, 0.18102382, 0.18111974, 0.18121569, 0.18131159, 0.18140753, 0.18150342, 0.18159932, 0.18169519, 0.18179111, 0.18188696, 0.18198282, 0.18207867, 0.18217456, 0.18227035, 0.18236618, 0.18246201, 0.18255782, 0.18265364, 0.18274941, 0.18284519, 0.18294096, 0.18303674, 0.1831325, 0.18322825, 0.18332401, 0.18341975, 0.18351546, 0.18361121, 0.18370686, 0.18380256, 0.18389829, 0.18399395, 0.18408965, 0.18418528, 0.18428095, 0.18437661, 0.18447223, 0.18456787, 0.1846635, 0.1847591, 0.18485473, 0.18495032, 0.1850459, 0.18514149, 0.18523705, 0.18533261, 0.18542816, 0.1855237, 0.18561924, 0.18571478, 0.18581028, 0.1859058, 0.1860013, 0.1860968, 0.18619229, 0.18628778, 0.18638323, 0.18647866, 0.18657412, 0.18666957, 0.18676503, 0.18686041, 0.18695588, 0.18705127, 0.18714665, 0.18724205, 0.18733743, 0.18743283, 0.18752818, 0.18762353, 0.18771888, 0.18781422, 0.18790956, 0.18800485, 0.18810016, 0.18819551, 0.18829076, 0.1883861, 0.18848133, 0.18857665, 0.18867189, 0.18876715, 0.18886238, 0.18895765, 0.18905285, 0.18914808, 0.1892433, 0.18933848, 0.18943368, 0.18952885, 0.18962406, 0.1897192, 0.18981439, 0.18990953, 0.19000468, 0.19009981, 0.19019493, 0.19029005, 0.19038516, 0.19048025, 0.19057535, 0.19067043, 0.1907655, 0.19086055, 0.19095562, 0.19105069, 0.1911457, 0.19124076, 0.19133577, 0.19143079, 0.1915258, 0.1916208, 0.19171579, 0.19181076, 0.19190574, 0.1920007, 0.19209564, 0.19219059, 0.19228552, 0.19238046, 0.19247539, 0.19257027, 0.1926652, 0.1927601, 0.19285497, 0.19294985, 0.19304474, 0.19313958, 0.19323446, 0.19332929, 0.19342409, 0.19351894, 0.19361375, 0.19370855, 0.19380336, 0.19389816, 0.19399294, 0.19408774, 0.19418249, 0.19427726, 0.19437198, 0.19446674, 0.19456147, 0.19465619, 0.19475091, 0.1948456, 0.1949403, 0.195035, 0.19512969, 0.19522433, 0.19531903, 0.19541368, 0.19550833, 0.19560295, 0.19569759, 0.19579218, 0.19588682, 0.1959814, 0.19607599, 0.19617058, 0.19626516, 0.19635972, 0.19645429, 0.19654886, 0.1966434, 0.19673793, 0.19683245, 0.19692698, 0.1970215, 0.197116, 0.19721048, 0.19730498, 0.19739945, 0.1974939, 0.19758835, 0.19768281, 0.19777726, 0.19787169, 0.1979661, 0.19806051, 0.19815496, 0.19824934, 0.19834374, 0.19843809, 0.19853248, 0.19862686, 0.1987212, 0.19881554, 0.19890986, 0.19900422, 0.19909851, 0.19919285, 0.19928713, 0.19938144, 0.19947572, 0.19957, 0.19966428, 0.19975854, 0.19985278, 0.19994706, 0.20004126, 0.20013548, 0.20022972, 0.20032389, 0.20041813, 0.2005123, 0.2006065, 0.20070067, 0.20079485, 0.20088899, 0.20098317, 0.2010773, 0.20117146, 0.20126556, 0.20135967, 0.20145378, 0.20154785, 0.20164198, 0.20173603, 0.20183013, 0.20192416, 0.20201825, 0.20211224, 0.20220634, 0.20230033, 0.20239438, 0.20248839, 0.2025824, 0.20267637, 0.20277037, 0.20286435, 0.20295832, 0.20305228, 0.20314622, 0.20324019, 0.20333412, 0.20342803, 0.20352195, 0.20361589, 0.20370975, 0.20380369, 0.20389755, 0.20399143, 0.20408528, 0.20417918, 0.204273, 0.20436683, 0.20446067, 0.2045545, 0.2046483, 0.2047421, 0.20483592, 0.20492971, 0.20502351, 0.20511726, 0.20521103, 0.20530479, 0.20539853, 0.20549227, 0.205586, 0.20567971, 0.20577341, 0.20586714, 0.20596083, 0.20605451, 0.20614819, 0.20624186, 0.20633553, 0.2064292, 0.20652281, 0.20661648, 0.20671009, 0.20680371, 0.20689732, 0.20699093, 0.20708451, 0.2071781, 0.20727168, 0.20736524, 0.20745881, 0.20755234, 0.20764589, 0.20773941, 0.20783298, 0.20792645, 0.20802, 0.20811349, 0.20820697, 0.20830046, 0.20839392, 0.20848739, 0.20858084, 0.20867428, 0.20876773, 0.20886119, 0.20895459, 0.20904802, 0.20914139, 0.20923483, 0.20932819, 0.20942159, 0.20951495, 0.20960833, 0.20970166, 0.20979498, 0.20988832, 0.20998164, 0.21007501, 0.2101683, 0.2102616, 0.21035488, 0.21044818, 0.21054146, 0.21063474, 0.21072796, 0.21082126, 0.21091446, 0.21100771, 0.21110092, 0.21119414, 0.21128736, 0.21138054, 0.21147375, 0.21156691, 0.2116601, 0.21175325, 0.21184643, 0.21193956, 0.21203272, 0.21212584, 0.21221898, 0.21231209, 0.21240519, 0.21249829, 0.21259135, 0.21268445, 0.21277751, 0.2128706, 0.21296363, 0.21305668, 0.2131497, 0.21324275, 0.21333575, 0.2134288, 0.21352179, 0.21361479, 0.21370776, 0.21380071, 0.21389371, 0.21398665, 0.2140796, 0.21417257, 0.21426548, 0.21435842, 0.21445133, 0.21454422, 0.21463715, 0.21473001, 0.21482292, 0.2149158, 0.21500865, 0.21510153, 0.21519436, 0.21528721, 0.21538003, 0.21547286, 0.21556568, 0.2156585, 0.21575126, 0.21584406, 0.21593681, 0.2160296, 0.21612236, 0.21621512, 0.21630788, 0.21640059, 0.21649335, 0.21658607, 0.21667878, 0.21677147, 0.21686417, 0.21695685, 0.21704952, 0.21714219, 0.21723486, 0.2173256, 0.21741429, 0.21750291, 0.21759146, 0.21767999, 0.21776846, 0.21785685, 0.2179452, 0.21803348, 0.21812171, 0.21820986, 0.21829797, 0.21838602, 0.218474, 0.21856195, 0.21864982, 0.21873763, 0.2188254, 0.21891309, 0.21900076, 0.21908833, 0.21917583, 0.21926332, 0.21935071, 0.21943808, 0.21952538, 0.2196126, 0.21969979, 0.2197869, 0.21987393, 0.21996097, 0.22004791, 0.22013478, 0.22022164, 0.22030841, 0.2203951, 0.22048177, 0.22056836, 0.2206549, 0.22074139, 0.22082779, 0.22091416, 0.22100045, 0.2210867, 0.2211729, 0.22125903, 0.2213451, 0.22143112, 0.22151707, 0.22160296, 0.22168881, 0.22177458, 0.2218603, 0.22194599, 0.22203158, 0.22211713, 0.22220261, 0.22228806, 0.22237344, 0.22245875, 0.222544, 0.22262919, 0.22271433, 0.22279944, 0.22288446, 0.22296943, 0.22305432, 0.22313918, 0.22322397, 0.22330871, 0.22339338, 0.22347799, 0.22356254, 0.22364706, 0.22373149, 0.22381589, 0.22390023, 0.22398448, 0.22406872, 0.22415285, 0.22423695, 0.22432098, 0.22440496, 0.22448888, 0.22457273, 0.22465652, 0.22474028, 0.22482397, 0.22490761, 0.22499119, 0.22507469, 0.22515815, 0.22524154, 0.22532487, 0.22540817, 0.22549139, 0.22557455, 0.22565766, 0.2257407, 0.2258237, 0.22590663, 0.22598948, 0.22607233, 0.22615507, 0.22623777, 0.22632042, 0.226403, 0.22648552, 0.226568, 0.2266504, 0.22673275, 0.22681506, 0.22689728, 0.22697943, 0.22706154, 0.2271436, 0.22722562, 0.22730756, 0.22738944, 0.22747126, 0.22755304, 0.22763474, 0.22771642, 0.227798, 0.22787954, 0.22796102, 0.22804244, 0.22812378, 0.2282051, 0.22828634, 0.22836752, 0.22844866, 0.22852971, 0.22861072, 0.22869171, 0.22877258, 0.22885342, 0.2289342, 0.22901493, 0.22909559, 0.22917619, 0.22925676, 0.22933723, 0.22941765, 0.22949804, 0.22957835, 0.22965862, 0.2297388, 0.22981894, 0.22989902, 0.22997904, 0.23005901, 0.23013891, 0.23021877, 0.23029856, 0.23037829, 0.23045795, 0.23053756, 0.23061714, 0.23069663, 0.23077607, 0.23085546, 0.2309348, 0.23101406, 0.23109326, 0.23117243, 0.23125151, 0.23133054, 0.23140952, 0.23148845, 0.23156732, 0.23164609, 0.23172484, 0.23180352, 0.23188217, 0.23196073, 0.23203924, 0.2321177, 0.23219608, 0.23227443, 0.23235272, 0.23243095, 0.23250909, 0.23258719, 0.23266526, 0.23274323, 0.23282117, 0.23289903, 0.23297684, 0.23305459, 0.2331323, 0.23320992, 0.2332875, 0.23336504, 0.2334425, 0.23351991, 0.23359726, 0.23367457, 0.23375179, 0.23382895, 0.23390608, 0.23398313, 0.23406012, 0.23413707, 0.23421395, 0.23429076, 0.23436753, 0.23444426, 0.23452091, 0.23459749, 0.23467404, 0.23475051, 0.23482692, 0.23490328, 0.23497958, 0.23505582, 0.23513199, 0.23520812, 0.23528419, 0.23536022, 0.23543617, 0.23551206, 0.23558789, 0.23566367, 0.2357394, 0.23581505, 0.23589067, 0.23596621, 0.23604169, 0.23611712, 0.23619249, 0.23626779, 0.23634306, 0.23641826, 0.23649338, 0.23656848, 0.23664349, 0.23671846, 0.23679337, 0.23686822, 0.23694299, 0.23701772, 0.23709242, 0.237167, 0.23724157, 0.23731607, 0.23739052, 0.2374649, 0.23753922, 0.23761348, 0.23768769, 0.23776184, 0.23783593, 0.23790997, 0.23798394, 0.23805787, 0.23813172, 0.23820549, 0.23827924, 0.23835294, 0.23842657, 0.23850013, 0.23857364, 0.23864709, 0.23872049, 0.23879384, 0.2388671, 0.2389403, 0.23901349, 0.2390866, 0.23915963, 0.23923263, 0.23930554, 0.23937841, 0.23945121, 0.23952396, 0.23959668, 0.23966929, 0.23974189, 0.2398144, 0.23988687, 0.23995927, 0.24003163, 0.24010392, 0.24017613, 0.24024831, 0.24032043, 0.24039249, 0.24046448, 0.24053642, 0.24060829, 0.24068013, 0.24075189, 0.2408236, 0.24089524, 0.24096683, 0.24103837, 0.24110985, 0.24118127, 0.24125262, 0.24132392, 0.24139516, 0.24146634, 0.24153747, 0.24160852, 0.24167955, 0.24175049, 0.24182139, 0.24189223, 0.24196298, 0.24203372, 0.24210438, 0.24217497, 0.24224553, 0.24231601, 0.24238642, 0.24245678, 0.24252711, 0.24259736, 0.24266754, 0.2427377, 0.24280778, 0.24287778, 0.24294774, 0.24301767, 0.2430875, 0.24315728, 0.24322703, 0.2432967, 0.2433663, 0.24343583, 0.24350534, 0.2435748, 0.24364418, 0.2437135, 0.24378276, 0.24385196, 0.24392113, 0.24399018, 0.24405923, 0.24412821, 0.24419715, 0.24426599, 0.24433479, 0.24440351, 0.24447219, 0.24454083, 0.24460939, 0.2446779, 0.24474634, 0.24481474, 0.24488306, 0.24495135, 0.24501957, 0.24508771, 0.24515583, 0.24522386, 0.24529186, 0.24535978, 0.24542764, 0.24549545, 0.24556319, 0.24563088, 0.24569853, 0.2457661, 0.24583362, 0.24590109, 0.24596848, 0.24603584, 0.24610311, 0.24617036, 0.24623753, 0.24630463, 0.24637169, 0.24643867, 0.24650562, 0.24657251, 0.24663933, 0.24670608, 0.24677281, 0.24683945, 0.24690603, 0.24697256, 0.24703902, 0.24710545, 0.2471718, 0.24723811, 0.24730434, 0.24737051, 0.24743664, 0.2475027, 0.2475687, 0.24763466, 0.24770054, 0.24776639, 0.24783216, 0.24789786, 0.24796353, 0.24802914, 0.24809471, 0.24816017, 0.2482256, 0.24829093, 0.24835627, 0.24842151, 0.2484867, 0.24855183, 0.24861692, 0.24868193, 0.24874689, 0.2488118, 0.24887666, 0.24894142, 0.24900617, 0.24907082, 0.24913546, 0.24919999, 0.24926448, 0.24932891, 0.2493933, 0.24945761, 0.24952187, 0.24958608, 0.24965023, 0.2497143, 0.24977835, 0.24984232, 0.24990623, 0.24997009, 0.25003389, 0.25009763, 0.25016129, 0.25022492, 0.25028849, 0.250352, 0.25041544, 0.25047883, 0.25054216, 0.25060543, 0.25066864, 0.2507318, 0.25079492, 0.25085795, 0.25092092, 0.25098386, 0.25104675, 0.25110954, 0.25117227, 0.25123498, 0.25129759, 0.25136018, 0.2514227, 0.25148517, 0.25154755, 0.25160989, 0.25167221, 0.25173444, 0.2517966, 0.25185871, 0.25192076, 0.25198272, 0.25204468, 0.25210655, 0.25216836, 0.25223017, 0.25229183, 0.25235349, 0.25241509, 0.2524766, 0.25253806, 0.25259948, 0.25266087, 0.25272214, 0.25278336, 0.25284454, 0.25290567, 0.25296673, 0.25302774, 0.25308868, 0.25314957, 0.2532104, 0.25327119, 0.2533319, 0.25339255, 0.25345314, 0.25351366, 0.25357416, 0.2536346, 0.25369495, 0.25375527, 0.2538155, 0.2538757, 0.25393584, 0.2539959, 0.25405595, 0.25411591, 0.25417578, 0.25423563, 0.25429541, 0.25435513, 0.2544148, 0.25447443, 0.25453395, 0.25459346, 0.25465289, 0.25471225, 0.25477159, 0.25483084, 0.25489005, 0.25494921, 0.25500828, 0.25506732, 0.25512627, 0.25518519, 0.25524405, 0.25530285, 0.25536159, 0.25542027, 0.25547889, 0.25553745, 0.25559595, 0.25565436, 0.25571278, 0.25577113, 0.25582936, 0.2558876, 0.25594574, 0.25600386, 0.25606188, 0.25611988, 0.25617781, 0.25623566, 0.25629345, 0.25635123, 0.2564089, 0.25646654, 0.25652412, 0.25658163, 0.25663909, 0.25669649, 0.2567538, 0.25681108, 0.2568683, 0.25692549, 0.25698259, 0.25703967, 0.25709665, 0.25715357, 0.25721046, 0.25726727, 0.25732404, 0.25738072, 0.25743738, 0.25749397, 0.25755051, 0.25760698, 0.25766337, 0.25771973, 0.25777602, 0.25783226, 0.25788844, 0.25794452, 0.25800061, 0.25805661, 0.25811255, 0.25816846, 0.25822425, 0.25828007, 0.25833577, 0.25839141, 0.25844702, 0.25850257, 0.25855806, 0.25861347, 0.25866881, 0.25872412, 0.25877938, 0.25883454, 0.2588897, 0.25894478, 0.25899976, 0.25905475, 0.25910965, 0.25916448, 0.25921926, 0.25927398, 0.25932863, 0.25938326, 0.25943783, 0.25949231, 0.25954673, 0.25960109, 0.25965545, 0.25970969, 0.2597639, 0.25981805, 0.25987211, 0.25992614, 0.25998011, 0.26003402, 0.26008788, 0.26014167, 0.26019537, 0.26024908, 0.26030269, 0.26035625, 0.26040974, 0.26046321, 0.26051655, 0.26056993, 0.26062319, 0.26067638, 0.26072952, 0.26078266, 0.26083568, 0.26088867, 0.26094159, 0.26099443, 0.26104724, 0.26109999, 0.26115265, 0.26120532, 0.26125789, 0.26131037, 0.26136285, 0.26141524, 0.26146761, 0.26151988, 0.26157209, 0.26162425, 0.26167637, 0.26172841, 0.26178041, 0.26183233, 0.26188418, 0.26193601, 0.26198778, 0.26203948, 0.26209113, 0.26214272, 0.26219425, 0.26224568, 0.26229712, 0.26234844, 0.26239976, 0.26245102, 0.26250216, 0.2625533, 0.26260436, 0.26265535, 0.26270628, 0.26275715, 0.262808, 0.26285878, 0.2629095, 0.26296014, 0.26301074, 0.26306126, 0.26311174, 0.26316217, 0.26321253, 0.26326281, 0.26331308, 0.26336327, 0.2634134, 0.26346347, 0.26351348, 0.26356342, 0.26361334, 0.26366317, 0.26371294, 0.26376265, 0.26381233, 0.26386192, 0.26391149, 0.26396096, 0.2640104, 0.26405978, 0.2641091, 0.26415837, 0.26420757, 0.26425669, 0.26430577, 0.2643548, 0.26440379, 0.26445267, 0.26450151, 0.26455033, 0.26459903, 0.26464772, 0.26469636, 0.26474491, 0.2647934, 0.26484182, 0.26489022, 0.26493853, 0.26498681, 0.26503503, 0.26508316, 0.26513129, 0.26517931, 0.26522729, 0.26527521, 0.26532307, 0.26537088, 0.26541862, 0.2654663, 0.26551396, 0.26556149, 0.265609, 0.26565647, 0.26570386, 0.26575121, 0.26579848, 0.26584572, 0.26589286, 0.26593998, 0.26598704, 0.26603401, 0.26608095, 0.26612782, 0.26617464, 0.26622137, 0.26626807, 0.26631474, 0.26636133, 0.26640782, 0.26645428, 0.26650071, 0.26654705, 0.26659334, 0.26663956, 0.26668575, 0.26673186, 0.26677793, 0.26682392, 0.26686984, 0.26691574, 0.26696157, 0.26700735, 0.26705304, 0.2670987, 0.26714429, 0.26718983, 0.26723531, 0.26728073, 0.26732609, 0.26737139, 0.26741663, 0.26746181, 0.26750693, 0.26755202, 0.26759702, 0.26764196, 0.26768687, 0.26773173, 0.26777649, 0.26782122, 0.26786587, 0.26791048, 0.26795501, 0.2679995, 0.26804397, 0.26808828, 0.26813263, 0.26817688, 0.26822105, 0.26826522, 0.2683093, 0.26835334, 0.26839727, 0.2684412, 0.26848501, 0.26852882, 0.26857254, 0.26861626, 0.26865986, 0.26870337, 0.26874691, 0.26879033, 0.26883373, 0.26887703, 0.2689203, 0.26896352, 0.26900667, 0.26904976, 0.2690928, 0.26913577, 0.26917869, 0.26922157, 0.26926437, 0.26930711, 0.26934978, 0.26939243, 0.26943499, 0.26947749, 0.26951995, 0.26956233, 0.26960468, 0.26964697, 0.26968914, 0.26973134, 0.26977345, 0.2698155, 0.2698575, 0.2698994, 0.26994127, 0.26998308, 0.27002484, 0.27006653, 0.27010819, 0.27014974, 0.27019128, 0.27023274, 0.27027413, 0.2703155, 0.27035677, 0.27039802, 0.27043918, 0.27048028, 0.27052137, 0.27056238, 0.2706033, 0.27064416, 0.27068499, 0.27072576, 0.27076647, 0.27080712, 0.27084771, 0.27088824, 0.27092871, 0.27096915, 0.27100947, 0.27104977, 0.27109003, 0.2711302, 0.27117035, 0.27121043, 0.27125043, 0.27129039, 0.27133027, 0.27137008, 0.27140987, 0.2714496, 0.27148926, 0.27152887, 0.27156842, 0.27160791, 0.27164733, 0.27168667, 0.27172598, 0.27176526, 0.27180445, 0.27184358, 0.27188268, 0.27192166, 0.27196065, 0.27199954, 0.2720384, 0.2720772, 0.27211592, 0.2721546, 0.27219322, 0.27223179, 0.27227026, 0.27230868, 0.27234709, 0.27238539, 0.27242365, 0.27246186, 0.27250004, 0.2725381, 0.27257615, 0.27261412, 0.27265203, 0.27268991, 0.2727277, 0.27276546, 0.27280313, 0.27284071, 0.27287832, 0.27291581, 0.27295324, 0.27299067, 0.27302799, 0.27306527, 0.27310249, 0.27313963, 0.27317676, 0.27321377, 0.27325079, 0.27328771, 0.27332458, 0.27336138, 0.27339813, 0.27343485, 0.27347147, 0.27350801, 0.27354458, 0.27358103, 0.27361745, 0.27365378, 0.27369007, 0.27372631, 0.27376246, 0.27379858, 0.27383462, 0.27387065, 0.27390656, 0.27394244, 0.27397826, 0.27401403, 0.27404973, 0.2740854, 0.27412099, 0.27415651, 0.27419198, 0.27422738, 0.27426276, 0.27429804, 0.27433327, 0.27436846, 0.2744036, 0.27443868, 0.27447367, 0.2745086, 0.27454349, 0.27457833, 0.27461314, 0.27464783, 0.27468252, 0.27471712, 0.27475163, 0.27478614, 0.27482057, 0.27485493, 0.27488923, 0.27492347, 0.27495766, 0.27499181, 0.2750259, 0.27505991, 0.27509388, 0.27512777, 0.27516159, 0.27519539, 0.27522916, 0.2752628, 0.27529642, 0.27532998, 0.27536348, 0.27539688, 0.27543026, 0.27546361, 0.27549687, 0.27553007, 0.27556321, 0.27559629, 0.27562934, 0.2756623, 0.2756952, 0.27572808, 0.27576089, 0.27579361, 0.27582628, 0.27585891, 0.27589148, 0.275924, 0.27595645, 0.27598882, 0.27602118, 0.27605343, 0.27608564, 0.2761178, 0.27614993, 0.27618197, 0.27621391, 0.27624586, 0.27627772, 0.27630955, 0.27634129, 0.276373, 0.27640462, 0.27643618, 0.27646771, 0.27649918, 0.27653056, 0.27656192, 0.27659318, 0.27662444, 0.27665561, 0.2766867, 0.27671775, 0.27674878, 0.27677971, 0.27681056, 0.2768414, 0.27687216, 0.27690285, 0.27693349, 0.27695704, 0.27697337, 0.27698967, 0.27700588, 0.27702203, 0.27703807, 0.27705407, 0.27706999, 0.27708584, 0.27710161, 0.27711731, 0.27713296, 0.27714851, 0.27716401, 0.27717942, 0.27719477, 0.27721006, 0.27722529, 0.2772404, 0.27725545, 0.27727047, 0.27728537, 0.27730024, 0.27731499, 0.27732971, 0.27734432, 0.27735889, 0.27737337, 0.2773878, 0.27740213, 0.27741641, 0.27743062, 0.27744472, 0.27745879, 0.27747279, 0.27748671, 0.27750057, 0.27751431, 0.27752802, 0.27754167, 0.27755523, 0.2775687, 0.27758211, 0.27759546, 0.27760872, 0.27762192, 0.27763507, 0.27764812, 0.27766111, 0.27767402, 0.27768683, 0.27769965, 0.27771232, 0.27772495, 0.2777375, 0.27774999, 0.27776238, 0.27777475, 0.277787, 0.27779922, 0.27781135, 0.27782339, 0.27783537, 0.27784726, 0.27785909, 0.27787089, 0.27788258, 0.2778942, 0.27790576, 0.27791724, 0.27792862, 0.27793998, 0.27795124, 0.27796245, 0.27797356, 0.27798462, 0.27799562, 0.27800649, 0.27801734, 0.2780281, 0.2780388, 0.27804941, 0.27805999, 0.27807045, 0.27808085, 0.27809119, 0.27810144, 0.27811167, 0.27812177, 0.27813184, 0.2781418, 0.27815172, 0.27816153, 0.2781713, 0.27818099, 0.27819061, 0.27820015, 0.27820963, 0.27821901, 0.27822837, 0.27823761, 0.27824679, 0.27825594, 0.27826494, 0.27827397, 0.27828285, 0.27829167, 0.27830043, 0.27830914, 0.27831778, 0.2783263, 0.27833474, 0.27834317, 0.27835152, 0.27835974, 0.27836794, 0.27837607, 0.27838409, 0.27839208, 0.27839997, 0.27840778, 0.27841556, 0.27842325, 0.27843085, 0.27843839, 0.27844587, 0.27845326, 0.27846062, 0.27846786, 0.27847502, 0.27848214, 0.27848917, 0.27849615, 0.27850303, 0.27850989, 0.27851662, 0.2785233, 0.27852991, 0.27853647, 0.27854294, 0.27854931, 0.27855563, 0.27856192, 0.27856809, 0.2785742, 0.27858022, 0.27858618, 0.27859208, 0.27859792, 0.27860367, 0.27860934, 0.27861497, 0.27862048, 0.27862597, 0.27863133, 0.27863666, 0.27864191, 0.27864709, 0.27865219, 0.27865723, 0.2786622, 0.27866709, 0.27867192, 0.27867663, 0.27868134, 0.27868593, 0.27869049, 0.27869493, 0.27869934, 0.27870363, 0.27870789, 0.27871206, 0.27871618, 0.2787202, 0.27872416, 0.27872807, 0.27873188, 0.27873564, 0.2787393, 0.27874291, 0.27874643, 0.27874988, 0.27875325, 0.27875659, 0.27875984, 0.278763, 0.2787661, 0.27876917, 0.27877209, 0.27877498, 0.27877781, 0.27878055, 0.27878323, 0.27878582, 0.27878836, 0.2787908, 0.27879319, 0.27879551, 0.27879775, 0.27879992, 0.27880201, 0.27880403, 0.278806, 0.27880788, 0.2788097, 0.27881145, 0.27881309, 0.2788147, 0.27881622, 0.27881768, 0.27881905, 0.2788204, 0.27882162, 0.27882278, 0.27882385, 0.2788249, 0.27882585, 0.27882674, 0.27882755, 0.27882829, 0.27882895, 0.27882951, 0.27883005, 0.27883053, 0.27883089, 0.27883118, 0.27883142, 0.2788316, 0.27883172, 0.27883172, 0.27883166, 0.27883154, 0.27883133, 0.27883109, 0.27883074, 0.27883035, 0.27882984, 0.27882931, 0.27882871, 0.278828, 0.27882722, 0.27882639, 0.27882546, 0.27882451, 0.27882344, 0.27882233, 0.27882114, 0.27881986, 0.27881852, 0.27881712, 0.27881563, 0.27881408, 0.27881244, 0.27881074, 0.27880898, 0.27880713, 0.27880523, 0.27880323, 0.2788012, 0.27879909, 0.27879685, 0.27879462, 0.27879226, 0.27878985, 0.27878734, 0.27878481, 0.27878219, 0.27877948, 0.27877671, 0.27877384, 0.27877095, 0.27876797, 0.2787649, 0.27876177, 0.27875856, 0.27875531, 0.27875197, 0.27874854, 0.27874506, 0.27874148, 0.27873784, 0.27873415, 0.27873036, 0.27872652, 0.27872264, 0.27871862, 0.27871454, 0.27871045, 0.27870625, 0.27870193, 0.27869761, 0.2786932, 0.2786887, 0.27868414, 0.27867952, 0.27867481, 0.27867001, 0.27866518, 0.27866027, 0.27865526, 0.27865022, 0.27864507, 0.27863985, 0.27863458, 0.27862921, 0.27862382, 0.27861831, 0.27861276, 0.27860713, 0.27860141, 0.27859563, 0.27858979, 0.27858385, 0.27857786, 0.27857178, 0.27856565, 0.27855945, 0.27855316, 0.27854681, 0.27854037, 0.27853391, 0.27852732, 0.27852067, 0.27851397, 0.27850717, 0.27850035, 0.2784934, 0.27848643, 0.27847937, 0.27847221, 0.278465, 0.2784577, 0.27845037, 0.27844292, 0.27843544, 0.27842784, 0.27842024, 0.27841249, 0.27840474, 0.27839684, 0.27838895, 0.27838096, 0.27837285, 0.27836472, 0.27835649, 0.27834821, 0.27833986, 0.27833143, 0.27832294, 0.27831435, 0.27830571, 0.27829704, 0.27828822, 0.27827936, 0.27827042, 0.27826142, 0.27825233, 0.27824321, 0.27823398, 0.27822468, 0.27821535, 0.2782059, 0.27819636, 0.27818683, 0.27817717, 0.27816746, 0.27815768, 0.27814782, 0.27813786, 0.27812785, 0.27811778, 0.27810764, 0.27809742, 0.27808714, 0.27807677, 0.27806634, 0.27805582, 0.27804527, 0.2780346, 0.2780239, 0.27801308, 0.27800223, 0.27799129, 0.27798027, 0.27796918, 0.27795804, 0.27794683, 0.27793553, 0.27792418, 0.27791271, 0.2779012, 0.27788964, 0.27787799, 0.27786624, 0.27785447, 0.27784261, 0.27783066, 0.27781865, 0.27780658, 0.27779442, 0.2777822, 0.27776989, 0.27775753, 0.27774507, 0.27773255, 0.27771997, 0.27770734, 0.27769458, 0.2776818, 0.27766892, 0.27765602, 0.277643, 0.27762988, 0.27761674, 0.27760351, 0.27759022, 0.27757683, 0.27756339, 0.27754989, 0.2775363, 0.27752265, 0.27750891, 0.27749512, 0.27748123, 0.27746728, 0.27745327, 0.27743918, 0.27742505, 0.27741078, 0.2773965, 0.27738211, 0.27736765, 0.27735314, 0.27733856, 0.27732393, 0.27730915, 0.27729437, 0.2772795, 0.27726457, 0.27724954, 0.27723444, 0.2772193, 0.27720404, 0.27718872, 0.27717334, 0.27715793, 0.27714238, 0.27712682, 0.27711114, 0.27709541, 0.27707961, 0.27706373, 0.27704778, 0.27703175, 0.27701566, 0.2769995, 0.27698326, 0.27696696, 0.27695057, 0.27693415, 0.27691761, 0.27690101, 0.27688435, 0.27686763, 0.27685079, 0.27683392, 0.27681696, 0.27679995, 0.27678284, 0.27676567, 0.27674842, 0.2767311, 0.27671376, 0.27669629, 0.27667877, 0.27666119, 0.27664348, 0.27662575, 0.27660796, 0.27659005, 0.27657211, 0.27655408, 0.27653599, 0.27651784, 0.27649957, 0.27648124, 0.27646288, 0.27644444, 0.2764259, 0.2764073, 0.27638865, 0.27636987, 0.27635106, 0.27633217, 0.27631322, 0.27629417, 0.2762751, 0.27625594, 0.27623668, 0.27621737, 0.27619797, 0.27617854, 0.27615899, 0.27613938, 0.27611971, 0.27609995, 0.27608013, 0.27606025, 0.27604029, 0.27602026, 0.27600014, 0.27598, 0.27595976, 0.27593943, 0.27591902, 0.27589855, 0.27587804, 0.27585745, 0.27583677, 0.27581599, 0.27579516, 0.27577427, 0.27575332, 0.27573228, 0.27571121, 0.27569002, 0.27566874, 0.27564743, 0.27562603, 0.27560458, 0.27558306, 0.27556145, 0.27553976, 0.275518, 0.27549618, 0.27547431, 0.27545232, 0.27543032, 0.27540818, 0.27538601, 0.27536374, 0.27534142, 0.27531901, 0.27529657, 0.27527404, 0.27525142, 0.27522874, 0.27520597, 0.27518314, 0.27516025, 0.27513728, 0.27511427, 0.27509114, 0.27506796, 0.27504471, 0.27502134, 0.27499798, 0.27497452, 0.27495095, 0.27492735, 0.27490366, 0.2748799, 0.27485606, 0.27483219, 0.27480823, 0.27478418, 0.27476004, 0.27473587, 0.27471161, 0.27468729, 0.27466288, 0.27463841, 0.27461386, 0.27458924, 0.27456456, 0.2745398, 0.27451497, 0.27449006, 0.27446508, 0.27444005, 0.27441493, 0.27438974, 0.27436447, 0.27433917, 0.27431375, 0.27428827, 0.27426273, 0.27423713, 0.27421144, 0.27418566, 0.27415982, 0.27413395, 0.27410796, 0.27408189, 0.27405578, 0.27402958, 0.27400333, 0.27397701, 0.27395058, 0.27392411, 0.27389756, 0.27387094, 0.27384424, 0.27381748, 0.27379066, 0.27376372, 0.27373677, 0.27370971, 0.27368256, 0.27365541, 0.27362812, 0.27360079, 0.2735734, 0.27354592, 0.27351835, 0.27349073, 0.27346304, 0.27343526, 0.27340743, 0.2733795, 0.27335155, 0.27332348, 0.27329534, 0.27326715, 0.27323887, 0.27321053, 0.27318212, 0.27315366, 0.27312508, 0.27309647, 0.27306777, 0.27303901, 0.27301016, 0.27298123, 0.27295226, 0.27292323, 0.27289408, 0.27286488, 0.27283564, 0.27280629, 0.27277684, 0.27274737, 0.2727178, 0.27268818, 0.27265847, 0.27262872, 0.27259886, 0.27256894, 0.27253896, 0.27250889, 0.27247876, 0.27244857, 0.27241829, 0.27238795, 0.27235755, 0.27232707, 0.27229649, 0.27226585, 0.27223518, 0.27220437, 0.27217352, 0.27214262, 0.27211162, 0.27208054, 0.27204943, 0.27201822, 0.27198696, 0.27195561, 0.27192417, 0.2718927, 0.27186111, 0.27182949, 0.27179778, 0.27176598, 0.27173415, 0.27170223, 0.27167025, 0.27163818, 0.27160606, 0.27157381, 0.27154157, 0.2715092, 0.27147678, 0.27144429, 0.27141172, 0.27137908, 0.27134636, 0.27131361, 0.27128074, 0.27124783, 0.27121481, 0.27118176, 0.27114862, 0.27111542, 0.27108213, 0.27104878, 0.27101535, 0.27098185, 0.27094829, 0.27091464, 0.27088094, 0.27084714, 0.27081329, 0.2707794, 0.27074537, 0.2707113, 0.27067718, 0.27064297, 0.27060869, 0.2705743, 0.27053988, 0.27050537, 0.2704708, 0.27043617, 0.27040148, 0.27036667, 0.27033183, 0.27029687, 0.27026188, 0.27022681, 0.2701917, 0.27015647, 0.27012119, 0.27008581, 0.27005038, 0.27001488, 0.2699793, 0.26994365, 0.26990792, 0.26987213, 0.26983631, 0.26980036, 0.26976436, 0.26972827, 0.26969212, 0.26965591, 0.26961961, 0.26958328, 0.26954684, 0.26951033, 0.26947376, 0.2694371, 0.26940039, 0.26936358, 0.26932675, 0.26928979, 0.26925281, 0.26921573, 0.26917857, 0.26914135, 0.26910406, 0.26906669, 0.26902926, 0.26899174, 0.26895416, 0.26891652, 0.26887879, 0.268841, 0.26880315, 0.26876518, 0.26872718, 0.2686891, 0.26865095, 0.26861277, 0.26857445, 0.26853609, 0.26849765, 0.26845914, 0.26842055, 0.26838189, 0.26834318, 0.26830435, 0.26826549, 0.26822659, 0.26818755, 0.26814845, 0.26810932, 0.26807007, 0.26803079, 0.26799142, 0.267952, 0.26791248, 0.2678729, 0.26783323, 0.26779351, 0.26775372, 0.26771384, 0.26767391, 0.26763386, 0.2675938, 0.26755366, 0.26751339, 0.2674731, 0.26743272, 0.26739228, 0.26735178, 0.26731119, 0.26727054, 0.2672298, 0.267189, 0.26714814, 0.26710719, 0.26706618, 0.26702508, 0.26698393, 0.26694268, 0.26690137, 0.26686001, 0.26681855, 0.26677704, 0.26673546, 0.2666938, 0.26665205, 0.26661026, 0.26656836, 0.26652643, 0.26648441, 0.2664423, 0.26640016, 0.26635793, 0.26631561, 0.26627323, 0.26623079, 0.26618829, 0.26614568, 0.26610303, 0.26606029, 0.26601747, 0.26597458, 0.26593164, 0.26588863, 0.26584551, 0.26580235, 0.26575914, 0.26571581, 0.26567245, 0.26562896, 0.26558545, 0.26554185, 0.26549822, 0.26545444, 0.26541066, 0.26536676, 0.2653228, 0.26527879, 0.26523471, 0.26519054, 0.26514629, 0.26510197, 0.26505759, 0.26501313, 0.2649686, 0.26492402, 0.26487935, 0.26483461, 0.26478979, 0.26474491, 0.26469997, 0.26465493, 0.26460984, 0.26456466, 0.26451942, 0.26447409, 0.2644287, 0.26438326, 0.26433772, 0.26429212, 0.26424646, 0.26420072, 0.26415491, 0.26410902, 0.26406306, 0.26401702, 0.26397091, 0.26392475, 0.26387849, 0.26383218, 0.26378578, 0.26373935, 0.2636928, 0.26364622, 0.26359954, 0.26355278, 0.26350597, 0.26345906, 0.26341209, 0.26336509, 0.26331797, 0.26327083, 0.26322356, 0.26317623, 0.26312885, 0.26308137, 0.26303384, 0.26298624, 0.26293856, 0.26289082, 0.26284298, 0.26279512, 0.26274714, 0.2626991, 0.262651, 0.26260284, 0.26255459, 0.26250625, 0.26245788, 0.26240939, 0.26236084, 0.26231223, 0.26226357, 0.26221478, 0.26216599, 0.26211709, 0.26206809, 0.2620191, 0.26196998, 0.26192081, 0.26187155, 0.26182222, 0.26177284, 0.26172337, 0.26167381, 0.26162422, 0.26157454, 0.26152477, 0.26147497, 0.26142505, 0.26137507, 0.26132506, 0.26127493, 0.26122472, 0.2611745, 0.26112416, 0.26107377, 0.26102328, 0.26097274, 0.26092213, 0.26087144, 0.26082069, 0.26076987, 0.26071897, 0.26066801, 0.26061696, 0.26056582, 0.26051465, 0.26046339, 0.26041207, 0.26036063, 0.26030916, 0.26025763, 0.26020601, 0.26015434, 0.26010257, 0.26005071, 0.25999886, 0.25994688, 0.25989482, 0.25984269, 0.25979051, 0.25973827, 0.2596859, 0.25963351, 0.25958103, 0.25952849, 0.25947589, 0.2594232, 0.25937042, 0.25931761, 0.25926468, 0.25921172, 0.25915864, 0.2591055, 0.25905234, 0.25899908, 0.25894573, 0.25889236, 0.25883886, 0.25878531, 0.25873169, 0.25867799, 0.25862423, 0.25857037, 0.25851649, 0.25846249, 0.25840846, 0.25835431, 0.25830013, 0.25824589, 0.25819153, 0.25813711, 0.25808263, 0.25802809, 0.25797346, 0.25791878, 0.257864, 0.25780916, 0.25775424, 0.25769925, 0.25764421, 0.25758907, 0.2575289, 0.25746369, 0.25739846, 0.25733316, 0.25726783, 0.25720248, 0.25713709, 0.25707167, 0.2570062, 0.25694069, 0.25687513, 0.25680959, 0.25674397, 0.25667831, 0.25661263, 0.25654691, 0.25648114, 0.25641534, 0.2563495, 0.25628364, 0.25621775, 0.2561518, 0.25608581, 0.25601977, 0.25595373, 0.25588763, 0.2558215, 0.25575534, 0.25568911, 0.25562289, 0.25555664, 0.2554903, 0.25542393, 0.25535759, 0.25529113, 0.2552247, 0.25515819, 0.25509164, 0.25502509, 0.25495848, 0.25489181, 0.25482515, 0.25475845, 0.25469169, 0.25462487, 0.25455806, 0.25449118, 0.2544243, 0.25435734, 0.25429037, 0.25422338, 0.25415629, 0.25408924, 0.25402209, 0.25395495, 0.25388774, 0.25382051, 0.25375324, 0.25368595, 0.2536186, 0.25355121, 0.25348377, 0.2534163, 0.25334883, 0.25328133, 0.25321376, 0.25314614, 0.25307852, 0.25301084, 0.25294313, 0.25287539, 0.25280762, 0.25273979, 0.2526719, 0.25260401, 0.25253609, 0.25246814, 0.25240013, 0.25233209, 0.25226399, 0.25219589, 0.25212771, 0.25205955, 0.2519913, 0.25192302, 0.25185475, 0.25178644, 0.25171801, 0.25164962, 0.25158116, 0.25151271, 0.25144416, 0.25137562, 0.25130701, 0.25123838, 0.25116974, 0.25110102, 0.25103226, 0.25096351, 0.25089467, 0.25082582, 0.25075692, 0.25068802, 0.25061905, 0.25055006, 0.25048101, 0.25041193, 0.25034282, 0.25027367, 0.25020447, 0.25013527, 0.25006601, 0.24999669, 0.24992739, 0.24985801, 0.2497886, 0.24971919, 0.24964969, 0.24958017, 0.24951063, 0.24944104, 0.24937141, 0.24930175, 0.24923207, 0.2491623, 0.24909255, 0.24902272, 0.2489529, 0.24888299, 0.24881308, 0.24874313, 0.24867314, 0.24860312, 0.24853304, 0.24846295, 0.24839279, 0.24832262, 0.24825241, 0.24818216, 0.24811187, 0.24804154, 0.24797118, 0.24790078, 0.24783033, 0.24775988, 0.24768935, 0.24761882, 0.24754825, 0.24747762, 0.24740696, 0.24733627, 0.24726555, 0.24719478, 0.24712399, 0.24705313, 0.24698226, 0.24691135, 0.2468404, 0.24676941, 0.24669838, 0.24662733, 0.24655622, 0.24648508, 0.2464139, 0.24634273, 0.24627148, 0.24620019, 0.24612889, 0.24605751, 0.24598612, 0.2459147, 0.24584323, 0.24577174, 0.2457002, 0.24562861, 0.245557, 0.24548535, 0.24541368, 0.24534194, 0.24527018, 0.24519837, 0.24512656, 0.24505469, 0.24498276, 0.24491082, 0.24483885, 0.24476685, 0.24469478, 0.24462268, 0.24455057, 0.24447839, 0.24440621, 0.24433395, 0.24426168, 0.24418938, 0.24411702, 0.24404463, 0.24397221, 0.24389975, 0.24382725, 0.24375473, 0.24368216, 0.24360955, 0.2435369, 0.24346423, 0.24339151, 0.24331877, 0.24324596, 0.24317315, 0.24310027, 0.24302736, 0.24295446, 0.24288148, 0.24280846, 0.24273542, 0.24266234, 0.24258922, 0.24251604, 0.24244286, 0.24236962, 0.24229635, 0.24222304, 0.24214971, 0.24207632, 0.24200292, 0.24192946, 0.24185596, 0.24178243, 0.24170886, 0.24163528, 0.24156165, 0.24148796, 0.24141426, 0.24134052, 0.24126673, 0.24119292, 0.24111904, 0.24104516, 0.24097122, 0.24089727, 0.24082324, 0.24074923, 0.24067514, 0.24060102, 0.24052685, 0.24045266, 0.24037845, 0.24030419, 0.24022989, 0.24015556, 0.24008119, 0.24000676, 0.23993233, 0.23985785, 0.23978332, 0.23970878, 0.23963417, 0.23955955, 0.23948489, 0.23941018, 0.23933543, 0.23926066, 0.23918584, 0.23911099, 0.23903611, 0.23896119, 0.23888622, 0.23881121, 0.2387362, 0.2386611, 0.23858601, 0.23851086, 0.23843569, 0.23836045, 0.2382852, 0.23820989, 0.23813458, 0.23805922, 0.23798382, 0.23790836, 0.23783289, 0.23775738, 0.23768182, 0.23760624, 0.23753062, 0.23745495, 0.23737925, 0.23730353, 0.23722775, 0.23715197, 0.2370761, 0.23700021, 0.23692429, 0.23684835, 0.23677236, 0.23669635, 0.23662026, 0.23654418, 0.23646803, 0.23639186, 0.23631562, 0.23623939, 0.23616311, 0.23608679, 0.23601042, 0.23593403, 0.23585759, 0.23578112, 0.2357046, 0.23562805, 0.23555148, 0.23547487, 0.23539822, 0.23532152, 0.23524481, 0.23516802, 0.23509122, 0.23501439, 0.23493752, 0.2348606, 0.23478366, 0.23470667, 0.23462965, 0.23455261, 0.23447549, 0.23439837, 0.23432119, 0.23424399, 0.23416676, 0.23408946, 0.23401213, 0.23393479, 0.23385741, 0.23377998, 0.23370253, 0.23362501, 0.23354748, 0.2334699, 0.2333923, 0.23331465, 0.23323697, 0.23315924, 0.23308149, 0.23300369, 0.23292585, 0.23284799, 0.23277007, 0.23269214, 0.23261417, 0.23253614, 0.2324581, 0.23238, 0.23230189, 0.23222372, 0.2321455, 0.23206729, 0.23198903, 0.23191069, 0.23183236, 0.23175398, 0.23167555, 0.23159708, 0.2315186, 0.23144005, 0.23136149, 0.23128289, 0.23120424, 0.23112556, 0.23104684, 0.23096812, 0.23088932, 0.23081049, 0.23073162, 0.23065272, 0.23057379, 0.23049481, 0.23041581, 0.23033676, 0.23025769, 0.23017858, 0.23009939, 0.23002023, 0.22994097, 0.22986172, 0.2297824, 0.22970305, 0.22962371, 0.22954428, 0.22946483, 0.22938533, 0.2293058, 0.22922625, 0.22914666, 0.22906703, 0.22898735, 0.22890764, 0.22882789, 0.22874811, 0.22866829, 0.22858843, 0.22850855, 0.2284286, 0.22834864, 0.22826865, 0.2281886, 0.22810853, 0.22802842, 0.22794826, 0.22786808, 0.22778787, 0.22770759, 0.22762729, 0.22754698, 0.2274666, 0.22738619, 0.22730573, 0.22722527, 0.22714473, 0.22706418, 0.22698359, 0.22690296, 0.2268223, 0.22674161, 0.22666085, 0.2265801, 0.22649927, 0.22641844, 0.22633754, 0.22625661, 0.22617565, 0.22609466, 0.22601362, 0.22593255, 0.22585145, 0.22577029, 0.22568913, 0.2256079, 0.22552666, 0.22544537, 0.22536404, 0.22528267, 0.22520125, 0.22511983, 0.22503836, 0.22495684, 0.22487529, 0.22479372, 0.22471209, 0.22463042, 0.22454874, 0.22446699, 0.22438522, 0.22430341, 0.22422159, 0.22413969, 0.22405779, 0.22397584, 0.22389384, 0.22381182, 0.22372974, 0.22364764, 0.22356552, 0.22348334, 0.22340111, 0.22331887, 0.22323659, 0.22315428, 0.22307192, 0.22298951, 0.22290708, 0.2228246, 0.22274211, 0.22265957, 0.22257699, 0.22249439, 0.22241171, 0.22232904, 0.22224632, 0.22216354, 0.22208075, 0.2219979, 0.22191502, 0.22183213, 0.22174919, 0.2216662, 0.22158317, 0.22150011, 0.22141702, 0.22133389, 0.22125073, 0.22116752, 0.22108427, 0.221001, 0.22091767, 0.22083433, 0.22075094, 0.22066753, 0.22058405, 0.22050054, 0.22041704, 0.22033346, 0.22024985, 0.22016619, 0.22008252, 0.21999879, 0.21991503, 0.21983124, 0.21974741, 0.21966356, 0.21957965, 0.2194957, 0.21941173, 0.21932772, 0.21924366, 0.21915957, 0.21907546, 0.21899129, 0.21890709, 0.21882285, 0.21873859, 0.21865429, 0.2185699, 0.21848553, 0.21840112, 0.21831669, 0.21823218, 0.21814765, 0.21806307, 0.21797848, 0.21789384, 0.21780916, 0.21772443, 0.2176397, 0.21755493, 0.21747009, 0.21738522, 0.21730033, 0.2172154, 0.21713042, 0.21704543, 0.21696037, 0.21687528, 0.21679017, 0.21670501, 0.21661983, 0.2165346, 0.21644934, 0.21636404, 0.21627872, 0.21619332, 0.21610792, 0.21602245, 0.21593697, 0.21585144, 0.21576588, 0.2156803, 0.21559466, 0.21550898, 0.21542327, 0.21533753, 0.21525176, 0.21516594, 0.21508008, 0.21499419, 0.21490827, 0.21482231, 0.2147363, 0.21465026, 0.21456417, 0.21447806, 0.21439193, 0.21430576, 0.21421951, 0.21413326, 0.21404697, 0.21396063, 0.21387427, 0.21378787, 0.21370141, 0.21361493, 0.21352841, 0.21344185, 0.21335526, 0.21326865, 0.21318197, 0.21309528, 0.21300855, 0.21292177, 0.21283495, 0.2127481, 0.21266122, 0.21257432, 0.21248734, 0.21240035, 0.21231332, 0.21222626, 0.21213914, 0.212052, 0.21196483, 0.2118776, 0.21179035, 0.21170306, 0.21161573, 0.21152836, 0.21144098, 0.21135354, 0.21126606, 0.21117857, 0.21109101, 0.21100344, 0.21091582, 0.21082816, 0.21074045, 0.21065272, 0.21056496, 0.21047714, 0.21038932, 0.21030144, 0.21021351, 0.21012555, 0.21003757, 0.20994957, 0.20986149, 0.20977339, 0.20968525, 0.20959707, 0.20950887, 0.20942062, 0.20933235, 0.20924403, 0.20915566, 0.20906727, 0.20897885, 0.20889038, 0.20880187, 0.20871332, 0.20862477, 0.20853615, 0.20844749, 0.20835881, 0.20827009, 0.20818131, 0.20809251, 0.2080037, 0.20791481, 0.2078259, 0.20773695, 0.20764798, 0.20755896, 0.20746991, 0.20738079, 0.20729168, 0.20720252, 0.20711331, 0.20702407, 0.20693478, 0.20684549, 0.20675613, 0.20666674, 0.20657732, 0.20648786, 0.20639837, 0.20630883, 0.20621926, 0.20612966, 0.20604001, 0.2059503, 0.2058606, 0.20577085, 0.20568104, 0.20559123, 0.20550135, 0.20541145, 0.20532152, 0.20523153, 0.20514153, 0.2050515, 0.2049614, 0.20487128, 0.20478112, 0.20469093, 0.20460071, 0.20451041, 0.2044201, 0.20432976, 0.20423937, 0.20414895, 0.2040585, 0.20396803, 0.20387749, 0.20378692, 0.20369634, 0.20360568, 0.20351501, 0.2034243, 0.20333356, 0.20324276, 0.20315194, 0.20306109, 0.20297019, 0.20287925, 0.20278828, 0.20269728, 0.20260623, 0.20251516, 0.20242405, 0.20233288, 0.20224169, 0.20215046, 0.20205922, 0.2019679, 0.20187658, 0.20178519, 0.20169377, 0.20160232, 0.20151086, 0.20141932, 0.20132777, 0.20123617, 0.20114455, 0.20105287, 0.20096117, 0.20086943, 0.20077765, 0.20068583, 0.20059399, 0.20050208, 0.20041019, 0.2003182, 0.2002262, 0.20013416, 0.2000421, 0.19994996, 0.19985783, 0.19976567, 0.19967343, 0.19958118, 0.19948889, 0.19939655, 0.19930418, 0.19921178, 0.19911933, 0.19902687, 0.19893435, 0.19884178, 0.19874921, 0.19865657, 0.19856392, 0.19847122, 0.19837847, 0.1982857, 0.19819289, 0.19810003, 0.19800718, 0.19791424, 0.19782129, 0.19772829, 0.19763528, 0.19754218, 0.1974491, 0.19735596, 0.19726276, 0.19716956, 0.19707632, 0.19698301, 0.1968897, 0.19679634, 0.19670294, 0.19660951, 0.19651605, 0.19642253, 0.19632897, 0.1962354, 0.19614179, 0.19604811, 0.19595443, 0.19586071, 0.19576693, 0.19567314, 0.19557931, 0.1954854, 0.19539151, 0.19529755, 0.19520357, 0.19510955, 0.19501549, 0.19492139, 0.19482724, 0.19473307, 0.19463888, 0.19454463, 0.19445033, 0.19435601, 0.19426167, 0.19416729, 0.19407286, 0.19397837, 0.19388388, 0.19378935, 0.19369477, 0.19360016, 0.1935055, 0.19341083, 0.19331609, 0.19322133, 0.19312653, 0.19303171, 0.19293684, 0.19284192, 0.19274698, 0.192652, 0.19255699, 0.19246192, 0.19236684, 0.19227171, 0.19217655, 0.19208138, 0.19198613, 0.19189084, 0.19179551, 0.19170018, 0.19160481, 0.19150937, 0.19141389, 0.19131841, 0.19122288, 0.19112732, 0.19103171, 0.19093604, 0.19084038, 0.19074467, 0.19064891, 0.19055311, 0.1904573, 0.19036143, 0.19026552, 0.19016959, 0.19007362, 0.18997759, 0.18988156, 0.18978547, 0.18968935, 0.1895932, 0.18949701, 0.18940076, 0.1893045, 0.18920818, 0.18911186, 0.18901546, 0.18891907, 0.18882261, 0.18872611, 0.1886296, 0.18853302, 0.18843643, 0.18833977, 0.18824311, 0.1881464, 0.18804966, 0.18795289, 0.18785605, 0.18775921, 0.18766229, 0.18756537, 0.18746839, 0.18737139, 0.18727437, 0.18717727, 0.18708016, 0.18698302, 0.18688582, 0.18678859, 0.18669133, 0.18659402, 0.1864967, 0.18639934, 0.1863019, 0.18620448, 0.18610698, 0.18600947, 0.18591191, 0.18581431, 0.18571669, 0.18561901, 0.1855213, 0.18542358, 0.1853258, 0.18522799, 0.18513013, 0.18503223, 0.18493432, 0.18483637, 0.18473837, 0.18464033, 0.18454225, 0.18444414, 0.18434601, 0.18424784, 0.18414961, 0.18405133, 0.18395306, 0.18385471, 0.18375635, 0.18365796, 0.18355952, 0.18346103, 0.18336253, 0.18326397, 0.18316539, 0.18306677, 0.18296812, 0.1828694, 0.18277067, 0.1826719, 0.18257309, 0.18247424, 0.18237537, 0.18227643, 0.18217748, 0.18207851, 0.18197946, 0.1818804, 0.18178131, 0.18168217, 0.18158297, 0.18148378, 0.18138455, 0.18128525, 0.1811859, 0.18108657, 0.18098716, 0.18088771, 0.18078826, 0.18068877, 0.18058918, 0.18048963, 0.18039002, 0.18029036, 0.18019067, 0.18009095, 0.17999119, 0.17989136, 0.17979151, 0.17969166, 0.17959176, 0.1794918, 0.1793918, 0.1792918, 0.17919172, 0.17909165, 0.1789915, 0.17889133, 0.17879112, 0.17869087, 0.1785906, 0.1784903, 0.17838994, 0.17828953, 0.17818913, 0.17808865, 0.17798814, 0.17788762, 0.17778704, 0.17768644, 0.1775858, 0.17748511, 0.17738436, 0.17728361, 0.17718282, 0.17708197, 0.17698111, 0.17688021, 0.17677927, 0.17667829, 0.17657728, 0.17647623, 0.17637514, 0.17627402, 0.17617284, 0.17607164, 0.17597042, 0.17586915, 0.17576784, 0.17566648, 0.17556508, 0.17546368, 0.17536221, 0.17526072, 0.17515919, 0.17505762, 0.17495602, 0.17485437, 0.17475271, 0.17465098, 0.17454924, 0.17444745, 0.17434561, 0.17424376, 0.17414187, 0.17403993, 0.17393929, 0.17383997, 0.17374066, 0.17364137, 0.17354207, 0.1734428, 0.17334352, 0.1732443, 0.17314506, 0.17304583, 0.17294663, 0.17284743, 0.17274827, 0.17264907, 0.17254993, 0.17245078, 0.17235164, 0.17225252, 0.17215343, 0.17205432, 0.17195523, 0.17185616, 0.17175712, 0.17165807, 0.17155905, 0.17146002, 0.17136101, 0.17126203, 0.17116302, 0.17106408, 0.17096512, 0.17086618, 0.17076726, 0.17066833, 0.17056943, 0.17047054, 0.17037165, 0.17027278, 0.17017396, 0.1700751, 0.16997626, 0.16987747, 0.16977865, 0.16967987, 0.16958109, 0.16948232, 0.16938357, 0.16928484, 0.1691861, 0.1690874, 0.16898869, 0.16889, 0.16879132, 0.16869266, 0.16859402, 0.16849539, 0.16839676, 0.16829814, 0.16819954, 0.16810097, 0.16800238, 0.16790381, 0.16780527, 0.16770673, 0.16760823, 0.1675097, 0.16741121, 0.16731271, 0.16721426, 0.16711579, 0.16701733, 0.16691889, 0.1668205, 0.16672209, 0.16662368, 0.16652529, 0.16642691, 0.16632856, 0.16623022, 0.16613188, 0.16603357, 0.16593525, 0.16583696, 0.16573869, 0.16564041, 0.16554217, 0.1654439, 0.16534568, 0.16524746, 0.16514927, 0.16505106, 0.16495287, 0.16485472, 0.16475658, 0.16465841, 0.16456029, 0.16446216, 0.16436407, 0.16426599, 0.1641679, 0.16406985, 0.16397178, 0.16387373, 0.16377571, 0.16367769, 0.1635797, 0.1634817, 0.16338372, 0.16328578, 0.1631878, 0.16308987, 0.16299196, 0.16289404, 0.16279612, 0.16269824, 0.16260035, 0.16250251, 0.16240466, 0.16230682, 0.162209, 0.16211116, 0.16201337, 0.1619156, 0.16181782, 0.16172007, 0.16162229, 0.16152456, 0.16142684, 0.16132914, 0.16123144, 0.16113375, 0.16103609, 0.16093843, 0.16084078, 0.16074315, 0.16064551, 0.16054791, 0.16045032, 0.16035274, 0.16025516, 0.16015759, 0.16006005, 0.15996252, 0.15986502, 0.15976749, 0.15967, 0.15957251, 0.15947504, 0.15937757, 0.15928015, 0.15918271, 0.15908532, 0.15898789, 0.1588905, 0.15879312, 0.15869576, 0.15859839, 0.15850103, 0.15840374, 0.1583064, 0.15820909, 0.1581118, 0.15801454, 0.15791725, 0.15782002, 0.15772277, 0.15762556, 0.15752831, 0.15743111, 0.15733393, 0.15723677, 0.15713958, 0.15704243, 0.1569453, 0.15684818, 0.15675107, 0.15665396, 0.15655687, 0.15645981, 0.15636271, 0.15626566, 0.15616865, 0.15607162, 0.15597461, 0.15587761, 0.15578061, 0.15568364, 0.15558669, 0.15548973, 0.1553928, 0.15529586, 0.15519898, 0.15510206, 0.15500519, 0.1549083, 0.15481146, 0.1547146, 0.15461777, 0.15452093, 0.15442413, 0.15432735, 0.15423055, 0.1541338, 0.15403703, 0.15394029, 0.15384355, 0.15374683, 0.15365012, 0.15355341, 0.15345675, 0.15336005, 0.15326342, 0.15316679, 0.15307015, 0.15297352, 0.15287691, 0.15278031, 0.15268375, 0.15258718, 0.15249062, 0.15239409, 0.15229753, 0.15220101, 0.15210453, 0.15200804, 0.15191154, 0.15181509, 0.15171863, 0.15162219, 0.15152577, 0.15142936, 0.15133294, 0.15123656, 0.15114017, 0.15104382, 0.15094745, 0.15085112, 0.15075479, 0.15065849, 0.1505622, 0.15046591, 0.15036961, 0.15027337, 0.15017709, 0.15008086, 0.14998463, 0.14988841, 0.14979222, 0.14969604, 0.14959987, 0.14950371, 0.14940755, 0.14931141, 0.1492153, 0.14911917, 0.14902309, 0.14892699, 0.14883094, 0.14873487, 0.1486388, 0.14854279, 0.14844675, 0.14835075, 0.14825475, 0.14815877, 0.1480628, 0.14796683, 0.1478709, 0.14777496, 0.14767905, 0.14758311, 0.14748724, 0.14739135, 0.14729548, 0.14719963, 0.14710379, 0.14700794, 0.14691213, 0.14681634, 0.14672053, 0.14662476, 0.14652899, 0.14643322, 0.14633749, 0.14624175, 0.14614604, 0.14605032, 0.14595464, 0.14585896, 0.14576331, 0.14566764, 0.14557201, 0.14547637, 0.14538075, 0.14528514, 0.14518957, 0.14509399, 0.14499842, 0.14490287, 0.14480732, 0.14471181, 0.14461628, 0.14452079, 0.14442529, 0.14432982, 0.14423434, 0.1441389, 0.14404348, 0.14394805, 0.14385264, 0.14375724, 0.14366184, 0.14356647, 0.14347111, 0.14337577, 0.14328043, 0.14318509, 0.14308979, 0.14299451, 0.1428992, 0.14280394, 0.14270867, 0.14261343, 0.14251819, 0.14242297, 0.14232776, 0.14223255, 0.14213738, 0.1420422, 0.14194705, 0.1418519, 0.14175676, 0.14166166, 0.14156653, 0.14147145, 0.14137636, 0.14128129, 0.14118622, 0.14109118, 0.14099616, 0.14090115, 0.14080614, 0.14071113, 0.14061615, 0.14052118, 0.14042622, 0.1403313, 0.14023636, 0.14014144, 0.14004654, 0.13995165, 0.13985676, 0.13976189, 0.13966705, 0.1395722, 0.13947737, 0.13938256, 0.13928775, 0.13919295, 0.13909817, 0.13900343, 0.13890867, 0.13881393, 0.1387192, 0.13862449, 0.13852978, 0.1384351, 0.13834041, 0.13824576, 0.13815111, 0.13805646, 0.13796185, 0.13786723, 0.13777263, 0.13767804, 0.13758346, 0.1374889, 0.13739437, 0.13729981, 0.13720529, 0.13711078, 0.13701628, 0.13692181, 0.13682733, 0.13673286, 0.13663842, 0.13654397, 0.13644956, 0.13635516, 0.13626076, 0.13616636, 0.13607201, 0.13597764, 0.13588329, 0.13578896, 0.13569464, 0.13560033, 0.13550603, 0.13541175, 0.13531749, 0.13522322, 0.13512897, 0.13503475, 0.13494053, 0.13484633, 0.13475214, 0.13465795, 0.13456377, 0.13446961, 0.13437548, 0.13428134, 0.13418724, 0.13409312, 0.13399903, 0.13390496, 0.13381089, 0.13371684, 0.1336228, 0.13352877, 0.13343474, 0.13334073, 0.13324675, 0.13315277, 0.13305882, 0.13296486, 0.13287091, 0.13277699, 0.13268307, 0.13258918, 0.1324953, 0.13240141, 0.13230754, 0.1322137, 0.13211985, 0.13202602, 0.13193223, 0.13183843, 0.13174462, 0.13165087, 0.13155709, 0.13146333, 0.13136961, 0.13127588, 0.13118218, 0.13108847, 0.1309948, 0.13090111, 0.13080746, 0.13071381, 0.13062017, 0.13052654, 0.13043293, 0.13033934, 0.13024576, 0.13015218, 0.13005863, 0.12996508, 0.12987155, 0.12977803, 0.12968451, 0.12959102, 0.12949753, 0.12940408, 0.12931061, 0.12921716, 0.12912373, 0.12903032, 0.1289369, 0.1288435, 0.12875013, 0.12865676, 0.12856342, 0.12847006, 0.12837674, 0.12828343, 0.12819012, 0.12809682, 0.12800354, 0.12791027, 0.12781702, 0.12772377, 0.12763055, 0.12753733, 0.12744413, 0.12735094, 0.12725776, 0.1271646, 0.12707143, 0.12697831, 0.12688516, 0.12679204, 0.12669894, 0.12660585, 0.12651277, 0.12641972, 0.12632667, 0.12623364, 0.12614061, 0.1260476, 0.12595461, 0.12586161, 0.12576863, 0.12567566, 0.12558271, 0.12548979, 0.12539686, 0.12530395, 0.12521105, 0.12511815, 0.1250253, 0.12493244, 0.12483957, 0.12474675, 0.12465392, 0.12456112, 0.12446833, 0.12437553, 0.12428276, 0.12418999, 0.12409725, 0.12400453, 0.12391181, 0.12381908, 0.1237264, 0.12363371, 0.12354103, 0.12344839, 0.12335573, 0.12326311, 0.12317048, 0.12307788, 0.12298528, 0.1228927, 0.12280013, 0.12270758, 0.12261504, 0.1225225, 0.12242997, 0.12233748, 0.12224498, 0.1221525, 0.12206004, 0.12196759, 0.12187515, 0.12178271, 0.1216903, 0.12159789, 0.12150551, 0.12141313, 0.12132076, 0.12122841, 0.12113606, 0.12104373, 0.12095143, 0.12085912, 0.12076683, 0.12067456, 0.12058229, 0.12049004, 0.1203978, 0.12030558, 0.12021336, 0.12012116, 0.12002897, 0.11993679, 0.11984463, 0.11975249, 0.11966035, 0.11956823, 0.11947612, 0.11938402, 0.11929193, 0.11919985, 0.11910778, 0.11901574, 0.11892371, 0.11883168, 0.11873967, 0.11864768, 0.11855568, 0.11846372, 0.11837176, 0.11827982, 0.1181879, 0.11809597, 0.11800406, 0.11791216, 0.11782027, 0.11772839, 0.11763654, 0.1175447, 0.11745286, 0.11736104, 0.11726923, 0.11717744, 0.11708568, 0.1169939, 0.11690215, 0.1168104, 0.11671867, 0.11662695, 0.11653524, 0.11644355, 0.11635187, 0.11626019, 0.11616854, 0.1160769, 0.11598527, 0.11589365, 0.11580206, 0.11571047, 0.1156189, 0.11552732, 0.11543577, 0.11534423, 0.1152527, 0.11516117, 0.11506969, 0.11497819, 0.11488672, 0.11479525, 0.1147038, 0.11461236, 0.11452092, 0.11442953, 0.11433812, 0.11424674, 0.11415537, 0.114064, 0.11397264, 0.11388131, 0.11378998, 0.11369867, 0.11360737, 0.11351608, 0.1134248, 0.11333355, 0.1132423, 0.11315106, 0.11305986, 0.11296864, 0.11287744, 0.11278626, 0.11269508, 0.11260392, 0.11251277, 0.11242165, 0.11233052, 0.11223941, 0.11214831, 0.11205722, 0.11196614, 0.11187509, 0.11178406, 0.11169303, 0.11160201, 0.111511, 0.11142001, 0.11132902, 0.11123805, 0.11114709, 0.11105615, 0.11096521, 0.11087429, 0.11078339, 0.1106925, 0.11060162, 0.11051075, 0.1104199, 0.11032906, 0.11023823, 0.11014742, 0.1100566, 0.10996581, 0.10987504, 0.10978428, 0.10969352, 0.10960278, 0.10951204, 0.10942133, 0.10933062, 0.10923994, 0.10914927, 0.1090586, 0.10896795, 0.1088773, 0.10878669, 0.10869607, 0.10860547, 0.10851488, 0.1084243, 0.10833374, 0.1082432, 0.10815266, 0.10806212, 0.10797161, 0.10788111, 0.10779063, 0.10770015, 0.1076097, 0.10751925, 0.10742882, 0.10733839, 0.10724798, 0.10715757, 0.10706718, 0.10697682, 0.10688646, 0.1067961, 0.10670577, 0.10661545, 0.10652515, 0.10643487, 0.10634458, 0.1062543, 0.10616404, 0.1060738, 0.10598357, 0.10589334, 0.10580313, 0.10571294, 0.10562275, 0.10553259, 0.10544243, 0.10535228, 0.10526216, 0.10517205, 0.10508194, 0.10499184, 0.10490177, 0.10481169, 0.10472164, 0.10463159, 0.10454157, 0.10445156, 0.10436155, 0.10427155, 0.10418157, 0.10409161, 0.10400166, 0.10391172, 0.10382179, 0.10373187, 0.10364196, 0.10355207, 0.10346221, 0.10337235, 0.10328248, 0.10319263, 0.10310282, 0.10301301, 0.1029232, 0.10283341, 0.10274363, 0.10265388, 0.10256413, 0.1024744, 0.10238467, 0.10229496, 0.10220525, 0.10211556, 0.10202589, 0.10193623, 0.10184658, 0.10175694, 0.10166731, 0.10157771, 0.10148811, 0.10139851, 0.10130896, 0.1012194, 0.10112984, 0.10104031, 0.10095079, 0.10086127, 0.10077178, 0.10068231, 0.10059283, 0.10050336, 0.10041392, 0.10032449, 0.10023507, 0.10014566, 0.10005628, 0.099966899, 0.099877514, 0.099788174, 0.099698827, 0.099609479, 0.099520169, 0.099430867, 0.099341571, 0.099252284, 0.099163018, 0.099073768, 0.098984517, 0.098895296, 0.098806076, 0.098716885, 0.098627694, 0.098538496, 0.098449335, 0.098360181, 0.098271042, 0.098181926, 0.098092809, 0.098003693, 0.097914599, 0.097825535, 0.09773647, 0.097647399, 0.097558364, 0.097469352, 0.097380333, 0.097291335, 0.097202353, 0.097113356, 0.097024411, 0.096935451, 0.096846521, 0.096757591, 0.096668676, 0.096579775, 0.09649089, 0.096402012, 0.096313156, 0.096224293, 0.09613549, 0.096046664, 0.095957845, 0.095869042, 0.095780253, 0.09569148, 0.095602728, 0.09551397, 0.095425233, 0.095336512, 0.095247805, 0.095159106, 0.095070414, 0.09498176, 0.094893113, 0.094804458, 0.094715826, 0.094627194, 0.094538592, 0.094449989, 0.09436141, 0.094272844, 0.094184279, 0.094095729, 0.094007209, 0.093918689, 0.093830176, 0.093741693, 0.09365321, 0.093564756, 0.093476295, 0.09338785, 0.093299426, 0.093210995, 0.093122594, 0.093034215, 0.092945829, 0.09285745, 0.092769101, 0.092680767, 0.092592433, 0.092504114, 0.092415802, 0.092327528, 0.092239253, 0.092150986, 0.092062727, 0.091974497, 0.091886275, 0.091798052, 0.091709852, 0.09162166, 0.091533482, 0.091445319, 0.091357172, 0.091269016, 0.091180906, 0.091092795, 0.091004707, 0.090916611, 0.09082853, 0.090740465, 0.090652421, 0.090564385, 0.090476364, 0.090388343, 0.090300359, 0.090212367, 0.090124391, 0.090036429, 0.089948475, 0.089860551, 0.089772642, 0.089684725, 0.089596823, 0.089508936, 0.089421071, 0.089333206, 0.089245364, 0.089157529, 0.089069709, 0.088981897, 0.088894106, 0.088806316, 0.088718548, 0.088630795, 0.088543057, 0.088455334, 0.088367596, 0.088279895, 0.08819221, 0.088104516, 0.088016853, 0.087929197, 0.087841555, 0.087753929, 0.08766631, 0.087578699, 0.087491117, 0.087403521, 0.087315954, 0.087228425, 0.087140873, 0.087053344, 0.086965829, 0.08687833, 0.086790837, 0.086703353, 0.086615898, 0.086528435, 0.086440988, 0.086353563, 0.08626616, 0.08617875, 0.086091362, 0.086003989, 0.085916638, 0.085829288, 0.085741945, 0.085654616, 0.085567296, 0.085480005, 0.085392714, 0.08530543, 0.085218176, 0.085130922, 0.085043684, 0.08495646, 0.084869251, 0.084782034, 0.084694877, 0.084607705, 0.084520549, 0.084433392, 0.08434625, 0.08425913, 0.084172018, 0.084084928, 0.083997831, 0.083910778, 0.083823696, 0.083736658, 0.083649635, 0.083562613, 0.08347562, 0.083388612, 0.083301634, 0.08321467, 0.0831277, 0.083040759, 0.082953818, 0.082866892, 0.082780004, 0.0826931, 0.082606219, 0.08251936, 0.082432494, 0.082345642, 0.082258828, 0.082172014, 0.082085215, 0.081998415, 0.081911631, 0.081824869, 0.081738122, 0.081651375, 0.081564642, 0.081477925, 0.081391223, 0.081304528, 0.081217848, 0.08113119, 0.081044525, 0.080963373, 0.080887713, 0.080812037, 0.080736421, 0.080660842, 0.080585279, 0.080509774, 0.0804343, 0.080358863, 0.080283441, 0.080208078, 0.080132738, 0.080057442, 0.079982169, 0.079906955, 0.079831757, 0.079756603, 0.079681456, 0.079606369, 0.079531312, 0.079456292, 0.079381302, 0.079306349, 0.079231441, 0.079156548, 0.079081714, 0.079006881, 0.078932121, 0.078857377, 0.078782693, 0.078708023, 0.078633383, 0.078558788, 0.0784842, 0.078409687, 0.078335188, 0.078260727, 0.078186303, 0.078111917, 0.078037567, 0.07796324, 0.077888958, 0.077814698, 0.07774049, 0.07766632, 0.077592179, 0.077518053, 0.077443987, 0.077369951, 0.077295952, 0.077221982, 0.07714805, 0.077074148, 0.07700029, 0.076926447, 0.076852657, 0.076778904, 0.076705173, 0.076631486, 0.076557845, 0.076484226, 0.076410644, 0.076337092, 0.076263577, 0.076190114, 0.076116651, 0.076043256, 0.075969875, 0.075896554, 0.075823225, 0.075749971, 0.075676732, 0.075603552, 0.075530395, 0.07545726, 0.07538417, 0.075311109, 0.075238086, 0.0751651, 0.075092144, 0.07501924, 0.074946351, 0.074873507, 0.074800692, 0.074727923, 0.074655168, 0.074582472, 0.074509814, 0.074437179, 0.074364573, 0.074292012, 0.074219473, 0.074146979, 0.074074522, 0.074002095, 0.073929705, 0.07385736, 0.073785037, 0.073712744, 0.073640503, 0.073568277, 0.073496111, 0.073423967, 0.073351867, 0.073279768, 0.073207729, 0.073135734, 0.073063776, 0.072991841, 0.072919942, 0.072848082, 0.072776251, 0.072704442, 0.072632693, 0.072560966, 0.072489277, 0.072417632, 0.072346017, 0.072274432, 0.072202884, 0.072131373, 0.072059885, 0.071988456, 0.071917035, 0.071845666, 0.071774326, 0.071703024, 0.071631752, 0.071560532, 0.071489327, 0.071418181, 0.07134705, 0.071275957, 0.071204893, 0.071133882, 0.071062893, 0.070991933, 0.070921019, 0.070850141, 0.070779294, 0.070708483, 0.07063771, 0.070566952, 0.070496254, 0.070425585, 0.070354961, 0.070284352, 0.070213795, 0.07014326, 0.070072763, 0.07000231, 0.06993188, 0.069861479, 0.069791138, 0.069720805, 0.069650538, 0.069580287, 0.069510065, 0.069439873, 0.069369748, 0.069299631, 0.069229566, 0.069159515, 0.069089517, 0.069019549, 0.068949617, 0.068879724, 0.068809859, 0.068740018, 0.068670228, 0.068600468, 0.068530731, 0.068461061, 0.068391412, 0.068321787, 0.068252213, 0.068182647, 0.068113148, 0.068043672, 0.067974217, 0.067904808, 0.067835443, 0.067766108, 0.067696802, 0.067627534, 0.067558296, 0.067489102, 0.067419931, 0.067350835, 0.06728173, 0.067212678, 0.067143649, 0.067074656, 0.067005709, 0.066936798, 0.06686791, 0.066799067, 0.066730246, 0.06666147, 0.066592731, 0.066524021, 0.066455349, 0.066386737, 0.066318132, 0.066249572, 0.066181034, 0.066112541, 0.06604407, 0.065975644, 0.065907255, 0.065838896, 0.065770581, 0.065702289, 0.065634035, 0.065565832, 0.065497644, 0.065429501, 0.065361403, 0.06529332, 0.065225281, 0.065157272, 0.065089308, 0.065021381, 0.064953476, 0.064885601, 0.064817786, 0.064750001, 0.064682238, 0.064614512, 0.064546816, 0.064479157, 0.064411543, 0.064343981, 0.06427642, 0.064208902, 0.064141423, 0.06407398, 0.064006582, 0.063939206, 0.063871861, 0.063804552, 0.063737303, 0.063670062, 0.063602865, 0.063535705, 0.063468575, 0.06340149, 0.063334443, 0.063267417, 0.063200422, 0.063133463, 0.063066565, 0.062999681, 0.062932819, 0.062866002, 0.062799238, 0.062732488, 0.062665783, 0.062599108, 0.062532462, 0.06246588, 0.06239932, 0.06233279, 0.06226629, 0.062199824, 0.062133398, 0.06206701, 0.062000651, 0.061934333, 0.061868042, 0.061801795, 0.061735578, 0.061669398, 0.061603237, 0.061537147, 0.061471075, 0.061405044, 0.061339036, 0.061273057, 0.061207119, 0.061141238, 0.061075363, 0.06100953, 0.06094373, 0.06087799, 0.060812261, 0.060746562, 0.060680907, 0.060615283, 0.060549717, 0.060484178, 0.060418662, 0.060353171, 0.060287725, 0.06022232, 0.060156949, 0.060091615, 0.060026307, 0.059961028, 0.059895806, 0.059830606, 0.059765436, 0.059700329, 0.059635218, 0.059570171, 0.05950515, 0.059440166, 0.059375212, 0.059310287, 0.059245411, 0.059180565, 0.059115741, 0.059050962, 0.058986247, 0.058921535, 0.058856867, 0.058792226, 0.058727611, 0.058663055, 0.05859853, 0.058534019, 0.058469556, 0.058405142, 0.058340754, 0.058276407, 0.058212087, 0.058147795, 0.058083534, 0.058019336, 0.057955138, 0.057891008, 0.057826888, 0.05776282, 0.057698768, 0.057634789, 0.057570811, 0.05750687, 0.057442971, 0.057379112, 0.057315283, 0.057251483, 0.057187717, 0.057124011, 0.057060309, 0.056996655, 0.056933034, 0.056869444, 0.056805905, 0.056742404, 0.056678917, 0.056615472, 0.05655206, 0.056488674, 0.056425355, 0.056362044, 0.056298774, 0.056235541, 0.056172349, 0.056109183, 0.056046054, 0.055982951, 0.055919901, 0.055856887, 0.055793904, 0.055730954, 0.055668026, 0.055605147, 0.055542309, 0.055479493, 0.055416703, 0.055353962, 0.055291269, 0.055228587, 0.055165946, 0.05510335, 0.055040773, 0.054978263, 0.054915767, 0.054853301, 0.054790877, 0.054728489, 0.054666117, 0.054603815, 0.054541521, 0.05447926, 0.054417048, 0.054354873, 0.05429272, 0.054230612, 0.054168522, 0.054106504, 0.054044496, 0.053982537, 0.053920597, 0.05385869, 0.053796817, 0.053735003, 0.053673204, 0.053611442, 0.053549711, 0.053488027, 0.05342637, 0.05336475, 0.053303163, 0.053241607, 0.053180106, 0.05311865, 0.053057197, 0.052995775, 0.052934401, 0.05287306, 0.05281176, 0.052750498, 0.052689258, 0.052628059, 0.052566901, 0.052505776, 0.052444667, 0.052383609, 0.0523226, 0.052261606, 0.052200668, 0.052139752, 0.052078854, 0.052018013, 0.051957205, 0.051896419, 0.051835671, 0.051774964, 0.051714301, 0.051653679, 0.051593076, 0.051532499, 0.051471967, 0.051411469, 0.051351018, 0.051290583, 0.0512302, 0.051169831, 0.051109504, 0.051049232, 0.050988991, 0.05092876, 0.050868586, 0.050808448, 0.05074833, 0.050688252, 0.050628204, 0.050568204, 0.050508231, 0.050448313, 0.0503884, 0.050328549, 0.050268713, 0.05020893, 0.050149158, 0.050089441, 0.050029743, 0.04997009, 0.049910478, 0.049850885, 0.049791329, 0.049731817, 0.049672343, 0.049612917, 0.049553499, 0.049494132, 0.049434781, 0.049375474, 0.049316213, 0.049256977, 0.049197767, 0.049138606, 0.049079485, 0.049020384, 0.048961326, 0.048902296, 0.048843332, 0.048784371, 0.048725471, 0.04866657, 0.048607726, 0.048548903, 0.048490144, 0.048431389, 0.048372682, 0.048314009, 0.048255384, 0.048196763, 0.048138201, 0.048079666, 0.048021186, 0.047962718, 0.047904294, 0.0478459, 0.047787543, 0.047729217, 0.047670931, 0.047612682, 0.047554467, 0.047496282, 0.04743813, 0.047380023, 0.047321953, 0.047263902, 0.047205895, 0.047147933, 0.047090001, 0.047032107, 0.046974245, 0.046916403, 0.046858605, 0.046800856, 0.046743128, 0.046685439, 0.046627775, 0.046570171, 0.046512581, 0.046455014, 0.046397496, 0.046340041, 0.046282582, 0.04622519, 0.046167813, 0.046110466, 0.046053167, 0.045995891, 0.045938671, 0.045881469, 0.045824297, 0.045767166, 0.045710079, 0.045653019, 0.045595989, 0.045538995, 0.045482058, 0.045425132, 0.045368265, 0.045311414, 0.045254592, 0.045197815, 0.045141082, 0.045084361, 0.045027684, 0.044971056, 0.044914458, 0.044857882, 0.044801373, 0.044744864, 0.0446884, 0.044631977, 0.044575594, 0.044519234, 0.044462912, 0.044406615, 0.044350363, 0.044294149, 0.044237971, 0.044181831, 0.044125721, 0.044069652, 0.044013605, 0.043957587, 0.043901626, 0.04384568, 0.043789785, 0.043733925, 0.04367809, 0.043622289, 0.043566544, 0.043510821, 0.043455131, 0.043399476, 0.043343838, 0.043288272, 0.043232728, 0.043177195, 0.043121718, 0.043066267, 0.043010864, 0.042955507, 0.042900164, 0.042844854, 0.042789578, 0.042734351, 0.04267915, 0.042623993, 0.042568851, 0.042513762, 0.042458706, 0.042403687, 0.042348687, 0.04229375, 0.042238828, 0.042183943, 0.042129103, 0.042074285, 0.042019505, 0.041964751, 0.04191006, 0.041855384, 0.04180073, 0.041746136, 0.041691579, 0.041637037, 0.041582536, 0.041528068, 0.041473664, 0.04141926, 0.041364916, 0.041310586, 0.041256294, 0.041202039, 0.041147824, 0.041093651, 0.041039497, 0.040985379, 0.040931311, 0.040877279, 0.040823262, 0.040769283, 0.04071537, 0.040661462, 0.04060759, 0.040553775, 0.040499974, 0.040446207, 0.040392477, 0.040338799, 0.040285144, 0.040231515, 0.040177926, 0.040124379, 0.040070873, 0.040017389, 0.039963935, 0.03991054, 0.039857157, 0.039803829, 0.039750516, 0.039697248, 0.03964401, 0.039590802, 0.03953765, 0.039484523, 0.039431415, 0.03937836, 0.039325349, 0.039272357, 0.039219394, 0.039166491, 0.039113611, 0.039060745, 0.039007951, 0.038955163, 0.038902413, 0.038849704, 0.038797051, 0.038744397, 0.038691789, 0.038639225, 0.038586706, 0.038534194, 0.038481735, 0.038429316, 0.038376927, 0.038324557, 0.038272247, 0.038219955, 0.038167708, 0.038115479, 0.038063291, 0.038011163, 0.037959039, 0.037906963, 0.03785494, 0.037802938, 0.037750959, 0.037699018, 0.037647113, 0.037595246, 0.037543409, 0.037491631, 0.037439864, 0.037388127, 0.037336443, 0.037284806, 0.037233189, 0.03718159, 0.037130039, 0.037078533, 0.03702705, 0.036975596, 0.036924195, 0.036872812, 0.036821473, 0.03677018, 0.036718916, 0.036667675, 0.036616482, 0.036565304, 0.036514189, 0.036463093, 0.036412023, 0.036360994, 0.036310025, 0.036259059, 0.036208142, 0.036157265, 0.036106411, 0.036055591, 0.03600483, 0.035954081, 0.035903368, 0.035852693, 0.035802066, 0.035751462, 0.035700884, 0.035650346, 0.035599861, 0.035549387, 0.035498966, 0.03544857, 0.035398223, 0.035347898, 0.035297621, 0.035247367, 0.035197146, 0.035146952, 0.035096806, 0.035046704, 0.034996621, 0.034946576, 0.034896564, 0.034846608, 0.034796663, 0.034746751, 0.034696911, 0.034647074, 0.034597259, 0.034547523, 0.034497794, 0.034448091, 0.034398433, 0.034348831, 0.034299232, 0.034249682, 0.034200158, 0.03415069, 0.03410124, 0.034051824, 0.034002464, 0.033953119, 0.033903807, 0.03385454, 0.033805314, 0.033756088, 0.033706937, 0.033657804, 0.033608727, 0.033559684, 0.033510629, 0.033461656, 0.033412702, 0.033363786, 0.033314887, 0.033266056, 0.033217225, 0.033168446, 0.033119693, 0.033071008, 0.03302234, 0.032973688, 0.032925095, 0.032876514, 0.032827999, 0.032779481, 0.03273103, 0.032682594, 0.032634214, 0.032585829, 0.03253752, 0.032489251, 0.032440994, 0.032392774, 0.032344587, 0.032296449, 0.032248318, 0.032200258, 0.032152206, 0.032104213, 0.032056216, 0.032008298, 0.031960405, 0.031912535, 0.031864695, 0.031816896, 0.031769145, 0.031721417, 0.031673722, 0.031626068, 0.031578451, 0.031530857, 0.031483307, 0.031435806, 0.031388324, 0.03134089, 0.031293459, 0.031246088, 0.031198749, 0.031151438, 0.031104166, 0.031056944, 0.031009747, 0.030962564, 0.030915454, 0.030868353, 0.030821301, 0.030774277, 0.030727277, 0.030680325, 0.030633414, 0.030586522, 0.030539665, 0.030492855, 0.03044609, 0.030399345, 0.030352622, 0.030305965, 0.030259319, 0.030212712, 0.030166145, 0.030119624, 0.030073117, 0.030026648, 0.02998022, 0.029933833, 0.029887488, 0.029841147, 0.029794864, 0.029748611, 0.029702412, 0.029656203, 0.029610071, 0.029563952, 0.02951787, 0.029471826, 0.029425833, 0.029379871, 0.029333908, 0.029288022, 0.029242147, 0.029196337, 0.029150514, 0.029104769, 0.02905903, 0.029013356, 0.02896768, 0.028922059, 0.028876478, 0.02883094, 0.028785422, 0.028739939, 0.028694499, 0.028649086, 0.028603705, 0.028558362, 0.02851307, 0.028467776, 0.028422553, 0.028377343, 0.028332192, 0.028287042, 0.028241958, 0.02819692, 0.028151888, 0.028106909, 0.028061932, 0.028017027, 0.027972139, 0.0279273, 0.027882461, 0.027837699, 0.027792944, 0.027748233, 0.027703559, 0.027658923, 0.027614323, 0.027569747, 0.027525229, 0.027480727, 0.027436277, 0.027391827, 0.027347444, 0.027303083, 0.027258767, 0.027214458, 0.027170215, 0.027125997, 0.027081823, 0.027037676, 0.026993562, 0.026949484, 0.026905429, 0.02686144, 0.026817452, 0.026773531, 0.02672961, 0.026685756, 0.026641924, 0.026598135, 0.026554363, 0.026510634, 0.026466953, 0.026423298, 0.026379667, 0.026336079, 0.026292533, 0.026249021, 0.02620553, 0.026162086, 0.026118686, 0.026075315, 0.026031967, 0.025988657, 0.02594539, 0.025902148, 0.025858942, 0.025815787, 0.025772663, 0.025729561, 0.025686495, 0.025643481, 0.0256005, 0.025557548, 0.025514618, 0.025471738, 0.025428897, 0.025386076, 0.025343288, 0.025300542, 0.025257844, 0.025215166, 0.025172517, 0.025129929, 0.025087355, 0.025044819, 0.025002323, 0.024959859, 0.024917429, 0.024875034, 0.024832675, 0.024790356, 0.024748087, 0.024705814, 0.024663605, 0.024621418, 0.024579285, 0.024537142, 0.024495086, 0.024453033, 0.024411023, 0.024369048, 0.02432712, 0.024285233, 0.024243345, 0.024201525, 0.024159728, 0.024117973, 0.024076225, 0.024034554, 0.023992879, 0.023951268, 0.023909664, 0.023868125, 0.023826625, 0.023785139, 0.023743689, 0.023702271, 0.023660904, 0.023619559, 0.023578251, 0.023536976, 0.023495752, 0.023454534, 0.023413382, 0.023372239, 0.023331163, 0.023290081, 0.023249071, 0.023208093, 0.023167126, 0.02312622, 0.023085317, 0.023044478, 0.023003664, 0.022962883, 0.02292213, 0.022881432, 0.022840751, 0.022800196, 0.022759724, 0.022719309, 0.022678927, 0.022638544, 0.022598218, 0.02255794, 0.022517705, 0.022477457, 0.02243728, 0.022397149, 0.022357034, 0.022316949, 0.022276908, 0.022236912, 0.022196945, 0.022156995, 0.022117103, 0.02207724, 0.022037392, 0.021997619, 0.021957861, 0.021918148, 0.021878434, 0.02183878, 0.021799186, 0.021759609, 0.021720044, 0.021680539, 0.021641064, 0.021601634, 0.021562206, 0.02152285, 0.021483522, 0.021444228, 0.021404944, 0.021365723, 0.021326547, 0.0212874, 0.021248251, 0.021209165, 0.021170136, 0.021131095, 0.021092126, 0.021053186, 0.021014279, 0.020975385, 0.020936551, 0.020897759, 0.020858999, 0.020820269, 0.020781554, 0.020742899, 0.020704286, 0.020665707, 0.020627111, 0.020588603, 0.020550126, 0.02051165, 0.020473247, 0.020434877, 0.020396547, 0.02035822, 0.02031995, 0.020281712, 0.020243518, 0.020205341, 0.020167222, 0.020129116, 0.020091072, 0.020053012, 0.020015042, 0.0199771, 0.01993919, 0.019901279, 0.019863443, 0.019825622, 0.019787859, 0.019750098, 0.019712396, 0.019674722, 0.019637065, 0.019599482, 0.019561913, 0.019524405, 0.019486882, 0.019449433, 0.019412013, 0.019374639, 0.019337248, 0.01929995, 0.019262679, 0.019225422, 0.019188197, 0.019151032, 0.019113896, 0.019076789, 0.019039698, 0.019002665, 0.018965678, 0.018928694, 0.01889178, 0.018854881, 0.018818043, 0.018781189, 0.018744413, 0.018707663, 0.018670959, 0.018634284, 0.018597625, 0.018561009, 0.018524438, 0.018487914, 0.018451389, 0.018414922, 0.0183785, 0.01834208, 0.018305719, 0.018269401, 0.018233113, 0.018196844, 0.018160615, 0.018124446, 0.018088309, 0.018052155, 0.018016092, 0.017980058, 0.017944053, 0.01790805, 0.017872119, 0.017836221, 0.017800365, 0.017764511, 0.017728714, 0.017692963, 0.017657243, 0.017621536, 0.017585889, 0.017550273, 0.017514657, 0.017479114, 0.017443616, 0.017408147, 0.017372681, 0.017337272, 0.01730191, 0.017266575, 0.017231256, 0.017195998, 0.017160768, 0.017125582, 0.017090399, 0.017055273, 0.017020192, 0.016985158, 0.016950106, 0.016915129, 0.016880197, 0.016845252, 0.01681038, 0.016775552, 0.016740739, 0.016705956, 0.016671235, 0.016636541, 0.016601877, 0.016567258, 0.016532626, 0.016498081, 0.016463567, 0.016429082, 0.016394611, 0.016360201, 0.016325822, 0.01629144, 0.01625715, 0.016222874, 0.016188642, 0.01615441, 0.016120255, 0.016086111, 0.01605203, 0.016017947, 0.015983909, 0.015949931, 0.015915982, 0.015882034, 0.01584816, 0.015814316, 0.015780501, 0.015746702, 0.015712963, 0.015679251, 0.015645588, 0.015611921, 0.015578316, 0.015544754, 0.015511207, 0.015477722, 0.015444264, 0.015410838, 0.015377426, 0.015344073, 0.015310764, 0.015277486, 0.015244208, 0.01521099, 0.015177831, 0.015144687, 0.015111559, 0.015078489, 0.015045464, 0.015012454, 0.014979474, 0.014946538, 0.014913647, 0.014880772, 0.014847956, 0.014815154, 0.014782412, 0.01474967, 0.014716988, 0.01468435, 0.014651744, 0.014619164, 0.014586602, 0.014554098, 0.014521639, 0.014489211, 0.014456782, 0.014424412, 0.014392087, 0.014359778, 0.014327512, 0.014295306, 0.014263116, 0.01423094, 0.014198825, 0.014166753, 0.014134711, 0.014102669, 0.014070703, 0.014038764, 0.014006872, 0.01397498, 0.013943146, 0.013911342, 0.013879584, 0.013847825, 0.013816142, 0.013784502, 0.013752877, 0.013721268, 0.013689717, 0.013658212, 0.013626706, 0.013595261, 0.013563859, 0.013532488, 0.013501116, 0.013469819, 0.013438553, 0.01340733, 0.013376107, 0.013344945, 0.013313826, 0.013282739, 0.013251665, 0.013220636, 0.013189667, 0.013158713, 0.013127773, 0.013096908, 0.013066058, 0.013035223, 0.013004463, 0.012973716, 0.012943031, 0.012912344, 0.012881718, 0.012851121, 0.012820555, 0.012790048, 0.012759524, 0.012729077, 0.012698659, 0.012668286, 0.012637897, 0.012607598, 0.012577314, 0.012547045, 0.012516851, 0.012486685, 0.012456551, 0.012426431, 0.01239637, 0.01236634, 0.012336339, 0.012306367, 0.012276442, 0.012246558, 0.012216708, 0.012186855, 0.012157078, 0.012127344, 0.012097628, 0.012067924, 0.01203828, 0.012008683, 0.011979128, 0.01194956, 0.011920065, 0.011890614, 0.01186115, 0.011831759, 0.0118024, 0.011773083, 0.011743783, 0.011714527, 0.011685301, 0.011656133, 0.011626968, 0.011597861, 0.011568783, 0.01153975, 0.011510733, 0.011481744, 0.011452815, 0.011423932, 0.011395049, 0.011366225, 0.01133743, 0.011308636, 0.011279916, 0.011251241, 0.011222595, 0.011193965, 0.01116538, 0.011136822, 0.011108327, 0.01107986, 0.011051393, 0.011023001, 0.010994639, 0.010966292, 0.010937974, 0.010909716, 0.010881502, 0.010853289, 0.010825135, 0.010797012, 0.010768916, 0.010740853, 0.010712848, 0.010684873, 0.010656928, 0.010628982, 0.010601111, 0.010573285, 0.010545489, 0.010517708, 0.01048997, 0.010462279, 0.010434617, 0.01040697, 0.010379381, 0.010351839, 0.010324325, 0.010296812, 0.010269358, 0.010241949, 0.010214556, 0.010187206, 0.010159916, 0.010132641, 0.010105367, 0.010078181, 0.010051025, 0.010023898, 0.0099967727, 0.0099697215, 0.0099427002, 0.0099157076, 0.0098887309, 0.0098618129, 0.0098349405, 0.009808098, 0.0097812554, 0.0097544715, 0.0097277323, 0.0097010098, 0.0096743451, 0.0096477261, 0.009621121, 0.0095945168, 0.0095680011, 0.0095415013, 0.0095150592, 0.0094886338, 0.0094622225, 0.0094358874, 0.0094095506, 0.0093832733, 0.0093570119, 0.0093308091, 0.0093046371, 0.009278479, 0.0092523508, 0.009226297, 0.0092002591, 0.0091742501, 0.0091482857, 0.009122367, 0.0090964623, 0.0090705873, 0.009044758, 0.0090189874, 0.0089932466, 0.0089675058, 0.0089418096, 0.0089161731, 0.0088905673, 0.0088649755, 0.0088394433, 0.0088139409, 0.0087884534, 0.0087629957, 0.0087376134, 0.0087122601, 0.0086869067, 0.0086616278, 0.0086363489, 0.0086111445, 0.0085859252, 0.0085607804, 0.0085356804, 0.0085106101, 0.0084855249, 0.0084605142, 0.0084355483, 0.008410627, 0.0083856899, 0.0083608292, 0.0083360123, 0.0083111944, 0.0082864221, 0.0082616946, 0.0082370117, 0.0082123438, 0.0081877196, 0.0081631262, 0.0081385775, 0.0081140734, 0.0080895694, 0.0080651399, 0.0080407392, 0.0080163693, 0.0079919994, 0.007967704, 0.0079434374, 0.0079192165, 0.0078949956, 0.0078708483, 0.0078467019, 0.0078226002, 0.0077985423, 0.00777453, 0.0077505615, 0.0077265939, 0.0077026854, 0.0076787919, 0.0076549579, 0.007631124, 0.007607365, 0.0075836354, 0.0075599351, 0.0075362353, 0.0075126099, 0.0074890293, 0.0074654631, 0.0074419272, 0.0074184365, 0.0073949751, 0.0073715728, 0.0073481556, 0.0073248288, 0.0073015164, 0.0072782184, 0.0072549656, 0.0072317719, 0.0072086086, 0.0071854447, 0.0071623558, 0.0071392967, 0.0071162521, 0.0070932377, 0.0070702825, 0.0070473724, 0.0070244917, 0.0070016109, 0.0069787898, 0.0069560139, 0.0069332821, 0.0069105355, 0.0068878788, 0.0068652364, 0.0068425941, 0.0068200263, 0.0067975037, 0.0067750104, 0.0067525618, 0.0067301132, 0.0067077242, 0.0066853506, 0.0066630361, 0.006640736, 0.0066184811, 0.0065962858, 0.0065741055, 0.0065519251, 0.0065298188, 0.0065077431, 0.006485682, 0.0064636949, 0.0064417226, 0.0064197956, 0.0063978685, 0.0063760006, 0.0063541927, 0.0063323998, 0.0063106217, 0.0062889177, 0.0062672142, 0.0062455698, 0.0062239408, 0.0062023713, 0.0061808312, 0.0061593209, 0.0061378111, 0.0061163753, 0.0060949842, 0.0060736234, 0.0060522771, 0.0060309903, 0.0060097338, 0.0059884614, 0.0059672794, 0.0059461268, 0.0059250193, 0.0059039108, 0.005882863, 0.0058618439, 0.0058408706, 0.0058199414, 0.0057990118, 0.0057781423, 0.0057573179, 0.0057364628, 0.0057157124, 0.0056949914, 0.0056743012, 0.0056536105, 0.0056330087, 0.0056123924, 0.0055918205, 0.005571309, 0.0055508413, 0.0055304039, 0.0055099959, 0.0054895733, 0.0054692402, 0.005448937, 0.0054286779, 0.0054084193, 0.0053882198, 0.0053680507, 0.0053479257, 0.0053278157, 0.0053077508, 0.005287745, 0.0052677244, 0.0052477638, 0.0052278624, 0.0052079759, 0.0051881191, 0.0051683071, 0.0051485403, 0.0051288027, 0.0051090647, 0.0050894022, 0.005069769, 0.0050501805, 0.005030592, 0.0050110635, 0.004991564, 0.00497211, 0.0049526701, 0.0049332902, 0.0049139401, 0.0048946347, 0.0048753293, 0.0048560835, 0.0048368671, 0.0048176809, 0.0047985394, 0.0047794571, 0.0047603901, 0.0047413078, 0.0047223154, 0.0047033676, 0.0046844492, 0.004665561, 0.0046466873, 0.0046278439, 0.0046090744, 0.0045902906, 0.0045715957, 0.0045529157, 0.0045342809, 0.0045156307, 0.0044970703, 0.0044785244, 0.0044600083, 0.0044415523, 0.0044231256, 0.0044047139, 0.0043863617, 0.0043680095, 0.0043497169, 0.004331484, 0.0043132659, 0.0042950329, 0.0042768894, 0.0042587905, 0.0042407215, 0.0042226524, 0.0042046579, 0.0041866931, 0.0041687135, 0.0041508232, 0.0041329628, 0.0041151321, 0.0040973159, 0.0040795598, 0.0040618186, 0.0040441365, 0.0040264698, 0.0040088478, 0.0039912849, 0.0039737374, 0.0039561894, 0.0039387164, 0.0039212727, 0.0039038742, 0.0038864904, 0.0038691512, 0.0038518566, 0.003834577, 0.0038173273, 0.0038001519, 0.0037829916, 0.0037658459, 0.0037487603, 0.0037317039, 0.0037146925, 0.003697681, 0.003680744, 0.003663837, 0.0036469745, 0.0036301268, 0.0036132943, 0.003596521, 0.0035797928, 0.0035630791, 0.0035464251, 0.003529801, 0.0035131918, 0.0034966124, 0.0034800924, 0.0034636171, 0.0034471422, 0.0034307262, 0.0034143406, 0.0033979996, 0.0033816881, 0.0033654068, 0.0033491699, 0.0033329627, 0.0033167854, 0.0033006379, 0.00328455, 0.0032684922, 0.0032524639, 0.0032364654, 0.0032204669, 0.0032045576, 0.0031886485, 0.0031728288, 0.0031570089, 0.003141219, 0.003125459, 0.0031097287, 0.0030940876, 0.0030784465, 0.0030628352, 0.0030472539, 0.003031732, 0.0030162104, 0.0030007479, 0.0029853154, 0.0029699425, 0.0029545994, 0.0029392566, 0.0029239433, 0.0029086894, 0.0028934954, 0.0028783013, 0.0028631666, 0.002848062, 0.0028329573, 0.002817912, 0.0028029266, 0.0027879707, 0.0027730151, 0.0027581188, 0.0027432523, 0.0027284159, 0.0027136388, 0.0026988618, 0.0026841443, 0.0026694865, 0.0026548286, 0.0026401707, 0.0026256023, 0.0026110935, 0.0025965548, 0.0025820758, 0.0025676561, 0.0025532069, 0.002538847, 0.0025245466, 0.0025102464, 0.0024959755, 0.0024817348, 0.0024675536, 0.0024534024, 0.002439281, 0.0024251891, 0.0024111269, 0.0023971247, 0.0023831518, 0.0023691792, 0.0023552664, 0.0023414127, 0.0023275593, 0.0023137657, 0.0023000014, 0.002286267, 0.0022725626, 0.002258888, 0.0022452727, 0.0022317173, 0.0022181319, 0.0022046061, 0.0021911401, 0.0021776739, 0.0021642672, 0.0021508904, 0.0021375436, 0.0021242264, 0.002110939, 0.0020977112, 0.0020845132, 0.0020713746, 0.0020582064, 0.0020451276, 0.0020320488, 0.0020190293, 0.00200604, 0.0019931102, 0.0019801802, 0.0019672802, 0.0019544396, 0.0019416289, 0.001928848, 0.0019161266, 0.0019034053, 0.0018907435, 0.0018780817, 0.0018655094, 0.0018529071, 0.0018403943, 0.0018279114, 0.0018154284, 0.0018030049, 0.0017906113, 0.0017782474, 0.0017659432, 0.0017536688, 0.0017414241, 0.001729239, 0.0017170241, 0.0017048689, 0.001692803, 0.001680737, 0.0016686711, 0.0016566947, 0.001644718, 0.001632801, 0.0016208842, 0.0016090268, 0.0015972289, 0.0015854015, 0.0015736632, 0.0015619549, 0.0015502762, 0.0015385976, 0.0015270084, 0.0015154489, 0.0015039193, 0.0014923598, 0.0014809195, 0.0014694793, 0.0014580985, 0.0014467179, 0.0014353968, 0.0014241055, 0.0014128439, 0.0014016123, 0.0013904402, 0.0013792978, 0.0013681852, 0.0013570726, 0.0013460494, 0.0013350262, 0.0013240328, 0.0013131289, 0.0013022248, 0.0012913507, 0.0012805063, 0.0012696915, 0.0012589663, 0.0012482411, 0.0012375456, 0.0012268501, 0.0012162441, 0.0012056677, 0.0011951212, 0.0011846045, 0.0011741475, 0.0011636904, 0.001153263, 0.0011428952, 0.0011325573, 0.0011222491, 0.0011120006, 0.0011017519, 0.0010915629, 0.0010814037, 0.0010712743, 0.0010611747, 0.0010511347, 0.0010411245, 0.0010311143, 0.0010211635, 0.0010112725, 0.0010014112, 0.00099154992, 0.00098174822, 0.00097197638, 0.00096220442, 0.00095249212, 0.00094286923, 0.00093324622, 0.00092362333, 0.00091405999, 0.00090452639, 0.00089505245, 0.00088557845, 0.00087616401, 0.00086680922, 0.00085745443, 0.00084812945, 0.00083886401, 0.00082962838, 0.00082042255, 0.00081121665, 0.00080210023, 0.00079301355, 0.00078395667, 0.00077489979, 0.00076590246, 0.00075696473, 0.00074802706, 0.00073914893, 0.00073027075, 0.00072148204, 0.00071269326, 0.00070393429, 0.00069523498, 0.00068656536, 0.00067792553, 0.00066928577, 0.00066073542, 0.0006522148, 0.00064372394, 0.00063523307, 0.00062680186, 0.0006184302, 0.00061005855, 0.00060174643, 0.00059346418, 0.00058518193, 0.00057695922, 0.00056879612, 0.00056066277, 0.00055255927, 0.00054445572, 0.00053644157, 0.00052842742, 0.00052047282, 0.00051251828, 0.00050462334, 0.00049678789, 0.0004889525, 0.00048111714, 0.0004733711, 0.00046568466, 0.00045796845, 0.00045031181, 0.00044271472, 0.00043514749, 0.0004275504, 0.00042007252, 0.00041259467, 0.00040517634, 0.00039775803, 0.00039039933, 0.00038307041, 0.00037577125, 0.00036850193, 0.00036126238, 0.00035411221, 0.00034696201, 0.00033981187, 0.00033272128, 0.00032566051, 0.00031865927, 0.00031165805, 0.00030474624, 0.0002978344, 0.00029092259, 0.00028410013, 0.00027730747, 0.00027054458, 0.00026381153, 0.00025713802, 0.00025046454, 0.00024385062, 0.0002372665, 0.00023068239, 0.00022418764, 0.00021772271, 0.00021125776, 0.00020482259, 0.00019844703, 0.00019213105, 0.00018578528, 0.00017952887, 0.00017330227, 0.00016707566, 0.00016090865, 0.00015480119, 0.00014869375, 0.00014264591, 0.00013662784, 0.00013060978, 0.0001246811, 0.00011875242, 0.00011288332, 0.00010701422, 0.0001012345, 9.545478e-05, 8.9675064e-05, 8.3984713e-05, 7.8324163e-05, 7.2663614e-05, 6.7092435e-05, 6.1521263e-05, 5.5979879e-05, 5.046829e-05, 4.5016284e-05, 3.9623865e-05, 3.4231442e-05, 2.8868815e-05, 2.353598e-05, 1.829252e-05, 1.3049063e-05, 7.8056028e-06, 2.6515218e-06, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 2.2699314e-15, 4.0219711e-06, 9.2356377e-06, 1.4479096e-05, 1.9722554e-05, 2.4995805e-05, 3.029885e-05, 3.5691271e-05, 4.1053896e-05, 4.6505906e-05, 5.2017494e-05, 5.7439705e-05, 6.3010884e-05, 6.8611851e-05, 7.4183023e-05, 7.9873367e-05, 8.5504122e-05, 9.1254056e-05, 9.7003984e-05, 0.00010278371, 0.00010862301, 0.00011443252, 0.0001203612, 0.0001262601, 0.00013221857, 0.00013823663, 0.00014431428, 0.00015033234, 0.00015646957, 0.00016257701, 0.00016877383, 0.00017494085, 0.00018122703, 0.00018751324, 0.00019379942, 0.000200175, 0.00020652078, 0.00021295593, 0.00021945065, 0.0002259156, 0.00023246993, 0.00023905405, 0.00024560836, 0.00025225207, 0.00025889577, 0.00026565866, 0.00027233214, 0.00027915457, 0.00028597706, 0.00029279949, 0.00029968153, 0.00030659337, 0.00031356479, 0.000320566, 0.00032753739, 0.00033462798, 0.00034174835, 0.00034883895, 0.00035604869, 0.00036319889, 0.00037046825, 0.00037773754, 0.00038503669, 0.00039239542, 0.00039975412, 0.00040717243, 0.00041459076, 0.00042206864, 0.0004296359, 0.00043714358, 0.00044477041, 0.00045239727, 0.00046005391, 0.00046777015, 0.00047545656, 0.0004832324, 0.00049106777, 0.00049887336, 0.00050676835, 0.00051466335, 0.00052258809, 0.00053054269, 0.00053858658, 0.00054666033, 0.00055476389, 0.00056286738, 0.00057100074, 0.00057916384, 0.00058744615, 0.0005956688, 0.00060398091, 0.00061235257, 0.00062066462, 0.00062909588, 0.00063749729, 0.00064598816, 0.00065453851, 0.00066302938, 0.0006716394, 0.00068024936, 0.00068888918, 0.00069758855, 0.00070628792, 0.00071507669, 0.0007238356, 0.00073265418, 0.00074156211, 0.00075041043, 0.0007593779, 0.00076831569, 0.00077734271, 0.00078639959, 0.00079542672, 0.00080457295, 0.00081374904, 0.00082289526, 0.00083213096, 0.00084133679, 0.00085066177, 0.00085998682, 0.00086931186, 0.00087872619, 0.00088814058, 0.00089758477, 0.00090705877, 0.00091662211, 0.000926245, 0.00093580841, 0.0009454611, 0.00095514371, 0.00096482621, 0.00097459805, 0.00098434021, 0.0009942014, 0.0010040627, 0.001013924, 0.0010238448, 0.0010337955, 0.0010438057, 0.0010538161, 0.0010638859, 0.0010740152, 0.0010841447, 0.0010943038, 0.0011045226, 0.0011147414, 0.0011250495, 0.001135328, 0.0011457256, 0.0011560932, 0.0011664907, 0.001176948, 0.0011874051, 0.0011979516, 0.0012085576, 0.0012190744, 0.00122974, 0.0012404354, 0.0012511011, 0.0012618264, 0.0012726113, 0.0012834258, 0.0012942405, 0.0013051445, 0.0013160784, 0.0013270121, 0.0013380055, 0.0013489692, 0.0013600518, 0.0013711943, 0.001382277, 0.0013934491, 0.0014046809, 0.0014158529, 0.0014271741, 0.0014384356, 0.0014497865, 0.001461197, 0.0014725777, 0.0014840179, 0.0014954583, 0.0015069878, 0.0015185176, 0.0015301366, 0.0015417854, 0.0015533747, 0.0015651128, 0.001576851, 0.0015885892, 0.0016004168, 0.0016122146, 0.0016241018, 0.0016360187, 0.0016479357, 0.0016599122, 0.0016718886, 0.0016839546, 0.0016960205, 0.0017081461, 0.001720331, 0.0017325162, 0.0017447311, 0.0017570055, 0.0017692799, 0.001781614, 0.0017939182, 0.0018063715, 0.0018188247, 0.0018312482, 0.0018437908   }, 
}; 

   inline double ReadLikelihood::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!fStatusIsClean) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            retval = GetMvaValue__( iV );
         }
         else {
            retval = GetMvaValue__( inputValues );
         }
      }

      return retval;
   }
