// Class: ReadLikelihoodPCA
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : Likelihood::LikelihoodPCA
TMVA Release   : 3.8.13        [198669]
ROOT Release   : 5.19/02       [332546]
Creator        : heponx
Date           : Fri Mar 28 00:39:41 2008
Host           : Darwin jlctpcmac.kek.jp 9.2.0 Darwin Kernel Version 9.2.0: Tue Feb 5 16:15:19 PST 2008; root:xnu-1228.3.13~1/RELEASE_PPC Power Macintosh
Dir            : /Users/root/root_v5.19.02-macosx10.5-ppc/test
Training events: 1000


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
VarTransform: "PCA" [Variable transformation method]
V: "False" [Verbose mode]
H: "False" [Print classifier-specific help message]
NSmooth: "5" [Number of smoothing iterations for the input histograms]
NAvEvtPerBin: "50" [Average number of events per PDF bin]
TransformOutput: "False" [Transform likelihood output by inverse sigmoid function]
# Default:
D: "False" [use-decorrelated-variables flag (depreciated)]
Normalise: "False" [Normalise input variables]
VarTransformType: "Signal" [Use signal or background events for var transform]
NbinsMVAPdf: "60" [Number of bins used to create MVA PDF]
NsmoothMVAPdf: "2" [Number of smoothing iterations for MVA PDF]
VerboseLevel: "Info" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs]
TxtWeightFilesOnly: "True" [if True, write all weights as text files]
NSmoothSig[0]: "10" [Number of smoothing iterations for the input histograms]
    NSmoothSig[1]: "5"
    NSmoothSig[2]: "5"
    NSmoothSig[3]: "5"
NSmoothBkg[0]: "10" [Number of smoothing iterations for the input histograms]
    NSmoothBkg[1]: "5"
    NSmoothBkg[2]: "5"
    NSmoothBkg[3]: "5"
NAvEvtPerBinSig[0]: "50" [Average num of events per PDF bin and variable (signal)]
    NAvEvtPerBinSig[1]: "50"
    NAvEvtPerBinSig[2]: "50"
    NAvEvtPerBinSig[3]: "50"
NAvEvtPerBinBkg[0]: "50" [Average num of events per PDF bin and variable (background)]
    NAvEvtPerBinBkg[1]: "50"
    NAvEvtPerBinBkg[2]: "50"
    NAvEvtPerBinBkg[3]: "50"
PDFInterpol[0]: "Spline2" [Method of interpolating reference histograms (e.g. Spline2 or KDE)]
    PDFInterpol[1]: "Spline2"
    PDFInterpol[2]: "Spline2"
    PDFInterpol[3]: "Spline2"
KDEtype: "Gauss" [KDE kernel type (1=Gauss)]
KDEiter: "Nonadaptive" [Number of iterations (1=non-adaptive, 2=adaptive)]
KDEFineFactor: "1" [Fine tuning factor for Adaptive KDE: Factor to multyply the width of the kernel]
KDEborder: "None" [Border effects treatment (1=no treatment , 2=kernel renormalization, 3=sample mirroring)]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 4
var1+var2                     var1_P_var2                       'F'    [-10.5705623627,4.64453220367]
var1-var2                     var1_M_var2                       'F'    [-3.58058381081,4.69073915482]
var3                          var3                              'F'    [-3.10452866554,2.63460898399]
var4                          var4                              'F'    [-1.26936435699,1.01415038109]


============================================================================ */

#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#include <math.h>
#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual double GetMvaValue( const std::vector<double>& inputValues ) const = 0;
};

#endif

class ReadLikelihoodPCA : public IClassifierReader {

 public:

   // constructor
   ReadLikelihoodPCA( std::vector<std::string>& theInputVars ) 
      : IClassifierReader(),
        fClassName( "ReadLikelihoodPCA" ),
        fStatusIsClean( true ),
        fNvars( 4 ),
        fIsNormalised( false )
   {      
      // the training input variables
      const char* inputVars[] = { "var1+var2", "var1-var2", "var3", "var4" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -10.5705623626709;
      fVmax[0] = 4.64453220367432;
      fVmin[1] = -3.58058381080627;
      fVmax[1] = 4.69073915481567;
      fVmin[2] = -3.1045286655426;
      fVmax[2] = 2.63460898399353;
      fVmin[3] = -1.26936435699463;
      fVmax[3] = 1.01415038108826;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';

      // initialize constants
      Initialize();

      // initialize transformation
      InitTransform();
   }

   // destructor
   virtual ~ReadLikelihoodPCA() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the 
   // variables given to the constructor
   double GetMvaValue( const std::vector<double>& inputValues ) const;

 private:

   // method-specific destructor
   void Clear();

   // input variable transformation

   void X2P( const double*, double*, int ) const;
   double fMeanValues[2][4];
   double fEigenVectors[2][4][4];

   void InitTransform();
   void Transform( std::vector<double> & iv, int sigOrBgd ) const;

   // common member variables
   const char* fClassName;
   bool fStatusIsClean;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   const bool fIsNormalised;
   bool IsNormalised() const { return fIsNormalised; }
   double fVmin[4];
   double fVmax[4];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[4];

   // initialize internal variables
   void Initialize();
   double GetMvaValue__( const std::vector<double>& inputValues ) const;

   // private members (method specific)
   double       fEpsilon;
   static float fRefS[][10000]; // signal reference vector [nvars][max_nbins]
   static float fRefB[][10000]; // backgr reference vector [nvars][max_nbins]

// if a variable has its PDF encoded as a spline0 --> treat it like an Integer valued one
   bool    fHasDiscretPDF[4]; 
   int    fNbin[4]; // number of bins (discrete variables may have less bins)
   double TransformLikelihoodOutput( double, double ) const;
};

inline void ReadLikelihoodPCA::Initialize() 
{
   fEpsilon = 1e-08;
   fNbin[0] = 10000;
   fNbin[1] = 10000;
   fNbin[2] = 10000;
   fNbin[3] = 10000;
   fHasDiscretPDF[0] = false; 
   fHasDiscretPDF[1] = false; 
   fHasDiscretPDF[2] = false; 
   fHasDiscretPDF[3] = false; 
}

inline double ReadLikelihoodPCA::GetMvaValue__( const std::vector<double>& inputValues ) const
{
   double ps(1), pb(1);
   std::vector<double> inputValuesSig = inputValues;
   std::vector<double> inputValuesBgd = inputValues;
   Transform(inputValuesSig,0);
   Transform(inputValuesBgd,1);
   for (size_t ivar = 0; ivar < GetNvar(); ivar++) {

      // dummy at present... will be used for variable transforms
      double x[2] = { inputValuesSig[ivar], inputValuesBgd[ivar] };

      for (int itype=0; itype < 2; itype++) {

         // interpolate linearly between adjacent bins
         // this is not useful for discrete variables (or forced Spline0)
         int bin = int((x[itype] - fVmin[ivar])/(fVmax[ivar] - fVmin[ivar])*fNbin[ivar]) + 0;

         // since the test data sample is in general different from the training sample
         // it can happen that the min/max of the training sample are trespassed --> correct this
         if      (bin < 0) {
            bin = 0;
            x[itype] = fVmin[ivar];
         }
         else if (bin >= fNbin[ivar]) {
            bin = fNbin[ivar]-1;
            x[itype] = fVmax[ivar];
         }

         // find corresponding histogram from cached indices
         float ref = (itype == 0) ? fRefS[ivar][bin] : fRefB[ivar][bin];

         // sanity check
         if (ref < 0) {
            std::cout << "Fatal error in ReadLikelihoodPCA: bin entry < 0 ==> abort" << std::endl;
            exit(1);
         }

         double p = ref;

         if (GetType(ivar) != 'I' && !fHasDiscretPDF[ivar]) {
            float bincenter = (bin + 0.5)/fNbin[ivar]*(fVmax[ivar] - fVmin[ivar]) + fVmin[ivar];
            int nextbin = bin;
            if ((x[itype] > bincenter && bin != fNbin[ivar]-1) || bin == 0) 
               nextbin++;
            else
               nextbin--;  

            double refnext      = (itype == 0) ? fRefS[ivar][nextbin] : fRefB[ivar][nextbin];
            float nextbincenter = (nextbin + 0.5)/fNbin[ivar]*(fVmax[ivar] - fVmin[ivar]) + fVmin[ivar];

            double dx = bincenter - nextbincenter;
            double dy = ref - refnext;
            p += (x[itype] - bincenter) * dy/dx;
         }

         if (p < fEpsilon) p = fEpsilon; // avoid zero response

         if (itype == 0) ps *= p;
         else            pb *= p;
      }            
   }     

   // the likelihood ratio (transform it ?)
   return TransformLikelihoodOutput( ps, pb );   
}

inline double ReadLikelihoodPCA::TransformLikelihoodOutput( double ps, double pb ) const
{
   // returns transformed or non-transformed output
   if (ps + pb < fEpsilon) pb = fEpsilon;
   double r = ps/(ps + pb);

   if (false) {
      // inverse Fermi function

      // sanity check
      if      (r <= 0.0) r = fEpsilon;
      else if (r >= 1.0) r = 1.0 - fEpsilon;

      double tau = 15.0;
      r = - log(1.0/r - 1.0)/tau;
   }

   return r;
}

// Clean up
inline void ReadLikelihoodPCA::Clear() 
{
   // nothing to clear
}

// signal map
float ReadLikelihoodPCA::fRefS[][10000] = 
{ 
   { 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.31373348987308e-15, 1.43702578725424e-07, 4.33241922337402e-07, 7.22069898984046e-07, 1.01160935628286e-06, 1.30114869989484e-06, 1.59139938205044e-06, 1.88236163012334e-06, 2.17332376450941e-06, 2.46499712375225e-06, 2.75667093774246e-06, 3.04976720144623e-06, 3.34215201291954e-06, 3.63524850399699e-06, 3.92834499507444e-06, 4.22215271100868e-06, 4.5166716517997e-06, 4.81261349705164e-06, 5.10642166773323e-06, 5.40165183338104e-06, 5.69901658309391e-06, 5.99638178755413e-06, 6.29303485766286e-06, 6.58968838251894e-06, 6.88776481183595e-06, 7.18512956154882e-06, 7.48391676097526e-06, 7.78199319029227e-06, 8.0814916145755e-06, 8.38099094835343e-06, 8.68191273184493e-06, 8.98212329047965e-06, 9.28304507397115e-06, 9.58396594796795e-06, 9.88559895631624e-06, 1.01872328741592e-05, 1.0489578016859e-05, 1.07926334749209e-05, 1.10956898424774e-05, 1.13994565253961e-05, 1.17039353426662e-05, 1.20098375191446e-05, 1.23143145174254e-05, 1.26180830193334e-05, 1.29254067360307e-05, 1.32313089125091e-05, 1.35379214043496e-05, 1.38445338961901e-05, 1.41518585223821e-05, 1.44598943734309e-05, 1.47679302244796e-05, 1.50766782098799e-05, 1.53854252857855e-05, 1.56941714521963e-05, 1.60043418873101e-05, 1.63145105034346e-05, 1.66246827575378e-05, 1.6935562598519e-05, 1.72464442584896e-05, 1.75594595930306e-05, 1.7871052477858e-05, 1.8184067812399e-05, 1.849708314694e-05, 1.88115227501839e-05, 1.91238268598681e-05, 1.94389758689795e-05, 1.9753413653234e-05, 2.00685644813348e-05, 2.03844247153029e-05, 2.0700284949271e-05, 2.10161470022285e-05, 2.13327202800428e-05, 2.16500029637245e-05, 2.1967289285385e-05, 2.22852831939235e-05, 2.26032789214514e-05, 2.29219858738361e-05, 2.32414022320881e-05, 2.3560822228319e-05, 2.38809498114279e-05, 2.42003698076587e-05, 2.45212104346137e-05, 2.48420510615688e-05, 2.51636029133806e-05, 2.5486577214906e-05, 2.5807417841861e-05, 2.61303957813652e-05, 2.6455503757461e-05, 2.67791911028326e-05, 2.71028766292147e-05, 2.74265639745863e-05, 2.77509607258253e-05, 2.80767817457672e-05, 2.84018915408524e-05, 2.87277125607943e-05, 2.90542429866036e-05, 2.93814882752486e-05, 2.97087299259147e-05, 3.00359752145596e-05, 3.03639299090719e-05, 3.06918846035842e-05, 3.10205505229533e-05, 3.13499294861685e-05, 3.1679304811405e-05, 3.20093968184665e-05, 3.23394851875491e-05, 3.26709960063454e-05, 3.30017974192742e-05, 3.3334730687784e-05, 3.36669545504265e-05, 3.39977559633553e-05, 3.43321153195575e-05, 3.46650485880673e-05, 3.49986949004233e-05, 3.53323412127793e-05, 3.566740633687e-05, 3.60024787369184e-05, 3.6337547498988e-05, 3.66726126230787e-05, 3.70091074728407e-05, 3.73448856407776e-05, 3.7682089896407e-05, 3.80192905140575e-05, 3.83564947696868e-05, 3.86951214750297e-05, 3.90337481803726e-05, 3.93730842915829e-05, 3.97117109969258e-05, 4.00517601519823e-05, 4.03918093070388e-05, 4.07332809118088e-05, 4.10726170230191e-05, 4.14155110775027e-05, 4.17569826822728e-05, 4.2099167330889e-05, 4.24420613853727e-05, 4.27849518018775e-05, 4.31285589002073e-05, 4.34721623605583e-05, 4.38157694588881e-05, 4.41607990069315e-05, 4.45051191491075e-05, 4.48508581030183e-05, 4.5196597056929e-05, 4.55430454167072e-05, 4.58895010524429e-05, 4.62366624560673e-05, 4.65838238596916e-05, 4.6931701945141e-05, 4.72795727546327e-05, 4.76281566079706e-05, 4.79781701869797e-05, 4.83260409964714e-05, 4.86760472995229e-05, 4.90281890961342e-05, 4.93789120810106e-05, 4.97296314279083e-05, 5.00810638186522e-05, 5.04332056152634e-05, 5.07853437738959e-05, 5.11374892084859e-05, 5.14903404109646e-05, 5.1843911933247e-05, 5.21981855854392e-05, 5.25524592376314e-05, 5.29074495716486e-05, 5.32624399056658e-05, 5.36174266017042e-05, 5.39731263415888e-05, 5.43295354873408e-05, 5.46859482710715e-05, 5.50430704606697e-05, 5.54009020561352e-05, 5.57594503334258e-05, 5.61172819288913e-05, 5.64772490179166e-05, 5.68365067010745e-05, 5.71950513403863e-05, 5.7555727835279e-05, 5.79164079681505e-05, 5.82770917390008e-05, 5.86377645959146e-05, 5.89998708164785e-05, 5.93619697610848e-05, 5.97240759816486e-05, 6.00868879701011e-05, 6.04504093644209e-05, 6.08132249908522e-05, 6.11774667049758e-05, 6.15417011431418e-05, 6.1906648625154e-05, 6.22715961071663e-05, 6.26379624009132e-05, 6.30036229267716e-05, 6.33699964964762e-05, 6.37370758340694e-05, 6.41041551716626e-05, 6.44726605969481e-05, 6.48397472104989e-05, 6.52089656796306e-05, 6.55781768728048e-05, 6.59481011098251e-05, 6.63173195789568e-05, 6.66872438159771e-05, 6.70578883728012e-05, 6.74285256536677e-05, 6.77998759783804e-05, 6.81712263030931e-05, 6.85432823956944e-05, 6.89153530402109e-05, 6.92888352205046e-05, 6.96623174007982e-05, 7.0036512624938e-05, 7.04100020811893e-05, 7.07849103491753e-05, 7.11598113412037e-05, 7.15347196091898e-05, 7.1910340921022e-05, 7.2287381044589e-05, 7.26630023564212e-05, 7.30407482478768e-05, 7.34192144591361e-05, 7.37969676265493e-05, 7.41747207939625e-05, 7.45531870052218e-05, 7.49323589843698e-05, 7.53115382394753e-05, 7.56914232624695e-05, 7.60713082854636e-05, 7.64519136282615e-05, 7.68332174629904e-05, 7.72145285736769e-05, 7.75965527282096e-05, 7.79785696067847e-05, 7.83613068051636e-05, 7.87440367275849e-05, 7.91274796938524e-05, 7.95109226601198e-05, 7.98950786702335e-05, 8.02806607680395e-05, 8.06655225460418e-05, 8.10511046438478e-05, 8.14381055533886e-05, 8.18243934190832e-05, 8.22106885607354e-05, 8.25976894702762e-05, 8.29853961477056e-05, 8.33723970572464e-05, 8.37608240544796e-05, 8.41506625874899e-05, 8.45390968606807e-05, 8.49289426696487e-05, 8.5318781202659e-05, 8.57086342875846e-05, 8.60991858644411e-05, 8.6490465037059e-05, 8.68817296577618e-05, 8.72737073223107e-05, 8.76671110745519e-05, 8.80590887391008e-05, 8.84524924913421e-05, 8.88458962435834e-05, 8.92400130396709e-05, 8.96341298357584e-05, 9.00303784874268e-05, 9.04237822396681e-05, 9.08207512111403e-05, 9.12169925868511e-05, 9.16132412385195e-05, 9.20102029340342e-05, 9.24071573535912e-05, 9.28048393689096e-05, 9.32025141082704e-05, 9.36008946155198e-05, 9.39999808906578e-05, 9.43990817177109e-05, 9.47981752688065e-05, 9.51994079514407e-05, 9.55992072704248e-05, 9.6000439953059e-05, 9.64009595918469e-05, 9.68028980423696e-05, 9.72048364928924e-05, 9.76074879872613e-05, 9.80101394816302e-05, 9.84142243396491e-05, 9.88175816019066e-05, 9.92216591839679e-05, 9.96271483018063e-05, 0.000100031938927714, 0.00010043743532151, 0.000100842938991264, 0.000101249141152948, 0.00010165535059059, 0.000102062265796121, 0.00010246918827761, 0.00010287753684679, 0.000103285870864056, 0.000103694226709194, 0.000104103273770306, 0.000104512328107376, 0.000104922095488291, 0.000105331855593249, 0.000105742336018011, 0.000106153529486619, 0.000106565428723115, 0.000106977327959612, 0.000107389219920151, 0.000107801839476451, 0.000108215877844486, 0.000108629195892718, 0.000109042513940949, 0.00010945726535283, 0.00010987128916895, 0.000110286040580831, 0.000110702210804448, 0.000111118381028064, 0.00011153455125168, 0.000111950714199338, 0.0001123675974668, 0.000112785186502151, 0.00011320278281346, 0.000113621077616699, 0.000114039379695896, 0.000114459107862785, 0.000114878836029675, 0.000115298556920607, 0.000115718990855385, 0.00011613943206612, 0.000116560579044744, 0.000116981733299326, 0.000117405012133531, 0.000117825446068309, 0.000118249445222318, 0.000118673437100369, 0.000119096723210532, 0.000119520715088584, 0.000119944699690677, 0.000120369404612575, 0.000120794822578318, 0.00012122024782002, 0.000121645665785763, 0.000122072509839199, 0.000122499346616678, 0.000122926896438003, 0.000123353733215481, 0.000123781996080652, 0.000124210258945823, 0.00012463923485484, 0.000125068196211942, 0.000125497172120959, 0.000125927559565753, 0.000126358689158224, 0.000126789076603018, 0.00012722160317935, 0.000127653416711837, 0.000128085244796239, 0.000128517058328725, 0.000128950297948904, 0.000129382839077152, 0.000129816791741177, 0.000130250744405203, 0.00013068612315692, 0.000131120788864791, 0.000131555440020747, 0.000131991531816311, 0.000132426910568029, 0.000132863715407439, 0.000133300520246848, 0.000133737310534343, 0.00013417552690953, 0.000134613030240871, 0.000135052687255666, 0.000135491616674699, 0.000135930546093732, 0.000136370188556612, 0.000136811257107183, 0.000137251612613909, 0.000137692681164481, 0.000138133749715053, 0.000138575531309471, 0.000139018025947735, 0.000139461233629845, 0.000139903713716194, 0.000140346906846389, 0.000140790827572346, 0.000141234733746387, 0.00014167936751619, 0.000142123986734077, 0.000142569318995811, 0.000143015378853306, 0.000143462137202732, 0.000143908182508312, 0.000144354926305823, 0.000144802397699095, 0.000145249883644283, 0.000145698068081401, 0.000146148377098143, 0.000146597260027193, 0.000147045444464311, 0.00014749719412066, 0.000147947503137402, 0.000148397826706059, 0.000148848848766647, 0.000149299870827235, 0.000149751605931669, 0.000150204068631865, 0.00015065650222823, 0.000151109663420357, 0.00015156353765633, 0.000152017411892302, 0.000152471999172121, 0.000152925873408094, 0.000153381159179844, 0.000153836459503509, 0.000154292458319105, 0.000154748471686617, 0.000155205198097974, 0.000155662623001263, 0.00015612218703609, 0.000156578200403601, 0.000157037749886513, 0.000157496615429409, 0.00015795546642039, 0.000158415030455217, 0.00015887530753389, 0.000159334857016802, 0.000159795847139321, 0.000160256837261841, 0.000160719253472053, 0.000161180942086503, 0.000161643343744799, 0.000162105774506927, 0.000162568874657154, 0.000163032716955058, 0.000163496544701047, 0.000163961085490882, 0.000164425640832633, 0.00016489160771016, 0.000165356861543842, 0.000165822828421369, 0.000166289508342743, 0.000166756173712201, 0.000167224279721268, 0.000167692371178418, 0.000168159778695554, 0.000168628583196551, 0.000169097387697548, 0.000169566905242391, 0.000170037150382996, 0.000170506682479754, 0.000170976913068444, 0.000171447856700979, 0.000171918800333515, 0.000172390457009897, 0.000172862826730125, 0.000173335196450353, 0.000173808977706358, 0.000174282075022347, 0.000174755856278352, 0.000175229637534358, 0.000175704146386124, 0.000176178655237891, 0.000176653862581588, 0.00017713122360874, 0.000177607143996283, 0.000178082351339981, 0.000178561123902909, 0.000179038470378146, 0.000179516544449143, 0.00017999458941631, 0.000180472663487308, 0.000180951436050236, 0.000181430921657011, 0.00018191039271187, 0.000182390591362491, 0.000182872216100805, 0.000183353113243356, 0.000183834024937823, 0.000184315635124221, 0.000184797972906381, 0.000185280296136625, 0.000185763332410716, 0.000186247081728652, 0.000186730845598504, 0.000187214594916441, 0.000187701909453608, 0.000188184945727699, 0.000188671532669105, 0.000189157435670495, 0.000189644008059986, 0.000190130624105223, 0.000190617196494713, 0.000191104511031881, 0.000191592538612895, 0.000192081992281601, 0.000192570005310699, 0.00019305944442749, 0.000193548883544281, 0.000194038337212987, 0.000194528474821709, 0.000195019354578108, 0.000195510205230676, 0.000196001783479005, 0.000196493361727335, 0.000196986366063356, 0.000197479370399378, 0.000197973786271177, 0.000198466063011438, 0.000198959780391306, 0.000199455622350797, 0.000199950052774511, 0.000200445181690156, 0.000200940310605802, 0.000201437593204901, 0.000201933435164392, 0.000202429975615814, 0.000202927258214913, 0.000203425239305943, 0.000203922507353127, 0.000204421186936088, 0.000204919895622879, 0.000205419288249686, 0.000205918695428409, 0.000206419499590993, 0.000206919634365477, 0.000207420453079976, 0.000207921271794476, 0.000208422818104737, 0.000208925062906928, 0.00020942730770912, 0.000209931677090935, 0.000210434649488889, 0.000210937607334927, 0.00021144341735635, 0.000211947786738165, 0.000212452170671895, 0.000212957282201387, 0.000213463077670895, 0.000213968873140402, 0.000214475381653756, 0.000214982617762871, 0.000215489839320071, 0.000215997788473032, 0.000216506436117925, 0.000217014370718971, 0.000217523018363863, 0.000218032393604517, 0.000218542467337102, 0.000219052541069686, 0.000219562600250356, 0.000220073401578702, 0.00022058559989091, 0.00022109852579888, 0.00022160931257531, 0.000222123650019057, 0.000222636561375111, 0.000223149487283081, 0.000223663126234896, 0.000224177449126728, 0.000224691786570475, 0.000225206851609983, 0.000225723313633353, 0.000226239091716707, 0.000226754855248146, 0.000227271317271516, 0.000227788521442562, 0.000228305711061694, 0.000228823584620841, 0.000229341501835734, 0.000229860102990642, 0.000230380144785158, 0.000230899473535828, 0.000231419486226514, 0.000231940954108723, 0.000232460268307477, 0.00023298102314584, 0.000233503902563825, 0.000234025341342203, 0.000234547522268258, 0.000235071100178175, 0.00023559397959616, 0.000236117572057992, 0.000236641179071739, 0.000237165455473587, 0.000237690474023111, 0.000238215492572635, 0.000238740496570244, 0.000239266941207461, 0.000239792658248916, 0.00024032051442191, 0.000240847657551058, 0.000241374800680205, 0.000241902671405114, 0.000242431226070039, 0.000242959809838794, 0.00024348909209948, 0.000244018374360166, 0.000244549795752391, 0.00024508050410077, 0.000245609757257625, 0.000246142619289458, 0.000246674026129767, 0.000247206160565838, 0.000247738265898079, 0.000248271098826081, 0.000248803960857913, 0.000249338219873607, 0.00024987175129354, 0.000250406737904996, 0.000250941695412621, 0.000251476652920246, 0.000252012367127463, 0.00025254805223085, 0.000253085134318098, 0.000253621547017246, 0.000254158658208326, 0.000254696467891335, 0.000255235005170107, 0.000255773542448878, 0.000256313476711512, 0.000256851286394522, 0.000257392675848678, 0.000257932639215142, 0.000258473271969706, 0.000259013962931931, 0.000259555323282257, 0.000260096683632582, 0.000260639499174431, 0.000261182285612449, 0.000261725101154298, 0.000262268586084247, 0.000262812100118026, 0.000263356312643737, 0.000263900554273278, 0.000264445465290919, 0.000264990405412391, 0.000265536771621555, 0.000266083108726889, 0.000266629474936053, 0.000267176539637148, 0.000267725030425936, 0.0002682713966351, 0.000268819858320057, 0.000269369775196537, 0.000269918993581086, 0.000270468182861805, 0.000271018798230216, 0.000271568715106696, 0.000272119330475107, 0.000272669974947348, 0.00027322128880769, 0.000273773330263793, 0.000274325371719897, 0.000274878140771762, 0.000275430909823626, 0.000275985075859353, 0.00027653924189508, 0.000277093437034637, 0.000277647603070363, 0.000278202496701851, 0.000278758117929101, 0.000279314437648281, 0.000279870029771701, 0.000280427047982812, 0.000280985521385446, 0.000281543238088489, 0.00028210028540343, 0.000282659428194165, 0.0002832185709849, 0.000283777015283704, 0.00028433691477403, 0.000284896785160527, 0.000285456655547023, 0.000286017952021211, 0.0002865792484954, 0.000287141243461519, 0.000287702539935708, 0.000288265262497589, 0.000288827955955639, 0.00028939067851752, 0.000289954827167094, 0.000290518248220906, 0.00029108309536241, 0.000291647244011983, 0.00029221351724118, 0.000292779091978446, 0.000293346063699573, 0.000293910910841078, 0.000294479308649898, 0.000295046309474856, 0.000295614008791745, 0.000296182406600565, 0.000296750105917454, 0.000297319929813966, 0.000297889055218548, 0.00029845887911506, 0.000299028703011572, 0.000299599254503846, 0.00030016980599612, 0.000300741055980325, 0.00030131300445646, 0.000301884982036427, 0.000302457658108324, 0.000303031032672152, 0.000303603708744049, 0.000304177840007469, 0.000304751913063228, 0.00030532744131051, 0.000305900815874338, 0.00030647634412162, 0.000307053298456594, 0.000307629525195807, 0.000308206479530782, 0.000308783404761925, 0.000309361057588831, 0.000309938739519566, 0.000310516392346472, 0.000311094743665308, 0.000311673822579905, 0.000312252901494503, 0.000312832708004862, 0.000313413213007152, 0.000313994416501373, 0.000314575619995594, 0.000315156852593645, 0.000315738056087866, 0.00031632068566978, 0.000316903315251693, 0.000317485944833606, 0.000318069302011281, 0.000318653386784717, 0.000319239567033947, 0.000319824321195483, 0.000320407678373158, 0.000320994586218148, 0.000321580067975447, 0.000322166248224676, 0.000322753156069666, 0.000323340063914657, 0.000323926971759647, 0.00032451530569233, 0.000325104338116944, 0.000325692672049627, 0.000326281704474241, 0.000326871435390785, 0.000327461195411161, 0.000328050955431536, 0.000328642141539603, 0.000329232570948079, 0.000329824455548078, 0.000330417067743838, 0.000331008923240006, 0.000331602233927697, 0.000332196243107319, 0.000332788156811148, 0.000333383592078462, 0.000333978299750015, 0.000334572338033468, 0.000335167802404612, 0.000335763237671927, 0.000336360099026933, 0.000336956232786179, 0.000337553123245016, 0.000338149955496192, 0.00033874754444696, 0.000339345831889659, 0.000339944119332358, 0.000340542406775057, 0.000341142120305449, 0.00034174183383584, 0.000342342216754332, 0.000342942657880485, 0.000343543069902807, 0.000344144209520891, 0.000344747473718598, 0.000345347914844751, 0.000345950451446697, 0.000346554414136335, 0.000347157678334042, 0.000347762397723272, 0.000348366360412911, 0.000348970352206379, 0.000349575013387948, 0.000350180431269109, 0.00035078584915027, 0.000351391936419532, 0.000351998751284555, 0.000352605624357238, 0.000353213137714192, 0.000353821378666908, 0.000354428892023861, 0.000355037860572338, 0.000355646101525053, 0.000356255768565461, 0.000356865464709699, 0.000357475859345868, 0.000358086195774376, 0.000358696561306715, 0.00035931053571403, 0.000359922327334061, 0.0003605326928664, 0.000361146638169885, 0.000361759884981439, 0.000362373102689162, 0.000362986349500716, 0.000363600993296131, 0.000364214909495786, 0.000364831008482724, 0.000365446350770071, 0.000366061722161248, 0.000366678490536287, 0.000367294531315565, 0.000367911357898265, 0.000368528824765235, 0.000369147019227967, 0.000369765242794529, 0.000370383466361091, 0.000371003086911514, 0.000371622707461938, 0.000372242328012362, 0.00037286410224624, 0.000373483024304733, 0.000374105467926711, 0.000374727242160589, 0.000375349016394466, 0.000375971460016444, 0.000376594660338014, 0.000377217860659584, 0.000377841031877324, 0.000378464930690825, 0.000379088858608156, 0.000379714154405519, 0.000380338751710951, 0.000380964105715975, 0.000381590100005269, 0.000382216152502224, 0.000382843601983041, 0.000383471051463857, 0.000384098500944674, 0.000384726678021252, 0.000385354825994, 0.00038598442915827, 0.000386612606234848, 0.000387242180295289, 0.000387873878935352, 0.000388504209695384, 0.000389134511351585, 0.000389766239095479, 0.000390397966839373, 0.000391029694583267, 0.000391662120819092, 0.000392294547054917, 0.000392928370274603, 0.000393562251701951, 0.000394196104025468, 0.000394829956348985, 0.000395465263864025, 0.000396100542275235, 0.000396736519178376, 0.000397372525185347, 0.000398008502088487, 0.000398645206587389, 0.000399283308070153, 0.000399920740164816, 0.00040055884164758, 0.000401198398321867, 0.000401837954996154, 0.000402476813178509, 0.000403116369852796, 0.000403756625019014, 0.000404396880185232, 0.000405038532335311, 0.00040567951509729, 0.0004063211963512, 0.00040696287760511, 0.000407605984946713, 0.000408249063184485, 0.000408892170526087, 0.000409536005463451, 0.000410179811296985, 0.000410824344726279, 0.000411469576647505, 0.000412114808568731, 0.000412760797189549, 0.000413408124586567, 0.000414054113207385, 0.000414700742112473, 0.000415349582908675, 0.000415995513321832, 0.000416644994402304, 0.000417294504586607, 0.000417943287175149, 0.000418592826463282, 0.000419242336647585, 0.000419892545323819, 0.000420543481595814, 0.00042119441786781, 0.000421846023527905, 0.000422497687395662, 0.00042315004975535, 0.000423802412115037, 0.000424455472966656, 0.000425109232310206, 0.000425763020757586, 0.000426417507696897, 0.000427071965532377, 0.00042772718006745, 0.000428382394602522, 0.000429039733717218, 0.00042969489004463, 0.000430352985858917, 0.000431010295869783, 0.000431667634984478, 0.000432325672591105, 0.000432983681093901, 0.00043364247540012, 0.000434301909990609, 0.000434961402788758, 0.000435621594078839, 0.000436281756265089, 0.0004369426460471, 0.000437603535829112, 0.000438265153206885, 0.000438927439972758, 0.000439589755842462, 0.000440252071712166, 0.000440915784565732, 0.000441578828031197, 0.000442243297584355, 0.000442907708929852, 0.000443572149379179, 0.000444237317424268, 0.00044490463915281, 0.000445571204181761, 0.00044623707071878, 0.000446903664851561, 0.000447570957476273, 0.000448238948592916, 0.000448906939709559, 0.000449575658421963, 0.000450244377134368, 0.000450913794338703, 0.000451583240646869, 0.000452253356343135, 0.000452923501143232, 0.00045359437353909, 0.000454265915323049, 0.000454938184702769, 0.000455609726486728, 0.000456282024970278, 0.00045695502194576, 0.000457630114397034, 0.000458302383776754, 0.000458976806839928, 0.000459652655990794, 0.000460325623862445, 0.000461002899101004, 0.000461678690044209, 0.000462354539195076, 0.000463031057734042, 0.000463708303868771, 0.000464385579107329, 0.000465063523733988, 0.000465741497464478, 0.000466420169686899, 0.00046709887101315, 0.000467778241727501, 0.000468458340037614, 0.000469138438347727, 0.000469819235149771, 0.000470500061055645, 0.00047118155634962, 0.000471863080747426, 0.000472545303637162, 0.00047322828322649, 0.00047391263069585, 0.000474594853585586, 0.000475279928650707, 0.000475964305223897, 0.000476648652693257, 0.000477333756862208, 0.00047801953041926, 0.000478705333080143, 0.000479391135741025, 0.00048007833538577, 0.000480765535030514, 0.000481452734675258, 0.000482140661915764, 0.00048282858915627, 0.000483517942484468, 0.000484206568216905, 0.000484896649140865, 0.000485585944261402, 0.000486276723677292, 0.000486967532197013, 0.000487658282509074, 0.000488349760416895, 0.00048904336290434, 0.000489734171424061, 0.000490428472403437, 0.000489109486807138, 0.000485779833979905, 0.000482461851788685, 0.000479155278299004, 0.000475837645353749, 0.000472554180305451, 0.000469270773464814, 0.000465999386506155, 0.000462705240352079, 0.000459467992186546, 0.000456219771876931, 0.000452971900813282, 0.000449724000645801, 0.000446510617621243, 0.000443297234596685, 0.000440061412518844, 0.000436871516285464, 0.000433692621299997, 0.000430503801908344, 0.000427313847467303, 0.000424147758167237, 0.000421004107920453, 0.000417860050220042, 0.000414695066865534, 0.000411563494708389, 0.000408443302148953, 0.000405346188927069, 0.000402215344365686, 0.000399118987843394, 0.00039604541962035, 0.000392960413591936, 0.000389875785913318, 0.000386802887078375, 0.000383752747438848, 0.000380702636903152, 0.000377664604457095, 0.000374637631466612, 0.00037161132786423, 0.000368585024261847, 0.000365593266906217, 0.000362590071745217, 0.000359609693987295, 0.000356619304511696, 0.000353650277247652, 0.000350682676071301, 0.000347737484844401, 0.000344780914019793, 0.000341847800882533, 0.000338914367603138, 0.000335992663167417, 0.00033308265847154, 0.000330172711983323, 0.000327286194078624, 0.000324376567732543, 0.000321512838127092, 0.000318649457767606, 0.00031578607740812, 0.000312911666696891, 0.000310082803480327, 0.000307242851704359, 0.000304426095681265, 0.000301575171761215, 0.000298781495075673, 0.000295988545985892, 0.000293194869300351, 0.000290389842120931, 0.00028760897112079, 0.000284861540421844, 0.000282103108474985, 0.000279333646176383, 0.000276598293567076, 0.000273863319307566, 0.000271139753749594, 0.000268405128736049, 0.000265693612163886, 0.000263004883890972, 0.000260316504864022, 0.000257616746239364, 0.000254939775913954, 0.000252286234172061, 0.000249632721533999, 0.000246967829298228, 0.00024432607460767, 0.00024170738470275, 0.000239065979258157, 0.000236448366194963, 0.000233840750297531, 0.000231246260227636, 0.000228651086217724, 0.000226066913455725, 0.000223495924728923, 0.000220947011257522, 0.0002183642500313, 0.000215815671253949, 0.000213278835872188, 0.000210753350984305, 0.000208216864848509, 0.000205703487154096, 0.000203201503609307, 0.000200711248908192, 0.000198209614609368, 0.000195731103303842, 0.00019326395704411, 0.000190774444490671, 0.000188342164619826, 0.000185898505151272, 0.000183455209480599, 0.000181011913809925, 0.000178603120730259, 0.000176183631992899, 0.000173786582308821, 0.000171367108123377, 0.000168993181432597, 0.000166619574883953, 0.000164246011991054, 0.000161872783792205, 0.000159533708938397, 0.000157183603732847, 0.00015484522737097, 0.000152506851009093, 0.000150202627992257, 0.000147887389175594, 0.000145561105455272, 0.000143269353429787, 0.000141000316943973, 0.000138731324113905, 0.000136439906782471, 0.000134182992042042, 0.000131926077301614, 0.000129692285554484, 0.000127436462207697, 0.000125214384752326, 0.000123014731798321, 0.000120805132610258, 0.000118583455332555, 0.000116396251542028, 0.000114209396997467, 0.000112045687274076, 0.000109859203803353, 0.000107706866401713, 0.000105554878246039, 0.00010342565656174, 0.000101274396001827, 9.91458800854161e-05, 9.70401524682529e-05, 9.49461318668909e-05, 9.28183362702839e-05, 9.07357316464186e-05, 8.86538255144842e-05, 8.65719193825498e-05, 8.45017420942895e-05, 8.24543531052768e-05, 8.04079973022453e-05, 7.83488358138129e-05, 7.63256248319522e-05, 7.43020573281683e-05, 7.22891563782468e-05, 7.02666511642747e-05, 6.82775935274549e-05, 6.62888705846854e-05, 6.43118764855899e-05, 6.23235246166587e-05, 6.0369315178832e-05, 5.84154586249497e-05, 5.64733491046354e-05, 5.45084512850735e-05, 5.25894574820995e-05, 5.06708202010486e-05, 4.87404358864296e-05, 4.68335201730952e-05, 4.49493963969871e-05, 4.30656000389718e-05, 4.11704531870782e-05, 3.92990914406255e-05, 3.74491064576432e-05, 3.5600176488515e-05, 3.37295568897389e-05, 3.19037462759297e-05, 3.00779574899934e-05, 2.82642267848132e-05, 2.64277496171417e-05, 2.46254312514793e-05, 2.2846214051242e-05, 2.10670150408987e-05, 1.92657353181858e-05, 1.74982833414106e-05, 1.57542817760259e-05, 1.39757885335712e-05, 1.22317878776812e-05, 1.04998853203142e-05, 8.76798367244191e-06, 7.04710237187101e-06, 5.35008484803257e-06, 3.64092966265162e-06, 1.94426456801011e-06, 2.58581422940551e-07, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.000490774400532246, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 0.00138645165134221, 1.33313608330354e-06, 3.04123386740685e-06, 4.737233666674e-06, 6.43385965304333e-06, 8.15335079096258e-06, 9.89590262179263e-06, 1.16043529487797e-05, 1.33703961182619e-05, 1.51133390318137e-05, 1.6868341845111e-05, 1.86339930223767e-05, 2.04239186132327e-05, 2.21903155761538e-05, 2.40025965467794e-05, 2.58038380707148e-05, 2.75937254627934e-05, 2.94184956146637e-05, 3.12659758492373e-05, 3.30789625877514e-05, 3.49382280546706e-05, 3.67864522559103e-05, 3.86342835554387e-05, 4.05056453018915e-05, 4.23997189500369e-05, 4.42714335804339e-05, 4.61545023426879e-05, 4.80717535538133e-05, 4.99782363476697e-05, 5.18965425726492e-05, 5.3825497161597e-05, 5.57669045520015e-05, 5.77083083044272e-05, 5.96721110923681e-05, 6.16256584180519e-05, 6.35898468317464e-05, 6.55778057989664e-05, 6.75651026540436e-05, 6.95530980010517e-05, 7.15759815648198e-05, 7.35753710614517e-05, 7.55982546252199e-05, 7.76214510551654e-05, 7.96784734120592e-05, 8.17134132375941e-05, 8.37824918562546e-05, 8.58402636367828e-05, 8.79100480233319e-05, 8.99795195437036e-05, 9.20837992453016e-05, 9.41764155868441e-05, 9.62693375186063e-05, 9.83971112873405e-05, 0.000100524921435863, 0.000102640988188796, 0.00010478089825483, 0.000106943196442444, 0.000109082713606767, 0.000111268469481729, 0.000113442518340889, 0.000115605878818315, 0.000117791634693276, 0.00012000092829112, 0.000122199126053602, 0.000124443220556714, 0.000126663857372478, 0.000128885949379764, 0.000131118300487287, 0.000133374138385989, 0.000135630325530656, 0.000137886207085103, 0.000140188640216365, 0.000142456570756622, 0.000144747653394006, 0.000147050435771234, 0.000149353567394428, 0.000151667394675314, 0.000154016801388934, 0.00015634237206541, 0.000158680384629406, 0.00016102941299323, 0.000163390563102439, 0.000165763398399577, 0.000168158381711692, 0.000170531566254795, 0.000172916566953063, 0.000175312175997533, 0.000177731271833181, 0.000180150775122456, 0.000182581265107729, 0.000185024211532436, 0.000187455021659844, 0.000189909726032056, 0.000192375417100266, 0.000194841108168475, 0.000197307585040107, 0.000199819871340878, 0.000202309063752182, 0.00020481031970121, 0.000207322606001981, 0.000209846679354087, 0.000212360042496584, 0.000214918225537986, 0.00021746612037532, 0.000220013651414774, 0.00022258392709773, 0.000225143900024705, 0.000227714524953626, 0.000230320380069315, 0.000232915204833262, 0.00023552036145702, 0.000238137959968299, 0.000240755907725543, 0.00024337311333511, 0.000246037321630865, 0.000248677679337561, 0.000251330842729658, 0.000253994687227532, 0.00025667023146525, 0.000259335152804852, 0.000262023182585835, 0.000264744623564184, 0.000267444382188842, 0.000270166550762951, 0.000272888719337061, 0.000275611586403102, 0.000278345483820885, 0.000281114625977352, 0.000283860281342641, 0.000286629714537412, 0.000289398856693879, 0.000292180076939985, 0.000294971978291869, 0.000297788035823032, 0.00030059166601859, 0.000303396343952045, 0.000306235189782456, 0.000309062306769192, 0.000311901821987703, 0.000314752047415823, 0.000317614729283378, 0.000320489139994606, 0.000323363172356039, 0.000326248642522842, 0.000329134752973914, 0.00033203192288056, 0.000334952579578385, 0.000337873236276209, 0.000340805272571743, 0.000343738007359207, 0.000346670392900705, 0.000349626265233383, 0.000352593866409734, 0.000355560739990324, 0.000358539691660553, 0.000361530459485948, 0.000364520790753886, 0.000367512606317177, 0.000370537483831868, 0.00037355165113695, 0.000376566196791828, 0.000379625940695405, 0.000382663623895496, 0.000385713035939261, 0.000388762098737061, 0.000391857378417626, 0.000394918519305065, 0.000398024858441204, 0.000401120894821361, 0.000404216494644061, 0.000407324259867892, 0.000410465785535052, 0.000413573550758883, 0.000416727183619514, 0.000419880816480145, 0.000423023768234998, 0.00042617812869139, 0.000429377658292651, 0.000432555447332561, 0.000435744295828044, 0.000438944523921236, 0.000442134070908651, 0.000445346086053178, 0.00044859285117127, 0.000451805884949863, 0.000455041008535773, 0.000458311289548874, 0.000461547810118645, 0.000464817741885781, 0.000468088750494644, 0.000471382198156789, 0.00047466458636336, 0.000477970083011314, 0.000481275259517133, 0.000484581454657018, 0.000487910117954016, 0.000491250480990857, 0.000494579842779785, 0.000497943663503975, 0.00050129578448832, 0.000504671363160014, 0.000508034892845899, 0.000511433987412602, 0.000514820916578174, 0.000518208194989711, 0.000521630456205457, 0.000525051902513951, 0.000528474454768002, 0.000531920115463436, 0.00053535436745733, 0.000538787979166955, 0.000542268448043615, 0.000545736867934465, 0.000549206044524908, 0.000552686222363263, 0.000556189799681306, 0.000559682433959097, 0.000563208828680217, 0.000566724920645356, 0.000570241012610495, 0.00057377916527912, 0.000577329425141215, 0.000580879976041615, 0.000584453344345093, 0.000588027411140501, 0.00059158937074244, 0.000595175195485353, 0.000598772021476179, 0.00060238060541451, 0.000605989538598806, 0.000609621580224484, 0.000613241922110319, 0.000616874604020268, 0.000620518112555146, 0.000624184613116086, 0.000627851870376617, 0.000631518778391182, 0.000635197793599218, 0.000638887810055166, 0.000642589933704585, 0.000646292057354003, 0.000650016590952873, 0.000653731171041727, 0.000657468102872372, 0.000661204743664712, 0.000664953782688826, 0.000668702530674636, 0.000672474037855864, 0.000676246592774987, 0.000680029799696058, 0.00068381370510906, 0.000687621126417071, 0.000691427092533559, 0.000695234921295196, 0.000699065101798624, 0.000702883873600513, 0.000706737453583628, 0.000710590742528439, 0.000714444438926876, 0.000718309776857495, 0.000722186232451349, 0.000726064026821405, 0.000729963532648981, 0.000733864202629775, 0.000737775815650821, 0.000741688185371459, 0.000745611556340009, 0.000749547267332673, 0.000753493455704302, 0.000757441041059792, 0.000761410978157073, 0.000765369215514511, 0.000769351609051228, 0.000773332954850048, 0.000777338165789843, 0.000781332608312368, 0.000785337819252163, 0.000789365731179714, 0.00079337164061144, 0.000797422719188035, 0.000801463436800987, 0.000805514922831208, 0.000809567340184003, 0.00081365363439545, 0.00081771711120382, 0.000821815861854702, 0.000825914554297924, 0.000830012955702841, 0.000834123406093568, 0.000838245265185833, 0.000842366775032133, 0.000846512033604085, 0.000850656710099429, 0.000854813784826547, 0.000858970452100039, 0.000863138877321035, 0.000867319467943162, 0.000871511350851506, 0.000875714293215424, 0.00087990693282336, 0.000884133041836321, 0.000888336973730475, 0.00089258688967675, 0.000896813289728016, 0.000901075371075422, 0.000905313820112497, 0.00090958719374612, 0.000913849158678204, 0.000918145349714905, 0.000922430830541998, 0.000926739361602813, 0.000931035843677819, 0.000935356190893799, 0.000939676538109779, 0.000944007886573672, 0.000948351342231035, 0.000952694448642433, 0.000957050011493266, 0.00096142862457782, 0.000965794431976974, 0.000970173510722816, 0.000974575290456414, 0.000978964962996542, 0.000983378849923611, 0.000987791689112782, 0.000992216635495424, 0.000996653456240892, 0.00100110145285726, 0.00100553885567933, 0.0010100097861141, 0.00101447012275457, 0.00101895374245942, 0.00102343736216426, 0.00102793169207871, 0.0010324273025617, 0.00103694503195584, 0.00104145216755569, 0.00104599329642951, 0.00105052313301712, 0.0010550650767982, 0.00105960667133331, 0.00106418342329562, 0.0010687488829717, 0.00107332493644208, 0.00107791309710592, 0.00108250195626169, 0.00108710140921175, 0.00109171355143189, 0.001096336171031, 0.00110095995478332, 0.00110560609027743, 0.00111025245860219, 0.00111489940900356, 0.00111955835018307, 0.00112423906102777, 0.00112890976015478, 0.00113360281102359, 0.0011382841039449, 0.00114300078712404, 0.00114771700464189, 0.00115244521293789, 0.00115716177970171, 0.00116190151311457, 0.00116664206143469, 0.00117139413487166, 0.00117616832721978, 0.00118094321805984, 0.00118571810889989, 0.00119050440844148, 0.00119530269876122, 0.00120011251419783, 0.00120493408758193, 0.00120975531172007, 0.00121457746718079, 0.00121942209079862, 0.00122426671441644, 0.00122912344522774, 0.00123400322627276, 0.00123887101653963, 0.00124375149607658, 0.00124864280223846, 0.00125354540068656, 0.00125844904687256, 0.0012633748119697, 0.00126827869098634, 0.00127322832122445, 0.00127816619351506, 0.0012831047642976, 0.00128807779401541, 0.00129303906578571, 0.00129801244474947, 0.0013029855908826, 0.00130799331236631, 0.00131298985797912, 0.00131799781229347, 0.00132301775738597, 0.0013280373532325, 0.00133306905627251, 0.00133812392596155, 0.0013431670377031, 0.00134823296684772, 0.00135329982731491, 0.00135837739799172, 0.00136345624923706, 0.00136856827884912, 0.00137365842238069, 0.00137877161614597, 0.00138389563653618, 0.00139007391408086, 0.00139731331728399, 0.00140458659734577, 0.00141188269481063, 0.00141916749998927, 0.00142652029171586, 0.00143385061528534, 0.00144123786594719, 0.00144860218279064, 0.0014560236595571, 0.00146345631219447, 0.00147090025711805, 0.00147837866097689, 0.00148589082527906, 0.00149339181371033, 0.00150092702824622, 0.00150848482735455, 0.00151605415157974, 0.00152364617679268, 0.00153126113582402, 0.00153890997171402, 0.00154654763173312, 0.00155421951785684, 0.00156191398855299, 0.00156963104382157, 0.00157737114932388, 0.0015851566568017, 0.00159289664588869, 0.00160070497076958, 0.0016085134120658, 0.00161636713892221, 0.00162423239089549, 0.0016321090515703, 0.00163999700453132, 0.00164794200100005, 0.00165586418006569, 0.00166384316980839, 0.00167181075084955, 0.00167981255799532, 0.00168782589025795, 0.00169587309937924, 0.00170394324231893, 0.00171201326884329, 0.00172012916300446, 0.00172826740890741, 0.00173638307023793, 0.00174454413354397, 0.00175275094807148, 0.00176094612106681, 0.00176918716169894, 0.00177740515209734, 0.00178569171112031, 0.00179397792089731, 0.0018022870644927, 0.00181061902549118, 0.00181896239519119, 0.00182732846587896, 0.00183572864625603, 0.00184411730151623, 0.001852574525401, 0.00186099752318114, 0.00186947733163834, 0.00187797995749861, 0.00188648258335888, 0.00189500802662224, 0.00190359028056264, 0.00191214983351529, 0.00192074361257255, 0.00192933727521449, 0.00193798786494881, 0.00194664997979999, 0.00195530033670366, 0.00196400796994567, 0.00197271560318768, 0.00198145722970366, 0.00199021026492119, 0.00199897470884025, 0.00200778478756547, 0.00201661721803248, 0.00202543870545924, 0.00203430559486151, 0.00204317248426378, 0.00205207359977067, 0.00206100870855153, 0.00206993240863085, 0.00207890174351633, 0.0020878710784018, 0.0020968746393919, 0.00210590078495443, 0.00211493857204914, 0.00212399871088564, 0.00213310495018959, 0.00214217649772763, 0.00215131649747491, 0.00216043391264975, 0.00216961954720318, 0.00217881635762751, 0.00218800199218094, 0.00219723326154053, 0.00220647570677102, 0.00221574096940458, 0.00222504022531211, 0.00223432830534875, 0.00224366178736091, 0.0022529955022037, 0.00226237438619137, 0.00227176491171122, 0.00228117825463414, 0.00229060277342796, 0.0023000615183264, 0.00230950908735394, 0.0023190132342279, 0.00232851738110185, 0.00233803340233862, 0.0023476171772927, 0.00235715555027127, 0.00236676237545907, 0.00237635779194534, 0.00238599861040711, 0.00239565083757043, 0.00240532588213682, 0.00241502374410629, 0.00242475559934974, 0.00243446487002075, 0.00244424236007035, 0.00245399703271687, 0.00246380874887109, 0.0024736316408962, 0.00248346594162285, 0.00249331165105104, 0.00250318017788231, 0.00251309433951974, 0.00252301967702806, 0.00253293383866549, 0.0025429162196815, 0.00255287578329444, 0.00256288098171353, 0.00257290876470506, 0.00258293678052723, 0.00259301019832492, 0.0026030836161226, 0.00261319102719426, 0.00262329867109656, 0.00263345171697438, 0.00264360453002155, 0.00265380367636681, 0.00266399071551859, 0.00267423479817808, 0.00268445606343448, 0.00269474601373076, 0.00270501291379333, 0.00271532498300076, 0.00272564892657101, 0.00273600686341524, 0.00274635339155793, 0.0027567686047405, 0.00276713795028627, 0.00277757574804127, 0.00278803589753807, 0.00279848487116396, 0.00280899088829756, 0.00281949690543115, 0.00283002527430654, 0.00284057692624629, 0.00285113975405693, 0.0028617256321013, 0.00287232245318592, 0.00288297655060887, 0.00289363018237054, 0.00290429568849504, 0.00291499518789351, 0.00292571727186441, 0.00293642817996442, 0.00294720730744302, 0.00295798643492162, 0.00296875415369868, 0.00297958985902369, 0.00299040321260691, 0.00300127384252846, 0.00301213236525655, 0.00302305934019387, 0.00303395255468786, 0.00304489070549607, 0.00305585213936865, 0.00306683592498302, 0.00307781994342804, 0.00308884959667921, 0.00309987924993038, 0.00311094289645553, 0.00312202912755311, 0.00313311559148133, 0.00314425933174789, 0.00315537978895009, 0.00316654588095844, 0.00317773479036987, 0.00318892346695065, 0.0032001466024667, 0.00321139255538583, 0.00322266086004674, 0.00323395221494138, 0.00324524333700538, 0.00325656915083528, 0.00326791731640697, 0.00327928829938173, 0.00329067069105804, 0.00330207566730678, 0.00331349251791835, 0.00332494312897325, 0.00333640491589904, 0.00334791257046163, 0.00335940904915333, 0.00337092787958682, 0.0033824925776571, 0.00339404540136456, 0.00340564409270883, 0.00341726536862552, 0.0034288871102035, 0.00344054261222482, 0.00345218693837523, 0.00346388784237206, 0.0034756229724735, 0.00348733551800251, 0.00349910510703921, 0.00351088587194681, 0.00352265499532223, 0.00353448116220534, 0.0035462963860482, 0.00355817936360836, 0.00357002834789455, 0.00358193437568843, 0.00359384040348232, 0.00360576901584864, 0.00361773208715022, 0.00362971774302423, 0.00364171480759978, 0.00365374609827995, 0.00366577738896012, 0.00367782008834183, 0.00368990772403777, 0.00370199605822563, 0.00371412956155837, 0.00372625165618956, 0.00373841961845756, 0.00375061016529799, 0.00376280047930777, 0.00377502548508346, 0.00378728425130248, 0.0037995430175215, 0.00381181319244206, 0.0038240950088948, 0.00383643317036331, 0.00384878343902528, 0.00386114418506622, 0.00387352821417153, 0.0038859355263412, 0.00389834214001894, 0.00391080556437373, 0.00392325781285763, 0.00393576733767986, 0.00394825404509902, 0.00396079709753394, 0.00397334061563015, 0.00398589530959725, 0.00399848446249962, 0.00401111878454685, 0.00402373028919101, 0.00403638789430261, 0.00404905620962381, 0.0040617361664772, 0.00407446175813675, 0.00408717570826411, 0.00409993575885892, 0.00411270651966333, 0.00412548892199993, 0.00413829460740089, 0.00415113382041454, 0.00416399585083127, 0.00417688023298979, 0.00418974226340652, 0.00420268438756466, 0.00421559205278754, 0.00422856770455837, 0.00424154382199049, 0.0042545311152935, 0.00426755286753178, 0.00428060814738274, 0.00429364107549191, 0.00430673081427813, 0.00431982055306435, 0.00433295592665672, 0.00434606848284602, 0.00435922620818019, 0.00437240721657872, 0.00438559893518686, 0.00439883721992373, 0.00441208621487021, 0.00442533520981669, 0.00443860702216625, 0.00445192446932197, 0.00446523074060678, 0.00447859382256866, 0.00449194479733706, 0.0045053418725729, 0.00451873894780874, 0.00453215930610895, 0.00454560201615095, 0.00455906707793474, 0.00457254378125072, 0.00458607729524374, 0.00459957681596279, 0.00461313314735889, 0.0046266783028841, 0.00464029144495726, 0.00465389341115952, 0.00466751819476485, 0.00468115415424109, 0.00469483621418476, 0.00470850616693497, 0.00472223339602351, 0.00473594898357987, 0.00474971067160368, 0.00476348306983709, 0.00477726710960269, 0.00479108560830355, 0.00480490364134312, 0.00481877895072103, 0.00483264261856675, 0.00484651746228337, 0.00486043840646744, 0.00487439334392548, 0.00488833663985133, 0.00490232557058334, 0.00491629168391228, 0.00493032624945045, 0.00494434917345643, 0.00495839538052678, 0.004972486756742, 0.00498657766729593, 0.00500069186091423, 0.00501485215499997, 0.00502898870036006, 0.0050431601703167, 0.00505738751962781, 0.00507158134132624, 0.005085832439363, 0.00510008307173848, 0.00511435652151704, 0.00512866443023086, 0.00514298351481557, 0.00515733612701297, 0.00517167849466205, 0.00518607720732689, 0.00520047591999173, 0.00521488627418876, 0.00522935250774026, 0.00524378567934036, 0.00525828637182713, 0.00527281127870083, 0.0052873007953167, 0.00530185922980309, 0.0053164279088378, 0.00533100916072726, 0.00534562394022942, 0.00536023918539286, 0.0053748763166368, 0.00538956001400948, 0.00540423206984997, 0.00541896093636751, 0.00543366651982069, 0.00544842937961221, 0.00546319270506501, 0.00547797884792089, 0.00549279805272818, 0.00550764100626111, 0.00552248302847147, 0.00553736044093966, 0.00555222574621439, 0.00556715950369835, 0.00558209326118231, 0.00559703819453716, 0.00561202876269817, 0.00562700815498829, 0.0056420098990202, 0.00565704610198736, 0.00567210512235761, 0.00568717531859875, 0.00570226833224297, 0.00571738416329026, 0.00573254562914371, 0.00574766146019101, 0.00576286856085062, 0.00577807519584894, 0.00579327065497637, 0.00580851128324866, 0.00582376355305314, 0.0058390386402607, 0.00585437146946788, 0.00586966890841722, 0.0058850129134953, 0.00590036669746041, 0.00591575587168336, 0.00593115668743849, 0.00594656867906451, 0.00596201466396451, 0.00597749371081591, 0.00599295180290937, 0.0060084774158895, 0.00602398021146655, 0.00603951746597886, 0.00605509942397475, 0.00607067067176104, 0.00608628708869219, 0.00610190397128463, 0.00611754320561886, 0.00613321736454964, 0.00614891340956092, 0.0061646094545722, 0.00618034042418003, 0.00619608163833618, 0.00621185777708888, 0.00622762273997068, 0.00624346639961004, 0.00625929981470108, 0.00627513276413083, 0.00629099924117327, 0.00630690064281225, 0.00632279086858034, 0.00633873743936419, 0.00635468401014805, 0.00637066503986716, 0.00638664606958628, 0.00640264898538589, 0.00641869846731424, 0.00643473630771041, 0.00645081931725144, 0.00646692514419556, 0.00648303143680096, 0.00649916054680943, 0.00651531247422099, 0.00653148628771305, 0.00654769549146295, 0.00656390376389027, 0.00658015767112374, 0.00659638829529285, 0.00661267712712288, 0.00662898831069469, 0.00664529949426651, 0.00666164420545101, 0.0066779893822968, 0.00669436808675528, 0.00671077100560069, 0.00672718323767185, 0.00674363132566214, 0.00676010129973292, 0.006776571739465, 0.00679308781400323, 0.00680960388854146, 0.00682614231482148, 0.00684270355850458, 0.00685928761959076, 0.00687589449808002, 0.00689250137656927, 0.00690914271399379, 0.00692584039643407, 0.00694249290972948, 0.00695922505110502, 0.00697594601660967, 0.00699268933385611, 0.00700944475829601, 0.00702623324468732, 0.00704304501414299, 0.00705989077687263, 0.00707671418786049, 0.00709359440952539, 0.0071104858070612, 0.00712738884612918, 0.00714432541280985, 0.00716126291081309, 0.00717824511229992, 0.00719521660357714, 0.00721223279833794, 0.00722927274182439, 0.00724632292985916, 0.0072633964009583, 0.0072805043309927, 0.00729760061949492, 0.00731475371867418, 0.00733190728351474, 0.00734907248988748, 0.00736627075821161, 0.00738348159939051, 0.00740071386098862, 0.00741796940565109, 0.00743524776771665, 0.00745253777131438, 0.0074698505923152, 0.0074871969409287, 0.00750455539673567, 0.00752193666994572, 0.00753932865336537, 0.0075567327439785, 0.0075741927139461, 0.00759165408089757, 0.00760912522673607, 0.0076266429387033, 0.00764417182654142, 0.00766168953850865, 0.00767925241962075, 0.00769682647660375, 0.00771443545818329, 0.00773205468431115, 0.00774970883503556, 0.00776736298575997, 0.00778503995388746, 0.00780275138095021, 0.00782049633562565, 0.00783823058009148, 0.00785598624497652, 0.0078737884759903, 0.00789156835526228, 0.00790942646563053, 0.0079272510483861, 0.00794512219727039, 0.00796302687376738, 0.00798091944307089, 0.00799885764718056, 0.00801678560674191, 0.00803475826978683, 0.00805276539176702, 0.00807076040655375, 0.00808881316334009, 0.00810683146119118, 0.00812491867691278, 0.00814302731305361, 0.00816112477332354, 0.0081792576238513, 0.00819742400199175, 0.0082155792042613, 0.00823377911001444, 0.00825197994709015, 0.00827022548764944, 0.00828847195953131, 0.00830674078315496, 0.00832505524158478, 0.00834334641695023, 0.00836170557886362, 0.00838006567209959, 0.00839843694120646, 0.00841683056205511, 0.00843526981770992, 0.00845367554575205, 0.00847214926034212, 0.0084906117990613, 0.00850914232432842, 0.00852764956653118, 0.00854618102312088, 0.00856474507600069, 0.00858332123607397, 0.00860193092375994, 0.00862056389451027, 0.00863917451351881, 0.00865784101188183, 0.00867651961743832, 0.00869522150605917, 0.0087139680981636, 0.00873269233852625, 0.00875147338956594, 0.00877025350928307, 0.00878904573619366, 0.00880788452923298, 0.00882672145962715, 0.00884560495615005, 0.00886449962854385, 0.00888337194919586, 0.00890232436358929, 0.00892125256359577, 0.00894023850560188, 0.00895922444760799, 0.00897823367267847, 0.00899726431816816, 0.00901633035391569, 0.00903537310659885, 0.00905447266995907, 0.00907357223331928, 0.00909270625561476, 0.00911187380552292, 0.00913101900368929, 0.00915023218840361, 0.00916942302137613, 0.00918868184089661, 0.00920793041586876, 0.00922719947993755, 0.00924649275839329, 0.00926580931991339, 0.00928513612598181, 0.00930450949817896, 0.00932387076318264, 0.00934326648712158, 0.00936268456280231, 0.00938212592154741, 0.00940157845616341, 0.00942105334252119, 0.00944056268781424, 0.00946008320897818, 0.00947960466146469, 0.00949918199330568, 0.00951873697340488, 0.0095383720472455, 0.00955799501389265, 0.00957759562879801, 0.00959727540612221, 0.00961695611476898, 0.00963664706796408, 0.0096563845872879, 0.00967612117528915, 0.00969588104635477, 0.00971567444503307, 0.00973546877503395, 0.00975529663264751, 0.00977513659745455, 0.00979501008987427, 0.00981489568948746, 0.00983479153364897, 0.00985472276806831, 0.00987468659877777, 0.00989464018493891, 0.0099146394059062, 0.00993462651968002, 0.00995465926826, 0.00997471529990435, 0.0099947601556778, 0.0100148832425475, 0.0100349625572562, 0.010055098682642, 0.010075256228447, 0.0100954137742519, 0.0101156178861856, 0.0101358331739902, 0.0101560708135366, 0.0101763205602765, 0.0101965693756938, 0.0102168759331107, 0.0102371936663985, 0.0102575337514281, 0.0102778859436512, 0.0102982595562935, 0.0103186452761292, 0.0103390775620937, 0.0103594856336713, 0.0103799737989902, 0.0104004284366965, 0.0104209389537573, 0.010441449470818, 0.0104619609192014, 0.0104825412854552, 0.0105031318962574, 0.010523721575737, 0.0105443466454744, 0.0105649717152119, 0.0105856312438846, 0.0106063243001699, 0.0106270173564553, 0.0106477569788694, 0.010668471455574, 0.0106892324984074, 0.0107100289314985, 0.0107308132573962, 0.0107516553252935, 0.0107724955305457, 0.0107933590188622, 0.0108142457902431, 0.0108351325616241, 0.0108560658991337, 0.0108770309016109, 0.0108979865908623, 0.0109189879149199, 0.0109399752691388, 0.0109609998762608, 0.0109820459038019, 0.0110031142830849, 0.0110242050141096, 0.0110453087836504, 0.0110664339736104, 0.0110875945538282, 0.0111087542027235, 0.0111299585551023, 0.0111511638388038, 0.0111723924055696, 0.0111936433240771, 0.0112149063497782, 0.011236191727221, 0.0112575329840183, 0.0112788518890738, 0.0113002052530646, 0.0113215697929263, 0.0113429585471749, 0.0113643798977137, 0.011385802179575, 0.0114072803407907, 0.0114287240430713, 0.0114502375945449, 0.0114717613905668, 0.0114932861179113, 0.011514843441546, 0.0115364473313093, 0.0115580167621374, 0.0115796541795135, 0.0116012813523412, 0.0116229308769107, 0.0116446260362864, 0.0116663202643394, 0.0116880489513278, 0.0117097776383162, 0.0117315296083689, 0.0117533272132277, 0.0117751024663448, 0.0117969550192356, 0.0118187991902232, 0.0118406526744366, 0.0118625303730369, 0.0118844183161855, 0.0119063509628177, 0.0119283087551594, 0.0119502646848559, 0.0119722560048103, 0.0119942706078291, 0.0120162721723318, 0.0120383314788342, 0.0120603889226913, 0.0120824826881289, 0.012104575522244, 0.0121267149224877, 0.0121488645672798, 0.0121710272505879, 0.0121932215988636, 0.0122154522687197, 0.0122376587241888, 0.0122599117457867, 0.0122821871191263, 0.0123044615611434, 0.0123267956078053, 0.0123491156846285, 0.012371470220387, 0.0123938368633389, 0.0124162258580327, 0.0124386372044683, 0.0124610606580973, 0.0124835297465324, 0.0125060100108385, 0.0125284790992737, 0.0125510161742568, 0.0125735299661756, 0.0125961005687714, 0.0126186721026897, 0.0126412780955434, 0.012663884088397, 0.0126865357160568, 0.0127091752365232, 0.012731870636344, 0.012754556722939, 0.0127772865816951, 0.0128000061959028, 0.0128227593377233, 0.0128455581143498, 0.0128683466464281, 0.0128911789506674, 0.0129140224307775, 0.0129368677735329, 0.0129597578197718, 0.0129826599732041, 0.0130055826157331, 0.0130285304039717, 0.0130514875054359, 0.0130744809284806, 0.0130974845960736, 0.0131204882636666, 0.0131435487419367, 0.0131666092202067, 0.0131897050887346, 0.0132128233090043, 0.013235917314887, 0.0132590690627694, 0.0132822319865227, 0.0133054405450821, 0.0133286481723189, 0.0133518688380718, 0.0133751127868891, 0.0133983781561255, 0.0134216668084264, 0.0134449889883399, 0.0134683111682534, 0.0134916678071022, 0.013515024445951, 0.0135384146124125, 0.0135618522763252, 0.0135852647945285, 0.013608724810183, 0.0136322071775794, 0.0136556886136532, 0.0136791924014688, 0.013702753931284, 0.0137262931093574, 0.0137498769909143, 0.0137734618037939, 0.0137970801442862, 0.0138207096606493, 0.0138443624600768, 0.0138680497184396, 0.0138917360454798, 0.0139154698699713, 0.0139392111450434, 0.013962933793664, 0.0139867328107357, 0.0140105448663235, 0.0140343457460403, 0.0140582043677568, 0.0140820490196347, 0.0141059188172221, 0.0141298435628414, 0.0141537478193641, 0.0141776958480477, 0.0142016559839249, 0.0142256384715438, 0.0142496433109045, 0.0142736611887813, 0.0142977172508836, 0.0143217630684376, 0.0143458591774106, 0.0143699673935771, 0.0143940635025501, 0.0144182341173291, 0.0144423982128501, 0.0144665809348226, 0.0144907850772142, 0.0145150069147348, 0.0145392455160618, 0.0145635362714529, 0.0145878028124571, 0.0146121326833963, 0.0146364411339164, 0.0146608045324683, 0.0146851735189557, 0.0147095564752817, 0.0147339757531881, 0.0147584257647395, 0.014782851561904, 0.0148073462769389, 0.0148318139836192, 0.0148563431575894, 0.0148808714002371, 0.0149054229259491, 0.0149299977347255, 0.0149545781314373, 0.0149791967123747, 0.0150038357824087, 0.0150284776464105, 0.0150531539693475, 0.0150778433308005, 0.0151025718078017, 0.0151273217052221, 0.0151520511135459, 0.0151768531650305, 0.0152016496285796, 0.0152264693751931, 0.0152513002976775, 0.0152761582285166, 0.0153010291978717, 0.0153259513899684, 0.0153508493676782, 0.0153758069500327, 0.0154007514938712, 0.0154257463291287, 0.0154507486149669, 0.0154757611453533, 0.0155008006840944, 0.0155258886516094, 0.0155509458854795, 0.0155760738998652, 0.015601160004735, 0.0156263262033463, 0.0156514924019575, 0.0156766641885042, 0.0157018881291151, 0.0157270841300488, 0.0157523471862078, 0.0157776214182377, 0.0158028956502676, 0.0158282052725554, 0.015853526070714, 0.0158788841217756, 0.0159042496234179, 0.015929626300931, 0.0159550607204437, 0.015980489552021, 0.0160059351474047, 0.0160314030945301, 0.0160569045692682, 0.016082402318716, 0.0161079317331314, 0.0161334741860628, 0.0161590557545424, 0.016184639185667, 0.0162102710455656, 0.0162358991801739, 0.0162615310400724, 0.0162872336804867, 0.0163129288703203, 0.0163386296480894, 0.0163643788546324, 0.0163901131600142, 0.0164158996194601, 0.0164417047053576, 0.0164675079286098, 0.0164933577179909, 0.0165192000567913, 0.0165450908243656, 0.0165709964931011, 0.0165969077497721, 0.01662284322083, 0.0166488010436296, 0.0166747868061066, 0.0167007781565189, 0.0167267974466085, 0.0167528353631496, 0.0167789179831743, 0.0168049782514572, 0.0168310943990946, 0.0168572179973125, 0.0168833527714014, 0.0169095266610384, 0.0169357005506754, 0.0169619079679251, 0.0169881284236908, 0.0170143749564886, 0.0170406512916088, 0.0170669164508581, 0.0170932319015265, 0.0171195715665817, 0.0171459149569273, 0.0171722695231438, 0.0171986557543278, 0.0172250736504793, 0.0172515101730824, 0.0172779392451048, 0.0173044260591269, 0.0173308961093426, 0.017357399687171, 0.0173839498311281, 0.0174104757606983, 0.017437070608139, 0.017463643103838, 0.0174902770668268, 0.0175168961286545, 0.0175435468554497, 0.0175702217966318, 0.0175969246774912, 0.0176236405968666, 0.0176503770053387, 0.0176771264523268, 0.0177038963884115, 0.0177306961268187, 0.0177575070410967, 0.0177843477576971, 0.017811194062233, 0.0178380720317364, 0.0178649686276913, 0.0178918838500977, 0.0179188195616007, 0.0179457999765873, 0.0179727654904127, 0.0179997589439154, 0.0180267635732889, 0.0180538240820169, 0.0180808827280998, 0.0181079711765051, 0.0181350782513618, 0.0181622039526701, 0.0181893277913332, 0.0182165037840605, 0.0182436686009169, 0.0182708818465471, 0.0182980969548225, 0.0183253400027752, 0.0183526016771793, 0.0183798857033253, 0.018407192081213, 0.0184345338493586, 0.0184618663042784, 0.0184892304241657, 0.0185166336596012, 0.0185440070927143, 0.0185714568942785, 0.0185988824814558, 0.018626382574439, 0.0186538528650999, 0.0186813585460186, 0.0187088865786791, 0.0187364276498556, 0.0187640059739351, 0.0187916252762079, 0.0188216213136911, 0.0188539456576109, 0.0188862718641758, 0.0189186558127403, 0.0189510509371758, 0.0189834330230951, 0.0190158616751432, 0.0190483126789331, 0.0190807525068521, 0.0191132370382547, 0.0191457122564316, 0.0191782545298338, 0.0192107744514942, 0.0192433279007673, 0.0192759037017822, 0.0193084795027971, 0.0193411018699408, 0.0193737354129553, 0.0194063670933247, 0.0194390472024679, 0.019471725448966, 0.0195044167339802, 0.0195371396839619, 0.0195698868483305, 0.0196026470512152, 0.0196354147046804, 0.0196681972593069, 0.0197010356932878, 0.019733838737011, 0.0197667106986046, 0.0197996068745852, 0.019832456484437, 0.0198653731495142, 0.0198982805013657, 0.0199312437325716, 0.0199642200022936, 0.0199971944093704, 0.0200301799923182, 0.0200632233172655, 0.0200962442904711, 0.0201293099671602, 0.0201623868197203, 0.0201954860240221, 0.02022859826684, 0.0202617198228836, 0.0202948786318302, 0.0203280337154865, 0.0203612353652716, 0.0203944500535727, 0.0204276740550995, 0.0204609129577875, 0.0204941723495722, 0.0205274410545826, 0.0205607824027538, 0.020594073459506, 0.0206274259835482, 0.0206607766449451, 0.0206941366195679, 0.0207275319844484, 0.020760940387845, 0.0207943934947252, 0.0208278577774763, 0.0208612997084856, 0.0208947863429785, 0.020928306505084, 0.0209618285298347, 0.0209953729063272, 0.0210289172828197, 0.0210625063627958, 0.0210961066186428, 0.0211297180503607, 0.0211633648723364, 0.0211970116943121, 0.0212306920439005, 0.0212643817067146, 0.021298099309206, 0.021331824362278, 0.0213655829429626, 0.0213993433862925, 0.0214331280440092, 0.0214669220149517, 0.0215007606893778, 0.021534601226449, 0.021568451076746, 0.0216023493558168, 0.0216362569481134, 0.0216701533645391, 0.0217040851712227, 0.0217380505055189, 0.0217720381915569, 0.0218060240149498, 0.0218400247395039, 0.0218740701675415, 0.0219081025570631, 0.0219421721994877, 0.0219762604683638, 0.0220103729516268, 0.0220444854348898, 0.0220786239951849, 0.0221127811819315, 0.0221469607204199, 0.0221811644732952, 0.0222153924405575, 0.0222496315836906, 0.0222838800400496, 0.0223181433975697, 0.0223524384200573, 0.0223867669701576, 0.0224210843443871, 0.0224554371088743, 0.0224897991865873, 0.0225241761654615, 0.0225585829466581, 0.0225930046290159, 0.0226274486631155, 0.0226619131863117, 0.022696390748024, 0.0227308683097363, 0.0227653905749321, 0.0227999333292246, 0.0228345040231943, 0.0228690728545189, 0.0229036509990692, 0.0229382663965225, 0.0229728911072016, 0.0230075400322676, 0.0230422001332045, 0.0230768918991089, 0.0231115967035294, 0.0231463126838207, 0.023181039839983, 0.023215813562274, 0.0232505984604359, 0.0232853945344687, 0.0233202129602432, 0.0233550313860178, 0.0233898852020502, 0.0234247725456953, 0.0234596580266953, 0.0234945807605982, 0.0235294904559851, 0.0235644318163395, 0.0235994122922421, 0.0236343909054995, 0.0236693900078535, 0.0237044133245945, 0.0237394589930773, 0.0237745065242052, 0.0238095782697201, 0.0238446798175573, 0.0238798167556524, 0.0239149443805218, 0.0239500813186169, 0.0239852629601955, 0.0240204464644194, 0.024055652320385, 0.0240908805280924, 0.0241261404007673, 0.0241613946855068, 0.0241966675966978, 0.0242319665849209, 0.0242673102766275, 0.0243026409298182, 0.0243379920721054, 0.0243733804672956, 0.0244087800383568, 0.0244441647082567, 0.0244795884937048, 0.0245150588452816, 0.0245505478233099, 0.0245860256254673, 0.0246215276420116, 0.0246570520102978, 0.0246926005929708, 0.0247281696647406, 0.0247637517750263, 0.024799345061183, 0.0248349700123072, 0.0248705986887217, 0.0249062571674585, 0.0249419417232275, 0.0249776486307383, 0.025013355538249, 0.0250490829348564, 0.0250848345458508, 0.0251205991953611, 0.0251563861966133, 0.0251921955496073, 0.0252280253916979, 0.0252638701349497, 0.0252997223287821, 0.0253356005996466, 0.0253715254366398, 0.0254074241966009, 0.0254433695226908, 0.0254793241620064, 0.0255152955651283, 0.0255512855947018, 0.0255873035639524, 0.0256233345717192, 0.0256593972444534, 0.0256954561918974, 0.025731548666954, 0.0257676411420107, 0.0258037820458412, 0.0258399229496717, 0.0258760824799538, 0.0259122680872679, 0.0259484630078077, 0.0259846840053797, 0.0260209124535322, 0.0260571651160717, 0.0260934643447399, 0.0261297523975372, 0.0261660497635603, 0.0262023843824863, 0.0262387469410896, 0.0262751150876284, 0.0263114832341671, 0.0263479072600603, 0.0263843275606632, 0.0264207553118467, 0.0264572240412235, 0.0264937151223421, 0.0265302062034607, 0.0265667140483856, 0.0266032759100199, 0.0266398061066866, 0.0266763810068369, 0.0267129801213741, 0.0267496015876532, 0.0267862230539322, 0.0268228724598885, 0.0268595330417156, 0.0268962346017361, 0.0269329398870468, 0.0269696451723576, 0.0270063877105713, 0.0270431563258171, 0.0270799286663532, 0.0271167289465666, 0.0271535459905863, 0.0271903853863478, 0.0272272452712059, 0.0272641181945801, 0.0273009892553091, 0.0273379124701023, 0.0273748524487019, 0.0274117924273014, 0.0274487566202879, 0.0274857468903065, 0.0275227576494217, 0.0275597777217627, 0.0275968164205551, 0.0276338830590248, 0.02767095528543, 0.0277080498635769, 0.0277451779693365, 0.0277823023498058, 0.0278194546699524, 0.0278566312044859, 0.0278938338160515, 0.0279310308396816, 0.0279682651162148, 0.0280055049806833, 0.0280427858233452, 0.0280800554901361, 0.0281173568218946, 0.0281546711921692, 0.0281920358538628, 0.0282293856143951, 0.0282667595893145, 0.0283041503280401, 0.0283415708690882, 0.0283790118992329, 0.0284164678305387, 0.0284539274871349, 0.0284914188086987, 0.0285289399325848, 0.0285664591938257, 0.0286040119826794, 0.0286415833979845, 0.0286791548132896, 0.0287167560309172, 0.0287543870508671, 0.0287920236587524, 0.028829675167799, 0.0288673471659422, 0.028905063867569, 0.0289427638053894, 0.0289804916828871, 0.029018260538578, 0.0290560349822044, 0.029093811288476, 0.0291316173970699, 0.0291694402694702, 0.0292073059827089, 0.0292451623827219, 0.0292830429971218, 0.0293209347873926, 0.029358871281147, 0.0293968059122562, 0.0294347573071718, 0.0294727310538292, 0.0295107290148735, 0.0295487605035305, 0.0295867975801229, 0.0296248216181993, 0.0296629071235657, 0.0297009907662868, 0.0297391060739756, 0.02977723069489, 0.029815386980772, 0.0298535395413637, 0.0298917107284069, 0.0299299191683531, 0.029968136921525, 0.0300063695758581, 0.0300446376204491, 0.0300829131156206, 0.0301212072372437, 0.0301595162600279, 0.0301978513598442, 0.0302362143993378, 0.0302745886147022, 0.0303129497915506, 0.0303513649851084, 0.0303898043930531, 0.0304282363504171, 0.0304666981101036, 0.0305051989853382, 0.0305436868220568, 0.0305822044610977, 0.030620738863945, 0.0306592974811792, 0.0306978728622198, 0.0307364817708731, 0.0307750795036554, 0.0308137107640505, 0.0308523550629616, 0.0308910384774208, 0.03092972189188, 0.030968438833952, 0.0310071595013142, 0.0310458894819021, 0.0310846474021673, 0.0311234369874001, 0.0311622358858585, 0.031201058998704, 0.0312398839741945, 0.0312787517905235, 0.031317625194788, 0.0313565097749233, 0.0313954241573811, 0.0314343683421612, 0.0314733199775219, 0.0315122567117214, 0.0315512642264366, 0.0315902829170227, 0.0316292978823185, 0.0316683426499367, 0.0317074097692966, 0.0317464806139469, 0.0317855812609196, 0.0318246893584728, 0.0318638347089291, 0.0319029949605465, 0.0319421663880348, 0.031981348991394, 0.032020565122366, 0.0320597961544991, 0.0320990458130836, 0.0321383140981197, 0.0321776121854782, 0.0322169102728367, 0.032256230711937, 0.032295573502779, 0.0323349423706532, 0.0323743149638176, 0.0324137099087238, 0.032453116029501, 0.0324925668537617, 0.0325320139527321, 0.0325714834034443, 0.0326109975576401, 0.0326505079865456, 0.0326900109648705, 0.0327295623719692, 0.0327691473066807, 0.0328087285161018, 0.0328483432531357, 0.0328879468142986, 0.0329276062548161, 0.032967247068882, 0.0330069325864315, 0.0330466292798519, 0.0330863483250141, 0.0331260897219181, 0.0331658311188221, 0.0332055948674679, 0.0332453995943069, 0.0332852117717266, 0.0333250425755978, 0.0333648882806301, 0.0334047637879848, 0.0334446392953396, 0.0334845334291458, 0.0335244499146938, 0.0335644148290157, 0.0336043685674667, 0.0336443409323692, 0.0336843244731426, 0.0337243489921093, 0.0337643846869469, 0.0338044427335262, 0.0338445268571377, 0.03388462215662, 0.0339247025549412, 0.0339648276567459, 0.0340049900114536, 0.0340451672673225, 0.0340853445231915, 0.0341255366802216, 0.0341657586395741, 0.034205999225378, 0.0342462547123432, 0.0342865362763405, 0.0343268364667892, 0.0343671552836895, 0.0344074741005898, 0.0344478227198124, 0.034488208591938, 0.0345286093652248, 0.0345690175890923, 0.0346094481647015, 0.0346498712897301, 0.0346903502941132, 0.0347308330237865, 0.0347713381052017, 0.0348118580877781, 0.0348523892462254, 0.0348929427564144, 0.0349335223436356, 0.0349741205573082, 0.0350147411227226, 0.0350553654134274, 0.0350960306823254, 0.0351366885006428, 0.0351773649454117, 0.0352180749177933, 0.0352588258683681, 0.0352995693683624, 0.0353403277695179, 0.0353811085224152, 0.0354219116270542, 0.0354627259075642, 0.0355035625398159, 0.0355444140732288, 0.0355853065848351, 0.035626195371151, 0.0356670953333378, 0.0357080288231373, 0.0357489958405495, 0.035789966583252, 0.0358309559524059, 0.035871971398592, 0.0359129719436169, 0.0359540358185768, 0.0359950847923756, 0.0360361747443676, 0.0360772833228111, 0.0361183993518353, 0.03615952283144, 0.036200687289238, 0.0362418703734875, 0.0362830571830273, 0.0363242626190186, 0.0363655164837837, 0.0364067405462265, 0.0364480093121529, 0.0364892967045307, 0.0365306288003922, 0.036571953445673, 0.036613292992115, 0.0366546474397182, 0.0366960391402245, 0.0367374308407307, 0.0367788448929787, 0.0368202887475491, 0.0368617475032806, 0.0369032099843025, 0.0369447097182274, 0.0369862280786037, 0.0370277464389801, 0.03706930950284, 0.0371108762919903, 0.0371524542570114, 0.0371940620243549, 0.0372356809675694, 0.0372773259878159, 0.0373189970850945, 0.0373606830835342, 0.0374023728072643, 0.0374440811574459, 0.0374858267605305, 0.037527572363615, 0.0375693514943123, 0.0376111380755901, 0.0376529730856419, 0.0376947857439518, 0.0377366282045841, 0.0377785041928291, 0.0378204025328159, 0.0378623083233833, 0.0379042290151119, 0.0379461608827114, 0.0379881262779236, 0.0380301028490067, 0.0380721017718315, 0.0381141267716885, 0.038156159222126, 0.0381982065737247, 0.0382402800023556, 0.0382823720574379, 0.0383244901895523, 0.0383666194975376, 0.0384087711572647, 0.0384509302675724, 0.0384931154549122, 0.0385353304445744, 0.0385775491595268, 0.0386197976768017, 0.0386620573699474, 0.0387043245136738, 0.0387466140091419, 0.0387889519333839, 0.0388312786817551, 0.0388736203312874, 0.0389160104095936, 0.0389583818614483, 0.0390007942914963, 0.0390432290732861, 0.0390856973826885, 0.039128165692091, 0.0391706302762032, 0.0392131172120571, 0.0392556637525558, 0.0392981991171837, 0.0393407642841339, 0.0393833369016647, 0.0394259393215179, 0.0394685454666615, 0.0395111814141273, 0.0395538322627544, 0.0395965166389942, 0.0396392047405243, 0.0396819114685059, 0.0397246479988098, 0.0397673882544041, 0.0398101471364498, 0.0398529469966888, 0.0398957543075085, 0.039938572794199, 0.0399814061820507, 0.0400242581963539, 0.0400671437382698, 0.0401100441813469, 0.0401529483497143, 0.0401958785951138, 0.0402388423681259, 0.0402818098664284, 0.0403247885406017, 0.0403677970170975, 0.0404108501970768, 0.0404538847506046, 0.0404969491064548, 0.0405400060117245, 0.0405831299722195, 0.0406262464821339, 0.0406693965196609, 0.040712546557188, 0.0407557263970375, 0.0407989211380482, 0.04084213078022, 0.0408853553235531, 0.0409286171197891, 0.0409718975424767, 0.0410151816904545, 0.0410584770143032, 0.0411018170416355, 0.0411451607942581, 0.0411885306239128, 0.041231919080019, 0.0412753224372864, 0.0413187295198441, 0.0413621626794338, 0.041405625641346, 0.0414491072297096, 0.0414925925433636, 0.0415361076593399, 0.0415796414017677, 0.0416231974959373, 0.0416667573153973, 0.041710339486599, 0.0417539738118649, 0.0417975969612598, 0.0418412275612354, 0.0418848805129528, 0.0419285856187344, 0.0419722832739353, 0.0420159958302975, 0.0420597419142723, 0.0421035028994083, 0.0421472638845444, 0.0421910472214222, 0.0422348789870739, 0.0422786995768547, 0.0423225499689579, 0.0423664301633835, 0.0424103178083897, 0.0424542129039764, 0.0424981489777565, 0.0425420887768269, 0.0425860583782196, 0.0426300354301929, 0.0426740348339081, 0.0427180491387844, 0.0427620969712734, 0.0428061410784721, 0.0428502224385738, 0.0428943075239658, 0.0429384335875511, 0.0429825447499752, 0.0430267006158829, 0.0430708713829517, 0.0431150794029236, 0.0431592799723148, 0.0432034805417061, 0.0432477183640003, 0.0432920046150684, 0.0433362871408463, 0.0433805882930756, 0.0434249080717564, 0.0434692315757275, 0.0435135923326015, 0.0435579605400562, 0.0436023660004139, 0.0436467565596104, 0.043691199272871, 0.0437356419861317, 0.0437801033258438, 0.0438245944678783, 0.0438691079616547, 0.0439136289060116, 0.0439581759274006, 0.0440027229487896, 0.0440473072230816, 0.0440919101238251, 0.0441365316510201, 0.0441811643540859, 0.0442258268594742, 0.044270496815443, 0.044315192848444, 0.0443599037826061, 0.0444046147167683, 0.0444493778049946, 0.0444941632449627, 0.0445389449596405, 0.0445837266743183, 0.0446285530924797, 0.0446734093129635, 0.0447182655334473, 0.0447631403803825, 0.0448080413043499, 0.0448529608547688, 0.0448978878557682, 0.0449428409337997, 0.0449878200888634, 0.0450328178703785, 0.0450778119266033, 0.0451228320598602, 0.0451678968966007, 0.0452129617333412, 0.0452580526471138, 0.0453031584620476, 0.0453482903540134, 0.0453934036195278, 0.0454385727643967, 0.0454837419092655, 0.0455289445817471, 0.0455741696059704, 0.0456193909049034, 0.0456646457314491, 0.0457099303603172, 0.0457552149891853, 0.0458005182445049, 0.0458458624780178, 0.0458912067115307, 0.0459365621209145, 0.0459819361567497, 0.046027347445488, 0.0460727736353874, 0.046118225902319, 0.0461636818945408, 0.0462091565132141, 0.046254638582468, 0.0463001653552055, 0.0463456884026527, 0.0463912524282932, 0.0464368164539337, 0.0464824140071869, 0.0465280152857304, 0.0465736500918865, 0.0466192848980427, 0.046664971858263, 0.0467106513679028, 0.046756349503994, 0.0468020662665367, 0.0468478091061115, 0.0468935705721378, 0.0469393394887447, 0.0469851456582546, 0.0470309518277645, 0.0470767952501774, 0.0471226312220097, 0.0471685044467449, 0.0472143925726414, 0.0472603067755699, 0.0473062433302402, 0.0473521687090397, 0.0473981313407421, 0.0474441200494766, 0.0474901273846626, 0.0475361607968807, 0.0475821904838085, 0.0476282499730587, 0.0476743169128895, 0.0477204173803329, 0.0477665178477764, 0.0478126630187035, 0.0478588081896305, 0.0479049757122993, 0.0479511618614197, 0.0479973778128624, 0.048043604940176, 0.0480898581445217, 0.0481361262500286, 0.0481823906302452, 0.0482286885380745, 0.0482750125229359, 0.048321358859539, 0.0483677200973034, 0.0484140887856483, 0.0484604686498642, 0.0485068969428539, 0.048553328961134, 0.0485997758805752, 0.0486462451517582, 0.0486927442252636, 0.0487392283976078, 0.0487857609987259, 0.0488323010504246, 0.0488788895308971, 0.0489254668354988, 0.0489720515906811, 0.0490186847746372, 0.0490653067827225, 0.049111969769001, 0.0491586364805698, 0.0492053478956223, 0.0492520444095135, 0.049298781901598, 0.0493455231189728, 0.0493922978639603, 0.0494390837848186, 0.0494858883321285, 0.0495327189564705, 0.0495795682072639, 0.0496264137327671, 0.0496732853353024, 0.0497202053666115, 0.0497671253979206, 0.0498140603303909, 0.0498610213398933, 0.0499079786241055, 0.0499549880623817, 0.0500019863247871, 0.0500490181148052, 0.0500960722565651, 0.0501431487500668, 0.0501902177929878, 0.0502373166382313, 0.0502844452857971, 0.0503316074609756, 0.0503787584602833, 0.0504259467124939, 0.0504731200635433, 0.0505203530192375, 0.0505675934255123, 0.0506148412823677, 0.0506621301174164, 0.0507094115018845, 0.0507567152380943, 0.0508040562272072, 0.05085139721632, 0.0508987680077553, 0.0509461499750614, 0.0509935617446899, 0.0510409772396088, 0.0510884188115597, 0.0511358752846718, 0.0511833652853966, 0.0512308701872826, 0.0512783788144588, 0.0513259209692478, 0.0513734631240368, 0.051421046257019, 0.0514686293900013, 0.0515162386000156, 0.0515638738870621, 0.0516115166246891, 0.0516591966152191, 0.0517068579792976, 0.0517545863986015, 0.0518023148179054, 0.0518500432372093, 0.0518977977335453, 0.0519455820322037, 0.0519933737814426, 0.0520411916077137, 0.052089024335146, 0.0521368682384491, 0.0521847419440746, 0.0522326566278934, 0.0522805489599705, 0.0523284822702408, 0.0523764304816723, 0.0524243973195553, 0.0524723827838898, 0.0525203831493855, 0.0525683984160423, 0.052616436034441, 0.052664503455162, 0.0527125932276249, 0.0527606680989265, 0.0528087988495827, 0.0528569258749485, 0.052905086427927, 0.0529532544314861, 0.053001444786787, 0.0530496574938297, 0.0530978888273239, 0.0531461387872696, 0.053194385021925, 0.0532426759600639, 0.0532909855246544, 0.0533393062651157, 0.0533876419067383, 0.053435992449522, 0.0534843802452087, 0.0535327754914761, 0.0535811819136143, 0.0536296106874943, 0.0536780580878258, 0.0537265539169312, 0.0537750236690044, 0.0538235306739807, 0.0538720637559891, 0.0539206191897392, 0.0539691857993603, 0.0540177635848522, 0.0540663488209248, 0.0541149862110615, 0.0541636310517788, 0.0542122721672058, 0.0542609542608261, 0.0543096400797367, 0.0543583743274212, 0.0544070936739445, 0.0544558465480804, 0.0545046105980873, 0.0545534156262875, 0.0546022169291973, 0.0546510294079781, 0.0546998754143715, 0.0547487549483776, 0.0547976270318031, 0.0548465363681316, 0.0548954494297504, 0.0549443811178207, 0.0549933463335037, 0.0550423264503479, 0.0550913140177727, 0.0551403202116489, 0.0551893599331379, 0.0552384257316589, 0.0552874803543091, 0.0553365610539913, 0.0553856864571571, 0.0554348081350327, 0.0554839484393597, 0.0555331148207188, 0.0555822849273682, 0.0556314922869205, 0.0556807182729244, 0.0557299442589283, 0.0557792037725449, 0.0558284819126129, 0.0558777824044228, 0.0559270866215229, 0.0559764131903648, 0.0560257583856583, 0.0560751371085644, 0.0561245195567608, 0.056173924356699, 0.0562233477830887, 0.0562727935612202, 0.0563222542405128, 0.0563717409968376, 0.0564212501049042, 0.0564707554876804, 0.0565203092992306, 0.0565698519349098, 0.0566194243729115, 0.0566690191626549, 0.0567186325788498, 0.0567682571709156, 0.0568179152905941, 0.0568675845861435, 0.0569172687828541, 0.0569669716060162, 0.0570167079567909, 0.0570664294064045, 0.0571161955595016, 0.0571659803390503, 0.0572157725691795, 0.0572655871510506, 0.057315431535244, 0.0573652870953083, 0.0574151612818241, 0.0574650540947914, 0.0575149692595005, 0.0575648918747902, 0.0576148480176926, 0.0576648265123367, 0.0577147863805294, 0.0577648021280766, 0.0578148253262043, 0.0578648820519447, 0.0579149350523949, 0.0579650029540062, 0.0580150969326496, 0.0580652318894863, 0.0581153556704521, 0.0581655129790306, 0.0582156851887703, 0.0582658760249615, 0.0583160780370235, 0.0583663173019886, 0.0584165677428246, 0.058466836810112, 0.0585171170532703, 0.0585674196481705, 0.0586177371442318, 0.0586680732667446, 0.0587184429168701, 0.0587688162922859, 0.0588192194700241, 0.0588696449995041, 0.0589200668036938, 0.0589705370366573, 0.0590209998190403, 0.0590714812278748, 0.0591219887137413, 0.0591725297272205, 0.0592230670154095, 0.0592736341059208, 0.0593242235481739, 0.0593748241662979, 0.059425450861454, 0.059476088732481, 0.0595267452299595, 0.0595774203538895, 0.0596281327307224, 0.0596788413822651, 0.0597295686602592, 0.0597803257405758, 0.0598310902714729, 0.0598818883299828, 0.0599327012896538, 0.0599835216999054, 0.0600343868136406, 0.0600852444767952, 0.0601361282169819, 0.0601870194077492, 0.0602379404008389, 0.0602889023721218, 0.0603398494422436, 0.0603908263146877, 0.0604418180882931, 0.0604949556291103, 0.0605501122772694, 0.0606052577495575, 0.0606604255735874, 0.0607155822217464, 0.0607707388699055, 0.0608258731663227, 0.060881033539772, 0.0609362050890923, 0.0609913319349289, 0.0610465034842491, 0.0611016526818275, 0.0611567944288254, 0.0612119510769844, 0.0612670965492725, 0.0613222382962704, 0.0613773874938488, 0.0614325366914272, 0.0614876821637154, 0.0615428239107132, 0.0615979842841625, 0.0616531111299992, 0.0617082677781582, 0.0617634057998657, 0.0618185512721539, 0.0618736855685711, 0.0619288347661495, 0.0619839690625668, 0.0620391108095646, 0.0620942525565624, 0.0621493794023991, 0.0622045360505581, 0.0622596628963947, 0.062314797192812, 0.0623699352145195, 0.062425073236227, 0.0624802000820637, 0.0625353381037712, 0.0625904724001884, 0.0626455992460251, 0.0627007335424423, 0.0627558678388596, 0.0628110095858574, 0.062866136431694, 0.0629212632775307, 0.0629763901233673, 0.0630315095186234, 0.06308663636446, 0.0631417781114578, 0.0631968900561333, 0.0632520318031311, 0.0633071437478065, 0.0633622705936432, 0.0634173974394798, 0.0634725168347359, 0.0635276287794113, 0.0635827630758286, 0.0636378824710846, 0.06369299441576, 0.0637481138110161, 0.0638032406568527, 0.0638583526015282, 0.0639134794473648, 0.0639685988426208, 0.0640237107872963, 0.0640788227319717, 0.0641339346766472, 0.0641890466213226, 0.0642441585659981, 0.0642992705106735, 0.0643543899059296, 0.0644094944000244, 0.0644646137952805, 0.0645197033882141, 0.0645748227834702, 0.0646299421787262, 0.0646850392222404, 0.0647401586174965, 0.0647952705621719, 0.0648503676056862, 0.0649054795503616, 0.0649605765938759, 0.0650156810879707, 0.065070778131485, 0.065125897526741, 0.0651809871196747, 0.0652360916137695, 0.0652911961078644, 0.0653463006019592, 0.0654013976454735, 0.0654564946889877, 0.0655115842819214, 0.0655666887760162, 0.0656217858195305, 0.0656768903136253, 0.065731979906559, 0.0657870769500732, 0.0658421665430069, 0.0658972635865211, 0.0659523606300354, 0.0660074576735497, 0.0660625398159027, 0.066117636859417, 0.0661727264523506, 0.0662278011441231, 0.0662829130887985, 0.0663379952311516, 0.0663930773735046, 0.0664481669664383, 0.0665032640099525, 0.0665583461523056, 0.0666134208440781, 0.0666685104370117, 0.0667236000299454, 0.0667786747217178, 0.0668337568640709, 0.066888839006424, 0.0669439285993576, 0.0669990032911301, 0.0670540779829025, 0.0671091675758362, 0.0671642497181892, 0.0672193169593811, 0.0672743991017342, 0.0673294812440872, 0.0673845559358597, 0.0674396380782127, 0.0674947127699852, 0.0675497800111771, 0.0676048472523689, 0.067659929394722, 0.0677149891853333, 0.0677700713276863, 0.0678251460194588, 0.0678802132606506, 0.0679352805018425, 0.067990355193615, 0.0680454075336456, 0.0681004822254181, 0.06815554946661, 0.0682106167078018, 0.0682656764984131, 0.0683207511901855, 0.0683758184313774, 0.0684308707714081, 0.0684859380125999, 0.0685410127043724, 0.0685960650444031, 0.0686511248350143, 0.0687061995267868, 0.0687612444162369, 0.0688163116574287, 0.06887137144804, 0.0689264237880707, 0.0689814686775208, 0.0690365433692932, 0.0690915808081627, 0.069146640598774, 0.0692016929388046, 0.0692567527294159, 0.0693118125200272, 0.0693668574094772, 0.0694219022989273, 0.069476954638958, 0.0695320144295692, 0.0695870593190193, 0.0696421191096306, 0.0696971639990807, 0.0697522014379501, 0.0698072612285614, 0.0698622986674309, 0.0699173510074615, 0.0699723958969116, 0.0700274407863617, 0.0700824782252312, 0.0701375305652618, 0.0701925829052925, 0.0702476128935814, 0.0703026503324509, 0.0703576952219009, 0.0704127326607704, 0.0704677700996399, 0.07052281498909, 0.0705778449773788, 0.0706328898668289, 0.0706879273056984, 0.0707429647445679, 0.0707979947328568, 0.0708530321717262, 0.0709080621600151, 0.0709631070494652, 0.0710181295871735, 0.0710731670260429, 0.0711281895637512, 0.0711832344532013, 0.0712382569909096, 0.0712932944297791, 0.0713483169674873, 0.0714033469557762, 0.0714583694934845, 0.071513406932354, 0.0715684369206429, 0.0716234520077705, 0.07167848944664, 0.0717335045337677, 0.071788527071476, 0.0718435496091843, 0.0718985795974731, 0.0719535872340202, 0.0720086172223091, 0.0720636397600174, 0.0721186548471451, 0.0721736699342728, 0.072228692471981, 0.0722837075591087, 0.072338730096817, 0.0723937451839447, 0.072448767721653, 0.0725037828087807, 0.0725587904453278, 0.0726138055324554, 0.0726688206195831, 0.0727238357067108, 0.0727788433432579, 0.072833850979805, 0.0728888735175133, 0.0729438737034798, 0.0729988887906075, 0.0730539038777351, 0.073108896613121, 0.0731639042496681, 0.0732189193367958, 0.0732739195227623, 0.0733289271593094, 0.0733839347958565, 0.073438934981823, 0.0734939426183701, 0.0735489502549171, 0.073603942990303, 0.0736589506268501, 0.073713943362236, 0.0737689435482025, 0.073823943734169, 0.0738789439201355, 0.073933944106102, 0.0739889368414879, 0.074043944478035, 0.0740989372134209, 0.0741539299488068, 0.0742089301347733, 0.0742639303207397, 0.0743189081549644, 0.0743739157915115, 0.0744289085268974, 0.0744838863611221, 0.0745388865470886, 0.0745938718318939, 0.0746488645672798, 0.0747038498520851, 0.074758842587471, 0.0748138278722763, 0.0748688131570816, 0.0749237984418869, 0.0749787837266922, 0.0750337690114975, 0.0750887617468834, 0.0751437395811081, 0.0751987248659134, 0.0752537101507187, 0.0753086879849434, 0.0753636732697487, 0.075418658554554, 0.0754736214876175, 0.0755286067724228, 0.0755835920572281, 0.0756385698914528, 0.0756935402750969, 0.0757485255599022, 0.0758034884929657, 0.075858473777771, 0.0759134516119957, 0.0759684145450592, 0.0760233923792839, 0.076078362762928, 0.0761333331465721, 0.0761883109807968, 0.0762432888150215, 0.076298251748085, 0.0763532221317291, 0.0764081850647926, 0.0764631554484367, 0.0765181183815002, 0.0765730962157249, 0.0766280516982079, 0.0766830295324326, 0.0767379850149155, 0.0767929628491402, 0.0768479183316231, 0.0769028812646866, 0.0769578441977501, 0.0770128071308136, 0.0770677626132965, 0.07712272554636, 0.0771776735782623, 0.0772326365113258, 0.0772876143455505, 0.0773425474762917, 0.0773975178599358, 0.0774524807929993, 0.0775074288249016, 0.0775623843073845, 0.0776173397898674, 0.0776722878217697, 0.0777272433042526, 0.0777821987867355, 0.0778371468186378, 0.0778921023011208, 0.0779470577836037, 0.0780019909143448, 0.0780569463968277, 0.0781119018793106, 0.0781668424606323, 0.0782217904925346, 0.0782767459750175, 0.0783316791057587, 0.0783866345882416, 0.0784415677189827, 0.078496515750885, 0.0785514563322067, 0.078606404364109, 0.0786613449454308, 0.0787162855267525, 0.0787712261080742, 0.0788261666893959, 0.0788811072707176, 0.0789360478520393, 0.0789909809827805, 0.0790459141135216, 0.0791008546948433, 0.0791557878255844, 0.0792107284069061, 0.0792656689882278, 0.0793205946683884, 0.0793755277991295, 0.0794304683804512, 0.0794853940606117, 0.0795403197407722, 0.079595260322094, 0.0796501934528351, 0.079705111682415, 0.0797600522637367, 0.0798149779438972, 0.0798698961734772, 0.0799248218536377, 0.0799797624349594, 0.0800346732139587, 0.0800896137952805, 0.080144539475441, 0.0801994502544403, 0.0802543759346008, 0.0803092941641808, 0.0803642198443413, 0.0804191380739212, 0.0804740637540817, 0.0805289819836617, 0.0805839076638222, 0.0806388184428215, 0.0806937366724014, 0.0807486549019814, 0.0808035731315613, 0.08085847645998, 0.0809134021401405, 0.0809683203697205, 0.0810232311487198, 0.0810781419277191, 0.081133060157299, 0.0811879634857178, 0.0812428742647171, 0.0812977850437164, 0.0813526958227158, 0.0814076066017151, 0.0814625173807144, 0.0815174132585526, 0.0815723314881325, 0.0816272348165512, 0.0816821381449699, 0.0817370489239693, 0.0817919597029686, 0.0818468555808067, 0.0819017589092255, 0.0819566622376442, 0.0820115581154823, 0.0820664688944817, 0.0821213647723198, 0.0821762606501579, 0.0822311639785767, 0.0822860673069954, 0.0823409557342529, 0.0823958590626717, 0.0824507549405098, 0.0825056508183479, 0.0825605466961861, 0.0826154425740242, 0.0826703384518623, 0.0827252268791199, 0.082780122756958, 0.0828350186347961, 0.0828899070620537, 0.0829448029398918, 0.0829996988177299, 0.0830545797944069, 0.083109475672245, 0.083164356648922, 0.0832192376255989, 0.083274133503437, 0.0833290219306946, 0.0833838954567909, 0.0834387913346291, 0.083493672311306, 0.0835485532879829, 0.0836034417152405, 0.083658330142498, 0.0837132036685944, 0.0837680771946907, 0.0838229656219482, 0.0838778391480446, 0.0839327201247215, 0.0839876011013985, 0.0840424746274948, 0.0840973556041718, 0.0841522291302681, 0.0842070952057838, 0.0842619836330414, 0.0843168646097183, 0.0843717232346535, 0.0844265967607498, 0.0844814851880074, 0.0845363438129425, 0.0845912247896194, 0.0846460908651352, 0.0847009569406509, 0.0847558230161667, 0.0848107039928436, 0.0848655551671982, 0.0849204286932945, 0.0849752947688103, 0.085030160844326, 0.0850850269198418, 0.0851398929953575, 0.0851947590708733, 0.085249625146389, 0.0853044837713242, 0.0853593498468399, 0.0854142084717751, 0.0854690670967102, 0.0855239257216454, 0.0855787843465805, 0.0856336504220963, 0.085688516497612, 0.085743360221386, 0.0857982188463211, 0.0858530923724174, 0.0859079286456108, 0.0859627947211266, 0.0860176384449005, 0.0860724970698357, 0.0861273482441902, 0.0861822068691254, 0.0862370431423187, 0.0862919017672539, 0.0863467529416084, 0.0864015966653824, 0.0864564478397369, 0.0865112990140915, 0.086566150188446, 0.08662099391222, 0.086675837635994, 0.0867306813597679, 0.0867855325341225, 0.0868403762578964, 0.0868952199816704, 0.0869500711560249, 0.0870049148797989, 0.0870597362518311, 0.0871145874261856, 0.0871694311499596, 0.0872242674231529, 0.0872791036963463, 0.0873339474201202, 0.087388776242733, 0.087443619966507, 0.0874984562397003, 0.0875532925128937, 0.087608128786087, 0.0876629650592804, 0.0877177864313126, 0.0877726376056671, 0.0878274589776993, 0.087882287800312, 0.0879371240735054, 0.0879919603466988, 0.0880467817187309, 0.0881016105413437, 0.0881564319133759, 0.0882112681865692, 0.0882660895586014, 0.0883209332823753, 0.0883757546544075, 0.0884305760264397, 0.088485412299633, 0.0885402336716652, 0.0885950475931168, 0.0886498689651489, 0.0887046903371811, 0.0887595191597939, 0.0888143330812454, 0.088869147002697, 0.0889239758253098, 0.0889787897467613, 0.0890336260199547, 0.0890884324908257, 0.0891432464122772, 0.0891980677843094, 0.089252881705761, 0.0893076956272125, 0.0893625095486641, 0.0894173160195351, 0.0894721299409866, 0.0895269364118576, 0.0895817652344704, 0.0896365717053413, 0.0896913781762123, 0.0897461846470833, 0.0898009985685349, 0.0898558050394058, 0.0899106115102768, 0.0899654254317284, 0.0900202319025993, 0.0900750383734703, 0.0901298299431801, 0.0901846438646317, 0.0902394354343414, 0.0902942568063736, 0.0903490409255028, 0.0904038473963737, 0.0904586538672447, 0.0905134603381157, 0.0905682444572449, 0.0906230509281158, 0.0906778499484062, 0.090732641518116, 0.090787447988987, 0.0908422470092773, 0.0908970385789871, 0.0909518301486969, 0.0910066366195679, 0.0910614207386971, 0.0911162123084068, 0.0911710113286972, 0.091225802898407, 0.0912805795669556, 0.0913353860378265, 0.0913901701569557, 0.0914449617266655, 0.0914997458457947, 0.0915545523166656, 0.0916093289852142, 0.091664120554924, 0.0917189046740532, 0.0917736887931824, 0.091828465461731, 0.0918832644820213, 0.0919380262494087, 0.0919928178191185, 0.0920476019382477, 0.0921023860573769, 0.0921571552753448, 0.0922119468450546, 0.0922667235136032, 0.0923215076327324, 0.092376284301281, 0.092431053519249, 0.0924858227372169, 0.0925406143069267, 0.0925953760743141, 0.0926501601934433, 0.0927049517631531, 0.0927597135305405, 0.0928144827485085, 0.0928692519664764, 0.0929240211844444, 0.092978797852993, 0.0930335745215416, 0.093088336288929, 0.093143105506897, 0.0931978821754456, 0.0932526439428329, 0.0933074131608009, 0.0933621749281883, 0.0934169441461563, 0.0934717059135437, 0.0935264751315117, 0.0935812368988991, 0.0936360061168671, 0.0936907678842545, 0.0937455222010612, 0.0938002839684486, 0.0938550382852554, 0.093909814953804, 0.0939645543694496, 0.0940193235874176, 0.0940740928053856, 0.0941288322210312, 0.0941836014389992, 0.0942383483052254, 0.0942931100726128, 0.094347856938839, 0.0944026261568069, 0.0944573655724525, 0.0945121273398399, 0.0945668667554855, 0.0946216285228729, 0.0946763679385185, 0.0947311297059059, 0.0947858691215515, 0.0948406308889389, 0.0948953628540039, 0.0949501171708107, 0.0950048565864563, 0.0950596109032631, 0.0951143428683281, 0.0951691046357155, 0.0952238440513611, 0.0952785834670067, 0.0953333303332329, 0.0953880846500397, 0.0954428091645241, 0.0954975560307503, 0.0955523028969765, 0.0956070274114609, 0.0956617742776871, 0.0957165136933327, 0.0957712531089783, 0.0958259850740433, 0.0958807095885277, 0.0959354490041733, 0.0959901809692383, 0.0960449278354645, 0.0960996523499489, 0.0961543917655945, 0.0962091237306595, 0.0962638556957245, 0.0963185951113701, 0.0963733196258545, 0.0964280515909195, 0.0964827761054039, 0.0965375080704689, 0.0965922474861145, 0.0966469645500183, 0.0967016890645027, 0.0967564210295677, 0.0968111380934715, 0.0968658551573753, 0.0969206020236015, 0.0969753041863441, 0.0970300287008286, 0.097084753215313, 0.0971394702792168, 0.0971941947937012, 0.0972489193081856, 0.0973036363720894, 0.0973583608865738, 0.097413070499897, 0.0974677950143814, 0.097522497177124, 0.0975772216916084, 0.0976319313049316, 0.097686655819416, 0.0977413579821587, 0.0977960899472237, 0.0978507921099663, 0.0979055091738701, 0.0979602113366127, 0.0980149284005165, 0.0980696305632591, 0.0981243401765823, 0.098179042339325, 0.0982337594032288, 0.098288469016552, 0.0983431786298752, 0.0983978882431984, 0.098452590405941, 0.0985073000192642, 0.0985620021820068, 0.0986166968941689, 0.0986714065074921, 0.0987261012196541, 0.0987807959318161, 0.0988355129957199, 0.0988902077078819, 0.0989449024200439, 0.0989996045827866, 0.0990543141961098, 0.0991090014576912, 0.0991637036204338, 0.0992183983325958, 0.0992730930447578, 0.0993277803063393, 0.0993824824690819, 0.0994371846318245, 0.0994918644428253, 0.0995465591549873, 0.0996012464165688, 0.0996559411287308, 0.0997106358408928, 0.0997653305530548, 0.0998200103640556, 0.0998747050762177, 0.0999293997883797, 0.0999840870499611, 0.100038759410381, 0.100093446671963, 0.100148133933544, 0.100202828645706, 0.100257501006126, 0.100312180817127, 0.100366875529289, 0.100421547889709, 0.100476235151291, 0.100530922412872, 0.100585594773293, 0.100640267133713, 0.100694954395294, 0.100749634206295, 0.100804306566715, 0.100858993828297, 0.100913658738136, 0.100968331098557, 0.101023010909557, 0.101077683269978, 0.101132340729237, 0.101187027990818, 0.101241707801819, 0.101296365261078, 0.101351037621498, 0.101405709981918, 0.101460382342339, 0.101515054702759, 0.101569719612598, 0.101624384522438, 0.101679056882858, 0.101733721792698, 0.101788386702538, 0.101843051612377, 0.101897716522217, 0.101952381432056, 0.102007046341896, 0.102061711251736, 0.102116376161575, 0.102171018719673, 0.102225691080093, 0.102280355989933, 0.102334998548031, 0.10238966345787, 0.10244432836771, 0.102498970925808, 0.102553643286228, 0.102608293294907, 0.102662943303585, 0.102717593312263, 0.102772250771523, 0.102826908230782, 0.10288155823946, 0.102936215698719, 0.102990865707397, 0.103045508265495, 0.103100173175335, 0.103154815733433, 0.103209465742111, 0.103264108300209, 0.103318758308887, 0.103373400866985, 0.103428043425083, 0.103482693433762, 0.103537335991859, 0.103591978549957, 0.103646628558636, 0.103701271116734, 0.103755906224251, 0.103810556232929, 0.103865191340446, 0.103919833898544, 0.103974469006062, 0.104029104113579, 0.104083746671677, 0.104138374328613, 0.104193016886711, 0.104247651994228, 0.104302287101746, 0.104356929659843, 0.104411572217941, 0.104466184973717, 0.104520834982395, 0.104575455188751, 0.104630082845688, 0.104684725403786, 0.104739353060722, 0.104793980717659, 0.104848600924015, 0.104903236031532, 0.10495787113905, 0.105012491345406, 0.105067126452923, 0.105121754109859, 0.105176374316216, 0.105231001973152, 0.105285629630089, 0.105340234935284, 0.105394877493382, 0.105449490249157, 0.105504110455513, 0.105558730661869, 0.105613350868225, 0.105667963624001, 0.105722576379776, 0.105777204036713, 0.105831809341908, 0.105886444449425, 0.10594104975462, 0.105995662510395, 0.106050282716751, 0.106104895472527, 0.106159493327141, 0.106214113533497, 0.106268733739853, 0.106323346495628, 0.106377951800823, 0.106432564556599, 0.106487162411213, 0.10654179006815, 0.106596395373344, 0.106650985777378, 0.106705605983734, 0.106760211288929, 0.106814816594124, 0.106869421899319, 0.106924027204514, 0.106978617608547, 0.107033237814903, 0.107087828218937, 0.107142426073551, 0.107197023928165, 0.107251636683941, 0.107306234538555, 0.107360824942589, 0.107415430247784, 0.107470020651817, 0.107524625957012, 0.107579223811626, 0.10763381421566, 0.107688404619694, 0.107743002474308, 0.107797607779503, 0.107852190732956, 0.10790678113699, 0.107961386442184, 0.108015969395638, 0.108070552349091, 0.108125157654285, 0.108179733157158, 0.108234331011772, 0.108288913965225, 0.108343482017517, 0.108398087322712, 0.108452670276165, 0.108507253229618, 0.108561843633652, 0.108616426587105, 0.108671002089977, 0.10872558504343, 0.108780160546303, 0.108834750950336, 0.108889319002628, 0.108943909406662, 0.108998484909534, 0.109053067862988, 0.10910764336586, 0.109162218868732, 0.109216794371605, 0.109271392226219, 0.109325930476189, 0.109380520880222, 0.109435103833675, 0.109489671885967, 0.10954424738884, 0.109598822891712, 0.109653383493423, 0.109707951545715, 0.109762534499168, 0.109817087650299, 0.109871663153172, 0.109926231205463, 0.109980799257755, 0.110035359859467, 0.110089935362339, 0.11014448851347, 0.110199056565762, 0.110253624618053, 0.110308200120926, 0.110362753272057, 0.110417321324348, 0.11047188192606, 0.11052643507719, 0.110580995678902, 0.110635556280613, 0.110690101981163, 0.110744670033455, 0.110799230635166, 0.110853776335716, 0.110908344388008, 0.1109629124403, 0.111017450690269, 0.11107199639082, 0.111126564443111, 0.111181117594242, 0.111235678195953, 0.111290216445923, 0.111344762146473, 0.111399322748184, 0.111453875899315, 0.111508421599865, 0.111562967300415, 0.111617513000965, 0.111672066152096, 0.111726604402065, 0.111781165003777, 0.111835688352585, 0.111890234053135, 0.111944779753685, 0.111999325454235, 0.112053871154785, 0.112108416855335, 0.112162955105305, 0.112217485904694, 0.112272031605244, 0.112326577305794, 0.112381123006344, 0.112435646355152, 0.112490184605122, 0.11254471540451, 0.112599261105061, 0.112653784453869, 0.112708330154419, 0.112762860953808, 0.112817406654358, 0.112871930003166, 0.112926475703716, 0.112980976700783, 0.113035522401333, 0.113090045750141, 0.113144591450691, 0.113199107348919, 0.113253645598888, 0.113308168947697, 0.113362692296505, 0.113417215645313, 0.113471746444702, 0.11352626979351, 0.113580793142319, 0.113635316491127, 0.113689832389355, 0.113744370639324, 0.113798886537552, 0.113853417336941, 0.113907925784588, 0.113962449133396, 0.114016957581043, 0.114071480929852, 0.11412600427866, 0.114180512726307, 0.114235036075115, 0.114289551973343, 0.114344052970409, 0.114398568868637, 0.114453092217445, 0.114507600665092, 0.114562101662159, 0.114616632461548, 0.114671133458614, 0.114725649356842, 0.114780157804489, 0.114834658801556, 0.114889174699783, 0.11494368314743, 0.114998184144497, 0.115052692592144, 0.115107208490372, 0.115161702036858, 0.115216203033924, 0.115270711481571, 0.115324936807156, 0.115378879010677, 0.115432821214199, 0.115486703813076, 0.115540586411953, 0.115594446659088, 0.115648254752159, 0.11570206284523, 0.115755826234818, 0.115809544920921, 0.115863271057606, 0.115916952490807, 0.115970619022846, 0.116024240851402, 0.116077840328217, 0.116131417453289, 0.116184957325459, 0.116238467395306, 0.116291970014572, 0.116345435380936, 0.116398878395557, 0.116452284157276, 0.116505660116673, 0.116559028625488, 0.11661234498024, 0.116665653884411, 0.116718932986259, 0.116772174835205, 0.116825394332409, 0.11687857657671, 0.116931758821011, 0.116984881460667, 0.117038004100323, 0.117091089487076, 0.117144130170345, 0.117197170853615, 0.117250174283981, 0.117303133010864, 0.117356091737747, 0.117409013211727, 0.117461897432804, 0.11751476675272, 0.117567606270313, 0.117620423436165, 0.117673203349113, 0.11772596091032, 0.117778681218624, 0.117831386625767, 0.117884062230587, 0.117936708033085, 0.11798932403326, 0.118041925132275, 0.118094474077225, 0.118147030472755, 0.118199527263641, 0.118252016603947, 0.118304468691349, 0.11835689842701, 0.118409313261509, 0.118461683392525, 0.118514031171799, 0.11856634914875, 0.11861863732338, 0.118670910596848, 0.118723146617413, 0.118775360286236, 0.118827551603317, 0.118879698216915, 0.118931829929352, 0.118983924388885, 0.119036018848419, 0.119088046252728, 0.119140088558197, 0.119192078709602, 0.119244024157524, 0.119295962154865, 0.119347885251045, 0.119399763643742, 0.119451619684696, 0.11950346082449, 0.119555249810219, 0.119607038795948, 0.119658775627613, 0.119710497558117, 0.119762182235718, 0.119813852012157, 0.119865491986275, 0.11991710960865, 0.119968689978123, 0.120020247995853, 0.120071783661842, 0.120123282074928, 0.120174735784531, 0.120226196944714, 0.120277613401413, 0.120329014956951, 0.120380371809006, 0.12043172121048, 0.12048302590847, 0.120534315705299, 0.120585568249226, 0.12063679844141, 0.120688006281853, 0.120739176869392, 0.12079032510519, 0.120841436088085, 0.12089254707098, 0.120943605899811, 0.1209946423769, 0.121045656502247, 0.121096633374691, 0.121147587895393, 0.121198527514935, 0.121249437332153, 0.121300302445889, 0.121351160109043, 0.121401973068714, 0.121452763676643, 0.12150352448225, 0.121554270386696, 0.121604979038239, 0.12165567278862, 0.121706329286098, 0.121756948530674, 0.121807567775249, 0.121858142316341, 0.12190867960453, 0.121959201991558, 0.122009702026844, 0.122060164809227, 0.122110597789288, 0.122161015868187, 0.122211389243603, 0.122261747717857, 0.12231208384037, 0.122362390160561, 0.122412651777267, 0.122462905943394, 0.122513122856617, 0.122563317418098, 0.122613497078419, 0.122663632035255, 0.12271374464035, 0.122763827443123, 0.122813895344734, 0.122863911092281, 0.122913911938667, 0.122963897883892, 0.123013831675053, 0.123063765466213, 0.12311364710331, 0.123163528740406, 0.123213373124599, 0.123263172805309, 0.123312957584858, 0.123362712562084, 0.123412445187569, 0.123462148010731, 0.12351182103157, 0.123561464250088, 0.123611100018024, 0.123660683631897, 0.123710252344608, 0.123759791254997, 0.123809307813644, 0.123858787119389, 0.123908244073391, 0.123957678675652, 0.12400708347559, 0.124056465923786, 0.124105803668499, 0.124155126512051, 0.12420441955328, 0.124253682792187, 0.124302931129932, 0.124352142214775, 0.124401330947876, 0.124450474977493, 0.124499619007111, 0.124548710882664, 0.124597795307636, 0.124646835029125, 0.124695859849453, 0.124744862318039, 0.124793812632561, 0.124842755496502, 0.124891676008701, 0.124940551817417, 0.124989420175552, 0.125038251280785, 0.125087052583694, 0.125135824084282, 0.125184580683708, 0.125233307480812, 0.125281989574432, 0.125330656766891, 0.125379294157028, 0.125427916646004, 0.125476494431496, 0.125525057315826, 0.125573590397835, 0.12562207877636, 0.125670567154884, 0.125719010829926, 0.125767454504967, 0.125815823674202, 0.125864192843437, 0.125912547111511, 0.12596084177494, 0.126009121537209, 0.126057386398315, 0.1261056214571, 0.126153811812401, 0.126202002167702, 0.12625016272068, 0.126298278570175, 0.126346364617348, 0.126394420862198, 0.126442462205887, 0.126490488648415, 0.126538470387459, 0.126586422324181, 0.126634359359741, 0.126682266592979, 0.126730129122734, 0.126777991652489, 0.12682580947876, 0.12687361240387, 0.126921370625496, 0.126969113945961, 0.127016827464104, 0.127064511179924, 0.127112179994583, 0.127159804105759, 0.127207413315773, 0.127254977822304, 0.127302527427673, 0.127350062131882, 0.127397552132607, 0.127445012331009, 0.127492442727089, 0.127539858222008, 0.127587243914604, 0.127634614706039, 0.127681940793991, 0.127729251980782, 0.127776518464088, 0.127823770046234, 0.127870991826057, 0.127918183803558, 0.127965360879898, 0.128012493252754, 0.128059610724449, 0.128106698393822, 0.128153756260872, 0.1282007843256, 0.128247782588005, 0.128294765949249, 0.128341719508171, 0.128388628363609, 0.128435537219048, 0.128482401371002, 0.128529235720634, 0.128576055169106, 0.128622844815254, 0.128669589757919, 0.128716334700584, 0.128763020038605, 0.128809705376625, 0.128856346011162, 0.128902986645699, 0.128949582576752, 0.128996133804321, 0.129042685031891, 0.129089191555977, 0.12913566827774, 0.129182144999504, 0.129228562116623, 0.129274979233742, 0.129321366548538, 0.129367709159851, 0.129414021968842, 0.129460319876671, 0.129506587982178, 0.129552826285362, 0.129599049687386, 0.129645228385925, 0.129691392183304, 0.129737511277199, 0.129783615469933, 0.129829704761505, 0.129875749349594, 0.129921779036522, 0.129967764019966, 0.130013734102249, 0.130059689283371, 0.130105584859848, 0.130151480436325, 0.130197331309319, 0.130243167281151, 0.130288973450661, 0.130334749817848, 0.130380496382713, 0.130426228046417, 0.130471915006638, 0.130517587065697, 0.130563214421272, 0.130608826875687, 0.13065442442894, 0.130699977278709, 0.130745515227318, 0.130791023373604, 0.130836501717567, 0.130881935358047, 0.130927368998528, 0.130972772836685, 0.131018131971359, 0.131063476204872, 0.131108790636063, 0.13115406036377, 0.131199344992638, 0.131244570016861, 0.131289780139923, 0.131334945559502, 0.131380096077919, 0.131425216794014, 0.131470322608948, 0.131515383720398, 0.131560429930687, 0.131605446338654, 0.131650418043137, 0.13169538974762, 0.131740316748619, 0.131785228848457, 0.131830096244812, 0.131874963641167, 0.131919786334038, 0.131964579224586, 0.132009342312813, 0.132054075598717, 0.132098793983459, 0.132143467664719, 0.132188141345978, 0.132232785224915, 0.132277369499207, 0.132321953773499, 0.132366508245468, 0.132411032915115, 0.132455512881279, 0.132499977946281, 0.132544428110123, 0.132588848471642, 0.132633239030838, 0.132677584886551, 0.132721915841103, 0.132766231894493, 0.1328105032444, 0.132854759693146, 0.132898986339569, 0.13294318318367, 0.132987350225449, 0.133031487464905, 0.133075594902039, 0.133119687438011, 0.133163750171661, 0.133207768201828, 0.133251771330833, 0.133295759558678, 0.1333397179842, 0.133383631706238, 0.133427545428276, 0.13347139954567, 0.133515238761902, 0.133559063076973, 0.13360284268856, 0.133646607398987, 0.133690342307091, 0.133734047412872, 0.133777722716331, 0.133821368217468, 0.133864998817444, 0.133908584713936, 0.133952155709267, 0.133995696902275, 0.134039208292961, 0.134082704782486, 0.134126156568527, 0.134169608354568, 0.134213000535965, 0.1342563778162, 0.134299725294113, 0.134343042969704, 0.134386330842972, 0.13442961871624, 0.134472861886024, 0.134516075253487, 0.134559258818626, 0.134602412581444, 0.1346455514431, 0.134688660502434, 0.134731724858284, 0.134774789214134, 0.134817823767662, 0.134860813617706, 0.134903773665428, 0.134946718811989, 0.134989634156227, 0.135032519698143, 0.135075375437737, 0.135118216276169, 0.135161012411118, 0.135203793644905, 0.13524654507637, 0.135289266705513, 0.135331973433495, 0.135374635457993, 0.135417282581329, 0.135459899902344, 0.135502472519875, 0.135545030236244, 0.135587573051453, 0.135630086064339, 0.135672554373741, 0.135715007781982, 0.135757446289062, 0.135799825191498, 0.135842204093933, 0.135884538292885, 0.135926857590675, 0.135969147086143, 0.136011406779289, 0.136053636670113, 0.136095836758614, 0.136138021945953, 0.136180177330971, 0.136222302913666, 0.136264383792877, 0.136306464672089, 0.136348515748978, 0.136390522122383, 0.136432498693466, 0.136474475264549, 0.136516407132149, 0.136558309197426, 0.136600181460381, 0.136642038822174, 0.136683851480484, 0.136725649237633, 0.136767417192459, 0.136809170246124, 0.136850893497467, 0.136892572045326, 0.136934220790863, 0.136975884437561, 0.137017473578453, 0.137059047818184, 0.137100607156754, 0.13714212179184, 0.137183636426926, 0.137225091457367, 0.137266531586647, 0.137307956814766, 0.137349337339401, 0.137390688061714, 0.137432038784027, 0.137473344802856, 0.137514621019363, 0.137555867433548, 0.137597098946571, 0.137638300657272, 0.13767945766449, 0.137720599770546, 0.137761726975441, 0.137802809476852, 0.137843862175941, 0.137884899973869, 0.137925907969475, 0.137966886162758, 0.13800784945488, 0.138048753142357, 0.138089656829834, 0.138130530714989, 0.13817135989666, 0.138212189078331, 0.13825298845768, 0.138293743133545, 0.138334468007088, 0.138375177979469, 0.138415858149529, 0.138456508517265, 0.13849712908268, 0.138537719845772, 0.138578295707703, 0.138618841767311, 0.138659358024597, 0.138699859380722, 0.138740301132202, 0.138780742883682, 0.13882115483284, 0.138861522078514, 0.138901874423027, 0.138942196965218, 0.138982504606247, 0.139022767543793, 0.139063000679016, 0.13910323381424, 0.139143407344818, 0.139183565974236, 0.139223709702492, 0.139263823628426, 0.139303892850876, 0.139343947172165, 0.139383986592293, 0.139423966407776, 0.139463946223259, 0.139503881335258, 0.139543801546097, 0.139583691954613, 0.139623552560806, 0.139663383364677, 0.139703199267387, 0.139742970466614, 0.139782711863518, 0.139822453260422, 0.139862135052681, 0.13990181684494, 0.139941453933716, 0.13998107612133, 0.140020668506622, 0.140060216188431, 0.140099748969078, 0.140139281749725, 0.140178740024567, 0.140218198299408, 0.140257626771927, 0.140297010540962, 0.140336379408836, 0.140375733375549, 0.140415042638779, 0.140454337000847, 0.140493601560593, 0.140532821416855, 0.140572041273117, 0.140611216425896, 0.140650361776352, 0.140689492225647, 0.140728607773781, 0.14076766371727, 0.140806704759598, 0.140845730900764, 0.140884697437286, 0.140923678874969, 0.140962600708008, 0.141001507639885, 0.141040399670601, 0.141079246997833, 0.141118079423904, 0.141156867146492, 0.14119565486908, 0.141234382987022, 0.141273111104965, 0.141311779618263, 0.141350448131561, 0.141389086842537, 0.14142769575119, 0.141466274857521, 0.14150482416153, 0.141543358564377, 0.141581848263741, 0.141620308160782, 0.141658753156662, 0.141697183251381, 0.141735568642616, 0.14177393913269, 0.141812264919281, 0.14185057580471, 0.141888841986656, 0.141927108168602, 0.141965329647064, 0.142003536224365, 0.142041698098183, 0.142079845070839, 0.142117947340012, 0.142156049609184, 0.142194107174873, 0.142232149839401, 0.142270147800446, 0.142308130860329, 0.142346084117889, 0.142384007573128, 0.142421916127205, 0.142459779977798, 0.142497628927231, 0.142535448074341, 0.142573237419128, 0.142610996961594, 0.142648726701736, 0.142686441540718, 0.142724126577377, 0.142761766910553, 0.142799392342567, 0.14283698797226, 0.14287456870079, 0.142912119626999, 0.142949625849724, 0.142987102270126, 0.143024578690529, 0.143062010407448, 0.143099412322044, 0.143136784434319, 0.143174156546593, 0.143211483955383, 0.143248781561852, 0.143286049365997, 0.143323302268982, 0.143360510468483, 0.143397703766823, 0.14343486726284, 0.143471986055374, 0.143509104847908, 0.14354619383812, 0.143583238124847, 0.143620252609253, 0.143657267093658, 0.143694221973419, 0.14373117685318, 0.143768101930618, 0.143804982304573, 0.143841847777367, 0.143878683447838, 0.143915489315987, 0.143952265381813, 0.143989026546478, 0.14402574300766, 0.14406244456768, 0.144099116325378, 0.144135758280754, 0.144172370433807, 0.144208967685699, 0.144245535135269, 0.144282072782516, 0.144318580627441, 0.144355058670044, 0.144391506910324, 0.144427925348282, 0.144464328885078, 0.144500702619553, 0.144537046551704, 0.144573360681534, 0.144609645009041, 0.144645929336548, 0.14468215405941, 0.144718363881111, 0.14475454390049, 0.144790709018707, 0.144826829433441, 0.144862920045853, 0.144898995757103, 0.144935041666031, 0.144971057772636, 0.14500704407692, 0.145043015480042, 0.14507894217968, 0.145114853978157, 0.145150735974312, 0.145186588168144, 0.145222410559654, 0.145258218050003, 0.145293980836868, 0.145329728722572, 0.145365446805954, 0.145401135087013, 0.14543679356575, 0.145472422242165, 0.145508036017418, 0.145543619990349, 0.145579174160957, 0.145614698529243, 0.145650193095207, 0.14568567276001, 0.14572112262249, 0.145756542682648, 0.145791918039322, 0.145827293395996, 0.145862624049187, 0.145897939801216, 0.145933210849762, 0.145968481898308, 0.146003693342209, 0.14603890478611, 0.146074071526527, 0.146109208464622, 0.146144330501556, 0.146179422736168, 0.146214485168457, 0.146249532699585, 0.146284535527229, 0.146319508552551, 0.146354466676712, 0.14638939499855, 0.146424293518066, 0.14645916223526, 0.146494016051292, 0.146528825163841, 0.146563604474068, 0.146598383784294, 0.146633103489876, 0.146667823195457, 0.146702498197556, 0.146737143397331, 0.146771788597107, 0.146806389093399, 0.146840944886208, 0.146875500679016, 0.146910011768341, 0.146944507956505, 0.146978974342346, 0.147013410925865, 0.147047817707062, 0.147082194685936, 0.147116556763649, 0.147150874137878, 0.147185176610947, 0.147219449281693, 0.147253692150116, 0.147287905216217, 0.147322103381157, 0.147356271743774, 0.14739041030407, 0.147424504160881, 0.147458598017693, 0.147492647171021, 0.147526666522026, 0.14756067097187, 0.147594660520554, 0.147628590464592, 0.147662505507469, 0.147696405649185, 0.147730261087418, 0.147764101624489, 0.147797912359238, 0.147831693291664, 0.147865429520607, 0.147899180650711, 0.14793287217617, 0.147966548800468, 0.148000195622444, 0.148033812642097, 0.148067399859428, 0.148100957274437, 0.148134499788284, 0.148168012499809, 0.148201480507851, 0.148234948515892, 0.148268386721611, 0.148301765322685, 0.148335143923759, 0.148368492722511, 0.148401811718941, 0.148435100913048, 0.148468360304832, 0.148501589894295, 0.148534819483757, 0.148567989468575, 0.148601144552231, 0.148634269833565, 0.148667380213737, 0.148700445890427, 0.148733496665955, 0.148766502737999, 0.148799493908882, 0.148832470178604, 0.148865416646004, 0.14889831840992, 0.148931190371513, 0.148964047431946, 0.148996889591217, 0.149029672145844, 0.14906245470047, 0.149095192551613, 0.149127915501595, 0.149160593748093, 0.14919325709343, 0.149225905537605, 0.149258509278297, 0.14929111301899, 0.149323657155037, 0.149356171488762, 0.149388685822487, 0.149421140551567, 0.149453595280647, 0.149486020207405, 0.149518415331841, 0.149550780653954, 0.149583101272583, 0.149615436792374, 0.149647697806358, 0.149679958820343, 0.149712190032005, 0.149744391441345, 0.149776563048363, 0.149808704853058, 0.149840831756592, 0.149872928857803, 0.149904981255531, 0.149937003850937, 0.149969026446342, 0.150001019239426, 0.150032967329025, 0.150064885616302, 0.150096789002419, 0.150128662586212, 0.150160506367683, 0.150192335247993, 0.150224134325981, 0.150255873799324, 0.150287613272667, 0.150319337844849, 0.150351002812386, 0.150382667779922, 0.150414302945137, 0.150445893406868, 0.150477468967438, 0.150509014725685, 0.15054053068161, 0.150572031736374, 0.150603502988815, 0.150634929537773, 0.15066634118557, 0.150697708129883, 0.150729089975357, 0.150760412216187, 0.150791704654694, 0.150822982192039, 0.150854229927063, 0.150885447859764, 0.150916635990143, 0.15094780921936, 0.150978937745094, 0.151010051369667, 0.151041135191917, 0.151072189211845, 0.151103228330612, 0.151134207844734, 0.151165187358856, 0.151196137070656, 0.151227056980133, 0.151257947087288, 0.151288822293282, 0.151319667696953, 0.151350468397141, 0.151381239295006, 0.15141199529171, 0.151442721486092, 0.151473432779312, 0.151504099369049, 0.151534751057625, 0.151565358042717, 0.151595950126648, 0.151626527309418, 0.151657059788704, 0.151687562465668, 0.15171805024147, 0.151748508214951, 0.151778936386108, 0.151809349656105, 0.151839718222618, 0.151870056986809, 0.151900365948677, 0.151930660009384, 0.151960924267769, 0.151991173624992, 0.152021393179893, 0.15205155313015, 0.152081727981567, 0.152111858129501, 0.152141958475113, 0.152172014117241, 0.152202069759369, 0.152232095599174, 0.152262076735497, 0.152292057871819, 0.152321979403496, 0.152351900935173, 0.152381777763367, 0.152411639690399, 0.152441471815109, 0.152471259236336, 0.152501046657562, 0.152530789375305, 0.152560502290726, 0.152590200304985, 0.152619868516922, 0.152649506926537, 0.152679115533829, 0.152708694338799, 0.152738258242607, 0.152767777442932, 0.152797281742096, 0.152826756238937, 0.152856200933456, 0.152885615825653, 0.152915015816689, 0.152944386005402, 0.152973726391792, 0.153003036975861, 0.153032302856445, 0.15306156873703, 0.153090804815292, 0.153120011091232, 0.153149172663689, 0.153178319334984, 0.153207451105118, 0.153236523270607, 0.153265610337257, 0.153294637799263, 0.153323650360107, 0.153352633118629, 0.153381586074829, 0.153410509228706, 0.153439417481422, 0.153468295931816, 0.153497129678726, 0.153525963425636, 0.153554752469063, 0.153583526611328, 0.15361225605011, 0.15364097058773, 0.153669655323029, 0.153698310256004, 0.153726935386658, 0.153755530714989, 0.153784111142159, 0.153812661767006, 0.153841182589531, 0.153869673609734, 0.153898134827614, 0.153926581144333, 0.15395499765873, 0.153983369469643, 0.154011741280556, 0.154040053486824, 0.154068365693092, 0.154096633195877, 0.154124885797501, 0.154153093695641, 0.154181286692619, 0.154209464788437, 0.154237598180771, 0.154265701770782, 0.154293805360794, 0.154321849346161, 0.154349878430367, 0.15437787771225, 0.154405862092972, 0.15443380177021, 0.154461726546288, 0.154489621520042, 0.154517471790314, 0.154545322060585, 0.154573127627373, 0.15460093319416, 0.154628664255142, 0.154656395316124, 0.154684111475945, 0.154711782932281, 0.154739424586296, 0.154767051339149, 0.154794633388519, 0.154822215437889, 0.154849752783775, 0.154877260327339, 0.154904738068581, 0.154932200908661, 0.154959633946419, 0.154987037181854, 0.155014395713806, 0.155041754245758, 0.155069068074226, 0.155096367001534, 0.155123621225357, 0.155150875449181, 0.155178084969521, 0.155205279588699, 0.155232429504395, 0.155259564518929, 0.155286654829979, 0.155313730239868, 0.155340775847435, 0.155367806553841, 0.155394792556763, 0.155421763658524, 0.155448690056801, 0.155475616455078, 0.155502498149872, 0.155529350042343, 0.155556172132492, 0.15558297932148, 0.155609756708145, 0.155636504292488, 0.155660659074783, 0.155682221055031, 0.155703738331795, 0.155725210905075, 0.155746638774872, 0.155768021941185, 0.155789375305176, 0.155810669064522, 0.155831933021545, 0.155853152275085, 0.155874326825142, 0.155895456671715, 0.155916541814804, 0.155937597155571, 0.155958607792854, 0.155979543924332, 0.156000480055809, 0.15602134168148, 0.156042188405991, 0.156062975525856, 0.156083732843399, 0.156104430556297, 0.156125083565712, 0.156145706772804, 0.156166285276413, 0.156186819076538, 0.15620730817318, 0.156227752566338, 0.156248182058334, 0.156268537044525, 0.156288862228394, 0.156309142708778, 0.15632937848568, 0.156349584460258, 0.156369730830193, 0.156389847397804, 0.156409904360771, 0.156429916620255, 0.156449913978577, 0.156469851732254, 0.156489744782448, 0.156509593129158, 0.156529411673546, 0.156549170613289, 0.15656889975071, 0.156588584184647, 0.1566082239151, 0.156627833843231, 0.156647384166718, 0.15666688978672, 0.156686365604401, 0.156705796718597, 0.156725183129311, 0.15674452483654, 0.156763821840286, 0.15678308904171, 0.156802296638489, 0.156821474432945, 0.156840592622757, 0.156859681010246, 0.156878724694252, 0.156897738575935, 0.156916692852974, 0.15693561732769, 0.156954482197762, 0.156973332166672, 0.156992107629776, 0.157010853290558, 0.157029554247856, 0.157048225402832, 0.157066836953163, 0.157085418701172, 0.157103955745697, 0.157122448086739, 0.157140895724297, 0.157159298658371, 0.157177671790123, 0.15719598531723, 0.157214254140854, 0.157232493162155, 0.157250687479973, 0.157268851995468, 0.157286942005157, 0.157305002212524, 0.157323032617569, 0.15734101831913, 0.157358959317207, 0.15737684071064, 0.15739469230175, 0.157412499189377, 0.157430276274681, 0.157447993755341, 0.157465681433678, 0.157483324408531, 0.157500922679901, 0.157518476247787, 0.15753598511219, 0.157553464174271, 0.157570883631706, 0.157588258385658, 0.157605603337288, 0.157622903585434, 0.157640174031258, 0.157657384872437, 0.157674551010132, 0.157691672444344, 0.157708749175072, 0.157725811004639, 0.1577427983284, 0.157759755849838, 0.157776668667793, 0.157793551683426, 0.157810375094414, 0.157827168703079, 0.157843917608261, 0.157860606908798, 0.157877281308174, 0.157893896102905, 0.157910451292992, 0.157926991581917, 0.157943487167358, 0.157959938049316, 0.15797632932663, 0.157992705702782, 0.158009022474289, 0.158025294542313, 0.158041536808014, 0.15805771946907, 0.158073872327805, 0.158089965581894, 0.158106043934822, 0.158122062683105, 0.158138036727905, 0.158153980970383, 0.158169865608215, 0.158185705542564, 0.158201530575752, 0.158217296004295, 0.158233016729355, 0.158248692750931, 0.158264324069023, 0.158279940485954, 0.158295482397079, 0.158310994505882, 0.158326461911201, 0.158341884613037, 0.158357262611389, 0.158372610807419, 0.158387914299965, 0.158403143286705, 0.158418372273445, 0.15843354165554, 0.158448666334152, 0.15846374630928, 0.158478796482086, 0.158493801951408, 0.158508747816086, 0.158523663878441, 0.158538535237312, 0.1585533618927, 0.158568143844604, 0.158582895994186, 0.158597588539124, 0.158612251281738, 0.158626854419708, 0.158641427755356, 0.158655971288681, 0.158670455217361, 0.158684894442558, 0.158699303865433, 0.158713653683662, 0.158727988600731, 0.158742249011993, 0.158756494522095, 0.15877066552639, 0.158784836530685, 0.158798933029175, 0.158812999725342, 0.158827021718025, 0.158840999007225, 0.158854931592941, 0.158868819475174, 0.158882662653923, 0.15889647603035, 0.158910229802132, 0.158923953771591, 0.158937633037567, 0.158951282501221, 0.158964857459068, 0.158978402614594, 0.158991917967796, 0.159005388617516, 0.159018814563751, 0.159032195806503, 0.159045532345772, 0.159058839082718, 0.159072071313858, 0.159085288643837, 0.159098461270332, 0.159111574292183, 0.159124657511711, 0.159137710928917, 0.159150704741478, 0.159163653850555, 0.159176558256149, 0.159189432859421, 0.159202262759209, 0.159215047955513, 0.159227803349495, 0.159240484237671, 0.159253135323524, 0.159265756607056, 0.159278333187103, 0.159290865063667, 0.159303352236748, 0.159315779805183, 0.159328192472458, 0.159340545535088, 0.159352868795395, 0.159365132451057, 0.159377366304398, 0.159389555454254, 0.159401699900627, 0.159413799643517, 0.159425869584084, 0.159437879920006, 0.159449875354767, 0.159461796283722, 0.159473687410355, 0.159485533833504, 0.159497335553169, 0.159509092569351, 0.15952080488205, 0.159532502293587, 0.159544125199318, 0.159555718302727, 0.159567251801491, 0.159578770399094, 0.159590244293213, 0.159601658582687, 0.159613043069839, 0.159624367952347, 0.159635677933693, 0.159646928310394, 0.159658133983612, 0.159669309854507, 0.159680411219597, 0.159691497683525, 0.159702554345131, 0.159713536500931, 0.159724473953247, 0.159735396504402, 0.159746274352074, 0.1597570925951, 0.159767881035805, 0.159778624773026, 0.159789308905602, 0.159799978137016, 0.159810572862625, 0.159821152687073, 0.159831672906876, 0.159842163324356, 0.159852594137192, 0.159862995147705, 0.159873366355896, 0.159883677959442, 0.159893944859505, 0.159904167056084, 0.15991435945034, 0.159924492239952, 0.159934595227242, 0.159944668412209, 0.159954681992531, 0.15996465086937, 0.159974575042725, 0.159984469413757, 0.159994319081306, 0.160004124045372, 0.160013869404793, 0.160023599863052, 0.160033270716667, 0.16004291176796, 0.160052493214607, 0.160062029957771, 0.160071551799774, 0.160081014037132, 0.160090431571007, 0.160099804401398, 0.160109147429466, 0.16011843085289, 0.160127684473991, 0.160136893391609, 0.160146072506905, 0.160155177116394, 0.160164251923561, 0.160173282027245, 0.160182282328606, 0.160191237926483, 0.160200148820877, 0.160209015011787, 0.160217836499214, 0.160226613283157, 0.160235345363617, 0.160244047641754, 0.160252705216408, 0.160261318087578, 0.160269886255264, 0.160278409719467, 0.160286888480186, 0.160295322537422, 0.160303726792336, 0.160312086343765, 0.160320401191711, 0.160328671336174, 0.160336881875992, 0.160345077514648, 0.160353228449821, 0.16036131978035, 0.160369381308556, 0.160377398133278, 0.160385370254517, 0.160393297672272, 0.160401195287704, 0.160409033298492, 0.160416826605797, 0.160424590110779, 0.160432308912277, 0.160439968109131, 0.160447597503662, 0.160455197095871, 0.160462737083435, 0.160470247268677, 0.160477712750435, 0.160485118627548, 0.160492494702339, 0.160499840974808, 0.160507127642632, 0.160514369606972, 0.16052158176899, 0.160528734326363, 0.160535857081413, 0.16054293513298, 0.160549968481064, 0.160556957125664, 0.16056390106678, 0.160570815205574, 0.160577669739723, 0.160584509372711, 0.160591289401054, 0.160598024725914, 0.16060471534729, 0.160611376166344, 0.160617962479591, 0.160624548792839, 0.160631075501442, 0.160637557506561, 0.160643994808197, 0.160650387406349, 0.160656735301018, 0.160663053393364, 0.160669311881065, 0.160675540566444, 0.160681709647179, 0.160687863826752, 0.16069395840168, 0.160700023174286, 0.160706028342247, 0.160712003707886, 0.160717934370041, 0.160723805427551, 0.160729646682739, 0.160735458135605, 0.160741209983826, 0.160746932029724, 0.160752594470978, 0.160758227109909, 0.160763800144196, 0.160769358277321, 0.16077484190464, 0.16078032553196, 0.160785734653473, 0.160791099071503, 0.16079643368721, 0.160801723599434, 0.160806983709335, 0.160812169313431, 0.160817340016365, 0.160822451114655, 0.160827532410622, 0.160832554101944, 0.160837545990944, 0.160842508077621, 0.160847410559654, 0.160852268338203, 0.16085709631443, 0.160861864686012, 0.160866603255272, 0.160871297121048, 0.16087594628334, 0.160880550742149, 0.160885125398636, 0.160889640450478, 0.160894125699997, 0.160898566246033, 0.160902947187424, 0.160907313227654, 0.160911619663239, 0.160915896296501, 0.160920098423958, 0.160924285650253, 0.160928428173065, 0.160932525992393, 0.160936579108238, 0.160940587520599, 0.160944551229477, 0.160948485136032, 0.160952374339104, 0.160956203937531, 0.160960018634796, 0.160963758826256, 0.160967469215393, 0.160971134901047, 0.160974770784378, 0.160978361964226, 0.16098190844059, 0.160985395312309, 0.160988852381706, 0.16099226474762, 0.160995632410049, 0.160998970270157, 0.161002263426781, 0.16100549697876, 0.161008700728416, 0.16101185977459, 0.161014974117279, 0.161018058657646, 0.16102109849453, 0.161024078726768, 0.161027029156685, 0.161029934883118, 0.161032795906067, 0.161035612225533, 0.161038383841515, 0.161041125655174, 0.161043807864189, 0.16104644536972, 0.161049053072929, 0.161051630973816, 0.161054149270058, 0.161056607961655, 0.161059066653252, 0.161061450839043, 0.161063805222511, 0.161066100001335, 0.161068364977837, 0.161070600152016, 0.16107277572155, 0.161074906587601, 0.161077007651329, 0.161079064011574, 0.161081075668335, 0.161083042621613, 0.161084964871407, 0.161086827516556, 0.161088675260544, 0.161090478301048, 0.161092221736908, 0.161093935370445, 0.16109561920166, 0.161097228527069, 0.161098808050156, 0.16110035777092, 0.1611018627882, 0.161103308200836, 0.16110472381115, 0.161106094717979, 0.161107435822487, 0.16110871732235, 0.161109954118729, 0.161111161112785, 0.161112308502197, 0.161113426089287, 0.161114513874054, 0.161115527153015, 0.161116510629654, 0.161117449402809, 0.161118358373642, 0.161119222640991, 0.161120042204857, 0.161120817065239, 0.161121547222137, 0.161122232675552, 0.161122888326645, 0.161123484373093, 0.161124050617218, 0.16112457215786, 0.161125048995018, 0.161125466227531, 0.161125853657722, 0.161126211285591, 0.161126509308815, 0.161126777529716, 0.161127001047134, 0.161127179861069, 0.161127313971519, 0.161127403378487, 0.161127462983131, 0.161127462983131, 0.161127433180809, 0.161127358675003, 0.161127239465714, 0.16112707555294, 0.161126881837845, 0.161126628518105, 0.161126330494881, 0.161125987768173, 0.161125615239143, 0.16112519800663, 0.161124750971794, 0.161124244332314, 0.161123692989349, 0.161123111844063, 0.161122471094131, 0.161121800541878, 0.16112108528614, 0.16112032532692, 0.161119520664215, 0.161118671298027, 0.161117792129517, 0.161116868257523, 0.161115899682045, 0.161114886403084, 0.161113828420639, 0.161112725734711, 0.161111578345299, 0.161110401153564, 0.161109179258347, 0.161107897758484, 0.161106586456299, 0.16110523045063, 0.161103844642639, 0.161102399230003, 0.161100909113884, 0.161099389195442, 0.161097809672356, 0.161096200346947, 0.161094561219215, 0.161092862486839, 0.16109111905098, 0.161089345812798, 0.161087512969971, 0.16108563542366, 0.161083742976189, 0.161081776022911, 0.161079794168472, 0.16107776761055, 0.161075681447983, 0.161073550581932, 0.161071389913559, 0.161069184541702, 0.161066934466362, 0.161064639687538, 0.161062315106392, 0.161059945821762, 0.161057516932487, 0.161055058240891, 0.161052539944649, 0.161049991846085, 0.161047399044037, 0.161044761538506, 0.161042109131813, 0.161039382219315, 0.161036610603333, 0.161033809185028, 0.161030977964401, 0.161028072237968, 0.161025151610374, 0.161022171378136, 0.161019176244736, 0.16101610660553, 0.16101299226284, 0.16100986301899, 0.161006674170494, 0.161003425717354, 0.161000177264214, 0.160996854305267, 0.160993501543999, 0.160990104079247, 0.160986661911011, 0.160983175039291, 0.160979643464088, 0.160976082086563, 0.160972461104393, 0.160968810319901, 0.160965114831924, 0.160961359739304, 0.160957589745522, 0.160953775048256, 0.160949885845184, 0.160945996642113, 0.160942032933235, 0.160938039422035, 0.160934001207352, 0.160929918289185, 0.160925790667534, 0.1609216183424, 0.160917416214943, 0.160913169384003, 0.160908877849579, 0.160904541611671, 0.16090016067028, 0.160895749926567, 0.160891279578209, 0.160886764526367, 0.160882219672203, 0.160877630114555, 0.160872995853424, 0.160868316888809, 0.160863608121872, 0.16085883975029, 0.160854026675224, 0.160849183797836, 0.160844296216965, 0.16083936393261, 0.160834386944771, 0.16082938015461, 0.160824298858643, 0.160819202661514, 0.160814061760902, 0.160808861255646, 0.160803630948067, 0.160798355937004, 0.160793051123619, 0.16078770160675, 0.160782292485237, 0.160776853561401, 0.160771355032921, 0.160765826702118, 0.160760253667831, 0.160754635930061, 0.160748988389969, 0.160743296146393, 0.160737559199333, 0.160731762647629, 0.160725936293602, 0.160720080137253, 0.160714164376259, 0.16070818901062, 0.16070219874382, 0.160696163773537, 0.16069008409977, 0.160683959722519, 0.160677790641785, 0.160671576857567, 0.160665333271027, 0.160659030079842, 0.160652682185173, 0.160646319389343, 0.160639882087708, 0.160633429884911, 0.160626903176308, 0.160620361566544, 0.160613775253296, 0.160607144236565, 0.160600453615189, 0.16059373319149, 0.160586982965469, 0.160580158233643, 0.160573303699493, 0.160566419363022, 0.160559490323067, 0.160552516579628, 0.160545498132706, 0.1605384349823, 0.16053132712841, 0.160524174571037, 0.160516992211342, 0.160509765148163, 0.160502478480339, 0.160495162010193, 0.160487815737724, 0.16048039495945, 0.160472959280014, 0.160465463995934, 0.160457938909531, 0.160450369119644, 0.160442739725113, 0.16043509542942, 0.160427391529083, 0.160419642925262, 0.160411864519119, 0.160404041409492, 0.160396158695221, 0.160388246178627, 0.160380288958549, 0.16037230193615, 0.160364240407944, 0.160356163978577, 0.160348042845726, 0.160339877009392, 0.160331666469574, 0.160323411226273, 0.160315111279488, 0.16030678153038, 0.160298392176628, 0.160289973020554, 0.160281494259834, 0.160272985696793, 0.160264432430267, 0.160255834460258, 0.160247191786766, 0.160238519310951, 0.160229802131653, 0.16022102534771, 0.160212233662605, 0.160203382372856, 0.160194471478462, 0.160185530781746, 0.160176560282707, 0.160167545080185, 0.160158470273018, 0.16014938056469, 0.160140231251717, 0.16013103723526, 0.16012179851532, 0.160112529993057, 0.16010320186615, 0.16009384393692, 0.160084441304207, 0.160074979066849, 0.160065501928329, 0.160055965185165, 0.160046398639679, 0.160036772489548, 0.160027116537094, 0.160017415881157, 0.160007670521736, 0.159997880458832, 0.159988060593605, 0.159978181123734, 0.159968256950378, 0.159958317875862, 0.15994830429554, 0.159938246011734, 0.159928187727928, 0.159918040037155, 0.159907877445221, 0.159897655248642, 0.159887418150902, 0.159877106547356, 0.159866765141487, 0.159856379032135, 0.159845963120461, 0.159835487604141, 0.159824967384338, 0.159814417362213, 0.159803822636604, 0.159793183207512, 0.159782499074936, 0.159771785140038, 0.159760996699333, 0.159750193357468, 0.15973936021328, 0.159728452563286, 0.15971751511097, 0.15970653295517, 0.159695506095886, 0.15968444943428, 0.159673348069191, 0.159662202000618, 0.1596509963274, 0.15963976085186, 0.159628480672836, 0.15961717069149, 0.159605801105499, 0.159594401717186, 0.159582957625389, 0.159571453928947, 0.159559920430183, 0.159548342227936, 0.159536734223366, 0.159525066614151, 0.159513354301453, 0.159501612186432, 0.159489825367928, 0.15947799384594, 0.159466117620468, 0.159454196691513, 0.159442231059074, 0.159430220723152, 0.159418195486069, 0.159406095743179, 0.159393981099129, 0.159381806850433, 0.159369587898254, 0.159357339143753, 0.159345030784607, 0.159332677721977, 0.159320309758186, 0.159307867288589, 0.15929539501667, 0.159282892942429, 0.159270331263542, 0.159257724881172, 0.15924508869648, 0.159232407808304, 0.159219682216644, 0.159206911921501, 0.159194096922874, 0.159181237220764, 0.159168347716331, 0.159155413508415, 0.159142419695854, 0.159129410982132, 0.159116327762604, 0.159103229641914, 0.15909007191658, 0.159076899290085, 0.159063637256622, 0.159050360321999, 0.159037038683891, 0.1590236723423, 0.159010261297226, 0.158996820449829, 0.158983334898949, 0.158969789743423, 0.158956214785576, 0.158942595124245, 0.15892893075943, 0.158915221691132, 0.15890146791935, 0.158887684345245, 0.158873841166496, 0.158859983086586, 0.15884605050087, 0.158832088112831, 0.15881809592247, 0.158804044127464, 0.158789962530136, 0.158775821328163, 0.158761650323868, 0.158747434616089, 0.158733174204826, 0.15871886909008, 0.158704519271851, 0.158690139651299, 0.158675715327263, 0.158661246299744, 0.158646732568741, 0.158632159233093, 0.158617556095123, 0.158602923154831, 0.158588230609894, 0.158573493361473, 0.158558741211891, 0.158543929457664, 0.158529072999954, 0.158514156937599, 0.158499225974083, 0.158484250307083, 0.158469215035439, 0.158454149961472, 0.158439055085182, 0.158423870801926, 0.158408686518669, 0.158393457531929, 0.158378168940544, 0.158362850546837, 0.158347487449646, 0.158332079648972, 0.158316612243652, 0.158301115036011, 0.158285588026047, 0.158270001411438, 0.158254384994507, 0.158238723874092, 0.158223018050194, 0.158207252621651, 0.158191457390785, 0.158175632357597, 0.158159747719765, 0.15814383327961, 0.158127874135971, 0.158111855387688, 0.158095821738243, 0.158079728484154, 0.158063590526581, 0.158047407865524, 0.158031195402145, 0.158014938235283, 0.157998636364937, 0.157982289791107, 0.157965898513794, 0.157949462532997, 0.157932996749878, 0.157916471362114, 0.157899916172028, 0.157883316278458, 0.157866671681404, 0.157849982380867, 0.157833263278008, 0.157816484570503, 0.157799661159515, 0.157782807946205, 0.157765910029411, 0.157748967409134, 0.157731980085373, 0.157714948058128, 0.157697886228561, 0.15768076479435, 0.157663613557816, 0.157646417617798, 0.157629176974297, 0.157611891627312, 0.157594561576843, 0.157577186822891, 0.157559797167778, 0.157542333006859, 0.157524839043617, 0.157507300376892, 0.157489717006683, 0.157472088932991, 0.157454431056976, 0.157436728477478, 0.157418966293335, 0.15740117430687, 0.15738333761692, 0.157365456223488, 0.157347530126572, 0.157329574227333, 0.15731155872345, 0.157293513417244, 0.157275423407555, 0.157257288694382, 0.157239124178886, 0.157220885157585, 0.157202631235123, 0.157184317708015, 0.157165974378586, 0.157147586345673, 0.157129153609276, 0.157110676169395, 0.157092154026031, 0.157073602080345, 0.157054990530014, 0.157036349177361, 0.157017663121223, 0.156998932361603, 0.156980156898499, 0.156961336731911, 0.156942471861839, 0.156923577189445, 0.156904637813568, 0.156885638833046, 0.156866610050201, 0.156847536563873, 0.156828418374062, 0.156809270381927, 0.156790062785149, 0.156770825386047, 0.156751543283463, 0.156732216477394, 0.156712844967842, 0.156693443655968, 0.156673982739449, 0.156654477119446, 0.156634926795959, 0.156615346670151, 0.156595721840858, 0.156576067209244, 0.156556352972984, 0.156536594033241, 0.156516805291176, 0.156496956944466, 0.156477093696594, 0.156457155942917, 0.156437203288078, 0.156417176127434, 0.156397134065628, 0.156377032399178, 0.156356900930405, 0.156336724758148, 0.156316503882408, 0.156296238303185, 0.156275928020477, 0.156255587935448, 0.156235188245773, 0.156214758753777, 0.156194269657135, 0.156173750758171, 0.156153187155724, 0.156132578849792, 0.156111925840378, 0.156091243028641, 0.15607051551342, 0.156049728393555, 0.156028926372528, 0.156008064746857, 0.155987158417702, 0.155966222286224, 0.155942484736443, 0.155915960669518, 0.155889376997948, 0.155862778425217, 0.155836135149002, 0.155809476971626, 0.155782774090767, 0.155756011605263, 0.155729234218597, 0.155702412128448, 0.155675545334816, 0.155648648738861, 0.155621722340584, 0.155594766139984, 0.155567765235901, 0.155540719628334, 0.155513644218445, 0.155486524105072, 0.155459374189377, 0.155432194471359, 0.155404970049858, 0.155377700924873, 0.155350401997566, 0.155323073267937, 0.155295699834824, 0.155268296599388, 0.155240848660469, 0.155213370919228, 0.155185848474503, 0.155158296227455, 0.155130699276924, 0.155103072524071, 0.155075401067734, 0.155047714710236, 0.155019968748093, 0.154992207884789, 0.15496438741684, 0.154936537146568, 0.154908657073975, 0.154880732297897, 0.154852777719498, 0.154824778437614, 0.154796749353409, 0.154768690466881, 0.154740586876869, 0.154712438583374, 0.154684260487556, 0.154656052589417, 0.154627814888954, 0.154599502682686, 0.154571175575256, 0.154542818665504, 0.15451443195343, 0.154485985636711, 0.154457524418831, 0.154429018497467, 0.15440046787262, 0.15437188744545, 0.154343277215958, 0.154314622282982, 0.154285922646523, 0.154257193207741, 0.154228433966637, 0.154199630022049, 0.154170796275139, 0.154141917824745, 0.154113009572029, 0.154084056615829, 0.154055073857307, 0.154026046395302, 0.153997004032135, 0.153967902064323, 0.153938785195351, 0.153909593820572, 0.153880387544632, 0.15385115146637, 0.153821885585785, 0.153792560100555, 0.153763219714165, 0.15373383462429, 0.153704404830933, 0.153674945235252, 0.153645440936089, 0.153615906834602, 0.153586342930794, 0.153556734323502, 0.153527081012726, 0.153497412800789, 0.153467684984207, 0.153437942266464, 0.153408154845238, 0.153378322720528, 0.153348460793495, 0.153318554162979, 0.153288617730141, 0.15325865149498, 0.153228625655174, 0.153198570013046, 0.153168499469757, 0.153138369321823, 0.153108224272728, 0.153078019618988, 0.153047785162926, 0.153017520904541, 0.152987211942673, 0.152956873178482, 0.152926504611969, 0.152896091341972, 0.152865633368492, 0.152835160493851, 0.152804613113403, 0.152774050831795, 0.152743473649025, 0.152712821960449, 0.152682155370712, 0.152651444077492, 0.152620702981949, 0.152589917182922, 0.152559101581573, 0.152528256177902, 0.152497366070747, 0.152466431260109, 0.152435481548309, 0.152404472231865, 0.152373433113098, 0.152342364192009, 0.152311250567436, 0.15228009223938, 0.152248919010162, 0.152217701077461, 0.152186423540115, 0.152155131101608, 0.152123808860779, 0.152092441916466, 0.15206104516983, 0.15202958881855, 0.151998117566109, 0.151966601610184, 0.151935055851936, 0.151903465390205, 0.151871830224991, 0.151840180158615, 0.151808485388756, 0.151776745915413, 0.151744976639748, 0.151713162660599, 0.151681318879128, 0.151649430394173, 0.151617527008057, 0.151585564017296, 0.151553571224213, 0.151521548628807, 0.151489481329918, 0.151457384228706, 0.151425242424011, 0.151393070816994, 0.151360854506493, 0.151328593492508, 0.151296332478523, 0.151264011859894, 0.151231646537781, 0.151199251413345, 0.151166826486588, 0.151134356856346, 0.151101842522621, 0.151069313287735, 0.151036724448204, 0.151004120707512, 0.150971457362175, 0.150938779115677, 0.150906056165695, 0.15087328851223, 0.150840505957603, 0.150807648897171, 0.150774791836739, 0.150741875171661, 0.150708943605423, 0.15067595243454, 0.150642931461334, 0.150609865784645, 0.150576800107956, 0.150543659925461, 0.150510504841805, 0.150477305054665, 0.150444060564041, 0.150410771369934, 0.150377467274666, 0.150344118475914, 0.15031073987484, 0.150277316570282, 0.150243848562241, 0.150210365653038, 0.150176823139191, 0.150143265724182, 0.15010966360569, 0.150076031684875, 0.150042355060577, 0.150008633732796, 0.149974882602692, 0.149941101670265, 0.149907261133194, 0.149873405694962, 0.149839505553246, 0.149805560708046, 0.149771600961685, 0.149737596511841, 0.149703547358513, 0.149669468402863, 0.149635329842567, 0.149601191282272, 0.149566993117332, 0.149532780051231, 0.149498507380486, 0.149464204907417, 0.149429872632027, 0.149395480751991, 0.149361088871956, 0.149326622486115, 0.149292156100273, 0.149257630109787, 0.149223074316978, 0.149188473820686, 0.149153843522072, 0.149119168519974, 0.149084478616714, 0.14904972910881, 0.149014949798584, 0.148980140686035, 0.148945286870003, 0.148910388350487, 0.14887547492981, 0.148840516805649, 0.148805513978004, 0.148770466446877, 0.148735418915749, 0.148700296878815, 0.148665145039558, 0.14862996339798, 0.148594751954079, 0.148559510707855, 0.148524209856987, 0.148488894104958, 0.148453518748283, 0.148418113589287, 0.148382678627968, 0.148347198963165, 0.14831168949604, 0.148276135325432, 0.148240551352501, 0.148204937577248, 0.148169279098511, 0.14813357591629, 0.148097842931747, 0.148062095046043, 0.148026272654533, 0.147990450263023, 0.147954568266869, 0.14791864156723, 0.147882699966431, 0.147846713662148, 0.14781066775322, 0.147774621844292, 0.14773853123188, 0.147702381014824, 0.147666215896606, 0.147630006074905, 0.147593766450882, 0.147557482123375, 0.147521153092384, 0.147484809160233, 0.147448420524597, 0.147411987185478, 0.147375524044037, 0.147339031100273, 0.147302478551865, 0.147265911102295, 0.147229298949242, 0.147192656993866, 0.147155955433846, 0.147119238972664, 0.147082477807999, 0.147045701742172, 0.147008866071701, 0.146971985697746, 0.146935075521469, 0.14689813554287, 0.146861165761948, 0.146824151277542, 0.146787106990814, 0.146750018000603, 0.146712899208069, 0.14667572081089, 0.14663852751255, 0.146601304411888, 0.146564021706581, 0.146526709198952, 0.146489366889, 0.146451979875565, 0.146414563059807, 0.146377116441727, 0.146339610219002, 0.146302089095116, 0.146264523267746, 0.146226912736893, 0.146189287304878, 0.14615161716938, 0.146113902330399, 0.146076157689095, 0.146038368344307, 0.146000549197197, 0.145962685346603, 0.145924791693687, 0.145886853337288, 0.145848885178566, 0.145810887217522, 0.145772844552994, 0.145734772086143, 0.14569665491581, 0.145658507943153, 0.145620301365852, 0.145582094788551, 0.145543828606606, 0.145505517721176, 0.145467191934586, 0.145428821444511, 0.145390421152115, 0.145351976156235, 0.145313486456871, 0.145274981856346, 0.145236417651176, 0.145197823643684, 0.14515919983387, 0.145120531320572, 0.145081833004951, 0.145043089985847, 0.145004317164421, 0.144965499639511, 0.144926652312279, 0.144887760281563, 0.144848853349686, 0.144809901714325, 0.144770905375481, 0.144731864333153, 0.144692793488503, 0.14465369284153, 0.144614547491074, 0.144575372338295, 0.144536167383194, 0.144496902823448, 0.14445760846138, 0.144418284296989, 0.144378945231438, 0.14433953166008, 0.1443000882864, 0.144260630011559, 0.144221112132072, 0.144181564450264, 0.144141986966133, 0.144102364778519, 0.144062712788582, 0.144023016095161, 0.143983289599419, 0.143943533301353, 0.143903732299805, 0.143863886594772, 0.143824025988579, 0.143784120678902, 0.14374415576458, 0.143704175949097, 0.14366415143013, 0.14362408220768, 0.143583998084068, 0.143543869256973, 0.143503695726395, 0.143463492393494, 0.143423244357109, 0.143382966518402, 0.143342658877373, 0.14330230653286, 0.143261924386024, 0.143221482634544, 0.143181025981903, 0.143140524625778, 0.143099993467331, 0.143059432506561, 0.143018826842308, 0.14297816157341, 0.142937496304512, 0.14289678633213, 0.142856031656265, 0.142815217375755, 0.142774403095245, 0.142733529210091, 0.142692625522614, 0.142651692032814, 0.142610713839531, 0.142569705843925, 0.142528653144836, 0.142487555742264, 0.14244644343853, 0.142405286431313, 0.142364099621773, 0.142322868108749, 0.142281591892242, 0.142240285873413, 0.142198950052261, 0.142157569527626, 0.142116144299507, 0.142074704170227, 0.142033204436302, 0.141991689801216, 0.141950130462646, 0.141908526420593, 0.141866892576218, 0.14182522892952, 0.141783505678177, 0.141741767525673, 0.141699984669685, 0.141658157110214, 0.141616299748421, 0.141574427485466, 0.141532495617867, 0.141490533947945, 0.141448512673378, 0.14140647649765, 0.1413644105196, 0.141322314739227, 0.141280144453049, 0.141237959265709, 0.141195744276047, 0.141153484582901, 0.141111180186272, 0.141068860888481, 0.141026496887207, 0.140984088182449, 0.140941649675369, 0.140899151563644, 0.14085665345192, 0.14081409573555, 0.140771508216858, 0.140728890895844, 0.140686228871346, 0.140643537044525, 0.140600800514221, 0.140558019280434, 0.140515193343163, 0.14047235250473, 0.140429481863976, 0.140386566519737, 0.140343606472015, 0.14030060172081, 0.140257582068443, 0.140214532613754, 0.14017142355442, 0.140128284692764, 0.140085116028786, 0.140041887760162, 0.139998644590378, 0.13995535671711, 0.139912039041519, 0.139868676662445, 0.139825284481049, 0.139781847596169, 0.139738380908966, 0.13969486951828, 0.139651328325272, 0.139607757329941, 0.139564141631126, 0.13952049612999, 0.139476805925369, 0.139433071017265, 0.139389321208, 0.13934551179409, 0.139301687479019, 0.139257818460464, 0.139213904738426, 0.139169946312904, 0.139125972986221, 0.139081954956055, 0.139037892222404, 0.138993799686432, 0.138949692249298, 0.138905510306358, 0.138861298561096, 0.138817086815834, 0.138772800564766, 0.138728484511375, 0.138684138655663, 0.138639748096466, 0.138595327734947, 0.138550877571106, 0.138506382703781, 0.138461843132973, 0.138417273759842, 0.138372659683228, 0.138328030705452, 0.138283357024193, 0.13823863863945, 0.138193875551224, 0.138149082660675, 0.138104259967804, 0.13805940747261, 0.138014495372772, 0.137969568371773, 0.13792459666729, 0.137879595160484, 0.137834548950195, 0.137789458036423, 0.137744337320328, 0.13769918680191, 0.137653991580009, 0.137608766555786, 0.13756351172924, 0.13751819729805, 0.137472853064537, 0.137427479028702, 0.137382075190544, 0.137336626648903, 0.137291148304939, 0.137245610356331, 0.137200057506561, 0.137154474854469, 0.137108832597733, 0.137063160538673, 0.137017458677292, 0.136971712112427, 0.136925935745239, 0.136880114674568, 0.136834278702736, 0.136788383126259, 0.136742457747459, 0.136696487665176, 0.136650487780571, 0.136604472994804, 0.136558383703232, 0.136512279510498, 0.136466130614281, 0.136419951915741, 0.136373728513718, 0.136327475309372, 0.136281177401543, 0.136234864592552, 0.136188492178917, 0.136142089962959, 0.136095657944679, 0.136049166321754, 0.136002659797668, 0.135956108570099, 0.135909527540207, 0.135862901806831, 0.135816246271133, 0.135769546031952, 0.135722815990448, 0.135676056146622, 0.135629236698151, 0.135582402348518, 0.135535538196564, 0.135488599538803, 0.135441660881042, 0.135394677519798, 0.13534764945507, 0.13530059158802, 0.135253489017487, 0.13520635664463, 0.13515916466713, 0.135111957788467, 0.135064721107483, 0.135017439723015, 0.134970113635063, 0.134922757744789, 0.134875386953354, 0.134827956557274, 0.13478048145771, 0.134732976555824, 0.134685426950455, 0.134637862443924, 0.13459025323391, 0.134542599320412, 0.13449490070343, 0.134447202086449, 0.134399428963661, 0.134351640939713, 0.13430380821228, 0.134255945682526, 0.134208023548126, 0.134160086512566, 0.134112104773521, 0.134064093232155, 0.134016051888466, 0.133967965841293, 0.133919835090637, 0.133871659636497, 0.133823469281197, 0.133775234222412, 0.133726969361305, 0.133678644895554, 0.133630305528641, 0.133581921458244, 0.133533507585526, 0.133485049009323, 0.133436545729637, 0.13338802754879, 0.133339449763298, 0.133290871977806, 0.133242219686508, 0.133193537592888, 0.133144825696945, 0.13309608399868, 0.133047297596931, 0.132998466491699, 0.132949605584145, 0.132900714874268, 0.132851794362068, 0.132802829146385, 0.132753819227219, 0.13270477950573, 0.132655695080757, 0.132606580853462, 0.132557421922684, 0.132508233189583, 0.13245901465416, 0.132409751415253, 0.132360458374023, 0.132311120629311, 0.132261738181114, 0.132212325930595, 0.132162883877754, 0.132113397121429, 0.132063895463943, 0.132014334201813, 0.13196474313736, 0.131915107369423, 0.131865441799164, 0.131815746426582, 0.131765991449356, 0.131716206669807, 0.131666421890259, 0.131616562604904, 0.131566673517227, 0.131516754627228, 0.131466805934906, 0.131416812539101, 0.131366774439812, 0.131316691637039, 0.131266593933105, 0.131216451525688, 0.131166279315948, 0.131116062402725, 0.131065800786018, 0.13101552426815, 0.130965188145638, 0.130914822220802, 0.130864426493645, 0.130813986063004, 0.130763530731201, 0.130713015794754, 0.130662456154823, 0.130611881613731, 0.130561262369156, 0.130510613322258, 0.130459904670715, 0.130409181118011, 0.130358412861824, 0.130307629704475, 0.130256772041321, 0.130205914378166, 0.130154997110367, 0.130104050040245, 0.13005305826664, 0.130002036690712, 0.129950985312462, 0.129899889230728, 0.129848748445511, 0.129797577857971, 0.129746377468109, 0.129695132374763, 0.129643842577934, 0.129592537879944, 0.12954118847847, 0.129489779472351, 0.129438370466232, 0.12938691675663, 0.129335418343544, 0.129283875226974, 0.129232302308083, 0.129180699586868, 0.12912905216217, 0.129077360033989, 0.129025638103485, 0.128973886370659, 0.128922089934349, 0.128870263695717, 0.128818392753601, 0.128766492009163, 0.128714561462402, 0.128662586212158, 0.12861056625843, 0.128558531403542, 0.128506436944008, 0.128454312682152, 0.128402158617973, 0.128349959850311, 0.128297716379166, 0.128245458006859, 0.128193154931068, 0.128140807151794, 0.128088429570198, 0.128036007285118, 0.127983555197716, 0.127931073307991, 0.127878546714783, 0.127825975418091, 0.127773389220238, 0.12772074341774, 0.12766806781292, 0.127615362405777, 0.127562612295151, 0.127509847283363, 0.12745700776577, 0.127404168248177, 0.127351254224777, 0.127298340201378, 0.127245366573334, 0.127192363142967, 0.127139329910278, 0.127086251974106, 0.127033144235611, 0.126980006694794, 0.126926809549332, 0.126873582601547, 0.12682032585144, 0.126767039299011, 0.126713693141937, 0.126660317182541, 0.126606926321983, 0.126553475856781, 0.126500010490417, 0.126446485519409, 0.12639294564724, 0.126339346170425, 0.126285716891289, 0.12623205780983, 0.126178354024887, 0.126124620437622, 0.126070842146873, 0.126017034053802, 0.125963196158409, 0.125909313559532, 0.125855386257172, 0.125801429152489, 0.125747442245483, 0.125693425536156, 0.125639349222183, 0.125585243105888, 0.125531107187271, 0.12547692656517, 0.125422716140747, 0.125368475914001, 0.125314190983772, 0.12525986135006, 0.125205501914024, 0.125151112675667, 0.125096663832664, 0.125042200088501, 0.124987699091434, 0.124933153390884, 0.124878570437431, 0.124823950231075, 0.124769300222397, 0.124714612960815, 0.124659888446331, 0.124605134129524, 0.124550312757492, 0.12449549138546, 0.124440625309944, 0.124385699629784, 0.124330773949623, 0.124275788664818, 0.124220758676529, 0.124165713787079, 0.124110609292984, 0.124055482447147, 0.124000310897827, 0.123945109546185, 0.123889870941639, 0.12383459508419, 0.123779289424419, 0.123723939061165, 0.123668551445007, 0.123613126575947, 0.123557679355145, 0.123502172529697, 0.123446643352509, 0.123391069471836, 0.123335473239422, 0.123279824852943, 0.123224131762981, 0.123168423771858, 0.123112678527832, 0.123056881129742, 0.12300106137991, 0.122945196926594, 0.122889295220375, 0.122833371162415, 0.122777387499809, 0.122721381485462, 0.122665330767632, 0.122609250247478, 0.122553132474422, 0.122496977448463, 0.122440785169601, 0.122384548187256, 0.122328288853168, 0.122271992266178, 0.122215650975704, 0.122159272432327, 0.122102864086628, 0.122046403586864, 0.121989913284779, 0.121933400630951, 0.121876835823059, 0.121820233762264, 0.121763601899147, 0.121706947684288, 0.121650226414204, 0.121593490242958, 0.12153671681881, 0.121479891240597, 0.121423043310642, 0.121366150677204, 0.121309220790863, 0.12125226855278, 0.121195271611214, 0.121138229966164, 0.121081158518791, 0.121024049818516, 0.120966896414757, 0.120909728109837, 0.120852492749691, 0.120795242488384, 0.120737954974174, 0.120680622756481, 0.120623245835304, 0.120565854012966, 0.120508417487144, 0.120450936257839, 0.120393432676792, 0.1203358694911, 0.120278276503086, 0.12022066116333, 0.12016300112009, 0.120105303823948, 0.120047584176064, 0.119989804923534, 0.119932003319263, 0.119874157011509, 0.119816273450851, 0.119758367538452, 0.119700409471989, 0.119642429053783, 0.119584381580353, 0.119526334106922, 0.119468227028847, 0.11941009759903, 0.119351930916309, 0.119293719530106, 0.119235478341579, 0.119177177548409, 0.119118854403496, 0.119060501456261, 0.119002111256123, 0.118943698704243, 0.118885219097137, 0.11882670968771, 0.118768185377121, 0.118709601461887, 0.118650987744331, 0.118592351675034, 0.11853364855051, 0.118474923074245, 0.118416175246239, 0.118357367813587, 0.118298538029194, 0.118239678442478, 0.118180766701698, 0.118121817708015, 0.118062846362591, 0.118003830313683, 0.117944777011871, 0.117885686457157, 0.117826551198959, 0.1177674010396, 0.117708198726177, 0.117648959159851, 0.117589682340622, 0.11753037571907, 0.117471024394035, 0.117411650717258, 0.117352232336998, 0.117292769253254, 0.117233268916607, 0.117173753678799, 0.117114178836346, 0.117054581642151, 0.116994947195053, 0.116935260593891, 0.116875551640987, 0.116815805435181, 0.11675601452589, 0.116696193814278, 0.116636335849762, 0.116576433181763, 0.116516500711441, 0.116456530988216, 0.116396531462669, 0.116336472332478, 0.116276405751705, 0.116216287016869, 0.11615613847971, 0.116095945239067, 0.116035714745522, 0.115975454449654, 0.115915156900883, 0.115854829549789, 0.115794450044632, 0.115734033286572, 0.115673594176769, 0.115613102912903, 0.115552589297295, 0.115492038428783, 0.115431435406208, 0.11537080258131, 0.11531013995409, 0.115249440073967, 0.115188702940941, 0.115127921104431, 0.115067102015018, 0.115006260573864, 0.114945374429226, 0.114884443581104, 0.11482348293066, 0.114762492477894, 0.114701464772224, 0.114640384912491, 0.114579282701015, 0.114518143236637, 0.114456966519356, 0.114395745098591, 0.114334486424923, 0.114273205399513, 0.11421187967062, 0.114150524139404, 0.114089109003544, 0.114027678966522, 0.113966196775436, 0.113904699683189, 0.113843157887459, 0.113781571388245, 0.113719955086708, 0.113658294081688, 0.113596610724926, 0.113534860312939, 0.113473109900951, 0.113411292433739, 0.113349460065365, 0.113287582993507, 0.113225668668747, 0.113163717091084, 0.113101735711098, 0.113039709627628, 0.112977653741837, 0.112915545701981, 0.112853422760963, 0.112791240215302, 0.112729042768478, 0.112666800618172, 0.112604521214962, 0.112542204558849, 0.112479858100414, 0.112417466938496, 0.112355031073093, 0.11229258030653, 0.112230077385902, 0.112167529761791, 0.112104967236519, 0.112042345106602, 0.111979700624943, 0.111917018890381, 0.111854307353497, 0.111791551113129, 0.111728757619858, 0.111665919423103, 0.111603043973446, 0.111540153622627, 0.111477211117744, 0.111414231359959, 0.11135122179985, 0.111288174986839, 0.111225090920925, 0.111161962151527, 0.111100926995277, 0.111041963100433, 0.110982991755009, 0.110923960804939, 0.110864922404289, 0.110805861651897, 0.110746763646603, 0.110687628388405, 0.110628470778465, 0.110569298267365, 0.1105100736022, 0.110450841486454, 0.110391587018967, 0.110332280397415, 0.110272958874702, 0.110213607549667, 0.110154211521149, 0.110094830393791, 0.110035382211208, 0.109975926578045, 0.109916418790817, 0.10985691100359, 0.109797358512878, 0.109737776219845, 0.109678171575069, 0.109618537127972, 0.109558865427971, 0.109499178826809, 0.109439477324486, 0.109379716217518, 0.109319940209389, 0.109260141849518, 0.109200306236744, 0.109140455722809, 0.10908056050539, 0.10902064293623, 0.108960703015327, 0.108900725841522, 0.108840718865395, 0.108780704438686, 0.108720637857914, 0.1086605489254, 0.108600452542305, 0.108540311455727, 0.108480125665665, 0.108419932425022, 0.108359716832638, 0.10829945653677, 0.10823917388916, 0.108178861439228, 0.108118526637554, 0.108058147132397, 0.107997760176659, 0.107937335968018, 0.107876881957054, 0.10781641304493, 0.107755891978741, 0.107695356011391, 0.107634797692299, 0.107574194669724, 0.107513599097729, 0.107452929019928, 0.107392258942127, 0.107331536710262, 0.107270807027817, 0.107210047543049, 0.107149258255959, 0.107088439166546, 0.107027590274811, 0.106966719031334, 0.106905825436115, 0.106844879686832, 0.106783911585808, 0.106722943484783, 0.106661915779114, 0.106600873172283, 0.10653980076313, 0.106478706002235, 0.106417573988438, 0.106356412172318, 0.106295235455036, 0.106234014034271, 0.106172770261765, 0.106111511588097, 0.106050208210945, 0.105988889932632, 0.105927526950836, 0.105866141617298, 0.105804733932018, 0.105743288993835, 0.105681821703911, 0.105620332062244, 0.105558805167675, 0.105497248470783, 0.105435684323311, 0.105374068021774, 0.105312414467335, 0.105250775814056, 0.105189085006714, 0.105127342045307, 0.1050655990839, 0.105003818869591, 0.104942016303539, 0.104880183935165, 0.104818321764469, 0.104756444692612, 0.104694522917271, 0.104632578790188, 0.104570589959621, 0.104508593678474, 0.104446560144424, 0.104384496808052, 0.104322403669357, 0.104260303080082, 0.104198150336742, 0.104135982692242, 0.104073777794838, 0.104011550545692, 0.103949293494225, 0.103887006640434, 0.103824697434902, 0.103762350976467, 0.10369998216629, 0.10363757610321, 0.103575155138969, 0.103512711822987, 0.10345021635294, 0.103387705981731, 0.103325165808201, 0.103262603282928, 0.103200010955334, 0.103137388825417, 0.103074721992016, 0.103012040257454, 0.102949351072311, 0.102886602282524, 0.102823846042156, 0.102761045098305, 0.102698229253292, 0.102635376155376, 0.102572500705719, 0.102509595453739, 0.102446652948856, 0.102383702993393, 0.102320693433285, 0.102257683873177, 0.102194644510746, 0.102131567895412, 0.102068468928337, 0.102005340158939, 0.101942166686058, 0.101878985762596, 0.101815767586231, 0.101752512156963, 0.101689249277115, 0.101625949144363, 0.10156261920929, 0.101499252021313, 0.101435877382755, 0.101372458040714, 0.101309023797512, 0.101245559751987, 0.101182051002979, 0.10111852735281, 0.101054973900318, 0.100991398096085, 0.100927777588367, 0.100864134728909, 0.100800469517708, 0.100736774504185, 0.10067305713892, 0.100609309971333, 0.100545510649681, 0.100481703877449, 0.100417882204056, 0.100354000926018, 0.10029011964798, 0.100226193666458, 0.100162237882614, 0.100098267197609, 0.100034274160862, 0.0999702364206314, 0.0999061539769173, 0.0998420715332031, 0.099777951836586, 0.0997138172388077, 0.0996496379375458, 0.0995854213833809, 0.099521204829216, 0.0994569361209869, 0.0993926525115967, 0.0993283316493034, 0.0992639809846878, 0.099199615418911, 0.0991352051496506, 0.0990708023309708, 0.0990063324570656, 0.098941832780838, 0.098877340555191, 0.0988127812743187, 0.0987482219934464, 0.098683625459671, 0.0986189842224121, 0.0985543355345726, 0.0984896570444107, 0.0984249413013458, 0.0983602032065392, 0.0982954353094101, 0.0982306450605392, 0.0981658026576042, 0.0981009751558304, 0.0980360954999924, 0.0979711711406708, 0.0979062393307686, 0.0978412702679634, 0.0977762788534164, 0.0977112650871277, 0.0976462140679359, 0.0975811257958412, 0.0975160375237465, 0.0974509045481682, 0.0973857268691063, 0.097320556640625, 0.0972553193569183, 0.0971900671720505, 0.0971248000860214, 0.0970594957470894, 0.0969941541552544, 0.0969287976622581, 0.0968634039163589, 0.0967979952692986, 0.0967325493693352, 0.0966670885682106, 0.0966015681624413, 0.0965360477566719, 0.0964704975485802, 0.0964049026370049, 0.0963392928242683, 0.0962736457586288, 0.0962079837918282, 0.0961422845721245, 0.0960765704512596, 0.0960108041763306, 0.0959450080990791, 0.0958792120218277, 0.0958133712410927, 0.0957475081086159, 0.0956816077232361, 0.0956156775355339, 0.0955497249960899, 0.0954837501049042, 0.0954177379608154, 0.0953517034649849, 0.095285639166832, 0.0952195450663567, 0.0951534137129784, 0.0950872749090195, 0.0950210988521576, 0.0949548929929733, 0.0948886573314667, 0.0948223993182182, 0.0947561040520668, 0.094689778983593, 0.094623439013958, 0.0945570543408394, 0.0944906622171402, 0.094424232840538, 0.0943577587604523, 0.0942912846803665, 0.0942247658967972, 0.0941582098603249, 0.0940916463732719, 0.094025045633316, 0.0939584150910378, 0.0938917621970177, 0.093825064599514, 0.0937583521008492, 0.0936916097998619, 0.0936248451471329, 0.0935580432415009, 0.0934912115335464, 0.0934243723750114, 0.0933574885129929, 0.0932905599474907, 0.0932236313819885, 0.0931566655635834, 0.0930896699428558, 0.0930226445198059, 0.092955581843853, 0.0928885117173195, 0.092821404337883, 0.0927542746067047, 0.0926871001720428, 0.0926199108362198, 0.0925526916980743, 0.0924854353070259, 0.0924181640148163, 0.0923508554697037, 0.0922835096716881, 0.0922161564230919, 0.0921487659215927, 0.0920813381671906, 0.0920139029622078, 0.0919464305043221, 0.0918789133429527, 0.0918113887310028, 0.0917438343167305, 0.0916762351989746, 0.0916086211800575, 0.0915409773588181, 0.0914733037352562, 0.0914056077599525, 0.0913378745317459, 0.0912701189517975, 0.0912023335695267, 0.0911345183849335, 0.0910666733980179, 0.0909988060593605, 0.0909309089183807, 0.090862974524498, 0.090795025229454, 0.0907270386815071, 0.0906590223312378, 0.0905909985303879, 0.0905229225754738, 0.0904548242688179, 0.0903867110610008, 0.0903185531497002, 0.0902503654360771, 0.0901821553707123, 0.0901139229536057, 0.0900456607341766, 0.0899773612618446, 0.0899090468883514, 0.0898406878113747, 0.0897723138332367, 0.0897039175033569, 0.0896354764699936, 0.0895670130848885, 0.0894985273480415, 0.0894300043582916, 0.0893614515662193, 0.0892928838729858, 0.0892242714762688, 0.0891556367278099, 0.0890869870781898, 0.0890182927250862, 0.0889495760202408, 0.0888808369636536, 0.0888120606541634, 0.0887432619929314, 0.088674433529377, 0.0886055752635002, 0.0885366871953011, 0.0884677767753601, 0.0883988291025162, 0.088329866528511, 0.0882608667016029, 0.0881918370723724, 0.0881227776408195, 0.0880536958575249, 0.0879845917224884, 0.0879154428839684, 0.0878462865948677, 0.0877770781517029, 0.0877078548073769, 0.0876386091113091, 0.0875693261623383, 0.0875000208616257, 0.0874306783080101, 0.0873613134026527, 0.0872919112443924, 0.0872225016355515, 0.0871530547738075, 0.0870835706591606, 0.0870140716433525, 0.0869445353746414, 0.0868749693036079, 0.0868053734302521, 0.086735762655735, 0.0866661071777344, 0.0865964293479919, 0.0865267366170883, 0.0864569991827011, 0.0863872393965721, 0.0863174572587013, 0.0862476378679276, 0.0861777886748314, 0.0861079171299934, 0.0860380157828331, 0.0859680846333504, 0.0858981385827065, 0.0858281478285789, 0.0857581272721291, 0.085688091814518, 0.0856180116534233, 0.0855479091405869, 0.0854777917265892, 0.0854076370596886, 0.0853374451398849, 0.0852672457695007, 0.0851969942450523, 0.0851267352700233, 0.085056446492672, 0.084986113011837, 0.0849157646298409, 0.0848453789949417, 0.0847749710083008, 0.0847045257687569, 0.0846340730786324, 0.0845635756850243, 0.0844930484890938, 0.0844225138425827, 0.0843519270420074, 0.0842813178896904, 0.0842106863856316, 0.0841400250792503, 0.0840693265199661, 0.0839986205101013, 0.0839278697967529, 0.0838570892810822, 0.0837862938642502, 0.0837154537439346, 0.0836445912718773, 0.0835737138986588, 0.0835027918219566, 0.0834318399429321, 0.0833608731627464, 0.0832898691296577, 0.0832188427448273, 0.0831477791070938, 0.0830766931176186, 0.0830055773258209, 0.0829344317317009, 0.0828632712364197, 0.0827920660376549, 0.0827208384871483, 0.0826495885848999, 0.0825783014297485, 0.0825069919228554, 0.0824356600642204, 0.0823642835021019, 0.0822928845882416, 0.0822214633226395, 0.082150012254715, 0.0820785313844681, 0.0820070281624794, 0.0819354876875877, 0.0818639174103737, 0.0817923322319984, 0.0817207023501396, 0.081649050116539, 0.0815773755311966, 0.0815056711435318, 0.081433929502964, 0.081362172961235, 0.0812903791666031, 0.0812185630202293, 0.0811467245221138, 0.0810748413205147, 0.0810029357671738, 0.0809310078620911, 0.0808590427041054, 0.0807870477437973, 0.080715037882328, 0.0806429982185364, 0.0805709138512611, 0.0804988220334053, 0.0804266929626465, 0.0803545266389847, 0.0802823528647423, 0.0802101343870163, 0.0801378861069679, 0.0800656229257584, 0.0799933224916458, 0.0799209922552109, 0.0798486396670341, 0.0797762498259544, 0.0797038450837135, 0.0796314105391502, 0.079558938741684, 0.0794864296913147, 0.0794139057397842, 0.0793413668870926, 0.0792687758803368, 0.0791961699724197, 0.0791235342621803, 0.0790508612990379, 0.0789781734347343, 0.078905463218689, 0.0788327008485794, 0.0787599161267281, 0.0786871239542961, 0.0786142796278, 0.0785414129495621, 0.078468531370163, 0.0783956050872803, 0.0783226564526558, 0.0782496929168701, 0.0781766846776009, 0.0781036540865898, 0.0780305936932564, 0.0779575034976006, 0.0778843760490417, 0.0778112486004829, 0.07773806899786, 0.0776648595929146, 0.0775916427373886, 0.0775183811783791, 0.0774450823664665, 0.077371783554554, 0.0772984251379967, 0.0772250592708588, 0.0771516710519791, 0.0770782381296158, 0.0770047828555107, 0.0769313052296638, 0.076857790350914, 0.0767842456698418, 0.0767106860876083, 0.0766370892524719, 0.0765634551644325, 0.0764898061752319, 0.076416127383709, 0.0763424187898636, 0.0762686803936958, 0.0761949121952057, 0.0761211216449738, 0.0760473012924194, 0.0759734511375427, 0.0758995711803436, 0.0758256539702415, 0.0757517293095589, 0.0756777599453926, 0.0756037682294846, 0.0755297541618347, 0.0754557102918625, 0.0753816291689873, 0.0753075331449509, 0.0752333998680115, 0.0751592293381691, 0.0750850513577461, 0.0750108286738396, 0.0749365836381912, 0.0748623162508011, 0.074788011610508, 0.0747136771678925, 0.0746393278241158, 0.0745649337768555, 0.074490524828434, 0.0744160860776901, 0.0743416100740433, 0.0742670968174934, 0.0741925910115242, 0.0741180256009102, 0.074043445289135, 0.0739688351750374, 0.0738941878080368, 0.0738195180892944, 0.0737448334693909, 0.0736701041460037, 0.0735953524708748, 0.0735205709934235, 0.0734457597136497, 0.0733709186315536, 0.0732960626482964, 0.0732211694121361, 0.0731462389230728, 0.073071300983429, 0.0729963183403015, 0.0729213133454323, 0.0728462785482407, 0.0727712064981461, 0.0726961120963097, 0.0726210102438927, 0.0725458487868309, 0.0724706724286079, 0.0723954737186432, 0.0723202377557755, 0.0722449794411659, 0.0721696987748146, 0.0720943808555603, 0.0720190182328224, 0.0719436481595039, 0.0718682557344437, 0.0717928186058998, 0.0717173591256142, 0.0716418772935867, 0.0715663656592369, 0.0714908167719841, 0.0714152455329895, 0.0713396519422531, 0.0712640136480331, 0.0711883753538132, 0.071112684905529, 0.0710369646549225, 0.0709612444043159, 0.0708854719996452, 0.0708096623420715, 0.0707338452339172, 0.07065799087286, 0.0705821067094803, 0.0705062076449394, 0.070430263876915, 0.0703542977571487, 0.0702783092856407, 0.0702022835612297, 0.0701262280344963, 0.0700501650571823, 0.0699740499258041, 0.0698979049921036, 0.0698217451572418, 0.0697455555200577, 0.0696693286299706, 0.0695931017398834, 0.0695168152451515, 0.0694405063986778, 0.0693641901016235, 0.0692878141999245, 0.0692114308476448, 0.0691350176930428, 0.0690585747361183, 0.0689820945262909, 0.0689055919647217, 0.0688290745019913, 0.0687524974346161, 0.0686759203672409, 0.0685993060469627, 0.0685226544737816, 0.0684459954500198, 0.0683692917227745, 0.0682925581932068, 0.0682158172130585, 0.068139024078846, 0.0680622160434723, 0.067985363304615, 0.0679085105657578, 0.0678316056728363, 0.0677546784281731, 0.067677728831768, 0.0676007494330406, 0.0675237402319908, 0.0674467086791992, 0.067369632422924, 0.0672925338149071, 0.0672154277563095, 0.0671382695436478, 0.0670610889792442, 0.0669838860630989, 0.0669066533446312, 0.0668293833732605, 0.0667521059513092, 0.0666747763752937, 0.0665974244475365, 0.066520057618618, 0.066442646086216, 0.0663652122020721, 0.0662877559661865, 0.0662102624773979, 0.0661327391862869, 0.0660552009940147, 0.0659776329994202, 0.0659000277519226, 0.0658224001526833, 0.0657447353005409, 0.0656670555472374, 0.0655893459916115, 0.0655116066336632, 0.0654338151216507, 0.0653560310602188, 0.0652781948447227, 0.0652003437280655, 0.0651224628090858, 0.0650445520877838, 0.0649666041135788, 0.0648886486887932, 0.0648106411099434, 0.0647326186299324, 0.064654566347599, 0.0645764842629433, 0.0644983798265457, 0.0644202455878258, 0.0643420740962029, 0.0642638802528381, 0.0641856417059898, 0.0641074031591415, 0.0640291273593903, 0.063950814306736, 0.0638724789023399, 0.0637941136956215, 0.0637157261371613, 0.0636373162269592, 0.0635588616132736, 0.0634803846478462, 0.0634018927812576, 0.0633233487606049, 0.0632447898387909, 0.0631662085652351, 0.0630875900387764, 0.0630089342594147, 0.0629302710294724, 0.0628515630960464, 0.0627728328108788, 0.0626940876245499, 0.0626152902841568, 0.0625364631414413, 0.0624576434493065, 0.0623787604272366, 0.0622998587787151, 0.0622209347784519, 0.0621419735252857, 0.0620629899203777, 0.061983983963728, 0.0619049482047558, 0.0618258714675903, 0.0617467761039734, 0.0616676583886147, 0.061588492244482, 0.0615093298256397, 0.0614301115274429, 0.0613508634269238, 0.061271607875824, 0.0611923187971115, 0.0611129924654961, 0.0610336363315582, 0.0609542578458786, 0.0608748495578766, 0.0607954226434231, 0.0607159659266472, 0.0606364607810974, 0.0605569519102573, 0.0604774057865143, 0.0603978149592876, 0.0603182278573513, 0.0602385774254799, 0.0601589232683182, 0.0600792244076729, 0.0599995218217373, 0.0599197670817375, 0.0598399862647057, 0.0597601979970932, 0.0596803613007069, 0.0596005022525787, 0.05952063575387, 0.0594407059252262, 0.0593607574701309, 0.0592807941138744, 0.0592008009552956, 0.0591207668185234, 0.0590407028794289, 0.0589606203138828, 0.0588805116713047, 0.0588003769516945, 0.0587202124297619, 0.0586399994790554, 0.0585597902536392, 0.0584795325994492, 0.0583992525935173, 0.0583189465105534, 0.0582385994493961, 0.0581582300364971, 0.0580778457224369, 0.0579974204301834, 0.0579169653356075, 0.0578364953398705, 0.0577559880912304, 0.0576754473149776, 0.0575948916375637, 0.0575142912566662, 0.0574336722493172, 0.0573530271649361, 0.0572723485529423, 0.0571916475892067, 0.057110920548439, 0.0570301562547684, 0.0569493621587753, 0.0568685457110405, 0.0567876994609833, 0.056706827133894, 0.0566259361803532, 0.0565449930727482, 0.0564640276134014, 0.0563830509781837, 0.0563020370900631, 0.0562209896743298, 0.0561399236321449, 0.0560588277876377, 0.0559776946902275, 0.0558965355157852, 0.0558153614401817, 0.0557341426610947, 0.0556528978049755, 0.0555716380476952, 0.0554903335869312, 0.0554090067744255, 0.055327657610178, 0.0552462749183178, 0.0551648698747158, 0.0550834350287914, 0.0550019592046738, 0.0549204610288143, 0.0548389554023743, 0.05475739762187, 0.0546758212149143, 0.0545942187309265, 0.0545125752687454, 0.0544309057295322, 0.0543492287397385, 0.0542674995958805, 0.0541857518255711, 0.0541039817035198, 0.0540221780538559, 0.0539403408765793, 0.0538584850728512, 0.0537765882909298, 0.0536946691572666, 0.0536127276718616, 0.0535307563841343, 0.0534487552940845, 0.0533667355775833, 0.0532846637070179, 0.0532025769352913, 0.0531204640865326, 0.0530383139848709, 0.0529561452567577, 0.0528739579021931, 0.0527917183935642, 0.0527094714343548, 0.0526271872222424, 0.0525448694825172, 0.0524625293910503, 0.0523801669478416, 0.05229776725173, 0.0522153377532959, 0.0521328933537006, 0.0520504042506218, 0.0519678965210915, 0.0518853515386581, 0.0518027916550636, 0.0517201907932758, 0.0516375675797462, 0.0515549331903458, 0.0514722466468811, 0.0513895340263844, 0.0513068027794361, 0.0512240342795849, 0.0511412397027016, 0.0510584302246571, 0.0509755797684193, 0.0508927032351494, 0.0508098043501377, 0.0507268644869328, 0.0506438985466957, 0.0505609177052975, 0.0504778958857059, 0.0503948479890823, 0.0503117814660072, 0.0502286739647388, 0.0501455403864384, 0.050062395632267, 0.0499791987240314, 0.0498959831893444, 0.0498127527534962, 0.0497294813394547, 0.0496461726725101, 0.0495628528296947, 0.0494794882833958, 0.049396101385355, 0.0493127033114433, 0.0492292568087578, 0.0491457805037498, 0.0490622892975807, 0.0489787682890892, 0.0488952063024044, 0.0488116405904293, 0.04872802272439, 0.0486443750560284, 0.0485607236623764, 0.04847701638937, 0.048393290489912, 0.0483095496892929, 0.0482257679104805, 0.0481419526040554, 0.0480581372976303, 0.0479742586612701, 0.0478903725743294, 0.0478064604103565, 0.0477225035429001, 0.0476385243237019, 0.0475545115768909, 0.04747049883008, 0.0473864264786243, 0.0473023317754269, 0.0472182296216488, 0.0471340678632259, 0.0470498949289322, 0.0469656996428967, 0.0468814745545387, 0.0467972047626972, 0.0467129312455654, 0.04662861302495, 0.0465442538261414, 0.0464599020779133, 0.0463755019009113, 0.0462910681962967, 0.0462066195905209, 0.0461221300065517, 0.0460376106202602, 0.0459530763328075, 0.0458685047924519, 0.0457838997244835, 0.0456992872059345, 0.045614629983902, 0.0455299466848373, 0.0454452373087406, 0.0453604981303215, 0.0452757328748703, 0.0451909452676773, 0.0451061241328716, 0.0450212545692921, 0.0449363924562931, 0.0448514744639397, 0.044766541570425, 0.0446815863251686, 0.0445965901017189, 0.0445115678012371, 0.0444265268743038, 0.0443414449691772, 0.0442563407123089, 0.0441712103784084, 0.0440860465168953, 0.0440008491277695, 0.0439156405627728, 0.0438303984701633, 0.0437451228499413, 0.0436598211526871, 0.0435744859278202, 0.0434891320765018, 0.0434037521481514, 0.0433183312416077, 0.0432328768074512, 0.0431474074721336, 0.0430619157850742, 0.0429763905704021, 0.0428908281028271, 0.0428052581846714, 0.0427196361124516, 0.0426339842379093, 0.0425483174622059, 0.0424626208841801, 0.0423768982291222, 0.0422911569476128, 0.0422053709626198, 0.0421195589005947, 0.0420337244868279, 0.041947852820158, 0.0418619513511658, 0.0417760349810123, 0.0416900888085365, 0.0416041053831577, 0.0415180996060371, 0.0414320603013039, 0.0413459986448288, 0.0412599146366119, 0.0411737821996212, 0.0410876423120499, 0.0410014651715755, 0.0409152545034885, 0.0408290214836597, 0.0407427661120892, 0.0406564772129059, 0.0405701547861099, 0.0404838174581528, 0.040397435426712, 0.0403110347688198, 0.0402246043086052, 0.0401381440460682, 0.0400516502559185, 0.0399651452898979, 0.0398786030709743, 0.0397920310497284, 0.0397054441273212, 0.0396188013255596, 0.0395321473479271, 0.0394454710185528, 0.0393587462604046, 0.0392720140516758, 0.0391852483153343, 0.0390984453260899, 0.0390116199851036, 0.0389247611165047, 0.0388378910720348, 0.0387509763240814, 0.038664024323225, 0.0385770723223686, 0.0384900793433189, 0.0384030491113663, 0.0383160077035427, 0.0382289215922356, 0.0381418094038963, 0.0380546785891056, 0.0379675142467022, 0.0378803126513958, 0.0377930998802185, 0.0377058573067188, 0.0376185737550259, 0.0375312827527523, 0.0374439358711243, 0.037356574088335, 0.037269189953804, 0.0371817760169506, 0.0370943248271942, 0.0370068624615669, 0.0369193442165852, 0.0368318147957325, 0.0367442704737186, 0.0366566702723503, 0.0365690588951111, 0.0364814177155495, 0.0363937392830849, 0.0363060384988785, 0.0362183228135109, 0.03613056614995, 0.0360427722334862, 0.0359549708664417, 0.0358671210706234, 0.0357792489230633, 0.0356913655996323, 0.0356034338474274, 0.0355154722929001, 0.0354274995625019, 0.0353394784033298, 0.0352514497935772, 0.0351633951067924, 0.0350752808153629, 0.0349871590733528, 0.0348990149796009, 0.034810833632946, 0.0347226224839687, 0.0346343964338303, 0.0345461294054985, 0.0344578325748444, 0.0343695059418678, 0.0342811681330204, 0.03419279307127, 0.0341043770313263, 0.0340159572660923, 0.0339274853467941, 0.0338389948010445, 0.0337504893541336, 0.0336619317531586, 0.033573355525732, 0.0334847643971443, 0.033396128565073, 0.0333074629306793, 0.0332187935709953, 0.0331300683319569, 0.0330413281917572, 0.0329525582492352, 0.0328637547791004, 0.0327749252319336, 0.032686073333025, 0.0325971879065037, 0.0325082689523697, 0.0324193388223648, 0.0323303751647472, 0.0322413630783558, 0.0321523547172546, 0.0320632867515087, 0.0319742076098919, 0.0318851061165333, 0.0317959599196911, 0.0317067913711071, 0.031617596745491, 0.0315283834934235, 0.031439121812582, 0.0313498266041279, 0.0312605313956738, 0.0311712045222521, 0.0310818515717983, 0.0309924427419901, 0.030903022736311, 0.0308135692030191, 0.0307240914553404, 0.0306346155703068, 0.0305450707674026, 0.0304555017501116, 0.0303659122437239, 0.0302762854844332, 0.0301866382360458, 0.0300969798117876, 0.0300072729587555, 0.0299175474792719, 0.0298277754336596, 0.029737988486886, 0.0296481717377901, 0.0295583419501781, 0.0294684786349535, 0.0293785687536001, 0.0292886346578598, 0.0291986688971519, 0.0291086807847023, 0.0290186908096075, 0.0289286449551582, 0.028838574886322, 0.0287484731525183, 0.0286583378911018, 0.0285681877285242, 0.0284780282527208, 0.0283878222107887, 0.028297571465373, 0.0282072983682156, 0.0281170010566711, 0.028026670217514, 0.0279363505542278, 0.0278459638357162, 0.0277555417269468, 0.0276651084423065, 0.0275746304541826, 0.0274841506034136, 0.0273936167359352, 0.0273030940443277, 0.0272125098854303, 0.0271218959242105, 0.0270312707871199, 0.0269405972212553, 0.0268499013036489, 0.0267592091113329, 0.0266684554517269, 0.0265776813030243, 0.026486873626709, 0.0263960305601358, 0.0263051744550467, 0.0262143108993769, 0.0261234007775784, 0.0260324403643608, 0.0259414743632078, 0.0258504617959261, 0.0257594250142574, 0.0256683994084597, 0.0255773067474365, 0.0254862010478973, 0.0253950525075197, 0.0253038667142391, 0.0252126716077328, 0.0251214634627104, 0.0250302124768496, 0.0249389261007309, 0.0248476043343544, 0.024756271392107, 0.024664893746376, 0.024573527276516, 0.0244820918887854, 0.0243906360119581, 0.0242991559207439, 0.0242076404392719, 0.0241161156445742, 0.0240245647728443, 0.0239329598844051, 0.0238413419574499, 0.0237496830523014, 0.0236580073833466, 0.0235663000494242, 0.0234745815396309, 0.0233828276395798, 0.0232910271733999, 0.0231992080807686, 0.0231073517352343, 0.023015471175313, 0.0229235701262951, 0.0228316560387611, 0.0227397009730339, 0.0226477067917585, 0.0225556809455156, 0.0224636420607567, 0.0223715584725142, 0.0222794879227877, 0.0221873465925455, 0.0220951829105616, 0.0220030080527067, 0.0219107773154974, 0.0218185447156429, 0.0217262916266918, 0.021633991971612, 0.0215416699647903, 0.02144930139184, 0.0213569216430187, 0.0212644971907139, 0.0211720820516348, 0.0210796128958464, 0.020987119525671, 0.020894592627883, 0.0208020303398371, 0.0207094457000494, 0.0206168610602617, 0.0205242205411196, 0.0204315558075905, 0.0203388594090939, 0.0202461257576942, 0.0201533827930689, 0.0200606267899275, 0.0199678260833025, 0.0198749806731939, 0.0197821110486984, 0.0196892190724611, 0.0195962935686111, 0.0195033792406321, 0.0194103959947824, 0.0193173792213202, 0.0192243531346321, 0.0191312879323959, 0.0190382041037083, 0.0189451072365046, 0.0188519544899464, 0.0187587775290012, 0.0186655689030886, 0.0185723453760147, 0.0184790790081024, 0.018385810777545, 0.0182925090193748, 0.0181991513818502, 0.0181057918816805, 0.0180123783648014, 0.0179189406335354, 0.0178254917263985, 0.0177320297807455, 0.017638523131609, 0.0175449717789888, 0.0174513962119818, 0.017357811331749, 0.0172641798853874, 0.0171705596148968, 0.0170768592506647, 0.0169831495732069, 0.016889413818717, 0.0167956463992596, 0.0167018547654152, 0.0166080538183451, 0.0165141951292753, 0.0164203122258186, 0.0163264069706202, 0.016232468187809, 0.016138507053256, 0.016044532880187, 0.0159505158662796, 0.0158564634621143, 0.0157623868435621, 0.0156682785600424, 0.0155741339549422, 0.015480013564229, 0.0153858121484518, 0.0152915995568037, 0.015197342261672, 0.0151030626147985, 0.0150087587535381, 0.0149144558236003, 0.0148201072588563, 0.0147257018834352, 0.0146312853321433, 0.0145368445664644, 0.014442372135818, 0.0143478978425264, 0.0142533667385578, 0.0141588030382991, 0.0140642253682017, 0.0139696039259434, 0.0138749703764915, 0.0137803144752979, 0.0136856138706207, 0.0135908890515566, 0.0134961316362023, 0.013401361182332, 0.0133065469563007, 0.013211696408689, 0.0131168588995934, 0.0130219636484981, 0.012927046045661, 0.0128320818766952, 0.0127370962873101, 0.0126420874148607, 0.0125470794737339, 0.0124520249664783, 0.0123569248244166, 0.0122617911547422, 0.0121666453778744, 0.0120714660733938, 0.0119762979447842, 0.0118810506537557, 0.0117857791483402, 0.0116904973983765, 0.0115951700136065, 0.0114998314529657, 0.0114044807851315, 0.011309084482491, 0.011213643476367, 0.0111181791871786, 0.0110226925462484, 0.010927171446383, 0.010831662453711, 0.0107360845431685, 0.0106404833495617, 0.0105448607355356, 0.0104491906240582, 0.0103535111993551, 0.010257818736136, 0.0101620703935623, 0.0100663099437952, 0.00997050479054451, 0.00987468753010035, 0.0097788255661726, 0.00968296267092228, 0.00958705507218838, 0.00949111301451921, 0.00939514767378569, 0.00929914880543947, 0.009203115478158, 0.00910709425806999, 0.00901101529598236, 0.00891491398215294, 0.00881876703351736, 0.00872259680181742, 0.00862640421837568, 0.00853017717599869, 0.00843396224081516, 0.00833767838776112, 0.00824137218296528, 0.00814504362642765, 0.00804866850376129, 0.00795228220522404, 0.00785589590668678, 0.00775944208726287, 0.00766296498477459, 0.00756645342335105, 0.0074699311517179, 0.00737336277961731, 0.0072768060490489, 0.00718019204214215, 0.00708353286609054, 0.00698687369003892, 0.00689016934484243, 0.00679342960938811, 0.00669670244678855, 0.00659991800785065, 0.00650311075150967, 0.00640625786036253, 0.0063093826174736, 0.00621249619871378, 0.0061155860312283, 0.00601864233613014, 0.00592165300622582, 0.00582462921738625, 0.00572759425267577, 0.00563052529469132, 0.00553346797823906, 0.00543633056804538, 0.00533917080610991, 0.00524199940264225, 0.00514478236436844, 0.00504755368456244, 0.00495031429454684, 0.00485300598666072, 0.00475569814443588, 0.00465833302587271, 0.00456096837297082, 0.00446355761960149, 0.00436614733189344, 0.00426868023350835, 0.00417118985205889, 0.00407367665320635, 0.00397611828520894, 0.0038785373326391, 0.00378096732310951, 0.00368332932703197, 0.00358567968942225, 0.00348798464983702, 0.00339026702567935, 0.00329252611845732, 0.00319474027492106, 0.00309697701595724, 0.00299914553761482, 0.0029012793675065, 0.00280340248718858, 0.00270547973923385, 0.00260754558257759, 0.00250960025005043, 0.00241158646531403, 0.00231357268057764, 0.00221550208516419, 0.00211743148975074, 0.00201931525953114, 0.00192119902931154, 0.00182303739711642, 0.00172483001369983, 0.00162661145441234, 0.00152835878543556, 0.00143007177393883, 0.00133179628755897, 0.0012334524653852, 0.00113509723450989, 0.00103669648524374, 0.000938261568080634, 0.000839826709125191, 0.000741369090974331, 0.000642865896224976, 0.000544328533578664, 0.000445757061243057, 0.000347174209309742, 0.000248545809881762, 0.000149928819155321, 5.12548904225696e-05, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782, 0.0380982719361782   }, 
   { 0.0118942549452186, 0.0119091272354126, 0.0119239995256066, 0.0119389351457357, 0.0119539024308324, 0.0119688687846065, 0.0119838993996382, 0.01199896261096, 0.0120140556246042, 0.0120291821658611, 0.012044339440763, 0.012059529311955, 0.0120747815817595, 0.0120900338515639, 0.0121053177863359, 0.0121206343173981, 0.0121360141783953, 0.0121513931080699, 0.0121668362990022, 0.0121822785586119, 0.0121977860108018, 0.0122133232653141, 0.0122288931161165, 0.0122444946318865, 0.0122601268813014, 0.012275792658329, 0.0122914891690016, 0.0123072173446417, 0.0123229771852493, 0.012338800355792, 0.0123546561226249, 0.0123704792931676, 0.0123863974586129, 0.0124023482203484, 0.0124182989820838, 0.0124343121424317, 0.0124503262341022, 0.0124664343893528, 0.0124825434759259, 0.0124986516311765, 0.0125148240476847, 0.0125310597941279, 0.0125472638756037, 0.012563562951982, 0.0125798620283604, 0.0125962244346738, 0.0126125868409872, 0.0126290135085583, 0.0126454392448068, 0.0126619283109903, 0.012678449973464, 0.0126949707046151, 0.0127115547657013, 0.0127281071618199, 0.0127448188140988, 0.0127614988014102, 0.012778177857399, 0.0127948895096779, 0.0128117268905044, 0.0128285335376859, 0.0128454035148025, 0.0128622418269515, 0.0128791118040681, 0.0128961401060224, 0.0129131367430091, 0.0129300700500607, 0.01294712908566, 0.012964284978807, 0.0129813766106963, 0.0129985641688108, 0.0130156874656677, 0.0130329057574272, 0.0130502199754119, 0.0130674699321389, 0.0130847524851561, 0.0131021291017532, 0.0131195383146405, 0.0131369791924953, 0.0131543884053826, 0.013171860948205, 0.0131894592195749, 0.0132070267572999, 0.0132245309650898, 0.0132421618327498, 0.0132598569616675, 0.0132775818929076, 0.0132952760905027, 0.0133130345493555, 0.0133307920768857, 0.0133487088605762, 0.0133665297180414, 0.0133843831717968, 0.0134023306891322, 0.0134202782064676, 0.0134382890537381, 0.0134563324972987, 0.0134743768721819, 0.0134924817830324, 0.0135106202214956, 0.0135287586599588, 0.0135469604283571, 0.0135652255266905, 0.0135834906250238, 0.0136017883196473, 0.0136201158165932, 0.0136384759098291, 0.0136569002643228, 0.0136753236874938, 0.013693779706955, 0.0137122981250286, 0.0137308165431023, 0.013749398291111, 0.0137680126354098, 0.0137866269797087, 0.01380530372262, 0.0138240437954664, 0.0138427531346679, 0.0138615258038044, 0.013880361802876, 0.0138991978019476, 0.0139180654659867, 0.0139369647949934, 0.0139558957889676, 0.0139748901128769, 0.0139939161017537, 0.0140129430219531, 0.014032032340765, 0.0140511533245444, 0.0140702743083239, 0.0140894595533609, 0.0141086438670754, 0.0141279241070151, 0.0141472034156322, 0.0141665153205395, 0.0141858588904142, 0.0142052657902241, 0.0142246400937438, 0.0142441103234887, 0.0142636122182012, 0.014283113181591, 0.0143026793375611, 0.0143222436308861, 0.0143418414518237, 0.0143615324050188, 0.0143812252208591, 0.0144009171053767, 0.0144206723198295, 0.0144404917955399, 0.0144602786749601, 0.014480160549283, 0.014500011689961, 0.0145199578255415, 0.0145399030297995, 0.014559879899025, 0.0145799219608307, 0.0145999947562814, 0.0146200666204095, 0.0146402027457952, 0.0146603705361485, 0.0146805383265018, 0.0147007694467902, 0.0147210313007236, 0.0147413266822696, 0.0147616527974606, 0.0147820422425866, 0.0148024009540677, 0.0148228537291288, 0.014843275770545, 0.0148637918755412, 0.014884339645505, 0.0149048883467913, 0.0149254994466901, 0.014946143142879, 0.0149667868390679, 0.0149874929338694, 0.0150082306936383, 0.01502900198102, 0.015049803070724, 0.0150706376880407, 0.0150914713740349, 0.0151123991236091, 0.0151333278045058, 0.0151542890816927, 0.0151753127574921, 0.015196368098259, 0.0152174234390259, 0.0152385113760829, 0.0152596309781075, 0.0152808437123895, 0.0153020275756717, 0.0153232729062438, 0.015344550833106, 0.0153658594936132, 0.0153872007504106, 0.0154085736721754, 0.0154299773275852, 0.0154514135792851, 0.0154729131609201, 0.0154944127425551, 0.0155159449204803, 0.0155375069007277, 0.015559165738523, 0.0155807919800282, 0.0156024489551783, 0.0156241394579411, 0.0156459249556065, 0.0156677085906267, 0.0156894940882921, 0.0157113429158926, 0.0157332550734282, 0.015755133703351, 0.0157771091908216, 0.0157990846782923, 0.0158210918307304, 0.0158431623131037, 0.0158652327954769, 0.0158873330801725, 0.0159095320850611, 0.0159316956996918, 0.0159538947045803, 0.0159761551767588, 0.0159984789788723, 0.0160207711160183, 0.0160431265830994, 0.016065513715148, 0.0160879343748093, 0.0161104165017605, 0.0161328669637442, 0.0161554124206305, 0.0161779914051294, 0.0162005368620157, 0.0162231773138046, 0.0162458512932062, 0.0162685234099627, 0.0162912588566542, 0.0163140278309584, 0.0163367949426174, 0.0163596589118242, 0.0163825210183859, 0.0164053849875927, 0.0164283104240894, 0.0164512693881989, 0.0164742898195982, 0.0164973121136427, 0.0165203660726547, 0.0165434498339891, 0.0165666006505489, 0.0165897477418184, 0.0166129600256681, 0.0166362039744854, 0.0166594460606575, 0.0166827533394098, 0.0167060922831297, 0.0167294628918171, 0.016752865165472, 0.0167762991040945, 0.0167997647076845, 0.0168232619762421, 0.0168467592447996, 0.0168703831732273, 0.0168939772993326, 0.0169175993651152, 0.016941225156188, 0.0169650055468082, 0.0169887263327837, 0.0170125085860491, 0.0170362591743469, 0.0170600730925798, 0.0170840471982956, 0.0171079561114311, 0.0171318352222443, 0.0171558074653149, 0.0171798747032881, 0.0172039102762938, 0.0172279477119446, 0.0172520484775305, 0.0172761790454388, 0.0173004064708948, 0.0173246003687382, 0.0173488277941942, 0.0173730850219727, 0.0173974707722664, 0.0174217615276575, 0.0174461454153061, 0.0174705311655998, 0.0174950435757637, 0.0175195559859276, 0.0175440367311239, 0.0175685472786427, 0.0175931230187416, 0.0176177937537432, 0.0176424011588097, 0.0176671035587788, 0.0176918059587479, 0.0177166033536196, 0.0177413690835238, 0.0177661664783955, 0.0177910272032022, 0.017815887928009, 0.0178408436477184, 0.0178657993674278, 0.0178907550871372, 0.0179157741367817, 0.0179408583790064, 0.0179659724235535, 0.017991054803133, 0.0180162321776152, 0.01804144307971, 0.0180666521191597, 0.0180918928235769, 0.0181171670556068, 0.0181425344198942, 0.0181679017841816, 0.0181932710111141, 0.0182187017053366, 0.0182441975921392, 0.0182696599513292, 0.0182951875030994, 0.018320744857192, 0.0183463674038649, 0.0183719899505377, 0.018397644162178, 0.0184233281761408, 0.0184490773826838, 0.0184748563915491, 0.0185006391257048, 0.0185264814645052, 0.0185523573309183, 0.0185782331973314, 0.0186041723936796, 0.0186301432549953, 0.0186561457812786, 0.0186822097748518, 0.0187082458287477, 0.0187343433499336, 0.018760472536087, 0.0187866650521755, 0.0188128892332315, 0.0188391134142876, 0.018865367397666, 0.0188916884362698, 0.0189180392771959, 0.0189443919807673, 0.0189708061516285, 0.0189972836524248, 0.0190237313508987, 0.0190502405166626, 0.0190767496824265, 0.0191033557057381, 0.0191299598664045, 0.0191565956920385, 0.0191832967102528, 0.0192100275307894, 0.0192367285490036, 0.0192635226994753, 0.0192903503775597, 0.0193171761929989, 0.0193440653383732, 0.0193709898740053, 0.0193979106843472, 0.0194249264895916, 0.0194519441574812, 0.0194789618253708, 0.0195060409605503, 0.0195331871509552, 0.0195603296160698, 0.0195875056087971, 0.019614715129137, 0.0196419842541218, 0.0196692869067192, 0.0196965895593166, 0.0197239257395267, 0.0197513531893492, 0.0197787508368492, 0.0198062118142843, 0.0198337063193321, 0.0198611989617348, 0.0198887847363949, 0.0199163742363453, 0.0199439618736506, 0.0199716445058584, 0.0199993588030338, 0.0200270432978868, 0.0200548209249973, 0.0200825985521078, 0.0201104395091534, 0.0201383121311665, 0.0201661866158247, 0.0201940927654505, 0.0202220920473337, 0.0202500615268946, 0.0202780924737453, 0.0203061569482088, 0.0203342512249947, 0.020362377166748, 0.0203905683010817, 0.0204187277704477, 0.0204469803720713, 0.0204752665013075, 0.0205035526305437, 0.0205318704247475, 0.0205602496862411, 0.0205886289477348, 0.0206170734018087, 0.0206455178558826, 0.0206740573048592, 0.0207025986164808, 0.0207311362028122, 0.0207597389817238, 0.0207884050905704, 0.0208170711994171, 0.0208457689732313, 0.0208744984120131, 0.0209032911807299, 0.0209320839494467, 0.0209609400480986, 0.0209897980093956, 0.021018685773015, 0.0210476666688919, 0.0210766177624464, 0.0211056340485811, 0.0211346503347158, 0.021163759753108, 0.0211928691715002, 0.0212219804525375, 0.0212511532008648, 0.021280387416482, 0.0213096253573895, 0.0213388949632645, 0.0213682278990746, 0.0213975571095943, 0.0214269552379847, 0.0214563813060522, 0.0214858073741198, 0.0215152986347675, 0.0215448215603828, 0.0215743444859982, 0.0216039288789034, 0.0216335784643888, 0.0216631945222616, 0.0216929074376822, 0.02172258682549, 0.0217523630708456, 0.0217821393162012, 0.0218119472265244, 0.0218418184667826, 0.0218717213720083, 0.0219016242772341, 0.0219315905123949, 0.0219615567475557, 0.0219915211200714, 0.0220216475427151, 0.022051740437746, 0.022081833332777, 0.0221119597554207, 0.0221422109752893, 0.0221724286675453, 0.022202679887414, 0.0222329329699278, 0.0222632475197315, 0.0222936570644379, 0.0223240368068218, 0.0223544780164957, 0.022384887561202, 0.0224154256284237, 0.0224459618330002, 0.0224765315651894, 0.0225070677697659, 0.0225377641618252, 0.0225684270262718, 0.0225990898907185, 0.0226297862827778, 0.0226605460047722, 0.0226914007216692, 0.0227222219109535, 0.0227530766278505, 0.0227839294821024, 0.0228149425238371, 0.0228458903729916, 0.0228768400847912, 0.0229078866541386, 0.0229389294981956, 0.022970100864768, 0.0230012089014053, 0.023032346740365, 0.0230635497719049, 0.0230948813259602, 0.0231260824948549, 0.0231573805212975, 0.0231887102127075, 0.0232200734317303, 0.0232514981180429, 0.0232829544693232, 0.0233144108206034, 0.0233459305018187, 0.0233774818480015, 0.0234090350568295, 0.0234406497329473, 0.0234722625464201, 0.0235039740800858, 0.0235356837511063, 0.0235673934221268, 0.023599199950695, 0.0236310381442308, 0.0236628409475088, 0.0236947424709797, 0.0237266421318054, 0.023758577182889, 0.0237905718386173, 0.0238226000219584, 0.0238546244800091, 0.0238867159932852, 0.0239188689738512, 0.0239509921520948, 0.0239831805229187, 0.0240153651684523, 0.0240476466715336, 0.0240799281746149, 0.0241122394800186, 0.024144584313035, 0.0241769924759865, 0.024209400638938, 0.0242418386042118, 0.0242743417620659, 0.0243068784475327, 0.0243394132703543, 0.024372011423111, 0.0244046077132225, 0.0244373008608818, 0.0244699958711863, 0.0245026871562004, 0.0245354436337948, 0.0245682634413242, 0.0246010851114988, 0.0246339347213507, 0.0246668197214603, 0.0246997661888599, 0.0247327145189047, 0.0247656926512718, 0.0247987359762192, 0.0248318091034889, 0.0248648822307587, 0.0248980186879635, 0.024931188672781, 0.024964390322566, 0.0249976217746735, 0.0250308867543936, 0.0250641480088234, 0.0250975079834461, 0.0251308977603912, 0.0251642595976591, 0.0251977145671844, 0.025231134146452, 0.0252646841108799, 0.0252982042729855, 0.0253317523747683, 0.0253653638064861, 0.0253990404307842, 0.0254326872527599, 0.0254663955420256, 0.0255001336336136, 0.0255339052528143, 0.0255677085369825, 0.0256015416234732, 0.0256354082375765, 0.02566934004426, 0.0257032699882984, 0.0257372315973043, 0.0257712248712778, 0.0258053112775087, 0.0258393380790949, 0.0258734561502934, 0.0259075779467821, 0.0259417928755283, 0.0259760078042746, 0.0260102227330208, 0.0260445028543472, 0.0260788444429636, 0.0261131562292576, 0.026147561147809, 0.0261819679290056, 0.0262164045125246, 0.0262509044259787, 0.0262854043394327, 0.0263199377804995, 0.0263545345515013, 0.0263891629874706, 0.0264237876981497, 0.0264584813266993, 0.0264932028949261, 0.0265279561281204, 0.0265627428889275, 0.0265975277870893, 0.0266323778778315, 0.0266672912985086, 0.0267022047191858, 0.0267371498048306, 0.0267721563577652, 0.0268071666359901, 0.026842238381505, 0.0268773082643747, 0.0269124116748571, 0.0269475784152746, 0.0269827768206596, 0.0270179752260447, 0.0270532369613647, 0.0270885638892651, 0.0271238554269075, 0.0271592456847429, 0.0271946024149656, 0.0272300522774458, 0.0272655058652163, 0.0273009892553091, 0.0273365043103695, 0.0273721143603325, 0.0274076946079731, 0.0274433046579361, 0.0274789799004793, 0.0275146849453449, 0.0275504216551781, 0.0275861583650112, 0.0276219584047794, 0.0276577919721603, 0.0276936888694763, 0.0277295522391796, 0.0277654808014631, 0.0278014708310366, 0.0278374627232552, 0.0278734862804413, 0.0279095396399498, 0.0279456563293934, 0.0279818084090948, 0.0280179567635059, 0.0280541703104973, 0.0280904155224562, 0.0281266923993826, 0.028162969276309, 0.0281993076205254, 0.0282356813549995, 0.0282721146941185, 0.0283085498958826, 0.0283449850976467, 0.0283815152943134, 0.0284180771559477, 0.0284546390175819, 0.0284912325441837, 0.0285278577357531, 0.0285645462572575, 0.0286012664437294, 0.0286379884928465, 0.0286747720092535, 0.0287116188555956, 0.0287484657019377, 0.0287853144109249, 0.0288222227245569, 0.0288591347634792, 0.0288961734622717, 0.0289331786334515, 0.0289702154695988, 0.0290072523057461, 0.0290444176644087, 0.0290815513581038, 0.0291187465190887, 0.0291559118777514, 0.0291931387037039, 0.0292304940521717, 0.0292677842080593, 0.0293051078915596, 0.0293424930423498, 0.0293799769133329, 0.0294174253940582, 0.0294548757374287, 0.029492387548089, 0.0295299347490072, 0.0295675750821829, 0.0296051502227783, 0.029642790555954, 0.0296804923564196, 0.0297182612121105, 0.0297559630125761, 0.0297937635332346, 0.0298315603286028, 0.0298694856464863, 0.0299073476344347, 0.0299452412873507, 0.0299831982702017, 0.0300212204456329, 0.0300592724233866, 0.0300972927361727, 0.0301354080438614, 0.0301734916865826, 0.0302117355167866, 0.0302498824894428, 0.0302880927920341, 0.0303263682872057, 0.0303646400570869, 0.0304030124098063, 0.0304413475096226, 0.0304797496646643, 0.0305181834846735, 0.0305566787719727, 0.0305951423943043, 0.0306336712092161, 0.030672263354063, 0.0307108536362648, 0.0307495091110468, 0.0307881645858288, 0.0308268498629332, 0.0308656003326178, 0.0309043824672699, 0.0309431627392769, 0.0309820100665092, 0.0310208853334188, 0.031059792265296, 0.031098734587431, 0.0311376731842756, 0.0311767086386681, 0.0312157440930605, 0.0312548093497753, 0.031293909996748, 0.0313330702483654, 0.0313722342252731, 0.0314114578068256, 0.0314506851136684, 0.0314899422228336, 0.0315292924642563, 0.0315686464309692, 0.0316080003976822, 0.0316474176943302, 0.0316868610680103, 0.0317263416945934, 0.0317658521234989, 0.0318053625524044, 0.0318449698388577, 0.0318846069276333, 0.0319242142140865, 0.0319639183580875, 0.0320036485791206, 0.032043382525444, 0.0320831798017025, 0.0321229733526707, 0.0321628339588642, 0.0322027243673801, 0.0322426483035088, 0.0322825722396374, 0.0323225893080235, 0.0323626063764095, 0.0324026606976986, 0.0324427410960197, 0.032482884824276, 0.0325230322778225, 0.0325632058084011, 0.0326034165918827, 0.0326436869800091, 0.0326839908957481, 0.0327242948114872, 0.0327646620571613, 0.0328050591051579, 0.0328454598784447, 0.0328859202563763, 0.0329264178872108, 0.0329669415950775, 0.0330075323581696, 0.0330481193959713, 0.0330887101590633, 0.0331293940544128, 0.0331701077520847, 0.0332108251750469, 0.0332515724003315, 0.0332923531532288, 0.0333332270383835, 0.0333740711212158, 0.0334149450063705, 0.0334558822214603, 0.0334968827664852, 0.0335378535091877, 0.0335788875818253, 0.0336199514567852, 0.0336610786616802, 0.0337022058665752, 0.0337433665990829, 0.0337845608592033, 0.0338258147239685, 0.0338671021163464, 0.0339083895087242, 0.0339497067034245, 0.0339911207556725, 0.0340325012803078, 0.0340739451348782, 0.0341153927147388, 0.0341568998992443, 0.0341984704136848, 0.034240011125803, 0.0342816151678562, 0.0343232862651348, 0.0343649499118328, 0.0344066508114338, 0.0344484113156796, 0.0344901755452156, 0.0345319993793964, 0.0345738269388676, 0.0346156843006611, 0.0346576385200024, 0.0346995890140533, 0.0347415432333946, 0.0347835570573807, 0.0348256044089794, 0.0348676852881908, 0.0349097959697247, 0.0349519401788712, 0.0349941439926624, 0.035036351531744, 0.035078588873148, 0.0351208597421646, 0.0351631939411163, 0.0352055244147778, 0.0352479219436646, 0.0352903492748737, 0.0353327803313732, 0.0353752709925175, 0.0354177951812744, 0.0354603491723537, 0.0355029366910458, 0.0355455875396729, 0.0355882048606873, 0.0356308855116367, 0.0356735996901989, 0.0357163771986961, 0.0357591882348061, 0.0358019657433033, 0.035844836384058, 0.0358877405524254, 0.0359306447207928, 0.0359736122190952, 0.0360166095197201, 0.0360596403479576, 0.0361027009785175, 0.0361457988619804, 0.0361888892948627, 0.0362320803105831, 0.0362752713263035, 0.0363184921443462, 0.0363617464900017, 0.0364050902426243, 0.0364483781158924, 0.0364917553961277, 0.0365351364016533, 0.0365785174071789, 0.036622054874897, 0.0366655290126801, 0.0367090664803982, 0.0367526039481163, 0.0367962382733822, 0.0368398725986481, 0.0368835367262363, 0.0369272343814373, 0.0369709953665733, 0.0370147526264191, 0.0370585471391678, 0.0371023677289486, 0.0371462255716324, 0.0371901728212833, 0.0372340939939022, 0.0372780449688435, 0.0373220257461071, 0.0373661331832409, 0.0374101772904396, 0.0374542884528637, 0.0374983958899975, 0.037542536854744, 0.0375868044793606, 0.0376310758292675, 0.0376752763986588, 0.0377195738255978, 0.0377640016376972, 0.0378083623945713, 0.0378527268767357, 0.0378971882164478, 0.0379416421055794, 0.037986196577549, 0.0380307175219059, 0.0380752682685852, 0.0381198897957802, 0.0381645634770393, 0.0382092148065567, 0.0382539592683315, 0.0382986702024937, 0.038343507796526, 0.0383882783353329, 0.0384331233799458, 0.0384780243039131, 0.0385229252278805, 0.0385678894817829, 0.038612887263298, 0.0386578813195229, 0.0387029089033604, 0.0387480333447456, 0.0387931615114212, 0.0388382822275162, 0.0388834699988365, 0.0389286875724792, 0.0389739684760571, 0.0390192531049252, 0.0390645675361156, 0.0391099117696285, 0.0391553193330765, 0.0392007306218147, 0.0392462015151978, 0.0392917096614838, 0.0393372103571892, 0.03938277810812, 0.0394283756613731, 0.0394739769399166, 0.0395196713507175, 0.0395653657615185, 0.0396110601723194, 0.0396568514406681, 0.0397026725113392, 0.0397484600543976, 0.0397943444550037, 0.0398401990532875, 0.0398861765861511, 0.0399321280419827, 0.0399781055748463, 0.0400241501629353, 0.0400702208280563, 0.0401163287460804, 0.0401624366641045, 0.0402086079120636, 0.0402548089623451, 0.0403010733425617, 0.0403473414480686, 0.0403936058282852, 0.0404399670660496, 0.0404863581061363, 0.0405327156186104, 0.0405791737139225, 0.0406256578862667, 0.0406721495091915, 0.0407187007367611, 0.0407652519643307, 0.040811862796545, 0.0408585071563721, 0.0409051850438118, 0.0409518964588642, 0.040998637676239, 0.0410454086959362, 0.0410922132432461, 0.0411390513181686, 0.0411859191954136, 0.0412328504025936, 0.041279811412096, 0.041326742619276, 0.0413737669587135, 0.0414208248257637, 0.0414678826928139, 0.0415150038897991, 0.0415621288120747, 0.0416093431413174, 0.0416565574705601, 0.0417037792503834, 0.0417510904371738, 0.041798435151577, 0.0418457463383675, 0.0418931171298027, 0.0419405587017536, 0.0419880300760269, 0.0420355014503002, 0.0420829989016056, 0.042130533605814, 0.0421781614422798, 0.0422257892787457, 0.0422734171152115, 0.0423211120069027, 0.0423688367009163, 0.0424165911972523, 0.0424643792212009, 0.0425121672451496, 0.0425600484013557, 0.0426079295575619, 0.0426558442413807, 0.0427038222551346, 0.0427518337965012, 0.0427998416125774, 0.0428478829562664, 0.0428959876298904, 0.0429441221058369, 0.042992290109396, 0.0430404581129551, 0.0430886894464493, 0.0431369505822659, 0.0431852787733078, 0.0432335734367371, 0.0432819314301014, 0.0433303229510784, 0.0433787778019905, 0.043427225202322, 0.0434757135808468, 0.0435242280364037, 0.0435728430747986, 0.0436214543879032, 0.0436700657010078, 0.0437187068164349, 0.0437674485146999, 0.043816152960062, 0.0438649244606495, 0.0439137257635593, 0.0439625605940819, 0.0440114587545395, 0.0440603271126747, 0.0441092513501644, 0.0441582798957825, 0.0442072376608849, 0.044256292283535, 0.0443053506314754, 0.0443544685840607, 0.0444036200642586, 0.0444528013467789, 0.0445019826292992, 0.0445512309670448, 0.0446005091071129, 0.0446498170495033, 0.0446991585195065, 0.0447485633194447, 0.0447979345917702, 0.0448473393917084, 0.0448968410491943, 0.04494633898139, 0.0449959002435207, 0.0450454689562321, 0.0450950935482979, 0.0451447181403637, 0.0451944097876549, 0.0452441275119781, 0.045293852686882, 0.0453436672687531, 0.045393455773592, 0.0454433336853981, 0.0454931780695915, 0.0455431267619133, 0.0455930717289448, 0.0456430464982986, 0.0456930510699749, 0.0457430891692638, 0.0457931943237782, 0.0458433255553246, 0.0458934605121613, 0.0459436550736427, 0.0459938868880272, 0.0460441149771214, 0.0460944101214409, 0.0461447350680828, 0.0461950860917568, 0.0462454780936241, 0.0462959297001362, 0.0463463477790356, 0.0463968589901924, 0.0464474074542522, 0.0464979223906994, 0.0465485267341137, 0.0465991720557213, 0.0466498136520386, 0.0467005148530006, 0.0467512235045433, 0.0468019917607307, 0.0468527898192406, 0.0469036214053631, 0.0469544865190983, 0.0470053777098656, 0.0470563061535358, 0.0471072681248188, 0.0471582561731339, 0.047209307551384, 0.0472603626549244, 0.0473114438354969, 0.0473625957965851, 0.047413744032383, 0.0474649593234062, 0.0475162006914616, 0.0475674420595169, 0.0476187467575073, 0.047670092433691, 0.0477214604616165, 0.0477728620171547, 0.0478242933750153, 0.0478757955133915, 0.0479272902011871, 0.0479788221418858, 0.0480303801596165, 0.0480820052325726, 0.0481336303055286, 0.0481852889060974, 0.0482370033860207, 0.0482887551188469, 0.0483405403792858, 0.0483923219144344, 0.0484441705048084, 0.0484960786998272, 0.0485479533672333, 0.048599898815155, 0.0486518703401089, 0.0487038753926754, 0.048755943775177, 0.0488080121576786, 0.0488601103425026, 0.0489122420549393, 0.0489644706249237, 0.0490166656672955, 0.0490688905119896, 0.0491211824119091, 0.0491734705865383, 0.0492258556187153, 0.0492782108485699, 0.0493306256830692, 0.0493830777704716, 0.0494355857372284, 0.0494881011545658, 0.0495406463742256, 0.0495932213962078, 0.0496458560228348, 0.0496984981000423, 0.049751166254282, 0.049803901463747, 0.0498566403985023, 0.0499094650149345, 0.0499622635543346, 0.0500151254236698, 0.050067987293005, 0.0501209422945976, 0.0501738972961903, 0.0502268858253956, 0.0502798743546009, 0.050332922488451, 0.0503860712051392, 0.0504391528666019, 0.0504923313856125, 0.050545509904623, 0.0505987517535686, 0.0506519936025143, 0.050705298781395, 0.0507586039602757, 0.0508119724690914, 0.0508654043078423, 0.0509188026189804, 0.0509722679853439, 0.0510257631540298, 0.0510793216526508, 0.0511328801512718, 0.0511864721775055, 0.0512400940060616, 0.0512937791645527, 0.0513474605977535, 0.0514011792838573, 0.0514549612998962, 0.0515087731182575, 0.0515625812113285, 0.0516164600849152, 0.0516703687608242, 0.0517243035137653, 0.0517782755196095, 0.051832277327776, 0.0518863126635551, 0.0519403479993343, 0.0519945099949837, 0.0520486384630203, 0.0521028004586697, 0.0521569922566414, 0.0522112473845482, 0.0522655062377453, 0.0523198246955872, 0.0523741468787193, 0.052428562194109, 0.0524829402565956, 0.0525373890995979, 0.0525918677449226, 0.0526463761925697, 0.0527009181678295, 0.0527554899454117, 0.0528100952506065, 0.0528647676110268, 0.0529194325208664, 0.0529741309583187, 0.053028866648674, 0.0530836917459965, 0.0531384870409966, 0.0531933158636093, 0.0532482042908669, 0.0533031560480595, 0.05335808172822, 0.0534130670130253, 0.053468082100153, 0.0535231307148933, 0.0535782165825367, 0.0536333248019218, 0.05368847027421, 0.0537436790764332, 0.0537989139556885, 0.0538541562855244, 0.0539094246923923, 0.0539647303521633, 0.0540201291441917, 0.0540754944086075, 0.0541308932006359, 0.0541863553225994, 0.0542418770492077, 0.0542973689734936, 0.0543529242277145, 0.0544085130095482, 0.0544641353189945, 0.0545198172330856, 0.054575502872467, 0.0546312145888805, 0.0546869933605194, 0.054742805659771, 0.0547986142337322, 0.0548544563353062, 0.0549103617668152, 0.0549662671983242, 0.0550222657620907, 0.0550782345235348, 0.0551342666149139, 0.0551903285086155, 0.0552464574575424, 0.0553025528788567, 0.0553587451577187, 0.0554149001836777, 0.0554711855947971, 0.0555274412035942, 0.0555837266147137, 0.0556400455534458, 0.055696427822113, 0.0557528398931026, 0.0558092817664146, 0.0558657273650169, 0.055922232568264, 0.0559787750244141, 0.0560353435575962, 0.0560919493436813, 0.0561485812067986, 0.0562052503228188, 0.0562619790434837, 0.0563187040388584, 0.0563754662871361, 0.0564322620630264, 0.0564891174435616, 0.0565460063517094, 0.0566028915345669, 0.0566598474979401, 0.0567168295383453, 0.056773841381073, 0.0568308606743813, 0.056887935847044, 0.0569450482726097, 0.0570022240281105, 0.0570593923330307, 0.0571165680885315, 0.0571738071739674, 0.0572311356663704, 0.0572884380817413, 0.0573457702994347, 0.0574031323194504, 0.0574605949223042, 0.0575180202722549, 0.0575755089521408, 0.057633001357317, 0.0576905868947506, 0.0577481724321842, 0.0578057616949081, 0.0578634068369865, 0.0579211190342903, 0.0579788312315941, 0.0580365769565105, 0.0580943524837494, 0.0581521913409233, 0.0582100674510002, 0.0582679361104965, 0.0583258382976055, 0.0583838373422623, 0.0584418028593063, 0.0584998019039631, 0.0585578605532646, 0.0586159862577915, 0.058674082159996, 0.058732271194458, 0.0587904267013073, 0.0588486790657043, 0.0589069314301014, 0.0589652135968208, 0.0590235255658627, 0.0590819343924522, 0.0591403171420097, 0.0591987259685993, 0.0592571683228016, 0.0593156702816486, 0.0593742430210114, 0.0594327785074711, 0.0594913773238659, 0.0595500096678734, 0.0596086755394936, 0.0596673712134361, 0.0597260966897011, 0.059784859418869, 0.0598436817526817, 0.0599025003612041, 0.0599613599479198, 0.0600202418863773, 0.0600791946053505, 0.0601381734013557, 0.0601971857249737, 0.0602562017738819, 0.0603152774274349, 0.06037437915802, 0.0604335218667984, 0.0604926906526089, 0.0605518966913223, 0.0606110990047455, 0.0606703981757164, 0.0607297271490097, 0.0607890263199806, 0.060848418623209, 0.0609078444540501, 0.0609672702848911, 0.0610267259180546, 0.0610862448811531, 0.0611457675695419, 0.0612053833901882, 0.0612649954855442, 0.0613246113061905, 0.0613842904567719, 0.061444029211998, 0.0615037754178047, 0.0615635477006435, 0.0616233199834824, 0.0616831928491592, 0.0617430880665779, 0.0618029907345772, 0.0618629232048988, 0.0619229227304459, 0.061982948333025, 0.0620429739356041, 0.0621030665934086, 0.0621631592512131, 0.062223345041275, 0.0622835271060467, 0.0623437464237213, 0.062403965741396, 0.0624642446637154, 0.0625245943665504, 0.0625849366188049, 0.0626453086733818, 0.0627057179808617, 0.0627662241458893, 0.0628266930580139, 0.0628871917724609, 0.0629477649927139, 0.0630083605647087, 0.0630689933896065, 0.063129648566246, 0.0631903111934662, 0.0632510706782341, 0.0633118227124214, 0.0633726194500923, 0.063433438539505, 0.0634943172335625, 0.0635552033782005, 0.063616119325161, 0.0636770650744438, 0.0637381076812744, 0.0637991204857826, 0.0638601630926132, 0.0639212355017662, 0.0639824047684669, 0.0640435740351677, 0.0641047433018684, 0.064165972173214, 0.0642272755503654, 0.0642885640263557, 0.0643498972058296, 0.0644112527370453, 0.0644726753234863, 0.0645340979099274, 0.0645955577492714, 0.0646570399403572, 0.0647185891866684, 0.064780168235302, 0.0648417845368385, 0.0649034008383751, 0.0649650394916534, 0.0650267824530602, 0.0650885179638863, 0.0651502907276154, 0.0652120932936668, 0.0652739331126213, 0.0653358027338982, 0.0653977319598198, 0.0654596611857414, 0.0655216500163078, 0.0655836462974548, 0.0656456723809242, 0.0657077580690384, 0.0657698437571526, 0.0658320337533951, 0.0658941864967346, 0.0659563988447189, 0.0660186409950256, 0.0660809203982353, 0.066143237054348, 0.0662055760622025, 0.0662679523229599, 0.0663303881883621, 0.0663928240537643, 0.0664552971720695, 0.0665178000926971, 0.0665803626179695, 0.0666429549455643, 0.0667055547237396, 0.0667682141065598, 0.0668308734893799, 0.0668936297297478, 0.0669563785195351, 0.0670191720128059, 0.0670819580554962, 0.0671448037028313, 0.0672077164053917, 0.0672706291079521, 0.0673335716128349, 0.0673965513706207, 0.0674595907330513, 0.0675226598978043, 0.0675857365131378, 0.0676488354802132, 0.0677120015025139, 0.0677752047777176, 0.0678384304046631, 0.0679016932845116, 0.06796495616436, 0.0680283159017563, 0.0680916681885719, 0.0681550577282906, 0.0682184770703316, 0.068281963467598, 0.0683454498648643, 0.0684089586138725, 0.0684725120663643, 0.0685360878705978, 0.0685997605323792, 0.0686634033918381, 0.0687271133065224, 0.0687908157706261, 0.0688546225428581, 0.0689184218645096, 0.068982221186161, 0.0690460875630379, 0.0691100135445595, 0.0691739395260811, 0.0692378953099251, 0.0693018957972527, 0.0693659409880638, 0.0694300308823586, 0.0694941207766533, 0.0695582404732704, 0.0696224495768547, 0.0696866288781166, 0.0697508454322815, 0.0698151215910912, 0.0698794648051262, 0.0699437707662582, 0.0700081437826157, 0.0700725466012955, 0.0701369792222977, 0.0702014788985252, 0.0702659785747528, 0.0703305080533028, 0.0703950747847557, 0.0704597234725952, 0.0705243498086929, 0.070589005947113, 0.0706537291407585, 0.0707184821367264, 0.0707832649350166, 0.0708480477333069, 0.0709128975868225, 0.0709778070449829, 0.0710427165031433, 0.0711076632142067, 0.0711726322770119, 0.071237675845623, 0.0713027119636536, 0.0713677853345871, 0.0714328810572624, 0.0714980810880661, 0.0715632438659668, 0.0716284438967705, 0.0716936960816383, 0.0717590227723122, 0.071824312210083, 0.0718896687030792, 0.0719550251960754, 0.0720204412937164, 0.0720859244465828, 0.0721543729305267, 0.0722257420420647, 0.0722971484065056, 0.0723685920238495, 0.0724400281906128, 0.0725114792585373, 0.0725829899311066, 0.0726544931530952, 0.0727260261774063, 0.0727975964546204, 0.0728691667318344, 0.0729407742619514, 0.0730124115943909, 0.0730840265750885, 0.0731557011604309, 0.0732273906469345, 0.0732991099357605, 0.0733708441257477, 0.0734425857663155, 0.0735143572092056, 0.0735861733555794, 0.0736579969525337, 0.0737298205494881, 0.0738017037510872, 0.0738735795021057, 0.0739454999566078, 0.0740174427628517, 0.0740893855690956, 0.0741613507270813, 0.0742333456873894, 0.0743053779006004, 0.0743774175643921, 0.0744494795799255, 0.0745215639472008, 0.0745936930179596, 0.0746658146381378, 0.0747379660606384, 0.0748101323843002, 0.0748823136091232, 0.0749545469880104, 0.0750267803668976, 0.0750990435481071, 0.0751713216304779, 0.0752436593174934, 0.0753159672021866, 0.0753883048892021, 0.0754606872797012, 0.0755330920219421, 0.075605496764183, 0.0756779313087463, 0.0757503807544708, 0.0758228898048401, 0.0758953914046288, 0.075967900454998, 0.0760404467582703, 0.0761130601167679, 0.0761856287717819, 0.0762582495808601, 0.0763308852910995, 0.076403521001339, 0.0764762312173843, 0.0765489265322685, 0.0766216367483139, 0.0766943842172623, 0.0767671689391136, 0.0768399462103844, 0.0769127756357193, 0.076985590159893, 0.077058456838131, 0.0771313458681107, 0.0772042348980904, 0.0772771462798119, 0.0773501396179199, 0.0774230733513832, 0.0774960592389107, 0.0775690749287605, 0.0776421204209328, 0.077715165913105, 0.0777882486581802, 0.0778613314032555, 0.0779344737529755, 0.0780076161026955, 0.0780807510018349, 0.0781539678573608, 0.0782271772623062, 0.0783004090189934, 0.0783736556768417, 0.0784469246864319, 0.0785202458500862, 0.0785935521125793, 0.0786668807268143, 0.0787402391433716, 0.0788136646151543, 0.0788870602846146, 0.0789604708552361, 0.0790339335799217, 0.0791073963046074, 0.0791809111833572, 0.0792544335126877, 0.0793279483914375, 0.0794015228748322, 0.079475112259388, 0.079548716545105, 0.0796223357319832, 0.0796959847211838, 0.0797696560621262, 0.0798433795571327, 0.0799170732498169, 0.0799907967448235, 0.0800645798444748, 0.0801383629441261, 0.0802121534943581, 0.0802859961986542, 0.0803598314523697, 0.080433689057827, 0.0805076211690903, 0.0805815160274506, 0.0806554406881332, 0.0807294026017189, 0.080803394317627, 0.080877386033535, 0.0809514373540878, 0.0810254737734795, 0.0810995250940323, 0.0811736211180687, 0.0812477469444275, 0.0813218727707863, 0.0813960209488869, 0.0814701989293098, 0.081544429063797, 0.0816186368465424, 0.0816928818821907, 0.0817671492695808, 0.0818414464592934, 0.0819157585501671, 0.0819900780916214, 0.0820644274353981, 0.0821388214826584, 0.0822132155299187, 0.0822876319289207, 0.082362063229084, 0.0824365541338921, 0.0825110301375389, 0.082585521042347, 0.0826600715517998, 0.0827346071600914, 0.0828092098236084, 0.0828837901353836, 0.0829584077000618, 0.0830330327153206, 0.0831077396869659, 0.0831824094057083, 0.0832571238279343, 0.0833318457007408, 0.0834066122770309, 0.0834813863039017, 0.0835561752319336, 0.0836309716105461, 0.083705835044384, 0.0837807059288025, 0.0838555619120598, 0.0839304774999619, 0.0840054154396057, 0.084080345928669, 0.084155336022377, 0.0842303261160851, 0.0843053534626961, 0.0843803882598877, 0.0844554379582405, 0.0845305174589157, 0.0846056416630745, 0.0846807733178139, 0.0847559124231339, 0.0848310738801956, 0.0849062874913216, 0.0849814713001251, 0.0850567296147346, 0.085131973028183, 0.0852072834968567, 0.085282564163208, 0.0853578895330429, 0.0854332372546196, 0.0855086296796799, 0.0855839997529984, 0.0856594070792198, 0.0857348442077637, 0.0858103185892105, 0.0858858078718185, 0.0859612971544266, 0.0860367864370346, 0.0861123353242874, 0.0861879363656044, 0.0862634927034378, 0.0863391309976578, 0.0864147320389748, 0.0864904075860977, 0.0865661054849625, 0.0866417810320854, 0.0867174863815308, 0.0867932662367821, 0.0868690088391304, 0.0869448035955429, 0.0870206132531166, 0.0870964452624321, 0.0871723145246506, 0.0872481688857079, 0.0873240679502487, 0.0874000042676926, 0.087475948035717, 0.0875518918037415, 0.0876278951764107, 0.0877038985490799, 0.0877799093723297, 0.0878559947013855, 0.0879320502281189, 0.0880081504583359, 0.0880842655897141, 0.0881603956222534, 0.0882365554571152, 0.0883127450942993, 0.0883889496326447, 0.0884651690721512, 0.0885414481163025, 0.0886177122592926, 0.0886939838528633, 0.0887703150510788, 0.0888466611504555, 0.0889230370521545, 0.0889993980526924, 0.0890757963061333, 0.0891522243618965, 0.0892286896705627, 0.0893051475286484, 0.0893816351890564, 0.0894581377506256, 0.089534692466259, 0.0896112620830536, 0.0896878242492676, 0.089764416217804, 0.0898410677909851, 0.0899177119135857, 0.0899943709373474, 0.0900710672140121, 0.0901477634906769, 0.0902245193719864, 0.0903012827038765, 0.090378038585186, 0.0904548466205597, 0.0905316919088364, 0.0906085073947906, 0.0906853973865509, 0.09076227247715, 0.0908391922712326, 0.0909161418676376, 0.0909930691123009, 0.0910700485110283, 0.0911470651626587, 0.0912240818142891, 0.0913011208176613, 0.0913781896233559, 0.0914552956819534, 0.0915323942899704, 0.0916095301508904, 0.0916866660118103, 0.091763861477375, 0.0918410643935204, 0.0919182598590851, 0.091995507478714, 0.0920727923512459, 0.0921500623226166, 0.0922273620963097, 0.0923046916723251, 0.0923820436000824, 0.0924594327807426, 0.0925368145108223, 0.0926142334938049, 0.09269168227911, 0.0927691534161568, 0.0928466394543648, 0.0929241254925728, 0.0930016413331032, 0.0930792316794395, 0.0931567922234535, 0.0932343751192093, 0.0933119654655457, 0.0933896452188492, 0.0934673100709915, 0.0935449525713921, 0.0936226695775986, 0.0937004238367081, 0.0937781557440758, 0.0938559174537659, 0.0939337164163589, 0.0940115377306938, 0.0940893813967705, 0.0941672250628471, 0.0942450985312462, 0.09432303160429, 0.0944009497761726, 0.0944788902997971, 0.0945568531751633, 0.0946348309516907, 0.0947128683328629, 0.0947909131646156, 0.094868928194046, 0.0949470400810242, 0.0950251370668411, 0.0951032489538193, 0.0951813980937004, 0.0952595621347427, 0.0953377410769463, 0.0954159647226334, 0.0954941958189011, 0.0955724492669106, 0.0956507250666618, 0.0957290306687355, 0.095807358622551, 0.0958857014775276, 0.0959640666842461, 0.0960424467921257, 0.0961208641529083, 0.0961992815136909, 0.0962777510285378, 0.0963562205433846, 0.0964347049593925, 0.0965132340788841, 0.0965917930006981, 0.0966703370213509, 0.0967489257454872, 0.096827544271946, 0.0969061776995659, 0.0969848036766052, 0.0970634892582893, 0.0971421971917152, 0.0972208976745605, 0.0972996354103088, 0.0973784029483795, 0.0974572077393532, 0.0975360050797462, 0.0976148396730423, 0.0976936742663383, 0.0977725386619568, 0.0978514552116394, 0.0979303792119026, 0.0980092957615852, 0.0980882421135902, 0.0981672555208206, 0.0982462540268898, 0.0983252748847008, 0.0984043180942535, 0.0984834060072899, 0.0985624939203262, 0.098641611635685, 0.0987207293510437, 0.0987998992204666, 0.0988790988922119, 0.0989582911133766, 0.0990374982357025, 0.0991167575120926, 0.0991960391402245, 0.0992753133177757, 0.0993546098470688, 0.0994339734315872, 0.0995133444666862, 0.0995926931500435, 0.0996720939874649, 0.0997515171766281, 0.0998309850692749, 0.0999104306101799, 0.0999899208545685, 0.100069426000118, 0.100148990750313, 0.100228525698185, 0.100308112800121, 0.100387692451477, 0.100467346608639, 0.100546978414059, 0.10062663257122, 0.100706309080124, 0.100786045193672, 0.10086578130722, 0.100945524871349, 0.10102529078722, 0.101105101406574, 0.101184919476509, 0.101264752447605, 0.101344622671604, 0.101424530148506, 0.101504422724247, 0.10158433765173, 0.101664297282696, 0.101744286715984, 0.101824291050434, 0.101904287934303, 0.101984336972237, 0.102064400911331, 0.102144464850426, 0.102224580943584, 0.102304711937904, 0.102384865283966, 0.10246504098177, 0.102545231580734, 0.102625444531441, 0.102705672383308, 0.102785967290401, 0.102866232395172, 0.102946519851685, 0.103026859462261, 0.103107191622257, 0.103187583386898, 0.103267975151539, 0.103348396718502, 0.103428818285465, 0.103509284555912, 0.10358976572752, 0.103670246899128, 0.1037507802248, 0.103831321001053, 0.103911899030209, 0.103992491960526, 0.104073114693165, 0.104153737425804, 0.104234412312508, 0.10431507229805, 0.104395784437656, 0.104476518929005, 0.104557231068611, 0.104638002812862, 0.104718796908855, 0.104799620807171, 0.104880452156067, 0.104961298406124, 0.105042159557343, 0.105123080313206, 0.105203993618488, 0.105284959077835, 0.10536590218544, 0.10544690489769, 0.10552791506052, 0.105608940124512, 0.105689987540245, 0.105771072208881, 0.105852171778679, 0.105933301150799, 0.10601444542408, 0.106095597147942, 0.106176786124706, 0.106257997453213, 0.1063392162323, 0.106420487165451, 0.106501743197441, 0.106583058834076, 0.106664352118969, 0.106745705008507, 0.106827065348625, 0.106908440589905, 0.106989845633507, 0.107071287930012, 0.107152737677097, 0.107234202325344, 0.107315704226494, 0.107397221028805, 0.107478752732277, 0.10756029933691, 0.107641912996769, 0.107723489403725, 0.107805132865906, 0.107886768877506, 0.10796844214201, 0.108050145208836, 0.108131863176823, 0.108213596045971, 0.108295351266861, 0.108377136290073, 0.108458951115608, 0.108540758490562, 0.108622618019581, 0.108704477548599, 0.108786374330521, 0.108868278563023, 0.108950227499008, 0.109032176434994, 0.109114162623882, 0.109196171164513, 0.109278187155724, 0.109360225498676, 0.109442301094532, 0.109524384140968, 0.109606496989727, 0.109688632190228, 0.10977079719305, 0.109852954745293, 0.10993517190218, 0.110017381608486, 0.110099658370018, 0.110181897878647, 0.110264182090759, 0.110346496105194, 0.110428810119629, 0.110511183738708, 0.110593557357788, 0.110675953328609, 0.110758356750011, 0.110840827226639, 0.110923260450363, 0.111005768179893, 0.111088275909424, 0.111170805990696, 0.111253343522549, 0.111335925757885, 0.111418522894382, 0.111501157283783, 0.111583769321442, 0.111666440963745, 0.11174912750721, 0.111831828951836, 0.111914560198784, 0.111997298896313, 0.112080089747906, 0.112162865698338, 0.112245693802834, 0.11232852935791, 0.112411379814148, 0.112494274973869, 0.11257716268301, 0.112660109996796, 0.112743049860001, 0.112826034426689, 0.112909004092216, 0.112992033362389, 0.113075070083141, 0.113158144056797, 0.113241203129292, 0.113324321806431, 0.113407425582409, 0.113490574061871, 0.113573752343655, 0.1136569455266, 0.113740161061287, 0.113823391497135, 0.113906651735306, 0.113989926874638, 0.114073224365711, 0.114156551659107, 0.114239893853664, 0.114323258399963, 0.114406652748585, 0.114490061998367, 0.114573493599892, 0.114656962454319, 0.114740431308746, 0.114823922514915, 0.114907450973988, 0.114991001784801, 0.115074567496777, 0.115158148109913, 0.115241773426533, 0.115325391292572, 0.115409053862095, 0.115492723882198, 0.115576416254044, 0.115660138428211, 0.115743905305862, 0.115827634930611, 0.115911446511745, 0.1159952506423, 0.116079092025757, 0.116162940859795, 0.116246812045574, 0.116330698132515, 0.116414621472359, 0.116498559713364, 0.116582527756691, 0.116666503250599, 0.11675052344799, 0.116834536194801, 0.116918586194515, 0.117002673447132, 0.11708677560091, 0.117170862853527, 0.11725502461195, 0.117339178919792, 0.117423363029957, 0.117507562041283, 0.11759178340435, 0.117676042020321, 0.11776028573513, 0.117844596505165, 0.117928899824619, 0.118013262748718, 0.118097610771656, 0.118181996047497, 0.118266396224499, 0.118350811302662, 0.118435271084309, 0.118519738316536, 0.118604220449924, 0.118688747286797, 0.118773274123669, 0.118857838213444, 0.11894241720438, 0.119027033448219, 0.119111649692059, 0.119196303188801, 0.119280956685543, 0.119365654885769, 0.119450353085995, 0.119535088539124, 0.119619846343994, 0.119704604148865, 0.119789429008961, 0.119874231517315, 0.119959093630314, 0.120043948292732, 0.120128840208054, 0.120213754475117, 0.120298683643341, 0.120383620262146, 0.120468601584435, 0.120553597807884, 0.120638616383076, 0.12072367221117, 0.120808720588684, 0.120893813669682, 0.120978929102421, 0.121064051985741, 0.121149204671383, 0.121234364807606, 0.121319569647312, 0.121404804289341, 0.121490016579628, 0.12157528847456, 0.121660575270653, 0.121745869517326, 0.121831208467484, 0.121916554868221, 0.122001931071281, 0.122087337076664, 0.122172750532627, 0.122258171439171, 0.122343651950359, 0.122429117560387, 0.122514635324478, 0.12260015308857, 0.122685723006725, 0.122771270573139, 0.122856862843037, 0.122942477464676, 0.123028121888638, 0.12311377376318, 0.123199462890625, 0.123285174369812, 0.12337089329958, 0.123456634581089, 0.123542428016663, 0.123628206551075, 0.12371402233839, 0.123799853026867, 0.123885706067085, 0.123971588909626, 0.124057486653328, 0.124143414199352, 0.124229364097118, 0.124315328896046, 0.124401323497295, 0.124487325549126, 0.12457337230444, 0.124659433960915, 0.12474549561739, 0.124831587076187, 0.124917723238468, 0.125003859400749, 0.125090003013611, 0.125176221132278, 0.125262424349785, 0.125348657369614, 0.125434905290604, 0.125521183013916, 0.12560747563839, 0.125693812966347, 0.125780150294304, 0.125866502523422, 0.125952884554863, 0.126039311289787, 0.126125738024712, 0.126212194561958, 0.126298651099205, 0.126385167241096, 0.126471668481827, 0.126558214426041, 0.126644775271416, 0.126731365919113, 0.126817971467972, 0.126904606819153, 0.126991242170334, 0.127077922224998, 0.127164617180824, 0.127251356840134, 0.127338051795959, 0.127424836158752, 0.127511620521545, 0.1275984197855, 0.127685248851776, 0.127772107720375, 0.127858966588974, 0.127945870161057, 0.128032773733139, 0.128119707107544, 0.128206670284271, 0.128293633460999, 0.128380671143532, 0.128467679023743, 0.128554731607437, 0.128641799092293, 0.128728896379471, 0.128815993666649, 0.12890313565731, 0.128990292549133, 0.129077464342117, 0.129164665937424, 0.129251882433891, 0.129339143633842, 0.129426404833794, 0.129513695836067, 0.129600986838341, 0.12968835234642, 0.129775688052177, 0.129863053560257, 0.129950478672981, 0.130037873983383, 0.130125343799591, 0.130212798714638, 0.130300283432007, 0.130387797951698, 0.130475327372551, 0.130562886595726, 0.130650475621223, 0.13073804974556, 0.130825683474541, 0.130913317203522, 0.131000995635986, 0.131088674068451, 0.131176382303238, 0.131264105439186, 0.131351873278618, 0.13143964111805, 0.131527453660965, 0.131615251302719, 0.131703093647957, 0.131790950894356, 0.131878837943077, 0.131966754794121, 0.132054686546326, 0.132142618298531, 0.132230594754219, 0.13231860101223, 0.132406622171402, 0.132494643330574, 0.132582724094391, 0.132670804858208, 0.132758885622025, 0.132847025990486, 0.132935166358948, 0.133023336529732, 0.133111536502838, 0.133199766278267, 0.133287966251373, 0.133376255631447, 0.133464515209198, 0.133552834391594, 0.13364115357399, 0.133729502558708, 0.133817881345749, 0.13390626013279, 0.133994683623314, 0.134083107113838, 0.134171560406685, 0.134260058403015, 0.134348541498184, 0.134437069296837, 0.134525611996651, 0.134614184498787, 0.134702786803246, 0.134791389107704, 0.134880021214485, 0.13496869802475, 0.135057359933853, 0.13514606654644, 0.135234788060188, 0.135323524475098, 0.135412290692329, 0.135501086711884, 0.135589882731438, 0.135678723454475, 0.135767564177513, 0.135856464505196, 0.135945335030556, 0.136034265160561, 0.136123210191727, 0.136212170124054, 0.136301174759865, 0.136390179395676, 0.136479198932648, 0.136568233370781, 0.136657327413559, 0.136746421456337, 0.136835530400276, 0.136924669146538, 0.137013852596283, 0.137103036046028, 0.137192234396935, 0.137281462550163, 0.137370720505714, 0.137459978461266, 0.1375492811203, 0.137638598680496, 0.137727916240692, 0.137817293405533, 0.137906685471535, 0.137996077537537, 0.138085499405861, 0.138174965977669, 0.138264417648315, 0.138353899121284, 0.138443425297737, 0.13853295147419, 0.138622522354126, 0.138712108135223, 0.138801693916321, 0.138891339302063, 0.138980999588966, 0.139070644974709, 0.139160349965096, 0.139250040054321, 0.139339789748192, 0.139429539442062, 0.139519348740578, 0.139609143137932, 0.139698952436447, 0.139788791537285, 0.139878675341606, 0.139968559145927, 0.140058472752571, 0.140148401260376, 0.140238374471664, 0.14032831788063, 0.140418320894241, 0.140508353710175, 0.140598386526108, 0.140688464045525, 0.140778541564941, 0.140868663787842, 0.140958786010742, 0.141048952937126, 0.14113911986351, 0.141229331493378, 0.141319528222084, 0.141409784555435, 0.141500040888786, 0.141590341925621, 0.141680628061295, 0.141770973801613, 0.141861319541931, 0.141951695084572, 0.142042100429535, 0.142132520675659, 0.142222955822945, 0.142313420772552, 0.142403900623322, 0.142494410276413, 0.142584934830666, 0.142675489187241, 0.142766058444977, 0.142856657505035, 0.142947256565094, 0.143037915229797, 0.143128573894501, 0.143219277262688, 0.143309965729713, 0.143400698900223, 0.143491432070732, 0.143582224845886, 0.143673002719879, 0.143763825297356, 0.143854662775993, 0.143945515155792, 0.144036397337914, 0.144127294421196, 0.144218221306801, 0.144309177994728, 0.144400149583817, 0.144491121172905, 0.144582137465477, 0.14467316865921, 0.144764244556427, 0.144855305552483, 0.144946411252022, 0.145037531852722, 0.145128682255745, 0.145219847559929, 0.145311042666435, 0.145402252674103, 0.145493492484093, 0.145584747195244, 0.145676016807556, 0.145767316222191, 0.145858645439148, 0.145949974656105, 0.146041363477707, 0.146132737398148, 0.146224141120911, 0.146315574645996, 0.146407037973404, 0.146498516201973, 0.146589994430542, 0.146681532263756, 0.14677307009697, 0.146864637732506, 0.146956220269203, 0.147047832608223, 0.147139444947243, 0.147231101989746, 0.147322773933411, 0.147414460778236, 0.147506207227707, 0.147597923874855, 0.147689700126648, 0.147781476378441, 0.147873297333717, 0.147965118288994, 0.148056983947754, 0.148148849606514, 0.148240745067596, 0.148332640528679, 0.148424580693245, 0.148516550660133, 0.148608535528183, 0.148700535297394, 0.148792549967766, 0.148884609341621, 0.148976683616638, 0.149068787693977, 0.149160891771317, 0.149253025650978, 0.149345189332962, 0.149437382817268, 0.149529561400414, 0.149621814489365, 0.149714037775993, 0.149806335568428, 0.14989860355854, 0.149990931153297, 0.150083243846893, 0.150175631046295, 0.150268003344536, 0.150360390543938, 0.150452822446823, 0.15054526925087, 0.150637745857239, 0.150730222463608, 0.150822728872299, 0.150915265083313, 0.151007816195488, 0.151100412011147, 0.151193007826805, 0.151285633444786, 0.151378259062767, 0.151470944285393, 0.151563629508018, 0.151656329631805, 0.151749059557915, 0.151841819286346, 0.151934593915939, 0.152027383446693, 0.152120217680931, 0.15221306681633, 0.152305901050568, 0.152398824691772, 0.152491718530655, 0.152584627270699, 0.152677610516548, 0.152770578861237, 0.152863562107086, 0.152956560254097, 0.153049618005753, 0.153142675757408, 0.153235763311386, 0.153328865766525, 0.153422012925148, 0.15351514518261, 0.153608337044716, 0.153701514005661, 0.15379473567009, 0.15388797223568, 0.153981253504753, 0.154074519872665, 0.154167830944061, 0.154261142015457, 0.154354527592659, 0.154447868466377, 0.154546350240707, 0.154649823904037, 0.154753297567368, 0.154856756329536, 0.154960185289383, 0.155063569545746, 0.15516696870327, 0.155270308256149, 0.155373647809029, 0.155476972460747, 0.155580282211304, 0.155683547258377, 0.155786797404289, 0.155890017747879, 0.155993223190308, 0.156096413731575, 0.156199589371681, 0.156302735209465, 0.156405836343765, 0.156508937478065, 0.156612023711205, 0.156715095043182, 0.156818106770515, 0.156921118497849, 0.157024130225182, 0.15712708234787, 0.157230034470558, 0.157332971692085, 0.157435849308968, 0.157538741827011, 0.157641619443893, 0.157744437456131, 0.157847255468369, 0.157950073480606, 0.158052831888199, 0.15815557539463, 0.158258303999901, 0.158361032605171, 0.158463716506958, 0.158566370606422, 0.158669039607048, 0.158771634101868, 0.158874243497849, 0.158976852893829, 0.159079387784004, 0.159181907773018, 0.159284442663193, 0.159386947751045, 0.159489408135414, 0.159591868519783, 0.15969429910183, 0.159796684980392, 0.159899070858955, 0.160001441836357, 0.160103768110275, 0.160206094384193, 0.16030840575695, 0.160410687327385, 0.160512909293175, 0.160615161061287, 0.160717368125916, 0.160819560289383, 0.160921707749367, 0.161023870110512, 0.161125987768173, 0.161228090524673, 0.161330178380013, 0.161432221531868, 0.161534264683723, 0.161636278033257, 0.161738261580467, 0.161840245127678, 0.161942198872566, 0.162044122815132, 0.162146031856537, 0.162247896194458, 0.162349790334702, 0.1624516248703, 0.162553429603577, 0.162655234336853, 0.162757009267807, 0.162858754396439, 0.16296049952507, 0.163062214851379, 0.163163915276527, 0.163265570998192, 0.163367226719856, 0.163468837738037, 0.163570463657379, 0.163672029972076, 0.163773581385612, 0.163875117897987, 0.163976639509201, 0.164078131318092, 0.164179623126984, 0.164281070232391, 0.164382502436638, 0.164483889937401, 0.164585292339325, 0.164686664938927, 0.164788007736206, 0.164889320731163, 0.16499063372612, 0.165091916918755, 0.165193155407906, 0.165294378995895, 0.165395617485046, 0.165496796369553, 0.165597975254059, 0.165699109435081, 0.165800228714943, 0.165901347994804, 0.166002422571182, 0.166103467345238, 0.166204527020454, 0.166305556893349, 0.166406542062759, 0.166507512331009, 0.166608452796936, 0.166709408164024, 0.166810303926468, 0.166911199688911, 0.167012050747871, 0.167112901806831, 0.167213708162308, 0.167314514517784, 0.167415291070938, 0.167516052722931, 0.167616784572601, 0.167717516422272, 0.167818173766136, 0.167918875813484, 0.168019518256187, 0.168120145797729, 0.168220743536949, 0.168321341276169, 0.168421894311905, 0.168522447347641, 0.168622970581055, 0.168723464012146, 0.168823912739754, 0.168924406170845, 0.16902482509613, 0.169125229120255, 0.169225618243217, 0.169325992465019, 0.169426321983337, 0.169526651501656, 0.169626951217651, 0.169727250933647, 0.169827505946159, 0.169927731156349, 0.170027941465378, 0.170128136873245, 0.17022830247879, 0.170328468084335, 0.170428588986397, 0.170528694987297, 0.170628786087036, 0.17072881758213, 0.170828893780708, 0.170928910374641, 0.171028897166252, 0.171128869056702, 0.171228840947151, 0.171328768134117, 0.171428680419922, 0.171528577804565, 0.171628460288048, 0.171728283166885, 0.171828106045723, 0.171927914023399, 0.172027692198753, 0.172127440571785, 0.172227174043655, 0.172326907515526, 0.172426596283913, 0.172526270151138, 0.172625944018364, 0.172725558280945, 0.172825157642365, 0.172924742102623, 0.17302431166172, 0.173123851418495, 0.17322339117527, 0.173322856426239, 0.17342235147953, 0.173521816730499, 0.173621267080307, 0.173720642924309, 0.173820048570633, 0.173919409513474, 0.174018770456314, 0.174118086695671, 0.174217402935028, 0.174316674470901, 0.174415946006775, 0.174515172839165, 0.174614384770393, 0.174713581800461, 0.174812763929367, 0.174911916255951, 0.175011038780212, 0.175110146403313, 0.175209239125252, 0.17530831694603, 0.175407350063324, 0.175506383180618, 0.175605356693268, 0.17570436000824, 0.175803303718567, 0.175902232527733, 0.176001161336899, 0.176100045442581, 0.176198914647102, 0.176297768950462, 0.1763965934515, 0.176495403051376, 0.176594167947769, 0.176692962646484, 0.176791682839394, 0.176890417933464, 0.176989108324051, 0.177087783813477, 0.17718642950058, 0.177285060286522, 0.177383661270142, 0.177482262253761, 0.177580818533897, 0.177679389715195, 0.177777901291847, 0.177876397967339, 0.177974879741669, 0.178073346614838, 0.178171768784523, 0.178270176053047, 0.178368583321571, 0.178466960787773, 0.178565293550491, 0.17866362631321, 0.178761929273605, 0.178860202431679, 0.178958490490913, 0.179056718945503, 0.179154932498932, 0.179253131151199, 0.179351314902306, 0.179449468851089, 0.179547607898712, 0.179645717144012, 0.17974379658699, 0.179841861128807, 0.179939925670624, 0.180037945508957, 0.180135950446129, 0.180233925580978, 0.180331885814667, 0.180429816246033, 0.180527746677399, 0.180625632405281, 0.180723518133163, 0.180821344256401, 0.180919200181961, 0.181017011404037, 0.181114792823792, 0.181212544441223, 0.181310296058655, 0.181408017873764, 0.181505709886551, 0.181603386998177, 0.181701049208641, 0.181798666715622, 0.181896299123764, 0.181993871927261, 0.182091444730759, 0.182188987731934, 0.182286530733109, 0.182383999228477, 0.18248151242733, 0.182578966021538, 0.182676419615746, 0.18277382850647, 0.182871222496033, 0.182968586683273, 0.183065950870514, 0.183163285255432, 0.183260589838028, 0.183357864618301, 0.183455124497414, 0.183552384376526, 0.183649599552155, 0.183746799826622, 0.183843985199928, 0.183941125869751, 0.184038281440735, 0.184135392308235, 0.184232488274574, 0.184329554438591, 0.184426590800285, 0.184523612260818, 0.184620603919029, 0.184717610478401, 0.184814557433128, 0.184911519289017, 0.18500842154026, 0.185105323791504, 0.185202196240425, 0.185299068689346, 0.185395881533623, 0.18549270927906, 0.185589477419853, 0.185686260461807, 0.185782998800278, 0.185879707336426, 0.185976415872574, 0.186073109507561, 0.186169758439064, 0.186266392469406, 0.186363011598587, 0.186459600925446, 0.186556175351143, 0.18665274977684, 0.186749249696732, 0.186845764517784, 0.186942219734192, 0.187038719654083, 0.187135130167007, 0.187231570482254, 0.187327951192856, 0.187424317002296, 0.187520697712898, 0.187617018818855, 0.187713339924812, 0.187809616327286, 0.18790590763092, 0.18800213932991, 0.188098356127739, 0.188194558024406, 0.188290730118752, 0.188386872410774, 0.188483044505119, 0.18857915699482, 0.188675239682198, 0.188771322369576, 0.188867390155792, 0.188963398337364, 0.189059391617775, 0.189155399799347, 0.189251363277435, 0.189347296953201, 0.189443215727806, 0.18953911960125, 0.189635008573532, 0.189730852842331, 0.189826682209969, 0.189922511577606, 0.19001829624176, 0.190114051103592, 0.190209820866585, 0.190305516123772, 0.190401241183281, 0.190496906638145, 0.190592586994171, 0.190688207745552, 0.190783828496933, 0.190879434347153, 0.19097501039505, 0.191070541739464, 0.191166073083878, 0.191261574625969, 0.19135707616806, 0.191452547907829, 0.191547989845276, 0.1916434019804, 0.191738799214363, 0.191834181547165, 0.191929534077644, 0.192024886608124, 0.19212019443512, 0.192215472459793, 0.192310735583305, 0.192405983805656, 0.192501217126846, 0.192596435546875, 0.19269160926342, 0.192786768078804, 0.192881911993027, 0.192977026104927, 0.193072110414505, 0.193167224526405, 0.193262249231339, 0.193357288837433, 0.193452283740044, 0.193547293543816, 0.193642243742943, 0.19373719394207, 0.193832129240036, 0.193927019834518, 0.19402189552784, 0.19411675632, 0.194211602210999, 0.194306403398514, 0.194401204586029, 0.194495975971222, 0.194590717554092, 0.194685444235802, 0.19478015601635, 0.194874837994576, 0.19496950507164, 0.195064142346382, 0.195158779621124, 0.195253357291222, 0.19534794986248, 0.195442512631416, 0.195537000894547, 0.19563153386116, 0.19572602212429, 0.195820480585098, 0.195914939045906, 0.196009337902069, 0.196103751659393, 0.196198135614395, 0.196292489767075, 0.196386843919754, 0.19648115336895, 0.196575433015823, 0.196669712662697, 0.196763962507248, 0.196858197450638, 0.196952387690544, 0.19704657793045, 0.197140753269196, 0.197234883904457, 0.197329014539719, 0.197423115372658, 0.197517186403275, 0.19761124253273, 0.197705268859863, 0.197799295186996, 0.197893291711807, 0.197987243533134, 0.198081195354462, 0.198175132274628, 0.198269009590149, 0.19836288690567, 0.198456764221191, 0.198550596833229, 0.198644414544106, 0.198738217353821, 0.198831990361214, 0.198925733566284, 0.199019476771355, 0.199113175272942, 0.199206858873367, 0.199300527572632, 0.199394181370735, 0.199487805366516, 0.199581384658813, 0.199674978852272, 0.199768543243408, 0.199862062931061, 0.199955582618713, 0.200049057602882, 0.200142547488213, 0.200235977768898, 0.200329408049583, 0.200422823429108, 0.200516179203987, 0.200609549880028, 0.200702890753746, 0.200796201825142, 0.200889512896538, 0.20098277926445, 0.201076045632362, 0.201169267296791, 0.20126248896122, 0.201355665922165, 0.201448827981949, 0.20154196023941, 0.201635092496872, 0.201728194952011, 0.201821282505989, 0.201914340257645, 0.202007383108139, 0.20210038125515, 0.202193394303322, 0.20228636264801, 0.202379301190376, 0.202472224831581, 0.202565148472786, 0.202658027410507, 0.202750876545906, 0.202843710780144, 0.20293653011322, 0.203029319643974, 0.20312212407589, 0.20321486890316, 0.203307598829269, 0.203400298953056, 0.203492999076843, 0.203585669398308, 0.203678324818611, 0.20377092063427, 0.203863546252251, 0.203956112265587, 0.204048663377762, 0.204141199588776, 0.204233720898628, 0.20432622730732, 0.204418674111366, 0.204511135816574, 0.20460356771946, 0.204695984721184, 0.204788357019424, 0.204880714416504, 0.204973056912422, 0.205065384507179, 0.205157682299614, 0.205249950289726, 0.205342203378677, 0.205434456467628, 0.205526649951935, 0.205618858337402, 0.205711022019386, 0.205803170800209, 0.205895289778709, 0.205987393856049, 0.206079483032227, 0.206171542406082, 0.206263571977615, 0.206355586647987, 0.206447586417198, 0.206539571285248, 0.206631511449814, 0.20672345161438, 0.206815332174301, 0.206907227635384, 0.206999093294144, 0.207090944051743, 0.207182765007019, 0.207274571061134, 0.207366332411766, 0.207458093762398, 0.207549825310707, 0.207641556859016, 0.20773321390152, 0.207824915647507, 0.207916542887688, 0.208008155226707, 0.208099767565727, 0.208191350102425, 0.208282917737961, 0.208374440670013, 0.208465993404388, 0.208557471632957, 0.208648949861526, 0.208740398287773, 0.208831831812859, 0.208923250436783, 0.209014609456062, 0.209105983376503, 0.209197342395782, 0.209288641810417, 0.209379956126213, 0.209471225738525, 0.209562510251999, 0.209653720259666, 0.209744945168495, 0.209836140275002, 0.209927335381508, 0.210018455982208, 0.210109606385231, 0.210200697183609, 0.210291773080826, 0.210382834076881, 0.210473880171776, 0.210564896464348, 0.210655897855759, 0.210746854543686, 0.210837826132774, 0.21092876791954, 0.211019665002823, 0.211110532283783, 0.211201429367065, 0.211292251944542, 0.21138308942318, 0.211473867297173, 0.211564674973488, 0.21165543794632, 0.211746171116829, 0.211836889386177, 0.211927577853203, 0.212018221616745, 0.212108880281448, 0.212199538946152, 0.212290123105049, 0.212380707263947, 0.212471276521683, 0.212561830878258, 0.212652340531349, 0.212742820382118, 0.212833300232887, 0.212923765182495, 0.213014185428619, 0.213104605674744, 0.213195011019707, 0.213285371661186, 0.213375702500343, 0.2134660333395, 0.213556334376335, 0.21364663541317, 0.213736891746521, 0.21382711827755, 0.213917329907417, 0.214007526636124, 0.214097708463669, 0.214187860488892, 0.214277982711792, 0.214368090033531, 0.214458167552948, 0.214548259973526, 0.214638277888298, 0.214728310704231, 0.214818298816681, 0.214908286929131, 0.214998215436935, 0.215088158845901, 0.215178102254868, 0.215267956256866, 0.215357854962349, 0.215447694063187, 0.215537518262863, 0.215627312660217, 0.215717107057571, 0.215806856751442, 0.215896606445312, 0.215986326336861, 0.216076031327248, 0.216165691614151, 0.216255336999893, 0.216344967484474, 0.216434583067894, 0.216524168848991, 0.216613739728928, 0.216703280806541, 0.216792821884155, 0.216882288455963, 0.216971784830093, 0.21706123650074, 0.217150673270226, 0.21724009513855, 0.217329457402229, 0.217418864369392, 0.217508181929588, 0.217597529292107, 0.217686846852303, 0.217776089906693, 0.217865392565727, 0.217954620718956, 0.218043819069862, 0.218133017420769, 0.218222185969353, 0.218311354517937, 0.218400478363037, 0.218489587306976, 0.218578666448593, 0.21866774559021, 0.218756780028343, 0.218845814466476, 0.218934819102287, 0.219023793935776, 0.219112753868103, 0.219201683998108, 0.219290599226952, 0.219379484653473, 0.219468384981155, 0.219557240605354, 0.219646036624908, 0.219734847545624, 0.219823643565178, 0.21991240978241, 0.220001146197319, 0.220089852809906, 0.220178574323654, 0.220267236232758, 0.220355898141861, 0.220444530248642, 0.220533147454262, 0.220621719956398, 0.220710292458534, 0.220798835158348, 0.220887377858162, 0.220975875854492, 0.221064358949661, 0.221152797341347, 0.221241250634193, 0.221329659223557, 0.221418052911758, 0.221506431698799, 0.221594780683517, 0.221683099865913, 0.221771404147148, 0.221859693527222, 0.221947968006134, 0.222036212682724, 0.222124427556992, 0.222212627530098, 0.222300797700882, 0.222388967871666, 0.222477078437805, 0.222565203905106, 0.222653299570084, 0.222741365432739, 0.222829401493073, 0.222917452454567, 0.223005428910255, 0.223093435168266, 0.223181396722794, 0.223269328474998, 0.223357245326042, 0.223445132374763, 0.223532989621162, 0.223620846867561, 0.22370870411396, 0.223796516656876, 0.223884284496307, 0.223972052335739, 0.22405980527401, 0.224147513508797, 0.224235221743584, 0.224322900176048, 0.224410533905029, 0.224498197436333, 0.224585816264153, 0.22467340528965, 0.224760949611664, 0.224848523736, 0.224936053156853, 0.225023552775383, 0.225111022591591, 0.22519850730896, 0.225285932421684, 0.225373357534409, 0.225460737943649, 0.22554811835289, 0.225635468959808, 0.225722804665565, 0.225810110569, 0.225897401571274, 0.225984677672386, 0.226071909070015, 0.226159125566483, 0.22624634206295, 0.226333513855934, 0.226420670747757, 0.226507797837257, 0.226594924926758, 0.226682007312775, 0.226769089698792, 0.226856112480164, 0.226943165063858, 0.227030172944069, 0.227117151021957, 0.227204129099846, 0.22729104757309, 0.227377966046333, 0.227464869618416, 0.227551743388176, 0.227638617157936, 0.227725446224213, 0.227812245488167, 0.22789902985096, 0.227985814213753, 0.228072553873062, 0.228159263730049, 0.228245973587036, 0.22833263874054, 0.228419318795204, 0.228505939245224, 0.228592574596405, 0.228679150342941, 0.228765740990639, 0.228852301836014, 0.228938832879066, 0.229025319218636, 0.229111820459366, 0.229198276996613, 0.229284718632698, 0.229371145367622, 0.229457527399063, 0.229543909430504, 0.229630261659622, 0.229716613888741, 0.229802921414375, 0.229889199137688, 0.229975476861, 0.230061709880829, 0.230147942900658, 0.230234161019325, 0.230320319533348, 0.230406492948532, 0.230492621660233, 0.230578735470772, 0.230664849281311, 0.230750918388367, 0.2308369576931, 0.230922996997833, 0.231008991599083, 0.231094971299171, 0.231180965900421, 0.231266885995865, 0.23135282099247, 0.231438711285591, 0.231524586677551, 0.231610462069511, 0.231696277856827, 0.231782093644142, 0.231867879629135, 0.231953665614128, 0.232039406895638, 0.232125133275986, 0.232210859656334, 0.232296511530876, 0.23238217830658, 0.232467815279961, 0.23255343735218, 0.232639044523239, 0.232724636793137, 0.232810154557228, 0.232895687222481, 0.232981204986572, 0.23306667804718, 0.233152166008949, 0.233237579464912, 0.233323037624359, 0.233408406376839, 0.233493790030479, 0.23357917368412, 0.233664497733116, 0.233749821782112, 0.233835116028786, 0.233920380473137, 0.234005630016327, 0.234090849757195, 0.234176069498062, 0.234261229634285, 0.234346389770508, 0.234431535005569, 0.23451666533947, 0.234601750969887, 0.234686836600304, 0.234771892428398, 0.23485691845417, 0.234941929578781, 0.23502691090107, 0.235111892223358, 0.235196843743324, 0.235281750559807, 0.235366672277451, 0.235451549291611, 0.23553641140461, 0.235621243715286, 0.23570604622364, 0.235790848731995, 0.235875636339188, 0.235960364341736, 0.236045107245445, 0.23612979054451, 0.236214488744736, 0.236299157142639, 0.236383780837059, 0.236468404531479, 0.236553013324738, 0.236637577414513, 0.236722141504288, 0.236806690692902, 0.236891210079193, 0.236975684762001, 0.237060129642487, 0.237144574522972, 0.237229019403458, 0.23731341958046, 0.2373978048563, 0.23748217523098, 0.237566515803337, 0.237650826573372, 0.237735122442245, 0.237819388508797, 0.237903654575348, 0.237987890839577, 0.238072082400322, 0.238156273961067, 0.23824043571949, 0.238324567675591, 0.238408699631691, 0.238492801785469, 0.238576889038086, 0.238660916686058, 0.23874494433403, 0.238828971982002, 0.238912984728813, 0.238996922969818, 0.239080861210823, 0.239164814352989, 0.239248722791672, 0.239332586526871, 0.239416465163231, 0.239500299096107, 0.239584118127823, 0.239667907357216, 0.239751696586609, 0.23983545601368, 0.239919185638428, 0.240002870559692, 0.240086570382118, 0.240170240402222, 0.240253880620003, 0.240337505936623, 0.24042110145092, 0.240504667162895, 0.24058823287487, 0.240671768784523, 0.240755274891853, 0.240838766098022, 0.240922227501869, 0.241005703806877, 0.241089105606079, 0.241172522306442, 0.241255909204483, 0.241339266300201, 0.24142262339592, 0.241505920886993, 0.241589218378067, 0.241672500967979, 0.241755753755569, 0.241839006543159, 0.241922184824944, 0.242005378007889, 0.242088556289673, 0.242171719670296, 0.242254838347435, 0.242337927222252, 0.242421001195908, 0.242504060268402, 0.242587089538574, 0.242670103907585, 0.242753118276596, 0.242836087942123, 0.242919027805328, 0.243001967668533, 0.243084862828255, 0.243167757987976, 0.243250623345375, 0.243333473801613, 0.243416264653206, 0.243499085307121, 0.243581846356392, 0.243664607405663, 0.243747338652611, 0.243830054998398, 0.243912741541862, 0.243995413184166, 0.244078055024147, 0.244160681962967, 0.244243294000626, 0.24432584643364, 0.244408428668976, 0.244490951299667, 0.24457348883152, 0.244655966758728, 0.244738444685936, 0.244820892810822, 0.244903340935707, 0.244985729455948, 0.24506813287735, 0.245150476694107, 0.245232820510864, 0.24531514942646, 0.245397448539734, 0.245479717850685, 0.245561972260475, 0.245644211769104, 0.245726436376572, 0.245808616280556, 0.245890811085701, 0.245972946286201, 0.246055066585541, 0.246137157082558, 0.246219262480736, 0.246301338076591, 0.246383339166641, 0.246465384960175, 0.246547386050224, 0.246629327535629, 0.246711283922195, 0.2467932254076, 0.246875137090683, 0.246957018971443, 0.247038871049881, 0.24712073802948, 0.247198760509491, 0.24727301299572, 0.247347190976143, 0.247421279549599, 0.247495323419571, 0.247569277882576, 0.247643157839775, 0.247716993093491, 0.247790738940239, 0.247864410281181, 0.247938007116318, 0.248011559247971, 0.248085021972656, 0.248158410191536, 0.248231738805771, 0.248304978013039, 0.248378172516823, 0.248451307415962, 0.248524323105812, 0.248597294092178, 0.2486702054739, 0.248743042349815, 0.248815789818764, 0.248888477683067, 0.248961091041565, 0.249033644795418, 0.249106124043465, 0.249178528785706, 0.249250859022141, 0.249323144555092, 0.249395310878754, 0.249467447400093, 0.249539494514465, 0.249611482024193, 0.249683380126953, 0.24975523352623, 0.249826997518539, 0.249898701906204, 0.249970331788063, 0.250041902065277, 0.250113397836685, 0.250184774398804, 0.2502561211586, 0.250327408313751, 0.250398635864258, 0.250469744205475, 0.25054082274437, 0.250611811876297, 0.25068274140358, 0.250753581523895, 0.250824362039566, 0.250895082950592, 0.250965714454651, 0.251036286354065, 0.251106798648834, 0.251177191734314, 0.251247584819794, 0.251317858695984, 0.251388072967529, 0.25145822763443, 0.251528292894363, 0.251598298549652, 0.251668244600296, 0.251738101243973, 0.251807898283005, 0.25187760591507, 0.25194725394249, 0.252016842365265, 0.252086341381073, 0.252155780792236, 0.252225160598755, 0.252294450998306, 0.252363681793213, 0.252432852983475, 0.252501934766769, 0.252570927143097, 0.252639889717102, 0.252708792686462, 0.252777576446533, 0.252846300601959, 0.25291496515274, 0.252983570098877, 0.253052085638046, 0.253120541572571, 0.253188908100128, 0.253257215023041, 0.253325462341309, 0.253393620252609, 0.253461718559265, 0.253529757261276, 0.25359770655632, 0.253665596246719, 0.253733396530151, 0.253801167011261, 0.253868818283081, 0.253936409950256, 0.254003971815109, 0.254071414470673, 0.254138797521591, 0.254206150770187, 0.254273384809494, 0.254340559244156, 0.254407674074173, 0.254474699497223, 0.254541665315628, 0.254608571529388, 0.254675388336182, 0.25474214553833, 0.254808843135834, 0.25487545132637, 0.254941999912262, 0.255008488893509, 0.255074858665466, 0.255141198635101, 0.255207479000092, 0.255273669958115, 0.255339771509171, 0.255405843257904, 0.255471795797348, 0.25553771853447, 0.255603551864624, 0.255669295787811, 0.255735009908676, 0.255800634622574, 0.255866199731827, 0.255931675434113, 0.255997061729431, 0.256062418222427, 0.256127685308456, 0.256192892789841, 0.256258010864258, 0.256323099136353, 0.256388068199158, 0.256452977657318, 0.256517857313156, 0.256582617759705, 0.256647348403931, 0.256711959838867, 0.256776541471481, 0.256841033697128, 0.256905436515808, 0.256969809532166, 0.257034093141556, 0.257098287343979, 0.25716245174408, 0.257226496934891, 0.25729051232338, 0.257354438304901, 0.257418304681778, 0.257482081651688, 0.257545828819275, 0.257609456777573, 0.257673054933548, 0.257736533880234, 0.257799983024597, 0.257863342761993, 0.257926642894745, 0.257989853620529, 0.258053004741669, 0.258116096258163, 0.258179098367691, 0.258242070674896, 0.258304923772812, 0.258367717266083, 0.258430451154709, 0.258493095636368, 0.258555680513382, 0.258618205785751, 0.258680641651154, 0.258743017911911, 0.258805334568024, 0.258867561817169, 0.258929759263992, 0.258991837501526, 0.259053856134415, 0.259115785360336, 0.259177684783936, 0.259239494800568, 0.259301245212555, 0.259362906217575, 0.25942450761795, 0.259486049413681, 0.259547501802444, 0.259608864784241, 0.259670197963715, 0.259731441736221, 0.259792625904083, 0.2598537504673, 0.259914755821228, 0.259975731372833, 0.260036617517471, 0.260097444057465, 0.260158181190491, 0.260218858718872, 0.260279476642609, 0.260340005159378, 0.260400474071503, 0.260460883378983, 0.260521233081818, 0.260581493377686, 0.260641664266586, 0.260701775550842, 0.260761827230453, 0.260821789503098, 0.260881692171097, 0.260941535234451, 0.261001288890839, 0.261060982942581, 0.261120587587357, 0.26118016242981, 0.261239647865295, 0.261299043893814, 0.261358380317688, 0.261417657136917, 0.261476874351501, 0.261535972356796, 0.261595040559769, 0.261654019355774, 0.261712938547134, 0.26177179813385, 0.261830538511276, 0.26188924908638, 0.261947900056839, 0.262006461620331, 0.262064963579178, 0.262123346328735, 0.26218169927597, 0.262239992618561, 0.262298196554184, 0.262356340885162, 0.262414425611496, 0.262472420930862, 0.262530326843262, 0.262588173151016, 0.262645989656448, 0.262703686952591, 0.262761324644089, 0.262818902730942, 0.262876391410828, 0.262933850288391, 0.262991189956665, 0.263048499822617, 0.263105690479279, 0.263162851333618, 0.263219922780991, 0.263276934623718, 0.263333886861801, 0.263390749692917, 0.263447523117065, 0.263504266738892, 0.263560920953751, 0.263617485761642, 0.263674020767212, 0.263730466365814, 0.263786822557449, 0.26384311914444, 0.263899356126785, 0.263955533504486, 0.26401162147522, 0.264067649841309, 0.26412358880043, 0.264179468154907, 0.264235258102417, 0.264290988445282, 0.264346688985825, 0.264402270317078, 0.264457792043686, 0.264513254165649, 0.264568626880646, 0.26462396979332, 0.264679193496704, 0.264734357595444, 0.264789462089539, 0.264844477176666, 0.264899462461472, 0.26495435833931, 0.265009135007858, 0.265063911676407, 0.265118569135666, 0.265173196792603, 0.26522770524025, 0.265282183885574, 0.265336602926254, 0.265390902757645, 0.26544514298439, 0.265499323606491, 0.265553444623947, 0.265607506036758, 0.26566144824028, 0.265715360641479, 0.265769213438034, 0.265822947025299, 0.265876650810242, 0.265930235385895, 0.265983790159225, 0.266037285327911, 0.26609069108963, 0.266144007444382, 0.266197293996811, 0.266250491142273, 0.266303598880768, 0.26635667681694, 0.266409635543823, 0.266462534666061, 0.266515374183655, 0.266568154096603, 0.266620874404907, 0.266673475503922, 0.266726046800613, 0.266778528690338, 0.266830950975418, 0.266883283853531, 0.266935557126999, 0.266987770795822, 0.267039924860001, 0.26709195971489, 0.267143964767456, 0.267195910215378, 0.26724773645401, 0.267299503087997, 0.267351239919662, 0.267402857542038, 0.267454445362091, 0.267505943775177, 0.267557382583618, 0.267608731985092, 0.267660021781921, 0.267711222171783, 0.267762362957001, 0.267813444137573, 0.267864435911179, 0.267915397882462, 0.267966240644455, 0.268017023801804, 0.268067747354507, 0.268118411302567, 0.268168985843658, 0.268219500780106, 0.268269926309586, 0.268320292234421, 0.268370598554611, 0.268420815467834, 0.268470972776413, 0.268521070480347, 0.268571078777313, 0.268621027469635, 0.268670916557312, 0.268720716238022, 0.268770456314087, 0.268820106983185, 0.268869698047638, 0.268919229507446, 0.268968671560287, 0.269018054008484, 0.269067347049713, 0.269116580486298, 0.269165754318237, 0.269214868545532, 0.269263863563538, 0.269312828779221, 0.269361734390259, 0.26941055059433, 0.269459277391434, 0.269507944583893, 0.26955658197403, 0.269605100154877, 0.269653528928757, 0.269701927900314, 0.269750267267227, 0.26979848742485, 0.269846677780151, 0.269894778728485, 0.269942849874496, 0.269990772008896, 0.270038694143295, 0.270086526870728, 0.270134270191193, 0.270181953907013, 0.270229578018188, 0.270277112722397, 0.27032458782196, 0.270372003316879, 0.270419329404831, 0.270466595888138, 0.270513772964478, 0.270560890436172, 0.270607948303223, 0.270654946565628, 0.270701825618744, 0.270748645067215, 0.270795434713364, 0.270842134952545, 0.27088874578476, 0.270935297012329, 0.270981818437576, 0.271028220653534, 0.271074533462524, 0.271120816469193, 0.271166980266571, 0.27121314406395, 0.271259188652039, 0.271305203437805, 0.271351099014282, 0.271396964788437, 0.271442711353302, 0.271488457918167, 0.271534085273743, 0.271579623222351, 0.271625131368637, 0.271670550107956, 0.27171590924263, 0.271761208772659, 0.271806418895721, 0.271851569414139, 0.271896630525589, 0.271941602230072, 0.271986544132233, 0.272031426429749, 0.272076189517975, 0.272120922803879, 0.272165536880493, 0.272210121154785, 0.272254675626755, 0.272299081087112, 0.272343456745148, 0.272387742996216, 0.272431969642639, 0.272476106882095, 0.272520214319229, 0.272564202547073, 0.272608160972595, 0.27265202999115, 0.272695809602737, 0.272739559412003, 0.272783219814301, 0.272826790809631, 0.27287033200264, 0.272913753986359, 0.272957146167755, 0.273000419139862, 0.273043662309647, 0.273086845874786, 0.273129940032959, 0.273172944784164, 0.273215889930725, 0.273258775472641, 0.273301601409912, 0.273344337940216, 0.273387014865875, 0.273429602384567, 0.273472130298615, 0.273514598608017, 0.273556977510452, 0.273599296808243, 0.273641526699066, 0.273683696985245, 0.273725807666779, 0.273767858743668, 0.273809820413589, 0.273851692676544, 0.273893535137177, 0.273935288190842, 0.27397695183754, 0.274018585681915, 0.274060100317001, 0.274101585149765, 0.274142980575562, 0.274184286594391, 0.274225562810898, 0.274266749620438, 0.274307876825333, 0.274348884820938, 0.274389892816544, 0.274430781602859, 0.274471610784531, 0.274512380361557, 0.274553060531616, 0.274593681097031, 0.274634212255478, 0.274674713611603, 0.27471512556076, 0.274755448102951, 0.274795740842819, 0.27483594417572, 0.274876058101654, 0.274916112422943, 0.274956107139587, 0.274996012449265, 0.275035858154297, 0.275075644254684, 0.275115340948105, 0.275154948234558, 0.275194525718689, 0.275234013795853, 0.275273412466049, 0.275312781333923, 0.27535206079483, 0.275391280651093, 0.275430411100388, 0.275469481945038, 0.275508463382721, 0.275547385215759, 0.275586247444153, 0.275625020265579, 0.275663763284683, 0.275702387094498, 0.27574098110199, 0.275779455900192, 0.275817930698395, 0.275856256484985, 0.275894552469254, 0.275932759046555, 0.275970935821533, 0.276008993387222, 0.276046991348267, 0.276084929704666, 0.276122838258743, 0.276160627603531, 0.276198327541351, 0.276235967874527, 0.276273548603058, 0.276311099529266, 0.276348501443863, 0.276385903358459, 0.276423186063766, 0.276460438966751, 0.276497602462769, 0.276534676551819, 0.276571691036224, 0.276608645915985, 0.276645511388779, 0.276682317256927, 0.276719033718109, 0.276755720376968, 0.27679231762886, 0.276828825473785, 0.276865273714066, 0.276901662349701, 0.276937991380692, 0.276974231004715, 0.277010411024094, 0.277046501636505, 0.277082532644272, 0.277118474245071, 0.277154386043549, 0.277190208435059, 0.277225971221924, 0.277261644601822, 0.277297228574753, 0.277332752943039, 0.27736821770668, 0.277403622865677, 0.277438968420029, 0.277474194765091, 0.277509421110153, 0.277544498443604, 0.277579545974731, 0.277614533901215, 0.277649402618408, 0.277684211730957, 0.277718991041183, 0.277753680944443, 0.277788311243057, 0.277822852134705, 0.277857303619385, 0.277891725301743, 0.277926087379456, 0.277960300445557, 0.277994513511658, 0.278028637170792, 0.278062671422958, 0.278096675872803, 0.27813059091568, 0.27816441655159, 0.278198212385178, 0.278231889009476, 0.278265535831451, 0.278299063444138, 0.278332591056824, 0.27836599946022, 0.278399348258972, 0.278432607650757, 0.278465807437897, 0.278498947620392, 0.278532028198242, 0.278564989566803, 0.278597891330719, 0.278630763292313, 0.278663545846939, 0.278696268796921, 0.278728902339935, 0.278761476278305, 0.278793960809708, 0.278826415538788, 0.278858751058578, 0.278891056776047, 0.278923273086548, 0.278955399990082, 0.278987467288971, 0.279019474983215, 0.279051393270493, 0.279083251953125, 0.279115051031113, 0.279146790504456, 0.279178440570831, 0.279210031032562, 0.279241532087326, 0.279272973537445, 0.279304325580597, 0.279335618019104, 0.279366850852966, 0.279397994279861, 0.279429078102112, 0.27946013212204, 0.279491066932678, 0.279521912336349, 0.279552727937698, 0.279583483934402, 0.279614120721817, 0.279644727706909, 0.279675245285034, 0.279705673456192, 0.279736042022705, 0.279766350984573, 0.279796600341797, 0.279826790094376, 0.279856890439987, 0.279886901378632, 0.279916852712631, 0.279946744441986, 0.279976546764374, 0.280006319284439, 0.280035972595215, 0.280065566301346, 0.280095130205154, 0.280124574899673, 0.280153959989548, 0.280183285474777, 0.28021252155304, 0.280241698026657, 0.28027081489563, 0.280299842357635, 0.280328810214996, 0.28035768866539, 0.280386537313461, 0.280415296554565, 0.280443966388702, 0.280472576618195, 0.280501127243042, 0.280529588460922, 0.28055801987648, 0.280586332082748, 0.280614584684372, 0.280642777681351, 0.280670911073685, 0.280698925256729, 0.280726909637451, 0.280754834413528, 0.280782669782639, 0.280810415744781, 0.280838131904602, 0.280865758657455, 0.280893325805664, 0.280920773744583, 0.28094819188118, 0.280975520610809, 0.281002819538116, 0.281029999256134, 0.281057149171829, 0.281084209680557, 0.281111180782318, 0.281138092279434, 0.281164944171906, 0.281191736459732, 0.281218439340591, 0.281245082616806, 0.281271636486053, 0.281298160552979, 0.281324565410614, 0.281350910663605, 0.281377226114273, 0.281403392553329, 0.281429529190063, 0.281455636024475, 0.281481623649597, 0.281507551670074, 0.281533390283585, 0.281559199094772, 0.281584888696671, 0.281610548496246, 0.281636148691177, 0.281661629676819, 0.281687080860138, 0.28171244263649, 0.281737744808197, 0.281762927770615, 0.281788110733032, 0.28181317448616, 0.281838208436966, 0.281863152980804, 0.281888008117676, 0.281912803649902, 0.281937539577484, 0.281962186098099, 0.281986773014069, 0.282011300325394, 0.282035738229752, 0.282060116529465, 0.282084435224533, 0.282108664512634, 0.282132804393768, 0.28215691447258, 0.282180935144424, 0.282204896211624, 0.282228767871857, 0.282252579927444, 0.282276332378387, 0.282299965620041, 0.282323598861694, 0.282347112894058, 0.282370567321777, 0.282393962144852, 0.282417267560959, 0.282440513372421, 0.282463699579239, 0.282486796379089, 0.282509803771973, 0.282532781362534, 0.282555669546127, 0.282578498125076, 0.282601237297058, 0.282623916864395, 0.282646536827087, 0.282669097185135, 0.282691568136215, 0.282713949680328, 0.282736271619797, 0.28275853395462, 0.282780706882477, 0.282802850008011, 0.282824873924255, 0.282846838235855, 0.28286874294281, 0.28289058804512, 0.282912343740463, 0.282934039831161, 0.282955646514893, 0.282977223396301, 0.28299868106842, 0.283020108938217, 0.283041417598724, 0.283062696456909, 0.283083885908127, 0.2831050157547, 0.283126085996628, 0.283147066831589, 0.283167988061905, 0.283188819885254, 0.283209592103958, 0.283230274915695, 0.28325092792511, 0.283271461725235, 0.283291965723038, 0.283312380313873, 0.283332735300064, 0.283353000879288, 0.283373236656189, 0.283393383026123, 0.28341343998909, 0.283433437347412, 0.283453345298767, 0.283473193645477, 0.283493012189865, 0.283512711524963, 0.283532351255417, 0.283551901578903, 0.283571422100067, 0.283590853214264, 0.283610194921494, 0.283629506826401, 0.283648729324341, 0.283667862415314, 0.283686965703964, 0.283705949783325, 0.283724904060364, 0.283743739128113, 0.283762574195862, 0.283781290054321, 0.283799946308136, 0.283818513154984, 0.283837020397186, 0.283855468034744, 0.283873826265335, 0.283892124891281, 0.283910363912582, 0.283928513526917, 0.283946603536606, 0.283964663743973, 0.283982574939728, 0.28400045633316, 0.284018278121948, 0.284036010503769, 0.284053653478622, 0.284071266651154, 0.284088790416718, 0.284106254577637, 0.284123629331589, 0.284140914678574, 0.284158170223236, 0.284175336360931, 0.284192442893982, 0.284209460020065, 0.284226417541504, 0.284243315458298, 0.284260123968124, 0.284276902675629, 0.284293562173843, 0.284310162067413, 0.284326702356339, 0.284343153238297, 0.28435954451561, 0.284375876188278, 0.284392118453979, 0.284408301115036, 0.284424424171448, 0.284440457820892, 0.284456431865692, 0.284472346305847, 0.284488171339035, 0.284503906965256, 0.284519612789154, 0.284535259008408, 0.284550756216049, 0.284566253423691, 0.284581661224365, 0.284597009420395, 0.284612238407135, 0.284627437591553, 0.284642547369003, 0.284657627344131, 0.28467258810997, 0.284687519073486, 0.284702360630035, 0.284717112779617, 0.284731835126877, 0.284746408462524, 0.284761011600494, 0.284775495529175, 0.28478991985321, 0.284804254770279, 0.284818530082703, 0.284832745790482, 0.284846842288971, 0.284860908985138, 0.28487491607666, 0.284888833761215, 0.284902691841125, 0.284916490316391, 0.284930169582367, 0.284943848848343, 0.284957379102707, 0.284970909357071, 0.284984320402145, 0.284997671842575, 0.28501096367836, 0.285024166107178, 0.285037308931351, 0.285050392150879, 0.28506338596344, 0.285076320171356, 0.285089164972305, 0.285101979970932, 0.285114675760269, 0.285127341747284, 0.285139918327332, 0.285152435302734, 0.285164892673492, 0.285177260637283, 0.285189539194107, 0.285201758146286, 0.28521391749382, 0.285225987434387, 0.285238027572632, 0.285249978303909, 0.28526183962822, 0.285273611545563, 0.285285353660583, 0.285297036170959, 0.285308599472046, 0.28532013297081, 0.285331606864929, 0.285342961549759, 0.285354256629944, 0.285365521907806, 0.285376697778702, 0.28538778424263, 0.285398811101913, 0.28540974855423, 0.285420626401901, 0.285431444644928, 0.285442173480988, 0.285452872514725, 0.285463482141495, 0.285474002361298, 0.285484462976456, 0.285494863986969, 0.285505175590515, 0.285515397787094, 0.285525590181351, 0.28553569316864, 0.285545736551285, 0.285555690526962, 0.285565614700317, 0.285575419664383, 0.285585165023804, 0.285594880580902, 0.285604447126389, 0.285614013671875, 0.285623490810394, 0.285632908344269, 0.285642236471176, 0.285651475191116, 0.285660684108734, 0.285669803619385, 0.285678833723068, 0.285687804222107, 0.285696715116501, 0.28570556640625, 0.28571429848671, 0.285723000764847, 0.285731643438339, 0.285740196704865, 0.285748690366745, 0.285757094621658, 0.285765439271927, 0.285773694515228, 0.285781919956207, 0.285790026187897, 0.285798102617264, 0.285806089639664, 0.285813987255096, 0.285821825265884, 0.28582963347435, 0.285837322473526, 0.285844951868057, 0.285852551460266, 0.285860031843185, 0.285867422819138, 0.285874783992767, 0.285882085561752, 0.28588929772377, 0.285896420478821, 0.285903483629227, 0.285910487174988, 0.285917431116104, 0.285924285650253, 0.285931080579758, 0.285937786102295, 0.285944432020187, 0.285950988531113, 0.285957515239716, 0.285963922739029, 0.28597030043602, 0.285976588726044, 0.285982817411423, 0.285988986492157, 0.285995036363602, 0.286001086235046, 0.286006987094879, 0.286012887954712, 0.286018669605255, 0.286024391651154, 0.28603008389473, 0.286035627126694, 0.286041170358658, 0.286046624183655, 0.286051988601685, 0.28605729341507, 0.286062508821487, 0.286067694425583, 0.286072790622711, 0.286077797412872, 0.286082774400711, 0.28608763217926, 0.286092460155487, 0.286097198724747, 0.286101847887039, 0.286106437444687, 0.28611096739769, 0.286115407943726, 0.286119818687439, 0.286124110221863, 0.286128371953964, 0.286132544279099, 0.286136627197266, 0.28614068031311, 0.286144644021988, 0.286148548126221, 0.286152362823486, 0.286156088113785, 0.286151319742203, 0.286137908697128, 0.286124467849731, 0.28611096739769, 0.286097377538681, 0.286083698272705, 0.286069959402084, 0.286056190729141, 0.286042302846909, 0.286028355360031, 0.286014348268509, 0.286000281572342, 0.285986125469208, 0.285971909761429, 0.285957604646683, 0.285943239927292, 0.285928785800934, 0.285914301872253, 0.285899698734283, 0.285885065793991, 0.285870343446732, 0.285855561494827, 0.285840690135956, 0.28582575917244, 0.285810768604279, 0.285795718431473, 0.285780549049377, 0.285765320062637, 0.285750031471252, 0.285734683275223, 0.285719275474548, 0.285703808069229, 0.285688251256943, 0.285672575235367, 0.285656869411469, 0.285641103982925, 0.285625249147415, 0.28560933470726, 0.28559336066246, 0.285577297210693, 0.285561144351959, 0.285544961690903, 0.285528689622879, 0.285512328147888, 0.285495907068253, 0.285479426383972, 0.285462886095047, 0.285446286201477, 0.28542959690094, 0.285412788391113, 0.285395950078964, 0.28537905216217, 0.285362094640732, 0.285345047712326, 0.285327911376953, 0.285310715436935, 0.285293459892273, 0.285276144742966, 0.285258740186691, 0.285241276025772, 0.285223722457886, 0.285206109285355, 0.285188406705856, 0.285170704126358, 0.285152852535248, 0.285134941339493, 0.285117000341415, 0.285098940134048, 0.285080850124359, 0.285062670707703, 0.285044401884079, 0.285026103258133, 0.28500771522522, 0.284989237785339, 0.284970730543137, 0.284952133893967, 0.28493344783783, 0.284914702177048, 0.284895926713943, 0.28487703204155, 0.284858077764511, 0.284839034080505, 0.284819930791855, 0.284800797700882, 0.28478154540062, 0.284762233495712, 0.28474286198616, 0.284723401069641, 0.2847039103508, 0.284684300422668, 0.284664630889893, 0.284644901752472, 0.284625113010406, 0.284605264663696, 0.284585297107697, 0.284565299749374, 0.284545242786407, 0.284525066614151, 0.28450483083725, 0.284484535455704, 0.284464180469513, 0.284443736076355, 0.284423232078552, 0.284402638673782, 0.28438201546669, 0.284361273050308, 0.284340471029282, 0.284319639205933, 0.284298717975616, 0.284277707338333, 0.284256637096405, 0.28423547744751, 0.28421425819397, 0.284192979335785, 0.284171640872955, 0.284150213003159, 0.284128755331039, 0.284107178449631, 0.284085512161255, 0.284063816070557, 0.284042030572891, 0.284020215272903, 0.283998280763626, 0.283976286649704, 0.283954232931137, 0.283932119607925, 0.283909887075424, 0.283887624740601, 0.28386527299881, 0.283842861652374, 0.283820390701294, 0.283797830343246, 0.283775210380554, 0.283752501010895, 0.283729732036591, 0.283706903457642, 0.283684015274048, 0.283661037683487, 0.283638000488281, 0.283614844083786, 0.283591687679291, 0.283568412065506, 0.283545076847076, 0.283521682024002, 0.283498227596283, 0.283474683761597, 0.283451050519943, 0.283427387475967, 0.283403605222702, 0.283379793167114, 0.283355891704559, 0.283331960439682, 0.283307909965515, 0.283283799886703, 0.283259630203247, 0.283235371112823, 0.283211052417755, 0.28318664431572, 0.283162206411362, 0.283137679100037, 0.283113092184067, 0.28308841586113, 0.283063650131226, 0.283038854598999, 0.283013969659805, 0.282989025115967, 0.282963991165161, 0.282938897609711, 0.282913744449615, 0.282888472080231, 0.282863169908524, 0.282837808132172, 0.282812356948853, 0.282786846160889, 0.282761245965958, 0.282735586166382, 0.282709866762161, 0.282684057950974, 0.282658219337463, 0.282632261514664, 0.282606244087219, 0.28258016705513, 0.282554000616074, 0.282527804374695, 0.282501488924026, 0.282475113868713, 0.282448679208755, 0.282422184944153, 0.282395571470261, 0.282368957996368, 0.282342255115509, 0.28231543302536, 0.282288610935211, 0.28226163983345, 0.282234668731689, 0.282207578420639, 0.282180428504944, 0.282153218984604, 0.282125949859619, 0.28209862112999, 0.282071173191071, 0.282043665647507, 0.28201612830162, 0.281988471746445, 0.281960785388947, 0.281932979822159, 0.281905144453049, 0.281877219676971, 0.281849265098572, 0.281821191310883, 0.281793057918549, 0.281764835119247, 0.281736552715302, 0.281708240509033, 0.281679838895798, 0.281651318073273, 0.281622797250748, 0.281594157218933, 0.281565457582474, 0.28153669834137, 0.281507879495621, 0.281478971242905, 0.281450003385544, 0.281420916318893, 0.281391829252243, 0.281362593173981, 0.281333386898041, 0.281304061412811, 0.281274646520615, 0.281245172023773, 0.281215637922287, 0.281186014413834, 0.281156331300735, 0.281126588582993, 0.281096756458282, 0.28106689453125, 0.281036883592606, 0.281006872653961, 0.280976742506027, 0.280946582555771, 0.280916333198547, 0.280885994434357, 0.280855625867844, 0.280825167894363, 0.280794650316238, 0.280764013528824, 0.280733346939087, 0.280702620744705, 0.280671805143356, 0.280640929937363, 0.280609965324402, 0.280578941106796, 0.280547857284546, 0.280516684055328, 0.280485451221466, 0.280454158782959, 0.280422747135162, 0.280391335487366, 0.28035980463028, 0.280328214168549, 0.28029653429985, 0.28026482462883, 0.280233025550842, 0.280201137065887, 0.28016921877861, 0.280137211084366, 0.280105113983154, 0.280072957277298, 0.280040740966797, 0.280008465051651, 0.279976069927216, 0.279943645000458, 0.279911130666733, 0.279878556728363, 0.279845923185349, 0.279813200235367, 0.279780387878418, 0.279747545719147, 0.279714614152908, 0.279681622982025, 0.279648542404175, 0.27961540222168, 0.27958220243454, 0.279548913240433, 0.279515564441681, 0.279482156038284, 0.279448628425598, 0.27941507101059, 0.279381453990936, 0.279347717761993, 0.279313951730728, 0.279280096292496, 0.279246181249619, 0.279212206602097, 0.279178142547607, 0.279144018888474, 0.279109805822372, 0.279075533151627, 0.279041200876236, 0.279006779193878, 0.278972297906876, 0.278937757015228, 0.278903126716614, 0.278868436813354, 0.278833657503128, 0.278798818588257, 0.278763920068741, 0.278728932142258, 0.278693914413452, 0.278658777475357, 0.27862361073494, 0.278588324785233, 0.278552979230881, 0.278517603874207, 0.278482139110565, 0.278446614742279, 0.278410971164703, 0.278375297784805, 0.27833953499794, 0.278303742408752, 0.278267800807953, 0.278231829404831, 0.278195798397064, 0.278159737586975, 0.278123527765274, 0.278087288141251, 0.27805095911026, 0.278014600276947, 0.277978152036667, 0.27794161438942, 0.277905017137527, 0.277868330478668, 0.277831584215164, 0.277794778347015, 0.277757912874222, 0.277720928192139, 0.277683913707733, 0.277646839618683, 0.277609646320343, 0.277572423219681, 0.277535110712051, 0.277497738599777, 0.277460306882858, 0.277422785758972, 0.277385175228119, 0.277347505092621, 0.2773098051548, 0.27727198600769, 0.277234137058258, 0.277196168899536, 0.277158170938492, 0.27712008357048, 0.277081936597824, 0.277043730020523, 0.277005404233932, 0.276967018842697, 0.276928603649139, 0.276890128850937, 0.276851534843445, 0.276812881231308, 0.276774168014526, 0.276735365390778, 0.276696532964706, 0.276657581329346, 0.276618599891663, 0.27657949924469, 0.276540398597717, 0.276501148939133, 0.276461869478226, 0.276422530412674, 0.276383101940155, 0.276343613862991, 0.27630403637886, 0.276264399290085, 0.276224702596664, 0.276184916496277, 0.276145070791245, 0.276105135679245, 0.276065140962601, 0.276025116443634, 0.275984972715378, 0.275944769382477, 0.275904506444931, 0.275864154100418, 0.275823771953583, 0.275783270597458, 0.275742709636688, 0.275702118873596, 0.275661408901215, 0.275620639324188, 0.275579810142517, 0.275538891553879, 0.275497943162918, 0.275456875562668, 0.275415748357773, 0.275374561548233, 0.275333285331726, 0.275291979312897, 0.275250554084778, 0.275209099054337, 0.275167554616928, 0.275125950574875, 0.275084257125854, 0.275042533874512, 0.275000691413879, 0.274958789348602, 0.27491682767868, 0.274874806404114, 0.27483269572258, 0.274790525436401, 0.274748265743256, 0.274705946445465, 0.27466356754303, 0.274621099233627, 0.27457857131958, 0.274535983800888, 0.274493306875229, 0.274450570344925, 0.274407744407654, 0.274364858865738, 0.274321913719177, 0.274278879165649, 0.274235814809799, 0.274192631244659, 0.274149388074875, 0.274106085300446, 0.274062722921371, 0.27401927113533, 0.273975759744644, 0.273932129144669, 0.273888498544693, 0.27384477853775, 0.273800939321518, 0.273757100105286, 0.273713171482086, 0.273669123649597, 0.273625075817108, 0.27358090877533, 0.273536682128906, 0.273492395877838, 0.273448020219803, 0.273403584957123, 0.273359090089798, 0.273314505815506, 0.273269861936569, 0.273225158452988, 0.273180335760117, 0.273135483264923, 0.273090571165085, 0.273045569658279, 0.273000508546829, 0.272955358028412, 0.272910118103027, 0.272864878177643, 0.272819519042969, 0.27277410030365, 0.272728592157364, 0.272683024406433, 0.272637367248535, 0.272591680288315, 0.272545903921127, 0.272500067949295, 0.272454142570496, 0.272408157587051, 0.27236208319664, 0.272315979003906, 0.272269755601883, 0.272223502397537, 0.272177129983902, 0.272130727767944, 0.27208423614502, 0.27203768491745, 0.271991074085236, 0.271944403648376, 0.271897614002228, 0.271850764751434, 0.271803885698318, 0.271756917238235, 0.271709889173508, 0.27166274189949, 0.271615564823151, 0.271568298339844, 0.271520972251892, 0.271473556756973, 0.27142608165741, 0.271378546953201, 0.271330952644348, 0.271283268928528, 0.27123549580574, 0.271187663078308, 0.271139800548553, 0.271091818809509, 0.27104377746582, 0.270995706319809, 0.270947486162186, 0.270899266004562, 0.27085092663765, 0.270802557468414, 0.270754098892212, 0.270705580711365, 0.270656943321228, 0.270608305931091, 0.270559549331665, 0.270510733127594, 0.270461857318878, 0.270412892103195, 0.270363867282867, 0.270314753055573, 0.270265609025955, 0.270216375589371, 0.270167052745819, 0.270117700099945, 0.270068258047104, 0.270018726587296, 0.269969135522842, 0.269919484853745, 0.269869744777679, 0.26981994509697, 0.269770085811615, 0.269720137119293, 0.269670128822327, 0.269620060920715, 0.269569873809814, 0.269519686698914, 0.269469380378723, 0.269419014453888, 0.269368588924408, 0.269318073987961, 0.269267499446869, 0.26921683549881, 0.269166141748428, 0.269115328788757, 0.269064486026764, 0.269013553857803, 0.268962532281876, 0.268911510705948, 0.268860340118408, 0.268809109926224, 0.268757849931717, 0.268706530332565, 0.268655061721802, 0.268603563308716, 0.268552005290985, 0.26850038766861, 0.268448680639267, 0.26839691400528, 0.268345057964325, 0.268293142318726, 0.268241137266159, 0.268189072608948, 0.268136978149414, 0.268084734678268, 0.268032491207123, 0.26798015832901, 0.26792773604393, 0.267875224351883, 0.267822682857513, 0.267770081758499, 0.267717391252518, 0.267664641141891, 0.267611771821976, 0.267558872699738, 0.267505913972855, 0.267452836036682, 0.267399728298187, 0.267346560955048, 0.267293304204941, 0.267239958047867, 0.26718658208847, 0.267133086919785, 0.267079561948776, 0.267025917768478, 0.266972243785858, 0.266918510198593, 0.266864687204361, 0.266810774803162, 0.266756802797318, 0.266702771186829, 0.266648679971695, 0.266594469547272, 0.266540259122849, 0.266485929489136, 0.266431540250778, 0.266377091407776, 0.266322553157806, 0.266267955303192, 0.266213297843933, 0.266158550977707, 0.266103714704514, 0.266048848628998, 0.265993893146515, 0.265938878059387, 0.265883773565292, 0.265828609466553, 0.265773385763168, 0.265718072652817, 0.26566269993782, 0.265607237815857, 0.265551745891571, 0.265496164560318, 0.265440493822098, 0.265384763479233, 0.265328943729401, 0.265273094177246, 0.265217155218124, 0.265161126852036, 0.265105038881302, 0.265048921108246, 0.2649926841259, 0.26493638753891, 0.264880031347275, 0.26482355594635, 0.264767080545425, 0.264710485935211, 0.264653861522675, 0.264597117900848, 0.2645403444767, 0.264483481645584, 0.264426559209824, 0.264369547367096, 0.264312475919724, 0.264255344867706, 0.264198154211044, 0.264140844345093, 0.264083504676819, 0.264026075601578, 0.26396855711937, 0.263911008834839, 0.263853371143341, 0.263795673847198, 0.263737916946411, 0.263680040836334, 0.263622134923935, 0.263564139604568, 0.26350611448288, 0.263447970151901, 0.263389766216278, 0.26333150267601, 0.263273149728775, 0.263214737176895, 0.26315626502037, 0.263097703456879, 0.263039082288742, 0.262980371713638, 0.262921631336212, 0.262862771749496, 0.262803882360458, 0.262744903564453, 0.262685865163803, 0.262626737356186, 0.262567549943924, 0.262508302927017, 0.262448966503143, 0.262389570474625, 0.262330085039139, 0.262270539999008, 0.262210935354233, 0.262151271104813, 0.262091517448425, 0.262031674385071, 0.261971771717072, 0.261911809444427, 0.261851787567139, 0.261791676282883, 0.261731505393982, 0.261671245098114, 0.261610954999924, 0.261550545692444, 0.261490076780319, 0.26142954826355, 0.261368960142136, 0.261308282613754, 0.261247545480728, 0.261186748743057, 0.261125862598419, 0.261064887046814, 0.261003881692886, 0.260942816734314, 0.26088160276413, 0.260820388793945, 0.260759085416794, 0.260697692632675, 0.260636240243912, 0.260574728250504, 0.260513156652451, 0.26045149564743, 0.260389775037766, 0.260327965021133, 0.260266095399857, 0.260204166173935, 0.260142147541046, 0.26008003950119, 0.260017901659012, 0.259955674409866, 0.259893387556076, 0.259831011295319, 0.259768575429916, 0.259706079959869, 0.259643495082855, 0.259580880403519, 0.259518146514893, 0.259455382823944, 0.259392499923706, 0.259329587221146, 0.259266555309296, 0.259203523397446, 0.259140372276306, 0.259077161550522, 0.25901386141777, 0.258950501680374, 0.258887082338333, 0.258823603391647, 0.258760035037994, 0.258696377277374, 0.258632689714432, 0.2585688829422, 0.258505046367645, 0.258441120386124, 0.258377134799957, 0.258313089609146, 0.25824898481369, 0.258184790611267, 0.258120507001877, 0.258056163787842, 0.25799173116684, 0.257927268743515, 0.257862716913223, 0.257798075675964, 0.257733404636383, 0.257668644189835, 0.257603794336319, 0.257538884878159, 0.257473915815353, 0.257408887147903, 0.257343739271164, 0.257278561592102, 0.257213324308395, 0.257147967815399, 0.257082581520081, 0.257017105817795, 0.256951540708542, 0.256885945796967, 0.256820261478424, 0.256754517555237, 0.256688714027405, 0.256622821092606, 0.256556838750839, 0.256490796804428, 0.256424695253372, 0.256358534097672, 0.256292283535004, 0.256225943565369, 0.256159573793411, 0.256093114614487, 0.256026595830917, 0.255959987640381, 0.2558933198452, 0.255826562643051, 0.25575977563858, 0.25569286942482, 0.255625933408737, 0.255558907985687, 0.25549179315567, 0.255424648523331, 0.255357414484024, 0.25529009103775, 0.255222737789154, 0.255155265331268, 0.25508776307106, 0.255020171403885, 0.254952520132065, 0.254884779453278, 0.254816979169846, 0.254749119281769, 0.254681169986725, 0.254613161087036, 0.254545092582703, 0.254476934671402, 0.254408717155457, 0.254340410232544, 0.254272043704987, 0.254203617572784, 0.254135102033615, 0.254066526889801, 0.25399786233902, 0.253929167985916, 0.253860354423523, 0.253791511058807, 0.253722608089447, 0.253653585910797, 0.253584533929825, 0.253515362739563, 0.253446161746979, 0.253376871347427, 0.253307551145554, 0.25323811173439, 0.253168612718582, 0.253099054098129, 0.253029406070709, 0.252959698438644, 0.252889931201935, 0.252820074558258, 0.252750158309937, 0.25268018245697, 0.252610117197037, 0.252539992332458, 0.252469807863235, 0.252399533987045, 0.25232920050621, 0.252258777618408, 0.252188295125961, 0.25211775302887, 0.252047121524811, 0.251976430416107, 0.251905649900436, 0.251834839582443, 0.251763910055161, 0.251692950725555, 0.251621901988983, 0.251550763845444, 0.251479595899582, 0.251408338546753, 0.251336991786957, 0.251265585422516, 0.25119411945343, 0.2511225938797, 0.251050978899002, 0.25097930431366, 0.25090754032135, 0.250835716724396, 0.250763833522797, 0.25069186091423, 0.250619828701019, 0.250547736883163, 0.25047555565834, 0.250403314828873, 0.250330984592438, 0.250258594751358, 0.250186115503311, 0.250113606452942, 0.250041007995605, 0.249968335032463, 0.249895587563515, 0.249822780489922, 0.249749884009361, 0.249676942825317, 0.249603927135468, 0.249530822038651, 0.24945767223835, 0.249384433031082, 0.249311119318008, 0.249237760901451, 0.249164298176765, 0.249090790748596, 0.249017208814621, 0.24894355237484, 0.248869836330414, 0.248796015977859, 0.248722150921822, 0.248648181557655, 0.248574182391167, 0.248500108718872, 0.248425960540771, 0.248351722955704, 0.248277440667152, 0.248203054070473, 0.248128652572632, 0.248054146766663, 0.247979551553726, 0.247904896736145, 0.247830182313919, 0.24775542318821, 0.247680559754372, 0.247605621814728, 0.247530624270439, 0.247455537319183, 0.247380420565605, 0.247305199503899, 0.247229903936386, 0.24715456366539, 0.247079148888588, 0.247003644704819, 0.246928080916405, 0.246852442622185, 0.24677674472332, 0.246700957417488, 0.246625110507011, 0.246549189090729, 0.246473208069801, 0.246397152543068, 0.246321022510529, 0.246244847774506, 0.246168568730354, 0.246092215180397, 0.246015802025795, 0.245939329266548, 0.245862782001495, 0.245786160230637, 0.245709463953972, 0.245632693171501, 0.245555862784386, 0.245478942990303, 0.245401963591576, 0.245324939489365, 0.245247811079025, 0.245170637965202, 0.245093360543251, 0.245016038417816, 0.244938641786575, 0.244861170649529, 0.244783625006676, 0.244706019759178, 0.244628325104713, 0.244550585746765, 0.244472742080688, 0.244394868612289, 0.244316905736923, 0.24423885345459, 0.244160756468773, 0.24408258497715, 0.24400432407856, 0.243926018476486, 0.243847638368607, 0.24376916885376, 0.243690624833107, 0.243612036108971, 0.243533372879028, 0.243454620242119, 0.243375808000565, 0.243296936154366, 0.243217974901199, 0.243138954043388, 0.243059873580933, 0.24298070371151, 0.242901459336281, 0.242822170257568, 0.242742776870728, 0.242663323879242, 0.242583826184273, 0.242504224181175, 0.242424592375755, 0.242344841361046, 0.242265075445175, 0.242185175418854, 0.242105260491371, 0.242025226354599, 0.241945162415504, 0.241865009069443, 0.241784766316414, 0.241704493761063, 0.241624101996422, 0.241543680429459, 0.241463184356689, 0.241382613778114, 0.241301968693733, 0.241221234202385, 0.241140455007553, 0.241059571504593, 0.24097865819931, 0.240897670388222, 0.240816593170166, 0.240735456347466, 0.240654245018959, 0.240572959184647, 0.240491598844528, 0.240410178899765, 0.240328684449196, 0.240247130393982, 0.240165486931801, 0.240083768963814, 0.240001991391182, 0.239920154213905, 0.239838257431984, 0.239756256341934, 0.239674210548401, 0.239592060446739, 0.239509865641594, 0.239427581429482, 0.239345252513885, 0.239262863993645, 0.239180371165276, 0.2390978038311, 0.239015191793442, 0.238932505249977, 0.238849744200706, 0.23876690864563, 0.238683998584747, 0.238600999116898, 0.238517954945564, 0.238434836268425, 0.238351687788963, 0.238268420100212, 0.238185077905655, 0.238101691007614, 0.238018214702606, 0.237934678792953, 0.237851053476334, 0.237767368555069, 0.23768362402916, 0.237599790096283, 0.237511932849884, 0.237420111894608, 0.237328261137009, 0.23723641037941, 0.237144529819489, 0.237052634358406, 0.236960723996162, 0.236868754029274, 0.236776798963547, 0.236684814095497, 0.236592799425125, 0.236500769853592, 0.236408725380898, 0.236316666007042, 0.236224576830864, 0.236132472753525, 0.236040338873863, 0.235948204994202, 0.235856026411057, 0.235763847827911, 0.235671609640121, 0.235579401254654, 0.235487148165703, 0.235394880175591, 0.235302567481995, 0.23521026968956, 0.235117927193642, 0.235025584697723, 0.23493318259716, 0.234840795397758, 0.234748378396034, 0.234655931591988, 0.234563484787941, 0.23447097837925, 0.234378471970558, 0.234285950660706, 0.234193399548531, 0.234100848436356, 0.234008252620697, 0.233915656805038, 0.233823031187057, 0.233730375766754, 0.23363770544529, 0.233545020222664, 0.233452305197716, 0.233359575271606, 0.233266830444336, 0.233174040913582, 0.233081251382828, 0.232988446950912, 0.232895597815514, 0.232802763581276, 0.232709884643555, 0.232617005705833, 0.232524067163467, 0.232431128621101, 0.232338160276413, 0.232245191931725, 0.232152193784714, 0.232059180736542, 0.231966122984886, 0.231873065233231, 0.231779977679253, 0.231686875224113, 0.231593757867813, 0.231500595808029, 0.231407418847084, 0.2313142567873, 0.231221035122871, 0.231127813458443, 0.231034576892853, 0.230941295623779, 0.230847984552383, 0.230754673480988, 0.230661332607269, 0.230567991733551, 0.230474606156349, 0.230381220579147, 0.230287805199623, 0.230194374918938, 0.230100899934769, 0.230007439851761, 0.229913920164108, 0.229820430278778, 0.229726865887642, 0.229633331298828, 0.22953973710537, 0.229446157813072, 0.229352504014969, 0.229258865118027, 0.229165181517601, 0.229071512818336, 0.22897781431675, 0.228884071111679, 0.228790327906609, 0.228696554899216, 0.228602766990662, 0.228508964180946, 0.22841514647007, 0.228321269154549, 0.22822742164135, 0.228133499622345, 0.228039607405663, 0.227945655584335, 0.227851703763008, 0.227757722139359, 0.22766375541687, 0.227569729089737, 0.227475672960281, 0.227381601929665, 0.227287530899048, 0.227193415164948, 0.227099314332008, 0.227005168795586, 0.226911008358002, 0.226816818118095, 0.226722612977028, 0.22662840783596, 0.226534143090248, 0.226439878344536, 0.226345583796501, 0.226251274347305, 0.226156935095787, 0.226062595844269, 0.225968196988106, 0.225873827934265, 0.225779429078102, 0.225684985518456, 0.22559055685997, 0.225496053695679, 0.225401565432549, 0.225307047367096, 0.225212514400482, 0.225117936730385, 0.225023373961449, 0.224928766489029, 0.224834144115448, 0.224739521741867, 0.224644854664803, 0.224550172686577, 0.22445547580719, 0.224360749125481, 0.224265992641449, 0.224171236157417, 0.224076449871063, 0.223981633782387, 0.22388681769371, 0.223791971802711, 0.22369709610939, 0.223602205514908, 0.223507300019264, 0.223412379622459, 0.223317414522171, 0.223222449421883, 0.223127439618111, 0.223032414913177, 0.222937375307083, 0.222842335700989, 0.222747251391411, 0.222652152180672, 0.222557038068771, 0.22246190905571, 0.222366720438004, 0.222271546721458, 0.222176373004913, 0.222081124782562, 0.221985876560211, 0.22189062833786, 0.221795350313187, 0.22170002758503, 0.221604704856873, 0.221509352326393, 0.221413999795914, 0.221318602561951, 0.221223175525665, 0.221127763390541, 0.221032321453094, 0.220936864614487, 0.220841348171234, 0.220745846629143, 0.22065033018589, 0.220554754137993, 0.220459192991257, 0.220363572239876, 0.220267966389656, 0.220172330737114, 0.220076680183411, 0.219980984926224, 0.219885289669037, 0.219789579510689, 0.219693824648857, 0.219598084688187, 0.219502300024033, 0.219406470656395, 0.21931067109108, 0.21921481192112, 0.219118967652321, 0.219023063778877, 0.218927159905434, 0.218831211328506, 0.218735292553902, 0.218639299273491, 0.218543320894241, 0.218447297811508, 0.218351274728775, 0.218255206942558, 0.218159154057503, 0.218063056468964, 0.217966943979263, 0.217870801687241, 0.217774644494057, 0.217678472399712, 0.217582255601883, 0.217486038804054, 0.217389822006226, 0.217293545603752, 0.21719728410244, 0.217100962996483, 0.217004656791687, 0.216908276081085, 0.216811954975128, 0.216715559363365, 0.216619163751602, 0.216522708535194, 0.216426253318787, 0.21632981300354, 0.21623332798481, 0.216136813163757, 0.216040283441544, 0.215943738818169, 0.21584714949131, 0.215750575065613, 0.215653941035271, 0.21555732190609, 0.215460658073425, 0.215363994240761, 0.215267285704613, 0.215170577168465, 0.215073838829994, 0.214977085590363, 0.214880287647247, 0.214783504605293, 0.214686661958694, 0.214589834213257, 0.214492946863174, 0.214396089315414, 0.21429917216301, 0.214202255010605, 0.214105322957039, 0.214008346199989, 0.213911354541779, 0.213814347982407, 0.213717311620712, 0.213620290160179, 0.213523209095001, 0.213426113128662, 0.213329002261162, 0.213231861591339, 0.213134720921516, 0.21303753554821, 0.212940350174904, 0.212843120098114, 0.212745904922485, 0.212648645043373, 0.212551355361938, 0.212454050779343, 0.212356731295586, 0.212259396910667, 0.212162032723427, 0.212064668536186, 0.211967259645462, 0.211869820952415, 0.21177239716053, 0.211674943566322, 0.211577445268631, 0.211479932069778, 0.211382433772087, 0.211284846067429, 0.211187303066254, 0.211089685559273, 0.210992097854614, 0.210894450545311, 0.210796818137169, 0.210699126124382, 0.210601463913918, 0.210503742098808, 0.210406005382538, 0.210308253765106, 0.210210472345352, 0.210112661123276, 0.210014864802361, 0.209916993975639, 0.209819167852402, 0.209721252322197, 0.209623366594315, 0.20952545106411, 0.209427505731583, 0.209329530596733, 0.209231555461884, 0.209133550524712, 0.20903554558754, 0.208937495946884, 0.208839416503906, 0.208741322159767, 0.208643212914467, 0.208545088768005, 0.208446949720383, 0.208348780870438, 0.20825058221817, 0.20815235376358, 0.208054140210152, 0.207955896854401, 0.207857608795166, 0.207759335637093, 0.207660987973213, 0.207562685012817, 0.207464307546616, 0.207365944981575, 0.207267537713051, 0.207169130444527, 0.207070678472519, 0.20697221159935, 0.20687372982502, 0.206775233149529, 0.206676706671715, 0.206578150391579, 0.206479594111443, 0.206381022930145, 0.206282392144203, 0.206183776259422, 0.206085115671158, 0.205986455082893, 0.205887764692307, 0.20578907430172, 0.205690324306488, 0.205591574311256, 0.205492809414864, 0.205394014716148, 0.205295190215111, 0.205196380615234, 0.205097496509552, 0.204998627305031, 0.204899713397026, 0.204800814390182, 0.204701870679855, 0.204602912068367, 0.204503923654556, 0.204404920339584, 0.204305917024612, 0.204206854104996, 0.20410780608654, 0.204008713364601, 0.203909605741501, 0.203810513019562, 0.203711345791817, 0.203612193465233, 0.203512996435165, 0.203413799405098, 0.203314557671547, 0.203215301036835, 0.203116029500961, 0.203016743063927, 0.202917441725731, 0.20281808078289, 0.202718749642372, 0.20261937379837, 0.202519953250885, 0.202420547604561, 0.202321141958237, 0.202221646904945, 0.202122196555138, 0.202022686600685, 0.201923176646233, 0.201823621988297, 0.20172406733036, 0.201624467968941, 0.201524883508682, 0.20142525434494, 0.201325625181198, 0.201225936412811, 0.201126262545586, 0.201026558876038, 0.200926840305328, 0.200827062129974, 0.200727313756943, 0.200627520680428, 0.20052769780159, 0.200427874922752, 0.200328022241592, 0.200228154659271, 0.200128242373466, 0.200028330087662, 0.199928402900696, 0.199828431010246, 0.199728488922119, 0.199628457427025, 0.199528455734253, 0.199428424239159, 0.199328362941742, 0.199228271842003, 0.199128180742264, 0.199028044939041, 0.198927909135818, 0.198827758431435, 0.198727563023567, 0.198627352714539, 0.198527112603188, 0.198426887392998, 0.198326617479324, 0.19822633266449, 0.198126032948494, 0.198025718331337, 0.197925344109535, 0.197824969887733, 0.197724580764771, 0.197624161839485, 0.197523713111877, 0.197423279285431, 0.197322815656662, 0.197222322225571, 0.197121784090996, 0.197021260857582, 0.196920678019524, 0.196820124983788, 0.196719527244568, 0.196618899703026, 0.196518272161484, 0.196417599916458, 0.196316912770271, 0.196216210722923, 0.196115493774414, 0.196014732122421, 0.195913970470428, 0.195813193917274, 0.195712387561798, 0.195611536502838, 0.195510700345039, 0.195409834384918, 0.195308938622475, 0.195208042860031, 0.195107102394104, 0.195006161928177, 0.194905176758766, 0.194804191589355, 0.194703176617622, 0.194602146744728, 0.194501087069511, 0.194399982690811, 0.194298908114433, 0.194197788834572, 0.194096654653549, 0.193995490670204, 0.193894311785698, 0.193793118000031, 0.193691894412041, 0.193590626120567, 0.193489387631416, 0.193388074636459, 0.193286791443825, 0.193185448646545, 0.193084120750427, 0.192982733249664, 0.192881360650063, 0.192779928445816, 0.192678511142731, 0.192577064037323, 0.192475602030754, 0.19237408041954, 0.192272588610649, 0.192171052098274, 0.192069500684738, 0.191967934370041, 0.191866338253021, 0.191764697432518, 0.191663056612015, 0.191561415791512, 0.191459715366364, 0.191358044743538, 0.191256299614906, 0.191154554486275, 0.191052809357643, 0.190951019525528, 0.190849214792252, 0.190747380256653, 0.190645560622215, 0.190543666481972, 0.190441817045212, 0.190339893102646, 0.19023796916008, 0.190136015415192, 0.190034046769142, 0.189932063221931, 0.189830049872398, 0.189728036522865, 0.189625963568687, 0.18952389061451, 0.189421787858009, 0.189319685101509, 0.189217537641525, 0.18911537528038, 0.189013198018074, 0.188911035656929, 0.188808783888817, 0.188706561923027, 0.188604295253754, 0.188502013683319, 0.188399687409401, 0.188297390937805, 0.188195049762726, 0.188092678785324, 0.1879902780056, 0.187887892127037, 0.187785446643829, 0.187683016061783, 0.187580540776253, 0.187478065490723, 0.187375545501709, 0.187273010611534, 0.187170460820198, 0.187067896127701, 0.186965301632881, 0.1868626922369, 0.186760053038597, 0.186657384037971, 0.186554700136185, 0.186452031135559, 0.18634931743145, 0.186246559023857, 0.186143800616264, 0.18604102730751, 0.185938209295273, 0.185835421085358, 0.185732588171959, 0.185629710555077, 0.185526818037033, 0.185423910617828, 0.185321003198624, 0.185218051075935, 0.185115069150925, 0.185012087225914, 0.184909090399742, 0.184806078672409, 0.184703022241592, 0.184599936008453, 0.184496864676476, 0.184393733739853, 0.18429060280323, 0.184187442064285, 0.18408428132534, 0.183981090784073, 0.183877855539322, 0.183774620294571, 0.18367138504982, 0.183568090200424, 0.18346481025219, 0.183361455798149, 0.183258131146431, 0.18315477669239, 0.183051407337189, 0.182947993278503, 0.182844579219818, 0.182741120457649, 0.18263766169548, 0.182534158229828, 0.182430654764175, 0.182327136397362, 0.182223603129387, 0.182120025157928, 0.182016432285309, 0.181912824511528, 0.181809186935425, 0.18170553445816, 0.181601881980896, 0.181498169898987, 0.1813944876194, 0.181290730834007, 0.181186974048615, 0.181083232164383, 0.180979415774345, 0.180875599384308, 0.180771753191948, 0.180667892098427, 0.180564016103745, 0.18046011030674, 0.180356204509735, 0.180252239108086, 0.180148273706436, 0.180044308304787, 0.179940283298492, 0.179836288094521, 0.179732248187065, 0.179628163576126, 0.179524049162865, 0.179419979453087, 0.179315820336342, 0.179211676120758, 0.179107502102852, 0.179003313183784, 0.178899109363556, 0.178794875741005, 0.178690612316132, 0.178586333990097, 0.178482055664062, 0.178377732634544, 0.178273409605026, 0.178169041872025, 0.1780646443367, 0.177960261702538, 0.177855849266052, 0.177751421928406, 0.177646949887276, 0.177542477846146, 0.177437961101532, 0.177333429455757, 0.177228882908821, 0.177124336361885, 0.177019745111465, 0.176915138959885, 0.176810503005981, 0.176705881953239, 0.176601186394691, 0.176496505737305, 0.176391795277596, 0.176287055015564, 0.176182299852371, 0.176077544689178, 0.175972744822502, 0.175867930054665, 0.175763085484505, 0.175658240914345, 0.175553351640701, 0.175448447465897, 0.175343558192253, 0.175238594412804, 0.175133660435677, 0.175028666853905, 0.174923673272133, 0.174818649888039, 0.174713596701622, 0.174608528614044, 0.174503460526466, 0.174398362636566, 0.174293220043182, 0.174188077449799, 0.174082934856415, 0.173977717757225, 0.173872515559196, 0.173767298460007, 0.173662036657333, 0.17355677485466, 0.173451483249664, 0.173346161842346, 0.173240855336189, 0.173135474324226, 0.173030108213425, 0.172924712300301, 0.172819301486015, 0.172713860869408, 0.172608390450478, 0.172502905130386, 0.172397419810295, 0.17229188978672, 0.172186359763145, 0.172080814838409, 0.171975210309029, 0.171869620680809, 0.171764001250267, 0.171658352017403, 0.171552672982216, 0.17144700884819, 0.171341270208359, 0.171235546469688, 0.171129807829857, 0.171024054288864, 0.170918241143227, 0.17081244289875, 0.170706629753113, 0.170600771903992, 0.170494884252548, 0.170388996601105, 0.170283064246178, 0.170177161693573, 0.170071184635162, 0.169965207576752, 0.169859185814857, 0.169753208756447, 0.16964715719223, 0.169541105628014, 0.169435009360313, 0.169328898191452, 0.169222787022591, 0.169116646051407, 0.169010475277901, 0.168904304504395, 0.168798089027405, 0.168691843748093, 0.168585613369942, 0.168479353189468, 0.168373048305511, 0.168266743421555, 0.168160423636436, 0.168054074048996, 0.167947694659233, 0.16784131526947, 0.167734876275063, 0.167628467082977, 0.16752202808857, 0.167415544390678, 0.167309030890465, 0.167202532291412, 0.167095988988876, 0.16698944568634, 0.166882857680321, 0.16677625477314, 0.166669636964798, 0.166562974452972, 0.166456326842308, 0.166349664330482, 0.166242957115173, 0.166136220097542, 0.16602948307991, 0.165922701358795, 0.165815934538841, 0.165709108114243, 0.165602281689644, 0.165495425462723, 0.165388569235802, 0.165281698107719, 0.165174782276154, 0.165067836642265, 0.164960891008377, 0.164853900671005, 0.164746925234795, 0.1646399050951, 0.164532855153084, 0.164425805211067, 0.164318740367889, 0.164211645722389, 0.164104521274567, 0.163997367024422, 0.163890227675438, 0.163783028721809, 0.163675829768181, 0.16356860101223, 0.163461357355118, 0.163354083895683, 0.16324682533741, 0.163139507174492, 0.163032174110413, 0.162924826145172, 0.162817478179932, 0.162710085511208, 0.162602663040161, 0.162495240569115, 0.162387788295746, 0.162280336022377, 0.162172824144363, 0.162065342068672, 0.161957770586014, 0.161850214004517, 0.161742657423019, 0.161635056138039, 0.161527439951897, 0.161419808864594, 0.161312147974968, 0.161204472184181, 0.161096766591072, 0.160989046096802, 0.16088131070137, 0.160773530602455, 0.160665765404701, 0.160557970404625, 0.160450115799904, 0.160342290997505, 0.160234421491623, 0.160126537084579, 0.160018622875214, 0.159910708665848, 0.159802734851837, 0.159694775938988, 0.159586772322655, 0.159478783607483, 0.159370735287666, 0.15926268696785, 0.159154608845711, 0.159046530723572, 0.158938407897949, 0.158830255270004, 0.158722117543221, 0.158613950014114, 0.158505722880363, 0.158397525548935, 0.158289268612862, 0.15818102657795, 0.158072754740715, 0.157964438199997, 0.157856121659279, 0.157747775316238, 0.157639414072037, 0.157531023025513, 0.157422631978989, 0.157314196228981, 0.157205760478973, 0.157097265124321, 0.15698878467083, 0.156880289316177, 0.156771749258041, 0.156663194298744, 0.156554609537125, 0.156446039676666, 0.156337440013885, 0.15622878074646, 0.156120136380196, 0.156011447310448, 0.1559027582407, 0.155794024467468, 0.155685305595398, 0.155576527118683, 0.155467748641968, 0.155358955264091, 0.155250146985054, 0.155141294002533, 0.155032426118851, 0.154923543334007, 0.154814645648003, 0.154705733060837, 0.154596775770187, 0.154487818479538, 0.154378816485405, 0.154269814491272, 0.154160782694817, 0.1540517359972, 0.153942674398422, 0.153833568096161, 0.1537244617939, 0.153615325689316, 0.153506174683571, 0.153396993875504, 0.153287813067436, 0.153178602457047, 0.153069362044334, 0.152960121631622, 0.152850836515427, 0.152741521596909, 0.152632206678391, 0.152522876858711, 0.152413502335548, 0.152304127812386, 0.1521947234869, 0.152085304260254, 0.151975855231285, 0.151866376399994, 0.151756882667542, 0.151647388935089, 0.151537880301476, 0.151428326964378, 0.151318743824959, 0.1512091755867, 0.151099547743797, 0.150989934802055, 0.15088027715683, 0.150770604610443, 0.150660887360573, 0.150551199913025, 0.150441452860832, 0.15033170580864, 0.150221914052963, 0.150112137198448, 0.15000231564045, 0.14989247918129, 0.149782612919807, 0.149672731757164, 0.149562850594521, 0.149452924728394, 0.149342969059944, 0.149232998490334, 0.149123027920723, 0.14901302754879, 0.148902997374535, 0.148792952299118, 0.148682877421379, 0.14857280254364, 0.148462697863579, 0.148352548480034, 0.148242428898811, 0.148132249712944, 0.148022055625916, 0.147911831736565, 0.147801607847214, 0.14769135415554, 0.147581085562706, 0.147470787167549, 0.14736045897007, 0.147250130772591, 0.147139772772789, 0.147029370069504, 0.146918997168541, 0.146808564662933, 0.146698147058487, 0.146587654948235, 0.146477207541466, 0.14636667072773, 0.146256163716316, 0.146145597100258, 0.146035060286522, 0.145924463868141, 0.14581386744976, 0.145703226327896, 0.145592585206032, 0.145481914281845, 0.145371228456497, 0.145260512828827, 0.145149797201157, 0.145039021968842, 0.144928261637688, 0.14481745660305, 0.144706651568413, 0.144595816731453, 0.144484952092171, 0.144374072551727, 0.144263178110123, 0.144152268767357, 0.144041314721107, 0.143930375576019, 0.143819391727448, 0.143708407878876, 0.143597364425659, 0.143486335873604, 0.143375247716904, 0.143264189362526, 0.143153071403503, 0.143041953444481, 0.142930805683136, 0.14281964302063, 0.142708450555801, 0.142597243189812, 0.1424860060215, 0.142374768853188, 0.142263486981392, 0.142152205109596, 0.142040893435478, 0.141929551959038, 0.141818195581436, 0.141706839203835, 0.141595423221588, 0.141484022140503, 0.141372561454773, 0.141261115670204, 0.141149625182152, 0.141038134694099, 0.140926614403725, 0.140815079212189, 0.14070351421833, 0.140591934323311, 0.140480324625969, 0.140368700027466, 0.140257060527802, 0.140145406126976, 0.140033707022667, 0.139922007918358, 0.139810279011726, 0.139698535203934, 0.139586761593819, 0.139474973082542, 0.139363154768944, 0.139251321554184, 0.139139473438263, 0.13902759552002, 0.138915702700615, 0.138803794980049, 0.138691857457161, 0.138579905033112, 0.138467937707901, 0.138355940580368, 0.138243928551674, 0.138131871819496, 0.138019815087318, 0.137907743453979, 0.137795642018318, 0.137683510780334, 0.137571379542351, 0.137459203600883, 0.137347012758255, 0.137234807014465, 0.137122586369514, 0.137010335922241, 0.136898070573807, 0.13678577542305, 0.136673495173454, 0.136561155319214, 0.136448800563812, 0.136336430907249, 0.136224031448364, 0.136111617088318, 0.13599918782711, 0.13588672876358, 0.135774254798889, 0.135661765933037, 0.135549247264862, 0.135436698794365, 0.135327830910683, 0.135222524404526, 0.135117292404175, 0.135012060403824, 0.134906888008118, 0.13480170071125, 0.134696573019028, 0.134591460227966, 0.13448640704155, 0.134381353855133, 0.1342763453722, 0.134171336889267, 0.134066388010979, 0.133961468935013, 0.133856594562531, 0.133751720190048, 0.133646890521049, 0.133542105555534, 0.133437320590019, 0.133332580327988, 0.133227854967117, 0.133123204112053, 0.133018538355827, 0.132913917303085, 0.132809326052666, 0.13270477950573, 0.132600232958794, 0.132495760917664, 0.132391288876534, 0.132286846637726, 0.132182419300079, 0.132078066468239, 0.131973698735237, 0.131869420409203, 0.131765112280846, 0.131660878658295, 0.131556630134583, 0.131452456116676, 0.131348267197609, 0.131244137883186, 0.131140038371086, 0.131035983562469, 0.130931928753853, 0.13082791864872, 0.130723938345909, 0.130619987845421, 0.130516082048416, 0.130412191152573, 0.13030831515789, 0.130204498767853, 0.130100697278976, 0.129996925592422, 0.129893183708191, 0.129789486527443, 0.129685804247856, 0.129582166671753, 0.12947852909565, 0.129374951124191, 0.129271402955055, 0.129167884588242, 0.12906439602375, 0.128960907459259, 0.128857508301735, 0.128754079341888, 0.128650709986687, 0.128547370433807, 0.12844406068325, 0.128340795636177, 0.128237530589104, 0.128134295344353, 0.128031119704247, 0.127927958965302, 0.12782484292984, 0.127721711993217, 0.127618670463562, 0.127515599131584, 0.127412617206573, 0.127309620380402, 0.127206683158875, 0.127103790640831, 0.127000883221626, 0.126898035407066, 0.126795202493668, 0.126692414283752, 0.126589640974998, 0.126486912369728, 0.126384198665619, 0.126281529664993, 0.126178875565529, 0.126076266169548, 0.125973701477051, 0.125871136784554, 0.125768631696701, 0.125666126608849, 0.12556366622448, 0.125461235642433, 0.12535884976387, 0.125256463885307, 0.12515415251255, 0.125051811337471, 0.124949537217617, 0.124847285449505, 0.124745078384876, 0.12464290112257, 0.124540731310844, 0.124438613653183, 0.124336510896683, 0.124234460294247, 0.124132394790649, 0.124030418694019, 0.123928427696228, 0.123826488852501, 0.123724579811096, 0.123622685670853, 0.123520828783512, 0.123419024050236, 0.12331722676754, 0.123215459287167, 0.123113699257374, 0.123012028634548, 0.122910358011723, 0.122808702290058, 0.122707106173038, 0.122605539858341, 0.122503958642483, 0.12240244448185, 0.122300952672958, 0.12219949811697, 0.122098073363304, 0.121996693313122, 0.121895305812359, 0.121793977916241, 0.121692664921284, 0.12159138917923, 0.121490128338337, 0.121388927102089, 0.121287748217583, 0.121186599135399, 0.121085457503796, 0.120984390377998, 0.120883300900459, 0.120782278478146, 0.120681278407574, 0.120580300688744, 0.120479352772236, 0.120378449559212, 0.120277561247349, 0.120176732540131, 0.120075926184654, 0.119975112378597, 0.119874365627766, 0.119773618876934, 0.119672916829586, 0.119572259485722, 0.119471624493599, 0.119371019303799, 0.119270443916321, 0.119169875979424, 0.119069382548332, 0.11896887421608, 0.118868440389633, 0.118768006563187, 0.118667609989643, 0.118567235767841, 0.118466913700104, 0.118366591632366, 0.118266344070435, 0.118166103959084, 0.118065886199474, 0.117965705692768, 0.117865547537804, 0.117765426635742, 0.117665335536003, 0.117565289139748, 0.117465257644653, 0.117365255951881, 0.117265269160271, 0.117165334522724, 0.117065422236919, 0.116965562105179, 0.116865701973438, 0.116765901446342, 0.116666108369827, 0.116566352546215, 0.116466626524925, 0.116366930305958, 0.116267286241055, 0.116167642176151, 0.116068050265312, 0.115968458354473, 0.115868903696537, 0.115769386291504, 0.115669921040535, 0.115570455789566, 0.115471042692661, 0.115371651947498, 0.115272291004658, 0.115172952413559, 0.115073651075363, 0.114974394440651, 0.1148751527071, 0.114775940775871, 0.114676758646965, 0.114577598869801, 0.114478498697281, 0.114379405975342, 0.114280335605145, 0.114181324839592, 0.114082314074039, 0.113983362913132, 0.113884396851063, 0.113785527646542, 0.113686636090279, 0.11358779668808, 0.113488964736462, 0.113390199840069, 0.113291412591934, 0.113192722201347, 0.11309402436018, 0.112995371222496, 0.112896725535393, 0.112798139452934, 0.112699553370476, 0.112601026892662, 0.11250251531601, 0.112404018640518, 0.112305574119091, 0.112207151949406, 0.112108744680882, 0.112010411918163, 0.111912079155445, 0.11181378364563, 0.111715532839298, 0.111617274582386, 0.111519075930119, 0.111420892179012, 0.111322775483131, 0.11122465133667, 0.111126571893692, 0.111028485000134, 0.110930487513542, 0.110832467675209, 0.110734522342682, 0.110636584460735, 0.110538676381111, 0.11044080555439, 0.110342964529991, 0.110245153307915, 0.110147386789322, 0.110049642622471, 0.109951913356781, 0.109854198992252, 0.10975655913353, 0.109658934175968, 0.109561309218407, 0.10946374386549, 0.109366208314896, 0.109268695116043, 0.109171241521835, 0.109073802828789, 0.108976386487484, 0.108879014849663, 0.10878162831068, 0.108684316277504, 0.108587011694908, 0.108489759266376, 0.108392506837845, 0.108295314013958, 0.108198128640652, 0.108100987970829, 0.108003862202168, 0.107906818389893, 0.107809759676456, 0.107712745666504, 0.107615739107132, 0.107518777251244, 0.107421852648258, 0.107324950397015, 0.107228092849255, 0.107131220400333, 0.107034422457218, 0.106937639415264, 0.106840901076794, 0.106744214892387, 0.106647521257401, 0.106550864875317, 0.106454223394394, 0.106357611715794, 0.106261059641838, 0.106164529919624, 0.106068007647991, 0.105971537530422, 0.105875089764595, 0.105778694152832, 0.105682283639908, 0.105585917830467, 0.105489648878574, 0.10539335757494, 0.105297096073627, 0.105200834572315, 0.10510465502739, 0.105008490383625, 0.104912333190441, 0.10481620579958, 0.104720123112202, 0.104624092578888, 0.104528084397316, 0.104432053864002, 0.104336120188236, 0.104240216314793, 0.104144334793091, 0.104048438370228, 0.10395260900259, 0.103856794536114, 0.103761024773121, 0.103665240108967, 0.103569559752941, 0.103473871946335, 0.103378243744373, 0.103282578289509, 0.103186972439289, 0.103091470897198, 0.102995917201042, 0.102900423109531, 0.102804943919182, 0.102709494531155, 0.102614104747772, 0.102518729865551, 0.102423340082169, 0.102328017354012, 0.102232754230499, 0.102137498557568, 0.102042257785797, 0.101947046816349, 0.101851925253868, 0.101756781339645, 0.101661659777164, 0.101566575467587, 0.101471535861492, 0.10137652605772, 0.101281531155109, 0.101186566054821, 0.101091645658016, 0.100996755063534, 0.100901879370213, 0.100807048380375, 0.10071224719286, 0.100617498159409, 0.100522741675377, 0.100428037345409, 0.100333355367184, 0.100238718092442, 0.100144065916538, 0.100049488246441, 0.0999549329280853, 0.0998603999614716, 0.0997658893465996, 0.0996714234352112, 0.099576972424984, 0.0994826257228851, 0.0993881970643997, 0.0992938876152039, 0.0991995558142662, 0.0991052687168121, 0.0990110114216805, 0.0989167764782906, 0.0988225862383842, 0.0987284258008003, 0.0986342951655388, 0.0985401719808578, 0.0984461084008217, 0.0983520448207855, 0.0982580706477165, 0.0981640741229057, 0.0980701148509979, 0.0979762077331543, 0.0978823229670525, 0.0977884382009506, 0.097694605588913, 0.0976008251309395, 0.0975070372223854, 0.0974132865667343, 0.0973195806145668, 0.0972259044647217, 0.0971322506666183, 0.0970386490225792, 0.0969450697302818, 0.0968515276908875, 0.0967579931020737, 0.0966644808650017, 0.0965709909796715, 0.0964775756001472, 0.0963841751217842, 0.0962907746434212, 0.0961974412202835, 0.0961041375994682, 0.0960108637809753, 0.0959176123142242, 0.0958243981003761, 0.095731221139431, 0.0956380590796471, 0.0955448895692825, 0.095451794564724, 0.0953587219119072, 0.095265693962574, 0.0951726585626602, 0.09507966786623, 0.0949867367744446, 0.0948938280344009, 0.0948009490966797, 0.0947080925107002, 0.094615250825882, 0.0945224612951279, 0.0944297015666962, 0.0943369418382645, 0.0942442491650581, 0.0941515937447548, 0.094058945775032, 0.0939662829041481, 0.0938737243413925, 0.0937811806797981, 0.0936886519193649, 0.0935961455106735, 0.0935036987066269, 0.0934112891554832, 0.0933188945055008, 0.0932265073060989, 0.0931341573596001, 0.0930418446660042, 0.0929495617747307, 0.0928572937846184, 0.0927650704979897, 0.0926728919148445, 0.0925807356834412, 0.092488594353199, 0.092396542429924, 0.092304453253746, 0.0922124162316322, 0.0921204015612602, 0.0920284315943718, 0.091936469078064, 0.0918445810675621, 0.0917526856064796, 0.091660812497139, 0.0915689840912819, 0.0914772003889084, 0.0913854241371155, 0.0912936925888062, 0.0912020280957222, 0.0911103561520576, 0.0910186767578125, 0.0909270867705345, 0.0908355042338371, 0.0907439440488815, 0.0906524285674095, 0.0905609279870987, 0.0904694572091103, 0.0903780311346054, 0.0902866497635841, 0.0901952609419823, 0.0901039317250252, 0.0900126323103905, 0.0899213626980782, 0.089830107986927, 0.0897388905286789, 0.0896477177739143, 0.0895565450191498, 0.0894654169678688, 0.0893743112683296, 0.0892832726240158, 0.0891922265291214, 0.0891011953353882, 0.0890102386474609, 0.0889193192124367, 0.0888284221291542, 0.0887375101447105, 0.0886466577649117, 0.0885558426380157, 0.0884650573134422, 0.0883742645382881, 0.08828354626894, 0.0881928578019142, 0.0881021842360497, 0.0880115032196045, 0.0879209190607071, 0.0878303498029709, 0.0877398177981377, 0.0876492708921432, 0.0875588059425354, 0.0874683633446693, 0.0873779505491257, 0.0872875079512596, 0.0871971547603607, 0.0871068313717842, 0.0870165154337883, 0.0869261994957924, 0.0868359506130219, 0.0867457538843155, 0.0866555944085121, 0.0865654796361923, 0.0864753276109695, 0.0863852277398109, 0.0862951651215553, 0.0862051621079445, 0.0861151143908501, 0.0860251411795616, 0.0859352052211761, 0.0858453214168549, 0.0857554003596306, 0.0856655612587929, 0.085575744509697, 0.0854860097169876, 0.0853962153196335, 0.0853064805269241, 0.085216797888279, 0.0851271450519562, 0.0850374922156334, 0.0849478766322136, 0.0848583057522774, 0.0847687646746635, 0.0846792161464691, 0.0845897495746613, 0.0845002830028534, 0.0844108611345291, 0.0843214988708496, 0.0842321366071701, 0.0841427966952324, 0.0840535014867783, 0.0839642137289047, 0.0838749781250954, 0.0837857499718666, 0.083696573972702, 0.0836074128746986, 0.0835183039307594, 0.0834292098879814, 0.083340160548687, 0.0832510963082314, 0.0831621438264847, 0.083073191344738, 0.0829842463135719, 0.0828953385353088, 0.0828064382076263, 0.0827176198363304, 0.0826287865638733, 0.0825399979948997, 0.082451231777668, 0.0823625102639198, 0.0822738036513329, 0.0821851491928101, 0.0820965468883514, 0.0820079371333122, 0.0819193795323372, 0.081830807030201, 0.0817422866821289, 0.0816538259387016, 0.0815653577446938, 0.0814769417047501, 0.0813885405659676, 0.0813001692295074, 0.0812118574976921, 0.0811235457658768, 0.0810352712869644, 0.0809470638632774, 0.0808588564395905, 0.0807706788182259, 0.0806825011968613, 0.0805944129824638, 0.0805063471198082, 0.080418273806572, 0.0803302228450775, 0.0802422240376472, 0.0801542773842812, 0.0800663381814957, 0.0799784064292908, 0.0798905268311501, 0.0798027366399765, 0.0797149166464806, 0.0796271115541458, 0.0795393511652946, 0.0794516578316689, 0.0793639644980431, 0.0792762860655785, 0.0791886448860168, 0.0791010558605194, 0.0790134742856026, 0.0789259448647499, 0.0788384154438972, 0.0787509679794312, 0.0786635130643845, 0.0785761252045631, 0.078488714993, 0.0784013494849205, 0.0783140361309052, 0.078226737678051, 0.0781394317746162, 0.0780522078275681, 0.0779650136828423, 0.0778778269886971, 0.0777906700968742, 0.0777035653591156, 0.0776165202260017, 0.0775294601917267, 0.0774424374103546, 0.0773554220795631, 0.077268473803997, 0.0771815329790115, 0.0770946368575096, 0.0770077556371689, 0.0769209191203117, 0.0768341049551964, 0.0767473131418228, 0.0766605511307716, 0.0765738412737846, 0.0764871835708618, 0.0764005109667778, 0.0763138979673386, 0.0762272998690605, 0.0761407390236855, 0.0760541707277298, 0.0759676769375801, 0.0758811980485916, 0.0757947489619255, 0.0757083147764206, 0.0756219476461411, 0.0755355805158615, 0.0754492953419685, 0.0753629878163338, 0.0752767398953438, 0.0751905143260956, 0.075104296207428, 0.075018122792244, 0.0749319642782211, 0.0748458728194237, 0.0747597813606262, 0.0746737346053123, 0.0745877027511597, 0.07450170814991, 0.0744157359004021, 0.0743298456072807, 0.0742439329624176, 0.0741580799221992, 0.0740722492337227, 0.0739864334464073, 0.0739006325602531, 0.0738148912787437, 0.0737291723489761, 0.0736434981226921, 0.0735578164458275, 0.0734722018241882, 0.0733866095542908, 0.0733010470867157, 0.0732155218720436, 0.0731300190091133, 0.0730445608496666, 0.0729591250419617, 0.072873666882515, 0.072788305580616, 0.0727029591798782, 0.0726176351308823, 0.0725323110818863, 0.0724470540881157, 0.0723618343472481, 0.0722766444087029, 0.0721914693713188, 0.072106346487999, 0.0720212534070015, 0.0719361901283264, 0.0718510895967484, 0.0717660784721375, 0.0716810971498489, 0.0715961456298828, 0.0715112388134003, 0.0714263170957565, 0.071341447532177, 0.071256622672081, 0.0711718127131462, 0.071087047457695, 0.0710023045539856, 0.0709175914525986, 0.0708329230546951, 0.0707482472062111, 0.0706636235117912, 0.0705790370702744, 0.0704944804310799, 0.0704099237918854, 0.0703254342079163, 0.0702409744262695, 0.070156529545784, 0.0700721368193626, 0.0699877515435219, 0.0699034184217453, 0.0698191002011299, 0.0697347819805145, 0.0696505233645439, 0.0695662945508957, 0.0694821178913116, 0.0693979263305664, 0.0693137869238853, 0.0692296922206879, 0.0691456198692322, 0.0690615624189377, 0.0689775571227074, 0.06889358907938, 0.0688096359372139, 0.068725697696209, 0.0686418116092682, 0.0685579553246498, 0.0684741288423538, 0.0683903023600578, 0.0683065429329872, 0.068222776055336, 0.0681390762329102, 0.0680553764104843, 0.0679717287421227, 0.067888155579567, 0.0678045675158501, 0.0677210241556168, 0.0676374658942223, 0.0675539746880531, 0.067470483481884, 0.0673870518803596, 0.0673036351799965, 0.0672202855348587, 0.0671369209885597, 0.0670536011457443, 0.0669702962040901, 0.0668870881199837, 0.0668038576841354, 0.0667206645011902, 0.0666374862194061, 0.0665543600916862, 0.06647127866745, 0.0663881748914719, 0.0663051307201385, 0.0662221312522888, 0.0661391541361809, 0.0660561919212341, 0.065973237156868, 0.0658903643488884, 0.0658075511455536, 0.0657247081398964, 0.0656418949365616, 0.0655591487884521, 0.0654763951897621, 0.0653937011957169, 0.0653109848499298, 0.0652283430099487, 0.0651457384228706, 0.0650631710886955, 0.0649805814027786, 0.0648980513215065, 0.0648155584931374, 0.0647331327199936, 0.0646506696939468, 0.0645682662725449, 0.0644859150052071, 0.0644035786390305, 0.0643212273716927, 0.0642389580607414, 0.0641566962003708, 0.0640745013952255, 0.0639922916889191, 0.0639101043343544, 0.0638279840350151, 0.0637459233403206, 0.0636638626456261, 0.063581794500351, 0.0634997859597206, 0.0634178146719933, 0.0633358731865883, 0.0632539242506027, 0.0631720423698425, 0.0630902051925659, 0.0630083754658699, 0.0629265457391739, 0.0628447979688644, 0.0627630650997162, 0.0626813992857933, 0.0625997111201286, 0.0625180378556252, 0.0624364502727985, 0.0623548738658428, 0.0622733011841774, 0.0621917694807053, 0.0621102787554264, 0.0620288290083408, 0.0619473643600941, 0.0618659667670727, 0.0617846176028252, 0.0617032758891582, 0.0616219863295555, 0.0615407153964043, 0.0614594407379627, 0.0613782443106174, 0.0612970180809498, 0.0612158924341202, 0.0611347258090973, 0.0610536597669125, 0.0609725788235664, 0.060891542583704, 0.060810524970293, 0.0607295669615269, 0.0606486275792122, 0.0605677217245102, 0.0604868419468403, 0.0604059807956219, 0.0603251494467258, 0.0602443479001522, 0.0601635836064816, 0.0600828491151333, 0.0600021444261074, 0.0599214658141136, 0.059840839356184, 0.0597601979970932, 0.0596796423196793, 0.0595991089940071, 0.0595185980200768, 0.0594381056725979, 0.0593576394021511, 0.059277206659317, 0.059196799993515, 0.0591164380311966, 0.0590361095964909, 0.0589557737112045, 0.0588755197823048, 0.0587952733039856, 0.0587150491774082, 0.0586348325014114, 0.058554720133543, 0.058474600315094, 0.0583945065736771, 0.0583144351840019, 0.0582343973219395, 0.0581544116139412, 0.0580744333565235, 0.0579944625496864, 0.0579145513474941, 0.0578346736729145, 0.0577548444271088, 0.0576749816536903, 0.0575952492654324, 0.0575154796242714, 0.0574357658624649, 0.0573560260236263, 0.0572763532400131, 0.0571967102587223, 0.0571171194314957, 0.0570375733077526, 0.056957982480526, 0.0568784847855568, 0.0567989870905876, 0.0567195378243923, 0.0566400736570358, 0.0565607324242592, 0.0564813613891602, 0.0564020350575447, 0.0563227161765099, 0.0562434382736683, 0.0561641938984394, 0.0560849830508232, 0.0560057908296585, 0.0559266209602356, 0.0558475032448769, 0.055768433958292, 0.0556893348693848, 0.0556103251874447, 0.0555313527584076, 0.0554523952305317, 0.0553734190762043, 0.055294506251812, 0.0552156493067741, 0.0551367960870266, 0.0550579689443111, 0.0549791641533375, 0.0549004301428795, 0.0548217073082924, 0.0547429919242859, 0.0546643175184727, 0.0545857064425945, 0.0545071139931679, 0.0544285215437412, 0.0543500036001205, 0.0542714595794678, 0.0541929937899113, 0.0541145242750645, 0.0540360882878304, 0.0539576858282089, 0.0538793466985226, 0.0538010075688362, 0.0537226945161819, 0.0536444187164307, 0.0535662211477757, 0.0534880086779594, 0.0534098148345947, 0.0533316805958748, 0.0532535426318645, 0.05317547544837, 0.0530974008142948, 0.0530193783342838, 0.0529413744807243, 0.0528634004294872, 0.0527854487299919, 0.0527075566351414, 0.0526296570897102, 0.0525518618524075, 0.0524740256369114, 0.0523962564766407, 0.0523185059428215, 0.0522407777607441, 0.0521630644798279, 0.0520853996276855, 0.0520077720284462, 0.0519301630556583, 0.0518525838851929, 0.0517750531435013, 0.0516975373029709, 0.0516200885176659, 0.051542617380619, 0.0514652132987976, 0.0513878092169762, 0.0513104349374771, 0.0512331128120422, 0.0511558167636395, 0.0510785542428493, 0.0510013215243816, 0.0509240962564945, 0.0508469082415104, 0.0507697761058807, 0.0506926737725735, 0.0506155863404274, 0.0505385287106037, 0.0504615008831024, 0.0503845252096653, 0.0503075309097767, 0.0502305924892426, 0.0501537099480629, 0.0500768274068832, 0.050000011920929, 0.0499231591820717, 0.0498463921248913, 0.0497696362435818, 0.0496929101645947, 0.0496162362396717, 0.0495395734906197, 0.0494629517197609, 0.0493863560259342, 0.0493097715079784, 0.0492332391440868, 0.0491567365825176, 0.0490802675485611, 0.0490037687122822, 0.0489273630082607, 0.048850990831852, 0.0487746298313141, 0.0486983209848404, 0.0486220233142376, 0.0485457591712475, 0.0484695322811604, 0.0483933165669441, 0.0483171157538891, 0.0482409968972206, 0.0481648780405521, 0.048088800162077, 0.0480127260088921, 0.0479367189109325, 0.0478607267141342, 0.0477847643196583, 0.0477088317275047, 0.0476329512894154, 0.0475570894777775, 0.0474812313914299, 0.0474054329097271, 0.0473296456038952, 0.0472539030015469, 0.0471781603991985, 0.0471024699509144, 0.0470268093049526, 0.0469511821866035, 0.0468755848705769, 0.0468000173568726, 0.0467245168983936, 0.0466490127146244, 0.0465735457837582, 0.0464980751276016, 0.0464226678013802, 0.0463472753763199, 0.0462719313800335, 0.0461966022849083, 0.0461213253438473, 0.0460460409522057, 0.0459707975387573, 0.0458955951035023, 0.0458204559981823, 0.0457453057169914, 0.0456702001392841, 0.0455951057374477, 0.045520082116127, 0.045445054769516, 0.045370064675808, 0.0452950857579708, 0.0452261976897717, 0.0451633036136627, 0.0451004169881344, 0.045037567615509, 0.0449747703969479, 0.0449120737612247, 0.0448493510484695, 0.0447866953909397, 0.0447240509092808, 0.0446614846587181, 0.0445989407598972, 0.0445364527404308, 0.0444739982485771, 0.0444116108119488, 0.0443492494523525, 0.0442869067192078, 0.0442246571183205, 0.0441624000668526, 0.044100247323513, 0.0440380908548832, 0.0439759865403175, 0.0439139492809772, 0.0438519082963467, 0.0437899604439735, 0.0437280163168907, 0.0436661168932915, 0.0436042994260788, 0.0435424819588661, 0.0434807278215885, 0.043418999761343, 0.0433573871850967, 0.0432957410812378, 0.043234147131443, 0.0431725978851318, 0.0431111119687557, 0.0430496335029602, 0.0429882295429707, 0.0429268442094326, 0.0428655445575714, 0.0428042486310005, 0.0427430048584938, 0.0426817871630192, 0.042620662599802, 0.0425595715641975, 0.0424984954297543, 0.0424374602735043, 0.0423764921724796, 0.0423155464231968, 0.0422546491026878, 0.0421937815845013, 0.042132992297411, 0.0420722216367722, 0.0420114807784557, 0.0419508181512356, 0.0418901890516281, 0.0418295711278915, 0.041769053786993, 0.0417085662484169, 0.041648093611002, 0.0415877029299736, 0.0415272787213326, 0.041466947644949, 0.0414066538214684, 0.0413464345037937, 0.0412862040102482, 0.0412260442972183, 0.0411659069359303, 0.0411058627068996, 0.0410458408296108, 0.040985856205225, 0.0409258939325809, 0.0408660210669041, 0.0408061407506466, 0.0407463349401951, 0.0406865254044533, 0.0406268164515495, 0.0405671261250973, 0.0405074618756771, 0.0404478460550308, 0.0403883270919323, 0.0403288081288338, 0.0402693673968315, 0.0402099080383778, 0.0401505306363106, 0.040091197937727, 0.0400318838655949, 0.0399726182222366, 0.0399134159088135, 0.0398542657494545, 0.0397951193153858, 0.0397360473871231, 0.039676982909441, 0.0396179929375648, 0.0395590215921402, 0.0395001694560051, 0.0394412875175476, 0.039382491260767, 0.0393236838281155, 0.039264939725399, 0.0392062477767467, 0.0391476154327393, 0.0390889719128609, 0.0390304177999496, 0.0389718748629093, 0.0389134362339973, 0.0388549603521824, 0.0387966148555279, 0.0387382321059704, 0.0386799499392509, 0.0386216528713703, 0.0385634452104568, 0.0385052636265755, 0.038447167724371, 0.0383890569210052, 0.0383309982717037, 0.0382729843258858, 0.0382150337100029, 0.0381571017205715, 0.0380992293357849, 0.0380414053797722, 0.0379836410284042, 0.0379258841276169, 0.0378681719303131, 0.0378105081617832, 0.0377529077231884, 0.0376953184604645, 0.0376377813518047, 0.0375803224742413, 0.0375228449702263, 0.0374654494225979, 0.0374081023037434, 0.0373507849872112, 0.0372935347259045, 0.0372363291680813, 0.0371791087090969, 0.0371219851076603, 0.0370648577809334, 0.0370078571140766, 0.0369507931172848, 0.0368938408792019, 0.036836888641119, 0.0367800332605839, 0.0367231629788876, 0.0366663709282875, 0.0366096422076225, 0.0365529581904411, 0.0364962592720985, 0.0364396423101425, 0.0363830551505089, 0.0363265462219715, 0.0362700074911118, 0.0362135618925095, 0.0361571498215199, 0.0361007861793041, 0.0360444709658623, 0.0359881818294525, 0.0359319448471069, 0.0358757860958576, 0.0358196273446083, 0.0357635170221329, 0.0357074365019798, 0.0356514193117619, 0.0355954505503178, 0.0355395153164864, 0.0354836396872997, 0.0354277826845646, 0.0353719554841518, 0.0353161953389645, 0.0352604798972607, 0.0352047979831696, 0.0351492427289486, 0.0350936055183411, 0.0350380800664425, 0.0349825397133827, 0.0349271111190319, 0.0348716489970684, 0.0348162986338139, 0.0347609482705593, 0.0347056910395622, 0.0346504226326942, 0.0345952324569225, 0.0345400720834732, 0.0344849899411201, 0.0344298928976059, 0.0343748778104782, 0.0343198738992214, 0.0342649519443512, 0.0342100337147713, 0.034155186265707, 0.0341003611683846, 0.0340455956757069, 0.0339908488094807, 0.0339361801743507, 0.033881526440382, 0.0338269397616386, 0.0337724313139915, 0.033717904239893, 0.0336634106934071, 0.0336090102791786, 0.0335546098649502, 0.0335002765059471, 0.0334459915757179, 0.0333917327225208, 0.0333375222980976, 0.0332833491265774, 0.0332292318344116, 0.0331751368939877, 0.0331211313605309, 0.0330671332776546, 0.0330132059752941, 0.0329592674970627, 0.0329054407775402, 0.0328515954315662, 0.0327978171408176, 0.0327440649271011, 0.0326903983950615, 0.0326367281377316, 0.0325831212103367, 0.0325295478105545, 0.0324760526418686, 0.0324225723743439, 0.0323691703379154, 0.0323157571256161, 0.0322624333202839, 0.0322090983390808, 0.032155841588974, 0.0321026146411896, 0.0320494547486305, 0.0319963097572327, 0.0319432243704796, 0.0318901725113392, 0.0318371839821339, 0.0317842289805412, 0.0317313373088837, 0.0316784456372261, 0.0316256284713745, 0.0315728634595871, 0.0315200984477997, 0.0314674116671085, 0.0314147397875786, 0.031362134963274, 0.0313095413148403, 0.0312570296227932, 0.0312045328319073, 0.0311521179974079, 0.0310997013002634, 0.0310473777353764, 0.0309950560331345, 0.030942814424634, 0.0308905560523272, 0.0308383777737617, 0.0307862292975187, 0.0307341460138559, 0.0306820776313543, 0.0306300707161427, 0.0305780824273825, 0.0305262058973312, 0.030474279075861, 0.0304224975407124, 0.030370682477951, 0.030318945646286, 0.0302672274410725, 0.0302155558019876, 0.0301639307290316, 0.0301123727113008, 0.0300608091056347, 0.0300093274563551, 0.0299578625708818, 0.0299064591526985, 0.0298551227897406, 0.0298037994652987, 0.0297525227069855, 0.0297012943774462, 0.0296501163393259, 0.0295989494770765, 0.0295478645712137, 0.0294967796653509, 0.0294457897543907, 0.0293947998434305, 0.0293438732624054, 0.0292929634451866, 0.0292421318590641, 0.0291913151741028, 0.0291405618190765, 0.0290898568928242, 0.0290392190217972, 0.0289885606616735, 0.0289379991590977, 0.0288874376565218, 0.028836952522397, 0.0287864692509174, 0.0287360679358244, 0.0286856815218925, 0.0286353696137667, 0.0285850632935762, 0.0285348333418369, 0.0284846518188715, 0.0284345205873251, 0.0283843837678432, 0.0283343158662319, 0.0282842759042978, 0.0282343327999115, 0.0281843561679125, 0.0281344782561064, 0.0280846133828163, 0.0280348137021065, 0.0279850400984287, 0.0279353056102991, 0.0278856158256531, 0.0278360042721033, 0.0277864243835211, 0.0277368761599064, 0.0276873949915171, 0.0276379100978374, 0.0275884903967381, 0.0275390855967999, 0.0274897590279579, 0.0274404510855675, 0.0273912027478218, 0.0273420065641403, 0.0272928401827812, 0.0272437203675508, 0.0271946657449007, 0.0271456092596054, 0.0270966496318579, 0.0270476881414652, 0.0269987750798464, 0.0269499234855175, 0.0269011240452528, 0.0268523208796978, 0.0268036127090454, 0.0267548933625221, 0.026706263422966, 0.0266576372087002, 0.0266091357916594, 0.0265606008470058, 0.0265121348202229, 0.0264636799693108, 0.0264153387397528, 0.0263669788837433, 0.0263186544179916, 0.0262703895568848, 0.0262221917510033, 0.026174021884799, 0.0261258874088526, 0.0260778144001961, 0.0260297581553459, 0.0259817950427532, 0.0259338319301605, 0.0258859358727932, 0.0258380379527807, 0.0257902331650257, 0.0257424302399158, 0.0256947074085474, 0.0256469994783401, 0.025599354878068, 0.0255517270416021, 0.0255041755735874, 0.0254566259682178, 0.0254091396927834, 0.0253617353737354, 0.0253143571317196, 0.0252669844776392, 0.0252196732908487, 0.025172408670187, 0.0251252073794603, 0.0250779930502176, 0.0250308681279421, 0.024983761832118, 0.0249367374926805, 0.0248897131532431, 0.0248427484184504, 0.024795850738883, 0.0247489809989929, 0.0247021466493607, 0.0246553719043732, 0.0246086157858372, 0.0245619080960751, 0.0245152302086353, 0.0244686305522919, 0.0244220495223999, 0.0243755113333464, 0.0243290401995182, 0.024282556027174, 0.0242361798882484, 0.0241898335516453, 0.0241435375064611, 0.024097241461277, 0.024051021784544, 0.0240048207342625, 0.0239586811512709, 0.023912575095892, 0.0238665174692869, 0.0238204877823591, 0.023774541914463, 0.0237285941839218, 0.0236827079206705, 0.023636857047677, 0.0235911142081022, 0.0235453229397535, 0.0234996136277914, 0.0234539359807968, 0.0234083365648985, 0.023362735286355, 0.0233172010630369, 0.0232716966420412, 0.0232262574136257, 0.0231808144599199, 0.0231354553252459, 0.0230901092290878, 0.0230448897927999, 0.0229996386915445, 0.022954436019063, 0.0229093134403229, 0.0228641871362925, 0.0228191111236811, 0.0227740854024887, 0.0227291341871023, 0.0226841848343611, 0.0226393155753613, 0.0225944295525551, 0.0225496236234903, 0.022504847496748, 0.0224601831287146, 0.0224154870957136, 0.0223708562552929, 0.0223262552171946, 0.0222817361354828, 0.0222371984273195, 0.0221927426755428, 0.0221483148634434, 0.0221039522439241, 0.0220596045255661, 0.0220153052359819, 0.0219710543751717, 0.0219268798828125, 0.0218827240169048, 0.0218385998159647, 0.0217945240437984, 0.021750507876277, 0.0217065121978521, 0.0216625612229109, 0.0216186568140984, 0.0215748194605112, 0.0215309783816338, 0.0214872192591429, 0.0214434750378132, 0.0213998090475798, 0.0213561784476042, 0.0213125739246607, 0.0212690364569426, 0.0212255157530308, 0.0211820397526026, 0.0211386140435934, 0.0210952516645193, 0.0210518836975098, 0.0210086163133383, 0.0209653172641993, 0.0209221430122852, 0.02087895385921, 0.0208358578383923, 0.0207927785813808, 0.0207497663795948, 0.0207067355513573, 0.0206637997180223, 0.0206208806484938, 0.0205780062824488, 0.0205351822078228, 0.0204924196004868, 0.0204496756196022, 0.0204069633036852, 0.0203643105924129, 0.0203217081725597, 0.0202791392803192, 0.0202366467565298, 0.0201941560953856, 0.0201517418026924, 0.0201093461364508, 0.0200669802725315, 0.0200246814638376, 0.0199824273586273, 0.0199401862919331, 0.0198980122804642, 0.0198558866977692, 0.0198137927800417, 0.0197717435657978, 0.0197297744452953, 0.0196878369897604, 0.0196459013968706, 0.0196040291339159, 0.0195621699094772, 0.0195204224437475, 0.0194786619395018, 0.0194369796663523, 0.0193952955305576, 0.0193536914885044, 0.0193121023476124, 0.0192705933004618, 0.0192290712147951, 0.0191876869648695, 0.0191462580114603, 0.0191049240529537, 0.019063588231802, 0.0190223511308432, 0.0189810954034328, 0.0189399197697639, 0.0188987758010626, 0.01885767839849, 0.01881661452353, 0.0187756139785051, 0.0187346450984478, 0.0186937376856804, 0.0186528470367193, 0.0186120215803385, 0.0185712091624737, 0.0185304470360279, 0.0184897463768721, 0.0184490941464901, 0.0184084568172693, 0.0183678679168224, 0.0183273423463106, 0.0182868465781212, 0.0182463862001896, 0.0182059705257416, 0.0181656666100025, 0.0181253161281347, 0.018085028976202, 0.0180448032915592, 0.0180046427994967, 0.0179644655436277, 0.0179243851453066, 0.0178842861205339, 0.0178443007171154, 0.0178042985498905, 0.0177643746137619, 0.0177244655787945, 0.0176846385002136, 0.0176448430866003, 0.0176051110029221, 0.0175653602927923, 0.0175257064402103, 0.0174860544502735, 0.0174464788287878, 0.0174069199711084, 0.0173674412071705, 0.0173279624432325, 0.0172885619103909, 0.017249146476388, 0.0172098260372877, 0.0171705689281225, 0.0171313416212797, 0.0170921497046947, 0.0170529708266258, 0.0170138571411371, 0.0169747900217772, 0.0169357545673847, 0.0168967675417662, 0.0168578270822763, 0.0168189499527216, 0.0167800728231668, 0.0167412590235472, 0.0167025085538626, 0.0166638065129519, 0.0166251044720411, 0.0165864657610655, 0.0165479071438313, 0.0165093149989843, 0.0164708346128464, 0.0164323374629021, 0.0163939371705055, 0.0163555350154638, 0.0163172129541636, 0.0162788927555084, 0.0162406805902719, 0.0162024553865194, 0.0161643233150244, 0.0161261912435293, 0.0160881243646145, 0.0160500705242157, 0.0160120986402035, 0.0159741099923849, 0.0159362312406301, 0.0158983543515205, 0.015860540792346, 0.0158227570354939, 0.0157850366085768, 0.0157473348081112, 0.0157097261399031, 0.0156720858067274, 0.0156345404684544, 0.0155970109626651, 0.0155595615506172, 0.0155221121385694, 0.015484725125134, 0.0154473707079887, 0.0154100796207786, 0.0153728052973747, 0.0153355915099382, 0.0152984438464046, 0.0152613110840321, 0.0152242099866271, 0.015187188051641, 0.0151502136141062, 0.0151132391765714, 0.015076344832778, 0.0150394346565008, 0.0150026343762875, 0.0149658191949129, 0.0149291139096022, 0.0148923778906465, 0.0148557536303997, 0.0148191275075078, 0.0147825656458735, 0.0147460354492068, 0.0147095685824752, 0.0146731184795499, 0.0146367466077209, 0.0146003738045692, 0.0145640829578042, 0.0145277893170714, 0.014491593465209, 0.0144553799182177, 0.0144192455336452, 0.0143831437453628, 0.0143471043556929, 0.0143111469224095, 0.0142751708626747, 0.0142392264679074, 0.0142033621668816, 0.0141675304621458, 0.0141317136585712, 0.0140959592536092, 0.0140602700412273, 0.0140245957300067, 0.0139889698475599, 0.0139534221962094, 0.0139178754761815, 0.0138823604211211, 0.0138469384983182, 0.0138115659356117, 0.0137761775404215, 0.0137408841401339, 0.0137055907398462, 0.0136703765019774, 0.013635179027915, 0.0136000439524651, 0.0135649098083377, 0.0135298687964678, 0.0134948287159204, 0.0134598687291145, 0.0134249404072762, 0.0133901061490178, 0.0133552402257919, 0.0133204385638237, 0.013285668566823, 0.0132509618997574, 0.013216270133853, 0.0131816752254963, 0.0131470467895269, 0.0131125301122665, 0.0130780292674899, 0.0130435917526484, 0.0130091700702906, 0.0129748126491904, 0.0129404868930578, 0.0129062235355377, 0.012871976941824, 0.0128377601504326, 0.0128036420792341, 0.0127695212140679, 0.0127354478463531, 0.0127014070749283, 0.0126674454659224, 0.0126334996894002, 0.0125995855778456, 0.012565734796226, 0.0125319799408317, 0.0124981924891472, 0.0124644851312041, 0.0124307768419385, 0.0123971626162529, 0.012363551184535, 0.0123300170525908, 0.0122964680194855, 0.0122630456462502, 0.0122296223416924, 0.012196246534586, 0.0121628884226084, 0.0121296076104045, 0.0120963919907808, 0.0120631922036409, 0.0120300063863397, 0.0119969174265862, 0.0119638275355101, 0.0119308019056916, 0.0118977911770344, 0.0118648586794734, 0.0118319448083639, 0.0117990933358669, 0.0117662725970149, 0.0117335002869368, 0.0117007903754711, 0.0116681298241019, 0.0116354674100876, 0.0116028534248471, 0.0115703344345093, 0.0115377847105265, 0.0115053132176399, 0.0114728743210435, 0.0114405294880271, 0.0114081697538495, 0.0113758724182844, 0.0113435909152031, 0.0113113895058632, 0.011279234662652, 0.011247112415731, 0.0112150060012937, 0.0111830253154039, 0.0111509989947081, 0.0111190341413021, 0.0110871186479926, 0.0110552655532956, 0.0110234273597598, 0.0109916552901268, 0.0109598813578486, 0.0109282350167632, 0.0108965551480651, 0.0108649879693985, 0.0108334049582481, 0.0108019011095166, 0.0107704121619463, 0.0107389716431499, 0.0107075469568372, 0.0106762340292335, 0.0106449034065008, 0.0106136696413159, 0.0105824349448085, 0.0105512477457523, 0.0105201080441475, 0.0104890475049615, 0.0104580027982593, 0.0104269906878471, 0.0103960735723376, 0.010365123860538, 0.010334238409996, 0.0103034004569054, 0.0102726258337498, 0.0102418661117554, 0.0102111715823412, 0.0101804910227656, 0.0101499063894153, 0.0101193059235811, 0.0100888162851334, 0.0100582959130406, 0.0100278863683343, 0.00999747589230537, 0.00996709614992142, 0.00993678160011768, 0.00990654621273279, 0.00987629499286413, 0.00984610803425312, 0.00981594994664192, 0.00978587381541729, 0.00975581258535385, 0.00972578302025795, 0.00969583168625832, 0.00966592971235514, 0.00963604263961315, 0.0096062021329999, 0.00957637932151556, 0.0095466673374176, 0.00951692368835211, 0.00948727410286665, 0.00945764034986496, 0.00942803919315338, 0.00939851626753807, 0.00936902686953545, 0.00933961570262909, 0.00931017193943262, 0.00928083993494511, 0.00925149209797382, 0.00922222435474396, 0.00919295474886894, 0.00916379783302546, 0.00913463998585939, 0.00910552963614464, 0.00907645188271999, 0.00904745329171419, 0.00901845470070839, 0.00898951850831509, 0.00896064564585686, 0.00893182214349508, 0.00890301261097193, 0.00887423567473888, 0.00884550623595715, 0.00881685595959425, 0.00878820568323135, 0.00875961873680353, 0.00873104855418205, 0.00870257243514061, 0.00867409724742174, 0.00864570029079914, 0.00861728750169277, 0.00858901813626289, 0.0085607161745429, 0.00853247940540314, 0.00850424077361822, 0.00847611390054226, 0.00844800285995007, 0.00841990672051907, 0.00839190743863583, 0.00836389046162367, 0.0083359545096755, 0.00830806512385607, 0.00828020833432674, 0.00825241394340992, 0.00822468288242817, 0.00819693692028522, 0.00816925335675478, 0.00814158655703068, 0.00811401382088661, 0.0080864429473877, 0.00805891864001751, 0.00803144183009863, 0.00800404325127602, 0.00797666143625975, 0.00794931221753359, 0.00792199280112982, 0.00789480190724134, 0.00786757841706276, 0.00784040335565805, 0.00781325902789831, 0.00778622599318624, 0.00775916129350662, 0.00773217575624585, 0.00770520651713014, 0.00767831644043326, 0.00765144173055887, 0.00762463081628084, 0.00759781990200281, 0.00757111981511116, 0.00754445139318705, 0.0075177988037467, 0.00749117787927389, 0.00746463658288121, 0.00743809482082725, 0.00741161685436964, 0.0073852026835084, 0.00735880387946963, 0.00733243720605969, 0.00730614876374602, 0.00727990875020623, 0.00725366873666644, 0.00722753955051303, 0.00720137823373079, 0.00717531237751245, 0.00714923068881035, 0.00712326029315591, 0.00709730526432395, 0.00707138236612082, 0.00704550696536899, 0.00701969396322966, 0.00699388235807419, 0.00696814944967628, 0.00694241654127836, 0.00691679446026683, 0.00689120450988412, 0.00686563085764647, 0.00684008747339249, 0.00681462418287992, 0.00678917719051242, 0.00676377722993493, 0.00673840846866369, 0.00671310350298882, 0.00668783113360405, 0.00666260533034801, 0.0066374116577208, 0.00661229714751244, 0.00658718263730407, 0.0065621635876596, 0.00653712823987007, 0.00651218788698316, 0.00648724753409624, 0.00646238727495074, 0.00643755774945021, 0.0064127603545785, 0.00638797925785184, 0.00636327685788274, 0.00633862242102623, 0.00631398288533092, 0.00628943974152207, 0.00626492779701948, 0.00624043121933937, 0.00621596723794937, 0.00619158195331693, 0.00616719713434577, 0.00614289054647088, 0.00611858488991857, 0.00609438959509134, 0.00607017939910293, 0.00604604789987206, 0.00602191593497992, 0.00599787989631295, 0.0059738433919847, 0.00594988651573658, 0.00592594500631094, 0.00590208359062672, 0.00587822124361992, 0.00585442269220948, 0.0058306553401053, 0.00580695224925876, 0.0057832645252347, 0.00575964106246829, 0.00573603203520179, 0.00571251986548305, 0.00568900583311915, 0.0056655565276742, 0.00564215425401926, 0.00561879994347692, 0.00559546099975705, 0.00557218585163355, 0.00554895820096135, 0.00552574638277292, 0.0055025820620358, 0.00547946477308869, 0.00545641221106052, 0.00543337408453226, 0.00541041605174541, 0.0053874421864748, 0.00536459498107433, 0.00534171611070633, 0.00531893223524094, 0.00529614835977554, 0.00527344364672899, 0.00525073893368244, 0.00522811338305473, 0.00520548829808831, 0.0051829582080245, 0.00516042811796069, 0.00513799302279949, 0.00511555839329958, 0.00509318709373474, 0.00507087865844369, 0.00504858605563641, 0.00502632604911923, 0.00500412844121456, 0.00498193083330989, 0.00495984498411417, 0.00493774330243468, 0.00491573614999652, 0.00489372946321964, 0.00487180193886161, 0.00484987394884229, 0.0048280255869031, 0.00480620888993144, 0.00478445598855615, 0.00476270262151957, 0.00474102888256311, 0.00471940217539668, 0.0046977917663753, 0.00467621302232146, 0.0046546976082027, 0.00463322969153523, 0.0046117939054966, 0.00459042098373175, 0.00456908019259572, 0.00454778643324971, 0.0045265406370163, 0.00450534233823419, 0.00448414403945208, 0.0044630253687501, 0.00444192159920931, 0.00442091375589371, 0.00439989008009434, 0.00437894556671381, 0.00435801688581705, 0.0043371831998229, 0.00431631784886122, 0.00429553166031837, 0.00427479343488812, 0.0042541497386992, 0.00423347484320402, 0.00421286327764392, 0.00419229920953512, 0.0041717984713614, 0.00415131356567144, 0.00413086032494903, 0.00411043874919415, 0.00409011263400316, 0.00406978698447347, 0.00404953956604004, 0.00402932427823544, 0.00400914112105966, 0.00398902036249638, 0.00396891636773944, 0.00394889106974006, 0.00392886623740196, 0.00390892056748271, 0.00388897466473281, 0.0038691081572324, 0.00384784652851522, 0.00382526870816946, 0.00380265968851745, 0.0037801768630743, 0.0037576628383249, 0.00373527524061501, 0.00371282454580069, 0.00369050051085651, 0.00366811314597726, 0.00364588410593569, 0.00362359173595905, 0.00360139482654631, 0.00357916578650475, 0.00355709553696215, 0.0035349300596863, 0.00351289147511125, 0.00349085289053619, 0.00346890930086374, 0.00344690238125622, 0.00342502212151885, 0.00340311066247523, 0.00338132563047111, 0.00335950893349946, 0.00333772413432598, 0.0033159707672894, 0.00329431262798607, 0.00327268638648093, 0.00325102848000824, 0.00322949700057507, 0.00320793432183564, 0.00318643450737, 0.00316493515856564, 0.00314353057183325, 0.00312215788289905, 0.00310081685893238, 0.00307944416999817, 0.00305819837376475, 0.00303695257753134, 0.003015770111233, 0.00299455597996712, 0.00297346874140203, 0.00295234960503876, 0.00293135759420693, 0.00291027035564184, 0.00288934144191444, 0.00286834919825196, 0.00284751574508846, 0.00282658683136106, 0.00280578504316509, 0.00278498278930783, 0.00276427599601448, 0.00274350587278605, 0.00272286264225841, 0.00270218751393259, 0.00268163927830756, 0.00266102771274745, 0.00264051114208996, 0.00261999457143247, 0.00259960489347577, 0.00257921521551907, 0.00255879387259483, 0.00253840419463813, 0.00251817307434976, 0.00249791028909385, 0.0024776472710073, 0.00245751137845218, 0.00243734382092953, 0.0024172393605113, 0.00239713513292372, 0.0023771261330694, 0.00235711690038443, 0.00233717123046517, 0.00231719366274774, 0.0022973429877311, 0.00227746064774692, 0.002257673535496, 0.00223785475827754, 0.00221816264092922, 0.00219840719364583, 0.00217881030403078, 0.00215911818668246, 0.00213958462700248, 0.00211998773738742, 0.00210051750764251, 0.0020810158457607, 0.00206157751381397, 0.0020421389490366, 0.0020228591747582, 0.00200348417274654, 0.00198420439846814, 0.00196492462418973, 0.0019457716261968, 0.0019265552982688, 0.0019074339652434, 0.00188828096725047, 0.00186928664334118, 0.00185029208660126, 0.00183126609772444, 0.00181227154098451, 0.00179340387694538, 0.00177453644573689, 0.00175566878169775, 0.00173689634539187, 0.00171812390908599, 0.0016994149191305, 0.0016807058127597, 0.00166209193412215, 0.00164344639051706, 0.00162489584181458, 0.00160631362814456, 0.00158785830717534, 0.00156937120482326, 0.00155097921378911, 0.00153255555778742, 0.00151422712951899, 0.00149586680345237, 0.00147763348650187, 0.00145936838816851, 0.00144119840115309, 0.00142299674917012, 0.00140492187347263, 0.00138678366784006, 0.00136877223849297, 0.00135072914417833, 0.00133281282614917, 0.0013148330617696, 0.00129694864153862, 0.00127906398847699, 0.00126127456314862, 0.00124345335643739, 0.00122572749387473, 0.00120796973351389, 0.00119037041440606, 0.00117273954674602, 0.00115510867908597, 0.00113750947639346, 0.00112003716640174, 0.0011025647399947, 0.00108509243000299, 0.00106771534774452, 0.00105030636768788, 0.00103299249894917, 0.00101567874662578, 0.000998428440652788, 0.000981209799647331, 0.000964022823609412, 0.000946835847571492, 0.000929775764234364, 0.000912683957722038, 0.000895655597560108, 0.000878627179190516, 0.000861693930346519, 0.000844728900119662, 0.000827890820801258, 0.000811020901892334, 0.000794214487541467, 0.000777408131398261, 0.000760728551540524, 0.000743985525332391, 0.000727369333617389, 0.000710689753759652, 0.000694168731570244, 0.000677584321238101, 0.000661094964016229, 0.00064457394182682, 0.000628211419098079, 0.000611753843259066, 0.000595423043705523, 0.000579060579184443, 0.000562824949156493, 0.000546589260920882, 0.000530353630892932, 0.00051414972404018, 0.000498072651680559, 0.000481995550217107, 0.000465886754682288, 0.000449904793640599, 0.000433891138527542, 0.000417972565628588, 0.000402022356865928, 0.000386167230317369, 0.000370343826944008, 0.000354552117642015, 0.000338760437443852, 0.000323063868563622, 0.000307367299683392, 0.000291734148049727, 0.000276100996416062, 0.00026056298520416, 0.000244993279920891, 0.000229518671403639, 0.000214044062886387, 0.000198632900719531, 0.000183221724000759, 0.000167905687703751, 0.000152557928231545, 0.000137337032356299, 0.000122052690130658, 0.000106895196950063, 9.17059951461852e-05, 7.66119264881127e-05, 6.14861419307999e-05, 4.64872027805541e-05, 3.14565513690468e-05, 1.64893208420835e-05, 1.522091224615e-06, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 0.00385907175950706, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 2.35198412497004e-15, 7.54703523853095e-06, 2.25142666749889e-05, 3.74497867596801e-05, 5.251214679447e-05, 6.75745104672387e-05, 8.2605161878746e-05, 9.77626550593413e-05, 0.000112983565486502, 0.000128172760014422, 0.000143457102240063, 0.000158678012667224, 0.00017402577213943, 0.000189405225683004, 0.000204816402401775, 0.000220195870497264, 0.000235702158533968, 0.000251208461122587, 0.000266778195509687, 0.000282316206721589, 0.000297981081530452, 0.000313582480885088, 0.000329342496115714, 0.000345039035892114, 0.000360830774297938, 0.000376654177671298, 0.000392509275116026, 0.000408364401664585, 0.000424314639531076, 0.000440296571468934, 0.000456278532510623, 0.00047229221672751, 0.000488369318190962, 0.000504478113725781, 0.000520650297403336, 0.000536790816113353, 0.0005530581693165, 0.000569325580727309, 0.000585624598897994, 0.000601987063419074, 0.000618317862972617, 0.000634743773844093, 0.000651201349683106, 0.00066765898372978, 0.000684180005919188, 0.000700764416251332, 0.000717380666173995, 0.000734028464648873, 0.000750676321331412, 0.000767387682572007, 0.000784130650572479, 0.000800968788098544, 0.000817743479274213, 0.000834613339975476, 0.000851514923851937, 0.000868479895871133, 0.00088541314471513, 0.000902441504877061, 0.000919469923246652, 0.000936593511141837, 0.000953685259446502, 0.00097087217727676, 0.000988059211522341, 0.00100534129887819, 0.00102255982346833, 0.0010399054735899, 0.00105728267226368, 0.00107465975452214, 0.00109203695319593, 0.00110950937960297, 0.00112701347097754, 0.00114458089228719, 0.00116211664862931, 0.00117974751628935, 0.00119741004891694, 0.0012151044793427, 0.00123286223970354, 0.00125058821868151, 0.00126840930897743, 0.00128623051568866, 0.00130405172239989, 0.00132199970539659, 0.00133997935336083, 0.00135795911774039, 0.00137600209563971, 0.00139404530636966, 0.00141215184703469, 0.00143029005266726, 0.00144849170465022, 0.00146666180808097, 0.00148492690641433, 0.00150322366971523, 0.00152155209798366, 0.00153988064266741, 0.0015583042986691, 0.00157669628970325, 0.00159524683840573, 0.00161373382434249, 0.00163228437304497, 0.00165086647029966, 0.00166951213032007, 0.00168815767392516, 0.00170686678029597, 0.00172563921660185, 0.00174441176932305, 0.00176318420562893, 0.00178205163683742, 0.00180095096584409, 0.0018198819598183, 0.00183881307020783, 0.00185783917549998, 0.00187689706217498, 0.00189598661381751, 0.00191510794684291, 0.00193422916345298, 0.00195347727276385, 0.00197266205213964, 0.00199187826365232, 0.00201118993572891, 0.00203056470490992, 0.00204993970692158, 0.00206937803886831, 0.0020887847058475, 0.00210828660055995, 0.00212782016023993, 0.00214741704985499, 0.00216698227450252, 0.00218664249405265, 0.00220630294643342, 0.00222605839371681, 0.00224575051106513, 0.00226556928828359, 0.00228535640053451, 0.00230527040548623, 0.0023251527454704, 0.0023450986482203, 0.00236507621593773, 0.00238511711359024, 0.00240512611344457, 0.00242523034103215, 0.00244539813138545, 0.0024655656889081, 0.00248570181429386, 0.00250599626451731, 0.00252625928260386, 0.00254658563062549, 0.00256691151298583, 0.00258733285591006, 0.00260778632946312, 0.0026282393373549, 0.00264875567518175, 0.00266927247866988, 0.00268988381139934, 0.00271046394482255, 0.0027310757432133, 0.00275178253650665, 0.00277255265973508, 0.00279332278296351, 0.00281412457115948, 0.00283492659218609, 0.00285582360811532, 0.00287675252184272, 0.00289771286770701, 0.00291867344640195, 0.0029397290199995, 0.00296078459359705, 0.00298190349712968, 0.00300308596342802, 0.00302420509979129, 0.00304541899822652, 0.00306669669225812, 0.00308797438628972, 0.00310931541025639, 0.00313068809919059, 0.00315209245309234, 0.00317349680699408, 0.00319499638862908, 0.00321655930019915, 0.00323809054680169, 0.00325965345837176, 0.00328131159767509, 0.00330296950414777, 0.00332469097338617, 0.00334638077765703, 0.00336819770745933, 0.00339004583656788, 0.00341189443133771, 0.00343380612321198, 0.00345568615011871, 0.00347772473469377, 0.00349966809153557, 0.00352167501114309, 0.00354377692565322, 0.00356591097079217, 0.00358807621523738, 0.00361027359031141, 0.00363247073255479, 0.00365476310253143, 0.00367705523967743, 0.00369944283738732, 0.0037217668723315, 0.00374421756714582, 0.00376666826196015, 0.00378918275237083, 0.00381172867491841, 0.00383427459746599, 0.00385685218498111, 0.00387952500022948, 0.00390216615051031, 0.0039249025285244, 0.00394767057150602, 0.0039704698137939, 0.00399333331733942, 0.00401616422459483, 0.00403909105807543, 0.00406201742589474, 0.00408503925427794, 0.00410799728706479, 0.00413105078041553, 0.00415416760370135, 0.00417725229635835, 0.00420046458020806, 0.00422367639839649, 0.00424691988155246, 0.00427022716030478, 0.00429350230842829, 0.00431690458208323, 0.00434027472510934, 0.00436367699876428, 0.00438714260235429, 0.00441067153587937, 0.00443423260003328, 0.00445782439783216, 0.0044814171269536, 0.00450507318601012, 0.00452879210934043, 0.00455254316329956, 0.00457626255229115, 0.00460007693618536, 0.0046239229850471, 0.00464783236384392, 0.00467177387326956, 0.00469568325206637, 0.0047196876257658, 0.00474372459575534, 0.0047677606344223, 0.00479189166799188, 0.00481602316722274, 0.0048402501270175, 0.00486447662115097, 0.00488870358094573, 0.00491302506998181, 0.00493734702467918, 0.00496173184365034, 0.00498611712828279, 0.00501053407788277, 0.00503504602238536, 0.00505958963185549, 0.00508410204201937, 0.00510874064639211, 0.00513334758579731, 0.00515804998576641, 0.00518272072076797, 0.0052075176499784, 0.00523225171491504, 0.00525711290538311, 0.00528191030025482, 0.00530683482065797, 0.00533175840973854, 0.0053567779250443, 0.00538173364475369, 0.00540678482502699, 0.00543186767026782, 0.00545701431110501, 0.00548212882131338, 0.0055073699913919, 0.00553257949650288, 0.00555788446217775, 0.00558322109282017, 0.00560852559283376, 0.00563389388844371, 0.00565932504832745, 0.00568475713953376, 0.00571028375998139, 0.00573581084609032, 0.00576140079647303, 0.00578702241182327, 0.00581264449283481, 0.00583832990378141, 0.00586404697969556, 0.00588982691988349, 0.00591560732573271, 0.00594141939654946, 0.00596732692793012, 0.00599326612427831, 0.00601914152503014, 0.00604517571628094, 0.00607117777690291, 0.00609727576375008, 0.00612330948933959, 0.00614950247108936, 0.00617563119158149, 0.00620188750326633, 0.00622808001935482, 0.00625439966097474, 0.00628071930259466, 0.00630710180848837, 0.00633345358073711, 0.00635989988222718, 0.00638637784868479, 0.00641288748010993, 0.00643939711153507, 0.00646600220352411, 0.00649263896048069, 0.00651930691674352, 0.00654603866860271, 0.00657273828983307, 0.00659950217232108, 0.00662632891908288, 0.00665312400087714, 0.00668004620820284, 0.00670696794986725, 0.00673395395278931, 0.00676097068935633, 0.0067879562266171, 0.00681506842374802, 0.0068421489559114, 0.00686932448297739, 0.00689646834507585, 0.0069237076677382, 0.0069509781897068, 0.00697831250727177, 0.00700558302924037, 0.0070329811424017, 0.00706041045486927, 0.00708787143230438, 0.00711530074477196, 0.0071428888477385, 0.00717041315510869, 0.00719803245738149, 0.00722562102600932, 0.00725333578884602, 0.00728101842105389, 0.00730879651382565, 0.00733654294162989, 0.00736438436433673, 0.0073922579176724, 0.0074201631359756, 0.00744806788861752, 0.00747606810182333, 0.00750406831502914, 0.00753213232383132, 0.00756025873124599, 0.00758832227438688, 0.00761648127809167, 0.00764470268040895, 0.00767292501404881, 0.00770121114328504, 0.00772952800616622, 0.00775787699967623, 0.00778628932312131, 0.00781466998159885, 0.00784317776560783, 0.00787165388464928, 0.00790022406727076, 0.00792876351624727, 0.00795736629515886, 0.00798603240400553, 0.00801473017781973, 0.00804342795163393, 0.00807222072035074, 0.00810101348906755, 0.00812986958771944, 0.00815869402140379, 0.0081876777112484, 0.00821656547486782, 0.00824558082967997, 0.008274563588202, 0.00830367300659418, 0.0083327516913414, 0.00836192537099123, 0.00839103572070599, 0.00842027179896832, 0.00844954047352076, 0.00847884081304073, 0.00850810948759317, 0.00853750482201576, 0.00856690015643835, 0.00859635882079601, 0.00862588174641132, 0.00865534041076899, 0.00868489407002926, 0.00871447939425707, 0.00874406564980745, 0.00877377763390541, 0.00880345888435841, 0.00883323419839144, 0.00886301044374704, 0.00889278668910265, 0.00892265699803829, 0.00895255990326405, 0.00898249447345734, 0.00901242904365063, 0.00904242694377899, 0.00907248817384243, 0.00910258106887341, 0.00913264229893684, 0.00916283018887043, 0.00919298734515905, 0.00922323856502771, 0.00925349071621895, 0.00928383693099022, 0.00931411981582642, 0.00934453029185534, 0.00937490910291672, 0.00940538197755814, 0.00943585578352213, 0.00946642458438873, 0.00949693005532026, 0.0095275929197669, 0.00955819338560104, 0.00958888977766037, 0.00961955264210701, 0.00965034402906895, 0.00968113448470831, 0.00971198827028275, 0.00974287465214729, 0.00977372843772173, 0.00980464555323124, 0.00983565859496593, 0.00986663904041052, 0.00989771541208029, 0.00992879085242748, 0.0099599314853549, 0.00999113358557224, 0.0100223049521446, 0.0100535396486521, 0.0100848376750946, 0.0101161673665047, 0.0101474653929472, 0.0101788584142923, 0.0102103147655725, 0.0102418037131429, 0.0102732600644231, 0.0103048114106059, 0.0103363944217563, 0.0103680407628417, 0.0103996563702822, 0.0104313986375928, 0.0104630766436458, 0.0104948822408915, 0.0105266245082021, 0.0105584934353828, 0.0105903623625636, 0.0106222936883569, 0.0106542268767953, 0.0106862531974912, 0.0107182487845421, 0.0107503402978182, 0.0107823982834816, 0.0108145847916603, 0.0108467387035489, 0.0108789876103401, 0.0109112691134214, 0.0109435189515352, 0.0109758321195841, 0.0110082076862454, 0.0110405832529068, 0.0110730547457933, 0.0111055271700025, 0.0111380610615015, 0.0111706275492907, 0.0112031940370798, 0.0112358229234815, 0.0112685160711408, 0.0113012101501226, 0.0113339358940721, 0.0113666914403439, 0.0113995438441634, 0.0114324269816279, 0.0114652467891574, 0.0114982258528471, 0.0115311723202467, 0.0115642147138715, 0.0115971937775612, 0.0116303311660886, 0.0116634359583259, 0.0116966050118208, 0.0117297424003482, 0.0117630064487457, 0.0117962704971433, 0.0118295969441533, 0.011862893588841, 0.0118963159620762, 0.0119297066703439, 0.0119631933048368, 0.0119966482743621, 0.0120301963761449, 0.0120637454092503, 0.0120973912999034, 0.0121310353279114   }, 
   { 0.0124488295987248, 0.0124105121940374, 0.0123722637072206, 0.0123339463025331, 0.0122958347201347, 0.0122577222064137, 0.0122197475284338, 0.0121815670281649, 0.0121436612680554, 0.012105755507946, 0.0120679857209325, 0.0120300799608231, 0.0119923800230026, 0.0119547480717301, 0.0119171161204576, 0.0118794841691852, 0.0118419891223311, 0.0118045629933476, 0.0117670679464936, 0.0117297107353806, 0.0116923525929451, 0.0116551322862506, 0.011617979966104, 0.0115807587280869, 0.0115436762571335, 0.0115067288279533, 0.0114696463569999, 0.0114326989278197, 0.0113958902657032, 0.0113590806722641, 0.0113222021609545, 0.0112855304032564, 0.0112489266321063, 0.0112123228609562, 0.0111756511032581, 0.0111391842365265, 0.0111027862876654, 0.0110663874074817, 0.0110299894586205, 0.0109937284141779, 0.0109575362876058, 0.0109212752431631, 0.0108851511031389, 0.0108491647988558, 0.0108131775632501, 0.0107771912589669, 0.0107411360368133, 0.0107053546234965, 0.0106695732101798, 0.0106337238103151, 0.0105980793014169, 0.0105624357238412, 0.0105269281193614, 0.0104912845417857, 0.010455846786499, 0.0104204760864377, 0.010385106317699, 0.0103497365489602, 0.0103145036846399, 0.0102792708203197, 0.0102441757917404, 0.0102089419960976, 0.0101739149540663, 0.0101389568299055, 0.0101040666922927, 0.0100691076368093, 0.0100342864170671, 0.0099995331838727, 0.00996484886854887, 0.00993009563535452, 0.00989548023790121, 0.00986093282699585, 0.00982631649821997, 0.00979190599173307, 0.00975749641656876, 0.00972322281450033, 0.00968895014375448, 0.00965460855513811, 0.00962047278881073, 0.00958633702248335, 0.00955220032483339, 0.00951820146292448, 0.00948427058756351, 0.00945034064352512, 0.00941634178161621, 0.00938261672854424, 0.00934889260679483, 0.00931516662240028, 0.00928144250065088, 0.0092479232698679, 0.00921440403908491, 0.00918095372617245, 0.00914743449538946, 0.00911405216902494, 0.00908073876053095, 0.00904735736548901, 0.0090141799300909, 0.0089810723438859, 0.00894796475768089, 0.00891492515802383, 0.00888181757181883, 0.00884891487658024, 0.00881608109921217, 0.00878311041742563, 0.00875034555792809, 0.00871764868497849, 0.00868502072989941, 0.00865232385694981, 0.00861969590187073, 0.00858720578253269, 0.0085547836497426, 0.00852229259908199, 0.00848993845283985, 0.00845772121101618, 0.00842550490051508, 0.00839321967214346, 0.00836107134819031, 0.00832905992865562, 0.00829691253602505, 0.00826496910303831, 0.00823309551924467, 0.00820115208625793, 0.00816941633820534, 0.00813754182308912, 0.00810587406158447, 0.00807427335530519, 0.00804253667593002, 0.00801100581884384, 0.00797954294830561, 0.00794814806431532, 0.00791668612509966, 0.00788536015897989, 0.00785410311073065, 0.00782291404902935, 0.00779158854857087, 0.0077604684047401, 0.00772948609665036, 0.00769850285723805, 0.0076674516312778, 0.00763660576194525, 0.00760575942695141, 0.00757498200982809, 0.00754413660615683, 0.00751349655911326, 0.00748292496427894, 0.00745235336944461, 0.00742171239107847, 0.00739120971411467, 0.00736084347590804, 0.00733040925115347, 0.00730011193081737, 0.0072698830626905, 0.00723972264677286, 0.00720956223085523, 0.00717940181493759, 0.00714937830343843, 0.00711942324414849, 0.0070894006639719, 0.00705958297476172, 0.00702969683334231, 0.00700001604855061, 0.00697019835934043, 0.00694051804021001, 0.00691097462549806, 0.00688143074512482, 0.00685181934386492, 0.00682241283357143, 0.00679307477548718, 0.00676373718306422, 0.00673433067277074, 0.00670512998476624, 0.00667599774897099, 0.00664672814309597, 0.00661766482517123, 0.00658866995945573, 0.00655974308028817, 0.00653088511899114, 0.00650189025327563, 0.00647316919639707, 0.0064444481395185, 0.00641565909609199, 0.00638700649142265, 0.00635849125683308, 0.0063299760222435, 0.00630132388323545, 0.00627294555306435, 0.00624456768855453, 0.00621632626280189, 0.00618794793263078, 0.00615977542474866, 0.00613167183473706, 0.00610356731340289, 0.00607539527118206, 0.00604742858558893, 0.00601952988654375, 0.00599156320095062, 0.00596373341977596, 0.00593597209081054, 0.00590827921405435, 0.00588058633729815, 0.00585289392620325, 0.00582533841952682, 0.00579791981726885, 0.00577029585838318, 0.00574294524267316, 0.00571559555828571, 0.00568838277831674, 0.00566103309392929, 0.00563388830050826, 0.00560674443840981, 0.00557966809719801, 0.00555252423509955, 0.00552558526396751, 0.005498715210706, 0.00547184469178319, 0.00544497510418296, 0.00541824195533991, 0.00539157725870609, 0.00536491302773356, 0.00533824833109975, 0.0053117205388844, 0.00528519321233034, 0.00525880325585604, 0.00523234438151121, 0.00520602241158485, 0.00517976935952902, 0.00515344738960266, 0.00512733124196529, 0.00510121509432793, 0.00507523631677032, 0.00504925707355142, 0.00502320937812328, 0.00499736750498414, 0.004971525631845, 0.00494554685428739, 0.00491984188556671, 0.00489420536905527, 0.00486863777041435, 0.00484293280169368, 0.00481743365526199, 0.00479200296103954, 0.00476664071902633, 0.00474114157259464, 0.0047159162349999, 0.00469069136306643, 0.00466553494334221, 0.00464024115353823, 0.00461515365168452, 0.00459013413637877, 0.00456504616886377, 0.00454016402363777, 0.00451534986495972, 0.00449053617194295, 0.00446579093113542, 0.00444097723811865, 0.00441636890172958, 0.00439176103100181, 0.00436715316027403, 0.00434268172830343, 0.00431821076199412, 0.00429380824789405, 0.00426940573379397, 0.00424514058977365, 0.00422094343230128, 0.00419681565836072, 0.00417255004867911, 0.00414855917915702, 0.00412456737831235, 0.00410064496099949, 0.00407665362581611, 0.00405279966071248, 0.00402901414781809, 0.00400529708713293, 0.00398151157423854, 0.00395786296576262, 0.00393435126170516, 0.00391084048897028, 0.00388726033270359, 0.00386388623155653, 0.00384051189757884, 0.00381706864573061, 0.00379390013404191, 0.00377066317014396, 0.00374756311066449, 0.00372432568110526, 0.00370129430666566, 0.00367833115160465, 0.00365543668158352, 0.00363247375935316, 0.00360964774154127, 0.00358689064159989, 0.00356420152820647, 0.00354144442826509, 0.00351882399991155, 0.00349634070880711, 0.00347385765053332, 0.00345123722217977, 0.00342889106832445, 0.00340654491446912, 0.00338426767848432, 0.003361921524629, 0.00333978096023202, 0.00331770931370556, 0.00329550006426871, 0.00327356532216072, 0.00325156189501286, 0.0032296956051141, 0.00320789800025523, 0.00318596325814724, 0.00316423387266695, 0.00314250495284796, 0.00312091270461679, 0.00309918355196714, 0.00307772867381573, 0.00305627356283367, 0.00303474999964237, 0.00301336380653083, 0.00299204559996724, 0.00297086476348341, 0.00294961570762098, 0.00292843487113714, 0.00290732248686254, 0.00288621033541858, 0.00286516663618386, 0.00284419138915837, 0.00282335327938199, 0.00280258362181485, 0.00278167705982924, 0.00276097608730197, 0.00274034379981458, 0.00271971127949655, 0.00269901030696929, 0.00267858360894024, 0.00265815667808056, 0.00263772974722087, 0.0026172345969826, 0.00259694480337203, 0.00257672369480133, 0.00255650258623064, 0.00253634992986917, 0.00251626595854759, 0.00249631889164448, 0.00247637182474136, 0.00245628785341978, 0.00243647792376578, 0.00241666822694242, 0.00239685829728842, 0.00237711705267429, 0.0023574442602694, 0.00233790837228298, 0.00231823581270874, 0.00229876860976219, 0.00227936985902488, 0.00226003979332745, 0.00224057259038091, 0.00222137989476323, 0.00220218673348427, 0.00218299380503595, 0.00216380087658763, 0.00214474508538842, 0.00212575774639845, 0.0021067017223686, 0.0020877830684185, 0.00206900131888688, 0.00205021956935525, 0.0020315065048635, 0.00201272498816252, 0.00199414882808924, 0.00197557266801596, 0.00195692805573344, 0.00193848926573992, 0.00192011881154031, 0.00190174847375602, 0.00188330945093185, 0.00186507601756603, 0.0018469113856554, 0.00182881508953869, 0.00181058177258819, 0.00179255404509604, 0.001774663454853, 0.00175670452881604, 0.00173874525353312, 0.00172092334832996, 0.00170316989533603, 0.00168548489455134, 0.00166773132514209, 0.00165011489298195, 0.00163256714586169, 0.00161508773453534, 0.00159753987099975, 0.00158019771333784, 0.00156292400788516, 0.00154551328159869, 0.00152830814477056, 0.00151110300794244, 0.00149403500836343, 0.00147696700878441, 0.00145983032416552, 0.00144289946183562, 0.00142603705171496, 0.0014090376207605, 0.00139224377926439, 0.00137551850639284, 0.00135893025435507, 0.00134213641285896, 0.00132561672944576, 0.00130909716244787, 0.0012926459312439, 0.00127605779562145, 0.00125974381808192, 0.00124342972412705, 0.00122718431521207, 0.00121087022125721, 0.00119476183317602, 0.00117865356151015, 0.00116254517342895, 0.00114657380618155, 0.00113060255534947, 0.0011147684417665, 0.00109893409535289, 0.00108309998176992, 0.00106740288902074, 0.00105177436489612, 0.00103594013489783, 0.001020448631607, 0.00100495724473149, 0.00098953431006521, 0.000974042806774378, 0.000958688440732658, 0.000943402643315494, 0.000928185414522886, 0.000912899500690401, 0.000897819409146905, 0.000882807711604983, 0.000867796072270721, 0.000852647353895009, 0.000837772793602198, 0.000822898233309388, 0.000808023731224239, 0.00079328624997288, 0.000778617395553738, 0.000763948424719274, 0.000749416649341583, 0.00073474773671478, 0.000720284471753985, 0.000705889775417745, 0.000691426452249289, 0.000677100266329944, 0.0006627740804106, 0.000648585031740367, 0.000634327414445579, 0.000620275386609137, 0.000606223416980356, 0.00059223995776847, 0.000578187988139689, 0.000564341607969254, 0.000550563796423376, 0.000536785984877497, 0.000522939662914723, 0.000509230419993401, 0.000495658256113529, 0.000482086063129827, 0.000468445388833061, 0.000455010303994641, 0.000441643787780777, 0.000428277242463082, 0.000414910726249218, 0.000401681289076805, 0.000388520391425118, 0.000375222414731979, 0.000362198625225574, 0.000349174835719168, 0.000336219585733488, 0.000323332875268534, 0.000310309056658298, 0.000297490914817899, 0.000284741283394396, 0.000271923170657828, 0.000259310618275777, 0.000246698124101385, 0.00023422269441653, 0.000221610185690224, 0.000209203295526095, 0.000196864959434606, 0.000184526623343118, 0.000172119747730903, 0.000159918505232781, 0.000147785802255385, 0.000135653113829903, 0.000123451885883696, 0.000111456269223709, 9.9529221188277e-05, 8.75336190802045e-05, 7.57436573621817e-05, 6.39536883682013e-05, 5.22322770848405e-05, 4.05794053222053e-05, 2.87894436041825e-05, 1.72736672539031e-05, 5.75788862988702e-06, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 3.39675267859612e-15, 6.10062033956638e-06, 1.76849443960236e-05, 2.933781252068e-05, 4.09906861023046e-05, 5.2643554226961e-05, 6.44335159449838e-05, 7.62234776630066e-05, 8.80819861777127e-05, 0.000100009041489102, 0.000112004643597174, 0.000124000245705247, 0.000136064394610003, 0.000148197097587399, 0.000160398325533606, 0.000172599568031728, 0.000184937904123217, 0.00019727622566279, 0.000209751669899561, 0.000222158545511775, 0.00023470250016544, 0.000247177958954126, 0.000259858992649242, 0.000272540055448189, 0.000285221118247136, 0.00029797074967064, 0.000310857431031764, 0.000323675601975992, 0.000336630851961672, 0.000349654641468078, 0.000362678460078314, 0.000375839328626171, 0.000388931686757132, 0.000402161123929545, 0.000415459100622684, 0.000428825587732717, 0.000442123622633517, 0.000455558649264276, 0.000468993763206527, 0.000482565897982568, 0.000496138061862439, 0.000509847362991422, 0.000523488037288189, 0.000537265848834068, 0.000551043660379946, 0.00056488998234272, 0.000578804931137711, 0.00059271976351738, 0.000606771791353822, 0.000620892329607159, 0.000635012867860496, 0.000649133406113833, 0.000663391081616282, 0.00067764864070341, 0.000691974826622754, 0.000706369522958994, 0.00072083284612745, 0.000735364679712802, 0.000749965023715049, 0.00076449679909274, 0.000779234280344099, 0.000793903192970902, 0.000808709184639156, 0.000823446607682854, 0.000838389678392559, 0.000853264238685369, 0.000868275936227292, 0.000883287575561553, 0.000898436293937266, 0.000913585012312979, 0.000928733788896352, 0.000944019586313516, 0.000959373894147575, 0.000974659807980061, 0.000990151194855571, 0.00100557412952185, 0.00102106551639736, 0.00103662558831275, 0.00105225411243737, 0.00106795120518655, 0.00108371686656028, 0.00109955109655857, 0.00111531675793231, 0.00113128800876439, 0.00114719080738723, 0.00116323062684387, 0.00117933901492506, 0.0011953788343817, 0.00121155579108745, 0.00122780131641775, 0.00124404672533274, 0.00126036070287228, 0.00127674324903637, 0.00129319436382502, 0.00130971404723823, 0.00132630229927599, 0.00134282186627388, 0.00135954713914543, 0.00137620395980775, 0.00139292923267931, 0.00140979164279997, 0.00142658548429608, 0.00144351634662598, 0.00146051589399576, 0.00147751532495022, 0.00149465200956911, 0.00151178846135736, 0.00152892502956092, 0.0015461987350136, 0.00156354100909084, 0.00158088316675276, 0.00159829389303923, 0.00161577330436558, 0.00163318403065205, 0.00165080034639686, 0.001668416778557, 0.0016861017793417, 0.00170385523233563, 0.00172167737036943, 0.00173943082336336, 0.00175738986581564, 0.00177528045605868, 0.00179330806713551, 0.00181133591104299, 0.00182950065936893, 0.00184759683907032, 0.0018658300396055, 0.001884063356556, 0.00190243381075561, 0.0019208041485399, 0.00193917460273951, 0.00195768219418824, 0.00197625812143087, 0.00199483428150415, 0.00201347889378667, 0.00203219195827842, 0.00205090525560081, 0.00206975522451103, 0.00208853697404265, 0.00210745586082339, 0.00212644296698272, 0.00214549899101257, 0.00216455501504242, 0.00218367925845087, 0.00220280373468995, 0.00222213380038738, 0.00224139518104494, 0.00226079393178225, 0.00228012376464903, 0.00229959096759558, 0.00231905817054212, 0.0023385938256979, 0.00235826685093343, 0.00237787095829844, 0.00239761220291257, 0.00241742213256657, 0.00243723206222057, 0.00245711044408381, 0.00247705751098692, 0.00249700434505939, 0.00251708854921162, 0.0025371725205332, 0.00255732517689466, 0.00257754628546536, 0.00259776739403605, 0.00261805718764663, 0.00263848411850631, 0.00265884213149548, 0.00267933751456439, 0.00269983289763331, 0.00272053387016058, 0.00274109770543873, 0.002761798677966, 0.00278249965049326, 0.00280333776026964, 0.00282417587004602, 0.0028450139798224, 0.00286598899401724, 0.00288703269325197, 0.00290807639248669, 0.00292925722897053, 0.00295036961324513, 0.0029716189019382, 0.00299293687567115, 0.00301418616436422, 0.00303564127534628, 0.0030570961534977, 0.00307855103164911, 0.00310007459484041, 0.00312173529528081, 0.00314332754351199, 0.00316505646333098, 0.00318678584881127, 0.00320865213871002, 0.00323051819577813, 0.00325245317071676, 0.00327445636503398, 0.00329645979218185, 0.00331853190436959, 0.00334074068814516, 0.00336288125254214, 0.00338515872135758, 0.00340743619017303, 0.00342978234402835, 0.00345219695009291, 0.0034746800083667, 0.00349716353230178, 0.00351971527561545, 0.00354240392334759, 0.00356509280391037, 0.00358778145164251, 0.00361060746945441, 0.0036334334872663, 0.0036562595050782, 0.00367922242730856, 0.00370218511670828, 0.0037252854090184, 0.00374838546849787, 0.0037716228980571, 0.00379479140974581, 0.00381809729151428, 0.00384140270762146, 0.00386477704159915, 0.00388822006061673, 0.0039117312990129, 0.00393524253740907, 0.00395882269367576, 0.00398240284994245, 0.00400618836283684, 0.00402990495786071, 0.00405369093641639, 0.00407761335372925, 0.00410153577104211, 0.00412545865401626, 0.00414951844140887, 0.00417364668101072, 0.00419770646840334, 0.00422190316021442, 0.00424609985202551, 0.00427043391391635, 0.00429476797580719, 0.00431917048990726, 0.00434364145621657, 0.00436818087473512, 0.00439265230670571, 0.00441732862964272, 0.00444200541824102, 0.00446675065904856, 0.00449149589985609, 0.00451637804508209, 0.00454119173809886, 0.00456614280119538, 0.00459109339863062, 0.00461611291393638, 0.0046412693336606, 0.00466642621904612, 0.00469165109097958, 0.00471694441512227, 0.00474216975271702, 0.00476759998127818, 0.00479303114116192, 0.00481846136972308, 0.00484402989968657, 0.00486966595053673, 0.00489523354917765, 0.0049208696000278, 0.00494664302095771, 0.0049724169075489, 0.00499832723289728, 0.00502423755824566, 0.00505014834925532, 0.00507619604468346, 0.00510231219232082, 0.00512835942208767, 0.00515461293980479, 0.00518079707399011, 0.00520711950957775, 0.0052333720959723, 0.00525983143597841, 0.005286221858114, 0.00531274918466806, 0.00533927651122212, 0.00536594074219465, 0.00539260543882847, 0.00541933858767152, 0.00544607127085328, 0.00547287333756685, 0.00549974339082837, 0.00552661344408989, 0.00555362040176988, 0.00558062782511115, 0.00560777215287089, 0.00563491648063064, 0.00566212926059961, 0.00568934250622988, 0.00571669265627861, 0.00574404234066606, 0.00577146094292402, 0.0057988790795207, 0.00582643458619714, 0.00585405901074409, 0.00588168343529105, 0.00590930739417672, 0.00593706872314215, 0.00596483005210757, 0.00599265983328223, 0.00602062651887536, 0.00604859320446849, 0.0060765603557229, 0.00610466441139579, 0.00613270001485944, 0.00616094097495079, 0.00618911348283291, 0.00621735444292426, 0.00624566385522485, 0.00627411063760519, 0.0063024889677763, 0.00633100420236588, 0.00635958788916469, 0.00638810358941555, 0.00641682418063283, 0.00644547631964087, 0.00647426629438996, 0.00650312379002571, 0.00653198221698403, 0.00656083971261978, 0.00658990349620581, 0.00661883037537336, 0.00664796214550734, 0.00667702592909336, 0.00670629506930709, 0.00673549575731158, 0.00676483381539583, 0.00679417187348008, 0.00682357838377357, 0.00685298396274447, 0.00688252784311771, 0.00691213924437761, 0.00694175157696009, 0.00697143236175179, 0.00700111268088222, 0.00703086145222187, 0.00706067960709333, 0.00709063420072198, 0.00712052080780268, 0.00715054338797927, 0.00718063581734896, 0.00721072731539607, 0.00724088773131371, 0.00727111706510186, 0.00730134546756744, 0.00733171170577407, 0.00736200902611017, 0.00739244371652603, 0.00742294685915112, 0.00745351845398545, 0.00748402159661055, 0.00751473009586334, 0.00754537060856819, 0.00757614756003022, 0.00760699389502406, 0.00763783929869533, 0.00766868470236659, 0.00769973685964942, 0.00773071916773915, 0.00776170240715146, 0.00779289146885276, 0.00782401114702225, 0.00785526819527149, 0.00788659416139126, 0.00791792012751102, 0.00794931408017874, 0.0079807760193944, 0.00801223888993263, 0.00804383959621191, 0.00807543843984604, 0.00810710713267326, 0.00813877582550049, 0.00817058142274618, 0.00820238701999187, 0.00823432952165604, 0.00826620310544968, 0.00829821452498436, 0.00833029393106699, 0.00836237426847219, 0.00839452166110277, 0.00842673797160387, 0.00845895614475012, 0.00849130935966969, 0.00852359458804131, 0.00855601672083139, 0.008588507771492, 0.00862106680870056, 0.00865362677723169, 0.00868625566363335, 0.00871895160526037, 0.00875164847820997, 0.00878448132425547, 0.00881731510162354, 0.00885021779686213, 0.00888318847864866, 0.0089161591604352, 0.00894919876009226, 0.00898237526416779, 0.00901548285037279, 0.00904872734099627, 0.00908204168081284, 0.00911542307585478, 0.00914873648434877, 0.00918218679726124, 0.00921563804149628, 0.00924922619014978, 0.00928281340748072, 0.00931646954268217, 0.00935019459575415, 0.00938398763537407, 0.00941771268844604, 0.00945164263248444, 0.00948550458997488, 0.00951950438320637, 0.00955357123166323, 0.00958763901144266, 0.00962177477777004, 0.00965597946196795, 0.00969018321484327, 0.00972452573478222, 0.00975893530994654, 0.00979320984333754, 0.00982775632292032, 0.00986230373382568, 0.00989678222686052, 0.00993146654218435, 0.00996615085750818, 0.0100008361041546, 0.0100356573238969, 0.0100704785436392, 0.010105368681252, 0.0101403277367353, 0.0101753547787666, 0.0102103818207979, 0.0102454777806997, 0.010280572809279, 0.0103158056735992, 0.01035110745579, 0.0103864772245288, 0.010421778075397, 0.0104572856798768, 0.0104927234351635, 0.0105282310396433, 0.0105638755485415, 0.0105995191261172, 0.0106352316215634, 0.0106710130348802, 0.0107067255303264, 0.010742574930191, 0.0107785621657968, 0.0108144795522094, 0.010850534774363, 0.0108865909278393, 0.0109227150678635, 0.0109589071944356, 0.0109951682388783, 0.0110314292833209, 0.011067827232182, 0.0111041571944952, 0.0111406240612268, 0.0111771589145064, 0.011213693767786, 0.0112502975389361, 0.0112869702279568, 0.0113236429169774, 0.0113604515790939, 0.011397329159081, 0.0114341387525201, 0.0114711541682482, 0.0115081686526537, 0.0115451840683818, 0.0115822665393353, 0.0116194197908044, 0.0116565711796284, 0.011693861335516, 0.0117311496287584, 0.011768507771194, 0.0118060018867254, 0.011843497864902, 0.0118809919804335, 0.0119185550138354, 0.0119561869651079, 0.0119938878342509, 0.0120315877720714, 0.0120694255456328, 0.0121072633191943, 0.0121451690793037, 0.0121830748394132, 0.0122211184352636, 0.0122591620311141, 0.0122972736135125, 0.012335523031652, 0.0123737715184689, 0.0124120200052857, 0.0124503374099731, 0.0124887237325311, 0.012527110055089, 0.0125656323507428, 0.0126041555777192, 0.0126428147777915, 0.0126814758405089, 0.0127201350405812, 0.0127589330077171, 0.0127977980300784, 0.0128365959972143, 0.0128755988553166, 0.012914533726871, 0.0129536045715213, 0.0129926754161716, 0.0130318151786923, 0.0130709558725357, 0.013110232539475, 0.0131495101377368, 0.0131889237090945, 0.0132283382117748, 0.0132678207010031, 0.0133073031902313, 0.013346922583878, 0.0133864739909768, 0.013426162302494, 0.0134659875184298, 0.013505675829947, 0.0135455699637532, 0.0135854640975595, 0.0136253591626883, 0.0136653892695904, 0.013705488294363, 0.0137455193325877, 0.0137857561931014, 0.0138259241357446, 0.0138662308454514, 0.0139065347611904, 0.0139469774439931, 0.0139873512089252, 0.0140278618782759, 0.0140683716163039, 0.0141089521348476, 0.0141495997086167, 0.0141903851181269, 0.0142311016097665, 0.0142719550058246, 0.0143127404153347, 0.0143536627292633, 0.0143946539610624, 0.0144356433302164, 0.0144767723977566, 0.0145179675891995, 0.0145590268075466, 0.0146002918481827, 0.0146416248753667, 0.0146829579025507, 0.0147243607789278, 0.0147657617926598, 0.0148073025047779, 0.0148489093407989, 0.014890518039465, 0.0149321928620338, 0.0149739384651184, 0.0150156831368804, 0.0150574957951903, 0.0150993773713708, 0.0151413278654218, 0.0151833463460207, 0.0152253657579422, 0.0152674540877342, 0.0153096094727516, 0.0153518337756395, 0.0153940571472049, 0.0154347391799092, 0.0154735716059804, 0.0155123686417937, 0.0155513025820255, 0.0155902365222573, 0.0156292747706175, 0.0156683456152678, 0.0157075542956591, 0.0157467294484377, 0.0157860741019249, 0.0158253163099289, 0.0158647652715445, 0.01590421423316, 0.0159437656402588, 0.0159833170473576, 0.0160230044275522, 0.0160626582801342, 0.0161024499684572, 0.0161422416567802, 0.0161821693181992, 0.0162220969796181, 0.0162621289491653, 0.0163022261112928, 0.0163423269987106, 0.0163825638592243, 0.0164227671921253, 0.0164631400257349, 0.0165034458041191, 0.0165439564734697, 0.0165843982249498, 0.016624977812171, 0.0166655909270048, 0.0167062729597092, 0.0167469903826714, 0.0167878083884716, 0.0168286971747875, 0.0168696045875549, 0.0169105604290962, 0.0169516708701849, 0.0169927123934031, 0.0170339420437813, 0.0170751046389341, 0.0171164385974407, 0.0171577539294958, 0.0171991735696793, 0.0172406435012817, 0.0172821991145611, 0.0173237901180983, 0.0173654481768608, 0.0174071434885263, 0.0174489561468363, 0.0174908190965652, 0.0175327192991972, 0.0175746511667967, 0.0176166538149118, 0.0176588110625744, 0.0177008807659149, 0.0177431236952543, 0.0177853982895613, 0.0178277269005775, 0.017870070412755, 0.017912570387125, 0.0179550517350435, 0.0179976522922516, 0.0180402882397175, 0.0180829744786024, 0.0181256961077452, 0.0181685052812099, 0.0182113461196423, 0.0182543583214283, 0.0182973183691502, 0.0183404181152582, 0.0183834824711084, 0.018426701426506, 0.0184699017554522, 0.018513223156333, 0.0185565780848265, 0.0186000373214483, 0.018643494695425, 0.0186870563775301, 0.0187306180596352, 0.0187742989510298, 0.0188180301338434, 0.0188618488609791, 0.0189057514071465, 0.0189496055245399, 0.0189936123788357, 0.0190375857055187, 0.0190817285329103, 0.0191258899867535, 0.019170118495822, 0.0192143656313419, 0.0192587487399578, 0.0193030647933483, 0.0193476025015116, 0.0193921066820621, 0.0194366276264191, 0.0194813180714846, 0.0195260290056467, 0.0195707716047764, 0.0196156017482281, 0.019660534337163, 0.0197054650634527, 0.0197504833340645, 0.0197955369949341, 0.0198406558483839, 0.0198858622461557, 0.0199311543256044, 0.0199764110147953, 0.0200218074023724, 0.0200672186911106, 0.0201127678155899, 0.0201583001762629, 0.0202039014548063, 0.0202496200799942, 0.0202953405678272, 0.0203411299735308, 0.0203869882971048, 0.020432947203517, 0.0204788893461227, 0.0205249544233084, 0.0205710344016552, 0.0206172168254852, 0.0206634514033794, 0.0207097716629505, 0.0207560919225216, 0.0208025313913822, 0.0208489894866943, 0.0208955314010382, 0.0209421273320913, 0.0209887903183699, 0.0210354514420033, 0.0210822857916355, 0.0211291052401066, 0.0211760234087706, 0.0212229955941439, 0.0212700013071299, 0.0213171094655991, 0.0213642679154873, 0.0214114282280207, 0.0214587077498436, 0.0215060580521822, 0.0215534046292305, 0.0216008741408587, 0.0216483771800995, 0.0216959286481142, 0.0217435695230961, 0.0217912774533033, 0.0218390226364136, 0.0218868665397167, 0.0219347290694714, 0.021982641890645, 0.0220306254923344, 0.0220787432044744, 0.0221268460154533, 0.0221750009804964, 0.0222232230007648, 0.0222715474665165, 0.0223198719322681, 0.022368336096406, 0.022416815161705, 0.0224653780460358, 0.0225140154361725, 0.0225626826286316, 0.0226114001125097, 0.0226602051407099, 0.0227090772241354, 0.0227579530328512, 0.0228069275617599, 0.0228559393435717, 0.0229050349444151, 0.0229542180895805, 0.0230034161359072, 0.0230526849627495, 0.0231020208448172, 0.0231514442712069, 0.0232008993625641, 0.0232504401355982, 0.0233000162988901, 0.0233496427536011, 0.0233993399888277, 0.0234490893781185, 0.0234989374876022, 0.0235488209873438, 0.0235987920314074, 0.0236487984657288, 0.023698853328824, 0.0237489435821772, 0.0237991698086262, 0.0238494481891394, 0.0238997954875231, 0.0239501260221004, 0.0240005608648062, 0.0240510609000921, 0.0241016130894423, 0.0241522695869207, 0.0242029093205929, 0.0242536831647158, 0.0243044774979353, 0.0243553388863802, 0.0244062840938568, 0.0244572665542364, 0.0245083160698414, 0.0245594177395105, 0.0246105529367924, 0.0246618092060089, 0.0247131157666445, 0.0247644577175379, 0.0248158313333988, 0.024867344647646, 0.0249188393354416, 0.0249704383313656, 0.0250221230089664, 0.0250738747417927, 0.0251256097108126, 0.0251774489879608, 0.0252293534576893, 0.0252813119441271, 0.0253333393484354, 0.0253853835165501, 0.0254375301301479, 0.025489779189229, 0.0255420114845037, 0.0255943648517132, 0.0256467498838902, 0.025699170306325, 0.0257517453283072, 0.0258042868226767, 0.0258569121360779, 0.0259096082299948, 0.0259623881429434, 0.0260151699185371, 0.0260680373758078, 0.0261209886521101, 0.0261739902198315, 0.0262270122766495, 0.0262802038341761, 0.0263333432376385, 0.0263865850865841, 0.0264398641884327, 0.0264932624995708, 0.0265466254204512, 0.0266001783311367, 0.0266536772251129, 0.0267073307186365, 0.0267609693109989, 0.0268146935850382, 0.0268684662878513, 0.026922345161438, 0.0269762724637985, 0.0270302183926105, 0.0270842518657446, 0.027138352394104, 0.0271924864500761, 0.0272467397153378, 0.0273010116070509, 0.0273553524166346, 0.0274097584187984, 0.0274641867727041, 0.0275187846273184, 0.02757334895432, 0.0276279971003532, 0.0276826787739992, 0.0277374461293221, 0.0277922470122576, 0.0278471708297729, 0.027902128174901, 0.0279571525752544, 0.028012178838253, 0.0280673243105412, 0.0281224884092808, 0.0281777549535036, 0.0282330866903067, 0.0282884389162064, 0.0283438749611378, 0.0283993817865849, 0.0284549184143543, 0.0285105798393488, 0.0285662747919559, 0.0286219660192728, 0.0286778174340725, 0.0287336278706789, 0.0287895277142525, 0.0288455653935671, 0.0289016179740429, 0.028957711532712, 0.0290138628333807, 0.0290701054036617, 0.0291264336556196, 0.0291827619075775, 0.0292392279952765, 0.0292956419289112, 0.0293522235006094, 0.0294087771326303, 0.0294654313474894, 0.0295221526175737, 0.029578909277916, 0.0296357683837414, 0.0296926777809858, 0.0297496225684881, 0.0298066530376673, 0.0298637542873621, 0.0299208872020245, 0.0299781039357185, 0.0300353597849607, 0.030092665925622, 0.0301500670611858, 0.0302075147628784, 0.0302650071680546, 0.0303225852549076, 0.0303802136331797, 0.0304379127919674, 0.0304956305772066, 0.0305535141378641, 0.0306113511323929, 0.0306693110615015, 0.030727282166481, 0.0307853259146214, 0.0308434665203094, 0.0309016145765781, 0.0309599097818136, 0.0310182254761457, 0.0310765411704779, 0.0311349928379059, 0.0311934631317854, 0.0312520191073418, 0.0313106440007687, 0.0313693061470985, 0.0314280278980732, 0.0314868427813053, 0.0315456688404083, 0.0316045880317688, 0.0316635556519032, 0.0317225754261017, 0.0317816622555256, 0.0318408310413361, 0.0319000743329525, 0.0319593362510204, 0.0320186614990234, 0.0320780538022518, 0.0321375355124474, 0.0321970172226429, 0.0322566516697407, 0.0323162712156773, 0.0323760099709034, 0.032435730099678, 0.0324955731630325, 0.0325554274022579, 0.032615389674902, 0.0326754339039326, 0.0327354818582535, 0.0327956490218639, 0.0328558683395386, 0.0329160839319229, 0.0329764224588871, 0.0330368131399155, 0.0330972000956535, 0.03315769135952, 0.0332182720303535, 0.0332788825035095, 0.0333396010100842, 0.0334003269672394, 0.0334610976278782, 0.033521980047226, 0.0335828997194767, 0.0336438715457916, 0.0337049476802349, 0.0337660573422909, 0.033827219158411, 0.0338884294033051, 0.0339497104287148, 0.0340110585093498, 0.0340724959969521, 0.0341340005397797, 0.034195501357317, 0.0342570915818214, 0.0343187302350998, 0.034380454570055, 0.0344422496855259, 0.0345040634274483, 0.0345659926533699, 0.0346279926598072, 0.0346899591386318, 0.0347520634531975, 0.0348142012953758, 0.0348764024674892, 0.0349386781454086, 0.0350009724497795, 0.0350633822381496, 0.0351258330047131, 0.0351883769035339, 0.0352509059011936, 0.0353135764598846, 0.0353762470185757, 0.035438995808363, 0.0355017520487309, 0.035564698278904, 0.0356276407837868, 0.0356906317174435, 0.0357536599040031, 0.0358167737722397, 0.0358799248933792, 0.0359432101249695, 0.0360065139830112, 0.0360698997974396, 0.0361333042383194, 0.0361967794597149, 0.0362602882087231, 0.0363239347934723, 0.0363875962793827, 0.0364512875676155, 0.03651512414217, 0.0365789756178856, 0.0366428941488266, 0.0367068313062191, 0.0367709398269653, 0.0368350148200989, 0.0368991754949093, 0.0369633510708809, 0.0370276793837547, 0.0370919965207577, 0.0371564067900181, 0.0372208431363106, 0.0372853614389896, 0.0373499169945717, 0.0374146215617657, 0.0374792777001858, 0.0375440903007984, 0.0376089178025723, 0.0376737788319588, 0.0377387478947639, 0.0378037616610527, 0.0378688089549541, 0.0379339158535004, 0.037999115884304, 0.0380643717944622, 0.0381297320127487, 0.0381950400769711, 0.0382605046033859, 0.0383259989321232, 0.0383915640413761, 0.0384571626782417, 0.0385228618979454, 0.0385885834693909, 0.0386544205248356, 0.0387202762067318, 0.0387861989438534, 0.0388522110879421, 0.0389182902872562, 0.0389843322336674, 0.0390505492687225, 0.0391167663037777, 0.0391830652952194, 0.0392494015395641, 0.0393158234655857, 0.03938227891922, 0.0394488051533699, 0.0395153947174549, 0.0395820736885071, 0.0396487861871719, 0.039715550839901, 0.0397824011743069, 0.0398492850363255, 0.0399162545800209, 0.0399832278490067, 0.0400503687560558, 0.0401174873113632, 0.0401847176253796, 0.0402519777417183, 0.0403192713856697, 0.0403866358101368, 0.0404541380703449, 0.0405216217041016, 0.0405892096459866, 0.0406568273901939, 0.0407245382666588, 0.0407923124730587, 0.040860153734684, 0.0409279987215996, 0.0409959629178047, 0.0410639606416225, 0.0411320067942142, 0.0412000939249992, 0.041268277913332, 0.0413365326821804, 0.0414048247039318, 0.0414731800556183, 0.0415415912866592, 0.0416100844740868, 0.0416786298155785, 0.0417472645640373, 0.0418159477412701, 0.041884683072567, 0.0419534333050251, 0.0420222878456116, 0.0420911945402622, 0.0421601682901382, 0.0422291792929173, 0.0422983057796955, 0.0423674546182156, 0.0424366481602192, 0.0425059162080288, 0.0425752848386765, 0.0426446683704853, 0.0427141785621643, 0.04278364777565, 0.0428532920777798, 0.0429229028522968, 0.0429926291108131, 0.0430623777210712, 0.0431322418153286, 0.0432021245360374, 0.0432720556855202, 0.0433420613408089, 0.0434121154248714, 0.0434822365641594, 0.0435524471104145, 0.043622687458992, 0.0436930358409882, 0.0437634140253067, 0.0438337922096252, 0.0439043268561363, 0.0439748838543892, 0.0440454818308353, 0.0441161543130875, 0.0441869311034679, 0.0442577041685581, 0.0443285778164864, 0.0443994887173176, 0.0444705039262772, 0.0445415191352367, 0.0446126535534859, 0.0446837842464447, 0.0447550378739834, 0.0448263324797153, 0.0448976680636406, 0.0449691116809845, 0.0450405739247799, 0.0451121293008327, 0.0451836958527565, 0.0452553778886795, 0.0453270971775055, 0.0453988797962666, 0.0454707145690918, 0.0455426014959812, 0.0456145405769348, 0.0456865839660168, 0.0457586608827114, 0.0458308421075344, 0.0459030047059059, 0.0459753014147282, 0.0460476353764534, 0.0461200214922428, 0.0461924225091934, 0.0462649799883366, 0.046337503939867, 0.0464101433753967, 0.0464828349649906, 0.0465555787086487, 0.0466283932328224, 0.046701293438673, 0.0467742457985878, 0.046847227960825, 0.046920295804739, 0.0469934232532978, 0.0470665618777275, 0.0471398159861565, 0.0472131110727787, 0.047286469489336, 0.0473599210381508, 0.0474334023892879, 0.0475069507956505, 0.047580536454916, 0.0476542413234711, 0.0477279424667358, 0.0478017665445805, 0.0478755943477154, 0.0479495041072369, 0.0480234995484352, 0.0480975285172462, 0.0481715947389603, 0.0482457801699638, 0.0483199954032898, 0.0483942665159702, 0.0484685860574245, 0.048542995005846, 0.0486174672842026, 0.0486919954419136, 0.0487665422260761, 0.0488412044942379, 0.0489159189164639, 0.0489906892180443, 0.0490654893219471, 0.0491403564810753, 0.0492153503000736, 0.0492903403937817, 0.0493654124438763, 0.0494405217468739, 0.0495157204568386, 0.0495909973978996, 0.0496662817895412, 0.0497417002916336, 0.0498171523213387, 0.0498926192522049, 0.049968171864748, 0.0500437989830971, 0.0501195229589939, 0.0501952022314072, 0.050271064043045, 0.0503468886017799, 0.050422839820385, 0.05049879103899, 0.0505748428404331, 0.0506509654223919, 0.050727155059576, 0.0508033260703087, 0.0508796535432339, 0.0509560145437717, 0.0510324239730835, 0.0511088855564594, 0.0511854030191898, 0.0512620024383068, 0.0513386391103268, 0.0514153763651848, 0.051492128521204, 0.0515690036118031, 0.0516458824276924, 0.051722839474678, 0.0517998710274696, 0.0518769472837448, 0.0519540794193745, 0.052031297236681, 0.0521085858345032, 0.0521859228610992, 0.0522632896900177, 0.0523407682776451, 0.0524182431399822, 0.0524958521127701, 0.0525734648108482, 0.0526511780917645, 0.0527289137244225, 0.0528067462146282, 0.0528845936059952, 0.0529625341296196, 0.0530405081808567, 0.0531185790896416, 0.0531967245042324, 0.0532748475670815, 0.0533531121909618, 0.0534314252436161, 0.053509809076786, 0.0535882078111172, 0.0536667108535767, 0.0537452474236488, 0.0538238361477852, 0.0539025254547596, 0.0539812333881855, 0.0540600083768368, 0.0541388876736164, 0.0542177557945251, 0.054296750575304, 0.0543757863342762, 0.0544549040496349, 0.0545340739190578, 0.0546133182942867, 0.0546925589442253, 0.0547719188034534, 0.054851308465004, 0.054930791258812, 0.0550102852284908, 0.0550899021327496, 0.0551695004105568, 0.0552492178976536, 0.0553290098905563, 0.0554088167846203, 0.0554886870086193, 0.0555686354637146, 0.0556486733257771, 0.0557287260890007, 0.0558088533580303, 0.0558890365064144, 0.0559692829847336, 0.0560496002435684, 0.0561299882829189, 0.0562103800475597, 0.0562909170985222, 0.0563714727759361, 0.0564521215856075, 0.0565327703952789, 0.0566135346889496, 0.0566943325102329, 0.0567751787602901, 0.0568560995161533, 0.0569371245801449, 0.0570181272923946, 0.0570992678403854, 0.0571804270148277, 0.0572616867721081, 0.0573429688811302, 0.0574242770671844, 0.05750572681427, 0.0575871989130974, 0.0576687343418598, 0.0577502883970737, 0.0578319616615772, 0.0579136982560158, 0.0579954609274864, 0.0580772683024406, 0.0581591986119747, 0.0582411624491215, 0.0583231821656227, 0.0584052614867687, 0.0584874004125595, 0.0585696026682854, 0.0586518906056881, 0.0587341859936714, 0.0588165745139122, 0.058899037539959, 0.0589815452694893, 0.0590641126036644, 0.0591467469930649, 0.0592294298112392, 0.0593121834099293, 0.059395007789135, 0.059477873146534, 0.0595608539879322, 0.0596437938511372, 0.0597268715500832, 0.0598100125789642, 0.0598932020366192, 0.0599764287471771, 0.0600597336888313, 0.0601431019604206, 0.0602265223860741, 0.0603099763393402, 0.0603935718536377, 0.0604771226644516, 0.0605608038604259, 0.0606445483863354, 0.060728345066309, 0.0608121454715729, 0.0608961172401905, 0.0609800443053246, 0.0610640868544579, 0.0611481964588165, 0.0612323544919491, 0.061316542327404, 0.0614008568227291, 0.0614851713180542, 0.0615696012973785, 0.0616540461778641, 0.0617385804653168, 0.0618231296539307, 0.0619077868759632, 0.0619924999773502, 0.0620772540569305, 0.0621621012687683, 0.0622470006346703, 0.0623319372534752, 0.0624169372022152, 0.0625020042061806, 0.062587134540081, 0.0626723542809486, 0.0627575889229774, 0.0628428980708122, 0.0629282891750336, 0.0630137398838997, 0.0630992129445076, 0.0631847754120827, 0.0632704049348831, 0.0633561015129089, 0.0634418055415154, 0.0635276213288307, 0.0636134818196297, 0.0636994391679764, 0.0637853741645813, 0.0638714358210564, 0.063957542181015, 0.0640437230467796, 0.0641299411654472, 0.0642161890864372, 0.0643025636672974, 0.0643889978528023, 0.0644754469394684, 0.0645619779825211, 0.0646485984325409, 0.0647352412343025, 0.0648219659924507, 0.0649087354540825, 0.0649956166744232, 0.0650824829936028, 0.0651694685220718, 0.0652564689517021, 0.065343551337719, 0.0654307305812836, 0.0655179172754288, 0.0656051635742188, 0.0656925439834595, 0.065779872238636, 0.0658673346042633, 0.0659548491239548, 0.0660424306988716, 0.0661300271749496, 0.0662176907062531, 0.0663054957985878, 0.0663933232426643, 0.0664812028408051, 0.0665690749883652, 0.0666570886969566, 0.0667451694607735, 0.0668332725763321, 0.0669214725494385, 0.0670096874237061, 0.0670979842543602, 0.0671863481402397, 0.067274771630764, 0.0673632770776749, 0.0674517974257469, 0.0675404444336891, 0.0676290988922119, 0.0677178427577019, 0.0678066536784172, 0.0678954944014549, 0.0679843798279762, 0.0680733770132065, 0.0681624040007591, 0.0682514756917953, 0.0683406740427017, 0.0684298649430275, 0.068519115447998, 0.0686085000634193, 0.0686978846788406, 0.0687873736023903, 0.0688768774271011, 0.0689664483070374, 0.0690560713410378, 0.0691457837820053, 0.0692355632781982, 0.0693253800272942, 0.0694152787327766, 0.0695051997900009, 0.0695952251553535, 0.0696852952241898, 0.0697754099965096, 0.0698656067252159, 0.0699558779597282, 0.0700461715459824, 0.070136584341526, 0.0702269747853279, 0.0703174918889999, 0.0704080611467361, 0.0704986602067947, 0.0705893635749817, 0.0706801414489746, 0.0707708969712257, 0.0708617866039276, 0.0709527134895325, 0.0710437297821045, 0.0711347237229347, 0.0712258368730545, 0.0713170245289803, 0.0714082345366478, 0.0714995265007019, 0.0715908482670784, 0.0716822668910027, 0.0717737674713135, 0.0718652904033661, 0.0719568654894829, 0.0720485672354698, 0.0721402317285538, 0.0722320303320885, 0.072323851287365, 0.0724157691001892, 0.0725076869130135, 0.0725997611880302, 0.0726918205618858, 0.072783961892128, 0.0728761702775955, 0.0729684382677078, 0.0730607509613037, 0.0731531903147697, 0.0732455924153328, 0.0733381286263466, 0.073430672287941, 0.0735233724117279, 0.0736160054802895, 0.073708787560463, 0.0738015994429588, 0.0738945007324219, 0.0739874094724655, 0.0740803927183151, 0.0741734430193901, 0.0742665827274323, 0.0743597596883774, 0.0744529664516449, 0.0745463073253632, 0.0746396631002426, 0.074733093380928, 0.0748265609145164, 0.0749201253056526, 0.07501370459795, 0.0751074105501175, 0.0752010941505432, 0.0752948820590973, 0.0753887519240379, 0.0754826664924622, 0.0755766108632088, 0.0756706893444061, 0.0757647678256035, 0.075858935713768, 0.0759531334042549, 0.0760474354028702, 0.0761417374014854, 0.0762361586093903, 0.0763306245207787, 0.0764251723885536, 0.0765197351574898, 0.0766143500804901, 0.0767090767621994, 0.0768038257956505, 0.0768986940383911, 0.0769935473799706, 0.0770885199308395, 0.0771834924817085, 0.0772786140441895, 0.077373705804348, 0.0774688944220543, 0.0775641798973083, 0.0776594877243042, 0.0777548402547836, 0.0778502896428108, 0.0779457837343216, 0.0780413448810577, 0.0781369879841805, 0.0782326385378838, 0.0783283859491348, 0.0784241780638695, 0.0785200372338295, 0.0786159709095955, 0.0787119641900063, 0.0788079798221588, 0.0789040997624397, 0.0790002569556236, 0.0790964961051941, 0.0791927501559258, 0.0792891606688499, 0.0793855637311935, 0.0794820487499237, 0.079578585922718, 0.0796751827001572, 0.0797718092799187, 0.0798685848712921, 0.0799653306603432, 0.0800621435046196, 0.080159068107605, 0.0802560448646545, 0.0803530290722847, 0.0804501324892044, 0.0805472433567047, 0.0806444585323334, 0.0807417556643486, 0.0808390602469444, 0.0809364169836044, 0.0810338854789734, 0.0811314135789871, 0.0812289491295815, 0.0813266113400459, 0.0814242735505104, 0.0815220400691032, 0.0816198587417603, 0.081717737019062, 0.081815667450428, 0.0819136798381805, 0.0820117220282555, 0.0821098387241364, 0.082208015024662, 0.082306295633316, 0.0824045687913895, 0.082502968609333, 0.0826013684272766, 0.082699827849865, 0.0827984288334846, 0.0828970298171043, 0.0829956755042076, 0.0830944404006004, 0.0831931680440903, 0.083292044699192, 0.0833909511566162, 0.0834899172186852, 0.0835889354348183, 0.0836880654096603, 0.083787202835083, 0.083886444568634, 0.0839857161045074, 0.0840850695967674, 0.0841844081878662, 0.0842839106917381, 0.0843834057450294, 0.0844830051064491, 0.0845826491713524, 0.0846915170550346, 0.0848095342516899, 0.0849275887012482, 0.0850456580519676, 0.085163801908493, 0.0852819755673409, 0.0854001566767693, 0.085518442094326, 0.0856367722153664, 0.0857550501823425, 0.0858734399080276, 0.0859918519854546, 0.0861102566123009, 0.0862287506461143, 0.0863472893834114, 0.0864658355712891, 0.0865844488143921, 0.0867030397057533, 0.0868217274546623, 0.0869404673576355, 0.0870591998100281, 0.0871779769659042, 0.087296836078167, 0.0874156951904297, 0.0875345766544342, 0.0876535549759865, 0.0877725332975388, 0.0878915637731552, 0.0880106240510941, 0.0881297066807747, 0.0882488638162613, 0.0883680060505867, 0.0884872451424599, 0.088606484234333, 0.0887257903814316, 0.0888451263308525, 0.0889644846320152, 0.0890839099884033, 0.0892033651471138, 0.0893228575587273, 0.0894424244761467, 0.0895619988441467, 0.0896815657615662, 0.0898012295365334, 0.0899209007620811, 0.0900406241416931, 0.0901604145765305, 0.0902801975607872, 0.0903999954462051, 0.0905198976397514, 0.0906398072838783, 0.0907597467303276, 0.090879775583744, 0.0909997746348381, 0.0911198481917381, 0.0912399962544441, 0.0913601070642471, 0.0914802923798561, 0.0916005373001099, 0.0917207971215248, 0.0918410941958427, 0.0919614434242249, 0.0920818150043488, 0.0922022461891174, 0.0923226922750473, 0.0924431756138802, 0.0925637260079384, 0.0926843211054802, 0.0928049236536026, 0.0929255858063698, 0.0930462703108788, 0.0931670218706131, 0.0932877734303474, 0.0934085994958878, 0.0935294330120087, 0.0936503112316132, 0.0937712416052818, 0.0938922315835953, 0.0940132141113281, 0.0941342785954475, 0.0942553356289864, 0.0943764373660088, 0.0944976359605789, 0.0946187898516655, 0.094740055501461, 0.094861313700676, 0.0949826091527939, 0.0951039865612984, 0.0952253714203835, 0.0953467562794685, 0.095468282699585, 0.095589779317379, 0.0957112908363342, 0.0958328694105148, 0.0959545150399208, 0.0960761681199074, 0.0961979031562805, 0.0963195711374283, 0.0964413806796074, 0.0965631976723671, 0.096685029566288, 0.0968069359660149, 0.0969288796186447, 0.0970508605241776, 0.0971728712320328, 0.0972949266433716, 0.0974170118570328, 0.0975391268730164, 0.0976612940430641, 0.0977834835648537, 0.0979057475924492, 0.0980280339717865, 0.098150335252285, 0.0982726961374283, 0.0983951166272163, 0.098517544567585, 0.0986400172114372, 0.0987625271081924, 0.0988850742578506, 0.0990076512098312, 0.099130280315876, 0.0992529764771461, 0.0993756577372551, 0.0994984209537506, 0.0996212065219879, 0.0997440069913864, 0.0998668819665909, 0.0999897941946983, 0.100112698972225, 0.10023570805788, 0.100358709692955, 0.100481756031513, 0.100604876875877, 0.100728042423725, 0.100851200520992, 0.100974440574646, 0.101097665727139, 0.101220943033695, 0.101344287395477, 0.101467661559582, 0.101591043174267, 0.101714506745338, 0.101837977766991, 0.101961500942707, 0.102085068821907, 0.102208659052849, 0.102332301437855, 0.102455973625183, 0.102579675614834, 0.102703422307968, 0.102827236056328, 0.10295107960701, 0.103074908256531, 0.10319884121418, 0.10332278907299, 0.103446744382381, 0.103570811450481, 0.103694878518581, 0.103818982839584, 0.10394311696291, 0.104067288339138, 0.104191534221172, 0.104315772652626, 0.104440048336983, 0.104564405977726, 0.104688815772533, 0.10481321066618, 0.104937687516212, 0.105062171816826, 0.105186685919762, 0.105311289429665, 0.105435892939568, 0.105560503900051, 0.105685226619244, 0.105809912085533, 0.105934664607048, 0.106059491634369, 0.10618432611227, 0.106309205293655, 0.106434144079685, 0.106559067964554, 0.106684073805809, 0.106809109449387, 0.106934189796448, 0.10705928504467, 0.107184432446957, 0.107309617102146, 0.107434831559658, 0.107560120522976, 0.107685416936874, 0.107810758054256, 0.107936151325703, 0.108061566948891, 0.108187027275562, 0.108312532305717, 0.108438059687614, 0.108563654124737, 0.108689293265343, 0.108814962208271, 0.108940608799458, 0.109066374599934, 0.109192155301571, 0.109317943453789, 0.109443813562393, 0.109569683670998, 0.109695598483086, 0.109821580350399, 0.109947554767132, 0.110073603689671, 0.110199712216854, 0.110325813293457, 0.110451959073544, 0.110578171908855, 0.110704392194748, 0.110830664634705, 0.110957019031048, 0.111083351075649, 0.111209727823734, 0.111336179077625, 0.111462607979774, 0.111589126288891, 0.111715696752071, 0.111842274665833, 0.111968889832497, 0.112095557153225, 0.112222261726856, 0.112349025905132, 0.112475760281086, 0.112602613866329, 0.112729445099831, 0.112856388092041, 0.112983293831348, 0.113110266625881, 0.113237291574478, 0.113364338874817, 0.113491453230381, 0.113618545234203, 0.113745719194412, 0.113872952759266, 0.114000178873539, 0.114127442240715, 0.114254787564278, 0.11438213288784, 0.114509508013725, 0.114636979997158, 0.114764459431171, 0.114891961216927, 0.115019544959068, 0.115147121250629, 0.115274712443352, 0.115402437746525, 0.115530095994473, 0.115657836198807, 0.115785673260689, 0.115913487970829, 0.116041325032711, 0.116169266402721, 0.11629718542099, 0.116425193846226, 0.116553239524364, 0.116681277751923, 0.116809360682964, 0.116937510669231, 0.11706567555666, 0.117193892598152, 0.117322146892548, 0.117450438439846, 0.117578744888306, 0.117707155644894, 0.117835536599159, 0.117963969707489, 0.118092462420464, 0.118220999836922, 0.11834953725338, 0.118478156626225, 0.118606798350811, 0.118735440075397, 0.118864215910435, 0.11899296194315, 0.119121715426445, 0.119250580668449, 0.119379460811615, 0.1195083335042, 0.119637310504913, 0.119766280055046, 0.119895301759243, 0.120024397969246, 0.120153494179249, 0.120282627642155, 0.120411843061447, 0.120541080832481, 0.120670318603516, 0.120799645781517, 0.120928965508938, 0.121058322489262, 0.121187768876553, 0.121317215263844, 0.121446684002876, 0.121576249599457, 0.121705800294876, 0.12183541059494, 0.121965065598488, 0.122094742953777, 0.122224479913712, 0.122354246675968, 0.122484058141708, 0.122613854706287, 0.122743763029575, 0.122873693704605, 0.123003616929054, 0.123133659362793, 0.123263671994209, 0.12339374423027, 0.123523861169815, 0.123654007911682, 0.123784206807613, 0.123914442956448, 0.124044708907604, 0.124175034463406, 0.124305360019207, 0.124435767531395, 0.124566175043583, 0.124696657061577, 0.124827139079571, 0.124957725405693, 0.125088304281235, 0.125218883156776, 0.125349551439285, 0.125480219721794, 0.125610962510109, 0.12574177980423, 0.125872552394867, 0.12600339949131, 0.126134321093559, 0.126265227794647, 0.126396179199219, 0.126527205109596, 0.126658245921135, 0.126789301633835, 0.126920431852341, 0.12705160677433, 0.127182796597481, 0.127314046025276, 0.127445325255394, 0.127576604485512, 0.127708002924919, 0.127839371562004, 0.127970784902573, 0.128102287650108, 0.128233790397644, 0.128365308046341, 0.128496915102005, 0.128628581762314, 0.128760233521461, 0.128891974687576, 0.129023686051369, 0.129155457019806, 0.129287287592888, 0.129419147968292, 0.129551038146019, 0.129682987928391, 0.129814952611923, 0.129946947097778, 0.130079030990601, 0.1302110850811, 0.130343228578568, 0.130475401878357, 0.130607590079308, 0.130739867687225, 0.130872160196304, 0.131004452705383, 0.131136804819107, 0.131269231438637, 0.131401658058167, 0.131534144282341, 0.131666660308838, 0.131799206137657, 0.131931811571121, 0.132064446806908, 0.132197126746178, 0.132329821586609, 0.132462576031685, 0.132595345377922, 0.132728204131126, 0.132861092686653, 0.132993996143341, 0.13312691450119, 0.133259937167168, 0.133392944931984, 0.133525982499123, 0.133659109473228, 0.133792236447334, 0.133925437927246, 0.134058639407158, 0.134191870689392, 0.134325206279755, 0.134458512067795, 0.134591862559319, 0.134725302457809, 0.1348587423563, 0.134992212057114, 0.135125756263733, 0.135259315371513, 0.135392904281616, 0.135526582598686, 0.135660231113434, 0.135793939232826, 0.135927721858025, 0.136061504483223, 0.136195346713066, 0.136329218745232, 0.136463135480881, 0.136597082018852, 0.136731088161469, 0.136865094304085, 0.136999204754829, 0.137133330106735, 0.137267470359802, 0.137401640415192, 0.137535855174065, 0.137670129537582, 0.137804418802261, 0.137938752770424, 0.138073146343231, 0.138207569718361, 0.138342022895813, 0.138476505875587, 0.138611018657684, 0.13874563574791, 0.138880237936974, 0.139014855027199, 0.139149561524391, 0.139284297823906, 0.139419034123421, 0.139553874731064, 0.139688700437546, 0.139823585748672, 0.139958515763283, 0.140093445777893, 0.140228465199471, 0.14036351442337, 0.14049856364727, 0.140633672475815, 0.140768855810165, 0.140904054045677, 0.141039296984673, 0.141174554824829, 0.14130987226963, 0.141445234417915, 0.141580626368523, 0.14171601831913, 0.141851514577866, 0.141987025737762, 0.14212255179882, 0.142258122563362, 0.142393752932549, 0.142529413104057, 0.142665088176727, 0.142800837755203, 0.14293660223484, 0.143072426319122, 0.143208295106888, 0.143344163894653, 0.143480077385902, 0.143616080284119, 0.143752083182335, 0.143888100981712, 0.144024223089218, 0.144160330295563, 0.144296497106552, 0.144432708621025, 0.144568920135498, 0.144705235958099, 0.144841551780701, 0.144977867603302, 0.145114287734032, 0.145250722765923, 0.145387187600136, 0.145523712038994, 0.145660281181335, 0.145796865224838, 0.145933508872986, 0.146070137619972, 0.146206870675087, 0.146343618631363, 0.146480366587639, 0.14661717414856, 0.146754086017609, 0.146890953183174, 0.147027894854546, 0.147164896130562, 0.147301897406578, 0.147438943386078, 0.147576048970222, 0.147713184356689, 0.147850319743156, 0.147987574338913, 0.148124814033508, 0.148262068629265, 0.148399412631989, 0.148536786437035, 0.148674175143242, 0.148811623454094, 0.14894911646843, 0.149086609482765, 0.149224191904068, 0.149361774325371, 0.149499416351318, 0.14963710308075, 0.149774834513664, 0.149912565946579, 0.150050386786461, 0.150188207626343, 0.150326058268547, 0.150463983416557, 0.150601908564568, 0.150739893317223, 0.150877937674522, 0.151015967130661, 0.151154100894928, 0.151292249560356, 0.151430398225784, 0.151568606495857, 0.151706904172897, 0.151845172047615, 0.151983484625816, 0.152121871709824, 0.152260303497314, 0.152398750185966, 0.152537226676941, 0.15267576277256, 0.152814298868179, 0.152952924370766, 0.153091579675674, 0.153230234980583, 0.153368979692459, 0.153507739305496, 0.153646513819695, 0.153785362839699, 0.153924256563187, 0.154063194990158, 0.154202163219452, 0.154341161251068, 0.154480144381523, 0.154619246721268, 0.154758363962173, 0.154897481203079, 0.155036687850952, 0.155175894498825, 0.155315190553665, 0.155454486608505, 0.155593797564507, 0.155733227729797, 0.155872628092766, 0.156012058258057, 0.156151577830315, 0.156291097402573, 0.156430676579475, 0.156570315361023, 0.156709939241409, 0.15684962272644, 0.156989380717278, 0.157129123806953, 0.157268941402435, 0.157408818602562, 0.157548680901527, 0.157688602805138, 0.157828569412231, 0.157968565821648, 0.158108592033386, 0.15824867784977, 0.158388778567314, 0.158528983592987, 0.15866918861866, 0.158809408545494, 0.158949688076973, 0.159090012311935, 0.159230351448059, 0.159370735287666, 0.159511163830757, 0.15965162217617, 0.159792110323906, 0.159932672977448, 0.16007325053215, 0.160213857889175, 0.160354539752007, 0.160495236515999, 0.160635948181152, 0.160776764154434, 0.160917580127716, 0.161058411002159, 0.161199316382408, 0.161340236663818, 0.161481201648712, 0.161622241139412, 0.161763250827789, 0.161904349923134, 0.162045493721962, 0.162186622619629, 0.162327840924263, 0.162469103932381, 0.162610337138176, 0.162751704454422, 0.162893086671829, 0.163034468889236, 0.163175910711288, 0.163317382335663, 0.163458868861198, 0.16360042989254, 0.163742050528526, 0.163883671164513, 0.164025336503983, 0.164167061448097, 0.164308786392212, 0.164450541138649, 0.164592400193214, 0.16473425924778, 0.164876133203506, 0.1650180965662, 0.165160074830055, 0.165302097797394, 0.165444165468216, 0.165586248040199, 0.165728360414505, 0.165870562195778, 0.166012734174728, 0.166155025362968, 0.166297316551208, 0.166439607739449, 0.166582003235817, 0.166724413633347, 0.166866824030876, 0.167009323835373, 0.167151838541031, 0.167294427752495, 0.167437061667442, 0.167579665780067, 0.167722329497337, 0.167865082621574, 0.16800782084465, 0.16815060377121, 0.168293461203575, 0.168436318635941, 0.16857922077179, 0.168722197413445, 0.168865144252777, 0.169008165597916, 0.169151246547699, 0.169294342398643, 0.169437482953072, 0.169580683112144, 0.169723868370056, 0.169867128133774, 0.170010432600975, 0.170153766870499, 0.170297130942345, 0.170440554618835, 0.17058402299881, 0.170727506279945, 0.170871034264565, 0.171014592051506, 0.171158209443092, 0.171301871538162, 0.171445548534393, 0.171589255332947, 0.171733036637306, 0.171876862645149, 0.172020673751831, 0.172164589166641, 0.172308519482613, 0.172452419996262, 0.172596454620361, 0.172740459442139, 0.172884538769722, 0.17302867770195, 0.173172786831856, 0.173316985368729, 0.173461243510246, 0.173605486750603, 0.173749789595604, 0.173894137144089, 0.174038529396057, 0.174182936549187, 0.174327418208122, 0.174471914768219, 0.174616411328316, 0.174761012196541, 0.174905627965927, 0.175050258636475, 0.175194978713989, 0.175339698791504, 0.175484478473663, 0.175629287958145, 0.175774127244949, 0.175918996334076, 0.17606395483017, 0.176208928227425, 0.176353916525841, 0.176499009132385, 0.176644071936607, 0.176789164543152, 0.176934346556664, 0.177079558372498, 0.177224785089493, 0.177370056509972, 0.177515342831612, 0.177660718560219, 0.177806109189987, 0.177951514720917, 0.178097009658813, 0.178242534399033, 0.178388059139252, 0.178533658385277, 0.178679272532463, 0.178824916481972, 0.178970664739609, 0.179116353392601, 0.17926213145256, 0.179407969117165, 0.179553806781769, 0.179699704051018, 0.179845660924911, 0.179991617798805, 0.180137619376183, 0.180283695459366, 0.180429756641388, 0.180575892329216, 0.180722087621689, 0.180868297815323, 0.181014537811279, 0.181160822510719, 0.181307137012482, 0.181453496217728, 0.181599915027618, 0.18174634873867, 0.181892812252045, 0.182039320468903, 0.182185873389244, 0.182332471013069, 0.182479128241539, 0.182625785470009, 0.18277245759964, 0.18291924893856, 0.18306602537632, 0.183212831616402, 0.183359727263451, 0.183506637811661, 0.18365353345871, 0.183800548315048, 0.183947563171387, 0.184094592928886, 0.184241726994514, 0.184388816356659, 0.184536010026932, 0.184683248400688, 0.184830471873283, 0.184977769851685, 0.185125127434731, 0.185272455215454, 0.185419902205467, 0.185567364096642, 0.185714840888977, 0.185862362384796, 0.186009913682938, 0.186157524585724, 0.186305165290833, 0.186452835798264, 0.186600551009178, 0.186748310923576, 0.186896115541458, 0.187043949961662, 0.187191784381866, 0.187339723110199, 0.187487676739693, 0.187635630369186, 0.18778370320797, 0.187931761145592, 0.188079833984375, 0.188227996230125, 0.188376203179359, 0.188524380326271, 0.188672676682472, 0.188820958137512, 0.188969328999519, 0.189117684960365, 0.189266085624695, 0.189414575695992, 0.189563065767288, 0.189711555838585, 0.189860165119171, 0.190008759498596, 0.190157428383827, 0.190306127071381, 0.190454840660095, 0.190603584051132, 0.190752416849136, 0.190901249647141, 0.191050112247467, 0.191199064254761, 0.191348031163216, 0.191496983170509, 0.191646069288254, 0.191795110702515, 0.191944226622581, 0.192093402147293, 0.192242592573166, 0.192391782999039, 0.19254107773304, 0.192690387368202, 0.192839726805687, 0.192989110946655, 0.193138524889946, 0.19328798353672, 0.193437501788139, 0.19358703494072, 0.1937365680933, 0.193886235356331, 0.194035902619362, 0.194185569882393, 0.194335326552391, 0.194485083222389, 0.194634899497032, 0.194784760475159, 0.194934666156769, 0.195084571838379, 0.195234566926956, 0.195384562015533, 0.195534601807594, 0.1956847012043, 0.195834800601006, 0.195984944701195, 0.196135193109512, 0.196285396814346, 0.196435660123825, 0.196586027741432, 0.196736350655556, 0.196886733174324, 0.197037175297737, 0.197187632322311, 0.197338134050369, 0.197488695383072, 0.197639301419258, 0.197789907455444, 0.197940587997437, 0.19809128344059, 0.198242023587227, 0.198392808437347, 0.19854362308979, 0.198694452643394, 0.198845386505127, 0.198996320366859, 0.199147254228592, 0.199298307299614, 0.199449360370636, 0.199600458145142, 0.199751615524292, 0.199902772903442, 0.200053960084915, 0.200205236673355, 0.200356468558311, 0.20050784945488, 0.200659185647964, 0.200810581445694, 0.200962066650391, 0.201113522052765, 0.201265007257462, 0.201416596770287, 0.201568186283112, 0.201719790697098, 0.201871499419212, 0.202023178339005, 0.202174931764603, 0.202326744794846, 0.202478557825089, 0.202630430459976, 0.202782347798347, 0.202934250235558, 0.203086242079735, 0.203238293528557, 0.203390344977379, 0.203542441129684, 0.203694581985474, 0.203846752643585, 0.203998953104019, 0.204151213169098, 0.204303547739983, 0.204455867409706, 0.204608246684074, 0.204760655760765, 0.204913094639778, 0.205065593123436, 0.205218106508255, 0.205370649695396, 0.205523282289505, 0.205675914883614, 0.205828577280045, 0.205981329083443, 0.206134080886841, 0.2062868475914, 0.206439718604088, 0.206592589616776, 0.206745475530624, 0.206898480653763, 0.207051426172256, 0.207204446196556, 0.207357540726662, 0.207510635256767, 0.207663774490356, 0.207816988229752, 0.207970172166824, 0.208123445510864, 0.208276778459549, 0.208430081605911, 0.20858345925808, 0.208736881613731, 0.208890333771706, 0.209043860435486, 0.209197402000427, 0.209350973367691, 0.209504574537277, 0.209658235311508, 0.209811940789223, 0.209965661168098, 0.210119426250458, 0.210273221135139, 0.210427060723305, 0.210580945014954, 0.210734874010086, 0.21088881790638, 0.211042821407318, 0.211196854710579, 0.211350932717323, 0.211505055427551, 0.211659222841263, 0.211813375353813, 0.211967632174492, 0.212121888995171, 0.212276235222816, 0.21243055164814, 0.212584927678108, 0.212739393115044, 0.212893843650818, 0.213048323988914, 0.213202893733978, 0.213357493281364, 0.213512077927589, 0.213666766881943, 0.213821455836296, 0.213976189494133, 0.214130997657776, 0.214285790920258, 0.214440643787384, 0.214595556259155, 0.214750453829765, 0.21490541100502, 0.215060457587242, 0.215215474367142, 0.215370565652847, 0.215525686740875, 0.215680837631226, 0.215836048126221, 0.215991303324699, 0.2161465883255, 0.216301888227463, 0.216457262635231, 0.216612637042999, 0.216768056154251, 0.216923534870148, 0.217079058289528, 0.217234581708908, 0.217390209436417, 0.217545822262764, 0.217701464891434, 0.217857196927071, 0.218012943863869, 0.218168690800667, 0.218324542045593, 0.218480408191681, 0.218636304140091, 0.218792289495468, 0.218948215246201, 0.219104260206223, 0.219260349869728, 0.219416409730911, 0.219572514295578, 0.219728738069534, 0.219884902238846, 0.220041170716286, 0.220197468996048, 0.220353752374649, 0.220510125160217, 0.22066655755043, 0.220822975039482, 0.220979452133179, 0.221135973930359, 0.2212925106287, 0.221449136734009, 0.221605777740479, 0.221762433648109, 0.221919134259224, 0.222080945968628, 0.222247868776321, 0.22241473197937, 0.222581580281258, 0.2227483689785, 0.22291511297226, 0.223081842064857, 0.223248526453972, 0.22341513633728, 0.223581776022911, 0.223748311400414, 0.223914816975594, 0.224081292748451, 0.224247723817825, 0.224414125084877, 0.224580466747284, 0.22474679350853, 0.224913060665131, 0.22507931292057, 0.225245475769043, 0.225411668419838, 0.225577756762505, 0.225743800401688, 0.225909858942032, 0.226075828075409, 0.226241782307625, 0.22640772163868, 0.226573556661606, 0.226739376783371, 0.226905196905136, 0.227070912718773, 0.227236613631248, 0.227402314543724, 0.227567911148071, 0.22773352265358, 0.227899059653282, 0.228064551949501, 0.228230029344559, 0.228395462036133, 0.228560835123062, 0.228726163506508, 0.228891476988792, 0.229056745767593, 0.229221984744072, 0.229387164115906, 0.229552298784256, 0.229717373847961, 0.229882448911667, 0.230047479271889, 0.230212405323982, 0.230377376079559, 0.230542302131653, 0.230707123875618, 0.230871975421906, 0.231036767363548, 0.231201454997063, 0.231366202235222, 0.23153081536293, 0.231695428490639, 0.231860041618347, 0.232024550437927, 0.232189059257507, 0.232353523373604, 0.232517927885056, 0.232682272791862, 0.232846632599831, 0.233010932803154, 0.233175158500671, 0.233339384198189, 0.233503580093384, 0.23366767168045, 0.233831763267517, 0.2339958101511, 0.234159857034683, 0.234323814511299, 0.234487757086754, 0.234651625156403, 0.234815508127213, 0.234979286789894, 0.235143080353737, 0.235306814312935, 0.235470488667488, 0.235634118318558, 0.235797747969627, 0.235961303114891, 0.23612479865551, 0.236288323998451, 0.236451759934425, 0.236615166068077, 0.236778527498245, 0.23694184422493, 0.237105116248131, 0.237268403172493, 0.237431570887566, 0.237594753503799, 0.237757861614227, 0.237920925021172, 0.238084033131599, 0.238246992230415, 0.23840993642807, 0.238572895526886, 0.238735750317574, 0.238898605108261, 0.239061400294304, 0.239224150776863, 0.239386841654778, 0.239549592137337, 0.239712178707123, 0.239874765276909, 0.240037366747856, 0.240199849009514, 0.240362346172333, 0.240524768829346, 0.240687161684036, 0.240849524736404, 0.24101185798645, 0.241174101829529, 0.241336330771446, 0.241498559713364, 0.241660684347153, 0.241822808980942, 0.241984888911247, 0.242146909236908, 0.242308899760246, 0.242470845580101, 0.242632761597633, 0.242794632911682, 0.242956504225731, 0.24311825633049, 0.243279993534088, 0.243441730737686, 0.243603393435478, 0.243764996528625, 0.243926614522934, 0.244088158011436, 0.244249612092972, 0.244411140680313, 0.244572550058365, 0.244733914732933, 0.24489526450634, 0.245056584477425, 0.245217829942703, 0.245379075407982, 0.245540246367455, 0.245701387524605, 0.245862498879433, 0.246023565530777, 0.246184602379799, 0.246345579624176, 0.24650651216507, 0.24666740000248, 0.246828272938728, 0.246989101171494, 0.247149854898453, 0.247310608625412, 0.247471302747726, 0.247631952166557, 0.247792586684227, 0.247953176498413, 0.248113691806793, 0.248274207115173, 0.248434647917747, 0.24859507381916, 0.248755484819412, 0.248915791511536, 0.249076083302498, 0.249236360192299, 0.249396547675133, 0.249556735157967, 0.249716877937317, 0.249876961112022, 0.250037014484406, 0.250197052955627, 0.250357002019882, 0.250516951084137, 0.250676840543747, 0.250836670398712, 0.250996470451355, 0.251156270503998, 0.251315981149673, 0.251475691795349, 0.25163534283638, 0.251794904470444, 0.25195449590683, 0.252114027738571, 0.25227352976799, 0.252432942390442, 0.252592384815216, 0.252751737833023, 0.25291109085083, 0.25307035446167, 0.25322961807251, 0.253388792276382, 0.253547966480255, 0.253707081079483, 0.253866195678711, 0.254025220870972, 0.254184246063232, 0.254343152046204, 0.25450211763382, 0.254660993814468, 0.254819840192795, 0.254978656768799, 0.255137413740158, 0.255296111106873, 0.255454808473587, 0.255613446235657, 0.255772054195404, 0.255930602550507, 0.256089121103287, 0.256247609853745, 0.256406009197235, 0.256564438343048, 0.256722778081894, 0.256881147623062, 0.257039368152618, 0.257197618484497, 0.257355809211731, 0.257513970136642, 0.257672071456909, 0.257830142974854, 0.257988184690475, 0.258146196603775, 0.25830414891243, 0.258462071418762, 0.25861993432045, 0.258777767419815, 0.258935540914536, 0.259093314409256, 0.259251028299332, 0.259408682584763, 0.259566336870193, 0.25972393155098, 0.259881496429443, 0.260039001703262, 0.260196447372437, 0.260353863239288, 0.260511249303818, 0.260668575763702, 0.260825902223587, 0.260983198881149, 0.261140406131744, 0.261297583580017, 0.261454731225967, 0.261611849069595, 0.261768907308578, 0.261925935745239, 0.262082934379578, 0.262239873409271, 0.26239675283432, 0.262553632259369, 0.262710452079773, 0.262867212295532, 0.263023972511292, 0.263180673122406, 0.263337343931198, 0.263493955135345, 0.26365053653717, 0.263807088136673, 0.263963580131531, 0.264120012521744, 0.264276474714279, 0.264432817697525, 0.264589190483093, 0.264745473861694, 0.264901727437973, 0.265057951211929, 0.265214115381241, 0.265370279550552, 0.265526354312897, 0.265682429075241, 0.265838414430618, 0.265994399785995, 0.266150325536728, 0.26630625128746, 0.266462087631226, 0.266617923974991, 0.266773670911789, 0.266929388046265, 0.26708510518074, 0.267240762710571, 0.267396360635757, 0.267551928758621, 0.267707467079163, 0.267862945795059, 0.268018394708633, 0.268173813819885, 0.268329173326492, 0.268484503030777, 0.268639802932739, 0.268795043230057, 0.268950253725052, 0.269105434417725, 0.269260555505753, 0.269415616989136, 0.269570708274841, 0.269725680351257, 0.269880652427673, 0.270035564899445, 0.270190447568893, 0.27034530043602, 0.270500123500824, 0.270654857158661, 0.270809590816498, 0.27096426486969, 0.271118938922882, 0.271273523569107, 0.27142807841301, 0.27158260345459, 0.271737098693848, 0.271891504526138, 0.272045910358429, 0.272200286388397, 0.272354602813721, 0.272508889436722, 0.272663116455078, 0.272817313671112, 0.272971510887146, 0.27312558889389, 0.273279666900635, 0.273433715105057, 0.273587703704834, 0.273741632699966, 0.273895591497421, 0.274049460887909, 0.274203300476074, 0.274357080459595, 0.274510830640793, 0.274664521217346, 0.2748182117939, 0.274971842765808, 0.275125473737717, 0.275279015302658, 0.275432497262955, 0.275585979223251, 0.275739431381226, 0.275892823934555, 0.276046127080917, 0.276199489831924, 0.276352763175964, 0.276505976915359, 0.276659160852432, 0.27681228518486, 0.276965409517288, 0.277118504047394, 0.277271509170532, 0.277424514293671, 0.277577459812164, 0.277730345726013, 0.27788320183754, 0.278036057949066, 0.278188854455948, 0.278341561555862, 0.278494268655777, 0.278646916151047, 0.278799563646317, 0.278952151536942, 0.279104679822922, 0.27925717830658, 0.279409617185593, 0.279562085866928, 0.279714435338974, 0.27986678481102, 0.280019104480743, 0.280171364545822, 0.280323565006256, 0.28047576546669, 0.280627876520157, 0.280779987573624, 0.280932039022446, 0.281084030866623, 0.281236052513123, 0.281387954950333, 0.281539857387543, 0.28169173002243, 0.281843543052673, 0.281995326280594, 0.28214704990387, 0.282298743724823, 0.282450377941132, 0.28260201215744, 0.282753586769104, 0.282905131578445, 0.28305658698082, 0.283208072185516, 0.283359467983246, 0.283510833978653, 0.283662170171738, 0.2838134765625, 0.283964723348618, 0.284115940332413, 0.284267097711563, 0.284418195486069, 0.284569323062897, 0.284720361232758, 0.284871369600296, 0.285022348165512, 0.285173267126083, 0.285324156284332, 0.285474985837936, 0.285625815391541, 0.285776555538177, 0.285927295684814, 0.286077976226807, 0.286228597164154, 0.286379218101501, 0.286529779434204, 0.286680310964584, 0.286830812692642, 0.286981225013733, 0.287131607532501, 0.287282019853592, 0.287432312965393, 0.287582635879517, 0.287732839584351, 0.287883043289185, 0.288033187389374, 0.288183331489563, 0.288333415985107, 0.288483470678329, 0.288633435964584, 0.288783371448517, 0.288933306932449, 0.289083212614059, 0.289233058691025, 0.289382785558701, 0.289532572031021, 0.289682328701019, 0.28983199596405, 0.289981603622437, 0.290131211280823, 0.290280759334564, 0.290430277585983, 0.29057976603508, 0.290729194879532, 0.290878564119339, 0.291027933359146, 0.291177272796631, 0.291326522827148, 0.291475743055344, 0.291624963283539, 0.291774094104767, 0.291923195123672, 0.292072266340256, 0.292221277952194, 0.29237025976181, 0.292519241571426, 0.292668104171753, 0.292817026376724, 0.292965829372406, 0.293114632368088, 0.293263375759125, 0.293412089347839, 0.293560743331909, 0.293709367513657, 0.293857961893082, 0.294006496667862, 0.29415500164032, 0.294303476810455, 0.294451892375946, 0.294600307941437, 0.294748604297638, 0.294896930456161, 0.295045167207718, 0.295193403959274, 0.295341581106186, 0.295489728450775, 0.295637845993042, 0.295785903930664, 0.295933902263641, 0.296081870794296, 0.296229839324951, 0.296377718448639, 0.296525597572327, 0.29667341709137, 0.296821177005768, 0.296968877315521, 0.297116637229919, 0.297264277935028, 0.297411888837814, 0.297559440135956, 0.297706991434097, 0.297854483127594, 0.298001945018768, 0.298149317502975, 0.298296719789505, 0.29844406247139, 0.29859134554863, 0.298738598823547, 0.298885822296143, 0.299032986164093, 0.299180120229721, 0.299327224493027, 0.299474269151688, 0.299621254205704, 0.29976823925972, 0.299915134906769, 0.30006206035614, 0.300208896398544, 0.300355702638626, 0.300502479076385, 0.300649225711823, 0.300795882940292, 0.300942569971085, 0.30108916759491, 0.30123570561409, 0.30138224363327, 0.301528722047806, 0.301675200462341, 0.301821559667587, 0.301967918872833, 0.302114307880402, 0.302260547876358, 0.302406787872314, 0.302553027868271, 0.302699148654938, 0.302845269441605, 0.302991360425949, 0.303137362003326, 0.303283393383026, 0.303429394960403, 0.303575277328491, 0.303721159696579, 0.303867012262344, 0.304012835025787, 0.304158568382263, 0.304304271936417, 0.304449945688248, 0.304595589637756, 0.30474117398262, 0.304886758327484, 0.305032283067703, 0.305177748203278, 0.305323153734207, 0.305468589067459, 0.305613934993744, 0.305759221315384, 0.305904507637024, 0.306049764156342, 0.306194961071014, 0.30634006857872, 0.306485205888748, 0.306630283594131, 0.306775331497192, 0.306920319795609, 0.307065278291702, 0.307210147380829, 0.307355016469955, 0.307499885559082, 0.307644635438919, 0.307789415121078, 0.307934105396271, 0.308078765869141, 0.308223366737366, 0.308367997407913, 0.308512538671494, 0.308657050132751, 0.308801531791687, 0.308945953845978, 0.309090346097946, 0.30923467874527, 0.309378981590271, 0.30952325463295, 0.309667438268661, 0.309811651706696, 0.309955775737762, 0.310099899768829, 0.310243964195251, 0.310387969017029, 0.310531973838806, 0.310675889253616, 0.310819804668427, 0.310963660478592, 0.311107486486435, 0.311251282691956, 0.311394989490509, 0.311538696289062, 0.311682343482971, 0.31182599067688, 0.311969548463821, 0.312113076448441, 0.31225660443306, 0.312400043010712, 0.312543451786041, 0.312686860561371, 0.312830150127411, 0.312973469495773, 0.313116729259491, 0.313259929418564, 0.313403099775314, 0.313546240329742, 0.313689351081848, 0.313832402229309, 0.313975393772125, 0.314118415117264, 0.31426128745079, 0.314404189586639, 0.314547061920166, 0.314689844846725, 0.314832627773285, 0.314975380897522, 0.315118044614792, 0.315260708332062, 0.315403312444687, 0.315545856952667, 0.315688401460648, 0.315830916166306, 0.315973371267319, 0.316115766763687, 0.316258132457733, 0.316400438547134, 0.316542714834213, 0.316684991121292, 0.316827178001404, 0.316969335079193, 0.31711146235466, 0.317253559827805, 0.317395597696304, 0.317537605762482, 0.317679554224014, 0.317821472883224, 0.317963391542435, 0.318105220794678, 0.318246990442276, 0.318388789892197, 0.318530470132828, 0.318672180175781, 0.318813800811768, 0.318955421447754, 0.319096982479095, 0.319238483905792, 0.319379955530167, 0.319521367549896, 0.319662809371948, 0.319804131984711, 0.319945484399796, 0.320086717605591, 0.320227980613708, 0.320369184017181, 0.32051032781601, 0.320651441812515, 0.320792526006699, 0.320933520793915, 0.321074545383453, 0.321215510368347, 0.321356415748596, 0.321497291326523, 0.321638107299805, 0.321778923273087, 0.321919709444046, 0.322060376405716, 0.322201043367386, 0.322341680526733, 0.322482258081436, 0.322622835636139, 0.322763323783875, 0.32290381193161, 0.323044210672379, 0.323184609413147, 0.323324948549271, 0.323465287685394, 0.323605507612228, 0.323745787143707, 0.323885947465897, 0.324026077985764, 0.324166178703308, 0.324306219816208, 0.32444629073143, 0.324586272239685, 0.324726223945618, 0.324866086244583, 0.325005978345871, 0.325145781040192, 0.325285583734512, 0.325425326824188, 0.325565040111542, 0.325704663991928, 0.325844317674637, 0.325983881950378, 0.326123416423798, 0.326262921094894, 0.326402366161346, 0.326541781425476, 0.326681137084961, 0.326820522546768, 0.326959788799286, 0.327099084854126, 0.327238261699677, 0.327377468347549, 0.327516585588455, 0.327655702829361, 0.327794760465622, 0.327933788299561, 0.328072726726532, 0.328211665153503, 0.32835054397583, 0.328489392995834, 0.328628242015839, 0.328767001628876, 0.328905761241913, 0.329044461250305, 0.32918307185173, 0.329321682453156, 0.329460263252258, 0.329598784446716, 0.329737275838852, 0.329875737428665, 0.330014139413834, 0.33015251159668, 0.330290824174881, 0.330429136753082, 0.330567389726639, 0.330705553293228, 0.33084374666214, 0.330981880426407, 0.331119984388351, 0.331258028745651, 0.331396013498306, 0.331533968448639, 0.331671893596649, 0.331809818744659, 0.33194762468338, 0.332085430622101, 0.332223206758499, 0.332360923290253, 0.332498580217361, 0.33263623714447, 0.332773864269257, 0.332911401987076, 0.333048939704895, 0.333186388015747, 0.333323836326599, 0.333461225032806, 0.333598613739014, 0.333735913038254, 0.333873212337494, 0.334010422229767, 0.33414763212204, 0.33428481221199, 0.334421902894974, 0.334558963775635, 0.334696024656296, 0.334833025932312, 0.334969967603683, 0.335106879472733, 0.335243761539459, 0.335380584001541, 0.335517376661301, 0.335654139518738, 0.33579084277153, 0.335927516222, 0.336064159870148, 0.336200773715973, 0.336337327957153, 0.336473852396011, 0.336610287427902, 0.336746692657471, 0.336883127689362, 0.337019473314285, 0.337155789136887, 0.337292045354843, 0.337428271770477, 0.337564438581467, 0.337700605392456, 0.337836682796478, 0.337972790002823, 0.3381088078022, 0.338244765996933, 0.338380753993988, 0.338516652584076, 0.338652491569519, 0.338788360357285, 0.338924080133438, 0.339059829711914, 0.33919557929039, 0.339331209659576, 0.339466840028763, 0.339602410793304, 0.339737981557846, 0.339873462915421, 0.340008914470673, 0.340144336223602, 0.340279757976532, 0.34041503071785, 0.340550363063812, 0.34068563580513, 0.340820848941803, 0.340956062078476, 0.341091156005859, 0.341226279735565, 0.341361343860626, 0.34149631857872, 0.341631293296814, 0.341766268014908, 0.341901183128357, 0.342035979032516, 0.342170834541321, 0.342305600643158, 0.34244030714035, 0.342575013637543, 0.342709690332413, 0.342844277620316, 0.342978894710541, 0.343113422393799, 0.343247890472412, 0.343382328748703, 0.343516767024994, 0.343651115894318, 0.343785434961319, 0.34391975402832, 0.344053983688354, 0.344188183546066, 0.344322383403778, 0.344456523656845, 0.344590604305267, 0.344724625349045, 0.344858646392822, 0.344992607831955, 0.345126539468765, 0.345260441303253, 0.345394283533096, 0.345528066158295, 0.345661818981171, 0.345795542001724, 0.345929235219955, 0.346062898635864, 0.346196502447128, 0.34633007645607, 0.346463590860367, 0.346597045660019, 0.346730530261993, 0.346863895654678, 0.346997290849686, 0.347130596637726, 0.347263902425766, 0.347397118806839, 0.34753030538559, 0.34766349196434, 0.347796618938446, 0.347929686307907, 0.348062723875046, 0.34819570183754, 0.348328649997711, 0.348461598157883, 0.348594456911087, 0.348727285861969, 0.348860085010529, 0.348992854356766, 0.349125593900681, 0.349258244037628, 0.349390894174576, 0.349523484706879, 0.349656015634537, 0.349788516759872, 0.349921047687531, 0.350053459405899, 0.350185841321945, 0.350318223237991, 0.350450485944748, 0.350582748651505, 0.350715011358261, 0.350847184658051, 0.35097935795784, 0.35111141204834, 0.351243525743484, 0.351375550031662, 0.351507544517517, 0.351639479398727, 0.351771414279938, 0.351903259754181, 0.352035105228424, 0.352166891098022, 0.352298587560654, 0.35243034362793, 0.352562010288239, 0.35269358754158, 0.352825194597244, 0.352956742048264, 0.353088229894638, 0.353219717741013, 0.353351145982742, 0.353482514619827, 0.353613883256912, 0.353745132684708, 0.353876411914825, 0.354007661342621, 0.354138821363449, 0.354269951581955, 0.354401081800461, 0.354532122612, 0.354663163423538, 0.35479411482811, 0.354925036430359, 0.355055958032608, 0.355186820030212, 0.355317652225494, 0.355448424816132, 0.355579137802124, 0.355709850788116, 0.355840504169464, 0.355971127748489, 0.35610169172287, 0.356232225894928, 0.356362730264664, 0.356493175029755, 0.356623619794846, 0.356753945350647, 0.356884300708771, 0.35701459646225, 0.357144832611084, 0.357275068759918, 0.357405245304108, 0.357535392045975, 0.357665479183197, 0.357795506715775, 0.35792550444603, 0.358055502176285, 0.35818538069725, 0.358315289020538, 0.358445137739182, 0.35857492685318, 0.358704715967178, 0.358834445476532, 0.358964145183563, 0.359093755483627, 0.359223395586014, 0.359352976083755, 0.35948246717453, 0.359611958265305, 0.359741419553757, 0.359870791435242, 0.360000163316727, 0.360129475593567, 0.360258758068085, 0.36038801074028, 0.360517233610153, 0.360646396875381, 0.360775500535965, 0.360904574394226, 0.361033648252487, 0.361162632703781, 0.361291587352753, 0.361420542001724, 0.361549377441406, 0.361678242683411, 0.361807018518448, 0.361935764551163, 0.362064510583878, 0.362193167209625, 0.362321794033051, 0.362450391054153, 0.362578958272934, 0.36270746588707, 0.362835973501205, 0.362964391708374, 0.36309278011322, 0.363221168518066, 0.363349437713623, 0.363477736711502, 0.363605976104736, 0.363734126091003, 0.363862305879593, 0.363990396261215, 0.36411851644516, 0.364246517419815, 0.36437451839447, 0.364502459764481, 0.364630371332169, 0.364758253097534, 0.364886075258255, 0.365013867616653, 0.365141600370407, 0.365269333124161, 0.36539700627327, 0.365524619817734, 0.365652203559875, 0.365779757499695, 0.365907222032547, 0.366034716367722, 0.366162121295929, 0.366289526224136, 0.366416871547699, 0.366544187068939, 0.366671472787857, 0.366798639297485, 0.366925835609436, 0.367052972316742, 0.367180109024048, 0.367307156324387, 0.367434203624725, 0.367561191320419, 0.367688119411469, 0.367814987897873, 0.3679418861866, 0.368068695068359, 0.368195414543152, 0.368322193622589, 0.368448913097382, 0.368575543165207, 0.368702173233032, 0.368821859359741, 0.368934482336044, 0.36904701590538, 0.369159460067749, 0.369271785020828, 0.369383960962296, 0.369496047496796, 0.369608014822006, 0.369719922542572, 0.369831651449203, 0.369943290948868, 0.370054811239243, 0.370166212320328, 0.370277553796768, 0.370388746261597, 0.370499819517136, 0.370610773563385, 0.370721638202667, 0.370832353830338, 0.370943009853363, 0.371053516864777, 0.371163904666901, 0.371274203062057, 0.371384382247925, 0.371494442224503, 0.371604412794113, 0.371714234352112, 0.371824026107788, 0.371933579444885, 0.37204310297966, 0.372152507305145, 0.372261762619019, 0.372370958328247, 0.372480034828186, 0.372588962316513, 0.372697770595551, 0.372806519269943, 0.372915118932724, 0.373023599386215, 0.373131990432739, 0.373240292072296, 0.373348414897919, 0.373456478118896, 0.37356436252594, 0.373672217130661, 0.373779952526093, 0.373887538909912, 0.37399497628212, 0.374102383852005, 0.374209642410278, 0.374316811561584, 0.374423831701279, 0.374530762434006, 0.374637514352798, 0.374744236469269, 0.37485083937645, 0.374957293272018, 0.375063687562943, 0.375169932842255, 0.375276029109955, 0.37538206577301, 0.375487953424454, 0.375593781471252, 0.375699490308762, 0.375805050134659, 0.375910490751266, 0.376015841960907, 0.37612110376358, 0.376226216554642, 0.376331239938736, 0.376436144113541, 0.376540899276733, 0.376645594835281, 0.376750141382217, 0.376854598522186, 0.376958966255188, 0.377063155174255, 0.377167254686356, 0.377271294593811, 0.377375155687332, 0.377478957176208, 0.377582609653473, 0.37768617272377, 0.377789616584778, 0.377892941236496, 0.377996116876602, 0.378099232912064, 0.378202259540558, 0.37830513715744, 0.378407865762711, 0.378510534763336, 0.378613084554672, 0.378715544939041, 0.378817826509476, 0.378920048475266, 0.379022151231766, 0.379124104976654, 0.379225999116898, 0.379327744245529, 0.379429370164871, 0.379530936479568, 0.379632323980331, 0.37973365187645, 0.379834830760956, 0.379935920238495, 0.380036890506744, 0.380137741565704, 0.380238473415375, 0.380339115858078, 0.380439609289169, 0.380540072917938, 0.38064032793045, 0.380740523338318, 0.380840569734573, 0.380940526723862, 0.381040394306183, 0.381140172481537, 0.381239771842957, 0.381339251995087, 0.38143864274025, 0.381537944078445, 0.381637096405029, 0.381736159324646, 0.381835103034973, 0.381933927536011, 0.382032662630081, 0.382131308317184, 0.382229775190353, 0.382328152656555, 0.382426470518112, 0.382524609565735, 0.38262265920639, 0.382720589637756, 0.382818430662155, 0.382916122674942, 0.383013725280762, 0.383111208677292, 0.383208602666855, 0.383305847644806, 0.383403033018112, 0.383500039577484, 0.383596956729889, 0.383693784475327, 0.383790463209152, 0.383887052536011, 0.383983552455902, 0.384079933166504, 0.384176164865494, 0.384272277355194, 0.38436833024025, 0.384464234113693, 0.384560018777847, 0.384655743837357, 0.384751319885254, 0.384846746921539, 0.38494211435318, 0.385037392377853, 0.385132491588593, 0.385227501392365, 0.385322421789169, 0.385417222976685, 0.38551190495491, 0.385606467723846, 0.385700911283493, 0.38579523563385, 0.38588947057724, 0.38598358631134, 0.386077612638474, 0.386171519756317, 0.386265277862549, 0.386358946561813, 0.386452496051788, 0.386545956134796, 0.386639297008514, 0.386732488870621, 0.386825621128082, 0.386918604373932, 0.387011468410492, 0.387104272842407, 0.387196898460388, 0.387289464473724, 0.387381911277771, 0.387474238872528, 0.387566387653351, 0.387658536434174, 0.387750506401062, 0.387842386960983, 0.387934118509293, 0.388025760650635, 0.388117283582687, 0.388208717107773, 0.388300061225891, 0.388391226530075, 0.388482332229614, 0.388573288917542, 0.388664156198502, 0.388754904270172, 0.388845562934875, 0.388936072587967, 0.389026492834091, 0.389116793870926, 0.389206975698471, 0.389297068119049, 0.389386981725693, 0.389476865530014, 0.389566570520401, 0.389656215906143, 0.389745712280273, 0.389835119247437, 0.38992440700531, 0.390013575553894, 0.390102654695511, 0.390191584825516, 0.390280425548553, 0.390369176864624, 0.390457779169083, 0.390546262264252, 0.390634685754776, 0.390722960233688, 0.390811115503311, 0.390899151563644, 0.39098709821701, 0.391074955463409, 0.391162633895874, 0.391250252723694, 0.391337722539902, 0.391425102949142, 0.391512393951416, 0.391599506139755, 0.391686588525772, 0.391773521900177, 0.391860336065292, 0.391947031021118, 0.392033636569977, 0.392120093107224, 0.392206490039825, 0.392292737960815, 0.392378896474838, 0.392464876174927, 0.392550826072693, 0.392636656761169, 0.392722308635712, 0.392807900905609, 0.392893373966217, 0.392978727817535, 0.393063962459564, 0.393149107694626, 0.393234133720398, 0.39331904053688, 0.393403828144073, 0.393488526344299, 0.393573075532913, 0.39365753531456, 0.393741875886917, 0.393826097249985, 0.393910259008408, 0.393994241952896, 0.394078135490417, 0.394161939620972, 0.394245624542236, 0.394329160451889, 0.394412606954575, 0.394495964050293, 0.394579142332077, 0.394662290811539, 0.394745260477066, 0.394828140735626, 0.394910961389542, 0.394993603229523, 0.395076155662537, 0.395158559083939, 0.395240873098373, 0.395323127508163, 0.395405203104019, 0.39548721909523, 0.395569086074829, 0.395650833845139, 0.395732462406158, 0.395814061164856, 0.395895421504974, 0.395976781845093, 0.396057963371277, 0.396139055490494, 0.396220028400421, 0.396300882101059, 0.39638164639473, 0.396462291479111, 0.396542817354202, 0.396623224020004, 0.396703511476517, 0.396783739328384, 0.396863788366318, 0.396943777799606, 0.397023618221283, 0.397103369235992, 0.39718297123909, 0.397262513637543, 0.397341907024384, 0.397421211004257, 0.397500336170197, 0.397579431533813, 0.397658377885818, 0.397737234830856, 0.397815942764282, 0.397894561290741, 0.397973090410233, 0.398051500320435, 0.398129761219025, 0.398207932710648, 0.398285984992981, 0.398363918066025, 0.398441731929779, 0.398519486188889, 0.398597091436386, 0.398674577474594, 0.398751974105835, 0.398829221725464, 0.398906379938126, 0.398983418941498, 0.399060368537903, 0.399137198925018, 0.399213910102844, 0.399290472269058, 0.399366974830627, 0.399443328380585, 0.399519622325897, 0.399595737457275, 0.399671792984009, 0.39974769949913, 0.399823516607285, 0.399899214506149, 0.399974793195724, 0.400050312280655, 0.400125652551651, 0.400200873613358, 0.400276035070419, 0.400351017713547, 0.400425970554352, 0.400500744581223, 0.400575429201126, 0.400650024414062, 0.400724470615387, 0.400798827409744, 0.400873064994812, 0.40094718337059, 0.401021212339401, 0.4010950922966, 0.401168882846832, 0.401242554187775, 0.40131613612175, 0.401389569044113, 0.401462912559509, 0.401536136865616, 0.401609241962433, 0.401682257652283, 0.401755154132843, 0.401827931404114, 0.401900589466095, 0.401973158121109, 0.402045547962189, 0.402117878198624, 0.402190119028091, 0.402262210845947, 0.402334213256836, 0.402406096458435, 0.402477860450745, 0.402549505233765, 0.402621060609818, 0.402692466974258, 0.402763813734055, 0.402835011482239, 0.402906090021133, 0.402977049350739, 0.403047949075699, 0.403118699789047, 0.403189361095428, 0.40325990319252, 0.403330266475677, 0.403400599956512, 0.403470784425735, 0.403540879487991, 0.403610825538635, 0.403680711984634, 0.403750419616699, 0.403820067644119, 0.403889566659927, 0.403959006071091, 0.40402826666832, 0.404097467660904, 0.404166549444199, 0.404235482215881, 0.404304355382919, 0.404373109340668, 0.404441714286804, 0.404510229825974, 0.404578626155853, 0.404646903276443, 0.404715090990067, 0.404783129692078, 0.404851078987122, 0.404918938875198, 0.404986619949341, 0.405054271221161, 0.405121743679047, 0.405189126729965, 0.405256390571594, 0.405323565006256, 0.405390590429306, 0.405457556247711, 0.405524373054504, 0.40559110045433, 0.405657678842545, 0.405724167823792, 0.405790567398071, 0.405856788158417, 0.405922949314117, 0.405988961458206, 0.40605491399765, 0.406120717525482, 0.406186431646347, 0.406252026557922, 0.406317502260208, 0.406382888555527, 0.406448096036911, 0.406513243913651, 0.4065782725811, 0.406643211841583, 0.406707972288132, 0.406772702932358, 0.406837284564972, 0.406901746988297, 0.406966060400009, 0.407030314207077, 0.407094448804855, 0.407158464193344, 0.407222360372543, 0.407286137342453, 0.407349824905396, 0.407413423061371, 0.407476872205734, 0.407540202140808, 0.407603442668915, 0.407666563987732, 0.407729536294937, 0.407792448997498, 0.407855212688446, 0.407917886972427, 0.407980442047119, 0.408042907714844, 0.408105224370956, 0.408167451620102, 0.408229559659958, 0.408291518688202, 0.408353418111801, 0.408415198326111, 0.408476889133453, 0.408538401126862, 0.408599823713303, 0.408661156892776, 0.408722341060638, 0.408783465623856, 0.408844441175461, 0.408905297517776, 0.408966064453125, 0.409026712179184, 0.409087240695953, 0.409147650003433, 0.409207999706268, 0.409268170595169, 0.409328252077103, 0.409388214349747, 0.409448117017746, 0.409507840871811, 0.409567475318909, 0.409626990556717, 0.40968644618988, 0.409745693206787, 0.409804880619049, 0.409863978624344, 0.409922927618027, 0.409981787204742, 0.410040527582169, 0.410099148750305, 0.41015762090683, 0.41021603345871, 0.410274356603622, 0.410332500934601, 0.410390585660934, 0.410448551177979, 0.410506337881088, 0.410564094781876, 0.410621702671051, 0.410679221153259, 0.410736590623856, 0.410793870687485, 0.410851031541824, 0.410908073186874, 0.41096505522728, 0.411021858453751, 0.411078542470932, 0.411135166883469, 0.411191642284393, 0.411248028278351, 0.411304324865341, 0.41136047244072, 0.411416500806808, 0.411472469568253, 0.411528259515762, 0.411583960056305, 0.41163957118988, 0.411695033311844, 0.41175040602684, 0.411805659532547, 0.411860764026642, 0.411915808916092, 0.411970764398575, 0.412025541067123, 0.412080228328705, 0.412134796380997, 0.412189275026321, 0.412243634462357, 0.412297874689102, 0.412352025508881, 0.41240605711937, 0.412459939718246, 0.412513762712479, 0.412567436695099, 0.41262099146843, 0.412674456834793, 0.412727802991867, 0.412781029939651, 0.412834137678146, 0.412887156009674, 0.41294002532959, 0.412992864847183, 0.413045525550842, 0.413098067045212, 0.413150519132614, 0.413202881813049, 0.41325506567955, 0.413307189941406, 0.413359194993973, 0.41341108083725, 0.413462847471237, 0.413514465093613, 0.413566052913666, 0.413617491722107, 0.413668811321259, 0.413720041513443, 0.413771122694016, 0.413822114467621, 0.413872987031937, 0.413923740386963, 0.413974404335022, 0.414024919271469, 0.414075344800949, 0.41412565112114, 0.414175868034363, 0.414225965738297, 0.414275944232941, 0.414325833320618, 0.41437554359436, 0.414425194263458, 0.414474725723267, 0.414524137973785, 0.414573431015015, 0.414622634649277, 0.414671689271927, 0.41472065448761, 0.414769500494003, 0.41481825709343, 0.414866894483566, 0.414915382862091, 0.414963811635971, 0.415012121200562, 0.41506028175354, 0.415108352899551, 0.415156304836273, 0.415204137563705, 0.415251880884171, 0.415299504995346, 0.41534698009491, 0.415394395589828, 0.415441691875458, 0.415488839149475, 0.415535897016525, 0.415582835674286, 0.415629655122757, 0.415676385164261, 0.415722995996475, 0.415769517421722, 0.415815860033035, 0.415862113237381, 0.41590827703476, 0.415954321622849, 0.416000247001648, 0.416046112775803, 0.416091799736023, 0.416137397289276, 0.416182905435562, 0.416228264570236, 0.416273504495621, 0.416318655014038, 0.416363686323166, 0.416408598423004, 0.416453421115875, 0.416498094797134, 0.416542708873749, 0.416587173938751, 0.416631549596786, 0.41667577624321, 0.416719913482666, 0.416763961315155, 0.416807860136032, 0.416851609945297, 0.416895300149918, 0.416938900947571, 0.41698232293129, 0.417025715112686, 0.417068958282471, 0.417112052440643, 0.417155086994171, 0.417198002338409, 0.417240828275681, 0.417283475399017, 0.417326033115387, 0.417368471622467, 0.41741082072258, 0.417453020811081, 0.417495131492615, 0.417537122964859, 0.417579025030136, 0.417620807886124, 0.417662471532822, 0.41770401597023, 0.417745471000671, 0.417786806821823, 0.417827993631363, 0.417869091033936, 0.417910099029541, 0.417950987815857, 0.417991727590561, 0.418032377958298, 0.418072938919067, 0.418113350868225, 0.418153703212738, 0.418193906545639, 0.41823399066925, 0.418273955583572, 0.418313801288605, 0.41835355758667, 0.418393194675446, 0.418432742357254, 0.418472170829773, 0.418511480093002, 0.418550670146942, 0.418589740991592, 0.418628722429276, 0.418667584657669, 0.418706327676773, 0.418744921684265, 0.418783456087112, 0.418821901082993, 0.418860197067261, 0.418898344039917, 0.418936431407928, 0.418974369764328, 0.41901221871376, 0.419049948453903, 0.419087588787079, 0.419125109910965, 0.419162482023239, 0.419199794530869, 0.419236958026886, 0.419274002313614, 0.419310957193375, 0.419347763061523, 0.419384479522705, 0.41942110657692, 0.419457584619522, 0.419493973255157, 0.419530272483826, 0.419566452503204, 0.419602453708649, 0.419638425111771, 0.419674247503281, 0.419709950685501, 0.419745534658432, 0.419781029224396, 0.41981640458107, 0.419851660728455, 0.41988679766655, 0.419921875, 0.419956773519516, 0.419991612434387, 0.420026272535324, 0.420060902833939, 0.420095354318619, 0.420129746198654, 0.420163989067078, 0.420198082923889, 0.420232146978378, 0.420266032218933, 0.420299857854843, 0.420333534479141, 0.420367151498795, 0.420400589704514, 0.420433938503265, 0.42046719789505, 0.420500308275223, 0.420533329248428, 0.420566231012344, 0.420599013566971, 0.42063170671463, 0.420664250850677, 0.420696705579758, 0.420729070901871, 0.420761287212372, 0.420793414115906, 0.420825392007828, 0.420857310295105, 0.420889109373093, 0.420920759439468, 0.420952320098877, 0.420983761548996, 0.421015083789825, 0.421046286821365, 0.421077400445938, 0.421108394861221, 0.421139270067215, 0.421170085668564, 0.421200692653656, 0.421231240034103, 0.421261668205261, 0.421292006969452, 0.421322256326675, 0.421352297067642, 0.421382278203964, 0.421412169933319, 0.421441912651062, 0.421471565961838, 0.421501100063324, 0.421530485153198, 0.42155984044075, 0.421589016914368, 0.421618103981018, 0.421647071838379, 0.42167592048645, 0.421704709529877, 0.421733319759369, 0.421761840581894, 0.421790242195129, 0.42181858420372, 0.421846747398376, 0.421874821186066, 0.421902775764465, 0.421930640935898, 0.421958357095718, 0.421985983848572, 0.422013521194458, 0.422040909528732, 0.422068178653717, 0.422095358371735, 0.422122448682785, 0.422149389982224, 0.422176212072372, 0.422202944755554, 0.422229528427124, 0.422256082296371, 0.422282457351685, 0.422308743000031, 0.422334849834442, 0.422360926866531, 0.422386854887009, 0.422412693500519, 0.422438412904739, 0.42246401309967, 0.422489523887634, 0.422514855861664, 0.422540158033371, 0.422565311193466, 0.422590345144272, 0.42261528968811, 0.422640085220337, 0.422664821147919, 0.422689408063889, 0.422713875770569, 0.42273822426796, 0.422762483358383, 0.422786593437195, 0.422810643911362, 0.422834575176239, 0.422858387231827, 0.422882080078125, 0.422905653715134, 0.422929137945175, 0.422952473163605, 0.42297574877739, 0.42299884557724, 0.423021882772446, 0.423044770956039, 0.423067569732666, 0.423090249300003, 0.423112839460373, 0.423135310411453, 0.423157602548599, 0.423179864883423, 0.423201978206635, 0.423224002122879, 0.423245877027512, 0.423267662525177, 0.423289358615875, 0.423310905694962, 0.423332393169403, 0.423353672027588, 0.42337492108345, 0.423396021127701, 0.423417031764984, 0.423437893390656, 0.423458695411682, 0.423479318618774, 0.423499882221222, 0.42352032661438, 0.423540621995926, 0.423560857772827, 0.423580944538116, 0.423600912094116, 0.423620820045471, 0.423640578985214, 0.423660218715668, 0.423679769039154, 0.423699170351028, 0.423718482255936, 0.423737704753876, 0.423756778240204, 0.423775762319565, 0.423794627189636, 0.423813372850418, 0.423832029104233, 0.423850536346436, 0.423868954181671, 0.42388728260994, 0.423905432224274, 0.423923492431641, 0.423941493034363, 0.423959344625473, 0.423977106809616, 0.423994719982147, 0.424012243747711, 0.424029618501663, 0.424046903848648, 0.424064129590988, 0.424081176519394, 0.424098134040833, 0.424114972352982, 0.424131721258163, 0.424148291349411, 0.424164831638336, 0.424181193113327, 0.424197494983673, 0.424213647842407, 0.424229711294174, 0.424245625734329, 0.424261480569839, 0.424277186393738, 0.424292802810669, 0.424308300018311, 0.42432364821434, 0.424338966608047, 0.42435410618782, 0.424369156360626, 0.42438405752182, 0.424398899078369, 0.424413621425629, 0.424428194761276, 0.424442678689957, 0.424457043409348, 0.424471288919449, 0.424485445022583, 0.424499481916428, 0.424513399600983, 0.424527227878571, 0.424540907144547, 0.424554526805878, 0.424567967653275, 0.424581348896027, 0.424594581127167, 0.42460772395134, 0.424620747566223, 0.424633622169495, 0.424646437168121, 0.424659132957458, 0.424671709537506, 0.424684166908264, 0.424696534872055, 0.424708753824234, 0.424720883369446, 0.424732893705368, 0.424744755029678, 0.424756586551666, 0.42476823925972, 0.424779832363129, 0.424791276454926, 0.424802601337433, 0.424813807010651, 0.424824953079224, 0.424835920333862, 0.424846798181534, 0.424857586622238, 0.424868255853653, 0.424878835678101, 0.424889266490936, 0.424899578094482, 0.424909770488739, 0.424919903278351, 0.424929887056351, 0.424939781427383, 0.424949526786804, 0.424959182739258, 0.424968749284744, 0.424978137016296, 0.424987465143204, 0.424996674060822, 0.42500576376915, 0.425014734268188, 0.425023645162582, 0.425032377243042, 0.425041019916534, 0.425049543380737, 0.425057977437973, 0.425066262483597, 0.425074487924576, 0.42508253455162, 0.42509052157402, 0.425098359584808, 0.425106108188629, 0.42511373758316, 0.425121247768402, 0.425128668546677, 0.425135970115662, 0.425143122673035, 0.425150215625763, 0.425157159566879, 0.425164014101028, 0.425170749425888, 0.425177395343781, 0.425183862447739, 0.425190299749374, 0.425196558237076, 0.42520272731781, 0.425208806991577, 0.425214767456055, 0.425220549106598, 0.425226300954819, 0.425231903791428, 0.425237417221069, 0.425242781639099, 0.425248086452484, 0.425253212451935, 0.425258278846741, 0.425263226032257, 0.425268024206161, 0.425272703170776, 0.425277322530746, 0.425281822681427, 0.425286173820496, 0.425290435552597, 0.425294578075409, 0.425298660993576, 0.425302565097809, 0.425306379795074, 0.425310075283051, 0.425313681364059, 0.425317138433456, 0.425320476293564, 0.425323754549026, 0.4253269135952, 0.425329923629761, 0.425332814455032, 0.425335645675659, 0.425338327884674, 0.425340890884399, 0.425343334674835, 0.425345718860626, 0.425347954034805, 0.425350069999695, 0.425352096557617, 0.42535400390625, 0.425355821847916, 0.425357460975647, 0.425359040498734, 0.425360500812531, 0.425361812114716, 0.425363063812256, 0.425364196300507, 0.425365179777145, 0.425366044044495, 0.425366848707199, 0.425367534160614, 0.425368070602417, 0.42535537481308, 0.42532941699028, 0.425303339958191, 0.425277143716812, 0.425250858068466, 0.425224483013153, 0.42519798874855, 0.425171375274658, 0.425144672393799, 0.425117880105972, 0.425090998411179, 0.425063967704773, 0.4250368475914, 0.425009608268738, 0.424982309341431, 0.424954861402512, 0.424927294254303, 0.42489966750145, 0.424871951341629, 0.424844115972519, 0.424816161394119, 0.42478808760643, 0.424759954214096, 0.424731701612473, 0.424703329801559, 0.424674838781357, 0.424646288156509, 0.42461758852005, 0.424588829278946, 0.42455992102623, 0.424530953168869, 0.424501836299896, 0.424472659826279, 0.424443364143372, 0.424413919448853, 0.424384444952011, 0.42435485124588, 0.424325078725815, 0.424295276403427, 0.424265325069427, 0.424235314130783, 0.424205213785172, 0.424174964427948, 0.424144625663757, 0.424114167690277, 0.42408362030983, 0.424052953720093, 0.424022197723389, 0.423991352319717, 0.423960357904434, 0.423929303884506, 0.423898130655289, 0.423866868019104, 0.42383548617363, 0.423803985118866, 0.423772364854813, 0.423740714788437, 0.423708915710449, 0.423676997423172, 0.423644989728928, 0.423612892627716, 0.423580676317215, 0.423548370599747, 0.423515975475311, 0.423483401536942, 0.423450767993927, 0.423418045043945, 0.423385202884674, 0.423352271318436, 0.423319220542908, 0.423286080360413, 0.423252820968628, 0.423219472169876, 0.423186004161835, 0.423152416944504, 0.423118740320206, 0.423085004091263, 0.423051118850708, 0.423017144203186, 0.422983050346375, 0.422948837280273, 0.422914564609528, 0.422880172729492, 0.422845631837845, 0.422811061143875, 0.422776341438293, 0.422741502523422, 0.422706604003906, 0.422671556472778, 0.422636449337006, 0.422601222991943, 0.422565907239914, 0.422530472278595, 0.422494918107986, 0.422459274530411, 0.422423541545868, 0.422387659549713, 0.422351717948914, 0.422315657138824, 0.422279477119446, 0.4222432076931, 0.422206819057465, 0.422170370817184, 0.422133773565292, 0.422097116708755, 0.422060310840607, 0.422023415565491, 0.421986401081085, 0.421949297189713, 0.421912103891373, 0.421874821186066, 0.421837389469147, 0.421799868345261, 0.421762228012085, 0.421724528074265, 0.421686679124832, 0.421648770570755, 0.421610713005066, 0.421572595834732, 0.421534329652786, 0.421495974063873, 0.421457529067993, 0.421418964862823, 0.421380281448364, 0.42134153842926, 0.421302646398544, 0.421263694763184, 0.421224623918533, 0.421185433864594, 0.421146124601364, 0.421106785535812, 0.421067237854004, 0.421027660369873, 0.420987963676453, 0.420948147773743, 0.420908212661743, 0.420868217945099, 0.420828104019165, 0.420787870883942, 0.420747578144073, 0.420707136392593, 0.420666605234146, 0.420625954866409, 0.420585215091705, 0.420544385910034, 0.420503437519073, 0.420462340116501, 0.420421212911606, 0.420379936695099, 0.420338571071625, 0.420297116041183, 0.420255541801453, 0.420213848352432, 0.420172065496445, 0.42013019323349, 0.420088231563568, 0.420046091079712, 0.420003920793533, 0.419961631298065, 0.419919192790985, 0.41987669467926, 0.419834107160568, 0.419791370630264, 0.419748514890671, 0.419705599546432, 0.419662594795227, 0.419619470834732, 0.419576197862625, 0.419532865285873, 0.419489413499832, 0.419445872306824, 0.419402211904526, 0.419358432292938, 0.419314593076706, 0.419270634651184, 0.41922652721405, 0.419182389974594, 0.419138103723526, 0.419093728065491, 0.419049263000488, 0.419004648923874, 0.418959945440292, 0.418915152549744, 0.418870270252228, 0.4188252389431, 0.418780118227005, 0.418734937906265, 0.418689608573914, 0.418644160032272, 0.418598651885986, 0.418553024530411, 0.418507277965546, 0.418461441993713, 0.418415486812592, 0.418369472026825, 0.418323278427124, 0.418277055025101, 0.418230712413788, 0.418184220790863, 0.418137699365616, 0.418090999126434, 0.418044239282608, 0.417997360229492, 0.417950361967087, 0.417903274297714, 0.417856097221375, 0.417808800935745, 0.417761385440826, 0.41771388053894, 0.417666286230087, 0.417618572711945, 0.417570769786835, 0.417522817850113, 0.417474836111069, 0.41742667555809, 0.417378485202789, 0.417330116033554, 0.417281717061996, 0.417233139276505, 0.417184501886368, 0.417135745286942, 0.417086899280548, 0.417037963867188, 0.416988879442215, 0.416939705610275, 0.416890442371368, 0.416841059923172, 0.416791588068008, 0.416741997003555, 0.416692286729813, 0.416642546653748, 0.416592627763748, 0.416542649269104, 0.41649255156517, 0.416442304849625, 0.416392028331757, 0.416341602802277, 0.416291087865829, 0.41624042391777, 0.416189759969711, 0.416138887405396, 0.416087955236435, 0.41603696346283, 0.41598579287529, 0.415934532880783, 0.415883183479309, 0.415831744670868, 0.415780186653137, 0.415728509426117, 0.41567674279213, 0.415624886751175, 0.415572881698608, 0.415520817041397, 0.415468633174896, 0.415416330099106, 0.415363997220993, 0.415311485528946, 0.415258884429932, 0.415206164121628, 0.415153354406357, 0.415100455284119, 0.415047436952591, 0.414994299411774, 0.414941102266312, 0.414887756109238, 0.414834320545197, 0.414780795574188, 0.41472715139389, 0.414673417806625, 0.414619535207748, 0.414565652608871, 0.41451159119606, 0.414457410573959, 0.414403140544891, 0.414348781108856, 0.414294302463531, 0.41423973441124, 0.414185047149658, 0.41413027048111, 0.414075374603271, 0.414020389318466, 0.413965284824371, 0.413910090923309, 0.413854777812958, 0.413799375295639, 0.413743883371353, 0.413688272237778, 0.413632541894913, 0.413576722145081, 0.413520783185959, 0.41346475481987, 0.413408637046814, 0.413352400064468, 0.413296043872833, 0.413239628076553, 0.413183063268661, 0.41312637925148, 0.413069665431976, 0.413012742996216, 0.412955790758133, 0.41289871931076, 0.412841558456421, 0.412784278392792, 0.412726908922195, 0.412669390439987, 0.412611842155457, 0.412554115056992, 0.412496328353882, 0.412438422441483, 0.412380427122116, 0.41232231259346, 0.412264078855515, 0.412205755710602, 0.412147343158722, 0.412088841199875, 0.412030220031738, 0.411971479654312, 0.411912590265274, 0.411853671073914, 0.411794632673264, 0.411735475063324, 0.411676198244095, 0.411616861820221, 0.411557406187057, 0.411497831344604, 0.411438167095184, 0.411378383636475, 0.411318510770798, 0.411258518695831, 0.41119846701622, 0.411138266324997, 0.411077976226807, 0.411017537117004, 0.41095706820488, 0.410896420478821, 0.410835713148117, 0.410774916410446, 0.410714000463486, 0.410652965307236, 0.410591870546341, 0.410530626773834, 0.41046929359436, 0.410407871007919, 0.410346299409866, 0.410284668207169, 0.410222887992859, 0.410161048173904, 0.41009908914566, 0.410037010908127, 0.409974873065948, 0.409912586212158, 0.409850209951401, 0.409787714481354, 0.409725159406662, 0.409662455320358, 0.409599661827087, 0.409536749124527, 0.409473776817322, 0.409410655498505, 0.409347474575043, 0.409284144639969, 0.40922075510025, 0.409157186746597, 0.409093618392944, 0.409029841423035, 0.408966034650803, 0.408902108669281, 0.408838093280792, 0.408773928880692, 0.408709675073624, 0.408645331859589, 0.408580869436264, 0.408516317605972, 0.408451646566391, 0.408386886119843, 0.408322006464005, 0.408257007598877, 0.408191949129105, 0.408126771450043, 0.408061474561691, 0.407996088266373, 0.407930612564087, 0.407865017652512, 0.407799303531647, 0.407733470201492, 0.407667607069016, 0.407601565122604, 0.407535433769226, 0.407469242811203, 0.407402902841568, 0.407336443662643, 0.407269924879074, 0.407203286886215, 0.407136529684067, 0.407069683074951, 0.407002747058868, 0.406935662031174, 0.406868517398834, 0.406801253557205, 0.406733870506287, 0.406666427850723, 0.40659886598587, 0.406531155109406, 0.406463384628296, 0.406395524740219, 0.406327486038208, 0.406259417533875, 0.406191200017929, 0.406122922897339, 0.406054496765137, 0.40598601102829, 0.405917376279831, 0.405848652124405, 0.405779838562012, 0.405710905790329, 0.405641883611679, 0.405572712421417, 0.405503511428833, 0.405434161424637, 0.405364692211151, 0.405295163393021, 0.405225515365601, 0.405155748128891, 0.405085861682892, 0.405015915632248, 0.404945820569992, 0.404875665903091, 0.404805392026901, 0.404734969139099, 0.404664516448975, 0.404593914747238, 0.404523193836212, 0.404452443122864, 0.404381513595581, 0.404310494661331, 0.404239416122437, 0.40416818857193, 0.404096841812134, 0.404025435447693, 0.403953939676285, 0.403882265090942, 0.403810530900955, 0.403738707304001, 0.403666764497757, 0.403594702482224, 0.403522580862045, 0.403450310230255, 0.403377950191498, 0.403305470943451, 0.403232932090759, 0.403160244226456, 0.403087496757507, 0.403014600276947, 0.40294161438942, 0.402868509292603, 0.402795344591141, 0.402722060680389, 0.402648657560349, 0.402575135231018, 0.40250152349472, 0.402427822351456, 0.402354001998901, 0.40228009223938, 0.402206063270569, 0.402131944894791, 0.402057677507401, 0.401983350515366, 0.401908934116364, 0.40183436870575, 0.401759773492813, 0.40168496966362, 0.401610136032104, 0.401535153388977, 0.401460081338882, 0.401384919881821, 0.401309669017792, 0.401234269142151, 0.401158809661865, 0.40108323097229, 0.401007533073425, 0.400931715965271, 0.400855839252472, 0.400779843330383, 0.400703728199005, 0.40062752366066, 0.400551229715347, 0.400474786758423, 0.400398284196854, 0.400321692228317, 0.400244921445847, 0.400168120861053, 0.400091171264648, 0.400014132261276, 0.399937003850937, 0.399859756231308, 0.39978238940239, 0.399704933166504, 0.399627357721329, 0.399549692869186, 0.399471938610077, 0.399394065141678, 0.399316072463989, 0.399238020181656, 0.399159789085388, 0.399081528186798, 0.399003177881241, 0.398924648761749, 0.398846060037613, 0.398767352104187, 0.398688554763794, 0.398609608411789, 0.398530632257462, 0.3984514772892, 0.398372292518616, 0.398292928934097, 0.398213505744934, 0.398133963346481, 0.398054331541061, 0.397974610328674, 0.397894740104675, 0.397814780473709, 0.397734731435776, 0.39765453338623, 0.397574305534363, 0.397493958473206, 0.397413492202759, 0.3973328769207, 0.397252172231674, 0.397171437740326, 0.397090524435043, 0.397009581327438, 0.396928459405899, 0.396847248077393, 0.396765977144241, 0.396684527397156, 0.396603018045425, 0.396521419286728, 0.396439701318741, 0.396357864141464, 0.39627593755722, 0.39619392156601, 0.396111756563187, 0.396029502153397, 0.395947188138962, 0.395864754915237, 0.395782202482224, 0.39569953083992, 0.395616769790649, 0.395533919334412, 0.395450919866562, 0.395367860794067, 0.395284712314606, 0.395201414823532, 0.395118027925491, 0.395034521818161, 0.394950926303864, 0.394867271184921, 0.394783467054367, 0.394699543714523, 0.394615530967712, 0.394531428813934, 0.394447237253189, 0.39436286687851, 0.394278466701508, 0.394193947315216, 0.394109308719635, 0.394024580717087, 0.393939763307571, 0.393854826688766, 0.393769770860672, 0.393684566020966, 0.393599331378937, 0.393513977527618, 0.39342850446701, 0.393342941999435, 0.393257260322571, 0.393171489238739, 0.393085598945618, 0.392999619245529, 0.392913520336151, 0.392827332019806, 0.392741024494171, 0.392654627561569, 0.392568111419678, 0.392481535673141, 0.392394840717316, 0.3923080265522, 0.392221063375473, 0.392134040594101, 0.392046928405762, 0.391959697008133, 0.391872346401215, 0.391784906387329, 0.391697376966476, 0.391609728336334, 0.391521990299225, 0.391434133052826, 0.39134618639946, 0.391258120536804, 0.391169935464859, 0.391081631183624, 0.390993297100067, 0.390904784202576, 0.390816211700439, 0.390727519989014, 0.390638738870621, 0.390549838542938, 0.390460819005966, 0.390371739864349, 0.390282571315765, 0.390193194150925, 0.390103787183762, 0.390014290809631, 0.389924645423889, 0.389834940433502, 0.389745116233826, 0.389655143022537, 0.389565140008926, 0.389474928379059, 0.389384716749191, 0.389294356107712, 0.389203906059265, 0.389113366603851, 0.389022707939148, 0.388931930065155, 0.388841062784195, 0.388750076293945, 0.388658970594406, 0.388567805290222, 0.388476520776749, 0.388385117053986, 0.388293623924255, 0.388202041387558, 0.388110339641571, 0.388018518686295, 0.387926608324051, 0.38783460855484, 0.387742459774017, 0.38765025138855, 0.387557923793793, 0.387465476989746, 0.387372940778732, 0.387280285358429, 0.387187570333481, 0.387094676494598, 0.387001752853394, 0.386908710002899, 0.386815518140793, 0.386722296476364, 0.386628895998001, 0.386535435914993, 0.386441856622696, 0.386348187923431, 0.386254370212555, 0.386160492897034, 0.386066526174545, 0.385972410440445, 0.3858782351017, 0.385783910751343, 0.385689496994019, 0.385594993829727, 0.385500371456146, 0.385405659675598, 0.38531082868576, 0.385215908288956, 0.385120868682861, 0.385025709867477, 0.384930521249771, 0.38483515381813, 0.384739696979523, 0.384644150733948, 0.384548455476761, 0.384452730417252, 0.38435685634613, 0.384260892868042, 0.384164810180664, 0.384068638086319, 0.383972346782684, 0.383875966072083, 0.383779525756836, 0.383682906627655, 0.383586198091507, 0.383489429950714, 0.383392482995987, 0.383295476436615, 0.383198380470276, 0.383101165294647, 0.383003860712051, 0.382906407117844, 0.382808893918991, 0.382711231708527, 0.382613509893417, 0.382515668869019, 0.38241770863533, 0.382319658994675, 0.382221519947052, 0.38212326169014, 0.38202491402626, 0.381926447153091, 0.381827861070633, 0.38172921538353, 0.381630420684814, 0.381531536579132, 0.381432563066483, 0.381333470344543, 0.381234288215637, 0.381134986877441, 0.381035566329956, 0.380936056375504, 0.380836486816406, 0.380736738443375, 0.380636930465698, 0.380537003278732, 0.380436986684799, 0.380336850881577, 0.380236655473709, 0.38013631105423, 0.380035847425461, 0.379935324192047, 0.379834651947021, 0.379733920097351, 0.379633039236069, 0.379532098770142, 0.379431009292603, 0.379329860210419, 0.379228591918945, 0.379127234220505, 0.379025727510452, 0.378924131393433, 0.378822445869446, 0.378720641136169, 0.378618776798248, 0.378516763448715, 0.378414660692215, 0.378312438726425, 0.378210127353668, 0.378107726573944, 0.37800520658493, 0.377902567386627, 0.377799838781357, 0.377697020769119, 0.37759405374527, 0.377491056919098, 0.377387881278992, 0.377284616231918, 0.377181261777878, 0.37707781791687, 0.376974254846573, 0.376870572566986, 0.376766830682755, 0.376662939786911, 0.376558989286423, 0.376454889774323, 0.376350730657578, 0.376246422529221, 0.376142024993896, 0.376037538051605, 0.375932931900024, 0.375828236341476, 0.375723421573639, 0.375618517398834, 0.37551349401474, 0.375408381223679, 0.375303119421005, 0.375197798013687, 0.375092387199402, 0.374986857175827, 0.37488117814064, 0.374775439500809, 0.37466961145401, 0.374563664197922, 0.374457597732544, 0.374351412057877, 0.374245166778564, 0.374138802289963, 0.374032348394394, 0.373925745487213, 0.373819082975388, 0.373712301254272, 0.373605400323868, 0.373498409986496, 0.373391330242157, 0.373284101486206, 0.373176783323288, 0.373069405555725, 0.37296187877655, 0.372854262590408, 0.372746556997299, 0.372638672590256, 0.372530788183212, 0.372422754764557, 0.372314602136612, 0.3722063601017, 0.372098028659821, 0.371989578008652, 0.371881037950516, 0.37177237868309, 0.371663600206375, 0.37155470252037, 0.371445775032043, 0.371336698532104, 0.371227502822876, 0.371118247509003, 0.371008843183517, 0.370899379253387, 0.370789796113968, 0.370680063962936, 0.370570302009583, 0.370460391044617, 0.370350390672684, 0.370240241289139, 0.370130062103271, 0.37001970410347, 0.369909316301346, 0.369798749685287, 0.369688153266907, 0.369577378034592, 0.369466513395309, 0.369355589151382, 0.369244545698166, 0.369133412837982, 0.369022160768509, 0.368910759687424, 0.368799299001694, 0.368687778711319, 0.36857607960701, 0.368464261293411, 0.36835241317749, 0.368240416049957, 0.36812835931778, 0.36801615357399, 0.367903828620911, 0.367791444063187, 0.367678940296173, 0.36756631731987, 0.367453575134277, 0.367340803146362, 0.367227852344513, 0.367114841938019, 0.367001712322235, 0.366888463497162, 0.366775125265121, 0.366661727428436, 0.366548150777817, 0.36643448472023, 0.366320759057999, 0.366206914186478, 0.366092920303345, 0.365978866815567, 0.365864723920822, 0.365750402212143, 0.365636050701141, 0.36552157998085, 0.36540699005127, 0.365292310714722, 0.365177512168884, 0.365062594413757, 0.364947587251663, 0.364832490682602, 0.364717304706573, 0.364601969718933, 0.364486545324326, 0.364371031522751, 0.364255428314209, 0.364139676094055, 0.364023834466934, 0.363907933235168, 0.363791882991791, 0.363675713539124, 0.363559454679489, 0.363443106412888, 0.363326668739319, 0.363210111856461, 0.36309340596199, 0.362976670265198, 0.362859785556793, 0.362742811441422, 0.36262571811676, 0.362508535385132, 0.362391263246536, 0.362273871898651, 0.362156361341476, 0.362038761377335, 0.361921042203903, 0.361803233623505, 0.361685335636139, 0.361567318439484, 0.361449182033539, 0.361330956220627, 0.361212641000748, 0.361094206571579, 0.360975682735443, 0.360857039690018, 0.360738277435303, 0.360619425773621, 0.360500484704971, 0.360381424427032, 0.360262215137482, 0.360143005847931, 0.360023587942123, 0.359904170036316, 0.359784573316574, 0.359664887189865, 0.359545111656189, 0.359425216913223, 0.359305202960968, 0.359185129404068, 0.359064936637878, 0.358944594860077, 0.358824193477631, 0.358703672885895, 0.358583092689514, 0.358462363481522, 0.358341544866562, 0.35822057723999, 0.358099550008774, 0.35797843337059, 0.357857197523117, 0.357735812664032, 0.357614398002625, 0.357492834329605, 0.357371181249619, 0.357249438762665, 0.357127547264099, 0.357005596160889, 0.356883496046066, 0.356761306524277, 0.35663902759552, 0.356516659259796, 0.35639414191246, 0.35627156496048, 0.35614886879921, 0.356026083230972, 0.355903178453445, 0.355780154466629, 0.355657041072845, 0.355533838272095, 0.355410486459732, 0.355287075042725, 0.355163544416428, 0.355039894580841, 0.35491618514061, 0.354792296886444, 0.354668378829956, 0.354544341564178, 0.354420155286789, 0.354295939207077, 0.354171603918076, 0.35404708981514, 0.353922516107559, 0.353797852993011, 0.353673070669174, 0.353548169136047, 0.353423207998276, 0.353298157453537, 0.353172928094864, 0.353047639131546, 0.352922230958939, 0.352796733379364, 0.3526711165905, 0.352545380592346, 0.352419584989548, 0.35229367017746, 0.352167636156082, 0.352041482925415, 0.351915270090103, 0.351788938045502, 0.351662486791611, 0.351535946130753, 0.351409286260605, 0.351282507181168, 0.351155668497086, 0.351028710603714, 0.350901663303375, 0.350774466991425, 0.350647211074829, 0.350519835948944, 0.35039234161377, 0.350264757871628, 0.350137054920197, 0.350009262561798, 0.34988135099411, 0.349753379821777, 0.349625289440155, 0.349497079849243, 0.349368721246719, 0.349240303039551, 0.349111825227737, 0.34898316860199, 0.348854422569275, 0.348725616931915, 0.348596662282944, 0.348467618227005, 0.348338484764099, 0.348209232091904, 0.348079860210419, 0.347950428724289, 0.34782087802887, 0.347691178321838, 0.347561419010162, 0.347426563501358, 0.347286760807037, 0.347146898508072, 0.347007006406784, 0.346867084503174, 0.346727162599564, 0.346587210893631, 0.346447259187698, 0.346307218074799, 0.346167236566544, 0.346027165651321, 0.345887094736099, 0.345747023820877, 0.34560689330101, 0.345466762781143, 0.345326602458954, 0.345186412334442, 0.345046192407608, 0.344905972480774, 0.344765722751617, 0.344625443220139, 0.34448516368866, 0.344344824552536, 0.34420445561409, 0.344064146280289, 0.34392374753952, 0.343783318996429, 0.343642890453339, 0.343502432107925, 0.343361914157867, 0.343221396207809, 0.343080878257751, 0.342940330505371, 0.342799752950668, 0.342659145593643, 0.342518538236618, 0.342377871274948, 0.342237204313278, 0.342096537351608, 0.341955810785294, 0.341815024614334, 0.341674268245697, 0.341533482074738, 0.3413927257061, 0.341251850128174, 0.341110974550247, 0.340970098972321, 0.340829223394394, 0.340688288211823, 0.340547353029251, 0.340406358242035, 0.340265363454819, 0.34012433886528, 0.339983284473419, 0.339842200279236, 0.339701175689697, 0.339560061693192, 0.339418858289719, 0.339277744293213, 0.339136570692062, 0.338995367288589, 0.338854134082794, 0.338712871074677, 0.338571608066559, 0.338430315256119, 0.338289022445679, 0.338147610425949, 0.338006287813187, 0.337864875793457, 0.33772349357605, 0.337582051753998, 0.337440609931946, 0.337299108505249, 0.337157607078552, 0.337016075849533, 0.336874514818192, 0.33673295378685, 0.336591303348541, 0.336449712514877, 0.336308062076569, 0.336166381835938, 0.336024701595306, 0.335882991552353, 0.335741251707077, 0.335599482059479, 0.335457682609558, 0.335315883159637, 0.335174053907394, 0.335032194852829, 0.334890335798264, 0.334748446941376, 0.334606528282166, 0.334464550018311, 0.334322601556778, 0.334180593490601, 0.334038555622101, 0.333896547555923, 0.333754479885101, 0.333612412214279, 0.333470284938812, 0.333328127861023, 0.333186000585556, 0.333043813705444, 0.332901626825333, 0.332759380340576, 0.33261713385582, 0.332474887371063, 0.332332581281662, 0.332190245389938, 0.332047909498215, 0.331905543804169, 0.3317631483078, 0.331620752811432, 0.331478357315063, 0.331335872411728, 0.331193387508392, 0.331050902605057, 0.330908387899399, 0.330765813589096, 0.330623269081116, 0.330480664968491, 0.330338001251221, 0.330195367336273, 0.330052703619003, 0.329910010099411, 0.329767316579819, 0.329624563455582, 0.329481810331345, 0.329338997602463, 0.329196274280548, 0.329053431749344, 0.328910559415817, 0.328767687082291, 0.328624784946442, 0.32848185300827, 0.328338950872421, 0.328195959329605, 0.328052937984467, 0.327909976243973, 0.327766925096512, 0.327623844146729, 0.327480792999268, 0.327337682247162, 0.327194511890411, 0.327051430940628, 0.326908200979233, 0.32676500082016, 0.326621800661087, 0.326478540897369, 0.326335281133652, 0.326191991567612, 0.326048672199249, 0.325905352830887, 0.32576197385788, 0.32561856508255, 0.325475215911865, 0.325331747531891, 0.325188308954239, 0.325044810771942, 0.324901342391968, 0.324757814407349, 0.324614256620407, 0.324470698833466, 0.324327111244202, 0.324183464050293, 0.324039816856384, 0.323896169662476, 0.323752492666245, 0.323608785867691, 0.323465049266815, 0.323321282863617, 0.323177486658096, 0.32303375005722, 0.322889864444733, 0.32274603843689, 0.322602182626724, 0.322458267211914, 0.322314321994781, 0.322170406579971, 0.322026461362839, 0.321882426738739, 0.321738451719284, 0.321594417095184, 0.321450382471085, 0.32130628824234, 0.321162194013596, 0.321018069982529, 0.320873916149139, 0.320729732513428, 0.320585548877716, 0.32044130563736, 0.320297092199326, 0.320152819156647, 0.320008546113968, 0.319864213466644, 0.319719880819321, 0.319575518369675, 0.319431126117706, 0.319286733865738, 0.319142311811447, 0.318997859954834, 0.318853378295898, 0.318708866834641, 0.318564355373383, 0.318419814109802, 0.3182752430439, 0.318130642175674, 0.317986041307449, 0.317841440439224, 0.317696779966354, 0.31755205988884, 0.317407339811325, 0.317262649536133, 0.317117869853973, 0.316973119974136, 0.316828310489655, 0.316683501005173, 0.316538661718369, 0.31639376282692, 0.316248893737793, 0.316103965044022, 0.315959066152573, 0.315814048051834, 0.315669059753418, 0.315524071455002, 0.315379083156586, 0.315234005451202, 0.315088927745819, 0.314943790435791, 0.314798682928085, 0.314653545618057, 0.314508408308029, 0.314363211393356, 0.314217984676361, 0.314072757959366, 0.313927471637726, 0.313782185316086, 0.313636898994446, 0.313491553068161, 0.313346177339554, 0.313200831413269, 0.313055425882339, 0.312909990549088, 0.312764555215836, 0.312619060277939, 0.312473565340042, 0.312328040599823, 0.312182515859604, 0.312036961317062, 0.311891347169876, 0.311745703220367, 0.311600118875504, 0.311454474925995, 0.311308801174164, 0.31116309762001, 0.311017334461212, 0.310871601104736, 0.310725837945938, 0.310580044984818, 0.310434192419052, 0.310288369655609, 0.310142546892166, 0.309996634721756, 0.309850752353668, 0.309704780578613, 0.309558838605881, 0.309412837028503, 0.309266865253448, 0.309120833873749, 0.308974772691727, 0.308828711509705, 0.308682590723038, 0.308536499738693, 0.308390319347382, 0.308244168758392, 0.308097988367081, 0.307951748371124, 0.30780553817749, 0.307659268379211, 0.30751296877861, 0.307366669178009, 0.307220339775085, 0.307073980569839, 0.306927591562271, 0.306781232357025, 0.306634783744812, 0.306488335132599, 0.306341886520386, 0.306195348501205, 0.306048899888992, 0.305902361869812, 0.305755764245987, 0.305609226226807, 0.305462598800659, 0.305315971374512, 0.305169314146042, 0.305022656917572, 0.304875910282135, 0.304729223251343, 0.304582446813583, 0.304435670375824, 0.304288893938065, 0.30414205789566, 0.303995251655579, 0.303848385810852, 0.303701490163803, 0.303554594516754, 0.303407669067383, 0.303260684013367, 0.303113698959351, 0.302966713905334, 0.302819699048996, 0.302672624588013, 0.302525579929352, 0.302378505468369, 0.30223137140274, 0.30208420753479, 0.30193704366684, 0.301789879798889, 0.301642656326294, 0.301495432853699, 0.301348179578781, 0.301200896501541, 0.301053613424301, 0.300906270742416, 0.300758898258209, 0.300611525774002, 0.300464153289795, 0.300316751003265, 0.300169318914413, 0.300021827220917, 0.29987433552742, 0.299726843833923, 0.299579322338104, 0.299431711435318, 0.299284160137177, 0.29913654923439, 0.298988938331604, 0.298841267824173, 0.298693597316742, 0.298545897006989, 0.298398166894913, 0.298250436782837, 0.298102647066116, 0.297954887151718, 0.297807097434998, 0.29765921831131, 0.297511368989944, 0.297363460063934, 0.297215610742569, 0.297067642211914, 0.296919703483582, 0.296771734952927, 0.296623736619949, 0.296475738286972, 0.296327650547028, 0.296179592609406, 0.296031504869461, 0.295883417129517, 0.295735210180283, 0.295587122440338, 0.295438915491104, 0.295290678739548, 0.295142471790314, 0.294994205236435, 0.294845938682556, 0.294697642326355, 0.294549286365509, 0.294400960206985, 0.29425260424614, 0.294104218482971, 0.293955773115158, 0.293807327747345, 0.293658912181854, 0.293510407209396, 0.293361902236938, 0.293213367462158, 0.293064832687378, 0.292916238307953, 0.292767614126205, 0.29261901974678, 0.292470365762711, 0.292321681976318, 0.292172998189926, 0.292024314403534, 0.291875511407852, 0.291726768016815, 0.291577965021133, 0.291429191827774, 0.29128035902977, 0.291131496429443, 0.290982604026794, 0.290833711624146, 0.290684759616852, 0.290535867214203, 0.290386855602264, 0.290237873792648, 0.290088832378387, 0.289939820766449, 0.289790719747543, 0.28964164853096, 0.289492547512054, 0.289343416690826, 0.289194285869598, 0.289045065641403, 0.288895845413208, 0.288746625185013, 0.288597404956818, 0.288448125123978, 0.288298815488815, 0.288149505853653, 0.288000166416168, 0.287850797176361, 0.287701427936554, 0.287551999092102, 0.28740257024765, 0.287253081798553, 0.287103593349457, 0.28695410490036, 0.286804556846619, 0.286655008792877, 0.286505430936813, 0.28635585308075, 0.286206215620041, 0.286056607961655, 0.285906910896301, 0.285757213830948, 0.285607516765594, 0.285457789897919, 0.285308003425598, 0.2851582467556, 0.285008430480957, 0.284858614206314, 0.284708768129349, 0.284558862447739, 0.284408986568451, 0.284259021282196, 0.284109115600586, 0.283959120512009, 0.283809125423431, 0.283659130334854, 0.283509075641632, 0.28335902094841, 0.283208936452866, 0.283058822154999, 0.282908707857132, 0.28275853395462, 0.282608360052109, 0.282458156347275, 0.282307952642441, 0.282157689332962, 0.282007455825806, 0.281857132911682, 0.281706809997559, 0.281556457281113, 0.281406104564667, 0.281255722045898, 0.281105279922485, 0.280954897403717, 0.280804395675659, 0.280653953552246, 0.280503422021866, 0.280352920293808, 0.280202358961105, 0.28005176782608, 0.279901206493378, 0.27975058555603, 0.27959993481636, 0.279449254274368, 0.279298573732376, 0.279147893190384, 0.278997123241425, 0.278846353292465, 0.278695583343506, 0.278544813394547, 0.278393983840942, 0.278243094682693, 0.278092265129089, 0.277941346168518, 0.277790427207947, 0.277639478445053, 0.277488499879837, 0.277337521314621, 0.277186512947083, 0.277035474777222, 0.276884406805038, 0.276733338832855, 0.27658224105835, 0.276431113481522, 0.276279956102371, 0.276128798723221, 0.275977551937103, 0.27582636475563, 0.275675117969513, 0.275523841381073, 0.275372564792633, 0.275221258401871, 0.275069892406464, 0.274918556213379, 0.274767160415649, 0.27461576461792, 0.274464339017868, 0.274312853813171, 0.27416142821312, 0.2740099132061, 0.273858368396759, 0.273706823587418, 0.273555248975754, 0.273403644561768, 0.273252040147781, 0.273100435733795, 0.272948741912842, 0.272797048091888, 0.272645354270935, 0.272493630647659, 0.272341847419739, 0.272190093994141, 0.272038280963898, 0.271886467933655, 0.271734625101089, 0.271582752466202, 0.271430850028992, 0.271278917789459, 0.271127015352249, 0.270975053310394, 0.270823031663895, 0.27067106962204, 0.270519018173218, 0.270366936922073, 0.270214915275574, 0.270062774419785, 0.269910663366318, 0.269758492708206, 0.269606322050095, 0.269454121589661, 0.269301921129227, 0.26914969086647, 0.268997400999069, 0.26884514093399, 0.268692791461945, 0.268540471792221, 0.268388122320175, 0.268235743045807, 0.268083333969116, 0.267930895090103, 0.26777845621109, 0.267625987529755, 0.267473489046097, 0.267320990562439, 0.267168402671814, 0.267015844583511, 0.266863256692886, 0.266710638999939, 0.266558021306992, 0.266405344009399, 0.266252666711807, 0.266099959611893, 0.265947252511978, 0.265794485807419, 0.265641689300537, 0.265488922595978, 0.265336126089096, 0.265183240175247, 0.265030413866043, 0.264877468347549, 0.264724552631378, 0.264571666717529, 0.264418691396713, 0.264265686273575, 0.264112710952759, 0.263959646224976, 0.263806611299515, 0.263653546571732, 0.263500422239304, 0.263347297906876, 0.263194173574448, 0.263041019439697, 0.262887805700302, 0.262734591960907, 0.262581348419189, 0.262428104877472, 0.26227480173111, 0.262121498584747, 0.261968165636063, 0.261814802885056, 0.261661440134048, 0.261508017778397, 0.261354595422745, 0.261201143264771, 0.261047661304474, 0.2608942091465, 0.260740667581558, 0.260587126016617, 0.260433584451675, 0.260280013084412, 0.260126382112503, 0.259972721338272, 0.259819149971008, 0.25966539978981, 0.259511709213257, 0.259357988834381, 0.259204238653183, 0.259050458669662, 0.25889664888382, 0.258742868900299, 0.258589029312134, 0.258435159921646, 0.258281260728836, 0.258127331733704, 0.257973402738571, 0.257819473743439, 0.257665485143661, 0.257511496543884, 0.257357448339462, 0.25720340013504, 0.257049322128296, 0.256895244121552, 0.256741106510162, 0.256586998701096, 0.256432801485062, 0.256278604269028, 0.256124407052994, 0.255970150232315, 0.255815923213959, 0.255661606788635, 0.255507320165634, 0.255353003740311, 0.255198627710342, 0.255044251680374, 0.254889875650406, 0.25473541021347, 0.25458100438118, 0.254426538944244, 0.254272043704987, 0.254117548465729, 0.253962993621826, 0.253808408975601, 0.253653854131699, 0.253499269485474, 0.253344595432281, 0.253189980983734, 0.25303527712822, 0.252880573272705, 0.252725869417191, 0.252571135759354, 0.25241631269455, 0.25226154923439, 0.252106726169586, 0.251951903104782, 0.251797050237656, 0.251642107963562, 0.251487255096436, 0.251332342624664, 0.251177370548248, 0.251022398471832, 0.250867366790771, 0.250712335109711, 0.25055730342865, 0.250402212142944, 0.250247150659561, 0.250092029571533, 0.249936908483505, 0.249781727790833, 0.24962654709816, 0.249471306800842, 0.249316111207008, 0.249160870909691, 0.249005571007729, 0.248850286006927, 0.248694941401482, 0.248539581894875, 0.248384222388268, 0.248228833079338, 0.248073399066925, 0.247918009757996, 0.247762516140938, 0.24760702252388, 0.247451514005661, 0.247295990586281, 0.247140392661095, 0.246984824538231, 0.246829241514206, 0.246673613786697, 0.246517971158028, 0.246362328529358, 0.246206566691399, 0.246050879359245, 0.245895117521286, 0.245739340782166, 0.245583578944206, 0.245427712798119, 0.245271921157837, 0.245116055011749, 0.244960159063339, 0.244804248213768, 0.244648352265358, 0.244492381811142, 0.244336411356926, 0.244180426001549, 0.244024381041527, 0.243868350982666, 0.243712291121483, 0.243556171655655, 0.243400067090988, 0.24324394762516, 0.243087753653526, 0.242931619286537, 0.242775410413742, 0.242619156837463, 0.242462918162346, 0.242306649684906, 0.242150336503983, 0.241994008421898, 0.241837695240974, 0.241681322455406, 0.241524919867516, 0.241368502378464, 0.241212040185928, 0.241055592894554, 0.240899115800858, 0.240742564201355, 0.240586087107658, 0.240429535508156, 0.24027293920517, 0.240116357803345, 0.239959716796875, 0.239803060889244, 0.239646404981613, 0.23948971927166, 0.239332988858223, 0.239176258444786, 0.239019498229027, 0.238862678408623, 0.238705888390541, 0.238549053668976, 0.238392189145088, 0.238235354423523, 0.238078430294991, 0.237921491265297, 0.237764552235603, 0.23760761320591, 0.237450569868088, 0.237293571233749, 0.237136572599411, 0.236979484558105, 0.236822381615639, 0.236665278673172, 0.236508131027222, 0.236350983381271, 0.236193805932999, 0.236036583781242, 0.235879346728325, 0.235722124576569, 0.235564842820168, 0.235407561063766, 0.235250234603882, 0.235092878341675, 0.234935522079468, 0.234778136014938, 0.234620705246925, 0.234463289380074, 0.234305858612061, 0.234148353338242, 0.233990833163261, 0.233833327889442, 0.233675763010979, 0.233518198132515, 0.233360558748245, 0.233202964067459, 0.233045324683189, 0.232887625694275, 0.232729956507683, 0.232572242617607, 0.23241451382637, 0.232256755232811, 0.232098981738091, 0.231941148638725, 0.231783330440521, 0.231625512242317, 0.231467574834824, 0.231309711933136, 0.231151774525642, 0.230993792414665, 0.230835869908333, 0.230677887797356, 0.230519860982895, 0.230361834168434, 0.230203747749329, 0.230045661330223, 0.229887560009956, 0.229729443788528, 0.229571267962456, 0.229413107037544, 0.22925491631031, 0.229096651077271, 0.228938445448875, 0.228780180215836, 0.228621855378151, 0.22846357524395, 0.228305235505104, 0.228146865963936, 0.227988466620445, 0.227830082178116, 0.227671608328819, 0.227513179183006, 0.227354720234871, 0.22719618678093, 0.227037698030472, 0.226879149675369, 0.226720541715622, 0.226561948657036, 0.226403340697289, 0.226244688034058, 0.226086035370827, 0.225927352905273, 0.225768625736237, 0.2256098985672, 0.225451171398163, 0.225292354822159, 0.225133553147316, 0.224974736571312, 0.224815860390663, 0.224657028913498, 0.224498108029366, 0.224339202046394, 0.224180266261101, 0.224021300673485, 0.223862305283546, 0.223703294992447, 0.223544284701347, 0.223385214805603, 0.223226115107536, 0.223067030310631, 0.222907856106758, 0.222748726606369, 0.222589567303658, 0.22243033349514, 0.222271144390106, 0.222111895680428, 0.221952617168427, 0.221793338656425, 0.221634015440941, 0.221474692225456, 0.221315339207649, 0.221155941486359, 0.220996558666229, 0.220837131142616, 0.220677644014359, 0.220518186688423, 0.220358684659004, 0.220199152827263, 0.220039591193199, 0.219880074262619, 0.219720438122749, 0.219560831785202, 0.219401225447655, 0.21924152970314, 0.219081833958626, 0.218922153115273, 0.218762412667274, 0.218602672219276, 0.218442901968956, 0.218283087015152, 0.218123272061348, 0.217963427305222, 0.21780352294445, 0.21764363348484, 0.217483758926392, 0.217323794960976, 0.21716383099556, 0.217003852128983, 0.216843813657761, 0.216683804988861, 0.216523751616478, 0.216363668441772, 0.216203570365906, 0.216043472290039, 0.215883284807205, 0.215723112225533, 0.21556293964386, 0.215402692556381, 0.215242475271225, 0.215082228183746, 0.214921906590462, 0.214761629700661, 0.214601293206215, 0.214440897107124, 0.214280545711517, 0.214120134711266, 0.213959693908691, 0.213799268007278, 0.213638797402382, 0.213478282094002, 0.213317766785622, 0.213157251477242, 0.212996646761894, 0.212836071848869, 0.212675482034683, 0.21251480281353, 0.212354183197021, 0.212193518877029, 0.212032780051231, 0.211872056126595, 0.211711302399635, 0.211550533771515, 0.211389720439911, 0.21122895181179, 0.21106806397438, 0.210907205939293, 0.210746333003044, 0.210585400462151, 0.210424467921257, 0.210263505578041, 0.210102528333664, 0.209941536188126, 0.209780514240265, 0.209619417786598, 0.209458351135254, 0.209297269582748, 0.209136143326759, 0.208975002169609, 0.208813846111298, 0.208652630448341, 0.208491429686546, 0.208330169320107, 0.208168908953667, 0.208007648587227, 0.20784629881382, 0.207684978842735, 0.207523673772812, 0.207362249493599, 0.207200884819031, 0.207039445638657, 0.20687797665596, 0.206716522574425, 0.206555038690567, 0.206393510103226, 0.206231981515884, 0.206070438027382, 0.205908820033073, 0.205747216939926, 0.205585613846779, 0.205423921346664, 0.205262243747711, 0.205100581049919, 0.204938814043999, 0.204777076840401, 0.204615324735641, 0.204453513026237, 0.204291686415672, 0.204129859805107, 0.203967973589897, 0.20380611717701, 0.203644201159477, 0.203482255339622, 0.203320309519768, 0.203158348798752, 0.202996328473091, 0.202834293246269, 0.202672258019447, 0.202510163187981, 0.202348083257675, 0.202185988426208, 0.202023804187775, 0.201861649751663, 0.201699480414391, 0.201537251472473, 0.201375007629395, 0.201212793588638, 0.201050475239754, 0.20088817179203, 0.200725868344307, 0.200563505291939, 0.200401127338409, 0.20023874938488, 0.200076282024384, 0.199913874268532, 0.199751421809196, 0.199588894844055, 0.199426382780075, 0.199263870716095, 0.199101284146309, 0.198938712477684, 0.198776140809059, 0.198613479733467, 0.198450848460197, 0.198288157582283, 0.198125436902046, 0.197962731122971, 0.197799995541573, 0.19763720035553, 0.197474434971809, 0.197311624884605, 0.197148770093918, 0.19698591530323, 0.196823045611382, 0.196660101413727, 0.196497187018394, 0.196334257721901, 0.196171253919601, 0.196016877889633, 0.195871084928513, 0.195725306868553, 0.195579633116722, 0.195433929562569, 0.195288330316544, 0.195142790675163, 0.194997251033783, 0.194851726293564, 0.194706305861473, 0.194560870528221, 0.194415524601936, 0.194270223379135, 0.194124907255173, 0.1939797103405, 0.193834528326988, 0.19368939101696, 0.193544298410416, 0.193399205803871, 0.193254187703133, 0.193109229207039, 0.192964300513268, 0.19281941652298, 0.192674577236176, 0.192529812455177, 0.192385047674179, 0.192240312695503, 0.192095652222633, 0.191951021552086, 0.191806435585022, 0.191661939024925, 0.191517427563667, 0.191372960805893, 0.191228583455086, 0.191084176301956, 0.190939858555794, 0.190795600414276, 0.190651327371597, 0.190507188439369, 0.190362989902496, 0.190218880772591, 0.190074846148491, 0.18993079662323, 0.189786836504936, 0.189642906188965, 0.189499035477638, 0.189355179667473, 0.18921135365963, 0.189067617058754, 0.188923880457878, 0.188780218362808, 0.188636600971222, 0.188492983579636, 0.188349440693855, 0.188205972313881, 0.188062444329262, 0.187919065356255, 0.187775731086731, 0.187632352113724, 0.187489077448845, 0.18734584748745, 0.187202632427216, 0.187059491872787, 0.186916351318359, 0.186773270368576, 0.18663027882576, 0.186487272381783, 0.186344310641289, 0.186201423406601, 0.186058595776558, 0.185915783047676, 0.185773000121117, 0.185630306601524, 0.185487613081932, 0.185344964265823, 0.185202404856682, 0.185059785842896, 0.184917315840721, 0.184774845838547, 0.184632390737534, 0.184490039944649, 0.184347689151764, 0.184205383062363, 0.184063166379929, 0.183920919895172, 0.183778777718544, 0.183636680245399, 0.183494567871094, 0.183352544903755, 0.1832105666399, 0.183068603277206, 0.182926699519157, 0.182784855365753, 0.182643011212349, 0.182501256465912, 0.182359531521797, 0.182217821478844, 0.182076156139374, 0.181934580206871, 0.181793019175529, 0.181651502847672, 0.18151006102562, 0.181368619203568, 0.181227207183838, 0.181085899472237, 0.180944532155991, 0.180803298950195, 0.180662110447884, 0.180520921945572, 0.180379793047905, 0.180238708853722, 0.180097654461861, 0.179956689476967, 0.179815694689751, 0.179674804210663, 0.17953397333622, 0.179393127560616, 0.179252326488495, 0.179111614823341, 0.178970918059349, 0.178830236196518, 0.178689613938332, 0.178549095988274, 0.178408563137054, 0.178268074989319, 0.178127646446228, 0.17798724770546, 0.177846878767014, 0.177706599235535, 0.177566289901733, 0.177426099777222, 0.177285954356194, 0.177145764231682, 0.17700569331646, 0.176865622401237, 0.176725625991821, 0.17658568918705, 0.17644576728344, 0.176305904984474, 0.176166072487831, 0.17602626979351, 0.175886526703835, 0.17574679851532, 0.175607159733772, 0.175467520952225, 0.175327971577644, 0.175188452005386, 0.175048962235451, 0.174909502267838, 0.174770146608353, 0.174630716443062, 0.174491435289383, 0.174352169036865, 0.174212917685509, 0.174073755741119, 0.173934608697891, 0.173795491456985, 0.173656463623047, 0.173517420887947, 0.173378452658653, 0.173239573836327, 0.173100620508194, 0.172961816191673, 0.172823011875153, 0.172684267163277, 0.172545567154884, 0.172406896948814, 0.172268241643906, 0.172129705548286, 0.171991154551506, 0.17185266315937, 0.171714201569557, 0.171575799584389, 0.171437427401543, 0.171299114823341, 0.171160832047462, 0.171022608876228, 0.170884430408478, 0.170746266841888, 0.170608147978783, 0.170470088720322, 0.170332103967667, 0.170194074511528, 0.17005617916584, 0.169918283820152, 0.169780433177948, 0.169642642140388, 0.16950486600399, 0.169367149472237, 0.169229477643967, 0.169091865420341, 0.168954253196716, 0.168816700577736, 0.168679222464561, 0.168541774153709, 0.168404340744019, 0.168266996741295, 0.168129667639732, 0.16799233853817, 0.167855143547058, 0.167717903852463, 0.167580768465996, 0.167443692684174, 0.167306572198868, 0.167169570922852, 0.167032554745674, 0.166895613074303, 0.16675877571106, 0.166621893644333, 0.166485086083412, 0.166348338127136, 0.16621159017086, 0.166074901819229, 0.165938287973404, 0.165801703929901, 0.16566513478756, 0.165528610348701, 0.165392175316811, 0.165255725383759, 0.165119364857674, 0.164983034133911, 0.164846733212471, 0.164710476994514, 0.164574310183525, 0.164438098669052, 0.164302006363869, 0.164165943861008, 0.164029866456985, 0.163893893361092, 0.16375795006752, 0.163622036576271, 0.163486212491989, 0.163350373506546, 0.163214594125748, 0.163078874349594, 0.162943169474602, 0.162807539105415, 0.16267192363739, 0.162536352872849, 0.162400856614113, 0.1622653901577, 0.162129938602448, 0.161994591355324, 0.161859229207039, 0.16172394156456, 0.16158863902092, 0.161453485488892, 0.161318302154541, 0.161183163523674, 0.161048114299774, 0.160913050174713, 0.160778060555458, 0.160643115639687, 0.160508170723915, 0.160373345017433, 0.160238534212112, 0.160103723406792, 0.159969016909599, 0.159834280610085, 0.159699618816376, 0.159565046429634, 0.159430488944054, 0.159295946359634, 0.159161493182182, 0.159027025103569, 0.158892631530762, 0.158758282661438, 0.158623993396759, 0.158489719033241, 0.158355474472046, 0.15822134912014, 0.158087208867073, 0.15795311331749, 0.157819092273712, 0.157685026526451, 0.157551094889641, 0.157417222857475, 0.157283306121826, 0.157149493694305, 0.157015696167946, 0.15688194334507, 0.156748250126839, 0.156614556908607, 0.156480953097343, 0.156347423791885, 0.156213879585266, 0.15608038008213, 0.155946955084801, 0.155813544988632, 0.15568020939827, 0.155546858906746, 0.155413612723351, 0.155280381441116, 0.155147194862366, 0.155014097690582, 0.154880985617638, 0.154747903347015, 0.15461491048336, 0.154481917619705, 0.154349014163017, 0.154216170310974, 0.154083281755447, 0.153950527310371, 0.153817757964134, 0.153685048222542, 0.153552383184433, 0.153419747948647, 0.153287172317505, 0.153154671192169, 0.153022170066833, 0.152889713644981, 0.152757287025452, 0.152624949812889, 0.152492612600327, 0.152360320091248, 0.152228087186813, 0.152095928788185, 0.151963770389557, 0.151831641793251, 0.151699587702751, 0.151567593216896, 0.151435598731041, 0.151303648948669, 0.151171818375587, 0.151039958000183, 0.150908127427101, 0.150776401162148, 0.150644645094872, 0.150513008236885, 0.15038138628006, 0.150249764323235, 0.150118261575699, 0.149986743927002, 0.14985528588295, 0.149723887443542, 0.149592503905296, 0.149461179971695, 0.149329900741577, 0.149198666214943, 0.149067461490631, 0.148936301469803, 0.148805201053619, 0.148674130439758, 0.14854308962822, 0.148412138223648, 0.148281186819077, 0.14815029501915, 0.148019477725029, 0.147888600826263, 0.14775787293911, 0.147627174854279, 0.147496461868286, 0.147365838289261, 0.147235229611397, 0.147104695439339, 0.146974205970764, 0.14684371650219, 0.146713301539421, 0.146582946181297, 0.146452590823174, 0.146322295069695, 0.146192044019699, 0.14606186747551, 0.14593169093132, 0.145801573991776, 0.145671531558037, 0.145541474223137, 0.145411461591721, 0.145281553268433, 0.145151600241661, 0.145021796226501, 0.144892007112503, 0.144762203097343, 0.144632458686829, 0.144502758979797, 0.144373133778572, 0.144243538379669, 0.14411398768425, 0.143984466791153, 0.143855005502701, 0.143725588917732, 0.143596187233925, 0.143466860055923, 0.143337562680244, 0.143208295106888, 0.143079087138176, 0.142949938774109, 0.142820820212364, 0.14269170165062, 0.142562702298164, 0.142433688044548, 0.142304733395576, 0.142175808548927, 0.142046958208084, 0.141918167471886, 0.141789361834526, 0.14166060090065, 0.141531944274902, 0.141403287649155, 0.141274660825729, 0.141146123409271, 0.141017556190491, 0.140889123082161, 0.140760719776154, 0.140632271766663, 0.140503957867622, 0.140375629067421, 0.140247359871864, 0.140119180083275, 0.139990985393524, 0.139862850308418, 0.139734789729118, 0.139606714248657, 0.139478728175163, 0.139350742101669, 0.139222860336304, 0.139094993472099, 0.138967156410217, 0.138839393854141, 0.138711631298065, 0.138583913445473, 0.138456284999847, 0.1383286267519, 0.138201102614403, 0.138073578476906, 0.13794606924057, 0.137818649411201, 0.137691229581833, 0.137563854455948, 0.13743656873703, 0.137309297919273, 0.137182056903839, 0.137054920196533, 0.136927753686905, 0.136800661683083, 0.136673584580421, 0.136546611785889, 0.136419638991356, 0.136292710900307, 0.136165857315063, 0.13603900372982, 0.135912194848061, 0.135785475373268, 0.135658726096153, 0.135532096028328, 0.135405480861664, 0.135278865695, 0.135152369737625, 0.135025858879089, 0.134899407625198, 0.134773030877113, 0.13464666903019, 0.134520322084427, 0.134394079446793, 0.13426785171032, 0.134141638875008, 0.134015485644341, 0.133889406919479, 0.133763328194618, 0.133637309074402, 0.133511394262314, 0.133385419845581, 0.133259564638138, 0.133133724331856, 0.133007884025574, 0.13288214802742, 0.13275645673275, 0.132630735635757, 0.132505133748055, 0.132379546761513, 0.132254004478455, 0.132128521800041, 0.13200306892395, 0.131877645850182, 0.131752297282219, 0.131626933813095, 0.131501659750938, 0.131376475095749, 0.131251215934753, 0.131126090884209, 0.131000965833664, 0.130875915288925, 0.130750879645348, 0.130625918507576, 0.130500957369804, 0.130376085639, 0.130251228809357, 0.130126431584358, 0.130001664161682, 0.129876956343651, 0.12975224852562, 0.129627615213394, 0.129503056406975, 0.129378482699394, 0.129253998398781, 0.129129558801651, 0.12900510430336, 0.128880739212036, 0.128756418824196, 0.128632083535194, 0.128507882356644, 0.128383681178093, 0.128259524703026, 0.128135412931442, 0.128011301159859, 0.127887278795242, 0.127763316035271, 0.127639353275299, 0.127515450119972, 0.127391591668129, 0.127267807722092, 0.127144023776054, 0.127020299434662, 0.126896619796753, 0.126772969961166, 0.126649364829063, 0.126525849103928, 0.126402318477631, 0.126278847455978, 0.126155450940132, 0.126032009720802, 0.125908687710762, 0.125785395503044, 0.125662118196487, 0.125538975000381, 0.125415787100792, 0.125292658805847, 0.125169575214386, 0.125046536326408, 0.124923542141914, 0.124800570309162, 0.124677710235119, 0.124554842710495, 0.124432004988194, 0.124309249222279, 0.124186515808105, 0.124063804745674, 0.123941175639629, 0.123818546533585, 0.123695991933346, 0.123573504388332, 0.123450987040997, 0.123328566551208, 0.123206168413162, 0.123083807528019, 0.122961543500423, 0.122839264571667, 0.122717075049877, 0.122594907879829, 0.122472733259201, 0.122350670397282, 0.122228607535362, 0.122106611728668, 0.121984660625458, 0.12186273932457, 0.121740885078907, 0.121619060635567, 0.121497273445129, 0.121375523507595, 0.121253862977028, 0.121132180094719, 0.121010556817055, 0.120888993144035, 0.1207674741745, 0.120646007359028, 0.120524547994137, 0.120403155684471, 0.12028182297945, 0.120160490274429, 0.120039232075214, 0.119917973875999, 0.119796849787235, 0.11967571824789, 0.119554579257965, 0.11943356692791, 0.119312532246113, 0.119191557168961, 0.119070664048195, 0.11894978582859, 0.118828944861889, 0.118708178400993, 0.118587411940098, 0.118466697633266, 0.118346028029919, 0.118225418031216, 0.118104845285416, 0.117984317243099, 0.117863863706589, 0.117743410170078, 0.11762297898531, 0.117502652108669, 0.117382280528545, 0.117262035608292, 0.117141835391521, 0.117021605372429, 0.116901502013206, 0.116781368851662, 0.116661317646503, 0.116541303694248, 0.116421334445477, 0.116301409900188, 0.116181537508965, 0.116061680018902, 0.115941889584064, 0.115822106599808, 0.11570243537426, 0.115582756698132, 0.115463130176067, 0.115343563258648, 0.11522401124239, 0.115104503929615, 0.114985078573227, 0.114865615963936, 0.114746280014515, 0.114626981317997, 0.114507667720318, 0.114388458430767, 0.114269249141216, 0.11415009945631, 0.114031009376049, 0.113911926746368, 0.113792896270752, 0.113673947751522, 0.11355496942997, 0.113436125218868, 0.113317251205444, 0.113198429346085, 0.113079689443111, 0.11296097189188, 0.11284227669239, 0.112723663449287, 0.112605065107346, 0.112486518919468, 0.112368017435074, 0.112249590456486, 0.112131156027317, 0.112012773752213, 0.111894458532333, 0.111776180565357, 0.111657902598381, 0.111539758741856, 0.111421585083008, 0.111303433775902, 0.111185394227505, 0.111067339777946, 0.110949359834194, 0.110831432044506, 0.110713504254818, 0.110595680773258, 0.110477857291698, 0.110360100865364, 0.110242381691933, 0.110124684870243, 0.110007032752037, 0.109889455139637, 0.10977191478014, 0.109654404222965, 0.109536916017532, 0.109419494867325, 0.109302125871181, 0.109184771776199, 0.109067492187023, 0.10895024985075, 0.108833037316799, 0.108715914189816, 0.108598724007607, 0.108481660485268, 0.108364656567574, 0.108247622847557, 0.10813070833683, 0.108013801276684, 0.107896916568279, 0.107780128717422, 0.107663340866566, 0.107546605169773, 0.107429936528206, 0.107313275337219, 0.107196643948555, 0.107080094516277, 0.106963604688644, 0.106847129762173, 0.106730684638023, 0.106614306569099, 0.106497965753078, 0.106381639838219, 0.106265425682068, 0.106149166822433, 0.106033019721508, 0.105916917324066, 0.105800785124302, 0.105684772133827, 0.105568751692772, 0.105452813208103, 0.105336911976337, 0.105221040546894, 0.105105206370354, 0.104989439249039, 0.104873679578304, 0.104757994413376, 0.104642316699028, 0.104526735842228, 0.104411140084267, 0.104295626282692, 0.104180119931698, 0.104064732789993, 0.103949338197708, 0.103833951056004, 0.103718660771847, 0.103603422641754, 0.1034881696105, 0.103372991085052, 0.103257864713669, 0.10314279794693, 0.10302771627903, 0.102912738919258, 0.102797716856003, 0.102682836353779, 0.102568008005619, 0.102453120052814, 0.102338336408138, 0.102223582565784, 0.102108880877495, 0.10199423879385, 0.101879596710205, 0.101765021681786, 0.101650528609753, 0.101536020636559, 0.10142157971859, 0.101307168602943, 0.101192839443684, 0.101078487932682, 0.100964225828648, 0.100850030779839, 0.100735850632191, 0.100621700286865, 0.100507616996765, 0.100393541157246, 0.10027951747179, 0.10016556084156, 0.10005160421133, 0.09993776679039, 0.0998239368200302, 0.0997101068496704, 0.0995963662862778, 0.0994826331734657, 0.0993689820170403, 0.099255345761776, 0.0991417840123177, 0.0990282371640205, 0.0989147573709488, 0.0988012999296188, 0.0986878871917725, 0.0985745191574097, 0.0984612181782722, 0.0983479171991348, 0.0982346907258034, 0.0981215238571167, 0.0980083718895912, 0.0978952422738075, 0.097782202064991, 0.0976691544055939, 0.0975561961531639, 0.0974432826042175, 0.0973303467035294, 0.0972175300121307, 0.0971047133207321, 0.0969919562339783, 0.0968792662024498, 0.0967665612697601, 0.0966539308428764, 0.0965413600206375, 0.0964288040995598, 0.0963163077831268, 0.0962038263678551, 0.0960914418101311, 0.0959790572524071, 0.0958667322993279, 0.0957544669508934, 0.0956422090530396, 0.0955300182104111, 0.0954178646206856, 0.0953057333827019, 0.0951936915516853, 0.0950816497206688, 0.0949696525931358, 0.0948577225208282, 0.094745822250843, 0.094633974134922, 0.0945221930742264, 0.0944103747606277, 0.0942986831068993, 0.0941869989037514, 0.0940753445029259, 0.0939637497067451, 0.093852199614048, 0.0937406942248344, 0.0936292558908463, 0.0935178101062775, 0.0934064388275146, 0.093295119702816, 0.0931838154792786, 0.0930725485086441, 0.0929613560438156, 0.0928502157330513, 0.0927390977740288, 0.0926279798150063, 0.0925169885158539, 0.0924059823155403, 0.0922950282692909, 0.0921841487288475, 0.0920732542872429, 0.0919624716043472, 0.091851718723774, 0.0917409285902977, 0.0916302651166916, 0.0915195941925049, 0.0914089903235435, 0.0912984609603882, 0.0911879315972328, 0.0910774692893028, 0.0909670516848564, 0.0908566638827324, 0.0907463207840919, 0.0906360521912575, 0.0905257612466812, 0.0904155522584915, 0.090305395424366, 0.0901952758431435, 0.0900851935148239, 0.0899751409888268, 0.089865155518055, 0.0897552073001862, 0.0896452739834785, 0.0895354375243187, 0.0894255861639977, 0.0893158093094826, 0.0892060771584511, 0.0890963524580002, 0.088986724615097, 0.0888770967721939, 0.0887675434350967, 0.0886580422520638, 0.088548555970192, 0.0884391069412231, 0.0883297398686409, 0.0882203876972198, 0.0881110727787018, 0.0880017951130867, 0.0878926217556, 0.0877834260463715, 0.0876742824912071, 0.0875652059912682, 0.0874561741948128, 0.0873471274971962, 0.0872382074594498, 0.0871292501688004, 0.0870204046368599, 0.086911603808403, 0.0868027657270432, 0.0866940319538116, 0.0865853354334831, 0.0864766538143158, 0.0863680467009544, 0.0862594544887543, 0.0861509442329407, 0.0860424712300301, 0.0859339907765388, 0.0858256295323372, 0.0857172533869743, 0.0856089666485786, 0.0855007171630859, 0.0853924825787544, 0.0852842628955841, 0.0851761400699615, 0.0850680321455002, 0.0849599838256836, 0.08485197275877, 0.0847440138459206, 0.0846361070871353, 0.0845282077789307, 0.0844203904271126, 0.0843125730752945, 0.0842048078775406, 0.0840971395373344, 0.0839894190430641, 0.0838818252086639, 0.0837742760777473, 0.083666704595089, 0.0835592225193977, 0.0834517702460289, 0.0833443254232407, 0.083237037062645, 0.0831296965479851, 0.0830223858356476, 0.0829151794314384, 0.0828079730272293, 0.0827008336782455, 0.0825937315821648, 0.0824866816401482, 0.0823796764016151, 0.0822727009654045, 0.0821657553315163, 0.0820588618516922, 0.0819520205259323, 0.081845223903656, 0.0817384794354439, 0.0816317498683929, 0.081525094807148, 0.081418439745903, 0.0813118815422058, 0.0812053605914116, 0.0810988023877144, 0.0809923559427261, 0.0808859691023827, 0.080779567360878, 0.0806732699275017, 0.0805669724941254, 0.0804607272148132, 0.0803545638918877, 0.0802483856678009, 0.0801422744989395, 0.0800362154841423, 0.0799302235245705, 0.0798242092132568, 0.079718254506588, 0.0796123743057251, 0.0795065388083458, 0.0794007107615471, 0.0792949572205544, 0.0791892036795616, 0.0790835618972778, 0.0789779499173164, 0.0788722857832909, 0.0787667632102966, 0.0786612331867218, 0.0785557851195335, 0.0784503966569901, 0.0783450081944466, 0.0782396718859673, 0.0781344026327133, 0.0780290961265564, 0.077923908829689, 0.077818751335144, 0.077713631093502, 0.077608585357666, 0.0775035545229912, 0.0773985758423805, 0.077293649315834, 0.0771887376904488, 0.0770838484168053, 0.0769789963960648, 0.0768742635846138, 0.0767695382237434, 0.0766648352146149, 0.0765602141618729, 0.0764556378126144, 0.0763510465621948, 0.076246552169323, 0.0761420354247093, 0.076037622988224, 0.0759332925081253, 0.075828917324543, 0.0757246091961861, 0.0756203681230545, 0.0755161568522453, 0.0754119977355003, 0.0753078833222389, 0.0752037540078163, 0.0750997886061668, 0.0749957710504532, 0.0748917981982231, 0.0747878849506378, 0.0746840387582779, 0.0745802223682404, 0.0744764283299446, 0.0743727013468742, 0.0742690414190292, 0.074165366590023, 0.0740617737174034, 0.0739581510424614, 0.0738546624779701, 0.0737511962652206, 0.0736477449536324, 0.07354436814785, 0.0734410062432289, 0.0733377188444138, 0.0732344686985016, 0.0731312409043312, 0.0730280429124832, 0.0729249566793442, 0.0728218778967857, 0.0727187991142273, 0.0726157873868942, 0.0725128352642059, 0.0724099278450012, 0.0723070576786995, 0.0722042396664619, 0.0721014365553856, 0.071998655796051, 0.0718960165977478, 0.0717975795269012, 0.0717029199004173, 0.0716084614396095, 0.0715139359235764, 0.0714195519685745, 0.0713252276182175, 0.0712308436632156, 0.0711366608738899, 0.0710424780845642, 0.0709483623504639, 0.0708543136715889, 0.0707603394985199, 0.0706663653254509, 0.0705725252628326, 0.0704786852002144, 0.0703849121928215, 0.070291206240654, 0.0701975747942924, 0.0701040104031563, 0.0700104460120201, 0.0699170157313347, 0.0698236525058746, 0.0697302222251892, 0.0696369335055351, 0.0695437118411064, 0.0694505572319031, 0.0693574696779251, 0.0692643821239471, 0.0691714361310005, 0.0690784901380539, 0.0689856112003326, 0.0688927918672562, 0.0687999874353409, 0.0687073096632957, 0.068614773452282, 0.0685220956802368, 0.0684296265244484, 0.06833715736866, 0.0682447627186775, 0.0681524202227592, 0.0680601671338081, 0.0679678991436958, 0.0678757727146149, 0.0677836537361145, 0.0676915869116783, 0.0675996020436287, 0.0675076767802238, 0.0674158334732056, 0.0673239752650261, 0.067232258617878, 0.0671406164765358, 0.067048966884613, 0.0669573917984962, 0.0668658167123795, 0.0667744427919388, 0.0666830688714981, 0.0665916949510574, 0.0665004625916481, 0.0664092302322388, 0.0663180574774742, 0.0662270337343216, 0.066135935485363, 0.0660449713468552, 0.0659540817141533, 0.0658631846308708, 0.0657723620533943, 0.0656816065311432, 0.065590925514698, 0.065500371158123, 0.0654097497463226, 0.0653192773461342, 0.0652288571000099, 0.0651383772492409, 0.0650481060147285, 0.0649577602744102, 0.0648676156997681, 0.0647774785757065, 0.0646873489022255, 0.0645973458886147, 0.0645073354244232, 0.0644174069166183, 0.0643276125192642, 0.0642378181219101, 0.0641480907797813, 0.064058430492878, 0.0639687702059746, 0.0638792514801025, 0.0637897998094559, 0.0637002736330032, 0.0636109560728073, 0.0635215789079666, 0.0634323284029961, 0.0633431524038315, 0.0632539689540863, 0.0631649270653725, 0.0630758926272392, 0.0629869177937508, 0.0628980100154877, 0.0628091022372246, 0.0627204105257988, 0.0626316368579865, 0.0625429451465607, 0.062454380095005, 0.0623658187687397, 0.0622773244976997, 0.0621889680624008, 0.0621004737913609, 0.0620121881365776, 0.0619239658117294, 0.0618357509374619, 0.0617476664483547, 0.0616595149040222, 0.0615715011954308, 0.061483558267355, 0.0613956786692142, 0.0613078065216541, 0.0612200647592545, 0.0611323304474354, 0.0610446594655514, 0.0609570518136024, 0.0608695223927498, 0.0607820525765419, 0.0606945902109146, 0.0606072619557381, 0.0605199337005615, 0.0604326762259007, 0.0603454858064651, 0.0602582953870296, 0.0601712390780449, 0.0600843206048012, 0.059997271746397, 0.059910424053669, 0.0598235726356506, 0.059736791998148, 0.0596501491963863, 0.0595634393393993, 0.0594768673181534, 0.0593903586268425, 0.0593037866055965, 0.059217419475317, 0.0591309778392315, 0.0590447522699833, 0.0589585192501545, 0.0588722862303257, 0.0587861910462379, 0.0587001666426659, 0.0586140751838684, 0.0585281848907471, 0.0584422238171101, 0.0583564788103104, 0.0582707263529301, 0.0581849701702595, 0.0580992884933949, 0.0580137446522713, 0.0579281970858574, 0.0578427873551846, 0.0577573142945766, 0.0576719753444195, 0.0575866997241974, 0.0575014278292656, 0.0574162937700748, 0.0573310926556587, 0.057246096432209, 0.057161096483469, 0.0570761002600193, 0.0569912418723106, 0.056906446814537, 0.0568216592073441, 0.0567370019853115, 0.0566523484885693, 0.0565677620470524, 0.0564832463860512, 0.0563987232744694, 0.0563143417239189, 0.0562300346791744, 0.0561456568539143, 0.0560614764690399, 0.0559773035347462, 0.0558931976556778, 0.0558091588318348, 0.0557251237332821, 0.0556412227451801, 0.0555573888123035, 0.0554734878242016, 0.0553897954523563, 0.0553060285747051, 0.055222399532795, 0.0551388449966908, 0.0550552867352962, 0.0549718663096428, 0.0548885092139244, 0.054805088788271, 0.0547218769788742, 0.0546385906636715, 0.0545554496347904, 0.0544723719358444, 0.0543892942368984, 0.0543063506484032, 0.0542234070599079, 0.0541404709219933, 0.0540577322244644, 0.0539749301970005, 0.053892258554697, 0.0538096614181995, 0.053727064281702, 0.0536446049809456, 0.0535620748996735, 0.0534796826541424, 0.053397424519062, 0.0533151030540466, 0.0532328449189663, 0.0531507283449173, 0.053068608045578, 0.0529865622520447, 0.0529045797884464, 0.0528226681053638, 0.0527408197522163, 0.0526589751243591, 0.052577268332243, 0.0524956285953522, 0.052413921803236, 0.0523324236273766, 0.0522508509457111, 0.0521694198250771, 0.0520881228148937, 0.0520066879689693, 0.051925465464592, 0.051844235509634, 0.0517630763351917, 0.0516820549964905, 0.0516009628772736, 0.051520012319088, 0.0514391288161278, 0.0513582415878773, 0.0512774251401424, 0.0511966794729233, 0.0511160008609295, 0.0510353893041611, 0.0509547777473927, 0.0508743077516556, 0.0507939010858536, 0.0507134944200516, 0.0506331585347652, 0.0505528934299946, 0.050472691655159, 0.0503926314413548, 0.0503124333918095, 0.050232507288456, 0.0501524470746517, 0.0500725209712982, 0.0499927289783955, 0.0499129444360733, 0.0498332269489765, 0.0497535727918148, 0.0496739223599434, 0.049594409763813, 0.0495148934423923, 0.0494354516267776, 0.049356073141098, 0.0492766983807087, 0.0491974577307701, 0.0491182878613472, 0.049039114266634, 0.0489600822329521, 0.0488810464739799, 0.0488020814955235, 0.0487231835722923, 0.0486442893743515, 0.0485655292868614, 0.048486839979887, 0.0484081469476223, 0.0483295917510986, 0.0482510402798653, 0.048172552138567, 0.0480941385030746, 0.048015721142292, 0.0479374416172504, 0.0478592291474342, 0.0477809496223927, 0.0477028712630272, 0.047624733299017, 0.0475467257201672, 0.047468788921833, 0.0473908521234989, 0.0473130494356155, 0.0472353212535381, 0.0471575893461704, 0.0470799244940281, 0.0470022633671761, 0.0469247363507748, 0.0468472801148891, 0.0467698238790035, 0.0466925017535686, 0.0466151796281338, 0.0465379320085049, 0.0464608147740364, 0.0463835634291172, 0.0463065877556801, 0.0462296083569527, 0.0461526326835155, 0.0460757203400135, 0.0459988825023174, 0.0459221079945564, 0.0458454079926014, 0.0457687713205814, 0.0456921383738518, 0.0456156395375729, 0.0455391407012939, 0.0454627126455307, 0.0453863516449928, 0.0453100614249706, 0.0452338382601738, 0.0451576113700867, 0.0450815260410309, 0.0450055077672005, 0.0449294224381447, 0.0448535420000553, 0.0447775907814503, 0.0447018481791019, 0.0446261055767536, 0.0445502921938896, 0.0444747544825077, 0.044399082660675, 0.0443236082792282, 0.044248141348362, 0.0441726706922054, 0.0440973378717899, 0.0440220721065998, 0.0439468137919903, 0.0438716858625412, 0.0437964871525764, 0.0437215007841587, 0.0436465106904507, 0.0435715205967426, 0.0434966646134853, 0.0434218868613243, 0.0433471016585827, 0.0432723835110664, 0.0431977398693562, 0.0431231558322906, 0.0430486500263214, 0.0429741404950619, 0.0428998321294785, 0.0428254641592503, 0.0427511595189571, 0.0426769927144051, 0.0426027551293373, 0.0425286553800106, 0.0424546264111996, 0.0423805974423885, 0.0423067025840282, 0.0422328822314739, 0.0421589873731136, 0.0420853011310101, 0.0420115441083908, 0.0419379249215126, 0.0418643727898598, 0.0417908243834972, 0.0417174138128757, 0.041643999516964, 0.0415706560015678, 0.0414973795413971, 0.0414240993559361, 0.0413509607315063, 0.0412778928875923, 0.041204821318388, 0.0411318875849247, 0.0410589575767517, 0.0409860908985138, 0.0409132950007915, 0.0408404991030693, 0.0407678373157978, 0.0406952500343323, 0.0406226590275764, 0.0405501388013363, 0.0404776819050312, 0.0404052995145321, 0.040332980453968, 0.0402606651186943, 0.0401884838938713, 0.0401163771748543, 0.0400441959500313, 0.039972223341465, 0.0399001836776733, 0.0398282743990421, 0.0397564396262169, 0.0396846048533916, 0.0396129041910172, 0.039541207253933, 0.0394695736467838, 0.0393980778753757, 0.0393264479935169, 0.0392550937831402, 0.0391837358474731, 0.0391123779118061, 0.0390411578118801, 0.0389698706567287, 0.0388987883925438, 0.0388277061283588, 0.0387566238641739, 0.03868567943573, 0.0386147983372211, 0.0385439246892929, 0.0384731143712997, 0.0384023748338223, 0.0383317060768604, 0.038261104375124, 0.0381904989480972, 0.0381200350821018, 0.0380495674908161, 0.0379791706800461, 0.0379089079797268, 0.0378385819494724, 0.0377684608101845, 0.0376983359456062, 0.037628211081028, 0.0375581607222557, 0.0374882407486439, 0.0374183245003223, 0.0373484790325165, 0.0372786931693554, 0.0372089855372906, 0.0371393412351608, 0.0370696298778057, 0.037000123411417, 0.0369306169450283, 0.0368611812591553, 0.0367918834090233, 0.036722581833601, 0.0366532802581787, 0.0365841165184975, 0.0365149527788162, 0.036445926874876, 0.0363768339157104, 0.0363078750669956, 0.0362389832735062, 0.036170095205307, 0.0361014157533646, 0.0360327288508415, 0.0359639786183834, 0.035895362496376, 0.0358268842101097, 0.035758338868618, 0.0356899984180927, 0.0356215871870518, 0.0355532504618168, 0.0354850441217422, 0.035416841506958, 0.0353487096726894, 0.0352805703878403, 0.0352126434445381, 0.0351446457207203, 0.0350767150521278, 0.0350089222192764, 0.0349412001669407, 0.0348734073340893, 0.0348058193922043, 0.0347382351756096, 0.0346706472337246, 0.0346031971275806, 0.034535750746727, 0.0344684347510338, 0.0344011224806309, 0.034333810210228, 0.0342666357755661, 0.0341995283961296, 0.0341324880719185, 0.0340655222535133, 0.0339985489845276, 0.0339316502213478, 0.0338648855686188, 0.0337980501353741, 0.0337313562631607, 0.0336646623909473, 0.0335981026291847, 0.0335316136479378, 0.0334650538861752, 0.0333987027406693, 0.0333322808146477, 0.0332660637795925, 0.0331998467445374, 0.0331336334347725, 0.033067487180233, 0.0330014787614346, 0.0329354666173458, 0.0328695923089981, 0.032803650945425, 0.0327377766370773, 0.032672043889761, 0.0326063744723797, 0.0325407758355141, 0.0324751064181328, 0.0324096456170082, 0.0323441848158836, 0.0322787240147591, 0.0322134010493755, 0.0321481414139271, 0.0320828892290592, 0.0320177003741264, 0.0319526493549347, 0.0318875312805176, 0.0318225473165512, 0.0317575670778751, 0.0316927917301655, 0.0316279456019402, 0.0315631702542305, 0.0314984619617462, 0.0314338244497776, 0.0313693210482597, 0.0313048176467419, 0.0312403161078691, 0.031175883486867, 0.0311115849763155, 0.0310472901910543, 0.0309830624610186, 0.0309189017862082, 0.0308548100292683, 0.0307907909154892, 0.0307266991585493, 0.0306628160178661, 0.030598996207118, 0.0305351801216602, 0.0304714310914278, 0.0304077509790659, 0.0303440745919943, 0.0302805304527283, 0.0302169900387526, 0.0301535818725824, 0.0300901774317026, 0.0300267729908228, 0.0299635715782642, 0.0299003031104803, 0.0298371743410826, 0.0297741089016199, 0.0297109801322222, 0.0296480543911457, 0.0295851975679398, 0.0295222718268633, 0.0294594839215279, 0.0293966941535473, 0.0293340440839529, 0.029271462932229, 0.0292088780552149, 0.0291463639587164, 0.0290838498622179, 0.0290215387940407, 0.0289592333137989, 0.0288969241082668, 0.0288346856832504, 0.0287725832313299, 0.0287104770541191, 0.0286485143005848, 0.0285864789038897, 0.028524512425065, 0.0284626819193363, 0.0284009240567684, 0.0283391643315554, 0.0282774697989225, 0.0282158460468054, 0.028154294937849, 0.0280928090214729, 0.028031388297677, 0.0279700420796871, 0.0279086902737617, 0.0278474111109972, 0.0277862679213285, 0.0277250558137894, 0.0276639834046364, 0.0276029072701931, 0.0275419689714909, 0.0274810995906591, 0.0274202320724726, 0.0273594316095114, 0.0272987000644207, 0.0272380355745554, 0.0271775107830763, 0.0271168444305658, 0.0270563885569572, 0.0269959289580584, 0.0269356090575457, 0.0268752872943878, 0.0268149673938751, 0.0267547834664583, 0.026694668456912, 0.0266345534473658, 0.0265745762735605, 0.0265145972371101, 0.0264546871185303, 0.0263948477804661, 0.0263350754976273, 0.0262753702700138, 0.026215735822916, 0.0261560995131731, 0.0260965339839458, 0.0260371044278145, 0.0259776059538126, 0.0259182453155518, 0.0258588828146458, 0.0257997289299965, 0.0257405042648315, 0.0256813485175371, 0.0256222616881132, 0.0255632437765598, 0.0255043618381023, 0.02544548176229, 0.0253865998238325, 0.0253277886658907, 0.0252691805362701, 0.0252104364335537, 0.0251518972218037, 0.0250932890921831, 0.0250348206609488, 0.0249764192849398, 0.0249180179089308, 0.0248597543686628, 0.0248015578836203, 0.0247432924807072, 0.0246851667761803, 0.0246271770447493, 0.0245691165328026, 0.0245111938565969, 0.0244532749056816, 0.024395490065217, 0.0243377033621073, 0.0242799185216427, 0.0242223404347897, 0.0241646934300661, 0.0241071842610836, 0.0240497402846813, 0.0239922311156988, 0.0239349268376827, 0.023877689614892, 0.0238204542547464, 0.0237632859498262, 0.0237061195075512, 0.0236490871757269, 0.0235920585691929, 0.0235350970178843, 0.0234782714396715, 0.0234213769435883, 0.0233646221458912, 0.0233079344034195, 0.0232512466609478, 0.023194694891572, 0.0231382120400667, 0.0230817291885614, 0.0230253860354424, 0.0229689721018076, 0.0229126270860434, 0.022856418043375, 0.0228002797812223, 0.022744208574295, 0.0226880684494972, 0.0226320661604404, 0.0225762017071247, 0.0225202683359385, 0.0224644709378481, 0.0224087424576283, 0.0223530158400536, 0.0222973562777042, 0.0222418326884508, 0.022186242043972, 0.0221308581531048, 0.0220754016190767, 0.02202008664608, 0.0219648368656635, 0.0219095200300217, 0.0218544080853462, 0.0217992290854454, 0.021744254976511, 0.0216892808675766, 0.0216343067586422, 0.0215794704854488, 0.0215246342122555, 0.021469933912158, 0.0214152317494154, 0.0213605333119631, 0.0213059708476067, 0.0212515443563461, 0.0211970489472151, 0.0211426243185997, 0.0210882667452097, 0.0210339780896902, 0.0209798272699118, 0.0209256075322628, 0.0208715237677097, 0.0208175089210272, 0.0207634959369898, 0.0207096170634031, 0.0206557400524616, 0.0206019319593906, 0.020548190921545, 0.0204944498836994, 0.0204409155994654, 0.0203873123973608, 0.0203337781131268, 0.0202803127467632, 0.0202269833534956, 0.020173653960228, 0.0201203934848309, 0.0200671330094337, 0.0200139414519072, 0.019960954785347, 0.0199078321456909, 0.0198549143970013, 0.0198019277304411, 0.019749078899622, 0.0196962971240282, 0.0196435172110796, 0.0195908732712269, 0.0195382982492447, 0.0194857232272625, 0.0194332171231508, 0.0193807780742645, 0.0193283408880234, 0.0192760415375233, 0.0192238092422485, 0.0191716440021992, 0.019119480624795, 0.0190673172473907, 0.0190152898430824, 0.0189633332192898, 0.0189114417880774, 0.0188596211373806, 0.0188077334314585, 0.018756115809083, 0.0187044329941273, 0.0186528172343969, 0.0186012703925371, 0.0185497254133224, 0.0184983145445585, 0.0184469725936651, 0.0183955635875463, 0.018344359472394, 0.0182930864393711, 0.0182420201599598, 0.0181909520179033, 0.018139885738492, 0.0180889554321766, 0.0180380269885063, 0.0179872326552868, 0.0179364401847124, 0.0178857166320086, 0.0178349930793047, 0.0177844036370516, 0.0177338868379593, 0.0176833681762218, 0.0176329165697098, 0.0175825357437134, 0.017532292753458, 0.0174819771200418, 0.017431803047657, 0.0173816960304976, 0.0173315871506929, 0.0172816179692745, 0.017231646925211, 0.0171817447990179, 0.0171319115906954, 0.0170820783823729, 0.0170323830097914, 0.0169827565550804, 0.0169331282377243, 0.0168835688382387, 0.0168340783566236, 0.0167847257107496, 0.0167353041470051, 0.0166859496384859, 0.0166367329657078, 0.0165876541286707, 0.0165384393185377, 0.016489427536726, 0.0164403486996889, 0.0163914076983929, 0.0163425337523222, 0.0162936598062515, 0.0162449236959219, 0.0161961875855923, 0.016147518530488, 0.01609898917377, 0.0160504579544067, 0.0160019267350435, 0.0159535333514214, 0.015905138105154, 0.0158568825572729, 0.0158086251467466, 0.015760438516736, 0.0157123189419508, 0.0156642664223909, 0.0156162846833467, 0.0155683029443026, 0.0155203891918063, 0.0154726132750511, 0.0154249044135213, 0.0153771266341209, 0.0153295565396547, 0.0152819156646729, 0.0152344135567546, 0.0151869114488363, 0.0151394763961434, 0.0150921801105142, 0.0150448149070144, 0.014997586607933, 0.0149504272267222, 0.0149032659828663, 0.014856243506074, 0.0148092899471521, 0.0147623345255852, 0.0147154498845339, 0.014668632298708, 0.0146218845620751, 0.0145752048119903, 0.0145285231992602, 0.0144819812849164, 0.0144354375079274, 0.0143888955935836, 0.0143425576388836, 0.0142962215468287, 0.0142499515786767, 0.0142037514597178, 0.0141574833542109, 0.0141114201396704, 0.0140654258430004, 0.0140193616971374, 0.0139735043048859, 0.0139275779947639, 0.0138817895203829, 0.0138360001146793, 0.0137902814894915, 0.0137446960434318, 0.0136990454047918, 0.0136535996571183, 0.0136081529781222, 0.0135627072304487, 0.0135173974558711, 0.0134721575304866, 0.0134269166737795, 0.0133817447349429, 0.0133366407826543, 0.0132915377616882, 0.0132466405630112, 0.013201673515141, 0.0131568443030119, 0.0131120150908828, 0.0130671858787537, 0.0130225624889135, 0.0129779390990734, 0.0129333836957812, 0.012888896279037, 0.0128444097936153, 0.0127999922260642, 0.0127557115629315, 0.0127113619819283, 0.0126672182232141, 0.0126230055466294, 0.0125789297744632, 0.01253492385149, 0.0124909169971943, 0.0124469790607691, 0.0124031091108918, 0.0123593769967556, 0.0123155750334263, 0.0122719118371606, 0.0122282477095723, 0.0121847884729505, 0.0121412621811032, 0.0120978038758039, 0.0120544144883752, 0.0120110930874944, 0.0119678396731615, 0.0119245881214738, 0.011881472542882, 0.0118383569642901, 0.0117953093722463, 0.0117523306980729, 0.011709488928318, 0.0116665791720152, 0.0116238063201308, 0.0115810334682465, 0.0115383975207806, 0.0114957625046372, 0.0114531945437193, 0.0114106955006719, 0.0113682663068175, 0.0113259041681886, 0.0112835429608822, 0.0112412497401237, 0.0111990934237838, 0.0111570060253143, 0.0111149186268449, 0.0110728992149234, 0.011030881665647, 0.010988999158144, 0.0109471855685115, 0.0109053729102015, 0.0108636282384396, 0.0108219515532255, 0.010780343785882, 0.010738804936409, 0.010697266086936, 0.0106558641418815, 0.0106145311146975, 0.0105731971561909, 0.0105319321155548, 0.0104907359927893, 0.0104495398700237, 0.0104085486382246, 0.0103674894198775, 0.0103265680372715, 0.0102856457233429, 0.0102447913959622, 0.0102040758356452, 0.0101632904261351, 0.0101226419210434, 0.0100820632651448, 0.0100414147600532, 0.0100009730085731, 0.00996059831231833, 0.00992022547870874, 0.00987991970032454, 0.00983968377113342, 0.00979944691061974, 0.00975934695452452, 0.00971924792975187, 0.00967921689152718, 0.00963925383985043, 0.0095993597060442, 0.00955953449010849, 0.00951977726072073, 0.00948008894920349, 0.00944040156900883, 0.00940085016191006, 0.00936122983694077, 0.00932181626558304, 0.00928233284503222, 0.00924305617809296, 0.00920371059328318, 0.00916450284421444, 0.00912529416382313, 0.00908615346997976, 0.00904715154320002, 0.00900807976722717, 0.0089691448956728, 0.00893027987331152, 0.00889141391962767, 0.00885268580168486, 0.00881395675241947, 0.00877529662102461, 0.00873670447617769, 0.00869811419397593, 0.00865965895354748, 0.00862127263098955, 0.0085828872397542, 0.00854463875293732, 0.00850638933479786, 0.00846827775239944, 0.00843009725213051, 0.00839205365628004, 0.00835401099175215, 0.00831617321819067, 0.0082781994715333, 0.00824042968451977, 0.00820266082882881, 0.0081649599596858, 0.00812732800841331, 0.00808969605714083, 0.00805220194160938, 0.00801477581262589, 0.00797727983444929, 0.00793999154120684, 0.00790270231664181, 0.00786541309207678, 0.00782826077193022, 0.00779117783531547, 0.00775409396737814, 0.00771714700385928, 0.00768013205379248, 0.00764332292601466, 0.00760651333257556, 0.00756977312266827, 0.0075330319814384, 0.00749635929241776, 0.00745982490479946, 0.00742335803806782, 0.00738682271912694, 0.00735049368813634, 0.00731409480795264, 0.00727783376350999, 0.00724164163693786, 0.00720544951036572, 0.00716932537034154, 0.00713327014818788, 0.00709728291258216, 0.00706136552616954, 0.00702544674277306, 0.00698966532945633, 0.00695395283401012, 0.00691824080422521, 0.00688259582966566, 0.00684708915650845, 0.006811514031142, 0.00677607534453273, 0.00674070511013269, 0.00670533534139395, 0.00667010247707367, 0.00663480116054416, 0.00659970566630363, 0.00656461017206311, 0.00652958313003182, 0.00649455562233925, 0.00645966595038772, 0.00642477534711361, 0.00639002257958055, 0.00635526981204748, 0.00632058503106236, 0.00628596963360906, 0.00625135377049446, 0.00621687481179833, 0.00618239585310221, 0.00614805426448584, 0.00611364422366023, 0.00607943907380104, 0.00604523485526443, 0.00601103017106652, 0.00597696285694838, 0.00594296352937818, 0.00590896466746926, 0.00587503425776958, 0.00584117230027914, 0.00580737926065922, 0.00577372312545776, 0.00573999807238579, 0.00570641038939357, 0.00567282270640135, 0.00563930394127965, 0.0056058531627059, 0.00557247083634138, 0.00553915742784739, 0.00550591247156262, 0.0054727359674871, 0.00543955992907286, 0.00540645187720656, 0.00537341274321079, 0.00534044159576297, 0.00530753936618567, 0.0052747055888176, 0.00524194072932005, 0.00520917540416121, 0.0051764789968729, 0.00514391949400306, 0.00511135999113321, 0.00507886940613389, 0.00504644680768251, 0.00501409266144037, 0.00498173898085952, 0.0049494537524879, 0.00491723697632551, 0.00488515757024288, 0.00485300878062844, 0.00482099782675505, 0.00478912377730012, 0.00475718127563596, 0.00472530769184232, 0.00469357008114457, 0.0046618334017694, 0.00463009625673294, 0.00459856539964676, 0.004567033611238, 0.00453550275415182, 0.00450410833582282, 0.00447271438315511, 0.00444138841703534, 0.00441006291657686, 0.00437901169061661, 0.00434782262891531, 0.00431670295074582, 0.00428571971133351, 0.00425480538979173, 0.00422382261604071, 0.00419311411678791, 0.00416226824745536, 0.00413149036467075, 0.00410098768770695, 0.00407027918845415, 0.00403970712795854, 0.00400920398533344, 0.00397883821278811, 0.00394847197458148, 0.00391810620203614, 0.00388794601894915, 0.00385771668516099, 0.00382755673490465, 0.00379760167561471, 0.00376750994473696, 0.00373755535110831, 0.00370773742906749, 0.0036779202055186, 0.00364810228347778, 0.00361842173151672, 0.00358874117955565, 0.00355912907980382, 0.00352958566509187, 0.00350017938762903, 0.00347070442512631, 0.00344129791483283, 0.00341209722682834, 0.00338282808661461, 0.00335362739861012, 0.00332456384785473, 0.00329550006426871, 0.00326643651351333, 0.00323757855221629, 0.00320865213871002, 0.00317979394458234, 0.00315093598328531, 0.00312242074869573, 0.00309363123960793, 0.00306504755280912, 0.00303660100325942, 0.0030080855358392, 0.00297963875345886, 0.00295139779336751, 0.00292301969602704, 0.00289477850310504, 0.00286674313247204, 0.00283857062458992, 0.00281046656891704, 0.00278243119828403, 0.00275453273206949, 0.0027266344986856, 0.00269880471751094, 0.00267111207358539, 0.0026434191968292, 0.0026157267857343, 0.00258823949843645, 0.00256061553955078, 0.00253312825225294, 0.00250584678724408, 0.00247842841781676, 0.0024511469528079, 0.00242400262504816, 0.00239678961224854, 0.0023696452844888, 0.00234250095672905, 0.00231563090346754, 0.00228869216516614, 0.00226175342686474, 0.00223502051085234, 0.00220828736200929, 0.00218155421316624, 0.00215495843440294, 0.00212829397059977, 0.00210176664404571, 0.00207544467411935, 0.00204898579977453, 0.00202259561046958, 0.00199627387337387, 0.00197015749290586, 0.00194397300947458, 0.00191778806038201, 0.00189187785144895, 0.0018658300396055, 0.00183985102921724, 0.00181407760828733, 0.00178823573514819, 0.00176246231421828, 0.00173682591412216, 0.00171125819906592, 0.00168562191538513, 0.00166012276895344, 0.00163469207473099, 0.00160919281188399, 0.00158389925491065, 0.0015587427187711, 0.00153344916179776, 0.00150836119428277, 0.00148327322676778, 0.00145818525925279, 0.00143316586036235, 0.00140835216734558, 0.0013834013370797, 0.00135858752764761, 0.00133391085546464, 0.00130923418328166, 0.00128455751109868, 0.00126008654478937, 0.00123554700985551, 0.00121100747492164, 0.00118674198165536, 0.00116240803617984, 0.00113807420711964, 0.00111387728247792, 0.0010898174950853, 0.00106562068685889, 0.00104156089946628, 0.00101770681794733, 0.000993784167803824, 0.00096986151766032, 0.000946144515182823, 0.00092235894408077, 0.000898641883395612, 0.000875130586791784, 0.000851550605148077, 0.000827970681712031, 0.000804527837317437, 0.000781222130171955, 0.000757847854401916, 0.000734542089048773, 0.000711441971361637, 0.000688273343257606, 0.00066517322557047, 0.000642210245132446, 0.000619178696069866, 0.000596284167841077, 0.00057352683506906, 0.000550700933672488, 0.00052794354269281, 0.000505323288962245, 0.00048270303523168, 0.000460151262814179, 0.000437599548604339, 0.000415253452956676, 0.000392838817788288, 0.000370492722140625, 0.000348283705534413, 0.000326074718032032, 0.000303865730529651, 0.000281930930214003, 0.000259858992649242, 0.000237855652812868, 0.000216057931538671, 0.000194123102119192, 0.000172325380844995, 0.000150596213643439, 0.000129004125483334, 0.000107343490526546, 8.57514096423984e-05, 6.43649691483006e-05, 4.29099782195408e-05, 2.15235359064536e-05, 2.74185168791519e-07, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794, 0.00679350551217794   }, 
   { 0.0494658648967743, 0.0493331141769886, 0.0492010451853275, 0.0490686371922493, 0.0489368177950382, 0.0488045811653137, 0.0486727654933929, 0.0485412068665028, 0.0484096445143223, 0.0482780002057552, 0.0481467805802822, 0.0480156466364861, 0.047884427011013, 0.0477537997066975, 0.047622837126255, 0.0474922135472298, 0.0473617538809776, 0.0472314730286598, 0.0471012741327286, 0.0469712428748608, 0.0468410402536392, 0.0467116087675095, 0.0465816631913185, 0.0464521422982216, 0.0463227927684784, 0.0461934432387352, 0.0460640899837017, 0.0459354221820831, 0.0458063296973705, 0.045677911490202, 0.0455490723252296, 0.0454205721616745, 0.0452924109995365, 0.045164167881012, 0.0450358353555202, 0.04490827023983, 0.0447801984846592, 0.0446522906422615, 0.0445250645279884, 0.0443974994122982, 0.0442701913416386, 0.0441432185471058, 0.0440161637961864, 0.043889444321394, 0.0437626466155052, 0.0436358451843262, 0.0435097254812717, 0.0433830916881561, 0.043256975710392, 0.043131023645401, 0.0430050753057003, 0.0428790375590324, 0.0427537672221661, 0.0426279865205288, 0.0425028875470161, 0.042377445846796, 0.0422522611916065, 0.0421274118125439, 0.0420025698840618, 0.0418776385486126, 0.0417533852159977, 0.0416287109255791, 0.0415043719112873, 0.0413803793489933, 0.0412560440599918, 0.0411321297287941, 0.0410084761679173, 0.0408848188817501, 0.0407614223659039, 0.040638018399477, 0.0405146144330502, 0.0403918139636517, 0.0402686670422554, 0.0401457734405994, 0.0400231406092644, 0.0399005860090256, 0.0397778637707233, 0.0396559983491898, 0.0395335294306278, 0.0394119136035442, 0.0392896980047226, 0.0391680002212524, 0.0390464700758457, 0.0389249362051487, 0.0388034023344517, 0.038682471960783, 0.0385611951351166, 0.0384401716291904, 0.0383194908499718, 0.0381988100707531, 0.0380783826112747, 0.037957701832056, 0.0378374457359314, 0.0377173572778702, 0.0375973582267761, 0.0374772697687149, 0.0373577773571014, 0.0372380316257477, 0.0371184535324574, 0.0369993038475513, 0.0368800684809685, 0.0367607474327087, 0.0366421043872833, 0.0365230366587639, 0.0364047363400459, 0.0362859219312668, 0.0361676216125488, 0.0360494032502174, 0.0359312705695629, 0.0358130596578121, 0.0356955230236053, 0.0355775579810143, 0.0354599356651306, 0.0353425703942776, 0.0352252013981342, 0.0351081751286983, 0.0349910631775856, 0.0348739512264729, 0.0347572639584541, 0.0346405766904354, 0.0345238037407398, 0.0344077982008457, 0.0342912822961807, 0.0341751053929329, 0.0340592674911022, 0.0339434295892715, 0.0338275097310543, 0.0337121821939945, 0.0335965976119041, 0.033481527119875, 0.0333661995828152, 0.0332511253654957, 0.0331363081932068, 0.0330214910209179, 0.0329065918922424, 0.0327924527227879, 0.0326778888702393, 0.0325636677443981, 0.0324496142566204, 0.0323356501758099, 0.0322219356894493, 0.0321080535650253, 0.0319944247603416, 0.0318813063204288, 0.0317677669227123, 0.0316545628011227, 0.0315416976809502, 0.0314285829663277, 0.0313158072531223, 0.031203281134367, 0.0310907606035471, 0.03097815066576, 0.0308662243187428, 0.0307539571076632, 0.0306422840803862, 0.030530272051692, 0.0304185971617699, 0.0303071811795235, 0.0301956776529551, 0.0300842598080635, 0.0299733523279428, 0.0298621878027916, 0.0297512803226709, 0.0296406280249357, 0.0295299757272005, 0.0294195767492056, 0.0293092634528875, 0.0291987806558609, 0.0290890634059906, 0.0289789196103811, 0.0288688614964485, 0.0287594832479954, 0.0286499354988337, 0.0285403877496719, 0.0284311790019274, 0.0283220559358597, 0.0282127615064383, 0.0281043201684952, 0.0279952809214592, 0.0278870929032564, 0.0277783088386059, 0.0276699513196945, 0.0275619346648455, 0.0274538304656744, 0.0273457262665033, 0.02723821811378, 0.0271303690969944, 0.0270227752625942, 0.0269155222922564, 0.0268082693219185, 0.0267012696713209, 0.0265942718833685, 0.0264871884137392, 0.0263807848095894, 0.0262739565223455, 0.0261675529181957, 0.0260613188147545, 0.0259549152106047, 0.0258488524705172, 0.0257430430501699, 0.0256372354924679, 0.025531342253089, 0.0254262126982212, 0.0253205727785826, 0.0252156984061003, 0.0251103155314922, 0.0250053573399782, 0.0249006543308496, 0.0247959494590759, 0.0246910750865936, 0.0245870519429445, 0.0244825184345245, 0.02437824010849, 0.0242743846029043, 0.0241704452782869, 0.0240668468177319, 0.0239631626754999, 0.023859478533268, 0.0237563904374838, 0.0236529596149921, 0.023549871519208, 0.0234469529241323, 0.0233442019671202, 0.0232412852346897, 0.0231388732790947, 0.0230363812297583, 0.0229342263191938, 0.0228320714086294, 0.0227298326790333, 0.0226282738149166, 0.0225262884050608, 0.0224246457219124, 0.0223232544958591, 0.0222219508141279, 0.022120475769043, 0.0220197681337595, 0.02191854827106, 0.0218177530914545, 0.0217172149568796, 0.0216166730970144, 0.0215163063257933, 0.0214160196483135, 0.0213156510144472, 0.0212159622460604, 0.0211159326136112, 0.0210161563009024, 0.0209167208522558, 0.0208172034472227, 0.0207176823168993, 0.0206187572330236, 0.020519407466054, 0.0204206518828869, 0.0203218143433332, 0.0202229749411345, 0.0201247297227383, 0.0200261436402798, 0.0199278984218836, 0.0198299083858728, 0.0197318345308304, 0.0196338463574648, 0.0195363648235798, 0.0194385461509228, 0.0193411502987146, 0.0192439258098602, 0.0191466994583607, 0.0190497301518917, 0.0189528446644545, 0.0188558753579855, 0.018759585916996, 0.0186627842485905, 0.0185664109885693, 0.018470287322998, 0.0183740835636854, 0.0182779636234045, 0.0181824378669262, 0.0180864874273539, 0.0179912187159061, 0.0178956091403961, 0.0178000833839178, 0.0177051518112421, 0.0176099669188261, 0.0175150372087955, 0.0174203608185053, 0.0173257701098919, 0.0172310099005699, 0.0171370152384043, 0.0170425940304995, 0.0169484298676252, 0.016854602843523, 0.016760777682066, 0.0166671220213175, 0.0165736358612776, 0.0164798963814974, 0.0163870044052601, 0.0162936057895422, 0.0162005443125963, 0.0161078236997128, 0.0160150174051523, 0.0159222111105919, 0.0158300008624792, 0.0157374497503042, 0.0156455785036087, 0.0155532835051417, 0.0154613275080919, 0.0153696266934276, 0.0152776706963778, 0.0151861403137445, 0.0150948641821742, 0.0150035880506039, 0.0149122271686792, 0.0148214614018798, 0.0147304404526949, 0.0146396746858954, 0.0145491631701589, 0.0144586525857449, 0.014368481002748, 0.0142782246693969, 0.0141879692673683, 0.0140983927994967, 0.0140083068981767, 0.0139186456799507, 0.0138292396441102, 0.0137398326769471, 0.0136503409594297, 0.0135616157203913, 0.0134723791852593, 0.0133838225156069, 0.013294842094183, 0.0132062854245305, 0.0131178982555866, 0.0130295967683196, 0.0129412114620209, 0.0128534194082022, 0.0127653731033206, 0.012677326798439, 0.0125900451093912, 0.0125022539868951, 0.0124152274802327, 0.0123277753591537, 0.0122405793517828, 0.012153722345829, 0.0120668662711978, 0.011980009265244, 0.0118936626240611, 0.0118070608004928, 0.0117207141593099, 0.0116347074508667, 0.0115486159920692, 0.0114624388515949, 0.0113770272582769, 0.0112911909818649, 0.0112060327082872, 0.0111204516142607, 0.0110352095216513, 0.0109502226114273, 0.0108652357012033, 0.0107801640406251, 0.0106956018134952, 0.0106110405176878, 0.0105265630409122, 0.0104424264281988, 0.0103580337017775, 0.0102743217721581, 0.0101901851594448, 0.0101064732298255, 0.0100229308009148, 0.00993947312235832, 0.00985584687441587, 0.00977298431098461, 0.00968969706445932, 0.00960666500031948, 0.00952405761927366, 0.00944128073751926, 0.00935858767479658, 0.00927649065852165, 0.00919396802783012, 0.00911212619394064, 0.00902985874563456, 0.00894801691174507, 0.00886642839759588, 0.00878475606441498, 0.00870308373123407, 0.00862209126353264, 0.00854067411273718, 0.0084594264626503, 0.0083787739276886, 0.00829778145998716, 0.00821738410741091, 0.00813664682209492, 0.00805624853819609, 0.00797610636800528, 0.00789596326649189, 0.00781573541462421, 0.00773618789389729, 0.00765621522441506, 0.00757666770368814, 0.00749728968366981, 0.00741791212931275, 0.0073385345749557, 0.00725983642041683, 0.00718071358278394, 0.00710218539461493, 0.00702340295538306, 0.00694479001685977, 0.0068666017614305, 0.00678824447095394, 0.0067099709995091, 0.00663229310885072, 0.00655419006943703, 0.00647651217877865, 0.00639900378882885, 0.00632141111418605, 0.00624441308900714, 0.00616698991507292, 0.00608990667387843, 0.00601316336542368, 0.00593633530661464, 0.0058595072478056, 0.00578335905447602, 0.00570670049637556, 0.0056304675526917, 0.00555448886007071, 0.00547851109877229, 0.005402447655797, 0.00532714929431677, 0.00525134056806564, 0.00517621217295527, 0.00510074384510517, 0.00502553069964051, 0.0049506570212543, 0.0048756985925138, 0.0048007401637733, 0.00472646206617355, 0.00465175788849592, 0.0045773945748806, 0.00450328644365072, 0.00442917738109827, 0.00435532396659255, 0.00428130012005568, 0.00420761667191982, 0.00413418794050813, 0.00406075920909643, 0.00398724572733045, 0.00391441211104393, 0.00384123809635639, 0.0037683192640543, 0.00369565561413765, 0.00362307671457529, 0.00355032808147371, 0.00347834406420588, 0.00340593513101339, 0.00333420629613101, 0.00326205254532397, 0.00319023849442601, 0.0031186796259135, 0.00304712052457035, 0.0029754766728729, 0.00290451245382428, 0.00283320853486657, 0.00276215956546366, 0.00269145029596984, 0.00262065604329109, 0.00255020195618272, 0.00247974810190499, 0.00240920879878104, 0.00233909441158175, 0.00226906524039805, 0.00219895108602941, 0.00212943181395531, 0.00205957260914147, 0.00199005333706737, 0.00192078913096339, 0.00185152469202876, 0.00178251543547958, 0.00171350606251508, 0.00164441158995032, 0.00157608208246529, 0.00150724279228598, 0.00143882830161601, 0.00137058377731591, 0.00130242423620075, 0.00123417982831597, 0.00116661516949534, 0.00109854084439576, 0.00103131611831486, 0.000963581493124366, 0.000896101933903992, 0.000829047290608287, 0.000761907605919987, 0.000694767979439348, 0.000628223177045584, 0.000561338500119746, 0.000494708772748709, 0.000428418978117406, 0.000361874233931303, 0.000295669451588765, 0.000229804601985961, 0.000163854754646309, 9.82448618742637e-05, 3.26349727401976e-05, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 8.48893455122944e-15, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 0.001661152462475, 1.52976426761597e-05, 8.09925186331384e-05, 0.000146772392326966, 0.000212467261007987, 0.000278502091532573, 0.000344706873875111, 0.000410826702136546, 0.000477286463137716, 0.00054383126553148, 0.00061054591787979, 0.000677260628435761, 0.000744230346754193, 0.000811369973234832, 0.000878594582900405, 0.000945819308981299, 0.00101338385138661, 0.00108103337697685, 0.00114859803579748, 0.00121650251094252, 0.00128457706887275, 0.00135282147675753, 0.00142089603468776, 0.00148931052535772, 0.00155789498239756, 0.00162647943943739, 0.00168401526752859, 0.00173050304874778, 0.00177728838752955, 0.00182398862671107, 0.00187094381544739, 0.0019181965617463, 0.0019656193908304, 0.00201316946186125, 0.00206097448244691, 0.00210886471904814, 0.00215679733082652, 0.00220511225052178, 0.00225363974459469, 0.00230216723866761, 0.00235099229030311, 0.00239994493313134, 0.00244919466786087, 0.00249852961860597, 0.00254803453572094, 0.00259766657836735, 0.00264763925224543, 0.00269778142683208, 0.00274779624305665, 0.00279827858321369, 0.00284884544089437, 0.00289962533861399, 0.00295070256106555, 0.0030019071418792, 0.00305298413150012, 0.00310457102023065, 0.00315632834099233, 0.00320804282091558, 0.00326001225039363, 0.00331240659579635, 0.00336475856602192, 0.0034173228777945, 0.00347014237195253, 0.00352287688292563, 0.00357607868500054, 0.00362945045344532, 0.00368282222189009, 0.00373649108223617, 0.00379028799943626, 0.00384438200853765, 0.00389856146648526, 0.00395303778350353, 0.00400738697499037, 0.00406211847439408, 0.00411710515618324, 0.00417217658832669, 0.00422729039564729, 0.00428278697654605, 0.00433849589899182, 0.00439424719661474, 0.00445021083578467, 0.0045063872821629, 0.00456264894455671, 0.00461920769885182, 0.0046759364195168, 0.0047327927313745, 0.00478977616876364, 0.00484709953889251, 0.00490455143153667, 0.00496217235922813, 0.00501975137740374, 0.00507775461301208, 0.00513592781499028, 0.00519431382417679, 0.00525286979973316, 0.00531138340011239, 0.00537032214924693, 0.00542930234223604, 0.00548853864893317, 0.00554785970598459, 0.00560747785493731, 0.00566709600389004, 0.00572709646075964, 0.00578722497448325, 0.00584743823856115, 0.00590786384418607, 0.00596867222338915, 0.00602952297776937, 0.00609028851613402, 0.00615152111276984, 0.0062129246070981, 0.00627441238611937, 0.00633619772270322, 0.00639806780964136, 0.00646015116944909, 0.00652240449562669, 0.00658491207286716, 0.00664737727493048, 0.00671014003455639, 0.00677315797656775, 0.00683634588494897, 0.00689978851005435, 0.0069631040096283, 0.00702680135145783, 0.00709075341001153, 0.00715496111661196, 0.00721895648166537, 0.00728337652981281, 0.00734805129468441, 0.00741285411641002, 0.00747774168848991, 0.00754279876127839, 0.00760819669812918, 0.00767355132848024, 0.00773937441408634, 0.00780506851151586, 0.00787101779133081, 0.00793730840086937, 0.00800381042063236, 0.00807039812207222, 0.00813694205135107, 0.00820391252636909, 0.00827105157077312, 0.00833840388804674, 0.00840567145496607, 0.00847340561449528, 0.00854122452437878, 0.008609214797616, 0.00867750123143196, 0.00874566100537777, 0.0088142454624176, 0.0088829156011343, 0.00895192474126816, 0.00902089104056358, 0.00909015536308289, 0.00915959011763334, 0.00922927912324667, 0.00929913856089115, 0.00936878565698862, 0.00943911168724298, 0.00950948148965836, 0.00957997795194387, 0.00965064484626055, 0.0097214812412858, 0.00979265663772821, 0.00986379198729992, 0.00993522256612778, 0.0100067388266325, 0.0100785102695227, 0.0101504093036056, 0.0102225635200739, 0.0102949291467667, 0.0103672118857503, 0.0104400021955371, 0.0105128362774849, 0.0105859255418181, 0.010658971965313, 0.0107323573902249, 0.0108059560880065, 0.0108797242864966, 0.0109536638483405, 0.0110276434570551, 0.0111019229516387, 0.0111764129251242, 0.0112511180341244, 0.011325778439641, 0.0114007797092199, 0.0114759504795074, 0.0115513326600194, 0.0116268871352077, 0.0117023978382349, 0.0117784179747105, 0.011854438111186, 0.0119308428838849, 0.0120070762932301, 0.0120837772265077, 0.012160561978817, 0.01223751809448, 0.0123147703707218, 0.0123918959870934, 0.0124694472178817, 0.0125471670180559, 0.0126251429319382, 0.0127029912546277, 0.0127812214195728, 0.0128596220165491, 0.0129382777959108, 0.0130170602351427, 0.0130957569926977, 0.0131749650463462, 0.0132543435320258, 0.0133338067680597, 0.0134133119136095, 0.0134932417422533, 0.0135732991620898, 0.0136533994227648, 0.0137338824570179, 0.0138142788782716, 0.0138951018452644, 0.0139759667217731, 0.0140571724623442, 0.014138420112431, 0.0142197096720338, 0.0143014239147305, 0.0143832238391042, 0.0144652798771858, 0.014547461643815, 0.0146296434104443, 0.0147122517228127, 0.0147949857637286, 0.014877762645483, 0.014960965141654, 0.0150440810248256, 0.0151275396347046, 0.0152112087234855, 0.0152950063347816, 0.0153788886964321, 0.0154628967866302, 0.0155472466722131, 0.015631852671504, 0.0157164558768272, 0.0158011876046658, 0.0158863868564367, 0.0159716289490461, 0.0160569567233324, 0.0161424949765205, 0.0162282474339008, 0.0163141246885061, 0.0164003446698189, 0.0164866484701633, 0.0165729969739914, 0.0166596826165915, 0.0167465824633837, 0.0168335661292076, 0.0169207211583853, 0.0170080028474331, 0.0170956235378981, 0.0171833727508783, 0.0172712914645672, 0.0173591692000628, 0.0174475535750389, 0.0175361111760139, 0.0176246259361506, 0.0177133083343506, 0.0178023744374514, 0.0178913976997137, 0.0179808884859085, 0.0180704221129417, 0.0181600414216518, 0.018249873071909, 0.0183399599045515, 0.0184303428977728, 0.0185204707086086, 0.0186111945658922, 0.018702045083046, 0.0187929812818766, 0.0188841298222542, 0.0189753640443087, 0.0190668106079102, 0.0191585104912519, 0.0192503817379475, 0.0193423368036747, 0.0194345489144325, 0.0195269715040922, 0.0196195226162672, 0.0197123698890209, 0.0198052171617746, 0.0198982357978821, 0.0199915505945683, 0.020085122436285, 0.0201786495745182, 0.0202724747359753, 0.0203665550798178, 0.020460806787014, 0.0205550137907267, 0.0206495188176632, 0.0207443237304688, 0.0208391696214676, 0.0209342688322067, 0.0210296232253313, 0.0211248528212309, 0.0212205033749342, 0.0213164128363132, 0.0214123632758856, 0.0215084385126829, 0.021604772657156, 0.0217012763023376, 0.0217979904264212, 0.0218948759138584, 0.0219917185604572, 0.0220891125500202, 0.0221865940839052, 0.0222841985523701, 0.0223818086087704, 0.0224797986447811, 0.0225779134780169, 0.0226762443780899, 0.0227747038006783, 0.0228732842952013, 0.022972084581852, 0.0230712201446295, 0.023170530796051, 0.023269709199667, 0.0233692713081837, 0.0234691314399242, 0.0235689897090197, 0.0236691478639841, 0.0237693022936583, 0.0238697584718466, 0.0239705108106136, 0.0240713488310575, 0.0241722241044044, 0.0242734458297491, 0.024374708533287, 0.0244763102382421, 0.0245780814439058, 0.0246798973530531, 0.0247819647192955, 0.0248841624706984, 0.0249866992235184, 0.0250892341136932, 0.0251919850707054, 0.0252950303256512, 0.0253982469439507, 0.0255014225840569, 0.0256048925220966, 0.025708619505167, 0.0258124750107527, 0.0259165409952402, 0.026020860299468, 0.0261251423507929, 0.0262296721339226, 0.0263345055282116, 0.026439506560564, 0.0265445075929165, 0.0266498066484928, 0.0267553608864546, 0.0268609579652548, 0.0269668083637953, 0.0270728301256895, 0.0271789766848087, 0.0272854249924421, 0.0273919980973005, 0.0274985712021589, 0.0276056099683046, 0.0277127809822559, 0.0278199072927237, 0.0279274582862854, 0.0280350092798471, 0.0281429011374712, 0.028250789269805, 0.0283590629696846, 0.0284673366695642, 0.028575737029314, 0.0286845210939646, 0.0287934336811304, 0.0289024692028761, 0.0290118064731359, 0.0291210152208805, 0.0292307734489441, 0.029340535402298, 0.0294503811746836, 0.0295605678111315, 0.0296709220856428, 0.0297814905643463, 0.0298920981585979, 0.030003048479557, 0.0301139149814844, 0.0302251614630222, 0.0303366649895906, 0.0304481685161591, 0.0305598843842745, 0.0306718125939369, 0.0307840369641781, 0.0308962613344193, 0.0310087855905294, 0.0311213489621878, 0.0312341712415218, 0.0313471183180809, 0.0314603187143803, 0.0315737761557102, 0.0316872783005238, 0.031800989061594, 0.0319150425493717, 0.0320290513336658, 0.0321431905031204, 0.0322576686739922, 0.0323723554611206, 0.0324870049953461, 0.032602034509182, 0.0327173173427582, 0.0328326858580112, 0.0329481847584248, 0.0330638512969017, 0.0331796482205391, 0.0332957804203033, 0.0334119163453579, 0.0335284322500229, 0.033645037561655, 0.0337617620825768, 0.0338787510991096, 0.0339959897100925, 0.0341133549809456, 0.0342305973172188, 0.034348301589489, 0.0344662219285965, 0.0345842242240906, 0.0347024016082287, 0.0348207876086235, 0.0349394716322422, 0.0350581519305706, 0.0351771339774132, 0.0352960303425789, 0.0354153998196125, 0.0355348475277424, 0.0356545485556126, 0.0357744656503201, 0.0358942970633507, 0.0360146425664425, 0.0361348986625671, 0.0362555347383022, 0.0363761335611343, 0.0364970266819, 0.0366182178258896, 0.0367394052445889, 0.0368608981370926, 0.0369824320077896, 0.0371042564511299, 0.0372262969613075, 0.037348423153162, 0.0374706760048866, 0.037593100219965, 0.0377158671617508, 0.0378388017416, 0.0379619039595127, 0.0380849614739418, 0.0382084064185619, 0.0383321456611156, 0.0384559333324432, 0.0385797172784805, 0.0387038812041283, 0.0388281717896461, 0.0389526374638081, 0.0390774384140968, 0.0392020717263222, 0.0393271744251251, 0.0394524037837982, 0.039577841758728, 0.0397032834589481, 0.0398290231823921, 0.0399549305438995, 0.0400811322033405, 0.0402074679732323, 0.0403337180614471, 0.040460430085659, 0.0405872762203217, 0.0407143272459507, 0.0408414267003536, 0.0409688651561737, 0.0410963892936707, 0.0412240400910378, 0.0413519851863384, 0.0414800196886063, 0.0416082628071308, 0.0417366810142994, 0.041865348815918, 0.0419941507279873, 0.0421230308711529, 0.0422522090375423, 0.0423815622925758, 0.042511124163866, 0.0426405966281891, 0.0427705012261868, 0.0429006144404411, 0.0430309027433395, 0.0431612320244312, 0.0432917252182961, 0.0434226505458355, 0.0435536131262779, 0.0436847507953644, 0.0438159294426441, 0.0439475290477276, 0.0440791286528111, 0.0442110300064087, 0.0443430133163929, 0.0444749966263771, 0.0446075350046158, 0.0447401143610477, 0.0448728688061237, 0.0450055710971355, 0.0451387874782085, 0.0452720895409584, 0.0454055182635784, 0.045539204031229, 0.0456728897988796, 0.0458069555461407, 0.0459411516785622, 0.0460756421089172, 0.0462099686264992, 0.0463446713984013, 0.0464796274900436, 0.0466147139668465, 0.0467500127851963, 0.0468853116035461, 0.0470209121704102, 0.0471567176282406, 0.0472928248345852, 0.0474287196993828, 0.047565121203661, 0.0477017425000668, 0.0478383153676987, 0.0479752719402313, 0.0481122247874737, 0.0482494384050369, 0.0483868233859539, 0.0485244579613209, 0.0486621335148811, 0.048800066113472, 0.0489382110536098, 0.0490766130387783, 0.0492151007056236, 0.0493535436689854, 0.0494924560189247, 0.0496314913034439, 0.0497707054018974, 0.0499101243913174, 0.0500495843589306, 0.0501893907785416, 0.0503293238580227, 0.0504693798720837, 0.0506095625460148, 0.0507500469684601, 0.0508905723690987, 0.0510315261781216, 0.051172561943531, 0.0513135567307472, 0.0514549724757671, 0.0515965148806572, 0.0517383217811584, 0.0518799051642418, 0.0520220883190632, 0.0521643571555614, 0.0523068383336067, 0.0524494051933289, 0.0525922700762749, 0.0527351722121239, 0.0528782494366169, 0.0530216619372368, 0.0531649924814701, 0.0533087030053139, 0.0534525886178017, 0.0535966418683529, 0.0537409074604511, 0.0538853034377098, 0.0540296956896782, 0.0541746392846107, 0.0543195828795433, 0.0544645264744759, 0.0546097680926323, 0.0547553971409798, 0.0549010187387466, 0.0550468154251575, 0.055192869156599, 0.0553390048444271, 0.0554853081703186, 0.0556320324540138, 0.0557785555720329, 0.0559254549443722, 0.0560725629329681, 0.0562199354171753, 0.0563673861324787, 0.0565149635076523, 0.0566626712679863, 0.0568106360733509, 0.0569588504731655, 0.0571071542799473, 0.0572556667029858, 0.0574044361710548, 0.0575532466173172, 0.0577023588120937, 0.0578516833484173, 0.0580009594559669, 0.0581505335867405, 0.0583003684878349, 0.0584502853453159, 0.0586003325879574, 0.0587507151067257, 0.0589012242853642, 0.0590519942343235, 0.0592027604579926, 0.0593537390232086, 0.0595049746334553, 0.0596563816070557, 0.0598079077899456, 0.0599596127867699, 0.0601116083562374, 0.0602636523544788, 0.0604160316288471, 0.0605685859918594, 0.0607210099697113, 0.0608738586306572, 0.0610268749296665, 0.0611801072955132, 0.0613334663212299, 0.0614869520068169, 0.0616407357156277, 0.0617946460843086, 0.0619487278163433, 0.062102809548378, 0.0622573606669903, 0.0624120756983757, 0.0625667497515678, 0.0627218559384346, 0.0628768280148506, 0.0630322694778442, 0.0631877928972244, 0.0633434951305389, 0.0634992718696594, 0.0636552646756172, 0.0638116002082825, 0.0639679804444313, 0.0641245245933533, 0.0642812326550484, 0.0644381642341614, 0.0645954310894012, 0.0647527873516083, 0.0649101883172989, 0.0650677904486656, 0.0652256533503532, 0.0653836876153946, 0.0655419304966927, 0.0657001808285713, 0.0658587664365768, 0.0660176426172256, 0.0661766156554222, 0.0663355439901352, 0.0664948895573616, 0.0666542872786522, 0.066814012825489, 0.0669738352298737, 0.0671336948871613, 0.0672939345240593, 0.0674543082714081, 0.0676148906350136, 0.0677755102515221, 0.0679364800453186, 0.0680974051356316, 0.0682587549090385, 0.0684202685952187, 0.0685816556215286, 0.0687434747815132, 0.0689055398106575, 0.069067656993866, 0.069229930639267, 0.0693924278020859, 0.0695551782846451, 0.069718062877655, 0.0698811113834381, 0.0700442343950272, 0.0702076703310013, 0.0703713521361351, 0.0705349966883659, 0.0706990659236908, 0.0708631351590157, 0.0710274130105972, 0.0711918994784355, 0.0713566914200783, 0.0715213939547539, 0.0716863200068474, 0.0718516111373901, 0.0720170438289642, 0.0721825510263443, 0.0723481029272079, 0.0725142508745193, 0.0726802796125412, 0.0728465542197227, 0.0730129256844521, 0.0731795355677605, 0.0733464509248734, 0.0735133960843086, 0.0736805722117424, 0.0738478675484657, 0.0740154311060905, 0.0741831883788109, 0.0743510723114014, 0.0745190605521202, 0.0746872872114182, 0.074855774641037, 0.075024425983429, 0.0751932188868523, 0.0753619521856308, 0.0755312070250511, 0.0757007151842117, 0.0758700519800186, 0.0760396867990494, 0.0762096121907234, 0.0763795897364616, 0.0765498578548431, 0.0767202973365784, 0.0768907368183136, 0.0770614370703697, 0.0772324353456497, 0.0774037316441536, 0.0775748863816261, 0.0777463540434837, 0.0779180601239204, 0.0780899003148079, 0.0782619193196297, 0.0784339755773544, 0.0786064118146896, 0.0787789300084114, 0.0789516717195511, 0.0791245400905609, 0.079297699034214, 0.0794709473848343, 0.0796443521976471, 0.079818069934845, 0.0799917876720428, 0.0801657140254974, 0.0803398862481117, 0.0805143341422081, 0.0806888937950134, 0.0808634459972382, 0.0810383930802345, 0.0812135115265846, 0.0813887119293213, 0.0815640017390251, 0.0817397087812424, 0.0819154679775238, 0.0820913836359978, 0.0822676047682762, 0.0824438706040382, 0.0826203376054764, 0.0827971175312996, 0.0829739794135094, 0.0831508338451385, 0.0833281129598618, 0.0835054889321327, 0.0836831480264664, 0.0838608592748642, 0.0840388163924217, 0.0842168629169464, 0.0843952521681786, 0.0845737606287003, 0.084752157330513, 0.0849310606718063, 0.0851102098822594, 0.0852893143892288, 0.0854687243700027, 0.0856483429670334, 0.0858278349041939, 0.086007833480835, 0.0861880481243134, 0.086368091404438, 0.0865484774112701, 0.0867292433977127, 0.0869099646806717, 0.0870909541845322, 0.0872721821069717, 0.0874533802270889, 0.0876349955797195, 0.0878167450428009, 0.0879984870553017, 0.0881805643439293, 0.0883627831935883, 0.0885452926158905, 0.0887279286980629, 0.088910736143589, 0.0890934988856316, 0.0892766416072845, 0.0894600078463554, 0.0896434858441353, 0.0898270979523659, 0.0900110155344009, 0.0901950970292091, 0.0903792232275009, 0.0905636921525002, 0.0907481536269188, 0.0909329131245613, 0.091117799282074, 0.0913029387593269, 0.0914882197976112, 0.0916735753417015, 0.0918592661619186, 0.0920452177524567, 0.0922312065958977, 0.0924172028899193, 0.0926036760210991, 0.0927902162075043, 0.0929770171642303, 0.0931637734174728, 0.0933508723974228, 0.0935381874442101, 0.0937255844473839, 0.0939132273197174, 0.0941009297966957, 0.0942889153957367, 0.0944770276546478, 0.0946654081344604, 0.0948540791869164, 0.0950426235795021, 0.0952315032482147, 0.0954205989837646, 0.0956099033355713, 0.0957990884780884, 0.0959886983036995, 0.0961785539984703, 0.0963684245944023, 0.0965586230158806, 0.0967487767338753, 0.0969393625855446, 0.0971299856901169, 0.0973209515213966, 0.0975118279457092, 0.0977030918002129, 0.0978944003582001, 0.0980859994888306, 0.0982777699828148, 0.0984695926308632, 0.0986617058515549, 0.0988540723919868, 0.0990466549992561, 0.0992390587925911, 0.0994319394230843, 0.0996249914169312, 0.0998180732131004, 0.100011512637138, 0.100204944610596, 0.100398659706116, 0.100592561066151, 0.100786723196507, 0.100980915129185, 0.101175233721733, 0.101369895040989, 0.101564772427082, 0.101759724318981, 0.101954683661461, 0.102150030434132, 0.102345541119576, 0.102541446685791, 0.102737165987492, 0.102933190762997, 0.103129506111145, 0.103325866162777, 0.103522442281246, 0.103719107806683, 0.103916108608246, 0.104113146662712, 0.104310527443886, 0.104507997632027, 0.104705676436424, 0.104903481900692, 0.1051015406847, 0.105299860239029, 0.105497971177101, 0.105696581304073, 0.105895400047302, 0.106094315648079, 0.106293402612209, 0.106492653489113, 0.106692157685757, 0.106891661882401, 0.107091598212719, 0.107291407883167, 0.107491627335548, 0.107691943645477, 0.107892476022243, 0.108093246817589, 0.108293987810612, 0.108495198190212, 0.108696445822716, 0.108897991478443, 0.109099321067333, 0.109301127493382, 0.109503224492073, 0.109705276787281, 0.109907679259777, 0.110110081732273, 0.110312767326832, 0.110515721142292, 0.110718749463558, 0.110921867191792, 0.111125282943249, 0.111328832805157, 0.111532717943192, 0.111736640334129, 0.111940525472164, 0.112144827842712, 0.112349517643452, 0.112554162740707, 0.112758859992027, 0.112963855266571, 0.113169133663177, 0.113374464213848, 0.113580100238323, 0.11378563195467, 0.113991603255272, 0.114197686314583, 0.114404045045376, 0.114610388875008, 0.114817038178444, 0.115023799240589, 0.115230828523636, 0.115438118577003, 0.115645192563534, 0.115852765738964, 0.116060599684715, 0.11626847833395, 0.116476438939571, 0.116684705018997, 0.116893224418163, 0.117101691663265, 0.117310583591461, 0.117519356310368, 0.117728546261787, 0.117937788367271, 0.118147417902946, 0.11835703253746, 0.118566773831844, 0.118776910007, 0.118987120687962, 0.119197636842728, 0.11940798163414, 0.119618706405163, 0.119829766452312, 0.120040878653526, 0.120252147316933, 0.120463691651821, 0.120675310492516, 0.120887137949467, 0.121099084615707, 0.121311388909817, 0.121523641049862, 0.121736116707325, 0.121948927640915, 0.122161895036697, 0.12237486988306, 0.122588112950325, 0.122801639139652, 0.123015254735947, 0.123229078948498, 0.123442865908146, 0.123657070100307, 0.123871363699436, 0.124086007475853, 0.124300673604012, 0.124515391886234, 0.124730587005615, 0.124945893883705, 0.12516126036644, 0.125376775860786, 0.125592559576035, 0.125808477401733, 0.126024723052979, 0.126241013407707, 0.126457303762436, 0.126674070954323, 0.126891031861305, 0.127108037471771, 0.127325102686882, 0.127542585134506, 0.127760022878647, 0.127977892756462, 0.128195881843567, 0.128413781523705, 0.128632038831711, 0.128850564360619, 0.129069417715073, 0.129287958145142, 0.129506975412369, 0.129726231098175, 0.129945635795593, 0.130165114998817, 0.130384713411331, 0.130604669451714, 0.130824819207191, 0.131045013666153, 0.131265431642532, 0.131486058235168, 0.131706863641739, 0.131927862763405, 0.132149040699005, 0.132370308041573, 0.132591784000397, 0.132813468575478, 0.133035451173782, 0.133257403969765, 0.133479595184326, 0.133702099323273, 0.133924722671509, 0.134147435426712, 0.134370297193527, 0.134593486785889, 0.134816735982895, 0.13504022359848, 0.135263934731483, 0.135487675666809, 0.135711744427681, 0.135935977101326, 0.136160418391228, 0.136384829878807, 0.13660953938961, 0.136834502220154, 0.13705962896347, 0.137284874916077, 0.137510150671005, 0.137765720486641, 0.138051226735115, 0.138336926698685, 0.138622507452965, 0.138908445835114, 0.139194518327713, 0.139480799436569, 0.139767199754715, 0.140053734183311, 0.140340402722359, 0.140627264976501, 0.140914261341095, 0.141201362013817, 0.141488641500473, 0.141776084899902, 0.142063677310944, 0.142351388931274, 0.142639294266701, 0.142927229404449, 0.143215447664261, 0.143503919243813, 0.143792390823364, 0.144080951809883, 0.144369825720787, 0.144658744335175, 0.144947797060013, 0.145236954092979, 0.145526379346848, 0.145815789699554, 0.146105647087097, 0.146395459771156, 0.146685391664505, 0.146975666284561, 0.147265940904617, 0.147556260228157, 0.147846817970276, 0.148137658834457, 0.148428410291672, 0.14871945977211, 0.149010717868805, 0.149302080273628, 0.149593517184258, 0.149885132908821, 0.150176987051964, 0.15046888589859, 0.150760978460312, 0.151053071022034, 0.15134559571743, 0.151638031005859, 0.151930764317513, 0.152223646640778, 0.152516633272171, 0.152809768915176, 0.153102993965149, 0.153396546840668, 0.153690084815025, 0.153983801603317, 0.154277607798576, 0.154571697115898, 0.154866009950638, 0.155160263180733, 0.155454754829407, 0.155749350786209, 0.156044185161591, 0.156339094042778, 0.156634166836739, 0.156929314136505, 0.157224699854851, 0.157520279288292, 0.157815992832184, 0.158111825585365, 0.158407792448997, 0.158703938126564, 0.159000247716904, 0.159296646714211, 0.159593194723129, 0.159889921545982, 0.160186871886253, 0.160483941435814, 0.160781130194664, 0.161078542470932, 0.161375969648361, 0.161673530936241, 0.161971345543861, 0.162269204854965, 0.162567287683487, 0.162865653634071, 0.163163915276527, 0.163462519645691, 0.163761287927628, 0.164060100913048, 0.164359003305435, 0.164658144116402, 0.164957404136658, 0.165256813168526, 0.165556475520134, 0.165856182575226, 0.166156008839607, 0.166456162929535, 0.166756361722946, 0.167056635022163, 0.167357116937637, 0.167657762765884, 0.167958498001099, 0.168259426951408, 0.168560594320297, 0.16886168718338, 0.169163167476654, 0.169464752078056, 0.169766426086426, 0.170068174600601, 0.170370176434517, 0.170672431588173, 0.170974686741829, 0.171277105808258, 0.171579658985138, 0.171882405877113, 0.172185182571411, 0.172488316893578, 0.172791495919228, 0.173094809055328, 0.173398375511169, 0.17370194196701, 0.174005746841431, 0.174309656023979, 0.174613758921623, 0.174917936325073, 0.175222456455231, 0.175526916980743, 0.175831541419029, 0.1761364787817, 0.176441505551338, 0.176746547222137, 0.177051827311516, 0.177357316017151, 0.17766273021698, 0.177968546748161, 0.178274527192116, 0.178580537438393, 0.178886786103249, 0.179193079471588, 0.179499506950378, 0.179806172847748, 0.180112972855568, 0.180419847369194, 0.18072697520256, 0.181034192442894, 0.181341543793678, 0.181649193167686, 0.181956857442856, 0.182264626026154, 0.182572618126869, 0.182880833745003, 0.183189079165459, 0.183497443795204, 0.183805987238884, 0.184114784002304, 0.184423759579659, 0.184732779860497, 0.185041919350624, 0.185351267457008, 0.185660734772682, 0.185970440506935, 0.18628017604351, 0.18659009039402, 0.186900153756142, 0.187210395932198, 0.187520861625671, 0.187831357121468, 0.188142061233521, 0.188452899456024, 0.188763871788979, 0.189074978232384, 0.189386233687401, 0.189697667956352, 0.190009266138077, 0.19032110273838, 0.190632939338684, 0.190945014357567, 0.191257134079933, 0.191569447517395, 0.191881909966469, 0.192194536328316, 0.192507341504097, 0.192820340394974, 0.193133443593979, 0.193446606397629, 0.19376003742218, 0.194073602557182, 0.194387301802635, 0.194701105356216, 0.195015043020248, 0.195329144597054, 0.19564351439476, 0.195957884192467, 0.19627246260643, 0.196587339043617, 0.196902140974998, 0.197217226028442, 0.19753235578537, 0.19784764945507, 0.198163226246834, 0.198478847742081, 0.198794588446617, 0.199110507965088, 0.199426561594009, 0.199742943048477, 0.2000592648983, 0.20037579536438, 0.200692415237427, 0.20100936293602, 0.201326251029968, 0.201643452048302, 0.201960682868958, 0.202278181910515, 0.20259565114975, 0.202913478016853, 0.203231379389763, 0.20354937016964, 0.203867569565773, 0.20418593287468, 0.204504370689392, 0.204822957515717, 0.205141857266426, 0.205460652709007, 0.205779865384102, 0.20609912276268, 0.206418454647064, 0.20673805475235, 0.207057639956474, 0.2073774933815, 0.207697495818138, 0.208017647266388, 0.208337917923927, 0.208658322691917, 0.208978980779648, 0.209299713373184, 0.2096206843853, 0.209941625595093, 0.210262790322304, 0.210584133863449, 0.210905626416206, 0.211227267980576, 0.211549028754234, 0.211870923638344, 0.212193056941032, 0.212515339255333, 0.212837681174278, 0.213160201907158, 0.213482871651649, 0.213805750012398, 0.214128777384758, 0.214451894164085, 0.214775085449219, 0.215098544955254, 0.215422257781029, 0.215745970606804, 0.216069772839546, 0.216393873095512, 0.216718003153801, 0.217042401432991, 0.217366844415665, 0.217691451311111, 0.218016192317009, 0.218341216444969, 0.218666329979897, 0.218991488218307, 0.219316944479942, 0.219642445445061, 0.219968199729919, 0.220293924212456, 0.220619887113571, 0.220946058630943, 0.221272364258766, 0.221598759293556, 0.221925362944603, 0.222252190113068, 0.222579091787338, 0.222906082868576, 0.223233267664909, 0.223560556769371, 0.223888009786606, 0.224215671420097, 0.224543437361717, 0.224871382117271, 0.225199609994888, 0.225527852773666, 0.22585617005825, 0.226184666156769, 0.226513355970383, 0.226842194795609, 0.227171242237091, 0.227500289678574, 0.227829545736313, 0.228159174323082, 0.228488638997078, 0.228818446397781, 0.229148268699646, 0.229478240013123, 0.229808479547501, 0.230138853192329, 0.230469271540642, 0.230799868702888, 0.231130719184875, 0.231461703777313, 0.231792762875557, 0.232123970985413, 0.232455372810364, 0.232786893844604, 0.233118638396263, 0.233450382947922, 0.233782395720482, 0.234114572405815, 0.234446793794632, 0.234779298305511, 0.235111847519875, 0.235444620251656, 0.235777467489243, 0.23611056804657, 0.236443713307381, 0.236777052283287, 0.237110614776611, 0.237444177269936, 0.237777963280678, 0.238112017512321, 0.238445952534676, 0.238780304789543, 0.239114597439766, 0.239449143409729, 0.239783778786659, 0.240118682384491, 0.240453660488129, 0.240788802504539, 0.241124197840691, 0.241459533572197, 0.241795137524605, 0.242130815982819, 0.242466688156128, 0.24280272424221, 0.243138939142227, 0.243475317955017, 0.243811741471291, 0.24414835870266, 0.244485229253769, 0.244822144508362, 0.24515925347805, 0.245496481657028, 0.24583388864994, 0.246171444654465, 0.246509090065956, 0.246846884489059, 0.247184872627258, 0.247522994875908, 0.247861370444298, 0.248199820518494, 0.248538330197334, 0.248877182602882, 0.249216020107269, 0.249555021524429, 0.24989415705204, 0.25023353099823, 0.250572919845581, 0.250912606716156, 0.251252472400665, 0.251592427492142, 0.25193253159523, 0.252272725105286, 0.252613097429276, 0.252953618764877, 0.253294229507446, 0.253635078668594, 0.253976136445999, 0.254317224025726, 0.254658550024033, 0.255000054836273, 0.255341678857803, 0.255683332681656, 0.256025195121765, 0.256367206573486, 0.256709456443787, 0.257051795721054, 0.257394254207611, 0.257736891508102, 0.25807973742485, 0.25842273235321, 0.25876572728157, 0.25910896062851, 0.259452342987061, 0.259795844554901, 0.260139554738998, 0.260483354330063, 0.260827392339706, 0.261171609163284, 0.261515825986862, 0.261860281229019, 0.262204885482788, 0.262549519538879, 0.262894511222839, 0.263239562511444, 0.263584643602371, 0.2639299929142, 0.264275521039963, 0.264621287584305, 0.264967024326324, 0.265312850475311, 0.2656589448452, 0.266005218029022, 0.266351610422134, 0.266698151826859, 0.267044752836227, 0.26739165186882, 0.267738610506058, 0.268085777759552, 0.268433153629303, 0.268780529499054, 0.269128143787384, 0.269475847482681, 0.26982370018959, 0.270171731710434, 0.270519942045212, 0.270868271589279, 0.271216750144958, 0.271565467119217, 0.271914184093475, 0.272263169288635, 0.27261221408844, 0.272961467504501, 0.273310840129852, 0.27366042137146, 0.274010121822357, 0.274359852075577, 0.274710029363632, 0.275060027837753, 0.275410383939743, 0.275760769844055, 0.276111364364624, 0.27646216750145, 0.27681303024292, 0.27716401219368, 0.277515202760696, 0.277866512537003, 0.27821809053421, 0.278569668531418, 0.278921484947205, 0.279273420572281, 0.279625505208969, 0.279977738857269, 0.280330121517181, 0.280682563781738, 0.281035274267197, 0.281388133764267, 0.281741172075272, 0.282094299793243, 0.282447576522827, 0.28280109167099, 0.283154606819153, 0.283508360385895, 0.283862233161926, 0.284216314554214, 0.284570455551147, 0.284924775362015, 0.285279303789139, 0.285633891820908, 0.285988807678223, 0.286343663930893, 0.286698698997498, 0.287053942680359, 0.287409365177155, 0.287764936685562, 0.288120567798615, 0.288476437330246, 0.288832426071167, 0.289188593626022, 0.289544880390167, 0.289901286363602, 0.290257811546326, 0.290614604949951, 0.290971547365189, 0.291328519582748, 0.29168564081192, 0.292043000459671, 0.292400538921356, 0.292758226394653, 0.293115973472595, 0.293473899364471, 0.293832004070282, 0.294190168380737, 0.294548571109772, 0.294907122850418, 0.295265883207321, 0.295624732971191, 0.295983731746674, 0.296342790126801, 0.296702116727829, 0.297061562538147, 0.297421127557755, 0.297780841588974, 0.298140823841095, 0.298500776290894, 0.298860967159271, 0.299221366643906, 0.299581825733185, 0.299942463636398, 0.300303190946579, 0.300664186477661, 0.301025331020355, 0.301386475563049, 0.301747918128967, 0.302109450101852, 0.302471101284027, 0.302832931280136, 0.303194999694824, 0.30355703830719, 0.30391937494278, 0.304281860589981, 0.30464443564415, 0.305007100105286, 0.305370062589645, 0.305733054876328, 0.306096196174622, 0.30645963549614, 0.30682310461998, 0.307186752557755, 0.307550579309464, 0.307914435863495, 0.308278530836105, 0.308642834424973, 0.309007108211517, 0.309371680021286, 0.309736490249634, 0.310101240873337, 0.310466259717941, 0.310831397771835, 0.311196655035019, 0.311562091112137, 0.311927765607834, 0.312293291091919, 0.312659353017807, 0.313025265932083, 0.313391655683517, 0.31375789642334, 0.314124405384064, 0.31449094414711, 0.314857810735703, 0.315224766731262, 0.315591782331467, 0.315959066152573, 0.316326439380646, 0.316693902015686, 0.31706166267395, 0.317429572343826, 0.31779745221138, 0.318165600299835, 0.318533957004547, 0.318902373313904, 0.31927090883255, 0.319639623165131, 0.320008546113968, 0.320377618074417, 0.320746868848801, 0.321116089820862, 0.321485638618469, 0.321855306625366, 0.32222506403923, 0.322595059871674, 0.322965085506439, 0.323335289955139, 0.323705732822418, 0.32407620549202, 0.3244469165802, 0.324817776679993, 0.325188815593719, 0.325559914112091, 0.325931191444397, 0.326302587985992, 0.326674163341522, 0.327045977115631, 0.327417820692062, 0.327789902687073, 0.328162133693695, 0.328534513711929, 0.328906923532486, 0.329279541969299, 0.32965224981308, 0.330025225877762, 0.330398321151733, 0.330771565437317, 0.331144958734512, 0.331518650054932, 0.331892311573029, 0.33226603269577, 0.332640111446381, 0.333014219999313, 0.333388417959213, 0.333762973546982, 0.334137499332428, 0.334512293338776, 0.33488717675209, 0.335262298583984, 0.335637390613556, 0.336012721061707, 0.336388170719147, 0.336763828992844, 0.337139695882797, 0.337515503168106, 0.337891638278961, 0.338267922401428, 0.338644206523895, 0.339020818471909, 0.339397549629211, 0.339774429798126, 0.340151429176331, 0.340528547763824, 0.340905725955963, 0.341283202171326, 0.3416608273983, 0.342038422822952, 0.342416346073151, 0.342794448137283, 0.34317272901535, 0.343550950288773, 0.343929529190063, 0.344308137893677, 0.344686895608902, 0.345065832138062, 0.345444887876511, 0.345824152231216, 0.346203565597534, 0.346583276987076, 0.346962809562683, 0.347342669963837, 0.347722589969635, 0.348102807998657, 0.348483115434647, 0.348863512277603, 0.349244028329849, 0.34962472319603, 0.350005835294724, 0.350386828184128, 0.350767999887466, 0.35114923119545, 0.351530790328979, 0.351912438869476, 0.352294236421585, 0.352676093578339, 0.353058129549026, 0.353440463542938, 0.353822886943817, 0.354205429553986, 0.354588061571121, 0.354970872402191, 0.355354011058807, 0.355737030506134, 0.356120318174362, 0.35650372505188, 0.356887370347977, 0.357271075248718, 0.357655107975006, 0.358038991689682, 0.358423233032227, 0.358807593584061, 0.359192043542862, 0.359576731920242, 0.359961479902267, 0.360346376895905, 0.360731452703476, 0.361116707324982, 0.361502170562744, 0.361887782812119, 0.362273454666138, 0.362659245729446, 0.363045215606689, 0.363431304693222, 0.363817632198334, 0.364204078912735, 0.364590585231781, 0.364977449178696, 0.365364372730255, 0.365751415491104, 0.36613854765892, 0.366525918245316, 0.366913408041, 0.367300927639008, 0.367688775062561, 0.368076652288437, 0.368464797735214, 0.368853121995926, 0.369241535663605, 0.369629949331284, 0.370018690824509, 0.370407551527023, 0.370796501636505, 0.371185660362244, 0.371574908494949, 0.371964395046234, 0.372353911399841, 0.372743785381317, 0.373133569955826, 0.373523682355881, 0.373913913965225, 0.374304175376892, 0.37469470500946, 0.375085324048996, 0.375476092100143, 0.37586697936058, 0.376258015632629, 0.376649409532547, 0.377040773630142, 0.377432346343994, 0.377823948860168, 0.378215879201889, 0.378607720136642, 0.378999948501587, 0.379392206668854, 0.379784643650055, 0.380177229642868, 0.380569964647293, 0.38096296787262, 0.381355911493301, 0.381749153137207, 0.38214248418808, 0.38253590464592, 0.382929593324661, 0.38332337141037, 0.383717328310013, 0.384111523628235, 0.384505808353424, 0.384900003671646, 0.385294646024704, 0.385689198970795, 0.386084109544754, 0.386479169130325, 0.386874258518219, 0.387269556522369, 0.387664914131165, 0.388060688972473, 0.388456404209137, 0.388852268457413, 0.389248222112656, 0.389644384384155, 0.390040814876556, 0.390437185764313, 0.390833884477615, 0.391230642795563, 0.391627550125122, 0.392024725675583, 0.392421960830688, 0.392819344997406, 0.393216848373413, 0.393614619970322, 0.394012421369553, 0.394410371780396, 0.39480847120285, 0.395206838846207, 0.395605206489563, 0.396003901958466, 0.396402567625046, 0.396801561117172, 0.397200644016266, 0.397599726915359, 0.397999048233032, 0.398398578166962, 0.398798137903214, 0.399197936058044, 0.39959791302681, 0.399998009204865, 0.400398284196854, 0.400798708200455, 0.401199191808701, 0.40159997344017, 0.402000725269318, 0.402401655912399, 0.402802884578705, 0.403204083442688, 0.403605550527573, 0.404007226228714, 0.4044089615345, 0.404810786247253, 0.405212908983231, 0.405615031719208, 0.406017363071442, 0.40641987323761, 0.406822443008423, 0.407225281000137, 0.407628327608109, 0.408031463623047, 0.40843454003334, 0.40883794426918, 0.409241497516632, 0.409645229578018, 0.410049080848694, 0.410452991724014, 0.410857141017914, 0.411261409521103, 0.411666005849838, 0.412070453166962, 0.412475258111954, 0.41288024187088, 0.413285166025162, 0.413690328598022, 0.414095669984818, 0.414501160383224, 0.414906799793243, 0.415312498807907, 0.415718555450439, 0.416124641895294, 0.416530966758728, 0.416937321424484, 0.417343854904175, 0.417750507593155, 0.418157368898392, 0.418564349412918, 0.418971419334412, 0.419378757476807, 0.419786334037781, 0.420193910598755, 0.420601546764374, 0.421009451150894, 0.421417444944382, 0.421825677156448, 0.42223396897316, 0.422642439603806, 0.423051178455353, 0.423459857702255, 0.423868924379349, 0.424277991056442, 0.424687206745148, 0.425096541643143, 0.425506055355072, 0.425915896892548, 0.426325649023056, 0.426735609769821, 0.427145838737488, 0.427556186914444, 0.427966564893723, 0.428377240896225, 0.428787857294083, 0.429198771715164, 0.429609835147858, 0.430020987987518, 0.430432289838791, 0.43084380030632, 0.431255400180817, 0.431667238473892, 0.432079285383224, 0.43249124288559, 0.432903528213501, 0.433315992355347, 0.433728516101837, 0.434141099452972, 0.434554040431976, 0.434966892004013, 0.435380071401596, 0.435793459415436, 0.436206787824631, 0.436620473861694, 0.43703430891037, 0.437448084354401, 0.437862128019333, 0.438276290893555, 0.438690632581711, 0.439105093479156, 0.439519673585892, 0.439934581518173, 0.440349578857422, 0.440764725208282, 0.441179811954498, 0.441595256328583, 0.44201073050499, 0.442426443099976, 0.442842274904251, 0.443258315324783, 0.443674474954605, 0.444090694189072, 0.44450718164444, 0.444923758506775, 0.445340573787689, 0.445757418870926, 0.446174472570419, 0.446591675281525, 0.447009027004242, 0.447426527738571, 0.447844177484512, 0.448261827230453, 0.448679894208908, 0.449097990989685, 0.449516206979752, 0.449934601783752, 0.450353115797043, 0.450771749019623, 0.451190739870071, 0.451609641313553, 0.452028781175613, 0.452448070049286, 0.452867448329926, 0.453287184238434, 0.453706860542297, 0.454126745462418, 0.454546749591827, 0.454966962337494, 0.455387324094772, 0.455807775259018, 0.456228464841843, 0.456649214029312, 0.457070231437683, 0.457491248846054, 0.457912594079971, 0.458333879709244, 0.458755403757095, 0.459177136421204, 0.459598928689957, 0.460021048784256, 0.460443049669266, 0.460865378379822, 0.46128785610199, 0.461710453033447, 0.462133169174194, 0.462556034326553, 0.462979137897491, 0.463402390480042, 0.463825732469559, 0.464249134063721, 0.464672803878784, 0.465096473693848, 0.465520560741425, 0.465944558382034, 0.466368854045868, 0.466793298721313, 0.467217743396759, 0.467642515897751, 0.468067318201065, 0.468492299318314, 0.468917399644852, 0.469342738389969, 0.469768106937408, 0.47019374370575, 0.470619559288025, 0.471045404672623, 0.47147136926651, 0.471897631883621, 0.472324013710022, 0.472750395536423, 0.473177075386047, 0.473603904247284, 0.47403085231781, 0.474458009004593, 0.474885195493698, 0.475312560796738, 0.475740134716034, 0.476167917251587, 0.476595610380173, 0.477023631334305, 0.477451890707016, 0.477880090475082, 0.478308588266373, 0.478737115859985, 0.479165822267532, 0.479594737291336, 0.480023831129074, 0.480452924966812, 0.480882376432419, 0.48131188750267, 0.481741458177567, 0.482171326875687, 0.482601255178452, 0.483031302690506, 0.483461529016495, 0.483891934156418, 0.48432257771492, 0.4847531914711, 0.485184043645859, 0.485614985227585, 0.4860460460186, 0.48647740483284, 0.486908823251724, 0.487340569496155, 0.487772196531296, 0.488204061985016, 0.488636165857315, 0.489068388938904, 0.489500641822815, 0.489933162927628, 0.490365743637085, 0.490798622369766, 0.491231590509415, 0.49166464805603, 0.49209788441658, 0.492531180381775, 0.492964863777161, 0.493398427963257, 0.493832290172577, 0.494266420602798, 0.494700461626053, 0.495134800672531, 0.495569229125977, 0.496003776788712, 0.496438503265381, 0.496873408555984, 0.497308433055878, 0.497743636369705, 0.498200535774231, 0.498678892850876, 0.499157249927521, 0.499635398387909, 0.500113487243652, 0.500591516494751, 0.50106942653656, 0.501547336578369, 0.502025127410889, 0.502502799034119, 0.502980411052704, 0.503457903862, 0.50393545627594, 0.504412710666656, 0.504889965057373, 0.505367159843445, 0.505844235420227, 0.506321310997009, 0.506798207759857, 0.50727504491806, 0.507751762866974, 0.508228421211243, 0.508705079555511, 0.509181559085846, 0.509657979011536, 0.510134339332581, 0.510610461235046, 0.511086761951447, 0.511562824249268, 0.512038767337799, 0.512514650821686, 0.512990474700928, 0.513466238975525, 0.513941943645477, 0.514417469501495, 0.514892935752869, 0.515368282794952, 0.515843689441681, 0.51631885766983, 0.516793966293335, 0.517269015312195, 0.517744064331055, 0.51821893453598, 0.518693745136261, 0.519168436527252, 0.519643068313599, 0.520117521286011, 0.520592093467712, 0.521066427230835, 0.521540760993958, 0.522014975547791, 0.522489130496979, 0.522963106632233, 0.523437082767487, 0.523910939693451, 0.524384737014771, 0.524858415126801, 0.525332033634186, 0.525805532932281, 0.526279032230377, 0.526752352714539, 0.5272256731987, 0.527698755264282, 0.528171896934509, 0.528644979000092, 0.52911788225174, 0.529590785503387, 0.530063569545746, 0.53053617477417, 0.531008720397949, 0.531481266021729, 0.531953692436218, 0.532425999641418, 0.532898306846619, 0.533370435237885, 0.533842504024506, 0.534314572811127, 0.534786462783813, 0.535258293151855, 0.535730004310608, 0.536201655864716, 0.536673307418823, 0.537144780158997, 0.537616193294525, 0.538087487220764, 0.538558661937714, 0.539029896259308, 0.539500892162323, 0.539971888065338, 0.540442764759064, 0.540913581848145, 0.541384339332581, 0.541855037212372, 0.542325496673584, 0.542796015739441, 0.543266296386719, 0.543736696243286, 0.544206976890564, 0.544677019119263, 0.545147061347961, 0.545617043972015, 0.54608690738678, 0.546556651592255, 0.547026336193085, 0.54749596118927, 0.547965586185455, 0.548434972763062, 0.548904359340668, 0.549373626708984, 0.549842834472656, 0.550311982631683, 0.550780951976776, 0.551249861717224, 0.551718711853027, 0.552187561988831, 0.552656292915344, 0.553124904632568, 0.553593397140503, 0.554061770439148, 0.554530084133148, 0.554998397827148, 0.555466532707214, 0.55593466758728, 0.556402683258057, 0.556870579719543, 0.557338416576385, 0.557806134223938, 0.558273911476135, 0.558741390705109, 0.559208929538727, 0.559676349163055, 0.560143649578094, 0.560610890388489, 0.561078071594238, 0.561545073986053, 0.562012076377869, 0.562478959560394, 0.56294584274292, 0.563412606716156, 0.563879191875458, 0.56434577703476, 0.564812242984772, 0.565278649330139, 0.565744817256927, 0.566211104393005, 0.566677272319794, 0.567143321037292, 0.567609310150146, 0.568075180053711, 0.568540990352631, 0.569006681442261, 0.569472372531891, 0.569937825202942, 0.570403277873993, 0.570868670940399, 0.571333944797516, 0.571799159049988, 0.57226425409317, 0.572729289531708, 0.573194324970245, 0.573659121990204, 0.574123919010162, 0.574588537216187, 0.575053215026855, 0.57551783323288, 0.575982213020325, 0.57644647359848, 0.576910793781281, 0.577374994754791, 0.577839136123657, 0.578303098678589, 0.578767120838165, 0.579230844974518, 0.579694628715515, 0.580158293247223, 0.580621898174286, 0.581085383892059, 0.581548750400543, 0.582012176513672, 0.582475423812866, 0.582938551902771, 0.583401679992676, 0.583864569664001, 0.584327459335327, 0.584790408611298, 0.585253119468689, 0.585715711116791, 0.586178302764893, 0.586640775203705, 0.587103247642517, 0.58756548166275, 0.588027775287628, 0.588489890098572, 0.588951945304871, 0.58941388130188, 0.589875817298889, 0.590337574481964, 0.590799331665039, 0.59126091003418, 0.591722548007965, 0.592184066772461, 0.592645406723022, 0.593106687068939, 0.593567967414856, 0.594029009342194, 0.594490051269531, 0.594950973987579, 0.595411837100983, 0.595872700214386, 0.596333384513855, 0.59679388999939, 0.597254514694214, 0.597714960575104, 0.598175346851349, 0.59863555431366, 0.599095821380615, 0.599555850028992, 0.600015878677368, 0.6004758477211, 0.600935637950897, 0.601395428180695, 0.601855158805847, 0.602314710617065, 0.602774202823639, 0.603233695030212, 0.603693008422852, 0.604152262210846, 0.604611337184906, 0.605070531368256, 0.605529487133026, 0.605988383293152, 0.606447279453278, 0.606905996799469, 0.607364654541016, 0.607823252677917, 0.60828173160553, 0.608740150928497, 0.609198451042175, 0.609656691551208, 0.610114872455597, 0.610572874546051, 0.61103081703186, 0.611488819122314, 0.611946642398834, 0.612404346466064, 0.612861931324005, 0.613319516181946, 0.613776981830597, 0.614234328269958, 0.614691734313965, 0.615148901939392, 0.615606069564819, 0.616063058376312, 0.616520047187805, 0.616976916790009, 0.617433726787567, 0.617890357971191, 0.61834704875946, 0.618803560733795, 0.619260013103485, 0.61971640586853, 0.620172679424286, 0.620628893375397, 0.621084988117218, 0.621541023254395, 0.621996939182281, 0.622452795505524, 0.622908651828766, 0.623364329338074, 0.623819887638092, 0.624275386333466, 0.624730825424194, 0.625186145305634, 0.625641465187073, 0.626096606254578, 0.626551687717438, 0.627006709575653, 0.627461671829224, 0.627916514873505, 0.628371179103851, 0.628825843334198, 0.6292804479599, 0.629734992980957, 0.63018935918808, 0.630643725395203, 0.631097972393036, 0.63155210018158, 0.632006227970123, 0.632460236549377, 0.632914125919342, 0.633367836475372, 0.633821606636047, 0.634275376796722, 0.634728908538818, 0.635182321071625, 0.635635673999786, 0.636089026927948, 0.63654226064682, 0.636995375156403, 0.637448489665985, 0.637901425361633, 0.638354361057281, 0.638807117938995, 0.639259815216064, 0.639712393283844, 0.640164971351624, 0.640617489814758, 0.641069769859314, 0.641522109508514, 0.641974329948425, 0.642426431179047, 0.642878532409668, 0.643330454826355, 0.643782258033752, 0.64423406124115, 0.644685745239258, 0.645137429237366, 0.645588994026184, 0.646040380001068, 0.646491646766663, 0.646942973136902, 0.647394180297852, 0.647845268249512, 0.648296236991882, 0.648747205734253, 0.649197936058044, 0.64964884519577, 0.650099515914917, 0.650550067424774, 0.651000499725342, 0.651450932025909, 0.651901423931122, 0.65235161781311, 0.652801752090454, 0.653251826763153, 0.653701722621918, 0.654151737689972, 0.654601514339447, 0.655051290988922, 0.655500948429108, 0.655950546264648, 0.6564000248909, 0.656849384307861, 0.657298684120178, 0.657747983932495, 0.658197045326233, 0.65864622592926, 0.659095168113708, 0.659544110298157, 0.659992814064026, 0.660441637039185, 0.660890161991119, 0.661338746547699, 0.661787211894989, 0.662235498428345, 0.662683963775635, 0.663132131099701, 0.663580298423767, 0.664028346538544, 0.664476275444031, 0.664924144744873, 0.665371894836426, 0.665819644927979, 0.666267216205597, 0.666714727878571, 0.667162179946899, 0.667609632015228, 0.668056786060333, 0.668503999710083, 0.668951094150543, 0.669398188591003, 0.669845044612885, 0.670291900634766, 0.670738697052002, 0.671185374259949, 0.671631991863251, 0.672078549861908, 0.672524929046631, 0.672971248626709, 0.673417508602142, 0.673863708972931, 0.674309849739075, 0.674755811691284, 0.675201654434204, 0.675647497177124, 0.676093339920044, 0.676538944244385, 0.676984488964081, 0.677429974079132, 0.677875459194183, 0.6783207654953, 0.678766012191772, 0.679211139678955, 0.679656147956848, 0.680101156234741, 0.68054610490799, 0.680990934371948, 0.681435644626617, 0.681880295276642, 0.682324826717377, 0.682769358158112, 0.683213651180267, 0.683657944202423, 0.684102177619934, 0.684546411037445, 0.684990465641022, 0.685434341430664, 0.685878276824951, 0.686322033405304, 0.686765730381012, 0.687209367752075, 0.687652885913849, 0.688096344470978, 0.688539743423462, 0.688983082771301, 0.689426243305206, 0.689869344234467, 0.690312325954437, 0.690755188465118, 0.691198229789734, 0.691640973091125, 0.692083597183228, 0.692526280879974, 0.692968785762787, 0.693411231040955, 0.693853616714478, 0.694295823574066, 0.69473797082901, 0.695180058479309, 0.695622086524963, 0.696064054965973, 0.696505844593048, 0.696947634220123, 0.697389245033264, 0.69783091545105, 0.698272407054901, 0.698713779449463, 0.699155151844025, 0.699596345424652, 0.70003753900528, 0.700478553771973, 0.700919508934021, 0.701360464096069, 0.701801240444183, 0.702242016792297, 0.702682673931122, 0.703123271465302, 0.703563749790192, 0.704004108905792, 0.704444408416748, 0.704884707927704, 0.705324828624725, 0.705764830112457, 0.706204891204834, 0.706644773483276, 0.707084536552429, 0.707524299621582, 0.707963824272156, 0.708403408527374, 0.708842933177948, 0.709282279014587, 0.709721505641937, 0.710160732269287, 0.710599899291992, 0.711038887500763, 0.711477875709534, 0.71191680431366, 0.712355554103851, 0.712794244289398, 0.713232815265656, 0.713671386241913, 0.714109838008881, 0.714548110961914, 0.714986443519592, 0.715424656867981, 0.715862691402435, 0.71630072593689, 0.71673858165741, 0.717176556587219, 0.717614352703094, 0.718051910400391, 0.718489587306976, 0.718927025794983, 0.71936446428299, 0.719801723957062, 0.720239043235779, 0.720676243305206, 0.721113324165344, 0.721550405025482, 0.721987247467041, 0.7224240899086, 0.722860813140869, 0.723297357559204, 0.723734021186829, 0.724170565605164, 0.724606931209564, 0.725043177604675, 0.725479483604431, 0.725915610790253, 0.726351737976074, 0.726787567138672, 0.727223515510559, 0.727659344673157, 0.728095054626465, 0.728530764579773, 0.728966295719147, 0.729401707649231, 0.729837119579315, 0.73027241230011, 0.730707585811615, 0.731142818927765, 0.731577813625336, 0.732012867927551, 0.732447683811188, 0.732882499694824, 0.733317136764526, 0.733751773834229, 0.734186291694641, 0.734620690345764, 0.735055148601532, 0.73548948764801, 0.735923528671265, 0.736357748508453, 0.736791670322418, 0.737225592136383, 0.737659454345703, 0.738093256950378, 0.738527059555054, 0.738960564136505, 0.739394128322601, 0.739827454090118, 0.74026083946228, 0.740694165229797, 0.741127252578735, 0.741560339927673, 0.741993367671967, 0.742426216602325, 0.742859125137329, 0.743291914463043, 0.743724584579468, 0.744157075881958, 0.744589567184448, 0.745022058486938, 0.745454430580139, 0.74588668346405, 0.746318757534027, 0.746750771999359, 0.747182905673981, 0.747614741325378, 0.748046517372131, 0.748478174209595, 0.748909890651703, 0.749341487884521, 0.749772965908051, 0.75020432472229, 0.75063556432724, 0.751066923141479, 0.751497983932495, 0.751929044723511, 0.752360045909882, 0.752790868282318, 0.753221750259399, 0.753652453422546, 0.754082977771759, 0.754513561725616, 0.75494396686554, 0.755374431610107, 0.755804717540741, 0.756234884262085, 0.756665050983429, 0.757095038890839, 0.757525026798248, 0.757954835891724, 0.758384644985199, 0.75881427526474, 0.759243905544281, 0.759673535823822, 0.760102927684784, 0.760532200336456, 0.760961472988129, 0.761390686035156, 0.76181972026825, 0.762248814105988, 0.762677729129791, 0.76310658454895, 0.763535261154175, 0.763963997364044, 0.764392554759979, 0.76482105255127, 0.76524943113327, 0.765677809715271, 0.766106128692627, 0.766534268856049, 0.766962349414825, 0.767390370368958, 0.76781815290451, 0.768245995044708, 0.768673717975616, 0.769101440906525, 0.769529044628143, 0.769956529140472, 0.770383954048157, 0.770811259746552, 0.771238446235657, 0.771665513515472, 0.772092700004578, 0.772519648075104, 0.772946417331696, 0.773373246192932, 0.773799955844879, 0.774226665496826, 0.774653196334839, 0.775079667568207, 0.77550595998764, 0.775932252407074, 0.776358544826508, 0.776784718036652, 0.777210712432861, 0.777636647224426, 0.778062522411346, 0.778488278388977, 0.778914034366608, 0.779339551925659, 0.779765129089355, 0.780190587043762, 0.780615985393524, 0.781041204929352, 0.781466424465179, 0.781891465187073, 0.782316505908966, 0.782741487026215, 0.783166289329529, 0.783591091632843, 0.784015774726868, 0.784440338611603, 0.784864842891693, 0.785289287567139, 0.785713672637939, 0.786137878894806, 0.786562025547028, 0.786986112594604, 0.787410199642181, 0.787834048271179, 0.788257896900177, 0.78868156671524, 0.789105296134949, 0.789528846740723, 0.789952278137207, 0.790375709533691, 0.790799021720886, 0.791222333908081, 0.791645467281342, 0.792068481445312, 0.792491495609283, 0.792914390563965, 0.793337166309357, 0.793760001659393, 0.794182598590851, 0.794605135917664, 0.795027613639832, 0.79544997215271, 0.795872390270233, 0.796294510364532, 0.796716630458832, 0.797138631343842, 0.797560691833496, 0.797982573509216, 0.798404276371002, 0.798825919628143, 0.799247682094574, 0.799669146537781, 0.800090610980988, 0.80051201581955, 0.800933241844177, 0.80135452747345, 0.801775634288788, 0.802196562290192, 0.80261754989624, 0.803038358688354, 0.803459167480469, 0.803879857063293, 0.804300546646118, 0.804720997810364, 0.805141448974609, 0.805561780929565, 0.805981993675232, 0.806402206420898, 0.806822240352631, 0.807242333889008, 0.80766224861145, 0.808082103729248, 0.808501780033112, 0.808921456336975, 0.809341013431549, 0.809760510921478, 0.810179948806763, 0.810599267482758, 0.811018526554108, 0.811437726020813, 0.811856746673584, 0.812275767326355, 0.812694668769836, 0.813113451004028, 0.81353223323822, 0.813950836658478, 0.814369440078735, 0.814787864685059, 0.815206289291382, 0.81562465429306, 0.816042840480804, 0.816460907459259, 0.816879034042358, 0.817296922206879, 0.817714869976044, 0.818132698535919, 0.81855034828186, 0.818967998027802, 0.819385588169098, 0.819803059101105, 0.820220351219177, 0.82063764333725, 0.821054935455322, 0.821471929550171, 0.821889042854309, 0.822305977344513, 0.822722792625427, 0.823139607906342, 0.823556244373322, 0.823972940444946, 0.824389517307281, 0.824805915355682, 0.825222253799438, 0.82563841342926, 0.826054751873016, 0.826470792293549, 0.826886773109436, 0.827302634716034, 0.827718555927277, 0.82813435792923, 0.828550040721893, 0.828965604305267, 0.829381108283997, 0.829796493053436, 0.830211818218231, 0.830627143383026, 0.831042170524597, 0.831457316875458, 0.831872344017029, 0.83228725194931, 0.832702159881592, 0.833116769790649, 0.833531439304352, 0.833946049213409, 0.834360539913177, 0.834774971008301, 0.835189282894135, 0.835603475570679, 0.836017608642578, 0.836431741714478, 0.836845636367798, 0.837259531021118, 0.837673425674438, 0.838087141513824, 0.838500797748566, 0.838914215564728, 0.839327752590179, 0.839741051197052, 0.840154349803925, 0.840567588806152, 0.840980708599091, 0.841393709182739, 0.841806709766388, 0.842219650745392, 0.842632353305817, 0.843045055866241, 0.843457579612732, 0.843870162963867, 0.844282686710358, 0.844695031642914, 0.845107316970825, 0.845519483089447, 0.845931649208069, 0.846343696117401, 0.846755564212799, 0.847167491912842, 0.847579181194305, 0.847990870475769, 0.848402500152588, 0.848814070224762, 0.849225401878357, 0.849636673927307, 0.850048005580902, 0.850459158420563, 0.850870251655579, 0.85128128528595, 0.851692199707031, 0.852102994918823, 0.85251373052597, 0.852924406528473, 0.853334963321686, 0.853745460510254, 0.854155957698822, 0.854566156864166, 0.854976534843445, 0.8553866147995, 0.855796694755554, 0.856206655502319, 0.85661655664444, 0.857026338577271, 0.857436060905457, 0.857845783233643, 0.858255326747894, 0.858664810657501, 0.859074234962463, 0.859483420848846, 0.859892606735229, 0.860301792621613, 0.860710859298706, 0.8611199259758, 0.861528694629669, 0.861937522888184, 0.862346231937408, 0.862754881381989, 0.863163411617279, 0.86357182264328, 0.863980174064636, 0.864388465881348, 0.86479663848877, 0.865204811096191, 0.865612804889679, 0.866020739078522, 0.866428673267365, 0.866836369037628, 0.867244064807892, 0.867651641368866, 0.868059158325195, 0.86846661567688, 0.86887401342392, 0.86928129196167, 0.869688391685486, 0.870095491409302, 0.870502531528473, 0.870909452438354, 0.871316313743591, 0.871723055839539, 0.872129738330841, 0.872536301612854, 0.872942864894867, 0.873349189758301, 0.873755574226379, 0.874161839485168, 0.874567985534668, 0.874974012374878, 0.875379979610443, 0.875785887241364, 0.876191794872284, 0.87659740447998, 0.877003133296967, 0.877408683300018, 0.87781423330307, 0.878219544887543, 0.878624975681305, 0.879030168056488, 0.879435181617737, 0.87984025478363, 0.880245268344879, 0.880650162696838, 0.881054997444153, 0.881459653377533, 0.881864309310913, 0.882268965244293, 0.882673323154449, 0.883077681064606, 0.883481979370117, 0.883886158466339, 0.884290337562561, 0.884694337844849, 0.885098278522491, 0.885502099990845, 0.885905921459198, 0.886309623718262, 0.886713266372681, 0.887116730213165, 0.88752019405365, 0.8879234790802, 0.888326823711395, 0.888730049133301, 0.889133095741272, 0.889536142349243, 0.88993912935257, 0.890341937541962, 0.890744686126709, 0.891147315502167, 0.891549944877625, 0.891952395439148, 0.892354965209961, 0.892757177352905, 0.89315938949585, 0.893561661243439, 0.893963694572449, 0.894365668296814, 0.894767642021179, 0.89516943693161, 0.895571172237396, 0.895972847938538, 0.896374464035034, 0.896775901317596, 0.897177278995514, 0.897578597068787, 0.897979855537415, 0.898380994796753, 0.898782074451447, 0.899183094501495, 0.89958393573761, 0.89998471736908, 0.900385499000549, 0.900786101818085, 0.901186645030975, 0.901587188243866, 0.901987552642822, 0.902387797832489, 0.902787923812866, 0.903188109397888, 0.903588175773621, 0.903988182544708, 0.904388010501862, 0.90478789806366, 0.905187487602234, 0.905587077140808, 0.905986666679382, 0.906386137008667, 0.906785428524017, 0.907184720039368, 0.907583951950073, 0.907983005046844, 0.90838211774826, 0.908780992031097, 0.909179866313934, 0.909578561782837, 0.909977316856384, 0.910375833511353, 0.910774409770966, 0.911172866821289, 0.911571145057678, 0.911969482898712, 0.912367641925812, 0.912765681743622, 0.913163721561432, 0.913561642169952, 0.913959443569183, 0.914357244968414, 0.914754867553711, 0.915152430534363, 0.91554993391037, 0.915947437286377, 0.916344702243805, 0.916741907596588, 0.917139053344727, 0.917536199092865, 0.917933166027069, 0.918330073356628, 0.918726801872253, 0.919123589992523, 0.919520258903503, 0.919916808605194, 0.920313239097595, 0.920709669589996, 0.921106040477753, 0.92150217294693, 0.921898305416107, 0.92229437828064, 0.922690331935883, 0.923086166381836, 0.923481941223145, 0.923877596855164, 0.924273312091827, 0.924668908119202, 0.925064384937286, 0.925459682941437, 0.925855040550232, 0.926250159740448, 0.926645278930664, 0.92704039812088, 0.927435338497162, 0.927830100059509, 0.928224921226501, 0.928619623184204, 0.929014265537262, 0.92940878868103, 0.929803192615509, 0.930197477340698, 0.930591762065887, 0.930985987186432, 0.931380033493042, 0.931774079799652, 0.932168006896973, 0.932561874389648, 0.932955682277679, 0.933349251747131, 0.933742940425873, 0.934114038944244, 0.934462547302246, 0.934810698032379, 0.935158669948578, 0.935506224632263, 0.935853481292725, 0.936200499534607, 0.936547040939331, 0.936893403530121, 0.937239348888397, 0.937585055828094, 0.937930405139923, 0.938275516033173, 0.938620150089264, 0.938964605331421, 0.939308702945709, 0.939652442932129, 0.939995944499969, 0.940339028835297, 0.940681874752045, 0.941024422645569, 0.941366612911224, 0.941708445549011, 0.942050039768219, 0.942391276359558, 0.942732214927673, 0.94307279586792, 0.943413078784943, 0.943753123283386, 0.944092750549316, 0.944432079792023, 0.94477105140686, 0.945109784603119, 0.945448279380798, 0.94578629732132, 0.946124017238617, 0.94646143913269, 0.946798622608185, 0.947135388851166, 0.947471916675568, 0.947808086872101, 0.94814395904541, 0.948479413986206, 0.948814630508423, 0.949149608612061, 0.949484169483185, 0.94981849193573, 0.950152456760406, 0.950486063957214, 0.950819373130798, 0.951152443885803, 0.951485097408295, 0.951817452907562, 0.952149569988251, 0.952481269836426, 0.952812671661377, 0.953143715858459, 0.953474581241608, 0.953805029392242, 0.954135119915009, 0.95446503162384, 0.954794585704803, 0.955123782157898, 0.955452561378479, 0.955781221389771, 0.956109404563904, 0.956437408924103, 0.956765055656433, 0.95709228515625, 0.957419276237488, 0.957745969295502, 0.958072364330292, 0.958398401737213, 0.958724081516266, 0.95904952287674, 0.959374487400055, 0.959699392318726, 0.960023760795593, 0.960347950458527, 0.960671782493591, 0.960995197296143, 0.961318373680115, 0.961641311645508, 0.961963832378387, 0.962286055088043, 0.962607979774475, 0.962929546833038, 0.963250875473022, 0.963571846485138, 0.96389240026474, 0.964212775230408, 0.964532852172852, 0.964852511882782, 0.965171933174133, 0.965490937232971, 0.96580970287323, 0.96612811088562, 0.966446280479431, 0.966764152050018, 0.967081546783447, 0.967398703098297, 0.967715501785278, 0.968032121658325, 0.968348264694214, 0.968664228916168, 0.968979775905609, 0.969295024871826, 0.969609916210175, 0.969924628734589, 0.970238924026489, 0.970552921295166, 0.970866560935974, 0.971179962158203, 0.971493065357208, 0.9718057513237, 0.972118139266968, 0.972430229187012, 0.972741961479187, 0.973053514957428, 0.973364651203156, 0.973675489425659, 0.973985970020294, 0.974296092987061, 0.974605977535248, 0.974915504455566, 0.975224792957306, 0.975533723831177, 0.975842297077179, 0.976150691509247, 0.976458609104156, 0.976766228675842, 0.977073609828949, 0.977380573749542, 0.977687358856201, 0.977993786334991, 0.978299796581268, 0.978605568408966, 0.978910982608795, 0.979216158390045, 0.979520976543427, 0.979825377464294, 0.980129659175873, 0.980433464050293, 0.980737030506134, 0.981040239334106, 0.9813432097435, 0.981645822525024, 0.981948018074036, 0.982249915599823, 0.982551634311676, 0.982852935791016, 0.983153939247131, 0.983454585075378, 0.983754992485046, 0.984055042266846, 0.984354794025421, 0.984654188156128, 0.984953224658966, 0.98525208234787, 0.985550582408905, 0.985848665237427, 0.986146628856659, 0.986444115638733, 0.986741304397583, 0.987038135528564, 0.987334728240967, 0.987631022930145, 0.98792690038681, 0.988222539424896, 0.988517940044403, 0.988812863826752, 0.989107549190521, 0.989401817321777, 0.989695906639099, 0.989989638328552, 0.990283071994781, 0.990576088428497, 0.990868926048279, 0.991161346435547, 0.991453468799591, 0.991745293140411, 0.992036759853363, 0.992327928543091, 0.992618799209595, 0.992909371852875, 0.993199646472931, 0.993489503860474, 0.993779063224792, 0.994068443775177, 0.994357347488403, 0.994646012783051, 0.994934380054474, 0.995222389698029, 0.99550998210907, 0.995797455310822, 0.996084451675415, 0.996371269226074, 0.99665766954422, 0.996943771839142, 0.997229635715485, 0.997515022754669, 0.997800230979919, 0.998085081577301, 0.998369634151459, 0.998653829097748, 0.998937785625458, 0.999221324920654, 0.999504625797272, 0.999787509441376, 1.00007009506226, 1.0003525018692, 1.00063455104828, 1.0009161233902, 1.00119745731354, 1.0014785528183, 1.00175929069519, 1.00203967094421, 1.00231969356537, 1.00259959697723, 1.00287902355194, 1.00315821170807, 1.00343692302704, 1.00371551513672, 1.00399374961853, 1.00427150726318, 1.00454914569855, 1.00482642650604, 1.00510334968567, 1.00537991523743, 1.00565624237061, 1.00593221187592, 1.00620782375336, 1.00648319721222, 1.00675821304321, 1.00703299045563, 1.00730729103088, 1.00758135318756, 1.00785517692566, 1.00812864303589, 1.00840163230896, 1.00867450237274, 1.00894701480865, 1.0092191696167, 1.00949096679688, 1.00976252555847, 1.0100337266922, 1.01030468940735, 1.01057529449463, 1.01084554195404, 1.01111555099487, 1.01138508319855, 1.01165449619293, 1.01192355155945, 1.01219213008881, 1.01246058940887, 1.01272857189178, 1.01299631595612, 1.01326370239258, 1.01353085041046, 1.01379764080048, 1.01406419277191, 1.01433026790619, 1.01459610462189, 1.01486170291901, 1.01512682437897, 1.01539170742035, 1.01565623283386, 1.0159205198288, 1.01618444919586, 1.01644814014435, 1.01671135425568, 1.01697432994843, 1.01723694801331, 1.0174994468689, 1.01776146888733, 1.01802313327789, 1.01828455924988, 1.01854562759399, 1.01880633831024, 1.01906681060791, 1.01932692527771, 1.01958680152893, 1.01984632015228, 1.02010548114777, 1.02036440372467, 1.02062296867371, 1.02088105678558, 1.02113914489746, 1.02139663696289, 1.02165400981903, 1.02191090583801, 1.02216756343842, 1.02242386341095, 1.0226799249649, 1.02293562889099, 1.02319097518921, 1.02344608306885, 1.02370083332062, 1.02395522594452, 1.02420926094055, 1.02446317672729, 1.02471661567688, 1.0249696969986, 1.02522265911102, 1.02547514438629, 1.02572739124298, 1.0259792804718, 1.02623081207275, 1.02648210525513, 1.02673304080963, 1.02698361873627, 1.02723395824432, 1.02748394012451, 1.02773368358612, 1.02798295021057, 1.02823209762573, 1.02848076820374, 1.02872920036316, 1.02897727489471, 1.02922511100769, 1.02947247028351, 1.02971971035004, 1.02996647357941, 1.0302129983902, 1.03045916557312, 1.03070509433746, 1.03095066547394, 1.03119587898254, 1.03144085407257, 1.03168547153473, 1.03192973136902, 1.03217375278473, 1.03241741657257, 1.03266072273254, 1.03290367126465, 1.03314638137817, 1.03338885307312, 1.0336309671402, 1.03387260437012, 1.03411412239075, 1.03435528278351, 1.03459596633911, 1.03483653068542, 1.03507661819458, 1.03531646728516, 1.03555607795715, 1.03579521179199, 1.03603422641754, 1.03627288341522, 1.03651106357574, 1.03674900531769, 1.03698670864105, 1.03722393512726, 1.03746104240417, 1.03769767284393, 1.03793406486511, 1.03817009925842, 1.03840589523315, 1.03864121437073, 1.03887629508972, 1.03911113739014, 1.03934562206268, 1.03957974910736, 1.03981351852417, 1.04004716873169, 1.04028022289276, 1.04051315784454, 1.04074585437775, 1.04097807407379, 1.04120993614197, 1.04144167900085, 1.04167282581329, 1.04190397262573, 1.04213452339172, 1.04236495494843, 1.04259490966797, 1.04282462596893, 1.04305410385132, 1.04328310489655, 1.04351198673248, 1.04374039173126, 1.04396855831146, 1.04419636726379, 1.04442381858826, 1.04465103149414, 1.04487788677216, 1.0451043844223, 1.04533064365387, 1.04555654525757, 1.04578220844269, 1.04600751399994, 1.04623246192932, 1.04645705223083, 1.04668140411377, 1.04690539836884, 1.04712903499603, 1.04735255241394, 1.04757559299469, 1.04779839515686, 1.04802072048187, 1.0482429265976, 1.04846465587616, 1.04868614673615, 1.04890727996826, 1.0491281747818, 1.04934859275818, 1.04956889152527, 1.0497887134552, 1.05000841617584, 1.05022764205933, 1.05044651031494, 1.05066525936127, 1.05088353157043, 1.05110156536102, 1.05131912231445, 1.05153667926788, 1.05175364017487, 1.05197036266327, 1.0521867275238, 1.05240285396576, 1.05261862277985, 1.05283403396606, 1.0530492067337, 1.05326402187347, 1.05347847938538, 1.05369281768799, 1.05390655994415, 1.05412018299103, 1.05433344841003, 1.05454635620117, 1.05475890636444, 1.05497121810913, 1.05518317222595, 1.05539488792419, 1.05560624599457, 1.05581724643707, 1.05602788925171, 1.05623829364777, 1.05644845962524, 1.05665814876556, 1.0568675994873, 1.05707669258118, 1.05728554725647, 1.05749404430389, 1.05770218372345, 1.05791008472443, 1.05811762809753, 1.05832481384277, 1.05853164196014, 1.05873835086823, 1.05894458293915, 1.05915057659149, 1.05935621261597, 1.05956149101257, 1.0597665309906, 1.05997121334076, 1.06017553806305, 1.06037962436676, 1.0605833530426, 1.06078684329987, 1.06098985671997, 1.0611926317215, 1.06139504909515, 1.06159734725952, 1.06179904937744, 1.06200063228607, 1.06220185756683, 1.06240272521973, 1.06260335445404, 1.06280362606049, 1.06300354003906, 1.06320321559906, 1.0634024143219, 1.06360137462616, 1.06380009651184, 1.06399846076965, 1.0641964673996, 1.06439423561096, 1.06459164619446, 1.06478869915009, 1.06498539447784, 1.06518197059631, 1.06537806987762, 1.06557381153107, 1.06576931476593, 1.06596446037292, 1.06615936756134, 1.06635391712189, 1.06654810905457, 1.06674206256866, 1.0669356584549, 1.06712901592255, 1.06732189655304, 1.06751453876495, 1.067706823349, 1.06789886951447, 1.06809055805206, 1.06828200817108, 1.06847310066223, 1.06866383552551, 1.06885421276093, 1.06904447078705, 1.06923413276672, 1.06942367553711, 1.06961274147034, 1.06980168819427, 1.06999015808105, 1.07017827033997, 1.07036626338959, 1.07055389881134, 1.07074117660522, 1.07092809677124, 1.07111477851868, 1.07130098342896, 1.07148694992065, 1.07167267799377, 1.07185804843903, 1.0720431804657, 1.07222771644592, 1.07241225242615, 1.07259631156921, 1.0727801322937, 1.07296359539032, 1.07314670085907, 1.07332956790924, 1.07351207733154, 1.07369434833527, 1.07387614250183, 1.07405769824982, 1.07423889636993, 1.07441985607147, 1.07460045814514, 1.07478082180023, 1.07496070861816, 1.07514035701752, 1.075319647789, 1.07549870014191, 1.07567739486694, 1.0758558511734, 1.07603394985199, 1.07621169090271, 1.07638907432556, 1.07656621932983, 1.07674312591553, 1.07691955566406, 1.07709574699402, 1.07727158069611, 1.07744705677032, 1.07762229442596, 1.07779729366302, 1.07797181606293, 1.07814598083496, 1.07832014560699, 1.07849371433258, 1.07866704463959, 1.07884001731873, 1.07901275157928, 1.07918512821198, 1.0793571472168, 1.07952892780304, 1.07970035076141, 1.07987141609192, 1.08004212379456, 1.08021259307861, 1.08038282394409, 1.0805526971817, 1.08072209358215, 1.0808914899826, 1.08106029033661, 1.08122885227203, 1.08139717578888, 1.08156502246857, 1.08173263072968, 1.0819000005722, 1.08206689357758, 1.08223366737366, 1.08239996433258, 1.08256602287292, 1.0827317237854, 1.08289706707001, 1.08306217193604, 1.08322691917419, 1.08339142799377, 1.0835554599762, 1.08371925354004, 1.0838828086853, 1.0840460062027, 1.08420884609222, 1.08437144756317, 1.08453369140625, 1.08469557762146, 1.08485722541809, 1.08501851558685, 1.08517944812775, 1.08534002304077, 1.08550035953522, 1.08566033840179, 1.08582019805908, 1.08597946166992, 1.08613860607147, 1.08629739284515, 1.08645570278168, 1.0866140127182, 1.08677172660828, 1.08692908287048, 1.08708643913269, 1.08724319934845, 1.08739972114563, 1.08755588531494, 1.08771193027496, 1.08786737918854, 1.08802270889282, 1.08817756175995, 1.0883321762085, 1.08848643302917, 1.08864045143127, 1.08879411220551, 1.08894765377045, 1.08910071849823, 1.08925330638885, 1.08940577507019, 1.08955800533295, 1.08970963954926, 1.08986103534698, 1.09001231193542, 1.09016299247742, 1.09031367301941, 1.09046375751495, 1.09061360359192, 1.09076309204102, 1.09091246128082, 1.09106147289276, 1.09121000766754, 1.09135830402374, 1.09150624275208, 1.09165394306183, 1.09180116653442, 1.09194815158844, 1.09209489822388, 1.09224128723145, 1.09238743782043, 1.09253311157227, 1.09267866611481, 1.09282374382019, 1.09296846389771, 1.09311306476593, 1.093257188797, 1.09340119361877, 1.09354472160339, 1.09368789196014, 1.09383082389832, 1.09397339820862, 1.09411561489105, 1.09425759315491, 1.09439933300018, 1.09454047679901, 1.09468150138855, 1.0948224067688, 1.09496247768402, 1.09510266780853, 1.0952422618866, 1.09538197517395, 1.09552109241486, 1.09565961360931, 1.09579825401306, 1.09593629837036, 1.09607410430908, 1.09621167182922, 1.0963488817215, 1.0964857339859, 1.09662234783173, 1.09675860404968, 1.09689462184906, 1.09703004360199, 1.09716546535492, 1.09730052947998, 1.09743499755859, 1.09756946563721, 1.09770345687866, 1.09783732891083, 1.09797060489655, 1.09810364246368, 1.09823656082153, 1.09836888313293, 1.09850108623505, 1.09863293170929, 1.09876441955566, 1.09889554977417, 1.0990264415741, 1.09915697574615, 1.09928727149963, 1.09941709041595, 1.09954679012299, 1.09967589378357, 1.09980487823486, 1.09993362426758, 1.10006189346313, 1.10018980503082, 1.10031759738922, 1.10044503211975, 1.10057199001312, 1.1006988286972, 1.10082530975342, 1.10095131397247, 1.10107719898224, 1.10120260715485, 1.10132789611816, 1.10145282745361, 1.10157716274261, 1.10170149803162, 1.10182535648346, 1.10194885730743, 1.10207211971283, 1.10219502449036, 1.10231781005859, 1.10244011878967, 1.10256206989288, 1.10268366336823, 1.10280513763428, 1.10292601585388, 1.1030467748642, 1.10316729545593, 1.10328733921051, 1.10340714454651, 1.10352659225464, 1.1036456823349, 1.10376465320587, 1.1038830280304, 1.10400116443634, 1.10411906242371, 1.1042366027832, 1.10435402393341, 1.10447084903717, 1.10458743572235, 1.10470378398895, 1.1048196554184, 1.10493528842926, 1.10505068302155, 1.10516560077667, 1.10528039932251, 1.10539495944977, 1.10550892353058, 1.10562264919281, 1.10573613643646, 1.10584926605225, 1.10596203804016, 1.1060745716095, 1.10618674755096, 1.10629856586456, 1.10641014575958, 1.10652136802673, 1.10663223266602, 1.10674285888672, 1.10685312747955, 1.10696303844452, 1.10707259178162, 1.10718190670013, 1.10729098320007, 1.10739982128143, 1.10750806331635, 1.10761606693268, 1.10772383213043, 1.10783123970032, 1.10793840885162, 1.10804510116577, 1.10815155506134, 1.10825777053833, 1.10836374759674, 1.10846924781799, 1.10857439041138, 1.10867929458618, 1.10878396034241, 1.10888814926147, 1.10899198055267, 1.10909557342529, 1.10919892787933, 1.10930180549622, 1.10940456390381, 1.10950696468353, 1.10960912704468, 1.10971057415009, 1.10981214046478, 1.10991322994232, 1.11001396179199, 1.11011433601379, 1.11021447181702, 1.11031436920166, 1.11041367053986, 1.11051309108734, 1.11061191558838, 1.11071050167084, 1.11080861091614, 1.11090660095215, 1.11100423336029, 1.11110150814056, 1.11119842529297, 1.11129510402679, 1.11139142513275, 1.11148750782013, 1.11158311367035, 1.11167848110199, 1.11177349090576, 1.11186838150024, 1.11196279525757, 1.11205697059631, 1.11215078830719, 1.1122442483902, 1.11233723163605, 1.11243009567261, 1.11252272129059, 1.1126149892807, 1.11270678043365, 1.11279833316803, 1.11288952827454, 1.11298048496246, 1.11307120323181, 1.11316156387329, 1.11325144767761, 1.11334109306335, 1.11343050003052, 1.1135196685791, 1.11360824108124, 1.11369681358337, 1.11378490924835, 1.11387264728546, 1.1139600276947, 1.11404728889465, 1.11413407325745, 1.11422061920166, 1.11430668830872, 1.11439263820648, 1.11447811126709, 1.11456334590912, 1.11464834213257, 1.11473298072815, 1.11481726169586, 1.11490118503571, 1.11498486995697, 1.11506831645966, 1.11515116691589, 1.11523377895355, 1.11531639099121, 1.11539828777313, 1.11548018455505, 1.11556148529053, 1.115642786026, 1.11572349071503, 1.11580407619476, 1.11588418483734, 1.11596417427063, 1.11604368686676, 1.11612284183502, 1.11620163917542, 1.11628031730652, 1.11635863780975, 1.11643648147583, 1.11651420593262, 1.11659157276154, 1.1166684627533, 1.11674523353577, 1.11682164669037, 1.1168977022171, 1.11697340011597, 1.11704885959625, 1.11712396144867, 1.11719870567322, 1.11727321147919, 1.117347240448, 1.11742103099823, 1.11749470233917, 1.11756801605225, 1.11764073371887, 1.11771333217621, 1.11778557300568, 1.11785757541656, 1.1179291009903, 1.11800038814545, 1.11807131767273, 1.11814200878143, 1.11821234226227, 1.11828243732452, 1.11835217475891, 1.11842155456543, 1.11849069595337, 1.11855936050415, 1.11862778663635, 1.11869597434998, 1.11876380443573, 1.11883139610291, 1.11889851093292, 1.11896538734436, 1.11903190612793, 1.11909830570221, 1.11916410923004, 1.11922967433929, 1.11929488182068, 1.11935985088348, 1.119424700737, 1.11948895454407, 1.11955285072327, 1.11961662769318, 1.11967992782593, 1.11974310874939, 1.1198056936264, 1.11986815929413, 1.11993038654327, 1.11999213695526, 1.12005364894867, 1.12011480331421, 1.12017571926117, 1.12023615837097, 1.12029635906219, 1.12035620212555, 1.12041580677032, 1.12047517299652, 1.12053406238556, 1.12059259414673, 1.1206511259079, 1.12070906162262, 1.12076663970947, 1.12082409858704, 1.12088108062744, 1.12093782424927, 1.12099432945251, 1.12105023860931, 1.12110602855682, 1.12116158008575, 1.12121677398682, 1.12127149105072, 1.12132608890533, 1.12138020992279, 1.12143397331238, 1.12148761749268, 1.1215409040451, 1.12159383296967, 1.12164640426636, 1.12169873714447, 1.12175071239471, 1.12180233001709, 1.1218535900116, 1.12190461158752, 1.12195539474487, 1.12200582027435, 1.12205600738525, 1.122105717659, 1.12215518951416, 1.12220418453217, 1.12225306034088, 1.12230157852173, 1.12234973907471, 1.12239766120911, 1.12244510650635, 1.12249219417572, 1.12253928184509, 1.12258577346802, 1.12263214588165, 1.12267804145813, 1.12272369861603, 1.12276887893677, 1.12281394004822, 1.12285876274109, 1.1229031085968, 1.12294709682465, 1.1229909658432, 1.12303411960602, 1.12307739257812, 1.12312018871307, 1.12316262722015, 1.12320482730865, 1.12324655056, 1.12328815460205, 1.12332928180695, 1.12337017059326, 1.123410820961, 1.12345099449158, 1.12349104881287, 1.12353050708771, 1.12356996536255, 1.12360894680023, 1.12364745140076, 1.12368595600128, 1.12372410297394, 1.12376165390015, 1.12379908561707, 1.12383627891541, 1.1238728761673, 1.12390923500061, 1.12394559383392, 1.12398135662079, 1.12401676177979, 1.12405204772949, 1.12408685684204, 1.12412142753601, 1.12415564060211, 1.12418961524963, 1.12422299385071, 1.12425637245178, 1.12428951263428, 1.12432193756104, 1.12435436248779, 1.12434577941895, 1.12429630756378, 1.12424635887146, 1.12419629096985, 1.12414586544037, 1.12409508228302, 1.1240439414978, 1.1239926815033, 1.12394118309021, 1.12388908863068, 1.12383699417114, 1.12378442287445, 1.12373161315918, 1.12367844581604, 1.12362504005432, 1.12357139587402, 1.12351727485657, 1.12346303462982, 1.1234085559845, 1.12335360050201, 1.12329828739166, 1.12324285507202, 1.12318706512451, 1.12313091754913, 1.12307465076447, 1.12301790714264, 1.12296080589294, 1.12290370464325, 1.1228461265564, 1.12278831005096, 1.12273001670837, 1.12267160415649, 1.12261283397675, 1.12255382537842, 1.12249445915222, 1.12243473529816, 1.1223748922348, 1.12231469154358, 1.12225413322449, 1.12219321727753, 1.12213218212128, 1.12207067012787, 1.12200903892517, 1.12194693088531, 1.12188470363617, 1.12182199954987, 1.12175905704498, 1.12169587612152, 1.12163233757019, 1.12156867980957, 1.1215044260025, 1.12144017219543, 1.12137544155121, 1.12131035327911, 1.12124514579773, 1.12117958068848, 1.12111377716064, 1.12104737758636, 1.12098109722137, 1.12091422080994, 1.12084722518921, 1.12077987194061, 1.12071216106415, 1.1206442117691, 1.12057590484619, 1.12050724029541, 1.12043845653534, 1.12036943435669, 1.12030005455017, 1.12023019790649, 1.12016010284424, 1.1200897693634, 1.12001919746399, 1.11994826793671, 1.11987698078156, 1.11980545520782, 1.11973369121552, 1.11966156959534, 1.11958920955658, 1.11951637268066, 1.11944341659546, 1.11937022209167, 1.11929655075073, 1.1192227602005, 1.11914849281311, 1.11907386779785, 1.11899924278259, 1.11892414093018, 1.11884880065918, 1.11877310276031, 1.11869704723358, 1.11862075328827, 1.11854422092438, 1.11846745014191, 1.11839020252228, 1.11831283569336, 1.11823511123657, 1.11815690994263, 1.11807858943939, 1.11800003051758, 1.1179211139679, 1.11784183979034, 1.11776232719421, 1.11768245697021, 1.11760246753693, 1.11752188205719, 1.11744105815887, 1.11736023426056, 1.1172788143158, 1.11719727516174, 1.11711537837982, 1.11703300476074, 1.11695063114166, 1.11686778068542, 1.11678469181061, 1.11670124530792, 1.11661744117737, 1.11653351783752, 1.1164493560791, 1.11636471748352, 1.11627995967865, 1.11619472503662, 1.11610925197601, 1.11602342128754, 1.11593747138977, 1.11585092544556, 1.11576437950134, 1.11567735671997, 1.11559009552002, 1.11550259590149, 1.11541473865509, 1.11532652378082, 1.11523807048798, 1.11514937877655, 1.11506032943726, 1.11497116088867, 1.11488151550293, 1.11479151248932, 1.11470115184784, 1.11461079120636, 1.11451983451843, 1.11442875862122, 1.11433744430542, 1.11424577236176, 1.11415362358093, 1.11406135559082, 1.11396884918213, 1.11387586593628, 1.11378288269043, 1.11368918418884, 1.11359548568726, 1.11350131034851, 1.11340689659119, 1.11331236362457, 1.11321723461151, 1.11312198638916, 1.11302649974823, 1.11293065547943, 1.11283445358276, 1.11273801326752, 1.11264109611511, 1.112544298172, 1.11244678497314, 1.112349152565, 1.11225128173828, 1.11215305328369, 1.11205446720123, 1.1119556427002, 1.11185646057129, 1.1117570400238, 1.11165738105774, 1.11155736446381, 1.111456990242, 1.11135649681091, 1.11125552654266, 1.11115443706512, 1.11105287075043, 1.11095106601715, 1.11084890365601, 1.11074650287628, 1.11064374446869, 1.11054074764252, 1.11043751239777, 1.11033391952515, 1.11023008823395, 1.11012589931488, 1.11002135276794, 1.10991668701172, 1.10981166362762, 1.10970628261566, 1.10960054397583, 1.10949456691742, 1.10938835144043, 1.10928189754486, 1.10917484760284, 1.10906791687012, 1.10896039009094, 1.10885274410248, 1.10874462127686, 1.10863626003265, 1.10852766036987, 1.10841870307922, 1.10830950737, 1.10820007324219, 1.10809016227722, 1.10798013210297, 1.10786974430084, 1.10775899887085, 1.10764801502228, 1.10753655433655, 1.10742509365082, 1.10731327533722, 1.10720098018646, 1.10708844661713, 1.10697567462921, 1.10686266422272, 1.10674929618835, 1.10663557052612, 1.10652160644531, 1.10640728473663, 1.10629284381866, 1.10617780685425, 1.10606276988983, 1.10594725608826, 1.10583162307739, 1.10571551322937, 1.10559916496277, 1.1054824590683, 1.10536551475525, 1.10524833202362, 1.10513079166412, 1.10501289367676, 1.1048948764801, 1.10477638244629, 1.1046576499939, 1.10453867912292, 1.10441935062408, 1.10429978370667, 1.10417973995209, 1.10405957698822, 1.10393917560577, 1.10381829738617, 1.10369729995728, 1.10357582569122, 1.1034539937973, 1.10333216190338, 1.1032098531723, 1.10308718681335, 1.10296440124512, 1.10284125804901, 1.10271775722504, 1.10259389877319, 1.10246980190277, 1.10234546661377, 1.10222089290619, 1.10209584236145, 1.10197067260742, 1.10184514522552, 1.10171937942505, 1.10159313678741, 1.10146677494049, 1.10133993625641, 1.10121285915375, 1.1010856628418, 1.10095798969269, 1.10082995891571, 1.10070180892944, 1.10057330131531, 1.10044455528259, 1.10031533241272, 1.10018599033356, 1.10005617141724, 1.09992623329163, 1.09979593753815, 1.09966540336609, 1.09953439235687, 1.09940338134766, 1.09927189350128, 1.09914004802704, 1.09900796413422, 1.09887564182281, 1.09874284267426, 1.09860992431641, 1.09847664833069, 1.09834313392639, 1.09820938110352, 1.09807515144348, 1.09794068336487, 1.09780597686768, 1.09767079353333, 1.09753549098969, 1.09739971160889, 1.09726393222809, 1.09712779521942, 1.0969911813736, 1.09685432910919, 1.09671711921692, 1.09657967090607, 1.09644198417664, 1.09630393981934, 1.09616553783417, 1.096027135849, 1.09588813781738, 1.09574902057648, 1.0956095457077, 1.09546959400177, 1.09532964229584, 1.09518921375275, 1.09504854679108, 1.09490740299225, 1.09476625919342, 1.09462463855743, 1.09448277950287, 1.09434044361115, 1.09419810771942, 1.09405529499054, 1.09391224384308, 1.09376895427704, 1.09362518787384, 1.09348130226135, 1.093337059021, 1.09319245815277, 1.09304761886597, 1.09290254116058, 1.09275710582733, 1.0926114320755, 1.0924654006958, 1.09231889247894, 1.09217238426208, 1.09202539920807, 1.09187829494476, 1.0917307138443, 1.09158289432526, 1.09143471717834, 1.09128642082214, 1.09113764762878, 1.09098875522614, 1.09083938598633, 1.09068977832794, 1.09053981304169, 1.09038972854614, 1.09023928642273, 1.09008836746216, 1.0899373292923, 1.08978593349457, 1.08963441848755, 1.08948230743408, 1.08932995796204, 1.08917737007141, 1.08902454376221, 1.08887147903442, 1.08871805667877, 1.08856415748596, 1.08841013908386, 1.08825588226318, 1.08810126781464, 1.08794629573822, 1.08779108524323, 1.08763551712036, 1.08747959136963, 1.08732354640961, 1.08716702461243, 1.08701038360596, 1.08685338497162, 1.0866961479187, 1.08653843402863, 1.08638060092926, 1.08622241020203, 1.08606386184692, 1.08590507507324, 1.08574593067169, 1.08558666706085, 1.08542692661285, 1.08526682853699, 1.08510661125183, 1.08494603633881, 1.0847852230072, 1.08462405204773, 1.08446252346039, 1.08430087566376, 1.08413875102997, 1.0839763879776, 1.08381366729736, 1.08365070819855, 1.08348751068115, 1.08332395553589, 1.08316016197205, 1.08299589157104, 1.08283150196075, 1.0826667547226, 1.08250176906586, 1.08233654499054, 1.08217084407806, 1.08200478553772, 1.08183860778809, 1.08167207241058, 1.0815052986145, 1.08133816719055, 1.08117079734802, 1.08100306987762, 1.08083510398865, 1.0806667804718, 1.08049821853638, 1.08032929897308, 1.08016014099121, 1.07999062538147, 1.07982087135315, 1.07965075969696, 1.07948040962219, 1.07930970191956, 1.07913875579834, 1.07896757125854, 1.07879590988159, 1.07862412929535, 1.07845187187195, 1.07827949523926, 1.07810664176941, 1.07793366909027, 1.07776033878326, 1.07758677005768, 1.07741272449493, 1.0772385597229, 1.07706391811371, 1.07688915729523, 1.07671403884888, 1.07653856277466, 1.07636296749115, 1.07618689537048, 1.07601058483124, 1.07583391666412, 1.07565701007843, 1.07547986507416, 1.07530236244202, 1.07512450218201, 1.07494640350342, 1.07476794719696, 1.07458937168121, 1.07441031932831, 1.07423114776611, 1.07405161857605, 1.07387161254883, 1.07369148731232, 1.07351100444794, 1.07333016395569, 1.07314908504486, 1.07296776771545, 1.07278621196747, 1.07260417938232, 1.0724219083786, 1.0722393989563, 1.07205653190613, 1.07187342643738, 1.07168996334076, 1.07150626182556, 1.0713222026825, 1.07113790512085, 1.07095336914062, 1.07076835632324, 1.07058310508728, 1.07039761543274, 1.07021176815033, 1.07002568244934, 1.06983923912048, 1.06965255737305, 1.06946563720703, 1.06927824020386, 1.0690906047821, 1.06890285015106, 1.06871461868286, 1.06852614879608, 1.06833732128143, 1.0681483745575, 1.0679589509964, 1.06776928901672, 1.06757926940918, 1.06738901138306, 1.06719851493835, 1.06700754165649, 1.06681632995605, 1.06662487983704, 1.06643331050873, 1.06624114513397, 1.06604874134064, 1.06585621833801, 1.06566321849823, 1.06546998023987, 1.06527650356293, 1.06508255004883, 1.06488859653473, 1.06469404697418, 1.06449937820435, 1.06430435180664, 1.06410908699036, 1.0639134645462, 1.06371760368347, 1.06352138519287, 1.0633248090744, 1.06312811374664, 1.06293094158173, 1.06273353099823, 1.06253588199615, 1.06233787536621, 1.06213963031769, 1.0619410276413, 1.06174218654633, 1.06154298782349, 1.06134343147278, 1.06114375591278, 1.06094372272491, 1.06074333190918, 1.06054270267487, 1.06034171581268, 1.06014049053192, 1.05993890762329, 1.05973708629608, 1.059534907341, 1.05933248996735, 1.05912971496582, 1.05892670154572, 1.05872344970703, 1.05851972103119, 1.05831587314606, 1.05811166763306, 1.05790710449219, 1.05770230293274, 1.05749726295471, 1.05729186534882, 1.05708611011505, 1.05688011646271, 1.05667388439178, 1.0564671754837, 1.05626034736633, 1.05605316162109, 1.05584561824799, 1.0556378364563, 1.05542981624603, 1.0552214384079, 1.05501282215118, 1.0548038482666, 1.05459451675415, 1.05438494682312, 1.05417513847351, 1.05396497249603, 1.05375456809998, 1.05354380607605, 1.05333268642426, 1.05312132835388, 1.05290985107422, 1.05269777774811, 1.05248558521271, 1.05227303504944, 1.05206024646759, 1.05184710025787, 1.05163359642029, 1.05141997337341, 1.05120599269867, 1.05099165439606, 1.05077707767487, 1.05056214332581, 1.05034685134888, 1.05013144016266, 1.04991567134857, 1.04969954490662, 1.04948318004608, 1.04926645755768, 1.0490494966507, 1.04883217811584, 1.04861462116241, 1.04839670658112, 1.04817855358124, 1.04796004295349, 1.04774141311646, 1.04752230644226, 1.04730296134949, 1.04708325862885, 1.04686331748962, 1.04664313793182, 1.04642248153687, 1.04620170593262, 1.0459805727005, 1.04575908184052, 1.04553735256195, 1.04531538486481, 1.04509305953979, 1.04487037658691, 1.04464757442474, 1.04442417621613, 1.04420077800751, 1.04397690296173, 1.04375290870667, 1.04352843761444, 1.04330372810364, 1.04307878017426, 1.04285335540771, 1.04262781143188, 1.04240190982819, 1.04217565059662, 1.04194927215576, 1.04172241687775, 1.04149544239044, 1.04126811027527, 1.04104042053223, 1.04081237316132, 1.04058420658112, 1.04035556316376, 1.04012668132782, 1.0398975610733, 1.03966808319092, 1.03943836688995, 1.03920829296112, 1.03897798061371, 1.03874742984772, 1.03851640224457, 1.03828513622284, 1.03805363178253, 1.03782176971436, 1.0375896692276, 1.03735733032227, 1.03712463378906, 1.03689157962799, 1.03665816783905, 1.03642463684082, 1.03619074821472, 1.03595650196075, 1.03572201728821, 1.03548729419708, 1.0352520942688, 1.03501677513123, 1.03478109836578, 1.03454506397247, 1.03430879116058, 1.03407227993011, 1.03383529186249, 1.03359818458557, 1.03336071968079, 1.03312301635742, 1.03288495540619, 1.03264653682709, 1.03240787982941, 1.03216886520386, 1.03192973136902, 1.03169012069702, 1.03145039081573, 1.03121018409729, 1.03096973896027, 1.03072905540466, 1.03048801422119, 1.03024673461914, 1.03000497817993, 1.02976310253143, 1.02952086925507, 1.02927839756012, 1.0290355682373, 1.02879238128662, 1.02854907512665, 1.02830541133881, 1.0280613899231, 1.02781713008881, 1.02757251262665, 1.02732753753662, 1.02708256244659, 1.02683687210083, 1.02659118175507, 1.02634513378143, 1.02609872817993, 1.02585196495056, 1.0256050825119, 1.02535784244537, 1.02511024475098, 1.02486228942871, 1.02461433410645, 1.02436578273773, 1.02411699295044, 1.02386796474457, 1.02361857891083, 1.02336895465851, 1.02311909198761, 1.02286887168884, 1.02261829376221, 1.02236747741699, 1.02211630344391, 1.02186489105225, 1.021613240242, 1.02136123180389, 1.0211089849472, 1.02085638046265, 1.02060341835022, 1.02035021781921, 1.02009677886963, 1.01984286308289, 1.01958882808685, 1.01933443546295, 1.01907980442047, 1.01882481575012, 1.0185694694519, 1.0183140039444, 1.01805806159973, 1.01780188083649, 1.01754546165466, 1.01728868484497, 1.01703155040741, 1.01677429676056, 1.01651656627655, 1.01625859737396, 1.0160003900528, 1.01574182510376, 1.01548302173615, 1.01522386074066, 1.0149644613266, 1.01470470428467, 1.01444470882416, 1.01418435573578, 1.01392376422882, 1.01366281509399, 1.01340162754059, 1.01314008235931, 1.01287829875946, 1.01261627674103, 1.01235377788544, 1.01209115982056, 1.01182806491852, 1.01156485080719, 1.01130127906799, 1.01103734970093, 1.01077318191528, 1.01050865650177, 1.01024389266968, 1.00997889041901, 1.00971341133118, 1.00944781303406, 1.00918173789978, 1.00891554355621, 1.00864899158478, 1.00838208198547, 1.00811505317688, 1.00784754753113, 1.0075798034668, 1.0073117017746, 1.00704348087311, 1.00677478313446, 1.00650584697723, 1.00623655319214, 1.00596702098846, 1.00569725036621, 1.00542712211609, 1.0051566362381, 1.00488591194153, 1.00461494922638, 1.00434362888336, 1.00407207012177, 1.0038001537323, 1.00352799892426, 1.00325548648834, 1.00298273563385, 1.00270962715149, 1.00243616104126, 1.00216245651245, 1.00188851356506, 1.0016143321991, 1.00133967399597, 1.00106477737427, 1.00078964233398, 1.00051414966583, 1.0002384185791, 0.999962389469147, 0.999685943126678, 0.999409377574921, 0.999132394790649, 0.998855113983154, 0.998577654361725, 0.998299837112427, 0.99802166223526, 0.997743248939514, 0.9974644780159, 0.997185409069061, 0.996906101703644, 0.996626555919647, 0.996346652507782, 0.996066331863403, 0.995785892009735, 0.995505094528198, 0.995223999023438, 0.994942545890808, 0.994660794734955, 0.994378805160522, 0.994096577167511, 0.993814051151276, 0.993531167507172, 0.993247866630554, 0.992964446544647, 0.992680668830872, 0.992396593093872, 0.992112159729004, 0.991827487945557, 0.99154257774353, 0.991257309913635, 0.990971744060516, 0.990685939788818, 0.990399777889252, 0.990113377571106, 0.989826560020447, 0.989539563655853, 0.989252209663391, 0.988964557647705, 0.988676607608795, 0.988388359546661, 0.988099873065948, 0.987811088562012, 0.987521886825562, 0.987232565879822, 0.986942768096924, 0.986652791500092, 0.986362457275391, 0.986071884632111, 0.985780954360962, 0.985489726066589, 0.985198259353638, 0.984906494617462, 0.984614372253418, 0.98432195186615, 0.984029293060303, 0.983736336231232, 0.983443021774292, 0.983149528503418, 0.982855618000031, 0.982561469078064, 0.982267022132874, 0.981972217559814, 0.981677114963531, 0.981381833553314, 0.981086134910583, 0.980790257453918, 0.980494022369385, 0.980197370052338, 0.979900598526001, 0.979603469371796, 0.979306101799011, 0.979008316993713, 0.978710293769836, 0.978411912918091, 0.978113353252411, 0.977814376354218, 0.977515161037445, 0.977215707302094, 0.976915836334229, 0.976615726947784, 0.976315319538116, 0.976014614105225, 0.975713670253754, 0.975412368774414, 0.975110828876495, 0.974808871746063, 0.974506676197052, 0.974204242229462, 0.973901510238647, 0.973598420619965, 0.973295092582703, 0.972991466522217, 0.972687423229218, 0.972383201122284, 0.972078621387482, 0.971773743629456, 0.97146862745285, 0.971163094043732, 0.970857441425323, 0.970551431179047, 0.970245003700256, 0.969938397407532, 0.969631433486938, 0.969324231147766, 0.969016671180725, 0.968708872795105, 0.968400716781616, 0.968092381954193, 0.967783689498901, 0.967474579811096, 0.967165291309357, 0.966855704784393, 0.966545879840851, 0.966235637664795, 0.96592515707016, 0.965614318847656, 0.965303301811218, 0.964991867542267, 0.964680254459381, 0.964368164539337, 0.964055895805359, 0.963743329048157, 0.963430523872375, 0.963117301464081, 0.962803840637207, 0.962490141391754, 0.962176024913788, 0.961861610412598, 0.961547017097473, 0.96123206615448, 0.960916817188263, 0.960601329803467, 0.960285484790802, 0.959969341754913, 0.959652960300446, 0.959336161613464, 0.959019184112549, 0.958701848983765, 0.958384215831757, 0.958066284656525, 0.957748055458069, 0.957429528236389, 0.95711076259613, 0.956791698932648, 0.956472277641296, 0.956152558326721, 0.955832540988922, 0.955512285232544, 0.955191731452942, 0.954870879650116, 0.954549610614777, 0.954228103160858, 0.953906357288361, 0.953584372997284, 0.953261971473694, 0.95293927192688, 0.952616393566132, 0.952293038368225, 0.951969504356384, 0.951645612716675, 0.951321482658386, 0.950997054576874, 0.950672328472137, 0.950347244739532, 0.950021862983704, 0.94969630241394, 0.949370324611664, 0.949044108390808, 0.948717534542084, 0.94839084148407, 0.948063611984253, 0.947736322879791, 0.947408556938171, 0.947080612182617, 0.94675225019455, 0.946423649787903, 0.946094751358032, 0.945765554904938, 0.945436000823975, 0.945106267929077, 0.944776117801666, 0.944445788860321, 0.944115161895752, 0.943784058094025, 0.943452835083008, 0.943121254444122, 0.942789375782013, 0.942457258701324, 0.942124783992767, 0.941792011260986, 0.941459000110626, 0.941125571727753, 0.9407919049263, 0.940457999706268, 0.940123796463013, 0.939789235591888, 0.93945437669754, 0.939119279384613, 0.938783764839172, 0.938448131084442, 0.938112080097198, 0.937775790691376, 0.93743908405304, 0.937102198600769, 0.936765015125275, 0.936427474021912, 0.936089634895325, 0.935751557350159, 0.935413181781769, 0.93507444858551, 0.934735536575317, 0.934396147727966, 0.93405669927597, 0.933716773986816, 0.933376550674438, 0.933036088943481, 0.932695329189301, 0.932354271411896, 0.932012856006622, 0.931671261787415, 0.931329250335693, 0.930987000465393, 0.930644452571869, 0.930301547050476, 0.929958462715149, 0.929614901542664, 0.929271221160889, 0.928927183151245, 0.928582847118378, 0.928238272666931, 0.927893340587616, 0.927548050880432, 0.927202522754669, 0.926856756210327, 0.926498591899872, 0.926128327846527, 0.925758004188538, 0.925387561321259, 0.925017118453979, 0.924646496772766, 0.924275934696198, 0.923905193805695, 0.923534512519836, 0.923163652420044, 0.922792792320251, 0.922421813011169, 0.922050833702087, 0.921679675579071, 0.921308577060699, 0.920937359333038, 0.920566082000732, 0.920194804668427, 0.919823288917542, 0.919451832771301, 0.919080317020416, 0.918708682060242, 0.918337047100067, 0.917965292930603, 0.917593419551849, 0.91722160577774, 0.916849672794342, 0.916477620601654, 0.916105628013611, 0.915733456611633, 0.915361225605011, 0.914988934993744, 0.914616644382477, 0.91424423456192, 0.913871765136719, 0.913499236106873, 0.913126528263092, 0.912753939628601, 0.912381231784821, 0.912008464336395, 0.911635458469391, 0.911262631416321, 0.910889565944672, 0.910516500473022, 0.910143315792084, 0.909770131111145, 0.909396946430206, 0.909023642539978, 0.90865021944046, 0.908276796340942, 0.907903254032135, 0.907529652118683, 0.907155990600586, 0.906782269477844, 0.906408429145813, 0.906034469604492, 0.905660629272461, 0.905286729335785, 0.90491259098053, 0.904538452625275, 0.90416431427002, 0.90379011631012, 0.903415739536285, 0.903041362762451, 0.902666807174683, 0.902292311191559, 0.90191775560379, 0.901543140411377, 0.901168406009674, 0.900793612003326, 0.900418817996979, 0.900043845176697, 0.899668872356415, 0.899293839931488, 0.898918688297272, 0.898543477058411, 0.89816826581955, 0.897792935371399, 0.897417545318604, 0.897042155265808, 0.896666586399078, 0.896291017532349, 0.895915389060974, 0.895539700984955, 0.895163953304291, 0.894788086414337, 0.894412219524384, 0.894036173820496, 0.893660128116608, 0.89328396320343, 0.892907798290253, 0.89253169298172, 0.892155289649963, 0.891778945922852, 0.89140248298645, 0.891026020050049, 0.890649437904358, 0.890272796154022, 0.889896035194397, 0.889519274234772, 0.889142453670502, 0.888765573501587, 0.888388633728027, 0.888011574745178, 0.887634515762329, 0.887257277965546, 0.886880099773407, 0.886502802371979, 0.886125385761261, 0.885747849941254, 0.885370552539825, 0.884992957115173, 0.884615242481232, 0.88423752784729, 0.883859753608704, 0.883481979370117, 0.883104026317596, 0.882726073265076, 0.88234806060791, 0.881970047950745, 0.881591856479645, 0.881213665008545, 0.880835294723511, 0.880456924438477, 0.880078554153442, 0.879700064659119, 0.879321455955505, 0.878942906856537, 0.878564238548279, 0.878185391426086, 0.877806603908539, 0.877427697181702, 0.877048850059509, 0.876669764518738, 0.876290678977966, 0.87591153383255, 0.875532388687134, 0.875153005123138, 0.874773621559143, 0.874394237995148, 0.874014854431152, 0.873635172843933, 0.873255670070648, 0.872875928878784, 0.872496247291565, 0.872116446495056, 0.871736526489258, 0.871356546878815, 0.870976567268372, 0.870596468448639, 0.870216369628906, 0.869836151599884, 0.869455873966217, 0.86907547712326, 0.868695080280304, 0.868314564228058, 0.867934107780457, 0.867553532123566, 0.86717289686203, 0.86679208278656, 0.86641126871109, 0.866030335426331, 0.865649461746216, 0.865268528461456, 0.864887356758118, 0.864506244659424, 0.86412501335144, 0.863743841648102, 0.863362491130829, 0.862981021404266, 0.862599670886993, 0.862218081951141, 0.861836493015289, 0.861454844474792, 0.861073017120361, 0.860691249370575, 0.860309362411499, 0.859927475452423, 0.859545588493347, 0.859163403511047, 0.858781278133392, 0.858399093151093, 0.858016848564148, 0.857634484767914, 0.85725212097168, 0.856869697570801, 0.856487095355988, 0.856104612350464, 0.855721950531006, 0.855339229106903, 0.854956448078156, 0.854573547840118, 0.854190647602081, 0.853807628154755, 0.853424549102783, 0.853041470050812, 0.852658331394196, 0.852275013923645, 0.851891756057739, 0.851508259773254, 0.851124942302704, 0.850741386413574, 0.850357830524445, 0.849974095821381, 0.849590361118317, 0.849206626415253, 0.848822832107544, 0.848438918590546, 0.848054885864258, 0.84767085313797, 0.847286701202393, 0.84690260887146, 0.846518397331238, 0.846133947372437, 0.84574967622757, 0.845365226268768, 0.844980776309967, 0.844596207141876, 0.844211459159851, 0.843826770782471, 0.84344208240509, 0.843057155609131, 0.842672228813171, 0.842287302017212, 0.841902196407318, 0.841517090797424, 0.841131985187531, 0.840746760368347, 0.840361416339874, 0.839976072311401, 0.839590609073639, 0.839205086231232, 0.838819622993469, 0.838433861732483, 0.838048279285431, 0.8376624584198, 0.837276637554169, 0.836890757083893, 0.836504697799683, 0.836118757724762, 0.835732638835907, 0.835346519947052, 0.834960222244263, 0.834573984146118, 0.834187567234039, 0.833801209926605, 0.833414673805237, 0.833028137683868, 0.832641422748566, 0.832254707813263, 0.83186811208725, 0.831481218338013, 0.831094324588776, 0.830707371234894, 0.830320298671722, 0.829933285713196, 0.829546093940735, 0.829158842563629, 0.828771531581879, 0.828384220600128, 0.827996909618378, 0.827609419822693, 0.827221810817719, 0.826834142208099, 0.826446533203125, 0.826058804988861, 0.825671017169952, 0.825283050537109, 0.824895143508911, 0.824507117271423, 0.824119031429291, 0.823730945587158, 0.823342680931091, 0.822954416275024, 0.822566092014313, 0.822177648544312, 0.821789145469666, 0.82140064239502, 0.821011960506439, 0.820623397827148, 0.820234596729279, 0.819845795631409, 0.819456934928894, 0.81906795501709, 0.818678975105286, 0.818289935588837, 0.817900836467743, 0.817511558532715, 0.817122280597687, 0.816732943058014, 0.816343545913696, 0.815954148769379, 0.815564572811127, 0.81517493724823, 0.814785301685333, 0.814395546913147, 0.814005792140961, 0.813615918159485, 0.813225924968719, 0.812835931777954, 0.812445878982544, 0.812055706977844, 0.811665534973145, 0.811275362968445, 0.810885012149811, 0.810494601726532, 0.810104072093964, 0.809713661670685, 0.809322953224182, 0.808932363986969, 0.808541655540466, 0.808150768280029, 0.807759940624237, 0.807368993759155, 0.806978106498718, 0.806587040424347, 0.806195855140686, 0.805804669857025, 0.805413484573364, 0.805022180080414, 0.804630696773529, 0.804239273071289, 0.80384773015976, 0.803456127643585, 0.803064584732056, 0.802672863006592, 0.802281022071838, 0.80188912153244, 0.801497280597687, 0.801105260848999, 0.800713181495667, 0.800321102142334, 0.799928903579712, 0.799536645412445, 0.799144387245178, 0.798752069473267, 0.798359513282776, 0.79796701669693, 0.797574520111084, 0.797181844711304, 0.796789169311523, 0.796396315097809, 0.796003580093384, 0.79561060667038, 0.795217573642731, 0.794824600219727, 0.794431447982788, 0.794038355350494, 0.793645083904266, 0.793251752853394, 0.792858362197876, 0.792464911937714, 0.792071402072906, 0.791677892208099, 0.791284263134003, 0.790890455245972, 0.790496706962585, 0.790102958679199, 0.789709031581879, 0.789315104484558, 0.788920938968658, 0.788526952266693, 0.788132846355438, 0.787738621234894, 0.787344336509705, 0.786949872970581, 0.786555409431458, 0.786160945892334, 0.785766363143921, 0.785371840000153, 0.78497701883316, 0.784582257270813, 0.784187495708466, 0.783792614936829, 0.783397614955902, 0.783002555370331, 0.78260749578476, 0.782212376594543, 0.781817078590393, 0.781421840190887, 0.781026482582092, 0.780631124973297, 0.780235528945923, 0.779840052127838, 0.779444396495819, 0.77904862165451, 0.778652906417847, 0.778257191181183, 0.777861297130585, 0.777465343475342, 0.777069270610809, 0.776673257350922, 0.7762770652771, 0.775880873203278, 0.775484621524811, 0.775088250637054, 0.774691879749298, 0.774295389652252, 0.773898839950562, 0.773502230644226, 0.773105502128601, 0.772708714008331, 0.772311985492706, 0.771915137767792, 0.771518111228943, 0.771121084690094, 0.770724058151245, 0.770326912403107, 0.769929707050323, 0.769532382488251, 0.769135057926178, 0.76873767375946, 0.768340349197388, 0.767942667007446, 0.767544984817505, 0.767147421836853, 0.766749620437622, 0.766351878643036, 0.76595401763916, 0.765556037425995, 0.765157997608185, 0.764759957790375, 0.76436185836792, 0.763963580131531, 0.763565361499786, 0.763166964054108, 0.762768685817719, 0.762370228767395, 0.761971652507782, 0.761573135852814, 0.761174440383911, 0.760775625705719, 0.760376870632172, 0.759978055953979, 0.759579122066498, 0.759180009365082, 0.7587810754776, 0.758381903171539, 0.757982790470123, 0.757583439350128, 0.757184207439423, 0.756784737110138, 0.756385266780853, 0.755985796451569, 0.755586206912994, 0.755186498165131, 0.754786849021912, 0.754387080669403, 0.753987193107605, 0.753587186336517, 0.753187298774719, 0.752787232398987, 0.75238710641861, 0.751986920833588, 0.751586675643921, 0.751186311244965, 0.750786066055298, 0.750385582447052, 0.749984979629517, 0.749584376811981, 0.749183714389801, 0.748783111572266, 0.748382329940796, 0.747981429100037, 0.747580528259277, 0.747179627418518, 0.746778547763824, 0.746377468109131, 0.745976150035858, 0.74557501077652, 0.745173633098602, 0.74477231502533, 0.744370877742767, 0.743969261646271, 0.743567824363708, 0.743166148662567, 0.742764472961426, 0.74236273765564, 0.741960823535919, 0.741558909416199, 0.741156995296478, 0.740754961967468, 0.740352869033813, 0.739950656890869, 0.739548325538635, 0.739146113395691, 0.738743841648102, 0.738341331481934, 0.737938761711121, 0.737536251544952, 0.737133622169495, 0.736730992794037, 0.736328184604645, 0.735925376415253, 0.735522449016571, 0.735119462013245, 0.734716415405273, 0.734313309192657, 0.733910262584686, 0.733506917953491, 0.733103632926941, 0.732700347900391, 0.732296943664551, 0.731893360614777, 0.731489956378937, 0.731086194515228, 0.730682551860809, 0.730278789997101, 0.729874968528748, 0.72947108745575, 0.729067146778107, 0.728663206100464, 0.728259027004242, 0.727854907512665, 0.727450668811798, 0.727046370506287, 0.726642072200775, 0.726237595081329, 0.725833058357239, 0.725428581237793, 0.725023984909058, 0.724619269371033, 0.724214613437653, 0.723809659481049, 0.723404884338379, 0.72299998998642, 0.722594916820526, 0.722189784049988, 0.721784651279449, 0.721379399299622, 0.720974206924438, 0.720568895339966, 0.720163404941559, 0.719757974147797, 0.7193523645401, 0.718946814537048, 0.718541145324707, 0.718135297298431, 0.71772962808609, 0.71732372045517, 0.716917872428894, 0.716511785984039, 0.716105699539185, 0.715699553489685, 0.715293407440186, 0.714887082576752, 0.714480757713318, 0.714074313640594, 0.713667929172516, 0.713261306285858, 0.712854862213135, 0.712448000907898, 0.712041437625885, 0.711634576320648, 0.711227715015411, 0.710820853710175, 0.710413753986359, 0.710006713867188, 0.709599554538727, 0.709192454814911, 0.708785116672516, 0.708377778530121, 0.707970380783081, 0.707562983036041, 0.707155525684357, 0.706747889518738, 0.706340134143829, 0.70593249797821, 0.705524742603302, 0.705116808414459, 0.704708933830261, 0.704300880432129, 0.703892886638641, 0.703484714031219, 0.703076601028442, 0.702668368816376, 0.702259957790375, 0.701851546764374, 0.701443135738373, 0.701034665107727, 0.700626134872437, 0.700217425823212, 0.699808657169342, 0.699399888515472, 0.698991060256958, 0.698582172393799, 0.69817316532135, 0.697764158248901, 0.697355031967163, 0.69694584608078, 0.696536660194397, 0.696127235889435, 0.695717930793762, 0.695308446884155, 0.694898962974548, 0.694489359855652, 0.694079697132111, 0.693669974803925, 0.693260192871094, 0.692850351333618, 0.692440569400787, 0.692030489444733, 0.691620469093323, 0.691210389137268, 0.690800249576569, 0.690389931201935, 0.689979672431946, 0.689569294452667, 0.689158856868744, 0.688748419284821, 0.688337802886963, 0.687927186489105, 0.687516450881958, 0.687105655670166, 0.686694920063019, 0.686283946037292, 0.685873031616211, 0.685461938381195, 0.685050964355469, 0.684639751911163, 0.684228479862213, 0.683817148208618, 0.683405816555023, 0.682994365692139, 0.682582914829254, 0.68217134475708, 0.681759715080261, 0.681348025798798, 0.680936276912689, 0.680524468421936, 0.680112481117249, 0.679700613021851, 0.679288566112518, 0.678876519203186, 0.678464293479919, 0.678052127361298, 0.677639842033386, 0.677227556705475, 0.676815032958984, 0.676402568817139, 0.675989985466003, 0.675577402114868, 0.675164759159088, 0.674751937389374, 0.674339234828949, 0.673926174640656, 0.673513352870941, 0.673100292682648, 0.672687292098999, 0.672274112701416, 0.671860933303833, 0.671447575092316, 0.671034276485443, 0.670620858669281, 0.670207321643829, 0.669793844223022, 0.669380247592926, 0.668966591358185, 0.668552696704865, 0.668138980865479, 0.667725086212158, 0.667311191558838, 0.666897177696228, 0.666483104228973, 0.666068971157074, 0.66565465927124, 0.665240466594696, 0.664826095104218, 0.664411723613739, 0.663997173309326, 0.663582742214203, 0.663168132305145, 0.662753522396088, 0.662338733673096, 0.661923825740814, 0.661509096622467, 0.661094069480896, 0.660679161548615, 0.660264015197754, 0.659848868846893, 0.659433662891388, 0.659018456935883, 0.658603131771088, 0.658187806606293, 0.657772243022919, 0.657356739044189, 0.656941175460815, 0.656525492668152, 0.656109809875488, 0.65569394826889, 0.655278146266937, 0.654862225055695, 0.654446244239807, 0.65403014421463, 0.653614044189453, 0.653197824954987, 0.652781546115875, 0.652365267276764, 0.651948809623718, 0.651532351970673, 0.651115894317627, 0.650699377059937, 0.650282621383667, 0.649865925312042, 0.649449110031128, 0.649032294750214, 0.648615300655365, 0.648198366165161, 0.647781252861023, 0.64736419916153, 0.646947026252747, 0.646529793739319, 0.646112561225891, 0.645695090293884, 0.645277559757233, 0.644860088825226, 0.644442558288574, 0.644024968147278, 0.643607139587402, 0.643189430236816, 0.642771601676941, 0.642353653907776, 0.641935706138611, 0.641517698764801, 0.641099572181702, 0.640681385993958, 0.640263199806213, 0.639844834804535, 0.639426410198212, 0.639008045196533, 0.63858950138092, 0.638171017169952, 0.63775235414505, 0.637333571910858, 0.636914789676666, 0.636496007442474, 0.636077105998993, 0.635658085346222, 0.635239064693451, 0.63482004404068, 0.634400844573975, 0.633981585502625, 0.633562445640564, 0.633142948150635, 0.632723569869995, 0.632304012775421, 0.631884455680847, 0.631464779376984, 0.63104510307312, 0.630625367164612, 0.630205571651459, 0.629785656929016, 0.629365622997284, 0.628945648670197, 0.62852555513382, 0.628105401992798, 0.627685189247131, 0.627264857292175, 0.626844584941864, 0.626424074172974, 0.626003623008728, 0.625583052635193, 0.625162482261658, 0.624741733074188, 0.624321043491364, 0.623900175094604, 0.62347936630249, 0.623058378696442, 0.622637331485748, 0.622216284275055, 0.621795117855072, 0.621373951435089, 0.620952606201172, 0.620531260967255, 0.620109856128693, 0.619688391685486, 0.619266867637634, 0.618845164775848, 0.618423521518707, 0.618001818656921, 0.617579996585846, 0.617158114910126, 0.616736114025116, 0.616314172744751, 0.615892052650452, 0.615469932556152, 0.615047812461853, 0.61462539434433, 0.614203095436096, 0.613780736923218, 0.61335825920105, 0.612935721874237, 0.612513065338135, 0.612090408802032, 0.611667692661285, 0.611244916915894, 0.610821962356567, 0.610399067401886, 0.60997599363327, 0.609552979469299, 0.609129846096039, 0.608706593513489, 0.608283340930939, 0.607860147953033, 0.607436716556549, 0.60701322555542, 0.606589615345001, 0.606166124343872, 0.605742394924164, 0.605318665504456, 0.604894876480103, 0.60447108745575, 0.604047119617462, 0.603623032569885, 0.603199064731598, 0.602774918079376, 0.602350652217865, 0.601926445960999, 0.601502180099487, 0.601077735424042, 0.600653290748596, 0.600228726863861, 0.599804162979126, 0.599379479885101, 0.598954796791077, 0.598529994487762, 0.598105132579803, 0.597680151462555, 0.597255289554596, 0.596830189228058, 0.596405148506165, 0.595979869365692, 0.595554709434509, 0.595129311084747, 0.594703912734985, 0.594278573989868, 0.593852996826172, 0.593427419662476, 0.593001782894135, 0.592576086521149, 0.592150211334229, 0.591724336147308, 0.591298580169678, 0.590872526168823, 0.590446531772614, 0.590020358562469, 0.589594185352325, 0.589167892932892, 0.588741600513458, 0.588315367698669, 0.587888777256012, 0.587462306022644, 0.587035775184631, 0.586609125137329, 0.586182415485382, 0.58575564622879, 0.585328757762909, 0.584901869297028, 0.584474861621857, 0.584047853946686, 0.583620727062225, 0.58319354057312, 0.582766354084015, 0.58233904838562, 0.581911742687225, 0.581484258174896, 0.581056833267212, 0.580629229545593, 0.580201685428619, 0.579773843288422, 0.579346120357513, 0.578918278217316, 0.578490376472473, 0.578062474727631, 0.577634334564209, 0.577206254005432, 0.57677811384201, 0.576349914073944, 0.575921654701233, 0.575493276119232, 0.575064837932587, 0.574636340141296, 0.574207723140717, 0.573779165744781, 0.573350489139557, 0.572921633720398, 0.572492897510529, 0.572063982486725, 0.571635127067566, 0.571206152439117, 0.57077693939209, 0.570347845554352, 0.569918572902679, 0.569489300251007, 0.569059908390045, 0.568630456924438, 0.568201005458832, 0.56777149438858, 0.567341804504395, 0.566912174224854, 0.566482424736023, 0.566052615642548, 0.565622687339783, 0.565192878246307, 0.564762771129608, 0.564332723617554, 0.56390255689621, 0.563472330570221, 0.563042044639587, 0.562611699104309, 0.562181293964386, 0.561750888824463, 0.561320304870605, 0.560889661312103, 0.560458958148956, 0.560028254985809, 0.559597432613373, 0.559166610240936, 0.55873566865921, 0.558304607868195, 0.557873487472534, 0.557442426681519, 0.557011246681213, 0.556580007076263, 0.556148529052734, 0.55571722984314, 0.555285751819611, 0.554854273796082, 0.554422616958618, 0.553990960121155, 0.553559243679047, 0.553127467632294, 0.552695572376251, 0.552263677120209, 0.551831662654877, 0.5513995885849, 0.550967454910278, 0.550535202026367, 0.550103008747101, 0.5496706366539, 0.549238324165344, 0.548805832862854, 0.548373281955719, 0.547940790653229, 0.547508060932159, 0.54707533121109, 0.546642541885376, 0.546209692955017, 0.545776784420013, 0.54534375667572, 0.544910669326782, 0.544477641582489, 0.544044435024261, 0.543611109256744, 0.543177783489227, 0.542744398117065, 0.542310953140259, 0.541877448558807, 0.541443824768066, 0.541010141372681, 0.540576457977295, 0.54014265537262, 0.539708912372589, 0.539274871349335, 0.53884094953537, 0.538406908512115, 0.537972807884216, 0.537538647651672, 0.537104427814484, 0.536670088768005, 0.536235690116882, 0.535801231861115, 0.535366773605347, 0.534932136535645, 0.534497499465942, 0.534062802791595, 0.533628046512604, 0.533193230628967, 0.532758235931396, 0.53232330083847, 0.531888246536255, 0.531453192234039, 0.531018078327179, 0.53058272600174, 0.53014749288559, 0.529712080955505, 0.529276669025421, 0.528841197490692, 0.528405547142029, 0.52796995639801, 0.527534306049347, 0.527098536491394, 0.526662647724152, 0.526226699352264, 0.525790810585022, 0.525354743003845, 0.524918675422668, 0.524482548236847, 0.524046242237091, 0.52360999584198, 0.523198544979095, 0.522812008857727, 0.522425532341003, 0.522039175033569, 0.52165299654007, 0.521266877651215, 0.520880877971649, 0.520494937896729, 0.520109176635742, 0.51972359418869, 0.519338011741638, 0.518952608108521, 0.518567264080048, 0.518182039260864, 0.51779693365097, 0.517412006855011, 0.517027139663696, 0.516642332077026, 0.516257703304291, 0.51587325334549, 0.515488803386688, 0.515104532241821, 0.514720261096954, 0.514336228370667, 0.513952255249023, 0.513568460941315, 0.513184785842896, 0.512801110744476, 0.512417554855347, 0.512034177780151, 0.511650919914246, 0.511267781257629, 0.510884702205658, 0.510501801967621, 0.510118961334229, 0.509736239910126, 0.509353637695312, 0.508971095085144, 0.508588850498199, 0.50820654630661, 0.50782436132431, 0.50744241476059, 0.507060408592224, 0.506678700447083, 0.506296992301941, 0.505915462970734, 0.505533933639526, 0.505152583122253, 0.50477135181427, 0.504390239715576, 0.504009246826172, 0.503628313541412, 0.503247439861298, 0.502866864204407, 0.502486288547516, 0.502105891704559, 0.501725554466248, 0.501345276832581, 0.500965178012848, 0.50058525800705, 0.500205397605896, 0.49982562661171, 0.499445974826813, 0.499066382646561, 0.498686939477921, 0.498307675123215, 0.497928440570831, 0.497549444437027, 0.4971704185009, 0.49679160118103, 0.496412813663483, 0.496034234762192, 0.495655715465546, 0.495277345180511, 0.494899034500122, 0.494520843029022, 0.494142770767212, 0.493764877319336, 0.493387013673782, 0.493009299039841, 0.492631733417511, 0.492254227399826, 0.491876810789108, 0.491499572992325, 0.491122484207153, 0.490745425224304, 0.4903684258461, 0.489991635084152, 0.489614903926849, 0.489238411188126, 0.488861888647079, 0.488485515117645, 0.488109260797501, 0.487733155488968, 0.487357139587402, 0.486981272697449, 0.486605376005173, 0.486229777336121, 0.485854148864746, 0.485478758811951, 0.485103338956833, 0.484728127717972, 0.484353065490723, 0.483978003263474, 0.483603239059448, 0.483228296041489, 0.482853710651398, 0.482479155063629, 0.482104808092117, 0.481730490922928, 0.481356292963028, 0.48098212480545, 0.48060816526413, 0.480234295129776, 0.479860603809357, 0.47948694229126, 0.479113399982452, 0.478739976882935, 0.478366702795029, 0.47799351811409, 0.477620452642441, 0.477247565984726, 0.476874709129333, 0.476501941680908, 0.476129293441772, 0.475756824016571, 0.475384473800659, 0.47501215338707, 0.474640101194382, 0.474267899990082, 0.473895996809006, 0.473524183034897, 0.473152548074722, 0.47278094291687, 0.472409337759018, 0.472038000822067, 0.471666812896729, 0.471295654773712, 0.470924645662308, 0.470553785562515, 0.4701828956604, 0.469812214374542, 0.469441682100296, 0.469071269035339, 0.468700915575027, 0.46833062171936, 0.467960506677628, 0.467590570449829, 0.467220634222031, 0.466850876808167, 0.466481119394302, 0.466111570596695, 0.465742170810699, 0.465372860431671, 0.465003579854965, 0.464634478092194, 0.464265584945679, 0.463896661996841, 0.463527947664261, 0.463159173727036, 0.462790727615356, 0.462422281503677, 0.46205398440361, 0.461685836315155, 0.461317658424377, 0.460949748754501, 0.46058189868927, 0.460214227437973, 0.459846526384354, 0.459479004144669, 0.459111571311951, 0.458744376897812, 0.458377242088318, 0.458010137081146, 0.457643121480942, 0.457276344299316, 0.456909596920013, 0.456543058156967, 0.456176549196243, 0.455810189247131, 0.455443829298019, 0.455077707767487, 0.454711705446243, 0.454345792531967, 0.453980058431625, 0.453614324331284, 0.453248649835587, 0.452883243560791, 0.452517867088318, 0.452152609825134, 0.451787531375885, 0.451422452926636, 0.451057583093643, 0.450692802667618, 0.45032811164856, 0.449963569641113, 0.449599176645279, 0.449234753847122, 0.448870539665222, 0.448506444692612, 0.448142468929291, 0.447778552770615, 0.447414875030518, 0.447051107883453, 0.446687638759613, 0.446324199438095, 0.445960909128189, 0.44559770822525, 0.445234566926956, 0.444871604442596, 0.444508761167526, 0.444146066904068, 0.44378337264061, 0.443420827388763, 0.443058460950851, 0.442696183919907, 0.442333996295929, 0.441971987485886, 0.44160994887352, 0.441248089075089, 0.440886348485947, 0.440524756908417, 0.440163314342499, 0.439801812171936, 0.439440578222275, 0.439079463481903, 0.438718408346176, 0.438357442617416, 0.437996625900269, 0.437635898590088, 0.437275350093842, 0.436914920806885, 0.436554491519928, 0.436194181442261, 0.435834050178528, 0.435474127531052, 0.435114204883575, 0.434754431247711, 0.434394627809525, 0.434035122394562, 0.433675616979599, 0.433316379785538, 0.432957112789154, 0.43259796500206, 0.432238936424255, 0.43188002705574, 0.431521266698837, 0.431162655353546, 0.430804014205933, 0.430445641279221, 0.430087298154831, 0.429729074239731, 0.429371029138565, 0.429013043642044, 0.428655177354813, 0.428297370672226, 0.427939742803574, 0.427582234144211, 0.42722487449646, 0.426867544651031, 0.426510274410248, 0.426153242588043, 0.425796300172806, 0.425439476966858, 0.425082743167877, 0.424726039171219, 0.424369543790817, 0.424013197422028, 0.42365688085556, 0.423300713300705, 0.422944694757462, 0.422588706016541, 0.422232925891876, 0.421877205371857, 0.421521604061127, 0.421166002750397, 0.420810699462891, 0.420455455780029, 0.420100331306458, 0.419745266437531, 0.419390320777893, 0.419035673141479, 0.418680936098099, 0.418326288461685, 0.417971760034561, 0.417617350816727, 0.417263150215149, 0.416909009218216, 0.416555017232895, 0.416201204061508, 0.415847450494766, 0.415493696928024, 0.415140211582184, 0.414786756038666, 0.414433240890503, 0.414080142974854, 0.413727045059204, 0.413374036550522, 0.413021206855774, 0.412668377161026, 0.412315756082535, 0.411963254213333, 0.411610782146454, 0.411258548498154, 0.410906225442886, 0.410554111003876, 0.410202175378799, 0.409850299358368, 0.409498572349548, 0.409146994352341, 0.408795475959778, 0.408444046974182, 0.408092767000198, 0.407741665840149, 0.407390475273132, 0.407039612531662, 0.406688749790192, 0.406337946653366, 0.405987322330475, 0.405636847019196, 0.405286490917206, 0.404936254024506, 0.404586106538773, 0.404236108064651, 0.403886079788208, 0.403536289930344, 0.403186649084091, 0.402836978435516, 0.402487456798553, 0.40213817358017, 0.401788890361786, 0.401439785957336, 0.401090770959854, 0.400741785764694, 0.400393009185791, 0.400044351816177, 0.399695754051208, 0.399347364902496, 0.398999005556107, 0.398650854825974, 0.398302614688873, 0.397954642772675, 0.397606730461121, 0.397258937358856, 0.396911263465881, 0.396563738584518, 0.396216332912445, 0.395868986845016, 0.395521849393845, 0.395174771547318, 0.394827842712402, 0.39448082447052, 0.394134074449539, 0.393787413835526, 0.393440902233124, 0.393094450235367, 0.392748177051544, 0.392402082681656, 0.392055988311768, 0.391710013151169, 0.391364187002182, 0.391018509864807, 0.390672862529755, 0.390327244997025, 0.389981836080551, 0.389636635780334, 0.389291435480118, 0.388946354389191, 0.38860148191452, 0.388256669044495, 0.387911975383759, 0.387567341327667, 0.387222945690155, 0.386878430843353, 0.386534154415131, 0.386189997196198, 0.385845988988876, 0.385502099990845, 0.38515830039978, 0.384814590215683, 0.384470999240875, 0.384127676486969, 0.383784204721451, 0.383440971374512, 0.38309782743454, 0.382754772901535, 0.38241183757782, 0.382069170475006, 0.381726503372192, 0.381383955478668, 0.381041467189789, 0.380699187517166, 0.380356878042221, 0.380014806985855, 0.379672825336456, 0.379330933094025, 0.37898924946785, 0.378647476434708, 0.378305971622467, 0.377964526414871, 0.377623230218887, 0.377282172441483, 0.376940965652466, 0.376599997282028, 0.376259177923203, 0.375918418169022, 0.375577807426453, 0.375237345695496, 0.374896794557571, 0.374556601047516, 0.374216437339783, 0.373876333236694, 0.373536288738251, 0.373196512460709, 0.372856795787811, 0.372517198324203, 0.372177749872208, 0.371838361024857, 0.37149915099144, 0.371159970760345, 0.370820879936218, 0.370481967926025, 0.370143055915833, 0.369804412126541, 0.369465827941895, 0.369127362966537, 0.36878901720047, 0.36845076084137, 0.368112593889236, 0.367774665355682, 0.367436736822128, 0.367098808288574, 0.366761088371277, 0.366423577070236, 0.366086155176163, 0.365748852491379, 0.365411639213562, 0.36507460474968, 0.364737510681152, 0.364400684833527, 0.364063918590546, 0.363727241754532, 0.363390564918518, 0.363054156303406, 0.362717837095261, 0.362381637096405, 0.362045586109161, 0.361709594726562, 0.361373752355576, 0.361038088798523, 0.360702395439148, 0.360366821289062, 0.360031425952911, 0.35969614982605, 0.359360814094543, 0.359025865793228, 0.35869088768959, 0.358356088399887, 0.358021348714828, 0.357686728239059, 0.357352256774902, 0.357017755508423, 0.356683492660522, 0.356349378824234, 0.356015354394913, 0.355681329965591, 0.355347603559494, 0.355013787746429, 0.354680269956589, 0.35434678196907, 0.354013442993164, 0.353680074214935, 0.35334700345993, 0.353013962507248, 0.352681070566177, 0.352348238229752, 0.352015554904938, 0.351682931184769, 0.351350545883179, 0.351018160581589, 0.350685834884644, 0.350353807210922, 0.350021749734879, 0.349689930677414, 0.349358081817627, 0.349026471376419, 0.348694890737534, 0.348363488912582, 0.348032087087631, 0.347700953483582, 0.347369730472565, 0.347038745880127, 0.346707880496979, 0.34637713432312, 0.346046507358551, 0.345715969800949, 0.345385640859604, 0.345055282115936, 0.344725102186203, 0.344395041465759, 0.344064950942993, 0.343735098838806, 0.343405365943909, 0.343075782060623, 0.342746257781982, 0.342416912317276, 0.342087596654892, 0.341758459806442, 0.341429382562637, 0.341100454330444, 0.340771555900574, 0.340442806482315, 0.340114176273346, 0.339785695075989, 0.339457333087921, 0.339129030704498, 0.338800936937332, 0.338472902774811, 0.338145047426224, 0.337817221879959, 0.337489426136017, 0.337161868810654, 0.336834341287613, 0.336506932973862, 0.33617976307869, 0.335852682590485, 0.335525631904602, 0.335198760032654, 0.334871977567673, 0.334545254707336, 0.334218710660934, 0.3338922560215, 0.333565920591354, 0.333239793777466, 0.33291357755661, 0.332587540149689, 0.332261711359024, 0.331935942173004, 0.331610321998596, 0.331284672021866, 0.330959260463715, 0.330633938312531, 0.330308765172958, 0.329983711242676, 0.329658776521683, 0.329333811998367, 0.329009056091309, 0.328684449195862, 0.328359961509705, 0.328035473823547, 0.327711224555969, 0.327387034893036, 0.327062904834747, 0.326739013195038, 0.326415151357651, 0.32609149813652, 0.325767874717712, 0.325444310903549, 0.32512092590332, 0.324797600507736, 0.324474364519119, 0.324151456356049, 0.323828458786011, 0.32350566983223, 0.323182970285416, 0.322860419750214, 0.322537958621979, 0.322215586900711, 0.321893304586411, 0.32157102227211, 0.321249037981033, 0.320927113294601, 0.320605367422104, 0.320283681154251, 0.319962173700333, 0.319640666246414, 0.319319307804108, 0.31899818778038, 0.318676948547363, 0.318355858325958, 0.318034946918488, 0.317714214324951, 0.317393600940704, 0.317073076963425, 0.316752582788467, 0.316432327032089, 0.316112130880356, 0.315791994333267, 0.315471947193146, 0.315152108669281, 0.314832359552383, 0.314512610435486, 0.31419312953949, 0.313873738050461, 0.313554406166077, 0.313235282897949, 0.312916129827499, 0.312597274780273, 0.312278360128403, 0.311959564685822, 0.311640977859497, 0.311322510242462, 0.311003983020782, 0.310685753822327, 0.310367554426193, 0.310049563646317, 0.309731602668762, 0.30941379070282, 0.3090960085392, 0.308778464794159, 0.30846095085144, 0.308143585920334, 0.307826310396194, 0.307509183883667, 0.307192116975784, 0.306875199079514, 0.30655837059021, 0.306241720914841, 0.305925101041794, 0.305608600378036, 0.305292308330536, 0.304976016283035, 0.304659903049469, 0.304343909025192, 0.30402797460556, 0.30371218919754, 0.30339652299881, 0.303080856800079, 0.302765488624573, 0.302450150251389, 0.302134960889816, 0.301819860935211, 0.301504850387573, 0.301189959049225, 0.300875246524811, 0.300560563802719, 0.300246030092239, 0.29993149638176, 0.299617171287537, 0.299302965402603, 0.298988968133926, 0.29867497086525, 0.298361122608185, 0.29804739356041, 0.297733753919601, 0.297420233488083, 0.297106891870499, 0.29679349064827, 0.296480238437653, 0.296167224645615, 0.295854270458221, 0.295541435480118, 0.295228749513626, 0.294916212558746, 0.294603645801544, 0.294291287660599, 0.29397901892662, 0.293666809797287, 0.293354779481888, 0.293042719364166, 0.292730957269669, 0.292419224977493, 0.29210764169693, 0.291796207427979, 0.291484922170639, 0.291173607110977, 0.29086247086525, 0.290551394224167, 0.290240526199341, 0.28992971777916, 0.289619028568268, 0.289308428764343, 0.288998007774353, 0.288687646389008, 0.288377434015274, 0.288067311048508, 0.287757217884064, 0.287447392940521, 0.287137627601624, 0.286827981472015, 0.286518454551697, 0.286208957433701, 0.285899639129639, 0.285590410232544, 0.285281330347061, 0.284972369670868, 0.284663438796997, 0.284354656934738, 0.284046113491058, 0.283737570047379, 0.283429145812988, 0.28312087059021, 0.282812714576721, 0.282504618167877, 0.282196551561356, 0.281888753175735, 0.281580954790115, 0.281273365020752, 0.280965834856033, 0.280658483505249, 0.280351161956787, 0.280044049024582, 0.279736965894699, 0.279430001974106, 0.279123216867447, 0.278816521167755, 0.278509795665741, 0.278203368186951, 0.27789694070816, 0.277590692043304, 0.27728459239006, 0.276978552341461, 0.276672691106796, 0.276366859674454, 0.276061177253723, 0.27575558423996, 0.275450021028519, 0.275144636631012, 0.274839460849762, 0.274534314870834, 0.274229317903519, 0.273924469947815, 0.273619651794434, 0.273315012454987, 0.273010462522507, 0.272705972194672, 0.272401601076126, 0.272097408771515, 0.271793246269226, 0.271489292383194, 0.271185368299484, 0.270881593227386, 0.270578056573868, 0.270274490118027, 0.269971072673798, 0.269667655229568, 0.269364535808563, 0.26906144618988, 0.268758475780487, 0.268455505371094, 0.268152832984924, 0.267850190401077, 0.267547637224197, 0.267245292663574, 0.266943037509918, 0.266640782356262, 0.266338706016541, 0.266036778688431, 0.265734940767288, 0.265433251857758, 0.265131622552872, 0.264830112457275, 0.264528751373291, 0.264227449893951, 0.263926357030869, 0.263625234365463, 0.263324350118637, 0.263023436069489, 0.262722820043564, 0.262422233819962, 0.262121766805649, 0.261821448802948, 0.261521130800247, 0.261220961809158, 0.260920971632004, 0.260620981454849, 0.260321199893951, 0.260021537542343, 0.259721964597702, 0.259422540664673, 0.259123176336288, 0.258823990821838, 0.258524864912033, 0.258225947618484, 0.257926911115646, 0.257628113031387, 0.257329493761063, 0.257030993700027, 0.256732523441315, 0.256434172391891, 0.256136029958725, 0.255837887525558, 0.255539983510971, 0.255242109298706, 0.254944294691086, 0.25464653968811, 0.254349082708359, 0.254051595926285, 0.253754407167435, 0.253457188606262, 0.253160119056702, 0.252863168716431, 0.252566367387772, 0.252269625663757, 0.251972943544388, 0.251676470041275, 0.251379996538162, 0.251083761453629, 0.250787556171417, 0.25049152970314, 0.25019559264183, 0.24989977478981, 0.249604076147079, 0.249308481812477, 0.249012976884842, 0.248717606067657, 0.248422354459763, 0.248127192258835, 0.247832119464874, 0.247537210583687, 0.247242406010628, 0.246947750449181, 0.246653154492378, 0.246358707547188, 0.246064320206642, 0.245770081877708, 0.245475992560387, 0.245181977748871, 0.244888052344322, 0.244594261050224, 0.244300588965416, 0.244007036089897, 0.243713617324829, 0.243420287966728, 0.243127003312111, 0.242833957076073, 0.242540925741196, 0.242248013615608, 0.241955325007439, 0.241662681102753, 0.241370186209679, 0.241077676415443, 0.240785405039787, 0.240493103861809, 0.240201041102409, 0.239909112453461, 0.239617303013802, 0.239325538277626, 0.239033862948418, 0.238742396235466, 0.238450974225998, 0.238159731030464, 0.237868577241898, 0.237577393651009, 0.237286403775215, 0.23699563741684, 0.236704885959625, 0.236414298415184, 0.236123830080032, 0.235833421349525, 0.235543206334114, 0.235253050923347, 0.234963074326515, 0.234672978520393, 0.234383121132851, 0.234093442559242, 0.233803898096085, 0.233514428138733, 0.233225092291832, 0.232935845851898, 0.232646733522415, 0.232357710599899, 0.232068851590157, 0.231779977679253, 0.231491312384605, 0.231202706694603, 0.230914250016212, 0.230625852942467, 0.230337709188461, 0.230049610137939, 0.22976166009903, 0.229473695158958, 0.229185953736305, 0.228898286819458, 0.2286107391119, 0.228323265910149, 0.228035882115364, 0.22774875164032, 0.227461576461792, 0.227174639701843, 0.226887837052345, 0.226601138710976, 0.226314350962639, 0.226027861237526, 0.225741490721703, 0.225455209612846, 0.225168973207474, 0.224882915616035, 0.224596932530403, 0.224311038851738, 0.22402535378933, 0.223739758133888, 0.223454236984253, 0.223168760538101, 0.222883507609367, 0.222598373889923, 0.222313404083252, 0.222028478980064, 0.221743628382683, 0.221458822488785, 0.221174210309982, 0.220889762043953, 0.220605343580246, 0.220321103930473, 0.220036968588829, 0.219752967357635, 0.21946907043457, 0.219185307621956, 0.218901574611664, 0.218618050217628, 0.218334645032883, 0.218051105737686, 0.217767849564552, 0.217484757304192, 0.217201769351959, 0.216918841004372, 0.216636091470718, 0.216353461146355, 0.216070964932442, 0.215788468718529, 0.215506181120872, 0.215223982930183, 0.214941740036011, 0.214659720659256, 0.214377894997597, 0.214096158742905, 0.213814467191696, 0.213532969355583, 0.213251605629921, 0.212970346212387, 0.212689086794853, 0.212407901883125, 0.212127014994621, 0.211846098303795, 0.211565360426903, 0.211284726858139, 0.211004257202148, 0.210723787546158, 0.210443556308746, 0.210163399577141, 0.209883391857147, 0.20960333943367, 0.209323510527611, 0.209043830633163, 0.208764255046844, 0.208484664559364, 0.208205297589302, 0.207926079630852, 0.20764684677124, 0.20736788213253, 0.207088962197304, 0.206810116767883, 0.206531405448914, 0.206252813339233, 0.205974385142326, 0.205696016550064, 0.205417692661285, 0.205139577388763, 0.204861611127853, 0.204583674669266, 0.204305931925774, 0.204028204083443, 0.203750655055046, 0.203473106026649, 0.203195884823799, 0.202918648719788, 0.20264159142971, 0.202364534139633, 0.202087610960007, 0.201810896396637, 0.201534137129784, 0.201257586479187, 0.200981199741364, 0.200704902410507, 0.200428664684296, 0.200152590870857, 0.199876666069031, 0.19960081577301, 0.199325010180473, 0.199049398303032, 0.198773801326752, 0.198498398065567, 0.198223024606705, 0.197947889566422, 0.197672918438911, 0.197397857904434, 0.197123095393181, 0.196848377585411, 0.196573823690414, 0.196299239993095, 0.196024730801582, 0.19575047492981, 0.195476397871971, 0.195202276110649, 0.194928392767906, 0.194654583930969, 0.194380864500999, 0.194107294082642, 0.193833813071251, 0.193560481071472, 0.193297371268272, 0.193044275045395, 0.192791178822517, 0.192538514733315, 0.19228595495224, 0.192033529281616, 0.191781207919121, 0.191529139876366, 0.191277235746384, 0.191025421023369, 0.190773695707321, 0.190522134304047, 0.190270826220512, 0.190019518136978, 0.189768463373184, 0.189517483115196, 0.189266860485077, 0.189016237854958, 0.188765794038773, 0.1885154992342, 0.188265383243561, 0.188015431165695, 0.187765583395958, 0.1875159740448, 0.187266454100609, 0.187016919255257, 0.186767742037773, 0.186518654227257, 0.18626980483532, 0.186021044850349, 0.185772463679314, 0.185524046421051, 0.185275703668594, 0.1850276440382, 0.184779658913612, 0.184531822800636, 0.184284001588821, 0.184036523103714, 0.183789134025574, 0.183541908860207, 0.183294847607613, 0.183047950267792, 0.182801231741905, 0.182554692029953, 0.182308241724968, 0.182061940431595, 0.181815803050995, 0.181569784879684, 0.181323811411858, 0.181078135967255, 0.180832609534264, 0.180587247014046, 0.180342048406601, 0.180097043514252, 0.179852098226547, 0.179607436060905, 0.179362758994102, 0.17911833524704, 0.17887407541275, 0.178629741072655, 0.178385749459267, 0.178141921758652, 0.17789825797081, 0.177654772996902, 0.177411377429962, 0.177168145775795, 0.176925078034401, 0.176682278513908, 0.176439464092255, 0.176196828484535, 0.175954103469849, 0.175711899995804, 0.175469845533371, 0.175227805972099, 0.174985930323601, 0.17474439740181, 0.174502864480019, 0.174261331558228, 0.174020141363144, 0.173779115080833, 0.173538267612457, 0.17329740524292, 0.173056721687317, 0.172816216945648, 0.172575876116753, 0.172335863113403, 0.172095865011215, 0.1718560308218, 0.171616211533546, 0.171376705169678, 0.171137377619743, 0.170898228883743, 0.170659065246582, 0.170419931411743, 0.170181274414062, 0.169942632317543, 0.169704169034958, 0.169465869665146, 0.169227719306946, 0.168989762663841, 0.16875196993351, 0.16851419210434, 0.168276727199554, 0.16803927719593, 0.167802155017853, 0.167564868927002, 0.167327925562859, 0.16709116101265, 0.166854560375214, 0.166618123650551, 0.166381686925888, 0.166145607829094, 0.165909677743912, 0.16567374765873, 0.165437996387482, 0.165202587842941, 0.164967000484467, 0.164731755852699, 0.164496675133705, 0.164261773228645, 0.16402705013752, 0.163792312145233, 0.163557916879654, 0.163323685526848, 0.163089469075203, 0.162855416536331, 0.162621542811394, 0.162387818098068, 0.162154272198677, 0.161920726299286, 0.161687523126602, 0.161454498767853, 0.161221623420715, 0.160988762974739, 0.16075624525547, 0.16052371263504, 0.160291358828545, 0.160059168934822, 0.159827172756195, 0.159595146775246, 0.159363478422165, 0.159131973981857, 0.158900633454323, 0.15866930782795, 0.158438310027122, 0.158207312226295, 0.157976493239403, 0.157745838165283, 0.157515347003937, 0.157285019755363, 0.157054722309113, 0.156824737787247, 0.156594932079315, 0.156365126371384, 0.15613566339016, 0.15590637922287, 0.155677080154419, 0.155447959899902, 0.155219003558159, 0.15499022603035, 0.154761597514153, 0.154533162713051, 0.154304534196854, 0.154076427221298, 0.153848513960838, 0.153620570898056, 0.153392806649208, 0.153165370225906, 0.152937948703766, 0.15271070599556, 0.152483612298965, 0.152256697416306, 0.152029782533646, 0.151803031563759, 0.151576638221741, 0.151350229978561, 0.151124000549316, 0.150898098945618, 0.150672197341919, 0.150446474552155, 0.150220930576324, 0.149995550513268, 0.149770319461823, 0.149545282125473, 0.149320244789124, 0.149095356464386, 0.148870646953583, 0.148646116256714, 0.148421749472618, 0.148197561502457, 0.147973537445068, 0.147749856114388, 0.147525995969772, 0.147302463650703, 0.14707912504673, 0.146855786442757, 0.146632432937622, 0.146409600973129, 0.146186769008636, 0.145964115858078, 0.145741611719131, 0.145519286394119, 0.14529712498188, 0.145075142383575, 0.144853323698044, 0.144631505012512, 0.144409865140915, 0.144188389182091, 0.14396707713604, 0.143745943903923, 0.143524974584579, 0.143304347991943, 0.143083557486534, 0.142863109707832, 0.142642810940742, 0.142422705888748, 0.142202585935593, 0.141982644796371, 0.141762852668762, 0.141543254256248, 0.141323834657669, 0.14110454916954, 0.140885457396507, 0.140666529536247, 0.140447780489922, 0.140229016542435, 0.140010431408882, 0.139792189002037, 0.139573946595192, 0.13935586810112, 0.139137968420982, 0.138920217752457, 0.138702660799026, 0.138485252857208, 0.138267859816551, 0.138050809502602, 0.137833744287491, 0.137617021799088, 0.137400314211845, 0.13718393445015, 0.136967554688454, 0.136751353740692, 0.136535152792931, 0.136319294571877, 0.136103585362434, 0.135887891054153, 0.13567253947258, 0.135457172989845, 0.135242164134979, 0.135027140378952, 0.134812295436859, 0.134597793221474, 0.134383112192154, 0.134168609976768, 0.133954435586929, 0.133740440011024, 0.13352644443512, 0.133312791585922, 0.133099123835564, 0.132885813713074, 0.132672488689423, 0.132459357380867, 0.132246375083923, 0.132033571600914, 0.131820932030678, 0.131608292460442, 0.131395816802979, 0.131183698773384, 0.130971565842628, 0.130759790539742, 0.130547985434532, 0.130336374044418, 0.130124926567078, 0.129913657903671, 0.129702538251877, 0.129491597414017, 0.129280671477318, 0.129069894552231, 0.128859475255013, 0.128649041056633, 0.128438785672188, 0.12822887301445, 0.128018945455551, 0.127809211611748, 0.127599626779556, 0.127390056848526, 0.127180814743042, 0.126971572637558, 0.126762509346008, 0.126553773880005, 0.126345053315163, 0.126136660575867, 0.125928267836571, 0.12572006881237, 0.125511839985847, 0.125303968787193, 0.125096261501312, 0.124888718128204, 0.124681182205677, 0.124473810195923, 0.124266609549522, 0.124059587717056, 0.123852901160717, 0.123646207153797, 0.123439691960812, 0.123233176767826, 0.123026996850967, 0.122820988297462, 0.122615151107311, 0.122409306466579, 0.122203476727009, 0.121998146176338, 0.121792815625668, 0.121587656438351, 0.121382668614388, 0.121177852153778, 0.120973199605942, 0.12076872587204, 0.120564244687557, 0.120360106229782, 0.120155967772007, 0.119952172040939, 0.119748204946518, 0.119544573128223, 0.119341112673283, 0.119137831032276, 0.118934705853462, 0.118731759488583, 0.118528805673122, 0.11832620203495, 0.118123590946198, 0.117921322584152, 0.117719054222107, 0.117516793310642, 0.117314860224724, 0.117113098502159, 0.116911508142948, 0.116710089147091, 0.116508677601814, 0.116307593882084, 0.116106688976288, 0.115905776619911, 0.115705035626888, 0.115504465997219, 0.11530390381813, 0.115103669464588, 0.11490361392498, 0.114703722298145, 0.114504002034664, 0.114304453134537, 0.114104904234409, 0.113905698060989, 0.113706484436989, 0.113507449626923, 0.11330857872963, 0.11310987174511, 0.11291117221117, 0.112712822854519, 0.11251462996006, 0.112316608428955, 0.112118594348431, 0.111920908093452, 0.111723229289055, 0.111525721848011, 0.11132837831974, 0.111131213605404, 0.110934212803841, 0.110737219452858, 0.110540561378002, 0.110344067215919, 0.110147580504417, 0.109951429069042, 0.109755277633667, 0.109559297561646, 0.109363652765751, 0.109168015420437, 0.108972549438477, 0.108777247369289, 0.108581945300102, 0.108386985957623, 0.108192026615143, 0.10799740254879, 0.107802785933018, 0.107608333230019, 0.107414051890373, 0.107220113277435, 0.107026174664497, 0.106832407414913, 0.106638804078102, 0.106445208191872, 0.106251776218414, 0.106058686971664, 0.105865597724915, 0.105672672390938, 0.105479925870895, 0.10528751462698, 0.105095103383064, 0.104902863502502, 0.104710794985294, 0.10451889783144, 0.104326993227005, 0.104135431349277, 0.103943705558777, 0.103752486407757, 0.103561267256737, 0.10337021201849, 0.103179335594177, 0.102988623082638, 0.102798074483871, 0.102607704699039, 0.102417506277561, 0.102227479219437, 0.102037444710732, 0.101847417652607, 0.101657725870609, 0.101468376815319, 0.101279027760029, 0.101089850068092, 0.100900828838348, 0.100711993873119, 0.100523322820663, 0.100334651768208, 0.100146323442459, 0.0999579876661301, 0.0997698307037354, 0.0995818302035332, 0.0993940159678459, 0.0992063656449318, 0.0990188866853714, 0.0988315716385841, 0.0986444354057312, 0.0984572917222977, 0.0982704907655716, 0.0980836898088455, 0.0978972241282463, 0.0977107658982277, 0.0975243076682091, 0.0973383486270905, 0.0971522331237793, 0.0969666242599487, 0.0967808440327644, 0.096595399081707, 0.0964101254940033, 0.0962248519062996, 0.0960399284958839, 0.0958549976348877, 0.0956702306866646, 0.0954854711890221, 0.0953010469675064, 0.0951168015599251, 0.0949327200651169, 0.0947488024830818, 0.0945650637149811, 0.0943813249468803, 0.0941979140043259, 0.0940145179629326, 0.0938312858343124, 0.093648225069046, 0.0934653282165527, 0.0932826101779938, 0.0930998921394348, 0.0929175093770027, 0.0927352905273438, 0.092553086578846, 0.0923712179064751, 0.092189334332943, 0.0920078083872795, 0.0918262749910355, 0.0916449129581451, 0.0914637222886086, 0.0912827029824257, 0.0911016762256622, 0.0909208282828331, 0.0907403156161308, 0.0905599668622017, 0.0903796255588531, 0.0901994556188583, 0.0900194495916367, 0.089839793741703, 0.0896601304411888, 0.0894806385040283, 0.0893009752035141, 0.0891218185424805, 0.0889428406953812, 0.0887638628482819, 0.0885852128267288, 0.088406577706337, 0.088228277862072, 0.0880499705672264, 0.0878718346357346, 0.0876938700675964, 0.0875160843133926, 0.0873382911086082, 0.087160661816597, 0.0869833827018738, 0.08680609613657, 0.0866291597485542, 0.0864522159099579, 0.0862754434347153, 0.0860988423228264, 0.0859224051237106, 0.0857461467385292, 0.0855700522661209, 0.0853941291570663, 0.0852180346846581, 0.0850424543023109, 0.0848668664693832, 0.0846916288137436, 0.0845163837075233, 0.0843413099646568, 0.084166407585144, 0.083991676568985, 0.0838171094655991, 0.0836425498127937, 0.0834683254361153, 0.0832942724227905, 0.0831200480461121, 0.0829463377594948, 0.0827726200222969, 0.0825990810990334, 0.0824257060885429, 0.0822525024414062, 0.0820794701576233, 0.0819066092371941, 0.0817337408661842, 0.0815612226724625, 0.0813888683915138, 0.0812163501977921, 0.0810441598296165, 0.0808721408247948, 0.080700471997261, 0.0805287957191467, 0.080357126891613, 0.0801857933402061, 0.080014631152153, 0.079843632876873, 0.0796726420521736, 0.0795018225908279, 0.0793313309550285, 0.0791606828570366, 0.0789903700351715, 0.0788202211260796, 0.0786502510309219, 0.0784804448485374, 0.0783108174800873, 0.0781411826610565, 0.0779718831181526, 0.077802762389183, 0.0776336342096329, 0.0774646773934364, 0.0772957354784012, 0.0771271139383316, 0.0769586712121964, 0.0767903998494148, 0.0766222923994064, 0.0764543563127518, 0.0762864276766777, 0.0761188343167305, 0.0759512335062027, 0.0757838115096092, 0.0756167247891426, 0.0754494741559029, 0.0752825662493706, 0.0751158148050308, 0.0749492421746254, 0.07478266954422, 0.0746164321899414, 0.0744503661990166, 0.0742843002080917, 0.0741184130311012, 0.073952853679657, 0.0737873017787933, 0.0736219212412834, 0.0734563618898392, 0.0732914879918098, 0.0731264427304268, 0.0729617401957512, 0.0727970376610756, 0.0726326704025269, 0.0724683031439781, 0.0723041146993637, 0.0721400901675224, 0.071976400911808, 0.0718127116560936, 0.0716488659381866, 0.0714855194091797, 0.0713223442435265, 0.0711593329906464, 0.0709963291883469, 0.0708335041999817, 0.0706710070371628, 0.0705085098743439, 0.0703461840748787, 0.0701840221881866, 0.0700220465660095, 0.0698602274060249, 0.0696984156966209, 0.0695367678999901, 0.0693754628300667, 0.0692141577601433, 0.0690530240535736, 0.0688920617103577, 0.0687314346432686, 0.0685708075761795, 0.0684103518724442, 0.0682500675320625, 0.068089947104454, 0.0679298415780067, 0.0677697211503983, 0.067610114812851, 0.0674506798386574, 0.0672912448644638, 0.067131981253624, 0.0669728815555573, 0.0668139606714249, 0.0666552037000656, 0.0664966180920601, 0.0663380324840546, 0.0661796182394028, 0.0660213753581047, 0.0658634677529335, 0.0657055601477623, 0.0655478239059448, 0.0653902590274811, 0.0652328655123711, 0.0650756359100342, 0.0649185851216316, 0.0647616982460022, 0.0646048113703728, 0.0644482672214508, 0.0642915517091751, 0.06413534283638, 0.0639791339635849, 0.0638231039047241, 0.0636672377586365, 0.063511535525322, 0.0633560121059418, 0.0632004886865616, 0.0630453005433083, 0.0628902837634087, 0.0627352669835091, 0.0625802502036095, 0.0624257475137711, 0.0622712410986423, 0.0621169023215771, 0.0619627386331558, 0.061808742582798, 0.0616549178957939, 0.0615010894834995, 0.0613476037979126, 0.0611942894756794, 0.0610409714281559, 0.0608878247439861, 0.0607346817851067, 0.0605820417404175, 0.0604294054210186, 0.0602767691016197, 0.060124471783638, 0.05997234582901, 0.0598203912377357, 0.0596684329211712, 0.0595166459679604, 0.0593651980161667, 0.0592137537896633, 0.0590623058378696, 0.0589112006127834, 0.0587602630257607, 0.0586094968020916, 0.058458898216486, 0.0583083033561707, 0.0581580474972725, 0.0580079592764378, 0.057857871055603, 0.0577079579234123, 0.0575583763420582, 0.0574086308479309, 0.0572590567171574, 0.0571098178625107, 0.0569607503712177, 0.0568118542432785, 0.0566629581153393, 0.0565143972635269, 0.0563658438622952, 0.0562176257371902, 0.0560694076120853, 0.0559213608503342, 0.0557734854519367, 0.055625606328249, 0.0554779022932053, 0.0553305335342884, 0.0551833361387253, 0.0550361387431622, 0.0548892803490162, 0.0547424256801605, 0.0545959062874317, 0.0544493906199932, 0.0543028749525547, 0.0541566945612431, 0.0540105178952217, 0.0538646802306175, 0.0537190139293671, 0.0535733439028263, 0.053428016602993, 0.0532826893031597, 0.0531375333666801, 0.052992545068264, 0.0528478994965553, 0.0527032464742661, 0.0525586009025574, 0.0524142943322659, 0.0522699877619743, 0.0521260164678097, 0.0519820488989353, 0.0518382526934147, 0.0516947954893112, 0.0515513382852077, 0.0514080487191677, 0.0512649305164814, 0.0511219836771488, 0.0509792044758797, 0.0508364289999008, 0.0506938211619854, 0.0505515486001968, 0.0504092834889889, 0.0502671860158443, 0.0501252561807632, 0.0499836690723896, 0.049842081964016, 0.0497006624937057, 0.0495592430233955, 0.0494181662797928, 0.0492772571742535, 0.0491363480687141, 0.0489956140518188, 0.0488550439476967, 0.048714816570282, 0.048574585467577, 0.048434529453516, 0.0482946410775185, 0.0481549203395844, 0.0480152033269405, 0.0478758215904236, 0.047736618667841, 0.0475974082946777, 0.047458540648222, 0.0473195016384125, 0.0471808016300201, 0.0470422729849815, 0.0469039157032967, 0.0467657260596752, 0.0466277077794075, 0.0464898571372032, 0.0463520102202892, 0.0462145023047924, 0.0460769906640053, 0.0459394827485085, 0.0458024814724922, 0.0456654839217663, 0.0455286577343941, 0.0453919991850853, 0.0452555119991302, 0.0451190210878849, 0.044982872903347, 0.0448468923568726, 0.0447109155356884, 0.0445751063525677, 0.0444396361708641, 0.0443039983510971, 0.0441686995327473, 0.0440335683524609, 0.0438986085355282, 0.0437638200819492, 0.0436290316283703, 0.0434945821762085, 0.0433603003621101, 0.0432260222733021, 0.0430919118225574, 0.0429579727351665, 0.0428240336477757, 0.0426904335618019, 0.0425570048391819, 0.0424237474799156, 0.0422906577587128, 0.0421575680375099, 0.0420248173177242, 0.0418920665979385, 0.0417596586048603, 0.0416272506117821, 0.0414950102567673, 0.0413629412651062, 0.0412308685481548, 0.0410991422832012, 0.0409675799310207, 0.0408360213041306, 0.0407048054039478, 0.0405735820531845, 0.0404427014291286, 0.0403118245303631, 0.0401811152696609, 0.0400505736470222, 0.0399202033877373, 0.0397898331284523, 0.0396598055958748, 0.0395299419760704, 0.0394000858068466, 0.039270393550396, 0.0391410440206528, 0.0390116944909096, 0.0388825163245201, 0.0387535020709038, 0.0386248342692852, 0.0384959951043129, 0.0383674912154675, 0.0382389947772026, 0.0381108298897743, 0.0379826724529266, 0.0378546826541424, 0.0377270318567753, 0.0375993810594082, 0.0374718979001045, 0.0373445898294449, 0.037217453122139, 0.0370904803276062, 0.0369636826217175, 0.0368367098271847, 0.0367102511227131, 0.0365839563310146, 0.0364576689898968, 0.036331545561552, 0.0362055972218513, 0.0360798165202141, 0.0359542071819305, 0.0358287654817104, 0.0357034951448441, 0.0355783924460411, 0.035453125834465, 0.0353283621370792, 0.0352036021649837, 0.0350790098309517, 0.0349547602236271, 0.0348305106163025, 0.0347062572836876, 0.0345825180411339, 0.0344586074352264, 0.0343350358307362, 0.0342114679515362, 0.0340882353484631, 0.0339650064706802, 0.0338419415056705, 0.0337190516293049, 0.0335963293910027, 0.0334737785160542, 0.0333513990044594, 0.033229187130928, 0.0331071466207504, 0.0329852737486362, 0.0328634046018124, 0.0327417030930519, 0.0326201729476452, 0.0324988104403019, 0.0323776192963123, 0.0322565957903862, 0.0321359150111675, 0.0320150628685951, 0.0318945534527302, 0.0317742116749287, 0.0316538698971272, 0.0315338671207428, 0.0314138680696487, 0.0312940366566181, 0.0311743747442961, 0.0310548841953278, 0.0309355612844229, 0.0308164097368717, 0.0306974276900291, 0.0305784475058317, 0.0304598044604063, 0.0303413327783346, 0.0302228610962629, 0.030104560777545, 0.0299864280968904, 0.0298682954162359, 0.0297506731003523, 0.0296328812837601, 0.0295154303312302, 0.0293981488794088, 0.0292810369282961, 0.0291639249771833, 0.0290471538901329, 0.0289303809404373, 0.0288137793540955, 0.0286975167691708, 0.0285809151828289, 0.0284649934619665, 0.0283489003777504, 0.0282331481575966, 0.0281175673007965, 0.028002155944705, 0.0278867427259684, 0.0277715008705854, 0.0276565961539745, 0.0275416951626539, 0.0274269636720419, 0.0273124016821384, 0.027197839692235, 0.0270836167037487, 0.0269693937152624, 0.0268555115908384, 0.0267416294664145, 0.0266280882060528, 0.0265145432204008, 0.0264013409614563, 0.0262879692018032, 0.0261751059442759, 0.0260622445493937, 0.0259492117911577, 0.0258366875350475, 0.0257243365049362, 0.0256119854748249, 0.0254999715834856, 0.0253879595547915, 0.0252762846648693, 0.0251646135002375, 0.0250531099736691, 0.0249416083097458, 0.0248306132853031, 0.0247194524854422, 0.0246084593236446, 0.0244976375252008, 0.0243871528655291, 0.024276839569211, 0.0241665281355381, 0.0240563843399286, 0.0239464100450277, 0.0238366089761257, 0.023726973682642, 0.0236175116151571, 0.0235082190483809, 0.0233987551182508, 0.0232898015528917, 0.0231808498501778, 0.0230720657855272, 0.022963622584939, 0.0228551793843508, 0.0227469056844711, 0.0226388014853001, 0.0225308705121279, 0.0224229358136654, 0.0223153438419104, 0.0222079195082188, 0.0221003256738186, 0.0219930727034807, 0.0218859892338514, 0.0217792447656393, 0.0216725021600723, 0.0215659271925688, 0.0214593540877104, 0.0213532913476229, 0.0212470572441816, 0.0211411640048027, 0.0210352707654238, 0.0209295470267534, 0.0208239927887917, 0.0207186099141836, 0.0206133965402842, 0.0205083508044481, 0.020403478294611, 0.0202987734228373, 0.0201940704137087, 0.0200897064059973, 0.0199855118989944, 0.0198813192546368, 0.0197771247476339, 0.0196734424680471, 0.0195697564631701, 0.0194662436842918, 0.0193629004061222, 0.019259724766016, 0.019156550988555, 0.0190537180751562, 0.0189508814364672, 0.0188483893871307, 0.018745893612504, 0.0186437405645847, 0.0185414161533117, 0.0184394307434559, 0.0183376185595989, 0.0182359721511602, 0.0181343294680119, 0.0180330239236355, 0.0179318897426128, 0.0178307555615902, 0.0177297908812761, 0.0176291670650244, 0.0175285413861275, 0.0174279194325209, 0.0173276327550411, 0.0172275193035603, 0.017127575352788, 0.0170278009027243, 0.0169280245900154, 0.016828591004014, 0.0167291555553675, 0.0166298914700747, 0.016530966386199, 0.0164320413023233, 0.0163332875818014, 0.0162345319986343, 0.0161361172795296, 0.0160378720611334, 0.0159396268427372, 0.0158417224884033, 0.0157438181340694, 0.0156462527811527, 0.0155486883595586, 0.0154512925073504, 0.015354068018496, 0.0152570130303502, 0.0151599580422044, 0.0150632429867983, 0.0149665279313922, 0.0148701528087258, 0.0147737776860595, 0.0146777424961329, 0.0145817073062062, 0.0144858425483108, 0.0143901463598013, 0.0142946215346456, 0.014199267141521, 0.0141039108857512, 0.0140088954940438, 0.013913881033659, 0.0138192046433687, 0.0137245301157236, 0.0136301945894957, 0.0135358590632677, 0.0134416930377483, 0.0133476983755827, 0.0132538722828031, 0.0131602166220546, 0.0130665618926287, 0.0129730757325888, 0.0128799304366112, 0.012786784209311, 0.0126938093453646, 0.0126011734828353, 0.012508537620306, 0.0124160721898079, 0.0123237762600183, 0.01223165076226, 0.0121396947652102, 0.0120477387681603, 0.0119559532031417, 0.0118643371388316, 0.0117730619385839, 0.0116817858070135, 0.0115906791761518, 0.0114997429773211, 0.0114089772105217, 0.0113183818757534, 0.0112279551103711, 0.0111376997083426, 0.0110474433749914, 0.01095752697438, 0.01086744107306, 0.0107778646051884, 0.0106882890686393, 0.0105988821014762, 0.0105096464976668, 0.0104205803945661, 0.0103316837921739, 0.0102427881211042, 0.0101542314514518, 0.0100658442825079, 0.00997745897620916, 0.00988907273858786, 0.00980119593441486, 0.00971331913024187, 0.00962561275810003, 0.00953807588666677, 0.00945070944726467, 0.00936351343989372, 0.0092763165012002, 0.00918946042656898, 0.0091026034206152, 0.00901608727872372, 0.00892957020550966, 0.00884305406361818, 0.00875687785446644, 0.0086708702147007, 0.00858503393828869, 0.00849936716258526, 0.00841386988759041, 0.00832854304462671, 0.00824321620166302, 0.00815805979073048, 0.00807307288050652, 0.00798842590302229, 0.00790360942482948, 0.00781913194805384, 0.00773482490330935, 0.00765068829059601, 0.00756672117859125, 0.00748275453224778, 0.00739912688732147, 0.00731533020734787, 0.00723204296082258, 0.00714875617995858, 0.00706580886617303, 0.00698286155238748, 0.00690008420497179, 0.00681747682392597, 0.00673486944288015, 0.00665260199457407, 0.00657050497829914, 0.00648806756362319, 0.006406310480088, 0.00632455293089151, 0.00624313578009605, 0.00616171816363931, 0.00608047097921371, 0.0059993932954967, 0.00591848604381084, 0.00583774829283357, 0.00575701054185629, 0.00567661318928003, 0.00559621583670378, 0.0055159879848361, 0.00543593056499958, 0.00535604264587164, 0.00527632515877485, 0.00519677717238665, 0.00511739915236831, 0.00503819156438112, 0.00495898397639394, 0.0048801158554852, 0.00480124820023775, 0.00472255051136017, 0.00464402278885245, 0.00456566456705332, 0.00448747677728534, 0.00440945895388722, 0.00433161109685898, 0.00425393274053931, 0.00417625484988093, 0.00409891689196229, 0.00402157893404365, 0.00394441094249487, 0.00386741245165467, 0.00379058439284563, 0.00371392630040646, 0.00363743794150651, 0.00356111978180707, 0.00348497158847749, 0.00340899336151779, 0.00333301513455808, 0.00325737684033811, 0.00318156857974827, 0.00310627021826804, 0.00303097162395716, 0.00295584322884679, 0.00288088480010629, 0.0028060965705663, 0.00273147807456553, 0.00265685957856476, 0.00258258101530373, 0.00250847241841257, 0.00243419385515153, 0.00236025522463024, 0.00228665675967932, 0.00221305806189775, 0.0021396295633167, 0.00206637079827487, 0.00199328199960291, 0.00192036328371614, 0.00184744468424469, 0.00177469581831247, 0.00170228711795062, 0.00162987818475813, 0.00155763945076615, 0.00148557056672871, 0.00141367164906114, 0.00134194269776344, 0.00127038371283561, 0.00119899481069297, 0.00112777575850487, 0.00105638685636222, 0.00098550773691386, 0.000914628733880818, 0.00084408960537985, 0.000773550476878881, 0.000703181372955441, 0.000632982235401869, 0.000562953064218163, 0.000493093859404325, 0.000423234625486657, 0.000353545387042686, 0.000284196110442281, 0.00021484681928996, 0.000145667494507506, 7.68281315686181e-05, 7.98876590124564e-06, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088, 0.0169778689742088   }, 
}; 

// background map
float ReadLikelihoodPCA::fRefB[][10000] = 
{ 
   { 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 1.3168554e-15, 3.4816597e-07, 1.0395954e-06, 1.7313367e-06, 2.4223204e-06, 3.1135939e-06, 3.8041319e-06, 4.4944027e-06, 5.1850075e-06, 5.8748551e-06, 6.5649915e-06, 7.2543712e-06, 7.9438614e-06, 8.6334194e-06, 9.3224644e-06, 1.0011465e-05, 1.0699686e-05, 1.1388241e-05, 1.2076015e-05, 1.2763545e-05, 1.3451409e-05, 1.4138492e-05, 1.4825889e-05, 1.5512527e-05, 1.6198943e-05, 1.6886072e-05, 1.7572018e-05, 1.8258277e-05, 1.894378e-05, 1.9629571e-05, 2.0314605e-05, 2.0999751e-05, 2.1684518e-05, 2.2369217e-05, 2.3053517e-05, 2.3737746e-05, 2.4421422e-05, 2.5105386e-05, 2.5789015e-05, 2.6472535e-05, 2.7155274e-05, 2.7838325e-05, 2.8520617e-05, 2.9202663e-05, 2.9885026e-05, 3.0566625e-05, 3.1248543e-05, 3.1929696e-05, 3.2611144e-05, 3.3291832e-05, 3.3972276e-05, 3.4653476e-05, 3.5333476e-05, 3.6013782e-05, 3.6693691e-05, 3.7373e-05, 3.8052618e-05, 3.8731479e-05, 3.9410632e-05, 4.0089046e-05, 4.0767751e-05, 4.1445699e-05, 4.21234e-05, 4.2801861e-05, 4.3479118e-05, 4.4156666e-05, 4.4833476e-05, 4.5510042e-05, 4.618692e-05, 4.6863017e-05, 4.7539448e-05, 4.8215101e-05, 4.889107e-05, 4.956625e-05, 5.024159e-05, 5.0916933e-05, 5.1591807e-05, 5.2266609e-05, 5.2940679e-05, 5.3614505e-05, 5.4288619e-05, 5.4962002e-05, 5.5635668e-05, 5.6308578e-05, 5.69818e-05, 5.7654248e-05, 5.8326466e-05, 5.8998998e-05, 5.9671198e-05, 6.0343264e-05, 6.1014591e-05, 6.1686187e-05, 6.2357052e-05, 6.3028026e-05, 6.3698593e-05, 6.4369124e-05, 6.5039225e-05, 6.5709304e-05, 6.6378787e-05, 6.7048553e-05, 6.7717585e-05, 6.8387337e-05, 6.9055895e-05, 6.9724774e-05, 7.0392874e-05, 7.1060771e-05, 7.1728937e-05, 7.2396368e-05, 7.306409e-05, 7.3731047e-05, 7.4397787e-05, 7.506484e-05, 7.5731114e-05, 7.6398115e-05, 7.7063945e-05, 7.7730081e-05, 7.8395795e-05, 7.9060927e-05, 7.9726371e-05, 8.0391037e-05, 8.1056016e-05, 8.172026e-05, 8.2384235e-05, 8.3048522e-05, 8.3712053e-05, 8.4375897e-05, 8.5039428e-05, 8.570277e-05, 8.6365406e-05, 8.702778e-05, 8.7690467e-05, 8.8352441e-05, 8.9014626e-05, 8.9676105e-05, 9.0337722e-05, 9.0998932e-05, 9.1660055e-05, 9.2320821e-05, 9.29815e-05, 9.3642535e-05, 9.4302406e-05, 9.4962066e-05, 9.5622032e-05, 9.6281241e-05, 9.6940705e-05, 9.7599434e-05, 9.8258461e-05, 9.8916731e-05, 9.9574776e-05, 0.00010023313, 0.00010089073, 0.00010154906, 0.00010220617, 0.00010286341, 0.00010352025, 0.0001041771, 0.00010483345, 0.00010548981, 0.00010614572, 0.00010680162, 0.00010745691, 0.0001081125, 0.00010876739, 0.00010942249, 0.00011007733, 0.0001107315, 0.00011138594, 0.00011203962, 0.00011269366, 0.00011334689, 0.00011400045, 0.00011465323, 0.00011530575, 0.00011595863, 0.0001166107, 0.00011726314, 0.00011791512, 0.00011856698, 0.00011921865, 0.00011986962, 0.00012052088, 0.0001211714, 0.00012182218, 0.00012247221, 0.00012312202, 0.00012377213, 0.00012442149, 0.00012507115, 0.00012572006, 0.0001263687, 0.00012701811, 0.00012766631, 0.00012831483, 0.00012896258, 0.00012961063, 0.00013025795, 0.00013090533, 0.00013155238, 0.00013219933, 0.00013284587, 0.00013349239, 0.00013413884, 0.00013478495, 0.00013543043, 0.00013607618, 0.00013672121, 0.00013736651, 0.00013801105, 0.00013865538, 0.00013930001, 0.00013994389, 0.00014058803, 0.00014123146, 0.00014187515, 0.00014251808, 0.00014316161, 0.00014380428, 0.00014444691, 0.00014508908, 0.00014573128, 0.00014637284, 0.0001470147, 0.00014765585, 0.00014829724, 0.00014893795, 0.00014957889, 0.0001502191, 0.00015085909, 0.00015149977, 0.00015213927, 0.00015277909, 0.00015341816, 0.00015405699, 0.00015469614, 0.00015533454, 0.0001559732, 0.0001566111, 0.00015724932, 0.00015788713, 0.00015852436, 0.00015916231, 0.00015979911, 0.00016043616, 0.0001610725, 0.00016170912, 0.00016234496, 0.00016298059, 0.00016361654, 0.00016425172, 0.00016488718, 0.00016552192, 0.00016615637, 0.00016679162, 0.00016742565, 0.00016805994, 0.00016869351, 0.0001693274, 0.00016996049, 0.00017059378, 0.00017122658, 0.00017185936, 0.00017249174, 0.00017312408, 0.00017375583, 0.00017438785, 0.00017501955, 0.00017565112, 0.00017628199, 0.00017691312, 0.00017754349, 0.00017817364, 0.00017880405, 0.00017943374, 0.00018006374, 0.00018069299, 0.00018132197, 0.00018195128, 0.00018258019, 0.00018320903, 0.00018383749, 0.00018446549, 0.00018509349, 0.00018572093, 0.00018634858, 0.00018697557, 0.00018760278, 0.00018822927, 0.00018885554, 0.00018948209, 0.00019010785, 0.00019073441, 0.00019135974, 0.00019198534, 0.00019261021, 0.00019323488, 0.00019385983, 0.00019448405, 0.00019510854, 0.00019573227, 0.0001963563, 0.00019697995, 0.000197603, 0.00019822635, 0.00019884936, 0.00019947224, 0.00020009441, 0.0002007163, 0.00020133848, 0.00020195999, 0.00020258171, 0.00020320274, 0.00020382401, 0.00020444451, 0.00020506486, 0.00020568543, 0.0002063053, 0.00020692586, 0.00020754526, 0.0002081648, 0.00020878389, 0.00020940295, 0.00021002159, 0.0002106402, 0.00021125838, 0.00021187653, 0.00021249411, 0.00021311195, 0.00021372909, 0.00021434689, 0.00021496353, 0.00021557994, 0.0002161967, 0.00021681267, 0.0002174289, 0.00021804438, 0.00021866018, 0.00021927527, 0.00021989009, 0.00022050517, 0.0002211199, 0.0002217342, 0.00022234887, 0.00022296257, 0.00022357654, 0.00022418976, 0.00022480328, 0.00022541604, 0.00022602908, 0.00022664139, 0.00022725345, 0.00022786581, 0.00022847747, 0.00022908935, 0.00022970051, 0.00023031238, 0.00023092309, 0.0002315336, 0.00023214432, 0.00023275436, 0.00023336463, 0.00023397424, 0.00023458393, 0.00023519353, 0.00023580241, 0.00023641156, 0.00023702002, 0.00023762909, 0.00023823707, 0.0002388448, 0.0002394528, 0.00024006008, 0.00024066764, 0.00024127449, 0.00024188111, 0.00024248793, 0.00024309407, 0.0002437005, 0.00024430617, 0.00024491211, 0.00024551779, 0.00024612309, 0.00024672801, 0.00024733294, 0.00024793737, 0.00024854179, 0.00024914567, 0.00024974978, 0.00025035319, 0.0002509568, 0.00025155977, 0.00025216295, 0.00025276546, 0.00025336811, 0.00025397065, 0.00025457246, 0.00025517447, 0.00025577581, 0.00025637745, 0.00025697832, 0.00025757932, 0.00025817988, 0.00025878043, 0.00025938055, 0.00025998065, 0.00026058016, 0.00026118034, 0.00026177938, 0.00026237869, 0.00026297726, 0.00026357613, 0.0002641743, 0.00026477218, 0.00026537036, 0.0002659678, 0.0002665655, 0.00026716254, 0.00026775929, 0.00026835673, 0.00026895301, 0.00026954958, 0.00027014542, 0.00027074153, 0.00027133696, 0.00027193245, 0.00027252789, 0.0002731226, 0.00027371757, 0.00027431184, 0.00027490585, 0.00027550012, 0.00027609407, 0.00027668788, 0.00027728101, 0.00027787438, 0.00027846705, 0.00027905943, 0.0002796521, 0.0002802441, 0.00028083631, 0.00028142781, 0.00028201943, 0.00028261065, 0.00028320184, 0.00028379294, 0.00028438366, 0.00028497388, 0.00028556417, 0.00028615384, 0.00028674377, 0.00028733304, 0.00028792248, 0.00028851125, 0.00028910028, 0.00028968859, 0.00029027666, 0.0002908654, 0.00029145298, 0.00029204087, 0.00029262804, 0.00029321498, 0.00029380218, 0.000294389, 0.00029497533, 0.00029556171, 0.00029614766, 0.00029673355, 0.00029731891, 0.00029790489, 0.00029848976, 0.00029907489, 0.0002996593, 0.00030024353, 0.00030082793, 0.0003014117, 0.00030199566, 0.00030257893, 0.00030316244, 0.00030374527, 0.00030432787, 0.00030491073, 0.00030549322, 0.00030607561, 0.00030665731, 0.0003072391, 0.00030782045, 0.00030840177, 0.000308983, 0.00030956353, 0.0003101443, 0.00031072443, 0.00031130426, 0.00031188433, 0.00031246373, 0.00031304377, 0.00031362273, 0.0003142014, 0.00031478037, 0.0003153586, 0.0003159371, 0.00031651487, 0.00031709293, 0.00031767026, 0.00031824768, 0.00031882469, 0.00031940168, 0.00031997863, 0.00032055515, 0.00032113126, 0.00032170734, 0.00032228284, 0.00032285857, 0.00032343363, 0.0003240089, 0.0003245835, 0.00032515789, 0.00032573246, 0.00032630636, 0.00032688049, 0.00032745433, 0.00032802802, 0.00032860102, 0.00032917378, 0.00032974678, 0.00033031945, 0.00033089161, 0.00033146379, 0.00033203544, 0.00033260731, 0.00033317844, 0.00033374983, 0.00033432056, 0.00033489184, 0.00033546213, 0.00033603216, 0.00033660239, 0.00033717195, 0.00033774172, 0.00033831087, 0.00033887973, 0.00033944883, 0.00034001726, 0.00034058586, 0.00034115388, 0.00034172245, 0.00034228995, 0.00034285756, 0.00034342473, 0.00034399185, 0.00034455897, 0.00034512527, 0.00034569189, 0.00034625782, 0.00034682345, 0.00034738932, 0.00034795454, 0.00034852003, 0.00034908517, 0.00034964969, 0.00035021445, 0.00035077851, 0.00035134284, 0.00035190643, 0.00035247026, 0.00035303345, 0.00035359673, 0.00035415954, 0.00035472238, 0.00035528472, 0.00035584706, 0.00035640923, 0.00035697123, 0.00035753261, 0.00035809417, 0.00035865503, 0.00035921612, 0.00035977655, 0.00036033674, 0.0003608971, 0.00036145686, 0.00036201681, 0.0003625761, 0.0003631351, 0.00036369479, 0.00036425336, 0.00036481215, 0.00036537065, 0.00036592863, 0.00036648667, 0.00036704415, 0.00036760178, 0.0003681588, 0.00036871596, 0.00036927249, 0.00036982881, 0.00037038574, 0.00037094156, 0.00037149759, 0.00037205298, 0.0003726086, 0.00037316352, 0.00037371821, 0.00037427314, 0.00037482739, 0.00037538182, 0.0003759356, 0.0003764896, 0.00037704295, 0.00037759676, 0.00037814977, 0.00037870277, 0.00037925557, 0.00037980778, 0.00038035971, 0.00038091192, 0.00038146341, 0.00038201516, 0.00038256618, 0.00038311744, 0.000383668, 0.00038421835, 0.00038476937, 0.00038531926, 0.00038586932, 0.00038641875, 0.00038696837, 0.00038751747, 0.00038806652, 0.00038861515, 0.00038916382, 0.00038971199, 0.00039026016, 0.00039080772, 0.00039135601, 0.00039190313, 0.00039245051, 0.00039299717, 0.00039354365, 0.00039409034, 0.0003946363, 0.00039518255, 0.00039572813, 0.00039627391, 0.00039681897, 0.00039736388, 0.00039790929, 0.00039845373, 0.00039899838, 0.00039954262, 0.00040008637, 0.00040063029, 0.00040117354, 0.00040171703, 0.00040225987, 0.00040280286, 0.00040334527, 0.0004038873, 0.00040442971, 0.00040497177, 0.00040551357, 0.00040605484, 0.00040659623, 0.00040713703, 0.00040767743, 0.00040821824, 0.00040875835, 0.00040929861, 0.00040983822, 0.00041037792, 0.0004109171, 0.00041145639, 0.00041199557, 0.00041253443, 0.00041307305, 0.00041361107, 0.00041414885, 0.00041468686, 0.00041522417, 0.00041576166, 0.00041629854, 0.00041683525, 0.00041737198, 0.00041790825, 0.00041844504, 0.00041898072, 0.00041951664, 0.00042005189, 0.00042058731, 0.00042112215, 0.00042165714, 0.00042219152, 0.00042272595, 0.00042325989, 0.00042379397, 0.00042432742, 0.00042486106, 0.00042539445, 0.00042592766, 0.00042646014, 0.0004269924, 0.00042752488, 0.00042805678, 0.00042858883, 0.00042912018, 0.00042965179, 0.00043018264, 0.00043071338, 0.00043124429, 0.00043177445, 0.00043230527, 0.00043283546, 0.00043336497, 0.00043389475, 0.00043442386, 0.00043495314, 0.00043548172, 0.00043601054, 0.0004365388, 0.00043706663, 0.00043759489, 0.00043812231, 0.00043865043, 0.00043917738, 0.00043970419, 0.00044023126, 0.00044075758, 0.00044128415, 0.00044181003, 0.00044233611, 0.00044286158, 0.00044338711, 0.00044391214, 0.00044443723, 0.00044496215, 0.0004454868, 0.00044601093, 0.00044653512, 0.00044705876, 0.0004475826, 0.00044810574, 0.00044862903, 0.00044915173, 0.00044967417, 0.00045019685, 0.00045071886, 0.0004512411, 0.00045176261, 0.00045228461, 0.00045280581, 0.00045332705, 0.00045384769, 0.00045436842, 0.00045488871, 0.00045540903, 0.00045592868, 0.00045644859, 0.0004569678, 0.0004574873, 0.00045800608, 0.00045852549, 0.0004590438, 0.00045956197, 0.00046008028, 0.00046059789, 0.00046111576, 0.00046163294, 0.00046214991, 0.00046266709, 0.00046318365, 0.00046370027, 0.00046421637, 0.00046473264, 0.00046524892, 0.00046576429, 0.00046627986, 0.00046679479, 0.00046730993, 0.00046782431, 0.00046833855, 0.00046885299, 0.00046936676, 0.0004698807, 0.00047039404, 0.00047090754, 0.00047142038, 0.00047193342, 0.00047244621, 0.0004729584, 0.00047347075, 0.00047398251, 0.0004744943, 0.0004750056, 0.00047551695, 0.0004760279, 0.00047653876, 0.00047704956, 0.0004775596, 0.00047806956, 0.00047857995, 0.00047908939, 0.00047959905, 0.00048010799, 0.00048061673, 0.00048112567, 0.00048163394, 0.00048214235, 0.00048265018, 0.00048315828, 0.00048366564, 0.00048417307, 0.00048468044, 0.00048518745, 0.00048569398, 0.00048620056, 0.00048670667, 0.00048721279, 0.00048771829, 0.00048822406, 0.0004887291, 0.0004892344, 0.000489739, 0.00049024337, 0.00049074792, 0.00049125229, 0.00049175642, 0.00049225986, 0.00049276359, 0.00049326656, 0.00049376936, 0.00049427227, 0.00049477466, 0.00049527723, 0.00049577904, 0.00049628102, 0.00049678294, 0.00049728411, 0.00049778586, 0.00049828662, 0.0004987875, 0.00049928779, 0.00049978786, 0.00050028809, 0.00050078763, 0.0005012874, 0.00050178659, 0.00050228549, 0.0005027845, 0.00050328299, 0.00050378207, 0.00050427997, 0.00050477812, 0.00050527573, 0.00050577335, 0.0005062705, 0.00050676765, 0.0005072644, 0.00050776108, 0.00050825765, 0.00050875364, 0.00050924934, 0.00050974562, 0.00051024085, 0.00051073631, 0.00051123108, 0.00051172561, 0.00051222037, 0.0005127145, 0.00051320874, 0.0005137024, 0.00051419629, 0.00051468937, 0.00051518274, 0.00051567552, 0.00051616877, 0.00051666109, 0.00051715347, 0.00051764533, 0.00051813724, 0.00051862869, 0.00051912013, 0.00051961112, 0.00052010221, 0.00052059261, 0.00052108284, 0.00052157324, 0.000522063, 0.00052255334, 0.00052304263, 0.00052353169, 0.00052402099, 0.00052450952, 0.00052499835, 0.00052548654, 0.00052597484, 0.00052646257, 0.00052695035, 0.00052743801, 0.00052792503, 0.00052841264, 0.00052889914, 0.00052938546, 0.00052987196, 0.00053035782, 0.00053084386, 0.00053132937, 0.00053181493, 0.00053229986, 0.00053278456, 0.00053326949, 0.00053375371, 0.00053423824, 0.00053472241, 0.0005352064, 0.00053568976, 0.00053617323, 0.00053665618, 0.00053713925, 0.00053762173, 0.00053810433, 0.00053858629, 0.00053906842, 0.00053954992, 0.00054003159, 0.00054051267, 0.0005409944, 0.0005414749, 0.00054195535, 0.00054243585, 0.00054291578, 0.00054339587, 0.00054387533, 0.00054435461, 0.00054483401, 0.00054531323, 0.00054579176, 0.00054627046, 0.00054674898, 0.00054722722, 0.00054770481, 0.0005481827, 0.00054865982, 0.00054913713, 0.00054961391, 0.00055009034, 0.00055056706, 0.00055104314, 0.00055151933, 0.00055199483, 0.00055247068, 0.00055294612, 0.00055342104, 0.00055389613, 0.00055437046, 0.00055484514, 0.00055531907, 0.00055579323, 0.00055626716, 0.00055674044, 0.00055721391, 0.00055768673, 0.00055815978, 0.00055863208, 0.00055910461, 0.0005595769, 0.00056004868, 0.00056052057, 0.00056099182, 0.00056146312, 0.00056193396, 0.00056240452, 0.00056287524, 0.00056334533, 0.00056381553, 0.0005642852, 0.00056475494, 0.00056522456, 0.00056569383, 0.00056616258, 0.00056663144, 0.00056709978, 0.00056756818, 0.00056803593, 0.00056850392, 0.00056897127, 0.00056943879, 0.00056990568, 0.00057037239, 0.00057083956, 0.00057130575, 0.00057177211, 0.00057223794, 0.00057270384, 0.00057316915, 0.00057363417, 0.00057409937, 0.00057456439, 0.00057502883, 0.00057549326, 0.00057595724, 0.00057642127, 0.00057688513, 0.00057734875, 0.00057563628, 0.00057176047, 0.00056787301, 0.00056400814, 0.00056015485, 0.00055628974, 0.00055244763, 0.00054862793, 0.00054478558, 0.00054097711, 0.00053714571, 0.00053333741, 0.00052957423, 0.00052575406, 0.00052199065, 0.00051822735, 0.00051445246, 0.00051071163, 0.00050698209, 0.00050322962, 0.00049951131, 0.00049580418, 0.00049208553, 0.00048838987, 0.00048468239, 0.00048099784, 0.00047733571, 0.00047365073, 0.00046999997, 0.00046636036, 0.00046270943, 0.000459081, 0.00045546409, 0.0004518468, 0.00044824101, 0.00044465798, 0.00044105196, 0.00043746852, 0.00043387368, 0.00043033564, 0.00042677482, 0.00042321373, 0.00041968693, 0.00041615983, 0.0004126213, 0.00040911676, 0.00040560079, 0.00040211901, 0.00039863712, 0.00039516657, 0.0003916843, 0.00038822475, 0.00038474242, 0.00038130541, 0.00037787994, 0.00037444287, 0.00037102841, 0.00036762538, 0.0003642106, 0.00036081881, 0.00035742664, 0.00035404621, 0.00035068803, 0.00034732994, 0.00034396016, 0.00034062448, 0.00033727748, 0.00033396439, 0.00033065141, 0.00032732668, 0.00032403608, 0.00032074552, 0.00031745469, 0.00031418694, 0.00031090729, 0.00030765054, 0.00030441632, 0.00030115928, 0.00029791359, 0.00029470187, 0.00029146732, 0.00028827816, 0.00028508881, 0.0002818768, 0.0002787101, 0.00027554348, 0.00027236532, 0.00026920988, 0.00026605415, 0.00026292109, 0.0002597881, 0.00025664343, 0.00025354448, 0.00025044518, 0.00024733457, 0.00024424648, 0.00024118126, 0.00023809297, 0.00023503888, 0.00023199618, 0.00022893053, 0.0002258988, 0.00022285571, 0.00021984657, 0.00021682608, 0.00021381672, 0.00021083003, 0.00020784349, 0.00020485657, 0.00020189257, 0.00019891687, 0.00019597562, 0.00019303391, 0.00019009206, 0.00018716174, 0.00018425391, 0.00018132334, 0.00017842687, 0.00017554151, 0.00017264481, 0.00016977066, 0.00016691939, 0.00016404496, 0.00016119344, 0.00015834179, 0.00015551271, 0.00015269505, 0.00014986575, 0.00014707069, 0.00014427539, 0.00014145729, 0.00013868455, 0.00013592311, 0.00013313891, 0.00013038864, 0.00012764987, 0.00012488791, 0.0001221719, 0.00011943261, 0.00011672758, 0.00011402244, 0.00011131702, 0.00010862305, 0.00010595159, 0.00010325723, 0.00010060859, 9.7959652e-05, 9.5299351e-05, 9.2661568e-05, 9.0023677e-05, 8.7408858e-05, 8.4804982e-05, 8.2178311e-05, 7.9597026e-05, 7.7004399e-05, 7.4422846e-05, 7.1864182e-05, 6.9293848e-05, 6.6723551e-05, 6.4187247e-05, 6.1662351e-05, 5.9114351e-05, 5.660086e-05, 5.4086842e-05, 5.1584346e-05, 4.9104372e-05, 4.6601635e-05, 4.4132848e-05, 4.1675306e-05, 3.9183658e-05, 3.67373e-05, 3.4302459e-05, 3.1855903e-05, 2.9432227e-05, 2.7008258e-05, 2.4607169e-05, 2.2205961e-05, 1.9804676e-05, 1.7425897e-05, 1.5058578e-05, 1.2679545e-05, 1.0323412e-05, 7.9898036e-06, 5.6220533e-06, 3.2995922e-06, 9.7724853e-07, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00057757809, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 0.00092643092, 1.4025896e-06, 3.7182615e-06, 6.0564994e-06, 8.4060011e-06, 1.0755542e-05, 1.3104768e-05, 1.5499716e-05, 1.7871547e-05, 2.0243458e-05, 2.2637974e-05, 2.5055213e-05, 2.7460836e-05, 2.9889377e-05, 3.2306147e-05, 3.4757057e-05, 3.7208123e-05, 3.9647381e-05, 4.2109517e-05, 4.4582757e-05, 4.7056117e-05, 4.9551963e-05, 5.204797e-05, 5.454358e-05, 5.7062072e-05, 5.9603091e-05, 6.2121348e-05, 6.4650791e-05, 6.7202876e-05, 6.9766538e-05, 7.234123e-05, 7.4904579e-05, 7.7479075e-05, 8.0076374e-05, 8.2673432e-05, 8.5270651e-05, 8.7890316e-05, 9.0509981e-05, 9.3140792e-05, 9.580591e-05, 9.8436562e-05, 0.00010109006, 0.00010375466, 0.00010644214, 0.00010912933, 0.00011181658, 0.00011450353, 0.0001172246, 0.0001199458, 0.00012266662, 0.00012539898, 0.0001281424, 0.00013089727, 0.00013365191, 0.00013641808, 0.0001391953, 0.00014198395, 0.00014479515, 0.00014758347, 0.00015038319, 0.00015320549, 0.00015605069, 0.0001588841, 0.00016171762, 0.00016456225, 0.00016744118, 0.00017030841, 0.00017318719, 0.00017607695, 0.00017896685, 0.0001818793, 0.0001847917, 0.00018770386, 0.0001906276, 0.00019356234, 0.00019653143, 0.00019946598, 0.00020243462, 0.00020540328, 0.0002083946, 0.00021138594, 0.00021437694, 0.000217368, 0.00022041582, 0.0002234295, 0.00022645439, 0.0002294906, 0.00023253795, 0.00023559667, 0.00023866678, 0.00024173662, 0.00024480652, 0.00024789901, 0.00025101434, 0.00025412935, 0.00025723307, 0.00026034788, 0.00026349697, 0.00026664583, 0.00026978325, 0.0002729432, 0.00027612588, 0.0002792858, 0.00028247989, 0.0002856623, 0.0002888561, 0.00029207248, 0.00029530012, 0.00029851639, 0.00030175518, 0.00030499403, 0.00030825555, 0.00031151701, 0.00031477815, 0.00031805085, 0.00032135737, 0.00032464124, 0.00032793626, 0.00033125412, 0.00033458302, 0.00033790042, 0.00034124081, 0.00034458077, 0.00034793233, 0.00035129493, 0.00035468044, 0.0003580428, 0.00036143945, 0.00036482443, 0.0003682551, 0.00037166273, 0.00037507014, 0.00037850047, 0.00038196493, 0.00038539484, 0.00038885907, 0.0003923116, 0.00039579824, 0.00039927353, 0.00040275988, 0.00040625775, 0.00040976671, 0.00041327585, 0.00041680739, 0.00042032768, 0.0004238704, 0.00042741324, 0.00043100136, 0.00043455538, 0.00043812054, 0.00044171981, 0.0004453077, 0.00044890665, 0.00045251718, 0.00045612728, 0.00045974905, 0.00046339325, 0.00046703749, 0.00047068144, 0.00047433682, 0.00047800338, 0.00048170428, 0.00048537063, 0.0004890596, 0.00049274869, 0.0004964947, 0.0005002062, 0.0005039291, 0.0005076747, 0.00051142008, 0.00051516556, 0.00051892211, 0.00052269013, 0.00052646926, 0.00053025997, 0.00053405028, 0.00053785212, 0.00054166507, 0.00054547802, 0.00054933631, 0.00055316032, 0.00055699586, 0.00056086521, 0.00056473468, 0.00056859246, 0.00057248451, 0.00057637627, 0.0005802681, 0.0005841711, 0.0005880855, 0.00059199962, 0.00059593655, 0.00059986184, 0.00060382142, 0.00060778088, 0.00061174022, 0.00061571068, 0.00061971543, 0.00062369712, 0.00062767876, 0.00063171744, 0.00063572155, 0.00063973712, 0.00064377522, 0.00064781343, 0.00065187417, 0.00065593509, 0.0006599956, 0.00066405616, 0.00066815055, 0.00067223376, 0.00067633949, 0.00068045646, 0.00068456214, 0.00068871304, 0.00069284125, 0.00069698063, 0.00070112001, 0.00070530479, 0.00070946675, 0.0007136513, 0.00071782444, 0.00072200876, 0.00072622724, 0.00073044561, 0.00073465263, 0.00073888211, 0.0007431116, 0.00074735226, 0.00075161556, 0.00075587904, 0.00076014228, 0.00076445111, 0.00076872535, 0.00077302253, 0.00077730801, 0.0007816506, 0.00078595878, 0.00079028978, 0.00079463172, 0.00079896249, 0.00080332713, 0.00080770307, 0.00081206771, 0.00081644347, 0.00082084211, 0.00082524051, 0.00082963886, 0.00083405979, 0.00083848072, 0.00084291282, 0.00084734504, 0.00085181108, 0.00085626589, 0.0008607317, 0.00086519745, 0.00086969754, 0.00087417464, 0.00087867427, 0.00088319683, 0.00088770763, 0.00089222973, 0.00089676335, 0.00090130809, 0.00090586435, 0.00091040868, 0.00091498747, 0.00091956597, 0.00092414452, 0.00092986907, 0.00093673758, 0.00094361743, 0.00095050875, 0.00095742283, 0.00096437114, 0.00097130815, 0.00097829069, 0.00098529609, 0.00099232432, 0.00099937536, 0.0010064149, 0.0010135002, 0.0010206311, 0.0010277505, 0.0010349043, 0.0010420922, 0.0010492688, 0.0010564795, 0.0010637359, 0.0010709923, 0.0010782487, 0.0010855622, 0.001092887, 0.0011002119, 0.0011075939, 0.0011149871, 0.0011223918, 0.001129808, 0.0011372698, 0.0011447544, 0.0011522389, 0.0011597577, 0.0011672879, 0.0011748525, 0.0011824283, 0.0011900384, 0.00119766, 0.0012053156, 0.00121296, 0.0012206613, 0.0012283742, 0.0012361098, 0.0012438453, 0.0012516037, 0.0012594078, 0.0012672232, 0.0012750729, 0.0012829454, 0.0012908294, 0.0012986904, 0.0013066314, 0.0013145723, 0.0013225476, 0.0013305455, 0.0013385437, 0.0013465645, 0.0013546195, 0.0013627087, 0.001370798, 0.0013789216, 0.0013870564, 0.0013952143, 0.0014033949, 0.0014115869, 0.0014198244, 0.0014280735, 0.0014363223, 0.0014446172, 0.0014529346, 0.0014612636, 0.0014696153, 0.0014779783, 0.0014863756, 0.0014947958, 0.0015032388, 0.0015117045, 0.0015201932, 0.0015286704, 0.0015371933, 0.0015457503, 0.0015543188, 0.0015629102, 0.0015715356, 0.0015801496, 0.0015887981, 0.0015974807, 0.0016061862, 0.0016148916, 0.0016236197, 0.0016323822, 0.0016411789, 0.001649987, 0.0016588065, 0.0016676373, 0.0016765139, 0.001685402, 0.0016943242, 0.0017032577, 0.0017122026, 0.0017211705, 0.0017301724, 0.0017391745, 0.0017482222, 0.0017573042, 0.0017663518, 0.0017754679, 0.001784584, 0.0017937458, 0.0018029076, 0.0018121036, 0.0018213111, 0.0018305526, 0.0018397945, 0.0018490816, 0.0018583804, 0.0018676904, 0.0018770118, 0.0018864019, 0.0018957689, 0.0019051819, 0.001914606, 0.0019240301, 0.0019335113, 0.0019430041, 0.0019525081, 0.0019620578, 0.001971619, 0.0019811685, 0.0019907642, 0.0020003936, 0.0020100344, 0.0020196983, 0.0020293735, 0.0020390716, 0.002048804, 0.0020585703, 0.0020683254, 0.0020781145, 0.0020879153, 0.0020977617, 0.0021076195, 0.0021174999, 0.0021274034, 0.0021373068, 0.0021472443, 0.0021571934, 0.0021671995, 0.0021772056, 0.0021872232, 0.0021972405, 0.0022073379, 0.0022174125, 0.0022275441, 0.0022376871, 0.0022478185, 0.0022579844, 0.0022681956, 0.0022784187, 0.0022886759, 0.0022989328, 0.0023092015, 0.0023195043, 0.002329841, 0.002340178, 0.0023505604, 0.0023609316, 0.0023713484, 0.0023817767, 0.0023922506, 0.0024027245, 0.0024132326, 0.0024237293, 0.0024342716, 0.0024448365, 0.0024554245, 0.0024660467, 0.0024766803, 0.0024873025, 0.0024979818, 0.0025086724, 0.0025193745, 0.0025301108, 0.0025408699, 0.0025516404, 0.0025624451, 0.0025732727, 0.0025841116, 0.0025949734, 0.0026058466, 0.0026167654, 0.0026276843, 0.002638649, 0.0026496018, 0.0026606005, 0.0026715994, 0.0026826435, 0.0026937108, 0.0027047892, 0.0027158908, 0.0027269921, 0.0027381277, 0.0027492864, 0.0027604899, 0.0027717056, 0.0027829211, 0.0027941593, 0.0028054318, 0.0028167274, 0.0028280567, 0.0028393865, 0.0028507391, 0.0028621026, 0.002873512, 0.0028849326, 0.0028963878, 0.0029078203, 0.0029193093, 0.0029308102, 0.0029423682, 0.0029539145, 0.0029654836, 0.0029770753, 0.0029886672, 0.0030003053, 0.0030119771, 0.0030236603, 0.0030353547, 0.0030470726, 0.0030588014, 0.0030705645, 0.0030823618, 0.0030941707, 0.003106002, 0.0031178449, 0.0031297223, 0.0031416223, 0.0031535223, 0.0031654679, 0.0031774023, 0.0031893938, 0.0032014078, 0.0032134219, 0.0032254702, 0.0032375415, 0.003249601, 0.0032617068, 0.0032738578, 0.0032860087, 0.0032981825, 0.0033103568, 0.0033225648, 0.0033348068, 0.0033470721, 0.0033593599, 0.0033716592, 0.0033839589, 0.0033963039, 0.0034086944, 0.0034210624, 0.003433476, 0.0034458777, 0.0034583481, 0.0034708187, 0.0034833122, 0.0034958508, 0.0035083788, 0.0035209064, 0.0035334907, 0.0035461094, 0.0035587281, 0.0035713702, 0.0035840459, 0.0035967105, 0.0036094207, 0.0036221538, 0.0036349208, 0.0036476764, 0.0036604551, 0.0036732908, 0.0036861261, 0.0036989849, 0.0037118548, 0.0037247587, 0.0037376857, 0.0037506237, 0.0037636077, 0.0037765917, 0.0037895984, 0.0038026052, 0.0038156691, 0.0038287444, 0.0038418423, 0.0038549632, 0.0038680839, 0.0038812277, 0.0038944285, 0.0039076293, 0.0039208638, 0.0039340989, 0.0039473567, 0.0039606486, 0.003973952, 0.0039872895, 0.0040006503, 0.0040140222, 0.0040274053, 0.0040408229, 0.0040542744, 0.0040677148, 0.0040812008, 0.0040946868, 0.0041082297, 0.0041217729, 0.0041353274, 0.0041489271, 0.0041625272, 0.0041761501, 0.0041898186, 0.0042034872, 0.0042171897, 0.0042309039, 0.0042446521, 0.0042583779, 0.0042721606, 0.0042859884, 0.0042998171, 0.0043136454, 0.0043274965, 0.0043414044, 0.0043553123, 0.0043692319, 0.0043831971, 0.0043971622, 0.0044111502, 0.0044251615, 0.0044392287, 0.0044532856, 0.0044673644, 0.0044814437, 0.0044955802, 0.0045097168, 0.0045238868, 0.0045380914, 0.0045522964, 0.0045665125, 0.0045807627, 0.004595059, 0.0046093552, 0.0046236622, 0.0046379925, 0.0046523688, 0.0046667331, 0.0046811434, 0.0046955645, 0.0047100205, 0.004724476, 0.0047389776, 0.0047534793, 0.0047680032, 0.0047825733, 0.0047971313, 0.0048117354, 0.0048263511, 0.0048409896, 0.00485565, 0.0048703458, 0.0048850183, 0.0048997593, 0.0049145003, 0.0049292641, 0.0049440623, 0.0049588718, 0.004973704, 0.0049885474, 0.0050034369, 0.0050183265, 0.00503325, 0.0050481735, 0.0050631426, 0.005078123, 0.0050931266, 0.005108153, 0.0051232129, 0.0051382505, 0.0051533571, 0.0051684743, 0.0051836148, 0.0051987325, 0.005213907, 0.005229115, 0.0052443473, 0.0052595902, 0.005274856, 0.0052901218, 0.0053054099, 0.0053207446, 0.0053361016, 0.0053514815, 0.0053668614, 0.0053822757, 0.00539769, 0.0054131495, 0.0054286323, 0.0054441378, 0.005459643, 0.005475183, 0.0054907342, 0.0055063418, 0.0055219391, 0.0055375691, 0.005553212, 0.0055688657, 0.0055845538, 0.0056002759, 0.0056160209, 0.0056317775, 0.0056475219, 0.005663347, 0.0056791608, 0.005694997, 0.0057108677, 0.0057267379, 0.005742643, 0.00575857, 0.0057745208, 0.0057904939, 0.0058064898, 0.0058224862, 0.0058385278, 0.0058545927, 0.0058706566, 0.005886755, 0.0059028771, 0.0059189983, 0.0059351656, 0.0059513673, 0.0059675798, 0.0059837815, 0.0060000168, 0.0060162987, 0.0060326019, 0.0060489066, 0.0060652564, 0.0060816058, 0.0060979556, 0.0061143623, 0.0061307917, 0.0061472328, 0.0061637079, 0.0061801607, 0.0061966814, 0.0062132021, 0.0062297573, 0.0062463353, 0.0062629133, 0.0062795137, 0.0062961485, 0.0063128294, 0.0063295104, 0.006346202, 0.0063629057, 0.0063796425, 0.0063964147, 0.0064131976, 0.0064300275, 0.0064468444, 0.0064636623, 0.0064805364, 0.0064974451, 0.0065143658, 0.0065312972, 0.006548252, 0.0065652174, 0.0065822066, 0.0065992293, 0.0066162865, 0.0066333548, 0.0066504115, 0.0066675488, 0.0066846623, 0.0067018112, 0.0067189825, 0.0067361761, 0.0067533823, 0.006770622, 0.0067878962, 0.0068051694, 0.0068224659, 0.0068397624, 0.0068571167, 0.0068744817, 0.006891869, 0.0069092801, 0.006926714, 0.0069441479, 0.0069616153, 0.0069791065, 0.0069966312, 0.0070141559, 0.0070317038, 0.007049297, 0.0070669022, 0.0070845182, 0.0071021682, 0.0071198302, 0.0071374923, 0.0071552, 0.0071729524, 0.0071907053, 0.0072084707, 0.0072262571, 0.0072440677, 0.0072619007, 0.0072797565, 0.0072976574, 0.007315537, 0.0073334491, 0.0073513966, 0.007369366, 0.0073873592, 0.007405363, 0.0074233892, 0.0074414285, 0.0074594896, 0.0074775955, 0.0074957251, 0.0075138668, 0.007532008, 0.0075501939, 0.0075683924, 0.0075866138, 0.0076048453, 0.0076231123, 0.0076414011, 0.0076597016, 0.0076780482, 0.0076963943, 0.0077147637, 0.0077331453, 0.007751571, 0.0077700079, 0.0077884579, 0.0078069633, 0.0078254584, 0.0078439638, 0.0078625046, 0.0078810789, 0.0078996532, 0.007918274, 0.0079368828, 0.0079555484, 0.0079742149, 0.0079929149, 0.0080116261, 0.0080303717, 0.0080491062, 0.0080678975, 0.0080867112, 0.0081055379, 0.0081243627, 0.0081432452, 0.0081621166, 0.0081810215, 0.0081999609, 0.0082189236, 0.0082378983, 0.0082568601, 0.0082758917, 0.0082949223, 0.0083139874, 0.0083330637, 0.0083521865, 0.0083712861, 0.0083904304, 0.00840961, 0.0084287897, 0.0084480029, 0.0084672049, 0.0084864749, 0.0085057458, 0.0085250512, 0.0085443668, 0.0085636824, 0.0085830335, 0.0086024292, 0.0086218482, 0.0086412672, 0.0086607207, 0.008680162, 0.008699649, 0.0087191593, 0.0087386928, 0.0087582478, 0.0087778158, 0.0087974053, 0.0088170301, 0.0088366652, 0.0088563235, 0.0088760164, 0.008895698, 0.0089154365, 0.008935174, 0.0089549348, 0.0089747421, 0.0089945486, 0.009014356, 0.0090342304, 0.0090540946, 0.0090739932, 0.0090939142, 0.0091138352, 0.0091337897, 0.0091537908, 0.0091737909, 0.0091938144, 0.0092138732, 0.0092339078, 0.0092540001, 0.0092741149, 0.0092942519, 0.0093144011, 0.0093345847, 0.0093547683, 0.0093749845, 0.009395225, 0.0094154887, 0.0094357738, 0.0094560608, 0.0094763925, 0.0094967354, 0.0095171127, 0.0095375124, 0.0095579131, 0.0095783249, 0.0095987814, 0.0096192732, 0.0096397642, 0.0096602896, 0.0096808262, 0.0097013637, 0.0097219571, 0.0097425627, 0.0097632026, 0.0097838193, 0.0098044937, 0.0098251784, 0.0098458985, 0.0098666176, 0.0098873833, 0.0099081481, 0.0099289473, 0.0099497698, 0.0099706147, 0.0099914828, 0.010012362, 0.010033241, 0.010054189, 0.010075126, 0.010096096, 0.010117089, 0.010138082, 0.010159122, 0.010180172, 0.010201245, 0.010222353, 0.010243471, 0.01026459, 0.010285766, 0.010306953, 0.010328152, 0.010349374, 0.010370641, 0.010391897, 0.010413187, 0.010434511, 0.010455836, 0.010477182, 0.01049854, 0.010519957, 0.010541372, 0.01056281, 0.010584258, 0.010605755, 0.010627239, 0.010648769, 0.010670345, 0.010691897, 0.010713494, 0.010735082, 0.010756725, 0.010778391, 0.010800069, 0.010821771, 0.010843471, 0.010865205, 0.010886964, 0.010908755, 0.010930571, 0.010952396, 0.010974246, 0.010996095, 0.011018001, 0.011039907, 0.011061848, 0.011083789, 0.011105763, 0.01112776, 0.011149791, 0.011171834, 0.0111939, 0.011215977, 0.011238066, 0.011260188, 0.011282346, 0.011304528, 0.011326728, 0.01134892, 0.011371158, 0.011393417, 0.011415678, 0.011437983, 0.0114603, 0.011482639, 0.011505012, 0.011527386, 0.011549806, 0.011572237, 0.011594657, 0.011617146, 0.011639633, 0.011662143, 0.011684678, 0.011707246, 0.011729801, 0.011752404, 0.011775039, 0.011797676, 0.011820347, 0.011843006, 0.011865722, 0.01188845, 0.011911189, 0.011933985, 0.011956769, 0.011979565, 0.012002396, 0.012025272, 0.012048147, 0.012071046, 0.012093957, 0.0121169, 0.012139857, 0.012162847, 0.012185859, 0.012208873, 0.012231908, 0.01225499, 0.012278093, 0.012301208, 0.012324346, 0.012347497, 0.012370658, 0.012393865, 0.012417084, 0.012440335, 0.01246361, 0.012486864, 0.012510184, 0.012533516, 0.012556859, 0.012580238, 0.012603616, 0.012627039, 0.012650463, 0.012673932, 0.012697401, 0.012720905, 0.012744408, 0.012767981, 0.012791529, 0.012815124, 0.012838742, 0.012862359, 0.012886001, 0.012909663, 0.01293336, 0.012957091, 0.012980823, 0.013004555, 0.013028355, 0.013052145, 0.013075978, 0.013099824, 0.013123681, 0.013147549, 0.013171475, 0.013195399, 0.013219349, 0.01324332, 0.013267302, 0.013291319, 0.01331536, 0.013339422, 0.013363508, 0.013387604, 0.0134117, 0.013435867, 0.013460032, 0.013484219, 0.013508431, 0.013532664, 0.013556886, 0.013581155, 0.013605468, 0.013629792, 0.013654105, 0.013678453, 0.013702846, 0.013727251, 0.013751669, 0.013776107, 0.013800569, 0.013825053, 0.013849572, 0.013874101, 0.013898655, 0.013923231, 0.013947808, 0.013972429, 0.013997072, 0.014021717, 0.014046419, 0.014071098, 0.014095822, 0.014120557, 0.014145339, 0.014170121, 0.014194947, 0.014219751, 0.014244613, 0.014269474, 0.01429437, 0.014319299, 0.01434424, 0.014369181, 0.014394179, 0.014419188, 0.014444186, 0.01446923, 0.014494285, 0.014519386, 0.014544498, 0.014569645, 0.014594791, 0.01461996, 0.014645129, 0.014670366, 0.014695604, 0.014720865, 0.014746137, 0.014771443, 0.014796748, 0.01482209, 0.014847476, 0.014872861, 0.014898271, 0.01492368, 0.014949146, 0.014974622, 0.01500011, 0.015025645, 0.01505118, 0.015076714, 0.015102294, 0.015127908, 0.015153546, 0.015179182, 0.015204842, 0.015230524, 0.015256242, 0.015281982, 0.015307744, 0.015333494, 0.015359269, 0.0153851, 0.015410942, 0.015436808, 0.015462696, 0.015488583, 0.015514505, 0.01554044, 0.015566419, 0.01559242, 0.015618434, 0.015644435, 0.015670506, 0.015696565, 0.015722672, 0.015748786, 0.015774926, 0.015801076, 0.015827261, 0.015853457, 0.015879698, 0.01590595, 0.015932193, 0.015958492, 0.015984813, 0.016011136, 0.016037481, 0.016063858, 0.016090248, 0.016116673, 0.016143119, 0.016169567, 0.016196061, 0.016222553, 0.016249079, 0.016275629, 0.016302189, 0.016328774, 0.016355405, 0.016382022, 0.016408674, 0.016435361, 0.01646206, 0.016488768, 0.01651549, 0.016542256, 0.016569035, 0.016595857, 0.016622692, 0.016649527, 0.016676374, 0.016703255, 0.016730182, 0.016757119, 0.016784079, 0.01681105, 0.016838046, 0.016865052, 0.016892092, 0.016919168, 0.01694623, 0.01697335, 0.017000457, 0.017027615, 0.017054791, 0.01708198, 0.01710918, 0.017136425, 0.01716366, 0.017190939, 0.017218253, 0.01724558, 0.017272893, 0.017300265, 0.017327636, 0.017355042, 0.017382471, 0.017409921, 0.017437384, 0.01746488, 0.017492389, 0.017519919, 0.017547484, 0.017575037, 0.017602649, 0.017630272, 0.017657893, 0.017685574, 0.017713264, 0.017740954, 0.017768679, 0.01779644, 0.017824197, 0.017851979, 0.017879784, 0.017907623, 0.017935485, 0.017963359, 0.017991254, 0.018019184, 0.018047115, 0.018075069, 0.018103067, 0.018131077, 0.018159099, 0.018187143, 0.0182152, 0.018243302, 0.018271413, 0.018299561, 0.018327696, 0.018355865, 0.018384069, 0.018412296, 0.018440548, 0.018468797, 0.018499661, 0.018533101, 0.018566599, 0.018600121, 0.01863363, 0.018667186, 0.01870073, 0.018734319, 0.018767919, 0.018801544, 0.018835189, 0.018868849, 0.018902518, 0.018936221, 0.018969947, 0.019003684, 0.019037457, 0.019071216, 0.019105023, 0.019138828, 0.019172668, 0.019206544, 0.019240396, 0.019274306, 0.019308226, 0.019342147, 0.019376112, 0.0194101, 0.019444076, 0.01947809, 0.019512134, 0.019546181, 0.01958026, 0.019614363, 0.019648455, 0.019682592, 0.019716751, 0.019750923, 0.019785104, 0.019819312, 0.019853549, 0.019887801, 0.019922076, 0.01995635, 0.01999067, 0.020024987, 0.020059342, 0.020093707, 0.020128109, 0.020162519, 0.020196928, 0.020231362, 0.020265829, 0.020300332, 0.020334834, 0.020369347, 0.020403884, 0.020438455, 0.020473048, 0.020507654, 0.020542281, 0.02057692, 0.020611571, 0.020646254, 0.020680962, 0.020715682, 0.020750422, 0.020785177, 0.020819942, 0.020854751, 0.020889584, 0.020924417, 0.020959262, 0.02099414, 0.021029042, 0.021063954, 0.021098901, 0.021133872, 0.02116883, 0.021203822, 0.021238828, 0.021273866, 0.021308949, 0.02134401, 0.021379095, 0.021414213, 0.021449331, 0.021484494, 0.021519681, 0.021554857, 0.021590067, 0.021625301, 0.021660555, 0.021695809, 0.021731108, 0.021766411, 0.021801759, 0.021837102, 0.021872485, 0.021907864, 0.021943258, 0.021978673, 0.022014132, 0.022049602, 0.022085099, 0.022120593, 0.022156112, 0.022191664, 0.022227215, 0.022262812, 0.022298433, 0.022334043, 0.022369673, 0.022405341, 0.022441026, 0.022476738, 0.022512475, 0.022548186, 0.022583943, 0.022619734, 0.022655535, 0.022691363, 0.022727177, 0.022763036, 0.022798929, 0.022834826, 0.022870753, 0.022906691, 0.022942644, 0.022978596, 0.023014603, 0.023050621, 0.023086678, 0.023122707, 0.023158796, 0.023194885, 0.023230983, 0.023267128, 0.023303295, 0.023339463, 0.023375643, 0.023411855, 0.023448104, 0.023484342, 0.023520622, 0.023556905, 0.023593219, 0.023629539, 0.023665899, 0.023702282, 0.023738636, 0.023775067, 0.023811497, 0.023847949, 0.023884401, 0.023920901, 0.0239574, 0.023993909, 0.024030477, 0.024067042, 0.024103632, 0.024140237, 0.024176849, 0.024213495, 0.024250176, 0.024286848, 0.024323553, 0.024360254, 0.024396995, 0.024433777, 0.024470562, 0.02450737, 0.024544166, 0.024580995, 0.024617869, 0.024654755, 0.024691653, 0.024728585, 0.024765519, 0.024802452, 0.02483944, 0.024876442, 0.024913454, 0.024950478, 0.024987534, 0.025024613, 0.025061706, 0.025098834, 0.025135983, 0.02517312, 0.025210282, 0.025247477, 0.025284706, 0.025321934, 0.025359198, 0.025396461, 0.025433736, 0.025471054, 0.025508398, 0.025545752, 0.025583096, 0.025620496, 0.025657907, 0.02569533, 0.025732789, 0.025770267, 0.025807738, 0.025845237, 0.025882777, 0.025920324, 0.025957897, 0.025995478, 0.026033072, 0.026070712, 0.026108364, 0.026146004, 0.0261837, 0.026221395, 0.026259115, 0.026296871, 0.026334636, 0.026372401, 0.026410209, 0.026448021, 0.026485879, 0.026523735, 0.026561625, 0.02659953, 0.026637418, 0.026675355, 0.026713327, 0.02675131, 0.0267893, 0.026827319, 0.026865371, 0.026903417, 0.02694148, 0.026979588, 0.027017705, 0.027055837, 0.02709399, 0.027132167, 0.027170377, 0.027208574, 0.02724682, 0.027285066, 0.027323334, 0.027361622, 0.027399946, 0.02743827, 0.027476629, 0.027514987, 0.02755337, 0.027591785, 0.027630234, 0.027668683, 0.027707158, 0.027745629, 0.027784126, 0.027822666, 0.027861221, 0.027899783, 0.027938379, 0.02797698, 0.028015599, 0.028054245, 0.02809291, 0.02813161, 0.028170301, 0.028209036, 0.028247772, 0.028286517, 0.028325308, 0.028364124, 0.028402939, 0.028441776, 0.028480636, 0.028519507, 0.028558426, 0.028597346, 0.028636286, 0.028675258, 0.02871421, 0.028753206, 0.028792238, 0.028831273, 0.028870337, 0.028909413, 0.028948504, 0.028987626, 0.029026762, 0.029065918, 0.029105095, 0.029144278, 0.02918349, 0.029222729, 0.029261976, 0.02930125, 0.029340552, 0.029379871, 0.029419189, 0.029458553, 0.029497914, 0.0295373, 0.029576719, 0.029616162, 0.029655615, 0.029695069, 0.029734559, 0.029774077, 0.029813603, 0.029853147, 0.029892715, 0.029932305, 0.02997192, 0.030011544, 0.030051179, 0.030090863, 0.030130534, 0.030170238, 0.030209966, 0.030249704, 0.030289479, 0.030329261, 0.030369069, 0.030408865, 0.030448731, 0.030488584, 0.030528473, 0.030568369, 0.030608289, 0.030648235, 0.030688191, 0.030728171, 0.030768184, 0.030808186, 0.030848242, 0.030888278, 0.03092836, 0.030968465, 0.031008592, 0.031048717, 0.031088879, 0.031129051, 0.031169238, 0.031209465, 0.031249685, 0.031289946, 0.031330235, 0.031370521, 0.031410832, 0.031451162, 0.031491507, 0.031531885, 0.031572275, 0.031612709, 0.031653132, 0.031693581, 0.031734049, 0.03177454, 0.031815045, 0.031855583, 0.031896133, 0.031936694, 0.031977288, 0.032017905, 0.032058522, 0.032099176, 0.032139827, 0.032180525, 0.032221232, 0.032261942, 0.032302696, 0.032343473, 0.032384228, 0.032425039, 0.032465883, 0.032506719, 0.032547574, 0.032588456, 0.03262936, 0.032670286, 0.032711223, 0.03275219, 0.032793183, 0.032834165, 0.03287518, 0.032916233, 0.032957289, 0.032998364, 0.033039473, 0.033080589, 0.033121716, 0.033162877, 0.033204053, 0.033245262, 0.033286463, 0.03332771, 0.033368953, 0.033410221, 0.033451535, 0.033492848, 0.033534184, 0.033575535, 0.0336169, 0.033658288, 0.033699706, 0.033741135, 0.033782605, 0.033824075, 0.033865556, 0.03390706, 0.033948597, 0.033990145, 0.034031715, 0.034073304, 0.034114912, 0.034156527, 0.034198184, 0.034239851, 0.034281556, 0.034323256, 0.034364987, 0.034406722, 0.034448475, 0.034490265, 0.034532081, 0.034573905, 0.034615759, 0.034657609, 0.034699492, 0.034741387, 0.034783311, 0.034825265, 0.034867238, 0.034909204, 0.034951203, 0.034993231, 0.035035264, 0.03507733, 0.035119407, 0.035161503, 0.035203621, 0.035245765, 0.035287928, 0.035330109, 0.035372294, 0.035414498, 0.035456754, 0.035498995, 0.035541289, 0.035583593, 0.035625909, 0.035668217, 0.035710573, 0.035752956, 0.035795353, 0.035837755, 0.035880197, 0.035922661, 0.035965111, 0.036007613, 0.03605013, 0.036092665, 0.036135204, 0.036177777, 0.036220368, 0.036262974, 0.03630561, 0.036348253, 0.036390938, 0.036433607, 0.036476314, 0.036519039, 0.036561776, 0.036604561, 0.036647357, 0.036690161, 0.036732975, 0.036775824, 0.036818687, 0.036861565, 0.036904465, 0.036947396, 0.036990345, 0.037033286, 0.037076291, 0.037119299, 0.037162304, 0.037205346, 0.037248403, 0.037291493, 0.037334595, 0.037377715, 0.037420861, 0.037464023, 0.037507191, 0.037550375, 0.037593607, 0.037636843, 0.037680104, 0.037723389, 0.03776665, 0.037809979, 0.03785333, 0.037896689, 0.037940059, 0.037983455, 0.038026873, 0.038070295, 0.038113732, 0.038157221, 0.038200725, 0.03824424, 0.038287766, 0.038331311, 0.038374882, 0.038418468, 0.03846208, 0.038505714, 0.038549375, 0.038593031, 0.038636718, 0.038680434, 0.038724147, 0.0387679, 0.038811676, 0.038855448, 0.038899269, 0.03894309, 0.038986936, 0.039030802, 0.039074682, 0.039118584, 0.039162517, 0.039206449, 0.039250426, 0.039294418, 0.039338399, 0.039382428, 0.039426476, 0.039470531, 0.039514616, 0.03955872, 0.039602842, 0.039646968, 0.039691139, 0.039735317, 0.039779522, 0.039823733, 0.039867986, 0.039912231, 0.039956499, 0.040000807, 0.040045131, 0.040089466, 0.040133819, 0.040178202, 0.040222585, 0.040267009, 0.040311422, 0.040355891, 0.040400371, 0.040444866, 0.040489368, 0.0405339, 0.040578462, 0.040623028, 0.040667616, 0.040712237, 0.040756848, 0.04080151, 0.040846191, 0.040890884, 0.040935572, 0.040980313, 0.041025057, 0.041069817, 0.041114613, 0.041159429, 0.041204263, 0.0412491, 0.04129396, 0.041338846, 0.041383766, 0.041428678, 0.041473627, 0.041518606, 0.041563552, 0.041608576, 0.041653596, 0.041698642, 0.041743707, 0.04178879, 0.041833885, 0.041879002, 0.041924145, 0.041969318, 0.042014498, 0.04205969, 0.0421049, 0.042150155, 0.042195406, 0.042240687, 0.042285986, 0.042331308, 0.042376634, 0.042421993, 0.042467374, 0.042512771, 0.042558186, 0.042603619, 0.042649098, 0.042694535, 0.042740043, 0.042785574, 0.042831097, 0.04287665, 0.042922217, 0.0429678, 0.043013416, 0.04305904, 0.043104712, 0.043150395, 0.043196067, 0.043241769, 0.043287516, 0.043333247, 0.04337902, 0.043424815, 0.043470629, 0.043516442, 0.043562301, 0.043608163, 0.043654047, 0.043699957, 0.04374589, 0.043791831, 0.043837789, 0.043883782, 0.043929797, 0.043975811, 0.044021867, 0.044067919, 0.044113994, 0.044160098, 0.044206213, 0.04425237, 0.044298545, 0.044344708, 0.044390906, 0.044437129, 0.044483367, 0.044529632, 0.044575907, 0.044622201, 0.044668522, 0.044714876, 0.044761226, 0.044807598, 0.044853993, 0.044900417, 0.044946846, 0.044993285, 0.045039777, 0.04508628, 0.04513279, 0.045179337, 0.045225874, 0.045272451, 0.045319039, 0.04536565, 0.045412295, 0.045458958, 0.045505609, 0.045552306, 0.045599017, 0.045645732, 0.0456925, 0.045739271, 0.045786034, 0.045832854, 0.045879703, 0.045926549, 0.045973409, 0.046020292, 0.046067197, 0.046114136, 0.046161074, 0.046208043, 0.046255041, 0.046302039, 0.046349049, 0.046396106, 0.046443168, 0.046490252, 0.046537355, 0.046584487, 0.046631608, 0.046678785, 0.046725966, 0.046773173, 0.046820376, 0.046867635, 0.046914883, 0.046962153, 0.047009461, 0.047056794, 0.047104131, 0.047151487, 0.047198862, 0.047246248, 0.047293678, 0.047341101, 0.047388583, 0.047436062, 0.047483556, 0.047531057, 0.047578607, 0.04762616, 0.047673721, 0.047721315, 0.047768939, 0.047816556, 0.047864206, 0.047911886, 0.047959592, 0.048007291, 0.048055038, 0.048102777, 0.048150532, 0.048198339, 0.048246138, 0.048293985, 0.048341822, 0.048389684, 0.048437573, 0.048485503, 0.048533417, 0.048581369, 0.048629336, 0.048677307, 0.048725318, 0.04877336, 0.048821408, 0.048869461, 0.048917547, 0.048965648, 0.049013764, 0.049061909, 0.049110081, 0.049158275, 0.049206458, 0.049254686, 0.049302932, 0.049351174, 0.049399469, 0.049447775, 0.049496099, 0.04954442, 0.049592793, 0.049641166, 0.049689583, 0.049737979, 0.049786434, 0.049834888, 0.049883347, 0.049931858, 0.049980376, 0.050028913, 0.050077461, 0.050126046, 0.050174624, 0.050223239, 0.050271876, 0.050320543, 0.050369229, 0.050417908, 0.050466605, 0.05051535, 0.050564088, 0.050612874, 0.050661668, 0.050710488, 0.050759297, 0.050808158, 0.050857022, 0.050905928, 0.050954819, 0.051003754, 0.051052704, 0.051101655, 0.05115065, 0.051199667, 0.051248688, 0.051297747, 0.051346794, 0.051395882, 0.051444992, 0.05149411, 0.051543258, 0.051592439, 0.051641587, 0.051690806, 0.051740039, 0.051789265, 0.05183854, 0.051887825, 0.051937114, 0.051986422, 0.052035782, 0.052085143, 0.052134525, 0.052183915, 0.052233346, 0.052282773, 0.05233223, 0.052381717, 0.052431215, 0.052480727, 0.052530266, 0.052579809, 0.0526294, 0.052679002, 0.052728608, 0.052778244, 0.052827906, 0.052877586, 0.052927256, 0.052976981, 0.053026706, 0.053076472, 0.053126246, 0.053176027, 0.053225838, 0.053275667, 0.053325523, 0.053375401, 0.053425286, 0.05347519, 0.053525127, 0.053575061, 0.05362504, 0.053675033, 0.053725034, 0.053775076, 0.05382511, 0.053875174, 0.053925261, 0.05397537, 0.054025482, 0.054075643, 0.054125812, 0.054175984, 0.054226205, 0.054276414, 0.054326657, 0.054376926, 0.054427207, 0.054477502, 0.054527823, 0.054578178, 0.054628532, 0.054678909, 0.054729309, 0.054779738, 0.054830175, 0.05488063, 0.054931108, 0.054981604, 0.055032134, 0.055082664, 0.055133231, 0.055183802, 0.055234391, 0.055285003, 0.055335648, 0.055386301, 0.055436969, 0.055487677, 0.055538379, 0.055589125, 0.055639867, 0.055690639, 0.055741448, 0.055792246, 0.055843081, 0.055893939, 0.055944808, 0.055995695, 0.056046613, 0.056097534, 0.056148496, 0.056199457, 0.056250449, 0.056301463, 0.056352496, 0.056403533, 0.05645461, 0.05650568, 0.056556787, 0.056607924, 0.056659065, 0.056710239, 0.056761432, 0.056812622, 0.056863848, 0.056915086, 0.056966346, 0.057017636, 0.05706894, 0.057120252, 0.057171613, 0.057222974, 0.057274353, 0.057325762, 0.057377163, 0.057428606, 0.057480078, 0.057531551, 0.057583053, 0.057634581, 0.057686109, 0.057737671, 0.057789229, 0.057840839, 0.057892457, 0.057944093, 0.057995752, 0.058047432, 0.058099113, 0.058150847, 0.058202576, 0.058254316, 0.058306098, 0.058357891, 0.058409702, 0.058461543, 0.058513381, 0.058565266, 0.058617167, 0.058669068, 0.058720991, 0.058772948, 0.058824927, 0.058876913, 0.058928922, 0.058980953, 0.059032999, 0.059085056, 0.059137154, 0.059189253, 0.059241381, 0.059293535, 0.059345696, 0.059397884, 0.059450109, 0.059502322, 0.059554555, 0.059606824, 0.059659112, 0.059711404, 0.059763744, 0.05981607, 0.059868447, 0.05992084, 0.059973225, 0.060025651, 0.060078096, 0.06013054, 0.060183022, 0.060235526, 0.060288042, 0.060340587, 0.060393143, 0.060445726, 0.060498323, 0.060550947, 0.060603574, 0.060656238, 0.060708914, 0.060761616, 0.060814336, 0.060867056, 0.060919825, 0.060972583, 0.061025389, 0.061078195, 0.06113103, 0.061183896, 0.061236762, 0.061289661, 0.061342567, 0.061395504, 0.061448433, 0.061501417, 0.061554413, 0.061607409, 0.061660461, 0.061713498, 0.06176877, 0.06182633, 0.061883897, 0.061941467, 0.061999034, 0.062056601, 0.062114157, 0.06217172, 0.062229272, 0.062286831, 0.062344383, 0.062401935, 0.062459484, 0.062517039, 0.062574595, 0.062632136, 0.062689684, 0.062747218, 0.062804766, 0.062862307, 0.062919855, 0.062977381, 0.063034922, 0.063092463, 0.063149989, 0.063207522, 0.063265055, 0.063322589, 0.063380107, 0.063437641, 0.063495144, 0.063552685, 0.063610211, 0.063667722, 0.063725241, 0.063782752, 0.063840277, 0.063897781, 0.0639553, 0.064012803, 0.064070314, 0.064127833, 0.064185329, 0.064242825, 0.064300343, 0.064357847, 0.064415336, 0.064472839, 0.064530343, 0.064587831, 0.064645328, 0.064702809, 0.064760312, 0.064817794, 0.06487529, 0.064932764, 0.064990252, 0.065047741, 0.065105215, 0.065162696, 0.06522017, 0.065277644, 0.065335125, 0.065392599, 0.065450065, 0.065507546, 0.06556502, 0.065622486, 0.065679953, 0.065737411, 0.06579487, 0.065852329, 0.065909803, 0.065967247, 0.066024713, 0.06608218, 0.066139616, 0.066197082, 0.066254519, 0.066311955, 0.066369414, 0.066426873, 0.06648431, 0.066541761, 0.066599198, 0.066656642, 0.066714063, 0.066771507, 0.066828936, 0.06688638, 0.066943817, 0.067001238, 0.067058675, 0.067116112, 0.067173526, 0.06723094, 0.067288376, 0.067345798, 0.06740322, 0.067460634, 0.067518063, 0.06757547, 0.067632891, 0.067690298, 0.067747697, 0.067805119, 0.067862526, 0.067919925, 0.067977332, 0.068034746, 0.068092145, 0.068149537, 0.068206936, 0.068264335, 0.068321727, 0.068379134, 0.068436511, 0.068493903, 0.068551309, 0.068608679, 0.068666071, 0.068723455, 0.068780832, 0.068838216, 0.068895608, 0.06895297, 0.069010362, 0.069067731, 0.069125116, 0.06918247, 0.069239862, 0.069297209, 0.069354586, 0.069411963, 0.069469318, 0.069526687, 0.069584042, 0.069641404, 0.069698758, 0.06975612, 0.069813475, 0.06987083, 0.069928184, 0.069985546, 0.070042893, 0.070100226, 0.070157588, 0.070214927, 0.070272274, 0.070329621, 0.070386946, 0.070444293, 0.07050164, 0.070558958, 0.070616305, 0.070673637, 0.070730969, 0.070788294, 0.070845619, 0.070902951, 0.070960276, 0.071017601, 0.071074918, 0.071132243, 0.071189567, 0.071246885, 0.071304195, 0.071361519, 0.071418822, 0.071476132, 0.071533449, 0.071590751, 0.071648061, 0.071705356, 0.071762651, 0.071819969, 0.071877271, 0.071934573, 0.071991861, 0.072049171, 0.072106458, 0.072163753, 0.072221041, 0.072278328, 0.072335616, 0.072392903, 0.072450191, 0.072507478, 0.072564766, 0.072622038, 0.072679326, 0.072736599, 0.072793871, 0.072851144, 0.072908424, 0.072965696, 0.073022962, 0.073080234, 0.073137499, 0.073194757, 0.073252022, 0.073309287, 0.073366553, 0.07342381, 0.073481068, 0.073538326, 0.073595583, 0.073652834, 0.073710077, 0.073767334, 0.073824584, 0.073881827, 0.073939078, 0.07399632, 0.074053556, 0.074110806, 0.074168049, 0.074225269, 0.074282512, 0.074339755, 0.074396983, 0.074454218, 0.074511454, 0.074568674, 0.074625902, 0.074683137, 0.07474035, 0.074797578, 0.074854791, 0.074912019, 0.074969232, 0.07502646, 0.075083666, 0.075140871, 0.075198099, 0.075255297, 0.075312503, 0.075369723, 0.075426914, 0.075484127, 0.075541332, 0.075598523, 0.075655729, 0.075712942, 0.075770125, 0.075827323, 0.075884521, 0.075941712, 0.075998902, 0.076056078, 0.076113284, 0.076170452, 0.07622765, 0.076284826, 0.076342009, 0.076399185, 0.076456375, 0.076513536, 0.076570719, 0.076627895, 0.076685056, 0.076742232, 0.076799408, 0.076856568, 0.076913737, 0.076970898, 0.077028066, 0.077085227, 0.077142388, 0.077199548, 0.077256702, 0.077313855, 0.077371001, 0.077428162, 0.077485316, 0.077542461, 0.077599607, 0.077656753, 0.077713892, 0.077771045, 0.077828184, 0.077885322, 0.077942461, 0.077999599, 0.078056738, 0.078113869, 0.078171, 0.078228131, 0.078285262, 0.078342393, 0.078399509, 0.07845664, 0.078513756, 0.07857088, 0.078628004, 0.078685127, 0.078742251, 0.078799352, 0.078856468, 0.078913584, 0.078970686, 0.079027802, 0.079084918, 0.079142019, 0.079199135, 0.079256229, 0.079313323, 0.079370432, 0.079427525, 0.079484619, 0.07954172, 0.079598814, 0.079655901, 0.079712987, 0.079770088, 0.079827167, 0.079884261, 0.079941347, 0.079998426, 0.080055512, 0.080112599, 0.080169663, 0.080226742, 0.080283828, 0.080340892, 0.080397971, 0.080455042, 0.080512106, 0.080569178, 0.080626242, 0.080683306, 0.08074037, 0.080797441, 0.080854498, 0.080911554, 0.080968611, 0.08102566, 0.081082717, 0.081139773, 0.081196822, 0.081253871, 0.08131092, 0.081367955, 0.081425011, 0.08148206, 0.081539094, 0.081596136, 0.081653178, 0.081710219, 0.081767246, 0.081824288, 0.081881322, 0.081938356, 0.081995383, 0.08205241, 0.082109429, 0.082166456, 0.08222349, 0.082280502, 0.082337528, 0.082394548, 0.08245156, 0.082508579, 0.082565598, 0.082622603, 0.082679622, 0.082736634, 0.082793638, 0.08285065, 0.082907647, 0.082964644, 0.083021656, 0.08307866, 0.083135657, 0.083192647, 0.083249651, 0.08330664, 0.08336363, 0.083420634, 0.083477609, 0.083534606, 0.083591595, 0.083648577, 0.083705559, 0.083762541, 0.083819516, 0.083876505, 0.08393348, 0.083990447, 0.084047429, 0.084104404, 0.084161371, 0.084218346, 0.08427532, 0.08433228, 0.084389247, 0.084446222, 0.084503174, 0.084560141, 0.084617093, 0.084674053, 0.084731005, 0.084787965, 0.084844917, 0.084901869, 0.084958822, 0.085015766, 0.085072719, 0.085129656, 0.085186608, 0.085243545, 0.085300483, 0.085357428, 0.085414357, 0.085471302, 0.08552824, 0.085585169, 0.085642099, 0.085699029, 0.085755952, 0.085812889, 0.085869811, 0.085926726, 0.085983664, 0.086040579, 0.086097501, 0.086154409, 0.086211331, 0.086268246, 0.086325161, 0.086382076, 0.086438976, 0.086495899, 0.086552806, 0.086609699, 0.086666614, 0.086723506, 0.086780414, 0.086837307, 0.086894214, 0.086951099, 0.087008007, 0.0870649, 0.087121785, 0.087178677, 0.087235563, 0.087292448, 0.087349333, 0.087406233, 0.087463103, 0.087519988, 0.087576874, 0.087633751, 0.087690629, 0.087747492, 0.087804377, 0.08786124, 0.087918125, 0.087974988, 0.088031858, 0.088088721, 0.088145584, 0.088202454, 0.088259295, 0.08831618, 0.088373028, 0.088429883, 0.088486739, 0.088543586, 0.088600442, 0.08865729, 0.088714138, 0.088770993, 0.088827841, 0.088884681, 0.088941514, 0.088998362, 0.089055203, 0.089112051, 0.089168884, 0.089225717, 0.089282542, 0.089339375, 0.089396216, 0.089453034, 0.08950986, 0.089566685, 0.089623511, 0.089680344, 0.089737162, 0.089793988, 0.089850798, 0.089907616, 0.089964442, 0.090021245, 0.090078048, 0.090134874, 0.090191677, 0.09024848, 0.090305299, 0.090362094, 0.090418905, 0.090475701, 0.090532504, 0.0905893, 0.090646096, 0.090702899, 0.090759702, 0.090816483, 0.090873271, 0.090930067, 0.090986855, 0.091043636, 0.091100425, 0.091157198, 0.091213979, 0.091270767, 0.091327541, 0.091384314, 0.091441102, 0.091497861, 0.091554649, 0.091611415, 0.091668181, 0.091724962, 0.091781728, 0.091838494, 0.091895245, 0.091952018, 0.092008762, 0.092065528, 0.092122294, 0.092179038, 0.092235796, 0.092292547, 0.092349291, 0.092406057, 0.0924628, 0.092519537, 0.092576288, 0.092633031, 0.092689767, 0.092746511, 0.092803247, 0.092859991, 0.092916727, 0.092973456, 0.093030185, 0.093086921, 0.093143649, 0.093200378, 0.093257114, 0.093313828, 0.093370572, 0.093427271, 0.093483999, 0.093540721, 0.093597427, 0.093654148, 0.093710877, 0.093767576, 0.093824282, 0.093881011, 0.09393771, 0.093994416, 0.094051123, 0.094107814, 0.094164528, 0.094221234, 0.094277941, 0.094334625, 0.094391324, 0.094448008, 0.094504707, 0.094561398, 0.094618082, 0.094674788, 0.094731472, 0.094788142, 0.094844826, 0.094901524, 0.094958194, 0.09501487, 0.095071554, 0.095128231, 0.0951849, 0.095241576, 0.095298238, 0.095354915, 0.095411576, 0.095468253, 0.095524907, 0.095581591, 0.095638238, 0.0956949, 0.095751561, 0.095808215, 0.09586487, 0.095921539, 0.095978186, 0.096034832, 0.096091487, 0.096148141, 0.096204773, 0.096261427, 0.096318074, 0.096374713, 0.096431352, 0.096487992, 0.096544631, 0.096601285, 0.096657909, 0.096714526, 0.096771173, 0.096827798, 0.096884422, 0.096941054, 0.096997686, 0.097054303, 0.097110935, 0.097167552, 0.097224161, 0.097280785, 0.097337402, 0.097394012, 0.097450629, 0.097507246, 0.097563848, 0.09762045, 0.097677074, 0.097733669, 0.097790278, 0.097846888, 0.097903483, 0.09796007, 0.098016687, 0.098073274, 0.098129861, 0.098186471, 0.09824305, 0.098299652, 0.098356239, 0.098412819, 0.098469406, 0.098525986, 0.098582573, 0.09863916, 0.09869574, 0.098752305, 0.098808885, 0.098865472, 0.098922037, 0.098978616, 0.099035181, 0.099091753, 0.099148311, 0.09920489, 0.099261455, 0.099317998, 0.09937457, 0.099431135, 0.099487692, 0.099544235, 0.099600799, 0.099657349, 0.099713907, 0.099770471, 0.099827014, 0.099883556, 0.099940099, 0.099996641, 0.10005318, 0.10010973, 0.10016626, 0.10022282, 0.10027934, 0.10033587, 0.10039242, 0.10044895, 0.10050547, 0.10056201, 0.10061854, 0.10067506, 0.10073159, 0.10078811, 0.10084462, 0.10090115, 0.10095767, 0.10101418, 0.10107071, 0.10112722, 0.10118372, 0.10124023, 0.10129674, 0.10135324, 0.10140976, 0.10146626, 0.10152277, 0.10157928, 0.10163578, 0.10169226, 0.10174876, 0.10180525, 0.10186173, 0.10191824, 0.10197474, 0.10203123, 0.10208771, 0.1021442, 0.10220069, 0.10225715, 0.10231365, 0.10237013, 0.1024266, 0.10248309, 0.10253957, 0.10259603, 0.10265251, 0.10270898, 0.10276544, 0.1028219, 0.10287838, 0.10293485, 0.10299131, 0.10304778, 0.10310424, 0.10316069, 0.10321715, 0.1032736, 0.10333006, 0.10338651, 0.10344296, 0.10349941, 0.10355587, 0.1036123, 0.10366875, 0.10372519, 0.10378163, 0.10383807, 0.10389451, 0.10395095, 0.10400739, 0.10406382, 0.10412025, 0.10417668, 0.10423312, 0.10428955, 0.10434598, 0.1044024, 0.10445881, 0.10451523, 0.10457166, 0.10462808, 0.10468449, 0.10474093, 0.10479733, 0.10485373, 0.10491016, 0.10496656, 0.10502296, 0.10507938, 0.10513578, 0.10519218, 0.10524859, 0.10530499, 0.10536138, 0.10541779, 0.10547418, 0.10553057, 0.10558697, 0.10564337, 0.10569974, 0.10575613, 0.10581252, 0.1058689, 0.10592528, 0.10598168, 0.10603805, 0.10609443, 0.10615081, 0.10620718, 0.10626356, 0.10631994, 0.10637631, 0.10643267, 0.10648904, 0.10654541, 0.10660177, 0.10665815, 0.1067145, 0.10677085, 0.10682723, 0.10688357, 0.10693993, 0.1069963, 0.10705264, 0.107109, 0.10716534, 0.10722169, 0.10727803, 0.10733439, 0.10739073, 0.10744707, 0.10750341, 0.10755975, 0.10761608, 0.10767242, 0.10772876, 0.10778509, 0.10784143, 0.10789775, 0.10795408, 0.10801041, 0.10806675, 0.10812306, 0.10817938, 0.10823571, 0.10829201, 0.10834835, 0.10840466, 0.10846098, 0.10851728, 0.1085736, 0.1086299, 0.10868621, 0.10874253, 0.10879882, 0.10885514, 0.10891144, 0.10896773, 0.10902403, 0.10908034, 0.10913663, 0.10919293, 0.10924923, 0.10930552, 0.1093618, 0.10941809, 0.10947437, 0.10953066, 0.10958695, 0.10964323, 0.10969951, 0.10975579, 0.10981207, 0.10986835, 0.10992461, 0.10998088, 0.11003716, 0.11009342, 0.1101497, 0.11020598, 0.11026224, 0.11031849, 0.11037476, 0.11043102, 0.11048728, 0.11054354, 0.1105998, 0.11065607, 0.1107123, 0.11076856, 0.11082481, 0.11088105, 0.1109373, 0.11099356, 0.1110498, 0.11110605, 0.11116228, 0.11121852, 0.11127477, 0.111331, 0.11138723, 0.11144347, 0.1114997, 0.11155593, 0.11161215, 0.11166839, 0.11172462, 0.11178083, 0.11183706, 0.11189327, 0.11194949, 0.11200573, 0.11206193, 0.11211815, 0.11217436, 0.11223057, 0.11228678, 0.112343, 0.11239921, 0.11245541, 0.11251161, 0.11256781, 0.11262401, 0.11268022, 0.11273641, 0.11279261, 0.11284881, 0.112905, 0.11296119, 0.11301739, 0.11307357, 0.11312976, 0.11318594, 0.11324213, 0.11329832, 0.1133545, 0.11341068, 0.11346686, 0.11352304, 0.11357921, 0.11363538, 0.11369155, 0.11374773, 0.11380389, 0.11386006, 0.11391623, 0.1139724, 0.11402856, 0.11408472, 0.11414088, 0.11419705, 0.11425321, 0.11430935, 0.11436551, 0.11442166, 0.11447779, 0.11453395, 0.11459012, 0.11464626, 0.1147024, 0.11475854, 0.11481468, 0.11487082, 0.11492696, 0.1149831, 0.11503923, 0.11509537, 0.11515149, 0.11520763, 0.11526377, 0.11531989, 0.11537602, 0.11543214, 0.11548826, 0.11554438, 0.1156005, 0.11565662, 0.11571275, 0.11576886, 0.11582497, 0.11588109, 0.1159372, 0.11599331, 0.11604942, 0.11610552, 0.11616163, 0.11621774, 0.11627383, 0.11632994, 0.11638603, 0.11644212, 0.11649822, 0.11655432, 0.11661041, 0.11666651, 0.11672259, 0.11677868, 0.11683477, 0.11689085, 0.11694694, 0.11700303, 0.1170591, 0.11711518, 0.11717126, 0.11722732, 0.1172834, 0.11733948, 0.11739554, 0.11745163, 0.11750769, 0.11756375, 0.11761981, 0.11767589, 0.11773195, 0.117788, 0.11784407, 0.11790012, 0.11795618, 0.11801224, 0.11806828, 0.11812434, 0.11818039, 0.11823642, 0.11829247, 0.11834854, 0.11840457, 0.11846061, 0.11851666, 0.11857219, 0.11862721, 0.11868219, 0.11873714, 0.11879205, 0.11884697, 0.11890183, 0.11895666, 0.11901148, 0.11906625, 0.11912099, 0.11917572, 0.11923041, 0.11928506, 0.1193397, 0.1193943, 0.11944886, 0.11950341, 0.11955791, 0.1196124, 0.11966685, 0.11972126, 0.11977565, 0.11983001, 0.11988435, 0.11993864, 0.11999293, 0.12004716, 0.12010137, 0.12015557, 0.12020972, 0.12026383, 0.12031793, 0.120372, 0.12042603, 0.12048004, 0.12053402, 0.12058796, 0.12064187, 0.12069576, 0.12074962, 0.12080345, 0.12085725, 0.120911, 0.12096474, 0.12101845, 0.12107214, 0.12112579, 0.12117941, 0.12123299, 0.12128656, 0.12134008, 0.12139358, 0.12144704, 0.12150049, 0.12155391, 0.12160729, 0.12166063, 0.12171394, 0.12176725, 0.12182052, 0.12187375, 0.12192696, 0.12198012, 0.12203328, 0.12208638, 0.12213947, 0.12219252, 0.12224554, 0.12229855, 0.12235152, 0.12240444, 0.12245735, 0.12251024, 0.12256307, 0.12261589, 0.12266868, 0.12272142, 0.12277417, 0.12282687, 0.12287953, 0.12293217, 0.12298479, 0.12303735, 0.12308992, 0.12314243, 0.12319492, 0.12324737, 0.12329981, 0.1233522, 0.12340458, 0.12345693, 0.12350924, 0.12356152, 0.12361377, 0.123666, 0.12371819, 0.12377035, 0.12382249, 0.12387459, 0.12392668, 0.12397871, 0.12403073, 0.12408272, 0.12413467, 0.1241866, 0.12423849, 0.12429036, 0.12434219, 0.12439401, 0.12444577, 0.12449753, 0.12454925, 0.12460095, 0.1246526, 0.12470423, 0.12475583, 0.1248074, 0.12485894, 0.12491045, 0.12496193, 0.12501338, 0.12506481, 0.12511618, 0.12516756, 0.1252189, 0.12527019, 0.12532145, 0.12537271, 0.12542392, 0.12547511, 0.12552625, 0.12557738, 0.12562847, 0.12567954, 0.12573057, 0.12578158, 0.12583256, 0.1258835, 0.12593444, 0.12598531, 0.12603617, 0.126087, 0.12613779, 0.12618856, 0.12623928, 0.12629001, 0.12634069, 0.12639134, 0.12644194, 0.12649255, 0.1265431, 0.12659363, 0.12664413, 0.12669462, 0.12674505, 0.12679546, 0.12684584, 0.12689619, 0.12694651, 0.1269968, 0.12704706, 0.12709731, 0.1271475, 0.12719768, 0.12724783, 0.12729794, 0.12734802, 0.12739807, 0.1274481, 0.12749809, 0.12754807, 0.127598, 0.12764791, 0.12769778, 0.12774764, 0.12779745, 0.12784724, 0.12789699, 0.12794672, 0.12799641, 0.1280461, 0.12809575, 0.12814535, 0.12819493, 0.12824447, 0.12829401, 0.12834349, 0.12839295, 0.12844238, 0.12849179, 0.12854116, 0.12859049, 0.12863982, 0.12868908, 0.12873833, 0.12878756, 0.12883675, 0.12888592, 0.12893505, 0.12898417, 0.12903322, 0.12908229, 0.1291313, 0.1291803, 0.12922925, 0.12927817, 0.12932707, 0.12937595, 0.12942477, 0.12947358, 0.12952237, 0.12957111, 0.12961984, 0.12966853, 0.12971717, 0.12976581, 0.1298144, 0.12986298, 0.12991153, 0.12996003, 0.13000852, 0.13005696, 0.13010538, 0.13015378, 0.13020213, 0.13025048, 0.13029876, 0.13034704, 0.13039528, 0.1304435, 0.13049169, 0.13053983, 0.13058797, 0.13063605, 0.13068412, 0.13073216, 0.13078016, 0.13082814, 0.13087609, 0.13092402, 0.13097189, 0.13101976, 0.13106757, 0.13111536, 0.13116315, 0.13121088, 0.13125859, 0.13130628, 0.13135391, 0.13140154, 0.13144913, 0.1314967, 0.13154423, 0.13159172, 0.13163918, 0.13168666, 0.13173406, 0.13178143, 0.1318288, 0.13187611, 0.13192339, 0.13197067, 0.13201791, 0.13206512, 0.13211228, 0.13215943, 0.13220653, 0.13225363, 0.13230067, 0.1323477, 0.1323947, 0.13244167, 0.13248861, 0.1325355, 0.1325824, 0.13262925, 0.13267605, 0.13272284, 0.1327696, 0.13281633, 0.13286303, 0.13290972, 0.13295634, 0.13300295, 0.13304955, 0.13309608, 0.13314259, 0.1331891, 0.13323556, 0.13328199, 0.13332838, 0.13337475, 0.13342111, 0.13346742, 0.1335137, 0.13355996, 0.13360618, 0.13365237, 0.13369854, 0.13374467, 0.13379078, 0.13383685, 0.13388291, 0.13392892, 0.13397491, 0.13402086, 0.13406678, 0.1341127, 0.13415855, 0.13420439, 0.13425021, 0.13429599, 0.13434172, 0.13438745, 0.13443314, 0.13447881, 0.13452443, 0.13457003, 0.1346156, 0.13466112, 0.13470665, 0.13475214, 0.13479759, 0.13484299, 0.1348884, 0.13493375, 0.13497908, 0.1350244, 0.13506967, 0.13511491, 0.13516013, 0.13520531, 0.13525048, 0.1352956, 0.13534069, 0.13538575, 0.1354308, 0.13547578, 0.13552077, 0.13556573, 0.13561064, 0.13565552, 0.13570039, 0.13574523, 0.13579001, 0.13583478, 0.13587952, 0.13592422, 0.13596891, 0.13601355, 0.13605818, 0.13610277, 0.13614734, 0.13619186, 0.13623637, 0.13628083, 0.13632528, 0.13636969, 0.13641408, 0.13645843, 0.13650274, 0.13654703, 0.1365913, 0.13663554, 0.13667974, 0.13672392, 0.13676807, 0.13681218, 0.13685626, 0.13690032, 0.13694435, 0.13698836, 0.13703232, 0.13707626, 0.13712017, 0.13716403, 0.13720788, 0.1372517, 0.13729548, 0.13733925, 0.13738297, 0.13742667, 0.13747036, 0.13751398, 0.13755761, 0.13760118, 0.13764474, 0.13768825, 0.13773175, 0.13777521, 0.13781863, 0.13786204, 0.13790542, 0.13794875, 0.13799208, 0.13803536, 0.13807862, 0.13812183, 0.13816504, 0.1382082, 0.13825133, 0.13829444, 0.13833752, 0.13838056, 0.13842358, 0.13846657, 0.13850953, 0.13855246, 0.13859534, 0.13863821, 0.13868105, 0.13872387, 0.13876663, 0.1388094, 0.13885212, 0.1388948, 0.13893746, 0.13898009, 0.13902269, 0.13906527, 0.13910781, 0.13915032, 0.13919279, 0.13923526, 0.13927768, 0.13932006, 0.13936244, 0.13940476, 0.13944706, 0.13948934, 0.13953158, 0.1395738, 0.13961598, 0.13965814, 0.13970026, 0.13974236, 0.13978443, 0.13982646, 0.13986847, 0.13991044, 0.13995241, 0.13999432, 0.14003621, 0.14007807, 0.14011988, 0.14016168, 0.14020345, 0.14024518, 0.14028691, 0.14032859, 0.14037023, 0.14041185, 0.14045344, 0.14049502, 0.14053655, 0.14057803, 0.14061952, 0.14066096, 0.14070238, 0.14074376, 0.14078511, 0.14082643, 0.14086773, 0.14090899, 0.14095022, 0.14099142, 0.14103262, 0.14107375, 0.14111486, 0.14115596, 0.141197, 0.14123803, 0.14127904, 0.14132001, 0.14136094, 0.14140184, 0.14144273, 0.14148358, 0.14152439, 0.14156517, 0.14160594, 0.14164668, 0.14168738, 0.14172804, 0.14176868, 0.1418093, 0.14184988, 0.14189042, 0.14193094, 0.14197144, 0.1420119, 0.14205232, 0.14209273, 0.14213312, 0.14217345, 0.14221378, 0.14225404, 0.1422943, 0.14233454, 0.14237472, 0.1424149, 0.14245503, 0.14249513, 0.14253521, 0.14257526, 0.14261527, 0.14265525, 0.14269522, 0.14273515, 0.14277504, 0.14281492, 0.14285475, 0.14289457, 0.14293434, 0.14297409, 0.14301381, 0.1430535, 0.14309315, 0.14313281, 0.1431724, 0.14321198, 0.14325151, 0.14329101, 0.1433305, 0.14336996, 0.14340939, 0.14344877, 0.14348814, 0.14352748, 0.14356679, 0.14360605, 0.14364529, 0.14368451, 0.1437237, 0.14376286, 0.14380197, 0.14384109, 0.14388014, 0.14391918, 0.14395818, 0.14399716, 0.14403611, 0.14407504, 0.14411391, 0.14415278, 0.14419161, 0.14423041, 0.14426917, 0.14430791, 0.14434662, 0.14438531, 0.14442396, 0.14446257, 0.14450118, 0.14453973, 0.14457826, 0.14461677, 0.14465523, 0.14469369, 0.14473209, 0.14477049, 0.14480883, 0.14484717, 0.14488545, 0.14492373, 0.14496194, 0.14500016, 0.14503832, 0.14507648, 0.1451146, 0.14515269, 0.14519075, 0.14522877, 0.14526676, 0.14530474, 0.14534268, 0.14538057, 0.14541845, 0.1454563, 0.14549412, 0.14553192, 0.14556967, 0.1456074, 0.14564511, 0.14568278, 0.14572042, 0.14575803, 0.14579561, 0.14583316, 0.14587069, 0.14590818, 0.14594564, 0.14598309, 0.14602047, 0.14605784, 0.14609519, 0.14613251, 0.1461698, 0.14620705, 0.14624427, 0.14628147, 0.14631863, 0.14635578, 0.14639288, 0.14642996, 0.146467, 0.14650401, 0.146541, 0.14657797, 0.14661489, 0.14665179, 0.14668867, 0.14672551, 0.14676231, 0.14679909, 0.14683585, 0.14687255, 0.14690925, 0.14694591, 0.14698255, 0.14701913, 0.14705572, 0.14709227, 0.14712878, 0.14716525, 0.1472017, 0.14723814, 0.14727452, 0.14731088, 0.14734721, 0.14738353, 0.14741981, 0.14745605, 0.14749227, 0.14752845, 0.1475646, 0.14760074, 0.14763683, 0.14767289, 0.14770894, 0.14774495, 0.14778091, 0.14781688, 0.14785279, 0.14788868, 0.14792454, 0.14796036, 0.14799616, 0.14803195, 0.14806767, 0.14810339, 0.14813906, 0.14817473, 0.14821033, 0.14824593, 0.14828148, 0.14831702, 0.14835253, 0.148388, 0.14842345, 0.14845885, 0.14849424, 0.14852959, 0.14856492, 0.14860022, 0.14863549, 0.14867072, 0.14870593, 0.14874111, 0.14877625, 0.14881136, 0.14884646, 0.14888151, 0.14891654, 0.14895153, 0.1489865, 0.14902143, 0.14905636, 0.14909123, 0.14912607, 0.14916091, 0.14919569, 0.14923045, 0.14926518, 0.14929989, 0.14933455, 0.1493692, 0.1494038, 0.1494384, 0.14947294, 0.14950746, 0.14954196, 0.14957643, 0.14961086, 0.14964527, 0.14967962, 0.14971398, 0.1497483, 0.14978257, 0.14981683, 0.14985107, 0.14988527, 0.14991942, 0.14995356, 0.14998765, 0.15002173, 0.15005578, 0.15008982, 0.15012379, 0.15015775, 0.15019168, 0.15022558, 0.15025945, 0.15029328, 0.1503271, 0.15036088, 0.15039463, 0.15042835, 0.15046205, 0.15049571, 0.15052934, 0.15056294, 0.15059651, 0.15063006, 0.15066357, 0.15069704, 0.15073051, 0.15076393, 0.15079732, 0.15083069, 0.15086402, 0.15089732, 0.1509306, 0.15096384, 0.15099706, 0.15103026, 0.15106341, 0.15109654, 0.15112963, 0.1511627, 0.15119573, 0.15122874, 0.15126173, 0.15129466, 0.1513276, 0.15136048, 0.15139334, 0.15142617, 0.15145898, 0.15149175, 0.15152448, 0.15155719, 0.15158987, 0.15162253, 0.15165515, 0.15168776, 0.15172032, 0.15175284, 0.15178533, 0.15181781, 0.15185025, 0.15188266, 0.15191506, 0.15194741, 0.15197974, 0.15201204, 0.1520443, 0.15207653, 0.15210874, 0.15214092, 0.15217306, 0.15220517, 0.15223727, 0.15226933, 0.15230134, 0.15233335, 0.15236531, 0.15239726, 0.15242918, 0.15246104, 0.1524929, 0.15252472, 0.15255651, 0.15258826, 0.15262, 0.1526517, 0.15268338, 0.15271501, 0.15274663, 0.15277819, 0.15280977, 0.1528413, 0.15287279, 0.15290424, 0.15293567, 0.15296708, 0.15299846, 0.15302981, 0.15306112, 0.1530924, 0.15312365, 0.15315489, 0.15318608, 0.15321724, 0.15324838, 0.1532795, 0.15331058, 0.15334162, 0.15337265, 0.15340362, 0.15343457, 0.15346551, 0.15349641, 0.15352727, 0.15355812, 0.15358894, 0.15361972, 0.15365046, 0.15368119, 0.15371187, 0.15374254, 0.15377317, 0.15380378, 0.15383434, 0.15386489, 0.15389541, 0.15392588, 0.15395634, 0.15398677, 0.15401718, 0.15404752, 0.15407786, 0.15410817, 0.15413843, 0.1541687, 0.1541989, 0.15422909, 0.15425925, 0.15428936, 0.15431947, 0.15434954, 0.15437958, 0.15440959, 0.15443955, 0.15446952, 0.15449944, 0.15452933, 0.15455918, 0.15458901, 0.15461881, 0.1546486, 0.15467833, 0.15470804, 0.15473773, 0.15476738, 0.154797, 0.1548266, 0.15485615, 0.15488568, 0.1549152, 0.15494466, 0.15497412, 0.15500353, 0.1550329, 0.15506226, 0.15509158, 0.15512088, 0.15515015, 0.15517938, 0.15520859, 0.15523776, 0.15526691, 0.15529603, 0.15532513, 0.15535419, 0.15538321, 0.15541221, 0.15544118, 0.15547012, 0.15549903, 0.1555279, 0.15555677, 0.15558559, 0.15561436, 0.15564314, 0.15567186, 0.15570055, 0.15572923, 0.15575787, 0.1557865, 0.15581506, 0.15584362, 0.15587215, 0.15590064, 0.1559291, 0.15595753, 0.15598595, 0.15601432, 0.15604267, 0.15607098, 0.15609927, 0.15612753, 0.15615575, 0.15618394, 0.15621212, 0.15624025, 0.15626836, 0.15629645, 0.15632449, 0.15635251, 0.1563805, 0.15640846, 0.15643638, 0.15646428, 0.15649216, 0.15652001, 0.1565478, 0.15657559, 0.15660334, 0.15663107, 0.15665875, 0.15668641, 0.15671405, 0.15674165, 0.15676923, 0.15679677, 0.15682429, 0.15685177, 0.15687922, 0.15690665, 0.15693404, 0.15696141, 0.15698874, 0.15701604, 0.15704332, 0.15707058, 0.15709779, 0.15712497, 0.15715215, 0.15717927, 0.15720636, 0.15723343, 0.15726046, 0.15728746, 0.15731445, 0.15734141, 0.15736833, 0.15739521, 0.15742208, 0.1574489, 0.15747571, 0.15750249, 0.15752922, 0.15755592, 0.15758261, 0.15760927, 0.1576359, 0.15766248, 0.15768903, 0.15771559, 0.15774208, 0.15776855, 0.15779501, 0.15782142, 0.15784781, 0.15787417, 0.15790048, 0.15792678, 0.15795305, 0.15797928, 0.15800549, 0.15803167, 0.15805782, 0.15808393, 0.15811002, 0.15813608, 0.15816212, 0.1581881, 0.15821408, 0.15824001, 0.15826593, 0.1582918, 0.15831766, 0.15834349, 0.15836927, 0.15839504, 0.15842077, 0.15844648, 0.15847214, 0.1584978, 0.1585234, 0.15854897, 0.15857452, 0.15860006, 0.15862554, 0.15865102, 0.15867645, 0.15870187, 0.15872724, 0.1587497, 0.15876924, 0.15878874, 0.15880817, 0.15882759, 0.15884693, 0.15886627, 0.15888554, 0.15890476, 0.15892394, 0.15894309, 0.15896218, 0.15898123, 0.15900025, 0.1590192, 0.15903813, 0.15905699, 0.15907583, 0.15909462, 0.15911335, 0.15913205, 0.1591507, 0.1591693, 0.15918787, 0.15920639, 0.15922487, 0.15924329, 0.15926167, 0.15928002, 0.15929832, 0.15931657, 0.15933478, 0.15935294, 0.15937106, 0.15938914, 0.15940717, 0.15942515, 0.1594431, 0.15946099, 0.15947884, 0.15949665, 0.15951443, 0.15953214, 0.15954983, 0.15956745, 0.15958503, 0.15960258, 0.15962008, 0.15963753, 0.15965495, 0.1596723, 0.15968962, 0.15970691, 0.15972415, 0.15974133, 0.15975846, 0.15977557, 0.15979262, 0.15980963, 0.15982661, 0.15984353, 0.1598604, 0.15987724, 0.15989402, 0.15991077, 0.15992747, 0.15994413, 0.15996075, 0.1599773, 0.15999381, 0.16001031, 0.16002674, 0.16004314, 0.16005948, 0.16007578, 0.16009204, 0.16010824, 0.16012442, 0.16014054, 0.16015662, 0.16017266, 0.16018865, 0.16020457, 0.16022049, 0.16023634, 0.16025217, 0.16026793, 0.16028365, 0.16029933, 0.16031498, 0.16033056, 0.16034611, 0.16036162, 0.16037707, 0.16039248, 0.16040786, 0.16042317, 0.16043846, 0.16045371, 0.16046889, 0.16048405, 0.16049914, 0.16051421, 0.16052921, 0.16054419, 0.16055912, 0.160574, 0.16058883, 0.16060363, 0.16061836, 0.16063307, 0.16064773, 0.16066235, 0.16067693, 0.16069146, 0.16070594, 0.16072038, 0.16073477, 0.16074912, 0.16076343, 0.16077769, 0.1607919, 0.16080607, 0.1608202, 0.16083428, 0.16084832, 0.16086231, 0.16087627, 0.16089018, 0.16090403, 0.16091785, 0.16093163, 0.16094536, 0.16095904, 0.16097268, 0.16098627, 0.16099982, 0.16101333, 0.16102679, 0.16104022, 0.16105358, 0.16106692, 0.1610802, 0.16109344, 0.16110665, 0.16111979, 0.1611329, 0.16114597, 0.16115899, 0.16117197, 0.16118489, 0.16119778, 0.16121061, 0.16122341, 0.16123617, 0.16124886, 0.16126154, 0.16127416, 0.16128674, 0.16129926, 0.16131176, 0.1613242, 0.1613366, 0.16134895, 0.16136126, 0.16137353, 0.16138574, 0.16139792, 0.16141005, 0.16142213, 0.16143419, 0.16144618, 0.16145812, 0.16147004, 0.16148192, 0.16149373, 0.16150551, 0.16151723, 0.16152893, 0.16154058, 0.16155218, 0.16156374, 0.16157524, 0.16158672, 0.16159813, 0.1616095, 0.16162084, 0.16163214, 0.16164337, 0.16165458, 0.16166574, 0.16167684, 0.16168791, 0.16169894, 0.16170992, 0.16172084, 0.16173173, 0.16174258, 0.16175337, 0.16176414, 0.16177486, 0.16178553, 0.16179615, 0.16180673, 0.16181727, 0.16182776, 0.1618382, 0.1618486, 0.16185896, 0.16186927, 0.16187954, 0.16188978, 0.16189995, 0.16191009, 0.16192017, 0.16193023, 0.16194023, 0.1619502, 0.1619601, 0.16196997, 0.16197981, 0.16198958, 0.16199933, 0.162009, 0.16201866, 0.16202825, 0.16203782, 0.16204734, 0.1620568, 0.16206624, 0.16207562, 0.16208497, 0.16209425, 0.1621035, 0.1621127, 0.16212186, 0.16213098, 0.16214004, 0.16214909, 0.16215806, 0.162167, 0.16217589, 0.16218475, 0.16219355, 0.16220231, 0.16221103, 0.1622197, 0.16222833, 0.16223691, 0.16224545, 0.16225395, 0.1622624, 0.16227081, 0.16227917, 0.16228749, 0.16229576, 0.16230398, 0.16231216, 0.1623203, 0.16232841, 0.16233647, 0.16234447, 0.16235243, 0.16236034, 0.16236822, 0.16237605, 0.16238384, 0.16239157, 0.16239928, 0.16240692, 0.16241454, 0.16242211, 0.16242963, 0.1624371, 0.16244452, 0.16245191, 0.16245924, 0.16246656, 0.1624738, 0.16248101, 0.16248818, 0.1624953, 0.16250236, 0.16250941, 0.16251639, 0.16252333, 0.16253024, 0.16253708, 0.16254389, 0.16255066, 0.16255738, 0.16256405, 0.1625707, 0.16257727, 0.16258383, 0.16259032, 0.16259679, 0.1626032, 0.16260955, 0.16261588, 0.16262215, 0.16262838, 0.16263458, 0.16264071, 0.16264682, 0.16265287, 0.16265889, 0.16266486, 0.16267078, 0.16267666, 0.16268249, 0.16268829, 0.16269402, 0.16269973, 0.16270539, 0.16271099, 0.16271657, 0.1627221, 0.16272758, 0.162733, 0.1627384, 0.16274375, 0.16274904, 0.1627543, 0.1627595, 0.16276468, 0.16276981, 0.16277489, 0.16277993, 0.1627849, 0.16278985, 0.16279477, 0.16279963, 0.16280444, 0.16280921, 0.16281393, 0.16281861, 0.16282324, 0.16282785, 0.16283238, 0.16283689, 0.16284135, 0.16284576, 0.16285013, 0.16285446, 0.16285875, 0.16286297, 0.16286717, 0.16287133, 0.16287543, 0.16287948, 0.16288351, 0.16288747, 0.1628914, 0.16289528, 0.16289912, 0.16290291, 0.16290666, 0.16291037, 0.16291402, 0.16291764, 0.16292122, 0.16292475, 0.16292822, 0.16293167, 0.16293506, 0.16293842, 0.16294171, 0.16294497, 0.16294819, 0.16295137, 0.16295449, 0.16295759, 0.16296062, 0.16296361, 0.16296656, 0.16296948, 0.16297233, 0.16297516, 0.16297793, 0.16298066, 0.16298334, 0.16298598, 0.16298857, 0.16299114, 0.16299364, 0.16299611, 0.16299851, 0.1630009, 0.16300322, 0.16300552, 0.16300777, 0.16300996, 0.1630121, 0.16301422, 0.16301627, 0.16301829, 0.16302028, 0.16302221, 0.16302408, 0.16302593, 0.16302773, 0.16302948, 0.16303119, 0.16303286, 0.16303447, 0.16303605, 0.16303758, 0.16303907, 0.16304052, 0.16304192, 0.16304326, 0.16304457, 0.16304584, 0.16304708, 0.16304824, 0.16304937, 0.16305046, 0.1630515, 0.16305251, 0.16305347, 0.16305438, 0.16305524, 0.16305606, 0.16305685, 0.16305758, 0.16305827, 0.16305891, 0.16305952, 0.16306007, 0.16306058, 0.16306104, 0.16306147, 0.16306184, 0.16306217, 0.16306248, 0.16306272, 0.16306292, 0.16306308, 0.16306318, 0.16306326, 0.16306327, 0.16306326, 0.1630632, 0.16306309, 0.16306295, 0.16306274, 0.1630625, 0.1630622, 0.16306187, 0.16306151, 0.1630611, 0.16306062, 0.1630601, 0.16305955, 0.16305897, 0.16305831, 0.16305764, 0.1630569, 0.16305612, 0.1630553, 0.16305445, 0.16305353, 0.16305259, 0.16305159, 0.16305055, 0.16304946, 0.16304833, 0.16304716, 0.16304594, 0.16304468, 0.16304336, 0.16304202, 0.16304062, 0.16303919, 0.1630377, 0.16303617, 0.1630346, 0.16303298, 0.16303132, 0.16302963, 0.16302785, 0.16302608, 0.16302423, 0.16302235, 0.16302042, 0.16301845, 0.16301644, 0.16301437, 0.16301227, 0.16301012, 0.16300792, 0.16300569, 0.1630034, 0.16300108, 0.16299871, 0.16299629, 0.16299383, 0.16299133, 0.16298878, 0.16298619, 0.16298355, 0.16298087, 0.16297814, 0.16297537, 0.16297255, 0.16296971, 0.16296679, 0.16296385, 0.16296086, 0.16295783, 0.16295473, 0.16295162, 0.16294844, 0.16294523, 0.16294198, 0.16293868, 0.16293532, 0.16293193, 0.16292849, 0.16292502, 0.1629215, 0.16291793, 0.16291431, 0.16291066, 0.16290694, 0.1629032, 0.1628994, 0.16289558, 0.1628917, 0.16288778, 0.16288382, 0.16287978, 0.16287574, 0.16287164, 0.16286749, 0.16286331, 0.16285907, 0.16285479, 0.16285047, 0.1628461, 0.16284169, 0.16283724, 0.16283272, 0.16282819, 0.1628236, 0.16281897, 0.16281429, 0.16280958, 0.1628048, 0.1628, 0.16279513, 0.16279025, 0.16278529, 0.1627803, 0.16277528, 0.1627702, 0.16276509, 0.1627599, 0.1627547, 0.16274945, 0.16274415, 0.16273881, 0.16273342, 0.16272798, 0.16272251, 0.162717, 0.16271143, 0.16270582, 0.16270016, 0.16269447, 0.16268873, 0.16268295, 0.16267712, 0.16267124, 0.16266532, 0.16265936, 0.16265336, 0.16264729, 0.1626412, 0.16263506, 0.16262887, 0.16262265, 0.16261636, 0.16261005, 0.16260368, 0.16259727, 0.16259082, 0.16258433, 0.16257779, 0.16257121, 0.16256458, 0.1625579, 0.16255118, 0.16254443, 0.1625376, 0.16253076, 0.16252388, 0.16251694, 0.16250995, 0.16250291, 0.16249585, 0.16248873, 0.16248158, 0.16247436, 0.16246712, 0.16245984, 0.16245247, 0.1624451, 0.16243766, 0.1624302, 0.16242269, 0.16241512, 0.16240752, 0.16239987, 0.16239217, 0.16238444, 0.16237666, 0.16236883, 0.16236095, 0.16235304, 0.16234508, 0.16233708, 0.16232903, 0.16232094, 0.16231281, 0.16230462, 0.16229638, 0.16228813, 0.16227981, 0.16227145, 0.16226305, 0.16225459, 0.16224611, 0.16223757, 0.16222899, 0.16222036, 0.1622117, 0.162203, 0.16219424, 0.16218543, 0.16217659, 0.16216768, 0.16215874, 0.16214977, 0.16214076, 0.16213168, 0.16212258, 0.16211341, 0.1621042, 0.16209497, 0.16208568, 0.16207634, 0.16206697, 0.16205755, 0.16204807, 0.16203856, 0.162029, 0.1620194, 0.16200975, 0.16200006, 0.16199034, 0.16198055, 0.16197073, 0.16196087, 0.16195096, 0.16194101, 0.16193101, 0.16192096, 0.16191088, 0.16190074, 0.16189057, 0.16188034, 0.16187008, 0.16185977, 0.16184941, 0.16183902, 0.16182856, 0.16181807, 0.16180755, 0.16179699, 0.16178635, 0.16177568, 0.16176496, 0.16175422, 0.16174343, 0.16173258, 0.16172169, 0.16171075, 0.16169979, 0.16168877, 0.1616777, 0.16166659, 0.16165544, 0.16164425, 0.161633, 0.16162172, 0.16161039, 0.16159903, 0.16158761, 0.16157614, 0.16156462, 0.16155307, 0.16154148, 0.16152984, 0.16151814, 0.16150643, 0.16149466, 0.16148283, 0.16147096, 0.16145906, 0.16144711, 0.16143511, 0.16142307, 0.16141099, 0.16139886, 0.16138668, 0.16137446, 0.16136222, 0.16134989, 0.16133755, 0.16132516, 0.16131273, 0.16130023, 0.16128771, 0.16127513, 0.16126251, 0.16124986, 0.16123715, 0.16122441, 0.16121161, 0.16119878, 0.16118589, 0.16117296, 0.16115999, 0.16114697, 0.16113392, 0.16112082, 0.16110767, 0.16109447, 0.16108124, 0.16106795, 0.16105463, 0.16104126, 0.16102783, 0.16101438, 0.16100088, 0.16098733, 0.16097373, 0.16096011, 0.16094641, 0.16093269, 0.16091894, 0.16090511, 0.16089126, 0.16087735, 0.1608634, 0.16084941, 0.16083539, 0.16082129, 0.16080716, 0.16079301, 0.16077878, 0.16076453, 0.16075023, 0.16073588, 0.1607215, 0.16070706, 0.16069257, 0.16067806, 0.16066349, 0.16064887, 0.16063422, 0.16061951, 0.16060476, 0.16058998, 0.16057515, 0.16056027, 0.16054535, 0.16053037, 0.16051537, 0.1605003, 0.16048521, 0.16047007, 0.16045488, 0.16043964, 0.16042437, 0.16040905, 0.16039369, 0.16037828, 0.16036282, 0.16034731, 0.16033177, 0.16031618, 0.16030055, 0.16028488, 0.16026914, 0.16025339, 0.16023758, 0.16022173, 0.16020581, 0.16018987, 0.16017389, 0.16015786, 0.16014178, 0.16012566, 0.16010951, 0.16009328, 0.16007705, 0.16006075, 0.1600444, 0.16002801, 0.16001157, 0.15999511, 0.15997858, 0.15996203, 0.15994541, 0.15992875, 0.15991206, 0.15989532, 0.15987854, 0.1598617, 0.15984483, 0.15982792, 0.15981095, 0.15979394, 0.15977688, 0.1597598, 0.15974265, 0.15972547, 0.15970823, 0.15969096, 0.15967365, 0.15965629, 0.15963888, 0.15962143, 0.15960394, 0.1595864, 0.15956882, 0.15955119, 0.15953352, 0.1595158, 0.15949804, 0.15948023, 0.15946238, 0.15944448, 0.15942654, 0.15940857, 0.15939052, 0.15937246, 0.15935434, 0.15933619, 0.15931799, 0.15929973, 0.15928143, 0.1592631, 0.15924472, 0.1592263, 0.15920782, 0.15918931, 0.15917075, 0.15915214, 0.15913349, 0.15911481, 0.15909606, 0.15907729, 0.15905847, 0.15903959, 0.15902066, 0.15900172, 0.15898271, 0.15896367, 0.15894458, 0.15892544, 0.15890625, 0.15888703, 0.15886775, 0.15884845, 0.15882909, 0.15880968, 0.15879023, 0.15877074, 0.1587512, 0.15873164, 0.158712, 0.15869233, 0.15867262, 0.15865287, 0.15863305, 0.15861322, 0.15859333, 0.1585734, 0.15855341, 0.15853339, 0.15851334, 0.15849321, 0.15847306, 0.15845285, 0.15843262, 0.15841232, 0.158392, 0.15837161, 0.15835118, 0.15833072, 0.15831022, 0.15828966, 0.15826906, 0.15824841, 0.15822773, 0.158207, 0.15818621, 0.1581654, 0.15814452, 0.15812361, 0.15810266, 0.15808167, 0.15806061, 0.15803954, 0.1580184, 0.15799722, 0.157976, 0.15795474, 0.15793341, 0.15791208, 0.15789068, 0.15786923, 0.15784775, 0.15782622, 0.15780464, 0.15778302, 0.15776135, 0.15773964, 0.1577179, 0.1576961, 0.15767425, 0.15765236, 0.15763043, 0.15760846, 0.15758644, 0.15756439, 0.15754227, 0.15752012, 0.15749793, 0.15747568, 0.15745339, 0.15743107, 0.1574087, 0.15738627, 0.15736382, 0.1573413, 0.15731876, 0.15729617, 0.15727352, 0.15725084, 0.1572281, 0.15720533, 0.15718251, 0.15715966, 0.15713675, 0.15711381, 0.1570908, 0.15706776, 0.15704468, 0.15702155, 0.15699838, 0.15697515, 0.15695189, 0.1569286, 0.15690525, 0.15688184, 0.15685841, 0.15683492, 0.15681142, 0.15678783, 0.15676421, 0.15674056, 0.15671685, 0.1566931, 0.1566693, 0.15664546, 0.15662159, 0.15659766, 0.1565737, 0.15654968, 0.15652563, 0.15650152, 0.15647738, 0.15645318, 0.15642893, 0.15640466, 0.15638033, 0.15635598, 0.15633155, 0.15630709, 0.15628259, 0.15625803, 0.15623344, 0.15620881, 0.15618412, 0.1561594, 0.15613195, 0.15610178, 0.15607156, 0.15604128, 0.15601099, 0.15598066, 0.15595029, 0.15591989, 0.15588945, 0.15585896, 0.15582845, 0.1557979, 0.15576731, 0.15573668, 0.15570602, 0.15567532, 0.15564458, 0.15561381, 0.15558299, 0.15555215, 0.15552127, 0.15549035, 0.15545939, 0.15542839, 0.15539737, 0.1553663, 0.15533519, 0.15530406, 0.15527289, 0.15524168, 0.15521041, 0.15517913, 0.15514781, 0.15511644, 0.15508504, 0.1550536, 0.15502214, 0.15499063, 0.15495908, 0.15492751, 0.15489589, 0.15486424, 0.15483256, 0.15480082, 0.15476906, 0.15473725, 0.15470542, 0.15467353, 0.15464163, 0.15460968, 0.15457769, 0.15454568, 0.15451361, 0.15448152, 0.15444939, 0.15441722, 0.154385, 0.15435277, 0.15432049, 0.15428817, 0.15425582, 0.15422343, 0.154191, 0.15415855, 0.15412603, 0.1540935, 0.15406093, 0.15402833, 0.15399568, 0.153963, 0.15393029, 0.15389751, 0.15386473, 0.15383191, 0.15379904, 0.15376614, 0.15373319, 0.15370022, 0.1536672, 0.15363415, 0.15360107, 0.15356795, 0.15353478, 0.15350159, 0.15346836, 0.15343508, 0.15340179, 0.15336843, 0.15333505, 0.15330164, 0.15326819, 0.15323469, 0.15320118, 0.15316762, 0.153134, 0.15310036, 0.15306669, 0.15303297, 0.15299924, 0.15296546, 0.15293163, 0.15289776, 0.15286388, 0.15282995, 0.15279597, 0.15276197, 0.15272793, 0.15269385, 0.15265974, 0.15262558, 0.15259139, 0.15255716, 0.15252291, 0.1524886, 0.15245427, 0.15241991, 0.15238549, 0.15235105, 0.15231657, 0.15228204, 0.1522475, 0.1522129, 0.15217827, 0.1521436, 0.15210891, 0.15207417, 0.15203939, 0.15200457, 0.15196973, 0.15193485, 0.15189993, 0.15186496, 0.15182996, 0.15179494, 0.15175986, 0.15172476, 0.15168962, 0.15165444, 0.15161923, 0.15158397, 0.15154867, 0.15151335, 0.15147798, 0.15144259, 0.15140715, 0.15137167, 0.15133616, 0.15130061, 0.15126503, 0.15122943, 0.15119375, 0.15115806, 0.15112233, 0.15108655, 0.15105076, 0.15101492, 0.15097904, 0.15094313, 0.15090719, 0.1508712, 0.15083517, 0.15079913, 0.15076301, 0.15072688, 0.1506907, 0.15065449, 0.15061826, 0.15058197, 0.15054564, 0.1505093, 0.15047289, 0.15043648, 0.15040001, 0.1503635, 0.15032697, 0.15029041, 0.15025379, 0.15021713, 0.15018046, 0.15014374, 0.15010698, 0.15007019, 0.15003335, 0.14999647, 0.14995958, 0.14992264, 0.14988565, 0.14984863, 0.14981158, 0.14977449, 0.14973737, 0.14970021, 0.149663, 0.14962578, 0.1495885, 0.14955118, 0.14951384, 0.14947645, 0.14943904, 0.14940159, 0.1493641, 0.14932656, 0.149289, 0.14925139, 0.14921375, 0.14917608, 0.14913836, 0.1491006, 0.14906281, 0.14902499, 0.14898714, 0.14894924, 0.14891133, 0.14887334, 0.14883533, 0.14879729, 0.14875922, 0.1487211, 0.14868294, 0.14864475, 0.14860652, 0.14856826, 0.14852996, 0.14849162, 0.14845325, 0.14841484, 0.14837639, 0.14833789, 0.14829937, 0.14826082, 0.14822222, 0.1481836, 0.14814493, 0.14810622, 0.14806749, 0.1480287, 0.14798988, 0.14795104, 0.14791214, 0.14787322, 0.14783426, 0.14779526, 0.14775622, 0.14771716, 0.14767805, 0.1476389, 0.14759971, 0.14756051, 0.14752124, 0.14748195, 0.14744262, 0.14740326, 0.14736386, 0.14732441, 0.14728494, 0.14724542, 0.14720587, 0.1471663, 0.14712667, 0.14708701, 0.14704731, 0.14700757, 0.14696781, 0.146928, 0.14688815, 0.14684828, 0.14680837, 0.14676841, 0.14672841, 0.14668839, 0.14664833, 0.14660823, 0.14656809, 0.14652792, 0.14648771, 0.14644746, 0.14640717, 0.14636686, 0.1463265, 0.14628612, 0.14624569, 0.14620522, 0.1461647, 0.14612415, 0.14608359, 0.14604297, 0.14600232, 0.14596163, 0.14592092, 0.14588015, 0.14583935, 0.1457985, 0.14575765, 0.14571674, 0.14567579, 0.14563482, 0.14559379, 0.14555274, 0.14551164, 0.14547051, 0.14542936, 0.14538814, 0.14534691, 0.14530562, 0.14526433, 0.14522298, 0.14518158, 0.14514017, 0.14509872, 0.1450572, 0.14501569, 0.14497411, 0.14493251, 0.14489087, 0.1448492, 0.14480746, 0.14476572, 0.14472394, 0.14468209, 0.14464024, 0.14459834, 0.1445564, 0.14451443, 0.14447242, 0.14443037, 0.14438829, 0.14434618, 0.14430402, 0.14426182, 0.14421959, 0.14417733, 0.14413503, 0.14409268, 0.1440503, 0.14400789, 0.14396544, 0.14392295, 0.14388043, 0.14383787, 0.14379527, 0.14375263, 0.14370997, 0.14366727, 0.14362451, 0.14358173, 0.14353892, 0.14349607, 0.14345317, 0.14341025, 0.14336729, 0.14332429, 0.14328125, 0.14323817, 0.14319506, 0.14315191, 0.14310873, 0.14306551, 0.14302224, 0.14297894, 0.14293562, 0.14289226, 0.14284883, 0.14280541, 0.14276193, 0.1427184, 0.14267486, 0.14263126, 0.14258765, 0.14254399, 0.14250028, 0.14245655, 0.14241278, 0.14236896, 0.14232512, 0.14228125, 0.14223732, 0.14219336, 0.14214937, 0.14210536, 0.14206128, 0.14201717, 0.14197303, 0.14192887, 0.14188464, 0.1418404, 0.14179611, 0.14175178, 0.14170744, 0.14166303, 0.14161861, 0.14157414, 0.14152962, 0.14148508, 0.1414405, 0.14139588, 0.14135122, 0.14130653, 0.14126182, 0.14121705, 0.14117225, 0.14112741, 0.14108254, 0.14103763, 0.14099267, 0.1409477, 0.14090268, 0.14085762, 0.14081252, 0.1407674, 0.14072223, 0.14067702, 0.14063178, 0.14058651, 0.14054118, 0.14049584, 0.14045045, 0.14040501, 0.14035957, 0.14031407, 0.14026852, 0.14022297, 0.14017735, 0.1401317, 0.14008602, 0.14004031, 0.13999455, 0.13994876, 0.13990292, 0.13985705, 0.13981116, 0.13976522, 0.13971925, 0.13967325, 0.13962719, 0.1395811, 0.13953498, 0.13948882, 0.13944262, 0.1393964, 0.13935013, 0.13930382, 0.13925749, 0.1392111, 0.13916469, 0.13911822, 0.13907173, 0.13902523, 0.13897865, 0.13893205, 0.13888541, 0.13883874, 0.13879202, 0.13874528, 0.1386985, 0.13865167, 0.13860482, 0.13855793, 0.138511, 0.13846403, 0.13841704, 0.13836999, 0.1383229, 0.1382758, 0.13822865, 0.13818145, 0.13813423, 0.13808697, 0.13803968, 0.13799235, 0.13794497, 0.13789757, 0.13785012, 0.13780265, 0.13775513, 0.13770756, 0.13765998, 0.13761234, 0.13756469, 0.13751699, 0.13746925, 0.13742147, 0.13737367, 0.13732581, 0.13727793, 0.13722999, 0.13718206, 0.13713405, 0.13708603, 0.13703795, 0.13698986, 0.1369417, 0.13689353, 0.13684531, 0.13679706, 0.13674876, 0.13670045, 0.13665208, 0.13660368, 0.13655525, 0.13650677, 0.13645826, 0.13640971, 0.13636114, 0.13631253, 0.13626386, 0.13621517, 0.13616644, 0.13611768, 0.13606887, 0.13602003, 0.13597116, 0.13592224, 0.1358733, 0.13582431, 0.13577528, 0.13572623, 0.13567713, 0.135628, 0.13557883, 0.13552962, 0.13548036, 0.1354311, 0.13538177, 0.13533242, 0.13528305, 0.1352336, 0.13518414, 0.13513464, 0.13508511, 0.13503553, 0.13498592, 0.13493627, 0.13488658, 0.13483687, 0.13478711, 0.13473731, 0.13468747, 0.13463762, 0.13458771, 0.13453777, 0.13448778, 0.13443777, 0.13438773, 0.13433765, 0.13428751, 0.13423735, 0.13418716, 0.13413693, 0.13408665, 0.13403633, 0.133986, 0.13393562, 0.13388519, 0.13383473, 0.13378425, 0.1337337, 0.13368316, 0.13363254, 0.13358191, 0.13353124, 0.13348052, 0.13342977, 0.13337898, 0.13332815, 0.1332773, 0.13322641, 0.13317549, 0.13312452, 0.13307349, 0.13302246, 0.13297138, 0.13292027, 0.13286911, 0.13281792, 0.13276671, 0.13271543, 0.13266413, 0.13261278, 0.13256143, 0.13251001, 0.13245857, 0.13240708, 0.13235557, 0.13230401, 0.13225241, 0.13220079, 0.1321491, 0.13209741, 0.13204566, 0.13199389, 0.13194208, 0.13189022, 0.13183834, 0.13178642, 0.13173446, 0.13168246, 0.13163044, 0.13157836, 0.13152625, 0.13147411, 0.13142192, 0.13136971, 0.13131745, 0.13126515, 0.13121283, 0.13116047, 0.13110806, 0.13105562, 0.13100314, 0.13095063, 0.13089809, 0.1308455, 0.13079289, 0.13074023, 0.13068753, 0.13063478, 0.13058202, 0.13052922, 0.13047639, 0.1304235, 0.1303706, 0.13031763, 0.13026464, 0.13021162, 0.13015856, 0.13010545, 0.13005231, 0.12999915, 0.12994593, 0.12989269, 0.12983941, 0.12978609, 0.12973273, 0.12967934, 0.12962592, 0.12957244, 0.12951896, 0.1294654, 0.12941182, 0.12935822, 0.12930456, 0.12925088, 0.12919715, 0.1291434, 0.12908959, 0.12903576, 0.1289819, 0.12892798, 0.12887405, 0.12882006, 0.12876604, 0.128712, 0.12865789, 0.12860377, 0.12854962, 0.1284954, 0.12844117, 0.1283869, 0.12833259, 0.12827823, 0.12822385, 0.12816943, 0.12811497, 0.12806047, 0.12800594, 0.12795138, 0.12789677, 0.12784214, 0.12778746, 0.12773275, 0.12767799, 0.12762322, 0.12756838, 0.12751351, 0.12745862, 0.12740369, 0.12734871, 0.12729371, 0.12723866, 0.12718357, 0.12712847, 0.1270733, 0.12701809, 0.12696289, 0.1269076, 0.1268523, 0.12679698, 0.12674159, 0.12668619, 0.12663074, 0.12657525, 0.12651974, 0.12646416, 0.12640856, 0.12635294, 0.12629728, 0.12624156, 0.12618582, 0.12613004, 0.12607422, 0.12601838, 0.12596248, 0.12590656, 0.12585059, 0.12579457, 0.12573856, 0.12568249, 0.12562637, 0.12557024, 0.12551405, 0.12545782, 0.12540157, 0.12534527, 0.12528895, 0.12523258, 0.12517616, 0.12511973, 0.12506326, 0.12500674, 0.12495019, 0.1248936, 0.12483697, 0.12478031, 0.12472362, 0.12466688, 0.1246101, 0.12455329, 0.12449645, 0.12443957, 0.12438265, 0.12432569, 0.12426871, 0.12421168, 0.12415462, 0.12409751, 0.12404037, 0.1239832, 0.12392599, 0.12386875, 0.12381146, 0.12375413, 0.12369678, 0.12363937, 0.12358195, 0.12352448, 0.12346698, 0.12340944, 0.12335186, 0.12329423, 0.12323658, 0.12317889, 0.12312116, 0.12306342, 0.12300561, 0.12294777, 0.12288991, 0.12283198, 0.12277404, 0.12271606, 0.12265804, 0.1226, 0.1225419, 0.12248375, 0.1224256, 0.12236739, 0.12230915, 0.12225087, 0.12219255, 0.1221342, 0.12207581, 0.1220174, 0.12195894, 0.12190043, 0.1218419, 0.12178334, 0.12172472, 0.1216661, 0.12160741, 0.12154868, 0.12148994, 0.12143115, 0.12137231, 0.12131346, 0.12125455, 0.12119561, 0.12113664, 0.12107764, 0.12101857, 0.12095951, 0.12090038, 0.12084122, 0.12078203, 0.12072279, 0.12066351, 0.12060422, 0.12054488, 0.1204855, 0.12042609, 0.12036663, 0.12030713, 0.12024763, 0.12018806, 0.12012846, 0.12006882, 0.12000915, 0.11994945, 0.11988971, 0.11982992, 0.11977009, 0.11971025, 0.11965035, 0.11959041, 0.11953045, 0.11947045, 0.1194104, 0.11935034, 0.11929023, 0.11923006, 0.11916988, 0.11910968, 0.1190494, 0.11898909, 0.11892878, 0.11886841, 0.11880799, 0.11874755, 0.11868707, 0.11862656, 0.11856601, 0.11850542, 0.11844479, 0.11838412, 0.11832343, 0.11826269, 0.11820193, 0.1181411, 0.11808026, 0.11801937, 0.11795845, 0.11789749, 0.1178365, 0.11777548, 0.11771439, 0.11765331, 0.11759216, 0.11753098, 0.11746977, 0.11740851, 0.11734722, 0.11728589, 0.11722453, 0.11716314, 0.11710171, 0.11704024, 0.11697873, 0.1169172, 0.11685561, 0.11679398, 0.11673234, 0.11667065, 0.11660891, 0.11654715, 0.11648534, 0.1164235, 0.11636164, 0.11629972, 0.11623777, 0.11617577, 0.11611377, 0.1160517, 0.1159896, 0.11592747, 0.11586531, 0.1158031, 0.11574086, 0.11567858, 0.11561625, 0.11555391, 0.11549152, 0.11542908, 0.11536663, 0.11530412, 0.11524159, 0.11517902, 0.11511641, 0.11505377, 0.11499108, 0.11492836, 0.1148656, 0.11480282, 0.11473998, 0.1146771, 0.11461422, 0.11455128, 0.11448829, 0.11442529, 0.11436223, 0.11429914, 0.11423603, 0.11417286, 0.11410966, 0.11404644, 0.11398317, 0.11391985, 0.11385652, 0.11379312, 0.11372971, 0.11366625, 0.11360276, 0.11353924, 0.11347568, 0.11341207, 0.11334843, 0.11328477, 0.11322103, 0.1131573, 0.11309351, 0.11302969, 0.11296583, 0.11290194, 0.11283801, 0.11277404, 0.11271004, 0.112646, 0.11258192, 0.1125178, 0.11245365, 0.11238946, 0.11232522, 0.11226098, 0.11219668, 0.11213233, 0.11206797, 0.11200356, 0.1119391, 0.11187463, 0.1118101, 0.11174554, 0.11168096, 0.11161633, 0.11155166, 0.11148696, 0.11142222, 0.11135744, 0.11129263, 0.11122779, 0.11116289, 0.11109798, 0.11103301, 0.11096802, 0.11090299, 0.11083791, 0.1107728, 0.11070766, 0.11064249, 0.11057726, 0.11051202, 0.11044673, 0.11038139, 0.11031604, 0.11025064, 0.1101852, 0.11011973, 0.11005422, 0.10998866, 0.10992309, 0.10985745, 0.1097918, 0.10972612, 0.10966038, 0.1095946, 0.10952879, 0.10946297, 0.10939708, 0.10933118, 0.10926522, 0.10919923, 0.1091332, 0.10906714, 0.10900106, 0.10893491, 0.10886874, 0.10880253, 0.10873628, 0.10867001, 0.10860369, 0.10853732, 0.10847095, 0.10840452, 0.10833804, 0.10827155, 0.10820501, 0.10813843, 0.10807183, 0.10800517, 0.10793848, 0.10787176, 0.10780499, 0.10773821, 0.10767138, 0.10760683, 0.10754453, 0.10748221, 0.10741985, 0.10735746, 0.10729507, 0.10723262, 0.10717016, 0.10710766, 0.10704515, 0.10698259, 0.10692004, 0.10685743, 0.1067948, 0.10673214, 0.10666946, 0.10660674, 0.10654402, 0.10648125, 0.10641845, 0.10635562, 0.10629278, 0.10622989, 0.10616699, 0.10610407, 0.1060411, 0.10597811, 0.10591511, 0.10585205, 0.10578898, 0.10572588, 0.10566277, 0.1055996, 0.10553645, 0.10547323, 0.10540998, 0.10534673, 0.10528345, 0.10522012, 0.10515679, 0.10509341, 0.10503, 0.10496659, 0.10490313, 0.10483964, 0.10477614, 0.10471259, 0.10464901, 0.10458545, 0.10452183, 0.10445817, 0.1043945, 0.10433079, 0.10426706, 0.10420331, 0.10413952, 0.10407571, 0.10401187, 0.103948, 0.10388412, 0.1038202, 0.10375623, 0.10369226, 0.10362826, 0.10356423, 0.10350016, 0.10343609, 0.10337196, 0.10330782, 0.10324365, 0.10317945, 0.10311521, 0.10305097, 0.10298669, 0.10292238, 0.10285804, 0.10279369, 0.10272929, 0.10266487, 0.10260043, 0.10253594, 0.10247144, 0.10240693, 0.10234236, 0.10227778, 0.10221318, 0.10214853, 0.10208385, 0.10201918, 0.10195445, 0.10188969, 0.10182493, 0.10176013, 0.10169528, 0.10163046, 0.10156555, 0.10150063, 0.10143568, 0.10137072, 0.10130572, 0.10124069, 0.10117564, 0.10111057, 0.10104548, 0.10098033, 0.10091517, 0.10085, 0.10078477, 0.10071952, 0.10065426, 0.10058895, 0.10052361, 0.10045828, 0.10039289, 0.10032749, 0.10026205, 0.10019659, 0.10013109, 0.10006557, 0.10000002, 0.099934459, 0.099868856, 0.099803232, 0.099737555, 0.099671878, 0.099606164, 0.099540427, 0.099474661, 0.099408872, 0.099343039, 0.099277198, 0.099211335, 0.099145412, 0.099079475, 0.09901353, 0.098947547, 0.098881528, 0.098815486, 0.098749414, 0.098683313, 0.098617196, 0.09855105, 0.098484859, 0.098418653, 0.09835241, 0.098286152, 0.098219872, 0.098153546, 0.098087206, 0.098020837, 0.09795443, 0.097888, 0.097821549, 0.09775506, 0.097688556, 0.097622015, 0.097555459, 0.097488858, 0.097422235, 0.097355589, 0.097288907, 0.097222216, 0.097155482, 0.097088709, 0.097021952, 0.096955128, 0.096888289, 0.09682142, 0.096754536, 0.096687607, 0.096620649, 0.096553668, 0.096486665, 0.096419625, 0.096352585, 0.096285477, 0.096218355, 0.096151225, 0.096084051, 0.096016847, 0.095949642, 0.095882371, 0.095815107, 0.095747784, 0.095680453, 0.095613085, 0.095545702, 0.095478281, 0.095410839, 0.095343359, 0.095275864, 0.095208332, 0.095140785, 0.095073193, 0.095005579, 0.094937943, 0.094870277, 0.094802581, 0.09473487, 0.094667122, 0.094599336, 0.094531536, 0.094463713, 0.094395846, 0.094327964, 0.094260044, 0.09419211, 0.094124138, 0.094056144, 0.093988106, 0.093920067, 0.093851984, 0.093783885, 0.09371575, 0.093647592, 0.093579389, 0.093511187, 0.093442939, 0.093374662, 0.09330637, 0.093238041, 0.093169674, 0.093101308, 0.093032897, 0.092964455, 0.092895992, 0.092827499, 0.092758983, 0.092690431, 0.092621863, 0.09255325, 0.092484631, 0.092415974, 0.092347279, 0.09227857, 0.092209838, 0.092141069, 0.092072271, 0.092003457, 0.091934606, 0.091865718, 0.09179683, 0.091727883, 0.091658928, 0.091589943, 0.091520935, 0.091451883, 0.091382831, 0.09131372, 0.091244593, 0.091175444, 0.091106258, 0.09103705, 0.090967827, 0.090898551, 0.090829268, 0.090759955, 0.090690605, 0.090621233, 0.090551838, 0.090482406, 0.090412952, 0.090343468, 0.090273961, 0.090204418, 0.090134867, 0.090065263, 0.089995645, 0.089926004, 0.089856319, 0.089786611, 0.089716896, 0.089647129, 0.089577347, 0.089507528, 0.089437693, 0.089367807, 0.089297928, 0.089227997, 0.089158051, 0.089088067, 0.089018069, 0.088948034, 0.088877976, 0.088807881, 0.088737763, 0.088667631, 0.088597462, 0.088527255, 0.088457026, 0.088386782, 0.0883165, 0.088246182, 0.088175856, 0.088105492, 0.088035092, 0.087964684, 0.087894231, 0.087823756, 0.087753266, 0.087682731, 0.087612182, 0.087541603, 0.087470986, 0.087400332, 0.087329686, 0.087258987, 0.087188259, 0.087117516, 0.087046735, 0.086975925, 0.086905107, 0.086834237, 0.086763352, 0.086692445, 0.086621508, 0.086550526, 0.086479545, 0.086408511, 0.086337462, 0.086266391, 0.086195275, 0.086124137, 0.086052984, 0.085981794, 0.085910574, 0.085839331, 0.085768059, 0.085696757, 0.085625425, 0.085554078, 0.085482702, 0.085411273, 0.085339852, 0.085268378, 0.08519689, 0.085125372, 0.085053831, 0.084982246, 0.084910654, 0.084839016, 0.084767357, 0.084695682, 0.08462397, 0.084552221, 0.084480457, 0.084408663, 0.08433684, 0.084264994, 0.084193118, 0.084121212, 0.084049284, 0.083977319, 0.083905332, 0.083833322, 0.083761275, 0.083689205, 0.083617114, 0.083544977, 0.083472826, 0.083400652, 0.083328448, 0.0832562, 0.083183952, 0.083111659, 0.083039336, 0.082966991, 0.082894623, 0.082822211, 0.082749799, 0.082677335, 0.082604855, 0.082532346, 0.082459807, 0.082387239, 0.082314655, 0.082242027, 0.082169376, 0.082096696, 0.082024001, 0.081951268, 0.081878506, 0.081805728, 0.081732914, 0.08166007, 0.081587203, 0.081514306, 0.081441388, 0.081368431, 0.081295453, 0.081222445, 0.081149422, 0.081076354, 0.081003264, 0.080930151, 0.080857009, 0.080783837, 0.080710649, 0.08063741, 0.080564156, 0.080490887, 0.080417573, 0.08034423, 0.080270879, 0.080197483, 0.080124065, 0.080050625, 0.07997714, 0.07990364, 0.079830118, 0.079756558, 0.079682969, 0.079609372, 0.079535723, 0.079462059, 0.079388373, 0.079314649, 0.079240888, 0.07916712, 0.079093315, 0.079019479, 0.078945629, 0.078871734, 0.078797825, 0.078723885, 0.078649908, 0.078575917, 0.078501895, 0.078427844, 0.078353755, 0.078279652, 0.078205526, 0.078131355, 0.078057162, 0.077982955, 0.077908702, 0.077834427, 0.077760138, 0.077685803, 0.077611446, 0.077537075, 0.077462658, 0.077388227, 0.077313766, 0.077239268, 0.077164747, 0.077090204, 0.077015631, 0.076941021, 0.076866396, 0.076791741, 0.076717049, 0.076642342, 0.076567605, 0.076492831, 0.076418042, 0.076343216, 0.07626836, 0.076193497, 0.076118581, 0.076043651, 0.07596869, 0.075893708, 0.075818688, 0.075743653, 0.075668581, 0.075593486, 0.075518362, 0.075443201, 0.07536801, 0.075292826, 0.075217582, 0.075142309, 0.075067028, 0.07499171, 0.074916355, 0.074841, 0.074765593, 0.074690156, 0.074614704, 0.074539222, 0.074463718, 0.074388169, 0.074312605, 0.074237019, 0.074161388, 0.07408575, 0.074010074, 0.073934361, 0.073858634, 0.073782876, 0.073707081, 0.073631279, 0.07355544, 0.07347957, 0.073403686, 0.073327757, 0.073251806, 0.073175825, 0.073099822, 0.073023789, 0.072947733, 0.07287164, 0.072795518, 0.07271938, 0.072643206, 0.072567008, 0.072490782, 0.072414532, 0.072338238, 0.072261944, 0.072185598, 0.072109237, 0.072032854, 0.071956433, 0.071879975, 0.07180351, 0.071727008, 0.071650475, 0.071573921, 0.071497336, 0.071420729, 0.071344092, 0.071267419, 0.071190722, 0.071114004, 0.071037255, 0.07096047, 0.070883684, 0.070806839, 0.070729986, 0.070653088, 0.070576183, 0.070499241, 0.070422262, 0.070345268, 0.070268244, 0.07019119, 0.070114113, 0.070037007, 0.069959871, 0.069882721, 0.069805525, 0.069728307, 0.069651067, 0.06957379, 0.06949649, 0.069419168, 0.069341809, 0.069264419, 0.06918703, 0.069109581, 0.06903211, 0.068954632, 0.068877108, 0.068799555, 0.068721995, 0.068644375, 0.068566747, 0.06848909, 0.068411402, 0.0683337, 0.068255961, 0.068178184, 0.0681004, 0.068022572, 0.067944728, 0.067866847, 0.067788944, 0.067711003, 0.067633048, 0.067555062, 0.067477055, 0.067398995, 0.067320943, 0.067242838, 0.067164704, 0.067086563, 0.067008376, 0.066930167, 0.066851936, 0.066773668, 0.066695377, 0.066617057, 0.066538714, 0.066460349, 0.066381939, 0.066303521, 0.066225059, 0.066146575, 0.066068068, 0.065989524, 0.065910958, 0.065832369, 0.065753751, 0.065675095, 0.065596424, 0.065517724, 0.065438986, 0.065360233, 0.065281443, 0.065202624, 0.065123789, 0.065044925, 0.064966016, 0.064887114, 0.06480816, 0.064729169, 0.064650171, 0.064571135, 0.064492069, 0.064412989, 0.064333871, 0.064254716, 0.064175561, 0.064096354, 0.064017132, 0.06393788, 0.063858591, 0.063779287, 0.063699961, 0.063620582, 0.063541181, 0.063461773, 0.063382328, 0.063302852, 0.063223362, 0.063143827, 0.063064255, 0.06298469, 0.062905073, 0.062825434, 0.06274578, 0.062666073, 0.062586352, 0.062506601, 0.062426828, 0.062347017, 0.062267184, 0.062187333, 0.06210744, 0.062027529, 0.061947584, 0.061867617, 0.061787609, 0.061707597, 0.061627537, 0.061547454, 0.061467361, 0.061387219, 0.061307054, 0.061226871, 0.061146654, 0.061066408, 0.060986146, 0.060905829, 0.060825501, 0.060745154, 0.060664773, 0.060584363, 0.060503922, 0.060423464, 0.06034296, 0.060262453, 0.060181905, 0.060101319, 0.060020722, 0.059940092, 0.059859432, 0.059778765, 0.059698045, 0.059617296, 0.059536543, 0.059455741, 0.059374902, 0.059294067, 0.059213184, 0.059132282, 0.059051357, 0.058970392, 0.058889396, 0.05880839, 0.058727335, 0.058646273, 0.058565166, 0.058484051, 0.058402888, 0.058321711, 0.058240507, 0.058159273, 0.058078006, 0.05799672, 0.057915397, 0.057834048, 0.057752684, 0.057671279, 0.05758984, 0.057508402, 0.057426911, 0.05734539, 0.057263862, 0.057182297, 0.057100698, 0.057019096, 0.056937438, 0.056855757, 0.056774054, 0.056692328, 0.056610558, 0.056528788, 0.056446966, 0.056365114, 0.056283254, 0.056201369, 0.056119435, 0.056037493, 0.055955507, 0.055873495, 0.055791471, 0.055709403, 0.055627313, 0.055545211, 0.055463053, 0.055380885, 0.055298686, 0.055216458, 0.0551342, 0.055051938, 0.054969616, 0.054887276, 0.054804921, 0.054722521, 0.054640103, 0.05455767, 0.054475181, 0.054392692, 0.05431015, 0.054227605, 0.054145012, 0.054062396, 0.053979754, 0.053897098, 0.0538144, 0.05373168, 0.05364893, 0.053566143, 0.053483352, 0.053400513, 0.053317655, 0.053234778, 0.053151853, 0.053068906, 0.052985951, 0.052902944, 0.052819923, 0.052736871, 0.05265379, 0.052570682, 0.052487552, 0.052404385, 0.052321188, 0.05223798, 0.052154738, 0.05207146, 0.051988173, 0.051904839, 0.051821481, 0.051738102, 0.051654696, 0.05157125, 0.0514878, 0.05140429, 0.051320776, 0.051237222, 0.051153652, 0.051070046, 0.050986424, 0.050902762, 0.050819069, 0.050735369, 0.050651625, 0.050567854, 0.050484065, 0.050400238, 0.050316382, 0.050232511, 0.050148606, 0.050064664, 0.049980704, 0.049896732, 0.049812712, 0.049728658, 0.049644593, 0.049560495, 0.049476359, 0.049392216, 0.049308039, 0.049223829, 0.0491396, 0.04905533, 0.048971038, 0.04888672, 0.048802372, 0.048718002, 0.048633602, 0.048549175, 0.048464712, 0.048380233, 0.048295721, 0.04821118, 0.048126627, 0.048042025, 0.047957402, 0.047872752, 0.047788084, 0.047703367, 0.047618654, 0.047533885, 0.047449097, 0.047364295, 0.04727944, 0.047194567, 0.047109693, 0.047024757, 0.046939805, 0.046854824, 0.046769824, 0.046684783, 0.046599735, 0.04651463, 0.046429519, 0.046344381, 0.04625921, 0.046174001, 0.046088785, 0.046003524, 0.045918237, 0.045832928, 0.045747597, 0.045662232, 0.045576829, 0.045491423, 0.045405973, 0.045320485, 0.045235008, 0.045149468, 0.045063909, 0.044978328, 0.044892713, 0.044807073, 0.04472141, 0.044635717, 0.044549979, 0.044464242, 0.044378467, 0.044292659, 0.044206832, 0.044120967, 0.044035077, 0.043949172, 0.043863226, 0.043777246, 0.043691266, 0.043605234, 0.043519173, 0.043433104, 0.043346997, 0.043260854, 0.043174703, 0.043088503, 0.043002281, 0.042916048, 0.042829771, 0.042743471, 0.042657148, 0.042570788, 0.042484406, 0.042398006, 0.042311568, 0.042225093, 0.04213861, 0.042052079, 0.041965529, 0.041878965, 0.041792359, 0.041705724, 0.04161907, 0.041532382, 0.041445669, 0.041358922, 0.041272167, 0.04118536, 0.041098539, 0.041011687, 0.040924817, 0.040837903, 0.040750984, 0.04066401, 0.040577024, 0.040490016, 0.040402971, 0.040315896, 0.040228795, 0.040141676, 0.040054515, 0.039967336, 0.039880134, 0.039792888, 0.039705638, 0.039618347, 0.039531019, 0.039443679, 0.039356306, 0.0392689, 0.039181478, 0.039094027, 0.039006528, 0.038919039, 0.038831491, 0.038743913, 0.038656324, 0.038568709, 0.038481053, 0.038393393, 0.038305677, 0.038217939, 0.03813019, 0.038042407, 0.037954587, 0.037866756, 0.037778869, 0.037690971, 0.037603062, 0.037515108, 0.037427116, 0.037339129, 0.037251081, 0.037163023, 0.037074942, 0.036986817, 0.036898669, 0.036810495, 0.03672231, 0.036634084, 0.036545817, 0.036457546, 0.036369223, 0.036280893, 0.036192536, 0.036104135, 0.036015712, 0.035927281, 0.035838798, 0.035750296, 0.035661768, 0.035573211, 0.035484616, 0.035396021, 0.03530737, 0.035218708, 0.03513002, 0.035041291, 0.034952536, 0.03486377, 0.034774959, 0.034686126, 0.03459727, 0.034508377, 0.034419455, 0.034330528, 0.034241557, 0.034152552, 0.034063537, 0.033974472, 0.03388539, 0.033796292, 0.033707149, 0.033617985, 0.033528809, 0.033439588, 0.033350334, 0.033261076, 0.033171762, 0.03308244, 0.032993089, 0.032903709, 0.032814283, 0.032724857, 0.03263538, 0.032545887, 0.032456368, 0.032366827, 0.032277249, 0.032187644, 0.032098021, 0.032008365, 0.031918664, 0.031828966, 0.031739216, 0.031649448, 0.031559654, 0.031469841, 0.031379979, 0.031290106, 0.0312002, 0.031110261, 0.03102031, 0.030930322, 0.030840291, 0.030750269, 0.03066018, 0.030570081, 0.030479969, 0.030389812, 0.030299619, 0.030209428, 0.030119179, 0.030028921, 0.029938636, 0.029848319, 0.029757958, 0.029667594, 0.029577184, 0.029486753, 0.029396312, 0.029305823, 0.029215302, 0.029124778, 0.02903421, 0.028943608, 0.028852994, 0.028762346, 0.028671663, 0.028580971, 0.02849023, 0.028399467, 0.028308695, 0.028217876, 0.028127024, 0.02803617, 0.02794526, 0.027854338, 0.027763382, 0.027672414, 0.027581401, 0.027490364, 0.027399305, 0.027308214, 0.027217098, 0.02712596, 0.027034774, 0.026943579, 0.02685236, 0.026761107, 0.02666981, 0.026578512, 0.026487168, 0.026395813, 0.026304422, 0.026212998, 0.02612154, 0.026030084, 0.02593858, 0.02584704, 0.025755491, 0.025663907, 0.025572278, 0.025480662, 0.025388986, 0.02529729, 0.025205567, 0.025113825, 0.025022037, 0.024930237, 0.024838401, 0.024746543, 0.02465464, 0.024562728, 0.024470812, 0.02437884, 0.024286835, 0.024194805, 0.024102753, 0.024010656, 0.023918584, 0.023826441, 0.023734275, 0.023642074, 0.023549853, 0.023457607, 0.02336535, 0.023273049, 0.023180723, 0.023088353, 0.022995973, 0.022903554, 0.022811139, 0.022718666, 0.022626169, 0.022533648, 0.022441084, 0.022348521, 0.022255944, 0.022163311, 0.022070631, 0.021977952, 0.021885227, 0.021792492, 0.021699732, 0.021606941, 0.021514112, 0.021421263, 0.021328367, 0.02123546, 0.021142554, 0.021049591, 0.020956591, 0.02086357, 0.020770526, 0.020677449, 0.020584336, 0.020491246, 0.020398088, 0.020304907, 0.020211693, 0.020118443, 0.020025183, 0.019931922, 0.019838581, 0.01974524, 0.019651866, 0.019558456, 0.019465012, 0.01937158, 0.019278103, 0.019184591, 0.019091034, 0.018997464, 0.018903874, 0.01881027, 0.018716611, 0.018622939, 0.018529221, 0.018435495, 0.01834172, 0.018247968, 0.018154148, 0.018060306, 0.017966429, 0.017872529, 0.017778594, 0.017684674, 0.017590681, 0.017496668, 0.017402632, 0.017308572, 0.017214468, 0.017120373, 0.017026234, 0.016932061, 0.016837841, 0.016743612, 0.016649358, 0.016555104, 0.016460782, 0.016366437, 0.016272081, 0.016177692, 0.016083255, 0.015988808, 0.015894361, 0.015799858, 0.015705306, 0.015610746, 0.015516161, 0.015421543, 0.015326925, 0.015232248, 0.015137563, 0.015042829, 0.014948062, 0.014853284, 0.014758506, 0.01466367, 0.014568801, 0.014473909, 0.014378994, 0.014284045, 0.014189107, 0.0140941, 0.013999072, 0.013904018, 0.013808922, 0.013713812, 0.013618703, 0.013523538, 0.013428336, 0.013333114, 0.013237868, 0.013142599, 0.013047307, 0.012951982, 0.012856621, 0.012761238, 0.01266581, 0.01257037, 0.01247493, 0.012379444, 0.012283902, 0.012188359, 0.012092782, 0.011997171, 0.01190156, 0.011805903, 0.011710213, 0.011614499, 0.011518739, 0.011422969, 0.011327209, 0.011231381, 0.011135507, 0.011039634, 0.010943727, 0.010847785, 0.010751808, 0.010655855, 0.010559833, 0.010463788, 0.010367698, 0.010271608, 0.010175472, 0.010079359, 0.0099831549, 0.0098869503, 0.009790712, 0.0096944384, 0.0095981434, 0.0095018474, 0.0094054947, 0.0093091186, 0.00921271, 0.0091162771, 0.0090198219, 0.0089233657, 0.0088268304, 0.008730296, 0.0086337263, 0.0085371342, 0.0084405076, 0.0083438689, 0.0082471976, 0.0081504909, 0.0080537498, 0.0079569863, 0.0078602005, 0.0077634142, 0.0076665711, 0.0075696823, 0.0074727819, 0.0073758587, 0.0072789011, 0.0071819439, 0.0070849294, 0.0069878921, 0.006890832, 0.0067937262, 0.0066966093, 0.0065994919, 0.0065023177, 0.0064050979, 0.0063078669, 0.0062106126, 0.0061133364, 0.006016002, 0.0059187026, 0.0058213347, 0.005723943, 0.0056265066, 0.0055290591, 0.0054315766, 0.0053341058, 0.0052365665, 0.0051390044, 0.0050414195, 0.0049438002, 0.0048461468, 0.0047485051, 0.0046508061, 0.0045530843, 0.0044553163, 0.0043575377, 0.0042597363, 0.0041619344, 0.0040640528, 0.0039661601, 0.0038682441, 0.0037703055, 0.0036723213, 0.0035743485, 0.0034763298, 0.0033782658, 0.0032801789, 0.0031820692, 0.003083925, 0.0029857925, 0.0028875917, 0.0027893677, 0.0026911213, 0.0025928402, 0.0024945252, 0.0023962327, 0.002297872, 0.0021994885, 0.0021010593, 0.0020026185, 0.0019041552, 0.0018056917, 0.0017071484, 0.001608605, 0.0015100276, 0.0014114272, 0.0013127812, 0.0012141238, 0.0011154665, 0.0010167406, 0.00091799186, 0.00081922038, 0.00072042603, 0.00062159752, 0.00052275759, 0.00042388338, 0.000324975, 0.00022603237, 0.00012705549, 2.8067216e-05, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532, 0.031604532   }, 
   { 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 0.014212511, 2.7784581e-06, 3.2000171e-05, 6.1317696e-05, 9.0667156e-05, 0.00011998467, 0.00014946189, 0.00017887521, 0.00020835242, 0.00023786156, 0.00026737069, 0.00029700759, 0.00032661253, 0.00035621747, 0.00038588632, 0.00041555514, 0.00044531978, 0.00047508438, 0.00050494482, 0.00053477334, 0.00056466571, 0.00059455808, 0.0006244824, 0.00065453444, 0.00068452267, 0.00071457465, 0.00074462674, 0.00077471079, 0.00080489053, 0.00083507033, 0.00086531404, 0.00089555769, 0.00092583336, 0.00095614087, 0.00098648039, 0.0010168836, 0.001047319, 0.0010777543, 0.0011082215, 0.0011387526, 0.0011693157, 0.0011998467, 0.0012305375, 0.0012611964, 0.0012918552, 0.0013225779, 0.0013533327, 0.0013841512, 0.0014149697, 0.0014458202, 0.0014767025, 0.0015076168, 0.0015385313, 0.0015695414, 0.0016006154, 0.0016316575, 0.0016627315, 0.0016938694, 0.0017250072, 0.0017562729, 0.0017874747, 0.0018187404, 0.0018500059, 0.0018813355, 0.001912665, 0.0019440904, 0.0019755794, 0.0020070048, 0.002038494, 0.002070047, 0.002101568, 0.002133185, 0.0021648339, 0.0021965147, 0.0022282277, 0.0022599082, 0.002291685, 0.0023234934, 0.002355366, 0.0023872384, 0.002419079, 0.0024510473, 0.0024830154, 0.0025149835, 0.0025470795, 0.0025791756, 0.0026112394, 0.0026433675, 0.0026755275, 0.0027077191, 0.0027400386, 0.0027722942, 0.002804582, 0.0028369334, 0.0028692849, 0.0029016682, 0.0029341793, 0.0029666268, 0.0029991381, 0.0030316808, 0.003064224, 0.0030968951, 0.0031295659, 0.0031622045, 0.0031949072, 0.0032276739, 0.0032604085, 0.0032932393, 0.0033261336, 0.003358996, 0.0033919225, 0.0034248487, 0.003457807, 0.0034908932, 0.003523947, 0.0035570012, 0.0035901191, 0.0036232371, 0.0036564509, 0.0036896646, 0.0037229422, 0.0037562198, 0.0037895613, 0.0038228708, 0.0038562443, 0.0038897137, 0.0039231828, 0.0039566518, 0.0039901533, 0.0040237182, 0.0040573152, 0.0040909443, 0.0041246051, 0.004158298, 0.0041920543, 0.0042257793, 0.0042595677, 0.0042934204, 0.0043272725, 0.004361189, 0.0043950733, 0.0044290219, 0.0044630021, 0.0044970461, 0.0045311539, 0.0045652301, 0.0045993379, 0.0046335417, 0.0046676816, 0.0047019813, 0.0047362489, 0.0047705485, 0.0048048482, 0.0048392117, 0.0048736068, 0.0049080346, 0.0049425573, 0.0049770488, 0.005011572, 0.0050461586, 0.0050807139, 0.0051153647, 0.0051500476, 0.0051847626, 0.0052195089, 0.0052542561, 0.005289034, 0.0053239088, 0.0053588152, 0.0053937216, 0.0054286281, 0.0054635983, 0.0054986007, 0.0055336342, 0.0055687646, 0.005603862, 0.0056390245, 0.0056741545, 0.0057093482, 0.0057446058, 0.0057799271, 0.0058152485, 0.0058505386, 0.0058859237, 0.005921341, 0.0059567587, 0.0059923036, 0.0060277851, 0.0060633617, 0.0060989391, 0.0061345161, 0.0061702207, 0.0062059253, 0.0062415982, 0.0062773353, 0.0063131354, 0.0063489364, 0.006384769, 0.0064207292, 0.0064565935, 0.0064925859, 0.0065285461, 0.0065645385, 0.0066006584, 0.0066367462, 0.0066728662, 0.0067090183, 0.0067451699, 0.0067813857, 0.0068176338, 0.0068539772, 0.0068902886, 0.0069266637, 0.0069630076, 0.0069994465, 0.0070359502, 0.0070724529, 0.0071089566, 0.0071455231, 0.0071820905, 0.0072187218, 0.0072553842, 0.0072921109, 0.0073288381, 0.0073655965, 0.007402387, 0.0074392096, 0.007476096, 0.0075129825, 0.0075499327, 0.0075868834, 0.0076238653, 0.0076608798, 0.0076979576, 0.0077350996, 0.0077722413, 0.0078093833, 0.0078465892, 0.0078838263, 0.0079211285, 0.0079584299, 0.0079957638, 0.0080330968, 0.008070494, 0.0081079239, 0.0081453854, 0.0081829745, 0.0082204668, 0.0082580242, 0.0082956459, 0.0083332658, 0.0083709508, 0.0084086685, 0.0084464485, 0.0084841978, 0.0085219778, 0.0085598221, 0.008597699, 0.0086356709, 0.0086735794, 0.0087115839, 0.0087495558, 0.0087876236, 0.0088256923, 0.0088638244, 0.0089019882, 0.0089401519, 0.0089783482, 0.0090165753, 0.0090548992, 0.0090932222, 0.0091315778, 0.0091699334, 0.0092083532, 0.0092468048, 0.0092852553, 0.0093238344, 0.009362381, 0.009400961, 0.0094395718, 0.0094782151, 0.0095169535, 0.0095556593, 0.0095944311, 0.0096331695, 0.0096720038, 0.0097108707, 0.0097497376, 0.0097886994, 0.0098276297, 0.0098666232, 0.0099056503, 0.0099446764, 0.0099838302, 0.010022984, 0.010062107, 0.010101291, 0.010140478, 0.01017976, 0.01021904, 0.010258419, 0.010297764, 0.010337174, 0.010376615, 0.010416024, 0.010455593, 0.01049513, 0.010534667, 0.010574269, 0.010613869, 0.010653534, 0.010693231, 0.010732992, 0.010772753, 0.010812545, 0.010852369, 0.010892258, 0.010932178, 0.010972098, 0.011012083, 0.011052068, 0.011092083, 0.011132164, 0.011172243, 0.011212451, 0.011252627, 0.011292803, 0.011333044, 0.011373315, 0.011413586, 0.011453985, 0.011494385, 0.011534752, 0.011575184, 0.011615648, 0.011656174, 0.011696765, 0.011737324, 0.011777915, 0.011818571, 0.011859225, 0.011899943, 0.011940727, 0.011981509, 0.012022324, 0.012063139, 0.012104017, 0.012144928, 0.012185933, 0.012226876, 0.012267915, 0.012308952, 0.012350023, 0.012391125, 0.012432322, 0.01247352, 0.012514718, 0.012555948, 0.012597241, 0.012638567, 0.012679957, 0.012721314, 0.012762703, 0.012804156, 0.012845674, 0.012887159, 0.012928772, 0.012970353, 0.013011966, 0.013053611, 0.01309532, 0.013137061, 0.013178834, 0.013220638, 0.013262411, 0.013304279, 0.013346179, 0.01338808, 0.013430107, 0.013472072, 0.013514101, 0.013556161, 0.01359822, 0.013640408, 0.013682597, 0.013724753, 0.013766972, 0.013809255, 0.01385154, 0.013893855, 0.013936298, 0.013978646, 0.014021089, 0.014063564, 0.01410604, 0.014148611, 0.014191214, 0.014233785, 0.014276421, 0.014319055, 0.014361754, 0.014404484, 0.014447312, 0.014490105, 0.014532932, 0.014575791, 0.014618682, 0.0146617, 0.014704621, 0.014747672, 0.014790691, 0.01483374, 0.014876855, 0.01492, 0.014963211, 0.015006419, 0.01504963, 0.015092904, 0.015136209, 0.015179547, 0.015222981, 0.015266414, 0.015309814, 0.01535328, 0.015396777, 0.015440338, 0.015483963, 0.015527557, 0.015571213, 0.015614902, 0.015658591, 0.015702313, 0.015746161, 0.015789976, 0.015833825, 0.015877705, 0.015921585, 0.015965562, 0.016009603, 0.01605358, 0.016097652, 0.016141756, 0.016185828, 0.016229963, 0.016274195, 0.016318427, 0.016362691, 0.016406953, 0.016451251, 0.016495673, 0.016540065, 0.016584488, 0.016628943, 0.016673399, 0.01671795, 0.016762501, 0.016807117, 0.016851731, 0.01689641, 0.016941089, 0.0169858, 0.017030606, 0.017075414, 0.01712022, 0.017165057, 0.01720996, 0.017254895, 0.017299829, 0.017344892, 0.01738989, 0.017434983, 0.017480077, 0.017525172, 0.017570393, 0.017615616, 0.017660838, 0.017706092, 0.017751377, 0.017796727, 0.017842075, 0.017887522, 0.017932935, 0.017978411, 0.018023921, 0.018069431, 0.018115068, 0.018160673, 0.01820631, 0.018251978, 0.018297646, 0.01834338, 0.018389177, 0.018435005, 0.018480834, 0.018526725, 0.018572619, 0.018618543, 0.018664595, 0.018710583, 0.018756635, 0.018802688, 0.018848771, 0.01889492, 0.018941132, 0.018987376, 0.01903362, 0.019079862, 0.019126201, 0.019172544, 0.019218883, 0.019265348, 0.019311816, 0.019358285, 0.019404784, 0.019451346, 0.019497909, 0.019544601, 0.019591227, 0.019637885, 0.019684641, 0.019731363, 0.019778118, 0.019825002, 0.019871883, 0.019918732, 0.019965649, 0.020012595, 0.020059574, 0.020106679, 0.020153688, 0.020200796, 0.020247933, 0.020295041, 0.020342242, 0.020389508, 0.020436741, 0.020484069, 0.020531368, 0.020578697, 0.020626156, 0.02067358, 0.020721037, 0.020768527, 0.020816017, 0.0208636, 0.020911219, 0.020958869, 0.021006515, 0.021054229, 0.02110194, 0.021149719, 0.021197526, 0.021245399, 0.021293242, 0.021341112, 0.021389049, 0.021437015, 0.021485018, 0.021533113, 0.021581179, 0.021629274, 0.021677403, 0.021725563, 0.021773785, 0.021822041, 0.02187033, 0.021918586, 0.021966936, 0.02201532, 0.022063704, 0.022112183, 0.022160629, 0.022209173, 0.022257684, 0.022306228, 0.022354899, 0.022403568, 0.022452207, 0.022500912, 0.022549678, 0.022598414, 0.022647245, 0.022696139, 0.022745, 0.022793895, 0.022842852, 0.022891812, 0.022940833, 0.022989919, 0.023039006, 0.023088124, 0.023137242, 0.023186425, 0.023235638, 0.023284947, 0.023334226, 0.023383504, 0.023432877, 0.02348225, 0.023531655, 0.023581157, 0.023630658, 0.02368016, 0.023729693, 0.02377929, 0.023828886, 0.023878612, 0.023928303, 0.023977999, 0.024027755, 0.024077542, 0.024127331, 0.024177248, 0.024227165, 0.024277048, 0.02432703, 0.024376977, 0.024427021, 0.02447713, 0.024527205, 0.024577312, 0.024627486, 0.02467769, 0.024727892, 0.024778226, 0.024828494, 0.024878824, 0.024929188, 0.024979552, 0.025030043, 0.025080534, 0.025130993, 0.025181549, 0.025232071, 0.025282692, 0.02533331, 0.025384024, 0.025434708, 0.025485486, 0.0255362, 0.025587013, 0.025637886, 0.025688762, 0.025739668, 0.025790572, 0.025841545, 0.025892578, 0.025943581, 0.025994711, 0.026045809, 0.02609697, 0.026148101, 0.026199326, 0.026250584, 0.026301874, 0.026353195, 0.026404517, 0.026455872, 0.026507288, 0.026558707, 0.02661025, 0.026661731, 0.02671331, 0.026764886, 0.026816463, 0.02686817, 0.026919842, 0.026971547, 0.027023282, 0.027075052, 0.027126852, 0.027178716, 0.027230645, 0.027282542, 0.027334502, 0.027386494, 0.027438488, 0.027490541, 0.027542662, 0.027594782, 0.027646935, 0.027699089, 0.027751302, 0.027803583, 0.027855894, 0.027908206, 0.02796058, 0.028012956, 0.028065365, 0.028117836, 0.02817034, 0.028222907, 0.028275443, 0.028328007, 0.02838064, 0.028433302, 0.02848603, 0.028538756, 0.028591484, 0.028644307, 0.028697129, 0.028749952, 0.0288029, 0.028855851, 0.0289088, 0.028961783, 0.029014766, 0.029067876, 0.029121019, 0.029174129, 0.02922727, 0.029280476, 0.029333716, 0.029386951, 0.029440319, 0.029493621, 0.029547017, 0.029600415, 0.029653812, 0.029707337, 0.029760862, 0.029814387, 0.029867945, 0.029921534, 0.029975185, 0.030028841, 0.030082589, 0.030136306, 0.030190118, 0.030243898, 0.030297713, 0.030351652, 0.030405561, 0.030459501, 0.030513475, 0.030567447, 0.030621514, 0.030675581, 0.030729713, 0.030783847, 0.030838042, 0.030892238, 0.030946467, 0.031000789, 0.031055113, 0.031109469, 0.031163825, 0.031218244, 0.031272694, 0.031327147, 0.031381726, 0.031436272, 0.031490821, 0.031545464, 0.031600107, 0.031654812, 0.031709518, 0.031764291, 0.03181906, 0.031873863, 0.031928699, 0.031983599, 0.032038592, 0.032093521, 0.032148484, 0.032203544, 0.03225857, 0.032313626, 0.032368813, 0.032423966, 0.032479152, 0.032534372, 0.032589618, 0.032644935, 0.032700282, 0.032755625, 0.032811034, 0.032866444, 0.032921884, 0.032977391, 0.033032961, 0.033088528, 0.033144128, 0.033199731, 0.033255398, 0.033311095, 0.033366855, 0.033422615, 0.033478376, 0.033534233, 0.03359009, 0.033645976, 0.033701964, 0.033757944, 0.033813931, 0.033869948, 0.033926029, 0.033982139, 0.034038313, 0.03409446, 0.034150634, 0.034206875, 0.034263179, 0.034319449, 0.03437585, 0.034432184, 0.034488615, 0.034545049, 0.03460148, 0.034658041, 0.034714598, 0.034771159, 0.034827746, 0.034884371, 0.034941059, 0.034997776, 0.035054561, 0.035111312, 0.035168156, 0.03522497, 0.035281852, 0.035338793, 0.035395768, 0.035452709, 0.035509717, 0.035566755, 0.035623856, 0.035680957, 0.035738155, 0.03579532, 0.035852551, 0.035909783, 0.035967045, 0.036024403, 0.036081757, 0.036139149, 0.036196537, 0.036253989, 0.036311511, 0.036368996, 0.036426608, 0.036484189, 0.036541767, 0.036599446, 0.036657125, 0.036714833, 0.036772635, 0.03683044, 0.036888245, 0.036946084, 0.037003949, 0.037061881, 0.037119914, 0.037177876, 0.037235904, 0.037293967, 0.037352026, 0.037410147, 0.037468366, 0.037526555, 0.037584778, 0.03764306, 0.037701312, 0.037759658, 0.037818071, 0.03787645, 0.037934892, 0.037993371, 0.038051844, 0.038110353, 0.038168956, 0.038227592, 0.038286194, 0.03834486, 0.038403526, 0.038462289, 0.038521085, 0.038579881, 0.038638707, 0.038697597, 0.03875649, 0.038815409, 0.038874429, 0.038933448, 0.038992465, 0.039051518, 0.039110631, 0.039169807, 0.039228987, 0.039288193, 0.039347403, 0.03940668, 0.039466016, 0.039525323, 0.039584752, 0.039644126, 0.039703593, 0.039763059, 0.039822552, 0.039882146, 0.039941743, 0.040001336, 0.04006099, 0.040120646, 0.040180366, 0.04024009, 0.040299937, 0.040359724, 0.040419601, 0.040479481, 0.040539365, 0.040599372, 0.040659383, 0.040719353, 0.040779393, 0.040839471, 0.040899605, 0.040959742, 0.041019972, 0.041080173, 0.041140467, 0.041200701, 0.041261025, 0.041321449, 0.04138181, 0.041442234, 0.041502692, 0.041563146, 0.041623667, 0.041684248, 0.041744862, 0.041805476, 0.041866127, 0.041926835, 0.04198755, 0.04204829, 0.042109128, 0.042169999, 0.042230804, 0.042291708, 0.042352609, 0.042413577, 0.042474639, 0.042535666, 0.042596702, 0.042657826, 0.042718921, 0.042780079, 0.04284133, 0.042902585, 0.042963836, 0.043025125, 0.043086413, 0.043147825, 0.04320927, 0.043270685, 0.04333213, 0.043393638, 0.04345518, 0.043516718, 0.04357839, 0.043640025, 0.043701697, 0.043763399, 0.043825097, 0.043886896, 0.043948755, 0.044010583, 0.044072445, 0.044134371, 0.044196293, 0.044258252, 0.0443203, 0.044382326, 0.044444408, 0.04450652, 0.044568639, 0.044630885, 0.044693094, 0.044755306, 0.044817582, 0.044879891, 0.04494223, 0.045004603, 0.045067068, 0.045129504, 0.045192003, 0.045254502, 0.045317035, 0.045379661, 0.045442287, 0.045504946, 0.045567606, 0.045630295, 0.045693085, 0.045755837, 0.04581872, 0.04588154, 0.045944452, 0.046007335, 0.046070285, 0.046133325, 0.046196371, 0.046259411, 0.046322487, 0.04638559, 0.04644876, 0.046511933, 0.0465752, 0.046638463, 0.046701763, 0.046765059, 0.046828419, 0.046891846, 0.046955299, 0.047018729, 0.047082216, 0.047145739, 0.047209293, 0.047272876, 0.04733656, 0.047400206, 0.047463886, 0.04752763, 0.047591377, 0.047655184, 0.047719061, 0.047782931, 0.047846805, 0.047910739, 0.047974676, 0.048038706, 0.048102774, 0.048166838, 0.048230901, 0.048295062, 0.048359223, 0.048423413, 0.048487701, 0.048551988, 0.048616279, 0.0486806, 0.048744947, 0.048809361, 0.048873842, 0.048938327, 0.0490028, 0.049067348, 0.049131922, 0.049196526, 0.049261197, 0.049325898, 0.049390603, 0.049455307, 0.049520075, 0.049584907, 0.049649797, 0.049714662, 0.049779557, 0.049844485, 0.049909472, 0.049974464, 0.050039582, 0.050104637, 0.050169755, 0.050234906, 0.050300088, 0.050365333, 0.050430577, 0.050495856, 0.050561167, 0.050626505, 0.050691914, 0.050757319, 0.050822821, 0.050888259, 0.05095382, 0.051019356, 0.051084921, 0.051150583, 0.051216241, 0.05128194, 0.051347632, 0.051413387, 0.051479172, 0.051544998, 0.051610909, 0.051676765, 0.051742714, 0.051808659, 0.051874641, 0.051940717, 0.052006792, 0.052072871, 0.052138977, 0.052205119, 0.052271325, 0.052337527, 0.052403856, 0.052470129, 0.052536458, 0.052602824, 0.052669182, 0.052735612, 0.052802134, 0.052868627, 0.05293515, 0.053001706, 0.053068325, 0.053134974, 0.053201631, 0.053268343, 0.053335056, 0.053401835, 0.053468678, 0.053535488, 0.053602334, 0.05366927, 0.053736206, 0.053803179, 0.053870182, 0.053937245, 0.054004282, 0.054071415, 0.054138541, 0.054205734, 0.054272931, 0.054340187, 0.054407448, 0.054474767, 0.054542121, 0.054609478, 0.054676924, 0.054744374, 0.054811824, 0.054879371, 0.054946885, 0.055014491, 0.055082068, 0.055149741, 0.055217415, 0.055285122, 0.055352885, 0.055420656, 0.05548849, 0.055556353, 0.055624217, 0.055692147, 0.055760074, 0.055828068, 0.055896096, 0.05596415, 0.056032237, 0.056100354, 0.056168512, 0.056236692, 0.056304943, 0.05637316, 0.056441467, 0.056509811, 0.056578156, 0.056646533, 0.056714971, 0.056783441, 0.056851912, 0.05692045, 0.056989018, 0.057057582, 0.057126246, 0.057194877, 0.057263572, 0.057332303, 0.057401087, 0.057469849, 0.057538703, 0.057607591, 0.057676446, 0.057745393, 0.057814382, 0.057883363, 0.057952408, 0.058021456, 0.058090564, 0.058159675, 0.058228847, 0.058298055, 0.058367293, 0.058436565, 0.058505863, 0.058575194, 0.058644596, 0.058713961, 0.058783423, 0.058852881, 0.058922373, 0.058991902, 0.05906152, 0.059131082, 0.059200734, 0.059270449, 0.059340134, 0.059409883, 0.059479635, 0.059549447, 0.059619322, 0.059689168, 0.059759043, 0.059829019, 0.059899021, 0.059968989, 0.060039062, 0.060109165, 0.06017926, 0.060249392, 0.060319558, 0.060389787, 0.060460016, 0.060530338, 0.060600631, 0.060670987, 0.060741372, 0.060811792, 0.060882244, 0.060952727, 0.061023243, 0.061093789, 0.061164368, 0.061235011, 0.061305624, 0.061376333, 0.061447036, 0.061517809, 0.061588611, 0.061659414, 0.061730281, 0.061801143, 0.061872076, 0.061943039, 0.062014036, 0.062085025, 0.062156085, 0.062227208, 0.062298302, 0.062369488, 0.062440705, 0.062511891, 0.062583171, 0.062654451, 0.062725797, 0.062797174, 0.06286855, 0.062939927, 0.063011438, 0.063082941, 0.063154444, 0.063226014, 0.063297652, 0.063369252, 0.063440919, 0.063512616, 0.063584343, 0.063656099, 0.06372793, 0.063799717, 0.063871607, 0.063943528, 0.064015456, 0.064087436, 0.064159453, 0.06423147, 0.064303547, 0.064375624, 0.064447805, 0.064519949, 0.064592153, 0.064664364, 0.064736664, 0.064808972, 0.06488131, 0.064953707, 0.065026075, 0.065098539, 0.065171033, 0.065243527, 0.065316051, 0.065388642, 0.065461271, 0.065533891, 0.065606579, 0.065679297, 0.065752015, 0.065824836, 0.065897614, 0.065970458, 0.066043369, 0.066116251, 0.0661892, 0.0662622, 0.066335209, 0.066408247, 0.066481344, 0.066554479, 0.066627614, 0.066700816, 0.066774011, 0.066847272, 0.066920534, 0.066993862, 0.067067184, 0.067140609, 0.067214034, 0.067287482, 0.067360967, 0.06743452, 0.067508034, 0.067581654, 0.067655265, 0.067728937, 0.067802586, 0.067876324, 0.067950062, 0.068023868, 0.068097711, 0.068171546, 0.068245478, 0.06831938, 0.068393342, 0.068467371, 0.06854137, 0.068615392, 0.068689518, 0.068763673, 0.068837799, 0.068912014, 0.068986274, 0.06906049, 0.069134809, 0.069209121, 0.0692835, 0.069357917, 0.069432326, 0.069506764, 0.069581307, 0.069655851, 0.069730386, 0.069805019, 0.069879659, 0.069954321, 0.070029028, 0.07010375, 0.070178546, 0.070253313, 0.070328169, 0.070403025, 0.070477948, 0.070552908, 0.070627861, 0.070702881, 0.07077793, 0.07085298, 0.070928097, 0.071003206, 0.07107842, 0.071153596, 0.071228869, 0.071304113, 0.071379445, 0.071454786, 0.071530156, 0.071605586, 0.071681023, 0.071756519, 0.071832053, 0.07190755, 0.071983114, 0.072058767, 0.072134428, 0.072210081, 0.072285801, 0.072361588, 0.072437339, 0.072513156, 0.07258901, 0.072664887, 0.072740801, 0.072816744, 0.072892718, 0.072968759, 0.073044829, 0.073120899, 0.073197037, 0.073273212, 0.073349372, 0.073425606, 0.07350184, 0.073578134, 0.073654465, 0.073734738, 0.073818728, 0.073902771, 0.073986821, 0.074070878, 0.074154943, 0.07423906, 0.074323177, 0.074407309, 0.074491449, 0.074575633, 0.074659824, 0.074744038, 0.074828267, 0.074912518, 0.074996777, 0.075081043, 0.075165354, 0.075249672, 0.075334013, 0.075418383, 0.075502746, 0.075587139, 0.075671569, 0.075755984, 0.075840428, 0.075924918, 0.076009415, 0.076093912, 0.076178402, 0.076262936, 0.076347545, 0.076432109, 0.07651671, 0.076601282, 0.07668595, 0.076770619, 0.07685528, 0.076939978, 0.077024676, 0.077109404, 0.077194162, 0.07727892, 0.077363692, 0.077448487, 0.07753332, 0.077618137, 0.077703014, 0.077787884, 0.077872768, 0.077957682, 0.078042649, 0.078127585, 0.078212522, 0.078297518, 0.078382537, 0.078467555, 0.078552604, 0.078637645, 0.078722738, 0.078807853, 0.078892939, 0.078978069, 0.079063214, 0.079148412, 0.079233609, 0.079318814, 0.079404004, 0.079489283, 0.07957454, 0.079659812, 0.079745114, 0.079830453, 0.079915769, 0.080001146, 0.080086507, 0.080171898, 0.080257297, 0.08034274, 0.080428191, 0.080513649, 0.080599152, 0.080684632, 0.080770165, 0.080855727, 0.080941275, 0.081026845, 0.081112437, 0.081198066, 0.081283696, 0.08136934, 0.081454992, 0.081540711, 0.081626423, 0.081712142, 0.08179789, 0.081883661, 0.081969418, 0.082055219, 0.082141034, 0.08222688, 0.082312725, 0.082398608, 0.082484499, 0.082570404, 0.082656339, 0.082742289, 0.082828261, 0.082914218, 0.08300025, 0.083086275, 0.083172299, 0.083258346, 0.083344452, 0.083430558, 0.083516628, 0.083602764, 0.083688959, 0.083775096, 0.083861306, 0.083947487, 0.08403372, 0.084119976, 0.084206238, 0.084292479, 0.084378809, 0.084465131, 0.084551461, 0.084637821, 0.084724203, 0.084810592, 0.084896997, 0.084983416, 0.085069887, 0.085156322, 0.085242815, 0.085329294, 0.085415863, 0.085502408, 0.085588932, 0.085675508, 0.085762143, 0.085848726, 0.085935362, 0.086021997, 0.086108662, 0.086195357, 0.086282082, 0.086368792, 0.086455524, 0.086542316, 0.08662907, 0.086715885, 0.086802661, 0.08688955, 0.086976402, 0.087063268, 0.087150142, 0.087237045, 0.087323993, 0.087410919, 0.087497897, 0.087584883, 0.087671883, 0.087758906, 0.087845936, 0.087933004, 0.088020071, 0.088107169, 0.088194273, 0.08828143, 0.088368572, 0.088455722, 0.088542901, 0.088630147, 0.088717356, 0.088804588, 0.088891834, 0.08897914, 0.089066438, 0.089153744, 0.089241065, 0.089328445, 0.089415804, 0.089503184, 0.089590602, 0.089678049, 0.089765474, 0.089852951, 0.089940421, 0.090027899, 0.090115435, 0.090202987, 0.090290532, 0.090378113, 0.090465717, 0.090553321, 0.090640955, 0.090728588, 0.090816274, 0.09090396, 0.090991646, 0.091079354, 0.091167122, 0.091254883, 0.09134265, 0.091430455, 0.091518268, 0.09160611, 0.09169396, 0.091781817, 0.091869734, 0.091957614, 0.092045546, 0.092133485, 0.092221476, 0.092309445, 0.092397436, 0.09248545, 0.092573516, 0.09266156, 0.092749625, 0.092837714, 0.092925832, 0.093013957, 0.093102105, 0.093190275, 0.093278475, 0.093366675, 0.093454897, 0.093543142, 0.093631402, 0.093719684, 0.09380798, 0.09389627, 0.093984589, 0.09407296, 0.094161354, 0.094249703, 0.094338119, 0.094426557, 0.094514996, 0.094603471, 0.094691932, 0.094780467, 0.094868951, 0.094957493, 0.095046036, 0.095134631, 0.095223233, 0.095311813, 0.09540046, 0.095489129, 0.095577784, 0.095666453, 0.095755152, 0.095843904, 0.095932618, 0.096021391, 0.096110143, 0.096198961, 0.096287765, 0.096376605, 0.096465461, 0.096554331, 0.096643217, 0.096732117, 0.09682104, 0.096909992, 0.096998952, 0.097087935, 0.097176924, 0.097265944, 0.097354986, 0.097444028, 0.097533114, 0.097622186, 0.097711317, 0.097800441, 0.097889587, 0.097978741, 0.098067932, 0.09815716, 0.098246343, 0.098335586, 0.098424859, 0.098514132, 0.098603427, 0.098692723, 0.098782092, 0.098871425, 0.098960795, 0.099050172, 0.099139594, 0.09922903, 0.099318452, 0.099407911, 0.099497408, 0.099586904, 0.09967643, 0.099765942, 0.099855512, 0.099945061, 0.10003467, 0.10012425, 0.1002139, 0.10030356, 0.10039321, 0.1004829, 0.10057262, 0.10066234, 0.10075207, 0.10084181, 0.10093161, 0.10102137, 0.1011112, 0.10120103, 0.10129088, 0.10138077, 0.10147063, 0.10156055, 0.10165045, 0.10174041, 0.10183039, 0.10192034, 0.10201032, 0.10210035, 0.10219041, 0.10228042, 0.10237051, 0.10246062, 0.10255071, 0.10264084, 0.10273098, 0.10282116, 0.10291133, 0.10300154, 0.10309175, 0.10318199, 0.10327226, 0.10336253, 0.10345282, 0.10354314, 0.10363347, 0.10372383, 0.10381417, 0.10390457, 0.10399497, 0.10408539, 0.10417581, 0.1042663, 0.10435679, 0.10444725, 0.10453778, 0.10462833, 0.10471888, 0.10480945, 0.10490002, 0.10499066, 0.10508125, 0.10517191, 0.10526256, 0.10535327, 0.10544397, 0.10553467, 0.10562541, 0.10571615, 0.10580695, 0.10589775, 0.10598854, 0.10607935, 0.10617021, 0.1062611, 0.10635197, 0.10644287, 0.10653383, 0.10662474, 0.10671571, 0.10680667, 0.1068977, 0.1069887, 0.10707974, 0.10717076, 0.10726184, 0.10735295, 0.10744403, 0.10753517, 0.10762633, 0.10771748, 0.10780867, 0.10789984, 0.10799108, 0.10808232, 0.10817355, 0.10826483, 0.10835613, 0.10844746, 0.10853877, 0.10863013, 0.10872151, 0.10881287, 0.10890428, 0.10899569, 0.10908715, 0.1091786, 0.10927006, 0.10936156, 0.1094531, 0.10954463, 0.10963617, 0.10972774, 0.10981933, 0.10991091, 0.11000257, 0.11009418, 0.11018587, 0.11027755, 0.11036924, 0.11046094, 0.11055268, 0.11064443, 0.11073621, 0.11082802, 0.11091984, 0.11101164, 0.1111035, 0.11119536, 0.11128724, 0.11137914, 0.11147109, 0.11156302, 0.11165497, 0.11174694, 0.11183894, 0.11193095, 0.112023, 0.11211503, 0.11220711, 0.11229919, 0.1123913, 0.11248341, 0.11257556, 0.11266773, 0.1127599, 0.1128521, 0.11294433, 0.11303657, 0.11312883, 0.11322107, 0.11331338, 0.11340569, 0.11349802, 0.11359036, 0.11368272, 0.1137751, 0.11386751, 0.11395992, 0.11405236, 0.11414483, 0.11423729, 0.11432979, 0.1144223, 0.11451485, 0.11460737, 0.11469995, 0.11479253, 0.11488516, 0.11497778, 0.11507042, 0.11516306, 0.11525575, 0.11534844, 0.11544117, 0.1155339, 0.11562666, 0.11571941, 0.11581221, 0.11590501, 0.11599785, 0.1160907, 0.11618356, 0.11627643, 0.11636934, 0.11646227, 0.11655519, 0.11664816, 0.11674114, 0.11683413, 0.11692715, 0.11702017, 0.11711323, 0.1172063, 0.11729939, 0.11739247, 0.1174856, 0.11757873, 0.11767189, 0.11776508, 0.11785827, 0.11795149, 0.11804472, 0.11813797, 0.11823124, 0.11832455, 0.11841784, 0.11851117, 0.11860452, 0.11869788, 0.11879125, 0.11888467, 0.11897807, 0.11907151, 0.11916497, 0.11925846, 0.11935193, 0.11944545, 0.11953898, 0.11963253, 0.11972609, 0.11981969, 0.11991329, 0.1200069, 0.12010055, 0.12019422, 0.12028789, 0.12038159, 0.12047529, 0.12056904, 0.12066277, 0.12075655, 0.12085036, 0.12094416, 0.12103797, 0.1211318, 0.12122568, 0.12131957, 0.12141345, 0.12150739, 0.12160131, 0.12169527, 0.12178925, 0.12188322, 0.12197725, 0.12207127, 0.12216532, 0.12225939, 0.12235348, 0.12244757, 0.1225417, 0.12263583, 0.12273, 0.12282417, 0.12291838, 0.12301257, 0.12310681, 0.12320107, 0.12329534, 0.12338962, 0.12348394, 0.12357825, 0.1236726, 0.12376697, 0.12386134, 0.12395576, 0.12405016, 0.12414458, 0.12423905, 0.12433352, 0.12442801, 0.12452252, 0.12461705, 0.1247116, 0.12480617, 0.12490077, 0.12499535, 0.12508997, 0.12518463, 0.12527926, 0.12537394, 0.12546864, 0.12556335, 0.12565809, 0.12575285, 0.12584762, 0.12594239, 0.1260372, 0.126132, 0.12622686, 0.12632172, 0.12641659, 0.1265115, 0.12660643, 0.12670135, 0.12679629, 0.12689129, 0.12698627, 0.12708127, 0.12717631, 0.12727135, 0.12736642, 0.12746149, 0.12755661, 0.12765174, 0.12774687, 0.12784202, 0.1279372, 0.1280324, 0.1281276, 0.12822284, 0.1283181, 0.12841335, 0.12850863, 0.12860392, 0.12869927, 0.12879461, 0.12888998, 0.12898536, 0.12908076, 0.12917617, 0.1292716, 0.12936705, 0.12946254, 0.12955801, 0.12965351, 0.12974904, 0.12984459, 0.12994017, 0.13003573, 0.13013135, 0.13022695, 0.13032261, 0.13041824, 0.13051394, 0.13060962, 0.13070534, 0.13080107, 0.13089684, 0.13099256, 0.13108836, 0.13118418, 0.13127999, 0.13137583, 0.13147171, 0.13156755, 0.13166347, 0.13175939, 0.13185532, 0.13195129, 0.13204724, 0.13214323, 0.13223925, 0.13233526, 0.13243131, 0.13252737, 0.13262346, 0.13271955, 0.13281566, 0.13291182, 0.13300796, 0.13310415, 0.13320035, 0.13329653, 0.13339277, 0.13348903, 0.13358532, 0.1336816, 0.1337779, 0.13387419, 0.13397054, 0.13406691, 0.13416328, 0.1342597, 0.13435608, 0.13445252, 0.13454898, 0.13464545, 0.13474193, 0.13483842, 0.13493496, 0.13503152, 0.13512808, 0.13522464, 0.13532124, 0.13541786, 0.13551451, 0.13561116, 0.13570786, 0.13580453, 0.13590124, 0.13599797, 0.13609472, 0.13619147, 0.13628827, 0.13638508, 0.1364819, 0.13657872, 0.13667558, 0.13677247, 0.13686937, 0.13696627, 0.13706319, 0.13716015, 0.13725714, 0.13735412, 0.13745113, 0.13754815, 0.13764518, 0.13774227, 0.13783933, 0.13793643, 0.13803355, 0.13813069, 0.13822784, 0.13832502, 0.13842222, 0.13851941, 0.13861665, 0.13871388, 0.13881116, 0.13890845, 0.13900575, 0.13910304, 0.13920039, 0.13929777, 0.13939513, 0.13949253, 0.13958997, 0.13968736, 0.13978483, 0.13988228, 0.13997979, 0.14007729, 0.14017482, 0.14027235, 0.14036991, 0.14046749, 0.1405651, 0.1406627, 0.14076035, 0.14085798, 0.14095566, 0.14105336, 0.14115107, 0.14124881, 0.14134656, 0.1414443, 0.14154209, 0.1416399, 0.14173771, 0.14183556, 0.14193343, 0.14203127, 0.14212918, 0.14222708, 0.14232503, 0.14242297, 0.14252095, 0.14261892, 0.14271693, 0.14281495, 0.142913, 0.14301106, 0.14310913, 0.14320724, 0.14330536, 0.14340349, 0.14350164, 0.14359981, 0.14369799, 0.14379621, 0.14389443, 0.14399269, 0.14409094, 0.14418922, 0.14428754, 0.14438584, 0.14448419, 0.14458254, 0.14468092, 0.14477931, 0.14487773, 0.14497615, 0.14507461, 0.14517307, 0.14527154, 0.14537005, 0.14546858, 0.14556712, 0.14566569, 0.14576426, 0.14586286, 0.14596146, 0.14606011, 0.14615875, 0.14625743, 0.14635612, 0.14645483, 0.14655355, 0.14665228, 0.14675106, 0.14684986, 0.14694867, 0.14704745, 0.14714628, 0.14724515, 0.14734401, 0.14744294, 0.14754182, 0.14764076, 0.14773971, 0.14783867, 0.14793766, 0.14803666, 0.14813566, 0.14823474, 0.14833377, 0.14843288, 0.14853194, 0.14863108, 0.14873022, 0.14882934, 0.14892854, 0.14902772, 0.14912692, 0.14922616, 0.14932539, 0.14942466, 0.14952393, 0.14962326, 0.14972255, 0.14982189, 0.14992125, 0.15002063, 0.15012002, 0.15021943, 0.15031885, 0.1504183, 0.15051778, 0.15061727, 0.15071677, 0.15081629, 0.15091582, 0.15101539, 0.15111497, 0.15121455, 0.15131417, 0.15141378, 0.15151344, 0.15161313, 0.15171279, 0.15181249, 0.15191221, 0.15201198, 0.15211174, 0.15221152, 0.15231133, 0.15241113, 0.15251097, 0.15261081, 0.15271072, 0.15281059, 0.15291052, 0.15301043, 0.15311037, 0.15321034, 0.15331031, 0.15341033, 0.15351033, 0.15361038, 0.15371045, 0.15381052, 0.15391064, 0.15401071, 0.15411088, 0.154211, 0.15431118, 0.15441136, 0.15451157, 0.1546118, 0.15471205, 0.15481229, 0.15491256, 0.15501288, 0.15511319, 0.15521353, 0.15531388, 0.15541425, 0.15551464, 0.15561506, 0.15571548, 0.15581593, 0.15591638, 0.15601687, 0.15611739, 0.1562179, 0.15631843, 0.15641898, 0.15651956, 0.15662016, 0.15672079, 0.1568214, 0.15692203, 0.15702273, 0.15712339, 0.15722413, 0.15732484, 0.1574256, 0.15752633, 0.15762712, 0.15772791, 0.15782873, 0.15792955, 0.15803044, 0.15813127, 0.15823217, 0.15833306, 0.15843402, 0.15853497, 0.15863593, 0.15873691, 0.1588379, 0.15893891, 0.15903996, 0.15914102, 0.15924209, 0.1593432, 0.1594443, 0.15954542, 0.15964659, 0.15974775, 0.15984894, 0.15995012, 0.16005138, 0.16015261, 0.16025385, 0.16035514, 0.16045643, 0.16055775, 0.1606591, 0.16076045, 0.16086179, 0.16096318, 0.16106459, 0.16116603, 0.16126747, 0.16136894, 0.16147041, 0.16157192, 0.16167346, 0.16177498, 0.16187654, 0.16197811, 0.16207968, 0.16218132, 0.16228293, 0.16238458, 0.16248627, 0.16258794, 0.16268963, 0.16279136, 0.1628931, 0.16299485, 0.16309665, 0.16319846, 0.16330023, 0.1634021, 0.16350394, 0.16360581, 0.16370769, 0.16380961, 0.16391151, 0.16401348, 0.16411543, 0.16421743, 0.16431943, 0.16442142, 0.16452347, 0.1646255, 0.16472761, 0.16482967, 0.16493179, 0.16503394, 0.16513607, 0.16523825, 0.16534044, 0.16544262, 0.16554482, 0.16564707, 0.16574936, 0.16585162, 0.1659539, 0.16605623, 0.16615856, 0.16626091, 0.16636328, 0.16646568, 0.16656809, 0.1666705, 0.16677295, 0.16687541, 0.1669831, 0.16709593, 0.16720876, 0.16732153, 0.1674343, 0.16754702, 0.16765971, 0.16777238, 0.16788501, 0.1679976, 0.16811018, 0.16822268, 0.16833518, 0.16844763, 0.16856006, 0.16867244, 0.16878484, 0.16889714, 0.16900945, 0.1691217, 0.16923395, 0.16934612, 0.1694583, 0.16957043, 0.16968252, 0.1697946, 0.16990662, 0.17001863, 0.1701306, 0.17024253, 0.17035444, 0.1704663, 0.17057814, 0.17068996, 0.17080173, 0.17091344, 0.17102517, 0.17113683, 0.17124847, 0.17136009, 0.17147164, 0.17158321, 0.17169471, 0.17180617, 0.1719176, 0.17202905, 0.17214042, 0.17225176, 0.17236307, 0.17247435, 0.17258559, 0.17269681, 0.17280799, 0.17291915, 0.17303024, 0.17314135, 0.17325236, 0.17336339, 0.17347436, 0.17358534, 0.17369623, 0.17380713, 0.17391798, 0.1740288, 0.17413957, 0.17425032, 0.17436104, 0.17447175, 0.17458238, 0.174693, 0.1748036, 0.17491415, 0.17502467, 0.17513515, 0.17524563, 0.17535605, 0.17546643, 0.17557681, 0.17568713, 0.1757974, 0.17590769, 0.17601791, 0.17612809, 0.17623825, 0.17634839, 0.17645849, 0.17656855, 0.17667857, 0.17678857, 0.17689854, 0.17700848, 0.17711838, 0.17722826, 0.17733808, 0.17744787, 0.17755763, 0.17766736, 0.17777707, 0.17788677, 0.17799637, 0.17810598, 0.17821553, 0.17832509, 0.17843461, 0.17854406, 0.17865349, 0.17876293, 0.17887227, 0.17898163, 0.17909095, 0.17920022, 0.17930944, 0.17941867, 0.17952782, 0.17963699, 0.17974611, 0.17985517, 0.17996423, 0.1800732, 0.18018222, 0.18029113, 0.18040006, 0.18050893, 0.18061779, 0.1807266, 0.18083538, 0.18094414, 0.18105286, 0.18116155, 0.1812702, 0.1813788, 0.18148741, 0.18159592, 0.18170446, 0.18181296, 0.18192141, 0.18202983, 0.18213822, 0.18224657, 0.18235488, 0.18246317, 0.18257144, 0.18267965, 0.18278785, 0.182896, 0.18300414, 0.18311222, 0.18322028, 0.18332832, 0.1834363, 0.18354425, 0.18365219, 0.18376009, 0.18386796, 0.18397577, 0.18408358, 0.18419135, 0.18429907, 0.18440677, 0.18451443, 0.18462206, 0.18472965, 0.18483724, 0.18494476, 0.18505226, 0.18515974, 0.18526718, 0.18537457, 0.18548195, 0.18558927, 0.1856966, 0.18580385, 0.18591112, 0.1860183, 0.18612547, 0.18623261, 0.18633974, 0.1864468, 0.18655384, 0.18666084, 0.18676782, 0.18687476, 0.18698168, 0.18708856, 0.18719541, 0.1873022, 0.18740901, 0.18751574, 0.18762244, 0.18772912, 0.18783578, 0.1879424, 0.18804899, 0.18815552, 0.18826203, 0.18836851, 0.18847498, 0.18858139, 0.18868776, 0.18879414, 0.18890044, 0.18900673, 0.18911296, 0.18921919, 0.18932538, 0.18943153, 0.18953766, 0.18964374, 0.18974981, 0.18985583, 0.18996181, 0.19006778, 0.1901737, 0.19027959, 0.19038546, 0.19049129, 0.19059709, 0.19070284, 0.19080856, 0.19091424, 0.19101994, 0.19112554, 0.19123115, 0.19133671, 0.19144225, 0.19154775, 0.19165318, 0.19175865, 0.19186403, 0.19196941, 0.19207472, 0.19218004, 0.19228531, 0.19239053, 0.19249575, 0.19260091, 0.19270603, 0.19281116, 0.19291621, 0.19302127, 0.19312625, 0.19323123, 0.19333617, 0.19344108, 0.19354595, 0.19365078, 0.19375561, 0.19386037, 0.19396512, 0.19406983, 0.1941745, 0.19427915, 0.19438376, 0.19448835, 0.19459286, 0.19469739, 0.19480187, 0.19490631, 0.19501075, 0.1951151, 0.19521947, 0.19532378, 0.19542806, 0.19553229, 0.19563654, 0.1957407, 0.19584487, 0.19594899, 0.19605306, 0.19615713, 0.19626114, 0.19636513, 0.19646908, 0.196573, 0.1966769, 0.19678076, 0.19688456, 0.19698837, 0.19709215, 0.19719584, 0.19729954, 0.19740318, 0.19750682, 0.19761041, 0.19771397, 0.19781747, 0.19792098, 0.19802444, 0.19812787, 0.19823126, 0.19833463, 0.19843797, 0.19854125, 0.19864453, 0.19874774, 0.19885096, 0.19895411, 0.19905727, 0.19916035, 0.19926341, 0.19936647, 0.19946946, 0.19957243, 0.19967537, 0.19977826, 0.19988114, 0.19998397, 0.20008676, 0.20018955, 0.20029227, 0.200395, 0.20049767, 0.2006003, 0.20070294, 0.2008055, 0.20090804, 0.20101054, 0.20111303, 0.20121546, 0.20131788, 0.20142025, 0.20152259, 0.2016249, 0.20172717, 0.20182942, 0.20193166, 0.20203382, 0.20213598, 0.20223807, 0.20234019, 0.20244221, 0.20254421, 0.20264621, 0.20274816, 0.20285009, 0.20295195, 0.20305382, 0.20315564, 0.20325741, 0.20335917, 0.2034609, 0.20356257, 0.20366423, 0.20376585, 0.20386745, 0.203969, 0.20407054, 0.20417202, 0.20427348, 0.20437488, 0.20447631, 0.20457765, 0.204679, 0.20478028, 0.20488153, 0.20498276, 0.20508397, 0.20518512, 0.20528626, 0.20538734, 0.20548841, 0.20558944, 0.20569046, 0.20579141, 0.20589235, 0.20599325, 0.20609413, 0.20619494, 0.20629574, 0.20639651, 0.20649724, 0.20659794, 0.20669864, 0.20679924, 0.20689985, 0.20700045, 0.20710096, 0.20720148, 0.20730193, 0.20740238, 0.2075028, 0.20760314, 0.20770352, 0.20780382, 0.20790409, 0.20800433, 0.20810454, 0.20820473, 0.20830485, 0.20840497, 0.20850506, 0.20860511, 0.2087051, 0.20880508, 0.20890503, 0.20900497, 0.20910484, 0.20920466, 0.2093045, 0.20940429, 0.20950404, 0.20960376, 0.20970342, 0.20980309, 0.2099027, 0.2100023, 0.21010184, 0.21020138, 0.21030085, 0.2104003, 0.21049972, 0.21059911, 0.21069847, 0.2107978, 0.21089709, 0.21099634, 0.21109556, 0.21119474, 0.21129392, 0.21139303, 0.21149214, 0.2115912, 0.21169022, 0.21178921, 0.21188818, 0.21198709, 0.21208602, 0.21218488, 0.21228369, 0.2123825, 0.21248126, 0.21258, 0.21267869, 0.21277735, 0.21287599, 0.21297459, 0.21307315, 0.21317168, 0.21327019, 0.21336867, 0.21346709, 0.2135655, 0.21366386, 0.21376221, 0.21386053, 0.21395878, 0.21405704, 0.21415523, 0.21425341, 0.21435153, 0.21444966, 0.21454772, 0.21464579, 0.21474378, 0.21484177, 0.21493971, 0.21503763, 0.21513547, 0.21523336, 0.21533115, 0.21542893, 0.21552669, 0.21562438, 0.21572205, 0.2158197, 0.21591733, 0.21601491, 0.21611245, 0.21620996, 0.21630745, 0.2164049, 0.21650234, 0.21659972, 0.21669707, 0.21679439, 0.21689169, 0.21698892, 0.21708615, 0.21718334, 0.21728049, 0.21737762, 0.2174747, 0.21757177, 0.21766879, 0.21776576, 0.21786273, 0.21795966, 0.21805656, 0.21815342, 0.21825024, 0.21834704, 0.2184438, 0.21854052, 0.21863724, 0.21873389, 0.2188305, 0.21892712, 0.21902366, 0.2191202, 0.2192167, 0.21931317, 0.2194096, 0.21950601, 0.21960236, 0.21969868, 0.21979499, 0.21989127, 0.2199875, 0.2200837, 0.22017987, 0.22027603, 0.22037211, 0.22046818, 0.22056423, 0.22066024, 0.2207562, 0.22085217, 0.22094806, 0.22104393, 0.22113976, 0.22123557, 0.22133134, 0.22142711, 0.22152279, 0.22161849, 0.22171411, 0.22180973, 0.22190532, 0.22200087, 0.22209637, 0.22219187, 0.22228731, 0.22238272, 0.22247811, 0.22257346, 0.22266877, 0.22276405, 0.22285929, 0.22295453, 0.2230497, 0.22314486, 0.22323996, 0.22333506, 0.22343011, 0.22352514, 0.22362013, 0.22371508, 0.22380999, 0.22390488, 0.22399975, 0.22409455, 0.22418936, 0.22428411, 0.22437882, 0.22447354, 0.22456819, 0.22466281, 0.2247574, 0.22485197, 0.2249465, 0.22504099, 0.22513546, 0.22522989, 0.22532429, 0.22541863, 0.22551297, 0.22560726, 0.22570156, 0.22579576, 0.22588997, 0.22598413, 0.22607826, 0.22617236, 0.22626644, 0.22636048, 0.2264545, 0.22654845, 0.2266424, 0.22673626, 0.22683017, 0.22692399, 0.2270178, 0.22711158, 0.22720532, 0.22729902, 0.22739269, 0.22748631, 0.22757995, 0.22767353, 0.22776707, 0.22786057, 0.22795404, 0.22804749, 0.22814091, 0.22823428, 0.22832762, 0.22842094, 0.22851421, 0.22860746, 0.22870068, 0.22879386, 0.22888701, 0.22898012, 0.2290732, 0.22916625, 0.22925925, 0.22935225, 0.22944522, 0.22953814, 0.22963101, 0.22972387, 0.22981666, 0.22990948, 0.23000221, 0.23009494, 0.23018764, 0.2302803, 0.23037291, 0.23046549, 0.23055805, 0.23065059, 0.23074308, 0.23083554, 0.23092796, 0.23102035, 0.23111273, 0.23120505, 0.23129733, 0.2313896, 0.23148182, 0.23157401, 0.23166616, 0.23175833, 0.23185042, 0.23194247, 0.23203452, 0.2321265, 0.23221847, 0.2323104, 0.23240229, 0.23249418, 0.23258601, 0.23267782, 0.23276958, 0.23286131, 0.23295301, 0.23304467, 0.23313634, 0.23322792, 0.23331952, 0.23341103, 0.23350254, 0.23359402, 0.23368546, 0.23377687, 0.23386826, 0.2339596, 0.2340509, 0.23414215, 0.23423342, 0.23432462, 0.23441578, 0.23450693, 0.23459806, 0.23468913, 0.23478018, 0.23487119, 0.23496217, 0.23505312, 0.23514405, 0.23523492, 0.23532578, 0.23541659, 0.23550737, 0.23559813, 0.23568884, 0.23577951, 0.23587018, 0.2359608, 0.23605138, 0.23614195, 0.23623246, 0.23632294, 0.23641339, 0.23650382, 0.2365942, 0.23668455, 0.23677488, 0.23686518, 0.23695545, 0.23704566, 0.23713584, 0.23722602, 0.23731613, 0.23740624, 0.2374963, 0.23758633, 0.23767631, 0.23776628, 0.23785622, 0.23794612, 0.23803599, 0.2381258, 0.23821558, 0.23830537, 0.23839509, 0.23848478, 0.23857446, 0.23866411, 0.23875371, 0.23884326, 0.2389328, 0.23902231, 0.23911178, 0.2392012, 0.23929062, 0.23937997, 0.23946932, 0.23955864, 0.23964791, 0.23973715, 0.23982635, 0.23991552, 0.24000466, 0.24009378, 0.24018285, 0.24027191, 0.24036092, 0.24044988, 0.24053884, 0.24062775, 0.24071662, 0.24080546, 0.24089427, 0.24098304, 0.24107182, 0.24116051, 0.24124922, 0.24133784, 0.24142647, 0.24151506, 0.24160361, 0.24169213, 0.24178061, 0.24186905, 0.24195746, 0.24204586, 0.2421342, 0.24222255, 0.24231082, 0.24239907, 0.2424873, 0.2425755, 0.24266362, 0.24275176, 0.24283984, 0.24292789, 0.24301593, 0.24310392, 0.2431919, 0.2432798, 0.2433677, 0.24345557, 0.2435434, 0.2436312, 0.24371895, 0.24380668, 0.2438944, 0.24398205, 0.24406967, 0.24415727, 0.24424481, 0.24433236, 0.24441986, 0.24450733, 0.24459477, 0.24468216, 0.24476951, 0.24485688, 0.24494417, 0.24503145, 0.24511868, 0.24520588, 0.24529305, 0.24538018, 0.24546729, 0.24555436, 0.2456414, 0.2457284, 0.2458154, 0.24590231, 0.24598923, 0.24607611, 0.24616294, 0.24624978, 0.24633653, 0.24642326, 0.24650997, 0.24659665, 0.2466833, 0.24676992, 0.2468565, 0.24694306, 0.24702954, 0.24711604, 0.2472025, 0.2472889, 0.24737531, 0.24746163, 0.24754792, 0.24763425, 0.24772048, 0.24780671, 0.24789289, 0.24797904, 0.24806516, 0.24815126, 0.24823731, 0.24832334, 0.24840932, 0.24849527, 0.24858119, 0.24866706, 0.24875295, 0.24883877, 0.24892455, 0.24901031, 0.24909602, 0.24918173, 0.24926738, 0.24935301, 0.2494386, 0.24952419, 0.24960971, 0.2496952, 0.24978067, 0.24986608, 0.2499515, 0.25003684, 0.25012216, 0.25020748, 0.25029272, 0.25037798, 0.25046319, 0.25054833, 0.25063348, 0.25071859, 0.25080365, 0.25088868, 0.25097367, 0.25105867, 0.2511436, 0.25122851, 0.25131336, 0.25139821, 0.25148302, 0.25156778, 0.25165254, 0.25173724, 0.25182194, 0.25190657, 0.25199115, 0.25207576, 0.25216028, 0.2522448, 0.25232929, 0.25241372, 0.25249815, 0.25258249, 0.25266686, 0.25275114, 0.25283545, 0.2529197, 0.25300393, 0.25308809, 0.25317225, 0.25325635, 0.25334045, 0.2534245, 0.25350851, 0.25359249, 0.25367644, 0.25376037, 0.25384423, 0.25392812, 0.25401193, 0.2540957, 0.25417948, 0.25426319, 0.25434688, 0.25443053, 0.25451416, 0.25459775, 0.25468129, 0.25476483, 0.25484833, 0.25493178, 0.25501522, 0.25509861, 0.25518197, 0.25526527, 0.25534859, 0.25543183, 0.25551507, 0.25559828, 0.25568146, 0.25576457, 0.25584766, 0.25593072, 0.25601378, 0.25609678, 0.25617972, 0.25626269, 0.25634557, 0.25642845, 0.25651127, 0.25659409, 0.25667685, 0.25675958, 0.25684229, 0.25692496, 0.25700757, 0.25709021, 0.25717276, 0.25725532, 0.25733781, 0.2574203, 0.2575027, 0.25758514, 0.25766751, 0.25774986, 0.25783217, 0.25791442, 0.25799668, 0.2580789, 0.2581611, 0.2582432, 0.25832534, 0.25840741, 0.25848946, 0.25857148, 0.25865343, 0.25873539, 0.25881732, 0.25889918, 0.25898105, 0.25906286, 0.25914463, 0.25922641, 0.25930813, 0.25938982, 0.25947145, 0.25955307, 0.25963467, 0.25971624, 0.25979772, 0.25987923, 0.25996068, 0.2600421, 0.26012349, 0.26020485, 0.26028618, 0.26036748, 0.26044872, 0.26052994, 0.26061118, 0.2606923, 0.26077342, 0.26085451, 0.2609356, 0.26101661, 0.26109764, 0.26117858, 0.26125953, 0.26134041, 0.26142129, 0.26150209, 0.26158291, 0.26166368, 0.26174441, 0.26182511, 0.26190579, 0.2619864, 0.26206702, 0.26214758, 0.2622281, 0.26230863, 0.26238909, 0.26246953, 0.26254994, 0.26263031, 0.26271063, 0.26279095, 0.26287124, 0.26295146, 0.26303166, 0.26311183, 0.263192, 0.26327211, 0.26335219, 0.2634263, 0.26349452, 0.26356262, 0.26363069, 0.26369864, 0.26376653, 0.26383436, 0.26390207, 0.26396969, 0.26403725, 0.26410472, 0.26417214, 0.26423943, 0.26430666, 0.26437381, 0.26444089, 0.26450789, 0.26457477, 0.26464161, 0.26470837, 0.26477501, 0.26484159, 0.26490811, 0.2649745, 0.26504087, 0.26510713, 0.26517329, 0.26523936, 0.26530537, 0.26537132, 0.26543716, 0.26550293, 0.26556861, 0.26563421, 0.26569974, 0.26576519, 0.26583055, 0.26589581, 0.26596102, 0.26602611, 0.26609114, 0.26615611, 0.26622096, 0.26628575, 0.26635048, 0.26641509, 0.26647964, 0.2665441, 0.26660848, 0.26667279, 0.26673701, 0.26680112, 0.26686519, 0.26692915, 0.26699305, 0.26705685, 0.2671206, 0.26718423, 0.2672478, 0.26731128, 0.26737466, 0.26743799, 0.26750124, 0.26756442, 0.26762748, 0.26769048, 0.26775339, 0.26781619, 0.26787895, 0.26794162, 0.26800421, 0.2680667, 0.26812917, 0.26819152, 0.26825377, 0.26831594, 0.26837805, 0.26844004, 0.268502, 0.26856384, 0.26862562, 0.26868731, 0.26874891, 0.26881045, 0.2688719, 0.26893327, 0.26899454, 0.26905572, 0.26911685, 0.26917791, 0.26923889, 0.26929975, 0.26936054, 0.26942125, 0.2694819, 0.26954243, 0.26960289, 0.26966327, 0.26972359, 0.26978382, 0.26984394, 0.26990402, 0.26996398, 0.27002388, 0.27008373, 0.27014345, 0.27020308, 0.27026266, 0.27032214, 0.27038157, 0.27044091, 0.27050012, 0.27055931, 0.27061838, 0.27067739, 0.27073631, 0.27079517, 0.27085391, 0.27091259, 0.27097115, 0.27102971, 0.27108812, 0.27114651, 0.27120477, 0.27126294, 0.27132103, 0.27137905, 0.27143699, 0.27149487, 0.27155265, 0.27161035, 0.27166796, 0.27172551, 0.27178293, 0.27184033, 0.27189761, 0.27195483, 0.27201194, 0.27206898, 0.27212596, 0.27218282, 0.27223966, 0.27229637, 0.27235299, 0.27240956, 0.27246603, 0.27252242, 0.27257875, 0.27263498, 0.27269113, 0.27274719, 0.27280316, 0.2728591, 0.27291489, 0.27297065, 0.27302632, 0.27308187, 0.27313739, 0.27319279, 0.27324814, 0.27330336, 0.27335852, 0.27341366, 0.27346867, 0.2735236, 0.27357844, 0.27363318, 0.2736879, 0.2737425, 0.27379701, 0.27385142, 0.27390581, 0.27396005, 0.27401426, 0.27406836, 0.27412239, 0.27417636, 0.27423021, 0.27428401, 0.27433771, 0.27439132, 0.27444488, 0.27449834, 0.27455172, 0.27460501, 0.27465823, 0.27471134, 0.27476439, 0.27481738, 0.27487028, 0.27492306, 0.27497581, 0.27502847, 0.27508101, 0.27513349, 0.27518591, 0.27523822, 0.27529046, 0.27534261, 0.27539468, 0.27544668, 0.2754986, 0.27555043, 0.27560219, 0.27565384, 0.27570543, 0.27575693, 0.27580836, 0.27585971, 0.27591097, 0.27596214, 0.27601326, 0.27606425, 0.27611518, 0.27616602, 0.2762168, 0.2762675, 0.2763181, 0.27636862, 0.2764191, 0.27646944, 0.27651972, 0.27656993, 0.27662003, 0.27667007, 0.27672005, 0.27676991, 0.27681971, 0.27686945, 0.27691904, 0.27696857, 0.27701807, 0.27706742, 0.27711675, 0.27716601, 0.27721512, 0.27726418, 0.27731314, 0.27736205, 0.27741086, 0.27745959, 0.27750826, 0.27755684, 0.27760532, 0.27765372, 0.27770203, 0.27775028, 0.27779847, 0.27784652, 0.27789453, 0.27794245, 0.27799028, 0.27803805, 0.27808574, 0.27813333, 0.27818084, 0.27822825, 0.27827561, 0.27832288, 0.27837005, 0.27841717, 0.27846417, 0.27851114, 0.27855799, 0.27860478, 0.27865145, 0.27869806, 0.27874461, 0.27879107, 0.27883744, 0.27888373, 0.27892992, 0.27897605, 0.2790221, 0.27906805, 0.27911395, 0.27915972, 0.27920547, 0.2792511, 0.27929667, 0.27934214, 0.27938753, 0.27943283, 0.27947804, 0.27952319, 0.27956828, 0.27961326, 0.27965817, 0.27970296, 0.27974772, 0.2797924, 0.27983695, 0.27988148, 0.27992588, 0.2799702, 0.28001446, 0.28005862, 0.2801027, 0.28014672, 0.28019068, 0.28023449, 0.28027827, 0.28032196, 0.28036553, 0.28040904, 0.28045249, 0.28049588, 0.28053913, 0.28058234, 0.28062543, 0.28066847, 0.28071138, 0.28075427, 0.28079706, 0.28083974, 0.28088239, 0.28092495, 0.28096735, 0.28100976, 0.28105205, 0.28109428, 0.28113639, 0.28117844, 0.28122041, 0.28126231, 0.28130412, 0.28134584, 0.28138748, 0.28142905, 0.28147054, 0.28151193, 0.28155324, 0.28159449, 0.28163564, 0.28167671, 0.28171769, 0.28175861, 0.28179944, 0.28184018, 0.28188086, 0.28192145, 0.28196195, 0.28200239, 0.28204271, 0.28208297, 0.28212315, 0.28216323, 0.28220326, 0.28224316, 0.28228301, 0.28232282, 0.28236249, 0.28240207, 0.28244162, 0.28248107, 0.28252044, 0.28255969, 0.28259891, 0.28263804, 0.28267705, 0.28271604, 0.2827549, 0.28279367, 0.28283238, 0.28287101, 0.28290957, 0.28294802, 0.28298643, 0.28302473, 0.28306293, 0.28310108, 0.28313914, 0.28317714, 0.28321502, 0.28325284, 0.28329057, 0.28332818, 0.28336576, 0.28340328, 0.28344068, 0.28347799, 0.28351524, 0.28355241, 0.28358948, 0.28362647, 0.28366342, 0.28370023, 0.28373697, 0.28377369, 0.28381026, 0.28384677, 0.28388318, 0.28391951, 0.28395581, 0.28399199, 0.28402811, 0.28406411, 0.28410006, 0.28413591, 0.2841717, 0.28420737, 0.28424299, 0.28427851, 0.28431398, 0.28434935, 0.28438464, 0.28441983, 0.28445497, 0.28448999, 0.28452498, 0.28455985, 0.28459466, 0.28462937, 0.28466401, 0.28469855, 0.28473303, 0.28476745, 0.28480172, 0.28483596, 0.28487009, 0.28490418, 0.28493816, 0.28497204, 0.28500587, 0.28503963, 0.28507328, 0.28510687, 0.28514034, 0.28517377, 0.28520709, 0.28524032, 0.28527352, 0.2853066, 0.28533959, 0.28537253, 0.28540537, 0.28543812, 0.28547081, 0.28550342, 0.28553593, 0.28556836, 0.28560069, 0.28563297, 0.28566515, 0.28569731, 0.28572932, 0.28576127, 0.28579313, 0.28582489, 0.2858566, 0.28588822, 0.28591976, 0.28595123, 0.28598258, 0.2860139, 0.2860451, 0.28607622, 0.2861073, 0.28613824, 0.28616914, 0.28619993, 0.28623068, 0.28626132, 0.2862919, 0.28632236, 0.28635275, 0.28638309, 0.28641331, 0.28644344, 0.28647354, 0.28650352, 0.28653342, 0.28656328, 0.28659302, 0.28662264, 0.28665224, 0.28668174, 0.28671116, 0.28674051, 0.28676975, 0.28679895, 0.28682801, 0.28685707, 0.28688598, 0.28691483, 0.28694358, 0.28697228, 0.28700089, 0.28702942, 0.28705788, 0.28708622, 0.2871145, 0.28714269, 0.28717083, 0.28719884, 0.2872268, 0.28725466, 0.28728247, 0.28731015, 0.28733781, 0.28736535, 0.28739282, 0.28742018, 0.28744751, 0.28747472, 0.28750184, 0.2875289, 0.28755587, 0.28758278, 0.28760958, 0.28763631, 0.28766298, 0.28768951, 0.287716, 0.28774244, 0.28776875, 0.28779498, 0.28782114, 0.28784722, 0.28787321, 0.28789911, 0.28792498, 0.28795072, 0.28797641, 0.28800198, 0.2880275, 0.28805292, 0.28807828, 0.28810352, 0.2881287, 0.28815383, 0.28817883, 0.28820378, 0.28822863, 0.2882534, 0.2882781, 0.28830272, 0.28832722, 0.28835168, 0.28837603, 0.28840032, 0.28842455, 0.28844866, 0.28847274, 0.2884967, 0.28852054, 0.28854436, 0.28856805, 0.28859168, 0.28861526, 0.28863871, 0.28866214, 0.28868544, 0.28870866, 0.28873178, 0.28875485, 0.28877783, 0.28880075, 0.28882354, 0.28884631, 0.28886893, 0.28889152, 0.28891402, 0.28893644, 0.28895876, 0.28898102, 0.28900319, 0.28902528, 0.28904727, 0.28906918, 0.28909105, 0.28911278, 0.28913447, 0.28915608, 0.28917757, 0.28919902, 0.28922036, 0.28924164, 0.2892628, 0.2892839, 0.28930494, 0.28932592, 0.28934678, 0.28936756, 0.28938824, 0.28940886, 0.28942943, 0.28944987, 0.28947023, 0.28949052, 0.28951073, 0.2895309, 0.2895509, 0.2895709, 0.28959078, 0.28961056, 0.28963029, 0.28964996, 0.28966951, 0.28968894, 0.28970835, 0.28972769, 0.28974691, 0.28976607, 0.28978512, 0.28980413, 0.28982306, 0.28984186, 0.28986061, 0.28987929, 0.28989786, 0.28991637, 0.28993475, 0.28995311, 0.28997138, 0.28998956, 0.29000762, 0.29002562, 0.29004356, 0.29006141, 0.29007918, 0.29009688, 0.29011446, 0.29013202, 0.29014942, 0.29016683, 0.29018408, 0.29020131, 0.29021838, 0.2902354, 0.29025236, 0.29026926, 0.29028606, 0.29030272, 0.29031938, 0.29033592, 0.29035237, 0.29036874, 0.29038504, 0.29040128, 0.2904174, 0.29043344, 0.29044947, 0.29046533, 0.29048115, 0.29049689, 0.29051253, 0.29052809, 0.29054359, 0.29055896, 0.29057431, 0.29058954, 0.29060471, 0.29061976, 0.29063475, 0.29064965, 0.29066452, 0.29067928, 0.29069394, 0.29070851, 0.29072303, 0.29073745, 0.29075181, 0.29076606, 0.29078025, 0.29079434, 0.29080838, 0.2908223, 0.29083616, 0.29084995, 0.29086363, 0.29087722, 0.29089075, 0.29090422, 0.29091761, 0.29093087, 0.29094407, 0.29095718, 0.29097024, 0.29098317, 0.29099604, 0.29100883, 0.29102156, 0.29103419, 0.29104674, 0.29105923, 0.29107162, 0.29108393, 0.29109615, 0.29110828, 0.29112035, 0.29113233, 0.29114422, 0.29115605, 0.29116777, 0.29117945, 0.29119101, 0.29120249, 0.2912139, 0.29122525, 0.29123649, 0.29124764, 0.29125872, 0.29126975, 0.29128066, 0.29129151, 0.29130226, 0.29131293, 0.29132354, 0.29133406, 0.29134446, 0.29135484, 0.29136512, 0.29137528, 0.29138538, 0.2913954, 0.29140538, 0.29141521, 0.29142502, 0.29143471, 0.29144433, 0.29145384, 0.29146332, 0.29147267, 0.29148197, 0.29149118, 0.29150033, 0.29150936, 0.29151833, 0.29152721, 0.291536, 0.29154474, 0.29155335, 0.2915619, 0.2915704, 0.2915788, 0.29158711, 0.29159534, 0.29160351, 0.29161158, 0.29161957, 0.29162747, 0.29163527, 0.29164302, 0.29165068, 0.29165828, 0.29166576, 0.29167318, 0.29168054, 0.29168779, 0.29169497, 0.29170203, 0.29170904, 0.29171598, 0.29172283, 0.2917296, 0.29173627, 0.29174289, 0.29174939, 0.29175583, 0.29176217, 0.29176846, 0.29177466, 0.29178077, 0.29178679, 0.29179275, 0.29179862, 0.2918044, 0.29181013, 0.29181576, 0.29182127, 0.29182673, 0.29183212, 0.29183742, 0.29184264, 0.29184777, 0.29185283, 0.29185778, 0.2918627, 0.29186749, 0.29187223, 0.29187688, 0.29188141, 0.29188591, 0.29189032, 0.29189464, 0.29189888, 0.29190305, 0.29190713, 0.2919111, 0.29191503, 0.29191884, 0.29192263, 0.29192629, 0.29192987, 0.29193336, 0.29193678, 0.29194015, 0.29194337, 0.29194656, 0.29194966, 0.29195267, 0.29195562, 0.29195848, 0.29196122, 0.29196393, 0.29196656, 0.29196906, 0.2919715, 0.29197389, 0.29197615, 0.29197839, 0.2919805, 0.29198253, 0.2919845, 0.29198638, 0.29198816, 0.29198986, 0.29199153, 0.29199305, 0.29199451, 0.29199591, 0.29199719, 0.29199842, 0.29199958, 0.29200062, 0.29200161, 0.2920025, 0.29200333, 0.29200405, 0.29200473, 0.2920053, 0.29200578, 0.29200619, 0.29200652, 0.29200676, 0.29200691, 0.29200703, 0.29200703, 0.29200691, 0.29200676, 0.29200652, 0.29200619, 0.29200581, 0.2920053, 0.29200473, 0.29200411, 0.29200333, 0.29200256, 0.29200163, 0.29200065, 0.29199961, 0.29199845, 0.29199722, 0.29199594, 0.29199454, 0.29199311, 0.29199156, 0.29198992, 0.29198822, 0.29198644, 0.29198456, 0.29198259, 0.29198056, 0.29197845, 0.29197624, 0.29197395, 0.29197159, 0.29196915, 0.29196662, 0.29196402, 0.29196134, 0.29195857, 0.29195574, 0.29195276, 0.29194978, 0.29194668, 0.29194352, 0.29194024, 0.2919369, 0.29193348, 0.29192996, 0.29192638, 0.29192269, 0.29191899, 0.29191512, 0.29191124, 0.29190722, 0.2919032, 0.29189903, 0.29189476, 0.29189047, 0.29188606, 0.29188156, 0.291877, 0.29187238, 0.29186764, 0.29186285, 0.29185796, 0.29185298, 0.29184794, 0.29184282, 0.29183757, 0.2918323, 0.2918269, 0.29182145, 0.29181594, 0.2918103, 0.29180458, 0.2917988, 0.29179293, 0.291787, 0.29178098, 0.29177484, 0.29176864, 0.29176235, 0.29175603, 0.2917496, 0.29174307, 0.29173645, 0.29172981, 0.29172301, 0.29171616, 0.29170927, 0.29170224, 0.29169518, 0.291688, 0.29168075, 0.29167342, 0.291666, 0.29165849, 0.29165092, 0.29164326, 0.29163554, 0.29162771, 0.29161981, 0.29161182, 0.29160377, 0.29159561, 0.29158738, 0.29157904, 0.29157066, 0.2915622, 0.29155365, 0.291545, 0.29153627, 0.29152751, 0.2915186, 0.29150966, 0.2915006, 0.29149148, 0.29148227, 0.29147297, 0.29146361, 0.29145417, 0.29144463, 0.291435, 0.29142529, 0.29141551, 0.29140568, 0.29139572, 0.29138571, 0.29137561, 0.29136541, 0.29135513, 0.29134479, 0.29133436, 0.29132387, 0.29131326, 0.29130259, 0.29129183, 0.29128098, 0.29127008, 0.29125908, 0.29124802, 0.29123682, 0.29122558, 0.29121426, 0.29120284, 0.29119137, 0.29117981, 0.29116815, 0.29115641, 0.29114461, 0.29113269, 0.29112074, 0.29110867, 0.29109651, 0.29108429, 0.29107198, 0.29105961, 0.29104716, 0.29103458, 0.29102197, 0.29100928, 0.29099646, 0.29098359, 0.29097062, 0.2909576, 0.29094446, 0.29092121, 0.29088789, 0.29085448, 0.29082102, 0.29078749, 0.29075387, 0.29072019, 0.29068649, 0.29065266, 0.29061881, 0.29058486, 0.29055086, 0.29051676, 0.29048264, 0.29044846, 0.29041418, 0.29037985, 0.29034543, 0.29031095, 0.29027641, 0.29024181, 0.29020715, 0.29017243, 0.29013762, 0.29010275, 0.29006782, 0.29003283, 0.28999776, 0.28996259, 0.28992742, 0.28989214, 0.28985682, 0.28982142, 0.28978592, 0.28975043, 0.28971478, 0.28967914, 0.28964341, 0.28960761, 0.28957173, 0.28953579, 0.28949982, 0.28946376, 0.28942761, 0.28939143, 0.28935516, 0.28931883, 0.28928244, 0.28924596, 0.28920946, 0.28917286, 0.28913617, 0.28909943, 0.28906265, 0.28902578, 0.28898886, 0.28895187, 0.2889148, 0.28887767, 0.28884047, 0.28880322, 0.28876591, 0.28872848, 0.28869101, 0.28865349, 0.28861591, 0.28857824, 0.28854051, 0.28850272, 0.28846484, 0.28842694, 0.28838894, 0.28835088, 0.28831276, 0.28827456, 0.28823632, 0.28819799, 0.28815958, 0.2881211, 0.2880826, 0.28804401, 0.28800535, 0.28796664, 0.28792784, 0.28788897, 0.28785005, 0.28781104, 0.287772, 0.28773287, 0.28769368, 0.28765443, 0.28761512, 0.28757572, 0.28753626, 0.28749672, 0.28745717, 0.2874175, 0.28737777, 0.28733799, 0.28729814, 0.28725818, 0.28721824, 0.28717816, 0.28713804, 0.28709787, 0.28705761, 0.28701729, 0.2869769, 0.28693646, 0.2868959, 0.28685534, 0.28681469, 0.28677398, 0.28673318, 0.28669232, 0.2866514, 0.28661042, 0.28656939, 0.28652823, 0.28648707, 0.28644583, 0.28640449, 0.2863631, 0.28632167, 0.28628016, 0.28623855, 0.28619692, 0.28615519, 0.28611341, 0.28607157, 0.28602964, 0.28598768, 0.28594559, 0.28590348, 0.28586131, 0.28581905, 0.28577673, 0.28573436, 0.28569189, 0.28564939, 0.2856068, 0.28556415, 0.28552145, 0.28547868, 0.28543583, 0.28539291, 0.28534994, 0.28530687, 0.28526378, 0.28522056, 0.28517732, 0.28513402, 0.28509063, 0.2850472, 0.28500372, 0.28496009, 0.28491646, 0.28487277, 0.28482899, 0.28478512, 0.28474122, 0.28469723, 0.28465319, 0.28460908, 0.28456491, 0.28452066, 0.28447637, 0.28443199, 0.28438753, 0.28434303, 0.28429845, 0.28425381, 0.2842091, 0.28416434, 0.28411949, 0.28407454, 0.28402957, 0.28398454, 0.28393945, 0.28389427, 0.28384903, 0.28380373, 0.28375837, 0.28371289, 0.28366742, 0.28362185, 0.28357616, 0.28353047, 0.2834847, 0.28343886, 0.28339297, 0.28334701, 0.28330097, 0.28325483, 0.28320867, 0.28316242, 0.28311613, 0.28306976, 0.2830233, 0.28297681, 0.28293025, 0.28288358, 0.28283688, 0.28279012, 0.28274328, 0.2826964, 0.28264943, 0.28260237, 0.28255528, 0.28250813, 0.28246084, 0.28241357, 0.28236622, 0.28231877, 0.28227127, 0.2822237, 0.28217605, 0.28212836, 0.28208059, 0.28203276, 0.28198487, 0.28193691, 0.28188887, 0.28184077, 0.28179258, 0.28174436, 0.28169605, 0.28164768, 0.28159925, 0.28155077, 0.28150219, 0.28145355, 0.28140485, 0.2813561, 0.28130725, 0.28125837, 0.28120938, 0.28116035, 0.28111127, 0.2810621, 0.28101286, 0.28096357, 0.28091419, 0.28086475, 0.28081527, 0.28076574, 0.28071609, 0.28066638, 0.28061664, 0.28056681, 0.28051689, 0.28046694, 0.28041694, 0.28036681, 0.28031665, 0.28026643, 0.28021613, 0.28016576, 0.28011534, 0.28006485, 0.28001428, 0.27996367, 0.27991298, 0.27986223, 0.27981138, 0.27976048, 0.27970952, 0.27965853, 0.27960742, 0.27955627, 0.27950501, 0.27945372, 0.27940238, 0.27935094, 0.27929947, 0.27924791, 0.27919626, 0.27914459, 0.27909285, 0.27904099, 0.27898911, 0.27893713, 0.27888513, 0.27883306, 0.27878091, 0.27872866, 0.27867639, 0.278624, 0.27857161, 0.27851909, 0.27846655, 0.27841392, 0.27836126, 0.27830848, 0.27825564, 0.27820277, 0.27814981, 0.2780968, 0.27804372, 0.27799055, 0.27793735, 0.27788404, 0.27783069, 0.27777728, 0.27772379, 0.27767026, 0.27761662, 0.27756295, 0.27750918, 0.27745536, 0.27740148, 0.27734751, 0.27729347, 0.27723941, 0.27718526, 0.27713105, 0.27707675, 0.27702242, 0.276968, 0.27691349, 0.27685896, 0.27680436, 0.27674967, 0.27669492, 0.27664012, 0.27658525, 0.27653027, 0.27647525, 0.27642018, 0.27636501, 0.27630979, 0.2762545, 0.27619916, 0.27614376, 0.27608827, 0.27603275, 0.27597713, 0.27592143, 0.27586567, 0.27580988, 0.275754, 0.27569804, 0.27564204, 0.27558595, 0.27552983, 0.27547359, 0.2754173, 0.27536097, 0.27530459, 0.27524808, 0.27519155, 0.27513492, 0.27507824, 0.27502149, 0.27496466, 0.27490783, 0.27485085, 0.27479386, 0.27473679, 0.27467963, 0.27462241, 0.27456516, 0.27450782, 0.27445042, 0.27439293, 0.27433538, 0.27427778, 0.27422011, 0.27416235, 0.27410454, 0.27404669, 0.27398875, 0.2739307, 0.27387264, 0.2738145, 0.2737563, 0.273698, 0.27363968, 0.27358127, 0.27352279, 0.27346426, 0.27340567, 0.27334696, 0.27328822, 0.27322945, 0.27317059, 0.27311161, 0.27305263, 0.27299353, 0.27293441, 0.27287522, 0.27281594, 0.27275658, 0.27269721, 0.27263772, 0.27257818, 0.27251858, 0.27245891, 0.27239919, 0.27233937, 0.2722795, 0.27221957, 0.27215955, 0.27209947, 0.27203932, 0.27197915, 0.27191886, 0.27185854, 0.27179813, 0.27173766, 0.27167714, 0.27161655, 0.27155587, 0.27149513, 0.27143434, 0.27137348, 0.27131253, 0.27125153, 0.27119043, 0.27112934, 0.27106813, 0.27100688, 0.27094555, 0.27088413, 0.27082267, 0.27076113, 0.27069953, 0.27063787, 0.27057615, 0.27051434, 0.27045247, 0.27039054, 0.27032855, 0.2702665, 0.27020437, 0.27014217, 0.27007988, 0.27001756, 0.26995516, 0.26989269, 0.26983017, 0.26976755, 0.26970491, 0.26964217, 0.26957938, 0.26951653, 0.26945361, 0.26939061, 0.26932755, 0.26926443, 0.26920122, 0.26913795, 0.26907465, 0.26901123, 0.26894778, 0.26888424, 0.26882067, 0.26875699, 0.26869327, 0.26862949, 0.26856562, 0.2685017, 0.26843771, 0.26837364, 0.2683095, 0.26824531, 0.26818109, 0.26811674, 0.26805237, 0.26798788, 0.26792336, 0.26785877, 0.2677941, 0.26772937, 0.26766461, 0.26759976, 0.26753482, 0.26746982, 0.26740476, 0.26733965, 0.26727447, 0.2672092, 0.26714391, 0.26707849, 0.26701304, 0.26694751, 0.26688194, 0.26681626, 0.26675054, 0.26668477, 0.26661891, 0.26655298, 0.266487, 0.26642096, 0.2663548, 0.26628864, 0.26622239, 0.26615608, 0.26608968, 0.26602322, 0.26595673, 0.26589015, 0.26582345, 0.26575676, 0.26568997, 0.26562312, 0.26555622, 0.26548922, 0.2654222, 0.26535505, 0.26528788, 0.26522061, 0.26515332, 0.26508591, 0.26501846, 0.26495093, 0.26488337, 0.26481572, 0.26474798, 0.26468021, 0.26461235, 0.26454446, 0.26447648, 0.26440841, 0.26434031, 0.26427209, 0.26420388, 0.26413557, 0.26406717, 0.26399872, 0.26393023, 0.26386163, 0.26379299, 0.26372427, 0.26365548, 0.26358664, 0.26351774, 0.26344875, 0.26337969, 0.26331061, 0.26324141, 0.26317218, 0.26310283, 0.26303348, 0.26296404, 0.26289454, 0.26282495, 0.2627553, 0.2626856, 0.2626158, 0.26254597, 0.26247606, 0.26240608, 0.26233605, 0.26226592, 0.26219577, 0.26212552, 0.26205519, 0.26198483, 0.26191437, 0.26184389, 0.26177329, 0.26170266, 0.26163194, 0.26156119, 0.26149035, 0.26141942, 0.26134846, 0.26127741, 0.2612063, 0.26113513, 0.26106387, 0.26099259, 0.26092121, 0.26084977, 0.26077825, 0.26070669, 0.26063505, 0.26056334, 0.26049155, 0.26041976, 0.26034781, 0.26027584, 0.26020381, 0.26013172, 0.26005954, 0.25998732, 0.25991499, 0.25984263, 0.25977018, 0.25969768, 0.25962511, 0.25955248, 0.25947976, 0.25940698, 0.25933418, 0.25926125, 0.25918829, 0.25911525, 0.25904217, 0.25896898, 0.25889575, 0.25882244, 0.25874907, 0.25867563, 0.25860214, 0.25852856, 0.25845495, 0.25838125, 0.25830746, 0.25823367, 0.25815976, 0.25808579, 0.25801173, 0.25793764, 0.25786346, 0.25778922, 0.25771496, 0.2576406, 0.25756615, 0.25749165, 0.25741708, 0.25734246, 0.25726774, 0.257193, 0.25711814, 0.25704324, 0.25696829, 0.25689325, 0.25681818, 0.25674301, 0.25666779, 0.25659248, 0.25651714, 0.25644171, 0.25636619, 0.25629061, 0.25621501, 0.25613931, 0.25606355, 0.2559877, 0.25591183, 0.25583586, 0.25575984, 0.25568375, 0.25560758, 0.25553134, 0.25545505, 0.25537869, 0.25530225, 0.25522578, 0.25514922, 0.25507259, 0.25499588, 0.25491911, 0.25484231, 0.25476539, 0.25468844, 0.25461143, 0.25453433, 0.25445718, 0.25437996, 0.25430268, 0.25422528, 0.25414789, 0.25407037, 0.25399283, 0.25391522, 0.25383753, 0.25375977, 0.25368193, 0.25360405, 0.25352609, 0.25344807, 0.25336999, 0.25329185, 0.25321361, 0.25313532, 0.25305697, 0.25297853, 0.25290006, 0.25282151, 0.25274289, 0.25266418, 0.25258544, 0.25250661, 0.25242773, 0.25234878, 0.25226974, 0.25219068, 0.25211149, 0.25203228, 0.25195301, 0.25187364, 0.25179425, 0.25171477, 0.25163519, 0.25155559, 0.2514759, 0.25139615, 0.25131634, 0.25123644, 0.25115648, 0.25107649, 0.25099638, 0.25091624, 0.25083601, 0.25075573, 0.25067538, 0.25059497, 0.25051448, 0.25043395, 0.25035331, 0.25027263, 0.2501919, 0.25011107, 0.25003019, 0.24994925, 0.24986821, 0.24978714, 0.249706, 0.24962479, 0.24954352, 0.24946217, 0.24938074, 0.24929927, 0.24921772, 0.24913611, 0.24905443, 0.24897267, 0.24889085, 0.24880898, 0.24872705, 0.24864502, 0.24856293, 0.24848081, 0.24839859, 0.24831632, 0.24823397, 0.24815156, 0.24806908, 0.24798654, 0.24790391, 0.24782126, 0.2477385, 0.24765569, 0.24757279, 0.24748987, 0.24740686, 0.24732378, 0.24724063, 0.24715742, 0.24707416, 0.2469908, 0.2469074, 0.24682392, 0.2467404, 0.24665678, 0.24657311, 0.24648938, 0.24640556, 0.24632168, 0.24623774, 0.24615374, 0.24606967, 0.24598552, 0.24590133, 0.24581704, 0.24573269, 0.24564829, 0.24556382, 0.24547929, 0.24539468, 0.24531002, 0.24522527, 0.24514046, 0.2450556, 0.24497065, 0.24488565, 0.24480057, 0.24471545, 0.24463023, 0.24454495, 0.24445961, 0.24437422, 0.24428874, 0.24420321, 0.24411762, 0.24403197, 0.24394621, 0.24386039, 0.24377453, 0.24368858, 0.2436026, 0.24351652, 0.24343041, 0.24334419, 0.24325792, 0.24317159, 0.24308519, 0.24299872, 0.24291219, 0.24282557, 0.2427389, 0.24265219, 0.24256536, 0.24247852, 0.24239159, 0.24230459, 0.24221754, 0.24213038, 0.2420432, 0.24195594, 0.2418686, 0.2417812, 0.24169372, 0.24160621, 0.2415186, 0.24143094, 0.2413432, 0.24125542, 0.24116755, 0.24107963, 0.24099161, 0.24090354, 0.24081543, 0.24072722, 0.24063897, 0.24055065, 0.24046224, 0.24037378, 0.24028526, 0.24019666, 0.240108, 0.24001926, 0.23993047, 0.23984161, 0.23975268, 0.23966369, 0.23957461, 0.23948552, 0.2393963, 0.23930703, 0.23921773, 0.23912832, 0.23903885, 0.23894933, 0.23885974, 0.2387701, 0.23868036, 0.23859058, 0.23850073, 0.2384108, 0.2383208, 0.23823074, 0.23814063, 0.2380504, 0.23796016, 0.23786984, 0.23777945, 0.237689, 0.23759846, 0.23750788, 0.23741724, 0.2373265, 0.23723571, 0.23714484, 0.23705395, 0.23696293, 0.23687188, 0.23678076, 0.23668957, 0.23659833, 0.23650701, 0.23641559, 0.23632416, 0.23623264, 0.23614106, 0.23604938, 0.23595767, 0.23586588, 0.23577404, 0.23568213, 0.23559012, 0.23549807, 0.23540595, 0.23531376, 0.23522152, 0.23512919, 0.23503681, 0.23494434, 0.23485184, 0.23475926, 0.23466662, 0.23457389, 0.23448113, 0.23438825, 0.23429534, 0.23420234, 0.23410931, 0.23401618, 0.233923, 0.23382977, 0.23373644, 0.23364304, 0.23354959, 0.23345609, 0.23336251, 0.23326884, 0.23317514, 0.23308136, 0.23298749, 0.23289359, 0.23279962, 0.23270556, 0.23261145, 0.23251727, 0.23242304, 0.2323287, 0.23223431, 0.23213987, 0.23204535, 0.23195079, 0.23185614, 0.23176143, 0.23166664, 0.23157179, 0.23147689, 0.23138189, 0.23128687, 0.23119177, 0.23109657, 0.23100133, 0.23090602, 0.23081066, 0.2307152, 0.23061968, 0.23052412, 0.23042844, 0.23033275, 0.23023699, 0.23014113, 0.23004524, 0.22994925, 0.22985321, 0.2297571, 0.22966091, 0.22956468, 0.22946838, 0.22937199, 0.22927555, 0.22917904, 0.22908248, 0.22898583, 0.22888914, 0.22879235, 0.22869551, 0.22859861, 0.22850163, 0.22840458, 0.2283075, 0.2282103, 0.22811309, 0.22801578, 0.2279184, 0.22782096, 0.22772345, 0.22762589, 0.22752824, 0.22743052, 0.22733276, 0.22723491, 0.22713704, 0.22703905, 0.22694099, 0.2268429, 0.22674474, 0.22664651, 0.22654819, 0.22644983, 0.22635138, 0.22625288, 0.22615433, 0.22605571, 0.22595701, 0.22585821, 0.22575939, 0.22566049, 0.22556151, 0.22546247, 0.22536339, 0.22526419, 0.22516496, 0.22506566, 0.2249663, 0.22486685, 0.22476739, 0.2246678, 0.22456817, 0.22446847, 0.22436716, 0.22426425, 0.22416131, 0.22405842, 0.2239555, 0.22385257, 0.22374964, 0.22364669, 0.22354373, 0.22344078, 0.22333784, 0.22323486, 0.22313191, 0.22302896, 0.22292598, 0.22282298, 0.22271998, 0.22261702, 0.222514, 0.22241099, 0.22230801, 0.22220501, 0.222102, 0.22199894, 0.22189592, 0.22179289, 0.22168988, 0.22158682, 0.22148378, 0.22138074, 0.22127768, 0.2211746, 0.22107154, 0.22096847, 0.22086538, 0.22076231, 0.22065923, 0.22055614, 0.22045302, 0.22034992, 0.22024684, 0.22014372, 0.22004059, 0.21993746, 0.21983434, 0.21973121, 0.21962808, 0.21952491, 0.21942179, 0.21931863, 0.21921548, 0.21911232, 0.21900913, 0.21890597, 0.21880278, 0.2186996, 0.21859641, 0.21849324, 0.21839003, 0.21828683, 0.21818361, 0.2180804, 0.21797717, 0.21787395, 0.21777071, 0.21766749, 0.21756424, 0.21746102, 0.21735775, 0.2172545, 0.21715124, 0.21704797, 0.21694471, 0.21684144, 0.21673815, 0.21663487, 0.21653157, 0.21642828, 0.21632499, 0.21622168, 0.21611837, 0.21601504, 0.21591173, 0.21580841, 0.21570507, 0.21560173, 0.2154984, 0.21539506, 0.21529169, 0.21518835, 0.21508498, 0.2149816, 0.21487828, 0.21477488, 0.21467149, 0.21456812, 0.21446472, 0.21436131, 0.21425793, 0.21415451, 0.21405111, 0.21394767, 0.21384428, 0.21374084, 0.2136374, 0.21353395, 0.21343051, 0.21332707, 0.21322364, 0.21312016, 0.21301669, 0.21291323, 0.21280977, 0.21270628, 0.21260281, 0.21249929, 0.21239583, 0.21229231, 0.21218881, 0.21208529, 0.21198182, 0.21187827, 0.21177474, 0.21167122, 0.2115677, 0.21146415, 0.2113606, 0.21125707, 0.21115351, 0.21104994, 0.21094638, 0.21084282, 0.21073924, 0.21063565, 0.21053208, 0.21042848, 0.21032488, 0.21022129, 0.21011767, 0.21001408, 0.20991045, 0.20980686, 0.20970321, 0.2095996, 0.20949595, 0.20939231, 0.20928867, 0.20918502, 0.20908137, 0.2089777, 0.20887403, 0.20877038, 0.2086667, 0.208563, 0.20845932, 0.20835564, 0.20825194, 0.20814824, 0.20804453, 0.20794083, 0.20783709, 0.20773338, 0.20762964, 0.20752591, 0.20742218, 0.20731844, 0.20721468, 0.20711094, 0.20700717, 0.20690343, 0.20679966, 0.20669588, 0.2065921, 0.20648831, 0.20638452, 0.20628074, 0.20617694, 0.20607315, 0.20596932, 0.20586553, 0.2057617, 0.20565788, 0.20555405, 0.20545022, 0.20534639, 0.20524253, 0.2051387, 0.20503485, 0.20493099, 0.20482713, 0.20472324, 0.20461936, 0.2045155, 0.20441161, 0.20430773, 0.20420381, 0.20409994, 0.20399602, 0.20389211, 0.20378819, 0.2036843, 0.20358036, 0.20347644, 0.20337249, 0.20326854, 0.20316459, 0.20306066, 0.20295669, 0.20285274, 0.20274876, 0.20264481, 0.20254081, 0.20243685, 0.20233285, 0.20222887, 0.20212486, 0.20202088, 0.20191686, 0.20181288, 0.20170885, 0.20160483, 0.2015008, 0.20139678, 0.20129272, 0.2011887, 0.20108466, 0.20098057, 0.20087655, 0.20077248, 0.20066839, 0.20056434, 0.20046028, 0.20035619, 0.2002521, 0.20014799, 0.20004392, 0.1999398, 0.1998357, 0.19973157, 0.19962747, 0.19952334, 0.19941922, 0.19931509, 0.19921096, 0.19910678, 0.19900265, 0.19889851, 0.19879435, 0.19869019, 0.19858602, 0.19848184, 0.19837768, 0.19827348, 0.19816929, 0.1980651, 0.1979609, 0.19785669, 0.19775248, 0.19764826, 0.19754405, 0.1974398, 0.1973356, 0.19723137, 0.19712712, 0.19702289, 0.19691865, 0.19681437, 0.19671009, 0.19660585, 0.19650158, 0.1963973, 0.19629303, 0.19618875, 0.19608445, 0.19598016, 0.19587585, 0.19577157, 0.19566724, 0.19556294, 0.19545859, 0.19535428, 0.19524993, 0.19514562, 0.19504127, 0.19493693, 0.19483258, 0.19472823, 0.19462386, 0.19451949, 0.19441511, 0.19431077, 0.19420636, 0.19410199, 0.19399759, 0.19389319, 0.19378878, 0.19368438, 0.19357996, 0.19347554, 0.19337112, 0.19326672, 0.19316226, 0.19305782, 0.19295341, 0.19284895, 0.19274449, 0.19264004, 0.19253558, 0.19243112, 0.19232662, 0.19222216, 0.19211769, 0.19201317, 0.1919087, 0.1918042, 0.1916997, 0.19159518, 0.19149068, 0.19138615, 0.19128162, 0.19117709, 0.19107258, 0.19096804, 0.19086351, 0.19075894, 0.19065437, 0.19054982, 0.19044527, 0.19034067, 0.19023611, 0.19013155, 0.19002695, 0.18992238, 0.18981777, 0.18971315, 0.18960857, 0.18950395, 0.18939935, 0.18929471, 0.18919009, 0.18908545, 0.18898082, 0.18887618, 0.18877155, 0.1886669, 0.18856223, 0.18845756, 0.1883529, 0.18824823, 0.18814357, 0.18803886, 0.1879342, 0.18782951, 0.1877248, 0.18762012, 0.18751541, 0.18741071, 0.18730597, 0.18720126, 0.18709655, 0.1869918, 0.18688706, 0.18678233, 0.18667758, 0.18657282, 0.18646805, 0.18636331, 0.18625854, 0.18615375, 0.18604897, 0.18594421, 0.18583941, 0.18573463, 0.18562983, 0.18552503, 0.18542022, 0.18531539, 0.18521057, 0.18510576, 0.18500091, 0.1848961, 0.18479127, 0.18468641, 0.18458158, 0.18447672, 0.18437184, 0.18426698, 0.18416214, 0.18405725, 0.18395236, 0.1838475, 0.18374261, 0.18363772, 0.18353279, 0.1834279, 0.18332298, 0.18321808, 0.18311316, 0.18300822, 0.1829033, 0.18279837, 0.18269341, 0.18258849, 0.18248355, 0.18237859, 0.18227363, 0.18216865, 0.18206371, 0.18195871, 0.18185374, 0.18174875, 0.18164374, 0.18153876, 0.18143375, 0.18132874, 0.18122375, 0.18111871, 0.18101372, 0.18090868, 0.18080364, 0.1806986, 0.18059358, 0.18048853, 0.18038347, 0.18027839, 0.18017337, 0.18006828, 0.17996322, 0.17985815, 0.17975305, 0.17964797, 0.1795429, 0.17943779, 0.17933267, 0.17922758, 0.17912246, 0.17901736, 0.17891221, 0.17880709, 0.17870197, 0.17859682, 0.1784917, 0.17838654, 0.17828137, 0.17817624, 0.17807107, 0.17796588, 0.17786071, 0.17775555, 0.17765035, 0.17754516, 0.17743999, 0.17733477, 0.17722957, 0.17712437, 0.17701916, 0.17691395, 0.17680871, 0.1767035, 0.17659825, 0.176493, 0.17638776, 0.17628253, 0.17617725, 0.176072, 0.17596672, 0.17586146, 0.17575619, 0.17565091, 0.17554563, 0.17544034, 0.17533503, 0.17522973, 0.17512444, 0.17501913, 0.17491381, 0.1748085, 0.17470315, 0.17459781, 0.17449249, 0.17438714, 0.17428181, 0.17417644, 0.17407109, 0.17396574, 0.17386037, 0.17375501, 0.17364964, 0.17354424, 0.17343889, 0.1733335, 0.17322809, 0.17312266, 0.17301726, 0.17291187, 0.17280643, 0.172701, 0.17259561, 0.17249015, 0.17238474, 0.17227928, 0.17217384, 0.17206837, 0.17196293, 0.17185746, 0.17175199, 0.17164651, 0.17154106, 0.17143555, 0.17133006, 0.17122458, 0.17111908, 0.17101356, 0.17090806, 0.17080253, 0.17069703, 0.17059152, 0.17048599, 0.17038046, 0.1702749, 0.17016935, 0.17006381, 0.16995825, 0.16985269, 0.16974714, 0.16964157, 0.16953599, 0.1694304, 0.16932483, 0.16921924, 0.16911365, 0.16900805, 0.16890246, 0.16879684, 0.16869123, 0.1685856, 0.16847998, 0.16837434, 0.16826874, 0.16816309, 0.16805744, 0.16795175, 0.16784611, 0.16774045, 0.1676348, 0.16752912, 0.16742347, 0.16731778, 0.1672121, 0.16710639, 0.16700068, 0.166895, 0.16678928, 0.16668357, 0.16657785, 0.16647215, 0.16636643, 0.16626066, 0.16615495, 0.16604918, 0.16594346, 0.16583771, 0.16573195, 0.16562618, 0.16552041, 0.16541463, 0.16530886, 0.16520306, 0.1650973, 0.1649915, 0.1648857, 0.1647799, 0.16467407, 0.16456829, 0.16446245, 0.16435666, 0.16425081, 0.16414499, 0.16403915, 0.16393331, 0.16382745, 0.16372161, 0.16361573, 0.16350988, 0.163404, 0.16329813, 0.16319226, 0.16308637, 0.16298048, 0.16287459, 0.16276869, 0.16266279, 0.16255689, 0.16245097, 0.16234505, 0.16223913, 0.16213317, 0.16202727, 0.16192132, 0.16181539, 0.16170941, 0.16160348, 0.1614975, 0.16139154, 0.16128556, 0.16117957, 0.1610736, 0.16096763, 0.16086166, 0.16075563, 0.16064963, 0.16054364, 0.1604376, 0.16033164, 0.16022559, 0.16011955, 0.16001353, 0.15990749, 0.15980147, 0.15969542, 0.15958937, 0.15948333, 0.15937725, 0.1592712, 0.15916511, 0.15905903, 0.15895297, 0.15884686, 0.15874077, 0.15863466, 0.15852857, 0.15842246, 0.15831636, 0.15821022, 0.15810414, 0.15799798, 0.15789184, 0.1577857, 0.15767959, 0.15757343, 0.15746728, 0.15736112, 0.15725496, 0.15714876, 0.15704261, 0.15693642, 0.15683022, 0.15672405, 0.15661788, 0.15651165, 0.15640546, 0.15629926, 0.15619303, 0.15608682, 0.15598062, 0.15587436, 0.15576813, 0.1556619, 0.15555564, 0.15544941, 0.15534315, 0.15523688, 0.15513062, 0.15502435, 0.15491809, 0.15481181, 0.15470552, 0.15459923, 0.15449291, 0.15438664, 0.15428032, 0.15417401, 0.1540677, 0.15396138, 0.15385504, 0.15374875, 0.15364237, 0.15353604, 0.1534297, 0.15332335, 0.15321699, 0.15311064, 0.15300426, 0.15289789, 0.1527915, 0.15268515, 0.15257874, 0.15247235, 0.15236595, 0.15225956, 0.15215315, 0.15204674, 0.1519403, 0.15183391, 0.15172747, 0.15162104, 0.15151459, 0.15140817, 0.15130173, 0.15119526, 0.15108882, 0.15098234, 0.15087587, 0.15076941, 0.15066293, 0.15055643, 0.15044998, 0.15034346, 0.15023696, 0.15013047, 0.15002395, 0.14991744, 0.14981094, 0.1497044, 0.14959788, 0.14949133, 0.14938481, 0.14927825, 0.14917171, 0.14906515, 0.14895859, 0.14885202, 0.14874546, 0.14863887, 0.14853232, 0.14842573, 0.14831914, 0.14821252, 0.14810593, 0.14799933, 0.14789273, 0.14778611, 0.14767949, 0.14757286, 0.14746624, 0.14735959, 0.14725295, 0.1471463, 0.14703967, 0.14693302, 0.14682636, 0.14671968, 0.14661302, 0.14650632, 0.14639968, 0.14629297, 0.14618628, 0.14607958, 0.14597288, 0.14586617, 0.14575946, 0.14565276, 0.14554603, 0.14543931, 0.14533256, 0.14522585, 0.14511909, 0.14501235, 0.1449056, 0.14479883, 0.14469208, 0.14458531, 0.14447853, 0.14437176, 0.14426497, 0.1441582, 0.1440514, 0.14394459, 0.14383779, 0.143731, 0.14362417, 0.14351736, 0.14341053, 0.14330372, 0.14319688, 0.14309005, 0.14298318, 0.14287634, 0.14276949, 0.14266263, 0.14255576, 0.1424489, 0.142342, 0.14223516, 0.14212826, 0.14202137, 0.14191449, 0.14180757, 0.14170067, 0.14159377, 0.14148685, 0.14137994, 0.14127299, 0.14116609, 0.14105916, 0.1409522, 0.14084527, 0.14073831, 0.14063136, 0.14052439, 0.14041744, 0.14031047, 0.14020349, 0.14009652, 0.13998953, 0.13988253, 0.13977554, 0.13966854, 0.13956153, 0.13945451, 0.13934751, 0.13924049, 0.13913345, 0.13902642, 0.1389194, 0.13881235, 0.1387053, 0.13859825, 0.1384912, 0.13838413, 0.13827707, 0.13817, 0.13806292, 0.13795583, 0.13784876, 0.13774166, 0.13763456, 0.13752747, 0.13742034, 0.13731323, 0.13720612, 0.137099, 0.13699189, 0.13688472, 0.13677761, 0.13667046, 0.1365633, 0.13645616, 0.13634899, 0.13624184, 0.13613465, 0.13602751, 0.13592033, 0.13581313, 0.13570593, 0.13559876, 0.13549155, 0.13538437, 0.13527714, 0.13516994, 0.13506271, 0.1349555, 0.13484827, 0.13474104, 0.13463376, 0.13452655, 0.13441929, 0.13431203, 0.13420478, 0.13409752, 0.13399024, 0.13388297, 0.1337757, 0.13366841, 0.13356109, 0.13345383, 0.13334651, 0.13323921, 0.13313191, 0.13302459, 0.13291727, 0.13280995, 0.1327026, 0.13259529, 0.13248792, 0.13238059, 0.13227323, 0.13216588, 0.13205852, 0.13195115, 0.13184379, 0.13173641, 0.13162903, 0.13152166, 0.13141425, 0.13130686, 0.13119946, 0.13109204, 0.13098463, 0.13087723, 0.1307698, 0.13066237, 0.13055494, 0.13044751, 0.13034007, 0.1302326, 0.13012516, 0.1300177, 0.12991023, 0.12980276, 0.1296953, 0.12958781, 0.12948035, 0.12937284, 0.12926537, 0.12915786, 0.12905037, 0.12894285, 0.12883534, 0.12872782, 0.1286203, 0.12851277, 0.12840523, 0.12829767, 0.12819016, 0.1280826, 0.12797505, 0.12786749, 0.12775992, 0.12765236, 0.12754478, 0.1274372, 0.12732962, 0.12722202, 0.12711444, 0.12700684, 0.12689921, 0.12679163, 0.12668401, 0.12657639, 0.12646876, 0.12636113, 0.1262535, 0.12614585, 0.12603821, 0.12593056, 0.1258229, 0.12571526, 0.12560758, 0.1254999, 0.12539223, 0.12528457, 0.12517688, 0.12506917, 0.12496147, 0.1248538, 0.12474607, 0.12463836, 0.12453064, 0.12442292, 0.12431519, 0.12420747, 0.12409973, 0.12399199, 0.12388422, 0.1237765, 0.12366872, 0.12356097, 0.1234532, 0.12334544, 0.12323765, 0.12312987, 0.12302206, 0.12291431, 0.12280649, 0.12269869, 0.12259087, 0.12248307, 0.12237526, 0.12226743, 0.12215961, 0.12205176, 0.12194394, 0.12183609, 0.12172826, 0.12162038, 0.12151255, 0.12140467, 0.1212968, 0.12118892, 0.12108104, 0.12097316, 0.12086527, 0.12075738, 0.12064949, 0.12054157, 0.12043368, 0.12032576, 0.12021784, 0.1201099, 0.12000197, 0.11989405, 0.11978611, 0.11967815, 0.11957023, 0.11946225, 0.11935431, 0.11924633, 0.11913835, 0.11903039, 0.11892888, 0.11883382, 0.11873879, 0.1186438, 0.11854888, 0.11845394, 0.11835907, 0.11826424, 0.11816943, 0.11807467, 0.11797994, 0.11788523, 0.1177906, 0.11769596, 0.1176014, 0.11750686, 0.11741234, 0.11731789, 0.11722343, 0.11712903, 0.11703467, 0.11694036, 0.11684606, 0.11675183, 0.11665759, 0.11656343, 0.11646928, 0.11637519, 0.11628111, 0.1161871, 0.11609311, 0.11599915, 0.11590524, 0.11581134, 0.11571749, 0.1156237, 0.11552992, 0.11543618, 0.1153425, 0.11524883, 0.11515522, 0.11506162, 0.11496808, 0.11487457, 0.11478108, 0.11468765, 0.11459426, 0.11450088, 0.11440755, 0.11431425, 0.11422101, 0.11412781, 0.1140346, 0.11394148, 0.11384835, 0.11375528, 0.11366226, 0.11356927, 0.11347631, 0.11338337, 0.11329049, 0.11319764, 0.11310482, 0.11301204, 0.11291932, 0.11282662, 0.11273397, 0.11264131, 0.11254874, 0.11245616, 0.11236367, 0.11227119, 0.11217874, 0.11208633, 0.11199395, 0.11190161, 0.11180934, 0.11171705, 0.11162483, 0.11153264, 0.11144051, 0.11134839, 0.11125633, 0.11116427, 0.11107229, 0.11098032, 0.1108884, 0.1107965, 0.11070462, 0.11061284, 0.11052105, 0.11042928, 0.11033759, 0.11024592, 0.11015429, 0.11006269, 0.10997114, 0.10987961, 0.10978813, 0.10969668, 0.10960527, 0.10951391, 0.10942255, 0.10933126, 0.10924, 0.10914876, 0.10905757, 0.10896644, 0.10887529, 0.10878423, 0.10869318, 0.10860217, 0.10851119, 0.10842028, 0.10832937, 0.10823853, 0.10814767, 0.10805691, 0.10796615, 0.10787545, 0.10778476, 0.10769414, 0.10760352, 0.10751296, 0.10742243, 0.10733195, 0.1072415, 0.10715107, 0.10706069, 0.10697037, 0.10688004, 0.10678977, 0.10669953, 0.10660935, 0.10651917, 0.10642906, 0.10633898, 0.10624893, 0.1061589, 0.10606894, 0.105979, 0.1058891, 0.10579921, 0.10570943, 0.10561963, 0.10552987, 0.10544015, 0.10535046, 0.10526085, 0.10517121, 0.10508166, 0.10499212, 0.10490262, 0.10481317, 0.10472376, 0.10463434, 0.10454502, 0.1044557, 0.10436643, 0.10427718, 0.10418798, 0.10409882, 0.10400971, 0.10392062, 0.10383156, 0.10374253, 0.10365357, 0.10356461, 0.1034757, 0.10338683, 0.10329802, 0.10320921, 0.10312045, 0.10303172, 0.10294304, 0.10285439, 0.1027658, 0.1026772, 0.10258868, 0.10250016, 0.1024117, 0.10232329, 0.1022349, 0.10214652, 0.10205822, 0.10196994, 0.10188168, 0.10179349, 0.10170531, 0.10161719, 0.10152909, 0.10144103, 0.10135302, 0.10126504, 0.10117707, 0.10108918, 0.10100131, 0.10091347, 0.10082567, 0.10073788, 0.10065017, 0.10056248, 0.10047481, 0.10038722, 0.10029963, 0.10021208, 0.10012458, 0.10003713, 0.09994968, 0.099862292, 0.099774942, 0.099687614, 0.099600337, 0.099513076, 0.099425845, 0.09933871, 0.099251546, 0.099164441, 0.099077389, 0.098990366, 0.098903373, 0.098816432, 0.098729491, 0.098642647, 0.098555759, 0.098468989, 0.098382212, 0.098295465, 0.098208793, 0.098122135, 0.098035492, 0.097948924, 0.09786237, 0.097775869, 0.097689398, 0.097602956, 0.097516552, 0.097430184, 0.097343877, 0.097257562, 0.097171322, 0.097085096, 0.09699893, 0.096912779, 0.096826687, 0.096740611, 0.096654579, 0.09656857, 0.096482627, 0.096396722, 0.096310817, 0.096224971, 0.096139148, 0.096053399, 0.095967643, 0.095881931, 0.095796302, 0.095710665, 0.095625058, 0.095539518, 0.095454, 0.095368534, 0.095283069, 0.095197663, 0.095112309, 0.095026992, 0.094941668, 0.094856426, 0.094771199, 0.094686039, 0.094600849, 0.094515763, 0.0944307, 0.094345659, 0.09426064, 0.094175681, 0.09409076, 0.094005883, 0.093921036, 0.093836218, 0.093751423, 0.093666703, 0.093581967, 0.093497306, 0.093412697, 0.093328089, 0.093243539, 0.093158998, 0.093074493, 0.092990093, 0.0929057, 0.092821278, 0.092736967, 0.092652671, 0.092568398, 0.092484161, 0.092399985, 0.092315845, 0.092231736, 0.092147626, 0.092063591, 0.091979593, 0.091895618, 0.091811672, 0.091727793, 0.091643944, 0.091560133, 0.091476336, 0.091392592, 0.091308884, 0.091225199, 0.091141552, 0.091057971, 0.090974405, 0.090890892, 0.090807386, 0.090723924, 0.090640523, 0.090557173, 0.090473786, 0.090390511, 0.090307236, 0.09022399, 0.090140812, 0.090057619, 0.089974545, 0.089891456, 0.089808404, 0.08972539, 0.089642428, 0.089559481, 0.0894766, 0.089393713, 0.089310899, 0.089228109, 0.08914534, 0.089062624, 0.088979959, 0.088897318, 0.088814728, 0.088732153, 0.088649608, 0.088567123, 0.08848466, 0.088402227, 0.08831986, 0.088237524, 0.088155217, 0.088072941, 0.087990694, 0.087908499, 0.087826341, 0.087744184, 0.087662116, 0.087580077, 0.087498054, 0.087416053, 0.087334141, 0.087252229, 0.087170385, 0.087088518, 0.087006748, 0.086925007, 0.086843282, 0.086761586, 0.086679935, 0.086598314, 0.08651676, 0.086435229, 0.086353734, 0.086272262, 0.086190827, 0.086109444, 0.086028092, 0.085946776, 0.085865512, 0.085784271, 0.085703045, 0.085621893, 0.085540779, 0.085459687, 0.085378595, 0.085297614, 0.085216597, 0.085135676, 0.085054725, 0.084973872, 0.084893055, 0.084812254, 0.084731475, 0.084650762, 0.084570065, 0.084489428, 0.084408812, 0.084328197, 0.084247701, 0.084167175, 0.084086709, 0.08400628, 0.083925888, 0.083845541, 0.083765209, 0.083684944, 0.083604679, 0.083524488, 0.083444282, 0.083364166, 0.083284058, 0.083204024, 0.083124012, 0.083043993, 0.082964055, 0.08288414, 0.082804255, 0.082724407, 0.082644612, 0.082564853, 0.082485124, 0.082405403, 0.082325742, 0.082246147, 0.08216659, 0.082086995, 0.082007512, 0.081928045, 0.081848621, 0.081769191, 0.081689827, 0.081610523, 0.081531242, 0.081451975, 0.08137276, 0.081293583, 0.08121445, 0.081135333, 0.081056267, 0.080977254, 0.08089827, 0.080819294, 0.080740385, 0.080661498, 0.080582649, 0.080503844, 0.080425076, 0.080346346, 0.080267653, 0.080188982, 0.080110334, 0.08003176, 0.079953216, 0.079874672, 0.079796232, 0.079717778, 0.07963939, 0.079561025, 0.079482667, 0.079404384, 0.079326145, 0.079247929, 0.079169735, 0.079091571, 0.079013467, 0.078935422, 0.078857377, 0.078779392, 0.078701422, 0.078623496, 0.0785456, 0.078467742, 0.078389928, 0.078312181, 0.078234404, 0.078156717, 0.07807906, 0.078001425, 0.077923819, 0.077846274, 0.07776875, 0.077691287, 0.077613845, 0.077536419, 0.077459052, 0.077381723, 0.077304415, 0.077227138, 0.077149935, 0.077072747, 0.076995589, 0.07691849, 0.076841407, 0.076764368, 0.076687343, 0.076610409, 0.076533459, 0.076456584, 0.076379716, 0.076302893, 0.076226108, 0.076149411, 0.076072678, 0.075996004, 0.075919367, 0.075842768, 0.075766213, 0.075689688, 0.075613201, 0.075536743, 0.075460337, 0.075383961, 0.075307615, 0.075231306, 0.07515505, 0.075078808, 0.075002626, 0.074926473, 0.074850336, 0.074774265, 0.074698225, 0.074622214, 0.074546255, 0.074470326, 0.074394412, 0.074318551, 0.074242741, 0.074166931, 0.074091189, 0.074015506, 0.073939815, 0.073864162, 0.073788561, 0.073712982, 0.073637471, 0.073561974, 0.073486507, 0.073411107, 0.073335722, 0.073260367, 0.073185079, 0.073109791, 0.07303457, 0.072959386, 0.072884187, 0.072809093, 0.072733983, 0.072658949, 0.072583944, 0.072508939, 0.07243403, 0.072359122, 0.072284237, 0.072209425, 0.072134644, 0.072059885, 0.071985155, 0.071910486, 0.071835853, 0.071761213, 0.071686625, 0.07161212, 0.071537614, 0.071463183, 0.071388729, 0.07131435, 0.07124, 0.071165696, 0.071091413, 0.071017183, 0.070942976, 0.070868798, 0.070794657, 0.070720598, 0.070646562, 0.070572503, 0.070498504, 0.070424572, 0.070350699, 0.070276812, 0.070202999, 0.070129156, 0.070055418, 0.069981694, 0.069908001, 0.069834389, 0.06976077, 0.069687173, 0.069613643, 0.069540143, 0.069466673, 0.069393247, 0.069319844, 0.069246486, 0.06917318, 0.069099903, 0.069026671, 0.068953454, 0.068880275, 0.068807155, 0.068734065, 0.068660982, 0.068587981, 0.068514951, 0.068442039, 0.068369083, 0.068296239, 0.068223424, 0.068150625, 0.06807781, 0.068005092, 0.067932405, 0.067859784, 0.067787156, 0.06771455, 0.067642018, 0.067569517, 0.06749703, 0.067424603, 0.067352235, 0.06727986, 0.06720753, 0.067135245, 0.067063004, 0.066990808, 0.066918604, 0.066846438, 0.066774361, 0.066702314, 0.066630267, 0.066558294, 0.066486321, 0.066414423, 0.066342555, 0.066270694, 0.0661989, 0.066127107, 0.06605538, 0.065983683, 0.065912016, 0.065840438, 0.06576883, 0.065697245, 0.065625757, 0.065554284, 0.06548284, 0.065411448, 0.065340102, 0.06526874, 0.065197453, 0.065126196, 0.06505499, 0.064983822, 0.064912684, 0.064841546, 0.064770482, 0.064699464, 0.064628482, 0.0645575, 0.064486556, 0.064415693, 0.064344861, 0.064274035, 0.064203262, 0.064132512, 0.064061821, 0.063991129, 0.063920513, 0.063849948, 0.063779406, 0.063708842, 0.063638374, 0.063567944, 0.063497551, 0.063427202, 0.063356854, 0.063286535, 0.063216269, 0.063146062, 0.063075863, 0.063005723, 0.062935621, 0.062865533, 0.062795475, 0.062725492, 0.062655553, 0.0625856, 0.062515683, 0.062445857, 0.06237606, 0.062306296, 0.062236533, 0.062166799, 0.062097143, 0.062027525, 0.061957903, 0.061888374, 0.061818868, 0.061749347, 0.061679885, 0.061610483, 0.061541118, 0.061471816, 0.06140247, 0.061333198, 0.06126399, 0.061194804, 0.06112564, 0.061056532, 0.060987443, 0.060918406, 0.060849395, 0.060780425, 0.060711507, 0.060642574, 0.060573716, 0.060504898, 0.060436137, 0.060367394, 0.0602987, 0.060229976, 0.060161356, 0.060092773, 0.060024224, 0.059955686, 0.059887171, 0.05981873, 0.059750322, 0.05968193, 0.059613589, 0.059545308, 0.059477009, 0.059408776, 0.059340581, 0.059272423, 0.059204321, 0.059136223, 0.059068162, 0.059000172, 0.058932211, 0.058864251, 0.058796354, 0.058728468, 0.058660671, 0.058592856, 0.058525119, 0.058457416, 0.058389708, 0.058322065, 0.058254454, 0.058186911, 0.058119401, 0.058051903, 0.057984404, 0.057916984, 0.057849616, 0.057782266, 0.057714976, 0.057647701, 0.057580445, 0.057513248, 0.057446089, 0.057378955, 0.05731187, 0.057244822, 0.05717779, 0.05711082, 0.057043891, 0.056976989, 0.056910113, 0.056843255, 0.056776479, 0.056709729, 0.056642998, 0.056576315, 0.056509648, 0.056443062, 0.056376457, 0.056309953, 0.056243461, 0.056177016, 0.056110539, 0.056044143, 0.055977818, 0.055911511, 0.055845212, 0.055778995, 0.055712774, 0.055646598, 0.05558046, 0.055514384, 0.055448327, 0.0553823, 0.055316303, 0.055250369, 0.05518445, 0.055118583, 0.05505275, 0.054986928, 0.054921184, 0.054855462, 0.054789763, 0.05472412, 0.05465848, 0.054592911, 0.054527346, 0.054461893, 0.054396424, 0.054330971, 0.054265562, 0.054200206, 0.054134909, 0.054069635, 0.054004401, 0.053939145, 0.053873975, 0.053808846, 0.053743757, 0.053678688, 0.053613666, 0.05354866, 0.053483717, 0.053418789, 0.053353939, 0.053289097, 0.053224266, 0.053159487, 0.053094778, 0.053030092, 0.052965436, 0.052900799, 0.05283621, 0.052771665, 0.052707165, 0.052642677, 0.052578259, 0.052513856, 0.052449491, 0.052385155, 0.052320864, 0.05225664, 0.052192435, 0.052128211, 0.052064095, 0.051999986, 0.051935922, 0.051871873, 0.051807892, 0.05174394, 0.051680017, 0.051616147, 0.051552285, 0.051488493, 0.051424686, 0.051360957, 0.051297277, 0.051233608, 0.051169995, 0.051106375, 0.051042825, 0.050979301, 0.050915845, 0.050852437, 0.050789006, 0.05072562, 0.050662287, 0.050598986, 0.050535738, 0.050472535, 0.050409365, 0.050346196, 0.050283089, 0.050220016, 0.050156981, 0.050094016, 0.050030988, 0.04996809, 0.049905207, 0.049842354, 0.049779534, 0.049716763, 0.049653996, 0.049591321, 0.049528647, 0.049466036, 0.04940344, 0.04934084, 0.04927833, 0.049215846, 0.049153425, 0.049091037, 0.049028635, 0.048966277, 0.048903983, 0.048841745, 0.048779529, 0.048717335, 0.048655156, 0.048593052, 0.048530985, 0.048468933, 0.048406929, 0.048345003, 0.048283033, 0.048221137, 0.048159294, 0.048097469, 0.048035685, 0.047973938, 0.047912203, 0.047850568, 0.047788933, 0.047727324, 0.047665786, 0.047604226, 0.047542751, 0.047481272, 0.047419891, 0.047358509, 0.047297161, 0.047235843, 0.047174588, 0.047113352, 0.04705219, 0.046991002, 0.046929874, 0.046868797, 0.04680777, 0.046746738, 0.046685785, 0.046624869, 0.046563949, 0.046503063, 0.046442255, 0.046381466, 0.046320736, 0.04626001, 0.046199314, 0.0461387, 0.046078101, 0.046017539, 0.04595698, 0.045896482, 0.04583602, 0.045775633, 0.045715239, 0.045654897, 0.045594569, 0.045534305, 0.04547406, 0.045413874, 0.045353737, 0.045293622, 0.045233481, 0.04517344, 0.045113452, 0.045053475, 0.044993516, 0.044933632, 0.044873752, 0.044813931, 0.044754118, 0.044694386, 0.044634655, 0.044574972, 0.044515301, 0.044455707, 0.044396143, 0.044336617, 0.044277098, 0.044217624, 0.04415822, 0.04409885, 0.044039495, 0.043980174, 0.043920886, 0.043861642, 0.043802436, 0.043743271, 0.04368417, 0.043625057, 0.043566007, 0.043506972, 0.043448005, 0.043389067, 0.043330174, 0.043271266, 0.043212444, 0.043153644, 0.0430949, 0.043036167, 0.042977467, 0.04291882, 0.042860217, 0.042801626, 0.042743091, 0.042684596, 0.04262612, 0.042567678, 0.042509284, 0.042450968, 0.042392638, 0.042334352, 0.042280823, 0.042232018, 0.042183243, 0.042134475, 0.042085782, 0.042037059, 0.041988425, 0.041939795, 0.041891221, 0.041842673, 0.041794192, 0.041745663, 0.041697238, 0.041648813, 0.041600469, 0.0415521, 0.041503817, 0.041455504, 0.041407298, 0.041359063, 0.041310918, 0.041262776, 0.041214656, 0.041166596, 0.04111857, 0.041070558, 0.041022614, 0.040974658, 0.040926758, 0.040878896, 0.040831078, 0.040783286, 0.040735535, 0.040687766, 0.040640082, 0.040592443, 0.040544815, 0.04049721, 0.040449686, 0.040402133, 0.04035465, 0.040307201, 0.040259793, 0.040212411, 0.040165044, 0.040117715, 0.040070448, 0.040023226, 0.039976012, 0.03992882, 0.039881658, 0.039834559, 0.039787479, 0.039740447, 0.039693452, 0.039646458, 0.039599508, 0.039552607, 0.039505746, 0.039458927, 0.039412126, 0.039365318, 0.039318603, 0.039271902, 0.03922525, 0.039178625, 0.039131988, 0.03908544, 0.039038934, 0.038992427, 0.038945973, 0.038899563, 0.038853142, 0.038806789, 0.038760468, 0.038714178, 0.038667951, 0.038621716, 0.038575519, 0.038529363, 0.038483266, 0.038437176, 0.038391139, 0.03834508, 0.038299121, 0.03825317, 0.038207274, 0.038161386, 0.038115542, 0.038069721, 0.038023956, 0.03797821, 0.037932523, 0.037886847, 0.037841171, 0.037795588, 0.037750032, 0.03770449, 0.037658997, 0.037613533, 0.037568074, 0.037522685, 0.037477322, 0.037432, 0.037386708, 0.037341453, 0.037296191, 0.037251018, 0.03720586, 0.037160736, 0.037115648, 0.037070587, 0.037025549, 0.036980581, 0.036935609, 0.03689073, 0.036845803, 0.036800973, 0.036756136, 0.036711376, 0.036666624, 0.036621921, 0.036577202, 0.036532573, 0.036487956, 0.036443405, 0.036398854, 0.036354367, 0.036309857, 0.036265433, 0.036221009, 0.036176655, 0.036132324, 0.036088001, 0.036043715, 0.035999507, 0.035955306, 0.035911154, 0.03586702, 0.035822906, 0.035778843, 0.035734817, 0.035690818, 0.035646867, 0.035602916, 0.035559036, 0.035515159, 0.035471361, 0.035427574, 0.035383821, 0.035340071, 0.035296395, 0.03525275, 0.035209142, 0.035165556, 0.035121985, 0.035078473, 0.035035007, 0.034991551, 0.034948155, 0.034904771, 0.034861416, 0.034818105, 0.034774832, 0.034731597, 0.034688409, 0.034645189, 0.034602068, 0.034558974, 0.034515914, 0.034472883, 0.034429871, 0.034386866, 0.034343962, 0.034301061, 0.034258194, 0.034215376, 0.034172557, 0.034129784, 0.034087073, 0.034044381, 0.034001749, 0.033959121, 0.033916496, 0.033873938, 0.033831436, 0.033788949, 0.033746488, 0.03370408, 0.033661671, 0.033619333, 0.033576995, 0.033534721, 0.033492498, 0.033450264, 0.033408053, 0.033365928, 0.033323821, 0.033281758, 0.033239692, 0.033197679, 0.033155706, 0.033113774, 0.033071876, 0.033030014, 0.032988127, 0.032946356, 0.032904584, 0.032862853, 0.032821141, 0.032779496, 0.032737851, 0.03269624, 0.032654684, 0.032613158, 0.032571673, 0.032530203, 0.032488748, 0.032447375, 0.032406032, 0.032364693, 0.032323416, 0.032282136, 0.032240931, 0.032199733, 0.032158587, 0.032117479, 0.03207637, 0.032035317, 0.031994294, 0.031953339, 0.031912394, 0.031871468, 0.031830579, 0.031789746, 0.031748932, 0.03170817, 0.031667411, 0.031626686, 0.031586025, 0.031545397, 0.031504765, 0.031464223, 0.031423707, 0.031383172, 0.031342693, 0.031302284, 0.031261876, 0.031221541, 0.031181172, 0.031140871, 0.031100616, 0.031060407, 0.031020189, 0.030980056, 0.030939896, 0.030899815, 0.030859742, 0.030819727, 0.030779749, 0.030739773, 0.030699847, 0.030659981, 0.030620124, 0.030580325, 0.030540539, 0.03050077, 0.030461058, 0.030421387, 0.030381728, 0.030342136, 0.030302558, 0.030262999, 0.030223483, 0.03018401, 0.03014457, 0.030105192, 0.030065797, 0.030026436, 0.029987141, 0.029947897, 0.02990865, 0.029869456, 0.02983026, 0.029791147, 0.02975205, 0.029712982, 0.029673954, 0.029634938, 0.029595977, 0.02955706, 0.029518163, 0.029479327, 0.029440494, 0.02940169, 0.029362904, 0.029324213, 0.029285522, 0.029246878, 0.029208254, 0.029169656, 0.029131111, 0.029092578, 0.029054113, 0.029015658, 0.028977243, 0.028938852, 0.028900513, 0.028862208, 0.028823948, 0.028785687, 0.02874746, 0.028709279, 0.028671179, 0.028633049, 0.02859498, 0.02855693, 0.028518939, 0.028480968, 0.028443044, 0.028405135, 0.02836729, 0.028329415, 0.028291648, 0.028253851, 0.028216152, 0.02817845, 0.028140781, 0.028103145, 0.028065572, 0.028028015, 0.027990505, 0.027952995, 0.027915535, 0.027878122, 0.027840739, 0.027803376, 0.027766075, 0.027728772, 0.027691519, 0.027654298, 0.027617138, 0.027579982, 0.027542887, 0.027505778, 0.02746873, 0.02743173, 0.027394751, 0.027357817, 0.027320897, 0.027284028, 0.027247205, 0.027210381, 0.027173638, 0.027136898, 0.027100151, 0.027063506, 0.027026875, 0.026990276, 0.026953727, 0.026917189, 0.02688067, 0.026844215, 0.026807778, 0.026771402, 0.026735041, 0.026698682, 0.026662419, 0.026626157, 0.026589939, 0.026553754, 0.026517604, 0.026481453, 0.026445394, 0.026409322, 0.026373331, 0.02633734, 0.026301377, 0.02626545, 0.026229603, 0.026193738, 0.026157938, 0.02612217, 0.026086399, 0.026050681, 0.026015023, 0.025979381, 0.025943788, 0.025908211, 0.025872665, 0.025837153, 0.025801687, 0.025766253, 0.025730867, 0.025695467, 0.025660146, 0.02562484, 0.025589598, 0.025554374, 0.025519162, 0.02548397, 0.025448872, 0.025413789, 0.025378723, 0.025343705, 0.025308687, 0.02527375, 0.025238825, 0.025203936, 0.025169095, 0.025134251, 0.025099458, 0.025064709, 0.025029995, 0.024995344, 0.024960678, 0.024926042, 0.024891457, 0.024856932, 0.024822425, 0.024787951, 0.024753507, 0.024719093, 0.024684716, 0.024650369, 0.024616068, 0.024581818, 0.024547549, 0.02451336, 0.024479171, 0.024445066, 0.024410972, 0.024376882, 0.024342837, 0.024308857, 0.024274893, 0.024240976, 0.024207059, 0.024173193, 0.024139371, 0.024105599, 0.024071826, 0.024038117, 0.024004439, 0.023970749, 0.023937119, 0.023903552, 0.023870006, 0.023836486, 0.023803003, 0.023769533, 0.023736127, 0.02370277, 0.023669396, 0.023636103, 0.023602793, 0.023569565, 0.023536349, 0.023503184, 0.023470052, 0.023436934, 0.023403846, 0.023370823, 0.023337804, 0.023304861, 0.023271916, 0.02323899, 0.023206111, 0.023173315, 0.023140501, 0.02310775, 0.023075014, 0.02304231, 0.023009641, 0.022977015, 0.022944428, 0.022911884, 0.02287934, 0.022846829, 0.02281438, 0.022781968, 0.022749601, 0.022717247, 0.022684898, 0.022652607, 0.022620369, 0.022588147, 0.022555972, 0.022523811, 0.022491697, 0.022459602, 0.022427568, 0.02239557, 0.022363601, 0.022331616, 0.022299713, 0.022267856, 0.022236031, 0.022204205, 0.022172399, 0.022140687, 0.022108989, 0.022077307, 0.022045691, 0.022014091, 0.021982506, 0.021951001, 0.02191948, 0.02188802, 0.021856613, 0.021825204, 0.021793826, 0.021762483, 0.021731215, 0.021699967, 0.021668732, 0.021637512, 0.021606375, 0.021575255, 0.021544179, 0.021513123, 0.021482078, 0.021451101, 0.021420155, 0.021389224, 0.021358375, 0.021327524, 0.021296673, 0.021265902, 0.021235164, 0.021204457, 0.021173799, 0.021143153, 0.021112526, 0.021081967, 0.02105142, 0.021020906, 0.020990467, 0.020959985, 0.020929582, 0.020899225, 0.020868903, 0.020838594, 0.02080835, 0.020778075, 0.020747896, 0.020717749, 0.020687614, 0.020657515, 0.020627448, 0.020597411, 0.020567456, 0.02053747, 0.020507559, 0.020477684, 0.020447806, 0.020417962, 0.020388197, 0.020358449, 0.020328764, 0.020299079, 0.020269394, 0.020239772, 0.020210216, 0.020180659, 0.020151149, 0.020121658, 0.020092228, 0.020062815, 0.020033434, 0.020004099, 0.019974781, 0.019945495, 0.019916276, 0.019887067, 0.019857911, 0.019828754, 0.019799644, 0.019770566, 0.019741552, 0.019712554, 0.019683586, 0.019654669, 0.019625768, 0.019596895, 0.019568073, 0.019539267, 0.019510539, 0.019481782, 0.019453101, 0.019424438, 0.019395839, 0.019367259, 0.019338707, 0.019310139, 0.019281683, 0.019253228, 0.019224821, 0.01919643, 0.01916807, 0.019139744, 0.019111479, 0.019083234, 0.019055033, 0.019026835, 0.018998696, 0.018970575, 0.01894252, 0.018914482, 0.018886473, 0.018858481, 0.018830568, 0.018802656, 0.018774776, 0.018746957, 0.018719159, 0.018691374, 0.018663635, 0.018635964, 0.018608276, 0.018580668, 0.018553058, 0.018525498, 0.018497951, 0.01847047, 0.018443022, 0.018415621, 0.018388186, 0.018360849, 0.018333511, 0.018306237, 0.018278996, 0.018251754, 0.018224562, 0.018197432, 0.018170301, 0.018143235, 0.0181162, 0.018089166, 0.018062182, 0.018035242, 0.018008336, 0.017981462, 0.017954618, 0.017927792, 0.017901029, 0.017874299, 0.017847601, 0.017820934, 0.017794266, 0.017767681, 0.01774111, 0.017714586, 0.017688079, 0.01766162, 0.017635161, 0.01760878, 0.017582402, 0.017556088, 0.017529804, 0.01750352, 0.017477283, 0.017451111, 0.017424956, 0.017398849, 0.017372757, 0.01734668, 0.017320652, 0.017294686, 0.01726874, 0.017242823, 0.017216923, 0.017191071, 0.017165249, 0.017139478, 0.017113738, 0.017088044, 0.017062336, 0.017036691, 0.017011076, 0.016985528, 0.01695998, 0.016934447, 0.016908977, 0.016883556, 0.016858134, 0.016832793, 0.016807452, 0.016782142, 0.016756849, 0.016731651, 0.016706437, 0.016681302, 0.016656138, 0.016631052, 0.016605981, 0.016580975, 0.016555985, 0.016531026, 0.016506068, 0.016481191, 0.016456345, 0.016431514, 0.01640673, 0.016381996, 0.016357245, 0.016332557, 0.016307903, 0.016283298, 0.016258722, 0.016234163, 0.016209636, 0.016185174, 0.016160741, 0.016136326, 0.016111942, 0.01608756, 0.016063288, 0.016039018, 0.01601476, 0.015990553, 0.015966378, 0.015942233, 0.015918138, 0.015894074, 0.01587004, 0.015846057, 0.015822057, 0.015798138, 0.015774248, 0.015750377, 0.015726551, 0.01570276, 0.015679, 0.01565527, 0.015631573, 0.015607908, 0.015584308, 0.01556069, 0.015537137, 0.015513601, 0.015490144, 0.015466701, 0.015443245, 0.015419852, 0.015396521, 0.015373224, 0.015349941, 0.015326693, 0.01530346, 0.015280274, 0.015257152, 0.015234029, 0.015210955, 0.015187929, 0.015164903, 0.01514191, 0.015119012, 0.015096081, 0.015073246, 0.015050349, 0.015027562, 0.015004807, 0.014982101, 0.014959378, 0.014936719, 0.01491406, 0.014891481, 0.014868918, 0.014846403, 0.014823904, 0.014801436, 0.014779002, 0.014756614, 0.014734243, 0.014711952, 0.014689629, 0.014667384, 0.014645172, 0.014622992, 0.014600845, 0.014578729, 0.014556613, 0.014534594, 0.014512573, 0.014490584, 0.014468645, 0.014446752, 0.014424845, 0.014403, 0.014381203, 0.01435944, 0.014337705, 0.014315989, 0.014294288, 0.014272668, 0.014251063, 0.014229489, 0.014207966, 0.014186439, 0.014164979, 0.01414355, 0.014122152, 0.014100802, 0.014079452, 0.014058168, 0.014036882, 0.014015676, 0.013994486, 0.013973328, 0.013952187, 0.013931094, 0.013910046, 0.013889048, 0.013868035, 0.013847101, 0.01382615, 0.013805295, 0.013784424, 0.013763603, 0.013742845, 0.013722085, 0.013701342, 0.01368068, 0.01366005, 0.013639435, 0.013618868, 0.013598285, 0.013577782, 0.013557326, 0.013536887, 0.01351648, 0.013496104, 0.013475761, 0.01345545, 0.013435186, 0.013414972, 0.013394771, 0.013374587, 0.013354435, 0.013334363, 0.013314307, 0.013294283, 0.013274243, 0.013254299, 0.01323437, 0.013214506, 0.013194626, 0.013174826, 0.013155008, 0.013135256, 0.013115536, 0.013095862, 0.013076223, 0.013056597, 0.013037005, 0.013017443, 0.012997945, 0.012978465, 0.012959031, 0.012939568, 0.012920212, 0.012900876, 0.012881554, 0.012862297, 0.012843024, 0.012823845, 0.012804668, 0.012785523, 0.012766423, 0.012747373, 0.012728292, 0.012709306, 0.012690336, 0.012671413, 0.012652507, 0.012633649, 0.012614791, 0.012596012, 0.01257725, 0.012558535, 0.012539836, 0.012521153, 0.012502518, 0.012483946, 0.012465393, 0.012446885, 0.012428394, 0.012409934, 0.012391492, 0.012373128, 0.012354764, 0.012336482, 0.01231815, 0.012299916, 0.012281694, 0.012263538, 0.012245383, 0.012227274, 0.012209184, 0.012191139, 0.012173128, 0.012155179, 0.012137216, 0.01211933, 0.012101415, 0.012083594, 0.012065805, 0.012048033, 0.012030324, 0.012012584, 0.011994908, 0.011977309, 0.011959713, 0.011942132, 0.011924583, 0.011907097, 0.011889628, 0.011872207, 0.011854835, 0.011837461, 0.011820119, 0.011802842, 0.01178558, 0.011768366, 0.011751201, 0.01173402, 0.011716901, 0.011699799, 0.011682777, 0.011665755, 0.011648781, 0.011631791, 0.011614912, 0.011598018, 0.011581189, 0.011564374, 0.011547623, 0.011530856, 0.011514138, 0.011497451, 0.011480845, 0.011464237, 0.011447631, 0.011431103, 0.011414609, 0.011398145, 0.01138173, 0.011365315, 0.011348931, 0.011332612, 0.011316325, 0.011300053, 0.01128383, 0.011267605, 0.011251462, 0.011235318, 0.011219255, 0.011203189, 0.011187189, 0.011171158, 0.011155222, 0.011139303, 0.011123429, 0.011107572, 0.011091763, 0.011075939, 0.011060212, 0.011044498, 0.011028818, 0.011013169, 0.010997552, 0.010981968, 0.01096643, 0.010950909, 0.010935468, 0.010919979, 0.010904586, 0.010889209, 0.010873895, 0.010858565, 0.010843331, 0.01082805, 0.010812865, 0.010797694, 0.010782572, 0.010767468, 0.01075244, 0.010737368, 0.010722374, 0.010707411, 0.010692496, 0.010677614, 0.010662716, 0.010647898, 0.010633126, 0.010618373, 0.01060365, 0.010588959, 0.010574283, 0.010557022, 0.010537094, 0.010517166, 0.01049727, 0.010477405, 0.010457573, 0.010437709, 0.01041794, 0.01039814, 0.010378403, 0.010358634, 0.010338961, 0.010319257, 0.010299616, 0.010279943, 0.010260367, 0.010240758, 0.010221181, 0.010201636, 0.010182123, 0.010162609, 0.01014316, 0.010123679, 0.010104262, 0.010084876, 0.010065491, 0.010046106, 0.010026785, 0.010007495, 0.0099882046, 0.0099689476, 0.0099496897, 0.0099304644, 0.0099112708, 0.0098921089, 0.0098729795, 0.0098538501, 0.0098347515, 0.0098156845, 0.0097966203, 0.0097776167, 0.0097585842, 0.0097396448, 0.009720644, 0.0097017363, 0.0096828314, 0.0096639553, 0.0096450821, 0.0096262395, 0.009607397, 0.0095886504, 0.0095698396, 0.0095511256, 0.0095324107, 0.0095136957, 0.0094950125, 0.0094763944, 0.0094577437, 0.0094391564, 0.00942057, 0.0094020143, 0.0093834912, 0.0093649998, 0.0093464777, 0.0093280496, 0.0093095908, 0.0092911962, 0.0092727682, 0.0092544369, 0.0092360731, 0.0092177745, 0.0091994423, 0.0091811744, 0.0091629392, 0.0091447039, 0.0091265002, 0.0091083283, 0.0090901572, 0.0090720486, 0.0090539409, 0.0090358648, 0.0090177888, 0.0089997444, 0.0089817327, 0.0089637525, 0.0089457724, 0.008927824, 0.0089099081, 0.0088920239, 0.0088741397, 0.0088563189, 0.0088384664, 0.0088206781, 0.0088028889, 0.0087851333, 0.0087673767, 0.0087497151, 0.0087319911, 0.008714362, 0.0086967014, 0.008679105, 0.0086615076, 0.0086439429, 0.0086263772, 0.0086088767, 0.0085913753, 0.0085739065, 0.0085564693, 0.0085390322, 0.0085216267, 0.0085042538, 0.00848688, 0.0084695704, 0.0084522609, 0.0084349839, 0.008417706, 0.0084004924, 0.0083832471, 0.0083660651, 0.0083488831, 0.0083317654, 0.0083146477, 0.0082975617, 0.008280444, 0.0082634222, 0.0082463995, 0.0082294093, 0.0082124192, 0.0081954608, 0.0081785033, 0.0081616081, 0.0081447139, 0.008127884, 0.0081110215, 0.0080941916, 0.008077424, 0.0080606584, 0.0080439234, 0.0080271894, 0.0080105178, 0.0079938155, 0.0079771765, 0.0079605374, 0.0079439627, 0.0079273563, 0.0079108132, 0.0078942701, 0.0078777904, 0.0078612799, 0.0078448327, 0.0078283856, 0.0078119701, 0.0077955867, 0.0077792355, 0.0077628838, 0.0077465647, 0.0077302451, 0.0077139898, 0.0076977341, 0.0076815425, 0.0076653184, 0.0076491269, 0.0076329671, 0.007616871, 0.0076007433, 0.0075846794, 0.0075685834, 0.0075525837, 0.0075365514, 0.0075205513, 0.0075045833, 0.007488647, 0.0074727107, 0.0074568386, 0.0074409661, 0.0074251257, 0.0074092858, 0.0073935087, 0.0073777004, 0.0073619559, 0.007346211, 0.0073305303, 0.007314818, 0.007299169, 0.0072835204, 0.0072679352, 0.0072523183, 0.0072367969, 0.0072212126, 0.0072057233, 0.0071902019, 0.0071747452, 0.007159288, 0.0071438942, 0.0071284692, 0.0071130763, 0.007097715, 0.0070824176, 0.007067088, 0.0070518227, 0.0070365565, 0.0070213228, 0.0070060892, 0.0069909198, 0.0069757178, 0.0069606123, 0.0069454741, 0.0069304002, 0.0069153267, 0.0069002849, 0.0068852426, 0.0068702647, 0.0068552545, 0.0068403399, 0.0068253623, 0.0068104798, 0.0067955973, 0.0067807473, 0.0067658965, 0.0067511098, 0.006736292, 0.0067215371, 0.0067067826, 0.0066920598, 0.0066773696, 0.0066627106, 0.006648052, 0.0066334568, 0.0066188299, 0.0066042673, 0.0065897042, 0.0065751411, 0.0065606423, 0.0065462068, 0.0065317079, 0.0065172408, 0.0065028695, 0.0064884657, 0.0064740945, 0.0064597554, 0.0064454479, 0.0064311405, 0.0064168968, 0.0064026215, 0.0063884095, 0.006374198, 0.0063600182, 0.0063458383, 0.0063317544, 0.0063176067, 0.0063035553, 0.0062894705, 0.0062754508, 0.0062614307, 0.0062474743, 0.0062334868, 0.0062195626, 0.0062056063, 0.0061917454, 0.0061778538, 0.006164025, 0.0061501651, 0.0061364002, 0.006122604, 0.0061088712, 0.0060951388, 0.0060814377, 0.0060677375, 0.0060541001, 0.0060404316, 0.0060268263, 0.0060132537, 0.0059996811, 0.0059861401, 0.0059726308, 0.005959122, 0.0059456765, 0.0059321998, 0.0059187864, 0.0059053735, 0.0058920234, 0.0058786422, 0.0058653248, 0.0058520073, 0.005838722, 0.0058254683, 0.0058122468, 0.0057990248, 0.0057858359, 0.0057726773, 0.00575952, 0.0057463944, 0.0057333321, 0.0057202382, 0.0057072085, 0.0056941784, 0.0056811804, 0.0056681819, 0.0056552482, 0.0056423135, 0.0056294119, 0.0056165094, 0.0056036706, 0.0055908323, 0.0055780257, 0.0055652196, 0.0055524767, 0.0055397023, 0.0055270242, 0.005514313, 0.0055016344, 0.0054889875, 0.0054763728, 0.0054637901, 0.005451207, 0.0054386239, 0.0054261368, 0.0054136179, 0.0054011308, 0.0053886757, 0.0053762528, 0.0053637973, 0.0053514377, 0.0053390786, 0.005326719, 0.0053144237, 0.0053021279, 0.0052898326, 0.0052776015, 0.00526537, 0.0052531702, 0.0052410024, 0.0052288664, 0.0052166986, 0.0052046264, 0.0051925229, 0.0051804828, 0.0051684426, 0.0051564029, 0.0051444266, 0.0051324824, 0.0051205386, 0.0051085944, 0.005096714, 0.0050848336, 0.0050730174, 0.0050611687, 0.0050493847, 0.0050375997, 0.0050258473, 0.005014095, 0.005002406, 0.0049907174, 0.004979061, 0.0049674357, 0.004955811, 0.0049442183, 0.0049326895, 0.0049211285, 0.0049096309, 0.004898102, 0.004886637, 0.0048752036, 0.0048637707, 0.0048523694, 0.0048409682, 0.0048296307, 0.0048182933, 0.0048070517, 0.0047957459, 0.0047845044, 0.0047732634, 0.0047620218, 0.004750812, 0.0047396659, 0.0047285203, 0.0047174385, 0.004706325, 0.0046952749, 0.0046842247, 0.004673175, 0.0046621566, 0.0046512345, 0.0046402486, 0.0046293582, 0.0046184361, 0.0046075457, 0.0045966874, 0.0045858612, 0.0045750029, 0.0045642722, 0.0045534773, 0.0045427792, 0.0045320485, 0.0045213494, 0.004510683, 0.0045000161, 0.0044893813, 0.0044788104, 0.0044682077, 0.0044577005, 0.0044471617, 0.0044366545, 0.0044261795, 0.0044157044, 0.0044052615, 0.0043948819, 0.004384439, 0.0043741232, 0.0043637757, 0.0043534287, 0.0043431772, 0.0043328614, 0.0043226099, 0.0043124543, 0.0043022027, 0.0042920471, 0.004281891, 0.0042717676, 0.0042616758, 0.0042515835, 0.0042414917, 0.0042315279, 0.0042214678, 0.0042115035, 0.0042015393, 0.0041915756, 0.004181643, 0.0041717747, 0.0041618748, 0.0041520703, 0.0041422658, 0.0041324613, 0.0041226568, 0.0041129165, 0.0041031442, 0.0040934673, 0.0040837904, 0.0040741777, 0.0040645008, 0.004054856, 0.0040453072, 0.0040357583, 0.0040261773, 0.0040166923, 0.0040071751, 0.00399769, 0.0039883009, 0.0039788159, 0.0039694584, 0.0039600693, 0.0039507118, 0.0039413865, 0.0039320611, 0.0039227996, 0.0039135702, 0.0039042763, 0.0038951426, 0.0038859132, 0.0038767473, 0.0038676136, 0.0038584799, 0.0038493781, 0.003840372, 0.0038312699, 0.0038222962, 0.00381329, 0.0038042839, 0.0037953737, 0.0037863997, 0.0037774893, 0.0037686748, 0.0037597967, 0.0037509503, 0.0037421361, 0.0037333535, 0.0037245711, 0.0037158523, 0.0037071018, 0.003698447, 0.0036897922, 0.0036811375, 0.0036725148, 0.0036638922, 0.0036553009, 0.003646774, 0.0036382151, 0.0036297522, 0.003621289, 0.0036128259, 0.0036043946, 0.0035959634, 0.003587564, 0.003579197, 0.0035708614, 0.0035625901, 0.0035542864, 0.0035460151, 0.0035377757, 0.0035295358, 0.0035213283, 0.0035131527, 0.0035049769, 0.0034968969, 0.0034887851, 0.0034807373, 0.0034726574, 0.0034646094, 0.0034565933, 0.0034486093, 0.0034406253, 0.003432737, 0.0034248168, 0.0034168968, 0.0034090402, 0.0034011838, 0.0033933276, 0.0033855992, 0.0033777747, 0.003370078, 0.0033623173, 0.0033546207, 0.0033469242, 0.0033392913, 0.0033316268, 0.0033240579, 0.003316425, 0.00330892, 0.0033013511, 0.0032938141, 0.003286341, 0.0032788678, 0.0032713949, 0.0032640174, 0.0032566085, 0.0032492629, 0.0032418859, 0.0032345403, 0.003227259, 0.0032199773, 0.0032126959, 0.0032055422, 0.0031982609, 0.003191107, 0.0031839532, 0.0031767995, 0.0031696777, 0.0031625878, 0.0031554978, 0.0031485041, 0.003141446, 0.0031344201, 0.0031274897, 0.0031205276, 0.0031136295, 0.0031066993, 0.0030998013, 0.0030929027, 0.0030861325, 0.0030792663, 0.0030725275, 0.0030657889, 0.0030590184, 0.0030523119, 0.003045605, 0.0030389305, 0.0030323195, 0.0030256768, 0.0030191301, 0.0030125193, 0.0030059402, 0.0029994573, 0.0029929101, 0.0029864274, 0.002980008, 0.0029735249, 0.0029671697, 0.0029607506, 0.002954395, 0.0029480718, 0.0029417481, 0.0029354568, 0.0029292293, 0.0029229061, 0.0029167742, 0.0029105467, 0.0029043511, 0.0028982193, 0.0028920874, 0.0028859556, 0.0028799197, 0.0028738198, 0.0028678479, 0.0028618118, 0.0028558078, 0.0028498678, 0.0028438955, 0.0028379555, 0.002832111, 0.0028262029, 0.0028204224, 0.0028145779, 0.0028087976, 0.0028029853, 0.0027972686, 0.0027915197, 0.0027858673, 0.0027801509, 0.0027745299, 0.0027688772, 0.0027632564, 0.0027576354, 0.0027521108, 0.0027465536, 0.0027410607, 0.0027355677, 0.0027301065, 0.0027246452, 0.0027192163, 0.002713819, 0.0027084537, 0.0027030883, 0.0026978189, 0.0026924857, 0.0026872479, 0.0026819783, 0.0026767089, 0.0026715032, 0.0026663295, 0.002661156, 0.0026560463, 0.0026509045, 0.0026458583, 0.0026407489, 0.0026357027, 0.0026306568, 0.0026256749, 0.0026206926, 0.0026157745, 0.0026108564, 0.00260597, 0.0026010519, 0.0025962295, 0.002591375, 0.0025865848, 0.0025817624, 0.0025770676, 0.0025723092, 0.0025675506, 0.002562888, 0.0025581932, 0.0025535307, 0.0025489638, 0.002544333, 0.0025397344, 0.0025352312, 0.0025307282, 0.0025261932, 0.0025217223, 0.0025172511, 0.0025128119, 0.0025084049, 0.0025040293, 0.002499718, 0.0024953429, 0.0024910632, 0.0024866881, 0.0024824725, 0.0024782249, 0.0024740093, 0.0024697937, 0.0024656418, 0.0024614905, 0.0024573705, 0.0024532506, 0.002449163, 0.002445139, 0.002441115, 0.0024370591, 0.0024330991, 0.0024291386, 0.0024252106, 0.0024212506, 0.002417386, 0.0024135218, 0.0024097215, 0.0024058572, 0.0024020886, 0.0023982883, 0.0023945835, 0.0023908154, 0.0023871106, 0.0023834698, 0.0023798291, 0.0023761247, 0.0023725478, 0.0023690027, 0.0023654259, 0.002361849, 0.0023583679, 0.002354855, 0.0023514377, 0.0023479569, 0.0023445075, 0.0023411543, 0.002337801, 0.0023343838, 0.0023310944, 0.0023278049, 0.0023245155, 0.0023212261, 0.0023180323, 0.0023148069, 0.0023116772, 0.0023084516, 0.0023053219, 0.002302224, 0.0022991581, 0.0022960284, 0.0022930263, 0.0022900242, 0.0022870223, 0.0022840202, 0.0022810821, 0.0022781759, 0.0022753016, 0.0022723635, 0.0022695211, 0.0022667109, 0.0022639323, 0.0022610899, 0.0022583436, 0.0022556288, 0.0022529461, 0.0022501997, 0.0022475489, 0.0022449302, 0.0022423114, 0.0022396608, 0.0022371376, 0.0022345828, 0.0022320598, 0.0022295369, 0.0022270458, 0.0022246188, 0.0022221596, 0.0022197326, 0.0022174011, 0.0022150378, 0.0022127065, 0.0022103752, 0.0022081076, 0.0022058401, 0.0022035406, 0.002201369, 0.0021991655, 0.0021969939, 0.0021948223, 0.0021926826, 0.0021906067, 0.0021885626, 0.0021864548, 0.0021844429, 0.002182463, 0.0021804827, 0.0021784708, 0.0021765546, 0.0021746384, 0.002172786, 0.0021708701, 0.0021690177, 0.0021672291, 0.0021654728, 0.0021636523, 0.0021618959, 0.0021602032, 0.0021585426, 0.0021567859, 0.0021551573, 0.0021535605, 0.0021519316, 0.0021503349, 0.0021488019, 0.0021472371, 0.0021457681, 0.002144235, 0.002142766, 0.0021413609, 0.0021399555, 0.0021384866, 0.0021371453, 0.0021358358, 0.0021344945, 0.0021331531, 0.0021319077, 0.0021306621, 0.0021294486, 0.0021282032, 0.0021270216, 0.0021258718, 0.002124754, 0.0021235722, 0.0021225184, 0.0021214965, 0.0021204425, 0.0021193887, 0.0021184306, 0.0021174406, 0.0021165144, 0.0021155563, 0.0021146622, 0.0021137998, 0.0021129693, 0.0021120752, 0.0021113087, 0.0021105423, 0.0021098077, 0.0021090093, 0.0021083069, 0.0021076361, 0.0021069655, 0.0021062947, 0.0021057199, 0.0021051131, 0.0021045702, 0.0021039634, 0.0021034523, 0.0021029734, 0.0021025261, 0.0021020153, 0.0021016002, 0.0021012169, 0.0021008337, 0.0021004183, 0.002100131, 0.0020998118, 0.0020995561, 0.0020992367, 0.0020989815, 0.0020987897, 0.0020986299, 0.0020984064, 0.0020982786, 0.0020981829, 0.0020980553, 0.0020979594, 0.0020979275, 0.0020978956, 0.0020979275, 0.0020978956, 0.0020979275, 0.0020980232, 0.002098151, 0.0020981829, 0.0020983426, 0.0020985343, 0.0020986299, 0.0020988856, 0.002099141, 0.0020993964, 0.002099684, 0.0020999394, 0.0021002907, 0.0021006421, 0.0021009615, 0.0021013764, 0.0021017918, 0.0021022707, 0.0021026859, 0.002103165, 0.002103708, 0.0021042828, 0.0021047618, 0.0021053685, 0.0021060074, 0.0021066142, 0.0021072528, 0.0021079555, 0.0021086261, 0.0021093925, 0.0021100952, 0.0021108615, 0.002111692, 0.0021125225, 0.0021132887, 0.002114183, 0.002115109, 0.0021160033, 0.0021169295, 0.0021178876, 0.0021188776, 0.0021198997, 0.0021208897, 0.0021219435, 0.0021230613, 0.0021241792, 0.0021252329, 0.0021264146, 0.0021275962, 0.0021287778, 0.0021299915, 0.0021312369, 0.0021325464, 0.0021338237, 0.0021351012, 0.0021364426, 0.0021378158, 0.0021392209, 0.0021405944, 0.0021419995, 0.0021435006, 0.0021450017, 0.0021464387, 0.0021479717, 0.0021495684, 0.0021511014, 0.0021526662, 0.002154327, 0.0021559556, 0.0021576483, 0.0021593091, 0.0021610016, 0.002162758, 0.0021645466, 0.002166271, 0.0021680915, 0.0021699439, 0.002171796, 0.0021736484, 0.0021755646, 0.0021774806, 0.0021794608, 0.0021814089, 0.0021833892, 0.0021854329, 0.0021875089, 0.0021894888, 0.0021915967, 0.0021937683, 0.0021958761, 0.0021980158, 0.0022002193, 0.0022024231, 0.0022046585, 0.0022068941, 0.0022091935, 0.002211493, 0.0022138243, 0.0022161556, 0.0022185189, 0.0022209461, 0.0022233732, 0.0022257364, 0.0022282596, 0.0022307504, 0.0022332736, 0.0022357644, 0.0022383514, 0.0022409381, 0.002243493, 0.0022461438, 0.0022487945, 0.0022515091, 0.0022542237, 0.0022569064, 0.0022596528, 0.0022624633, 0.0022651779, 0.0022680201, 0.0022708946, 0.0022737687, 0.002276611, 0.0022795491, 0.0022824875, 0.0022854893, 0.0022884274, 0.0022914296, 0.0022944633, 0.0022975612, 0.0023005633, 0.002303693, 0.0023068546, 0.0023099845, 0.0023131142, 0.0023163399, 0.0023195653, 0.0023228228, 0.0023260484, 0.0023293698, 0.0023326911, 0.0023360443, 0.0023393659, 0.0023427512, 0.0023461683, 0.0023496493, 0.0023530347, 0.0023565157, 0.0023600606, 0.0023635735, 0.0023670865, 0.0023706954, 0.0023742723, 0.0023779129, 0.0023815217, 0.0023851946, 0.002388899, 0.0023926354, 0.0023963084, 0.0024000767, 0.0024039091, 0.0024077096, 0.0024115099, 0.0024153742, 0.0024192384, 0.0024231668, 0.002427063, 0.0024310229, 0.002435015, 0.0024390391, 0.0024429671, 0.002447055, 0.002451143, 0.0024552306, 0.0024593186, 0.0024634704, 0.0024676223, 0.0024718374, 0.0024759893, 0.0024802368, 0.0024845162, 0.0024888278, 0.0024930753, 0.0024973867, 0.0025017618, 0.0025061693, 0.0025105125, 0.0025149516, 0.0025194227, 0.0025238618, 0.0025283331, 0.0025328679, 0.002537403, 0.0025420017, 0.0025465367, 0.0025511356, 0.002555798, 0.0025604928, 0.0025650917, 0.0025698182, 0.0025745768, 0.0025793032, 0.0025840299, 0.0025888842, 0.0025936745, 0.0025985609, 0.0026033833, 0.0026082695, 0.0026132194, 0.0026181699, 0.0026230561, 0.0026280701, 0.0026331157, 0.0026380662, 0.002643144, 0.0026482537, 0.0026533636, 0.0026585052, 0.0026636152, 0.0026687889, 0.0026739945, 0.0026792001, 0.0026844377, 0.0026897071, 0.0026950403, 0.00270031, 0.0027056432, 0.0027110407, 0.0027164377, 0.0027217709, 0.0027272322, 0.0027327253, 0.0027381864, 0.0027436477, 0.0027492044, 0.0027547614, 0.0027603502, 0.0027659072, 0.0027715277, 0.0027772128, 0.0027828971, 0.0027885179, 0.0027942664, 0.0028000153, 0.0028057636, 0.0028115122, 0.0028173565, 0.0028231689, 0.0028290772, 0.0028349215, 0.0028407979, 0.0028467379, 0.0028527419, 0.0028586499, 0.0028646542, 0.0028707222, 0.0028767579, 0.0028827619, 0.0028888937, 0.0028949936, 0.0029011574, 0.0029072892, 0.0029134529, 0.0029197123, 0.0029259718, 0.0029321355, 0.0029384587, 0.0029447824, 0.0029511375, 0.0029574293, 0.0029638163, 0.0029702357, 0.0029766548, 0.0029830739, 0.0029895569, 0.00299604, 0.003002587, 0.0030090699, 0.0030156488, 0.0030222598, 0.0030288706, 0.0030354494, 0.0030421242, 0.0030488307, 0.0030555374, 0.0030622119, 0.0030689826, 0.0030757531, 0.0030825876, 0.0030893579, 0.0030962243, 0.0031030907, 0.0031100207, 0.0031168552, 0.003123817, 0.0031308113, 0.0031378053, 0.0031447676, 0.0031518252, 0.0031588832, 0.0031659731, 0.0031730628, 0.0031801846, 0.0031873384, 0.0031945561, 0.0032016779, 0.0032089273, 0.0032162089, 0.0032234585, 0.003230708, 0.0032380533, 0.0032454305, 0.0032527759, 0.0032601214, 0.0032675625, 0.0032749716, 0.0032824767, 0.0032899179, 0.003297423, 0.0033049597, 0.0033125286, 0.0033200337, 0.0033276665, 0.0033352992, 0.0033429004, 0.0033505969, 0.0033582936, 0.0033660219, 0.0033737826, 0.0033815112, 0.0033892717, 0.0033971281, 0.0034049205, 0.003412745, 0.0034206649, 0.0034286173, 0.0034364418, 0.0034444258, 0.0034524419, 0.0034604257, 0.0034684099, 0.0034764896, 0.0034845376, 0.0034926813, 0.0035007293, 0.0035088733, 0.0035170808, 0.0035252883, 0.0035334001, 0.0035416719, 0.0035499432, 0.0035582785, 0.0035664863, 0.0035748535, 0.0035832208, 0.0035915882, 0.0035999555, 0.0036084184, 0.0036168497, 0.0036253447, 0.0036338079, 0.0036423029, 0.003650862, 0.0036594528, 0.0036679797, 0.0036766026, 0.0036852893, 0.0036939122, 0.0037025667, 0.0037112853, 0.0037200041, 0.0037287865, 0.0037375372, 0.0037463196, 0.003755166, 0.0037640443, 0.0037728266, 0.0037817687, 0.0037907111, 0.0037996212, 0.0038085636, 0.0038175695, 0.0038265756, 0.0038356455, 0.0038446514, 0.0038537213, 0.003862855, 0.0038720206, 0.0038810908, 0.0038902883, 0.0038995182, 0.0039087473, 0.0039179451, 0.0039272388, 0.003936532, 0.0039458894, 0.0039551826, 0.0039645722, 0.0039739613, 0.0039833826, 0.0039927722, 0.0040022251, 0.0040117423, 0.004021259, 0.0040307441, 0.0040402934, 0.004049906, 0.004059487, 0.004069068, 0.0040787444, 0.0040884209, 0.0040981299, 0.0041078064, 0.0041175471, 0.0041273516, 0.0041371561, 0.0041468968, 0.0041567651, 0.0041666329, 0.0041765017, 0.0041863699, 0.0041963342, 0.0042062663, 0.0042162621, 0.004226258, 0.0042362544, 0.0042463141, 0.0042563742, 0.004266466, 0.00427659, 0.0042867456, 0.0042969012, 0.0043070568, 0.0043173088, 0.0043275282, 0.0043377476, 0.0043480634, 0.004358347, 0.0043687262, 0.0043790094, 0.0043894206, 0.0043998319, 0.0044102753, 0.0044206865, 0.0044311294, 0.0044416683, 0.0044522076, 0.0044626826, 0.0044732536, 0.0044838884, 0.004494491, 0.0045050941, 0.004515761, 0.0045264275, 0.0045371582, 0.0045478567, 0.0045586191, 0.0045694136, 0.0045802402, 0.0045910026, 0.0046018609, 0.0046127513, 0.0046236417, 0.0046345317, 0.0046454859, 0.0046564401, 0.0046674581, 0.0046784445, 0.0046894625, 0.0047005443, 0.0047116582, 0.0047226762, 0.004733854, 0.0047450317, 0.0047561773, 0.0047673546, 0.0047785966, 0.0047898381, 0.0048011434, 0.0048123854, 0.0048237545, 0.004835092, 0.0048464611, 0.0048578307, 0.0048691998, 0.004880697, 0.004892162, 0.0049035633, 0.0049151243, 0.0049266848, 0.0049382146, 0.0049497434, 0.0049613682, 0.0049729925, 0.0049846815, 0.0049963063, 0.0050079948, 0.005019716, 0.0050315, 0.0050431886, 0.0050550052, 0.0050668535, 0.0050786701, 0.0050904863, 0.0051023988, 0.0051142788, 0.0051262551, 0.0051381672, 0.0051501435, 0.0051621515, 0.0051742238, 0.0051861997, 0.0051983036, 0.0052104075, 0.005222511, 0.0052346149, 0.0052468148, 0.0052589825, 0.0052711819, 0.0052834456, 0.0052956776, 0.0053079729, 0.0053203315, 0.0053326278, 0.0053449553, 0.0053573782, 0.0053697377, 0.005382129, 0.0053946157, 0.0054071029, 0.0054195262, 0.0054320768, 0.0054446603, 0.0054572108, 0.0054697618, 0.0054824091, 0.0054950234, 0.005507702, 0.0055203494, 0.0055330596, 0.0055458019, 0.0055586086, 0.0055712871, 0.0055841259, 0.0055969642, 0.0056098029, 0.0056226407, 0.0056355754, 0.0056484775, 0.0056614433, 0.005674378, 0.0056873444, 0.0057004057, 0.005713468, 0.0057264343, 0.0057395599, 0.0057526859, 0.0057658111, 0.0057789371, 0.005792127, 0.0058053168, 0.00581857, 0.005831792, 0.0058450452, 0.0058583627, 0.0058717122, 0.0058849659, 0.0058983788, 0.0059117922, 0.0059252372, 0.0059385872, 0.0059520961, 0.0059656049, 0.0059790821, 0.0059925914, 0.006006164, 0.0060197371, 0.0060333735, 0.0060469466, 0.0060605835, 0.0060742842, 0.0060880166, 0.0061016539, 0.0061154179, 0.006129215, 0.006142979, 0.0061567756, 0.006170636, 0.0061844965, 0.006198389, 0.0062122489, 0.0062261731, 0.0062401616, 0.0062541813, 0.0062681055, 0.0062821577, 0.0062962417, 0.006310293, 0.0063243452, 0.006338493, 0.0063526407, 0.0063668205, 0.0063809683, 0.0063951802, 0.0064094556, 0.0064237309, 0.0064379429, 0.006452282, 0.0064666215, 0.0064810244, 0.0064953323, 0.0065097357, 0.0065242029, 0.0065386379, 0.0065530734, 0.0065676044, 0.0065821032, 0.0065966658, 0.0066111973, 0.006625792, 0.0066404189, 0.0066550774, 0.0066696722, 0.006684395, 0.0066991174, 0.0067138406, 0.0067285635, 0.0067433496, 0.0067581683, 0.0067729545, 0.0067878049, 0.0068026874, 0.0068176012, 0.0068325475, 0.00684743, 0.0068624085, 0.0068774186, 0.006892364, 0.0069074384, 0.0069225123, 0.0069375862, 0.0069526602, 0.00696783, 0.0069829677, 0.0069981692, 0.0070133391, 0.0070285406, 0.007043838, 0.0070591355, 0.0070743691, 0.0070896987   }, 
   { 0.023632066, 0.023575237, 0.023518341, 0.023461718, 0.023405096, 0.023348404, 0.02329185, 0.023235295, 0.023178879, 0.023122599, 0.023066182, 0.023010176, 0.022953961, 0.022897819, 0.022841813, 0.022785807, 0.022729937, 0.022673998, 0.022618266, 0.022562603, 0.022507006, 0.022451479, 0.022395885, 0.022340493, 0.022285102, 0.022229712, 0.022174528, 0.022119412, 0.022064364, 0.022009317, 0.021954199, 0.021899356, 0.021844514, 0.021789672, 0.021735035, 0.02168026, 0.02162569, 0.021571329, 0.021516828, 0.021462465, 0.021408034, 0.021353807, 0.021299649, 0.021245424, 0.021191401, 0.021137519, 0.021083565, 0.02102975, 0.020975865, 0.020922188, 0.020868441, 0.02081483, 0.020761356, 0.020707883, 0.020654548, 0.020601211, 0.020547874, 0.020494744, 0.020441476, 0.020388413, 0.020335419, 0.020282427, 0.020229705, 0.020176848, 0.020124128, 0.02007141, 0.020018756, 0.019966243, 0.019913658, 0.019861281, 0.01980911, 0.019756733, 0.019704491, 0.019652318, 0.019600214, 0.019548248, 0.019496214, 0.019444315, 0.019392485, 0.019340791, 0.019289168, 0.019237474, 0.019185919, 0.01913443, 0.019082874, 0.019031592, 0.018980173, 0.018929096, 0.018877883, 0.018826805, 0.018775797, 0.018724719, 0.018673848, 0.018622909, 0.018572174, 0.018521575, 0.018470909, 0.018420314, 0.018369852, 0.018319324, 0.018268999, 0.018218676, 0.018168353, 0.018118167, 0.018068116, 0.018018065, 0.017968016, 0.017918102, 0.017868258, 0.017818416, 0.017768707, 0.017719001, 0.017669566, 0.017619995, 0.017570494, 0.01752113, 0.017471695, 0.017422467, 0.017373307, 0.017324079, 0.017275194, 0.017226169, 0.017177215, 0.01712833, 0.017079514, 0.017030695, 0.016982084, 0.016933402, 0.01688486, 0.016836451, 0.016788047, 0.016739709, 0.01669137, 0.016643168, 0.016594967, 0.016546903, 0.016498908, 0.016450979, 0.01640312, 0.016355261, 0.01630754, 0.016259819, 0.016212096, 0.01616458, 0.016117131, 0.016069617, 0.016022442, 0.015975062, 0.01592782, 0.015880715, 0.01583354, 0.015786503, 0.015739465, 0.015692564, 0.015645871, 0.015599038, 0.015552343, 0.015505647, 0.01545909, 0.015412533, 0.015366043, 0.015319758, 0.015273475, 0.01522726, 0.015181112, 0.015134896, 0.015088886, 0.015042944, 0.014996935, 0.014951129, 0.014905256, 0.014859656, 0.014814057, 0.014768389, 0.014722859, 0.014677327, 0.014632002, 0.014586539, 0.014541282, 0.014496299, 0.014451042, 0.014406058, 0.014360938, 0.014316091, 0.014271177, 0.01422633, 0.014181622, 0.014137118, 0.014092409, 0.014047904, 0.014003401, 0.013958965, 0.013914667, 0.0138703, 0.013826137, 0.013781977, 0.013737952, 0.013693928, 0.013649903, 0.013606085, 0.013562196, 0.013518445, 0.013474762, 0.013431081, 0.013387672, 0.013344126, 0.013300718, 0.013257379, 0.013214039, 0.013170835, 0.0131277, 0.013084497, 0.013041637, 0.012998571, 0.01295571, 0.012912917, 0.012870057, 0.012827402, 0.012784678, 0.012742092, 0.012699641, 0.012657261, 0.012614879, 0.012572497, 0.01253032, 0.012488145, 0.012445969, 0.01240393, 0.012361891, 0.012320125, 0.012278292, 0.012236458, 0.012194761, 0.012152996, 0.012111437, 0.012069944, 0.012028454, 0.011987031, 0.011945881, 0.011904527, 0.011863378, 0.011822229, 0.011781149, 0.011740137, 0.011699192, 0.011658318, 0.011617579, 0.01157691, 0.011536171, 0.01149557, 0.011455038, 0.011414505, 0.011374109, 0.011333781, 0.011293591, 0.011253401, 0.01121321, 0.011173157, 0.011133171, 0.011093118, 0.01105327, 0.01101349, 0.010973642, 0.010934137, 0.010894425, 0.010854919, 0.010815345, 0.010775908, 0.010736607, 0.010697238, 0.010658075, 0.01061898, 0.010579885, 0.010540859, 0.010501832, 0.010462942, 0.010424052, 0.010385368, 0.010346616, 0.010307931, 0.010269522, 0.010231042, 0.010192564, 0.010154222, 0.010115881, 0.010077607, 0.01003947, 0.010001265, 0.0099634025, 0.0099253347, 0.0098874029, 0.0098496098, 0.0098117469, 0.0097740898, 0.0097363647, 0.0096988445, 0.0096613234, 0.009623941, 0.0095865577, 0.0095491745, 0.0095119271, 0.0094747497, 0.0094375713, 0.0094005307, 0.0093635581, 0.0093267234, 0.0092898868, 0.0092529831, 0.0092162844, 0.0091796545, 0.0091429558, 0.0091064628, 0.009069901, 0.0090336818, 0.0089973258, 0.0089610377, 0.0089248177, 0.0088885985, 0.0088525852, 0.0088165021, 0.0087805567, 0.0087447474, 0.008708939, 0.0086732674, 0.0086375969, 0.0086019253, 0.0085663898, 0.0085309241, 0.0084954575, 0.0084601287, 0.0084248679, 0.0083896751, 0.0083545512, 0.0083193593, 0.0082843723, 0.0082493853, 0.0082145352, 0.0081796171, 0.008144835, 0.0081103267, 0.0080756145, 0.0080411071, 0.0080065308, 0.0079720914, 0.007937721, 0.0079033496, 0.007869184, 0.0078351563, 0.0078009907, 0.007766963, 0.0077330028, 0.007699043, 0.0076652197, 0.0076313969, 0.0075977109, 0.0075640245, 0.007530544, 0.0074970638, 0.0074635139, 0.0074301702, 0.0073968265, 0.0073635518, 0.0073304134, 0.0072972067, 0.0072643417, 0.0072312723, 0.0071983398, 0.0071654748, 0.0071326103, 0.0070999516, 0.0070672925, 0.0070346333, 0.0070023169, 0.0069697942, 0.0069373413, 0.0069050239, 0.006872708, 0.006840528, 0.0068083475, 0.0067762369, 0.0067442623, 0.006712425, 0.0066805873, 0.0066486816, 0.0066169808, 0.0065853489, 0.0065536485, 0.0065221535, 0.0064906585, 0.0064593004, 0.0064279423, 0.0063966527, 0.006365431, 0.0063342783, 0.006303194, 0.0062721102, 0.0062411623, 0.0062102834, 0.0061795418, 0.0061487998, 0.0061180578, 0.0060874531, 0.006056916, 0.0060263798, 0.0059959115, 0.0059655802, 0.0059353863, 0.0059051239, 0.0058749295, 0.0058448724, 0.0058148149, 0.0057848264, 0.0057549058, 0.0057250541, 0.0056954073, 0.0056656925, 0.0056359773, 0.0056063998, 0.00557689, 0.005547449, 0.005518008, 0.005488704, 0.0054594679, 0.0054303696, 0.0054012709, 0.0053722402, 0.0053432104, 0.0053142486, 0.0052854232, 0.0052565988, 0.0052278424, 0.0051993597, 0.0051707402, 0.0051421896, 0.0051137069, 0.0050852927, 0.005056947, 0.0050286702, 0.0050004614, 0.0049723214, 0.0049443864, 0.0049163834, 0.0048883799, 0.0048605138, 0.0048327157, 0.0048049865, 0.0047772573, 0.0047496646, 0.0047222781, 0.0046947538, 0.0046672979, 0.0046399795, 0.0046127294, 0.0045854794, 0.0045582978, 0.0045311847, 0.0045042085, 0.0044773691, 0.0044504614, 0.004423622, 0.0043968512, 0.0043701488, 0.0043435148, 0.0043169498, 0.0042904527, 0.004264093, 0.0042377324, 0.0042114411, 0.0041852179, 0.0041589946, 0.0041329088, 0.0041068913, 0.0040809419, 0.0040551298, 0.0040292488, 0.0040035048, 0.0039778296, 0.0039521544, 0.0039265477, 0.0039010092, 0.0038756074, 0.0038502063, 0.00382501, 0.0037997453, 0.0037745496, 0.0037494218, 0.0037243627, 0.0036993718, 0.0036744499, 0.0036495274, 0.0036248793, 0.0036002307, 0.0035755143, 0.0035508657, 0.0035264229, 0.0035019114, 0.0034775371, 0.0034531625, 0.0034289253, 0.0034048243, 0.003380724, 0.0033566232, 0.0033325911, 0.0033086273, 0.0032848008, 0.0032609741, 0.0032372158, 0.0032136629, 0.0031900418, 0.0031664888, 0.0031430044, 0.0031195886, 0.003096241, 0.0030729619, 0.0030497515, 0.0030266095, 0.0030036045, 0.0029805992, 0.0029576628, 0.0029347946, 0.0029119262, 0.002889195, 0.0028664637, 0.0028438694, 0.0028214122, 0.0027988863, 0.0027764975, 0.0027541085, 0.002731788, 0.0027095361, 0.0026873527, 0.002665306, 0.0026433964, 0.0026214183, 0.0025995087, 0.0025776676, 0.0025558264, 0.0025341907, 0.0025125549, 0.0024909191, 0.0024694202, 0.0024481269, 0.0024267649, 0.0024054032, 0.0023841781, 0.002362953, 0.0023418653, 0.0023207772, 0.0022998261, 0.002279012, 0.0022581294, 0.0022373837, 0.0022166381, 0.0021959606, 0.0021753521, 0.0021548118, 0.0021343399, 0.0021140052, 0.0020937386, 0.0020734724, 0.0020532743, 0.0020332134, 0.002013084, 0.0019930913, 0.0019731673, 0.0019533117, 0.0019335931, 0.0019138743, 0.0018941556, 0.001874574, 0.0018550606, 0.0018355475, 0.0018161027, 0.0017967948, 0.0017776238, 0.001758453, 0.001739282, 0.0017201796, 0.0017011455, 0.0016821801, 0.001663283, 0.0016444544, 0.0016256943, 0.0016071396, 0.0015885849, 0.0015700301, 0.0015514754, 0.0015330577, 0.0015147084, 0.0014964275, 0.0014781466, 0.0014601396, 0.0014420643, 0.0014239887, 0.0014060503, 0.0013881119, 0.0013703102, 0.0013525087, 0.0013348439, 0.0013171794, 0.0012997201, 0.0012821924, 0.0012647333, 0.0012473424, 0.0012300885, 0.0012128347, 0.0011956494, 0.0011785325, 0.0011616211, 0.0011446411, 0.0011276611, 0.0011108866, 0.0010940436, 0.0010773374, 0.0010606998, 0.0010440622, 0.0010275615, 0.0010112661, 0.000994834, 0.00097853877, 0.00096224342, 0.00094601663, 0.0009299267, 0.00091383682, 0.00089781539, 0.00088206783, 0.00086618343, 0.00085036742, 0.00083461986, 0.00081894075, 0.00080333016, 0.00078785646, 0.00077238283, 0.00075704604, 0.00074177777, 0.0007264411, 0.00071124121, 0.0006961099, 0.00068097858, 0.00066598417, 0.00065105828, 0.00063613232, 0.00062148023, 0.00060669123, 0.0005920392, 0.00057738711, 0.00056287198, 0.00054835691, 0.00053391024, 0.00051953201, 0.00050542771, 0.00049118645, 0.00047701367, 0.00046290932, 0.00044887347, 0.00043490611, 0.00042100716, 0.0004071767, 0.00039341472, 0.00037985816, 0.00036623311, 0.00035260804, 0.00033911993, 0.0003257003, 0.00031234912, 0.00029899794, 0.00028578367, 0.00027270638, 0.00025956059, 0.00024655176, 0.00023354293, 0.00022067101, 0.00020779911, 0.00019499568, 0.00018232917, 0.0001697996, 0.00015720156, 0.00014467201, 0.0001322109, 0.00011981827, 0.0001074941, 9.5238407e-05, 8.3051178e-05, 7.0932416e-05, 5.9019061e-05, 4.6968762e-05, 3.5055404e-05, 2.321051e-05, 1.1434086e-05, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.0033928521, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 0.012089952, 1.1228683e-05, 2.3005108e-05, 3.4781533e-05, 4.6694891e-05, 5.8676716e-05, 7.0727016e-05, 8.2777311e-05, 9.5101474e-05, 0.0001072887, 0.00011961287, 0.00013193703, 0.00014439813, 0.00015685923, 0.00016945727, 0.0001820553, 0.00019472181, 0.00020759371, 0.00022046562, 0.00023333752, 0.00024627789, 0.00025928672, 0.00027236404, 0.0002855098, 0.00029872407, 0.00031214373, 0.00032542643, 0.00033891454, 0.00035233417, 0.00036589077, 0.00037951581, 0.00039314086, 0.00040690284, 0.0004207333, 0.00043470069, 0.00044859957, 0.00046263545, 0.0004766713, 0.00049084413, 0.00050501688, 0.00051925814, 0.00053363637, 0.0005481515, 0.00056259811, 0.00057711324, 0.00059169688, 0.00060634891, 0.00062106946, 0.00063585845, 0.0006507159, 0.00066577876, 0.00068077317, 0.00069583603, 0.00071089889, 0.00072609872, 0.00074129854, 0.00075663521, 0.00077204045, 0.00078744564, 0.0008031248, 0.00081866689, 0.00083434599, 0.00085002504, 0.0008657726, 0.00088165712, 0.00089754153, 0.00091349456, 0.00092965283, 0.00094574271, 0.00096196955, 0.00097819639, 0.00099449162, 0.0010108554, 0.0010272191, 0.0010437199, 0.001060289, 0.0010770635, 0.0010937697, 0.0011104757, 0.0011273187, 0.0011441618, 0.0011611418, 0.0011781901, 0.0011952386, 0.0012125609, 0.0012297463, 0.0012470686, 0.0012643909, 0.00128185, 0.0012993093, 0.001316837, 0.0013344331, 0.0013521663, 0.0013699678, 0.0013877695, 0.0014056395, 0.0014235779, 0.001441585, 0.0014596604, 0.0014778044, 0.0014960167, 0.001514366, 0.0015327153, 0.0015511331, 0.0015696194, 0.0015881056, 0.0016067288, 0.001625352, 0.0016441122, 0.0016630092, 0.0016818377, 0.0017008032, 0.0017197687, 0.0017388711, 0.0017579737, 0.0017771445, 0.001796384, 0.0018156919, 0.0018352051, 0.0018546499, 0.0018741633, 0.0018937449, 0.001913395, 0.0019331138, 0.001952901, 0.0019726879, 0.0019927488, 0.0020127415, 0.0020328027, 0.0020528636, 0.0020730614, 0.0020933279, 0.0021135944, 0.0021339292, 0.0021544008, 0.0021750098, 0.0021956186, 0.0022162271, 0.0022369043, 0.00225765, 0.0022784641, 0.0022993467, 0.0023202978, 0.0023414546, 0.0023625423, 0.0023836989, 0.002404924, 0.0024262173, 0.0024475793, 0.0024690095, 0.0024904397, 0.0025121442, 0.0025337799, 0.0025554155, 0.0025771882, 0.0025990296, 0.0026208707, 0.0026428485, 0.0026648268, 0.0026869418, 0.0027091939, 0.0027313773, 0.0027536293, 0.0027759499, 0.0027984071, 0.0028208643, 0.0028433902, 0.0028659846, 0.0028887843, 0.0029115155, 0.0029343152, 0.0029571834, 0.0029800516, 0.0030030566, 0.0030261301, 0.0030492721, 0.0030724143, 0.0030958303, 0.0031191777, 0.0031425252, 0.0031660094, 0.0031895624, 0.0032131153, 0.0032367366, 0.0032604265, 0.0032843899, 0.0033082166, 0.003332112, 0.0033560756, 0.0033801077, 0.0034042082, 0.0034283772, 0.0034526149, 0.0034771261, 0.0035014322, 0.003525875, 0.0035503863, 0.0035749662, 0.0035996148, 0.003624263, 0.0036490483, 0.0036739018, 0.0036989613, 0.0037238833, 0.0037488742, 0.0037740015, 0.0037991977, 0.003824394, 0.0038496584, 0.0038749916, 0.0039005983, 0.0039260681, 0.0039516068, 0.0039772135, 0.0040028887, 0.0040286328, 0.0040544448, 0.0040803943, 0.0041062748, 0.0041324296, 0.0041585839, 0.0041846703, 0.0042108935, 0.0042371168, 0.0042635449, 0.0042899051, 0.0043164021, 0.0043430356, 0.0043696011, 0.0043963036, 0.0044230744, 0.0044498453, 0.0044766846, 0.0045035924, 0.0045306371, 0.0045578186, 0.0045849313, 0.0046121133, 0.0046393634, 0.0046666819, 0.0046941377, 0.0047215931, 0.004749117, 0.0047766408, 0.0048045074, 0.0048321681, 0.0048599662, 0.0048878323, 0.0049157673, 0.0049437014, 0.0049717734, 0.0049998453, 0.005028191, 0.0050564678, 0.0050847451, 0.0051130904, 0.005141573, 0.0051700557, 0.0051986747, 0.0052272948, 0.0052561196, 0.0052848756, 0.005313701, 0.0053425939, 0.0053715562, 0.0054005859, 0.0054296847, 0.0054588518, 0.0054880874, 0.0055175284, 0.0055468329, 0.0055763423, 0.0056057833, 0.0056353612, 0.0056649395, 0.0056946543, 0.0057244375, 0.0057543577, 0.0057842787, 0.0058141989, 0.0058441875, 0.005874245, 0.0059044389, 0.0059346333, 0.0059648962, 0.005995227, 0.0060257637, 0.0060563004, 0.0060868366, 0.0061174417, 0.0061481148, 0.0061788573, 0.0062096678, 0.0062404778, 0.006271631, 0.0063025779, 0.0063336622, 0.0063648149, 0.0063959677, 0.0064272573, 0.0064586159, 0.006489974, 0.0065215374, 0.0065531009, 0.0065846643, 0.0066162967, 0.0066480655, 0.0066798343, 0.0067116716, 0.0067435778, 0.0067756204, 0.0068077999, 0.0068399119, 0.0068720914, 0.0069043399, 0.0069366558, 0.0069690412, 0.0070014261, 0.0070340177, 0.0070666759, 0.0070993355, 0.0071319947, 0.0071647908, 0.0071976548, 0.0072305873, 0.0072635207, 0.0072965217, 0.0073297974, 0.0073629352, 0.0073962109, 0.0074294861, 0.0074628294, 0.0074962419, 0.007529791, 0.00756334, 0.007596957, 0.0076307808, 0.0076645352, 0.0076983585, 0.0077322498, 0.00776621, 0.0078002377, 0.0078343349, 0.0078684315, 0.007902802, 0.0079371044, 0.0079714069, 0.0080058463, 0.0080403537, 0.008074862, 0.0081095062, 0.0081441505, 0.0081790006, 0.0082138507, 0.0082487008, 0.0082836188, 0.0083186748, 0.0083537297, 0.0083888536, 0.0084240464, 0.0084593752, 0.0084948409, 0.0085302396, 0.0085656373, 0.0086011719, 0.0086368434, 0.0086724469, 0.0087081864, 0.0087439949, 0.0087799402, 0.0088158855, 0.0088518998, 0.0088879131, 0.0089240652, 0.0089602154, 0.0089964345, 0.0090327915, 0.0090692155, 0.0091057783, 0.0091422712, 0.0091789011, 0.0092155309, 0.0092522297, 0.0092889974, 0.0093258321, 0.0093627367, 0.0093998462, 0.0094368868, 0.0094739962, 0.0095111746, 0.009548421, 0.0095857354, 0.0096230498, 0.009660502, 0.0096980911, 0.0097357482, 0.0097733373, 0.0098109934, 0.0098487884, 0.0098865824, 0.0099245133, 0.0099624442, 0.010000512, 0.010038718, 0.010076853, 0.010115127, 0.0101534, 0.010191742, 0.010230152, 0.010268631, 0.010307178, 0.010345931, 0.010384616, 0.010423368, 0.010462189, 0.010501078, 0.010539968, 0.010578996, 0.01061809, 0.010657185, 0.010696554, 0.010735786, 0.010775154, 0.010814592, 0.010854029, 0.010893535, 0.010933178, 0.01097282, 0.011012669, 0.011052517, 0.011092365, 0.011132281, 0.011172266, 0.01121232, 0.011252442, 0.011292633, 0.011332892, 0.011373356, 0.011413752, 0.011454215, 0.01149468, 0.011535281, 0.011575951, 0.011616689, 0.011657427, 0.01169844, 0.011739383, 0.011780327, 0.01182134, 0.011862488, 0.011903637, 0.011944923, 0.011986209, 0.0120277, 0.012069192, 0.01210969, 0.012149299, 0.01218901, 0.012228722, 0.012268569, 0.012308486, 0.01234847, 0.012388559, 0.012428578, 0.012468768, 0.012508992, 0.012549389, 0.01258975, 0.012630216, 0.012670713, 0.012711418, 0.012751984, 0.012792758, 0.012833564, 0.012874438, 0.012915349, 0.01295636, 0.01299744, 0.013038556, 0.013079842, 0.013121127, 0.013162483, 0.013203905, 0.013245465, 0.013287025, 0.013328618, 0.013370281, 0.013412115, 0.013453949, 0.013495919, 0.01353789, 0.013579964, 0.01362207, 0.013664281, 0.013706492, 0.013748805, 0.013791322, 0.013833772, 0.013876326, 0.013918946, 0.013961602, 0.014004394, 0.014047152, 0.014090014, 0.014133045, 0.014176076, 0.014219177, 0.014262379, 0.014305616, 0.014348854, 0.014392229, 0.014435671, 0.014479181, 0.01452283, 0.014566478, 0.014610264, 0.014654049, 0.014697834, 0.014741824, 0.014785813, 0.014829908, 0.014874034, 0.014918266, 0.014962562, 0.01500693, 0.015051297, 0.015095768, 0.015140374, 0.015185014, 0.01522969, 0.015274468, 0.015319347, 0.015364263, 0.015409177, 0.01545423, 0.015499383, 0.015544573, 0.015589862, 0.015635155, 0.015680583, 0.015726009, 0.015771542, 0.015817141, 0.015862843, 0.015908614, 0.01595442, 0.016000291, 0.016046233, 0.016092211, 0.016138356, 0.016184505, 0.016230721, 0.016277039, 0.016323427, 0.016369846, 0.016416438, 0.01646293, 0.016509622, 0.016556317, 0.016603149, 0.016650015, 0.016696949, 0.016743954, 0.016791023, 0.016838063, 0.016885305, 0.016932614, 0.016979927, 0.017027374, 0.017074857, 0.017122408, 0.01717006, 0.017217714, 0.017265471, 0.01731333, 0.017361224, 0.017409183, 0.017457249, 0.017505415, 0.017553514, 0.017601749, 0.017650053, 0.017698495, 0.017746935, 0.017795477, 0.01784409, 0.017892804, 0.017941486, 0.017990269, 0.018039152, 0.018088108, 0.018137131, 0.018186223, 0.018235382, 0.018284611, 0.018333839, 0.018383238, 0.018432673, 0.018482173, 0.018531779, 0.018581385, 0.018631091, 0.0186809, 0.018730711, 0.018780624, 0.018830605, 0.01888069, 0.018930841, 0.018981064, 0.019031318, 0.019081607, 0.019132033, 0.019182496, 0.019233057, 0.01928369, 0.019334355, 0.019385159, 0.019435963, 0.019486798, 0.019537773, 0.019588849, 0.019639961, 0.019691139, 0.019742355, 0.019793669, 0.019845055, 0.019896509, 0.019947963, 0.019999588, 0.020051278, 0.020103006, 0.020154802, 0.020206667, 0.020258632, 0.020310601, 0.02036267, 0.02041484, 0.020467049, 0.020519359, 0.020571699, 0.020624148, 0.020676628, 0.02072911, 0.020781795, 0.020834515, 0.020887302, 0.02094016, 0.02099305, 0.021046011, 0.021099074, 0.021152204, 0.021205369, 0.021258637, 0.021312008, 0.021365378, 0.021418884, 0.021472428, 0.02152597, 0.021579647, 0.021633394, 0.02168721, 0.021741129, 0.021795081, 0.021849135, 0.021903191, 0.021957314, 0.022011574, 0.022065904, 0.022120267, 0.022174699, 0.022229234, 0.022283835, 0.022338474, 0.022393145, 0.022447953, 0.022502795, 0.022557775, 0.022612754, 0.022667836, 0.022723023, 0.022778137, 0.022833392, 0.022888748, 0.022944205, 0.022999665, 0.023055259, 0.023110891, 0.023166589, 0.023222288, 0.023278123, 0.023334026, 0.023390066, 0.023446107, 0.023502216, 0.023558395, 0.023614639, 0.023670921, 0.023727339, 0.02378379, 0.023840345, 0.023896966, 0.023953591, 0.024010351, 0.024067178, 0.024124039, 0.024180936, 0.02423797, 0.024295071, 0.024352241, 0.02440948, 0.024466788, 0.024524061, 0.02458154, 0.024639018, 0.024696633, 0.024754284, 0.024812035, 0.024869788, 0.024927644, 0.0249855, 0.025043491, 0.025101585, 0.025159715, 0.025217947, 0.025276212, 0.02533458, 0.025392983, 0.025451388, 0.025509959, 0.025568567, 0.025627244, 0.025686024, 0.025744874, 0.025803823, 0.025862738, 0.025921725, 0.025980812, 0.026040003, 0.026099296, 0.026158586, 0.026217984, 0.026277447, 0.026336979, 0.026396479, 0.026456147, 0.02651592, 0.026575727, 0.026635602, 0.026695546, 0.026755558, 0.026815604, 0.026875751, 0.026935969, 0.026996255, 0.027056608, 0.027117033, 0.027177555, 0.027238151, 0.027298745, 0.027359441, 0.027420171, 0.02748104, 0.027541978, 0.02760298, 0.027664052, 0.027725162, 0.027786268, 0.027847581, 0.027908893, 0.027970342, 0.028031794, 0.028093379, 0.028154964, 0.028216623, 0.028278345, 0.02834017, 0.028402066, 0.028463997, 0.028526025, 0.028588159, 0.028650362, 0.028712532, 0.028774802, 0.028837245, 0.028899655, 0.028962165, 0.029024778, 0.029087426, 0.029150177, 0.029212894, 0.029275747, 0.029338703, 0.029401727, 0.029464785, 0.029527912, 0.029591143, 0.02965444, 0.029717736, 0.029781176, 0.029844644, 0.029908214, 0.029971853, 0.030035531, 0.03009934, 0.030163186, 0.030227067, 0.030291017, 0.030355068, 0.030419189, 0.030483374, 0.030547667, 0.03061196, 0.030676389, 0.030740779, 0.030805312, 0.030869944, 0.030934578, 0.030999349, 0.031064153, 0.031129029, 0.031193897, 0.031258944, 0.031324089, 0.03138924, 0.031454455, 0.031519771, 0.031585123, 0.031650577, 0.03171603, 0.031781659, 0.031847283, 0.031912982, 0.031978779, 0.032044645, 0.032110576, 0.03217658, 0.032242619, 0.032308724, 0.032374933, 0.03244121, 0.032507587, 0.032573964, 0.03264045, 0.032706998, 0.032773618, 0.032840271, 0.032907028, 0.032973886, 0.033040781, 0.033107702, 0.033174735, 0.033241898, 0.033309069, 0.033376269, 0.033443607, 0.033511013, 0.033578455, 0.033645965, 0.033713542, 0.033781253, 0.033848971, 0.033916753, 0.033984601, 0.034052592, 0.034120616, 0.034188639, 0.034256794, 0.034325026, 0.034393322, 0.034461685, 0.034530118, 0.034598622, 0.034667157, 0.034735758, 0.034804538, 0.034873281, 0.034942158, 0.035011038, 0.035079982, 0.035149064, 0.035218216, 0.035287369, 0.035356659, 0.035425983, 0.035495374, 0.03556487, 0.035634398, 0.035703994, 0.035773661, 0.035843428, 0.035913233, 0.035983138, 0.03605308, 0.036123153, 0.036193267, 0.036263376, 0.036333587, 0.036403973, 0.036474325, 0.036544744, 0.03661523, 0.036685854, 0.036756516, 0.03682724, 0.036898002, 0.036968868, 0.037039831, 0.037110835, 0.037181869, 0.037252974, 0.03732425, 0.037395556, 0.037466865, 0.037538275, 0.03760979, 0.037681337, 0.037752956, 0.037824679, 0.037896466, 0.037968252, 0.03804018, 0.038112134, 0.038184233, 0.038256299, 0.038328461, 0.038400728, 0.038473062, 0.038545437, 0.038617909, 0.038690448, 0.038763061, 0.038835704, 0.038908452, 0.038981263, 0.039054152, 0.0391271, 0.039200123, 0.039273214, 0.039346371, 0.039419629, 0.03949292, 0.039566286, 0.039639719, 0.039713219, 0.039786786, 0.039860424, 0.039934162, 0.0400079, 0.040081814, 0.040155724, 0.040229667, 0.040303748, 0.040377866, 0.040452123, 0.040526338, 0.040600661, 0.040675122, 0.04074958, 0.040824138, 0.040898737, 0.040973432, 0.041048232, 0.041123036, 0.041197903, 0.041272912, 0.041347984, 0.041423023, 0.041498203, 0.04157348, 0.041648831, 0.041724145, 0.041799597, 0.04187515, 0.041950773, 0.042026397, 0.042102087, 0.042177916, 0.042253844, 0.042329744, 0.042405743, 0.04248184, 0.042558011, 0.042634219, 0.042710524, 0.042786833, 0.042863239, 0.042939786, 0.043016367, 0.043092981, 0.043169666, 0.043246455, 0.043323342, 0.043400265, 0.043477155, 0.04355425, 0.043631412, 0.043708574, 0.043785807, 0.043863211, 0.043940578, 0.044018086, 0.044095587, 0.044173196, 0.044250906, 0.044328619, 0.044406433, 0.044484381, 0.044562332, 0.044640351, 0.044718437, 0.044796627, 0.044874854, 0.044953145, 0.045031507, 0.045109939, 0.045188535, 0.045267101, 0.045345739, 0.045424439, 0.045503281, 0.04558209, 0.045661032, 0.045740042, 0.045819122, 0.045898274, 0.045977455, 0.04605674, 0.046136092, 0.046215516, 0.046294972, 0.046374567, 0.046454228, 0.046533886, 0.046613652, 0.046693489, 0.046773389, 0.046853393, 0.046933435, 0.04701354, 0.047093749, 0.047173996, 0.047254305, 0.047334719, 0.047415171, 0.047495726, 0.047576305, 0.047656965, 0.047737721, 0.047818549, 0.04789944, 0.047980338, 0.048061401, 0.048142467, 0.048223637, 0.048304871, 0.048386145, 0.048467517, 0.048548996, 0.048630506, 0.048712015, 0.048793662, 0.048875451, 0.048957232, 0.049039051, 0.049120974, 0.049202997, 0.049285054, 0.049367145, 0.049449377, 0.049531639, 0.049614005, 0.049696375, 0.049778875, 0.04986145, 0.049944092, 0.050026763, 0.050109506, 0.050192349, 0.050275266, 0.05035818, 0.050441232, 0.050524317, 0.05060754, 0.050690763, 0.050774086, 0.050857447, 0.050940942, 0.051024441, 0.051108006, 0.05119171, 0.05127544, 0.051359214, 0.051443085, 0.051527061, 0.051611073, 0.051695179, 0.05177933, 0.05186351, 0.051947791, 0.052032214, 0.052116599, 0.052201122, 0.052285645, 0.052370306, 0.052455034, 0.052539799, 0.052624594, 0.052709565, 0.052794565, 0.052879605, 0.052964706, 0.053049915, 0.05313516, 0.053220537, 0.05330592, 0.053391363, 0.053476915, 0.053562533, 0.053648185, 0.053733975, 0.053819835, 0.053905688, 0.053991653, 0.054077685, 0.05416378, 0.054249946, 0.054336183, 0.054422453, 0.054508891, 0.054595295, 0.054681838, 0.054768417, 0.054855127, 0.054941811, 0.055028599, 0.055115443, 0.055202432, 0.055289388, 0.055376481, 0.055463605, 0.055550832, 0.055638097, 0.055725485, 0.055812888, 0.055900395, 0.055987965, 0.056075599, 0.056163274, 0.056251049, 0.056338862, 0.056426805, 0.056514751, 0.056602832, 0.05669092, 0.056779105, 0.056867395, 0.05695565, 0.057044044, 0.057132538, 0.057221066, 0.057309661, 0.057398356, 0.05748713, 0.057575971, 0.057664771, 0.057753704, 0.057842784, 0.057931893, 0.058021005, 0.058110252, 0.05819957, 0.058288958, 0.058378339, 0.058467858, 0.058557481, 0.058647107, 0.058736801, 0.058826596, 0.058916427, 0.059006423, 0.059096362, 0.059186429, 0.059276562, 0.0593668, 0.059457082, 0.05954735, 0.059637766, 0.059728313, 0.059818864, 0.059909441, 0.060000163, 0.060090918, 0.060181737, 0.060272664, 0.060363621, 0.060454652, 0.06054575, 0.060636945, 0.060728215, 0.060819477, 0.060910884, 0.061002355, 0.061093859, 0.061185468, 0.061277155, 0.061368868, 0.061460681, 0.061552498, 0.061644513, 0.061736505, 0.061828554, 0.061920743, 0.062013008, 0.062105268, 0.062197629, 0.062290024, 0.062382568, 0.06247516, 0.062567763, 0.062660441, 0.062753208, 0.062846079, 0.062939033, 0.063031979, 0.063125022, 0.063218214, 0.063311391, 0.063404642, 0.063497968, 0.063591391, 0.063684814, 0.063778408, 0.063872002, 0.063965708, 0.064059436, 0.064153269, 0.064247169, 0.064341143, 0.064435147, 0.064529225, 0.064623438, 0.06471765, 0.06481196, 0.064906344, 0.065000795, 0.06509532, 0.065189905, 0.065284558, 0.065379284, 0.065474115, 0.065568946, 0.065663874, 0.065758906, 0.065853968, 0.065949112, 0.066044308, 0.066139616, 0.066234961, 0.066330366, 0.066425912, 0.066521421, 0.066617042, 0.06671273, 0.066808544, 0.066904396, 0.067000248, 0.067096211, 0.067192309, 0.067288436, 0.067384563, 0.067480862, 0.067577198, 0.067673594, 0.067770071, 0.067866571, 0.067963213, 0.068059899, 0.06815657, 0.068253413, 0.0683503, 0.068447284, 0.068544261, 0.068641387, 0.068738505, 0.068835795, 0.068933062, 0.069030419, 0.069127887, 0.069225416, 0.069322981, 0.069420613, 0.06951832, 0.069616169, 0.069713965, 0.06981191, 0.069909886, 0.070007935, 0.070106089, 0.070204332, 0.070302621, 0.070400931, 0.070499361, 0.07059785, 0.070696406, 0.07079497, 0.070893727, 0.070992492, 0.071091294, 0.071190163, 0.071289167, 0.0713882, 0.071487315, 0.071586482, 0.071685769, 0.071785077, 0.071884453, 0.071983874, 0.072083458, 0.072183043, 0.072282702, 0.07238242, 0.07248228, 0.072582111, 0.072682075, 0.072782069, 0.072882131, 0.072982334, 0.073082507, 0.073182814, 0.073283181, 0.073383659, 0.073484108, 0.073584676, 0.073685326, 0.073786072, 0.073886834, 0.07398764, 0.074088566, 0.074189626, 0.074290648, 0.074391738, 0.074492969, 0.074594237, 0.074695572, 0.074796997, 0.074898429, 0.07500001, 0.075101607, 0.075203285, 0.07530503, 0.075406872, 0.075508758, 0.075610705, 0.075712755, 0.075814843, 0.07591702, 0.076019242, 0.076121569, 0.076223932, 0.076326393, 0.076428927, 0.076531492, 0.076634154, 0.07673689, 0.076839693, 0.076942571, 0.077045478, 0.077148519, 0.077251598, 0.077354744, 0.077457927, 0.077561207, 0.077664599, 0.077768013, 0.077871472, 0.07797502, 0.078078687, 0.078182414, 0.078286149, 0.078389972, 0.078493908, 0.078597911, 0.078701913, 0.078806058, 0.078910254, 0.07901454, 0.07911884, 0.079223223, 0.079327703, 0.079432227, 0.079536803, 0.079641528, 0.079746254, 0.079851106, 0.079955965, 0.080060929, 0.08016596, 0.080271013, 0.080376185, 0.080481388, 0.080586724, 0.08069209, 0.080797538, 0.080903046, 0.081008621, 0.08111427, 0.081220008, 0.081325792, 0.081431642, 0.081537567, 0.081643589, 0.08174964, 0.081855804, 0.08196193, 0.082068257, 0.082174629, 0.082281023, 0.082387492, 0.082494095, 0.08260069, 0.082707368, 0.082814112, 0.082920991, 0.083027899, 0.083134845, 0.083241858, 0.083348975, 0.083456203, 0.083563454, 0.083670735, 0.083778135, 0.083885595, 0.083993092, 0.084100686, 0.084208384, 0.084316149, 0.084423922, 0.084531792, 0.084639758, 0.084747806, 0.084855847, 0.084963985, 0.085072242, 0.085180558, 0.085288875, 0.085397318, 0.085505806, 0.085614398, 0.085723057, 0.085831746, 0.08594051, 0.086049378, 0.086158305, 0.08626727, 0.086376339, 0.086496264, 0.086626485, 0.086756758, 0.086887069, 0.087017439, 0.08714778, 0.087278232, 0.087408692, 0.087539159, 0.087669671, 0.087800257, 0.087930828, 0.088061444, 0.088192128, 0.088322818, 0.088453561, 0.088584296, 0.088715121, 0.088845946, 0.08897686, 0.089107752, 0.089238673, 0.089369707, 0.089500703, 0.089631744, 0.089762866, 0.089893982, 0.090025127, 0.090156347, 0.090287544, 0.090418801, 0.090550154, 0.090681456, 0.090812817, 0.090944238, 0.091075704, 0.091207139, 0.091338679, 0.091470197, 0.091601804, 0.091733396, 0.091865063, 0.091996722, 0.092128456, 0.092260204, 0.09239202, 0.092523851, 0.092655689, 0.092787556, 0.092919543, 0.09305153, 0.093183488, 0.093315564, 0.093447633, 0.093579747, 0.093711868, 0.093844064, 0.093976274, 0.094108537, 0.094240837, 0.094373144, 0.094505511, 0.094637893, 0.094770312, 0.094902813, 0.095035277, 0.095167845, 0.095300406, 0.095432974, 0.095565625, 0.095698357, 0.095831014, 0.095963754, 0.09609656, 0.096229397, 0.096362188, 0.096495129, 0.096628025, 0.096760988, 0.096894003, 0.097027004, 0.097160101, 0.097293168, 0.09742631, 0.097559489, 0.097692698, 0.0978259, 0.097959183, 0.098092526, 0.098225869, 0.098359242, 0.09849266, 0.098626085, 0.098759644, 0.098893106, 0.099026665, 0.099160284, 0.099293917, 0.099427558, 0.099561259, 0.099694975, 0.099828757, 0.09996257, 0.1000964, 0.10023029, 0.1003642, 0.10049814, 0.10063212, 0.10076614, 0.1009002, 0.10103425, 0.1011684, 0.10130255, 0.10143671, 0.10157098, 0.10170526, 0.10183953, 0.10197386, 0.10210823, 0.10224264, 0.10237712, 0.10251153, 0.10264605, 0.10278063, 0.10291519, 0.10304981, 0.10318447, 0.10331914, 0.10345387, 0.10358863, 0.10372341, 0.10385825, 0.10399312, 0.104128, 0.10426292, 0.10439792, 0.10453291, 0.10466793, 0.10480303, 0.10493814, 0.1050733, 0.10520847, 0.1053437, 0.10547893, 0.10561424, 0.10574953, 0.10588489, 0.1060203, 0.1061557, 0.10629116, 0.10642669, 0.10656223, 0.10669778, 0.10683339, 0.10696901, 0.1071047, 0.10724042, 0.10737616, 0.10751195, 0.10764776, 0.10778356, 0.10791951, 0.10805541, 0.10819138, 0.10832735, 0.1084634, 0.10859945, 0.10873558, 0.10887167, 0.10900784, 0.10914408, 0.10928031, 0.10941657, 0.10955288, 0.10968924, 0.1098256, 0.109962, 0.11009846, 0.11023495, 0.11037152, 0.11050802, 0.11064462, 0.11078129, 0.11091789, 0.11105459, 0.11119135, 0.1113281, 0.1114649, 0.11160177, 0.11173864, 0.11187553, 0.11201248, 0.11214946, 0.11228648, 0.11242355, 0.11256059, 0.11269771, 0.11283491, 0.11297207, 0.1131093, 0.11324657, 0.11338389, 0.11352118, 0.11365855, 0.11379596, 0.11393341, 0.11407095, 0.11420838, 0.11434592, 0.11448355, 0.11462115, 0.11475877, 0.1148965, 0.11503419, 0.11517198, 0.11530976, 0.11544757, 0.11558544, 0.1157233, 0.11586125, 0.11599922, 0.11613725, 0.11627525, 0.11641333, 0.11655148, 0.11668959, 0.11682775, 0.11696599, 0.11710427, 0.11724252, 0.11738083, 0.1175192, 0.11765759, 0.11779606, 0.11793448, 0.11807298, 0.11821153, 0.1183501, 0.11848868, 0.11862731, 0.11876601, 0.11890475, 0.11904345, 0.11918224, 0.11932108, 0.11945989, 0.11959877, 0.11973768, 0.11987666, 0.12001565, 0.12015467, 0.12029374, 0.12043282, 0.12057196, 0.12071114, 0.12085032, 0.12098961, 0.12112885, 0.12126815, 0.12140751, 0.12154688, 0.12168627, 0.12182577, 0.12196526, 0.12210476, 0.12224428, 0.12238391, 0.12252351, 0.12266321, 0.12280286, 0.12294262, 0.1230824, 0.12322218, 0.12336199, 0.12350191, 0.12364183, 0.12378176, 0.12392173, 0.12406175, 0.12420181, 0.12434191, 0.124482, 0.12462214, 0.12476236, 0.12490255, 0.12504281, 0.12518314, 0.12532346, 0.1254638, 0.12560421, 0.12574466, 0.12588516, 0.12602562, 0.12616615, 0.12630676, 0.12644739, 0.126588, 0.12672873, 0.12686945, 0.12701021, 0.12715094, 0.12729183, 0.12743267, 0.12757356, 0.12771448, 0.12785546, 0.12799646, 0.12813753, 0.12827855, 0.12841967, 0.12856087, 0.12870201, 0.1288432, 0.12898448, 0.12912576, 0.12926711, 0.12940843, 0.12954982, 0.12969127, 0.12983268, 0.1299742, 0.13011576, 0.13025732, 0.1303989, 0.13054055, 0.13068223, 0.13082393, 0.13096566, 0.13110745, 0.13124926, 0.13139112, 0.13153298, 0.13167489, 0.13181689, 0.13195887, 0.13210088, 0.13224293, 0.13238505, 0.13252716, 0.13266933, 0.13281153, 0.13295376, 0.13309608, 0.13323833, 0.13338068, 0.13352309, 0.13366549, 0.13380791, 0.13395043, 0.13409294, 0.13423552, 0.13437809, 0.13452072, 0.13466337, 0.13480607, 0.13494879, 0.13509157, 0.13523439, 0.13537718, 0.13552006, 0.13566299, 0.13580593, 0.13594885, 0.13609193, 0.13623497, 0.13637803, 0.13652119, 0.13666432, 0.13680749, 0.13695076, 0.13709399, 0.1372373, 0.13738066, 0.13752401, 0.13766737, 0.13781084, 0.13795431, 0.13809779, 0.13824134, 0.13838492, 0.13852854, 0.13867222, 0.13881588, 0.13895957, 0.13910337, 0.13924715, 0.13939096, 0.13953483, 0.13967873, 0.13982262, 0.13996661, 0.14011063, 0.14025468, 0.14039873, 0.14054283, 0.14068699, 0.14083119, 0.14097536, 0.14111963, 0.1412639, 0.14140821, 0.14155257, 0.14169696, 0.14184137, 0.14198585, 0.14213033, 0.14227486, 0.14241944, 0.14256407, 0.14270864, 0.14285333, 0.14299807, 0.14314279, 0.14328758, 0.14343239, 0.14357722, 0.14372216, 0.14386702, 0.14401199, 0.14415701, 0.14430203, 0.14444704, 0.14459217, 0.1447373, 0.14488243, 0.14502767, 0.14517288, 0.14531815, 0.14546348, 0.1456088, 0.14575417, 0.14589967, 0.14604501, 0.14619051, 0.14633609, 0.14648162, 0.14662717, 0.1467728, 0.14691849, 0.14706416, 0.14720991, 0.14735566, 0.14750147, 0.14764734, 0.14779316, 0.1479391, 0.14808501, 0.14823103, 0.148377, 0.14852308, 0.14866917, 0.14881524, 0.14896141, 0.14910761, 0.14925382, 0.1494001, 0.14954637, 0.1496927, 0.14983909, 0.14998546, 0.15013188, 0.15027839, 0.15042491, 0.15057142, 0.150718, 0.15086463, 0.15101127, 0.15115795, 0.15130466, 0.15145144, 0.15159823, 0.15174501, 0.15189193, 0.1520388, 0.15218572, 0.15233271, 0.15247965, 0.15262671, 0.15277381, 0.15292089, 0.15306804, 0.15321523, 0.15336245, 0.15350966, 0.15365696, 0.15380429, 0.15395163, 0.15409902, 0.15424643, 0.1543939, 0.15454139, 0.15468889, 0.15483649, 0.1549841, 0.15513171, 0.15527937, 0.1554271, 0.15557486, 0.15572257, 0.15587045, 0.15601829, 0.15616617, 0.15631409, 0.15646203, 0.15661003, 0.15675807, 0.15690607, 0.15705417, 0.15720235, 0.1573505, 0.15749866, 0.15764691, 0.15779519, 0.1579435, 0.15809184, 0.15824021, 0.15838861, 0.1585371, 0.15868552, 0.15883407, 0.15898262, 0.15913121, 0.15927981, 0.15942849, 0.15957721, 0.15972589, 0.15987469, 0.1600235, 0.16017231, 0.16032119, 0.1604701, 0.16061901, 0.16076803, 0.16091698, 0.16106606, 0.16121516, 0.16136429, 0.1615134, 0.16166258, 0.16181184, 0.16196109, 0.16211037, 0.16225971, 0.16240907, 0.16255848, 0.16270788, 0.16285735, 0.16300689, 0.16315645, 0.16330601, 0.16345561, 0.16360527, 0.16375497, 0.16390465, 0.16405442, 0.16420422, 0.16435404, 0.16450386, 0.16465379, 0.16480371, 0.16495363, 0.16510369, 0.16525368, 0.16540377, 0.16555385, 0.16570401, 0.16585419, 0.16600442, 0.16615465, 0.16630492, 0.16645527, 0.16660561, 0.16675596, 0.16690642, 0.16705687, 0.16720736, 0.16735789, 0.16750845, 0.16765904, 0.16780972, 0.16796035, 0.16811106, 0.16826181, 0.1684126, 0.16856335, 0.16871426, 0.16886511, 0.16901603, 0.169167, 0.16931796, 0.16946898, 0.16962008, 0.16977113, 0.16992228, 0.17007345, 0.17022462, 0.17037585, 0.17052716, 0.17067844, 0.17082977, 0.17098115, 0.17113258, 0.17128403, 0.17143549, 0.17158699, 0.17173855, 0.17189017, 0.17204176, 0.17219339, 0.17234513, 0.17249687, 0.17264858, 0.17280042, 0.17295225, 0.17310411, 0.17325604, 0.17340796, 0.17355995, 0.17371199, 0.17386398, 0.17401606, 0.17416821, 0.17432034, 0.17447253, 0.17462476, 0.17477702, 0.17492929, 0.17508163, 0.17523399, 0.1753864, 0.17553882, 0.17569126, 0.17584381, 0.17599635, 0.17614889, 0.17630152, 0.17645417, 0.17660688, 0.17675957, 0.17691232, 0.1770651, 0.17721795, 0.17737077, 0.17752366, 0.17767663, 0.17782958, 0.17798254, 0.17813562, 0.17828867, 0.17844179, 0.17859492, 0.17874806, 0.1789013, 0.17905454, 0.17920782, 0.1793611, 0.1795145, 0.17966788, 0.17982127, 0.17997478, 0.18012825, 0.1802818, 0.18043534, 0.18058893, 0.18074256, 0.18089622, 0.18104994, 0.18120366, 0.18135747, 0.18151125, 0.18166509, 0.18181901, 0.18197292, 0.18212681, 0.18228085, 0.18243487, 0.18258892, 0.18274301, 0.18289714, 0.18305129, 0.18320553, 0.18335973, 0.18351398, 0.18366832, 0.18382265, 0.18397699, 0.18413144, 0.18428586, 0.18444037, 0.18459487, 0.18474941, 0.18490401, 0.18505864, 0.18521328, 0.18536797, 0.18552271, 0.18567744, 0.18583223, 0.1859871, 0.18614195, 0.18629684, 0.18645181, 0.18660678, 0.1867618, 0.18691683, 0.1870719, 0.18722706, 0.18738218, 0.18753736, 0.1876926, 0.18784785, 0.18800314, 0.18815845, 0.18831384, 0.18846923, 0.18862468, 0.18878011, 0.18893561, 0.18909118, 0.18924674, 0.18940234, 0.18955801, 0.18971367, 0.18986939, 0.19002514, 0.19018093, 0.19033675, 0.19049263, 0.19064848, 0.19080441, 0.19096039, 0.19111638, 0.19127239, 0.1914285, 0.19158459, 0.19174071, 0.1918969, 0.19205308, 0.19220936, 0.1923656, 0.19252194, 0.19267829, 0.19283469, 0.19299108, 0.19314753, 0.19330405, 0.19346058, 0.19361711, 0.19377375, 0.19393034, 0.19408701, 0.19424373, 0.19440046, 0.19455723, 0.19471408, 0.19487089, 0.19502777, 0.19518471, 0.19534166, 0.19549859, 0.19565566, 0.1958127, 0.19596981, 0.19612691, 0.19628409, 0.19644128, 0.1965985, 0.19675577, 0.19691306, 0.19707043, 0.19722779, 0.19738516, 0.19754265, 0.19770011, 0.1978576, 0.1980152, 0.19817276, 0.19833039, 0.19848804, 0.19864571, 0.19880344, 0.19896126, 0.19911902, 0.19927686, 0.19943473, 0.19959264, 0.19975057, 0.19990852, 0.20006654, 0.20022462, 0.20038268, 0.20054075, 0.20069896, 0.20085713, 0.20101532, 0.2011736, 0.2013319, 0.20149022, 0.20164858, 0.20180699, 0.20196541, 0.20212385, 0.20228235, 0.20244089, 0.20259951, 0.20275807, 0.2029167, 0.20307542, 0.20323414, 0.20339285, 0.20355166, 0.2037105, 0.20386933, 0.20402822, 0.20418712, 0.20434611, 0.20450512, 0.20466414, 0.20482317, 0.20498233, 0.20514144, 0.20530058, 0.20545983, 0.20561905, 0.20577836, 0.20593767, 0.20609704, 0.2062564, 0.20641583, 0.20657526, 0.20673475, 0.20689431, 0.20705386, 0.20721342, 0.2073731, 0.20753275, 0.20769243, 0.20785217, 0.20801196, 0.20817177, 0.2083316, 0.20849147, 0.20865138, 0.20881134, 0.20897132, 0.20913132, 0.20929143, 0.20945151, 0.20961159, 0.20977178, 0.20993195, 0.21009222, 0.21025246, 0.21041277, 0.21057311, 0.2107335, 0.21089388, 0.2110543, 0.21121483, 0.21137533, 0.21153587, 0.21169646, 0.21185707, 0.21201776, 0.21217842, 0.21233915, 0.21249995, 0.21266067, 0.21282154, 0.21298242, 0.21314332, 0.21330422, 0.21346521, 0.21362622, 0.21378726, 0.21394834, 0.21410945, 0.21427061, 0.21443179, 0.21459299, 0.21475424, 0.21491557, 0.21507689, 0.21523821, 0.21539962, 0.21556108, 0.21572252, 0.21588401, 0.21604556, 0.21620712, 0.21636878, 0.21653038, 0.21669206, 0.21685378, 0.21701553, 0.21717729, 0.21733914, 0.217501, 0.21766287, 0.21782479, 0.21798675, 0.21814877, 0.21831077, 0.21847285, 0.21863495, 0.21879709, 0.21895923, 0.21912143, 0.21928373, 0.219446, 0.21960828, 0.21977067, 0.21993305, 0.22009543, 0.22025791, 0.22042039, 0.2205829, 0.22074549, 0.22090805, 0.22107068, 0.22123337, 0.22139609, 0.22155878, 0.22172157, 0.22188438, 0.22204721, 0.22221008, 0.22237301, 0.22253595, 0.22269896, 0.22286195, 0.22302501, 0.2231881, 0.22335124, 0.22351433, 0.22367762, 0.2238408, 0.22400409, 0.22416738, 0.22433071, 0.2244941, 0.22465749, 0.22482093, 0.22498442, 0.22514795, 0.22531146, 0.22547506, 0.22563866, 0.22580233, 0.22596601, 0.22612976, 0.2262935, 0.2264573, 0.22662111, 0.22678496, 0.22694892, 0.22711283, 0.22727679, 0.22744082, 0.22760485, 0.22776891, 0.22793303, 0.2280972, 0.22826137, 0.22842564, 0.22858982, 0.22875412, 0.22891849, 0.22908284, 0.22924718, 0.22941166, 0.22957611, 0.22974056, 0.22990514, 0.2300697, 0.2302343, 0.23039895, 0.23056361, 0.23072834, 0.23089311, 0.23105787, 0.23122267, 0.23138757, 0.23155244, 0.23171732, 0.23188232, 0.2320473, 0.23221235, 0.2323774, 0.2325425, 0.23270765, 0.23287284, 0.23303799, 0.23320325, 0.23336856, 0.23353386, 0.23369916, 0.23386458, 0.23403001, 0.23419544, 0.23436415, 0.23453599, 0.23470782, 0.23487964, 0.23505132, 0.23522298, 0.2353946, 0.23556612, 0.23573764, 0.2359091, 0.23608048, 0.23625183, 0.23642313, 0.23659433, 0.23676549, 0.23693664, 0.23710769, 0.23727874, 0.23744971, 0.23762059, 0.23779146, 0.23796223, 0.23813297, 0.23830371, 0.23847429, 0.23864488, 0.23881544, 0.2389859, 0.23915629, 0.2393267, 0.23949698, 0.23966725, 0.23983747, 0.24000759, 0.24017766, 0.24034776, 0.24051774, 0.24068765, 0.24085757, 0.24102734, 0.24119712, 0.24136683, 0.24153651, 0.24170612, 0.24187569, 0.24204519, 0.24221464, 0.24238403, 0.24255337, 0.2427226, 0.24289188, 0.24306104, 0.24323015, 0.24339925, 0.24356823, 0.24373719, 0.24390611, 0.24407497, 0.24424374, 0.24441251, 0.24458118, 0.24474983, 0.24491842, 0.24508692, 0.2452554, 0.24542385, 0.24559221, 0.2457605, 0.24592878, 0.24609698, 0.2462651, 0.24643323, 0.24660122, 0.24676922, 0.24693717, 0.24710506, 0.24727285, 0.24744064, 0.24760838, 0.24777602, 0.24794364, 0.24811117, 0.24827868, 0.24844614, 0.24861354, 0.24878088, 0.24894816, 0.24911538, 0.24928254, 0.24944972, 0.24961677, 0.24978374, 0.24995072, 0.2501176, 0.25028452, 0.2504513, 0.25061801, 0.25078472, 0.25095135, 0.25111791, 0.25128448, 0.25145096, 0.25161734, 0.25178376, 0.25195003, 0.25211626, 0.2522825, 0.25244865, 0.25261471, 0.2527808, 0.25294676, 0.2531127, 0.25327858, 0.2534444, 0.25361016, 0.25377589, 0.25394157, 0.25410718, 0.25427273, 0.25443822, 0.25460365, 0.25476906, 0.2549344, 0.25509965, 0.25526491, 0.2554301, 0.25559518, 0.25576028, 0.2559253, 0.25609025, 0.25625518, 0.25641999, 0.25658482, 0.25674954, 0.25691423, 0.25707886, 0.25724345, 0.25740796, 0.25757244, 0.25773686, 0.25790125, 0.25806555, 0.25822982, 0.258394, 0.25855815, 0.25872228, 0.25888628, 0.25905025, 0.25921425, 0.25937811, 0.2595419, 0.25970572, 0.25986943, 0.26003307, 0.26019669, 0.26036021, 0.26052371, 0.26068717, 0.26085058, 0.26101393, 0.26117718, 0.26134044, 0.26150358, 0.26166674, 0.26182976, 0.26199278, 0.26215577, 0.26231867, 0.26248151, 0.26264432, 0.26280707, 0.26296976, 0.26313239, 0.26329497, 0.26345751, 0.26361996, 0.26378241, 0.26394477, 0.26410705, 0.26426932, 0.26443154, 0.26459372, 0.26475579, 0.26491779, 0.2650798, 0.26524171, 0.2654036, 0.26556545, 0.26572719, 0.2658889, 0.26605058, 0.2662122, 0.26637375, 0.26653528, 0.26669669, 0.26685807, 0.26701942, 0.26718074, 0.26734197, 0.26750311, 0.26766422, 0.26782531, 0.26798633, 0.26814732, 0.26830816, 0.26846904, 0.26862985, 0.26879057, 0.2689513, 0.2691119, 0.26927251, 0.26943302, 0.26959351, 0.2697539, 0.26991427, 0.27007458, 0.27023482, 0.27039504, 0.27055523, 0.2707153, 0.2708753, 0.27103534, 0.27119523, 0.27135512, 0.27151495, 0.27167472, 0.27183443, 0.27199411, 0.27215371, 0.27231327, 0.27247277, 0.27263221, 0.27279159, 0.27295095, 0.27311024, 0.27326947, 0.27342865, 0.27358773, 0.27374685, 0.27390581, 0.27406481, 0.27422372, 0.27438259, 0.27454138, 0.27470011, 0.27485883, 0.27501741, 0.27517599, 0.27533454, 0.27549303, 0.27565143, 0.27580979, 0.2759681, 0.27612635, 0.27628461, 0.27644277, 0.27660081, 0.27675885, 0.27691683, 0.27707478, 0.27723265, 0.27739048, 0.27754825, 0.27770597, 0.27786365, 0.27802125, 0.27817878, 0.27833632, 0.27849373, 0.27865115, 0.27880847, 0.27896574, 0.27912298, 0.27928016, 0.27943727, 0.27959436, 0.27975136, 0.27990833, 0.28006524, 0.28022209, 0.28037888, 0.28053564, 0.28069231, 0.28084898, 0.28100553, 0.28116205, 0.28131852, 0.28147495, 0.28163132, 0.28178763, 0.28194386, 0.28210011, 0.28225625, 0.28241235, 0.28256837, 0.28272435, 0.28288031, 0.28303617, 0.28319201, 0.28334776, 0.28350347, 0.28365913, 0.28381476, 0.28397033, 0.2841258, 0.28428125, 0.28443664, 0.284592, 0.28474727, 0.28490251, 0.28505766, 0.28521281, 0.28536785, 0.28552288, 0.28567785, 0.28583273, 0.28598759, 0.28614244, 0.28629711, 0.28645182, 0.28660649, 0.28676105, 0.28691557, 0.28707007, 0.28722447, 0.28737882, 0.28753316, 0.28768736, 0.28784159, 0.28799579, 0.28814983, 0.28830391, 0.28845787, 0.2886118, 0.2887657, 0.28891951, 0.28907329, 0.28922698, 0.28938064, 0.28953424, 0.28968781, 0.28984132, 0.28999478, 0.2901482, 0.2903015, 0.29045478, 0.29060799, 0.2907612, 0.2909143, 0.29106739, 0.29122043, 0.29137334, 0.29152626, 0.29167911, 0.29183194, 0.29198468, 0.29213732, 0.29229, 0.29244259, 0.29259509, 0.29274756, 0.29289997, 0.29305238, 0.29320469, 0.2933569, 0.29350913, 0.2936613, 0.29381338, 0.29396543, 0.29411742, 0.29426932, 0.2944212, 0.29457304, 0.29472479, 0.29487652, 0.29502818, 0.29517981, 0.29533136, 0.29548287, 0.2956343, 0.29578567, 0.29593703, 0.29608834, 0.29623955, 0.29639071, 0.29654184, 0.29669291, 0.29684389, 0.29699492, 0.29714581, 0.29729667, 0.29744744, 0.29759818, 0.29774886, 0.29789951, 0.29805011, 0.29820064, 0.29835114, 0.29850152, 0.29865187, 0.2988022, 0.29895246, 0.29910263, 0.29925281, 0.29940286, 0.29955295, 0.29970291, 0.29985285, 0.30000272, 0.30015257, 0.30030233, 0.30045205, 0.30060172, 0.3007513, 0.30090085, 0.30105036, 0.30119982, 0.30134922, 0.30149853, 0.30164778, 0.30179703, 0.30194625, 0.30209538, 0.30224442, 0.30239344, 0.30254239, 0.30269128, 0.30284017, 0.30298898, 0.30313769, 0.30328637, 0.30343503, 0.30358359, 0.30373213, 0.3038806, 0.30402905, 0.3041774, 0.3043257, 0.30447397, 0.30462217, 0.30477029, 0.30491841, 0.30506644, 0.30521443, 0.30536237, 0.30551025, 0.30565807, 0.30580583, 0.30595356, 0.30610123, 0.30624881, 0.30639637, 0.30654392, 0.30669129, 0.30683872, 0.30698609, 0.30713332, 0.30728057, 0.30742773, 0.30757487, 0.30772194, 0.30786899, 0.30801591, 0.30816284, 0.30830964, 0.30845648, 0.3086032, 0.30874991, 0.30889654, 0.30904311, 0.30918965, 0.30933613, 0.30948254, 0.30962893, 0.30977523, 0.3099215, 0.31006765, 0.31021383, 0.31035993, 0.31050596, 0.31065199, 0.3107979, 0.31094375, 0.31108961, 0.31123534, 0.31138107, 0.31152675, 0.31167233, 0.31181791, 0.31196338, 0.31210887, 0.31225422, 0.3123996, 0.31254488, 0.31269011, 0.31283531, 0.31298038, 0.31312549, 0.31327048, 0.31341544, 0.31356034, 0.31370518, 0.31384999, 0.31399471, 0.31413943, 0.31428406, 0.31442866, 0.3145732, 0.31471765, 0.31486207, 0.31500643, 0.31515077, 0.31529501, 0.31543922, 0.31558335, 0.31572744, 0.31587151, 0.31601548, 0.3161594, 0.31630328, 0.31644711, 0.31659088, 0.31673461, 0.31687826, 0.31702185, 0.3171654, 0.31730893, 0.31745237, 0.31759575, 0.3177391, 0.31788236, 0.31802559, 0.31816879, 0.31831187, 0.31845501, 0.318598, 0.31874096, 0.31888384, 0.31902674, 0.31916952, 0.31931224, 0.31945494, 0.31959757, 0.31974015, 0.31988272, 0.32002518, 0.32016757, 0.32030997, 0.32045227, 0.32059452, 0.32073674, 0.32087889, 0.32102096, 0.321163, 0.32130501, 0.32144696, 0.32158881, 0.32173064, 0.32187238, 0.32201412, 0.3221558, 0.32229739, 0.32243896, 0.32258046, 0.32272187, 0.32286328, 0.32300466, 0.3231459, 0.32328713, 0.3234283, 0.32356942, 0.32371053, 0.32385153, 0.32399249, 0.3241334, 0.32427424, 0.32441503, 0.32455575, 0.32469648, 0.32483709, 0.3249777, 0.32511821, 0.3252587, 0.3253991, 0.32553947, 0.32567981, 0.32582006, 0.32596025, 0.32610038, 0.32624048, 0.32638052, 0.3265205, 0.32666045, 0.32680032, 0.32694015, 0.32707992, 0.32721964, 0.32735929, 0.32749891, 0.32763845, 0.32777798, 0.3279174, 0.32805681, 0.32819617, 0.32833543, 0.32847464, 0.32861382, 0.32875291, 0.32889202, 0.32903102, 0.32916999, 0.3293089, 0.32944775, 0.32958654, 0.32972527, 0.32986397, 0.33000261, 0.33014122, 0.33027974, 0.33041823, 0.3305566, 0.330695, 0.33083332, 0.33097157, 0.33110979, 0.3312479, 0.331386, 0.33152404, 0.33166206, 0.33179998, 0.33193785, 0.33207569, 0.33221343, 0.33235115, 0.33248883, 0.33262646, 0.332764, 0.33290151, 0.33303893, 0.33317634, 0.33331367, 0.33345094, 0.33358818, 0.33372536, 0.33386245, 0.33399951, 0.33413658, 0.33427349, 0.33441043, 0.33454725, 0.3346841, 0.33482081, 0.33495751, 0.33509412, 0.33523071, 0.33536726, 0.33550373, 0.33564013, 0.33577651, 0.33591282, 0.33604908, 0.33618531, 0.33632144, 0.33645755, 0.33659357, 0.33672956, 0.33686545, 0.33700135, 0.33713719, 0.33727297, 0.33740866, 0.33754435, 0.33767995, 0.33781549, 0.33795097, 0.33808646, 0.33822185, 0.33835718, 0.33849245, 0.3386277, 0.33876285, 0.33889797, 0.33903304, 0.33916807, 0.33930305, 0.33943796, 0.33957279, 0.33970758, 0.33984232, 0.33997703, 0.34011167, 0.34024626, 0.34038079, 0.34051526, 0.34064963, 0.34078404, 0.34091833, 0.34105259, 0.34118682, 0.34132096, 0.34145504, 0.34158906, 0.34172305, 0.34185699, 0.34199086, 0.3421247, 0.34225848, 0.34239221, 0.34252587, 0.34265944, 0.34279305, 0.34292653, 0.34305996, 0.34319338, 0.34332672, 0.34345996, 0.34359321, 0.3437264, 0.34385952, 0.34399259, 0.3441256, 0.34425855, 0.34439149, 0.34452432, 0.34465712, 0.34478986, 0.34492254, 0.34505519, 0.34518778, 0.34532031, 0.34545273, 0.34558517, 0.34571755, 0.34584984, 0.3459821, 0.34611431, 0.34624648, 0.34637856, 0.34651062, 0.34664258, 0.34677452, 0.34690639, 0.34703827, 0.34717003, 0.34730169, 0.34743339, 0.347565, 0.34769654, 0.34782809, 0.34795949, 0.34809086, 0.34822223, 0.34835348, 0.34848475, 0.34861591, 0.34874704, 0.34887809, 0.34900913, 0.34914005, 0.349271, 0.34940186, 0.34953263, 0.34966338, 0.34979406, 0.34992468, 0.35005528, 0.35018584, 0.35031629, 0.3504467, 0.35057706, 0.35070738, 0.35083762, 0.35096782, 0.35109797, 0.35122809, 0.35135812, 0.35148808, 0.35161802, 0.35174793, 0.35187775, 0.35200751, 0.35213724, 0.35226691, 0.35239649, 0.35252604, 0.35265556, 0.35278502, 0.35291442, 0.35304374, 0.35317302, 0.35330224, 0.35343143, 0.35356057, 0.35368964, 0.35381863, 0.35394761, 0.3540765, 0.35420537, 0.35433415, 0.35446289, 0.35459158, 0.35472023, 0.3548488, 0.35497731, 0.35510582, 0.35523421, 0.35536259, 0.35549092, 0.35561916, 0.35574737, 0.35587549, 0.35600361, 0.35613164, 0.35625964, 0.35638756, 0.35651544, 0.35664329, 0.35677102, 0.35689875, 0.3570264, 0.35715401, 0.3572816, 0.35740906, 0.35753652, 0.35766393, 0.35779127, 0.35791856, 0.35804579, 0.35817298, 0.35830009, 0.35842714, 0.35855415, 0.35868111, 0.35880804, 0.35893488, 0.35906169, 0.35918841, 0.3593151, 0.35944173, 0.3595683, 0.35969484, 0.35982132, 0.35994774, 0.3600741, 0.36020043, 0.36032665, 0.36045286, 0.36057901, 0.36070514, 0.36083117, 0.36095718, 0.36108306, 0.36120898, 0.36133477, 0.36146057, 0.36158627, 0.36171192, 0.36183754, 0.36196309, 0.36208862, 0.36221406, 0.36233944, 0.36246479, 0.36259007, 0.3627153, 0.36284047, 0.36296558, 0.36309063, 0.36321566, 0.36334065, 0.36346555, 0.36359042, 0.3637152, 0.36383992, 0.36396462, 0.36408925, 0.36421385, 0.36433837, 0.36446282, 0.36458725, 0.36471164, 0.36483595, 0.36496019, 0.36508438, 0.36520854, 0.36533266, 0.3654567, 0.36558068, 0.36570457, 0.36582848, 0.36595231, 0.36607611, 0.36619979, 0.36632344, 0.36644703, 0.36657062, 0.36669415, 0.36681756, 0.36694095, 0.3670643, 0.36718756, 0.36731082, 0.367434, 0.36755711, 0.36768016, 0.36780322, 0.36792612, 0.36804906, 0.36817193, 0.36829469, 0.36841744, 0.36854014, 0.36866277, 0.36878535, 0.36890793, 0.36903036, 0.36915278, 0.36927515, 0.36939746, 0.36951968, 0.36964193, 0.36976406, 0.36988616, 0.3700082, 0.37013018, 0.37025213, 0.37037402, 0.37049583, 0.3706176, 0.37073931, 0.37086096, 0.37098259, 0.37110415, 0.37122566, 0.3713471, 0.37146848, 0.37158984, 0.37171111, 0.37183234, 0.37195352, 0.37207463, 0.37219572, 0.37231672, 0.37243766, 0.37255859, 0.37267941, 0.37280023, 0.37292099, 0.37304166, 0.3731623, 0.37328288, 0.37340337, 0.37352392, 0.37364432, 0.37376466, 0.37388495, 0.37400523, 0.37412542, 0.37424558, 0.37436569, 0.3744857, 0.37460572, 0.37472564, 0.3748455, 0.37496534, 0.37508515, 0.37520486, 0.37532449, 0.37544408, 0.37556362, 0.37568316, 0.37580261, 0.37592199, 0.37604135, 0.37616062, 0.37627986, 0.37639904, 0.37651816, 0.37663725, 0.37675628, 0.37687519, 0.3769941, 0.37711298, 0.37723175, 0.37735048, 0.37746921, 0.37758783, 0.37770638, 0.37782493, 0.37794337, 0.37806183, 0.37818018, 0.37829849, 0.37841678, 0.37853497, 0.37865311, 0.37877119, 0.37888923, 0.37900725, 0.37912518, 0.37923309, 0.37933108, 0.37942904, 0.37952682, 0.37962452, 0.37972206, 0.37981951, 0.37991685, 0.38001406, 0.38011119, 0.38020813, 0.38030499, 0.38040176, 0.38049838, 0.38059488, 0.38069129, 0.38078758, 0.38088375, 0.38097978, 0.38107571, 0.38117155, 0.38126722, 0.3813628, 0.38145825, 0.38155362, 0.38164884, 0.38174391, 0.38183895, 0.38193381, 0.38202858, 0.38212323, 0.38221776, 0.38231215, 0.38240647, 0.38250062, 0.38259467, 0.38268864, 0.38278243, 0.38287616, 0.38296974, 0.38306326, 0.3831566, 0.38324982, 0.38334298, 0.38343593, 0.38352889, 0.38362166, 0.38371432, 0.38380682, 0.38389924, 0.38399154, 0.38408378, 0.38417587, 0.38426781, 0.38435963, 0.38445139, 0.38454297, 0.38463444, 0.38472581, 0.38481709, 0.3849082, 0.38499922, 0.38509017, 0.38518092, 0.38527161, 0.38536218, 0.38545263, 0.38554293, 0.38563314, 0.38572323, 0.38581321, 0.38590303, 0.3859928, 0.38608241, 0.38617188, 0.38626128, 0.38635054, 0.38643971, 0.38652879, 0.38661769, 0.3867065, 0.38679516, 0.38688374, 0.38697222, 0.38706052, 0.38714874, 0.38723686, 0.38732481, 0.38741273, 0.38750046, 0.38758808, 0.38767561, 0.38776299, 0.38785028, 0.38793746, 0.38802451, 0.38811144, 0.38819823, 0.38828498, 0.38837156, 0.38845801, 0.38854435, 0.3886306, 0.3887167, 0.38880271, 0.3888886, 0.38897437, 0.38905999, 0.38914555, 0.38923097, 0.38931626, 0.38940144, 0.38948649, 0.38957146, 0.38965628, 0.389741, 0.38982561, 0.38991004, 0.38999444, 0.39007869, 0.3901628, 0.39024684, 0.39033073, 0.39041451, 0.39049816, 0.39058173, 0.39066517, 0.39074844, 0.39083165, 0.39091474, 0.39099771, 0.39108053, 0.39116326, 0.39124587, 0.39132836, 0.39141074, 0.39149302, 0.39157516, 0.39165717, 0.3917391, 0.39182091, 0.39190254, 0.39198413, 0.39206558, 0.39214692, 0.39222807, 0.39230922, 0.39239016, 0.39247105, 0.39255178, 0.39263242, 0.39271292, 0.39279333, 0.39287359, 0.39295375, 0.3930338, 0.39311367, 0.39319351, 0.39327323, 0.39335278, 0.39343223, 0.39351159, 0.39359078, 0.39366993, 0.39374891, 0.39382777, 0.39390653, 0.39398515, 0.39406371, 0.39414209, 0.39422038, 0.39429855, 0.39437664, 0.39445454, 0.39453238, 0.39461008, 0.39468765, 0.39476514, 0.39484251, 0.39491975, 0.39499685, 0.39507386, 0.39515075, 0.39522749, 0.39530417, 0.39538071, 0.39545712, 0.39553344, 0.39560959, 0.3956857, 0.39576164, 0.39583749, 0.39591321, 0.39598879, 0.39606431, 0.39613965, 0.3962149, 0.39629006, 0.39636505, 0.39643994, 0.39651474, 0.3965894, 0.39666396, 0.39673841, 0.39681274, 0.39688694, 0.396961, 0.39703494, 0.39710882, 0.39718255, 0.39725617, 0.39732969, 0.39740303, 0.39747632, 0.39754948, 0.3976225, 0.39769542, 0.39776823, 0.39784092, 0.39791346, 0.39798591, 0.39805824, 0.39813045, 0.39820257, 0.39827451, 0.39834639, 0.39841816, 0.39848977, 0.39856127, 0.39863271, 0.39870396, 0.39877513, 0.39884618, 0.39891714, 0.39898789, 0.39905861, 0.39912918, 0.39919963, 0.39927, 0.39934021, 0.39941034, 0.39948034, 0.39955023, 0.39961997, 0.39968961, 0.39975914, 0.39982855, 0.39989784, 0.39996701, 0.40003607, 0.40010503, 0.40017387, 0.4002426, 0.40031117, 0.40037966, 0.40044799, 0.40051621, 0.40058437, 0.40065238, 0.40072027, 0.40078807, 0.40085572, 0.40092325, 0.40099069, 0.40105802, 0.40112519, 0.40119225, 0.40125921, 0.40132603, 0.40139279, 0.4014594, 0.40152586, 0.40159225, 0.40165851, 0.40172464, 0.40179068, 0.40185657, 0.40192237, 0.40198806, 0.40205359, 0.40211901, 0.40218437, 0.40224957, 0.40231463, 0.4023796, 0.40244448, 0.40250921, 0.40257385, 0.40263835, 0.40270275, 0.402767, 0.40283117, 0.40289521, 0.40295911, 0.40302292, 0.4030866, 0.40315017, 0.40321362, 0.40327695, 0.40334016, 0.40340328, 0.40346625, 0.40352914, 0.40359187, 0.40365452, 0.40371707, 0.40377945, 0.40384173, 0.4039039, 0.40396598, 0.40402788, 0.40408972, 0.40415141, 0.40421298, 0.40427446, 0.40433583, 0.40439707, 0.40445817, 0.40451914, 0.40458006, 0.40464079, 0.40470147, 0.404762, 0.40482241, 0.40488273, 0.4049429, 0.40500295, 0.40506291, 0.40512276, 0.40518245, 0.40524209, 0.40530157, 0.40536088, 0.40542015, 0.40547928, 0.40553829, 0.40559718, 0.40565598, 0.40571463, 0.40577319, 0.40583161, 0.40588993, 0.40594813, 0.40600619, 0.40606415, 0.406122, 0.40617976, 0.40623736, 0.40629482, 0.40635219, 0.40640947, 0.40646663, 0.40652367, 0.40658057, 0.40663737, 0.40669402, 0.40675059, 0.40680707, 0.40686339, 0.40691957, 0.40697566, 0.40703163, 0.40708753, 0.40714327, 0.40719888, 0.4072544, 0.40730977, 0.40736505, 0.40742022, 0.40747526, 0.40753019, 0.407585, 0.40763968, 0.40769425, 0.4077487, 0.40780306, 0.40785727, 0.40791139, 0.40796539, 0.40801927, 0.40807301, 0.40812665, 0.40818021, 0.40823361, 0.40828687, 0.40834004, 0.40839311, 0.40844604, 0.40849888, 0.40855157, 0.40860417, 0.40865666, 0.40870902, 0.40876123, 0.40881339, 0.40886536, 0.40891722, 0.40896901, 0.40902066, 0.40907222, 0.40912363, 0.40917495, 0.40922615, 0.4092772, 0.40932813, 0.40937898, 0.4094297, 0.4094803, 0.40953076, 0.40958115, 0.4096314, 0.40968156, 0.4097316, 0.40978146, 0.40983129, 0.40988091, 0.4099305, 0.40997994, 0.41002923, 0.41007844, 0.41012752, 0.41017652, 0.41022533, 0.41027403, 0.4103227, 0.41037118, 0.41041958, 0.41046783, 0.41051599, 0.41056404, 0.41061196, 0.41065973, 0.41070741, 0.41075498, 0.41080245, 0.41084978, 0.41089699, 0.41094407, 0.41099107, 0.41103792, 0.41108468, 0.41113132, 0.41117781, 0.41122422, 0.4112705, 0.41131669, 0.41136274, 0.41140866, 0.41145447, 0.41150016, 0.41154575, 0.4115912, 0.41163656, 0.4116818, 0.41172689, 0.41177186, 0.41181675, 0.41186154, 0.41190618, 0.41195068, 0.41199511, 0.4120394, 0.4120836, 0.41212764, 0.4121716, 0.41221541, 0.41225913, 0.41230273, 0.41234621, 0.41238955, 0.41243279, 0.41247594, 0.41251895, 0.41256183, 0.4126046, 0.41264728, 0.41268983, 0.41273221, 0.41277453, 0.4128167, 0.41285881, 0.41290078, 0.41294262, 0.41298434, 0.41302598, 0.41306743, 0.4131088, 0.41315007, 0.41319123, 0.41323224, 0.41327313, 0.41331396, 0.41335461, 0.41339514, 0.41343561, 0.4134759, 0.41351613, 0.41355622, 0.41359621, 0.41363603, 0.41367579, 0.41371539, 0.41375491, 0.41379431, 0.41383356, 0.41387275, 0.41391176, 0.41395071, 0.41398948, 0.4140282, 0.41406676, 0.41410518, 0.41414356, 0.41418177, 0.41421986, 0.41425785, 0.41429573, 0.41433346, 0.41437113, 0.41440862, 0.41444606, 0.41448331, 0.4145205, 0.41455755, 0.41459447, 0.41463128, 0.41466799, 0.41470456, 0.41474104, 0.4147774, 0.41481361, 0.41484976, 0.41488573, 0.41492161, 0.4149574, 0.41499305, 0.41502857, 0.41506401, 0.41509929, 0.41513449, 0.41516954, 0.4152045, 0.41523933, 0.41527405, 0.41530865, 0.41534314, 0.4153775, 0.41541174, 0.41544589, 0.4154799, 0.41551378, 0.41554758, 0.41558123, 0.41561478, 0.41564822, 0.41568151, 0.41571471, 0.41574782, 0.41578075, 0.41581362, 0.41584635, 0.41587895, 0.41591144, 0.41594383, 0.41597608, 0.41600823, 0.41604027, 0.41607219, 0.41610399, 0.41613564, 0.41616723, 0.41619867, 0.41622999, 0.4162612, 0.41629231, 0.41632324, 0.41635412, 0.41638488, 0.41641551, 0.416446, 0.41647643, 0.41650668, 0.41653687, 0.41656688, 0.4165968, 0.41662663, 0.41665635, 0.41668591, 0.41671535, 0.41674468, 0.41677389, 0.41680303, 0.416832, 0.41686091, 0.41688964, 0.41691825, 0.41694683, 0.41697523, 0.41700351, 0.41703168, 0.41705975, 0.41708764, 0.41711551, 0.4171432, 0.41717079, 0.41719827, 0.41722563, 0.41725284, 0.41728002, 0.41730699, 0.41733387, 0.41736066, 0.41738731, 0.41741386, 0.41744027, 0.41746655, 0.41749275, 0.41751882, 0.41754478, 0.41757062, 0.41759634, 0.41762194, 0.41764745, 0.41767281, 0.41769809, 0.41772321, 0.41774821, 0.4177731, 0.41779792, 0.4178226, 0.41784713, 0.41787156, 0.41789588, 0.41792008, 0.41794419, 0.41796815, 0.417992, 0.41801575, 0.41803935, 0.41806287, 0.41808623, 0.41810951, 0.41813263, 0.41815567, 0.41817859, 0.41820139, 0.41822407, 0.41824666, 0.41826913, 0.41829142, 0.41831362, 0.41833574, 0.41835773, 0.4183796, 0.41840136, 0.41842297, 0.41844448, 0.41846588, 0.41848716, 0.41850835, 0.41852936, 0.41855034, 0.41857114, 0.41859183, 0.41861239, 0.41863289, 0.41865319, 0.41867346, 0.41869357, 0.41871357, 0.41873345, 0.41875321, 0.41877285, 0.41879237, 0.41881177, 0.41883108, 0.41885027, 0.41886932, 0.41888827, 0.41890708, 0.41892582, 0.41894442, 0.4189629, 0.41898125, 0.41899949, 0.41901761, 0.41903564, 0.41905349, 0.41907129, 0.41908896, 0.41910651, 0.41912392, 0.41914123, 0.41915843, 0.41917551, 0.41919243, 0.41920933, 0.41922602, 0.41924265, 0.41925913, 0.41927552, 0.41929176, 0.41930792, 0.41932395, 0.41933984, 0.41935563, 0.41937131, 0.41938683, 0.41940233, 0.41941762, 0.41943285, 0.41944793, 0.41946289, 0.41947776, 0.41949251, 0.41950712, 0.4195216, 0.41953602, 0.4195503, 0.41956446, 0.41957846, 0.41959241, 0.41960621, 0.41961989, 0.41963348, 0.41964692, 0.41966024, 0.4196735, 0.41968659, 0.41969955, 0.41971242, 0.41972518, 0.41973785, 0.41975036, 0.41976276, 0.41977501, 0.41978723, 0.41979924, 0.41981122, 0.41982302, 0.4198347, 0.4198463, 0.41985774, 0.41986912, 0.41988033, 0.41989148, 0.41990247, 0.41991335, 0.41992411, 0.41993478, 0.4199453, 0.41995573, 0.41996604, 0.4199762, 0.41998628, 0.41999623, 0.42000607, 0.42001578, 0.42002538, 0.42003486, 0.42004424, 0.42005345, 0.4200626, 0.42007163, 0.42008051, 0.42008933, 0.42009798, 0.4201065, 0.42011496, 0.42012325, 0.42013147, 0.42013955, 0.42014751, 0.42015538, 0.42016309, 0.42017069, 0.42017817, 0.42018557, 0.42019284, 0.42019999, 0.42020699, 0.42021394, 0.4202207, 0.42022741, 0.42023396, 0.4202404, 0.42024672, 0.42025298, 0.42025906, 0.42026502, 0.42027092, 0.42027664, 0.42028227, 0.42028779, 0.42029315, 0.42029843, 0.42030361, 0.42030862, 0.42031357, 0.42031839, 0.42032307, 0.42032766, 0.42033213, 0.42033648, 0.42034066, 0.4203448, 0.42034879, 0.42035267, 0.42035642, 0.42036003, 0.42036358, 0.420367, 0.42037028, 0.42037347, 0.42037651, 0.42037946, 0.42038229, 0.42038497, 0.42038757, 0.42039007, 0.42039239, 0.42039463, 0.42039678, 0.42039877, 0.42040068, 0.42040244, 0.42040411, 0.42040566, 0.42040703, 0.42040837, 0.42040956, 0.4204106, 0.42041156, 0.42041239, 0.42041314, 0.42041373, 0.42041424, 0.4204146, 0.42041487, 0.42041501, 0.42041501, 0.42041489, 0.42041472, 0.42041433, 0.42041391, 0.42041335, 0.42041269, 0.42041188, 0.42041096, 0.42040995, 0.42040882, 0.4204075, 0.42040616, 0.42040467, 0.42040303, 0.4204013, 0.42039943, 0.42039746, 0.4203954, 0.4203932, 0.42039087, 0.42038846, 0.42038593, 0.42038321, 0.42038044, 0.42037755, 0.42037454, 0.42037138, 0.42036816, 0.4203648, 0.42036131, 0.4203577, 0.42035398, 0.42035013, 0.4203462, 0.42034212, 0.42033795, 0.42033362, 0.42032924, 0.42032468, 0.42032003, 0.42031524, 0.42031038, 0.42030537, 0.42030028, 0.420295, 0.42028967, 0.42028418, 0.42027861, 0.42027292, 0.42026708, 0.42026114, 0.42025509, 0.42024893, 0.42024261, 0.42023626, 0.4202297, 0.42022306, 0.42021632, 0.42020944, 0.42020243, 0.42019534, 0.42018813, 0.42018077, 0.42017335, 0.42016575, 0.42015809, 0.42015025, 0.42014232, 0.42013431, 0.42012614, 0.42011788, 0.42010945, 0.42010096, 0.42009231, 0.42008361, 0.42007476, 0.42006576, 0.42005667, 0.42004749, 0.42003813, 0.42002869, 0.42001915, 0.42000949, 0.41999969, 0.41998976, 0.41997975, 0.41996959, 0.41995934, 0.41994897, 0.41993847, 0.41992784, 0.41991714, 0.41990626, 0.41989535, 0.41988426, 0.41987309, 0.41986173, 0.41985032, 0.41983879, 0.4198271, 0.4198153, 0.41980341, 0.41979143, 0.4197793, 0.41976705, 0.41975468, 0.4197422, 0.41972962, 0.41971689, 0.41970408, 0.41969112, 0.41967806, 0.41966486, 0.4196516, 0.41963819, 0.41962463, 0.41961095, 0.41959718, 0.41958335, 0.41956934, 0.41955522, 0.41954103, 0.41952667, 0.41951218, 0.41949761, 0.41948292, 0.41946808, 0.41945317, 0.41943809, 0.41942295, 0.41940767, 0.41939226, 0.41937676, 0.41936111, 0.41934535, 0.41932949, 0.41931352, 0.4192974, 0.41928118, 0.41926488, 0.41924837, 0.4192318, 0.41921517, 0.41919833, 0.41918141, 0.41916439, 0.41914725, 0.41912997, 0.41911259, 0.4190951, 0.41907746, 0.41905969, 0.4190419, 0.41902387, 0.41900581, 0.4189876, 0.4189693, 0.41895086, 0.41893229, 0.41890138, 0.41885805, 0.4188146, 0.41877103, 0.41872743, 0.41868371, 0.4186399, 0.418596, 0.41855201, 0.41850793, 0.41846374, 0.41841948, 0.41837513, 0.41833067, 0.41828617, 0.41824153, 0.41819683, 0.418152, 0.41810712, 0.41806212, 0.41801703, 0.41797188, 0.41792661, 0.41788125, 0.4178358, 0.41779029, 0.41774464, 0.41769892, 0.41765308, 0.41760722, 0.41756123, 0.41751513, 0.41746897, 0.41742271, 0.41737634, 0.41732991, 0.41728336, 0.41723675, 0.41719002, 0.4171432, 0.41709629, 0.41704929, 0.41700223, 0.41695505, 0.41690779, 0.41686043, 0.41681302, 0.41676548, 0.41671783, 0.41667011, 0.41662234, 0.41657439, 0.41652641, 0.41647831, 0.41643018, 0.41638193, 0.41633353, 0.4162851, 0.41623655, 0.41618791, 0.41613922, 0.4160904, 0.41604146, 0.4159925, 0.41594341, 0.41589427, 0.41584501, 0.41579562, 0.41574615, 0.41569662, 0.41564703, 0.41559726, 0.41554746, 0.4154976, 0.41544759, 0.4153975, 0.41534734, 0.41529709, 0.41524673, 0.41519627, 0.41514573, 0.41509509, 0.41504437, 0.41499358, 0.41494268, 0.41489169, 0.41484058, 0.41478941, 0.41473815, 0.4146868, 0.41463533, 0.4145838, 0.41453218, 0.41448048, 0.41442865, 0.41437674, 0.41432476, 0.41427267, 0.41422051, 0.41416824, 0.41411585, 0.41406339, 0.41401088, 0.41395825, 0.41390553, 0.41385269, 0.41379985, 0.41374683, 0.41369376, 0.41364053, 0.41358733, 0.41353396, 0.41348052, 0.41342694, 0.41337335, 0.41331962, 0.41326579, 0.41321188, 0.41315791, 0.41310385, 0.41304964, 0.41299537, 0.41294101, 0.41288659, 0.41283205, 0.41277742, 0.41272268, 0.41266787, 0.41261294, 0.41255796, 0.41250288, 0.41244772, 0.41239244, 0.41233709, 0.41228163, 0.41222608, 0.41217047, 0.41211474, 0.41205895, 0.41200304, 0.41194701, 0.41189095, 0.41183478, 0.41177851, 0.41172212, 0.41166571, 0.41160917, 0.41155252, 0.41149583, 0.411439, 0.41138208, 0.4113251, 0.41126803, 0.41121083, 0.41115358, 0.41109622, 0.41103876, 0.41098124, 0.41092357, 0.41086587, 0.41080806, 0.41075012, 0.41069216, 0.41063407, 0.41057587, 0.41051763, 0.41045925, 0.41040084, 0.41034228, 0.41028363, 0.41022491, 0.41016611, 0.4101072, 0.41004822, 0.40998912, 0.40992993, 0.40987068, 0.40981132, 0.40975189, 0.40969235, 0.40963271, 0.40957296, 0.40951318, 0.40945327, 0.40939325, 0.40933317, 0.40927297, 0.40921271, 0.40915239, 0.40909192, 0.40903139, 0.40897074, 0.40891004, 0.40884921, 0.40878826, 0.40872729, 0.40866619, 0.40860507, 0.40854377, 0.4084824, 0.40842095, 0.40835944, 0.40829781, 0.40823606, 0.40817425, 0.40811235, 0.40805033, 0.40798825, 0.40792608, 0.40786383, 0.40780148, 0.40773901, 0.40767643, 0.40761384, 0.40755111, 0.40748832, 0.40742534, 0.4073624, 0.40729928, 0.4072361, 0.40717283, 0.40710947, 0.40704602, 0.40698248, 0.40691888, 0.40685514, 0.40679133, 0.4067274, 0.40666345, 0.40659934, 0.40653515, 0.40647089, 0.40640649, 0.40634206, 0.40627751, 0.40621287, 0.40614817, 0.40608335, 0.40601847, 0.40595347, 0.40588835, 0.40582317, 0.4057579, 0.40569252, 0.4056271, 0.40556157, 0.40549591, 0.4054302, 0.40536439, 0.40529844, 0.40523246, 0.40516639, 0.40510023, 0.40503392, 0.40496758, 0.40490112, 0.4048346, 0.40476796, 0.40470123, 0.40463442, 0.40456751, 0.40450048, 0.4044334, 0.40436623, 0.40429896, 0.40423161, 0.40416417, 0.4040966, 0.40402898, 0.40396121, 0.40389341, 0.40382552, 0.40375748, 0.40368944, 0.40362123, 0.40355301, 0.40348461, 0.40341616, 0.40334761, 0.40327898, 0.40321022, 0.40314141, 0.40307251, 0.40300354, 0.40293443, 0.40286526, 0.40279597, 0.40272662, 0.40265715, 0.40258762, 0.402518, 0.40244827, 0.40237844, 0.40230852, 0.40223855, 0.40216845, 0.40209827, 0.40202799, 0.40195763, 0.40188718, 0.40181667, 0.401746, 0.40167528, 0.40160444, 0.40153351, 0.40146255, 0.40139148, 0.40132028, 0.40124899, 0.40117764, 0.40110621, 0.40103462, 0.40096301, 0.40089127, 0.40081945, 0.40074757, 0.40067557, 0.40060347, 0.40053129, 0.40045902, 0.40038663, 0.40031421, 0.40024164, 0.40016901, 0.40009627, 0.40002346, 0.39995056, 0.39987752, 0.39980447, 0.39973128, 0.39965802, 0.39958465, 0.39951119, 0.39943764, 0.39936402, 0.39929026, 0.39921647, 0.39914253, 0.39906856, 0.39899445, 0.3989203, 0.398846, 0.39877161, 0.39869717, 0.39862266, 0.39854801, 0.39847326, 0.39839846, 0.39832354, 0.39824852, 0.39817348, 0.39809826, 0.39802301, 0.39794761, 0.39787218, 0.3977966, 0.39772099, 0.39764526, 0.39756942, 0.39749354, 0.39741755, 0.39734143, 0.39726526, 0.39718899, 0.39711261, 0.39703616, 0.39695963, 0.39688301, 0.39680624, 0.39672941, 0.39665252, 0.39657554, 0.39649841, 0.39642125, 0.39634398, 0.39626658, 0.39618915, 0.39611161, 0.39603397, 0.39595622, 0.3958784, 0.39580047, 0.39572251, 0.39564443, 0.39556623, 0.39548793, 0.39540958, 0.39533111, 0.39525259, 0.39517394, 0.3950952, 0.3950164, 0.39493749, 0.39485848, 0.39477938, 0.3947002, 0.39462093, 0.39454156, 0.39446211, 0.39438254, 0.3943029, 0.39422321, 0.39414337, 0.39406347, 0.39398345, 0.39390334, 0.39382321, 0.39374289, 0.39366251, 0.39358205, 0.39350155, 0.39342088, 0.39334017, 0.39325935, 0.39317843, 0.39309743, 0.39301634, 0.39293513, 0.39285383, 0.39277247, 0.39269108, 0.39260948, 0.39252785, 0.39244613, 0.39236429, 0.3922824, 0.39220038, 0.3921183, 0.39203611, 0.39195386, 0.39187148, 0.39178902, 0.39170647, 0.39162382, 0.39154109, 0.39145824, 0.39137536, 0.39129236, 0.39120924, 0.39112607, 0.3910428, 0.39095944, 0.390876, 0.39079243, 0.39070877, 0.39062506, 0.39054123, 0.3904573, 0.39037332, 0.39028922, 0.39020503, 0.39012074, 0.39003637, 0.38995191, 0.3898674, 0.38978273, 0.389698, 0.38961318, 0.38952827, 0.38944328, 0.38935816, 0.38927299, 0.38918772, 0.38910234, 0.3890169, 0.3889313, 0.38884568, 0.38875994, 0.38867411, 0.38858822, 0.38850218, 0.38841614, 0.38832995, 0.38824365, 0.38815728, 0.38807082, 0.38798428, 0.38789764, 0.38781089, 0.38772407, 0.38763714, 0.38755018, 0.38746303, 0.38737589, 0.38728857, 0.38720125, 0.38711378, 0.38702619, 0.38693857, 0.38685086, 0.38676304, 0.38667512, 0.38658708, 0.38649902, 0.38641083, 0.38632253, 0.38623419, 0.38614574, 0.38605717, 0.38596854, 0.38587978, 0.38579094, 0.38570207, 0.38561305, 0.38552397, 0.38543478, 0.38534552, 0.38525611, 0.38516665, 0.38507712, 0.38498747, 0.38489771, 0.38480788, 0.384718, 0.38462797, 0.38453788, 0.38444769, 0.38435742, 0.38426706, 0.38417658, 0.38408604, 0.38399538, 0.38390464, 0.38381383, 0.3837229, 0.38363189, 0.38354084, 0.38344961, 0.38335833, 0.38326699, 0.38317552, 0.38308397, 0.38299233, 0.3829006, 0.38280874, 0.38271686, 0.38262483, 0.38253275, 0.38244054, 0.3823483, 0.38225588, 0.38216341, 0.3820709, 0.38197824, 0.38188553, 0.38179269, 0.38169977, 0.38160679, 0.38151368, 0.38142049, 0.38132718, 0.38123381, 0.38114038, 0.38104683, 0.38095316, 0.38085943, 0.38076562, 0.38067171, 0.38057768, 0.38048363, 0.38038939, 0.38029513, 0.38020074, 0.38010627, 0.38001171, 0.37991709, 0.37982234, 0.37972754, 0.37963259, 0.37953761, 0.37944251, 0.37934729, 0.37925205, 0.37915665, 0.37906122, 0.37896565, 0.37886998, 0.37877426, 0.37867844, 0.37858251, 0.37848651, 0.3783904, 0.37829423, 0.37819797, 0.37810159, 0.37800515, 0.37790859, 0.37781194, 0.37771517, 0.37761834, 0.37752146, 0.37742442, 0.37732732, 0.37723014, 0.37713286, 0.3770355, 0.37693805, 0.37684047, 0.37674284, 0.37664506, 0.37654728, 0.37644935, 0.37635133, 0.37625325, 0.37615505, 0.37605676, 0.37595838, 0.37585992, 0.37576136, 0.37566271, 0.37556398, 0.37546515, 0.37536621, 0.37526724, 0.37516814, 0.37506893, 0.37496966, 0.37487027, 0.37477082, 0.37467125, 0.37457162, 0.37447187, 0.37437207, 0.37427214, 0.37417212, 0.37407202, 0.37397182, 0.37387154, 0.37377119, 0.37367073, 0.37357017, 0.3734695, 0.3733688, 0.37326795, 0.37316704, 0.37306601, 0.37296495, 0.37286374, 0.37276247, 0.37266105, 0.37255964, 0.37245804, 0.37235638, 0.37225464, 0.37215286, 0.37205091, 0.37194893, 0.3718468, 0.37174463, 0.37164235, 0.37153995, 0.37143749, 0.37133494, 0.3712323, 0.37112957, 0.37102675, 0.37092382, 0.37082079, 0.37071773, 0.3706145, 0.37051123, 0.37040785, 0.37030438, 0.37020084, 0.37009719, 0.36999345, 0.36988962, 0.3697857, 0.36968172, 0.36957759, 0.3694734, 0.36936909, 0.36926472, 0.36916026, 0.36905572, 0.36895105, 0.36884633, 0.36874151, 0.36863658, 0.36853155, 0.36842647, 0.36832127, 0.36821598, 0.3681106, 0.36800513, 0.36789957, 0.36779395, 0.36768821, 0.36758238, 0.36747646, 0.36737043, 0.36726436, 0.36715814, 0.36705187, 0.36694551, 0.36683899, 0.36673245, 0.36662582, 0.36651906, 0.36641225, 0.36630532, 0.3661983, 0.36609122, 0.36598399, 0.3658767, 0.36576936, 0.36566189, 0.3655543, 0.36544669, 0.36533895, 0.3652311, 0.36512321, 0.36501518, 0.36490706, 0.36479887, 0.3646906, 0.36458221, 0.36447376, 0.36436519, 0.36425653, 0.36414781, 0.36403897, 0.36393005, 0.36382103, 0.36371195, 0.36360276, 0.36349347, 0.36338407, 0.36327463, 0.36316505, 0.36305541, 0.36294568, 0.36283585, 0.36272591, 0.36261591, 0.36250579, 0.36239561, 0.36228532, 0.36217493, 0.36206448, 0.36195391, 0.36184326, 0.36173254, 0.36162168, 0.36151078, 0.36139974, 0.36128864, 0.36117744, 0.36106619, 0.36095482, 0.36084333, 0.36073178, 0.36062014, 0.36050835, 0.36039656, 0.3602846, 0.36017263, 0.36006048, 0.35994831, 0.35983601, 0.35972366, 0.35961118, 0.35949862, 0.35938597, 0.35927323, 0.35916039, 0.35904747, 0.35893446, 0.35882136, 0.35870817, 0.35859486, 0.35848147, 0.35836804, 0.35825446, 0.35814083, 0.3580271, 0.35791326, 0.35779932, 0.3576853, 0.35757118, 0.35745701, 0.35734269, 0.35722831, 0.35711387, 0.35699931, 0.35688466, 0.35676992, 0.35665512, 0.35654014, 0.35642514, 0.35631007, 0.35619485, 0.35607958, 0.35596418, 0.35584873, 0.35573319, 0.35561749, 0.35550177, 0.35538593, 0.35527, 0.35515398, 0.3550379, 0.3549217, 0.35480538, 0.354689, 0.35457253, 0.35445598, 0.35433936, 0.3542226, 0.35410577, 0.3539888, 0.35387182, 0.3537547, 0.35363752, 0.35352024, 0.35340285, 0.35328534, 0.35316783, 0.35305014, 0.35293242, 0.35281458, 0.35269666, 0.35257864, 0.35246053, 0.35234234, 0.35222405, 0.35210568, 0.35198721, 0.35186863, 0.35174999, 0.35163128, 0.3515124, 0.35139349, 0.35127446, 0.35115534, 0.35103616, 0.35091689, 0.3507975, 0.35067803, 0.35055849, 0.3504388, 0.35031909, 0.35019925, 0.3500793, 0.34995928, 0.34983921, 0.34971899, 0.34959871, 0.3494783, 0.34935787, 0.34923729, 0.34911659, 0.34899586, 0.34887505, 0.34875411, 0.34863311, 0.34851199, 0.34839082, 0.34826952, 0.34814814, 0.34802666, 0.3479051, 0.34778345, 0.3476617, 0.34753987, 0.34741795, 0.34729594, 0.34717381, 0.34705162, 0.34692931, 0.34680694, 0.34668449, 0.34656194, 0.34643927, 0.34631652, 0.34619367, 0.34607074, 0.34594771, 0.34582463, 0.34570143, 0.34557813, 0.34545475, 0.34533128, 0.34520769, 0.34508407, 0.34496033, 0.3448365, 0.34471256, 0.34458852, 0.34446445, 0.34434023, 0.34421596, 0.34409156, 0.34396711, 0.34384254, 0.3437179, 0.34359312, 0.34346831, 0.34334338, 0.34321836, 0.34309322, 0.34296805, 0.34284276, 0.34271738, 0.34259191, 0.34246632, 0.34234068, 0.34221494, 0.34208912, 0.34196314, 0.34183714, 0.34171104, 0.34158483, 0.34145856, 0.34133214, 0.34120569, 0.34107915, 0.34095252, 0.34082571, 0.3406989, 0.34057197, 0.34044495, 0.34031785, 0.34019065, 0.34006333, 0.33993599, 0.33980846, 0.33968091, 0.33955324, 0.33942553, 0.33929771, 0.33916974, 0.33904174, 0.33891362, 0.33878544, 0.33865714, 0.33852875, 0.33840027, 0.33827171, 0.33814305, 0.3380143, 0.3378855, 0.33775654, 0.33762753, 0.3374984, 0.33736923, 0.33723992, 0.33711055, 0.33698106, 0.33685148, 0.33672184, 0.33659211, 0.33646226, 0.33633232, 0.33620232, 0.33607221, 0.33594203, 0.3358117, 0.33568132, 0.33555084, 0.33542028, 0.33528963, 0.33515891, 0.33502802, 0.33489707, 0.33476609, 0.33463499, 0.33450377, 0.33437249, 0.33424112, 0.3341096, 0.33397806, 0.33384645, 0.33371466, 0.33358282, 0.33345088, 0.33331886, 0.33318672, 0.33305454, 0.33292222, 0.33278984, 0.3326574, 0.33252484, 0.33239219, 0.33225945, 0.33212659, 0.33199367, 0.33186063, 0.3317275, 0.33159432, 0.33146104, 0.33132765, 0.33119416, 0.33106059, 0.33092695, 0.3307932, 0.33065939, 0.33052546, 0.33039141, 0.33025727, 0.33012214, 0.32998595, 0.32984972, 0.32971352, 0.32957727, 0.32944101, 0.32930478, 0.32916847, 0.32903221, 0.3288959, 0.32875961, 0.32862329, 0.32848692, 0.3283506, 0.32821423, 0.32807788, 0.32794148, 0.32780507, 0.3276687, 0.32753229, 0.32739586, 0.32725942, 0.32712296, 0.32698649, 0.32685003, 0.32671353, 0.32657704, 0.32644051, 0.32630399, 0.32616746, 0.32603091, 0.32589436, 0.32575777, 0.32562119, 0.32548463, 0.32534799, 0.32521138, 0.32507476, 0.32493809, 0.32480145, 0.32466477, 0.3245281, 0.32439142, 0.32425472, 0.32411799, 0.32398126, 0.32384452, 0.32370779, 0.32357103, 0.32343423, 0.32329747, 0.32316065, 0.32302386, 0.32288703, 0.32275018, 0.32261336, 0.32247651, 0.32233965, 0.32220277, 0.32206589, 0.32192895, 0.32179201, 0.32165512, 0.32151818, 0.32138121, 0.32124427, 0.32110727, 0.32097033, 0.3208333, 0.32069629, 0.32055926, 0.32042223, 0.32028517, 0.32014814, 0.32001105, 0.31987399, 0.31973687, 0.31959975, 0.31946266, 0.31932554, 0.31918836, 0.31905124, 0.31891406, 0.31877688, 0.3186397, 0.31850252, 0.31836528, 0.31822807, 0.3180908, 0.31795359, 0.31781635, 0.31767905, 0.31754175, 0.31740445, 0.31726712, 0.31712985, 0.31699249, 0.31685516, 0.3167178, 0.31658041, 0.31644303, 0.31630567, 0.31616825, 0.3160308, 0.31589341, 0.31575596, 0.31561852, 0.31548107, 0.31534356, 0.31520605, 0.3150686, 0.31493104, 0.31479353, 0.31465602, 0.31451845, 0.31438088, 0.31424332, 0.31410575, 0.31396818, 0.31383055, 0.31369296, 0.31355527, 0.31341761, 0.31328002, 0.31314233, 0.31300464, 0.31286693, 0.31272927, 0.31259152, 0.31245387, 0.31231609, 0.31217834, 0.31204057, 0.31190279, 0.31176499, 0.31162724, 0.31148943, 0.3113516, 0.31121376, 0.31107593, 0.31093803, 0.31080016, 0.31066233, 0.3105244, 0.31038651, 0.31024858, 0.31011066, 0.30997273, 0.30983478, 0.30969679, 0.30955884, 0.30942085, 0.30928284, 0.30914485, 0.30900681, 0.3088688, 0.30873075, 0.30859268, 0.3084546, 0.30831653, 0.30817848, 0.30804032, 0.30790219, 0.30776408, 0.30762592, 0.30748779, 0.30734962, 0.30721143, 0.30707321, 0.30693504, 0.30679685, 0.3066586, 0.30652034, 0.30638209, 0.30624384, 0.30610558, 0.3059673, 0.30582902, 0.30569068, 0.30555236, 0.30541405, 0.30527568, 0.30513734, 0.30499896, 0.30486059, 0.30472219, 0.30458376, 0.30444539, 0.30430695, 0.30416852, 0.30403006, 0.3038916, 0.30375311, 0.30361465, 0.30347613, 0.30333763, 0.30319911, 0.30306056, 0.30292201, 0.30278343, 0.30264491, 0.3025063, 0.30236772, 0.30222908, 0.3020905, 0.30195183, 0.30181324, 0.30167454, 0.3015359, 0.3013972, 0.30125853, 0.30111983, 0.3009811, 0.3008424, 0.30070364, 0.30056489, 0.30042616, 0.30028737, 0.30014858, 0.30000976, 0.29987097, 0.29973218, 0.29959333, 0.29945448, 0.29931563, 0.29917675, 0.29903787, 0.29889899, 0.29876006, 0.29862115, 0.29848224, 0.29834327, 0.29820433, 0.29806536, 0.2979264, 0.2977874, 0.2976484, 0.29750937, 0.29737037, 0.29723132, 0.29709229, 0.29695323, 0.29681414, 0.29667509, 0.296536, 0.29639688, 0.29625776, 0.29611865, 0.29597947, 0.29584035, 0.29570118, 0.29556197, 0.29542282, 0.29528359, 0.29514438, 0.29500517, 0.29486591, 0.29472664, 0.29458743, 0.29444814, 0.29430887, 0.29416957, 0.29403022, 0.29389092, 0.2937516, 0.29361227, 0.29347289, 0.29333356, 0.29319417, 0.29305476, 0.29291534, 0.29277593, 0.29263651, 0.29249704, 0.29235762, 0.29221815, 0.29207867, 0.2919392, 0.29179969, 0.29166016, 0.29152066, 0.29138112, 0.29124156, 0.29110202, 0.29096246, 0.29082286, 0.29068327, 0.29054368, 0.29040405, 0.29026443, 0.29012477, 0.28998512, 0.28984547, 0.28970575, 0.2895661, 0.28942642, 0.28928667, 0.28914696, 0.28900722, 0.28886747, 0.2887277, 0.28858793, 0.28844815, 0.28830835, 0.28816852, 0.28802869, 0.28788888, 0.28774902, 0.28760916, 0.28746933, 0.28732944, 0.28718954, 0.28704962, 0.28690973, 0.28676978, 0.28662986, 0.2864899, 0.28634992, 0.28620997, 0.28606999, 0.28592995, 0.28578997, 0.28564993, 0.28550991, 0.28536984, 0.2852298, 0.28508976, 0.28494963, 0.28480953, 0.28466946, 0.28452933, 0.2843892, 0.28424907, 0.28410894, 0.28396872, 0.28382859, 0.2836884, 0.28354818, 0.28340796, 0.28326777, 0.28312752, 0.28298727, 0.28284702, 0.28270671, 0.28256646, 0.28242612, 0.28228581, 0.28214553, 0.28200516, 0.28186482, 0.28172445, 0.28158411, 0.28144372, 0.28130332, 0.28116292, 0.28102249, 0.28088206, 0.28074163, 0.2806012, 0.28046072, 0.28032023, 0.28017977, 0.28003928, 0.27989876, 0.27975824, 0.2796177, 0.27947715, 0.27933657, 0.27919602, 0.27905545, 0.27891487, 0.2787742, 0.27863365, 0.27849299, 0.27835235, 0.27821171, 0.27807105, 0.27793035, 0.27778965, 0.27764896, 0.27750826, 0.27736753, 0.27722678, 0.27708602, 0.27694529, 0.27680448, 0.27666372, 0.27652293, 0.27638209, 0.27624127, 0.27610046, 0.27595964, 0.27581877, 0.27567789, 0.27553701, 0.27539611, 0.2752552, 0.27511433, 0.27497339, 0.27483243, 0.27469146, 0.27455053, 0.27440953, 0.27426854, 0.27412757, 0.27398655, 0.27384552, 0.2737045, 0.27356344, 0.27342239, 0.27328131, 0.27314025, 0.27299914, 0.27285802, 0.27271691, 0.2725758, 0.27243465, 0.27229348, 0.27215233, 0.27201113, 0.27186993, 0.27172875, 0.27158752, 0.27144629, 0.27130505, 0.27116385, 0.27102256, 0.2708813, 0.27074, 0.27059871, 0.27045739, 0.27031609, 0.27017477, 0.27003342, 0.26989204, 0.26975065, 0.2696093, 0.26946789, 0.26932648, 0.26918507, 0.26904365, 0.26890224, 0.26876077, 0.2686193, 0.26847783, 0.26833633, 0.26819482, 0.26805335, 0.26791179, 0.26777026, 0.26762873, 0.26748717, 0.26734561, 0.26720405, 0.2670624, 0.2669208, 0.26677918, 0.26663756, 0.26649591, 0.26635426, 0.26621258, 0.26607093, 0.26592925, 0.26578754, 0.26564583, 0.26550409, 0.26536235, 0.26522061, 0.26507884, 0.26493707, 0.2647953, 0.2646535, 0.2645117, 0.26436985, 0.26422805, 0.26408619, 0.26394436, 0.26380244, 0.26366058, 0.26351869, 0.26337677, 0.26323488, 0.26309296, 0.26295102, 0.26280907, 0.26266709, 0.26252514, 0.26238313, 0.26224113, 0.26209912, 0.26195711, 0.26181507, 0.261673, 0.26153097, 0.2613889, 0.26124683, 0.2611047, 0.26096261, 0.26082051, 0.26067835, 0.26053622, 0.26039407, 0.26025191, 0.26010972, 0.25996754, 0.25982532, 0.2596831, 0.25954089, 0.25939867, 0.25925639, 0.25911418, 0.25897187, 0.25882956, 0.25868729, 0.25854498, 0.25840265, 0.25826031, 0.258118, 0.25797564, 0.25783327, 0.25769091, 0.25754848, 0.25740612, 0.25726369, 0.25712124, 0.25697878, 0.25683635, 0.2566939, 0.25655141, 0.25640896, 0.25626642, 0.2561239, 0.25598139, 0.25583884, 0.25569633, 0.25555378, 0.25541121, 0.2552686, 0.25512603, 0.25498343, 0.25484079, 0.25469819, 0.25455549, 0.25441286, 0.2542702, 0.2541275, 0.25398484, 0.25384215, 0.25369942, 0.2535567, 0.25341395, 0.25327122, 0.25312844, 0.25298566, 0.25284287, 0.25270009, 0.25255728, 0.25241446, 0.25227162, 0.25212881, 0.25198597, 0.25184307, 0.25170019, 0.25155729, 0.25141442, 0.25127146, 0.25112852, 0.25098559, 0.25084266, 0.2506997, 0.25055674, 0.25041375, 0.25027075, 0.2501277, 0.24998471, 0.24984166, 0.24969862, 0.24955556, 0.24941249, 0.2492694, 0.2491263, 0.2489832, 0.24884008, 0.24869695, 0.24855381, 0.24841067, 0.2482675, 0.24812432, 0.24798113, 0.24783793, 0.2476947, 0.2475515, 0.24740823, 0.24726498, 0.24712174, 0.24697848, 0.24683517, 0.2466919, 0.24654858, 0.24640527, 0.24626192, 0.24611856, 0.24597521, 0.24583186, 0.24568848, 0.2455451, 0.2454017, 0.24525827, 0.24511483, 0.24497141, 0.24482797, 0.24468449, 0.244541, 0.24439755, 0.24425401, 0.24411052, 0.243967, 0.24382347, 0.24367993, 0.24353634, 0.24339278, 0.24324922, 0.24310561, 0.242962, 0.24281839, 0.24267475, 0.24253111, 0.24238749, 0.24224381, 0.24210012, 0.24195646, 0.24181274, 0.24166901, 0.24152528, 0.24138156, 0.24123779, 0.24109402, 0.24095029, 0.24080646, 0.24066269, 0.24051888, 0.24037506, 0.24023125, 0.24008739, 0.23994352, 0.23979965, 0.23965578, 0.23951189, 0.23936796, 0.23922409, 0.23908015, 0.2389362, 0.23879224, 0.2386483, 0.23850432, 0.2383603, 0.23821633, 0.23807232, 0.2379283, 0.23778427, 0.23764022, 0.23749614, 0.23735212, 0.23720801, 0.2370639, 0.23691981, 0.2367757, 0.23663156, 0.23648743, 0.23634328, 0.23619907, 0.23605488, 0.23591076, 0.23576653, 0.23562232, 0.2354781, 0.23533385, 0.23518959, 0.23504536, 0.23490107, 0.23475678, 0.23461251, 0.23446816, 0.23432387, 0.23417954, 0.23403518, 0.23389082, 0.23374648, 0.23360209, 0.2334577, 0.23331326, 0.23316887, 0.23302446, 0.23288, 0.23273554, 0.23259111, 0.23244663, 0.23230213, 0.23215763, 0.23201309, 0.23186859, 0.23172405, 0.23157951, 0.23143497, 0.23129041, 0.23114577, 0.23100123, 0.23085663, 0.23071198, 0.23056734, 0.23042274, 0.23027804, 0.2301334, 0.22998872, 0.22984405, 0.22969934, 0.22955465, 0.2294099, 0.22926517, 0.22912042, 0.22897564, 0.22883089, 0.22868609, 0.22854128, 0.22839649, 0.22825168, 0.22810683, 0.22796197, 0.22781715, 0.22767226, 0.22752741, 0.2273825, 0.22723757, 0.22709268, 0.22694778, 0.2268028, 0.22665787, 0.22651291, 0.22636789, 0.22622293, 0.22607793, 0.22593291, 0.22578791, 0.2256429, 0.22549784, 0.22535278, 0.22520772, 0.22506259, 0.22491753, 0.22477242, 0.22462729, 0.22448216, 0.22433703, 0.22419186, 0.22404671, 0.22390154, 0.22375634, 0.22361115, 0.22346593, 0.22332072, 0.22317548, 0.22303022, 0.22288494, 0.2227397, 0.22259443, 0.22244911, 0.22230381, 0.22215846, 0.22201315, 0.22186781, 0.22172245, 0.22157708, 0.2214317, 0.22128631, 0.22114091, 0.22099549, 0.22085007, 0.22070463, 0.22055918, 0.22041368, 0.22026823, 0.22012275, 0.21997723, 0.21983172, 0.21968623, 0.21954067, 0.21939515, 0.21924959, 0.21910399, 0.21895844, 0.21881285, 0.21866719, 0.21852161, 0.21837598, 0.21823032, 0.21808466, 0.21793903, 0.2177933, 0.21764764, 0.21750197, 0.21735623, 0.21721052, 0.21706478, 0.21691902, 0.21677326, 0.21662752, 0.21648172, 0.21633592, 0.21619011, 0.21604428, 0.21589844, 0.21575263, 0.21560673, 0.2154609, 0.21531503, 0.21516912, 0.21502323, 0.21487731, 0.21473135, 0.21458542, 0.2144395, 0.21429352, 0.21414755, 0.21400158, 0.21385556, 0.21370956, 0.21356355, 0.21341749, 0.21327144, 0.21312541, 0.21297929, 0.21283323, 0.21268715, 0.21254103, 0.21239491, 0.2122488, 0.21210265, 0.2119565, 0.21181034, 0.21166416, 0.21151797, 0.21137178, 0.21122554, 0.21107933, 0.21093306, 0.21078682, 0.21064058, 0.21049429, 0.21034801, 0.21020174, 0.21005541, 0.20990907, 0.20976277, 0.20961641, 0.20947006, 0.2093237, 0.20917732, 0.20903094, 0.20888454, 0.20873809, 0.20859165, 0.20844525, 0.20829877, 0.20815232, 0.20800588, 0.20785937, 0.20771286, 0.20756637, 0.20741983, 0.20727329, 0.20712678, 0.2069802, 0.20683365, 0.20668706, 0.20654045, 0.20639384, 0.20624724, 0.20610058, 0.20595397, 0.20580733, 0.20566063, 0.20551397, 0.20536728, 0.20522058, 0.20507386, 0.20492715, 0.2047804, 0.20463365, 0.20448688, 0.20434012, 0.20419334, 0.20404655, 0.20389973, 0.20375293, 0.20360608, 0.20345923, 0.20331238, 0.20316552, 0.20301864, 0.20287175, 0.20272484, 0.20257792, 0.20243101, 0.20228407, 0.20213708, 0.20199016, 0.20184319, 0.20169617, 0.20154919, 0.20140219, 0.20125514, 0.20110814, 0.20096108, 0.20081401, 0.20066695, 0.20051986, 0.20037276, 0.20022565, 0.20007858, 0.19993141, 0.19978431, 0.19963714, 0.19948994, 0.19934277, 0.19919559, 0.19904839, 0.19890118, 0.19875394, 0.1986067, 0.19845946, 0.19831219, 0.19816494, 0.19801766, 0.19787036, 0.19772305, 0.19757573, 0.19742838, 0.19728106, 0.19713369, 0.19698633, 0.19683896, 0.19669157, 0.19654416, 0.19639674, 0.19624931, 0.19610184, 0.19595443, 0.195807, 0.19565949, 0.195512, 0.19536451, 0.19521698, 0.19506946, 0.19492194, 0.19477437, 0.19462684, 0.1944793, 0.19433165, 0.19418409, 0.19403648, 0.19388886, 0.19374123, 0.19359361, 0.19344592, 0.19329827, 0.19315059, 0.19300289, 0.19285519, 0.19270749, 0.19255976, 0.19241203, 0.19226429, 0.19211653, 0.19196877, 0.19182098, 0.19167316, 0.19152535, 0.19137757, 0.19122972, 0.19108187, 0.19093403, 0.19078614, 0.19063827, 0.19049039, 0.19034246, 0.19019455, 0.19004662, 0.18989867, 0.18975073, 0.18960279, 0.18945481, 0.18930684, 0.18915884, 0.1890108, 0.18886279, 0.18871477, 0.18856671, 0.18841867, 0.18827061, 0.1881225, 0.18798296, 0.18785208, 0.18772127, 0.18759054, 0.18745975, 0.18732902, 0.18719837, 0.18706772, 0.18693711, 0.18680659, 0.18667603, 0.18654557, 0.18641509, 0.18628466, 0.18615428, 0.18602397, 0.18589363, 0.1857634, 0.18563314, 0.18550293, 0.18537277, 0.18524267, 0.18511257, 0.18498251, 0.18485251, 0.18472254, 0.1845926, 0.1844627, 0.18433282, 0.184203, 0.18407324, 0.18394344, 0.18381374, 0.18368407, 0.1835544, 0.18342479, 0.18329522, 0.18316567, 0.18303619, 0.18290673, 0.18277729, 0.18264788, 0.18251853, 0.18238921, 0.18225993, 0.18213072, 0.1820015, 0.18187235, 0.18174322, 0.1816141, 0.18148503, 0.18135604, 0.181227, 0.1810981, 0.18096919, 0.18084028, 0.18071146, 0.18058267, 0.18045388, 0.18032518, 0.18019648, 0.18006781, 0.1799392, 0.17981061, 0.17968203, 0.17955354, 0.17942509, 0.17929666, 0.17916825, 0.1790399, 0.17891155, 0.1787833, 0.17865504, 0.17852679, 0.17839867, 0.17827052, 0.17814238, 0.17801432, 0.17788628, 0.17775828, 0.17763035, 0.17750239, 0.17737453, 0.17724669, 0.17711887, 0.17699109, 0.17686337, 0.17673564, 0.176608, 0.17648038, 0.17635275, 0.1762252, 0.17609771, 0.17597021, 0.17584276, 0.1757154, 0.17558798, 0.17546065, 0.17533337, 0.17520609, 0.17507888, 0.17495172, 0.17482454, 0.17469744, 0.17457035, 0.17444329, 0.17431633, 0.17418936, 0.17406242, 0.17393555, 0.17380869, 0.17368186, 0.17355506, 0.17342831, 0.17330159, 0.17317493, 0.17304833, 0.1729217, 0.17279515, 0.17266862, 0.17254211, 0.17241566, 0.17228927, 0.17216288, 0.17203651, 0.17191023, 0.17178394, 0.17165774, 0.17153154, 0.17140536, 0.17127925, 0.17115319, 0.17102709, 0.17090109, 0.17077512, 0.17064917, 0.17052327, 0.17039743, 0.17027158, 0.17014579, 0.17002003, 0.16989432, 0.16976863, 0.16964303, 0.1695174, 0.16939184, 0.16926628, 0.16914077, 0.16901533, 0.1688899, 0.1687645, 0.16863917, 0.16851386, 0.16838858, 0.1682633, 0.16813813, 0.16801295, 0.16788782, 0.16776271, 0.16763766, 0.16751266, 0.16738765, 0.1672627, 0.16713779, 0.16701292, 0.16688809, 0.16676331, 0.16663851, 0.16651379, 0.16638911, 0.16626444, 0.16613983, 0.16601527, 0.16589071, 0.16576619, 0.16564174, 0.16551729, 0.16539291, 0.16526856, 0.16514419, 0.16501991, 0.1648957, 0.16477147, 0.1646473, 0.16452317, 0.16439906, 0.16427499, 0.16415095, 0.16402695, 0.163903, 0.16377909, 0.16365519, 0.16353135, 0.16340756, 0.16328377, 0.16316003, 0.16303635, 0.16291265, 0.16278903, 0.16266549, 0.16254191, 0.16241838, 0.16229492, 0.16217147, 0.16204807, 0.16192469, 0.16180132, 0.16167809, 0.16155481, 0.16143158, 0.16130839, 0.16118525, 0.16106212, 0.16093905, 0.16081604, 0.16069299, 0.16057006, 0.16044712, 0.16032425, 0.16020137, 0.16007859, 0.15995577, 0.15983303, 0.15971033, 0.15958765, 0.15946501, 0.15934242, 0.15921985, 0.15909734, 0.15897486, 0.15885237, 0.15872999, 0.1586076, 0.15848525, 0.15836294, 0.15824066, 0.15811846, 0.15799628, 0.15787409, 0.15775196, 0.15762989, 0.15750784, 0.15738583, 0.15726389, 0.15714191, 0.15702, 0.15689817, 0.15677632, 0.15665454, 0.15653282, 0.15641104, 0.1562894, 0.15616776, 0.15604612, 0.15592457, 0.15580305, 0.15568154, 0.15556008, 0.15543866, 0.15531725, 0.15519592, 0.15507461, 0.15495332, 0.15483209, 0.1547109, 0.15458971, 0.15446858, 0.15434749, 0.15422645, 0.15410541, 0.15398446, 0.15386346, 0.15374258, 0.15362172, 0.15350087, 0.15338005, 0.15325929, 0.15313856, 0.15301789, 0.15289724, 0.15277663, 0.15265606, 0.1525355, 0.15241499, 0.15229452, 0.1521741, 0.15205368, 0.15193334, 0.15181303, 0.15169273, 0.15157248, 0.15145229, 0.15133208, 0.15121196, 0.15109186, 0.15097179, 0.15085176, 0.15073177, 0.1506118, 0.15049191, 0.15037201, 0.15025218, 0.15013237, 0.1500126, 0.14989287, 0.14977315, 0.14965351, 0.14953387, 0.14941429, 0.14929473, 0.14917521, 0.14905573, 0.14893632, 0.14881687, 0.14869751, 0.1485782, 0.1484589, 0.14833963, 0.14822042, 0.14810123, 0.14798212, 0.14786299, 0.1477439, 0.14762485, 0.14750585, 0.14738688, 0.14726798, 0.14714907, 0.14703023, 0.14691141, 0.14679261, 0.14667389, 0.14655519, 0.14643651, 0.14631787, 0.14619927, 0.1460807, 0.14596219, 0.14584373, 0.14572525, 0.14560686, 0.14548849, 0.14537013, 0.14525183, 0.14513355, 0.14501531, 0.14489715, 0.144779, 0.14466083, 0.14454277, 0.14442474, 0.14430672, 0.14418876, 0.14407082, 0.14395292, 0.14383504, 0.14371724, 0.14359942, 0.14348169, 0.14336398, 0.14324628, 0.14312865, 0.14301106, 0.14289346, 0.14277594, 0.14265844, 0.14254098, 0.14242356, 0.14230619, 0.14218879, 0.14207152, 0.14195424, 0.141837, 0.14171979, 0.14160267, 0.1414855, 0.14136842, 0.14125137, 0.14113434, 0.14101736, 0.14090042, 0.14078349, 0.14066663, 0.14054982, 0.140433, 0.14031625, 0.14019951, 0.14008282, 0.13996619, 0.13984959, 0.13973297, 0.13961644, 0.13949993, 0.13938345, 0.13926703, 0.13915063, 0.13903429, 0.13891795, 0.13880165, 0.13868542, 0.13856922, 0.13845302, 0.1383369, 0.1382208, 0.13810471, 0.1379887, 0.13787273, 0.13775676, 0.13764085, 0.13752499, 0.13740914, 0.13729331, 0.13717754, 0.13706182, 0.13694613, 0.13683048, 0.13671482, 0.13659927, 0.13648371, 0.13636816, 0.13625272, 0.13613726, 0.13602187, 0.1359065, 0.13579118, 0.13567586, 0.13556062, 0.1354454, 0.13533022, 0.13521507, 0.13509998, 0.1349849, 0.13486984, 0.13475488, 0.13463989, 0.13452499, 0.13441007, 0.13429523, 0.13418041, 0.13406567, 0.13395086, 0.13383618, 0.13372153, 0.13360688, 0.13349229, 0.13337775, 0.13326319, 0.13314874, 0.13303427, 0.13291986, 0.13280548, 0.13269116, 0.13257685, 0.13246255, 0.13234834, 0.13223416, 0.13212, 0.1320059, 0.1318918, 0.13177778, 0.13166375, 0.13154975, 0.13143586, 0.13132194, 0.13120806, 0.13109426, 0.13098051, 0.13086672, 0.130753, 0.1306393, 0.13052566, 0.1304121, 0.13029848, 0.13018496, 0.13007149, 0.12995803, 0.12984459, 0.12973122, 0.12961787, 0.12950459, 0.12939128, 0.12927802, 0.12916484, 0.12905167, 0.12893854, 0.12882547, 0.12871245, 0.12859941, 0.12848642, 0.12837347, 0.12826057, 0.12814768, 0.12803487, 0.12792206, 0.12780932, 0.12769657, 0.12758388, 0.12747124, 0.12735862, 0.12724604, 0.12713353, 0.12702103, 0.12690854, 0.1267961, 0.12668373, 0.12657136, 0.12645903, 0.12634677, 0.12623453, 0.12612233, 0.12601013, 0.12589797, 0.1257859, 0.12567386, 0.1255618, 0.12544982, 0.1253379, 0.12522595, 0.12511407, 0.12500224, 0.12489043, 0.12477867, 0.12466692, 0.12455523, 0.12444358, 0.12433194, 0.12422035, 0.12410881, 0.12399732, 0.12388586, 0.12377436, 0.12366299, 0.12355162, 0.12344029, 0.12332901, 0.12321775, 0.12310655, 0.12299537, 0.12288419, 0.1227731, 0.12266202, 0.12255097, 0.12243999, 0.12232908, 0.12221811, 0.12210721, 0.12199639, 0.12188554, 0.12177476, 0.12166401, 0.12155332, 0.12144268, 0.12133201, 0.12122142, 0.12111089, 0.12100036, 0.12088986, 0.12077942, 0.120669, 0.12055865, 0.1204483, 0.120338, 0.12022773, 0.12011755, 0.12000731, 0.11989715, 0.11978708, 0.11967698, 0.11956692, 0.11945692, 0.11934695, 0.11923702, 0.11912711, 0.11901725, 0.11890744, 0.11879764, 0.11868788, 0.1185782, 0.11846853, 0.11835886, 0.11824926, 0.11813971, 0.11803018, 0.11792067, 0.11781123, 0.11770181, 0.11759242, 0.11748307, 0.11737375, 0.1172645, 0.11715525, 0.11704605, 0.11693689, 0.11682781, 0.11671866, 0.1166096, 0.11650062, 0.11639163, 0.11628266, 0.1161738, 0.11606491, 0.1159561, 0.11584727, 0.11573851, 0.11562981, 0.11552114, 0.1154125, 0.11530386, 0.1151953, 0.11508676, 0.11497823, 0.11486981, 0.11476135, 0.11465298, 0.11454462, 0.11443627, 0.11432802, 0.11421975, 0.11411154, 0.11400338, 0.11389528, 0.11378714, 0.11367908, 0.11357106, 0.11346307, 0.1133551, 0.11324719, 0.11313933, 0.1130315, 0.11292367, 0.11281589, 0.1127082, 0.11260049, 0.11249281, 0.11238521, 0.1122776, 0.11217009, 0.11206257, 0.11195509, 0.11184767, 0.11174029, 0.11163287, 0.11152555, 0.11141828, 0.11131101, 0.11120379, 0.11109664, 0.11098946, 0.11088239, 0.11077528, 0.11066825, 0.11056129, 0.11045431, 0.11034738, 0.11024052, 0.11013369, 0.11002686, 0.10992005, 0.10981333, 0.10970663, 0.10959993, 0.10949336, 0.10938673, 0.10928017, 0.10917366, 0.10906716, 0.10896072, 0.10885433, 0.10874793, 0.10864162, 0.10853532, 0.10842906, 0.10832281, 0.10821666, 0.1081105, 0.10800435, 0.10789829, 0.10779222, 0.10768625, 0.10758026, 0.10747433, 0.10736844, 0.10726262, 0.10715674, 0.10705096, 0.10694523, 0.10683952, 0.10673384, 0.10662822, 0.10652261, 0.10641707, 0.10631153, 0.106206, 0.10610056, 0.10599513, 0.10588975, 0.10578443, 0.10567914, 0.10557383, 0.10546858, 0.10536342, 0.10525825, 0.10515312, 0.10504802, 0.10494298, 0.10483796, 0.10473299, 0.10462804, 0.10452317, 0.10441829, 0.10431343, 0.10420866, 0.10410388, 0.10399917, 0.10389449, 0.10378983, 0.10368523, 0.10358065, 0.10347611, 0.10337159, 0.10326716, 0.10316274, 0.10305832, 0.10295399, 0.10284966, 0.10274537, 0.10264114, 0.10253692, 0.10243277, 0.10232863, 0.10222452, 0.10212049, 0.10201649, 0.10191245, 0.10180852, 0.10170461, 0.10160072, 0.10149687, 0.10139309, 0.10128932, 0.10118558, 0.10108189, 0.10097823, 0.10087463, 0.10077102, 0.10066748, 0.10056397, 0.10046053, 0.10035707, 0.10025367, 0.10015033, 0.100047, 0.099943675, 0.09984047, 0.09973722, 0.099634051, 0.099530913, 0.099427782, 0.099324733, 0.099221691, 0.099118695, 0.099015735, 0.098912843, 0.098809935, 0.098707087, 0.098604299, 0.098501511, 0.09839876, 0.098296061, 0.098193392, 0.098090775, 0.097988158, 0.097885616, 0.097783111, 0.097680651, 0.097578153, 0.097475767, 0.097373426, 0.097271085, 0.097168759, 0.097066514, 0.096964277, 0.096862108, 0.096759938, 0.09665782, 0.096555769, 0.096453719, 0.096351705, 0.096249752, 0.096147783, 0.096045919, 0.095944047, 0.095842212, 0.09574046, 0.095638692, 0.09553697, 0.095435306, 0.09533371, 0.095232084, 0.095130511, 0.095029011, 0.094927497, 0.094826035, 0.094724618, 0.094623238, 0.094521903, 0.094420604, 0.094319321, 0.094218113, 0.094116896, 0.094015718, 0.093914591, 0.093813531, 0.093712479, 0.093611456, 0.093510501, 0.093409561, 0.09330865, 0.093207769, 0.093106933, 0.093006149, 0.092905395, 0.092804685, 0.09270402, 0.092603371, 0.092502765, 0.09240216, 0.092301652, 0.092201144, 0.092100672, 0.092000276, 0.091899849, 0.091799505, 0.09169919, 0.091598906, 0.09149868, 0.091398448, 0.091298275, 0.091198146, 0.091098078, 0.090998009, 0.090897985, 0.090797998, 0.090698056, 0.090598144, 0.090498276, 0.090398423, 0.090298645, 0.09019886, 0.090099134, 0.089999452, 0.089899831, 0.089800142, 0.089700587, 0.089601055, 0.089501552, 0.089402065, 0.089302637, 0.089203238, 0.089103892, 0.089004509, 0.088905238, 0.088806003, 0.088706799, 0.088607602, 0.088508479, 0.088409357, 0.088310294, 0.088211261, 0.088112257, 0.088013336, 0.087914385, 0.087815486, 0.087716669, 0.087617874, 0.087519087, 0.087420344, 0.087321669, 0.087222978, 0.087124355, 0.087025762, 0.086927198, 0.086828694, 0.086730205, 0.086631767, 0.086533383, 0.08643499, 0.08633662, 0.086238354, 0.086140119, 0.086041883, 0.085943684, 0.085845552, 0.085747436, 0.085649341, 0.085551314, 0.085453302, 0.085355364, 0.085257418, 0.085159525, 0.085061662, 0.084963858, 0.084866039, 0.084768303, 0.084670626, 0.084572949, 0.084475294, 0.084377706, 0.084280133, 0.084182627, 0.084085114, 0.083987653, 0.083890259, 0.083792858, 0.083695538, 0.083598219, 0.083500966, 0.083403721, 0.083306529, 0.083209395, 0.083112262, 0.083015151, 0.082918122, 0.082821101, 0.082724147, 0.082627185, 0.082530282, 0.082433432, 0.082336605, 0.082239792, 0.082143046, 0.082046352, 0.081949666, 0.081853002, 0.081756428, 0.081659846, 0.081563279, 0.081466794, 0.081370331, 0.081273921, 0.081177518, 0.081081167, 0.080984883, 0.080888569, 0.080792323, 0.080696143, 0.080599964, 0.080503829, 0.080407754, 0.080311678, 0.080215648, 0.080119714, 0.080023736, 0.07992781, 0.079831958, 0.079736121, 0.079640314, 0.079544552, 0.079448819, 0.079353169, 0.079257481, 0.079161853, 0.079066269, 0.078970738, 0.078875229, 0.07877975, 0.078684367, 0.078588918, 0.078493573, 0.078398272, 0.078302957, 0.078207701, 0.07811252, 0.078017324, 0.077922195, 0.077827096, 0.077732004, 0.077636994, 0.077541992, 0.077447034, 0.077352114, 0.077257283, 0.07716237, 0.077067576, 0.07697282, 0.076878056, 0.076783367, 0.076688722, 0.07659407, 0.076499507, 0.076404952, 0.076310419, 0.07621596, 0.076121546, 0.076027125, 0.075932749, 0.075838394, 0.075744092, 0.075649858, 0.075555645, 0.075463191, 0.075372644, 0.07528206, 0.075191543, 0.075101137, 0.07501065, 0.074920274, 0.074830003, 0.074739762, 0.074649483, 0.074559279, 0.074469142, 0.074379042, 0.074288934, 0.074198939, 0.074108973, 0.074019074, 0.073929176, 0.073839314, 0.07374955, 0.073659793, 0.073570028, 0.073480405, 0.073390745, 0.073301226, 0.073211633, 0.073122144, 0.073032729, 0.072943345, 0.072853893, 0.072764605, 0.072675362, 0.072586149, 0.072496898, 0.07240779, 0.072318681, 0.072229676, 0.072140627, 0.072051659, 0.071962751, 0.071873844, 0.07178501, 0.071696237, 0.071607545, 0.071518809, 0.071430102, 0.071341544, 0.071252942, 0.071164384, 0.071075924, 0.0709875, 0.070899107, 0.070810713, 0.070722423, 0.070634171, 0.070545919, 0.070457734, 0.070369646, 0.070281565, 0.070193514, 0.070105463, 0.070017554, 0.069929637, 0.069841728, 0.069753915, 0.069666147, 0.069578439, 0.069490694, 0.069403015, 0.069315456, 0.069227919, 0.069140345, 0.069052882, 0.06896548, 0.068878084, 0.068790719, 0.06870342, 0.068616159, 0.068528965, 0.068441771, 0.068354644, 0.068267584, 0.068180494, 0.068093508, 0.06800659, 0.067919709, 0.067832857, 0.067745969, 0.067659251, 0.067572504, 0.067485787, 0.067399181, 0.067312568, 0.067226022, 0.067139514, 0.067053013, 0.066966601, 0.066880234, 0.066793859, 0.066707589, 0.066621318, 0.066535152, 0.066448957, 0.066362821, 0.066276796, 0.066190727, 0.066104732, 0.066018805, 0.065932952, 0.065847054, 0.065761231, 0.065675475, 0.065589756, 0.065504037, 0.065418445, 0.06533283, 0.065247312, 0.065161794, 0.065076321, 0.064990938, 0.064905591, 0.064820178, 0.064734936, 0.064649694, 0.064564489, 0.064479306, 0.064394243, 0.064309172, 0.064224169, 0.064139128, 0.064054199, 0.063969329, 0.063884459, 0.063799635, 0.063714907, 0.063630208, 0.063545555, 0.063460894, 0.06337633, 0.063291781, 0.063207254, 0.063122831, 0.063038409, 0.062954098, 0.062869713, 0.062785424, 0.06270124, 0.062616996, 0.06253285, 0.062448766, 0.062364757, 0.062280715, 0.062196709, 0.062112834, 0.062028926, 0.061945051, 0.061861284, 0.061777513, 0.061693847, 0.061610144, 0.061526511, 0.061442979, 0.061359484, 0.061275918, 0.06119249, 0.061109133, 0.061025776, 0.060942411, 0.060859159, 0.060775936, 0.06069278, 0.06060959, 0.060526505, 0.060443491, 0.060360476, 0.060277455, 0.060194574, 0.060111698, 0.060028885, 0.059946075, 0.059863295, 0.059780624, 0.059697945, 0.059615307, 0.059532769, 0.059450299, 0.059367828, 0.059285324, 0.059202958, 0.059120629, 0.059038263, 0.058956031, 0.058873806, 0.058791678, 0.058709517, 0.058627389, 0.058545396, 0.058463339, 0.058381386, 0.058299497, 0.058217674, 0.058135826, 0.058054008, 0.057972327, 0.057890605, 0.057808995, 0.057727348, 0.057645768, 0.057564296, 0.057482783, 0.05740137, 0.057320002, 0.057238694, 0.05715739, 0.057076082, 0.056994911, 0.056913748, 0.056832578, 0.056751512, 0.056670483, 0.056589521, 0.056508519, 0.056427628, 0.0563468, 0.056265943, 0.056185145, 0.056104463, 0.056023803, 0.05594315, 0.055862531, 0.055781979, 0.055701498, 0.055620972, 0.055540591, 0.055460211, 0.055379901, 0.055299588, 0.055219311, 0.055139136, 0.055059027, 0.054978821, 0.054898776, 0.054818779, 0.054738805, 0.054658838, 0.054578971, 0.054499101, 0.054419301, 0.054339502, 0.054259773, 0.054180142, 0.054100484, 0.054020856, 0.053941362, 0.053861842, 0.053782418, 0.053702958, 0.053623572, 0.053544287, 0.053464964, 0.053385749, 0.053306565, 0.053227454, 0.053148337, 0.053069223, 0.052990247, 0.05291127, 0.052832294, 0.052753419, 0.052674577, 0.052595805, 0.052517001, 0.052438296, 0.052359663, 0.052280992, 0.052202392, 0.052123889, 0.052045427, 0.051966965, 0.051888533, 0.051810171, 0.051731847, 0.051653553, 0.051575363, 0.051497173, 0.051419053, 0.05134093, 0.051262844, 0.051184859, 0.051106945, 0.051028926, 0.050951079, 0.050873265, 0.050795484, 0.05071767, 0.050639994, 0.050562352, 0.050484743, 0.050407134, 0.050329596, 0.050252158, 0.050174654, 0.050097249, 0.05001992, 0.04994265, 0.049865384, 0.049788121, 0.049710993, 0.049633827, 0.049556699, 0.049479675, 0.04940268, 0.04932576, 0.0492488, 0.049171913, 0.049095128, 0.049018268, 0.048941553, 0.048864868, 0.048788253, 0.048711639, 0.048635025, 0.048558544, 0.048482034, 0.048405588, 0.048329212, 0.048252869, 0.048176598, 0.048100326, 0.048024055, 0.047947951, 0.047871813, 0.047795679, 0.04771968, 0.047643684, 0.047567751, 0.047491789, 0.047415923, 0.047340132, 0.047264371, 0.04718858, 0.047112923, 0.047037296, 0.046961676, 0.046886086, 0.046810605, 0.046735119, 0.046659734, 0.046584316, 0.046508968, 0.046433687, 0.046358407, 0.046283197, 0.046208054, 0.046132978, 0.046057902, 0.04598283, 0.045907855, 0.045832917, 0.045757983, 0.045683149, 0.045608308, 0.045533579, 0.045458812, 0.04538415, 0.045309518, 0.045234889, 0.045160327, 0.04508587, 0.045011412, 0.044936989, 0.044862598, 0.044788275, 0.044713989, 0.044639699, 0.044565547, 0.044491366, 0.044417284, 0.044343203, 0.044269156, 0.044195209, 0.044121295, 0.044047423, 0.043973509, 0.043899737, 0.043825965, 0.043752223, 0.043678585, 0.043604951, 0.043531381, 0.04345778, 0.043384276, 0.043310847, 0.043237418, 0.043164052, 0.043090757, 0.043017499, 0.042944204, 0.042871043, 0.042797852, 0.042724799, 0.042651676, 0.042578723, 0.042505771, 0.042432785, 0.042359933, 0.042287052, 0.042214304, 0.04214149, 0.042068809, 0.041996133, 0.041923523, 0.04185098, 0.041778404, 0.041705932, 0.041633528, 0.041561089, 0.041488685, 0.041416384, 0.041344151, 0.041271884, 0.041199718, 0.041127551, 0.04105546, 0.040983465, 0.040911399, 0.040839478, 0.040767517, 0.04069566, 0.040623803, 0.04055205, 0.040480331, 0.040408574, 0.040336955, 0.040265307, 0.040193759, 0.040122177, 0.04005073, 0.039979316, 0.039907869, 0.039836563, 0.03976522, 0.039693978, 0.039622705, 0.039551567, 0.039480392, 0.039409325, 0.039338324, 0.039267287, 0.039196353, 0.039125495, 0.039054561, 0.038983695, 0.038912937, 0.038842242, 0.038771514, 0.03870089, 0.038630232, 0.038559709, 0.038489155, 0.038418703, 0.03834828, 0.038277864, 0.03820755, 0.038137194, 0.038066983, 0.037996802, 0.037926592, 0.037856482, 0.037786372, 0.037716359, 0.037646316, 0.037576415, 0.037506543, 0.037436634, 0.037366766, 0.037297033, 0.037227329, 0.037157629, 0.037087999, 0.037018437, 0.036948837, 0.036879346, 0.03680985, 0.03674046, 0.036671031, 0.036601707, 0.036532383, 0.036463164, 0.036393978, 0.036324792, 0.03625571, 0.036186658, 0.03611761, 0.036048561, 0.035979647, 0.03591077, 0.03584189, 0.035773113, 0.035704304, 0.035635598, 0.035566892, 0.035498284, 0.03542975, 0.035361145, 0.035292678, 0.035224173, 0.035155777, 0.035087444, 0.035019081, 0.034950819, 0.034882523, 0.034814361, 0.034746166, 0.034678113, 0.034610055, 0.034541998, 0.034474045, 0.034406088, 0.034338206, 0.03427032, 0.034202572, 0.034134824, 0.034067076, 0.033999424, 0.033931781, 0.033864241, 0.033796627, 0.033729184, 0.033661675, 0.033594303, 0.033526964, 0.033459596, 0.033392359, 0.033325087, 0.033257924, 0.033190757, 0.033123657, 0.033056628, 0.032989599, 0.032922637, 0.032855675, 0.032788817, 0.032721959, 0.032655168, 0.032588448, 0.032521725, 0.032455072, 0.032388419, 0.03232187, 0.032255385, 0.03218887, 0.032122355, 0.032056008, 0.031989664, 0.03192332, 0.031857073, 0.031790871, 0.031724662, 0.031658553, 0.031592418, 0.031526379, 0.031460341, 0.031394407, 0.031328473, 0.031262606, 0.03119681, 0.031130977, 0.031065283, 0.030999521, 0.030933894, 0.030868232, 0.03080271, 0.030737221, 0.030671699, 0.030606311, 0.030540857, 0.030475538, 0.030410219, 0.030344969, 0.030279789, 0.030214574, 0.03014946, 0.030084349, 0.030019337, 0.029954361, 0.029889354, 0.029824479, 0.029759571, 0.029694766, 0.029629963, 0.029565262, 0.029500594, 0.029435894, 0.029371258, 0.029306728, 0.029242231, 0.029177735, 0.029113341, 0.029048981, 0.028984623, 0.02892033, 0.028856041, 0.028791888, 0.028727662, 0.028663576, 0.028599458, 0.028535441, 0.02847149, 0.028407509, 0.028343629, 0.028279714, 0.028215937, 0.028152125, 0.028088415, 0.028024776, 0.027961101, 0.027897526, 0.027833924, 0.027770452, 0.027706949, 0.027643582, 0.027580213, 0.027516849, 0.027453585, 0.027390322, 0.027327126, 0.027263997, 0.027200837, 0.027137743, 0.027074752, 0.027011797, 0.026948808, 0.026885955, 0.026823135, 0.026760282, 0.026697462, 0.026634779, 0.026572132, 0.026509451, 0.026446905, 0.026384326, 0.026321849, 0.026259407, 0.026196964, 0.026134625, 0.026072284, 0.026010012, 0.025947742, 0.025885573, 0.025823439, 0.025761304, 0.025699273, 0.025637208, 0.025575278, 0.025513316, 0.025451453, 0.025389628, 0.025327768, 0.025266046, 0.025204321, 0.025142666, 0.025081011, 0.025019459, 0.02495794, 0.024896422, 0.024834972, 0.024773557, 0.024712211, 0.024650931, 0.024589619, 0.024528375, 0.024467198, 0.02440609, 0.024344949, 0.02428391, 0.02422294, 0.024161937, 0.024100965, 0.024040133, 0.023979299, 0.023918465, 0.023857769, 0.023797004, 0.023736376, 0.023675781, 0.023615189, 0.023554698, 0.023494173, 0.02343375, 0.023373293, 0.023312973, 0.023252686, 0.0231924, 0.023132218, 0.023071967, 0.023011887, 0.022951737, 0.022891724, 0.022831749, 0.02277177, 0.02271186, 0.022651952, 0.022592146, 0.022532338, 0.02247267, 0.022412896, 0.022353295, 0.02229373, 0.022234095, 0.02217463, 0.022115167, 0.022055702, 0.021996273, 0.021936946, 0.021877687, 0.021818394, 0.021759203, 0.021699978, 0.021640891, 0.021581771, 0.021522751, 0.021463767, 0.021404782, 0.021345899, 0.021287017, 0.021228204, 0.021169458, 0.021110712, 0.021052036, 0.020993359, 0.020934785, 0.020876177, 0.020817706, 0.02075927, 0.020700797, 0.02064243, 0.02058406, 0.020525794, 0.020467494, 0.020409331, 0.020351201, 0.020293038, 0.020234978, 0.020176917, 0.020118959, 0.020060968, 0.020003112, 0.019945189, 0.019887438, 0.019829683, 0.019771932, 0.019714247, 0.019656701, 0.019599017, 0.019541468, 0.019483991, 0.019426547, 0.019369103, 0.01931176, 0.019254385, 0.019197112, 0.019139906, 0.019082667, 0.019025533, 0.018968398, 0.018911364, 0.018854296, 0.018797331, 0.018740434, 0.018683502, 0.018626606, 0.018569846, 0.018513121, 0.01845636, 0.018399704, 0.018343115, 0.018286493, 0.018229974, 0.018173419, 0.018117001, 0.01806055, 0.018004201, 0.017947853, 0.017891606, 0.017835394, 0.017779183, 0.017723039, 0.017666897, 0.017610891, 0.017554814, 0.017498875, 0.017442973, 0.017387034, 0.017331233, 0.017275399, 0.017219666, 0.017163932, 0.017108304, 0.017052706, 0.016997077, 0.016941585, 0.016886057, 0.016830666, 0.016775277, 0.016719887, 0.016664598, 0.016609311, 0.016554093, 0.016498875, 0.016443757, 0.016388709, 0.016333593, 0.016278544, 0.016223634, 0.016168721, 0.01611381, 0.016059004, 0.016004264, 0.015949454, 0.015894784, 0.015840078, 0.01578551, 0.015730908, 0.015676405, 0.015621872, 0.015567475, 0.015513111, 0.015458714, 0.015404419, 0.015350193, 0.015295932, 0.015241739, 0.015187616, 0.015133561, 0.015079472, 0.015025519, 0.014971499, 0.014917614, 0.014863729, 0.014809914, 0.014756168, 0.014702386, 0.014648742, 0.01459503, 0.014541454, 0.014487911, 0.01443437, 0.014380864, 0.014327459, 0.014274088, 0.014220751, 0.014167484, 0.01411425, 0.014061017, 0.014007783, 0.013954686, 0.013901658, 0.013848561, 0.013795602, 0.013742609, 0.013689751, 0.013636895, 0.013584036, 0.013531317, 0.013478528, 0.013425877, 0.013373191, 0.013320643, 0.013268094, 0.013215545, 0.013163098, 0.013110652, 0.013058309, 0.013005931, 0.012953656, 0.01290145, 0.012849209, 0.012797071, 0.012744932, 0.012692863, 0.012640793, 0.01258886, 0.012536928, 0.012484995, 0.012433166, 0.012381336, 0.012329575, 0.012277882, 0.012226188, 0.012174495, 0.012122938, 0.012071417, 0.012019861, 0.011968441, 0.011917057, 0.011865637, 0.011814287, 0.011763039, 0.011711859, 0.011660611, 0.0116095, 0.011558355, 0.011507312, 0.011456304, 0.011405297, 0.011354391, 0.01130345, 0.011252647, 0.01120181, 0.011151075, 0.01110041, 0.011049675, 0.010999077, 0.01094848, 0.010897951, 0.010847422, 0.010796996, 0.010746603, 0.010696212, 0.010645922, 0.010595598, 0.010545411, 0.010495191, 0.010445072, 0.01039492, 0.010344905, 0.010294923, 0.010244908, 0.010194994, 0.01014515, 0.010095271, 0.010045427, 0.0099957194, 0.0099460455, 0.0098963389, 0.0098467339, 0.0097971298, 0.0097476272, 0.0096981591, 0.0096486909, 0.0095993262, 0.009549927, 0.0095006302, 0.0094513334, 0.00940214, 0.0093529793, 0.0093038203, 0.0092547974, 0.009205672, 0.009156717, 0.0091077294, 0.0090588434, 0.0090099918, 0.0089611057, 0.0089123566, 0.0088635739, 0.0088148937, 0.0087662125, 0.0087176356, 0.0086690914, 0.0086205136, 0.0085720727, 0.0085235983, 0.0084752254, 0.0084268535, 0.008378583, 0.00833028, 0.0082820784, 0.0082339458, 0.0081857787, 0.008137715, 0.0080896839, 0.0080416547, 0.007993659, 0.0079458002, 0.0078979414, 0.0078500826, 0.0078023262, 0.0077545703, 0.0077069169, 0.0076592974, 0.007611644, 0.0075641274, 0.0075165424, 0.0074691288, 0.0074216467, 0.0073743006, 0.0073269904, 0.0072796452, 0.0072324015, 0.0071851932, 0.0071380534, 0.0070908796, 0.0070438418, 0.0069968048, 0.0069498019, 0.0069028675, 0.006855967, 0.0068091354, 0.0067623039, 0.0067155403, 0.0066687767, 0.0066221161, 0.0065755239, 0.0065288972, 0.0064823739, 0.0064358842, 0.0063893949, 0.0063429056, 0.0062965872, 0.0062502688, 0.0062039504, 0.0061577344, 0.006111485, 0.0060653724, 0.0060191904, 0.0059731463, 0.0059271702, 0.005881126, 0.0058352523, 0.0057893107, 0.0057434719, 0.0056977011, 0.0056518959, 0.005606194, 0.0055604917, 0.0055148927, 0.0054692593, 0.0054237279, 0.0053782654, 0.0053327689, 0.0052873404, 0.0052419808, 0.0051966896, 0.005151364, 0.0051061753, 0.0050609866, 0.0050157984, 0.0049707466, 0.0049256263, 0.004880643, 0.0048356256, 0.0047907112, 0.0047457963, 0.0047009843, 0.0046562403, 0.0046114628, 0.0045667877, 0.0045221467, 0.004477472, 0.0044328654, 0.0043883612, 0.0043438915, 0.0042993873, 0.004255021, 0.0042106197, 0.0041663209, 0.0041220225, 0.0040778266, 0.0040336652, 0.0039894693, 0.0039454103, 0.0039013172, 0.0038573267, 0.0038134048, 0.0037694485, 0.0037255951, 0.0036817074, 0.0036379567, 0.0035941715, 0.0035504892, 0.0035068411, 0.0034631931, 0.0034195792, 0.0033761023, 0.0033326254, 0.0032891484, 0.0032457742, 0.0032023999, 0.0031591284, 0.0031158912, 0.0030726199, 0.0030294508, 0.0029862821, 0.0029432501, 0.0029001499, 0.0028571866, 0.0028142573, 0.0027712937, 0.0027284333, 0.0026855725, 0.0026428145, 0.0026000564, 0.0025574355, 0.0025147803, 0.002472159, 0.0024296064, 0.0023870538, 0.0023446039, 0.0023021197, 0.0022597725, 0.0022174595, 0.0021751125, 0.0021329022, 0.0020906234, 0.0020484817, 0.0020064083, 0.0019642664, 0.0019221932, 0.0018802226, 0.0018383204, 0.0017963497, 0.001754516, 0.0017127165, 0.0016709171, 0.0016292204, 0.0015874894, 0.0015458611, 0.0015042329, 0.0014627072, 0.0014211474, 0.0013797245, 0.0013383359, 0.0012969129, 0.0012555928, 0.0012142383, 0.0011730551, 0.0011318034, 0.0010906544, 0.0010495739, 0.001008459, 0.00096744689, 0.00092643482, 0.00088552549, 0.00084458187, 0.00080374099, 0.0007629685, 0.00072216184, 0.00068145787, 0.00064075389, 0.00060011836, 0.00055955135, 0.0005190185, 0.00047855417, 0.00043805558, 0.00039765972, 0.00035722961, 0.00031693644, 0.00027667751, 0.00023641856, 0.00019615963, 0.00015603763, 0.00011594986, 7.5862081e-05, 3.5842782e-05, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043, 0.0067857043   }, 
   { 0.052044392, 0.051903009, 0.051761456, 0.05162042, 0.051479377, 0.051338509, 0.051198319, 0.051057622, 0.050917432, 0.05077707, 0.050637051, 0.050497033, 0.050357699, 0.050218023, 0.050078683, 0.049939174, 0.049800009, 0.049661011, 0.04952253, 0.049383704, 0.049244877, 0.049106561, 0.048968248, 0.048830103, 0.048692469, 0.048554491, 0.04841686, 0.048279401, 0.048141938, 0.048004642, 0.047868032, 0.047731079, 0.047594298, 0.047457516, 0.047321074, 0.047184803, 0.047048874, 0.046912771, 0.046776671, 0.046640914, 0.046505325, 0.046369903, 0.046234995, 0.046099748, 0.045964841, 0.045829926, 0.045695189, 0.045560624, 0.045426566, 0.04529234, 0.045158286, 0.045024227, 0.044890512, 0.044756796, 0.044623591, 0.044490214, 0.04435667, 0.044223808, 0.044090774, 0.043958079, 0.043825727, 0.043693371, 0.043561019, 0.043428838, 0.043296825, 0.043165151, 0.043033481, 0.042901982, 0.042770479, 0.042639147, 0.042508155, 0.042377509, 0.042246688, 0.042115696, 0.041985217, 0.041854911, 0.0417246, 0.0415948, 0.041464835, 0.041335206, 0.041205406, 0.04107612, 0.040946666, 0.040817715, 0.040688772, 0.040559825, 0.04043122, 0.040302616, 0.040174179, 0.040046085, 0.039917987, 0.039789725, 0.03966197, 0.039534215, 0.039406635, 0.039279729, 0.039152317, 0.039025243, 0.038898341, 0.038771611, 0.03864488, 0.038518827, 0.038392436, 0.038266215, 0.038140167, 0.038014114, 0.037888408, 0.037763204, 0.037637837, 0.037512127, 0.037387099, 0.037262071, 0.03713721, 0.037012864, 0.036888175, 0.036763832, 0.036639482, 0.036515474, 0.036391813, 0.036267973, 0.036144305, 0.036020815, 0.035897486, 0.035774164, 0.03565152, 0.035528533, 0.035405718, 0.035282906, 0.035160434, 0.035038128, 0.034916341, 0.034794204, 0.034672413, 0.034550618, 0.034428999, 0.034307718, 0.034186777, 0.034065668, 0.033944555, 0.033823788, 0.033703018, 0.033582587, 0.033462498, 0.033342239, 0.033221982, 0.033102062, 0.032982312, 0.032862566, 0.032743499, 0.032624092, 0.032504853, 0.032385789, 0.032266892, 0.032148167, 0.032029949, 0.031911567, 0.031793181, 0.031675138, 0.031557091, 0.031439219, 0.031321853, 0.03120432, 0.031086616, 0.030969422, 0.0308524, 0.030735377, 0.030618867, 0.030502183, 0.030385843, 0.030269332, 0.030153161, 0.030037161, 0.0299215, 0.029805841, 0.029690182, 0.029574692, 0.02945937, 0.029344223, 0.029229585, 0.029114777, 0.0289998, 0.028885162, 0.028770693, 0.028656736, 0.028542781, 0.028428653, 0.028314866, 0.028201252, 0.028087808, 0.027974701, 0.027861426, 0.02774832, 0.027635386, 0.027522624, 0.027410029, 0.027297946, 0.027185522, 0.027073441, 0.026961187, 0.026849275, 0.026737532, 0.026626302, 0.026514899, 0.0264035, 0.026292438, 0.026181377, 0.026070656, 0.025960276, 0.025849728, 0.025739348, 0.025629139, 0.025518931, 0.025408892, 0.025299534, 0.025189837, 0.025080139, 0.024970781, 0.024861593, 0.024752576, 0.024644071, 0.024535226, 0.024426719, 0.024318213, 0.024209877, 0.024101712, 0.023994058, 0.023886235, 0.023778582, 0.023671098, 0.023563614, 0.023456302, 0.023349499, 0.023242526, 0.023135554, 0.023028921, 0.02292246, 0.022815999, 0.022710219, 0.022604097, 0.022498146, 0.022392366, 0.022286756, 0.022181317, 0.022076389, 0.02197112, 0.021866189, 0.021761261, 0.021656504, 0.021551916, 0.021447837, 0.021343591, 0.021239344, 0.021135267, 0.021031531, 0.020928137, 0.020824568, 0.020721175, 0.020617951, 0.020514894, 0.020412011, 0.020309465, 0.020206923, 0.02010438, 0.020002006, 0.019899974, 0.019797768, 0.019696247, 0.019594556, 0.019493032, 0.019391341, 0.019289989, 0.01918881, 0.019088138, 0.018987468, 0.018886629, 0.018786129, 0.018685799, 0.01858547, 0.01848565, 0.018385662, 0.018286016, 0.018186366, 0.018086888, 0.01798741, 0.017888613, 0.017789477, 0.017690511, 0.017591715, 0.017493088, 0.017394632, 0.017296687, 0.017198572, 0.017100457, 0.017002683, 0.016904909, 0.016807305, 0.016710212, 0.016612949, 0.016515857, 0.016418934, 0.016322181, 0.01622577, 0.016129188, 0.016032945, 0.015936535, 0.015840463, 0.015744563, 0.015649002, 0.015553443, 0.015457883, 0.015362664, 0.015267445, 0.015172396, 0.015077858, 0.014983149, 0.014888613, 0.014794074, 0.014699877, 0.01460568, 0.014511993, 0.014418307, 0.014324451, 0.014230764, 0.014137419, 0.014044243, 0.01395141, 0.013858575, 0.01376574, 0.013673076, 0.013580582, 0.013488259, 0.013396447, 0.013304293, 0.013212481, 0.013120668, 0.013029196, 0.012937725, 0.012846764, 0.012755632, 0.012664502, 0.01257354, 0.01248275, 0.0123923, 0.012302192, 0.012211911, 0.012121803, 0.012031863, 0.011942096, 0.011852327, 0.01176324, 0.011673813, 0.011584725, 0.011495639, 0.011406722, 0.011317975, 0.01122974, 0.011141164, 0.011052758, 0.010964523, 0.010876457, 0.010788733, 0.01070118, 0.010613795, 0.010526242, 0.010439028, 0.010351815, 0.010264942, 0.01017841, 0.010091707, 0.010005176, 0.0099188145, 0.0098326234, 0.0097469427, 0.009660922, 0.0095752412, 0.0094893901, 0.0094038807, 0.0093185408, 0.0092337122, 0.0091487132, 0.0090638855, 0.008979056, 0.0088945692, 0.0088100806, 0.0087261032, 0.0086419564, 0.0085579799, 0.008474173, 0.0083903661, 0.0083069, 0.0082237748, 0.0081406496, 0.0080575254, 0.0079743993, 0.0078916149, 0.007809001, 0.0077267275, 0.0076444536, 0.00756218, 0.007480077, 0.0073983148, 0.0073165516, 0.0072353007, 0.0071538785, 0.0070724571, 0.0069913757, 0.0069104647, 0.0068295542, 0.0067491545, 0.0066685844, 0.0065881843, 0.0065077846, 0.0064275549, 0.0063476665, 0.0062681185, 0.0061885701, 0.0061090221, 0.0060296445, 0.0059504365, 0.0058717406, 0.0057928734, 0.0057140072, 0.0056354809, 0.0055569545, 0.0054785986, 0.005400754, 0.005322739, 0.0052448944, 0.0051668799, 0.0050893752, 0.005011871, 0.0049350485, 0.0048578857, 0.0047808923, 0.0047040698, 0.0046274173, 0.0045509352, 0.0044747936, 0.0043986528, 0.0043225111, 0.0042465399, 0.0041707396, 0.0040952796, 0.0040199901, 0.0039447006, 0.0038695808, 0.0037942913, 0.0037193424, 0.003644564, 0.0035704665, 0.0034960285, 0.0034217609, 0.0033474932, 0.0032735665, 0.0031996395, 0.003126394, 0.0030528074, 0.0029793917, 0.002906146, 0.0028330709, 0.0027601658, 0.0026876018, 0.0026150376, 0.0025424731, 0.0024699091, 0.0023976853, 0.0023256324, 0.0022540903, 0.0021823777, 0.0021108354, 0.0020392933, 0.0019679214, 0.0018968902, 0.0018261996, 0.0017553389, 0.0016844779, 0.0016139578, 0.001543608, 0.0014734286, 0.0014035897, 0.0013335806, 0.0012637418, 0.001193903, 0.0011244048, 0.0010550771, 0.00098608993, 0.00091710279, 0.00084811565, 0.00077929889, 0.00071082282, 0.00064268737, 0.00057438161, 0.00050607586, 0.00043811079, 0.00037031603, 0.00030252128, 0.00023523756, 0.00016778347, 0.00010049975, 3.3386357e-05, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 8.5071517e-15, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 0.0076538287, 7.4948966e-06, 7.4267613e-05, 0.00014172167, 0.00020900542, 0.00027628915, 0.00034425422, 0.00041170829, 0.00047984373, 0.00054780877, 0.00061594421, 0.00068442035, 0.00075289642, 0.00082154281, 0.00089035963, 0.00095934677, 0.0010283339, 0.001097832, 0.0011671599, 0.0012366578, 0.0013064967, 0.0013763355, 0.0014463447, 0.0015165242, 0.0015867036, 0.0016570534, 0.0017279143, 0.0017986048, 0.001869636, 0.0019406672, 0.0020116984, 0.0020832405, 0.0021546122, 0.0022261548, 0.0022982077, 0.0023700907, 0.0024421439, 0.0025145377, 0.0025867613, 0.0026593255, 0.0027320599, 0.0028047946, 0.0028776997, 0.0029511154, 0.0030243611, 0.0030976068, 0.0031713634, 0.0032451197, 0.0033188765, 0.0033929739, 0.0034670711, 0.0035415089, 0.0036161172, 0.0036905552, 0.0037653337, 0.003840453, 0.0039154021, 0.0039906916, 0.0040659816, 0.0041416115, 0.0042172419, 0.0042930427, 0.0043690139, 0.0044451547, 0.0045214668, 0.0045979489, 0.0046744305, 0.0047512534, 0.0048280759, 0.0049050688, 0.0049822326, 0.0050595663, 0.0051369001, 0.0052147447, 0.0052924189, 0.0053702635, 0.0054484494, 0.0055266349, 0.0056048199, 0.0056835162, 0.0057622129, 0.0058409087, 0.0059199464, 0.005998983, 0.0060783611, 0.0061577386, 0.0062372866, 0.006317005, 0.0063968943, 0.0064767832, 0.0065570124, 0.0066374121, 0.0067178123, 0.0067985523, 0.0068791225, 0.0069600334, 0.0070411148, 0.0071221958, 0.0072036176, 0.0072852098, 0.0073668021, 0.0074485643, 0.0075306674, 0.0076126005, 0.0076890807, 0.0077598565, 0.0078305472, 0.0079015782, 0.0079728654, 0.0080439812, 0.0081155235, 0.0081872363, 0.0082592042, 0.0083310865, 0.0084033106, 0.0084757041, 0.0085482681, 0.0086210892, 0.008693737, 0.0087668123, 0.0088401437, 0.0089133894, 0.0089870607, 0.0090607312, 0.0091347443, 0.0092088412, 0.0092831934, 0.0093574617, 0.00943207, 0.0095068477, 0.0095817978, 0.0096569164, 0.0097323759, 0.0098077506, 0.0098833824, 0.0099593531, 0.010035153, 0.010111295, 0.010187692, 0.010264259, 0.010340911, 0.010417905, 0.010494812, 0.010572061, 0.01064948, 0.010726813, 0.010804658, 0.010882418, 0.010960603, 0.011038873, 0.011117315, 0.011195756, 0.011274622, 0.011353659, 0.01143261, 0.011511903, 0.011591282, 0.011670914, 0.011750803, 0.011830862, 0.011910751, 0.011991152, 0.012071636, 0.012152376, 0.012233117, 0.012314113, 0.012395364, 0.012476701, 0.012558208, 0.012639714, 0.012721732, 0.01280375, 0.012886024, 0.012968383, 0.013050827, 0.013133611, 0.013216567, 0.013299606, 0.013382901, 0.013466283, 0.013549918, 0.013633726, 0.013717531, 0.013801679, 0.013885912, 0.013970484, 0.014055056, 0.014139971, 0.014224885, 0.014310054, 0.014395308, 0.014480819, 0.014566414, 0.014652264, 0.014738285, 0.014824476, 0.014910838, 0.01499737, 0.015084072, 0.015170859, 0.015257988, 0.015345287, 0.015432585, 0.01552014, 0.015607948, 0.01569593, 0.015783908, 0.015872145, 0.015960634, 0.01604921, 0.016138043, 0.016227044, 0.016316047, 0.016405389, 0.016494902, 0.016584415, 0.016674181, 0.016764292, 0.0168544, 0.016944766, 0.0170353, 0.017125836, 0.017216796, 0.017307928, 0.017398888, 0.017490275, 0.017581832, 0.017673559, 0.017765457, 0.017857609, 0.017949592, 0.018042171, 0.018134834, 0.018227501, 0.018320333, 0.018413508, 0.018506771, 0.018600287, 0.018693801, 0.018787486, 0.018881515, 0.018975712, 0.01907008, 0.019164363, 0.019259155, 0.019353949, 0.019448912, 0.01954413, 0.019639352, 0.019734912, 0.01983064, 0.019926544, 0.020022359, 0.020118684, 0.020215094, 0.020311592, 0.020408345, 0.020505352, 0.020602191, 0.020699538, 0.020797055, 0.020894492, 0.020992266, 0.021090126, 0.021188324, 0.021286609, 0.02138515, 0.021483604, 0.021582486, 0.021681368, 0.021780591, 0.021879813, 0.021979291, 0.022079024, 0.022178927, 0.022278916, 0.022378989, 0.02247932, 0.022579819, 0.022680661, 0.022781329, 0.022882426, 0.022983691, 0.023085214, 0.023186736, 0.023288427, 0.023390289, 0.023492238, 0.023594612, 0.023697071, 0.023799613, 0.023902413, 0.024005381, 0.024108522, 0.024211662, 0.024315145, 0.024418795, 0.024522616, 0.024626609, 0.024730768, 0.024835102, 0.024939604, 0.025044277, 0.025149036, 0.025253965, 0.025359234, 0.025464673, 0.025570197, 0.025675809, 0.025781587, 0.025887709, 0.025993999, 0.026100462, 0.026206836, 0.02631364, 0.026420612, 0.026527671, 0.0266349, 0.026742298, 0.02684995, 0.026957689, 0.027065769, 0.027173765, 0.0272821, 0.027390603, 0.027499197, 0.027608041, 0.027716888, 0.027826076, 0.027935604, 0.028045047, 0.028154658, 0.028264612, 0.028374482, 0.028484689, 0.028595155, 0.028705791, 0.028816253, 0.028927313, 0.029038377, 0.029149521, 0.029260922, 0.029372493, 0.029484235, 0.029596319, 0.029708317, 0.029820483, 0.029932909, 0.030045588, 0.030158181, 0.030271284, 0.030384474, 0.030497748, 0.03061128, 0.030724984, 0.030838683, 0.03095264, 0.03106685, 0.031181235, 0.031295698, 0.03141034, 0.031525232, 0.031640299, 0.031755615, 0.031870764, 0.031986341, 0.032102086, 0.032217998, 0.032334257, 0.032450341, 0.032566682, 0.032683451, 0.032800131, 0.0329169, 0.03303409, 0.03315137, 0.033268902, 0.033386521, 0.033504225, 0.033622269, 0.033740398, 0.033858702, 0.033976998, 0.034095809, 0.034214705, 0.034333602, 0.034452926, 0.034572244, 0.034691744, 0.0348114, 0.034931321, 0.035051409, 0.035171498, 0.035291843, 0.035412531, 0.035533212, 0.035654068, 0.035775095, 0.035896376, 0.036017828, 0.036139533, 0.036261242, 0.036383118, 0.036505334, 0.036627553, 0.03674994, 0.036872499, 0.0369954, 0.037118468, 0.037241705, 0.037364863, 0.03748836, 0.037612107, 0.037735946, 0.037859954, 0.037984215, 0.03810839, 0.038232911, 0.03835785, 0.03848245, 0.038607482, 0.038732853, 0.038858224, 0.038983848, 0.03910964, 0.03923535, 0.039361484, 0.039487794, 0.039614182, 0.039740745, 0.039867651, 0.039994545, 0.040121704, 0.04024912, 0.040376276, 0.040504031, 0.040631868, 0.040759962, 0.040887974, 0.041016411, 0.041144848, 0.041273534, 0.041402485, 0.041531261, 0.041660462, 0.041789915, 0.041919455, 0.042049259, 0.042179137, 0.042309195, 0.04243942, 0.042569898, 0.042700291, 0.042831112, 0.0429621, 0.043093175, 0.043224506, 0.043355919, 0.043487512, 0.043619268, 0.043751191, 0.043883294, 0.044015642, 0.044148084, 0.044280775, 0.044413645, 0.044546593, 0.044679713, 0.044813171, 0.04494663, 0.045080345, 0.045214146, 0.045348201, 0.045482345, 0.045616824, 0.045751397, 0.04588588, 0.046020955, 0.046156034, 0.04629137, 0.046426702, 0.046562206, 0.046697963, 0.046833977, 0.046970084, 0.04710618, 0.047242794, 0.047379408, 0.04751619, 0.047653057, 0.047790173, 0.047927555, 0.0480651, 0.04820282, 0.048340626, 0.0484786, 0.04861683, 0.048755229, 0.048893541, 0.049032282, 0.049171112, 0.049310278, 0.049449529, 0.049588867, 0.049728289, 0.049868047, 0.050008073, 0.050148088, 0.050288275, 0.050428808, 0.050569423, 0.050710205, 0.050851159, 0.050992116, 0.051133409, 0.051274963, 0.051416684, 0.051558323, 0.05170038, 0.051842529, 0.051984761, 0.052127335, 0.05226991, 0.052412741, 0.052555908, 0.052699078, 0.052842334, 0.052986015, 0.053129692, 0.053273462, 0.053417649, 0.053561669, 0.053706117, 0.053850822, 0.053995524, 0.054140314, 0.054285523, 0.054430738, 0.054576207, 0.054721843, 0.054867659, 0.055013467, 0.055159707, 0.055305935, 0.055452429, 0.055599004, 0.055745836, 0.055892751, 0.056040097, 0.05618744, 0.056334782, 0.056482464, 0.056630317, 0.056778431, 0.056926623, 0.057074904, 0.057223439, 0.057372231, 0.057521187, 0.057669982, 0.057819366, 0.057968754, 0.058118314, 0.058268208, 0.058417939, 0.058568176, 0.058718413, 0.058868907, 0.059019405, 0.059170239, 0.059321243, 0.059472416, 0.059623677, 0.059775196, 0.059926625, 0.060078736, 0.060230594, 0.060382709, 0.060535073, 0.060687527, 0.060840409, 0.060993202, 0.061146162, 0.061299298, 0.061452772, 0.061606418, 0.061759982, 0.061913967, 0.062067952, 0.06222228, 0.062376607, 0.06253127, 0.062685937, 0.062840857, 0.062996127, 0.063151479, 0.063306734, 0.063462421, 0.063618287, 0.063774236, 0.063930266, 0.064086542, 0.064243086, 0.064399719, 0.06455677, 0.06471356, 0.064870708, 0.065028094, 0.065185659, 0.065343387, 0.065501124, 0.065659195, 0.065817438, 0.065975852, 0.066134445, 0.066293113, 0.066452123, 0.066611223, 0.066770405, 0.066929929, 0.067089364, 0.067249052, 0.067409083, 0.067569204, 0.067729406, 0.067889951, 0.068050586, 0.068211466, 0.068372436, 0.068533495, 0.0686948, 0.068856366, 0.069018021, 0.06917993, 0.069341831, 0.069504082, 0.069666497, 0.069829084, 0.069991499, 0.070154607, 0.070317529, 0.070480809, 0.070644334, 0.070807852, 0.070971549, 0.071135581, 0.071299538, 0.071463652, 0.071628205, 0.071792834, 0.07195764, 0.072122693, 0.072287753, 0.072452977, 0.072618462, 0.072784118, 0.072949767, 0.073115945, 0.073282018, 0.073448442, 0.073614866, 0.073781617, 0.073948294, 0.074115485, 0.074282669, 0.074449942, 0.074617557, 0.074785247, 0.074953124, 0.075121336, 0.07528954, 0.07545767, 0.075626381, 0.075795196, 0.075964175, 0.076133229, 0.076302454, 0.076471858, 0.076641604, 0.07681144, 0.07698109, 0.077151343, 0.07732176, 0.077492274, 0.07766287, 0.077833548, 0.078004658, 0.078175932, 0.078347288, 0.078518569, 0.078690358, 0.078862138, 0.07903444, 0.079206392, 0.079378858, 0.079551496, 0.079724215, 0.079897113, 0.080070265, 0.080243245, 0.08041665, 0.0805903, 0.080764048, 0.080937959, 0.081112228, 0.081286483, 0.081460908, 0.081635676, 0.081810176, 0.081985131, 0.082160488, 0.08233577, 0.082511134, 0.082686916, 0.082862712, 0.083038755, 0.083214968, 0.08339119, 0.083567746, 0.083744459, 0.083921358, 0.084098428, 0.08427567, 0.084452987, 0.084630489, 0.084808402, 0.084986068, 0.085164145, 0.085342497, 0.085521005, 0.085699528, 0.08587838, 0.086057231, 0.086236343, 0.086415716, 0.086594999, 0.086774625, 0.086954586, 0.087134548, 0.087314673, 0.087495059, 0.087675542, 0.087856181, 0.088037074, 0.088217981, 0.088399224, 0.088580549, 0.088762045, 0.088943794, 0.089125797, 0.089307636, 0.089490071, 0.089672416, 0.089855015, 0.090037704, 0.090220571, 0.090403676, 0.09058696, 0.090770423, 0.090953961, 0.091137752, 0.091321811, 0.091505945, 0.091690078, 0.091874547, 0.092059284, 0.092244104, 0.092429094, 0.092614159, 0.092799485, 0.092984982, 0.093170822, 0.093356587, 0.093542591, 0.093728773, 0.093915291, 0.094101809, 0.094288506, 0.094475284, 0.094662398, 0.094849601, 0.095036969, 0.095224597, 0.095412314, 0.095600374, 0.095788427, 0.095976651, 0.096165039, 0.096353687, 0.096542425, 0.096731409, 0.09692058, 0.097109906, 0.097299494, 0.097488992, 0.09767884, 0.097868763, 0.098058954, 0.098249301, 0.09843991, 0.098630518, 0.098821387, 0.099012509, 0.099203713, 0.099395081, 0.099586457, 0.09977825, 0.099970229, 0.10016237, 0.10035452, 0.100547, 0.10073957, 0.1009323, 0.10112529, 0.10131821, 0.10151162, 0.10170513, 0.10189871, 0.10209247, 0.10228658, 0.10248068, 0.10267495, 0.10286939, 0.10306409, 0.10325895, 0.10345382, 0.10364904, 0.1038445, 0.10404005, 0.10423568, 0.10443166, 0.10462753, 0.10482378, 0.10502018, 0.10521674, 0.10541348, 0.10561039, 0.10580748, 0.10600473, 0.10620223, 0.10639974, 0.10659751, 0.10679545, 0.10699355, 0.10719182, 0.10739035, 0.10758896, 0.10778775, 0.1079867, 0.10818601, 0.10838521, 0.10858476, 0.1087844, 0.10898429, 0.10918427, 0.10938442, 0.10958473, 0.10978531, 0.10998604, 0.11018696, 0.11038797, 0.1105893, 0.11079056, 0.11099216, 0.11119392, 0.11139577, 0.11159788, 0.11180016, 0.11200261, 0.1122053, 0.1124081, 0.11261097, 0.11281418, 0.11301748, 0.11322078, 0.11342459, 0.11362823, 0.11383229, 0.11403654, 0.11424085, 0.11444534, 0.11465009, 0.11485492, 0.11505984, 0.11526518, 0.11547036, 0.11567587, 0.11588181, 0.11608766, 0.1162936, 0.11649997, 0.11670642, 0.11691287, 0.11711966, 0.11732662, 0.11753359, 0.11774097, 0.11794828, 0.11815591, 0.11836381, 0.1185718, 0.11877986, 0.11898819, 0.11919668, 0.11940527, 0.11961409, 0.11982311, 0.12003227, 0.12024171, 0.12045123, 0.12066083, 0.12087077, 0.12108079, 0.12129091, 0.12150136, 0.1217119, 0.12192252, 0.12213358, 0.12234463, 0.12255576, 0.12276723, 0.12297879, 0.12319052, 0.1234026, 0.12361458, 0.12382682, 0.12403941, 0.12425207, 0.12446491, 0.12467784, 0.12489093, 0.12510419, 0.12531771, 0.12553132, 0.12574527, 0.1259592, 0.12617341, 0.12638786, 0.12660232, 0.12681703, 0.127032, 0.12724689, 0.1274621, 0.12767757, 0.12789306, 0.1281088, 0.1283247, 0.12854077, 0.12875701, 0.1289736, 0.1291901, 0.12940685, 0.12962379, 0.12984088, 0.13005815, 0.13027567, 0.13049319, 0.13071105, 0.13092917, 0.13114721, 0.13136549, 0.13158412, 0.13180275, 0.13202155, 0.13224061, 0.13245974, 0.13267915, 0.13289879, 0.13311836, 0.13333827, 0.13355844, 0.13377859, 0.13399893, 0.13421953, 0.13444027, 0.13466111, 0.13488221, 0.13510357, 0.13532501, 0.13554662, 0.13576832, 0.13599035, 0.13621247, 0.13643469, 0.13665715, 0.13687988, 0.13710268, 0.13732563, 0.13754888, 0.1377721, 0.13799568, 0.1382194, 0.13844314, 0.13866715, 0.13889149, 0.13911574, 0.1393404, 0.13956508, 0.13978992, 0.14001511, 0.1402403, 0.14046559, 0.14069128, 0.14091706, 0.14114289, 0.14136904, 0.14159533, 0.1418218, 0.14204837, 0.14227518, 0.14250205, 0.14272928, 0.14295657, 0.14318401, 0.14341171, 0.14363956, 0.14386752, 0.14409566, 0.14432408, 0.14455259, 0.14478123, 0.14501013, 0.14523901, 0.14546832, 0.14569779, 0.14592722, 0.14615701, 0.14638688, 0.14661697, 0.1468472, 0.14707765, 0.14730826, 0.147539, 0.1477699, 0.14800097, 0.14823234, 0.14846382, 0.14869542, 0.14892723, 0.14915913, 0.14939137, 0.14962369, 0.14985612, 0.15008882, 0.15032157, 0.1505546, 0.15078783, 0.15102115, 0.15125468, 0.15148842, 0.15172228, 0.15195632, 0.15219054, 0.15242492, 0.15265943, 0.15289429, 0.15312915, 0.1533642, 0.15359953, 0.15383494, 0.15407047, 0.15430635, 0.15454222, 0.15477832, 0.15501469, 0.15525116, 0.15548767, 0.15572457, 0.15596153, 0.15619867, 0.15643604, 0.15667345, 0.15691112, 0.15714909, 0.15738697, 0.15762517, 0.15786366, 0.1581021, 0.15834078, 0.15857975, 0.15881878, 0.15905793, 0.15929744, 0.15953693, 0.15977669, 0.16001673, 0.16025679, 0.16049699, 0.16073747, 0.16097796, 0.16121882, 0.16145983, 0.16170083, 0.16194215, 0.1621837, 0.16242537, 0.16266708, 0.16290912, 0.16315134, 0.16339356, 0.16363616, 0.16387878, 0.16412163, 0.16436467, 0.1646336, 0.16492862, 0.16522391, 0.16551924, 0.16581465, 0.16611022, 0.16640593, 0.16670173, 0.16699764, 0.16729365, 0.16758981, 0.16788612, 0.16818261, 0.16847894, 0.16877563, 0.16907239, 0.16936913, 0.16966617, 0.16996324, 0.17026038, 0.17055777, 0.17085525, 0.17115271, 0.17145042, 0.17174821, 0.17204605, 0.17234406, 0.1726422, 0.1729404, 0.1732388, 0.17353731, 0.17383583, 0.17413458, 0.17443347, 0.17473233, 0.17503144, 0.17533061, 0.17562985, 0.17592925, 0.17622884, 0.17652859, 0.17682822, 0.17712814, 0.1774281, 0.17772815, 0.17802846, 0.17832872, 0.17862915, 0.17892975, 0.17923048, 0.17953128, 0.17983222, 0.18013316, 0.18043441, 0.18073565, 0.18103698, 0.18133844, 0.1816401, 0.18194178, 0.18224379, 0.18254571, 0.18284777, 0.18314993, 0.18345229, 0.18375465, 0.18405722, 0.18435992, 0.18466263, 0.18496551, 0.18526866, 0.18557177, 0.18587498, 0.18617834, 0.18648191, 0.1867854, 0.18708915, 0.18739291, 0.18769687, 0.18800102, 0.1883052, 0.18860938, 0.18891387, 0.18921843, 0.18952295, 0.18982773, 0.19013268, 0.19043759, 0.19074264, 0.191048, 0.19135328, 0.19165878, 0.19196437, 0.19226995, 0.19257584, 0.19288172, 0.19318773, 0.19349389, 0.19380015, 0.19410658, 0.19441305, 0.19471967, 0.19502637, 0.19533324, 0.19564024, 0.19594727, 0.19625446, 0.1965618, 0.19686922, 0.19717681, 0.19748452, 0.19779225, 0.19810013, 0.19840816, 0.19871621, 0.19902448, 0.19933291, 0.19964135, 0.19994988, 0.2002587, 0.20056753, 0.20087643, 0.20118548, 0.20149459, 0.20180389, 0.20211332, 0.20242281, 0.20273247, 0.20304224, 0.20335218, 0.2036621, 0.20397225, 0.20428239, 0.20459279, 0.20490323, 0.2052138, 0.20552455, 0.2058353, 0.20614631, 0.20645727, 0.20676839, 0.20707974, 0.20739108, 0.20770253, 0.20801413, 0.20832594, 0.20863779, 0.20894964, 0.20926182, 0.20957404, 0.20988637, 0.21019872, 0.2105113, 0.21082398, 0.21113673, 0.21144959, 0.21176256, 0.21207573, 0.21238907, 0.21270244, 0.21301576, 0.21332945, 0.21364313, 0.21395695, 0.21427095, 0.21458502, 0.21489908, 0.21521343, 0.21552785, 0.21584232, 0.21615699, 0.21647181, 0.21678668, 0.21710165, 0.21741673, 0.21773189, 0.21804728, 0.21836275, 0.21867834, 0.21899402, 0.21930982, 0.21962573, 0.21994178, 0.22025797, 0.22057416, 0.22089052, 0.22120701, 0.22152373, 0.22184041, 0.22215733, 0.22247416, 0.22279134, 0.2231085, 0.22342572, 0.22374323, 0.22406077, 0.22437839, 0.22469622, 0.22501417, 0.22533223, 0.22565025, 0.22596852, 0.22628684, 0.22660534, 0.22692396, 0.22724259, 0.22756144, 0.22788045, 0.22819954, 0.22851868, 0.22883797, 0.22915734, 0.2294769, 0.22979651, 0.23011623, 0.23043613, 0.23075606, 0.2310763, 0.23139645, 0.23171677, 0.23203728, 0.2323578, 0.23267849, 0.23299925, 0.23332018, 0.23364122, 0.23396246, 0.23428364, 0.23460503, 0.23492658, 0.23524809, 0.23556992, 0.23589176, 0.23621362, 0.23653573, 0.23685789, 0.23718029, 0.23750271, 0.23782532, 0.23814791, 0.23847073, 0.23879366, 0.23911662, 0.23943965, 0.23976301, 0.24008626, 0.24040988, 0.2407335, 0.24105716, 0.24138093, 0.24170494, 0.24202888, 0.24235305, 0.24267741, 0.24300179, 0.24332623, 0.24365103, 0.24397568, 0.24430057, 0.24462561, 0.24495059, 0.24527584, 0.24560119, 0.24592659, 0.24625222, 0.2465779, 0.24690382, 0.24722971, 0.24755569, 0.24788184, 0.24820814, 0.24853452, 0.24886096, 0.24918753, 0.24951428, 0.24984106, 0.25016811, 0.25049523, 0.25082248, 0.25114974, 0.25147715, 0.25180465, 0.2521323, 0.25246012, 0.25278798, 0.25311604, 0.25344419, 0.2537725, 0.25410083, 0.25442928, 0.25475791, 0.25508648, 0.25541535, 0.25574428, 0.2560733, 0.25640264, 0.2567319, 0.25706121, 0.25739083, 0.25772044, 0.25805011, 0.25838003, 0.25870997, 0.25904009, 0.25937036, 0.25970075, 0.26003116, 0.26036164, 0.26069245, 0.26102316, 0.26135409, 0.2616851, 0.26201624, 0.26234755, 0.26267889, 0.26301041, 0.26334205, 0.26367384, 0.26400557, 0.2643376, 0.26466966, 0.26500189, 0.26533413, 0.26566666, 0.26599908, 0.26633185, 0.26666465, 0.26699743, 0.2673305, 0.26766366, 0.26799682, 0.26833028, 0.2686637, 0.26899725, 0.26933098, 0.26966482, 0.2699987, 0.27033278, 0.27066696, 0.27100122, 0.27133566, 0.27167022, 0.27200478, 0.27233961, 0.27267447, 0.27300954, 0.27334452, 0.27367973, 0.27401507, 0.27435055, 0.27468613, 0.27502182, 0.2753576, 0.27569351, 0.27602962, 0.2763657, 0.27670202, 0.2770384, 0.27737492, 0.27771151, 0.27804822, 0.27838498, 0.27872208, 0.27905902, 0.2793963, 0.27973369, 0.28007105, 0.28040859, 0.28074625, 0.28108412, 0.2814219, 0.28175995, 0.28209794, 0.28243622, 0.28277463, 0.28311318, 0.28345174, 0.28379041, 0.28412929, 0.2844682, 0.28480726, 0.28514636, 0.28548563, 0.28582516, 0.28616461, 0.28650427, 0.28684404, 0.28718391, 0.28752384, 0.28786397, 0.28820422, 0.28854454, 0.28888494, 0.28922561, 0.28956619, 0.2899071, 0.29024801, 0.290589, 0.29093006, 0.29127142, 0.29161274, 0.29195419, 0.29229593, 0.29263762, 0.29297951, 0.29332155, 0.29366356, 0.29400569, 0.29434806, 0.29469037, 0.29503301, 0.29537565, 0.29571834, 0.29606131, 0.29640445, 0.29674745, 0.29709068, 0.29743409, 0.29777756, 0.29812115, 0.29846483, 0.2988086, 0.29915255, 0.29949671, 0.29984093, 0.30018508, 0.30052951, 0.30087399, 0.30121872, 0.30156344, 0.30190825, 0.30225325, 0.30259839, 0.30294362, 0.30328903, 0.30363446, 0.30397999, 0.30432564, 0.30467147, 0.30501732, 0.30536333, 0.30570951, 0.30605587, 0.30640218, 0.30674872, 0.30709532, 0.30744201, 0.30778888, 0.30813584, 0.30848289, 0.30883005, 0.30917731, 0.30952486, 0.30987242, 0.31022018, 0.31056783, 0.31091571, 0.31126371, 0.3116118, 0.31196007, 0.31230837, 0.31265682, 0.31300557, 0.31335428, 0.31370303, 0.31405196, 0.31440103, 0.31475013, 0.31509951, 0.31544888, 0.31579837, 0.31614804, 0.31649786, 0.31684765, 0.31719768, 0.31754783, 0.31789792, 0.31824827, 0.31859878, 0.31894928, 0.31929997, 0.31965092, 0.32000181, 0.32035279, 0.32070398, 0.3210552, 0.3214066, 0.32175806, 0.32210958, 0.32246137, 0.32281327, 0.3231653, 0.32351735, 0.32386953, 0.32422173, 0.32457426, 0.32492673, 0.32527938, 0.32563218, 0.3259851, 0.32633802, 0.32669124, 0.32704455, 0.32739785, 0.32775131, 0.32810488, 0.32845852, 0.32881236, 0.32916641, 0.32952029, 0.32987455, 0.33022889, 0.3305833, 0.33093783, 0.33129245, 0.33164716, 0.33200198, 0.33235708, 0.33271214, 0.33306733, 0.33342266, 0.33377817, 0.33413363, 0.33448938, 0.33484519, 0.33520105, 0.3355571, 0.33591333, 0.3362695, 0.33662596, 0.33698252, 0.33733901, 0.33769578, 0.33805263, 0.33840957, 0.33876669, 0.33912393, 0.33948117, 0.33983859, 0.34019616, 0.34055385, 0.34091157, 0.34126949, 0.34162736, 0.34198561, 0.34234384, 0.34270218, 0.34306064, 0.34341931, 0.34377784, 0.34413677, 0.34449571, 0.3448548, 0.34521392, 0.34557322, 0.3459326, 0.34629217, 0.34665188, 0.34701151, 0.34737137, 0.34773147, 0.34809154, 0.34845173, 0.34881213, 0.3491725, 0.34953311, 0.34989378, 0.35025448, 0.35061538, 0.3509765, 0.35133773, 0.35169891, 0.35206029, 0.35242176, 0.35278341, 0.35314518, 0.35350689, 0.3538689, 0.35423103, 0.35459325, 0.35495549, 0.35531798, 0.35568056, 0.35604316, 0.35640591, 0.35676879, 0.35713178, 0.35749486, 0.35785809, 0.3582215, 0.35858506, 0.35894865, 0.35931227, 0.35967615, 0.36004016, 0.36040407, 0.36076826, 0.3611325, 0.36149687, 0.36186159, 0.36222622, 0.36259091, 0.36295581, 0.36332083, 0.36368585, 0.36405107, 0.36441639, 0.3647818, 0.36514735, 0.36551318, 0.36587894, 0.36624491, 0.36661088, 0.36697695, 0.36734328, 0.36770967, 0.36807612, 0.36844268, 0.36880946, 0.36917636, 0.36954331, 0.36991045, 0.37027752, 0.37064481, 0.37101233, 0.37137973, 0.3717474, 0.37211525, 0.37248325, 0.37285119, 0.37321934, 0.37358746, 0.37395585, 0.37432435, 0.37469292, 0.37506157, 0.37543043, 0.37579927, 0.37616849, 0.37653768, 0.37690699, 0.37727627, 0.37764585, 0.37801537, 0.37838513, 0.37875509, 0.37912497, 0.37949514, 0.37986544, 0.38023579, 0.38060617, 0.38097671, 0.38134745, 0.38171819, 0.38208911, 0.38246012, 0.38283128, 0.38320255, 0.38357398, 0.38394547, 0.38431707, 0.38468885, 0.38506058, 0.38543257, 0.38580456, 0.38617682, 0.38654909, 0.3869215, 0.38729414, 0.38766679, 0.38803962, 0.38841242, 0.38878548, 0.38915864, 0.38953176, 0.38990515, 0.39027852, 0.39065227, 0.39102599, 0.39139977, 0.3917737, 0.39214781, 0.39252198, 0.39289615, 0.39327058, 0.39364508, 0.39401969, 0.39439452, 0.39476946, 0.39514437, 0.39551944, 0.39589468, 0.39626995, 0.39664549, 0.39702103, 0.39739662, 0.3977724, 0.39814851, 0.3985244, 0.39890066, 0.39927688, 0.39965326, 0.40002966, 0.40040636, 0.40078303, 0.40115991, 0.40153688, 0.40191406, 0.40229118, 0.40266848, 0.40304583, 0.40342346, 0.40380105, 0.40417883, 0.40455675, 0.40493479, 0.40531287, 0.40569109, 0.40606955, 0.40644792, 0.40682653, 0.40720522, 0.40758401, 0.40796298, 0.40834206, 0.40872115, 0.4091005, 0.40948001, 0.40985951, 0.41023907, 0.41061881, 0.4109987, 0.41137865, 0.41175875, 0.41213894, 0.41251928, 0.41289979, 0.4132804, 0.41366094, 0.41404182, 0.41442278, 0.41480368, 0.41518497, 0.41556612, 0.41594747, 0.41632903, 0.41671073, 0.41709238, 0.41747427, 0.41785625, 0.41823819, 0.41862047, 0.41900274, 0.41938516, 0.41976768, 0.42015028, 0.42053318, 0.42091602, 0.4212991, 0.42168215, 0.42206541, 0.42244878, 0.42283216, 0.42321578, 0.42359957, 0.42398322, 0.42436725, 0.42475134, 0.42513558, 0.42551985, 0.42590421, 0.42628872, 0.42667332, 0.4270581, 0.42744288, 0.42782789, 0.42821309, 0.42859825, 0.42898366, 0.42936912, 0.42975456, 0.43014026, 0.43052611, 0.43091196, 0.43129793, 0.4316842, 0.43207052, 0.43245685, 0.43284336, 0.43322983, 0.43361664, 0.43400341, 0.43439037, 0.4347775, 0.43516469, 0.43555218, 0.43593952, 0.43632704, 0.43671474, 0.43710244, 0.43749034, 0.43787828, 0.4382664, 0.4386546, 0.43904296, 0.43943152, 0.43982014, 0.44020885, 0.44059765, 0.44098654, 0.44137558, 0.44176468, 0.44215405, 0.44254342, 0.44293293, 0.44332266, 0.44371241, 0.44410226, 0.44449219, 0.44488236, 0.44527248, 0.44566286, 0.44605318, 0.44644377, 0.44683453, 0.44722542, 0.44761628, 0.44800726, 0.44839844, 0.44878969, 0.44918102, 0.44957259, 0.44996414, 0.45035583, 0.45074785, 0.45113972, 0.45153183, 0.45192406, 0.45231625, 0.45270866, 0.45310122, 0.45349386, 0.45388663, 0.45427948, 0.45467255, 0.45506576, 0.45545897, 0.4558523, 0.45624575, 0.45663935, 0.45703301, 0.45742682, 0.45782074, 0.45821479, 0.45860907, 0.45900336, 0.45939773, 0.45979223, 0.46018684, 0.46058151, 0.46097645, 0.46137139, 0.46176648, 0.46216172, 0.46255714, 0.46295261, 0.46334806, 0.46374384, 0.46413952, 0.46453547, 0.46493149, 0.46532765, 0.46572396, 0.46612027, 0.46651676, 0.4669134, 0.46731019, 0.46770704, 0.46810389, 0.46850097, 0.46889812, 0.46929559, 0.46969286, 0.47009048, 0.47048813, 0.47088587, 0.47128385, 0.47168177, 0.4720799, 0.47247818, 0.47287643, 0.47327495, 0.47367352, 0.47407225, 0.47447106, 0.47487003, 0.47526905, 0.47566822, 0.47606754, 0.47646686, 0.47686642, 0.47726604, 0.47766584, 0.47806567, 0.47846568, 0.47886574, 0.47926602, 0.47966632, 0.48006672, 0.48046735, 0.48086804, 0.48126879, 0.48166966, 0.48207071, 0.48247188, 0.48287317, 0.48327458, 0.48367596, 0.48407763, 0.4844794, 0.48488122, 0.48528317, 0.48568517, 0.48608747, 0.48648968, 0.48689216, 0.48729464, 0.48769733, 0.48810014, 0.48850298, 0.48890609, 0.48930916, 0.48971236, 0.49011582, 0.4905192, 0.49092278, 0.49132651, 0.49173033, 0.49213421, 0.4925383, 0.49294242, 0.49334681, 0.49375117, 0.49415562, 0.4945603, 0.49496508, 0.49536997, 0.49577487, 0.49617997, 0.49658522, 0.49699056, 0.49739602, 0.49780151, 0.49820718, 0.49861303, 0.49901894, 0.49942499, 0.49983111, 0.50023735, 0.50064379, 0.50105029, 0.5014568, 0.5018636, 0.50227046, 0.50267744, 0.50308448, 0.50349164, 0.50389892, 0.50430638, 0.50471389, 0.50512153, 0.50552934, 0.50593722, 0.50634515, 0.50675339, 0.50716156, 0.50756997, 0.5079785, 0.50838697, 0.5087958, 0.50920451, 0.50961345, 0.51002246, 0.51043165, 0.51084089, 0.51125038, 0.51165992, 0.51206946, 0.51247919, 0.51288909, 0.51329911, 0.51370913, 0.51411939, 0.51452976, 0.5149402, 0.51535076, 0.51576138, 0.51617223, 0.51658314, 0.51699418, 0.51740539, 0.51782948, 0.51826686, 0.51870412, 0.51914126, 0.51957828, 0.52001518, 0.52045202, 0.52088881, 0.52132547, 0.52176201, 0.52219844, 0.52263486, 0.52307117, 0.52350736, 0.52394342, 0.52437937, 0.5248152, 0.52525109, 0.5256868, 0.52612233, 0.52655786, 0.52699322, 0.52742857, 0.5278638, 0.52829897, 0.52873391, 0.52916878, 0.52960372, 0.53003842, 0.53047305, 0.53090757, 0.53134209, 0.53177643, 0.53221065, 0.53264481, 0.53307885, 0.53351283, 0.53394675, 0.5343805, 0.53481418, 0.53524774, 0.53568125, 0.53611469, 0.5365479, 0.53698117, 0.53741425, 0.53784722, 0.53828013, 0.53871298, 0.53914565, 0.53957832, 0.54001087, 0.5404433, 0.54087555, 0.54130781, 0.54173994, 0.54217201, 0.54260403, 0.54303581, 0.54346758, 0.54389918, 0.54433078, 0.54476225, 0.54519361, 0.54562485, 0.54605603, 0.54648715, 0.54691821, 0.54734904, 0.5477798, 0.5482105, 0.54864109, 0.54907161, 0.54950207, 0.54993236, 0.55036259, 0.55079275, 0.55122268, 0.55165261, 0.55208254, 0.55251217, 0.55294186, 0.55337137, 0.55380088, 0.55423021, 0.55465943, 0.55508864, 0.55551773, 0.55594665, 0.55637556, 0.5568043, 0.55723304, 0.55766159, 0.55809009, 0.55851847, 0.55894679, 0.55937499, 0.55980301, 0.56023103, 0.56065899, 0.56108683, 0.56151456, 0.56194216, 0.56236964, 0.56279707, 0.56322455, 0.56365174, 0.56407881, 0.56450593, 0.56493282, 0.56535971, 0.56578642, 0.56621313, 0.56663972, 0.56706607, 0.56749254, 0.56791884, 0.56834495, 0.568771, 0.56919706, 0.56962293, 0.57004869, 0.57047451, 0.57090002, 0.57132554, 0.57175106, 0.57217628, 0.57260156, 0.57302666, 0.57345164, 0.57387656, 0.57430154, 0.5747261, 0.57515085, 0.57557541, 0.5759998, 0.57642412, 0.57684851, 0.57727259, 0.57769668, 0.57812071, 0.5785445, 0.57896829, 0.57939196, 0.57981551, 0.58023912, 0.58066249, 0.5810858, 0.58150887, 0.58193201, 0.58235514, 0.58277804, 0.58320081, 0.58362347, 0.58404619, 0.58446866, 0.58489114, 0.58531344, 0.58573574, 0.58615786, 0.58657986, 0.58700186, 0.58742368, 0.5878455, 0.58826715, 0.58868873, 0.58911008, 0.58953154, 0.58995283, 0.59037405, 0.59079516, 0.59121615, 0.59163696, 0.59205776, 0.59247851, 0.59289908, 0.59331959, 0.59373999, 0.59416032, 0.59458059, 0.59500068, 0.59542078, 0.59584069, 0.59626049, 0.59668028, 0.5970999, 0.59751946, 0.5979389, 0.59835821, 0.59877753, 0.59919673, 0.59961575, 0.60003471, 0.60045356, 0.60087234, 0.60129112, 0.6017096, 0.60212809, 0.60254651, 0.60296488, 0.60338312, 0.60380119, 0.60421914, 0.60463709, 0.60505491, 0.60547262, 0.60589021, 0.60630774, 0.60672528, 0.60714263, 0.60755986, 0.60797691, 0.60839397, 0.60881108, 0.6092279, 0.60964459, 0.61006123, 0.61047781, 0.61089438, 0.61131078, 0.61172694, 0.6121431, 0.6125592, 0.61297524, 0.61339116, 0.61380696, 0.61422265, 0.61463827, 0.61505383, 0.61546922, 0.61588448, 0.61629975, 0.61671484, 0.61712998, 0.61754483, 0.61795974, 0.61837441, 0.61878908, 0.61920369, 0.61961812, 0.62003243, 0.62044674, 0.62086082, 0.62127501, 0.62168896, 0.62210286, 0.62251657, 0.62293023, 0.62334394, 0.62375736, 0.62417084, 0.62458408, 0.62499732, 0.62541044, 0.62582344, 0.62623632, 0.62664914, 0.6270619, 0.62747455, 0.62788707, 0.62829953, 0.62871182, 0.6291241, 0.62953621, 0.6299482, 0.63036025, 0.63077211, 0.63118386, 0.63159555, 0.63200712, 0.63241863, 0.63282996, 0.63324136, 0.63365245, 0.63406354, 0.63447452, 0.63488543, 0.63529629, 0.63570702, 0.63611752, 0.63652802, 0.63693851, 0.63734883, 0.63775909, 0.63816923, 0.63857919, 0.63898915, 0.63939899, 0.63980877, 0.64021844, 0.64062798, 0.6410374, 0.64144683, 0.64185607, 0.64226526, 0.64267427, 0.64308333, 0.64349222, 0.64390099, 0.64430964, 0.64471823, 0.64512676, 0.64553517, 0.64594346, 0.64635164, 0.64675975, 0.64716774, 0.64757574, 0.64798355, 0.64839131, 0.64879894, 0.64920646, 0.64961386, 0.65002126, 0.65042847, 0.65083563, 0.65124273, 0.65164965, 0.65205663, 0.65246332, 0.65286994, 0.65327656, 0.65368307, 0.65408939, 0.65449572, 0.65490186, 0.65530801, 0.65571398, 0.65611988, 0.65652567, 0.65693146, 0.65733701, 0.6577425, 0.65814793, 0.6585533, 0.65895855, 0.65936369, 0.6597687, 0.66017371, 0.66057843, 0.66098326, 0.66138792, 0.66179246, 0.66219687, 0.66260123, 0.66300553, 0.66340971, 0.66381377, 0.66421777, 0.66462159, 0.66502547, 0.66542912, 0.66583276, 0.66623628, 0.66663957, 0.66704297, 0.66744626, 0.6678493, 0.66825235, 0.66865522, 0.66905808, 0.66946077, 0.6698634, 0.67026597, 0.67066842, 0.67107081, 0.67147303, 0.67187518, 0.67227721, 0.67267913, 0.6730811, 0.67348284, 0.67388451, 0.67428607, 0.67468756, 0.675089, 0.6754902, 0.67589146, 0.67629254, 0.67669356, 0.67709446, 0.67749524, 0.67789596, 0.67829657, 0.67869711, 0.67909759, 0.67949796, 0.67989814, 0.68029821, 0.68069828, 0.68109822, 0.68149805, 0.68189782, 0.68229747, 0.68269694, 0.68309647, 0.68349588, 0.68389517, 0.68429428, 0.68469334, 0.68509245, 0.68549126, 0.68589008, 0.68628877, 0.68668741, 0.68708593, 0.68748432, 0.68788254, 0.68828082, 0.68867892, 0.6890769, 0.68947494, 0.68987262, 0.69027036, 0.69066811, 0.69106561, 0.69146305, 0.69186044, 0.69225764, 0.69265485, 0.69305193, 0.6934489, 0.69384569, 0.69424248, 0.69463921, 0.69503582, 0.69543225, 0.69582862, 0.69622487, 0.69662118, 0.69701719, 0.69741327, 0.6978091, 0.69820493, 0.69860065, 0.69899625, 0.69939178, 0.6997872, 0.7001825, 0.70057786, 0.70097297, 0.70136797, 0.70176286, 0.70215774, 0.70255256, 0.70294726, 0.70334172, 0.70373625, 0.70413059, 0.70452487, 0.70491904, 0.70531309, 0.70570713, 0.70610106, 0.70649481, 0.7068885, 0.70728207, 0.7076757, 0.70806903, 0.7084623, 0.70885557, 0.70924872, 0.7096417, 0.71003461, 0.71042746, 0.71082014, 0.71121281, 0.71160537, 0.71199781, 0.71239018, 0.7127825, 0.71317464, 0.71356666, 0.71395868, 0.71435058, 0.71474224, 0.71513397, 0.71552563, 0.71591711, 0.71630847, 0.71669972, 0.71709096, 0.71748197, 0.71787304, 0.71826398, 0.71865475, 0.71904552, 0.71943611, 0.7198267, 0.72021705, 0.72060734, 0.72099757, 0.72138774, 0.72177786, 0.72216779, 0.7225576, 0.72294736, 0.72333699, 0.72372669, 0.72411609, 0.72450554, 0.72489476, 0.72528398, 0.72567302, 0.726062, 0.7264508, 0.72683966, 0.7272284, 0.72761697, 0.72800547, 0.72839391, 0.72878218, 0.72917044, 0.72955859, 0.72994655, 0.73033452, 0.73072231, 0.73111004, 0.73149782, 0.73188525, 0.73227274, 0.73266011, 0.73304737, 0.73343456, 0.73382163, 0.73420852, 0.73459542, 0.73498225, 0.73536891, 0.73575544, 0.73614198, 0.73652834, 0.73691463, 0.73730087, 0.73768693, 0.73807299, 0.73845893, 0.73884469, 0.73923045, 0.7396161, 0.74000156, 0.74038696, 0.74077237, 0.74115765, 0.74154282, 0.7419278, 0.74231273, 0.7426976, 0.74308234, 0.74346709, 0.7438516, 0.74423605, 0.74462044, 0.74500477, 0.74538893, 0.74577302, 0.74615699, 0.74654096, 0.74692482, 0.74730837, 0.74769205, 0.74807554, 0.74845898, 0.74884218, 0.74922544, 0.74960858, 0.7499916, 0.75037462, 0.7507574, 0.75114006, 0.75152278, 0.75190532, 0.75228781, 0.75267011, 0.75305235, 0.7534346, 0.75381672, 0.75419861, 0.75458056, 0.75496233, 0.75534391, 0.75572556, 0.75610709, 0.75648844, 0.75686973, 0.75725096, 0.75763208, 0.75801307, 0.75839394, 0.75877476, 0.75915551, 0.75953627, 0.75991672, 0.76029718, 0.76067746, 0.76105767, 0.76143789, 0.76181787, 0.76219785, 0.76257765, 0.76295751, 0.76333719, 0.76371676, 0.76409614, 0.76447558, 0.76485485, 0.76523405, 0.76561314, 0.76599211, 0.76637101, 0.76674986, 0.76712853, 0.76750714, 0.76788568, 0.76826406, 0.76864249, 0.76902062, 0.76939875, 0.76977676, 0.77015471, 0.77053261, 0.77091038, 0.77128798, 0.77166551, 0.77204293, 0.77242035, 0.77279758, 0.77317476, 0.77355182, 0.77392882, 0.77430564, 0.77468246, 0.77505916, 0.77543575, 0.77581221, 0.77618861, 0.77656496, 0.77694112, 0.77731729, 0.77769327, 0.7780692, 0.77844501, 0.77882075, 0.77919638, 0.77957189, 0.7799474, 0.78032267, 0.78069794, 0.78107309, 0.78144813, 0.7818231, 0.78219801, 0.78257269, 0.78294742, 0.78332198, 0.78369653, 0.78407091, 0.78444511, 0.78481936, 0.7851935, 0.7855674, 0.7859413, 0.78631508, 0.78668875, 0.78706247, 0.78743595, 0.78780937, 0.78818274, 0.78855592, 0.78892905, 0.78930217, 0.789675, 0.79004782, 0.79042059, 0.7907933, 0.79116583, 0.7915383, 0.79191065, 0.79228288, 0.79265511, 0.79302716, 0.79339916, 0.79377097, 0.79414278, 0.79451454, 0.79488611, 0.79525757, 0.79562896, 0.7960003, 0.79637146, 0.79674256, 0.79711366, 0.79748458, 0.79785538, 0.79822618, 0.79859668, 0.79896724, 0.79933769, 0.79970801, 0.80007827, 0.80044842, 0.8008185, 0.80118847, 0.80155838, 0.8019281, 0.80229771, 0.80266732, 0.80303681, 0.80340624, 0.80377549, 0.80414468, 0.80451375, 0.80488276, 0.80525166, 0.80562049, 0.80598927, 0.80635774, 0.80672628, 0.80709481, 0.80746311, 0.80783135, 0.80819952, 0.80856752, 0.80893546, 0.80930328, 0.80967098, 0.81003863, 0.81040627, 0.81077373, 0.81114107, 0.8115083, 0.81187558, 0.81224257, 0.81260955, 0.81297648, 0.81334329, 0.81370997, 0.81407648, 0.81444311, 0.8148095, 0.81517577, 0.81554198, 0.81590807, 0.81627411, 0.8166399, 0.81700587, 0.81737161, 0.81773722, 0.81810278, 0.81846821, 0.81883359, 0.81919873, 0.81956398, 0.819929, 0.8202939, 0.8206588, 0.82102364, 0.8213883, 0.82175285, 0.82211733, 0.82248169, 0.82284594, 0.82321018, 0.8235743, 0.82393831, 0.8243022, 0.82466602, 0.82502979, 0.82539338, 0.82575691, 0.82612026, 0.82648367, 0.8268469, 0.82721001, 0.82757306, 0.82793599, 0.82829881, 0.82866168, 0.82902426, 0.82938683, 0.82974923, 0.83011162, 0.8304739, 0.83083606, 0.83119816, 0.83156013, 0.83192199, 0.83228385, 0.83264554, 0.83300716, 0.83336866, 0.83373004, 0.83409142, 0.83445257, 0.83481365, 0.83517468, 0.83553553, 0.83589655, 0.83625716, 0.83661783, 0.83697838, 0.83733881, 0.83769917, 0.83805943, 0.8384195, 0.83877963, 0.83913964, 0.83949947, 0.83985931, 0.84021884, 0.8405785, 0.84093791, 0.84129739, 0.84165668, 0.84201586, 0.84237492, 0.84273398, 0.84309286, 0.84345168, 0.84381038, 0.84416902, 0.84452754, 0.84488595, 0.84524435, 0.84560245, 0.84596068, 0.84631878, 0.84667665, 0.84703451, 0.84739226, 0.84774995, 0.84810752, 0.84846503, 0.84882224, 0.84917963, 0.84953678, 0.84989387, 0.85025078, 0.85060775, 0.85096455, 0.85132122, 0.85167778, 0.85203439, 0.85239077, 0.85274714, 0.85310328, 0.85345942, 0.8538155, 0.85417128, 0.85452712, 0.85488296, 0.85523856, 0.8555941, 0.85594952, 0.85630488, 0.85666025, 0.85701531, 0.85737044, 0.85772532, 0.85808021, 0.85843503, 0.85878974, 0.85914427, 0.8594988, 0.85985315, 0.86020756, 0.86056167, 0.86091578, 0.86126977, 0.86162364, 0.86197752, 0.86233121, 0.86268479, 0.86303836, 0.86339176, 0.86374509, 0.86409843, 0.86445153, 0.86480451, 0.86515754, 0.86551034, 0.86586314, 0.86621571, 0.86656827, 0.86692071, 0.86727327, 0.86762547, 0.86797762, 0.86832964, 0.86868173, 0.86903363, 0.86938542, 0.86973703, 0.8700887, 0.87044013, 0.87079161, 0.87114286, 0.87149417, 0.8718453, 0.87219626, 0.87254715, 0.8728981, 0.87324882, 0.87359941, 0.87395, 0.87430048, 0.87465084, 0.87500107, 0.87535125, 0.87570131, 0.87605131, 0.87640113, 0.87675089, 0.87710059, 0.87745023, 0.87779975, 0.87814903, 0.87849838, 0.87884754, 0.8791967, 0.87954569, 0.87989461, 0.88024342, 0.88059211, 0.88094074, 0.88128924, 0.88163769, 0.88198608, 0.88233429, 0.8826825, 0.88303053, 0.88337839, 0.8837263, 0.88407403, 0.88442171, 0.88476926, 0.88511676, 0.88546419, 0.88581139, 0.88615853, 0.88650578, 0.88685268, 0.88719958, 0.8875463, 0.88789308, 0.88823974, 0.88858622, 0.88893253, 0.88927895, 0.88962513, 0.88997126, 0.89031732, 0.89066321, 0.89100909, 0.89135486, 0.89170045, 0.89204597, 0.89239144, 0.89273685, 0.89308202, 0.89342731, 0.8937723, 0.8941173, 0.89446229, 0.89480692, 0.89515167, 0.89549619, 0.8958407, 0.8961851, 0.8965295, 0.89687359, 0.89721763, 0.89756173, 0.89790565, 0.89824945, 0.89859319, 0.89893675, 0.89928031, 0.89962381, 0.89996719, 0.9003104, 0.90065348, 0.90099657, 0.90133947, 0.90168238, 0.90202504, 0.90236777, 0.90271038, 0.90305287, 0.90339524, 0.90373749, 0.90407968, 0.90442187, 0.90476376, 0.90510565, 0.90544748, 0.9057892, 0.90613079, 0.90647233, 0.90681368, 0.90713507, 0.90743601, 0.90773672, 0.90803707, 0.9083373, 0.90863705, 0.90893668, 0.90923595, 0.90953493, 0.90983373, 0.91013199, 0.91043031, 0.91072816, 0.91102576, 0.91132301, 0.91162008, 0.91191679, 0.91221321, 0.91250944, 0.91280544, 0.91310102, 0.91339636, 0.91369152, 0.91398627, 0.91428077, 0.91457498, 0.91486901, 0.91516262, 0.915456, 0.91574907, 0.91604197, 0.91633445, 0.91662675, 0.91691875, 0.91721046, 0.91750187, 0.91779298, 0.91808385, 0.91837442, 0.91866475, 0.91895473, 0.91924453, 0.91953391, 0.91982317, 0.92011195, 0.92040062, 0.92068899, 0.920977, 0.92126483, 0.9215523, 0.92183948, 0.92212647, 0.92241311, 0.92269945, 0.92298555, 0.9232713, 0.92355686, 0.92384213, 0.9241271, 0.92441177, 0.92469621, 0.92498034, 0.92526412, 0.92554772, 0.92583102, 0.92611396, 0.92639667, 0.92667913, 0.92696136, 0.92724317, 0.92752481, 0.92780614, 0.92808717, 0.92836791, 0.92864841, 0.92892861, 0.92920852, 0.92948818, 0.92976749, 0.93004656, 0.93032539, 0.93060392, 0.9308821, 0.93116009, 0.93143767, 0.93171507, 0.93199223, 0.93226904, 0.9325456, 0.93282181, 0.93309784, 0.93337357, 0.93364894, 0.93392414, 0.93419898, 0.93447351, 0.93474782, 0.93502188, 0.93529558, 0.93556911, 0.93584222, 0.93611515, 0.93638778, 0.93666011, 0.93693215, 0.93720388, 0.93747544, 0.93774664, 0.93801755, 0.93828827, 0.93855858, 0.93882871, 0.93909848, 0.93936807, 0.9396373, 0.93990624, 0.94017494, 0.94044334, 0.94071144, 0.9409793, 0.94124693, 0.94151419, 0.94178122, 0.94204789, 0.94231433, 0.94258052, 0.94284642, 0.94311202, 0.94337738, 0.94364238, 0.94390708, 0.94417149, 0.94443583, 0.9446997, 0.94496334, 0.94522667, 0.9454897, 0.94575256, 0.94601506, 0.94627726, 0.94653922, 0.94680095, 0.94706237, 0.94732338, 0.94758427, 0.94784486, 0.9481051, 0.94836509, 0.94862479, 0.94888425, 0.94914335, 0.94940215, 0.94966072, 0.9499191, 0.95017713, 0.95043492, 0.95069236, 0.95094949, 0.95120639, 0.95146298, 0.9517194, 0.95197546, 0.95223123, 0.95248669, 0.95274186, 0.95299691, 0.95325154, 0.95350587, 0.95375997, 0.95401376, 0.95426726, 0.95452052, 0.95477355, 0.95502627, 0.95527864, 0.95553076, 0.95578265, 0.95603424, 0.95628554, 0.95653647, 0.95678723, 0.95703763, 0.95728779, 0.95753771, 0.95778728, 0.95803666, 0.95828563, 0.95853448, 0.95878291, 0.95903111, 0.95927906, 0.95952666, 0.95977402, 0.96002102, 0.9602679, 0.96051443, 0.96076071, 0.96100664, 0.96125227, 0.9614976, 0.96174282, 0.96198767, 0.96223217, 0.96247643, 0.96272039, 0.96296418, 0.9632076, 0.96345073, 0.96369362, 0.96393621, 0.9641785, 0.9644205, 0.96466225, 0.96490365, 0.96514499, 0.96538579, 0.96562648, 0.96586674, 0.96610689, 0.96634662, 0.96658611, 0.96682537, 0.96706426, 0.96730292, 0.96754134, 0.9677794, 0.96801722, 0.96825469, 0.96849197, 0.96872902, 0.96896565, 0.96920204, 0.96943814, 0.96967411, 0.96990961, 0.97014499, 0.97037995, 0.97061461, 0.9708491, 0.97108322, 0.97131711, 0.97155082, 0.97178406, 0.97201717, 0.97224993, 0.97248238, 0.97271466, 0.97294652, 0.97317815, 0.97340953, 0.9736405, 0.97387141, 0.9741019, 0.97433209, 0.97456211, 0.97479171, 0.97502118, 0.9752503, 0.97547907, 0.97570765, 0.97593594, 0.97616392, 0.97639167, 0.97661906, 0.97684622, 0.97707313, 0.97729969, 0.97752601, 0.97775203, 0.97797775, 0.97820324, 0.97842848, 0.97865337, 0.97887796, 0.97910231, 0.97932637, 0.97955012, 0.97977364, 0.97999692, 0.98021978, 0.98044246, 0.98066479, 0.98088688, 0.98110873, 0.98133034, 0.98155153, 0.98177248, 0.9819932, 0.98221368, 0.98243374, 0.98265362, 0.9828732, 0.98309249, 0.98331153, 0.98353028, 0.98374867, 0.98396689, 0.98418468, 0.9844023, 0.98461968, 0.98483676, 0.98505348, 0.9852699, 0.98548615, 0.98570204, 0.98591775, 0.98613316, 0.98634815, 0.98656303, 0.98677748, 0.9869917, 0.98720574, 0.98741937, 0.98763281, 0.98784596, 0.98805869, 0.9882713, 0.98848355, 0.98869556, 0.98890728, 0.98911875, 0.98932981, 0.98954076, 0.98975128, 0.98996162, 0.99017167, 0.99038136, 0.99059087, 0.99080002, 0.991009, 0.99121761, 0.99142593, 0.99163401, 0.99184179, 0.99204928, 0.99225658, 0.99246347, 0.99267018, 0.99287653, 0.99308264, 0.9932884, 0.99349391, 0.99369925, 0.99390429, 0.99410897, 0.9943133, 0.99451751, 0.99472129, 0.9949249, 0.99512821, 0.99533117, 0.99553394, 0.99573636, 0.99593848, 0.99614042, 0.996342, 0.99654341, 0.99674445, 0.99694514, 0.99714571, 0.99734586, 0.99754578, 0.99774545, 0.99794483, 0.99814397, 0.99834275, 0.99854124, 0.99873942, 0.99893749, 0.9991352, 0.99933249, 0.99952966, 0.99972647, 0.99992305, 1.0001193, 1.0003153, 1.0005111, 1.0007064, 1.0009016, 1.0010965, 1.0012912, 1.0014853, 1.0016794, 1.0018731, 1.0020666, 1.0022599, 1.0024527, 1.0026454, 1.0028377, 1.0030298, 1.0032215, 1.0034131, 1.0036042, 1.0037953, 1.0039859, 1.0041763, 1.0043664, 1.0045563, 1.0047457, 1.004935, 1.005124, 1.0053128, 1.0055012, 1.0056893, 1.0058771, 1.0060647, 1.0062519, 1.006439, 1.0066258, 1.0068122, 1.0069983, 1.0071843, 1.0073699, 1.0075552, 1.0077403, 1.007925, 1.0081095, 1.0082937, 1.0084777, 1.0086613, 1.0088447, 1.0090277, 1.0092106, 1.0093931, 1.0095752, 1.0097573, 1.0099391, 1.0101204, 1.0103015, 1.0104823, 1.0106628, 1.0108432, 1.0110232, 1.0112029, 1.0113823, 1.0115615, 1.0117404, 1.0119189, 1.0120972, 1.0122753, 1.0124531, 1.0126305, 1.0128077, 1.0129846, 1.0131613, 1.0133376, 1.0135137, 1.0136895, 1.013865, 1.0140402, 1.0142152, 1.0143899, 1.0145643, 1.0147383, 1.0149121, 1.0150857, 1.015259, 1.015432, 1.0156046, 1.0157771, 1.0159491, 1.016121, 1.0162927, 1.0164639, 1.0166349, 1.0168056, 1.0169761, 1.0171463, 1.0173162, 1.0174859, 1.0176551, 1.0178243, 1.017993, 1.0181615, 1.0183296, 1.0184976, 1.0186653, 1.0188326, 1.0189997, 1.0191666, 1.0193331, 1.0194993, 1.0196652, 1.0198309, 1.0199964, 1.0201615, 1.0203264, 1.0204909, 1.0206552, 1.0208192, 1.0209829, 1.0211464, 1.0213095, 1.0214725, 1.0216351, 1.0217973, 1.0219593, 1.0221211, 1.0222826, 1.0224438, 1.0226046, 1.0227653, 1.0229256, 1.0230857, 1.0232456, 1.023405, 1.0235643, 1.0237231, 1.0238819, 1.0240403, 1.0241984, 1.0243561, 1.0245137, 1.0246711, 1.024828, 1.0249848, 1.0251411, 1.0252973, 1.0254531, 1.0256087, 1.025764, 1.025919, 1.0260737, 1.0262282, 1.0263824, 1.0265362, 1.02669, 1.0268433, 1.0269963, 1.0271491, 1.0273015, 1.0274538, 1.0276058, 1.0277574, 1.0279087, 1.0280598, 1.0282106, 1.0283612, 1.0285114, 1.0286614, 1.028811, 1.0289605, 1.0291097, 1.0292585, 1.029407, 1.0295553, 1.0297034, 1.0298511, 1.0299985, 1.0301456, 1.0302925, 1.0304391, 1.0305855, 1.0307314, 1.0308772, 1.0310227, 1.0311679, 1.0313128, 1.0314574, 1.0316019, 1.0317459, 1.0318897, 1.0320332, 1.0321765, 1.0323194, 1.032462, 1.0326045, 1.0327466, 1.0328884, 1.0330299, 1.0331712, 1.0333122, 1.0334529, 1.0335933, 1.0337335, 1.0338733, 1.034013, 1.0341522, 1.0342913, 1.0344299, 1.0345684, 1.0347066, 1.0348445, 1.0349821, 1.0351195, 1.0352565, 1.0353934, 1.0355299, 1.035666, 1.0358019, 1.0359377, 1.0360731, 1.036208, 1.0363429, 1.0364774, 1.0366117, 1.0367455, 1.0368793, 1.0370127, 1.0371457, 1.0372788, 1.0374112, 1.0375435, 1.0376755, 1.0378073, 1.0379388, 1.0380698, 1.0382007, 1.0383314, 1.0384617, 1.0385917, 1.0387214, 1.0388509, 1.0389802, 1.0391091, 1.0392377, 1.039366, 1.0394943, 1.0396219, 1.0397495, 1.0398767, 1.0400037, 1.0401304, 1.0402567, 1.0403829, 1.0405086, 1.0406342, 1.0407594, 1.0408845, 1.0410092, 1.0411336, 1.0412577, 1.0413816, 1.0415052, 1.0416286, 1.0417515, 1.0418743, 1.0419967, 1.0421189, 1.0422407, 1.0423625, 1.0424838, 1.0426048, 1.0427257, 1.0428462, 1.0429664, 1.0430863, 1.0432059, 1.0433253, 1.0434444, 1.0435632, 1.0436817, 1.0438, 1.043918, 1.0440357, 1.0441531, 1.0442703, 1.0443871, 1.0445036, 1.0446199, 1.0447359, 1.0448517, 1.0449672, 1.0450823, 1.0451971, 1.0453118, 1.0454261, 1.0455401, 1.0456539, 1.0457674, 1.0458807, 1.0459934, 1.0461061, 1.0462185, 1.0463306, 1.0464424, 1.0465539, 1.0466652, 1.0467761, 1.0468868, 1.0469972, 1.0471073, 1.0472171, 1.0473267, 1.0474359, 1.047545, 1.0476537, 1.047762, 1.0478702, 1.047978, 1.0480857, 1.048193, 1.0483, 1.0484067, 1.0485132, 1.0486195, 1.0487254, 1.0488309, 1.0489362, 1.0490414, 1.0491461, 1.0492506, 1.0493548, 1.0494589, 1.0495625, 1.0496658, 1.0497689, 1.0498717, 1.0499743, 1.0500765, 1.0501784, 1.0502802, 1.0503817, 1.0504827, 1.0505836, 1.0506841, 1.0507845, 1.0508845, 1.0509841, 1.0510837, 1.0511827, 1.0512817, 1.0513803, 1.0514786, 1.0515766, 1.0516745, 1.0517719, 1.0518692, 1.0519661, 1.0520626, 1.0521591, 1.0522552, 1.052351, 1.0524465, 1.0525416, 1.0526366, 1.0527314, 1.0528257, 1.0529197, 1.0530136, 1.0531073, 1.0532005, 1.0532935, 1.0533862, 1.0534786, 1.0535707, 1.0536627, 1.0537543, 1.0538455, 1.0539366, 1.0540273, 1.0541178, 1.054208, 1.0542979, 1.0543876, 1.0544769, 1.0545659, 1.0546547, 1.0547432, 1.0548315, 1.0549194, 1.055007, 1.0550945, 1.0551815, 1.0552683, 1.0553548, 1.0554411, 1.0555271, 1.0556128, 1.0556982, 1.0557834, 1.0558681, 1.0559528, 1.0560372, 1.0561211, 1.0562048, 1.0562884, 1.0563713, 1.0564543, 1.0565369, 1.0566193, 1.0567013, 1.056783, 1.0568645, 1.0569458, 1.0570267, 1.0571073, 1.0571878, 1.0572678, 1.0573475, 1.0574272, 1.0575063, 1.0575854, 1.057664, 1.0577425, 1.0578206, 1.0578983, 1.0579759, 1.0580531, 1.0581301, 1.0582069, 1.0582833, 1.0583595, 1.0584353, 1.0585109, 1.0585862, 1.0586612, 1.058736, 1.0588105, 1.0588847, 1.0589586, 1.0590322, 1.0591055, 1.0591786, 1.0592514, 1.0593239, 1.0593961, 1.0594682, 1.0595398, 1.0596112, 1.0596823, 1.0597531, 1.0598236, 1.0598938, 1.0599638, 1.0600336, 1.0601031, 1.0601721, 1.060241, 1.0603095, 1.0603778, 1.0604458, 1.0605136, 1.060581, 1.0606482, 1.0607151, 1.0607817, 1.060848, 1.0609142, 1.0609798, 1.0610454, 1.0611106, 1.0611755, 1.0612401, 1.0613046, 1.0613686, 1.0614324, 1.0614959, 1.0615592, 1.0616221, 1.0616848, 1.0617472, 1.0618093, 1.0618712, 1.0619327, 1.0619941, 1.062055, 1.0621157, 1.0621762, 1.0622363, 1.0622962, 1.0623558, 1.062415, 1.0624741, 1.0625329, 1.0625913, 1.0626496, 1.0627075, 1.0627651, 1.0628223, 1.0628794, 1.0629363, 1.0629928, 1.063049, 1.063105, 1.0631607, 1.0632161, 1.0632712, 1.0633259, 1.0633805, 1.0634347, 1.0634887, 1.0635424, 1.0635959, 1.0636489, 1.0637019, 1.0637544, 1.0638067, 1.0638587, 1.0639104, 1.063962, 1.0640131, 1.064064, 1.0641146, 1.064165, 1.0642151, 1.0642648, 1.0643142, 1.0643635, 1.0644124, 1.064461, 1.0645094, 1.0645576, 1.0646052, 1.0646528, 1.0647, 1.0647471, 1.0647938, 1.0648401, 1.0648863, 1.0649321, 1.0649778, 1.0650231, 1.0650679, 1.0651126, 1.0651571, 1.0652013, 1.0652452, 1.0652888, 1.0653321, 1.0653751, 1.0654178, 1.0654603, 1.0655025, 1.0655445, 1.0655861, 1.0656275, 1.0656685, 1.0657092, 1.0657498, 1.0657901, 1.0658299, 1.0658696, 1.065909, 1.0659481, 1.0659869, 1.0660255, 1.0660636, 1.0661017, 1.0661395, 1.0661769, 1.066214, 1.0662509, 1.0662874, 1.0663238, 1.0663598, 1.0663955, 1.0664309, 1.0664662, 1.066501, 1.0665357, 1.0665699, 1.0666039, 1.0666379, 1.0666714, 1.0667045, 1.0667374, 1.0667701, 1.0668024, 1.0668344, 1.0668664, 1.0668979, 1.0669291, 1.0669601, 1.0669907, 1.0670213, 1.0670513, 1.0670811, 1.0671108, 1.06714, 1.0671691, 1.0671978, 1.0672262, 1.0672543, 1.0672822, 1.0673097, 1.0673372, 1.0673642, 1.067391, 1.0674174, 1.0674436, 1.0674695, 1.0674951, 1.0675205, 1.0675455, 1.0675703, 1.0675949, 1.0676191, 1.067643, 1.0676668, 1.06769, 1.0677133, 1.067736, 1.0677586, 1.0677809, 1.0678029, 1.0678246, 1.0678459, 1.0678672, 1.067888, 1.0678768, 1.0678339, 1.0677905, 1.067747, 1.0677031, 1.0676591, 1.0676148, 1.0675702, 1.0675254, 1.0674803, 1.0674349, 1.0673892, 1.0673434, 1.0672972, 1.0672508, 1.0672042, 1.0671573, 1.0671101, 1.0670626, 1.0670149, 1.066967, 1.0669188, 1.0668703, 1.0668217, 1.0667727, 1.0667233, 1.0666739, 1.0666242, 1.0665741, 1.0665239, 1.0664734, 1.0664226, 1.0663714, 1.0663202, 1.0662687, 1.0662168, 1.0661647, 1.0661124, 1.0660598, 1.0660068, 1.0659537, 1.0659004, 1.0658468, 1.0657929, 1.0657388, 1.0656844, 1.0656296, 1.0655748, 1.0655196, 1.0654641, 1.0654085, 1.0653524, 1.0652963, 1.0652398, 1.065183, 1.0651261, 1.0650688, 1.0650114, 1.0649536, 1.0648955, 1.0648372, 1.0647787, 1.0647199, 1.0646609, 1.0646015, 1.0645419, 1.0644821, 1.064422, 1.0643617, 1.064301, 1.0642402, 1.0641792, 1.0641177, 1.064056, 1.0639942, 1.0639319, 1.0638696, 1.063807, 1.0637441, 1.0636808, 1.0636173, 1.0635537, 1.0634897, 1.0634254, 1.0633609, 1.0632962, 1.0632312, 1.063166, 1.0631005, 1.0630347, 1.0629686, 1.0629023, 1.0628358, 1.0627691, 1.0627019, 1.0626347, 1.062567, 1.0624992, 1.0624311, 1.0623627, 1.0622941, 1.0622252, 1.0621562, 1.0620867, 1.0620171, 1.0619472, 1.061877, 1.0618066, 1.0617359, 1.0616649, 1.0615938, 1.0615224, 1.0614506, 1.0613786, 1.0613064, 1.0612339, 1.0611612, 1.0610881, 1.0610149, 1.0609413, 1.0608675, 1.0607934, 1.0607193, 1.0606447, 1.0605698, 1.0604948, 1.0604194, 1.0603439, 1.060268, 1.0601919, 1.0601156, 1.0600389, 1.059962, 1.0598849, 1.0598074, 1.0597298, 1.059652, 1.0595737, 1.0594952, 1.0594167, 1.0593376, 1.0592585, 1.0591789, 1.0590992, 1.0590192, 1.058939, 1.0588585, 1.0587778, 1.0586967, 1.0586156, 1.058534, 1.0584522, 1.0583702, 1.0582879, 1.0582052, 1.0581224, 1.0580393, 1.057956, 1.0578724, 1.0577885, 1.0577044, 1.05762, 1.0575354, 1.0574505, 1.0573653, 1.0572799, 1.0571944, 1.0571084, 1.0570221, 1.0569358, 1.0568491, 1.0567621, 1.0566748, 1.0565873, 1.0564996, 1.0564116, 1.0563235, 1.0562348, 1.0561461, 1.0560571, 1.0559678, 1.0558783, 1.0557885, 1.0556985, 1.0556082, 1.0555176, 1.0554267, 1.0553356, 1.0552442, 1.0551527, 1.0550609, 1.0549687, 1.0548762, 1.0547836, 1.0546907, 1.0545975, 1.0545043, 1.0544105, 1.0543165, 1.0542223, 1.0541279, 1.0540333, 1.0539383, 1.053843, 1.0537475, 1.0536518, 1.0535557, 1.0534595, 1.0533631, 1.0532663, 1.0531693, 1.0530719, 1.0529745, 1.0528766, 1.0527785, 1.0526801, 1.0525817, 1.0524827, 1.0523837, 1.0522842, 1.0521847, 1.0520848, 1.0519847, 1.0518843, 1.0517837, 1.0516827, 1.0515816, 1.0514802, 1.0513784, 1.0512766, 1.0511743, 1.0510718, 1.0509691, 1.0508661, 1.0507629, 1.0506594, 1.0505557, 1.0504518, 1.0503474, 1.0502429, 1.0501381, 1.0500331, 1.0499278, 1.0498221, 1.0497165, 1.0496103, 1.0495039, 1.0493973, 1.0492905, 1.0491834, 1.049076, 1.0489684, 1.0488605, 1.0487524, 1.0486439, 1.0485353, 1.0484264, 1.0483173, 1.0482079, 1.0480982, 1.0479882, 1.047878, 1.0477675, 1.0476568, 1.0475458, 1.0474346, 1.0473231, 1.0472113, 1.0470992, 1.0469869, 1.0468744, 1.0467616, 1.0466486, 1.0465353, 1.0464218, 1.0463079, 1.0461938, 1.0460795, 1.0459648, 1.04585, 1.0457349, 1.0456195, 1.045504, 1.045388, 1.0452719, 1.0451554, 1.0450388, 1.0449219, 1.0448047, 1.0446873, 1.0445696, 1.0444516, 1.0443333, 1.044215, 1.0440961, 1.0439771, 1.0438579, 1.0437384, 1.0436186, 1.0434986, 1.0433784, 1.0432578, 1.043137, 1.0430158, 1.0428946, 1.042773, 1.0426512, 1.0425291, 1.0424068, 1.0422841, 1.0421612, 1.0420382, 1.0419147, 1.0417911, 1.0416672, 1.041543, 1.0414187, 1.041294, 1.041169, 1.0410439, 1.0409185, 1.0407926, 1.0406667, 1.0405405, 1.040414, 1.0402873, 1.0401603, 1.040033, 1.0399054, 1.0397776, 1.0396497, 1.0395215, 1.0393928, 1.039264, 1.039135, 1.0390056, 1.0388761, 1.0387462, 1.0386161, 1.0384858, 1.0383551, 1.0382242, 1.0380931, 1.0379617, 1.03783, 1.0376981, 1.0375659, 1.0374336, 1.0373008, 1.0371679, 1.0370347, 1.0369012, 1.0367675, 1.0366336, 1.0364994, 1.0363649, 1.0362301, 1.036095, 1.0359598, 1.0358243, 1.0356885, 1.0355525, 1.0354161, 1.0352796, 1.0351429, 1.0350058, 1.0348685, 1.0347308, 1.0345929, 1.0344548, 1.0343164, 1.0341779, 1.0340389, 1.0338998, 1.0337604, 1.0336207, 1.0334809, 1.0333407, 1.0332001, 1.0330596, 1.0329186, 1.0327773, 1.0326359, 1.0324942, 1.0323522, 1.03221, 1.0320674, 1.0319247, 1.0317817, 1.0316384, 1.0314949, 1.0313511, 1.0312071, 1.0310627, 1.0309181, 1.0307734, 1.0306282, 1.0304829, 1.0303373, 1.0301914, 1.0300453, 1.029899, 1.0297523, 1.0296055, 1.0294583, 1.0293108, 1.0291632, 1.0290152, 1.028867, 1.0287186, 1.0285699, 1.0284209, 1.0282717, 1.0281223, 1.0279726, 1.0278225, 1.0276722, 1.0275217, 1.027371, 1.02722, 1.0270686, 1.0269171, 1.0267653, 1.0266132, 1.026461, 1.0263084, 1.0261555, 1.0260025, 1.0258491, 1.0256954, 1.0255417, 1.0253875, 1.0252331, 1.0250785, 1.0249236, 1.0247684, 1.024613, 1.0244573, 1.0243014, 1.0241451, 1.0239887, 1.0238321, 1.023675, 1.0235178, 1.0233604, 1.0232027, 1.0230446, 1.0228863, 1.0227278, 1.0225691, 1.02241, 1.0222508, 1.0220913, 1.0219314, 1.0217712, 1.021611, 1.0214504, 1.0212895, 1.0211284, 1.0209671, 1.0208055, 1.0206436, 1.0204813, 1.0203191, 1.0201564, 1.0199935, 1.0198303, 1.0196669, 1.0195032, 1.0193393, 1.0191751, 1.0190105, 1.0188459, 1.0186809, 1.0185156, 1.0183501, 1.0181844, 1.0180184, 1.0178522, 1.0176857, 1.0175189, 1.0173517, 1.0171845, 1.0170169, 1.0168492, 1.0166811, 1.0165126, 1.0163441, 1.0161752, 1.0160061, 1.0158367, 1.0156671, 1.0154972, 1.0153271, 1.0151567, 1.014986, 1.0148151, 1.0146439, 1.0144725, 1.0143008, 1.0141289, 1.0139567, 1.0137842, 1.0136114, 1.0134385, 1.0132653, 1.0130917, 1.012918, 1.0127439, 1.0125697, 1.012395, 1.0122204, 1.0120453, 1.01187, 1.0116944, 1.0115186, 1.0113425, 1.0111661, 1.0109895, 1.0108126, 1.0106356, 1.0104582, 1.0102806, 1.0101026, 1.0099245, 1.0097461, 1.0095674, 1.0093886, 1.0092094, 1.0090299, 1.0088502, 1.0086703, 1.00849, 1.0083095, 1.0081288, 1.0079478, 1.0077666, 1.007585, 1.0074033, 1.0072212, 1.007039, 1.0068564, 1.0066736, 1.0064905, 1.0063072, 1.0061237, 1.0059397, 1.0057558, 1.0055714, 1.0053867, 1.0052018, 1.0050167, 1.0048314, 1.0046457, 1.0044599, 1.0042737, 1.0040872, 1.0039005, 1.0037136, 1.0035264, 1.0033389, 1.0031513, 1.0029633, 1.0027751, 1.0025866, 1.0023979, 1.0022088, 1.0020196, 1.0018301, 1.0016403, 1.0014502, 1.0012599, 1.0010694, 1.0008787, 1.0006875, 1.0004963, 1.0003046, 1.0001128, 0.99992067, 0.99972826, 0.99953562, 0.9993428, 0.99914968, 0.99895632, 0.99876261, 0.99856871, 0.99837458, 0.99818015, 0.99798548, 0.99779046, 0.99759525, 0.99739981, 0.99720412, 0.99700814, 0.99681187, 0.99661541, 0.99641865, 0.9962216, 0.99602431, 0.99582684, 0.99562901, 0.99543101, 0.9952327, 0.9950341, 0.99483526, 0.99463624, 0.99443686, 0.9942373, 0.99403745, 0.99383742, 0.99363697, 0.99343628, 0.99323541, 0.99303436, 0.9928329, 0.99263126, 0.99242932, 0.99222714, 0.99202472, 0.991822, 0.99161905, 0.99141586, 0.99121243, 0.99100864, 0.99080467, 0.99060041, 0.9903959, 0.9901911, 0.98998612, 0.9897809, 0.98957533, 0.98936951, 0.98916352, 0.98895717, 0.98875058, 0.98854381, 0.98833662, 0.98812932, 0.98792177, 0.98771381, 0.98750573, 0.98729736, 0.9870888, 0.98687983, 0.98667067, 0.98646122, 0.98625159, 0.98604161, 0.98583144, 0.98562104, 0.98541033, 0.98519939, 0.98498821, 0.98477662, 0.9845649, 0.98435295, 0.98414069, 0.9839282, 0.98371536, 0.98350239, 0.98328912, 0.98307562, 0.98286176, 0.98264766, 0.98243338, 0.98221874, 0.98200393, 0.98178881, 0.98157346, 0.98135787, 0.98114198, 0.98092592, 0.98070943, 0.98049289, 0.98027605, 0.98005885, 0.97984141, 0.97962368, 0.97940576, 0.97918755, 0.9789691, 0.97875041, 0.97853142, 0.97831219, 0.97809279, 0.97787303, 0.97765297, 0.97743267, 0.97721213, 0.97699147, 0.97677034, 0.97654909, 0.97632748, 0.97610563, 0.97588366, 0.97566134, 0.97543871, 0.97521591, 0.97499281, 0.97476941, 0.97454584, 0.97432196, 0.97409779, 0.97387338, 0.97364879, 0.97342378, 0.97319859, 0.97297317, 0.9727475, 0.97252166, 0.9722954, 0.97206885, 0.97184223, 0.97161525, 0.97138804, 0.97116047, 0.97093278, 0.97070467, 0.97047651, 0.97024792, 0.9700191, 0.96979016, 0.9695608, 0.9693312, 0.96910143, 0.9688713, 0.96864098, 0.96841037, 0.96817952, 0.96794838, 0.96771711, 0.96748543, 0.96725357, 0.96702135, 0.96678901, 0.96655631, 0.96632338, 0.9660902, 0.96585679, 0.96562308, 0.96538913, 0.96515495, 0.9649204, 0.96468574, 0.96445078, 0.96421558, 0.96397996, 0.96374422, 0.96350825, 0.96327198, 0.9630354, 0.96279854, 0.96256155, 0.96232426, 0.96208662, 0.9618488, 0.96161079, 0.96137238, 0.96113378, 0.96089494, 0.96065581, 0.96041644, 0.96017683, 0.95993692, 0.95969671, 0.95945638, 0.95921564, 0.95897466, 0.95873356, 0.9584921, 0.95825046, 0.95800835, 0.95776612, 0.9575237, 0.95728099, 0.95703799, 0.95679474, 0.95655125, 0.95630747, 0.95606345, 0.95581913, 0.95557457, 0.95532984, 0.95508474, 0.95483947, 0.9545939, 0.95434797, 0.95410192, 0.95385551, 0.95360887, 0.95336205, 0.95311493, 0.95286757, 0.95261991, 0.95237201, 0.95212388, 0.95187539, 0.95162672, 0.95137787, 0.9511286, 0.95087916, 0.95062935, 0.95037943, 0.95012921, 0.94987875, 0.94962806, 0.949377, 0.94912571, 0.94887424, 0.94862241, 0.94837034, 0.94811809, 0.94786561, 0.9476127, 0.94735962, 0.94710636, 0.94685274, 0.94659889, 0.94634479, 0.9460904, 0.94583577, 0.94558096, 0.94532579, 0.94507039, 0.94481474, 0.9445588, 0.94430262, 0.94404626, 0.94378948, 0.94353259, 0.94327533, 0.9430179, 0.94276017, 0.9425022, 0.94224399, 0.94198555, 0.94172668, 0.9414677, 0.94120842, 0.9409489, 0.94068915, 0.94042915, 0.94016874, 0.93990821, 0.93964738, 0.93938625, 0.93912494, 0.9388634, 0.93860155, 0.93833935, 0.93807697, 0.93781441, 0.9375515, 0.93728834, 0.93702489, 0.93676126, 0.93649733, 0.93623328, 0.93596876, 0.93570411, 0.93543917, 0.93517387, 0.93490845, 0.93464273, 0.93437666, 0.9341104, 0.93384391, 0.93357718, 0.93331015, 0.93304288, 0.93277532, 0.93250751, 0.93223947, 0.93197119, 0.93170261, 0.93143386, 0.93116468, 0.93089539, 0.9306258, 0.93035591, 0.93008578, 0.92981535, 0.92954475, 0.9292739, 0.9290027, 0.92873126, 0.92845958, 0.92818761, 0.92791545, 0.92764306, 0.92737037, 0.92709738, 0.92682421, 0.92655063, 0.92627686, 0.92600298, 0.92572868, 0.9254542, 0.92517936, 0.92490441, 0.92462903, 0.92435348, 0.92407769, 0.92380166, 0.92352527, 0.92324871, 0.9229719, 0.9226948, 0.92241746, 0.92213982, 0.92186201, 0.92158389, 0.92130548, 0.92102683, 0.92074788, 0.92046869, 0.92018932, 0.9199096, 0.91962969, 0.91934949, 0.91906911, 0.91878831, 0.9185074, 0.91822612, 0.91794467, 0.91766286, 0.91738093, 0.91709864, 0.91681612, 0.91653329, 0.91625029, 0.91596705, 0.91568345, 0.91539967, 0.91511554, 0.91483122, 0.91454661, 0.91426176, 0.91397667, 0.91369134, 0.91340566, 0.91311979, 0.91283363, 0.91254723, 0.91226059, 0.91197371, 0.9116866, 0.91139907, 0.91111141, 0.91082352, 0.91053522, 0.91024685, 0.90995806, 0.9096691, 0.9093799, 0.90909034, 0.9088006, 0.90851057, 0.90822029, 0.90792978, 0.90763903, 0.90734792, 0.90705657, 0.9067651, 0.90647328, 0.90618116, 0.9058888, 0.90559626, 0.90530336, 0.90501028, 0.90471691, 0.9044233, 0.90412939, 0.90383524, 0.90354085, 0.90324616, 0.90295124, 0.90265608, 0.90236062, 0.90206492, 0.90176892, 0.90147275, 0.90117621, 0.90087956, 0.90058255, 0.9002853, 0.89998782, 0.89969003, 0.89939201, 0.89909369, 0.89879525, 0.89849639, 0.89819741, 0.89789802, 0.89759845, 0.89729857, 0.89699852, 0.89669824, 0.89639759, 0.89609671, 0.89578605, 0.89546591, 0.8951456, 0.89482534, 0.89450485, 0.89418435, 0.8938638, 0.89354312, 0.89322245, 0.89290172, 0.89258087, 0.89225996, 0.89193898, 0.89161789, 0.89129674, 0.89097559, 0.89065433, 0.89033306, 0.89001155, 0.8896901, 0.88936859, 0.88904691, 0.88872522, 0.88840342, 0.88808167, 0.88775975, 0.88743776, 0.88711572, 0.88679355, 0.88647139, 0.88614917, 0.88582671, 0.88550442, 0.8851819, 0.88485938, 0.88453668, 0.88421404, 0.88389128, 0.88356847, 0.88324553, 0.88292253, 0.88259953, 0.88227648, 0.88195324, 0.88163, 0.88130665, 0.88098317, 0.88065976, 0.88033623, 0.88001257, 0.87968886, 0.87936509, 0.87904125, 0.87871736, 0.87839341, 0.87806934, 0.87774521, 0.87742108, 0.87709683, 0.87677252, 0.87644804, 0.87612361, 0.875799, 0.87547445, 0.87514979, 0.87482494, 0.87450016, 0.87417525, 0.87385029, 0.87352526, 0.87320012, 0.87287492, 0.87254977, 0.87222433, 0.87189889, 0.87157345, 0.87124789, 0.87092227, 0.87059665, 0.87027091, 0.86994499, 0.86961919, 0.86929315, 0.86896712, 0.86864102, 0.86831486, 0.86798865, 0.86766231, 0.86733586, 0.8670094, 0.86668283, 0.86635625, 0.86602956, 0.86570281, 0.865376, 0.865049, 0.86472213, 0.86439508, 0.86406797, 0.8637408, 0.86341357, 0.86308616, 0.86275882, 0.86243135, 0.86210376, 0.86177623, 0.86144853, 0.86112076, 0.86079299, 0.86046499, 0.86013705, 0.85980904, 0.85948092, 0.85915279, 0.85882455, 0.85849613, 0.85816771, 0.85783929, 0.85751075, 0.85718209, 0.85685354, 0.85652471, 0.85619593, 0.85586697, 0.85553807, 0.85520899, 0.85487992, 0.85455072, 0.85422152, 0.85389215, 0.85356277, 0.85323328, 0.85290372, 0.85257423, 0.8522445, 0.8519147, 0.85158491, 0.851255, 0.85092503, 0.850595, 0.85026491, 0.8499347, 0.84960449, 0.84927428, 0.84894383, 0.84861332, 0.84828275, 0.84795213, 0.8476215, 0.84729069, 0.84695989, 0.84662908, 0.8462981, 0.84596711, 0.84563595, 0.84530485, 0.84497356, 0.84464216, 0.84431088, 0.84397936, 0.84364784, 0.8433162, 0.84298462, 0.84265286, 0.84232098, 0.8419891, 0.84165704, 0.84132516, 0.84099299, 0.84066081, 0.84032863, 0.83999628, 0.83966392, 0.83933139, 0.83899885, 0.83866632, 0.83833373, 0.83800089, 0.83766818, 0.83733523, 0.83700222, 0.83666921, 0.83633614, 0.83600301, 0.83566964, 0.83533645, 0.83500308, 0.83466953, 0.8343361, 0.83400244, 0.83366877, 0.83333504, 0.8330012, 0.83266729, 0.83233339, 0.8319993, 0.83166522, 0.83133101, 0.83099693, 0.83066255, 0.83032811, 0.82999361, 0.82965916, 0.8293246, 0.82898992, 0.82865518, 0.82832038, 0.82798547, 0.82765043, 0.82731545, 0.82698035, 0.8266452, 0.82631004, 0.82597476, 0.82563931, 0.82530391, 0.82496834, 0.82463276, 0.82429707, 0.82396132, 0.82362556, 0.82328969, 0.8229537, 0.82261765, 0.82228154, 0.82194543, 0.8216092, 0.82127285, 0.82093644, 0.82060009, 0.82026356, 0.81992692, 0.81959027, 0.8192535, 0.8189168, 0.81857985, 0.81824291, 0.8179059, 0.81756884, 0.8172316, 0.81689447, 0.81655711, 0.81621975, 0.81588233, 0.81554472, 0.81520724, 0.81486952, 0.8145318, 0.81419396, 0.81385612, 0.81351823, 0.81318015, 0.81284207, 0.81250381, 0.81216568, 0.81182742, 0.81148899, 0.81115049, 0.81081194, 0.81047338, 0.81013483, 0.80979604, 0.80945724, 0.80911833, 0.80877942, 0.80844045, 0.8081013, 0.80776215, 0.80742294, 0.80708361, 0.80674428, 0.80640483, 0.80606532, 0.80572575, 0.80538601, 0.80504632, 0.80470651, 0.80436665, 0.80402666, 0.80368668, 0.80334657, 0.80300647, 0.80266613, 0.8023259, 0.80198556, 0.8016451, 0.80130458, 0.80096394, 0.80062336, 0.8002826, 0.79994184, 0.79960096, 0.79926002, 0.79891896, 0.79857796, 0.79823679, 0.79789555, 0.79755425, 0.79721284, 0.79687148, 0.79652995, 0.79618829, 0.79584664, 0.79550499, 0.79516321, 0.79482132, 0.79447937, 0.7941373, 0.79379529, 0.79345322, 0.79311091, 0.7927686, 0.79242623, 0.79208386, 0.79174131, 0.7913987, 0.79105604, 0.79071331, 0.79037052, 0.79002768, 0.78968471, 0.78934169, 0.78899872, 0.78865546, 0.78831226, 0.78796899, 0.78762555, 0.78728217, 0.78693867, 0.78659517, 0.78625143, 0.78590769, 0.78556395, 0.78522009, 0.78487617, 0.78453219, 0.78418797, 0.78384393, 0.78349972, 0.78315544, 0.78281105, 0.78246659, 0.78212208, 0.78177756, 0.78143293, 0.78108823, 0.78074336, 0.78039849, 0.78005356, 0.77970856, 0.77936339, 0.77901834, 0.77867311, 0.77832788, 0.77798247, 0.77763706, 0.77729148, 0.77694595, 0.7766003, 0.77625465, 0.77590877, 0.77556288, 0.775217, 0.77487099, 0.77452499, 0.7741788, 0.77383262, 0.77348626, 0.77313995, 0.77279359, 0.77244705, 0.77210045, 0.77175379, 0.77140707, 0.77106029, 0.77071345, 0.77036649, 0.77001947, 0.76967245, 0.76932526, 0.76897806, 0.7686308, 0.76828343, 0.76793599, 0.76758856, 0.76724094, 0.76689327, 0.76654559, 0.7661978, 0.76585001, 0.76550198, 0.765154, 0.76480597, 0.76445782, 0.76410961, 0.76376134, 0.76341301, 0.7630645, 0.76271605, 0.76236749, 0.76201886, 0.76167017, 0.76132131, 0.7609725, 0.76062351, 0.76027453, 0.75992554, 0.75957638, 0.75922716, 0.75887787, 0.75852853, 0.75817907, 0.75782967, 0.75748003, 0.75713038, 0.75678068, 0.75643098, 0.75608104, 0.75573117, 0.75538111, 0.75503105, 0.75468087, 0.75433069, 0.75398058, 0.75363004, 0.75327975, 0.75292915, 0.75257862, 0.75222802, 0.75187725, 0.75152653, 0.75117564, 0.75082469, 0.7504738, 0.75012267, 0.7497716, 0.74942034, 0.74906909, 0.74871773, 0.7483663, 0.74801481, 0.74766326, 0.74731165, 0.74695992, 0.74660814, 0.74625629, 0.74590439, 0.74555242, 0.74520028, 0.74484819, 0.74449593, 0.74414372, 0.74379134, 0.7434389, 0.74308646, 0.7427339, 0.74238127, 0.74202853, 0.74167573, 0.74132288, 0.74097002, 0.74061698, 0.74026394, 0.73991084, 0.73955762, 0.73920429, 0.73885095, 0.73849761, 0.73814416, 0.73779052, 0.73743695, 0.7370832, 0.7367295, 0.73637563, 0.7360217, 0.73566771, 0.73531365, 0.73495954, 0.73460531, 0.73425102, 0.73389667, 0.73354226, 0.73318779, 0.73283327, 0.73247862, 0.73212391, 0.7317692, 0.73141432, 0.73105937, 0.73070443, 0.73034936, 0.72999424, 0.72963905, 0.72928375, 0.72892851, 0.72857302, 0.7282176, 0.727862, 0.7275064, 0.72715062, 0.72679496, 0.72643906, 0.72608316, 0.72572714, 0.72537106, 0.72501493, 0.72465873, 0.72430247, 0.72394615, 0.72358972, 0.72323328, 0.72287679, 0.72252011, 0.72216344, 0.72180665, 0.72144979, 0.72109288, 0.72073591, 0.72037888, 0.72002178, 0.71966457, 0.7193073, 0.71894997, 0.71859258, 0.71823508, 0.71787757, 0.71751988, 0.71716225, 0.7168045, 0.71644658, 0.71608871, 0.71573079, 0.71537268, 0.71501452, 0.71465641, 0.71429813, 0.71393979, 0.71358138, 0.71322292, 0.71286434, 0.7125057, 0.71214706, 0.7117883, 0.71142948, 0.71107054, 0.7107116, 0.71035254, 0.70999336, 0.70963424, 0.70927489, 0.70891559, 0.70855618, 0.7081967, 0.70783716, 0.70747757, 0.70711786, 0.70675814, 0.70639825, 0.70603842, 0.7056784, 0.70531833, 0.70495826, 0.70459801, 0.70423782, 0.70387745, 0.70351714, 0.70315653, 0.70279604, 0.70243543, 0.70207477, 0.70171392, 0.70135313, 0.70099223, 0.70063126, 0.70027024, 0.69990915, 0.69954795, 0.69918668, 0.6988253, 0.69846392, 0.69810247, 0.69774097, 0.69737935, 0.69701761, 0.69665587, 0.69629401, 0.69593215, 0.69557023, 0.69520819, 0.69484603, 0.69448388, 0.69412154, 0.69375926, 0.69339681, 0.69303441, 0.69267184, 0.69230932, 0.69194663, 0.69158381, 0.691221, 0.69085801, 0.69049507, 0.69013208, 0.68976891, 0.68940586, 0.68904251, 0.68867916, 0.68831587, 0.6879524, 0.68758881, 0.68722522, 0.68686146, 0.68649775, 0.68613392, 0.68577003, 0.68540603, 0.68504208, 0.68467796, 0.68431371, 0.68394947, 0.68358517, 0.6832208, 0.68285638, 0.68249178, 0.68212724, 0.68176246, 0.68139774, 0.68103296, 0.68066806, 0.6803031, 0.67993802, 0.67957294, 0.67920774, 0.67884254, 0.67847717, 0.67811179, 0.6777463, 0.67738074, 0.67701519, 0.67664957, 0.67628372, 0.67591792, 0.67555207, 0.6751861, 0.67482007, 0.67445397, 0.67408776, 0.67372149, 0.67335528, 0.67298883, 0.67262238, 0.67225581, 0.67188919, 0.67152262, 0.67115575, 0.67078894, 0.67042208, 0.67005515, 0.66968817, 0.669321, 0.66895384, 0.66858661, 0.66821921, 0.66785187, 0.6674844, 0.66711688, 0.6667493, 0.66638166, 0.6660139, 0.66564602, 0.66527814, 0.6649102, 0.66454214, 0.66417414, 0.66380584, 0.6634376, 0.66306931, 0.66270101, 0.66233253, 0.661964, 0.66159534, 0.66122669, 0.66085798, 0.6604892, 0.66012025, 0.65975136, 0.65938234, 0.65901321, 0.65864402, 0.65827477, 0.65790546, 0.65753609, 0.65716666, 0.65679711, 0.65642756, 0.65605783, 0.65568817, 0.65531832, 0.65494841, 0.65457839, 0.65420848, 0.6538384, 0.65346813, 0.65309793, 0.6527276, 0.65235722, 0.65198678, 0.65161628, 0.65124565, 0.65087497, 0.65050429, 0.65013349, 0.64976263, 0.64939165, 0.64902055, 0.64864951, 0.64827836, 0.64790714, 0.64753574, 0.6471644, 0.64679301, 0.64642149, 0.64604986, 0.64567822, 0.64530641, 0.64493465, 0.64456272, 0.64419085, 0.6438188, 0.64344662, 0.64307451, 0.64270234, 0.64233005, 0.64195764, 0.64158517, 0.64121264, 0.64084011, 0.64046741, 0.64009458, 0.63972187, 0.63934898, 0.63897604, 0.63860309, 0.63822991, 0.63785678, 0.63748354, 0.63711029, 0.63673681, 0.63636339, 0.6359899, 0.6356163, 0.63524264, 0.63486886, 0.63449502, 0.63412118, 0.63374728, 0.63337332, 0.63299912, 0.63262498, 0.63225079, 0.63187647, 0.63150209, 0.6311276, 0.6307531, 0.63037854, 0.63000393, 0.62962914, 0.62925428, 0.62887949, 0.62850451, 0.62812954, 0.62775445, 0.62737924, 0.62700403, 0.62662876, 0.62625349, 0.62587798, 0.62550241, 0.62512678, 0.62475121, 0.62437546, 0.62399966, 0.62362379, 0.62324786, 0.62287182, 0.62249577, 0.62211961, 0.62174332, 0.6213671, 0.62099063, 0.62061423, 0.62023777, 0.61986119, 0.61948454, 0.61910778, 0.61873096, 0.61835408, 0.61797714, 0.61760014, 0.61722308, 0.61684597, 0.61646873, 0.61609137, 0.61571401, 0.61533666, 0.61495906, 0.61458147, 0.61420381, 0.6138261, 0.61344832, 0.61307049, 0.61269248, 0.61231446, 0.61193645, 0.61155832, 0.61118007, 0.61080176, 0.61042339, 0.61004496, 0.60966653, 0.60928792, 0.60890919, 0.60853052, 0.60815173, 0.60777283, 0.60739392, 0.60701489, 0.60663587, 0.60625666, 0.6058774, 0.60549819, 0.60511875, 0.60473937, 0.60435992, 0.6039803, 0.60360068, 0.60322088, 0.60284114, 0.60246128, 0.6020813, 0.60170132, 0.60132122, 0.60094112, 0.6005609, 0.60018057, 0.59980023, 0.59941977, 0.59903932, 0.59865874, 0.59827811, 0.59789723, 0.59751654, 0.59713572, 0.59675479, 0.5963738, 0.59599268, 0.59561151, 0.59523034, 0.59484911, 0.5944677, 0.59408617, 0.5937047, 0.59332317, 0.59294152, 0.59255981, 0.59217799, 0.5917961, 0.59141421, 0.59103227, 0.59065014, 0.59026802, 0.58988577, 0.58950353, 0.58912116, 0.58873874, 0.5883562, 0.58797365, 0.58759099, 0.58720827, 0.58682555, 0.58644265, 0.58605975, 0.58567673, 0.58529365, 0.58491051, 0.58452725, 0.584144, 0.58376068, 0.58337724, 0.58299375, 0.58261013, 0.58222646, 0.58184278, 0.58145905, 0.58107519, 0.58069122, 0.58030725, 0.57992321, 0.57953906, 0.57915485, 0.57877058, 0.57838619, 0.57800174, 0.57761729, 0.57723266, 0.57684803, 0.57646334, 0.57607859, 0.57569373, 0.57530874, 0.57492381, 0.57453865, 0.57415366, 0.57376838, 0.57338309, 0.57299769, 0.57261229, 0.57222688, 0.5718413, 0.5714556, 0.5710699, 0.57068413, 0.57029831, 0.56991243, 0.56952637, 0.56914032, 0.5687542, 0.56836796, 0.56798178, 0.5675953, 0.56720889, 0.56682241, 0.56643587, 0.56604928, 0.5656625, 0.56527579, 0.56488895, 0.564502, 0.56411505, 0.56372792, 0.56334078, 0.56295353, 0.56256634, 0.56217891, 0.5617916, 0.56140411, 0.5610165, 0.56062889, 0.56024122, 0.55985337, 0.55946553, 0.55907768, 0.55868965, 0.55830151, 0.55791348, 0.55752522, 0.55713701, 0.55674863, 0.55636019, 0.55597174, 0.55558312, 0.55519456, 0.55480576, 0.55441701, 0.55402821, 0.55363923, 0.55325031, 0.55286127, 0.55247205, 0.5520829, 0.55169362, 0.55130434, 0.55091488, 0.55052537, 0.55013585, 0.54974622, 0.54935652, 0.54896671, 0.54857689, 0.54818696, 0.54779702, 0.54740691, 0.54701686, 0.54662657, 0.54623634, 0.54584599, 0.54545563, 0.5450651, 0.54467452, 0.54428387, 0.54389322, 0.54350251, 0.54311162, 0.54272074, 0.54232973, 0.54193866, 0.54154754, 0.54115641, 0.54076505, 0.54037368, 0.54000133, 0.53964794, 0.53929466, 0.5389415, 0.53858846, 0.53823537, 0.53788239, 0.53752947, 0.53717673, 0.53682393, 0.53647125, 0.53611869, 0.53576618, 0.53541386, 0.53506142, 0.53470922, 0.53435707, 0.53400487, 0.53365284, 0.53330094, 0.53294903, 0.53259724, 0.53224546, 0.53189385, 0.5315423, 0.53119081, 0.53083944, 0.53048807, 0.53013682, 0.52978563, 0.52943456, 0.52908349, 0.5287326, 0.52838176, 0.52803093, 0.52768028, 0.52732962, 0.52697903, 0.52662849, 0.5262782, 0.52592784, 0.52557766, 0.52522743, 0.52487737, 0.52452737, 0.52417743, 0.52382755, 0.52347779, 0.52312809, 0.52277851, 0.52242899, 0.52207947, 0.52173012, 0.52138078, 0.52103162, 0.52068239, 0.52033329, 0.5199843, 0.51963544, 0.51928657, 0.51893783, 0.51858914, 0.51824057, 0.51789206, 0.51754355, 0.51719522, 0.51684684, 0.51649863, 0.51615047, 0.5158025, 0.51545447, 0.51510656, 0.51475865, 0.51441097, 0.5140633, 0.51371568, 0.51336813, 0.51302069, 0.51267344, 0.51232612, 0.51197892, 0.51163167, 0.51128471, 0.51093775, 0.51059091, 0.51024401, 0.50989729, 0.50955069, 0.50920403, 0.50885755, 0.50851107, 0.5081647, 0.5078184, 0.50747222, 0.50712615, 0.50678015, 0.50643414, 0.50608826, 0.50574249, 0.50539678, 0.50505108, 0.50470549, 0.50436002, 0.50401455, 0.50366926, 0.50332397, 0.5029788, 0.50263375, 0.5022887, 0.50194371, 0.50159883, 0.50125408, 0.50090933, 0.50056469, 0.50022012, 0.49987569, 0.49953124, 0.49918696, 0.49884266, 0.49849856, 0.49815434, 0.49781042, 0.49746642, 0.49712265, 0.49677879, 0.49643511, 0.49609149, 0.49574795, 0.49540448, 0.49506104, 0.49471769, 0.49437451, 0.49403137, 0.49368826, 0.49334526, 0.49300236, 0.49265948, 0.49231672, 0.49197406, 0.49163145, 0.49128884, 0.49094638, 0.49060395, 0.49026173, 0.48991948, 0.48957741, 0.48923525, 0.4888933, 0.48855135, 0.48820952, 0.48786774, 0.48752606, 0.48718446, 0.48684293, 0.48650151, 0.48616016, 0.48581889, 0.48547766, 0.48513654, 0.48479539, 0.48445445, 0.48411357, 0.4837727, 0.48343202, 0.48309135, 0.48275071, 0.48241016, 0.48206982, 0.48172939, 0.48138911, 0.48104885, 0.48070881, 0.48036873, 0.48002884, 0.47968888, 0.47934908, 0.47900936, 0.47866973, 0.47833014, 0.47799057, 0.47765115, 0.47731182, 0.47697255, 0.47663334, 0.47629428, 0.47595516, 0.47561625, 0.47527742, 0.4749386, 0.47459987, 0.47426119, 0.47392264, 0.47358409, 0.47324577, 0.47290739, 0.47256914, 0.47223094, 0.47189289, 0.47155485, 0.47121689, 0.47087899, 0.47054124, 0.47020352, 0.46986586, 0.46952829, 0.46919087, 0.46885344, 0.46851614, 0.46817884, 0.46784166, 0.46750462, 0.46716762, 0.46683064, 0.46649384, 0.46615699, 0.46582034, 0.4654837, 0.4651472, 0.46481067, 0.46447429, 0.46413794, 0.46380177, 0.46346554, 0.46312949, 0.46279353, 0.46245757, 0.46212175, 0.461786, 0.46145031, 0.46111465, 0.46077907, 0.46044365, 0.46010831, 0.45977297, 0.45943776, 0.4591026, 0.45876756, 0.45843267, 0.45809767, 0.45776284, 0.45742804, 0.45709342, 0.45675877, 0.45642427, 0.45608979, 0.45575547, 0.45542124, 0.45508701, 0.45475283, 0.45441878, 0.45408478, 0.45375091, 0.45341709, 0.45308331, 0.45274964, 0.45241603, 0.45208254, 0.45174909, 0.45141578, 0.4510825, 0.45074928, 0.45041618, 0.45008317, 0.44975021, 0.44941729, 0.4490844, 0.44875169, 0.44841906, 0.44808647, 0.447754, 0.44742155, 0.44708923, 0.44675693, 0.44642475, 0.44609264, 0.44576061, 0.44542864, 0.44509676, 0.444765, 0.44443324, 0.44410163, 0.44377011, 0.44343862, 0.44310725, 0.44277576, 0.44244462, 0.4421134, 0.44178236, 0.44145134, 0.44112036, 0.44078946, 0.44045871, 0.440128, 0.43979737, 0.43946674, 0.43913633, 0.43880594, 0.43847558, 0.43814537, 0.43781519, 0.43748513, 0.4371551, 0.43682522, 0.4364953, 0.43616554, 0.43583578, 0.43550622, 0.43517664, 0.43484724, 0.43451783, 0.43418851, 0.43385932, 0.43353012, 0.43320113, 0.432872, 0.43254313, 0.43221429, 0.43188551, 0.43155685, 0.43122831, 0.43089974, 0.43057126, 0.43024287, 0.42991456, 0.42958635, 0.4292582, 0.42893016, 0.42860213, 0.42827427, 0.42794648, 0.42761868, 0.42729104, 0.42696342, 0.42663586, 0.42630845, 0.4259811, 0.42565379, 0.42532662, 0.42499948, 0.42467245, 0.42434543, 0.42401859, 0.42369172, 0.42336494, 0.42303827, 0.4227117, 0.42238525, 0.42205879, 0.42173252, 0.42140618, 0.42108005, 0.4207539, 0.42042789, 0.42010179, 0.41977599, 0.4194501, 0.41912448, 0.41879877, 0.41847321, 0.41814771, 0.4178223, 0.41749698, 0.41717169, 0.41684648, 0.41652137, 0.41619638, 0.41587144, 0.41554654, 0.41522175, 0.41489705, 0.41457239, 0.41424787, 0.41392335, 0.4135989, 0.41327462, 0.41295031, 0.41262618, 0.41230211, 0.4119781, 0.41165414, 0.41133028, 0.41100648, 0.41068274, 0.4103592, 0.41003561, 0.40971217, 0.40938872, 0.40906546, 0.40874219, 0.40841907, 0.40809599, 0.40777296, 0.40744999, 0.40712714, 0.40680435, 0.40648168, 0.4061591, 0.40583655, 0.40551412, 0.40519169, 0.40486944, 0.40454718, 0.40422499, 0.40390292, 0.4035809, 0.40325898, 0.40293717, 0.4026154, 0.40229377, 0.40197212, 0.40165064, 0.40132925, 0.40100777, 0.4006865, 0.40036523, 0.40004417, 0.39972311, 0.39940208, 0.3990812, 0.39876038, 0.39843962, 0.398119, 0.39779836, 0.39747784, 0.39715737, 0.396837, 0.39651677, 0.39619654, 0.39587644, 0.39555642, 0.39523646, 0.39491645, 0.3945967, 0.39427698, 0.39395729, 0.39363775, 0.39331821, 0.39299881, 0.39267942, 0.39236024, 0.39204103, 0.39172181, 0.39140281, 0.39108381, 0.39076498, 0.39044619, 0.39012751, 0.38980883, 0.38949028, 0.38917181, 0.38885343, 0.3885349, 0.38821673, 0.38789856, 0.38758048, 0.38726243, 0.38694453, 0.38662657, 0.38630888, 0.38599116, 0.38567352, 0.3853558, 0.38503841, 0.38472104, 0.38440365, 0.3840864, 0.38376936, 0.38345224, 0.38313523, 0.38281825, 0.38250145, 0.38218454, 0.38186786, 0.3815513, 0.38123474, 0.38091826, 0.38060188, 0.38028559, 0.37996933, 0.37965319, 0.37933701, 0.37902108, 0.37870508, 0.37838924, 0.3780736, 0.37775794, 0.37744224, 0.37712669, 0.37681133, 0.3764959, 0.3761805, 0.37586522, 0.37555021, 0.37523508, 0.37492016, 0.37460518, 0.37429044, 0.37397566, 0.37366101, 0.37334645, 0.3730318, 0.37271729, 0.37240291, 0.3720887, 0.37177449, 0.37146035, 0.37114632, 0.37083241, 0.37051848, 0.37020469, 0.36989084, 0.36957723, 0.36926356, 0.36895004, 0.3686367, 0.3683233, 0.36801004, 0.36769682, 0.36738378, 0.36707073, 0.36675763, 0.3664448, 0.36613196, 0.36581919, 0.36550656, 0.36519402, 0.36488152, 0.36456913, 0.36425674, 0.36394447, 0.36363226, 0.36332011, 0.36300817, 0.36269617, 0.36238432, 0.36207253, 0.36176085, 0.36144918, 0.36113763, 0.36082602, 0.36051467, 0.36020333, 0.35989204, 0.35958084, 0.35926989, 0.35895878, 0.35864782, 0.35833704, 0.35802624, 0.35771549, 0.35740483, 0.35709435, 0.35678378, 0.35647342, 0.35616302, 0.35585293, 0.35554272, 0.35523263, 0.35492259, 0.35461262, 0.35430273, 0.353993, 0.35368335, 0.35337371, 0.35306418, 0.35275465, 0.35244536, 0.35213599, 0.35182685, 0.35151762, 0.35120848, 0.35089949, 0.35059062, 0.3502818, 0.34997302, 0.34966436, 0.34935573, 0.34904724, 0.34873873, 0.34843034, 0.34812203, 0.34781379, 0.34750569, 0.34719759, 0.34688967, 0.34658179, 0.34627393, 0.34596616, 0.34565848, 0.34535086, 0.34504336, 0.34473583, 0.34442857, 0.34412125, 0.34381399, 0.3435069, 0.34319991, 0.34289294, 0.34258595, 0.3422792, 0.34197247, 0.34166574, 0.34135917, 0.34105271, 0.34074625, 0.34043989, 0.34013367, 0.33982751, 0.33952129, 0.33921519, 0.33890933, 0.33860344, 0.33829761, 0.33799183, 0.33768627, 0.33738068, 0.33707511, 0.33676973, 0.33646438, 0.33615911, 0.33585393, 0.33554888, 0.33524382, 0.33493882, 0.33463398, 0.33432922, 0.33402452, 0.33371973, 0.33341521, 0.33311075, 0.33280635, 0.33250201, 0.33219782, 0.33189365, 0.33158955, 0.33128551, 0.33098161, 0.33067766, 0.33037388, 0.33007014, 0.3297666, 0.32946303, 0.32915956, 0.32885614, 0.3285529, 0.3282496, 0.32794642, 0.32764336, 0.32734033, 0.32703736, 0.32673457, 0.32643181, 0.32612914, 0.3258265, 0.32552394, 0.32522154, 0.32491916, 0.32461676, 0.32431462, 0.32401243, 0.32371032, 0.32340831, 0.32310647, 0.3228046, 0.32250282, 0.32220113, 0.32189959, 0.32159799, 0.32129651, 0.32099524, 0.32069394, 0.3203927, 0.32009149, 0.31979051, 0.31948951, 0.31918854, 0.31888765, 0.31858701, 0.3182863, 0.31798574, 0.31768516, 0.31738481, 0.31708449, 0.31678411, 0.31648397, 0.31618387, 0.31588373, 0.31558371, 0.31528389, 0.31498405, 0.3146843, 0.31438464, 0.31408513, 0.31378558, 0.31348619, 0.31318682, 0.31288752, 0.31258827, 0.31228921, 0.31199026, 0.31169125, 0.31139237, 0.31109354, 0.31079486, 0.31049621, 0.31019759, 0.30989918, 0.30960068, 0.30930233, 0.30900407, 0.30870596, 0.30840778, 0.30810979, 0.30781186, 0.30751404, 0.30721623, 0.30691844, 0.30662078, 0.30632329, 0.3060258, 0.30572835, 0.30543116, 0.30513385, 0.30483663, 0.30453956, 0.30424252, 0.30394554, 0.30364871, 0.30335188, 0.30305529, 0.3027586, 0.30246204, 0.30216569, 0.30186927, 0.30157292, 0.30127656, 0.30098054, 0.30068442, 0.3003884, 0.30009246, 0.29979667, 0.29950091, 0.29920521, 0.29890954, 0.29861411, 0.29831856, 0.29802316, 0.29772791, 0.29743266, 0.29713753, 0.29684243, 0.2965475, 0.29625255, 0.29595777, 0.29566297, 0.29536831, 0.29507366, 0.29477909, 0.29448476, 0.29419035, 0.29389602, 0.29360181, 0.29330778, 0.29301366, 0.29271969, 0.29242572, 0.2921319, 0.29183814, 0.29154447, 0.29125097, 0.29095745, 0.29066396, 0.29037061, 0.29007736, 0.28978419, 0.28949097, 0.28919789, 0.28890499, 0.28861216, 0.28831929, 0.28802654, 0.28773391, 0.2874414, 0.2871488, 0.28685641, 0.28656408, 0.28627181, 0.2859796, 0.28568748, 0.28539544, 0.28510347, 0.28481162, 0.28451991, 0.28422818, 0.28393644, 0.28364494, 0.28335339, 0.28306198, 0.28277057, 0.28247944, 0.28218824, 0.28189713, 0.28160611, 0.28131521, 0.28102428, 0.28073347, 0.28044283, 0.28015217, 0.27986157, 0.27957109, 0.27928078, 0.27899045, 0.27870017, 0.27841002, 0.27811989, 0.27782986, 0.27753991, 0.27725008, 0.27696034, 0.27667063, 0.27638102, 0.27609149, 0.27580202, 0.27551261, 0.2752232, 0.27493405, 0.27464488, 0.27435577, 0.27406675, 0.27377796, 0.27348909, 0.27320027, 0.27291167, 0.272623, 0.27233446, 0.27204594, 0.27175766, 0.27146932, 0.27118108, 0.27089292, 0.27060497, 0.27031696, 0.27002901, 0.26974118, 0.26945344, 0.26916575, 0.26887807, 0.26859066, 0.26830319, 0.26801577, 0.26772851, 0.26744136, 0.26715425, 0.26686704, 0.26658016, 0.26629326, 0.26600641, 0.26571965, 0.26543304, 0.26514646, 0.26485991, 0.26457351, 0.26428723, 0.26400083, 0.26371464, 0.26342851, 0.26314253, 0.26285657, 0.26257065, 0.2622849, 0.26199916, 0.2617135, 0.26142788, 0.2611424, 0.26085699, 0.26057166, 0.26028633, 0.26000118, 0.25971609, 0.25943103, 0.25914603, 0.25886127, 0.25857633, 0.25829163, 0.25800708, 0.2577225, 0.257438, 0.25715354, 0.25686935, 0.25658503, 0.25630084, 0.25601676, 0.25573269, 0.25544873, 0.2551648, 0.2548812, 0.25459746, 0.2543138, 0.25403023, 0.25374684, 0.25346342, 0.25318012, 0.2528967, 0.2526136, 0.25233054, 0.25204748, 0.25176468, 0.2514818, 0.25119901, 0.2509163, 0.25063375, 0.25035119, 0.2500686, 0.2497862, 0.24950399, 0.24922173, 0.24893956, 0.24865748, 0.24837558, 0.24809362, 0.24781175, 0.2475301, 0.24724826, 0.24696662, 0.24668513, 0.24640374, 0.24612235, 0.24584107, 0.24555984, 0.24527875, 0.24499772, 0.24471657, 0.24443573, 0.24415489, 0.24387416, 0.24359341, 0.24331295, 0.24303235, 0.24275199, 0.24247156, 0.2421914, 0.24191105, 0.24163096, 0.24135096, 0.24107096, 0.24079099, 0.24051118, 0.24023151, 0.23995188, 0.2396723, 0.23939277, 0.2391133, 0.23883393, 0.23855461, 0.23827553, 0.23799638, 0.23771733, 0.23743835, 0.23715957, 0.23688076, 0.23660199, 0.23632324, 0.23604473, 0.23576619, 0.23548777, 0.23520948, 0.23493123, 0.23465307, 0.23437496, 0.23409699, 0.23381904, 0.23354106, 0.23326324, 0.23298557, 0.23270796, 0.23243037, 0.23215283, 0.23187552, 0.23159815, 0.2313209, 0.23104371, 0.23076662, 0.23048961, 0.23021264, 0.22993582, 0.22965908, 0.22938235, 0.2291057, 0.22882919, 0.22855273, 0.22827628, 0.22799999, 0.22772379, 0.22744757, 0.2271715, 0.22689554, 0.2266196, 0.22634374, 0.22606796, 0.2257923, 0.22552603, 0.22526883, 0.22501169, 0.22475474, 0.22449785, 0.22424108, 0.22398455, 0.22372803, 0.22347158, 0.22321522, 0.22295912, 0.22270294, 0.22244699, 0.22219114, 0.22193556, 0.22167987, 0.22142428, 0.22116895, 0.22091377, 0.22065853, 0.22040345, 0.22014862, 0.21989378, 0.21963905, 0.2193844, 0.21913007, 0.21887568, 0.21862137, 0.21836722, 0.21811333, 0.21785936, 0.21760555, 0.217352, 0.21709844, 0.21684498, 0.21659152, 0.21633849, 0.21608536, 0.21583232, 0.21557954, 0.21532676, 0.21507406, 0.21482153, 0.21456917, 0.2143169, 0.21406464, 0.21381262, 0.21356069, 0.21330884, 0.21305709, 0.21280541, 0.21255399, 0.21230257, 0.21205132, 0.21180034, 0.21154915, 0.21129826, 0.21104743, 0.21079686, 0.21054612, 0.21029563, 0.21004523, 0.20979519, 0.20954496, 0.20929492, 0.20904501, 0.20879538, 0.20854567, 0.20829603, 0.20804675, 0.20779736, 0.20754808, 0.20729895, 0.2070501, 0.20680124, 0.20655237, 0.20630376, 0.2060554, 0.20580681, 0.20555852, 0.20531043, 0.20506242, 0.20481439, 0.20456648, 0.20431888, 0.20407131, 0.20382379, 0.2035763, 0.20332915, 0.20308198, 0.20283489, 0.20258808, 0.20234126, 0.20209453, 0.20184796, 0.20160156, 0.20135517, 0.20110893, 0.20086265, 0.20061684, 0.20037086, 0.20012507, 0.19987936, 0.19963391, 0.19938843, 0.19914316, 0.19889812, 0.19865292, 0.19840789, 0.19816294, 0.19791834, 0.19767365, 0.19742912, 0.19718468, 0.1969405, 0.19669625, 0.19645223, 0.19620822, 0.19596438, 0.19572072, 0.19547704, 0.1952337, 0.19499031, 0.19474697, 0.19450381, 0.19426091, 0.19401802, 0.19377501, 0.19353247, 0.19328991, 0.19304742, 0.19280493, 0.19256289, 0.19232075, 0.19207871, 0.19183674, 0.19159512, 0.1913534, 0.19111177, 0.19087049, 0.19062912, 0.19038793, 0.1901468, 0.18990596, 0.18966509, 0.18942432, 0.18918362, 0.1889431, 0.18870269, 0.18846242, 0.18822224, 0.18798223, 0.18774231, 0.1875024, 0.18726289, 0.18702313, 0.18678364, 0.18654424, 0.18630509, 0.18606593, 0.18582685, 0.18558787, 0.18534923, 0.18511051, 0.18487185, 0.18463337, 0.18439524, 0.18415686, 0.18391873, 0.18368085, 0.18344288, 0.18320508, 0.18296739, 0.18273002, 0.18249257, 0.18225519, 0.18201809, 0.18178098, 0.18154396, 0.181307, 0.18107042, 0.1808338, 0.18059729, 0.18036078, 0.18012469, 0.17988843, 0.17965226, 0.17941634, 0.17918059, 0.17894493, 0.17870918, 0.17847385, 0.17823844, 0.17800321, 0.17776807, 0.17753308, 0.17729808, 0.17706329, 0.17682855, 0.17659409, 0.17635962, 0.17612532, 0.17589101, 0.17565705, 0.175423, 0.17518914, 0.17495535, 0.17472164, 0.1744881, 0.17425466, 0.17402147, 0.17378826, 0.17355517, 0.17332214, 0.17308946, 0.1728566, 0.17262392, 0.17239158, 0.17215908, 0.17192681, 0.17169455, 0.17146273, 0.17123073, 0.17099881, 0.17076707, 0.17053556, 0.17030399, 0.17007267, 0.16984153, 0.16961037, 0.16937931, 0.16914834, 0.1689177, 0.16868697, 0.16845642, 0.16822587, 0.16799565, 0.16776545, 0.16753523, 0.16730535, 0.16707548, 0.16684571, 0.16661599, 0.16638656, 0.1661571, 0.16592774, 0.16569847, 0.16546954, 0.1652406, 0.16501167, 0.1647829, 0.16455439, 0.16432589, 0.16409746, 0.16386938, 0.16364104, 0.16341296, 0.16318505, 0.1629573, 0.16272955, 0.1625019, 0.16227441, 0.16204727, 0.16181986, 0.16159271, 0.16136582, 0.16113885, 0.16091205, 0.16068532, 0.16045895, 0.16023239, 0.16000602, 0.1597798, 0.15955386, 0.15932781, 0.15910177, 0.15887624, 0.15865055, 0.15842493, 0.15819949, 0.15797429, 0.1577491, 0.15752402, 0.157299, 0.15707423, 0.15684947, 0.15662479, 0.15640028, 0.15617603, 0.15595171, 0.15572745, 0.15550363, 0.15527962, 0.15505581, 0.15483198, 0.1546085, 0.15438502, 0.15416162, 0.15393829, 0.15371533, 0.15349227, 0.1532694, 0.15304658, 0.15282403, 0.15260139, 0.15237893, 0.15215665, 0.15193443, 0.15171231, 0.15149027, 0.1512685, 0.15104672, 0.1508251, 0.1506035, 0.15038215, 0.15016079, 0.1499396, 0.14971867, 0.14949766, 0.14927681, 0.14905605, 0.14883555, 0.14861506, 0.14839454, 0.14817421, 0.14795423, 0.14773415, 0.14751415, 0.14729449, 0.14707476, 0.14685512, 0.14663564, 0.14641641, 0.1461971, 0.14597787, 0.14575891, 0.1455401, 0.14532131, 0.14510258, 0.14488412, 0.14466567, 0.14444739, 0.1442291, 0.14401107, 0.14379302, 0.14357516, 0.14335731, 0.14313987, 0.14292227, 0.14270489, 0.14248747, 0.14227046, 0.14205335, 0.14183635, 0.14161959, 0.14140283, 0.14118625, 0.14096966, 0.14075342, 0.14053708, 0.14032093, 0.14010486, 0.13988912, 0.13967313, 0.13945748, 0.13924201, 0.13902643, 0.13881114, 0.13859583, 0.13838087, 0.1381658, 0.13795084, 0.13773604, 0.13752151, 0.13730688, 0.13709241, 0.13687822, 0.13666402, 0.13644981, 0.13623588, 0.13602209, 0.13580832, 0.13559455, 0.13538103, 0.13516776, 0.1349545, 0.13474123, 0.13452815, 0.1343153, 0.13410246, 0.13388963, 0.13367721, 0.13346463, 0.13325222, 0.13303989, 0.13282791, 0.13261583, 0.13240394, 0.13219203, 0.13198048, 0.13176891, 0.13155735, 0.13134605, 0.13113484, 0.1309237, 0.13071264, 0.13050185, 0.13029106, 0.13008034, 0.12986982, 0.12965944, 0.12944916, 0.12923887, 0.12902893, 0.12881882, 0.12860896, 0.12839919, 0.12818976, 0.12798008, 0.12777074, 0.12756138, 0.12735239, 0.1271432, 0.1269342, 0.12672536, 0.12651679, 0.12630811, 0.12609962, 0.12589139, 0.12568307, 0.12547483, 0.12526675, 0.12505902, 0.12485113, 0.1246434, 0.12443575, 0.12422846, 0.12402116, 0.12381385, 0.12360681, 0.12339984, 0.12319288, 0.12298601, 0.12277947, 0.12257294, 0.12236649, 0.12216012, 0.12195402, 0.1217479, 0.12154196, 0.12133603, 0.12113034, 0.12092474, 0.12071914, 0.12051389, 0.12030854, 0.12010337, 0.11989828, 0.11969345, 0.11948862, 0.11928387, 0.11907938, 0.1188748, 0.1186704, 0.11846607, 0.1182621, 0.11805803, 0.11785405, 0.11765024, 0.11744677, 0.11724305, 0.11703958, 0.1168362, 0.11663315, 0.11642993, 0.11622689, 0.11602418, 0.1158214, 0.11561862, 0.11541608, 0.11521371, 0.11501136, 0.11480916, 0.11460705, 0.11440521, 0.11420336, 0.11400151, 0.11379991, 0.11359848, 0.11339714, 0.11319572, 0.11299463, 0.11279363, 0.11259263, 0.11239172, 0.11219115, 0.11199057, 0.11179009, 0.1115896, 0.11138953, 0.1111893, 0.11098915, 0.11078943, 0.11058962, 0.1103899, 0.11019035, 0.10999097, 0.10979159, 0.10959238, 0.10939325, 0.10919429, 0.10899535, 0.10879656, 0.10859811, 0.1083995, 0.10820105, 0.1080027, 0.10780467, 0.10760649, 0.10740846, 0.10721062, 0.10701294, 0.10681526, 0.10661776, 0.10642034, 0.10622326, 0.106026, 0.10582892, 0.1056321, 0.10543519, 0.10523845, 0.10504187, 0.10484547, 0.10464915, 0.10445276, 0.10425661, 0.10406081, 0.10386483, 0.10366894, 0.10347339, 0.10327784, 0.10308229, 0.10288692, 0.10269187, 0.10249676, 0.10230172, 0.10210676, 0.10191216, 0.10171746, 0.10152285, 0.10132857, 0.10113422, 0.10094003, 0.10074594, 0.100552, 0.10035816, 0.10016439, 0.09997081, 0.099777386, 0.099583879, 0.099390633, 0.099197552, 0.099004477, 0.098811485, 0.098618664, 0.098426178, 0.098233439, 0.098040953, 0.097848564, 0.097656421, 0.097464189, 0.097272217, 0.097080253, 0.096888617, 0.096696898, 0.096505269, 0.096313983, 0.09612269, 0.095931321, 0.095740192, 0.09554933, 0.095358387, 0.095167607, 0.094976909, 0.094786562, 0.094596118, 0.094405763, 0.094215579, 0.094025575, 0.093835555, 0.093645632, 0.093456127, 0.093266457, 0.093076952, 0.092887446, 0.092698373, 0.092509218, 0.092320144, 0.092131235, 0.091942415, 0.091753684, 0.091565028, 0.09137664, 0.091188326, 0.091000021, 0.090811878, 0.090623997, 0.090436026, 0.090248227, 0.090060435, 0.089873061, 0.089685604, 0.089498229, 0.089311197, 0.089123994, 0.088936962, 0.088750102, 0.088563494, 0.088376723, 0.088190198, 0.088003762, 0.087817498, 0.087631322, 0.087445222, 0.087259293, 0.08707355, 0.086887792, 0.086702123, 0.086516708, 0.086331293, 0.086145967, 0.085960813, 0.085775904, 0.085591003, 0.085406102, 0.085221373, 0.085036978, 0.08485233, 0.084667936, 0.084483884, 0.084299751, 0.084115617, 0.083931737, 0.08374811, 0.083564401, 0.083380856, 0.083197325, 0.083014123, 0.082830921, 0.082647726, 0.082464866, 0.082282014, 0.082099229, 0.081916548, 0.081734113, 0.081551678, 0.081369422, 0.081187077, 0.081005149, 0.080823228, 0.080641307, 0.080459729, 0.080278061, 0.080096565, 0.079915158, 0.07973408, 0.079552844, 0.079371691, 0.079190791, 0.079010054, 0.078829333, 0.078648776, 0.0784683, 0.078288078, 0.078107782, 0.07792756, 0.07774768, 0.077567719, 0.077387929, 0.077208221, 0.077028848, 0.076849319, 0.076669954, 0.076490752, 0.076311812, 0.076132871, 0.075953849, 0.075775243, 0.075596564, 0.075417966, 0.075239532, 0.07506144, 0.074883185, 0.074705184, 0.074527092, 0.074349426, 0.074171685, 0.073993936, 0.073816612, 0.073639199, 0.073461965, 0.073284723, 0.073107831, 0.072930932, 0.07275404, 0.072577395, 0.072400838, 0.072224371, 0.072047986, 0.071871683, 0.07169573, 0.07151968, 0.071343809, 0.071168184, 0.070992403, 0.070816867, 0.070641331, 0.070466138, 0.070290856, 0.070115834, 0.069940813, 0.069766045, 0.069591276, 0.06941659, 0.069242083, 0.069067739, 0.068893395, 0.068719231, 0.068545319, 0.068371318, 0.068197399, 0.068023741, 0.067850247, 0.06767676, 0.067503273, 0.067330122, 0.067156971, 0.066983908, 0.066810928, 0.066638291, 0.066465564, 0.066292927, 0.066120461, 0.065948248, 0.065776043, 0.065603741, 0.065431952, 0.065259993, 0.065088212, 0.064916514, 0.064745069, 0.064573616, 0.064402342, 0.06423115, 0.064060137, 0.063889116, 0.063718177, 0.06354741, 0.063376904, 0.063206397, 0.063035972, 0.062865719, 0.062695548, 0.062525466, 0.062355556, 0.062185727, 0.062015984, 0.061846413, 0.061676927, 0.061507609, 0.06133838, 0.061169233, 0.061000176, 0.060831364, 0.060662474, 0.060493756, 0.060325377, 0.060156826, 0.059988447, 0.059820235, 0.059652284, 0.059484161, 0.059316289, 0.059148509, 0.058980983, 0.058813281, 0.058645841, 0.058478735, 0.058311462, 0.058144365, 0.057977345, 0.057810668, 0.057643905, 0.057477232, 0.057310641, 0.057144389, 0.056978054, 0.056811802, 0.056645896, 0.056479983, 0.056314159, 0.056148335, 0.05598285, 0.055817369, 0.05565197, 0.055486657, 0.055321682, 0.055156626, 0.054991651, 0.054826766, 0.054662302, 0.054497674, 0.05433321, 0.054168999, 0.05400471, 0.053840589, 0.053676553, 0.053512771, 0.053348996, 0.053185295, 0.053021774, 0.05285842, 0.052695062, 0.052531879, 0.05236895, 0.052205853, 0.05204301, 0.051880248, 0.051717833, 0.051555242, 0.051392823, 0.051230494, 0.0510685, 0.050906342, 0.050744347, 0.050582696, 0.050420962, 0.050259307, 0.050097827, 0.0499366, 0.049775291, 0.049614064, 0.049453095, 0.049292296, 0.049131498, 0.048970696, 0.048810326, 0.048649866, 0.048489492, 0.048329115, 0.048169173, 0.048009224, 0.047849275, 0.047689497, 0.047529887, 0.047370452, 0.047211017, 0.047051579, 0.046892483, 0.046733391, 0.046574462, 0.046415705, 0.046256948, 0.046098363, 0.045939777, 0.045781538, 0.04562312, 0.045465048, 0.045306973, 0.045149069, 0.044991333, 0.044833601, 0.044675872, 0.044518478, 0.044361085, 0.044203863, 0.044046979, 0.043889757, 0.043732874, 0.043575991, 0.043419622, 0.04326291, 0.04310637, 0.042950168, 0.042793967, 0.042637765, 0.042481739, 0.042326052, 0.042170361, 0.042014673, 0.041858982, 0.041703805, 0.041548286, 0.041393105, 0.041238099, 0.041083261, 0.040928423, 0.040773585, 0.040619086, 0.040464588, 0.04031026, 0.040155936, 0.04000178, 0.039847791, 0.039693806, 0.039539993, 0.039386347, 0.039232701, 0.039079227, 0.038925923, 0.038772788, 0.038619652, 0.038466517, 0.038313724, 0.038160931, 0.03800831, 0.037855685, 0.037703235, 0.037550952, 0.037398666, 0.037246555, 0.037094783, 0.036942843, 0.036791071, 0.036639638, 0.036487866, 0.036336437, 0.036185175, 0.036034256, 0.035882995, 0.035732076, 0.035581157, 0.035430577, 0.035279829, 0.035129417, 0.03497918, 0.034828942, 0.034678705, 0.034528632, 0.034378737, 0.03422901, 0.034079108, 0.033929553, 0.033780169, 0.033630949, 0.033481561, 0.033332519, 0.033183642, 0.033034593, 0.032885719, 0.032737356, 0.03258865, 0.032440115, 0.032291748, 0.032143723, 0.031995699, 0.031847678, 0.031699654, 0.03155214, 0.031404454, 0.031256944, 0.031109599, 0.030962257, 0.030815084, 0.030667912, 0.03052108, 0.030374249, 0.030227588, 0.030080926, 0.029934434, 0.029788114, 0.029641792, 0.029495642, 0.029349662, 0.029203681, 0.029057872, 0.028912403, 0.028766764, 0.028621124, 0.028475827, 0.028330697, 0.028185569, 0.028040441, 0.027895823, 0.027751036, 0.027606249, 0.027461631, 0.027317353, 0.027173076, 0.027028801, 0.026884524, 0.026740758, 0.026596822, 0.026453057, 0.02630946, 0.026166037, 0.026022611, 0.025879188, 0.02573627, 0.025593188, 0.025450103, 0.02530719, 0.025164615, 0.025022043, 0.02487964, 0.024737066, 0.024595004, 0.024452772, 0.024310708, 0.024168817, 0.024027094, 0.023885373, 0.023743654, 0.023602441, 0.023461061, 0.02331985, 0.023178641, 0.023037769, 0.022896901, 0.022756029, 0.022615502, 0.022474971, 0.022334442, 0.022194082, 0.022054065, 0.021913877, 0.021773858, 0.021634011, 0.021494502, 0.021354655, 0.021215148, 0.021075811, 0.020936474, 0.020797307, 0.020658312, 0.020519486, 0.020380659, 0.020241832, 0.020103179, 0.019964863, 0.019826377, 0.019688064, 0.019549919, 0.019412115, 0.01927414, 0.019136336, 0.018998705, 0.018861242, 0.018723777, 0.018586313, 0.018449191, 0.018312069, 0.018174946, 0.018037995, 0.017901383, 0.017764771, 0.017628161, 0.017491719, 0.017355619, 0.017219348, 0.017083077, 0.016947318, 0.016811388, 0.016675627, 0.016540037, 0.016404619, 0.0162692, 0.016133951, 0.015998702, 0.015863793, 0.015728716, 0.015593978, 0.015459239, 0.015324673, 0.015190105, 0.015055879, 0.014921651, 0.014787425, 0.014653368, 0.014519483, 0.014385767, 0.014252051, 0.014118506, 0.013985131, 0.013851927, 0.013718551, 0.013585347, 0.013452482, 0.013319618, 0.013186755, 0.013054061, 0.012921707, 0.012789184, 0.012656831, 0.012524649, 0.012392806, 0.012260795, 0.012128782, 0.011997281, 0.011865609, 0.011733937, 0.011602606, 0.011471446, 0.011340285, 0.011209294, 0.011078134, 0.010947485, 0.010816835, 0.010686015, 0.010555706, 0.010425397, 0.010295088, 0.010164949, 0.010034981, 0.0099051837, 0.0097753853, 0.0096455868, 0.0095161302, 0.0093866726, 0.0092572151, 0.0091280993, 0.0089989826, 0.0088700363, 0.0087410901, 0.0086124837, 0.0084837088, 0.0083552739, 0.008226838, 0.0080985734, 0.007970308, 0.0078422138, 0.0077142897, 0.0075865355, 0.0074587818, 0.0073311985, 0.0072037848, 0.0070763719, 0.0069489586, 0.0068217162, 0.0066949842, 0.0065679112, 0.0064410097, 0.0063142776, 0.0061878865, 0.0060613248, 0.0059349337, 0.0058088833, 0.0056826621, 0.0055566118, 0.0054307319, 0.005305022, 0.0051793121, 0.0050536022, 0.0049282331, 0.0048030345, 0.0046778354, 0.0045526368, 0.0044277785, 0.0043029208, 0.0041780625, 0.0040533748, 0.0039290278, 0.0038045102, 0.0036801631, 0.0035559863, 0.0034319798, 0.0033081437, 0.0031841372, 0.0030604715, 0.0029369763, 0.0028133104, 0.0026899856, 0.0025668307, 0.0024436761, 0.0023205213, 0.0021977073, 0.0020748931, 0.0019520791, 0.0018296058, 0.0017071323, 0.0015848293, 0.0014625263, 0.0013403936, 0.0012186016, 0.0010964688, 0.0009746768, 0.0008530551, 0.00073160382, 0.00061015243, 0.00048870116, 0.00036759046, 0.00024665013, 0.00012553947, 4.5991392e-06, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453, 0.025521453   }, 
}; 

   inline double ReadLikelihoodPCA::GetMvaValue( const std::vector<double>& inputValues ) const
   {
      // classifier response value
      double retval = 0;

      // classifier response, sanity check first
      if (!fStatusIsClean) {
         std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                   << " because status is dirty" << std::endl;
         retval = 0;
      }
      else {
         if (IsNormalised()) {
            // normalise variables
            std::vector<double> iV;
            int ivar = 0;
            for (std::vector<double>::const_iterator varIt = inputValues.begin();
                 varIt != inputValues.end(); varIt++, ivar++) {
               iV.push_back(NormVariable( *varIt, fVmin[ivar], fVmax[ivar] ));
            }
            retval = GetMvaValue__( iV );
         }
         else {
            retval = GetMvaValue__( inputValues );
         }
      }

      return retval;
   }
inline void ReadLikelihoodPCA::X2P( const double* x, double* p, int index ) const
{
   // Calculate the principal components from the original data vector
   // x, and return it in p (function extracted from TPrincipal::X2P)
   // It's the users responsibility to make sure that both x and p are
   // of the right size (i.e., memory must be allocated for p).
   const int nvar = 4;

   for (int i = 0; i < nvar; i++) {
      p[i] = 0;
      for (int j = 0; j < nvar; j++) p[i] += (x[j] - fMeanValues[index][j]) * fEigenVectors[index][j][i];
   }
}

inline void ReadLikelihoodPCA::InitTransform()
{
   // initialise vector of mean values
   fMeanValues[0][0] = 0.617110981841;
   fMeanValues[0][1] = -0.178461294428;
   fMeanValues[0][2] = 0.591686958997;
   fMeanValues[0][3] = 0.789380960007;
   fMeanValues[1][0] = -0.746459402926;
   fMeanValues[1][1] = 0.260592678882;
   fMeanValues[1][2] = -0.668087820793;
   fMeanValues[1][3] = -0.86222600251;

   // initialise matrix of eigenvectors
   fEigenVectors[0][0][0] = 0.738632657661;
   fEigenVectors[0][0][1] = 0.285008557645;
   fEigenVectors[0][0][2] = -0.607013683489;
   fEigenVectors[0][0][3] = -0.0687481429892;
   fEigenVectors[0][1][0] = -0.12382057979;
   fEigenVectors[0][1][1] = 0.948148576153;
   fEigenVectors[0][1][2] = 0.291529697489;
   fEigenVectors[0][1][3] = 0.0263282555817;
   fEigenVectors[0][2][0] = 0.459661132789;
   fEigenVectors[0][2][1] = -0.101892445268;
   fEigenVectors[0][2][2] = 0.586163952153;
   fEigenVectors[0][2][3] = -0.659349219911;
   fEigenVectors[0][3][0] = 0.47728597723;
   fEigenVectors[0][3][1] = -0.0969656083681;
   fEigenVectors[0][3][2] = 0.45050709732;
   fEigenVectors[0][3][3] = 0.748223978496;
   fEigenVectors[1][0][0] = 0.763114485654;
   fEigenVectors[1][0][1] = 0.204488313488;
   fEigenVectors[1][0][2] = -0.610399559785;
   fEigenVectors[1][0][3] = -0.0570367324298;
   fEigenVectors[1][1][0] = -0.0291426636873;
   fEigenVectors[1][1][1] = 0.958418519115;
   fEigenVectors[1][1][2] = 0.283691517144;
   fEigenVectors[1][1][3] = 0.0101867792027;
   fEigenVectors[1][2][0] = 0.447998636834;
   fEigenVectors[1][2][1] = -0.14881641162;
   fEigenVectors[1][2][2] = 0.57284127143;
   fEigenVectors[1][2][3] = -0.670077439386;
   fEigenVectors[1][3][0] = 0.464870098343;
   fEigenVectors[1][3][1] = -0.132182251063;
   fEigenVectors[1][3][2] = 0.467743923811;
   fEigenVectors[1][3][3] = 0.740026530544;
}

inline void ReadLikelihoodPCA::Transform( std::vector<double>& iv, int sigOrBgd ) const
{
   const int nvar = 4;
   double *dv = new double[nvar];
   double *rv = new double[nvar];
   for (int ivar=0; ivar<nvar; ivar++) dv[ivar] = iv[ivar];

   // Perform PCA and put it into PCAed events tree
   this->X2P( dv, rv, (sigOrBgd==0 ? 0 : 1 ) );
   for (int ivar=0; ivar<nvar; ivar++) iv[ivar] = rv[ivar];

   delete [] dv;
   delete [] rv;
}
